;----------------------------------------------------------------
; GF64's Sonic 2 (Early prototype) disassembly
; 2010
;
; Original disasm credits: Hivebrain, Rika_Chou
;----------------------------------------------------------------

		include	"Macros/Main.asm"
		include	"Macros/ASM68k.asm"

		include	"RAM.asm"

;====================================================================

		dc.l RAM_MD_SysStack,EntryPoint,BusError,AddressError
		dc.l IllegalInstr,ZeroDivide,ChkInstr,TrapvInstr
		dc.l PriviledgeViolation,Trace,Line1010Emu,Line1111Emu
		dc.l ErrorException,ErrorException,ErrorException,ErrorException
		dc.l ErrorException,ErrorException,ErrorException,ErrorException
		dc.l ErrorException,ErrorException,ErrorException,ErrorException
		dc.l ErrorException,ErrorTrap,ErrorTrap,ErrorTrap
		dc.l HBlank,ErrorTrap,VBlank,ErrorTrap
		dc.l ErrorTrap,ErrorTrap,ErrorTrap,ErrorTrap
		dc.l ErrorTrap,ErrorTrap,ErrorTrap,ErrorTrap
		dc.l ErrorTrap,ErrorTrap,ErrorTrap,ErrorTrap
		dc.l ErrorTrap,ErrorTrap,ErrorTrap,ErrorTrap
		dc.l ErrorTrap,ErrorTrap,ErrorTrap,ErrorTrap
		dc.l ErrorTrap,ErrorTrap,ErrorTrap,ErrorTrap
		dc.l ErrorTrap,ErrorTrap,ErrorTrap,ErrorTrap
		dc.l ErrorTrap,ErrorTrap,ErrorTrap,ErrorTrap
		dc.b "SEGA MEGA DRIVE "
		dc.b "(C)SEGA 1991.APR"
		dc.b "SONIC THE             HEDGEHOG 2                "
		dc.b "SONIC THE             HEDGEHOG 2                "
		dc.b "GM 00004049-01"
Checksum:	dc.w $AFC7
IOSupport:	dc.b "J               "
ROMStart:	dc.l 0
ROMEnd:		dc.l $07FFFF
RAMStart:	dc.l $FF0000
RAMEnd:		dc.l $FFFFFF
SRAMSupport:	dc.l $20202020
		dc.l $20202020
		dc.l $20202020
		dc.l $20202020
Notes:		dc.b "                                                "
Region:		dc.b "JUE             "

; ===============================================================================

ErrorTrap:
		nop
		nop
		bra.s	ErrorTrap
; ===============================================================================

EntryPoint:
		tst.l	($A10008).l	;Test Port A Ctrl
		bne.s	PortA_OK
loc_20E:				;Test Port C Ctrl
		tst.w	($A1000C).l

PortA_OK:
		bne.s	PortC_OK
		lea	InitValues(pc),a5
		movem.w	(a5)+,d5-d7
		movem.l	(a5)+,a0-a4
		move.b	-$10FF(a1),d0	; get hardware version
		andi.b	#$F,d0
		beq.s	SkipSecurity
		move.l	#'SEGA',$2F00(a1)

SkipSecurity:
		move.w	(a4),d0
		moveq	#0,d0
		movea.l	d0,a6
		move.l	a6,usp
		moveq	#$17,d1

VDPInitLoop:
		move.b	(a5)+,d5
		move.w	d5,(a4)
		add.w	d7,d5
		dbf	d1,VDPInitLoop
		move.l	(a5)+,(a4)
		move.w	d0,(a3)
		move.w	d7,(a1)
		move.w	d7,(a2)

WaitForZ80:
		btst	d0,(a1)
		bne.s	WaitForZ80
		moveq	#$25,d2	; '%'

Z80InitLoop:
		move.b	(a5)+,(a0)+
		dbf	d2,Z80InitLoop
		move.w	d0,(a2)
		move.w	d0,(a1)
		move.w	d7,(a2)

ClearRAMLoop:
		move.l	d0,-(a6)

loc_264:
		dbf	d6,ClearRAMLoop
		move.l	(a5)+,(a4)
		move.l	(a5)+,(a4)
		moveq	#$1F,d3

ClearCRAMLoop:
		move.l	d0,(a3)
		dbf	d3,ClearCRAMLoop
		move.l	(a5)+,(a4)
		moveq	#$13,d4

ClearVSRAMLoop:
		move.l	d0,(a3)
		dbf	d4,ClearVSRAMLoop
		moveq	#3,d5

PSGInitLoop:
		move.b	(a5)+,$11(a3)
		dbf	d5,PSGInitLoop
		move.w	d0,(a2)
		movem.l	(a6),d0-a6
		move	#$2700,sr

PortC_OK:
		bra.s	GameProgram
; ===============================================================================
InitValues:	dc.w $8000		; DATA XREF: ROM:00000216t
		dc.w $3FFF
		dc.w $100

		dc.l $A00000		; Z80 RAM start	location
		dc.l $A11100		; Z80 bus request
		dc.l $A11200		; Z80 reset
		dc.l $C00000		; VDP data port
		dc.l $C00004		; VDP control port

		dc.b   4,$14,$30,$3C	; 0 ; values for VDP registers
		dc.b   7,$6C,  0,  0	; 4
		dc.b   0,  0,$FF,  0	; 8
		dc.b $81,$37,  0,  1	; 12
		dc.b   1,  0,  0,$FF	; 16
		dc.b $FF,  0,  0,$80	; 20

		dc.l $40000080		; value	for VRAM fill

		dc.b $AF,1,$D9,$1F,$11,$27,0    ;Z80 Instructions
                dc.b $21,$26,0,$F9,$77,$ED,$B0
                dc.b $DD,$E1,$FD,$E1,$ED,$47,$ED
		dc.b $4F,$D1,$E1,$F1,8,$D9,$C1
                dc.b $D1,$E1,$F1,$F9,$F3,$ED,$56
                dc.b $36,$E9,$E9

		dc.w $8104		; VDP display mode
		dc.w $8F02		; VDP increment
		dc.l $C0000000		; value	for CRAM Write mode
		dc.l $40000010		; value	for VSRAM write	mode

		dc.b  $9F, $BF,	$DF, $FF; 0 ; values for PSG channel volumes
; ===============================================================================

GameProgram:
		tst.w	($C00004).l
		btst	#6,($A1000D).l				;Test soft reset
		beq.s	ChecksumCheck				;If not, branch
		cmpi.l	#'init',(RAM_Checksum_INIT).w		;Check "init" at $FFFFFFFC
		beq.w	StartProgram				;If yes, don't check the checksum

ChecksumCheck:
		movea.l	#ErrorTrap,a0         			;Get $200
		movea.l	#ROMEnd,a1            			;Get $7FFFF
		move.l	(a1),d0               			;Move $7FFFF to d0
		move.l	#$7FFFF,d0            			;...pointless...
		moveq	#0,d1

ChksumChkLoop:
		add.w	(a0)+,d1
		cmp.l	a0,d0
		bcc.s	ChksumChkLoop
		movea.l	#Checksum,a1				;Get Checksum (at $18E)
		cmp.w	(a1),d1               			;Compare Checksum to d1
		nop                           			;And nothing...
		nop

		lea	(RAM_MD_SysStack).w,a6
		moveq	#0,d7
		move.w	#$7F,d6

GameProgram_ClearSysStack_Loop:
		move.l	d7,(a6)+
		dbf	d6,GameProgram_ClearSysStack_Loop

		move.b	($A10001).l,d0				;Get system register to d0
		andi.b	#$C0,d0
		move.b	d0,(RAM_MD_SysRegion).w			;Copy Region code to RAM_MD_SysRegion
		move.l	#'init',(RAM_Checksum_INIT).w		;Don't check the checksum again

; ===============================================================================
StartProgram:
		lea	($FF0000).l,a6
		moveq	#0,d7
		move.w	#$3F7F,d6

@ClearRam:
		move.l	d7,(a6)+
		dbf	d6,@ClearRam
		bsr.w	VDPRegSetup
		bsr.w	SoundDriverLoad				;SMPS -> Load Z80 driver
		bsr.w	JoypadInit				;Init Controllers

		move.b	#ModeId_Sega,(RAM_GameMode).w		;Start Game Mode at $0 (SEGA)

MainGameLoop:
		move.b	(RAM_GameMode).w,d0			;Get ID
		andi.w	#$1C,d0					;Limit to $1C
		jsr	GameModeArray(pc,d0.w)			;Jump to Array + d0 bytes
		bra.s	MainGameLoop
; ===============================================================================

GameModeArray:
		bra.w	SegaScreen
		bra.w	TitleScreen
		bra.w	Level
		bra.w	Level
		bra.w	GameMode10

; ===============================================================================

ChecksumError:
		bsr.w	VDPRegSetup				;Setup VDP
		move.l	#$C0000000,($C00004).l			;VDP -> CRAM mode
		moveq	#$3F,d7

@ColorFill:
		move.w	#$E,($C00000).l				;Put color red
		dbf	d7,@ColorFill

@InfLoop:
		bra.s	@InfLoop

; ===============================================================================

BusError:
		move.b	#2,(RAM_ErrorCode).w
		bra.s	ErrorMsg_TwoAddresses
; ===============================================================================

AddressError:
		move.b	#4,(RAM_ErrorCode).w
		bra.s	ErrorMsg_TwoAddresses
; ===============================================================================

IllegalInstr:
		move.b	#6,(RAM_ErrorCode).w

;loc_3E4:
		addq.l	#2,2(sp)
		bra.s	ErrorMessage
; ===============================================================================

ZeroDivide:
		move.b	#8,(RAM_ErrorCode).w
		bra.s	ErrorMessage
; ===============================================================================

ChkInstr:
		move.b	#$A,(RAM_ErrorCode).w
		bra.s	ErrorMessage
; ===============================================================================

TrapvInstr:
		move.b	#$C,(RAM_ErrorCode).w
		bra.s	ErrorMessage
; ===============================================================================

PriviledgeViolation:
		move.b	#$E,(RAM_ErrorCode).w
		bra.s	ErrorMessage
; ===============================================================================

Trace:
		move.b	#$10,(RAM_ErrorCode).w
		bra.s	ErrorMessage
; ===============================================================================

Line1010Emu:
		move.b	#$12,(RAM_ErrorCode).w
		addq.l	#2,2(sp)
		bra.s	ErrorMessage
; ===============================================================================

Line1111Emu:
		move.b	#$14,(RAM_ErrorCode).w
		addq.l	#2,2(sp)
		bra.s	ErrorMessage
; ===============================================================================

ErrorException:
		move.b	#0,(RAM_ErrorCode).w
		bra.s	ErrorMessage
; ===============================================================================

ErrorMsg_TwoAddresses:
		move	#$2700,sr
		addq.w	#2,sp
		move.l	(sp)+,(RAM_ObjRespawnTbl+$40).w
		addq.w	#2,sp
		movem.l	d0-a7,(RAM_ObjRespawnTbl).w
		bsr.w	ShowErrorMsg
		move.l	2(sp),d0
		bsr.w	ShowErrAddress
		move.l	(RAM_ObjRespawnTbl+$40).w,d0
		bsr.w	ShowErrAddress
		bra.s	ErrorMsg_Wait
; ===============================================================================

ErrorMessage:
		move	#$2700,sr
		movem.l	d0-a7,(RAM_ObjRespawnTbl).w
		bsr.w	ShowErrorMsg
		move.l	2(sp),d0
		bsr.w	ShowErrAddress

ErrorMsg_Wait:
		bsr.w	Error_WaitForC
		movem.l	(RAM_ObjRespawnTbl).w,d0-a7
		move	#$2300,sr
		rte

; =============== S U B	R O U T	I N E =======================================


ShowErrorMsg:
		lea	($C00000).l,a6			;Put VDP Data address to a6
		move.l	#$78000003,($C00004).l		;VDP location
		lea	(Art_Text).l,a0			;Load text graphics
		move.w	#$27F,d1			;Length

Error_LoadGfx:
		move.w	(a0)+,(a6)			;Put the graphics to a6
		dbf	d1,Error_LoadGfx		;and Loop

		moveq	#0,d0				;Clear d0
		move.b	(RAM_ErrorCode).w,d0		;Put error code to d0
		move.w	ErrorText(pc,d0.w),d0
		lea	ErrorText(pc,d0.w),a0		;Load array (*+Data) to a0
		move.l	#$46040003,($C00004).l		;VDP location
		moveq	#$12,d1				;ASCII Text length

Error_CharsLoop:
		moveq	#0,d0				;Clear d0
		move.b	(a0)+,d0			;Put ASCII character to d0
		addi.w	#$790,d0			;VRAM address
		move.w	d0,(a6)				;Put the ASCII character from d0 to a6
		dbf	d1,Error_CharsLoop		;Loop
		rts					;End

; ===============================================================================
ErrorText:	dc.w ErrText_Exept-ErrorText
		dc.w ErrText_BusErr-ErrorText
		dc.w ErrText_AddrErr-ErrorText
		dc.w ErrText_IllInstr-ErrorText
		dc.w ErrText_ZeroDiv-ErrorText
		dc.w ErrText_ChkInstr-ErrorText
		dc.w ErrText_TrapV-ErrorText
		dc.w ErrText_PrivViol-ErrorText
		dc.w ErrText_Trace-ErrorText
		dc.w ErrText_Line1010-ErrorText
		dc.w ErrText_Line1111-ErrorText

ErrText_Exept:	  dc.b 'ERROR EXCEPTION    '
ErrText_BusErr:	  dc.b 'BUS ERROR          '
ErrText_AddrErr:  dc.b 'ADDRESS ERROR      '
ErrText_IllInstr: dc.b 'ILLEGAL INSTRUCTION'
ErrText_ZeroDiv:  dc.b '@ERO DIVIDE        '
ErrText_ChkInstr: dc.b 'CHK INSTRUCTION    '
ErrText_TrapV:	  dc.b 'TRAPV INSTRUCTION  '
ErrText_PrivViol: dc.b 'PRIVILEGE VIOLATION'
ErrText_Trace:	  dc.b 'TRACE              '
ErrText_Line1010: dc.b 'LINE 1010 EMULATOR '
ErrText_Line1111: dc.b 'LINE 1111 EMULATOR '
                  dc.b 0

; =============== S U B	R O U T	I N E =======================================


ShowErrAddress:
		move.w	#$7CA,(a6)			;VRAM address
		moveq	#7,d2				;Length

ShowErrAddress_DigitLoop:
		rol.l	#4,d0
		bsr.s	ShowErrDigit
		dbf	d2,ShowErrAddress_DigitLoop
		rts

; =============== S U B	R O U T	I N E =======================================

ShowErrDigit:
		move.w	d0,d1
		andi.w	#$F,d1				;Max $F
		cmpi.w	#$A,d1				;Is 10?
		bcs.s	ShowErrDigit_NoHex      	;Branch if hex ($A to $F)
		addq.w	#7,d1                   	;Skip next $7 gfx tiles

ShowErrDigit_NoHex:
		addi.w	#$7C0,d1			;VRAM address
		move.w	d1,(a6)				;Display digit
		rts

; =============== S U B	R O U T	I N E =======================================


Error_WaitForC:
		bsr.w	ReadJoypads
		cmpi.b	#$20,(RAM_Control_1_Press).w	;Is C Pressed?
		bne.w	Error_WaitForC			;If not, branch
		rts

; ===============================================================================
Art_Text:	incbin "Art/Unc/art_text.bin"
		even

; ===============================================================================
; VBlank
; ===============================================================================

VBlank:
		movem.l	d0-a6,-(sp)				;Save d0 to a6
		tst.b	(RAM_VIntCount).w			;RAM_VIntCount contains something?
		beq.s	Vint_0					;If $0, branch

VBlank_LoopUnk:
		move.w	($C00004).l,d0
		andi.w	#8,d0
		beq.s	VBlank_LoopUnk

		move.l	#$40000010,($C00004).l			;VDP -> VSRAM mode
		move.l	(RAM_VDP_VScroll).w,($C00000).l		;Copy Vertical scroll to VDP

		btst	#6,(RAM_MD_SysRegion).w			;Is a PAL Mega Drive?
		beq.s	VBlank_IsNTSC				;If not, branch

		move.w	#$700,d0				;Delay count
		dbf	d0,*					;Branch itself, d0 times

VBlank_IsNTSC:
		move.b	(RAM_VIntCount).w,d0			;Get RAM_VIntCount value to d0
		move.b	#0,(RAM_VIntCount).w			;Reset to $0 in RAM
		move.w	#1,(RAM_Flag_VDP_VIntFlag).w
		andi.w	#$3E,d0					;Limit to $3E
		move.w	VIntTypes(pc,d0.w),d0
		jsr	VIntTypes(pc,d0.w)

VBlank_VintEnd:
		jsr	SoundDriver_Run

VBlank_VintEnd_2:
		addq.l	#1,(RAM_VIntFrameCnt).w
		movem.l	(sp)+,d0-a6				;Restore d0 to a6
		rte
; ===============================================================================================================
VIntTypes:
		dc.w Vint_0-VIntTypes
                dc.w Vint_2-VIntTypes
		dc.w VInt_4-VIntTypes
                dc.w VInt_6-VIntTypes
		dc.w VInt_8-VIntTypes
                dc.w VInt_A-VIntTypes
		dc.w VInt_C-VIntTypes
                dc.w VInt_E-VIntTypes
		dc.w VInt_10-VIntTypes
                dc.w VInt_12-VIntTypes
		dc.w VInt_14-VIntTypes
                dc.w VInt_16-VIntTypes
		dc.w VInt_C-VIntTypes

; ===============================================================================
; VInt $0
;
; Processes pallet, and more stuff
; ===============================================================================

Vint_0:
		cmpi.b	#$80+ModeID_Level,(RAM_GameMode).w	;Level mode? (+$80 - loading submode)
		beq.s	Vint_0_Demo
		cmpi.b	#ModeID_Demo,(RAM_GameMode).w		;Demo mode?
		beq.s	Vint_0_Demo
		cmpi.b	#ModeID_Level,(RAM_GameMode).w		;Level mode?
		bne.w	VBlank_VintEnd

Vint_0_Demo:
		tst.b	(RAM_Flag_WaterLevel).w
		beq.w	Vint_0_NotWaterLvl
		move.w	($C00004).l,d0
		btst	#6,(RAM_MD_SysRegion).w
		beq.s	@IsNTSC

		move.w	#$700,d0
		dbf	d0,*

@IsNTSC:
		move.w	#1,(RAM_Flag_VDP_VIntFlag).w
		move.w	#$100,($A11100).l			;Stop Z80

Vint_0_WaitZ80:
		btst	#0,($A11100).l
		bne.s	Vint_0_WaitZ80
		tst.b	(RAM_FillWaterPalScr).w
		bne.s	Vint_0_OnWater

		dma68kToVDP RAM_Pal_1,$0000,$80,CRAM

		bra.s	Vint_0_ContinuePal
; ===============================================================================

Vint_0_OnWater:
		dma68kToVDP RAM_Pal_1_Water,$0000,$80,CRAM

Vint_0_ContinuePal:
		move.w	(RAM_VDPCmdForHint).w,(a5)
		move.w	#$8230,($C00004).l			;Set Plane A $7800 (?)
		move.w	#0,($A11100).l				;Start Z80
		bra.w	VBlank_VintEnd
; ===============================================================================

Vint_0_NotWaterLvl:
		move.w	($C00004).l,d0
		move.l	#$40000010,($C00004).l			;VSRAM Mode
		move.l	(RAM_VDP_VScroll).w,($C00000).l		;Copy data to VSRAM
		btst	#6,(RAM_MD_SysRegion).w
		beq.s	@IsNTSC

		move.w	#$700,d0
		dbf	d0,*

@IsNTSC:
		move.w	#1,(RAM_Flag_VDP_VIntFlag).w
		move.w	(RAM_VDPCmdForHint).w,($C00004).l
		move.w	#$8230,($C00004).l			;Set Plane A $7800 (?)
		move.l	(RAM_Level_CopyTo2pVscrl).w,(RAM_VDP_VScroll_2p).w

		dma68kToVDP RAM_SprAttrTable,$F800,$280,VRAM

		bra.w	VBlank_VintEnd
; ===============================================================================
; VInt $2
;
; Demo timer
; ===============================================================================

VInt_2:
		bsr.w	VInt_DefaultStuff

VInt_14:
		tst.w	(RAM_DemoTimeLeft).w
		beq.w	VInt_2_NoDemoTime
		subq.w	#1,(RAM_DemoTimeLeft).w

VInt_2_NoDemoTime:
		rts
; ===============================================================================
; VInt $4
;
; Demo timer, runs PLC
; ===============================================================================

VInt_4:
		bsr.w	VInt_DefaultStuff
		bsr.w	RunPLC_VInt
		tst.w	(RAM_DemoTimeLeft).w
		beq.w	VInt_4_NoDemoTime
		subq.w	#1,(RAM_DemoTimeLeft).w

VInt_4_NoDemoTime:
		rts
; ===============================================================================
; VInt $6
;
; Process default stuff
; ===============================================================================

VInt_6:
		bsr.w	VInt_DefaultStuff
		rts
; ===============================================================================
; VInt $10
;
; Goes to $A if it's the Special stage, if not, goes to $8
; ===============================================================================

VInt_10:
		cmpi.b	#ModeId_SS,(RAM_GameMode).w		;Special stage?
		beq.w	VInt_A					;Use Mode $A Instead

; ===============================================================================
; VInt $8
;
; Demo mode
; ===============================================================================

VInt_8:
		move.w	#$100,($A11100).l			;Stop Z80
@WaitZ80:
		btst	#0,($A11100).l
		bne.s	@WaitZ80
		bsr.w	ReadJoypads

		tst.b	(RAM_FillWaterPalScr).w
		bne.s	VInt_8_OnWater

		dma68kToVDP RAM_Pal_1,$0000,$80,CRAM

		bra.s	VInt_8_Continue
; ===============================================================================

VInt_8_OnWater:
		dma68kToVDP RAM_Pal_1_Water,$0000,$80,CRAM

VInt_8_Continue:
		move.w	(RAM_VDPCmdForHint).w,(a5)
		move.w	#$8230,($C00004).l			;Set Plane A $7800 (?)

		dma68kToVDP RAM_HorScrollBuffer,$FC00,$380,VRAM
		dma68kToVDP RAM_SprAttrTable,$F800,$280,VRAM

		bsr.w	Process_DMA

		move.w	#0,($A11100).l				;Start Z80

		movem.l	(RAM_LevelSys_Buff).w,d0-d7
		movem.l	d0-d7,(RAM_LevelSys_Buff_Backup).w
		movem.l	(RAM_LevelSys_Buff_2P).w,d0-d7
		movem.l	d0-d7,(RAM_LevelSys_Buff_2P_Backup).w
		movem.l	(RAM_LevelSys_DirToDraw).w,d0-d3
		movem.l	d0-d3,(RAM_LevelSys_DirToDraw_Backup).w
		move.l	(RAM_Level_CopyTo2pVscrl).w,(RAM_VDP_VScroll_2p).w

		cmpi.b	#$5C,(RAM_VDPCmdForHint+$1).w
		bcc.s	DemoTime
		move.b	#1,(RAM_Flag_VDP_Line5C).w
		addq.l	#4,sp
		bra.w	VBlank_VintEnd_2

; =============== S U B	R O U T	I N E =======================================


DemoTime:
		bsr.w	LoadTilesAsYouMove
		jsr	HudUpdate
		bsr.w	RunPLC_Vint_2
		tst.w	(RAM_DemoTimeLeft).w
		beq.w	DemoTime_End
		subq.w	#1,(RAM_DemoTimeLeft).w
DemoTime_End:
		rts

; ===============================================================================
; VInt $A
;
; Demo special stage
; ===============================================================================

VInt_A:
		move.w	#$100,($A11100).l
@WaitZ80:
		btst	#0,($A11100).l
		bne.s	@WaitZ80
		bsr.w	ReadJoypads

		dma68kToVDP RAM_Pal_1,$0000,$80,CRAM
		dma68kToVDP RAM_SprAttrTable,$F800,$280,VRAM
		dma68kToVDP RAM_HorScrollBuffer,$FC00,$380,VRAM

		bsr.w	Process_DMA

		move.w	#0,($A11100).l
		bsr.w	PalCycle_S1SS

		tst.w	(RAM_DemoTimeLeft).w
		beq.w	VInt_A_Return
		subq.w	#1,(RAM_DemoTimeLeft).w
VInt_A_Return:
		rts

; ===============================================================================
; VInt $C
;
; Main level stuff
; ===============================================================================

VInt_C:
		move.w	#$100,($A11100).l			;Stop Z80
@WaitZ80:
		btst	#0,($A11100).l
		bne.s	@WaitZ80
		bsr.w	ReadJoypads

		tst.b	(RAM_FillWaterPalScr).w
		bne.s	VInt_C_OnWater

		dma68kToVDP RAM_Pal_1,$0000,$80,CRAM

		bra.s	VInt_C_Continue
; ===============================================================================

VInt_C_OnWater:
		dma68kToVDP RAM_Pal_1_Water,$0000,$80,CRAM

VInt_C_Continue:
		move.w	(RAM_VDPCmdForHint).w,(a5)

		dma68kToVDP RAM_HorScrollBuffer,$FC00,$380,VRAM
		dma68kToVDP RAM_SprAttrTable,$F800,$280,VRAM

		bsr.w	Process_DMA
		move.w	#0,($A11100).l				;Start Z80

		movem.l	(RAM_LevelSys_Buff).w,d0-d7
		movem.l	d0-d7,(RAM_LevelSys_Buff_Backup).w
		movem.l	(RAM_LevelSys_DirToDraw).w,d0-d1
		movem.l	d0-d1,(RAM_LevelSys_DirToDraw_Backup).w
		bsr.w	LoadTilesAsYouMove
		jsr	HudUpdate
		bsr.w	RunPLC_VInt
		rts

; ===============================================================================
; VInt $E
;
; ???
; ===============================================================================

VInt_E:
		bsr.w	VInt_DefaultStuff
		addq.b	#1,(RAM_Vint_Unk).w
		move.b	#$E,(RAM_VIntCount).w
		rts
; ===============================================================================

VInt_12:
		bsr.w	VInt_DefaultStuff
		move.w	(RAM_VDPCmdForHint).w,(a5)
		bra.w	RunPLC_VInt
; ===============================================================================
; VInt $16
; ===============================================================================

VInt_16:
		move.w	#$100,($A11100).l			;Stop Z80

@WaitZ80:
		btst	#0,($A11100).l
		bne.s	@WaitZ80
		bsr.w	ReadJoypads

		dma68kToVDP RAM_Pal_1,$0000,$80,CRAM
		dma68kToVDP RAM_SprAttrTable,$F800,$280,VRAM
		dma68kToVDP RAM_HorScrollBuffer,$FC00,$380,VRAM

		move.w	#0,($A11100).l				;Start Z80
		tst.w	(RAM_DemoTimeLeft).w
		beq.w	VInt_16_Return
		subq.w	#1,(RAM_DemoTimeLeft).w

VInt_16_Return:
		rts

; =============================================================================
; "VInt_DefaultStuff"
;
; Does normal stuff
; Reads joypads, copies Pallet/Sprites/HScroll to VRAM
; =============================================================================

VInt_DefaultStuff:
		move.w	#$100,($A11100).l

@WaitZ80:
		btst	#0,($A11100).l
		bne.s	@WaitZ80

		bsr.w	ReadJoypads
		tst.b	(RAM_FillWaterPalScr).w
		bne.s	loc_107E

		dma68kToVDP RAM_Pal_1,$0000,$80,CRAM

		bra.s	loc_10A2
; ===============================================================================

loc_107E:
		dma68kToVDP RAM_Pal_1_Water,$0000,$80,CRAM

loc_10A2:
		dma68kToVDP RAM_SprAttrTable,$F800,$280,VRAM
		dma68kToVDP RAM_HorScrollBuffer,$FC00,$380,VRAM

		move.w	#0,($A11100).l
		rts

; ===============================================================================
; HBlank
; ===============================================================================

HBlank:
		tst.w	(RAM_Flag_VDP_VIntFlag).w
		beq.w	HBlank_Return
		tst.w	(RAM_Flag_SplitScreen).w
		beq.w	HBlank_Not2pMode

		move.w	#0,(RAM_Flag_VDP_VIntFlag).w
		move.l	a5,-(sp)				;Save a5
		move.l	d0,-(sp)				;and d0

@WaitVDP:
		move.w	($C00004).l,d0
		andi.w	#4,d0
		beq.s	@WaitVDP

		move.w	(RAM_VDP_Command_1).w,d0
		andi.b	#$BF,d0
		move.w	d0,($C00004).l

		move.w	#$8228,($C00004).l

		move.l	#$40000010,($C00004).l
		move.l	(RAM_VDP_VScroll_2p).w,($C00000).l

		dma68kToVDP RAM_SprAttrTable_2p,$F800,$280,VRAM		;???

@WaitVDP2:
		move.w	($C00004).l,d0
		andi.w	#4,d0
		beq.s	@WaitVDP2

		move.w	(RAM_VDP_Command_1).w,d0
		ori.b	#$40,d0
		move.w	d0,($C00004).l

		move.l	(sp)+,d0				;Restore d0
		movea.l	(sp)+,a5				;and a5

HBlank_Return:
		rte
; ===============================================================================

HBlank_Not2pMode:
		move	#$2700,sr
		move.w	#0,(RAM_Flag_VDP_VIntFlag).w

		movem.l	a0-a1,-(sp)
		lea	($C00000).l,a1
		lea	(RAM_Pal_1_Water).w,a0
		move.l	#$C0000000,4(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.l	(a0)+,(a1)
		move.w	#$8ADF,4(a1)
		movem.l	(sp)+,a0-a1

		tst.b	(RAM_Flag_VDP_Line5C).w
		bne.s	loc_11F8
		rte
; ===============================================================================

loc_11F8:
		clr.b	(RAM_Flag_VDP_Line5C).w

		movem.l	d0-a6,-(sp)
		bsr.w	DemoTime
		jsr	SoundDriver_Run
		movem.l	(sp)+,d0-a6

		rte

; ==============================================================================

		include	"Subs/ReadJoypads.asm"
		even

; ==============================================================================

		include	"Subs/VDPSetup.asm"
		even

; ==============================================================================

		include	"Subs/ClearScreen.asm"
		even

; ==============================================================================

		include	"Sound/SndDrv_Load.asm"
		even

		include	"Sound/SndDrv_Play.asm"
		even

; =============== S U B R O U T I N E ==========================================


Pause:
		nop
		tst.b	(RAM_Sonic_Lives).w
		beq.s	Unpause
		tst.w	(RAM_Flag_LevelPaused).w
		bne.s	Pause_AlreadyPaused
		btst	#7,(RAM_Control_1_Press).w
		beq.s	Pause_DoNothing

Pause_AlreadyPaused:
		move.w	#1,(RAM_Flag_LevelPaused).w
		move.b	#1,(RAM_Level_Pause_Unk).w

Pause_Loop:
		move.b	#$10,(RAM_VIntCount).w
		bsr.w	DelayProgram

		tst.b	(RAM_SndDrv_TstSFX).w
		beq.s	Pause_CheckStart
		btst	#6,(RAM_Control_1_Press).w
		beq.s	Pause_CheckBC
		move.b	#ModeId_TitleScr,(RAM_GameMode).w
		nop
		bra.s	Pause_UnpauseFlag
; ===============================================================================

Pause_CheckBC:
		btst	#4,(RAM_Control_1_Hold).w
		bne.s	Pause_RunOneFrame
		btst	#5,(RAM_Control_1_Press).w
		bne.s	Pause_RunOneFrame

Pause_CheckStart:
		btst	#7,(RAM_Control_1_Press).w
		beq.s	Pause_Loop

Pause_UnpauseFlag:
		move.b	#$80,(RAM_Level_Pause_Unk).w

Unpause:
		move.w	#0,(RAM_Flag_LevelPaused).w

Pause_DoNothing:
		rts
; ===============================================================================

Pause_RunOneFrame:
		move.w	#1,(RAM_Flag_LevelPaused).w
		move.b	#$80,(RAM_Level_Pause_Unk).w
		rts

; ===============================================================================

		include	"Subs/LoadMaps.asm"
		even

; ===============================================================================

		include	"Subs/DMA_68KtoVRAM.asm"
		even

; ===============================================================================

		include	"Subs/Process_DMA.asm"
		even

; ===============================================================================

		include	"Subs/NemDec.asm"
		even

; ===============================================================================

;Note: The PLC routines requires some Nemesis compression routines

		include	"Subs/PLC.asm"
		even

; ===============================================================================

		include	"Subs/EniDec.asm"
		even

; ===============================================================================

		include	"Subs/KosDec.asm"
		even

; ===============================================================================

		include	"Subs/UnkDec.asm"
		even


; =============== S U B R O U T I N E ==========================================


PalCycle_Load:
		moveq	#0,d2
		moveq	#0,d0
		move.b	(RAM_Level_CurrentZone).w,d0
		add.w	d0,d0
		move.w	PalCycle(pc,d0.w),d0
		jmp	PalCycle(pc,d0.w)
		rts

; ===============================================================================
PalCycle:	dc.w PalCycle_GHZ-PalCycle
		dc.w PalCycle_CPZ-PalCycle
		dc.w PalCycle_CPZ-PalCycle
		dc.w PalCycle_EHZ-PalCycle
		dc.w PalCycle_HPZ-PalCycle
		dc.w PalCycle_HTZ-PalCycle
		dc.w PalCycle_GHZ-PalCycle
; ===============================================================================

;Leftover from Sonic 1
		lea	(Pal_S1TitleCyc).l,a0
		bra.s	loc_1E7C
; ===============================================================================

PalCycle_GHZ:
		lea	(Pal_GHZCyc).l,a0

loc_1E7C:
		subq.w	#1,(RAM_PalCyc_Timer2).w
		bpl.s	locret_1EA2
		move.w	#5,(RAM_PalCyc_Timer2).w
		move.w	(RAM_PalCyc_Timer1).w,d0
		addq.w	#1,(RAM_PalCyc_Timer1).w
		andi.w	#3,d0
		lsl.w	#3,d0
		lea	(RAM_Pal_3+$10).w,a1
		move.l	(a0,d0.w),(a1)+
		move.l	4(a0,d0.w),(a1)

locret_1EA2:
		rts
; ===============================================================================

PalCycle_CPZ:
		subq.w	#1,(RAM_PalCyc_Timer2).w
		bpl.s	locret_1F14
		move.w	#7,(RAM_PalCyc_Timer2).w
		lea	(Pal_CPZCyc1).l,a0
		move.w	(RAM_PalCyc_Timer1).w,d0
		addq.w	#6,(RAM_PalCyc_Timer1).w
		cmpi.w	#$36,(RAM_PalCyc_Timer1).w ; '6'
		bcs.s	loc_1ECC
		move.w	#0,(RAM_PalCyc_Timer1).w

loc_1ECC:
		lea	(RAM_Pal_4+$18).w,a1
		move.l	(a0,d0.w),(a1)+
		move.w	4(a0,d0.w),(a1)
		lea	(Pal_CPZCyc2).l,a0
		move.w	(RAM_Level_WaterSpd).w,d0
		addq.w	#2,(RAM_Level_WaterSpd).w
		cmpi.w	#$2A,(RAM_Level_WaterSpd).w
		bcs.s	loc_1EF4
		move.w	#0,(RAM_Level_WaterSpd).w

loc_1EF4:
		move.w	(a0,d0.w),(RAM_Pal_4+$1E).w
		lea	(Pal_CPZCyc3).l,a0
		move.w	(RAM_PalCyc_Timer3).w,d0
		addq.w	#2,(RAM_PalCyc_Timer3).w
		andi.w	#$1E,(RAM_PalCyc_Timer3).w
		move.w	(a0,d0.w),(RAM_Pal_3+$1E).w

locret_1F14:
		rts
; ===============================================================================

PalCycle_HPZ:
		subq.w	#1,(RAM_PalCyc_Timer2).w
		bpl.s	locret_1F56
		move.w	#4,(RAM_PalCyc_Timer2).w
		lea	(Pal_HPZCyc1).l,a0
		move.w	(RAM_PalCyc_Timer1).w,d0
		subq.w	#2,(RAM_PalCyc_Timer1).w
		bcc.s	loc_1F38
		move.w	#6,(RAM_PalCyc_Timer1).w

loc_1F38:
		lea	(RAM_Pal_4+$12).w,a1
		move.l	(a0,d0.w),(a1)+
		move.l	4(a0,d0.w),(a1)
		lea	(Pal_HPZCyc2).l,a0
		lea	(RAM_Pal_4_Water+$12).w,a1
		move.l	(a0,d0.w),(a1)+
		move.l	4(a0,d0.w),(a1)

locret_1F56:
		rts
; ===============================================================================

		include	"Levels/03/palcyc.asm"
		even

; ===============================================================================

PalCycle_HTZ:
		lea	(Pal_HTZCyc1).l,a0
		subq.w	#1,(RAM_PalCyc_Timer2).w
		bpl.s	locret_1FB8
		move.w	#0,(RAM_PalCyc_Timer2).w
		move.w	(RAM_PalCyc_Timer1).w,d0
		addq.w	#1,(RAM_PalCyc_Timer1).w
		andi.w	#$F,d0
		move.b	Pal_HTZCyc2(pc,d0.w),(RAM_PalCyc_Timer2+$1).w
		lsl.w	#3,d0
		move.l	(a0,d0.w),(RAM_Pal_2+$6).w
		move.l	4(a0,d0.w),(RAM_Pal_2+$1C).w

locret_1FB8:
		rts
; ===============================================================================
Pal_HTZCyc2:	incbin	"Levels\05\palcyc\HTZCyc2.bin"
		even
Pal_S1TitleCyc:	dc.w  $C42, $E86, $ECA,	$EEC, $EEC, $C42, $E86,	$ECA, $ECA, $EEC, $C42,	$E86, $E86, $ECA, $EEC,	$C42
Pal_GHZCyc:	dc.w  $A86, $E86, $EA8,	$ECA, $ECA, $A86, $E86,	$EA8, $EA8, $ECA, $A86,	$E86, $E86, $EA8, $ECA,	$A86
Pal_EHZCyc:	dc.b  $A,$86, $E,$86, $E,$A8, $E,$CA, $E,$CA, $A,$86, $E,$86, $E,$A8
		dc.b  $E,$A8, $E,$CA, $A,$86, $E,$86, $E,$86, $E,$A8, $E,$CA, $A,$86
Pal_HTZCyc1:	incbin	"Levels\05\palcyc\HTZCyc1.bin"
		even
Pal_CPZCyc1:	dc.w  $E40, $C00, $C00,	$E60, $C20, $C00, $E40,	$E40, $C00, $C20, $E60,	$C20, $C00, $E40, $C40,	$C00
		dc.w  $C20, $E40, $C00,	$C00, $E60, $C20, $C00,	$E40, $E20, $C00, $C20
Pal_CPZCyc2:	dc.w   $E0,  $C2,  $A4,	 $86,  $68,  $4A,  $2C,	  $E, $20C, $40A, $608,	$806, $A04, $C02, $E00,	$C20
		dc.w  $A40, $860, $680,	$4A0, $2C0
Pal_CPZCyc3:	dc.w	$E,   $C,   $A,	   8,	 6,    4,    2,	   4,	 6,    8,   $A,	  $C,	$E,  $2E,  $4E,	 $2E
Pal_HPZCyc1:	dc.w  $E44, $E82, $EA8,	$EEE, $E44, $E82, $EA8,	$EEE
Pal_HPZCyc2:	dc.w  $E84, $EA6, $EC6,	$EE6, $E84, $EA6, $EC6,	$EE6

; ===============================================================================

		include	"Subs/PalFadingControls.asm"
		even

; ===============================================================================

		include	"Modes/SegaScreen/palcyc.asm"
		even

; ===============================================================================

PalLoad1:
		lea	(PalPointers).l,a1
		lsl.w	#3,d0
		adda.w	d0,a1
		movea.l	(a1)+,a2		;Get pallet location [long]
		movea.w	(a1)+,a3        	;Get RAM adress
		adda.w	#$80,a3         	;Add $80 to a3
		move.w	(a1)+,d7        	;Get the pallete length

PalLoad1_Loop:
		move.l	(a2)+,(a3)+
		dbf	d7,PalLoad1_Loop	;Loop d7 times
		rts

; ===============================================================================

PalLoad2:
		lea	(PalPointers).l,a1
		lsl.w	#3,d0
		adda.w	d0,a1
		movea.l	(a1)+,a2
		movea.w	(a1)+,a3
		move.w	(a1)+,d7

PalLoad2_Loop:
		move.l	(a2)+,(a3)+
		dbf	d7,PalLoad2_Loop
		rts


; ===============================================================================

PalLoad3:
		lea	(PalPointers).l,a1
		lsl.w	#3,d0
		adda.w	d0,a1
		movea.l	(a1)+,a2
		movea.w	(a1)+,a3
		suba.w	#$80,a3
		move.w	(a1)+,d7

PalLoad3_Loop:
		move.l	(a2)+,(a3)+
		dbf	d7,PalLoad3_Loop
		rts


; ===============================================================================

PalLoad4:
		lea	(PalPointers).l,a1
		lsl.w	#3,d0
		adda.w	d0,a1
		movea.l	(a1)+,a2
		movea.w	(a1)+,a3
		suba.w	#$100,a3
		move.w	(a1)+,d7

PalLoad4_Loop:
		move.l	(a2)+,(a3)+
		dbf	d7,PalLoad4_Loop
		rts

; ===============================================================================

PalPointers:
		dc.l Pal_SegaBG
		dc.w $FB00
		dc.w $1F
		dc.l Pal_Title
		dc.w $FB00
		dc.w (((Pal_Title_End-Pal_Title)/4)-1)
		dc.l Pal_LevelSelect
		dc.w $FB00
		dc.w (((Pal_LevelSelect_End-Pal_LevelSelect)/4)-1)
		dc.l Pal_SonicTails
		dc.w $FB00
		dc.w (((Pal_SonicTails_End-Pal_SonicTails)/4)-1)
		dc.l Pal_GHZ
		dc.w $FB20
		dc.w (((Pal_GHZ_End-Pal_GHZ)/4)-1)
		dc.l Pal_CPZ
		dc.w $FB20
		dc.w $17
		dc.l Pal_CPZ
		dc.w $FB20
		dc.w $17
		dc.l Pal_EHZ
		dc.w $FB20
		dc.w $17
		dc.l Pal_HPZ
		dc.w $FB20
		dc.w $17
		dc.l Pal_HTZ
		dc.w $FB20
		dc.w $17
		dc.l Pal_SpecialStage
		dc.w $FB00
		dc.w $1F
		dc.l Pal_HPZWater
		dc.w $FB00
		dc.w $1F
		dc.l Pal_LZ
		dc.w $FB20
		dc.w $17
		dc.l Pal_LZ4
		dc.w $FB00
		dc.w $1F
		dc.l Pal_HTZ
		dc.w $FB20
		dc.w $17
		dc.l Pal_LZSonicWater
		dc.w $FB00
		dc.w 7
		dc.l Pal_LZ4SonicWater
		dc.w $FB00
		dc.w 7
		dc.l Pal_S1SpecialStageTC
		dc.w $FB00
		dc.w $1F
		dc.l Pal_S1Continue
		dc.w $FB00
		dc.w $F
		dc.l Pal_S1Ending
		dc.w $FB00
		dc.w $1F

; ===============================================================================

Pal_SegaBG:	dc.w  $EEE, $EEE, $EEE,	$EEE, $EEE, $EEE, $EEE,	$EEE, $EEE, $EEE, $EEE,	$EEE, $EEE, $EEE, $EEE,	$EEE
		dc.w  $EEE, $EEE, $EEE,	$EEE, $EEE, $EEE, $EEE,	$EEE, $EEE, $EEE, $EEE,	$EEE, $EEE, $EEE, $EEE,	$EEE
		dc.w  $EEE, $EEE, $EEE,	$EEE, $EEE, $EEE, $EEE,	$EEE, $EEE, $EEE, $EEE,	$EEE, $EEE, $EEE, $EEE,	$EEE
		dc.w  $EEE, $EEE, $EEE,	$EEE, $EEE, $EEE, $EEE,	$EEE, $EEE, $EEE, $EEE,	$EEE, $EEE, $EEE, $EEE,	$EEE
Pal_SegaBG_End:


Pal_Title:	dc.w  $C00,    2, $800,	 $26,  $48,  $6C,  $8E,	 $AE, $4A0,  $40,  $60,	 $80,  $A0, $6A4,    0,	   0; 0
		dc.w  $C8C, $800,    0,	$A66, $EA8, $ECA, $EEE,	 $AE,  $8E,  $6C, $8CE,	$EEC,  $4A,    6,    0,	   0; 16
		dc.w  $C00, $C00, $E22,	$E44, $E66, $E88, $EEE,	$AAA, $888, $666,  $24,	$248, $8AE, $68C,    0,	$ECA; 32
		dc.w  $C00, $600, $C00,	$E44, $E66, $E88, $EEE,	 $AE,  $6A,  $26,  $EE,	$EAA,	$C,    6,    2,	   0; 48
Pal_Title_End:

Pal_LevelSelect:dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	$EEE; 0
		dc.w  $C00,  $24, $246,	$468, $68A, $8AC, $ACE,	$8AC, $68A, $468, $ACE,	$ACE, $246,  $24,    0,	   0; 16
		dc.w  $C00,  $24, $246,	$468, $68A, $8AC, $ACE,	$8AC, $68A, $468,  $24,	$246, $8AC, $68A,    0,	 $EE; 32
		dc.w  $C00,  $24, $246,	$468, $68A, $8AC, $ACE,	$8AC, $68A, $468, $ACE,	$ACE, $468, $246,    2,	   0; 48
Pal_LevelSelect_End:

Pal_SonicTails:
               incbin "Sprites\01\Pal.bin"
               even
Pal_SonicTails_End:

Pal_GHZ:	dc.w  $800,    0, $242,	$464, $686, $8C8, $EEE,	$AAA, $888, $444, $8EA,	$46A,  $EE,  $88,  $44,	  $E; 0
		dc.w  $E80,    2, $EEE,	 $26,  $48,  $6C,  $8E,	 $CE, $A86, $E86, $EA8,	$ECA,  $40,  $60,  $A4,	 $E8; 16
		dc.w  $C82, $A02, $C42,	$E86, $ECA, $EEC, $EEE,	$EAC, $E8A, $E68,  $E8,	 $A4,	 2,  $26,  $6C,	 $CE; 32
Pal_GHZ_End:

Pal_HPZWater:	dc.w	 0, $402, $A20,	$B40, $B60, $B80, $ECA,	$CA8, $A84, $860, $AA8,	$884, $428, $424, $8AA,	$88A; 0
		dc.w	 0, $202, $242,	$464, $686, $442, $EAA,	$D88, $D66, $A22, $666,	$46A, $6CA, $484, $EEE,	  $E; 16
		dc.w  $400, $A20, $C22,	$E26, $E28, $A22, $A40,	$C22, $A60, $E28, $E4A,	$E6A, $CAA, $E24, $E26,	$E8A; 32
		dc.w  $400, $440, $660,	$880, $8A0, $8C0, $AE4,	$EEA, $A60, $E84, $EA6,	$EC6, $EE6, $E6A, $E8A,	$CAA; 48

Pal_CPZ:	dc.w	 2,    0, $E64,	$A68, $E86,  $44, $EEE,	$AAA, $888, $444, $666,	   0,  $EE,  $88, $EA8,	$ECA; 0
		dc.w	 2,    0,    6,	$A0A, $C4C, $E6E, $EAE,	 $CE,  $8E,  $4E,  $2C,	 $2A,	 8,    4, $EEE,	  $E; 16
		dc.w	 2,    0, $222,	$444, $888, $AAA, $EEE,	$E40, $C00, $800,  $CE,	$28E, $E40, $C00, $C00,	 $E0; 32

Pal_EHZ:	incbin "Levels\03\Pal.bin"
		even

Pal_HPZ:	dc.w  $800,    0, $242,	$464, $686,  $44, $EEE,	$AAA, $888, $444, $8EA,	$46A,  $EE,  $88,  $44,	  $E; 0
		dc.w  $200, $402, $604,	$806, $808, $602, $620,	$202, $640,  $26,  $68,	$28A, $6CE,  $24,  $46,	$4AC; 16
		dc.w  $200,  $20,  $40,	 $60,  $80,  $C0, $4E6,	$EEE, $602, $E44, $E82,	$EA8, $EEE,  $24,  $46,	$4AC; 32

Pal_HTZ:	dc.w  $C20,    0, $200,	  $E,  $6E,  $44, $EEE,	$AAA, $888, $444, $666,	$E86,  $EE,  $88,  $AE,	 $EE; 0
		dc.w  $E42, $200, $E86,	$640, $860, $A82, $CA4,	$EC6,  $24,  $40,  $62,	 $82,  $A4,  $6C,  $C4,	 $E8; 16
		dc.w  $E42,    4, $E64,	$E86, $EA8,  $28, $EEC,	$E6E, $C4C, $A2A, $ECA,	 $80, $26E,  $4C,  $A4,	 $E8; 32

Pal_SpecialStage:
		dc.w  $400,	0, $822, $A44, $C66, $E88, $EEE, $AAA, $888, $444, $8AE, $46A,	 $E,	8,    4,  $EE; 0
		dc.w  $400,    0,  $24,	 $68,  $AC, $2EE, $EEE,	$AAA, $888, $444, $AE4,	$6A2,  $EE,  $88,  $44,	   0; 16
		dc.w  $400,    0, $204,	$628, $A4C, $C6E, $ECE,	$800, $C42, $E86, $ECA,	$EEC,	 0, $EE0, $AA0,	$440; 32
		dc.w  $400,    0,  $60,	 $A0,  $C6,  $EA, $AEC,	$EEA, $EE0, $AA0, $880,	$660, $440, $EE0, $AA0,	$440; 48

Pal_LZ:		dc.w  $800,    0, $626,	$A2A, $C4C, $E8E, $EEE,	$AAA, $888, $444, $8E0,	$260,  $EE,  $88,  $44,	  $E; 0
		dc.w	 0, $444, $666,	$888, $AAA, $CCC, $EEE,	   0, $C8C, $A6A, $848,	$ECE, $E8C, $A48, $826,	$EEE; 16
		dc.w	 0,    0,  $20,	$240, $462, $882, $CC6,	$EEA, $282, $4A4, $8E8,	$AAA, $666, $222, $684,	$EEE; 32

Pal_LZ4:	dc.w	 0,    0, $A26,	$C48, $E6A, $E8C, $ECE,	$CAC, $868, $646, $CAE,	$86C, $60C, $426,    4,	 $EE; 0
		dc.w  $800,    0, $226,	$22A, $44C, $88E, $EEE,	$AAA, $888, $444, $6C0,	$240,  $EA,  $84,  $40,	  $E; 16
		dc.w	 0, $202, $404,	$626, $848, $A6A, $C8C,	   0, $848, $626, $404,	$ECE, $E8C, $A48, $826,	$EEE; 32
		dc.w	 0,    0,    0,	$200, $402, $644, $866,	$A88, $264, $486, $6A8,	 $26,  $48,  $6A, $604,	$AAA; 48

Pal_LZSonicWater:
		dc.w	  0,	0, $220, $442, $662, $884, $EEE, $AAA, $888, $444, $6AA, $266,	$48,  $24,    2,  $EE; 0

Pal_LZ4SonicWater:
		dc.w	   0,	 0, $A26, $C48,	$E6A, $E8C, $ECE, $CAC,	$868, $646, $CAE, $86C,	$60C, $426,    4,  $EE;	0

Pal_S1SpecialStageTC:
		dc.w  $EEE, $EAA, $EAA,  $EE,  $EE,  $EE, $8A0, $AC0, $CE0, $EAA,	$24,  $68,  $AC, $2EE, $EEE, $4C0; 0
		dc.w  $EEE,    0, $822,	$A44, $C66, $E88, $EEE,	$AAA, $888, $444, $8AE,	$46A,	$E,    8,    4,	   0; 16
		dc.w  $EEE,    0, $204,	$628, $A4C, $C6E, $ECE,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 32
		dc.w  $EEE,    0,  $60,	 $A0,  $C6,  $EA, $AEC,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 48

Pal_S1Continue:	dc.w	 0,    0, $822,	$A44, $C66, $E88, $EEE,	$AAA, $888, $444, $8AE,	$46A,	$E,    8,    4,	 $EE; 0
		dc.w	 0,    0, $424,	$848, $A6A, $E8E,    0,	   0,	 0,    0,    0,	   0,  $EE,  $88,  $44,	   0; 16

Pal_S1Ending:	dc.w  $E80,    0, $822,	$A44, $C66, $E88, $EEE,	$AAA, $888, $444, $8AE,	$46A,	$E,    8,    4,	 $EE; 0
		dc.w  $E80,    0, $608,	$82A, $A4C, $C6E, $EEE,	$AAE, $66C, $22A, $8EA,	$46A,  $EE,  $88,  $44,	  $E; 16
		dc.w  $E80,    2, $EEE,	 $26,  $48,  $6C,  $8E,	 $CE, $A86, $E86, $EA8,	$ECA,  $40,  $60,  $A4,	 $E8; 32
		dc.w  $C82, $A02, $C42,	$E86, $ECA, $EEC, $EEE,	$EAC, $E8A, $E68,  $E8,	 $A4,	 2,  $26,  $6C,	 $CE; 48
; ===============================================================================
		nop

; ===============================================================================

DelayProgram:
		move	#$2300,sr
loc_2C88:
		tst.b	(RAM_VIntCount).w
		bne.s	loc_2C88
		rts


; =============== S U B R O U T I N E ==========================================


		include	"Subs/MakeRandomNumber.asm"
		even


; =============== S U B R O U T I N E ==========================================


CalcSine:
		andi.w	#$FF,d0
		add.w	d0,d0
		addi.w	#$80,d0
		move.w	Sine_Data(pc,d0.w),d1
		subi.w	#$80,d0
		move.w	Sine_Data(pc,d0.w),d0
		rts

; ===============================================================================
Sine_Data:	dc.w	  0,	 6,    $C,   $12,   $19,   $1F,	  $25,	 $2B; 0
		dc.w	$31,   $38,   $3E,   $44,   $4A,   $50,	  $56,	 $5C; 8
		dc.w	$61,   $67,   $6D,   $73,   $78,   $7E,	  $83,	 $88; 16
		dc.w	$8E,   $93,   $98,   $9D,   $A2,   $A7,	  $AB,	 $B0; 24
		dc.w	$B5,   $B9,   $BD,   $C1,   $C5,   $C9,	  $CD,	 $D1; 32
		dc.w	$D4,   $D8,   $DB,   $DE,   $E1,   $E4,	  $E7,	 $EA; 40
		dc.w	$EC,   $EE,   $F1,   $F3,   $F4,   $F6,	  $F8,	 $F9; 48
		dc.w	$FB,   $FC,   $FD,   $FE,   $FE,   $FF,	  $FF,	 $FF; 56
		dc.w   $100,   $FF,   $FF,   $FF,   $FE,   $FE,	  $FD,	 $FC; 64
		dc.w	$FB,   $F9,   $F8,   $F6,   $F4,   $F3,	  $F1,	 $EE; 72
		dc.w	$EC,   $EA,   $E7,   $E4,   $E1,   $DE,	  $DB,	 $D8; 80
		dc.w	$D4,   $D1,   $CD,   $C9,   $C5,   $C1,	  $BD,	 $B9; 88
		dc.w	$B5,   $B0,   $AB,   $A7,   $A2,   $9D,	  $98,	 $93; 96
		dc.w	$8E,   $88,   $83,   $7E,   $78,   $73,	  $6D,	 $67; 104
		dc.w	$61,   $5C,   $56,   $50,   $4A,   $44,	  $3E,	 $38; 112
		dc.w	$31,   $2B,   $25,   $1F,   $19,   $12,	   $C,	   6; 120
		dc.w	  0,	-6,   -$C,  -$12,  -$19,  -$1F,	 -$25,	-$2B; 128
		dc.w   -$31,  -$38,  -$3E,  -$44,  -$4A,  -$50,	 -$56,	-$5C; 136
		dc.w   -$61,  -$67,  -$6D,  -$75,  -$78,  -$7E,	 -$83,	-$88; 144
		dc.w   -$8E,  -$93,  -$98,  -$9D,  -$A2,  -$A7,	 -$AB,	-$B0; 152
		dc.w   -$B5,  -$B9,  -$BD,  -$C1,  -$C5,  -$C9,	 -$CD,	-$D1; 160
		dc.w   -$D4,  -$D8,  -$DB,  -$DE,  -$E1,  -$E4,	 -$E7,	-$EA; 168
		dc.w   -$EC,  -$EE,  -$F1,  -$F3,  -$F4,  -$F6,	 -$F8,	-$F9; 176
		dc.w   -$FB,  -$FC,  -$FD,  -$FE,  -$FE,  -$FF,	 -$FF,	-$FF; 184
		dc.w  -$100,  -$FF,  -$FF,  -$FF,  -$FE,  -$FE,	 -$FD,	-$FC; 192
		dc.w   -$FB,  -$F9,  -$F8,  -$F6,  -$F4,  -$F3,	 -$F1,	-$EE; 200
		dc.w   -$EC,  -$EA,  -$E7,  -$E4,  -$E1,  -$DE,	 -$DB,	-$D8; 208
		dc.w   -$D4,  -$D1,  -$CD,  -$C9,  -$C5,  -$C1,	 -$BD,	-$B9; 216
		dc.w   -$B5,  -$B0,  -$AB,  -$A7,  -$A2,  -$9D,	 -$98,	-$93; 224
		dc.w   -$8E,  -$88,  -$83,  -$7E,  -$78,  -$75,	 -$6D,	-$67; 232
		dc.w   -$61,  -$5C,  -$56,  -$50,  -$4A,  -$44,	 -$3E,	-$38; 240
		dc.w   -$31,  -$2B,  -$25,  -$1F,  -$19,  -$12,	  -$C,	  -6; 248
		dc.w	  0,	 6,    $C,   $12,   $19,   $1F,	  $25,	 $2B; 256
		dc.w	$31,   $38,   $3E,   $44,   $4A,   $50,	  $56,	 $5C; 264
		dc.w	$61,   $67,   $6D,   $73,   $78,   $7E,	  $83,	 $88; 272
		dc.w	$8E,   $93,   $98,   $9D,   $A2,   $A7,	  $AB,	 $B0; 280
		dc.w	$B5,   $B9,   $BD,   $C1,   $C5,   $C9,	  $CD,	 $D1; 288
		dc.w	$D4,   $D8,   $DB,   $DE,   $E1,   $E4,	  $E7,	 $EA; 296
		dc.w	$EC,   $EE,   $F1,   $F3,   $F4,   $F6,	  $F8,	 $F9; 304
		dc.w	$FB,   $FC,   $FD,   $FE,   $FE,   $FF,	  $FF,	 $FF; 312

; =============== S U B R O U T I N E ==========================================


CalcAngle:
		movem.l	d3-d4,-(sp)
		moveq	#0,d3
		moveq	#0,d4
		move.w	d1,d3
		move.w	d2,d4
		or.w	d3,d4
		beq.s	loc_2FAA
		move.w	d2,d4
		tst.w	d3
		bpl.w	loc_2F68
		neg.w	d3

loc_2F68:
		tst.w	d4
		bpl.w	loc_2F70
		neg.w	d4

loc_2F70:
		cmp.w	d3,d4
		bcc.w	loc_2F82
		lsl.l	#8,d4
		divu.w	d3,d4
		moveq	#0,d0
		move.b	AngleData(pc,d4.w),d0
		bra.s	loc_2F8C
; ===============================================================================

loc_2F82:
		lsl.l	#8,d3
		divu.w	d4,d3
		moveq	#$40,d0
		sub.b	AngleData(pc,d3.w),d0

loc_2F8C:
		tst.w	d1
		bpl.w	loc_2F98
		neg.w	d0
		addi.w	#$80,d0

loc_2F98:
		tst.w	d2
		bpl.w	loc_2FA4
		neg.w	d0
		addi.w	#$100,d0

loc_2FA4:
		movem.l	(sp)+,d3-d4
		rts
; ===============================================================================

loc_2FAA:
		move.w	#$40,d0
		movem.l	(sp)+,d3-d4
		rts

; ===============================================================================
AngleData:	dc.b   0,  0,  0,  0,  1,  1,  1,  1; 0
		dc.b   1,  1,  2,  2,  2,  2,  2,  2; 8
		dc.b   3,  3,  3,  3,  3,  3,  3,  4; 16
		dc.b   4,  4,  4,  4,  4,  5,  5,  5; 24
		dc.b   5,  5,  5,  6,  6,  6,  6,  6; 32
		dc.b   6,  6,  7,  7,  7,  7,  7,  7; 40
		dc.b   8,  8,  8,  8,  8,  8,  8,  9; 48
		dc.b   9,  9,  9,  9,  9, $A, $A, $A; 56
		dc.b  $A, $A, $A, $A, $B, $B, $B, $B; 64
		dc.b  $B, $B, $B, $C, $C, $C, $C, $C; 72
		dc.b  $C, $C, $D, $D, $D, $D, $D, $D; 80
		dc.b  $D, $E, $E, $E, $E, $E, $E, $E; 88
		dc.b  $F, $F, $F, $F, $F, $F, $F,$10; 96
		dc.b $10,$10,$10,$10,$10,$10,$11,$11; 104
		dc.b $11,$11,$11,$11,$11,$11,$12,$12; 112
		dc.b $12,$12,$12,$12,$12,$13,$13,$13; 120
		dc.b $13,$13,$13,$13,$13,$14,$14,$14; 128
		dc.b $14,$14,$14,$14,$14,$15,$15,$15; 136
		dc.b $15,$15,$15,$15,$15,$15,$16,$16; 144
		dc.b $16,$16,$16,$16,$16,$16,$17,$17; 152
		dc.b $17,$17,$17,$17,$17,$17,$17,$18; 160
		dc.b $18,$18,$18,$18,$18,$18,$18,$18; 168
		dc.b $19,$19,$19,$19,$19,$19,$19,$19; 176
		dc.b $19,$19,$1A,$1A,$1A,$1A,$1A,$1A; 184
		dc.b $1A,$1A,$1A,$1B,$1B,$1B,$1B,$1B; 192
		dc.b $1B,$1B,$1B,$1B,$1B,$1C,$1C,$1C; 200
		dc.b $1C,$1C,$1C,$1C,$1C,$1C,$1C,$1C; 208
		dc.b $1D,$1D,$1D,$1D,$1D,$1D,$1D,$1D; 216
		dc.b $1D,$1D,$1D,$1E,$1E,$1E,$1E,$1E; 224
		dc.b $1E,$1E,$1E,$1E,$1E,$1E,$1F,$1F; 232
		dc.b $1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F; 240
		dc.b $1F,$1F,$20,$20,$20,$20,$20,$20; 248
		dc.b $20,  0
; ===============================================================================
		nop
; ===============================================================================

		include	"Modes/SegaScreen/code.asm"
		even

; ===============================================================================
		dc.w 0
; ===============================================================================

		include	"Modes/TitleScreen/code.asm"
		even

		include	"Modes/Demo/code.asm"
		even

; =============== S U B R O U T I N E ==========================================


LevelSelect_Controls:
		move.b	(RAM_Control_1_Press).w,d1
		andi.b	#3,d1
		bne.s	loc_3706
		subq.w	#1,(RAM_LevSel_CursorPos).w
		bpl.s	loc_3740

loc_3706:
		move.w	#$B,(RAM_LevSel_CursorPos).w
		move.b	(RAM_Control_1_Hold).w,d1
		andi.b	#3,d1
		beq.s	loc_3740
		move.w	(RAM_LevSel_SelItem).w,d0
		btst	#0,d1
		beq.s	loc_3726
		subq.w	#1,d0
		bcc.s	loc_3726
		moveq	#$14,d0

loc_3726:
		btst	#1,d1
		beq.s	loc_3736
		addq.w	#1,d0
		cmpi.w	#$15,d0
		bcs.s	loc_3736
		moveq	#0,d0

loc_3736:
		move.w	d0,(RAM_LevSel_SelItem).w
		bsr.w	LevelSelect_TextLoad
		rts
; ===============================================================================

loc_3740:
		cmpi.w	#$14,(RAM_LevSel_SelItem).w
		bne.s	locret_377A
		move.b	(RAM_Control_1_Press).w,d1
		andi.b	#$C,d1
		beq.s	locret_377A
		move.w	(RAM_LevSel_SelSnd).w,d0
		btst	#2,d1
		beq.s	loc_3762
		subq.w	#1,d0
		bcc.s	loc_3762
		moveq	#$4F,d0

loc_3762:
		btst	#3,d1
		beq.s	loc_3772
		addq.w	#1,d0
		cmpi.w	#$50,d0
		bcs.s	loc_3772
		moveq	#0,d0

loc_3772:
		move.w	d0,(RAM_LevSel_SelSnd).w
		bsr.w	LevelSelect_TextLoad

locret_377A:
		rts


; =============== S U B R O U T I N E ==========================================


LevelSelect_TextLoad:
		lea	(LevelSelect_Text).l,a1
		lea	($C00000).l,a6			;Move VDP Data Port to a6
		move.l	#$62100003,d4			;VDP Address to d4
		move.w	#$8680,d3			;VRAM Address to d3
		moveq	#$14,d1				;Y-pos length

loc_3794:
		move.l	d4,4(a6)
		bsr.w	sub_381C
		addi.l	#$800000,d4
		dbf	d1,loc_3794
		moveq	#0,d0
		move.w	(RAM_LevSel_SelItem).w,d0
		move.w	d0,d1
		move.l	#$62100003,d4			;VDP Address to d4
		lsl.w	#7,d0
		swap	d0
		add.l	d0,d4
		lea	(LevelSelect_Text).l,a1
		lsl.w	#3,d1
		move.w	d1,d0
		add.w	d1,d1
		add.w	d0,d1
		adda.w	d1,a1
		move.w	#$C680,d3
		move.l	d4,4(a6)
		bsr.w	sub_381C
		move.w	#$8680,d3			;VRAM Address to d3
		cmpi.w	#$14,(RAM_LevSel_SelItem).w
		bne.s	loc_37E6
		move.w	#$C680,d3			;VRAM Address to d3

loc_37E6:
		move.l	#$6C300003,($C00004).l		;VDP Address
		move.w	(RAM_LevSel_SelSnd).w,d0	;Copy the selected sound to d0
		addi.w	#$80,d0				;Add $80 to d0
		move.b	d0,d2				;Backup d0 to d2
		lsr.b	#4,d0
		bsr.w	LevelSelect_ShowByte
		move.b	d2,d0				;Restore d0 from d2
		bsr.w	LevelSelect_ShowByte
		rts


; =============== S U B R O U T I N E ==========================================


LevelSelect_ShowByte:
		andi.w	#$F,d0
		cmpi.b	#$A,d0
		bcs.s	loc_3816
		addi.b	#7,d0

loc_3816:
		add.w	d3,d0
		move.w	d0,(a6)
		rts


; =============== S U B R O U T I N E ==========================================


sub_381C:
		moveq	#$17,d2

loc_381E:
		moveq	#0,d0
		move.b	(a1)+,d0
		bpl.s	loc_382E
		move.w	#0,(a6)
		dbf	d2,loc_381E
		rts
; ===============================================================================

loc_382E:
		add.w	d3,d0
		move.w	d0,(a6)
		dbf	d2,loc_381E
		rts

; ===============================================================================
__Mney	equ	$0A
__Line	equ	$0B
__Equ	equ	$0C
__Rgt	equ	$0D
__Rgt2	equ	$0E
__Y	equ	$0F
__Z	equ	$10
__A	equ	$11
__B	equ	$12
__C	equ	$13
__D	equ	$14
__E	equ	$15
__F	equ	$16
__G	equ	$17
__H	equ	$18
__I	equ	$19
__J	equ	$1A
__K	equ	$1B
__L	equ	$1C
__M	equ	$1D
__N	equ	$1E
__O	equ	$1F
__P	equ	$20
__Q	equ	$21
__R	equ	$22
__S	equ	$23
__T	equ	$24
__U	equ	$25
__V	equ	$26
__X	equ	$27

___	equ	$FF

LevelSelect_Text:
	dc.b	__G,__R,__E,__E,__N,___,__H,__I,__L,__L,___,__Z,__O,__N,__E,___,___,__S,__T,__A,__G,__E,___,1
	dc.b	___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,__S,__T,__A,__G,__E,___,2
	dc.b	___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,__S,__T,__A,__G,__E,___,3
	dc.b	__M,__A,__R,__B,__L,__E,___,__Z,__O,__N,__E,___,___,___,___,___,___,__S,__T,__A,__G,__E,___,1
	dc.b	___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,__S,__T,__A,__G,__E,___,2
	dc.b	___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,__S,__T,__A,__G,__E,___,3
	dc.b	__S,__P,__R,__I,__N,__G,___,__Y,__A,__R,__D,___,__Z,__O,__N,__E,___,__S,__T,__A,__G,__E,___,1
	dc.b	___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,__S,__T,__A,__G,__E,___,2
	dc.b	___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,__S,__T,__A,__G,__E,___,3
	dc.b	__L,__A,__B,__Y,__R,__I,__N,__T,__H,___,__Z,__O,__N,__E,___,___,___,__S,__T,__A,__G,__E,___,1
	dc.b	___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,__S,__T,__A,__G,__E,___,2
	dc.b	___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,__S,__T,__A,__G,__E,___,3
	dc.b	__S,__T,__A,__R,___,__L,__I,__G,__H,__T,___,__Z,__O,__N,__E,___,___,__S,__T,__A,__G,__E,___,1
	dc.b	___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,__S,__T,__A,__G,__E,___,2
	dc.b	___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,__S,__T,__A,__G,__E,___,3
	dc.b	__S,__C,__R,__A,__P,___,__B,__R,__A,__I,__N,___,__Z,__O,__N,__E,___,__S,__T,__A,__G,__E,___,1
	dc.b	___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,__S,__T,__A,__G,__E,___,2
	dc.b	___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,___,__S,__T,__A,__G,__E,___,3
	dc.b	__F,__I,__N,__A,__L,___,__Z,__O,__N,__E,___,___,___,___,___,___,___,___,___,___,___,___,___,___
	dc.b	__S,__P,__E,__C,__I,__A,__L,___,__S,__T,__A,__G,__E,___,___,___,___,___,___,___,___,___,___,___
	dc.b	__S,__O,__U,__N,__D,___,__S,__E,__L,__E,__C,__T,___,___,___,___,___,___,___,___,___,___,___,___
; ===============================================================================

UnknownSub_1:
		lea	(RAM_MetablockTable).l,a1
		move.w	#$2EB,d2

loc_3A3A:
		move.w	(a1),d0
		move.w	d0,d1
		andi.w	#$F800,d1
		andi.w	#$7FF,d0
		lsr.w	#1,d0
		or.w	d0,d1
		move.w	d1,(a1)+
		dbf	d2,loc_3A3A
		rts
; ===============================================================================

UnknownSub_2:
		lea	($FE0000).l,a1
		lea	($FE0080).l,a2
		lea	(RAM_MetablockTable).l,a3
		move.w	#$3F,d1	; '?'

loc_3A68:
		bsr.w	UnknownSub_4
		bsr.w	UnknownSub_4
		dbf	d1,loc_3A68
		lea	($FE0000).l,a1
		lea	($FF0000).l,a2
		move.w	#$3F,d1	; '?'

loc_3A84:
		move.w	#0,(a2)+
		dbf	d1,loc_3A84
		move.w	#$3FBF,d1

loc_3A90:
		move.w	(a1)+,(a2)+
		dbf	d1,loc_3A90
		rts
; ===============================================================================

UnknownSub_3:
		lea	($FE0000).l,a1
		lea	(RAM_MetablockTable).l,a3
		moveq	#$1F,d0

loc_3AA6:
		move.l	(a1)+,(a3)+
		dbf	d0,loc_3AA6
		moveq	#0,d7
		lea	($FE0000).l,a1
		move.w	#$FF,d5

loc_3AB8:
		lea	(RAM_MetablockTable).l,a3
		move.w	d7,d6

loc_3AC0:
		movem.l	a1-a3,-(sp)
		move.w	#$3F,d0

loc_3AC8:
		cmpm.w	(a1)+,(a3)+
		bne.s	loc_3ADE
		dbf	d0,loc_3AC8
		movem.l	(sp)+,a1-a3
		adda.w	#$80,a1
		dbf	d5,loc_3AB8
		bra.s	loc_3AF8
; ===============================================================================

loc_3ADE:
		movem.l	(sp)+,a1-a3
		adda.w	#$80,a3
		dbf	d6,loc_3AC0
		moveq	#$1F,d0

loc_3AEC:
		move.l	(a1)+,(a3)+
		dbf	d0,loc_3AEC
		addq.l	#1,d7
		dbf	d5,loc_3AB8

loc_3AF8:
		bra.s	loc_3AF8

; =============== S U B R O U T I N E ==========================================


UnknownSub_4:
		moveq	#7,d0

loc_3AFC:
		move.l	(a3)+,(a1)+
		move.l	(a3)+,(a1)+
		move.l	(a3)+,(a1)+
		move.l	(a3)+,(a1)+
		move.l	(a3)+,(a2)+
		move.l	(a3)+,(a2)+
		move.l	(a3)+,(a2)+
		move.l	(a3)+,(a2)+
		dbf	d0,loc_3AFC
		adda.w	#$80,a1
		adda.w	#$80,a2
		rts

; ===============================================================================
		nop
; ===============================================================================
MusicList:
          	dc.b $81	;GHZ
		dc.b $82        ;LZ
                dc.b $83        ;MZ
                dc.b $84        ;SLZ
                dc.b $85        ;SYZ
                dc.b $86        ;SBZ
                dc.b $8D        ;Final
                dc.b 0
; ===============================================================================

Level:
		bset	#7,(RAM_GameMode).w			;level loading flag ($0C+$80)
		tst.w	(RAM_Flag_DemoMode).w			;Demo Mode?
		bmi.s	loc_3B38				;Branch if Minus
		move.b	#$E0,d0
		bsr.w	PlaySound_Special
loc_3B38:
		bsr.w	ClearPLC
		bsr.w	Pal_FadeFrom
		tst.w	(RAM_Flag_DemoMode).w
		bmi.s	Level_StartCleaning
		move	#$2700,sr				;Disable ints

		move.l	#$70000002,($C00004).l
		lea	(Nem_S1TitleCard).l,a0
		bsr.w	NemDec

		bsr.w	ClearScreen
		lea	($C00004).l,a5
		move.w	#$8F01,(a5)
		move.l	#$940F93FF,(a5)
		move.w	#$9780,(a5)

		move.l	#$60000082,(a5)				;Prevent access to VRAM location: $500
		move.w	#0,($C00000).l

loc_3B84:
		move.w	(a5),d1
		btst	#1,d1
		bne.s	loc_3B84
		move.w	#$8F02,(a5)
		move	#$2300,sr				;Re-enable ints

		moveq	#0,d0 					;S1's 2nd PLC load method
		move.b	(RAM_Level_CurrentZone).w,d0
		lsl.w	#4,d0
		lea	(MainLoadBlocks).l,a2
		lea	(a2,d0.w),a2
		moveq	#0,d0 					;Clear 0
		move.b	(a2),d0					;Move ID to d0
		beq.s	loc_3BB0				;Branch if $0 (Nothing to load)
		bsr.w	LoadPLC
loc_3BB0:
		moveq	#1,d0
		bsr.w	LoadPLC

Level_StartCleaning:
		lea	(RAM_SpriteTable).w,a1			;Clear Sprites
		moveq	#0,d0
		move.w	#$FF,d1
Level_ClearSprTable_Loop:
		move.l	d0,(a1)+
		dbf	d1,Level_ClearSprTable_Loop

		lea	(RAM_ObjectTable).w,a1			;Clear Objects
		moveq	#0,d0
		move.w	#$7FF,d1
Level_ClearSprites_Loop:
		move.l	d0,(a1)+
		dbf	d1,Level_ClearSprites_Loop

		lea	(RAM_Vint_Unk).w,a1			;[Unknown]
		moveq	#0,d0
		move.w	#$15,d1
loc_3BE0:
		move.l	d0,(a1)+
		dbf	d1,loc_3BE0

		lea	(RAM_S1_Level_PlaneA_XPos).w,a1		;Leftover from Sonic 1
		moveq	#0,d0
		move.w	#$3F,d1
loc_3BF0:
		move.l	d0,(a1)+
		dbf	d1,loc_3BF0

		lea	(RAM_WaterEffects).w,a1
		moveq	#0,d0
		move.w	#$47,d1
Level_ClearWaterEffect_Loop:
		move.l	d0,(a1)+
		dbf	d1,Level_ClearWaterEffect_Loop

		cmpi.b	#4,(RAM_Level_CurrentZone).w		;Is Spring Yard zone?
		bne.s	Level_NoWaterLevel			;If not, branch
		move.b	#1,(RAM_Flag_WaterLevel).w		;Mark as Water Level
		move.w	#0,(RAM_Flag_SplitScreen).w		;And disable split screen

Level_NoWaterLevel:
		lea	($C00004).l,a6
		move.w	#$8B03,(a6)
		move.w	#$8230,(a6)
		move.w	#$8407,(a6)
		move.w	#$857C,(a6)
		move.w	#$9001,(a6)
		move.w	#$8004,(a6)
		move.w	#$8720,(a6)
		move.w	#$8ADF,(RAM_VDPCmdForHint).w

		tst.w	(RAM_Flag_SplitScreen).w
		beq.s	Level_NoSplitScreen

		move.w	#$8A6B,(RAM_VDPCmdForHint).w
		move.w	#$8014,(a6)			;HInt Enable
		move.w	#$8C87,(a6)			;Double interlace H40

Level_NoSplitScreen:
		move.w	(RAM_VDPCmdForHint).w,(a6)
		move.l	#RAM_VDP_CmdBuffer,(RAM_VDPCmdFreeAddr).w

		tst.b	(RAM_Flag_WaterLevel).w
		beq.s	LevelInit_DontLoadWaterHeight

		move.w	#$8014,(a6)			;HInt Enable
		moveq	#0,d0				;LZ Leftover
		move.b	(RAM_Level_CurrentAct).w,d0
		add.w	d0,d0
		lea	(WaterHeight).l,a1
		move.w	(a1,d0.w),d0
		move.w	d0,(RAM_Level_Water_Action).w
		move.w	d0,(RAM_Level_Water_MainPos).w
		move.w	d0,(RAM_Level_Water_SetPos).w
		clr.b	(RAM_Level_WaterRoutineCntr).w
		clr.b	(RAM_FillWaterPalScr).w
		move.b	#1,(RAM_Flag_WaterFlag_Copy).w

LevelInit_DontLoadWaterHeight:
		move.w	#$1E,(RAM_Sonic_AirLeft).w

		moveq	#3,d0				;Set pal ID $3 (Sonic's Pallete)
		bsr.w	PalLoad2			;Load pallete quickly

		tst.b	(RAM_Flag_WaterLevel).w
		beq.s	loc_3CC6
		moveq	#$F,d0
		cmpi.b	#3,(RAM_Level_CurrentAct).w
		bne.s	loc_3CB6
		moveq	#$10,d0

loc_3CB6:
		bsr.w	PalLoad3
		tst.b	(RAM_Level_LamppostCntr).w
		beq.s	loc_3CC6
		move.b	(RAM_Lamppost_FillWtrPalScr).w,(RAM_FillWaterPalScr).w

loc_3CC6:
		tst.w	(RAM_Flag_DemoMode).w
		bmi.s	loc_3D2A

		moveq	#0,d0
		move.b	(RAM_Level_CurrentZone).w,d0
		cmpi.w	#$103,(RAM_Level_CurrentZone).w
		bne.s	loc_3CDC
		moveq	#5,d0

loc_3CDC:
		cmpi.w	#$502,(RAM_Level_CurrentZone).w
		bne.s	loc_3CE6
		moveq	#6,d0

loc_3CE6:
		lea	MusicList(pc),a1
		nop
		move.b	(a1,d0.w),d0
		bsr.w	PlaySound
		move.b	#$34,(RAM_ObjectTable+Obj_Slot_3).w

LevelInit_TitleCard:
		move.b	#$C,(RAM_VIntCount).w
		bsr.w	DelayProgram

		jsr	ObjectsLoad
		jsr	BuildSprites
		bsr.w	RunPLC
		move.w	(RAM_ObjectTable+Obj_Slot_5+$8).w,d0
		cmp.w	(RAM_ObjectTable+Obj_Slot_5+$30).w,d0
		bne.s	LevelInit_TitleCard
		tst.l	(RAM_PLC_Buffer).w				;Any items left on PLC buffer?
		bne.s	LevelInit_TitleCard				;If not, branch
		jsr	HUD_Base

loc_3D2A:
		moveq	#3,d0
		bsr.w	PalLoad1

		bsr.w	LevelSizeLoad
		bsr.w	DeformBGLayer
		bset	#2,(RAM_LevelSys_DirToDraw).w
		bsr.w	MainLevelLoadBlock
		jsr	LoadMap16Delta
		bsr.w	LoadTilesFromStart
		jsr	FloorLog_Unk
		bsr.w	ColIndexLoad
		bsr.w	WaterEffects
		move.b	#1,(RAM_ObjectTable).w
		tst.w	(RAM_Flag_DemoMode).w
		bmi.s	loc_3D6C
		move.b	#$21,(RAM_ObjectTable+Obj_Slot_15).w

loc_3D6C:
		tst.w	(RAM_Flag_SplitScreen).w
		bne.s	LevelInit_LoadTails
		cmpi.b	#3,(RAM_Level_CurrentZone).w				;is EHZ?
		beq.s	LevelInit_SkipTails					;If yes, branch ("funny how they skipped Tails in EHZ for the Nick Arcade show")

LevelInit_LoadTails:
		move.b	#2,(RAM_ObjRAM_Tails).w					;Load Obj02
		move.w	(RAM_ObjRAM_Sonic+$8).w,(RAM_ObjRAM_Tails+$8).w		;Copy Obj01's X-pos to Obj02's X-pos
		move.w	(RAM_ObjRAM_Sonic+$C).w,(RAM_ObjRAM_Tails+$C).w		;Copy Obj01's Y-pos to Obj02's Y-pos
		subi.w	#$20,(RAM_ObjRAM_Tails+$8).w				;Subtract $20 from Obj02's X-pos

LevelInit_SkipTails:
		tst.b	(RAM_Flag_Unk_1).w
		beq.s	loc_3DA6
		btst	#6,(RAM_Control_1_Hold).w
		beq.s	loc_3DA6
		move.b	#1,(RAM_Flag_DebugMode).w

loc_3DA6:
		move.w	#0,(RAM_Control_1_Hold_Copy).w
		move.w	#0,(RAM_Control_1_Hold).w
		tst.b	(RAM_Flag_WaterLevel).w					;Water level?
		beq.s	LevelInit_NoWaterObject					;If not, branch

		move.b	#4,(RAM_ObjectTable+Obj_Slot_31).w
		move.w	#$60,(RAM_ObjectTable+Obj_Slot_31+$8).w
		move.b	#4,(RAM_ObjectTable+Obj_Slot_32).w
		move.w	#$120,(RAM_ObjectTable+Obj_Slot_32+$8).w

LevelInit_NoWaterObject:
		jsr	ObjPosLoad
		jsr	RingPosLoad
		jsr	ObjectsLoad
		jsr	BuildSprites
		bsr.w	j_DynamicArtCues

		moveq	#0,d0
		tst.b	(RAM_Level_LamppostCntr).w				;Any lamppost touched?
		bne.s	loc_3E00						;If yes, don't clear the following stuff:
		move.w	d0,(RAM_Sonic_CurrentRings).w
		move.l	d0,(RAM_Hud_Time).w
		move.b	d0,(RAM_Sonic_1upScore).w

loc_3E00:
		move.b	d0,(RAM_Flag_Sonic_TimeOver).w
		move.b	d0,(RAM_Flag_Sonic_Shield).w
		move.b	d0,(RAM_Flag_Sonic_Invincibility).w
		move.b	d0,(RAM_Flag_Sonic_Shoes).w
		move.b	d0,(RAM_Flag_Sonic_Unused).w
		move.w	d0,(RAM_Flag_Debug_Placement).w
		move.w	d0,(RAM_Flag_ResetLevel).w
		move.w	d0,(RAM_Flag_LevelFrameTmr).w
		bsr.w	OscillateNumInit
		move.b	#1,(RAM_Flag_HudUpd_Score).w
		move.b	#1,(RAM_Flag_HudUpd_Rings).w
		move.b	#1,(RAM_Flag_HudUpd_Timer).w
		move.w	#4,(RAM_Sonic_StaticsRecBuffer).w
		move.w	#0,(RAM_Sonic_InvStarPosTable).w
		move.w	#0,(RAM_Demo_ButtonIndex).w
		move.w	#0,(RAM_Demo_ButtonIndex_2P).w

		lea	(Demo_Index).l,a1
		moveq	#0,d0
		move.b	(RAM_Level_CurrentZone).w,d0
		lsl.w	#2,d0
		movea.l	(a1,d0.w),a1

		tst.w	(RAM_Flag_DemoMode).w
		bpl.s	loc_3E78

		lea	(Demo_S1EndIndex).l,a1					; garbage, leftover from Sonic 1's ending sequence demos
		move.w	(RAM_S1_CreditsID).w,d0
		subq.w	#1,d0
		lsl.w	#2,d0
		movea.l	(a1,d0.w),a1
loc_3E78:
		move.b	1(a1),(RAM_Demo_FramesLeft).w
		subq.b	#1,(RAM_Demo_FramesLeft).w
		lea	(Demo_2P).l,a1
		move.b	1(a1),(RAM_Demo_ButtonIndex_2P+$2).w
		subq.b	#1,(RAM_Demo_ButtonIndex_2P+$2).w
		move.w	#$668,(RAM_DemoTimeLeft).w
		tst.w	(RAM_Flag_DemoMode).w
		bpl.s	LevelInit_AltWaterPal
		move.w	#$21C,(RAM_DemoTimeLeft).w
		cmpi.w	#4,(RAM_S1_CreditsID).w
		bne.s	LevelInit_AltWaterPal
		move.w	#$1FE,(RAM_DemoTimeLeft).w

LevelInit_AltWaterPal:
		tst.b	(RAM_Flag_WaterLevel).w
		beq.s	loc_3EC8
		moveq	#$B,d0
		cmpi.b	#3,(RAM_Level_CurrentAct).w
		bne.s	loc_3EC4
		moveq	#$D,d0
loc_3EC4:
		bsr.w	PalLoad4

loc_3EC8:
		move.w	#3,d1

loc_3ECC:
		move.b	#8,(RAM_VIntCount).w
		bsr.w	DelayProgram

		dbf	d1,loc_3ECC
		move.w	#$202F,(RAM_Pal_FadeToCtrl_PalStart).w		;Especial fade-in, Add $20 to start RAM, length = $2F
		bsr.w	Pal_FadeTo2
		tst.w	(RAM_Flag_DemoMode).w
		bmi.s	Level_ClrTitleCard
		addq.b	#2,(RAM_ObjectTable+Obj_Slot_3+$24).w
		addq.b	#4,(RAM_ObjectTable+Obj_Slot_4+$24).w
		addq.b	#4,(RAM_ObjectTable+Obj_Slot_5+$24).w
		addq.b	#4,(RAM_ObjectTable+Obj_Slot_6+$24).w
		bra.s	Level_StartGame
; ===============================================================================

Level_ClrTitleCard:
		moveq	#2,d0
		jsr	(LoadPLC).l
		moveq	#0,d0
		move.b	(RAM_Level_CurrentZone).w,d0
		addi.w	#$15,d0
		jsr	(LoadPLC).l

Level_StartGame:
		bclr	#7,(RAM_GameMode).w 		;Clear level loading flag

Level_MainLoop:
		bsr.w	Pause
		move.b	#8,(RAM_VIntCount).w
		bsr.w	DelayProgram

		addq.w	#1,(RAM_Flag_LevelFrameTmr).w
		bsr.w	MoveSonicInDemo
		bsr.w	WaterEffects
		jsr	ObjectsLoad
		tst.w	(RAM_Flag_ResetLevel).w
		bne.w	Level
		tst.w	(RAM_Flag_Debug_Placement).w
		bne.s	loc_3F50
		cmpi.b	#6,(RAM_ObjRAM_Sonic+$24).w
		bcc.s	loc_3F54

loc_3F50:
		bsr.w	DeformBGLayer

loc_3F54:
		bsr.w	ChangeWaterSurfacePos
		jsr	RingPosLoad
		bsr.w	j_DynamicArtCues
		bsr.w	PalCycle_Load
		bsr.w	RunPLC
		bsr.w	OscillateNumDo
		bsr.w	ChangeRingFrame
		bsr.w	SignpostArtLoad
		jsr	BuildSprites
		jsr	ObjPosLoad
		cmpi.b	#ModeId_Demo,(RAM_GameMode).w
		beq.s	loc_3F96
		cmpi.b	#ModeId_Level,(RAM_GameMode).w
		beq.w	Level_MainLoop
		rts
; ===============================================================================

loc_3F96:
		tst.w	(RAM_Flag_ResetLevel).w
		bne.s	loc_3FB4
		tst.w	(RAM_DemoTimeLeft).w
		beq.s	loc_3FB4
		cmpi.b	#ModeId_Demo,(RAM_GameMode).w
		beq.w	Level_MainLoop
		move.b	#ModeId_Sega,(RAM_GameMode).w
		rts
; ===============================================================================

loc_3FB4:
		cmpi.b	#ModeId_Demo,(RAM_GameMode).w
		bne.s	loc_3FCE
		move.b	#ModeId_Sega,(RAM_GameMode).w
		tst.w	(RAM_Flag_DemoMode).w
		bpl.s	loc_3FCE
		move.b	#$1C,(RAM_GameMode).w			;Leftover from S1

loc_3FCE:
		move.w	#$3C,(RAM_DemoTimeLeft).w
		move.w	#$3F,(RAM_Pal_FadeToCtrl_PalStart).w
		clr.w	(RAM_SS_Unknown_1).w

loc_3FDE:
		move.b	#8,(RAM_VIntCount).w
		bsr.w	DelayProgram

		bsr.w	MoveSonicInDemo
		jsr	ObjectsLoad
		jsr	BuildSprites
		jsr	ObjPosLoad
		subq.w	#1,(RAM_SS_Unknown_1).w
		bpl.s	loc_400E
		move.w	#2,(RAM_SS_Unknown_1).w
		bsr.w	Pal_FadeOut

loc_400E:
		tst.w	(RAM_DemoTimeLeft).w
		bne.s	loc_3FDE
		rts

; =============== S U B R O U T I N E ==========================================


ChangeWaterSurfacePos:
		tst.b	(RAM_Flag_WaterLevel).w
		beq.s	locret_403E
		move.w	(RAM_LevelSys_Buff).w,d1
		btst	#0,(RAM_Flag_LevelFrameTmr+$1).w
		beq.s	loc_402C
		addi.w	#$20,d1

loc_402C:
		move.w	d1,d0
		addi.w	#$60,d0
		move.w	d0,(RAM_ObjectTable+Obj_Slot_31+$8).w
		addi.w	#$120,d1
		move.w	d1,(RAM_ObjectTable+Obj_Slot_32+8).w

locret_403E:
		rts


; =============== S U B R O U T I N E ==========================================


WaterEffects:
		tst.b	(RAM_Flag_WaterLevel).w
		beq.s	locret_4094
		tst.b	(RAM_Level_NoEffectsFlag).w
		bne.s	loc_4058
		cmpi.b	#6,(RAM_ObjRAM_Sonic+$24).w
		bcc.s	loc_4058
		bsr.w	DynamicWaterHeight

loc_4058:
		clr.b	(RAM_FillWaterPalScr).w
		moveq	#0,d0
		move.b	(RAM_WaterEffects).w,d0
		lsr.w	#1,d0
		add.w	(RAM_Level_Water_MainPos).w,d0
		move.w	d0,(RAM_Level_Water_Action).w
		move.w	(RAM_Level_Water_Action).w,d0
		sub.w	(RAM_LevelSys_Buff+$4).w,d0
		bcc.s	loc_4086
		tst.w	d0
		bpl.s	loc_4086
		move.b	#$DF,(RAM_VDPCmdForHint+$1).w
		move.b	#1,(RAM_FillWaterPalScr).w

loc_4086:
		cmpi.w	#$DF,d0
		bcs.s	loc_4090
		move.w	#$DF,d0

loc_4090:
		move.b	d0,(RAM_VDPCmdForHint+$1).w

locret_4094:
		rts

; ===============================================================================
WaterHeight:	dc.w  $600, $328, $900,	$228

; =============== S U B R O U T I N E ==========================================


DynamicWaterHeight:
		moveq	#0,d0
		move.b	(RAM_Level_CurrentAct).w,d0
		add.w	d0,d0
		move.w	DynWater_Index(pc,d0.w),d0
		jsr	DynWater_Index(pc,d0.w)
		moveq	#0,d1
		move.b	(RAM_Flag_WaterFlag_Copy).w,d1
		move.w	(RAM_Level_Water_SetPos).w,d0
		sub.w	(RAM_Level_Water_MainPos).w,d0
		beq.s	locret_40C6
		bcc.s	loc_40C2
		neg.w	d1

loc_40C2:
		add.w	d1,(RAM_Level_Water_MainPos).w

locret_40C6:
		rts

; ===============================================================================
DynWater_Index:	dc.w DynWater_HPZ1-DynWater_Index; 0
		dc.w DynWater_HPZ2-DynWater_Index; 1
		dc.w DynWater_HPZ3-DynWater_Index; 2
		dc.w DynWater_HPZ4-DynWater_Index; 3
; ===============================================================================

DynWater_HPZ1:
		btst	#0,(RAM_Control_2_Hold).w
		beq.s	loc_40E2
		tst.w	(RAM_Level_Water_SetPos).w
		beq.s	loc_40E2
		subq.w	#1,(RAM_Level_Water_SetPos).w

loc_40E2:
		btst	#1,(RAM_Control_2_Hold).w
		beq.s	locret_40F6
		cmpi.w	#$700,(RAM_Level_Water_SetPos).w
		beq.s	locret_40F6
		addq.w	#1,(RAM_Level_Water_SetPos).w

locret_40F6:
		rts
; ===============================================================================

S1DynWater_LZ1:
		move.w	(RAM_LevelSys_Buff).w,d0
		move.b	(RAM_Level_WaterRoutineCntr).w,d2
		bne.s	loc_4164
		move.w	#$B8,d1
		cmpi.w	#$600,d0
		bcs.s	loc_4148
		move.w	#$108,d1
		cmpi.w	#$200,(RAM_ObjRAM_Sonic+$C).w
		bcs.s	loc_414E
		cmpi.w	#$C00,d0
		bcs.s	loc_4148
		move.w	#$318,d1
		cmpi.w	#$1080,d0
		bcs.s	loc_4148
		move.b	#$80,(RAM_Level_Switches+$5).w
		move.w	#$5C8,d1
		cmpi.w	#$1380,d0
		bcs.s	loc_4148
		move.w	#$3A8,d1
		cmp.w	(RAM_Level_Water_MainPos).w,d1
		bne.s	loc_4148
		move.b	#1,(RAM_Level_WaterRoutineCntr).w

loc_4148:
		move.w	d1,(RAM_Level_Water_SetPos).w
		rts
; ===============================================================================

loc_414E:
		cmpi.w	#$C80,d0
		bcs.s	loc_4148
		move.w	#$E8,d1
		cmpi.w	#$1500,d0
		bcs.s	loc_4148
		move.w	#$108,d1
		bra.s	loc_4148
; ===============================================================================

loc_4164:
		subq.b	#1,d2
		bne.s	locret_4188
		cmpi.w	#$2E0,(RAM_ObjRAM_Sonic+$C).w
		bcc.s	locret_4188
		move.w	#$3A8,d1
		cmpi.w	#$1300,d0
		bcs.s	loc_4184
		move.w	#$108,d1
		move.b	#2,(RAM_Level_WaterRoutineCntr).w

loc_4184:
		move.w	d1,(RAM_Level_Water_SetPos).w

locret_4188:
		rts
; ===============================================================================

DynWater_HPZ2:
		move.w	(RAM_LevelSys_Buff).w,d0 ; leftover from Sonic 1's LZ2
		move.w	#$328,d1
		cmpi.w	#$500,d0
		bcs.s	loc_41A6
		move.w	#$3C8,d1
		cmpi.w	#$B00,d0
		bcs.s	loc_41A6
		move.w	#$428,d1

loc_41A6:
		move.w	d1,(RAM_Level_Water_SetPos).w
		rts
; ===============================================================================

DynWater_HPZ3:
		move.w	(RAM_LevelSys_Buff).w,d0		; in fact, this is a leftover from Sonic 1's LZ3
		move.b	(RAM_Level_WaterRoutineCntr).w,d2
		bne.s	loc_41F2
		move.w	#$900,d1
		cmpi.w	#$600,d0
		bcs.s	loc_41E8
		cmpi.w	#$3C0,(RAM_ObjRAM_Sonic+$C).w
		bcs.s	loc_41E8
		cmpi.w	#$600,(RAM_ObjRAM_Sonic+$C).w
		bcc.s	loc_41E8
		move.w	#$4C8,d1
		move.b	#$4B,(RAM_LevelLayout+$206).w			;Layout edit (Sonic 1)
		move.b	#1,(RAM_Level_WaterRoutineCntr).w
		move.w	#$B7,d0
		bsr.w	PlaySound_Special

loc_41E8:
		move.w	d1,(RAM_Level_Water_SetPos).w
		move.w	d1,(RAM_Level_Water_MainPos).w
		rts
; ===============================================================================

loc_41F2:
		subq.b	#1,d2
		bne.s	loc_423C
		move.w	#$4C8,d1
		cmpi.w	#$770,d0
		bcs.s	loc_4236
		move.w	#$308,d1
		cmpi.w	#$1400,d0
		bcs.s	loc_4236
		cmpi.w	#$508,(RAM_Level_Water_SetPos).w
		beq.s	loc_4222
		cmpi.w	#$600,(RAM_ObjRAM_Sonic+$C).w
		bcc.s	loc_4222
		cmpi.w	#$280,(RAM_ObjRAM_Sonic+$C).w
		bcc.s	loc_4236

loc_4222:
		move.w	#$508,d1
		move.w	d1,(RAM_Level_Water_MainPos).w
		cmpi.w	#$1770,d0
		bcs.s	loc_4236
		move.b	#2,(RAM_Level_WaterRoutineCntr).w

loc_4236:
		move.w	d1,(RAM_Level_Water_SetPos).w
		rts
; ===============================================================================

loc_423C:
		subq.b	#1,d2
		bne.s	loc_4266
		move.w	#$508,d1
		cmpi.w	#$1860,d0
		bcs.s	loc_4260
		move.w	#$188,d1
		cmpi.w	#$1AF0,d0
		bcc.s	loc_425A
		cmp.w	(RAM_Level_Water_MainPos).w,d1
		bne.s	loc_4260

loc_425A:
		move.b	#3,(RAM_Level_WaterRoutineCntr).w

loc_4260:
		move.w	d1,(RAM_Level_Water_SetPos).w
		rts
; ===============================================================================

loc_4266:
		subq.b	#1,d2
		bne.s	loc_42A2
		move.w	#$188,d1
		cmpi.w	#$1AF0,d0
		bcs.s	loc_4298
		move.w	#$900,d1
		cmpi.w	#$1BC0,d0
		bcs.s	loc_4298
		move.b	#4,(RAM_Level_WaterRoutineCntr).w
		move.w	#$608,(RAM_Level_Water_SetPos).w
		move.w	#$7C0,(RAM_Level_Water_MainPos).w
		move.b	#1,(RAM_Level_Switches+$8).w
		rts
; ===============================================================================

loc_4298:
		move.w	d1,(RAM_Level_Water_SetPos).w
		move.w	d1,(RAM_Level_Water_MainPos).w
		rts
; ===============================================================================

loc_42A2:
		cmpi.w	#$1E00,d0
		bcs.s	locret_42AE
		move.w	#$128,(RAM_Level_Water_SetPos).w

locret_42AE:
		rts
; ===============================================================================

DynWater_HPZ4:
		move.w	#$228,d1					; in fact, this	is a leftover from Sonic 1's SBZ3
		cmpi.w	#$F00,(RAM_LevelSys_Buff).w
		bcs.s	loc_42C0
		move.w	#$4C8,d1

loc_42C0:
		move.w	d1,(RAM_Level_Water_SetPos).w
		rts
; ===============================================================================

S1_LZWindTunnels:							; leftover from	Sonic 1's LZ
		tst.w	(RAM_Flag_Debug_Placement).w
		bne.w	locret_43A2
		lea	(S1LZWind_Data).l,a2
		moveq	#0,d0
		move.b	(RAM_Level_CurrentAct).w,d0
		lsl.w	#3,d0
		adda.w	d0,a2
		moveq	#0,d1
		tst.b	(RAM_Level_CurrentAct).w
		bne.s	loc_42EA
		moveq	#1,d1
		subq.w	#8,a2

loc_42EA:
		lea	(RAM_ObjectTable).w,a1

loc_42EE:
		move.w	8(a1),d0
		cmp.w	(a2),d0
		bcs.w	loc_438C
		cmp.w	4(a2),d0
		bcc.w	loc_438C
		move.w	$C(a1),d2
		cmp.w	2(a2),d2
		bcs.w	loc_438C
		cmp.w	6(a2),d2
		bcc.s	loc_438C
		move.b	(RAM_VIntFrameCnt+3).w,d0
		andi.b	#$3F,d0
		bne.s	loc_4326
		move.w	#$D0,d0
		jsr	(PlaySound_Special).l

loc_4326:
		tst.b	($FFFFF7C9).w
		bne.w	locret_43A2
		cmpi.b	#4,$24(a1)
		bcc.s	loc_439E
		move.b	#1,(RAM_Flag_Sonic_Slide).w
		subi.w	#$80,d0
		cmp.w	(a2),d0
		bcc.s	loc_4354
		moveq	#2,d0
		cmpi.b	#1,(RAM_Level_CurrentAct).w
		bne.s	loc_4350
		neg.w	d0

loc_4350:
		add.w	d0,$C(a1)

loc_4354:
		addi.w	#4,8(a1)
		move.w	#$400,$10(a1)
		move.w	#0,$12(a1)
		move.b	#$F,$1C(a1)
		bset	#1,$22(a1)
		btst	#0,(RAM_Control_1_Hold).w
		beq.s	loc_437E
		subq.w	#1,$C(a1)

loc_437E:
		btst	#1,(RAM_Control_1_Hold).w
		beq.s	locret_438A
		addq.w	#1,$C(a1)

locret_438A:
		rts
; ===============================================================================

loc_438C:
		addq.w	#8,a2
		dbf	d1,loc_42EE
		tst.b	(RAM_Flag_Sonic_Slide).w
		beq.s	locret_43A2
		move.b	#0,$1C(a1)

loc_439E:
		clr.b	(RAM_Flag_Sonic_Slide).w

locret_43A2:
		rts
; ===============================================================================
		dc.w	$A80, $300, $C10, $380 ;Unused

S1LZWind_Data:	dc.w	$F80, $100,$1410, $180	;LZ1
		dc.w	$460, $400, $710, $480	;LZ2
                dc.w	$A20, $600,$1610, $6E0	;LZ3
                dc.w	$C80, $600,$13D0, $680	;LZ4
; ===============================================================================

S1_LZWaterSlides:
		lea	(RAM_ObjectTable).w,a1
		btst	#1,$22(a1)
		bne.s	loc_4400
		move.w	$C(a1),d0
		andi.w	#$700,d0
		move.b	8(a1),d1

loc_43E4:
		andi.w	#$7F,d1
		add.w	d1,d0
		lea	(RAM_LevelLayout).w,a2
		move.b	(a2,d0.w),d0
		lea	byte_4465(pc),a2
		moveq	#6,d1

loc_43F8:
		cmp.b	-(a2),d0
		dbeq	d1,loc_43F8
		beq.s	loc_4412

loc_4400:
		tst.b	(RAM_Sonic_IgnoreCtrl_2).w
		beq.s	locret_4410
		move.w	#5,$2E(a1)
		clr.b	(RAM_Sonic_IgnoreCtrl_2).w

locret_4410:
		rts
; ===============================================================================

loc_4412:
		cmpi.w	#3,d1
		bcc.s	loc_441A
		nop

loc_441A:
		bclr	#0,$22(a1)
		move.b	byte_4456(pc,d1.w),d0
		move.b	d0,$14(a1)
		bpl.s	loc_4430
		bset	#0,$22(a1)

loc_4430:
		clr.b	$15(a1)
		move.b	#$1B,$1C(a1)
		move.b	#1,(RAM_Sonic_IgnoreCtrl_2).w
		move.b	(RAM_VIntFrameCnt+3).w,d0
		andi.b	#$1F,d0
		bne.s	locret_4454
		move.w	#$D0,d0
		jsr	(PlaySound_Special).l

locret_4454:
		rts
; ===============================================================================
byte_4456:	dc.b  $A,$F5, $A,$F6,$F5,$F4, $B,  0,  2,  7,  3,$4C,$4B,  8,  4
byte_4465:	dc.b 0

; =============== S U B R O U T I N E ==========================================


MoveSonicInDemo:
		tst.w	(RAM_Flag_DemoMode).w
		bne.s	MoveDemo_On
		rts
; ===============================================================================

MoveSonic_DemoRecord:					; unused subroutine for	recording demos
		lea	($FE8000).l,a1

loc_4474:
		move.w	(RAM_Demo_ButtonIndex).w,d0
		adda.w	d0,a1
		move.b	(RAM_Control_1_Hold).w,d0
		cmp.b	(a1),d0
		bne.s	loc_4490
		addq.b	#1,1(a1)
		cmpi.b	#$FF,1(a1)
		beq.s	loc_4490
		bra.s	loc_44A4
; ===============================================================================

loc_4490:
		move.b	d0,2(a1)
		move.b	#0,3(a1)
		addq.w	#2,(RAM_Demo_ButtonIndex).w
		andi.w	#$3FF,(RAM_Demo_ButtonIndex).w

loc_44A4:
		cmpi.b	#3,(RAM_Level_CurrentZone).w
		bne.s	locret_44E2
		lea	($FEC000).l,a1
		move.w	(RAM_Demo_ButtonIndex_2P).w,d0
		adda.w	d0,a1
		move.b	(RAM_Control_2_Hold).w,d0
		cmp.b	(a1),d0
		bne.s	loc_44CE
		addq.b	#1,1(a1)
		cmpi.b	#$FF,1(a1)
		beq.s	loc_44CE
		bra.s	locret_44E2
; ===============================================================================

loc_44CE:
		move.b	d0,2(a1)
		move.b	#0,3(a1)
		addq.w	#2,(RAM_Demo_ButtonIndex_2P).w
		andi.w	#$3FF,(RAM_Demo_ButtonIndex_2P).w

locret_44E2:
		rts
; ===============================================================================

MoveDemo_On:
		tst.b	(RAM_Control_1_Hold).w
		bpl.s	loc_44F6
		tst.w	(RAM_Flag_DemoMode).w
		bmi.s	loc_44F6
		move.b	#ModeId_TitleScr,(RAM_GameMode).w

loc_44F6:
		lea	(Demo_Index).l,a1
		moveq	#0,d0
		move.b	(RAM_Level_CurrentZone).w,d0
		cmpi.b	#ModeId_SS,(RAM_GameMode).w
		bne.s	loc_450C
		moveq	#6,d0

loc_450C:
		lsl.w	#2,d0
		movea.l	(a1,d0.w),a1
		move.w	(RAM_Demo_ButtonIndex).w,d0
		adda.w	d0,a1
		move.b	(a1),d0
		lea	(RAM_Control_1_Hold).w,a0
		move.b	d0,d1
		moveq	#0,d2
		eor.b	d2,d0
		move.b	d1,(a0)+
		and.b	d1,d0
		move.b	d0,(a0)+
		subq.b	#1,(RAM_Demo_FramesLeft).w
		bcc.s	loc_453A
		move.b	3(a1),(RAM_Demo_FramesLeft).w
		addq.w	#2,(RAM_Demo_ButtonIndex).w

loc_453A:
		cmpi.b	#3,(RAM_Level_CurrentZone).w
		bne.s	loc_4572
		lea	(Demo_2P).l,a1
		move.w	(RAM_Demo_ButtonIndex_2P).w,d0
		adda.w	d0,a1
		move.b	(a1),d0
		lea	(RAM_Control_2_Hold).w,a0
		move.b	d0,d1
		moveq	#0,d2
		eor.b	d2,d0
		move.b	d1,(a0)+
		and.b	d1,d0
		move.b	d0,(a0)+
		subq.b	#1,(RAM_Demo_ButtonIndex_2P+$2).w
		bcc.s	locret_4570
		move.b	3(a1),(RAM_Demo_ButtonIndex_2P+$2).w
		addq.w	#2,(RAM_Demo_ButtonIndex_2P).w

locret_4570:
		rts
; ===============================================================================

loc_4572:
		move.w	#0,(RAM_Control_2_Hold).w
		rts

; ===============================================================================
Demo_Index:	dc.l Demo_S1GHZ
		dc.l Demo_S1GHZ		; leftover demo	from Sonic 1 GHZ
		dc.l Demo_CPZ
		dc.l Demo_EHZ
		dc.l Demo_HPZ
		dc.l Demo_HTZ
		dc.l Demo_S1SS		; leftover demo	from Sonic 1 Special Stage
		dc.l Demo_S1SS		; leftover demo	from Sonic 1 Special Stage
		dc.l $FE8000
		dc.l $FE8000
		dc.l $FE8000
		dc.l $FE8000
		dc.l $FE8000
		dc.l $FE8000
		dc.l $FE8000
		dc.l $FE8000
		dc.l $FE8000

Demo_S1EndIndex:
		dc.l $008B0837
		dc.l $0042085C
		dc.l $006A085F
		dc.l $002F082C
		dc.l $00210803
		dc.l $28300808
		dc.l $002E0815
		dc.l $000F0846
		dc.l $001A08FF
		dc.l $08CA0000
		dc.l 0
		dc.l 0

; =============== S U B R O U T I N E ==========================================


ColIndexLoad:
		moveq	#0,d0
		move.b	(RAM_Level_CurrentZone).w,d0
		lsl.w	#2,d0
		move.l	#RAM_Level_ColP,(RAM_Level_ColPointer).w

		movea.l	ColP_Index(pc,d0.w),a1
		lea	(RAM_Level_ColP).w,a2
		bsr.s	Col_Load

		movea.l	ColS_Index(pc,d0.w),a1
		lea	(RAM_Level_ColS).w,a2

Col_Load:
		move.w	#$2FF,d1
		moveq	#0,d2

loc_4616:
		move.b	(a1)+,d2
		move.w	d2,(a2)+
		dbf	d1,loc_4616
		rts

; ===============================================================================
ColP_Index:	dc.l ColP_GHZ
		dc.l ColP_CPZ
		dc.l ColP_CPZ
		dc.l ColP_EHZ
		dc.l ColP_HPZ
		dc.l ColP_EHZ

ColS_Index:	dc.l ColS_GHZ
		dc.l ColS_CPZ
		dc.l ColS_CPZ
		dc.l ColS_EHZ
		dc.l ColS_HPZ
		dc.l ColS_EHZ

; =============== S U B R O U T I N E ==========================================

OscillateNumInit:
		lea	(RAM_RandomTimers_Buff).w,a1
		lea	(Osc_Data).l,a2
		moveq	#$20,d1

loc_465C:
		move.w	(a2)+,(a1)+
		dbf	d1,loc_465C
		rts

; ===============================================================================
Osc_Data:	dc.w   $7C,  $80	; 0
		dc.w	 0,  $80	; 2
		dc.w	 0,  $80	; 4
		dc.w	 0,  $80	; 6
		dc.w	 0,  $80	; 8
		dc.w	 0,  $80	; 10
		dc.w	 0,  $80	; 12
		dc.w	 0,  $80	; 14
		dc.w	 0,  $80	; 16
		dc.w	 0,$50F0	; 18
		dc.w  $11E,$2080	; 20
		dc.w   $B4,$3080	; 22
		dc.w  $10E,$5080	; 24
		dc.w  $1C2,$7080	; 26
		dc.w  $276,  $80	; 28
		dc.w	 0,  $80	; 30
		dc.w	0

; =============== S U B R O U T I N E ==========================================


OscillateNumDo:
		cmpi.b	#6,(RAM_ObjRAM_Sonic+$24).w
		bcc.s	locret_46FC
		lea	(RAM_RandomTimers_Buff).w,a1
		lea	(OscData2).l,a2
		move.w	(a1)+,d3
		moveq	#$F,d1

loc_46BC:
		move.w	(a2)+,d2
		move.w	(a2)+,d4
		btst	d1,d3
		bne.s	loc_46DC
		move.w	2(a1),d0
		add.w	d2,d0
		move.w	d0,2(a1)
		add.w	d0,0(a1)
		cmp.b	0(a1),d4
		bhi.s	loc_46F2
		bset	d1,d3
		bra.s	loc_46F2
; ===============================================================================

loc_46DC:
		move.w	2(a1),d0
		sub.w	d2,d0
		move.w	d0,2(a1)
		add.w	d0,0(a1)
		cmp.b	0(a1),d4
		bls.s	loc_46F2
		bclr	d1,d3

loc_46F2:
		addq.w	#4,a1
		dbf	d1,loc_46BC
		move.w	d3,(RAM_RandomTimers_Buff).w

locret_46FC:
		rts

; ===============================================================================
OscData2:	dc.w	 2,  $10	; 0
		dc.w	 2,  $18	; 2
		dc.w	 2,  $20	; 4
		dc.w	 2,  $30	; 6
		dc.w	 4,  $20	; 8
		dc.w	 8,    8	; 10
		dc.w	 8,  $40	; 12
		dc.w	 4,  $40	; 14
		dc.w	 2,  $50	; 16
		dc.w	 2,  $50	; 18
		dc.w	 2,  $20	; 20
		dc.w	 3,  $30	; 22
		dc.w	 5,  $50	; 24
		dc.w	 7,  $70	; 26
		dc.w	 2,  $10	; 28
		dc.w	 2,  $10	; 30

; =============== S U B R O U T I N E ==========================================

ChangeRingFrame:
		subq.b	#1,(RAM_ObjSpecial_RingFrame_1).w
		bpl.s	loc_4754
		move.b	#$B,(RAM_ObjSpecial_RingFrame_1).w
		subq.b	#1,(RAM_ObjSpecial_RingFrame_2).w
		andi.b	#7,(RAM_ObjSpecial_RingFrame_2).w

loc_4754:
		subq.b	#1,(RAM_ObjSpecial_RingFrame_3).w
		bpl.s	loc_476A
		move.b	#7,(RAM_ObjSpecial_RingFrame_3).w
		addq.b	#1,(RAM_ObjSpecial_RingFrame_4).w
		andi.b	#3,(RAM_ObjSpecial_RingFrame_4).w

loc_476A:
		subq.b	#1,(RAM_ObjSpecial_RingFrame_5).w
		bpl.s	loc_4788
		move.b	#7,(RAM_ObjSpecial_RingFrame_5).w
		addq.b	#1,(RAM_ObjSpecial_RingFrame_6).w
		cmpi.b	#6,(RAM_ObjSpecial_RingFrame_6).w
		bcs.s	loc_4788
		move.b	#0,(RAM_ObjSpecial_RingFrame_6).w

loc_4788:
		tst.b	(RAM_ObjSpecial_RingFrame_7).w
		beq.s	locret_47AA
		moveq	#0,d0
		move.b	(RAM_ObjSpecial_RingFrame_7).w,d0
		add.w	(RAM_ObjSpecial_RingFrame_9).w,d0
		move.w	d0,(RAM_ObjSpecial_RingFrame_9).w
		rol.w	#7,d0
		andi.w	#3,d0
		move.b	d0,(RAM_ObjSpecial_RingFrame_8).w
		subq.b	#1,(RAM_ObjSpecial_RingFrame_7).w

locret_47AA:
		rts


; =============== S U B R O U T I N E ==========================================


SignpostArtLoad:
		tst.w	(RAM_Flag_Debug_Placement).w
		bne.w	locret_47E2
		cmpi.b	#1,(RAM_Level_CurrentAct).w
		beq.s	locret_47E2
		move.w	(RAM_LevelSys_Buff).w,d0
		move.w	(RAM_LevelSys_XPos_SetEnd).w,d1
		subi.w	#$100,d1
		cmp.w	d1,d0
		blt.s	locret_47E2
		tst.b	(RAM_Flag_HudUpd_Timer).w
		beq.s	locret_47E2
		cmp.w	(RAM_LevelSys_XPos_SetStart).w,d1
		beq.s	locret_47E2
		move.w	d1,(RAM_LevelSys_XPos_SetStart).w
		moveq	#$12,d0
		bra.w	LoadPLC2
; ===============================================================================

locret_47E2:
		rts

; ===============================================================================
Demo_EHZ:	dc.b   0,$44,  8,  0,$28,  5,  8,$59,$28,  4,  8,$35,$28,  6,  8,$42; 0
					; DATA XREF: ROM:00004586o
		dc.b $28,  4,  8,$19,  0, $F,  8, $A,$28,  9,  8,$4A,$28,  9,  8,$10; 16
		dc.b   0,  5,  4,$1B,  2,  0,  8,$4B,$28,$2D,  8,$55,$28,  9,  8,$26; 32
		dc.b $28,$1C,  8,$19,$28,  8,  8,$FF,  8,$96,$28,$13,  8,$1D,$28,$19; 48
		dc.b   8,$2A,$28,  7,  9,  0,  1,  0,  5,$20,  4,  2,  5,  1,  0,  0; 64
		dc.b   8,$3A,  0,$25,  4, $A,$24,  9,  4,$1C,  0,  3,  8,$3A,$28,  6; 80
		dc.b   8, $C,  0,$16,  8,  0,$28, $F,  8,$33,$28,  7,  8,  4,  0,$46; 96
		dc.b   8,$6A,  0,$29,$80,  0,$C0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 112
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 128
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 144
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 160
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 176
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 192
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 208
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 224
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 240
Demo_2P:	dc.b   0,$46,  8,$1E,$28, $A,  8,$5E,$28,$30,  8,$66,  0, $F,  8, $F; 0
					; DATA XREF: ROM:00003E82o
					; MoveSonicInDemo+DCo
		dc.b $28,$2E,  8,  0,  0,$1F,  8,$12,  0,$13,  8, $A,  0,$16,  4, $D; 16
		dc.b   0,  8,  4,$10,  0,$30,  8,$6B,$28,$14,  8,$80, $A,  2,  2,$23; 32
		dc.b   0,  7,  8,$13,$28,$17,  8,  0,  0,  3,  4,  3,  5,  0,  1,  0; 48
		dc.b   9,  1,  8,$3C,$28,  7,  0,$18,  8,$4D,$28,$12,  8,  1,  0,  4; 64
		dc.b   8, $B,  0,  7,  8,$1B,  0,  9,$20,  5,$28,$13,  8,  4,  0,$21; 80
		dc.b   8,$11,  0,$20,  8,$51,  0, $B,  4,$57,  0, $D,  2,$27, $A,  0; 96
		dc.b   0,  2,  9,  1,  8,$2A,$28,$15,  8,  3,$28,$19,  8, $A,  0, $A; 112
		dc.b   8,  2,$28,$1B,  8,$33,  0,$27,  8,$3A,  9,$12,  1,  7,  0,$13; 128
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 144
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 160
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 176
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 192
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 208
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 224
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 240
Demo_HTZ:	dc.b   0,  5,  1,$1D,  9,  3,$29,  5,  9,$10,  1,  0,  0,$13,  4,  0; 0
					; DATA XREF: ROM:0000458Eo
		dc.b   5, $A,$25,  7,  5,$10,  4,  1,  0, $C,  8,  4,  9, $C,$29, $A; 16
		dc.b   9,$10,  8,  3,  0,$1C,$20,  7,  0, $B,  4,  6,  0,$25,$20,  6; 32
		dc.b   0,$22,  8,  5,  0,$25,  4, $E,  0,$33,  8,  7,  0,$39,  8, $A; 48
		dc.b $28,  8,  8,$16,  0,$24,  8,$74,$28,  2,$29,  7,  9,  3,  0, $F; 64
		dc.b   8, $D,  0,  5,  4, $C,  0,  1,$20,  2,$28,  0,$2A,  8,$28,  2; 80
		dc.b   8,$1E,  0,  4,  4,$13,  0,$12,  8,$18,$28, $B,  8,$11,  0,$2C; 96
		dc.b   8, $C,  0, $D,$20,  4,$28,  3,  8,  5,  0,$22,  4,$12,  0,  4; 112
		dc.b   8,$1A,  0, $D,  4,  6,  0,$37,  8, $C,  0,$19,  8, $D,  0, $C; 128
		dc.b   4,  9,  0,  3,  8,$20,  0,$1A,  4,  6,  0,$22,  8,  9,  0,  9; 144
		dc.b   8,$16,  0,$2F,  8, $E,$28,  4,$20,  2,  0,  8,  4,$19,  0,  5; 160
		dc.b   8,  6,$28,  8,  8,  8,  0,$24,  8,$72, $A,  9,  2, $E, $A,$6B; 176
		dc.b $8A,  0,$40,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 192
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 208
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 224
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 240
Demo_HPZ:	dc.b   0,$40,  8,$33,$28,  6,  8,$39,$28,  5,  8, $D,  0,$25,  8,$10; 0
					; DATA XREF: ROM:0000458Ao
		dc.b $28,$2A,  8,$1C,  2,  0,$26,  3,$22,  0,$2A,  0,$28,  6,  8,$22; 16
		dc.b   2,  0,  6, $F,  4,  8,  6,  0,  2, $E,  6,$2F,  2,$79,  6,  1; 32
		dc.b   4,$43,$24, $F,  4,$17,  0,  9,  8,$1C,$28,  3,  8,$45,  0,  5; 48
		dc.b   8,$1A,$28,$33,  8,$72,  0, $F,  4,$15,$24,$10,  4, $B,  0,$24; 64
		dc.b   4,  1,$24,  8,  4,  7,  0,  6,  4,  4,  0,$1E,$24, $E,  4,$15; 80
		dc.b   0,$1E,$20,  3,$24, $F,  4,  0,  0,  7,  8,$12,  4,  9,$24, $F; 96
		dc.b   4,  6,  0, $A,  4,$62,$24,$12,$20,  4,  0,$21,$28, $E,  8,$16; 112
		dc.b   0,$19,  8,$29,  0,$63,  4,$15,$24,  9,  4,$39,  0,$31,  8,$25; 128
		dc.b $28,  2,  8,$12,  0,$93,$80,  0,$C0,  0,  0,  0,  0,  0,  0,  0; 144
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 160
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 176
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 192
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 208
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 224
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 240
Demo_CPZ:	dc.b   0,$1B,  1,$30,  0,$19,  8,$29,$28,$13,  8,  3,  0,$1D,$20,  3; 0
					; DATA XREF: ROM:00004582o
		dc.b $28,$1E,  8,  2,  0,  9,  4,  5,  0,$2E,  8,$1E,$28,  5,$20,  3; 16
		dc.b   0, $B,  4,  1,  5,  7,  4,  0,  0,$2F,$28,  3,$2A,  4, $A,  0; 32
		dc.b   8,  6,  0,$24,  8,  2,$28,  6,  8,  1,  0,$26,  8,$FF,  8,$14; 48
		dc.b $28, $A,  8,  3,  0,$60,  8, $E,$28,  7,  8, $C,  0,  8,  4, $B; 64
		dc.b   0,$23,  8,  5,  0,$93,  8,$19,$28,$11,  8,$78,$28, $F,  8,$FF; 80
		dc.b   8,$83,$28, $D,  8,$82,  0,$1F,$80,  0,$40,  0,  0,  0,  0,  0; 96
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 112
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 128
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 144
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 160
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 176
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 192
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 208
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 224
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 240
Demo_S1GHZ:	dc.b   0,$4A,  8,$61,$28, $B,  8,$47,$28,  7,  8,$3B,$28,  8,  8,$D1; 0
					; DATA XREF: ROM:Demo_Indexo
					; ROM:0000457Eo
		dc.b $28,$10,  8, $A,  0, $E,$20,$12,$28,  4,  8,$1F,  0, $B,  6,  5; 16 ; leftover demo from Sonic 1 GHZ
		dc.b   4,  5,  0,  4,$20, $B,$28, $E,  8,$20,  0,  5,$20,  2,$28,$12; 32
		dc.b   8, $F,  0, $F,  8, $B,  0,  0,$20, $E,$28,  4,  8, $B,  0,$1A; 48
		dc.b   8, $C,  0,  6,$20,$12,$28,  7,  8,$77,$28,  0,$20, $C,$24,  4; 64
		dc.b $20,  7,$28,  6,  8,  4,  0, $F,  8,$39,  0,$11,  8, $D,$28, $A; 80
		dc.b   8,$50,$28, $F,  8,  5,  0,$14,  8,$FF,  8,$56,  0,$FF,  0,$3F; 96
		dc.b   8,  0,$28, $E,  8,$17,  0,$17,  8,  5,  0,  0,  0,  0,  0,  0; 112
		dc.b   0,  9,  8,$78,  0,  6,  8,  6,  0,  3,$20,  5,$28,$11,  8, $D; 128
		dc.b   0,$2B,  8,  2,$29,  7,  9,  2,  0,  7,  5, $F,  0,  8,  8, $D; 144
		dc.b $28,  7,  8, $B,  0,$28,  8,  0,  9,  2,$29,  2,$28,  4,  8,$12; 160
		dc.b   0,  9,  8,  0,$29,  2,$28,  4,  8,  9,  0, $F,  8, $C,  0, $E; 176
		dc.b   9,  0,$29,  8,  9,  2,  8,$18,  0,  9,$28,  0,$29, $A,  9,$12; 192
		dc.b   8,  0,  0,$18,$29,$10,  9,$10,  8,  3,  0,$2F,  5,  6,  0,  9; 208
		dc.b   8,  0,  9,  1,$29,$12,  9,  0,  8,  5,  0,$24,  8,  0,  9,  0; 224
		dc.b $29,  9,$28,  6,  8, $A,  0,$2A,  8,$1B,  0,$17,  4,  5,  0, $C; 240
		dc.b   8,$20,  0,  4,$20,  3,  0, $E,  9,  4,  1,  0,  0,$1E,  8,  5; 256
		dc.b   0,  1,$20,  6,$29,  1,  5,  7,  0,$13,  8,  5,  0,$15,$20,  1; 272
		dc.b $28,  2,$29,  4,  9,  1,  8,  0,  0,  7,  8, $B,  0,$19,  8, $B; 288
		dc.b $28,  6,  8,  5,  0,$12,  8,$11,  0, $C,$20,  2,$28,  4,  8,  4; 304
		dc.b   0,$15,  8, $C,  0,$14,$20,  4,$28,  0,  8,  2,  0,$18,  8,  3; 320
		dc.b   0,$2C,$20,  2,$28,  7,  8,  4,  0,$24,  6,$48,  4,$47,  0, $A; 336
		dc.b   4,  7,  0,$14,  4,$44,  5,  0,  4,  0,  0,$15,  8,$15, $A,  1; 352
		dc.b   0,  8,  4,  2,  5,$14,  0,  1,  5,  1,$25, $D,  5,$1B,  0,  7; 368
		dc.b   8,$23,  9,  0,  0,  7,  5,$22,$25, $B,  5,$52,  0,  6,  8,$26; 384
		dc.b   9,  1,  1,  0,  0,  0,  1,  0,  5,$17,$25,  8,  5,$1A,  0, $C; 400
		dc.b   8,  6,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 416
		dc.b   0,$11,  8,$37,$28,  4,  8, $A,  0,$12,  8, $B,  0,$1F,  8,$1B; 432
		dc.b   0,  9,  8,$20,  0,$14,  4,$16,$24,  0,$20, $F,  0,$13,  4,$17; 448
		dc.b   6,  4,  2,  0,  0,$24,  8, $D,  0,$46,  8,$77,  0,$60,  8,$17; 464
		dc.b   0,$16,  4,  3,  0,$22,  8,$19,$28,  2,$20,  1,  0,$26,$20,  9; 480
		dc.b   0,$3A,$20,$23,  0,  3,  8,  1,  0,$29,  4,$13,  0,$19,  4,$1B; 496
		dc.b   0,$91,  8,$21,  0,$19,  4,  4,  0,$67,  4,$23,  0, $A,  8,  5; 512
		dc.b   0,$87,  8,$21,  0,$2C,  8,$27,  0, $F,  8,$35,$28,  8,  8,$45; 528
		dc.b $28,  9,  8,$31,  0,$99,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 544
Demo_S1SS:	dc.b   0,$26,  4,  5,  0,$2A,  8,$1B,  0,  6,  4,  9,  0,  6,$20,  1; 0
					; DATA XREF: ROM:00004592o
					; ROM:00004596o
		dc.b $28,  1,$29,  2,  9,  0,  8,  8,  0,  6,  8,  7,  0,$49,  8, $B; 16 ; leftover demo from Sonic 1 Special Stage
		dc.b   0,  2,$20,  3,  0, $D,  8,$1D,  0,$13,  8,  6,  0,$21,  8,$21; 32
		dc.b   0,  6,  8,$36,  0,$1E,  8,$1A,  0,  6,$20,  0,$28,  4,  8,$19; 48
		dc.b   0,  4,  4,$11,  0,$1F,  4, $D,  0, $C,  4,$1E,  5,  1,  4,  0; 64
		dc.b   0,  9,  8, $C,  0,  6,  4,  5,  5,  1,  4,$87,$24,  7,  4,  4; 80
		dc.b   0,  4,  8, $D,  9,$14,  8,  4,  0,  3,  4,$17,$24,$13,  4, $A; 96
		dc.b   0,  4,  9,  9,  8,  2,  0,  6,  4,$18,$24, $B,$20,  4,  0,  2; 112
		dc.b   4,$2E,  5,  1,  4,  0,  0,$13,$20,$14,  0,  4,  8,$19,  0,$10; 128
		dc.b $20,$1D,$24,  7,  4, $E,  0, $B,$20,$1B,$24,  5,  4,$17,$24,  0; 144
		dc.b $20,$18,$24,  5,  4, $B,  0,  8,$20,$1F,$24,  1,  4,  8,  0, $B; 160
		dc.b $20,$12,$28,  7,$29, $C,$20,  0,  4,$18,  0,$1A,  8,  0,  9,  7; 176
		dc.b   8,  9,  9,$31,  8,  0,  0,  7,$20,  8,$24,$15,  4,  8,  0,$27; 192
		dc.b $20,  9,$24,$12,  4, $E,$24, $E,  4, $A,  0,  9,  8,$16,$28,  0; 208
		dc.b $20, $F,$28,  4,$29,$1B,  9,  5,$29, $C,  9,  0,  8,  7,  0,$A0; 224
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 240
; ===============================================================================

j_DynamicArtCues:
		jmp	DynamicArtCues
; ===============================================================================
		align 4

GameMode10:
		move.w	#$CA,d0
		bsr.w	PlaySound_Special
		bsr.w	Pal_MakeFlash
		move	#$2700,sr
		lea	($C00004).l,a6
		move.w	#$8B03,(a6)
		move.w	#$8004,(a6)
		move.w	#$8AAF,(RAM_VDPCmdForHint).w
		move.w	#$9011,(a6)
		move.w	(RAM_VDP_Command_1).w,d0
		andi.b	#$BF,d0
		move.w	d0,($C00004).l
		bsr.w	ClearScreen
		move	#$2300,sr
		lea	($C00004).l,a5
		move.w	#$8F01,(a5)
		move.l	#$946F93FF,(a5)
		move.w	#$9780,(a5)
		move.l	#$50000081,(a5)
		move.w	#0,($C00000).l

loc_507C:
		move.w	(a5),d1
		btst	#1,d1
		bne.s	loc_507C
		move.w	#$8F02,(a5)
		bsr.w	S1_SSBGLoad
		moveq	#$14,d0
		bsr.w	RunPLC_ROM
		lea	(RAM_Level_ColP).w,a1
		moveq	#0,d0
		move.w	#$7FF,d1

loc_509C:
		move.l	d0,(a1)+
		dbf	d1,loc_509C
		lea	(RAM_S1_Level_PlaneA_XPos).w,a1
		moveq	#0,d0
		move.w	#$3F,d1

loc_50AC:
		move.l	d0,(a1)+
		dbf	d1,loc_50AC
		lea	(RAM_WaterEffects).w,a1
		moveq	#0,d0
		move.w	#$27,d1

loc_50BC:
		move.l	d0,(a1)+
		dbf	d1,loc_50BC
		lea	(RAM_DecompBuffer).w,a1
		moveq	#0,d0
		move.w	#$7F,d1

loc_50CC:
		move.l	d0,(a1)+
		dbf	d1,loc_50CC
		clr.b	(RAM_FillWaterPalScr).w
		clr.w	(RAM_Flag_ResetLevel).w
		moveq	#$A,d0
		bsr.w	PalLoad1
		jsr	S1SS_Load
		move.l	#0,(RAM_LevelSys_Buff).w
		move.l	#0,(RAM_LevelSys_Buff+$4).w
		move.b	#9,(RAM_ObjectTable).w
		bsr.w	PalCycle_S1SS
		clr.w	(RAM_ObjPos_2pData).w
		move.w	#$40,($FFFFF782).w
		move.w	#$89,d0
		bsr.w	PlaySound
		move.w	#0,(RAM_Demo_ButtonIndex).w
		lea	(Demo_Index).l,a1
		moveq	#6,d0
		lsl.w	#2,d0
		movea.l	(a1,d0.w),a1
		move.b	1(a1),(RAM_Demo_FramesLeft).w
		subq.b	#1,(RAM_Demo_FramesLeft).w
		clr.w	(RAM_Sonic_CurrentRings).w
		clr.b	(RAM_Sonic_1upScore).w
		move.w	#0,(RAM_Flag_Debug_Placement).w
		move.w	#$708,(RAM_DemoTimeLeft).w
		tst.b	(RAM_Flag_Unk_1).w
		beq.s	loc_5158
		btst	#6,(RAM_Control_1_Hold).w
		beq.s	loc_5158
		move.b	#1,(RAM_Flag_DebugMode).w

loc_5158:
		move.w	(RAM_VDP_Command_1).w,d0
		ori.b	#$40,d0
		move.w	d0,($C00004).l
		bsr.w	Pal_MakeWhite

loc_516A:
		bsr.w	Pause
		move.b	#$A,(RAM_VIntCount).w
		bsr.w	DelayProgram

		bsr.w	MoveSonicInDemo
		move.w	(RAM_Control_1_Hold).w,(RAM_Control_1_Hold_Copy).w
		jsr	ObjectsLoad
		jsr	BuildSprites
		jsr	S1SS_ShowLayout	; leftover from	Sonic 1
		bsr.w	S1SS_BgAnimate
		tst.w	(RAM_Flag_DemoMode).w
		beq.s	loc_51A6
		tst.w	(RAM_DemoTimeLeft).w
		beq.w	loc_52D4

loc_51A6:
		cmpi.b	#ModeId_SS,(RAM_GameMode).w
		beq.w	loc_516A
		tst.w	(RAM_Flag_DemoMode).w
		bne.w	loc_52DC
		move.b	#ModeId_Level,(RAM_GameMode).w
		cmpi.w	#$503,(RAM_Level_CurrentZone).w
		bcs.s	loc_51CA
		clr.w	(RAM_Level_CurrentZone).w

loc_51CA:
		move.w	#$3C,(RAM_DemoTimeLeft).w
		move.w	#$3F,(RAM_Pal_FadeToCtrl_PalStart).w
		clr.w	(RAM_SS_Unknown_1).w

loc_51DA:
		move.b	#$16,(RAM_VIntCount).w
		bsr.w	DelayProgram

		bsr.w	MoveSonicInDemo
		move.w	(RAM_Control_1_Hold).w,(RAM_Control_1_Hold_Copy).w
		jsr	ObjectsLoad
		jsr	BuildSprites
		jsr	S1SS_ShowLayout			; leftover from	Sonic 1
		bsr.w	S1SS_BgAnimate
		subq.w	#1,(RAM_SS_Unknown_1).w
		bpl.s	loc_5214
		move.w	#2,(RAM_SS_Unknown_1).w
		bsr.w	Pal_ToWhite

loc_5214:
		tst.w	(RAM_DemoTimeLeft).w
		bne.s	loc_51DA
		move	#$2700,sr
		lea	($C00004).l,a6
		move.w	#$8230,(a6)
		move.w	#$8407,(a6)
		move.w	#$9001,(a6)
		bsr.w	ClearScreen
		move.l	#$70000002,($C00004).l
		lea	(Nem_S1TitleCard).l,a0
		bsr.w	NemDec
		jsr	HUD_Base
		move	#$2300,sr
		moveq	#$11,d0
		bsr.w	PalLoad2
		moveq	#0,d0
		bsr.w	LoadPLC2
		moveq	#$1B,d0
		bsr.w	LoadPLC
		move.b	#1,(RAM_Flag_HudUpd_Score).w
		move.b	#1,(RAM_Flag_HudUpd_Bonus).w
		move.w	(RAM_Sonic_CurrentRings).w,d0
		mulu.w	#$A,d0
		move.w	d0,($FFFFF7D4).w
		move.w	#$8E,d0
		jsr	(PlaySound_Special).l
		lea	(RAM_ObjectTable).w,a1
		moveq	#0,d0
		move.w	#$7FF,d1

loc_5290:
		move.l	d0,(a1)+
		dbf	d1,loc_5290
		move.b	#$7E,(RAM_ObjectTable+Obj_Slot_24).w

loc_529C:
		bsr.w	Pause
		move.b	#$C,(RAM_VIntCount).w
		bsr.w	DelayProgram

		jsr	ObjectsLoad
		jsr	BuildSprites
		bsr.w	RunPLC
		tst.w	(RAM_Flag_ResetLevel).w
		beq.s	loc_529C
		tst.l	(RAM_PLC_Buffer).w
		bne.s	loc_529C
		move.w	#$CA,d0
		bsr.w	PlaySound_Special
		bsr.w	Pal_MakeFlash
		rts
; ===============================================================================

loc_52D4:
		move.b	#ModeId_Sega,(RAM_GameMode).w
		rts
; ===============================================================================

loc_52DC:
		cmpi.b	#ModeId_Level,(RAM_GameMode).w
		beq.s	loc_52D4
		rts

; =============== S U B R O U T I N E ==========================================


S1_SSBGLoad:
		lea	(RAM_MetablockTable).l,a1
		move.w	#$4051,d0
		bsr.w	EniDec
		move.l	#$50000001,d3
		lea	(RAM_MetablockTable+$80).l,a2
		moveq	#6,d7

loc_5302:
		move.l	d3,d0
		moveq	#3,d6
		moveq	#0,d4
		cmpi.w	#3,d7
		bcc.s	loc_5310
		moveq	#1,d4

loc_5310:
		moveq	#7,d5

loc_5312:
		movea.l	a2,a1
		eori.b	#1,d4
		bne.s	loc_5326
		cmpi.w	#6,d7
		bne.s	loc_5336
		lea	(RAM_MetablockTable).l,a1

loc_5326:
		movem.l	d0-d4,-(sp)
		moveq	#7,d1
		moveq	#7,d2
		bsr.w	LoadMaps
		movem.l	(sp)+,d0-d4

loc_5336:
		addi.l	#$100000,d0
		dbf	d5,loc_5312
		addi.l	#$3800000,d0
		eori.b	#1,d4
		dbf	d6,loc_5310
		addi.l	#$10000000,d3
		bpl.s	loc_5360
		swap	d3
		addi.l	#$C000,d3
		swap	d3

loc_5360:
		adda.w	#$80,a2
		dbf	d7,loc_5302
		lea	(RAM_MetablockTable).l,a1
		move.w	#$4000,d0
		bsr.w	EniDec
		lea	(RAM_MetablockTable).l,a1
		move.l	#$40000003,d0
		moveq	#$3F,d1
		moveq	#$1F,d2
		bsr.w	LoadMaps
		lea	(RAM_MetablockTable).l,a1
		move.l	#$50000003,d0
		moveq	#$3F,d1
		moveq	#$3F,d2
		bsr.w	LoadMaps
		rts


; =============== S U B R O U T I N E ==========================================


PalCycle_S1SS:
		tst.w	(RAM_Flag_LevelPaused).w
		bne.s	locret_5424
		subq.w	#1,($FFFFF79C).w
		bpl.s	locret_5424
		lea	($C00004).l,a6
		move.w	($FFFFF79A).w,d0
		addq.w	#1,($FFFFF79A).w
		andi.w	#$1F,d0
		lsl.w	#2,d0
		lea	(word_547A).l,a0
		adda.w	d0,a0
		move.b	(a0)+,d0
		bpl.s	loc_53D0
		move.w	#$1FF,d0

loc_53D0:
		move.w	d0,($FFFFF79C).w
		moveq	#0,d0
		move.b	(a0)+,d0
		move.w	d0,($FFFFF7A0).w
		lea	(word_54FA).l,a1
		lea	(a1,d0.w),a1
		move.w	#$8200,d0
		move.b	(a1)+,d0
		move.w	d0,(a6)
		move.b	(a1),(RAM_VDP_VScroll).w
		move.w	#$8400,d0
		move.b	(a0)+,d0
		move.w	d0,(a6)
		move.l	#$40000010,($C00004).l
		move.l	(RAM_VDP_VScroll).w,($C00000).l
		moveq	#0,d0
		move.b	(a0)+,d0
		bmi.s	loc_5426
		lea	(Pal_S1SSCyc1).l,a1
		adda.w	d0,a1
		lea	(RAM_Pal_3+$E).w,a2
		move.l	(a1)+,(a2)+
		move.l	(a1)+,(a2)+
		move.l	(a1)+,(a2)+

locret_5424:
		rts
; ===============================================================================

loc_5426:
		move.w	($FFFFF79E).w,d1
		cmpi.w	#$8A,d0
		bcs.s	loc_5432
		addq.w	#1,d1

loc_5432:
		mulu.w	#$2A,d1
		lea	(Pal_S1SSCyc2).l,a1
		adda.w	d1,a1
		andi.w	#$7F,d0
		bclr	#0,d0
		beq.s	loc_5456
		lea	(RAM_Pal_4+$E).w,a2
		move.l	(a1),(a2)+
		move.l	4(a1),(a2)+
		move.l	8(a1),(a2)+

loc_5456:
		adda.w	#$C,a1
		lea	(RAM_Pal_3+$1A).w,a2
		cmpi.w	#$A,d0
		bcs.s	loc_546C
		subi.w	#$A,d0
		lea	(RAM_Pal_4+$1A).w,a2

loc_546C:
		move.w	d0,d1
		add.w	d0,d0
		add.w	d1,d0
		adda.w	d0,a1
		move.l	(a1)+,(a2)+
		move.w	(a1)+,(a2)+
		rts

; ===============================================================================
word_547A:	dc.w  $300, $792, $300,	$790, $300, $78E, $300,	$78C, $300, $78B, $300,	$780, $300, $782, $300,	$784; 0
		dc.w  $300, $786, $300,	$788, $708, $700, $70A,	$70C,$FF0C, $718,$FF0C,	$718, $70A, $70C, $708,	$700; 16
		dc.w  $300, $688, $300,	$686, $300, $684, $300,	$682, $300, $681, $300,	$68A, $300, $68C, $300,	$68E; 32
		dc.w  $300, $690, $300,	$692, $702, $624, $704,	$630,$FF06, $63C,$FF06,	$63C, $704, $630, $702,	$624; 48
word_54FA:	dc.w $1001,$1800,$1801,$2000,$2001,$2800,$2801;	0
Pal_S1SSCyc1:	dc.w  $400, $600, $620,	$624, $664, $666, $600,	$820, $A64, $A68, $AA6,	$AAA, $800, $C42, $E86,	$ECA; 0
		dc.w  $EEC, $EEE, $400,	$420, $620, $620, $864,	$666, $420, $620, $842,	$842, $A86, $AAA, $620,	$842; 16
		dc.w  $A64, $C86, $EA8,	$EEE; 32
Pal_S1SSCyc2:	dc.w  $EEA, $EE0, $AA0,	$880, $660, $440, $EE0,	$AA0, $440, $AA0, $AA0,	$AA0, $860, $860, $860,	$640; 0
		dc.w  $640, $640, $400,	$400, $400, $AEC, $6EA,	$4C6, $2A4,  $82,  $60,	$6EA, $4C6,  $60, $4C6,	$4C6; 16
		dc.w  $4C6, $484, $484,	$484, $442, $442, $442,	$400, $400, $400, $ECC,	$E8A, $C68, $A46, $824,	$602; 32
		dc.w  $E8A, $C68, $602,	$C68, $C68, $C68, $846,	$846, $846, $624, $624,	$624, $400, $400, $400,	$AEC; 48
		dc.w  $8CA, $6A8, $486,	$264,  $42, $8CA, $6A8,	 $42, $6A8, $6A8, $6A8,	$684, $684, $684, $442,	$442; 64
		dc.w  $442, $400, $400,	$400, $EEC, $CCA, $AA8,	$886, $664, $442, $CCA,	$AA8, $442, $AA8, $AA8,	$AA8; 80
		dc.w  $864, $864, $864,	$642, $642, $642, $400,	$400, $400; 96

; =============== S U B R O U T I N E ==========================================


S1SS_BgAnimate:
		move.w	($FFFFF7A0).w,d0
		bne.s	loc_5634
		move.w	#0,(RAM_LevelSys_Buff+$C).w
		move.w	(RAM_LevelSys_Buff+$C).w,(RAM_VDP_VScroll+$2).w

loc_5634:
		cmpi.w	#8,d0
		bcc.s	loc_568C
		cmpi.w	#6,d0
		bne.s	loc_564E
		addq.w	#1,(RAM_LevelSys_Buff+$18).w
		addq.w	#1,(RAM_LevelSys_Buff+$C).w
		move.w	(RAM_LevelSys_Buff+$C).w,(RAM_VDP_VScroll+$2).w

loc_564E:
		moveq	#0,d0
		move.w	(RAM_LevelSys_Buff+$8).w,d0
		neg.w	d0
		swap	d0
		lea	(byte_5709).l,a1
		lea	(RAM_DecompBuffer).w,a3
		moveq	#9,d3

loc_5664:
		move.w	2(a3),d0
		bsr.w	CalcSine
		moveq	#0,d2
		move.b	(a1)+,d2
		muls.w	d2,d0
		asr.l	#8,d0
		move.w	d0,(a3)+
		move.b	(a1)+,d2
		ext.w	d2
		add.w	d2,(a3)+
		dbf	d3,loc_5664
		lea	(RAM_DecompBuffer).w,a3
		lea	(byte_56F6).l,a2
		bra.s	loc_56BC
; ===============================================================================

loc_568C:
		cmpi.w	#$C,d0
		bne.s	loc_56B2
		subq.w	#1,(RAM_LevelSys_Buff+$18).w
		lea	($FFFFAB00).w,a3
		move.l	#$18000,d2
		moveq	#6,d1

loc_56A2:
		move.l	(a3),d0
		sub.l	d2,d0
		move.l	d0,(a3)+
		subi.l	#$2000,d2
		dbf	d1,loc_56A2

loc_56B2:
		lea	($FFFFAB00).w,a3
		lea	(byte_5701).l,a2

loc_56BC:
		lea	(RAM_HorScrollBuffer).w,a1
		move.w	(RAM_LevelSys_Buff+$18).w,d0
		neg.w	d0
		swap	d0
		moveq	#0,d3
		move.b	(a2)+,d3
		move.w	(RAM_LevelSys_Buff+$C).w,d2
		neg.w	d2
		andi.w	#$FF,d2
		lsl.w	#2,d2

loc_56D8:
		move.w	(a3)+,d0
		addq.w	#2,a3
		moveq	#0,d1
		move.b	(a2)+,d1
		subq.w	#1,d1

loc_56E2:
		move.l	d0,(a1,d2.w)
		addq.w	#4,d2
		andi.w	#$3FC,d2
		dbf	d1,loc_56E2
		dbf	d3,loc_56D8
		rts

; ===============================================================================
byte_56F6:	dc.b   9,$28,$18,$10,$28,$18,$10,$30,$18,  8,$10; 0
byte_5701:	dc.b   6,$30,$30,$30,$28,$18,$18,$18

byte_5709:	dc.b   8,  2,  4,$FF,  2,  3,  8,$FF,  4,  2,  2,  3,  8,$FD,  4,  2; 0
		dc.b   2,  3,  2,$FF,  0; 16
; ===============================================================================
		nop

; =============== S U B R O U T I N E ==========================================


LevelSizeLoad:
		clr.w	(RAM_LevelSys_DirToDraw).w
		clr.w	(RAM_BlockScrollBuff).w
		clr.w	(RAM_BlockScrollBuff+$2).w
		clr.w	(RAM_BlockScrollBuff+$4).w
		clr.w	(RAM_BlockScrollBuff+$6).w
		clr.w	(RAM_BlockScrollBuff+$8).w
		clr.w	(RAM_BlockScrollBuff+$A).w
		clr.w	(RAM_BlockScrollBuff+$C).w
		clr.w	(RAM_LevelSys_DirToDraw_Backup).w
		clr.w	(RAM_LevelDrawBuff).w
		clr.w	(RAM_LevelDrawBuff+$2).w
		clr.w	(RAM_LevelDrawBuff+$4).w
		clr.w	(RAM_LevelDrawBuff+$6).w
		clr.w	(RAM_LevelDrawBuff+$8).w
		clr.w	(RAM_LevelDrawBuff+$A).w
		clr.w	(RAM_LevelDrawBuff+$C).w
		clr.b	(RAM_Level_NoEffectsFlag).w

		moveq	#0,d0
		move.b	d0,(RAM_DynResizeCntr).w
		move.w	(RAM_Level_CurrentZone).w,d0
		lsl.b	#6,d0
		lsr.w	#3,d0
		lea	LevelSizeArray(pc,d0.w),a0
		move.l	(a0)+,d0
		move.l	d0,(RAM_LevelSys_XPos_SetStart).w
		move.l	d0,(RAM_LevelSys_XPos_SetStart_Backup).w
		move.l	(a0)+,d0
		move.l	d0,(RAM_LevelSys_YPos_SetStart).w
		move.l	d0,(RAM_LevelSys_YPos_SetStart_Backup).w
		move.w	#$1010,(RAM_LevelSys_Unk).w
		move.w	#$60,(RAM_LevelSys_ForceToYPos).w
		bra.w	LevelSize_CheckLamp

; ===============================================================================
LevelSizeArray:
		dc.w	 0,$24BF,    0,	$300,	 0,$1EBF,    0,	$300; 0
		dc.w	 0,$2960,    0,	$300,	 0,$2ABF,    0,	$300; 8
		dc.w	 0,$3FFF,    0,	$720,	 0,$3FFF,    0,	$720; 16
		dc.w	 0,$3FFF,    0,	$720,	 0,$3FFF,    0,	$720; 24
		dc.w	 0,$3FFF,    0,	$720,	 0,$3FFF,    0,	$720; 32
		dc.w	 0,$3FFF,    0,	$720,	 0,$3FFF,    0,	$720; 40
		dc.w	 0,$29A0,    0,	$320,	 0,$2940,    0,	$420; 48
		dc.w	 0,$25C0,    0,	$720,	 0,$3FFF,    0,	$720; 56
		dc.w	 0,$3FFF,    0,	$720,	 0,$3FFF,    0,	$720; 64
		dc.w	 0,$3FFF,    0,	$720,	 0,$3FFF,    0,	$720; 72
		dc.w	 0,$3FFF,    0,	$720,	 0,$3FFF,$FF00,	$720; 80
		dc.w $2080,$3FFF, $510,	$720,	 0,$3FFF,    0,	$720; 88
		dc.w	 0, $500, $110,	$110,	 0, $DC0, $110,	$110; 96
		dc.w	 0,$2FFF,    0,	$320,	 0,$2FFF,    0,	$320; 104

S1EndingStartLoc:dc.w	$50, $3B0, $EA0, $46C,$1750,  $BD, $A00, $62C; 0
		dc.w  $BB0,  $4C,$1570,	$16C, $1B0, $72C,$1400,	$2AC; 8
; ===============================================================================

LevelSize_CheckLamp:
		tst.b	(RAM_Level_LamppostCntr).w
		beq.s	LevelSize_StartLoc
		jsr	Lamppost_LoadInfo
		move.w	(RAM_ObjRAM_Sonic+$8).w,d1
		move.w	(RAM_ObjRAM_Sonic+$C).w,d0
		bra.s	LevelSize_StartLocLoaded
; ===============================================================================

LevelSize_StartLoc:
		move.w	(RAM_Level_CurrentZone).w,d0
		lsl.b	#6,d0
		lsr.w	#4,d0
		lea	StartLocArray(pc,d0.w),a1
		tst.w	(RAM_Flag_DemoMode).w
		bpl.s	loc_58CE
		move.w	(RAM_S1_CreditsID).w,d0
		subq.w	#1,d0
		lsl.w	#2,d0
		lea	S1EndingStartLoc(pc,d0.w),a1

loc_58CE:
		moveq	#0,d1
		move.w	(a1)+,d1
		move.w	d1,(RAM_ObjRAM_Sonic+$8).w
		moveq	#0,d0
		move.w	(a1),d0
		move.w	d0,(RAM_ObjRAM_Sonic+$C).w

LevelSize_StartLocLoaded:
		subi.w	#$A0,d1
		bcc.s	loc_58E6
		moveq	#0,d1

loc_58E6:
		move.w	(RAM_LevelSys_XPos_SetEnd).w,d2
		cmp.w	d2,d1
		bcs.s	loc_58F0
		move.w	d2,d1

loc_58F0:
		move.w	d1,(RAM_LevelSys_Buff).w
		move.w	d1,(RAM_LevelSys_Buff_2P).w
		subi.w	#$60,d0
		bcc.s	loc_5900
		moveq	#0,d0

loc_5900:
		cmp.w	(RAM_LevelSys_YPos_SetEnd).w,d0
		blt.s	loc_590A
		move.w	(RAM_LevelSys_YPos_SetEnd).w,d0

loc_590A:
		move.w	d0,(RAM_LevelSys_Buff+$4).w
		move.w	d0,(RAM_LevelSys_Buff_2P+$4).w
		bsr.w	BgScrollSpeed
		rts

; ===============================================================================
StartLocArray:	dc.w   $50, $3B0,  $50,	 $FC,  $50, $3B0,  $80,	 $A8; 0
		dc.w   $60,  $6C,  $50,	 $EC,  $50, $2EC, $B80,	   0; 8
		dc.w   $30, $1EC,  $30,	$266,  $30, $166,  $80,	 $A8; 16
		dc.w   $60, $28F,  $40,	$2AF,  $40, $370,  $80,	 $A8; 24
		dc.w  $230, $1AC,  $30,	$1BD,  $30,  $EC,  $80,	 $A8; 32
		dc.w   $40, $36F,  $60,	$690,$2140, $5AC,  $80,	 $A8; 40
		dc.w  $620, $16B, $EE0,	$16C,  $80,  $A8,  $80,	 $A8; 48

; =============== S U B R O U T I N E ==========================================


BgScrollSpeed:
		tst.b	(RAM_Level_LamppostCntr).w
		bne.s	loc_59B6
		move.w	d0,(RAM_LevelSys_Buff+$C).w
		move.w	d0,(RAM_LevelSys_Buff+$14).w
		move.w	d1,(RAM_LevelSys_Buff+$8).w
		move.w	d1,(RAM_LevelSys_Buff+$10).w
		move.w	d1,(RAM_LevelSys_Buff+$18).w

		move.w	d0,(RAM_LevelSys_Buff_2p+$C).w
		move.w	d0,(RAM_LevelSys_Buff_2p+$14).w
		move.w	d1,(RAM_LevelSys_Buff_2p+$8).w
		move.w	d1,(RAM_LevelSys_Buff_2p+$10).w
		move.w	d1,(RAM_LevelSys_Buff_2p+$18).w

loc_59B6:
		moveq	#0,d2
		move.b	(RAM_Level_CurrentZone).w,d2
		add.w	d2,d2
		move.w	BgScroll_Index(pc,d2.w),d2
		jmp	BgScroll_Index(pc,d2.w)
; End of function BgScrollSpeed

; ===============================================================================
BgScroll_Index:	dc.w BgScroll_GHZ-BgScroll_Index; 0
		dc.w BgScroll_LZ-BgScroll_Index; 1
		dc.w BgScroll_CPZ-BgScroll_Index; 2
		dc.w BgScroll_EHZ-BgScroll_Index; 3
		dc.w BgScroll_HPZ-BgScroll_Index; 4
		dc.w BgScroll_EHZ-BgScroll_Index; 5
		dc.w BgScroll_S1Ending-BgScroll_Index; 6
; ===============================================================================

BgScroll_GHZ:
		clr.l	(RAM_LevelSys_Buff+$8).w
		clr.l	(RAM_LevelSys_Buff+$C).w
		clr.l	(RAM_LevelSys_Buff+$14).w
		clr.l	(RAM_LevelSys_Buff+$1C).w
		lea	(RAM_LevelDeform_Buff).w,a2
		clr.l	(a2)+
		clr.l	(a2)+
		clr.l	(a2)+
		clr.l	(RAM_LevelSys_Buff_2p+$8).w
		clr.l	(RAM_LevelSys_Buff_2p+$C).w
		clr.l	(RAM_LevelSys_Buff_2p+$14).w
		clr.l	(RAM_LevelSys_Buff_2p+$1C).w
		rts
; ===============================================================================

BgScroll_LZ:
		asr.l	#1,d0
		move.w	d0,(RAM_LevelSys_Buff+$C).w
		rts
; ===============================================================================

BgScroll_CPZ:
		lsr.w	#2,d0
		move.w	d0,(RAM_LevelSys_Buff+$C).w
		move.w	d0,(RAM_LevelSys_Buff_2p+$C).w
		clr.l	(RAM_LevelSys_Buff+$8).w
		clr.l	(RAM_LevelSys_Buff+$10).w
		rts
; ===============================================================================

		include	"Levels/03/bgscroll.asm"
		even
; ===============================================================================

BgScroll_HPZ:
		asr.w	#1,d0
		move.w	d0,(RAM_LevelSys_Buff+$C).w
		clr.l	(RAM_LevelSys_Buff+$8).w
		rts
; ===============================================================================

BgScroll_S1SYZ:				; leftover from	Sonic 1
		asl.l	#4,d0
		move.l	d0,d2
		asl.l	#1,d0
		add.l	d2,d0
		asr.l	#8,d0
		addq.w	#1,d0
		move.w	d0,(RAM_LevelSys_Buff+$C).w
		clr.l	(RAM_LevelSys_Buff+$8).w
		rts
; ===============================================================================

BgScroll_S1Ending:
		move.w	(RAM_LevelSys_Buff).w,d0
		asr.w	#1,d0
		move.w	d0,(RAM_LevelSys_Buff+$8).w
		move.w	d0,(RAM_LevelSys_Buff+$10).w
		asr.w	#2,d0
		move.w	d0,d1
		add.w	d0,d0
		add.w	d1,d0
		move.w	d0,(RAM_LevelSys_Buff+$18).w
		clr.l	(RAM_LevelSys_Buff+$C).w
		clr.l	(RAM_LevelSys_Buff+$14).w
		clr.l	(RAM_LevelSys_Buff+$1C).w
		lea	(RAM_LevelDeform_Buff).w,a2
		clr.l	(a2)+
		clr.l	(a2)+
		clr.l	(a2)+
		rts

; =============== S U B R O U T I N E ==========================================


DeformBGLayer:
		tst.b	(RAM_Level_NoEffectsFlag).w
		beq.s	@DontDisable
		rts
; ===============================================================================

@DontDisable:
		clr.w	(RAM_LevelSys_DirToDraw).w
		clr.w	(RAM_BlockScrollBuff).w
		clr.w	(RAM_BlockScrollBuff+$2).w
		clr.w	(RAM_BlockScrollBuff+$4).w
		clr.w	(RAM_BlockScrollBuff+$6).w
		clr.w	(RAM_BlockScrollBuff+$8).w
		clr.w	(RAM_BlockScrollBuff+$A).w
		clr.w	(RAM_BlockScrollBuff+$C).w

		lea	(RAM_ObjectTable).w,a0			;Objects to check on-screen
		lea	(RAM_LevelSys_Buff).w,a1		;Get level's Xpos
		lea	(RAM_LevelSys_Unk).w,a2			;???
		lea	(RAM_LevelSys_DirToDraw).w,a3		;Draw direction
		lea	(RAM_LevelSys_DrawSpeed_XPos).w,a4	;Drawing speed
		lea	(RAM_LevelSys_WaitToScr).w,a5		;Timer: Wait to Scroll (Spindash)
		lea	(RAM_Sonic_InvStarPosTable).w,a6	;Save Sonic's X/Y Positions randomly (Invincibility stars)
		bsr.w	ScrollHorizontal

		lea	(RAM_LevelSys_Buff+$4).w,a1		;Get level's Ypos
		lea	(RAM_LevelSys_Unk+$1).w,a2		;???
		lea	(RAM_LevelSys_DrawSpeed_YPos).w,a4	;Drawing speed
		bsr.w	ScrollVertical

		tst.w	(RAM_Flag_SplitScreen).w
		beq.s	@DontDraw2p

		lea	(RAM_ObjRAM_Tails).w,a0
		lea	(RAM_LevelSys_Buff_2P).w,a1
		lea	(RAM_LevelSys_Unk+$8).w,a2
		lea	(RAM_LevelSys_DirToDraw_2p).w,a3
		lea	(RAM_LevelSys_DrawSpeed_2p_XPos).w,a4
		lea	(RAM_LevelSys_WaitToScr_2p).w,a5
		lea	(RAM_Tails_InvStarPosTable).w,a6
		bsr.w	ScrollHorizontal

		lea	(RAM_LevelSys_Buff_2P+$4).w,a1
		lea	(RAM_LevelSys_Unk+$9).w,a2
		lea	(RAM_LevelSys_DrawSpeed_2p_YPos).w,a4
		bsr.w	ScrollVertical

@DontDraw2p:
		bsr.w	DynScreenResizeLoad
		move.w	(RAM_LevelSys_Buff+$4).w,(RAM_VDP_VScroll).w
		move.w	(RAM_LevelSys_Buff+$C).w,(RAM_VDP_VScroll+$2).w
		moveq	#0,d0
		move.b	(RAM_Level_CurrentZone).w,d0
		add.w	d0,d0
		move.w	Deform_Index(pc,d0.w),d0
		jmp	Deform_Index(pc,d0.w)

; ===============================================================================
Deform_Index:	dc.w Deform_GHZ-Deform_Index
		dc.w Deform_LZ-Deform_Index
		dc.w Deform_CPZ-Deform_Index
		dc.w Deform_EHZ-Deform_Index
		dc.w Deform_HPZ-Deform_Index
		dc.w Deform_HTZ-Deform_Index
		dc.w Deform_GHZ-Deform_Index
; ===============================================================================

Deform_GHZ:
		tst.w	(RAM_Flag_SplitScreen).w
		bne.w	loc_5C5A
		move.w	(RAM_LevelSys_DrawSpeed_XPos).w,d4
		ext.l	d4
		asl.l	#5,d4
		move.l	d4,d1
		asl.l	#1,d4
		add.l	d1,d4
		moveq	#0,d6
		bsr.w	ScrollBlock6
		move.w	(RAM_LevelSys_DrawSpeed_XPos).w,d4
		ext.l	d4
		asl.l	#7,d4
		moveq	#0,d6
		bsr.w	ScrollBlock5
		lea	(RAM_HorScrollBuffer).w,a1
		move.w	(RAM_LevelSys_Buff+$4).w,d0
		andi.w	#$7FF,d0
		lsr.w	#5,d0
		neg.w	d0
		addi.w	#$20,d0
		bpl.s	loc_5B9A
		moveq	#0,d0

loc_5B9A:
		move.w	d0,d4
		move.w	d0,(RAM_VDP_VScroll+$2).w
		move.w	(RAM_LevelSys_Buff).w,d0
		cmpi.b	#ModeId_TitleScr,(RAM_GameMode).w
		bne.s	loc_5BAE
		moveq	#0,d0

loc_5BAE:
		neg.w	d0
		swap	d0
		lea	(RAM_LevelDeform_Buff).w,a2
		addi.l	#$10000,(a2)+
		addi.l	#$C000,(a2)+
		addi.l	#$8000,(a2)+
		move.w	(RAM_LevelDeform_Buff).w,d0
		add.w	(RAM_LevelSys_Buff+$18).w,d0
		neg.w	d0
		move.w	#$1F,d1
		sub.w	d4,d1
		bcs.s	loc_5BE0

loc_5BDA:
		move.l	d0,(a1)+
		dbf	d1,loc_5BDA

loc_5BE0:
		move.w	(RAM_LevelDeform_Buff+$4).w,d0
		add.w	(RAM_LevelSys_Buff+$18).w,d0
		neg.w	d0
		move.w	#$F,d1

loc_5BEE:
		move.l	d0,(a1)+
		dbf	d1,loc_5BEE
		move.w	(RAM_LevelDeform_Buff+$8).w,d0
		add.w	(RAM_LevelSys_Buff+$18).w,d0
		neg.w	d0
		move.w	#$F,d1

loc_5C02:
		move.l	d0,(a1)+
		dbf	d1,loc_5C02
		move.w	#$2F,d1
		move.w	(RAM_LevelSys_Buff+$18).w,d0
		neg.w	d0

loc_5C12:
		move.l	d0,(a1)+
		dbf	d1,loc_5C12
		move.w	#$27,d1
		move.w	(RAM_LevelSys_Buff+$10).w,d0
		neg.w	d0

loc_5C22:
		move.l	d0,(a1)+
		dbf	d1,loc_5C22
		move.w	(RAM_LevelSys_Buff+$10).w,d0
		move.w	(RAM_LevelSys_Buff).w,d2
		sub.w	d0,d2
		ext.l	d2
		asl.l	#8,d2
		divs.w	#$68,d2
		ext.l	d2
		asl.l	#8,d2
		moveq	#0,d3
		move.w	d0,d3
		move.w	#$47,d1
		add.w	d4,d1

loc_5C48:
		move.w	d3,d0
		neg.w	d0
		move.l	d0,(a1)+
		swap	d3
		add.l	d2,d3
		swap	d3
		dbf	d1,loc_5C48
		rts
; ===============================================================================

loc_5C5A:
		move.w	(RAM_LevelSys_DrawSpeed_XPos).w,d4
		ext.l	d4
		asl.l	#5,d4
		move.l	d4,d1
		asl.l	#1,d4
		add.l	d1,d4
		moveq	#0,d6
		bsr.w	ScrollBlock6
		move.w	(RAM_LevelSys_DrawSpeed_XPos).w,d4
		ext.l	d4
		asl.l	#7,d4
		moveq	#0,d6
		bsr.w	ScrollBlock5
		lea	(RAM_HorScrollBuffer).w,a1
		move.w	(RAM_LevelSys_Buff+$4).w,d0
		andi.w	#$7FF,d0
		lsr.w	#5,d0
		neg.w	d0
		addi.w	#$20,d0
		bpl.s	loc_5C94
		moveq	#0,d0

loc_5C94:
		andi.w	#$FFFE,d0
		move.w	d0,d4
		lsr.w	#1,d4
		move.w	d0,(RAM_VDP_VScroll+$2).w
		andi.l	#$FFFEFFFE,(RAM_VDP_VScroll).w
		move.w	(RAM_LevelSys_Buff).w,d0
		cmpi.b	#ModeId_TitleScr,(RAM_GameMode).w
		bne.s	loc_5CB6
		moveq	#0,d0

loc_5CB6:
		neg.w	d0
		swap	d0
		lea	(RAM_LevelDeform_Buff).w,a2
		addi.l	#$10000,(a2)+
		addi.l	#$C000,(a2)+
		addi.l	#$8000,(a2)+
		move.w	(RAM_LevelDeform_Buff).w,d0
		add.w	(RAM_LevelSys_Buff+$18).w,d0
		neg.w	d0
		move.w	#$F,d1
		sub.w	d4,d1
		bcs.s	loc_5CE8

loc_5CE2:
		move.l	d0,(a1)+
		dbf	d1,loc_5CE2

loc_5CE8:
		move.w	(RAM_LevelDeform_Buff+$4).w,d0
		add.w	(RAM_LevelSys_Buff+$18).w,d0
		neg.w	d0
		move.w	#7,d1

loc_5CF6:
		move.l	d0,(a1)+
		dbf	d1,loc_5CF6
		move.w	(RAM_LevelDeform_Buff+$8).w,d0
		add.w	(RAM_LevelSys_Buff+$18).w,d0
		neg.w	d0
		move.w	#7,d1

loc_5D0A:
		move.l	d0,(a1)+
		dbf	d1,loc_5D0A
		move.w	#$17,d1
		move.w	(RAM_LevelSys_Buff+$18).w,d0
		neg.w	d0

loc_5D1A:
		move.l	d0,(a1)+
		dbf	d1,loc_5D1A
		move.w	#$17,d1
		move.w	(RAM_LevelSys_Buff+$10).w,d0
		neg.w	d0

loc_5D2A:
		move.l	d0,(a1)+
		dbf	d1,loc_5D2A
		move.w	(RAM_LevelSys_Buff+$10).w,d0
		move.w	(RAM_LevelSys_Buff).w,d2
		sub.w	d0,d2
		ext.l	d2
		asl.l	#8,d2
		divs.w	#$68,d2
		ext.l	d2
		asl.l	#8,d2
		add.l	d2,d2
		moveq	#0,d3
		move.w	d0,d3
		move.w	#$23,d1
		add.w	d4,d1

loc_5D52:
		move.w	d3,d0
		neg.w	d0
		move.l	d0,(a1)+
		swap	d3
		add.l	d2,d3
		swap	d3
		dbf	d1,loc_5D52
		move.w	(RAM_LevelSys_DrawSpeed_2p_XPos).w,d4
		ext.l	d4
		asl.l	#5,d4
		move.l	d4,d1
		asl.l	#1,d4
		add.l	d1,d4
		add.l	d4,(RAM_LevelSys_Buff_2p+$18).w
		move.w	(RAM_LevelSys_DrawSpeed_2p_XPos).w,d4
		ext.l	d4
		asl.l	#7,d4
		add.l	d4,(RAM_LevelSys_Buff_2p+$10).w
		lea	(RAM_HorScrollBuffer+$1C0).w,a1
		move.w	(RAM_LevelSys_Buff_2P+$4).w,d0
		andi.w	#$7FF,d0
		lsr.w	#5,d0
		neg.w	d0
		addi.w	#$20,d0
		bpl.s	loc_5D98
		moveq	#0,d0

loc_5D98:
		andi.w	#$FFFE,d0
		move.w	d0,d4
		lsr.w	#1,d4
		move.w	d0,(RAM_Deform_Unk_1).w
		subi.w	#$E0,(RAM_Deform_Unk_1).w
		move.w	(RAM_LevelSys_Buff_2P+$4).w,(RAM_Level_CopyTo2pVscrl).w
		subi.w	#$E0,(RAM_Level_CopyTo2pVscrl).w
		andi.l	#$FFFEFFFE,(RAM_Level_CopyTo2pVscrl).w
		move.w	(RAM_LevelSys_Buff_2P).w,d0
		cmpi.b	#ModeId_TitleScr,(RAM_GameMode).w
		bne.s	loc_5DCC
		moveq	#0,d0

loc_5DCC:
		neg.w	d0
		swap	d0
		move.w	(RAM_LevelDeform_Buff).w,d0
		add.w	(RAM_LevelSys_Buff_2p+$18).w,d0
		neg.w	d0
		move.w	#$F,d1
		sub.w	d4,d1
		bcs.s	loc_5DE8

loc_5DE2:
		move.l	d0,(a1)+
		dbf	d1,loc_5DE2

loc_5DE8:
		move.w	(RAM_LevelDeform_Buff+$4).w,d0
		add.w	(RAM_LevelSys_Buff_2p+$18).w,d0
		neg.w	d0
		move.w	#7,d1

loc_5DF6:
		move.l	d0,(a1)+
		dbf	d1,loc_5DF6
		move.w	(RAM_LevelDeform_Buff+$8).w,d0
		add.w	(RAM_LevelSys_Buff_2p+$18).w,d0
		neg.w	d0
		move.w	#7,d1

loc_5E0A:
		move.l	d0,(a1)+
		dbf	d1,loc_5E0A
		move.w	#$17,d1
		move.w	(RAM_LevelSys_Buff_2p+$18).w,d0
		neg.w	d0

loc_5E1A:
		move.l	d0,(a1)+
		dbf	d1,loc_5E1A
		move.w	#$17,d1
		move.w	(RAM_LevelSys_Buff_2p+$10).w,d0
		neg.w	d0

loc_5E2A:
		move.l	d0,(a1)+
		dbf	d1,loc_5E2A
		move.w	(RAM_LevelSys_Buff_2p+$10).w,d0
		move.w	(RAM_LevelSys_Buff_2P).w,d2
		sub.w	d0,d2
		ext.l	d2
		asl.l	#8,d2
		divs.w	#$68,d2	; 'h'
		ext.l	d2
		asl.l	#8,d2
		add.l	d2,d2
		moveq	#0,d3
		move.w	d0,d3
		move.w	#$23,d1	; '#'
		add.w	d4,d1

loc_5E52:
		move.w	d3,d0
		neg.w	d0
		move.l	d0,(a1)+
		swap	d3
		add.l	d2,d3
		swap	d3
		dbf	d1,loc_5E52
		rts
; ===============================================================================

Deform_LZ:
		move.w	(RAM_LevelSys_DrawSpeed_XPos).w,d4
		ext.l	d4
		asl.l	#7,d4
		move.w	(RAM_LevelSys_DrawSpeed_YPos).w,d5
		ext.l	d5
		asl.l	#7,d5
		bsr.w	ScrollBlock1
		move.w	(RAM_LevelSys_Buff+$C).w,(RAM_VDP_VScroll+$2).w
		lea	(Deform_LZ_Data1).l,a3
		lea	(Obj0A_WobbleData).l,a2
		move.b	(RAM_Level_GetYPos_80).w,d2
		move.b	d2,d3
		addi.w	#$80,(RAM_Level_GetYPos_80).w
		add.w	(RAM_LevelSys_Buff+$C).w,d2
		andi.w	#$FF,d2
		add.w	(RAM_LevelSys_Buff+$4).w,d3
		andi.w	#$FF,d3
		lea	(RAM_HorScrollBuffer).w,a1
		move.w	#$DF,d1
		move.w	(RAM_LevelSys_Buff).w,d0
		neg.w	d0
		move.w	d0,d6
		swap	d0
		move.w	(RAM_LevelSys_Buff+$8).w,d0
		neg.w	d0
		move.w	(RAM_Level_Water_Action).w,d4
		move.w	(RAM_LevelSys_Buff+$4).w,d5

loc_5EC6:
		cmp.w	d4,d5
		bge.s	loc_5ED8
		move.l	d0,(a1)+
		addq.w	#1,d5
		addq.b	#1,d2
		addq.b	#1,d3
		dbf	d1,loc_5EC6
		rts
; ===============================================================================

loc_5ED8:
		move.b	(a3,d3.w),d4
		ext.w	d4
		add.w	d6,d4
		move.w	d4,(a1)+
		move.b	(a2,d2.w),d4
		ext.w	d4
		add.w	d0,d4
		move.w	d4,(a1)+
		addq.b	#1,d2
		addq.b	#1,d3
		dbf	d1,loc_5ED8
		rts
; ===============================================================================
Deform_LZ_Data1:
		dc.b   1,  1,  2,  2,  3,  3,  3,  3,  2,  2,  1,  1,  0,  0,  0,  0; 0
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 16
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 32
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 48
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 64
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 80
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 96
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 112
		dc.b $FF,$FF,$FE,$FE,$FD,$FD,$FD,$FD,$FE,$FE,$FF,$FF,  0,  0,  0,  0; 128
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 144
		dc.b   1,  1,  2,  2,  3,  3,  3,  3,  2,  2,  1,  1,  0,  0,  0,  0; 160
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 176
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 192
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 208
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 224
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 240
; ===============================================================================

Deform_CPZ:
		move.w	(RAM_LevelSys_DrawSpeed_XPos).w,d4
		ext.l	d4
		asl.l	#5,d4
		move.w	(RAM_LevelSys_DrawSpeed_YPos).w,d5
		ext.l	d5
		asl.l	#6,d5
		bsr.w	ScrollBlock1
		move.w	(RAM_LevelSys_Buff+$C).w,(RAM_VDP_VScroll+$2).w
		lea	(RAM_HorScrollBuffer).w,a1
		move.w	#$DF,d1	; ''
		move.w	(RAM_LevelSys_Buff).w,d0
		neg.w	d0
		swap	d0
		move.w	(RAM_LevelSys_Buff+$8).w,d0
		neg.w	d0

loc_6026:
		move.l	d0,(a1)+
		dbf	d1,loc_6026
		rts
; ===============================================================================

Deform_Unk:				; unknown BG deform
		move.w	(RAM_LevelSys_DrawSpeed_XPos).w,d4
		ext.l	d4
		asl.l	#5,d4
		move.w	(RAM_LevelSys_DrawSpeed_YPos).w,d5
		ext.l	d5
		asl.l	#6,d5
		bsr.w	ScrollBlock1
		move.w	(RAM_LevelSys_DrawSpeed_XPos).w,d4
		ext.l	d4
		asl.l	#7,d4
		moveq	#4,d6
		bsr.w	ScrollBlock5
		move.w	(RAM_LevelSys_Buff+$C).w,(RAM_VDP_VScroll+$2).w
		move.b	(RAM_BlockScrollBuff).w,d0
		or.b	(RAM_BlockScrollBuff+$2).w,d0
		move.b	d0,(RAM_BlockScrollBuff+$4).w
		clr.b	(RAM_BlockScrollBuff).w
		clr.b	(RAM_BlockScrollBuff+$2).w
		lea	(RAM_LevelDeform_Buff).w,a1
		move.w	(RAM_LevelSys_Buff+$8).w,d0
		neg.w	d0
		move.w	#$12,d1

loc_6078:
		move.w	d0,(a1)+
		dbf	d1,loc_6078
		move.w	(RAM_LevelSys_Buff+$10).w,d0
		neg.w	d0
		move.w	#$1C,d1

loc_6088:
		move.w	d0,(a1)+
		dbf	d1,loc_6088
		lea	(RAM_LevelDeform_Buff).w,a2
		move.w	(RAM_LevelSys_Buff+$C).w,d0
		andi.w	#$3F0,d0
		lsr.w	#3,d0
		lea	(a2,d0.w),a2
		bra.w	loc_6306

; =============== S U B R O U T I N E ==========================================


Deform_TitleScreen:
		move.w	(RAM_LevelSys_Buff+$C).w,(RAM_VDP_VScroll+$2).w
		move.w	(RAM_LevelSys_Buff).w,d0
		cmpi.w	#$1C00,d0
		bcc.s	loc_60B6
		addq.w	#8,d0

loc_60B6:
		move.w	d0,(RAM_LevelSys_Buff).w
		lea	(RAM_HorScrollBuffer).w,a1
		move.w	(RAM_LevelSys_Buff).w,d2
		neg.w	d2
		moveq	#0,d0
		bra.s	loc_60E4
; ===============================================================================

		include	"Levels/03/deform.asm"
		even

; ===============================================================================

Deform_HPZ:				; DATA XREF: ROM:Deform_Indexo
		move.w	(RAM_LevelSys_DrawSpeed_XPos).w,d4
		ext.l	d4
		asl.l	#6,d4
		moveq	#2,d6
		bsr.w	ScrollBlock4

		move.w	(RAM_LevelSys_DrawSpeed_YPos).w,d5
		ext.l	d5
		asl.l	#7,d5
		moveq	#6,d6
		bsr.w	ScrollBlock2
		move.w	(RAM_LevelSys_Buff+$C).w,(RAM_VDP_VScroll+$2).w
		lea	(RAM_LevelDeform_Buff).w,a1
		move.w	(RAM_LevelSys_Buff).w,d2
		neg.w	d2
		move.w	d2,d0
		asr.w	#1,d0
		move.w	#7,d1

loc_637E:				; CODE XREF: ROM:00006380j
		move.w	d0,(a1)+
		dbf	d1,loc_637E
		move.w	d2,d0
		asr.w	#3,d0
		sub.w	d2,d0
		ext.l	d0
		asl.l	#3,d0
		divs.w	#8,d0
		ext.l	d0
		asl.l	#4,d0
		asl.l	#8,d0
		moveq	#0,d3
		move.w	d2,d3
		asr.w	#1,d3
		lea	(RAM_LevelDeform_Buff+$60).w,a2
		swap	d3
		add.l	d0,d3
		swap	d3
		move.w	d3,(a1)+
		move.w	d3,(a1)+
		move.w	d3,(a1)+
		move.w	d3,-(a2)
		move.w	d3,-(a2)
		move.w	d3,-(a2)
		swap	d3
		add.l	d0,d3
		swap	d3
		move.w	d3,(a1)+
		move.w	d3,(a1)+
		move.w	d3,-(a2)
		move.w	d3,-(a2)
		swap	d3
		add.l	d0,d3
		swap	d3
		move.w	d3,(a1)+
		move.w	d3,-(a2)
		swap	d3
		add.l	d0,d3
		swap	d3
		move.w	d3,(a1)+
		move.w	d3,-(a2)
		move.w	(RAM_LevelSys_Buff+$8).w,d0
		neg.w	d0
		move.w	#$19,d1

loc_63E0:				; CODE XREF: ROM:000063E2j
		move.w	d0,(a1)+
		dbf	d1,loc_63E0
		adda.w	#$E,a1
		move.w	d2,d0
		asr.w	#1,d0
		move.w	#$17,d1

loc_63F2:				; CODE XREF: ROM:000063F4j
		move.w	d0,(a1)+
		dbf	d1,loc_63F2
		lea	(RAM_LevelDeform_Buff).w,a2
		move.w	(RAM_LevelSys_Buff+$C).w,d0
		move.w	d0,d2
		andi.w	#$3F0,d0
		lsr.w	#3,d0
		lea	(a2,d0.w),a2
		bra.w	loc_6306
; ===============================================================================

Deform_HTZ:				; DATA XREF: ROM:Deform_Indexo
		move.w	(RAM_LevelSys_Buff+$C).w,(RAM_VDP_VScroll+$2).w
		lea	(RAM_HorScrollBuffer).w,a1
		move.w	(RAM_LevelSys_Buff).w,d0
		neg.w	d0
		move.w	d0,d2
		swap	d0
		move.w	d2,d0
		asr.w	#3,d0
		move.w	#$7F,d1	; ''

loc_642C:				; CODE XREF: ROM:0000642Ej
		move.l	d0,(a1)+
		dbf	d1,loc_642C
		move.l	d0,d4
		move.w	d2,d0
		asr.w	#1,d0
		move.w	d2,d1
		asr.w	#3,d1
		sub.w	d1,d0
		ext.l	d0
		asl.l	#4,d0
		divs.w	#$18,d0
		ext.l	d0
		asl.l	#4,d0
		asl.l	#8,d0
		moveq	#0,d3
		move.w	d2,d3
		asr.w	#3,d3
		swap	d3
		add.l	d0,d3
		swap	d3
		move.w	d3,d4
		move.l	d4,(a1)+
		move.l	d4,(a1)+
		move.l	d4,(a1)+
		swap	d3
		add.l	d0,d3
		swap	d3
		move.w	d3,d4
		move.l	d4,(a1)+
		move.l	d4,(a1)+
		move.l	d4,(a1)+
		move.l	d4,(a1)+
		move.l	d4,(a1)+
		swap	d3
		add.l	d0,d3
		swap	d3
		move.w	d3,d4
		move.w	#6,d1

loc_647E:				; CODE XREF: ROM:00006480j
		move.l	d4,(a1)+
		dbf	d1,loc_647E
		swap	d3
		add.l	d0,d3
		add.l	d0,d3
		swap	d3
		move.w	d3,d4
		move.w	#7,d1

loc_6492:				; CODE XREF: ROM:00006494j
		move.l	d4,(a1)+
		dbf	d1,loc_6492
		swap	d3
		add.l	d0,d3
		add.l	d0,d3
		swap	d3
		move.w	d3,d4
		move.w	#9,d1

loc_64A6:				; CODE XREF: ROM:000064A8j
		move.l	d4,(a1)+
		dbf	d1,loc_64A6
		swap	d3
		add.l	d0,d3
		add.l	d0,d3
		add.l	d0,d3
		swap	d3
		move.w	d3,d4
		move.w	#$E,d1

loc_64BC:				; CODE XREF: ROM:000064BEj
		move.l	d4,(a1)+
		dbf	d1,loc_64BC
		swap	d3
		add.l	d0,d3
		add.l	d0,d3
		add.l	d0,d3
		swap	d3
		move.w	#2,d2

loc_64D0:				; CODE XREF: ROM:000064E8j
		move.w	d3,d4
		move.w	#$F,d1

loc_64D6:				; CODE XREF: ROM:000064D8j
		move.l	d4,(a1)+
		dbf	d1,loc_64D6
		swap	d3
		add.l	d0,d3
		add.l	d0,d3
		add.l	d0,d3
		add.l	d0,d3
		swap	d3
		dbf	d2,loc_64D0
		rts

; =============== S U B R O U T I N E ==========================================


ScrollHorizontal:			; CODE XREF: DeformBGLayer+44p
					; DeformBGLayer+7Ap
		move.w	(a1),d4
		bsr.s	sub_6514
		move.w	(a1),d0
		andi.w	#$10,d0
		move.b	(a2),d1
		eor.b	d1,d0
		bne.s	locret_6512
		eori.b	#$10,(a2)
		move.w	(a1),d0
		sub.w	d4,d0
		bpl.s	loc_650E
		bset	#2,(a3)
		rts
; ===============================================================================

loc_650E:				; CODE XREF: ScrollHorizontal+18j
		bset	#3,(a3)

locret_6512:				; CODE XREF: ScrollHorizontal+Ej
		rts
; End of function ScrollHorizontal


; =============== S U B R O U T I N E ==========================================


sub_6514:				; CODE XREF: ScrollHorizontal+2p
		move.w	(a5),d1
		beq.s	loc_6536
		subi.w	#$100,d1
		move.w	d1,(a5)
		moveq	#0,d1
		move.b	(a5),d1
		lsl.b	#2,d1
		addq.b	#4,d1
		move.w	2(a5),d0
		sub.b	d1,d0
		move.w	(a6,d0.w),d0
		andi.w	#$3FFF,d0
		bra.s	loc_653A
; ===============================================================================

loc_6536:				; CODE XREF: sub_6514+2j
		move.w	8(a0),d0

loc_653A:				; CODE XREF: sub_6514+20j
		sub.w	(a1),d0
		subi.w	#$90,d0	; ''
		blt.s	loc_654C
		subi.w	#$10,d0
		bge.s	loc_6564
		clr.w	(a4)
		rts
; ===============================================================================

loc_654C:				; CODE XREF: sub_6514+2Cj
		cmpi.w	#$FFF0,d0
		bgt.s	loc_6556
		move.w	#$FFF0,d0

loc_6556:				; CODE XREF: sub_6514+3Cj
		add.w	(a1),d0
		cmp.w	(RAM_LevelSys_XPos_SetStart).w,d0
		bgt.s	loc_657A
		move.w	(RAM_LevelSys_XPos_SetStart).w,d0
		bra.s	loc_657A
; ===============================================================================

loc_6564:				; CODE XREF: sub_6514+32j
		cmpi.w	#$10,d0
		bcs.s	loc_656E
		move.w	#$10,d0

loc_656E:				; CODE XREF: sub_6514+54j
		add.w	(a1),d0
		cmp.w	(RAM_LevelSys_XPos_SetEnd).w,d0
		blt.s	loc_657A
		move.w	(RAM_LevelSys_XPos_SetEnd).w,d0

loc_657A:				; CODE XREF: sub_6514+48j sub_6514+4Ej ...
		move.w	d0,d1
		sub.w	(a1),d1
		asl.w	#8,d1
		move.w	d0,(a1)
		move.w	d1,(a4)
		rts
; End of function sub_6514


; =============== S U B R O U T I N E ==========================================


ScrollVertical:
		moveq	#0,d1
		move.w	$C(a0),d0
		sub.w	(a1),d0
		btst	#2,$22(a0)
		beq.s	loc_6598
		subq.w	#5,d0

loc_6598:
		btst	#1,$22(a0)
		beq.s	loc_65B8
		addi.w	#$20,d0
		sub.w	(RAM_LevelSys_ForceToYPos).w,d0
		bcs.s	loc_6602
		subi.w	#$40,d0
		bcc.s	loc_6602
		tst.b	(RAM_LevelSys_Ver_Flag_Unk).w
		bne.s	loc_6614
		bra.s	loc_65C4
; ===============================================================================

loc_65B8:
		sub.w	(RAM_LevelSys_ForceToYPos).w,d0
		bne.s	loc_65C8
		tst.b	(RAM_LevelSys_Ver_Flag_Unk).w
		bne.s	loc_6614

loc_65C4:
		clr.w	(a4)
		rts
; ===============================================================================

loc_65C8:
		cmpi.w	#$60,(RAM_LevelSys_ForceToYPos).w
		bne.s	loc_65F0
		move.w	$14(a0),d1
		bpl.s	loc_65D8
		neg.w	d1

loc_65D8:
		cmpi.w	#$800,d1
		bcc.s	loc_6602
		move.w	#$600,d1
		cmpi.w	#6,d0
		bgt.s	loc_665C
		cmpi.w	#$FFFA,d0
		blt.s	loc_662A
		bra.s	loc_661A
; ===============================================================================

loc_65F0:
		move.w	#$200,d1
		cmpi.w	#2,d0
		bgt.s	loc_665C
		cmpi.w	#$FFFE,d0
		blt.s	loc_662A
		bra.s	loc_661A
; ===============================================================================

loc_6602:
		move.w	#$1000,d1
		cmpi.w	#$10,d0
		bgt.s	loc_665C
		cmpi.w	#$FFF0,d0
		blt.s	loc_662A
		bra.s	loc_661A
; ===============================================================================

loc_6614:
		moveq	#0,d0
		move.b	d0,(RAM_LevelSys_Ver_Flag_Unk).w

loc_661A:
		moveq	#0,d1
		move.w	d0,d1
		add.w	(a1),d1
		tst.w	d0
		bpl.w	loc_6664
		bra.w	loc_6634
; ===============================================================================

loc_662A:
		neg.w	d1
		ext.l	d1
		asl.l	#8,d1
		add.l	(a1),d1
		swap	d1

loc_6634:
		cmp.w	(RAM_LevelSys_YPos_SetStart).w,d1
		bgt.s	loc_6686
		cmpi.w	#$FF00,d1
		bgt.s	loc_6656
		andi.w	#$7FF,d1
		andi.w	#$7FF,$C(a0)
		andi.w	#$7FF,(a1)
		andi.w	#$3FF,8(a1)
		bra.s	loc_6686
; ===============================================================================

loc_6656:
		move.w	(RAM_LevelSys_YPos_SetStart).w,d1
		bra.s	loc_6686
; ===============================================================================

loc_665C:
		ext.l	d1
		asl.l	#8,d1
		add.l	(a1),d1
		swap	d1

loc_6664:
		cmp.w	(RAM_LevelSys_YPos_SetEnd).w,d1
		blt.s	loc_6686
		subi.w	#$800,d1
		bcs.s	loc_6682
		andi.w	#$7FF,$C(a0)
		subi.w	#$800,(a1)
		andi.w	#$3FF,8(a1)
		bra.s	loc_6686
; ===============================================================================

loc_6682:
		move.w	(RAM_LevelSys_YPos_SetEnd).w,d1

loc_6686:
		move.w	(a1),d4
		swap	d1
		move.l	d1,d3
		sub.l	(a1),d3
		ror.l	#8,d3
		move.w	d3,(a4)
		move.l	d1,(a1)
		move.w	(a1),d0
		andi.w	#$10,d0
		move.b	(a2),d1
		eor.b	d1,d0
		bne.s	locret_66B4
		eori.b	#$10,(a2)
		move.w	(a1),d0
		sub.w	d4,d0
		bpl.s	loc_66B0
		bset	#0,(a3)
		rts
; ===============================================================================

loc_66B0:
		bset	#1,(a3)

locret_66B4:
		rts


; =============== S U B R O U T I N E ==========================================


ScrollBlock1:
		move.l	(RAM_LevelSys_Buff+$8).w,d2
		move.l	d2,d0
		add.l	d4,d0
		move.l	d0,(RAM_LevelSys_Buff+$8).w
		move.l	d0,d1
		swap	d1
		andi.w	#$10,d1
		move.b	(RAM_LevelSys_Unk+$2).w,d3
		eor.b	d3,d1
		bne.s	loc_66EA
		eori.b	#$10,(RAM_LevelSys_Unk+$2).w
		sub.l	d2,d0
		bpl.s	loc_66E4
		bset	#2,(RAM_BlockScrollBuff).w
		bra.s	loc_66EA
; ===============================================================================

loc_66E4:
		bset	#3,(RAM_BlockScrollBuff).w

loc_66EA:
		move.l	(RAM_LevelSys_Buff+$C).w,d3
		move.l	d3,d0
		add.l	d5,d0
		move.l	d0,(RAM_LevelSys_Buff+$C).w
		move.l	d0,d1
		swap	d1
		andi.w	#$10,d1
		move.b	(RAM_LevelSys_Unk+$3).w,d2
		eor.b	d2,d1
		bne.s	locret_671E
		eori.b	#$10,(RAM_LevelSys_Unk+$3).w
		sub.l	d3,d0
		bpl.s	loc_6718
		bset	#0,(RAM_BlockScrollBuff).w
		rts
; ===============================================================================

loc_6718:
		bset	#1,(RAM_BlockScrollBuff).w

locret_671E:
		rts


; =============== S U B R O U T I N E ==========================================


ScrollBlock2:
		move.l	(RAM_LevelSys_Buff+$C).w,d3
		move.l	d3,d0
		add.l	d5,d0
		move.l	d0,(RAM_LevelSys_Buff+$C).w
		move.l	d0,d1
		swap	d1
		andi.w	#$10,d1
		move.b	(RAM_LevelSys_Unk+$3).w,d2
		eor.b	d2,d1
		bne.s	locret_6752
		eori.b	#$10,(RAM_LevelSys_Unk+$3).w
		sub.l	d3,d0
		bpl.s	loc_674C
		bset	d6,(RAM_BlockScrollBuff).w
		rts
; ===============================================================================

loc_674C:
		addq.b	#1,d6
		bset	d6,(RAM_BlockScrollBuff).w

locret_6752:
		rts


; ===============================================================================

ScrollBlock3:
		move.w	(RAM_LevelSys_Buff+$C).w,d3
		move.w	d0,(RAM_LevelSys_Buff+$C).w
		move.w	d0,d1
		andi.w	#$10,d1
		move.b	(RAM_LevelSys_Unk+$3).w,d2
		eor.b	d2,d1
		bne.s	locret_6782
		eori.b	#$10,(RAM_LevelSys_Unk+$3).w
		sub.w	d3,d0
		bpl.s	loc_677C
		bset	#0,(RAM_BlockScrollBuff).w
		rts
; ===============================================================================

loc_677C:
		bset	#1,(RAM_BlockScrollBuff).w

locret_6782:
		rts

; =============== S U B R O U T I N E ==========================================


ScrollBlock4:
		move.l	(RAM_LevelSys_Buff+$8).w,d2
		move.l	d2,d0
		add.l	d4,d0
		move.l	d0,(RAM_LevelSys_Buff+$8).w
		move.l	d0,d1
		swap	d1
		andi.w	#$10,d1
		move.b	(RAM_LevelSys_Unk+$2).w,d3
		eor.b	d3,d1
		bne.s	locret_67B6
		eori.b	#$10,(RAM_LevelSys_Unk+$2).w
		sub.l	d2,d0
		bpl.s	loc_67B0
		bset	d6,(RAM_BlockScrollBuff).w
		bra.s	locret_67B6
; ===============================================================================

loc_67B0:
		addq.b	#1,d6
		bset	d6,(RAM_BlockScrollBuff).w

locret_67B6:
		rts


; =============== S U B R O U T I N E ==========================================


ScrollBlock5:
		move.l	(RAM_LevelSys_Buff+$10).w,d2
		move.l	d2,d0
		add.l	d4,d0
		move.l	d0,(RAM_LevelSys_Buff+$10).w
		move.l	d0,d1
		swap	d1
		andi.w	#$10,d1
		move.b	(RAM_LevelSys_Unk+$4).w,d3
		eor.b	d3,d1
		bne.s	locret_67EA
		eori.b	#$10,(RAM_LevelSys_Unk+$4).w
		sub.l	d2,d0
		bpl.s	loc_67E4
		bset	d6,(RAM_BlockScrollBuff+$2).w
		bra.s	locret_67EA
; ===============================================================================

loc_67E4:
		addq.b	#1,d6
		bset	d6,(RAM_BlockScrollBuff+$2).w

locret_67EA:
		rts


; =============== S U B R O U T I N E ==========================================


ScrollBlock6:
		move.l	(RAM_LevelSys_Buff+$18).w,d2
		move.l	d2,d0
		add.l	d4,d0
		move.l	d0,(RAM_LevelSys_Buff+$18).w
		move.l	d0,d1
		swap	d1
		andi.w	#$10,d1
		move.b	(RAM_LevelSys_Unk+$6).w,d3
		eor.b	d3,d1
		bne.s	locret_681E
		eori.b	#$10,(RAM_LevelSys_Unk+$6).w
		sub.l	d2,d0
		bpl.s	loc_6818
		bset	d6,(RAM_BlockScrollBuff+$4).w
		bra.s	locret_681E
; ===============================================================================

loc_6818:
		addq.b	#1,d6
		bset	d6,(RAM_BlockScrollBuff+$4).w

locret_681E:
		rts

; ===============================================================================
		lea	($C00004).l,a5
		lea	($C00000).l,a6
		lea	(RAM_BlockScrollBuff).w,a2
		lea	(RAM_LevelSys_Buff+$8).w,a3
		lea	(RAM_LevelLayout+$80).w,a4
		move.w	#$6000,d2
		bsr.w	sub_69B2
		lea	(RAM_BlockScrollBuff+$2).w,a2
		lea	(RAM_LevelSys_Buff+$10).w,a3
		bra.w	sub_6A82

; =============== S U B R O U T I N E ==========================================


LoadTilesAsYouMove:
		lea	($C00004).l,a5
		lea	($C00000).l,a6

		lea	(RAM_LevelDrawBuff).w,a2
		lea	(RAM_LevelSys_ReturnVal).w,a3
		lea	(RAM_LevelLayout+$80).w,a4
		move.w	#$6000,d2
		bsr.w	sub_69B2

		lea	(RAM_LevelDrawBuff+$2).w,a2
		lea	(RAM_LevelSys_ReturnVal+$8).w,a3
		bsr.w	sub_6A82

		lea	(RAM_LevelDrawBuff+$4).w,a2
		lea	(RAM_LevelSys_ReturnVal+$10).w,a3
		bsr.w	sub_6B7C

		tst.w	(RAM_Flag_SplitScreen).w
		beq.s	loc_689E

		lea	(RAM_LevelDrawBuff+$6).w,a2
		lea	(RAM_LevelSys_Buff_2P_Backup).w,a3
		lea	(RAM_LevelLayout).w,a4
		move.w	#$6000,d2
		bsr.w	sub_694C

loc_689E:
		lea	(RAM_LevelSys_DirToDraw_Backup).w,a2
		lea	(RAM_LevelSys_Buff_Backup).w,a3
		lea	(RAM_LevelLayout).w,a4
		move.w	#$4000,d2

		tst.b	(RAM_Flag_Level_ForceReload).w
		beq.s	loc_68E6
		move.b	#0,(RAM_Flag_Level_ForceReload).w

		moveq	#$FFFFFFF0,d4
		moveq	#$F,d6

loc_68BE:
		movem.l	d4-d6,-(sp)
		moveq	#$FFFFFFF0,d5
		move.w	d4,d1
		bsr.w	sub_7084
		move.w	d1,d4
		moveq	#$FFFFFFF0,d5
		bsr.w	sub_6D8C
		movem.l	(sp)+,d4-d6
		addi.w	#$10,d4
		dbf	d6,loc_68BE
		move.b	#0,(RAM_LevelSys_DirToDraw_Backup).w
		rts

; ===============================================================================

loc_68E6:
		tst.b	(a2)
		beq.s	locret_694A
		bclr	#0,(a2)
		beq.s	loc_6900
		moveq	#$FFFFFFF0,d4
		moveq	#$FFFFFFF0,d5
		bsr.w	sub_7084
		moveq	#$FFFFFFF0,d4
		moveq	#$FFFFFFF0,d5
		bsr.w	sub_6D8C

loc_6900:
		bclr	#1,(a2)
		beq.s	loc_691A
		move.w	#$E0,d4	; ''
		moveq	#$FFFFFFF0,d5
		bsr.w	sub_7084
		move.w	#$E0,d4	; ''
		moveq	#$FFFFFFF0,d5
		bsr.w	sub_6D8C

loc_691A:				; CODE XREF: LoadTilesAsYouMove+B8j
		bclr	#2,(a2)
		beq.s	loc_6930
		moveq	#$FFFFFFF0,d4
		moveq	#$FFFFFFF0,d5
		bsr.w	sub_7084
		moveq	#$FFFFFFF0,d4
		moveq	#$FFFFFFF0,d5
		bsr.w	sub_6CFE

loc_6930:				; CODE XREF: LoadTilesAsYouMove+D2j
		bclr	#3,(a2)
		beq.s	locret_694A
		moveq	#$FFFFFFF0,d4
		move.w	#$140,d5
		bsr.w	sub_7084
		moveq	#$FFFFFFF0,d4
		move.w	#$140,d5
		bsr.w	sub_6CFE

locret_694A:				; CODE XREF: LoadTilesAsYouMove+9Cj
					; LoadTilesAsYouMove+E8j
		rts
; End of function LoadTilesAsYouMove


; =============== S U B R O U T I N E ==========================================


sub_694C:				; CODE XREF: LoadTilesAsYouMove+4Ep
		tst.b	(a2)
		beq.s	locret_69B0
		bclr	#0,(a2)
		beq.s	loc_6966
		moveq	#$FFFFFFF0,d4
		moveq	#$FFFFFFF0,d5
		bsr.w	sub_70C0
		moveq	#$FFFFFFF0,d4
		moveq	#$FFFFFFF0,d5
		bsr.w	sub_6D8C

loc_6966:				; CODE XREF: sub_694C+8j
		bclr	#1,(a2)
		beq.s	loc_6980
		move.w	#$E0,d4	; ''
		moveq	#$FFFFFFF0,d5
		bsr.w	sub_70C0
		move.w	#$E0,d4	; ''
		moveq	#$FFFFFFF0,d5
		bsr.w	sub_6D8C

loc_6980:				; CODE XREF: sub_694C+1Ej
		bclr	#2,(a2)
		beq.s	loc_6996
		moveq	#$FFFFFFF0,d4
		moveq	#$FFFFFFF0,d5
		bsr.w	sub_70C0
		moveq	#$FFFFFFF0,d4
		moveq	#$FFFFFFF0,d5
		bsr.w	sub_6CFE

loc_6996:				; CODE XREF: sub_694C+38j
		bclr	#3,(a2)
		beq.s	locret_69B0
		moveq	#$FFFFFFF0,d4
		move.w	#$140,d5
		bsr.w	sub_70C0
		moveq	#$FFFFFFF0,d4
		move.w	#$140,d5
		bsr.w	sub_6CFE

locret_69B0:				; CODE XREF: sub_694C+2j sub_694C+4Ej
		rts
; End of function sub_694C


; =============== S U B R O U T I N E ==========================================


sub_69B2:
		tst.b	(a2)
		beq.w	locret_6A80
		bclr	#0,(a2)
		beq.s	loc_69CE
		moveq	#$FFFFFFF0,d4
		moveq	#$FFFFFFF0,d5
		bsr.w	sub_7084
		moveq	#$FFFFFFF0,d4
		moveq	#$FFFFFFF0,d5
		bsr.w	sub_6D8C

loc_69CE:				; CODE XREF: sub_69B2+Aj
		bclr	#1,(a2)
		beq.s	loc_69E8
		move.w	#$E0,d4	; ''
		moveq	#$FFFFFFF0,d5
		bsr.w	sub_7084
		move.w	#$E0,d4	; ''
		moveq	#$FFFFFFF0,d5
		bsr.w	sub_6D8C

loc_69E8:				; CODE XREF: sub_69B2+20j
		bclr	#2,(a2)
		beq.s	loc_69FE
		moveq	#$FFFFFFF0,d4
		moveq	#$FFFFFFF0,d5
		bsr.w	sub_7084
		moveq	#$FFFFFFF0,d4
		moveq	#$FFFFFFF0,d5
		bsr.w	sub_6CFE

loc_69FE:				; CODE XREF: sub_69B2+3Aj
		bclr	#3,(a2)
		beq.s	loc_6A18
		moveq	#$FFFFFFF0,d4
		move.w	#$140,d5
		bsr.w	sub_7084
		moveq	#$FFFFFFF0,d4
		move.w	#$140,d5
		bsr.w	sub_6CFE

loc_6A18:				; CODE XREF: sub_69B2+50j
		bclr	#4,(a2)
		beq.s	loc_6A30
		moveq	#$FFFFFFF0,d4
		moveq	#0,d5
		bsr.w	sub_7086
		moveq	#$FFFFFFF0,d4
		moveq	#0,d5
		moveq	#$1F,d6
		bsr.w	Level_DrawTiles_Upd_Ver

loc_6A30:				; CODE XREF: sub_69B2+6Aj
		bclr	#5,(a2)
		beq.s	loc_6A4C
		move.w	#$E0,d4	; ''
		moveq	#0,d5
		bsr.w	sub_7086
		move.w	#$E0,d4	; ''
		moveq	#0,d5
		moveq	#$1F,d6
		bsr.w	Level_DrawTiles_Upd_Ver

loc_6A4C:				; CODE XREF: sub_69B2+82j
		bclr	#6,(a2)
		beq.s	loc_6A64
		moveq	#$FFFFFFF0,d4
		moveq	#$FFFFFFF0,d5
		bsr.w	sub_7084
		moveq	#$FFFFFFF0,d4
		moveq	#$FFFFFFF0,d5
		moveq	#$1F,d6
		bsr.w	sub_6D84

loc_6A64:				; CODE XREF: sub_69B2+9Ej
		bclr	#7,(a2)
		beq.s	locret_6A80
		move.w	#$E0,d4	; ''
		moveq	#$FFFFFFF0,d5
		bsr.w	sub_7084
		move.w	#$E0,d4	; ''
		moveq	#$FFFFFFF0,d5
		moveq	#$1F,d6
		bsr.w	sub_6D84

locret_6A80:				; CODE XREF: sub_69B2+2j sub_69B2+B6j
		rts
; End of function sub_69B2


; =============== S U B R O U T I N E ==========================================


sub_6A82:
		tst.b	(a2)
		beq.w	locret_6ACE
		cmpi.b	#5,(RAM_Level_CurrentZone).w
		beq.w	loc_6AF2
		bclr	#0,(a2)
		beq.s	loc_6AAE
		move.w	#$70,d4
		moveq	#$FFFFFFF0,d5
		bsr.w	sub_7084
		move.w	#$70,d4
		moveq	#$FFFFFFF0,d5
		moveq	#2,d6
		bsr.w	sub_6D00

loc_6AAE:
		bclr	#1,(a2)
		beq.s	locret_6ACE
		move.w	#$70,d4
		move.w	#$140,d5
		bsr.w	sub_7084
		move.w	#$70,d4
		move.w	#$140,d5
		moveq	#2,d6
		bsr.w	sub_6D00

locret_6ACE:
		rts
; ===============================================================================
byte_6AD0:	dc.b 0
byte_6AD1:	dc.b   0,  0,  0,  0,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  4,  4; 0
		dc.b   4,  4,  4,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2; 16
		dc.b 0
; ===============================================================================

loc_6AF2:				; CODE XREF: sub_6A82+Cj
		moveq	#$FFFFFFF0,d4
		bclr	#0,(a2)
		bne.s	loc_6B04
		bclr	#1,(a2)
		beq.s	loc_6B4C
		move.w	#$E0,d4	; ''

loc_6B04:				; CODE XREF: sub_6A82+76j
		lea	byte_6AD1(pc),a0
		move.w	(RAM_LevelSys_Buff+$C).w,d0
		add.w	d4,d0
		andi.w	#$1F0,d0
		lsr.w	#4,d0
		move.b	(a0,d0.w),d0
		lea	(word_6C78).l,a3
		movea.w	(a3,d0.w),a3
		beq.s	loc_6B38
		moveq	#$FFFFFFF0,d5
		movem.l	d4-d5,-(sp)
		bsr.w	sub_7084
		movem.l	(sp)+,d4-d5
		bsr.w	sub_6D8C
		bra.s	loc_6B4C
; ===============================================================================

loc_6B38:				; CODE XREF: sub_6A82+A0j
		moveq	#0,d5
		movem.l	d4-d5,-(sp)
		bsr.w	sub_7086
		movem.l	(sp)+,d4-d5
		moveq	#$1F,d6
		bsr.w	Level_DrawTiles_Upd_Ver

loc_6B4C:				; CODE XREF: sub_6A82+7Cj sub_6A82+B4j
		tst.b	(a2)
		bne.s	loc_6B52
		rts
; ===============================================================================

loc_6B52:				; CODE XREF: sub_6A82+CCj
		moveq	#$FFFFFFF0,d4
		moveq	#$FFFFFFF0,d5
		move.b	(a2),d0
		andi.b	#$A8,d0
		beq.s	loc_6B66
		lsr.b	#1,d0
		move.b	d0,(a2)
		move.w	#$140,d5

loc_6B66:				; CODE XREF: sub_6A82+DAj
		lea	byte_6AD0(pc),a0
		move.w	(RAM_LevelSys_Buff+$C).w,d0
		andi.w	#$1F0,d0
		lsr.w	#4,d0
		lea	(a0,d0.w),a0
		bra.w	loc_6C80
; End of function sub_6A82


; =============== S U B R O U T I N E ==========================================


sub_6B7C:				; CODE XREF: LoadTilesAsYouMove+34p
		tst.b	(a2)
		beq.w	locret_6BC8
		cmpi.b	#2,(RAM_Level_CurrentZone).w
		beq.w	loc_6C0C
		bclr	#0,(a2)
		beq.s	loc_6BA8
		move.w	#$40,d4	; '@'
		moveq	#$FFFFFFF0,d5
		bsr.w	sub_7084
		move.w	#$40,d4	; '@'
		moveq	#$FFFFFFF0,d5
		moveq	#2,d6
		bsr.w	sub_6D00

loc_6BA8:				; CODE XREF: sub_6B7C+14j
		bclr	#1,(a2)
		beq.s	locret_6BC8
		move.w	#$40,d4	; '@'
		move.w	#$140,d5
		bsr.w	sub_7084
		move.w	#$40,d4	; '@'
		move.w	#$140,d5
		moveq	#2,d6
		bsr.w	sub_6D00

locret_6BC8:				; CODE XREF: sub_6B7C+2j sub_6B7C+30j
		rts
; ===============================================================================
byte_6BCA:	dc.b 0
byte_6BCB:	dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4
		dc.b   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4
		dc.b   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4
		dc.b 0
; ===============================================================================

loc_6C0C:
		moveq	#$FFFFFFF0,d4
		bclr	#0,(a2)
		bne.s	loc_6C1E
		bclr	#1,(a2)
		beq.s	loc_6C48
		move.w	#$E0,d4

loc_6C1E:
		lea	byte_6BCB(pc),a0
		move.w	(RAM_LevelSys_Buff+$C).w,d0
		add.w	d4,d0
		andi.w	#$3F0,d0
		lsr.w	#4,d0
		move.b	(a0,d0.w),d0
		movea.w	word_6C78(pc,d0.w),a3
		moveq	#$FFFFFFF0,d5
		movem.l	d4-d5,-(sp)
		bsr.w	sub_7084
		movem.l	(sp)+,d4-d5
		bsr.w	sub_6D8C

loc_6C48:
		tst.b	(a2)
		bne.s	loc_6C4E
		rts
; ===============================================================================

loc_6C4E:				; CODE XREF: sub_6B7C+CEj
		moveq	#$FFFFFFF0,d4
		moveq	#$FFFFFFF0,d5
		move.b	(a2),d0
		andi.b	#$A8,d0
		beq.s	loc_6C62
		lsr.b	#1,d0
		move.b	d0,(a2)
		move.w	#$140,d5

loc_6C62:				; CODE XREF: sub_6B7C+DCj
		lea	byte_6BCA(pc),a0
		move.w	(RAM_LevelSys_Buff+$C).w,d0
		andi.w	#$7F0,d0
		lsr.w	#4,d0
		lea	(a0,d0.w),a0
		bra.w	loc_6C80
; ===============================================================================
word_6C78:	dc.w $EE68,$EE68,$EE70,$EE78; 0	; DATA XREF: sub_6A82+96o
; ===============================================================================

loc_6C80:				; CODE XREF: sub_6A82+F6j sub_6B7C+F8j
		tst.w	(RAM_Flag_SplitScreen).w
		bne.s	loc_6CC2
		moveq	#$F,d6
		move.l	#$800000,d7

loc_6C8E:				; CODE XREF: sub_6B7C+13Ej
		moveq	#0,d0
		move.b	(a0)+,d0
		btst	d0,(a2)
		beq.s	loc_6CB6
		movea.w	word_6C78(pc,d0.w),a3
		movem.l	d4-d5/a0,-(sp)
		movem.l	d4-d5,-(sp)
		bsr.w	sub_7040
		movem.l	(sp)+,d4-d5
		bsr.w	sub_7084
		bsr.w	sub_6F70
		movem.l	(sp)+,d4-d5/a0

loc_6CB6:				; CODE XREF: sub_6B7C+118j
		addi.w	#$10,d4
		dbf	d6,loc_6C8E
		clr.b	(a2)
		rts
; ===============================================================================

loc_6CC2:				; CODE XREF: sub_6B7C+108j
		moveq	#$F,d6
		move.l	#$800000,d7

loc_6CCA:				; CODE XREF: sub_6B7C+17Aj
		moveq	#0,d0
		move.b	(a0)+,d0
		btst	d0,(a2)
		beq.s	loc_6CF2
		movea.w	word_6C78(pc,d0.w),a3
		movem.l	d4-d5/a0,-(sp)
		movem.l	d4-d5,-(sp)
		bsr.w	sub_7040
		movem.l	(sp)+,d4-d5
		bsr.w	sub_7084
		bsr.w	sub_6FF6
		movem.l	(sp)+,d4-d5/a0

loc_6CF2:				; CODE XREF: sub_6B7C+154j
		addi.w	#$10,d4
		dbf	d6,loc_6CCA
		clr.b	(a2)
		rts
; End of function sub_6B7C


; =============== S U B R O U T I N E ==========================================


sub_6CFE:				; CODE XREF: LoadTilesAsYouMove+E0p
					; LoadTilesAsYouMove+FAp ...
		moveq	#$F,d6
; End of function sub_6CFE


; =============== S U B R O U T I N E ==========================================


sub_6D00:				; CODE XREF: sub_6A82+28p sub_6A82+48p ...
		add.w	(a3),d5
		add.w	4(a3),d4
		move.l	#$800000,d7
		move.l	d0,d1
		bsr.w	sub_6E98
		tst.w	(RAM_Flag_SplitScreen).w
		bne.s	loc_6D4E

loc_6D18:				; CODE XREF: sub_6D00:loc_6D48j
		move.w	(a0),d3
		andi.w	#$3FF,d3
		lsl.w	#3,d3
		lea	(RAM_Level_Data_16).w,a1
		adda.w	d3,a1
		move.l	d1,d0
		bsr.w	sub_6F70
		adda.w	#$10,a0
		addi.w	#$100,d1
		andi.w	#$FFF,d1
		addi.w	#$10,d4
		move.w	d4,d0
		andi.w	#$70,d0	; 'p'
		bne.s	loc_6D48
		bsr.w	sub_6E98

loc_6D48:				; CODE XREF: sub_6D00+42j
		dbf	d6,loc_6D18
		rts
; ===============================================================================

loc_6D4E:				; CODE XREF: sub_6D00+16j
					; sub_6D00:loc_6D7Ej
		move.w	(a0),d3
		andi.w	#$3FF,d3
		lsl.w	#3,d3
		lea	(RAM_Level_Data_16).w,a1
		adda.w	d3,a1
		move.l	d1,d0
		bsr.w	sub_6FF6
		adda.w	#$10,a0
		addi.w	#$80,d1	; ''
		andi.w	#$FFF,d1
		addi.w	#$10,d4
		move.w	d4,d0
		andi.w	#$70,d0	; 'p'
		bne.s	loc_6D7E
		bsr.w	sub_6E98

loc_6D7E:				; CODE XREF: sub_6D00+78j
		dbf	d6,loc_6D4E
		rts
; End of function sub_6D00


; =============== S U B R O U T I N E ==========================================


sub_6D84:				; CODE XREF: sub_69B2+AEp sub_69B2+CAp ...
		add.w	(a3),d5
		add.w	4(a3),d4
		bra.s	loc_6D94
; End of function sub_6D84


; =============== S U B R O U T I N E ==========================================


sub_6D8C:
		moveq	#$15,d6
		add.w	(a3),d5
; End of function sub_6D8C


; =============== S U B R O U T I N E ==========================================


Level_DrawTiles_Upd_Ver:
		add.w	4(a3),d4

loc_6D94:
		tst.w	(RAM_Flag_SplitScreen).w
		bne.s	loc_6E12
		move.l	a2,-(sp)
		move.w	d6,-(sp)
		lea	(RAM_LevelSys_VerUpdBuff).w,a2
		move.l	d0,d1
		or.w	d2,d1
		swap	d1
		move.l	d1,-(sp)
		move.l	d1,(a5)
		swap	d1
		bsr.w	sub_6E98

loc_6DB2:				; CODE XREF: Level_DrawTiles_Upd_Ver:loc_6DE4j
		move.w	(a0),d3
		andi.w	#$3FF,d3
		lsl.w	#3,d3
		lea	(RAM_Level_Data_16).w,a1
		adda.w	d3,a1
		bsr.w	sub_6ED0
		addq.w	#2,a0
		addq.b	#4,d1
		bpl.s	loc_6DD4
		andi.b	#$7F,d1	; ''
		swap	d1
		move.l	d1,(a5)
		swap	d1

loc_6DD4:				; CODE XREF: Level_DrawTiles_Upd_Ver+38j
		addi.w	#$10,d5
		move.w	d5,d0
		andi.w	#$70,d0	; 'p'
		bne.s	loc_6DE4
		bsr.w	sub_6E98

loc_6DE4:				; CODE XREF: Level_DrawTiles_Upd_Ver+4Ej
		dbf	d6,loc_6DB2
		move.l	(sp)+,d1
		addi.l	#$800000,d1
		lea	(RAM_LevelSys_VerUpdBuff).w,a2
		move.l	d1,(a5)
		swap	d1
		move.w	(sp)+,d6

loc_6DFA:				; CODE XREF: Level_DrawTiles_Upd_Ver:loc_6E0Aj
		move.l	(a2)+,(a6)
		addq.b	#4,d1
		bmi.s	loc_6E0A
		ori.b	#$80,d1
		swap	d1
		move.l	d1,(a5)
		swap	d1

loc_6E0A:				; CODE XREF: Level_DrawTiles_Upd_Ver+6Ej
		dbf	d6,loc_6DFA
		movea.l	(sp)+,a2
		rts
; ===============================================================================

loc_6E12:				; CODE XREF: Level_DrawTiles_Upd_Ver+8j
		move.l	d0,d1
		or.w	d2,d1
		swap	d1
		move.l	d1,(a5)
		swap	d1
		tst.b	d1
		bmi.s	loc_6E5C
		bsr.w	sub_6E98

loc_6E24:				; CODE XREF: Level_DrawTiles_Upd_Ver:loc_6E56j
		move.w	(a0),d3
		andi.w	#$3FF,d3
		lsl.w	#3,d3
		lea	(RAM_Level_Data_16).w,a1
		adda.w	d3,a1
		bsr.w	sub_6F32
		addq.w	#2,a0
		addq.b	#4,d1
		bpl.s	loc_6E46
		andi.b	#$7F,d1	; ''
		swap	d1
		move.l	d1,(a5)
		swap	d1

loc_6E46:				; CODE XREF: Level_DrawTiles_Upd_Ver+AAj
		addi.w	#$10,d5
		move.w	d5,d0
		andi.w	#$70,d0	; 'p'
		bne.s	loc_6E56
		bsr.w	sub_6E98

loc_6E56:				; CODE XREF: Level_DrawTiles_Upd_Ver+C0j
		dbf	d6,loc_6E24
		rts
; ===============================================================================

loc_6E5C:				; CODE XREF: Level_DrawTiles_Upd_Ver+8Ej
		bsr.w	sub_6E98

loc_6E60:				; CODE XREF: Level_DrawTiles_Upd_Ver:loc_6E92j
		move.w	(a0),d3
		andi.w	#$3FF,d3
		lsl.w	#3,d3
		lea	(RAM_Level_Data_16).w,a1
		adda.w	d3,a1
		bsr.w	sub_6F32
		addq.w	#2,a0
		addq.b	#4,d1
		bmi.s	loc_6E82
		ori.b	#$80,d1
		swap	d1
		move.l	d1,(a5)
		swap	d1

loc_6E82:				; CODE XREF: Level_DrawTiles_Upd_Ver+E6j
		addi.w	#$10,d5
		move.w	d5,d0
		andi.w	#$70,d0	; 'p'
		bne.s	loc_6E92
		bsr.w	sub_6E98

loc_6E92:				; CODE XREF: Level_DrawTiles_Upd_Ver+FCj
		dbf	d6,loc_6E60
		rts
; End of function Level_DrawTiles_Upd_Ver


; =============== S U B R O U T I N E ==========================================


sub_6E98:				; CODE XREF: sub_6D00+Ep sub_6D00+44p	...
		movem.l	d4-d5,-(sp)
		move.w	d4,d3
		add.w	d3,d3
		andi.w	#$F00,d3
		lsr.w	#3,d5
		move.w	d5,d0
		lsr.w	#4,d0
		andi.w	#$7F,d0	; ''
		add.w	d3,d0
		moveq	#$FFFFFFFF,d3
		move.b	(a4,d0.w),d3
		andi.w	#$FF,d3
		lsl.w	#7,d3
		andi.w	#$70,d4	; 'p'
		andi.w	#$E,d5
		add.w	d4,d3
		add.w	d5,d3
		movea.l	d3,a0
		movem.l	(sp)+,d4-d5
		rts
; End of function sub_6E98


; =============== S U B R O U T I N E ==========================================


sub_6ED0:				; CODE XREF: Level_DrawTiles_Upd_Ver+30p
		btst	#3,(a0)
		bne.s	loc_6EFC
		btst	#2,(a0)
		bne.s	loc_6EE2
		move.l	(a1)+,(a6)
		move.l	(a1)+,(a2)+
		rts
; ===============================================================================

loc_6EE2:				; CODE XREF: sub_6ED0+Aj
		move.l	(a1)+,d3
		eori.l	#$8000800,d3
		swap	d3
		move.l	d3,(a6)
		move.l	(a1)+,d3
		eori.l	#$8000800,d3
		swap	d3
		move.l	d3,(a2)+
		rts
; ===============================================================================

loc_6EFC:				; CODE XREF: sub_6ED0+4j
		btst	#2,(a0)
		bne.s	loc_6F18
		move.l	(a1)+,d0
		move.l	(a1)+,d3
		eori.l	#$10001000,d3
		move.l	d3,(a6)
		eori.l	#$10001000,d0
		move.l	d0,(a2)+
		rts
; ===============================================================================

loc_6F18:				; CODE XREF: sub_6ED0+30j
		move.l	(a1)+,d0
		move.l	(a1)+,d3
		eori.l	#$18001800,d3
		swap	d3
		move.l	d3,(a6)
		eori.l	#$18001800,d0
		swap	d0
		move.l	d0,(a2)+
		rts
; End of function sub_6ED0


; =============== S U B R O U T I N E ==========================================


sub_6F32:				; CODE XREF: Level_DrawTiles_Upd_Ver+A2p Level_DrawTiles_Upd_Ver+DEp
		btst	#3,(a0)
		bne.s	loc_6F50
		btst	#2,(a0)
		bne.s	loc_6F42
		move.l	(a1)+,(a6)
		rts
; ===============================================================================

loc_6F42:				; CODE XREF: sub_6F32+Aj
		move.l	(a1)+,d3
		eori.l	#$8000800,d3
		swap	d3
		move.l	d3,(a6)
		rts
; ===============================================================================

loc_6F50:				; CODE XREF: sub_6F32+4j
		btst	#2,(a0)
		bne.s	loc_6F62
		move.l	(a1)+,d3
		eori.l	#$10001000,d3
		move.l	d3,(a6)
		rts
; ===============================================================================

loc_6F62:				; CODE XREF: sub_6F32+22j
		move.l	(a1)+,d3
		eori.l	#$18001800,d3
		swap	d3
		move.l	d3,(a6)
		rts
; End of function sub_6F32


; =============== S U B R O U T I N E ==========================================


sub_6F70:				; CODE XREF: sub_6B7C+132p
					; sub_6D00+28p
		or.w	d2,d0
		swap	d0
		btst	#3,(a0)
		bne.s	loc_6FAC
		btst	#2,(a0)
		bne.s	loc_6F8C
		move.l	d0,(a5)
		move.l	(a1)+,(a6)
		add.l	d7,d0
		move.l	d0,(a5)
		move.l	(a1)+,(a6)
		rts
; ===============================================================================

loc_6F8C:				; CODE XREF: sub_6F70+Ej
		move.l	d0,(a5)
		move.l	(a1)+,d3
		eori.l	#$8000800,d3
		swap	d3
		move.l	d3,(a6)
		add.l	d7,d0
		move.l	d0,(a5)
		move.l	(a1)+,d3
		eori.l	#$8000800,d3
		swap	d3
		move.l	d3,(a6)
		rts
; ===============================================================================

loc_6FAC:				; CODE XREF: sub_6F70+8j
		btst	#2,(a0)
		bne.s	loc_6FD2
		move.l	d5,-(sp)
		move.l	d0,(a5)
		move.l	(a1)+,d5
		move.l	(a1)+,d3
		eori.l	#$10001000,d3
		move.l	d3,(a6)
		add.l	d7,d0
		move.l	d0,(a5)
		eori.l	#$10001000,d5
		move.l	d5,(a6)
		move.l	(sp)+,d5
		rts
; ===============================================================================

loc_6FD2:				; CODE XREF: sub_6F70+40j
		move.l	d5,-(sp)
		move.l	d0,(a5)
		move.l	(a1)+,d5
		move.l	(a1)+,d3
		eori.l	#$18001800,d3
		swap	d3
		move.l	d3,(a6)
		add.l	d7,d0
		move.l	d0,(a5)
		eori.l	#$18001800,d5
		swap	d5
		move.l	d5,(a6)
		move.l	(sp)+,d5
		rts
; End of function sub_6F70


; =============== S U B R O U T I N E ==========================================


sub_6FF6:				; CODE XREF: sub_6B7C+16Ep
					; sub_6D00+5Ep
		or.w	d2,d0
		swap	d0
		btst	#3,(a0)
		bne.s	loc_701C
		btst	#2,(a0)
		bne.s	loc_700C
		move.l	d0,(a5)
		move.l	(a1)+,(a6)
		rts
; ===============================================================================

loc_700C:				; CODE XREF: sub_6FF6+Ej
		move.l	d0,(a5)
		move.l	(a1)+,d3
		eori.l	#$8000800,d3
		swap	d3
		move.l	d3,(a6)
		rts
; ===============================================================================

loc_701C:				; CODE XREF: sub_6FF6+8j
		btst	#2,(a0)
		bne.s	loc_7030
		move.l	d0,(a5)
		move.l	(a1)+,d3
		eori.l	#$10001000,d3
		move.l	d3,(a6)
		rts
; ===============================================================================

loc_7030:				; CODE XREF: sub_6FF6+2Aj
		move.l	d0,(a5)
		move.l	(a1)+,d3
		eori.l	#$18001800,d3
		swap	d3
		move.l	d3,(a6)
		rts
; End of function sub_6FF6


; =============== S U B R O U T I N E ==========================================


sub_7040:				; CODE XREF: sub_6B7C+126p
					; sub_6B7C+162p
		add.w	(a3),d5
		add.w	4(a3),d4
		lea	(RAM_Level_Data_16).w,a1
		move.w	d4,d3
		add.w	d3,d3
		andi.w	#$F00,d3
		lsr.w	#3,d5
		move.w	d5,d0
		lsr.w	#4,d0
		andi.w	#$7F,d0	; ''
		add.w	d3,d0
		moveq	#$FFFFFFFF,d3
		move.b	(a4,d0.w),d3
		andi.w	#$FF,d3
		lsl.w	#7,d3
		andi.w	#$70,d4	; 'p'
		andi.w	#$E,d5
		add.w	d4,d3
		add.w	d5,d3
		movea.l	d3,a0
		move.w	(a0),d3
		andi.w	#$3FF,d3
		lsl.w	#3,d3
		adda.w	d3,a1
		rts
; End of function sub_7040


; =============== S U B R O U T I N E ==========================================


sub_7084:				; CODE XREF: LoadTilesAsYouMove+7Ap
					; LoadTilesAsYouMove+A8p ...
		add.w	(a3),d5
; End of function sub_7084


; =============== S U B R O U T I N E ==========================================


sub_7086:				; CODE XREF: sub_69B2+70p sub_69B2+8Ap ...
		tst.w	(RAM_Flag_SplitScreen).w
		bne.s	loc_70A6
		add.w	4(a3),d4
		andi.w	#$F0,d4	; ''
		andi.w	#$1F0,d5
		lsl.w	#4,d4
		lsr.w	#2,d5
		add.w	d5,d4
		moveq	#3,d0
		swap	d0
		move.w	d4,d0
		rts
; ===============================================================================

loc_70A6:				; CODE XREF: sub_7086+4j
		add.w	4(a3),d4
		andi.w	#$1F0,d4
		andi.w	#$1F0,d5
		lsl.w	#3,d4
		lsr.w	#2,d5
		add.w	d5,d4
		moveq	#3,d0
		swap	d0
		move.w	d4,d0
		rts
; End of function sub_7086


; =============== S U B R O U T I N E ==========================================


sub_70C0:				; CODE XREF: sub_694C+Ep sub_694C+26p	...
		tst.w	(RAM_Flag_SplitScreen).w
		bne.s	loc_70E2
		add.w	4(a3),d4
		add.w	(a3),d5
		andi.w	#$F0,d4	; ''
		andi.w	#$1F0,d5
		lsl.w	#4,d4
		lsr.w	#2,d5
		add.w	d5,d4
		moveq	#2,d0
		swap	d0
		move.w	d4,d0
		rts
; ===============================================================================

loc_70E2:				; CODE XREF: sub_70C0+4j
		add.w	4(a3),d4
		add.w	(a3),d5
		andi.w	#$1F0,d4
		andi.w	#$1F0,d5
		lsl.w	#3,d4
		lsr.w	#2,d5
		add.w	d5,d4
		moveq	#2,d0
		swap	d0
		move.w	d4,d0
		rts
; End of function sub_70C0


; =============== S U B R O U T I N E ==========================================


LoadTilesFromStart:
		lea	($C00004).l,a5
		lea	($C00000).l,a6
		tst.w	(RAM_Flag_SplitScreen).w
		beq.s	loc_711E
		lea	(RAM_LevelSys_Buff_2P).w,a3
		lea	(RAM_LevelLayout).w,a4
		move.w	#$6000,d2
		bsr.s	LoadTilesFromStart_2p

loc_711E:
		lea	(RAM_LevelSys_Buff).w,a3
		lea	(RAM_LevelLayout).w,a4
		move.w	#$4000,d2
		bsr.s	LoadTilesFromStart2
		lea	(RAM_LevelSys_Buff+$8).w,a3
		lea	(RAM_LevelLayout+$80).w,a4
		move.w	#$6000,d2
		tst.b	(RAM_Level_CurrentZone).w
		beq.w	loc_71A0


; =============== S U B R O U T I N E ==========================================


LoadTilesFromStart2:
		moveq	#$FFFFFFF0,d4
		moveq	#$F,d6

loc_7144:
		movem.l	d4-d6,-(sp)
		moveq	#0,d5
		move.w	d4,d1
		bsr.w	sub_7084
		move.w	d1,d4
		moveq	#0,d5
		moveq	#$1F,d6
		move	#$2700,sr
		bsr.w	sub_6D84
		move	#$2300,sr
		movem.l	(sp)+,d4-d6
		addi.w	#$10,d4
		dbf	d6,loc_7144
		rts


; =============== S U B R O U T I N E ==========================================


LoadTilesFromStart_2p:
		moveq	#$FFFFFFF0,d4
		moveq	#$F,d6

loc_7174:
		movem.l	d4-d6,-(sp)
		moveq	#0,d5
		move.w	d4,d1
		bsr.w	sub_70C0
		move.w	d1,d4
		moveq	#0,d5
		moveq	#$1F,d6
		move	#$2700,sr
		bsr.w	sub_6D84
		move	#$2300,sr
		movem.l	(sp)+,d4-d6
		addi.w	#$10,d4
		dbf	d6,loc_7174
		rts

; ===============================================================================
; START	OF FUNCTION CHUNK FOR LoadTilesFromStart

loc_71A0:				; CODE XREF: LoadTilesFromStart+3Ej
		moveq	#0,d4
		moveq	#$F,d6

loc_71A4:				; CODE XREF: LoadTilesFromStart+C6j
		movem.l	d4-d6,-(sp)
		lea	(byte_71CA).l,a0
		move.w	(RAM_LevelSys_Buff+$C).w,d0
		add.w	d4,d0
		andi.w	#$F0,d0	; ''
		bsr.w	sub_7232
		movem.l	(sp)+,d4-d6
		addi.w	#$10,d4
		dbf	d6,loc_71A4
		rts
; END OF FUNCTION CHUNK	FOR LoadTilesFromStart
; ===============================================================================
byte_71CA:	dc.b   0,  0,  0,  0,  6,  6,  6,  4,  4,  4,  0,  0,  0,  0,  0,  0; 0
					; DATA XREF: LoadTilesFromStart+AAo
; ===============================================================================
		moveq	#$FFFFFFF0,d4
		moveq	#$F,d6

loc_71DE:				; CODE XREF: ROM:000071FCj
		movem.l	d4-d6,-(sp)
		lea	byte_6BCB(pc),a0
		move.w	(RAM_LevelSys_Buff+$C).w,d0
		add.w	d4,d0
		andi.w	#$3F0,d0
		bsr.w	sub_7232
		movem.l	(sp)+,d4-d6
		addi.w	#$10,d4
		dbf	d6,loc_71DE
		rts
; ===============================================================================
		moveq	#$FFFFFFF0,d4
		moveq	#$F,d6

loc_7206:				; CODE XREF: ROM:00007224j
		movem.l	d4-d6,-(sp)
		lea	byte_6AD1(pc),a0
		move.w	(RAM_LevelSys_Buff+$C).w,d0
		add.w	d4,d0
		andi.w	#$1F0,d0
		bsr.w	sub_7232
		movem.l	(sp)+,d4-d6
		addi.w	#$10,d4
		dbf	d6,loc_7206
		rts
; ===============================================================================
word_722A:	dc.w $EE08
		dc.w $EE08
		dc.w $EE10
		dc.w $EE18

; =============== S U B R O U T I N E ==========================================


sub_7232:
		lsr.w	#4,d0
		move.b	(a0,d0.w),d0
		movea.w	word_722A(pc,d0.w),a3
		beq.s	loc_725A
		moveq	#$FFFFFFF0,d5
		movem.l	d4-d5,-(sp)
		bsr.w	sub_7084
		movem.l	(sp)+,d4-d5
		move	#$2700,sr
		bsr.w	sub_6D8C
		move	#$2300,sr
		rts
; ===============================================================================

loc_725A:
		moveq	#0,d5
		movem.l	d4-d5,-(sp)
		bsr.w	sub_7086
		movem.l	(sp)+,d4-d5
		moveq	#$1F,d6
		bsr.w	Level_DrawTiles_Upd_Ver
		rts

; =============== S U B R O U T I N E ==========================================


MainLevelLoadBlock:
		moveq	#0,d0
		move.b	(RAM_Level_CurrentZone).w,d0
		lsl.w	#4,d0
		lea	(MainLoadBlocks).l,a2
		lea	(a2,d0.w),a2
		move.l	a2,-(sp)			; Save a2
		addq.l	#4,a2				; Skip $4 byte (Ignored level GFX pointer)
		movea.l	(a2)+,a0			; Get 16x16 data location
		tst.b	(RAM_Level_CurrentZone).w 	; Is GHZ?
		beq.s	MainLvlLoadBlk_Load16		; If yes, branch [same thing]
		bra.s	MainLvlLoadBlk_Load16

; ===============================================================================

; -------------------------------------------------
; Decompress the S1's 16x16 blocks to RAM [UNUSED]
; -------------------------------------------------

MainLvlLoadBlk_Decomp16:
		lea	(RAM_Level_Data_16).w,a1
		move.w	#0,d0
		bsr.w	EniDec
		bra.s	MainLvlLoadBlk_ChkHTZ

; ===============================================================================

MainLvlLoadBlk_Load16:
		lea	(RAM_Level_Data_16).w,a1
		move.w	#$BFF,d2

@BlocksToRAM:
		move.w	(a0)+,d0
		tst.w	(RAM_Flag_SplitScreen).w	;2P mode?
		beq.s	@BlocksToRAM_No2P
		move.w	d0,d1				;Start converting to 2P format
		andi.w	#$F800,d0
		andi.w	#$7FF,d1
		lsr.w	#1,d1
		or.w	d1,d0

@BlocksToRAM_No2P:
		move.w	d0,(a1)+
		dbf	d2,@BlocksToRAM

MainLvlLoadBlk_ChkHTZ:
		cmpi.b	#5,(RAM_Level_CurrentZone).w	; Is the level HTZ [SBZ]?
		bne.s	MainLvlLoadBlk_Load128		; Branch if equal

		lea	(RAM_Level_Data_16+$980).w,a1
		lea	(Map16_HTZ).l,a0
		move.w	#$3FF,d2
@HTZ_Loop:
		move.w	(a0)+,d0
		tst.w	(RAM_Flag_SplitScreen).w
		beq.s	@HTZ_No2p
		move.w	d0,d1
		andi.w	#$F800,d0
		andi.w	#$7FF,d1
		lsr.w	#1,d1
		or.w	d1,d0
@HTZ_No2p:
		move.w	d0,(a1)+
		dbf	d2,@HTZ_Loop

MainLvlLoadBlk_Load128:
		movea.l	(a2)+,a0
		cmpi.b	#2,(RAM_Level_CurrentZone).w	;CPZ[MZ]?
		beq.s	MainLvlLoadBlk_Default_128
		cmpi.b	#3,(RAM_Level_CurrentZone).w	;EHZ[SLZ]?
		beq.s	MainLvlLoadBlk_Default_128
		cmpi.b	#4,(RAM_Level_CurrentZone).w	;HPZ[SYZ]?
		beq.s	MainLvlLoadBlk_Default_128
		cmpi.b	#5,(RAM_Level_CurrentZone).w	;HTZ[SBZ]?
		beq.s	MainLvlLoadBlk_Default_128

		move.l	a2,-(sp)			;Load chunks with the uncracked compression
		moveq	#0,d1
		moveq	#0,d2
		move.w	(a0)+,d0
		lea	(a0,d0.w),a1
		lea	(RAM_MetablockTable).l,a2
		lea	(RAM_LevelLayout).w,a3

@UnkComp_Loop:
		bsr.w	UnknownDec
		tst.w	d0
		bmi.s	@UnkComp_Loop
		movea.l	(sp)+,a2
		bra.s	MainLvlLoadBlk_LoadLayout
; ===============================================================================

MainLvlLoadBlk_Default_128:
		lea	(RAM_MetablockTable).l,a1
		move.w	#$3FFF,d0
@Loop:
		move.w	(a0)+,(a1)+
		dbf	d0,@Loop

MainLvlLoadBlk_LoadLayout:
		bsr.w	LevelLayoutLoad

		move.w	(a2)+,d0		;Get pallet
		move.w	(a2),d0
		andi.w	#$FF,d0			;Limit to $FF

		cmpi.w	#$103,(RAM_Level_CurrentZone).w
		bne.s	@NotLZ4
		moveq	#$C,d0

@NotLZ4:
		cmpi.w	#$501,(RAM_Level_CurrentZone).w
		beq.s	@NotEHZ2
		cmpi.w	#$502,(RAM_Level_CurrentZone).w
		bne.s	@NotEHZ3

@NotEHZ2:
		moveq	#$E,d0

@NotEHZ3:
		bsr.w	PalLoad1
		movea.l	(sp)+,a2
		addq.w	#4,a2
		moveq	#0,d0
		move.b	(a2),d0
		beq.s	@NoPlc
		bsr.w	LoadPLC

@NoPlc:
		rts


; =============== S U B R O U T I N E ==========================================


LevelLayoutLoad:
		lea	(RAM_LevelLayout).w,a3
		move.w	#$3FF,d1
		moveq	#0,d0

@ClearRAM:
		move.l	d0,(a3)+
		dbf	d1,@ClearRAM

		lea	(RAM_LevelLayout).w,a3		;Foreground
		moveq	#0,d1
		bsr.w	LevelLayoutLoad2

		lea	(RAM_LevelLayout+$80).w,a3		;Background
		moveq	#2,d1

LevelLayoutLoad2:
		tst.b	(RAM_Level_CurrentZone).w
		beq.s	LevelLayoutLoad_GHZ

		move.w	(RAM_Level_CurrentZone).w,d0
		lsl.b	#6,d0
		lsr.w	#5,d0
		move.w	d0,d2
		add.w	d0,d0
		add.w	d2,d0
		add.w	d1,d0
		lea	(LevelLayout_Index).l,a1
		move.w	(a1,d0.w),d0
		lea	(a1,d0.w),a1
		moveq	#0,d1
		move.w	d1,d2
		move.b	(a1)+,d1
		move.b	(a1)+,d2
		move.l	d1,d5
		addq.l	#1,d5
		moveq	#0,d3
		move.w	#$80,d3
		divu.w	d5,d3
		subq.w	#1,d3

LevelLayoutLoad_Next:
		movea.l	a3,a0
		move.w	d3,d4

loc_73E2:
		move.l	a1,-(sp)
		move.w	d1,d0

loc_73E6:
		move.b	(a1)+,(a0)+
		dbf	d0,loc_73E6
		movea.l	(sp)+,a1
		dbf	d4,loc_73E2
		lea	(a1,d5.w),a1
		lea	$100(a3),a3
		dbf	d2,LevelLayoutLoad_Next
		rts

; ===============================================================================

LevelLayoutLoad_GHZ:
		move.w	(RAM_Level_CurrentZone).w,d0
		lsl.b	#6,d0
		lsr.w	#5,d0
		move.w	d0,d2
		add.w	d0,d0
		add.w	d2,d0
		add.w	d1,d0
		lea	(LevelLayout_Index).l,a1
		move.w	(a1,d0.w),d0
		lea	(a1,d0.w),a1
		moveq	#0,d1
		move.w	d1,d2
		move.b	(a1)+,d1
		move.b	(a1)+,d2

loc_7426:
		move.w	d1,d0
		movea.l	a3,a0

loc_742A:
		move.b	(a1)+,d3
		subq.b	#1,d3
		bcc.s	loc_7440
		moveq	#0,d3
		move.b	d3,(a0)+
		move.b	d3,(a0)+
		move.b	d3,$FE(a0)
		move.b	d3,$FF(a0)
		bra.s	loc_7456
; ===============================================================================

loc_7440:
		lsl.b	#2,d3
		addq.b	#1,d3
		move.b	d3,(a0)+
		addq.b	#1,d3
		move.b	d3,(a0)+
		addq.b	#1,d3
		move.b	d3,$FE(a0)
		addq.b	#1,d3
		move.b	d3,$FF(a0)

loc_7456:
		dbf	d0,loc_742A
		lea	$200(a3),a3
		dbf	d2,loc_7426
		rts

; ===============================================================================
; leftover level layout	converting function (from raw to the way it's stored in the game)
; ===============================================================================

LevelLayout_Convert:
		lea	($FE0000).l,a1
		lea	($FE0080).l,a2
		lea	(RAM_MetablockTable).l,a3
		move.w	#$3F,d1

loc_747A:
		bsr.w	sub_750C
		bsr.w	sub_750C
		dbf	d1,loc_747A
		lea	($FE0000).l,a1
		lea	($FF0000).l,a2
		move.w	#$3F,d1

loc_7496:
		move.w	#0,(a2)+
		dbf	d1,loc_7496
		move.w	#$3FBF,d1

loc_74A2:
		move.w	(a1)+,(a2)+
		dbf	d1,loc_74A2
		rts

; ===============================================================================
		lea	($FE0000).l,a1
		lea	(RAM_MetablockTable).l,a3
		moveq	#$1F,d0

loc_74B8:
		move.l	(a1)+,(a3)+
		dbf	d0,loc_74B8
		moveq	#0,d7
		lea	($FE0000).l,a1
		move.w	#$FF,d5

loc_74CA:
		lea	(RAM_MetablockTable).l,a3
		move.w	d7,d6

loc_74D2:
		movem.l	a1-a3,-(sp)
		move.w	#$3F,d0

loc_74DA:
		cmpm.w	(a1)+,(a3)+
		bne.s	loc_74F0
		dbf	d0,loc_74DA
		movem.l	(sp)+,a1-a3
		adda.w	#$80,a1
		dbf	d5,loc_74CA
		bra.s	loc_750A
; ===============================================================================

loc_74F0:
		movem.l	(sp)+,a1-a3
		adda.w	#$80,a3
		dbf	d6,loc_74D2
		moveq	#$1F,d0

loc_74FE:
		move.l	(a1)+,(a3)+
		dbf	d0,loc_74FE
		addq.l	#1,d7
		dbf	d5,loc_74CA

loc_750A:
		bra.s	loc_750A

; =============== S U B R O U T I N E ==========================================


sub_750C:
		moveq	#7,d0

loc_750E:
		move.l	(a3)+,(a1)+
		move.l	(a3)+,(a1)+
		move.l	(a3)+,(a1)+
		move.l	(a3)+,(a1)+
		move.l	(a3)+,(a2)+
		move.l	(a3)+,(a2)+
		move.l	(a3)+,(a2)+
		move.l	(a3)+,(a2)+
		dbf	d0,loc_750E
		adda.w	#$80,a1
		adda.w	#$80,a2
		rts


; =============== S U B R O U T I N E ==========================================


DynScreenResizeLoad:
		moveq	#0,d0
		move.b	(RAM_Level_CurrentZone).w,d0
		add.w	d0,d0
		move.w	DynResize_Index(pc,d0.w),d0
		jsr	DynResize_Index(pc,d0.w)
		moveq	#2,d1
		move.w	(RAM_Level_Camera_Boundary_1).w,d0
		sub.w	(RAM_LevelSys_YPos_SetEnd).w,d0
		beq.s	locret_756A
		bcc.s	loc_756C
		neg.w	d1
		move.w	(RAM_LevelSys_Buff+$4).w,d0
		cmp.w	(RAM_Level_Camera_Boundary_1).w,d0
		bls.s	loc_7560
		move.w	d0,(RAM_LevelSys_YPos_SetEnd).w
		andi.w	#-2,(RAM_LevelSys_YPos_SetEnd).w

loc_7560:
		add.w	d1,(RAM_LevelSys_YPos_SetEnd).w
		move.b	#1,(RAM_LevelSys_Ver_Flag_Unk).w

locret_756A:
		rts
; ===============================================================================

loc_756C:
		move.w	(RAM_LevelSys_Buff+$4).w,d0
		addi.w	#8,d0
		cmp.w	(RAM_LevelSys_YPos_SetEnd).w,d0
		bcs.s	loc_7586
		btst	#1,(RAM_ObjRAM_Sonic+$22).w
		beq.s	loc_7586
		add.w	d1,d1
		add.w	d1,d1

loc_7586:
		add.w	d1,(RAM_LevelSys_YPos_SetEnd).w
		move.b	#1,(RAM_LevelSys_Ver_Flag_Unk).w
		rts

; ===============================================================================
DynResize_Index:dc.w DynResize_GHZ-DynResize_Index
		dc.w DynResize_LZ-DynResize_Index; 1
		dc.w DynResize_CPZ-DynResize_Index; 2
		dc.w DynResize_EHZ-DynResize_Index; 3
		dc.w DynResize_HPZ-DynResize_Index; 4
		dc.w DynResize_HTZ-DynResize_Index; 5
		dc.w DynResize_S1Ending-DynResize_Index; 6
; ===============================================================================

DynResize_GHZ:
		moveq	#0,d0
		move.b	(RAM_Level_CurrentAct).w,d0
		add.w	d0,d0
		move.w	DynResize_GHZ_Index(pc,d0.w),d0
		jmp	DynResize_GHZ_Index(pc,d0.w)
; ===============================================================================
DynResize_GHZ_Index:
		dc.w DynResize_GHZ1-DynResize_GHZ_Index
		dc.w DynResize_GHZ2-DynResize_GHZ_Index
		dc.w DynResize_GHZ3-DynResize_GHZ_Index
; ===============================================================================

DynResize_GHZ1:				; DATA XREF: ROM:DynResize_GHZ_Indexo
		move.w	#$300,(RAM_Level_Camera_Boundary_1).w
		cmpi.w	#$1780,(RAM_LevelSys_Buff).w
		bcs.s	locret_75CA
		move.w	#$400,(RAM_Level_Camera_Boundary_1).w

locret_75CA:				; CODE XREF: ROM:000075C2j
		rts
; ===============================================================================

DynResize_GHZ2:				; DATA XREF: ROM:DynResize_GHZ_Indexo
		move.w	#$300,(RAM_Level_Camera_Boundary_1).w
		cmpi.w	#$ED0,(RAM_LevelSys_Buff).w
		bcs.s	locret_75FC
		move.w	#$200,(RAM_Level_Camera_Boundary_1).w
		cmpi.w	#$1600,(RAM_LevelSys_Buff).w
		bcs.s	locret_75FC
		move.w	#$400,(RAM_Level_Camera_Boundary_1).w
		cmpi.w	#$1D60,(RAM_LevelSys_Buff).w
		bcs.s	locret_75FC
		move.w	#$300,(RAM_Level_Camera_Boundary_1).w

locret_75FC:				; CODE XREF: ROM:000075D8j
					; ROM:000075E6j ...
		rts
; ===============================================================================

DynResize_GHZ3:				; DATA XREF: ROM:DynResize_GHZ_Indexo
		moveq	#0,d0
		move.b	(RAM_DynResizeCntr).w,d0
		move.w	DynResize_GHZ3_Index(pc,d0.w),d0
		jmp	DynResize_GHZ3_Index(pc,d0.w)
; ===============================================================================
DynResize_GHZ3_Index:dc.w DynResize_GHZ3_Main-DynResize_GHZ3_Index; 0
					; DATA XREF: ROM:DynResize_GHZ3_Indexo
					; ROM:DynResize_GHZ3_Index+2o ...
		dc.w DynResize_GHZ3_Boss-DynResize_GHZ3_Index; 1
		dc.w DynResize_GHZ3_End-DynResize_GHZ3_Index; 2
; ===============================================================================

DynResize_GHZ3_Main:			; DATA XREF: ROM:DynResize_GHZ3_Indexo
		move.w	#$300,(RAM_Level_Camera_Boundary_1).w
		cmpi.w	#$380,(RAM_LevelSys_Buff).w
		bcs.s	locret_7658
		move.w	#$310,(RAM_Level_Camera_Boundary_1).w
		cmpi.w	#$960,(RAM_LevelSys_Buff).w
		bcs.s	locret_7658
		cmpi.w	#$280,(RAM_LevelSys_Buff+$4).w
		bcs.s	loc_765A
		move.w	#$400,(RAM_Level_Camera_Boundary_1).w
		cmpi.w	#$1380,(RAM_LevelSys_Buff).w
		bcc.s	loc_7650
		move.w	#$4C0,(RAM_Level_Camera_Boundary_1).w
		move.w	#$4C0,(RAM_LevelSys_YPos_SetEnd).w

loc_7650:				; CODE XREF: ROM:00007642j
		cmpi.w	#$1700,(RAM_LevelSys_Buff).w
		bcc.s	loc_765A

locret_7658:				; CODE XREF: ROM:0000761Ej
					; ROM:0000762Cj
		rts
; ===============================================================================

loc_765A:				; CODE XREF: ROM:00007634j
					; ROM:00007656j
		move.w	#$300,(RAM_Level_Camera_Boundary_1).w
		addq.b	#2,(RAM_DynResizeCntr).w
		rts
; ===============================================================================

DynResize_GHZ3_Boss:			; DATA XREF: ROM:DynResize_GHZ3_Indexo
		cmpi.w	#$960,(RAM_LevelSys_Buff).w
		bcc.s	loc_7672
		subq.b	#2,(RAM_DynResizeCntr).w

loc_7672:				; CODE XREF: ROM:0000766Cj
		cmpi.w	#$2960,(RAM_LevelSys_Buff).w
		bcs.s	locret_76AA
		bsr.w	SingleObjectLoad
		bne.s	loc_7692
		move.b	#$3D,0(a1) ; '='
		move.w	#$2A60,8(a1)
		move.w	#$280,$C(a1)

loc_7692:				; CODE XREF: ROM:0000767Ej
		move.w	#$8C,d0	; ''
		bsr.w	PlaySound
		move.b	#1,(RAM_Level_BossMode).w
		addq.b	#2,(RAM_DynResizeCntr).w
		moveq	#$11,d0
		bra.w	LoadPLC
; ===============================================================================

locret_76AA:				; CODE XREF: ROM:00007678j
		rts
; ===============================================================================

DynResize_GHZ3_End:			; DATA XREF: ROM:DynResize_GHZ3_Indexo
		move.w	(RAM_LevelSys_Buff).w,(RAM_LevelSys_XPos_SetStart).w
		rts
; ===============================================================================

DynResize_LZ:
		moveq	#0,d0
		move.b	(RAM_Level_CurrentAct).w,d0
		add.w	d0,d0
		move.w	DynResize_LZ_Index(pc,d0.w),d0
		jmp	DynResize_LZ_Index(pc,d0.w)
; ===============================================================================
DynResize_LZ_Index:
		dc.w DynResize_LZ_Null-DynResize_LZ_Index
		dc.w DynResize_LZ_Null-DynResize_LZ_Index
		dc.w DynResize_LZ3-DynResize_LZ_Index
		dc.w DynResize_LZ4-DynResize_LZ_Index
; ===============================================================================

DynResize_LZ_Null:
		rts
; ===============================================================================

DynResize_LZ3:
		tst.b	(RAM_Level_Switches+$F).w
		beq.s	loc_76EA
		lea	(RAM_LevelLayout+$206).w,a1
		cmpi.b	#7,(a1)
		beq.s	loc_76EA
		move.b	#7,(a1)
		move.w	#$B7,d0
		bsr.w	PlaySound_Special

loc_76EA:
		tst.b	(RAM_DynResizeCntr).w
		bne.s	locret_7726
		cmpi.w	#$1CA0,(RAM_LevelSys_Buff).w
		bcs.s	locret_7724
		cmpi.w	#$600,(RAM_LevelSys_Buff+$4).w
		bcc.s	locret_7724
		bsr.w	SingleObjectLoad
		bne.s	loc_770C
		move.b	#$77,0(a1) ; 'w'

loc_770C:				; CODE XREF: ROM:00007704j
		move.w	#$8C,d0	; ''
		bsr.w	PlaySound
		move.b	#1,(RAM_Level_BossMode).w
		addq.b	#2,(RAM_DynResizeCntr).w
		moveq	#$11,d0
		bra.w	LoadPLC
; ===============================================================================

locret_7724:				; CODE XREF: ROM:000076F6j
					; ROM:000076FEj
		rts
; ===============================================================================

locret_7726:				; CODE XREF: ROM:000076EEj
		rts
; ===============================================================================

DynResize_LZ4:				; DATA XREF: ROM:DynResize_LZ_Indexo
		cmpi.w	#$D00,(RAM_LevelSys_Buff).w
		bcs.s	locret_774E
		cmpi.w	#$18,(RAM_ObjRAM_Sonic+$C).w
		bcc.s	locret_774E
		clr.b	(RAM_Level_LamppostCntr).w
		move.w	#1,(RAM_Flag_ResetLevel).w
		move.w	#$502,(RAM_Level_CurrentZone).w
		move.b	#1,(RAM_Flag_ControlLock).w

locret_774E:				; CODE XREF: ROM:0000772Ej
					; ROM:00007736j
		rts
; ===============================================================================

DynResize_CPZ:				; DATA XREF: ROM:DynResize_Indexo
		moveq	#0,d0
		move.b	(RAM_Level_CurrentAct).w,d0
		add.w	d0,d0
		move.w	DynResize_CPZ_Index(pc,d0.w),d0
		jmp	DynResize_CPZ_Index(pc,d0.w)
; ===============================================================================
DynResize_CPZ_Index:dc.w DynResize_CPZ1-DynResize_CPZ_Index; 0
					; DATA XREF: ROM:DynResize_CPZ_Indexo
					; ROM:DynResize_CPZ_Index+2o ...
		dc.w DynResize_CPZ2-DynResize_CPZ_Index; 1
		dc.w DynResize_CPZ3-DynResize_CPZ_Index; 2
; ===============================================================================

DynResize_CPZ1:				; DATA XREF: ROM:DynResize_CPZ_Indexo
		rts
; ===============================================================================

S1DynResize_MZ1:			; leftover from	Sonic 1
		moveq	#0,d0
		move.b	(RAM_DynResizeCntr).w,d0
		move.w	off_7776(pc,d0.w),d0
		jmp	off_7776(pc,d0.w)
; ===============================================================================
off_7776:	dc.w loc_777E-off_7776	; 0 ; DATA XREF: ROM:off_7776o
					; ROM:off_7776+2o ...
		dc.w loc_77AE-off_7776	; 1
		dc.w loc_77F2-off_7776	; 2
		dc.w loc_781C-off_7776	; 3
; ===============================================================================

loc_777E:				; DATA XREF: ROM:off_7776o
		move.w	#$1D0,(RAM_Level_Camera_Boundary_1).w
		cmpi.w	#$700,(RAM_LevelSys_Buff).w
		bcs.s	locret_77AC
		move.w	#$220,(RAM_Level_Camera_Boundary_1).w
		cmpi.w	#$D00,(RAM_LevelSys_Buff).w
		bcs.s	locret_77AC
		move.w	#$340,(RAM_Level_Camera_Boundary_1).w
		cmpi.w	#$340,(RAM_LevelSys_Buff+$4).w
		bcs.s	locret_77AC
		addq.b	#2,(RAM_DynResizeCntr).w

locret_77AC:				; CODE XREF: ROM:0000778Aj
					; ROM:00007798j ...
		rts
; ===============================================================================

loc_77AE:				; DATA XREF: ROM:off_7776o
		cmpi.w	#$340,(RAM_LevelSys_Buff+$4).w
		bcc.s	loc_77BC
		subq.b	#2,(RAM_DynResizeCntr).w
		rts
; ===============================================================================

loc_77BC:				; CODE XREF: ROM:000077B4j
		move.w	#0,(RAM_LevelSys_YPos_SetStart).w
		cmpi.w	#$E00,(RAM_LevelSys_Buff).w
		bcc.s	locret_77F0
		move.w	#$340,(RAM_LevelSys_YPos_SetStart).w
		move.w	#$340,(RAM_Level_Camera_Boundary_1).w
		cmpi.w	#$A90,(RAM_LevelSys_Buff).w
		bcc.s	locret_77F0
		move.w	#$500,(RAM_Level_Camera_Boundary_1).w
		cmpi.w	#$370,(RAM_LevelSys_Buff+$4).w
		bcs.s	locret_77F0
		addq.b	#2,(RAM_DynResizeCntr).w

locret_77F0:				; CODE XREF: ROM:000077C8j
					; ROM:000077DCj ...
		rts
; ===============================================================================

loc_77F2:				; DATA XREF: ROM:off_7776o
		cmpi.w	#$370,(RAM_LevelSys_Buff+$4).w
		bcc.s	loc_7800
		subq.b	#2,(RAM_DynResizeCntr).w
		rts
; ===============================================================================

loc_7800:				; CODE XREF: ROM:000077F8j
		cmpi.w	#$500,(RAM_LevelSys_Buff+$4).w
		bcs.s	locret_781A
		cmpi.w	#$B80,(RAM_LevelSys_Buff).w
		bcs.s	locret_781A
		move.w	#$500,(RAM_LevelSys_YPos_SetStart).w
		addq.b	#2,(RAM_DynResizeCntr).w

locret_781A:				; CODE XREF: ROM:00007806j
					; ROM:0000780Ej
		rts
; ===============================================================================

loc_781C:				; DATA XREF: ROM:off_7776o
		cmpi.w	#$B80,(RAM_LevelSys_Buff).w
		bcc.s	loc_7832
		cmpi.w	#$340,(RAM_LevelSys_YPos_SetStart).w
		beq.s	locret_786A
		subq.w	#2,(RAM_LevelSys_YPos_SetStart).w
		rts
; ===============================================================================

loc_7832:				; CODE XREF: ROM:00007822j
		cmpi.w	#$500,(RAM_LevelSys_YPos_SetStart).w
		beq.s	loc_7848
		cmpi.w	#$500,(RAM_LevelSys_Buff+$4).w
		bcs.s	locret_786A
		move.w	#$500,(RAM_LevelSys_YPos_SetStart).w

loc_7848:				; CODE XREF: ROM:00007838j
		cmpi.w	#$E70,(RAM_LevelSys_Buff).w
		bcs.s	locret_786A
		move.w	#0,(RAM_LevelSys_YPos_SetStart).w
		move.w	#$500,(RAM_Level_Camera_Boundary_1).w
		cmpi.w	#$1430,(RAM_LevelSys_Buff).w
		bcs.s	locret_786A
		move.w	#$210,(RAM_Level_Camera_Boundary_1).w

locret_786A:				; CODE XREF: ROM:0000782Aj
					; ROM:00007840j ...
		rts
; ===============================================================================

DynResize_CPZ2:				; DATA XREF: ROM:DynResize_CPZ_Indexo
		rts
; ===============================================================================

S1DynResize_MZ2:			; leftover from	Sonic 1
		move.w	#$520,(RAM_Level_Camera_Boundary_1).w
		cmpi.w	#$1700,(RAM_LevelSys_Buff).w
		bcs.s	locret_7882
		move.w	#$200,(RAM_Level_Camera_Boundary_1).w

locret_7882:				; CODE XREF: ROM:0000787Aj
		rts
; ===============================================================================

DynResize_CPZ3:				; DATA XREF: ROM:DynResize_CPZ_Indexo
		moveq	#0,d0
		move.b	(RAM_DynResizeCntr).w,d0
		move.w	off_7892(pc,d0.w),d0
		jmp	off_7892(pc,d0.w)
; ===============================================================================
off_7892:	dc.w DynResize_CPZ3_BossCheck-off_7892;	0 ; DATA XREF: ROM:off_7892o
					; ROM:off_7892+2o
		dc.w DynResize_CPZ3_Null-off_7892; 1
; ===============================================================================

DynResize_CPZ3_BossCheck:		; DATA XREF: ROM:off_7892o
		cmpi.w	#$480,(RAM_LevelSys_Buff).w
		blt.s	DynResize_CPZ3_Null
		cmpi.w	#$740,(RAM_LevelSys_Buff).w
		bgt.s	DynResize_CPZ3_Null
		move.w	(RAM_LevelSys_YPos_SetEnd).w,d0
		cmp.w	(RAM_LevelSys_Buff+$4).w,d0
		bne.s	DynResize_CPZ3_Null
		move.w	#$740,(RAM_LevelSys_XPos_SetEnd).w
		move.w	#$480,(RAM_LevelSys_XPos_SetStart).w
		addq.b	#2,(RAM_DynResizeCntr).w
		bsr.w	SingleObjectLoad
		bne.s	DynResize_CPZ3_Null
		move.b	#$55,0(a1) ; 'U'
		move.w	#$680,8(a1)
		move.w	#$540,$C(a1)
		moveq	#$11,d0
		bra.w	LoadPLC
; ===============================================================================

DynResize_CPZ3_Null:			; CODE XREF: ROM:0000789Cj
					; ROM:000078A4j ...
		rts
; ===============================================================================

		include	"Levels/03/Resize.asm"
		even
; ===============================================================================

S1DynResize_SLZ3:			; leftover from	Sonic 1
		moveq	#0,d0
		move.b	(RAM_DynResizeCntr).w,d0
		move.w	off_7990(pc,d0.w),d0
		jmp	off_7990(pc,d0.w)
; ===============================================================================
off_7990:	dc.w loc_7996-off_7990	; DATA XREF: ROM:off_7990o
					; ROM:00007992o ...
		dc.w loc_79AA-off_7990
		dc.w loc_79D6-off_7990
; ===============================================================================

loc_7996:				; DATA XREF: ROM:off_7990o
		cmpi.w	#$1E70,(RAM_LevelSys_Buff).w
		bcs.s	locret_79A8
		move.w	#$210,(RAM_Level_Camera_Boundary_1).w
		addq.b	#2,(RAM_DynResizeCntr).w

locret_79A8:				; CODE XREF: ROM:0000799Cj
		rts
; ===============================================================================

loc_79AA:				; DATA XREF: ROM:00007992o
		cmpi.w	#$2000,(RAM_LevelSys_Buff).w
		bcs.s	locret_79D4
		bsr.w	SingleObjectLoad
		bne.s	loc_79BC
		move.b	#$7A,(a1) ; 'z'

loc_79BC:				; CODE XREF: ROM:000079B6j
		move.w	#$8C,d0	; ''
		bsr.w	PlaySound
		move.b	#1,(RAM_Level_BossMode).w
		addq.b	#2,(RAM_DynResizeCntr).w
		moveq	#$11,d0
		bra.w	LoadPLC
; ===============================================================================

locret_79D4:				; CODE XREF: ROM:000079B0j
		rts
; ===============================================================================

loc_79D6:				; DATA XREF: ROM:00007994o
		move.w	(RAM_LevelSys_Buff).w,(RAM_LevelSys_XPos_SetStart).w
		rts
; ===============================================================================
		rts
; ===============================================================================

DynResize_HPZ:				; DATA XREF: ROM:DynResize_Indexo
		moveq	#0,d0
		move.b	(RAM_Level_CurrentAct).w,d0
		add.w	d0,d0
		move.w	DynResize_HPZ_Index(pc,d0.w),d0
		jmp	DynResize_HPZ_Index(pc,d0.w)
; ===============================================================================
DynResize_HPZ_Index:dc.w DynResize_HPZ1-DynResize_HPZ_Index
					; DATA XREF: ROM:DynResize_HPZ_Indexo
					; ROM:000079F2o ...
		dc.w DynResize_HPZ2-DynResize_HPZ_Index
		dc.w DynResize_HPZ3-DynResize_HPZ_Index
; ===============================================================================

DynResize_HPZ1:				; DATA XREF: ROM:DynResize_HPZ_Indexo
		rts
; ===============================================================================

DynResize_HPZ2:				; DATA XREF: ROM:000079F2o
		move.w	#$520,(RAM_Level_Camera_Boundary_1).w
		cmpi.w	#$25A0,(RAM_LevelSys_Buff).w
		bcs.s	locret_7A1A
		move.w	#$420,(RAM_Level_Camera_Boundary_1).w
		cmpi.w	#$4D0,(RAM_ObjRAM_Sonic+$C).w
		bcs.s	locret_7A1A
		move.w	#$520,(RAM_Level_Camera_Boundary_1).w

locret_7A1A:				; CODE XREF: ROM:00007A04j
					; ROM:00007A12j
		rts
; ===============================================================================

DynResize_HPZ3:				; DATA XREF: ROM:000079F4o
		moveq	#0,d0
		move.b	(RAM_DynResizeCntr).w,d0
		move.w	DynResize_HPZ3_Index(pc,d0.w),d0
		jmp	DynResize_HPZ3_Index(pc,d0.w)
; ===============================================================================
DynResize_HPZ3_Index:dc.w loc_7A30-DynResize_HPZ3_Index
					; DATA XREF: ROM:DynResize_HPZ3_Indexo
					; ROM:00007A2Co ...
		dc.w loc_7A48-DynResize_HPZ3_Index
		dc.w loc_7A7A-DynResize_HPZ3_Index
; ===============================================================================

loc_7A30:				; DATA XREF: ROM:DynResize_HPZ3_Indexo
		cmpi.w	#$2AC0,(RAM_LevelSys_Buff).w
		bcs.s	locret_7A46
		bsr.w	SingleObjectLoad
		bne.s	locret_7A46
		move.b	#$76,(a1) ; 'v'
		addq.b	#2,(RAM_DynResizeCntr).w

locret_7A46:				; CODE XREF: ROM:00007A36j
					; ROM:00007A3Cj
		rts
; ===============================================================================

loc_7A48:				; DATA XREF: ROM:00007A2Co
		cmpi.w	#$2C00,(RAM_LevelSys_Buff).w
		bcs.s	locret_7A78
		move.w	#$4CC,(RAM_Level_Camera_Boundary_1).w
		bsr.w	SingleObjectLoad
		bne.s	loc_7A64
		move.b	#$75,(a1) ; 'u'
		addq.b	#2,(RAM_DynResizeCntr).w

loc_7A64:				; CODE XREF: ROM:00007A5Aj
		move.w	#$8C,d0	; ''
		bsr.w	PlaySound
		move.b	#1,(RAM_Level_BossMode).w
		moveq	#$11,d0
		bra.w	LoadPLC
; ===============================================================================

locret_7A78:				; CODE XREF: ROM:00007A4Ej
		rts
; ===============================================================================

loc_7A7A:				; DATA XREF: ROM:00007A2Eo
		move.w	(RAM_LevelSys_Buff).w,(RAM_LevelSys_XPos_SetStart).w
		rts
; ===============================================================================

DynResize_HTZ:				; DATA XREF: ROM:DynResize_Indexo
		moveq	#0,d0
		move.b	(RAM_Level_CurrentAct).w,d0
		add.w	d0,d0
		move.w	DynResize_HTZ_Index(pc,d0.w),d0
		jmp	DynResize_HTZ_Index(pc,d0.w)
; ===============================================================================
DynResize_HTZ_Index:dc.w DynResize_HTZ1-DynResize_HTZ_Index
					; DATA XREF: ROM:DynResize_HTZ_Indexo
					; ROM:00007A94o ...
		dc.w DynResize_HTZ2-DynResize_HTZ_Index
		dc.w DynResize_HTZ3-DynResize_HTZ_Index
; ===============================================================================

DynResize_HTZ1:				; DATA XREF: ROM:DynResize_HTZ_Indexo
		move.w	#$720,(RAM_Level_Camera_Boundary_1).w
		cmpi.w	#$1880,(RAM_LevelSys_Buff).w
		bcs.s	locret_7ABA
		move.w	#$620,(RAM_Level_Camera_Boundary_1).w
		cmpi.w	#$2000,(RAM_LevelSys_Buff).w
		bcs.s	locret_7ABA
		move.w	#$2A0,(RAM_Level_Camera_Boundary_1).w

locret_7ABA:				; CODE XREF: ROM:00007AA4j
					; ROM:00007AB2j
		rts
; ===============================================================================

DynResize_HTZ2:				; DATA XREF: ROM:00007A94o
		moveq	#0,d0
		move.b	(RAM_DynResizeCntr).w,d0
		move.w	DynResize_HTZ2_Index(pc,d0.w),d0
		jmp	DynResize_HTZ2_Index(pc,d0.w)
; ===============================================================================
DynResize_HTZ2_Index:dc.w loc_7AD2-DynResize_HTZ2_Index
					; DATA XREF: ROM:DynResize_HTZ2_Indexo
					; ROM:00007ACCo ...
		dc.w loc_7AF4-DynResize_HTZ2_Index
		dc.w loc_7B12-DynResize_HTZ2_Index
		dc.w loc_7B30-DynResize_HTZ2_Index
; ===============================================================================

loc_7AD2:				; DATA XREF: ROM:DynResize_HTZ2_Indexo
		move.w	#$800,(RAM_Level_Camera_Boundary_1).w
		cmpi.w	#$1800,(RAM_LevelSys_Buff).w
		bcs.s	locret_7AF2
		move.w	#$510,(RAM_Level_Camera_Boundary_1).w
		cmpi.w	#$1E00,(RAM_LevelSys_Buff).w
		bcs.s	locret_7AF2
		addq.b	#2,(RAM_DynResizeCntr).w

locret_7AF2:				; CODE XREF: ROM:00007ADEj
					; ROM:00007AECj
		rts
; ===============================================================================

loc_7AF4:				; DATA XREF: ROM:00007ACCo
		cmpi.w	#$1EB0,(RAM_LevelSys_Buff).w
		bcs.s	locret_7B10
		bsr.w	SingleObjectLoad
		bne.s	locret_7B10
		move.b	#$83,(a1)
		addq.b	#2,(RAM_DynResizeCntr).w
		moveq	#$1E,d0
		bra.w	LoadPLC
; ===============================================================================

locret_7B10:				; CODE XREF: ROM:00007AFAj
					; ROM:00007B00j
		rts
; ===============================================================================

loc_7B12:				; DATA XREF: ROM:00007ACEo
		cmpi.w	#$1F60,(RAM_LevelSys_Buff).w
		bcs.s	loc_7B2E
		bsr.w	SingleObjectLoad
		bne.s	loc_7B28
		move.b	#$82,(a1)
		addq.b	#2,(RAM_DynResizeCntr).w

loc_7B28:				; CODE XREF: ROM:00007B1Ej
		move.b	#1,(RAM_Level_BossMode).w

loc_7B2E:				; CODE XREF: ROM:00007B18j
		bra.s	loc_7B3A
; ===============================================================================

loc_7B30:				; DATA XREF: ROM:00007AD0o
		cmpi.w	#$2050,(RAM_LevelSys_Buff).w
		bcs.s	loc_7B3A
		rts
; ===============================================================================

loc_7B3A:				; CODE XREF: ROM:loc_7B2Ej
					; ROM:00007B36j ...
		move.w	(RAM_LevelSys_Buff).w,(RAM_LevelSys_XPos_SetStart).w
		rts
; ===============================================================================

DynResize_HTZ3:				; DATA XREF: ROM:00007A96o
		moveq	#0,d0
		move.b	(RAM_DynResizeCntr).w,d0
		move.w	DynResize_HTZ3_Index(pc,d0.w),d0
		jmp	DynResize_HTZ3_Index(pc,d0.w)
; ===============================================================================
DynResize_HTZ3_Index:dc.w loc_7B5A-DynResize_HTZ3_Index
					; DATA XREF: ROM:DynResize_HTZ3_Indexo
					; ROM:00007B52o ...
		dc.w loc_7B6E-DynResize_HTZ3_Index
		dc.w loc_7B8C-DynResize_HTZ3_Index
		dc.w locret_7B9A-DynResize_HTZ3_Index
		dc.w loc_7B9C-DynResize_HTZ3_Index
; ===============================================================================

loc_7B5A:				; DATA XREF: ROM:DynResize_HTZ3_Indexo
		cmpi.w	#$2148,(RAM_LevelSys_Buff).w
		bcs.s	loc_7B6C
		addq.b	#2,(RAM_DynResizeCntr).w
		moveq	#$1F,d0
		bsr.w	LoadPLC

loc_7B6C:				; CODE XREF: ROM:00007B60j
		bra.s	loc_7B3A
; ===============================================================================

loc_7B6E:				; DATA XREF: ROM:00007B52o
		cmpi.w	#$2300,(RAM_LevelSys_Buff).w
		bcs.s	loc_7B8A
		bsr.w	SingleObjectLoad
		bne.s	loc_7B8A
		move.b	#$85,(a1)
		addq.b	#2,(RAM_DynResizeCntr).w
		move.b	#1,(RAM_Level_BossMode).w

loc_7B8A:				; CODE XREF: ROM:00007B74j
					; ROM:00007B7Aj
		bra.s	loc_7B3A
; ===============================================================================

loc_7B8C:				; DATA XREF: ROM:00007B54o
		cmpi.w	#$2450,(RAM_LevelSys_Buff).w
		bcs.s	loc_7B98
		addq.b	#2,(RAM_DynResizeCntr).w

loc_7B98:				; CODE XREF: ROM:00007B92j
		bra.s	loc_7B3A
; ===============================================================================

locret_7B9A:				; DATA XREF: ROM:00007B56o
		rts
; ===============================================================================

loc_7B9C:				; DATA XREF: ROM:00007B58o
		bra.s	loc_7B3A
; ===============================================================================

DynResize_S1Ending:			; DATA XREF: ROM:DynResize_Indexo
		rts
; ===============================================================================
;----------------------------------------------------
; Object 11 - Bridge
;----------------------------------------------------

Obj11:					; DATA XREF: ROM:Obj_Indexo
		btst	#6,1(a0)
		bne.w	loc_7BB8
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj11_Index(pc,d0.w),d1
		jmp	Obj11_Index(pc,d1.w)
; ===============================================================================

loc_7BB8:				; CODE XREF: ROM:00007BA6j
		moveq	#3,d0
		bra.w	DisplaySprite_Param
; ===============================================================================
Obj11_Index:	dc.w loc_7BC6-Obj11_Index ; DATA XREF: ROM:Obj11_Indexo
					; ROM:00007BC0o ...
		dc.w loc_7CC8-Obj11_Index
		dc.w loc_7D5A-Obj11_Index
		dc.w loc_7D5E-Obj11_Index
; ===============================================================================

loc_7BC6:				; DATA XREF: ROM:Obj11_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj11,4(a0)
		move.w	#$44C6,2(a0)
		move.b	#3,$18(a0)
		cmpi.b	#3,(RAM_Level_CurrentZone).w
		bne.s	loc_7BFA
		move.l	#Map_Obj11_EHZ,4(a0)
		move.w	#$43C6,2(a0)
		move.b	#3,$18(a0)

loc_7BFA:				; CODE XREF: ROM:00007BE4j
		cmpi.b	#4,(RAM_Level_CurrentZone).w
		bne.s	loc_7C14
		addq.b	#4,$24(a0)
		move.l	#Map_Obj11_HPZ,4(a0)
		move.w	#$6300,2(a0)

loc_7C14:				; CODE XREF: ROM:00007C00j
		bsr.w	ModifySpriteAttr_2P
		move.b	#4,1(a0)
		move.b	#$80,$19(a0)
		move.w	$C(a0),d2
		move.w	d2,$3C(a0)
		move.w	8(a0),d3
		lea	$28(a0),a2
		moveq	#0,d1
		move.b	(a2),d1
		move.w	d1,d0
		lsr.w	#1,d0
		lsl.w	#4,d0
		sub.w	d0,d3
		swap	d1
		move.w	#8,d1
		bsr.s	sub_7C76
		move.w	$28(a1),d0
		subq.w	#8,d0
		move.w	d0,8(a1)
		move.l	a1,$30(a0)
		swap	d1
		subq.w	#8,d1
		bls.s	loc_7C74
		move.w	d1,d4
		bsr.s	sub_7C76
		move.l	a1,$34(a0)
		move.w	d4,d0
		add.w	d0,d0
		add.w	d4,d0
		move.w	$10(a1,d0.w),d0
		subq.w	#8,d0
		move.w	d0,8(a1)

loc_7C74:				; CODE XREF: ROM:00007C5Aj
		bra.s	loc_7CC8

; =============== S U B R O U T I N E ==========================================


sub_7C76:				; CODE XREF: ROM:00007C46p
					; ROM:00007C5Ep
		bsr.w	S1SingleObjectLoad2
		bne.s	locret_7CC6
		move.b	0(a0),0(a1)
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		move.l	4(a0),4(a1)
		move.w	2(a0),2(a1)
		move.b	1(a0),1(a1)
		bset	#6,1(a1)
		move.b	#$40,$E(a1) ; '@'
		move.b	d1,$F(a1)
		subq.b	#1,d1
		lea	$10(a1),a2

loc_7CB6:				; CODE XREF: sub_7C76+4Cj
		move.w	d3,(a2)+
		move.w	d2,(a2)+
		move.w	#0,(a2)+
		addi.w	#$10,d3
		dbf	d1,loc_7CB6

locret_7CC6:				; CODE XREF: sub_7C76+4j
		rts
; End of function sub_7C76

; ===============================================================================

loc_7CC8:				; CODE XREF: ROM:loc_7C74j
					; DATA XREF: ROM:00007BC0o
		move.b	$22(a0),d0
		andi.b	#$18,d0
		bne.s	loc_7CDE
		tst.b	$3E(a0)
		beq.s	loc_7D0A
		subq.b	#4,$3E(a0)
		bra.s	loc_7D06
; ===============================================================================

loc_7CDE:				; CODE XREF: ROM:00007CD0j
		andi.b	#$10,d0
		beq.s	loc_7CFA
		move.b	$3F(a0),d0
		sub.b	$3B(a0),d0
		beq.s	loc_7CFA
		bcc.s	loc_7CF6
		addq.b	#1,$3F(a0)
		bra.s	loc_7CFA
; ===============================================================================

loc_7CF6:				; CODE XREF: ROM:00007CEEj
		subq.b	#1,$3F(a0)

loc_7CFA:				; CODE XREF: ROM:00007CE2j
					; ROM:00007CECj ...
		cmpi.b	#$40,$3E(a0) ; '@'
		beq.s	loc_7D06
		addq.b	#4,$3E(a0)

loc_7D06:				; CODE XREF: ROM:00007CDCj
					; ROM:00007D00j
		bsr.w	sub_7F36

loc_7D0A:				; CODE XREF: ROM:00007CD6j
		moveq	#0,d1
		move.b	$28(a0),d1
		lsl.w	#3,d1
		move.w	d1,d2
		addq.w	#8,d1
		add.w	d2,d2
		moveq	#8,d3
		move.w	8(a0),d4
		bsr.w	sub_7DC0

loc_7D22:				; CODE XREF: ROM:00007DBCj
		tst.w	(RAM_Flag_SplitScreen).w
		beq.s	loc_7D2A
		rts
; ===============================================================================

loc_7D2A:				; CODE XREF: ROM:00007D26j
		move.w	8(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.s	loc_7D3E
		rts
; ===============================================================================

loc_7D3E:				; CODE XREF: ROM:00007D3Aj
		movea.l	$30(a0),a1
		bsr.w	sub_CF3C
		cmpi.b	#8,$28(a0)
		bls.s	loc_7D56
		movea.l	$34(a0),a1
		bsr.w	sub_CF3C

loc_7D56:				; CODE XREF: ROM:00007D4Cj
		bra.w	DeleteObject
; ===============================================================================

loc_7D5A:				; DATA XREF: ROM:00007BC2o
		bra.w	DisplaySprite
; ===============================================================================

loc_7D5E:				; DATA XREF: ROM:00007BC4o
		move.b	$22(a0),d0
		andi.b	#$18,d0
		bne.s	loc_7D74
		tst.b	$3E(a0)
		beq.s	loc_7DA0
		subq.b	#4,$3E(a0)
		bra.s	loc_7D9C
; ===============================================================================

loc_7D74:				; CODE XREF: ROM:00007D66j
		andi.b	#$10,d0
		beq.s	loc_7D90
		move.b	$3F(a0),d0
		sub.b	$3B(a0),d0
		beq.s	loc_7D90
		bcc.s	loc_7D8C
		addq.b	#1,$3F(a0)
		bra.s	loc_7D90
; ===============================================================================

loc_7D8C:				; CODE XREF: ROM:00007D84j
		subq.b	#1,$3F(a0)

loc_7D90:				; CODE XREF: ROM:00007D78j
					; ROM:00007D82j ...
		cmpi.b	#$40,$3E(a0) ; '@'
		beq.s	loc_7D9C
		addq.b	#4,$3E(a0)

loc_7D9C:				; CODE XREF: ROM:00007D72j
					; ROM:00007D96j
		bsr.w	sub_7F36

loc_7DA0:				; CODE XREF: ROM:00007D6Cj
		moveq	#0,d1
		move.b	$28(a0),d1
		lsl.w	#3,d1
		move.w	d1,d2
		addq.w	#8,d1
		add.w	d2,d2
		moveq	#8,d3
		move.w	8(a0),d4
		bsr.w	sub_7DC0
		bsr.w	sub_7E60
		bra.w	loc_7D22

; =============== S U B R O U T I N E ==========================================


sub_7DC0:				; CODE XREF: ROM:00007D1Ep
					; ROM:00007DB4p
		lea	(RAM_ObjRAM_Tails).w,a1
		moveq	#4,d6
		moveq	#$3B,d5	; ';'
		movem.l	d1-d4,-(sp)
		bsr.s	sub_7DDA
		movem.l	(sp)+,d1-d4
		lea	(RAM_ObjRAM_Sonic).w,a1
		subq.b	#1,d6
		moveq	#$3F,d5	; '?'
; End of function sub_7DC0


; =============== S U B R O U T I N E ==========================================


sub_7DDA:				; CODE XREF: sub_7DC0+Cp
		btst	d6,$22(a0)
		beq.s	loc_7E3E
		btst	#1,$22(a1)
		bne.s	loc_7DFA
		moveq	#0,d0
		move.w	8(a1),d0
		sub.w	8(a0),d0
		add.w	d1,d0
		bmi.s	loc_7DFA
		cmp.w	d2,d0
		bcs.s	loc_7E08

loc_7DFA:				; CODE XREF: sub_7DDA+Cj sub_7DDA+1Aj
		bclr	#3,$22(a1)
		bclr	d6,$22(a0)
		moveq	#0,d4
		rts
; ===============================================================================

loc_7E08:				; CODE XREF: sub_7DDA+1Ej
		lsr.w	#4,d0
		move.b	d0,(a0,d5.w)
		movea.l	$30(a0),a2
		cmpi.w	#8,d0
		bcs.s	loc_7E20
		movea.l	$34(a0),a2
		subi.w	#8,d0

loc_7E20:				; CODE XREF: sub_7DDA+3Cj
		add.w	d0,d0
		move.w	d0,d1
		add.w	d0,d0
		add.w	d1,d0
		move.w	$12(a2,d0.w),d0
		subq.w	#8,d0
		moveq	#0,d1
		move.b	$16(a1),d1
		sub.w	d1,d0
		move.w	d0,$C(a1)
		moveq	#0,d4
		rts
; ===============================================================================

loc_7E3E:				; CODE XREF: sub_7DDA+4j
		move.w	d1,-(sp)
		bsr.w	sub_F880
		move.w	(sp)+,d1
		btst	d6,$22(a0)
		beq.s	locret_7E5E
		moveq	#0,d0
		move.w	8(a1),d0
		sub.w	8(a0),d0
		add.w	d1,d0
		lsr.w	#4,d0
		move.b	d0,(a0,d5.w)

locret_7E5E:				; CODE XREF: sub_7DDA+70j
		rts
; End of function sub_7DDA


; =============== S U B R O U T I N E ==========================================


sub_7E60:				; CODE XREF: ROM:00007DB8p
		moveq	#0,d0
		tst.w	(RAM_ObjRam_Sonic+$10).w
		bne.s	loc_7E72
		move.b	(RAM_VIntFrameCnt+3).w,d0
		andi.w	#$1C,d0
		lsr.w	#1,d0

loc_7E72:				; CODE XREF: sub_7E60+6j
		moveq	#0,d2
		move.b	byte_7E9F(pc,d0.w),d2
		swap	d2
		move.b	byte_7E9E(pc,d0.w),d2
		moveq	#0,d0
		tst.w	(RAM_ObjRam_Tails+$10).w
		bne.s	loc_7E90
		move.b	(RAM_VIntFrameCnt+3).w,d0
		andi.w	#$1C,d0
		lsr.w	#1,d0

loc_7E90:				; CODE XREF: sub_7E60+24j
		moveq	#0,d6
		move.b	byte_7E9F(pc,d0.w),d6
		swap	d6
		move.b	byte_7E9E(pc,d0.w),d6
		bra.s	loc_7EAE
; ===============================================================================
byte_7E9E:	dc.b 1
byte_7E9F:	dc.b   2,  1,  2,  1,  2,  1,  2,  0,  1,  0,  0,  0,  0,  0,  1; 0
; ===============================================================================

loc_7EAE:				; CODE XREF: sub_7E60+3Cj
		moveq	#$FFFFFFFE,d3
		moveq	#$FFFFFFFE,d4
		move.b	$22(a0),d0
		andi.b	#8,d0
		beq.s	loc_7EC0
		move.b	$3F(a0),d3

loc_7EC0:				; CODE XREF: sub_7E60+5Aj
		move.b	$22(a0),d0
		andi.b	#$10,d0
		beq.s	loc_7ECE
		move.b	$3B(a0),d4

loc_7ECE:				; CODE XREF: sub_7E60+68j
		movea.l	$30(a0),a1
		lea	$45(a1),a2
		lea	$15(a1),a1
		moveq	#0,d1
		move.b	$28(a0),d1
		subq.b	#1,d1
		moveq	#0,d5

loc_7EE4:				; CODE XREF: sub_7E60:loc_7F30j
		moveq	#0,d0
		subq.w	#1,d3
		cmp.b	d3,d5
		bne.s	loc_7EEE
		move.w	d2,d0

loc_7EEE:				; CODE XREF: sub_7E60+8Aj
		addq.w	#2,d3
		cmp.b	d3,d5
		bne.s	loc_7EF6
		move.w	d2,d0

loc_7EF6:				; CODE XREF: sub_7E60+92j
		subq.w	#1,d3
		subq.w	#1,d4
		cmp.b	d4,d5
		bne.s	loc_7F00
		move.w	d6,d0

loc_7F00:				; CODE XREF: sub_7E60+9Cj
		addq.w	#2,d4
		cmp.b	d4,d5
		bne.s	loc_7F08
		move.w	d6,d0

loc_7F08:				; CODE XREF: sub_7E60+A4j
		subq.w	#1,d4
		cmp.b	d3,d5
		bne.s	loc_7F14
		swap	d2
		move.w	d2,d0
		swap	d2

loc_7F14:				; CODE XREF: sub_7E60+ACj
		cmp.b	d4,d5
		bne.s	loc_7F1E
		swap	d6
		move.w	d6,d0
		swap	d6

loc_7F1E:				; CODE XREF: sub_7E60+B6j
		move.b	d0,(a1)
		addq.w	#1,d5
		addq.w	#6,a1
		cmpa.w	a2,a1
		bne.s	loc_7F30
		movea.l	$34(a0),a1
		lea	$15(a1),a1

loc_7F30:				; CODE XREF: sub_7E60+C6j
		dbf	d1,loc_7EE4
		rts
; End of function sub_7E60


; =============== S U B R O U T I N E ==========================================


sub_7F36:				; CODE XREF: ROM:loc_7D06p
					; ROM:loc_7D9Cp
		move.b	$3E(a0),d0
		bsr.w	CalcSine
		move.w	d0,d4
		lea	(Obj11_BendData2).l,a4
		moveq	#0,d0
		move.b	$28(a0),d0
		lsl.w	#4,d0
		moveq	#0,d3
		move.b	$3F(a0),d3
		move.w	d3,d2
		add.w	d0,d3
		moveq	#0,d5
		lea	(Obj11_BendData-$80).l,a5
		move.b	(a5,d3.w),d5

loc_7F64:
		andi.w	#$F,d3
		lsl.w	#4,d3
		lea	(a4,d3.w),a3
		movea.l	$30(a0),a1
		lea	$42(a1),a2
		lea	$12(a1),a1

loc_7F7A:				; CODE XREF: sub_7F36:loc_7F9Aj
		moveq	#0,d0
		move.b	(a3)+,d0
		addq.w	#1,d0
		mulu.w	d5,d0
		mulu.w	d4,d0
		swap	d0
		add.w	$3C(a0),d0
		move.w	d0,(a1)
		addq.w	#6,a1
		cmpa.w	a2,a1
		bne.s	loc_7F9A
		movea.l	$34(a0),a1
		lea	$12(a1),a1

loc_7F9A:				; CODE XREF: sub_7F36+5Aj
		dbf	d2,loc_7F7A
		moveq	#0,d0
		move.b	$28(a0),d0
		moveq	#0,d3
		move.b	$3F(a0),d3
		addq.b	#1,d3
		sub.b	d0,d3
		neg.b	d3
		bmi.s	locret_7FE4
		move.w	d3,d2
		lsl.w	#4,d3
		lea	(a4,d3.w),a3
		adda.w	d2,a3
		subq.w	#1,d2
		bcs.s	locret_7FE4

loc_7FC0:				; CODE XREF: sub_7F36:loc_7FE0j
		moveq	#0,d0
		move.b	-(a3),d0
		addq.w	#1,d0
		mulu.w	d5,d0
		mulu.w	d4,d0
		swap	d0
		add.w	$3C(a0),d0
		move.w	d0,(a1)
		addq.w	#6,a1
		cmpa.w	a2,a1
		bne.s	loc_7FE0
		movea.l	$34(a0),a1
		lea	$12(a1),a1

loc_7FE0:				; CODE XREF: sub_7F36+A0j
		dbf	d2,loc_7FC0

locret_7FE4:				; CODE XREF: sub_7F36+7Aj sub_7F36+88j
		rts
; End of function sub_7F36

; ===============================================================================
Obj11_BendData:	dc.b   2,  4,  6,  8,  8,  6,  4,  2,  0,  0,  0,  0,  0,  0,  0,  0; 0
					; DATA XREF: sub_7F36+24t
		dc.b   2,  4,  6,  8, $A,  8,  6,  4,  2,  0,  0,  0,  0,  0,  0,  0; 16
		dc.b   2,  4,  6,  8, $A, $A,  8,  6,  4,  2,  0,  0,  0,  0,  0,  0; 32
		dc.b   2,  4,  6,  8, $A, $C, $A,  8,  6,  4,  2,  0,  0,  0,  0,  0; 48
		dc.b   2,  4,  6,  8, $A, $C, $C, $A,  8,  6,  4,  2,  0,  0,  0,  0; 64
		dc.b   2,  4,  6,  8, $A, $C, $E, $C, $A,  8,  6,  4,  2,  0,  0,  0; 80
		dc.b   2,  4,  6,  8, $A, $C, $E, $E, $C, $A,  8,  6,  4,  2,  0,  0; 96
		dc.b   2,  4,  6,  8, $A, $C, $E,$10, $E, $C, $A,  8,  6,  4,  2,  0; 112
		dc.b   2,  4,  6,  8, $A, $C, $E,$10,$10, $E, $C, $A,  8,  6,  4,  2; 128
Obj11_BendData2:dc.b $FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 0
					; DATA XREF: sub_7F36+Ao
		dc.b $B5,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 16
		dc.b $7E,$DB,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 32
		dc.b $61,$B5,$EC,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 48
		dc.b $4A,$93,$CD,$F3,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 64
		dc.b $3E,$7E,$B0,$DB,$F6,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 80
		dc.b $38,$6D,$9D,$C5,$E4,$F8,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0; 96
		dc.b $31,$61,$8E,$B5,$D4,$EC,$FB,$FF,  0,  0,  0,  0,  0,  0,  0,  0; 112
		dc.b $2B,$56,$7E,$A2,$C1,$DB,$EE,$FB,$FF,  0,  0,  0,  0,  0,  0,  0; 128
		dc.b $25,$4A,$73,$93,$B0,$CD,$E1,$F3,$FC,$FF,  0,  0,  0,  0,  0,  0; 144
		dc.b $1F,$44,$67,$88,$A7,$BD,$D4,$E7,$F4,$FD,$FF,  0,  0,  0,  0,  0; 160
		dc.b $1F,$3E,$5C,$7E,$98,$B0,$C9,$DB,$EA,$F6,$FD,$FF,  0,  0,  0,  0; 176
		dc.b $19,$38,$56,$73,$8E,$A7,$BD,$D1,$E1,$EE,$F8,$FE,$FF,  0,  0,  0; 192
		dc.b $19,$38,$50,$6D,$83,$9D,$B0,$C5,$D8,$E4,$F1,$F8,$FE,$FF,  0,  0; 208
		dc.b $19,$31,$4A,$67,$7E,$93,$A7,$BD,$CD,$DB,$E7,$F3,$F9,$FE,$FF,  0; 224
		dc.b $19,$31,$4A,$61,$78,$8E,$A2,$B5,$C5,$D4,$E1,$EC,$F4,$FB,$FE,$FF; 240
Map_Obj11:	dc.w word_817C-Map_Obj11 ; DATA	XREF: ROM:00007BCAo
					; ROM:Map_Obj11o ...
		dc.w word_8186-Map_Obj11
		dc.w word_8198-Map_Obj11
word_817C:	dc.w 1			; DATA XREF: ROM:Map_Obj11o
		dc.w $F805,    0,    0,$FFF8; 0
word_8186:	dc.w 2			; DATA XREF: ROM:00008178o
		dc.w $F804,    4,    2,$FFF0; 0
		dc.w	$C,    6,    3,$FFF0; 4
word_8198:	dc.w 1			; DATA XREF: ROM:0000817Ao
		dc.w $FC04,    8,    4,$FFF8; 0
Map_Obj11_HPZ:	dc.w word_81AE-Map_Obj11_HPZ ; DATA XREF: ROM:00007C06o
					; ROM:Map_Obj11_HPZo ...
		dc.w word_81B8-Map_Obj11_HPZ
		dc.w word_81C2-Map_Obj11_HPZ
		dc.w word_81CC-Map_Obj11_HPZ
		dc.w word_81D6-Map_Obj11_HPZ
		dc.w word_81E0-Map_Obj11_HPZ
word_81AE:	dc.w 1			; DATA XREF: ROM:Map_Obj11_HPZo
		dc.w $F805,    0,    0,$FFF8; 0
word_81B8:	dc.w 1			; DATA XREF: ROM:000081A4o
		dc.w $F805,    4,    2,$FFF8; 0
word_81C2:	dc.w 1			; DATA XREF: ROM:000081A6o
		dc.w $F805,    8,    4,$FFF8; 0
word_81CC:	dc.w 1			; DATA XREF: ROM:000081A8o
		dc.w $F402,   $C,    6,$FFFC; 0
word_81D6:	dc.w 1			; DATA XREF: ROM:000081AAo
		dc.w $F402,   $F,    7,$FFFC; 0
word_81E0:	dc.w 1			; DATA XREF: ROM:000081ACo
word_81E2:	dc.w $F402,  $12,    9,$FFFC; 0
Map_Obj11_EHZ:	dc.w word_81EE-Map_Obj11_EHZ ; DATA XREF: ROM:00007BE6o
					; ROM:Map_Obj11_EHZo ...
		dc.w word_81F8-Map_Obj11_EHZ
word_81EE:	dc.w 1			; DATA XREF: ROM:Map_Obj11_EHZo
		dc.w $F805,    4,    2,$FFF8; 0
word_81F8:	dc.w 1			; DATA XREF: ROM:000081ECo
		dc.w $F805,    0,    0,$FFF8; 0
; ===============================================================================
		nop
;----------------------------------------------------
; Object 15 - swinging platforms
;----------------------------------------------------

Obj15:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj15_Index(pc,d0.w),d1
		jmp	Obj15_Index(pc,d1.w)
; ===============================================================================
Obj15_Index:	dc.w loc_821E-Obj15_Index ; DATA XREF: ROM:Obj15_Indexo
					; ROM:00008214o ...
		dc.w loc_83AA-Obj15_Index
		dc.w loc_8526-Obj15_Index
		dc.w loc_8526-Obj15_Index
		dc.w loc_852A-Obj15_Index
		dc.w loc_83CA-Obj15_Index
; ===============================================================================

loc_821E:				; DATA XREF: ROM:Obj15_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj15,4(a0)
		move.w	#$44D0,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#4,1(a0)
		move.b	#3,$18(a0)
		move.b	#$18,$19(a0)
		move.b	#8,$16(a0)
		move.w	$C(a0),$38(a0)
		move.w	8(a0),$3A(a0)
		cmpi.b	#3,(RAM_Level_CurrentZone).w
		bne.s	loc_8284
		move.l	#Map_Obj15_EHZ,4(a0)
		move.w	#$43DC,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#$20,$19(a0) ; ' '
		move.b	#$10,$16(a0)
		move.b	#$99,$20(a0)

loc_8284:				; CODE XREF: ROM:0000825Ej
		cmpi.b	#2,(RAM_Level_CurrentZone).w
		bne.s	loc_82BE
		move.l	#Map_Obj15_CPZ,4(a0)
		move.w	#$2418,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#$20,$19(a0) ; ' '
		move.b	#$10,$16(a0)
		lea	$28(a0),a2
		move.b	(a2),d0
		lsl.w	#4,d0
		move.b	d0,$3C(a0)
		move.b	#0,(a2)+
		bra.w	loc_8388
; ===============================================================================

loc_82BE:				; CODE XREF: ROM:0000828Aj
		move.b	0(a0),d4
		moveq	#0,d1
		lea	$28(a0),a2
		move.b	(a2),d1
		move.w	d1,-(sp)
		andi.w	#$F,d1
		move.b	#0,(a2)+
		move.w	d1,d3
		lsl.w	#4,d3
		addi.b	#8,d3
		move.b	d3,$3C(a0)
		subi.b	#8,d3
		tst.b	$1A(a0)
		beq.s	loc_82F0
		addi.b	#8,d3
		subq.w	#1,d1

loc_82F0:				; CODE XREF: ROM:000082E8j
					; ROM:loc_8358j
		bsr.w	S1SingleObjectLoad2
		bne.s	loc_835C
		addq.b	#1,$28(a0)
		move.w	a1,d5
		subi.w	#$B000,d5
		lsr.w	#6,d5
		andi.w	#$7F,d5	; ''
		move.b	d5,(a2)+
		move.b	#8,$24(a1)
		move.b	d4,0(a1)
		move.l	4(a0),4(a1)
		move.w	2(a0),2(a1)
		bclr	#6,2(a1)
		move.b	#4,1(a1)
		move.b	#4,$18(a1)
		move.b	#8,$19(a1)
		move.b	#1,$1A(a1)
		move.b	d3,$3C(a1)
		subi.b	#$10,d3
		bcc.s	loc_8358
		move.b	#2,$1A(a1)
		move.b	#3,$18(a1)
		bset	#6,2(a1)

loc_8358:				; CODE XREF: ROM:00008344j
		dbf	d1,loc_82F0

loc_835C:				; CODE XREF: ROM:000082F4j
		move.w	(sp)+,d1
		btst	#4,d1
		beq.s	loc_8388
		move.l	#Map_Obj48,4(a0)
		move.w	#$43AA,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#1,$1A(a0)
		move.b	#2,$18(a0)
		move.b	#$81,$20(a0)

loc_8388:				; CODE XREF: ROM:000082BAj
					; ROM:00008362j
		move.w	a0,d5
		subi.w	#$B000,d5
		lsr.w	#6,d5
		andi.w	#$7F,d5	; ''
		move.b	d5,(a2)+
		move.w	#$4080,$26(a0)
		move.w	#$FE00,$3E(a0)
		cmpi.b	#5,(RAM_Level_CurrentZone).w
		beq.s	loc_83CA

loc_83AA:				; DATA XREF: ROM:00008214o
		move.w	8(a0),-(sp)
		bsr.w	sub_83D2
		moveq	#0,d1
		move.b	$19(a0),d1
		moveq	#0,d3
		move.b	$16(a0),d3
		addq.b	#1,d3
		move.w	(sp)+,d4
		bsr.w	sub_F82E
		bra.w	loc_84EE
; ===============================================================================

loc_83CA:
		bsr.w	sub_83D2
		bra.w	loc_84EE

; =============== S U B R O U T I N E ==========================================


sub_83D2:
		move.b	(RAM_RandomTimers_Buff+$1A).w,d0
		move.w	#$80,d1
		btst	#0,$22(a0)
		beq.s	loc_83E6
		neg.w	d0
		add.w	d1,d0

loc_83E6:
		bra.w	loc_8472
; ===============================================================================

loc_83EA:
		tst.b	$3D(a0)
		bne.s	loc_840E
		move.w	$3E(a0),d0
		addi.w	#8,d0
		move.w	d0,$3E(a0)
		add.w	d0,$26(a0)
		cmpi.w	#$200,d0
		bne.s	loc_842A
		move.b	#1,$3D(a0)
		bra.s	loc_842A
; ===============================================================================

loc_840E:				; CODE XREF: sub_83D2+1Cj
		move.w	$3E(a0),d0
		subi.w	#8,d0
		move.w	d0,$3E(a0)
		add.w	d0,$26(a0)
		cmpi.w	#$FE00,d0
		bne.s	loc_842A
		move.b	#0,$3D(a0)

loc_842A:				; CODE XREF: sub_83D2+32j sub_83D2+3Aj ...
		move.b	$26(a0),d0

loc_842E:				; CODE XREF: ROM:0001921Ap
		bsr.w	CalcSine
		move.w	$38(a0),d2
		move.w	$3A(a0),d3
		lea	$28(a0),a2
		moveq	#0,d6
		move.b	(a2)+,d6

loc_8442:				; CODE XREF: sub_83D2+9Aj
		moveq	#0,d4
		move.b	(a2)+,d4
		lsl.w	#6,d4
		addi.l	#RAM_ObjectTable,d4
		movea.l	d4,a1
		moveq	#0,d4
		move.b	$3C(a1),d4
		move.l	d4,d5
		muls.w	d0,d4
		asr.l	#8,d4
		muls.w	d1,d5
		asr.l	#8,d5
		add.w	d2,d4
		add.w	d3,d5
		move.w	d4,$C(a1)
		move.w	d5,8(a1)
		dbf	d6,loc_8442
		rts
; ===============================================================================

loc_8472:				; CODE XREF: sub_83D2:loc_83E6j
		bsr.w	CalcSine
		move.w	$38(a0),d2
		move.w	$3A(a0),d3
		moveq	#0,d4
		move.b	$3C(a0),d4
		move.l	d4,d5
		muls.w	d0,d4
		asr.l	#8,d4
		muls.w	d1,d5
		asr.l	#8,d5
		add.w	d2,d4
		add.w	d3,d5
		move.w	d4,$C(a0)
		move.w	d5,8(a0)
		lea	$28(a0),a2
		moveq	#0,d6
		move.b	(a2)+,d6
		adda.w	d6,a2
		subq.b	#1,d6
		bcs.s	locret_84EC
		move.w	d6,-(sp)
		asl.w	#4,d0
		ext.l	d0
		asl.l	#8,d0
		asl.w	#4,d1
		ext.l	d1
		asl.l	#8,d1
		moveq	#0,d4
		moveq	#0,d5

loc_84BA:				; CODE XREF: sub_83D2+114j
		moveq	#0,d6
		move.b	-(a2),d6
		lsl.w	#6,d6
		addi.l	#RAM_ObjectTable,d6
		movea.l	d6,a1
		movem.l	d4-d5,-(sp)
		swap	d4
		swap	d5
		add.w	d2,d4
		add.w	d3,d5
		move.w	d4,$C(a1)
		move.w	d5,8(a1)
		movem.l	(sp)+,d4-d5
		add.l	d0,d4
		add.l	d1,d5
		subq.w	#1,(sp)
		bcc.w	loc_84BA
		addq.w	#2,sp

locret_84EC:				; CODE XREF: sub_83D2+D4j
		rts
; End of function sub_83D2

; ===============================================================================

loc_84EE:				; CODE XREF: ROM:000083C6j
					; ROM:000083CEj
		move.w	$3A(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_8506
		bra.w	DisplaySprite
; ===============================================================================

loc_8506:				; CODE XREF: ROM:000084FEj
		moveq	#0,d2
		lea	$28(a0),a2
		move.b	(a2)+,d2

loc_850E:				; CODE XREF: ROM:00008520j
		moveq	#0,d0
		move.b	(a2)+,d0
		lsl.w	#6,d0
		addi.l	#RAM_ObjectTable,d0
		movea.l	d0,a1
		bsr.w	sub_CF3C
		dbf	d2,loc_850E
		rts
; ===============================================================================

loc_8526:				; DATA XREF: ROM:00008216o
					; ROM:00008218o
		bra.w	DeleteObject
; ===============================================================================

loc_852A:				; DATA XREF: ROM:0000821Ao
		bra.w	DisplaySprite
; ===============================================================================
Map_Obj15:	dc.w word_8534-Map_Obj15 ; DATA	XREF: ROM:00008222o
					; ROM:Map_Obj15o ...
		dc.w word_8546-Map_Obj15
		dc.w word_8550-Map_Obj15
word_8534:	dc.w 2			; DATA XREF: ROM:Map_Obj15o
		dc.w $F809,    4,    2,$FFE8; 0
		dc.w $F809,    4,    2,	   0; 4
word_8546:	dc.w 1			; DATA XREF: ROM:00008530o
		dc.w $F805,    0,    0,$FFF8; 0
word_8550:	dc.w 1			; DATA XREF: ROM:00008532o
		dc.w $F805,   $A,    5,$FFF8; 0
Map_Obj15_CPZ:	dc.w word_855C-Map_Obj15_CPZ ; DATA XREF: ROM:0000828Co
					; ROM:Map_Obj15_CPZo ...
word_855C:	dc.w 2			; DATA XREF: ROM:Map_Obj15_CPZo
		dc.w $F00F,    8,    4,$FFE0; 0
		dc.w $F00F, $808, $804,	   0; 4
Map_Obj15_EHZ:	dc.w word_8574-Map_Obj15_EHZ ; DATA XREF: ROM:00008260o
					; ROM:Map_Obj15_EHZo ...
		dc.w word_85B6-Map_Obj15_EHZ
		dc.w word_85C0-Map_Obj15_EHZ
word_8574:	dc.w 8			; DATA XREF: ROM:Map_Obj15_EHZo
		dc.w $F00F,    4,    2,$FFE0; 0
		dc.w $F00F, $804, $802,	   0; 4
		dc.w $F005,  $14,   $A,$FFD0; 8
		dc.w $F005, $814, $80A,	 $20; 12
		dc.w $1004,  $18,   $C,$FFE0; 16
		dc.w $1004, $818, $80C,	 $10; 20
		dc.w $1001,  $1A,   $D,$FFF8; 24
		dc.w $1001, $81A, $80D,	   0; 28
word_85B6:	dc.w 1			; DATA XREF: ROM:00008570o
		dc.w $F805,$4000,$4000,$FFF8; 0
word_85C0:	dc.w 1			; DATA XREF: ROM:00008572o
		dc.w $F805,  $1C,   $E,$FFF8; 0
Map_Obj48:	dc.w word_85D2-Map_Obj48 ; DATA	XREF: ROM:00008364o
					; ROM:Map_Obj48o ...
		dc.w word_8604-Map_Obj48
		dc.w word_8626-Map_Obj48
		dc.w word_8648-Map_Obj48
word_85D2:	dc.w 6			; DATA XREF: ROM:Map_Obj48o
		dc.w $F004,  $24,  $12,$FFF0; 0
		dc.w $F804,$1024,$1012,$FFF0; 4
		dc.w $E80A,    0,    0,$FFE8; 8
		dc.w $E80A, $800, $800,	   0; 12
		dc.w	$A,$1000,$1000,$FFE8; 16
		dc.w	$A,$1800,$1800,	   0; 20
word_8604:	dc.w 4			; DATA XREF: ROM:000085CCo
		dc.w $E80A,    9,    4,$FFE8; 0
		dc.w $E80A, $809, $804,	   0; 4
		dc.w	$A,$1009,$1004,$FFE8; 8
		dc.w	$A,$1809,$1804,	   0; 12
word_8626:	dc.w 4			; DATA XREF: ROM:000085CEo
		dc.w $E80A,  $12,    9,$FFE8; 0
		dc.w $E80A,  $1B,   $D,	   0; 4
		dc.w	$A,$181B,$180D,$FFE8; 8
		dc.w	$A,$1812,$1809,	   0; 12
word_8648:	dc.w 4			; DATA XREF: ROM:000085D0o
		dc.w $E80A, $81B, $80D,$FFE8; 0
		dc.w $E80A, $812, $809,	   0; 4
		dc.w	$A,$1012,$1009,$FFE8; 8
		dc.w	$A,$101B,$100D,	   0; 12
; ===============================================================================
		nop

Obj17:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj17_Index(pc,d0.w),d1
		jmp	Obj17_Index(pc,d1.w)
; ===============================================================================
Obj17_Index:	dc.w loc_8680-Obj17_Index ; DATA XREF: ROM:Obj17_Indexo
					; ROM:0000867Co ...
		dc.w loc_874A-Obj17_Index
		dc.w loc_87AC-Obj17_Index
; ===============================================================================

loc_8680:				; DATA XREF: ROM:Obj17_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj17,4(a0)
		move.w	#$4398,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#7,$22(a0)
		move.b	#4,1(a0)
		move.b	#3,$18(a0)
		move.b	#8,$19(a0)
		move.w	$C(a0),d2
		move.w	8(a0),d3
		move.b	0(a0),d4
		lea	$28(a0),a2
		moveq	#0,d1
		move.b	(a2),d1
		move.b	#0,(a2)+
		move.w	d1,d0
		lsr.w	#1,d0
		lsl.w	#4,d0
		sub.w	d0,d3
		subq.b	#2,d1
		bcs.s	loc_874A
		moveq	#0,d6

loc_86D4:				; CODE XREF: ROM:loc_8746j
		bsr.w	S1SingleObjectLoad2
		bne.s	loc_874A
		addq.b	#1,$28(a0)
		move.w	a1,d5
		subi.w	#$B000,d5
		lsr.w	#6,d5
		andi.w	#$7F,d5	; ''
		move.b	d5,(a2)+
		move.b	#4,$24(a1)
		move.b	d4,0(a1)
		move.w	d2,$C(a1)
		move.w	d3,8(a1)
		move.l	4(a0),4(a1)
		move.w	#$4398,2(a1)
		bsr.w	ModifyA1SpriteAttr_2P
		move.b	#4,1(a1)
		move.b	#3,$18(a1)
		move.b	#8,$19(a1)
		move.b	d6,$3E(a1)
		addq.b	#1,d6
		andi.b	#7,d6
		addi.w	#$10,d3
		cmp.w	8(a0),d3
		bne.s	loc_8746
		move.b	d6,$3E(a0)
		addq.b	#1,d6
		andi.b	#7,d6
		addi.w	#$10,d3
		addq.b	#1,$28(a0)

loc_8746:				; CODE XREF: ROM:00008732j
		dbf	d1,loc_86D4

loc_874A:				; CODE XREF: ROM:000086D0j
					; ROM:000086D8j
					; DATA XREF: ...
		bsr.w	sub_878C
		move.w	8(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_8766
		bra.w	DisplaySprite
; ===============================================================================

loc_8766:				; CODE XREF: ROM:0000875Ej
		moveq	#0,d2
		lea	$28(a0),a2
		move.b	(a2)+,d2
		subq.b	#2,d2
		bcs.s	loc_8788

loc_8772:				; CODE XREF: ROM:00008784j
		moveq	#0,d0
		move.b	(a2)+,d0
		lsl.w	#6,d0
		addi.l	#RAM_ObjectTable,d0
		movea.l	d0,a1
		bsr.w	sub_CF3C
		dbf	d2,loc_8772

loc_8788:				; CODE XREF: ROM:00008770j
		bra.w	DeleteObject

; =============== S U B R O U T I N E ==========================================


sub_878C:
		move.b	(RAM_ObjSpecial_RingFrame_2).w,d0
		move.b	#0,$20(a0)
		add.b	$3E(a0),d0
		andi.b	#7,d0
		move.b	d0,$1A(a0)
		bne.s	locret_87AA
		move.b	#$84,$20(a0)

locret_87AA:
		rts

; ===============================================================================

loc_87AC:
		bsr.w	sub_878C
		bra.w	DisplaySprite
; ===============================================================================
Map_Obj17:	dc.w word_87C4-Map_Obj17
		dc.w word_87CE-Map_Obj17
		dc.w word_87D8-Map_Obj17
		dc.w word_87E2-Map_Obj17
		dc.w word_87EC-Map_Obj17
		dc.w word_87F6-Map_Obj17
		dc.w word_880A-Map_Obj17
		dc.w word_8800-Map_Obj17
word_87C4:	dc.w 1			; DATA XREF: ROM:Map_Obj17o
		dc.w $F001,    0,    0,$FFFC; 0
word_87CE:	dc.w 1			; DATA XREF: ROM:000087B6o
		dc.w $F505,    2,    1,$FFF8; 0
word_87D8:	dc.w 1			; DATA XREF: ROM:000087B8o
		dc.w $F805,    6,    3,$FFF8; 0
word_87E2:	dc.w 1			; DATA XREF: ROM:000087BAo
		dc.w $FB05,   $A,    5,$FFF8; 0
word_87EC:	dc.w 1			; DATA XREF: ROM:000087BCo
		dc.w	 1,   $E,    7,$FFFC; 0
word_87F6:	dc.w 1			; DATA XREF: ROM:000087BEo
		dc.w  $400,  $10,    8,$FFFD; 0
word_8800:	dc.w 1			; DATA XREF: ROM:000087C2o
		dc.w $F400,  $11,    8,$FFFD; 0
word_880A:	dc.w 0			; DATA XREF: ROM:000087C0o
; ===============================================================================

Obj18:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj18_Index(pc,d0.w),d1
		jmp	Obj18_Index(pc,d1.w)
; ===============================================================================
Obj18_Index:	dc.w loc_882C-Obj18_Index ; DATA XREF: ROM:Obj18_Indexo
					; ROM:0000881Co ...
		dc.w loc_88A2-Obj18_Index
		dc.w loc_8908-Obj18_Index
		dc.w loc_88E0-Obj18_Index
Obj18_Conf:	dc.w $2000
		dc.w $2001
		dc.w $2002
		dc.w $4003
		dc.w $3004
; ===============================================================================

loc_882C:				; DATA XREF: ROM:Obj18_Indexo
		addq.b	#2,$24(a0)
		moveq	#0,d0
		move.b	$28(a0),d0
		lsr.w	#3,d0
		andi.w	#$1E,d0
		lea	Obj18_Conf(pc,d0.w),a2
		move.b	(a2)+,$19(a0)
		move.b	(a2)+,$1A(a0)
		move.w	#$4000,2(a0)
		move.l	#Map_Obj18,4(a0)
		cmpi.b	#3,(RAM_Level_CurrentZone).w
		beq.s	loc_8866
		cmpi.b	#5,(RAM_Level_CurrentZone).w
		bne.s	loc_8874

loc_8866:				; CODE XREF: ROM:0000885Cj
		move.l	#Map_Obj18_EHZ,4(a0)
		move.w	#$4000,2(a0)

loc_8874:				; CODE XREF: ROM:00008864j
		bsr.w	ModifySpriteAttr_2P
		move.b	#4,1(a0)
		move.b	#4,$18(a0)
		move.w	$C(a0),$2C(a0)
		move.w	$C(a0),$34(a0)
		move.w	8(a0),$32(a0)
		move.w	#$80,$26(a0) ; ''
		andi.b	#$F,$28(a0)

loc_88A2:				; DATA XREF: ROM:0000881Co
		move.b	$22(a0),d0
		andi.b	#$18,d0
		bne.s	loc_88B8
		tst.b	$38(a0)
		beq.s	loc_88C4
		subq.b	#4,$38(a0)
		bra.s	loc_88C4
; ===============================================================================

loc_88B8:				; CODE XREF: ROM:000088AAj
		cmpi.b	#$40,$38(a0) ; '@'
		beq.s	loc_88C4
		addq.b	#4,$38(a0)

loc_88C4:				; CODE XREF: ROM:000088B0j
					; ROM:000088B6j ...
		move.w	8(a0),-(sp)
		bsr.w	sub_8926
		bsr.w	sub_890C
		moveq	#0,d1
		move.b	$19(a0),d1
		moveq	#8,d3
		move.w	(sp)+,d4
		bsr.w	sub_F78A
		bra.s	loc_88E8
; ===============================================================================

loc_88E0:				; DATA XREF: ROM:00008820o
		bsr.w	sub_8926
		bsr.w	sub_890C

loc_88E8:				; CODE XREF: ROM:000088DEj
		tst.w	(RAM_Flag_SplitScreen).w
		beq.s	loc_88F2
		bra.w	DisplaySprite
; ===============================================================================

loc_88F2:				; CODE XREF: ROM:000088ECj
		move.w	$32(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.s	loc_8908
		bra.w	DisplaySprite
; ===============================================================================

loc_8908:				; CODE XREF: ROM:00008902j
					; DATA XREF: ROM:0000881Eo
		bra.w	DeleteObject

; =============== S U B R O U T I N E ==========================================


sub_890C:				; CODE XREF: ROM:000088CCp
					; ROM:000088E4p
		move.b	$38(a0),d0
		bsr.w	CalcSine
		move.w	#$400,d1
		muls.w	d1,d0
		swap	d0
		add.w	$2C(a0),d0
		move.w	d0,$C(a0)
		rts
; End of function sub_890C


; =============== S U B R O U T I N E ==========================================


sub_8926:				; CODE XREF: ROM:000088C8p
					; ROM:loc_88E0p
		moveq	#0,d0
		move.b	$28(a0),d0
		andi.w	#$F,d0
		add.w	d0,d0
		move.w	off_893A(pc,d0.w),d1
		jmp	off_893A(pc,d1.w)
; End of function sub_8926

; ===============================================================================
off_893A:	dc.w locret_8956-off_893A ; DATA XREF: ROM:off_893Ao
					; ROM:0000893Co ...
		dc.w loc_8968-off_893A
		dc.w loc_89AE-off_893A
		dc.w loc_89C6-off_893A
		dc.w loc_89EE-off_893A
		dc.w loc_8958-off_893A
		dc.w loc_899E-off_893A
		dc.w loc_8A5C-off_893A
		dc.w loc_8A88-off_893A
		dc.w locret_8956-off_893A
		dc.w loc_8AA0-off_893A
		dc.w loc_8ABA-off_893A
		dc.w loc_8990-off_893A
		dc.w loc_8980-off_893A
; ===============================================================================

locret_8956:				; DATA XREF: ROM:off_893Ao
					; ROM:0000894Co
		rts
; ===============================================================================

loc_8958:				; DATA XREF: ROM:00008944o
		move.w	$32(a0),d0
		move.b	$26(a0),d1
		neg.b	d1
		addi.b	#$40,d1	; '@'
		bra.s	loc_8974
; ===============================================================================

loc_8968:				; DATA XREF: ROM:0000893Co
		move.w	$32(a0),d0
		move.b	$26(a0),d1
		subi.b	#$40,d1	; '@'

loc_8974:				; CODE XREF: ROM:00008966j
		ext.w	d1
		add.w	d1,d0
		move.w	d0,8(a0)
		bra.w	loc_8AD2
; ===============================================================================

loc_8980:				; DATA XREF: ROM:00008954o
		move.w	$34(a0),d0
		move.b	(RAM_RandomTimers_Buff+$E).w,d1
		neg.b	d1
		addi.b	#$30,d1	; '0'
		bra.s	loc_89BA
; ===============================================================================

loc_8990:				; DATA XREF: ROM:00008952o
		move.w	$34(a0),d0
		move.b	(RAM_RandomTimers_Buff+$E).w,d1
		subi.b	#$30,d1	; '0'
		bra.s	loc_89BA
; ===============================================================================

loc_899E:				; DATA XREF: ROM:00008946o
		move.w	$34(a0),d0
		move.b	$26(a0),d1
		neg.b	d1
		addi.b	#$40,d1	; '@'
		bra.s	loc_89BA
; ===============================================================================

loc_89AE:				; DATA XREF: ROM:0000893Eo
		move.w	$34(a0),d0
		move.b	$26(a0),d1
		subi.b	#$40,d1	; '@'

loc_89BA:				; CODE XREF: ROM:0000898Ej
					; ROM:0000899Cj ...
		ext.w	d1
		add.w	d1,d0
		move.w	d0,$2C(a0)
		bra.w	loc_8AD2
; ===============================================================================

loc_89C6:				; DATA XREF: ROM:00008940o
		tst.w	$3A(a0)
		bne.s	loc_89DC
		btst	#3,$22(a0)
		beq.s	locret_89DA
		move.w	#$1E,$3A(a0)

locret_89DA:				; CODE XREF: ROM:000089D2j
					; ROM:000089E0j
		rts
; ===============================================================================

loc_89DC:				; CODE XREF: ROM:000089CAj
		subq.w	#1,$3A(a0)
		bne.s	locret_89DA
		move.w	#$20,$3A(a0) ; ' '
		addq.b	#1,$28(a0)
		rts
; ===============================================================================

loc_89EE:				; DATA XREF: ROM:00008942o
		tst.w	$3A(a0)
		beq.s	loc_8A2E
		subq.w	#1,$3A(a0)
		bne.s	loc_8A2E
		btst	#3,$22(a0)
		beq.s	loc_8A28
		lea	(RAM_ObjRam_Sonic).w,a1
		bset	#1,$22(a1)
		bclr	#3,$22(a1)
		move.b	#2,$24(a1)
		bclr	#3,$22(a0)
		clr.b	$25(a0)
		move.w	$12(a0),$12(a1)

loc_8A28:				; CODE XREF: ROM:00008A00j
		move.b	#6,$24(a0)

loc_8A2E:				; CODE XREF: ROM:000089F2j
					; ROM:000089F8j
		move.l	$2C(a0),d3
		move.w	$12(a0),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,d3
		move.l	d3,$2C(a0)
		addi.w	#$38,$12(a0) ; '8'
		move.w	(RAM_LevelSys_YPos_SetEnd).w,d0
		addi.w	#$E0,d0	; ''
		cmp.w	$2C(a0),d0
		bcc.s	locret_8A5A
		move.b	#4,$24(a0)

locret_8A5A:				; CODE XREF: ROM:00008A52j
		rts
; ===============================================================================

loc_8A5C:				; DATA XREF: ROM:00008948o
		tst.w	$3A(a0)
		bne.s	loc_8A7C
		lea	(RAM_Level_Switches).w,a2
		moveq	#0,d0
		move.b	$28(a0),d0
		lsr.w	#4,d0
		tst.b	(a2,d0.w)
		beq.s	locret_8A7A
		move.w	#$3C,$3A(a0) ; '<'

locret_8A7A:				; CODE XREF: ROM:00008A72j
					; ROM:00008A80j
		rts
; ===============================================================================

loc_8A7C:				; CODE XREF: ROM:00008A60j
		subq.w	#1,$3A(a0)
		bne.s	locret_8A7A
		addq.b	#1,$28(a0)
		rts
; ===============================================================================

loc_8A88:				; DATA XREF: ROM:0000894Ao
		subq.w	#2,$2C(a0)
		move.w	$34(a0),d0
		subi.w	#$200,d0
		cmp.w	$2C(a0),d0
		bne.s	locret_8A9E
		clr.b	$28(a0)

locret_8A9E:				; CODE XREF: ROM:00008A98j
		rts
; ===============================================================================

loc_8AA0:				; DATA XREF: ROM:0000894Eo
		move.w	$34(a0),d0
		move.b	$26(a0),d1
		subi.b	#$40,d1	; '@'
		ext.w	d1
		asr.w	#1,d1
		add.w	d1,d0
		move.w	d0,$2C(a0)
		bra.w	loc_8AD2
; ===============================================================================

loc_8ABA:				; DATA XREF: ROM:00008950o
		move.w	$34(a0),d0
		move.b	$26(a0),d1
		neg.b	d1
		addi.b	#$40,d1	; '@'
		ext.w	d1
		asr.w	#1,d1
		add.w	d1,d0
		move.w	d0,$2C(a0)

loc_8AD2:				; CODE XREF: ROM:0000897Cj
					; ROM:000089C2j ...
		move.b	(RAM_RandomTimers_Buff+$1A).w,$26(a0)
		rts
; ===============================================================================
Map_Obj18x:	dc.w word_8ADE-Map_Obj18x ; DATA XREF: ROM:Map_Obj18xo
					; ROM:00008ADCo
		dc.w word_8AF0-Map_Obj18x
word_8ADE:	dc.w 2			; DATA XREF: ROM:Map_Obj18xo
		dc.w $F40B,  $3C,  $1E,$FFE8; 0
		dc.w $F40B,  $48,  $24,	   0; 4
word_8AF0:	dc.w $A			; DATA XREF: ROM:00008ADCo
		dc.w $F40F,  $CA,  $65,$FFE0; 0
		dc.w  $40F,  $DA,  $6D,$FFE0; 4
		dc.w $240F,  $DA,  $6D,$FFE0; 8
		dc.w $440F,  $DA,  $6D,$FFE0; 12
		dc.w $640F,  $DA,  $6D,$FFE0; 16
		dc.w $F40F, $8CA, $865,	   0; 20
		dc.w  $40F, $8DA, $86D,	   0; 24
		dc.w $240F, $8DA, $86D,	   0; 28
		dc.w $440F, $8DA, $86D,	   0; 32
		dc.w $640F, $8DA, $86D,	   0; 36
Map_Obj18:	dc.w word_8B46-Map_Obj18 ; DATA	XREF: ROM:0000884Eo
					; ROM:Map_Obj18o ...
		dc.w word_8B68-Map_Obj18
word_8B46:	dc.w 4			; DATA XREF: ROM:Map_Obj18o
		dc.w $F40B,  $3B,  $1D,$FFE0; 0
		dc.w $F407,  $3F,  $1F,$FFF8; 4
		dc.w $F407,  $3F,  $1F,	   8; 8
		dc.w $F403,  $47,  $23,	 $18; 12
word_8B68:	dc.w $A			; DATA XREF: ROM:00008B44o
		dc.w $F40F,  $C5,  $62,$FFE0; 0
		dc.w  $40F,  $D5,  $6A,$FFE0; 4
		dc.w $240F,  $D5,  $6A,$FFE0; 8
		dc.w $440F,  $D5,  $6A,$FFE0; 12
		dc.w $640F,  $D5,  $6A,$FFE0; 16
		dc.w $F40F, $8C5, $862,	   0; 20
		dc.w  $40F, $8D5, $86A,	   0; 24
		dc.w $240F, $8D5, $86A,	   0; 28
		dc.w $440F, $8D5, $86A,	   0; 32
		dc.w $640F, $8D5, $86A,	   0; 36
		dc.w	 2,    3,$F60B,	 $49; 40
		dc.w   $24,$FFE0,$F607,	 $51; 44
		dc.w   $28,$FFF8,$F60B,	 $55; 48
		dc.w   $2A,    8,    2,	   2; 52
		dc.w $F80F,  $21,  $10,$FFE0; 56
		dc.w $F80F,  $21,  $10,	   0; 60
Map_Obj18_EHZ:	dc.w word_8BEE-Map_Obj18_EHZ ; DATA XREF: ROM:loc_8866o
					; ROM:Map_Obj18_EHZo ...
		dc.w word_8C00-Map_Obj18_EHZ
word_8BEE:	dc.w 2			; DATA XREF: ROM:Map_Obj18_EHZo
		dc.w $F40F,  $56,  $2B,$FFE0; 0
		dc.w $F40F, $856, $82B,	   0; 4
word_8C00:	dc.w 8			; DATA XREF: ROM:00008BECo
		dc.w $F407,   $A,    5,$FFE0; 0
		dc.w $F40D,  $12,    9,$FFF0; 4
		dc.w  $40D,  $1A,   $D,$FFF0; 8
		dc.w $F407,  $22,  $11,	 $10; 12
		dc.w $140F,  $2A,  $15,$FFE0; 16
		dc.w $140F, $82A, $815,	   0; 20
		dc.w $340F,  $3A,  $1D,$FFE0; 24
		dc.w $340F, $83A, $81D,	   0; 28
; ===============================================================================
		nop

Obj1A:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj1A_Index(pc,d0.w),d1
		jmp	Obj1A_Index(pc,d1.w)
; ===============================================================================
Obj1A_Index:	dc.w loc_8C58-Obj1A_Index ; DATA XREF: ROM:Obj1A_Indexo
					; ROM:00008C54o ...
		dc.w loc_8CCA-Obj1A_Index
		dc.w loc_8D02-Obj1A_Index
; ===============================================================================

loc_8C58:				; DATA XREF: ROM:Obj1A_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj1A,4(a0)
		move.w	#$4000,2(a0)
		bsr.w	ModifySpriteAttr_2P
		ori.b	#4,1(a0)
		move.b	#4,$18(a0)
		move.b	#7,$38(a0)
		move.b	$28(a0),$1A(a0)
		cmpi.b	#4,(RAM_Level_CurrentZone).w
		bne.s	loc_8CB0
		move.l	#Map_Obj1A_HPZ,4(a0)
		move.w	#$434A,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#$30,$19(a0) ; '0'
		move.l	#Obj1A_Conf_HPZ,$3C(a0)
		bra.s	loc_8CCA
; ===============================================================================

loc_8CB0:				; CODE XREF: ROM:00008C8Cj
		move.l	#Obj1A_Conf,$3C(a0)
		move.b	#$34,$19(a0) ; '4'
		move.b	#$38,$16(a0) ; '8'
		bset	#4,1(a0)

loc_8CCA:				; CODE XREF: ROM:00008CAEj
					; DATA XREF: ROM:00008C54o
		tst.b	$3A(a0)
		beq.s	loc_8CDC
		tst.b	$38(a0)
		beq.w	loc_8E58
		subq.b	#1,$38(a0)

loc_8CDC:				; CODE XREF: ROM:00008CCEj
		move.b	$22(a0),d0
		andi.b	#$18,d0
		beq.s	sub_8CEC
		move.b	#1,$3A(a0)

; =============== S U B R O U T I N E ==========================================


sub_8CEC:				; CODE XREF: ROM:00008CE4j
					; ROM:loc_8D16p

; FUNCTION CHUNK AT 0000CE5A SIZE 00000038 BYTES
; FUNCTION CHUNK AT 0000CF3A SIZE 00000002 BYTES

		moveq	#0,d1
		move.b	$19(a0),d1
		movea.l	$3C(a0),a2
		move.w	8(a0),d4
		bsr.w	sub_F7DC
		bra.w	MarkObjGone
; End of function sub_8CEC

; ===============================================================================

loc_8D02:				; DATA XREF: ROM:00008C56o
		tst.b	$38(a0)
		beq.s	loc_8D46
		tst.b	$3A(a0)
		bne.s	loc_8D16
		subq.b	#1,$38(a0)
		bra.w	DisplaySprite
; ===============================================================================

loc_8D16:				; CODE XREF: ROM:00008D0Cj
		bsr.w	sub_8CEC
		subq.b	#1,$38(a0)
		bne.s	locret_8D44
		lea	(RAM_ObjRAM_Sonic).w,a1
		bsr.s	sub_8D2A
		lea	(RAM_ObjRAM_Tails).w,a1

; =============== S U B R O U T I N E ==========================================


sub_8D2A:				; CODE XREF: ROM:00008D24p
		btst	#3,$22(a1)
		beq.s	locret_8D44
		bclr	#3,$22(a1)
		bclr	#5,$22(a1)
		move.b	#1,$1D(a1)

locret_8D44:				; CODE XREF: ROM:00008D1Ej sub_8D2A+6j
		rts
; End of function sub_8D2A

; ===============================================================================

loc_8D46:				; CODE XREF: ROM:00008D06j
		bsr.w	ObjectFall
		tst.b	1(a0)
		bpl.w	DeleteObject
		bra.w	DisplaySprite
; ===============================================================================

S1Obj_53:				; leftover object from Sonic 1
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	S1Obj_53_Index(pc,d0.w),d1
		jmp	S1Obj_53_Index(pc,d1.w)
; ===============================================================================
S1Obj_53_Index:	dc.w loc_8D6A-S1Obj_53_Index ; DATA XREF: ROM:S1Obj_53_Indexo
					; ROM:00008D66o ...
		dc.w loc_8DB4-S1Obj_53_Index
		dc.w loc_8DEA-S1Obj_53_Index
; ===============================================================================

loc_8D6A:				; DATA XREF: ROM:S1Obj_53_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_S1Obj53,4(a0)
		move.w	#$42B8,2(a0)
		cmpi.b	#3,(RAM_Level_CurrentZone).w
		bne.s	loc_8D8E
		move.w	#$44E0,2(a0)
		addq.b	#2,$1A(a0)

loc_8D8E:				; CODE XREF: ROM:00008D82j
		cmpi.b	#5,(RAM_Level_CurrentZone).w
		bne.s	loc_8D9C
		move.w	#$43F5,2(a0)

loc_8D9C:				; CODE XREF: ROM:00008D94j
		ori.b	#4,1(a0)
		move.b	#4,$18(a0)
		move.b	#7,$38(a0)
		move.b	#$44,$19(a0) ; 'D'

loc_8DB4:				; DATA XREF: ROM:00008D66o
		tst.b	$3A(a0)
		beq.s	loc_8DC6
		tst.b	$38(a0)
		beq.w	loc_8E3E
		subq.b	#1,$38(a0)

loc_8DC6:				; CODE XREF: ROM:00008DB8j
		move.b	$22(a0),d0
		andi.b	#$18,d0
		beq.s	sub_8DD6
		move.b	#1,$3A(a0)

; =============== S U B R O U T I N E ==========================================


sub_8DD6:				; CODE XREF: ROM:00008DCEj
					; ROM:loc_8DFEp
		move.w	#$20,d1	; ' '
		move.w	#8,d3
		move.w	8(a0),d4
		bsr.w	sub_F78A
		bra.w	MarkObjGone
; End of function sub_8DD6

; ===============================================================================

loc_8DEA:				; DATA XREF: ROM:00008D68o
		tst.b	$38(a0)
		beq.s	loc_8E2E
		tst.b	$3A(a0)
		bne.s	loc_8DFE
		subq.b	#1,$38(a0)
		bra.w	DisplaySprite
; ===============================================================================

loc_8DFE:				; CODE XREF: ROM:00008DF4j
		bsr.w	sub_8DD6
		subq.b	#1,$38(a0)
		bne.s	locret_8E2C
		lea	(RAM_ObjRAM_Sonic).w,a1
		bsr.s	sub_8E12
		lea	(RAM_ObjRAM_Tails).w,a1

; =============== S U B R O U T I N E ==========================================


sub_8E12:				; CODE XREF: ROM:00008E0Cp
		btst	#3,$22(a1)
		beq.s	locret_8E2C
		bclr	#3,$22(a1)
		bclr	#5,$22(a1)
		move.b	#1,$1D(a1)

locret_8E2C:				; CODE XREF: ROM:00008E06j sub_8E12+6j
		rts
; End of function sub_8E12

; ===============================================================================

loc_8E2E:				; CODE XREF: ROM:00008DEEj
		bsr.w	ObjectFall
		tst.b	1(a0)
		bpl.w	DeleteObject
		bra.w	DisplaySprite
; ===============================================================================

loc_8E3E:				; CODE XREF: ROM:00008DBEj
		lea	(byte_8F17).l,a4
		btst	#0,$28(a0)
		beq.s	loc_8E52
		lea	(byte_8F1F).l,a4

loc_8E52:				; CODE XREF: ROM:00008E4Aj
		addq.b	#1,$1A(a0)
		bra.s	loc_8E70
; ===============================================================================

loc_8E58:				; CODE XREF: ROM:00008CD4j
		lea	(byte_8EF2).l,a4
		cmpi.b	#4,(RAM_Level_CurrentZone).w
		bne.s	loc_8E6C
		lea	(byte_8F0B).l,a4

loc_8E6C:				; CODE XREF: ROM:00008E64j
		addq.b	#2,$1A(a0)

loc_8E70:				; CODE XREF: ROM:00008E56j
		moveq	#0,d0
		move.b	$1A(a0),d0
		add.w	d0,d0
		movea.l	4(a0),a3
		adda.w	(a3,d0.w),a3
		move.w	(a3)+,d1
		subq.w	#1,d1
		bset	#5,1(a0)
		move.b	0(a0),d4
		move.b	1(a0),d5
		movea.l	a0,a1
		bra.s	loc_8E9E
; ===============================================================================

loc_8E96:				; CODE XREF: ROM:loc_8EE0j
		bsr.w	SingleObjectLoad
		bne.s	loc_8EE4
		addq.w	#8,a3

loc_8E9E:				; CODE XREF: ROM:00008E94j
		move.b	#4,$24(a1)
		move.b	d4,0(a1)
		move.l	a3,4(a1)
		move.b	d5,1(a1)
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		move.w	2(a0),2(a1)
		move.b	$18(a0),$18(a1)
		move.b	$19(a0),$19(a1)
		move.b	$16(a0),$16(a1)
		move.b	(a4)+,$38(a1)
		cmpa.l	a0,a1
		bcc.s	loc_8EE0
		bsr.w	DisplayA1Sprite

loc_8EE0:				; CODE XREF: ROM:00008EDAj
		dbf	d1,loc_8E96

loc_8EE4:				; CODE XREF: ROM:00008E9Aj
		bsr.w	DisplaySprite
		move.w	#$B9,d0	; ''
		jmp	(PlaySound_Special).l
; ===============================================================================
byte_8EF2:	dc.b $1C,$18,$14,$10	; 0 ; DATA XREF: ROM:loc_8E58o
		dc.b $1A,$16,$12, $E	; 4
		dc.b  $A,  6,$18,$14	; 8
		dc.b $10, $C,  8,  4	; 12
		dc.b $16,$12, $E, $A	; 16
		dc.b   6,  2,$14,$10	; 20
		dc.b  $C		; 24
byte_8F0B:	dc.b $18,$1C,$20,$1E	; 0 ; DATA XREF: ROM:00008E66o
		dc.b $1A,$16,  6, $E	; 4
		dc.b $14,$12, $A,  2	; 8
byte_8F17:	dc.b $1E,$16, $E,  6	; 0 ; DATA XREF: ROM:loc_8E3Eo
		dc.b $1A,$12, $A,  2	; 4
byte_8F1F:	dc.b $16,$1E,$1A,$12	; 0 ; DATA XREF: ROM:00008E4Co
		dc.b   6, $E, $A,  2	; 4
		dc.b   0		; 8
Obj1A_Conf:	dc.b $20,$20,$20,$20	; 0 ; DATA XREF: ROM:loc_8CB0o
		dc.b $20,$20,$20,$20	; 4
		dc.b $21,$21,$22,$22	; 8
		dc.b $23,$23,$24,$24	; 12
		dc.b $25,$25,$26,$26	; 16
		dc.b $27,$27,$28,$28	; 20
		dc.b $29,$29,$2A,$2A	; 24
		dc.b $2B,$2B,$2C,$2C	; 28
		dc.b $2D,$2D,$2E,$2E	; 32
		dc.b $2F,$2F,$30,$30	; 36
		dc.b $30,$30,$30,$30	; 40
		dc.b $30,$30,$30,$30	; 44
Map_Obj1A:	dc.w word_8F60-Map_Obj1A ; DATA	XREF: ROM:00008C5Co
					; ROM:Map_Obj1Ao ...
		dc.w word_8FE2-Map_Obj1A
		dc.w word_9064-Map_Obj1A
		dc.w word_912E-Map_Obj1A
word_8F60:	dc.w $10		; DATA XREF: ROM:Map_Obj1Ao
		dc.w $C80E,  $57,  $2B,	 $10; 0
		dc.w $D00D,  $63,  $31,$FFF0; 4
		dc.w $E00D,  $6B,  $35,	 $10; 8
		dc.w $E00D,  $73,  $39,$FFF0; 12
		dc.w $D806,  $7B,  $3D,$FFE0; 16
		dc.w $D806,  $81,  $40,$FFD0; 20
		dc.w $F00D,  $87,  $43,	 $10; 24
		dc.w $F00D,  $8F,  $47,$FFF0; 28
		dc.w $F005,  $97,  $4B,$FFE0; 32
		dc.w $F005,  $9B,  $4D,$FFD0; 36
		dc.w	$D,  $9F,  $4F,	 $10; 40
		dc.w	 5,  $A7,  $53,	   0; 44
		dc.w	$D,  $AB,  $55,$FFE0; 48
		dc.w	 5,  $B3,  $59,$FFD0; 52
		dc.w $100D,  $AB,  $55,	 $10; 56
		dc.w $1005,  $B7,  $5B,	   0; 60
word_8FE2:	dc.w $10		; DATA XREF: ROM:00008F5Ao
		dc.w $C80E,  $57,  $2B,	 $10; 0
		dc.w $D00D,  $63,  $31,$FFF0; 4
		dc.w $E00D,  $6B,  $35,	 $10; 8
		dc.w $E00D,  $73,  $39,$FFF0; 12
		dc.w $D806,  $7B,  $3D,$FFE0; 16
		dc.w $D806,  $BB,  $5D,$FFD0; 20
		dc.w $F00D,  $87,  $43,	 $10; 24
		dc.w $F00D,  $8F,  $47,$FFF0; 28
		dc.w $F005,  $97,  $4B,$FFE0; 32
		dc.w $F005,  $C1,  $60,$FFD0; 36
		dc.w	$D,  $9F,  $4F,	 $10; 40
		dc.w	 5,  $A7,  $53,	   0; 44
		dc.w	$D,  $AB,  $55,$FFE0; 48
		dc.w	 5,  $B7,  $5B,$FFD0; 52
		dc.w $100D,  $AB,  $55,	 $10; 56
		dc.w $1005,  $B7,  $5B,	   0; 60
word_9064:	dc.w $19		; DATA XREF: ROM:00008F5Co
		dc.w $C806,  $5D,  $2E,	 $20; 0
		dc.w $C806,  $57,  $2B,	 $10; 4
		dc.w $D005,  $67,  $33,	   0; 8
		dc.w $D005,  $63,  $31,$FFF0; 12
		dc.w $E005,  $6F,  $37,	 $20; 16
		dc.w $E005,  $6B,  $35,	 $10; 20
		dc.w $E005,  $77,  $3B,	   0; 24
		dc.w $E005,  $73,  $39,$FFF0; 28
		dc.w $D806,  $7B,  $3D,$FFE0; 32
		dc.w $D806,  $81,  $40,$FFD0; 36
		dc.w $F005,  $8B,  $45,	 $20; 40
		dc.w $F005,  $87,  $43,	 $10; 44
		dc.w $F005,  $93,  $49,	   0; 48
		dc.w $F005,  $8F,  $47,$FFF0; 52
		dc.w $F005,  $97,  $4B,$FFE0; 56
		dc.w $F005,  $9B,  $4D,$FFD0; 60
		dc.w	 5,  $8B,  $45,	 $20; 64
		dc.w	 5,  $8B,  $45,	 $10; 68
		dc.w	 5,  $A7,  $53,	   0; 72
		dc.w	 5,  $AB,  $55,$FFF0; 76
		dc.w	 5,  $AB,  $55,$FFE0; 80
		dc.w	 5,  $B3,  $59,$FFD0; 84
		dc.w $1005,  $AB,  $55,	 $20; 88
		dc.w $1005,  $AB,  $55,	 $10; 92
		dc.w $1005,  $B7,  $5B,	   0; 96
word_912E:	dc.w $19		; DATA XREF: ROM:00008F5Eo
		dc.w $C806,  $5D,  $2E,	 $20; 0
		dc.w $C806,  $57,  $2B,	 $10; 4
		dc.w $D005,  $67,  $33,	   0; 8
		dc.w $D005,  $63,  $31,$FFF0; 12
		dc.w $E005,  $6F,  $37,	 $20; 16
		dc.w $E005,  $6B,  $35,	 $10; 20
		dc.w $E005,  $77,  $3B,	   0; 24
		dc.w $E005,  $73,  $39,$FFF0; 28
		dc.w $D806,  $7B,  $3D,$FFE0; 32
		dc.w $D806,  $BB,  $5D,$FFD0; 36
		dc.w $F005,  $8B,  $45,	 $20; 40
		dc.w $F005,  $87,  $43,	 $10; 44
		dc.w $F005,  $93,  $49,	   0; 48
		dc.w $F005,  $8F,  $47,$FFF0; 52
		dc.w $F005,  $97,  $4B,$FFE0; 56
		dc.w $F005,  $C1,  $60,$FFD0; 60
		dc.w	 5,  $8B,  $45,	 $20; 64
		dc.w	 5,  $8B,  $45,	 $10; 68
		dc.w	 5,  $A7,  $53,	   0; 72
		dc.w	 5,  $AB,  $55,$FFF0; 76
		dc.w	 5,  $AB,  $55,$FFE0; 80
		dc.w	 5,  $B7,  $5B,$FFD0; 84
		dc.w $1005,  $AB,  $55,	 $20; 88
		dc.w $1005,  $AB,  $55,	 $10; 92
		dc.w $1005,  $B7,  $5B,	   0; 96
Map_S1Obj53:	dc.w word_9200-Map_S1Obj53 ; DATA XREF:	ROM:00008D6Eo
					; ROM:Map_S1Obj53o ...
		dc.w word_9222-Map_S1Obj53
		dc.w word_9264-Map_S1Obj53
		dc.w word_9286-Map_S1Obj53
word_9200:	dc.w 4			; DATA XREF: ROM:Map_S1Obj53o
		dc.w $F80D,    0,    0,$FFE0; 0
		dc.w  $80D,    0,    0,$FFE0; 4
		dc.w $F80D,    0,    0,	   0; 8
		dc.w  $80D,    0,    0,	   0; 12
word_9222:	dc.w 8			; DATA XREF: ROM:000091FAo
		dc.w $F805,    0,    0,$FFE0; 0
		dc.w $F805,    0,    0,$FFF0; 4
		dc.w $F805,    0,    0,	   0; 8
		dc.w $F805,    0,    0,	 $10; 12
		dc.w  $805,    0,    0,$FFE0; 16
		dc.w  $805,    0,    0,$FFF0; 20
		dc.w  $805,    0,    0,	   0; 24
		dc.w  $805,    0,    0,	 $10; 28
word_9264:	dc.w 4			; DATA XREF: ROM:000091FCo
		dc.w $F80D,    0,    0,$FFE0; 0
		dc.w  $80D,    8,    4,$FFE0; 4
		dc.w $F80D,    0,    0,	   0; 8
		dc.w  $80D,    8,    4,	   0; 12
word_9286:	dc.w 8			; DATA XREF: ROM:000091FEo
		dc.w $F805,    0,    0,$FFE0; 0
		dc.w $F805,    4,    2,$FFF0; 4
		dc.w $F805,    0,    0,	   0; 8
		dc.w $F805,    4,    2,	 $10; 12
		dc.w  $805,    8,    4,$FFE0; 16
		dc.w  $805,   $C,    6,$FFF0; 20
		dc.w  $805,    8,    4,	   0; 24
		dc.w  $805,   $C,    6,	 $10; 28
Obj1A_Conf_HPZ:	dc.b $10,$10,$10,$10	; 0 ; DATA XREF: ROM:00008CA6o
		dc.b $10,$10,$10,$10	; 4
		dc.b $10,$10,$10,$10	; 8
		dc.b $10,$10,$10,$10	; 12
		dc.b $10,$10,$10,$10	; 16
		dc.b $10,$10,$10,$10	; 20
		dc.b $10,$10,$10,$10	; 24
		dc.b $10,$10,$10,$10	; 28
		dc.b $10,$10,$10,$10	; 32
		dc.b $10,$10,$10,$10	; 36
		dc.b $10,$10,$10,$10	; 40
		dc.b $10,$10,$10,$10	; 44
Map_Obj1A_HPZ:	dc.w word_92FE-Map_Obj1A_HPZ ; DATA XREF: ROM:00008C8Eo
					; ROM:Map_Obj1A_HPZo ...
		dc.w word_9340-Map_Obj1A_HPZ
		dc.w word_9340-Map_Obj1A_HPZ
word_92FE:	dc.w 8			; DATA XREF: ROM:Map_Obj1A_HPZo
		dc.w $F00D,    0,    0,$FFD0; 0
		dc.w	$D,    8,    4,$FFD0; 4
		dc.w $F005,    4,    2,$FFF0; 8
		dc.w $F005, $804, $802,	   0; 12
		dc.w	 5,   $C,    6,$FFF0; 16
		dc.w	 5, $80C, $806,	   0; 20
		dc.w $F00D, $800, $800,	 $10; 24
		dc.w	$D, $808, $804,	 $10; 28
word_9340:	dc.w $C			; DATA XREF: ROM:000092FAo
					; ROM:000092FCo
		dc.w $F005,    0,    0,$FFD0; 0
		dc.w $F005,    4,    2,$FFE0; 4
		dc.w $F005,    4,    2,$FFF0; 8
		dc.w $F005, $804, $802,	   0; 12
		dc.w $F005, $804, $802,	 $10; 16
		dc.w $F005, $800, $800,	 $20; 20
		dc.w	 5,    8,    4,$FFD0; 24
		dc.w	 5,   $C,    6,$FFE0; 28
		dc.w	 5,   $C,    6,$FFF0; 32
		dc.w	 5, $80C, $806,	   0; 36
		dc.w	 5, $80C, $806,	 $10; 40
		dc.w	 5, $808, $804,	 $20; 44
; ===============================================================================
		nop

Obj1C:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj1C_Index(pc,d0.w),d1
		jmp	Obj1C_Index(pc,d1.w)
; ===============================================================================
Obj1C_Index:	dc.w loc_93F4-Obj1C_Index ; DATA XREF: ROM:Obj1C_Indexo
					; ROM:000093B4o ...
		dc.w loc_9442-Obj1C_Index
		dc.w loc_9464-Obj1C_Index
Obj1C_Conf:	dc.l Map_Obj11_HPZ
		dc.w $6300
		dc.b   3,  4,  1,  0	; 0
		dc.l Map_Obj1C_01
		dc.w $E35A
		dc.b   0,$10,  1,  0	; 0
		dc.l Map_Obj11_EHZ
		dc.w $43C6
		dc.b   1,  4,  1,  0	; 0
		dc.l Map_Obj11
		dc.w $44C6
		dc.b   1,$10,  1,  0	; 0
		dc.l Map_Obj16
		dc.w $43E6
		dc.b   1,  8,  4,  0	; 0
		dc.l Map_Obj16
		dc.w $43E6
		dc.b   2,  8,  4,  0	; 0
; ===============================================================================

loc_93F4:				; DATA XREF: ROM:Obj1C_Indexo
		addq.b	#2,$24(a0)
		move.b	$28(a0),d0
		andi.w	#$F,d0
		mulu.w	#$A,d0
		lea	Obj1C_Conf(pc,d0.w),a1
		move.l	(a1)+,4(a0)
		move.w	(a1)+,2(a0)
		bsr.w	ModifySpriteAttr_2P
		ori.b	#4,1(a0)
		move.b	(a1)+,$1A(a0)
		move.b	(a1)+,$19(a0)
		move.b	(a1)+,$18(a0)
		move.b	(a1)+,$20(a0)
		move.b	$28(a0),d0
		andi.w	#$F0,d0	; ''
		beq.s	loc_9442
		addq.b	#2,$24(a0)
		lsr.b	#4,d0
		subq.b	#1,d0
		move.b	d0,$1C(a0)
		bra.s	loc_9464
; ===============================================================================

loc_9442:				; CODE XREF: ROM:00009432j
					; DATA XREF: ROM:000093B4o
		tst.w	(RAM_Flag_SplitScreen).w
		beq.s	loc_944C
		bra.w	DisplaySprite
; ===============================================================================

loc_944C:				; CODE XREF: ROM:00009446j
		move.w	8(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.w	DeleteObject
		bra.w	DisplaySprite
; ===============================================================================

loc_9464:				; CODE XREF: ROM:00009440j
					; DATA XREF: ROM:000093B6o
		lea	(Ani_Obj1C).l,a1
		bsr.w	AnimateSprite
		tst.w	(RAM_Flag_SplitScreen).w
		beq.s	loc_9478
		bra.w	DisplaySprite
; ===============================================================================

loc_9478:				; CODE XREF: ROM:00009472j
		move.w	8(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.w	DeleteObject
		bra.w	DisplaySprite
; ===============================================================================
Ani_Obj1C:	dc.w byte_9494-Ani_Obj1C ; DATA	XREF: ROM:loc_9464o
					; ROM:Ani_Obj1Co ...
		dc.w byte_949C-Ani_Obj1C
byte_9494:	dc.b   8,  3,  3,  4,  5,  5,  4,$FF; 0	; DATA XREF: ROM:Ani_Obj1Co
byte_949C:	dc.b   5,  0,  0,  0,  1,  2,  3,  3; 0	; DATA XREF: ROM:00009492o
		dc.b   2,  1,  2,  3,  3,  1,$FF,  0; 8
Map_Obj1C_01:	dc.w word_94B4-Map_Obj1C_01 ; DATA XREF: ROM:000093C2o
					; ROM:Map_Obj1C_01o ...
		dc.w word_94BE-Map_Obj1C_01
		dc.w word_94C8-Map_Obj1C_01
		dc.w word_94DA-Map_Obj1C_01
word_94B4:	dc.w 1			; DATA XREF: ROM:Map_Obj1C_01o
		dc.w $F40A,    0,    0,$FFF4; 0
word_94BE:	dc.w 1			; DATA XREF: ROM:000094AEo
		dc.w $F40A,    9,    4,$FFF4; 0
word_94C8:	dc.w 2			; DATA XREF: ROM:000094B0o
		dc.w $F00D,  $12,    9,$FFF0; 0
		dc.w	$D,$1812,$1809,$FFF0; 4
word_94DA:	dc.w 2			; DATA XREF: ROM:000094B2o
		dc.w $F00D,  $1A,   $D,$FFF0; 0
		dc.w	$D,$181A,$180D,$FFF0; 4
; ===============================================================================

Obj2A:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj2A_Index(pc,d0.w),d1
		jmp	Obj2A_Index(pc,d1.w)
; ===============================================================================
Obj2A_Index:	dc.w loc_94FE-Obj2A_Index ; DATA XREF: ROM:Obj2A_Indexo
					; ROM:000094FCo
		dc.w loc_9526-Obj2A_Index
; ===============================================================================

loc_94FE:				; DATA XREF: ROM:Obj2A_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj2A,4(a0)
		move.w	#$42E8,2(a0)
		bsr.w	ModifySpriteAttr_2P
		ori.b	#4,1(a0)
		move.b	#8,$19(a0)
		move.b	#4,$18(a0)

loc_9526:				; DATA XREF: ROM:000094FCo
		move.w	#$40,d1	; '@'
		clr.b	$1C(a0)
		move.w	(RAM_ObjRam_Sonic+$8).w,d0
		add.w	d1,d0
		cmp.w	8(a0),d0
		bcs.s	loc_9564
		sub.w	d1,d0
		sub.w	d1,d0
		cmp.w	8(a0),d0
		bcc.s	loc_9564
		add.w	d1,d0
		cmp.w	8(a0),d0
		bcc.s	loc_9556
		btst	#0,$22(a0)
		bne.s	loc_9564
		bra.s	loc_955E
; ===============================================================================

loc_9556:				; CODE XREF: ROM:0000954Aj
		btst	#0,$22(a0)
		beq.s	loc_9564

loc_955E:				; CODE XREF: ROM:00009554j
		move.b	#1,$1C(a0)

loc_9564:				; CODE XREF: ROM:00009538j
					; ROM:00009542j ...
		lea	(Ani_Obj2A).l,a1
		bsr.w	AnimateSprite
		tst.b	$1A(a0)
		bne.s	loc_9588
		move.w	#$11,d1
		move.w	#$20,d2	; ' '
		move.w	d2,d3
		addq.w	#1,d3
		move.w	8(a0),d4
		bsr.w	SolidObject

loc_9588:				; CODE XREF: ROM:00009572j
		bra.w	MarkObjGone
; ===============================================================================
Ani_Obj2A:	dc.w byte_9590-Ani_Obj2A ; DATA	XREF: ROM:loc_9564o
					; ROM:Ani_Obj2Ao ...
		dc.w byte_959C-Ani_Obj2A
byte_9590:	dc.b   0,  8,  7,  6,  5,  4,  3,  2; 0	; DATA XREF: ROM:Ani_Obj2Ao
		dc.b   1,  0,$FE,  1	; 8
byte_959C:	dc.b   0,  0,  1,  2,  3,  4,  5,  6; 0	; DATA XREF: ROM:0000958Eo
		dc.b   7,  8,$FE,  1	; 8
Map_Obj2A:	dc.w word_95BA-Map_Obj2A ; DATA	XREF: ROM:00009502o
					; ROM:Map_Obj2Ao ...
		dc.w word_95CC-Map_Obj2A
		dc.w word_95DE-Map_Obj2A
		dc.w word_95F0-Map_Obj2A
		dc.w word_9602-Map_Obj2A
		dc.w word_9614-Map_Obj2A
		dc.w word_9626-Map_Obj2A
		dc.w word_9638-Map_Obj2A
		dc.w word_964A-Map_Obj2A
word_95BA:	dc.w 2			; DATA XREF: ROM:Map_Obj2Ao
		dc.w $E007, $800, $800,$FFF8; 0
		dc.w	 7, $800, $800,$FFF8; 4
word_95CC:	dc.w 2			; DATA XREF: ROM:000095AAo
		dc.w $DC07, $800, $800,$FFF8; 0
		dc.w  $407, $800, $800,$FFF8; 4
word_95DE:	dc.w 2			; DATA XREF: ROM:000095ACo
		dc.w $D807, $800, $800,$FFF8; 0
		dc.w  $807, $800, $800,$FFF8; 4
word_95F0:	dc.w 2			; DATA XREF: ROM:000095AEo
		dc.w $D407, $800, $800,$FFF8; 0
		dc.w  $C07, $800, $800,$FFF8; 4
word_9602:	dc.w 2			; DATA XREF: ROM:000095B0o
		dc.w $D007, $800, $800,$FFF8; 0
		dc.w $1007, $800, $800,$FFF8; 4
word_9614:	dc.w 2			; DATA XREF: ROM:000095B2o
		dc.w $CC07, $800, $800,$FFF8; 0
		dc.w $1407, $800, $800,$FFF8; 4
word_9626:	dc.w 2			; DATA XREF: ROM:000095B4o
		dc.w $C807, $800, $800,$FFF8; 0
		dc.w $1807, $800, $800,$FFF8; 4
word_9638:	dc.w 2			; DATA XREF: ROM:000095B6o
		dc.w $C407, $800, $800,$FFF8; 0
		dc.w $1C07, $800, $800,$FFF8; 4
word_964A:	dc.w 2			; DATA XREF: ROM:000095B8o
		dc.w $C007, $800, $800,$FFF8; 0
		dc.w $2007, $800, $800,$FFF8; 4
; ===============================================================================
;----------------------------------------------------
; Sonic	1 Object 1E - leftover Ballhog object
;----------------------------------------------------

S1Obj_1E:				; leftover from	Sonic 1
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	S1Obj_1E_Index(pc,d0.w),d1
		jmp	S1Obj_1E_Index(pc,d1.w)
; ===============================================================================
S1Obj_1E_Index:	dc.w loc_966E-S1Obj_1E_Index ; DATA XREF: ROM:S1Obj_1E_Indexo
					; ROM:0000966Co
		dc.w loc_96C2-S1Obj_1E_Index
; ===============================================================================

loc_966E:				; DATA XREF: ROM:S1Obj_1E_Indexo
		move.b	#$13,$16(a0)
		move.b	#8,$17(a0)
		move.l	#Map_S1Obj1E,4(a0)
		move.w	#$2302,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#4,1(a0)
		move.b	#4,$18(a0)
		move.b	#5,$20(a0)
		move.b	#$C,$19(a0)
		bsr.w	ObjectFall
		jsr	ObjHitFloor
		tst.w	d1
		bpl.s	locret_96C0
		add.w	d1,$C(a0)
		move.w	#0,$12(a0)
		addq.b	#2,$24(a0)

locret_96C0:				; CODE XREF: ROM:000096B0j
		rts
; ===============================================================================

loc_96C2:				; DATA XREF: ROM:0000966Co
		lea	(Ani_S1Obj1E).l,a1
		bsr.w	AnimateSprite
		cmpi.b	#1,$1A(a0)
		bne.s	loc_96DC
		tst.b	$32(a0)
		beq.s	loc_96E4
		bra.s	loc_96E0
; ===============================================================================

loc_96DC:				; CODE XREF: ROM:000096D2j
		clr.b	$32(a0)

loc_96E0:				; CODE XREF: ROM:000096DAj
					; ROM:loc_972Ej
		bra.w	MarkObjGone
; ===============================================================================

loc_96E4:				; CODE XREF: ROM:000096D8j
		move.b	#1,$32(a0)
		bsr.w	SingleObjectLoad
		bne.s	loc_972E
		move.b	#$20,0(a1) ; ' '
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		move.w	#$FF00,$10(a1)
		move.w	#0,$12(a1)
		moveq	#$FFFFFFFC,d0
		btst	#0,$22(a0)
		beq.s	loc_971E
		neg.w	d0
		neg.w	$10(a1)

loc_971E:				; CODE XREF: ROM:00009716j
		add.w	d0,8(a1)
		addi.w	#$C,$C(a1)
		move.b	$28(a0),$28(a1)

loc_972E:				; CODE XREF: ROM:000096EEj
		bra.s	loc_96E0
; ===============================================================================
;----------------------------------------------------
; Sonic	1 Object 20 - leftover object for the
;  ball	that S1	Ballhog	throws
;----------------------------------------------------

S1Obj20:
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	S1Obj20_Index(pc,d0.w),d1
		jmp	S1Obj20_Index(pc,d1.w)
; ===============================================================================
S1Obj20_Index:	dc.w loc_9742-S1Obj20_Index ; DATA XREF: ROM:S1Obj20_Indexo
					; ROM:00009740o
		dc.w loc_978A-S1Obj20_Index
; ===============================================================================

loc_9742:				; DATA XREF: ROM:S1Obj20_Indexo
		addq.b	#2,$24(a0)
		move.b	#7,$16(a0)
		move.l	#Map_S1Obj1E,4(a0)
		move.w	#$2302,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#4,1(a0)
		move.b	#3,$18(a0)
		move.b	#$87,$20(a0)
		move.b	#8,$19(a0)
		moveq	#0,d0
		move.b	$28(a0),d0
		mulu.w	#$3C,d0	; '<'
		move.w	d0,$30(a0)
		move.b	#4,$1A(a0)

loc_978A:				; DATA XREF: ROM:00009740o
		jsr	ObjectFall
		tst.w	$12(a0)
		bmi.s	loc_97C6
		jsr	ObjHitFloor
		tst.w	d1
		bpl.s	loc_97C6
		add.w	d1,$C(a0)
		move.w	#$FD00,$12(a0)
		tst.b	d3
		beq.s	loc_97C6
		bmi.s	loc_97BC
		tst.w	$10(a0)
		bpl.s	loc_97C6
		neg.w	$10(a0)
		bra.s	loc_97C6
; ===============================================================================

loc_97BC:				; CODE XREF: ROM:000097AEj
		tst.w	$10(a0)
		bmi.s	loc_97C6
		neg.w	$10(a0)

loc_97C6:				; CODE XREF: ROM:00009794j
					; ROM:0000979Ej ...
		subq.w	#1,$30(a0)
		bpl.s	loc_97E2
		move.b	#$24,0(a0) ; '$'
		move.b	#$3F,0(a0) ; '?'
		move.b	#0,$24(a0)
		bra.w	Obj3F		; explosion object
; ===============================================================================

loc_97E2:				; CODE XREF: ROM:000097CAj
		subq.b	#1,$1E(a0)
		bpl.s	loc_97F4
		move.b	#5,$1E(a0)
		bchg	#0,$1A(a0)

loc_97F4:				; CODE XREF: ROM:000097E6j
		move.w	(RAM_LevelSys_YPos_SetEnd).w,d0
		addi.w	#$E0,d0	; ''
		cmp.w	$C(a0),d0
		bcs.w	DeleteObject
		bra.w	DisplaySprite
; ===============================================================================
;----------------------------------------------------
; Object 24 - explosion	from a hit monitor
;----------------------------------------------------

Obj24:					; CODE XREF: ROM:0000A62Cj
					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj24_Index(pc,d0.w),d1
		jmp	Obj24_Index(pc,d1.w)
; ===============================================================================
Obj24_Index:	dc.w loc_981A-Obj24_Index ; DATA XREF: ROM:Obj24_Indexo
					; ROM:00009818o
		dc.w loc_985E-Obj24_Index
; ===============================================================================

loc_981A:				; DATA XREF: ROM:Obj24_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj24,4(a0)
		move.w	#$41C,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#4,1(a0)
		move.b	#1,$18(a0)
		move.b	#0,$20(a0)
		move.b	#$C,$19(a0)
		move.b	#9,$1E(a0)
		move.b	#0,$1A(a0)
		move.w	#$A5,d0	; ''
		jsr	(PlaySound_Special).l

loc_985E:				; DATA XREF: ROM:00009818o
		subq.b	#1,$1E(a0)
		bpl.s	loc_9878
		move.b	#9,$1E(a0)
		addq.b	#1,$1A(a0)
		cmpi.b	#4,$1A(a0)
		beq.w	DeleteObject

loc_9878:				; CODE XREF: ROM:00009862j
		bra.w	DisplaySprite
; ===============================================================================
;----------------------------------------------------
; Object 27 - explosion	from a hit enemy
;----------------------------------------------------

Obj27:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj27_Index(pc,d0.w),d1
		jmp	Obj27_Index(pc,d1.w)
; ===============================================================================
Obj27_Index:	dc.w loc_9890-Obj27_Index ; DATA XREF: ROM:Obj27_Indexo
					; ROM:0000988Co ...
		dc.w loc_98B2-Obj27_Index
		dc.w loc_98F6-Obj27_Index
; ===============================================================================

loc_9890:				; DATA XREF: ROM:Obj27_Indexo
		addq.b	#2,$24(a0)
		bsr.w	SingleObjectLoad
		bne.s	loc_98B2
		move.b	#$28,0(a1) ; '('
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		move.w	$3E(a0),$3E(a1)

loc_98B2:				; CODE XREF: ROM:00009898j
					; DATA XREF: ROM:0000988Co
		addq.b	#2,$24(a0)
		move.l	#Map_Obj27,4(a0)
		move.w	#$5A0,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#4,1(a0)
		move.b	#1,$18(a0)
		move.b	#0,$20(a0)
		move.b	#$C,$19(a0)
		move.b	#7,$1E(a0)
		move.b	#0,$1A(a0)
		move.w	#$C1,d0	; ''
		jsr	(PlaySound_Special).l

loc_98F6:				; DATA XREF: ROM:0000988Eo
					; ROM:00009924o
		subq.b	#1,$1E(a0)
		bpl.s	loc_9910
		move.b	#7,$1E(a0)
		addq.b	#1,$1A(a0)
		cmpi.b	#5,$1A(a0)
		beq.w	DeleteObject

loc_9910:				; CODE XREF: ROM:000098FAj
		bra.w	DisplaySprite
; ===============================================================================
;----------------------------------------------------
; Object 3F - Explosion
;----------------------------------------------------

Obj3F:					; CODE XREF: ROM:000097DEj
					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0		; explosion object
		move.b	$24(a0),d0
		move.w	Obj3F_Index(pc,d0.w),d1
		jmp	Obj3F_Index(pc,d1.w)
; ===============================================================================
Obj3F_Index:	dc.w loc_9926-Obj3F_Index ; DATA XREF: ROM:Obj3F_Indexo
					; ROM:00009924o
		dc.w loc_98F6-Obj3F_Index
; ===============================================================================

loc_9926:				; DATA XREF: ROM:Obj3F_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj3F,4(a0)
		move.w	#$5A0,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#4,1(a0)
		move.b	#1,$18(a0)
		move.b	#0,$20(a0)
		move.b	#$C,$19(a0)
		move.b	#7,$1E(a0)
		move.b	#0,$1A(a0)
		move.w	#$C4,d0	; ''
		jmp	(PlaySound_Special).l
; ===============================================================================
Ani_S1Obj1E:	dc.w byte_996C-Ani_S1Obj1E ; DATA XREF:	ROM:loc_96C2o
					; ROM:Ani_S1Obj1Eo
byte_996C:	dc.b   9,  0,  0,  2,  2,  3,  2,  0 ; DATA XREF: ROM:Ani_S1Obj1Eo
		dc.b   0,  2,  2,  3,  2,  0,  0,  2
		dc.b   2,  3,  2,  0,  0,  1,$FF,  0
Map_S1Obj1E:	dc.w word_9990-Map_S1Obj1E ; DATA XREF:	ROM:0000967Ao
					; ROM:0000974Co ...
		dc.w word_99A2-Map_S1Obj1E
		dc.w word_99B4-Map_S1Obj1E
		dc.w word_99C6-Map_S1Obj1E
		dc.w word_99D8-Map_S1Obj1E
		dc.w word_99E2-Map_S1Obj1E
word_9990:	dc.w 2			; DATA XREF: ROM:Map_S1Obj1Eo
		dc.w $EF09,    0,    0,$FFF4; 0
		dc.w $FF0A,    6,    3,$FFF4; 4
word_99A2:	dc.w 2			; DATA XREF: ROM:00009986o
		dc.w $EF09,    0,    0,$FFF4; 0
		dc.w $FF0A,   $F,    7,$FFF4; 4
word_99B4:	dc.w 2			; DATA XREF: ROM:00009988o
		dc.w $F409,    0,    0,$FFF4; 0
		dc.w  $409,  $18,   $C,$FFF4; 4
word_99C6:	dc.w 2			; DATA XREF: ROM:0000998Ao
		dc.w $E409,    0,    0,$FFF4; 0
		dc.w $F40A,  $1E,   $F,$FFF4; 4
word_99D8:	dc.w 1			; DATA XREF: ROM:0000998Co
		dc.w $F805,  $27,  $13,$FFF8; 0
word_99E2:	dc.w 1			; DATA XREF: ROM:0000998Eo
		dc.w $F805,  $2B,  $15,$FFF8; 0
Map_Obj24:	dc.w word_99F4-Map_Obj24 ; DATA	XREF: ROM:0000981Eo
					; ROM:Map_Obj24o ...
		dc.w word_99FE-Map_Obj24
		dc.w word_9A08-Map_Obj24
		dc.w word_9A12-Map_Obj24
word_99F4:	dc.w 1			; DATA XREF: ROM:Map_Obj24o
		dc.w $F40A,    0,    0,$FFF4; 0
word_99FE:	dc.w 1			; DATA XREF: ROM:000099EEo
		dc.w $F40A,    9,    4,$FFF4; 0
word_9A08:	dc.w 1			; DATA XREF: ROM:000099F0o
		dc.w $F40A,  $12,    9,$FFF4; 0
word_9A12:	dc.w 1			; DATA XREF: ROM:000099F2o
		dc.w $F40A,  $1B,   $D,$FFF4; 0
Map_Obj27:	dc.w word_9A26-Map_Obj27 ; DATA	XREF: ROM:000098B6o
					; ROM:Map_Obj27o ...
		dc.w word_9A30-Map_Obj27
		dc.w word_9A3A-Map_Obj27
		dc.w word_9A44-Map_Obj27
		dc.w word_9A66-Map_Obj27
word_9A26:	dc.w 1			; DATA XREF: ROM:Map_Obj27o
					; ROM:Map_Obj3Fo
		dc.w $F809,    0,    0,$FFF4; 0
word_9A30:	dc.w 1			; DATA XREF: ROM:00009A1Eo
		dc.w $F00F,    6,    3,$FFF0; 0
word_9A3A:	dc.w 1			; DATA XREF: ROM:00009A20o
		dc.w $F00F,  $16,   $B,$FFF0; 0
word_9A44:	dc.w 4			; DATA XREF: ROM:00009A22o
					; ROM:00009A8Eo
		dc.w $EC0A,  $26,  $13,$FFEC; 0
		dc.w $EC05,  $2F,  $17,	   4; 4
		dc.w  $405,$182F,$1817,$FFEC; 8
		dc.w $FC0A,$1826,$1813,$FFFC; 12
word_9A66:	dc.w 4			; DATA XREF: ROM:00009A24o
					; ROM:00009A90o
		dc.w $EC0A,  $33,  $19,$FFEC; 0
		dc.w $EC05,  $3C,  $1E,	   4; 4
		dc.w  $405,$183C,$181E,$FFEC; 8
		dc.w $FC0A,$1833,$1819,$FFFC; 12
Map_Obj3F:	dc.w word_9A26-Map_Obj3F ; DATA	XREF: ROM:0000992Ao
					; ROM:Map_Obj3Fo ...
		dc.w word_9A92-Map_Obj3F
		dc.w word_9A9C-Map_Obj3F
		dc.w word_9A44-Map_Obj3F
		dc.w word_9A66-Map_Obj3F
word_9A92:	dc.w 1			; DATA XREF: ROM:00009A8Ao
		dc.w $F00F,  $40,  $20,$FFF0; 0
word_9A9C:	dc.w 1			; DATA XREF: ROM:00009A8Co
		dc.w $F00F,  $50,  $28,$FFF0; 0
; ===============================================================================
		nop
;----------------------------------------------------
; Object 28 - animals
;----------------------------------------------------

Obj28:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	off_9AB6(pc,d0.w),d1
		jmp	off_9AB6(pc,d1.w)
; ===============================================================================
off_9AB6:	dc.w loc_9B92-off_9AB6,loc_9CB8-off_9AB6,loc_9D12-off_9AB6; 0
					; DATA XREF: ROM:off_9AB6o
					; ROM:off_9AB6+2o ...
		dc.w loc_9D4E-off_9AB6,loc_9D12-off_9AB6,loc_9D12-off_9AB6; 3
		dc.w loc_9D12-off_9AB6,loc_9D4E-off_9AB6,loc_9D12-off_9AB6; 6
		dc.w loc_9DCE-off_9AB6,loc_9DEE-off_9AB6,loc_9DEE-off_9AB6; 9
		dc.w loc_9E0E-off_9AB6,loc_9E48-off_9AB6,loc_9EA2-off_9AB6; 12
		dc.w loc_9EC0-off_9AB6,loc_9EA2-off_9AB6,loc_9EC0-off_9AB6; 15
		dc.w loc_9EA2-off_9AB6,loc_9EFE-off_9AB6,loc_9E64-off_9AB6; 18
byte_9AE0:	dc.b   0,  5,  2,  3,  6,  3,  4,  5,  4,  1,  0,  1; 0
					; DATA XREF: ROM:00009C16t
word_9AEC:	dc.w $FE00		; DATA XREF: ROM:00009C24t
		dc.w $FC00
		dc.l Map_Obj28a
		dc.w $FE00
		dc.w $FD00
		dc.l Map_Obj28
		dc.w $FE80
		dc.w $FD00
		dc.l Map_Obj28a
		dc.w $FEC0
		dc.w $FE80
		dc.l Map_Obj28
		dc.w $FE40
		dc.w $FD00
		dc.l Map_Obj28b
		dc.w $FD00
		dc.w $FC00
		dc.l Map_Obj28
		dc.w $FD80
		dc.w $FC80
		dc.l Map_Obj28b
word_9B24:	dc.w $FBC0,$FC00,$FBC0,$FC00; 0	; DATA XREF: ROM:00009BB8t
		dc.w $FBC0,$FC00,$FD00,$FC00; 4
		dc.w $FD00,$FC00,$FE80,$FD00; 8
		dc.w $FE80,$FD00,$FEC0,$FE80; 12
		dc.w $FE40,$FD00,$FE00,$FD00; 16
		dc.w $FD80,$FC80	; 20
off_9B50:	dc.l Map_Obj28,Map_Obj28; 0
		dc.l Map_Obj28,Map_Obj28a; 2
		dc.l Map_Obj28a,Map_Obj28a; 4
		dc.l Map_Obj28a,Map_Obj28; 6
		dc.l Map_Obj28b,Map_Obj28; 8
		dc.l Map_Obj28b		; 10
word_9B7C:	dc.w  $5A5, $5A5, $5A5,	$553, $553, $573, $573,	$585, $593, $565, $5B3;	0
; ===============================================================================

loc_9B92:				; DATA XREF: ROM:off_9AB6o
		tst.b	$28(a0)
		beq.w	loc_9C00
		moveq	#0,d0
		move.b	$28(a0),d0
		add.w	d0,d0
		move.b	d0,$24(a0)
		subi.w	#$14,d0
		move.w	word_9B7C(pc,d0.w),2(a0)
		add.w	d0,d0
		move.l	off_9B50(pc,d0.w),4(a0)
		lea	word_9B24(pc),a1
		move.w	(a1,d0.w),$32(a0)
		move.w	(a1,d0.w),$10(a0)
		move.w	2(a1,d0.w),$34(a0)
		move.w	2(a1,d0.w),$12(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#$C,$16(a0)
		move.b	#4,1(a0)
		bset	#0,1(a0)
		move.b	#6,$18(a0)
		move.b	#8,$19(a0)
		move.b	#7,$1E(a0)
		bra.w	DisplaySprite
; ===============================================================================

loc_9C00:				; CODE XREF: ROM:00009B96j
		addq.b	#2,$24(a0)
		bsr.w	PseudoRandomNumber
		andi.w	#1,d0
		moveq	#0,d1
		move.b	(RAM_Level_CurrentZone).w,d1
		add.w	d1,d1
		add.w	d0,d1
		lea	byte_9AE0(pc),a1
		move.b	(a1,d1.w),d0
		move.b	d0,$30(a0)
		lsl.w	#3,d0
		lea	word_9AEC(pc),a1
		adda.w	d0,a1
		move.w	(a1)+,$32(a0)
		move.w	(a1)+,$34(a0)
		move.l	(a1)+,4(a0)
		move.w	#$580,2(a0)
		btst	#0,$30(a0)
		beq.s	loc_9C4A
		move.w	#$592,2(a0)

loc_9C4A:				; CODE XREF: ROM:00009C42j
		bsr.w	ModifySpriteAttr_2P
		move.b	#$C,$16(a0)
		move.b	#4,1(a0)
		bset	#0,1(a0)
		move.b	#6,$18(a0)
		move.b	#8,$19(a0)
		move.b	#7,$1E(a0)
		move.b	#2,$1A(a0)
		move.w	#$FC00,$12(a0)
		tst.b	(RAM_Flag_Level_NoAnimals).w
		bne.s	loc_9CAA
		bsr.w	SingleObjectLoad
		bne.s	loc_9CA6
		move.b	#$29,0(a1) ; ')'
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		move.w	$3E(a0),d0
		lsr.w	#1,d0
		move.b	d0,$1A(a1)

loc_9CA6:				; CODE XREF: ROM:00009C88j
		bra.w	DisplaySprite
; ===============================================================================

loc_9CAA:				; CODE XREF: ROM:00009C82j
		move.b	#$12,$24(a0)
		clr.w	$10(a0)
		bra.w	DisplaySprite
; ===============================================================================

loc_9CB8:				; DATA XREF: ROM:off_9AB6o
		tst.b	1(a0)
		bpl.w	DeleteObject
		bsr.w	ObjectFall
		tst.w	$12(a0)
		bmi.s	loc_9D0E
		jsr	ObjHitFloor
		tst.w	d1
		bpl.s	loc_9D0E
		add.w	d1,$C(a0)
		move.w	$32(a0),$10(a0)
		move.w	$34(a0),$12(a0)
		move.b	#1,$1A(a0)
		move.b	$30(a0),d0
		add.b	d0,d0
		addq.b	#4,d0
		move.b	d0,$24(a0)
		tst.b	(RAM_Flag_Level_NoAnimals).w
		beq.s	loc_9D0E
		btst	#4,(RAM_VIntFrameCnt+3).w
		beq.s	loc_9D0E
		neg.w	$10(a0)
		bchg	#0,1(a0)

loc_9D0E:				; CODE XREF: ROM:00009CC8j
					; ROM:00009CD2j ...
		bra.w	DisplaySprite
; ===============================================================================

loc_9D12:				; CODE XREF: ROM:00009E60j
					; DATA XREF: ROM:off_9AB6o
		bsr.w	ObjectFall
		move.b	#1,$1A(a0)
		tst.w	$12(a0)
		bmi.s	loc_9D3C
		move.b	#0,$1A(a0)
		jsr	ObjHitFloor
		tst.w	d1
		bpl.s	loc_9D3C
		add.w	d1,$C(a0)
		move.w	$34(a0),$12(a0)

loc_9D3C:				; CODE XREF: ROM:00009D20j
					; ROM:00009D30j
		tst.b	$28(a0)
		bne.s	loc_9DB2
		tst.b	1(a0)
		bpl.w	DeleteObject
		bra.w	DisplaySprite
; ===============================================================================

loc_9D4E:				; CODE XREF: ROM:00009E06j
					; DATA XREF: ROM:off_9AB6o
		bsr.w	SpeedToPos
		addi.w	#$18,$12(a0)
		tst.w	$12(a0)
		bmi.s	loc_9D8A
		jsr	ObjHitFloor
		tst.w	d1
		bpl.s	loc_9D8A
		add.w	d1,$C(a0)
		move.w	$34(a0),$12(a0)
		tst.b	$28(a0)
		beq.s	loc_9D8A
		cmpi.b	#$A,$28(a0)
		beq.s	loc_9D8A
		neg.w	$10(a0)
		bchg	#0,1(a0)

loc_9D8A:				; CODE XREF: ROM:00009D5Cj
					; ROM:00009D66j ...
		subq.b	#1,$1E(a0)
		bpl.s	loc_9DA0
		move.b	#1,$1E(a0)
		addq.b	#1,$1A(a0)
		andi.b	#1,$1A(a0)

loc_9DA0:				; CODE XREF: ROM:00009D8Ej
		tst.b	$28(a0)
		bne.s	loc_9DB2
		tst.b	1(a0)
		bpl.w	DeleteObject
		bra.w	DisplaySprite
; ===============================================================================

loc_9DB2:				; CODE XREF: ROM:00009D40j
					; ROM:00009DA4j ...
		move.w	8(a0),d0
		sub.w	(RAM_ObjRam_Sonic+$8).w,d0
		bcs.s	loc_9DCA
		subi.w	#$180,d0
		bpl.s	loc_9DCA
		tst.b	1(a0)
		bpl.w	DeleteObject

loc_9DCA:				; CODE XREF: ROM:00009DBAj
					; ROM:00009DC0j
		bra.w	DisplaySprite
; ===============================================================================

loc_9DCE:				; DATA XREF: ROM:off_9AB6o
		tst.b	1(a0)
		bpl.w	DeleteObject
		subq.w	#1,$36(a0)
		bne.w	loc_9DEA
		move.b	#2,$24(a0)
		move.b	#3,$18(a0)

loc_9DEA:				; CODE XREF: ROM:00009DDAj
		bra.w	DisplaySprite
; ===============================================================================

loc_9DEE:				; DATA XREF: ROM:off_9AB6o
		bsr.w	sub_9F92
		bcc.s	loc_9E0A
		move.w	$32(a0),$10(a0)
		move.w	$34(a0),$12(a0)
		move.b	#$E,$24(a0)
		bra.w	loc_9D4E
; ===============================================================================

loc_9E0A:				; CODE XREF: ROM:00009DF2j
		bra.w	loc_9DB2
; ===============================================================================

loc_9E0E:				; DATA XREF: ROM:off_9AB6o
		bsr.w	sub_9F92
		bpl.s	loc_9E44
		clr.w	$10(a0)
		clr.w	$32(a0)
		bsr.w	SpeedToPos
		addi.w	#$18,$12(a0)
		bsr.w	sub_9F52
		bsr.w	sub_9F7A
		subq.b	#1,$1E(a0)
		bpl.s	loc_9E44
		move.b	#1,$1E(a0)
		addq.b	#1,$1A(a0)
		andi.b	#1,$1A(a0)

loc_9E44:				; CODE XREF: ROM:00009E12j
					; ROM:00009E32j
		bra.w	loc_9DB2
; ===============================================================================

loc_9E48:				; DATA XREF: ROM:off_9AB6o
		bsr.w	sub_9F92
		bpl.s	loc_9E9E
		move.w	$32(a0),$10(a0)
		move.w	$34(a0),$12(a0)
		move.b	#4,$24(a0)
		bra.w	loc_9D12
; ===============================================================================

loc_9E64:				; DATA XREF: ROM:off_9AB6o
		bsr.w	ObjectFall
		move.b	#1,$1A(a0)
		tst.w	$12(a0)
		bmi.s	loc_9E9E
		move.b	#0,$1A(a0)
		jsr	ObjHitFloor
		tst.w	d1
		bpl.s	loc_9E9E
		not.b	$29(a0)
		bne.s	loc_9E94
		neg.w	$10(a0)
		bchg	#0,1(a0)

loc_9E94:				; CODE XREF: ROM:00009E88j
		add.w	d1,$C(a0)
		move.w	$34(a0),$12(a0)

loc_9E9E:				; CODE XREF: ROM:00009E4Cj
					; ROM:00009E72j ...
		bra.w	loc_9DB2
; ===============================================================================

loc_9EA2:				; DATA XREF: ROM:off_9AB6o
		bsr.w	sub_9F92
		bpl.s	loc_9EBC
		clr.w	$10(a0)
		clr.w	$32(a0)
		bsr.w	ObjectFall
		bsr.w	sub_9F52
		bsr.w	sub_9F7A

loc_9EBC:				; CODE XREF: ROM:00009EA6j
		bra.w	loc_9DB2
; ===============================================================================

loc_9EC0:				; DATA XREF: ROM:off_9AB6o
		bsr.w	sub_9F92
		bpl.s	loc_9EFA
		bsr.w	ObjectFall
		move.b	#1,$1A(a0)
		tst.w	$12(a0)
		bmi.s	loc_9EFA
		move.b	#0,$1A(a0)
		jsr	ObjHitFloor
		tst.w	d1
		bpl.s	loc_9EFA
		neg.w	$10(a0)
		bchg	#0,1(a0)
		add.w	d1,$C(a0)
		move.w	$34(a0),$12(a0)

loc_9EFA:				; CODE XREF: ROM:00009EC4j
					; ROM:00009ED4j ...
		bra.w	loc_9DB2
; ===============================================================================

loc_9EFE:				; DATA XREF: ROM:off_9AB6o
		bsr.w	sub_9F92
		bpl.s	loc_9F4E
		bsr.w	SpeedToPos
		addi.w	#$18,$12(a0)
		tst.w	$12(a0)
		bmi.s	loc_9F38
		jsr	ObjHitFloor
		tst.w	d1
		bpl.s	loc_9F38
		not.b	$29(a0)
		bne.s	loc_9F2E
		neg.w	$10(a0)
		bchg	#0,1(a0)

loc_9F2E:				; CODE XREF: ROM:00009F22j
		add.w	d1,$C(a0)
		move.w	$34(a0),$12(a0)

loc_9F38:				; CODE XREF: ROM:00009F12j
					; ROM:00009F1Cj
		subq.b	#1,$1E(a0)
		bpl.s	loc_9F4E
		move.b	#1,$1E(a0)
		addq.b	#1,$1A(a0)
		andi.b	#1,$1A(a0)

loc_9F4E:				; CODE XREF: ROM:00009F02j
					; ROM:00009F3Cj
		bra.w	loc_9DB2

; =============== S U B R O U T I N E ==========================================


sub_9F52:				; CODE XREF: ROM:00009E26p
					; ROM:00009EB4p
		move.b	#1,$1A(a0)
		tst.w	$12(a0)
		bmi.s	locret_9F78
		move.b	#0,$1A(a0)
		jsr	ObjHitFloor
		tst.w	d1
		bpl.s	locret_9F78
		add.w	d1,$C(a0)
		move.w	$34(a0),$12(a0)

locret_9F78:				; CODE XREF: sub_9F52+Aj sub_9F52+1Aj
		rts
; End of function sub_9F52


; =============== S U B R O U T I N E ==========================================


sub_9F7A:				; CODE XREF: ROM:00009E2Ap
					; ROM:00009EB8p
		bset	#0,1(a0)
		move.w	8(a0),d0
		sub.w	(RAM_ObjRam_Sonic+$8).w,d0
		bcc.s	locret_9F90
		bclr	#0,1(a0)

locret_9F90:				; CODE XREF: sub_9F7A+Ej
		rts
; End of function sub_9F7A


; =============== S U B R O U T I N E ==========================================


sub_9F92:				; CODE XREF: ROM:loc_9DEEp
					; ROM:loc_9E0Ep ...
		move.w	(RAM_ObjRam_Sonic+$8).w,d0
		sub.w	8(a0),d0
		subi.w	#$B8,d0	; ''
		rts
; End of function sub_9F92

; ===============================================================================
;----------------------------------------------------
; Object 29 - points that appear when you destroy something
;----------------------------------------------------

Obj29:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj29_Index(pc,d0.w),d1
		jmp	Obj29_Index(pc,d1.w)
; ===============================================================================
Obj29_Index:	dc.w loc_9FB2-Obj29_Index ; DATA XREF: ROM:Obj29_Indexo
					; ROM:00009FB0o
		dc.w loc_9FE0-Obj29_Index
; ===============================================================================

loc_9FB2:				; DATA XREF: ROM:Obj29_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj29,4(a0)
		move.w	#$4AC,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#4,1(a0)
		move.b	#1,$18(a0)
		move.b	#8,$19(a0)
		move.w	#$FD00,$12(a0)

loc_9FE0:				; DATA XREF: ROM:00009FB0o
		tst.w	$12(a0)
		bpl.w	DeleteObject
		bsr.w	SpeedToPos
		addi.w	#$18,$12(a0)
		bra.w	DisplaySprite
; ===============================================================================
Map_Obj28a:	dc.w word_A006-Map_Obj28a ; DATA XREF: ROM:00009AF0o
					; ROM:00009B00o ...
		dc.w word_A010-Map_Obj28a
		dc.w word_9FFC-Map_Obj28a
word_9FFC:	dc.w 1			; DATA XREF: ROM:00009FFAo
		dc.w $F406,    0,    0,$FFF8; 0
word_A006:	dc.w 1			; DATA XREF: ROM:Map_Obj28ao
		dc.w $F406,    6,    3,$FFF8; 0
word_A010:	dc.w 1			; DATA XREF: ROM:00009FF8o
		dc.w $F406,   $C,    6,$FFF8; 0
Map_Obj28:	dc.w word_A02A-Map_Obj28 ; DATA	XREF: ROM:00009AF8o
					; ROM:00009B08o ...
		dc.w word_A034-Map_Obj28
		dc.w word_A020-Map_Obj28
word_A020:	dc.w 1			; DATA XREF: ROM:0000A01Eo
		dc.w $F406,    0,    0,$FFF8; 0
word_A02A:	dc.w 1			; DATA XREF: ROM:Map_Obj28o
		dc.w $FC05,    6,    3,$FFF8; 0
word_A034:	dc.w 1			; DATA XREF: ROM:0000A01Co
		dc.w $FC05,   $A,    5,$FFF8; 0
Map_Obj28b:	dc.w word_A04E-Map_Obj28b ; DATA XREF: ROM:00009B10o
					; ROM:00009B20o ...
		dc.w word_A058-Map_Obj28b
		dc.w word_A044-Map_Obj28b
word_A044:	dc.w 1			; DATA XREF: ROM:0000A042o
		dc.w $F406,    0,    0,$FFF8; 0
word_A04E:	dc.w 1			; DATA XREF: ROM:Map_Obj28bo
		dc.w $FC09,    6,    3,$FFF4; 0
word_A058:	dc.w 1			; DATA XREF: ROM:0000A040o
		dc.w $FC09,   $C,    6,$FFF4; 0
Map_Obj29:	dc.w word_A070-Map_Obj29 ; DATA	XREF: ROM:00009FB6o
					; ROM:Map_Obj29o ...
		dc.w word_A07A-Map_Obj29
		dc.w word_A084-Map_Obj29
		dc.w word_A08E-Map_Obj29
		dc.w word_A0A0-Map_Obj29
		dc.w word_A0AA-Map_Obj29
		dc.w word_A0BC-Map_Obj29
word_A070:	dc.w 1			; DATA XREF: ROM:Map_Obj29o
		dc.w $F805,    2,    1,$FFF8; 0
word_A07A:	dc.w 1			; DATA XREF: ROM:0000A064o
		dc.w $F805,    6,    3,$FFF8; 0
word_A084:	dc.w 1			; DATA XREF: ROM:0000A066o
		dc.w $F805,   $A,    5,$FFF8; 0
word_A08E:	dc.w 2			; DATA XREF: ROM:0000A068o
		dc.w $F801,    0,    0,$FFF8; 0
		dc.w $F805,   $E,    7,	   0; 4
word_A0A0:	dc.w 1			; DATA XREF: ROM:0000A06Ao
		dc.w $F801,    0,    0,$FFFC; 0
word_A0AA:	dc.w 2			; DATA XREF: ROM:0000A06Co
		dc.w $F805,    2,    1,$FFF0; 0
		dc.w $F805,   $E,    7,	   0; 4
word_A0BC:	dc.w 2			; DATA XREF: ROM:0000A06Eo
		dc.w $F805,   $A,    5,$FFF0; 0
		dc.w $F805,   $E,    7,	   0; 4
; ===============================================================================
		nop
;----------------------------------------------------
; Object 1F - GHZ Crabmeat
;----------------------------------------------------

Obj1F:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj1F_Index(pc,d0.w),d1
		jmp	Obj1F_Index(pc,d1.w)
; ===============================================================================
Obj1F_Index:	dc.w loc_A0E8-Obj1F_Index ; DATA XREF: ROM:Obj1F_Indexo
					; ROM:0000A0E0o ...
		dc.w loc_A140-Obj1F_Index
		dc.w loc_A29C-Obj1F_Index
		dc.w loc_A2A0-Obj1F_Index
		dc.w loc_A2DA-Obj1F_Index
; ===============================================================================

loc_A0E8:				; DATA XREF: ROM:Obj1F_Indexo
		move.b	#$10,$16(a0)
		move.b	#8,$17(a0)
		move.l	#Map_Obj1F,4(a0)
		move.w	#$400,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#4,1(a0)
		move.b	#3,$18(a0)
		move.b	#6,$20(a0)
		move.b	#$15,$19(a0)
		bsr.w	ObjectFall
		jsr	ObjHitFloor
		tst.w	d1
		bpl.s	locret_A13E
		add.w	d1,$C(a0)
		move.b	d3,$26(a0)
		move.w	#0,$12(a0)
		addq.b	#2,$24(a0)

locret_A13E:				; CODE XREF: ROM:0000A12Aj
		rts
; ===============================================================================

loc_A140:				; DATA XREF: ROM:0000A0E0o
		moveq	#0,d0
		move.b	$25(a0),d0
		move.w	off_A15C(pc,d0.w),d1
		jsr	off_A15C(pc,d1.w)
		lea	(Ani_Obj1F).l,a1
		bsr.w	AnimateSprite
		bra.w	MarkObjGone
; ===============================================================================
off_A15C:	dc.w loc_A160-off_A15C	; DATA XREF: ROM:off_A15Co
					; ROM:0000A15Eo
		dc.w loc_A1FE-off_A15C
; ===============================================================================

loc_A160:				; DATA XREF: ROM:off_A15Co
		subq.w	#1,$30(a0)
		bpl.s	locret_A19A
		tst.b	1(a0)
		bpl.s	loc_A174
		bchg	#1,$32(a0)
		bne.s	loc_A19C

loc_A174:				; CODE XREF: ROM:0000A16Aj
		addq.b	#2,$25(a0)
		move.w	#$7F,$30(a0) ; ''
		move.w	#$80,$10(a0) ; ''
		bsr.w	sub_A26C
		addq.b	#3,d0
		move.b	d0,$1C(a0)
		bchg	#0,$22(a0)
		bne.s	locret_A19A
		neg.w	$10(a0)

locret_A19A:				; CODE XREF: ROM:0000A164j
					; ROM:0000A194j
		rts
; ===============================================================================

loc_A19C:				; CODE XREF: ROM:0000A172j
		move.w	#$3B,$30(a0) ; ';'
		move.b	#6,$1C(a0)
		bsr.w	SingleObjectLoad
		bne.s	loc_A1D2
		move.b	#$1F,0(a1)
		move.b	#6,$24(a1)
		move.w	8(a0),8(a1)
		subi.w	#$10,8(a1)
		move.w	$C(a0),$C(a1)
		move.w	#$FF00,$10(a1)

loc_A1D2:				; CODE XREF: ROM:0000A1ACj
		bsr.w	SingleObjectLoad
		bne.s	locret_A1FC
		move.b	#$1F,0(a1)
		move.b	#6,$24(a1)
		move.w	8(a0),8(a1)
		addi.w	#$10,8(a1)
		move.w	$C(a0),$C(a1)
		move.w	#$100,$10(a1)

locret_A1FC:				; CODE XREF: ROM:0000A1D6j
		rts
; ===============================================================================

loc_A1FE:				; DATA XREF: ROM:0000A15Eo
		subq.w	#1,$30(a0)
		bmi.s	loc_A252
		bsr.w	SpeedToPos
		bchg	#0,$32(a0)
		bne.s	loc_A238
		move.w	8(a0),d3
		addi.w	#$10,d3
		btst	#0,$22(a0)
		beq.s	loc_A224
		subi.w	#$20,d3	; ' '

loc_A224:				; CODE XREF: ROM:0000A21Ej
		jsr	ObjHitFloor2
		cmpi.w	#$FFF8,d1
		blt.s	loc_A252
		cmpi.w	#$C,d1
		bge.s	loc_A252
		rts
; ===============================================================================

loc_A238:				; CODE XREF: ROM:0000A20Ej
		jsr	ObjHitFloor
		add.w	d1,$C(a0)
		move.b	d3,$26(a0)
		bsr.w	sub_A26C
		addq.b	#3,d0
		move.b	d0,$1C(a0)
		rts
; ===============================================================================

loc_A252:				; CODE XREF: ROM:0000A202j
					; ROM:0000A22Ej ...
		subq.b	#2,$25(a0)
		move.w	#$3B,$30(a0) ; ';'
		move.w	#0,$10(a0)
		bsr.w	sub_A26C
		move.b	d0,$1C(a0)
		rts

; =============== S U B R O U T I N E ==========================================


sub_A26C:				; CODE XREF: ROM:0000A184p
					; ROM:0000A246p ...
		moveq	#0,d0
		move.b	$26(a0),d3
		bmi.s	loc_A288
		cmpi.b	#6,d3
		bcs.s	locret_A286
		moveq	#1,d0
		btst	#0,$22(a0)
		bne.s	locret_A286
		moveq	#2,d0

locret_A286:				; CODE XREF: sub_A26C+Cj sub_A26C+16j
		rts
; ===============================================================================

loc_A288:				; CODE XREF: sub_A26C+6j
		cmpi.b	#$FA,d3
		bhi.s	locret_A29A
		moveq	#2,d0
		btst	#0,$22(a0)
		bne.s	locret_A29A
		moveq	#1,d0

locret_A29A:				; CODE XREF: sub_A26C+20j sub_A26C+2Aj
		rts
; End of function sub_A26C

; ===============================================================================

loc_A29C:				; DATA XREF: ROM:0000A0E2o
		bra.w	DeleteObject
; ===============================================================================

loc_A2A0:				; DATA XREF: ROM:0000A0E4o
		addq.b	#2,$24(a0)
		move.l	#Map_Obj1F,4(a0)
		move.w	#$400,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#4,1(a0)
		move.b	#3,$18(a0)
		move.b	#$87,$20(a0)
		move.b	#8,$19(a0)
		move.w	#$FC00,$12(a0)
		move.b	#7,$1C(a0)

loc_A2DA:				; DATA XREF: ROM:0000A0E6o
		lea	(Ani_Obj1F).l,a1
		bsr.w	AnimateSprite
		bsr.w	ObjectFall
		move.w	(RAM_LevelSys_YPos_SetEnd).w,d0
		addi.w	#$E0,d0	; ''
		cmp.w	$C(a0),d0
		bcs.w	DeleteObject
		bra.w	DisplaySprite
; ===============================================================================
Ani_Obj1F:	dc.w byte_A30C-Ani_Obj1F ; DATA	XREF: ROM:0000A14Eo
					; ROM:loc_A2DAo ...
		dc.w byte_A30F-Ani_Obj1F
		dc.w byte_A312-Ani_Obj1F
		dc.w byte_A315-Ani_Obj1F
		dc.w byte_A31A-Ani_Obj1F
		dc.w byte_A31F-Ani_Obj1F
		dc.w byte_A324-Ani_Obj1F
		dc.w byte_A327-Ani_Obj1F
byte_A30C:	dc.b  $F,  0,$FF	; 0 ; DATA XREF: ROM:Ani_Obj1Fo
byte_A30F:	dc.b  $F,  2,$FF	; 0 ; DATA XREF: ROM:0000A2FEo
byte_A312:	dc.b  $F,$22,$FF	; 0 ; DATA XREF: ROM:0000A300o
byte_A315:	dc.b  $F,  1,$21,  0,$FF; 0 ; DATA XREF: ROM:0000A302o
byte_A31A:	dc.b  $F,$21,  3,  2,$FF; 0 ; DATA XREF: ROM:0000A304o
byte_A31F:	dc.b  $F,  1,$23,$22,$FF; 0 ; DATA XREF: ROM:0000A306o
byte_A324:	dc.b  $F,  4,$FF	; 0 ; DATA XREF: ROM:0000A308o
byte_A327:	dc.b   1,  5,  6,$FF,  0; 0 ; DATA XREF: ROM:0000A30Ao
Map_Obj1F:	dc.w word_A33A-Map_Obj1F ; DATA	XREF: ROM:0000A0F4o
					; ROM:0000A2A4o ...
		dc.w word_A35C-Map_Obj1F
		dc.w word_A37E-Map_Obj1F
		dc.w word_A3A0-Map_Obj1F
		dc.w word_A3C2-Map_Obj1F
		dc.w word_A3F4-Map_Obj1F
		dc.w word_A3FE-Map_Obj1F
word_A33A:	dc.w 4			; DATA XREF: ROM:Map_Obj1Fo
		dc.w $F009,    0,    0,$FFE8; 0
		dc.w $F009, $800, $800,	   0; 4
		dc.w	 5,    6,    3,$FFF0; 8
		dc.w	 5, $806, $803,	   0; 12
word_A35C:	dc.w 4			; DATA XREF: ROM:0000A32Eo
		dc.w $F009,   $A,    5,$FFE8; 0
		dc.w $F009,  $10,    8,	   0; 4
		dc.w	 5,  $16,   $B,$FFF0; 8
		dc.w	 9,  $1A,   $D,	   0; 12
word_A37E:	dc.w 4			; DATA XREF: ROM:0000A330o
		dc.w $EC09,    0,    0,$FFE8; 0
		dc.w $EC09, $800, $800,	   0; 4
		dc.w $FC05, $806, $803,	   0; 8
		dc.w $FC06,  $20,  $10,$FFF0; 12
word_A3A0:	dc.w 4			; DATA XREF: ROM:0000A332o
		dc.w $EC09,   $A,    5,$FFE8; 0
		dc.w $EC09,  $10,    8,	   0; 4
		dc.w $FC09,  $26,  $13,	   0; 8
		dc.w $FC06,  $2C,  $16,$FFF0; 12
word_A3C2:	dc.w 6			; DATA XREF: ROM:0000A334o
		dc.w $F004,  $32,  $19,$FFF0; 0
		dc.w $F004, $832, $819,	   0; 4
		dc.w $F809,  $34,  $1A,$FFE8; 8
		dc.w $F809, $834, $81A,	   0; 12
		dc.w  $804,  $3A,  $1D,$FFF0; 16
		dc.w  $804, $83A, $81D,	   0; 20
word_A3F4:	dc.w 1			; DATA XREF: ROM:0000A336o
		dc.w $F805,  $3C,  $1E,$FFF8; 0
word_A3FE:	dc.w 1			; DATA XREF: ROM:0000A338o
		dc.w $F805,  $40,  $20,$FFF8; 0
; ===============================================================================
;----------------------------------------------------
; Object 22 - Buzzbomber
;----------------------------------------------------

Obj22:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	off_A416(pc,d0.w),d1
		jmp	off_A416(pc,d1.w)
; ===============================================================================
off_A416:	dc.w loc_A41C-off_A416	; DATA XREF: ROM:off_A416o
					; ROM:0000A418o ...
		dc.w loc_A44A-off_A416
		dc.w loc_A55A-off_A416
; ===============================================================================

loc_A41C:				; DATA XREF: ROM:off_A416o
		addq.b	#2,$24(a0)
		move.l	#Map_Obj22,4(a0)
		move.w	#$444,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#4,1(a0)
		move.b	#3,$18(a0)
		move.b	#8,$20(a0)
		move.b	#$18,$19(a0)

loc_A44A:				; DATA XREF: ROM:0000A418o
		moveq	#0,d0
		move.b	$25(a0),d0
		move.w	off_A466(pc,d0.w),d1
		jsr	off_A466(pc,d1.w)
		lea	(Ani_Obj22).l,a1
		bsr.w	AnimateSprite
		bra.w	MarkObjGone
; ===============================================================================
off_A466:	dc.w loc_A46A-off_A466	; DATA XREF: ROM:off_A466o
					; ROM:0000A468o
		dc.w loc_A500-off_A466
; ===============================================================================

loc_A46A:				; DATA XREF: ROM:off_A466o
		subq.w	#1,$32(a0)
		bpl.s	locret_A49A
		btst	#1,$34(a0)
		bne.s	loc_A49C
		addq.b	#2,$25(a0)
		move.w	#$7F,$32(a0) ; ''
		move.w	#$400,$10(a0)
		move.b	#1,$1C(a0)
		btst	#0,$22(a0)
		bne.s	locret_A49A
		neg.w	$10(a0)

locret_A49A:				; CODE XREF: ROM:0000A46Ej
					; ROM:0000A494j
		rts
; ===============================================================================

loc_A49C:				; CODE XREF: ROM:0000A476j
		bsr.w	SingleObjectLoad
		bne.s	locret_A4FE
		move.b	#$23,0(a1) ; '#'
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		addi.w	#$1C,$C(a1)
		move.w	#$200,$12(a1)
		move.w	#$200,$10(a1)
		move.w	#$18,d0
		btst	#0,$22(a0)
		bne.s	loc_A4D8
		neg.w	d0
		neg.w	$10(a1)

loc_A4D8:				; CODE XREF: ROM:0000A4D0j
		add.w	d0,8(a1)
		move.b	$22(a0),$22(a1)
		move.w	#$E,$32(a1)
		move.l	a0,$3C(a1)
		move.b	#1,$34(a0)
		move.w	#$3B,$32(a0) ; ';'
		move.b	#2,$1C(a0)

locret_A4FE:
		rts
; ===============================================================================

loc_A500:
		subq.w	#1,$32(a0)
		bmi.s	loc_A536
		bsr.w	SpeedToPos
		tst.b	$34(a0)
		bne.s	locret_A558
		move.w	(RAM_ObjRAM_Sonic+$8).w,d0
		sub.w	8(a0),d0
		bpl.s	loc_A51C
		neg.w	d0

loc_A51C:
		cmpi.w	#$60,d0
		bcc.s	locret_A558
		tst.b	1(a0)
		bpl.s	locret_A558
		move.b	#2,$34(a0)
		move.w	#$1D,$32(a0)
		bra.s	loc_A548
; ===============================================================================

loc_A536:
		move.b	#0,$34(a0)
		bchg	#0,$22(a0)
		move.w	#$3B,$32(a0)

loc_A548:
		subq.b	#2,$25(a0)
		move.w	#0,$10(a0)
		move.b	#0,$1C(a0)

locret_A558:
		rts
; ===============================================================================

loc_A55A:
		bra.w	DeleteObject
; ===============================================================================
;----------------------------------------------------
; Object 23 - Missile that Buzzbomber throws
;----------------------------------------------------

Obj23:
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	off_A56C(pc,d0.w),d1
		jmp	off_A56C(pc,d1.w)
; ===============================================================================
off_A56C:	dc.w loc_A576-off_A56C
		dc.w loc_A5C4-off_A56C
		dc.w loc_A5EC-off_A56C
		dc.w loc_A630-off_A56C
		dc.w loc_A634-off_A56C
; ===============================================================================

loc_A576:
		subq.w	#1,$32(a0)
		bpl.s	loc_A5DE
		addq.b	#2,$24(a0)
		move.l	#Map_Obj23,4(a0)
		move.w	#$2444,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#4,1(a0)
		move.b	#3,$18(a0)
		move.b	#8,$19(a0)
		andi.b	#3,$22(a0)
		tst.b	$28(a0)
		beq.s	loc_A5C4
		move.b	#8,$24(a0)
		move.b	#$87,$20(a0)
		move.b	#1,$1C(a0)
		bra.s	loc_A63E
; ===============================================================================

loc_A5C4:
		movea.l	$3C(a0),a1
		cmpi.b	#$27,0(a1)
		beq.s	loc_A630
		lea	(Ani_Obj33).l,a1
		bsr.w	AnimateSprite
		bra.w	DisplaySprite
; ===============================================================================

loc_A5DE:
		movea.l	$3C(a0),a1
		cmpi.b	#$27,0(a1)
		beq.s	loc_A630
		rts
; ===============================================================================

loc_A5EC:
		btst	#7,$22(a0)
		bne.s	loc_A620
		move.b	#$87,$20(a0)
		move.b	#1,$1C(a0)
		bsr.w	SpeedToPos
		lea	(Ani_Obj33).l,a1
		bsr.w	AnimateSprite
		move.w	(RAM_LevelSys_YPos_SetEnd).w,d0
		addi.w	#$E0,d0
		cmp.w	$C(a0),d0
		bcs.s	loc_A630
		bra.w	DisplaySprite
; ===============================================================================

loc_A620:
		move.b	#$24,0(a0)
		move.b	#0,$24(a0)
		bra.w	Obj24
; ===============================================================================

loc_A630:
		bra.w	DeleteObject
; ===============================================================================

loc_A634:
		tst.b	1(a0)
		bpl.s	loc_A630
		bsr.w	SpeedToPos

loc_A63E:
		lea	(Ani_Obj33).l,a1
		bsr.w	AnimateSprite
		bra.w	DisplaySprite
; ===============================================================================
Ani_Obj22:	dc.w byte_A652-Ani_Obj22
		dc.w byte_A656-Ani_Obj22
		dc.w byte_A65A-Ani_Obj22
byte_A652:	dc.b   1,  0,  1,$FF	; 0 ; DATA XREF: ROM:Ani_Obj22o
byte_A656:	dc.b   1,  2,  3,$FF	; 0 ; DATA XREF: ROM:0000A64Eo
byte_A65A:	dc.b   1,  4,  5,$FF	; 0 ; DATA XREF: ROM:0000A650o
Ani_Obj33:	dc.w byte_A662-Ani_Obj33 ; DATA	XREF: ROM:0000A5D0o
					; ROM:0000A604o ...
		dc.w byte_A666-Ani_Obj33
byte_A662:	dc.b   7,  0,  1,$FC	; 0 ; DATA XREF: ROM:Ani_Obj33o
byte_A666:	dc.b   1,  2,  3,$FF	; 0 ; DATA XREF: ROM:0000A660o
Map_Obj22:	dc.w word_A676-Map_Obj22 ; DATA	XREF: ROM:0000A420o
					; ROM:Map_Obj22o ...
		dc.w word_A6A8-Map_Obj22
		dc.w word_A6DA-Map_Obj22
		dc.w word_A714-Map_Obj22
		dc.w word_A74E-Map_Obj22
		dc.w word_A780-Map_Obj22
word_A676:	dc.w 6			; DATA XREF: ROM:Map_Obj22o
		dc.w $F409,    0,    0,$FFE8; 0
		dc.w $F409,   $F,    7,	   0; 4
		dc.w  $408,  $15,   $A,$FFE8; 8
		dc.w  $404,  $18,   $C,	   0; 12
		dc.w $F108,  $1A,   $D,$FFEC; 16
		dc.w $F104,  $1D,   $E,	   4; 20
word_A6A8:	dc.w 6			; DATA XREF: ROM:0000A66Co
		dc.w $F409,    0,    0,$FFE8; 0
		dc.w $F409,   $F,    7,	   0; 4
		dc.w  $408,  $15,   $A,$FFE8; 8
		dc.w  $404,  $18,   $C,	   0; 12
		dc.w $F408,  $1F,   $F,$FFEC; 16
		dc.w $F404,  $22,  $11,	   4; 20
word_A6DA:	dc.w 7			; DATA XREF: ROM:0000A66Eo
		dc.w  $400,  $30,  $18,	  $C; 0
		dc.w $F409,    0,    0,$FFE8; 4
		dc.w $F409,   $F,    7,	   0; 8
		dc.w  $408,  $15,   $A,$FFE8; 12
		dc.w  $404,  $18,   $C,	   0; 16
		dc.w $F108,  $1A,   $D,$FFEC; 20
		dc.w $F104,  $1D,   $E,	   4; 24
word_A714:	dc.w 7			; DATA XREF: ROM:0000A670o
		dc.w  $404,  $31,  $18,	  $C; 0
		dc.w $F409,    0,    0,$FFE8; 4
		dc.w $F409,   $F,    7,	   0; 8
		dc.w  $408,  $15,   $A,$FFE8; 12
		dc.w  $404,  $18,   $C,	   0; 16
		dc.w $F408,  $1F,   $F,$FFEC; 20
		dc.w $F404,  $22,  $11,	   4; 24
word_A74E:	dc.w 6			; DATA XREF: ROM:0000A672o
		dc.w $F40D,    0,    0,$FFEC; 0
		dc.w  $40C,    8,    4,$FFEC; 4
		dc.w  $400,   $C,    6,	  $C; 8
		dc.w  $C04,   $D,    6,$FFF4; 12
		dc.w $F108,  $1A,   $D,$FFEC; 16
		dc.w $F104,  $1D,   $E,	   4; 20
word_A780:	dc.w 4			; DATA XREF: ROM:0000A674o
		dc.w $F40D,    0,    0,$FFEC; 0
		dc.w  $40C,    8,    4,$FFEC; 4
		dc.w  $400,   $C,    6,	  $C; 8
		dc.w  $C04,   $D,    6,$FFF4; 12
		dc.w $F408,  $1F,   $F,$FFEC; 16
		dc.w $F404,  $22,  $11,	   4; 20
Map_Obj23:	dc.w word_A7BA-Map_Obj23 ; DATA	XREF: ROM:0000A580o
					; ROM:Map_Obj23o ...
		dc.w word_A7C4-Map_Obj23
		dc.w word_A7CE-Map_Obj23
		dc.w word_A7D8-Map_Obj23
word_A7BA:	dc.w 1			; DATA XREF: ROM:Map_Obj23o
		dc.w $F805,  $24,  $12,$FFF8; 0
word_A7C4:	dc.w 1			; DATA XREF: ROM:0000A7B4o
		dc.w $F805,  $28,  $14,$FFF8; 0
word_A7CE:	dc.w 1			; DATA XREF: ROM:0000A7B6o
		dc.w $F805,  $2C,  $16,$FFF8; 0
word_A7D8:	dc.w 1			; DATA XREF: ROM:0000A7B8o
		dc.w $F805,  $33,  $19,$FFF8; 0
; ===============================================================================
		nop
;----------------------------------------------------
; Object 25 - Rings
;----------------------------------------------------

Obj25:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj25_Index(pc,d0.w),d1
		jmp	Obj25_Index(pc,d1.w)
; ===============================================================================
Obj25_Index:	dc.w loc_A81C-Obj25_Index ; DATA XREF: ROM:Obj25_Indexo
					; ROM:0000A7F4o ...
		dc.w loc_A88A-Obj25_Index
		dc.w loc_A8A6-Obj25_Index
		dc.w loc_A8CC-Obj25_Index
		dc.w loc_A8DA-Obj25_Index
		dc.b $10,  0,$18,  0	; 0
		dc.b $20,  0,  0,$10	; 4
		dc.b   0,$18,  0,$20	; 8
		dc.b $10,$10,$18,$18	; 12
		dc.b $20,$20,$F0,$10	; 16
		dc.b $E8,$18,$E0,$20	; 20
		dc.b $10,  8,$18,$10	; 24
		dc.b $F0,  8,$E8,$10	; 28
; ===============================================================================

loc_A81C:
		movea.l	a0,a1
		moveq	#0,d1
		move.w	8(a0),d2
		move.w	$C(a0),d3
		bra.s	loc_A832
; ===============================================================================

loc_A82A:
		swap	d1
		bsr.w	SingleObjectLoad
		bne.s	loc_A88A

loc_A832:
		move.b	#$25,0(a1) ; '%'
		addq.b	#2,$24(a1)
		move.w	d2,8(a1)
		move.w	8(a0),$32(a1)
		move.w	d3,$C(a1)
		move.l	#Map_Obj25,4(a1)
		move.w	#$26BC,2(a1)
		bsr.w	ModifyA1SpriteAttr_2P
		move.b	#4,1(a1)
		move.b	#2,$18(a1)
		move.b	#$47,$20(a1) ; 'G'
		move.b	#8,$19(a1)
		move.b	$23(a0),$23(a1)
		move.b	d1,$34(a1)
		addq.w	#1,d1
		add.w	d5,d2
		add.w	d6,d3
		swap	d1
		dbf	d1,loc_A82A

loc_A88A:
		move.b	(RAM_ObjSpecial_RingFrame_4).w,$1A(a0)
		move.w	$32(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.s	loc_A8DA
		bra.w	DisplaySprite
; ===============================================================================

loc_A8A6:				; DATA XREF: ROM:0000A7F6o
		addq.b	#2,$24(a0)
		move.b	#0,$20(a0)
		move.b	#1,$18(a0)
		bsr.w	sub_A8DE
		lea	(RAM_ObjRespawnTbl).w,a2
		moveq	#0,d0
		move.b	$23(a0),d0
		move.b	$34(a0),d1
		bset	d1,2(a2,d0.w)

loc_A8CC:				; DATA XREF: ROM:0000A7F8o
		lea	(Ani_Obj25).l,a1
		bsr.w	AnimateSprite
		bra.w	DisplaySprite
; ===============================================================================

loc_A8DA:				; CODE XREF: ROM:0000A8A0j
					; DATA XREF: ROM:0000A7FAo
		bra.w	DeleteObject

; =============== S U B R O U T I N E ==========================================


sub_A8DE:				; CODE XREF: ROM:0000A8B6p
					; ROM:0000AA5Cp ...
		addq.w	#1,(RAM_Sonic_CurrentRings).w
		ori.b	#1,(RAM_Flag_HudUpd_Rings).w
		move.w	#$B5,d0	; ''
		cmpi.w	#$64,(RAM_Sonic_CurrentRings).w ; 'd'
		bcs.s	loc_A918
		bset	#1,(RAM_Sonic_1upScore).w
		beq.s	loc_A90C
		cmpi.w	#$C8,(RAM_Sonic_CurrentRings).w ; ''
		bcs.s	loc_A918
		bset	#2,(RAM_Sonic_1upScore).w
		bne.s	loc_A918

loc_A90C:				; CODE XREF: sub_A8DE+1Cj
		addq.b	#1,(RAM_Sonic_Lives).w
		addq.b	#1,(RAM_Flag_HudUpd_Lives).w
		move.w	#$88,d0	; ''

loc_A918:				; CODE XREF: sub_A8DE+14j sub_A8DE+24j ...
		jmp	(PlaySound_Special).l
; End of function sub_A8DE

; ===============================================================================
;----------------------------------------------------
; Object 37 - Rings flying out of you when you get hit
;----------------------------------------------------

Obj37:
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj37_Index(pc,d0.w),d1
		jmp	Obj37_Index(pc,d1.w)
; ===============================================================================
Obj37_Index:	dc.w loc_A936-Obj37_Index
		dc.w loc_A9FA-Obj37_Index
		dc.w loc_AA4C-Obj37_Index
		dc.w loc_AA60-Obj37_Index
		dc.w loc_AA6E-Obj37_Index
; ===============================================================================

loc_A936:
		movea.l	a0,a1
		moveq	#0,d5
		move.w	(RAM_Sonic_CurrentRings).w,d5
		moveq	#$20,d0
		cmp.w	d0,d5
		bcs.s	loc_A946
		move.w	d0,d5

loc_A946:
		subq.w	#1,d5
		move.w	#$288,d4
		bra.s	loc_A956
; ===============================================================================

loc_A94E:
		bsr.w	SingleObjectLoad
		bne.w	loc_A9DE

loc_A956:
		move.b	#$37,0(a1)
		addq.b	#2,$24(a1)
		move.b	#8,$16(a1)
		move.b	#8,$17(a1)
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		move.l	#Map_Obj25,4(a1)
		move.w	#$26BC,2(a1)
		bsr.w	ModifyA1SpriteAttr_2P
		move.b	#4,1(a1)
		move.b	#3,$18(a1)
		move.b	#$47,$20(a1)
		move.b	#8,$19(a1)
		move.b	#$FF,(RAM_ObjSpecial_RingFrame_7).w
		tst.w	d4
		bmi.s	loc_A9CE
		move.w	d4,d0
		bsr.w	CalcSine
		move.w	d4,d2
		lsr.w	#8,d2
		asl.w	d2,d0
		asl.w	d2,d1
		move.w	d0,d2
		move.w	d1,d3
		addi.b	#$10,d4
		bcc.s	loc_A9CE
		subi.w	#$80,d4
		bcc.s	loc_A9CE
		move.w	#$288,d4

loc_A9CE:
		move.w	d2,$10(a1)
		move.w	d3,$12(a1)
		neg.w	d2
		neg.w	d4
		dbf	d5,loc_A94E

loc_A9DE:
		move.w	#0,(RAM_Sonic_CurrentRings).w
		move.b	#$80,(RAM_Flag_HudUpd_Rings).w
		move.b	#0,(RAM_Sonic_1upScore).w
		move.w	#$C6,d0
		jsr	(PlaySound_Special).l

loc_A9FA:
		move.b	(RAM_ObjSpecial_RingFrame_8).w,$1A(a0)
		bsr.w	SpeedToPos
		addi.w	#$18,$12(a0)
		bmi.s	loc_AA34
		move.b	(RAM_VIntFrameCnt+3).w,d0
		add.b	d7,d0
		andi.b	#3,d0
		bne.s	loc_AA34
		jsr	ObjHitFloor
		tst.w	d1
		bpl.s	loc_AA34
		add.w	d1,$C(a0)
		move.w	$12(a0),d0
		asr.w	#2,d0
		sub.w	d0,$12(a0)
		neg.w	$12(a0)

loc_AA34:
		tst.b	(RAM_ObjSpecial_RingFrame_7).w
		beq.s	loc_AA6E
		move.w	(RAM_LevelSys_YPos_SetEnd).w,d0
		addi.w	#$E0,d0
		cmp.w	$C(a0),d0
		bcs.s	loc_AA6E
		bra.w	DisplaySprite
; ===============================================================================

loc_AA4C:
		addq.b	#2,$24(a0)
		move.b	#0,$20(a0)
		move.b	#1,$18(a0)
		bsr.w	sub_A8DE

loc_AA60:
		lea	(Ani_Obj25).l,a1
		bsr.w	AnimateSprite
		bra.w	DisplaySprite
; ===============================================================================

loc_AA6E:
		bra.w	DeleteObject
; ===============================================================================
;----------------------------------------------------
; Sonic	1 Object 4B - leftover giant ring code
;----------------------------------------------------

S1Obj4B:
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	S1Obj4B_Index(pc,d0.w),d1
		jmp	S1Obj4B_Index(pc,d1.w)
; ===============================================================================
S1Obj4B_Index:	dc.w loc_AA88-S1Obj4B_Index
		dc.w loc_AAD6-S1Obj4B_Index
		dc.w loc_AAF4-S1Obj4B_Index
		dc.w loc_AB38-S1Obj4B_Index
; ===============================================================================

loc_AA88:
		move.l	#Map_S1Obj4B,4(a0)
		move.w	#$2400,2(a0)
		bsr.w	ModifySpriteAttr_2P
		ori.b	#4,1(a0)
		move.b	#$40,$19(a0)
		tst.b	1(a0)
		bpl.s	loc_AAD6
		cmpi.b	#6,(RAM_Sonic_Emeralds).w
		beq.w	loc_AB38
		cmpi.w	#$32,(RAM_Sonic_CurrentRings).w
		bcc.s	loc_AAC0
		rts
; ===============================================================================

loc_AAC0:
		addq.b	#2,$24(a0)
		move.b	#2,$18(a0)
		move.b	#$52,$20(a0)
		move.w	#$C40,(RAM_Level_BigRing_VRAM).w

loc_AAD6:
		move.b	(RAM_ObjSpecial_RingFrame_4).w,$1A(a0)
		move.w	8(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.w	DeleteObject
		bra.w	DisplaySprite
; ===============================================================================

loc_AAF4:
		subq.b	#2,$24(a0)
		move.b	#0,$20(a0)
		bsr.w	SingleObjectLoad
		bne.w	loc_AB2C
		move.b	#$7C,0(a1)
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		move.l	a0,$3C(a1)
		move.w	(RAM_ObjRAM_Sonic+$8).w,d0
		cmp.w	8(a0),d0
		bcs.s	loc_AB2C
		bset	#0,1(a1)

loc_AB2C:
		move.w	#$C3,d0
		jsr	(PlaySound_Special).l
		bra.s	loc_AAD6
; ===============================================================================

loc_AB38:
		bra.w	DeleteObject
; ===============================================================================
;----------------------------------------------------
; Sonic	1 Object 7C - leftover giant flash when	you
;   collected the giant	ring
;----------------------------------------------------

Obj_S1Obj7C:
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj_S1Obj7C_Index(pc,d0.w),d1
		jmp	Obj_S1Obj7C_Index(pc,d1.w)
; ===============================================================================
Obj_S1Obj7C_Index:
		dc.w loc_AB50-Obj_S1Obj7C_Index
		dc.w loc_AB7E-Obj_S1Obj7C_Index
		dc.w loc_ABE6-Obj_S1Obj7C_Index
; ===============================================================================

loc_AB50:
		addq.b	#2,$24(a0)
		move.l	#Map_S1Obj7C,4(a0)
		move.w	#$2462,2(a0)
		bsr.w	ModifySpriteAttr_2P
		ori.b	#4,1(a0)
		move.b	#0,$18(a0)
		move.b	#$20,$19(a0)
		move.b	#$FF,$1A(a0)

loc_AB7E:
		bsr.s	sub_AB98
		move.w	8(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.w	DeleteObject
		bra.w	DisplaySprite

; =============== S U B R O U T I N E ==========================================


sub_AB98:
		subq.b	#1,$1E(a0)
		bpl.s	locret_ABD6
		move.b	#1,$1E(a0)
		addq.b	#1,$1A(a0)
		cmpi.b	#8,$1A(a0)
		bcc.s	loc_ABD8
		cmpi.b	#3,$1A(a0)
		bne.s	locret_ABD6
		movea.l	$3C(a0),a1
		move.b	#6,$24(a1)
		move.b	#$1C,(RAM_ObjRAM_Sonic+$1C).w
		move.b	#1,(RAM_Flag_Level_StopBonus).w
		clr.b	(RAM_Flag_Sonic_Invincibility).w
		clr.b	(RAM_Flag_Sonic_Shield).w

locret_ABD6:
		rts
; ===============================================================================

loc_ABD8:
		addq.b	#2,$24(a0)
		move.w	#0,(RAM_ObjRAM_Sonic).w
		addq.l	#4,sp
		rts

; ===============================================================================

loc_ABE6:
		bra.w	DeleteObject
; ===============================================================================
Ani_Obj25:	dc.w byte_ABEC-Ani_Obj25 ; DATA	XREF: ROM:loc_A8CCo
					; ROM:loc_AA60o ...
byte_ABEC:	dc.b   5,  4,  5,  6,  7,$FC; 0	; DATA XREF: ROM:Ani_Obj25o

Map_Obj25:	dc.w word_AC04-Map_Obj25
		dc.w word_AC0E-Map_Obj25
		dc.w word_AC18-Map_Obj25
		dc.w word_AC22-Map_Obj25
		dc.w word_AC2C-Map_Obj25
		dc.w word_AC36-Map_Obj25
		dc.w word_AC40-Map_Obj25
		dc.w word_AC4A-Map_Obj25
		dc.w word_AC54-Map_Obj25
word_AC04:	dc.w 1			; DATA XREF: ROM:Map_Obj25o
		dc.w $F805,    0,    0,$FFF8; 0
word_AC0E:	dc.w 1			; DATA XREF: ROM:0000ABF4o
		dc.w $F805,    4,    2,$FFF8; 0
word_AC18:	dc.w 1			; DATA XREF: ROM:0000ABF6o
		dc.w $F801,    8,    4,$FFFC; 0
word_AC22:	dc.w 1			; DATA XREF: ROM:0000ABF8o
		dc.w $F805, $804, $802,$FFF8; 0
word_AC2C:	dc.w 1			; DATA XREF: ROM:0000ABFAo
		dc.w $F805,   $A,    5,$FFF8; 0
word_AC36:	dc.w 1			; DATA XREF: ROM:0000ABFCo
		dc.w $F805,$180A,$1805,$FFF8; 0
word_AC40:	dc.w 1			; DATA XREF: ROM:0000ABFEo
		dc.w $F805, $80A, $805,$FFF8; 0
word_AC4A:	dc.w 1			; DATA XREF: ROM:0000AC00o
		dc.w $F805,$100A,$1005,$FFF8; 0
word_AC54:	dc.w 0			; DATA XREF: ROM:0000AC02o
Map_S1Obj4B:	dc.w word_AC5E-Map_S1Obj4B ; DATA XREF:	ROM:loc_AA88o
					; ROM:Map_S1Obj4Bo ...
		dc.w word_ACB0-Map_S1Obj4B
		dc.w word_ACF2-Map_S1Obj4B
		dc.w word_AD14-Map_S1Obj4B
word_AC5E:	dc.w $A			; DATA XREF: ROM:Map_S1Obj4Bo
		dc.w $E008,    0,    0,$FFE8; 0
		dc.w $E008,    3,    1,	   0; 4
		dc.w $E80C,    6,    3,$FFE0; 8
		dc.w $E80C,   $A,    5,	   0; 12
		dc.w $F007,   $E,    7,$FFE0; 16
		dc.w $F007,  $16,   $B,	 $10; 20
		dc.w $100C,  $1E,   $F,$FFE0; 24
		dc.w $100C,  $22,  $11,	   0; 28
		dc.w $1808,  $26,  $13,$FFE8; 32
		dc.w $1808,  $29,  $14,	   0; 36
word_ACB0:	dc.w 8			; DATA XREF: ROM:0000AC58o
		dc.w $E00C,  $2C,  $16,$FFF0; 0
		dc.w $E808,  $30,  $18,$FFE8; 4
		dc.w $E809,  $33,  $19,	   0; 8
		dc.w $F007,  $39,  $1C,$FFE8; 12
		dc.w $F805,  $41,  $20,	   8; 16
		dc.w  $809,  $45,  $22,	   0; 20
		dc.w $1008,  $4B,  $25,$FFE8; 24
		dc.w $180C,  $4E,  $27,$FFF0; 28
word_ACF2:	dc.w 4			; DATA XREF: ROM:0000AC5Ao
		dc.w $E007,  $52,  $29,$FFF4; 0
		dc.w $E003, $852, $829,	   4; 4
		dc.w	 7,  $5A,  $2D,$FFF4; 8
		dc.w	 3, $85A, $82D,	   4; 12
word_AD14:	dc.w 8			; DATA XREF: ROM:0000AC5Co
		dc.w $E00C, $82C, $816,$FFF0; 0
		dc.w $E808, $830, $818,	   0; 4
		dc.w $E809, $833, $819,$FFE8; 8
		dc.w $F007, $839, $81C,	   8; 12
		dc.w $F805, $841, $820,$FFE8; 16
		dc.w  $809, $845, $822,$FFE8; 20
		dc.w $1008, $84B, $825,	   0; 24
		dc.w $180C, $84E, $827,$FFF0; 28
Map_S1Obj7C:	dc.w word_AD66-Map_S1Obj7C ; DATA XREF:	ROM:0000AB54o
					; ROM:Map_S1Obj7Co ...
		dc.w word_AD78-Map_S1Obj7C
		dc.w word_AD9A-Map_S1Obj7C
		dc.w word_ADBC-Map_S1Obj7C
		dc.w word_ADDE-Map_S1Obj7C
		dc.w word_AE00-Map_S1Obj7C
		dc.w word_AE22-Map_S1Obj7C
		dc.w word_AE34-Map_S1Obj7C
word_AD66:	dc.w 2			; DATA XREF: ROM:Map_S1Obj7Co
		dc.w $E00F,    0,    0,	   0; 0
		dc.w	$F,$1000,$1000,	   0; 4
word_AD78:	dc.w 4			; DATA XREF: ROM:0000AD58o
		dc.w $E00F,  $10,    8,$FFF0; 0
		dc.w $E007,  $20,  $10,	 $10; 4
		dc.w	$F,$1010,$1008,$FFF0; 8
		dc.w	 7,$1020,$1010,	 $10; 12
word_AD9A:	dc.w 4			; DATA XREF: ROM:0000AD5Ao
		dc.w $E00F,  $28,  $14,$FFE8; 0
		dc.w $E00B,  $38,  $1C,	   8; 4
		dc.w	$F,$1028,$1014,$FFE8; 8
		dc.w	$B,$1038,$101C,	   8; 12
word_ADBC:	dc.w 4			; DATA XREF: ROM:0000AD5Co
		dc.w $E00F, $834, $81A,$FFE0; 0
		dc.w $E00F,  $34,  $1A,	   0; 4
		dc.w	$F,$1834,$181A,$FFE0; 8
		dc.w	$F,$1034,$101A,	   0; 12
word_ADDE:	dc.w 4			; DATA XREF: ROM:0000AD5Eo
		dc.w $E00B, $838, $81C,$FFE0; 0
		dc.w $E00F, $828, $814,$FFF8; 4
		dc.w	$B,$1838,$181C,$FFE0; 8
		dc.w	$F,$1828,$1814,$FFF8; 12
word_AE00:	dc.w 4			; DATA XREF: ROM:0000AD60o
		dc.w $E007, $820, $810,$FFE0; 0
		dc.w $E00F, $810, $808,$FFF0; 4
		dc.w	 7,$1820,$1810,$FFE0; 8
		dc.w	$F,$1810,$1808,$FFF0; 12
word_AE22:	dc.w 2			; DATA XREF: ROM:0000AD62o
		dc.w $E00F, $800, $800,$FFE0; 0
		dc.w	$F,$1800,$1800,$FFE0; 4
word_AE34:	dc.w 4			; DATA XREF: ROM:0000AD64o
		dc.w $E00F,  $44,  $22,$FFE0; 0
		dc.w $E00F, $844, $822,	   0; 4
		dc.w	$F,$1044,$1022,$FFE0; 8
		dc.w	$F,$1844,$1822,	   0; 12
; ===============================================================================
		nop
;----------------------------------------------------
; Object 26 - monitor
;----------------------------------------------------

Obj26:
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj26_Index(pc,d0.w),d1
		jmp	Obj26_Index(pc,d1.w)
; ===============================================================================
Obj26_Index:	dc.w loc_AE70-Obj26_Index
		dc.w loc_AED6-Obj26_Index
		dc.w loc_AFDC-Obj26_Index
		dc.w loc_AFBA-Obj26_Index
		dc.w loc_AFC4-Obj26_Index
; ===============================================================================

loc_AE70:
		addq.b	#2,$24(a0)
		move.b	#$E,$16(a0)
		move.b	#$E,$17(a0)
		move.l	#Map_Obj26,4(a0)
		move.w	#$680,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#4,1(a0)
		move.b	#3,$18(a0)
		move.b	#$F,$19(a0)
		lea	(RAM_ObjRespawnTbl).w,a2
		moveq	#0,d0
		move.b	$23(a0),d0
		bclr	#7,2(a2,d0.w)
		btst	#0,2(a2,d0.w)
		beq.s	loc_AECA
		move.b	#8,$24(a0)
		move.b	#$B,$1A(a0)
		rts
; ===============================================================================

loc_AECA:
		move.b	#$46,$20(a0)
		move.b	$28(a0),$1C(a0)

loc_AED6:
		move.b	$25(a0),d0
		beq.s	loc_AF30
		subq.b	#2,d0
		bne.s	loc_AF10
		moveq	#0,d1
		move.b	$19(a0),d1
		addi.w	#$B,d1
		bsr.w	sub_F9C8
		btst	#3,$22(a1)
		bne.w	loc_AF00
		clr.b	$25(a0)
		bra.w	loc_AFBA
; ===============================================================================

loc_AF00:
		move.w	#$10,d3
		move.w	8(a0),d2
		bsr.w	sub_F70E
		bra.w	loc_AFBA
; ===============================================================================

loc_AF10:
		bsr.w	ObjectFall
		jsr	ObjHitFloor
		tst.w	d1
		bpl.w	loc_AFBA
		add.w	d1,$C(a0)
		clr.w	$12(a0)
		clr.b	$25(a0)
		bra.w	loc_AFBA
; ===============================================================================

loc_AF30:
		move.w	#$1A,d1
		move.w	#$F,d2
		bsr.w	Obj26_SolidSides
		beq.w	loc_AFA0
		tst.w	$12(a1)
		bmi.s	loc_AF4E
		cmpi.b	#2,$1C(a1)
		beq.s	loc_AFA0

loc_AF4E:
		tst.w	d1
		bpl.s	loc_AF64
		sub.w	d3,$C(a1)
		bsr.w	sub_F8F8
		move.b	#2,$25(a0)
		bra.w	loc_AFBA
; ===============================================================================

loc_AF64:
		tst.w	d0
		beq.w	loc_AF8A
		bmi.s	loc_AF74
		tst.w	$10(a1)
		bmi.s	loc_AF8A
		bra.s	loc_AF7A
; ===============================================================================

loc_AF74:
		tst.w	$10(a1)
		bpl.s	loc_AF8A

loc_AF7A:
		sub.w	d0,8(a1)
		move.w	#0,$14(a1)
		move.w	#0,$10(a1)

loc_AF8A:
		btst	#1,$22(a1)
		bne.s	loc_AFAE
		bset	#5,$22(a1)
		bset	#5,$22(a0)
		bra.s	loc_AFBA
; ===============================================================================

loc_AFA0:
		btst	#5,$22(a0)
		beq.s	loc_AFBA
		move.w	#1,$1C(a1)

loc_AFAE:
		bclr	#5,$22(a0)
		bclr	#5,$22(a1)

loc_AFBA:
		lea	(Ani_Obj26).l,a1
		bsr.w	AnimateSprite

loc_AFC4:
		move.w	8(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.w	DeleteObject
		bra.w	DisplaySprite
; ===============================================================================

loc_AFDC:
		addq.b	#2,$24(a0)
		move.b	#0,$20(a0)
		bsr.w	SingleObjectLoad
		bne.s	loc_B004
		move.b	#$2E,0(a1)
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		move.b	$1C(a0),$1C(a1)

loc_B004:
		bsr.w	SingleObjectLoad
		bne.s	loc_B020
		move.b	#$27,0(a1)
		addq.b	#2,$24(a1)
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)

loc_B020:
		lea	(RAM_ObjRespawnTbl).w,a2
		moveq	#0,d0
		move.b	$23(a0),d0
		bset	#0,2(a2,d0.w)
		move.b	#$A,$1C(a0)
		bra.w	DisplaySprite

; ===============================================================================
;----------------------------------------------------
; Object 2E - contents of monitors
;----------------------------------------------------

Obj2E:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj2E_Index(pc,d0.w),d1
		jmp	Obj2E_Index(pc,d1.w)
; ===============================================================================
Obj2E_Index:	dc.w loc_B04E-Obj2E_Index ; DATA XREF: ROM:Obj2E_Indexo
					; ROM:0000B04Ao ...
		dc.w loc_B092-Obj2E_Index
		dc.w loc_B1AA-Obj2E_Index
; ===============================================================================

loc_B04E:				; DATA XREF: ROM:Obj2E_Indexo
		addq.b	#2,$24(a0)
		move.w	#$680,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#$24,1(a0) ; '$'
		move.b	#3,$18(a0)
		move.b	#8,$19(a0)
		move.w	#$FD00,$12(a0)
		moveq	#0,d0
		move.b	$1C(a0),d0
		addq.b	#1,d0
		move.b	d0,$1A(a0)
		movea.l	#Map_Obj26,a1
		add.b	d0,d0
		adda.w	(a1,d0.w),a1
		addq.w	#2,a1
		move.l	a1,4(a0)

loc_B092:				; DATA XREF: ROM:0000B04Ao
		bsr.s	sub_B098
		bra.w	DisplaySprite

; =============== S U B R O U T I N E ==========================================


sub_B098:				; CODE XREF: ROM:loc_B092p
		tst.w	$12(a0)
		bpl.w	loc_B0AC
		bsr.w	SpeedToPos
		addi.w	#$18,$12(a0)
		rts
; ===============================================================================

loc_B0AC:				; CODE XREF: sub_B098+4j
		addq.b	#2,$24(a0)
		move.w	#$1D,$1E(a0)
		moveq	#0,d0
		move.b	$1C(a0),d0
		add.w	d0,d0
		move.w	@Types(pc,d0.w),d0
		jmp	@Types(pc,d0.w)

; ===============================================================================
@Types:
		dc.w Monitor_Null-@Types
		dc.w Monitor_SonicLife-@Types
		dc.w Monitor_TailsLife-@Types
		dc.w Monitor_Null-@Types
		dc.w Monitor_Rigns-@Types
		dc.w Monitor_Shoes-@Types
		dc.w Monitor_Shield-@Types
		dc.w Monitor_Invincibility-@Types
		dc.w Monitor_Null-@Types
		dc.w Monitor_Null-@Types
; ===============================================================================

Monitor_Null:
		rts
; ===============================================================================

Monitor_SonicLife:
		addq.b	#1,(RAM_Sonic_Lives).w
		addq.b	#1,(RAM_Flag_HudUpd_Lives).w
		move.w	#$88,d0
		jmp	(PlaySound).l
; ===============================================================================

Monitor_TailsLife:			; DATA XREF: ROM:0000B0CAo
		addq.b	#1,(RAM_Sonic_Lives).w
		addq.b	#1,(RAM_Flag_HudUpd_Lives).w
		move.w	#$88,d0	; ''
		jmp	(PlaySound).l
; ===============================================================================

Monitor_Rigns:
		addi.w	#$A,(RAM_Sonic_CurrentRings).w
		ori.b	#1,(RAM_Flag_HudUpd_Rings).w
		cmpi.w	#$64,(RAM_Sonic_CurrentRings).w
		bcs.s	loc_B130
		bset	#1,(RAM_Sonic_1upScore).w
		beq.w	Monitor_SonicLife
		cmpi.w	#$C8,(RAM_Sonic_CurrentRings).w
		bcs.s	loc_B130
		bset	#2,(RAM_Sonic_1upScore).w
		beq.w	Monitor_SonicLife

loc_B130:
		move.w	#$B5,d0
		jmp	(PlaySound).l
; ===============================================================================

Monitor_Shoes:
		move.b	#1,(RAM_Flag_Sonic_Shoes).w
		move.w	#$4B0,(RAM_ObjRAM_Sonic+$34).w
		move.w	#$C00,(RAM_Sonic_TopSpeed).w
		move.w	#$18,(RAM_Sonic_Acceleration).w
		move.w	#$80,(RAM_Sonic_Deceleration).w
		move.w	#$E2,d0
		jmp	(PlaySound).l
; ===============================================================================

Monitor_Shield:				; DATA XREF: ROM:0000B0D2o
		move.b	#1,(RAM_Flag_Sonic_Shield).w
		move.b	#$38,(RAM_ObjectTable+Obj_Slot_7).w
		move.w	#$AF,d0
		jmp	(PlaySound).l
; ===============================================================================

Monitor_Invincibility:
		move.b	#1,(RAM_Flag_Sonic_Invincibility).w
		move.w	#$4B0,(RAM_ObjRAM_Sonic+$32).w
		move.b	#$38,(RAM_ObjectTable+Obj_Slot_9).w
		move.b	#1,(RAM_ObjectTable+Obj_Slot_9+$1C).w
		tst.b	(RAM_Level_BossMode).w
		bne.s	locret_B1A8
		cmpi.w	#$C,(RAM_Sonic_AirLeft).w
		bls.s	locret_B1A8
		move.w	#$87,d0	; ''
		jmp	(PlaySound).l
; ===============================================================================

locret_B1A8:				; CODE XREF: ROM:0000B194j
					; ROM:0000B19Cj
		rts
; ===============================================================================

loc_B1AA:				; DATA XREF: ROM:0000B04Co
		subq.w	#1,$1E(a0)
		bmi.w	DeleteObject
		bra.w	DisplaySprite

; =============== S U B R O U T I N E ==========================================


Obj26_SolidSides:			; CODE XREF: ROM:0000AF38p
		lea	(RAM_ObjRAM_Sonic).w,a1
		move.w	8(a1),d0
		sub.w	8(a0),d0
		add.w	d1,d0
		bmi.s	loc_B20E
		move.w	d1,d3
		add.w	d3,d3
		cmp.w	d3,d0
		bhi.s	loc_B20E
		move.b	$16(a1),d3
		ext.w	d3
		add.w	d3,d2
		move.w	$C(a1),d3
		sub.w	$C(a0),d3
		add.w	d2,d3
		bmi.s	loc_B20E
		add.w	d2,d2
		cmp.w	d2,d3
		bcc.s	loc_B20E
		tst.b	(RAM_Flag_ControlLock).w
		bmi.s	loc_B20E
		cmpi.b	#6,(RAM_ObjRAM_Sonic+$24).w
		bcc.s	loc_B20E
		tst.w	(RAM_Flag_Debug_Placement).w
		bne.s	loc_B20E
		cmp.w	d0,d1
		bcc.s	loc_B204
		add.w	d1,d1
		sub.w	d1,d0

loc_B204:				; CODE XREF: Obj26_SolidSides+48j
		cmpi.w	#$10,d3
		bcs.s	loc_B212

loc_B20A:				; CODE XREF: Obj26_SolidSides+70j
					; Obj26_SolidSides+74j
		moveq	#1,d1
		rts
; ===============================================================================

loc_B20E:				; CODE XREF: Obj26_SolidSides+Ej
					; Obj26_SolidSides+16j	...
		moveq	#0,d1
		rts
; ===============================================================================

loc_B212:				; CODE XREF: Obj26_SolidSides+52j
		moveq	#0,d1
		move.b	$19(a0),d1
		addq.w	#4,d1
		move.w	d1,d2
		add.w	d2,d2
		add.w	8(a1),d1
		sub.w	8(a0),d1
		bmi.s	loc_B20A
		cmp.w	d2,d1
		bcc.s	loc_B20A
		moveq	#$FFFFFFFF,d1
		rts
; End of function Obj26_SolidSides

; ===============================================================================
Ani_Obj26:	dc.w byte_B246-Ani_Obj26 ; DATA	XREF: ROM:loc_AFBAo
					; ROM:Ani_Obj26o ...
		dc.w byte_B24A-Ani_Obj26
		dc.w byte_B252-Ani_Obj26
		dc.w byte_B25A-Ani_Obj26
		dc.w byte_B262-Ani_Obj26
		dc.w byte_B26A-Ani_Obj26
		dc.w byte_B272-Ani_Obj26
		dc.w byte_B27A-Ani_Obj26
		dc.w byte_B282-Ani_Obj26
		dc.w byte_B28A-Ani_Obj26
		dc.w byte_B292-Ani_Obj26
byte_B246:	dc.b   1,  0,  1,$FF	; 0 ; DATA XREF: ROM:Ani_Obj26o
byte_B24A:	dc.b   1,  0,  2,  2,  1,  2,  2,$FF; 0	; DATA XREF: ROM:0000B232o
byte_B252:	dc.b   1,  0,  3,  3,  1,  3,  3,$FF; 0	; DATA XREF: ROM:0000B234o
byte_B25A:	dc.b   1,  0,  4,  4,  1,  4,  4,$FF; 0	; DATA XREF: ROM:0000B236o
byte_B262:	dc.b   1,  0,  5,  5,  1,  5,  5,$FF; 0	; DATA XREF: ROM:0000B238o
byte_B26A:	dc.b   1,  0,  6,  6,  1,  6,  6,$FF; 0	; DATA XREF: ROM:0000B23Ao
byte_B272:	dc.b   1,  0,  7,  7,  1,  7,  7,$FF; 0	; DATA XREF: ROM:0000B23Co
byte_B27A:	dc.b   1,  0,  8,  8,  1,  8,  8,$FF; 0	; DATA XREF: ROM:0000B23Eo
byte_B282:	dc.b   1,  0,  9,  9,  1,  9,  9,$FF; 0	; DATA XREF: ROM:0000B240o
byte_B28A:	dc.b   1,  0, $A, $A,  1, $A, $A,$FF; 0	; DATA XREF: ROM:0000B242o
byte_B292:	dc.b   2,  0,  1, $B,$FE,  1; 0	; DATA XREF: ROM:0000B244o
Map_Obj26:	dc.w word_B2B0-Map_Obj26 ; DATA	XREF: ROM:0000AE80o
					; ROM:Map_Obj26o ...
		dc.w word_B2BA-Map_Obj26
		dc.w word_B2CC-Map_Obj26
		dc.w word_B2DE-Map_Obj26
		dc.w word_B2F0-Map_Obj26
		dc.w word_B302-Map_Obj26
		dc.w word_B314-Map_Obj26
		dc.w word_B326-Map_Obj26
		dc.w word_B338-Map_Obj26
		dc.w word_B34A-Map_Obj26
		dc.w word_B35C-Map_Obj26
		dc.w word_B36E-Map_Obj26
word_B2B0:	dc.w 1			; DATA XREF: ROM:Map_Obj26o
		dc.w $EF0F,    0,    0,$FFF0; 0
word_B2BA:	dc.w 2			; DATA XREF: ROM:0000B29Ao
		dc.w $F505,  $18,   $C,$FFF8,$EF0F,    0,    0,$FFF0; 0
word_B2CC:	dc.w 2			; DATA XREF: ROM:0000B29Co
		dc.w $F505, $154,  $AA,$FFF8,$EF0F,    0,    0,$FFF0; 0
word_B2DE:	dc.w 2			; DATA XREF: ROM:0000B29Eo
		dc.w $F505,  $1C,   $E,$FFF8,$EF0F,    0,    0,$FFF0; 0
word_B2F0:	dc.w 2			; DATA XREF: ROM:0000B2A0o
		dc.w $F505,  $20,  $10,$FFF8,$EF0F,    0,    0,$FFF0; 0
word_B302:	dc.w 2			; DATA XREF: ROM:0000B2A2o
		dc.w $F505,$2024,$2012,$FFF8,$EF0F,    0,    0,$FFF0; 0
word_B314:	dc.w 2			; DATA XREF: ROM:0000B2A4o
		dc.w $F505,  $28,  $14,$FFF8,$EF0F,    0,    0,$FFF0; 0
word_B326:	dc.w 2			; DATA XREF: ROM:0000B2A6o
		dc.w $F505,  $2C,  $16,$FFF8,$EF0F,    0,    0,$FFF0; 0
word_B338:	dc.w 2			; DATA XREF: ROM:0000B2A8o
		dc.w $F505,  $30,  $18,$FFF8,$EF0F,    0,    0,$FFF0; 0
word_B34A:	dc.w 2			; DATA XREF: ROM:0000B2AAo
		dc.w $F505,  $34,  $1A,$FFF8,$EF0F,    0,    0,$FFF0; 0
word_B35C:	dc.w 2			; DATA XREF: ROM:0000B2ACo
		dc.w $F505,  $38,  $1C,$FFF8,$EF0F,    0,    0,$FFF0; 0
word_B36E:	dc.w 1			; DATA XREF: ROM:0000B2AEo
		dc.w $FF0D,  $10,    8,$FFF0; 0
; ===============================================================================
;----------------------------------------------------
; Object 0E - Sonic on title screen
;----------------------------------------------------

Obj0E:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj0E_Index(pc,d0.w),d1
		jmp	Obj0E_Index(pc,d1.w)
; ===============================================================================
Obj0E_Index:	dc.w loc_B38E-Obj0E_Index ; DATA XREF: ROM:Obj0E_Indexo
					; ROM:0000B388o ...
		dc.w loc_B3D0-Obj0E_Index
		dc.w loc_B3E4-Obj0E_Index
		dc.w loc_B3FA-Obj0E_Index
; ===============================================================================

loc_B38E:				; DATA XREF: ROM:Obj0E_Indexo
		addq.b	#2,$24(a0)
		move.w	#$148,8(a0)
		move.w	#$C4,$A(a0) ; ''
		move.l	#Map_Obj0E,4(a0)
		move.w	#$4200,2(a0)
		move.b	#1,$18(a0)
		move.b	#$1D,$1F(a0)
		tst.b	$1A(a0)
		beq.s	loc_B3D0
		move.w	#$FC,8(a0) ; ''
		move.w	#$CC,$A(a0) ; ''
		move.w	#$2200,2(a0)

loc_B3D0:				; CODE XREF: ROM:0000B3BCj
					; DATA XREF: ROM:0000B388o
		bra.w	DisplaySprite
; ===============================================================================
		subq.b	#1,$1F(a0)
		bpl.s	locret_B3E2
		addq.b	#2,$24(a0)
		bra.w	DisplaySprite
; ===============================================================================

locret_B3E2:				; CODE XREF: ROM:0000B3D8j
		rts
; ===============================================================================

loc_B3E4:				; DATA XREF: ROM:0000B38Ao
		subi.w	#8,$A(a0)
		cmpi.w	#$96,$A(a0) ; ''
		bne.s	loc_B3F6
		addq.b	#2,$24(a0)

loc_B3F6:				; CODE XREF: ROM:0000B3F0j
		bra.w	DisplaySprite
; ===============================================================================

loc_B3FA:				; DATA XREF: ROM:0000B38Co
		bra.w	DisplaySprite
; ===============================================================================
;----------------------------------------------------
; Object 0F - ???
;----------------------------------------------------

Obj0F:
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj0F_Index(pc,d0.w),d1
		jsr	Obj0F_Index(pc,d1.w)
		bra.w	DisplaySprite
; ===============================================================================
Obj0F_Index:	dc.w loc_B416-Obj0F_Index
		dc.w loc_B438-Obj0F_Index
		dc.w loc_B438-Obj0F_Index
; ===============================================================================

loc_B416:
		addq.b	#2,$24(a0)
		move.w	#$90,8(a0)
		move.w	#$90,$A(a0)
		move.l	#Map_Obj0F,4(a0)
		move.w	#$680,2(a0)
		bsr.w	ModifySpriteAttr_2P

loc_B438:
		move.b	(RAM_Control_1_Press).w,d0
		btst	#5,d0
		beq.s	loc_B44C
		addq.b	#1,$1A(a0)
		andi.b	#$F,$1A(a0)

loc_B44C:
		btst	#4,d0
		beq.s	locret_B458
		bchg	#0,($FFFFFFE9).w

locret_B458:
		rts
; ===============================================================================
Map_Obj0F:	dc.w word_B47A-Map_Obj0F
		dc.w word_B484-Map_Obj0F
		dc.w word_B48E-Map_Obj0F
		dc.w word_B498-Map_Obj0F
		dc.w word_B4A2-Map_Obj0F
		dc.w word_B4AC-Map_Obj0F
		dc.w word_B4B6-Map_Obj0F
		dc.w word_B4C0-Map_Obj0F
		dc.w word_B4CA-Map_Obj0F
		dc.w word_B4D4-Map_Obj0F
		dc.w word_B4DE-Map_Obj0F
		dc.w word_B4E8-Map_Obj0F
		dc.w word_B4F2-Map_Obj0F
		dc.w word_B4FC-Map_Obj0F
		dc.w word_B506-Map_Obj0F
		dc.w word_B510-Map_Obj0F
word_B47A:	dc.w 1			; DATA XREF: ROM:Map_Obj0Fo
		dc.w	 0,    0,    0,	   0; 0
word_B484:	dc.w 1			; DATA XREF: ROM:0000B45Co
		dc.w	 1,    0,    0,	   0; 0
word_B48E:	dc.w 1			; DATA XREF: ROM:0000B45Eo
		dc.w	 2,    0,    0,	   0; 0
word_B498:	dc.w 1			; DATA XREF: ROM:0000B460o
		dc.w	 3,    0,    0,	   0; 0
word_B4A2:	dc.w 1			; DATA XREF: ROM:0000B462o
		dc.w	 4,    0,    0,	   0; 0
word_B4AC:	dc.w 1			; DATA XREF: ROM:0000B464o
		dc.w	 5,    0,    0,	   0; 0
word_B4B6:	dc.w 1			; DATA XREF: ROM:0000B466o
		dc.w	 6,    0,    0,	   0; 0
word_B4C0:	dc.w 1			; DATA XREF: ROM:0000B468o
		dc.w	 7,    0,    0,	   0; 0
word_B4CA:	dc.w 1			; DATA XREF: ROM:0000B46Ao
		dc.w	 8,    0,    0,	   0; 0
word_B4D4:	dc.w 1			; DATA XREF: ROM:0000B46Co
		dc.w	 9,    0,    0,	   0; 0
word_B4DE:	dc.w 1			; DATA XREF: ROM:0000B46Eo
		dc.w	$A,    0,    0,	   0; 0
word_B4E8:	dc.w 1			; DATA XREF: ROM:0000B470o
		dc.w	$B,    0,    0,	   0; 0
word_B4F2:	dc.w 1			; DATA XREF: ROM:0000B472o
		dc.b   0, $C,  0,  0	; 0
		dc.b   0,  0,  0,  0	; 4
word_B4FC:	dc.w 1			; DATA XREF: ROM:0000B474o
		dc.b   0, $D,  0,  0	; 0
		dc.b   0,  0,  0,  0	; 4
word_B506:	dc.w 1			; DATA XREF: ROM:0000B476o
		dc.w	$E,    0,    0,	   0; 0
word_B510:	dc.w 1			; DATA XREF: ROM:0000B478o
		dc.w	$F,    0,    0,	   0; 0
off_B51A:	dc.w byte_B51C-off_B51A	; DATA XREF: ROM:off_B51Ao
byte_B51C:	dc.b   7,  0,  1,  2,  3,  4,  5,  6; 0	; DATA XREF: ROM:off_B51Ao
		dc.b   7,$FE,  2,  0	; 8
off_B528:	dc.w byte_B52A-off_B528	; DATA XREF: ROM:off_B528o
byte_B52A:	dc.b $1F,  0,  1,$FF	; 0 ; DATA XREF: ROM:off_B528o
Map_S1Obj0F:	dc.w word_B536-Map_S1Obj0F ; DATA XREF:	ROM:Map_S1Obj0Fo
					; ROM:0000B530o ...
					; leftover from	Sonic 1
		dc.w word_B538-Map_S1Obj0F ; leftover from Sonic 1
		dc.w word_B56A-Map_S1Obj0F ; leftover from Sonic 1
		dc.w word_B65C-Map_S1Obj0F ; leftover from Sonic 1
word_B536:	dc.w 0			; DATA XREF: ROM:Map_S1Obj0Fo
word_B538:	dc.w 6			; DATA XREF: ROM:0000B530o
		dc.w	$C,  $F0,  $78,	   0; 0
		dc.w	 0,  $F3,  $79,	 $20; 4
		dc.w	 0,  $F3,  $79,	 $30; 8
		dc.w	$C,  $F4,  $7A,	 $38; 12
		dc.w	 8,  $F8,  $7C,	 $60; 16
		dc.w	 8,  $FB,  $7D,	 $78; 20
word_B56A:	dc.w $1E		; DATA XREF: ROM:0000B532o
		dc.w $B80F,    0,    0,$FF80; 0
		dc.w $B80F,    0,    0,$FF80; 4
		dc.w $B80F,    0,    0,$FF80; 8
		dc.w $B80F,    0,    0,$FF80; 12
		dc.w $B80F,    0,    0,$FF80; 16
		dc.w $B80F,    0,    0,$FF80; 20
		dc.w $B80F,    0,    0,$FF80; 24
		dc.w $B80F,    0,    0,$FF80; 28
		dc.w $B80F,    0,    0,$FF80; 32
		dc.w $B80F,    0,    0,$FF80; 36
		dc.w $D80F,    0,    0,$FF80; 40
		dc.w $D80F,    0,    0,$FF80; 44
		dc.w $D80F,    0,    0,$FF80; 48
		dc.w $D80F,    0,    0,$FF80; 52
		dc.w $D80F,    0,    0,$FF80; 56
		dc.w $D80F,    0,    0,$FF80; 60
		dc.w $D80F,    0,    0,$FF80; 64
		dc.w $D80F,    0,    0,$FF80; 68
		dc.w $D80F,    0,    0,$FF80; 72
		dc.w $D80F,    0,    0,$FF80; 76
		dc.w $F80F,    0,    0,$FF80; 80
		dc.w $F80F,    0,    0,$FF80; 84
		dc.w $F80F,    0,    0,$FF80; 88
		dc.w $F80F,    0,    0,$FF80; 92
		dc.w $F80F,    0,    0,$FF80; 96
		dc.w $F80F,    0,    0,$FF80; 100
		dc.w $F80F,    0,    0,$FF80; 104
		dc.w $F80F,    0,    0,$FF80; 108
		dc.w $F80F,    0,    0,$FF80; 112
		dc.w $F80F,    0,    0,$FF80; 116
word_B65C:	dc.w 1			; DATA XREF: ROM:0000B534o
		dc.w $FC04,    0,    0,$FFF8; 0
Map_Obj0E:	dc.w word_B66A-Map_Obj0E ; DATA	XREF: ROM:0000B39Eo
					; ROM:Map_Obj0Eo ...
		dc.w word_B6C4-Map_Obj0E
word_B66A:	dc.w $B			; DATA XREF: ROM:Map_Obj0Eo
		dc.w $D40D,    0,    0,$FFD8; 0
		dc.w $CC0E,    8,    4,$FFF8; 4
		dc.w $CC07,  $14,   $A,	 $18; 8
		dc.w $E40F,  $1C,   $E,$FFE0; 12
		dc.w $E40B,  $2C,  $16,	   0; 16
		dc.w $EC07,  $38,  $1C,	 $18; 20
		dc.w  $40F,  $40,  $20,$FFD8; 24
		dc.w  $40F,  $50,  $28,$FFF8; 28
		dc.w  $C06,  $60,  $30,	 $18; 32
		dc.w $2404,  $66,  $33,$FFE8; 36
		dc.w $240D,  $68,  $34,$FFF8; 40
word_B6C4:	dc.w $A			; DATA XREF: ROM:0000B668o
		dc.w $DC06,  $70,  $38,$FFEC; 0
		dc.w $F40F,  $76,  $3B,$FFD4; 4
		dc.w $F40F,  $86,  $43,$FFF4; 8
		dc.w $E409,  $96,  $4B,$FFFC; 12
		dc.w $DC0B,  $9C,  $4E,	 $14; 16
		dc.w $FC08,  $A8,  $54,	 $14; 20
		dc.w  $405,  $AB,  $55,	 $14; 24
		dc.w $1404,  $AF,  $57,$FFD4; 28
		dc.w $140D,  $B1,  $58,$FFE4; 32
		dc.w $140D,  $B9,  $5C,	   4; 36
		dc.w $4E71		; 40
; ===============================================================================
;----------------------------------------------------
; Object 2B - GHZ Chopper Badnik
;----------------------------------------------------

Obj2B:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj2B_Index(pc,d0.w),d1
		jsr	Obj2B_Index(pc,d1.w)
		bra.w	MarkObjGone
; ===============================================================================
Obj2B_Index:	dc.w loc_B72E-Obj2B_Index ; DATA XREF: ROM:Obj2B_Indexo
					; ROM:0000B72Co
		dc.w loc_B768-Obj2B_Index
; ===============================================================================

loc_B72E:				; DATA XREF: ROM:Obj2B_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj2B,4(a0)
		move.w	#$470,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#4,1(a0)
		move.b	#4,$18(a0)
		move.b	#9,$20(a0)
		move.b	#$10,$19(a0)
		move.w	#$F900,$12(a0)
		move.w	$C(a0),$30(a0)

loc_B768:				; DATA XREF: ROM:0000B72Co
		lea	(Ani_Obj2B).l,a1
		bsr.w	AnimateSprite
		bsr.w	SpeedToPos
		addi.w	#$18,$12(a0)
		move.w	$30(a0),d0
		cmp.w	$C(a0),d0
		bcc.s	loc_B790
		move.w	d0,$C(a0)
		move.w	#$F900,$12(a0)

loc_B790:				; CODE XREF: ROM:0000B784j
		move.b	#1,$1C(a0)
		subi.w	#$C0,d0	; ''
		cmp.w	$C(a0),d0
		bcc.s	locret_B7B2
		move.b	#0,$1C(a0)
		tst.w	$12(a0)
		bmi.s	locret_B7B2
		move.b	#2,$1C(a0)

locret_B7B2:				; CODE XREF: ROM:0000B79Ej
					; ROM:0000B7AAj
		rts
; ===============================================================================
Ani_Obj2B:	dc.w byte_B7BA-Ani_Obj2B ; DATA	XREF: ROM:loc_B768o
					; ROM:Ani_Obj2Bo ...
		dc.w byte_B7BE-Ani_Obj2B
		dc.w byte_B7C2-Ani_Obj2B
byte_B7BA:	dc.b   7,  0,  1,$FF	; 0 ; DATA XREF: ROM:Ani_Obj2Bo
byte_B7BE:	dc.b   3,  0,  1,$FF	; 0 ; DATA XREF: ROM:0000B7B6o
byte_B7C2:	dc.b   7,  0,$FF,  0	; 0 ; DATA XREF: ROM:0000B7B8o
Map_Obj2B:	dc.w word_B7CA-Map_Obj2B ; DATA	XREF: ROM:0000B732o
					; ROM:Map_Obj2Bo ...
		dc.w word_B7D4-Map_Obj2B
word_B7CA:	dc.w 1			; DATA XREF: ROM:Map_Obj2Bo
		dc.w $F00F,    0,    0,$FFF0; 0
word_B7D4:	dc.w 1			; DATA XREF: ROM:0000B7C8o
		dc.w $F00F,  $10,    8,$FFF0; 0
; ===============================================================================
;----------------------------------------------------
; Object 2C - LZ Jaws Badnik
;----------------------------------------------------

Obj2C:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj2C_Index(pc,d0.w),d1
		jmp	Obj2C_Index(pc,d1.w)
; ===============================================================================
Obj2C_Index:	dc.w loc_B7F0-Obj2C_Index ; DATA XREF: ROM:Obj2C_Indexo
					; ROM:0000B7EEo
		dc.w loc_B842-Obj2C_Index
; ===============================================================================

loc_B7F0:				; DATA XREF: ROM:Obj2C_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj2C,4(a0)
		move.w	#$2486,2(a0)
		bsr.w	ModifySpriteAttr_2P
		ori.b	#4,1(a0)
		move.b	#$A,$20(a0)
		move.b	#4,$18(a0)
		move.b	#$10,$19(a0)
		moveq	#0,d0
		move.b	$28(a0),d0
		lsl.w	#6,d0
		subq.w	#1,d0
		move.w	d0,$30(a0)
		move.w	d0,$32(a0)
		move.w	#$FFC0,$10(a0)
		btst	#0,$22(a0)
		beq.s	loc_B842
		neg.w	$10(a0)

loc_B842:				; CODE XREF: ROM:0000B83Cj
					; DATA XREF: ROM:0000B7EEo
		subq.w	#1,$30(a0)
		bpl.s	loc_B85E
		move.w	$32(a0),$30(a0)
		neg.w	$10(a0)
		bchg	#0,$22(a0)
		move.b	#1,$1D(a0)

loc_B85E:				; CODE XREF: ROM:0000B846j
		lea	(Ani_Obj2C).l,a1
		bsr.w	AnimateSprite
		bsr.w	SpeedToPos
		bra.w	MarkObjGone
; ===============================================================================
Ani_Obj2C:	dc.b   0,  2,  7,  0,  1,  2,  3,$FF; 0	; DATA XREF: ROM:loc_B85Eo
Map_Obj2C:	dc.w word_B880-Map_Obj2C ; DATA	XREF: ROM:0000B7F4o
					; ROM:Map_Obj2Co ...
		dc.w word_B892-Map_Obj2C
		dc.w word_B8A4-Map_Obj2C
		dc.w word_B8B6-Map_Obj2C
word_B880:	dc.w 2			; DATA XREF: ROM:Map_Obj2Co
		dc.w $F40E,    0,    0,$FFF0; 0
		dc.w $F505,  $18,   $C,	 $10; 4
word_B892:	dc.w 2			; DATA XREF: ROM:0000B87Ao
		dc.w $F40E,   $C,    6,$FFF0; 0
		dc.w $F505,  $1C,   $E,	 $10; 4
word_B8A4:	dc.w 2			; DATA XREF: ROM:0000B87Co
		dc.w $F40E,    0,    0,$FFF0; 0
		dc.w $F505,$1018,$100C,	 $10; 4
word_B8B6:	dc.w 2			; DATA XREF: ROM:0000B87Eo
		dc.w $F40E,   $C,    6,$FFF0; 0
		dc.w $F505,$101C,$100E,	 $10; 4
; ===============================================================================
;----------------------------------------------------
; Object 34 - leftover Sonic 1 title cards
;----------------------------------------------------

Obj34:
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj34_Index(pc,d0.w),d1
		jmp	Obj34_Index(pc,d1.w)
; ===============================================================================
Obj34_Index:	dc.w Obj34_CheckLZ4-Obj34_Index
		dc.w Obj34_CheckPos-Obj34_Index
		dc.w Obj34_Wait-Obj34_Index
		dc.w Obj34_Wait-Obj34_Index
; ===============================================================================

Obj34_CheckLZ4:
		movea.l	a0,a1
		moveq	#0,d0
		move.b	(RAM_Level_CurrentZone).w,d0
		cmpi.w	#$103,(RAM_Level_CurrentZone).w
		bne.s	Obj34_CheckFZ
		moveq	#5,d0

Obj34_CheckFZ:
		move.w	d0,d2
		cmpi.w	#$502,(RAM_Level_CurrentZone).w
		bne.s	Obj34_CheckConfig
		moveq	#6,d0
		moveq	#$B,d2

Obj34_CheckConfig:
		lea	(Obj34_Config).l,a3
		lsl.w	#4,d0
		adda.w	d0,a3
		lea	(Obj34_ItemData).l,a2
		moveq	#3,d1

Obj34_Loop:
		move.b	#$34,0(a1)
		move.w	(a3),8(a1)
		move.w	(a3)+,$32(a1)
		move.w	(a3)+,$30(a1)
		move.w	(a2)+,$A(a1)
		move.b	(a2)+,$24(a1)
		move.b	(a2)+,d0
		bne.s	Obj34_ActNumber
		move.b	d2,d0

Obj34_ActNumber:
		cmpi.b	#7,d0
		bne.s	Obj34_MakeSprite
		add.b	(RAM_Level_CurrentAct).w,d0
		cmpi.b	#3,(RAM_Level_CurrentAct).w
		bne.s	Obj34_MakeSprite
		subq.b	#1,d0

Obj34_MakeSprite:
		move.b	d0,$1A(a1)
		move.l	#Map_Obj34,4(a1)
		move.w	#$8580,2(a1)
		bsr.w	ModifyA1SpriteAttr_2P
		move.b	#$78,$19(a1)
		move.b	#0,1(a1)
		move.b	#0,$18(a1)
		move.w	#$3C,$1E(a1)
		lea	$40(a1),a1
		dbf	d1,Obj34_Loop

Obj34_CheckPos:
		moveq	#$10,d1
		move.w	$30(a0),d0
		cmp.w	8(a0),d0
		beq.s	loc_B98E
		bge.s	Obj34_Move
		neg.w	d1

Obj34_Move:
		add.w	d1,8(a0)

loc_B98E:
		move.w	8(a0),d0
		bmi.s	Obj34_NoDisplay
		cmpi.w	#$200,d0
		bcc.s	Obj34_NoDisplay
		rts
; ===============================================================================
		bra.w	DisplaySprite
; ===============================================================================

Obj34_NoDisplay:
		rts
; ===============================================================================

Obj34_Wait:
		tst.w	$1E(a0)
		beq.s	Obj34_CheckPos2
		subq.w	#1,$1E(a0)
		rts
; ===============================================================================
		bra.w	DisplaySprite
; ===============================================================================

Obj34_CheckPos2:
		tst.b	1(a0)
		bpl.s	Obj34_ChangeArt
		moveq	#$20,d1
		move.w	$32(a0),d0
		cmp.w	8(a0),d0
		beq.s	Obj34_ChangeArt
		bge.s	Obj34_Move2
		neg.w	d1

Obj34_Move2:
		add.w	d1,8(a0)
		move.w	8(a0),d0
		bmi.s	Obj34_NoDisplay2
		cmpi.w	#$200,d0
		bcc.s	Obj34_NoDisplay2
		rts
; ===============================================================================
		bra.w	DisplaySprite
; ===============================================================================

Obj34_NoDisplay2:
		rts
; ===============================================================================

Obj34_ChangeArt:
		cmpi.b	#4,$24(a0)
		bne.s	Obj34_Delete
		moveq	#2,d0
		jsr	(LoadPLC).l
		moveq	#0,d0
		move.b	(RAM_Level_CurrentZone).w,d0
		addi.w	#$15,d0
		jsr	(LoadPLC).l

Obj34_Delete:
		bra.w	DeleteObject
; ===============================================================================
Obj34_ItemData:	dc.w $D0		; DATA XREF: ROM:0000B908o
		dc.b   2,  0		; 0
		dc.w $E4
		dc.b   2,  6		; 0
		dc.w $EA
		dc.b   2,  7		; 0
		dc.w $E0
		dc.b   2, $A		; 0
Obj34_Config:	dc.w	 0, $120,$FEFC,	$13C, $414, $154, $214,	$154; 0
					; DATA XREF: ROM:Obj34_CheckConfigo
		dc.w	 0, $120,$FEF4,	$134, $40C, $14C, $20C,	$14C; 8
		dc.w	 0, $120,$FEE0,	$120, $3F8, $138, $1F8,	$138; 16
		dc.w	 0, $120,$FEFC,	$13C, $414, $154, $214,	$154; 24
		dc.w	 0, $120,$FF04,	$144, $41C, $15C, $21C,	$15C; 32
		dc.w	 0, $120,$FF04,	$144, $41C, $15C, $21C,	$15C; 40
		dc.w	 0, $120,$FEE4,	$124, $3EC, $3EC, $1EC,	$12C; 48
; ===============================================================================
;----------------------------------------------------
; Object 39 - Game over	/ time over
;----------------------------------------------------

Obj39:
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj39_Index(pc,d0.w),d1
		jmp	Obj39_Index(pc,d1.w)
; ===============================================================================
Obj39_Index:	dc.w loc_BA98-Obj39_Index
		dc.w loc_BADC-Obj39_Index
		dc.w loc_BAFE-Obj39_Index
; ===============================================================================

loc_BA98:
		tst.l	(RAM_PLC_Buffer).w
		beq.s	loc_BAA0
		rts
; ===============================================================================

loc_BAA0:
		addq.b	#2,$24(a0)
		move.w	#$50,8(a0)
		btst	#0,$1A(a0)
		beq.s	loc_BAB8
		move.w	#$1F0,8(a0)

loc_BAB8:
		move.w	#$F0,$A(a0)
		move.l	#Map_Obj39,4(a0)
		move.w	#$855E,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#0,1(a0)
		move.b	#0,$18(a0)

loc_BADC:
		moveq	#$10,d1
		cmpi.w	#$120,8(a0)
		beq.s	loc_BAF2
		bcs.s	loc_BAEA
		neg.w	d1

loc_BAEA:
		add.w	d1,8(a0)
		bra.w	DisplaySprite
; ===============================================================================

loc_BAF2:
		move.w	#$2D0,$1E(a0)
		addq.b	#2,$24(a0)
		rts
; ===============================================================================

loc_BAFE:
		move.b	(RAM_Control_1_Press).w,d0
		andi.b	#$70,d0
		bne.s	loc_BB1E
		btst	#0,$1A(a0)
		bne.s	loc_BB42
		tst.w	$1E(a0)
		beq.s	loc_BB1E
		subq.w	#1,$1E(a0)
		bra.w	DisplaySprite
; ===============================================================================

loc_BB1E:
		tst.b	(RAM_Flag_Sonic_TimeOver).w
		bne.s	loc_BB38
		move.b	#$14,(RAM_GameMode).w			;Leftover from S1
		tst.b	(RAM_Sonic_Continues).w
		bne.s	loc_BB42
		move.b	#ModeId_Sega,(RAM_GameMode).w
		bra.s	loc_BB42
; ===============================================================================

loc_BB38:
		clr.l	(RAM_Lamppost_Hud_Time).w
		move.w	#1,(RAM_Flag_ResetLevel).w

loc_BB42:
		bra.w	DisplaySprite
; ===============================================================================
;----------------------------------------------------
; Object 3A - leftover SONIC GOT THROUGH title card
;----------------------------------------------------

Obj3A:
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj3A_Index(pc,d0.w),d1
		jmp	Obj3A_Index(pc,d1.w)
; ===============================================================================
Obj3A_Index:	dc.w loc_BB5C-Obj3A_Index
		dc.w loc_BBB8-Obj3A_Index
		dc.w loc_BC04-Obj3A_Index
		dc.w loc_BC80-Obj3A_Index
; ===============================================================================

loc_BB5C:
		tst.l	(RAM_PLC_Buffer).w
		beq.s	loc_BB64
		rts
; ===============================================================================

loc_BB64:
		movea.l	a0,a1
		lea	(Obj3A_Conf).l,a2
		moveq	#6,d1

loc_BB6E:
		move.b	#$3A,0(a1)
		move.w	(a2),8(a1)
		move.w	(a2)+,$32(a1)
		move.w	(a2)+,$30(a1)
		move.w	(a2)+,$A(a1)
		move.b	(a2)+,$24(a1)
		move.b	(a2)+,d0
		cmpi.b	#6,d0
		bne.s	loc_BB94
		add.b	(RAM_Level_CurrentAct).w,d0

loc_BB94:
		move.b	d0,$1A(a1)
		move.l	#Map_Obj3A,4(a1)
		move.w	#$8580,2(a1)
		bsr.w	ModifyA1SpriteAttr_2P
		move.b	#0,1(a1)
		lea	$40(a1),a1
		dbf	d1,loc_BB6E

loc_BBB8:
		moveq	#$10,d1
		move.w	$30(a0),d0
		cmp.w	8(a0),d0
		beq.s	loc_BBEA
		bge.s	loc_BBC8
		neg.w	d1

loc_BBC8:
		add.w	d1,8(a0)

loc_BBCC:
		move.w	8(a0),d0
		bmi.s	locret_BBDE
		cmpi.w	#$200,d0
		bcc.s	locret_BBDE
		rts
; ===============================================================================
		bra.w	DisplaySprite
; ===============================================================================

locret_BBDE:
		rts
; ===============================================================================

loc_BBE0:
		move.b	#$E,$24(a0)
		bra.w	loc_BCF8
; ===============================================================================

loc_BBEA:
		cmpi.b	#$E,(RAM_ObjectTable+Obj_Slot_29+$24).w
		beq.s	loc_BBE0
		cmpi.b	#4,$1A(a0)
		bne.s	loc_BBCC
		addq.b	#2,$24(a0)
		move.w	#$B4,$1E(a0)

loc_BC04:
		subq.w	#1,$1E(a0)
		bne.s	locret_BC0E
		addq.b	#2,$24(a0)

locret_BC0E:
		rts
; ===============================================================================
		bra.w	DisplaySprite
; ===============================================================================
		bsr.w	DisplaySprite
		move.b	#1,(RAM_Flag_HudUpd_Bonus).w
		moveq	#0,d0
		tst.w	(RAM_Level_Bonus_Time).w
		beq.s	loc_BC30
		addi.w	#$A,d0
		subi.w	#$A,(RAM_Level_Bonus_Time).w

loc_BC30:
		tst.w	(RAM_Level_Bonus_Rings).w
		beq.s	loc_BC40
		addi.w	#$A,d0
		subi.w	#$A,(RAM_Level_Bonus_Rings).w

loc_BC40:
		tst.w	d0
		bne.s	loc_BC66
		move.w	#$C5,d0
		jsr	(PlaySound_Special).l
		addq.b	#2,$24(a0)
		cmpi.w	#$501,(RAM_Level_CurrentZone).w
		bne.s	loc_BC5E
		addq.b	#4,$24(a0)

loc_BC5E:
		move.w	#$B4,$1E(a0)

locret_BC64:
		rts
; ===============================================================================

loc_BC66:
		jsr	AddPoints
		move.b	(RAM_VIntFrameCnt+3).w,d0
		andi.b	#3,d0
		bne.s	locret_BC64
		move.w	#$CD,d0
		jmp	(PlaySound_Special).l
; ===============================================================================

loc_BC80:
		move.b	(RAM_Level_CurrentZone).w,d0
		andi.w	#7,d0
		lsl.w	#3,d0
		move.b	(RAM_Level_CurrentAct).w,d1
		andi.w	#3,d1
		add.w	d1,d1
		add.w	d1,d0
		move.w	LevelOrder(pc,d0.w),d0
		move.w	d0,(RAM_Level_CurrentZone).w
		tst.w	d0
		bne.s	loc_BCAA
		move.b	#ModeId_Sega,(RAM_GameMode).w
		bra.s	locret_BCC2
; ===============================================================================

loc_BCAA:
		clr.b	(RAM_Level_LamppostCntr).w
		tst.b	(RAM_Flag_Level_StopBonus).w
		beq.s	loc_BCBC
		move.b	#ModeId_SS,(RAM_GameMode).w
		bra.s	locret_BCC2
; ===============================================================================

loc_BCBC:
		move.w	#1,(RAM_Flag_ResetLevel).w
locret_BCC2:
		rts
; ===============================================================================
		bra.w	DisplaySprite
; ===============================================================================
LevelOrder:	dc.w	 1,    2, $200,	   0; 0
		dc.w  $101, $102, $300,	$502; 4
		dc.w  $201, $202, $400,	   0; 8
		dc.w  $301, $302, $500,	   0; 12
		dc.w  $401, $402, $100,	   0; 16
		dc.w  $501, $103,    0,	   0; 20
; ===============================================================================

loc_BCF8:
		moveq	#$20,d1
		move.w	$32(a0),d0
		cmp.w	8(a0),d0
		beq.s	loc_BD1E
		bge.s	loc_BD08
		neg.w	d1

loc_BD08:
		add.w	d1,8(a0)
		move.w	8(a0),d0
		bmi.s	locret_BD1C
		cmpi.w	#$200,d0
		bcc.s	locret_BD1C
		bra.w	DisplaySprite
; ===============================================================================

locret_BD1C:
		rts
; ===============================================================================

loc_BD1E:
		cmpi.b	#4,$1A(a0)
		bne.w	DeleteObject
		addq.b	#2,$24(a0)
		clr.b	(RAM_Flag_Sonic_IgnoreControl).w
		move.w	#$8D,d0
		jmp	(PlaySound).l
; ===============================================================================
		addq.w	#2,(RAM_LevelSys_XPos_SetEnd).w
		cmpi.w	#$2100,(RAM_LevelSys_XPos_SetEnd).w
		beq.w	DeleteObject
		rts
; ===============================================================================
Obj3A_Conf:	dc.w	 4, $124,  $BC,	$200; 0
		dc.w $FEE0, $120,  $D0,	$201; 4
		dc.w  $40C, $14C,  $D6,	$206; 8
		dc.w  $520, $120,  $EC,	$202; 12
		dc.w  $540, $120,  $FC,	$203; 16
		dc.w  $560, $120, $10C,	$204; 20
		dc.w  $20C, $14C,  $CC,	$205; 24
; ===============================================================================
;----------------------------------------------------
; Sonic	1 Object 7E - leftover S1 Special Stage	results
;----------------------------------------------------

S1Obj7E:
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	S1Obj7E_Index(pc,d0.w),d1
		jmp	S1Obj7E_Index(pc,d1.w)
; ===============================================================================
S1Obj7E_Index:	dc.w loc_BDA6-S1Obj7E_Index
		dc.w loc_BE1E-S1Obj7E_Index
		dc.w loc_BE5C-S1Obj7E_Index
		dc.w loc_BE6A-S1Obj7E_Index
		dc.w loc_BE5C-S1Obj7E_Index
		dc.w loc_BEC4-S1Obj7E_Index
		dc.w loc_BE5C-S1Obj7E_Index
		dc.w loc_BECE-S1Obj7E_Index
		dc.w loc_BE5C-S1Obj7E_Index
		dc.w loc_BEC4-S1Obj7E_Index
		dc.w loc_BEF2-S1Obj7E_Index
; ===============================================================================

loc_BDA6:
		tst.l	(RAM_PLC_Buffer).w
		beq.s	loc_BDAE
		rts
; ===============================================================================

loc_BDAE:
		movea.l	a0,a1
		lea	(S1Obj7E_Conf).l,a2
		moveq	#3,d1
		cmpi.w	#$32,(RAM_Sonic_CurrentRings).w
		bcs.s	loc_BDC2
		addq.w	#1,d1

loc_BDC2:
		move.b	#$7E,0(a1)
		move.w	(a2)+,8(a1)
		move.w	(a2)+,$30(a1)
		move.w	(a2)+,$A(a1)
		move.b	(a2)+,$24(a1)
		move.b	(a2)+,$1A(a1)
		move.l	#Map_S1Obj7E,4(a1)
		move.w	#$8580,2(a1)
		bsr.w	ModifyA1SpriteAttr_2P
		move.b	#0,1(a1)
		lea	$40(a1),a1
		dbf	d1,loc_BDC2
		moveq	#7,d0
		move.b	(RAM_Sonic_Emeralds).w,d1
		beq.s	loc_BE1A
		moveq	#0,d0
		cmpi.b	#6,d1
		bne.s	loc_BE1A
		moveq	#8,d0
		move.w	#$18,8(a0)
		move.w	#$118,$30(a0)

loc_BE1A:
		move.b	d0,$1A(a0)

loc_BE1E:
		moveq	#$10,d1
		move.w	$30(a0),d0
		cmp.w	8(a0),d0
		beq.s	loc_BE44
		bge.s	loc_BE2E
		neg.w	d1

loc_BE2E:
		add.w	d1,8(a0)

loc_BE32:
		move.w	8(a0),d0
		bmi.s	locret_BE42
		cmpi.w	#$200,d0
		bcc.s	locret_BE42
		bra.w	DisplaySprite
; ===============================================================================

locret_BE42:
		rts
; ===============================================================================

loc_BE44:
		cmpi.b	#2,$1A(a0)
		bne.s	loc_BE32
		addq.b	#2,$24(a0)
		move.w	#$B4,$1E(a0)
		move.b	#$7F,(RAM_ObjectTable+$800).w

loc_BE5C:
		subq.w	#1,$1E(a0)
		bne.s	loc_BE66
		addq.b	#2,$24(a0)

loc_BE66:
		bra.w	DisplaySprite
; ===============================================================================

loc_BE6A:
		bsr.w	DisplaySprite
		move.b	#1,(RAM_Flag_HudUpd_Bonus).w
		tst.w	(RAM_Level_Bonus_Rings).w
		beq.s	loc_BE9C
		subi.w	#$A,(RAM_Level_Bonus_Rings).w
		moveq	#$A,d0
		jsr	AddPoints
		move.b	(RAM_VIntFrameCnt+3).w,d0
		andi.b	#3,d0
		bne.s	locret_BEC2
		move.w	#$CD,d0
		jmp	(PlaySound_Special).l
; ===============================================================================

loc_BE9C:
		move.w	#$C5,d0
		jsr	(PlaySound_Special).l
		addq.b	#2,$24(a0)
		move.w	#$B4,$1E(a0)
		cmpi.w	#$32,(RAM_Sonic_CurrentRings).w
		bcs.s	locret_BEC2
		move.w	#$3C,$1E(a0)
		addq.b	#4,$24(a0)

locret_BEC2:
		rts
; ===============================================================================

loc_BEC4:
		move.w	#1,(RAM_Flag_ResetLevel).w
		bra.w	DisplaySprite
; ===============================================================================

loc_BECE:
		move.b	#4,(RAM_ObjectTable+Obj_Slot_28+$1A).w
		move.b	#$14,(RAM_ObjectTable+Obj_Slot_28+$24).w
		move.w	#$BF,d0
		jsr	(PlaySound_Special).l
		addq.b	#2,$24(a0)
		move.w	#$168,$1E(a0)
		bra.w	DisplaySprite
; ===============================================================================

loc_BEF2:
		move.b	(RAM_VIntFrameCnt+3).w,d0
		andi.b	#$F,d0
		bne.s	loc_BF02
		bchg	#0,$1A(a0)

loc_BF02:
		bra.w	DisplaySprite
; ===============================================================================
S1Obj7E_Conf:	dc.w   $20, $120,  $C4,	$200; 0
		dc.w  $320, $120, $118,	$201; 4
		dc.w  $360, $120, $128,	$202; 8
		dc.w  $1EC, $11C,  $C4,	$203; 12
		dc.w  $3A0, $120, $138,	$206; 16
; ===============================================================================
;----------------------------------------------------
; Sonic	1 Object 7F - leftover Sonic 1 SS emeralds
;----------------------------------------------------

S1Obj7F:
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	S1Obj7F_Index(pc,d0.w),d1
		jmp	S1Obj7F_Index(pc,d1.w)
; ===============================================================================
S1Obj7F_Index:	dc.w loc_BF4C-S1Obj7F_Index
		dc.w loc_BFA6-S1Obj7F_Index

word_BF40:	dc.w $110
		dc.w $128
		dc.w $F8
		dc.w $140
		dc.w $E0
		dc.w $158
; ===============================================================================

loc_BF4C:
		movea.l	a0,a1
		lea	word_BF40(pc),a2
		moveq	#0,d2
		moveq	#0,d1
		move.b	(RAM_Sonic_Emeralds).w,d1
		subq.b	#1,d1
		bcs.w	DeleteObject

loc_BF60:
		move.b	#$7F,0(a1)
		move.w	(a2)+,8(a1)
		move.w	#$F0,$A(a1)
		lea	(RAM_Sonic_EmeraldTypes).w,a3
		move.b	(a3,d2.w),d3
		move.b	d3,$1A(a1)
		move.b	d3,$1C(a1)
		addq.b	#1,d2
		addq.b	#2,$24(a1)
		move.l	#Map_S1Obj7F,4(a1)
		move.w	#$8541,2(a1)
		bsr.w	ModifyA1SpriteAttr_2P
		move.b	#0,1(a1)
		lea	$40(a1),a1
		dbf	d1,loc_BF60

loc_BFA6:
		move.b	$1A(a0),d0
		move.b	#6,$1A(a0)
		cmpi.b	#6,d0
		bne.s	loc_BFBC
		move.b	$1C(a0),$1A(a0)

loc_BFBC:
		bra.w	DisplaySprite
; ===============================================================================
Map_Obj34:	dc.w word_BFD8-Map_Obj34
		dc.w word_C022-Map_Obj34
		dc.w word_C06C-Map_Obj34
		dc.w word_C09E-Map_Obj34
		dc.w word_C0E8-Map_Obj34
		dc.w word_C13A-Map_Obj34
		dc.w word_C18C-Map_Obj34
		dc.w word_C1AE-Map_Obj34
		dc.w word_C1C0-Map_Obj34
		dc.w word_C1D2-Map_Obj34
		dc.w word_C1E4-Map_Obj34
		dc.w word_C24E-Map_Obj34

word_BFD8:	dc.w 9
		dc.w $F805,  $18,   $C,$FFB4; 0
		dc.w $F805,  $3A,  $1D,$FFC4; 4
		dc.w $F805,  $10,    8,$FFD4; 8
		dc.w $F805,  $10,    8,$FFE4; 12
		dc.w $F805,  $2E,  $17,$FFF4; 16
		dc.w $F805,  $1C,   $E,	 $14; 20
		dc.w $F801,  $20,  $10,	 $24; 24
		dc.w $F805,  $26,  $13,	 $2C; 28
		dc.w $F805,  $26,  $13,	 $3C; 32

word_C022:	dc.w 9
		dc.w $F805,  $26,  $13,$FFBC; 0
		dc.w $F805,    0,    0,$FFCC; 4
		dc.w $F805,    4,    2,$FFDC; 8
		dc.w $F805,  $4A,  $25,$FFEC; 12
		dc.w $F805,  $3A,  $1D,$FFFC; 16
		dc.w $F801,  $20,  $10,	  $C; 20
		dc.w $F805,  $2E,  $17,	 $14; 24
		dc.w $F805,  $42,  $21,	 $24; 28
		dc.w $F805,  $1C,   $E,	 $34; 32

word_C06C:	dc.w 6
		dc.w $F805,  $2A,  $15,$FFCF; 0
		dc.w $F805,    0,    0,$FFE0; 4
		dc.w $F805,  $3A,  $1D,$FFF0; 8
		dc.w $F805,    4,    2,	   0; 12
		dc.w $F805,  $26,  $13,	 $10; 16
		dc.w $F805,  $10,    8,	 $20; 20

word_C09E:	dc.w 9
		dc.w $F805,  $3E,  $1F,$FFB4; 0
		dc.w $F805,  $42,  $21,$FFC4; 4
		dc.w $F805,    0,    0,$FFD4; 8
		dc.w $F805,  $3A,  $1D,$FFE4; 12
		dc.w $F805,  $26,  $13,	   4; 16
		dc.w $F801,  $20,  $10,	 $14; 20
		dc.w $F805,  $18,   $C,	 $1C; 24
		dc.w $F805,  $1C,   $E,	 $2C; 28
		dc.w $F805,  $42,  $21,	 $3C; 32

word_C0E8:	dc.w $A
		dc.w $F805,  $3E,  $1F,$FFAC; 0
		dc.w $F805,  $36,  $1B,$FFBC; 4
		dc.w $F805,  $3A,  $1D,$FFCC; 8
		dc.w $F801,  $20,  $10,$FFDC; 12
		dc.w $F805,  $2E,  $17,$FFE4; 16
		dc.w $F805,  $18,   $C,$FFF4; 20
		dc.w $F805,  $4A,  $25,	 $14; 24
		dc.w $F805,    0,    0,	 $24; 28
		dc.w $F805,  $3A,  $1D,	 $34; 32
		dc.w $F805,   $C,    6,	 $44; 36

word_C13A:	dc.w $A
		dc.w $F805,  $3E,  $1F,$FFAC; 0
		dc.w $F805,    8,    4,$FFBC; 4
		dc.w $F805,  $3A,  $1D,$FFCC; 8
		dc.w $F805,    0,    0,$FFDC; 12
		dc.w $F805,  $36,  $1B,$FFEC; 16
		dc.w $F805,    4,    2,	  $C; 20
		dc.w $F805,  $3A,  $1D,	 $1C; 24
		dc.w $F805,    0,    0,	 $2C; 28
		dc.w $F801,  $20,  $10,	 $3C; 32
		dc.w $F805,  $2E,  $17,	 $44; 36

word_C18C:	dc.w 4
		dc.w $F805,  $4E,  $27,$FFE0; 0
		dc.w $F805,  $32,  $19,$FFF0; 4
		dc.w $F805,  $2E,  $17,	   0; 8
		dc.w $F805,  $10,    8,	 $10; 12

word_C1AE:	dc.w 2
		dc.w  $40C,  $53,  $29,$FFEC; 0
		dc.w $F402,  $57,  $2B,	  $C; 4

word_C1C0:	dc.w 2
		dc.w  $40C,  $53,  $29,$FFEC; 0
		dc.w $F406,  $5A,  $2D,	   8; 4

word_C1D2:	dc.w 2
		dc.w  $40C,  $53,  $29,$FFEC; 0
		dc.w $F406,  $60,  $30,	   8; 4

word_C1E4:	dc.w $D
		dc.w $E40C,  $70,  $38,$FFF4; 0
		dc.w $E402,  $74,  $3A,	 $14; 4
		dc.w $EC04,  $77,  $3B,$FFEC; 8
		dc.w $F405,  $79,  $3C,$FFE4; 12
		dc.w $140C,$1870,$1838,$FFEC; 16
		dc.w  $402,$1874,$183A,$FFE4; 20
		dc.w  $C04,$1877,$183B,	   4; 24
		dc.w $FC05,$1879,$183C,	  $C; 28
		dc.w $EC08,  $7D,  $3E,$FFFC; 32
		dc.w $F40C,  $7C,  $3E,$FFF4; 36
		dc.w $FC08,  $7C,  $3E,$FFF4; 40
		dc.w  $40C,  $7C,  $3E,$FFEC; 44
		dc.w  $C08,  $7C,  $3E,$FFEC; 48

word_C24E:	dc.w 5
		dc.w $F805,  $14,   $A,$FFDC; 0
		dc.w $F801,  $20,  $10,$FFEC; 4
		dc.w $F805,  $2E,  $17,$FFF4; 8
		dc.w $F805,    0,    0,	   4; 12
		dc.w $F805,  $26,  $13,	 $14; 16

Map_Obj39:	dc.w word_C280-Map_Obj39
		dc.w word_C292-Map_Obj39
		dc.w word_C2A4-Map_Obj39
		dc.w word_C2B6-Map_Obj39
word_C280:	dc.w 2			; DATA XREF: ROM:Map_Obj39o
		dc.w $F80D,    0,    0,$FFB8; 0
		dc.w $F80D,    8,    4,$FFD8; 4
word_C292:	dc.w 2			; DATA XREF: ROM:0000C27Ao
		dc.w $F80D,  $14,   $A,	   8; 0
		dc.w $F80D,   $C,    6,	 $28; 4
word_C2A4:	dc.w 2			; DATA XREF: ROM:0000C27Co
		dc.w $F809,  $1C,   $E,$FFC4; 0
		dc.w $F80D,    8,    4,$FFDC; 4
word_C2B6:	dc.w 2			; DATA XREF: ROM:0000C27Eo
		dc.w $F80D,  $14,   $A,	  $C; 0
		dc.w $F80D,   $C,    6,	 $2C; 4
Map_Obj3A:	dc.w word_C2DA-Map_Obj3A ; DATA	XREF: ROM:0000BB98o
					; ROM:Map_Obj3Ao ...
		dc.w word_C31C-Map_Obj3A
		dc.w word_C34E-Map_Obj3A
		dc.w word_C380-Map_Obj3A
		dc.w word_C3BA-Map_Obj3A
		dc.w word_C1E4-Map_Obj3A
		dc.w word_C1AE-Map_Obj3A
		dc.w word_C1C0-Map_Obj3A
		dc.w word_C1D2-Map_Obj3A
word_C2DA:	dc.w 8			; DATA XREF: ROM:Map_Obj3Ao
		dc.w $F805,  $3E,  $1F,$FFB8; 0
		dc.w $F805,  $32,  $19,$FFC8; 4
		dc.w $F805,  $2E,  $17,$FFD8; 8
		dc.w $F801,  $20,  $10,$FFE8; 12
		dc.w $F805,    8,    4,$FFF0; 16
		dc.w $F805,  $1C,   $E,	 $10; 20
		dc.w $F805,    0,    0,	 $20; 24
		dc.w $F805,  $3E,  $1F,	 $30; 28
word_C31C:	dc.w 6			; DATA XREF: ROM:0000C2CAo
		dc.w $F805,  $36,  $1B,$FFD0; 0
		dc.w $F805,    0,    0,$FFE0; 4
		dc.w $F805,  $3E,  $1F,$FFF0; 8
		dc.w $F805,  $3E,  $1F,	   0; 12
		dc.w $F805,  $10,    8,	 $10; 16
		dc.w $F805,   $C,    6,	 $20; 20
word_C34E:	dc.w 6			; DATA XREF: ROM:0000C2CCo
		dc.w $F80D, $14A,  $A5,$FFB0; 0
		dc.w $F801, $162,  $B1,$FFD0; 4
		dc.w $F809, $164,  $B2,	 $18; 8
		dc.w $F80D, $16A,  $B5,	 $30; 12
		dc.w $F704,  $6E,  $37,$FFCD; 16
		dc.w $FF04,$186E,$1837,$FFCD; 20
word_C380:	dc.w 7			; DATA XREF: ROM:0000C2CEo
		dc.w $F80D, $15A,  $AD,$FFB0; 0
		dc.w $F80D,  $66,  $33,$FFD9; 4
		dc.w $F801, $14A,  $A5,$FFF9; 8
		dc.w $F704,  $6E,  $37,$FFF6; 12
		dc.w $FF04,$186E,$1837,$FFF6; 16
		dc.w $F80D,$FFF0,$FBF8,	 $28; 20
		dc.w $F801, $170,  $B8,	 $48; 24
word_C3BA:	dc.w 7			; DATA XREF: ROM:0000C2D0o
		dc.w $F80D, $152,  $A9,$FFB0; 0
		dc.w $F80D,  $66,  $33,$FFD9; 4
		dc.w $F801, $14A,  $A5,$FFF9; 8
		dc.w $F704,  $6E,  $37,$FFF6; 12
		dc.w $FF04,$186E,$1837,$FFF6; 16
		dc.w $F80D,$FFF8,$FBFC,	 $28; 20
		dc.w $F801, $170,  $B8,	 $48; 24
Map_S1Obj7E:	dc.w word_C406-Map_S1Obj7E ; DATA XREF:	ROM:0000BDDCo
					; ROM:Map_S1Obj7Eo ...
		dc.w word_C470-Map_S1Obj7E
		dc.w word_C4A2-Map_S1Obj7E
		dc.w word_1C1E4-Map_S1Obj7E
		dc.w word_C4DC-Map_S1Obj7E
		dc.w word_C4FE-Map_S1Obj7E
		dc.w word_C520-Map_S1Obj7E
		dc.w word_C53A-Map_S1Obj7E
		dc.w word_C59C-Map_S1Obj7E
word_C406:	dc.w $D			; DATA XREF: ROM:Map_S1Obj7Eo
		dc.w $F805,    8,    4,$FF90; 0
		dc.w $F805,  $1C,   $E,$FFA0; 4
		dc.w $F805,    0,    0,$FFB0; 8
		dc.w $F805,  $32,  $19,$FFC0; 12
		dc.w $F805,  $3E,  $1F,$FFD0; 16
		dc.w $F805,  $10,    8,$FFF0; 20
		dc.w $F805,  $2A,  $15,	   0; 24
		dc.w $F805,  $10,    8,	 $10; 28
		dc.w $F805,  $3A,  $1D,	 $20; 32
		dc.w $F805,    0,    0,	 $30; 36
		dc.w $F805,  $26,  $13,	 $40; 40
		dc.w $F805,   $C,    6,	 $50; 44
		dc.w $F805,  $3E,  $1F,	 $60; 48
word_C470:	dc.w 6			; DATA XREF: ROM:0000C3F6o
		dc.w $F80D, $14A,  $A5,$FFB0; 0
		dc.w $F801, $162,  $B1,$FFD0; 4
		dc.w $F809, $164,  $B2,	 $18; 8
		dc.w $F80D, $16A,  $B5,	 $30; 12
		dc.w $F704,  $6E,  $37,$FFCD; 16
		dc.w $FF04,$186E,$1837,$FFCD; 20
word_C4A2:	dc.w 7			; DATA XREF: ROM:0000C3F8o
		dc.w $F80D, $152,  $A9,$FFB0; 0
		dc.w $F80D,  $66,  $33,$FFD9; 4
		dc.w $F801, $14A,  $A5,$FFF9; 8
		dc.w $F704,  $6E,  $37,$FFF6; 12
		dc.w $FF04,$186E,$1837,$FFF6; 16
		dc.w $F80D,$FFF8,$FBFC,	 $28; 20
		dc.w $F801, $170,  $B8,	 $48; 24
word_C4DC:	dc.w 4			; DATA XREF: ROM:0000C3FCo
		dc.w $F80D,$FFD1,$7FC8,$FFB0; 0
		dc.w $F80D,$FFD9,$7FD4,$FFD0; 4
		dc.w $F801,$FFE1,$7FE0,$FFF0; 8
		dc.w $F806,$1FE3,$2FE3,	 $40; 12
word_C4FE:	dc.w 4			; DATA XREF: ROM:0000C3FEo
		dc.w $F80D,$FFD1,$7FC8,$FFB0; 0
		dc.w $F80D,$FFD9,$7FD4,$FFD0; 4
		dc.w $F801,$FFE1,$7FE0,$FFF0; 8
		dc.w $F806,$1FE9,$2FEC,	 $40; 12
word_C520:	dc.w 3			; DATA XREF: ROM:0000C400o
		dc.w $F80D,$FFD1,$7FC8,$FFB0; 0
		dc.w $F80D,$FFD9,$7FD4,$FFD0; 4
		dc.w $F801,$FFE1,$7FE0,$FFF0; 8
word_C53A:	dc.w $C			; DATA XREF: ROM:0000C402o
		dc.w $F805,  $3E,  $1F,$FF9C; 0
		dc.w $F805,  $36,  $1B,$FFAC; 4
		dc.w $F805,  $10,    8,$FFBC; 8
		dc.w $F805,    8,    4,$FFCC; 12
		dc.w $F801,  $20,  $10,$FFDC; 16
		dc.w $F805,    0,    0,$FFE4; 20
		dc.w $F805,  $26,  $13,$FFF4; 24
		dc.w $F805,  $3E,  $1F,	 $14; 28
		dc.w $F805,  $42,  $21,	 $24; 32
		dc.w $F805,    0,    0,	 $34; 36
		dc.w $F805,  $18,   $C,	 $44; 40
		dc.w $F805,  $10,    8,	 $54; 44
word_C59C:	dc.w $F			; DATA XREF: ROM:0000C404o
		dc.w $F805,  $3E,  $1F,$FF88; 0
		dc.w $F805,  $32,  $19,$FF98; 4
		dc.w $F805,  $2E,  $17,$FFA8; 8
		dc.w $F801,  $20,  $10,$FFB8; 12
		dc.w $F805,    8,    4,$FFC0; 16
		dc.w $F805,  $18,   $C,$FFD8; 20
		dc.w $F805,  $32,  $19,$FFE8; 24
		dc.w $F805,  $42,  $21,$FFF8; 28
		dc.w $F805,  $42,  $21,	 $10; 32
		dc.w $F805,  $1C,   $E,	 $20; 36
		dc.w $F805,  $10,    8,	 $30; 40
		dc.w $F805,  $2A,  $15,	 $40; 44
		dc.w $F805,    0,    0,	 $58; 48
		dc.w $F805,  $26,  $13,	 $68; 52
		dc.w $F805,  $26,  $13,	 $78; 56
Map_S1Obj7F:	dc.w word_C624-Map_S1Obj7F ; DATA XREF:	ROM:0000BF86o
					; ROM:Map_S1Obj7Fo ...
		dc.w word_C62E-Map_S1Obj7F
		dc.w word_C638-Map_S1Obj7F
		dc.w word_C642-Map_S1Obj7F
		dc.w word_C64C-Map_S1Obj7F
		dc.w word_C656-Map_S1Obj7F
		dc.w word_C660-Map_S1Obj7F
word_C624:	dc.w 1			; DATA XREF: ROM:Map_S1Obj7Fo
		dc.w $F805,$2004,$2002,$FFF8; 0
word_C62E:	dc.w 1			; DATA XREF: ROM:0000C618o
		dc.w $F805,    0,    0,$FFF8; 0
word_C638:	dc.w 1			; DATA XREF: ROM:0000C61Ao
		dc.w $F805,$4004,$4002,$FFF8; 0
word_C642:	dc.w 1			; DATA XREF: ROM:0000C61Co
		dc.w $F805,$6004,$6002,$FFF8; 0
word_C64C:	dc.w 1			; DATA XREF: ROM:0000C61Eo
		dc.w $F805,$2008,$2004,$FFF8; 0
word_C656:	dc.w 1			; DATA XREF: ROM:0000C620o
		dc.w $F805,$200C,$2006,$FFF8; 0
word_C660:	dc.w 0			; DATA XREF: ROM:0000C622o
; ===============================================================================
		nop
;----------------------------------------------------
; Object 36 - Spikes
;----------------------------------------------------

Obj36:
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj36_Index(pc,d0.w),d1
		jmp	Obj36_Index(pc,d1.w)
; ===============================================================================
Obj36_Index:	dc.w loc_C682-Obj36_Index
		dc.w loc_C6CE-Obj36_Index

Obj36_Conf:	dc.b   0,$10		; 0
		dc.b   0,$10		; 2
		dc.b   0,$10		; 4
		dc.b   0,$10		; 6
		dc.b   0,$10		; 8
		dc.b   0,$10		; 10
; ===============================================================================

loc_C682:
		addq.b	#2,$24(a0)
		move.l	#Map_Obj36,4(a0)
		move.w	#$2434,2(a0)
		bsr.w	ModifySpriteAttr_2P
		ori.b	#4,1(a0)
		move.b	#4,$18(a0)
		move.b	$28(a0),d0
		andi.b	#$F,$28(a0)
		andi.w	#$F0,d0	; ''
		lea	Obj36_Conf(pc),a1
		lsr.w	#3,d0
		adda.w	d0,a1
		move.b	(a1)+,$1A(a0)
		move.b	(a1)+,$19(a0)
		move.w	8(a0),$30(a0)
		move.w	$C(a0),$32(a0)

loc_C6CE:
		bsr.w	sub_C788
		move.w	#4,d2
		cmpi.b	#5,$1A(a0)
		beq.s	loc_C6EA
		cmpi.b	#1,$1A(a0)
		bne.s	loc_C70C
		move.w	#$14,d2

loc_C6EA:
		move.w	#$1B,d1
		move.w	d2,d3
		addq.w	#1,d3
		move.w	8(a0),d4
		bsr.w	SolidObject
		btst	#3,$22(a0)
		bne.s	loc_C766
		swap	d6
		andi.w	#3,d6
		bne.s	loc_C736
		bra.s	loc_C766
; ===============================================================================

loc_C70C:
		moveq	#0,d1
		move.b	$19(a0),d1
		addi.w	#$B,d1
		move.w	#$10,d2
		move.w	#$11,d3
		move.w	8(a0),d4
		bsr.w	SolidObject
		btst	#3,$22(a0)
		bne.s	loc_C736
		swap	d6
		andi.w	#$C0,d6	; ''
		beq.s	loc_C766

loc_C736:
		tst.b	(RAM_Flag_Sonic_Invincibility).w
		bne.s	loc_C766
		move.l	a0,-(sp)
		movea.l	a0,a2
		lea	(RAM_ObjRAM_Sonic).w,a0
		cmpi.b	#4,$24(a0)
		bcc.s	loc_C764
		move.l	$C(a0),d3
		move.w	$12(a0),d0
		ext.l	d0
		asl.l	#8,d0
		sub.l	d0,d3
		move.l	d3,$C(a0)
		jsr	HurtSonic

loc_C764:
		movea.l	(sp)+,a0

loc_C766:
		tst.w	(RAM_Flag_SplitScreen).w
		beq.s	loc_C770
		bra.w	DisplaySprite
; ===============================================================================

loc_C770:
		move.w	$30(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.w	DeleteObject
		bra.w	DisplaySprite

; =============== S U B R O U T I N E ==========================================


sub_C788:
		moveq	#0,d0
		move.b	$28(a0),d0
		add.w	d0,d0
		move.w	off_C798(pc,d0.w),d1
		jmp	off_C798(pc,d1.w)
; ===============================================================================
off_C798:	dc.w locret_C79E-off_C798
		dc.w loc_C7A0-off_C798
		dc.w loc_C7B4-off_C798
; ===============================================================================

locret_C79E:
		rts
; ===============================================================================

loc_C7A0:
		bsr.w	sub_C7C8
		moveq	#0,d0
		move.b	$34(a0),d0
		add.w	$32(a0),d0
		move.w	d0,$C(a0)
		rts
; ===============================================================================

loc_C7B4:
		bsr.w	sub_C7C8
		moveq	#0,d0
		move.b	$34(a0),d0
		add.w	$30(a0),d0
		move.w	d0,8(a0)
		rts

; =============== S U B R O U T I N E ==========================================


sub_C7C8:
		tst.w	$38(a0)
		beq.s	loc_C7E6
		subq.w	#1,$38(a0)
		bne.s	locret_C828
		tst.b	1(a0)
		bpl.s	locret_C828
		move.w	#$B6,d0	; ''
		jsr	(PlaySound_Special).l
		bra.s	locret_C828
; ===============================================================================

loc_C7E6:
		tst.w	$36(a0)
		beq.s	loc_C808
		subi.w	#$800,$34(a0)
		bcc.s	locret_C828
		move.w	#0,$34(a0)
		move.w	#0,$36(a0)
		move.w	#$3C,$38(a0) ; '<'
		bra.s	locret_C828
; ===============================================================================

loc_C808:
		addi.w	#$800,$34(a0)
		cmpi.w	#$2000,$34(a0)
		bcs.s	locret_C828
		move.w	#$2000,$34(a0)
		move.w	#1,$36(a0)
		move.w	#$3C,$38(a0) ; '<'

locret_C828:
		rts

; ===============================================================================
Map_Obj36:	dc.w word_C836-Map_Obj36
		dc.w word_C836-Map_Obj36
		dc.w word_C836-Map_Obj36
		dc.w word_C836-Map_Obj36
		dc.w word_C836-Map_Obj36
		dc.w word_C836-Map_Obj36
word_C836:	dc.w 2
		dc.w $F007,    0,    0,$FFF0; 0
		dc.w $F007,    0,    0,	   0; 4
; ===============================================================================
;----------------------------------------------------
; Object 3B - GHZ Purple Rock
;----------------------------------------------------

Obj3B:
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj3B_Index(pc,d0.w),d1
		jmp	Obj3B_Index(pc,d1.w)
; ===============================================================================
Obj3B_Index:	dc.w loc_C85A-Obj3B_Index
		dc.w loc_C882-Obj3B_Index
; ===============================================================================

loc_C85A:
		addq.b	#2,$24(a0)
		move.l	#Map_Obj3B,4(a0)
		move.w	#$66C0,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#4,1(a0)
		move.b	#$13,$19(a0)
		move.b	#4,$18(a0)

loc_C882:
		move.w	#$1B,d1
		move.w	#$10,d2
		move.w	#$10,d3
		move.w	8(a0),d4
		bsr.w	SolidObject
		move.w	8(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.w	DeleteObject
		bra.w	DisplaySprite
; ===============================================================================
Map_Obj3B:	dc.w word_C8B0-Map_Obj3B
word_C8B0:	dc.w 2			; DATA XREF: ROM:Map_Obj3Bo
		dc.w $F00B,    0,    0,$FFE8; 0
		dc.w $F00B,   $C,    6,	   0; 4
		dc.w 0
; ===============================================================================
;----------------------------------------------------
; Object 3C - GHZ smashable wall
;----------------------------------------------------

Obj3C:
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj3C_Index(pc,d0.w),d1
		jsr	Obj3C_Index(pc,d1.w)
		bra.w	MarkObjGone
; ===============================================================================
Obj3C_Index:	dc.w loc_C8DC-Obj3C_Index
		dc.w loc_C90A-Obj3C_Index
		dc.w loc_C988-Obj3C_Index
; ===============================================================================

loc_C8DC:
		addq.b	#2,$24(a0)
		move.l	#Map_Obj3C,4(a0)
		move.w	#$4590,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#4,1(a0)
		move.b	#$10,$19(a0)
		move.b	#4,$18(a0)
		move.b	$28(a0),$1A(a0)

loc_C90A:
		move.w	(RAM_ObjRam_Sonic+$10).w,$30(a0)
		move.w	#$1B,d1
		move.w	#$20,d2
		move.w	#$20,d3
		move.w	8(a0),d4
		bsr.w	SolidObject
		btst	#5,$22(a0)
		bne.s	loc_C92E

locret_C92C:
		rts
; ===============================================================================

loc_C92E:
		lea	(RAM_ObjRAM_Sonic).w,a1
		cmpi.b	#2,$1C(a1)
		bne.s	locret_C92C
		move.w	$30(a0),d0
		bpl.s	loc_C942
		neg.w	d0

loc_C942:
		cmpi.w	#$480,d0
		bcs.s	locret_C92C
		move.w	$30(a0),$10(a1)
		addq.w	#4,8(a1)
		lea	(Obj3C_FragSpdRight).l,a4
		move.w	8(a0),d0
		cmp.w	8(a1),d0
		bcs.s	loc_C96E
		subi.w	#8,8(a1)
		lea	(Obj3C_FragSpdLeft).l,a4

loc_C96E:
		move.w	$10(a1),$14(a1)
		bclr	#5,$22(a0)
		bclr	#5,$22(a1)
		moveq	#7,d1
		move.w	#$70,d2
		bsr.s	sub_C99E

loc_C988:
		bsr.w	SpeedToPos
		addi.w	#$70,$12(a0)
		tst.b	1(a0)
		bpl.w	DeleteObject
		bra.w	DisplaySprite

; =============== S U B R O U T I N E ==========================================


sub_C99E:
		moveq	#0,d0
		move.b	$1A(a0),d0
		add.w	d0,d0
		movea.l	4(a0),a3
		adda.w	(a3,d0.w),a3
		addq.w	#2,a3
		bset	#5,1(a0)
		move.b	0(a0),d4
		move.b	1(a0),d5
		movea.l	a0,a1
		bra.s	loc_C9CA
; ===============================================================================

loc_C9C2:
		bsr.w	SingleObjectLoad
		bne.s	loc_CA1C
		addq.w	#8,a3

loc_C9CA:
		move.b	#4,$24(a1)
		move.b	d4,0(a1)
		move.l	a3,4(a1)
		move.b	d5,1(a1)
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		move.w	2(a0),2(a1)
		move.b	$18(a0),$18(a1)
		move.b	$19(a0),$19(a1)
		move.w	(a4)+,$10(a1)
		move.w	(a4)+,$12(a1)
		cmpa.l	a0,a1
		bcc.s	loc_CA18
		move.l	a0,-(sp)
		movea.l	a1,a0
		bsr.w	SpeedToPos
		add.w	d2,$12(a0)
		movea.l	(sp)+,a0
		bsr.w	DisplayA1Sprite

loc_CA18:
		dbf	d1,loc_C9C2

loc_CA1C:
		move.w	#$CB,d0
		jmp	(PlaySound_Special).l
; End of function sub_C99E

; ===============================================================================
Obj3C_FragSpdRight:
		dc.w	 $400,$FB00	   ; 0
		dc.w  $600,$FF00	; 2
		dc.w  $600, $100	; 4
		dc.w  $400, $500	; 6
		dc.w  $600,$FA00	; 8
		dc.w  $800,$FE00	; 10
		dc.w  $800, $200	; 12
		dc.w  $600, $600	; 14

Obj3C_FragSpdLeft:
		dc.w $FA00,$FA00	  ; 0
		dc.w $F800,$FE00	; 2
		dc.w $F800, $200	; 4
		dc.w $FA00, $600	; 6
		dc.w $FC00,$FB00	; 8
		dc.w $FA00,$FF00	; 10
		dc.w $FA00, $100	; 12
		dc.w $FC00, $500	; 14

Map_Obj3C:	dc.w word_CA6C-Map_Obj3C
		dc.w word_CAAE-Map_Obj3C
		dc.w word_CAF0-Map_Obj3C
word_CA6C:	dc.w 8			; DATA XREF: ROM:Map_Obj3Co
		dc.w $E005,    0,    0,$FFF0; 0
		dc.w $F005,    0,    0,$FFF0; 4
		dc.w	 5,    0,    0,$FFF0; 8
		dc.w $1005,    0,    0,$FFF0; 12
		dc.w $E005,    4,    2,	   0; 16
		dc.w $F005,    4,    2,	   0; 20
		dc.w	 5,    4,    2,	   0; 24
		dc.w $1005,    4,    2,	   0; 28
word_CAAE:	dc.w 8			; DATA XREF: ROM:0000CA68o
		dc.w $E005,    4,    2,$FFF0; 0
		dc.w $F005,    4,    2,$FFF0; 4
		dc.w	 5,    4,    2,$FFF0; 8
		dc.w $1005,    4,    2,$FFF0; 12
		dc.w $E005,    4,    2,	   0; 16
		dc.w $F005,    4,    2,	   0; 20
		dc.w	 5,    4,    2,	   0; 24
		dc.w $1005,    4,    2,	   0; 28
word_CAF0:	dc.w 8			; DATA XREF: ROM:0000CA6Ao
		dc.w $E005,    4,    2,$FFF0; 0
		dc.w $F005,    4,    2,$FFF0; 4
		dc.w	 5,    4,    2,$FFF0; 8
		dc.w $1005,    4,    2,$FFF0; 12
		dc.w $E005,    8,    4,	   0; 16
		dc.w $F005,    8,    4,	   0; 20
		dc.w	 5,    8,    4,	   0; 24
		dc.w $1005,    8,    4,	   0; 28
; ===============================================================================
		nop

; =============== S U B R O U T I N E ==========================================


ObjectsLoad:
		lea	(RAM_ObjectTable).w,a0
		moveq	#$7F,d7
		moveq	#0,d0
		cmpi.b	#6,(RAM_ObjRAM_Sonic+$24).w
		bcc.s	loc_CB5E


; =============== S U B R O U T I N E ==========================================


sub_CB44:
		move.b	(a0),d0
		beq.s	loc_CB54
		add.w	d0,d0
		add.w	d0,d0
		movea.l	Obj_Index-4(pc,d0.w),a1
		jsr	(a1)
		moveq	#0,d0

loc_CB54:
		lea	$40(a0),a0
		dbf	d7,sub_CB44
		rts

; ===============================================================================
; START	OF FUNCTION CHUNK FOR ObjectsLoad

loc_CB5E:
		moveq	#$1F,d7
		bsr.s	sub_CB44
		moveq	#$5F,d7

loc_CB64:
		moveq	#0,d0
		move.b	(a0),d0
		beq.s	loc_CB74
		tst.b	1(a0)
		bpl.s	loc_CB74
		bsr.w	DisplaySprite

loc_CB74:
		lea	$40(a0),a0

loc_CB78:
		dbf	d7,loc_CB64
		rts

; ===============================================================================
Obj_Index:
		dc.l	Obj01
                dc.l	Obj02
                dc.l	Obj03
                dc.l	Obj04
		dc.l	Obj05
                dc.l	Obj06
                dc.l	jmp_DeleteObject
                dc.l	Obj08
		dc.l	Obj09
                dc.l	Obj0A
                dc.l	Obj0B
                dc.l	Obj0C
		dc.l	Obj0D
                dc.l	Obj0E
                dc.l	Obj0F
                dc.l	Obj10
		dc.l	Obj11
                dc.l	Obj12
                dc.l	Obj13
                dc.l	Obj14
		dc.l	Obj15
                dc.l	Obj16
                dc.l	Obj17
                dc.l	Obj18
		dc.l	Obj19
                dc.l	Obj1A
                dc.l	jmp_DeleteObject
                dc.l	Obj1C
		dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	Obj1F
                dc.l	jmp_DeleteObject
		dc.l	Obj21
                dc.l	Obj22
                dc.l	Obj23
                dc.l	Obj24
		dc.l	Obj25
                dc.l	Obj26
                dc.l	Obj27
                dc.l	Obj28
		dc.l	Obj29
                dc.l	Obj2A
                dc.l	Obj2B
                dc.l	Obj2C
		dc.l	jmp_DeleteObject
		dc.l	Obj2E
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
		dc.l	jmp_DeleteObject
		dc.l	jmp_DeleteObject
		dc.l	jmp_DeleteObject
		dc.l	Obj34
                dc.l	jmp_DeleteObject
		dc.l	Obj36
		dc.l	Obj37
		dc.l	Obj38
		dc.l	Obj39
                dc.l	Obj3A
                dc.l	Obj3B
                dc.l	Obj3C
		dc.l	Obj3D
                dc.l	Obj3E
                dc.l	Obj3F
                dc.l	Obj40
		dc.l	Obj41
                dc.l	Obj42
                dc.l	jmp_DeleteObject
                dc.l	Obj44
		dc.l	jmp_DeleteObject
		dc.l	jmp_DeleteObject
		dc.l	jmp_DeleteObject
		dc.l	Obj48
		dc.l	Obj49
                dc.l	Obj4A
                dc.l	Obj4B
                dc.l	Obj4C
		dc.l	Obj4D
                dc.l	Obj4E
                dc.l	Obj4F
                dc.l	Obj50
		dc.l	Obj51
                dc.l	Obj52
                dc.l	Obj53
                dc.l	Obj54
		dc.l	Obj55
                dc.l	Obj56
                dc.l	Obj57
                dc.l	Obj58
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	Obj79
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	Obj7D
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject
                dc.l	Obj8A
                dc.l	jmp_DeleteObject
                dc.l	jmp_DeleteObject

; ===============================================================================

jmp_DeleteObject:
		bra.w	DeleteObject

; =============== S U B R O U T I N E ==========================================


ObjectFall:
		move.l	8(a0),d2
		move.l	$C(a0),d3
		move.w	$10(a0),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,d2
		move.w	$12(a0),d0
		addi.w	#$38,$12(a0)
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,d3
		move.l	d2,8(a0)
		move.l	d3,$C(a0)
		rts


; =============== S U B R O U T I N E ==========================================


SpeedToPos:
		move.l	8(a0),d2
		move.l	$C(a0),d3
		move.w	$10(a0),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,d2
		move.w	$12(a0),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,d3
		move.l	d2,8(a0)
		move.l	d3,$C(a0)
		rts


; =============== S U B R O U T I N E ==========================================


DisplaySprite:
		lea	(RAM_SpriteTable).w,a1
		move.w	$18(a0),d0
		lsr.w	#1,d0
		andi.w	#$380,d0
		adda.w	d0,a1
		cmpi.w	#$7E,(a1)
		bcc.s	locret_CE20
		addq.w	#2,(a1)
		adda.w	(a1),a1
		move.w	a0,(a1)

locret_CE20:
		rts


; =============== S U B R O U T I N E ==========================================


DisplayA1Sprite:
		lea	(RAM_SpriteTable).w,a2
		move.w	$18(a1),d0
		lsr.w	#1,d0
		andi.w	#$380,d0
		adda.w	d0,a2
		cmpi.w	#$7E,(a2)
		bcc.s	locret_CE3E
		addq.w	#2,(a2)
		adda.w	(a2),a2
		move.w	a1,(a2)

locret_CE3E:
		rts

; ===============================================================================

DisplaySprite_Param:
		lea	(RAM_SpriteTable).w,a1
		lsr.w	#1,d0
		andi.w	#$380,d0
		adda.w	d0,a1
		cmpi.w	#$7E,(a1) ; '~'
		bcc.s	locret_CE58
		addq.w	#2,(a1)
		adda.w	(a1),a1
		move.w	a0,(a1)

locret_CE58:
		rts
; ===============================================================================

MarkObjGone:
		tst.w	(RAM_Flag_SplitScreen).w
		beq.s	loc_CE64
		bra.w	DisplaySprite
; ===============================================================================

loc_CE64:
		move.w	8(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_CE7C
		bra.w	DisplaySprite
; ===============================================================================

loc_CE7C:
		lea	(RAM_ObjRespawnTbl).w,a2
		moveq	#0,d0
		move.b	$23(a0),d0
		beq.s	loc_CE8E
		bclr	#7,2(a2,d0.w)

loc_CE8E:
		bra.w	DeleteObject
; ===============================================================================

loc_CE92:
		tst.w	(RAM_Flag_SplitScreen).w
		beq.s	loc_CE9A
		rts
; ===============================================================================

loc_CE9A:
		move.w	8(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_CEB0
		rts
; ===============================================================================

loc_CEB0:
		lea	(RAM_ObjRespawnTbl).w,a2
		moveq	#0,d0
		move.b	$23(a0),d0
		beq.s	loc_CEC2
		bclr	#7,2(a2,d0.w)

loc_CEC2:
		bra.w	DeleteObject
; ===============================================================================

loc_CEC6:
		tst.w	(RAM_Flag_SplitScreen).w
		bne.s	loc_CEFA
		move.w	8(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_CEE4
		bra.w	DisplaySprite
; ===============================================================================

loc_CEE4:
		lea	(RAM_ObjRespawnTbl).w,a2
		moveq	#0,d0
		move.b	$23(a0),d0
		beq.s	loc_CEF6
		bclr	#7,2(a2,d0.w)

loc_CEF6:
		bra.w	DeleteObject
; ===============================================================================

loc_CEFA:
		move.w	8(a0),d0
		andi.w	#$FF80,d0
		move.w	d0,d1
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_CF14
		bra.w	DisplaySprite
; ===============================================================================

loc_CF14:
		sub.w	(RAM_ObjPos_DelSpr_2p).w,d1
		cmpi.w	#$280,d1
		bhi.w	loc_CF24
		bra.w	DisplaySprite
; ===============================================================================

loc_CF24:
		lea	(RAM_ObjRespawnTbl).w,a2
		moveq	#0,d0
		move.b	$23(a0),d0
		beq.s	loc_CF36
		bclr	#7,2(a2,d0.w)

loc_CF36:
		bra.w	DeleteObject	; *+4

; =============== S U B R O U T I N E ==========================================


DeleteObject:
		movea.l	a0,a1

sub_CF3C:
		moveq	#0,d1
		moveq	#$F,d0

loc_CF40:
		move.l	d1,(a1)+
		dbf	d0,loc_CF40
		rts


; =============== S U B R O U T I N E ==========================================


AnimateSprite:
		moveq	#0,d0
		move.b	$1C(a0),d0
		cmp.b	$1D(a0),d0
		beq.s	loc_CF64
		move.b	d0,$1D(a0)
		move.b	#0,$1B(a0)
		move.b	#0,$1E(a0)

loc_CF64:
		subq.b	#1,$1E(a0)
		bpl.s	locret_CFA4
		add.w	d0,d0
		adda.w	(a1,d0.w),a1
		move.b	(a1),$1E(a0)
		moveq	#0,d1
		move.b	$1B(a0),d1
		move.b	1(a1,d1.w),d0
		bmi.s	loc_CFA6

loc_CF80:
		move.b	d0,d1
		andi.b	#$1F,d0
		move.b	d0,$1A(a0)
		move.b	$22(a0),d0
		rol.b	#3,d1
		eor.b	d0,d1
		andi.b	#3,d1
		andi.b	#$FC,1(a0)
		or.b	d1,1(a0)
		addq.b	#1,$1B(a0)

locret_CFA4:
		rts
; ===============================================================================

loc_CFA6:
		addq.b	#1,d0
		bne.s	loc_CFB6
		move.b	#0,$1B(a0)
		move.b	1(a1),d0
		bra.s	loc_CF80
; ===============================================================================

loc_CFB6:
		addq.b	#1,d0
		bne.s	loc_CFCA
		move.b	2(a1,d1.w),d0
		sub.b	d0,$1B(a0)
		sub.b	d0,d1
		move.b	1(a1,d1.w),d0
		bra.s	loc_CF80
; ===============================================================================

loc_CFCA:
		addq.b	#1,d0
		bne.s	loc_CFD6
		move.b	2(a1,d1.w),$1C(a0)
		rts
; ===============================================================================

loc_CFD6:
		addq.b	#1,d0
		bne.s	loc_CFE0
		addq.b	#2,$24(a0)
		rts
; ===============================================================================

loc_CFE0:
		addq.b	#1,d0
		bne.s	loc_CFF0
		move.b	#0,$1B(a0)
		clr.b	$25(a0)
		rts
; ===============================================================================

loc_CFF0:
		addq.b	#1,d0
		bne.s	locret_CFFA
		addq.b	#2,$25(a0)
		rts
; ===============================================================================

locret_CFFA:
		rts

; ===============================================================================
BldSpr_ScrPos:	dc.l 0
		dc.l RAM_LevelSys_Buff
		dc.l RAM_LevelSys_Buff+$8
		dc.l RAM_LevelSys_Buff+$18

; =============== S U B R O U T I N E ==========================================


BuildSprites:
		tst.w	(RAM_Flag_SplitScreen).w
		bne.w	BuildSprites_2p
		lea	(RAM_SprAttrTable).w,a2
		moveq	#0,d5
		moveq	#0,d4
		tst.b	(RAM_Flag_BuildSpr_Unk).w
		beq.s	loc_D026
		bsr.w	BuildSprites2

loc_D026:
		lea	(RAM_SpriteTable).w,a4
		moveq	#7,d7

loc_D02C:
		tst.w	(a4)
		beq.w	loc_D102
		moveq	#2,d6

loc_D034:
		movea.w	(a4,d6.w),a0
		tst.b	(a0)
		beq.w	loc_D124
		tst.l	4(a0)
		beq.w	loc_D124
		andi.b	#$7F,1(a0)
		move.b	1(a0),d0
		move.b	d0,d4
		btst	#6,d0
		bne.w	loc_D126
		andi.w	#$C,d0
		beq.s	loc_D0B2
		movea.l	BldSpr_ScrPos(pc,d0.w),a1
		moveq	#0,d0
		move.b	$19(a0),d0
		move.w	8(a0),d3
		sub.w	(a1),d3
		move.w	d3,d1
		add.w	d0,d1
		bmi.w	loc_D0FA
		move.w	d3,d1
		sub.w	d0,d1
		cmpi.w	#$140,d1
		bge.w	loc_D0FA
		addi.w	#$80,d3
		btst	#4,d4
		beq.s	loc_D0BC
		moveq	#0,d0
		move.b	$16(a0),d0
		move.w	$C(a0),d2
		sub.w	4(a1),d2
		move.w	d2,d1
		add.w	d0,d1
		bmi.s	loc_D0FA
		move.w	d2,d1
		sub.w	d0,d1
		cmpi.w	#$E0,d1
		bge.s	loc_D0FA
		addi.w	#$80,d2
		bra.s	loc_D0D4
; ===============================================================================

loc_D0B2:
		move.w	$A(a0),d2
		move.w	8(a0),d3
		bra.s	loc_D0D4
; ===============================================================================

loc_D0BC:
		move.w	$C(a0),d2
		sub.w	4(a1),d2
		addi.w	#$80,d2
		cmpi.w	#$60,d2
		bcs.s	loc_D0FA
		cmpi.w	#$180,d2
		bcc.s	loc_D0FA

loc_D0D4:
		movea.l	4(a0),a1
		moveq	#0,d1
		btst	#5,d4
		bne.s	loc_D0F0
		move.b	$1A(a0),d1
		add.w	d1,d1
		adda.w	(a1,d1.w),a1
		move.w	(a1)+,d1
		subq.w	#1,d1
		bmi.s	loc_D0F4

loc_D0F0:
		bsr.w	sub_D1B6

loc_D0F4:
		ori.b	#$80,1(a0)

loc_D0FA:
		addq.w	#2,d6
		subq.w	#2,(a4)
		bne.w	loc_D034

loc_D102:
		lea	$80(a4),a4
		dbf	d7,loc_D02C
		move.b	d5,(RAM_Debug_MaxSprites).w
		cmpi.b	#$50,d5
		beq.s	loc_D11C
		move.l	#0,(a2)
		rts
; ===============================================================================

loc_D11C:
		move.b	#0,-5(a2)
		rts
; ===============================================================================

loc_D124:
		bra.s	loc_D0FA
; ===============================================================================

loc_D126:
		move.l	a4,-(sp)
		lea	(RAM_LevelSys_Buff).w,a4
		movea.w	2(a0),a3
		movea.l	4(a0),a5
		moveq	#0,d0
		move.b	$E(a0),d0
		move.w	8(a0),d3
		sub.w	(a4),d3
		move.w	d3,d1
		add.w	d0,d1
		bmi.w	loc_D1B0
		move.w	d3,d1
		sub.w	d0,d1
		cmpi.w	#$140,d1
		bge.s	loc_D1B0
		move.w	$C(a0),d2
		sub.w	4(a4),d2
		addi.w	#$80,d2
		cmpi.w	#$60,d2
		bcs.s	loc_D1B0
		cmpi.w	#$180,d2
		bcc.s	loc_D1B0
		ori.b	#$80,1(a0)
		lea	$10(a0),a6
		moveq	#0,d0
		move.b	$F(a0),d0
		subq.w	#1,d0
		bcs.s	loc_D1B0

loc_D17E:
		swap	d0
		move.w	(a6)+,d3
		sub.w	(a4),d3
		addi.w	#$80,d3
		move.w	(a6)+,d2
		sub.w	4(a4),d2
		addi.w	#$80,d2
		addq.w	#1,a6
		moveq	#0,d1
		move.b	(a6)+,d1
		add.w	d1,d1
		movea.l	a5,a1
		adda.w	(a1,d1.w),a1
		move.w	(a1)+,d1
		subq.w	#1,d1
		bmi.s	loc_D1AA
		bsr.w	sub_D1BA

loc_D1AA:
		swap	d0
		dbf	d0,loc_D17E

loc_D1B0:
		movea.l	(sp)+,a4
		bra.w	loc_D0FA


; =============== S U B R O U T I N E ==========================================


sub_D1B6:
		movea.w	2(a0),a3

sub_D1BA:
		cmpi.b	#$50,d5	; 'P'
		bcc.s	locret_D1F6
		btst	#0,d4
		bne.s	loc_D1F8
		btst	#1,d4
		bne.w	loc_D258

loc_D1CE:
		move.b	(a1)+,d0
		ext.w	d0
		add.w	d2,d0
		move.w	d0,(a2)+
		move.b	(a1)+,(a2)+
		addq.b	#1,d5
		move.b	d5,(a2)+
		move.w	(a1)+,d0
		add.w	a3,d0
		move.w	d0,(a2)+
		addq.w	#2,a1
		move.w	(a1)+,d0
		add.w	d3,d0
		andi.w	#$1FF,d0
		bne.s	loc_D1F0
		addq.w	#1,d0

loc_D1F0:
		move.w	d0,(a2)+
		dbf	d1,loc_D1CE

locret_D1F6:
		rts
; ===============================================================================

loc_D1F8:
		btst	#1,d4
		bne.w	loc_D2A0

loc_D200:
		move.b	(a1)+,d0
		ext.w	d0
		add.w	d2,d0
		move.w	d0,(a2)+
		move.b	(a1)+,d4
		move.b	d4,(a2)+
		addq.b	#1,d5
		move.b	d5,(a2)+
		move.w	(a1)+,d0
		add.w	a3,d0
		eori.w	#$800,d0
		move.w	d0,(a2)+
		addq.w	#2,a1
		move.w	(a1)+,d0
		neg.w	d0
		move.b	byte_D238(pc,d4.w),d4
		sub.w	d4,d0
		add.w	d3,d0
		andi.w	#$1FF,d0
		bne.s	loc_D230
		addq.w	#1,d0

loc_D230:
		move.w	d0,(a2)+
		dbf	d1,loc_D200
		rts
; ===============================================================================
byte_D238:	dc.b   8,  8,  8,  8	; 0
		dc.b $10,$10,$10,$10	; 4
		dc.b $18,$18,$18,$18	; 8
		dc.b $20,$20,$20,$20	; 12
byte_D248:	dc.b   8,$10,$18,$20	; 0
		dc.b   8,$10,$18,$20	; 4
		dc.b   8,$10,$18,$20	; 8
		dc.b   8,$10,$18,$20	; 12
; ===============================================================================

loc_D258:
		move.b	(a1)+,d0
		move.b	(a1),d4
		ext.w	d0
		neg.w	d0
		move.b	byte_D248(pc,d4.w),d4
		sub.w	d4,d0
		add.w	d2,d0
		move.w	d0,(a2)+
		move.b	(a1)+,(a2)+
		addq.b	#1,d5
		move.b	d5,(a2)+
		move.w	(a1)+,d0
		add.w	a3,d0
		eori.w	#$1000,d0
		move.w	d0,(a2)+
		addq.w	#2,a1
		move.w	(a1)+,d0
		add.w	d3,d0
		andi.w	#$1FF,d0
		bne.s	loc_D288
		addq.w	#1,d0

loc_D288:
		move.w	d0,(a2)+
		dbf	d1,loc_D258
		rts
; ===============================================================================
byte_D290:	dc.b   8,$10,$18,$20	; 0
		dc.b   8,$10,$18,$20	; 4
		dc.b   8,$10,$18,$20	; 8
		dc.b   8,$10,$18,$20	; 12
; ===============================================================================

loc_D2A0:
		move.b	(a1)+,d0
		move.b	(a1),d4
		ext.w	d0
		neg.w	d0
		move.b	byte_D290(pc,d4.w),d4
		sub.w	d4,d0
		add.w	d2,d0
		move.w	d0,(a2)+
		move.b	(a1)+,d4
		move.b	d4,(a2)+
		addq.b	#1,d5
		move.b	d5,(a2)+
		move.w	(a1)+,d0
		add.w	a3,d0
		eori.w	#$1800,d0
		move.w	d0,(a2)+
		addq.w	#2,a1
		move.w	(a1)+,d0
		neg.w	d0
		move.b	byte_D2E2(pc,d4.w),d4
		sub.w	d4,d0
		add.w	d3,d0
		andi.w	#$1FF,d0
		bne.s	loc_D2DA
		addq.w	#1,d0

loc_D2DA:
		move.w	d0,(a2)+
		dbf	d1,loc_D2A0
		rts

; ===============================================================================
byte_D2E2:	dc.b   8,  8,  8,  8
		dc.b $10,$10,$10,$10
		dc.b $18,$18,$18,$18
		dc.b $20,$20,$20,$20

BldSpr_ScrPos_2p:
		dc.l 0
		dc.l RAM_LevelSys_Buff
		dc.l RAM_LevelSys_Buff+$8
		dc.l RAM_LevelSys_Buff+$18
; ===============================================================================

BuildSprites_2p:
		tst.w	(RAM_Flag_VDP_VIntFlag).w
		bne.s	BuildSprites_2p
		lea	(RAM_SprAttrTable).w,a2
		moveq	#2,d5
		moveq	#0,d4
		move.l	#$1D80F01,(a2)+
		move.l	#1,(a2)+
		move.l	#$1D80F02,(a2)+
		move.l	#0,(a2)+
		tst.b	(RAM_Flag_BuildSpr_Unk).w
		beq.s	loc_D332
		bsr.w	BuildSprites2_2p

loc_D332:
		lea	(RAM_SpriteTable).w,a4
		moveq	#7,d7

loc_D338:
		move.w	(a4),d0
		beq.w	loc_D410
		move.w	d0,-(sp)
		moveq	#2,d6

loc_D342:
		movea.w	(a4,d6.w),a0
		tst.b	(a0)
		beq.w	loc_D406
		andi.b	#$7F,1(a0)
		move.b	1(a0),d0
		move.b	d0,d4
		btst	#6,d0
		bne.w	loc_D54A
		andi.w	#$C,d0
		beq.s	loc_D3B6
		movea.l	BldSpr_ScrPos_2p(pc,d0.w),a1
		moveq	#0,d0
		move.b	$19(a0),d0
		move.w	8(a0),d3
		sub.w	(a1),d3
		move.w	d3,d1
		add.w	d0,d1
		bmi.w	loc_D406
		move.w	d3,d1
		sub.w	d0,d1
		cmpi.w	#$140,d1
		bge.s	loc_D406
		addi.w	#$80,d3
		btst	#4,d4
		beq.s	loc_D3C4
		moveq	#0,d0
		move.b	$16(a0),d0
		move.w	$C(a0),d2
		sub.w	4(a1),d2
		move.w	d2,d1
		add.w	d0,d1
		bmi.s	loc_D406
		move.w	d2,d1
		sub.w	d0,d1
		cmpi.w	#$E0,d1
		bge.s	loc_D406
		addi.w	#$100,d2
		bra.s	loc_D3E0
; ===============================================================================

loc_D3B6:
		move.w	$A(a0),d2
		move.w	8(a0),d3
		addi.w	#$80,d2
		bra.s	loc_D3E0
; ===============================================================================

loc_D3C4:
		move.w	$C(a0),d2
		sub.w	4(a1),d2
		addi.w	#$80,d2
		cmpi.w	#$60,d2
		bcs.s	loc_D406
		cmpi.w	#$180,d2
		bcc.s	loc_D406
		addi.w	#$80,d2

loc_D3E0:
		movea.l	4(a0),a1
		moveq	#0,d1
		btst	#5,d4
		bne.s	loc_D3FC
		move.b	$1A(a0),d1
		add.w	d1,d1
		adda.w	(a1,d1.w),a1
		move.w	(a1)+,d1
		subq.w	#1,d1
		bmi.s	loc_D400

loc_D3FC:				; CODE XREF: BuildSprites+3DEj
		bsr.w	sub_D6A2

loc_D400:				; CODE XREF: BuildSprites+3EEj
		ori.b	#$80,1(a0)

loc_D406:				; CODE XREF: BuildSprites+33Cj
					; BuildSprites+36Ej ...
		addq.w	#2,d6
		subq.w	#2,(sp)
		bne.w	loc_D342
		addq.w	#2,sp

loc_D410:				; CODE XREF: BuildSprites+32Ej
		lea	$80(a4),a4
		dbf	d7,loc_D338
		move.b	d5,(RAM_Debug_MaxSprites).w
		cmpi.b	#$50,d5	; 'P'
		bcc.s	loc_D42A
		move.l	#0,(a2)
		bra.s	loc_D442
; ===============================================================================

loc_D42A:				; CODE XREF: BuildSprites+414j
		move.b	#0,-5(a2)
		bra.s	loc_D442
; END OF FUNCTION CHUNK	FOR BuildSprites
; ===============================================================================
dword_D432:	dc.l 0
		dc.l RAM_LevelSys_Buff_2P
		dc.l RAM_LevelSys_Buff_2p+$8
		dc.l RAM_LevelSys_Buff_2p+$18
; ===============================================================================
; START	OF FUNCTION CHUNK FOR BuildSprites

loc_D442:				; CODE XREF: BuildSprites+41Cj
					; BuildSprites+424j
		lea	(RAM_SprAttrTable_2p).w,a2
		moveq	#0,d5
		moveq	#0,d4
		tst.b	(RAM_Flag_BuildSpr_Unk).w
		beq.s	loc_D454
		bsr.w	sub_DACA

loc_D454:				; CODE XREF: BuildSprites+442j
		lea	(RAM_SpriteTable).w,a4
		moveq	#7,d7

loc_D45A:				; CODE XREF: BuildSprites+520j
		tst.w	(a4)
		beq.w	loc_D528
		moveq	#2,d6

loc_D462:				; CODE XREF: BuildSprites+518j
		movea.w	(a4,d6.w),a0
		tst.b	(a0)
		beq.w	loc_D520
		move.b	1(a0),d0
		move.b	d0,d4
		btst	#6,d0
		bne.w	loc_D5DA
		andi.w	#$C,d0
		beq.s	loc_D4D0
		movea.l	dword_D432(pc,d0.w),a1
		moveq	#0,d0
		move.b	$19(a0),d0
		move.w	8(a0),d3
		sub.w	(a1),d3
		move.w	d3,d1
		add.w	d0,d1
		bmi.w	loc_D520
		move.w	d3,d1
		sub.w	d0,d1
		cmpi.w	#$140,d1
		bge.s	loc_D520
		addi.w	#$80,d3	; ''
		btst	#4,d4
		beq.s	loc_D4DE
		moveq	#0,d0
		move.b	$16(a0),d0
		move.w	$C(a0),d2
		sub.w	4(a1),d2
		move.w	d2,d1
		add.w	d0,d1
		bmi.s	loc_D520
		move.w	d2,d1
		sub.w	d0,d1
		cmpi.w	#$E0,d1	; ''
		bge.s	loc_D520
		addi.w	#$1E0,d2
		bra.s	loc_D4FA
; ===============================================================================

loc_D4D0:				; CODE XREF: BuildSprites+472j
		move.w	$A(a0),d2
		move.w	8(a0),d3
		addi.w	#$160,d2
		bra.s	loc_D4FA
; ===============================================================================

loc_D4DE:				; CODE XREF: BuildSprites+49Ej
		move.w	$C(a0),d2
		sub.w	4(a1),d2
		addi.w	#$80,d2	; ''
		cmpi.w	#$60,d2	; '`'
		bcs.s	loc_D520
		cmpi.w	#$180,d2
		bcc.s	loc_D520
		addi.w	#$160,d2

loc_D4FA:				; CODE XREF: BuildSprites+4C2j
					; BuildSprites+4D0j
		movea.l	4(a0),a1
		moveq	#0,d1
		btst	#5,d4
		bne.s	loc_D516
		move.b	$1A(a0),d1
		add.w	d1,d1
		adda.w	(a1,d1.w),a1
		move.w	(a1)+,d1
		subq.w	#1,d1
		bmi.s	loc_D51A

loc_D516:				; CODE XREF: BuildSprites+4F8j
		bsr.w	sub_D6A2

loc_D51A:				; CODE XREF: BuildSprites+508j
		ori.b	#$80,1(a0)

loc_D520:				; CODE XREF: BuildSprites+45Cj
					; BuildSprites+488j ...
		addq.w	#2,d6
		subq.w	#2,(a4)
		bne.w	loc_D462

loc_D528:				; CODE XREF: BuildSprites+450j
		lea	$80(a4),a4
		dbf	d7,loc_D45A
		move.b	d5,(RAM_Debug_MaxSprites).w
		cmpi.b	#$50,d5
		beq.s	loc_D542
		move.l	#0,(a2)
		rts
; ===============================================================================

loc_D542:				; CODE XREF: BuildSprites+52Cj
		move.b	#0,-5(a2)
		rts
; ===============================================================================

loc_D54A:				; CODE XREF: BuildSprites+350j
		move.l	a4,-(sp)
		lea	(RAM_LevelSys_Buff).w,a4
		movea.w	2(a0),a3
		movea.l	4(a0),a5
		moveq	#0,d0
		move.b	$E(a0),d0
		move.w	8(a0),d3
		sub.w	(a4),d3
		move.w	d3,d1
		add.w	d0,d1
		bmi.w	loc_D5D4
		move.w	d3,d1
		sub.w	d0,d1
		cmpi.w	#$140,d1
		bge.s	loc_D5D4
		move.w	$C(a0),d2
		sub.w	4(a4),d2
		addi.w	#$80,d2	; ''
		cmpi.w	#$60,d2	; '`'
		bcs.s	loc_D5D4
		cmpi.w	#$180,d2
		bcc.s	loc_D5D4
		ori.b	#$80,1(a0)
		lea	$10(a0),a6
		moveq	#0,d0
		move.b	$F(a0),d0
		subq.w	#1,d0
		bcs.s	loc_D5D4

loc_D5A2:				; CODE XREF: BuildSprites+5C4j
		swap	d0
		move.w	(a6)+,d3
		sub.w	(a4),d3
		addi.w	#$80,d3	; ''
		move.w	(a6)+,d2
		sub.w	4(a4),d2
		addi.w	#$100,d2
		addq.w	#1,a6
		moveq	#0,d1
		move.b	(a6)+,d1
		add.w	d1,d1
		movea.l	a5,a1
		adda.w	(a1,d1.w),a1
		move.w	(a1)+,d1
		subq.w	#1,d1
		bmi.s	loc_D5CE
		bsr.w	sub_D6A6

loc_D5CE:				; CODE XREF: BuildSprites+5BCj
		swap	d0
		dbf	d0,loc_D5A2

loc_D5D4:				; CODE XREF: BuildSprites+55Cj
					; BuildSprites+568j ...
		movea.l	(sp)+,a4
		bra.w	loc_D406
; ===============================================================================

loc_D5DA:				; CODE XREF: BuildSprites+46Aj
		move.l	a4,-(sp)
		lea	(RAM_LevelSys_Buff_2P).w,a4
		movea.w	2(a0),a3
		movea.l	4(a0),a5
		moveq	#0,d0
		move.b	$E(a0),d0
		move.w	8(a0),d3
		sub.w	(a4),d3
		move.w	d3,d1
		add.w	d0,d1
		bmi.w	loc_D664
		move.w	d3,d1
		sub.w	d0,d1
		cmpi.w	#$140,d1
		bge.s	loc_D664
		move.w	$C(a0),d2
		sub.w	4(a4),d2
		addi.w	#$80,d2	; ''
		cmpi.w	#$60,d2	; '`'
		bcs.s	loc_D664
		cmpi.w	#$180,d2
		bcc.s	loc_D664
		ori.b	#$80,1(a0)
		lea	$10(a0),a6
		moveq	#0,d0
		move.b	$F(a0),d0
		subq.w	#1,d0
		bcs.s	loc_D664

loc_D632:				; CODE XREF: BuildSprites+654j
		swap	d0
		move.w	(a6)+,d3
		sub.w	(a4),d3
		addi.w	#$80,d3	; ''
		move.w	(a6)+,d2
		sub.w	4(a4),d2
		addi.w	#$1E0,d2
		addq.w	#1,a6
		moveq	#0,d1
		move.b	(a6)+,d1
		add.w	d1,d1
		movea.l	a5,a1
		adda.w	(a1,d1.w),a1
		move.w	(a1)+,d1
		subq.w	#1,d1
		bmi.s	loc_D65E
		bsr.w	sub_D6A6

loc_D65E:				; CODE XREF: BuildSprites+64Cj
		swap	d0
		dbf	d0,loc_D632

loc_D664:				; CODE XREF: BuildSprites+5ECj
					; BuildSprites+5F8j ...
		movea.l	(sp)+,a4
		bra.w	loc_D520
; END OF FUNCTION CHUNK	FOR BuildSprites

; =============== S U B R O U T I N E ==========================================


ModifySpriteAttr_2P:			; CODE XREF: ROM:loc_7C14p
					; ROM:00008230p ...
		tst.w	(RAM_Flag_SplitScreen).w
		beq.s	locret_D684
		move.w	2(a0),d0
		andi.w	#$7FF,d0
		lsr.w	#1,d0
		andi.w	#$F800,2(a0)
		add.w	d0,2(a0)

locret_D684:				; CODE XREF: ModifySpriteAttr_2P+4j
		rts
; End of function ModifySpriteAttr_2P


; =============== S U B R O U T I N E ==========================================


ModifyA1SpriteAttr_2P:			; CODE XREF: ROM:0000870Ap
					; ROM:0000A858p ...
		tst.w	(RAM_Flag_SplitScreen).w
		beq.s	ModifySpriteAttr_Not2pmode
		move.w	2(a1),d0
		andi.w	#$7FF,d0
		lsr.w	#1,d0
		andi.w	#$F800,2(a1)
		add.w	d0,2(a1)

ModifySpriteAttr_Not2pmode:		; CODE XREF: ModifyA1SpriteAttr_2P+4j
		rts
; End of function ModifyA1SpriteAttr_2P


; =============== S U B R O U T I N E ==========================================


sub_D6A2:				; CODE XREF: BuildSprites:loc_D3FCp
					; BuildSprites:loc_D516p
		movea.w	2(a0),a3
; End of function sub_D6A2


; =============== S U B R O U T I N E ==========================================


sub_D6A6:				; CODE XREF: BuildSprites+5BEp
					; BuildSprites+64Ep
		cmpi.b	#$50,d5	; 'P'
		bcc.s	locret_D6E6
		btst	#0,d4
		bne.s	loc_D6F8
		btst	#1,d4
		bne.w	loc_D75A

loc_D6BA:				; CODE XREF: sub_D6A6+3Cj
		move.b	(a1)+,d0
		ext.w	d0
		add.w	d2,d0
		move.w	d0,(a2)+
		move.b	(a1)+,d4
		move.b	byte_D6E8(pc,d4.w),(a2)+
		addq.b	#1,d5
		move.b	d5,(a2)+
		addq.w	#2,a1
		move.w	(a1)+,d0
		add.w	a3,d0
		move.w	d0,(a2)+
		move.w	(a1)+,d0
		add.w	d3,d0
		andi.w	#$1FF,d0
		bne.s	loc_D6E0
		addq.w	#1,d0

loc_D6E0:				; CODE XREF: sub_D6A6+36j
		move.w	d0,(a2)+
		dbf	d1,loc_D6BA

locret_D6E6:				; CODE XREF: sub_D6A6+4j
		rts
; ===============================================================================
byte_D6E8:	dc.b   0,  0		; 0
		dc.b   1,  1		; 2
		dc.b   4,  4		; 4
		dc.b   5,  5		; 6
		dc.b   8,  8		; 8
		dc.b   9,  9		; 10
		dc.b  $C, $C		; 12
		dc.b  $D, $D		; 14
; ===============================================================================

loc_D6F8:				; CODE XREF: sub_D6A6+Aj
		btst	#1,d4
		bne.w	loc_D7B6

loc_D700:				; CODE XREF: sub_D6A6+8Ej
		move.b	(a1)+,d0
		ext.w	d0
		add.w	d2,d0
		move.w	d0,(a2)+
		move.b	(a1)+,d4
		move.b	byte_D6E8(pc,d4.w),(a2)+
		addq.b	#1,d5
		move.b	d5,(a2)+
		addq.w	#2,a1
		move.w	(a1)+,d0
		add.w	a3,d0
		eori.w	#$800,d0
		move.w	d0,(a2)+
		move.w	(a1)+,d0
		neg.w	d0
		move.b	byte_D73A(pc,d4.w),d4
		sub.w	d4,d0
		add.w	d3,d0
		andi.w	#$1FF,d0
		bne.s	loc_D732
		addq.w	#1,d0

loc_D732:				; CODE XREF: sub_D6A6+88j
		move.w	d0,(a2)+
		dbf	d1,loc_D700
		rts
; ===============================================================================
byte_D73A:	dc.b   8,  8		; 0
		dc.b   8,  8		; 2
		dc.b $10,$10		; 4
		dc.b $10,$10		; 6
		dc.b $18,$18		; 8
		dc.b $18,$18		; 10
		dc.b $20,$20		; 12
		dc.b $20,$20		; 14
byte_D74A:	dc.b   8,$10,$18,$20	; 0
		dc.b   8,$10,$18,$20	; 4
		dc.b   8,$10,$18,$20	; 8
		dc.b   8,$10,$18,$20	; 12
; ===============================================================================

loc_D75A:				; CODE XREF: sub_D6A6+10j sub_D6A6+EAj
		move.b	(a1)+,d0
		move.b	(a1),d4
		ext.w	d0
		neg.w	d0
		move.b	byte_D74A(pc,d4.w),d4
		sub.w	d4,d0
		add.w	d2,d0
		move.w	d0,(a2)+
		move.b	(a1)+,d4
		move.b	byte_D796(pc,d4.w),(a2)+
		addq.b	#1,d5
		move.b	d5,(a2)+
		addq.w	#2,a1
		move.w	(a1)+,d0
		add.w	a3,d0
		eori.w	#$1000,d0
		move.w	d0,(a2)+
		move.w	(a1)+,d0
		add.w	d3,d0
		andi.w	#$1FF,d0
		bne.s	loc_D78E
		addq.w	#1,d0

loc_D78E:				; CODE XREF: sub_D6A6+E4j
		move.w	d0,(a2)+
		dbf	d1,loc_D75A
		rts
; ===============================================================================
byte_D796:	dc.b   0,  0,  1,  1	; 0
		dc.b   4,  4,  5,  5	; 4
		dc.b   8,  8,  9,  9	; 8
		dc.b  $C, $C, $D, $D	; 12
byte_D7A6:	dc.b   8,$10,$18,$20	; 0
		dc.b   8,$10,$18,$20	; 4
		dc.b   8,$10,$18,$20	; 8
		dc.b   8,$10,$18,$20	; 12
; ===============================================================================

loc_D7B6:				; CODE XREF: sub_D6A6+56j
					; sub_D6A6+14Ej
		move.b	(a1)+,d0
		move.b	(a1),d4
		ext.w	d0
		neg.w	d0
		move.b	byte_D7A6(pc,d4.w),d4
		sub.w	d4,d0
		add.w	d2,d0
		move.w	d0,(a2)+
		move.b	(a1)+,d4
		move.b	byte_D796(pc,d4.w),(a2)+
		addq.b	#1,d5
		move.b	d5,(a2)+
		addq.w	#2,a1
		move.w	(a1)+,d0
		add.w	a3,d0
		eori.w	#$1800,d0
		move.w	d0,(a2)+
		move.w	(a1)+,d0
		neg.w	d0
		move.b	byte_D7FA(pc,d4.w),d4
		sub.w	d4,d0
		add.w	d3,d0
		andi.w	#$1FF,d0
		bne.s	loc_D7F2
		addq.w	#1,d0

loc_D7F2:				; CODE XREF: sub_D6A6+148j
		move.w	d0,(a2)+
		dbf	d1,loc_D7B6
		rts
; End of function sub_D6A6

; ===============================================================================
byte_D7FA:	dc.b   8,  8,  8,  8	; 0
		dc.b $10,$10,$10,$10	; 4
		dc.b $18,$18,$18,$18	; 8
		dc.b $20,$20,$20,$20	; 12
		dc.b $30,$28,  0,  8	; 16
; ===============================================================================
		sub.w	(RAM_LevelSys_Buff).w,d0
		bmi.s	loc_D82E
		cmpi.w	#$140,d0
		bge.s	loc_D82E
		move.w	$C(a0),d1
		sub.w	(RAM_LevelSys_Buff+$4).w,d1
		bmi.s	loc_D82E
		cmpi.w	#$E0,d1	; ''
		bge.s	loc_D82E
		moveq	#0,d0
		rts
; ===============================================================================

loc_D82E:				; CODE XREF: ROM:0000D812j
					; ROM:0000D818j ...
		moveq	#1,d0
		rts
; ===============================================================================
		moveq	#0,d1
		move.b	$19(a0),d1
		move.w	8(a0),d0
		sub.w	(RAM_LevelSys_Buff).w,d0
		add.w	d1,d0
		bmi.s	loc_D862
		add.w	d1,d1
		sub.w	d1,d0
		cmpi.w	#$140,d0
		bge.s	loc_D862
		move.w	$C(a0),d1
		sub.w	(RAM_LevelSys_Buff+$4).w,d1
		bmi.s	loc_D862
		cmpi.w	#$E0,d1	; ''
		bge.s	loc_D862
		moveq	#0,d0
		rts
; ===============================================================================

loc_D862:				; CODE XREF: ROM:0000D842j
					; ROM:0000D84Cj ...
		moveq	#1,d0
		rts
; ===============================================================================
		nop

; =============== S U B R O U T I N E ==========================================


RingPosLoad:
		moveq	#0,d0
		move.b	(RAM_RingSys_Routine).w,d0
		move.w	RPL_Index(pc,d0.w),d0
		jmp	RPL_Index(pc,d0.w)

; ===============================================================================
RPL_Index:	dc.w RPL_Main-RPL_Index
		dc.w RPL_Next-RPL_Index
; ===============================================================================

RPL_Main:
		addq.b	#2,(RAM_RingSys_Routine).w
		bsr.w	RingPosLoad2
		lea	(RAM_RingSys_Buffer).w,a1
		move.w	(RAM_LevelSys_Buff).w,d4
		subq.w	#8,d4
		bhi.s	loc_D896
		moveq	#1,d4
		bra.s	loc_D896
; ===============================================================================

loc_D892:
		lea	6(a1),a1

loc_D896:
		cmp.w	2(a1),d4
		bhi.s	loc_D892
		move.w	a1,(RAM_RingSys_Addr_1).w
		move.w	a1,(RAM_RingSys_Addr_1_2p).w
		addi.w	#$150,d4
		bra.s	loc_D8AE
; ===============================================================================

loc_D8AA:
		lea	6(a1),a1

loc_D8AE:
		cmp.w	2(a1),d4
		bhi.s	loc_D8AA
		move.w	a1,(RAM_RingSys_Addr_2).w
		move.w	a1,(RAM_RingSys_Addr_2_2p).w
		move.b	#1,(RAM_Flag_BuildSpr_Unk).w
		rts
; ===============================================================================

RPL_Next:
		lea	(RAM_RingSys_Buffer).w,a1
		move.w	#$FF,d1

loc_D8CC:
		move.b	(a1),d0
		beq.s	loc_D8EA
		bmi.s	loc_D8EA
		subq.b	#1,(a1)
		bne.s	loc_D8EA
		move.b	#6,(a1)
		addq.b	#1,1(a1)
		cmpi.b	#8,1(a1)
		bne.s	loc_D8EA
		move.w	#$FFFF,(a1)

loc_D8EA:
		lea	6(a1),a1
		dbf	d1,loc_D8CC
		movea.w	(RAM_RingSys_Addr_1).w,a1
		move.w	(RAM_LevelSys_Buff).w,d4
		subq.w	#8,d4
		bhi.s	loc_D906
		moveq	#1,d4
		bra.s	loc_D906
; ===============================================================================

loc_D902:
		lea	6(a1),a1

loc_D906:
		cmp.w	2(a1),d4
		bhi.s	loc_D902
		bra.s	loc_D910
; ===============================================================================

loc_D90E:
		subq.w	#6,a1

loc_D910:
		cmp.w	-4(a1),d4
		bls.s	loc_D90E
		move.w	a1,(RAM_RingSys_Addr_1).w
		movea.w	(RAM_RingSys_Addr_2).w,a2
		addi.w	#$150,d4
		bra.s	loc_D928
; ===============================================================================

loc_D924:
		lea	6(a2),a2

loc_D928:
		cmp.w	2(a2),d4
		bhi.s	loc_D924
		bra.s	loc_D932
; ===============================================================================

loc_D930:
		subq.w	#6,a2

loc_D932:
		cmp.w	-4(a2),d4
		bls.s	loc_D930
		move.w	a2,(RAM_RingSys_Addr_2).w
		tst.w	(RAM_Flag_SplitScreen).w
		bne.s	loc_D94C
		move.w	a1,(RAM_RingSys_Addr_1_2p).w
		move.w	a2,(RAM_RingSys_Addr_2_2p).w
		rts
; ===============================================================================

loc_D94C:
		movea.w	(RAM_RingSys_Addr_1_2p).w,a1
		move.w	(RAM_LevelSys_Buff_2P).w,d4
		subq.w	#8,d4
		bhi.s	loc_D960
		moveq	#1,d4
		bra.s	loc_D960
; ===============================================================================

loc_D95C:
		lea	6(a1),a1

loc_D960:
		cmp.w	2(a1),d4
		bhi.s	loc_D95C
		bra.s	loc_D96A
; ===============================================================================

loc_D968:
		subq.w	#6,a1

loc_D96A:
		cmp.w	-4(a1),d4
		bls.s	loc_D968
		move.w	a1,(RAM_RingSys_Addr_1_2p).w
		movea.w	(RAM_RingSys_Addr_2_2p).w,a2
		addi.w	#$150,d4
		bra.s	loc_D982
; ===============================================================================

loc_D97E:
		lea	6(a2),a2

loc_D982:
		cmp.w	2(a2),d4
		bhi.s	loc_D97E
		bra.s	loc_D98C
; ===============================================================================

loc_D98A:
		subq.w	#6,a2

loc_D98C:
		cmp.w	-4(a2),d4
		bls.s	loc_D98A
		move.w	a2,(RAM_RingSys_Addr_2_2p).w
		rts

; =============== S U B R O U T I N E ==========================================


sub_D998:
		movea.w	(RAM_RingSys_Addr_1).w,a1
		movea.w	(RAM_RingSys_Addr_2).w,a2
		cmpa.w	#$B000,a0
		beq.s	loc_D9AE
		movea.w	(RAM_RingSys_Addr_1_2p).w,a1
		movea.w	(RAM_RingSys_Addr_2_2p).w,a2

loc_D9AE:
		cmpa.l	a1,a2
		beq.w	locret_DA36
		cmpi.w	#$5A,$30(a0)
		bcc.s	locret_DA36
		move.w	8(a0),d2
		move.w	$C(a0),d3
		subi.w	#8,d2
		moveq	#0,d5
		move.b	$16(a0),d5
		subq.b	#3,d5
		sub.w	d5,d3
		cmpi.b	#$39,$1A(a0)
		bne.s	loc_D9E0
		addi.w	#$C,d3
		moveq	#$A,d5

loc_D9E0:
		move.w	#6,d1
		move.w	#$C,d6
		move.w	#$10,d4
		add.w	d5,d5

loc_D9EE:
		tst.w	(a1)
		bne.w	loc_DA2C
		move.w	2(a1),d0
		sub.w	d1,d0
		sub.w	d2,d0
		bcc.s	loc_DA06
		add.w	d6,d0
		bcs.s	loc_DA0C
		bra.w	loc_DA2C
; ===============================================================================

loc_DA06:
		cmp.w	d4,d0
		bhi.w	loc_DA2C

loc_DA0C:
		move.w	4(a1),d0
		sub.w	d1,d0
		sub.w	d3,d0
		bcc.s	loc_DA1E
		add.w	d6,d0
		bcs.s	loc_DA24
		bra.w	loc_DA2C
; ===============================================================================

loc_DA1E:
		cmp.w	d5,d0
		bhi.w	loc_DA2C

loc_DA24:
		move.w	#$604,(a1)
		bsr.w	sub_A8DE

loc_DA2C:
		lea	6(a1),a1
		cmpa.l	a1,a2
		bne.w	loc_D9EE

locret_DA36:
		rts


; =============== S U B R O U T I N E ==========================================


BuildSprites2:
		movea.w	(RAM_RingSys_Addr_1).w,a0
		movea.w	(RAM_RingSys_Addr_2).w,a4
		cmpa.l	a0,a4
		bne.s	loc_DA46
		rts
; ===============================================================================

loc_DA46:
		lea	(RAM_LevelSys_Buff).w,a3

loc_DA4A:
		tst.w	(a0)
		bmi.w	loc_DAA8
		move.w	2(a0),d3
		sub.w	(a3),d3
		addi.w	#$80,d3
		move.w	4(a0),d2
		sub.w	4(a3),d2
		addi.w	#8,d2
		bmi.s	loc_DAA8
		cmpi.w	#$F0,d2
		bge.s	loc_DAA8
		addi.w	#$78,d2
		lea	(off_DC04).l,a1
		moveq	#0,d1
		move.b	1(a0),d1
		bne.s	loc_DA84
		move.b	(RAM_ObjSpecial_RingFrame_4).w,d1

loc_DA84:
		add.w	d1,d1
		adda.w	(a1,d1.w),a1
		move.b	(a1)+,d0
		ext.w	d0
		add.w	d2,d0
		move.w	d0,(a2)+
		move.b	(a1)+,(a2)+
		addq.b	#1,d5
		move.b	d5,(a2)+
		move.w	(a1)+,d0
		addi.w	#$26BC,d0
		move.w	d0,(a2)+
		addq.w	#2,a1
		move.w	(a1)+,d0
		add.w	d3,d0
		move.w	d0,(a2)+

loc_DAA8:
		lea	6(a0),a0
		cmpa.l	a0,a4
		bne.w	loc_DA4A
		rts


; =============== S U B R O U T I N E ==========================================


BuildSprites2_2p:
		lea	(RAM_LevelSys_Buff).w,a3
		move.w	#$78,d6
		movea.w	(RAM_RingSys_Addr_1).w,a0
		movea.w	(RAM_RingSys_Addr_2).w,a4
		cmpa.l	a0,a4
		bne.s	loc_DAE0
		rts


; =============== S U B R O U T I N E ==========================================


sub_DACA:
		lea	(RAM_LevelSys_Buff_2P).w,a3
		move.w	#$158,d6
		movea.w	(RAM_RingSys_Addr_1_2p).w,a0
		movea.w	(RAM_RingSys_Addr_2_2p).w,a4
		cmpa.l	a0,a4
		bne.s	loc_DAE0
		rts
; ===============================================================================

loc_DAE0:
		tst.w	(a0)
		bmi.w	loc_DB40
		move.w	2(a0),d3
		sub.w	(a3),d3
		addi.w	#$80,d3
		move.w	4(a0),d2
		sub.w	4(a3),d2
		addi.w	#$88,d2
		bmi.s	loc_DB40
		cmpi.w	#$170,d2
		bge.s	loc_DB40
		add.w	d6,d2
		lea	(off_DC04).l,a1
		moveq	#0,d1
		move.b	1(a0),d1
		bne.s	loc_DB18
		move.b	(RAM_ObjSpecial_RingFrame_4).w,d1

loc_DB18:
		add.w	d1,d1
		adda.w	(a1,d1.w),a1
		move.b	(a1)+,d0
		ext.w	d0
		add.w	d2,d0
		move.w	d0,(a2)+
		move.b	(a1)+,d4
		move.b	byte_DB4C(pc,d4.w),(a2)+
		addq.b	#1,d5
		move.b	d5,(a2)+
		addq.w	#2,a1
		move.w	(a1)+,d0
		addi.w	#$235E,d0
		move.w	d0,(a2)+
		move.w	(a1)+,d0
		add.w	d3,d0
		move.w	d0,(a2)+

loc_DB40:
		lea	6(a0),a0
		cmpa.l	a0,a4
		bne.w	loc_DAE0
		rts

; ===============================================================================
byte_DB4C:	dc.b   0,  0,  1,  1	; 0
		dc.b   4,  4,  5,  5	; 4
		dc.b   8,  8,  9,  9	; 8
		dc.b  $C, $C, $D, $D	; 12

; =============== S U B R O U T I N E ==========================================


RingPosLoad2:				; CODE XREF: ROM:0000D87Ep
		lea	(RAM_RingSys_Buffer).w,a1
		moveq	#0,d0
		move.w	#$17F,d1

loc_DB66:				; CODE XREF: RingPosLoad2+Cj
		move.l	d0,(a1)+
		dbf	d1,loc_DB66
		moveq	#0,d0
		move.w	(RAM_Level_CurrentZone).w,d0
		lsl.b	#6,d0
		lsr.w	#5,d0
		lea	(RingPos_Index).l,a1
		move.w	(a1,d0.w),d0
		lea	(a1,d0.w),a1
		lea	(RAM_RingSys_Buffer+$6).w,a2

loc_DB88:				; CODE XREF: RingPosLoad2+50j
					; RingPosLoad2+6Ej
		move.w	(a1)+,d2
		bmi.s	loc_DBCC
		move.w	(a1)+,d3
		bmi.s	loc_DBAE
		move.w	d3,d0
		rol.w	#4,d0
		andi.w	#7,d0
		andi.w	#$FFF,d3

loc_DB9C:				; CODE XREF: RingPosLoad2+4Cj
		move.w	#0,(a2)+
		move.w	d2,(a2)+
		move.w	d3,(a2)+
		addi.w	#$18,d2
		dbf	d0,loc_DB9C
		bra.s	loc_DB88
; ===============================================================================

loc_DBAE:				; CODE XREF: RingPosLoad2+32j
		move.w	d3,d0
		rol.w	#4,d0
		andi.w	#7,d0
		andi.w	#$FFF,d3

loc_DBBA:				; CODE XREF: RingPosLoad2+6Aj
		move.w	#0,(a2)+
		move.w	d2,(a2)+
		move.w	d3,(a2)+
		addi.w	#$18,d3
		dbf	d0,loc_DBBA
		bra.s	loc_DB88
; ===============================================================================

loc_DBCC:				; CODE XREF: RingPosLoad2+2Ej
		moveq	#$FFFFFFFF,d0
		move.l	d0,(a2)+
		lea	(RAM_RingSys_Buffer+$2).w,a1
		move.w	#$FE,d3	; ''

loc_DBD8:				; CODE XREF: RingPosLoad2+A2j
		move.w	d3,d4
		lea	6(a1),a2
		move.w	(a1),d0

loc_DBE0:				; CODE XREF: RingPosLoad2+9Aj
		tst.w	(a2)
		beq.s	loc_DBF2
		cmp.w	(a2),d0
		bls.s	loc_DBF2
		move.l	(a1),d1
		move.l	(a2),d0
		move.l	d0,(a1)
		move.l	d1,(a2)
		swap	d0

loc_DBF2:				; CODE XREF: RingPosLoad2+86j
					; RingPosLoad2+8Aj
		lea	6(a2),a2
		dbf	d4,loc_DBE0
		lea	6(a1),a1
		dbf	d3,loc_DBD8
		rts
; End of function RingPosLoad2

; ===============================================================================
off_DC04:	dc.w word_DC14-off_DC04
		dc.w word_DC1C-off_DC04
		dc.w word_DC24-off_DC04
		dc.w word_DC2C-off_DC04
		dc.w word_DC34-off_DC04
		dc.w word_DC3C-off_DC04
		dc.w word_DC44-off_DC04
		dc.w word_DC4C-off_DC04
word_DC14:	dc.w $F805,    0,    0,$FFF8; 0	; DATA XREF: ROM:off_DC04o
word_DC1C:	dc.w $F805,    4,    2,$FFF8; 0	; DATA XREF: ROM:0000DC06o
word_DC24:	dc.w $F801,    8,    4,$FFFC; 0	; DATA XREF: ROM:0000DC08o
word_DC2C:	dc.w $F805, $804, $802,$FFF8; 0	; DATA XREF: ROM:0000DC0Ao
word_DC34:	dc.w $F805,   $A,    5,$FFF8; 0	; DATA XREF: ROM:0000DC0Co
word_DC3C:	dc.w $F805,$180A,$1805,$FFF8; 0	; DATA XREF: ROM:0000DC0Eo
word_DC44:	dc.w $F805, $80A, $805,$FFF8; 0	; DATA XREF: ROM:0000DC10o
word_DC4C:	dc.w $F805,$100A,$1005,$FFF8; 0	; DATA XREF: ROM:0000DC12o

; =============== S U B R O U T I N E ==========================================


ObjPosLoad:
		moveq	#0,d0
		move.b	(RAM_ObjPos_SubCntr).w,d0
		move.w	@Index(pc,d0.w),d0
		jmp	@Index(pc,d0.w)

; ===============================================================================
@Index:		dc.w loc_DC68-@Index
		dc.w loc_DD14-@Index
		dc.w loc_DE5C-@Index
; ===============================================================================

loc_DC68:
		addq.b	#2,(RAM_ObjPos_SubCntr).w
		move.w	(RAM_Level_CurrentZone).w,d0
		lsl.b	#6,d0
		lsr.w	#4,d0
		lea	(ObjPos_Index).l,a0
		movea.l	a0,a1
		adda.w	(a0,d0.w),a0
		move.l	a0,(RAM_ObjPos_GetObjPos).w
		move.l	a0,(RAM_ObjPos_GetObjPos+$4).w
		move.l	a0,(RAM_ObjPos_GetObjPos+$8).w
		move.l	a0,(RAM_ObjPos_GetObjPos+$C).w

		lea	(RAM_ObjRespawnTbl).w,a2
		move.w	#$101,(a2)+
		move.w	#$5E,d0
loc_DC9C:
		clr.l	(a2)+
		dbf	d0,loc_DC9C

		lea	(RAM_ObjRespawnTbl).w,a2
		moveq	#0,d2
		move.w	(RAM_LevelSys_Buff).w,d6
		subi.w	#$80,d6
		bcc.s	loc_DCB4
		moveq	#0,d6

loc_DCB4:
		andi.w	#$FF80,d6
		movea.l	(RAM_ObjPos_GetObjPos).w,a0

loc_DCBC:
		cmp.w	(a0),d6
		bls.s	loc_DCCE
		tst.b	4(a0)
		bpl.s	loc_DCCA
		move.b	(a2),d2
		addq.b	#1,(a2)

loc_DCCA:
		addq.w	#6,a0
		bra.s	loc_DCBC
; ===============================================================================

loc_DCCE:
		move.l	a0,(RAM_ObjPos_GetObjPos).w
		move.l	a0,(RAM_ObjPos_GetObjPos+$8).w
		movea.l	(RAM_ObjPos_GetObjPos+$4).w,a0
		subi.w	#$80,d6
		bcs.s	loc_DCF2

loc_DCE0:
		cmp.w	(a0),d6
		bls.s	loc_DCF2
		tst.b	4(a0)
		bpl.s	loc_DCEE
		addq.b	#1,1(a2)

loc_DCEE:
		addq.w	#6,a0
		bra.s	loc_DCE0
; ===============================================================================

loc_DCF2:
		move.l	a0,(RAM_ObjPos_GetObjPos+$4).w
		move.l	a0,(RAM_ObjPos_GetObjPos+$C).w
		move.w	#$FFFF,(RAM_ObjPos_GetXPos).w
		move.w	#$FFFF,(RAM_ObjPos_GetXPos_2p).w
		tst.w	(RAM_Flag_SplitScreen).w
		beq.s	loc_DD14
		addq.b	#2,(RAM_ObjPos_SubCntr).w
		bra.w	loc_DDE0
; ===============================================================================

loc_DD14:
		move.w	(RAM_LevelSys_Buff).w,d1
		subi.w	#$80,d1
		andi.w	#$FF80,d1
		move.w	d1,(RAM_ObjPos_DelSpr).w
		lea	(RAM_ObjRespawnTbl).w,a2
		moveq	#0,d2
		move.w	(RAM_LevelSys_Buff).w,d6
		andi.w	#$FF80,d6
		cmp.w	(RAM_ObjPos_GetXPos).w,d6
		beq.w	locret_DDDE
		bge.s	loc_DD9A
		move.w	d6,(RAM_ObjPos_GetXPos).w
		movea.l	(RAM_ObjPos_GetObjPos+$4).w,a0
		subi.w	#$80,d6
		bcs.s	loc_DD76

loc_DD4A:
		cmp.w	-6(a0),d6
		bge.s	loc_DD76
		subq.w	#6,a0
		tst.b	4(a0)
		bpl.s	loc_DD60
		subq.b	#1,1(a2)
		move.b	1(a2),d2

loc_DD60:
		bsr.w	sub_E0D2
		bne.s	loc_DD6A
		subq.w	#6,a0
		bra.s	loc_DD4A
; ===============================================================================

loc_DD6A:
		tst.b	4(a0)
		bpl.s	loc_DD74
		addq.b	#1,1(a2)

loc_DD74:
		addq.w	#6,a0

loc_DD76:
		move.l	a0,(RAM_ObjPos_GetObjPos+$4).w
		movea.l	(RAM_ObjPos_GetObjPos).w,a0
		addi.w	#$300,d6

loc_DD82:
		cmp.w	-6(a0),d6
		bgt.s	loc_DD94
		tst.b	-2(a0)
		bpl.s	loc_DD90
		subq.b	#1,(a2)

loc_DD90:
		subq.w	#6,a0
		bra.s	loc_DD82
; ===============================================================================

loc_DD94:
		move.l	a0,(RAM_ObjPos_GetObjPos).w
		rts
; ===============================================================================

loc_DD9A:
		move.w	d6,(RAM_ObjPos_GetXPos).w
		movea.l	(RAM_ObjPos_GetObjPos).w,a0
		addi.w	#$280,d6

loc_DDA6:
		cmp.w	(a0),d6
		bls.s	loc_DDBA
		tst.b	4(a0)
		bpl.s	loc_DDB4
		move.b	(a2),d2
		addq.b	#1,(a2)

loc_DDB4:
		bsr.w	sub_E0D2
		beq.s	loc_DDA6

loc_DDBA:
		move.l	a0,(RAM_ObjPos_GetObjPos).w
		movea.l	(RAM_ObjPos_GetObjPos+$4).w,a0
		subi.w	#$300,d6
		bcs.s	loc_DDDA

loc_DDC8:
		cmp.w	(a0),d6
		bls.s	loc_DDDA
		tst.b	4(a0)
		bpl.s	loc_DDD6
		addq.b	#1,1(a2)

loc_DDD6:
		addq.w	#6,a0
		bra.s	loc_DDC8
; ===============================================================================

loc_DDDA:
		move.l	a0,(RAM_ObjPos_GetObjPos+$4).w

locret_DDDE:
		rts

; ===============================================================================

loc_DDE0:
		moveq	#$FFFFFFFF,d0
		move.l	d0,(RAM_ObjPos_2pData).w
		move.l	d0,(RAM_ObjPos_2pData+$4).w
		move.l	d0,(RAM_ObjPos_2pData+$8).w
		move.l	d0,(RAM_ObjPos_GetXPos_2p).w
		move.w	#0,(RAM_ObjPos_GetXPos).w
		move.w	#0,(RAM_ObjPos_GetXPos_2p).w
		lea	(RAM_ObjRespawnTbl).w,a2
		move.w	(a2),(RAM_ObjPos_2pData+$E).w
		moveq	#0,d2
		lea	(RAM_ObjRespawnTbl).w,a5
		lea	(RAM_ObjPos_GetObjPos).w,a4
		lea	(RAM_ObjPos_2pData+$6).w,a1
		lea	(RAM_ObjPos_2pData+$9).w,a6
		moveq	#$FFFFFFFE,d6
		bsr.w	sub_DF80
		lea	(RAM_ObjPos_2pData+$6).w,a1
		moveq	#$FFFFFFFF,d6
		bsr.w	sub_DF80
		lea	(RAM_ObjPos_2pData+$6).w,a1
		moveq	#0,d6
		bsr.w	sub_DF80
		lea	(RAM_ObjPos_2pData+$E).w,a5
		lea	(RAM_ObjPos_GetObjPos+$8).w,a4
		lea	(RAM_ObjPos_2pData+$9).w,a1
		lea	(RAM_ObjPos_2pData+$6).w,a6
		moveq	#$FFFFFFFE,d6
		bsr.w	sub_DF80
		lea	(RAM_ObjPos_2pData+$9).w,a1
		moveq	#$FFFFFFFF,d6
		bsr.w	sub_DF80
		lea	(RAM_ObjPos_2pData+$9).w,a1
		moveq	#0,d6
		bsr.w	sub_DF80

loc_DE5C:
		move.w	(RAM_LevelSys_Buff).w,d1
		andi.w	#$FF00,d1
		move.w	d1,(RAM_ObjPos_DelSpr).w
		move.w	(RAM_LevelSys_Buff_2P).w,d1
		andi.w	#$FF00,d1
		move.w	d1,(RAM_ObjPos_DelSpr_2p).w
		move.b	(RAM_LevelSys_Buff).w,d6
		andi.w	#$FF,d6
		move.w	(RAM_ObjPos_GetXPos).w,d0
		cmp.w	(RAM_ObjPos_GetXPos).w,d6
		beq.s	loc_DE9C
		move.w	d6,(RAM_ObjPos_GetXPos).w
		lea	(RAM_ObjRespawnTbl).w,a5
		lea	(RAM_ObjPos_GetObjPos).w,a4
		lea	(RAM_ObjPos_2pData+$6).w,a1
		lea	(RAM_ObjPos_2pData+$9).w,a6
		bsr.s	sub_DED2

loc_DE9C:
		move.b	(RAM_LevelSys_Buff_2P).w,d6
		andi.w	#$FF,d6
		move.w	(RAM_ObjPos_GetXPos_2p).w,d0
		cmp.w	(RAM_ObjPos_GetXPos_2p).w,d6
		beq.s	loc_DEC4
		move.w	d6,(RAM_ObjPos_GetXPos_2p).w
		lea	(RAM_ObjPos_2pData+$E).w,a5
		lea	(RAM_ObjPos_GetObjPos+$8).w,a4
		lea	(RAM_ObjPos_2pData+$9).w,a1
		lea	(RAM_ObjPos_2pData+$6).w,a6
		bsr.s	sub_DED2

loc_DEC4:
		move.w	(RAM_ObjRespawnTbl).w,(RAM_ObjRespawnTbl_Copy).w
		move.w	(RAM_ObjPos_2pData+$E).w,(RAM_ObjPos_2pDataE_Copy).w
		rts

; =============== S U B R O U T I N E ==========================================


sub_DED2:
		lea	(RAM_ObjRespawnTbl).w,a2
		moveq	#0,d2
		cmp.w	d0,d6
		beq.w	locret_DDDE
		bge.w	sub_DF80
		move.b	2(a1),d2
		move.b	1(a1),2(a1)
		move.b	(a1),1(a1)
		move.b	d6,(a1)
		cmp.b	(a6),d2
		beq.s	loc_DF08
		cmp.b	1(a6),d2
		beq.s	loc_DF08
		cmp.b	2(a6),d2
		beq.s	loc_DF08
		bsr.w	sub_E062
		bra.s	loc_DF0C
; ===============================================================================

loc_DF08:				; CODE XREF: sub_DED2+22j sub_DED2+28j ...
		bsr.w	sub_E026

loc_DF0C:				; CODE XREF: sub_DED2+34j
		bsr.w	sub_E002
		bne.s	loc_DF30
		movea.l	4(a4),a0

loc_DF16:				; CODE XREF: sub_DED2+56j
		cmp.b	-6(a0),d6
		bne.s	loc_DF2A
		tst.b	-2(a0)
		bpl.s	loc_DF26
		subq.b	#1,1(a5)

loc_DF26:				; CODE XREF: sub_DED2+4Ej
		subq.w	#6,a0
		bra.s	loc_DF16
; ===============================================================================

loc_DF2A:				; CODE XREF: sub_DED2+48j
		move.l	a0,4(a4)
		bra.s	loc_DF66
; ===============================================================================

loc_DF30:				; CODE XREF: sub_DED2+3Ej
		movea.l	4(a4),a0
		move.b	d6,(a1)

loc_DF36:				; CODE XREF: sub_DED2+82j
		cmp.b	-6(a0),d6
		bne.s	loc_DF62
		subq.w	#6,a0
		tst.b	4(a0)
		bpl.s	loc_DF4C
		subq.b	#1,1(a5)
		move.b	1(a5),d2

loc_DF4C:				; CODE XREF: sub_DED2+70j
		bsr.w	sub_E122
		bne.s	loc_DF56
		subq.w	#6,a0
		bra.s	loc_DF36
; ===============================================================================

loc_DF56:				; CODE XREF: sub_DED2+7Ej
		tst.b	4(a0)
		bpl.s	loc_DF60
		addq.b	#1,1(a5)

loc_DF60:				; CODE XREF: sub_DED2+88j
		addq.w	#6,a0

loc_DF62:				; CODE XREF: sub_DED2+68j
		move.l	a0,4(a4)

loc_DF66:				; CODE XREF: sub_DED2+5Cj
		movea.l	(a4),a0
		addq.w	#3,d6

loc_DF6A:				; CODE XREF: sub_DED2+A8j
		cmp.b	-6(a0),d6
		bne.s	loc_DF7C
		tst.b	-2(a0)
		bpl.s	loc_DF78
		subq.b	#1,(a5)

loc_DF78:				; CODE XREF: sub_DED2+A2j
		subq.w	#6,a0
		bra.s	loc_DF6A
; ===============================================================================

loc_DF7C:				; CODE XREF: sub_DED2+9Cj
		move.l	a0,(a4)
		rts
; End of function sub_DED2


; =============== S U B R O U T I N E ==========================================


sub_DF80:
		addq.w	#2,d6
		move.b	(a1),d2
		move.b	1(a1),(a1)
		move.b	2(a1),1(a1)
		move.b	d6,2(a1)
		cmp.b	(a6),d2
		beq.s	loc_DFA8
		cmp.b	1(a6),d2
		beq.s	loc_DFA8
		cmp.b	2(a6),d2
		beq.s	loc_DFA8
		bsr.w	sub_E062
		bra.s	loc_DFAC
; ===============================================================================

loc_DFA8:				; CODE XREF: sub_DF80+14j sub_DF80+1Aj ...
		bsr.w	sub_E026

loc_DFAC:				; CODE XREF: sub_DF80+26j
		bsr.w	sub_E002
		bne.s	loc_DFC8
		movea.l	(a4),a0

loc_DFB4:				; CODE XREF: sub_DF80+42j
		cmp.b	(a0),d6
		bne.s	loc_DFC4
		tst.b	4(a0)
		bpl.s	loc_DFC0
		addq.b	#1,(a5)

loc_DFC0:				; CODE XREF: sub_DF80+3Cj
		addq.w	#6,a0
		bra.s	loc_DFB4
; ===============================================================================

loc_DFC4:				; CODE XREF: sub_DF80+36j
		move.l	a0,(a4)
		bra.s	loc_DFE2
; ===============================================================================

loc_DFC8:				; CODE XREF: sub_DF80+30j
		movea.l	(a4),a0
		move.b	d6,(a1)

loc_DFCC:				; CODE XREF: sub_DF80+5Ej
		cmp.b	(a0),d6
		bne.s	loc_DFE0
		tst.b	4(a0)
		bpl.s	loc_DFDA
		move.b	(a5),d2
		addq.b	#1,(a5)

loc_DFDA:				; CODE XREF: sub_DF80+54j
		bsr.w	sub_E122
		beq.s	loc_DFCC

loc_DFE0:				; CODE XREF: sub_DF80+4Ej
		move.l	a0,(a4)

loc_DFE2:				; CODE XREF: sub_DF80+46j
		movea.l	4(a4),a0
		subq.w	#3,d6
		bcs.s	loc_DFFC

loc_DFEA:				; CODE XREF: sub_DF80+7Aj
		cmp.b	(a0),d6
		bne.s	loc_DFFC
		tst.b	4(a0)
		bpl.s	loc_DFF8
		addq.b	#1,1(a5)

loc_DFF8:				; CODE XREF: sub_DF80+72j
		addq.w	#6,a0
		bra.s	loc_DFEA
; ===============================================================================

loc_DFFC:				; CODE XREF: sub_DF80+68j sub_DF80+6Cj
		move.l	a0,4(a4)
		rts
; End of function sub_DF80


; =============== S U B R O U T I N E ==========================================


sub_E002:
		move.l	a1,-(sp)
		lea	(RAM_ObjPos_2pData).w,a1
		cmp.b	(a1)+,d6
		beq.s	VInt_A2
		cmp.b	(a1)+,d6
		beq.s	VInt_A2
		cmp.b	(a1)+,d6
		beq.s	VInt_A2
		cmp.b	(a1)+,d6
		beq.s	VInt_A2
		cmp.b	(a1)+,d6
		beq.s	VInt_A2
		cmp.b	(a1)+,d6
		beq.s	VInt_A2
		moveq	#1,d0

VInt_A2:
		movea.l	(sp)+,a1
		rts


; =============== S U B R O U T I N E ==========================================


sub_E026:
		lea	(RAM_ObjPos_2pData).w,a1
		lea	(RAM_ObjectTable+$E00).w,a3
		tst.b	(a1)+
		bmi.s	loc_E05E
		lea	(RAM_ObjectTable+$1100).w,a3
		tst.b	(a1)+
		bmi.s	loc_E05E
		lea	(RAM_ObjectTable+$1400).w,a3
		tst.b	(a1)+
		bmi.s	loc_E05E
		lea	(RAM_ObjectTable+$1700).w,a3
		tst.b	(a1)+
		bmi.s	loc_E05E
		lea	(RAM_ObjectTable+$1A00).w,a3
		tst.b	(a1)+
		bmi.s	loc_E05E
		lea	(RAM_ObjectTable+$1D00).w,a3
		tst.b	(a1)+
		bmi.s	loc_E05E
		nop
		nop

loc_E05E:
		subq.w	#1,a1
		rts


; =============== S U B R O U T I N E ==========================================


sub_E062:
		lea	(RAM_ObjPos_2pData).w,a1
		lea	(RAM_ObjectTable+$E00).w,a3
		cmp.b	(a1)+,d2
		beq.s	loc_E09A
		lea	(RAM_ObjectTable+$1100).w,a3
		cmp.b	(a1)+,d2
		beq.s	loc_E09A
		lea	(RAM_ObjectTable+$1400).w,a3
		cmp.b	(a1)+,d2
		beq.s	loc_E09A
		lea	(RAM_ObjectTable+$1700).w,a3
		cmp.b	(a1)+,d2
		beq.s	loc_E09A
		lea	(RAM_ObjectTable+$1A00).w,a3
		cmp.b	(a1)+,d2
		beq.s	loc_E09A
		lea	(RAM_ObjectTable+$1D00).w,a3
		cmp.b	(a1)+,d2
		beq.s	loc_E09A
		nop
		nop

loc_E09A:
		move.b	#$FF,-(a1)
		movem.l	a1/a3,-(sp)
		moveq	#0,d1
		moveq	#$B,d2

loc_E0A6:
		tst.b	(a3)
		beq.s	loc_E0C2
		movea.l	a3,a1
		moveq	#0,d0
		move.b	$23(a1),d0
		beq.s	loc_E0BA
		bclr	#7,2(a2,d0.w)

loc_E0BA:
		moveq	#$F,d0

loc_E0BC:
		move.l	d1,(a1)+
		dbf	d0,loc_E0BC

loc_E0C2:
		lea	$40(a3),a3
		dbf	d2,loc_E0A6
		moveq	#0,d2
		movem.l	(sp)+,a1/a3
		rts


; =============== S U B R O U T I N E ==========================================


sub_E0D2:
		tst.b	4(a0)
		bpl.s	loc_E0E6
		bset	#7,2(a2,d2.w)
		beq.s	loc_E0E6
		addq.w	#6,a0
		moveq	#0,d0
		rts
; ===============================================================================

loc_E0E6:
		bsr.w	SingleObjectLoad
		bne.s	locret_E120
		move.w	(a0)+,8(a1)
		move.w	(a0)+,d0
		move.w	d0,d1
		andi.w	#$FFF,d0
		move.w	d0,$C(a1)
		rol.w	#2,d1
		andi.b	#3,d1
		move.b	d1,1(a1)
		move.b	d1,$22(a1)
		move.b	(a0)+,d0
		bpl.s	loc_E116
		andi.b	#$7F,d0
		move.b	d2,$23(a1)

loc_E116:				; CODE XREF: sub_E0D2+3Aj
		move.b	d0,0(a1)
		move.b	(a0)+,$28(a1)
		moveq	#0,d0

locret_E120:				; CODE XREF: sub_E0D2+18j
		rts
; End of function sub_E0D2


; =============== S U B R O U T I N E ==========================================


sub_E122:				; CODE XREF: sub_DED2:loc_DF4Cp
					; sub_DF80:loc_DFDAp
		tst.b	4(a0)
		bpl.s	loc_E136
		bset	#7,2(a2,d2.w)
		beq.s	loc_E136
		addq.w	#6,a0
		moveq	#0,d0
		rts
; ===============================================================================

loc_E136:				; CODE XREF: sub_E122+4j sub_E122+Cj
		btst	#5,2(a0)
		beq.s	loc_E146
		bsr.w	SingleObjectLoad
		bne.s	locret_E180
		bra.s	loc_E14C
; ===============================================================================

loc_E146:				; CODE XREF: sub_E122+1Aj
		bsr.w	sub_E1B4
		bne.s	locret_E180

loc_E14C:				; CODE XREF: sub_E122+22j
		move.w	(a0)+,8(a1)
		move.w	(a0)+,d0
		move.w	d0,d1
		andi.w	#$FFF,d0
		move.w	d0,$C(a1)
		rol.w	#2,d1
		andi.b	#3,d1
		move.b	d1,1(a1)
		move.b	d1,$22(a1)
		move.b	(a0)+,d0
		bpl.s	loc_E176
		andi.b	#$7F,d0	; ''
		move.b	d2,$23(a1)

loc_E176:				; CODE XREF: sub_E122+4Aj
		move.b	d0,0(a1)
		move.b	(a0)+,$28(a1)
		moveq	#0,d0

locret_E180:				; CODE XREF: sub_E122+20j sub_E122+28j
		rts
; End of function sub_E122


; =============== S U B R O U T I N E ==========================================


SingleObjectLoad:
		lea	(RAM_ObjectTable+$800).w,a1
		move.w	#$5F,d0

loc_E18A:
		tst.b	(a1)
		beq.s	locret_E196
		lea	$40(a1),a1
		dbf	d0,loc_E18A

locret_E196:
		rts


; =============== S U B R O U T I N E ==========================================


S1SingleObjectLoad2:			; CODE XREF: sub_7C76p	ROM:loc_82F0p ...
		movea.l	a0,a1
		move.w	#$D000,d0
		sub.w	a0,d0
		lsr.w	#6,d0
		subq.w	#1,d0
		bcs.s	locret_E1B2

loc_E1A6:				; CODE XREF: S1SingleObjectLoad2+16j
		tst.b	(a1)
		beq.s	locret_E1B2
		lea	$40(a1),a1
		dbf	d0,loc_E1A6

locret_E1B2:				; CODE XREF: S1SingleObjectLoad2+Cj
					; S1SingleObjectLoad2+10j
		rts
; End of function S1SingleObjectLoad2


; =============== S U B R O U T I N E ==========================================


sub_E1B4:				; CODE XREF: sub_E122:loc_E146p
		movea.l	a3,a1
		move.w	#$B,d0

loc_E1BA:				; CODE XREF: sub_E1B4+Ej
		tst.b	(a1)
		beq.s	locret_E1C6
		lea	$40(a1),a1
		dbf	d0,loc_E1BA

locret_E1C6:				; CODE XREF: sub_E1B4+8j
		rts
; End of function sub_E1B4

; ===============================================================================
;----------------------------------------------------
; Object 41 - springs
;----------------------------------------------------

Obj41:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj41_Index(pc,d0.w),d1
		jsr	Obj41_Index(pc,d1.w)
		tst.w	(RAM_Flag_SplitScreen).w
		beq.s	loc_E1E0
		bra.w	DisplaySprite
; ===============================================================================

loc_E1E0:				; CODE XREF: ROM:0000E1DAj
		move.w	8(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.w	DeleteObject
		bra.w	DisplaySprite
; ===============================================================================
Obj41_Index:	dc.w loc_E204-Obj41_Index ; DATA XREF: ROM:Obj41_Indexo
					; ROM:0000E1FAo ...
		dc.w loc_E302-Obj41_Index
		dc.w loc_E3F4-Obj41_Index
		dc.w loc_E606-Obj41_Index
		dc.w loc_E6F2-Obj41_Index
		dc.w loc_E828-Obj41_Index
; ===============================================================================

loc_E204:				; DATA XREF: ROM:Obj41_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj41_GHZ,4(a0)
		move.w	#$4A8,2(a0)
		tst.b	(RAM_Level_CurrentZone).w
		beq.s	loc_E22A
		move.l	#Map_Obj41,4(a0)
		move.w	#$45C,2(a0)

loc_E22A:				; CODE XREF: ROM:0000E21Aj
		ori.b	#4,1(a0)
		move.b	#$10,$19(a0)
		move.b	#4,$18(a0)
		move.b	$28(a0),d0
		lsr.w	#3,d0
		andi.w	#$E,d0
		move.w	off_E24E(pc,d0.w),d0
		jmp	off_E24E(pc,d0.w)
; ===============================================================================
off_E24E:	dc.w loc_E2D0-off_E24E	; DATA XREF: ROM:off_E24Eo
					; ROM:0000E250o ...
		dc.w loc_E258-off_E24E
		dc.w loc_E284-off_E24E
		dc.w loc_E298-off_E24E
		dc.w loc_E2B2-off_E24E
; ===============================================================================

loc_E258:				; DATA XREF: ROM:0000E250o
		move.b	#4,$24(a0)
		move.b	#2,$1C(a0)
		move.b	#3,$1A(a0)
		move.w	#$4B8,2(a0)
		tst.b	(RAM_Level_CurrentZone).w
		beq.s	loc_E27C
		move.w	#$470,2(a0)

loc_E27C:				; CODE XREF: ROM:0000E274j
		move.b	#8,$19(a0)
		bra.s	loc_E2D0
; ===============================================================================

loc_E284:				; DATA XREF: ROM:0000E252o
		move.b	#6,$24(a0)
		move.b	#6,$1A(a0)
		bset	#1,$22(a0)
		bra.s	loc_E2D0
; ===============================================================================

loc_E298:				; DATA XREF: ROM:0000E254o
		move.b	#8,$24(a0)
		move.b	#4,$1C(a0)
		move.b	#7,$1A(a0)
		move.w	#$43C,2(a0)
		bra.s	loc_E2D0
; ===============================================================================

loc_E2B2:				; DATA XREF: ROM:0000E256o
		move.b	#$A,$24(a0)
		move.b	#4,$1C(a0)
		move.b	#$A,$1A(a0)
		move.w	#$43C,2(a0)
		bset	#1,$22(a0)

loc_E2D0:				; CODE XREF: ROM:0000E282j
					; ROM:0000E296j ...
		move.b	$28(a0),d0
		andi.w	#2,d0
		move.w	word_E2FE(pc,d0.w),$30(a0)
		btst	#1,d0
		beq.s	loc_E2F8
		bset	#5,2(a0)
		tst.b	(RAM_Level_CurrentZone).w
		beq.s	loc_E2F8
		move.l	#Map_Obj41a,4(a0)

loc_E2F8:				; CODE XREF: ROM:0000E2E2j
					; ROM:0000E2EEj
		bsr.w	ModifySpriteAttr_2P
		rts
; ===============================================================================
word_E2FE:	dc.w $F000
		dc.w $F600
; ===============================================================================

loc_E302:				; DATA XREF: ROM:0000E1FAo
		move.w	#$1B,d1
		move.w	#8,d2
		move.w	#$10,d3
		move.w	8(a0),d4
		lea	(RAM_ObjRAM_Sonic).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.w	loc_F4A8
		btst	#3,$22(a0)
		beq.s	loc_E32A
		bsr.s	sub_E34E

loc_E32A:				; CODE XREF: ROM:0000E326j
		movem.l	(sp)+,d1-d4
		lea	(RAM_ObjRAM_Tails).w,a1
		moveq	#4,d6
		bsr.w	loc_F4A8
		btst	#4,$22(a0)
		beq.s	loc_E342
		bsr.s	sub_E34E

loc_E342:				; CODE XREF: ROM:0000E33Ej
		lea	(Ani_Obj41).l,a1
		bra.w	AnimateSprite
; ===============================================================================
		rts

; =============== S U B R O U T I N E ==========================================


sub_E34E:				; CODE XREF: ROM:0000E328p
					; ROM:0000E340p
		move.w	#$100,$1C(a0)
		addq.w	#8,$C(a1)
		move.w	$30(a0),$12(a1)
		bset	#1,$22(a1)
		bclr	#3,$22(a1)
		move.b	#$10,$1C(a1)
		move.b	#2,$24(a1)
		move.b	$28(a0),d0
		bpl.s	loc_E382
		move.w	#0,$10(a1)

loc_E382:				; CODE XREF: sub_E34E+2Cj
		btst	#0,d0
		beq.s	loc_E3C2
		move.w	#1,$14(a1)
		move.b	#1,$27(a1)
		move.b	#0,$1C(a1)
		move.b	#0,$2C(a1)
		move.b	#4,$2D(a1)
		btst	#1,d0
		bne.s	loc_E3B2
		move.b	#1,$2C(a1)

loc_E3B2:				; CODE XREF: sub_E34E+5Cj
		btst	#0,$22(a1)
		beq.s	loc_E3C2
		neg.b	$27(a1)
		neg.w	$14(a1)

loc_E3C2:				; CODE XREF: sub_E34E+38j sub_E34E+6Aj
		andi.b	#$C,d0
		cmpi.b	#4,d0
		bne.s	loc_E3D8
		move.b	#$C,$3E(a1)
		move.b	#$D,$3F(a1)

loc_E3D8:				; CODE XREF: sub_E34E+7Cj
		cmpi.b	#8,d0
		bne.s	loc_E3EA
		move.b	#$E,$3E(a1)
		move.b	#$F,$3F(a1)

loc_E3EA:				; CODE XREF: sub_E34E+8Ej
		move.w	#$CC,d0	; ''
		jmp	(PlaySound_Special).l
; End of function sub_E34E

; ===============================================================================

loc_E3F4:				; DATA XREF: ROM:0000E1FCo
		move.w	#$13,d1
		move.w	#$E,d2
		move.w	#$F,d3
		move.w	8(a0),d4
		lea	(RAM_ObjRAM_Sonic).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.w	loc_F4A8
		btst	#5,$22(a0)
		beq.s	loc_E434
		move.b	$22(a0),d1
		move.w	8(a0),d0
		sub.w	8(a1),d0
		bcs.s	loc_E42C
		eori.b	#1,d1

loc_E42C:				; CODE XREF: ROM:0000E426j
		andi.b	#1,d1
		bne.s	loc_E434
		bsr.s	sub_E474

loc_E434:				; CODE XREF: ROM:0000E418j
					; ROM:0000E430j
		movem.l	(sp)+,d1-d4
		lea	(RAM_ObjRAM_Tails).w,a1
		moveq	#4,d6
		bsr.w	loc_F4A8
		btst	#6,$22(a0)
		beq.s	loc_E464
		move.b	$22(a0),d1
		move.w	8(a0),d0
		sub.w	8(a1),d0
		bcs.s	loc_E45C
		eori.b	#1,d1

loc_E45C:				; CODE XREF: ROM:0000E456j
		andi.b	#1,d1
		bne.s	loc_E464
		bsr.s	sub_E474

loc_E464:				; CODE XREF: ROM:0000E448j
					; ROM:0000E460j
		bsr.w	sub_E54C
		lea	(Ani_Obj41).l,a1
		bra.w	AnimateSprite
; ===============================================================================
		rts

; =============== S U B R O U T I N E ==========================================


sub_E474:				; CODE XREF: ROM:0000E432p
					; ROM:0000E462p ...
		move.w	#$300,$1C(a0)
		move.w	$30(a0),$10(a1)
		addq.w	#8,8(a1)
		bset	#0,$22(a1)
		btst	#0,$22(a0)
		bne.s	loc_E4A2
		bclr	#0,$22(a1)
		subi.w	#$10,8(a1)
		neg.w	$10(a1)

loc_E4A2:				; CODE XREF: sub_E474+1Cj
		move.w	#$F,$2E(a1)
		move.w	$10(a1),$14(a1)
		btst	#2,$22(a1)
		bne.s	loc_E4BC
		move.b	#0,$1C(a1)

loc_E4BC:				; CODE XREF: sub_E474+40j
		move.b	$28(a0),d0
		bpl.s	loc_E4C8
		move.w	#0,$12(a1)

loc_E4C8:				; CODE XREF: sub_E474+4Cj
		btst	#0,d0
		beq.s	loc_E508
		move.w	#1,$14(a1)
		move.b	#1,$27(a1)
		move.b	#0,$1C(a1)
		move.b	#1,$2C(a1)
		move.b	#8,$2D(a1)
		btst	#1,d0
		bne.s	loc_E4F8
		move.b	#3,$2C(a1)

loc_E4F8:				; CODE XREF: sub_E474+7Cj
		btst	#0,$22(a1)
		beq.s	loc_E508
		neg.b	$27(a1)
		neg.w	$14(a1)

loc_E508:				; CODE XREF: sub_E474+58j sub_E474+8Aj
		andi.b	#$C,d0
		cmpi.b	#4,d0
		bne.s	loc_E51E
		move.b	#$C,$3E(a1)
		move.b	#$D,$3F(a1)

loc_E51E:				; CODE XREF: sub_E474+9Cj
		cmpi.b	#8,d0
		bne.s	loc_E530
		move.b	#$E,$3E(a1)
		move.b	#$F,$3F(a1)

loc_E530:				; CODE XREF: sub_E474+AEj
		bclr	#5,$22(a0)
		bclr	#6,$22(a0)
		bclr	#5,$22(a1)
		move.w	#$CC,d0	; ''
		jmp	(PlaySound_Special).l
; End of function sub_E474


; =============== S U B R O U T I N E ==========================================


sub_E54C:				; CODE XREF: ROM:loc_E464p
		cmpi.b	#3,$1C(a0)
		beq.w	locret_E604
		move.w	8(a0),d0
		move.w	d0,d1
		addi.w	#$28,d1	; '('
		btst	#0,$22(a0)
		beq.s	loc_E56E
		move.w	d0,d1
		subi.w	#$28,d0	; '('

loc_E56E:				; CODE XREF: sub_E54C+1Aj
		move.w	$C(a0),d2
		move.w	d2,d3
		subi.w	#$18,d2
		addi.w	#$18,d3
		lea	(RAM_ObjRAM_Sonic).w,a1
		btst	#1,$22(a1)
		bne.s	loc_E5C2
		move.w	$14(a1),d4
		btst	#0,$22(a0)
		beq.s	loc_E596
		neg.w	d4

loc_E596:				; CODE XREF: sub_E54C+46j
		tst.w	d4
		bmi.s	loc_E5C2
		move.w	8(a1),d4
		cmp.w	d0,d4
		bcs.w	loc_E5C2
		cmp.w	d1,d4
		bcc.w	loc_E5C2
		move.w	$C(a1),d4
		cmp.w	d2,d4
		bcs.w	loc_E5C2
		cmp.w	d3,d4
		bcc.w	loc_E5C2
		move.w	d0,-(sp)
		bsr.w	sub_E474
		move.w	(sp)+,d0

loc_E5C2:				; CODE XREF: sub_E54C+3Aj sub_E54C+4Cj ...
		lea	(RAM_ObjRAM_Tails).w,a1
		btst	#1,$22(a1)
		bne.s	locret_E604
		move.w	$14(a1),d4
		btst	#0,$22(a0)
		beq.s	loc_E5DC
		neg.w	d4

loc_E5DC:				; CODE XREF: sub_E54C+8Cj
		tst.w	d4
		bmi.s	locret_E604
		move.w	8(a1),d4
		cmp.w	d0,d4
		bcs.w	locret_E604
		cmp.w	d1,d4
		bcc.w	locret_E604
		move.w	$C(a1),d4
		cmp.w	d2,d4
		bcs.w	locret_E604
		cmp.w	d3,d4
		bcc.w	locret_E604
		bsr.w	sub_E474

locret_E604:				; CODE XREF: sub_E54C+6j sub_E54C+80j	...
		rts
; End of function sub_E54C

; ===============================================================================

loc_E606:				; DATA XREF: ROM:0000E1FEo
		move.w	#$1B,d1
		move.w	#8,d2
		move.w	#$10,d3
		move.w	8(a0),d4
		lea	(RAM_ObjRAM_Sonic).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.w	loc_F4A8
		cmpi.w	#$FFFE,d4
		bne.s	loc_E62C
		bsr.s	sub_E64E

loc_E62C:				; CODE XREF: ROM:0000E628j
		movem.l	(sp)+,d1-d4
		lea	(RAM_ObjRAM_Tails).w,a1
		moveq	#4,d6
		bsr.w	loc_F4A8
		cmpi.w	#$FFFE,d4
		bne.s	loc_E642
		bsr.s	sub_E64E

loc_E642:				; CODE XREF: ROM:0000E63Ej
		lea	(Ani_Obj41).l,a1
		bra.w	AnimateSprite
; ===============================================================================
		rts

; =============== S U B R O U T I N E ==========================================


sub_E64E:				; CODE XREF: ROM:0000E62Ap
					; ROM:0000E640p
		move.w	#$100,$1C(a0)
		subq.w	#8,$C(a1)
		move.w	$30(a0),$12(a1)
		neg.w	$12(a1)
		move.b	$28(a0),d0
		bpl.s	loc_E66E
		move.w	#0,$10(a1)

loc_E66E:				; CODE XREF: sub_E64E+18j
		btst	#0,d0
		beq.s	loc_E6AE
		move.w	#1,$14(a1)
		move.b	#1,$27(a1)
		move.b	#0,$1C(a1)
		move.b	#0,$2C(a1)
		move.b	#4,$2D(a1)
		btst	#1,d0
		bne.s	loc_E69E
		move.b	#1,$2C(a1)

loc_E69E:				; CODE XREF: sub_E64E+48j
		btst	#0,$22(a1)
		beq.s	loc_E6AE
		neg.b	$27(a1)
		neg.w	$14(a1)

loc_E6AE:				; CODE XREF: sub_E64E+24j sub_E64E+56j
		andi.b	#$C,d0
		cmpi.b	#4,d0
		bne.s	loc_E6C4
		move.b	#$C,$3E(a1)
		move.b	#$D,$3F(a1)

loc_E6C4:				; CODE XREF: sub_E64E+68j
		cmpi.b	#8,d0
		bne.s	loc_E6D6
		move.b	#$E,$3E(a1)
		move.b	#$F,$3F(a1)

loc_E6D6:				; CODE XREF: sub_E64E+7Aj
		bset	#1,$22(a1)
		bclr	#3,$22(a1)
		move.b	#2,$24(a1)
		move.w	#$CC,d0	; ''
		jmp	(PlaySound_Special).l
; End of function sub_E64E

; ===============================================================================

loc_E6F2:				; DATA XREF: ROM:0000E200o
		move.w	#$1B,d1
		move.w	#$10,d2
		move.w	8(a0),d4
		lea	byte_E934(pc),a2
		lea	(RAM_ObjRAM_Sonic).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.w	loc_F4FA
		btst	#3,$22(a0)
		beq.s	loc_E71A
		bsr.s	sub_E73E

loc_E71A:				; CODE XREF: ROM:0000E716j
		movem.l	(sp)+,d1-d4
		lea	(RAM_ObjRAM_Tails).w,a1
		moveq	#4,d6
		bsr.w	loc_F4FA
		btst	#4,$22(a0)
		beq.s	loc_E732
		bsr.s	sub_E73E

loc_E732:				; CODE XREF: ROM:0000E72Ej
		lea	(Ani_Obj41).l,a1
		bra.w	AnimateSprite
; ===============================================================================
		rts

; =============== S U B R O U T I N E ==========================================


sub_E73E:				; CODE XREF: ROM:0000E718p
					; ROM:0000E730p
		btst	#0,$22(a0)
		bne.s	loc_E754
		move.w	8(a0),d0
		subq.w	#4,d0
		cmp.w	8(a1),d0
		bcs.s	loc_E762
		rts
; ===============================================================================

loc_E754:				; CODE XREF: sub_E73E+6j
		move.w	8(a0),d0
		addq.w	#4,d0
		cmp.w	8(a1),d0
		bcc.s	loc_E762
		rts
; ===============================================================================

loc_E762:				; CODE XREF: sub_E73E+12j sub_E73E+20j
		move.w	#$500,$1C(a0)
		move.w	$30(a0),$12(a1)
		move.w	$30(a0),$10(a1)
		addq.w	#6,$C(a1)
		addq.w	#6,8(a1)
		bset	#0,$22(a1)
		btst	#0,$22(a0)
		bne.s	loc_E79A
		bclr	#0,$22(a1)
		subi.w	#$C,8(a1)
		neg.w	$10(a1)

loc_E79A:				; CODE XREF: sub_E73E+4Aj
		bset	#1,$22(a1)
		bclr	#3,$22(a1)
		move.b	#$10,$1C(a1)
		move.b	#2,$24(a1)
		move.b	$28(a0),d0
		btst	#0,d0
		beq.s	loc_E7F6
		move.w	#1,$14(a1)
		move.b	#1,$27(a1)
		move.b	#0,$1C(a1)
		move.b	#1,$2C(a1)
		move.b	#8,$2D(a1)
		btst	#1,d0
		bne.s	loc_E7E6
		move.b	#3,$2C(a1)

loc_E7E6:				; CODE XREF: sub_E73E+A0j
		btst	#0,$22(a1)
		beq.s	loc_E7F6
		neg.b	$27(a1)
		neg.w	$14(a1)

loc_E7F6:				; CODE XREF: sub_E73E+7Cj sub_E73E+AEj
		andi.b	#$C,d0
		cmpi.b	#4,d0
		bne.s	loc_E80C
		move.b	#$C,$3E(a1)
		move.b	#$D,$3F(a1)

loc_E80C:				; CODE XREF: sub_E73E+C0j
		cmpi.b	#8,d0
		bne.s	loc_E81E
		move.b	#$E,$3E(a1)
		move.b	#$F,$3F(a1)

loc_E81E:				; CODE XREF: sub_E73E+D2j
		move.w	#$CC,d0	; ''
		jmp	(PlaySound_Special).l
; End of function sub_E73E

; ===============================================================================

loc_E828:				; DATA XREF: ROM:0000E202o
		move.w	#$1B,d1
		move.w	#$10,d2
		move.w	8(a0),d4
		lea	byte_E950(pc),a2
		lea	(RAM_ObjRAM_Sonic).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.w	loc_F4FA
		cmpi.w	#$FFFE,d4
		bne.s	loc_E84E
		bsr.s	sub_E870

loc_E84E:				; CODE XREF: ROM:0000E84Aj
		movem.l	(sp)+,d1-d4
		lea	(RAM_ObjRAM_Tails).w,a1
		moveq	#4,d6
		bsr.w	loc_F4FA
		cmpi.w	#$FFFE,d4
		bne.s	loc_E864
		bsr.s	sub_E870

loc_E864:				; CODE XREF: ROM:0000E860j
		lea	(Ani_Obj41).l,a1
		bra.w	AnimateSprite
; ===============================================================================
		rts

; =============== S U B R O U T I N E ==========================================


sub_E870:				; CODE XREF: ROM:0000E84Cp
					; ROM:0000E862p
		move.w	#$500,$1C(a0)
		move.w	$30(a0),$12(a1)
		neg.w	$12(a1)
		move.w	$30(a0),$10(a1)
		subq.w	#6,$C(a1)
		addq.w	#6,8(a1)
		bset	#0,$22(a1)
		btst	#0,$22(a0)
		bne.s	loc_E8AC
		bclr	#0,$22(a1)
		subi.w	#$C,8(a1)
		neg.w	$10(a1)

loc_E8AC:				; CODE XREF: sub_E870+2Aj
		bset	#1,$22(a1)
		bclr	#3,$22(a1)
		move.b	#2,$24(a1)
		move.b	$28(a0),d0
		btst	#0,d0
		beq.s	loc_E902
		move.w	#1,$14(a1)
		move.b	#1,$27(a1)
		move.b	#0,$1C(a1)
		move.b	#1,$2C(a1)
		move.b	#8,$2D(a1)
		btst	#1,d0
		bne.s	loc_E8F2
		move.b	#3,$2C(a1)

loc_E8F2:				; CODE XREF: sub_E870+7Aj
		btst	#0,$22(a1)
		beq.s	loc_E902
		neg.b	$27(a1)
		neg.w	$14(a1)

loc_E902:				; CODE XREF: sub_E870+56j sub_E870+88j
		andi.b	#$C,d0
		cmpi.b	#4,d0
		bne.s	loc_E918
		move.b	#$C,$3E(a1)
		move.b	#$D,$3F(a1)

loc_E918:				; CODE XREF: sub_E870+9Aj
		cmpi.b	#8,d0
		bne.s	loc_E92A
		move.b	#$E,$3E(a1)
		move.b	#$F,$3F(a1)

loc_E92A:				; CODE XREF: sub_E870+ACj
		move.w	#$CC,d0	; ''
		jmp	(PlaySound_Special).l
; End of function sub_E870

; ===============================================================================
byte_E934:	dc.b $10,$10,$10,$10	; 0 ; DATA XREF: ROM:0000E6FEt
		dc.b $10,$10,$10,$10	; 4
		dc.b $10,$10,$10,$10	; 8
		dc.b  $E, $C, $A,  8	; 12
		dc.b   6,  4,  2,  0	; 16
		dc.b $FE,$FC,$FC,$FC	; 20
		dc.b $FC,$FC,$FC,$FC	; 24
byte_E950:	dc.b $F4,$F0,$F0,$F0	; 0 ; DATA XREF: ROM:0000E834t
		dc.b $F0,$F0,$F0,$F0	; 4
		dc.b $F0,$F0,$F0,$F0	; 8
		dc.b $F2,$F4,$F6,$F8	; 12
		dc.b $FA,$FC,$FE,  0	; 16
		dc.b   2,  4,  4,  4	; 20
		dc.b   4,  4,  4,  4	; 24
Ani_Obj41:	dc.w byte_E978-Ani_Obj41 ; DATA	XREF: ROM:loc_E342o
					; ROM:0000E468o ...
		dc.w byte_E97B-Ani_Obj41
		dc.w byte_E987-Ani_Obj41
		dc.w byte_E98A-Ani_Obj41
		dc.w byte_E996-Ani_Obj41
		dc.w byte_E999-Ani_Obj41
byte_E978:	dc.b  $F,  0,$FF	; 0 ; DATA XREF: ROM:Ani_Obj41o
byte_E97B:	dc.b   0,  1,  0,  0,  2,  2,  2,  2; 0	; DATA XREF: ROM:0000E96Eo
		dc.b   2,  2,$FD,  0	; 8
byte_E987:	dc.b  $F,  3,$FF	; 0 ; DATA XREF: ROM:0000E970o
byte_E98A:	dc.b   0,  4,  3,  3,  5,  5,  5,  5; 0	; DATA XREF: ROM:0000E972o
		dc.b   5,  5,$FD,  2	; 8
byte_E996:	dc.b  $F,  7,$FF	; 0 ; DATA XREF: ROM:0000E974o
byte_E999:	dc.b   0,  8,  7,  7,  9,  9,  9,  9; 0	; DATA XREF: ROM:0000E976o
		dc.b   9,  9,$FD,  4,  0; 8
Map_Obj41_GHZ:	dc.w word_E9B2-Map_Obj41_GHZ ; DATA XREF: ROM:0000E208o
					; ROM:Map_Obj41_GHZo ...
		dc.w word_E9C4-Map_Obj41_GHZ
		dc.w word_E9CE-Map_Obj41_GHZ
		dc.w word_E9E8-Map_Obj41_GHZ
		dc.w word_E9F2-Map_Obj41_GHZ
		dc.w word_E9FC-Map_Obj41_GHZ
word_E9B2:	dc.w 2			; DATA XREF: ROM:Map_Obj41_GHZo
		dc.w $F80C,    0,    0,$FFF0; 0
		dc.w	$C,    4,    2,$FFF0; 4
word_E9C4:	dc.w 1			; DATA XREF: ROM:0000E9A8o
		dc.w	$C,    0,    0,$FFF0; 0
word_E9CE:	dc.w 3			; DATA XREF: ROM:0000E9AAo
		dc.w $E80C,    0,    0,$FFF0; 0
		dc.w $F005,    8,    4,$FFF8; 4
		dc.w	$C,   $C,    6,$FFF0; 8
word_E9E8:	dc.w 1			; DATA XREF: ROM:0000E9ACo
		dc.b $F0,  7,  0,  0	; 0
		dc.b   0,  0,$FF,$F8	; 4
word_E9F2:	dc.w 1			; DATA XREF: ROM:0000E9AEo
		dc.w $F003,    4,    2,$FFF8; 0
word_E9FC:	dc.w 4			; DATA XREF: ROM:0000E9B0o
		dc.w $F003,    4,    2,	 $10; 0
		dc.w $F809,    8,    4,$FFF8; 4
		dc.w $F000,    0,    0,$FFF8; 8
		dc.w  $800,    3,    1,$FFF8; 12
Map_Obj41:	dc.w word_EA4A-Map_Obj41 ; DATA	XREF: ROM:0000E21Co
					; ROM:Map_Obj41o ...
		dc.w word_EA5C-Map_Obj41
		dc.w word_EA66-Map_Obj41
		dc.w word_EA78-Map_Obj41
		dc.w word_EA8A-Map_Obj41
		dc.w word_EA94-Map_Obj41
		dc.w word_EAA6-Map_Obj41
		dc.w word_EAB8-Map_Obj41
		dc.w word_EADA-Map_Obj41
		dc.w word_EAF4-Map_Obj41
		dc.w word_EB16-Map_Obj41
Map_Obj41a:	dc.w word_EA4A-Map_Obj41a ; DATA XREF: ROM:0000E2F0o
					; ROM:Map_Obj41ao ...
		dc.w word_EA5C-Map_Obj41a
		dc.w word_EA66-Map_Obj41a
		dc.w word_EA78-Map_Obj41a
		dc.w word_EA8A-Map_Obj41a
		dc.w word_EA94-Map_Obj41a
		dc.w word_EAA6-Map_Obj41a
		dc.w word_EB38-Map_Obj41a
		dc.w word_EB5A-Map_Obj41a
		dc.w word_EB74-Map_Obj41a
		dc.w word_EB96-Map_Obj41a
word_EA4A:	dc.w 2			; DATA XREF: ROM:Map_Obj41o
					; ROM:Map_Obj41ao
		dc.w $F00D,    0,    0,$FFF0; 0
		dc.w	 5,    8,    4,$FFF8; 4
word_EA5C:	dc.w 1			; DATA XREF: ROM:0000EA20o
					; ROM:0000EA36o
		dc.w $F80D,    0,    0,$FFF0; 0
word_EA66:	dc.w 2			; DATA XREF: ROM:0000EA22o
					; ROM:0000EA38o
		dc.w $E00D,    0,    0,$FFF0; 0
		dc.w $F007,   $C,    6,$FFF8; 4
word_EA78:	dc.w 2			; DATA XREF: ROM:0000EA24o
					; ROM:0000EA3Ao
		dc.w $F003,    0,    0,	   0; 0
		dc.w $F801,    4,    2,$FFF8; 4
word_EA8A:	dc.w 1			; DATA XREF: ROM:0000EA26o
					; ROM:0000EA3Co
		dc.w $F003,    0,    0,$FFF8; 0
word_EA94:	dc.w 2			; DATA XREF: ROM:0000EA28o
					; ROM:0000EA3Eo
		dc.w $F003,    0,    0,	 $10; 0
		dc.w $F809,    6,    3,$FFF8; 4
word_EAA6:	dc.w 2			; DATA XREF: ROM:0000EA2Ao
					; ROM:0000EA40o
		dc.w	$D,$1000,$1000,$FFF0; 0
		dc.w $F005,$1008,$1004,$FFF8; 4
word_EAB8:	dc.w 4			; DATA XREF: ROM:0000EA2Co
		dc.w $F00D,    0,    0,$FFF0; 0
		dc.w	 5,    8,    4,	   0; 4
		dc.w $FB05,   $C,    6,$FFF6; 8
		dc.w	 5,$201C,$200E,$FFF0; 12
word_EADA:	dc.w 3			; DATA XREF: ROM:0000EA2Eo
		dc.w $F60D,    0,    0,$FFEA; 0
		dc.w  $605,    8,    4,$FFFA; 4
		dc.w	 5,$201C,$200E,$FFF0; 8
word_EAF4:	dc.w 4			; DATA XREF: ROM:0000EA30o
		dc.w $E60D,    0,    0,$FFFB; 0
		dc.w $F605,    8,    4,	  $B; 4
		dc.w $F30B,  $10,    8,$FFF6; 8
		dc.w	 5,$201C,$200E,$FFF0; 12
word_EB16:	dc.w 4			; DATA XREF: ROM:0000EA32o
		dc.w	$D,$1000,$1000,$FFF0; 0
		dc.w $F005,$1008,$1004,	   0; 4
		dc.w $F505,$100C,$1006,$FFF6; 8
		dc.w $F005,$301C,$300E,$FFF0; 12
word_EB38:	dc.w 4			; DATA XREF: ROM:0000EA42o
		dc.w $F00D,    0,    0,$FFF0; 0
		dc.w	 5,    8,    4,	   0; 4
		dc.w $FB05,   $C,    6,$FFF6; 8
		dc.w	 5,  $1C,   $E,$FFF0; 12
word_EB5A:	dc.w 3			; DATA XREF: ROM:0000EA44o
		dc.w $F60D,    0,    0,$FFEA; 0
		dc.w  $605,    8,    4,$FFFA; 4
		dc.w	 5,  $1C,   $E,$FFF0; 8
word_EB74:	dc.w 4			; DATA XREF: ROM:0000EA46o
		dc.w $E60D,    0,    0,$FFFB; 0
		dc.w $F605,    8,    4,	  $B; 4
		dc.w $F30B,  $10,    8,$FFF6; 8
		dc.w	 5,  $1C,   $E,$FFF0; 12
word_EB96:	dc.w 4			; DATA XREF: ROM:0000EA48o
		dc.w	$D,$1000,$1000,$FFF0; 0
		dc.w $F005,$1008,$1004,	   0; 4
		dc.w $F505,$100C,$1006,$FFF6; 8
		dc.w $F005,$101C,$100E,$FFF0; 12
; ===============================================================================
;----------------------------------------------------
; Object 42 - GHZ Newtron badnik
;----------------------------------------------------

Obj42:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj42_Index(pc,d0.w),d1
		jmp	Obj42_Index(pc,d1.w)
; ===============================================================================
Obj42_Index:	dc.w loc_EBCC-Obj42_Index ; DATA XREF: ROM:Obj42_Indexo
					; ROM:0000EBC8o ...
		dc.w loc_EC00-Obj42_Index
		dc.w loc_ED6E-Obj42_Index
; ===============================================================================

loc_EBCC:				; DATA XREF: ROM:Obj42_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj32,4(a0)
		move.w	#$49B,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#4,1(a0)
		move.b	#4,$18(a0)
		move.b	#$14,$19(a0)
		move.b	#$10,$16(a0)
		move.b	#8,$17(a0)

loc_EC00:				; DATA XREF: ROM:0000EBC8o
		moveq	#0,d0
		move.b	$25(a0),d0
		move.w	off_EC1C(pc,d0.w),d1
		jsr	off_EC1C(pc,d1.w)
		lea	(Ani_Obj32).l,a1
		bsr.w	AnimateSprite
		bra.w	MarkObjGone
; ===============================================================================
off_EC1C:	dc.w loc_EC26-off_EC1C	; DATA XREF: ROM:off_EC1Co
					; ROM:0000EC1Eo ...
		dc.w loc_EC6C-off_EC1C
		dc.w loc_ECE0-off_EC1C
		dc.w loc_ED00-off_EC1C
		dc.w loc_ED06-off_EC1C
; ===============================================================================

loc_EC26:				; DATA XREF: ROM:off_EC1Co
		bset	#0,$22(a0)
		move.w	(RAM_ObjRam_Sonic+$8).w,d0
		sub.w	8(a0),d0
		bcc.s	loc_EC3E
		neg.w	d0
		bclr	#0,$22(a0)

loc_EC3E:				; CODE XREF: ROM:0000EC34j
		cmpi.w	#$80,d0	; ''
		bcc.s	locret_EC6A
		addq.b	#2,$25(a0)
		move.b	#1,$1C(a0)
		tst.b	$28(a0)
		beq.s	locret_EC6A
		move.w	#$249B,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#8,$25(a0)
		move.b	#4,$1C(a0)

locret_EC6A:				; CODE XREF: ROM:0000EC42j
					; ROM:0000EC52j
		rts
; ===============================================================================

loc_EC6C:				; DATA XREF: ROM:0000EC1Eo
		cmpi.b	#4,$1A(a0)
		bcc.s	loc_EC8C
		bset	#0,$22(a0)
		move.w	(RAM_ObjRam_Sonic+$8).w,d0
		sub.w	8(a0),d0
		bcc.s	locret_EC8A
		bclr	#0,$22(a0)

locret_EC8A:				; CODE XREF: ROM:0000EC82j
		rts
; ===============================================================================

loc_EC8C:				; CODE XREF: ROM:0000EC72j
		cmpi.b	#1,$1A(a0)
		bne.s	loc_EC9A
		move.b	#$C,$20(a0)

loc_EC9A:				; CODE XREF: ROM:0000EC92j
		bsr.w	ObjectFall
		bsr.w	ObjHitFloor
		tst.w	d1
		bpl.s	locret_ECDE
		add.w	d1,$C(a0)
		move.w	#0,$12(a0)
		addq.b	#2,$25(a0)
		move.b	#2,$1C(a0)
		btst	#5,2(a0)
		beq.s	loc_ECC6
		addq.b	#1,$1C(a0)

loc_ECC6:				; CODE XREF: ROM:0000ECC0j
		move.b	#$D,$20(a0)
		move.w	#$200,$10(a0)
		btst	#0,$22(a0)
		bne.s	locret_ECDE
		neg.w	$10(a0)

locret_ECDE:				; CODE XREF: ROM:0000ECA4j
					; ROM:0000ECD8j
		rts
; ===============================================================================

loc_ECE0:				; DATA XREF: ROM:0000EC20o
		bsr.w	SpeedToPos
		bsr.w	ObjHitFloor
		cmpi.w	#$FFF8,d1
		blt.s	loc_ECFA
		cmpi.w	#$C,d1
		bge.s	loc_ECFA
		add.w	d1,$C(a0)
		rts
; ===============================================================================

loc_ECFA:				; CODE XREF: ROM:0000ECECj
					; ROM:0000ECF2j
		addq.b	#2,$25(a0)
		rts
; ===============================================================================

loc_ED00:				; DATA XREF: ROM:0000EC22o
		bsr.w	SpeedToPos
		rts
; ===============================================================================

loc_ED06:				; DATA XREF: ROM:0000EC24o
		cmpi.b	#1,$1A(a0)
		bne.s	loc_ED14
		move.b	#$C,$20(a0)

loc_ED14:				; CODE XREF: ROM:0000ED0Cj
		cmpi.b	#2,$1A(a0)
		bne.s	locret_ED6C
		tst.b	$32(a0)
		bne.s	locret_ED6C
		move.b	#1,$32(a0)
		bsr.w	SingleObjectLoad
		bne.s	locret_ED6C
		move.b	#$23,0(a1) ; '#'
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		subq.w	#8,$C(a1)
		move.w	#$200,$10(a1)
		move.w	#$14,d0
		btst	#0,$22(a0)
		bne.s	loc_ED5C
		neg.w	d0
		neg.w	$10(a1)

loc_ED5C:				; CODE XREF: ROM:0000ED54j
		add.w	d0,8(a1)
		move.b	$22(a0),$22(a1)
		move.b	#1,$28(a1)

locret_ED6C:				; CODE XREF: ROM:0000ED1Aj
					; ROM:0000ED20j ...
		rts
; ===============================================================================

loc_ED6E:				; DATA XREF: ROM:0000EBCAo
		bra.w	DeleteObject
; ===============================================================================
Ani_Obj32:	dc.w byte_ED7C-Ani_Obj32 ; DATA	XREF: ROM:0000EC0Eo
					; ROM:Ani_Obj32o ...
		dc.w byte_ED7F-Ani_Obj32
		dc.w byte_ED87-Ani_Obj32
		dc.w byte_ED8B-Ani_Obj32
		dc.w byte_ED8F-Ani_Obj32
byte_ED7C:	dc.b  $F, $A,$FF	; 0 ; DATA XREF: ROM:Ani_Obj32o
byte_ED7F:	dc.b $13,  0,  1,  3,  4,  5,$FE,  1; 0	; DATA XREF: ROM:0000ED74o
byte_ED87:	dc.b   2,  6,  7,$FF	; 0 ; DATA XREF: ROM:0000ED76o
byte_ED8B:	dc.b   2,  8,  9,$FF	; 0 ; DATA XREF: ROM:0000ED78o
byte_ED8F:	dc.b $13,  0,  1,  1,  2,  1,  1,  0; 0	; DATA XREF: ROM:0000ED7Ao
		dc.b $FC		; 8
Map_Obj32:	dc.w word_EDAE-Map_Obj32 ; DATA	XREF: ROM:0000EBD0o
					; ROM:Map_Obj32o ...
		dc.w word_EDC8-Map_Obj32
		dc.w word_EDE2-Map_Obj32
		dc.w word_EDFC-Map_Obj32
		dc.w word_EE1E-Map_Obj32
		dc.w word_EE38-Map_Obj32
		dc.w word_EE4A-Map_Obj32
		dc.w word_EE64-Map_Obj32
		dc.w word_EE7E-Map_Obj32
		dc.w word_EE98-Map_Obj32
		dc.w word_EEB2-Map_Obj32
word_EDAE:	dc.w 3			; DATA XREF: ROM:Map_Obj32o
		dc.w $EC0D,    0,    0,$FFEC; 0
		dc.w $F400,    8,    4,	  $C; 4
		dc.w $FC0E,    9,    4,$FFF4; 8
word_EDC8:	dc.w 3			; DATA XREF: ROM:0000ED9Ao
		dc.w $EC06,  $15,   $A,$FFEC; 0
		dc.w $EC09,  $1B,   $D,$FFFC; 4
		dc.w $FC0A,  $21,  $10,$FFFC; 8
word_EDE2:	dc.w 3			; DATA XREF: ROM:0000ED9Co
		dc.w $EC06,  $2A,  $15,$FFEC; 0
		dc.w $EC09,  $1B,   $D,$FFFC; 4
		dc.w $FC0A,  $21,  $10,$FFFC; 8
word_EDFC:	dc.w 4			; DATA XREF: ROM:0000ED9Eo
		dc.w $EC06,  $30,  $18,$FFEC; 0
		dc.w $EC09,  $1B,   $D,$FFFC; 4
		dc.w $FC09,  $36,  $1B,$FFFC; 8
		dc.w  $C00,  $3C,  $1E,	  $C; 12
word_EE1E:	dc.w 3			; DATA XREF: ROM:0000EDA0o
		dc.w $F40D,  $3D,  $1E,$FFEC; 0
		dc.w $FC00,  $20,  $10,	  $C; 4
		dc.w  $408,  $45,  $22,$FFFC; 8
word_EE38:	dc.w 2			; DATA XREF: ROM:0000EDA2o
		dc.w $F80D,  $48,  $24,$FFEC; 0
		dc.w $F801,  $50,  $28,	  $C; 4
word_EE4A:	dc.w 3			; DATA XREF: ROM:0000EDA4o
		dc.w $F80D,  $48,  $24,$FFEC; 0
		dc.w $F801,  $50,  $28,	  $C; 4
		dc.w $FE00,  $52,  $29,	 $14; 8
word_EE64:	dc.w 3			; DATA XREF: ROM:0000EDA6o
		dc.w $F80D,  $48,  $24,$FFEC; 0
		dc.w $F801,  $50,  $28,	  $C; 4
		dc.w $FE04,  $53,  $29,	 $14; 8
word_EE7E:	dc.w 3			; DATA XREF: ROM:0000EDA8o
		dc.w $F80D,  $48,  $24,$FFEC; 0
		dc.w $F801,  $50,  $28,	  $C; 4
		dc.w $FE00,$E052,$E029,	 $14; 8
word_EE98:	dc.w 3			; DATA XREF: ROM:0000EDAAo
		dc.w $F80D,  $48,  $24,$FFEC; 0
		dc.w $F801,  $50,  $28,	  $C; 4
		dc.w $FE04,$E053,$E029,	 $14; 8
word_EEB2:	dc.w 0			; DATA XREF: ROM:0000EDACo
; ===============================================================================
;----------------------------------------------------
; Object 44 - GHZ wall
;----------------------------------------------------

Obj44:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj44_Index(pc,d0.w),d1
		jmp	Obj44_Index(pc,d1.w)
; ===============================================================================
Obj44_Index:	dc.w loc_EEC8-Obj44_Index ; DATA XREF: ROM:Obj44_Indexo
					; ROM:0000EEC4o ...
		dc.w loc_EF04-Obj44_Index
		dc.w loc_EF18-Obj44_Index
; ===============================================================================

loc_EEC8:				; DATA XREF: ROM:Obj44_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj44,4(a0)
		move.w	#$434C,2(a0)
		bsr.w	ModifySpriteAttr_2P
		ori.b	#4,1(a0)
		move.b	#8,$19(a0)
		move.b	#6,$18(a0)
		move.b	$28(a0),$1A(a0)
		bclr	#4,$1A(a0)
		beq.s	loc_EF04
		addq.b	#2,$24(a0)
		bra.s	loc_EF18
; ===============================================================================

loc_EF04:				; CODE XREF: ROM:0000EEFCj
					; DATA XREF: ROM:0000EEC4o
		move.w	#$13,d1
		move.w	#$28,d2	; '('
		move.w	d2,d3
		addq.w	#1,d3
		move.w	8(a0),d4
		bsr.w	SolidObject

loc_EF18:				; CODE XREF: ROM:0000EF02j
					; DATA XREF: ROM:0000EEC6o
		move.w	8(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.w	DeleteObject
		bra.w	DisplaySprite
; ===============================================================================
Map_Obj44:	dc.w word_EF36-Map_Obj44 ; DATA	XREF: ROM:0000EECCo
					; ROM:Map_Obj44o ...
		dc.w word_EF58-Map_Obj44
		dc.w word_EF7A-Map_Obj44
word_EF36:	dc.w 4			; DATA XREF: ROM:Map_Obj44o
		dc.w $E005,    4,    2,$FFF8; 0
		dc.w $F005,    8,    4,$FFF8; 4
		dc.w	 5,    8,    4,$FFF8; 8
		dc.w $1005,    8,    4,$FFF8; 12
word_EF58:	dc.w 4			; DATA XREF: ROM:0000EF32o
		dc.w $E005,    8,    4,$FFF8; 0
		dc.w $F005,    8,    4,$FFF8; 4
		dc.w	 5,    8,    4,$FFF8; 8
		dc.w $1005,    8,    4,$FFF8; 12
word_EF7A:	dc.w 4			; DATA XREF: ROM:0000EF34o
		dc.w $E005,    0,    0,$FFF8; 0
		dc.w $F005,    0,    0,$FFF8; 4
		dc.w	 5,    0,    0,$FFF8; 8
		dc.w $1005,    0,    0,$FFF8; 12
; ===============================================================================
;----------------------------------------------------
; Object 0D - end of level signpost
;----------------------------------------------------

Obj0D:
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj0D_Index(pc,d0.w),d1
		jsr	Obj0D_Index(pc,d1.w)
		lea	(Ani_Obj0D).l,a1
		bsr.w	AnimateSprite
		move.w	8(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.w	DeleteObject
		bra.w	DisplaySprite
; ===============================================================================
Obj0D_Index:	dc.w loc_EFD6-Obj0D_Index
		dc.w loc_EFFE-Obj0D_Index
		dc.w loc_F028-Obj0D_Index
		dc.w loc_F0C4-Obj0D_Index
		dc.w locret_F18A-Obj0D_Index
; ===============================================================================

loc_EFD6:
		addq.b	#2,$24(a0)
		move.l	#Map_Obj0D,4(a0)
		move.w	#$680,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#4,1(a0)
		move.b	#$18,$19(a0)
		move.b	#4,$18(a0)

loc_EFFE:
		move.w	(RAM_ObjRam_Sonic+$8).w,d0
		sub.w	8(a0),d0
		bcs.s	locret_F026
		cmpi.w	#$20,d0
		bcc.s	locret_F026
		move.w	#$CF,d0
		jsr	(PlaySound).l
		clr.b	(RAM_Flag_HudUpd_Timer).w
		move.w	(RAM_LevelSys_XPos_SetEnd).w,(RAM_LevelSys_XPos_SetStart).w
		addq.b	#2,$24(a0)

locret_F026:
		rts
; ===============================================================================

loc_F028:
		subq.w	#1,$30(a0)
		bpl.s	loc_F044
		move.w	#$3C,$30(a0)
		addq.b	#1,$1C(a0)
		cmpi.b	#3,$1C(a0)
		bne.s	loc_F044
		addq.b	#2,$24(a0)

loc_F044:
		subq.w	#1,$32(a0)
		bpl.s	locret_F0B2
		move.w	#$B,$32(a0)
		moveq	#0,d0
		move.b	$34(a0),d0
		addq.b	#2,$34(a0)
		andi.b	#$E,$34(a0)
		lea	dword_F0B4(pc,d0.w),a2
		bsr.w	SingleObjectLoad
		bne.s	locret_F0B2
		move.b	#$25,0(a1)
		move.b	#6,$24(a1)
		move.b	(a2)+,d0
		ext.w	d0
		add.w	8(a0),d0
		move.w	d0,8(a1)
		move.b	(a2)+,d0
		ext.w	d0
		add.w	$C(a0),d0
		move.w	d0,$C(a1)
		move.l	#Map_Obj25,4(a1)
		move.w	#$27B2,2(a1)
		bsr.w	ModifyA1SpriteAttr_2P
		move.b	#4,1(a1)
		move.b	#2,$18(a1)
		move.b	#8,$19(a1)

locret_F0B2:
		rts
; ===============================================================================
dword_F0B4:	dc.l $E8F00808
		dc.l $F00018F8
		dc.l $F81000
		dc.l $E8081810
; ===============================================================================

loc_F0C4:
		tst.w	(RAM_Flag_Debug_Placement).w
		bne.w	locret_F15E
		btst	#1,(RAM_ObjRam_Sonic+$22).w
		bne.s	loc_F0E0
		move.b	#1,(RAM_Flag_Sonic_IgnoreControl).w
		move.w	#$800,(RAM_Control_1_Hold_Copy).w

loc_F0E0:
		tst.b	(RAM_ObjRAM_Sonic).w
		beq.s	loc_F0F6
		move.w	(RAM_ObjRam_Sonic+$8).w,d0
		move.w	(RAM_LevelSys_XPos_SetEnd).w,d1
		addi.w	#$128,d1
		cmp.w	d1,d0
		bcs.s	locret_F15E

loc_F0F6:
		addq.b	#2,$24(a0)

; =============== S U B R O U T I N E ==========================================


GotThroughAct:
		tst.b	(RAM_ObjectTable+Obj_Slot_24).w
		bne.s	locret_F15E
		move.w	(RAM_LevelSys_XPos_SetEnd).w,(RAM_LevelSys_XPos_SetStart).w
		clr.b	(RAM_Flag_Sonic_Invincibility).w
		clr.b	(RAM_Flag_HudUpd_Timer).w
		move.b	#$3A,(RAM_ObjectTable+Obj_Slot_24).w
		moveq	#$10,d0
		jsr	(LoadPLC2).l
		move.b	#1,(RAM_Flag_HudUpd_Bonus).w
		moveq	#0,d0
		move.b	(RAM_Hud_Time+$1).w,d0
		mulu.w	#$3C,d0	; '<'
		moveq	#0,d1
		move.b	(RAM_Hud_Time+$2).w,d1
		add.w	d1,d0
		divu.w	#$F,d0
		moveq	#$14,d1
		cmp.w	d1,d0
		bcs.s	loc_F140
		move.w	d1,d0

loc_F140:
		add.w	d0,d0
		move.w	TimeBonuses(pc,d0.w),(RAM_Level_Bonus_Time).w
		move.w	(RAM_Sonic_CurrentRings).w,d0
		mulu.w	#$A,d0
		move.w	d0,(RAM_Level_Bonus_Rings).w
		move.w	#$8E,d0
		jsr	(PlaySound_Special).l

locret_F15E:
		rts

; ===============================================================================
TimeBonuses:	dc.w  5000, 5000, 1000,	 500
		dc.w   400,  400,  300,	 300
		dc.w   200,  200,  200,	 200
		dc.w   100,  100,  100,	 100
		dc.w	50,   50,   50,	  50
		dc.w	 0
; ===============================================================================

locret_F18A:
		rts
; ===============================================================================

Ani_Obj0D:	dc.w byte_F194-Ani_Obj0D ; DATA	XREF: ROM:0000EFAAo
					; ROM:Ani_Obj0Do ...
		dc.w byte_F197-Ani_Obj0D
		dc.w byte_F1A5-Ani_Obj0D
		dc.w byte_F1B3-Ani_Obj0D
byte_F194:	dc.b  $F,  2,$FF	; 0 ; DATA XREF: ROM:Ani_Obj0Do
byte_F197:	dc.b   1,  2,  3,  4,  5,  1,  3,  4; 0	; DATA XREF: ROM:0000F18Eo
		dc.b   5,  0,  3,  4,  5,$FF; 8
byte_F1A5:	dc.b   1,  2,  3,  4,  5,  1,  3,  4; 0	; DATA XREF: ROM:0000F190o
		dc.b   5,  0,  3,  4,  5,$FF; 8
byte_F1B3:	dc.b  $F,  0,$FF	; 0 ; DATA XREF: ROM:0000F192o
Map_Obj0D:	dc.w word_F1C2-Map_Obj0D ; DATA	XREF: ROM:0000EFDAo
					; ROM:Map_Obj0Do ...
		dc.w word_F1DC-Map_Obj0D
		dc.w word_F1F6-Map_Obj0D
		dc.w word_F210-Map_Obj0D
		dc.w word_F222-Map_Obj0D
		dc.w word_F234-Map_Obj0D
word_F1C2:	dc.w 3			; DATA XREF: ROM:Map_Obj0Do
		dc.w $F00B,    0,    0,$FFE8; 0
		dc.w $F00B, $800, $800,	   0; 4
		dc.w $1001,  $38,  $1C,$FFFC; 8
word_F1DC:	dc.w 3			; DATA XREF: ROM:0000F1B8o
		dc.w $F00B,   $C,    6,$FFE8; 0
		dc.w $F00B, $80C, $806,	   0; 4
		dc.w $1001,  $38,  $1C,$FFFC; 8
word_F1F6:	dc.w 3			; DATA XREF: ROM:0000F1BAo
		dc.w $F00B,  $18,   $C,$FFE8; 0
		dc.w $F00B, $818, $80C,	   0; 4
		dc.w $1001,  $38,  $1C,$FFFC; 8
word_F210:	dc.w 2			; DATA XREF: ROM:0000F1BCo
		dc.w $F00F,  $24,  $12,$FFF0; 0
		dc.w $1001,  $38,  $1C,$FFFC; 4
word_F222:	dc.w 2			; DATA XREF: ROM:0000F1BEo
		dc.w $F003,  $34,  $1A,$FFFC; 0
		dc.w $1001,  $38,  $1C,$FFFC; 4
word_F234:	dc.w 2			; DATA XREF: ROM:0000F1C0o
		dc.w $F00F, $824, $812,$FFF0; 0
		dc.w $1001,  $38,  $1C,$FFFC; 4
; ===============================================================================
		nop
;----------------------------------------------------
; Object 40 - GHZ Motobug
;----------------------------------------------------

Obj40:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	off_F256(pc,d0.w),d1
		jmp	off_F256(pc,d1.w)
; ===============================================================================
off_F256:	dc.w loc_F25E-off_F256	; DATA XREF: ROM:off_F256o
					; ROM:0000F258o ...
		dc.w loc_F2C6-off_F256
		dc.w loc_F36E-off_F256
		dc.w loc_F37C-off_F256
; ===============================================================================

loc_F25E:				; DATA XREF: ROM:off_F256o
		move.l	#Map_Obj40,4(a0)
		move.w	#$4E0,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#4,1(a0)
		move.b	#4,$18(a0)
		move.b	#$14,$19(a0)
		tst.b	$1C(a0)
		bne.s	loc_F2BE
		move.b	#$E,$16(a0)
		move.b	#8,$17(a0)
		move.b	#$C,$20(a0)
		bsr.w	ObjectFall
		jsr	ObjHitFloor
		tst.w	d1
		bpl.s	locret_F2BC
		add.w	d1,$C(a0)
		move.w	#0,$12(a0)
		addq.b	#2,$24(a0)
		bchg	#0,$22(a0)

locret_F2BC:				; CODE XREF: ROM:0000F2A6j
		rts
; ===============================================================================

loc_F2BE:				; CODE XREF: ROM:0000F286j
		addq.b	#4,$24(a0)
		bra.w	loc_F36E
; ===============================================================================

loc_F2C6:				; DATA XREF: ROM:0000F258o
		moveq	#0,d0
		move.b	$25(a0),d0
		move.w	off_F2E2(pc,d0.w),d1
		jsr	off_F2E2(pc,d1.w)
		lea	(Ani_Obj40).l,a1
		bsr.w	AnimateSprite
		bra.w	MarkObjGone
; ===============================================================================
off_F2E2:	dc.w loc_F2E6-off_F2E2	; DATA XREF: ROM:off_F2E2o
					; ROM:0000F2E4o
		dc.w loc_F30A-off_F2E2
; ===============================================================================

loc_F2E6:				; DATA XREF: ROM:off_F2E2o
		subq.w	#1,$30(a0)
		bpl.s	locret_F308
		addq.b	#2,$25(a0)
		move.w	#$FF00,$10(a0)
		move.b	#1,$1C(a0)
		bchg	#0,$22(a0)
		bne.s	locret_F308
		neg.w	$10(a0)

locret_F308:				; CODE XREF: ROM:0000F2EAj
					; ROM:0000F302j
		rts
; ===============================================================================

loc_F30A:				; DATA XREF: ROM:0000F2E4o
		bsr.w	SpeedToPos
		jsr	ObjHitFloor
		cmpi.w	#$FFF8,d1
		blt.s	loc_F356
		cmpi.w	#$C,d1
		bge.s	loc_F356
		add.w	d1,$C(a0)
		subq.b	#1,$33(a0)
		bpl.s	locret_F354
		move.b	#$F,$33(a0)
		bsr.w	SingleObjectLoad
		bne.s	locret_F354
		move.b	#$40,0(a1) ; '@'
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		move.b	$22(a0),$22(a1)
		move.b	#2,$1C(a1)

locret_F354:				; CODE XREF: ROM:0000F328j
					; ROM:0000F334j
		rts
; ===============================================================================

loc_F356:				; CODE XREF: ROM:0000F318j
					; ROM:0000F31Ej
		subq.b	#2,$25(a0)
		move.w	#$3B,$30(a0) ; ';'
		move.w	#0,$10(a0)
		move.b	#0,$1C(a0)
		rts
; ===============================================================================

loc_F36E:				; CODE XREF: ROM:0000F2C2j
					; DATA XREF: ROM:0000F25Ao
		lea	(Ani_Obj40).l,a1
		bsr.w	AnimateSprite
		bra.w	DisplaySprite
; ===============================================================================

loc_F37C:				; DATA XREF: ROM:0000F25Co
		bra.w	DeleteObject
; ===============================================================================
Ani_Obj40:	dc.w byte_F386-Ani_Obj40 ; DATA	XREF: ROM:0000F2D4o
					; ROM:loc_F36Eo ...
		dc.w byte_F389-Ani_Obj40
		dc.w byte_F38F-Ani_Obj40
byte_F386:	dc.b  $F,  2,$FF	; 0 ; DATA XREF: ROM:Ani_Obj40o
byte_F389:	dc.b   7,  0,  1,  0,  2,$FF; 0	; DATA XREF: ROM:0000F382o
byte_F38F:	dc.b   1,  3,  6,  3,  6,  4,  6,  4; 0	; DATA XREF: ROM:0000F384o
		dc.b   6,  4,  6,  5,$FC; 8
Map_Obj40:	dc.w word_F3AA-Map_Obj40 ; DATA	XREF: ROM:loc_F25Eo
					; ROM:Map_Obj40o ...
		dc.w word_F3CC-Map_Obj40
		dc.w word_F3EE-Map_Obj40
		dc.w word_F418-Map_Obj40
		dc.w word_F422-Map_Obj40
		dc.w word_F42C-Map_Obj40
		dc.w word_F436-Map_Obj40
word_F3AA:	dc.w 4			; DATA XREF: ROM:Map_Obj40o
		dc.w $F00D,    0,    0,$FFEC; 0
		dc.w	$C,    8,    4,$FFEC; 4
		dc.w $F801,   $C,    6,	  $C; 8
		dc.w  $808,   $E,    7,$FFF4; 12
word_F3CC:	dc.w 4			; DATA XREF: ROM:0000F39Eo
		dc.w $F10D,    0,    0,$FFEC; 0
		dc.w  $10C,    8,    4,$FFEC; 4
		dc.w $F901,   $C,    6,	  $C; 8
		dc.w  $908,  $11,    8,$FFF4; 12
word_F3EE:	dc.w 5			; DATA XREF: ROM:0000F3A0o
word_F3F0:	dc.w $F00D,    0,    0,$FFEC; 0
		dc.w	$C,  $14,   $A,$FFEC; 4
		dc.w $F801,   $C,    6,	  $C; 8
		dc.w  $804,  $18,   $C,$FFEC; 12
		dc.w  $804,  $12,    9,$FFFC; 16
word_F418:	dc.w 1			; DATA XREF: ROM:0000F3A2o
		dc.w $FA00,  $1A,   $D,	 $10; 0
word_F422:	dc.w 1			; DATA XREF: ROM:0000F3A4o
		dc.w $FA00,  $1B,   $D,	 $10; 0
word_F42C:	dc.w 1			; DATA XREF: ROM:0000F3A6o
		dc.w $FA00,  $1C,   $E,	 $10; 0
word_F436:	dc.w 0			; DATA XREF: ROM:0000F3A8o

; =============== S U B R O U T I N E ==========================================


SolidObject:
		lea	(RAM_ObjRAM_Sonic).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.s	sub_F456
		movem.l	(sp)+,d1-d4
		lea	(RAM_ObjRAM_Tails).w,a1
		tst.b	1(a1)
		bpl.w	locret_F490
		addq.b	#1,d6
; End of function SolidObject


; =============== S U B R O U T I N E ==========================================


sub_F456:				; CODE XREF: SolidObject+Ap

; FUNCTION CHUNK AT 0000F684 SIZE 0000008A BYTES

		btst	d6,$22(a0)
		beq.w	loc_F590
		move.w	d1,d2
		add.w	d2,d2
		btst	#1,$22(a1)
		bne.s	loc_F47A
		move.w	8(a1),d0
		sub.w	8(a0),d0
		add.w	d1,d0
		bmi.s	loc_F47A
		cmp.w	d2,d0
		bcs.s	loc_F488

loc_F47A:				; CODE XREF: sub_F456+12j sub_F456+1Ej
		bclr	#3,$22(a1)
		bclr	d6,$22(a0)
		moveq	#0,d4
		rts
; ===============================================================================

loc_F488:				; CODE XREF: sub_F456+22j
		move.w	d4,d2
		bsr.w	sub_F70E
		moveq	#0,d4

locret_F490:				; CODE XREF: SolidObject+18j
		rts
; ===============================================================================
		lea	(RAM_ObjRAM_Sonic).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.s	loc_F4A8
		movem.l	(sp)+,d1-d4
		lea	(RAM_ObjRAM_Tails).w,a1
		addq.b	#1,d6

loc_F4A8:				; CODE XREF: ROM:0000E31Cp
					; ROM:0000E334p ...
		btst	d6,$22(a0)
		beq.w	loc_F598
		move.w	d1,d2
		add.w	d2,d2
		btst	#1,$22(a1)
		bne.s	loc_F4CC
		move.w	8(a1),d0
		sub.w	8(a0),d0
		add.w	d1,d0
		bmi.s	loc_F4CC
		cmp.w	d2,d0
		bcs.s	loc_F4DA

loc_F4CC:				; CODE XREF: sub_F456+64j sub_F456+70j
		bclr	#3,$22(a1)
		bclr	d6,$22(a0)
		moveq	#0,d4
		rts
; ===============================================================================

loc_F4DA:				; CODE XREF: sub_F456+74j
		move.w	d4,d2
		bsr.w	sub_F70E
		moveq	#0,d4
		rts
; ===============================================================================
		lea	(RAM_ObjRAM_Sonic).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.s	loc_F4FA
		movem.l	(sp)+,d1-d4
		lea	(RAM_ObjRAM_Tails).w,a1
		addq.b	#1,d6

loc_F4FA:				; CODE XREF: ROM:0000E70Cp
					; ROM:0000E724p ...
		btst	d6,$22(a0)
		beq.w	loc_F536
		move.w	d1,d2
		add.w	d2,d2
		btst	#1,$22(a1)
		bne.s	loc_F51E
		move.w	8(a1),d0
		sub.w	8(a0),d0
		add.w	d1,d0
		bmi.s	loc_F51E
		cmp.w	d2,d0
		bcs.s	loc_F52C

loc_F51E:				; CODE XREF: sub_F456+B6j sub_F456+C2j
		bclr	#3,$22(a1)
		bclr	d6,$22(a0)
		moveq	#0,d4
		rts
; ===============================================================================

loc_F52C:				; CODE XREF: sub_F456+C6j
		move.w	d4,d2
		bsr.w	sub_F748
		moveq	#0,d4
		rts
; ===============================================================================

loc_F536:				; CODE XREF: sub_F456+A8j
		move.w	8(a1),d0
		sub.w	8(a0),d0
		add.w	d1,d0
		bmi.w	loc_F668
		move.w	d1,d3
		add.w	d3,d3
		cmp.w	d3,d0
		bhi.w	loc_F668
		move.w	d0,d5
		btst	#0,1(a0)
		beq.s	loc_F55C
		not.w	d5
		add.w	d3,d5

loc_F55C:				; CODE XREF: sub_F456+100j
		lsr.w	#1,d5
		move.b	(a2,d5.w),d3
		sub.b	(a2),d3
		ext.w	d3
		move.w	$C(a0),d5
		sub.w	d3,d5
		move.b	$16(a1),d3
		ext.w	d3
		add.w	d3,d2
		move.w	$C(a1),d3
		sub.w	d5,d3
		addq.w	#4,d3
		add.w	d2,d3
		bmi.w	loc_F668
		move.w	d2,d4
		add.w	d4,d4
		cmp.w	d4,d3
		bcc.w	loc_F668
		bra.w	loc_F5D2
; ===============================================================================

loc_F590:				; CODE XREF: sub_F456+4j
		tst.b	1(a0)
		bpl.w	loc_F668

loc_F598:				; CODE XREF: sub_F456+56j
		move.w	8(a1),d0
		sub.w	8(a0),d0
		add.w	d1,d0
		bmi.w	loc_F668
		move.w	d1,d3
		add.w	d3,d3
		cmp.w	d3,d0
		bhi.w	loc_F668
		move.b	$16(a1),d3
		ext.w	d3
		add.w	d3,d2
		move.w	$C(a1),d3
		sub.w	$C(a0),d3
		addq.w	#4,d3
		add.w	d2,d3
		bmi.w	loc_F668
		move.w	d2,d4
		add.w	d4,d4
		cmp.w	d4,d3
		bcc.w	loc_F668

loc_F5D2:				; CODE XREF: sub_F456+136j
		tst.b	(RAM_Flag_ControlLock).w
		bmi.w	loc_F668
		cmpi.b	#6,$24(a1)
		bcc.w	loc_F680
		tst.w	(RAM_Flag_Debug_Placement).w
		bne.w	loc_F680
		move.w	d0,d5
		cmp.w	d0,d1
		bcc.s	loc_F5FA
		add.w	d1,d1
		sub.w	d1,d0
		move.w	d0,d5
		neg.w	d5

loc_F5FA:				; CODE XREF: sub_F456+19Aj
		move.w	d3,d1
		cmp.w	d3,d2
		bcc.s	loc_F608
		subq.w	#4,d3
		sub.w	d4,d3
		move.w	d3,d1
		neg.w	d1

loc_F608:				; CODE XREF: sub_F456+1A8j
		cmp.w	d1,d5
		bhi.w	loc_F684
		cmpi.w	#4,d1
		bls.s	loc_F65A
		tst.w	d0
		beq.s	loc_F634
		bmi.s	loc_F622
		tst.w	$10(a1)
		bmi.s	loc_F634
		bra.s	loc_F628
; ===============================================================================

loc_F622:				; CODE XREF: sub_F456+1C2j
		tst.w	$10(a1)
		bpl.s	loc_F634

loc_F628:				; CODE XREF: sub_F456+1CAj
		move.w	#0,$14(a1)
		move.w	#0,$10(a1)

loc_F634:				; CODE XREF: sub_F456+1C0j
					; sub_F456+1C8j ...
		sub.w	d0,8(a1)
		btst	#1,$22(a1)
		bne.s	loc_F65A
		move.l	d6,d4
		addq.b	#2,d4
		bset	d4,$22(a0)
		bset	#5,$22(a1)
		move.w	d6,d4
		addi.b	#$D,d4
		bset	d4,d6
		moveq	#1,d4
		rts
; ===============================================================================

loc_F65A:				; CODE XREF: sub_F456+1BCj
					; sub_F456+1E8j
		bsr.s	sub_F678
		move.w	d6,d4
		addi.b	#$D,d4
		bset	d4,d6
		moveq	#1,d4
		rts
; ===============================================================================

loc_F668:				; CODE XREF: sub_F456+EAj sub_F456+F4j ...
		move.l	d6,d4
		addq.b	#2,d4
		btst	d4,$22(a0)
		beq.s	loc_F680
		move.w	#1,$1C(a1)
; End of function sub_F456


; =============== S U B R O U T I N E ==========================================


sub_F678:				; CODE XREF: sub_F456:loc_F65Ap
		move.l	d6,d4
		addq.b	#2,d4
		bclr	d4,$22(a0)

loc_F680:				; CODE XREF: sub_F456+18Aj
					; sub_F456+192j ...
		moveq	#0,d4
		rts
; End of function sub_F678

; ===============================================================================
; START	OF FUNCTION CHUNK FOR sub_F456

loc_F684:				; CODE XREF: sub_F456+1B4j
		tst.w	d3
		bmi.s	loc_F690
		cmpi.w	#$10,d3
		bcs.s	loc_F6D2
		bra.s	loc_F668
; ===============================================================================

loc_F690:				; CODE XREF: sub_F456+230j
		tst.w	$12(a1)
		beq.s	loc_F6B2
		bpl.s	loc_F6A6
		tst.w	d3
		bpl.s	loc_F6A6
		sub.w	d3,$C(a1)
		move.w	#0,$12(a1)

loc_F6A6:				; CODE XREF: sub_F456+240j
					; sub_F456+244j ...
		move.w	d6,d4
		addi.b	#$F,d4
		bset	d4,d6
		moveq	#$FFFFFFFE,d4
		rts
; ===============================================================================

loc_F6B2:				; CODE XREF: sub_F456+23Ej
		btst	#1,$22(a1)
		bne.s	loc_F6A6
		move.l	a0,-(sp)
		movea.l	a1,a0
		jsr	KillSonic
		movea.l	(sp)+,a0
		move.w	d6,d4
		addi.b	#$F,d4
		bset	d4,d6
		moveq	#$FFFFFFFE,d4
		rts
; ===============================================================================

loc_F6D2:				; CODE XREF: sub_F456+236j
		subq.w	#4,d3
		moveq	#0,d1
		move.b	$19(a0),d1
		move.w	d1,d2
		add.w	d2,d2
		add.w	8(a1),d1
		sub.w	8(a0),d1
		bmi.s	loc_F70A
		cmp.w	d2,d1
		bcc.s	loc_F70A
		tst.w	$12(a1)
		bmi.s	loc_F70A
		sub.w	d3,$C(a1)
		subq.w	#1,$C(a1)
		bsr.w	sub_F8F8
		move.w	d6,d4
		addi.b	#$11,d4
		bset	d4,d6
		moveq	#$FFFFFFFF,d4
		rts
; ===============================================================================

loc_F70A:				; CODE XREF: sub_F456+290j
					; sub_F456+294j ...
		moveq	#0,d4
		rts
; END OF FUNCTION CHUNK	FOR sub_F456

; =============== S U B R O U T I N E ==========================================


sub_F70E:
		move.w	$C(a0),d0
		sub.w	d3,d0
		bra.s	loc_F71E
; ===============================================================================
		move.w	$C(a0),d0
		subi.w	#9,d0

loc_F71E:				; CODE XREF: sub_F70E+6j
		tst.b	(RAM_Flag_ControlLock).w
		bmi.s	locret_F746
		cmpi.b	#6,$24(a1)
		bcc.s	locret_F746
		tst.w	(RAM_Flag_Debug_Placement).w
		bne.s	locret_F746
		moveq	#0,d1
		move.b	$16(a1),d1
		sub.w	d1,d0
		move.w	d0,$C(a1)
		sub.w	8(a0),d2
		sub.w	d2,8(a1)

locret_F746:
		rts


; =============== S U B R O U T I N E ==========================================


sub_F748:				; CODE XREF: sub_F456+D8p sub_F7F2+34p
		btst	#3,$22(a1)
		beq.s	locret_F788
		move.w	8(a1),d0
		sub.w	8(a0),d0
		add.w	d1,d0
		lsr.w	#1,d0
		btst	#0,1(a0)
		beq.s	loc_F768
		not.w	d0
		add.w	d1,d0

loc_F768:				; CODE XREF: sub_F748+1Aj
		move.b	(a2,d0.w),d1
		ext.w	d1
		move.w	$C(a0),d0
		sub.w	d1,d0
		moveq	#0,d1
		move.b	$16(a1),d1
		sub.w	d1,d0
		move.w	d0,$C(a1)
		sub.w	8(a0),d2
		sub.w	d2,8(a1)

locret_F788:				; CODE XREF: sub_F748+6j
		rts
; End of function sub_F748


; =============== S U B R O U T I N E ==========================================


sub_F78A:				; CODE XREF: ROM:000088DAp sub_8DD6+Cp ...
		lea	(RAM_ObjRAM_Sonic).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.s	sub_F7A0
		movem.l	(sp)+,d1-d4
		lea	(RAM_ObjRAM_Tails).w,a1
		addq.b	#1,d6
; End of function sub_F78A


; =============== S U B R O U T I N E ==========================================


sub_F7A0:				; CODE XREF: sub_F78A+Ap
		btst	d6,$22(a0)
		beq.w	loc_F89E
		move.w	d1,d2
		add.w	d2,d2
		btst	#1,$22(a1)
		bne.s	loc_F7C4
		move.w	8(a1),d0
		sub.w	8(a0),d0
		add.w	d1,d0
		bmi.s	loc_F7C4
		cmp.w	d2,d0
		bcs.s	loc_F7D2

loc_F7C4:				; CODE XREF: sub_F7A0+12j sub_F7A0+1Ej
		bclr	#3,$22(a1)
		bclr	d6,$22(a0)
		moveq	#0,d4
		rts
; ===============================================================================

loc_F7D2:				; CODE XREF: sub_F7A0+22j
		move.w	d4,d2
		bsr.w	sub_F70E
		moveq	#0,d4
		rts
; End of function sub_F7A0


; =============== S U B R O U T I N E ==========================================


sub_F7DC:				; CODE XREF: sub_8CEC+Ep ROM:00014DEEj
		lea	(RAM_ObjRAM_Sonic).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.s	sub_F7F2
		movem.l	(sp)+,d1-d4
		lea	(RAM_ObjRAM_Tails).w,a1
		addq.b	#1,d6
; End of function sub_F7DC


; =============== S U B R O U T I N E ==========================================


sub_F7F2:				; CODE XREF: sub_F7DC+Ap

; FUNCTION CHUNK AT 0000F968 SIZE 00000038 BYTES

		btst	d6,$22(a0)
		beq.w	loc_F968
		move.w	d1,d2
		add.w	d2,d2
		btst	#1,$22(a1)
		bne.s	loc_F816
		move.w	8(a1),d0
		sub.w	8(a0),d0
		add.w	d1,d0
		bmi.s	loc_F816
		cmp.w	d2,d0
		bcs.s	loc_F824

loc_F816:				; CODE XREF: sub_F7F2+12j sub_F7F2+1Ej
		bclr	#3,$22(a1)
		bclr	d6,$22(a0)
		moveq	#0,d4
		rts
; ===============================================================================

loc_F824:				; CODE XREF: sub_F7F2+22j
		move.w	d4,d2
		bsr.w	sub_F748
		moveq	#0,d4
		rts
; End of function sub_F7F2


; =============== S U B R O U T I N E ==========================================


sub_F82E:				; CODE XREF: ROM:000083C2p
		lea	(RAM_ObjRAM_Sonic).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.s	sub_F844
		movem.l	(sp)+,d1-d4
		lea	(RAM_ObjRAM_Tails).w,a1
		addq.b	#1,d6
; End of function sub_F82E


; =============== S U B R O U T I N E ==========================================


sub_F844:				; CODE XREF: sub_F82E+Ap

; FUNCTION CHUNK AT 0000F9A0 SIZE 00000028 BYTES

		btst	d6,$22(a0)
		beq.w	loc_F9A0
		move.w	d1,d2
		add.w	d2,d2
		btst	#1,$22(a1)
		bne.s	loc_F868
		move.w	8(a1),d0
		sub.w	8(a0),d0
		add.w	d1,d0
		bmi.s	loc_F868
		cmp.w	d2,d0
		bcs.s	loc_F876

loc_F868:				; CODE XREF: sub_F844+12j sub_F844+1Ej
		bclr	#3,$22(a1)
		bclr	d6,$22(a0)
		moveq	#0,d4
		rts
; ===============================================================================

loc_F876:				; CODE XREF: sub_F844+22j
		move.w	d4,d2
		bsr.w	sub_F70E
		moveq	#0,d4
		rts
; End of function sub_F844


; =============== S U B R O U T I N E ==========================================


sub_F880:				; CODE XREF: sub_7DDA+66p
		tst.w	$12(a1)
		bmi.w	locret_F966
		move.w	8(a1),d0
		sub.w	8(a0),d0
		add.w	d1,d0
		bmi.w	locret_F966
		cmp.w	d2,d0
		bcc.w	locret_F966
		bra.s	loc_F8BC
; ===============================================================================

loc_F89E:				; CODE XREF: sub_F7A0+4j
		tst.w	$12(a1)
		bmi.w	locret_F966
		move.w	8(a1),d0
		sub.w	8(a0),d0
		add.w	d1,d0
		bmi.w	locret_F966
		add.w	d1,d1
		cmp.w	d1,d0
		bcc.w	locret_F966

loc_F8BC:				; CODE XREF: sub_F880+1Cj
		move.w	$C(a0),d0
		sub.w	d3,d0

loc_F8C2:				; CODE XREF: sub_F7F2+1AAj
					; sub_F844+180j
		move.w	$C(a1),d2
		move.b	$16(a1),d1
		ext.w	d1
		add.w	d2,d1
		addq.w	#4,d1
		sub.w	d1,d0
		bhi.w	locret_F966
		cmpi.w	#$FFF0,d0
		bcs.w	locret_F966
		tst.b	(RAM_Flag_ControlLock).w
		bmi.w	locret_F966
		cmpi.b	#6,$24(a1)
		bcc.w	locret_F966
		add.w	d0,d2
		addq.w	#3,d2
		move.w	d2,$C(a1)
; End of function sub_F880


; =============== S U B R O U T I N E ==========================================


sub_F8F8:				; CODE XREF: ROM:0000AF56p
					; sub_F456+2A4p ...
		btst	#3,$22(a1)
		beq.s	loc_F916
		moveq	#0,d0
		move.b	$3D(a1),d0
		lsl.w	#6,d0
		addi.l	#RAM_ObjectTable,d0
		movea.l	d0,a3
		bclr	#3,$22(a3)

loc_F916:				; CODE XREF: sub_F8F8+6j
		move.w	a0,d0
		subi.w	#$B000,d0
		lsr.w	#6,d0
		andi.w	#$7F,d0	; ''
		move.b	d0,$3D(a1)
		move.b	#0,$26(a1)
		move.w	#0,$12(a1)
		move.w	$10(a1),$14(a1)
		btst	#1,$22(a1)
		beq.s	loc_F95C
		move.l	a0,-(sp)
		movea.l	a1,a0
		move.w	a0,d1
		subi.w	#$B000,d1
		bne.s	loc_F954
		jsr	Sonic_ResetOnFloor
		bra.s	loc_F95A
; ===============================================================================

loc_F954:				; CODE XREF: sub_F8F8+52j
		jsr	Tails_ResetTailsOnFloor

loc_F95A:				; CODE XREF: sub_F8F8+5Aj
		movea.l	(sp)+,a0

loc_F95C:				; CODE XREF: sub_F8F8+46j
		bset	#3,$22(a1)
		bset	d6,$22(a0)

locret_F966:				; CODE XREF: sub_F880+4j sub_F880+12j	...
		rts
; End of function sub_F8F8

; ===============================================================================
; START	OF FUNCTION CHUNK FOR sub_F7F2

loc_F968:				; CODE XREF: sub_F7F2+4j
		tst.w	$12(a1)
		bmi.w	locret_F966
		move.w	8(a1),d0
		sub.w	8(a0),d0
		add.w	d1,d0
		bmi.s	locret_F966
		add.w	d1,d1
		cmp.w	d1,d0
		bcc.s	locret_F966
		btst	#0,1(a0)
		beq.s	VInt_12E
		not.w	d0
		add.w	d1,d0

VInt_12E:				; CODE XREF: sub_F7F2+196j
		lsr.w	#1,d0
		move.b	(a2,d0.w),d3
		ext.w	d3
		move.w	$C(a0),d0
		sub.w	d3,d0
		bra.w	loc_F8C2
; END OF FUNCTION CHUNK	FOR sub_F7F2
; ===============================================================================
; START	OF FUNCTION CHUNK FOR sub_F844

loc_F9A0:				; CODE XREF: sub_F844+4j
		tst.w	$12(a1)
		bmi.w	locret_F966
		move.w	8(a1),d0
		sub.w	8(a0),d0
		add.w	d1,d0
		bmi.w	locret_F966
		add.w	d1,d1
		cmp.w	d1,d0
		bcc.w	locret_F966
		move.w	$C(a0),d0
		sub.w	d3,d0
		bra.w	loc_F8C2
; END OF FUNCTION CHUNK	FOR sub_F844

; =============== S U B R O U T I N E ==========================================


sub_F9C8:				; CODE XREF: ROM:0000AEEAp
		move.w	d1,d2
		add.w	d2,d2
		lea	(RAM_ObjRAM_Sonic).w,a1
		btst	#1,$22(a1)
		bne.s	loc_F9E8
		move.w	8(a1),d0
		sub.w	8(a0),d0
		add.w	d1,d0
		bmi.s	loc_F9E8
		cmp.w	d2,d0
		bcs.s	locret_F9FA

loc_F9E8:				; CODE XREF: sub_F9C8+Ej sub_F9C8+1Aj
		bclr	#3,$22(a1)
		move.b	#2,$24(a0)
		bclr	#3,$22(a0)

locret_F9FA:				; CODE XREF: sub_F9C8+1Ej
		rts
; End of function sub_F9C8

; ===============================================================================
;----------------------------------------------------
; Object 01 - Sonic
;----------------------------------------------------

Obj01:
		tst.w	(RAM_Flag_Debug_Placement).w	;Is sonic turned into a object?
		beq.s	Obj01_Normal	;If not, branch
		jmp	DebugMode
; ===============================================================================

Obj01_Normal:
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj01_Index(pc,d0.w),d1
		jmp	Obj01_Index(pc,d1.w)
; ===============================================================================
Obj01_Index:	dc.w Obj01_Main-Obj01_Index
		dc.w Obj01_Control-Obj01_Index
		dc.w Obj01_Hurt-Obj01_Index
		dc.w Obj01_Death-Obj01_Index
		dc.w Obj01_ResetLevel-Obj01_Index
; ===============================================================================

Obj01_Main:
		addq.b	#2,$24(a0)		;Next routine
		move.b	#$13,$16(a0)
		move.b	#9,$17(a0)
		move.l	#Map_Sonic,4(a0)	;Load sonic mappings to $4(a0)
		move.w	#$780,2(a0)		;VRAM location
		bsr.w	ModifySpriteAttr_2P
		move.b	#2,$18(a0)
		move.b	#$18,$19(a0)
		move.b	#4,1(a0)
		move.w	#$600,(RAM_Sonic_TopSpeed).w
		move.w	#$C,(RAM_Sonic_Acceleration).w
		move.w	#$80,(RAM_Sonic_Deceleration).w
		move.b	#$C,$3E(a0)
		move.b	#$D,$3F(a0)
		move.b	#0,$2C(a0)
		move.b	#4,$2D(a0)
		move.w	#0,(RAM_Sonic_StaticsRecBuffer).w
		move.w	#$3F,d2	; '?'

loc_FA88:
		bsr.w	CopySonicMovesForTails
		move.w	#0,(a1,d0.w)
		dbf	d2,loc_FA88

Obj01_Control:
		tst.w	(RAM_Flag_DebugMode).w
		beq.s	loc_FAB0
		btst	#4,(RAM_Control_1_Press).w
		beq.s	loc_FAB0
		move.w	#1,(RAM_Flag_Debug_Placement).w
		clr.b	(RAM_Flag_Sonic_IgnoreControl).w
		rts
; ===============================================================================

loc_FAB0:
		tst.b	(RAM_Flag_Sonic_IgnoreControl).w
		bne.s	loc_FABC
		move.w	(RAM_Control_1_Hold).w,(RAM_Control_1_Hold_Copy).w

loc_FABC:
		btst	#0,(RAM_Flag_ControlLock).w	;Are the controls locked?
		bne.s	Obj01_ControlsLock      ;If yes, branch
		moveq	#0,d0
		move.b	$22(a0),d0
		andi.w	#6,d0
		move.w	Obj01_Modes(pc,d0.w),d1
		jsr	Obj01_Modes(pc,d1.w)

Obj01_ControlsLock:
		bsr.s	Sonic_Display
		bsr.w	CopySonicMovesForTails
		bsr.w	Sonic_Water
		move.b	(RAM_Sonic_CurrAngle_Front).w,$36(a0)
		move.b	(RAM_Sonic_CurrAngle_Below).w,$37(a0)
		tst.b	(RAM_Flag_Sonic_Slide).w
		beq.s	loc_FAFE
		tst.b	$1C(a0)
		bne.s	loc_FAFE
		move.b	$1D(a0),$1C(a0)

loc_FAFE:
		bsr.w	Sonic_Animate
		tst.b	(RAM_Flag_ControlLock).w
		bmi.s	loc_FB0E
		jsr	TouchResponse

loc_FB0E:
		bra.w	LoadSonicDynPLC
; ===============================================================================
Obj01_Modes:	dc.w Obj01_MdNormal-Obj01_Modes
		dc.w Obj01_MdJump-Obj01_Modes
		dc.w Obj01_MdRoll-Obj01_Modes
		dc.w Obj01_MdJump2-Obj01_Modes
; ===============================================================================
MusicList_Sonic:dc.b $81,$82,$83,$84,$85,$86

; =============== S U B R O U T I N E ==========================================


Sonic_Display:
		move.w	$30(a0),d0
		beq.s	loc_FB2E
		subq.w	#1,$30(a0)
		lsr.w	#3,d0
		bcc.s	loc_FB34

loc_FB2E:
		jsr	DisplaySprite

loc_FB34:
		tst.b	(RAM_Flag_Sonic_Invincibility).w
		beq.s	loc_FB7A
		tst.w	$32(a0)
		beq.s	loc_FB7A
		bra.s	loc_FB7A
; ===============================================================================
		subq.w	#1,$32(a0)
		bne.s	loc_FB7A
		tst.b	(RAM_Level_BossMode).w
		bne.s	loc_FB74
		cmpi.w	#$C,(RAM_Sonic_AirLeft).w
		bcs.s	loc_FB74
		moveq	#0,d0
		move.b	(RAM_Level_CurrentZone).w,d0
		cmpi.w	#$103,(RAM_Level_CurrentZone).w
		bne.s	loc_FB66
		moveq	#5,d0

loc_FB66:
		lea	MusicList_Sonic(pc),a1
		move.b	(a1,d0.w),d0
		jsr	(PlaySound).l

loc_FB74:
		move.b	#0,(RAM_Flag_Sonic_Invincibility).w

loc_FB7A:
		tst.b	(RAM_Flag_Sonic_Shoes).w
		beq.s	locret_FBAE
		tst.w	$34(a0)
		beq.s	locret_FBAE
		subq.w	#1,$34(a0)
		bne.s	locret_FBAE
		move.w	#$600,(RAM_Sonic_TopSpeed).w
		move.w	#$C,(RAM_Sonic_Acceleration).w
		move.w	#$80,(RAM_Sonic_Deceleration).w
		move.b	#0,(RAM_Flag_Sonic_Shoes).w
		move.w	#$E3,d0
		jmp	(PlaySound).l
; ===============================================================================

locret_FBAE:
		rts

; =============== S U B R O U T I N E ==========================================


CopySonicMovesForTails:
		move.w	(RAM_Sonic_StaticsRecBuffer).w,d0
		lea	(RAM_Sonic_InvStarPosTable).w,a1
		lea	(a1,d0.w),a1
		move.w	8(a0),(a1)+
		move.w	$C(a0),(a1)+
		addq.b	#4,(RAM_TailsCPU_Random).w
		lea	(RAM_TailsCPU_CopiedPresses).w,a1
		move.w	(RAM_Control_1_Hold).w,(a1,d0.w)
		rts

; ===============================================================================
;----------------------------------------------------
; unused subroutine for	recording Sonic's position
;----------------------------------------------------

Unused_PosRecord:
		move.w	($FFFFEEE0).w,d0
		subq.b	#4,d0
		lea	(RAM_Stars_InvStarPosTable).w,a1
		lea	(a1,d0.w),a2
		move.w	8(a0),d1
		swap	d1
		move.w	$C(a0),d1
		cmp.l	(a2),d1
		beq.s	locret_FC02
		addq.b	#4,d0
		lea	(a1,d0.w),a2
		move.w	8(a0),(a2)+
		move.w	$C(a0),(a2)
		addq.b	#4,($FFFFEEE1).w

locret_FC02:
		rts

; =============== S U B R O U T I N E ==========================================


Sonic_Water:
		tst.b	(RAM_Flag_WaterLevel).w		;Is sonic underwater?
		bne.s	Obj01_InLevelWithWater		;If yes, branch

locret_FC0A:
		rts
; ===============================================================================

Obj01_InLevelWithWater:
		move.w	(RAM_Level_Water_Action).w,d0
		cmp.w	$C(a0),d0
		bge.s	Obj01_NotInWater
		bset	#6,$22(a0)
		bne.s	locret_FC0A
		bsr.w	ResumeMusic
		move.b	#$A,(RAM_ObjectTable+Obj_Slot_14).w
		move.b	#$81,(RAM_ObjectTable+Obj_Slot_14+$28).w
		move.w	#$300,(RAM_Sonic_TopSpeed).w
		move.w	#6,(RAM_Sonic_Acceleration).w
		move.w	#$40,(RAM_Sonic_Deceleration).w
		asr	$10(a0)
		asr	$12(a0)
		asr	$12(a0)
		beq.s	locret_FC0A
		move.b	#8,(RAM_ObjectTable+Obj_Slot_13).w
		move.w	#$AA,d0
		jmp	(PlaySound_Special).l
; ===============================================================================

Obj01_NotInWater:
		bclr	#6,$22(a0)
		beq.s	locret_FC0A
		bsr.w	ResumeMusic
		move.w	#$600,(RAM_Sonic_TopSpeed).w
		move.w	#$C,(RAM_Sonic_Acceleration).w
		move.w	#$80,(RAM_Sonic_Deceleration).w
		asl	$12(a0)
		beq.w	locret_FC0A
		move.b	#8,(RAM_ObjectTable+Obj_Slot_13).w
		cmpi.w	#$F000,$12(a0)
		bgt.s	loc_FC98
		move.w	#$F000,$12(a0)

loc_FC98:
		move.w	#$AA,d0
		jmp	(PlaySound_Special).l

; ===============================================================================

Obj01_MdNormal:
		bsr.w	Sonic_Spindash
		bsr.w	Sonic_Jump
		bsr.w	Sonic_SlopeResist
		bsr.w	Sonic_Move
		bsr.w	Sonic_Roll
		bsr.w	Sonic_LevelBoundaries
		jsr	SpeedToPos
		bsr.w	Sonic_AnglePos
		bsr.w	Sonic_SlopeRepel
		rts
; ===============================================================================

Obj01_MdJump:
		bsr.w	Sonic_JumpHeight
		bsr.w	Sonic_ChgJumpDir
		bsr.w	Sonic_LevelBoundaries
		jsr	ObjectFall
		btst	#6,$22(a0)
		beq.s	loc_FCEA
		subi.w	#$28,$12(a0)

loc_FCEA:
		bsr.w	Sonic_JumpAngle
		bsr.w	Sonic_Floor
		rts
; ===============================================================================

Obj01_MdRoll:
		bsr.w	Sonic_Jump
		bsr.w	Sonic_RollRepel
		bsr.w	Sonic_RollSpeed
		bsr.w	Sonic_LevelBoundaries
		jsr	SpeedToPos
		bsr.w	Sonic_AnglePos
		bsr.w	Sonic_SlopeRepel
		rts
; ===============================================================================

Obj01_MdJump2:
		bsr.w	Sonic_JumpHeight
		bsr.w	Sonic_ChgJumpDir
		bsr.w	Sonic_LevelBoundaries
		jsr	ObjectFall
		btst	#6,$22(a0)
		beq.s	loc_FD34
		subi.w	#$28,$12(a0)

loc_FD34:
		bsr.w	Sonic_JumpAngle
		bsr.w	Sonic_Floor
		rts

; =============== S U B R O U T I N E ==========================================


Sonic_Move:
		move.w	(RAM_Sonic_TopSpeed).w,d6
		move.w	(RAM_Sonic_Acceleration).w,d5
		move.w	(RAM_Sonic_Deceleration).w,d4
		tst.b	(RAM_Sonic_IgnoreCtrl_2).w
		bne.w	loc_FE58
		tst.w	$2E(a0)
		bne.w	loc_FE2C
		btst	#2,(RAM_Control_1_Hold_Copy).w
		beq.s	loc_FD66
		bsr.w	Sonic_MoveLeft

loc_FD66:
		btst	#3,(RAM_Control_1_Hold_Copy).w
		beq.s	loc_FD72
		bsr.w	Sonic_MoveRight

loc_FD72:
		move.b	$26(a0),d0
		addi.b	#$20,d0
		andi.b	#$C0,d0
		bne.w	loc_FE2C
		tst.w	$14(a0)
		bne.w	loc_FE2C
		bclr	#5,$22(a0)
		cmpi.b	#$B,$1C(a0)
		beq.s	loc_FD9E
		move.b	#5,$1C(a0)

loc_FD9E:
		btst	#3,$22(a0)
		beq.s	Sonic_Balance
		moveq	#0,d0
		move.b	$3D(a0),d0
		lsl.w	#6,d0
		lea	(RAM_ObjRAM_Sonic).w,a1
		lea	(a1,d0.w),a1
		tst.b	$22(a1)
		bmi.s	Sonic_LookUp
		moveq	#0,d1
		move.b	$19(a1),d1
		move.w	d1,d2
		add.w	d2,d2
		subq.w	#4,d2
		add.w	8(a0),d1
		sub.w	8(a1),d1
		cmpi.w	#4,d1
		blt.s	loc_FE00
		cmp.w	d2,d1
		bge.s	loc_FDF0
		bra.s	Sonic_LookUp
; ===============================================================================

Sonic_Balance:
		jsr	Sonic_HitFloor
		cmpi.w	#$C,d1
		blt.s	Sonic_LookUp
		cmpi.b	#3,$36(a0)
		bne.s	loc_FDF8

loc_FDF0:
		bclr	#0,$22(a0)
		bra.s	loc_FE06
; ===============================================================================

loc_FDF8:
		cmpi.b	#3,$37(a0)
		bne.s	Sonic_LookUp

loc_FE00:
		bset	#0,$22(a0)

loc_FE06:
		move.b	#6,$1C(a0)
		bra.s	loc_FE2C
; ===============================================================================

Sonic_LookUp:
		btst	#0,(RAM_Control_1_Hold_Copy).w
		beq.s	Sonic_Duck
		move.b	#7,$1C(a0)
		bra.s	loc_FE2C
; ===============================================================================

Sonic_Duck:
		btst	#1,(RAM_Control_1_Hold_Copy).w
		beq.s	loc_FE2C
		move.b	#8,$1C(a0)

loc_FE2C:
		move.b	(RAM_Control_1_Hold_Copy).w,d0
		andi.b	#$C,d0
		bne.s	loc_FE58
		move.w	$14(a0),d0
		beq.s	loc_FE58
		bmi.s	loc_FE4C
		sub.w	d5,d0
		bcc.s	loc_FE46
		move.w	#0,d0

loc_FE46:
		move.w	d0,$14(a0)
		bra.s	loc_FE58
; ===============================================================================

loc_FE4C:
		add.w	d5,d0
		bcc.s	loc_FE54
		move.w	#0,d0

loc_FE54:
		move.w	d0,$14(a0)

loc_FE58:
		move.b	$26(a0),d0
		jsr	(CalcSine).l
		muls.w	$14(a0),d1
		asr.l	#8,d1
		move.w	d1,$10(a0)
		muls.w	$14(a0),d0
		asr.l	#8,d0
		move.w	d0,$12(a0)

loc_FE76:
		move.b	$26(a0),d0
		addi.b	#$40,d0
		bmi.s	locret_FEF6
		move.b	#$40,d1
		tst.w	$14(a0)
		beq.s	locret_FEF6
		bmi.s	loc_FE8E
		neg.w	d1

loc_FE8E:
		move.b	$26(a0),d0
		add.b	d1,d0
		move.w	d0,-(sp)
		bsr.w	Sonic_WalkSpeed
		move.w	(sp)+,d0
		tst.w	d1
		bpl.s	locret_FEF6
		asl.w	#8,d1
		addi.b	#$20,d0
		andi.b	#$C0,d0
		beq.s	loc_FEF2
		cmpi.b	#$40,d0
		beq.s	loc_FED8
		cmpi.b	#$80,d0
		beq.s	loc_FED2
		cmpi.w	#$600,$10(a0)
		bge.s	Sonic_WallRecoil
		add.w	d1,$10(a0)
		bset	#5,$22(a0)
		move.w	#0,$14(a0)
		rts
; ===============================================================================

loc_FED2:
		sub.w	d1,$12(a0)
		rts
; ===============================================================================

loc_FED8:
		cmpi.w	#$FA00,$10(a0)
		ble.s	Sonic_WallRecoil
		sub.w	d1,$10(a0)
		bset	#5,$22(a0)
		move.w	#0,$14(a0)
		rts
; ===============================================================================

loc_FEF2:
		add.w	d1,$12(a0)

locret_FEF6:
		rts
; ===============================================================================

Sonic_WallRecoil:
		move.b	#4,$24(a0)
		bsr.w	Sonic_ResetOnFloor
		bset	#1,$22(a0)
		move.w	#$FE00,d0
		tst.w	$10(a0)
		bpl.s	Sonic_WallRecoil_Right
		neg.w	d0

Sonic_WallRecoil_Right:
		move.w	d0,$10(a0)
		move.w	#$FC00,$12(a0)
		move.w	#0,$14(a0)
		move.b	#$A,$1C(a0)
		move.b	#1,$25(a0)
		move.w	#$A3,d0	; ''
		jsr	(PlaySound_Special).l
		rts

; =============== S U B R O U T I N E ==========================================


Sonic_MoveLeft:
		move.w	$14(a0),d0
		beq.s	loc_FF44
		bpl.s	loc_FF70

loc_FF44:
		bset	#0,$22(a0)
		bne.s	loc_FF58
		bclr	#5,$22(a0)
		move.b	#1,$1D(a0)

loc_FF58:
		sub.w	d5,d0
		move.w	d6,d1
		neg.w	d1
		cmp.w	d1,d0
		bgt.s	loc_FF64
		move.w	d1,d0

loc_FF64:
		move.w	d0,$14(a0)
		move.b	#0,$1C(a0)
		rts
; ===============================================================================

loc_FF70:
		sub.w	d4,d0
		bcc.s	loc_FF78
		move.w	#$FF80,d0

loc_FF78:
		move.w	d0,$14(a0)
		move.b	$26(a0),d0
		addi.b	#$20,d0
		andi.b	#$C0,d0
		bne.s	locret_FFA6
		cmpi.w	#$400,d0
		blt.s	locret_FFA6
		move.b	#$D,$1C(a0)
		bclr	#0,$22(a0)
		move.w	#$A4,d0
		jsr	(PlaySound_Special).l

locret_FFA6:
		rts


; =============== S U B R O U T I N E ==========================================


Sonic_MoveRight:
		move.w	$14(a0),d0
		bmi.s	loc_FFD6
		bclr	#0,$22(a0)
		beq.s	loc_FFC2
		bclr	#5,$22(a0)
		move.b	#1,$1D(a0)

loc_FFC2:
		add.w	d5,d0
		cmp.w	d6,d0
		blt.s	loc_FFCA
		move.w	d6,d0

loc_FFCA:
		move.w	d0,$14(a0)
		move.b	#0,$1C(a0)
		rts
; ===============================================================================

loc_FFD6:
		add.w	d4,d0
		bcc.s	loc_FFDE
		move.w	#$80,d0

loc_FFDE:
		move.w	d0,$14(a0)
		move.b	$26(a0),d0
		addi.b	#$20,d0
		andi.b	#$C0,d0
		bne.s	locret_1000C
		cmpi.w	#$FC00,d0
		bgt.s	locret_1000C
		move.b	#$D,$1C(a0)

loc_FFFC:
		bset	#0,$22(a0)
		move.w	#$A4,d0

loc_10006:
		jsr	(PlaySound_Special).l

locret_1000C:
		rts


; =============== S U B R O U T I N E ==========================================


Sonic_RollSpeed:
		move.w	(RAM_Sonic_TopSpeed).w,d6
		asl.w	#1,d6
		move.w	(RAM_Sonic_Acceleration).w,d5
		asr.w	#1,d5
		move.w	(RAM_Sonic_Deceleration).w,d4
		asr.w	#2,d4
		tst.b	(RAM_Sonic_IgnoreCtrl_2).w
		bne.w	loc_1008A
		tst.w	$2E(a0)
		bne.s	loc_10046
		btst	#2,(RAM_Control_1_Hold_Copy).w
		beq.s	loc_1003A
		bsr.w	Sonic_RollLeft

loc_1003A:
		btst	#3,(RAM_Control_1_Hold_Copy).w
		beq.s	loc_10046
		bsr.w	Sonic_RollRight

loc_10046:
		move.w	$14(a0),d0
		beq.s	loc_10068
		bmi.s	loc_1005C
		sub.w	d5,d0
		bcc.s	loc_10056
		move.w	#0,d0

loc_10056:
		move.w	d0,$14(a0)
		bra.s	loc_10068
; ===============================================================================

loc_1005C:
		add.w	d5,d0
		bcc.s	loc_10064
		move.w	#0,d0

loc_10064:
		move.w	d0,$14(a0)

loc_10068:
		tst.w	$14(a0)
		bne.s	loc_1008A
		bclr	#2,$22(a0)
		move.b	#$13,$16(a0)
		move.b	#9,$17(a0)
		move.b	#5,$1C(a0)
		subq.w	#5,$C(a0)

loc_1008A:
		move.b	$26(a0),d0
		jsr	(CalcSine).l
		muls.w	$14(a0),d0
		asr.l	#8,d0
		move.w	d0,$12(a0)
		muls.w	$14(a0),d1
		asr.l	#8,d1
		cmpi.w	#$1000,d1
		ble.s	loc_100AE
		move.w	#$1000,d1

loc_100AE:
		cmpi.w	#$F000,d1
		bge.s	loc_100B8
		move.w	#$F000,d1

loc_100B8:
		move.w	d1,$10(a0)
		bra.w	loc_FE76


; =============== S U B R O U T I N E ==========================================


Sonic_RollLeft:
		move.w	$14(a0),d0
		beq.s	loc_100C8
		bpl.s	loc_100D6

loc_100C8:
		bset	#0,$22(a0)
		move.b	#2,$1C(a0)
		rts
; ===============================================================================

loc_100D6:
		sub.w	d4,d0
		bcc.s	loc_100DE
		move.w	#$FF80,d0

loc_100DE:
		move.w	d0,$14(a0)
		rts


; =============== S U B R O U T I N E ==========================================


Sonic_RollRight:
		move.w	$14(a0),d0
		bmi.s	loc_100F8
		bclr	#0,$22(a0)
		move.b	#2,$1C(a0)
		rts
; ===============================================================================

loc_100F8:
		add.w	d4,d0
		bcc.s	loc_10100
		move.w	#$80,d0

loc_10100:
		move.w	d0,$14(a0)
		rts


; =============== S U B R O U T I N E ==========================================


Sonic_ChgJumpDir:
		move.w	(RAM_Sonic_TopSpeed).w,d6
		move.w	(RAM_Sonic_Acceleration).w,d5
		asl.w	#1,d5
		btst	#4,$22(a0)
		bne.s	loc_10150
		move.w	$10(a0),d0
		btst	#2,(RAM_Control_1_Hold_Copy).w
		beq.s	loc_10136
		bset	#0,$22(a0)
		sub.w	d5,d0
		move.w	d6,d1
		neg.w	d1
		cmp.w	d1,d0
		bgt.s	loc_10136
		move.w	d1,d0

loc_10136:
		btst	#3,(RAM_Control_1_Hold_Copy).w
		beq.s	loc_1014C
		bclr	#0,$22(a0)
		add.w	d5,d0
		cmp.w	d6,d0
		blt.s	loc_1014C
		move.w	d6,d0

loc_1014C:
		move.w	d0,$10(a0)

loc_10150:
		cmpi.w	#$60,(RAM_LevelSys_ForceToYPos).w
		beq.s	loc_10162
		bcc.s	loc_1015E
		addq.w	#4,(RAM_LevelSys_ForceToYPos).w

loc_1015E:
		subq.w	#2,(RAM_LevelSys_ForceToYPos).w

loc_10162:
		cmpi.w	#$FC00,$12(a0)
		bcs.s	locret_10190
		move.w	$10(a0),d0
		move.w	d0,d1
		asr.w	#5,d1
		beq.s	locret_10190
		bmi.s	loc_10184
		sub.w	d1,d0
		bcc.s	loc_1017E
		move.w	#0,d0

loc_1017E:
		move.w	d0,$10(a0)
		rts
; ===============================================================================

loc_10184:
		sub.w	d1,d0
		bcs.s	loc_1018C
		move.w	#0,d0

loc_1018C:
		move.w	d0,$10(a0)

locret_10190:
		rts


; =============== S U B R O U T I N E ==========================================


Sonic_LevelBoundaries:
		move.l	8(a0),d1
		move.w	$10(a0),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,d1
		swap	d1
		move.w	(RAM_LevelSys_XPos_SetStart).w,d0
		addi.w	#$10,d0
		cmp.w	d1,d0
		bhi.s	loc_101FA
		move.w	(RAM_LevelSys_XPos_SetEnd).w,d0
		addi.w	#$128,d0
		tst.b	(RAM_Level_BossMode).w
		bne.s	loc_101C0
		addi.w	#$40,d0	; '@'

loc_101C0:
		cmp.w	d1,d0
		bls.s	loc_101FA

loc_101C4:
		move.w	(RAM_LevelSys_YPos_SetEnd).w,d0
		addi.w	#$E0,d0	; ''
		cmp.w	$C(a0),d0
		blt.s	loc_101D4
		rts
; ===============================================================================

loc_101D4:
		cmpi.w	#$501,(RAM_Level_CurrentZone).w
		bne.w	j_KillSonic
		cmpi.w	#$2000,(RAM_ObjRam_Sonic+$8).w
		bcs.w	j_KillSonic
		clr.b	(RAM_Level_LamppostCntr).w
		move.w	#1,(RAM_Flag_ResetLevel).w
		move.w	#$103,(RAM_Level_CurrentZone).w
		rts
; ===============================================================================

loc_101FA:
		move.w	d0,8(a0)
		move.w	#0,$A(a0)
		move.w	#0,$10(a0)
		move.w	#0,$14(a0)
		bra.s	loc_101C4

; =============== S U B R O U T I N E ==========================================


Sonic_Roll:
		tst.b	(RAM_Sonic_IgnoreCtrl_2).w
		bne.s	Obj01_NoRoll
		move.w	$14(a0),d0
		bpl.s	loc_10220
		neg.w	d0

loc_10220:
		cmpi.w	#$80,d0
		bcs.s	Obj01_NoRoll
		move.b	(RAM_Control_1_Hold_Copy).w,d0
		andi.b	#$C,d0
		bne.s	Obj01_NoRoll
		btst	#1,(RAM_Control_1_Hold_Copy).w
		bne.s	loc_1023A

Obj01_NoRoll:
		rts
; ===============================================================================

loc_1023A:
		btst	#2,$22(a0)
		beq.s	Obj01_DoRoll
		rts
; ===============================================================================

Obj01_DoRoll:
		bset	#2,$22(a0)
		move.b	#$E,$16(a0)
		move.b	#7,$17(a0)
		move.b	#2,$1C(a0)
		addq.w	#5,$C(a0)
		move.w	#$BE,d0
		jsr	(PlaySound_Special).l
		tst.w	$14(a0)
		bne.s	locret_10276
		move.w	#$200,$14(a0)

locret_10276:
		rts

; =============== S U B R O U T I N E ==========================================


Sonic_Jump:
		move.b	(RAM_Control_1_Press_Copy).w,d0
		andi.b	#$70,d0
		beq.w	locret_1031C
		moveq	#0,d0
		move.b	$26(a0),d0
		addi.b	#$80,d0
		bsr.w	sub_13102
		cmpi.w	#6,d1
		blt.w	locret_1031C
		move.w	#$680,d2
		btst	#6,$22(a0)
		beq.s	loc_102AA
		move.w	#$380,d2

loc_102AA:
		moveq	#0,d0
		move.b	$26(a0),d0
		subi.b	#$40,d0
		jsr	(CalcSine).l
		muls.w	d2,d1
		asr.l	#8,d1
		add.w	d1,$10(a0)
		muls.w	d2,d0
		asr.l	#8,d0
		add.w	d0,$12(a0)
		bset	#1,$22(a0)
		bclr	#5,$22(a0)
		addq.l	#4,sp
		move.b	#1,$3C(a0)
		clr.b	$38(a0)
		move.w	#$A0,d0
		jsr	(PlaySound_Special).l
		move.b	#$13,$16(a0)
		move.b	#9,$17(a0)
		btst	#2,$22(a0)
		bne.s	loc_1031E
		move.b	#$E,$16(a0)
		move.b	#7,$17(a0)
		move.b	#2,$1C(a0)
		bset	#2,$22(a0)
		addq.w	#5,$C(a0)

locret_1031C:
		rts
; ===============================================================================

loc_1031E:
		bset	#4,$22(a0)
		rts

; =============== S U B R O U T I N E ==========================================


Sonic_JumpHeight:
		tst.b	$3C(a0)
		beq.s	loc_10352
		move.w	#$FC00,d1
		btst	#6,$22(a0)
		beq.s	loc_1033C
		move.w	#$FE00,d1

loc_1033C:
		cmp.w	$12(a0),d1
		ble.s	locret_10350
		move.b	(RAM_Control_1_Hold_Copy).w,d0
		andi.b	#$70,d0
		bne.s	locret_10350
		move.w	d1,$12(a0)

locret_10350:
		rts
; ===============================================================================

loc_10352:
		cmpi.w	#$F040,$12(a0)
		bge.s	locret_10360
		move.w	#$F040,$12(a0)

locret_10360:
		rts


; =============== S U B R O U T I N E ==========================================


Sonic_Spindash:
		tst.b	$39(a0)
		bne.s	loc_10396
		cmpi.b	#8,$1C(a0)
		bne.s	locret_10394
		move.b	(RAM_Control_1_Press_Copy).w,d0
		andi.b	#$70,d0
		beq.w	locret_10394
		move.b	#9,$1C(a0)
		move.w	#$BE,d0
		jsr	(PlaySound_Special).l
		addq.l	#4,sp
		move.b	#1,$39(a0)

locret_10394:
		rts
; ===============================================================================

loc_10396:
		move.b	(RAM_Control_1_Hold_Copy).w,d0
		btst	#1,d0
		bne.s	loc_103DC
		move.b	#$E,$16(a0)
		move.b	#7,$17(a0)
		move.b	#2,$1C(a0)
		addq.w	#5,$C(a0)
		move.b	#0,$39(a0)
		move.w	#$2000,(RAM_LevelSys_WaitToScr).w
		move.w	#$800,$14(a0)
		btst	#0,$22(a0)
		beq.s	loc_103D4
		neg.w	$14(a0)

loc_103D4:
		bset	#2,$22(a0)
		rts
; ===============================================================================

loc_103DC:
		move.b	(RAM_Control_1_Press_Copy).w,d0
		andi.b	#$70,d0	; 'p'
		beq.w	loc_103EA
		nop

loc_103EA:
		addq.l	#4,sp
		rts


; =============== S U B R O U T I N E ==========================================


Sonic_SlopeResist:			; CODE XREF: ROM:0000FCAAp
		move.b	$26(a0),d0
		addi.b	#$60,d0	; '`'
		cmpi.b	#$C0,d0
		bcc.s	locret_10422
		move.b	$26(a0),d0

loc_10400:
		jsr	(CalcSine).l
		muls.w	#$20,d0	; ' '
		asr.l	#8,d0
		tst.w	$14(a0)
		beq.s	locret_10422
		bmi.s	loc_1041E
		tst.w	d0
		beq.s	locret_1041C
		add.w	d0,$14(a0)

locret_1041C:				; CODE XREF: Sonic_SlopeResist+28j
		rts
; ===============================================================================

loc_1041E:				; CODE XREF: Sonic_SlopeResist+24j
		add.w	d0,$14(a0)

locret_10422:				; CODE XREF: Sonic_SlopeResist+Cj
					; Sonic_SlopeResist+22j
		rts
; End of function Sonic_SlopeResist


; =============== S U B R O U T I N E ==========================================


Sonic_RollRepel:			; CODE XREF: ROM:0000FCF8p
		move.b	$26(a0),d0
		addi.b	#$60,d0	; '`'
		cmpi.b	#$C0,d0
		bcc.s	locret_1045E
		move.b	$26(a0),d0
		jsr	(CalcSine).l
		muls.w	#$50,d0	; 'P'
		asr.l	#8,d0
		tst.w	$14(a0)
		bmi.s	loc_10454
		tst.w	d0
		bpl.s	loc_1044E
		asr.l	#2,d0

loc_1044E:				; CODE XREF: Sonic_RollRepel+26j
		add.w	d0,$14(a0)
		rts
; ===============================================================================

loc_10454:				; CODE XREF: Sonic_RollRepel+22j
		tst.w	d0
		bmi.s	loc_1045A
		asr.l	#2,d0

loc_1045A:				; CODE XREF: Sonic_RollRepel+32j
		add.w	d0,$14(a0)

locret_1045E:				; CODE XREF: Sonic_RollRepel+Cj
		rts
; End of function Sonic_RollRepel


; =============== S U B R O U T I N E ==========================================


Sonic_SlopeRepel:			; CODE XREF: ROM:0000FCC4p
					; ROM:0000FD0Ep
		nop
		tst.b	$38(a0)
		bne.s	locret_1049A
		tst.w	$2E(a0)
		bne.s	loc_1049C
		move.b	$26(a0),d0
		addi.b	#$20,d0	; ' '
		andi.b	#$C0,d0
		beq.s	locret_1049A
		move.w	$14(a0),d0
		bpl.s	loc_10484
		neg.w	d0

loc_10484:				; CODE XREF: Sonic_SlopeRepel+20j
		cmpi.w	#$280,d0
		bcc.s	locret_1049A
		clr.w	$14(a0)
		bset	#1,$22(a0)
		move.w	#$1E,$2E(a0)

locret_1049A:				; CODE XREF: Sonic_SlopeRepel+6j
					; Sonic_SlopeRepel+1Aj	...
		rts
; ===============================================================================

loc_1049C:				; CODE XREF: Sonic_SlopeRepel+Cj
		subq.w	#1,$2E(a0)
		rts
; End of function Sonic_SlopeRepel


; =============== S U B R O U T I N E ==========================================


Sonic_JumpAngle:			; CODE XREF: ROM:loc_FCEAp
					; ROM:loc_FD34p
		move.b	$26(a0),d0
		beq.s	loc_104BC
		bpl.s	loc_104B2
		addq.b	#2,d0
		bcc.s	loc_104B0
		moveq	#0,d0

loc_104B0:				; CODE XREF: Sonic_JumpAngle+Aj
		bra.s	loc_104B8
; ===============================================================================

loc_104B2:				; CODE XREF: Sonic_JumpAngle+6j
		subq.b	#2,d0
		bcc.s	loc_104B8
		moveq	#0,d0

loc_104B8:				; CODE XREF: Sonic_JumpAngle:loc_104B0j
					; Sonic_JumpAngle+12j
		move.b	d0,$26(a0)

loc_104BC:				; CODE XREF: Sonic_JumpAngle+4j
		move.b	$27(a0),d0
		beq.s	locret_104FA
		tst.w	$14(a0)
		bmi.s	loc_104E0
		move.b	$2D(a0),d1
		add.b	d1,d0
		bcc.s	loc_104DE
		subq.b	#1,$2C(a0)
		bcc.s	loc_104DE
		move.b	#0,$2C(a0)
		moveq	#0,d0

loc_104DE:				; CODE XREF: Sonic_JumpAngle+2Cj
					; Sonic_JumpAngle+32j
		bra.s	loc_104F6
; ===============================================================================

loc_104E0:				; CODE XREF: Sonic_JumpAngle+24j
		move.b	$2D(a0),d1
		sub.b	d1,d0
		bcc.s	loc_104F6
		subq.b	#1,$2C(a0)
		bcc.s	loc_104F6
		move.b	#0,$2C(a0)
		moveq	#0,d0

loc_104F6:				; CODE XREF: Sonic_JumpAngle:loc_104DEj
					; Sonic_JumpAngle+44j ...
		move.b	d0,$27(a0)

locret_104FA:				; CODE XREF: Sonic_JumpAngle+1Ej
		rts
; End of function Sonic_JumpAngle


; =============== S U B R O U T I N E ==========================================


Sonic_Floor:				; CODE XREF: ROM:0000FCEEp
					; ROM:0000FD38p ...
		move.l	#RAM_Level_ColP,(RAM_Level_ColPointer).w
		cmpi.b	#$C,$3E(a0)
		beq.s	loc_10514
		move.l	#RAM_Level_ColS,(RAM_Level_ColPointer).w

loc_10514:				; CODE XREF: Sonic_Floor+Ej
		move.b	$3F(a0),d5
		move.w	$10(a0),d1
		move.w	$12(a0),d2
		jsr	(CalcAngle).l
		subi.b	#$20,d0	; ' '
		andi.b	#$C0,d0
		cmpi.b	#$40,d0	; '@'
		beq.w	loc_105E4
		cmpi.b	#$80,d0
		beq.w	loc_10646
		cmpi.b	#$C0,d0
		beq.w	loc_106A2
		bsr.w	Sonic_HitWall
		tst.w	d1
		bpl.s	loc_10558
		sub.w	d1,8(a0)
		move.w	#0,$10(a0)

loc_10558:				; CODE XREF: Sonic_Floor+50j
		bsr.w	sub_132EE
		tst.w	d1
		bpl.s	loc_1056A
		add.w	d1,8(a0)
		move.w	#0,$10(a0)

loc_1056A:				; CODE XREF: Sonic_Floor+62j
		bsr.w	loc_13146
		tst.w	d1
		bpl.s	locret_105E2
		move.b	$12(a0),d2
		addq.b	#8,d2
		neg.b	d2
		cmp.b	d2,d1
		bge.s	loc_10582
		cmp.b	d2,d0
		blt.s	locret_105E2

loc_10582:				; CODE XREF: Sonic_Floor+80j
		add.w	d1,$C(a0)
		move.b	d3,$26(a0)
		bsr.w	Sonic_ResetOnFloor
		move.b	#0,$1C(a0)
		move.b	d3,d0
		addi.b	#$20,d0	; ' '
		andi.b	#$40,d0	; '@'
		bne.s	loc_105C0
		move.b	d3,d0
		addi.b	#$10,d0
		andi.b	#$20,d0	; ' '
		beq.s	loc_105B2
		asr	$12(a0)
		bra.s	loc_105D4
; ===============================================================================

loc_105B2:				; CODE XREF: Sonic_Floor+AEj
		move.w	#0,$12(a0)
		move.w	$10(a0),$14(a0)
		rts
; ===============================================================================

loc_105C0:				; CODE XREF: Sonic_Floor+A2j
		move.w	#0,$10(a0)
		cmpi.w	#$FC0,$12(a0)
		ble.s	loc_105D4
		move.w	#$FC0,$12(a0)

loc_105D4:				; CODE XREF: Sonic_Floor+B4j
					; Sonic_Floor+D0j
		move.w	$12(a0),$14(a0)
		tst.b	d3
		bpl.s	locret_105E2
		neg.w	$14(a0)

locret_105E2:				; CODE XREF: Sonic_Floor+74j
					; Sonic_Floor+84j ...
		rts
; ===============================================================================

loc_105E4:				; CODE XREF: Sonic_Floor+36j
		bsr.w	Sonic_HitWall
		tst.w	d1
		bpl.s	loc_105FE
		sub.w	d1,8(a0)
		move.w	#0,$10(a0)
		move.w	$12(a0),$14(a0)
		rts
; ===============================================================================

loc_105FE:				; CODE XREF: Sonic_Floor+EEj
		bsr.w	Sonic_DontRunOnWalls
		tst.w	d1
		bpl.s	loc_10618
		sub.w	d1,$C(a0)
		tst.w	$12(a0)
		bpl.s	locret_10616
		move.w	#0,$12(a0)

locret_10616:				; CODE XREF: Sonic_Floor+112j
		rts
; ===============================================================================

loc_10618:				; CODE XREF: Sonic_Floor+108j
		tst.w	$12(a0)
		bmi.s	locret_10644
		bsr.w	loc_13146
		tst.w	d1
		bpl.s	locret_10644
		add.w	d1,$C(a0)
		move.b	d3,$26(a0)
		bsr.w	Sonic_ResetOnFloor
		move.b	#0,$1C(a0)
		move.w	#0,$12(a0)
		move.w	$10(a0),$14(a0)

locret_10644:				; CODE XREF: Sonic_Floor+120j
					; Sonic_Floor+128j
		rts
; ===============================================================================

loc_10646:				; CODE XREF: Sonic_Floor+3Ej
		bsr.w	Sonic_HitWall
		tst.w	d1
		bpl.s	loc_10658
		sub.w	d1,8(a0)
		move.w	#0,$10(a0)

loc_10658:				; CODE XREF: Sonic_Floor+150j
		bsr.w	sub_132EE
		tst.w	d1
		bpl.s	loc_1066A
		add.w	d1,8(a0)
		move.w	#0,$10(a0)

loc_1066A:				; CODE XREF: Sonic_Floor+162j
		bsr.w	Sonic_DontRunOnWalls
		tst.w	d1
		bpl.s	locret_106A0
		sub.w	d1,$C(a0)
		move.b	d3,d0
		addi.b	#$20,d0	; ' '
		andi.b	#$40,d0	; '@'
		bne.s	loc_1068A
		move.w	#0,$12(a0)
		rts
; ===============================================================================

loc_1068A:				; CODE XREF: Sonic_Floor+184j
		move.b	d3,$26(a0)
		bsr.w	Sonic_ResetOnFloor
		move.w	$12(a0),$14(a0)
		tst.b	d3
		bpl.s	locret_106A0
		neg.w	$14(a0)

locret_106A0:				; CODE XREF: Sonic_Floor+174j
					; Sonic_Floor+19Ej
		rts
; ===============================================================================

loc_106A2:				; CODE XREF: Sonic_Floor+46j
		bsr.w	sub_132EE
		tst.w	d1
		bpl.s	loc_106BC
		add.w	d1,8(a0)
		move.w	#0,$10(a0)
		move.w	$12(a0),$14(a0)
		rts
; ===============================================================================

loc_106BC:				; CODE XREF: Sonic_Floor+1ACj
		bsr.w	Sonic_DontRunOnWalls
		tst.w	d1
		bpl.s	loc_106D6
		sub.w	d1,$C(a0)
		tst.w	$12(a0)
		bpl.s	locret_106D4
		move.w	#0,$12(a0)

locret_106D4:				; CODE XREF: Sonic_Floor+1D0j
		rts
; ===============================================================================

loc_106D6:				; CODE XREF: Sonic_Floor+1C6j
		tst.w	$12(a0)
		bmi.s	locret_10702
		bsr.w	loc_13146
		tst.w	d1
		bpl.s	locret_10702
		add.w	d1,$C(a0)
		move.b	d3,$26(a0)
		bsr.w	Sonic_ResetOnFloor
		move.b	#0,$1C(a0)
		move.w	#0,$12(a0)
		move.w	$10(a0),$14(a0)

locret_10702:				; CODE XREF: Sonic_Floor+1DEj
					; Sonic_Floor+1E6j
		rts
; End of function Sonic_Floor


; =============== S U B R O U T I N E ==========================================


Sonic_ResetOnFloor:			; CODE XREF: sub_F8F8+54p
					; Sonic_Move+1C0p ...
		btst	#4,$22(a0)
		beq.s	loc_10712
		nop
		nop
		nop

loc_10712:				; CODE XREF: Sonic_ResetOnFloor+6j
		bclr	#5,$22(a0)
		bclr	#1,$22(a0)
		bclr	#4,$22(a0)
		btst	#2,$22(a0)
		beq.s	loc_10748
		bclr	#2,$22(a0)
		move.b	#$13,$16(a0)
		move.b	#9,$17(a0)
		move.b	#0,$1C(a0)
		subq.w	#5,$C(a0)

loc_10748:				; CODE XREF: Sonic_ResetOnFloor+26j
		move.b	#0,$3C(a0)
		move.w	#0,(RAM_Level_Enemy_FixPoints).w
		move.b	#0,$27(a0)
		rts
; End of function Sonic_ResetOnFloor

; ===============================================================================

Obj01_Hurt:				; DATA XREF: ROM:0000FA1Ao
		tst.b	$25(a0)
		bmi.w	loc_107E8
		jsr	SpeedToPos
		addi.w	#$30,$12(a0) ; '0'
		btst	#6,$22(a0)
		beq.s	loc_1077E
		subi.w	#$20,$12(a0) ; ' '

loc_1077E:				; CODE XREF: ROM:00010776j
		bsr.w	Sonic_HurtStop
		bsr.w	Sonic_LevelBoundaries
		bsr.w	CopySonicMovesForTails
		bsr.w	Sonic_Animate
		bsr.w	LoadSonicDynPLC
		jmp	DisplaySprite

; =============== S U B R O U T I N E ==========================================


Sonic_HurtStop:				; CODE XREF: ROM:loc_1077Ep
		move.w	(RAM_LevelSys_YPos_SetEnd).w,d0
		addi.w	#$E0,d0	; ''
		cmp.w	$C(a0),d0
		bcs.w	j_KillSonic
		bsr.w	Sonic_Floor
		btst	#1,$22(a0)
		bne.s	locret_107E6
		moveq	#0,d0
		move.w	d0,$12(a0)
		move.w	d0,$10(a0)
		move.w	d0,$14(a0)
		tst.b	$25(a0)
		beq.s	loc_107D6
		move.b	#$FF,$25(a0)
		move.b	#$B,$1C(a0)
		rts
; ===============================================================================

loc_107D6:				; CODE XREF: Sonic_HurtStop+2Ej
		move.b	#0,$1C(a0)
		subq.b	#2,$24(a0)
		move.w	#$78,$30(a0) ; 'x'

locret_107E6:				; CODE XREF: Sonic_HurtStop+1Aj
		rts
; End of function Sonic_HurtStop

; ===============================================================================

loc_107E8:				; CODE XREF: ROM:00010760j
		cmpi.b	#$B,$1C(a0)
		bne.s	loc_107FA
		move.b	(RAM_Control_1_Press).w,d0
		andi.b	#$7F,d0
		beq.s	loc_10804

loc_107FA:				; CODE XREF: ROM:000107EEj
		subq.b	#2,$24(a0)
		move.b	#0,$25(a0)

loc_10804:				; CODE XREF: ROM:000107F8j
		bsr.w	CopySonicMovesForTails
		bsr.w	Sonic_Animate
		bsr.w	LoadSonicDynPLC
		jmp	DisplaySprite
; ===============================================================================

Obj01_Death:				; DATA XREF: ROM:0000FA1Co
		bsr.w	Sonic_GameOver
		jsr	ObjectFall
		bsr.w	CopySonicMovesForTails
		bsr.w	Sonic_Animate
		bsr.w	LoadSonicDynPLC
		jmp	DisplaySprite

; =============== S U B R O U T I N E ==========================================


Sonic_GameOver:				; CODE XREF: ROM:Obj01_Deathp
		move.w	(RAM_LevelSys_YPos_SetEnd).w,d0
		addi.w	#$100,d0
		cmp.w	$C(a0),d0
		bcc.w	locret_108B4
		move.w	#$FFC8,$12(a0)
		addq.b	#2,$24(a0)
		clr.b	(RAM_Flag_HudUpd_Timer).w
		addq.b	#1,(RAM_Flag_HudUpd_Lives).w
		subq.b	#1,(RAM_Sonic_Lives).w
		bne.s	loc_10888
		move.w	#0,$3A(a0)
		move.b	#$39,(RAM_ObjectTable+Obj_Slot_3).w
		move.b	#$39,(RAM_ObjectTable+Obj_Slot_4).w
		move.b	#1,(RAM_ObjectTable+Obj_Slot_4+$1A).w
		clr.b	(RAM_Flag_Sonic_TimeOver).w

loc_10876:				; CODE XREF: Sonic_GameOver+80j
		move.w	#$8F,d0	; ''
		jsr	(PlaySound).l
		moveq	#3,d0
		jmp	(LoadPLC).l
; ===============================================================================

loc_10888:				; CODE XREF: Sonic_GameOver+26j
		move.w	#$3C,$3A(a0) ; '<'
		tst.b	(RAM_Flag_Sonic_TimeOver).w
		beq.s	locret_108B4
		move.w	#0,$3A(a0)
		move.b	#$39,(RAM_ObjectTable+Obj_Slot_3).w
		move.b	#$39,(RAM_ObjectTable+Obj_Slot_4).w
		move.b	#2,(RAM_ObjectTable+Obj_Slot_3+$1A).w
		move.b	#3,(RAM_ObjectTable+Obj_Slot_4+$1A).w
		bra.s	loc_10876
; ===============================================================================

locret_108B4:				; CODE XREF: Sonic_GameOver+Cj
					; Sonic_GameOver+60j
		rts
; End of function Sonic_GameOver

; ===============================================================================

Obj01_ResetLevel:			; DATA XREF: ROM:0000FA1Eo
		tst.w	$3A(a0)
		beq.s	locret_108C8
		subq.w	#1,$3A(a0)
		bne.s	locret_108C8
		move.w	#1,(RAM_Flag_ResetLevel).w

locret_108C8:				; CODE XREF: ROM:000108BAj
					; ROM:000108C0j
		rts

; =============== S U B R O U T I N E ==========================================


Sonic_Animate:				; CODE XREF: ROM:loc_FAFEp
					; ROM:0001078Ap ...

; FUNCTION CHUNK AT 0001095C SIZE 0000015E BYTES

		lea	(SonicAniData).l,a1
		moveq	#0,d0
		move.b	$1C(a0),d0
		cmp.b	$1D(a0),d0
		beq.s	loc_108EC
		move.b	d0,$1D(a0)
		move.b	#0,$1B(a0)
		move.b	#0,$1E(a0)

loc_108EC:				; CODE XREF: Sonic_Animate+10j
		add.w	d0,d0
		adda.w	(a1,d0.w),a1
		move.b	(a1),d0
		bmi.s	loc_1095C
		move.b	$22(a0),d1
		andi.b	#1,d1
		andi.b	#$FC,1(a0)
		or.b	d1,1(a0)
		subq.b	#1,$1E(a0)
		bpl.s	locret_1092A
		move.b	d0,$1E(a0)
; End of function Sonic_Animate


; =============== S U B R O U T I N E ==========================================


sub_10912:				; CODE XREF: Sonic_Animate+116p
					; Sonic_Animate+1BAj ...
		moveq	#0,d1
		move.b	$1B(a0),d1
		move.b	1(a1,d1.w),d0
		cmpi.b	#$F0,d0
		bcc.s	loc_1092C

loc_10922:				; CODE XREF: sub_10912+28j
					; sub_10912+3Cj
		move.b	d0,$1A(a0)
		addq.b	#1,$1B(a0)

locret_1092A:				; CODE XREF: Sonic_Animate+42j
					; Sonic_Animate+96j
		rts
; ===============================================================================

loc_1092C:				; CODE XREF: sub_10912+Ej
		addq.b	#1,d0
		bne.s	loc_1093C
		move.b	#0,$1B(a0)
		move.b	1(a1),d0
		bra.s	loc_10922
; ===============================================================================

loc_1093C:				; CODE XREF: sub_10912+1Cj
		addq.b	#1,d0
		bne.s	loc_10950
		move.b	2(a1,d1.w),d0
		sub.b	d0,$1B(a0)
		sub.b	d0,d1
		move.b	1(a1,d1.w),d0
		bra.s	loc_10922
; ===============================================================================

loc_10950:				; CODE XREF: sub_10912+2Cj
		addq.b	#1,d0
		bne.s	locret_1095A
		move.b	2(a1,d1.w),$1C(a0)

locret_1095A:				; CODE XREF: sub_10912+40j
		rts
; End of function sub_10912

; ===============================================================================
; START	OF FUNCTION CHUNK FOR Sonic_Animate

loc_1095C:				; CODE XREF: Sonic_Animate+2Aj
		subq.b	#1,$1E(a0)
		bpl.s	locret_1092A
		addq.b	#1,d0
		bne.w	loc_10A44
		moveq	#0,d0
		move.b	$27(a0),d0
		bne.w	loc_109EA
		moveq	#0,d1
		move.b	$26(a0),d0
		move.b	$22(a0),d2
		andi.b	#1,d2
		bne.s	loc_10984
		not.b	d0

loc_10984:				; CODE XREF: Sonic_Animate+B6j
		addi.b	#$10,d0
		bpl.s	loc_1098C
		moveq	#3,d1

loc_1098C:				; CODE XREF: Sonic_Animate+BEj
		andi.b	#$FC,1(a0)
		eor.b	d1,d2
		or.b	d2,1(a0)
		btst	#5,$22(a0)
		bne.w	loc_10A88
		lsr.b	#4,d0
		andi.b	#6,d0
		move.w	$14(a0),d2
		bpl.s	loc_109B0
		neg.w	d2

loc_109B0:				; CODE XREF: Sonic_Animate+E2j
		lea	(SonicAni_Run).l,a1
		cmpi.w	#$600,d2
		bcc.s	loc_109C2
		lea	(SonicAni_Walk).l,a1

loc_109C2:				; CODE XREF: Sonic_Animate+F0j
		move.b	d0,d1
		lsr.b	#1,d1
		add.b	d1,d0
		add.b	d0,d0
		add.b	d0,d0
		move.b	d0,d3
		neg.w	d2
		addi.w	#$800,d2
		bpl.s	loc_109D8
		moveq	#0,d2

loc_109D8:				; CODE XREF: Sonic_Animate+10Aj
		lsr.w	#8,d2
		lsr.w	#1,d2
		move.b	d2,$1E(a0)
		bsr.w	sub_10912
		add.b	d3,$1A(a0)
		rts
; ===============================================================================

loc_109EA:				; CODE XREF: Sonic_Animate+A4j
		move.b	$27(a0),d0
		moveq	#0,d1
		move.b	$22(a0),d2
		andi.b	#1,d2
		bne.s	loc_10A1E
		andi.b	#$FC,1(a0)
		moveq	#0,d2
		or.b	d2,1(a0)
		addi.b	#$B,d0
		divu.w	#$16,d0
		addi.b	#$9B,d0
		move.b	d0,$1A(a0)
		move.b	#0,$1E(a0)
		rts
; ===============================================================================

loc_10A1E:				; CODE XREF: Sonic_Animate+12Ej
		moveq	#3,d2
		andi.b	#$FC,1(a0)
		or.b	d2,1(a0)
		neg.b	d0
		addi.b	#$8F,d0
		divu.w	#$16,d0
		addi.b	#$9B,d0
		move.b	d0,$1A(a0)
		move.b	#0,$1E(a0)
		rts
; ===============================================================================

loc_10A44:				; CODE XREF: Sonic_Animate+9Aj
		addq.b	#1,d0
		bne.s	loc_10A88
		move.w	$14(a0),d2
		bpl.s	loc_10A50
		neg.w	d2

loc_10A50:				; CODE XREF: Sonic_Animate+182j
		lea	(SonicAni_Roll2).l,a1
		cmpi.w	#$600,d2
		bcc.s	loc_10A62
		lea	(SonicAni_Roll).l,a1

loc_10A62:				; CODE XREF: Sonic_Animate+190j
		neg.w	d2
		addi.w	#$400,d2
		bpl.s	loc_10A6C
		moveq	#0,d2

loc_10A6C:				; CODE XREF: Sonic_Animate+19Ej
		lsr.w	#8,d2
		move.b	d2,$1E(a0)
		move.b	$22(a0),d1
		andi.b	#1,d1
		andi.b	#$FC,1(a0)
		or.b	d1,1(a0)
		bra.w	sub_10912
; ===============================================================================

loc_10A88:				; CODE XREF: Sonic_Animate+D4j
					; Sonic_Animate+17Cj
		move.w	$14(a0),d2
		bmi.s	loc_10A90
		neg.w	d2

loc_10A90:				; CODE XREF: Sonic_Animate+1C2j
		addi.w	#$800,d2
		bpl.s	loc_10A98
		moveq	#0,d2

loc_10A98:				; CODE XREF: Sonic_Animate+1CAj
		lsr.w	#6,d2
		move.b	d2,$1E(a0)
		lea	(SonicAni_Push).l,a1
		move.b	$22(a0),d1
		andi.b	#1,d1
		andi.b	#$FC,1(a0)
		or.b	d1,1(a0)
		bra.w	sub_10912
; END OF FUNCTION CHUNK	FOR Sonic_Animate
; ===============================================================================
SonicAniData:	dc.w SonicAni_Walk-SonicAniData,SonicAni_Run-SonicAniData; 0
					; DATA XREF: Sonic_Animateo
					; ROM:SonicAniDatao ...
		dc.w SonicAni_Roll-SonicAniData,SonicAni_Roll2-SonicAniData; 2
		dc.w SonicAni_Push-SonicAniData,SonicAni_Wait-SonicAniData; 4
		dc.w SonicAni_Balance-SonicAniData,SonicAni_LookUp-SonicAniData; 6
		dc.w SonicAni_Duck-SonicAniData,SonicAni_Spindash-SonicAniData;	8
		dc.w SonicAni_WallRecoil1-SonicAniData,SonicAni_WallRecoil2-SonicAniData; 10
		dc.w SonicAni_0C-SonicAniData,SonicAni_Stop-SonicAniData; 12
		dc.w SonicAni_Float1-SonicAniData,SonicAni_Float2-SonicAniData;	14
		dc.w SonicAni_10-SonicAniData,SonicAni_S1LZHang-SonicAniData; 16
		dc.w SonicAni_Unused12-SonicAniData,SonicAni_Unused13-SonicAniData; 18
		dc.w SonicAni_Unused14-SonicAniData,SonicAni_Bubble-SonicAniData; 20
		dc.w SonicAni_Death1-SonicAniData,SonicAni_Drown-SonicAniData; 22
		dc.w SonicAni_Death2-SonicAniData,SonicAni_Unused19-SonicAniData; 24
		dc.w SonicAni_Hurt-SonicAniData,SonicAni_S1LZSlide-SonicAniData; 26
		dc.w SonicAni_1C-SonicAniData,SonicAni_Float3-SonicAniData; 28
		dc.w SonicAni_1E-SonicAniData; 30
SonicAni_Walk:	dc.b $FF,$10,$11,$12,$13,$14,$15,$16,$17, $C, $D, $E, $F,$FF; 0
					; DATA XREF: Sonic_Animate+F2o
					; ROM:SonicAniDatao
SonicAni_Run:	dc.b $FF,$3C,$3D,$3E,$3F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF; 0
					; DATA XREF: Sonic_Animate:loc_109B0o
					; ROM:SonicAniDatao
SonicAni_Roll:	dc.b $FE,$6C,$70,$6D,$70,$6E,$70,$6F,$70,$FF; 0
					; DATA XREF: Sonic_Animate+192o
					; ROM:SonicAniDatao
SonicAni_Roll2:	dc.b $FE,$6C,$70,$6D,$70,$6E,$70,$6F,$70,$FF; 0
					; DATA XREF: Sonic_Animate:loc_10A50o
					; ROM:SonicAniDatao
SonicAni_Push:	dc.b $FD,$77,$78,$79,$7A,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF; 0
					; DATA XREF: Sonic_Animate+1D4o
					; ROM:SonicAniDatao
SonicAni_Wait:	dc.b   7,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1; 0
					; DATA XREF: ROM:SonicAniDatao
		dc.b   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  2; 16
		dc.b   3,  3,  3,  4,  4,  5,  5,$FE,  4; 32
SonicAni_Balance:dc.b	7,$89,$8A,$FF	 ; 0 ; DATA XREF: ROM:SonicAniDatao
SonicAni_LookUp:dc.b   5,  6,  7,$FE,  1; 0 ; DATA XREF: ROM:SonicAniDatao
SonicAni_Duck:	dc.b   5,$7F,$80,$FE,  1; 0 ; DATA XREF: ROM:SonicAniDatao
SonicAni_Spindash:dc.b	 0,$71,$72,$71,$73,$71,$74,$71,$75,$71,$76,$71,$FF; 0
					; DATA XREF: ROM:SonicAniDatao
SonicAni_WallRecoil1:dc.b $3F,$82,$FF	     ; 0 ; DATA	XREF: ROM:SonicAniDatao
SonicAni_WallRecoil2:dc.b   7,	8,  8,	9,$FD,	5; 0 ; DATA XREF: ROM:SonicAniDatao
SonicAni_0C:	dc.b   7,  9,$FD,  5	; 0 ; DATA XREF: ROM:SonicAniDatao
SonicAni_Stop:	dc.b   3,$81,$82,$83,$84,$85,$86,$87,$88,$FE,  2; 0
					; DATA XREF: ROM:SonicAniDatao
SonicAni_Float1:dc.b   7,$94,$96,$FF	; 0 ; DATA XREF: ROM:SonicAniDatao
SonicAni_Float2:dc.b   7,$91,$92,$93,$94,$95,$FF; 0 ; DATA XREF: ROM:SonicAniDatao
SonicAni_10:	dc.b $2F,$7E,$FD,  0	; 0 ; DATA XREF: ROM:SonicAniDatao
SonicAni_S1LZHang:dc.b	 5,$8F,$90,$FF	  ; 0 ;	DATA XREF: ROM:SonicAniDatao
SonicAni_Unused12:dc.b	$F,$43,$43,$43,$FE,  1;	0 ; DATA XREF: ROM:SonicAniDatao
SonicAni_Unused13:dc.b	$F,$43,$44,$FE,	 1; 0 ;	DATA XREF: ROM:SonicAniDatao
SonicAni_Unused14:dc.b $3F,$49,$FF	  ; 0 ;	DATA XREF: ROM:SonicAniDatao
SonicAni_Bubble:dc.b  $B,$97,$97,$12,$13,$FD,  0; 0 ; DATA XREF: ROM:SonicAniDatao
SonicAni_Death1:dc.b $20,$9A,$FF	; 0 ; DATA XREF: ROM:SonicAniDatao
SonicAni_Drown:	dc.b $20,$99,$FF	; 0 ; DATA XREF: ROM:SonicAniDatao
SonicAni_Death2:dc.b $20,$98,$FF	; 0 ; DATA XREF: ROM:SonicAniDatao
SonicAni_Unused19:dc.b	 3,$4E,$4F,$50,$51,$52,	 0,$FE,	 1; 0 ;	DATA XREF: ROM:SonicAniDatao
SonicAni_Hurt:	dc.b $40,$8D,$FF	; 0 ; DATA XREF: ROM:SonicAniDatao
SonicAni_S1LZSlide:dc.b	  9,$8D,$8E,$FF	   ; 0 ; DATA XREF: ROM:SonicAniDatao
SonicAni_1C:	dc.b $77,  0,$FD,  0	; 0 ; DATA XREF: ROM:SonicAniDatao
SonicAni_Float3:dc.b   3,$91,$92,$93,$94,$95,$FF; 0 ; DATA XREF: ROM:SonicAniDatao
SonicAni_1E:	dc.b   3,$3C,$FD,  0	; 0 ; DATA XREF: ROM:SonicAniDatao

; =============== S U B R O U T I N E ==========================================


LoadSonicDynPLC:
		moveq	#0,d0
		move.b	$1A(a0),d0
		cmp.b	(RAM_Sonic_CurrAnimFrame).w,d0
		beq.s	locret_10C34
		move.b	d0,(RAM_Sonic_CurrAnimFrame).w
		lea	(SonicDynPLC).l,a2
		add.w	d0,d0
		adda.w	(a2,d0.w),a2
		move.w	(a2)+,d5
		subq.w	#1,d5
		bmi.s	locret_10C34

loc_10C04:
		move.w	#$F000,d4

loc_10C08:				; CODE XREF: LoadSonicDynPLC+4Ej
		moveq	#0,d1
		move.w	(a2)+,d1
		move.w	d1,d3
		lsr.w	#8,d3
		andi.w	#$F0,d3	; ''
		addi.w	#$10,d3
		andi.w	#$FFF,d1
		lsl.l	#5,d1
		addi.l	#Art_Sonic,d1
		move.w	d4,d2
		add.w	d3,d4
		add.w	d3,d4
		jsr	(DMA_68KtoVRAM).l
		dbf	d5,loc_10C08

locret_10C34:				; CODE XREF: LoadSonicDynPLC+Aj
					; LoadSonicDynPLC+20j
		rts
; End of function LoadSonicDynPLC

; ===============================================================================
		nop
; START	OF FUNCTION CHUNK FOR Sonic_LevelBoundaries

j_KillSonic:				; CODE XREF: Sonic_LevelBoundaries+48j
					; Sonic_LevelBoundaries+52j ...
		jmp	KillSonic
; END OF FUNCTION CHUNK	FOR Sonic_LevelBoundaries
; ===============================================================================
		align 4

;----------------------------------------------------
; Object 02 - Tails
;----------------------------------------------------

Obj02:
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj02_Index(pc,d0.w),d1
		jmp	Obj02_Index(pc,d1.w)
; ===============================================================================
Obj02_Index:	dc.w Obj02_Main-Obj02_Index
		dc.w Obj02_Control-Obj02_Index
		dc.w Obj02_Hurt-Obj02_Index
		dc.w Obj02_Death-Obj02_Index
		dc.w Obj02_ResetLevel-Obj02_Index
; ===============================================================================

Obj02_Main:
		addq.b	#2,$24(a0)
		move.b	#$F,$16(a0)
		move.b	#9,$17(a0)
		move.l	#Map_Tails,4(a0)
		move.w	#$7A0,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#2,$18(a0)
		move.b	#$18,$19(a0)
		move.b	#$84,1(a0)
		move.w	#$600,(RAM_Sonic_TopSpeed).w
		move.w	#$C,(RAM_Sonic_Acceleration).w
		move.w	#$80,(RAM_Sonic_Deceleration).w
		move.b	#$C,$3E(a0)
		move.b	#$D,$3F(a0)
		move.b	#0,$2C(a0)
		move.b	#4,$2D(a0)
		move.b	#5,(RAM_ObjectTable+Obj_Slot_8).w

Obj02_Control:				; DATA XREF: ROM:Obj02_Indexo
		bsr.w	Tails_Control
		btst	#0,(RAM_Flag_ControlLock).w
		bne.s	Obj02_ControlsLock
		moveq	#0,d0
		move.b	$22(a0),d0
		andi.w	#6,d0
		move.w	Obj02_Modes(pc,d0.w),d1
		jsr	Obj02_Modes(pc,d1.w)

Obj02_ControlsLock:			; CODE XREF: ROM:00010CC6j
		bsr.s	Tails_Display
		bsr.w	RecordTailsMoves
		move.b	(RAM_Sonic_CurrAngle_Front).w,$36(a0)
		move.b	(RAM_Sonic_CurrAngle_Below).w,$37(a0)
		bsr.w	Tails_Animate
		tst.b	(RAM_Flag_ControlLock).w
		bmi.s	loc_10CFC
		jsr	TouchResponse

loc_10CFC:				; CODE XREF: ROM:00010CF4j
		bsr.w	LoadTailsDynPLC
		rts
; ===============================================================================
Obj02_Modes:	dc.w Obj02_MdNormal-Obj02_Modes
		dc.w Obj02_MdJump-Obj02_Modes
		dc.w Obj02_MdRoll-Obj02_Modes
		dc.w Obj02_MdJump2-Obj02_Modes

MusicList_Tails:dc.b $81,$82,$83,$84,$85,$86

; =============== S U B R O U T I N E ==========================================


Tails_Display:
		move.w	$30(a0),d0
		beq.s	loc_10D1E
		subq.w	#1,$30(a0)
		lsr.w	#3,d0
		bcc.s	loc_10D24

loc_10D1E:
		jsr	DisplaySprite

loc_10D24:
		tst.b	(RAM_Flag_Sonic_Invincibility).w
		beq.s	loc_10D68
		tst.w	$32(a0)
		beq.s	loc_10D68
		subq.w	#1,$32(a0)
		bne.s	loc_10D68
		tst.b	(RAM_Level_BossMode).w
		bne.s	loc_10D62
		cmpi.w	#$C,(RAM_Sonic_AirLeft).w
		bcs.s	loc_10D62
		moveq	#0,d0
		move.b	(RAM_Level_CurrentZone).w,d0
		cmpi.w	#$103,(RAM_Level_CurrentZone).w
		bne.s	loc_10D54
		moveq	#5,d0

loc_10D54:
		lea	MusicList_Tails(pc),a1
		move.b	(a1,d0.w),d0
		jsr	(PlaySound).l

loc_10D62:
		move.b	#0,(RAM_Flag_Sonic_Invincibility).w

loc_10D68:
		tst.b	(RAM_Flag_Sonic_Shoes).w
		beq.s	locret_10D9C
		tst.w	$34(a0)
		beq.s	locret_10D9C
		subq.w	#1,$34(a0)
		bne.s	locret_10D9C
		move.w	#$600,(RAM_Sonic_TopSpeed).w
		move.w	#$C,(RAM_Sonic_Acceleration).w
		move.w	#$80,(RAM_Sonic_Deceleration).w
		move.b	#0,(RAM_Flag_Sonic_Shoes).w
		move.w	#$E3,d0
		jmp	(PlaySound).l
; ===============================================================================

locret_10D9C:
		rts


; =============== S U B R O U T I N E ==========================================


Tails_Control:
		move.b	(RAM_Control_2_Hold).w,d0
		andi.b	#$7F,d0
		beq.s	TailsC_NoKeysPressed
		move.w	#0,(RAM_S1_Level_PlaneA_XPos).w
		move.w	#$12C,(RAM_TailsCPU_Timer).w
		rts
; ===============================================================================

TailsC_NoKeysPressed:
		tst.w	(RAM_TailsCPU_Timer).w
		beq.s	TailsC_DoControl
		subq.w	#1,(RAM_TailsCPU_Timer).w
		rts
; ===============================================================================

TailsC_DoControl:
		move.w	(RAM_TailsCPU_Routine).w,d0
		move.w	TailsC_Index(pc,d0.w),d0
		jmp	TailsC_Index(pc,d0.w)

; ===============================================================================
TailsC_Index:	dc.w TailsC_00-TailsC_Index
		dc.w TailsC_02-TailsC_Index
		dc.w TailsC_04-TailsC_Index
		dc.w TailsC_CopySonicMoves-TailsC_Index
; ===============================================================================

TailsC_00:
		move.w	#6,(RAM_TailsCPU_Routine).w
		rts
; ===============================================================================

TailsC_02:
		move.w	#6,(RAM_TailsCPU_Routine).w
		rts
; ===============================================================================
		move.w	#$40,($FFFFF706).w
		move.w	#4,(RAM_TailsCPU_Routine).w

TailsC_04:
		move.w	#6,(RAM_TailsCPU_Routine).w
		rts
; ===============================================================================
		move.w	($FFFFF706).w,d1
		subq.w	#1,d1
		cmpi.w	#$10,d1
		bne.s	loc_10E0C
		move.w	#6,(RAM_TailsCPU_Routine).w

loc_10E0C:
		move.w	d1,($FFFFF706).w
		lea	(RAM_Stars_InvStarPosTable).w,a1
		lsl.b	#2,d1
		addq.b	#4,d1
		move.w	($FFFFEEE0).w,d0
		sub.b	d1,d0
		move.w	(a1,d0.w),8(a0)
		move.w	2(a1,d0.w),$C(a0)
		rts
; ===============================================================================

TailsC_CopySonicMoves:
		move.w	(RAM_ObjRam_Sonic+$8).w,d0
		sub.w	8(a0),d0
		bpl.s	loc_10E38
		neg.w	d0

loc_10E38:
		cmpi.w	#$C0,d0	; ''
		bcs.s	loc_10E40
		nop

loc_10E40:
		lea	(RAM_Sonic_InvStarPosTable).w,a1
		move.w	#$10,d1
		lsl.b	#2,d1
		addq.b	#4,d1
		move.w	(RAM_Sonic_StaticsRecBuffer).w,d0
		sub.b	d1,d0
		lea	(RAM_TailsCPU_CopiedPresses).w,a1
		move.w	(a1,d0.w),(RAM_Control_2_Hold).w
		rts

; =============== S U B R O U T I N E ==========================================


RecordTailsMoves:
		move.w	(RAM_TailsCPU_ToNextAddr).w,d0
		lea	(RAM_Tails_InvStarPosTable).w,a1
		lea	(a1,d0.w),a1
		move.w	8(a0),(a1)+
		move.w	$C(a0),(a1)+
		addq.b	#4,(RAM_TailsCPU_ToNextAddr+$1).w
		rts


; ===============================================================================

Obj02_MdNormal:
		bsr.w	Tails_Spindash
		bsr.w	Tails_Jump
		bsr.w	Tails_SlopeResist
		bsr.w	Tails_Move
		bsr.w	Tails_Roll
		bsr.w	Tails_LevelBoundaries
		jsr	SpeedToPos
		bsr.w	Sonic_AnglePos
		bsr.w	Tails_SlopeRepel
		rts
; ===============================================================================

Obj02_MdJump:				; DATA XREF: ROM:00010D04o
		bsr.w	Tails_JumpHeight
		bsr.w	Tails_ChgJumpDir
		bsr.w	Tails_LevelBoundaries
		jsr	ObjectFall
		btst	#6,$22(a0)
		beq.s	loc_10EC0
		subi.w	#$28,$12(a0) ; '('

loc_10EC0:				; CODE XREF: ROM:00010EB8j
		bsr.w	Tails_JumpAngle
		bsr.w	Tails_Floor
		rts
; ===============================================================================

Obj02_MdRoll:				; DATA XREF: ROM:00010D06o
		bsr.w	Tails_Jump
		bsr.w	Tails_RollRepel
		bsr.w	Tails_RollSpeed
		bsr.w	Tails_LevelBoundaries
		jsr	SpeedToPos
		bsr.w	Sonic_AnglePos
		bsr.w	Tails_SlopeRepel
		rts
; ===============================================================================

Obj02_MdJump2:				; DATA XREF: ROM:00010D08o
		bsr.w	Tails_JumpHeight
		bsr.w	Tails_ChgJumpDir
		bsr.w	Tails_LevelBoundaries
		jsr	ObjectFall
		btst	#6,$22(a0)
		beq.s	loc_10F0A
		subi.w	#$28,$12(a0) ; '('

loc_10F0A:				; CODE XREF: ROM:00010F02j
		bsr.w	Tails_JumpAngle
		bsr.w	Tails_Floor
		rts

; =============== S U B R O U T I N E ==========================================


Tails_Move:				; CODE XREF: ROM:00010E84p
		move.w	(RAM_Sonic_TopSpeed).w,d6
		move.w	(RAM_Sonic_Acceleration).w,d5
		move.w	(RAM_Sonic_Deceleration).w,d4
		tst.b	(RAM_Sonic_IgnoreCtrl_2).w
		bne.w	loc_11026
		tst.w	$2E(a0)
		bne.w	loc_10FFA
		btst	#2,(RAM_Control_2_Hold).w
		beq.s	loc_10F3C
		bsr.w	Tails_MoveLeft

loc_10F3C:				; CODE XREF: Tails_Move+22j
		btst	#3,(RAM_Control_2_Hold).w
		beq.s	loc_10F48
		bsr.w	Tails_MoveRight

loc_10F48:				; CODE XREF: Tails_Move+2Ej
		move.b	$26(a0),d0
		addi.b	#$20,d0	; ' '
		andi.b	#$C0,d0
		bne.w	loc_10FFA
		tst.w	$14(a0)
		bne.w	loc_10FFA
		bclr	#5,$22(a0)
		move.b	#5,$1C(a0)
		btst	#3,$22(a0)
		beq.s	Tails_Balance
		moveq	#0,d0
		move.b	$3D(a0),d0
		lsl.w	#6,d0
		lea	(RAM_ObjRAM_Sonic).w,a1
		lea	(a1,d0.w),a1
		tst.b	$22(a1)
		bmi.s	Tails_LookUp
		moveq	#0,d1
		move.b	$19(a1),d1
		move.w	d1,d2
		add.w	d2,d2
		subq.w	#4,d2
		add.w	8(a0),d1
		sub.w	8(a1),d1
		cmpi.w	#4,d1
		blt.s	loc_10FCE
		cmp.w	d2,d1
		bge.s	loc_10FBE
		bra.s	Tails_LookUp
; ===============================================================================

Tails_Balance:				; CODE XREF: Tails_Move+5Ej
		jsr	ObjHitFloor
		cmpi.w	#$C,d1
		blt.s	Tails_LookUp
		cmpi.b	#3,$36(a0)
		bne.s	loc_10FC6

loc_10FBE:				; CODE XREF: Tails_Move+92j
		bclr	#0,$22(a0)
		bra.s	loc_10FD4
; ===============================================================================

loc_10FC6:				; CODE XREF: Tails_Move+A8j
		cmpi.b	#3,$37(a0)
		bne.s	Tails_LookUp

loc_10FCE:				; CODE XREF: Tails_Move+8Ej
		bset	#0,$22(a0)

loc_10FD4:				; CODE XREF: Tails_Move+B0j
		move.b	#6,$1C(a0)
		bra.s	loc_10FFA
; ===============================================================================

Tails_LookUp:				; CODE XREF: Tails_Move+74j
					; Tails_Move+94j ...
		btst	#0,(RAM_Control_2_Hold).w
		beq.s	Tails_Duck
		move.b	#7,$1C(a0)
		bra.s	loc_10FFA
; ===============================================================================

Tails_Duck:				; CODE XREF: Tails_Move+CEj
		btst	#1,(RAM_Control_2_Hold).w
		beq.s	loc_10FFA
		move.b	#8,$1C(a0)

loc_10FFA:				; CODE XREF: Tails_Move+18j
					; Tails_Move+40j ...
		move.b	(RAM_Control_2_Hold).w,d0

loc_10FFE:
		andi.b	#$C,d0
		bne.s	loc_11026
		move.w	$14(a0),d0
		beq.s	loc_11026
		bmi.s	loc_1101A
		sub.w	d5,d0
		bcc.s	loc_11014
		move.w	#0,d0

loc_11014:				; CODE XREF: Tails_Move+FAj
		move.w	d0,$14(a0)
		bra.s	loc_11026
; ===============================================================================

loc_1101A:				; CODE XREF: Tails_Move+F6j
		add.w	d5,d0
		bcc.s	loc_11022
		move.w	#0,d0

loc_11022:				; CODE XREF: Tails_Move+108j
		move.w	d0,$14(a0)

loc_11026:				; CODE XREF: Tails_Move+10j
					; Tails_Move+EEj ...
		move.b	$26(a0),d0
		jsr	(CalcSine).l
		muls.w	$14(a0),d1
		asr.l	#8,d1
		move.w	d1,$10(a0)
		muls.w	$14(a0),d0
		asr.l	#8,d0
		move.w	d0,$12(a0)

loc_11044:				; CODE XREF: Tails_RollSpeed+AEj
		move.b	$26(a0),d0
		addi.b	#$40,d0	; '@'
		bmi.s	locret_110B4
		move.b	#$40,d1	; '@'
		tst.w	$14(a0)
		beq.s	locret_110B4
		bmi.s	loc_1105C
		neg.w	d1

loc_1105C:				; CODE XREF: Tails_Move+144j
		move.b	$26(a0),d0
		add.b	d1,d0
		move.w	d0,-(sp)
		bsr.w	Sonic_WalkSpeed
		move.w	(sp)+,d0
		tst.w	d1
		bpl.s	locret_110B4
		asl.w	#8,d1
		addi.b	#$20,d0	; ' '
		andi.b	#$C0,d0
		beq.s	loc_110B0
		cmpi.b	#$40,d0	; '@'
		beq.s	loc_1109E
		cmpi.b	#$80,d0
		beq.s	loc_11098
		add.w	d1,$10(a0)
		bset	#5,$22(a0)
		move.w	#0,$14(a0)
		rts
; ===============================================================================

loc_11098:				; CODE XREF: Tails_Move+170j
		sub.w	d1,$12(a0)
		rts
; ===============================================================================

loc_1109E:				; CODE XREF: Tails_Move+16Aj
		sub.w	d1,$10(a0)
		bset	#5,$22(a0)
		move.w	#0,$14(a0)
		rts
; ===============================================================================

loc_110B0:				; CODE XREF: Tails_Move+164j
		add.w	d1,$12(a0)

locret_110B4:				; CODE XREF: Tails_Move+138j
					; Tails_Move+142j ...
		rts
; End of function Tails_Move


; =============== S U B R O U T I N E ==========================================


Tails_MoveLeft:				; CODE XREF: Tails_Move+24p
		move.w	$14(a0),d0
		beq.s	loc_110BE
		bpl.s	loc_110EA

loc_110BE:				; CODE XREF: Tails_MoveLeft+4j
		bset	#0,$22(a0)
		bne.s	loc_110D2
		bclr	#5,$22(a0)
		move.b	#1,$1D(a0)

loc_110D2:				; CODE XREF: Tails_MoveLeft+Ej
		sub.w	d5,d0
		move.w	d6,d1
		neg.w	d1
		cmp.w	d1,d0
		bgt.s	loc_110DE
		move.w	d1,d0

loc_110DE:				; CODE XREF: Tails_MoveLeft+24j
		move.w	d0,$14(a0)
		move.b	#0,$1C(a0)
		rts
; ===============================================================================

loc_110EA:				; CODE XREF: Tails_MoveLeft+6j
		sub.w	d4,d0
		bcc.s	loc_110F2
		move.w	#$FF80,d0

loc_110F2:				; CODE XREF: Tails_MoveLeft+36j
		move.w	d0,$14(a0)
		move.b	$26(a0),d0
		addi.b	#$20,d0	; ' '
		andi.b	#$C0,d0
		bne.s	locret_11120
		cmpi.w	#$400,d0
		blt.s	locret_11120
		move.b	#$D,$1C(a0)
		bclr	#0,$22(a0)
		move.w	#$A4,d0	; ''
		jsr	(PlaySound_Special).l

locret_11120:				; CODE XREF: Tails_MoveLeft+4Cj
					; Tails_MoveLeft+52j
		rts
; End of function Tails_MoveLeft


; =============== S U B R O U T I N E ==========================================


Tails_MoveRight:			; CODE XREF: Tails_Move+30p
		move.w	$14(a0),d0
		bmi.s	loc_11150
		bclr	#0,$22(a0)
		beq.s	loc_1113C
		bclr	#5,$22(a0)
		move.b	#1,$1D(a0)

loc_1113C:				; CODE XREF: Tails_MoveRight+Cj
		add.w	d5,d0
		cmp.w	d6,d0
		blt.s	loc_11144
		move.w	d6,d0

loc_11144:
		move.w	d0,$14(a0)
		move.b	#0,$1C(a0)
		rts
; ===============================================================================

loc_11150:
		add.w	d4,d0
		bcc.s	loc_11158
		move.w	#$80,d0

loc_11158:
		move.w	d0,$14(a0)
		move.b	$26(a0),d0
		addi.b	#$20,d0
		andi.b	#$C0,d0
		bne.s	locret_11186
		cmpi.w	#$FC00,d0
		bgt.s	locret_11186
		move.b	#$D,$1C(a0)
		bset	#0,$22(a0)
		move.w	#$A4,d0
		jsr	(PlaySound_Special).l

locret_11186:
		rts


; =============== S U B R O U T I N E ==========================================


Tails_RollSpeed:
		move.w	(RAM_Sonic_TopSpeed).w,d6
		asl.w	#1,d6
		move.w	(RAM_Sonic_Acceleration).w,d5
		asr.w	#1,d5
		move.w	(RAM_Sonic_Deceleration).w,d4
		asr.w	#2,d4
		tst.b	(RAM_Sonic_IgnoreCtrl_2).w
		bne.w	loc_11204
		tst.w	$2E(a0)
		bne.s	loc_111C0
		btst	#2,(RAM_Control_2_Hold).w
		beq.s	loc_111B4
		bsr.w	Tails_RollLeft

loc_111B4:
		btst	#3,(RAM_Control_2_Hold).w
		beq.s	loc_111C0
		bsr.w	Tails_RollRight

loc_111C0:
		move.w	$14(a0),d0
		beq.s	loc_111E2
		bmi.s	loc_111D6
		sub.w	d5,d0
		bcc.s	loc_111D0
		move.w	#0,d0

loc_111D0:
		move.w	d0,$14(a0)
		bra.s	loc_111E2
; ===============================================================================

loc_111D6:
		add.w	d5,d0
		bcc.s	loc_111DE
		move.w	#0,d0

loc_111DE:
		move.w	d0,$14(a0)

loc_111E2:
		tst.w	$14(a0)
		bne.s	loc_11204
		bclr	#2,$22(a0)
		move.b	#$F,$16(a0)
		move.b	#9,$17(a0)
		move.b	#5,$1C(a0)
		subq.w	#5,$C(a0)

loc_11204:
		move.b	$26(a0),d0
		jsr	(CalcSine).l
		muls.w	$14(a0),d0
		asr.l	#8,d0
		move.w	d0,$12(a0)
		muls.w	$14(a0),d1
		asr.l	#8,d1
		cmpi.w	#$1000,d1
		ble.s	loc_11228
		move.w	#$1000,d1

loc_11228:
		cmpi.w	#$F000,d1
		bge.s	loc_11232
		move.w	#$F000,d1

loc_11232:
		move.w	d1,$10(a0)
		bra.w	loc_11044


; =============== S U B R O U T I N E ==========================================


Tails_RollLeft:
		move.w	$14(a0),d0
		beq.s	loc_11242
		bpl.s	loc_11250

loc_11242:
		bset	#0,$22(a0)
		move.b	#2,$1C(a0)
		rts
; ===============================================================================

loc_11250:
		sub.w	d4,d0
		bcc.s	loc_11258
		move.w	#$FF80,d0

loc_11258:
		move.w	d0,$14(a0)
		rts


; =============== S U B R O U T I N E ==========================================


Tails_RollRight:
		move.w	$14(a0),d0
		bmi.s	loc_11272
		bclr	#0,$22(a0)
		move.b	#2,$1C(a0)
		rts
; ===============================================================================

loc_11272:
		add.w	d4,d0
		bcc.s	loc_1127A
		move.w	#$80,d0

loc_1127A:
		move.w	d0,$14(a0)
		rts


; =============== S U B R O U T I N E ==========================================


Tails_ChgJumpDir:
		move.w	(RAM_Sonic_TopSpeed).w,d6
		move.w	(RAM_Sonic_Acceleration).w,d5
		asl.w	#1,d5
		btst	#4,$22(a0)
		bne.s	loc_112CA
		move.w	$10(a0),d0
		btst	#2,(RAM_Control_2_Hold).w
		beq.s	loc_112B0
		bset	#0,$22(a0)
		sub.w	d5,d0
		move.w	d6,d1
		neg.w	d1
		cmp.w	d1,d0
		bgt.s	loc_112B0
		move.w	d1,d0

loc_112B0:
		btst	#3,(RAM_Control_2_Hold).w
		beq.s	loc_112C6
		bclr	#0,$22(a0)
		add.w	d5,d0
		cmp.w	d6,d0
		blt.s	loc_112C6
		move.w	d6,d0

loc_112C6:
		move.w	d0,$10(a0)

loc_112CA:
		cmpi.w	#$60,(RAM_LevelSys_ForceToYPos).w
		beq.s	loc_112DC
		bcc.s	loc_112D8
		addq.w	#4,(RAM_LevelSys_ForceToYPos).w

loc_112D8:
		subq.w	#2,(RAM_LevelSys_ForceToYPos).w

loc_112DC:
		cmpi.w	#$FC00,$12(a0)
		bcs.s	locret_1130A
		move.w	$10(a0),d0
		move.w	d0,d1
		asr.w	#5,d1
		beq.s	locret_1130A
		bmi.s	loc_112FE
		sub.w	d1,d0
		bcc.s	loc_112F8
		move.w	#0,d0

loc_112F8:
		move.w	d0,$10(a0)
		rts
; ===============================================================================

loc_112FE:
		sub.w	d1,d0
		bcs.s	loc_11306
		move.w	#0,d0

loc_11306:
		move.w	d0,$10(a0)

locret_1130A:
		rts


; =============== S U B R O U T I N E ==========================================


Tails_LevelBoundaries:
		move.l	8(a0),d1
		move.w	$10(a0),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,d1
		swap	d1
		move.w	(RAM_LevelSys_XPos_SetStart).w,d0
		addi.w	#$10,d0
		cmp.w	d1,d0
		bhi.s	loc_11374
		move.w	(RAM_LevelSys_XPos_SetEnd).w,d0
		addi.w	#$128,d0
		tst.b	(RAM_Level_BossMode).w
		bne.s	loc_1133A
		addi.w	#$40,d0

loc_1133A:
		cmp.w	d1,d0
		bls.s	loc_11374

loc_1133E:
		move.w	(RAM_LevelSys_YPos_SetEnd).w,d0
		addi.w	#$E0,d0
		cmp.w	$C(a0),d0
		blt.s	loc_1134E
		rts
; ===============================================================================

loc_1134E:
		cmpi.w	#$501,(RAM_Level_CurrentZone).w
		bne.w	KillTails
		cmpi.w	#$2000,8(a0)
		bcs.w	KillTails
		clr.b	(RAM_Level_LamppostCntr).w
		move.w	#1,(RAM_Flag_ResetLevel).w
		move.w	#$103,(RAM_Level_CurrentZone).w
		rts
; ===============================================================================

loc_11374:
		move.w	d0,8(a0)
		move.w	#0,$A(a0)
		move.w	#0,$10(a0)
		move.w	#0,$14(a0)
		bra.s	loc_1133E


; =============== S U B R O U T I N E ==========================================


Tails_Roll:
		tst.b	(RAM_Sonic_IgnoreCtrl_2).w
		bne.s	locret_113B2
		move.w	$14(a0),d0
		bpl.s	loc_1139A
		neg.w	d0

loc_1139A:
		cmpi.w	#$80,d0
		bcs.s	locret_113B2
		move.b	(RAM_Control_2_Hold).w,d0
		andi.b	#$C,d0
		bne.s	locret_113B2
		btst	#1,(RAM_Control_2_Hold).w
		bne.s	loc_113B4

locret_113B2:
		rts
; ===============================================================================

loc_113B4:
		btst	#2,$22(a0)
		beq.s	loc_113BE
		rts
; ===============================================================================

loc_113BE:
		bset	#2,$22(a0)
		move.b	#$E,$16(a0)
		move.b	#7,$17(a0)
		move.b	#2,$1C(a0)
		addq.w	#5,$C(a0)
		move.w	#$BE,d0
		jsr	(PlaySound_Special).l
		tst.w	$14(a0)
		bne.s	locret_113F0
		move.w	#$200,$14(a0)

locret_113F0:
		rts

; =============== S U B R O U T I N E ==========================================


Tails_Jump:
		move.b	(RAM_Control_2_Press).w,d0
		andi.b	#$70,d0
		beq.w	locret_11496
		moveq	#0,d0
		move.b	$26(a0),d0

loc_11404:
		addi.b	#$80,d0

loc_11408:
		bsr.w	sub_13102
		cmpi.w	#6,d1
		blt.w	locret_11496
		move.w	#$680,d2
		btst	#6,$22(a0)
		beq.s	loc_11424
		move.w	#$380,d2

loc_11424:
		moveq	#0,d0
		move.b	$26(a0),d0
		subi.b	#$40,d0	; '@'
		jsr	(CalcSine).l
		muls.w	d2,d1
		asr.l	#8,d1
		add.w	d1,$10(a0)
		muls.w	d2,d0
		asr.l	#8,d0
		add.w	d0,$12(a0)
		bset	#1,$22(a0)
		bclr	#5,$22(a0)
		addq.l	#4,sp
		move.b	#1,$3C(a0)
		clr.b	$38(a0)
		move.w	#$A0,d0
		jsr	(PlaySound_Special).l
		move.b	#$F,$16(a0)
		move.b	#9,$17(a0)
		btst	#2,$22(a0)
		bne.s	loc_11498
		move.b	#$E,$16(a0)
		move.b	#7,$17(a0)
		move.b	#2,$1C(a0)
		bset	#2,$22(a0)
		addq.w	#5,$C(a0)

locret_11496:
		rts
; ===============================================================================

loc_11498:
		bset	#4,$22(a0)
		rts


; =============== S U B R O U T I N E ==========================================


Tails_JumpHeight:
		tst.b	$3C(a0)
		beq.s	loc_114CC
		move.w	#$FC00,d1
		btst	#6,$22(a0)
		beq.s	loc_114B6
		move.w	#$FE00,d1

loc_114B6:
		cmp.w	$12(a0),d1
		ble.s	locret_114CA
		move.b	(RAM_Control_2_Hold).w,d0
		andi.b	#$70,d0
		bne.s	locret_114CA
		move.w	d1,$12(a0)

locret_114CA:
		rts
; ===============================================================================

loc_114CC:
		cmpi.w	#$F040,$12(a0)
		bge.s	locret_114DA
		move.w	#$F040,$12(a0)

locret_114DA:
		rts


; =============== S U B R O U T I N E ==========================================


Tails_Spindash:
		tst.b	$39(a0)
		bne.s	loc_11510
		cmpi.b	#8,$1C(a0)
		bne.s	locret_1150E
		move.b	(RAM_Control_2_Press).w,d0
		andi.b	#$70,d0	; 'p'
		beq.w	locret_1150E
		move.b	#9,$1C(a0)
		move.w	#$BE,d0
		jsr	(PlaySound_Special).l
		addq.l	#4,sp
		move.b	#1,$39(a0)

locret_1150E:
		rts
; ===============================================================================

loc_11510:
		move.b	(RAM_Control_2_Hold).w,d0
		btst	#1,d0
		bne.s	loc_11556
		move.b	#$E,$16(a0)
		move.b	#7,$17(a0)
		move.b	#2,$1C(a0)
		addq.w	#5,$C(a0)
		move.b	#0,$39(a0)
		move.w	#$2000,(RAM_LevelSys_WaitToScr).w
		move.w	#$800,$14(a0)
		btst	#0,$22(a0)
		beq.s	loc_1154E
		neg.w	$14(a0)

loc_1154E:
		bset	#2,$22(a0)
		rts
; ===============================================================================

loc_11556:
		move.b	(RAM_Control_2_Press).w,d0
		andi.b	#$70,d0
		beq.w	loc_11564
		nop

loc_11564:
		addq.l	#4,sp
		rts


; =============== S U B R O U T I N E ==========================================


Tails_SlopeResist:
		move.b	$26(a0),d0
		addi.b	#$60,d0
		cmpi.b	#$C0,d0
		bcc.s	locret_1159C
		move.b	$26(a0),d0
		jsr	(CalcSine).l
		muls.w	#$20,d0
		asr.l	#8,d0
		tst.w	$14(a0)
		beq.s	locret_1159C
		bmi.s	loc_11598
		tst.w	d0
		beq.s	locret_11596
		add.w	d0,$14(a0)

locret_11596:
		rts
; ===============================================================================

loc_11598:
		add.w	d0,$14(a0)

locret_1159C:
		rts


; =============== S U B R O U T I N E ==========================================


Tails_RollRepel:
		move.b	$26(a0),d0
		addi.b	#$60,d0
		cmpi.b	#$C0,d0
		bcc.s	locret_115D8
		move.b	$26(a0),d0
		jsr	(CalcSine).l
		muls.w	#$50,d0
		asr.l	#8,d0
		tst.w	$14(a0)
		bmi.s	loc_115CE
		tst.w	d0
		bpl.s	loc_115C8
		asr.l	#2,d0

loc_115C8:
		add.w	d0,$14(a0)
		rts

; ===============================================================================

loc_115CE:
		tst.w	d0
		bmi.s	loc_115D4
		asr.l	#2,d0

loc_115D4:
		add.w	d0,$14(a0)

locret_115D8:
		rts


; =============== S U B R O U T I N E ==========================================


Tails_SlopeRepel:
		nop
		tst.b	$38(a0)
		bne.s	locret_11614
		tst.w	$2E(a0)
		bne.s	loc_11616
		move.b	$26(a0),d0
		addi.b	#$20,d0
		andi.b	#$C0,d0
		beq.s	locret_11614
		move.w	$14(a0),d0
		bpl.s	loc_115FE
		neg.w	d0

loc_115FE:
		cmpi.w	#$280,d0
		bcc.s	locret_11614
		clr.w	$14(a0)
		bset	#1,$22(a0)
		move.w	#$1E,$2E(a0)

locret_11614:
		rts
; ===============================================================================

loc_11616:
		subq.w	#1,$2E(a0)
		rts

; =============== S U B R O U T I N E ==========================================


Tails_JumpAngle:
		move.b	$26(a0),d0
		beq.s	loc_11636
		bpl.s	loc_1162C
		addq.b	#2,d0
		bcc.s	loc_1162A
		moveq	#0,d0

loc_1162A:
		bra.s	loc_11632
; ===============================================================================

loc_1162C:
		subq.b	#2,d0
		bcc.s	loc_11632
		moveq	#0,d0

loc_11632:
		move.b	d0,$26(a0)

loc_11636:
		move.b	$27(a0),d0
		beq.s	locret_11674
		tst.w	$14(a0)
		bmi.s	loc_1165A
		move.b	$2D(a0),d1
		add.b	d1,d0
		bcc.s	loc_11658
		subq.b	#1,$2C(a0)
		bcc.s	loc_11658
		move.b	#0,$2C(a0)
		moveq	#0,d0

loc_11658:
		bra.s	loc_11670
; ===============================================================================

loc_1165A:
		move.b	$2D(a0),d1
		sub.b	d1,d0
		bcc.s	loc_11670
		subq.b	#1,$2C(a0)
		bcc.s	loc_11670
		move.b	#0,$2C(a0)
		moveq	#0,d0

loc_11670:
		move.b	d0,$27(a0)

locret_11674:
		rts

; =============== S U B R O U T I N E ==========================================


Tails_Floor:
		move.b	$3F(a0),d5
		move.w	$10(a0),d1
		move.w	$12(a0),d2
		jsr	(CalcAngle).l
		subi.b	#$20,d0
		andi.b	#$C0,d0
		cmpi.b	#$40,d0
		beq.w	loc_11746
		cmpi.b	#$80,d0
		beq.w	loc_117A8
		cmpi.b	#$C0,d0
		beq.w	loc_11804
		bsr.w	Sonic_HitWall
		tst.w	d1
		bpl.s	loc_116BA
		sub.w	d1,8(a0)
		move.w	#0,$10(a0)

loc_116BA:
		bsr.w	sub_132EE
		tst.w	d1
		bpl.s	loc_116CC
		add.w	d1,8(a0)
		move.w	#0,$10(a0)

loc_116CC:
		bsr.w	loc_13146
		tst.w	d1
		bpl.s	locret_11744
		move.b	$12(a0),d2
		addq.b	#8,d2
		neg.b	d2
		cmp.b	d2,d1
		bge.s	loc_116E4
		cmp.b	d2,d0
		blt.s	locret_11744

loc_116E4:
		add.w	d1,$C(a0)
		move.b	d3,$26(a0)
		bsr.w	Tails_ResetTailsOnFloor
		move.b	#0,$1C(a0)
		move.b	d3,d0
		addi.b	#$20,d0
		andi.b	#$40,d0
		bne.s	loc_11722
		move.b	d3,d0
		addi.b	#$10,d0
		andi.b	#$20,d0
		beq.s	loc_11714
		asr	$12(a0)
		bra.s	loc_11736
; ===============================================================================

loc_11714:
		move.w	#0,$12(a0)
		move.w	$10(a0),$14(a0)
		rts
; ===============================================================================

loc_11722:
		move.w	#0,$10(a0)
		cmpi.w	#$FC0,$12(a0)
		ble.s	loc_11736
		move.w	#$FC0,$12(a0)

loc_11736:
		move.w	$12(a0),$14(a0)
		tst.b	d3
		bpl.s	locret_11744
		neg.w	$14(a0)

locret_11744:
		rts
; ===============================================================================

loc_11746:
		bsr.w	Sonic_HitWall
		tst.w	d1
		bpl.s	loc_11760
		sub.w	d1,8(a0)
		move.w	#0,$10(a0)
		move.w	$12(a0),$14(a0)
		rts
; ===============================================================================

loc_11760:
		bsr.w	Sonic_DontRunOnWalls
		tst.w	d1
		bpl.s	loc_1177A
		sub.w	d1,$C(a0)
		tst.w	$12(a0)
		bpl.s	locret_11778
		move.w	#0,$12(a0)

locret_11778:
		rts
; ===============================================================================

loc_1177A:
		tst.w	$12(a0)
		bmi.s	locret_117A6
		bsr.w	loc_13146
		tst.w	d1
		bpl.s	locret_117A6
		add.w	d1,$C(a0)
		move.b	d3,$26(a0)
		bsr.w	Tails_ResetTailsOnFloor
		move.b	#0,$1C(a0)
		move.w	#0,$12(a0)
		move.w	$10(a0),$14(a0)

locret_117A6:
		rts
; ===============================================================================

loc_117A8:
		bsr.w	Sonic_HitWall
		tst.w	d1
		bpl.s	loc_117BA
		sub.w	d1,8(a0)
		move.w	#0,$10(a0)

loc_117BA:
		bsr.w	sub_132EE
		tst.w	d1
		bpl.s	loc_117CC
		add.w	d1,8(a0)
		move.w	#0,$10(a0)

loc_117CC:
		bsr.w	Sonic_DontRunOnWalls
		tst.w	d1
		bpl.s	locret_11802
		sub.w	d1,$C(a0)
		move.b	d3,d0
		addi.b	#$20,d0
		andi.b	#$40,d0
		bne.s	loc_117EC
		move.w	#0,$12(a0)
		rts
; ===============================================================================

loc_117EC:
		move.b	d3,$26(a0)
		bsr.w	Tails_ResetTailsOnFloor
		move.w	$12(a0),$14(a0)
		tst.b	d3
		bpl.s	locret_11802
		neg.w	$14(a0)

locret_11802:
		rts
; ===============================================================================

loc_11804:
		bsr.w	sub_132EE
		tst.w	d1
		bpl.s	loc_1181E
		add.w	d1,8(a0)
		move.w	#0,$10(a0)
		move.w	$12(a0),$14(a0)
		rts
; ===============================================================================

loc_1181E:
		bsr.w	Sonic_DontRunOnWalls
		tst.w	d1
		bpl.s	loc_11838
		sub.w	d1,$C(a0)
		tst.w	$12(a0)
		bpl.s	locret_11836
		move.w	#0,$12(a0)

locret_11836:
		rts
; ===============================================================================

loc_11838:
		tst.w	$12(a0)
		bmi.s	locret_11864
		bsr.w	loc_13146
		tst.w	d1
		bpl.s	locret_11864
		add.w	d1,$C(a0)
		move.b	d3,$26(a0)
		bsr.w	Tails_ResetTailsOnFloor
		move.b	#0,$1C(a0)
		move.w	#0,$12(a0)
		move.w	$10(a0),$14(a0)

locret_11864:
		rts

; =============== S U B R O U T I N E ==========================================


Tails_ResetTailsOnFloor:
		btst	#4,$22(a0)
		beq.s	loc_11874
		nop
		nop
		nop

loc_11874:
		bclr	#5,$22(a0)
		bclr	#1,$22(a0)
		bclr	#4,$22(a0)
		btst	#2,$22(a0)
		beq.s	loc_118AA
		bclr	#2,$22(a0)
		move.b	#$F,$16(a0)
		move.b	#9,$17(a0)
		move.b	#0,$1C(a0)
		subq.w	#1,$C(a0)

loc_118AA:
		move.b	#0,$3C(a0)
		move.w	#0,(RAM_Level_Enemy_FixPoints).w
		move.b	#0,$27(a0)
		rts

; ===============================================================================

Obj02_Hurt:
		jsr	SpeedToPos
		addi.w	#$30,$12(a0)
		btst	#6,$22(a0)
		beq.s	loc_118D8
		subi.w	#$20,$12(a0)

loc_118D8:
		bsr.w	Tails_HurtStop
		bsr.w	Tails_LevelBoundaries
		bsr.w	Tails_Animate
		bsr.w	LoadTailsDynPLC
		jmp	DisplaySprite

; =============== S U B R O U T I N E ==========================================


Tails_HurtStop:
		move.w	(RAM_LevelSys_YPos_SetEnd).w,d0
		addi.w	#$E0,d0
		cmp.w	$C(a0),d0
		bcs.w	KillTails
		bsr.w	Tails_Floor
		btst	#1,$22(a0)
		bne.s	locret_1192A
		moveq	#0,d0
		move.w	d0,$12(a0)
		move.w	d0,$10(a0)
		move.w	d0,$14(a0)
		move.b	#0,$1C(a0)
		move.b	#2,$24(a0)
		move.w	#$78,$30(a0)

locret_1192A:
		rts

; ===============================================================================

Obj02_Death:
		bsr.w	Tails_GameOver
		jsr	ObjectFall
		bsr.w	Tails_Animate
		bsr.w	LoadTailsDynPLC
		jmp	DisplaySprite

; =============== S U B R O U T I N E ==========================================


Tails_GameOver:
		move.w	(RAM_LevelSys_YPos_SetEnd).w,d0
		addi.w	#$100,d0
		cmp.w	$C(a0),d0
		bcc.w	locret_11986
		move.w	(RAM_ObjRAM_Sonic+$8).w,d0
		subi.w	#$40,d0
		move.w	d0,8(a0)
		move.w	(RAM_ObjRAM_Sonic+$C).w,d0
		subi.w	#$80,d0
		move.w	d0,$C(a0)
		move.b	#2,$24(a0)
		andi.w	#$7FFF,2(a0)
		move.b	#$C,$3E(a0)
		move.b	#$D,$3F(a0)
		nop

locret_11986:
		rts

; ===============================================================================

Obj02_ResetLevel:
		tst.w	$3A(a0)
		beq.s	locret_1199A
		subq.w	#1,$3A(a0)
		bne.s	locret_1199A
		move.w	#1,(RAM_Flag_ResetLevel).w

locret_1199A:
		rts

; =============== S U B R O U T I N E ==========================================


Tails_Animate:
		lea	(TailsAniData).l,a1

Tails_Animate2:
		moveq	#0,d0
		move.b	$1C(a0),d0
		cmp.b	$1D(a0),d0
		beq.s	loc_119BE
		move.b	d0,$1D(a0)
		move.b	#0,$1B(a0)
		move.b	#0,$1E(a0)

loc_119BE:
		add.w	d0,d0
		adda.w	(a1,d0.w),a1
		move.b	(a1),d0
		bmi.s	loc_11A2E
		move.b	$22(a0),d1
		andi.b	#1,d1
		andi.b	#$FC,1(a0)
		or.b	d1,1(a0)
		subq.b	#1,$1E(a0)
		bpl.s	locret_119FC
		move.b	d0,$1E(a0)


; =============== S U B R O U T I N E ==========================================


sub_119E4:
		moveq	#0,d1
		move.b	$1B(a0),d1
		move.b	1(a1,d1.w),d0
		cmpi.b	#$F0,d0
		bcc.s	loc_119FE

loc_119F4:
		move.b	d0,$1A(a0)
		addq.b	#1,$1B(a0)

locret_119FC:
		rts
; ===============================================================================

loc_119FE:
		addq.b	#1,d0
		bne.s	loc_11A0E
		move.b	#0,$1B(a0)
		move.b	1(a1),d0
		bra.s	loc_119F4
; ===============================================================================

loc_11A0E:
		addq.b	#1,d0
		bne.s	loc_11A22
		move.b	2(a1,d1.w),d0
		sub.b	d0,$1B(a0)
		sub.b	d0,d1
		move.b	1(a1,d1.w),d0
		bra.s	loc_119F4
; ===============================================================================

loc_11A22:
		addq.b	#1,d0
		bne.s	locret_11A2C
		move.b	2(a1,d1.w),$1C(a0)

locret_11A2C:
		rts

; ===============================================================================

loc_11A2E:
		subq.b	#1,$1E(a0)
		bpl.s	locret_119FC
		addq.b	#1,d0
		bne.w	loc_11B0E
		moveq	#0,d0
		move.b	$27(a0),d0
		bne.w	loc_11AB4
		moveq	#0,d1
		move.b	$26(a0),d0
		move.b	$22(a0),d2
		andi.b	#1,d2
		bne.s	loc_11A56
		not.b	d0

loc_11A56:
		addi.b	#$10,d0
		bpl.s	loc_11A5E
		moveq	#3,d1

loc_11A5E:
		andi.b	#$FC,1(a0)
		eor.b	d1,d2
		or.b	d2,1(a0)
		lsr.b	#4,d0
		andi.b	#6,d0
		move.w	$14(a0),d2
		bpl.s	loc_11A78
		neg.w	d2

loc_11A78:
		move.b	d0,d3
		add.b	d3,d3
		add.b	d3,d3
		lea	(TailsAni_Walk).l,a1
		cmpi.w	#$600,d2
		bcs.s	loc_11A9A
		lea	(TailsAni_Run).l,a1
		move.b	d0,d1
		lsr.b	#1,d1
		add.b	d1,d0
		add.b	d0,d0
		move.b	d0,d3

loc_11A9A:
		neg.w	d2
		addi.w	#$800,d2
		bpl.s	loc_11AA4
		moveq	#0,d2

loc_11AA4:
		lsr.w	#8,d2
		move.b	d2,$1E(a0)
		bsr.w	sub_119E4
		add.b	d3,$1A(a0)
		rts
; ===============================================================================

loc_11AB4:
		move.b	$27(a0),d0
		moveq	#0,d1
		move.b	$22(a0),d2
		andi.b	#1,d2
		bne.s	loc_11AE8
		andi.b	#$FC,1(a0)
		moveq	#0,d2
		or.b	d2,1(a0)
		addi.b	#$B,d0
		divu.w	#$16,d0
		addi.b	#$75,d0
		move.b	d0,$1A(a0)
		move.b	#0,$1E(a0)
		rts
; ===============================================================================

loc_11AE8:
		moveq	#3,d2
		andi.b	#$FC,1(a0)
		or.b	d2,1(a0)
		neg.b	d0
		addi.b	#$8F,d0
		divu.w	#$16,d0
		addi.b	#$75,d0
		move.b	d0,$1A(a0)
		move.b	#0,$1E(a0)
		rts
; ===============================================================================

loc_11B0E:
		addq.b	#1,d0
		bne.s	loc_11B52
		move.w	$14(a0),d2
		bpl.s	loc_11B1A
		neg.w	d2

loc_11B1A:
		lea	(TailsAni_Roll2).l,a1
		cmpi.w	#$600,d2
		bcc.s	loc_11B2C
		lea	(TailsAni_Roll).l,a1

loc_11B2C:
		neg.w	d2
		addi.w	#$400,d2
		bpl.s	loc_11B36
		moveq	#0,d2

loc_11B36:
		lsr.w	#8,d2
		move.b	d2,$1E(a0)
		move.b	$22(a0),d1
		andi.b	#1,d1
		andi.b	#$FC,1(a0)
		or.b	d1,1(a0)
		bra.w	sub_119E4
; ===============================================================================

loc_11B52:
		addq.b	#1,d0
		bne.s	loc_11B88
		move.w	$14(a0),d2
		bmi.s	loc_11B5E
		neg.w	d2

loc_11B5E:
		addi.w	#$800,d2
		bpl.s	loc_11B66
		moveq	#0,d2

loc_11B66:
		lsr.w	#6,d2
		move.b	d2,$1E(a0)
		lea	(TailsAni_Push_NoArt).l,a1
		move.b	$22(a0),d1
		andi.b	#1,d1
		andi.b	#$FC,1(a0)
		or.b	d1,1(a0)
		bra.w	sub_119E4
; ===============================================================================

loc_11B88:
		move.w	(RAM_ObjRAM_Tails+$10).w,d1
		move.w	(RAM_ObjRAM_Tails+$12).w,d2
		jsr	(CalcAngle).l
		moveq	#0,d1
		move.b	$22(a0),d2
		andi.b	#1,d2
		bne.s	loc_11BA6
		not.b	d0
		bra.s	loc_11BAA
; ===============================================================================

loc_11BA6:
		addi.b	#$80,d0

loc_11BAA:
		addi.b	#$10,d0
		bpl.s	loc_11BB2
		moveq	#3,d1

loc_11BB2:
		andi.b	#$FC,1(a0)
		eor.b	d1,d2
		or.b	d2,1(a0)
		lsr.b	#3,d0
		andi.b	#$C,d0
		move.b	d0,d3
		lea	(byte_11E3C).l,a1
		move.b	#3,$1E(a0)
		bsr.w	sub_119E4
		add.b	d3,$1A(a0)
		rts

; ===============================================================================
TailsAniData:	dc.w TailsAni_Walk-TailsAniData,TailsAni_Run-TailsAniData; 0
		dc.w TailsAni_Roll-TailsAniData,TailsAni_Roll2-TailsAniData; 2
		dc.w TailsAni_Push_NoArt-TailsAniData,TailsAni_Wait-TailsAniData; 4
		dc.w TailsAni_Balance_NoArt-TailsAniData,TailsAni_LookUp-TailsAniData; 6
		dc.w TailsAni_Duck-TailsAniData,TailsAni_Spindash-TailsAniData;	8
		dc.w TailsAni_0A-TailsAniData,TailsAni_0B-TailsAniData;	10
		dc.w TailsAni_0C-TailsAniData,TailsAni_Stop-TailsAniData; 12
		dc.w TailsAni_Fly-TailsAniData,TailsAni_0F-TailsAniData; 14
		dc.w TailsAni_Jump-TailsAniData,TailsAni_11-TailsAniData; 16
		dc.w TailsAni_12-TailsAniData,TailsAni_13-TailsAniData;	18
		dc.w TailsAni_14-TailsAniData,TailsAni_15-TailsAniData;	20
		dc.w TailsAni_Death1-TailsAniData,TailsAni_UnusedDrown-TailsAniData; 22
		dc.w TailsAni_Death2-TailsAniData,TailsAni_19-TailsAniData; 24
		dc.w TailsAni_1A-TailsAniData,TailsAni_1B-TailsAniData;	26
		dc.w TailsAni_1C-TailsAniData,TailsAni_1D-TailsAniData;	28
		dc.w TailsAni_1E-TailsAniData; 30
TailsAni_Walk:	dc.b $FF,$10,$11,$12,$13,$14,$15, $E, $F,$FF; 0
					; DATA XREF: Tails_Animate+E2o
					; ROM:TailsAniDatao
TailsAni_Run:	dc.b $FF,$2E,$2F,$30,$31,$FF,$FF,$FF,$FF,$FF; 0
					; DATA XREF: Tails_Animate+EEo
					; ROM:TailsAniDatao
TailsAni_Roll:	dc.b   1,$48,$47,$46,$FF; 0 ; DATA XREF: Tails_Animate+18Ao
					; ROM:TailsAniDatao
TailsAni_Roll2:	dc.b   1,$48,$47,$46,$FF; 0 ; DATA XREF: Tails_Animate:loc_11B1Ao
					; ROM:TailsAniDatao
TailsAni_Push_NoArt:dc.b $FD,  9, $A, $B, $C, $D, $E,$FF; 0 ; DATA XREF: Tails_Animate+1D0o
					; ROM:TailsAniDatao
TailsAni_Wait:	dc.b   7,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  3,  2,  1,  1,  1; 0
					; DATA XREF: ROM:TailsAniDatao
		dc.b   1,  1,  1,  1,  1,  3,  2,  1,  1,  1,  1,  1,  1,  1,  1,  1; 16
		dc.b   5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5; 32
		dc.b   6,  7,  8,  7,  8,  7,  8,  7,  8,  7,  8,  6,$FE,$1C; 48
TailsAni_Balance_NoArt:dc.b $1F,  1,  2,  3,  4,  5,  6,  7,  8,$FF; 0
					; DATA XREF: ROM:TailsAniDatao
TailsAni_LookUp:dc.b $3F,  4,$FF	; 0 ; DATA XREF: ROM:TailsAniDatao
TailsAni_Duck:	dc.b $3F,$5B,$FF	; 0 ; DATA XREF: ROM:TailsAniDatao
TailsAni_Spindash:dc.b	 0,$60,$61,$62,$FF; 0 ;	DATA XREF: ROM:TailsAniDatao
TailsAni_0A:	dc.b $3F,$82,$FF	; 0 ; DATA XREF: ROM:TailsAniDatao
TailsAni_0B:	dc.b   7,  8,  8,  9,$FD,  5; 0	; DATA XREF: ROM:TailsAniDatao
TailsAni_0C:	dc.b   7,  9,$FD,  5	; 0 ; DATA XREF: ROM:TailsAniDatao
TailsAni_Stop:	dc.b   7,  1,  2,$FF	; 0 ; DATA XREF: ROM:TailsAniDatao
TailsAni_Fly:	dc.b   7,$5E,$5F,$FF	; 0 ; DATA XREF: ROM:TailsAniDatao
TailsAni_0F:	dc.b   7,  1,  2,  3,  4,  5,$FF; 0 ; DATA XREF: ROM:TailsAniDatao
TailsAni_Jump:	dc.b   3,$59,$5A,$59,$5A,$59,$5A,$59,$5A,$59,$5A,$59,$5A,$FD,  0; 0
					; DATA XREF: ROM:TailsAniDatao
TailsAni_11:	dc.b   4,  1,  2,$FF	; 0 ; DATA XREF: ROM:TailsAniDatao
TailsAni_12:	dc.b  $F,  1,  2,  3,$FE,  1; 0	; DATA XREF: ROM:TailsAniDatao
TailsAni_13:	dc.b  $F,  1,  2,$FE,  1; 0 ; DATA XREF: ROM:TailsAniDatao
TailsAni_14:	dc.b $3F,  1,$FF	; 0 ; DATA XREF: ROM:TailsAniDatao
TailsAni_15:	dc.b  $B,  1,  2,  3,  4,$FD,  0; 0 ; DATA XREF: ROM:TailsAniDatao
TailsAni_Death1:dc.b $20,$5D,$FF	; 0 ; DATA XREF: ROM:TailsAniDatao
TailsAni_UnusedDrown:dc.b $2F,$5D,$FF	     ; 0 ; DATA	XREF: ROM:TailsAniDatao
TailsAni_Death2:dc.b   3,$5D,$FF	; 0 ; DATA XREF: ROM:TailsAniDatao
TailsAni_19:	dc.b   3,$5D,$FF	; 0 ; DATA XREF: ROM:TailsAniDatao
TailsAni_1A:	dc.b   3,$5C,$FF	; 0 ; DATA XREF: ROM:TailsAniDatao
TailsAni_1B:	dc.b   7,  1,  1,$FF	; 0 ; DATA XREF: ROM:TailsAniDatao
TailsAni_1C:	dc.b $77,  0,$FD,  0	; 0 ; DATA XREF: ROM:TailsAniDatao
TailsAni_1D:	dc.b   3,  1,  2,  3,  4,  5,  6,  7,  8,$FF; 0
					; DATA XREF: ROM:TailsAniDatao
TailsAni_1E:	dc.b   3,  1,  2,  3,  4,  5,  6,  7,  8,$FF; 0
					; DATA XREF: ROM:TailsAniDatao

; =============== S U B R O U T I N E ==========================================

; loads	the tails patterns in a	buffer at F600
; as opposed to	the usual F400

LoadTailsDynPLC_F600:
		moveq	#0,d0
		move.b	$1A(a0),d0
		cmp.b	(RAM_TailsTails_CurrAnimFrame).w,d0
		beq.s	locret_11D7C
		move.b	d0,(RAM_TailsTails_CurrAnimFrame).w
		lea	(TailsDynPLC).l,a2
		add.w	d0,d0
		adda.w	(a2,d0.w),a2
		move.w	(a2)+,d5
		subq.w	#1,d5
		bmi.s	locret_11D7C
		move.w	#$F600,d4
		bra.s	loc_11D50

; =============== S U B R O U T I N E ==========================================


LoadTailsDynPLC:
		moveq	#0,d0
		move.b	$1A(a0),d0
		cmp.b	(RAM_Tails_CurrAnimFrame).w,d0
		beq.s	locret_11D7C
		move.b	d0,(RAM_Tails_CurrAnimFrame).w
		lea	(TailsDynPLC).l,a2
		add.w	d0,d0
		adda.w	(a2,d0.w),a2
		move.w	(a2)+,d5
		subq.w	#1,d5
		bmi.s	locret_11D7C
		move.w	#$F400,d4

loc_11D50:
		moveq	#0,d1
		move.w	(a2)+,d1
		move.w	d1,d3
		lsr.w	#8,d3
		andi.w	#$F0,d3	; ''
		addi.w	#$10,d3
		andi.w	#$FFF,d1
		lsl.l	#5,d1
		addi.l	#Art_Tails,d1
		move.w	d4,d2
		add.w	d3,d4
		add.w	d3,d4
		jsr	(DMA_68KtoVRAM).l
		dbf	d5,loc_11D50

locret_11D7C:
		rts

; ===============================================================================
;----------------------------------------------------
; Object 05 - Tails' tails
;----------------------------------------------------

Obj05:
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj05_Index(pc,d0.w),d1
		jmp	Obj05_Index(pc,d1.w)
; ===============================================================================
Obj05_Index:	dc.w Obj05_Init-Obj05_Index
		dc.w Obj05_Main-Obj05_Index
; ===============================================================================

Obj05_Init:
		addq.b	#2,$24(a0)
		move.l	#Map_Tails,4(a0)
		move.w	#$7B0,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#2,$18(a0)
		move.b	#$18,$19(a0)
		move.b	#4,1(a0)

Obj05_Main:
		move.b	(RAM_ObjectTable+Obj_Slot_2+$26).w,$26(a0)
		move.b	(RAM_ObjectTable+Obj_Slot_2+$22).w,$22(a0)
		move.w	(RAM_ObjRam_Tails+$8).w,8(a0)
		move.w	(RAM_ObjRam_Tails+$C).w,$C(a0)
		moveq	#0,d0
		move.b	(RAM_ObjectTable+Obj_Slot_2+$1C).w,d0
		cmp.b	$30(a0),d0
		beq.s	loc_11DE6
		move.b	d0,$30(a0)
		move.b	Obj05_Animations(pc,d0.w),$1C(a0)

loc_11DE6:
		lea	(Obj05_AniData).l,a1
		bsr.w	Tails_Animate2
		bsr.w	LoadTailsDynPLC_F600
		jsr	DisplaySprite
		rts

; ===============================================================================
Obj05_Animations:dc.b	0,  0		 ; 0
		dc.b   3,  3		; 2
		dc.b   0,  1		; 4
		dc.b   0,  2		; 6
		dc.b   1,  7		; 8
		dc.b   0,  0		; 10
		dc.b   0,  0		; 12
		dc.b   0,  0		; 14
		dc.b   0,  0		; 16
		dc.b   0,  0		; 18
		dc.b   0,  0		; 20
		dc.b   0,  0		; 22
		dc.b   0,  0		; 24
		dc.b   0,  0		; 26
		dc.b   0,  0		; 28

Obj05_AniData:	dc.w byte_11E2A-Obj05_AniData
		dc.w byte_11E2D-Obj05_AniData
		dc.w byte_11E34-Obj05_AniData
		dc.w byte_11E3C-Obj05_AniData
		dc.w byte_11E42-Obj05_AniData
		dc.w byte_11E48-Obj05_AniData
		dc.w byte_11E4E-Obj05_AniData
		dc.w byte_11E54-Obj05_AniData
byte_11E2A:	dc.b $20,  0,$FF	; 0 ; DATA XREF: ROM:Obj05_AniDatao
byte_11E2D:	dc.b   7,  9, $A, $B, $C, $D,$FF; 0 ; DATA XREF: ROM:00011E1Co
byte_11E34:	dc.b   3,  9, $A, $B, $C, $D,$FD,  1; 0	; DATA XREF: ROM:00011E1Eo
byte_11E3C:	dc.b $FC,$49,$4A,$4B,$4C,$FF; 0	; DATA XREF: Tails_Animate+22Ao
					; ROM:00011E20o
byte_11E42:	dc.b   3,$4D,$4E,$4F,$50,$FF; 0	; DATA XREF: ROM:00011E22o
byte_11E48:	dc.b   3,$51,$52,$53,$54,$FF; 0	; DATA XREF: ROM:00011E24o
byte_11E4E:	dc.b   3,$55,$56,$57,$58,$FF; 0	; DATA XREF: ROM:00011E26o
byte_11E54:	dc.b   2,$81,$82,$83,$84,$FF; 0	; DATA XREF: ROM:00011E28o
; ===============================================================================
		nop

KillTails:
		jmp	KillSonic

; ===============================================================================
		align 4
;----------------------------------------------------
; Object 0A - drowning bubbles and countdown numbers
;----------------------------------------------------

Obj0A:
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj0A_Index(pc,d0.w),d1
		jmp	Obj0A_Index(pc,d1.w)
; ===============================================================================
Obj0A_Index:	dc.w Obj0A_Init-Obj0A_Index
		dc.w Obj0A_Animate-Obj0A_Index
		dc.w Obj0A_ChkWater-Obj0A_Index
		dc.w Obj0A_Display-Obj0A_Index
		dc.w Obj0A_Delete-Obj0A_Index
		dc.w Obj0A_Countdown-Obj0A_Index
		dc.w Obj0A_AirLeft-Obj0A_Index
		dc.w Obj0A_Display-Obj0A_Index
		dc.w Obj0A_Delete-Obj0A_Index
; ===============================================================================

Obj0A_Init:
		addq.b	#2,$24(a0)
		move.l	#Map_Obj0A_Bubbles,4(a0)
		move.w	#$8348,2(a0)
		move.b	#$84,1(a0)
		move.b	#$10,$19(a0)
		move.b	#1,$18(a0)
		move.b	$28(a0),d0
		bpl.s	loc_11ECC
		addq.b	#8,$24(a0)
		move.l	#Map_Obj0A_Countdown,4(a0)
		move.w	#$440,2(a0)
		andi.w	#$7F,d0
		move.b	d0,$33(a0)
		bra.w	Obj0A_Countdown
; ===============================================================================

loc_11ECC:
		move.b	d0,$1C(a0)
		bsr.w	ModifySpriteAttr_2P
		move.w	8(a0),$30(a0)
		move.w	#$FF78,$12(a0)

Obj0A_Animate:
		lea	(Ani_Obj0A).l,a1
		jsr	AnimateSprite

Obj0A_ChkWater:
		move.w	(RAM_Level_Water_Action).w,d0
		cmp.w	$C(a0),d0
		bcs.s	loc_11F0A
		move.b	#6,$24(a0)
		addq.b	#7,$1C(a0)
		cmpi.b	#$D,$1C(a0)
		beq.s	Obj0A_Display
		bra.s	Obj0A_Display
; ===============================================================================

loc_11F0A:
		tst.b	(RAM_Flag_Sonic_Slide).w
		beq.s	loc_11F14
		addq.w	#4,$30(a0)

loc_11F14:
		move.b	$26(a0),d0
		addq.b	#1,$26(a0)
		andi.w	#$7F,d0
		lea	(Obj0A_WobbleData).l,a1
		move.b	(a1,d0.w),d0
		ext.w	d0
		add.w	$30(a0),d0
		move.w	d0,8(a0)
		bsr.s	Obj0A_ShowNumber
		jsr	SpeedToPos
		tst.b	1(a0)
		bpl.s	loc_11F48
		jmp	DisplaySprite
; ===============================================================================

loc_11F48:
		jmp	DeleteObject
; ===============================================================================

Obj0A_Display:
		bsr.s	Obj0A_ShowNumber
		lea	(Ani_Obj0A).l,a1
		jsr	AnimateSprite
		jmp	DisplaySprite
; ===============================================================================

Obj0A_Delete:
		jmp	DeleteObject
; ===============================================================================

Obj0A_AirLeft:
		cmpi.w	#$C,(RAM_Sonic_AirLeft).w
		bhi.s	loc_11F9A
		subq.w	#1,$38(a0)
		bne.s	loc_11F82
		move.b	#$E,$24(a0)
		addq.b	#7,$1C(a0)
		bra.s	Obj0A_Display
; ===============================================================================

loc_11F82:
		lea	(Ani_Obj0A).l,a1
		jsr	AnimateSprite
		tst.b	1(a0)
		bpl.s	loc_11F9A
		jmp	DisplaySprite
; ===============================================================================

loc_11F9A:
		jmp	DeleteObject

; =============== S U B R O U T I N E ==========================================


Obj0A_ShowNumber:
		tst.w	$38(a0)
		beq.s	locret_11FEA
		subq.w	#1,$38(a0)
		bne.s	locret_11FEA
		cmpi.b	#7,$1C(a0)
		bcc.s	locret_11FEA
		move.w	#$F,$38(a0)
		clr.w	$12(a0)
		move.b	#$80,1(a0)
		move.w	8(a0),d0
		sub.w	(RAM_LevelSys_Buff).w,d0
		addi.w	#$80,d0
		move.w	d0,8(a0)
		move.w	$C(a0),d0
		sub.w	(RAM_LevelSys_Buff+$4).w,d0
		addi.w	#$80,d0
		move.w	d0,$A(a0)
		move.b	#$C,$24(a0)

locret_11FEA:
		rts

; ===============================================================================
Obj0A_WobbleData:dc.b	 0,   0,   0,	0,   0,	  0,   1,   1,	 1,   1,   1,	2,   2,	  2,   2,   2; 0
					; DATA XREF: ROM:00005E84o
					; ROM:00011F20o ...
		dc.b	2,   2,	  3,   3,   3,	 3,   3,   3,	3,   3,	  3,   3,   3,	 3,   3,   3; 16
		dc.b	3,   3,	  3,   3,   3,	 3,   3,   3,	3,   3,	  3,   3,   3,	 3,   3,   2; 32
		dc.b	2,   2,	  2,   2,   2,	 2,   1,   1,	1,   1,	  1,   0,   0,	 0,   0,   0; 48
		dc.b	0,  -1,	 -1,  -1,  -1,	-1,  -2,  -2,  -2,  -2,	 -2,  -3,  -3,	-3,  -3,  -3; 64
		dc.b   -3,  -3,	 -4,  -4,  -4,	-4,  -4,  -4,  -4,  -4,	 -4,  -4,  -4,	-4,  -4,  -4; 80
		dc.b   -4,  -4,	 -4,  -4,  -4,	-4,  -4,  -4,  -4,  -4,	 -4,  -4,  -4,	-4,  -4,  -3; 96
		dc.b   -3,  -3,	 -3,  -3,  -3,	-3,  -2,  -2,  -2,  -2,	 -2,  -1,  -1,	-1,  -1,  -1; 112
		dc.b	0,   0,	  0,   0,   0,	 0,   1,   1,	1,   1,	  1,   2,   2,	 2,   2,   2; 128
		dc.b	2,   2,	  3,   3,   3,	 3,   3,   3,	3,   3,	  3,   3,   3,	 3,   3,   3; 144
		dc.b	3,   3,	  3,   3,   3,	 3,   3,   3,	3,   3,	  3,   3,   3,	 3,   3,   2; 160
		dc.b	2,   2,	  2,   2,   2,	 2,   1,   1,	1,   1,	  1,   0,   0,	 0,   0,   0; 176
		dc.b	0,  -1,	 -1,  -1,  -1,	-1,  -2,  -2,  -2,  -2,	 -2,  -3,  -3,	-3,  -3,  -3; 192
		dc.b   -3,  -3,	 -4,  -4,  -4,	-4,  -4,  -4,  -4,  -4,	 -4,  -4,  -4,	-4,  -4,  -4; 208
		dc.b   -4,  -4,	 -4,  -4,  -4,	-4,  -4,  -4,  -4,  -4,	 -4,  -4,  -4,	-4,  -4,  -3; 224
		dc.b   -3,  -3,	 -3,  -3,  -3,	-3,  -2,  -2,  -2,  -2,	 -2,  -1,  -1,	-1,  -1,  -1; 240
; ===============================================================================

Obj0A_Countdown:
		tst.w	$2C(a0)
		bne.w	loc_121D6
		cmpi.b	#6,(RAM_ObjRam_Sonic+$24).w
		bcc.w	locret_122DC
		btst	#6,(RAM_ObjRam_Sonic+$22).w
		beq.w	locret_122DC
		subq.w	#1,$38(a0)
		bpl.w	loc_121FC
		move.w	#$3B,$38(a0)
		move.w	#1,$36(a0)
		jsr	(PseudoRandomNumber).l
		andi.w	#1,d0
		move.b	d0,$34(a0)
		move.w	(RAM_Sonic_AirLeft).w,d0
		cmpi.w	#$19,d0
		beq.s	loc_12166
		cmpi.w	#$14,d0
		beq.s	loc_12166
		cmpi.w	#$F,d0
		beq.s	loc_12166
		cmpi.w	#$C,d0
		bhi.s	loc_12170
		bne.s	loc_12152
		move.w	#$92,d0
		jsr	(PlaySound).l

loc_12152:
		subq.b	#1,$32(a0)
		bpl.s	loc_12170
		move.b	$33(a0),$32(a0)
		bset	#7,$36(a0)
		bra.s	loc_12170
; ===============================================================================

loc_12166:
		move.w	#$C2,d0
		jsr	(PlaySound_Special).l

loc_12170:
		subq.w	#1,(RAM_Sonic_AirLeft).w
		bcc.w	loc_121FA
		bsr.w	ResumeMusic
		move.b	#$81,(RAM_Flag_ControlLock).w
		move.w	#$B2,d0
		jsr	(PlaySound_Special).l
		move.b	#$A,$34(a0)
		move.w	#1,$36(a0)
		move.w	#$78,$2C(a0)
		move.l	a0,-(sp)
		lea	(RAM_ObjRAM_Sonic).w,a0
		bsr.w	Sonic_ResetOnFloor
		move.b	#$17,$1C(a0)
		bset	#1,$22(a0)
		bset	#7,2(a0)
		move.w	#0,$12(a0)
		move.w	#0,$10(a0)
		move.w	#0,$14(a0)
		move.b	#1,(RAM_Level_NoEffectsFlag).w
		movea.l	(sp)+,a0
		rts
; ===============================================================================

loc_121D6:				; CODE XREF: ROM:000120F0j
		subq.w	#1,$2C(a0)
		bne.s	loc_121E4
		move.b	#6,(RAM_ObjRAM_Sonic+$24).w
		rts
; ===============================================================================

loc_121E4:				; CODE XREF: ROM:000121DAj
		move.l	a0,-(sp)
		lea	(RAM_ObjRAM_Sonic).w,a0
		jsr	SpeedToPos
		addi.w	#$10,$12(a0)
		movea.l	(sp)+,a0
		bra.s	loc_121FC
; ===============================================================================

loc_121FA:				; CODE XREF: ROM:00012174j
		bra.s	loc_1220C
; ===============================================================================

loc_121FC:				; CODE XREF: ROM:0001210Cj
					; ROM:000121F8j
		tst.w	$36(a0)
		beq.w	locret_122DC
		subq.w	#1,$3A(a0)
		bpl.w	locret_122DC

loc_1220C:				; CODE XREF: ROM:loc_121FAj
		jsr	(PseudoRandomNumber).l
		andi.w	#$F,d0
		move.w	d0,$3A(a0)
		jsr	SingleObjectLoad
		bne.w	locret_122DC
		move.b	#$A,0(a1)
		move.w	(RAM_ObjRam_Sonic+$8).w,8(a1)
		moveq	#6,d0
		btst	#0,(RAM_ObjRam_Sonic+$22).w
		beq.s	loc_12242
		neg.w	d0
		move.b	#$40,$26(a1) ; '@'

loc_12242:				; CODE XREF: ROM:00012238j
		add.w	d0,8(a1)
		move.w	(RAM_ObjRam_Sonic+$C).w,$C(a1)
		move.b	#6,$28(a1)
		tst.w	$2C(a0)
		beq.w	loc_1228E
		andi.w	#7,$3A(a0)
		addi.w	#0,$3A(a0)
		move.w	(RAM_ObjRam_Sonic+$C).w,d0
		subi.w	#$C,d0
		move.w	d0,$C(a1)
		jsr	(PseudoRandomNumber).l
		move.b	d0,$26(a1)
		move.w	(RAM_Flag_LevelFrameTmr).w,d0
		andi.b	#3,d0
		bne.s	loc_122D2
		move.b	#$E,$28(a1)
		bra.s	loc_122D2
; ===============================================================================

loc_1228E:
		btst	#7,$36(a0)
		beq.s	loc_122D2
		move.w	(RAM_Sonic_AirLeft).w,d2
		lsr.w	#1,d2
		jsr	(PseudoRandomNumber).l
		andi.w	#3,d0
		bne.s	loc_122BA
		bset	#6,$36(a0)
		bne.s	loc_122D2
		move.b	d2,$28(a1)
		move.w	#$1C,$38(a1)

loc_122BA:
		tst.b	$34(a0)
		bne.s	loc_122D2
		bset	#6,$36(a0)
		bne.s	loc_122D2
		move.b	d2,$28(a1)
		move.w	#$1C,$38(a1)

loc_122D2:
		subq.b	#1,$34(a0)
		bpl.s	locret_122DC
		clr.w	$36(a0)

locret_122DC:
		rts

; =============== S U B R O U T I N E ==========================================


ResumeMusic:
		cmpi.w	#$C,(RAM_Sonic_AirLeft).w
		bhi.s	loc_12310
		move.w	#$82,d0	; ''
		cmpi.w	#$103,(RAM_Level_CurrentZone).w
		bne.s	loc_122F6
		move.w	#$86,d0

loc_122F6:
		tst.b	(RAM_Flag_Sonic_Invincibility).w
		beq.s	loc_12300
		move.w	#$87,d0

loc_12300:
		tst.b	(RAM_Level_BossMode).w
		beq.s	loc_1230A
		move.w	#$8C,d0

loc_1230A:
		jsr	(PlaySound).l

loc_12310:
		move.w	#$1E,(RAM_Sonic_AirLeft).w
		clr.b	(RAM_ObjectTable+Obj_Slot_14+$32).w
		rts

; ===============================================================================
Ani_Obj0A:	dc.w byte_1233A-Ani_Obj0A,byte_12343-Ani_Obj0A;	0
		dc.w byte_1234C-Ani_Obj0A,byte_12355-Ani_Obj0A;	2
		dc.w byte_1235E-Ani_Obj0A,byte_12367-Ani_Obj0A;	4
		dc.w byte_12370-Ani_Obj0A,byte_12375-Ani_Obj0A;	6
		dc.w byte_1237D-Ani_Obj0A,byte_12385-Ani_Obj0A;	8
		dc.w byte_1238D-Ani_Obj0A,byte_12395-Ani_Obj0A;	10
		dc.w byte_1239D-Ani_Obj0A,byte_123A5-Ani_Obj0A;	12
		dc.w byte_123A7-Ani_Obj0A; 14
byte_1233A:	dc.b   5,  0,  1,  2,  3,  4,  9, $D,$FC; 0 ; DATA XREF: ROM:Ani_Obj0Ao
byte_12343:	dc.b   5,  0,  1,  2,  3,  4, $C,$12,$FC; 0 ; DATA XREF: ROM:Ani_Obj0Ao
byte_1234C:	dc.b   5,  0,  1,  2,  3,  4, $C,$11,$FC; 0 ; DATA XREF: ROM:Ani_Obj0Ao
byte_12355:	dc.b   5,  0,  1,  2,  3,  4, $B,$10,$FC; 0 ; DATA XREF: ROM:Ani_Obj0Ao
byte_1235E:	dc.b   5,  0,  1,  2,  3,  4,  9, $F,$FC; 0 ; DATA XREF: ROM:Ani_Obj0Ao
byte_12367:	dc.b   5,  0,  1,  2,  3,  4, $A, $E,$FC; 0 ; DATA XREF: ROM:Ani_Obj0Ao
byte_12370:	dc.b  $E,  0,  1,  2,$FC; 0 ; DATA XREF: ROM:Ani_Obj0Ao
byte_12375:	dc.b   7,$16, $D,$16, $D,$16, $D,$FC; 0	; DATA XREF: ROM:Ani_Obj0Ao
byte_1237D:	dc.b   7,$16,$12,$16,$12,$16,$12,$FC; 0	; DATA XREF: ROM:Ani_Obj0Ao
byte_12385:	dc.b   7,$16,$11,$16,$11,$16,$11,$FC; 0	; DATA XREF: ROM:Ani_Obj0Ao
byte_1238D:	dc.b   7,$16,$10,$16,$10,$16,$10,$FC; 0	; DATA XREF: ROM:Ani_Obj0Ao
byte_12395:	dc.b   7,$16, $F,$16, $F,$16, $F,$FC; 0	; DATA XREF: ROM:Ani_Obj0Ao
byte_1239D:	dc.b   7,$16, $E,$16, $E,$16, $E,$FC; 0	; DATA XREF: ROM:Ani_Obj0Ao
byte_123A5:	dc.b  $E,$FC		; 0 ; DATA XREF: ROM:Ani_Obj0Ao
byte_123A7:	dc.b  $E,  1,  2,  3,  4,$FC,  0; 0 ; DATA XREF: ROM:Ani_Obj0Ao
Map_Obj0A_Countdown:dc.w word_123B0-Map_Obj0A_Countdown	; DATA XREF: ROM:00011EB2o
					; ROM:Map_Obj0A_Countdowno
word_123B0:	dc.w 1			; DATA XREF: ROM:Map_Obj0A_Countdowno
		dc.w $E80E,    0,    0,$FFF2; 0
; ===============================================================================
;----------------------------------------------------
; Object 38 - shield invincibility stars
;----------------------------------------------------

Obj38:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj38_Index(pc,d0.w),d1
		jmp	Obj38_Index(pc,d1.w)
; ===============================================================================
Obj38_Index:	dc.w Obj38_Init-Obj38_Index ; DATA XREF: ROM:Obj38_Indexo
					; ROM:000123CAo ...
		dc.w Obj38_Shield-Obj38_Index
		dc.w Obj38_Stars-Obj38_Index
; ===============================================================================

Obj38_Init:				; DATA XREF: ROM:Obj38_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj38,4(a0)
		move.b	#4,1(a0)
		move.b	#1,$18(a0)
		move.b	#$18,$19(a0)
		tst.b	$1C(a0)
		bne.s	loc_1240C
		move.w	#$4BE,2(a0)
		cmpi.b	#3,(RAM_Level_CurrentZone).w
		bne.s	loc_12406
		move.w	#$560,2(a0)

loc_12406:				; CODE XREF: ROM:000123FEj
		bsr.w	ModifySpriteAttr_2P
		rts
; ===============================================================================

loc_1240C:				; CODE XREF: ROM:000123F0j
		addq.b	#2,$24(a0)
		move.l	#Map_Sonic,4(a0)
		move.w	#$4DE,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#2,$18(a0)
		rts
; ===============================================================================

Obj38_Shield:				; DATA XREF: ROM:000123CAo
		tst.b	(RAM_Flag_Sonic_Invincibility).w
		bne.s	locret_1245A
		tst.b	(RAM_Flag_Sonic_Shield).w
		beq.s	loc_1245C
		move.w	(RAM_ObjRam_Sonic+$8).w,8(a0)
		move.w	(RAM_ObjRam_Sonic+$C).w,$C(a0)
		move.b	(RAM_ObjRam_Sonic+$22).w,$22(a0)
		lea	(Ani_Obj38_Shield).l,a1
		jsr	AnimateSprite
		jmp	DisplaySprite
; ===============================================================================

locret_1245A:				; CODE XREF: ROM:0001242Ej
		rts
; ===============================================================================

loc_1245C:				; CODE XREF: ROM:00012434j
		jmp	DeleteObject
; ===============================================================================

Obj38_Stars:
		tst.b	(RAM_Flag_Sonic_Invincibility).w
		beq.s	loc_124B2
		move.w	($FFFFEEE0).w,d0
		move.b	$1C(a0),d1
		subq.b	#1,d1
		move.b	#$3F,d1
		lsl.b	#2,d1
		addi.b	#4,d1
		sub.b	d1,d0
		lea	(RAM_Stars_InvStarPosTable).w,a1
		lea	(a1,d0.w),a1
		move.w	(a1)+,d0
		andi.w	#$3FFF,d0
		move.w	d0,8(a0)
		move.w	(a1)+,d0
		andi.w	#$7FF,d0
		move.w	d0,$C(a0)
		move.b	(RAM_ObjRam_Sonic+$22).w,$22(a0)
		move.b	(RAM_ObjRam_Sonic+$1A).w,$1A(a0)
		move.b	(RAM_ObjRam_Sonic+$1).w,1(a0)
		jmp	DisplaySprite
; ===============================================================================

loc_124B2:				; CODE XREF: ROM:00012466j
		jmp	DeleteObject
; ===============================================================================
;----------------------------------------------------
; Sonic	1 Object 4A - special stage entry from
;		      Sonic 1 beta
;----------------------------------------------------

S1Obj4A:
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	S1Obj4A_Index(pc,d0.w),d1
		jmp	S1Obj4A_Index(pc,d1.w)
; ===============================================================================
S1Obj4A_Index:	dc.w S1Obj4A_Init-S1Obj4A_Index
		dc.w S1Obj4A_RmvSonic-S1Obj4A_Index
		dc.w S1Obj4A_LoadSonic-S1Obj4A_Index
; ===============================================================================

S1Obj4A_Init:				; DATA XREF: ROM:S1Obj4A_Indexo
		tst.l	(RAM_PLC_Buffer).w
		beq.s	loc_124D4
		rts
; ===============================================================================

loc_124D4:				; CODE XREF: ROM:000124D0j
		addq.b	#2,$24(a0)
		move.l	#Map_S1Obj4A,4(a0)
		move.b	#4,1(a0)
		move.b	#1,$18(a0)
		move.b	#$38,$19(a0) ; '8'
		move.w	#$541,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.w	#$78,$30(a0) ; 'x'

S1Obj4A_RmvSonic:			; DATA XREF: ROM:000124C8o
		move.w	(RAM_ObjRam_Sonic+$8).w,8(a0)
		move.w	(RAM_ObjRam_Sonic+$C).w,$C(a0)
		move.b	(RAM_ObjRam_Sonic+$22).w,$22(a0)
		lea	(Ani_S1Obj4A).l,a1
		jsr	AnimateSprite
		cmpi.b	#2,$1A(a0)
		bne.s	loc_1253E
		tst.b	(RAM_ObjRAM_Sonic).w
		beq.s	loc_1253E
		move.b	#0,(RAM_ObjRAM_Sonic).w
		move.w	#$A8,d0	; ''
		jsr	(PlaySound_Special).l

loc_1253E:				; CODE XREF: ROM:00012526j
					; ROM:0001252Cj
		jmp	DisplaySprite
; ===============================================================================

S1Obj4A_LoadSonic:			; DATA XREF: ROM:000124CAo
		subq.w	#1,$30(a0)
		bne.s	locret_12556
		move.b	#1,(RAM_ObjRAM_Sonic).w
		jmp	DeleteObject
; ===============================================================================

locret_12556:				; CODE XREF: ROM:00012548j
		rts
; ===============================================================================
;----------------------------------------------------
; Object 08 - water splash
;----------------------------------------------------

Obj08:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj08_Index(pc,d0.w),d1
		jmp	Obj08_Index(pc,d1.w)
; ===============================================================================
Obj08_Index:	dc.w Obj08_Init-Obj08_Index ; DATA XREF: ROM:Obj08_Indexo
					; ROM:00012568o ...
		dc.w Obj08_Display-Obj08_Index
		dc.w Obj08_Delete-Obj08_Index
; ===============================================================================

Obj08_Init:				; DATA XREF: ROM:Obj08_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj08,4(a0)
		ori.b	#4,1(a0)
		move.b	#1,$18(a0)
		move.b	#$10,$19(a0)
		move.w	#$4259,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.w	(RAM_ObjRam_Sonic+$8).w,8(a0)

Obj08_Display:				; DATA XREF: ROM:00012568o
		move.w	(RAM_Level_Water_Action).w,$C(a0)
		lea	(Ani_Obj08).l,a1
		jsr	AnimateSprite
		jmp	DisplaySprite
; ===============================================================================

Obj08_Delete:				; DATA XREF: ROM:0001256Ao
		jmp	DeleteObject
; ===============================================================================
Ani_Obj38_Shield:dc.w byte_125C2-Ani_Obj38_Shield ; DATA XREF: ROM:00012448o
					; ROM:Ani_Obj38_Shieldo ...
		dc.w byte_125CE-Ani_Obj38_Shield
		dc.w byte_125D4-Ani_Obj38_Shield
		dc.w byte_125EE-Ani_Obj38_Shield
		dc.w byte_12608-Ani_Obj38_Shield
byte_125C2:	dc.b   0,  5,  0,  5,  1,  5,  2,  5,  3,  5,  4,$FF; 0
					; DATA XREF: ROM:Ani_Obj38_Shieldo
byte_125CE:	dc.b   5,  4,  5,  6,  7,$FF; 0	; DATA XREF: ROM:000125BAo
byte_125D4:	dc.b   0,  4,  4,  0,  4,  4,  0,  5,  5,  0,  5,  5,  0,  6,  6,  0; 0
					; DATA XREF: ROM:000125BCo
		dc.b   6,  6,  0,  7,  7,  0,  7,  7,  0,$FF; 16
byte_125EE:	dc.b   0,  4,  4,  0,  4,  0,  0,  5,  5,  0,  5,  0,  0,  6,  6,  0; 0
					; DATA XREF: ROM:000125BEo
		dc.b   6,  0,  0,  7,  7,  0,  7,  0,  0,$FF; 16
byte_12608:	dc.b   0,  4,  0,  0,  4,  0,  0,  5,  0,  0,  5,  0,  0,  6,  0,  0; 0
					; DATA XREF: ROM:000125C0o
		dc.b   6,  0,  0,  7,  0,  0,  7,  0,  0,$FF; 16
Map_Obj38:	dc.w word_12636-Map_Obj38 ; DATA XREF: ROM:000123D2o
					; ROM:Map_Obj38o ...
		dc.w word_12658-Map_Obj38
		dc.w word_1267A-Map_Obj38
		dc.w word_1269C-Map_Obj38
		dc.w word_126BE-Map_Obj38
		dc.w word_126E0-Map_Obj38
		dc.w word_12702-Map_Obj38
		dc.w word_12724-Map_Obj38
		dc.w word_12746-Map_Obj38
		dc.w word_12768-Map_Obj38
word_12636:	dc.w 4			; DATA XREF: ROM:Map_Obj38o
		dc.w $F005,    0,    0,$FFF0; 0
		dc.w $F005, $800, $800,	   0; 4
		dc.w	 5,$1000,$1000,$FFF0; 8
		dc.w	 5,$1800,$1800,	   0; 12
word_12658:	dc.w 4			; DATA XREF: ROM:00012624o
		dc.w $F005,    4,    2,$FFF0; 0
		dc.w $F005, $804, $802,	   0; 4
		dc.w	 5,$1004,$1002,$FFF0; 8
		dc.w	 5,$1804,$1802,	   0; 12
word_1267A:	dc.w 4			; DATA XREF: ROM:00012626o
		dc.w $F005,    8,    4,$FFF0; 0
		dc.w $F005, $808, $804,	   0; 4
		dc.w	 5,$1008,$1004,$FFF0; 8
		dc.w	 5,$1808,$1804,	   0; 12
word_1269C:	dc.w 4			; DATA XREF: ROM:00012628o
		dc.w $F005,   $C,    6,$FFF0; 0
		dc.w $F005, $80C, $806,	   0; 4
		dc.w	 5,$100C,$1006,$FFF0; 8
		dc.w	 5,$180C,$1806,	   0; 12
word_126BE:	dc.w 4			; DATA XREF: ROM:0001262Ao
		dc.w $F005,  $10,    8,$FFF0; 0
		dc.w $F005, $810, $808,	   0; 4
		dc.w	 5,$1010,$1008,$FFF0; 8
		dc.w	 5,$1810,$1808,	   0; 12
word_126E0:	dc.w 4			; DATA XREF: ROM:0001262Co
		dc.w $E00B,  $14,   $A,$FFE8; 0
		dc.w $E00B, $814, $80A,	   0; 4
		dc.w	$B,$1014,$100A,$FFE8; 8
		dc.w	$B,$1814,$180A,	   0; 12
word_12702:	dc.w 4			; DATA XREF: ROM:0001262Eo
		dc.w $E80A,    0,    0,$FFE8; 0
		dc.w $E80A,    9,    4,	   0; 4
		dc.w	$A,$1809,$1804,$FFE8; 8
		dc.w	$A,$1800,$1800,	   0; 12
word_12724:	dc.w 4			; DATA XREF: ROM:00012630o
		dc.w $E80A, $809, $804,$FFE8; 0
		dc.w $E80A, $800, $800,	   0; 4
		dc.w	$A,$1000,$1000,$FFE8; 8
		dc.w	$A,$1009,$1004,	   0; 12
word_12746:	dc.w 4			; DATA XREF: ROM:00012632o
		dc.w $E80A,  $12,    9,$FFE8; 0
		dc.w $E80A,  $1B,   $D,	   0; 4
		dc.w	$A,$181B,$180D,$FFE8; 8
		dc.w	$A,$1812,$1809,	   0; 12
word_12768:	dc.w 4			; DATA XREF: ROM:00012634o
		dc.w $E80A, $81B, $80D,$FFE8; 0
		dc.w $E80A, $812, $809,	   0; 4
		dc.w	$A,$1012,$1009,$FFE8; 8
		dc.w	$A,$101B,$100D,	   0; 12
Ani_S1Obj4A:	dc.w byte_1278C-Ani_S1Obj4A ; DATA XREF: ROM:00012514o
					; ROM:Ani_S1Obj4Ao
byte_1278C:	dc.b   5,  0,  1,  0,  1,  0,  7,  1,  7,  2,  7,  3,  7,  4,  7,  5; 0
					; DATA XREF: ROM:Ani_S1Obj4Ao
		dc.b   7,  6,  7,$FC	; 16
Map_S1Obj4A:	dc.w word_127B0-Map_S1Obj4A ; DATA XREF: ROM:000124D8o
					; ROM:Map_S1Obj4Ao ...
		dc.w word_127CA-Map_S1Obj4A
		dc.w word_127E4-Map_S1Obj4A
		dc.w word_1280E-Map_S1Obj4A
		dc.w word_12858-Map_S1Obj4A
		dc.w word_128EA-Map_S1Obj4A
		dc.w word_12974-Map_S1Obj4A
		dc.w word_129BE-Map_S1Obj4A
word_127B0:	dc.w 3			; DATA XREF: ROM:Map_S1Obj4Ao
		dc.w $F800,    0,    0,	   8; 0
		dc.w	 4,    1,    0,	   0; 4
		dc.w  $800,$1000,$1000,	   8; 8
word_127CA:	dc.w 3			; DATA XREF: ROM:000127A2o
		dc.w $F00D,    3,    1,$FFF0; 0
		dc.w	$C,   $B,    5,$FFF0; 4
		dc.w  $80D,$1003,$1001,$FFF0; 8
word_127E4:	dc.w 5			; DATA XREF: ROM:000127A4o
		dc.w $E40E,   $F,    7,$FFF4; 0
		dc.w $EC02,  $1B,   $D,$FFEC; 4
		dc.w $FC0C,  $1E,   $F,$FFF4; 8
		dc.w  $40E,$100F,$1007,$FFF4; 12
		dc.w  $401,$101B,$100D,$FFEC; 16
word_1280E:	dc.w 9			; DATA XREF: ROM:000127A6o
		dc.w $F008,  $22,  $11,$FFF8; 0
		dc.w $F80E,  $25,  $12,$FFF0; 4
		dc.w $1008,  $31,  $18,$FFF0; 8
		dc.w	 5,  $34,  $1A,	 $10; 12
		dc.w $F800, $825, $812,	 $10; 16
		dc.w $F000,$1836,$181B,	 $18; 20
		dc.w $F800,$1825,$1812,	 $20; 24
		dc.w	 0, $825, $812,	 $28; 28
		dc.w $F800,  $25,  $12,	 $30; 32
word_12858:	dc.w $12		; DATA XREF: ROM:000127A8o
		dc.w	 0,$1825,$1812,$FFF0; 0
		dc.w $F804,  $38,  $1C,$FFF8; 4
		dc.w $F000,  $26,  $13,	   8; 8
		dc.w	 0,  $25,  $12,	   0; 12
		dc.w  $800,$1825,$1812,$FFF8; 16
		dc.w $1000,$1026,$1013,	   0; 20
		dc.w  $800,$1038,$101C,	   8; 24
		dc.w $F800,  $29,  $14,	 $10; 28
		dc.w	 0,  $26,  $13,	 $10; 32
		dc.w	 0,  $2D,  $16,	 $18; 36
		dc.w  $800, $826, $813,	 $18; 40
		dc.w  $800,  $29,  $14,	 $20; 44
		dc.w $F800,  $26,  $13,	 $20; 48
		dc.w $F800,  $2D,  $16,	 $28; 52
		dc.w	 0,  $3A,  $1D,	 $28; 56
		dc.w $F800,$1826,$1813,	 $30; 60
		dc.w	 0,$1025,$1012,	 $38; 64
		dc.w $F800,$1025,$1012,	 $40; 68
word_128EA:	dc.w $11		; DATA XREF: ROM:000127AAo
		dc.w $F800, $825, $812,	   0; 0
		dc.w $F000,  $38,  $1C,	 $10; 4
		dc.w $1000, $825, $812,	   0; 8
		dc.w	 0,$1825,$1812,	 $10; 12
		dc.w  $800,$1025,$1012,	 $18; 16
		dc.w $F800,$1825,$1812,	 $20; 20
		dc.w	 0,$1026,$1013,	 $28; 24
		dc.w $F800,$1025,$1012,	 $30; 28
		dc.w	 0,  $25,  $12,	 $30; 32
		dc.w  $800, $825, $812,	 $30; 36
		dc.w	 0, $826, $813,	 $38; 40
		dc.w  $800,  $29,  $14,	 $38; 44
		dc.w $F800, $826, $813,	 $40; 48
		dc.w	 0,  $2D,  $16,	 $40; 52
		dc.w $F800, $825, $812,	 $48; 56
		dc.w	 0,  $25,  $12,	 $48; 60
		dc.w	 0,$1025,$1012,	 $50; 64
word_12974:	dc.w 9			; DATA XREF: ROM:000127ACo
		dc.w $FC00, $826, $813,	 $30; 0
		dc.w  $400, $825, $812,	 $28; 4
		dc.w  $400,$1027,$1013,	 $38; 8
		dc.w  $400, $826, $813,	 $40; 12
		dc.w $FC00,$1025,$1012,	 $40; 16
		dc.w $FC00,$1026,$1013,	 $48; 20
		dc.w  $C00, $827, $813,	 $48; 24
		dc.w  $400,$1826,$1813,	 $50; 28
		dc.w  $400, $827, $813,	 $58; 32
word_129BE:	dc.w 0			; DATA XREF: ROM:000127AEo
Ani_Obj08:	dc.w byte_129C2-Ani_Obj08 ; DATA XREF: ROM:000125A0o
					; ROM:Ani_Obj08o
byte_129C2:	dc.b   4,  0,  1,  2,$FC,  0; 0	; DATA XREF: ROM:Ani_Obj08o
Map_Obj08:	dc.w word_129CE-Map_Obj08 ; DATA XREF: ROM:00012570o
					; ROM:Map_Obj08o ...
		dc.w word_129E0-Map_Obj08
		dc.w word_129F2-Map_Obj08
word_129CE:	dc.w 2			; DATA XREF: ROM:Map_Obj08o
		dc.w $F204,  $6D,  $36,$FFF8; 0
		dc.w $FA0C,  $6F,  $37,$FFF0; 4
word_129E0:	dc.w 2			; DATA XREF: ROM:000129CAo
		dc.w $E200,  $73,  $39,$FFF8; 0
		dc.w $EA0E,  $74,  $3A,$FFF0; 4
word_129F2:	dc.w 1			; DATA XREF: ROM:000129CCo
		dc.w $E20F,  $80,  $40,$FFF0; 0

; =============== S U B R O U T I N E ==========================================


Sonic_AnglePos:
		move.l	#RAM_Level_ColP,(RAM_Level_ColPointer).w
		cmpi.b	#$C,$3E(a0)
		beq.s	loc_12A14
		move.l	#RAM_Level_ColS,(RAM_Level_ColPointer).w

loc_12A14:				; CODE XREF: Sonic_AnglePos+Ej
		move.b	$3E(a0),d5
		btst	#3,$22(a0)
		beq.s	loc_12A2C
		moveq	#0,d0
		move.b	d0,(RAM_Sonic_CurrAngle_Front).w
		move.b	d0,(RAM_Sonic_CurrAngle_Below).w
		rts
; ===============================================================================

loc_12A2C:				; CODE XREF: Sonic_AnglePos+22j
		moveq	#3,d0
		move.b	d0,(RAM_Sonic_CurrAngle_Front).w
		move.b	d0,(RAM_Sonic_CurrAngle_Below).w
		move.b	$26(a0),d0
		addi.b	#$20,d0	; ' '
		bpl.s	loc_12A4E
		move.b	$26(a0),d0
		bpl.s	loc_12A48
		subq.b	#1,d0

loc_12A48:				; CODE XREF: Sonic_AnglePos+48j
		addi.b	#$20,d0	; ' '
		bra.s	loc_12A5A
; ===============================================================================

loc_12A4E:				; CODE XREF: Sonic_AnglePos+42j
		move.b	$26(a0),d0
		bpl.s	loc_12A56
		addq.b	#1,d0

loc_12A56:				; CODE XREF: Sonic_AnglePos+56j
		addi.b	#$1F,d0

loc_12A5A:				; CODE XREF: Sonic_AnglePos+50j
		andi.b	#$C0,d0
		cmpi.b	#$40,d0	; '@'
		beq.w	Sonic_WalkVertL
		cmpi.b	#$80,d0
		beq.w	Sonic_WalkCeiling
		cmpi.b	#$C0,d0
		beq.w	Sonic_WalkVertR
		move.w	$C(a0),d2
		move.w	8(a0),d3
		moveq	#0,d0
		move.b	$16(a0),d0
		ext.w	d0
		add.w	d0,d2
		move.b	$17(a0),d0
		ext.w	d0
		add.w	d0,d3
		lea	(RAM_Sonic_CurrAngle_Front).w,a4
		movea.w	#$10,a3
		move.w	#0,d6
		bsr.w	FindFloor
		move.w	d1,-(sp)
		move.w	$C(a0),d2
		move.w	8(a0),d3
		moveq	#0,d0
		move.b	$16(a0),d0
		ext.w	d0
		add.w	d0,d2
		move.b	$17(a0),d0
		ext.w	d0
		neg.w	d0
		add.w	d0,d3
		lea	(RAM_Sonic_CurrAngle_Below).w,a4
		movea.w	#$10,a3
		move.w	#0,d6
		bsr.w	FindFloor
		move.w	(sp)+,d0
		bsr.w	Sonic_Angle
		tst.w	d1
		beq.s	locret_12AE4
		bpl.s	loc_12AE6
		cmpi.w	#$FFF2,d1
		blt.s	locret_12B0C
		add.w	d1,$C(a0)

locret_12AE4:				; CODE XREF: Sonic_AnglePos+DAj
		rts
; ===============================================================================

loc_12AE6:				; CODE XREF: Sonic_AnglePos+DCj
		cmpi.w	#$E,d1
		bgt.s	loc_12AF2

loc_12AEC:				; CODE XREF: Sonic_AnglePos+FAj
		add.w	d1,$C(a0)
		rts
; ===============================================================================

loc_12AF2:				; CODE XREF: Sonic_AnglePos+EEj
		tst.b	$38(a0)
		bne.s	loc_12AEC
		bset	#1,$22(a0)
		bclr	#5,$22(a0)
		move.b	#1,$1D(a0)
		rts
; ===============================================================================

locret_12B0C:				; CODE XREF: Sonic_AnglePos+E2j
					; Sonic_AnglePos+2ACj
		rts
; End of function Sonic_AnglePos

; ===============================================================================
		move.l	8(a0),d2
		move.w	$10(a0),d0
		ext.l	d0
		asl.l	#8,d0
		sub.l	d0,d2
		move.l	d2,8(a0)
		move.w	#$38,d0	; '8'
		ext.l	d0
		asl.l	#8,d0
		sub.l	d0,d3
		move.l	d3,$C(a0)
		rts
; ===============================================================================
; START	OF FUNCTION CHUNK FOR Sonic_AnglePos

locret_12B30:				; CODE XREF: Sonic_AnglePos+20Ej
					; Sonic_AnglePos+34Aj
		rts
; END OF FUNCTION CHUNK	FOR Sonic_AnglePos
; ===============================================================================
		move.l	$C(a0),d3
		move.w	$12(a0),d0
		subi.w	#$38,d0	; '8'
		move.w	d0,$12(a0)
		ext.l	d0
		asl.l	#8,d0
		sub.l	d0,d3
		move.l	d3,$C(a0)
		rts
; ===============================================================================
		rts
; ===============================================================================
		move.l	8(a0),d2
		move.l	$C(a0),d3
		move.w	$10(a0),d0
		ext.l	d0
		asl.l	#8,d0
		sub.l	d0,d2
		move.w	$12(a0),d0
		ext.l	d0
		asl.l	#8,d0
		sub.l	d0,d3
		move.l	d2,8(a0)
		move.l	d3,$C(a0)
		rts

; =============== S U B R O U T I N E ==========================================


Sonic_Angle:				; CODE XREF: Sonic_AnglePos+D4p
					; Sonic_AnglePos+200p ...
		move.b	(RAM_Sonic_CurrAngle_Below).w,d2
		cmp.w	d0,d1
		ble.s	loc_12B84
		move.b	(RAM_Sonic_CurrAngle_Front).w,d2
		move.w	d0,d1

loc_12B84:				; CODE XREF: Sonic_Angle+6j
		btst	#0,d2
		bne.s	loc_12B90
		move.b	d2,$26(a0)
		rts
; ===============================================================================

loc_12B90:				; CODE XREF: Sonic_Angle+12j
		move.b	$26(a0),d2
		addi.b	#$20,d2	; ' '
		andi.b	#$C0,d2
		move.b	d2,$26(a0)
		rts
; End of function Sonic_Angle

; ===============================================================================
; START	OF FUNCTION CHUNK FOR Sonic_AnglePos

Sonic_WalkVertR:			; CODE XREF: Sonic_AnglePos+76j
		move.w	$C(a0),d2
		move.w	8(a0),d3
		moveq	#0,d0
		move.b	$17(a0),d0
		ext.w	d0
		neg.w	d0
		add.w	d0,d2
		move.b	$16(a0),d0
		ext.w	d0
		add.w	d0,d3
		lea	(RAM_Sonic_CurrAngle_Front).w,a4
		movea.w	#$10,a3
		move.w	#0,d6
		bsr.w	FindWall
		move.w	d1,-(sp)
		move.w	$C(a0),d2
		move.w	8(a0),d3
		moveq	#0,d0
		move.b	$17(a0),d0
		ext.w	d0
		add.w	d0,d2
		move.b	$16(a0),d0
		ext.w	d0
		add.w	d0,d3
		lea	(RAM_Sonic_CurrAngle_Below).w,a4
		movea.w	#$10,a3
		move.w	#0,d6
		bsr.w	FindWall
		move.w	(sp)+,d0
		bsr.w	Sonic_Angle
		tst.w	d1
		beq.s	locret_12C12
		bpl.s	loc_12C14
		cmpi.w	#$FFF2,d1
		blt.w	locret_12B30
		add.w	d1,8(a0)

locret_12C12:				; CODE XREF: Sonic_AnglePos+206j
		rts
; ===============================================================================

loc_12C14:				; CODE XREF: Sonic_AnglePos+208j
		cmpi.w	#$E,d1
		bgt.s	loc_12C20

loc_12C1A:				; CODE XREF: Sonic_AnglePos+228j
		add.w	d1,8(a0)
		rts
; ===============================================================================

loc_12C20:				; CODE XREF: Sonic_AnglePos+21Cj
		tst.b	$38(a0)
		bne.s	loc_12C1A
		bset	#1,$22(a0)
		bclr	#5,$22(a0)
		move.b	#1,$1D(a0)
		rts
; ===============================================================================

Sonic_WalkCeiling:			; CODE XREF: Sonic_AnglePos+6Ej
		move.w	$C(a0),d2
		move.w	8(a0),d3
		moveq	#0,d0
		move.b	$16(a0),d0
		ext.w	d0
		sub.w	d0,d2
		eori.w	#$F,d2
		move.b	$17(a0),d0
		ext.w	d0
		add.w	d0,d3
		lea	(RAM_Sonic_CurrAngle_Front).w,a4
		movea.w	#$FFF0,a3
		move.w	#$800,d6
		bsr.w	FindFloor
		move.w	d1,-(sp)
		move.w	$C(a0),d2
		move.w	8(a0),d3
		moveq	#0,d0
		move.b	$16(a0),d0
		ext.w	d0
		sub.w	d0,d2
		eori.w	#$F,d2
		move.b	$17(a0),d0
		ext.w	d0
		sub.w	d0,d3
		lea	(RAM_Sonic_CurrAngle_Below).w,a4
		movea.w	#$FFF0,a3
		move.w	#$800,d6
		bsr.w	FindFloor
		move.w	(sp)+,d0
		bsr.w	Sonic_Angle
		tst.w	d1
		beq.s	locret_12CB0
		bpl.s	loc_12CB2
		cmpi.w	#$FFF2,d1
		blt.w	locret_12B0C
		sub.w	d1,$C(a0)

locret_12CB0:				; CODE XREF: Sonic_AnglePos+2A4j
		rts
; ===============================================================================

loc_12CB2:				; CODE XREF: Sonic_AnglePos+2A6j
		cmpi.w	#$E,d1
		bgt.s	loc_12CBE

loc_12CB8:				; CODE XREF: Sonic_AnglePos+2C6j
		sub.w	d1,$C(a0)
		rts
; ===============================================================================

loc_12CBE:				; CODE XREF: Sonic_AnglePos+2BAj
		tst.b	$38(a0)
		bne.s	loc_12CB8
		bset	#1,$22(a0)
		bclr	#5,$22(a0)
		move.b	#1,$1D(a0)
		rts
; ===============================================================================

Sonic_WalkVertL:			; CODE XREF: Sonic_AnglePos+66j
		move.w	$C(a0),d2
		move.w	8(a0),d3
		moveq	#0,d0
		move.b	$17(a0),d0
		ext.w	d0
		sub.w	d0,d2
		move.b	$16(a0),d0
		ext.w	d0
		sub.w	d0,d3
		eori.w	#$F,d3
		lea	(RAM_Sonic_CurrAngle_Front).w,a4
		movea.w	#$FFF0,a3
		move.w	#$400,d6
		bsr.w	FindWall
		move.w	d1,-(sp)
		move.w	$C(a0),d2
		move.w	8(a0),d3
		moveq	#0,d0
		move.b	$17(a0),d0
		ext.w	d0
		add.w	d0,d2
		move.b	$16(a0),d0
		ext.w	d0
		sub.w	d0,d3
		eori.w	#$F,d3
		lea	(RAM_Sonic_CurrAngle_Below).w,a4
		movea.w	#$FFF0,a3
		move.w	#$400,d6
		bsr.w	FindWall
		move.w	(sp)+,d0
		bsr.w	Sonic_Angle
		tst.w	d1
		beq.s	locret_12D4E
		bpl.s	loc_12D50
		cmpi.w	#$FFF2,d1
		blt.w	locret_12B30
		sub.w	d1,8(a0)

locret_12D4E:				; CODE XREF: Sonic_AnglePos+342j
		rts
; ===============================================================================

loc_12D50:				; CODE XREF: Sonic_AnglePos+344j
		cmpi.w	#$E,d1
		bgt.s	loc_12D5C

loc_12D56:				; CODE XREF: Sonic_AnglePos+364j
		sub.w	d1,8(a0)
		rts
; ===============================================================================

loc_12D5C:				; CODE XREF: Sonic_AnglePos+358j
		tst.b	$38(a0)
		bne.s	loc_12D56
		bset	#1,$22(a0)
		bclr	#5,$22(a0)
		move.b	#1,$1D(a0)
		rts
; END OF FUNCTION CHUNK	FOR Sonic_AnglePos

; =============== S U B R O U T I N E ==========================================


Floor_ChkTile:				; CODE XREF: FindFloorp FindFloor2p ...
		move.w	d2,d0
		add.w	d0,d0
		andi.w	#$F00,d0
		move.w	d3,d1
		lsr.w	#7,d1
		andi.w	#$7F,d1	; ''
		add.w	d1,d0
		moveq	#$FFFFFFFF,d1
		lea	(RAM_LevelLayout).w,a1
		move.b	(a1,d0.w),d1
		andi.w	#$FF,d1
		lsl.w	#7,d1
		move.w	d2,d0
		andi.w	#$70,d0	; 'p'
		add.w	d0,d1
		move.w	d3,d0
		lsr.w	#3,d0
		andi.w	#$E,d0
		add.w	d0,d1
		movea.l	d1,a1
		rts
; End of function Floor_ChkTile


; =============== S U B R O U T I N E ==========================================


FindFloor:				; CODE XREF: Sonic_AnglePos+A0p
					; Sonic_AnglePos+CEp ...
		bsr.s	Floor_ChkTile
		move.w	(a1),d0
		move.w	d0,d4
		andi.w	#$3FF,d0
		beq.s	loc_12DBE
		btst	d5,d4
		bne.s	loc_12DCC

loc_12DBE:				; CODE XREF: FindFloor+Aj
					; FindFloor+28j ...
		add.w	a3,d2
		bsr.w	FindFloor2
		sub.w	a3,d2
		addi.w	#$10,d1
		rts
; ===============================================================================

loc_12DCC:				; CODE XREF: FindFloor+Ej
		movea.l	(RAM_Level_ColPointer).w,a2
		add.w	d0,d0
		move.w	(a2,d0.w),d0
		beq.s	loc_12DBE
		lea	(AngleMap).l,a2
		move.b	(a2,d0.w),(a4)
		lsl.w	#4,d0
		move.w	d3,d1
		btst	#$A,d4
		beq.s	loc_12DF0
		not.w	d1
		neg.b	(a4)

loc_12DF0:				; CODE XREF: FindFloor+3Cj
		btst	#$B,d4
		beq.s	loc_12E00
		addi.b	#$40,(a4) ; '@'
		neg.b	(a4)
		subi.b	#$40,(a4) ; '@'

loc_12E00:				; CODE XREF: FindFloor+46j
		andi.w	#$F,d1
		add.w	d0,d1
		lea	(ColArray1).l,a2
		move.b	(a2,d1.w),d0
		ext.w	d0
		eor.w	d6,d4
		btst	#$B,d4
		beq.s	loc_12E1C
		neg.w	d0

loc_12E1C:				; CODE XREF: FindFloor+6Aj
		tst.w	d0
		beq.s	loc_12DBE
		bmi.s	loc_12E38
		cmpi.b	#$10,d0
		beq.s	loc_12E44
		move.w	d2,d1
		andi.w	#$F,d1
		add.w	d1,d0
		move.w	#$F,d1
		sub.w	d0,d1
		rts
; ===============================================================================

loc_12E38:				; CODE XREF: FindFloor+72j
		move.w	d2,d1
		andi.w	#$F,d1
		add.w	d1,d0
		bpl.w	loc_12DBE

loc_12E44:				; CODE XREF: FindFloor+78j
		sub.w	a3,d2
		bsr.w	FindFloor2
		add.w	a3,d2
		subi.w	#$10,d1
		rts
; End of function FindFloor


; =============== S U B R O U T I N E ==========================================


FindFloor2:				; CODE XREF: FindFloor+12p
					; FindFloor+98p
		bsr.w	Floor_ChkTile
		move.w	(a1),d0
		move.w	d0,d4
		andi.w	#$3FF,d0
		beq.s	loc_12E64
		btst	d5,d4
		bne.s	loc_12E72

loc_12E64:				; CODE XREF: FindFloor2+Cj
					; FindFloor2+2Aj ...
		move.w	#$F,d1
		move.w	d2,d0
		andi.w	#$F,d0
		sub.w	d0,d1
		rts
; ===============================================================================

loc_12E72:				; CODE XREF: FindFloor2+10j
		movea.l	(RAM_Level_ColPointer).w,a2
		add.w	d0,d0
		move.w	(a2,d0.w),d0
		beq.s	loc_12E64
		lea	(AngleMap).l,a2
		move.b	(a2,d0.w),(a4)
		lsl.w	#4,d0
		move.w	d3,d1
		btst	#$A,d4
		beq.s	loc_12E96
		not.w	d1
		neg.b	(a4)

loc_12E96:				; CODE XREF: FindFloor2+3Ej
		btst	#$B,d4
		beq.s	loc_12EA6
		addi.b	#$40,(a4) ; '@'
		neg.b	(a4)
		subi.b	#$40,(a4) ; '@'

loc_12EA6:				; CODE XREF: FindFloor2+48j
		andi.w	#$F,d1
		add.w	d0,d1
		lea	(ColArray1).l,a2
		move.b	(a2,d1.w),d0
		ext.w	d0
		eor.w	d6,d4
		btst	#$B,d4
		beq.s	loc_12EC2
		neg.w	d0

loc_12EC2:				; CODE XREF: FindFloor2+6Cj
		tst.w	d0
		beq.s	loc_12E64
		bmi.s	loc_12ED8
		move.w	d2,d1
		andi.w	#$F,d1
		add.w	d1,d0
		move.w	#$F,d1
		sub.w	d0,d1
		rts
; ===============================================================================

loc_12ED8:				; CODE XREF: FindFloor2+74j
		move.w	d2,d1
		andi.w	#$F,d1
		add.w	d1,d0
		bpl.w	loc_12E64
		not.w	d1
		rts
; End of function FindFloor2


; =============== S U B R O U T I N E ==========================================


FindWall:				; CODE XREF: Sonic_AnglePos+1CEp
					; Sonic_AnglePos+1FAp ...
		bsr.w	Floor_ChkTile
		move.w	(a1),d0
		move.w	d0,d4
		andi.w	#$3FF,d0
		beq.s	loc_12EFA
		btst	d5,d4
		bne.s	loc_12F08

loc_12EFA:				; CODE XREF: FindWall+Cj FindWall+2Aj	...
		add.w	a3,d3
		bsr.w	FindWall2
		sub.w	a3,d3
		addi.w	#$10,d1
		rts
; ===============================================================================

loc_12F08:				; CODE XREF: FindWall+10j
		movea.l	(RAM_Level_ColPointer).w,a2
		add.w	d0,d0
		move.w	(a2,d0.w),d0
		beq.s	loc_12EFA
		lea	(AngleMap).l,a2
		move.b	(a2,d0.w),(a4)
		lsl.w	#4,d0
		move.w	d2,d1
		btst	#$B,d4
		beq.s	loc_12F34
		not.w	d1
		addi.b	#$40,(a4) ; '@'
		neg.b	(a4)
		subi.b	#$40,(a4) ; '@'

loc_12F34:				; CODE XREF: FindWall+3Ej
		btst	#$A,d4
		beq.s	loc_12F3C
		neg.b	(a4)

loc_12F3C:				; CODE XREF: FindWall+50j
		andi.w	#$F,d1
		add.w	d0,d1
		lea	(ColArray2).l,a2
		move.b	(a2,d1.w),d0
		ext.w	d0
		eor.w	d6,d4
		btst	#$A,d4
		beq.s	loc_12F58
		neg.w	d0

loc_12F58:				; CODE XREF: FindWall+6Cj
		tst.w	d0
		beq.s	loc_12EFA
		bmi.s	loc_12F74
		cmpi.b	#$10,d0
		beq.s	loc_12F80
		move.w	d3,d1
		andi.w	#$F,d1
		add.w	d1,d0
		move.w	#$F,d1
		sub.w	d0,d1
		rts
; ===============================================================================

loc_12F74:				; CODE XREF: FindWall+74j
		move.w	d3,d1
		andi.w	#$F,d1
		add.w	d1,d0
		bpl.w	loc_12EFA

loc_12F80:				; CODE XREF: FindWall+7Aj
		sub.w	a3,d3
		bsr.w	FindWall2
		add.w	a3,d3
		subi.w	#$10,d1
		rts
; End of function FindWall


; =============== S U B R O U T I N E ==========================================


FindWall2:				; CODE XREF: FindWall+14p FindWall+9Ap
		bsr.w	Floor_ChkTile
		move.w	(a1),d0
		move.w	d0,d4
		andi.w	#$3FF,d0
		beq.s	loc_12FA0
		btst	d5,d4
		bne.s	loc_12FAE

loc_12FA0:				; CODE XREF: FindWall2+Cj
					; FindWall2+2Aj ...
		move.w	#$F,d1
		move.w	d3,d0
		andi.w	#$F,d0
		sub.w	d0,d1
		rts
; ===============================================================================

loc_12FAE:				; CODE XREF: FindWall2+10j
		movea.l	(RAM_Level_ColPointer).w,a2
		add.w	d0,d0
		move.w	(a2,d0.w),d0
		beq.s	loc_12FA0
		lea	(AngleMap).l,a2
		move.b	(a2,d0.w),(a4)
		lsl.w	#4,d0
		move.w	d2,d1
		btst	#$B,d4
		beq.s	loc_12FDA
		not.w	d1
		addi.b	#$40,(a4) ; '@'
		neg.b	(a4)
		subi.b	#$40,(a4) ; '@'

loc_12FDA:				; CODE XREF: FindWall2+3Ej
		btst	#$A,d4
		beq.s	loc_12FE2
		neg.b	(a4)

loc_12FE2:				; CODE XREF: FindWall2+50j
		andi.w	#$F,d1
		add.w	d0,d1
		lea	(ColArray2).l,a2
		move.b	(a2,d1.w),d0
		ext.w	d0
		eor.w	d6,d4
		btst	#$A,d4
		beq.s	loc_12FFE
		neg.w	d0

loc_12FFE:				; CODE XREF: FindWall2+6Cj
		tst.w	d0
		beq.s	loc_12FA0
		bmi.s	loc_13014
		move.w	d3,d1
		andi.w	#$F,d1
		add.w	d1,d0
		move.w	#$F,d1
		sub.w	d0,d1
		rts
; ===============================================================================

loc_13014:				; CODE XREF: FindWall2+74j
		move.w	d3,d1
		andi.w	#$F,d1
		add.w	d1,d0
		bpl.w	loc_12FA0
		not.w	d1
		rts
; End of function FindWall2

;-----------------------------------------------------------
; On-The-Fly Collision converter? (Contains wrong settings)
;-----------------------------------------------------------

; =============== S U B R O U T I N E ==========================================

FloorLog_Unk:
		rts					;Nothing to see here

		lea	(ColArray1_GHZ).l,a1
		tst.b	(RAM_Level_CurrentZone).w
		beq.s	loc_13038
		lea	(ColArray1).l,a1

loc_13038:
		lea	(ColArray1).l,a2
		move.w	#$7FF,d1

loc_13042:
		move.w	(a1)+,(a2)+
		dbf	d1,loc_13042
		lea	(ColArray2).l,a2
		move.w	#$7FF,d1

loc_13052:
		move.w	(a1)+,(a2)+
		dbf	d1,loc_13052
		lea	(AngleMap_GHZ).l,a1
		tst.b	(RAM_Level_CurrentZone).w
		beq.s	loc_1306A
		lea	(AngleMap).l,a1

loc_1306A:
		lea	(AngleMap).l,a2
		move.w	#$7F,d1

loc_13074:
		move.w	(a1)+,(a2)+
		dbf	d1,loc_13074
		rts

; =============== S U B R O U T I N E ==========================================


Sonic_WalkSpeed:
		move.l	#RAM_Level_ColP,(RAM_Level_ColPointer).w
		cmpi.b	#$C,$3E(a0)
		beq.s	loc_13094
		move.l	#RAM_Level_ColS,(RAM_Level_ColPointer).w

loc_13094:
		move.b	$3F(a0),d5
		move.l	8(a0),d3
		move.l	$C(a0),d2
		move.w	$10(a0),d1
		ext.l	d1
		asl.l	#8,d1
		add.l	d1,d3
		move.w	$12(a0),d1
		ext.l	d1
		asl.l	#8,d1
		add.l	d1,d2
		swap	d2
		swap	d3
		move.b	d0,(RAM_Sonic_CurrAngle_Front).w
		move.b	d0,(RAM_Sonic_CurrAngle_Below).w
		move.b	d0,d1
		addi.b	#$20,d0
		bpl.s	loc_130D4
		move.b	d1,d0
		bpl.s	loc_130CE
		subq.b	#1,d0

loc_130CE:
		addi.b	#$20,d0
		bra.s	loc_130DE
; ===============================================================================

loc_130D4:
		move.b	d1,d0
		bpl.s	loc_130DA
		addq.b	#1,d0

loc_130DA:
		addi.b	#$1F,d0

loc_130DE:
		andi.b	#$C0,d0
		beq.w	loc_131DE
		cmpi.b	#$80,d0
		beq.w	loc_133B0
		andi.b	#$38,d1
		bne.s	loc_130F6
		addq.w	#8,d2

loc_130F6:
		cmpi.b	#$40,d0
		beq.w	loc_13478
		bra.w	loc_132F6


; =============== S U B R O U T I N E ==========================================


sub_13102:
		move.l	#RAM_Level_ColP,(RAM_Level_ColPointer).w
		cmpi.b	#$C,$3E(a0)
		beq.s	loc_1311A
		move.l	#RAM_Level_ColS,(RAM_Level_ColPointer).w

loc_1311A:
		move.b	$3F(a0),d5
		move.b	d0,(RAM_Sonic_CurrAngle_Front).w
		move.b	d0,(RAM_Sonic_CurrAngle_Below).w
		addi.b	#$20,d0	; ' '
		andi.b	#$C0,d0
		cmpi.b	#$40,d0	; '@'
		beq.w	loc_13408
		cmpi.b	#$80,d0
		beq.w	Sonic_DontRunOnWalls
		cmpi.b	#$C0,d0
		beq.w	loc_1328E

loc_13146:
		move.l	#RAM_Level_ColP,(RAM_Level_ColPointer).w
		cmpi.b	#$C,$3E(a0)
		beq.s	loc_1315E
		move.l	#RAM_Level_ColS,(RAM_Level_ColPointer).w

loc_1315E:
		move.b	$3E(a0),d5
		move.w	$C(a0),d2
		move.w	8(a0),d3
		moveq	#0,d0
		move.b	$16(a0),d0
		ext.w	d0
		add.w	d0,d2
		move.b	$17(a0),d0
		ext.w	d0
		add.w	d0,d3
		lea	(RAM_Sonic_CurrAngle_Front).w,a4
		movea.w	#$10,a3
		move.w	#0,d6
		bsr.w	FindFloor
		move.w	d1,-(sp)
		move.w	$C(a0),d2
		move.w	8(a0),d3
		moveq	#0,d0
		move.b	$16(a0),d0
		ext.w	d0
		add.w	d0,d2
		move.b	$17(a0),d0
		ext.w	d0
		sub.w	d0,d3
		lea	(RAM_Sonic_CurrAngle_Below).w,a4
		movea.w	#$10,a3
		move.w	#0,d6
		bsr.w	FindFloor
		move.w	(sp)+,d0
		move.b	#0,d2

loc_131BE:
		move.b	(RAM_Sonic_CurrAngle_Below).w,d3
		cmp.w	d0,d1
		ble.s	loc_131CC
		move.b	(RAM_Sonic_CurrAngle_Front).w,d3
		exg	d0,d1

loc_131CC:
		btst	#0,d3
		beq.s	locret_131D4
		move.b	d2,d3

locret_131D4:
		rts

; ===============================================================================
		move.w	$C(a0),d2
		move.w	8(a0),d3

loc_131DE:
		addi.w	#$A,d2
		lea	(RAM_Sonic_CurrAngle_Front).w,a4
		movea.w	#$10,a3
		move.w	#0,d6
		bsr.w	FindFloor
		move.b	#0,d2

loc_131F6:
		move.b	(RAM_Sonic_CurrAngle_Front).w,d3
		btst	#0,d3
		beq.s	locret_13202
		move.b	d2,d3

locret_13202:
		rts

; =============== S U B R O U T I N E ==========================================


Sonic_HitFloor:
		move.w	8(a0),d3
		move.w	$C(a0),d2
		moveq	#0,d0
		move.b	$16(a0),d0
		ext.w	d0
		add.w	d0,d2
		move.l	#RAM_Level_ColP,(RAM_Level_ColPointer).w
		cmpi.b	#$C,$3E(a0)
		beq.s	loc_1322E
		move.l	#RAM_Level_ColS,(RAM_Level_ColPointer).w

loc_1322E:
		lea	(RAM_Sonic_CurrAngle_Front).w,a4
		move.b	#0,(a4)
		movea.w	#$10,a3
		move.w	#0,d6
		move.b	$3E(a0),d5
		bsr.w	FindFloor
		move.b	(RAM_Sonic_CurrAngle_Front).w,d3
		btst	#0,d3
		beq.s	locret_13254
		move.b	#0,d3

locret_13254:
		rts


; =============== S U B R O U T I N E ==========================================


ObjHitFloor:
		move.w	8(a0),d3

ObjHitFloor2:
		move.w	$C(a0),d2
		moveq	#0,d0
		move.b	$16(a0),d0
		ext.w	d0
		add.w	d0,d2
		lea	(RAM_Sonic_CurrAngle_Front).w,a4
		move.b	#0,(a4)
		movea.w	#$10,a3
		move.w	#0,d6
		moveq	#$C,d5
		bsr.w	FindFloor
		move.b	(RAM_Sonic_CurrAngle_Front).w,d3
		btst	#0,d3
		beq.s	locret_1328C
		move.b	#0,d3

locret_1328C:
		rts

; ===============================================================================

loc_1328E:
		move.w	$C(a0),d2
		move.w	8(a0),d3
		moveq	#0,d0
		move.b	$17(a0),d0
		ext.w	d0
		sub.w	d0,d2
		move.b	$16(a0),d0
		ext.w	d0
		add.w	d0,d3
		lea	(RAM_Sonic_CurrAngle_Front).w,a4
		movea.w	#$10,a3
		move.w	#0,d6
		bsr.w	FindWall
		move.w	d1,-(sp)
		move.w	$C(a0),d2
		move.w	8(a0),d3
		moveq	#0,d0
		move.b	$17(a0),d0
		ext.w	d0
		add.w	d0,d2
		move.b	$16(a0),d0
		ext.w	d0
		add.w	d0,d3
		lea	(RAM_Sonic_CurrAngle_Below).w,a4
		movea.w	#$10,a3
		move.w	#0,d6
		bsr.w	FindWall
		move.w	(sp)+,d0
		move.b	#$C0,d2
		bra.w	loc_131BE


; =============== S U B R O U T I N E ==========================================


sub_132EE:
		move.w	$C(a0),d2
		move.w	8(a0),d3

loc_132F6:
		addi.w	#$A,d3
		lea	(RAM_Sonic_CurrAngle_Front).w,a4
		movea.w	#$10,a3
		move.w	#0,d6
		bsr.w	FindWall
		move.b	#$C0,d2
		bra.w	loc_131F6


; =============== S U B R O U T I N E ==========================================


ObjHitWallRight:
		add.w	8(a0),d3
		move.w	$C(a0),d2
		lea	(RAM_Sonic_CurrAngle_Front).w,a4
		move.b	#0,(a4)
		movea.w	#$10,a3
		move.w	#0,d6
		moveq	#$D,d5
		bsr.w	FindWall
		move.b	(RAM_Sonic_CurrAngle_Front).w,d3
		btst	#0,d3
		beq.s	locret_1333E
		move.b	#$C0,d3

locret_1333E:
		rts


; =============== S U B R O U T I N E ==========================================


Sonic_DontRunOnWalls:
		move.w	$C(a0),d2
		move.w	8(a0),d3
		moveq	#0,d0
		move.b	$16(a0),d0
		ext.w	d0
		sub.w	d0,d2
		eori.w	#$F,d2
		move.b	$17(a0),d0
		ext.w	d0
		add.w	d0,d3
		lea	(RAM_Sonic_CurrAngle_Front).w,a4
		movea.w	#$FFF0,a3
		move.w	#$800,d6
		bsr.w	FindFloor
		move.w	d1,-(sp)
		move.w	$C(a0),d2
		move.w	8(a0),d3
		moveq	#0,d0
		move.b	$16(a0),d0
		ext.w	d0
		sub.w	d0,d2
		eori.w	#$F,d2
		move.b	$17(a0),d0
		ext.w	d0
		sub.w	d0,d3
		lea	(RAM_Sonic_CurrAngle_Below).w,a4
		movea.w	#$FFF0,a3
		move.w	#$800,d6
		bsr.w	FindFloor
		move.w	(sp)+,d0
		move.b	#$80,d2
		bra.w	loc_131BE

; ===============================================================================
		move.w	$C(a0),d2
		move.w	8(a0),d3

loc_133B0:
		subi.w	#$A,d2
		eori.w	#$F,d2
		lea	(RAM_Sonic_CurrAngle_Front).w,a4
		movea.w	#$FFF0,a3
		move.w	#$800,d6
		bsr.w	FindFloor
		move.b	#$80,d2
		bra.w	loc_131F6

; ===============================================================================

ObjHitCeiling:
		move.w	$C(a0),d2
		move.w	8(a0),d3
		moveq	#0,d0
		move.b	$16(a0),d0
		ext.w	d0
		sub.w	d0,d2
		eori.w	#$F,d2
		lea	(RAM_Sonic_CurrAngle_Front).w,a4
		movea.w	#$FFF0,a3
		move.w	#$800,d6
		moveq	#$D,d5
		bsr.w	FindFloor
		move.b	(RAM_Sonic_CurrAngle_Front).w,d3
		btst	#0,d3
		beq.s	locret_13406
		move.b	#$80,d3

locret_13406:
		rts
; ===============================================================================

loc_13408:
		move.w	$C(a0),d2
		move.w	8(a0),d3
		moveq	#0,d0
		move.b	$17(a0),d0
		ext.w	d0
		sub.w	d0,d2
		move.b	$16(a0),d0
		ext.w	d0
		sub.w	d0,d3
		eori.w	#$F,d3
		lea	(RAM_Sonic_CurrAngle_Front).w,a4
		movea.w	#$FFF0,a3
		move.w	#$400,d6
		bsr.w	FindWall
		move.w	d1,-(sp)
		move.w	$C(a0),d2
		move.w	8(a0),d3
		moveq	#0,d0
		move.b	$17(a0),d0
		ext.w	d0
		add.w	d0,d2
		move.b	$16(a0),d0
		ext.w	d0
		sub.w	d0,d3
		eori.w	#$F,d3
		lea	(RAM_Sonic_CurrAngle_Below).w,a4
		movea.w	#$FFF0,a3
		move.w	#$400,d6
		bsr.w	FindWall
		move.w	(sp)+,d0
		move.b	#$40,d2
		bra.w	loc_131BE


; =============== S U B R O U T I N E ==========================================


Sonic_HitWall:
		move.w	$C(a0),d2
		move.w	8(a0),d3

loc_13478:
		subi.w	#$A,d3
		eori.w	#$F,d3
		lea	(RAM_Sonic_CurrAngle_Front).w,a4
		movea.w	#$FFF0,a3
		move.w	#$400,d6
		bsr.w	FindWall
		move.b	#$40,d2
		bra.w	loc_131F6

; ===============================================================================

ObjHitWallLeft:
		add.w	8(a0),d3
		move.w	$C(a0),d2
		lea	(RAM_Sonic_CurrAngle_Front).w,a4
		move.b	#0,(a4)
		movea.w	#$FFF0,a3
		move.w	#$400,d6
		moveq	#$D,d5
		bsr.w	FindWall
		move.b	(RAM_Sonic_CurrAngle_Front).w,d3
		btst	#0,d3
		beq.s	locret_134C4
		move.b	#$40,d3	; '@'

locret_134C4:				; CODE XREF: ROM:000134BEj
		rts
; ===============================================================================
		nop
;----------------------------------------------------
; Object 79 - lamppost
;----------------------------------------------------

Obj79:
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj79_Index(pc,d0.w),d1
		jsr	Obj79_Index(pc,d1.w)
		jmp	MarkObjGone
; ===============================================================================
Obj79_Index:	dc.w Obj79_Init-Obj79_Index
		dc.w Obj79_Main-Obj79_Index
		dc.w Obj79_AfterHit-Obj79_Index
; ===============================================================================

Obj79_Init:
		addq.b	#2,$24(a0)
		move.l	#Map_Obj79,4(a0)
		move.w	#$47C,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#4,1(a0)
		move.b	#8,$19(a0)
		move.b	#5,$18(a0)
		lea	(RAM_ObjRespawnTbl).w,a2
		moveq	#0,d0
		move.b	$23(a0),d0
		bclr	#7,2(a2,d0.w)
		btst	#0,2(a2,d0.w)
		bne.s	loc_13536
		move.b	(RAM_Level_LamppostCntr).w,d1
		andi.b	#$7F,d1
		move.b	$28(a0),d2
		andi.b	#$7F,d2
		cmp.b	d2,d1
		bcs.s	Obj79_Main

loc_13536:
		bset	#0,2(a2,d0.w)
		move.b	#4,$24(a0)
		rts
; ===============================================================================

Obj79_Main:
		tst.w	(RAM_Flag_Debug_Placement).w
		bne.w	locret_135CA
		tst.b	(RAM_Flag_ControlLock).w
		bmi.w	locret_135CA
		move.b	(RAM_Level_LamppostCntr).w,d1
		andi.b	#$7F,d1	; ''
		move.b	$28(a0),d2
		andi.b	#$7F,d2	; ''
		cmp.b	d2,d1
		bcs.s	Obj79_HitLamp
		lea	(RAM_ObjRespawnTbl).w,a2
		moveq	#0,d0
		move.b	$23(a0),d0
		bset	#0,2(a2,d0.w)
		move.b	#4,$24(a0)
		bra.w	locret_135CA
; ===============================================================================

Obj79_HitLamp:
		move.w	(RAM_ObjRam_Sonic+$8).w,d0
		sub.w	8(a0),d0
		addi.w	#8,d0
		cmpi.w	#$10,d0
		bcc.w	locret_135CA
		move.w	(RAM_ObjRam_Sonic+$C).w,d0
		sub.w	$C(a0),d0
		addi.w	#$40,d0	; '@'
		cmpi.w	#$68,d0	; 'h'
		bcc.s	locret_135CA
		move.w	#$A1,d0	; ''
		jsr	(PlaySound_Special).l
		addq.b	#2,$24(a0)
		bsr.w	Lamppost_StoreInfo
		lea	(RAM_ObjRespawnTbl).w,a2
		moveq	#0,d0
		move.b	$23(a0),d0
		bset	#0,2(a2,d0.w)

locret_135CA:
		rts
; ===============================================================================

Obj79_AfterHit:
		move.b	(RAM_VIntFrameCnt+3).w,d0
		andi.b	#2,d0
		lsr.b	#1,d0
		addq.b	#1,d0
		move.b	d0,$1A(a0)
		rts

; =============== S U B R O U T I N E ==========================================


Lamppost_StoreInfo:
		move.b	$28(a0),(RAM_Level_LamppostCntr).w
		move.b	(RAM_Level_LamppostCntr).w,(RAM_Lamppost_LamppostCntr).w
		move.w	8(a0),(RAM_Lamppost_Sonic_XPos).w
		move.w	$C(a0),(RAM_Lamppost_Sonic_YPos).w
		move.w	(RAM_Sonic_CurrentRings).w,(RAM_Lamppost_Sonic_CurrRings).w
		move.b	(RAM_Sonic_1upScore).w,(RAM_Lamppost_Sonic_1upScore).w
		move.l	(RAM_Hud_Time).w,(RAM_Lamppost_Hud_Time).w
		move.b	(RAM_DynResizeCntr).w,(RAM_Lamppost_DynResizeCntr).w
		move.w	(RAM_LevelSys_YPos_SetEnd).w,(RAM_Lamppost_Level_YPos_SetEnd).w
		move.w	(RAM_LevelSys_Buff).w,(RAM_Lamppost_LevelSysBuf).w
		move.w	(RAM_LevelSys_Buff+$4).w,(RAM_Lamppost_LevelSysBuf+$2).w
		move.w	(RAM_LevelSys_Buff+$8).w,(RAM_Lamppost_LevelSysBuf+$4).w
		move.w	(RAM_LevelSys_Buff+$C).w,(RAM_Lamppost_LevelSysBuf+$6).w
		move.w	(RAM_LevelSys_Buff+$10).w,(RAM_Lamppost_LevelSysBuf+$8).w
		move.w	(RAM_LevelSys_Buff+$14).w,(RAM_Lamppost_LevelSysBuf+$A).w
		move.w	(RAM_LevelSys_Buff+$18).w,(RAM_Lamppost_LevelSysBuf+$C).w
		move.w	(RAM_LevelSys_Buff+$1C).w,(RAM_Lamppost_LevelSysBuf+$E).w
		move.w	(RAM_Level_Water_MainPos).w,(RAM_Lamppost_Water_MainPos).w
		move.b	(RAM_Level_WaterRoutineCntr).w,(RAM_Lamppost_Water_RoutineCntr).w
		move.b	(RAM_FillWaterPalScr).w,(RAM_Lamppost_FillWtrPalScr).w
		rts


; =============== S U B R O U T I N E ==========================================


Lamppost_LoadInfo:
		move.b	(RAM_Lamppost_LamppostCntr).w,(RAM_Level_LamppostCntr).w
		move.w	(RAM_Lamppost_Sonic_XPos).w,(RAM_ObjRam_Sonic+$8).w
		move.w	(RAM_Lamppost_Sonic_YPos).w,(RAM_ObjRam_Sonic+$C).w
		move.w	(RAM_Lamppost_Sonic_CurrRings).w,(RAM_Sonic_CurrentRings).w
		move.b	(RAM_Lamppost_Sonic_1upScore).w,(RAM_Sonic_1upScore).w
		clr.w	(RAM_Sonic_CurrentRings).w
		clr.b	(RAM_Sonic_1upScore).w
		move.l	(RAM_Lamppost_Hud_Time).w,(RAM_Hud_Time).w
		move.b	#59,(RAM_Hud_Time+$3).w
		subq.b	#1,(RAM_Hud_Time+$2).w
		move.b	(RAM_Lamppost_DynResizeCntr).w,(RAM_DynResizeCntr).w
		move.b	(RAM_Lamppost_Water_RoutineCntr).w,(RAM_Level_WaterRoutineCntr).w
		move.w	(RAM_Lamppost_Level_YPos_SetEnd).w,(RAM_LevelSys_YPos_SetEnd).w
		move.w	(RAM_Lamppost_Level_YPos_SetEnd).w,(RAM_Level_Camera_Boundary_1).w
		move.w	(RAM_Lamppost_LevelSysBuf).w,(RAM_LevelSys_Buff).w
		move.w	(RAM_Lamppost_LevelSysBuf+$2).w,(RAM_LevelSys_Buff+$4).w
		move.w	(RAM_Lamppost_LevelSysBuf+$4).w,(RAM_LevelSys_Buff+$8).w
		move.w	(RAM_Lamppost_LevelSysBuf+$6).w,(RAM_LevelSys_Buff+$C).w
		move.w	(RAM_Lamppost_LevelSysBuf+$8).w,(RAM_LevelSys_Buff+$10).w
		move.w	(RAM_Lamppost_LevelSysBuf+$A).w,(RAM_LevelSys_Buff+$14).w
		move.w	(RAM_Lamppost_LevelSysBuf+$C).w,(RAM_LevelSys_Buff+$18).w
		move.w	(RAM_Lamppost_LevelSysBuf+$E).w,(RAM_LevelSys_Buff+$1C).w
		cmpi.b	#1,(RAM_Level_CurrentZone).w
		bne.s	loc_136F0
		move.w	(RAM_Lamppost_Water_MainPos).w,(RAM_Level_Water_MainPos).w
		move.b	(RAM_Lamppost_Water_RoutineCntr).w,(RAM_Level_WaterRoutineCntr).w
		move.b	(RAM_Lamppost_FillWtrPalScr).w,(RAM_FillWaterPalScr).w

loc_136F0:
		tst.b	(RAM_Level_LamppostCntr).w
		bpl.s	locret_13702
		move.w	(RAM_Lamppost_Sonic_XPos).w,d0
		subi.w	#$A0,d0
		move.w	d0,(RAM_LevelSys_XPos_SetStart).w

locret_13702:
		rts

; ===============================================================================
Map_Obj79:	dc.w word_1370A-Map_Obj79
		dc.w word_1372C-Map_Obj79
		dc.w word_1374E-Map_Obj79
word_1370A:	dc.w 4
		dc.w $E801,$2000,$2000,$FFF8; 0
		dc.w $E801,$2800,$2800,	   0; 4
		dc.w $F803,    6,    3,$FFF8; 8
		dc.w $F803, $806, $803,	   0; 12
word_1372C:	dc.w 4
		dc.w $E801,    2,    1,$FFF8; 0
		dc.w $E801, $802, $801,	   0; 4
		dc.w $F803,    6,    3,$FFF8; 8
		dc.w $F803, $806, $803,	   0; 12
word_1374E:	dc.w 4
		dc.w $E801,$2004,$2002,$FFF8; 0
		dc.w $E801,$2804,$2802,	   0; 4
		dc.w $F803,    6,    3,$FFF8; 8
		dc.w $F803, $806, $803,	   0; 12
; ===============================================================================
;----------------------------------------------------
; Object 7D - hidden points at the end of a level
;----------------------------------------------------

Obj7D:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj7D_Index(pc,d0.w),d1
		jmp	Obj7D_Index(pc,d1.w)
; ===============================================================================
Obj7D_Index:	dc.w Obj7D_Main-Obj7D_Index ; DATA XREF: ROM:Obj7D_Indexo
					; ROM:00013780o
		dc.w Obj7D_DelayDelete-Obj7D_Index
; ===============================================================================

Obj7D_Main:				; DATA XREF: ROM:Obj7D_Indexo
		moveq	#$10,d2
		move.w	d2,d3
		add.w	d3,d3
		lea	(RAM_ObjRAM_Sonic).w,a1
		move.w	8(a1),d0
		sub.w	8(a0),d0
		add.w	d2,d0
		cmp.w	d3,d0
		bcc.s	loc_13804
		move.w	$C(a1),d1
		sub.w	$C(a0),d1
		add.w	d2,d1
		cmp.w	d3,d1
		bcc.s	loc_13804
		tst.w	(RAM_Flag_Debug_Placement).w
		bne.s	loc_13804
		tst.b	(RAM_Flag_Level_StopBonus).w
		bne.s	loc_13804
		addq.b	#2,$24(a0)
		move.l	#Map_Obj7D,4(a0)
		move.w	#$84B6,2(a0)
		bsr.w	ModifySpriteAttr_2P
		ori.b	#4,1(a0)
		move.b	#0,$18(a0)
		move.b	#$10,$19(a0)
		move.b	$28(a0),$1A(a0)
		move.w	#$77,$30(a0) ; 'w'
		move.w	#$C9,d0	; ''
		jsr	(PlaySound_Special).l
		moveq	#0,d0
		move.b	$28(a0),d0
		add.w	d0,d0
		move.w	Obj7D_Points(pc,d0.w),d0
		jsr	AddPoints

loc_13804:				; CODE XREF: ROM:00013798j
					; ROM:000137A6j ...
		move.w	8(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.s	loc_13818
		rts
; ===============================================================================

loc_13818:				; CODE XREF: ROM:00013814j
		jmp	DeleteObject
; ===============================================================================
Obj7D_Points:	dc.w	 0, 1000,  100,	   1; 0
; ===============================================================================

Obj7D_DelayDelete:			; DATA XREF: ROM:00013780o
		subq.w	#1,$30(a0)
		bmi.s	loc_13844
		move.w	8(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.s	loc_13844
		jmp	DisplaySprite
; ===============================================================================

loc_13844:				; CODE XREF: ROM:0001382Aj
					; ROM:0001383Cj
		jmp	DeleteObject
; ===============================================================================
Map_Obj7D:	dc.w word_13852-Map_Obj7D ; DATA XREF: ROM:000137B8o
					; ROM:Map_Obj7Do ...
		dc.w word_13854-Map_Obj7D
		dc.w word_1385E-Map_Obj7D
		dc.w word_13868-Map_Obj7D
word_13852:	dc.w 0			; DATA XREF: ROM:Map_Obj7Do
word_13854:	dc.w 1			; DATA XREF: ROM:0001384Co
		dc.w $F40E,    0,    0,$FFF0; 0
word_1385E:	dc.w 1			; DATA XREF: ROM:0001384Eo
		dc.w $F40E,   $C,    6,$FFF0; 0
word_13868:	dc.w 1			; DATA XREF: ROM:00013850o
		dc.w $F40E,  $18,   $C,$FFF0; 0
; ===============================================================================
		nop

S1Obj47:
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	S1Obj47_Index(pc,d0.w),d1
		jmp	S1Obj47_Index(pc,d1.w)
; ===============================================================================
S1Obj47_Index:	dc.w S1Obj47_Init-S1Obj47_Index	; DATA XREF: ROM:S1Obj47_Indexo
					; ROM:00013884o
		dc.w S1Obj47_Main-S1Obj47_Index
; ===============================================================================

S1Obj47_Init:				; DATA XREF: ROM:S1Obj47_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_S1Obj47,4(a0)
		move.w	#$380,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#4,1(a0)
		move.b	#$10,$19(a0)
		move.b	#1,$18(a0)
		move.b	#$D7,$20(a0)

S1Obj47_Main:				; DATA XREF: ROM:00013884o
		move.b	$21(a0),d0
		beq.w	loc_13976
		lea	(RAM_ObjRAM_Sonic).w,a1
		bclr	#0,$21(a0)
		beq.s	loc_138CA
		bsr.s	S1Obj47_Bump

loc_138CA:				; CODE XREF: ROM:000138C6j
		lea	(RAM_ObjRAM_Tails).w,a1
		bclr	#1,$21(a0)
		beq.s	loc_138D8
		bsr.s	S1Obj47_Bump

loc_138D8:				; CODE XREF: ROM:000138D4j
		clr.b	$21(a0)
		bra.w	loc_13976

; =============== S U B R O U T I N E ==========================================


S1Obj47_Bump:				; CODE XREF: ROM:000138C8p
					; ROM:000138D6p
		move.w	8(a0),d1
		move.w	$C(a0),d2
		sub.w	8(a1),d1
		sub.w	$C(a1),d2
		jsr	(CalcAngle).l
		jsr	(CalcSine).l
		muls.w	#$F900,d1
		asr.l	#8,d1
		move.w	d1,$10(a1)
		muls.w	#$F900,d0
		asr.l	#8,d0
		move.w	d0,$12(a1)
		bset	#1,$22(a1)
		bclr	#4,$22(a1)
		bclr	#5,$22(a1)
		clr.b	$3C(a1)
		move.b	#1,$1C(a0)
		move.w	#$B4,d0	; ''
		jsr	(PlaySound_Special).l
		lea	(RAM_ObjRespawnTbl).w,a2
		moveq	#0,d0
		move.b	$23(a0),d0
		beq.s	loc_1394E
		cmpi.b	#$8A,2(a2,d0.w)
		bcc.s	locret_13974
		addq.b	#1,2(a2,d0.w)

loc_1394E:				; CODE XREF: S1Obj47_Bump+60j
		moveq	#1,d0
		jsr	AddPoints
		bsr.w	SingleObjectLoad
		bne.s	locret_13974
		move.b	#$29,0(a1) ; ')'
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		move.b	#4,$1A(a1)

locret_13974:				; CODE XREF: S1Obj47_Bump+68j
					; S1Obj47_Bump+7Aj
		rts
; End of function S1Obj47_Bump

; ===============================================================================

loc_13976:				; CODE XREF: ROM:000138B8j
					; ROM:000138DCj
		lea	(Ani_S1Obj47).l,a1
		bsr.w	AnimateSprite
		bra.w	MarkObjGone
; ===============================================================================
Ani_S1Obj47:	dc.w byte_13988-Ani_S1Obj47 ; DATA XREF: ROM:loc_13976o
					; ROM:Ani_S1Obj47o ...
		dc.w byte_1398B-Ani_S1Obj47
byte_13988:	dc.b  $F,  0,$FF	; 0 ; DATA XREF: ROM:Ani_S1Obj47o
byte_1398B:	dc.b   3,  1,  2,  1,  2,$FD,  0; 0 ; DATA XREF: ROM:00013986o
Map_S1Obj47:	dc.w word_13998-Map_S1Obj47 ; DATA XREF: ROM:0001388Ao
					; ROM:Map_S1Obj47o ...
		dc.w word_139AA-Map_S1Obj47
		dc.w word_139BC-Map_S1Obj47
word_13998:	dc.w 2			; DATA XREF: ROM:Map_S1Obj47o
		dc.w $F007,    0,    0,$FFF0; 0
		dc.w $F007, $800, $800,	   0; 4
word_139AA:	dc.w 2			; DATA XREF: ROM:00013994o
		dc.w $F406,    8,    4,$FFF4; 0
		dc.w $F402, $808, $804,	   4; 4
word_139BC:	dc.w 2			; DATA XREF: ROM:00013996o
		dc.w $F007,   $E,    7,$FFF0; 0
		dc.w $F007, $80E, $807,	   0; 4
; ===============================================================================
		nop

S1Obj64:
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	S1Obj64_Index(pc,d0.w),d1
		jmp	S1Obj64_Index(pc,d1.w)
; ===============================================================================
S1Obj64_Index:	dc.w S1Obj64_Init-S1Obj64_Index	; DATA XREF: ROM:S1Obj64_Indexo
					; ROM:000139E0o ...
		dc.w S1Obj64_Animate-S1Obj64_Index
		dc.w S1Obj64_ChkWater-S1Obj64_Index
		dc.w S1Obj64_Display-S1Obj64_Index
		dc.w S1Obj64_Delete-S1Obj64_Index
		dc.w S1Obj64_BblMaker-S1Obj64_Index
; ===============================================================================

S1Obj64_Init:				; DATA XREF: ROM:S1Obj64_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj0A_Bubbles,4(a0)
		move.w	#$8348,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#$84,1(a0)
		move.b	#$10,$19(a0)
		move.b	#1,$18(a0)
		move.b	$28(a0),d0
		bpl.s	loc_13A32
		addq.b	#8,$24(a0)
		andi.w	#$7F,d0	; ''
		move.b	d0,$32(a0)
		move.b	d0,$33(a0)
		move.b	#6,$1C(a0)
		bra.w	S1Obj64_BblMaker
; ===============================================================================

loc_13A32:				; CODE XREF: ROM:00013A16j
		move.b	d0,$1C(a0)
		move.w	8(a0),$30(a0)
		move.w	#$FF78,$12(a0)
		jsr	(PseudoRandomNumber).l
		move.b	d0,$26(a0)

S1Obj64_Animate:			; DATA XREF: ROM:000139E0o
		lea	(Ani_S1Obj64).l,a1
		jsr	AnimateSprite
		cmpi.b	#6,$1A(a0)
		bne.s	S1Obj64_ChkWater
		move.b	#1,$2E(a0)

S1Obj64_ChkWater:			; CODE XREF: ROM:00013A5Ej
					; DATA XREF: ROM:000139E2o
		move.w	(RAM_Level_Water_Action).w,d0
		cmp.w	$C(a0),d0
		bcs.s	loc_13A7E

loc_13A70:				; CODE XREF: ROM:00013AECj
					; ROM:00013B06j
		move.b	#6,$24(a0)
		addq.b	#3,$1C(a0)
		bra.w	S1Obj64_Display
; ===============================================================================

loc_13A7E:				; CODE XREF: ROM:00013A6Ej
		move.b	$26(a0),d0
		addq.b	#1,$26(a0)
		andi.w	#$7F,d0	; ''
		lea	(Obj0A_WobbleData).l,a1
		move.b	(a1,d0.w),d0
		ext.w	d0
		add.w	$30(a0),d0
		move.w	d0,8(a0)
		tst.b	$2E(a0)
		beq.s	loc_13B0A
		bsr.w	S1Obj64_ChkSonic
		beq.s	loc_13B0A
		bsr.w	ResumeMusic
		move.w	#$AD,d0	; ''
		jsr	(PlaySound_Special).l
		lea	(RAM_ObjRAM_Sonic).w,a1
		clr.w	$10(a1)
		clr.w	$12(a1)
		clr.w	$14(a1)
		move.b	#$15,$1C(a1)
		move.w	#$23,$2E(a1) ; '#'
		move.b	#0,$3C(a1)
		bclr	#5,$22(a1)
		bclr	#4,$22(a1)
		btst	#2,$22(a1)
		beq.w	loc_13A70
		bclr	#2,$22(a1)
		move.b	#$13,$16(a1)
		move.b	#9,$17(a1)
		subq.w	#5,$C(a1)
		bra.w	loc_13A70
; ===============================================================================

loc_13B0A:				; CODE XREF: ROM:00013AA2j
					; ROM:00013AA8j
		bsr.w	SpeedToPos
		tst.b	1(a0)
		bpl.s	loc_13B1A
		jmp	DisplaySprite
; ===============================================================================

loc_13B1A:				; CODE XREF: ROM:00013B12j
		jmp	DeleteObject
; ===============================================================================

S1Obj64_Display:			; CODE XREF: ROM:00013A7Aj
					; DATA XREF: ROM:000139E4o
		lea	(Ani_S1Obj64).l,a1
		jsr	AnimateSprite
		tst.b	1(a0)
		bpl.s	loc_13B38
		jmp	DisplaySprite
; ===============================================================================

loc_13B38:				; CODE XREF: ROM:00013B30j
		jmp	DeleteObject
; ===============================================================================

S1Obj64_Delete:				; DATA XREF: ROM:000139E6o
		bra.w	DeleteObject
; ===============================================================================

S1Obj64_BblMaker:			; CODE XREF: ROM:00013A2Ej
					; DATA XREF: ROM:000139E8o
		tst.w	$36(a0)
		bne.s	loc_13BA4
		move.w	(RAM_Level_Water_Action).w,d0
		cmp.w	$C(a0),d0
		bcc.w	loc_13C50
		tst.b	1(a0)
		bpl.w	loc_13C50
		subq.w	#1,$38(a0)
		bpl.w	loc_13C44
		move.w	#1,$36(a0)

loc_13B6A:				; CODE XREF: ROM:00013B7Aj
		jsr	(PseudoRandomNumber).l
		move.w	d0,d1
		andi.w	#7,d0
		cmpi.w	#6,d0
		bcc.s	loc_13B6A
		move.b	d0,$34(a0)
		andi.w	#$C,d1
		lea	(S1Obj64_BblTypes).l,a1
		adda.w	d1,a1
		move.l	a1,$3C(a0)
		subq.b	#1,$32(a0)
		bpl.s	loc_13BA2
		move.b	$33(a0),$32(a0)
		bset	#7,$36(a0)

loc_13BA2:				; CODE XREF: ROM:00013B94j
		bra.s	loc_13BAC
; ===============================================================================

loc_13BA4:				; CODE XREF: ROM:00013B46j
		subq.w	#1,$38(a0)
		bpl.w	loc_13C44

loc_13BAC:				; CODE XREF: ROM:loc_13BA2j
		jsr	(PseudoRandomNumber).l
		andi.w	#$1F,d0
		move.w	d0,$38(a0)
		bsr.w	SingleObjectLoad
		bne.s	loc_13C28
		move.b	#$64,0(a1) ; 'd'
		move.w	8(a0),8(a1)
		jsr	(PseudoRandomNumber).l
		andi.w	#$F,d0
		subq.w	#8,d0
		add.w	d0,8(a1)
		move.w	$C(a0),$C(a1)
		moveq	#0,d0
		move.b	$34(a0),d0
		movea.l	$3C(a0),a2
		move.b	(a2,d0.w),$28(a1)
		btst	#7,$36(a0)
		beq.s	loc_13C28
		jsr	(PseudoRandomNumber).l
		andi.w	#3,d0
		bne.s	loc_13C14
		bset	#6,$36(a0)
		bne.s	loc_13C28
		move.b	#2,$28(a1)

loc_13C14:				; CODE XREF: ROM:00013C04j
		tst.b	$34(a0)
		bne.s	loc_13C28
		bset	#6,$36(a0)
		bne.s	loc_13C28
		move.b	#2,$28(a1)

loc_13C28:				; CODE XREF: ROM:00013BBEj
					; ROM:00013BF8j ...
		subq.b	#1,$34(a0)
		bpl.s	loc_13C44
		jsr	(PseudoRandomNumber).l
		andi.w	#$7F,d0	; ''
		addi.w	#$80,d0	; ''
		add.w	d0,$38(a0)
		clr.w	$36(a0)

loc_13C44:				; CODE XREF: ROM:00013B60j
					; ROM:00013BA8j ...
		lea	(Ani_S1Obj64).l,a1
		jsr	AnimateSprite

loc_13C50:				; CODE XREF: ROM:00013B50j
					; ROM:00013B58j
		move.w	8(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.w	DeleteObject
		move.w	(RAM_Level_Water_Action).w,d0
		cmp.w	$C(a0),d0
		bcs.w	DisplaySprite
		rts
; ===============================================================================
S1Obj64_BblTypes:dc.b	0,  1,	0,  0,	0,  0,	1,  0,	0; 0 ; DATA XREF: ROM:00013B84o
		dc.b   0,  0,  1,  0,  1,  0,  0,  1,  0; 9

; =============== S U B R O U T I N E ==========================================


S1Obj64_ChkSonic:			; CODE XREF: ROM:00013AA4p
		tst.b	(RAM_Flag_ControlLock).w
		bmi.s	loc_13CBE
		lea	(RAM_ObjRAM_Sonic).w,a1
		move.w	8(a1),d0
		move.w	8(a0),d1
		subi.w	#$10,d1
		cmp.w	d0,d1
		bcc.s	loc_13CBE
		addi.w	#$20,d1	; ' '
		cmp.w	d0,d1
		bcs.s	loc_13CBE
		move.w	$C(a1),d0
		move.w	$C(a0),d1
		cmp.w	d0,d1
		bcc.s	loc_13CBE
		addi.w	#$10,d1
		cmp.w	d0,d1
		bcs.s	loc_13CBE
		moveq	#1,d0
		rts
; ===============================================================================

loc_13CBE:				; CODE XREF: S1Obj64_ChkSonic+4j
					; S1Obj64_ChkSonic+18j	...
		moveq	#0,d0
		rts
; End of function S1Obj64_ChkSonic

; ===============================================================================
Ani_S1Obj64:	dc.w byte_13CD0-Ani_S1Obj64 ; DATA XREF: ROM:S1Obj64_Animateo
					; ROM:S1Obj64_Displayo	...
		dc.w byte_13CD5-Ani_S1Obj64
		dc.w byte_13CDB-Ani_S1Obj64
		dc.w byte_13CE2-Ani_S1Obj64
		dc.w byte_13CE2-Ani_S1Obj64
		dc.w byte_13CE4-Ani_S1Obj64
		dc.w byte_13CE9-Ani_S1Obj64
byte_13CD0:	dc.b  $E,  0,  1,  2,$FC; 0 ; DATA XREF: ROM:Ani_S1Obj64o
byte_13CD5:	dc.b  $E,  1,  2,  3,  4,$FC; 0	; DATA XREF: ROM:00013CC4o
byte_13CDB:	dc.b  $E,  2,  3,  4,  5,  6,$FC; 0 ; DATA XREF: ROM:00013CC6o
byte_13CE2:	dc.b   4,$FC		; 0 ; DATA XREF: ROM:00013CC8o
					; ROM:00013CCAo
byte_13CE4:	dc.b   4,  6,  7,  8,$FC; 0 ; DATA XREF: ROM:00013CCCo
byte_13CE9:	dc.b  $F,$13,$14,$15,$FF; 0 ; DATA XREF: ROM:00013CCEo
Map_Obj0A_Bubbles:dc.w word_13D1C-Map_Obj0A_Bubbles ; DATA XREF: ROM:00011E88o
					; ROM:000139EEo ...
		dc.w word_13D26-Map_Obj0A_Bubbles
		dc.w word_13D30-Map_Obj0A_Bubbles
		dc.w word_13D3A-Map_Obj0A_Bubbles
		dc.w word_13D44-Map_Obj0A_Bubbles
		dc.w word_13D4E-Map_Obj0A_Bubbles
		dc.w word_13D58-Map_Obj0A_Bubbles
		dc.w word_13D62-Map_Obj0A_Bubbles
		dc.w word_13D84-Map_Obj0A_Bubbles
		dc.w word_13DA6-Map_Obj0A_Bubbles
		dc.w word_13DB0-Map_Obj0A_Bubbles
		dc.w word_13DBA-Map_Obj0A_Bubbles
		dc.w word_13DC4-Map_Obj0A_Bubbles
		dc.w word_13DCE-Map_Obj0A_Bubbles
		dc.w word_13DD8-Map_Obj0A_Bubbles
		dc.w word_13DE2-Map_Obj0A_Bubbles
		dc.w word_13DEC-Map_Obj0A_Bubbles
		dc.w word_13DF6-Map_Obj0A_Bubbles
		dc.w word_13E00-Map_Obj0A_Bubbles
		dc.w word_13E0A-Map_Obj0A_Bubbles
		dc.w word_13E14-Map_Obj0A_Bubbles
		dc.w word_13E1E-Map_Obj0A_Bubbles
		dc.w word_13E28-Map_Obj0A_Bubbles
word_13D1C:	dc.w 1			; DATA XREF: ROM:Map_Obj0A_Bubbleso
		dc.w $FC00,    0,    0,$FFFC; 0
word_13D26:	dc.w 1			; DATA XREF: ROM:00013CF0o
		dc.w $FC00,    1,    0,$FFFC; 0
word_13D30:	dc.w 1			; DATA XREF: ROM:00013CF2o
		dc.w $FC00,    2,    1,$FFFC; 0
word_13D3A:	dc.w 1			; DATA XREF: ROM:00013CF4o
		dc.w $F805,    3,    1,$FFF8; 0
word_13D44:	dc.w 1			; DATA XREF: ROM:00013CF6o
		dc.w $F805,    7,    3,$FFF8; 0
word_13D4E:	dc.w 1			; DATA XREF: ROM:00013CF8o
		dc.w $F40A,   $B,    5,$FFF4; 0
word_13D58:	dc.w 1			; DATA XREF: ROM:00013CFAo
		dc.w $F00F,  $14,   $A,$FFF0; 0
word_13D62:	dc.w 4			; DATA XREF: ROM:00013CFCo
		dc.w $F005,  $24,  $12,$FFF0; 0
		dc.w $F005, $824, $812,	   0; 4
		dc.w	 5,$1024,$1012,$FFF0; 8
		dc.w	 5,$1824,$1812,	   0; 12
word_13D84:	dc.w 4			; DATA XREF: ROM:00013CFEo
		dc.w $F005,  $28,  $14,$FFF0; 0
		dc.w $F005, $828, $814,	   0; 4
		dc.w	 5,$1028,$1014,$FFF0; 8
		dc.w	 5,$1828,$1814,	   0; 12
word_13DA6:	dc.w 1			; DATA XREF: ROM:00013D00o
		dc.w $F406,  $2C,  $16,$FFF8; 0
word_13DB0:	dc.w 1			; DATA XREF: ROM:00013D02o
		dc.w $F406,  $32,  $19,$FFF8; 0
word_13DBA:	dc.w 1			; DATA XREF: ROM:00013D04o
		dc.w $F406,  $38,  $1C,$FFF8; 0
word_13DC4:	dc.w 1			; DATA XREF: ROM:00013D06o
		dc.w $F406,  $3E,  $1F,$FFF8; 0
word_13DCE:	dc.w 1			; DATA XREF: ROM:00013D08o
		dc.w $F406,$2044,$2022,$FFF8; 0
word_13DD8:	dc.w 1			; DATA XREF: ROM:00013D0Ao
		dc.w $F406,$204A,$2025,$FFF8; 0
word_13DE2:	dc.w 1			; DATA XREF: ROM:00013D0Co
		dc.w $F406,$2050,$2028,$FFF8; 0
word_13DEC:	dc.w 1			; DATA XREF: ROM:00013D0Eo
		dc.w $F406,$2056,$202B,$FFF8; 0
word_13DF6:	dc.w 1			; DATA XREF: ROM:00013D10o
		dc.w $F406,$205C,$202E,$FFF8; 0
word_13E00:	dc.w 1			; DATA XREF: ROM:00013D12o
		dc.w $F406,$2062,$2031,$FFF8; 0
word_13E0A:	dc.w 1			; DATA XREF: ROM:00013D14o
		dc.w $F805,  $68,  $34,$FFF8; 0
word_13E14:	dc.w 1			; DATA XREF: ROM:00013D16o
		dc.w $F805,  $6C,  $36,$FFF8; 0
word_13E1E:	dc.w 1			; DATA XREF: ROM:00013D18o
		dc.w $F805,  $70,  $38,$FFF8; 0
word_13E28:	dc.w 0			; DATA XREF: ROM:00013D1Ao
; ===============================================================================
		nop
;----------------------------------------------------
; Object 03 - collision	index switcher (in loops)
;----------------------------------------------------

Obj03:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj03_Index(pc,d0.w),d1
		jsr	Obj03_Index(pc,d1.w)
		tst.w	(RAM_Flag_DebugMode).w
		beq.w	loc_CE92
		jmp	MarkObjGone
; ===============================================================================
Obj03_Index:	dc.w Obj03_Init-Obj03_Index ; DATA XREF: ROM:Obj03_Indexo
					; ROM:00013E4Ao ...
		dc.w loc_13EB4-Obj03_Index
		dc.w loc_13FB6-Obj03_Index
; ===============================================================================

Obj03_Init:				; DATA XREF: ROM:Obj03_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj03,4(a0)
		move.w	#$26BC,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#4,1(a0)
		move.b	#$10,$19(a0)
		move.b	#5,$18(a0)
		move.b	$28(a0),d0
		btst	#2,d0
		beq.s	loc_13EA4
		addq.b	#2,$24(a0)
		andi.w	#7,d0
		move.b	d0,$1A(a0)
		andi.w	#3,d0
		add.w	d0,d0
		move.w	Obj03_Data(pc,d0.w),$32(a0)
		bra.w	loc_13FB6
; ===============================================================================
Obj03_Data:	dc.w   $20,  $40,  $80,	$100; 0
; ===============================================================================

loc_13EA4:				; CODE XREF: ROM:00013E7Ej
		andi.w	#3,d0
		move.b	d0,$1A(a0)
		add.w	d0,d0
		move.w	Obj03_Data(pc,d0.w),$32(a0)

loc_13EB4:				; DATA XREF: ROM:00013E4Ao
		tst.w	(RAM_Flag_Debug_Placement).w
		bne.w	locret_13FB4
		move.w	$30(a0),d5
		move.w	8(a0),d0
		move.w	d0,d1
		subq.w	#8,d0
		addq.w	#8,d1
		move.w	$C(a0),d2
		move.w	d2,d3
		move.w	$32(a0),d4
		sub.w	d4,d2
		add.w	d4,d3
		lea	(dword_140B8).l,a2
		moveq	#7,d6

loc_13EE0:				; CODE XREF: ROM:00013FAAj
		move.l	(a2)+,d4
		beq.w	loc_13FA8
		movea.l	d4,a1
		move.w	8(a1),d4
		cmp.w	d0,d4
		bcs.w	loc_13F10
		cmp.w	d1,d4
		bcc.w	loc_13F10
		move.w	$C(a1),d4
		cmp.w	d2,d4
		bcs.w	loc_13F10
		cmp.w	d3,d4
		bcc.w	loc_13F10
		ori.w	#$8000,d5
		bra.w	loc_13FA8
; ===============================================================================

loc_13F10:				; CODE XREF: ROM:00013EEEj
					; ROM:00013EF4j ...
		tst.w	d5
		bpl.w	loc_13FA8
		swap	d0
		move.b	$28(a0),d0
		bpl.s	loc_13F26
		btst	#1,$22(a1)
		bne.s	loc_13FA2

loc_13F26:				; CODE XREF: ROM:00013F1Cj
		move.w	8(a1),d4
		cmp.w	8(a0),d4
		bcs.s	loc_13F62
		move.b	#$C,$3E(a1)
		move.b	#$D,$3F(a1)
		btst	#3,d0
		beq.s	loc_13F4E
		move.b	#$E,$3E(a1)
		move.b	#$F,$3F(a1)

loc_13F4E:				; CODE XREF: ROM:00013F40j
		bclr	#7,2(a1)
		btst	#5,d0
		beq.s	loc_13F92
		bset	#7,2(a1)
		bra.s	loc_13F92
; ===============================================================================

loc_13F62:				; CODE XREF: ROM:00013F2Ej
		move.b	#$C,$3E(a1)
		move.b	#$D,$3F(a1)
		btst	#4,d0
		beq.s	loc_13F80
		move.b	#$E,$3E(a1)
		move.b	#$F,$3F(a1)

loc_13F80:				; CODE XREF: ROM:00013F72j
		bclr	#7,2(a1)
		btst	#6,d0
		beq.s	loc_13F92
		bset	#7,2(a1)

loc_13F92:				; CODE XREF: ROM:00013F58j
					; ROM:00013F60j ...
		tst.w	(RAM_Flag_DebugMode).w
		beq.s	loc_13FA2
		move.w	#$A1,d0	; ''
		jsr	(PlaySound_Special).l

loc_13FA2:				; CODE XREF: ROM:00013F24j
					; ROM:00013F96j
		swap	d0
		andi.w	#$7FFF,d5

loc_13FA8:				; CODE XREF: ROM:00013EE2j
					; ROM:00013F0Cj ...
		add.l	d5,d5
		dbf	d6,loc_13EE0
		swap	d5
		move.b	d5,$30(a0)

locret_13FB4:				; CODE XREF: ROM:00013EB8j
		rts
; ===============================================================================

loc_13FB6:				; CODE XREF: ROM:00013E98j
					; DATA XREF: ROM:00013E4Co
		tst.w	(RAM_Flag_Debug_Placement).w
		bne.w	locret_140B6
		move.w	$30(a0),d5
		move.w	8(a0),d0
		move.w	d0,d1
		move.w	$32(a0),d4
		sub.w	d4,d0
		add.w	d4,d1
		move.w	$C(a0),d2
		move.w	d2,d3
		subq.w	#8,d2
		addq.w	#8,d3
		lea	(dword_140B8).l,a2
		moveq	#7,d6

loc_13FE2:				; CODE XREF: ROM:000140ACj
		move.l	(a2)+,d4
		beq.w	loc_140AA
		movea.l	d4,a1
		move.w	8(a1),d4
		cmp.w	d0,d4
		bcs.w	loc_14012
		cmp.w	d1,d4
		bcc.w	loc_14012
		move.w	$C(a1),d4
		cmp.w	d2,d4
		bcs.w	loc_14012
		cmp.w	d3,d4
		bcc.w	loc_14012
		ori.w	#$8000,d5
		bra.w	loc_140AA
; ===============================================================================

loc_14012:				; CODE XREF: ROM:00013FF0j
					; ROM:00013FF6j ...
		tst.w	d5
		bpl.w	loc_140AA
		swap	d0
		move.b	$28(a0),d0
		bpl.s	loc_14028
		btst	#1,$22(a1)
		bne.s	loc_140A4

loc_14028:				; CODE XREF: ROM:0001401Ej
		move.w	$C(a1),d4
		cmp.w	$C(a0),d4
		bcs.s	loc_14064
		move.b	#$C,$3E(a1)
		move.b	#$D,$3F(a1)
		btst	#3,d0
		beq.s	loc_14050
		move.b	#$E,$3E(a1)
		move.b	#$F,$3F(a1)

loc_14050:				; CODE XREF: ROM:00014042j
		bclr	#7,2(a1)
		btst	#5,d0
		beq.s	loc_14094
		bset	#7,2(a1)
		bra.s	loc_14094
; ===============================================================================

loc_14064:				; CODE XREF: ROM:00014030j
		move.b	#$C,$3E(a1)
		move.b	#$D,$3F(a1)
		btst	#4,d0
		beq.s	loc_14082
		move.b	#$E,$3E(a1)
		move.b	#$F,$3F(a1)

loc_14082:				; CODE XREF: ROM:00014074j
		bclr	#7,2(a1)
		btst	#6,d0
		beq.s	loc_14094
		bset	#7,2(a1)

loc_14094:				; CODE XREF: ROM:0001405Aj
					; ROM:00014062j ...
		tst.w	(RAM_Flag_DebugMode).w
		beq.s	loc_140A4
		move.w	#$A1,d0	; ''
		jsr	(PlaySound_Special).l

loc_140A4:				; CODE XREF: ROM:00014026j
					; ROM:00014098j
		swap	d0
		andi.w	#$7FFF,d5

loc_140AA:				; CODE XREF: ROM:00013FE4j
					; ROM:0001400Ej ...
		add.l	d5,d5
		dbf	d6,loc_13FE2
		swap	d5
		move.b	d5,$30(a0)

locret_140B6:				; CODE XREF: ROM:00013FBAj
		rts
; ===============================================================================
dword_140B8:	dc.l RAM_ObjRAM_Sonic		; DATA XREF: ROM:00013ED8o
					; ROM:00013FDAo
		dc.l RAM_ObjRAM_Tails
		dc.l 0
		dc.l 0
		dc.l 0
		dc.l 0
		dc.l 0
		dc.l 0
Map_Obj03:	dc.w word_140E8-Map_Obj03 ; DATA XREF: ROM:00013E52o
					; ROM:Map_Obj03o ...
		dc.w word_1410A-Map_Obj03
		dc.w word_1412C-Map_Obj03
		dc.w word_1412C-Map_Obj03
		dc.w word_1414E-Map_Obj03
		dc.w word_14170-Map_Obj03
		dc.w word_14192-Map_Obj03
		dc.w word_14192-Map_Obj03
word_140E8:	dc.w 4			; DATA XREF: ROM:Map_Obj03o
		dc.w $E005,    0,    0,$FFF8; 0
		dc.w $F005,    0,    0,$FFF8; 4
		dc.w	 5,    0,    0,$FFF8; 8
		dc.w $1005,    0,    0,$FFF8; 12
word_1410A:	dc.w 4			; DATA XREF: ROM:000140DAo
		dc.w $C005,    0,    0,$FFF8; 0
		dc.w $E005,    0,    0,$FFF8; 4
		dc.w	 5,    0,    0,$FFF8; 8
		dc.w $3005,    0,    0,$FFF8; 12
word_1412C:	dc.w 4			; DATA XREF: ROM:000140DCo
					; ROM:000140DEo
		dc.w $8005,    0,    0,$FFF8; 0
		dc.w $E005,    0,    0,$FFF8; 4
		dc.w	 5,    0,    0,$FFF8; 8
		dc.w $7005,    0,    0,$FFF8; 12
word_1414E:	dc.w 4			; DATA XREF: ROM:000140E0o
		dc.w $F805,    0,    0,$FFE0; 0
		dc.w $F805,    0,    0,$FFF0; 4
		dc.w $F805,    0,    0,	   0; 8
		dc.w $F805,    0,    0,	 $10; 12
word_14170:	dc.w 4			; DATA XREF: ROM:000140E2o
		dc.w $F805,    0,    0,$FFC0; 0
		dc.w $F805,    0,    0,$FFE0; 4
		dc.w $F805,    0,    0,	   0; 8
		dc.w $F805,    0,    0,	 $30; 12
word_14192:	dc.w 4			; DATA XREF: ROM:000140E4o
					; ROM:000140E6o
		dc.w $F805,    0,    0,$FF80; 0
		dc.w $F805,    0,    0,$FFE0; 4
		dc.w $F805,    0,    0,	   0; 8
		dc.w $F805,    0,    0,	 $70; 12
; ===============================================================================

Obj0B:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj0B_Index(pc,d0.w),d1
		jmp	Obj0B_Index(pc,d1.w)
; ===============================================================================
Obj0B_Index:	dc.w loc_141C8-Obj0B_Index ; DATA XREF:	ROM:Obj0B_Indexo
					; ROM:000141C4o ...
		dc.w loc_1421C-Obj0B_Index
		dc.w loc_1422A-Obj0B_Index
; ===============================================================================

loc_141C8:				; DATA XREF: ROM:Obj0B_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj0B,4(a0)
		move.w	#$E000,2(a0)
		bsr.w	ModifySpriteAttr_2P
		ori.b	#4,1(a0)
		move.b	#$10,$19(a0)
		move.b	#4,$18(a0)
		moveq	#0,d0
		move.b	$28(a0),d0
		andi.w	#$F0,d0	; ''
		addi.w	#$10,d0
		move.w	d0,d1
		subq.w	#1,d0
		move.w	d0,$30(a0)
		move.w	d0,$32(a0)
		moveq	#0,d0
		move.b	$28(a0),d0
		andi.w	#$F,d0
		addq.w	#1,d0
		lsl.w	#4,d0
		move.b	d0,$36(a0)

loc_1421C:				; DATA XREF: ROM:000141C4o
		move.b	(RAM_VIntFrameCnt+3).w,d0
		add.b	$36(a0),d0
		bne.s	loc_14254
		addq.b	#2,$24(a0)

loc_1422A:				; DATA XREF: ROM:000141C6o
		subq.w	#1,$30(a0)
		bpl.s	loc_14248
		move.w	#$7F,$30(a0) ; ''
		tst.b	$1C(a0)
		beq.s	loc_14242
		move.w	$32(a0),$30(a0)

loc_14242:				; CODE XREF: ROM:0001423Aj
		bchg	#0,$1C(a0)

loc_14248:				; CODE XREF: ROM:0001422Ej
		lea	(off_1428A).l,a1
		jsr	AnimateSprite

loc_14254:				; CODE XREF: ROM:00014224j
		tst.b	$1A(a0)
		bne.s	loc_1426E
		moveq	#0,d1
		move.b	$19(a0),d1
		moveq	#$11,d3
		move.w	8(a0),d4
		bsr.w	sub_F78A
		bra.w	MarkObjGone
; ===============================================================================

loc_1426E:				; CODE XREF: ROM:00014258j
		btst	#3,$22(a0)
		beq.s	loc_14286
		lea	(RAM_ObjRAM_Sonic).w,a1
		bclr	#3,$22(a1)
		bclr	#3,$22(a0)

loc_14286:				; CODE XREF: ROM:00014274j
		bra.w	MarkObjGone
; ===============================================================================
off_1428A:	dc.w byte_1428E-off_1428A ; DATA XREF: ROM:loc_14248o
					; ROM:off_1428Ao ...
		dc.w byte_14296-off_1428A
byte_1428E:	dc.b   7,  0,  1,  2,  3,  4,$FE,  1; 0	; DATA XREF: ROM:off_1428Ao
byte_14296:	dc.b   7,  4,  3,  2,  1,  0,$FE,  1; 0	; DATA XREF: ROM:0001428Co
Map_Obj0B:	dc.w word_142A8-Map_Obj0B ; DATA XREF: ROM:000141CCo
					; ROM:Map_Obj0Bo ...
		dc.w word_142B2-Map_Obj0B
		dc.w word_142BC-Map_Obj0B
		dc.w word_142C6-Map_Obj0B
		dc.w word_142D0-Map_Obj0B
word_142A8:	dc.w 1			; DATA XREF: ROM:Map_Obj0Bo
		dc.w $F00C,  $11,    8,$FFF0; 0
word_142B2:	dc.w 1			; DATA XREF: ROM:000142A0o
		dc.w $E80F,  $15,   $A,$FFF0; 0
word_142BC:	dc.w 1			; DATA XREF: ROM:000142A2o
		dc.w $F40F,  $25,  $12,$FFF0; 0
word_142C6:	dc.w 1			; DATA XREF: ROM:000142A4o
		dc.w	$F,$1015,$100A,$FFF0; 0
word_142D0:	dc.w 1			; DATA XREF: ROM:000142A6o
		dc.w $100C,$1011,$1008,$FFF0; 0
; ===============================================================================
		nop

Obj0C:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj0C_Index(pc,d0.w),d1
		jmp	Obj0C_Index(pc,d1.w)
; ===============================================================================
Obj0C_Index:	dc.w Obj0C_Init-Obj0C_Index ; DATA XREF: ROM:Obj0C_Indexo
					; ROM:000142ECo
		dc.w Obj0C_Main-Obj0C_Index
; ===============================================================================

Obj0C_Init:				; DATA XREF: ROM:Obj0C_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj0C,4(a0)
		move.w	#$E418,2(a0)
		bsr.w	ModifySpriteAttr_2P
		ori.b	#4,1(a0)
		move.b	#$10,$19(a0)
		move.b	#4,$18(a0)
		move.w	$C(a0),d0
		subi.w	#$10,d0
		move.w	d0,$3A(a0)
		moveq	#0,d0
		move.b	$28(a0),d0
		andi.w	#$F0,d0	; ''
		addi.w	#$10,d0
		move.w	d0,d1
		subq.w	#1,d0
		move.w	d0,$30(a0)
		move.w	d0,$32(a0)
		moveq	#0,d0
		move.b	$28(a0),d0
		andi.w	#$F,d0
		move.b	d0,$3E(a0)
		move.b	d0,$3F(a0)

Obj0C_Main:				; DATA XREF: ROM:000142ECo
		move.b	$3C(a0),d0
		beq.s	loc_1438C
		cmpi.b	#$80,d0
		bne.s	loc_1439C
		move.b	$3D(a0),d1
		bne.s	loc_1436E
		subq.b	#1,$3E(a0)
		bpl.s	loc_1436E
		move.b	$3F(a0),$3E(a0)
		bra.s	loc_1439C
; ===============================================================================

loc_1436E:				; CODE XREF: ROM:0001435Ej
					; ROM:00014364j
		addq.b	#1,$3D(a0)
		move.b	d1,d0
		bsr.w	j_CalcSine
		addi.w	#8,d0
		asr.w	#6,d0
		subi.w	#$10,d0
		add.w	$3A(a0),d0
		move.w	d0,$C(a0)
		bra.s	loc_143B2
; ===============================================================================

loc_1438C:				; CODE XREF: ROM:00014352j
		move.w	(RAM_VIntFrameCnt+2).w,d1
		andi.w	#$3FF,d1
		bne.s	loc_143A0
		move.b	#1,$3D(a0)

loc_1439C:				; CODE XREF: ROM:00014358j
					; ROM:0001436Cj
		addq.b	#1,$3C(a0)

loc_143A0:				; CODE XREF: ROM:00014394j
		bsr.w	j_CalcSine
		addi.w	#8,d1
		asr.w	#4,d1
		add.w	$3A(a0),d1
		move.w	d1,$C(a0)

loc_143B2:				; CODE XREF: ROM:0001438Aj
		moveq	#0,d1
		move.b	$19(a0),d1
		moveq	#9,d3
		move.w	8(a0),d4
		bsr.w	sub_F78A
		bra.w	MarkObjGone
; ===============================================================================
Map_Obj0C:	dc.w word_143C8-Map_Obj0C ; DATA XREF: ROM:000142F2o
					; ROM:Map_Obj0Co ...
word_143C8:	dc.w 1			; DATA XREF: ROM:Map_Obj0Co
		dc.w $F80D,    0,    0,$FFF0; 0
; ===============================================================================
		nop

j_CalcSine:				; CODE XREF: ROM:00014374p
					; ROM:loc_143A0p
		jmp	(CalcSine).l
; ===============================================================================
		align 4
;----------------------------------------------------
; Object 12 - Master Emerald from HPZ
;----------------------------------------------------

Obj12:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj12_Index(pc,d0.w),d1
		jmp	Obj12_Index(pc,d1.w)
; ===============================================================================
Obj12_Index:	dc.w Obj12_Init-Obj12_Index ; DATA XREF: ROM:Obj12_Indexo
					; ROM:000143ECo
		dc.w Obj12_Display-Obj12_Index
; ===============================================================================

Obj12_Init:				; DATA XREF: ROM:Obj12_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj12,4(a0)
		move.w	#$6392,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#4,1(a0)
		move.b	#$20,$19(a0) ; ' '
		move.b	#4,$18(a0)

Obj12_Display:				; DATA XREF: ROM:000143ECo
		move.w	#$20,d1	; ' '
		move.w	#$10,d2
		move.w	#$10,d3
		move.w	8(a0),d4
		bsr.w	SolidObject
		move.w	8(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.w	DeleteObject
		bra.w	DisplaySprite
; ===============================================================================
Map_Obj12:	dc.w word_14444-Map_Obj12 ; DATA XREF: ROM:000143F2o
					; ROM:Map_Obj12o
word_14444:	dc.w 2			; DATA XREF: ROM:Map_Obj12o
		dc.w $F00F,    0,    0,$FFE0; 0
		dc.w $F00F,  $10,    8,	   0; 4
; ===============================================================================
		nop
;----------------------------------------------------
; Object 13 - HPZ waterfall
;----------------------------------------------------

Obj13:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj13_Index(pc,d0.w),d1
		jmp	Obj13_Index(pc,d1.w)
; ===============================================================================
Obj13_Index:	dc.w loc_1446C-Obj13_Index ; DATA XREF:	ROM:Obj13_Indexo
					; ROM:00014468o ...
		dc.w loc_14532-Obj13_Index
		dc.w loc_145BC-Obj13_Index
; ===============================================================================

loc_1446C:				; DATA XREF: ROM:Obj13_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj13,4(a0)
		move.w	#$E315,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#4,1(a0)
		move.b	#$10,$19(a0)
		move.b	#1,$18(a0)
		move.b	#$12,$1A(a0)
		bsr.s	sub_144D4
		move.b	#$A0,$16(a1)
		bset	#4,1(a1)
		move.l	a1,$38(a0)
		move.w	$C(a0),$34(a0)
		move.w	$C(a0),$36(a0)
		cmpi.b	#$10,$28(a0)
		bcs.s	loc_14518
		bsr.s	sub_144D4
		move.l	a1,$3C(a0)
		move.w	$C(a0),$C(a1)
		addi.w	#$98,$C(a1) ; ''
		bra.s	loc_14518

; =============== S U B R O U T I N E ==========================================


sub_144D4:				; CODE XREF: ROM:0001449Ap
					; ROM:000144C0p
		jsr	S1SingleObjectLoad2
		bne.s	locret_14516
		move.b	#$13,0(a1)
		addq.b	#4,$24(a1)
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		move.l	#Map_Obj13,4(a1)
		move.w	#$E315,2(a1)
		bsr.w	ModifyA1SpriteAttr_2P
		move.b	#4,1(a1)
		move.b	#$10,$19(a1)
		move.b	#1,$18(a1)

locret_14516:				; CODE XREF: sub_144D4+6j
		rts
; End of function sub_144D4

; ===============================================================================

loc_14518:				; CODE XREF: ROM:000144BEj
					; ROM:000144D2j
		moveq	#0,d1
		move.b	$28(a0),d1
		move.w	$34(a0),d0
		subi.w	#$78,d0	; 'x'
		lsl.w	#4,d1
		add.w	d1,d0
		move.w	d0,$C(a0)
		move.w	d0,$34(a0)

loc_14532:				; DATA XREF: ROM:00014468o
		movea.l	$38(a0),a1
		move.b	#$12,$1A(a0)
		move.w	$34(a0),d0
		move.w	(RAM_Level_Water_Action).w,d1
		cmp.w	d0,d1
		bcc.s	loc_1454A
		move.w	d1,d0

loc_1454A:				; CODE XREF: ROM:00014546j
		move.w	d0,$C(a0)
		sub.w	$36(a0),d0
		addi.w	#$80,d0	; ''
		bmi.s	loc_1459C
		lsr.w	#4,d0
		move.w	d0,d1
		cmpi.w	#$F,d0
		bcs.s	loc_14564
		moveq	#$F,d0

loc_14564:				; CODE XREF: ROM:00014560j
		move.b	d0,$1A(a1)
		cmpi.b	#$10,$28(a0)
		bcs.s	loc_14584
		movea.l	$3C(a0),a1
		subi.w	#$F,d1
		bcc.s	loc_1457C
		moveq	#0,d1

loc_1457C:				; CODE XREF: ROM:00014578j
		addi.w	#$13,d1
		move.b	d1,$1A(a1)

loc_14584:				; CODE XREF: ROM:0001456Ej
		move.w	8(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.w	DeleteObject
		bra.w	DisplaySprite
; ===============================================================================

loc_1459C:				; CODE XREF: ROM:00014556j
		moveq	#$13,d0
		move.b	d0,$1A(a0)
		move.b	d0,$1A(a1)
		move.w	8(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.w	DeleteObject
		rts
; ===============================================================================

loc_145BC:				; DATA XREF: ROM:0001446Ao
		move.w	8(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.w	DeleteObject
		bra.w	DisplaySprite
; ===============================================================================
Map_Obj13:	dc.w word_1460E-Map_Obj13 ; DATA XREF: ROM:00014470o
					; sub_144D4+1Eo ...
		dc.w word_14618-Map_Obj13
		dc.w word_1462A-Map_Obj13
		dc.w word_1463C-Map_Obj13
		dc.w word_14656-Map_Obj13
		dc.w word_14670-Map_Obj13
		dc.w word_14692-Map_Obj13
		dc.w word_146B4-Map_Obj13
		dc.w word_146DE-Map_Obj13
		dc.w word_14708-Map_Obj13
		dc.w word_1473A-Map_Obj13
		dc.w word_1476C-Map_Obj13
		dc.w word_147A6-Map_Obj13
		dc.w word_147E0-Map_Obj13
		dc.w word_14822-Map_Obj13
		dc.w word_14864-Map_Obj13
		dc.w word_148AE-Map_Obj13
		dc.w word_148AE-Map_Obj13
		dc.w word_148AE-Map_Obj13
		dc.w word_1460C-Map_Obj13
		dc.w word_148C0-Map_Obj13
		dc.w word_148CA-Map_Obj13
		dc.w word_148D4-Map_Obj13
		dc.w word_148E6-Map_Obj13
		dc.w word_148F8-Map_Obj13
		dc.w word_14912-Map_Obj13
		dc.w word_1492C-Map_Obj13
		dc.w word_1494E-Map_Obj13
word_1460C:	dc.w 0			; DATA XREF: ROM:000145FAo
word_1460E:	dc.w 1			; DATA XREF: ROM:Map_Obj13o
		dc.w $800C,  $10,    8,$FFF0; 0
word_14618:	dc.w 2			; DATA XREF: ROM:000145D6o
		dc.w $800C,  $10,    8,$FFF0; 0
		dc.w $880D,  $2D,  $16,$FFF0; 4
word_1462A:	dc.w 2			; DATA XREF: ROM:000145D8o
		dc.w $800C,  $10,    8,$FFF0; 0
		dc.w $880F,    0,    0,$FFF0; 4
word_1463C:	dc.w 3			; DATA XREF: ROM:000145DAo
		dc.w $800C,  $10,    8,$FFF0; 0
		dc.w $880F,    0,    0,$FFF0; 4
		dc.w $A80D,  $2D,  $16,$FFF0; 8
word_14656:	dc.w 3			; DATA XREF: ROM:000145DCo
		dc.w $800C,  $10,    8,$FFF0; 0
		dc.w $880F,    0,    0,$FFF0; 4
		dc.w $A80F,    0,    0,$FFF0; 8
word_14670:	dc.w 4			; DATA XREF: ROM:000145DEo
		dc.w $800C,  $10,    8,$FFF0; 0
		dc.w $880F,    0,    0,$FFF0; 4
		dc.w $A80F,    0,    0,$FFF0; 8
		dc.w $C80D,  $2D,  $16,$FFF0; 12
word_14692:	dc.w 4			; DATA XREF: ROM:000145E0o
		dc.w $800C,  $10,    8,$FFF0; 0
		dc.w $880F,    0,    0,$FFF0; 4
		dc.w $A80F,    0,    0,$FFF0; 8
		dc.w $C80F,    0,    0,$FFF0; 12
word_146B4:	dc.w 5			; DATA XREF: ROM:000145E2o
		dc.w $800C,  $10,    8,$FFF0; 0
		dc.w $880F,    0,    0,$FFF0; 4
		dc.w $A80F,    0,    0,$FFF0; 8
		dc.w $C80F,    0,    0,$FFF0; 12
		dc.w $E80D,  $2D,  $16,$FFF0; 16
word_146DE:	dc.w 5			; DATA XREF: ROM:000145E4o
		dc.w $800C,  $10,    8,$FFF0; 0
		dc.w $880F,    0,    0,$FFF0; 4
		dc.w $A80F,    0,    0,$FFF0; 8
		dc.w $C80F,    0,    0,$FFF0; 12
		dc.w $E80F,    0,    0,$FFF0; 16
word_14708:	dc.w 6			; DATA XREF: ROM:000145E6o
		dc.w $800C,  $10,    8,$FFF0; 0
		dc.w $880F,    0,    0,$FFF0; 4
		dc.w $A80F,    0,    0,$FFF0; 8
		dc.w $C80F,    0,    0,$FFF0; 12
		dc.w $E80F,    0,    0,$FFF0; 16
		dc.w  $80D,  $2D,  $16,$FFF0; 20
word_1473A:	dc.w 6			; DATA XREF: ROM:000145E8o
		dc.w $800C,  $10,    8,$FFF0; 0
		dc.w $880F,    0,    0,$FFF0; 4
		dc.w $A80F,    0,    0,$FFF0; 8
		dc.w $C80F,    0,    0,$FFF0; 12
		dc.w $E80F,    0,    0,$FFF0; 16
		dc.w  $80F,    0,    0,$FFF0; 20
word_1476C:	dc.w 7			; DATA XREF: ROM:000145EAo
		dc.w $800C,  $10,    8,$FFF0; 0
		dc.w $880F,    0,    0,$FFF0; 4
		dc.w $A80F,    0,    0,$FFF0; 8
		dc.w $C80F,    0,    0,$FFF0; 12
		dc.w $E80F,    0,    0,$FFF0; 16
		dc.w  $80F,    0,    0,$FFF0; 20
		dc.w $280D,  $2D,  $16,$FFF0; 24
word_147A6:	dc.w 7			; DATA XREF: ROM:000145ECo
		dc.w $800C,  $10,    8,$FFF0; 0
		dc.w $880F,    0,    0,$FFF0; 4
		dc.w $A80F,    0,    0,$FFF0; 8
		dc.w $C80F,    0,    0,$FFF0; 12
		dc.w $E80F,    0,    0,$FFF0; 16
		dc.w  $80F,    0,    0,$FFF0; 20
		dc.w $280F,    0,    0,$FFF0; 24
word_147E0:	dc.w 8			; DATA XREF: ROM:000145EEo
		dc.w $800C,  $10,    8,$FFF0; 0
		dc.w $880F,    0,    0,$FFF0; 4
		dc.w $A80F,    0,    0,$FFF0; 8
		dc.w $C80F,    0,    0,$FFF0; 12
		dc.w $E80F,    0,    0,$FFF0; 16
		dc.w  $80F,    0,    0,$FFF0; 20
		dc.w $280F,    0,    0,$FFF0; 24
		dc.w $480D,  $2D,  $16,$FFF0; 28
word_14822:	dc.w 8			; DATA XREF: ROM:000145F0o
		dc.w $800C,  $10,    8,$FFF0; 0
		dc.w $880F,    0,    0,$FFF0; 4
		dc.w $A80F,    0,    0,$FFF0; 8
		dc.w $C80F,    0,    0,$FFF0; 12
		dc.w $E80F,    0,    0,$FFF0; 16
		dc.w  $80F,    0,    0,$FFF0; 20
		dc.w $280F,    0,    0,$FFF0; 24
		dc.w $480F,    0,    0,$FFF0; 28
word_14864:	dc.w 9			; DATA XREF: ROM:000145F2o
		dc.w $800C,  $10,    8,$FFF0; 0
		dc.w $880F,    0,    0,$FFF0; 4
		dc.w $A80F,    0,    0,$FFF0; 8
		dc.w $C80F,    0,    0,$FFF0; 12
		dc.w $E80F,    0,    0,$FFF0; 16
		dc.w  $80F,    0,    0,$FFF0; 20
		dc.w $280F,    0,    0,$FFF0; 24
		dc.w $480F,    0,    0,$FFF0; 28
		dc.w $680D,  $2D,  $16,$FFF0; 32
word_148AE:	dc.w 2			; DATA XREF: ROM:000145F4o
					; ROM:000145F6o ...
		dc.w $F00A,  $18,   $C,$FFE8; 0
		dc.w $F00A, $818, $80C,	   0; 4
word_148C0:	dc.w 1			; DATA XREF: ROM:000145FCo
		dc.w $E00D,  $2D,  $16,$FFF0; 0
word_148CA:	dc.w 1			; DATA XREF: ROM:000145FEo
		dc.w $E00F,    0,    0,$FFF0; 0
word_148D4:	dc.w 2			; DATA XREF: ROM:00014600o
		dc.w $E00F,    0,    0,$FFF0; 0
		dc.w	$D,  $2D,  $16,$FFF0; 4
word_148E6:	dc.w 2			; DATA XREF: ROM:00014602o
		dc.w $E00F,    0,    0,$FFF0; 0
		dc.w	$F,    0,    0,$FFF0; 4
word_148F8:	dc.w 3			; DATA XREF: ROM:00014604o
		dc.w $E00F,    0,    0,$FFF0; 0
		dc.w	$F,    0,    0,$FFF0; 4
		dc.w $200D,  $2D,  $16,$FFF0; 8
word_14912:	dc.w 3			; DATA XREF: ROM:00014606o
		dc.w $E00F,    0,    0,$FFF0; 0
		dc.w	$F,    0,    0,$FFF0; 4
		dc.w $200F,    0,    0,$FFF0; 8
word_1492C:	dc.w 4			; DATA XREF: ROM:00014608o
		dc.w $E00F,    0,    0,$FFF0; 0
		dc.w	$F,    0,    0,$FFF0; 4
		dc.w $200F,    0,    0,$FFF0; 8
		dc.w $400D,  $2D,  $16,$FFF0; 12
word_1494E:	dc.w 4			; DATA XREF: ROM:0001460Ao
		dc.w $E00F,    0,    0,$FFF0; 0
		dc.w	$F,    0,    0,$FFF0; 4
		dc.w $200F,    0,    0,$FFF0; 8
		dc.w $400F,    0,    0,$FFF0; 12
; ===============================================================================
;----------------------------------------------------
; Object 06 - spiral loop in EHZ
;----------------------------------------------------

Obj06:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj06_Index(pc,d0.w),d1
		jsr	Obj06_Index(pc,d1.w)
		tst.w	(RAM_Flag_SplitScreen).w
		beq.s	loc_14986
		rts
; ===============================================================================

loc_14986:				; CODE XREF: ROM:00014982j
		move.w	8(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.s	loc_1499A
		rts
; ===============================================================================

loc_1499A:				; CODE XREF: ROM:00014996j
		jmp	DeleteObject
; ===============================================================================
Obj06_Index:	dc.w Obj06_Init-Obj06_Index ; DATA XREF: ROM:Obj06_Indexo
					; ROM:000149A2o
		dc.w Obj06_Main-Obj06_Index
; ===============================================================================

Obj06_Init:				; DATA XREF: ROM:Obj06_Indexo
		addq.b	#2,$24(a0)
		move.b	#$D0,$19(a0)

Obj06_Main:				; DATA XREF: ROM:000149A2o
		lea	(RAM_ObjRAM_Sonic).w,a1
		moveq	#3,d6
		bsr.s	sub_149BC
		lea	(RAM_ObjRAM_Tails).w,a1
		addq.b	#1,d6

; =============== S U B R O U T I N E ==========================================


sub_149BC:				; CODE XREF: ROM:000149B4p
		btst	d6,$22(a0)
		bne.w	loc_14A56
		btst	#1,$22(a1)
		bne.w	locret_14A54
		btst	#3,$22(a1)
		bne.s	loc_14A16
		move.w	8(a1),d0
		sub.w	8(a0),d0
		tst.w	$10(a1)
		bmi.s	loc_149F2
		cmpi.w	#$FF40,d0
		bgt.s	locret_14A54
		cmpi.w	#$FF30,d0
		blt.s	locret_14A54
		bra.s	loc_149FE
; ===============================================================================

loc_149F2:				; CODE XREF: sub_149BC+26j
		cmpi.w	#$C0,d0	; ''
		blt.s	locret_14A54
		cmpi.w	#$D0,d0	; ''
		bgt.s	locret_14A54

loc_149FE:				; CODE XREF: sub_149BC+34j
		move.w	$C(a1),d1
		sub.w	$C(a0),d1
		subi.w	#$10,d1
		cmpi.w	#$30,d1	; '0'
		bcc.s	locret_14A54
		bsr.w	sub_F8F8
		rts
; ===============================================================================

loc_14A16:				; CODE XREF: sub_149BC+18j
		move.w	8(a1),d0
		sub.w	8(a0),d0
		tst.w	$10(a1)
		bmi.s	loc_14A32
		cmpi.w	#$FF50,d0
		bgt.s	locret_14A54
		cmpi.w	#$FF40,d0
		blt.s	locret_14A54
		bra.s	loc_14A3E
; ===============================================================================

loc_14A32:				; CODE XREF: sub_149BC+66j
		cmpi.w	#$B0,d0	; ''
		blt.s	locret_14A54
		cmpi.w	#$C0,d0	; ''
		bgt.s	locret_14A54

loc_14A3E:				; CODE XREF: sub_149BC+74j
		move.w	$C(a1),d1
		sub.w	$C(a0),d1
		subi.w	#$10,d1
		cmpi.w	#$30,d1	; '0'
		bcc.s	locret_14A54
		bsr.w	sub_F8F8

locret_14A54:				; CODE XREF: sub_149BC+Ej
					; sub_149BC+2Cj ...
		rts
; ===============================================================================

loc_14A56:				; CODE XREF: sub_149BC+4j
		move.w	$14(a1),d0
		bpl.s	loc_14A5E
		neg.w	d0

loc_14A5E:				; CODE XREF: sub_149BC+9Ej
		cmpi.w	#$600,d0
		bcs.s	loc_14A80
		btst	#1,$22(a1)
		bne.s	loc_14A80
		move.w	8(a1),d0
		sub.w	8(a0),d0
		addi.w	#$D0,d0	; ''
		bmi.s	loc_14A80
		cmpi.w	#$1A0,d0
		bcs.s	loc_14A98

loc_14A80:				; CODE XREF: sub_149BC+A6j
					; sub_149BC+AEj ...
		bclr	#3,$22(a1)
		bclr	d6,$22(a0)
		move.b	#0,$2C(a1)
		move.b	#4,$2D(a1)
		rts
; ===============================================================================

loc_14A98:				; CODE XREF: sub_149BC+C2j
		btst	#3,$22(a1)
		beq.s	locret_14A54
		move.b	Obj06_PlayerDeltaYArray(pc,d0.w),d1
		ext.w	d1
		move.w	$C(a0),d2
		add.w	d1,d2
		moveq	#0,d1
		move.b	$16(a1),d1
		subi.w	#$13,d1
		sub.w	d1,d2
		move.w	d2,$C(a1)
		lsr.w	#3,d0
		andi.w	#$3F,d0	; '?'
		move.b	Obj06_PlayerAngleArray(pc,d0.w),$27(a1)
		rts
; End of function sub_149BC

; ===============================================================================
Obj06_PlayerAngleArray:dc.b   0,  0,  1,  1    ; 0
		dc.b $16,$16,$16,$16	; 4
		dc.b $2C,$2C,$2C,$2C	; 8
		dc.b $42,$42,$42,$42	; 12
		dc.b $58,$58,$58,$58	; 16
		dc.b $6E,$6E,$6E,$6E	; 20
		dc.b $84,$84,$84,$84	; 24
		dc.b $9A,$9A,$9A,$9A	; 28
		dc.b $B0,$B0,$B0,$B0	; 32
		dc.b $C6,$C6,$C6,$C6	; 36
		dc.b $DC,$DC,$DC,$DC	; 40
		dc.b $F2,$F2,$F2,$F2	; 44
		dc.b   1,  1,  0,  0	; 48
Obj06_PlayerDeltaYArray:dc.b  $20, $20,	$20, $20, $20, $20, $20, $20, $20, $20,	$20, $20, $20, $20, $20, $20; 0
		dc.b  $20, $20,	$20, $20, $20, $20, $20, $20, $20, $20,	$20, $20, $20, $20, $1F, $1F; 16
		dc.b  $1F, $1F,	$1F, $1F, $1F, $1F, $1F, $1F, $1F, $1F,	$1F, $1F, $1F, $1E, $1E, $1E; 32
		dc.b  $1E, $1E,	$1E, $1E, $1E, $1E, $1D, $1D, $1D, $1D,	$1D, $1C, $1C, $1C, $1C, $1B; 48
		dc.b  $1B, $1B,	$1B, $1A, $1A, $1A, $19, $19, $19, $18,	$18, $18, $17, $17, $16, $16; 64
		dc.b  $15, $15,	$14, $14, $13, $12, $12, $11, $10, $10,	 $F,  $E,  $E,	$D,  $C,  $C; 80
		dc.b   $B,  $A,	 $A,   9,   8,	 8,   7,   6,	6,   5,	  4,   4,   3,	 2,   2,   1; 96
		dc.b	0,  -1,	 -2,  -2,  -3,	-4,  -4,  -5,  -6,  -7,	 -7,  -8,  -9,	-9, -$A, -$A; 112
		dc.b  -$B, -$B,	-$C, -$C, -$D, -$E, -$E, -$F, -$F,-$10,-$10,-$11,-$11,-$12,-$12,-$13; 128
		dc.b -$13,-$13,-$14,-$15,-$15,-$16,-$16,-$17,-$17,-$18,-$18,-$19,-$19,-$1A,-$1A,-$1B; 144
		dc.b -$1B,-$1C,-$1C,-$1C,-$1D,-$1D,-$1E,-$1E,-$1E,-$1F,-$1F,-$1F,-$20,-$20,-$20,-$21; 160
		dc.b -$21,-$21,-$21,-$22,-$22,-$22,-$23,-$23,-$23,-$23,-$23,-$23,-$23,-$23,-$24,-$24; 176
		dc.b -$24,-$24,-$24,-$24,-$24,-$24,-$24,-$25,-$25,-$25,-$25,-$25,-$25,-$25,-$25,-$25; 192
		dc.b -$25,-$25,-$25,-$25,-$25,-$25,-$25,-$25,-$25,-$25,-$25,-$25,-$25,-$25,-$25,-$25; 208
		dc.b -$25,-$25,-$25,-$25,-$24,-$24,-$24,-$24,-$24,-$24,-$24,-$23,-$23,-$23,-$23,-$23; 224
		dc.b -$23,-$23,-$23,-$22,-$22,-$22,-$21,-$21,-$21,-$21,-$20,-$20,-$20,-$1F,-$1F,-$1F; 240
		dc.b -$1E,-$1E,-$1E,-$1D,-$1D,-$1C,-$1C,-$1C,-$1B,-$1B,-$1A,-$1A,-$19,-$19,-$18,-$18; 256
		dc.b -$17,-$17,-$16,-$16,-$15,-$15,-$14,-$13,-$13,-$12,-$12,-$11,-$10,-$10, -$F, -$E; 272
		dc.b  -$E, -$D,	-$C, -$B, -$B, -$A,  -9,  -8,  -7,  -7,	 -6,  -5,  -4,	-3,  -2,  -1; 288
		dc.b	0,   1,	  2,   3,   4,	 5,   6,   7,	8,   8,	  9,  $A,  $A,	$B,  $C,  $D; 304
		dc.b   $D,  $E,	 $E,  $F,  $F, $10, $10, $11, $11, $12,	$12, $13, $13, $14, $14, $15; 320
		dc.b  $15, $16,	$16, $17, $17, $18, $18, $18, $19, $19,	$19, $19, $1A, $1A, $1A, $1A; 336
		dc.b  $1B, $1B,	$1B, $1B, $1C, $1C, $1C, $1C, $1C, $1C,	$1D, $1D, $1D, $1D, $1D, $1D; 352
		dc.b  $1D, $1E,	$1E, $1E, $1E, $1E, $1E, $1E, $1F, $1F,	$1F, $1F, $1F, $1F, $1F, $1F; 368
		dc.b  $1F, $1F,	$20, $20, $20, $20, $20, $20, $20, $20,	$20, $20, $20, $20, $20, $20; 384
		dc.b  $20, $20,	$20, $20, $20, $20, $20, $20, $20, $20,	$20, $20, $20, $20, $20, $20; 400
; ===============================================================================
		nop
;----------------------------------------------------
; Object 14 - HTZ see-saw
;----------------------------------------------------

Obj14:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj14_Index(pc,d0.w),d1
		jsr	Obj14_Index(pc,d1.w)
		move.w	$30(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.w	DeleteObject
		bra.w	DisplaySprite
; ===============================================================================
Obj14_Index:	dc.w loc_14CD2-Obj14_Index ; DATA XREF:	ROM:Obj14_Indexo
					; ROM:00014CC8o ...
		dc.w loc_14D40-Obj14_Index
		dc.w locret_14DF2-Obj14_Index
		dc.w loc_14E3C-Obj14_Index
		dc.w loc_14E9C-Obj14_Index
		dc.w loc_14F30-Obj14_Index
; ===============================================================================

loc_14CD2:				; DATA XREF: ROM:Obj14_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj14,4(a0)
		move.w	#$3CE,2(a0)
		bsr.w	ModifySpriteAttr_2P
		ori.b	#4,1(a0)
		move.b	#4,$18(a0)
		move.b	#$30,$19(a0) ; '0'
		move.w	8(a0),$30(a0)
		tst.b	$28(a0)
		bne.s	loc_14D2C
		bsr.w	S1SingleObjectLoad2
		bne.s	loc_14D2C
		move.b	#$14,0(a1)
		addq.b	#6,$24(a1)
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		move.b	$22(a0),$22(a1)
		move.l	a0,$3C(a1)

loc_14D2C:				; CODE XREF: ROM:00014D04j
					; ROM:00014D0Aj
		btst	#0,$22(a0)
		beq.s	loc_14D3A
		move.b	#2,$1A(a0)

loc_14D3A:				; CODE XREF: ROM:00014D32j
		move.b	$1A(a0),$3A(a0)

loc_14D40:				; DATA XREF: ROM:00014CC8o
		move.b	$3A(a0),d1
		btst	#3,$22(a0)
		beq.s	loc_14D9A
		moveq	#2,d1
		lea	(RAM_ObjRAM_Sonic).w,a1
		move.w	8(a0),d0
		sub.w	8(a1),d0
		bcc.s	loc_14D60
		neg.w	d0
		moveq	#0,d1

loc_14D60:				; CODE XREF: ROM:00014D5Aj
		cmpi.w	#8,d0
		bcc.s	loc_14D68
		moveq	#1,d1

loc_14D68:				; CODE XREF: ROM:00014D64j
		btst	#4,$22(a0)
		beq.s	loc_14DBE
		moveq	#2,d2
		lea	(RAM_ObjRAM_Tails).w,a1
		move.w	8(a0),d0
		sub.w	8(a1),d0
		bcc.s	loc_14D84
		neg.w	d0
		moveq	#0,d2

loc_14D84:				; CODE XREF: ROM:00014D7Ej
		cmpi.w	#8,d0
		bcc.s	loc_14D8C
		moveq	#1,d2

loc_14D8C:				; CODE XREF: ROM:00014D88j
		add.w	d2,d1
		cmpi.w	#3,d1
		bne.s	loc_14D96
		addq.w	#1,d1

loc_14D96:				; CODE XREF: ROM:00014D92j
		lsr.w	#1,d1
		bra.s	loc_14DBE
; ===============================================================================

loc_14D9A:				; CODE XREF: ROM:00014D4Aj
		btst	#4,$22(a0)
		beq.s	loc_14DBE
		moveq	#2,d1
		lea	(RAM_ObjRAM_Tails).w,a1
		move.w	8(a0),d0
		sub.w	8(a1),d0
		bcc.s	loc_14DB6
		neg.w	d0
		moveq	#0,d1

loc_14DB6:				; CODE XREF: ROM:00014DB0j
		cmpi.w	#8,d0
		bcc.s	loc_14DBE
		moveq	#1,d1

loc_14DBE:				; CODE XREF: ROM:00014D6Ej
					; ROM:00014D98j ...
		bsr.w	sub_14E10
		lea	(byte_14FFE).l,a2
		btst	#0,$1A(a0)
		beq.s	loc_14DD6
		lea	(byte_1502F).l,a2

loc_14DD6:				; CODE XREF: ROM:00014DCEj
		lea	(RAM_ObjRAM_Sonic).w,a1
		move.w	$12(a1),$38(a0)
		move.w	8(a0),-(sp)
		moveq	#0,d1
		move.b	$19(a0),d1
		moveq	#8,d3
		move.w	(sp)+,d4
		bra.w	sub_F7DC
; ===============================================================================

locret_14DF2:				; DATA XREF: ROM:00014CCAo
		rts
; ===============================================================================
		moveq	#2,d1
		lea	(RAM_ObjRAM_Sonic).w,a1
		move.w	8(a0),d0
		sub.w	8(a1),d0
		bcc.s	loc_14E08
		neg.w	d0
		moveq	#0,d1

loc_14E08:				; CODE XREF: ROM:00014E02j
		cmpi.w	#8,d0
		bcc.s	sub_14E10
		moveq	#1,d1

; =============== S U B R O U T I N E ==========================================


sub_14E10:				; CODE XREF: ROM:loc_14DBEp
					; ROM:00014E0Cj
		move.b	$1A(a0),d0
		cmp.b	d1,d0
		beq.s	locret_14E3A
		bcc.s	loc_14E1C
		addq.b	#2,d0

loc_14E1C:				; CODE XREF: sub_14E10+8j
		subq.b	#1,d0
		move.b	d0,$1A(a0)
		move.b	d1,$3A(a0)
		bclr	#0,1(a0)
		btst	#1,$1A(a0)
		beq.s	locret_14E3A
		bset	#0,1(a0)

locret_14E3A:				; CODE XREF: sub_14E10+6j
					; sub_14E10+22j
		rts
; End of function sub_14E10

; ===============================================================================

loc_14E3C:				; DATA XREF: ROM:00014CCCo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj14b,4(a0)
		move.w	#$3CE,2(a0)
		bsr.w	ModifySpriteAttr_2P
		ori.b	#4,1(a0)
		move.b	#4,$18(a0)
		move.b	#$8B,$20(a0)
		move.b	#$C,$19(a0)
		move.w	8(a0),$30(a0)
		addi.w	#$28,8(a0) ; '('
		addi.w	#$10,$C(a0)
		move.w	$C(a0),$34(a0)
		move.b	#1,$1A(a0)
		btst	#0,$22(a0)
		beq.s	loc_14E9C
		subi.w	#$50,8(a0) ; 'P'
		move.b	#2,$3A(a0)

loc_14E9C:				; CODE XREF: ROM:00014E8Ej
					; DATA XREF: ROM:00014CCEo
		movea.l	$3C(a0),a1
		moveq	#0,d0
		move.b	$3A(a0),d0
		sub.b	$3A(a1),d0
		beq.s	loc_14EF2
		bcc.s	loc_14EB0
		neg.b	d0

loc_14EB0:				; CODE XREF: ROM:00014EACj
		move.w	#$F7E8,d1
		move.w	#$FEEC,d2
		cmpi.b	#1,d0
		beq.s	loc_14ED6
		move.w	#$F510,d1
		move.w	#$FF34,d2
		cmpi.w	#$A00,$38(a1)
		blt.s	loc_14ED6
		move.w	#$F200,d1
		move.w	#$FF60,d2

loc_14ED6:				; CODE XREF: ROM:00014EBCj
					; ROM:00014ECCj
		move.w	d1,$12(a0)
		move.w	d2,$10(a0)
		move.w	8(a0),d0
		sub.w	$30(a0),d0
		bcc.s	loc_14EEC
		neg.w	$10(a0)

loc_14EEC:				; CODE XREF: ROM:00014EE6j
		addq.b	#2,$24(a0)
		bra.s	loc_14F30
; ===============================================================================

loc_14EF2:				; CODE XREF: ROM:00014EAAj
		lea	(word_14FF4).l,a2
		moveq	#0,d0
		move.b	$1A(a1),d0
		move.w	#$28,d2	; '('
		move.w	8(a0),d1
		sub.w	$30(a0),d1
		bcc.s	loc_14F10
		neg.w	d2
		addq.w	#2,d0

loc_14F10:				; CODE XREF: ROM:00014F0Aj
		add.w	d0,d0
		move.w	$34(a0),d1
		add.w	(a2,d0.w),d1
		move.w	d1,$C(a0)
		add.w	$30(a0),d2
		move.w	d2,8(a0)
		clr.w	$E(a0)
		clr.w	$A(a0)
		rts
; ===============================================================================

loc_14F30:				; CODE XREF: ROM:00014EF0j
					; DATA XREF: ROM:00014CD0o
		tst.w	$12(a0)
		bpl.s	loc_14F4E
		bsr.w	j_ObjectFall
		move.w	$34(a0),d0
		subi.w	#$2F,d0	; '/'
		cmp.w	$C(a0),d0
		bgt.s	locret_14F4C
		bsr.w	j_ObjectFall

locret_14F4C:				; CODE XREF: ROM:00014F46j
		rts
; ===============================================================================

loc_14F4E:				; CODE XREF: ROM:00014F34j
		bsr.w	j_ObjectFall
		movea.l	$3C(a0),a1
		lea	(word_14FF4).l,a2
		moveq	#0,d0
		move.b	$1A(a1),d0
		move.w	8(a0),d1
		sub.w	$30(a0),d1
		bcc.s	loc_14F6E
		addq.w	#2,d0

loc_14F6E:				; CODE XREF: ROM:00014F6Aj
		add.w	d0,d0
		move.w	$34(a0),d1
		add.w	(a2,d0.w),d1
		cmp.w	$C(a0),d1
		bgt.s	locret_14FC2
		movea.l	$3C(a0),a1
		moveq	#2,d1
		tst.w	$10(a0)
		bmi.s	loc_14F8C
		moveq	#0,d1

loc_14F8C:				; CODE XREF: ROM:00014F88j
		move.b	d1,$3A(a1)
		move.b	d1,$3A(a0)
		cmp.b	$1A(a1),d1
		beq.s	loc_14FB6
		lea	(RAM_ObjRAM_Sonic).w,a2
		bclr	#3,$22(a1)
		beq.s	loc_14FA8
		bsr.s	sub_14FC4

loc_14FA8:				; CODE XREF: ROM:00014FA4j
		lea	(RAM_ObjRAM_Tails).w,a2
		bclr	#4,$22(a1)
		beq.s	loc_14FB6
		bsr.s	sub_14FC4

loc_14FB6:				; CODE XREF: ROM:00014F98j
					; ROM:00014FB2j
		clr.w	$10(a0)
		clr.w	$12(a0)
		subq.b	#2,$24(a0)

locret_14FC2:				; CODE XREF: ROM:00014F7Cj
		rts

; =============== S U B R O U T I N E ==========================================


sub_14FC4:				; CODE XREF: ROM:00014FA6p
					; ROM:00014FB4p
		move.w	$12(a0),$12(a2)
		neg.w	$12(a2)
		bset	#1,$22(a2)
		bclr	#3,$22(a2)
		clr.b	$3C(a2)
		move.b	#$10,$1C(a2)
		move.b	#2,$24(a2)
		move.w	#$CC,d0	; ''
		jmp	(PlaySound_Special).l
; End of function sub_14FC4

; ===============================================================================
word_14FF4:	dc.w	 -8,  -$1C,  -$2F,  -$1C,    -8; 0 ; DATA XREF:	ROM:loc_14EF2o
					; ROM:00014F56o
byte_14FFE:	dc.b  $14, $14,	$16, $18, $1A, $1C, $1A; 0 ; DATA XREF:	ROM:00014DC2o
		dc.b  $18, $16,	$14, $13, $12, $11, $10; 7
		dc.b   $F,  $E,	 $D,  $C,  $B,	$A,   9; 14
		dc.b	8,   7,	  6,   5,   4,	 3,   2; 21
		dc.b	1,   0,	 -1,  -2,  -3,	-4,  -5; 28
		dc.b   -6,  -7,	 -8,  -9, -$A, -$B, -$C; 35
		dc.b  -$D, -$E,	-$E, -$E, -$E, -$E, -$E; 42
byte_1502F:	dc.b	5,   5,	  5,   5,   5,	 5,   5; 0 ; DATA XREF:	ROM:00014DD0o
		dc.b	5,   5,	  5,   5,   5,	 5,   5; 7
		dc.b	5,   5,	  5,   5,   5,	 5,   5; 14
		dc.b	5,   5,	  5,   5,   5,	 5,   5; 21
		dc.b	5,   5,	  5,   5,   5,	 5,   5; 28
		dc.b	5,   5,	  5,   5,   5,	 5,   5; 35
		dc.b	5,   5,	  5,   5,   5,	 5,   0; 42
Map_Obj14:	dc.w word_15068-Map_Obj14 ; DATA XREF: ROM:00014CD6o
					; ROM:Map_Obj14o ...
		dc.w word_150AA-Map_Obj14
		dc.w word_15068-Map_Obj14
		dc.w word_150AA-Map_Obj14
word_15068:	dc.w 8			; DATA XREF: ROM:Map_Obj14o
					; ROM:00015064o
		dc.w $FC05,$4014,$400A,$FFF8; 0
		dc.w  $C01,$2012,$2009,$FFFC; 4
		dc.w $E405,$4006,$4003,$FFD0; 8
		dc.w $EC05,$400A,$4005,$FFE0; 12
		dc.w $F405,$400A,$4005,$FFF0; 16
		dc.w $FC05,$400A,$4005,	   0; 20
		dc.w  $405,$400A,$4005,	 $10; 24
		dc.w  $C05,$400E,$4007,	 $20; 28
word_150AA:	dc.w 8			; DATA XREF: ROM:00015062o
					; ROM:00015066o
word_150AC:	dc.w $FC05,$4014,$400A,$FFF8; 0
		dc.w  $C01,$2012,$2009,$FFFC; 4
		dc.w $F405,$4000,$4000,$FFD0; 8
		dc.w $F405,$4002,$4001,$FFE0; 12
		dc.w $F405,$4002,$4001,$FFF0; 16
		dc.w $F405,$4002,$4001,	   0; 20
		dc.w $F405,$4002,$4001,	 $10; 24
		dc.w $F405,$4800,$4800,	 $20; 28
Map_Obj14b:	dc.w word_150F0-Map_Obj14b ; DATA XREF:	ROM:00014E40o
					; ROM:Map_Obj14bo ...
		dc.w word_150F0-Map_Obj14b
word_150F0:	dc.w 1			; DATA XREF: ROM:Map_Obj14bo
					; ROM:000150EEo
		dc.w $F805,$4014,$400A,$FFF8; 0
; ===============================================================================
		nop

j_ObjectFall:				; CODE XREF: ROM:00014F36p
					; ROM:00014F48p ...
		jmp	ObjectFall
; ===============================================================================
		align 4
;----------------------------------------------------
; Object 16 - the HTZ platform that goes down diagonally
;	      and stops	after a	while (in final, it falls)
;----------------------------------------------------

Obj16:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0

loc_15106:
		move.b	$24(a0),d0
		move.w	Obj16_Index(pc,d0.w),d1
		jmp	Obj16_Index(pc,d1.w)
; ===============================================================================
Obj16_Index:	dc.w Obj16_Init-Obj16_Index ; DATA XREF: ROM:Obj16_Indexo
					; ROM:00015114o
		dc.w Obj16_Main-Obj16_Index
; ===============================================================================

Obj16_Init:				; DATA XREF: ROM:Obj16_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj16,4(a0)
		move.w	#$43E6,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#4,1(a0)
		move.b	#$20,$19(a0) ; ' '
		move.b	#0,$1A(a0)
		move.b	#1,$18(a0)
		move.w	8(a0),$30(a0)
		move.w	$C(a0),$32(a0)

Obj16_Main:				; DATA XREF: ROM:00015114o
		move.w	8(a0),-(sp)
		bsr.w	sub_15184
		moveq	#0,d1
		move.b	$19(a0),d1
		move.w	#$FFD8,d3
		move.w	(sp)+,d4
		bsr.w	sub_F78A
		move.w	$30(a0),d0
		move.w	8(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_152AA
		bra.w	loc_152A4

; =============== S U B R O U T I N E ==========================================


sub_15184:				; CODE XREF: ROM:00015154p
		moveq	#0,d0
		move.b	$28(a0),d0
		andi.w	#$F,d0
		add.w	d0,d0
		move.w	Obj16_SubIndex(pc,d0.w),d1
		jmp	Obj16_SubIndex(pc,d1.w)
; End of function sub_15184

; ===============================================================================
Obj16_SubIndex:	dc.w Obj16_InitMove-Obj16_SubIndex ; DATA XREF:	ROM:Obj16_SubIndexo
					; ROM:0001519Ao ...
		dc.w Obj16_Move-Obj16_SubIndex
		dc.w Obj16_NoMove-Obj16_SubIndex
; ===============================================================================

Obj16_InitMove:				; DATA XREF: ROM:Obj16_SubIndexo
		move.b	$22(a0),d0
		andi.b	#$18,d0
		beq.s	locret_151BE
		addq.b	#1,$28(a0)
		move.w	#$200,$10(a0)
		move.w	#$100,$12(a0)
		move.w	#$A0,$34(a0) ; ''

locret_151BE:				; CODE XREF: ROM:000151A6j
		rts
; ===============================================================================

Obj16_Move:				; DATA XREF: ROM:0001519Ao
		bsr.w	j_SpeedToPos_0
		subq.w	#1,$34(a0)
		bne.s	locret_151CE
		addq.b	#1,$28(a0)

locret_151CE:				; CODE XREF: ROM:000151C8j
		rts
; ===============================================================================

Obj16_NoMove:				; DATA XREF: ROM:0001519Co
		rts
; ===============================================================================
Map_Obj16:	dc.w word_151DA-Map_Obj16 ; DATA XREF: ROM:000093E0o
					; ROM:000093EAo ...
		dc.w word_1522C-Map_Obj16
		dc.w word_15246-Map_Obj16
		dc.w word_15260-Map_Obj16
word_151DA:	dc.w $A			; DATA XREF: ROM:Map_Obj16o
		dc.w $C105,    0,    0,$FFE4; 0
		dc.w $D003,    4,    2,$FFE6; 4
		dc.w $F003,    4,    2,$FFE6; 8
		dc.w $1001,    8,    4,$FFE7; 12
		dc.w $D505,   $A,    5,	  $C; 16
		dc.w $E003,   $E,    7,	 $11; 20
		dc.w $1001,  $12,    9,	 $11; 24
		dc.w	 3,   $E,    7,	 $11; 28
		dc.w $200D,  $14,   $A,$FFE0; 32
		dc.w $200D, $814, $80A,	   0; 36
word_1522C:	dc.w 3			; DATA XREF: ROM:000151D4o
		dc.w $D805,  $1C,   $E,$FFF8; 0
		dc.w $E807,  $20,  $10,$FFF8; 4
		dc.w  $807,  $20,  $10,$FFF8; 8
word_15246:	dc.w 3			; DATA XREF: ROM:000151D6o
		dc.w $D805,  $28,  $14,$FFF8; 0
		dc.w $E807, $820, $810,$FFF8; 4
		dc.w  $807, $820, $810,$FFF8; 8
word_15260:	dc.w 8			; DATA XREF: ROM:000151D8o
		dc.w $C905,    0,    0,$FFE4; 0
		dc.w $D803,    4,    2,$FFE6; 4
		dc.w $F803,    4,    2,$FFE6; 8
		dc.w $1801,  $2C,  $16,$FFE6; 12
		dc.w $DD05,   $A,    5,	  $C; 16
		dc.w $E803,   $E,    7,	 $11; 20
		dc.w $2001,  $2E,  $17,	 $11; 24
		dc.w  $803,   $E,    7,	 $11; 28
; ===============================================================================
		nop

loc_152A4:				; CODE XREF: ROM:00015180j
		jmp	DisplaySprite
; ===============================================================================

loc_152AA:				; CODE XREF: ROM:0001517Cj
		jmp	DeleteObject
; ===============================================================================

j_SpeedToPos_0:				; CODE XREF: ROM:Obj16_Movep
		jmp	SpeedToPos
; ===============================================================================
		align 4
;----------------------------------------------------
; Object 19 - CPZ platforms moving side	to side
;----------------------------------------------------

Obj19:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj19_Index(pc,d0.w),d1
		jmp	Obj19_Index(pc,d1.w)
; ===============================================================================
Obj19_Index:	dc.w Obj19_Init-Obj19_Index ; DATA XREF: ROM:Obj19_Indexo
					; ROM:000152C8o
		dc.w Obj19_Main-Obj19_Index
Obj19_WidthArray:dc.w $2000		 ; 0
		dc.w $2001		; 1
		dc.w $2002		; 2
		dc.w $4003		; 3
		dc.w $3004		; 4
; ===============================================================================

Obj19_Init:				; DATA XREF: ROM:Obj19_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj19,4(a0)
		move.w	#$6400,2(a0)
		bsr.w	ModifySpriteAttr_2P
		move.b	#4,1(a0)
		moveq	#0,d0
		move.b	$28(a0),d0
		lsr.w	#3,d0
		andi.w	#$1E,d0
		lea	Obj19_WidthArray(pc,d0.w),a2
		move.b	(a2)+,$19(a0)
		move.b	(a2)+,$1A(a0)
		move.b	#4,$18(a0)
		move.w	8(a0),$30(a0)
		move.w	$C(a0),$32(a0)
		andi.b	#$F,$28(a0)

Obj19_Main:				; DATA XREF: ROM:000152C8o
		move.w	8(a0),-(sp)
		bsr.w	Obj19_Modes
		moveq	#0,d1
		move.b	$19(a0),d1
		move.w	#$10,d3
		move.w	(sp)+,d4
		bsr.w	sub_F78A
		move.w	$30(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_154C6
		bra.w	loc_154C0

; =============== S U B R O U T I N E ==========================================


Obj19_Modes:				; CODE XREF: ROM:00015324p
		moveq	#0,d0
		move.b	$28(a0),d0
		andi.w	#$F,d0
		add.w	d0,d0
		move.w	Obj19_SubIndex(pc,d0.w),d1
		jmp	Obj19_SubIndex(pc,d1.w)
; End of function Obj19_Modes

; ===============================================================================
Obj19_SubIndex:	dc.w locret_1537A-Obj19_SubIndex ; DATA	XREF: ROM:Obj19_SubIndexo
					; ROM:00015366o ...
		dc.w loc_1537C-Obj19_SubIndex
		dc.w loc_1539C-Obj19_SubIndex
		dc.w loc_153AC-Obj19_SubIndex
		dc.w loc_1539C-Obj19_SubIndex
		dc.w loc_153CC-Obj19_SubIndex
		dc.w loc_153EC-Obj19_SubIndex
		dc.w loc_1540E-Obj19_SubIndex
		dc.w loc_15430-Obj19_SubIndex
		dc.w loc_1539C-Obj19_SubIndex
		dc.w loc_15450-Obj19_SubIndex
; ===============================================================================

locret_1537A:				; DATA XREF: ROM:Obj19_SubIndexo
		rts
; ===============================================================================

loc_1537C:				; DATA XREF: ROM:00015366o
		move.b	(RAM_RandomTimers_Buff+$E).w,d0
		move.w	#$60,d1	; '`'
		btst	#0,$22(a0)
		beq.s	loc_15390
		neg.w	d0
		add.w	d1,d0

loc_15390:				; CODE XREF: ROM:0001538Aj
		move.w	$30(a0),d1
		sub.w	d0,d1
		move.w	d1,8(a0)
		rts
; ===============================================================================

loc_1539C:				; DATA XREF: ROM:00015368o
					; ROM:0001536Co ...
		move.b	$22(a0),d0
		andi.b	#$18,d0
		beq.s	locret_153AA
		addq.b	#1,$28(a0)

locret_153AA:				; CODE XREF: ROM:000153A4j
		rts
; ===============================================================================

loc_153AC:				; DATA XREF: ROM:0001536Ao
		moveq	#0,d3
		move.b	$19(a0),d3
		bsr.w	ObjHitWallRight
		tst.w	d1
		bmi.s	loc_153C6
		addq.w	#1,8(a0)
		move.w	8(a0),$30(a0)
		rts
; ===============================================================================

loc_153C6:				; CODE XREF: ROM:000153B8j
		clr.b	$28(a0)
		rts
; ===============================================================================

loc_153CC:				; DATA XREF: ROM:0001536Eo
		moveq	#0,d3
		move.b	$19(a0),d3
		bsr.w	ObjHitWallRight
		tst.w	d1
		bmi.s	loc_153E6
		addq.w	#1,8(a0)
		move.w	8(a0),$30(a0)
		rts
; ===============================================================================

loc_153E6:				; CODE XREF: ROM:000153D8j
		addq.b	#1,$28(a0)
		rts
; ===============================================================================

loc_153EC:				; DATA XREF: ROM:00015370o
		bsr.w	j_SpeedToPos_1
		addi.w	#$18,$12(a0)
		bsr.w	ObjHitFloor
		tst.w	d1
		bpl.w	locret_1540C
		add.w	d1,$C(a0)
		clr.w	$12(a0)
		clr.b	$28(a0)

locret_1540C:				; CODE XREF: ROM:000153FCj
		rts
; ===============================================================================

loc_1540E:				; DATA XREF: ROM:00015372o
		tst.b	(RAM_Level_Switches+$2).w
		beq.s	loc_15418
		subq.b	#3,$28(a0)

loc_15418:				; CODE XREF: ROM:00015412j
		addq.l	#6,sp
		move.w	$30(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_154C6
		rts
; ===============================================================================

loc_15430:				; DATA XREF: ROM:00015374o
		move.b	(RAM_RandomTimers_Buff+$1E).w,d0
		move.w	#$80,d1
		btst	#0,$22(a0)
		beq.s	loc_15444
		neg.w	d0
		add.w	d1,d0

loc_15444:				; CODE XREF: ROM:0001543Ej
		move.w	$32(a0),d1
		sub.w	d0,d1
		move.w	d1,$C(a0)
		rts
; ===============================================================================

loc_15450:				; DATA XREF: ROM:00015378o
		moveq	#0,d3
		move.b	$19(a0),d3
		add.w	d3,d3
		moveq	#8,d1
		btst	#0,$22(a0)
		beq.s	loc_15466
		neg.w	d1
		neg.w	d3

loc_15466:				; CODE XREF: ROM:00015460j
		tst.w	$36(a0)
		bne.s	loc_15492
		move.w	8(a0),d0
		sub.w	$30(a0),d0
		cmp.w	d3,d0
		beq.s	loc_15484
		add.w	d1,8(a0)
		move.w	#$12C,$34(a0)
		rts
; ===============================================================================

loc_15484:				; CODE XREF: ROM:00015476j
		subq.w	#1,$34(a0)
		bne.s	locret_15490
		move.w	#1,$36(a0)

locret_15490:				; CODE XREF: ROM:00015488j
		rts
; ===============================================================================

loc_15492:				; CODE XREF: ROM:0001546Aj
		move.w	8(a0),d0
		sub.w	$30(a0),d0
		beq.s	loc_154A2
		sub.w	d1,8(a0)
		rts
; ===============================================================================

loc_154A2:				; CODE XREF: ROM:0001549Aj
		clr.w	$36(a0)
		subq.b	#1,$28(a0)
		rts
; ===============================================================================
Map_Obj19:	dc.w word_154AE-Map_Obj19 ; DATA XREF: ROM:000152D8o
					; ROM:Map_Obj19o ...
word_154AE:	dc.w 2			; DATA XREF: ROM:Map_Obj19o
		dc.w $F00F,    0,    0,$FFE0; 0
		dc.w $F00F, $800, $800,	   0; 4
; ===============================================================================

loc_154C0:				; CODE XREF: ROM:0001534Cj
		jmp	DisplaySprite
; ===============================================================================

loc_154C6:				; CODE XREF: ROM:00015348j
					; ROM:0001542Aj
		jmp	DeleteObject
; ===============================================================================

j_SpeedToPos_1:				; CODE XREF: ROM:loc_153ECp
		jmp	SpeedToPos
; ===============================================================================
		align 4
;----------------------------------------------------
; Object 04 - water surface
;----------------------------------------------------

Obj04:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj04_Index(pc,d0.w),d1
		jmp	Obj04_Index(pc,d1.w)
; ===============================================================================
Obj04_Index:	dc.w Obj04_Init-Obj04_Index ; DATA XREF: ROM:Obj04_Indexo
					; ROM:000154E4o
		dc.w Obj04_Main-Obj04_Index
; ===============================================================================

Obj04_Init:				; DATA XREF: ROM:Obj04_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj04,4(a0)
		move.w	#$8400,2(a0)
		bsr.w	j_ModifySpriteAttr_2P_0
		move.b	#4,1(a0)
		move.b	#$80,$19(a0)
		move.w	8(a0),$30(a0)

Obj04_Main:				; DATA XREF: ROM:000154E4o
		move.w	(RAM_Level_Water_Action).w,d1
		move.w	d1,$C(a0)
		tst.b	$32(a0)
		bne.s	loc_15530
		btst	#7,(RAM_Control_1_Press).w
		beq.s	loc_15540
		addq.b	#3,$1A(a0)
		move.b	#1,$32(a0)
		bra.s	loc_15540
; ===============================================================================

loc_15530:				; CODE XREF: ROM:0001551Aj
		tst.w	(RAM_Flag_LevelPaused).w
		bne.s	loc_15540
		move.b	#0,$32(a0)
		subq.b	#3,$1A(a0)

loc_15540:				; CODE XREF: ROM:00015522j
					; ROM:0001552Ej ...
		lea	(Obj04_FrameData).l,a1
		moveq	#0,d1
		move.b	$1B(a0),d1
		move.b	(a1,d1.w),$1A(a0)
		addq.b	#1,$1B(a0)
		andi.b	#$3F,$1B(a0) ; '?'
		bra.w	loc_15868
; ===============================================================================
Obj04_FrameData:dc.b   0,  1,  0,  1,  0,  1,  0,  1,  0,  1,  0,  1,  0,  1,  0,  1; 0
					; DATA XREF: ROM:loc_15540o
		dc.b   1,  2,  1,  2,  1,  2,  1,  2,  1,  2,  1,  2,  1,  2,  1,  2; 16
		dc.b   2,  1,  2,  1,  2,  1,  2,  1,  2,  1,  2,  1,  2,  1,  2,  1; 32
		dc.b   1,  0,  1,  0,  1,  0,  1,  0,  1,  0,  1,  0,  1,  0,  1,  0; 48
Map_Obj04:	dc.w word_155AC-Map_Obj04 ; DATA XREF: ROM:000154EAo
					; ROM:Map_Obj04o ...
		dc.w word_155C6-Map_Obj04
		dc.w word_155E0-Map_Obj04
		dc.w word_155FA-Map_Obj04
		dc.w word_1562C-Map_Obj04
		dc.w word_1565E-Map_Obj04
word_155AC:	dc.w 3			; DATA XREF: ROM:Map_Obj04o
		dc.w $F80D,    0,    0,$FFA0; 0
		dc.w $F80D,    0,    0,$FFE0; 4
		dc.w $F80D,    0,    0,	 $20; 8
word_155C6:	dc.w 3			; DATA XREF: ROM:000155A2o
		dc.w $F80D,    8,    4,$FFA0; 0
		dc.w $F80D,    8,    4,$FFE0; 4
		dc.w $F80D,    8,    4,	 $20; 8
word_155E0:	dc.w 3			; DATA XREF: ROM:000155A4o
		dc.w $F80D,  $10,    8,$FFA0; 0
		dc.w $F80D,  $10,    8,$FFE0; 4
		dc.w $F80D,  $10,    8,	 $20; 8
word_155FA:	dc.w 6			; DATA XREF: ROM:000155A6o
		dc.w $F80D,    0,    0,$FFA0; 0
		dc.w $F80D,    8,    4,$FFC0; 4
		dc.w $F80D,    0,    0,$FFE0; 8
		dc.w $F80D,    8,    4,	   0; 12
		dc.w $F80D,    0,    0,	 $20; 16
		dc.w $F80D,    8,    4,	 $40; 20
word_1562C:	dc.w 6			; DATA XREF: ROM:000155A8o
		dc.w $F80D,    8,    4,$FFA0; 0
		dc.w $F80D,  $10,    8,$FFC0; 4
		dc.w $F80D,    8,    4,$FFE0; 8
		dc.w $F80D,  $10,    8,	   0; 12
		dc.w $F80D,    8,    4,	 $20; 16
		dc.w $F80D,  $10,    8,	 $40; 20
word_1565E:	dc.w 6			; DATA XREF: ROM:000155AAo
		dc.w $F80D,  $10,    8,$FFA0; 0
		dc.w $F80D,    8,    4,$FFC0; 4
		dc.w $F80D,  $10,    8,$FFE0; 8
		dc.w $F80D,    8,    4,	   0; 12
		dc.w $F80D,  $10,    8,	 $20; 16
		dc.w $F80D,    8,    4,	 $40; 20
; ===============================================================================
;----------------------------------------------------
; Object 49 - EHZ waterfalls
;----------------------------------------------------

Obj49:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj49_Index(pc,d0.w),d1
		jmp	Obj49_Index(pc,d1.w)
; ===============================================================================
Obj49_Index:	dc.w Obj49_Init-Obj49_Index
		dc.w Obj49_Main-Obj49_Index
; ===============================================================================

Obj49_Init:				; DATA XREF: ROM:Obj49_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj49,4(a0)
		move.w	#$23AE,2(a0)
		bsr.w	j_ModifySpriteAttr_2P_0
		move.b	#4,1(a0)
		move.b	#$20,$19(a0) ; ' '
		move.w	8(a0),$30(a0)
		move.b	#0,$18(a0)
		move.b	#$80,$16(a0)
		bset	#4,1(a0)

Obj49_Main:				; DATA XREF: ROM:000156A0o
		tst.w	(RAM_Flag_SplitScreen).w
		bne.s	loc_156F6
		move.w	8(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_1586E

loc_156F6:				; CODE XREF: ROM:000156E0j
		move.w	8(a0),d1
		move.w	d1,d2
		subi.w	#$40,d1	; '@'
		addi.w	#$40,d2	; '@'
		move.b	$28(a0),d3
		move.b	#0,$1A(a0)
		move.w	(RAM_ObjRam_Sonic+$8).w,d0
		cmp.w	d1,d0
		bcs.s	loc_15728
		cmp.w	d2,d0
		bcc.s	loc_15728
		move.b	#1,$1A(a0)
		add.b	d3,$1A(a0)
		bra.w	loc_15868
; ===============================================================================

loc_15728:
		move.w	(RAM_ObjRam_Tails+$8).w,d0
		cmp.w	d1,d0
		bcs.s	loc_1573A
		cmp.w	d2,d0
		bcc.s	loc_1573A
		move.b	#1,$1A(a0)

loc_1573A:				; CODE XREF: ROM:0001572Ej
					; ROM:00015732j
		add.b	d3,$1A(a0)
		bra.w	loc_15868
; ===============================================================================
Map_Obj49:	dc.w word_1574E-Map_Obj49
		dc.w word_15760-Map_Obj49
		dc.w word_157F2-Map_Obj49
		dc.w word_157F4-Map_Obj49
		dc.w word_157F2-Map_Obj49
		dc.w word_15816-Map_Obj49
word_1574E:	dc.w 2			; DATA XREF: ROM:Map_Obj49o
		dc.w $800D,    0,    0,$FFE0; 0
		dc.w $800D,    0,    0,	   0; 4
word_15760:	dc.w $12		; DATA XREF: ROM:00015744o
		dc.w $800D,    0,    0,$FFE0; 0
		dc.w $800D,    0,    0,	   0; 4
		dc.w $800F,    8,    4,$FFE0; 8
		dc.w $800F,    8,    4,	   0; 12
		dc.w $A00F,    8,    4,$FFE0; 16
		dc.w $A00F,    8,    4,	   0; 20
		dc.w $C00F,    8,    4,$FFE0; 24
		dc.w $C00F,    8,    4,	   0; 28
		dc.w $E00F,    8,    4,$FFE0; 32
		dc.w $E00F,    8,    4,	   0; 36
		dc.w	$F,    8,    4,$FFE0; 40
		dc.w	$F,    8,    4,	   0; 44
		dc.w $200F,    8,    4,$FFE0; 48
		dc.w $200F,    8,    4,	   0; 52
		dc.w $400F,    8,    4,$FFE0; 56
		dc.w $400F,    8,    4,	   0; 60
		dc.w $600F,    8,    4,$FFE0; 64
		dc.w $600F,    8,    4,	   0; 68
word_157F2:	dc.w 0			; DATA XREF: ROM:00015746o
					; ROM:0001574Ao
word_157F4:	dc.w 4			; DATA XREF: ROM:00015748o
		dc.w $E00F,    8,    4,$FFE0; 0
		dc.w $E00F,    8,    4,	   0; 4
		dc.w	$F,    8,    4,$FFE0; 8
		dc.w	$F,    8,    4,	   0; 12
word_15816:	dc.w $A			; DATA XREF: ROM:0001574Co
		dc.w $C00F,    8,    4,$FFE0; 0
		dc.w $C00F,    8,    4,	   0; 4
		dc.w $E00F,    8,    4,$FFE0; 8
		dc.w $E00F,    8,    4,	   0; 12
		dc.w	$F,    8,    4,$FFE0; 16
		dc.w	$F,    8,    4,	   0; 20
		dc.w $200F,    8,    4,$FFE0; 24
		dc.w $200F,    8,    4,	   0; 28
		dc.w $400F,    8,    4,$FFE0; 32
		dc.w $400F,    8,    4,	   0; 36
; ===============================================================================

loc_15868:				; CODE XREF: ROM:0001555Cj
					; ROM:00015724j ...
		jmp	DisplaySprite
; ===============================================================================

loc_1586E:				; CODE XREF: ROM:000156F2j
		jmp	DeleteObject
; ===============================================================================

j_ModifySpriteAttr_2P_0:		; CODE XREF: ROM:000154F8p
					; ROM:000156B4p
		jmp	ModifySpriteAttr_2P
; ===============================================================================
		align 4
;----------------------------------------------------
; Object 4D - Rhinobot badnik
;----------------------------------------------------

Obj4D:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj4D_Index(pc,d0.w),d1
		jmp	Obj4D_Index(pc,d1.w)
; ===============================================================================
Obj4D_Index:	dc.w Obj4D_Init-Obj4D_Index ; DATA XREF: ROM:Obj4D_Indexo
					; ROM:0001588Co
		dc.w Obj4D_Main-Obj4D_Index
; ===============================================================================

Obj4D_Init:				; DATA XREF: ROM:Obj4D_Indexo
		move.l	#Map_Obj4D,4(a0)
		move.w	#$23C4,2(a0)
		ori.b	#4,1(a0)
		move.b	#$A,$20(a0)
		move.b	#4,$18(a0)
		move.b	#$18,$19(a0)
		move.b	#$10,$16(a0)
		move.b	#$18,$17(a0)
		bsr.w	j_ObjectFall_0
		jsr	ObjHitFloor
		tst.w	d1
		bpl.s	locret_158DC
		add.w	d1,$C(a0)
		move.w	#0,$12(a0)
		addq.b	#2,$24(a0)

locret_158DC:				; CODE XREF: ROM:000158CCj
		rts
; ===============================================================================

Obj4D_Main:				; DATA XREF: ROM:0001588Co
		moveq	#0,d0
		move.b	$25(a0),d0
		move.w	Obj4D_SubIndex(pc,d0.w),d1
		jsr	Obj4D_SubIndex(pc,d1.w)
		lea	(Ani_Obj4D).l,a1
		bsr.w	j_AnimateSprite_0
		bra.w	loc_15B38
; ===============================================================================
Obj4D_SubIndex:	dc.w loc_158FE-Obj4D_SubIndex ;	DATA XREF: ROM:Obj4D_SubIndexo
					; ROM:000158FCo
		dc.w loc_15922-Obj4D_SubIndex
; ===============================================================================

loc_158FE:				; DATA XREF: ROM:Obj4D_SubIndexo
		subq.w	#1,$30(a0)
		bpl.s	locret_15920
		addq.b	#2,$25(a0)
		move.w	#$FF80,$10(a0)
		move.b	#0,$1C(a0)
		bchg	#0,$22(a0)
		bne.s	locret_15920
		neg.w	$10(a0)

locret_15920:				; CODE XREF: ROM:00015902j
					; ROM:0001591Aj
		rts
; ===============================================================================

loc_15922:				; DATA XREF: ROM:000158FCo
		bsr.w	sub_1596C
		bsr.w	j_ObjectFall_0
		jsr	ObjHitFloor
		cmpi.w	#$FFF8,d1
		blt.s	loc_15948
		cmpi.w	#$C,d1
		bge.s	locret_15946
		move.w	#0,$12(a0)
		add.w	d1,$C(a0)

locret_15946:				; CODE XREF: ROM:0001593Aj
		rts
; ===============================================================================

loc_15948:				; CODE XREF: ROM:00015934j
		subq.b	#2,$25(a0)
		move.w	#$3B,$30(a0) ; ';'
		move.w	$10(a0),d0
		ext.l	d0
		asl.l	#8,d0
		sub.l	d0,8(a0)
		move.w	#0,$10(a0)
		move.b	#1,$1C(a0)
		rts

; =============== S U B R O U T I N E ==========================================


sub_1596C:				; CODE XREF: ROM:loc_15922p
		move.w	8(a0),d0
		sub.w	(RAM_ObjRam_Sonic+$8).w,d0
		bmi.s	loc_159A0
		cmpi.w	#$60,d0	; '`'
		bgt.s	locret_15990
		btst	#0,$22(a0)
		bne.s	loc_15992
		move.b	#2,$1C(a0)
		move.w	#$FE00,$10(a0)

locret_15990:				; CODE XREF: sub_1596C+Ej
					; sub_1596C+38j
		rts
; ===============================================================================

loc_15992:				; CODE XREF: sub_1596C+16j
		move.b	#0,$1C(a0)
		move.w	#$80,$10(a0) ; ''
		rts
; ===============================================================================

loc_159A0:				; CODE XREF: sub_1596C+8j
		cmpi.w	#$FFA0,d0
		blt.s	locret_15990
		btst	#0,$22(a0)
		beq.s	loc_159BC
		move.b	#2,$1C(a0)
		move.w	#$200,$10(a0)
		rts
; ===============================================================================

loc_159BC:				; CODE XREF: sub_1596C+40j
		move.b	#0,$1C(a0)
		move.w	#$FF80,$10(a0)
		rts
; End of function sub_1596C

; ===============================================================================
Ani_Obj4D:	dc.w byte_159D0-Ani_Obj4D ; DATA XREF: ROM:000158ECo
					; ROM:Ani_Obj4Do ...
		dc.w byte_159DE-Ani_Obj4D
		dc.w byte_159E1-Ani_Obj4D
byte_159D0:	dc.b   2,  0,  0,  0,  3,  3,  4,  1,  1,  2,  5,  5,  5,$FF; 0
					; DATA XREF: ROM:Ani_Obj4Do
byte_159DE:	dc.b  $F,  0,$FF	; 0 ; DATA XREF: ROM:000159CCo
byte_159E1:	dc.b   2,  6,  7,$FF,  0; 0 ; DATA XREF: ROM:000159CEo
Map_Obj4D:	dc.w word_159F6-Map_Obj4D ; DATA XREF: ROM:Obj4D_Inito
					; ROM:Map_Obj4Do ...
		dc.w word_15A20-Map_Obj4D
		dc.w word_15A4A-Map_Obj4D
		dc.w word_15A74-Map_Obj4D
		dc.w word_15A9E-Map_Obj4D
		dc.w word_15AC8-Map_Obj4D
		dc.w word_15AF2-Map_Obj4D
		dc.w word_15B14-Map_Obj4D
word_159F6:	dc.w 5			; DATA XREF: ROM:Map_Obj4Do
		dc.w $F005,    0,    0,$FFF0; 0
		dc.w $F005,    4,    2,	   0; 4
		dc.w $F801,    8,    4,$FFE8; 8
		dc.w	 5,   $A,    5,$FFF0; 12
		dc.w	 9,  $22,  $11,	   0; 16
word_15A20:	dc.w 5			; DATA XREF: ROM:000159E8o
		dc.w $F005,    0,    0,$FFF0; 0
		dc.w $F005,    4,    2,	   0; 4
		dc.w $F801,    8,    4,$FFE8; 8
		dc.w	 5,   $E,    7,$FFF0; 12
		dc.w	 9,  $22,  $11,	   0; 16
word_15A4A:	dc.w 5			; DATA XREF: ROM:000159EAo
		dc.w $F005,    0,    0,$FFF0; 0
		dc.w $F005,    4,    2,	   0; 4
		dc.w $F801,    8,    4,$FFE8; 8
		dc.w	 5,  $12,    9,$FFF0; 12
		dc.w	 9,  $22,  $11,	   0; 16
word_15A74:	dc.w 5			; DATA XREF: ROM:000159ECo
		dc.w $F005,    0,    0,$FFF0; 0
		dc.w $F005,    4,    2,	   0; 4
		dc.w $F801,    8,    4,$FFE8; 8
		dc.w	 5,   $A,    5,$FFF0; 12
		dc.w	 9,  $28,  $14,	   0; 16
word_15A9E:	dc.w 5			; DATA XREF: ROM:000159EEo
		dc.w $F005,    0,    0,$FFF0; 0
		dc.w $F005,    4,    2,	   0; 4
		dc.w $F801,    8,    4,$FFE8; 8
		dc.w	 5,   $E,    7,$FFF0; 12
		dc.w	 9,  $28,  $14,	   0; 16
word_15AC8:	dc.w 5			; DATA XREF: ROM:000159F0o
		dc.w $F005,    0,    0,$FFF0; 0
		dc.w $F005,    4,    2,	   0; 4
		dc.w $F801,    8,    4,$FFE8; 8
		dc.w	 5,  $12,    9,$FFF0; 12
		dc.w	 9,  $28,  $14,	   0; 16
word_15AF2:	dc.w 4			; DATA XREF: ROM:000159F2o
		dc.w $F00B,  $16,   $B,$FFE8; 0
		dc.w $F005,    4,    2,	   0; 4
		dc.w	 9,  $22,  $11,	   0; 8
		dc.w $FB01,  $2E,  $17,	 $1A; 12
word_15B14:	dc.w 4			; DATA XREF: ROM:000159F4o
		dc.w $F00B,  $16,   $B,$FFE8; 0
		dc.w $F005,    4,    2,	   0; 4
		dc.w	 9,  $28,  $14,	   0; 8
		dc.w $FB01,  $30,  $18,	 $1A; 12
		align 4

loc_15B38:				; CODE XREF: ROM:000158F6j
		jmp	MarkObjGone
; ===============================================================================

j_AnimateSprite_0:			; CODE XREF: ROM:000158F2p
		jmp	AnimateSprite
; ===============================================================================

j_ObjectFall_0:				; CODE XREF: ROM:000158C0p
					; ROM:00015926p
		jmp	ObjectFall
; ===============================================================================
		align 4
;----------------------------------------------------
; Object 52 - Piranha badnik
;----------------------------------------------------

Obj52:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj52_Index(pc,d0.w),d1
		jmp	Obj52_Index(pc,d1.w)
; ===============================================================================
Obj52_Index:	dc.w Obj52_Init-Obj52_Index ; DATA XREF: ROM:Obj52_Indexo
					; ROM:00015B5Co ...
		dc.w Obj52_Main-Obj52_Index
		dc.w loc_15C48-Obj52_Index
; ===============================================================================

Obj52_Init:				; DATA XREF: ROM:Obj52_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj52,4(a0)
		move.w	#$2530,2(a0)
		ori.b	#4,1(a0)
		move.b	#$A,$20(a0)
		move.b	#4,$18(a0)
		move.b	#$10,$19(a0)
		moveq	#0,d0
		move.b	$28(a0),d0
		move.b	d0,d1
		andi.w	#$F0,d1	; ''
		add.w	d1,d1
		add.w	d1,d1
		move.w	d1,$3A(a0)
		move.w	d1,$3C(a0)
		andi.w	#$F,d0
		lsl.w	#6,d0
		subq.w	#1,d0
		move.w	d0,$30(a0)
		move.w	d0,$32(a0)
		move.w	#$FF80,$10(a0)
		move.l	#$FFFB8000,$36(a0)
		move.w	$C(a0),$34(a0)
		bset	#6,$22(a0)
		btst	#0,$22(a0)
		beq.s	Obj52_Main
		neg.w	$10(a0)

Obj52_Main:				; CODE XREF: ROM:00015BD2j
					; DATA XREF: ROM:00015B5Co
		cmpi.w	#$FFFF,$3A(a0)
		beq.s	loc_15BE4
		subq.w	#1,$3A(a0)

loc_15BE4:				; CODE XREF: ROM:00015BDEj
		subq.w	#1,$30(a0)
		bpl.s	loc_15C06
		move.w	$32(a0),$30(a0)
		neg.w	$10(a0)
		bchg	#0,$22(a0)
		move.b	#1,$1D(a0)
		move.w	$3C(a0),$3A(a0)

loc_15C06:				; CODE XREF: ROM:00015BE8j
		lea	(Ani_Obj52).l,a1
		bsr.w	j_AnimateSprite_1
		bsr.w	j_SpeedToPos_2
		tst.w	$3A(a0)
		bgt.w	loc_15D90
		cmpi.w	#$FFFF,$3A(a0)
		beq.w	loc_15D90
		move.l	#$FFFB8000,$36(a0)
		addq.b	#2,$24(a0)
		move.w	#$FFFF,$3A(a0)
		move.b	#2,$1C(a0)
		move.w	#1,$3E(a0)
		bra.w	loc_15D90
; ===============================================================================

loc_15C48:				; DATA XREF: ROM:00015B5Eo
		move.w	#$390,(RAM_Level_Water_Action).w
		lea	(Ani_Obj52).l,a1
		bsr.w	j_AnimateSprite_1
		move.w	$3E(a0),d0
		sub.w	d0,$30(a0)
		bsr.w	sub_15CF8
		tst.l	$36(a0)
		bpl.s	loc_15CA0
		move.w	$C(a0),d0
		cmp.w	(RAM_Level_Water_Action).w,d0
		bgt.w	loc_15D90
		move.b	#3,$1C(a0)
		bclr	#6,$22(a0)
		tst.b	$2A(a0)
		bne.w	loc_15D90
		move.w	$10(a0),d0
		asl.w	#1,d0
		move.w	d0,$10(a0)
		addq.w	#1,$3E(a0)
		st	$2A(a0)
		bra.w	loc_15D90
; ===============================================================================

loc_15CA0:				; CODE XREF: ROM:00015C68j
		move.w	$C(a0),d0
		cmp.w	(RAM_Level_Water_Action).w,d0
		bgt.s	loc_15CB4
		move.b	#1,$1C(a0)
		bra.w	loc_15D90
; ===============================================================================

loc_15CB4:				; CODE XREF: ROM:00015CA8j
		move.b	#0,$1C(a0)
		bset	#6,$22(a0)
		bne.s	loc_15CCE
		move.l	$36(a0),d0
		asr.l	#1,d0
		move.l	d0,$36(a0)
		nop

loc_15CCE:				; CODE XREF: ROM:00015CC0j
		move.w	$34(a0),d0
		cmp.w	$C(a0),d0
		bgt.w	loc_15D90
		subq.b	#2,$24(a0)
		tst.b	$2A(a0)
		beq.w	loc_15D90
		move.w	$10(a0),d0
		asr.w	#1,d0
		move.w	d0,$10(a0)
		sf	$2A(a0)
		bra.w	loc_15D90

; =============== S U B R O U T I N E ==========================================


sub_15CF8:				; CODE XREF: ROM:00015C60p
		move.l	8(a0),d2
		move.l	$C(a0),d3
		move.w	$10(a0),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,d2
		add.l	$36(a0),d3
		btst	#6,$22(a0)
		beq.s	loc_15D34
		tst.l	$36(a0)
		bpl.s	loc_15D2C
		addi.l	#$1000,$36(a0)
		addi.l	#$1000,$36(a0)

loc_15D2C:				; CODE XREF: sub_15CF8+22j
		subi.l	#$1000,$36(a0)

loc_15D34:				; CODE XREF: sub_15CF8+1Cj
		addi.l	#$1800,$36(a0)
		move.l	d2,8(a0)
		move.l	d3,$C(a0)
		rts
; End of function sub_15CF8

; ===============================================================================
Ani_Obj52:	dc.w byte_15D4E-Ani_Obj52 ; DATA XREF: ROM:loc_15C06o
					; ROM:00015C4Eo ...
		dc.w byte_15D52-Ani_Obj52
		dc.w byte_15D56-Ani_Obj52
		dc.w byte_15D5A-Ani_Obj52
byte_15D4E:	dc.b  $E,  0,  1,$FF	; 0 ; DATA XREF: ROM:Ani_Obj52o
byte_15D52:	dc.b   3,  0,  1,$FF	; 0 ; DATA XREF: ROM:00015D48o
byte_15D56:	dc.b  $E,  2,  3,$FF	; 0 ; DATA XREF: ROM:00015D4Ao
byte_15D5A:	dc.b   3,  2,  3,$FF	; 0 ; DATA XREF: ROM:00015D4Co
Map_Obj52:	dc.w word_15D66-Map_Obj52 ; DATA XREF: ROM:00015B64o
					; ROM:Map_Obj52o ...
		dc.w word_15D70-Map_Obj52
		dc.w word_15D7A-Map_Obj52
		dc.w word_15D84-Map_Obj52
word_15D66:	dc.w 1			; DATA XREF: ROM:Map_Obj52o
		dc.w $F00F,    0,    0,$FFF0; 0
word_15D70:	dc.w 1			; DATA XREF: ROM:00015D60o
		dc.w $F00F,  $10,    8,$FFF0; 0
word_15D7A:	dc.w 1			; DATA XREF: ROM:00015D62o
		dc.w $F00F,  $20,  $10,$FFF0; 0
word_15D84:	dc.w 1			; DATA XREF: ROM:00015D64o
		dc.w $F00F,  $30,  $18,$FFF0; 0
		align 4

loc_15D90:				; CODE XREF: ROM:00015C18j
					; ROM:00015C22j ...
		jmp	MarkObjGone
; ===============================================================================

j_AnimateSprite_1:			; CODE XREF: ROM:00015C0Cp
					; ROM:00015C54p
		jmp	AnimateSprite
; ===============================================================================

j_SpeedToPos_2:				; CODE XREF: ROM:00015C10p
		jmp	SpeedToPos
; ===============================================================================
		align 4
;----------------------------------------------------
; Object 4F - Dinobot badnik
;----------------------------------------------------

Obj4F:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj4F_Index(pc,d0.w),d1
		jmp	Obj4F_Index(pc,d1.w)
; ===============================================================================
Obj4F_Index:	dc.w Obj4F_Init-Obj4F_Index ; DATA XREF: ROM:Obj4F_Indexo
					; ROM:00015DB4o ...
		dc.w Obj4F_Main-Obj4F_Index
		dc.w Obj4F_Delete-Obj4F_Index
; ===============================================================================

Obj4F_Init:				; DATA XREF: ROM:Obj4F_Indexo
		move.l	#Map_Obj4F,4(a0)
		move.w	#$500,2(a0)
		move.b	#4,1(a0)
		move.b	#4,$18(a0)
		move.b	#$10,$19(a0)
		move.b	#$10,$16(a0)
		move.b	#6,$17(a0)
		move.b	#$C,$20(a0)
		bsr.w	j_ObjectFall_1
		jsr	ObjHitFloor
		tst.w	d1
		bpl.s	locret_15E0C
		add.w	d1,$C(a0)

loc_15DFC:
		move.w	#0,$12(a0)
		addq.b	#2,$24(a0)
		bchg	#0,$22(a0)

locret_15E0C:				; CODE XREF: ROM:00015DF6j
		rts
; ===============================================================================

Obj4F_Main:				; DATA XREF: ROM:00015DB4o
		moveq	#0,d0
		move.b	$25(a0),d0
		move.w	Obj4F_SubIndex(pc,d0.w),d1
		jsr	Obj4F_SubIndex(pc,d1.w)
		lea	(Ani_Obj4F).l,a1
		bsr.w	j_AnimateSprite_2
		move.w	8(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_15E3E
		bra.w	loc_15EE8
; ===============================================================================

loc_15E3E:				; CODE XREF: ROM:00015E36j
		lea	(RAM_ObjRespawnTbl).w,a2
		moveq	#0,d0
		move.b	$23(a0),d0
		beq.s	loc_15E50
		bclr	#7,2(a2,d0.w)

loc_15E50:				; CODE XREF: ROM:00015E48j
		bra.w	j_DeleteObject
; ===============================================================================
Obj4F_SubIndex:	dc.w loc_15E58-Obj4F_SubIndex ;	DATA XREF: ROM:Obj4F_SubIndexo
					; ROM:00015E56o
		dc.w loc_15E7C-Obj4F_SubIndex
; ===============================================================================

loc_15E58:				; DATA XREF: ROM:Obj4F_SubIndexo
		subq.w	#1,$30(a0)
		bpl.s	locret_15E7A
		addq.b	#2,$25(a0)
		move.w	#$FF80,$10(a0)
		move.b	#1,$1C(a0)
		bchg	#0,$22(a0)
		bne.s	locret_15E7A
		neg.w	$10(a0)

locret_15E7A:				; CODE XREF: ROM:00015E5Cj
					; ROM:00015E74j
		rts
; ===============================================================================

loc_15E7C:				; DATA XREF: ROM:00015E56o
		bsr.w	j_SpeedToPos_3
		jsr	ObjHitFloor
		cmpi.w	#$FFF8,d1
		blt.s	loc_15E98
		cmpi.w	#$C,d1
		bge.s	loc_15E98
		add.w	d1,$C(a0)
		rts
; ===============================================================================

loc_15E98:				; CODE XREF: ROM:00015E8Aj
					; ROM:00015E90j
		subq.b	#2,$25(a0)
		move.w	#$3B,$30(a0) ; ';'
		move.w	#0,$10(a0)
		move.b	#0,$1C(a0)
		rts
; ===============================================================================

Obj4F_Delete:				; DATA XREF: ROM:00015DB6o
		bra.w	j_DeleteObject
; ===============================================================================
Ani_Obj4F:	dc.w byte_15EB8-Ani_Obj4F ; DATA XREF: ROM:00015E1Co
					; ROM:Ani_Obj4Fo ...
		dc.w byte_15EBB-Ani_Obj4F
byte_15EB8:	dc.b   9,  1,$FF	; 0 ; DATA XREF: ROM:Ani_Obj4Fo
byte_15EBB:	dc.b   9,  0,  1,  2,  1,$FF,  0; 0 ; DATA XREF: ROM:00015EB6o
Map_Obj4F:	dc.w word_15EC8-Map_Obj4F ; DATA XREF: ROM:Obj4F_Inito
					; ROM:Map_Obj4Fo ...
		dc.w word_15ED2-Map_Obj4F
		dc.w word_15EDC-Map_Obj4F
word_15EC8:	dc.w 1			; DATA XREF: ROM:Map_Obj4Fo
		dc.w $F00F,    0,    0,$FFF0; 0
word_15ED2:	dc.w 1			; DATA XREF: ROM:00015EC4o
		dc.w $F00F,  $10,    8,$FFF0; 0
word_15EDC:	dc.w 1			; DATA XREF: ROM:00015EC6o
		dc.w $F00F,  $20,  $10,$FFF0; 0
		align 4

loc_15EE8:				; CODE XREF: ROM:00015E3Aj
		jmp	DisplaySprite
; ===============================================================================

j_DeleteObject:				; CODE XREF: ROM:loc_15E50j
					; ROM:Obj4F_Deletej
		jmp	DeleteObject
; ===============================================================================

j_AnimateSprite_2:			; CODE XREF: ROM:00015E22p
		jmp	AnimateSprite
; ===============================================================================

j_ObjectFall_1:				; CODE XREF: ROM:00015DEAp
		jmp	ObjectFall
; ===============================================================================

j_SpeedToPos_3:				; CODE XREF: ROM:loc_15E7Cp
		jmp	SpeedToPos
; ===============================================================================
		align 4
;----------------------------------------------------
; Object 50 - unused Seahorse badnik from HPZ
;----------------------------------------------------

Obj50:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj50_Index(pc,d0.w),d1
		jmp	Obj50_Index(pc,d1.w)
; ===============================================================================
Obj50_Index:	dc.w Obj50_Init-Obj50_Index ; DATA XREF: ROM:Obj50_Indexo
					; ROM:00015F18o ...
		dc.w loc_15FDA-Obj50_Index
		dc.w loc_16006-Obj50_Index
		dc.w loc_16030-Obj50_Index
		dc.w Obj50_Routine08-Obj50_Index
		dc.w Obj50_Routine0A-Obj50_Index
; ===============================================================================

Obj50_Init:				; DATA XREF: ROM:Obj50_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj50,4(a0)
		move.w	#$2570,2(a0)
		ori.b	#4,1(a0)
		move.b	#$A,$20(a0)
		move.b	#4,$18(a0)
		move.b	#$10,$19(a0)
		move.w	#$FF00,$10(a0)
		move.b	$28(a0),d0
		move.b	d0,d1
		andi.w	#$F0,d1	; ''
		lsl.w	#4,d1
		move.w	d1,$2E(a0)
		move.w	d1,$30(a0)
		andi.w	#$F,d0
		lsl.w	#4,d0
		subq.w	#1,d0
		move.w	d0,$32(a0)
		move.w	d0,$34(a0)
		move.w	$C(a0),$2A(a0)
		bsr.w	j_SingleObjectLoad
		bne.s	loc_15FDA
		move.b	#$50,0(a1) ; 'P'
		move.b	#4,$24(a1)
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		addi.w	#$A,8(a1)
		addi.w	#$FFFA,$C(a1)
		move.l	#Map_Obj50,4(a1)
		move.w	#$24E0,2(a1)
		ori.b	#4,1(a1)
		move.b	#3,$18(a1)
		move.b	$22(a0),$22(a1)
		move.b	#3,$1C(a1)
		move.l	a1,$36(a0)
		move.l	a0,$36(a1)
		bset	#6,$22(a0)

loc_15FDA:				; CODE XREF: ROM:00015F80j
					; DATA XREF: ROM:00015F18o
		lea	(Ani_Obj50).l,a1
		bsr.w	j_AnimateSprite_3
		move.w	#$39C,(RAM_Level_Water_Action).w
		moveq	#0,d0
		move.b	$25(a0),d0
		move.w	Obj50_SubIndex(pc,d0.w),d1
		jsr	Obj50_SubIndex(pc,d1.w)
		bsr.w	sub_161D8
		bra.w	loc_1677A
; ===============================================================================
Obj50_SubIndex:	dc.w loc_16046-Obj50_SubIndex ;	DATA XREF: ROM:Obj50_SubIndexo
					; ROM:00016002o ...
		dc.w loc_16058-Obj50_SubIndex
		dc.w loc_16066-Obj50_SubIndex
; ===============================================================================

loc_16006:				; DATA XREF: ROM:00015F1Ao
		movea.l	$36(a0),a1
		tst.b	(a1)
		beq.w	loc_1676E
		cmpi.b	#$50,(a1) ; 'P'
		bne.w	loc_1676E
		btst	#7,$22(a1)
		bne.w	loc_1676E
		lea	(Ani_Obj50).l,a1
		bsr.w	j_AnimateSprite_3
		bra.w	loc_16768
; ===============================================================================

loc_16030:				; DATA XREF: ROM:00015F1Co
		bsr.w	loc_162FC
		bsr.w	j_SpeedToPos_4
		lea	(Ani_Obj50).l,a1
		bsr.w	j_AnimateSprite_3
		bra.w	loc_1677A
; ===============================================================================

loc_16046:				; DATA XREF: ROM:Obj50_SubIndexo
		bsr.w	j_SpeedToPos_4
		bsr.w	sub_162DE
		bsr.w	sub_16184
		bsr.w	sub_1611C
		rts
; ===============================================================================

loc_16058:				; DATA XREF: ROM:00016002o
		bsr.w	j_SpeedToPos_4
		bsr.w	sub_162DE
		bsr.w	sub_161A6
		rts
; ===============================================================================

loc_16066:				; DATA XREF: ROM:00016004o
		bsr.w	j_ObjectFall_2
		bsr.w	sub_162DE
		bsr.w	sub_16078
		bsr.w	sub_160F4
		rts

; =============== S U B R O U T I N E ==========================================


sub_16078:				; CODE XREF: ROM:0001606Ep
		tst.b	$2D(a0)
		bne.s	locret_16084
		tst.w	$12(a0)
		bpl.s	loc_16086

locret_16084:				; CODE XREF: sub_16078+4j
		rts
; ===============================================================================

loc_16086:				; CODE XREF: sub_16078+Aj
		st	$2D(a0)
		bsr.w	j_SingleObjectLoad
		bne.s	locret_160F2
		move.b	#$50,0(a1) ; 'P'
		move.b	#6,$24(a1)
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		move.l	#Map_Obj50,4(a1)
		move.w	#$24E0,2(a1)
		ori.b	#4,1(a1)
		move.b	#3,$18(a1)
		move.b	#$E5,$20(a1)
		move.b	#2,$1C(a1)
		move.w	#$C,d0
		move.w	#$10,d1
		move.w	#$FD00,d2
		btst	#0,$22(a0)
		beq.s	loc_160E6
		neg.w	d1
		neg.w	d2

loc_160E6:				; CODE XREF: sub_16078+68j
		sub.w	d0,$C(a1)
		sub.w	d1,8(a1)
		move.w	d2,$10(a1)

locret_160F2:				; CODE XREF: sub_16078+16j
		rts
; End of function sub_16078


; =============== S U B R O U T I N E ==========================================


sub_160F4:				; CODE XREF: ROM:00016072p
		move.w	$C(a0),d0
		cmp.w	(RAM_Level_Water_Action).w,d0
		blt.s	locret_1611A
		move.b	#2,$25(a0)
		move.b	#0,$1C(a0)
		move.w	$30(a0),$2E(a0)
		move.w	#$40,$12(a0) ; '@'
		sf	$2D(a0)

locret_1611A:				; CODE XREF: sub_160F4+8j
		rts
; End of function sub_160F4


; =============== S U B R O U T I N E ==========================================


sub_1611C:				; CODE XREF: ROM:00016052p
		tst.b	$2C(a0)
		beq.s	locret_16182
		move.w	(RAM_ObjRam_Sonic+$8).w,d0
		move.w	(RAM_ObjRam_Sonic+$C).w,d1
		sub.w	$C(a0),d1
		bpl.s	locret_16182
		cmpi.w	#$FFD0,d1
		blt.s	locret_16182
		sub.w	8(a0),d0
		cmpi.w	#$48,d0	; 'H'
		bgt.s	locret_16182
		cmpi.w	#$FFB8,d0
		blt.s	locret_16182
		tst.w	d0
		bpl.s	loc_1615A
		cmpi.w	#$FFD8,d0
		bgt.s	locret_16182
		btst	#0,$22(a0)
		bne.s	locret_16182
		bra.s	loc_16168
; ===============================================================================

loc_1615A:				; CODE XREF: sub_1611C+2Cj
		cmpi.w	#$28,d0	; '('
		blt.s	locret_16182
		btst	#0,$22(a0)
		beq.s	locret_16182

loc_16168:				; CODE XREF: sub_1611C+3Cj
		moveq	#$20,d0	; ' '
		cmp.w	$32(a0),d0
		bgt.s	locret_16182
		move.b	#4,$25(a0)
		move.b	#1,$1C(a0)
		move.w	#$FC00,$12(a0)

locret_16182:				; CODE XREF: sub_1611C+4j
					; sub_1611C+12j ...
		rts
; End of function sub_1611C


; =============== S U B R O U T I N E ==========================================


sub_16184:				; CODE XREF: ROM:0001604Ep
		subq.w	#1,$2E(a0)
		bne.s	locret_161A4
		move.w	$30(a0),$2E(a0)
		addq.b	#2,$25(a0)
		move.w	#$FFC0,d0
		tst.b	$2C(a0)
		beq.s	loc_161A0
		neg.w	d0

loc_161A0:				; CODE XREF: sub_16184+18j
		move.w	d0,$12(a0)

locret_161A4:				; CODE XREF: sub_16184+4j
		rts
; End of function sub_16184


; =============== S U B R O U T I N E ==========================================


sub_161A6:				; CODE XREF: ROM:00016060p
		move.w	$C(a0),d0
		tst.b	$2C(a0)
		bne.s	loc_161C4
		cmp.w	(RAM_Level_Water_Action).w,d0
		bgt.s	locret_161C2
		subq.b	#2,$25(a0)
		st	$2C(a0)
		clr.w	$12(a0)

locret_161C2:				; CODE XREF: sub_161A6+Ej
					; sub_161A6+22j
		rts
; ===============================================================================

loc_161C4:				; CODE XREF: sub_161A6+8j
		cmp.w	$2A(a0),d0
		blt.s	locret_161C2
		subq.b	#2,$25(a0)
		sf	$2C(a0)
		clr.w	$12(a0)
		rts
; End of function sub_161A6


; =============== S U B R O U T I N E ==========================================


sub_161D8:				; CODE XREF: ROM:00015FF8p
		moveq	#$A,d0
		moveq	#$FFFFFFFA,d1
		movea.l	$36(a0),a1
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		move.b	$22(a0),$22(a1)
		move.b	$23(a0),$23(a1)
		move.b	1(a0),1(a1)
		btst	#0,$22(a1)
		beq.s	loc_16208
		neg.w	d0

loc_16208:				; CODE XREF: sub_161D8+2Cj
		add.w	d0,8(a1)
		add.w	d1,$C(a1)
		rts
; End of function sub_161D8

; ===============================================================================

Obj50_Routine08:			; DATA XREF: ROM:00015F1Eo
					; ROM:0001653At
		bsr.w	j_ObjectFall_2
		bsr.w	sub_16228
		lea	(Ani_Obj50).l,a1
		bsr.w	j_AnimateSprite_3
		bra.w	loc_1677A

; =============== S U B R O U T I N E ==========================================


sub_16228:				; CODE XREF: ROM:00016216p
		jsr	ObjHitFloor
		tst.w	d1
		bpl.s	loc_16242
		add.w	d1,$C(a0)
		move.w	$12(a0),d0
		asr.w	#1,d0
		neg.w	d0
		move.w	d0,$12(a0)

loc_16242:				; CODE XREF: sub_16228+8j
		subi.b	#1,$21(a0)
		beq.w	loc_1676E
		rts
; End of function sub_16228

; ===============================================================================

Obj50_Routine0A:			; DATA XREF: ROM:00015F20o
					; ROM:0001653Ct
		bsr.w	sub_1629E
		tst.b	$25(a0)
		beq.s	locret_1628E
		subi.w	#1,$2C(a0)
		beq.w	loc_1676E
		move.w	(RAM_ObjRam_Sonic+$8).w,8(a0)
		move.w	(RAM_ObjRam_Sonic+$C).w,$C(a0)
		addi.w	#$C,$C(a0)
		subi.b	#1,$2A(a0)
		bne.s	loc_16290
		move.b	#3,$2A(a0)
		bchg	#0,$22(a0)
		bchg	#0,1(a0)

locret_1628E:				; CODE XREF: ROM:00016256j
		rts
; ===============================================================================

loc_16290:				; CODE XREF: ROM:0001627Aj
		lea	(Ani_Obj50).l,a1
		bsr.w	j_AnimateSprite_3
		bra.w	loc_16768

; =============== S U B R O U T I N E ==========================================


sub_1629E:				; CODE XREF: ROM:Obj50_Routine0Ap
		tst.b	$25(a0)
		bne.s	locret_162DC
		move.b	(RAM_ObjRam_Sonic+$24).w,d0
		cmpi.b	#2,d0
		bne.s	locret_162DC
		move.w	(RAM_ObjRam_Sonic+$8).w,8(a0)
		move.w	(RAM_ObjRam_Sonic+$C).w,$C(a0)
		ori.b	#4,1(a0)
		move.b	#1,$18(a0)
		move.b	#5,$1C(a0)
		st	$25(a0)
		move.w	#$12C,$2C(a0)
		move.b	#3,$2A(a0)

locret_162DC:				; CODE XREF: sub_1629E+4j sub_1629E+Ej
		rts
; End of function sub_1629E


; =============== S U B R O U T I N E ==========================================


sub_162DE:				; CODE XREF: ROM:0001604Ap
					; ROM:0001605Cp ...
		subq.w	#1,$32(a0)
		bpl.s	locret_162FA
		move.w	$34(a0),$32(a0)
		neg.w	$10(a0)
		bchg	#0,$22(a0)
		move.b	#1,$1D(a0)

locret_162FA:				; CODE XREF: sub_162DE+4j
		rts
; End of function sub_162DE

; ===============================================================================

loc_162FC:				; CODE XREF: ROM:loc_16030p
					; ROM:loc_165C0p
		tst.b	$21(a0)
		beq.w	locret_1639E
		moveq	#2,d3

loc_16306:				; CODE XREF: ROM:loc_16378j
		bsr.w	j_SingleObjectLoad
		bne.s	loc_16378
		move.b	0(a0),0(a1)
		move.b	#8,$24(a1)
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		move.l	4(a0),4(a1)
		move.w	#$24E0,2(a1)
		ori.b	#4,1(a1)
		move.b	#3,$18(a1)
		move.w	#$FF00,$12(a1)
		move.b	#4,$1C(a1)
		move.b	#$78,$21(a1) ; 'x'
		cmpi.w	#1,d3
		beq.s	loc_16372
		blt.s	loc_16364
		move.w	#$C0,$10(a1) ; ''
		addi.w	#$FF40,$12(a1)
		bra.s	loc_16378
; ===============================================================================

loc_16364:				; CODE XREF: ROM:00016354j
		move.w	#$FF00,$10(a1)
		addi.w	#$FFC0,$12(a1)
		bra.s	loc_16378
; ===============================================================================

loc_16372:				; CODE XREF: ROM:00016352j
		move.w	#$40,$10(a1) ; '@'

loc_16378:				; CODE XREF: ROM:0001630Aj
					; ROM:00016362j ...
		dbf	d3,loc_16306
		bsr.w	j_SingleObjectLoad
		bne.s	loc_1639A
		move.b	0(a0),0(a1)
		move.b	#$A,$24(a1)
		move.l	4(a0),4(a1)
		move.w	#$24E0,2(a1)

loc_1639A:				; CODE XREF: ROM:00016380j
		bra.w	loc_1676E
; ===============================================================================

locret_1639E:				; CODE XREF: ROM:00016300j
		rts
; ===============================================================================
Ani_Obj50:	dc.w byte_163B0-Ani_Obj50 ; DATA XREF: ROM:loc_15FDAo
					; ROM:00016022o ...
		dc.w byte_163B3-Ani_Obj50
		dc.w byte_163BB-Ani_Obj50
		dc.w byte_163C1-Ani_Obj50
		dc.w byte_163C5-Ani_Obj50
		dc.w byte_163C8-Ani_Obj50
		dc.w byte_163CB-Ani_Obj50
		dc.w byte_163CF-Ani_Obj50
byte_163B0:	dc.b  $E,  0,$FF	; 0 ; DATA XREF: ROM:Ani_Obj50o
byte_163B3:	dc.b   5,  3,  4,  3,  4,  3,  4,$FF; 0	; DATA XREF: ROM:000163A2o
byte_163BB:	dc.b   3,  5,  6,  7,  6,$FF; 0	; DATA XREF: ROM:000163A4o
byte_163C1:	dc.b   3,  1,  2,$FF	; 0 ; DATA XREF: ROM:000163A6o
byte_163C5:	dc.b   1,  5,$FF	; 0 ; DATA XREF: ROM:000163A8o
byte_163C8:	dc.b  $E,  8,$FF	; 0 ; DATA XREF: ROM:000163AAo
byte_163CB:	dc.b   1,  9, $A,$FF	; 0 ; DATA XREF: ROM:000163ACo
byte_163CF:	dc.b   5, $B, $C, $B, $C, $B, $C,$FF,  0; 0 ; DATA XREF: ROM:000163AEo
Map_Obj50:	dc.w word_163F2-Map_Obj50 ; DATA XREF: ROM:00015F26o
					; ROM:00015FA6o ...
		dc.w word_1640C-Map_Obj50
		dc.w word_16416-Map_Obj50
		dc.w word_16420-Map_Obj50
		dc.w word_16442-Map_Obj50
		dc.w word_16464-Map_Obj50
		dc.w word_1646E-Map_Obj50
		dc.w word_16478-Map_Obj50
		dc.w word_16482-Map_Obj50
		dc.w word_1648C-Map_Obj50
		dc.w word_164AE-Map_Obj50
		dc.w word_164D0-Map_Obj50
		dc.w word_164FA-Map_Obj50
word_163F2:	dc.w 3			; DATA XREF: ROM:Map_Obj50o
		dc.w $E80D,    0,    0,$FFF0; 0
		dc.w $F809,  $16,   $B,$FFF8; 4
		dc.w  $805,  $24,  $12,$FFF8; 8
word_1640C:	dc.w 1			; DATA XREF: ROM:000163DAo
		dc.w $F805,  $28,  $14,$FFF8; 0
word_16416:	dc.w 1			; DATA XREF: ROM:000163DCo
		dc.w $F805,  $2C,  $16,$FFF8; 0
word_16420:	dc.w 4			; DATA XREF: ROM:000163DEo
		dc.w $E809,    8,    4,$FFF0; 0
		dc.w $E801,   $E,    7,	   8; 4
		dc.w $F809,  $16,   $B,$FFF8; 8
		dc.w  $805,  $24,  $12,$FFF8; 12
word_16442:	dc.w 4			; DATA XREF: ROM:000163E0o
		dc.w $E809,  $10,    8,$FFF0; 0
		dc.w $E801,   $E,    7,	   8; 4
		dc.w $F809,  $16,   $B,$FFF8; 8
		dc.w  $805,  $24,  $12,$FFF8; 12
word_16464:	dc.w 1			; DATA XREF: ROM:000163E2o
		dc.w $F801,  $30,  $18,$FFFC; 0
word_1646E:	dc.w 1			; DATA XREF: ROM:000163E4o
		dc.w $F801,  $32,  $19,$FFFC; 0
word_16478:	dc.w 1			; DATA XREF: ROM:000163E6o
		dc.w $F801,  $34,  $1A,$FFFC; 0
word_16482:	dc.w 1			; DATA XREF: ROM:000163E8o
		dc.w $F80D,  $36,  $1B,$FFF0; 0
word_1648C:	dc.w 4			; DATA XREF: ROM:000163EAo
		dc.w $E80D,    0,    0,$FFF0; 0
		dc.w $F805,  $1C,   $E,$FFF8; 4
		dc.w $F801,  $20,  $10,	   8; 8
		dc.w  $805,  $24,  $12,$FFF8; 12
word_164AE:	dc.w 4			; DATA XREF: ROM:000163ECo
		dc.w $E80D,    0,    0,$FFF0; 0
		dc.w $F805,  $1C,   $E,$FFF8; 4
		dc.w $F801,  $22,  $11,	   8; 8
		dc.w  $805,  $24,  $12,$FFF8; 12
word_164D0:	dc.w 5			; DATA XREF: ROM:000163EEo
		dc.w $E809,    8,    4,$FFF0; 0
		dc.w $E801,   $E,    7,	   8; 4
		dc.w $F805,  $1C,   $E,$FFF8; 8
		dc.w $F801,  $20,  $10,	   8; 12
		dc.w  $805,  $24,  $12,$FFF8; 16
word_164FA:	dc.w 5			; DATA XREF: ROM:000163F0o
		dc.w $E809,  $10,    8,$FFF0; 0
		dc.w $E801,   $E,    7,	   8; 4
		dc.w $F805,  $1C,   $E,$FFF8; 8
		dc.w $F801,  $22,  $11,	   8; 12
		dc.w  $805,  $24,  $12,$FFF8; 16
; ===============================================================================
;----------------------------------------------------
; Object 51 - unused Skyhorse badnik from HPZ
;----------------------------------------------------

Obj51:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	off_16532(pc,d0.w),d1
		jmp	off_16532(pc,d1.w)
; ===============================================================================
off_16532:	dc.w loc_1653E-off_16532 ; DATA	XREF: ROM:off_16532o
					; ROM:00016534o ...
		dc.w loc_1659C-off_16532
		dc.w loc_165C0-off_16532
		dc.w 0
		dc.w Obj50_Routine08-off_16532
		dc.w Obj50_Routine0A-off_16532
; ===============================================================================

loc_1653E:				; DATA XREF: ROM:off_16532o
		addq.b	#2,$24(a0)
		move.l	#Map_Obj50,4(a0)
		move.w	#$2570,2(a0)
		ori.b	#4,1(a0)
		move.b	#$A,$20(a0)
		move.b	#4,$18(a0)
		move.b	#$10,$19(a0)
		move.b	#6,$1C(a0)
		move.b	$28(a0),d0
		andi.w	#$F,d0
		move.w	d0,d1
		lsl.w	#5,d1
		subq.w	#1,d1
		move.w	d1,$32(a0)
		move.w	d1,$34(a0)
		move.w	$C(a0),$2A(a0)
		move.w	$C(a0),$2E(a0)
		addi.w	#$60,$2E(a0) ; '`'
		move.w	#$FF00,$10(a0)

loc_1659C:				; DATA XREF: ROM:00016534o
		lea	Ani_Obj50(pc),a1
		bsr.w	j_AnimateSprite_3
		move.w	#$39C,(RAM_Level_Water_Action).w
		moveq	#0,d0
		move.b	$25(a0),d0
		move.w	off_165BC(pc,d0.w),d1
		jsr	off_165BC(pc,d1.w)
		bra.w	loc_1677A
; ===============================================================================
off_165BC:	dc.w loc_165D4-off_165BC ; DATA	XREF: ROM:off_165BCo
					; ROM:000165BEo
		dc.w loc_165EA-off_165BC
; ===============================================================================

loc_165C0:				; DATA XREF: ROM:00016536o
		bsr.w	loc_162FC
		bsr.w	j_SpeedToPos_4
		lea	Ani_Obj50(pc),a1
		bsr.w	j_AnimateSprite_3
		bra.w	loc_1677A
; ===============================================================================

loc_165D4:				; DATA XREF: ROM:off_165BCo
		bsr.w	j_SpeedToPos_4
		bsr.w	sub_162DE
		bsr.w	loc_16626
		bsr.w	loc_16708
		bsr.w	loc_16678
		rts
; ===============================================================================

loc_165EA:				; DATA XREF: ROM:000165BEo
		bsr.w	j_SpeedToPos_4
		bsr.w	sub_162DE
		bsr.w	loc_16626
		bsr.w	loc_16708
		bsr.w	loc_16600
		rts
; ===============================================================================

loc_16600:				; CODE XREF: ROM:000165FAp
		subq.w	#1,$30(a0)
		beq.s	loc_16614
		move.w	$30(a0),d0
		cmpi.w	#$12,d0
		beq.w	loc_1669E
		rts
; ===============================================================================

loc_16614:				; CODE XREF: ROM:00016604j
		subq.b	#2,$25(a0)
		move.b	#6,$1C(a0)
		move.w	#$B4,$30(a0) ; ''
		rts
; ===============================================================================

loc_16626:				; CODE XREF: ROM:000165DCp
					; ROM:000165F2p
		sf	$2D(a0)
		sf	$2C(a0)
		sf	$36(a0)
		move.w	(RAM_ObjRam_Sonic+$8).w,d0
		sub.w	8(a0),d0
		bpl.s	loc_16646
		btst	#0,$22(a0)
		bne.s	loc_1664E
		bra.s	loc_16652
; ===============================================================================

loc_16646:				; CODE XREF: ROM:0001663Aj
		btst	#0,$22(a0)
		bne.s	loc_16652

loc_1664E:				; CODE XREF: ROM:00016642j
		st	$2C(a0)

loc_16652:				; CODE XREF: ROM:00016644j
					; ROM:0001664Cj
		move.w	(RAM_ObjRam_Sonic+$C).w,d0
		sub.w	$C(a0),d0
		cmpi.w	#$FFFC,d0
		blt.s	locret_16676
		cmpi.w	#4,d0
		bgt.s	loc_16672
		st	$2D(a0)
		move.w	#0,$12(a0)
		rts
; ===============================================================================

loc_16672:				; CODE XREF: ROM:00016664j
		st	$36(a0)

locret_16676:				; CODE XREF: ROM:0001665Ej
		rts
; ===============================================================================

loc_16678:				; CODE XREF: ROM:000165E4p
		tst.b	$2C(a0)
		bne.s	locret_1669C
		subq.w	#1,$30(a0)
		bgt.s	locret_1669C
		tst.b	$2D(a0)
		beq.s	locret_1669C
		move.b	#7,$1C(a0)
		move.w	#$24,$30(a0) ; '$'
		addi.b	#2,$25(a0)

locret_1669C:				; CODE XREF: ROM:0001667Cj
					; ROM:00016682j ...
		rts
; ===============================================================================

loc_1669E:				; CODE XREF: ROM:0001660Ej
		bsr.w	j_SingleObjectLoad
		bne.s	locret_16706
		move.b	#$51,0(a1) ; 'Q'
		move.b	#4,$24(a1)
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		move.l	#Map_Obj50,4(a1)
		move.w	#$24E0,2(a1)
		ori.b	#4,1(a1)
		move.b	#3,$18(a1)
		move.b	#2,$1C(a1)
		move.b	#$E5,$20(a1)
		move.w	#$C,d0
		move.w	#$10,d1
		move.w	#$FD00,d2
		btst	#0,$22(a0)
		beq.s	loc_166FA
		neg.w	d1
		neg.w	d2

loc_166FA:				; CODE XREF: ROM:000166F4j
		sub.w	d0,$C(a1)
		sub.w	d1,8(a1)
		move.w	d2,$10(a1)

locret_16706:				; CODE XREF: ROM:000166A2j
		rts
; ===============================================================================

loc_16708:				; CODE XREF: ROM:000165E0p
					; ROM:000165F6p
		tst.b	$2D(a0)
		bne.s	locret_16766
		tst.b	$36(a0)
		beq.s	loc_16738
		move.w	$2E(a0),d0
		cmp.w	$C(a0),d0
		ble.s	loc_1675C
		tst.b	$2C(a0)
		beq.s	loc_16730
		move.w	$2A(a0),d0
		cmp.w	$C(a0),d0
		bge.s	loc_1675C
		rts
; ===============================================================================

loc_16730:				; CODE XREF: ROM:00016722j
		move.w	#$180,$12(a0)
		rts
; ===============================================================================

loc_16738:				; CODE XREF: ROM:00016712j
		move.w	$2A(a0),d0
		cmp.w	$C(a0),d0
		bge.s	loc_1675C
		tst.b	$2C(a0)
		beq.s	loc_16754
		move.w	$2E(a0),d0
		cmp.w	$C(a0),d0
		ble.s	loc_1675C
		rts
; ===============================================================================

loc_16754:				; CODE XREF: ROM:00016746j
		move.w	#$FE80,$12(a0)
		rts
; ===============================================================================

loc_1675C:				; CODE XREF: ROM:0001671Cj
					; ROM:0001672Cj ...
		move.w	d0,$C(a0)
		move.w	#0,$12(a0)

locret_16766:				; CODE XREF: ROM:0001670Cj
		rts
; ===============================================================================

loc_16768:				; CODE XREF: ROM:0001602Cj
					; ROM:0001629Aj
		jmp	DisplaySprite
; ===============================================================================

loc_1676E:				; CODE XREF: ROM:0001600Cj
					; ROM:00016014j ...
		jmp	DeleteObject
; ===============================================================================

j_SingleObjectLoad:			; CODE XREF: ROM:00015F7Cp
					; sub_16078+12p ...
		jmp	SingleObjectLoad
; ===============================================================================

loc_1677A:				; CODE XREF: ROM:00015FFCj
					; ROM:00016042j ...
		jmp	MarkObjGone
; ===============================================================================

j_AnimateSprite_3:			; CODE XREF: ROM:00015FE0p
					; ROM:00016028p ...
		jmp	AnimateSprite
; ===============================================================================

j_ObjectFall_2:				; CODE XREF: ROM:loc_16066p
					; ROM:Obj50_Routine08p
		jmp	ObjectFall
; ===============================================================================

j_SpeedToPos_4:				; CODE XREF: ROM:00016034p
					; ROM:loc_16046p ...
		jmp	SpeedToPos
; ===============================================================================
		align 4
;----------------------------------------------------
; Object 4B - Buzz Bomber badnik
;----------------------------------------------------

Obj4B:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj4B_Index(pc,d0.w),d1
		jmp	Obj4B_Index(pc,d1.w)
; ===============================================================================
Obj4B_Index:	dc.w Obj4B_Init-Obj4B_Index ; DATA XREF: ROM:Obj4B_Indexo
					; ROM:000167A4o ...
		dc.w Obj4B_Main-Obj4B_Index
		dc.w loc_167BC-Obj4B_Index
		dc.w loc_167AA-Obj4B_Index
; ===============================================================================

loc_167AA:				; DATA XREF: ROM:000167A8o
		bsr.w	j_SpeedToPos_5
		lea	(Ani_Obj4B).l,a1
		bsr.w	j_AnimateSprite_4
		bra.w	loc_16A8C
; ===============================================================================

loc_167BC:				; DATA XREF: ROM:000167A6o
		movea.l	$2A(a0),a1
		tst.b	(a1)
		beq.w	loc_16A74
		tst.w	$30(a1)
		bmi.s	loc_167CE
		rts
; ===============================================================================

loc_167CE:				; CODE XREF: ROM:000167CAj
		move.w	8(a1),8(a0)
		move.w	$C(a1),$C(a0)
		move.b	$22(a1),$22(a0)
		move.b	1(a1),1(a0)
		lea	(Ani_Obj4B).l,a1
		bsr.w	j_AnimateSprite_4
		bra.w	loc_16A8C
; ===============================================================================

Obj4B_Init:				; DATA XREF: ROM:Obj4B_Indexo
		move.l	#Map_Obj4B,4(a0)
		move.w	#$3E6,2(a0)
		bsr.w	j_ModifySpriteAttr_2P_2
		ori.b	#4,1(a0)
		move.b	#$A,$20(a0)
		move.b	#4,$18(a0)
		move.b	#$10,$19(a0)
		move.b	#$10,$16(a0)
		move.b	#$18,$17(a0)
		move.b	#3,$18(a0)
		addq.b	#2,$24(a0)
		bsr.w	j_S1SingleObjectLoad2_0
		bne.s	locret_1689E
		move.b	#$4B,0(a1) ; 'K'
		move.b	#4,$24(a1)
		move.l	#Map_Obj4B,4(a1)
		move.w	#$3E6,2(a1)
		bsr.w	j_ModifyA1SpriteAttr_2P
		move.b	#4,$18(a1)
		move.b	#$10,$19(a1)
		move.b	$22(a0),$22(a1)
		move.b	1(a0),1(a1)
		move.b	#1,$1C(a1)
		move.l	a0,$2A(a1)
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		move.w	#$100,$2E(a0)
		move.w	#$FF00,$10(a0)
		btst	#0,1(a0)
		beq.s	locret_1689E
		neg.w	$10(a0)

locret_1689E:				; CODE XREF: ROM:00016838j
					; ROM:00016898j
		rts
; ===============================================================================

Obj4B_Main:				; DATA XREF: ROM:000167A4o
		moveq	#0,d0
		move.b	$25(a0),d0
		move.w	Obj4B_SubIndex(pc,d0.w),d1
		jsr	Obj4B_SubIndex(pc,d1.w)
		lea	(Ani_Obj4B).l,a1
		bsr.w	j_AnimateSprite_4
		bra.w	loc_16A8C
; ===============================================================================
Obj4B_SubIndex:	dc.w loc_168C0-Obj4B_SubIndex ;	DATA XREF: ROM:Obj4B_SubIndexo
					; ROM:000168BEo
		dc.w loc_16950-Obj4B_SubIndex
; ===============================================================================

loc_168C0:				; DATA XREF: ROM:Obj4B_SubIndexo
		bsr.w	sub_16902
		subq.w	#1,$30(a0)
		move.w	$30(a0),d0
		cmpi.w	#$F,d0
		beq.s	loc_168E6
		tst.w	d0
		bpl.s	locret_168E4
		subq.w	#1,$2E(a0)
		bgt.w	j_SpeedToPos_5
		move.w	#$1E,$30(a0)

locret_168E4:				; CODE XREF: ROM:000168D4j
		rts
; ===============================================================================

loc_168E6:				; CODE XREF: ROM:000168D0j
		sf	$32(a0)
		neg.w	$10(a0)
		bchg	#0,1(a0)
		bchg	#0,$22(a0)
		move.w	#$100,$2E(a0)
		rts

; =============== S U B R O U T I N E ==========================================


sub_16902:				; CODE XREF: ROM:loc_168C0p
		tst.b	$32(a0)
		bne.w	locret_1694E
		move.w	8(a0),d0
		sub.w	(RAM_ObjRam_Sonic+$8).w,d0
		move.w	d0,d1
		bpl.s	loc_16918
		neg.w	d0

loc_16918:				; CODE XREF: sub_16902+12j
		cmpi.w	#$28,d0	; '('
		blt.s	locret_1694E
		cmpi.w	#$30,d0	; '0'
		bgt.s	locret_1694E
		tst.w	d1
		bpl.s	loc_16932
		btst	#0,1(a0)
		beq.s	locret_1694E
		bra.s	loc_1693A
; ===============================================================================

loc_16932:				; CODE XREF: sub_16902+24j
		btst	#0,1(a0)
		bne.s	locret_1694E

loc_1693A:				; CODE XREF: sub_16902+2Ej
		st	$32(a0)
		addq.b	#2,$25(a0)
		move.b	#3,$1C(a0)
		move.w	#$32,$34(a0) ; '2'

locret_1694E:				; CODE XREF: sub_16902+4j
					; sub_16902+1Aj ...
		rts
; End of function sub_16902

; ===============================================================================

loc_16950:				; DATA XREF: ROM:000168BEo
		move.w	$34(a0),d0
		subq.w	#1,d0
		blt.s	loc_16964
		move.w	d0,$34(a0)
		cmpi.w	#$14,d0
		beq.s	loc_1696A
		rts
; ===============================================================================

loc_16964:				; CODE XREF: ROM:00016956j
		subq.b	#2,$25(a0)
		rts
; ===============================================================================

loc_1696A:				; CODE XREF: ROM:00016960j
		jsr	S1SingleObjectLoad2
		bne.s	locret_169D8
		move.b	#$4B,0(a1) ; 'K'
		move.b	#6,$24(a1)
		move.l	#Map_Obj4B,4(a1)
		move.w	#$3E6,2(a1)
		bsr.w	j_ModifyA1SpriteAttr_2P
		move.b	#4,$18(a1)
		move.b	#$98,$20(a1)
		move.b	#$10,$19(a1)
		move.b	$22(a0),$22(a1)
		move.b	1(a0),1(a1)
		move.b	#2,$1C(a1)
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		move.w	#$180,$12(a1)
		move.w	#$FE80,$10(a1)
		btst	#0,1(a1)
		beq.s	locret_169D8
		neg.w	$10(a1)

locret_169D8:				; CODE XREF: ROM:00016970j
					; ROM:000169D2j
		rts
; ===============================================================================
Ani_Obj4B:	dc.w byte_169E2-Ani_Obj4B ; DATA XREF: ROM:000167AEo
					; ROM:000167E6o ...
		dc.w byte_169E5-Ani_Obj4B
		dc.w byte_169E9-Ani_Obj4B
		dc.w byte_169ED-Ani_Obj4B
byte_169E2:	dc.b  $F,  0,$FF	; 0 ; DATA XREF: ROM:Ani_Obj4Bo
byte_169E5:	dc.b   2,  3,  4,$FF	; 0 ; DATA XREF: ROM:000169DCo
byte_169E9:	dc.b   3,  5,  6,$FF	; 0 ; DATA XREF: ROM:000169DEo
byte_169ED:	dc.b   9,  1,  1,  1,  1,  1,$FD,  0,  0; 0 ; DATA XREF: ROM:000169E0o
Map_Obj4B:	dc.w word_16A04-Map_Obj4B ; DATA XREF: ROM:Obj4B_Inito
					; ROM:00016846o ...
		dc.w word_16A16-Map_Obj4B
		dc.w word_16A30-Map_Obj4B
		dc.w word_16A4A-Map_Obj4B
		dc.w word_16A54-Map_Obj4B
		dc.w word_16A5E-Map_Obj4B
		dc.w word_16A68-Map_Obj4B
word_16A04:	dc.w 2			; DATA XREF: ROM:Map_Obj4Bo
		dc.w $F809,    0,    0,$FFE8; 0
		dc.w $F809,    6,    3,	   0; 4
word_16A16:	dc.w 3			; DATA XREF: ROM:000169F8o
		dc.w $F809,    0,    0,$FFE8; 0
		dc.w $F805,   $C,    6,	   0; 4
		dc.w  $805,  $10,    8,	   2; 8
word_16A30:	dc.w 3			; DATA XREF: ROM:000169FAo
		dc.w $F809,    0,    0,$FFE8; 0
		dc.w $F805,   $C,    6,	   0; 4
		dc.w  $805,  $14,   $A,	   2; 8
word_16A4A:	dc.w 1			; DATA XREF: ROM:000169FCo
		dc.w $F001,  $14,   $A,	   4; 0
word_16A54:	dc.w 1			; DATA XREF: ROM:000169FEo
		dc.w $F001,  $16,   $B,	   4; 0
word_16A5E:	dc.w 1			; DATA XREF: ROM:00016A00o
		dc.w $1001,  $18,   $C,	   9; 0
word_16A68:	dc.w 1			; DATA XREF: ROM:00016A02o
		dc.w $1001,  $1A,   $D,	   9; 0
		align 4

loc_16A74:				; CODE XREF: ROM:000167C2j
		jmp	DeleteObject
; ===============================================================================

j_S1SingleObjectLoad2_0:		; CODE XREF: ROM:00016834p
		jmp	S1SingleObjectLoad2
; ===============================================================================

j_AnimateSprite_4:			; CODE XREF: ROM:000167B4p
					; ROM:000167ECp ...
		jmp	AnimateSprite
; ===============================================================================

j_ModifyA1SpriteAttr_2P:		; CODE XREF: ROM:00016854p
					; ROM:0001698Cp
		jmp	ModifyA1SpriteAttr_2P
; ===============================================================================

loc_16A8C:				; CODE XREF: ROM:000167B8j
					; ROM:000167F0j ...
		jmp	loc_CEC6
; ===============================================================================

j_ModifySpriteAttr_2P_2:		; CODE XREF: ROM:00016802p
		jmp	ModifySpriteAttr_2P
; ===============================================================================

j_SpeedToPos_5:				; CODE XREF: ROM:loc_167AAp
					; ROM:000168DAj
		jmp	SpeedToPos
; ===============================================================================
		align 4
;----------------------------------------------------
; Object 4A - Octopus badnik
;----------------------------------------------------

Obj4A:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj4A_Index(pc,d0.w),d1
		jmp	Obj4A_Index(pc,d1.w)
; ===============================================================================
Obj4A_Index:	dc.w loc_16ADE-Obj4A_Index ; DATA XREF:	ROM:Obj4A_Indexo
					; ROM:00016AB0o ...
		dc.w loc_16B44-Obj4A_Index
		dc.w loc_16AD2-Obj4A_Index
		dc.w loc_16AB6-Obj4A_Index
; ===============================================================================

loc_16AB6:				; DATA XREF: ROM:00016AB4o
		subi.w	#1,$2C(a0)
		bmi.s	loc_16AC0
		rts
; ===============================================================================

loc_16AC0:				; CODE XREF: ROM:00016ABCj
		bsr.w	j_ObjectFall_3
		lea	(Ani_Obj4A).l,a1
		bsr.w	j_AnimateSprite_5
		bra.w	loc_16D3C
; ===============================================================================

loc_16AD2:				; DATA XREF: ROM:00016AB2o
		subq.w	#1,$2C(a0)
		beq.w	loc_16D36
		bra.w	loc_16D30
; ===============================================================================

loc_16ADE:				; DATA XREF: ROM:Obj4A_Indexo
		move.l	#Map_Obj4A,4(a0)
		move.w	#$238A,2(a0)
		ori.b	#4,1(a0)
		move.b	#$A,$20(a0)
		move.b	#4,$18(a0)
		move.b	#$10,$19(a0)
		move.b	#$10,$16(a0)
		move.b	#8,$17(a0)
		bsr.w	j_ObjectFall_3
		jsr	ObjHitFloor
		tst.w	d1
		bpl.s	loc_16B3C
		add.w	d1,$C(a0)
		move.w	#0,$12(a0)
		addq.b	#2,$24(a0)
		move.w	8(a0),d0
		sub.w	(RAM_ObjRam_Sonic+$8).w,d0
		bpl.s	loc_16B3C
		bchg	#0,$22(a0)

loc_16B3C:				; CODE XREF: ROM:00016B1Cj
					; ROM:00016B34j
		move.w	$C(a0),$2A(a0)
		rts
; ===============================================================================

loc_16B44:				; DATA XREF: ROM:00016AB0o
		moveq	#0,d0
		move.b	$25(a0),d0
		move.w	Obj4A_SubIndex(pc,d0.w),d1
		jsr	Obj4A_SubIndex(pc,d1.w)
		lea	(Ani_Obj4A).l,a1
		bsr.w	j_AnimateSprite_5
		bra.w	loc_16D3C
; ===============================================================================
Obj4A_SubIndex:	dc.w Obj4A_Init-Obj4A_SubIndex ; DATA XREF: ROM:Obj4A_SubIndexo
					; ROM:00016B62o ...
		dc.w Obj4A_Main-Obj4A_SubIndex
		dc.w loc_16BAA-Obj4A_SubIndex
		dc.w loc_16C7C-Obj4A_SubIndex
; ===============================================================================

Obj4A_Init:				; DATA XREF: ROM:Obj4A_SubIndexo
		move.w	8(a0),d0
		sub.w	(RAM_ObjRam_Sonic+$8).w,d0
		cmpi.w	#$80,d0	; ''
		bgt.s	locret_16B86
		cmpi.w	#$FF80,d0
		blt.s	locret_16B86
		addq.b	#2,$25(a0)
		move.b	#1,$1C(a0)

locret_16B86:				; CODE XREF: ROM:00016B74j
					; ROM:00016B7Aj
		rts
; ===============================================================================

Obj4A_Main:				; DATA XREF: ROM:00016B62o
		subi.l	#$18000,$C(a0)
		move.w	$2A(a0),d0
		sub.w	$C(a0),d0
		cmpi.w	#$20,d0	; ' '
		ble.s	locret_16BA8
		addq.b	#2,$25(a0)
		move.w	#0,$2C(a0)

locret_16BA8:				; CODE XREF: ROM:00016B9Cj
		rts
; ===============================================================================

loc_16BAA:				; DATA XREF: ROM:00016B64o
		subi.w	#1,$2C(a0)
		beq.w	loc_16C76
		bpl.w	locret_16C74
		move.w	#$1E,$2C(a0)
		jsr	SingleObjectLoad
		bne.s	loc_16C10
		move.b	#$4A,0(a1) ; 'J'
		move.b	#4,$24(a1)
		move.l	#Map_Obj4A,4(a1)
		move.b	#4,$1A(a1)
		move.w	#$24C6,2(a1)
		move.b	#3,$18(a1)
		move.b	#$10,$19(a1)
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		move.w	#$1E,$2C(a1)
		move.b	1(a0),1(a1)
		move.b	$22(a0),$22(a1)

loc_16C10:				; CODE XREF: ROM:00016BC4j
		jsr	SingleObjectLoad
		bne.s	locret_16C74
		move.b	#$4A,0(a1) ; 'J'
		move.b	#6,$24(a1)
		move.l	#Map_Obj4A,4(a1)
		move.w	#$24C6,2(a1)
		move.b	#4,$18(a1)
		move.b	#$10,$19(a1)
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		move.w	#$F,$2C(a1)
		move.b	1(a0),1(a1)
		move.b	$22(a0),$22(a1)
		move.b	#2,$1C(a1)
		move.w	#$FA80,$10(a1)
		btst	#0,1(a1)
		beq.s	locret_16C74
		neg.w	$10(a1)

locret_16C74:				; CODE XREF: ROM:00016BB4j
					; ROM:00016C16j ...
		rts
; ===============================================================================

loc_16C76:				; CODE XREF: ROM:00016BB0j
		addq.b	#2,$25(a0)
		rts
; ===============================================================================

loc_16C7C:				; DATA XREF: ROM:00016B66o
		move.w	#$FFFA,d0
		btst	#0,1(a0)
		beq.s	loc_16C8A
		neg.w	d0

loc_16C8A:				; CODE XREF: ROM:00016C86j
		add.w	d0,8(a0)
		bra.w	loc_16D3C
; ===============================================================================
Ani_Obj4A:	dc.w byte_16C98-Ani_Obj4A ; DATA XREF: ROM:00016AC4o
					; ROM:00016B52o ...
		dc.w byte_16C9B-Ani_Obj4A
		dc.w byte_16CA0-Ani_Obj4A
byte_16C98:	dc.b  $F,  0,$FF	; 0 ; DATA XREF: ROM:Ani_Obj4Ao
byte_16C9B:	dc.b   3,  1,  2,  3,$FF; 0 ; DATA XREF: ROM:00016C94o
byte_16CA0:	dc.b   2,  5,  6,$FF	; 0 ; DATA XREF: ROM:00016C96o
Map_Obj4A:	dc.w word_16CB2-Map_Obj4A ; DATA XREF: ROM:loc_16ADEo
					; ROM:00016BD2o ...
		dc.w word_16CC4-Map_Obj4A
		dc.w word_16CDE-Map_Obj4A
		dc.w word_16CF8-Map_Obj4A
		dc.w word_16D12-Map_Obj4A
		dc.w word_16D1C-Map_Obj4A
		dc.w word_16D26-Map_Obj4A
word_16CB2:	dc.w 2			; DATA XREF: ROM:Map_Obj4Ao
		dc.w $F00D,    0,    0,$FFF0; 0
		dc.w	$D,    8,    4,$FFF0; 4
word_16CC4:	dc.w 3			; DATA XREF: ROM:00016CA6o
		dc.w $F00D,    0,    0,$FFF0; 0
		dc.w	 9,  $10,    8,$FFE8; 4
		dc.w	 9,  $16,   $B,	   0; 8
word_16CDE:	dc.w 3			; DATA XREF: ROM:00016CA8o
		dc.w $F00D,    0,    0,$FFF0; 0
		dc.w	 9,  $1C,   $E,$FFE8; 4
		dc.w	 9,  $22,  $11,	   0; 8
word_16CF8:	dc.w 3			; DATA XREF: ROM:00016CAAo
		dc.w $F00D,    0,    0,$FFF0; 0
		dc.w	 9,  $28,  $14,$FFE8; 4
		dc.w	 9,  $2E,  $17,	   0; 8
word_16D12:	dc.w 1			; DATA XREF: ROM:00016CACo
		dc.w $F001,  $34,  $1A,$FFF7; 0
word_16D1C:	dc.w 1			; DATA XREF: ROM:00016CAEo
		dc.w $F201,  $36,  $1B,$FFF0; 0
word_16D26:	dc.w 1			; DATA XREF: ROM:00016CB0o
		dc.w $F201,  $38,  $1C,$FFF0; 0
; ===============================================================================

loc_16D30:				; CODE XREF: ROM:00016ADAj
		jmp	DisplaySprite
; ===============================================================================

loc_16D36:				; CODE XREF: ROM:00016AD6j
		jmp	DeleteObject
; ===============================================================================

loc_16D3C:				; CODE XREF: ROM:00016ACEj
					; ROM:00016B5Cj ...
		jmp	MarkObjGone
; ===============================================================================

j_AnimateSprite_5:			; CODE XREF: ROM:00016ACAp
					; ROM:00016B58p
		jmp	AnimateSprite
; ===============================================================================

j_ObjectFall_3:				; CODE XREF: ROM:loc_16AC0p
					; ROM:00016B10p
		jmp	ObjectFall
; ===============================================================================
		align 4
;----------------------------------------------------
; Object 4C - Bat badnik from HPZ
;----------------------------------------------------

Obj4C:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj4C_Index(pc,d0.w),d1
		jmp	Obj4C_Index(pc,d1.w)
; ===============================================================================
Obj4C_Index:	dc.w Obj4C_Init-Obj4C_Index ; DATA XREF: ROM:Obj4C_Indexo
					; ROM:00016D60o ...
		dc.w loc_16DA2-Obj4C_Index
		dc.w loc_16E10-Obj4C_Index
; ===============================================================================

Obj4C_Init:				; DATA XREF: ROM:Obj4C_Indexo
		move.l	#Map_Obj4C,4(a0)
		move.w	#$2530,2(a0)
		ori.b	#4,1(a0)
		move.b	#$A,$20(a0)
		move.b	#4,$18(a0)
		move.b	#$10,$19(a0)
		move.b	#$10,$16(a0)
		move.b	#8,$17(a0)
		addq.b	#2,$24(a0)
		move.w	$C(a0),$2E(a0)
		rts
; ===============================================================================

loc_16DA2:				; DATA XREF: ROM:00016D60o
		moveq	#0,d0
		move.b	$25(a0),d0
		move.w	Obj4C_SubIndex(pc,d0.w),d1
		jsr	Obj4C_SubIndex(pc,d1.w)
		bsr.w	sub_16DC8
		lea	(Ani_Obj4C).l,a1
		bsr.w	j_AnimateSprite_6
		bra.w	loc_171C4
; ===============================================================================
Obj4C_SubIndex:	dc.w loc_16F2E-Obj4C_SubIndex ;	DATA XREF: ROM:Obj4C_SubIndexo
					; ROM:00016DC4o ...
		dc.w loc_16F66-Obj4C_SubIndex
		dc.w loc_16F72-Obj4C_SubIndex

; =============== S U B R O U T I N E ==========================================


sub_16DC8:				; CODE XREF: ROM:00016DB0p
		move.b	$3F(a0),d0
		jsr	(CalcSine).l
		asr.w	#6,d0
		add.w	$2E(a0),d0
		move.w	d0,$C(a0)
		addq.b	#4,$3F(a0)
		rts
; End of function sub_16DC8


; =============== S U B R O U T I N E ==========================================


sub_16DE2:				; CODE XREF: ROM:00016F36p
		move.w	8(a0),d0
		sub.w	(RAM_ObjRam_Sonic+$8).w,d0
		cmpi.w	#$80,d0	; ''
		bgt.s	locret_16E0E
		cmpi.w	#$FF80,d0
		blt.s	locret_16E0E
		move.b	#4,$25(a0)
		move.b	#2,$1C(a0)
		move.w	#8,$2A(a0)
		move.b	#0,$3E(a0)

locret_16E0E:				; CODE XREF: sub_16DE2+Cj
					; sub_16DE2+12j
		rts
; End of function sub_16DE2

; ===============================================================================

loc_16E10:				; DATA XREF: ROM:00016D62o
		bsr.w	sub_16F0E
		bsr.w	sub_16EB0
		bsr.w	sub_16E30
		bsr.w	j_SpeedToPos_8
		lea	(Ani_Obj4C).l,a1
		bsr.w	j_AnimateSprite_6
		bra.w	loc_171C4
; ===============================================================================
		rts

; =============== S U B R O U T I N E ==========================================


sub_16E30:				; CODE XREF: ROM:00016E18p
		tst.b	$3D(a0)
		beq.s	locret_16E42
		bset	#0,1(a0)
		bset	#0,$22(a0)

locret_16E42:				; CODE XREF: sub_16E30+4j
		rts
; End of function sub_16E30


; =============== S U B R O U T I N E ==========================================


sub_16E44:				; CODE XREF: ROM:loc_16F72p
		subi.w	#1,$2C(a0)
		bpl.s	locret_16E8E
		move.w	8(a0),d0
		sub.w	(RAM_ObjRam_Sonic+$8).w,d0
		cmpi.w	#$60,d0	; '`'
		bgt.s	loc_16E90
		cmpi.w	#$FFA0,d0
		blt.s	loc_16E90
		tst.w	d0
		bpl.s	loc_16E68
		st	$3D(a0)

loc_16E68:				; CODE XREF: sub_16E44+1Ej
		move.b	#$40,$3F(a0) ; '@'
		move.w	#$400,$14(a0)
		move.b	#4,$24(a0)
		move.b	#3,$1C(a0)
		move.w	#$C,$2A(a0)
		move.b	#1,$3E(a0)
		moveq	#0,d0

locret_16E8E:				; CODE XREF: sub_16E44+6j
					; sub_16E44+56j
		rts
; ===============================================================================

loc_16E90:				; CODE XREF: sub_16E44+14j
					; sub_16E44+1Aj
		cmpi.w	#$80,d0	; ''
		bgt.s	loc_16E9C
		cmpi.w	#$FF80,d0
		bgt.s	locret_16E8E

loc_16E9C:				; CODE XREF: sub_16E44+50j
		move.b	#1,$1C(a0)
		move.b	#0,$25(a0)
		move.w	#$18,$2A(a0)
		rts
; End of function sub_16E44


; =============== S U B R O U T I N E ==========================================


sub_16EB0:				; CODE XREF: ROM:00016E14p
		tst.b	$3D(a0)
		bne.s	loc_16ECA
		moveq	#0,d0
		move.b	$3F(a0),d0
		cmpi.w	#$C0,d0	; ''
		bge.s	loc_16EDE
		addq.b	#2,d0
		move.b	d0,$3F(a0)
		rts
; ===============================================================================

loc_16ECA:				; CODE XREF: sub_16EB0+4j
		moveq	#0,d0
		move.b	$3F(a0),d0
		cmpi.w	#$C0,d0	; ''
		beq.s	loc_16EDE
		subq.b	#2,d0
		move.b	d0,$3F(a0)
		rts
; ===============================================================================

loc_16EDE:				; CODE XREF: sub_16EB0+10j
					; sub_16EB0+24j
		sf	$3D(a0)
		move.b	#0,$1C(a0)
		move.b	#2,$24(a0)
		move.b	#0,$25(a0)
		move.w	#$18,$2A(a0)
		move.b	#1,$1C(a0)
		bclr	#0,1(a0)
		bclr	#0,$22(a0)
		rts
; End of function sub_16EB0


; =============== S U B R O U T I N E ==========================================


sub_16F0E:				; CODE XREF: ROM:loc_16E10p
		move.b	$3F(a0),d0
		jsr	(CalcSine).l
		muls.w	$14(a0),d1
		asr.l	#8,d1
		move.w	d1,$10(a0)
		muls.w	$14(a0),d0
		asr.l	#8,d0
		move.w	d0,$12(a0)
		rts
; End of function sub_16F0E

; ===============================================================================

loc_16F2E:				; DATA XREF: ROM:Obj4C_SubIndexo
		subi.w	#1,$2A(a0)
		bpl.s	locret_16F64
		bsr.w	sub_16DE2
		beq.s	locret_16F64
		jsr	(PseudoRandomNumber).l
		andi.b	#$FF,d0
		bne.s	locret_16F64
		move.w	#$18,$2A(a0)
		move.w	#$1E,$2C(a0)
		addq.b	#2,$25(a0)
		move.b	#1,$1C(a0)
		move.b	#0,$3E(a0)

locret_16F64:				; CODE XREF: ROM:00016F34j
					; ROM:00016F3Aj ...
		rts
; ===============================================================================

loc_16F66:				; DATA XREF: ROM:00016DC4o
		subq.b	#1,$2A(a0)
		bpl.s	locret_16F70
		subq.b	#2,$25(a0)

locret_16F70:				; CODE XREF: ROM:00016F6Aj
		rts
; ===============================================================================

loc_16F72:				; DATA XREF: ROM:00016DC6o
		bsr.w	sub_16E44
		beq.s	locret_16FB8
		subi.w	#1,$2A(a0)
		bne.s	locret_16FB8
		move.b	$3E(a0),d0
		beq.s	loc_16FA0
		move.b	#0,$3E(a0)
		move.w	#8,$2A(a0)
		bset	#0,1(a0)
		bset	#0,$22(a0)
		rts
; ===============================================================================

loc_16FA0:				; CODE XREF: ROM:00016F84j
		move.b	#1,$3E(a0)
		move.w	#$C,$2A(a0)
		bclr	#0,1(a0)
		bclr	#0,$22(a0)

locret_16FB8:				; CODE XREF: ROM:00016F76j
					; ROM:00016F7Ej
		rts
; ===============================================================================
Ani_Obj4C:	dc.w byte_16FC2-Ani_Obj4C ; DATA XREF: ROM:00016DB4o
					; ROM:00016E20o ...
		dc.w byte_16FC6-Ani_Obj4C
		dc.w byte_16FD5-Ani_Obj4C
		dc.w byte_16FE6-Ani_Obj4C
byte_16FC2:	dc.b   1,  0,  5,$FF	; 0 ; DATA XREF: ROM:Ani_Obj4Co
byte_16FC6:	dc.b   1,  1,  6,  1,  6,  2,  7,  2,  7,  1,  6,  1,  6,$FD,  0; 0
					; DATA XREF: ROM:00016FBCo
byte_16FD5:	dc.b   1,  1,  6,  1,  6,  2,  7,  3,  8,  4,  9,  4,  9,  3,  8,$FE; 0
					; DATA XREF: ROM:00016FBEo
		dc.b  $A		; 16
byte_16FE6:	dc.b   3, $A, $B, $C, $D, $E,$FF,  0; 0	; DATA XREF: ROM:00016FC0o
Map_Obj4C:	dc.w word_1700C-Map_Obj4C ; DATA XREF: ROM:Obj4C_Inito
					; ROM:Map_Obj4Co ...
		dc.w word_1702E-Map_Obj4C
		dc.w word_17050-Map_Obj4C
		dc.w word_17072-Map_Obj4C
		dc.w word_17094-Map_Obj4C
		dc.w word_170AE-Map_Obj4C
		dc.w word_170D0-Map_Obj4C
		dc.w word_170F2-Map_Obj4C
		dc.w word_17114-Map_Obj4C
		dc.w word_17136-Map_Obj4C
		dc.w word_17150-Map_Obj4C
		dc.w word_1716A-Map_Obj4C
		dc.w word_17184-Map_Obj4C
		dc.w word_17196-Map_Obj4C
		dc.w word_171A8-Map_Obj4C
word_1700C:	dc.w 4			; DATA XREF: ROM:Map_Obj4Co
		dc.w $F005,    0,    0,$FFF8; 0
		dc.w	 5,    4,    2,$FFF8; 4
		dc.w $F00B,    8,    4,	   5; 8
		dc.w $F00B, $808, $804,$FFE3; 12
word_1702E:	dc.w 4			; DATA XREF: ROM:00016FF0o
		dc.w $F005,    0,    0,$FFF8; 0
		dc.w	 5,    4,    2,$FFF8; 4
		dc.w $F60D,  $14,   $A,	   5; 8
		dc.w $F60D, $814, $80A,$FFDB; 12
word_17050:	dc.w 4			; DATA XREF: ROM:00016FF2o
		dc.w $F005,    0,    0,$FFF8; 0
		dc.w	 5,    4,    2,$FFF8; 4
		dc.w $F80D,  $1C,   $E,	   4; 8
		dc.w $F80D, $81C, $80E,$FFDC; 12
word_17072:	dc.w 4			; DATA XREF: ROM:00016FF4o
		dc.w $F005,    0,    0,$FFF8; 0
		dc.w	 5,    4,    2,$FFF8; 4
		dc.w $F805,  $24,  $12,$FFEC; 8
		dc.w $F805,  $28,  $14,	   4; 12
word_17094:	dc.w 3			; DATA XREF: ROM:00016FF6o
		dc.w $F801,  $2C,  $16,	   0; 0
		dc.w $F005,    0,    0,$FFF8; 4
		dc.w	 5,    4,    2,$FFF8; 8
word_170AE:	dc.w 4			; DATA XREF: ROM:00016FF8o
		dc.w $F005,    0,    0,$FFF8; 0
		dc.w	 5,  $2E,  $17,$FFF8; 4
		dc.w $F00B,    8,    4,	   5; 8
		dc.w $F00B, $808, $804,$FFE3; 12
word_170D0:	dc.w 4			; DATA XREF: ROM:00016FFAo
		dc.w $F005,    0,    0,$FFF8; 0
		dc.w	 5,  $2E,  $17,$FFF8; 4
		dc.w $F60D,  $14,   $A,	   5; 8
		dc.w $F60D, $814, $80A,$FFDB; 12
word_170F2:	dc.w 4			; DATA XREF: ROM:00016FFCo
		dc.w $F005,    0,    0,$FFF8; 0
		dc.w	 5,  $2E,  $17,$FFF8; 4
		dc.w $F80D,  $1C,   $E,	   4; 8
		dc.w $F80D, $81C, $80E,$FFDC; 12
word_17114:	dc.w 4			; DATA XREF: ROM:00016FFEo
		dc.w $F005,    0,    0,$FFF8; 0
		dc.w	 5,  $2E,  $17,$FFF8; 4
		dc.w $F805,  $28,  $14,	   4; 8
		dc.w $F805,  $24,  $12,$FFEC; 12
word_17136:	dc.w 3			; DATA XREF: ROM:00017000o
		dc.w $F801,  $2C,  $16,	   0; 0
		dc.w $F005,    0,    0,$FFF8; 4
		dc.w	 5,  $2E,  $17,$FFF8; 8
word_17150:	dc.w 3			; DATA XREF: ROM:00017002o
		dc.w $F007,  $32,  $19,$FFF8; 0
		dc.w $F80D,  $1C,   $E,	   4; 4
		dc.w $F80D, $81C, $80E,$FFDC; 8
word_1716A:	dc.w 3			; DATA XREF: ROM:00017004o
		dc.w $F007,  $32,  $19,$FFF8; 0
		dc.w $F805,  $28,  $14,	   4; 4
		dc.w $F805,  $24,  $12,$FFEC; 8
word_17184:	dc.w 2			; DATA XREF: ROM:00017006o
		dc.w $F801,  $2C,  $16,	   0; 0
		dc.w $F007,  $32,  $19,$FFF8; 4
word_17196:	dc.w 2			; DATA XREF: ROM:00017008o
		dc.w $F801, $82C, $816,$FFF8; 0
		dc.w $F007,  $32,  $19,$FFF8; 4
word_171A8:	dc.w 3			; DATA XREF: ROM:0001700Ao
		dc.w $F007,  $32,  $19,$FFF8; 0
		dc.w $F805, $828, $814,$FFEC; 4
		dc.w $F805, $824, $812,	   4; 8
		align 4

loc_171C4:				; CODE XREF: ROM:00016DBEj
					; ROM:00016E2Aj
		jmp	MarkObjGone
; ===============================================================================

j_AnimateSprite_6:			; CODE XREF: ROM:00016DBAp
					; ROM:00016E26p
		jmp	AnimateSprite
; ===============================================================================

j_SpeedToPos_8:				; CODE XREF: ROM:00016E1Cp
		jmp	SpeedToPos
; ===============================================================================
		align 4
;----------------------------------------------------
; Object 4E - Aligator badnik from HPZ
;----------------------------------------------------

Obj4E:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj4E_Index(pc,d0.w),d1
		jmp	Obj4E_Index(pc,d1.w)
; ===============================================================================
Obj4E_Index:	dc.w Obj4E_Init-Obj4E_Index ; DATA XREF: ROM:Obj4E_Indexo
					; ROM:000171E8o
		dc.w Obj4E_Main-Obj4E_Index
; ===============================================================================

Obj4E_Init:				; DATA XREF: ROM:Obj4E_Indexo
		move.l	#Map_Obj4E,4(a0)
		move.w	#$2300,2(a0)
		ori.b	#4,1(a0)
		move.b	#$A,$20(a0)
		move.b	#4,$18(a0)
		move.b	#$10,$19(a0)
		move.b	#$10,$16(a0)
		move.b	#8,$17(a0)
		bsr.w	j_ObjectFall_4
		jsr	ObjHitFloor
		tst.w	d1
		bpl.s	locret_17238
		add.w	d1,$C(a0)
		move.w	#0,$12(a0)
		addq.b	#2,$24(a0)

locret_17238:				; CODE XREF: ROM:00017228j
		rts
; ===============================================================================

Obj4E_Main:				; DATA XREF: ROM:000171E8o
		moveq	#0,d0
		move.b	$25(a0),d0
		move.w	Obj4E_SubIndex(pc,d0.w),d1
		jsr	Obj4E_SubIndex(pc,d1.w)
		lea	(Ani_Obj4E).l,a1
		bsr.w	j_AnimateSprite_7
		bra.w	loc_174B8
; ===============================================================================
Obj4E_SubIndex:	dc.w loc_1725A-Obj4E_SubIndex ;	DATA XREF: ROM:Obj4E_SubIndexo
					; ROM:00017258o
		dc.w loc_1727E-Obj4E_SubIndex
; ===============================================================================

loc_1725A:				; DATA XREF: ROM:Obj4E_SubIndexo
		subq.w	#1,$30(a0)
		bpl.s	locret_1727C
		addq.b	#2,$25(a0)
		move.w	#$FF40,$10(a0)
		move.b	#0,$1C(a0)
		bchg	#0,$22(a0)
		bne.s	locret_1727C
		neg.w	$10(a0)

locret_1727C:				; CODE XREF: ROM:0001725Ej
					; ROM:00017276j
		rts
; ===============================================================================

loc_1727E:				; DATA XREF: ROM:00017258o
		bsr.w	sub_172B6
		bsr.w	j_SpeedToPos_6
		jsr	ObjHitFloor
		cmpi.w	#$FFF8,d1
		blt.s	loc_1729E
		cmpi.w	#$C,d1
		bge.s	loc_1729E
		add.w	d1,$C(a0)
		rts
; ===============================================================================

loc_1729E:				; CODE XREF: ROM:00017290j
					; ROM:00017296j
		subq.b	#2,$25(a0)
		move.w	#$3B,$30(a0) ; ';'
		move.w	#0,$10(a0)
		move.b	#1,$1C(a0)
		rts

; =============== S U B R O U T I N E ==========================================


sub_172B6:				; CODE XREF: ROM:loc_1727Ep
		move.w	8(a0),d0
		sub.w	(RAM_ObjRam_Sonic+$8).w,d0
		bmi.s	loc_172D0
		cmpi.w	#$40,d0	; '@'
		bgt.s	loc_172E6
		btst	#0,$22(a0)
		beq.s	loc_172DE
		rts
; ===============================================================================

loc_172D0:				; CODE XREF: sub_172B6+8j
		cmpi.w	#$FFC0,d0
		blt.s	loc_172E6
		btst	#0,$22(a0)
		beq.s	loc_172E6

loc_172DE:				; CODE XREF: sub_172B6+16j
		move.b	#2,$1C(a0)
		rts
; ===============================================================================

loc_172E6:				; CODE XREF: sub_172B6+Ej
					; sub_172B6+1Ej ...
		move.b	#0,$1C(a0)
		rts
; End of function sub_172B6

; ===============================================================================
Ani_Obj4E:	dc.w byte_172F4-Ani_Obj4E ; DATA XREF: ROM:00017248o
					; ROM:Ani_Obj4Eo ...
		dc.w byte_172FC-Ani_Obj4E
		dc.w byte_172FF-Ani_Obj4E
byte_172F4:	dc.b   3,  0,  4,  2,  3,  1,  5,$FF; 0	; DATA XREF: ROM:Ani_Obj4Eo
byte_172FC:	dc.b  $F,  0,$FF	; 0 ; DATA XREF: ROM:000172F0o
byte_172FF:	dc.b   3,  6, $A,  8,  9,  7, $B,$FF,  0; 0 ; DATA XREF: ROM:000172F2o
Map_Obj4E:	dc.w word_17320-Map_Obj4E ; DATA XREF: ROM:Obj4E_Inito
					; ROM:Map_Obj4Eo ...
		dc.w word_17342-Map_Obj4E
		dc.w word_17364-Map_Obj4E
		dc.w word_17386-Map_Obj4E
		dc.w word_173A8-Map_Obj4E
		dc.w word_173CA-Map_Obj4E
		dc.w word_173EC-Map_Obj4E
		dc.w word_1740E-Map_Obj4E
		dc.w word_17430-Map_Obj4E
		dc.w word_17452-Map_Obj4E
		dc.w word_17474-Map_Obj4E
		dc.w word_17496-Map_Obj4E
word_17320:	dc.w 4			; DATA XREF: ROM:Map_Obj4Eo
		dc.w $F80E,    0,    0,$FFE4; 0
		dc.w $F805,  $18,   $C,	   4; 4
		dc.w	 1,  $1C,   $E,	   4; 8
		dc.w	 5,  $20,  $10,	  $C; 12
word_17342:	dc.w 4			; DATA XREF: ROM:0001730Ao
		dc.w $F80E,    0,    0,$FFE4; 0
		dc.w $F805,  $18,   $C,	   4; 4
		dc.w	 1,  $1C,   $E,	   4; 8
		dc.w	 5,  $24,  $12,	  $C; 12
word_17364:	dc.w 4			; DATA XREF: ROM:0001730Co
		dc.w $F80E,    0,    0,$FFE4; 0
		dc.w $F805,  $18,   $C,	   4; 4
		dc.w	 1,  $1C,   $E,	   4; 8
		dc.w	 5,  $28,  $14,	  $C; 12
word_17386:	dc.w 4			; DATA XREF: ROM:0001730Eo
		dc.w $F80E,    0,    0,$FFE4; 0
		dc.w $F805,  $18,   $C,	   4; 4
		dc.w	 1,  $1E,   $F,	   4; 8
		dc.w	 5,  $20,  $10,	  $C; 12
word_173A8:	dc.w 4			; DATA XREF: ROM:00017310o
		dc.w $F80E,    0,    0,$FFE4; 0
		dc.w $F805,  $18,   $C,	   4; 4
		dc.w	 1,  $1E,   $F,	   4; 8
		dc.w	 5,  $24,  $12,	  $C; 12
word_173CA:	dc.w 4			; DATA XREF: ROM:00017312o
		dc.w $F80E,    0,    0,$FFE4; 0
		dc.w $F805,  $18,   $C,	   4; 4
		dc.w	 1,  $1E,   $F,	   4; 8
		dc.w	 5,  $28,  $14,	  $C; 12
word_173EC:	dc.w 4			; DATA XREF: ROM:00017314o
		dc.w $F00B,   $C,    6,$FFEC; 0
		dc.w $F805,  $18,   $C,	   4; 4
		dc.w	 1,  $1C,   $E,	   4; 8
		dc.w	 5,  $20,  $10,	  $C; 12
word_1740E:	dc.w 4			; DATA XREF: ROM:00017316o
		dc.w $F00B,   $C,    6,$FFEC; 0
		dc.w $F805,  $18,   $C,	   4; 4
		dc.w	 1,  $1C,   $E,	   4; 8
		dc.w	 5,  $24,  $12,	  $C; 12
word_17430:	dc.w 4			; DATA XREF: ROM:00017318o
		dc.w $F00B,   $C,    6,$FFEC; 0
		dc.w $F805,  $18,   $C,	   4; 4
		dc.w	 1,  $1C,   $E,	   4; 8
		dc.w	 5,  $28,  $14,	  $C; 12
word_17452:	dc.w 4			; DATA XREF: ROM:0001731Ao
		dc.w $F00B,   $C,    6,$FFEC; 0
		dc.w $F805,  $18,   $C,	   4; 4
		dc.w	 1,  $1E,   $F,	   4; 8
		dc.w	 5,  $20,  $10,	  $C; 12
word_17474:	dc.w 4			; DATA XREF: ROM:0001731Co
		dc.w $F00B,   $C,    6,$FFEC; 0
		dc.w $F805,  $18,   $C,	   4; 4
		dc.w	 1,  $1E,   $F,	   4; 8
		dc.w	 5,  $24,  $12,	  $C; 12
word_17496:	dc.w 4			; DATA XREF: ROM:0001731Eo
		dc.w $F00B,   $C,    6,$FFEC; 0
		dc.w $F805,  $18,   $C,	   4; 4
		dc.w	 1,  $1E,   $F,	   4; 8
		dc.w	 5,  $28,  $14,	  $C; 12
; ===============================================================================

loc_174B8:				; CODE XREF: ROM:00017252j
		jmp	MarkObjGone
; ===============================================================================

j_AnimateSprite_7:			; CODE XREF: ROM:0001724Ep
		jmp	AnimateSprite
; ===============================================================================

j_ObjectFall_4:				; CODE XREF: ROM:0001721Cp
		jmp	ObjectFall
; ===============================================================================

j_SpeedToPos_6:				; CODE XREF: ROM:00017282p
		jmp	SpeedToPos
; ===============================================================================

Obj53:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0

loc_174D2:
		move.b	$24(a0),d0
		move.w	Obj53_Index(pc,d0.w),d1
		jsr	Obj53_Index(pc,d1.w)
		bra.w	loc_175B8
; ===============================================================================
Obj53_Index:	dc.w Obj53_Init-Obj53_Index ; DATA XREF: ROM:Obj53_Indexo
					; ROM:000174E4o
		dc.w Obj53_Main-Obj53_Index
; ===============================================================================

Obj53_Init:				; DATA XREF: ROM:Obj53_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj53,4(a0)
		move.w	#$41C,2(a0)
		bsr.w	j_ModifySpriteAttr_2P
		move.b	#4,1(a0)
		move.b	#4,$18(a0)
		move.b	#9,$20(a0)
		move.b	#$10,$19(a0)
		move.w	#$FC00,$12(a0)
		move.w	$C(a0),$30(a0)

Obj53_Main:				; DATA XREF: ROM:000174E4o
		lea	(Ani_Obj53).l,a1
		bsr.w	j_AnimateSprite
		bsr.w	j_SpeedToPos
		addi.w	#$18,$12(a0)
		move.w	$30(a0),d0
		cmp.w	$C(a0),d0
		bcc.s	loc_17548
		move.w	d0,$C(a0)
		move.w	#$FB00,$12(a0)

loc_17548:				; CODE XREF: ROM:0001753Cj
		move.b	#1,$1C(a0)
		subi.w	#$C0,d0	; ''
		cmp.w	$C(a0),d0
		bcc.s	locret_1756A
		move.b	#0,$1C(a0)
		tst.w	$12(a0)
		bmi.s	locret_1756A
		move.b	#2,$1C(a0)

locret_1756A:				; CODE XREF: ROM:00017556j
					; ROM:00017562j
		rts
; ===============================================================================
Ani_Obj53:	dc.w byte_17572-Ani_Obj53 ; DATA XREF: ROM:Obj53_Maino
					; ROM:Ani_Obj53o ...
		dc.w byte_17576-Ani_Obj53
		dc.w byte_1757A-Ani_Obj53
byte_17572:	dc.b   7,  0,  1,$FF	; 0 ; DATA XREF: ROM:Ani_Obj53o
byte_17576:	dc.b   3,  0,  1,$FF	; 0 ; DATA XREF: ROM:0001756Eo
byte_1757A:	dc.b   7,  0,$FF,  0	; 0 ; DATA XREF: ROM:00017570o
Map_Obj53:	dc.w word_17582-Map_Obj53 ; DATA XREF: ROM:000174EAo
					; ROM:Map_Obj53o ...
		dc.w word_1759C-Map_Obj53
word_17582:	dc.w 3			; DATA XREF: ROM:Map_Obj53o
		dc.w $F005,    0,    0,$FFF4; 0
		dc.w $F001,    4,    2,	   4; 4
		dc.w	 9,   $A,    5,$FFF4; 8
word_1759C:	dc.w 3			; DATA XREF: ROM:00017580o
		dc.w $F005,    0,    0,$FFF4; 0
		dc.w $F005,    6,    3,	   2; 4
		dc.w	 9,  $10,    8,$FFF4; 8
		dc.w	 0		; 12
; ===============================================================================

loc_175B8:				; CODE XREF: ROM:000174DEj
		jmp	MarkObjGone
; ===============================================================================

j_AnimateSprite:			; CODE XREF: ROM:00017526p
		jmp	AnimateSprite
; ===============================================================================

j_ModifySpriteAttr_2P:			; CODE XREF: ROM:000174F8p
		jmp	ModifySpriteAttr_2P
; ===============================================================================

j_SpeedToPos:				; CODE XREF: ROM:0001752Ap
		jmp	SpeedToPos
; ===============================================================================
;----------------------------------------------------
; Object 54 - Snail badnik from	EHZ
;----------------------------------------------------

Obj54:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj54_Index(pc,d0.w),d1
		jmp	Obj54_Index(pc,d1.w)
; ===============================================================================
Obj54_Index:	dc.w Obj54_Init-Obj54_Index ; DATA XREF: ROM:Obj54_Indexo
					; ROM:000175E0o ...
		dc.w loc_17688-Obj54_Index
		dc.w loc_177B4-Obj54_Index
		dc.w loc_177EC-Obj54_Index
		dc.w loc_17772-Obj54_Index
; ===============================================================================

Obj54_Init:				; DATA XREF: ROM:Obj54_Indexo
		move.l	#Map_Obj54,4(a0)
		move.w	#$402,2(a0)
		bsr.w	j_ModifySpriteAttr_2P_3
		ori.b	#4,1(a0)
		move.b	#$A,$20(a0)
		move.b	#4,$18(a0)
		move.b	#$10,$19(a0)
		move.b	#$10,$16(a0)
		move.b	#$E,$17(a0)
		bsr.w	j_S1SingleObjectLoad2_1
		bne.s	loc_17670
		move.b	#$54,0(a1) ; 'T'
		move.b	#6,$24(a1)
		move.l	#Map_Obj54,4(a1)
		move.w	#$2402,2(a1)
		bsr.w	j_ModifyA1SpriteAttr_2P_0
		move.b	#3,$18(a1)
		move.b	#$10,$19(a1)
		move.b	$22(a0),$22(a1)
		move.b	1(a0),1(a1)
		move.l	a0,$2A(a1)
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		move.b	#2,$1A(a1)

loc_17670:				; CODE XREF: ROM:00017622j
		addq.b	#2,$24(a0)
		move.w	#$FF80,d0
		btst	#0,$22(a0)
		beq.s	loc_17682
		neg.w	d0

loc_17682:				; CODE XREF: ROM:0001767Ej
		move.w	d0,$10(a0)
		rts
; ===============================================================================

loc_17688:				; DATA XREF: ROM:000175E0o
		bsr.w	sub_176D0
		bsr.w	j_SpeedToPos_7
		jsr	ObjHitFloor
		cmpi.w	#$FFF8,d1
		blt.s	loc_176B4
		cmpi.w	#$C,d1
		bge.s	loc_176B4
		add.w	d1,$C(a0)
		lea	(Ani_Obj54).l,a1
		bsr.w	j_AnimateSprite_8
		bra.w	loc_1786C
; ===============================================================================

loc_176B4:				; CODE XREF: ROM:0001769Aj
					; ROM:000176A0j
		addq.b	#2,$24(a0)
		move.w	#$14,$30(a0)
		st	$34(a0)
		lea	(Ani_Obj54).l,a1
		bsr.w	j_AnimateSprite_8
		bra.w	loc_1786C

; =============== S U B R O U T I N E ==========================================


sub_176D0:				; CODE XREF: ROM:loc_17688p
		tst.b	$35(a0)
		bne.s	locret_17712
		move.w	(RAM_ObjRam_Sonic+$8).w,d0
		sub.w	8(a0),d0
		cmpi.w	#$64,d0	; 'd'
		bgt.s	locret_17712
		cmpi.w	#$FF9C,d0
		blt.s	locret_17712
		tst.w	d0
		bmi.s	loc_176F8
		btst	#0,$22(a0)
		beq.s	locret_17712
		bra.s	loc_17700
; ===============================================================================

loc_176F8:				; CODE XREF: sub_176D0+1Cj
		btst	#0,$22(a0)
		bne.s	locret_17712

loc_17700:				; CODE XREF: sub_176D0+26j
		move.w	$10(a0),d0
		asl.w	#2,d0
		move.w	d0,$10(a0)
		st	$35(a0)
		bsr.w	sub_17714

locret_17712:				; CODE XREF: sub_176D0+4j
					; sub_176D0+12j ...
		rts
; End of function sub_176D0


; =============== S U B R O U T I N E ==========================================


sub_17714:				; CODE XREF: sub_176D0+3Ep
		bsr.w	j_S1SingleObjectLoad2_1
		bne.s	locret_17770
		move.b	#$54,0(a1) ; 'T'
		move.b	#8,$24(a1)
		move.l	#Map_Obj4B,4(a1)
		move.w	#$3E6,2(a1)
		bsr.w	j_ModifyA1SpriteAttr_2P_0
		move.b	#4,$18(a1)
		move.b	#$10,$19(a1)
		move.b	$22(a0),$22(a1)
		move.b	1(a0),1(a1)
		move.l	a0,$2A(a1)
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		addq.w	#7,$C(a1)
		addi.w	#$D,8(a1)
		move.b	#1,$1C(a1)

locret_17770:				; CODE XREF: sub_17714+4j
		rts
; End of function sub_17714

; ===============================================================================

loc_17772:				; DATA XREF: ROM:000175E6o
		movea.l	$2A(a0),a1
		cmpi.b	#$54,(a1) ; 'T'
		bne.w	loc_17854
		tst.b	$34(a1)
		bne.w	loc_17854
		move.w	8(a1),8(a0)
		move.w	$C(a1),$C(a0)
		addq.w	#7,$C(a0)
		moveq	#$D,d0
		btst	#0,$22(a0)
		beq.s	loc_177A2
		neg.w	d0

loc_177A2:				; CODE XREF: ROM:0001779Ej
		add.w	d0,8(a0)
		lea	(Ani_Obj4B).l,a1
		bsr.w	j_AnimateSprite_8
		bra.w	loc_1786C
; ===============================================================================

loc_177B4:				; DATA XREF: ROM:000175E2o
		subi.w	#1,$30(a0)
		bpl.w	loc_1786C
		neg.w	$10(a0)
		bsr.w	j_ObjectFall_5
		move.w	$10(a0),d0
		asr.w	#2,d0
		move.w	d0,$10(a0)
		bchg	#0,$22(a0)
		bchg	#0,1(a0)
		subq.b	#2,$24(a0)
		sf	$34(a0)
		sf	$35(a0)
		bra.w	loc_1786C
; ===============================================================================

loc_177EC:				; DATA XREF: ROM:000175E4o
		movea.l	$2A(a0),a1
		cmpi.b	#$54,(a1) ; 'T'
		bne.w	loc_17854
		move.w	8(a1),8(a0)
		move.w	$C(a1),$C(a0)
		move.b	$22(a1),$22(a0)
		move.b	1(a1),1(a0)
		bra.w	loc_1786C
; ===============================================================================
Ani_Obj54:	dc.w byte_17818-Ani_Obj54 ; DATA XREF: ROM:000176A6o
					; ROM:000176C2o ...
		dc.w byte_1781C-Ani_Obj54
byte_17818:	dc.b   5,  0,  1,$FF	; 0 ; DATA XREF: ROM:Ani_Obj54o
byte_1781C:	dc.b   1,  0,  1,$FF	; 0 ; DATA XREF: ROM:00017816o
Map_Obj54:	dc.w word_17826-Map_Obj54 ; DATA XREF: ROM:Obj54_Inito
					; ROM:00017630o ...
		dc.w word_17838-Map_Obj54
		dc.w word_1784A-Map_Obj54
word_17826:	dc.w 2			; DATA XREF: ROM:Map_Obj54o
		dc.w $F00F,    0,    0,$FFF0; 0
		dc.w  $109,  $14,   $A,$FFF4; 4
word_17838:	dc.w 2			; DATA XREF: ROM:00017822o
		dc.w $F00F,    0,    0,$FFF0; 0
		dc.w  $109,$1014,$100A,$FFF4; 4
word_1784A:	dc.w 1			; DATA XREF: ROM:00017824o
		dc.w $FA05,  $10,    8,$FFE9; 0
; ===============================================================================

loc_17854:				; CODE XREF: ROM:0001777Aj
					; ROM:00017782j ...
		jmp	DeleteObject
; ===============================================================================

j_S1SingleObjectLoad2_1:		; CODE XREF: ROM:0001761Ep sub_17714p
		jmp	S1SingleObjectLoad2
; ===============================================================================

j_AnimateSprite_8:			; CODE XREF: ROM:000176ACp
					; ROM:000176C8p ...
		jmp	AnimateSprite
; ===============================================================================

j_ModifyA1SpriteAttr_2P_0:		; CODE XREF: ROM:0001763Ep
					; sub_17714+20p
		jmp	ModifyA1SpriteAttr_2P
; ===============================================================================

loc_1786C:				; CODE XREF: ROM:000176B0j
					; ROM:000176CCj ...
		jmp	loc_CEC6
; ===============================================================================

j_ModifySpriteAttr_2P_3:		; CODE XREF: ROM:000175F6p
		jmp	ModifySpriteAttr_2P
; ===============================================================================

j_ObjectFall_5:				; CODE XREF: ROM:000177C2p
		jmp	ObjectFall
; ===============================================================================

j_SpeedToPos_7:				; CODE XREF: ROM:0001768Cp
		jmp	SpeedToPos
; ===============================================================================
;----------------------------------------------------
; Object 57 - sub object of the	EHZ boss
;----------------------------------------------------

Obj57:					; DATA XREF: ROM:Obj_Indexo
					; ROM:0001833Co
		moveq	#0,d0
		move.b	$25(a0),d0
		move.w	off_17892(pc,d0.w),d1
		jmp	off_17892(pc,d1.w)
; ===============================================================================
off_17892:	dc.w loc_1789E-off_17892; 0 ; DATA XREF: ROM:off_17892o
					; ROM:off_17892+2o ...
		dc.w loc_178C4-off_17892; 1
		dc.w loc_17920-off_17892; 2
		dc.w loc_17952-off_17892; 3
		dc.w loc_1797C-off_17892; 4
		dc.w loc_17996-off_17892; 5
; ===============================================================================

loc_1789E:				; DATA XREF: ROM:off_17892o
		move.b	#0,$20(a0)
		cmpi.w	#$29D0,8(a0)
		ble.s	loc_178B6
		subi.w	#1,8(a0)
		bra.w	loc_181A8
; ===============================================================================

loc_178B6:				; CODE XREF: ROM:000178AAj
		move.w	#$29D0,8(a0)
		addq.b	#2,$25(a0)
		bra.w	loc_181A8
; ===============================================================================

loc_178C4:				; DATA XREF: ROM:off_17892o
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	off_178D2(pc,d0.w),d1
		jmp	off_178D2(pc,d1.w)
; ===============================================================================
off_178D2:	dc.w loc_178D6-off_178D2 ; DATA	XREF: ROM:off_178D2o
					; ROM:000178D4o
		dc.w loc_178FC-off_178D2
; ===============================================================================

loc_178D6:				; DATA XREF: ROM:off_178D2o
		cmpi.w	#$41E,$C(a0)
		bge.s	loc_178E8
		addi.w	#1,$C(a0)
		bra.w	loc_181A8
; ===============================================================================

loc_178E8:				; CODE XREF: ROM:000178DCj
		addq.b	#2,$2C(a0)
		bset	#0,$2D(a0)
		move.w	#$3C,$2A(a0) ; '<'
		bra.w	loc_181A8
; ===============================================================================

loc_178FC:				; DATA XREF: ROM:000178D4o
		subi.w	#1,$2A(a0)
		bpl.w	loc_181A8
		move.w	#$FE00,$10(a0)
		addq.b	#2,$25(a0)
		move.b	#$F,$20(a0)
		bset	#1,$2D(a0)
		bra.w	loc_181A8
; ===============================================================================

loc_17920:				; DATA XREF: ROM:off_17892o
		bsr.w	sub_17A8C
		bsr.w	sub_17A6A
		move.w	$2E(a0),d0
		lsr.w	#1,d0
		subi.w	#$14,d0
		move.w	d0,$C(a0)
		move.w	#0,$2E(a0)
		move.l	8(a0),d2
		move.w	$10(a0),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,d2
		move.l	d2,8(a0)
		bra.w	loc_181A8
; ===============================================================================

loc_17952:				; DATA XREF: ROM:off_17892o
		subq.w	#1,$3C(a0)
		bpl.w	BossDefeated
		bset	#0,$22(a0)
		bclr	#7,$22(a0)
		clr.w	$10(a0)
		addq.b	#2,$25(a0)
		move.w	#$FFDA,$3C(a0)
		move.w	#$C,$2A(a0)
		rts
; ===============================================================================

loc_1797C:				; DATA XREF: ROM:off_17892o
		addq.w	#1,$C(a0)
		subq.w	#1,$2A(a0)
		bpl.w	loc_181A8
		addq.b	#2,$25(a0)
		move.b	#0,$2C(a0)
		bra.w	loc_181A8
; ===============================================================================

loc_17996:				; DATA XREF: ROM:off_17892o
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	off_179A8(pc,d0.w),d1
		jsr	off_179A8(pc,d1.w)
		bra.w	loc_181A8
; ===============================================================================
off_179A8:	dc.w loc_179AE-off_179A8 ; DATA	XREF: ROM:off_179A8o
					; ROM:000179AAo ...
		dc.w loc_17A22-off_179A8
		dc.w loc_17A3C-off_179A8
; ===============================================================================

loc_179AE:				; DATA XREF: ROM:off_179A8o
		bclr	#0,$2D(a0)
		bsr.w	j_S1SingleObjectLoad2
		bne.w	loc_181A8
		move.b	#$58,0(a1) ; 'X'
		move.l	a0,$34(a1)
		move.l	#Map_Obj58,4(a1)
		move.w	#$2540,2(a1)
		move.b	#4,1(a1)
		move.b	#$20,$19(a1) ; ' '
		move.b	#4,$18(a1)
		move.l	8(a0),8(a1)
		move.l	$C(a0),$C(a1)
		addi.w	#$C,$C(a1)
		move.b	$22(a0),$22(a1)
		move.b	1(a0),1(a1)
		move.b	#8,$24(a1)
		move.b	#2,$1C(a1)
		move.w	#$10,$2A(a1)
		move.w	#$32,$2A(a0) ; '2'
		addq.b	#2,$2C(a0)
		rts
; ===============================================================================

loc_17A22:				; DATA XREF: ROM:000179AAo
		subi.w	#1,$2A(a0)
		bpl.s	locret_17A3A
		bset	#2,$2D(a0)
		move.w	#$60,$2A(a0) ; '`'
		addq.b	#2,$2C(a0)

locret_17A3A:				; CODE XREF: ROM:00017A28j
		rts
; ===============================================================================

loc_17A3C:				; DATA XREF: ROM:000179ACo
		subq.w	#1,$C(a0)
		subi.w	#1,$2A(a0)
		bpl.s	locret_17A68
		addq.w	#1,$C(a0)
		addq.w	#2,8(a0)
		cmpi.w	#$2B08,8(a0)
		bcs.s	locret_17A68
		tst.b	(RAM_Flag_Level_NoAnimals).w
		bne.s	locret_17A68
		move.b	#1,(RAM_Flag_Level_NoAnimals).w
		bra.w	loc_181AE
; ===============================================================================

locret_17A68:				; CODE XREF: ROM:00017A46j
					; ROM:00017A56j ...
		rts

; =============== S U B R O U T I N E ==========================================


sub_17A6A:				; CODE XREF: ROM:00017924p
					; ROM:loc_17C58p
		move.w	8(a0),d0
		cmpi.w	#$2720,d0
		ble.s	loc_17A7A
		cmpi.w	#$2B08,d0
		blt.s	locret_17A8A

loc_17A7A:				; CODE XREF: sub_17A6A+8j
		bchg	#0,$22(a0)
		bchg	#0,1(a0)
		neg.w	$10(a0)

locret_17A8A:				; CODE XREF: sub_17A6A+Ej
		rts
; End of function sub_17A6A


; =============== S U B R O U T I N E ==========================================


sub_17A8C:				; CODE XREF: ROM:loc_17920p
		cmpi.b	#6,$25(a0)
		bcc.s	locret_17AD2
		tst.b	$22(a0)
		bmi.s	loc_17AD4
		tst.b	$20(a0)
		bne.s	locret_17AD2
		tst.b	$3E(a0)
		bne.s	loc_17AB6
		move.b	#$20,$3E(a0) ; ' '
		move.w	#$AC,d0	; ''
		jsr	(PlaySound_Special).l

loc_17AB6:				; CODE XREF: sub_17A8C+18j
		lea	(RAM_Pal_2+$2).w,a1
		moveq	#0,d0
		tst.w	(a1)
		bne.s	loc_17AC4
		move.w	#$EEE,d0

loc_17AC4:				; CODE XREF: sub_17A8C+32j
		move.w	d0,(a1)
		subq.b	#1,$3E(a0)
		bne.s	locret_17AD2
		move.b	#$F,$20(a0)

locret_17AD2:				; CODE XREF: sub_17A8C+6j
					; sub_17A8C+12j ...
		rts
; ===============================================================================

loc_17AD4:				; CODE XREF: sub_17A8C+Cj
		moveq	#$64,d0	; 'd'
		bsr.w	AddPoints
		move.b	#6,$25(a0)
		move.w	#$B3,$3C(a0) ; ''
		bset	#3,$2D(a0)
		rts
; End of function sub_17A8C

; ===============================================================================
;----------------------------------------------------
; Object 58 - sub object of the	EHZ boss
;----------------------------------------------------

Obj58:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	off_17AFC(pc,d0.w),d1
		jmp	off_17AFC(pc,d1.w)
; ===============================================================================
off_17AFC:	dc.w loc_17B2A-off_17AFC ; DATA	XREF: ROM:off_17AFCo
					; ROM:00017AFEo ...
		dc.w loc_17BB0-off_17AFC
		dc.w loc_17C02-off_17AFC
		dc.w loc_17CE4-off_17AFC
		dc.w loc_17B06-off_17AFC
; ===============================================================================

loc_17B06:				; DATA XREF: ROM:00017B04o
		subi.w	#1,$C(a0)
		subi.w	#1,$2A(a0)
		bpl.w	loc_181A8
		move.b	#0,$24(a0)
		lea	(Ani_Obj58).l,a1
		bsr.w	j_AnimateSprite_9
		bra.w	loc_181A8
; ===============================================================================

loc_17B2A:				; DATA XREF: ROM:off_17AFCo
		moveq	#0,d0
		move.b	$25(a0),d0
		move.w	off_17B38(pc,d0.w),d1
		jmp	off_17B38(pc,d1.w)
; ===============================================================================
off_17B38:	dc.w loc_17B3C-off_17B38 ; DATA	XREF: ROM:off_17B38o
					; ROM:00017B3Ao
		dc.w loc_17B86-off_17B38
; ===============================================================================

loc_17B3C:				; DATA XREF: ROM:off_17B38o
		movea.l	$34(a0),a1
		cmpi.b	#$55,(a1) ; 'U'
		bne.w	loc_181AE
		btst	#0,$2D(a1)
		beq.s	loc_17B60
		move.b	#1,$1C(a0)
		move.w	#$18,$2A(a0)
		addq.b	#2,$25(a0)

loc_17B60:				; CODE XREF: ROM:00017B4Ej
		move.w	8(a1),8(a0)
		move.w	$C(a1),$C(a0)
		move.b	$22(a1),$22(a0)
		move.b	1(a1),1(a0)
		lea	(Ani_Obj58).l,a1
		bsr.w	j_AnimateSprite_9
		bra.w	loc_181A8
; ===============================================================================

loc_17B86:				; DATA XREF: ROM:00017B3Ao
		subi.w	#1,$2A(a0)
		bpl.s	loc_17BA2
		cmpi.w	#$FFF0,$2A(a0)
		ble.w	loc_181AE
		addi.w	#1,$C(a0)
		bra.w	loc_181A8
; ===============================================================================

loc_17BA2:				; CODE XREF: ROM:00017B8Cj
		lea	(Ani_Obj58).l,a1
		bsr.w	j_AnimateSprite_9
		bra.w	loc_181A8
; ===============================================================================

loc_17BB0:				; DATA XREF: ROM:00017AFEo
		movea.l	$34(a0),a1
		cmpi.b	#$55,(a1) ; 'U'
		bne.w	loc_181AE
		btst	#1,$2D(a1)
		beq.w	loc_181A8
		btst	#2,$2D(a1)
		bne.w	loc_17BF2
		move.w	8(a1),8(a0)
		move.w	$C(a1),$C(a0)
		addi.w	#8,$C(a0)
		move.b	$22(a1),$22(a0)
		move.b	1(a1),1(a0)
		bra.w	loc_181A8
; ===============================================================================

loc_17BF2:				; CODE XREF: ROM:00017BCCj
		move.b	#8,$1A(a0)
		move.b	#0,$18(a0)
		bra.w	loc_181A8
; ===============================================================================

loc_17C02:				; DATA XREF: ROM:00017B00o
		moveq	#0,d0
		move.b	$25(a0),d0
		move.w	off_17C10(pc,d0.w),d1
		jmp	off_17C10(pc,d1.w)
; ===============================================================================
off_17C10:	dc.w loc_17C18-off_17C10 ; DATA	XREF: ROM:off_17C10o
					; ROM:00017C12o ...
		dc.w loc_17C36-off_17C10
		dc.w loc_17C96-off_17C10
		dc.w loc_17CC2-off_17C10
; ===============================================================================

loc_17C18:				; DATA XREF: ROM:off_17C10o
		movea.l	$34(a0),a1
		cmpi.b	#$55,(a1) ; 'U'
		bne.w	loc_181AE
		btst	#1,$2D(a1)
		beq.w	loc_181A8
		addq.b	#2,$25(a0)
		bra.w	loc_181A8
; ===============================================================================

loc_17C36:				; DATA XREF: ROM:00017C12o
		movea.l	$34(a0),a1
		cmpi.b	#$55,(a1) ; 'U'
		bne.w	loc_181AE
		move.b	$22(a1),$22(a0)
		move.b	1(a1),1(a0)
		tst.b	$22(a0)
		bpl.s	loc_17C58
		addq.b	#2,$25(a0)

loc_17C58:				; CODE XREF: ROM:00017C52j
		bsr.w	sub_17A6A
		bsr.w	j_ObjectFall_6
		jsr	ObjHitFloor
		tst.w	d1
		bpl.s	loc_17C6E
		add.w	d1,$C(a0)

loc_17C6E:				; CODE XREF: ROM:00017C68j
		move.w	#$100,$12(a0)
		cmpi.b	#1,$18(a0)
		bne.s	loc_17C88
		move.w	$C(a0),d0
		movea.l	$34(a0),a1
		add.w	d0,$2E(a1)

loc_17C88:				; CODE XREF: ROM:00017C7Aj
		lea	(Ani_Obj58a).l,a1
		bsr.w	j_AnimateSprite_9
		bra.w	loc_181A8
; ===============================================================================

loc_17C96:				; DATA XREF: ROM:00017C14o
		subi.w	#1,$2A(a0)
		bpl.w	loc_181A8
		addq.b	#2,$25(a0)
		move.w	#$A,$2A(a0)
		move.w	#$FD00,$12(a0)
		cmpi.b	#1,$18(a0)
		beq.w	loc_181A8
		neg.w	$10(a0)
		bra.w	loc_181A8
; ===============================================================================

loc_17CC2:				; DATA XREF: ROM:00017C16o
		subq.w	#1,$2A(a0)
		bpl.w	loc_181A8
		bsr.w	j_ObjectFall_6
		bsr.w	ObjHitFloor
		tst.w	d1
		bpl.s	loc_17CE0
		move.w	#$FE00,$12(a0)
		add.w	d1,$C(a0)

loc_17CE0:				; CODE XREF: ROM:00017CD4j
		bra.w	loc_181B4
; ===============================================================================

loc_17CE4:				; DATA XREF: ROM:00017B02o
		movea.l	$34(a0),a1
		cmpi.b	#$55,(a1) ; 'U'
		bne.w	loc_181AE
		btst	#3,$2D(a1)
		bne.s	loc_17D4A
		bsr.w	sub_17D6A
		btst	#1,$2D(a1)
		beq.w	loc_181A8
		move.b	#$8B,$20(a0)
		move.w	8(a1),8(a0)
		move.w	$C(a1),$C(a0)
		move.b	$22(a1),$22(a0)
		move.b	1(a1),1(a0)
		addi.w	#$10,$C(a0)
		move.w	#$FFCA,d0
		btst	#0,$22(a0)
		beq.s	loc_17D38
		neg.w	d0

loc_17D38:				; CODE XREF: ROM:00017D34j
		add.w	d0,8(a0)
		lea	(Ani_Obj58a).l,a1
		bsr.w	j_AnimateSprite_9
		bra.w	loc_181A8
; ===============================================================================

loc_17D4A:				; CODE XREF: ROM:00017CF6j
		move.w	#$FFFD,d0
		btst	#0,$22(a0)
		beq.s	loc_17D58
		neg.w	d0

loc_17D58:				; CODE XREF: ROM:00017D54j
		add.w	d0,8(a0)
		lea	(Ani_Obj58a).l,a1
		bsr.w	j_AnimateSprite_9
		bra.w	loc_181A8

; =============== S U B R O U T I N E ==========================================


sub_17D6A:				; CODE XREF: ROM:00017CF8p
		cmpi.b	#1,$21(a1)
		beq.s	loc_17D74
		rts
; ===============================================================================

loc_17D74:				; CODE XREF: sub_17D6A+6j
		move.w	8(a0),d0
		sub.w	(RAM_ObjRam_Sonic+$8).w,d0
		bpl.s	loc_17D88
		btst	#0,$22(a1)
		bne.s	loc_17D92
		rts
; ===============================================================================

loc_17D88:				; CODE XREF: sub_17D6A+12j
		btst	#0,$22(a1)
		beq.s	loc_17D92
		rts
; ===============================================================================

loc_17D92:				; CODE XREF: sub_17D6A+1Aj
					; sub_17D6A+24j
		bset	#3,$2D(a1)
		rts
; End of function sub_17D6A


; =============== S U B R O U T I N E ==========================================


sub_17D9A:				; CODE XREF: ROM:loc_17F98p
		jsr	S1SingleObjectLoad2
		bne.s	loc_17E0E
		move.b	#$58,0(a1) ; 'X'
		move.l	a0,$34(a1)
		move.l	#Map_Obj58a,4(a1)
		move.w	#$24C0,2(a1)
		move.b	#4,1(a1)
		move.b	#$10,$19(a1)
		move.b	#1,$18(a1)
		move.b	#$10,$16(a1)
		move.b	#$10,$17(a1)
		move.l	8(a0),8(a1)
		move.l	$C(a0),$C(a1)
		addi.w	#$1C,8(a1)
		addi.w	#$C,$C(a1)
		move.w	#$FE00,$10(a1)
		move.b	#4,$24(a1)
		move.b	#4,$1A(a1)
		move.b	#1,$1C(a1)
		move.w	#$16,$2A(a1)

loc_17E0E:				; CODE XREF: sub_17D9A+6j
		jsr	S1SingleObjectLoad2
		bne.s	loc_17E82
		move.b	#$58,0(a1) ; 'X'
		move.l	a0,$34(a1)
		move.l	#Map_Obj58a,4(a1)
		move.w	#$24C0,2(a1)
		move.b	#4,1(a1)
		move.b	#$10,$19(a1)
		move.b	#1,$18(a1)
		move.b	#$10,$16(a1)
		move.b	#$10,$17(a1)
		move.l	8(a0),8(a1)
		move.l	$C(a0),$C(a1)
		addi.w	#$FFF4,8(a1)
		addi.w	#$C,$C(a1)
		move.w	#$FE00,$10(a1)
		move.b	#4,$24(a1)
		move.b	#4,$1A(a1)
		move.b	#1,$1C(a1)
		move.w	#$4B,$2A(a1) ; 'K'

loc_17E82:				; CODE XREF: sub_17D9A+7Aj
		jsr	S1SingleObjectLoad2
		bne.s	loc_17EF6
		move.b	#$58,0(a1) ; 'X'
		move.l	a0,$34(a1)
		move.l	#Map_Obj58a,4(a1)
		move.w	#$24C0,2(a1)
		move.b	#4,1(a1)
		move.b	#$10,$19(a1)
		move.b	#2,$18(a1)
		move.b	#$10,$16(a1)
		move.b	#$10,$17(a1)
		move.l	8(a0),8(a1)
		move.l	$C(a0),$C(a1)
		addi.w	#$FFD4,8(a1)
		addi.w	#$C,$C(a1)
		move.w	#$FE00,$10(a1)
		move.b	#4,$24(a1)
		move.b	#6,$1A(a1)
		move.b	#2,$1C(a1)
		move.w	#$30,$2A(a1) ; '0'

loc_17EF6:				; CODE XREF: sub_17D9A+EEj
		jsr	S1SingleObjectLoad2
		bne.s	locret_17F52
		move.b	#$58,0(a1) ; 'X'
		move.l	a0,$34(a1)
		move.l	#Map_Obj58a,4(a1)
		move.w	#$24C0,2(a1)
		move.b	#4,1(a1)
		move.b	#$10,$19(a1)
		move.b	#1,$18(a1)
		move.l	8(a0),8(a1)
		move.l	$C(a0),$C(a1)
		addi.w	#$FFCA,8(a1)
		addi.w	#8,$C(a1)
		move.b	#6,$24(a1)
		move.b	#1,$1A(a1)
		move.b	#0,$1C(a1)

locret_17F52:				; CODE XREF: sub_17D9A+162j
		rts
; End of function sub_17D9A

; ===============================================================================

loc_17F54:				; DATA XREF: ROM:000182FEo
		jsr	S1SingleObjectLoad2
		bne.s	loc_17F98
		move.b	#$58,0(a1) ; 'X'
		move.l	a0,$34(a1)
		move.l	#Map_Obj58a,4(a1)
		move.w	#$4C0,2(a1)
		move.b	#4,1(a1)
		move.b	#$20,$19(a1) ; ' '
		move.b	#2,$18(a1)
		move.l	8(a0),8(a1)
		move.l	$C(a0),$C(a1)
		move.b	#2,$24(a1)

loc_17F98:				; CODE XREF: ROM:00017F5Aj
		bsr.w	sub_17D9A
		subi.w	#8,$38(a0)
		move.w	#$2A00,8(a0)
		move.w	#$2C0,$C(a0)
		jsr	S1SingleObjectLoad2
		bne.s	locret_17FF8
		move.b	#$58,0(a1) ; 'X'
		move.l	a0,$34(a1)
		move.l	#Map_Obj58,4(a1)
		move.w	#$2540,2(a1)
		move.b	#4,1(a1)
		move.b	#$20,$19(a1) ; ' '
		move.b	#4,$18(a1)
		move.l	8(a0),8(a1)
		move.l	$C(a0),$C(a1)
		move.w	#$1E,$2A(a1)
		move.b	#0,$24(a1)

locret_17FF8:				; CODE XREF: ROM:00017FB4j
		rts
; ===============================================================================
Ani_Obj58:	dc.w byte_18000-Ani_Obj58 ; DATA XREF: ROM:00017B1Co
					; ROM:00017B78o ...
		dc.w byte_18004-Ani_Obj58
		dc.w byte_1801A-Ani_Obj58
byte_18000:	dc.b   1,  5,  6,$FF	; 0 ; DATA XREF: ROM:Ani_Obj58o
byte_18004:	dc.b   1,  1,  1,  1,  2,  2,  2,  3,  3,  3,  4,  4,  4,  0,  0,  0; 0
					; DATA XREF: ROM:00017FFCo
		dc.b   0,  0,  0,  0,  0,$FF; 16
byte_1801A:	dc.b   1,  0,  0,  0,  0,  0,  0,  0,  0,  4,  4,  4,  3,  3,  3,  2; 0
					; DATA XREF: ROM:00017FFEo
		dc.b   2,  2,  1,  1,  1,  5,  6,$FE,  2,  0; 16
Map_Obj58:	dc.w word_18042-Map_Obj58 ; DATA XREF: ROM:000179C6o
					; ROM:00017FC0o ...
		dc.w word_1804C-Map_Obj58
		dc.w word_18076-Map_Obj58
		dc.w word_180A0-Map_Obj58
		dc.w word_180BA-Map_Obj58
		dc.w word_180D4-Map_Obj58
		dc.w word_180EE-Map_Obj58
word_18042:	dc.w 1			; DATA XREF: ROM:Map_Obj58o
		dc.w $D805,    0,    0,	   2; 0
word_1804C:	dc.w 5			; DATA XREF: ROM:00018036o
		dc.w $D805,    4,    2,	   2; 0
		dc.w $D80D,   $C,    6,	 $12; 4
		dc.w $D80D,   $C,    6,	 $32; 8
		dc.w $D80D,   $C,    6,$FFE2; 12
		dc.w $D80D,   $C,    6,$FFC2; 16
word_18076:	dc.w 5			; DATA XREF: ROM:00018038o
		dc.w $D805,    4,    2,	   2; 0
		dc.w $D80D,   $C,    6,	 $12; 4
		dc.w $D805,    8,    4,	 $32; 8
		dc.w $D80D,   $C,    6,$FFE2; 12
		dc.w $D805,    8,    4,$FFD2; 16
word_180A0:	dc.w 3			; DATA XREF: ROM:0001803Ao
		dc.w $D805,    4,    2,	   2; 0
		dc.w $D80D,   $C,    6,	 $12; 4
		dc.w $D80D,   $C,    6,$FFE2; 8
word_180BA:	dc.w 3			; DATA XREF: ROM:0001803Co
		dc.w $D805,    4,    2,	   2; 0
		dc.w $D805,    8,    4,	 $12; 4
		dc.w $D805,    8,    4,$FFF2; 8
word_180D4:	dc.w 3			; DATA XREF: ROM:0001803Eo
		dc.w $D805,    0,    0,	   2; 0
		dc.w $D80D,   $C,    6,	 $12; 4
		dc.w $D80D,   $C,    6,	 $32; 8
word_180EE:	dc.w 3			; DATA XREF: ROM:00018040o
		dc.w $D805,    4,    2,	   2; 0
		dc.w $D80D,   $C,    6,$FFE2; 4
		dc.w $D80D,   $C,    6,$FFC2; 8
Ani_Obj58a:	dc.w byte_1810E-Ani_Obj58a ; DATA XREF:	ROM:loc_17C88o
					; ROM:00017D3Co ...
		dc.w byte_18113-Ani_Obj58a
		dc.w byte_18117-Ani_Obj58a
byte_1810E:	dc.b   5,  1,  2,  3,$FF; 0 ; DATA XREF: ROM:Ani_Obj58ao
byte_18113:	dc.b   1,  4,  5,$FF	; 0 ; DATA XREF: ROM:0001810Ao
byte_18117:	dc.b   1,  6,  7,$FF,  0; 0 ; DATA XREF: ROM:0001810Co
Map_Obj58a:	dc.w word_1812E-Map_Obj58a ; DATA XREF:	sub_17D9A+12o
					; sub_17D9A+86o ...
		dc.w word_18148-Map_Obj58a
		dc.w word_18152-Map_Obj58a
		dc.w word_1815C-Map_Obj58a
		dc.w word_18166-Map_Obj58a
		dc.w word_18170-Map_Obj58a
		dc.w word_1817A-Map_Obj58a
		dc.w word_18184-Map_Obj58a
		dc.w word_1818E-Map_Obj58a
word_1812E:	dc.w 3			; DATA XREF: ROM:Map_Obj58ao
		dc.w $F00F,    0,    0,$FFD0; 0
		dc.w $F00F,  $10,    8,$FFF0; 4
		dc.w $F00F,  $20,  $10,	 $10; 8
word_18148:	dc.w 1			; DATA XREF: ROM:0001811Eo
		dc.w $F00F,  $30,  $18,$FFF0; 0
word_18152:	dc.w 1			; DATA XREF: ROM:00018120o
		dc.w $F00F,  $40,  $20,$FFF0; 0
word_1815C:	dc.w 1			; DATA XREF: ROM:00018122o
		dc.w $F00F,  $50,  $28,$FFF0; 0
word_18166:	dc.w 1			; DATA XREF: ROM:00018124o
		dc.w $F00F,  $60,  $30,$FFF0; 0
word_18170:	dc.w 1			; DATA XREF: ROM:00018126o
		dc.w $F00F,$1060,$1030,$FFF0; 0
word_1817A:	dc.w 1			; DATA XREF: ROM:00018128o
		dc.w $F00F,  $70,  $38,$FFF0; 0
word_18184:	dc.w 1			; DATA XREF: ROM:0001812Ao
		dc.w $F00F,$1070,$1038,$FFF0; 0
word_1818E:	dc.w 3			; DATA XREF: ROM:0001812Co
		dc.w $F00F,$8000,$8000,$FFD0; 0
		dc.w $F00F,$8010,$8008,$FFF0; 4
		dc.w $F00F,$8020,$8010,	 $10; 8
; ===============================================================================

loc_181A8:				; CODE XREF: ROM:000178B2j
					; ROM:000178C0j ...
		jmp	DisplaySprite
; ===============================================================================

loc_181AE:				; CODE XREF: ROM:00017A64j
					; ROM:00017B44j ...
		jmp	DeleteObject
; ===============================================================================

loc_181B4:				; CODE XREF: ROM:loc_17CE0j
		jmp	MarkObjGone
; ===============================================================================

j_S1SingleObjectLoad2:			; CODE XREF: ROM:000179B4p
		jmp	S1SingleObjectLoad2
; ===============================================================================

j_AnimateSprite_9:			; CODE XREF: ROM:00017B22p
					; ROM:00017B7Ep ...
		jmp	AnimateSprite
; ===============================================================================

j_ObjectFall_6:				; CODE XREF: ROM:00017C5Cp
					; ROM:00017CCAp
		jmp	ObjectFall
; ===============================================================================

Obj55:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj55_Index(pc,d0.w),d1
		jmp	Obj55_Index(pc,d1.w)
; ===============================================================================
Obj55_Index:	dc.w loc_181E4-Obj55_Index; 0 ;	DATA XREF: ROM:Obj55_Indexo
					; ROM:Obj55_Index+2o ...
		dc.w loc_18302-Obj55_Index; 1
		dc.w loc_18340-Obj55_Index; 2
		dc.w loc_18372-Obj55_Index; 3
		dc.w loc_18410-Obj55_Index; 4
; ===============================================================================

loc_181E4:				; DATA XREF: ROM:Obj55_Indexo
		move.l	#Map_Obj55,4(a0)
		move.w	#$2400,2(a0)
		ori.b	#4,1(a0)
		move.b	#$20,$19(a0) ; ' '
		move.b	#3,$18(a0)
		move.b	#$F,$20(a0)
		move.b	#8,$21(a0)
		addq.b	#2,$24(a0)
		move.w	8(a0),$30(a0)
		move.w	$C(a0),$38(a0)
		move.b	$28(a0),d0
		cmpi.b	#$81,d0
		bne.s	loc_18230
		addi.w	#$60,2(a0) ; '`'

loc_18230:				; CODE XREF: ROM:00018228j
		jsr	S1SingleObjectLoad2
		bne.w	loc_182E8
		move.b	#$55,0(a1) ; 'U'
		move.l	a0,$34(a1)
		move.l	a1,$34(a0)
		move.l	#Map_Obj55,4(a1)
		move.w	#$400,2(a1)
		move.b	#4,1(a1)
		move.b	#$20,$19(a1) ; ' '
		move.b	#3,$18(a1)
		move.l	8(a0),8(a1)
		move.l	$C(a0),$C(a1)
		addq.b	#4,$24(a1)
		move.b	#1,$1C(a1)
		move.b	1(a0),1(a1)
		move.b	$28(a0),d0
		cmpi.b	#$81,d0
		bne.s	loc_18294
		addi.w	#$60,2(a1) ; '`'

loc_18294:				; CODE XREF: ROM:0001828Cj
		tst.b	$28(a0)
		bmi.s	loc_182E8
		jsr	S1SingleObjectLoad2
		bne.s	loc_182E8
		move.b	#$55,0(a1) ; 'U'
		move.l	a0,$34(a1)

loc_182AC:
		move.l	#Map_Obj55a,4(a1)
		move.w	#$4D0,2(a1)
		move.b	#1,$1E(a0)

loc_182C0:
		move.b	#4,1(a1)
		move.b	#$20,$19(a1) ; ' '
		move.b	#3,$18(a1)
		move.l	8(a0),8(a1)
		move.l	$C(a0),$C(a1)
		addq.b	#6,$24(a1)
		move.b	1(a0),1(a1)

loc_182E8:				; CODE XREF: ROM:00018236j
					; ROM:00018298j ...
		move.b	$28(a0),d0
		andi.w	#$7F,d0	; ''
		add.w	d0,d0
		add.w	d0,d0
		movea.l	dword_182FA(pc,d0.w),a1
		jmp	(a1)
; ===============================================================================
dword_182FA:	dc.l 0
		dc.l loc_17F54
; ===============================================================================

loc_18302:				; DATA XREF: ROM:Obj55_Indexo
		move.b	$28(a0),d0
		andi.w	#$7F,d0	; ''
		add.w	d0,d0
		add.w	d0,d0
		movea.l	dword_18338(pc,d0.w),a1
		jsr	(a1)
		lea	(Ani_Obj55a).l,a1
		jsr	AnimateSprite
		move.b	$22(a0),d0
		andi.b	#3,d0
		andi.b	#$FC,1(a0)
		or.b	d0,1(a0)
		jmp	DisplaySprite
; ===============================================================================
dword_18338:	dc.l 0
		dc.l Obj57
; ===============================================================================

loc_18340:				; DATA XREF: ROM:Obj55_Indexo
		movea.l	$34(a0),a1
		move.l	8(a1),8(a0)
		move.l	$C(a1),$C(a0)
		move.b	$22(a1),$22(a0)
		move.b	1(a1),1(a0)
		movea.l	#Ani_Obj55a,a1
		jsr	AnimateSprite
		jmp	DisplaySprite
; ===============================================================================
byte_1836E:	dc.b   0,$FF,  1,  0	; 0
; ===============================================================================

loc_18372:				; DATA XREF: ROM:Obj55_Indexo
		btst	#7,$22(a0)
		bne.s	loc_183C6
		movea.l	$34(a0),a1
		move.l	8(a1),8(a0)
		move.l	$C(a1),$C(a0)
		move.b	$22(a1),$22(a0)
		move.b	1(a1),1(a0)
		subq.b	#1,$1E(a0)
		bpl.s	loc_183BA
		move.b	#1,$1E(a0)
		move.b	$2A(a0),d0
		addq.b	#1,d0
		cmpi.b	#2,d0
		ble.s	loc_183B0
		moveq	#0,d0

loc_183B0:				; CODE XREF: ROM:000183ACj
		move.b	byte_1836E(pc,d0.w),$1A(a0)
		move.b	d0,$2A(a0)

loc_183BA:				; CODE XREF: ROM:0001839Aj
		cmpi.b	#$FF,$1A(a0)
		bne.w	loc_185D4
		rts
; ===============================================================================

loc_183C6:				; CODE XREF: ROM:00018378j
		movea.l	$34(a0),a1
		btst	#6,$2E(a1)
		bne.s	loc_183D4
		rts
; ===============================================================================

loc_183D4:				; CODE XREF: ROM:000183D0j
		addq.b	#2,$24(a0)
		move.l	#Map_Obj55b,4(a0)
		move.w	#$4D8,2(a0)
		move.b	#0,$1A(a0)
		move.b	#5,$1E(a0)
		movea.l	$34(a0),a1
		move.w	8(a1),8(a0)
		move.w	$C(a1),$C(a0)
		addi.w	#4,$C(a0)
		subi.w	#$28,8(a0) ; '('
		rts
; ===============================================================================

loc_18410:				; DATA XREF: ROM:Obj55_Indexo
		subq.b	#1,$1E(a0)
		bpl.s	loc_18452
		move.b	#5,$1E(a0)
		addq.b	#1,$1A(a0)
		cmpi.b	#4,$1A(a0)
		bne.w	loc_18452
		move.b	#0,$1A(a0)
		movea.l	$34(a0),a1
		move.b	(a1),d0
		beq.w	loc_185DA
		move.w	8(a1),8(a0)
		move.w	$C(a1),$C(a0)
		addi.w	#4,$C(a0)
		subi.w	#$28,8(a0) ; '('

loc_18452:				; CODE XREF: ROM:00018414j
					; ROM:00018426j
		bra.w	loc_185D4
; ===============================================================================

Obj56:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj56_Index(pc,d0.w),d1
		jmp	Obj56_Index(pc,d1.w)
; ===============================================================================
Obj56_Index:	dc.w Obj56_Init-Obj56_Index ; DATA XREF: ROM:Obj56_Indexo
					; ROM:00018466o
		dc.w Obj56_Animate-Obj56_Index
; ===============================================================================

Obj56_Init:				; DATA XREF: ROM:Obj56_Indexo
		addq.b	#2,$24(a0)
		move.l	#Map_Obj56,4(a0)
		move.w	#$5A0,2(a0)
		move.b	#4,1(a0)
		move.b	#1,$18(a0)
		move.b	#0,$20(a0)
		move.b	#$C,$19(a0)
		move.b	#7,$1E(a0)
		move.b	#0,$1A(a0)
		rts
; ===============================================================================

Obj56_Animate:				; DATA XREF: ROM:00018466o
		subq.b	#1,$1E(a0)
		bpl.s	loc_184BA
		move.b	#7,$1E(a0)
		addq.b	#1,$1A(a0)
		cmpi.b	#7,$1A(a0)
		beq.w	loc_185DA

loc_184BA:				; CODE XREF: ROM:000184A4j
		bra.w	loc_185D4
; ===============================================================================
Map_Obj55a:	dc.w word_184C2-Map_Obj55a ; DATA XREF:	ROM:loc_182ACo
					; ROM:Map_Obj55ao ...
		dc.w word_184CC-Map_Obj55a
word_184C2:	dc.w 1			; DATA XREF: ROM:Map_Obj55ao
		dc.w	 5,    0,    0,	 $1C; 0
word_184CC:	dc.w 1			; DATA XREF: ROM:000184C0o
		dc.w	 5,    4,    2,	 $1C; 0
Map_Obj55b:	dc.w word_184DE-Map_Obj55b ; DATA XREF:	ROM:000183D8o
					; ROM:Map_Obj55bo ...
		dc.w word_184E8-Map_Obj55b
		dc.w word_184F2-Map_Obj55b
		dc.w word_184FC-Map_Obj55b
word_184DE:	dc.w 1			; DATA XREF: ROM:Map_Obj55bo
		dc.w $F805,    0,    0,$FFF8; 0
word_184E8:	dc.w 1			; DATA XREF: ROM:000184D8o
		dc.w $F805,    4,    2,$FFF8; 0
word_184F2:	dc.w 1			; DATA XREF: ROM:000184DAo
		dc.w $F805,    8,    4,$FFF8; 0
word_184FC:	dc.w 1			; DATA XREF: ROM:000184DCo
		dc.w $F805,   $C,    6,$FFF8; 0
Map_Obj56:	dc.w word_18514-Map_Obj56 ; DATA XREF: ROM:0001846Co
					; ROM:Map_Obj56o ...
		dc.w word_1851E-Map_Obj56
		dc.w word_18528-Map_Obj56
		dc.w word_18532-Map_Obj56
		dc.w word_1853C-Map_Obj56
		dc.w word_18546-Map_Obj56
		dc.w word_18550-Map_Obj56
word_18514:	dc.w 1			; DATA XREF: ROM:Map_Obj56o
		dc.w $F805,    0,    0,$FFF8; 0
word_1851E:	dc.w 1			; DATA XREF: ROM:00018508o
		dc.w $F00F,    4,    2,$FFF0; 0
word_18528:	dc.w 1			; DATA XREF: ROM:0001850Ao
		dc.w $F00F,  $14,   $A,$FFF0; 0
word_18532:	dc.w 1			; DATA XREF: ROM:0001850Co
		dc.w $F00F,  $24,  $12,$FFF0; 0
word_1853C:	dc.w 1			; DATA XREF: ROM:0001850Eo
		dc.w $F00F,  $34,  $1A,$FFF0; 0
word_18546:	dc.w 1			; DATA XREF: ROM:00018510o
		dc.w $F00F,  $44,  $22,$FFF0; 0
word_18550:	dc.w 1			; DATA XREF: ROM:00018512o
		dc.w $F00F,  $54,  $2A,$FFF0; 0
Ani_Obj55a:	dc.w byte_1855E-Ani_Obj55a ; DATA XREF:	ROM:00018314o
					; ROM:0001835Co ...
		dc.w byte_18561-Ani_Obj55a
byte_1855E:	dc.b  $F,  0,$FF	; 0 ; DATA XREF: ROM:Ani_Obj55ao
byte_18561:	dc.b   7,  1,  2,$FF,  0; 0 ; DATA XREF: ROM:0001855Co
Map_Obj55:	dc.w word_1856C-Map_Obj55 ; DATA XREF: ROM:loc_181E4o
					; ROM:00018248o ...
		dc.w word_1858E-Map_Obj55
		dc.w word_185B0-Map_Obj55
word_1856C:	dc.w 4			; DATA XREF: ROM:Map_Obj55o
		dc.w $F805,    0,    0,$FFE0; 0
		dc.w  $805,    4,    2,$FFE0; 4
		dc.w $F80F,    8,    4,$FFF0; 8
		dc.w $F807,  $18,   $C,	 $10; 12
word_1858E:	dc.w 4			; DATA XREF: ROM:00018568o
		dc.w $E805,  $28,  $14,$FFE0; 0
		dc.w $E80D,  $30,  $18,$FFF0; 4
		dc.w $E805,  $24,  $12,	 $10; 8
		dc.w $D805,  $20,  $10,	   2; 12
word_185B0:	dc.w 4			; DATA XREF: ROM:0001856Ao
		dc.w $E805,  $28,  $14,$FFE0; 0
		dc.w $E80D,  $38,  $1C,$FFF0; 4
		dc.w $E805,  $24,  $12,	 $10; 8
		dc.w $D805,  $20,  $10,	   2; 12
; ===============================================================================
		nop

loc_185D4:				; CODE XREF: ROM:000183C0j
					; ROM:loc_18452j ...
		jmp	DisplaySprite
; ===============================================================================

loc_185DA:				; CODE XREF: ROM:00018436j
					; ROM:000184B6j
		jmp	DeleteObject
; ===============================================================================

Obj8A:					; DATA XREF: ROM:Obj_Indexo
		moveq	#0,d0

loc_185E2:
		move.b	$24(a0),d0
		move.w	off_185EE(pc,d0.w),d1
		jmp	off_185EE(pc,d1.w)
; ===============================================================================
off_185EE:	dc.w loc_185F2-off_185EE
		dc.w loc_18660-off_185EE
; ===============================================================================

loc_185F2:
		addq.b	#2,$24(a0)
		move.w	#$120,8(a0)
		move.w	#$F0,$A(a0) ; ''
		move.l	#Map_Obj8A,4(a0)
		move.w	#$5A0,2(a0)
		bsr.w	j_ModifySpriteAttr_2P_4
		move.w	(RAM_S1_CreditsID).w,d0
		move.b	d0,$1A(a0)
		move.b	#0,1(a0)
		move.b	#0,$18(a0)
		cmpi.b	#ModeId_TitleScr,(RAM_GameMode).w
		bne.s	loc_18660
		move.w	#$300,2(a0)
		bsr.w	j_ModifySpriteAttr_2P_4
		move.b	#$A,$1A(a0)
		tst.b	(RAM_SndDrv_PlaySnd).w
		beq.s	loc_18660
		cmpi.b	#$72,(RAM_Control_1_Hold).w
		bne.s	loc_18660

loc_1864E:
		move.w	#$EEE,(RAM_Pal_3_FadeTo).w
		move.w	#$880,(RAM_Pal_3_FadeTo+$2).w
		jmp	DeleteObject
; ===============================================================================

loc_18660:
		jmp	DisplaySprite
; ===============================================================================
Map_Obj8A:	dc.w word_1867C-Map_Obj8A
		dc.w word_186EE-Map_Obj8A
		dc.w word_18770-Map_Obj8A
		dc.w word_187C2-Map_Obj8A
		dc.w word_18884-Map_Obj8A
		dc.w word_18926-Map_Obj8A
		dc.w word_189F8-Map_Obj8A
		dc.w word_18AB2-Map_Obj8A
		dc.w word_18BAC-Map_Obj8A
		dc.w word_18C26-Map_Obj8A
		dc.w word_18C68-Map_Obj8A
word_1867C:	dc.w $E			; DATA XREF: ROM:Map_Obj8Ao
		dc.w $F805,  $2E,  $17,$FF88; 0
		dc.w $F805,  $26,  $13,$FF98; 4
		dc.w $F805,  $1A,   $D,$FFA8; 8
		dc.w $F801,  $46,  $23,$FFB8; 12
		dc.w $F805,  $1E,   $F,$FFC0; 16
		dc.w $F805,  $3E,  $1F,$FFD8; 20
		dc.w $F805,   $E,    7,$FFE8; 24
		dc.w $F805,    4,    2,$FFF8; 28
		dc.w $F809,    8,    4,	   8; 32
		dc.w $F805,  $2E,  $17,	 $28; 36
		dc.w $F805,  $3E,  $1F,	 $38; 40
		dc.w $F805,    4,    2,	 $48; 44
		dc.w $F805,  $5C,  $2E,	 $58; 48
		dc.w $F805,  $5C,  $2E,	 $68; 52
word_186EE:	dc.w $10		; DATA XREF: ROM:00018668o
		dc.w $D805,    0,    0,$FF80; 0
		dc.w $D805,    4,    2,$FF90; 4
		dc.w $D809,    8,    4,$FFA0; 8
		dc.w $D805,   $E,    7,$FFB4; 12
		dc.w $D805,  $12,    9,$FFD0; 16
		dc.w $D805,  $16,   $B,$FFE0; 20
		dc.w $D805,    4,    2,$FFF0; 24
		dc.w $D805,  $1A,   $D,	   0; 28
		dc.w  $805,  $1E,   $F,$FFC8; 32
		dc.w  $805,    4,    2,$FFD8; 36
		dc.w  $805,  $22,  $11,$FFE8; 40
		dc.w  $805,  $26,  $13,$FFF8; 44
		dc.w  $805,  $16,   $B,	   8; 48
		dc.w  $805,  $2A,  $15,	 $20; 52
		dc.w  $805,    4,    2,	 $30; 56
		dc.w  $805,  $2E,  $17,	 $44; 60
word_18770:	dc.w $A			; DATA XREF: ROM:0001866Ao
		dc.w $D805,  $12,    9,$FF80; 0
		dc.w $D805,  $22,  $11,$FF90; 4
		dc.w $D805,  $26,  $13,$FFA0; 8
		dc.w $D805,    0,    0,$FFB0; 12
		dc.w $D805,  $22,  $11,$FFC0; 16
		dc.w $D805,    4,    2,$FFD0; 20
		dc.w $D809,    8,    4,$FFE0; 24
		dc.w  $805,  $2A,  $15,$FFE8; 28
		dc.w  $805,  $32,  $19,$FFF8; 32
		dc.w  $805,  $36,  $1B,	   8; 36
word_187C2:	dc.w $18		; DATA XREF: ROM:0001866Co
		dc.w $D805,  $1E,   $F,$FF88; 0
		dc.w $D805,  $3A,  $1D,$FF98; 4
		dc.w $D805,    4,    2,$FFA8; 8
		dc.w $D805,  $22,  $11,$FFB8; 12
		dc.w $D805,    4,    2,$FFC8; 16
		dc.w $D805,  $1E,   $F,$FFD8; 20
		dc.w $D805,  $3E,  $1F,$FFE8; 24
		dc.w $D805,   $E,    7,$FFF8; 28
		dc.w $D805,  $22,  $11,	   8; 32
		dc.w $D805,  $42,  $21,	 $20; 36
		dc.w $D805,   $E,    7,	 $30; 40
		dc.w $D805,  $2E,  $17,	 $40; 44
		dc.w $D801,  $46,  $23,	 $50; 48
		dc.w $D805,    0,    0,	 $58; 52
		dc.w $D805,  $1A,   $D,	 $68; 56
		dc.w  $805,  $48,  $24,$FFC0; 60
		dc.w  $801,  $46,  $23,$FFD0; 64
		dc.w  $805,    0,    0,$FFD8; 68
		dc.w  $801,  $46,  $23,$FFE8; 72
		dc.w  $805,  $2E,  $17,$FFF0; 76
		dc.w  $805,  $16,   $B,	   0; 80
		dc.w  $805,    4,    2,	 $10; 84
		dc.w  $805,  $1A,   $D,	 $20; 88
		dc.w  $805,  $42,  $21,	 $30; 92
word_18884:	dc.w $14		; DATA XREF: ROM:0001866Eo
		dc.w $D005,  $42,  $21,$FFA0; 0
		dc.w $D005,   $E,    7,$FFB0; 4
		dc.w $D005,  $2E,  $17,$FFC0; 8
		dc.w $D001,  $46,  $23,$FFD0; 12
		dc.w $D005,    0,    0,$FFD8; 16
		dc.w $D005,  $1A,   $D,$FFE8; 20
		dc.w	 5,  $4C,  $26,$FFE8; 24
		dc.w	 1,  $46,  $23,$FFF8; 28
		dc.w	 5,  $1A,   $D,	   4; 32
		dc.w	 5,  $2A,  $15,	 $14; 36
		dc.w	 5,    4,    2,	 $24; 40
		dc.w $2005,  $12,    9,$FFD0; 44
		dc.w $2005,  $3A,  $1D,$FFE0; 48
		dc.w $2005,   $E,    7,$FFF0; 52
		dc.w $2005,  $1A,   $D,	   0; 56
		dc.w $2001,  $46,  $23,	 $10; 60
		dc.w $2005,  $50,  $28,	 $18; 64
		dc.w $2005,  $22,  $11,	 $30; 68
		dc.w $2001,  $46,  $23,	 $40; 72
		dc.w $2005,   $E,    7,	 $48; 76
word_18926:	dc.w $1A		; DATA XREF: ROM:00018670o
		dc.w $D805,  $2E,  $17,$FF98; 0
		dc.w $D805,  $26,  $13,$FFA8; 4
		dc.w $D805,  $32,  $19,$FFB8; 8
		dc.w $D805,  $1A,   $D,$FFC8; 12
		dc.w $D805,  $54,  $2A,$FFD8; 16
		dc.w $D805,  $12,    9,$FFF8; 20
		dc.w $D805,  $22,  $11,	   8; 24
		dc.w $D805,  $26,  $13,	 $18; 28
		dc.w $D805,  $42,  $21,	 $28; 32
		dc.w $D805,  $32,  $19,	 $38; 36
		dc.w $D805,  $1E,   $F,	 $48; 40
		dc.w $D805,   $E,    7,	 $58; 44
		dc.w  $809,    8,    4,$FF88; 48
		dc.w  $805,    4,    2,$FF9C; 52
		dc.w  $805,  $2E,  $17,$FFAC; 56
		dc.w  $805,    4,    2,$FFBC; 60
		dc.w  $805,  $3E,  $1F,$FFCC; 64
		dc.w  $805,  $26,  $13,$FFDC; 68
		dc.w  $805,  $1A,   $D,$FFF8; 72
		dc.w  $805,    4,    2,	   8; 76
		dc.w  $805,  $58,  $2C,	 $18; 80
		dc.w  $805,    4,    2,	 $28; 84
		dc.w  $809,    8,    4,	 $38; 88
		dc.w  $805,  $32,  $19,	 $4C; 92
		dc.w  $805,  $22,  $11,	 $5C; 96
		dc.w  $805,    4,    2,	 $6C; 100
word_189F8:	dc.w $17		; DATA XREF: ROM:00018672o
		dc.w $D005,  $2E,  $17,$FF98; 0
		dc.w $D005,  $26,  $13,$FFA8; 4
		dc.w $D005,  $32,  $19,$FFB8; 8
		dc.w $D005,  $1A,   $D,$FFC8; 12
		dc.w $D005,  $54,  $2A,$FFD8; 16
		dc.w $D005,  $12,    9,$FFF8; 20
		dc.w $D005,  $22,  $11,	   8; 24
		dc.w $D005,  $26,  $13,	 $18; 28
		dc.w $D005,    0,    0,	 $28; 32
		dc.w $D005,  $22,  $11,	 $38; 36
		dc.w $D005,    4,    2,	 $48; 40
		dc.w $D009,    8,    4,	 $58; 44
		dc.w	 5,  $4C,  $26,$FFD0; 48
		dc.w	 1,  $46,  $23,$FFE0; 52
		dc.w	 9,    8,    4,$FFE8; 56
		dc.w	 1,  $46,  $23,$FFFC; 60
		dc.w	 5,  $3E,  $1F,	   4; 64
		dc.w	 5,    4,    2,	 $14; 68
		dc.w $2009,    8,    4,$FFD0; 72
		dc.w $2005,    4,    2,$FFE4; 76
		dc.w $2005,  $1E,   $F,$FFF4; 80
		dc.w $2005,  $58,  $2C,	   4; 84
		dc.w $2005,  $2A,  $15,	 $14; 88
word_18AB2:	dc.w $1F		; DATA XREF: ROM:00018674o
		dc.w $D805,  $2E,  $17,$FF80; 0
		dc.w $D805,  $12,    9,$FF90; 4
		dc.w $D805,   $E,    7,$FFA0; 8
		dc.w $D805,  $1E,   $F,$FFB0; 12
		dc.w $D801,  $46,  $23,$FFC0; 16
		dc.w $D805,    4,    2,$FFC8; 20
		dc.w $D805,  $16,   $B,$FFD8; 24
		dc.w $D805,  $3E,  $1F,$FFF8; 28
		dc.w $D805,  $3A,  $1D,	   8; 32
		dc.w $D805,    4,    2,	 $18; 36
		dc.w $D805,  $1A,   $D,	 $28; 40
		dc.w $D805,  $58,  $2C,	 $38; 44
		dc.w $D805,  $2E,  $17,	 $48; 48
		dc.w	 5,  $5C,  $2E,$FFB0; 52
		dc.w	 5,  $32,  $19,$FFC0; 56
		dc.w	 5,  $4C,  $26,$FFD0; 60
		dc.w	 1,  $46,  $23,$FFE0; 64
		dc.w	 5,  $26,  $13,$FFE8; 68
		dc.w	 9,    8,    4,	   0; 72
		dc.w	 1,  $46,  $23,	 $14; 76
		dc.w	 5,  $1A,   $D,	 $1C; 80
		dc.w	 5,   $E,    7,	 $2C; 84
		dc.w	 5,    0,    0,	 $3C; 88
		dc.w	 1,  $46,  $23,	 $4C; 92
		dc.w	 5,  $2E,  $17,	 $54; 96
		dc.w	 5,  $3A,  $1D,	 $64; 100
		dc.w	 1,  $46,  $23,	 $74; 104
		dc.w $2005,  $12,    9,$FFF8; 108
		dc.w $2005,    4,    2,	   8; 112
		dc.w $2005,  $12,    9,	 $18; 116
		dc.w $2005,    4,    2,	 $28; 120
word_18BAC:	dc.w $F			; DATA XREF: ROM:00018676o
		dc.w $F805,  $12,    9,$FF80; 0
		dc.w $F805,  $22,  $11,$FF90; 4
		dc.w $F805,   $E,    7,$FFA0; 8
		dc.w $F805,  $2E,  $17,$FFB0; 12
		dc.w $F805,   $E,    7,$FFC0; 16
		dc.w $F805,  $1A,   $D,$FFD0; 20
		dc.w $F805,  $3E,  $1F,$FFE0; 24
		dc.w $F805,   $E,    7,$FFF0; 28
		dc.w $F805,  $42,  $21,	   0; 32
		dc.w $F805,  $48,  $24,	 $18; 36
		dc.w $F805,  $2A,  $15,	 $28; 40
		dc.w $F805,  $2E,  $17,	 $40; 44
		dc.w $F805,   $E,    7,	 $50; 48
		dc.w $F805,    0,    0,	 $60; 52
		dc.w $F805,    4,    2,	 $70; 56
word_18C26:	dc.w 8			; DATA XREF: ROM:00018678o
		dc.w $3005,  $3E,  $1F,$FFC0; 0
		dc.w $3005,  $22,  $11,$FFD0; 4
		dc.w $3005,  $2A,  $15,$FFE0; 8
		dc.w $3005,    4,    2,$FFF8; 12
		dc.w $3005,    0,    0,	   8; 16
		dc.w $3005,    4,    2,	 $18; 20
		dc.w $3001,  $46,  $23,	 $28; 24
		dc.w $3005,  $1A,   $D,	 $30; 28
word_18C68:	dc.w $11		; DATA XREF: ROM:0001867Ao
		dc.w $E805,  $2E,  $17,$FFB4; 0
		dc.w $E805,  $26,  $13,$FFC4; 4
		dc.w $E805,  $1A,   $D,$FFD4; 8
		dc.w $E801,  $46,  $23,$FFE4; 12
		dc.w $E805,  $1E,   $F,$FFEC; 16
		dc.w $E805,  $3E,  $1F,	   4; 20
		dc.w $E805,   $E,    7,	 $14; 24
		dc.w $E805,    4,    2,	 $24; 28
		dc.w $E809,    8,    4,	 $34; 32
		dc.w	 5,  $12,    9,$FFC0; 36
		dc.w	 5,  $22,  $11,$FFD0; 40
		dc.w	 5,   $E,    7,$FFE0; 44
		dc.w	 5,  $2E,  $17,$FFF0; 48
		dc.w	 5,   $E,    7,	   0; 52
		dc.w	 5,  $1A,   $D,	 $10; 56
		dc.w	 5,  $3E,  $1F,	 $20; 60
		dc.w	 5,  $2E,  $17,	 $30; 64
; ===============================================================================
		nop

j_ModifySpriteAttr_2P_4:		; CODE XREF: ROM:00018610p
					; ROM:00018636p
		jmp	ModifySpriteAttr_2P
; ===============================================================================
		align 4
;----------------------------------------------------
; Object 3D - GHZ Boss
;----------------------------------------------------

Obj3D:
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj3D_Index(pc,d0.w),d1
		jmp	Obj3D_Index(pc,d1.w)
; ===============================================================================
Obj3D_Index:	dc.w Obj3D_Main-Obj3D_Index
		dc.w Obj3D_ShipMain-Obj3D_Index
		dc.w Obj3D_FaceMain-Obj3D_Index
		dc.w Obj3D_FlameMain-Obj3D_Index
Obj3D_ObjData:	dc.b   2,  0		; 0
		dc.b   4,  1		; 2
		dc.b   6,  7		; 4
; ===============================================================================

Obj3D_Main:
		lea	Obj3D_ObjData(pc),a2
		movea.l	a0,a1
		moveq	#2,d1
		bra.s	loc_18D2A
; ===============================================================================

loc_18D22:
		jsr	S1SingleObjectLoad2
		bne.s	loc_18D70

loc_18D2A:
		move.b	(a2)+,$24(a1)
		move.b	#$3D,0(a1)
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		move.l	#Map_Eggman,4(a1)
		move.w	#$400,2(a1)
		bsr.w	j_ModifyA1SpriteAttr_2P_1
		move.b	#4,1(a1)
		move.b	#$20,$19(a1)
		move.b	#3,$18(a1)
		move.b	(a2)+,$1C(a1)
		move.l	a0,$34(a1)
		dbf	d1,loc_18D22

loc_18D70:
		move.w	8(a0),$30(a0)
		move.w	$C(a0),$38(a0)
		move.b	#$F,$20(a0)
		move.b	#8,$21(a0)

Obj3D_ShipMain:
		moveq	#0,d0
		move.b	$25(a0),d0
		move.w	Obj3D_ShipIndex(pc,d0.w),d1
		jsr	Obj3D_ShipIndex(pc,d1.w)
		lea	(Ani_Eggman).l,a1
		jsr	AnimateSprite
		move.b	$22(a0),d0
		andi.b	#3,d0
		andi.b	#$FC,1(a0)
		or.b	d0,1(a0)
		jmp	DisplaySprite
; ===============================================================================
Obj3D_ShipIndex:dc.w loc_18DC8-Obj3D_ShipIndex
		dc.w loc_18EC8-Obj3D_ShipIndex
		dc.w loc_18F18-Obj3D_ShipIndex
		dc.w loc_18F52-Obj3D_ShipIndex
		dc.w loc_18F78-Obj3D_ShipIndex
		dc.w loc_18FAA-Obj3D_ShipIndex
		dc.w loc_18FF6-Obj3D_ShipIndex
; ===============================================================================

loc_18DC8:
		move.w	#$100,$12(a0)
		bsr.w	BossMove
		cmpi.w	#$338,$38(a0)
		bne.s	loc_18DE4
		move.w	#0,$12(a0)
		addq.b	#2,$25(a0)

loc_18DE4:
		move.b	$3F(a0),d0
		jsr	(CalcSine).l
		asr.w	#6,d0
		add.w	$38(a0),d0
		move.w	d0,$C(a0)
		move.w	$30(a0),8(a0)
		addq.b	#2,$3F(a0)
		cmpi.b	#8,$25(a0)
		bcc.s	locret_18E48
		tst.b	$22(a0)
		bmi.s	loc_18E4A
		tst.b	$20(a0)
		bne.s	locret_18E48
		tst.b	$3E(a0)
		bne.s	loc_18E2C
		move.b	#$20,$3E(a0)
		move.w	#$AC,d0
		jsr	(PlaySound_Special).l

loc_18E2C:
		lea	(RAM_Pal_2+$2).w,a1
		moveq	#0,d0
		tst.w	(a1)
		bne.s	loc_18E3A
		move.w	#$EEE,d0

loc_18E3A:
		move.w	d0,(a1)
		subq.b	#1,$3E(a0)
		bne.s	locret_18E48
		move.b	#$F,$20(a0)

locret_18E48:
		rts
; ===============================================================================

loc_18E4A:
		moveq	#$64,d0
		bsr.w	AddPoints
		move.b	#8,$25(a0)
		move.w	#$B3,$3C(a0)
		rts

; =============== S U B R O U T I N E ==========================================


BossDefeated:
		move.b	(RAM_VIntFrameCnt+3).w,d0
		andi.b	#7,d0
		bne.s	BossDefeated_Return
		jsr	SingleObjectLoad
		bne.s	BossDefeated_Return
		move.b	#$3F,0(a1)
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		jsr	(PseudoRandomNumber).l
		move.w	d0,d1
		moveq	#0,d1
		move.b	d0,d1
		lsr.b	#2,d1
		subi.w	#$20,d1
		add.w	d1,8(a1)
		lsr.w	#8,d0
		lsr.b	#3,d0
		add.w	d0,$C(a1)

BossDefeated_Return:
		rts


; =============== S U B R O U T I N E ==========================================


BossMove:
		move.l	$30(a0),d2
		move.l	$38(a0),d3
		move.w	$10(a0),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,d2
		move.w	$12(a0),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,d3
		move.l	d2,$30(a0)
		move.l	d3,$38(a0)
		rts

; ===============================================================================

loc_18EC8:
		move.w	#$FF00,$10(a0)
		move.w	#$FFC0,$12(a0)
		bsr.w	BossMove
		cmpi.w	#$2A00,$30(a0)
		bne.s	loc_18F14
		move.w	#0,$10(a0)
		move.w	#0,$12(a0)
		addq.b	#2,$25(a0)
		jsr	S1SingleObjectLoad2
		bne.s	loc_18F0E
		move.b	#$48,0(a1) ; 'H'
		move.w	$30(a0),8(a1)
		move.w	$38(a0),$C(a1)
		move.l	a0,$34(a1)

loc_18F0E:
		move.w	#$77,$3C(a0)

loc_18F14:
		bra.w	loc_18DE4
; ===============================================================================

loc_18F18:
		subq.w	#1,$3C(a0)
		bpl.s	loc_18F42
		addq.b	#2,$25(a0)
		move.w	#$3F,$3C(a0)
		move.w	#$100,$10(a0)
		cmpi.w	#$2A00,$30(a0)
		bne.s	loc_18F42
		move.w	#$7F,$3C(a0)
		move.w	#$40,$10(a0)

loc_18F42:
		btst	#0,$22(a0)
		bne.s	loc_18F4E
		neg.w	$10(a0)

loc_18F4E:
		bra.w	loc_18DE4
; ===============================================================================

loc_18F52:
		subq.w	#1,$3C(a0)
		bmi.s	loc_18F5E
		bsr.w	BossMove
		bra.s	loc_18F74
; ===============================================================================

loc_18F5E:
		bchg	#0,$22(a0)
		move.w	#$3F,$3C(a0)
		subq.b	#2,$25(a0)
		move.w	#0,$10(a0)

loc_18F74:
		bra.w	loc_18DE4
; ===============================================================================

loc_18F78:
		subq.w	#1,$3C(a0)
		bmi.s	loc_18F82
		bra.w	BossDefeated
; ===============================================================================

loc_18F82:
		bset	#0,$22(a0)
		bclr	#7,$22(a0)
		clr.w	$10(a0)
		addq.b	#2,$25(a0)
		move.w	#$FFDA,$3C(a0)
		tst.b	(RAM_Flag_Level_NoAnimals).w
		bne.s	locret_18FA8
		move.b	#1,(RAM_Flag_Level_NoAnimals).w

locret_18FA8:
		rts
; ===============================================================================

loc_18FAA:
		addq.w	#1,$3C(a0)
		beq.s	loc_18FBA
		bpl.s	loc_18FC0
		addi.w	#$18,$12(a0)
		bra.s	loc_18FEE
; ===============================================================================

loc_18FBA:
		clr.w	$12(a0)
		bra.s	loc_18FEE
; ===============================================================================

loc_18FC0:
		cmpi.w	#$30,$3C(a0)
		bcs.s	loc_18FD8
		beq.s	loc_18FE0
		cmpi.w	#$38,$3C(a0)
		bcs.s	loc_18FEE
		addq.b	#2,$25(a0)
		bra.s	loc_18FEE
; ===============================================================================

loc_18FD8:
		subi.w	#8,$12(a0)
		bra.s	loc_18FEE
; ===============================================================================

loc_18FE0:
		clr.w	$12(a0)
		move.w	#$81,d0
		jsr	(PlaySound).l

loc_18FEE:
		bsr.w	BossMove
		bra.w	loc_18DE4
; ===============================================================================

loc_18FF6:
		move.w	#$400,$10(a0)
		move.w	#$FFC0,$12(a0)
		cmpi.w	#$2AC0,(RAM_LevelSys_XPos_SetEnd).w
		beq.s	loc_19010
		addq.w	#2,(RAM_LevelSys_XPos_SetEnd).w
		bra.s	loc_19016
; ===============================================================================

loc_19010:
		tst.b	1(a0)
		bpl.s	loc_1901E

loc_19016:
		bsr.w	BossMove
		bra.w	loc_18DE4
; ===============================================================================

loc_1901E:
		addq.l	#4,sp
		jmp	DeleteObject
; ===============================================================================

Obj3D_FaceMain:
		moveq	#0,d0
		moveq	#1,d1
		movea.l	$34(a0),a1
		move.b	$25(a1),d0
		subq.b	#4,d0
		bne.s	loc_19040
		cmpi.w	#$2A00,$30(a1)
		bne.s	loc_19048
		moveq	#4,d1

loc_19040:
		subq.b	#6,d0
		bmi.s	loc_19048
		moveq	#$A,d1
		bra.s	loc_1905C
; ===============================================================================

loc_19048:
		tst.b	$20(a1)
		bne.s	loc_19052
		moveq	#5,d1
		bra.s	loc_1905C
; ===============================================================================

loc_19052:
		cmpi.b	#4,(RAM_ObjRam_Sonic+$24).w
		bcs.s	loc_1905C
		moveq	#4,d1

loc_1905C:
		move.b	d1,$1C(a0)
		subq.b	#2,d0
		bne.s	loc_19070
		move.b	#6,$1C(a0)
		tst.b	1(a0)
		bpl.s	loc_19072

loc_19070:
		bra.s	Obj3D_Display
; ===============================================================================

loc_19072:
		jmp	DeleteObject
; ===============================================================================

Obj3D_FlameMain:
		move.b	#7,$1C(a0)
		movea.l	$34(a0),a1
		cmpi.b	#$C,$25(a1)
		bne.s	loc_19098
		move.b	#$B,$1C(a0)
		tst.b	1(a0)
		bpl.s	loc_190A6
		bra.s	loc_190A4
; ===============================================================================

loc_19098:
		move.w	$10(a1),d0
		beq.s	loc_190A4
		move.b	#8,$1C(a0)

loc_190A4:
		bra.s	Obj3D_Display
; ===============================================================================

loc_190A6:
		jmp	DeleteObject
; ===============================================================================

Obj3D_Display:
		movea.l	$34(a0),a1
		move.w	8(a1),8(a0)
		move.w	$C(a1),$C(a0)
		move.b	$22(a1),$22(a0)
		lea	(Ani_Eggman).l,a1
		jsr	AnimateSprite
		move.b	$22(a0),d0
		andi.b	#3,d0
		andi.b	#$FC,1(a0)
		or.b	d0,1(a0)
		jmp	DisplaySprite

; ===============================================================================
;----------------------------------------------------
; Object 48 - the ball that swings on the GHZ boss
;----------------------------------------------------

Obj48:
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj48_Index(pc,d0.w),d1
		jmp	Obj48_Index(pc,d1.w)
; ===============================================================================
Obj48_Index:	dc.w Obj48_Init-Obj48_Index
		dc.w Obj48_Main-Obj48_Index
		dc.w loc_19226-Obj48_Index
		dc.w loc_19274-Obj48_Index
		dc.w loc_19290-Obj48_Index
; ===============================================================================

Obj48_Init:
		addq.b	#2,$24(a0)
		move.w	#$4080,$26(a0)
		move.w	#$FE00,$3E(a0)
		move.l	#Map_BossItems,4(a0)
		move.w	#$46C,2(a0)
		bsr.w	j_ModifySpriteAttr_2P_5
		lea	$28(a0),a2
		move.b	#0,(a2)+
		moveq	#5,d1
		movea.l	a0,a1
		bra.s	loc_1916A
; ===============================================================================

loc_1912E:
		jsr	S1SingleObjectLoad2
		bne.s	loc_19194
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		move.b	#$48,0(a1)
		move.b	#6,$24(a1)
		move.l	#$852E,4(a1)
		move.w	#$380,2(a1)
		bsr.w	j_ModifyA1SpriteAttr_2P_1
		move.b	#1,$1A(a1)
		addq.b	#1,$28(a0)

loc_1916A:
		move.w	a1,d5
		subi.w	#$B000,d5
		lsr.w	#6,d5
		andi.w	#$7F,d5
		move.b	d5,(a2)+
		move.b	#4,1(a1)
		move.b	#8,$19(a1)
		move.b	#6,$18(a1)
		move.l	$34(a0),$34(a1)
		dbf	d1,loc_1912E

loc_19194:
		move.b	#8,$24(a1)
		move.l	#$85CA,4(a1)
		move.w	#$43AA,2(a1)
		bsr.w	j_ModifyA1SpriteAttr_2P_1
		move.b	#1,$1A(a1)
		move.b	#5,$18(a1)
		move.b	#$81,$20(a1)
		rts

; ===============================================================================
Obj48_PosData:	dc.b   0,$10,$20,$30,$40,$60
; ===============================================================================

Obj48_Main:
		lea	Obj48_PosData(pc),a3
		lea	$28(a0),a2
		moveq	#0,d6
		move.b	(a2)+,d6

loc_191D2:
		moveq	#0,d4
		move.b	(a2)+,d4
		lsl.w	#6,d4
		addi.l	#RAM_ObjectTable,d4
		movea.l	d4,a1
		move.b	(a3)+,d0
		cmp.b	$3C(a1),d0
		beq.s	loc_191EC
		addq.b	#1,$3C(a1)

loc_191EC:
		dbf	d6,loc_191D2
		cmp.b	$3C(a1),d0
		bne.s	loc_19206
		movea.l	$34(a0),a1
		cmpi.b	#6,$25(a1)
		bne.s	loc_19206
		addq.b	#2,$24(a0)

loc_19206:
		cmpi.w	#$20,$32(a0)
		beq.s	loc_19212
		addq.w	#1,$32(a0)

loc_19212:
		bsr.w	sub_19236
		move.b	$26(a0),d0
		jsr	loc_842E
		jmp	DisplaySprite
; ===============================================================================

loc_19226:
		bsr.w	sub_19236
		jsr	loc_83EA
		jmp	DisplaySprite

; =============== S U B R O U T I N E ==========================================


sub_19236:
		movea.l	$34(a0),a1
		addi.b	#$20,$1B(a0)
		bcc.s	loc_19248
		bchg	#0,$1A(a0)

loc_19248:
		move.w	8(a1),$3A(a0)
		move.w	$C(a1),d0
		add.w	$32(a0),d0
		move.w	d0,$38(a0)
		move.b	$22(a1),$22(a0)
		tst.b	$22(a1)
		bpl.s	locret_19272
		move.b	#$3F,0(a0) ; '?'
		move.b	#0,$24(a0)

locret_19272:
		rts

; ===============================================================================

loc_19274:
		movea.l	$34(a0),a1
		tst.b	$22(a1)
		bpl.s	loc_1928A
		move.b	#$3F,0(a0)
		move.b	#0,$24(a0)

loc_1928A:
		jmp	DisplaySprite
; ===============================================================================

loc_19290:
		moveq	#0,d0
		tst.b	$1A(a0)
		bne.s	loc_1929A
		addq.b	#1,d0

loc_1929A:
		move.b	d0,$1A(a0)
		movea.l	$34(a0),a1
		tst.b	$22(a1)
		bpl.s	loc_192C2
		move.b	#0,$20(a0)
		bsr.w	BossDefeated
		subq.b	#1,$3C(a0)
		bpl.s	loc_192C2
		move.b	#$3F,(a0)
		move.b	#0,$24(a0)

loc_192C2:
		jmp	DisplaySprite
; ===============================================================================
Ani_Eggman:	dc.w byte_192E0-Ani_Eggman
		dc.w byte_192E3-Ani_Eggman
		dc.w byte_192E7-Ani_Eggman
		dc.w byte_192EB-Ani_Eggman
		dc.w byte_192EF-Ani_Eggman
		dc.w byte_192F3-Ani_Eggman
		dc.w byte_192F7-Ani_Eggman
		dc.w byte_192FB-Ani_Eggman
		dc.w byte_192FE-Ani_Eggman
		dc.w byte_19302-Ani_Eggman
		dc.w byte_19306-Ani_Eggman
		dc.w byte_19309-Ani_Eggman
byte_192E0:	dc.b  $F,  0,$FF
byte_192E3:	dc.b   5,  1,  2,$FF
byte_192E7:	dc.b   3,  1,  2,$FF
byte_192EB:	dc.b   1,  1,  2,$FF
byte_192EF:	dc.b   4,  3,  4,$FF
byte_192F3:	dc.b $1F,  5,  1,$FF
byte_192F7:	dc.b   3,  6,  1,$FF
byte_192FB:	dc.b  $F, $A,$FF
byte_192FE:	dc.b   3,  8,  9,$FF
byte_19302:	dc.b   1,  8,  9,$FF
byte_19306:	dc.b  $F,  7,$FF
byte_19309:	dc.b   2,  9,  8, $B, $C, $B, $C,  9,  8,$FE,  2; 0


Map_Eggman:	dc.w word_1932E-Map_Eggman
		dc.w word_19360-Map_Eggman
		dc.w word_19372-Map_Eggman
		dc.w word_19384-Map_Eggman
		dc.w word_1939E-Map_Eggman
		dc.w word_193B8-Map_Eggman
		dc.w word_193D2-Map_Eggman
		dc.w word_193EC-Map_Eggman
		dc.w word_1940E-Map_Eggman
		dc.w word_19418-Map_Eggman
		dc.w word_19422-Map_Eggman
		dc.w word_19424-Map_Eggman
		dc.w word_19436-Map_Eggman
word_1932E:	dc.w 6
		dc.w $EC01,   $A,    5,$FFE4; 0
		dc.w $EC05,   $C,    6,	  $C; 4
		dc.w $FC0E,$2010,$2008,$FFE4; 8
		dc.w $FC0E,$201C,$200E,	   4; 12
		dc.w $140C,$2028,$2014,$FFEC; 16
		dc.w $1400,$202C,$2016,	  $C; 20
word_19360:	dc.w 2
		dc.w $E404,    0,    0,$FFF4; 0
		dc.w $EC0D,    2,    1,$FFEC; 4
word_19372:	dc.w 2			; DATA XREF: ROM:00019318o
		dc.w $E404,    0,    0,$FFF4; 0
		dc.w $EC0D,  $35,  $1A,$FFEC; 4
word_19384:	dc.w 3			; DATA XREF: ROM:0001931Ao
		dc.w $E408,  $3D,  $1E,$FFF4; 0
		dc.w $EC09,  $40,  $20,$FFEC; 4
		dc.w $EC05,  $46,  $23,	   4; 8
word_1939E:	dc.w 3			; DATA XREF: ROM:0001931Co
		dc.w $E408,  $4A,  $25,$FFF4; 0
		dc.w $EC09,  $4D,  $26,$FFEC; 4
		dc.w $EC05,  $53,  $29,	   4; 8
word_193B8:	dc.w 3			; DATA XREF: ROM:0001931Eo
		dc.w $E408,  $57,  $2B,$FFF4; 0
		dc.w $EC09,  $5A,  $2D,$FFEC; 4
		dc.w $EC05,  $60,  $30,	   4; 8
word_193D2:	dc.w 3			; DATA XREF: ROM:00019320o
		dc.w $E404,  $64,  $32,	   4; 0
		dc.w $E404,    0,    0,$FFF4; 4
		dc.w $EC0D,  $35,  $1A,$FFEC; 8
word_193EC:	dc.w 4			; DATA XREF: ROM:00019322o
		dc.w $E409,  $66,  $33,$FFF4; 0
		dc.w $E408,  $57,  $2B,$FFF4; 4
		dc.w $EC09,  $5A,  $2D,$FFEC; 8
		dc.w $EC05,  $60,  $30,	   4; 12
word_1940E:	dc.w 1			; DATA XREF: ROM:00019324o
		dc.w  $405,  $2D,  $16,	 $22; 0
word_19418:	dc.w 1			; DATA XREF: ROM:00019326o
		dc.w  $405,  $31,  $18,	 $22; 0
word_19422:	dc.w 0			; DATA XREF: ROM:00019328o
word_19424:	dc.w 2			; DATA XREF: ROM:0001932Ao
		dc.w	 8, $12A, $195,	 $22; 0
		dc.w  $808,$112A,$1995,	 $22; 4
word_19436:	dc.w 2			; DATA XREF: ROM:0001932Co
		dc.w $F80B, $12D, $199,	 $22; 0
		dc.w	 1, $139, $1AB,	 $3A; 4
Map_BossItems:	dc.w word_19458-Map_BossItems ;	DATA XREF: ROM:0001910Eo
					; ROM:Map_BossItemso ...
		dc.w word_19462-Map_BossItems
		dc.w word_19474-Map_BossItems
		dc.w word_1947E-Map_BossItems
		dc.w word_19488-Map_BossItems
		dc.w word_19492-Map_BossItems
		dc.w word_194B4-Map_BossItems
		dc.w word_194C6-Map_BossItems
word_19458:	dc.w 1			; DATA XREF: ROM:Map_BossItemso
		dc.w $F805,    0,    0,$FFF8; 0
word_19462:	dc.w 2			; DATA XREF: ROM:0001944Ao
		dc.w $FC04,    4,    2,$FFF8; 0
		dc.w $F805,    0,    0,$FFF8; 4
word_19474:	dc.w 1			; DATA XREF: ROM:0001944Co
		dc.w $FC00,    6,    3,$FFFC; 0
word_1947E:	dc.w 1			; DATA XREF: ROM:0001944Eo
		dc.w $1409,    7,    3,$FFF4; 0
word_19488:	dc.w 1			; DATA XREF: ROM:00019450o
		dc.w $1405,   $D,    6,$FFF8; 0
word_19492:	dc.w 4			; DATA XREF: ROM:00019452o
		dc.w $F004,  $11,    8,$FFF8; 0
		dc.w $F801,  $13,    9,$FFF8; 4
		dc.w $F801, $813, $809,	   0; 8
		dc.w  $804,  $15,   $A,$FFF8; 12
word_194B4:	dc.w 2			; DATA XREF: ROM:00019454o
		dc.w	 5,  $17,   $B,	   0; 0
		dc.w	 0,  $1B,   $D,	 $10; 4
word_194C6:	dc.w 2			; DATA XREF: ROM:00019456o
		dc.w $1804,  $1C,   $E,	   0; 0
		dc.w	$B,  $1E,   $F,	 $10; 4
; ===============================================================================

j_ModifyA1SpriteAttr_2P_1:
		jmp	ModifyA1SpriteAttr_2P
; ===============================================================================

j_ModifySpriteAttr_2P_5:
		jmp	ModifySpriteAttr_2P
; ===============================================================================

;----------------------------------------------------
; Object 3E - prison capsule
;----------------------------------------------------

Obj3E:
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj3E_Index(pc,d0.w),d1
		jsr	Obj3E_Index(pc,d1.w)
		move.w	8(a0),d0
		andi.w	#$FF80,d0
		sub.w	(RAM_ObjPos_DelSpr).w,d0
		cmpi.w	#$280,d0
		bhi.s	loc_1950A
		jmp	DisplaySprite
; ===============================================================================

loc_1950A:
		jmp	DeleteObject
; ===============================================================================
Obj3E_Index:	dc.w Obj3E_Init-Obj3E_Index
		dc.w Obj3E_BodyMain-Obj3E_Index
		dc.w Obj3E_Switched-Obj3E_Index
		dc.w Obj3E_Explosion-Obj3E_Index
		dc.w Obj3E_Explosion-Obj3E_Index
		dc.w Obj3E_Explosion-Obj3E_Index
		dc.w Obj3E_Animals-Obj3E_Index
		dc.w Obj3E_EndAct-Obj3E_Index
Obj3E_Var:	dc.b   2,$20,  4,  0	; 0
		dc.b   4, $C,  5,  1	; 4
		dc.b   6,$10,  4,  3	; 8
		dc.b   8,$10,  3,  5	; 12
; ===============================================================================

Obj3E_Init:
		move.l	#Map_Obj3E,4(a0)
		move.w	#$49D,2(a0)
		bsr.w	j_ModifySpriteAttr_2P_6
		move.b	#4,1(a0)
		move.w	$C(a0),$30(a0)
		moveq	#0,d0
		move.b	$28(a0),d0
		lsl.w	#2,d0
		lea	Obj3E_Var(pc,d0.w),a1
		move.b	(a1)+,$24(a0)
		move.b	(a1)+,$19(a0)
		move.b	(a1)+,$18(a0)
		move.b	(a1)+,$1A(a0)
		cmpi.w	#8,d0
		bne.s	locret_1957C
		move.b	#6,$20(a0)
		move.b	#8,$21(a0)

locret_1957C:
		rts
; ===============================================================================

Obj3E_BodyMain:
		cmpi.b	#2,(RAM_Flag_Level_NoAnimals).w
		beq.s	loc_1959C
		move.w	#$2B,d1
		move.w	#$18,d2
		move.w	#$18,d3
		move.w	8(a0),d4
		jmp	SolidObject
; ===============================================================================

loc_1959C:
		tst.b	$25(a0)
		beq.s	loc_195B2
		clr.b	$25(a0)
		bclr	#3,(RAM_ObjRam_Sonic+$22).w
		bset	#1,(RAM_ObjRam_Sonic+$22).w

loc_195B2:
		move.b	#2,$1A(a0)
		rts
; ===============================================================================

Obj3E_Switched:
		move.w	#$17,d1
		move.w	#8,d2
		move.w	#8,d3
		move.w	8(a0),d4
		jsr	SolidObject
		lea	(Ani_Obj3E).l,a1
		jsr	AnimateSprite
		move.w	$30(a0),$C(a0)
		move.b	$22(a0),d0
		andi.b	#$18,d0
		beq.s	locret_19620
		addq.w	#8,$C(a0)
		move.b	#$A,$24(a0)
		move.w	#$3C,$1E(a0)
		clr.b	(RAM_Flag_HudUpd_Timer).w
		clr.b	(RAM_Level_BossMode).w
		move.b	#1,(RAM_Flag_Sonic_IgnoreControl).w
		move.w	#$800,(RAM_Control_1_Hold_Copy).w
		clr.b	$25(a0)
		bclr	#3,(RAM_ObjRam_Sonic+$22).w
		bset	#1,(RAM_ObjRam_Sonic+$22).w

locret_19620:
		rts
; ===============================================================================

Obj3E_Explosion:
		moveq	#7,d0
		and.b	(RAM_VIntFrameCnt+3).w,d0
		bne.s	loc_19660
		jsr	SingleObjectLoad
		bne.s	loc_19660
		move.b	#$3F,0(a1) ; '?'
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		jsr	(PseudoRandomNumber).l
		moveq	#0,d1
		move.b	d0,d1
		lsr.b	#2,d1
		subi.w	#$20,d1	; ' '
		add.w	d1,8(a1)
		lsr.w	#8,d0
		lsr.b	#3,d0
		add.w	d0,$C(a1)

loc_19660:
		subq.w	#1,$1E(a0)
		beq.s	loc_19668
		rts
; ===============================================================================

loc_19668:
		move.b	#2,(RAM_Flag_Level_NoAnimals).w
		move.b	#$C,$24(a0)
		move.b	#6,$1A(a0)
		move.w	#$96,$1E(a0)
		addi.w	#$20,$C(a0)
		moveq	#7,d6
		move.w	#$9A,d5
		moveq	#$FFFFFFE4,d4

loc_1968E:
		jsr	SingleObjectLoad
		bne.s	locret_196B8
		move.b	#$28,0(a1)
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		add.w	d4,8(a1)
		addq.w	#7,d4
		move.w	d5,$36(a1)
		subq.w	#8,d5
		dbf	d6,loc_1968E

locret_196B8:
		rts
; ===============================================================================

Obj3E_Animals:
		moveq	#7,d0
		and.b	(RAM_VIntFrameCnt+3).w,d0
		bne.s	loc_196F8
		jsr	SingleObjectLoad
		bne.s	loc_196F8
		move.b	#$28,0(a1)
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		jsr	(PseudoRandomNumber).l
		andi.w	#$1F,d0
		subq.w	#6,d0
		tst.w	d1
		bpl.s	loc_196EE
		neg.w	d0

loc_196EE:
		add.w	d0,8(a1)
		move.w	#$C,$36(a1)

loc_196F8:
		subq.w	#1,$1E(a0)
		bne.s	locret_19708
		addq.b	#2,$24(a0)
		move.w	#$B4,$1E(a0)

locret_19708:
		rts
; ===============================================================================

Obj3E_EndAct:
		moveq	#$3E,d0
		moveq	#$28,d1
		moveq	#$40,d2
		lea	(RAM_ObjRAM_Tails).w,a1

loc_19714:
		cmp.b	(a1),d1
		beq.s	locret_1972A
		adda.w	d2,a1
		dbf	d0,loc_19714
		jsr	GotThroughAct
		jmp	DeleteObject
; ===============================================================================

locret_1972A:
		rts
; ===============================================================================
Ani_Obj3E:	dc.w byte_19730-Ani_Obj3E
		dc.w byte_19730-Ani_Obj3E
byte_19730:	dc.b   2,  1,  3,$FF

Map_Obj3E:	dc.w word_19742-Map_Obj3E
		dc.w word_1977C-Map_Obj3E
		dc.w word_19786-Map_Obj3E
		dc.w word_197B8-Map_Obj3E
		dc.w word_197C2-Map_Obj3E
		dc.w word_197D4-Map_Obj3E
		dc.w unk_197DE-Map_Obj3E
word_19742:	dc.w 7			; DATA XREF: ROM:Map_Obj3Eo
		dc.w $E00C,$2000,$2000,$FFF0; 0
		dc.w $E80D,$2004,$2002,$FFE0; 4
		dc.w $E80D,$200C,$2006,	   0; 8
		dc.w $F80E,$2014,$200A,$FFE0; 12
		dc.w $F80E,$2020,$2010,	   0; 16
		dc.w $100D,$202C,$2016,$FFE0; 20
		dc.w $100D,$2034,$201A,	   0; 24
word_1977C:	dc.w 1			; DATA XREF: ROM:00019736o
		dc.w $F809,  $3C,  $1E,$FFF4; 0
word_19786:	dc.w 6			; DATA XREF: ROM:00019738o
		dc.w	 8,$2042,$2021,$FFE0; 0
		dc.w  $80C,$2045,$2022,$FFE0; 4
		dc.w	 4,$2049,$2024,	 $10; 8
		dc.w  $80C,$204B,$2025,	   0; 12
		dc.w $100D,$202C,$2016,$FFE0; 16
		dc.w $100D,$2034,$201A,	   0; 20
word_197B8:	dc.w 1			; DATA XREF: ROM:0001973Ao
		dc.w $F809,  $4F,  $27,$FFF4; 0
word_197C2:	dc.w 2			; DATA XREF: ROM:0001973Co
		dc.w $E80E,$2055,$202A,$FFF0; 0
		dc.w	$E,$2061,$2030,$FFF0; 4
word_197D4:	dc.w 1			; DATA XREF: ROM:0001973Eo
		dc.w $F007,$206D,$2036,$FFF8; 0
unk_197DE:	dc.b   0		; DATA XREF: ROM:00019740o
		dc.b   0
; ===============================================================================

j_ModifySpriteAttr_2P_6:
		jmp	ModifySpriteAttr_2P
; ===============================================================================
		align 4

; =============== S U B R O U T I N E ==========================================


TouchResponse:
		nop
		bsr.w	loc_19B7A
		move.w	8(a0),d2
		move.w	$C(a0),d3
		subi.w	#8,d2
		moveq	#0,d5
		move.b	$16(a0),d5
		subq.b	#3,d5
		sub.w	d5,d3
		cmpi.b	#$39,$1A(a0)
		bne.s	loc_19812
		addi.w	#$C,d3
		moveq	#$A,d5

loc_19812:
		move.w	#$10,d4
		add.w	d5,d5
		lea	(RAM_ObjectTable+$800).w,a1
		move.w	#$5F,d6

loc_19820:
		move.b	$20(a1),d0
		bne.s	Touch_Height

loc_19826:
		lea	$40(a1),a1
		dbf	d6,loc_19820
		moveq	#0,d0

locret_19830:
		rts
; ===============================================================================
Touch_Sizes:	dc.b $14,$14		; 0
		dc.b  $C,$14		; 2
		dc.b $14, $C		; 4
		dc.b   4,$10		; 6
		dc.b  $C,$12		; 8
		dc.b $10,$10		; 10
		dc.b   6,  6		; 12
		dc.b $18, $C		; 14
		dc.b  $C,$10		; 16
		dc.b $10, $C		; 18
		dc.b   8,  8		; 20
		dc.b $14,$10		; 22
		dc.b $14,  8		; 24
		dc.b  $E, $E		; 26
		dc.b $18,$18		; 28
		dc.b $28,$10		; 30
		dc.b $10,$18		; 32
		dc.b   8,$10		; 34
		dc.b $20,$70		; 36
		dc.b $40,$20		; 38
		dc.b $80,$20		; 40
		dc.b $20,$20		; 42
		dc.b   8,  8		; 44
		dc.b   4,  4		; 46
		dc.b $20,  8		; 48
		dc.b  $C, $C		; 50
		dc.b   8,  4		; 52
		dc.b $18,  4		; 54
		dc.b $28,  4		; 56
		dc.b   4,  8		; 58
		dc.b   4,$18		; 60
		dc.b   4,$28		; 62
		dc.b   4,$20		; 64
		dc.b $18,$18		; 66
		dc.b  $C,$18		; 68
		dc.b $48,  8		; 70
; ===============================================================================

Touch_Height:
		andi.w	#$3F,d0
		add.w	d0,d0
		lea	Touch_Sizes-2(pc,d0.w),a2
		moveq	#0,d1
		move.b	(a2)+,d1
		move.w	8(a1),d0
		sub.w	d1,d0
		sub.w	d2,d0
		bcc.s	loc_1989C
		add.w	d1,d1
		add.w	d1,d0
		bcs.s	loc_198A2
		bra.w	loc_19826
; ===============================================================================

loc_1989C:
		cmp.w	d4,d0
		bhi.w	loc_19826

loc_198A2:
		moveq	#0,d1
		move.b	(a2)+,d1
		move.w	$C(a1),d0
		sub.w	d1,d0
		sub.w	d3,d0
		bcc.s	loc_198BA
		add.w	d1,d1
		add.w	d1,d0
		bcs.s	loc_198C0
		bra.w	loc_19826
; ===============================================================================

loc_198BA:
		cmp.w	d5,d0
		bhi.w	loc_19826

loc_198C0:
		move.b	$20(a1),d1
		andi.b	#$C0,d1
		beq.w	loc_1993A
		cmpi.b	#$C0,d1
		beq.w	Touch_Special
		tst.b	d1
		bmi.w	loc_199F2
		move.b	$20(a1),d0
		andi.b	#$3F,d0
		cmpi.b	#6,d0
		beq.s	loc_198FA
		cmpi.w	#$5A,$30(a0)
		bcc.w	locret_198F8
		move.b	#4,$24(a1)

locret_198F8:
		rts
; ===============================================================================

loc_198FA:
		tst.w	$12(a0)
		bpl.s	loc_19926
		move.w	$C(a0),d0
		subi.w	#$10,d0
		cmp.w	$C(a1),d0
		bcs.s	locret_19938

loc_1990E:
		neg.w	$12(a0)

loc_19912:
		move.w	#$FE80,$12(a1)
		tst.b	$25(a1)
		bne.s	locret_19938
		move.b	#4,$25(a1)
		rts
; ===============================================================================

loc_19926:
		cmpi.b	#2,$1C(a0)
		bne.s	locret_19938
		neg.w	$12(a0)
		move.b	#4,$24(a1)

locret_19938:
		rts
; ===============================================================================

loc_1993A:
		tst.b	(RAM_Flag_Sonic_Invincibility).w
		bne.s	loc_19952
		cmpi.b	#9,$1C(a0)
		beq.s	loc_19952
		cmpi.b	#2,$1C(a0)
		bne.w	loc_199F2

loc_19952:
		tst.b	$21(a1)
		beq.s	Touch_KillEnemy
		neg.w	$10(a0)
		neg.w	$12(a0)
		asr	$10(a0)
		asr	$12(a0)
		move.b	#0,$20(a1)
		subq.b	#1,$21(a1)
		bne.s	locret_1997A
		bset	#7,$22(a1)

locret_1997A:
		rts
; ===============================================================================

Touch_KillEnemy:
		bset	#7,$22(a1)
		moveq	#0,d0
		move.w	(RAM_Level_Enemy_FixPoints).w,d0
		addq.w	#2,(RAM_Level_Enemy_FixPoints).w
		cmpi.w	#6,d0
		bcs.s	loc_19994
		moveq	#6,d0

loc_19994:
		move.w	d0,$3E(a1)
		move.w	Enemy_Points(pc,d0.w),d0
		cmpi.w	#$20,(RAM_Level_Enemy_FixPoints).w
		bcs.s	loc_199AE
		move.w	#$3E8,d0
		move.w	#$A,$3E(a1)

loc_199AE:
		bsr.w	AddPoints
		move.b	#$27,0(a1)
		move.b	#0,$24(a1)
		tst.w	$12(a0)
		bmi.s	loc_199D4
		move.w	$C(a0),d0
		cmp.w	$C(a1),d0
		bcc.s	loc_199DC
		neg.w	$12(a0)
		rts
; ===============================================================================

loc_199D4:
		addi.w	#$100,$12(a0)
		rts
; ===============================================================================

loc_199DC:
		subi.w	#$100,$12(a0)
		rts
; ===============================================================================
Enemy_Points:
		dc.w	10,   20,   50,	 100; 0
; ===============================================================================

loc_199EC:
		bset	#7,$22(a1)

loc_199F2:
		tst.b	(RAM_Flag_Sonic_Invincibility).w
		beq.s	Touch_Hurt
loc_199F8:
		moveq	#-1,d0
		rts
; ===============================================================================

Touch_Hurt:
		nop
		tst.w	$30(a0)
		bne.s	loc_199F8
		movea.l	a1,a2

; =============== S U B R O U T I N E ==========================================


HurtSonic:
		tst.b	(RAM_Flag_Sonic_Shield).w
		bne.s	HurtShield
		tst.w	(RAM_Sonic_CurrentRings).w

loc_19A10:
		beq.w	Hurt_NoRings
		jsr	SingleObjectLoad
		bne.s	HurtShield
		move.b	#$37,0(a1)
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)

HurtShield:
		move.b	#0,(RAM_Flag_Sonic_Shield).w
		move.b	#4,$24(a0)
		bsr.w	j_Sonic_ResetOnFloor
		bset	#1,$22(a0)
		move.w	#$FC00,$12(a0)
		move.w	#$FE00,$10(a0)
		btst	#6,$22(a0)
		beq.s	Hurt_Reverse
		move.w	#$FE00,$12(a0)
		move.w	#$FF00,$10(a0)

Hurt_Reverse:
		move.w	8(a0),d0
		cmp.w	8(a2),d0
		bcs.s	Hurt_ChkSpikes
		neg.w	$10(a0)

Hurt_ChkSpikes:
		move.w	#0,$14(a0)
		move.b	#$1A,$1C(a0)
		move.w	#$78,$30(a0)
		move.w	#$A3,d0
		cmpi.b	#$36,(a2)
		bne.s	loc_19A98
		cmpi.b	#$16,(a2)
		bne.s	loc_19A98
		move.w	#$A6,d0

loc_19A98:
		jsr	(PlaySound_Special).l
		moveq	#-1,d0
		rts
; ===============================================================================

Hurt_NoRings:
		tst.w	(RAM_Flag_DebugMode).w
		bne.w	HurtShield


; =============== S U B R O U T I N E ==========================================


KillSonic:
		tst.w	(RAM_Flag_Debug_Placement).w
		bne.s	Kill_NoDeath
		move.b	#0,(RAM_Flag_Sonic_Invincibility).w
		move.b	#6,$24(a0)
		bsr.w	j_Sonic_ResetOnFloor
		bset	#1,$22(a0)
		move.w	#$F900,$12(a0)
		move.w	#0,$10(a0)
		move.w	#0,$14(a0)
		move.w	$C(a0),$38(a0)
		move.b	#$18,$1C(a0)
		bset	#7,2(a0)
		move.w	#$A3,d0	; ''
		cmpi.b	#$36,(a2) ; '6'
		bne.s	loc_19AF8
		move.w	#$A6,d0	; ''

loc_19AF8:
		jsr	(PlaySound_Special).l

Kill_NoDeath:
		moveq	#-1,d0
		rts

; ===============================================================================
; START	OF FUNCTION CHUNK FOR TouchResponse

Touch_Special:				; CODE XREF: TouchResponse+E8j
		move.b	$20(a1),d1
		andi.b	#$3F,d1	; '?'
		cmpi.b	#$B,d1
		beq.s	Touch_Caterkiller
		cmpi.b	#$C,d1
		beq.s	Touch_Yadrin
		cmpi.b	#$17,d1
		beq.s	Touch_D7
		cmpi.b	#$21,d1	; '!'
		beq.s	Touch_E1
		rts
; ===============================================================================

Touch_Caterkiller:			; CODE XREF: TouchResponse+326j
		bra.w	loc_199EC
; ===============================================================================

Touch_Yadrin:				; CODE XREF: TouchResponse+32Cj
		sub.w	d0,d5
		cmpi.w	#8,d5
		bcc.s	loc_19B56
		move.w	8(a1),d0
		subq.w	#4,d0
		btst	#0,$22(a1)
		beq.s	loc_19B42
		subi.w	#$10,d0

loc_19B42:				; CODE XREF: TouchResponse+354j
		sub.w	d2,d0
		bcc.s	loc_19B4E
		addi.w	#$18,d0
		bcs.s	loc_19B52
		bra.s	loc_19B56
; ===============================================================================

loc_19B4E:				; CODE XREF: TouchResponse+35Cj
		cmp.w	d4,d0
		bhi.s	loc_19B56

loc_19B52:				; CODE XREF: TouchResponse+362j
		bra.w	loc_199F2
; ===============================================================================

loc_19B56:				; CODE XREF: TouchResponse+346j
					; TouchResponse+364j ...
		bra.w	loc_1993A
; ===============================================================================

Touch_D7:				; CODE XREF: TouchResponse+332j
		move.w	a0,d1
		subi.w	#$B000,d1
		beq.s	loc_19B66
		addq.b	#1,$21(a1)

loc_19B66:				; CODE XREF: TouchResponse+378j
		addq.b	#1,$21(a1)
		rts
; ===============================================================================

Touch_E1:				; CODE XREF: TouchResponse+338j
		addq.b	#1,$21(a1)
		rts
; END OF FUNCTION CHUNK	FOR TouchResponse
; ===============================================================================
		nop

j_Sonic_ResetOnFloor:			; CODE XREF: HurtSonic+34p
					; KillSonic+12p
		jmp	Sonic_ResetOnFloor
; ===============================================================================

loc_19B7A:				; CODE XREF: TouchResponse+2p
		jmp	sub_D998

; =============== S U B R O U T I N E ==========================================

; leftover from	Sonic 1

S1SS_ShowLayout:
		bsr.w	sub_19CC2
		bsr.w	sub_19F02
		move.w	d5,-(sp)
		lea	(RAM_LevelLayout).w,a1
		move.b	(RAM_ObjPos_2pData).w,d0
		andi.b	#$FC,d0
		jsr	(CalcSine).l
		move.w	d0,d4
		move.w	d1,d5
		muls.w	#$18,d4
		muls.w	#$18,d5
		moveq	#0,d2
		move.w	(RAM_LevelSys_Buff).w,d2
		divu.w	#$18,d2
		swap	d2
		neg.w	d2
		addi.w	#$FF4C,d2
		moveq	#0,d3
		move.w	(RAM_LevelSys_Buff+$4).w,d3
		divu.w	#$18,d3
		swap	d3
		neg.w	d3
		addi.w	#$FF4C,d3
		move.w	#$F,d7

loc_19BD0:				; CODE XREF: S1SS_ShowLayout+8Ej
		movem.w	d0-d2,-(sp)
		movem.w	d0-d1,-(sp)
		neg.w	d0
		muls.w	d2,d1
		muls.w	d3,d0
		move.l	d0,d6
		add.l	d1,d6
		movem.w	(sp)+,d0-d1
		muls.w	d2,d0
		muls.w	d3,d1
		add.l	d0,d1
		move.l	d6,d2
		move.w	#$F,d6

loc_19BF2:				; CODE XREF: S1SS_ShowLayout+82j
		move.l	d2,d0
		asr.l	#8,d0
		move.w	d0,(a1)+
		move.l	d1,d0
		asr.l	#8,d0
		move.w	d0,(a1)+
		add.l	d5,d2
		add.l	d4,d1
		dbf	d6,loc_19BF2
		movem.w	(sp)+,d0-d2
		addi.w	#$18,d3
		dbf	d7,loc_19BD0
		move.w	(sp)+,d5
		lea	(RAM_MetablockTable).l,a0
		moveq	#0,d0
		move.w	(RAM_LevelSys_Buff+$4).w,d0
		divu.w	#$18,d0
		mulu.w	#$80,d0	; ''
		adda.l	d0,a0
		moveq	#0,d0
		move.w	(RAM_LevelSys_Buff).w,d0
		divu.w	#$18,d0
		adda.w	d0,a0
		lea	(RAM_LevelLayout).w,a4
		move.w	#$F,d7

loc_19C3E:				; CODE XREF: S1SS_ShowLayout+124j
		move.w	#$F,d6

loc_19C42:				; CODE XREF: S1SS_ShowLayout+11Cj
		moveq	#0,d0
		move.b	(a0)+,d0
		beq.s	loc_19C9A
		cmpi.b	#$4E,d0	; 'N'
		bhi.s	loc_19C9A
		move.w	(a4),d3
		addi.w	#$120,d3
		cmpi.w	#$70,d3	; 'p'
		bcs.s	loc_19C9A
		cmpi.w	#$1D0,d3
		bcc.s	loc_19C9A
		move.w	2(a4),d2
		addi.w	#$F0,d2	; ''
		cmpi.w	#$70,d2	; 'p'
		bcs.s	loc_19C9A
		cmpi.w	#$170,d2
		bcc.s	loc_19C9A
		lea	($FFFF4000).l,a5
		lsl.w	#3,d0
		lea	(a5,d0.w),a5
		movea.l	(a5)+,a1
		move.w	(a5)+,d1
		add.w	d1,d1
		adda.w	(a1,d1.w),a1
		movea.w	(a5)+,a3
		moveq	#0,d1
		move.b	(a1)+,d1
		subq.b	#1,d1
		bmi.s	loc_19C9A
		jsr	loc_D1CE

loc_19C9A:				; CODE XREF: S1SS_ShowLayout+C6j
					; S1SS_ShowLayout+CCj ...
		addq.w	#4,a4
		dbf	d6,loc_19C42
		lea	$70(a0),a0
		dbf	d7,loc_19C3E
		move.b	d5,(RAM_Debug_MaxSprites).w
		cmpi.b	#$50,d5	; 'P'
		beq.s	loc_19CBA
		move.l	#0,(a2)
		rts
; ===============================================================================

loc_19CBA:				; CODE XREF: S1SS_ShowLayout+130j
		move.b	#0,-5(a2)
		rts
; End of function S1SS_ShowLayout


; =============== S U B R O U T I N E ==========================================


sub_19CC2:				; CODE XREF: S1SS_ShowLayoutp
		lea	($FFFF400C).l,a1
		moveq	#0,d0
		move.b	(RAM_ObjPos_2pData).w,d0
		lsr.b	#2,d0
		andi.w	#$F,d0
		moveq	#$23,d1	; '#'

loc_19CD6:				; CODE XREF: sub_19CC2+18j
		move.w	d0,(a1)
		addq.w	#8,a1
		dbf	d1,loc_19CD6
		lea	($FFFF4005).l,a1
		subq.b	#1,(RAM_ObjSpecial_RingFrame_3).w
		bpl.s	loc_19CFA
		move.b	#7,(RAM_ObjSpecial_RingFrame_3).w
		addq.b	#1,(RAM_ObjSpecial_RingFrame_4).w
		andi.b	#3,(RAM_ObjSpecial_RingFrame_4).w

loc_19CFA:				; CODE XREF: sub_19CC2+26j
		move.b	(RAM_ObjSpecial_RingFrame_4).w,$1D0(a1)
		subq.b	#1,(RAM_ObjSpecial_RingFrame_5).w
		bpl.s	loc_19D16
		move.b	#7,(RAM_ObjSpecial_RingFrame_5).w
		addq.b	#1,(RAM_ObjSpecial_RingFrame_6).w
		andi.b	#1,(RAM_ObjSpecial_RingFrame_6).w

loc_19D16:				; CODE XREF: sub_19CC2+42j
		move.b	(RAM_ObjSpecial_RingFrame_6).w,d0
		move.b	d0,$138(a1)

loc_19D1E:
		move.b	d0,$160(a1)
		move.b	d0,$148(a1)
		move.b	d0,$150(a1)
		move.b	d0,$1D8(a1)
		move.b	d0,$1E0(a1)
		move.b	d0,$1E8(a1)
		move.b	d0,$1F0(a1)
		move.b	d0,$1F8(a1)
		move.b	d0,$200(a1)
		subq.b	#1,(RAM_ObjSpecial_RingFrame_7).w
		bpl.s	loc_19D58
		move.b	#4,(RAM_ObjSpecial_RingFrame_7).w
		addq.b	#1,(RAM_ObjSpecial_RingFrame_8).w
		andi.b	#3,(RAM_ObjSpecial_RingFrame_8).w

loc_19D58:				; CODE XREF: sub_19CC2+84j
		move.b	(RAM_ObjSpecial_RingFrame_8).w,d0
		move.b	d0,$168(a1)
		move.b	d0,$170(a1)
		move.b	d0,$178(a1)
		move.b	d0,$180(a1)
		subq.b	#1,(RAM_ObjSpecial_RingFrame_1).w
		bpl.s	loc_19D82
		move.b	#7,(RAM_ObjSpecial_RingFrame_1).w
		subq.b	#1,(RAM_ObjSpecial_RingFrame_2).w
		andi.b	#7,(RAM_ObjSpecial_RingFrame_2).w

loc_19D82:				; CODE XREF: sub_19CC2+AEj
		lea	($FFFF4016).l,a1
		lea	(S1SS_WaRiVramSet).l,a0
		moveq	#0,d0
		move.b	(RAM_ObjSpecial_RingFrame_2).w,d0
		add.w	d0,d0
		lea	(a0,d0.w),a0
		move.w	(a0),(a1)
		move.w	2(a0),8(a1)
		move.w	4(a0),$10(a1)
		move.w	6(a0),$18(a1)
		move.w	8(a0),$20(a1)
		move.w	$A(a0),$28(a1)
		move.w	$C(a0),$30(a1)
		move.w	$E(a0),$38(a1)
		adda.w	#$20,a0	; ' '
		adda.w	#$48,a1	; 'H'
		move.w	(a0),(a1)
		move.w	2(a0),8(a1)
		move.w	4(a0),$10(a1)
		move.w	6(a0),$18(a1)
		move.w	8(a0),$20(a1)
		move.w	$A(a0),$28(a1)
		move.w	$C(a0),$30(a1)
		move.w	$E(a0),$38(a1)
		adda.w	#$20,a0	; ' '
		adda.w	#$48,a1	; 'H'
		move.w	(a0),(a1)
		move.w	2(a0),8(a1)
		move.w	4(a0),$10(a1)
		move.w	6(a0),$18(a1)
		move.w	8(a0),$20(a1)
		move.w	$A(a0),$28(a1)
		move.w	$C(a0),$30(a1)
		move.w	$E(a0),$38(a1)
		adda.w	#$20,a0	; ' '
		adda.w	#$48,a1	; 'H'
		move.w	(a0),(a1)
		move.w	2(a0),8(a1)
		move.w	4(a0),$10(a1)
		move.w	6(a0),$18(a1)
		move.w	8(a0),$20(a1)
		move.w	$A(a0),$28(a1)
		move.w	$C(a0),$30(a1)
		move.w	$E(a0),$38(a1)
		adda.w	#$20,a0	; ' '
		adda.w	#$48,a1	; 'H'
		rts
; End of function sub_19CC2

; ===============================================================================
S1SS_WaRiVramSet:dc.w  $142,$6142, $142, $142, $142, $142, $142,$6142; 0
					; DATA XREF: sub_19CC2+C6o
		dc.w  $142,$6142, $142,	$142, $142, $142, $142,$6142; 8
		dc.w $2142, $142,$2142,$2142,$2142,$2142,$2142,	$142; 16
		dc.w $2142, $142,$2142,$2142,$2142,$2142,$2142,	$142; 24
		dc.w $4142,$2142,$4142,$4142,$4142,$4142,$4142,$2142; 32
		dc.w $4142,$2142,$4142,$4142,$4142,$4142,$4142,$2142; 40
		dc.w $6142,$4142,$6142,$6142,$6142,$6142,$6142,$4142; 48
		dc.w $6142,$4142,$6142,$6142,$6142,$6142,$6142,$4142; 56

; =============== S U B R O U T I N E ==========================================


sub_19EEC:				; CODE XREF: Obj09_ChkItems+40p
					; Obj09_ChkItems+7Cp ...
		lea	($FFFF4400).l,a2
		move.w	#$1F,d0

loc_19EF6:				; CODE XREF: sub_19EEC+10j
		tst.b	(a2)
		beq.s	locret_19F00
		addq.w	#8,a2
		dbf	d0,loc_19EF6

locret_19F00:				; CODE XREF: sub_19EEC+Cj
		rts
; End of function sub_19EEC


; =============== S U B R O U T I N E ==========================================


sub_19F02:				; CODE XREF: S1SS_ShowLayout+4p
		lea	($FFFF4400).l,a0
		move.w	#$1F,d7

loc_19F0C:				; CODE XREF: sub_19F02:loc_19F1Cj
		moveq	#0,d0
		move.b	(a0),d0
		beq.s	loc_19F1A
		lsl.w	#2,d0
		movea.l	S1SS_AniIndex-4(pc,d0.w),a1
		jsr	(a1)

loc_19F1A:				; CODE XREF: sub_19F02+Ej
		addq.w	#8,a0

loc_19F1C:
		dbf	d7,loc_19F0C
		rts
; End of function sub_19F02

; ===============================================================================
S1SS_AniIndex:	dc.l loc_19F3A		; DATA XREF: sub_19F02+12t
		dc.l loc_19F6A
		dc.l loc_19FA0
		dc.l loc_19FD0
		dc.l loc_1A006
		dc.l loc_1A046
; ===============================================================================

loc_19F3A:				; DATA XREF: ROM:S1SS_AniIndexo
		subq.b	#1,2(a0)
		bpl.s	locret_19F62
		move.b	#5,2(a0)
		moveq	#0,d0
		move.b	3(a0),d0
		addq.b	#1,3(a0)
		movea.l	4(a0),a1
		move.b	byte_19F64(pc,d0.w),d0
		move.b	d0,(a1)
		bne.s	locret_19F62
		clr.l	(a0)
		clr.l	4(a0)

locret_19F62:				; CODE XREF: ROM:00019F3Ej
					; ROM:00019F5Aj
		rts
; ===============================================================================
byte_19F64:	dc.b $42,$43,$44,$45,  0,  0; 0
; ===============================================================================

loc_19F6A:				; DATA XREF: ROM:00019F26o
		subq.b	#1,2(a0)
		bpl.s	locret_19F98
		move.b	#7,2(a0)
		moveq	#0,d0
		move.b	3(a0),d0
		addq.b	#1,3(a0)
		movea.l	4(a0),a1
		move.b	byte_19F9A(pc,d0.w),d0
		bne.s	loc_19F96
		clr.l	(a0)
		clr.l	4(a0)
		move.b	#$25,(a1) ; '%'
		rts
; ===============================================================================

loc_19F96:				; CODE XREF: ROM:00019F88j
		move.b	d0,(a1)

locret_19F98:				; CODE XREF: ROM:00019F6Ej
		rts
; ===============================================================================
byte_19F9A:	dc.b $32,$33,$32,$33,  0,  0; 0
; ===============================================================================

loc_19FA0:				; DATA XREF: ROM:00019F2Ao
		subq.b	#1,2(a0)
		bpl.s	locret_19FC8
		move.b	#5,2(a0)
		moveq	#0,d0
		move.b	3(a0),d0
		addq.b	#1,3(a0)
		movea.l	4(a0),a1
		move.b	byte_19FCA(pc,d0.w),d0
		move.b	d0,(a1)
		bne.s	locret_19FC8
		clr.l	(a0)
		clr.l	4(a0)

locret_19FC8:				; CODE XREF: ROM:00019FA4j
					; ROM:00019FC0j
		rts
; ===============================================================================
byte_19FCA:	dc.b $46,$47,$48,$49,  0,  0; 0
; ===============================================================================

loc_19FD0:				; DATA XREF: ROM:00019F2Eo
		subq.b	#1,2(a0)
		bpl.s	locret_19FFE
		move.b	#7,2(a0)
		moveq	#0,d0
		move.b	3(a0),d0
		addq.b	#1,3(a0)
		movea.l	4(a0),a1
		move.b	byte_1A000(pc,d0.w),d0
		bne.s	loc_19FFC
		clr.l	(a0)
		clr.l	4(a0)
		move.b	#$2B,(a1) ; '+'
		rts
; ===============================================================================

loc_19FFC:				; CODE XREF: ROM:00019FEEj
		move.b	d0,(a1)

locret_19FFE:				; CODE XREF: ROM:00019FD4j
		rts
; ===============================================================================
byte_1A000:	dc.b $2B,$31,$2B,$31,  0,  0; 0
; ===============================================================================

loc_1A006:				; DATA XREF: ROM:00019F32o
		subq.b	#1,2(a0)
		bpl.s	locret_1A03E
		move.b	#5,2(a0)
		moveq	#0,d0
		move.b	3(a0),d0
		addq.b	#1,3(a0)
		movea.l	4(a0),a1
		move.b	byte_1A040(pc,d0.w),d0
		move.b	d0,(a1)
		bne.s	locret_1A03E
		clr.l	(a0)
		clr.l	4(a0)
		move.b	#4,(RAM_ObjRam_Sonic+$24).w
		move.w	#$A8,d0	; ''
		jsr	(PlaySound_Special).l

locret_1A03E:				; CODE XREF: ROM:0001A00Aj
					; ROM:0001A026j
		rts
; ===============================================================================
byte_1A040:	dc.b $46,$47,$48,$49,  0,  0; 0
; ===============================================================================

loc_1A046:				; DATA XREF: ROM:00019F36o
		subq.b	#1,2(a0)
		bpl.s	locret_1A072
		move.b	#1,2(a0)
		moveq	#0,d0
		move.b	3(a0),d0
		addq.b	#1,3(a0)
		movea.l	4(a0),a1
		move.b	byte_1A074(pc,d0.w),d0
		move.b	d0,(a1)
		bne.s	locret_1A072
		move.b	4(a0),(a1)
		clr.l	(a0)
		clr.l	4(a0)

locret_1A072:				; CODE XREF: ROM:0001A04Aj
					; ROM:0001A066j
		rts
; ===============================================================================
byte_1A074:	dc.b $4B,$4C,$4D,$4E,$4B,$4C,$4D,$4E; 0
		dc.b   0,  0		; 8
S1SS_LayoutIndex:dc.l S1SS_1,S1SS_2	 ; 0
		dc.l S1SS_3,S1SS_4	; 2
		dc.l S1SS_5,S1SS_6	; 4
S1SS_StartLoc:	dc.w  $3D0, $2E0	; 0
		dc.w  $328, $574	; 2
		dc.w  $4E4, $2E0	; 4
		dc.w  $3AD, $2E0	; 6
		dc.w  $340, $6B8	; 8
		dc.w  $49B, $358	; 10

; =============== S U B R O U T I N E ==========================================


S1SS_Load:				; CODE XREF: ROM:000050E0p
					; S1SS_Load+34j
		moveq	#0,d0
		move.b	(RAM_SpecialStg_Level).w,d0
		addq.b	#1,(RAM_SpecialStg_Level).w
		cmpi.b	#6,(RAM_SpecialStg_Level).w
		bcs.s	loc_1A0C6
		move.b	#0,(RAM_SpecialStg_Level).w

loc_1A0C6:				; CODE XREF: S1SS_Load+10j
		cmpi.b	#6,(RAM_Sonic_Emeralds).w
		beq.s	loc_1A0E8
		moveq	#0,d1
		move.b	(RAM_Sonic_Emeralds).w,d1
		subq.b	#1,d1
		bcs.s	loc_1A0E8
		lea	(RAM_Sonic_EmeraldTypes).w,a3

loc_1A0DC:				; CODE XREF: S1SS_Load:loc_1A0E4j
		cmp.b	(a3,d1.w),d0
		bne.s	loc_1A0E4
		bra.s	S1SS_Load
; ===============================================================================

loc_1A0E4:				; CODE XREF: S1SS_Load+32j
		dbf	d1,loc_1A0DC

loc_1A0E8:				; CODE XREF: S1SS_Load+1Ej
					; S1SS_Load+28j
		lsl.w	#2,d0
		lea	S1SS_StartLoc(pc,d0.w),a1
		move.w	(a1)+,(RAM_ObjRam_Sonic+$8).w
		move.w	(a1)+,(RAM_ObjRam_Sonic+$C).w
		movea.l	S1SS_LayoutIndex(pc,d0.w),a0
		lea	($FFFF4000).l,a1
		move.w	#0,d0
		jsr	(EniDec).l
		lea	(RAM_MetablockTable).l,a1
		move.w	#$FFF,d0

loc_1A114:				; CODE XREF: S1SS_Load+68j
		clr.l	(a1)+
		dbf	d0,loc_1A114
		lea	($FFFF1020).l,a1
		lea	($FFFF4000).l,a0
		moveq	#$3F,d1	; '?'

loc_1A128:				; CODE XREF: S1SS_Load+86j
		moveq	#$3F,d2	; '?'

loc_1A12A:				; CODE XREF: S1SS_Load+7Ej
		move.b	(a0)+,(a1)+
		dbf	d2,loc_1A12A
		lea	$40(a1),a1
		dbf	d1,loc_1A128
		lea	($FFFF4008).l,a1
		lea	(S1SS_MapIndex).l,a0
		moveq	#$4D,d1	; 'M'

loc_1A146:				; CODE XREF: S1SS_Load+A6j
		move.l	(a0)+,(a1)+
		move.w	#0,(a1)+
		move.b	-4(a0),-1(a1)
		move.w	(a0)+,(a1)+
		dbf	d1,loc_1A146
		lea	($FFFF4400).l,a1
		move.w	#$3F,d1	; '?'

loc_1A162:				; CODE XREF: S1SS_Load+B6j
		clr.l	(a1)+
		dbf	d1,loc_1A162
		rts
; End of function S1SS_Load

; ===============================================================================
S1SS_MapIndex:	dc.l S1Map_SS_R		; DATA XREF: S1SS_Load+90o
		dc.w $142
		dc.l S1Map_SS_R
		dc.w $142
		dc.l S1Map_SS_R
		dc.w $142
		dc.l S1Map_SS_R
		dc.w $142
		dc.l S1Map_SS_R
		dc.w $142
		dc.l S1Map_SS_R
		dc.w $142
		dc.l S1Map_SS_R
		dc.w $142
		dc.l S1Map_SS_R
		dc.w $142
		dc.l S1Map_SS_R
		dc.w $142
		dc.l S1Map_SS_R
		dc.w $2142
		dc.l S1Map_SS_R
		dc.w $2142
		dc.l S1Map_SS_R
		dc.w $2142
		dc.l S1Map_SS_R
		dc.w $2142
		dc.l S1Map_SS_R
		dc.w $2142
		dc.l S1Map_SS_R
		dc.w $2142
		dc.l S1Map_SS_R
		dc.w $2142
		dc.l S1Map_SS_R
		dc.w $2142
		dc.l S1Map_SS_R
		dc.w $2142
		dc.l S1Map_SS_R
		dc.w $4142
		dc.l S1Map_SS_R
		dc.w $4142
		dc.l S1Map_SS_R
		dc.w $4142
		dc.l S1Map_SS_R
		dc.w $4142
		dc.l S1Map_SS_R
		dc.w $4142
		dc.l S1Map_SS_R
		dc.w $4142
		dc.l S1Map_SS_R
		dc.w $4142
		dc.l S1Map_SS_R
		dc.w $4142
		dc.l S1Map_SS_R
		dc.w $4142
		dc.l S1Map_SS_R
		dc.w $6142
		dc.l S1Map_SS_R
		dc.w $6142
		dc.l S1Map_SS_R
		dc.w $6142
		dc.l S1Map_SS_R
		dc.w $6142
		dc.l S1Map_SS_R
		dc.w $6142
		dc.l S1Map_SS_R
		dc.w $6142
		dc.l S1Map_SS_R
		dc.w $6142
		dc.l S1Map_SS_R
		dc.w $6142
		dc.l S1Map_SS_R
		dc.w $6142
		dc.l Map_S1Obj47
		dc.w $23B
		dc.l S1Map_SS_R
		dc.w $570
		dc.l S1Map_SS_R
		dc.w $251
		dc.l S1Map_SS_R
		dc.w $370
		dc.l S1Map_SS_Up
		dc.w $263
		dc.l S1Map_SS_Down
		dc.w $263
		dc.l S1Map_SS_R
		dc.w $22F0
		dc.l S1Map_SS_Glass
		dc.w $470
		dc.l S1Map_SS_Glass
		dc.w $5F0
		dc.l S1Map_SS_Glass
		dc.w $65F0
		dc.l S1Map_SS_Glass
		dc.w $25F0
		dc.l S1Map_SS_Glass
		dc.w $45F0
		dc.l S1Map_SS_R
		dc.w $2F0
		dc.l Map_S1Obj47+$1000000
		dc.w $23B
		dc.l Map_S1Obj47+$2000000
		dc.w $23B
		dc.l S1Map_SS_R
		dc.w $797
		dc.l S1Map_SS_R
		dc.w $7A0
		dc.l S1Map_SS_R
		dc.w $7A9
		dc.l S1Map_SS_R
		dc.w $797
		dc.l S1Map_SS_R
		dc.w $7A0
		dc.l S1Map_SS_R
		dc.w $7A9
		dc.l Map_Obj25
		dc.w $27B2
		dc.l S1Map_SS_Chaos3
		dc.w $770
		dc.l S1Map_SS_Chaos3
		dc.w $2770
		dc.l S1Map_SS_Chaos3
		dc.w $4770
		dc.l S1Map_SS_Chaos3
		dc.w $6770
		dc.l S1Map_SS_Chaos1
		dc.w $770
		dc.l S1Map_SS_Chaos2
		dc.w $770
		dc.l S1Map_SS_R
		dc.w $4F0
		dc.l Map_Obj25+$4000000
		dc.w $27B2
		dc.l Map_Obj25+$5000000
		dc.w $27B2
		dc.l Map_Obj25+$6000000
		dc.w $27B2
		dc.l Map_Obj25+$7000000
		dc.w $27B2
		dc.l S1Map_SS_Glass
		dc.w $23F0
		dc.l S1Map_SS_Glass+$1000000
		dc.w $23F0
		dc.l S1Map_SS_Glass+$2000000
		dc.w $23F0
		dc.l S1Map_SS_Glass+$3000000
		dc.w $23F0
		dc.l S1Map_SS_R+$2000000
		dc.w $4F0
		dc.l S1Map_SS_Glass
		dc.w $5F0
		dc.l S1Map_SS_Glass
		dc.w $65F0
		dc.l S1Map_SS_Glass
		dc.w $25F0
		dc.l S1Map_SS_Glass
		dc.w $45F0
;
; this is actually pretty funny, sonic 1 format	mappings
;
; ps. sonic 1 special stages code sucks	and i always hated it
;
S1Map_SS_R:	dc.w byte_1A344-S1Map_SS_R ; DATA XREF:	ROM:S1SS_MapIndexo
					; ROM:0001A170o ...
		dc.w byte_1A34A-S1Map_SS_R
		dc.w word_1A350-S1Map_SS_R
byte_1A344:	dc.b 1			; DATA XREF: ROM:S1Map_SS_Ro
		dc.b $F4, $A,  0,  0,$F4; 0
byte_1A34A:	dc.b 1			; DATA XREF: ROM:0001A340o
		dc.b $F4, $A,  0,  9,$F4; 0
word_1A350:	dc.w 0			; DATA XREF: ROM:0001A342o
S1Map_SS_Glass:	dc.w byte_1A35A-S1Map_SS_Glass ; DATA XREF: ROM:0001A26Co
					; ROM:0001A272o ...
		dc.w byte_1A360-S1Map_SS_Glass
		dc.w byte_1A366-S1Map_SS_Glass
		dc.w byte_1A36C-S1Map_SS_Glass
byte_1A35A:	dc.b 1			; DATA XREF: ROM:S1Map_SS_Glasso
		dc.b $F4, $A,  0,  0,$F4; 0
byte_1A360:	dc.b 1			; DATA XREF: ROM:0001A354o
		dc.b $F4, $A,  8,  0,$F4; 0
byte_1A366:	dc.b 1			; DATA XREF: ROM:0001A356o
		dc.b $F4, $A,$18,  0,$F4; 0
byte_1A36C:	dc.b 1			; DATA XREF: ROM:0001A358o
		dc.b $F4, $A,$10,  0,$F4; 0
S1Map_SS_Up:	dc.w byte_1A376-S1Map_SS_Up ; DATA XREF: ROM:0001A25Ao
					; ROM:S1Map_SS_Upo ...
		dc.w byte_1A37C-S1Map_SS_Up
byte_1A376:	dc.b 1			; DATA XREF: ROM:S1Map_SS_Upo
		dc.b $F4, $A,  0,  0,$F4; 0
byte_1A37C:	dc.b 1			; DATA XREF: ROM:0001A374o
		dc.b $F4, $A,  0,$12,$F4; 0
S1Map_SS_Down:	dc.w byte_1A386-S1Map_SS_Down ;	DATA XREF: ROM:0001A260o
					; ROM:S1Map_SS_Downo ...
		dc.w byte_1A38C-S1Map_SS_Down
byte_1A386:	dc.b 1			; DATA XREF: ROM:S1Map_SS_Downo
		dc.b $F4, $A,  0,  9,$F4; 0
byte_1A38C:	dc.b 1			; DATA XREF: ROM:0001A384o
		dc.b $F4, $A,  0,$12,$F4; 0
S1Map_SS_Chaos1:dc.w byte_1A39E-S1Map_SS_Chaos1	; DATA XREF: ROM:0001A2DEo
					; ROM:S1Map_SS_Chaos1o	...
		dc.w byte_1A3B0-S1Map_SS_Chaos1
S1Map_SS_Chaos2:dc.w byte_1A3A4-S1Map_SS_Chaos2	; DATA XREF: ROM:0001A2E4o
					; ROM:S1Map_SS_Chaos2o	...
		dc.w byte_1A3B0-S1Map_SS_Chaos2
S1Map_SS_Chaos3:dc.w byte_1A3AA-S1Map_SS_Chaos3	; DATA XREF: ROM:0001A2C6o
					; ROM:0001A2CCo ...
		dc.w byte_1A3B0-S1Map_SS_Chaos3
byte_1A39E:	dc.b 1			; DATA XREF: ROM:S1Map_SS_Chaos1o
		dc.b $F8,  5,  0,  0,$F8; 0
byte_1A3A4:	dc.b 1			; DATA XREF: ROM:S1Map_SS_Chaos2o
		dc.b $F8,  5,  0,  4,$F8; 0
byte_1A3AA:	dc.b 1			; DATA XREF: ROM:S1Map_SS_Chaos3o
		dc.b $F8,  5,  0,  8,$F8; 0
byte_1A3B0:	dc.b 1			; DATA XREF: ROM:0001A394o
					; ROM:0001A398o ...
		dc.b $F8,  5,  0, $C,$F8; 0
; ===============================================================================
		nop
;----------------------------------------------------
; Object 09 - Sonic in Sonic 1 special stage
;----------------------------------------------------

Obj09:					; DATA XREF: ROM:Obj_Indexo
		tst.w	(RAM_Flag_Debug_Placement).w
		beq.s	Obj09_Normal
		bsr.w	S1SS_FixCamera
		bra.w	DebugMode
; ===============================================================================

Obj09_Normal:				; CODE XREF: ROM:0001A3BCj
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj09_Index(pc,d0.w),d1
		jmp	Obj09_Index(pc,d1.w)
; ===============================================================================
Obj09_Index:	dc.w loc_1A3DC-Obj09_Index ; DATA XREF:	ROM:Obj09_Indexo
					; ROM:0001A3D6o ...
		dc.w loc_1A41C-Obj09_Index
		dc.w loc_1A618-Obj09_Index
		dc.w loc_1A66C-Obj09_Index
; ===============================================================================

loc_1A3DC:				; DATA XREF: ROM:Obj09_Indexo
		addq.b	#2,$24(a0)
		move.b	#$E,$16(a0)
		move.b	#7,$17(a0)
		move.l	#Map_Sonic,4(a0)
		move.w	#$780,2(a0)
		bsr.w	j_ModifySpriteAttr_2P_7
		move.b	#4,1(a0)
		move.b	#0,$18(a0)
		move.b	#2,$1C(a0)
		bset	#2,$22(a0)
		bset	#1,$22(a0)

loc_1A41C:				; DATA XREF: ROM:0001A3D6o
		tst.w	(RAM_Flag_DebugMode).w
		beq.s	loc_1A430
		btst	#4,(RAM_Control_1_Press).w
		beq.s	loc_1A430
		move.w	#1,(RAM_Flag_Debug_Placement).w

loc_1A430:				; CODE XREF: ROM:0001A420j
					; ROM:0001A428j
		move.b	#0,$30(a0)
		moveq	#0,d0
		move.b	$22(a0),d0
		andi.w	#2,d0
		move.w	Obj09_Modes(pc,d0.w),d1
		jsr	Obj09_Modes(pc,d1.w)
		jsr	LoadSonicDynPLC
		jmp	DisplaySprite
; ===============================================================================
Obj09_Modes:	dc.w Obj09_OnWall-Obj09_Modes ;	DATA XREF: ROM:Obj09_Modeso
					; ROM:0001A456o
		dc.w Obj09_InAir-Obj09_Modes
; ===============================================================================

Obj09_OnWall:				; DATA XREF: ROM:Obj09_Modeso
		bsr.w	Obj09_Jump
		bsr.w	Obj09_Move
		bsr.w	Obj09_Fall
		bra.s	Obj09_Display
; ===============================================================================

Obj09_InAir:				; DATA XREF: ROM:0001A456o
		bsr.w	nullsub_2
		bsr.w	Obj09_Move
		bsr.w	Obj09_Fall

Obj09_Display:				; CODE XREF: ROM:0001A464j
		bsr.w	Obj09_ChkItems
		bsr.w	OBj09_ChkItems2
		jsr	SpeedToPos
		bsr.w	S1SS_FixCamera
		move.w	(RAM_ObjPos_2pData).w,d0
		add.w	($FFFFF782).w,d0
		move.w	d0,(RAM_ObjPos_2pData).w
		jsr	Sonic_Animate
		rts

; =============== S U B R O U T I N E ==========================================


Obj09_Move:
		btst	#2,(RAM_Control_1_Hold_Copy).w
		beq.s	loc_1A4A4
		bsr.w	Obj09_MoveLeft

loc_1A4A4:
		btst	#3,(RAM_Control_1_Hold_Copy).w
		beq.s	loc_1A4B0
		bsr.w	Obj09_MoveRight

loc_1A4B0:
		move.b	(RAM_Control_1_Hold_Copy).w,d0
		andi.b	#$C,d0
		bne.s	loc_1A4E0
		move.w	$14(a0),d0
		beq.s	loc_1A4E0
		bmi.s	loc_1A4D2
		subi.w	#$C,d0
		bcc.s	loc_1A4CC
		move.w	#0,d0

loc_1A4CC:
		move.w	d0,$14(a0)
		bra.s	loc_1A4E0
; ===============================================================================

loc_1A4D2:
		addi.w	#$C,d0
		bcc.s	loc_1A4DC
		move.w	#0,d0

loc_1A4DC:				; CODE XREF: Obj09_Move+3Ej
		move.w	d0,$14(a0)

loc_1A4E0:				; CODE XREF: Obj09_Move+20j
					; Obj09_Move+26j ...
		move.b	(RAM_ObjPos_2pData).w,d0
		addi.b	#$20,d0	; ' '
		andi.b	#$C0,d0
		neg.b	d0
		jsr	(CalcSine).l
		muls.w	$14(a0),d1
		add.l	d1,8(a0)
		muls.w	$14(a0),d0
		add.l	d0,$C(a0)
		movem.l	d0-d1,-(sp)
		move.l	$C(a0),d2
		move.l	8(a0),d3
		bsr.w	sub_1A720
		beq.s	loc_1A52A
		movem.l	(sp)+,d0-d1
		sub.l	d1,8(a0)
		sub.l	d0,$C(a0)
		move.w	#0,$14(a0)
		rts
; ===============================================================================

loc_1A52A:				; CODE XREF: Obj09_Move+7Cj
		movem.l	(sp)+,d0-d1
		rts
; End of function Obj09_Move


; =============== S U B R O U T I N E ==========================================


Obj09_MoveLeft:				; CODE XREF: Obj09_Move+8p
		bset	#0,$22(a0)
		move.w	$14(a0),d0
		beq.s	loc_1A53E
		bpl.s	loc_1A552

loc_1A53E:				; CODE XREF: Obj09_MoveLeft+Aj
		subi.w	#$C,d0
		cmpi.w	#$F800,d0
		bgt.s	loc_1A54C
		move.w	#$F800,d0

loc_1A54C:				; CODE XREF: Obj09_MoveLeft+16j
		move.w	d0,$14(a0)
		rts
; ===============================================================================

loc_1A552:				; CODE XREF: Obj09_MoveLeft+Cj
		subi.w	#$40,d0	; '@'
		bcc.s	loc_1A55A
		nop

loc_1A55A:				; CODE XREF: Obj09_MoveLeft+26j
		move.w	d0,$14(a0)
		rts
; End of function Obj09_MoveLeft


; =============== S U B R O U T I N E ==========================================


Obj09_MoveRight:			; CODE XREF: Obj09_Move+14p
		bclr	#0,$22(a0)
		move.w	$14(a0),d0
		bmi.s	loc_1A580
		addi.w	#$C,d0
		cmpi.w	#$800,d0
		blt.s	loc_1A57A
		move.w	#$800,d0

loc_1A57A:				; CODE XREF: Obj09_MoveRight+14j
		move.w	d0,$14(a0)
		bra.s	locret_1A58C
; ===============================================================================

loc_1A580:				; CODE XREF: Obj09_MoveRight+Aj
		addi.w	#$40,d0	; '@'
		bcc.s	loc_1A588
		nop

loc_1A588:				; CODE XREF: Obj09_MoveRight+24j
		move.w	d0,$14(a0)

locret_1A58C:				; CODE XREF: Obj09_MoveRight+1Ej
		rts
; End of function Obj09_MoveRight


; =============== S U B R O U T I N E ==========================================


Obj09_Jump:				; CODE XREF: ROM:Obj09_OnWallp
		move.b	(RAM_Control_1_Press_Copy).w,d0
		andi.b	#$70,d0	; 'p'
		beq.s	locret_1A5D0
		move.b	(RAM_ObjPos_2pData).w,d0
		andi.b	#$FC,d0
		neg.b	d0
		subi.b	#$40,d0	; '@'
		jsr	(CalcSine).l
		muls.w	#$680,d1
		asr.l	#8,d1
		move.w	d1,$10(a0)
		muls.w	#$680,d0
		asr.l	#8,d0
		move.w	d0,$12(a0)
		bset	#1,$22(a0)
		move.w	#$A0,d0	; ''
		jsr	(PlaySound_Special).l

locret_1A5D0:				; CODE XREF: Obj09_Jump+8j
		rts
; End of function Obj09_Jump


; =============== S U B R O U T I N E ==========================================


nullsub_2:				; CODE XREF: ROM:Obj09_InAirp
		rts
; End of function nullsub_2

; ===============================================================================
		move.w	#$FC00,d1
		cmp.w	$12(a0),d1
		ble.s	locret_1A5EC
		move.b	(RAM_Control_1_Hold_Copy).w,d0
		andi.b	#$70,d0	; 'p'
		bne.s	locret_1A5EC
		move.w	d1,$12(a0)

locret_1A5EC:				; CODE XREF: ROM:0001A5DCj
					; ROM:0001A5E6j
		rts

; =============== S U B R O U T I N E ==========================================


S1SS_FixCamera:				; CODE XREF: ROM:0001A3BEp
					; ROM:0001A480p ...
		move.w	$C(a0),d2
		move.w	8(a0),d3
		move.w	(RAM_LevelSys_Buff).w,d0
		subi.w	#$A0,d3	; ''
		bcs.s	loc_1A606
		sub.w	d3,d0
		sub.w	d0,(RAM_LevelSys_Buff).w

loc_1A606:				; CODE XREF: S1SS_FixCamera+10j
		move.w	(RAM_LevelSys_Buff+$4).w,d0
		subi.w	#$70,d2	; 'p'
		bcs.s	locret_1A616
		sub.w	d2,d0
		sub.w	d0,(RAM_LevelSys_Buff+$4).w

locret_1A616:				; CODE XREF: S1SS_FixCamera+20j
		rts
; End of function S1SS_FixCamera

; ===============================================================================

loc_1A618:
		addi.w	#$40,($FFFFF782).w
		cmpi.w	#$1800,($FFFFF782).w
		bne.s	loc_1A62C
		move.b	#ModeId_Level,(RAM_GameMode).w

loc_1A62C:
		cmpi.w	#$3000,($FFFFF782).w
		blt.s	loc_1A64A
		move.w	#0,($FFFFF782).w
		move.w	#$4000,(RAM_ObjPos_2pData).w
		addq.b	#2,$24(a0)
		move.w	#$3C,$38(a0) ; '<'

loc_1A64A:				; CODE XREF: ROM:0001A632j
		move.w	(RAM_ObjPos_2pData).w,d0
		add.w	($FFFFF782).w,d0
		move.w	d0,(RAM_ObjPos_2pData).w
		jsr	Sonic_Animate
		jsr	LoadSonicDynPLC
		bsr.w	S1SS_FixCamera
		jmp	DisplaySprite
; ===============================================================================

loc_1A66C:				; DATA XREF: ROM:0001A3DAo
		subq.w	#1,$38(a0)
		bne.s	loc_1A678
		move.b	#ModeId_Level,(RAM_GameMode).w

loc_1A678:				; CODE XREF: ROM:0001A670j
		jsr	Sonic_Animate
		jsr	LoadSonicDynPLC
		bsr.w	S1SS_FixCamera
		jmp	DisplaySprite

; =============== S U B R O U T I N E ==========================================


Obj09_Fall:
		move.l	$C(a0),d2
		move.l	8(a0),d3
		move.b	(RAM_ObjPos_2pData).w,d0
		andi.b	#$FC,d0
		jsr	(CalcSine).l
		move.w	$10(a0),d4
		ext.l	d4
		asl.l	#8,d4
		muls.w	#$2A,d0	; '*'
		add.l	d4,d0
		move.w	$12(a0),d4
		ext.l	d4
		asl.l	#8,d4
		muls.w	#$2A,d1	; '*'
		add.l	d4,d1
		add.l	d0,d3
		bsr.w	sub_1A720
		beq.s	loc_1A6E8
		sub.l	d0,d3
		moveq	#0,d0
		move.w	d0,$10(a0)
		bclr	#1,$22(a0)
		add.l	d1,d2
		bsr.w	sub_1A720
		beq.s	loc_1A6FE
		sub.l	d1,d2
		moveq	#0,d1
		move.w	d1,$12(a0)
		rts
; ===============================================================================

loc_1A6E8:				; CODE XREF: Obj09_Fall+38j
		add.l	d1,d2
		bsr.w	sub_1A720
		beq.s	loc_1A70C
		sub.l	d1,d2
		moveq	#0,d1
		move.w	d1,$12(a0)
		bclr	#1,$22(a0)

loc_1A6FE:				; CODE XREF: Obj09_Fall+4Ej
		asr.l	#8,d0
		asr.l	#8,d1
		move.w	d0,$10(a0)
		move.w	d1,$12(a0)
		rts
; ===============================================================================

loc_1A70C:				; CODE XREF: Obj09_Fall+60j
		asr.l	#8,d0
		asr.l	#8,d1
		move.w	d0,$10(a0)
		move.w	d1,$12(a0)
		bset	#1,$22(a0)
		rts
; End of function Obj09_Fall


; =============== S U B R O U T I N E ==========================================


sub_1A720:				; CODE XREF: Obj09_Move+78p
					; Obj09_Fall+34p ...
		lea	(RAM_MetablockTable).l,a1
		moveq	#0,d4
		swap	d2
		move.w	d2,d4
		swap	d2
		addi.w	#$44,d4	; 'D'
		divu.w	#$18,d4
		mulu.w	#$80,d4	; ''
		adda.l	d4,a1
		moveq	#0,d4
		swap	d3
		move.w	d3,d4
		swap	d3
		addi.w	#$14,d4
		divu.w	#$18,d4
		adda.w	d4,a1
		moveq	#0,d5
		move.b	(a1)+,d4
		bsr.s	sub_1A768
		move.b	(a1)+,d4
		bsr.s	sub_1A768
		adda.w	#$7E,a1	; '~'
		move.b	(a1)+,d4
		bsr.s	sub_1A768
		move.b	(a1)+,d4
		bsr.s	sub_1A768
		tst.b	d5
		rts
; End of function sub_1A720


; =============== S U B R O U T I N E ==========================================


sub_1A768:				; CODE XREF: sub_1A720+32p
					; sub_1A720+36p ...
		beq.s	locret_1A77C
		cmpi.b	#$28,d4	; '('
		beq.s	locret_1A77C
		cmpi.b	#$3A,d4	; ':'
		bcs.s	loc_1A77E
		cmpi.b	#$4B,d4	; 'K'
		bcc.s	loc_1A77E

locret_1A77C:				; CODE XREF: sub_1A768j sub_1A768+6j
		rts
; ===============================================================================

loc_1A77E:				; CODE XREF: sub_1A768+Cj
					; sub_1A768+12j
		move.b	d4,$30(a0)
		move.l	a1,$32(a0)
		moveq	#-1,d5
		rts
; End of function sub_1A768


; =============== S U B R O U T I N E ==========================================


Obj09_ChkItems:
		lea	(RAM_MetablockTable).l,a1
		moveq	#0,d4
		move.w	$C(a0),d4
		addi.w	#$50,d4	; 'P'
		divu.w	#$18,d4
		mulu.w	#$80,d4	; ''
		adda.l	d4,a1
		moveq	#0,d4
		move.w	8(a0),d4
		addi.w	#$20,d4	; ' '
		divu.w	#$18,d4
		adda.w	d4,a1
		move.b	(a1),d4
		bne.s	loc_1A7C4
		tst.b	$3A(a0)
		bne.w	loc_1A894
		moveq	#0,d4
		rts
; ===============================================================================

loc_1A7C4:				; CODE XREF: Obj09_ChkItems+2Cj
		cmpi.b	#$3A,d4	; ':'
		bne.s	loc_1A800
		bsr.w	sub_19EEC
		bne.s	loc_1A7D8
		move.b	#1,(a2)
		move.l	a1,4(a2)

loc_1A7D8:				; CODE XREF: Obj09_ChkItems+44j
		jsr	sub_A8DE
		cmpi.w	#$32,(RAM_Sonic_CurrentRings).w ; '2'
		bcs.s	loc_1A7FC
		bset	#0,(RAM_Sonic_1upScore).w
		bne.s	loc_1A7FC
		addq.b	#1,(RAM_Sonic_Continues).w
		move.w	#$BF,d0	; ''
		jsr	(PlaySound).l

loc_1A7FC:				; CODE XREF: Obj09_ChkItems+5Aj
					; Obj09_ChkItems+62j
		moveq	#0,d4
		rts
; ===============================================================================

loc_1A800:				; CODE XREF: Obj09_ChkItems+3Ej
		cmpi.b	#$28,d4	; '('
		bne.s	loc_1A82A
		bsr.w	sub_19EEC
		bne.s	loc_1A814
		move.b	#3,(a2)
		move.l	a1,4(a2)

loc_1A814:				; CODE XREF: Obj09_ChkItems+80j
		addq.b	#1,(RAM_Sonic_Lives).w
		addq.b	#1,(RAM_Flag_HudUpd_Lives).w
		move.w	#$88,d0	; ''
		jsr	(PlaySound).l
		moveq	#0,d4
		rts
; ===============================================================================

loc_1A82A:				; CODE XREF: Obj09_ChkItems+7Aj
		cmpi.b	#$3B,d4	; ';'
		bcs.s	loc_1A870
		cmpi.b	#$40,d4	; '@'
		bhi.s	loc_1A870
		bsr.w	sub_19EEC
		bne.s	loc_1A844
		move.b	#5,(a2)
		move.l	a1,4(a2)

loc_1A844:				; CODE XREF: Obj09_ChkItems+B0j
		cmpi.b	#6,(RAM_Sonic_Emeralds).w
		beq.s	loc_1A862
		subi.b	#$3B,d4	; ';'
		moveq	#0,d0
		move.b	(RAM_Sonic_Emeralds).w,d0
		lea	(RAM_Sonic_EmeraldTypes).w,a2
		move.b	d4,(a2,d0.w)
		addq.b	#1,(RAM_Sonic_Emeralds).w

loc_1A862:				; CODE XREF: Obj09_ChkItems+C0j
		move.w	#$93,d0	; ''
		jsr	(PlaySound_Special).l
		moveq	#0,d4
		rts
; ===============================================================================

loc_1A870:				; CODE XREF: Obj09_ChkItems+A4j
					; Obj09_ChkItems+AAj
		cmpi.b	#$41,d4	; 'A'
		bne.s	loc_1A87C
		move.b	#1,$3A(a0)

loc_1A87C:				; CODE XREF: Obj09_ChkItems+EAj
		cmpi.b	#$4A,d4	; 'J'
		bne.s	loc_1A890
		cmpi.b	#1,$3A(a0)
		bne.s	loc_1A890
		move.b	#2,$3A(a0)

loc_1A890:				; CODE XREF: Obj09_ChkItems+F6j
					; Obj09_ChkItems+FEj
		moveq	#$FFFFFFFF,d4
		rts
; ===============================================================================

loc_1A894:				; CODE XREF: Obj09_ChkItems+32j
		cmpi.b	#2,$3A(a0)
		bne.s	loc_1A8BE
		lea	($FFFF1020).l,a1
		moveq	#$3F,d1	; '?'

loc_1A8A4:				; CODE XREF: Obj09_ChkItems+130j
		moveq	#$3F,d2	; '?'

loc_1A8A6:				; CODE XREF: Obj09_ChkItems+128j
		cmpi.b	#$41,(a1) ; 'A'
		bne.s	loc_1A8B0
		move.b	#$2C,(a1) ; ','

loc_1A8B0:				; CODE XREF: Obj09_ChkItems+120j
		addq.w	#1,a1
		dbf	d2,loc_1A8A6
		lea	$40(a1),a1
		dbf	d1,loc_1A8A4

loc_1A8BE:				; CODE XREF: Obj09_ChkItems+110j
		clr.b	$3A(a0)
		moveq	#0,d4
		rts
; End of function Obj09_ChkItems


; =============== S U B R O U T I N E ==========================================


OBj09_ChkItems2:			; CODE XREF: ROM:0001A476p
		move.b	$30(a0),d0
		bne.s	loc_1A8E6
		subq.b	#1,$36(a0)
		bpl.s	loc_1A8D8
		move.b	#0,$36(a0)

loc_1A8D8:				; CODE XREF: OBj09_ChkItems2+Aj
		subq.b	#1,$37(a0)
		bpl.s	locret_1A8E4
		move.b	#0,$37(a0)

locret_1A8E4:				; CODE XREF: OBj09_ChkItems2+16j
		rts
; ===============================================================================

loc_1A8E6:				; CODE XREF: OBj09_ChkItems2+4j
		cmpi.b	#$25,d0	; '%'
		bne.s	loc_1A95E
		move.l	$32(a0),d1
		subi.l	#$FFFF0001,d1
		move.w	d1,d2
		andi.w	#$7F,d1	; ''
		mulu.w	#$18,d1
		subi.w	#$14,d1
		lsr.w	#7,d2
		andi.w	#$7F,d2	; ''
		mulu.w	#$18,d2
		subi.w	#$44,d2	; 'D'
		sub.w	8(a0),d1
		sub.w	$C(a0),d2
		jsr	(CalcAngle).l
		jsr	(CalcSine).l
		muls.w	#$F900,d1
		asr.l	#8,d1
		move.w	d1,$10(a0)
		muls.w	#$F900,d0
		asr.l	#8,d0
		move.w	d0,$12(a0)
		bset	#1,$22(a0)
		bsr.w	sub_19EEC
		bne.s	loc_1A954
		move.b	#2,(a2)
		move.l	$32(a0),d0
		subq.l	#1,d0
		move.l	d0,4(a2)

loc_1A954:				; CODE XREF: OBj09_ChkItems2+7Ej
		move.w	#$B4,d0	; ''
		jmp	(PlaySound_Special).l
; ===============================================================================

loc_1A95E:				; CODE XREF: OBj09_ChkItems2+24j
		cmpi.b	#$27,d0	; '''
		bne.s	loc_1A974
		addq.b	#2,$24(a0)
		move.w	#$A8,d0	; ''
		jsr	(PlaySound_Special).l
		rts
; ===============================================================================

loc_1A974:				; CODE XREF: OBj09_ChkItems2+9Cj
		cmpi.b	#$29,d0	; ')'
		bne.s	loc_1A9A8
		tst.b	$36(a0)
		bne.w	locret_1AA58
		move.b	#$1E,$36(a0)
		btst	#6,($FFFFF783).w
		beq.s	loc_1A99E
		asl	($FFFFF782).w
		movea.l	$32(a0),a1
		subq.l	#1,a1
		move.b	#$2A,(a1) ; '*'

loc_1A99E:				; CODE XREF: OBj09_ChkItems2+C8j
		move.w	#$A9,d0	; ''
		jmp	(PlaySound_Special).l
; ===============================================================================

loc_1A9A8:				; CODE XREF: OBj09_ChkItems2+B2j
		cmpi.b	#$2A,d0	; '*'
		bne.s	loc_1A9DC
		tst.b	$36(a0)
		bne.w	locret_1AA58
		move.b	#$1E,$36(a0)
		btst	#6,($FFFFF783).w
		bne.s	loc_1A9D2
		asr	($FFFFF782).w
		movea.l	$32(a0),a1
		subq.l	#1,a1
		move.b	#$29,(a1) ; ')'

loc_1A9D2:				; CODE XREF: OBj09_ChkItems2+FCj
		move.w	#$A9,d0	; ''
		jmp	(PlaySound_Special).l
; ===============================================================================

loc_1A9DC:				; CODE XREF: OBj09_ChkItems2+E6j
		cmpi.b	#$2B,d0	; '+'
		bne.s	loc_1AA12
		tst.b	$37(a0)
		bne.w	locret_1AA58
		move.b	#$1E,$37(a0)
		bsr.w	sub_19EEC
		bne.s	loc_1AA04
		move.b	#4,(a2)
		move.l	$32(a0),d0
		subq.l	#1,d0
		move.l	d0,4(a2)

loc_1AA04:
		neg.w	($FFFFF782).w
		move.w	#$A9,d0
		jmp	(PlaySound_Special).l
; ===============================================================================

loc_1AA12:
		cmpi.b	#$2D,d0
		beq.s	loc_1AA2A
		cmpi.b	#$2E,d0
		beq.s	loc_1AA2A
		cmpi.b	#$2F,d0
		beq.s	loc_1AA2A
		cmpi.b	#$30,d0
		bne.s	locret_1AA58

loc_1AA2A:
		bsr.w	sub_19EEC
		bne.s	loc_1AA4E
		move.b	#6,(a2)
		movea.l	$32(a0),a1
		subq.l	#1,a1
		move.l	a1,4(a2)
		move.b	(a1),d0
		addq.b	#1,d0
		cmpi.b	#$30,d0
		bls.s	loc_1AA4A
		clr.b	d0

loc_1AA4A:
		move.b	d0,4(a2)

loc_1AA4E:
		move.w	#$BA,d0
		jmp	(PlaySound_Special).l
; ===============================================================================

locret_1AA58:
		rts

; ===============================================================================
;----------------------------------------------------
; Object 10 - Tails eating the master emerald
;----------------------------------------------------

Obj10:
		rts
; ===============================================================================

j_ModifySpriteAttr_2P_7:
		jmp	ModifySpriteAttr_2P
; ===============================================================================
		align 4

; =============== S U B R O U T I N E ==========================================


DynamicArtCues:
		moveq	#0,d0
		move.b	(RAM_Level_CurrentZone).w,d0
		add.w	d0,d0
		add.w	d0,d0
		move.w	DynArtCue_Index+2(pc,d0.w),d1	;Get DynamicArtCues list
		lea	DynArtCue_Index(pc,d1.w),a2	;Save to a2
		move.w	DynArtCue_Index(pc,d0.w),d0
		jmp	DynArtCue_Index(pc,d0.w)
		rts

; ===============================================================================
DynArtCue_Index:
		dc.w Dynamic_NullGHZ-DynArtCue_Index,AnimCue_EHZ-DynArtCue_Index
		dc.w Dynamic_Null-DynArtCue_Index,AnimCue_Unk-DynArtCue_Index
		dc.w Dynamic_Null-DynArtCue_Index,AnimCue_Unk-DynArtCue_Index
		dc.w Dynamic_Run-DynArtCue_Index,AnimCue_EHZ-DynArtCue_Index
		dc.w Dynamic_Run-DynArtCue_Index,AnimCue_HPZ-DynArtCue_Index
		dc.w Dynamic_Run-DynArtCue_Index,AnimCue_EHZ-DynArtCue_Index
		dc.w Dynamic_Null-DynArtCue_Index,AnimCue_Unk-DynArtCue_Index
		dc.w Dynamic_Null-DynArtCue_Index,AnimCue_Unk-DynArtCue_Index
		dc.w Dynamic_Run-DynArtCue_Index,AnimCue_HPZ-DynArtCue_Index
		dc.w Dynamic_Null-DynArtCue_Index,AnimCue_Unk-DynArtCue_Index
		dc.w Dynamic_Null-DynArtCue_Index,AnimCue_Unk-DynArtCue_Index
		dc.w Dynamic_Null-DynArtCue_Index,AnimCue_Unk-DynArtCue_Index
		dc.w Dynamic_Null-DynArtCue_Index,AnimCue_Unk-DynArtCue_Index
		dc.w Dynamic_Null-DynArtCue_Index,AnimCue_Unk-DynArtCue_Index
		dc.w Dynamic_Null-DynArtCue_Index,AnimCue_Unk-DynArtCue_Index
		dc.w Dynamic_Null-DynArtCue_Index,AnimCue_Unk-DynArtCue_Index
; ===============================================================================

Dynamic_Null:
		rts
; ===============================================================================

Dynamic_NullGHZ:
		rts
; ===============================================================================

Dynamic_Run:
		lea	(RAM_DynLoadCues_Buffer).w,a3
		move.w	(a2)+,d6

loc_1AACA:
		subq.b	#1,(a3)
		bpl.s	loc_1AB10
		moveq	#0,d0
		move.b	1(a3),d0
		cmp.b	6(a2),d0
		bcs.s	loc_1AAE0
		moveq	#0,d0
		move.b	d0,1(a3)

loc_1AAE0:
		addq.b	#1,1(a3)
		move.b	(a2),(a3)
		bpl.s	loc_1AAEE
		add.w	d0,d0
		move.b	9(a2,d0.w),(a3)

loc_1AAEE:
		move.b	8(a2,d0.w),d0
		lsl.w	#5,d0
		move.w	4(a2),d2
		move.l	(a2),d1
		andi.l	#$FFFFFF,d1
		add.l	d0,d1
		moveq	#0,d3
		move.b	7(a2),d3
		lsl.w	#4,d3
		jsr	(DMA_68KtoVRAM).l

loc_1AB10:
		move.b	6(a2),d0
		tst.b	(a2)
		bpl.s	loc_1AB1A
		add.b	d0,d0

loc_1AB1A:
		addq.b	#1,d0
		andi.w	#$FE,d0	; ''
		lea	8(a2,d0.w),a2
		addq.w	#2,a3
		dbf	d6,loc_1AACA
		rts
; ===============================================================================
AnimCue_EHZ:	dc.w 4
		dc.l Art_EHZFlower1+$FF000000
		dc.w $7280
		dc.b 6
		dc.b 2
		dc.b   0,$7F		; 0
		dc.b   2,$13		; 2
		dc.b   0,  7		; 4
		dc.b   2,  7		; 6
		dc.b   0,  7		; 8
		dc.b   2,  7		; 10
		dc.l Art_EHZFlower2+$FF000000
		dc.w $72C0
		dc.b 8
		dc.b 2
		dc.b   2,$7F		; 0
		dc.b   0, $B		; 2
		dc.b   2, $B		; 4
		dc.b   0, $B		; 6
		dc.b   2,  5		; 8
		dc.b   0,  5		; 10
		dc.b   2,  5		; 12
		dc.b   0,  5		; 14
		dc.l Art_EHZFlower3+$7000000
		dc.w $7300
		dc.b 2
		dc.b 2
		dc.b   0,  2		; 0
		dc.l Art_EHZFlower4+$FF000000
		dc.w $7340
		dc.b 8
		dc.b 2
		dc.b   0,$7F		; 0
		dc.b   2,  7		; 2
		dc.b   0,  7		; 4
		dc.b   2,  7		; 6
		dc.b   0,  7		; 8
		dc.b   2, $B		; 10
		dc.b   0, $B		; 12
		dc.b   2, $B		; 14
		dc.l Art_EHZFlower5+$1000000
		dc.w $7380
		dc.b 6
		dc.b 2
		dc.b   0,  2		; 0
		dc.b   4,  6		; 2
		dc.b   4,  2		; 4

AnimCue_HPZ:	dc.w 2
		dc.l Art_HPZGlowingBall+$8000000
		dc.w $5D00
		dc.b 6
		dc.b 8
		dc.b   0,  0		; 0
		dc.b   8,$10		; 2
		dc.b $10,  8		; 4
		dc.l Art_HPZGlowingBall+$8000000
		dc.w $5E00
		dc.b 6
		dc.b 8
		dc.b   8,$10		; 0
		dc.b $10,  8		; 2
		dc.b   0,  0		; 4
		dc.l Art_HPZGlowingBall+$8000000
		dc.w $5F00
		dc.b 6
		dc.b 8
		dc.b $10,  8		; 0
		dc.b   0,  0		; 2
		dc.b   8,$10		; 4

AnimCue_Unk:	dc.w 7
		dc.l Art_UnkZone_1+$7000000
		dc.w $9000
		dc.b 2
		dc.b 4
		dc.b   0,  4		; 0
		dc.l Art_UnkZone_2+$7000000
		dc.w $9080
		dc.b 3
		dc.b 8
		dc.b   0,  8		; 0
		dc.b $10,  0		; 2
		dc.l Art_UnkZone_3+$7000000
		dc.w $9180
		dc.b 4
		dc.b 2
		dc.b   0,  2		; 0
		dc.b   0,  4		; 2
		dc.l Art_UnkZone_4+$B000000
		dc.w $91C0
		dc.b 4
		dc.b 2
		dc.b   0,  2		; 0
		dc.b   4,  2		; 2
		dc.l Art_UnkZone_5+$F000000
		dc.w $9200
		dc.b $A
		dc.b 1
		dc.b   0		; 0
		dc.b   0		; 1
		dc.b   1		; 2
		dc.b   2		; 3
		dc.b   3		; 4
		dc.b   4		; 5
		dc.b   5		; 6
		dc.b   4		; 7
		dc.b   5		; 8
		dc.b   4		; 9
		dc.l Art_UnkZone_6+$3000000
		dc.w $9220
		dc.b 4
		dc.b 4
		dc.b   0,  4		; 0
		dc.b   8,  4		; 2
		dc.l Art_UnkZone_7+$7000000
		dc.w $92A0
		dc.b 6
		dc.b 3
		dc.b   0,  3		; 0
		dc.b   6,  9		; 2
		dc.b  $C, $F		; 4
		dc.l Art_UnkZone_8+$7000000
		dc.w $9300
		dc.b 4
		dc.b 1
		dc.b   0		; 0
		dc.b   1		; 1
		dc.b   2		; 2
		dc.b   3		; 3
; ===============================================================================
		cmpi.b	#2,(RAM_Level_CurrentZone).w
		beq.s	loc_1AC28

locret_1AC26:
		rts
; ===============================================================================

loc_1AC28:
		move.w	(RAM_LevelSys_Buff).w,d0
		cmpi.w	#$1940,d0
		bcs.s	locret_1AC26
		cmpi.w	#$1F80,d0
		bcc.s	locret_1AC26
		subq.b	#1,($FFFFF721).w
		bpl.s	locret_1AC26
		move.b	#7,($FFFFF721).w
		move.b	#1,(RAM_Flag_Level_ForceReload).w
		lea	($FFFF7500).l,a1
		bsr.s	sub_1AC58
		lea	($FFFF7D00).l,a1

; =============== S U B R O U T I N E ==========================================


sub_1AC58:
		move.w	#7,d1

loc_1AC5C:
		move.w	(a1),d0
		move.w	2(a1),(a1)+
		move.w	2(a1),(a1)+
		move.w	2(a1),(a1)+
		move.w	2(a1),(a1)+
		move.w	2(a1),(a1)+
		move.w	2(a1),(a1)+
		move.w	2(a1),(a1)+
		move.w	$72(a1),(a1)+
		adda.w	#$70,a1	; 'p'
		move.w	2(a1),(a1)+
		move.w	2(a1),(a1)+
		move.w	2(a1),(a1)+
		move.w	2(a1),(a1)+
		move.w	2(a1),(a1)+
		move.w	2(a1),(a1)+
		move.w	2(a1),(a1)+
		move.w	$72(a1),(a1)+
		adda.w	#$70,a1	; 'p'
		move.w	2(a1),(a1)+
		move.w	2(a1),(a1)+
		move.w	2(a1),(a1)+
		move.w	2(a1),(a1)+
		move.w	2(a1),(a1)+
		move.w	2(a1),(a1)+
		move.w	2(a1),(a1)+
		move.w	$72(a1),(a1)+
		adda.w	#$70,a1	; 'p'
		move.w	2(a1),(a1)+
		move.w	2(a1),(a1)+
		move.w	2(a1),(a1)+
		move.w	2(a1),(a1)+
		move.w	2(a1),(a1)+
		move.w	2(a1),(a1)+
		move.w	2(a1),(a1)+
		move.w	d0,(a1)+
		suba.w	#$180,a1
		dbf	d1,loc_1AC5C
		rts
; End of function sub_1AC58

;----------------------------------------------------
; This subroutines changes some	16x16 mappings
;----------------------------------------------------

; =============== S U B R O U T I N E ==========================================


LoadMap16Delta:
		moveq	#0,d0
		move.b	(RAM_Level_CurrentZone).w,d0
		add.w	d0,d0
		move.w	Map16Delta_Index(pc,d0.w),d0
		lea	Map16Delta_Index(pc,d0.w),a0
		tst.w	(a0)				;A0 contains something?
		beq.s	LoadMap16Delta_NoData		;branch if $0 (nothing)
		lea	(RAM_Level_Data_16).w,a1
		adda.w	(a0)+,a1
		move.w	(a0)+,d1
		tst.w	(RAM_Flag_SplitScreen).w
		bne.s	loc_1AD1C

loc_1AD14:
		move.w	(a0)+,(a1)+
		dbf	d1,loc_1AD14

LoadMap16Delta_NoData:
		rts
; ===============================================================================

loc_1AD1C:
		move.w	(a0)+,d0
		move.w	d0,d1
		andi.w	#$F800,d0
		andi.w	#$7FF,d1
		lsr.w	#1,d1
		or.w	d1,d0
		move.w	d0,(a1)+
		dbf	d1,loc_1AD1C
		rts
; End of function LoadMap16Delta

; ===============================================================================
Map16Delta_Index:
		dc.w Map16Delta_GHZ1-Map16Delta_Index;	0
		dc.w Map16Delta_GHZ2-Map16Delta_Index; 1
		dc.w Map16Delta_GHZ3-Map16Delta_Index; 2
		dc.w Map16Delta_GHZ1-Map16Delta_Index; 3
		dc.w Map16Delta_CPZ1-Map16Delta_Index; 4
		dc.w Map16Delta_GHZ1-Map16Delta_Index; 5
		dc.w Map16Delta_GHZ2-Map16Delta_Index; 6
		dc.w Map16Delta_GHZ2-Map16Delta_Index; 7
		dc.w Map16Delta_CPZ1-Map16Delta_Index; 8
		dc.w Map16Delta_GHZ2-Map16Delta_Index; 9
		dc.w Map16Delta_GHZ2-Map16Delta_Index; 10
		dc.w Map16Delta_GHZ2-Map16Delta_Index; 11
		dc.w Map16Delta_GHZ2-Map16Delta_Index; 12
		dc.w Map16Delta_GHZ3-Map16Delta_Index; 13
		dc.w Map16Delta_GHZ2-Map16Delta_Index; 14
		dc.w Map16Delta_GHZ2-Map16Delta_Index; 15

Map16Delta_GHZ1:dc.w $1788,  $3B,$4502,$4504,$4503,$4505,$4506,$4508,$4507,$4509,$450A,$450C,$450B,$450D,$450E,$4510; 0
					; DATA XREF: ROM:Map16Delta_Indexo
		dc.w $450F,$4511,$4512,$4514,$4513,$4515,$4516,$4518,$4517,$4519,$651A,$651C,$651B,$651D,$651E,$6520; 16
		dc.w $651F,$6521,$439C,$4B9C,$439D,$4B9D,$4158,$439C,$4159,$439D,$4B9C,$4958,$4B9D,$4959,$6394,$6B94; 32
		dc.w $6395,$6B95,$E396,$EB96,$E397,$EB97,$6398,$6B98,$6399,$6B99,$E39A,$EB9A,$E39B,$EB9B; 48
Map16Delta_GHZ2:dc.w	 0, $C80,  $9B,$43A1,$43A2,$43A3,$43A4,$43A5,$43A6,$43A7,$43A8,$43A9,$43AA,$43AB,$43AC,$43AD; 0
					; DATA XREF: ROM:Map16Delta_Indexo
		dc.w $43AE,$43AF,$43B0,$43B1,$43B2,$43B3,$43B4,$43B5,$43B6,$43B7,$43B8,$43B9,$43BA,$43BB,$43BC,$43BD; 16
		dc.w $43BE,$43BF,$43C0,$43C1,$43C2,$43C3,$43C4,$63A0,$63A0,$63A0,$63A0,$63A0,$63A0,$63A0,$63A0,	   0; 32
		dc.w	 0,$6340,$6344,	   0,	 0,$6348,$634C,$6341,$6345,$6342,$6346,$6349,$634D,$634A,$634E,$6343; 48
		dc.w $6347,$4358,$4359,$634B,$634F,$435A,$435B,$6380,$6384,$6381,$6385,$6388,$638C,$6389,$638D,$6382; 64
		dc.w $6386,$6383,$6387,$638A,$638E,$638B,$638F,$6390,$6394,$6391,$6395,$6398,$639C,$6399,$639D,$6392; 80
		dc.w $6396,$6393,$6397,$639A,$639E,$639B,$639F,$4378,$4379,$437A,$437B,$437C,$437D,$437E,$437F,$235C; 96
		dc.w $235D,$235E,$235F,$2360,$2361,$2362,$2363,$2364,$2365,$2366,$2367,$2368,$2369,$236A,$236B,	   0; 112
		dc.w	 0,$636C,$636D,	   0,	 0,$636E,    0,$636F,$6370,$6371,$6372,$6373,	 0,$6374,    0,$6375; 128
		dc.w $6376,$4358,$4359,$6377,	 0,$435A,$435B,$C378,$C379,$C37A,$C37B,$C37C,$C37D,$C37E,$C37F;	144
Map16Delta_GHZ3:dc.w $17E0,   $F,$43D1,$43D1,$43D1,$43D1,$43D2,$43D2,$43D3,$43D3,$43D4,$43D4,$43D5,$43D5,$43D6,$43D6; 0
					; DATA XREF: ROM:Map16Delta_Indexo
		dc.w $43D7,$43D7	; 16
Map16Delta_CPZ1:dc.w $1710,  $77,$62E8,$62E9,$62EA,$62EB,$62EC,$62ED,$62EE,$62EF,$62F0,$62F1,$62F2,$62F3,$62F4,$62F5; 0
					; DATA XREF: ROM:Map16Delta_Indexo
		dc.w $62F6,$62F7,$62F8,$62F9,$62FA,$62FB,$62FC,$62FD,$62FE,$62FF,$42E8,$42E9,$42EA,$42EB,$42EC,$42ED; 16
		dc.w $42EE,$42EF,$42F0,$42F1,$42F2,$42F3,$42F4,$42F5,$42F6,$42F7,$42F8,$42F9,$42FA,$42FB,$42FC,$42FD; 32
		dc.w $42FE,$42FF,    0,$62E8,	 0,$62EA,$62E9,$62EC,$62EB,$62EE,$62ED,	   0,$62EF,    0,    0,$62F0; 48
		dc.w	 0,$62F2,$62F1,$62F4,$62F3,$62F6,$62F5,	   0,$62F7,    0,    0,$62F8,	 0,$62FA,$62F9,$62FC; 64
		dc.w $62FB,$62FE,$62FD,	   0,$62FF,    0,    0,$42E8,	 0,$42EA,$42E9,$42EC,$42EB,$42EE,$42ED,	   0; 80
		dc.w $42EF,    0,    0,$42F0,	 0,$42F2,$42F1,$42F4,$42F3,$42F6,$42F5,	   0,$42F7,    0,    0,$42F8; 96
		dc.w	 0,$42FA,$42F9,$42FC,$42FB,$42FE,$42FD,	   0,$42FF,    0; 112
; ===============================================================================
		nop
;----------------------------------------------------
; Object 21 - SCORE, TIME, RINGS
;----------------------------------------------------

Obj21:
		moveq	#0,d0
		move.b	$24(a0),d0
		move.w	Obj21_Index(pc,d0.w),d1
		jmp	Obj21_Index(pc,d1.w)
; ===============================================================================
Obj21_Index:	dc.w Obj21_Init-Obj21_Index
		dc.w Obj21_Main-Obj21_Index
; ===============================================================================

Obj21_Init:
		addq.b	#2,$24(a0)
		move.w	#$90,8(a0)
		move.w	#$108,$A(a0)
		move.l	#Map_Obj21,4(a0)
		move.w	#$6CA,2(a0)
		bsr.w	j_ModifySpriteAttr_2P_8
		move.b	#0,1(a0)
		move.b	#0,$18(a0)

Obj21_Main:
		tst.w	(RAM_Sonic_CurrentRings).w
		beq.s	loc_1B08C
		moveq	#0,d0
		btst	#3,(RAM_Flag_LevelFrameTmr+$1).w
		bne.s	loc_1B082
		cmpi.b	#9,(RAM_Hud_Time+$1).w
		bne.s	loc_1B082
		addq.w	#2,d0

loc_1B082:
		move.b	d0,$1A(a0)
		jmp	DisplaySprite
; ===============================================================================

loc_1B08C:
		moveq	#0,d0
		btst	#3,(RAM_Flag_LevelFrameTmr+$1).w
		bne.s	loc_1B0A2
		addq.w	#1,d0
		cmpi.b	#9,(RAM_Hud_Time+$1).w
		bne.s	loc_1B0A2
		addq.w	#2,d0

loc_1B0A2:
		move.b	d0,$1A(a0)
		jmp	DisplaySprite
; ===============================================================================
Map_Obj21:	dc.w word_1B0B4-Map_Obj21
		dc.w word_1B106-Map_Obj21
		dc.w word_1B158-Map_Obj21
		dc.w word_1B1AA-Map_Obj21

word_1B0B4:	dc.w $A
		dc.w $800D,$A000,$A000,	   0; 0
		dc.w $800D,$A018,$A00C,	 $20; 4
		dc.w $800D,$A020,$A010,	 $40; 8
		dc.w $900D,$A010,$A008,	   0; 12
		dc.w $900D,$A028,$A014,	 $28; 16
		dc.w $A00D,$A008,$A004,	   0; 20
		dc.w $A001,$A000,$A000,	 $20; 24
		dc.w $A009,$A030,$A018,	 $30; 28
		dc.w $4005,$810A,$8085,	   0; 32
		dc.w $400D,$A10E,$A087,	 $10; 36

word_1B106:	dc.w $A
		dc.w $800D,$A000,$A000,	   0; 0
		dc.w $800D,$A018,$A00C,	 $20; 4
		dc.w $800D,$A020,$A010,	 $40; 8
		dc.w $900D,$A010,$A008,	   0; 12
		dc.w $900D,$A028,$A014,	 $28; 16
		dc.w $A00D,$8008,$8004,	   0; 20
		dc.w $A001,$8000,$8000,	 $20; 24
		dc.w $A009,$A030,$A018,	 $30; 28
		dc.w $4005,$810A,$8085,	   0; 32
		dc.w $400D,$A10E,$A087,	 $10; 36

word_1B158:	dc.w $A
		dc.w $800D,$A000,$A000,	   0; 0
		dc.w $800D,$A018,$A00C,	 $20; 4
		dc.w $800D,$A020,$A010,	 $40; 8
		dc.w $900D,$8010,$8008,	   0; 12
		dc.w $900D,$A028,$A014,	 $28; 16
		dc.w $A00D,$A008,$A004,	   0; 20
		dc.w $A001,$A000,$A000,	 $20; 24
		dc.w $A009,$A030,$A018,	 $30; 28
		dc.w $4005,$810A,$8085,	   0; 32
		dc.w $400D,$A10E,$A087,	 $10; 36

word_1B1AA:	dc.w $A
		dc.w $800D,$A000,$A000,	   0; 0
		dc.w $800D,$A018,$A00C,	 $20; 4
		dc.w $800D,$A020,$A010,	 $40; 8
		dc.w $900D,$8010,$8008,	   0; 12
		dc.w $900D,$A028,$A014,	 $28; 16
		dc.w $A00D,$8008,$8004,	   0; 20
		dc.w $A001,$8000,$8000,	 $20; 24
		dc.w $A009,$A030,$A018,	 $30; 28
		dc.w $4005,$810A,$8085,	   0; 32
		dc.w $400D,$A10E,$A087,	 $10; 36

; =============== S U B R O U T I N E ==========================================


AddPoints:
		move.b	#1,(RAM_Flag_HudUpd_Score).w
		lea	(RAM_Hud_Score).w,a3
		add.l	d0,(a3)
		move.l	#999999,d1
		cmp.l	(a3),d1
		bhi.s	loc_1B214
		move.l	d1,(a3)

loc_1B214:
		move.l	(a3),d0
		cmp.l	(RAM_Sonic_NextScore).w,d0
		bcs.s	locret_1B23C
		addi.l	#5000,(RAM_Sonic_NextScore).w
		tst.b	(RAM_MD_SysRegion).w
		bmi.s	locret_1B23C
		addq.b	#1,(RAM_Sonic_Lives).w
		addq.b	#1,(RAM_Flag_HudUpd_Lives).w
		move.w	#$88,d0
		jmp	(PlaySound).l
; ===============================================================================

locret_1B23C:
		rts

; =============== S U B R O U T I N E ==========================================


HudUpdate:
		nop
		lea	($C00000).l,a6
		tst.w	(RAM_Flag_DebugMode).w
		bne.w	loc_1B330
		tst.b	(RAM_Flag_HudUpd_Score).w
		beq.s	loc_1B266
		clr.b	(RAM_Flag_HudUpd_Score).w
		move.l	#$5C800003,d0
		move.l	(RAM_Hud_Score).w,d1
		bsr.w	HUD_Score

loc_1B266:
		tst.b	(RAM_Flag_HudUpd_Rings).w
		beq.s	loc_1B286
		bpl.s	loc_1B272
		bsr.w	HUD_LoadZero

loc_1B272:
		clr.b	(RAM_Flag_HudUpd_Rings).w
		move.l	#$5F400003,d0
		moveq	#0,d1
		move.w	(RAM_Sonic_CurrentRings).w,d1
		bsr.w	HUD_Rings

loc_1B286:
		tst.b	(RAM_Flag_HudUpd_Timer).w
		beq.s	loc_1B2E2
		tst.w	(RAM_Flag_LevelPaused).w
		bne.s	loc_1B2E2
		lea	(RAM_Hud_Time).w,a1
		cmpi.l	#$93B3B,(a1)+
		nop
		addq.b	#1,-(a1)
		cmpi.b	#$3C,(a1)
		bcs.s	loc_1B2E2
		move.b	#0,(a1)
		addq.b	#1,-(a1)
		cmpi.b	#$3C,(a1)
		bcs.s	loc_1B2C2
		move.b	#0,(a1)
		addq.b	#1,-(a1)
		cmpi.b	#9,(a1)
		bcs.s	loc_1B2C2
		move.b	#9,(a1)

loc_1B2C2:
		move.l	#$5E400003,d0
		moveq	#0,d1
		move.b	(RAM_Hud_Time+$1).w,d1
		bsr.w	HUD_Mins
		move.l	#$5EC00003,d0
		moveq	#0,d1
		move.b	(RAM_Hud_Time+$2).w,d1
		bsr.w	HUD_Secs

loc_1B2E2:
		tst.b	(RAM_Flag_HudUpd_Lives).w
		beq.s	loc_1B2F0
		clr.b	(RAM_Flag_HudUpd_Lives).w
		bsr.w	HUD_Lives

loc_1B2F0:
		tst.b	(RAM_Flag_HudUpd_Bonus).w
		beq.s	locret_1B318
		clr.b	(RAM_Flag_HudUpd_Bonus).w
		move.l	#$6E000002,($C00004).l
		moveq	#0,d1
		move.w	(RAM_Level_Bonus_Time).w,d1
		bsr.w	HUD_TimeRingBonus
		moveq	#0,d1
		move.w	(RAM_Level_Bonus_Rings).w,d1
		bsr.w	HUD_TimeRingBonus

locret_1B318:
		rts
; ===============================================================================

S1TimeOver:				; leftover from	Sonic 1
		clr.b	(RAM_Flag_HudUpd_Timer).w
		lea	(RAM_ObjRAM_Sonic).w,a0
		movea.l	a0,a2
		bsr.w	KillSonic
		move.b	#1,(RAM_Flag_Sonic_TimeOver).w
		rts
; ===============================================================================

loc_1B330:
		bsr.w	HUDDebug_XY
		tst.b	(RAM_Flag_HudUpd_Rings).w
		beq.s	loc_1B354
		bpl.s	loc_1B340
		bsr.w	HUD_LoadZero

loc_1B340:
		clr.b	(RAM_Flag_HudUpd_Rings).w
		move.l	#$5F400003,d0
		moveq	#0,d1
		move.w	(RAM_Sonic_CurrentRings).w,d1
		bsr.w	HUD_Rings

loc_1B354:
		move.l	#$5EC00003,d0
		moveq	#0,d1
		move.b	(RAM_Debug_MaxSprites).w,d1
		bsr.w	HUD_Secs
		tst.b	(RAM_Flag_HudUpd_Lives).w
		beq.s	loc_1B372
		clr.b	(RAM_Flag_HudUpd_Lives).w
		bsr.w	HUD_Lives

loc_1B372:
		tst.b	(RAM_Flag_HudUpd_Bonus).w
		beq.s	locret_1B39A
		clr.b	(RAM_Flag_HudUpd_Bonus).w
		move.l	#$6E000002,($C00004).l
		moveq	#0,d1
		move.w	(RAM_Level_Bonus_Time).w,d1
		bsr.w	HUD_TimeRingBonus
		moveq	#0,d1
		move.w	(RAM_Level_Bonus_Rings).w,d1
		bsr.w	HUD_TimeRingBonus

locret_1B39A:
		rts

; =============== S U B R O U T I N E ==========================================


HUD_LoadZero:
		move.l	#$5F400003,($C00004).l
		lea	HUD_TilesZero(pc),a2
		move.w	#2,d2
		bra.s	loc_1B3CC


; =============== S U B R O U T I N E ==========================================


HUD_Base:
		lea	($C00000).l,a6
		bsr.w	HUD_Lives
		move.l	#$5C400003,($C00004).l
		lea	HUD_TilesBase(pc),a2
		move.w	#$E,d2

loc_1B3CC:
		lea	Art_HUD(pc),a1

loc_1B3D0:
		move.w	#$F,d1
		move.b	(a2)+,d0
		bmi.s	loc_1B3EC
		ext.w	d0
		lsl.w	#5,d0
		lea	(a1,d0.w),a3

loc_1B3E0:
		move.l	(a3)+,(a6)
		dbf	d1,loc_1B3E0

loc_1B3E6:
		dbf	d2,loc_1B3D0
		rts
; ===============================================================================

loc_1B3EC:
		move.l	#0,(a6)
		dbf	d1,loc_1B3EC
		bra.s	loc_1B3E6

; ===============================================================================
HUD_TilesBase:	dc.b $16,$FF,$FF,$FF,$FF,$FF,$FF,  0,  0,$14,  0,  0; 0
HUD_TilesZero:	dc.b $FF,$FF,  0,  0

; =============== S U B R O U T I N E ==========================================

HUDDebug_XY:
		move.l	#$5C400003,($C00004).l
		move.w	(RAM_LevelSys_Buff).w,d1
		swap	d1
		move.w	(RAM_ObjRam_Sonic+$8).w,d1
		bsr.s	HUDDebug_XY2
		move.w	(RAM_LevelSys_Buff+$4).w,d1
		swap	d1
		move.w	(RAM_ObjRam_Sonic+$C).w,d1


; =============== S U B R O U T I N E ==========================================


HUDDebug_XY2:
		moveq	#7,d6
		lea	(Art_Text).l,a1

loc_1B430:
		rol.w	#4,d1
		move.w	d1,d2
		andi.w	#$F,d2
		cmpi.w	#$A,d2
		bcs.s	loc_1B442
		addi.w	#7,d2

loc_1B442:
		lsl.w	#5,d2
		lea	(a1,d2.w),a3
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		swap	d1
		dbf	d6,loc_1B430
		rts


; =============== S U B R O U T I N E ==========================================


HUD_Rings:
		lea	(HUD_100).l,a2
		moveq	#2,d6
		bra.s	loc_1B472


; =============== S U B R O U T I N E ==========================================


HUD_Score:
		lea	(HUD_100000).l,a2
		moveq	#5,d6

loc_1B472:
		moveq	#0,d4
		lea	Art_HUD(pc),a1

loc_1B478:
		moveq	#0,d2
		move.l	(a2)+,d3

loc_1B47C:
		sub.l	d3,d1
		bcs.s	loc_1B484
		addq.w	#1,d2
		bra.s	loc_1B47C
; ===============================================================================

loc_1B484:
		add.l	d3,d1
		tst.w	d2
		beq.s	loc_1B48E
		move.w	#1,d4

loc_1B48E:
		tst.w	d4
		beq.s	loc_1B4BC
		lsl.w	#6,d2
		move.l	d0,4(a6)
		lea	(a1,d2.w),a3
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)

loc_1B4BC:
		addi.l	#$400000,d0
		dbf	d6,loc_1B478
		rts

; ===============================================================================

HUD_Unk:
		move.l	#$5F800003,($C00004).l
		lea	($C00000).l,a6
		lea	(HUD_10).l,a2
		moveq	#1,d6
		moveq	#0,d4
		lea	Art_HUD(pc),a1

loc_1B4E6:
		moveq	#0,d2
		move.l	(a2)+,d3

loc_1B4EA:
		sub.l	d3,d1
		bcs.s	loc_1B4F2
		addq.w	#1,d2
		bra.s	loc_1B4EA
; ===============================================================================

loc_1B4F2:
		add.l	d3,d1
		lsl.w	#6,d2
		lea	(a1,d2.w),a3
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		dbf	d6,loc_1B4E6
		rts
; ===============================================================================
HUD_100000:	dc.l 100000
HUD_10000:	dc.l 10000
HUD_1000:	dc.l 1000
HUD_100:	dc.l 100
HUD_10:		dc.l 10
HUD_1:		dc.l 1

; =============== S U B R O U T I N E ==========================================


HUD_Mins:
		lea	HUD_1(pc),a2
		moveq	#0,d6
		bra.s	loc_1B546

; =============== S U B R O U T I N E ==========================================


HUD_Secs:
		lea	HUD_10(pc),a2
		moveq	#1,d6

loc_1B546:
		moveq	#0,d4

loc_1B548:
		lea	Art_HUD(pc),a1

loc_1B54C:
		moveq	#0,d2
		move.l	(a2)+,d3

loc_1B550:
		sub.l	d3,d1
		bcs.s	loc_1B558
		addq.w	#1,d2
		bra.s	loc_1B550
; ===============================================================================

loc_1B558:
		add.l	d3,d1
		tst.w	d2
		beq.s	loc_1B562
		move.w	#1,d4

loc_1B562:
		lsl.w	#6,d2
		move.l	d0,4(a6)
		lea	(a1,d2.w),a3
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		addi.l	#$400000,d0
		dbf	d6,loc_1B54C
		rts
; End of function HUD_Secs


; =============== S U B R O U T I N E ==========================================


HUD_TimeRingBonus:
		lea	HUD_1000(pc),a2
		moveq	#3,d6
		moveq	#0,d4
		lea	Art_HUD(pc),a1

loc_1B5A4:
		moveq	#0,d2
		move.l	(a2)+,d3

loc_1B5A8:
		sub.l	d3,d1
		bcs.s	loc_1B5B0
		addq.w	#1,d2
		bra.s	loc_1B5A8
; ===============================================================================

loc_1B5B0:
		add.l	d3,d1
		tst.w	d2
		beq.s	loc_1B5BA
		move.w	#1,d4

loc_1B5BA:
		tst.w	d4
		beq.s	loc_1B5EA
		lsl.w	#6,d2
		lea	(a1,d2.w),a3
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
loc_1B5E4:
		dbf	d6,loc_1B5A4
		rts
; ===============================================================================

loc_1B5EA:
		moveq	#$F,d5

loc_1B5EC:
		move.l	#0,(a6)
		dbf	d5,loc_1B5EC
		bra.s	loc_1B5E4

; =============== S U B R O U T I N E ==========================================


HUD_Lives:
		move.l	#$7BA00003,d0
		moveq	#0,d1
		move.b	(RAM_Sonic_Lives).w,d1
		lea	HUD_10(pc),a2
		moveq	#1,d6
		moveq	#0,d4
		lea	Art_LivesNums(pc),a1

loc_1B610:
		move.l	d0,4(a6)
		moveq	#0,d2
		move.l	(a2)+,d3

loc_1B618:
		sub.l	d3,d1
		bcs.s	loc_1B620
		addq.w	#1,d2
		bra.s	loc_1B618
; ===============================================================================

loc_1B620:
		add.l	d3,d1
		tst.w	d2
		beq.s	loc_1B62A
		move.w	#1,d4

loc_1B62A:
		tst.w	d4
		beq.s	loc_1B650

loc_1B62E:
		lsl.w	#5,d2
		lea	(a1,d2.w),a3
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)

loc_1B644:
		addi.l	#$400000,d0
		dbf	d6,loc_1B610
		rts
; ===============================================================================

loc_1B650:
		tst.w	d6
		beq.s	loc_1B62E
		moveq	#7,d5

loc_1B656:
		move.l	#0,(a6)
		dbf	d5,loc_1B656
		bra.s	loc_1B644

; ===============================================================================
Art_HUD:	dc.b   0,  0,  0,  0,  0,$66,$66,$10,  6,$66,$66,$61,  6,$61,$16,$61,  6,$61,  6,$61,$76,$61,$76,$61,$66,$10,$66,$10,$66,$10,$66,$10; 0
		dc.b $66,$10,$66,$10,$66,$66,$66,$10,  6,$66,$61,  0,  1,$11,$10,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 32
		dc.b   0,  0,  0,  0,  0,  6,$61,  0,  0,$66,$61,  0,  0,  6,$61,  0,  0,  6,$61,  0,  0,$76,$61,  0,  0,$66,$10,  0,  0,$66,$10,  0; 64
		dc.b   0,$66,$10,  0,  0,$66,$10,  0,  0,$66,$10,  0,  0,$11,$10,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 96
		dc.b   0,  0,  0,  0,  0,$66,$66,$10,  6,$66,$66,$61,  6,$61,$16,$61,  1,$11,$66,$61,  0,  6,$66,$10,  7,$66,$10,  0,$76,$61,  0,  0; 128
		dc.b $66,$61,  0,  0,$66,$66,$66,$10,$66,$66,$66,$10,$11,$11,$11,$10,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 160
		dc.b   0,  0,  0,  0,  0,$66,$66,$10,  6,$66,$66,$61,  6,$61,$16,$61,  1,$11,  6,$61,  0,  6,$66,$10,  0,$66,$61,  0,  0,$11,$66,$10; 192
		dc.b $66,$10,$66,$10,$66,$66,$66,$10,  6,$66,$61,  0,  1,$11,$10,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 224
		dc.b   0,  0,  0,  0,  0,  0,$66,$10,  0,  6,$66,$10,  0,$76,$66,$10,  0,$66,$66,$10,  6,$61,$66,$10,$76,$16,$61,  0,$66,$66,$66,$10; 256
		dc.b $66,$66,$66,$10,$11,$16,$61,$10,  0,  6,$61,  0,  0,  1,$11,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 288
		dc.b   0,  0,  0,  0,  6,$66,$66,$61,  6,$66,$66,$61,  6,$61,$11,$11,  6,$61,  0,  0,$76,$66,$67,$10,$66,$66,$66,$10,$11,$11,$66,$10; 320
		dc.b $66,$10,$66,$10,$66,$66,$66,$10,$16,$66,$61,  0,  1,$11,$10,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 352
		dc.b   0,  0,  0,  0,  0,$66,$66,$10,  6,$66,$66,$61,  6,$61,$16,$61,  6,$61,  1,$11,$76,$66,$78,$10,$66,$66,$67,$10,$66,$11,$66,$10; 384
		dc.b $66,$10,$66,$10,$66,$66,$66,$10,  6,$66,$61,  0,  1,$11,$10,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 416
		dc.b   0,  0,  0,  0,  6,$66,$66,$61,  6,$66,$66,$61,  1,$11,$16,$61,  0,  0,$76,$10,  0,  7,$66,$10,  0,  6,$61,  0,  0,$66,$10,  0; 448
		dc.b   0,$66,$10,  0,  6,$67,$10,  0,  6,$67,$10,  0,  0,$11,$10,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 480
		dc.b   0,  0,  0,  0,  0,$66,$66,$10,  6,$66,$66,$61,  6,$61,$16,$61,  6,$61,  6,$61,  0,$66,$66,$10,  6,$66,$61,  0,$66,$11,$66,$10; 512
		dc.b $66,$10,$66,$10,$66,$66,$66,$10,  6,$66,$61,  0,  1,$11,$10,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 544
		dc.b   0,  0,  0,  0,  0,$66,$66,$10,  6,$66,$66,$61,  6,$61,$16,$61,  6,$61,  6,$61,  6,$66,$66,$61,  8,$66,$66,$71,  1,$11,$66,$10; 576
		dc.b $66,$10,$66,$10,$66,$66,$66,$10,  6,$66,$61,  0,  1,$11,$10,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 608
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  6,$61,  0,  0,  6,$61,  0,  0,  1,$11,  0,  0,  0,  0,  0,  0,  6,$61,  0; 640
		dc.b   0,  6,$61,  0,  0,  1,$11,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 672
		dc.b   0,  0,  0,  0, $C,$CC,$CC,$C1, $C,$CC,$CC,$C1, $C,$C1,$11,$11, $C,$C1,  0,  0, $C,$CC,$CC,$10,$CC,$CC,$C1,  0,$CC,$11,$11,  0; 704
		dc.b $CC,$10,  0,  0,$CC,$CC,$CC,$10,$CC,$CC,$CC,$10,$11,$11,$11,$10,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 736

Art_LivesNums:	dc.b   0,  0,  0,  0,  0,$66,$66,$10,  6,$61,$16,$61,  6,$61,  6,$61,  6,$61,  6,$61,  6,$61,  6,$61,  0,$66,$66,$10,  0,$11,$11,  0; 0
		dc.b   0,  0,  0,  0,  0,  6,$61,  0,  0,$66,$61,  0,  0,$16,$61,  0,  0,  6,$61,  0,  0,  6,$61,  0,  0,  6,$61,  0,  0,  1,$11,  0; 32
		dc.b   0,  0,  0,  0,  0,$66,$66,$10,  0,$11,$16,$61,  0,  0,$66,$11,  0,  6,$61,$10,  0,$66,$11,$10,  6,$66,$66,$61,  1,$11,$11,$11; 64
		dc.b   0,  0,  0,  0,  0,$66,$66,$10,  0,$11,$16,$61,  0,  6,$66,$10,  0,  1,$16,$61,  6,$61,  6,$61,  0,$66,$66,$10,  0,$11,$11,  0; 96
		dc.b   0,  0,  0,  0,  0,  0,$66,$10,  0,  6,$66,$10,  0,$61,$66,$10,  6,$61,$66,$10,  6,$66,$66,$61,  1,$11,$66,$11,  0,  0,$11,$10; 128
		dc.b   0,  0,  0,  0,  6,$66,$66,$61,  6,$61,$11,$11,  6,$66,$66,$10,  1,$11,$16,$61,  6,$61,  6,$61,  0,$66,$66,$10,  0,$11,$11,  0; 160
		dc.b   0,  0,  0,  0,  0,$66,$66,$10,  6,$61,$11,$10,  6,$66,$66,$10,  6,$61,$16,$61,  6,$61,  6,$61,  0,$66,$66,$10,  0,$11,$11,  0; 192
		dc.b   0,  0,  0,  0,  6,$66,$66,$61,  1,$11,$16,$61,  0,  0,$66,$10,  0,  6,$61,  0,  0,$66,$10,  0,  0,$66,$10,  0,  0,$11,$10,  0; 224
		dc.b   0,  0,  0,  0,  0,$66,$66,$10,  6,$61,$16,$61,  0,$66,$66,$10,  6,$61,$16,$61,  6,$61,  6,$61,  0,$66,$66,$10,  0,$11,$11,  0; 256
		dc.b   0,  0,  0,  0,  0,$66,$66,$10,  6,$61,$16,$61,  6,$61,  6,$61,  0,$66,$66,$61,  0,$11,$16,$61,  0,$66,$66,$10,  0,$11,$11,  0; 288
; ===============================================================================
		nop

j_ModifySpriteAttr_2P_8:
		jmp	ModifySpriteAttr_2P
; ===============================================================================
		align 4

DebugMode:
		moveq	#0,d0
		move.b	(RAM_Flag_Debug_Placement).w,d0
		move.w	DebugIndex(pc,d0.w),d1
		jmp	DebugIndex(pc,d1.w)
; ===============================================================================
DebugIndex:	dc.w Debug_Init-DebugIndex
		dc.w Debug_Move-DebugIndex
; ===============================================================================

Debug_Init:
		addq.b	#2,(RAM_Flag_Debug_Placement).w
		move.w	(RAM_LevelSys_YPos_SetStart).w,(RAM_DebugMode_YPosSetStart).w
		move.w	(RAM_Level_Camera_Boundary_1).w,(RAM_DebugMode_CamaraBoundary1).w
		move.w	#0,(RAM_LevelSys_YPos_SetStart).w
		move.w	#$720,(RAM_Level_Camera_Boundary_1).w
		andi.w	#$7FF,(RAM_ObjRam_Sonic+$C).w
		andi.w	#$7FF,(RAM_LevelSys_Buff+$4).w
		andi.w	#$3FF,(RAM_LevelSys_Buff+$C).w
		move.b	#0,$1A(a0)
		move.b	#0,$1C(a0)
		cmpi.b	#ModeId_SS,(RAM_GameMode).w
		bne.s	loc_1BB04
		moveq	#6,d0
		bra.s	loc_1BB0A
; ===============================================================================

loc_1BB04:
		moveq	#0,d0
		move.b	(RAM_Level_CurrentZone).w,d0

loc_1BB0A:
		lea	(DebugList).l,a2
		add.w	d0,d0
		adda.w	(a2,d0.w),a2
		move.w	(a2)+,d6
		cmp.b	(RAM_DebugMode_SelObj).w,d6
		bhi.s	loc_1BB24
		move.b	#0,(RAM_DebugMode_SelObj).w

loc_1BB24:
		bsr.w	Debug_ShowItem
		move.b	#$C,(RAM_DebugMode_WaitToMove).w
		move.b	#1,(RAM_DebugMode_MoveSpeed).w

Debug_Move:
		moveq	#6,d0
		cmpi.b	#ModeId_SS,(RAM_GameMode).w
		beq.s	loc_1BB44
		moveq	#0,d0
		move.b	(RAM_Level_CurrentZone).w,d0

loc_1BB44:
		lea	(DebugList).l,a2
		add.w	d0,d0
		adda.w	(a2,d0.w),a2
		move.w	(a2)+,d6
		bsr.w	Debug_Control
		jmp	DisplaySprite

; =============== S U B R O U T I N E ==========================================


Debug_Control:
		moveq	#0,d4
		move.w	#1,d1
		move.b	(RAM_Control_1_Press).w,d4
		andi.w	#$F,d4
		bne.s	loc_1BB9E
		move.b	(RAM_Control_1_Hold).w,d0
		andi.w	#$F,d0
		bne.s	loc_1BB86
		move.b	#$C,(RAM_DebugMode_WaitToMove).w
		move.b	#$F,(RAM_DebugMode_MoveSpeed).w
		bra.w	loc_1BBF4
; ===============================================================================

loc_1BB86:
		subq.b	#1,(RAM_DebugMode_WaitToMove).w
		bne.s	loc_1BBA2
		move.b	#1,(RAM_DebugMode_WaitToMove).w
		addq.b	#1,(RAM_DebugMode_MoveSpeed).w
		bne.s	loc_1BB9E
		move.b	#$FF,(RAM_DebugMode_MoveSpeed).w

loc_1BB9E:
		move.b	(RAM_Control_1_Hold).w,d4

loc_1BBA2:
		moveq	#0,d1
		move.b	(RAM_DebugMode_MoveSpeed).w,d1
		addq.w	#1,d1
		swap	d1
		asr.l	#4,d1
		move.l	$C(a0),d2
		move.l	8(a0),d3
		btst	#0,d4
		beq.s	loc_1BBC2
		sub.l	d1,d2
		bcc.s	loc_1BBC2
		moveq	#0,d2

loc_1BBC2:
		btst	#1,d4
		beq.s	loc_1BBD8
		add.l	d1,d2
		cmpi.l	#$7FF0000,d2
		bcs.s	loc_1BBD8
		move.l	#$7FF0000,d2

loc_1BBD8:
		btst	#2,d4
		beq.s	loc_1BBE4
		sub.l	d1,d3
		bcc.s	loc_1BBE4
		moveq	#0,d3

loc_1BBE4:
		btst	#3,d4
		beq.s	loc_1BBEC
		add.l	d1,d3

loc_1BBEC:
		move.l	d2,$C(a0)
		move.l	d3,8(a0)

loc_1BBF4:
		btst	#6,(RAM_Control_1_Hold).w
		beq.s	loc_1BC2C
		btst	#5,(RAM_Control_1_Press).w
		beq.s	loc_1BC10
		subq.b	#1,(RAM_DebugMode_SelObj).w
		bcc.s	loc_1BC28
		add.b	d6,(RAM_DebugMode_SelObj).w
		bra.s	loc_1BC28
; ===============================================================================

loc_1BC10:
		btst	#6,(RAM_Control_1_Press).w
		beq.s	loc_1BC2C
		addq.b	#1,(RAM_DebugMode_SelObj).w
		cmp.b	(RAM_DebugMode_SelObj).w,d6
		bhi.s	loc_1BC28
		move.b	#0,(RAM_DebugMode_SelObj).w

loc_1BC28:
		bra.w	Debug_ShowItem
; ===============================================================================

loc_1BC2C:
		btst	#5,(RAM_Control_1_Press).w
		beq.s	loc_1BC70
		jsr	SingleObjectLoad
		bne.s	loc_1BC70
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		move.b	4(a0),0(a1)
		move.b	1(a0),1(a1)
		move.b	1(a0),$22(a1)
		andi.b	#$7F,$22(a1)
		moveq	#0,d0
		move.b	(RAM_DebugMode_SelObj).w,d0
		lsl.w	#3,d0
		move.b	4(a2,d0.w),$28(a1)
		rts
; ===============================================================================

loc_1BC70:
		btst	#4,(RAM_Control_1_Press).w
		beq.s	locret_1BCCA
		moveq	#0,d0
		move.w	d0,(RAM_Flag_Debug_Placement).w
		move.l	#Map_Sonic,(RAM_ObjRam_Sonic+$4).w
		move.w	#$780,(RAM_ObjRam_Sonic+$2).w
		tst.w	(RAM_Flag_SplitScreen).w
		beq.s	loc_1BC98
		move.w	#$3C0,(RAM_ObjRam_Sonic+$2).w

loc_1BC98:
		move.b	d0,(RAM_ObjRam_Sonic+$1C).w
		move.w	d0,$A(a0)
		move.w	d0,$E(a0)
		move.w	(RAM_DebugMode_YPosSetStart).w,(RAM_LevelSys_YPos_SetStart).w
		move.w	(RAM_DebugMode_CamaraBoundary1).w,(RAM_Level_Camera_Boundary_1).w
		cmpi.b	#ModeId_SS,(RAM_GameMode).w
		bne.s	locret_1BCCA
		move.b	#2,(RAM_ObjRam_Sonic+$1C).w
		bset	#2,(RAM_ObjRam_Sonic+$22).w
		bset	#1,(RAM_ObjRam_Sonic+$22).w

locret_1BCCA:
		rts

; =============== S U B R O U T I N E ==========================================


Debug_ShowItem:
		moveq	#0,d0
		move.b	(RAM_DebugMode_SelObj).w,d0
		lsl.w	#3,d0
		move.l	(a2,d0.w),4(a0)
		move.w	6(a2,d0.w),2(a0)
		move.b	5(a2,d0.w),$1A(a0)
		bsr.w	j_ModifySpriteAttr_2P_1
		rts

; ===============================================================================
DebugList:	dc.w Debug_GHZ-DebugList
		dc.w Debug_CPZ-DebugList
		dc.w Debug_CPZ-DebugList
		dc.w Debug_EHZ-DebugList
		dc.w Debug_HPZ-DebugList
		dc.w Debug_HTZ-DebugList
		dc.w Debug_HPZ-DebugList

Debug_GHZ:	dc.w $E
		dc.l Map_Obj25+$25000000
		dc.b   0,  0,$26,$BC	; subtype, frame, VRAM setting (2 bytes)
		dc.l Map_Obj26+$26000000
		dc.b   0,  0,  6,$80	; 0
		dc.l Map_Obj1F+$1F000000
		dc.b   0,  0,  4,  0	; 0
		dc.l Map_Obj22+$22000000
		dc.b   0,  0,  4,$44	; 0
		dc.l Map_Obj2B+$2B000000
		dc.b   0,  0,  4,$70	; 0
		dc.l Map_Obj36+$36000000
		dc.b   0,  0,  4,$A0	; 0
		dc.l Map_Obj18+$18000000
		dc.b   0,  0,$40,  0	; 0
		dc.l Map_Obj3B+$3B000000
		dc.b   0,  0,$66,$C0	; 0
		dc.l Map_Obj40+$40000000
		dc.b   0,  0,  4,$E0	; 0
		dc.l Map_Obj41_GHZ+$41000000
		dc.b   0,  0,  4,$A8	; 0
		dc.l Map_Obj32+$42000000
		dc.b   0,  0,$24,$9B	; 0
		dc.l Map_Obj44+$44000000
		dc.b   0,  0,$43,$4C	; 0
		dc.l Map_Obj79+$79000000
		dc.b   1,  0,$26,$BC	; 0
		dc.l Map_Obj03+$03000000
		dc.b   0,  0,$26,$BC	; 0

Debug_CPZ:	dc.w $10
		dc.l Map_Obj25+$25000000
		dc.b   0,  0,$26,$BC	; 0
		dc.l Map_Obj26+$26000000
		dc.b   0,  0,  6,$80	; 0
		dc.l Map_Obj41_GHZ+$41000000
		dc.b   0,  0,  4,$A8	; 0
		dc.l Map_Obj03+$03000000
		dc.b   0,  0,  7,$BC	; 0
		dc.l Map_Obj0B+$0B000000
		dc.b   0,  0,$E0,  0	; 0
		dc.l Map_Obj0C+$0C000000
		dc.b   0,  0,$E4,$18	; 0
		dc.l Map_Obj15_CPZ+$15000000
		dc.b   8,  0,$24,$18	; 0
		dc.l Map_Obj03+$03000000
		dc.b   9,  1,$26,$BC	; 0
		dc.l Map_Obj03+$03000000
		dc.b  $D,  5,$26,$BC	; 0
		dc.l Map_Obj19+$19000000
		dc.b   1,  0,$64,  0	; 0
		dc.l Map_Obj36+$36000000
		dc.b   0,  0,$24,$34	; 0
		dc.l Map_Obj41+$41000000
		dc.b $81,  0,  4,$5C	; 0
		dc.l Map_Obj41+$41000000
		dc.b $90,  3,  4,$70	; 0
		dc.l Map_Obj41+$41000000
		dc.b $A0,  6,  4,$5C	; 0
		dc.l Map_Obj41+$41000000
		dc.b $30,  7,  4,$3C	; 0
		dc.l Map_Obj41+$41000000
		dc.b $40, $A,  4,$3C	; 0

Debug_EHZ:	dc.w $13
		dc.l Map_Obj25+$25000000
		dc.b   0,  0,$26,$BC	; 0
		dc.l Map_Obj26+$26000000
		dc.b   0,  0,  6,$80	; 0
		dc.l Map_Obj79+$79000000
		dc.b   1,  0,  4,$7C	; 0
		dc.l Map_Obj03+$03000000
		dc.b   0,  0,$26,$BC	; 0
		dc.l Map_Obj49+$49000000
		dc.b   0,  0,$23,$AE	; 0
		dc.l Map_Obj49+$49000000
		dc.b   2,  3,$23,$AE	; 0
		dc.l Map_Obj49+$49000000
		dc.b   4,  5,$23,$AE	; 0
		dc.l Map_Obj18_EHZ+$18000000
		dc.b   1,  0,$40,  0	; 0
		dc.l Map_Obj18_EHZ+$18000000
		dc.b  $A,  1,$40,  0	; 0
		dc.l Map_Obj36+$36000000
		dc.b   0,  0,$24,$34	; 0
		dc.l Map_Obj14+$14000000
		dc.b   0,  0,  3,$CE	; 0
		dc.l Map_Obj41+$41000000
		dc.b $81,  0,  4,$5C	; 0
		dc.l Map_Obj41+$41000000
		dc.b $90,  3,  4,$70	; 0
		dc.l Map_Obj41+$41000000
		dc.b $A0,  6,  4,$5C	; 0
		dc.l Map_Obj41+$41000000
		dc.b $30,  7,  4,$3C	; 0
		dc.l Map_Obj41+$41000000
		dc.b $40, $A,  4,$3C	; 0
		dc.l Map_Obj4B+$4B000000
		dc.b   0,  0,  3,$E6	; 0
		dc.l Map_Obj54+$54000000
		dc.b   0,  0,  4,  2	; 0
		dc.l Map_Obj53+$53000000
		dc.b   0,  0,  4,$1C	; 0
		dc.l Map_Obj4F+$4F000000
		dc.b   0,  0,  5,  0	; 0
		dc.l Map_Obj52+$52000000
		dc.b   0,  0,$25,$30	; 0
		dc.l Map_Obj50+$50000000
		dc.b   0,  0,$25,$70	; 0
		dc.l Map_Obj50+$51000000
		dc.b   0,  0,$25,$70	; 0
		dc.l Map_Obj4D+$4D000000
		dc.b   0,  0,$23,$C4	; 0
		dc.l Map_Obj4B+$4B000000
		dc.b   0,  0,  3,$2C	; 0
		dc.l Map_Obj4E+$4E000000
		dc.b   0,  0,$23,  0	; 0
		dc.l Map_Obj4C+$4C000000
		dc.b   0,  0,$23,$50	; 0
		dc.l Map_Obj4A+$4A000000
		dc.b   0,  0,$23,$8A	; 0

Debug_HTZ:	dc.w $13
		dc.l Map_Obj25+$25000000
		dc.b   0,  0,$26,$BC	; 0
		dc.l Map_Obj26+$26000000
		dc.b   0,  0,  6,$80	; 0
		dc.l Map_Obj79+$79000000
		dc.b   1,  0,  4,$7C	; 0
		dc.l Map_Obj03+$03000000
		dc.b   0,  0,$26,$BC	; 0
		dc.l Map_Obj18_EHZ+$18000000
		dc.b   1,  0,$40,  0	; 0
		dc.l Map_Obj18_EHZ+$18000000
		dc.b  $A,  1,$40,  0	; 0
		dc.l Map_Obj36+$36000000
		dc.b   0,  0,$24,$34	; 0
		dc.l Map_Obj14+$14000000
		dc.b   0,  0,  3,$CE	; 0
		dc.l Map_Obj41+$41000000
		dc.b $81,  0,  4,$5C	; 0
		dc.l Map_Obj41+$41000000
		dc.b $90,  3,  4,$70	; 0
		dc.l Map_Obj41+$41000000
		dc.b $A0,  6,  4,$5C	; 0
		dc.l Map_Obj41+$41000000
		dc.b $30,  7,  4,$3C	; 0
		dc.l Map_Obj41+$41000000
		dc.b $40, $A,  4,$3C	; 0
		dc.l Map_Obj16+$16000000
		dc.b   0,  0,$43,$E6	; 0
		dc.l Map_Obj16+$1C000000
		dc.b   4,  1,$43,$E6	; 0
		dc.l Map_Obj16+$1C000000
		dc.b   5,  2,$43,$E6	; 0
		dc.l Map_Obj4B+$4B000000
		dc.b   0,  0,  3,$E6	; 0
		dc.l Map_Obj54+$54000000
		dc.b   0,  0,  4,  2	; 0
		dc.l Map_Obj53+$53000000
		dc.b   0,  0,  4,$1C	; 0

Debug_HPZ:	dc.w $F
		dc.l Map_Obj25+$25000000
		dc.b   0,  0,$26,$BC	; 0
		dc.l Map_Obj26+$26000000
		dc.b   0,  0,  6,$80	; 0
		dc.l Map_Obj1C_01+$1C000000
		dc.b $21,  3,$E4,$85	; 0
		dc.l Map_Obj13+$13000000
		dc.b   4,  4,$E4,$15	; 0
		dc.l Map_Obj1A_HPZ+$1A000000
		dc.b   0,  0,$44,$75	; 0
		dc.l Map_Obj03+$03000000
		dc.b   0,  0,$26,$BC	; 0
		dc.l Map_Obj4F+$4F000000
		dc.b   0,  0,  5,  0	; 0
		dc.l Map_Obj52+$52000000
		dc.b   0,  0,$25,$30	; 0
		dc.l Map_Obj50+$50000000
		dc.b   0,  0,$25,$70	; 0
		dc.l Map_Obj50+$51000000
		dc.b   0,  0,$25,$70	; 0
		dc.l Map_Obj4D+$4D000000
		dc.b   0,  0,$23,$C4	; 0
		dc.l Map_Obj4B+$4B000000
		dc.b   0,  0,  3,$2C	; 0
		dc.l Map_Obj4E+$4E000000
		dc.b   0,  0,$23,  0	; 0
		dc.l Map_Obj4C+$4C000000
		dc.b   0,  0,$23,$50	; 0
		dc.l Map_Obj4A+$4A000000
		dc.b   0,  0,$23,$8A	; 0
; ===============================================================================

j_ModifySpriteAttr_2P_1:
		jmp	ModifySpriteAttr_2P
; ===============================================================================
		align 4

MainLoadBlocks:	dc.l Nem_GHZ+$4000000
		dc.l Map16_GHZ+$5000000
		dc.l UnkComp_Map128_GHZ
		dc.b   0,$81,  4,  4	; 0
		dc.l Nem_CPZ+$6000000
		dc.l Map16_CPZ+$7000000
		dc.l Map128_CPZ
		dc.b   0,$82,  5,  5	; 0
		dc.l Nem_CPZ+$8000000
		dc.l Map16_CPZ+$9000000
		dc.l Map128_CPZ
		dc.b   0,$83,  6,  6	; 0
		dc.l Nem_EHZ+$A000000
		dc.l Map16_EHZ+$B000000
		dc.l Map128_EHZ
		dc.b   0,$84,  7,  7	; 0
		dc.l Nem_HPZ+$C000000
		dc.l Map16_HPZ+$D000000
		dc.l Map128_HPZ
		dc.b   0,$85,  8,  8	; 0
		dc.l Nem_EHZ+$E000000
		dc.l Map16_EHZ+$F000000
		dc.l Map128_EHZ
		dc.b   0,$86,  9,  9	; 0
		dc.l Nem_GHZ
		dc.l Map16_GHZ
		dc.l UnkComp_Map128_GHZ
		dc.b   0,$86,$13,$13	; 0

ArtLoadCues:	dc.w PLC_Main-ArtLoadCues
		dc.w PLC_Main2-ArtLoadCues
		dc.w PLC_Explode-ArtLoadCues
                dc.w PLC_GameOver-ArtLoadCues
		dc.w PLC_GHZ-ArtLoadCues
                dc.w PLC_GHZ2-ArtLoadCues
		dc.w PLC_CPZ-ArtLoadCues
                dc.w PLC_CPZ2-ArtLoadCues
		dc.w PLC_CPZ-ArtLoadCues
                dc.w PLC_CPZ2-ArtLoadCues
		dc.w PLC_EHZ-ArtLoadCues
                dc.w PLC_EHZ2-ArtLoadCues
		dc.w PLC_HPZ-ArtLoadCues
                dc.w PLC_HPZ2-ArtLoadCues
		dc.w PLC_HTZ-ArtLoadCues
                dc.w PLC_HTZ2-ArtLoadCues
		dc.w PLC_S1TitleCard-ArtLoadCues
                dc.w PLC_Boss-ArtLoadCues
		dc.w PLC_Signpost-ArtLoadCues
                dc.w PLC_Invalid-ArtLoadCues
		dc.w PLC_Invalid-ArtLoadCues
                dc.w PLC_GHZAnimals-ArtLoadCues
		dc.w PLC_LZAnimals-ArtLoadCues
                dc.w PLC_CPZAnimals-ArtLoadCues
		dc.w PLC_EHZAnimals-ArtLoadCues
                dc.w PLC_HPZAnimals-ArtLoadCues
		dc.w PLC_HTZAnimals-ArtLoadCues
                dc.w LeftoverArt_Unknown-ArtLoadCues
		dc.w LeftoverArt_Unknown_2-ArtLoadCues
                dc.w LeftoverArt_Unknown_3-ArtLoadCues
		dc.w LeftoverArt_Unknown_4-ArtLoadCues
                dc.w LeftoverArt_Unknown_5-ArtLoadCues

PLC_Main:	dc.w 4
		dc.l Nem_Lamppost
		dc.w $8F80
		dc.l Nem_HUD
		dc.w $D940
		dc.l Nem_Lives
		dc.w $FA80
		dc.l Nem_Ring
		dc.w $D780
		dc.l Nem_Points
		dc.w $9580

PLC_Main2:	dc.w 2
		dc.l Nem_Monitors
		dc.w $D000
		dc.l Nem_Shield
		dc.w $97C0
		dc.l Nem_Stars
		dc.w $9BC0

PLC_Explode:	dc.w 0
		dc.l Nem_Explosion
		dc.w $B400

PLC_GameOver:	dc.w 0
		dc.l Nem_GameOver
		dc.w $ABC0

PLC_GHZ:	dc.w 8
		dc.l Nem_GHZ
		dc.w 0
		dc.l Nem_GHZ_Piranha
		dc.w $8E00
		dc.l Nem_VSpikes
		dc.w $9400
		dc.l Nem_VSpring
		dc.w $9500
		dc.l Nem_HSpring
		dc.w $9700
		dc.l Nem_GHZ_Bridge
		dc.w $98C0
		dc.l Nem_SwingPlatform
		dc.w $9A00
		dc.l Nem_Motobug
		dc.w $9C00
		dc.l Nem_GHZ_Rock
		dc.w $D800

PLC_GHZ2:	dc.w 0
		dc.l Nem_GHZ_Piranha
		dc.w $8E00

PLC_CPZ:	dc.w 2
		dc.l Nem_CPZ
		dc.w 0
		dc.l Nem_CPZ_Unknown
		dc.w $7A00
		dc.l Nem_CPZ_FloatingPlatform
		dc.w $8000

PLC_CPZ2:	dc.w 3
		dc.l Nem_VSpikes
		dc.w $8680
		dc.l Nem_DSpikes
		dc.w $8780
		dc.l Nem_VSpring2
		dc.w $8B80
		dc.l Nem_HSpring2
		dc.w $8E00

PLC_EHZ:	dc.w 8
		dc.l Nem_EHZ
		dc.w 0
		dc.l Nem_EHZ_Fireball
		dc.w $73C0
		dc.l Nem_EHZ_Waterfall
		dc.w $75C0
		dc.l Nem_EHZ_Bridge
		dc.w $78C0
		dc.l Nem_HTZ_Seesaw
		dc.w $79C0
		dc.l Nem_VSpikes
		dc.w $8680
		dc.l Nem_DSpikes
		dc.w $8780
		dc.l Nem_VSpring2
		dc.w $8B80
		dc.l Nem_HSpring2
		dc.w $8E00

PLC_EHZ2:	dc.w 4
		dc.l Nem_Shield
		dc.w $AC00
		dc.l Nem_Points
		dc.w $9580
		dc.l Nem_Buzzbomber
		dc.w $7CC0
		dc.l Nem_Snail
		dc.w $8040
		dc.l Nem_EHZ_Piranha
		dc.w $8380

PLC_HPZ:	dc.w 7
		dc.l Nem_HPZ
		dc.w 0
		dc.l Nem_HPZ_Bridge
		dc.w $6000
		dc.l Nem_HPZ_Waterfall
		dc.w $62A0
		dc.l Nem_HPZ_Platform
		dc.w $6940
		dc.l Nem_HPZ_PulsingBall
		dc.w $6B40
		dc.l Nem_HPZ_Various
		dc.w $6F80
		dc.l Nem_HPZ_Emerald
		dc.w $7240
		dc.l Nem_HPZ_WaterSurface
		dc.w $8000

PLC_HPZ2:	dc.w 1
		dc.l Nem_Dinobot
		dc.w $A000
		dc.l Nem_Bat
word_1C1E4:	dc.w $A600
		dc.l Nem_Crocobot
		dc.w $6000
		dc.l Nem_Buzzbomber
		dc.w $6580
		dc.l Nem_Bat
		dc.w $6A00
		dc.l Nem_Triceratops
		dc.w $7880
		dc.l Nem_Dinobot
		dc.w $A000
		dc.l Nem_HPZ_Piranha
		dc.w $A600

PLC_HTZ:	dc.w 9
		dc.l Nem_EHZ
		dc.w 0
		dc.l Nem_HTZ
		dc.w $3F80
		dc.l Nem_HTZ_AniPlaceholders
		dc.w $A000
		dc.l Nem_EHZ_Fireball
		dc.w $73C0
		dc.l Nem_HTZ_Fireball
		dc.w $75C0
		dc.l Nem_HTZ_AutomaticDoor
		dc.w $77C0
		dc.l Nem_EHZ_Bridge
		dc.w $78C0
		dc.l Nem_HTZ_Seesaw
		dc.w $79C0
		dc.l Nem_VSpikes
		dc.w $8680
		dc.l Nem_DSpikes
		dc.w $8780
		dc.l Nem_VSpring2
		dc.w $8B80
		dc.l Nem_HSpring2
		dc.w $8E00

PLC_HTZ2:	dc.w 0
		dc.l Nem_HTZ_Lift
		dc.w $7CC0
		dc.l Nem_Buzzbomber
		dc.w $7CC0
		dc.l Nem_Snail
		dc.w $8040
		dc.l Nem_EHZ_Piranha
		dc.w $8380

PLC_S1TitleCard:dc.w 0
		dc.l Nem_S1TitleCard
		dc.w $B000

PLC_Boss:	dc.w 2
		dc.l Nem_BossShip
		dc.w $8C00
		dc.l Nem_EHZ_Boss
		dc.w $9800
		dc.l Nem_EHZ_Boss_Blades
		dc.w $A800
		dc.l Nem_BossShip
		dc.w $8000
		dc.l Nem_CPZ_ProtoBoss
		dc.w $8C00
		dc.l Nem_BossShipBoost
		dc.w $9A00
		dc.l Nem_Smoke
		dc.w $9B00
		dc.l Nem_EHZ_Boss
		dc.w $9D00
		dc.l Nem_EHZ_Boss_Blades
		dc.w $AD00

PLC_Signpost:	dc.w 2
		dc.l Nem_Signpost
		dc.w $D000
		dc.l Nem_S1BonusPoints
		dc.w $96C0
		dc.l Nem_BigFlash
		dc.w $8C40

PLC_Invalid:	dc.w $10
PLC_GHZAnimals:	dc.w 1
		dc.l Nem_Bunny
		dc.w $B000
		dc.l Nem_Flicky
		dc.w $B240

PLC_LZAnimals:	dc.w 1
		dc.l Nem_Penguin
		dc.w $B000
		dc.l Nem_Seal
		dc.w $B240

PLC_CPZAnimals:	dc.w 1
		dc.l Nem_Squirrel
		dc.w $B000
		dc.l Nem_Seal
		dc.w $B240

PLC_EHZAnimals:	dc.w 1
		dc.l Nem_Pig
		dc.w $B000
		dc.l Nem_Flicky
		dc.w $B240

PLC_HPZAnimals:	dc.w 1
		dc.l Nem_Pig
		dc.w $B000
		dc.l Nem_Chicken
		dc.w $B240

PLC_HTZAnimals:	dc.w 1
		dc.l Nem_Bunny
		dc.w $B000
		dc.l Nem_Chicken
		dc.w $B240
;----------------------------------------------------
; Unknown leftover art from an unknown prototype game
;  leftover due	to usage of a large FF padding
;----------------------------------------------------
LeftoverArt_Unknown:
		dc.b	0,  1
LeftoverArt_Unknown_2
                dc.b	0, $D
LeftoverArt_Unknown_3:
                dc.b	0,  2
LeftoverArt_Unknown_4:
                dc.b	0,  2
LeftoverArt_Unknown_5:
                dc.b	0,  4
                dc.b   0,  0,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4
		dc.b   4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2
		dc.b   4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  4,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  4,  2,  4,  4,  4,  2,  2,  2,  2
		dc.b   2,  4,  2,  2,  4,  2,  2,  4,  2,  2,  4,  2,  2,  2,  4,  4,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  4,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  4,  2,  4,  2,  4
		dc.b   2,  2,  4,  2,  4,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2, $A,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  2
		dc.b   2,  4,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   4,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  4,  2,  2,  2,  2,  4,  2,  4,  4,  4,  2,  2,  2
		dc.b   2,  4,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2, $A,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  4,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2
		dc.b   2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  4,  4,  4,  2,  2,  2,  2
		dc.b   2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  4,  2,  2,  2,  4,  2,  2,  2
		dc.b   2,  2,  2,  4,  4,  2,  4,  2,  2, $A,  4,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  4,  2,  2,  2,  2,  2, $A,  2
		dc.b   2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2, $A,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2
		dc.b   2,  4,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  4,  2,  4,  4,  2,  4,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  4,  2,  2,  2,  4,  2,  4,  2,  2
		dc.b   4,  4,  2,  4,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4, $A,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2
		dc.b   2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  4,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  4,  2,  4,  2,  4,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  6,  2,  2,  2,  2,  2,  2,  2,  2,  4
		dc.b   2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2
		dc.b   4, $A,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  4
		dc.b   2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  4,  2,  2,  4,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2
		dc.b   2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  4
		dc.b   4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2
		dc.b   2,  2,  4,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  4,  4,  4,  4,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  4,  2,  2,  4,  4,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  4,  2,  2
		dc.b   4,  2,  2,  2,  2,  2,  2,  4,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  4,  4,  2,  2,  2,  4,  2,  2,  2,  4,  2,  4
		dc.b   2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2
		dc.b   2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2
		dc.b   4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2, $A,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4
		dc.b   2,  2,  2,  2,  4,  4,  4,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  4,  4,  2,  2,  4,  4,  4,  4,  2,  4,  2,  2
		dc.b   4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  4,  4
		dc.b   2,  4,  2,  2,  4,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  4,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   4,  2,  2,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2
		dc.b   2,  2,  2,  2,  4,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2
		dc.b   2,  2,  4,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   4,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2, $A,  2,  4,  2,  2,  4,  2,  4,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  4,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  4,  2,  2,  4,  4,  4
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4
		dc.b   2,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  4,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4
		dc.b   2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  4,  4
		dc.b   2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  4,  2,  4,  2,  2,  2
		dc.b   4,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  4,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2
		dc.b   4,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  4,  2,  2,  2,  2,  4,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  4,  4,  4,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   4,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4
		dc.b   4,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2
		dc.b   4,  4,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2
		dc.b   2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  4,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b  $A,  2,  2,  2,  2,  2,  2,  2,  6,  6,  6,  2,  2,  6,  6, $A,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  4, $A,  4,  2,  2,  4,  2, $A,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2
		dc.b   6,  6,  2,  2,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2
		dc.b   2,  2,  2,  2,  4,  2,  2,  2,  6,  6,  4,  2,  6,  2,  6,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  4,  2,  2,  2,  2,  4,  4,  2,  2,  2,  6
		dc.b   8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  4,  4,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  6,  4
		dc.b   6,  6,  6,  6,  6,  8,  6,  4,  8,  8,  8,  8,  8,  8,  6,  6,  8,  6,  6,  6,  6,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  6
		dc.b   6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  2,  6,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  6,  8
		dc.b   8,  8,  8,  8,  8,  8,  8,  8,  6,  4,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  6,  2,  6
		dc.b   6,  4,  6,  8,  8,  6,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  6,  6,  6,  2,  4,  2,  6,  6,  6,  6,  6
		dc.b   8,  6,  8,  6,  6,  6,  6,  8,  8,  8,  6,  8,  6,  6,  6,  6,  6,  6,  4,  2,  2,  2,  4,  4,  4,  2,  2,  2,  2,  2,  4,  4
		dc.b   4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  6,  8,  8
		dc.b   8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  4,  4,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  6,  6,  2,  6,  6,  6,  8
		dc.b   8,  6,  8,  8,  8,  8,  8,  8,  0,  0, $E,  0,  0,  0,  0,  8,  8,  8,  6,  6,  8,  8,  6,  6,  6,  6,  6,  6,  6,  8,  6,  6
		dc.b   6,  6,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  6,  6,  2,  4,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  4,  2,  2,  4,  4,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  6,  8,  8,  8
		dc.b   8,  8,  8,  8,  8,  8,  6,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  6,  6,  6,  6,  4,  8,  8,  8
		dc.b   8,  8,  8,  8,  0,  0, $E,  0,  0,  0,  0,  0,  0,  0, $E,  0,  0,  0,  8,  8,  8,  6,  6,  6,  6,  8,  8,  8,  8,  8,  6,  8
		dc.b   8,  0,  0,  0, $E,  0,  0,  0,  0,  0, $E,  0,  8,  8,  8,  8,  6,  8,  6,  6,  6,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2
		dc.b   2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  6,  8,  8,  8,  8
		dc.b   8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4, $A,  6,  6,  6,  8,  8,  8,  8, $E
		dc.b   0,  0,  0, $E,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $E,  8,  8,  8,  8,  8,  8,  8,  6,  8,  8,  8,  0
		dc.b   0, $E,  0,  0,  0,  0,  0, $E,  0,  0,  0,  0,  0, $E,  0,  0,  8,  8,  6,  8,  6,  6,  6,  2,  2,  2,  2,  2,  2, $A,  4,  4
		dc.b   2,  2,  2,  2,  2,  4,  4,  2,  2,  4,  4,  2,  4,  4,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  6,  8,  8,  8,  8,  8
		dc.b   8,  8,  8,  8,  6,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  4,  4,  4,  2,  2,  4,  6,  6,  8,  8,  8,  8,  0,  0,  0
		dc.b   0, $E,  0,  0,  0, $E,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $E,  0,  0,  0, $E,  0,  0,  0, $E,  0, $E,  0
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $E,  0,  0,  0,  0,  0, $E,  0,  8,  8,  8,  6,  6,  6,  2,  2,  2,  2,  2,  4,  2,  2
		dc.b   2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  4,  6,  8,  8,  8,  8,  8,  8
		dc.b   8,  8,  8,  6,  4,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  8,  8,  4,  2,  8,  6,  8,  8,  0,  0,  0,  0
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  8,  8,  8,  6,  6,  6,  2,  2,  4,  4,  2,  2
		dc.b   4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  4,  6,  8,  8,  8,  8,  8,  8,  8
		dc.b   8,  8,  6,  6,  2,  4,  2,  2,  2,  2,  2,  2, $A,  2,  2,  2,  4,  2,  2,  2,  2,  6,  6,  6,  8,  8,  0,  0,  0,  0,  0,  0
		dc.b   0,  0,  0,  0,  0,  0,  0,  0, $E,  0,  0,  0,  0, $E,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
		dc.b   0,  0, $E,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $E,  0,  0,  8,  6,  8,  8,  6,  6,  6,  6,  2,  2,  2
		dc.b   4,  2,  2,  2,  2,  2,  2, $A,  2,  6,  6,  6,  6,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8
		dc.b   8,  6,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  4,  2,  2,  2,  6,  8,  6,  6,  8,  0,  0,  0, $E,  0,  0,  0
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $E,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $E,  0
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $E,  0,  0,  8,  8,  8,  6,  6,  6,  6,  2,  6
		dc.b   8,  8,  2,  8,  2,  2,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  2,  2,  6,  2,  2,  4,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8
		dc.b   6,  4,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  4,  2,  4,  2,  2,  4,  4,  6,  2,  2,  6,  8,  0, $E,  0,  0,  0,  0,  0,  0
		dc.b   0,  0,  0,  0,  0, $E,  0, $E,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
		dc.b   0,  0,  0,  0,  0,  0,  0,  0, $E,  0,  0,  0,  0,  0,  0, $E,  0,  0,  0,  0,  0,  0,  0,  0,  8,  6,  8,  8,  6,  6,  6,  8
		dc.b   8,  8,  8,  8,  6,  6,  6,  6,  6,  8,  6,  6,  6,  6,  2,  6,  6,  6,  6,  6,  6,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6
		dc.b   2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2, $A,  2,  2,  2,  4,  2,  2,  8,  6,  2,  6,  8,  8,  0,  0,  0,  0,  0,  0,  0, $E
		dc.b   0,  0, $E,  0,  0,  0,  0,  0,  2,  2,  2,  0, $E,  0,  0,  0,  0,  0,  0,  0,  0, $E,  0,  0,  0,  0,  0, $E,  0,  0,  0,  0
		dc.b   0,  0,  0,  0,  0,  0, $E,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $E,  0,  0,  8,  8,  8,  6,  6,  8
		dc.b   6,  8,  6,  6,  8,  8,  8,  8,  6,  6,  6,  8,  8,  8,  6,  6,  6,  8,  6,  6,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2
		dc.b   4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  8,  2,  8,  8,  8,  0,  0,  0,  0,  0,  0,  0,  0,  0
		dc.b   0,  0,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  0, $E,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
		dc.b   0,  0,  0, $E,  0,  0,  0,  0,  0,  0,  0, $E,  0,  0,  0, $E,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  8,  8,  8,  8
		dc.b   8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  8,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2
		dc.b   4,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  8,  8,  8,  8,  8,  0, $E,  0,  0,  0,  0,  0, $E,  0,  0
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  8,  8,  8, $E,  0,  0,  0,  0,  0,  0, $E,  0,  0,  0,  0,  0, $E
		dc.b   0,  2,  2,  2,  2,  8,  6,  6,  8,  8,  6,  8,  0,  0, $E,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $E,  0, $E,  0,  8
		dc.b   8,  8,  8, $E,  0,  0, $E,  0, $E,  0,  0,  0,  0, $E,  0,  0,  8,  8,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6, $A, $A,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  4,  2,  2,  2,  2,  2,  8,  6,  8,  8, $E,  0,  0,  0,  0,  0,  0,  0,  0,  0,  4
		dc.b   2,  2,  2,  2,  4,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  8,  8,  8,  8,  8,  8,  8,  8,  8,  2,  4,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  6,  8,  8,  8,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $E,  0,  0,  0, $E,  0,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6, $A, $A,  6,  6
		dc.b   2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  4,  4,  2,  2,  2,  8,  8,  6,  8,  8,  0,  0,  0,  0,  0,  0,  0,  0,  2,  2,  4
		dc.b   2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  6,  6,  6,  8,  0, $E,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
		dc.b  $E,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  6,  6,  8,  6,  6
		dc.b   6,  6,  6,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  8,  8,  8,  8,  6,  0,  0,  0,  0,  0,  0,  0, $E,  2,  2,  4,  4
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  6,  6,  6,  8,  8,  0, $E,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6, $A, $A,  0,  8,  8,  6
		dc.b   8,  8,  6,  6,  8,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  8,  8,  8, $E,  0,  0,  0, $E,  0,  0,  0,  2,  2,  2,  2
		dc.b   4,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  6,  8,  8,  0,  0,  0,  0, $E,  0,  0,  0,  0,  0,  0
		dc.b   0,  0,  0,  0,  0, $E,  0,  0,  0,  0, $E,  0,  0,  0,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6, $A, $A,  0,  0,  0, $E,  0
		dc.b   8,  8,  8,  8,  6,  6,  6,  2,  2,  2,  2,  4,  2,  2,  2,  2,  6,  6,  8,  0,  0,  0,  0,  0,  0,  0,  0,  2,  2,  2,  2,  2
		dc.b   2,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  8,  0, $E,  0,  0,  0,  0,  0,  0,  0,  0
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6, $A, $A,  0, $E,  0,  0,  0,  0
		dc.b   0,  0,  8,  8,  8,  8,  6,  6,  6,  6,  2,  2,  2,  2,  2,  8,  6,  8,  8, $E,  0,  0,  0,  0,  0,  0,  0,  2,  4,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  4,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  8,  8,  0,  0,  0,  0,  0,  0,  0,  0,  0
		dc.b  $E,  0,  0,  0,  0,  0,  0,  0,  0, $E,  0,  0,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6, $A, $A,  0,  0,  0,  0,  0,  0,  0
		dc.b   0, $E,  0,  0,  8,  8,  8,  8,  8,  8,  6,  6,  2,  2,  4,  8,  6,  8,  8,  0,  0,  0,  0,  0,  0,  0,  2,  2,  4,  2,  2,  4
		dc.b   4,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4
		dc.b   2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  8,  0,  0, $E,  0, $E,  0,  0,  0
		dc.b   0,  0,  0,  0,  0, $E,  0,  0,  0,  0,  0,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6, $A, $A,  0,  0,  0,  0,  0,  0,  0,  0
		dc.b   0,  0,  0, $E,  0,  0,  8,  6,  6,  8,  6,  6,  8,  6,  6,  8,  8,  8,  0,  0,  0, $E,  0,  0,  0,  0,  2,  2,  2,  2,  2,  2
		dc.b   2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2, $A,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  4,  4,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  4,  2,  2,  2,  4,  2,  2,  2,  2,  8,  8,  8,  0,  0, $E,  0
		dc.b   0,  0, $E,  0,  0,  0,  2,  4,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6, $A, $A,  0,  0, $E,  0,  0,  0,  0,  0,  0
		dc.b   0,  0, $E,  0,  0,  0, $E,  0,  8,  6,  8,  6,  6,  8,  8,  8,  6,  8,  0,  0,  0,  0,  0,  0,  0, $E,  2,  2,  2,  2,  4,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  4,  4,  4,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  4,  2,  2,  4,  4,  2,  4,  2,  2,  8,  8
		dc.b   8,  8,  4,  2,  2,  2,  4,  2,  4,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  6,  6,  0, $E,  0,  0,  0, $E,  0,  0,  0,  0
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  8,  8,  6,  6,  8,  8,  6,  6,  0,  0,  0,  0,  0,  0,  0,  0,  2,  2,  2,  2,  4,  2,  4
		dc.b   2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  4,  4,  2,  4,  2,  2
		dc.b   2,  2,  2,  4,  4,  2,  4,  2,  4,  2,  4,  2,  2,  2, $A,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  2
		dc.b   4,  4,  2,  2,  4,  4,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  4,  2,  2,  2,  2,  0, $E,  0,  0,  0,  0,  0, $E
		dc.b   0,  0,  0,  0,  0,  0,  0,  0, $E,  0,  8,  8,  8,  8,  8,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  4,  4,  2,  2,  2,  2,  2
		dc.b   4,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  4,  4,  2,  2,  4,  2,  2,  4,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2
		dc.b   4,  2,  4,  4,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2
		dc.b   2,  2,  4,  2,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  4,  2,  4,  2,  2,  2,  4,  2,  0,  0,  0,  0,  0
		dc.b   0,  0,  0,  0,  0, $E,  0,  0,  0,  0, $E,  0,  0, $E,  0,  0,  0, $E,  0,  0,  0,  0,  0, $E,  0,  2,  4,  4,  2,  2,  2,  2
		dc.b   2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  4,  2,  2,  2,  2
		dc.b   2,  4,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  4,  4,  2,  2
		dc.b   2,  2,  2,  2,  4,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  4,  2,  2,  2,  2,  4,  2,  4,  4,  2, $E,  0,  0
		dc.b  $E,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  2,  2,  2,  2,  4, $A,  2
		dc.b   4,  2,  4,  2,  2,  4,  2,  4,  2,  4,  2,  4,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  4,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  4,  4,  2,  2,  2,  2,  2,  4,  2,  4,  4,  2,  4,  4,  4,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  4,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $E,  0,  0,  2,  2,  4,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4
		dc.b   2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  2,  2,  4,  4,  4,  2,  2,  2,  4,  2,  2,  2
		dc.b   2,  2, $E,  0, $E,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  2,  4,  4,  2,  4,  2,  4,  2
		dc.b   4,  2,  2,  2,  4,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  4,  2,  4,  2,  2,  2,  4,  2,  2
		dc.b   2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  4,  2,  2,  2,  2
		dc.b   2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  4
		dc.b   2,  4,  2,  2,  0,  0, $E,  0,  0,  0,  0,  0,  0,  0, $E,  0,  0,  0,  0,  0, $E,  0,  6,  2,  2,  4,  4,  2,  2,  2,  2,  2
		dc.b   2,  4,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  4,  2,  2,  4,  4,  2,  2,  2,  2,  2,  4
		dc.b   2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2
		dc.b   2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2
		dc.b   4,  2, $A,  2,  2,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  6,  6,  4,  2,  2,  2,  2,  2,  2,  4,  2
		dc.b   2,  4,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2, $A,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2
		dc.b   4,  4,  2,  2,  4,  2,  2,  4,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  4,  2,  4,  2,  2,  4,  2,  2,  2,  4,  2,  4
		dc.b   2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  6,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $E,  0,  6,  6,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4
		dc.b   2,  4,  2,  4,  4,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2
		dc.b   6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2
		dc.b   4,  2,  2,  2,  2,  2,  6,  6, $E,  0,  0,  0, $E,  0,  0,  0,  0,  0,  8,  8,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  4,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2
		dc.b   2,  4,  4,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  6
		dc.b   8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  6,  6,  6,  0,  0,  0,  0,  0, $E,  0,  8,  6,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2
		dc.b   2,  4,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  4,  2,  2,  2,  4,  2,  2,  2, $A,  2, $A,  2,  2,  4,  4,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  6,  8
		dc.b   8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  4,  6,  4,  8,  8,  6,  6,  6,  8,  6,  6,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2
		dc.b   2,  2,  4,  4,  2,  2,  2,  2,  4,  4,  2,  2,  4,  4,  2,  4,  4,  4,  4,  2,  2,  4,  2,  2,  2, $A,  4,  2,  2,  6,  8,  8
		dc.b   8,  8,  8,  8,  8,  8,  8,  6,  4,  2,  2,  4,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  4,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  6,  6,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  4,  4,  2,  4
		dc.b   2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2, $A,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2
		dc.b   4,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  6,  8,  8,  8
		dc.b   8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  4,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2, $A,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  4,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  6,  8,  8,  8,  8
		dc.b   8,  8,  8,  8,  8,  6,  2,  4,  4, $A,  2,  2,  2,  2, $A,  2,  2,  2,  2,  2,  2,  4,  4,  2,  4,  2,  2,  2,  2,  2,  4,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  4,  2,  2,  4,  2
		dc.b   4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2
		dc.b   4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  6,  8,  8,  8,  8,  8
		dc.b   8,  8,  8,  8,  6,  2,  2,  4,  2,  4,  2,  4,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  4,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, $A,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  4,  2,  2,  6,  8,  8,  8,  8,  8,  8
		dc.b   8,  8,  8,  6,  2,  4,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  4,  2,  4,  4,  4
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2, $A,  4,  2, $A,  4,  4,  2,  2, $A,  2,  4,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8
		dc.b   8,  8,  6,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2
		dc.b   4,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  6,  8,  8,  8,  8,  8,  8,  8,  8
		dc.b   8,  6,  4,  2,  2, $A,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  4,  2,  2,  2,  2
		dc.b   2,  4,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2
		dc.b   4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8
		dc.b   6,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  4,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   4,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  4,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4
		dc.b   2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  4,  4,  4,  2,  2,  4,  2,  4,  2,  2,  2
		dc.b   4,  2,  2,  2, $A,  4,  2,  2,  2,  2,  2,  2,  4,  4,  4,  2,  4,  2,  2,  4,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4
		dc.b   2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2
		dc.b   2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  4,  4,  4,  2,  4,  2
		dc.b   2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2
		dc.b   2,  2,  4,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2
		dc.b   2,  2,  4,  2,  2,  4, $A,  2,  2,  2,  2,  2,  4,  2,  4,  4,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2
		dc.b   2,  4,  4,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  4
		dc.b   2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2, $A,  2,  4,  4,  2,  2,  2
		dc.b   4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  4,  4,  2,  4,  2,  2,  2,  2,  2
		dc.b   2, $A,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  4,  4,  2,  2,  2
		dc.b   2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  4
		dc.b   2,  2,  4,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2
		dc.b   4,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  4,  2,  2,  4,  2
		dc.b   2,  4,  2,  2,  4,  4,  4,  4, $A,  2,  4,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  4,  4
		dc.b   2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  4,  2,  2,  2
		dc.b   2,  2,  2,  4,  4,  4,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2
		dc.b   2,  4,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, $A,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  2
		dc.b   2,  4,  2,  4,  4,  2,  2,  2,  4,  4,  2,  2,  4,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2, $A,  2,  2,  4,  2,  4,  2
		dc.b   4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  4,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  4,  2,  4,  4,  2
		dc.b   2,  2,  4,  2,  2, $E,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  4,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  2,  2,  4
		dc.b   2,  2,  2,  2, $E, $C, $E,  2,  2,  4,  2,  4,  2,  4,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2
		dc.b   2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4
		dc.b   2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  4,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  4,  2,  2,  2,  4,  2
		dc.b   2,  4,  4, $E, $C, $C, $C, $E,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  4,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  4,  2,  4,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  4,  2,  2,  2,  2,  4,  2
		dc.b   2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4
		dc.b   2,  4,  4,  2,  2,  2,  4,  2,  2,  2,  4,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2
		dc.b   4,  2, $E, $C, $C, $C, $C, $C, $E,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  4,  2,  2,  4,  4,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  4,  2,  4,  4,  2,  2,  2,  2,  2,  2
		dc.b   2, $E, $C, $C, $C, $C, $C, $C, $C, $E,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  4,  2,  4,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  4,  2
		dc.b   4,  4,  2,  2,  2,  2,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2
		dc.b  $E, $C, $C, $C, $C, $C, $C, $C, $C, $C, $E,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  4,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4
		dc.b   4,  4,  4,  2,  2,  2,  2,  4,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2, $E
		dc.b  $C, $C, $C, $C, $C, $C, $C, $C, $C, $C, $A,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2, $A,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2
		dc.b   2,  2,  2,  4,  4,  4,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  4,  2,  2,  2,  2,  4,  2,  4,  2,  4,  2,  2,  2, $A
		dc.b  $C, $C, $C, $C, $C, $C, $C, $C, $C, $A, $A,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  4,  2,  4,  2,  2,  4,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4
		dc.b   2,  2,  2,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  4,  2,  2,  4,  2,  4,  2,  2,  2,  2,  4,  4,  2,  2, $A
		dc.b  $A, $C, $C, $C, $C, $C, $C, $C, $A, $A, $A,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4
		dc.b   4,  2,  2,  4,  2,  2,  2,  4,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  4,  4,  2
		dc.b   4,  4,  4,  2,  2,  2, $A,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2, $A,  2,  2,  2,  4,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2, $A,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  4, $A
		dc.b  $A, $A, $C, $C, $C, $C, $C, $A, $A, $A, $A,  2,  2,  2,  2,  2, $A,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2
		dc.b   2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   4,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  4,  4,  2,  2,  2,  4,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2
		dc.b   2,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  4,  2,  2,  2, $A
		dc.b  $A, $A, $A, $C, $C, $C, $A, $A, $A, $A,  2,  4,  4,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4
		dc.b   2,  2,  2,  2,  4,  2,  4,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4
		dc.b   2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  4,  2,  4,  2,  2,  2,  4,  4,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2
		dc.b  $A, $A, $A, $A, $C, $A, $A, $A, $A,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  4,  4,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2
		dc.b   4,  2,  2,  2,  2,  4,  4,  2,  2,  2,  4,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2
		dc.b   2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2, $A, $A, $A, $A, $A, $A, $A,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  4,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2
		dc.b   2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4
		dc.b   2,  2, $A, $A, $A, $A, $A,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  4
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2
		dc.b   2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4, $C,  2,  2,  4,  2,  2,  2,  2
		dc.b   2,  2,  2, $A, $A, $A,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  4,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4
		dc.b   2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2
		dc.b   4,  2, $A,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  6
		dc.b   8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4, $C, $C, $C,  4,  2,  2,  2,  2,  2
		dc.b   2,  4,  2,  2, $C,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4
		dc.b   2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  6,  8
		dc.b   8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  4,  2,  4,  4,  4,  2,  2,  2,  2, $C, $C, $A, $C, $C,  4,  2,  2,  4,  2
		dc.b   4,  4,  2,  2,  2,  2,  2,  4,  4,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4
		dc.b   4,  2,  2,  2,  4,  2,  2,  4,  2,  2,  4,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  4
		dc.b   2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  6,  8,  8
		dc.b   8,  8,  8,  8,  8,  8,  8,  6,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, $C, $C, $A, $E, $E, $C, $C,  2,  2,  2,  2
		dc.b   2,  2,  4,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2
		dc.b   2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  6,  8,  8,  8
		dc.b   8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  4, $C, $C, $A, $E, $E, $E, $E, $C, $C,  4,  4,  2
		dc.b   4,  4,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  4,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  4,  4,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2
		dc.b   2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, $A,  4,  6,  8,  8,  8,  8
		dc.b   8,  8,  8,  8,  8,  6, $A,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2, $C, $C, $A, $E, $E, $E, $E, $E, $E, $C, $C,  2,  2
		dc.b   2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  4,  4,  2,  2,  4,  4,  4,  2,  2,  2,  2,  2,  2
		dc.b   2,  4,  2,  2,  2,  4,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  6,  8,  8,  8,  8,  8
		dc.b   8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2, $C, $C, $A, $E, $E, $E, $E, $E, $E, $E, $E, $C, $C,  2
		dc.b   2,  4,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2
		dc.b   4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8
		dc.b   8,  8,  8,  6,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2, $C, $C, $A, $E, $E, $E, $E, $C, $E, $E, $E, $E, $E, $C, $C
		dc.b   2,  2,  2,  2,  4,  2,  4,  4,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  4,  2
		dc.b   2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  4,  4,  2,  6,  8,  8,  8,  8,  8,  8,  8
		dc.b   8,  8,  6,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2, $C, $C, $A, $E, $E, $E, $E, $C, $C, $C, $E, $E, $E, $E, $E, $C
		dc.b  $C,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4, $A,  4,  4,  2,  4
		dc.b   4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   4,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8
		dc.b   8,  6,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2, $C, $C, $A, $E, $E, $E, $E, $C, $C, $E, $C, $C, $E, $E, $E, $E, $E
		dc.b  $C, $C,  4,  4,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2
		dc.b   2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4, $A
		dc.b   2,  2,  2,  4,  2,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8
		dc.b   6,  2,  2,  2,  4,  4,  4,  2,  2,  2,  2,  2,  2,  2, $C, $C, $A, $E, $E, $E, $E, $C, $C, $E, $E, $E, $C, $C, $E, $E, $E, $E
		dc.b  $E, $C, $C,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2
		dc.b   2,  4,  2, $A,  2,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  4,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6
		dc.b   2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, $C, $C, $A, $E, $E, $E, $E, $C, $C, $E, $E, $E, $E, $E, $C, $C, $E, $E, $E
		dc.b  $E, $E, $C, $C,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2
		dc.b   2,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4
		dc.b   4,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2
		dc.b   2,  2,  4,  4,  2,  2,  2,  2,  2,  4,  2,  2, $C, $C, $A, $E, $E, $E, $E, $C, $C, $E, $E, $E, $E, $E, $E, $E, $C, $C, $E, $E
		dc.b  $E, $E, $E, $C, $C,  2,  4,  2,  4,  2,  4,  2,  4,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2
		dc.b   2,  2,  4,  2,  2,  4,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, $C, $C, $A, $E, $E, $E, $E, $C, $C, $E, $E, $E, $E, $E, $E, $E, $E, $E, $C, $C, $E
		dc.b  $E, $E, $E, $E, $C, $C,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  4,  2,  2,  4,  2,  4,  2,  2,  4,  2,  2
		dc.b   2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2
		dc.b   2,  4,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  4,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  4, $C, $C, $A, $E, $E, $E, $E, $C, $C, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $C, $C
		dc.b  $E, $E, $E, $E, $E, $C, $C,  4,  2,  2,  2,  2,  4,  4,  2,  4,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2, $A,  2,  2,  2,  2
		dc.b   2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  4,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2
		dc.b   2,  4,  2,  2,  2,  2,  2,  2,  2, $C, $C, $A, $E, $E, $E, $E, $C, $C, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $C
		dc.b  $C, $E, $E, $E, $E, $E, $C, $C,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  4,  2,  2,  2
		dc.b   2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  4,  2,  2,  4,  4,  2,  2,  2,  2,  4,  2,  4,  2,  2,  6,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  4,  4,  2,  2,  2
		dc.b   2,  2,  4,  4,  2,  4,  2,  4, $C, $C, $A, $E, $E, $E, $E, $C, $C, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E
		dc.b  $C, $C, $E, $E, $E, $E, $E, $C, $C,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  4,  2,  2,  4,  4,  4,  4,  2,  2,  4
		dc.b   2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4
		dc.b   2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  6,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  2
		dc.b   4,  2,  4,  2,  2,  4,  4,  2,  2, $C, $C, $E, $E, $E, $E, $E, $C, $C, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $C
		dc.b  $C, $A, $E, $E, $E, $E, $C, $C,  4,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2, $A,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  6,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  4,  2,  2,  2,  2,  2, $C, $C, $E, $E, $E, $E, $E, $C, $C, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $C, $C
		dc.b  $A, $E, $E, $E, $E, $C, $C,  2,  4,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  6,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  4,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, $C, $C, $E, $E, $E, $E, $E, $C, $C, $E, $E, $E, $E, $E, $E, $E, $E, $E, $C, $C, $A
		dc.b  $E, $E, $E, $E, $C, $C,  2,  4,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  4,  4,  2,  2,  2,  4,  4,  2,  4,  2,  2,  4,  2, $A,  2,  2,  4,  2,  2,  4,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  6,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   4,  4,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2, $C, $C, $E, $E, $E, $E, $E, $C, $C, $E, $E, $E, $E, $E, $E, $E, $C, $C, $A, $E
		dc.b  $E, $E, $E, $C, $C,  2,  2,  4,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2
		dc.b   2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2, $A,  2,  4,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2
		dc.b   4,  2,  2,  4,  2,  2,  2,  2,  4,  2, $A,  2,  2, $C, $C, $E, $E, $E, $E, $E, $C, $C, $E, $E, $E, $E, $E, $C, $C, $A, $E, $E
		dc.b  $E, $E, $C, $C,  2,  2,  2,  4,  2,  2,  4,  2,  4,  2,  4,  4,  2,  4,  4,  2,  2,  4,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2
		dc.b   4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2
		dc.b   2,  4,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2, $C, $C, $E, $E, $E, $E, $E, $C, $C, $E, $E, $E, $C, $C, $A, $E, $E, $E
		dc.b  $E, $C, $C,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  4,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2
		dc.b   4,  2,  2,  2,  2,  2,  4,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  4,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2, $C, $C, $E, $E, $E, $E, $E, $C, $C, $E, $C, $C, $A, $E, $E, $E, $E
		dc.b  $C, $C,  2,  2,  4,  2,  2,  2,  2,  2,  2, $A,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2
		dc.b   2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4
		dc.b   2,  4,  4,  2,  2,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  4,  2,  4,  4,  2,  2,  2,  2,  4,  2,  4,  2,  2
		dc.b   2,  2,  2,  2,  2,  2, $A,  2,  2,  2,  2,  2,  2,  2,  2,  4, $C, $C, $E, $E, $E, $E, $E, $C, $C, $C, $A, $E, $E, $E, $E, $C
		dc.b  $C,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  4,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2
		dc.b   2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  4,  2
		dc.b   4,  2,  2,  2,  2,  2,  2,  2,  8,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  4, $A,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, $C, $C, $E, $E, $E, $E, $E, $C, $A, $E, $E, $E, $E, $C, $C
		dc.b   2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2
		dc.b   4,  4,  2,  2,  2,  4,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2
		dc.b   4,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2, $C, $C, $E, $E, $E, $E, $E, $E, $E, $E, $E, $C, $C,  2
		dc.b   2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4, $A,  4,  2,  2,  2,  2,  2,  4,  2,  2, $A,  2,  4,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  4,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  4
		dc.b   2,  2,  2,  2,  4,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2, $C, $C, $E, $E, $E, $E, $E, $E, $E, $C, $C,  2,  2
		dc.b   4,  4,  2,  2,  4,  2,  4,  4,  4,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4
		dc.b   2,  2,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4, $C, $C, $E, $E, $E, $E, $E, $C, $C,  4,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2
		dc.b   4,  2, $A,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2
		dc.b   2,  2,  4,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  4,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2, $C, $C, $E, $E, $E, $C, $C,  2,  4,  2,  2
		dc.b   2,  2,  2,  4,  4,  2,  2,  4,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2, $A,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2
		dc.b   2,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  4,  4,  2,  4,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  4,  2,  2,  4,  2,  2, $C, $C, $E, $C, $C,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4
		dc.b   2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  2
		dc.b   2,  2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  6,  6,  4,  2,  2,  4,  2,  2,  2,  2,  2,  4,  4,  2,  4,  2,  4,  2,  4,  2,  2
		dc.b   4,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4, $C, $C, $C,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  4,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4
		dc.b   2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  4,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2
		dc.b   2,  6,  8,  8,  8,  8,  8,  8,  8,  8,  6,  4,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, $C,  4,  2,  2,  2,  2,  2,  4
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2
		dc.b   6,  8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2
		dc.b   2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  4,  4,  4,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2, $A,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  6
		dc.b   8,  8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2
		dc.b   4,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   4,  2, $A,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2
		dc.b   2,  2,  2,  2,  2,  4,  4,  4,  2,  4,  2,  4,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  6,  8
		dc.b   8,  8,  8,  8,  8,  8,  8,  8,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  4
		dc.b   2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  2,  2,  2,  4,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  6,  8,  8
		dc.b   8,  8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2
		dc.b   2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  2,  4,  2,  4,  2,  2,  4,  2,  4,  2
		dc.b   2,  2,  2,  2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  4,  2,  2,  2,  2,  4,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  6,  8,  8,  8
		dc.b   8,  8,  8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2
		dc.b   2,  2,  4,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  4
		dc.b   2,  2,  4,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2, $A,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  6,  8,  8,  8,  8
		dc.b   8,  8,  8,  8,  8,  6,  2,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  4,  2,  4,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  4,  2,  4,  2,  4,  2,  2,  2,  2,  2,  4
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2, $A,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  2,  4,  2,  2,  2,  2,  6,  8,  8,  8,  8,  8
		dc.b   8,  8,  8,  8,  6,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2,  4,  2,  4,  2,  2,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  4,  4,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  4,  4,  2,  4,  2,  2,  2,  2
		dc.b   2,  4,  2,  4,  2,  2,  2,  2,  4,  2,  4,  4,  2,  2,  4,  2,  4,  2,  2,  2,  2,  4,  2,  2,  2,  6,  8,  8,  8,  8,  8,  8
		dc.b   8,  8,  8,  6,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  4,  4,  2,  2,  2,  4,  4,  2,  2,  2,  2,  2,  4,  2,  2,  2,  4
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2, $A,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  2,  2,  2
		dc.b   2,  2,  4,  2,  4,  2,  2,  2,  2,  4,  2, $A,  4,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  2,  2,  2,  2,  2,  2
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  2,  2,  6,  8,  8,  8,  8,  8,  8,  8
		dc.b   8,  8,  6,  2,  2,  2,  4,  2

; ===========================================================================================
AngleMap_GHZ:	dc.b $FF,  0,$88,$90,$A0,$B0,$B8,$C4,  0,  0,  0,  0,$D0,  0,  0,  0; 0
		dc.b $FC,$FC,$FC,$FC,$FC,$FC,$FC,$FC,$F8,$F8,$F8,$F8,$F0,$F0,$D0,$D0; 16
		dc.b $D4,$E0,$E0,$C8,$FC,$F8,$F0,$EA,$E6,$E0,$E0,$EC,$CC,$F0,$C8,$C8; 32
		dc.b $DA,$D6,$C8,$D0,$D8,$E8,  4,$F0,$D0,$C4,$7A,$6C,$6A,$F4,$54,  0; 48
		dc.b $10,$14,$16,$18,$18,$18,$1C,$1C,$20,$24,$2C,$28,$58,$58,$FF,$FF; 64
		dc.b $E0,$22,$60,$54,$20,$FF,$20,  0,$F8,$F8,$F8,$F8,$1C,$14,  8,  8; 80
		dc.b   6,  4,  2,$FF,$FC,$FC,$FC,$F8,$F4,$F0,$EC,$E8,$E0,$BC,$B4,$AC; 96
		dc.b $A0,$94,$8C,$84,$10,$FF,$FF,$FF,  4,  4,$D4,$D4,  4,  6,  8, $C; 112
		dc.b  $E, $C,$14,$10, $C, $C,  8,  6,  4,  4,$78,$6C,$60,$54,$48,$FF; 128
		dc.b $FF,$44,$70,$58,$FF,$E4,$D0,$D0,  4,$D0,$10,$24,$38,$FF,$FF,$10; 144
		dc.b $20,$30, $C,$14,$20,$2C,$34,$7C,$70,$58,$48,$84,$88,$90,$98,$9C; 160
		dc.b $A0,$B0,$B8,$BC,$28,$18,$20,$E8,$F4,$20,$18,$80,$80,$84,$88,$88; 176
		dc.b $8C,$90,$94,$94,$8C,$8C,$88,$84,$84,$80,$80,$8C,$90,$98,$A8,$A8; 192
		dc.b $B0,$B8,$C0,  8,$18,$30,$84,$88,$90,$98,$A8,$B0,$B4,$B8,$BC,$10; 208
		dc.b $20,$30,  8, $A, $C,$10,$E4,$EC,$E4,$E8,$E8,$E8,$F4,$D8,$EC,$F4; 224
		dc.b $FA,$FC,$38,$38,$38,$38,$E4,  0,  0,  0,  0,$E0,$20,$A0,$60,$FF; 240

AngleMap:	dc.b $FF,$FF,$E0,$D0,$D0,$C8,$C8,$C8,$C8,$F0,$F0,$F8,$F8,$F8,$F8,$FF; 0
		dc.b $FC,$F8,$F4,$F0,$E8,$E4,$E2,$E0,$FF,$D4,$D0,$D0,$C8,$C6,$FF,$FC; 16
		dc.b $F0,$E8,$E0,$D8,$D0,$C4,$FC,$F8,$F4,$F0,$EC,$E8,$E4,$E2,$E0,$E2; 32
		dc.b $E4,$E8,$E8,$EC,$F0,$F4,$F6,$F8,$FC,$FE,$FF,$FE,$FC,$FA,$F8,$F6; 48
		dc.b $F4,$F2,$F2,$F4,$F6,$F8,$FA,$FC,$FE,$FC,$F8,$F0,$E8,$E0,$D8,$D4; 64
		dc.b $D0,$C8,$C4,$F8,$E0,$C8,$C4,$CC,$D4,$E0,$EC,$F4,$FC,$C4,$C8,$CC; 80
		dc.b $D0,$D8,$E0,$E4,$E8,$F0,$F4,$F8,$FC,$D0,$E0,$F0,$FC,$F8,$F0,$E8; 96
		dc.b $E4,$E0,$DC,$C4,$C8,$D0,$D8,$18,$10,$10,$20,$24,$28,$20,$20,$24; 112
		dc.b $D8,$D0,$F0,$F8,$FE,$F8,$F0,$E0,$D0,$C8,$C4,$E0,$E4,$DC,$D8,$D0; 128
		dc.b $CC,$C8,$C6,$C4,$FE,$FC,$FC,$F8,$F0,$E8,$E4,$F4,$E0,$DC,$D4,$FC; 144
		dc.b $F4,$E0,$F6,$F6,$FF,$FF,$FF,$FC,$FC,$FF,$FF,$FC,$F0,$F0,$FF,$DC; 160
		dc.b $E0,$F6,$F8,$F0,$F0,$F0,$E8,$FC,$F4,$FC,$E8,$D8,$FF,$DC,$DC,$FC; 176
		dc.b $F0,$FC,$FC,$D0,$FF,$20,$E0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 192
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 208
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 224
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$E0,$20,$A0,$60,$FF; 240

ColArray1_GHZ:	dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 0
		dc.b   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1; 16
		dc.b $FE,$FE,$FE,$FE,$FD,$FD,$FD,$FD,$FC,$FC,$FC,$FB,$FB,$FB,$FA,$FA; 32
		dc.b $F9,$F9,$F8,$F8,$F7,$F7,$F6,$F6,$F5,$F5,$F4,$F4,$F3,$F2,$F2,$F1; 48
		dc.b   0,$FF,$FF,$FE,$FD,$FC,$FB,$FA,$F9,$F8,$F7,$F6,$F5,$F4,$F3,$F1; 64
		dc.b   0,$FF,$FD,$FC,$FA,$F8,$F6,$F4,$F2,$10,$10,$10,$10,$10,$10,$10; 80
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FE,$FB,$F8,$F4,$10,$10; 96
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  5,  9; 112
		dc.b   8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8; 128
		dc.b   9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9; 144
		dc.b  $A, $A, $A, $A, $A, $A, $A, $A, $A, $A, $A, $A, $A, $A, $A, $A; 160
		dc.b  $B, $B, $B, $B, $B, $B, $B, $B, $B, $B, $B, $B, $B, $B, $B, $B; 176
		dc.b   0,  0,  0,  0,  0,  0,  0,  1,  3,  6,  8, $B, $E,$10,$10,$10; 192
		dc.b  $D, $D, $D, $D, $D, $D, $D, $D, $D, $D, $D, $D, $D, $D, $D, $D; 208
		dc.b  $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E; 224
		dc.b  $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F; 240
		dc.b   1,  1,  1,  1,  1,  1,  1,  1,  2,  2,  2,  2,  2,  2,  2,  2; 256
		dc.b   3,  3,  3,  3,  3,  3,  3,  3,  4,  4,  4,  4,  4,  4,  4,  4; 272
		dc.b   5,  5,  5,  5,  5,  5,  5,  5,  6,  6,  6,  6,  6,  6,  6,  6; 288
		dc.b   7,  7,  7,  7,  7,  7,  7,  7,  8,  8,  8,  8,  8,  8,  8,  8; 304
		dc.b   9,  9,  9,  9,  9,  9,  9,  9, $A, $A, $A, $A, $A, $A, $A, $A; 320
		dc.b  $B, $B, $B, $B, $B, $B, $B, $B, $C, $C, $C, $C, $C, $C, $C, $C; 336
		dc.b  $D, $D, $D, $D, $D, $D, $D, $D, $E, $E, $E, $E, $E, $E, $E, $E; 352
		dc.b  $F, $F, $F, $F, $F, $F, $F, $F,$10,$10,$10,$10,$10,$10,$10,$10; 368
		dc.b   1,  1,  1,  1,  2,  2,  2,  2,  3,  3,  3,  3,  4,  4,  4,  4; 384
		dc.b   5,  5,  5,  5,  6,  6,  6,  6,  7,  7,  7,  7,  8,  8,  8,  8; 400
		dc.b   9,  9,  9,  9, $A, $A, $A, $A, $B, $B, $B, $B, $C, $C, $C, $C; 416
		dc.b  $D, $D, $D, $D, $E, $E, $E, $E, $F, $F, $F, $F,$10,$10,$10,$10; 432
		dc.b   1,  1,  2,  2,  3,  3,  4,  4,  5,  5,  6,  6,  7,  7,  8,  8; 448
		dc.b   9,  9, $A, $A, $B, $B, $C, $C, $D, $D, $E, $E, $F, $F,$10,$10; 464
		dc.b   2,  4,  6,  8, $A, $C, $E,$10,$10,$10,$10,$10,$10,$10,$10,$10; 480
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  2,  4,  6,  8, $A, $C, $E,$10; 496
		dc.b   4,  5,  7,  9, $B, $D, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10; 512
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  2; 528
		dc.b   0,  0,  0,  1,  3,  4,  5,  6,  8,  9, $A, $C, $D, $F,$10,$10; 544
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  4,  8, $C,$10; 560
		dc.b   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  2,  2,  2,  2,  2,  2; 576
		dc.b   2,  3,  3,  3,  3,  3,  4,  4,  4,  4,  5,  5,  5,  6,  6,  6; 592
		dc.b   7,  7,  7,  8,  8,  8,  9,  9, $A, $A, $B, $B, $C, $C, $D, $D; 608
		dc.b  $E, $F, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 624
		dc.b   0,  0,  0,  0,  0,  1,  2,  2,  3,  4,  5,  5,  6,  7,  8,  9; 640
		dc.b  $A, $B, $B, $C, $D, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 656
		dc.b   0,  0,  1,  1,  2,  3,  4,  5,  6,  7,  8,  9, $A, $B, $C, $D; 672
		dc.b   4,  5,  5,  6,  6,  7,  8,  8,  9, $A, $A, $B, $C, $D, $D, $E; 688
		dc.b   0,  0,  0,  0,  0,  0,  2,  5,  7, $A, $D,$10,$10,$10,$10,$10; 704
		dc.b  $C, $D, $D, $D, $E, $E, $F, $F,$10,$10,$10,$10,$10,$10,$10,$10; 720
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  6, $C,$10,$10; 736
		dc.b   0,  0,  0,  0,  0,  0,  0,  2,  5,  9, $D,$10,$10,$10,$10,$10; 752
		dc.b   0,  0,  0,  0,  0,  0,  0,  1,  2,  3,  4,  6,  7,  8, $A, $B; 768
		dc.b  $D, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 784
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  3,  6, $A, $F,$10,$10; 800
		dc.b   7,  8, $A, $C, $E,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 816
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  3,  5; 832
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  2,  3,  3; 848
		dc.b   1,  1,  1,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 864
		dc.b  $B, $B, $C, $C, $D, $D, $E, $E, $F,$10,$10,$10,$10,$10,$10,$10; 880
		dc.b   0,  0,  0,  2,  4,  6,  8, $A, $D,$10,$10,$10,$10,$10,$10,$10; 896
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  6,$10; 912
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$F1,$F1,$F1,$F1,$F1,$F1,$F2,$F2; 928
		dc.b $F2,$F2,$F3,$F3,$F3,$F4,$F4,$F4,$F5,$F5,$F6,$F6,$F7,$F7,$F8,$F8; 944
		dc.b $F9,$F9,$FA,$FB,$FB,$FC,$FD,$FD,$FE,$FF,  0,  0,  0,  0,  0,  0; 960
		dc.b   5,  5,  5,  6,  6,  6,  7,  7,  7,  8,  8,  9,  9,  9, $A, $A; 976
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$F2,$F4,$F6,$F8,$FB,$FE,  0,  0; 992
		dc.b   1,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1008
		dc.b  $C, $B, $B, $B, $A, $A,  9,  9,  8,  8,  8,  7,  7,  6,  6,  6; 1024
		dc.b   5,  4,  4,  3,  3,  2,  2,  1,  1,  0,  0,  0,  0,  0,  0,  0; 1040
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10, $F, $F, $E, $E, $D; 1056
		dc.b  $D, $C, $B, $B, $A, $A,  9,  8,  8,  7,  7,  6,  5,  5,  4,  3; 1072
		dc.b   3,  2,  1,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1088
		dc.b $10,$10,$10,$10,$10, $F, $F, $E, $D, $D, $C, $B, $A, $A,  9,  8; 1104
		dc.b   7,  7,  6,  5,  4,  3,  3,  2,  1,  0,  0,  0,  0,  0,  0,  0; 1120
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10, $F, $E, $D, $D, $C, $B; 1136
		dc.b  $A,  9,  8,  7,  6,  5,  4,  3,  2,  1,  0,  0,  0,  0,  0,  0; 1152
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10, $F, $D, $C, $B, $A,  8; 1168
		dc.b $10, $E, $C, $A,  8,  6,  5,  3,  1,  0,  0,  0,  0,  0,  0,  0; 1184
		dc.b   7,  6,  4,  3,  2,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1200
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$F1,$F2; 1216
		dc.b $F3,$F5,$F6,$F7,$F8,$F9,$FA,$FB,$FD,$FE,$FF,  0,  0,  0,  0,  0; 1232
		dc.b $10,$10,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1248
		dc.b   0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1264
		dc.b   1,  2,  3,  4,  5,  6,  7,  8,  9, $A, $B, $C, $D, $E, $F,$10; 1280
		dc.b $10,$10,$10,$10,$10,$10,$10, $F, $E, $D, $C, $B,  9,  8,  7,  6; 1296
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$F1,$F2,$F3,$F4,$F5; 1312
		dc.b $F6,$F7,$F8,$FA,$FC,$FD,$FE,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1328
		dc.b   5,  4,  3,  2,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1344
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  6, $A, $E, $E, $F, $F, $F, $F; 1360
		dc.b $10,$10,$10,$10,$10,$10, $F, $E, $D, $C, $B, $A,  9,  8,  7,  6; 1376
		dc.b  $F, $F, $F, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1392
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  1,  1,  2,  2,  2,  2; 1408
		dc.b   3,  3,  3,  3,  4,  4,  4,  4,  5,  5,  5,  5,  6,  6,  6,  6; 1424
		dc.b   7,  7,  7,  7,  8,  8,  8,  8,  9,  9,  9,  9, $A, $A, $A, $A; 1440
		dc.b  $B, $B, $B, $B, $C, $C, $C, $C, $D, $D, $D, $D, $E, $E, $E, $E; 1456
		dc.b   5,  4,  3,  3,  2,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1472
		dc.b  $D, $C, $B, $B, $A,  9,  9,  8,  8,  7,  6,  6,  5,  5,  4,  4; 1488
		dc.b  $E, $E, $E, $D, $D, $D, $C, $C, $C, $C, $B, $B, $B, $A, $A, $A; 1504
		dc.b  $A,  9,  9,  9,  9,  9,  8,  8,  8,  8,  7,  7,  7,  7,  7,  6; 1520
		dc.b   6,  6,  6,  6,  6,  5,  5,  5,  5,  5,  5,  4,  4,  4,  4,  4; 1536
		dc.b   4,  4,  4,  4,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  2; 1552
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  1,  1,  1; 1568
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$10; 1584
		dc.b   0,  0,  0,  0,  0,  0,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1; 1600
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  3,  3,  3,  3,  3,  3,  3; 1616
		dc.b   4,  4,  4,  4,  4,  4,  4,  5,  5,  5,  5,  5,  5,  6,  6,  6; 1632
		dc.b   6,  6,  7,  7,  7,  7,  7,  8,  8,  8,  8,  8,  9,  9,  9,  9; 1648
		dc.b  $A, $A, $A, $A, $B, $B, $B, $B, $C, $C, $C, $D, $D, $D, $E, $E; 1664
		dc.b  $E, $F, $F, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1680
		dc.b   0,  0,  0,  0,  0,  0,  0,  1,  1,  2,  2,  3,  3,  4,  4,  5; 1696
		dc.b   5,  6,  6,  7,  8,  8,  9, $A, $A, $B, $C, $D, $D, $E, $F,$10; 1712
		dc.b   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, $A, $B, $D, $E, $F,$10; 1728
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$F9,$10; 1744
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,$FE,$FB,$F8,$F4,$10,$10,$10; 1760
		dc.b $FE,$FD,$FB,$FA,$F8,$F6,$F4,$F2,$10,$10,$10,$10,$10,$10,$10,$10; 1776
		dc.b $FF,$FE,$FD,$FC,$FC,$FB,$FA,$F9,$F8,$F7,$F6,$F5,$F3,$F2,$F1,$10; 1792
		dc.b $F8,$F8,$F7,$F7,$F6,$F6,$F5,$F5,$F4,$F4,$F3,$F2,$F2,$F1,$10,$10; 1808
		dc.b $FD,$FD,$FD,$FD,$FC,$FC,$FC,$FC,$FB,$FB,$FB,$FA,$FA,$FA,$F9,$F9; 1824
		dc.b $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE,$FE,$FE,$FE,$FE,$FE,$FE; 1840
		dc.b   4,  3,  3,  3,  2,  2,  2,  1,  1,  1,  0,  0,  0,  0,  0,  0; 1856
		dc.b $FC,$FC,$FC,$FC,$FC,$FC,$FC,$FC,$FC,$FC,$FC,$FC,$FC,$FC,$FC,$FC; 1872
		dc.b $FC,$FC,$FC,$FC,$FC,$FC,$FC,$FC,$FC,$FB,$FA,$F9,$10,$10,$10,$10; 1888
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$10,$10,$10,$10; 1904
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10, $F, $F; 1920
		dc.b  $F, $F, $F, $F, $F, $F, $E, $E, $E, $E, $E, $E, $E, $E, $E, $D; 1936
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  3,  5,  6,  8; 1952
		dc.b   1,  3,  4,  6,  7,  9, $A, $C, $D, $F,$10,$10,$10,$10,$10,$10; 1968
		dc.b $10,$10, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $E, $E; 1984
		dc.b  $E, $E, $E, $E, $E, $E, $E, $D, $D, $D, $D, $D, $D, $D, $D, $C; 2000
		dc.b  $C, $C, $C, $C, $C, $B, $B, $B, $B, $B, $B, $B, $A, $A, $A, $A; 2016
		dc.b   9,  9,  9,  9,  9,  8,  8,  8,  8,  8,  7,  7,  7,  7,  6,  6; 2032
		dc.b   6,  6,  5,  5,  5,  4,  4,  4,  4,  3,  3,  3,  2,  2,  2,  1; 2048
		dc.b $10,$10,$10,$10,$10, $F, $F, $E, $E, $E, $D, $D, $C, $C, $B, $B; 2064
		dc.b  $A, $A,  9,  8,  8,  7,  7,  6,  5,  4,  4,  3,  2,  2,  1,  0; 2080
		dc.b $10, $F, $E, $E, $D, $C, $C, $B, $A, $A,  9,  9,  8,  8,  7,  7; 2096
		dc.b   6,  6,  5,  5,  4,  4,  3,  3,  3,  2,  2,  1,  1,  1,  0,  0; 2112
		dc.b $10, $F, $F, $F, $E, $E, $E, $D, $D, $D, $D, $C, $C, $C, $B, $B; 2128
		dc.b  $B, $B, $A, $A, $A, $A,  9,  9,  9,  9,  9,  8,  8,  8,  8,  8; 2144
		dc.b   7,  7,  7,  7,  6,  6,  6,  6,  6,  6,  6,  5,  5,  5,  5,  5; 2160
		dc.b   5,  4,  4,  4,  4,  4,  4,  4,  4,  3,  3,  3,  3,  3,  3,  3; 2176
		dc.b   3,  3,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  1,  1; 2192
		dc.b $F8,$F8,$F8,$F8,$F8,$F8,$F8,$F9,$F9,$F9,$F9,$FA,$FA,$FA,$FB,$FB; 2208
		dc.b $FB,$FC,$FC,$FD,$FD,$FE,$FF,$FF,  0,  0,  0,  0,  0,  0,  0,  0; 2224
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$F1,$F2,$F3,$F4,$F5,$F6,$F7; 2240
		dc.b $F8,$FA,$FB,$FD,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2256
		dc.b $10,$10,$10,$10,$10,$F2,$F5,$F9,  0,  0,  0,  0,  0,  0,  0,  0; 2272
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,  0,  0,  0,  0,  0; 2288
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$F8,$FC,$FE,$FF,$FF; 2304
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$F2,$F4,$F9,  0,  0,  0,  0,  0; 2320
		dc.b $10,$10,$10,$F1,$F1,$F1,$F1,$F2,$F2,$F3,$F3,$F4,$F4,$F5,$F6,$F6; 2336
		dc.b $F7,$F8,$F9,$FA,$FC,$FD,$FE,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2352
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $F; 2368
		dc.b  $C, $D, $E, $F, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 2384
		dc.b   0,  2,  4,  6,  8, $A, $C, $E,$10,$10,$10,$10,$10,$10,$10,$10; 2400
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  4,  6,  8, $A, $C, $E; 2416
		dc.b  $D, $D, $D, $D, $D, $D, $D, $C, $C, $C, $C, $C, $C, $B, $B, $B; 2432
		dc.b   0,  0,  0,  0,  0,  0,  0,  1,  2,  3,  5,  6,  8, $A, $C, $E; 2448
		dc.b  $F, $F, $F, $E, $E, $E, $E, $D, $D, $C, $C, $B, $B, $A,  9,  9; 2464
		dc.b   8,  7,  6,  5,  3,  2,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2480
		dc.b $10,$10,$10,$10,$10,$10,$10, $E, $C,  8,  2,  0,  0,  0,  0,  0; 2496
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,  3,  1,  0,  0,  0; 2512
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,  0,  0,  0,  0,  0,  0,  0,  0; 2528
		dc.b $10,$10,$10,$10,$10,$10, $F, $F, $F, $F, $E, $E, $E, $D, $D, $C; 2544
		dc.b  $C, $B, $A, $A,  9,  8,  7,  6,  5,  4,  2,  1,  0,  0,  0,  0; 2560
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10, $F, $D, $A,  6; 2576
		dc.b $10,$10,$10,$10,$10,$10,$10, $F, $F, $F, $F, $F, $E, $E, $E, $E; 2592
		dc.b  $D, $D, $C, $C, $C, $B, $B, $A,  9,  9,  8,  8,  7,  6,  5,  4; 2608
		dc.b   4,  3,  2,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2624
		dc.b $10,$10,$10,$10, $F, $E, $D, $C, $A,  8,  7,  5,  2,  0,  0,  0; 2640
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10, $C,  7; 2656
		dc.b $F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8,$F9,$F9,$F9,$F9,$F9; 2672
		dc.b $F9,$F9,$F9,$FA,$FA,$FA,$FB,$FB,$FB,$FC,$FC,$FD,$FD,$FE,$FF,$FF; 2688
		dc.b $10,$F1,$F2,$F3,$F4,$F5,$F6,$F7,$F8,$FA,$FB,$FD,$FF,  0,  0,  0; 2704
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$F2,$F5,$F9; 2720
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF; 2736
		dc.b $FF,$FE,$FE,$FE,$FE,$FE,$FE,$FE,$FD,$FD,$FD,$FD,$FC,$FC,$FC,$FC; 2752
		dc.b $FB,$FB,$FB,$FA,$FA,$FA,$F9,$F9,$F8,$F8,$F7,$F7,$F6,$F6,$F5,$F5; 2768
		dc.b $F4,$F4,$F3,$F2,$F2,$F1,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 2784
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,$FF,$FE,$FD,$FC,$FC,$FB,$FA,$F9; 2800
		dc.b $F8,$F7,$F6,$F5,$F3,$F2,$F1,$10,$10,$10,$10,$10,$10,$10,$10,$10; 2816
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,$FE,$FD,$FB,$FA,$F8,$F6,$F4,$F2; 2832
		dc.b   0,$FE,$FB,$F8,$F4,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 2848
		dc.b   0,  0,  0,  0,  0,  0,$F9,$10,$10,$10,$10,$10,$10,$10,$10,$10; 2864
		dc.b  $C, $A,  9,  8,  6,  4,  2,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2880
		dc.b   8,  8,  7,  7,  6,  6,  5,  4,  3,  3,  2,  1,  0,  0,  0,  0; 2896
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10, $F, $E, $D; 2912
		dc.b  $D, $D, $E, $E, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 2928
		dc.b   9,  9, $A, $A, $B, $B, $C, $C, $D, $D, $E, $E, $F, $F, $F, $F; 2944
		dc.b  $F, $F, $F, $F, $F, $E, $E, $D, $D, $C, $B, $A,  9,  7,  5,  0; 2960
		dc.b $10,$10, $F, $F, $E, $E, $D, $D, $D, $C, $B, $A,  9,  7,  5,  0; 2976
		dc.b $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF; 2992
		dc.b $FF,$FF,$FE,$FE,$FE,$FE,$FE,$FE,$FE,$FE,$FE,$FE,$FE,$FE,$FD,$FD; 3008
		dc.b $FD,$FD,$FD,$FD,$FD,$FD,$FD,$FC,$FC,$FC,$FC,$FC,$FC,$FC,$FC,$FB; 3024
		dc.b $FB,$FB,$FB,$FB,$FB,$FA,$FA,$FA,$FA,$FA,$FA,$FA,$F9,$F9,$F9,$F9; 3040
		dc.b $F8,$F8,$F8,$F8,$F8,$F7,$F7,$F7,$F7,$F7,$F6,$F6,$F6,$F6,$F5,$F5; 3056
		dc.b $F5,$F5,$F4,$F4,$F4,$F3,$F3,$F3,$F3,$F2,$F2,$F2,$F1,$F1,$F1,$10; 3072
		dc.b   0,  0,$FF,$FF,$FF,$FE,$FE,$FD,$FD,$FD,$FC,$FC,$FB,$FB,$FA,$FA; 3088
		dc.b $F9,$F9,$F8,$F8,$F7,$F7,$F6,$F6,$F5,$F4,$F4,$F3,$F2,$F2,$F1,$10; 3104
		dc.b   0,$FF,$FE,$FE,$FD,$FC,$FC,$FB,$FA,$F9,$F9,$F8,$F8,$F7,$F6,$F6; 3120
		dc.b $F5,$F5,$F4,$F4,$F3,$F3,$F2,$F2,$F2,$F1,$F1,$10,$10,$10,$10,$10; 3136
		dc.b $FF,$FE,$FE,$FE,$FD,$FD,$FD,$FC,$FC,$FC,$FC,$FB,$FB,$FB,$FA,$FA; 3152
		dc.b $FA,$FA,$F9,$F9,$F9,$F9,$F8,$F8,$F8,$F8,$F8,$F7,$F7,$F7,$F7,$F7; 3168
		dc.b $F6,$F6,$F6,$F6,$F5,$F5,$F5,$F5,$F5,$F5,$F5,$F4,$F4,$F4,$F4,$F4; 3184
		dc.b $F4,$F3,$F3,$F3,$F3,$F3,$F3,$F3,$F3,$F2,$F2,$F2,$F2,$F2,$F2,$F2; 3200
		dc.b $F2,$F2,$F1,$F1,$F1,$F1,$F1,$F1,$F1,$F1,$F1,$F1,$F1,$F1,$10,$10; 3216
		dc.b $F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8,$F7,$F7,$F7,$F7,$F7,$F7,$F7,$F7; 3232
		dc.b $F5,$F5,$F5,$F5,$F4,$F4,$F4,$F4,$F3,$F3,$F3,$F2,$F2,$F2,$F1,$F1; 3248
		dc.b   0,  0,$FF,$FF,$FE,$FE,$FD,$FD,$FC,$FC,$FB,$FA,$FA,$F9,$F8,$F8; 3264
		dc.b $F7,$F6,$F5,$F4,$F4,$F3,$F2,$F1,$10,$10,$10,$10,$10,$10,$10,$10; 3280
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,$FF,$FE,$FD,$FB,$FA,$F9,$F8; 3296
		dc.b $F6,$F5,$F3,$F2,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 3312
		dc.b   0,  0,  0,  0,  0,$FE,$FC,$FA,$F8,$F6,$F3,$10,$10,$10,$10,$10; 3328
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FC,$F8,$F1,$10; 3344
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$F8; 3360
		dc.b $10,$10,$10,$10,$10,$10,$10, $F, $F, $F, $F, $E, $E, $E, $D, $D; 3376
		dc.b  $D, $C, $C, $B, $B, $A,  9,  9,  8,  7,  6,  5,  4,  3,  2,  1; 3392
		dc.b $10, $E, $D, $B,  9,  6,  3,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3408
		dc.b $F7,$F6,$F6,$F6,$F6,$F6,$F6,$F6,$F5,$F5,$F5,$F5,$F4,$F4,$F4,$F4; 3424
		dc.b $F3,$F3,$F3,$F2,$F2,$F2,$F1,$F1,$10,$10,$10,$10,$10,$10,$10,$10; 3440
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FF,$FF,$FE,$FE,$FD,$FD; 3456
		dc.b $FC,$FC,$FB,$FA,$FA,$F9,$F8,$F8,$F7,$F6,$F5,$F4,$F4,$F3,$F2,$F1; 3472
		dc.b   0,$FF,$FE,$FD,$FB,$FA,$F9,$F8,$F6,$F5,$F3,$F2,$10,$10,$10,$10; 3488
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FE,$FC,$FA; 3504
		dc.b $F8,$F6,$F3,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 3520
		dc.b   0,  0,  0,  0,$FC,$F8,$F1,$10,$10,$10,$10,$10,$10,$10,$10,$10; 3536
		dc.b   0,  0,  0,  0,  0,  0,  0,$F8,$10,$10,$10,$10,$10,$10,$10,$10; 3552
		dc.b  $F, $F, $F, $E, $E, $E, $D, $D, $D, $C, $C, $B, $B, $A,  9,  9; 3568
		dc.b   8,  7,  6,  5,  4,  3,  2,  1,  0,  0,  0,  0,  0,  0,  0,  0; 3584
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10, $E, $D, $B,  9,  6,  3,  0; 3600
		dc.b  $B, $B, $B, $A, $A, $A, $A, $A,  9,  9,  9,  9,  9,  8,  8,  8; 3616
		dc.b   8,  8,  7,  7,  7,  7,  6,  6,  6,  6,  5,  5,  5,  5,  4,  4; 3632
		dc.b   4,  4,  3,  3,  3,  2,  2,  2,  1,  1,  1,  0,  0,  0,  0,  0; 3648
		dc.b  $F, $E, $E, $E, $D, $D, $D, $C, $C, $C, $B, $B, $A, $A,  9,  9; 3664
		dc.b   6,  7,  7,  8,  9, $A, $A, $B, $C, $D, $D, $E, $F,$10,$10,$10; 3680
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  2,  3,  4,  4,  5; 3696
		dc.b  $A, $B, $B, $C, $D, $E, $E, $F,$10,$10,$10,$10,$10,$10,$10,$10; 3712
		dc.b   0,  0,  0,  0,  1,  2,  2,  3,  4,  5,  5,  6,  7,  8,  8,  9; 3728
		dc.b  $E, $F, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 3744
		dc.b   2,  3,  3,  4,  5,  6,  6,  7,  8,  9,  9, $A, $B, $C, $C, $D; 3760
		dc.b   7,  7,  7,  8,  8,  8,  9,  9,  9, $A, $A, $A, $B, $B, $C, $C; 3776
		dc.b   3,  4,  6,  7,  9, $A, $C, $D, $F,$10,$10,$10,$10,$10,$10,$10; 3792
		dc.b   5,  6,  7,  7,  8,  8,  9, $A, $A, $B, $C, $C, $D, $D, $E, $F; 3808
		dc.b   6,  7,  7,  7,  8,  8,  8,  9,  9,  9, $A, $A, $A, $A, $B, $B; 3824
		dc.b  $B, $C, $C, $C, $C, $C, $C, $D, $D, $D, $D, $D, $D, $E, $E, $E; 3840
		dc.b  $E, $E, $E, $E, $E, $E, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F; 3856
		dc.b  $E, $A,  6,  2,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3872
		dc.b $10,$10,$10,$10, $E, $A,  6,  2,  0,  0,  0,  0,  0,  0,  0,  0; 3888
		dc.b $10,$10,$10,$10,$10,$10,$10,$10, $E, $A,  6,  2,  0,  0,  0,  0; 3904
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10, $E, $A,  6,  2; 3920
		dc.b  $B, $C, $D, $E, $F, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 3936
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3952
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3968
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3984
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 4000
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4016
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4032
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4048
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4064
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4080
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 4096
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$10; 4112
		dc.b $10,$10, $C,  8,  5,  2,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 4128
		dc.b $10,$10,$10,$10,$10,$10,$10, $E, $C, $A,  8,  6,  4,  3,  1,  0; 4144
		dc.b  $F, $D, $C, $B, $A,  9,  8,  7,  6,  5,  4,  3,  2,  1,  1,  0; 4160
		dc.b  $F, $E, $E, $D, $C, $C, $B, $B, $A, $A,  9,  9,  8,  8,  7,  7; 4176
		dc.b   6,  6,  5,  5,  5,  4,  4,  4,  3,  3,  3,  3,  2,  2,  2,  2; 4192
		dc.b   0,  0,  0,  0,  0,  0,  0,  1,  1,  1,  1,  2,  2,  2,  2,  3; 4208
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,$10,$10,$10,$10,$10,$10,$10,$10; 4224
		dc.b   0,  0,  0,  0,  0,  0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4240
		dc.b   0,  0,  0,  0,  0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4256
		dc.b   0,  0,  0,  0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4272
		dc.b   3,  3,  4,  4,  4,  5,  5,  5,  6,  6,  7,  7,  7,  8,  8,  9; 4288
		dc.b   0,  0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4304
		dc.b   0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4320
		dc.b   0,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4336
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  8,$10; 4352
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  8,$10,$10,$10; 4368
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  8,$10,$10,$10,$10,$10; 4384
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  8,$10,$10,$10,$10,$10,$10,$10; 4400
		dc.b   0,  0,  0,  0,  0,  0,  8,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4416
		dc.b   0,  0,  0,  0,  8,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4432
		dc.b   0,  0,  8,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4448
		dc.b   8,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4464
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  4,  8, $C,$10; 4480
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  4,  8, $C,$10,$10,$10,$10,$10; 4496
		dc.b   0,  0,  0,  0,  4,  8, $C,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4512
		dc.b   4,  8, $C,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4528
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  2,  4,  6,  8, $A, $C, $E,$10; 4544
		dc.b   2,  4,  6,  8, $A, $C, $E,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4560
		dc.b   9,  9, $A, $A, $B, $B, $C, $C, $D, $D, $E, $E, $F, $F,$10,$10; 4576
		dc.b   1,  1,  2,  2,  3,  3,  4,  4,  5,  5,  6,  6,  7,  7,  8,  8; 4592
		dc.b   9, $A, $A, $B, $B, $C, $C, $D, $D, $E, $E, $F,$10,$10,$10,$10; 4608
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1; 4624
		dc.b   2,  3,  3,  4,  5,  5,  6,  7,  8,  8,  9, $A, $B, $C, $C, $D; 4640
		dc.b   1,  1,  1,  1,  2,  2,  2,  2,  3,  3,  3,  3,  4,  4,  4,  4; 4656
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  6,$10; 4672
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  3,  6, $A, $F,$10,$10; 4688
		dc.b   0,  0,  0,  2,  4,  6,  8, $A, $D,$10,$10,$10,$10,$10,$10,$10; 4704
		dc.b  $D, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4720
		dc.b   0,  0,  0,  0,  0,  0,  0,  1,  2,  3,  4,  6,  7,  8, $A, $B; 4736
		dc.b  $A, $B, $B, $C, $D, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4752
		dc.b   0,  0,  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, $A, $B, $C, $E; 4768
		dc.b   0,  0,  1,  3,  4,  5,  7,  8, $A, $B, $D, $F,$10,$10,$10,$10; 4784
		dc.b   5,  5,  5,  6,  6,  6,  7,  7,  7,  8,  8,  9,  9,  9, $A, $A; 4800
		dc.b   8, $A, $C, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4816
		dc.b   2,  2,  2,  2,  3,  3,  3,  3,  3,  3,  4,  4,  4,  4,  5,  5; 4832
		dc.b   5,  5,  5,  6,  6,  6,  6,  7,  7,  7,  7,  8,  8,  8,  9,  9; 4848
		dc.b   0,  0,  0,  0,  0,  1,  2,  2,  3,  4,  5,  5,  6,  7,  8,  9; 4864
		dc.b  $E, $F, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4880
		dc.b   2,  3,  3,  3,  3,  3,  4,  4,  4,  4,  5,  5,  5,  6,  6,  6; 4896
		dc.b  $B, $B, $C, $C, $D, $D, $E, $E, $F,$10,$10,$10,$10,$10,$10,$10; 4912
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  2,  2,  3; 4928
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  3,  5; 4944
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FC; 4960
		dc.b   7,  8, $A, $C, $E,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4976
		dc.b   7,  7,  7,  8,  8,  8,  9,  9, $A, $A, $B, $B, $C, $C, $D, $D; 4992
		dc.b   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  2,  2,  2,  2,  2,  2; 5008
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$F2,$F8; 5024
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$F2,$F4,$F6,$F8,$FB,$FE,  0,  0; 5040
		dc.b $F6,$F7,$F8,$FA,$FB,$FD,$FE,  0,  0,  0,  0,  0,  0,  0,  0,  0; 5056
		dc.b   0,  0,  0,  0,  0,  0,  2,  5,  7, $A, $D,$10,$10,$10,$10,$10; 5072
		dc.b $F2,$F2,$F3,$F3,$F3,$F4,$F4,$F4,$F5,$F5,$F6,$F6,$F7,$F7,$F8,$F8; 5088
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FE; 5104
		dc.b   0,  0,  0,  0,$FF,$FC,$FA,$F8,$F5,$F3,$10,$10,$10,$10,$10,$10; 5120
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FF,$FD,$FB,$F9,$F7; 5136
		dc.b $F5,$F3,$F1,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 5152
		dc.b   0,  0,  0,$FF,$FE,$FC,$FA,$F9,$F7,$F5,$F4,$F2,$F1,$10,$10,$10; 5168
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FF,$FE,$FC; 5184
		dc.b $FB,$F9,$F8,$F6,$F5,$F4,$F2,$F1,$10,$10,$10,$10,$10,$10,$10,$10; 5200
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,$FE,$FD,$FC,$FB,$F9,$F8,$F7; 5216
		dc.b $F6,$F5,$F4,$F2,$F1,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 5232
		dc.b   0,  0,  0,  0,  0,  0,$FF,$FE,$FD,$FC,$FB,$FA,$F9,$F8,$F7,$F6; 5248
		dc.b $F6,$F5,$F5,$F4,$F3,$F2,$F1,$F1,$10,$10,$10,$10,$10,$10,$10,$10; 5264
		dc.b $FF,$FF,$FE,$FE,$FD,$FD,$FC,$FC,$FB,$FB,$FA,$F9,$F9,$F8,$F8,$F7; 5280
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,$FF,$FE,$FE,$FD,$FC,$FB,$FA; 5296
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$F1,$F2; 5312
		dc.b $F5,$F6,$F7,$F8,$F8,$F9,$FA,$FB,$FC,$FD,$FE,$FF,$FF,  0,  0,  0; 5328
		dc.b $FE,$FE,$FE,$FE,$FE,$FE,$FE,$FE,$FE,$FE,$FE,$FE,$FE,$FE,$FE,$FE; 5344
		dc.b  $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E; 5360
		dc.b   1,  2,  3,  4,  5,  6,  7,  8,  9, $A, $B, $C, $D, $E, $F,$10; 5376
		dc.b $F9,$F8,$F7,$F6,$F5,$F4,$F4,$F3,$F2,$F1,$10,$10,$10,$10,$10,$10; 5392
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$F1,$F2,$F3,$F4,$F5; 5408
		dc.b $F9,$F9,$FA,$FB,$FC,$FC,$FD,$FD,$FE,$FF,  0,  0,  0,  0,  0,  0; 5424
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FF,$FE,$FD,$FC,$FB; 5440
		dc.b   0,  4,  8,  8,  8,  8,  8,  8,  7,  7,  7,  7,  6,  6,  6,  6; 5456
		dc.b $FA,$F9,$F8,$F7,$F6,$F5,$F4,$F3,$F2,$F1,$10,$10,$10,$10,$10,$10; 5472
		dc.b  $C,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 5488
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  4,  8; 5504
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  4,  8, $C,$10,$10,$10; 5520
		dc.b   0,  0,  0,  0,  0,  0,  4,  8, $C,$10,$10,$10,$10,$10,$10,$10; 5536
		dc.b   0,  0,  4,  8, $C,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 5552
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FF,$FE,$FC,$FB,$FA; 5568
		dc.b   0,  0,  0,$FF,$FE,$FC,$FB,$F9,$F7,$F6,$F4,$F2,$10,$10,$10,$10; 5584
		dc.b   0,  0,$FD,$FA,$F6,$F3,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 5600
		dc.b   0,  0,  0,  0,  0,  0,$FF,$FA,$F6,$F1,$10,$10,$10,$10,$10,$10; 5616
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FB,$F5,$10,$10,$10,$10; 5632
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FC,$F1,$10,$10; 5648
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$F3,$10; 5664
		dc.b   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1; 5680
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $A; 5696
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  7,$10,$10; 5712
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  3,  9,$10,$10,$10,$10; 5728
		dc.b   0,  0,  0,  0,  0,  0,  0,  4,  9, $E,$10,$10,$10,$10,$10,$10; 5744
		dc.b   0,  0,  2,  5,  8, $C,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 5760
		dc.b  $C, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 5776
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  3,  5,  7,  9; 5792
		dc.b   1,  2,  3,  5,  6,  7,  9, $A, $C, $D, $F,$10,$10,$10,$10,$10; 5808
		dc.b   1,  2,  3,  4,  4,  5,  6,  7,  8,  9, $A, $B, $C, $D, $E, $F; 5824
		dc.b   2,  2,  2,  2,  2,  2,  2,  1,  1,  1,  1,  1,  1,  1,  1,  1; 5840
		dc.b   7,  7,  6,  6,  6,  5,  5,  5,  4,  4,  4,  4,  3,  3,  3,  3; 5856
		dc.b $10,$10, $F, $E, $E, $D, $C, $C, $B, $B, $A, $A,  9,  9,  8,  8; 5872
		dc.b $10, $F, $E, $D, $B, $A,  9,  8,  7,  6,  5,  4,  4,  3,  2,  1; 5888
		dc.b $10,$10,$10,$10,$10,$10,$10,$10, $E, $C, $A,  8,  6,  5,  3,  2; 5904
		dc.b $10,$10,$10, $C,  8,  5,  2,  0,  0,  0,  0,  0,  0,  0,  0,  0; 5920
		dc.b $10,  7,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 5936
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FF,$FC,$F9,$F6; 5952
		dc.b $10,$10,$10,$10,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 5968
		dc.b $10,$10,$10,$10,  7,  6,  5,  4,  4,  4,  4,  4,  4,  4,  4,  4; 5984
		dc.b   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4; 6000
		dc.b $F2,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 6016
		dc.b   0,$FA,$F1,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 6032
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  2,  3,  3,  4,  5,  5; 6048
		dc.b   6,  7,  7,  8,  9,  9, $A, $B, $B, $C, $D, $D, $E, $F, $F,$10; 6064
		dc.b $FE,$F2,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 6080
		dc.b   0,  0,$F9,$F1,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 6096
		dc.b   0,  0,  0,  0,$FB,$F4,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 6112
		dc.b   0,  0,  0,  0,  0,  0,  0,$FB,$F6,$F2,$10,$10,$10,$10,$10,$10; 6128
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FE,$FB,$F7,$F4,$F1,$10; 6144
		dc.b $FB,$F9,$F6,$F4,$F2,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 6160
		dc.b   0,  0,  0,  0,  0,  0,$FE,$FD,$FB,$F9,$F8,$F7,$F5,$F4,$F2,$F1; 6176
		dc.b $FF,$FE,$FC,$FB,$F9,$F8,$F6,$F4,$F2,$10,$10,$10,$10,$10,$10,$10; 6192
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FE,$FC,$FA,$F7,$F5,$F2; 6208
		dc.b $FF,$FC,$F9,$F5,$F2,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 6224
		dc.b   0,  0,  0,  0,  0,$FE,$FA,$F5,$10,$10,$10,$10,$10,$10,$10,$10; 6240
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,$FC,$F5,$10,$10,$10,$10,$10; 6256
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FF,$F7,$10,$10,$10; 6272
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FE,$F2,$10; 6288
		dc.b $10,$10,$10,$10,$10,$F2,$F5,$F9,  0,  0,  0,  0,  0,  0,  0,  0; 6304
		dc.b $F8,$FA,$FB,$FD,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 6320
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$F1,$F2,$F3,$F4,$F5,$F6,$F7; 6336
		dc.b $FB,$FC,$FC,$FD,$FD,$FE,$FF,$FF,  0,  0,  0,  0,  0,  0,  0,  0; 6352
		dc.b $F8,$F8,$F8,$F8,$F8,$F8,$F8,$F9,$F9,$F9,$F9,$FA,$FA,$FA,$FB,$FB; 6368
		dc.b $F5,$F5,$F5,$F5,$F5,$F5,$F5,$F5,$F5,$F5,$F5,$F5,$F5,$F5,$F5,$F5; 6384
		dc.b $10,$F2,$F3,$F3,$F4,$F4,$F4,$F4,$F5,$F5,$F5,$F5,$F5,$F5,$F5,$F5; 6400
		dc.b $F5,$F5,$F5,$F5,$F5,$F5,$F5,$F6,$F6,$F6,$F6,$F6,$F7,$F7,$F8,$F8; 6416
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$F2,$F3,$F5,$F7,$F9,$FD; 6432
		dc.b $F9,$F9,$FA,$FB,$FC,$FC,$FD,$FE,$FF,  0,  0,  0,  0,  0,  0,  0; 6448
		dc.b   0,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1; 6464
		dc.b  $B, $D, $E, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 6480
		dc.b   8,  8,  9,  9, $A, $A, $B, $B, $C, $C, $D, $D, $E, $E, $F, $F; 6496
		dc.b   0,  0,  1,  1,  2,  2,  3,  3,  4,  4,  5,  5,  6,  6,  7,  7; 6512
		dc.b   0,  0,  0,$F9,$F3,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 6528
		dc.b   0,  0,  1,  1,  2,  2,  3,  3,  4,  4,  5,  6,  6,  7,  8,  9; 6544
		dc.b   0,$FD,$F9,$F7,$F5,$F3,$F2,$10,$10,$10,$10,$10,$10,$10,$10,$10; 6560
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,$FF,$FE,$FD,$FC,$FC,$FB,$FA,$FA; 6576
		dc.b $F9,$F9,$F8,$F8,$F7,$F7,$F7,$F7,$F6,$F6,$F6,$F6,$F6,$F6,$F5,$F5; 6592
		dc.b $F5,$F5,$F5,$F5,$F5,$F5,$F5,$F5,$F5,$F5,$F5,$F5,$F5,$F4,$F4,$F3; 6608
		dc.b $F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8; 6624
		dc.b $FA,$F6,$F3,$F1,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 6640
		dc.b   0,  0,  0,  0,$FF,$FE,$FC,$FB,$FA,$F9,$F8,$F7,$F6,$F6,$F5,$F4; 6656
		dc.b $F4,$F3,$F3,$F2,$F2,$F2,$F1,$F1,$F1,$F1,$10,$10,$10,$10,$10,$10; 6672
		dc.b $F9,$F4,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 6688
		dc.b   0,  0,  0,$FE,$FB,$F9,$F8,$F6,$F4,$F3,$F2,$F1,$10,$10,$10,$10; 6704
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FF,$FE,$FD,$FD; 6720
		dc.b $FC,$FB,$FA,$F9,$F8,$F8,$F7,$F7,$F6,$F5,$F5,$F4,$F4,$F4,$F3,$F3; 6736
		dc.b $F2,$F2,$F2,$F2,$F1,$F1,$F1,$F1,$F1,$10,$10,$10,$10,$10,$10,$10; 6752
		dc.b $10,$10,$10,$10,$10,$10,$10,$F5,  0,  0,  0,  0,  0,  0,  0,  0; 6768
		dc.b $10,$F2,$F3,$F5,$F7,$FA,$FD,  0,  0,  0,  0,  0,  0,  0,  0,  0; 6784
		dc.b $F3,$F4,$F4,$F5,$F5,$F6,$F7,$F7,$F8,$F9,$FA,$FB,$FC,$FD,$FE,$FF; 6800
		dc.b $10,$10,$10,$10,$10,$10,$10,$F1,$F1,$F1,$F1,$F2,$F2,$F2,$F3,$F3; 6816
		dc.b   8,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 6832
		dc.b $10, $F,  8,  4,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 6848
		dc.b $10,$10,$10,$10,$10, $D, $A,  8,  6,  4,  2,  0,  0,  0,  0,  0; 6864
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10, $E, $D, $B, $A; 6880
		dc.b   8,  7,  6,  5,  3,  2,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0; 6896
		dc.b $10,$10,$10,$10,$10,$10,$10,$10, $F, $E, $D, $C, $C, $B, $A,  9; 6912
		dc.b   8,  8,  7,  6,  6,  5,  4,  4,  3,  3,  2,  2,  1,  1,  0,  0; 6928
		dc.b  $F, $F, $E, $E, $E, $D, $D, $D, $C, $C, $C, $C, $B, $B, $B, $B; 6944
		dc.b  $A, $A, $A, $A, $A, $A, $A,  9,  9,  9,  9,  9,  9,  9,  9,  9; 6960
		dc.b   0,  0,  0,  0,$FF,$FF,$FE,$FD,$FC,$FC,$FB,$FB,$FA,$FA,$F9,$F9; 6976
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,$FE,$FC,$FA,$F9,$F8,$F6,$F5,$F4; 6992
		dc.b $F3,$F2,$F1,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 7008
		dc.b  $B, $C, $E,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 7024
		dc.b   0,  4,  6,  8, $A, $C, $E,$10,$10,$10,$10,$10,$10,$10,$10,$10; 7040
		dc.b   0,$FB,$F9,$F7,$F6,$F5,$F4,$F3,$F3,$F2,$F2,$F1,$F1,$F1,$F1,$F1; 7056
		dc.b $FE,$FC,$FA,$F7,$F6,$F5,$F4,$F3,$F3,$F2,$F2,$F1,$F1,$F1,$F1,$F1; 7072
		dc.b $10,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 7088
		dc.b $10, $E,  2,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 7104
		dc.b $10,$10,$10,  9,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 7120
		dc.b $10,$10,$10,$10,$10, $B,  4,  0,  0,  0,  0,  0,  0,  0,  0,  0; 7136
		dc.b $10,$10,$10,$10,$10,$10,$10,$10, $B,  6,  2,  0,  0,  0,  0,  0; 7152
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10, $E, $B,  7,  4,  1; 7168
		dc.b  $E, $B,  9,  6,  4,  2,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 7184
		dc.b $10,$10,$10,$10,$10,$10,$10, $E, $C, $A,  8,  7,  5,  4,  2,  1; 7200
		dc.b  $F, $E, $C, $B,  9,  8,  7,  5,  3,  2,  0,  0,  0,  0,  0,  0; 7216
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10, $E, $C, $A,  7,  5; 7232
		dc.b $10, $F, $C,  9,  5,  2,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 7248
		dc.b $10,$10,$10,$10,$10,$10, $E, $A,  5,  0,  0,  0,  0,  0,  0,  0; 7264
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10, $C,  5,  0,  0,  0,  0; 7280
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10, $F,  7,  0,  0; 7296
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10, $E,  2; 7312
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,  8,  0,  0,  0,  0,  0,  0,  0; 7328
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10, $C,  8,  5,  2,  0; 7344
		dc.b  $E, $C, $A,  8,  6,  5,  3,  2,  0,  0,  0,  0,  0,  0,  0,  0; 7360
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10, $F, $E, $D, $B, $A,  9,  8; 7376
		dc.b   7,  6,  5,  4,  4,  3,  2,  1,  0,  0,  0,  0,  0,  0,  0,  0; 7392
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10, $F, $E, $E, $D, $C, $C; 7408
		dc.b  $B, $B, $A, $A,  9,  9,  8,  8,  7,  7,  6,  6,  6,  5,  5,  5; 7424
		dc.b   4,  4,  4,  4,  3,  3,  3,  3,  2,  2,  2,  2,  2,  2,  2,  1; 7440
		dc.b   1,  1,  1,  1,  1,  1,  1,  1,  0,  0,  0,  0,  0,  0,  0,  0; 7456
		dc.b $F9,$F5,$F2,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 7472
		dc.b   0,  0,  0,$FF,$FD,$FB,$FA,$F8,$F7,$F6,$F5,$F4,$F3,$F2,$F1,$10; 7488
		dc.b $FF,$FF,$FE,$FD,$FD,$FC,$FC,$FB,$FB,$FB,$FA,$FA,$FA,$F9,$F9,$F9; 7504
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10, $F,  8,  4,  0,  0,  0,  0; 7520
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10, $D, $A,  8; 7536
		dc.b   6,  4,  2,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 7552
		dc.b $10,$10,$10,$10, $E, $D, $B, $A,  8,  7,  6,  5,  3,  2,  1,  0; 7568
		dc.b  $F, $E, $D, $C, $C, $B, $A,  9,  8,  8,  7,  6,  6,  5,  4,  4; 7584
		dc.b   3,  3,  2,  2,  1,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 7600
		dc.b $10,$10,$10,$10,$10,$10,$10,$10, $F, $F, $E, $E, $E, $D, $D, $D; 7616
		dc.b  $C, $C, $C, $C, $B, $B, $B, $B, $A, $A, $A, $A, $A, $A, $A,  9; 7632
		dc.b   9,  9,  9,  9,  9,  9,  9,  9,  8,  8,  8,  8,  8,  8,  8,  8; 7648
		dc.b   0,$FD,$FA,$F7,$F5,$F3,$F2,$10,$10,$10,$10,$10,$10,$10,$10,$10; 7664
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,$FF,$FE,$FD,$FC,$FB,$FA,$F9,$F8; 7680
		dc.b $F7,$F7,$F6,$F5,$F5,$F4,$F4,$F3,$F3,$F3,$F2,$F2,$F2,$F1,$F1,$F1; 7696
		dc.b   0,  0,  0,  0,  0,$FD,$F8,$F3,$10,$10,$10,$10,$10,$10,$10,$10; 7712
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,$FE,$FA,$F6,$F2,$10,$10,$10,$10; 7728
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FE,$FB,$F8,$F5; 7744
		dc.b   0,$FF,$FC,$F9,$F6,$F4,$F2,$10,$10,$10,$10,$10,$10,$10,$10,$10; 7760
		dc.b   3,  4,  5,  7,  8,  9, $B, $C, $D, $F,$10,$10,$10,$10,$10,$10; 7776
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  3,  4,  5,  7; 7792
		dc.b   8,  9, $B, $C, $D, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 7808
		dc.b   0,  0,  0,  0,  0,  0,  0,  1,  3,  4,  5,  7,  8,  9, $B, $C; 7824
		dc.b  $D, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 7840
		dc.b   0,  0,  0,  1,  3,  4,  5,  7,  8,  9, $B, $C, $D, $F,$10,$10; 7856
		dc.b   0,  0,  0,  0,  2,  4,  7, $A, $D,$10,$10,$10,$10,$10,$10,$10; 7872
		dc.b   7,  8,  8,  9, $A, $A, $B, $C, $C, $D, $E, $E, $F,$10,$10,$10; 7888
		dc.b   0,  1,  2,  4,  6,  7,  9, $A, $C, $E, $F,$10,$10,$10,$10,$10; 7904
		dc.b   0,  0,  0,  0,  0,  2,  6,  9, $C, $F,$10,$10,$10,$10,$10,$10; 7920
		dc.b   0,  0,  3,  9, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 7936
		dc.b   0, $A,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 7952
		dc.b   0,  0,$FF,$FF,$FF,$FF,$FE,$FE,$FE,$FE,$FD,$FD,$FD,$FD,$FC,$FC; 7968
		dc.b $FC,$FC,$FB,$FB,$FB,$FB,$FA,$FA,$FA,$FA,$F9,$F9,$F9,$F9,$F8,$F8; 7984
		dc.b $F8,$F8,$F7,$F7,$F7,$F7,$F6,$F6,$F6,$F6,$F5,$F5,$F5,$F5,$F4,$F4; 8000
		dc.b $F4,$F4,$F3,$F3,$F3,$F3,$F2,$F2,$F2,$F2,$F1,$F1,$F1,$F1,$10,$10; 8016
		dc.b  $A, $C, $D, $E, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 8032
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 8048
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 8064
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 8080
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 8096
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 8112
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 8128
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 8144
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 8160
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 8176

ColArray1:	dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 0
		dc.b   8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8; 16
		dc.b   1,  2,  3,  4,  5,  6,  7,  8,  9, $A, $B, $C, $D, $E, $F,$10; 32
		dc.b   2,  4,  6,  8, $A, $C, $E,$10,$10,$10,$10,$10,$10,$10,$10,$10; 48
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  2,  4,  6,  8, $A, $C, $E,$10; 64
		dc.b   4,  8, $C,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 80
		dc.b   0,  0,  0,  0,  4,  8, $C,$10,$10,$10,$10,$10,$10,$10,$10,$10; 96
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  4,  8, $C,$10,$10,$10,$10,$10; 112
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  4,  8, $C,$10; 128
		dc.b   1,  1,  2,  2,  3,  3,  4,  4,  5,  5,  6,  6,  7,  7,  8,  8; 144
		dc.b   9,  9, $A, $A, $B, $B, $C, $C, $D, $D, $E, $E, $F, $F,$10,$10; 160
		dc.b   1,  1,  1,  1,  2,  2,  2,  2,  3,  3,  3,  3,  4,  4,  4,  4; 176
		dc.b   5,  5,  5,  5,  6,  6,  6,  6,  7,  7,  7,  7,  8,  8,  8,  8; 192
		dc.b   9,  9,  9,  9, $A, $A, $A, $A, $B, $B, $B, $B, $C, $C, $C, $C; 208
		dc.b  $D, $D, $D, $D, $E, $E, $E, $E, $F, $F, $F, $F,$10,$10,$10,$10; 224
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,  0,  0,  0,  0,  0,  0,  0,  0; 240
		dc.b   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  2,  2,  2,  2; 256
		dc.b   2,  2,  2,  2,  3,  3,  3,  3,  3,  3,  4,  4,  4,  4,  5,  5; 272
		dc.b   5,  5,  6,  6,  6,  6,  7,  7,  7,  8,  8,  8,  9,  9, $A, $A; 288
		dc.b  $A, $B, $B, $C, $C, $D, $D, $D, $E, $E, $F, $F,$10,$10,$10,$10; 304
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  2; 320
		dc.b   2,  3,  3,  4,  5,  5,  6,  7,  7,  8,  9,  9, $A, $B, $C, $C; 336
		dc.b  $D, $E, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 352
		dc.b   0,  0,  0,  0,  1,  1,  2,  3,  4,  5,  6,  7,  8,  9, $A, $C; 368
		dc.b   2,  4,  6,  8, $A, $C, $E,$10,$10, $E, $C, $A,  8,  6,  4,  2; 384
		dc.b   0,  0,  0,  0,  2,  3,  4,  6,  7,  9, $A, $C, $D, $F,$10,$10; 400
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  3; 416
		dc.b   4,  6,  8, $B, $D, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 432
		dc.b   0,  0,  0,  0,  0,  0,  2,  4,  7, $A, $E,$10,$10,$10,$10,$10; 448
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  6, $C,$10,$10; 464
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  4,$10; 480
		dc.b   1,  1,  1,  1,  1,  1,  1,  1,  2,  2,  2,  2,  2,  2,  3,  3; 496
		dc.b   3,  3,  4,  4,  4,  5,  5,  5,  6,  6,  7,  7,  8,  8,  9,  9; 512
		dc.b  $A, $A, $B, $C, $C, $D, $E, $E, $F,$10,$10,$10,$10,$10,$10,$10; 528
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  2,  3,  4,  5,  6; 544
		dc.b   7,  8, $A, $B, $D, $E,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 560
		dc.b   0,  0,  0,  0,  0,  0,  0,  2,  4,  6,  8, $B, $E,$10,$10,$10; 576
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  8,$10; 592
		dc.b   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  2,  2,  2; 608
		dc.b   2,  2,  2,  2,  2,  2,  3,  3,  3,  3,  3,  3,  3,  4,  4,  4; 624
		dc.b   4,  4,  5,  5,  5,  5,  6,  6,  6,  6,  7,  7,  7,  7,  8,  8; 640
		dc.b   8,  9,  9,  9, $A, $A, $A, $B, $B, $C, $C, $C, $D, $D, $E, $E; 656
		dc.b  $E, $F, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 672
		dc.b   0,  0,  0,  0,  0,  1,  1,  2,  2,  3,  3,  4,  4,  5,  5,  6; 688
		dc.b   7,  7,  8,  8,  9, $A, $A, $B, $B, $C, $D, $E, $E, $F,$10,$10; 704
		dc.b   1,  2,  3,  3,  4,  5,  6,  7,  8,  8,  9, $A, $B, $C, $D, $E; 720
		dc.b  $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 736
		dc.b   0,  0,  1,  2,  3,  4,  5,  6,  8,  9, $A, $B, $C, $E, $F,$10; 752
		dc.b   1,  2,  4,  5,  6,  7,  8, $A, $B, $C, $D, $E, $F,$10,$10,$10; 768
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  2; 784
		dc.b   3,  4,  5,  6,  7,  8,  9,  9, $A, $B, $C, $D, $E, $E, $F,$10; 800
		dc.b   1,  1,  2,  3,  3,  4,  5,  6,  6,  7,  7,  8,  9,  9, $A, $A; 816
		dc.b  $B, $C, $C, $D, $D, $E, $E, $F, $F,$10,$10,$10,$10,$10,$10,$10; 832
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  2,  2,  3; 848
		dc.b   3,  3,  4,  4,  5,  5,  5,  6,  6,  7,  7,  7,  8,  8,  8,  9; 864
		dc.b   9,  9, $A, $A, $A, $A, $B, $B, $B, $B, $C, $C, $C, $C, $D, $D; 880
		dc.b  $D, $D, $D, $E, $E, $E, $E, $E, $E, $E, $F, $F, $F, $F, $F, $F; 896
		dc.b  $F, $F, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 912
		dc.b   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1; 928
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  3,  3,  3,  3; 944
		dc.b   3,  3,  3,  3,  3,  4,  4,  4,  4,  4,  4,  4,  5,  5,  5,  5; 960
		dc.b   5,  6,  6,  6,  6,  6,  6,  7,  7,  7,  7,  8,  8,  8,  8,  8; 976
		dc.b   9,  9,  9,  9, $A, $A, $A, $A, $B, $B, $B, $C, $C, $C, $C, $D; 992
		dc.b  $D, $D, $E, $E, $E, $F, $F, $F,$10,$10,$10,$10,$10,$10,$10,$10; 1008
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  1,  2,  2; 1024
		dc.b   2,  3,  3,  4,  4,  4,  5,  5,  5,  6,  6,  7,  7,  8,  8,  8; 1040
		dc.b   9,  9,  9, $A, $A, $B, $B, $C, $C, $C, $D, $D, $D, $E, $E, $F; 1056
		dc.b  $F, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1072
		dc.b   0,  0,  0,  0,  0,  1,  1,  1,  2,  2,  2,  3,  3,  3,  4,  4; 1088
		dc.b   4,  5,  5,  5,  5,  6,  6,  6,  7,  7,  7,  7,  8,  8,  8,  8; 1104
		dc.b   9,  9,  9,  9,  9, $A, $A, $A, $A, $B, $B, $B, $B, $B, $B, $C; 1120
		dc.b  $C, $C, $C, $C, $D, $D, $D, $D, $D, $D, $D, $E, $E, $E, $E, $E; 1136
		dc.b  $E, $E, $E, $E, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F; 1152
		dc.b   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  2,  2,  2,  2,  2,  2; 1168
		dc.b   2,  3,  3,  3,  3,  3,  4,  4,  4,  4,  5,  5,  5,  6,  6,  6; 1184
		dc.b   7,  7,  7,  8,  8,  8,  9,  9, $A, $A, $B, $B, $C, $C, $D, $D; 1200
		dc.b   0,  0,  0,  0,  0,  1,  2,  2,  3,  4,  5,  5,  6,  7,  8,  9; 1216
		dc.b  $A, $B, $B, $C, $D, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1232
		dc.b   0,  0,  0,  0,  0,  0,  0,  1,  2,  3,  4,  6,  7,  8, $A, $B; 1248
		dc.b  $D, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1264
		dc.b   0,  0,  0,  2,  4,  6,  8, $A, $D,$10,$10,$10,$10,$10,$10,$10; 1280
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  3,  6, $A, $F,$10,$10; 1296
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  6,$10; 1312
		dc.b   1,  1,  1,  1,  1,  1,  2,  2,  2,  2,  3,  3,  3,  4,  4,  5; 1328
		dc.b   5,  6,  7,  7,  8,  9, $A, $B, $C, $E, $F,$10,$10,$10,$10,$10; 1344
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  3,  6, $A,$10; 1360
		dc.b   8, $E,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1376
		dc.b   0,  0,  2,  5,  8, $A, $C, $E,$10,$10,$10,$10,$10,$10,$10,$10; 1392
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  3,  5,  6,  8,  9, $A; 1408
		dc.b  $B, $C, $D, $E, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1424
		dc.b   0,  0,  0,  0,  0,  0,  1,  2,  3,  3,  4,  5,  5,  6,  7,  7; 1440
		dc.b   8,  8,  9,  9, $A, $A, $B, $B, $C, $C, $C, $D, $D, $D, $E, $E; 1456
		dc.b  $E, $E, $F, $F, $F, $F, $F, $F,$10,$10,$10,$10,$10,$10,$10,$10; 1472
		dc.b  $C,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1488
		dc.b   0,  4, $A, $E,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1504
		dc.b   0,  0,  0,  0,  2,  6,  9, $C, $E,$10,$10,$10,$10,$10,$10,$10; 1520
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  3,  5,  8, $A, $C, $D; 1536
		dc.b   0,  1,  3,  4,  6,  7,  9, $A, $C, $D, $E,$10,$10,$10,$10,$10; 1552
		dc.b   6,  7,  8,  9, $A, $B, $C, $D, $E, $F,$10,$10,$10,$10,$10,$10; 1568
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  2,  3,  4; 1584
		dc.b   5,  5,  6,  7,  8,  8,  9, $A, $A, $B, $C, $C, $D, $E, $E, $F; 1600
		dc.b   0,  0,  0,  1,  2,  2,  3,  3,  4,  4,  4,  5,  5,  6,  6,  7; 1616
		dc.b   7,  7,  8,  8,  9,  9,  9, $A, $A, $A, $B, $B, $B, $B, $C, $C; 1632
		dc.b  $C, $C, $D, $D, $D, $D, $E, $E, $E, $E, $E, $E, $F, $F, $F, $F; 1648
		dc.b  $F, $F, $F, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1664
		dc.b   6, $A, $D, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1680
		dc.b   0,  0,  0,  0,  1,  2,  4,  5,  6,  7,  8,  9, $A, $A, $B, $C; 1696
		dc.b  $C, $D, $D, $E, $E, $E, $F, $F, $F, $F,$10,$10,$10,$10,$10,$10; 1712
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  1,  1,  1,  1; 1728
		dc.b   1,  2,  2,  2,  2,  2,  3,  3,  3,  3,  4,  4,  4,  4,  5,  5; 1744
		dc.b   5,  6,  6,  7,  7,  7,  8,  8,  9,  9, $A, $A, $B, $B, $C, $C; 1760
		dc.b  $D, $D, $E, $F, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1776
		dc.b   0,  0,  0,  0,  0,  0,  1,  1,  2,  3,  3,  4,  5,  6,  7,  7; 1792
		dc.b   8,  9, $A, $B, $C, $D, $E, $F,$10,$10,$10,$10,$10,$10,$10,$10; 1808
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  3,  4,  5,  7,  8, $A; 1824
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  6; 1840
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  6, $A, $F,$10; 1856
		dc.b   0,  0,  0,  0,  2,  4,  6,  8, $A, $D, $F,$10,$10,$10,$10,$10; 1872
		dc.b  $B, $D, $E,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1888
		dc.b $10,$10, $F, $E, $E, $D, $C, $B, $B, $A, $A,  9,  8,  8,  7,  7; 1904
		dc.b   6,  5,  5,  4,  4,  3,  3,  2,  2,  1,  1,  0,  0,  0,  0,  0; 1920
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10, $F, $F, $E; 1936
		dc.b $10, $F, $E, $E, $D, $C, $B, $A,  9,  9,  8,  7,  6,  5,  4,  3; 1952
		dc.b   2,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1968
		dc.b $10,$10,$10, $F, $E, $D, $C, $B, $A,  8,  7,  6,  5,  4,  2,  1; 1984
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10, $F; 2000
		dc.b  $E, $D, $C, $B, $A,  9,  8,  8,  7,  6,  5,  4,  3,  3,  2,  1; 2016
		dc.b $10, $F, $E, $C, $B, $A,  9,  8,  6,  5,  4,  3,  2,  1,  0,  0; 2032
		dc.b   0,  0,  0,  2,  5,  7,  9, $A, $C, $E, $F,$10,$10,$10,$10,$10; 2048
		dc.b   8, $C,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 2064
		dc.b   5,  6,  7,  7,  8,  8,  9, $A, $A, $B, $B, $C, $C, $C, $D, $D; 2080
		dc.b  $E, $E, $E, $E, $F, $F, $F, $F,$10,$10,$10,$10,$10,$10,$10,$10; 2096
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  1,  1,  1,  1,  1,  1; 2112
		dc.b   2,  2,  2,  2,  3,  3,  3,  3,  4,  4,  4,  5,  5,  5,  6,  6; 2128
		dc.b   7,  7,  8,  8,  8,  9, $A, $A, $B, $B, $C, $C, $D, $E, $E, $F; 2144
		dc.b   0,  1,  1,  2,  3,  4,  5,  6,  7,  8,  9, $A, $B, $C, $D, $F; 2160
		dc.b   0,  1,  3,  4,  6,  8, $A, $B, $E,$10,$10,$10,$10,$10,$10,$10; 2176
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  5,  8, $C,$10,$10; 2192
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  8; 2208
		dc.b   4,  7,  9, $A, $B, $C, $D, $E, $E, $F, $F, $F,$10,$10,$10,$10; 2224
		dc.b   2,  3,  4,  5,  6,  7,  8,  8,  9, $A, $B, $C, $D, $D, $F,$10; 2240
		dc.b   0,  1,  2,  4,  5,  6,  7,  8, $A, $B, $C, $D, $E, $F,$10,$10; 2256
		dc.b   0,  0,  0,  0,  0,  0,  0,  2,  4,  5,  7,  9, $A, $B, $D, $E; 2272
		dc.b   5,  7,  9, $B, $D, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 2288
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  1,  4,  7,  9, $C, $E,$10,$10; 2304
		dc.b   0,  0,  0,  0,  2,  6, $A, $E,$10,$10,$10,$10,$10,$10,$10,$10; 2320
		dc.b   0,  0,  6, $D,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 2336
		dc.b   0, $D,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 2352
		dc.b  $E, $E, $E, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F; 2368
		dc.b  $C, $C, $C, $D, $D, $D, $D, $D, $D, $D, $E, $E, $E, $E, $E, $E; 2384
		dc.b   8,  8,  9,  9,  9,  9, $A, $A, $A, $A, $B, $B, $B, $B, $C, $C; 2400
		dc.b   2,  2,  3,  3,  4,  4,  4,  5,  5,  6,  6,  6,  7,  7,  7,  8; 2416
		dc.b  $A, $B, $B, $C, $C, $D, $D, $E, $E, $F, $F,$10,$10,$10,$10,$10; 2432
		dc.b   0,  0,  1,  2,  2,  3,  4,  5,  5,  6,  6,  7,  8,  9,  9,  9; 2448
		dc.b   2,  3,  4,  5,  6,  7,  8,  8,  9, $A, $B, $C, $D, $D, $E, $F; 2464
		dc.b  $B, $B, $C, $C, $D, $D, $E, $E, $F, $F, $F, $F,$10,$10,$10,$10; 2480
		dc.b   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, $A, $B, $C, $D, $E, $F; 2496
		dc.b   0,  1,  2,  3,  4,  5,  7,  8,  9, $A, $B, $C, $D, $E, $F,$10; 2512
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  3,  5,  8, $A, $B, $D; 2528
		dc.b  $D, $E, $E, $E, $E, $E, $F, $F, $F, $F, $F, $F,$10,$10,$10,$10; 2544
		dc.b   1,  2,  3,  3,  4,  5,  5,  6,  6,  7,  7,  8,  8,  8,  9,  9; 2560
		dc.b   0,  1,  3,  4,  6,  7,  8,  9, $A, $B, $C, $D, $E, $F, $F,$10; 2576
		dc.b   7,  7,  7,  8,  8,  9,  9,  9, $A, $A, $A, $B, $B, $B, $C, $C; 2592
		dc.b   1,  1,  2,  2,  2,  3,  3,  4,  4,  4,  5,  5,  5,  6,  6,  6; 2608
		dc.b  $C, $C, $C, $C, $C, $C, $C, $C, $C, $C, $C, $C, $C, $C, $C, $C; 2624
		dc.b  $B, $B, $B, $B, $B, $B, $B, $B, $B, $B, $B, $B, $B, $B, $B, $B; 2640
		dc.b  $A, $A, $A, $A, $A, $A, $A, $A, $A, $A, $A, $A, $A, $A, $A, $A; 2656
		dc.b  $A, $A, $A, $A, $A, $A, $A, $A, $B, $B, $B, $B, $B, $B, $B, $B; 2672
		dc.b   8,  8,  8,  8,  8,  8,  8,  8,  9,  9,  9,  9,  9,  9,  9,  9; 2688
		dc.b  $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E, $E; 2704
		dc.b   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4; 2720
		dc.b  $F, $F, $F, $F, $F, $F, $F, $F,$10,$10,$10,$10,$10,$10,$10,$10; 2736
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  1,  2,  2,  3,  3,  4; 2752
		dc.b   4,  5,  5,  6,  6,  7,  7,  8,  8,  9,  9, $A, $A, $B, $B, $B; 2768
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$10,$10; 2784
		dc.b   7,  8,  9, $A, $B, $C, $D, $E,$10,$10,$10,$10,$10,$10,$10,$10; 2800
		dc.b   9, $A, $B, $B, $C, $D, $E, $F,$10,$10,$10,$10,$10,$10,$10,$10; 2816
		dc.b   3,  3,  3,  4,  4,  4,  5,  5,  6,  6,  6,  7,  7,  7,  8,  8; 2832
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  1,  2,  2,  2; 2848
		dc.b   5,  5,  6,  6,  7,  7,  8,  8,  9,  9, $A, $A, $B, $B, $C, $C; 2864
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  2,  2,  3,  3,  4,  4; 2880
		dc.b  $D, $D, $E, $E, $F, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 2896
		dc.b   5,  6,  6,  7,  8,  9,  9, $A, $B, $C, $C, $D, $E, $F, $F,$10; 2912
		dc.b  $D, $D, $D, $D, $D, $D, $D, $D, $E, $E, $E, $E, $E, $E, $E, $E; 2928
		dc.b   7,  7,  7,  8,  8,  8,  9,  9, $A, $A, $B, $B, $C, $C, $C, $C; 2944
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  3,  3,  3,  4,  4,  5; 2960
		dc.b   0,  0,  0,  0,  0,  0,  1,  2,  3,  3,  4,  4,  5,  6,  7,  7; 2976
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  3,  5,  7,  8,  9, $A; 2992
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,  0,  0; 3008
		dc.b   0,  0,  0,  0,  0,  1,  2,  3,  5,  6,  7,  8,  9, $A, $B, $D; 3024
		dc.b  $E, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 3040
		dc.b  $C, $D, $D, $D, $E, $E, $E, $F, $F, $F,$10,$10,$10,$10,$10,$10; 3056
		dc.b  $D, $D, $E, $E, $F, $F, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10; 3072
		dc.b   2,  2,  3,  3,  3,  4,  4,  4,  5,  5,  5,  6,  6,  6,  7,  7; 3088
		dc.b   8,  8,  8,  9,  9,  9, $A, $A, $A, $B, $B, $B, $C, $C, $C, $D; 3104
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  3,  5,  6,  8, $A, $B; 3120
		dc.b   0,  0,  0,  2,  4,  6,  8, $A, $C, $C, $C, $C, $C, $C, $C, $C; 3136
		dc.b $10, $F, $E, $D, $C, $B, $A,  9,  8,  7,  6,  5,  4,  3,  2,  1; 3152
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  1,  2,  3,  4,  5,  6,  7,  8; 3168
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3184
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3200
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3216
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3232
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3248
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3264
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3280
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3296
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3312
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3328
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3344
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3360
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3376
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3392
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3408
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3424
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3440
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3456
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3472
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3488
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3504
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3520
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3536
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3552
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3568
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3584
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3600
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3616
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3632
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3648
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3664
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3680
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3696
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3712
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3728
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3744
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3760
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3776
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3792
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3808
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3824
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3840
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3856
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3872
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3888
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3904
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3920
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3936
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3952
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3968
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3984
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 4000
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4016
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4032
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4048
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4064
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4080

ColArray2:	dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 0
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,$10,$10,$10,$10,$10,$10,$10,$10; 16
		dc.b   1,  2,  3,  4,  5,  6,  7,  8,  9, $A, $B, $C, $D, $E, $F,$10; 32
		dc.b   9,  9, $A, $A, $B, $B, $C, $C, $D, $D, $E, $E, $F, $F,$10,$10; 48
		dc.b   1,  1,  2,  2,  3,  3,  4,  4,  5,  5,  6,  6,  7,  7,  8,  8; 64
		dc.b  $D, $D, $D, $D, $E, $E, $E, $E, $F, $F, $F, $F,$10,$10,$10,$10; 80
		dc.b   9,  9,  9,  9, $A, $A, $A, $A, $B, $B, $B, $B, $C, $C, $C, $C; 96
		dc.b   5,  5,  5,  5,  6,  6,  6,  6,  7,  7,  7,  7,  8,  8,  8,  8; 112
		dc.b   1,  1,  1,  1,  2,  2,  2,  2,  3,  3,  3,  3,  4,  4,  4,  4; 128
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  2,  4,  6,  8, $A, $C, $E,$10; 144
		dc.b   2,  4,  6,  8, $A, $C, $E,$10,$10,$10,$10,$10,$10,$10,$10,$10; 160
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  4,  8, $C,$10; 176
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  4,  8, $C,$10,$10,$10,$10,$10; 192
		dc.b   0,  0,  0,  0,  4,  8, $C,$10,$10,$10,$10,$10,$10,$10,$10,$10; 208
		dc.b   4,  8, $C,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 224
		dc.b $F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8; 240
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  4,$10; 256
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  6, $C,$10,$10; 272
		dc.b   0,  0,  0,  0,  0,  0,  2,  4,  7, $A, $E,$10,$10,$10,$10,$10; 288
		dc.b   4,  6,  8, $B, $D, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 304
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  3; 320
		dc.b   0,  0,  0,  0,  2,  3,  4,  6,  7,  9, $A, $C, $D, $F,$10,$10; 336
		dc.b  $D, $E, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 352
		dc.b   0,  0,  0,  0,  1,  1,  2,  3,  4,  5,  6,  7,  8,  9, $A, $C; 368
		dc.b   2,  2,  4,  4,  6,  6,  8,  8, $A, $A, $C, $C, $E, $E,$10,$10; 384
		dc.b   2,  3,  3,  4,  5,  5,  6,  7,  7,  8,  9,  9, $A, $B, $C, $C; 400
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  2; 416
		dc.b  $A, $B, $B, $C, $C, $D, $D, $D, $E, $E, $F, $F,$10,$10,$10,$10; 432
		dc.b   5,  5,  6,  6,  6,  6,  7,  7,  7,  8,  8,  8,  9,  9, $A, $A; 448
		dc.b   2,  2,  2,  2,  3,  3,  3,  3,  3,  3,  4,  4,  4,  4,  5,  5; 464
		dc.b   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  2,  2,  2,  2; 480
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  8,$10; 496
		dc.b   0,  0,  0,  0,  0,  0,  0,  2,  4,  6,  8, $B, $E,$10,$10,$10; 512
		dc.b   7,  8, $A, $B, $D, $E,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 528
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  2,  3,  4,  5,  6; 544
		dc.b  $A, $A, $B, $C, $C, $D, $E, $E, $F,$10,$10,$10,$10,$10,$10,$10; 560
		dc.b   3,  3,  4,  4,  4,  5,  5,  5,  6,  6,  7,  7,  8,  8,  9,  9; 576
		dc.b   1,  1,  1,  1,  1,  1,  1,  1,  2,  2,  2,  2,  2,  2,  3,  3; 592
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  3,$10; 608
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  3, $A,$10,$10; 624
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  2,  6, $A, $E,$10,$10,$10,$10; 640
		dc.b   0,  0,  2,  4,  7,  9, $C, $F,$10,$10,$10,$10,$10,$10,$10,$10; 656
		dc.b  $D, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 672
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  3,  5,  7,  9, $B; 688
		dc.b   2,  3,  5,  6,  7,  9, $B, $C, $E,$10,$10,$10,$10,$10,$10,$10; 704
		dc.b   0,  0,  1,  2,  3,  4,  5,  6,  8,  9, $A, $B, $C, $E, $F,$10; 720
		dc.b  $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 736
		dc.b   1,  2,  3,  3,  4,  5,  6,  7,  8,  8,  9, $A, $B, $C, $D, $E; 752
		dc.b   3,  4,  5,  6,  7,  8,  9,  9, $A, $B, $C, $D, $E, $E, $F,$10; 768
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  2; 784
		dc.b   1,  2,  4,  5,  6,  7,  8, $A, $B, $C, $D, $E, $F,$10,$10,$10; 800
		dc.b   0,  0,  0,  0,  0,  0,  2,  4,  5,  7,  9, $A, $B, $D, $E,$10; 816
		dc.b   7,  9, $B, $D, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 832
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  3,  5; 848
		dc.b   0,  0,  0,  0,  0,  0,  0,  1,  4,  7,  9, $C, $E,$10,$10,$10; 864
		dc.b   0,  0,  0,  2,  6, $A, $E,$10,$10,$10,$10,$10,$10,$10,$10,$10; 880
		dc.b   0,  6, $D,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 896
		dc.b  $D,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 912
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$10; 928
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  4,$10,$10; 944
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  4, $B,$10,$10,$10; 960
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  5,  9, $F,$10,$10,$10,$10,$10; 976
		dc.b   0,  0,  0,  1,  5,  8, $C,$10,$10,$10,$10,$10,$10,$10,$10,$10; 992
		dc.b   8, $B, $E,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1008
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  5; 1024
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  3,  5,  7, $A, $D, $F,$10,$10; 1040
		dc.b   0,  1,  3,  6,  9, $B, $D,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1056
		dc.b  $E,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1072
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  5,  8, $B; 1088
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  4,  8, $B, $F,$10,$10,$10,$10; 1104
		dc.b   0,  0,  0,  0,  1,  7, $B,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1120
		dc.b   0,  0,  5, $C,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1136
		dc.b   0, $C,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1152
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  6,$10; 1168
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  3,  6, $A, $F,$10,$10; 1184
		dc.b   0,  0,  0,  2,  4,  6,  8, $A, $D,$10,$10,$10,$10,$10,$10,$10; 1200
		dc.b   0,  0,  0,  0,  0,  0,  0,  1,  2,  3,  4,  6,  7,  8, $A, $B; 1216
		dc.b  $A, $B, $B, $C, $D, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1232
		dc.b   0,  0,  0,  0,  0,  1,  2,  2,  3,  4,  5,  5,  6,  7,  8,  9; 1248
		dc.b  $E, $F, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1264
		dc.b   7,  7,  7,  8,  8,  8,  9,  9, $A, $A, $B, $B, $C, $C, $D, $D; 1280
		dc.b   2,  3,  3,  3,  3,  3,  4,  4,  4,  4,  5,  5,  5,  6,  6,  6; 1296
		dc.b   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  2,  2,  2,  2,  2,  2; 1312
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  3,  6, $A,$10; 1328
		dc.b   5,  6,  7,  7,  8,  9, $A, $B, $C, $E, $F,$10,$10,$10,$10,$10; 1344
		dc.b   1,  1,  1,  1,  1,  1,  2,  2,  2,  2,  3,  3,  3,  4,  4,  5; 1360
		dc.b  $E, $E, $F, $F, $F, $F, $F, $F,$10,$10,$10,$10,$10,$10,$10,$10; 1376
		dc.b   8,  8,  9,  9, $A, $A, $B, $B, $C, $C, $C, $D, $D, $D, $E, $E; 1392
		dc.b   0,  0,  0,  0,  0,  0,  1,  2,  3,  3,  4,  5,  5,  6,  7,  7; 1408
		dc.b  $B, $C, $D, $E, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1424
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  3,  5,  6,  8,  9, $A; 1440
		dc.b   0,  0,  2,  5,  8, $A, $C, $E,$10,$10,$10,$10,$10,$10,$10,$10; 1456
		dc.b   8, $E,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1472
		dc.b  $F, $F, $F, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1488
		dc.b  $C, $C, $D, $D, $D, $D, $E, $E, $E, $E, $E, $E, $F, $F, $F, $F; 1504
		dc.b   7,  7,  8,  8,  9,  9,  9, $A, $A, $A, $B, $B, $B, $B, $C, $C; 1520
		dc.b   0,  0,  0,  1,  2,  2,  3,  3,  4,  4,  4,  5,  5,  6,  6,  7; 1536
		dc.b   5,  5,  6,  7,  8,  8,  9, $A, $A, $B, $C, $C, $D, $E, $E, $F; 1552
		dc.b   6,  7,  8,  9, $A, $B, $C, $D, $E, $F,$10,$10,$10,$10,$10,$10; 1568
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  2,  3,  4; 1584
		dc.b   0,  1,  3,  4,  6,  7,  9, $A, $C, $D, $E,$10,$10,$10,$10,$10; 1600
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  3,  5,  8, $A, $C, $D; 1616
		dc.b   0,  0,  0,  0,  2,  6,  9, $C, $E,$10,$10,$10,$10,$10,$10,$10; 1632
		dc.b   0,  4, $A, $E,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1648
		dc.b  $C,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1664
		dc.b  $C, $D, $D, $E, $E, $E, $F, $F, $F, $F,$10,$10,$10,$10,$10,$10; 1680
		dc.b   0,  0,  0,  0,  1,  2,  4,  5,  6,  7,  8,  9, $A, $A, $B, $C; 1696
		dc.b   6, $A, $D, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1712
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  6; 1728
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  6, $A, $F,$10; 1744
		dc.b   0,  0,  0,  0,  2,  4,  6,  8, $A, $D, $F,$10,$10,$10,$10,$10; 1760
		dc.b  $B, $D, $E,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1776
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  3,  4,  5,  7,  8, $A; 1792
		dc.b   8,  9, $A, $B, $C, $D, $E, $F,$10,$10,$10,$10,$10,$10,$10,$10; 1808
		dc.b   0,  0,  0,  0,  0,  0,  1,  1,  2,  3,  3,  4,  5,  6,  7,  7; 1824
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  1,  1,  1,  1; 1840
		dc.b   1,  2,  2,  2,  2,  2,  3,  3,  3,  3,  4,  4,  4,  4,  5,  5; 1856
		dc.b   5,  6,  6,  7,  7,  7,  8,  8,  9,  9, $A, $A, $B, $B, $C, $C; 1872
		dc.b  $D, $D, $E, $F, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1888
		dc.b $FE,$FD,$FB,$FA,$F9,$F7,$F5,$F4,$F2,$10,$10,$10,$10,$10,$10,$10; 1904
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FF,$FD,$FB,$F9,$F7,$F5; 1920
		dc.b $F3,$F1,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1936
		dc.b $FF,$FE,$FC,$FB,$FA,$F9,$F8,$F6,$F5,$F4,$F3,$F2,$F1,$10,$10,$10; 1952
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FF,$FE; 1968
		dc.b $FD,$FC,$FB,$FA,$F9,$F8,$F7,$F7,$F6,$F5,$F4,$F3,$F2,$F2,$F1,$10; 1984
		dc.b $F1,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 2000
		dc.b   0,  0,$FF,$FE,$FD,$FC,$FB,$FA,$F8,$F7,$F6,$F5,$F4,$F2,$F1,$10; 2016
		dc.b $FF,$FE,$FD,$FD,$FC,$FB,$FA,$F9,$F8,$F8,$F7,$F6,$F5,$F4,$F3,$F2; 2032
		dc.b   5,  6,  7,  7,  8,  8,  9, $A, $A, $B, $B, $C, $C, $C, $D, $D; 2048
		dc.b  $E, $E, $E, $E, $F, $F, $F, $F,$10,$10,$10,$10,$10,$10,$10,$10; 2064
		dc.b   0,  0,  0,  2,  5,  7,  9, $A, $C, $E, $F,$10,$10,$10,$10,$10; 2080
		dc.b   8, $C,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 2096
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  8; 2112
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  5,  8, $C,$10,$10; 2128
		dc.b   0,  1,  3,  4,  6,  8, $A, $B, $E,$10,$10,$10,$10,$10,$10,$10; 2144
		dc.b   0,  1,  1,  2,  3,  4,  5,  6,  7,  8,  9, $A, $B, $C, $D, $F; 2160
		dc.b   7,  7,  8,  8,  8,  9, $A, $A, $B, $B, $C, $C, $D, $E, $E, $F; 2176
		dc.b   2,  2,  2,  2,  3,  3,  3,  3,  4,  4,  4,  5,  5,  5,  6,  6; 2192
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  1,  1,  1,  1,  1,  1; 2208
		dc.b   4,  7,  9, $A, $B, $C, $D, $E, $E, $F, $F, $F,$10,$10,$10,$10; 2224
		dc.b   1,  2,  2,  4,  5,  6,  7,  8, $A, $B, $C, $D, $E, $F,$10,$10; 2240
		dc.b   2,  3,  4,  5,  6,  7,  8,  8,  9, $A, $B, $C, $D, $D, $E, $F; 2256
		dc.b   0,  0,  1,  2,  2,  3,  4,  5,  5,  6,  6,  7,  8,  8,  9,  9; 2272
		dc.b  $A, $B, $B, $C, $C, $D, $D, $E, $E, $F, $F,$10,$10,$10,$10,$10; 2288
		dc.b   2,  2,  3,  3,  4,  4,  4,  5,  5,  6,  6,  6,  7,  7,  7,  8; 2304
		dc.b   8,  8,  9,  9,  9,  9, $A, $A, $A, $A, $B, $B, $B, $B, $C, $C; 2320
		dc.b  $C, $C, $C, $D, $D, $D, $D, $D, $D, $D, $E, $E, $E, $E, $E, $E; 2336
		dc.b  $E, $E, $E, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F; 2352
		dc.b   0, $D,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 2368
		dc.b   0,  0,  6, $D,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 2384
		dc.b   0,  0,  0,  0,  2,  6, $A, $E,$10,$10,$10,$10,$10,$10,$10,$10; 2400
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  1,  4,  7,  9, $C, $E,$10,$10; 2416
		dc.b   5,  7,  9, $B, $D, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 2432
		dc.b   0,  0,  0,  0,  0,  0,  0,  3,  4,  5,  7,  9, $A, $B, $D, $E; 2448
		dc.b   0,  1,  2,  4,  5,  6,  7,  8, $A, $B, $C, $D, $E, $F,$10,$10; 2464
		dc.b   4,  8, $A, $C, $E,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 2480
		dc.b   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, $A, $B, $C, $D, $E, $F; 2496
		dc.b   1,  2,  3,  4,  5,  6,  7,  8,  9, $A, $A, $B, $C, $D, $E, $F; 2512
		dc.b   0,  0,  0,  1,  1,  2,  3,  3,  4,  4,  4,  5,  5,  6,  6,  7; 2528
		dc.b   4, $A, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 2544
		dc.b   0,  0,  0,  0,  0,  0,  0,  2,  5,  7,  9, $B, $C, $E, $F,$10; 2560
		dc.b   1,  3,  4,  5,  6,  7,  8,  9, $A, $B, $C, $C, $D, $E, $E, $F; 2576
		dc.b   0,  0,  0,  0,  2,  5,  8, $B, $D,$10,$10,$10,$10,$10,$10,$10; 2592
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  3,  6,  9, $B, $E,$10; 2608
		dc.b   0,  0,  0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 2624
		dc.b   0,  0,  0,  0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 2640
		dc.b   0,  0,  0,  0,  0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 2656
		dc.b   0,  0,  0,  0,  0,  8,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 2672
		dc.b   0,  0,  0,  0,  0,  0,  0,  8,$10,$10,$10,$10,$10,$10,$10,$10; 2688
		dc.b   0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 2704
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$10,$10,$10,$10; 2720
		dc.b   8,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 2736
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  3,  5,  8; 2752
		dc.b   0,  0,  0,  0,  0,  3,  5,  7,  9, $B, $D, $F,$10,$10,$10,$10; 2768
		dc.b   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2; 2784
		dc.b   8,  8,  9, $A, $B, $C, $D, $E, $F,$10,$10,$10,$10,$10,$10,$10; 2800
		dc.b   8,  9, $A, $B, $C, $E, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10; 2816
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  2,  5,  8, $A, $D,$10,$10,$10; 2832
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  3,  6; 2848
		dc.b   0,  0,  0,  0,  2,  4,  6,  8, $A, $C, $E,$10,$10,$10,$10,$10; 2864
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  4,  6,  8; 2880
		dc.b  $A, $C, $E,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 2896
		dc.b   1,  3,  4,  5,  7,  8,  9, $B, $C, $D, $F,$10,$10,$10,$10,$10; 2912
		dc.b   0,  0,  8,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 2928
		dc.b   0,  0,  0,  0,  4,  6,  8, $A, $D,$10,$10,$10,$10,$10,$10,$10; 2944
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  3,  6,$10,$10; 2960
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  3,  4,  6,  8,  9, $A; 2976
		dc.b   0,  0,  0,  0,  0,  0,  1,  2,  3,  4,  4,  5,  5,  6,  7,  7; 2992
		dc.b $F2,$F2,$F2,$F2,$F2,$F2,$F2,$F2,$F2,$F2,$F2,$F2,$F2,$F2,$F2,$F2; 3008
		dc.b   0,  0,  0,  1,  1,  2,  3,  4,  5,  6,  7,  8,  8,  9, $A, $B; 3024
		dc.b  $E, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 3040
		dc.b   6,  9, $C, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 3056
		dc.b   9, $C, $E,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 3072
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  5,  8, $B, $E,$10,$10; 3088
		dc.b   0,  0,  0,  1,  4,  7, $A, $D,$10,$10,$10,$10,$10,$10,$10,$10; 3104
		dc.b   0,  0,  0,  0,  0,  1,  2,  2,  3,  3,  4,  5,  5,  6,  7,  7; 3120
		dc.b   0,  0,  0,  0,  8,  8,  9,  9, $A, $A, $B, $B, $C, $C, $D, $D; 3136
		dc.b $FF,$FE,$FD,$FC,$FB,$FA,$F9,$F8,$F7,$F6,$F5,$F4,$F3,$F2,$F1,$10; 3152
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  1,  2,  3,  4,  5,  6,  7,  8; 3168
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3184
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3200
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3216
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3232
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3248
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3264
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3280
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3296
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3312
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3328
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3344
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3360
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3376
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3392
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3408
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3424
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3440
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3456
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3472
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3488
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3504
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3520
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3536
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3552
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3568
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3584
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3600
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3616
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3632
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3648
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3664
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3680
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3696
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3712
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3728
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3744
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3760
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3776
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3792
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3808
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3824
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3840
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3856
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3872
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3888
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3904
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3920
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3936
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3952
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3968
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3984
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 4000
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4016
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4032
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4048
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4064
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 4080

ColP_GHZ:	dc.b   0,$FF,$1A,  0,  0,  0,$1A,  0,$1D,$1C,$FF,$FF,  9,$14, $B,  0,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF; 0
		dc.b $FF,$FF,$FF,$FF,$FF,$FF,$FF,  0,  0,$10,$11,$12,$13,$14,$15,$16,$18,$19,$1A,$1B,$FF,$FF,$FF,$FF,$FF,$FF,  0,$1C,$1D,$FF,$FF,$FF; 32
		dc.b $FF,  0,$13,  9,$FF, $A,$FF,$FF,$FF,$14,$15,$16,$16,$18,$19,$1A,$1B,$FF,$1C,$1D,$6F, $A,$1A,$75,$76,$77,  0,  0,$FF,  0,$FF,$FF; 64
		dc.b   0,  0,  0,  0,  0,  0,$14,  0,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,  0,  0,$FF,  0,  0,$FF,$FF; 96
		dc.b $FF,$FF,$FF,  0,$FF,  0,$1A,$1A,  0,$1A,$14,  0,$FF,$FF,$FF,$FF,  0,$24,$25,$26,$27,$FF,$FF,  0,  0,$28,$29,$FF,$FF,$3A,$3B,$3C; 128
		dc.b $30,$31,$FF,$FF,$52,$53,$38,$FF,$3E,$32,$FF,$4E,$4F,$FF,$FF,$52,$53,$4C,$4D,  0,  0,$14,$FF,  0,$FF,$15,  0,  0,  0,$FF,$FF,  0; 160
		dc.b $14,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 192
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$1C,  0,  0,  0,  0,  0,  0, $E,$1D,$1C,  0,$18,  0,  0,  0,  0,  0,  0,  0,  0; 224
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 256
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 288
		dc.b $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,  0,$6F,$6E,$6D,$FF,$70,$6E,$FF,$FF,$6D,$6A,$6B,$6C,$69,$FF,  0,  0,  0,  0,  0,  0,  0; 320
		dc.b $68,  0,  0,  0,  0,  0,  0,  0,  0,$66,$67,  0,  0,  0,  0,  0,  0,  0,$64,$65,$66,$67,$68,$69,$6A,$6B,$6C,$6D,$6E,$6F,$70,$71; 352
		dc.b $72,$73,$64,$65,$1A,  0,  0,$1A,  0,$FB,$FB,$FD,$FC,$FC,  0,  0,$15,$FF,$FF,  9, $A,  0,  0,$FF,$FF,  0; 384

ColS_GHZ:	dc.b   0,$FF,$1A,  0,  0,  0,$1A,  0,$1D,$1C,$FF,$FF,  9,$14, $B,  0,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF; 0
		dc.b $FF,$FF,$FF,$FF,$FF,$FF,$FF,  0,  0,$10,$11,$12,$13,$14,$15,$16,$18,$19,$1A,$1B,$FF,$FF,$FF,$FF,$FF,$FF,  0,$1C,$1D,$FF,$FF,$FF; 32
		dc.b $FF,  0,$13,  9,$FF, $A,$FF,$FF,$FF,$14,$15,$16,$16,$18,$19,$1A,$1B,$FF,$1C,$1D,$6F, $A,$1A,$75,$76,$77,  0,  0,$FF,  0,$FF,$FF; 64
		dc.b   0,  0,  0,  0,  0,  0,$14,  0,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,  0,  0,$FF,  0,  0,$FF,$FF; 96
		dc.b $FF,$FF,$FF,  0,$FF,  0,$1A,$1A,  0,$1A,$14,  0,$FF,$FF,$FF,$FF,  0,$24,$25,$26,$27,$FF,$FF,  0,  0,$28,$29,$FF,$FF,$3A,$3B,$3C; 128
		dc.b $30,$31,$FF,$FF,$52,$53,$38,$FF,$3E,$32,$FF,$4E,$4F,$FF,$FF,$52,$53,$4C,$4D,  0,  0,$14,$FF,  0,$FF,$15,  0,  0,  0,$FF,$FF,  0; 160
		dc.b $14,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 192
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$1C,  0,  0,  0,  0,  0,  0, $E,$1D,$1C,  0,$18,  0,  0,  0,  0,  0,  0,  0,  0; 224
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 256
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 288
		dc.b $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,  0,$6F,$6E,$6D,$FF,$70,$6E,$FF,$FF,$6D,$6A,$6B,$6C,$69,$FF,  0,  0,  0,  0,  0,  0,  0; 320
		dc.b $68,  0,  0,  0,  0,  0,  0,  0,  0,$66,$67,  0,  0,  0,  0,  0,  0,  0,$64,$FF,$69,$68,$67,$66,$6A,$6B,$6C,$6D,$6E,$6F,$70,$71; 352
		dc.b $72,$73,$64,$65,$1A,  0,  0,$1A,  0,$FB,$65,$FD,$FC,$FC,  0,  0,$15,$FF,$FF,  9, $A,  0,  0,$FF,$FF,  0; 384

ColP_EHZ:	dc.b   0,  0,$A4,$FF, $E,$A4,$A5,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$A6,$FF,$FF,$FF,$FF,  0, $B, $C, $D; 0
		dc.b  $E,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$A7,$A8,$4D,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$A4,$FF,$FF,  0,$FF,$FF,$FF,$FF,$FF,$FF,$FF; 32
		dc.b $FF,$FF,  0,  0,$A9,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$AA,$FF,$FF,$A4,$C4,$4F,$FF,$A4,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$A4,$A4,$2A; 64
		dc.b $FF,$FF,$FF,$FF,$FF,  0,  0,$FF,$FF,$FF,$FF,$FF,  0,$FF,  0,  0,  0,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$AC,$AD,$FF,$FF,$FF,$FF,$2A; 96
		dc.b $4B,$4A,$49,$FF,$4D,$4C,$4F,$4E,$50,$51,$AE,$51,$FF,$FF,  0,  0,  0,  9,$FF,$50,$FF,$FF,$FF,  0,$A4,$FF,  0,  0,  0,  0,  0,  0; 128
		dc.b   0,  0,  0,  0,  0, $C,$FF,$4F,$4D,$FF,$49,$FF, $E,  0,$FF,  0,$B3,$B4,$FF,$B5,$B3,  0, $A,  9,  0,$B6,$A4,$52,  0,  0,  0,  0; 160
		dc.b   0,$FF,$FF,$FF,$FF,$4E,$4F,$FF,$FF,$4C,$FF,$FF,$FF,  1,  0,  0,  0,  0,  0,$B7,$AB,$FF,$FF,$FF,$4D,$FF,$FF,$FF,$49,$4A,$4B,$FF; 192
		dc.b   0,$FF,  0,$FF,$A4,$A4,$A5,$A6,$A4,  0,  0,$FF,$52,$51,$AE,$FF,$FF,$FF,  0,$4D,$FF,$FF,$4F,$FF,$FF,$FF,$FF,$FF,$FF,$FF, $B, $C; 224
		dc.b  $D, $E,  0,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF, $B,$FF,$FF,$FF,$FF,$FF,$FF,$FF,  0,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF; 256
		dc.b $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$B7,$AB,$FF,$FF,$A4,$A5,$A6,$A4,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 288
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 320
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $C,$FF,$FF,$FF,$FF,$FF,$FF,$5C,  0,$FF,$FF,$FF,  0,  0,$49; 352
		dc.b $4A,$4B,$2A,$4C,$FF,$4D,$FF,$5C,$5B,$BA,$FF,$57,$BC,$59,$BB,$FF,$50,$BD,$BE,$51,$FF,$AE,$FF,$FF,$FF,$BD,$BE,$AE,$93,$92,$FF,$FF; 384
		dc.b $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$A4,  0,  0,$A4,$FF; 416
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 448
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$BF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 480
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 512
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 544
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 576
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 608
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 640
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 672
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 704
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 736

ColS_EHZ:	dc.b   0,  0,$A4,$FF, $E,$A4,$A5,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$A6,$FF,$FF,$FF,$FF,  0, $B, $C, $D; 0
		dc.b  $E,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$A7,$A8,$4D,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$A4,$FF,$FF,  0,$FF,$FF,$FF,$FF,$FF,$FF,$FF; 32
		dc.b $FF,$FF,  0,  0,$A9,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$AA,$FF,$FF,$A4,$C4,$4F,$FF,$A4,$FF,$FF,$FF,$FF,$FF,  0,$FF,$FF,$FF,$A4,$A4,$2A; 64
		dc.b $FF,$FF,$B2,$FF,$FF,  0,  0,$FF,$FF,$FF,$FF,$FF,  0,$FF,  0,  0,  0,$B5,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$AC,$AD,$FF,$FF,$FF,$FF,$2A; 96
		dc.b $4B,$4A,$49,$FF,$4D,$4C,$4F,$4E,$50,$51,$AE,$51,  0,  0,  0,  0,  0,  9,$B3,$50,$FF,$FF,$FF,  0,  0,$FF,$50,$4F,$C3,$FF,$AF,$22; 128
		dc.b $FF,  0,$FF,$B0,$C6, $C,$FF,$4F,$4D,$FF,$49,$FF,$FF,  0,$FF,  0,$B3,$B4,$FF,$B5,$B3,  0, $A,  9,  0,$B6,$A4,$52,  0,  0,  0,  0; 160
		dc.b   0,$FF,$FF,$FF,$FF,$4E,$4F,$FF,$FF,$4C,$FF,$FF,$FF,  1,  0,  0,  0,  0,  0,$B7,$AB,$FF,$FF,$FF,$4D,$FF,$FF,$FF,$49,$4A,$4B,$FF; 192
		dc.b   0,$FF,  0,$FF,$A4,$A4,$A5,$A6,$A4,  0,  0,$B5,$52,$51,$AE,$B4,$C1,$A4,  0,$4D,$FF,$FF,$4F,$FF,$B4,  0,  0,$B5,$A4,$FF, $B, $C; 224
		dc.b  $D, $E,  0,$B3,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF, $B,$FF,$FF,$FF,$FF,$FF,$FF,$FF,  0,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF; 256
		dc.b $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$B7,$AB,$FF,$FF,$A4,$A5,$A6,$A4,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 288
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 320
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $C,$FF,$FF,$FF,$FF,$FF,$FF,$5C,  0,$FF,$FF,$FF,  0,  0,$49; 352
		dc.b $4A,$4B,$2A,$4C,$FF,$4D,$FF,$5C,$5B,$BA,$FF,$57,$BC,$59,$BB,$FF,$50,$BD,$BE,$51,$FF,$AE,$FF,$FF,$FF,$BD,$BE,$AE,$93,$92,$FF,$FF; 384
		dc.b $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$A4,  0,  0,$A4,  0; 416
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 448
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$BF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 480
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 512
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 544
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 576
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 608
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 640
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 672
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 704
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 736

ColP_CPZ:	dc.b   0,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF; 0
		dc.b $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF; 32
		dc.b $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,  0,  0; 64
		dc.b   0,$FF,$FF,$FF,$FF,  2,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FB,$FE,$2A,$4B,$4A,$49,$4B,$2A,$FF,$FF,$FE,$4D,$4C,$FC,$2A,$4B,$FF; 96
		dc.b $FD,$FF,$FF,$4F,$4E,$50,  0,  0,$52,$FF,$4F,$FF,$FF,$50,$FF,$4F,  0,  0,$51,$FF,$50,$FF,$FF,$51,$FF,$FC,  0,$52,$50,$FF,$FF,$FF; 128
		dc.b $FF,$52,$FF,$FF,  0,$51,$4F,$FB,$FF,$FF,$FF,$FF,$FC,$4B,$2A,$FB,$FF,$FF,  0,  0,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,  0,  0,$FF,$FF; 160
		dc.b $FF,$FF,$FF,$FF,$FF,$FF,  0,  0,$FF,$FF,$FF,$FF,$FF,$FF,  0,  0,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,  0,  0,  0,  0,$FF,$FF,$FF,$25; 192
		dc.b   0,  0,  0,  0,  0,$FF,$40,$41, $A,$24,  0, $D,  0,  0,  9,$42,$3E,$3F,$22,$23, $C, $B, $E,  0,$FF,  0,$1F,$20,$21,$FB,$FF,$FF; 224
		dc.b  $E, $D, $C, $B,$3A,$3B,$FF,$FF,$FF,$40,$41, $A,$41, $A,$3A,$3B,$3C,$3D,$3E,$3F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF; 256
		dc.b $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,  0,$FF,$FF,$44,$45,$46,$47,$48,$FF,$38,$39,  9,$42,$43,$FF,$FF,$FF,$FF,$FF,  0,  0; 288
		dc.b $FF,$FF,$FF,$FF,$FF,  0,  0,  0,$26,$27,$FF,$2D,  2,$35,$36,$37,$38,$39,$31,$32,  0,$FF,$33,$34,$FF,$FF,$2B,$2F,$FB,$30,$31,$32; 320
		dc.b $FB,$FF,$FF,$FF,$2D,$2E,$FF,$FF,$30,$FB,$FB,$FF,$FF,$2C,$FB,$FF,$FF,$FF,$26,$27,$28,$29,$2A,$FB,  0,$FF,$FF,$FF,$FF,$FF,$FF,$FF; 352
		dc.b $FF,$FF,$FF,  0,  0,  0,$FF,$FF,$FF,$FF,  0,  0,  2,  2,$FF,$FF,  0,$FC,$7F,  0,  0,$2F,$FB,  0,  2,$FB,$FF,$FC,$7D,$7E,$2D,$2E; 384
		dc.b $FB,$FF,$FB,  0,$FF,$FF,$FC,$FC,$FB,$FF,$FF,$FF,$FB,  0,  0,$35,$36,$37,$38,$39,$FC,$C5,$C5,  0,$33,$34,$FF,  0,  0,$FF,$FC,$FC; 416
		dc.b $FF,  0,$FF,$FF,$FF,$FF,$FF,  0,  0,$FF,$FC,  0,$FF,$FF,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 448
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 480
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 512
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 544
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 576
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 608
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 640
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 672
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 704
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 736

ColS_CPZ:	dc.b   0,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF; 0
		dc.b $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF; 32
		dc.b $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,  0,  0; 64
		dc.b   0,$FF,$FF,$FF,$FF,  2,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FB,$FE,$2A,$4B,$4A,$49,$4B,$2A,$FF,$FF,$FE,$4D,$4C,$FC,$2A,$4B,$FF; 96
		dc.b $FD,$FF,$FF,$4F,$4E,$50,  0,  0,$52,$FF,$4F,$FF,$FF,$50,$FF,$4F,  0,  0,$51,$FF,$50,$FF,$FF,$51,$FF,$FC,  0,$52,$50,$FF,$FF,$FF; 128
		dc.b $FF,$52,$FF,$FF,  0,$51,$4F,$FB,$FF,$FF,$FF,$FF,$FC,$4B,$2A,$FB,$FF,$FF,  0,  0,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,  0,  0,$FF,$FF; 160
		dc.b $FF,$FF,$FF,$FF,$FF,$FF,  0,  0,$FF,$FF,$FF,$FF,$FF,$FF,  0,  0,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,  0,  0,  0,  0,$FF,$FF,$FF,$25; 192
		dc.b   0,  0,  0,  0,  0,$FF,$50,$FF,$FF,$24,  0, $D,  0,  0,  9,$42,$4E,$4F,$22,$23, $C, $B, $E,  0,$FF,  0,$1F,$20,$21,$FB,$FF,$FF; 224
		dc.b  $E, $D, $C, $B,$3A,$3B,$49,$4A,$4B,$40,$41, $A,$41, $A,$3A,$3B,$3C,$3D,$3E,$3F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF; 256
		dc.b $4C,$4D,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,  0,$2A,$FF,$44,$45,$46,$47,$48,$FF,$38,$39,  9,$42,$43,$FF,$FF,$FF,$FF,$FF,  0,  0; 288
		dc.b $FF,$FF,$FF,$FF,$FF,  0,  0,  0,$26,$27,$FF,$2D,  0,$35,$36,$37,$38,$39,$31,$32,  0,$FF,$33,$34,$FF,$FF,$2B,$2F,$FB,$30,$31,$32; 320
		dc.b $FB,$FF,$FF,$FF,$2D,$2E,$FF,$FF,$30,$FB,$FB,$FF,$FF,$2C,$FB,$FF,$FF,$FF,$26,$27,$28,$29,$2A,$FB,  0,$FF,$FF,$FF,$FF,$FF,$FF,$FF; 352
		dc.b $FF,$FF,$FF,  0,  0,  0,$FF,$FF,$FF,$FF,  0,  0,  2,  2,$FF,$FF,  0,$2F,$FB,  0,  0,$FC,$7F,  0,  2,$FB,$2D,$2E,$FB,$FF,$FF,$FC; 384
		dc.b $7D,$7E,$FB,  0,$FB,$FF,$FF,$FF,$FF,$FF,$FC,$FC,$FB,  0,  0,$FF,$FF,$FF,$FF,$FF,$40,$41,$FF,  0,$FF,$FF,$FF,  0,$3D,$3E,$3F,$FF; 416
		dc.b $FF,  0,$35,$36,$37,$38,$39,$FF,  0,$FF,$FC,  0,$33,$34,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 448
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 480
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 512
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 544
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 576
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 608
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 640
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 672
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 704
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 736

ColP_HPZ:	dc.b   0,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,  3,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF; 0
		dc.b $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,  0,  0,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$68,$FF,$65,  0,$FF,$FF,$FF,$FF,$FF,$FF,$FB,$FF,$2E; 32
		dc.b $64,$FF,$FF,  0,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FB,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$60,$5F,  2,  0,  0,$FF,$FF,$FF,$FF,$5E,  0,  0,$5D; 64
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 96
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 128
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FF; 160
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$1E,$FF,$FF,$FB,$13,$12,$11,$10,$1D,  0,$FF,$14,$1C,  0,$FE,$1B,$1A,$FB,$19,$FB,$FF,$FF; 192
		dc.b $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF, $E, $D, $C, $B,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF; 224
		dc.b $FF,$FF,$FF,$8B,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$81,  0,$8A,$FF,$FF,$FB,$80,  0,$89,$FB,$FF,$FF,$FF,$FF,$FF,$83,$82,$63,$88,$FB; 256
		dc.b   0,  0,$87,$FB,  0,$49,$85,$86,$FB,$FF,$FF,$FF,  0,$FF,$FF,$FF,$FF,$FF,$8A,  0,$FF,$FD,$FF,$FF,$FC,$83,$FF,  0,$84,  0,$84,  0; 288
		dc.b $FF,$FF,$FF,$FD,$8A,  0,$81,  0,  0,$FF,$FF,  3,$FF,$FF,  4,$FB,$FF,$FF,  0,  3,$FF,$FE,  4,  0,  0,  3,$FF,  4,$FB,$FF,  3,  0; 320
		dc.b $FB,$FE,$FE,  3,  4,$FB,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$44,$45,$46,$47,$48,$FF,$FF; 352
		dc.b $48,$47,$46,$45,$44,  0,  9,$42,$43,$FB,$FF,$FB,$43,$42,  9,$FB,$FC,$FF,$FF,  0,  0,$FF,  0,  0, $A,$41,$40,  0,  0,  0,$40,$41; 384
		dc.b  $A,$FC,$3F,$3E,$3D,$3C,$3B,$3A,$3A,$3B,$3C,$3D,$3E,$3F,$FC,$FC,$FF,$FF,$FF,$FB,$FB,$FF,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0; 416
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 448
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 480
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 512
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 544
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 576
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 608
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$62,$63,  0,  0,$63,$61,$FF,  2,  0,  0,$FF,$FF, $A,  0,  2,$FF,$FF,$66,$67,$FF; 640
		dc.b $FF,$FF,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$17,$16,$15,$16,$FB,  3,  4,$FB,  3,$FB,  4,$FB,$FF,$FF,  0,  0,  0,  0,  0; 672
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 704
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 736

ColS_HPZ:	dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 0
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 32
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 64
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 96
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 128
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 160
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 192
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 224
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 256
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 288
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 320
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 352
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 384
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 416
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 448
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 480
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 512
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 544
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 576
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 608
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 640
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 672
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 704
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 736

S1SS_1:		dc.b  $B, $F,  0,  2,  0,  0,$48,  8,$20,$40,$78,  2,  0,$7D,$B0,$11,$E0, $C,  1,$F6,$C0,$47,$80,$40,  7,$DB,  1,$1E,  1,$40,$1F,$6C,  4,$78,  6,  0,$7D,$B0,$11,$E0,$1C,  1,$F7,$39,$12,$3A,$74,$74,$A8,  1,$F7,$39, $D,$3A,$74,$74,  0,$A9,$F7,$38, $E,  0,$47,$8A; 0
		dc.b $A0,$D1,$C1,$EF,$B5,$C8,$78,  0,  3,$A7,$47,$48,$F1,$22,$24,$B0,  1,$F6,$3B,$2C,  0,  0,$74,$E8,$E8,  1,$D3,$A3,$A0,  0,  0, $B,$1F,$63,$80,  2,$B4,$7A,  0,$3A,$74,$74,  0,$E9,$D0,  2,$C0,  7,$D8,$E2,$B0,$48,$58,$62,$3C,$80,$1D,$3A,  0,$30,  0,$FB,$5D,  7; 64
		dc.b   7,$90,$1A,$56,$74,$E8,  0,$C8,  3,$EA,$72,  0,$4E,$9C,$9D,$39,$3A,$9C,$8A,  0,  0,  0,$4A,  0,$FA,$9C,$80,  5,  0,  0,  0,$14,$A7,$22,$A0, $E,$80, $D,$80,$3E,$A7,$20,  1,$40,  0,  0,  5,$29,$C8,$B0,  3,$A0,  2,$80, $F,$A9,$C8,  1,$28,  0,  0,  4,$AA,$72; 128
		dc.b $3A,  0,$E8,  1,  0,  3,$EA,$72,  0,$14,  0,  0,  0,$52,$9C,$94,$80,  0,  0,$58,  0,$FA,$9D,$D6,  0,$3A,$3A,$74,$56, $C, $D,$48,$48,$80,  0,  0,  0, $A,$51,$E0,  0,$B1,$F4,$F9,$80,$2C,  0,  0,$E8,$E9,$D0,  2,$3C,$80,  3,  0,  0,  0,$40,$8F,  0,  4,$8F,$A7; 192
		dc.b $C5,$60,  0,  3,$A4,$BD,$80,$3A,  0,  0,$10,  0,  1,  8,  0,  5,$80,  0, $A,$CE,$8F,  0,  0,  0,$58,$74,$79,$38,  3,$DE,$8B,$80,$3A,$3A,  0,$58,$B4,$B5,$69,$60,  3,$A7,$49,$4A,$C9,$11,$96,  0,$3A,$74,$74,$8F,$34,  4,$2B,  0,  0,  0,$27,  0,$7B,$D9,$80,  7; 256
		dc.b $47,$40, $B,$5D,$1D,$3A,$2D,  0,$74,$E9,$2A,  8,  0,  0,  7,$47,$4E,$8E,$9D,  0,$27,$C1,$38,  3,$DF,$92,$80,$3A,$3A,  0,$5A,$E8,$ED,$D1,$68,  3,$A7,$49,$50,$4E,$9D,$1D,$3A,$3A,$4A,$74,$E8,$B0,  1,$D3,$A3,$A7,$47,$48,$70,$4E,  0,$F7,$B3,$40, $E,$8E,$80,$16; 320
		dc.b $BA,$3A,$74,$5A,  0,$E9,$D2,$54,$10,  0,  0, $E,$8E,$9D,$1D,$3A,  0,$4F,$82,$70,  7,$BD,$1B,  0,$74,$74,  0,$B1,$69,$6A,$D2,$C0,  7,$4E,$92,$96, $F,$1D,$2C,  0,$74,$E8,$E9,$1E,$67,$49,$16,  0,  0,  0,$4E,  0,$F7,$15,$80,  0, $E,$92,$F6,  0,$E8,  0,  0,$60; 384
		dc.b   0,  4,$80,  0,$16,  0,  0,$2B,$40,$3E,  0,  0,  1,$62,  1,$F4,$E0, $F,$73,  0,$58,  0,  1,$D1,$D3,$A0,  4,$40,$43,$80,  2,$34,$78,  0,$22,$7D,$4F,$4B,  0,$1D,$1D,$3A,$2B, $A, $A,$A4, $C,$10,  0,  0,  0,  4,$40,  0,$1D,  0,  0,$23,$7D,$4E,$40,  2,$80,  0; 448
		dc.b   0, $A,$53,$92,$B0,  7,$40, $B,  0,$1F,$53,$90,  2,$50,  0,  0,  9,$54,$E4,$7C,  1,$D0,  1,$E0,  7,$D4,$E4,  0,$28,  0,  0,  0,$A5,$39,$1E,  0,$74,  0,$94,  1,$F5,$39,  0, $A,  0,  0,  0,$29,$4E,$47,$40,$1D,  0,$20,  0,$7D,$4E,$40,  9,$D3,$93,$A7,$27,$53; 512
		dc.b $92,$40,  0,  0,  8,$40,$1F,$72, $A,$72,$7E,  9,$C0,$1F,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$4F,$F8; 576

S1SS_2:		dc.b  $B, $F,  0,  0,  0,  0,  1,$3E,$60,  9,$D3,$93,$A7,$27,$4E,  0,$FB,$7C,  0,  9,$23,$C0,$90,  3,$ED,$F0,  0,$22,$8F,  1,$60, $F,$B7,$C0,  1,$2A,$3C,  6,  0,$3E,$DF,$20,  1,$E0,  0,  0,  7,$3E,$E7,$21,$A0,  0,  0,  0,  7,$BE,$E7,$21,$80,  0,  0,  0,$16,$3E; 0
		dc.b $DF,$10,  2,$4A,$C0,$11,$E2,$B0,$2C,$61,$53,$EC,$F2,$58,  0,  0,  0,  1,$D2,$5C,$15,  0,$3E,$BF,  0,  5,$28,$F1,$74,$74,$E8,  1,$1E,$40, $A,$85,$86,$2C,  0,$7D,$5E,$2B,  0,  0,  0,$42,  0,$74,$9F,  0,  5,$8F,$AB,$E8,$88,  0,  0,  7,$47,$4E,$80,$1D,$1D,$3A; 64
		dc.b   0,  0,  0,  0,$E9,$D0,  0,  0,  5,$80, $F,$A9,$D4,$80,  0,  3,$A7,$44,$AE,$8E,$9D,$12,$BA,$3A,$47,$93,$A3,$A0,  0,  4,$80,$1F,$53,$A8,$F0,  0,  0, $E,$8E,$9D,  0,$3A,$3A,$74,  0,$8F,$30,  7,$4E,$80,$15,$86, $D,$2C,$7D,$3E,$2B,  0,  0,  0,$42,  0,$74,$8F; 128
		dc.b $20,  5,$80,  0,$1D,  0,$23,$C1,$60,  3,$E9,$70,  0,$54,$8F,$17,$47,$4E,$80,$12,$E0,$B0,  1,$2E,$60, $B,  5,$92,$8D, $E,$4E,  0,$FA,$1C,$96,  0,  0,  0,  0,$74,$9F,  0,  5,$8A,$F0,$4E,  0,$FA,$1D,$40,  8, $F, $E,  0,  0,  0,$AC,$88,$90,$B2,$94,$78,$80,$3A; 192
		dc.b $74,$74,$9F,  4,$E0, $F,$A3,$C8,  0,$68,  0,  0,  1,$E8,$F4,$52,  0,  0,  1,$D1,$D3,$A3,$A7,$40,  9,$70,$4E,  0,$FA,$3C,$80,$16,  0,  0,  0,$58,$8F,$80,  5,$20,  0,$1D,$1D,$25,$3A,$74,  0,  0,$A4,$61,$28,$E0,$F4,$E0, $F,$A3,$C8,  1,$60,  0,  0,  5,$88,$F5; 256
		dc.b   0,$2A,  0,  1,$D1,$D3,$A3,$A7,$40, $A,$40,$1F,$53,$90,  2,$C0,  0,  0, $B,$11,$EA,  0,$58,  0,  0,  3,$A7,$47,$40,  0, $D,  0,$3E,$A7,$20,  1,  0,  0,  0,  1,$25,$C0,$C0,  2,$5C, $D,$80,$3E,$97,$C0,  5,$41,  1,$43,$15,$80,  0,  0,$12,$20,$1C,$30,  0,  0; 320
		dc.b   3,$20,  0,  0,$12,$80,  0,  0,$28,  0,$FA,$5C,$15,  0,$29,$D4,$28,  0,  0,  0,  3,$60,  0, $A,  0,  0,$15,$7D,$3F,$62,  0,$1D,$1D,$3A,  0,  0,$74,$E8,$E8,  0,  2,$C0,  0,  0,  0,  5,  0,  0,$15,  0,  0,$2C,$FA,$7D,$43,$80,$3A,$3A,$74,  0,  0,$E9,$D1,$D0; 384
		dc.b   2,$C4,$79,$80,$15,  0,  0,$58,  0,  0,$BB,$E8,  1,$DC,$10,$18,$40,$55,$60,  0,  0,$16,  0,  0,$2C,  0,  0,$B0,  1,$1E,$60,  5,$80,  0,$17,  0,  0,$30,$FA,$18,$40,  0,$A3,$C4,  1,$D3,$A0,  4,$7C,  7,  0,  0,  0,$68,$AC,$C0,$BC,$14,$13,  8,$30,$46,$4D,$15; 448
		dc.b $94,  0,$7B,  8,  0,$14,$78,$80,$3A,$74,  0,$8F,$30,$C0,  0,  0, $D,$80,  0,$4A,$85,$29,$29, $E,  5,$40,$1E,$C2,  0,  5,$1E,$20, $E,$9D,  0,$23,$C8,$28,  0,  0,  2,$60,  8,$F0,$74,  0,$8F,  2,$C0, $F,$73,  0,  2,  8, $C,$20,$2A,$A0,  4,$78,$A9,  9,  4,  6; 512
		dc.b $8F,  2,$80,  8,$F0,$74,  0,$8F,  2,$E0, $F,$A3,$C8,  1,$50,  0,  0,  5,$29,$F6,$52,  0,  0,$B0,  0,  2,$50,  0,  5,$80,  0,$15,  0,$3E,$8F,$20,  1,$20,  0,  0,  2,$A5,$C0,  1,$62,$30,$9D,  0,$21,$C0,  1,$63,$E8,$80,$87,  0,  4,$A9,$70,$52,  0,$8F,$10,  7; 576
		dc.b $4E,$8E,$92,$E0,$A8,  1,$F4,$38,$80,$2C,  0,  0,  2,$5C, $C,$80,$25,$C1,$D0,  2,$5C, $A,$80,$3E,$87,$25,$80,  0,  0,  0,$16,$25,$E0,$D0,  3,$A3,$A0,  0, $B,  0,  0,  0,$2C,  0,  0,$74,$E8,  0,$B0,  3,$E8,$72, $C,  0,  0,  1,$60,  2,$5E, $D,$80,$3A,$3A,  0; 640
		dc.b   0,$BC,$B1,$61,$62,$F0,  0,  7,$4E,$80, $B,$80,$3E,$87,$20,$E0,  0,  0,  3,$80,$23,$CC,$F8,$F2,$B0,  7,$47,$40, $B,$D1,$E8,  0,$BC,  1,$D3,$A0,  5,$64,$48,$C0,$1F,$E4,$20,  0,  0,  0,$60,  4,$78,$20,  0,$47,$A2,$F0,  0,  5,$CB,$8B,$80,  0,$2F,  0,$47,$82; 704
		dc.b $40,  7,$E0,$A7,$27,$E0,$9C,  1,$1E,$E8,$40,  0,  0,  0,$2F,  0,  0,$B4,$B5,$69,$6A,$D0,  0,  5,$E8,$F0,$3A,  0,$FA,$9E,$92,$80,  0,$3A,$74,$58,  0,$B9,$68,  0,  0,  5,$A5,$C0, $B,$1D,$1D,  0,  0,$4A,  0,$FA,$9E,$91,$80,  0,$3A,$74,$58,  0,$B9,$68,  3,$C0; 768
		dc.b   5,$A5,$C0, $B,$1D,$1D,  0,  0,$3E,  0,$FA,$9E,$95,  0,  0,$3A,$74,$58,  0,$B9,$68,  0,  0,  5,$A5,$C0, $B,$1D,$1D,  0,  0,$52,  0,$FA,$9E,$40,$15,  0,  0,  0,$5E,  0,  1,$69,$6A,$D2,$D5,$A0,  0, $B,$C0,  0,  0,$29,$7D,$5E,  0,  7,$D1,$EC,$BC,  0,  1,$72; 832
		dc.b $E2,$E0,  0, $B,$C0,  0,  0,  0,$23,$7D,$5E,$60,  9,$40,  0,$3A,$3A,  0,$5E,$8F,$30,  5,$E0, $E,$9D,  0,  0,$25,$7D,$5F,$20,  8,$40,  0,$3A,$3A,  0,  0,$BC,$B1,$61,$62,$F0,  0,  7,$4E,$80,  0, $E,$BE,$AF,  0,  5,$89,$71,  0,$74,$E8,$E9,$2E,  0, $B,$1F,$5B; 896
		dc.b $82,$C0,  4,$78,$80,$3A,$74,$74,$97,  5,$80, $F,$AD,$C8,  1,$61,$F2,$54,$24,  8,$F2,  0,$3C,$74,$95,$19,$63,$EC,$F0,  0,$3E,$8F,  0,  3,$EF,$B7,$CC,  0,$F1,$D0,  0,  0,  8,$48,$1F,$73,$91,$E0,  0,  0,  8,$80,$1F,$73,$91,$F0,  0,  0,  8,$C0,$1F,$72, $A,$72; 960
		dc.b $7E,  9,$C0,$1F,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$43,$F8; 1024

S1SS_3:		dc.b  $B,  7,  0,  2,  0,  0,$63,$90,  0,$62,  2,$8C, $E,$FB,$5C,$80,  6,$1C,$AC,$90,  4,$78,$8C,$56,$40,$4B,$EB,$72,  0,$A8,$20,$31,  0,$15,$E2,$18,$20,$A5,$2F,$A9,$C2,$A0,  4,$78,$F4,$75,$D0,  2,$3C,$7A,$3A,$E8,  1,$1E,$14,$80,$3E,$97,  0, $A,$92,$E3,$D1,$D7; 0
		dc.b $40,  8,$F1,$E8,$EB,$A0,  4,$78,  0,$52,$FA,$5C,  0,  4,$6B,$80,  0,$6F,$A5,$F0,  0,$30,  0,$29,  0,$E8,$EB,$A0, $B,  0,$3A,$3A,$E8,  2,$C0, $E,$8E,$BA,  0,$A8,  0,  0,$47,$D2,  1,$1F,$3D,$1D,$74,  0,  0,  7,$47,$5D,  0,  0,  1,$D1,$D7,$40,  0,  0,  0, $A; 64
		dc.b $FA,$5C,  0,$2C,$6B,$80,  5,$8F,$F3,  0,$9C,$F0,$E3,$43,$2C,  0,$47,$80,  5,$68,$F0,  0,$95,$1E,  0,$15,$A5,$CA,$C0,$B3,  3,$4E,$27,$73,$80,  4,$E8,$F2,  0,$EB,$A0, $B,  0,$17,$E3,$60,  7,$47,$48,$F0,  0,$9D,$CE,  0,$13,$A3,$F0,  3,$AE,$80,$2C,  0,$E8,$EB; 128
		dc.b $A0,  0,  0,$3A,$3A,$E8,  0,  0, $E,$8E,$BA,  0,$B0,  3,$A3,$A4,$78,  0,$4E,$E7,  0,  9,$D1,$F8,  1,$D7,$40,$16,  0,$74,$75,$D0,  5,$40,$1D,$1D,$74,  1,$48,  7,$47,$5D,  0,$58,  1,$D1,$D2,$3C,  0,$27,$73,$98,  4,$E5,$86,$1A,$1D,$60,  2,$3D,$FA,$3A,$E8,  0; 192
		dc.b   0, $E,$8E,$BA,  0,  0,  3,$A3,$AE,$80,$11,$E5,$60,$61,$62,$48,$93,$BF,$C0,  2,$C6,$B8,  0,$58,$FA,$5C,  0,$12,$47,$80,  5,$88,$F0,  0,$95,$1E,  0,$16,$23,$C0,  1,  7,$D2,$E0,  1,$5B,$5C,  0,$2B,$7D,$2E,  0,  6,$23,$E7,$A3,$AE,$80,  0,  0,$E8,$EB,$A0,  0; 256
		dc.b   0,$3A,$3A,$E8,  0,  0,  0,  4,$9F,$4B,$E0,  5,$20,  0,$4A,  1,$D1,$D7,$40,$15,$80,$74,$75,$D0,  5,$60,$1D,$1D,$74,  1,$28,  0,  5,$4F,$A5,$C2,$90,  4,$7B,$F4,$75,$D0,  0,  0,$1D,$1D,$74,  0,  0,  7,$47,$5D,  0,$23,$C2,$A0,  7,$D1,$E0,$80,  3,$7C, $E,  0; 320
		dc.b $7D,$1E,$12,$80,$29,$C0,  2,$55,$78,$4A,  0,$FA,$3C,$12,  0,$4B,$85,$80,  9,$F0,$B0,  1,$2E,  8,  0,$3E,$8F, $A,$80,$11,$E3,$D1,$D7,$45,$89,$72,  0,$B3,$A3,$AE,$80,$11,$E1,$48,  3,$E8,$FC,  0,$A8,  0, $B,  0,$3A,$3A,$E8,  2,$C3, $B,$CE,$AF,$30,$B0,  3,$A3; 384
		dc.b $AE,$80,$2C,  0,  0,$A5,$F4,$B8,  0,$2E,$8F,$9E,$8E,$BA,  0,$C0,$BE,$E2,$EB,$8B,$F0,  0,$E8,$EB,$A0,  0,  0,  0,$15,$7D,$2E,  0, $C,$27,$CE,$F2,$EB,$4B,$6D,$2E,$BC,  1,$2E,  0, $B,$3E,$97,  0,  6,$51,$EC,  1,$28,  0,$1D,$17,$5A,$7B,$69,$77,$40,  0,$12,$A3; 448
		dc.b $C0,  1,$77,$D2,$E0,  1,$62,$7C,$EF,$2E,$B4,$B6,$D2,$EB,$C0,$12,$E0,  1,$63,$FC,$C0,$27,$60,$5D,$61,$5B,  0,$11,$EF,$D1,$D7,$40,$18,$17,$DC,$5D,$71,$7E,  0,$1D,$1D,$74,  0,$8F,$2B,  6,$D4,$15,$58,$9D,$CE,  0,$13,$A3,$F0,  3,$AE,$80,$2C,  0,$E8,$EB,$A0, $B; 512
		dc.b  $C,$2F,$3A,$BC,$C2,$C0, $E,$8E,$BA,  0,$B0,  3,$A3,$A4,$78,  0,$4E,$E7,  0,  9,$D1,$E8,  1,$D7,$40,$16,  0,$74,$75,$D1,$62,$5D,  0,$2C,$E8,$EB,$A0, $B,  0,$3A,$3A,$47,$80,  4,$EE,$70,  0,$9D,$1E,$80,$1D,$74,  1,$60,  0,  0,$16,  0,$27,$CE,$C0,  0,  0,$2C; 576
		dc.b   0,$E8,$E9,$1E,  0,$13,$B9,$CC,  2,$77,$47,$9F,$20,$B0,  1,$4E,  0,$12,$AB,$CA,$C1,$E7,$49,$23,$27,$7F,$80,  5,$8D,$70,  0,$B1,$F4,$B8,  0,$48,$8F,$9E,$8E,$BA,  0,  0,  3,$A3,$AE,$80,  0,  0,$E8,$EB,$A0,  0,  0,  0,$22,$7D,$2F,$80, $E,$80,  1,$28,  7,$47; 640
		dc.b $5D,  0,$54,  1,$D1,$D7,$40,$14,$80,$74,$75,$D0,  4,$A0,  0,$11,$BE,$97,  0,  7,$9A,$E0,  1,$23,$E9,$70,  0,$A5,$4E,$3D,$1D,$74,  0,$9F,  0, $A,$9F,$4F,$85,$20,  9,$F1,$B0,$B2,$C0,  4,$F8,$54,  0,$FA,$7C,$80,$29,$90,$AD,$E0,  4,$78,$F4,$75,$D0,  2,$3C,$61; 704
		dc.b $2B,$88,$A9,$F5,$B8,$80,$41,  9,$62,$5C,$40,$2C,$90,$8D,$F6,$B8,$58,  0,$8F, $B,  0,$1F,$6F,$90,  3,$C0,  0,  0,$42,$FB,$9C,$80,$1F,  0,  0,  2,$27,$DC,$E4,  1,$28,  0,  0,$12,$BE,$E7,$20,  8,$40,  0,  0,$91,$F7,$39,  0,$44,  0,  0,  3,$AF,$B9,$C8,  2,$79; 768
		dc.b $C9,$E7,$27,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$D3,$FE; 832

S1SS_4:		dc.b  $B, $F,  0,  2,  0,  0,$4A,  8,$10,$1E,  0,$40,$16,$E6,  0,$7D,  1,$2A,$12,$24,$E0,  8,$C1,$4E,$4F,$C1,$38,  3,$9C,$81,  0,  0,  0,  4,  0,$B7,  3,$A0,  8,$F0,$4E,  0,$8F,$22,$80,  0,  0, $D,$80,$39,$C8,$18,  0,  0,  0,$60,  8,$F4,$3E,$3C,$74,$A9,$51,$2A; 0
		dc.b $92,$93,$A4,$69,$70,$4E,  0,$8F,$22,$A0,  0,  0, $D,  0,$39,$D0,$20,  0,  0,  0,$80,  0,  0,  0,$15,$AF,$D1,$38,  0,  0,  0,  5,$80,  0,  0, $C,$3B,$F8,$28,  0,  0,  0,$A0,  0,  0,$11,$80,$3A,$3A,  0,  0,$E8,$E9,$D0,  0,  3,$A7,$40, $A,$C8,$10,$91,$27,  0; 64
		dc.b   0,  1,$C8,$C0,  0,  0,  0,  2,$ED,$F8,  0,$12,$AC,$1C,$30,  0,  0,  0,$C0,  0,  0,$12,  0,$3A,$3A,$58,  0,$8F,$25,$87,$4E,$80, $F,  0,$25,$C8,$C8,  0,  0,  2,$A0, $D,$F0,  6,  0,$97,$90,  5,$80,  0, $E,$80,  0,$2C,  0,  0,$C0,  1,$80,  0,  2,$C0,  0,  7; 128
		dc.b $40,$11,$E6,$50,$6D,$60,  0,  0,  5,$63,$6D,$F5,  8,  0,$E8,$E9,$D0,  0,  0,  0,  5,$80, $A,$51,$E4,  0,$C1,$79,$72,$F3,  4,$7A,$24,$23,$44,$4A,$80,$7C,  0,  3,$A0,  4,$78,$19,  0,$6B,$E8,$50,  7,$47,$4E,$80,  0,  0,  0,$2C,  0,$52,  0,  1,$D0,  3,  2,$F5; 192
		dc.b $A0, $B,$4B,$D8,  0,$3A,  0,$94,$82,$8F,  0,  7,$49,$70,$30,  0,$D7,$D0,$C0, $E,$8E,$9D,  0,  0,  5,  8,  0,  0,$94,  0,  3,$A0,  0,  5,$C0, $F,$80,$17,  0,  0,$74,  1,$29,  5,$18,$2E,$8E,$B9,$2C,$3A,$74,  0,$5C,  1,$AE,  0, $B,$11,$F4,$A8,  0,  0,  0,  2; 256
		dc.b $A0,  0, $E,$80,$18,$17,$AD,  0,$5A,$5E,$C0,  1,$D0,  4,$A4,$14,$78,  0,$3A,$4B,$88,  1,$52,$85,$2C,$F5,  0,$58,  0,  1,$D1,$D2,$A0,  0,  0,  0, $A,$91,$E4,  0,$C1,$79,$72,$F3,  4,$7C,$A1,$20,$3E,$4A,$74,$90,  0,  3,$A0,  0,  0, $E,$8E,$9D,  0,  0,  0,$52; 320
		dc.b   0,$CF,$20,$60, $E,$8E,$80,  4,$A3,$DD,$10,  0,  2,$C0,  0, $C,  0,$18,  0,  0,$2C,  0,  0,$88,  1,$1E,$C6,$46, $B,$8B,  0,  0,$74,$74,$E8,  0,  0,  0,  2,$96,$78,$84,  0,  0,  0,  2,$3C,$90,$80,$3A,$3A,$58,  0,$8F,$25,$87,$4E,$80,$11,$80,$27,$C8,$A0,  3; 384
		dc.b $A3,$A7,$40,  8,$F0,$2E,  0,$C7,$E0,  0,$C0, $E,$9D,  0,  3,  0,  0,  0,$80,  1,$D1,$D0,  0,  7,$47,$4E,$80,  0,$1D,$3A,  0,$56,$3A,$78,$7D,$38,  2,$3C,  0, $D,$23,$C9,$28,  0,  0,  2,$C0, $C,$75,  0, $E,  0,$E9,$D0,  0,$40,  0,  0,  0, $A,$D7,$E0,$9C,  1; 448
		dc.b $2E, $B,  0,$12,$E0,$54,  1,$9E,$42,$40,  0,  0,$2C,  0,$47,$A2,$42,$34,$45,$2A,$49,$55,$15,$1E,$1D,$4B,$82,$70,  4,$BA,  0,$2C,  0,  0,$E8,$E9,$D0,  1,$40,  6,$79,  2,  0,  0,  0,  0,$B1,$6E,  8,$C0,$11,$E0,$9C,  1,$3E,$6B,  0,$1D,$1D,$3A,  0,$32,  0,$CF; 512
		dc.b   5,$20,  8,$F0,$58,  0,$AF,$30,  4,$28,  9,$4F, $E,$A7,  0,$4F,$99,$B0,  7,$47,$4E,$80,$16,  0,$33,$C9,$48,  3,$A3,$A7,$47,$40,$3B,$C0,$D0,  2,$3C,  0, $B,$33,$C8,$28,  3,$A2,$C7,$47,$40,$70, $A, $C,$E7,$33,$23, $A,$C0,  0,  0,  0,$15,$67,$A0,$60,  7,$47; 576
		dc.b $4B, $E,$80,  0,  0,  7,$77,$81,$60,  4,$78,$29,  0,$63,$A8,$70,  7,$47,$4E,$8E,$80,  0,  0,$2B,$12,  4,$E7,  2,$A0,  8,$F0,$52,  0,$C7,  0,  5,$8A,$70,$52,  0,$C7,$34,$E2,$E6,  9,$4D, $D,$AC,  0,$47,$80,  2,$B6,$7A,$AC,  0,  0,  0,  0,$E9,$D1,$D3,$A0,  0; 640
		dc.b   5,$2C,$70,$4E,  0,$8F,$30,  7,$4E,$8B,$1D,$1D,  0,$17,$67,$B0,  2,$C0,  0,  0, $E,$96,$16,$3A,  0,  0,  0,$20,  1,$7E,  9,$C0,$11,$E6,  0,$E9,$D1,$63,$A3,$A0,  2,$CD,$75,$56,  0,  0,$E9,$61,$63,$A0,  0,  0,  2,$40,$17,$E0,$9C,  1,$1E,$60, $E,$9D,$16,$3A; 704
		dc.b $3A,  0,$2A,$D7,$51,  0,  0, $E,$9D,$1D,$3A,  0,  0,  0,$2C,  1,$7E,$69,$C6,$CD,$12,$98,$17,$58,  0,$8F,  0,  5,$6D,$70,$12,  0,$8F,$20,  7,$4E,$80,  6,  0,$35,$C0,$60,  2,$3C,$15,  0,$35,$D8,  0,$18,$40,$50,$C5,$80, $E,$9D,  0,$29, $E,$1E,$58,$CF,  1,$60; 768
		dc.b   8,$F0,$54,  0,$E7,$20,  5,$80, $E,$9D,  0,$23,$D5,$60,  0,  0,  0,  2,$24,$82,$D2,$86,$8E,$27,$4B,$80,  1,$14,$78,  0, $F,$77,$B8,  2,$C0,  7,$4E,$8E,$9D,$1D,  0,  0,  0,$58,  0,  0,$78,  2,$3C,  0,$13,$A5,$C0,  0,$82,$3C,  0,  7,$3B,$CC,  1,$60,  3,$A7; 832
		dc.b $47,$4E,$8E,$91,$E0,$B0,$35,$2E,  0,  9,$D2,$E6,$38,$E9,$D1,$D3,$A0,  1,$80, $F,$70,$56,  0,$97,  7,$47,$49,$F0,  0,$4E,$97,$31,$A7,$4E,$8E,$9D,  0, $B,  0,$7B,$C8,  2,$C2,  2,$2A,$80,  0,$1D,$3A,$3A,$74,  0,  0,  1,$58,$5A,$51,$12,  4,$E8,$F3,  0,$16,  0; 896
		dc.b   0,  1,$D3,$A1,$27,$D1,$EA,$2C,  1,$D1,$D2,$C2,$C7,$47,$40,  0,  6,$80,$27,$CC,  0,$90,  0,  0,  7,$4E,$84,$5F,$47,$A8,$C0,  0,  7,$4E,$8E,$9D,  0,  0,  0,$1C,  0,$9F,  5,$80,  8,$F0,$58,  0,$FA,$3C,$86,$80,  0,  0,$74,$74,$8F,  1,$E0,  9,$F3,$58,  0,  0; 960
		dc.b $E8,  0,  2,$C0,  7,$D1,$E0,$38,  1,$3E,  4,  0,$13,$E6,$B0,  1,$D1,$D3,$A0,  5,$80, $F,$A3,$F8,  1,$62,$C2,$C5,$81,$80, $E,$9D,  0,$2B,$12,$4A,$18,$34,$38,$78,  0,  0,  5,$87,$40, $E,$80,$1D,$2C,  0,  0,$21,$C4,$88,$90,$B2,$77,$D0,$E4,  0,$34,  1,$D3,$A0; 1024
		dc.b   4,$BC,  0,$2A,$54,$54,$AC,  0,  1,$D0,  0,  1,$81,$A3,$80,  0,  0,  0,$27,$7D, $E,$A0,  9,$40,$1D,$3A,  0,  0,  0,$E8,$E9,$D0,  2,$5C,  0,$1D,$27,$C0,  1,$3B,$E8,$70,  0,$1E,$97,$57,$45,$8E,$80,  0,$1D,$3A,$3A,  0,  0,  0,$B1,$3E,  0,  9,$DF,$43,$80,  1; 1088
		dc.b   4,$BA,$BA,$3A,$74,  0,  0,$E9,$61,$D0,  0,  0,  7,$49,$71,  0,$1E,$40,$9D,$F4,$79,$12, $B,$18,$1A,$38,  1,$1E,$20, $E,$9D,$1D,$25,$C8,$89,$28,$B0,$C1,$A0, $F,$A9,$C8,  0,$81,$12,$95,$25,$28,$F2,  0,$58,$B0,$95,$61,$63,$ED,$72,$1C,$1E,$94,$44,$90,  3,$EF; 1152
		dc.b $BE,$FB,$EF,$BE,$FB,$EF,$BE,$FB,$EF,$BE,$FB,$EF,$BE,$FB,$EF,$BE,$FB,$EF,$BE,$FB,$EF,$BE,$FB,$EF,$B5,$FC; 1216

S1SS_5:		dc.b  $B, $F,  0,  2,  0,  0,$63,$90,  2,$74,$E4,$E9,$C9,$D7,$E6,  0,$81,  9,$12,$52,$44,$64,$4F,$A1,$C8,  0,$70,  0,  0,  2,$4B,$71,  0,$3A,$78,  1,$2E,  8,  7,$DF,$E4,  0,$34,  0,  0,  1,$15,$B9,$AC,  0,  0,  0,  0,$E9,$D1,$D2,$3C,$16,  0,$3D,$C8,  0,$60,  0; 0
		dc.b   0,  4,$A9,$F2,$4E,$44,  0,  0,  1,$52,$3D,$DD,$1D,$25,$3A,$74,  0,  0,  0,  1,$48,  0,  0,  3,$A9,$C0,$1B,$E4,  0,$2C,  0,  0,  0,$F4,$BC,  0,$27,  0,  0,$80,  1,$20,  0,  0,  0,  6, $C,  0,$17,  0,$30,$30,$47,$92,$20,  3,$C0,  0,  9,$DC,$E2,$48,  0,  0; 64
		dc.b $72,$5C,$93,$80,  0,  0,  0,$3C,$8E,$10,  6,$14,$40,$17,$A3,$C1,$59,  2,$3C,$13,$80,$37,$C8,$88,  0,  0,  1,$A0,  8,$F0,$48,  0,$97,$67,$45,$8E,$80,$17,$80,$2D,  0,$5E,  0,$E8,$B1,$D0,  2,$5C,$12,  0,$37,$C9,$28,  0,  0,  1,$80,  8,$F0,  0,$46,$97,$67,$45; 128
		dc.b $8E,$8B,$80,$16,$BF,$2D,  0,$5C,$E8,$B1,$D0,  2,$3C,  0,$11,$39,$C8,$78,  0,  0,  1,$60,  9,$70,$44,  0,$8F,$67,$45,$8E,$80,$17,$80,$2D,  0,$5E,  0,$E8,$B1,$D0,  2,$3C,$10,  0,$35,$D0,  0,$58,$C0,$D5,$60,  0,  0,  0,$14,$A5,$DC,  1,$22,$52,$25,$60,  0,  0; 192
		dc.b   0,$18,  0,$2F,  0,$5E,  0,$C1,$1E,$20,  9,$12,$8F,$37,$C0,$88,  2,$7C,$14,$80,$27,$D4,$F8,  0,  0,  0,  6, $C,  0,$17,  0,$30,$30,$47,$82,$10,  6,$F9,$80, $F,  0,  0,$E8,$E9,$D0,  2,$3C,$80,$14,$90,$11,$24,$16,$8F,  5,$80,  8,$F2,$74,$74,$94,$E9,$D0,  2; 256
		dc.b $3C,$16,  0,$37,$D0,$70,  0,  0,  7,$47,$4E,$80,$12,$80,$25,$C0,  0,$62,$3C,  0,$14,$A3,$C4,  1,$D3,$A3,$A4,$78,  0,$2A,$73,$98,$D0,  0,  0, $E,$8E,$9D,  0,$27,$C4,  1,$58,$E0,$F4,$78,$AC,$1F,$3C,  0,$97,$14,$44,$6B,  0,$1C,$E6,$B0,  0,  0,  3,$A3,$A7,$40; 320
		dc.b  $A,$F0,$22,  0,$8F,$30,  4,$92,$92,$A5,$25,$4A,$21,$77,$80,  2,$C4,$F9,  0, $D,$1C,$1E,$40,$B1,$2E,  4,$80,$11,$E6,  0,$8E, $A, $C,$14,$18,$23,$EE,$F0,$58,  0,$8F,$25,$82,  4,$44,$85,$80,$23,$CD,$60,  0,  3,$A7,$40,  2,$C0,$11,$E0,  0,$89,$1E,  0,  7,$9C; 384
		dc.b $E0,  0,$11,$1E,  0, $B,$14,$E6,  0,$B0,  1,$D3,$A0,  4,$A0,  8,$F0,  0,$42,$8F,  0,  3,$AE,$70,  0,  6,$8F,  5,$80, $A,$73,  0,$1C,  0,$E9,$D0,  0,$D0,  4,$79,$80,$25,  0,$74,$E8,  0,  1,$23,$80,$41,$74,$75,$C0,$48,  2,$9C,  0,  7,$A3,$C0,$70,  2,$3C,$C0; 448
		dc.b  $F,$80,$3A,$74,  0,$88,  1,$CE,$60, $A,$DD,$1D,$3A,$3A,$4A,  0,$A7,$20,  2,  0,  0,  0,  8,$25,$CC,  0,$F0,  3,$A7,$40,  8,$40,$1C,$E6,  0,$21,$D1,$D3,$A3,$A0,$E0, $A,$72,$58,  0,  0,  0,  0,$8A,$5C, $D,$80,$23,$C1,$28,  3,$9C,  0,  3,$A3,$C0,$30,  2,$7C; 512
		dc.b   0,$16,$23,$C0,  0,$92,$5C,$CD,$1D,$3A,$3A,$74,$74,$7C,  1,$CE,  0, $A,$51,$E0,$B0,  1,$3E,$6B,  0,  0,$1D,$3A,$3A,  0,$16,$97,$33,$27,$4E,$8E,$9D,$1D,$1E,  0,$73,$92,$90,  0,  0,  0, $B,$13,$E8,  0,$40,  0,  3,$A3,$A7,$40,  0, $A,$92,$E0,$B0,  1,$1E, $A; 576
		dc.b $80,$1B,$E0,  0,$A5,$1E, $B,  0,$13,$E0,  0,$45,$2E, $A,$80,$11,$E0,  0,$B1,$1E,  0, $A,$9C,$E6,  0,$1D,$D1,$D3,$A3,$A1,  0,  9,$F3,  0,$52,  0,$E9,$61,$D0,  2,$A4,$B8,$2C,  0,$47,$82,$A0,  7,$39,$80,  6,$74,$74,$E8,$E8,$38,  2,$7C,$C0,$14,$80,$3A,$58,$74; 640
		dc.b   0,$3D,$2E,  6,$C0,$11,$E4,$AC,$65,$28,$B9,$60,  6,$B9,$80,$25,$74,$74,$E8,$E9,$58,  2,$7C,$C0,$14,$80,$3A,$58,$74,  0,$95,$2E,$46,$80,$1D,$16,$3A,  0,$47,$88,  1,$43,$64,$EC,$F0,  0, $C,$8F,  0,$A0,  9,$F0,$1C,  0,$8F,  0,  2,$29,$72,$32,  0,$E8,$B1,$D0; 704
		dc.b   2,$5C,  0,$13,$B3,$C0,  0,$2A,$3C,  2,  0,$27,$C0,$78,  2,$3C,  0,  9,$25,$C9,$58,  3,$A2,$C7,$40,  9,$70,  0,$4E,$CF,  0,  5,$88,$F0,$52,  0,$9F,$32,  0,  0,  0,$15,$86,$8C, $B,$47,$80,  1,$64,$B9,$AB,$14,$2A,$2C,  0,  0,  1,$3B,$5C,$96,  0,  0,  0,  0; 768
		dc.b $52,$9F,$22,$20,  0,  0,  7,$80,$25,$C0,  0,$AA,$5C,$CD,  0,  0,  0,$30,$32,$68,$9D,$AE,$60, $B,$1D,$1D,$3A,$3A,$52,  0,$8F,  0,  2,$88,$F0,$20,  0,$97,  0,  2,$88,$F0,  0,$30,$F7,$30,  0,$EE,$8E,$9D,$1D,  6,  0,$47,$80,  1,$54,$78,$29,  0,$4B,$98,  2,$A0; 832
		dc.b   0, $B,  0,  0, $B,$BD,$CC,  0,$33,$A3,$A7,$47,$41,$40,$11,$E0,  0,$95,$1E,  0, $A,$52,$E6,$A8,  0,  0,  2,$C0,  0,  4,$AF,$73,  0, $A,$E8,$E9,$D1,$D0,$40,  4,$7B,  0,$17,  0,$74,$E8,$E8,  0,  2,$91,$93,$43,$65, $A,$92,$E0,  0,$55,$EE,$40, $A,$40,  0,  0; 896
		dc.b   2,$4B,$98,  1,$80,  0, $E,$8E,$9D,  0,$23,$D1,$D1,$D3,$A0,  7,$47,$40,  0,  0, $A,$3D,$C9,$48,  0,  0,  0,  1,$29,$F2,$58,  0,  0,$E9,$D1,$D2,$3D,$1D,$1D,$3A,  0,$74,$74,  0,  0,$D0,  3,$9C,$42,$83,  7,$29,$47,$80,  2,$54,$F8,  0,$2C,$4F,$9A,$C2,$C5,$80; 960
		dc.b   0,  0,  0,$16,$37,$C4,  8,$48,$20,$34,$F8,  0,  7,$53,$82,$C0,  4,$B9,$BA,$3A,$74,  0,  0,  1,$60,  3,$7C,  0,$80,$29,$C0,  0,$32,$9D,$80, $C,$2B,  0,  0,$58,  0,  1,$D1,$D3,$A0,  0,  5,$8E,$70,  2,  0,$A7,  0,  5,$8A,$F5,$36,  0,  0,$B0,  0,  2,$C1,$B2; 1024
		dc.b $82,$A5,$80,$1C,$E0,  4,  1,$4E, $B,  0,$15,$E6,$50,  0,  1,$D0,  0,  3,$20, $F,$70,  2,  0,$8F,$25,$60,$A1,$81,$C4,$16,$2D,$CC,$A8,  0,  3,$A0,  0,  6,$80,$1E,$E4,  4,$18,$38,$40,$90,$26,$79,$80,$18,  0,$74,  0,  0,$D8,  3,$ED,$F2,  0,$32,  0,  0,  0,$AB; 1088
		dc.b $EE,$72,  0,$34,  0,  0,  0,$B3,$EE,$72,  0,$36,  0,  0,  0,$BB,$EE,$72,  0,$4E,$9C,$9D,$39,$3B,$EF,$BE,$FB,$EF,$BE,$FB,$EF,$BE,$FB,$EF,$BE,$FB,$EF,$BE,$FB,$EF,$BE,$FB,$EF,$BE,$FB,$DF,$C0,  0; 1152

S1SS_6:		dc.b  $B, $F,  0,  2,  0,  0,$7D,$F7,$DF,$72, $A,$72,$7E,  9,$C0,$1F,$73,$91,$C0,  0,  0,  7,  0,$1F,$57,$88,  0,$40,$60,$48,$F5,  0,$3A,$78,$7C,  0,  1,$C0,  0,  0,  7,  0,$1F,$53,$D0,$80,$70,$C0,  0,  0,$15,  0,$A5,$1C,$52,  0,  0,  1,  9,$11,$C0,  0,  0,  9; 0
		dc.b $40,$1F,$4C,  6,$78,$1C,  0,$7F,$A0,  2,$70,$20,$29,$40,$40,$80,$81,  0,$4B,$88,  3,$A7,$47,$4A,$70,$38,  0,$FF,  0,  4,$EB,$71,  0,$74,$E8,$E9,$2E,$40, $B,  0,  0,$1C,  0,$7F,$80,  2,$74,$B9,  0,$3A,$74,$74,  0,$95,$3E,  0,  9,$52,$E0,$70,  1,$FE,  0,  9; 64
		dc.b $D1,$E4,  0,$B0,  1,$D3,$A3,$A4,$78,$80,$2C,$56,$58,$97,$20,  7,$4E,$80,  0, $E,$BF,$C8,  1,$38,$10,$10,$20,  9,$F9,$74,$74,$E8,  0,  0,  3,$A3,$A7,$40,  0,  0,  0,$1D,$3A,  0,  0,  0,$8C,  1,$F4,$38,  7,  0,$4F,$CB,$A3,$A7,$40,  0,  0,$1D,$1D,$3A,  0,  0; 128
		dc.b   0,  0,$E9,$D0,  0,  0,  4,$40, $F,$A1,$C0,$30,  2,$7D,$16,  0,  0,$30,$60,$60,  0,  1,$60,  2,$7C,$10,$80,$3F,$C0,  0,$22,$3D,$D2,$80,  0,  0,  0,$58,$BC,$BD,$78,  0,  0,  5,$E5,$EB,$CB,$11,$E4,$94,  0,  0,  0,  1,$F7,$C0,$4B,$8B,$A3,$A5,$85,$E9,$F2,  0; 192
		dc.b $5E,$B0,$E9,$D0,  2,$3C,  0, $F,$3F,$C0,  0,$12,$5E,$1D,$1D,  0,$2F,  0,$74,$E8,$B9,$71,$73,$A3,$A0,  5,$E0, $E,$9D,  0,$23,$C0,  0,$EB,$E8,$70,$52,  0,$8F,$87,$47,$40, $B,$C0,$1D,$2D,$2D,$5A,$5A,$B4,$E8,  1,$78,  3,$A7,$40,  8,$F0,$54,  0,$FA,$1F,$80,$80; 256
		dc.b $3A,$3A,  0,$58,  0,  1,$80,  0,  2,$E5,$A0,  0,  0,$16,$97,  0,  0,$60,  0,  0,$B0,  1,$D3,$A0,  3,$80, $F,$A1,$F9,$28,  3,$A3,$A0,  5,$60,  0,$18,  0,  0,$2E,$5A,  1,  0,  1,$69,$70,  0,  6,  0,  0, $A,$C0,$1D,$3A,  0,$4A,  0,$FA,$1F,$85,  0,$3A,$3A,  0; 320
		dc.b $58,  0,  1,$80,  0,  2,$E5,$A0,  0,  0,$16,$97,  0,  0,$60,  0,  0,$B0,  1,$D3,$A0,  2,$60, $F,$A1,$C1,$50,  2,$3E,$1D,$1D,  0,$2F,  0,$74,$B4,$B5,$69,$6A,$D3,$A0,  5,$E0, $E,$9D,  0,$23,$C1,$48,  3,$FC,  0,  5,$A5,$E1,$D1,$D0,  2,$F0,  7,$4E,$8B,$97,$17; 384
		dc.b $3A,$3A,  0,$5E,  0,$E9,$D0,  2,$3C,  0, $A,$3F,$C0,  0,$62,$5C,$5D,$1D,$2C,$2F,$4F,$90,  2,$F5,$87,$4E,$80,$11,$E0,  0,$55,$FE,  0,  3,$51,$EE,$94,  0,  0,  0,  2,$C5,$E5,$EB,$C0,  0,  0,$2F,$2F,$5E,$58,$8F,$24,$A0,  0,  0,  0, $B,$3E,$87,  1,$E0,  9,$F4; 448
		dc.b $58,  0,  0,$C1,$81,$80,  0,  5,$80,  9,$F0,$30,  0,$FA,$1C,$88,  0,  0,  0,$74,$74,$8F,$47,$47,$4E,$80,  0,  0,$3A,$3A,$74,  0,$9F,  3,$20, $F,$A1,$C8,$88,  0,  0,  7,$47,$48,$F4,$74,$74,$E8,  0,  0,  3,$A3,$A7,$40,  9,$F1,$26,$26,$4C,$9D,$FE,$40,  2,$C0; 512
		dc.b   0,$3A,$3A,$4B,$88,  2,$C5,$65,$88,$F2,  0,$74,$E8,$E8,  1,$62,$3C,  0,$13,$BE,$87,  1,$40,  8,$F0,  0,$4A,$9F,$20,  4,$A0, $E,$9D,$1D,$25,$C0,  1,$3B,$E8,$71,$14,  0,  0,$B1,$2E,$20, $E,$9D,$1D,$2D,$C0,  1,$3B,$E8,$70,$14,  0,$9F,$10,  7,$4E,$8E,$93,$82; 576
		dc.b $4C,$4F,$8A,$51,$32,$64,$EF,$A1,$C0,$50,  3,$1C,  0, $A,$3E,$A7,$A4,$A0,  0,  0,  5,  8, $F,  0,  0,  0,$A4,$29,$28,$9A,$A0,  0,  0,  6,  6,$4D,  0,$3E,$A7,$41,$40,  0,  0,  5,  0,  0, $D,$18,$16,$8F,$10,  2,$85,$45,$9F,$5B,$90,$A0,  0,  0,  2,$80,$1F,$72; 640
		dc.b  $A,$72,$7E,  9,$C0,$1F,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F6,$7F,$80,  0; 704

Art_EHZFlower1:	dc.l	     0,	       0,	 0,	   0,	     0,	     $98, $8880087,  $998088; 0
		dc.l	 $9899,	$9887777,  $988777,   $98887,	 $9988,	    $998,      $99,	   9; 8
		dc.l	 $9980,	   $9800,   $98098,   $98087,	$98088,	   $9899,  $998777,   $98777; 16
		dc.l	$98887,	   $9888,    $9888,	$988,	  $998,	     $99,      $99,	   9; 24

Art_EHZFlower2:	dc.l	 $DD00,	  $DCD50,   $5DD50,    $5500,	     0,	     $55,     $55D,	$5DC; 0
		dc.l	  $5DC,	    $5DD,     $5DD,	$5DD,	  $5DD,	    $55D,     $555,	 $55; 8
		dc.l	     0,	       0,	 0,	   0,	$DD000,	 $DCD500,  $5DD500,   $55000; 16
		dc.l	   $55,	    $5DD,    $5DDC,    $5DDC,	 $5DDD,	   $55DD,     $555,	 $55; 24

Art_EHZFlower3:	dc.l	    $C,	     $CC,     $CCD,	$DCD,	   $D5,	 $CD0005, $CCCD098,$CCDD5587; 0
		dc.l $CCDD5587,	$CCCD098,  $CD0005,	 $D5,	  $DCD,	    $CCD,      $CC,	  $C; 8
		dc.l	     0,	       0,  $CCCCD0,  $CCDCD0,  $CDDDD0,	 $CCD5D0,  $DDDD58,	 $87; 16
		dc.l	   $87,	 $DDDD58,  $CCD5D0,  $CDDDD0,  $CCDCD0,	 $CCCCD0,	 0,	   0; 24

Art_EHZFlower4:	dc.l	     0,	       0,	 0,   $88000,  $877800,	$9988780,   $98878,    $9877; 0
		dc.l   $999887,	$9899887, $8999988, $8900999, $9000099,	    $BEF,     $BBE,	 $BB; 8
		dc.l	     0,	       0,	 0,	   0,  $880000,	$8877800,$99988788,   $99887; 16
		dc.l	 $9877,	  $99877, $9889887,$98899998,$89900099,$90000BEF,     $BBE,	 $BB; 24

Art_EHZFlower5:	dc.l $11333111,$11333111,$33111333,$33111333,$33111434,$11334311,$11333111,$1133411B; 0
		dc.l $1133411B,$11333111,$11334311,$33111434,$33111333,$33111333,$11333111,$11333111; 8
		dc.l $11333111,$11333111,$33111333,$33111344,$33111434,$11334311,$11343111,$1134411C; 16
		dc.l $1134411C,$11343111,$11334311,$33111434,$33111344,$33111333,$11333111,$11333111; 24
		dc.l $11333111,$11333111,$33111333,$33111344,$33111445,$11334311,$11344111,$1134511E; 32
		dc.l $1134511E,$11344111,$11334311,$33111445,$33111344,$33111333,$11333111,$11333111; 40
		dc.l $11333111,$11333111,$33111333,$33111344,$33111456,$11334533,$11345331,$1134631F; 48
		dc.l $1134631F,$11345331,$11334533,$33111456,$33111344,$33111333,$11333111,$11333111; 56

Art_HPZUnusedBg:dc.l	     0,	       0,	 0,	   0,	     6,	     $67,     $677,    $6777,	     0,	       0,	 6,	 $67,$22100677,$77210677,$77721677,$77721677; 0
		dc.l	     0,	$6600000,$67711111,$77777777,$77777777,$77777777,$77777777,$77777777,	     0,	       0,$11000000,$77110000,$77771000,$77777100,$77777200,$77777210; 16
		dc.l	$67777,	 $677777, $6777777, $6777777,$67777777,$67777777,$67777777,$67777777,$77771677,$77771777,$77777777,$77777777,$77777777,$77777777,$77777777,$77777777; 32
		dc.l $77777777,$77777777,$77777777,$77777777,$77777777,$77777777,$77777777,$77777777,$77777210,$77777210,$77777721,$77777721,$77777721,$77777721,$77777721,$77777721; 48
		dc.l $67777771,$67777721, $6777721, $6777721, $6777210,	 $677210,   $62210,	   0,$77777777,$67777777,$67777777,$67777777,$67777777,$67777777, $6777777, $6777777; 64
		dc.l $77777777,$77777777,$77777777,$71777777,$21777777,$21677777,$21677777,$21677777,$77777721,$77777721,$77777721,$77777721,$77777721,$77777721,$77777210,$77777210; 80
		dc.l	     0,	       0,	 0,	   0,	     0,	       0,	 0,	   0, $6777772,	$6777772, $6777772,  $677721,	$67221,	  $62110,	 0,	   0; 96
		dc.l $10677777,$10677777,$10067777,   $67777,	  $111,	       0,	 0,	   0,$77772100,$77772100,$77721000,$72210000,$21000000,	       0,	 0,	   0; 112
		dc.l	     0,	       0,	 0,	   0,	     0,	       0,	 0,	   0,	     0,	       0,	 6,	 $67,	   $67,	    $677,     $677,	$677; 128
		dc.l   $660000,	$6771111,$67777777,$77777777,$77777777,$77777777,$77777777,$77777777,	     0,$10000000,$21000000,$72100000,$72100000,$72100000,$77210000,$77210000; 144
		dc.l	     0,	       0,	 0,	   0,	     0,	       0,	 0,	   0,	 $6777,	   $6777,    $6777,    $6777,	 $6777,	   $6777,    $6777,	$677; 160
		dc.l $77777777,$77777777,$77777777,$77777777,$72777777,$21777777,$21677777,$21677777,$77210000,$77210000,$77210000,$77210000,$77210000,$77210000,$77210000,$77210000; 176
		dc.l	     0,	       0,	 0,	   0,	     0,	       0,	 0,	   0,	  $677,	    $672,     $672,	 $21,	   $10,	       0,	 0,	   0; 192
		dc.l $21677777,$10677777,$10677777,   $67777,	$67777,	  $67772,   $66721,    $6210,$77210000,$72100000,$72100000,$72100000,$21000000,$10000000,	 0,	   0; 208
		dc.l	     0,	       0,	 0,	   0,	     0,	       0,	 0,	   0,	     0,	       0,	 0,	   0,	     0,	       0,	 0,	   0; 224
		dc.l	     0,	       0,	 0,	   0,	     0,	       0,	 0,	   0,	     0,	       0,	 0,	   0,	     0,	       0,	 0,	   0; 240

Art_HPZGlowingBall:
		dc.l $11111111,   $11111,	$1111,	  $1111,   $11122,  $111220,  $111200, $1112001; 0
		dc.l $11111111,$11112222,$12221100,$21000000,	 $1121,	 $122222,$12222211,$22233122; 8
		dc.l  $1120012,	$1220012,$11200122,$12200123,$12101224,$12001232,$12001222,$12001222; 16
		dc.l $22412221,$44222111,$42211111,$32111111,$21111111,$21111111,$21111111,$11111111; 24
		dc.l $22222211,$22222222,   $22222,	 $22,$11110000,$11111100,$11111111,$11111121; 32
		dc.l $10000000,$11000000,$21100000,$22110000,$22211000,	$2221100,  $221100,$10022110; 40
		dc.l $11111112,$11111111,$11111111,$11111111,$11111111,$11111111,$11111111,$11111111; 48
		dc.l $11002110,$21002211,$22100211,$12100211,$12110221,$12210021,$22210021,$22210021; 56
		dc.l $11111111,	  $11111,    $1111,    $1111,	$11122,	 $111220,  $111200, $1112001; 64
		dc.l $11111111,$11112222,$12221100,$21000000,	 $1121,	 $122222,$12222211,$22244122; 72
		dc.l  $1120012,	$1220012,$11200122,$12200124,$12101224,$12001242,$12001222,$12001222; 80
		dc.l $22412222,$44222222,$42222222,$42222222,$22222233,$22222333,$22223334,$22223344; 88
		dc.l $22222211,$22222222,   $22222,	 $22,$11110000,$11111100,$11111111,$11111121; 96
		dc.l $10000000,$11000000,$21100000,$22110000,$22211000,	$2221100,  $221100,$10022110; 104
		dc.l $22211112,$22222111,$22222211,$22222221,$33222221,$33322222,$43332222,$44332222; 112
		dc.l $11002110,$21002211,$22100211,$12100211,$12110221,$12210021,$22210021,$22210021; 120
		dc.l $11111111,	  $11111,    $1111,    $1111,	$11124,	 $111240,  $111400, $1114001; 128
		dc.l $11111111,$11112444,$12444100,$44000000,	 $1121,	 $123222,$12433322,$33344233; 136
		dc.l  $1140013,	$1240014,$11400133,$12400144,$12401344,$14001343,$14001343,$14001333; 144
		dc.l $43423333,$44333333,$43333344,$43334444,$33344444,$33344444,$33444444,$33444444; 152
		dc.l $22222211,$44422222,   $44422,	 $44,$11110000,$22111100,$22222111,$22222221; 160
		dc.l $10000000,$11000000,$21100000,$22110000,$42211000,	$4221100,  $421100,$10042110; 168
		dc.l $33322222,$33333222,$44333322,$44443332,$44444332,$44444333,$44444433,$44444433; 176
		dc.l $11004110,$21004211,$22100411,$22100411,$23110421,$23210041,$33210041,$33310041; 184

Art_UnkZone_1:	dc.l $12332411,$12334199,$12331999,$12331999,$12331999,$12343199,$12313311,$12222222; 0
		dc.l $11423333,$99143333,$99913333,$99913333,$99913333,$99133333,$11333333,$22222222; 8
		dc.l $33332411,$333341BB,$33331BBB,$33331BBB,$33331BBB,$333331BB,$33333311,$22222222; 16
		dc.l $11423321,$BB143321,$BBB13321,$BBB13321,$BBB13321,$BB134321,$11331321,$22222221; 24
		dc.l $12332411,$123341BB,$12331BBB,$12331BBB,$12331BBB,$123431BB,$12313311,$12222222; 32
		dc.l $11423333,$BB143333,$BBB13333,$BBB13333,$BBB13333,$BB133333,$11333333,$22222222; 40
		dc.l $33332411,$33334199,$33331999,$33331999,$33331999,$33333199,$33333311,$22222222; 48
		dc.l $11423321,$99143321,$99913321,$99913321,$99913321,$99134321,$11331321,$22222221; 56

Art_UnkZone_2:	dc.l $13333334,$11111111,$13333334,$13333334,$11111111,$13333334,$13333334,$14444444; 0
		dc.l $13333334,$11111111,$13333334,$13333334,$11111111,$13333334,$13333334,$14444444; 8
		dc.l $11111111,$14444445,$14444445,$15555555,$15555555,$11111111,$15555555,$15555555; 16
		dc.l $11111111,$14444445,$14444445,$15555555,$15555555,$11111111,$15555555,$15555555; 24
		dc.l $15555555,$15555555,$11111111,$15555555,$15555555,$14444445,$14444445,$11111111; 32
		dc.l $15555555,$15555555,$11111111,$15555555,$15555555,$14444445,$14444445,$11111111; 40
		dc.l $14444444,$13333334,$13333334,$11111111,$13333334,$13333334,$11111111,$13333334; 48
		dc.l $14444444,$13333334,$13333334,$11111111,$13333334,$13333334,$11111111,$13333334; 56
		dc.l $13333334,$13333334,$11111111,$13333334,$13333334,$13333334,$11111111,$14444445; 64
		dc.l $11111111,$13333334,$11111111,$13333334,$13333334,$11111111,$13333334,$14444445; 72
		dc.l $14444445,$14444445,$15555555,$11111111,$15555555,$15555555,$15555555,$15555555; 80
		dc.l $14444445,$11111111,$14444445,$15555555,$15555555,$15555555,$11111111,$15555555; 88
		dc.l $15555555,$11111111,$15555555,$15555555,$15555555,$14444445,$11111111,$14444445; 96
		dc.l $15555555,$15555555,$15555555,$15555555,$11111111,$15555555,$14444445,$14444445; 104
		dc.l $14444445,$13333334,$11111111,$13333334,$13333334,$11111111,$13333334,$11111111; 112
		dc.l $14444445,$11111111,$13333334,$13333334,$13333334,$11111111,$13333334,$13333334; 120
		dc.l $11111111,$13333334,$11111111,$13333334,$13333334,$11111111,$13333334,$14444445; 128
		dc.l $13333334,$13333334,$11111111,$13333334,$13333334,$13333334,$11111111,$14444445; 136
		dc.l $14444445,$11111111,$14444445,$15555555,$15555555,$15555555,$11111111,$15555555; 144
		dc.l $14444445,$14444445,$15555555,$11111111,$15555555,$15555555,$15555555,$15555555; 152
		dc.l $15555555,$15555555,$15555555,$15555555,$11111111,$15555555,$14444445,$14444445; 160
		dc.l $15555555,$11111111,$15555555,$15555555,$15555555,$14444445,$11111111,$14444445; 168
		dc.l $14444445,$11111111,$13333334,$13333334,$13333334,$11111111,$13333334,$13333334; 176
		dc.l $14444445,$13333334,$11111111,$13333334,$13333334,$11111111,$13333334,$11111111; 184

Art_UnkZone_3:	dc.l $11111111,$13111131,$13111131,$14333341,$12222221,$12222221,$11111111,$11111111; 0
		dc.l $11111111,$13111131,$13111131,$14333341,$12222221,$12222221,$11111111,$11111111; 8
		dc.l $13111131,$13111131,$14333341,$12222221,$12222221,$11111111,$11111111,$11111111; 16
		dc.l $11111111,$11111111,$13111131,$13111131,$14333341,$12222221,$12222221,$11111111; 24
		dc.l $11111111,$11111111,$13111131,$13111131,$14333341,$12222221,$12222221,$11111111; 32
		dc.l $13111131,$13111131,$14333341,$12222221,$12222221,$11111111,$11111111,$11111111; 40

Art_UnkZone_4:	dc.l $22222233,$15111111,$11111455,$11145555,$1115B555,$11455B55,$115555B5,$1155555B; 0
		dc.l $33434445,$11111151,$55411111,$55554111,$55555111,$55555411,$55555511,$55555511; 8
		dc.l $22222233,$15111111,$11111455,$1114555B,$1115555B,$1145555B,$1155555B,$1155555B; 16
		dc.l $33434445,$11111151,$55411111,$55554111,$55555111,$55555411,$55555511,$55555511; 24
		dc.l $22222233,$15111111,$11111455,$11145555,$11155555,$11455555,$11555555,$1155555B; 32
		dc.l $33434445,$11111151,$55411111,$55554111,$55B55111,$5B555411,$B5555511,$55555511; 40

Art_UnkZone_5:	dc.l $11111111,$15511222,$15511222,$11155111,$11155111,$12211551,$12211551,$12211115; 0
		dc.l $11111111,$12211222,$12211222,$11155111,$11155111,$12211551,$12211551,$12211115; 8
		dc.l $11111111,$12211222,$12211222,$11122111,$11122111,$12211551,$12211551,$12211115; 16
		dc.l $11111111,$12211222,$12211222,$11122111,$11122111,$12211221,$12211221,$12211115; 24
		dc.l $11111111,$12211222,$12211222,$11122111,$11122111,$12211221,$12211221,$12211112; 32
		dc.l $11111111,$12211555,$12211555,$11155111,$11155111,$15511221,$15511221,$15511112; 40

Art_UnkZone_6:	dc.l	     0,	       0,	 0,	   0,	     0,	$2222222,$22222222,$22222222; 0
		dc.l	  $234,	    $234,     $234,	$234,	  $234,$22000234,$22222234,$22222211; 8
		dc.l $43200000,$43200000,$43200000,$43200000,$43200000,$43200044,$43234444,$11233333; 16
		dc.l	     0,	       0,	 0,	   0,	     0,$55555500,$44455555,$33444444; 24
		dc.l	     0,	       0,	 0,	   0,	     0,	     $44,    $4433,    $3332; 32
		dc.l	  $234,	    $234,     $234,	$234,	  $234,$33300234,$32222234,$22222211; 40
		dc.l $43200000,$43200000,$43200000,$43200000,$43200000,$43200054,$43225543,$11354432; 48
		dc.l	     0,	       0,	 0,	   0,	     0,$32000000,$32220000,$22220000; 56
		dc.l	     0,	       0,	 0,	   0,	     0,	       0,	 0,	   0; 64
		dc.l	  $234,	    $234,     $234,	$234,	  $234,	    $223,    $2334,    $2211; 72
		dc.l $43200000,$43200000,$43200000,$43200000,$43200000,$45200000,$44500000,$11250000; 80
		dc.l	     0,	       0,	 0,	   0,	     0,	       0,	 0,	   0; 88

Art_UnkZone_7:	dc.l	     0,	       0,	 0,	   0,	 $8700,	 $688786,$87876887,$68767768; 0
		dc.l	     0,	       0,	 0,	   0,$80000000,$67600000,$87876007,$68767768; 8
		dc.l	     0,	       0,	 0,	   0,	 $8700,	 $688786,$87876887,$68767768; 16
		dc.l	     0,	       0,	 0,	   0,	   $68,	   $8786,$87876887,$68767768; 24
		dc.l	     0,	       0,	 0,	   0,$88778000,$67688780,$87876887,$68767768; 32
		dc.l	     0,	       0,	 0,	   0,	     8,	   $8786,$87876887,$68767768; 40
		dc.l	     0,	       0,	 0,	   0,	 $8000,	     $86,$80076887,$68767768; 48
		dc.l	     0,	       0,	 0,	   0,$88778760,$67688786,$87876887,$68767768; 56
		dc.l	     0,	       0,	 0,	   0,	     0,$67680000,$87876887,$68767768; 64
		dc.l	     0,	       0,	 0,	   0,	     0,$67600000,$87876800,$68767768; 72
		dc.l	     0,	       0,	 0,	   0,	   $68,	   $8786,  $876887,$68767768; 80
		dc.l	     0,	       0,	 0,	   0,$88700000,$67688780,$87876887,$68767768; 88
		dc.l	     0,	       0,	 0,	   0,$80000000,$67688700,$87876887,$68767768; 96
		dc.l	     0,	       0,	 0,	   0,	     0,	       6,$87000887,$68767768; 104
		dc.l	     0,	       0,	 0,	   0,  $778760,$67688786,$87876887,$68767768; 112
		dc.l	     0,	       0,	 0,	   0,  $778700,$67688786,$87876887,$68767768; 120
		dc.l	     0,	       0,	 0,	   0,	     0,$60000000,$87800087,$68767768; 128
		dc.l	     0,	       0,	 0,	   0,	$78700,	$7688786,$87876887,$68767768; 136

Art_UnkZone_8:	dc.l  $6600666,	$7777777, $8888888,	   0, $6600666,	$7777777, $8888888,	   0; 0
		dc.l	     0,	$6600666, $7777777, $8888888,	     0,	$6600666, $7777777, $8888888; 8
		dc.l  $8888888,	       0, $6600666, $7777777, $8888888,	       0, $6600666, $7777777; 16
		dc.l  $7777777,	$8888888,	 0, $6600666, $7777777,	$8888888,	 0, $6600666; 24

LevelLayout_Index:
		dc.w Level_GHZ1-LevelLayout_Index,Level_GHZBg-LevelLayout_Index,Level_Null-LevelLayout_Index
		dc.w Level_GHZ2-LevelLayout_Index,Level_GHZBg-LevelLayout_Index,Level_Null-LevelLayout_Index
		dc.w Level_GHZ3-LevelLayout_Index,Level_GHZBg-LevelLayout_Index,Level_Null-LevelLayout_Index
		dc.w Level_CPZ1-LevelLayout_Index,Level_CPZBg-LevelLayout_Index,Level_Null-LevelLayout_Index

		dc.w Level_CPZ1-LevelLayout_Index,Level_CPZBg-LevelLayout_Index,Level_Null-LevelLayout_Index
		dc.w Level_CPZ1-LevelLayout_Index,Level_CPZBg-LevelLayout_Index,Level_Null-LevelLayout_Index
		dc.w Level_CPZ1-LevelLayout_Index,Level_CPZBg-LevelLayout_Index,Level_Null-LevelLayout_Index
		dc.w Level_CPZ1-LevelLayout_Index,Level_CPZBg-LevelLayout_Index,Level_Null-LevelLayout_Index

		dc.w Level_CPZ1-LevelLayout_Index,Level_CPZBg-LevelLayout_Index,Level_Null-LevelLayout_Index
		dc.w Level_CPZ1-LevelLayout_Index,Level_CPZBg-LevelLayout_Index,Level_Null-LevelLayout_Index
		dc.w Level_CPZ1-LevelLayout_Index,Level_CPZBg-LevelLayout_Index,Level_Null-LevelLayout_Index
		dc.w Level_CPZ1-LevelLayout_Index,Level_CPZBg-LevelLayout_Index,Level_Null-LevelLayout_Index

		dc.w Level_EHZ1-LevelLayout_Index,Level_EHZBg-LevelLayout_Index,Level_Null-LevelLayout_Index
		dc.w Level_EHZ2-LevelLayout_Index,Level_EHZBg-LevelLayout_Index,Level_Null-LevelLayout_Index
		dc.w Level_EHZ1-LevelLayout_Index,Level_EHZBg-LevelLayout_Index,Level_Null-LevelLayout_Index
		dc.w Level_EHZ2-LevelLayout_Index,Level_EHZBg-LevelLayout_Index,Level_Null-LevelLayout_Index

		dc.w Level_HPZ1-LevelLayout_Index,LeveL_HPZBg-LevelLayout_Index,Level_Null-LevelLayout_Index
		dc.w Level_HPZ1-LevelLayout_Index,LeveL_HPZBg-LevelLayout_Index,Level_Null-LevelLayout_Index
		dc.w Level_HPZ1-LevelLayout_Index,LeveL_HPZBg-LevelLayout_Index,Level_Null-LevelLayout_Index
		dc.w Level_HPZ1-LevelLayout_Index,LeveL_HPZBg-LevelLayout_Index,Level_Null-LevelLayout_Index

		dc.w Level_HTZ1-LevelLayout_Index,Level_HTZBg-LevelLayout_Index,Level_Null-LevelLayout_Index
		dc.w Level_HTZ2-LevelLayout_Index,Level_HTZBg-LevelLayout_Index,Level_Null-LevelLayout_Index
		dc.w Level_HTZ1-LevelLayout_Index,Level_HTZBg-LevelLayout_Index,Level_Null-LevelLayout_Index
		dc.w Level_HTZ2-LevelLayout_Index,Level_HTZBg-LevelLayout_Index,Level_Null-LevelLayout_Index

		dc.w Level_CPZ1-LevelLayout_Index,Level_CPZBg-LevelLayout_Index,Level_Null-LevelLayout_Index
		dc.w Level_CPZ1-LevelLayout_Index,Level_CPZBg-LevelLayout_Index,Level_Null-LevelLayout_Index
		dc.w Level_CPZ1-LevelLayout_Index,Level_CPZBg-LevelLayout_Index,Level_Null-LevelLayout_Index
		dc.w Level_CPZ1-LevelLayout_Index,Level_CPZBg-LevelLayout_Index,Level_Null-LevelLayout_Index

Level_GHZ1:	dc.b $2F,  4,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 0
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,$38,  1,  1,  1,$24,  0,  0; 16
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 32
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 48
		dc.b   0,  0,  0,  0,$38,$24,  0,  0,$21,$26,$11,$11,$1F, $F,  0,  0; 64
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 80
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$2D,$31; 96
		dc.b $24,$14,$38,  4,$23,$25,$2D,$B5,$26,$11,$1F,$1E,$20, $F,  0,  0; 112
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 128
		dc.b   0,  0,$2D,$2D,  3,$31,$24,$10,  2,  7,  4,  5,$2B, $E,$1E,$11; 144
		dc.b $25,$1A,$26,$11,  8,  9, $A,$17,$1E,$1E,$20,$11,$1F, $F,  0,$10; 160
		dc.b   5,$2B,$16,  2,  3,$37,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 176
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 192
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,$1E,$1E,$1E,$20,$25,  7,$22; 208
		dc.b  $C, $D,$15,$19,$11,$25,$2D,$2D,$2D,$2D,  0,  0,  0,  0,  0,  0; 224
		dc.b   0,  0		; 240

Level_GHZ2:	dc.b $20,  5,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 0
					; DATA XREF: ROM:LevelLayout_Indexo
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 16
		dc.b   0,  0,  0, $E,$2B,$16,$1C,  5,$2B,$16,  2,$37,  0,  0,  0,  0; 32
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,$21,  3,  0,  0,  0,  0,$21,$31; 48
		dc.b $24,  0,  0,  0, $C, $D,  6, $C,$1E, $D,$15,$11,$25,$32,$2B, $B; 64
		dc.b $2D,$B5,$2D,  7,$24,$12,$38,$24,$2D,$26,  8,  5,$2B, $B,$21,$26; 80
		dc.b $1F, $F,  0,  0,  0,$1E,$1E,$1E,$1E, $A,$17,$1E,$1E, $C, $C, $D; 96
		dc.b $19,$11,  8,$17,$1E,$1E,$1E,$1E,$1E,$1E,$1E,$1E,$18, $D,  8,$23; 112
		dc.b $11,$20,$25,$2D,$2D,$2D,$1E,$1E,$1E,$1E,$1E,$1E,$1E,$1E,$1E,$1E; 128
		dc.b $1E,$1E,$1E,$1E,$1E,$1E,  0,  0,  0,  0,  0,$1E,$1E, $A,$17,$1E; 144
		dc.b $11,  8,$1D,  9,$1E,$1E,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 160
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$1E,$1E,$1E; 176
		dc.b $1E,$1E,$1E,$1E,$1E,$1E,$1E,  0; 192
Level_GHZ3:	dc.b $2F,  5,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 0
					; DATA XREF: ROM:LevelLayout_Indexo
		dc.b $2D,$37,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 16
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 32
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$13,$38; 48
		dc.b $18, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 64
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 80
		dc.b   0,  0,  0,  0,  0,$13,$38,$24,$14,  0,$13,$38,$27,  2,$1A,$26; 96
		dc.b $1F, $F,  0,  0,$14,$21,$2D,  0,  0,  0,$13,$33,$33,$10,$24,$2C; 112
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 128
		dc.b   0,  0,$2D,$37,$16,$1B,$23,$25,$1A,  3,  6,$26,$1F,$1E,$1E,$1E; 144
		dc.b $20,$25,$B5,$31,$1B,$23,$11,$33,$33,  2,$1A,$34,$34,$19,$25,  6; 160
		dc.b $31,$27,  0,$16,  2,  7,  2,$37,$2D,$2D,$2D,$3C,$3C,$2D,$2D,  0; 176
		dc.b   0,  0,$1E, $F,$15,$1E,$1E,$1E,$1E,$1E,$1E,$1E,$20,$1F,$1E,$1E; 192
		dc.b $1E,$1E,$1E,$1E, $C,$11,  9,$34,$34,$11,$1E,$1E,$1E,$1E,  0,  0; 208
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 224
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$1E,$1E,$20,$11,  8; 240
		dc.b   9, $A,$1D,  9,$1E,$1E,$1E,$1E,$1E,$1E,  0,  0,  0,  0,  0,  0; 256
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 272
		dc.b   0,  0		; 288
Level_GHZBg:	dc.b $1F,  0,$3D,$3E,$3A,$3F,$30,$39,$3B,$3D,$3A,$30,$3E,$39,$3D,$3B; 0
					; DATA XREF: ROM:LevelLayout_Indexo
		dc.b $3B,$3D,$3E,$3A,$3F,$3E,$3A,$3F,$30,$39,$3B,$3D,$3A,$30,$3E,$39; 16
		dc.b $3D,$3B		; 32

Level_EHZ1:	incbin "Levels/03/fg.bin"
		even

Level_EHZ2:	dc.b $7F, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 0
					; DATA XREF: ROM:LevelLayout_Indexo
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 16
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,$94, $F,$90,  0,  0,  0,  0,  0; 32
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 48
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 64
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 80
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 96
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 112
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 128
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 144
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,$94, $F,$90,  0,  0,  0,  0,  0; 160
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 176
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 192
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 208
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 224
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 240
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 256
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 272
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,$A1, $F,$90,  0,  0,  0,  0,  0; 288
		dc.b   0,  0,$19,$1A,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 304
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 320
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 336
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 352
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 368
		dc.b   0,  0,$93,$A2,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 384
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 400
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,$94,$90,  0,  0,$93,$84,$9D; 416
		dc.b $24,$25,$29,$2A,  0,$19,$1A,  0,  0,  0,  0,  0,  0,  0,  0,  0; 432
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 448
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 464
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 480
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 496
		dc.b   0,  0,$9F,$A8,  0,  0,  0,  0,  0,  0,$93,$A2,  0,$93,  0,  0; 512
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,$A2,  0,$84,$9D,$24,$25,$2B; 528
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,$62,$52,  0,  0,$B2,$94,$95; 544
		dc.b $26,$6F, $F,$3A,$3B,$29,$2A,  0,  0,$B7,$BC,$C4,$B7,$BC,$C4,$B7; 560
		dc.b $BC,$C4,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 576
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 592
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 608
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 624
		dc.b   0,  0,$8E,$8E,  7,$20,$BD,$83,  0,  0,$9F,$A8,  0,$B2,$8A,$24; 640
		dc.b $25,$16,$83,  0,$1F,  7,$20,  0,  0,$A8,  0,$BA,$A0,$AA,$B8,$A7; 656
		dc.b $3B,$3C,$8B,  0,  0,  0,  0,  0,  0,  0,$BD,  3, $B,$BA,$5A,$3E; 672
		dc.b $AA,$B8,$3E,  0,$43,$44,$3A, $D,$E5,$E6,  0,$E3,$C6,  0,$E3,$C6; 688
		dc.b   0,$EB,$EF,$8B,  0,$19,$1A,  0,  0,  0,  0,  0,  0,$A2,$93,  0; 704
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 720
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 736
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 752
		dc.b   0,  0, $F, $F, $F,$30,$4F,$4F, $B, $C,$98,  4,$45,$F6,$F6,$27; 768
		dc.b $28,$A3,$F6,  7,$2E, $F,$30,$3F,$2B,$98,$C9,$AB,$93,$26,$6F,$90; 784
		dc.b $43,$52,  0,$19,$1A,  0,  0,  0,  0,  0,$62,$BA,$91,$BA,$47,$7C; 800
		dc.b $26,$6F,$90,  0,  0,  0,  0,$62,$52,  0,  0,  0,  0,  0,  0,  0; 816
		dc.b $C8,$C8,$7F,$87,  9,$29,$2A,  0,  0,$B7,$BC,$C4,  0,$A8,$9F,  0; 832
		dc.b   0,  0,  0,  0,$A2,$93,  0,$A2,$A2,  0,$93,  0,  0,  0,  0,  0; 848
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 864
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 880
		dc.b   0,  0, $F, $F, $F, $F, $F, $F,$23,$26,$94, $F, $F, $F, $F,$23; 896
		dc.b $26,$94, $F, $F, $F, $F, $F, $F,$A7,$4F,$E8,$E9,$8E,$27,$28,$65; 912
		dc.b $2B,$12,  9,$29,$2A,  0,$19,$1A,  0,  0,  0,$44,$23,$8D,$6E,$5B; 928
		dc.b $27,$28,$65, $A,$C9,$14,  0,  0,$A2,  0,$93,$87,$46,$AE,$AD,$2C; 944
		dc.b $8D,$7C,$6E,$82, $F, $F,$3A, $D,$E5,$E6,  0,$EB,$EF,  2,  2,$8B; 960
		dc.b   0,  0,  0,$93,$A8,$9F,$93,$A8,$A8,$93,$9F,  0,  0,  0,  0,  0; 976
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 992
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1008
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1024
		dc.b   0,  0,  0,  0,  0, $F, $F, $F, $F, $F, $F, $F, $F,$23,$26,$94; 1040
		dc.b $A7,$22, $F, $F,$3A,$3B,$29,$2A,  0,  0,  0,$93,$4D,$D4,$6E,$BA; 1056
		dc.b $91,$AA,$BA,$5A,$3E,$2F,$ED,  0,$A8,$93,$9F,$49,$7E,$7E,$7E,$4D; 1072
		dc.b $D4,$6E,$59,$5A,$5A,$3E,  0,$62,$52,  0,  0,$12,$80,$80,$80,  9; 1088
		dc.b  $A, $D,$18,$8E,$8E,$8E,$8E,$8E,$8E,$8E,$8E,  0,  0,  0,  0,  0; 1104
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1120
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1136
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1152
		dc.b   0,  0,  0,  0,  0,  0, $F, $F, $F, $F, $F, $F, $F,$23,$26,$94; 1168
		dc.b  $F, $F, $F,$90,  0,$43, $F,$3A,$3B,$3C,$18,$8E,$4B,$5B,$6B,$82; 1184
		dc.b $23,$26,$82, $F, $F, $F,$90,$B4,$B2,$8E,$8E,$4A,$4B,$81,$81,$81; 1200
		dc.b $5B,$6B,$82, $F, $F,$90,$2C, $C,$98,$3B, $A,$22, $F, $F, $F, $F; 1216
		dc.b  $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F,  0,  0,  0,  0,  0; 1232
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1248
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1264
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1280
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1296
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1312
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1328
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1344
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1360
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1376
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1392
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1408
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1424
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1440
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1456
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1472
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1488
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1504
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1520
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1536
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1552
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1568
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1584
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1600
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1616
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1632
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1648
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1664
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1680
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1696
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1712
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1728
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1744
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1760
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1776
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1792
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1808
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1824
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1840
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1856
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1872
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1888
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1904
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1920
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1936
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1952
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1968
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1984
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2000
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2016
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2032
		dc.b   0,  0		; 2048

Level_EHZBg:	incbin "Levels/03/bg.bin"
		even

Level_HTZ1:	dc.b $7F, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 0
					; DATA XREF: ROM:LevelLayout_Indexo
		dc.b   0,  0,  0,  0,  0,$82, $F, $F, $F,$90,  0,  0,  0,  0,  0,  0; 16
		dc.b   0,  0,$A2,  0,  0,  0,  0,  0,  0,  0,$94,$90,  0,  0,  0,  0; 32
		dc.b   0,  0,$94, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 48
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 64
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 80
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 96
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 112
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 128
		dc.b   0,  0,  0,  0,  0,$82, $F, $F, $F,$90,  0,  0,  0,  0,  0,  0; 144
		dc.b   0,$10,$9E,  0,  0,  0,  0,$67,  0,  0,$AB,$52,  0,  0,  0,  0; 160
		dc.b $93,$A2,$94, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 176
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 192
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 208
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 224
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 240
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 256
		dc.b   0,  0,  0,  0,  0,$82, $F, $F, $F,$90,  0,  0,  0,$87,$46,  0; 272
		dc.b   0,$55,$63,  0,  0,$B4,$B4,$B5,$66,$67,$AB,$A2,$93,$A2,$57,$1A; 288
		dc.b $8E,$8E,$94, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 304
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 320
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 336
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 352
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 368
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 384
		dc.b   0,  0,  0,  0,  0,$82, $F, $F, $F,$90,  0,  0,  0,$64,$42,  0; 400
		dc.b   0,  0,  0,  0,  0,$8D,$73,  0,  0,$B5,$A3,$8E,$8E,$8E,$35,$36; 416
		dc.b  $F, $F, $F, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 432
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 448
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 464
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 480
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 496
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 512
		dc.b   0,  0,  0,  0,$C8,$BA,$5A,$5A,$5A,$3E,  0,  0,$93,  0,  0,  0; 528
		dc.b   0,  0,  0,$93,$84,$8D,  0,$B4,$F0,$F0,$82, $F, $F, $F,$39, $F; 544
		dc.b  $F, $F, $F, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 560
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 576
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 592
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 608
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 624
		dc.b   0,  0,$A2,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$10,$46; 640
		dc.b   0,  0,$A2,  0,$62,$54,$49, $F, $F,$95,  0,$10,$9E,  0,  0,  0; 656
		dc.b   0,$93,  0,$A8,$82,$95,$F0,$8D,$F1,$F1,$94,$90,$96,$96,$39, $F; 672
		dc.b  $F, $F, $F, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 688
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 704
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 720
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 736
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 752
		dc.b   0,  0,$A8,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$43,$42; 768
		dc.b   0,  0,$A8,  0,  0,  0,$6E,$40,$41,$95,$B3,$55,$63,  0,  0,  0; 784
		dc.b   0,$8C,$16,  2,$82, $F, $F,$8D,$5F,$49,$4E,$7C,$6E,$6E,$6E,$49; 800
		dc.b  $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F; 816
		dc.b  $F, $F, $F,$90,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 832
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 848
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 864
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 880
		dc.b   0,  0,  4, $D,$9D,$66,$67,  0,$A2,  0,  0,  0,  0,  0,  0,  0; 896
		dc.b   0,$34,$A6,$F0,$84,  3,$7B,$50,$51,$63,$73,  0,  0,$A2,$B1,$F0; 912
		dc.b $F0,$82, $F, $F, $F, $F,$96,$4E,$6E,$6E,$6E,$6E,$6E,$6A,$6B,$6E; 928
		dc.b $82, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F; 944
		dc.b  $F, $F, $F,$90,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 960
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 976
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 992
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1008
		dc.b   0,  0, $F,$90,$52,  0,$B5,$66,$A8,$12,  9,$E7,$F0,$F0,$85, $E; 1024
		dc.b $34,$33,$90,$F1,$94, $F,$90,$60,$61,  0,  0,  0,$12,$9E,$8D,$F1; 1040
		dc.b $F1,$82, $F, $F,$96,$7C,$74,$75,$5B,$59,$E0,$E0,$E0,$82, $F,$59; 1056
		dc.b $82, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F; 1072
		dc.b  $F, $F,$90,$63,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1088
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1104
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1120
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1136
		dc.b   0,  0, $F,$90,  0,  0,  0,  0,$C3,$22, $F,$90,$F1,$F1,$94,$B9; 1152
		dc.b $CC, $F,$90,$F1,$94, $F, $F,$70,$71, $D,$18, $A,$22,$90, $F,$F1; 1168
		dc.b $F1,$95,$3E,$7C,$74,$75,$B0,$6E,$BA,$5A,$F1,$F1,$F1,$94,$69,$BA; 1184
		dc.b $5A,$5A, $F, $F, $F,$96,$96,$96,$96,$96,$96, $F, $F, $F, $F, $F; 1200
		dc.b  $F, $F,$90,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1216
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1232
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1248
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1264
		dc.b   0,  0, $F,$90,  0,  0,  0,  0,  0,$82, $F,$90,$F1,$F1,$94, $F; 1280
		dc.b  $F, $F,$90,$F1,$94, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F,$F1; 1296
		dc.b $F1, $F,$95,$6B,$B0,$D3,$6E,$77,$47,$A1,$96, $F, $F, $F,$69,$47; 1312
		dc.b $49,$96,$96,$5F,$5F,$6E,$6A,$4A,$6B,$6E,$6E,$5F,$40,$41, $F, $F; 1328
		dc.b  $F, $F,$63,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1344
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1360
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1376
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1392
		dc.b   0,  0, $F,$90,  0,  0,  0,  0,  0,$82, $F,$90,$F1,$F1,$94, $F; 1408
		dc.b  $F, $F,  0,  0,  0,  0, $F, $F, $F, $F, $F, $F, $F, $F, $F,$F1; 1424
		dc.b $F1, $F, $F,$95,$E0,$8D,$59,$AF,$76,$77,$47,$A1, $F, $F,$69,$7D; 1440
		dc.b $6A,$4A,$4A,$4A,$6B,$E2,$82, $F,$95,$6E,$E4,$7B,$50,$51, $F, $F; 1456
		dc.b  $F,$3E,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1472
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1488
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1504
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1520
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1536
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1552
		dc.b   0,  0, $F,$90,$F1,$94,$95,$6E,$6E,$AF,$76,$6E,$47,$5F,$68,$BA; 1568
		dc.b $5A,$90, $F, $F,$95,$95,$82, $F, $F,$6E,$49,$82,$60,$61,$40,$41; 1584
		dc.b $95,$53,  0,  0,  0,  0,$57,$1A,$8F,  0,  0,  0,  0,$A2,$93,$A2; 1600
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1616
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1632
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1648
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1664
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1680
		dc.b   0,  0, $F,$90,$F1,$94,$95,$E0,$E0,$E0,$E0,$59,$5B,$4A,$4A,$82; 1696
		dc.b  $F,$90, $F, $F,$95,$95,$82, $F, $F,$6E,$6E,$82,$70,$71,$50,$51; 1712
		dc.b $95,  0,  0,  0,$84,$18,$35,$36,  0,$A2,$93,  0,  0,$A8,$A8,$A8; 1728
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1744
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1760
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1776
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1792
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1808
		dc.b   0,  0, $F,$90,$F1,$94,$90,$F1,$F1,$F1,$F1,$A1,$94, $F, $F,$94; 1824
		dc.b  $F,$90, $F, $F,$95,$95,$82, $F, $F,$6E,$6E,$82, $F, $F,$60,$61; 1840
		dc.b $53,  0,  0,  0,$82, $F,$31,$80,$20,$A8,$A8,$2D,$16,  2,  2,  2; 1856
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1872
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1888
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1904
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1920
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1936
		dc.b   0,  0, $F,$90,$F1,$94,$90,$F1,$F1,$F1,$F1,$F1,$A1, $F, $F, $F; 1952
		dc.b  $F,$90, $F, $F,$95,$95,$82, $F, $F,$6E,$6E,$82, $F, $F,$70,$71; 1968
		dc.b  $D,$18, $A,$C9,$82, $F, $F, $F,$30,  4,  4,$3D, $F, $F, $F, $F; 1984
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2000
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2016
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2032
		dc.b   0,  0		; 2048
Level_HTZ2:	dc.b $7F, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 0
					; DATA XREF: ROM:LevelLayout_Indexo
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 16
		dc.b   0,  0,$82, $F, $F, $F, $F,$95,  0,  0,$82, $F, $F,$95,$5F,$5F; 32
		dc.b $5F,$5D,$5C,$A1, $F, $F,$63,  0,  0,  0,  0,  0,  0,  0,  0,$49; 48
		dc.b  $F, $F, $F, $F, $F, $F, $F,$90,  0,  0,$DA,$66,$67,  0,$94, $F; 64
		dc.b  $F, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 80
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 96
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 112
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 128
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 144
		dc.b   0,$A2,$82, $F, $F, $F, $F,$63,  0,  0,$82, $F, $F,$95,$6E,$5B; 160
		dc.b $4A,$D1,$6E,$6E,$49,$96,$96,$BE,$57,$1A,  0,  0,  0,  0,  0,$6E; 176
		dc.b $47,$49, $F, $F, $F, $F, $F,$90,  0,  0,$D9,  0,$B5,$66,$94, $F; 192
		dc.b  $F, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 208
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 224
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 240
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 256
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 272
		dc.b   0,$A8,$40,$41, $F, $F,$3E,  0,  0,  0,$82, $F,$96,$95,$6E,$49; 288
		dc.b $96,$BE,$D0,$5B,$4A,$4A,$4A,$4A,$35,$36,  0,  0,  0,  0,  0,$59; 304
		dc.b $D0,$D1,$47,$49, $F, $F, $F,$90,  0,  0,$CC,$CD,$CE,$AE,$94, $F; 320
		dc.b  $F, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 336
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 352
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 368
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 384
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,$67,  0,  0,  0,$84,$18,$38; 400
		dc.b  $A,  4,$50,$51, $F, $F,$95,$8F,  0,  0,$A1, $F, $F,$95,$4A,$4A; 416
		dc.b $6B,$6E,$5F,$5F,$5F,$82,$95, $F,$72,$63,$1F,$D8,$F0,$F0,$F0,$94; 432
		dc.b  $F,$90,$6E,$D3,$47,$49, $F,$90,  0,$1C,$AB,$B6,$67,$DC,$44, $F; 448
		dc.b  $F, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 464
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 480
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 496
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 512
		dc.b   0,  0,  0,  0,$A2,  0,  0,  0,$B4,  0,$66,$67,  0,$82,$82,$39; 528
		dc.b  $F, $F,$60,$61,$40,$41,$95,  0,  0,  0,$6E,$47,$5F,$A1,$BE,$5F; 544
		dc.b $5F,$6E,$6E,$6E,$5B,$82,$95, $F,$31,$87,$2E,$90,$F1,$F1,$F1, $F; 560
		dc.b  $F,$90,$E0,$AB,$6E,$D3,$47,$5F,  0,$CB,$90,$DB,$B5,$66,$67,$94; 576
		dc.b  $F, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 592
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 608
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 624
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 640
		dc.b   0,  0,  0,  0,$A8,  0,$B4,$F0,$8D,$F4,$F4,$F4,$B3,$8D,$73,$9C; 656
		dc.b  $F, $F,$70,$71,$50,$51,$95,  0,  0,$34,$7B,$D0,$5B,$4A,$4A,$4A; 672
		dc.b $E2,$58,$58,$E4,$82, $F, $F, $F, $F, $F,$96,$BE,$96, $F, $F, $F; 688
		dc.b  $F,$90,$F1,$90,$E0,$94,$D0,$4A,$8A,$94,$90,$43,  0,$CD,$B5,$94; 704
		dc.b  $F, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 720
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 736
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 752
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 768
		dc.b   0,  0,  0,$85,$A6,  0,$8D,$F1,$AB,$F1,$F1,$F1,$94,$95,  0,$9C; 784
		dc.b  $F, $F, $F, $F,$60,$61,$53,  0,  0,$9C, $F, $F, $F, $F, $F,$82; 800
		dc.b  $F, $F, $F,$82, $F, $F, $F, $F,$95,$73,  0,  0,  0,$64,$44, $F; 816
		dc.b  $F, $F,$F1,$BE,$47,$49,$96,$96, $F, $F,$90,$CD,$CE,$B6,$AC,$44; 832
		dc.b  $F, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 848
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 864
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 880
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 896
		dc.b   0,  0,  0,$A0,$5A,  0,$A1, $F,$90,$96,$96,$96, $F, $F,$37,$33; 912
		dc.b  $F, $F, $F, $F,$70,$71, $D,$18, $A,$33, $F, $F, $F, $F, $F, $F; 928
		dc.b  $F, $F, $F, $F, $F, $F, $F, $F,$63,  0,  0,  0,  0,  0,  0,$82; 944
		dc.b  $F, $F,$F1,$69,$6E,$6E,$77,$6E,$47,$49,$90,$B6,$67,  0,$42,  0; 960
		dc.b $62,$54,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 976
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 992
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1008
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1024
		dc.b   0,  0,  0,$A1,$95,  0,$A0,$63,$52,  0,  0,  0,$94, $F,$72,$63; 1040
		dc.b $54,$44,$94,$AB,$63,$54,$54,$54,$44, $F, $F, $F, $F, $F, $F, $F; 1056
		dc.b  $F,$D4,$5F,$5F,$5F,$5F,$5F,$7C,$9F,  0,  0,  0,  0,  0,  0,$82; 1072
		dc.b  $F, $F, $F,$69,$59,$59,$AF,$76,$77,$6E,$AB,$DB,$B5,$66,$67,  0; 1088
		dc.b $A2,$93,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1104
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1120
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1136
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1152
		dc.b   0,  0,$1B,$A1,$95,  0,$73,  0,  0,  0,  0,  0,$62,$44,$31,  9; 1168
		dc.b $38,$14,$64,$73,  0,$10,$46,$9F,  0,$62,$49, $F, $F, $F,$D4,$5F; 1184
		dc.b $7C,$6E,$86,$88,$E4,$9A,$58,$58,  2,$18,$14,  0,  0,  0,  0,$82; 1200
		dc.b  $F, $F, $F,$69,$94,$90,$6E,$6E,$AF,$76,$AB,$43,  0,  0,$B5,$66; 1216
		dc.b $A8,$B2,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1232
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1248
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1264
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,$A2,  0,  0,$93,  0,  0,$93,$57; 1280
		dc.b $1A,  0,$9C, $F,$95,  0,  0,  0,$B3,$66,$67,  0,  0,  0,$A1,$96; 1296
		dc.b $39,$2F,$C9,$84,$8F,$43,$42,$98, $D,$18,$D1,$47,$5F,$7C,$6E,$86; 1312
		dc.b $88,$6E,$6E,$86,$94, $F, $F,$90, $F, $F,$2F,$3F,$14,  0,$93,$49; 1328
		dc.b $96,$96,$D4,$68,$94,$90,$6E,$74,$75,$86,$AB,$F0,$F0,$F0,$F0,$F0; 1344
		dc.b $98, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1360
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1376
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1392
		dc.b   0,  0,  0,  0,  0,$10,  9,$2B,$A8,$2D,$14,$8C,$16,  6,$8E,$35; 1408
		dc.b $36,$1F,$CB, $F,$95, $E,  0,  0,$64,  0,$B5,$66,$67,  0,$67,  0; 1424
		dc.b $43,$54,$44,$63,$A2,  0,  0,$73,$62,$44,$95,$7B,$7B,$D0,$6E,$6E; 1440
		dc.b $6E,$6E,$7D,$BF,$BA,$5A,$5A,$5A,$5A,$5A,$5A,$5A,$2F,$3F,$8E,$78; 1456
		dc.b $D7,$4A,$4A,$E2,$94,$90,$75,$B0,$6E,$6E,$A1,$96,$96,$96,$96,$96; 1472
		dc.b $96,$96,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1488
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1504
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1520
		dc.b   0,  0,$9F,  0,  0,$55, $F,$A7,  4,$3D,$42,$47,$40,$41, $F,$31; 1536
		dc.b $80,$2E, $F,$53,$54,$42,  0,  0,$93,$A2,$57,$1A,$B5,$C2,$B5,$66; 1552
		dc.b $67,  0,  0,$93,$A8,$C5,$66,$67,  0,  0,$47,$49,$96,$4E,$6E,$6E; 1568
		dc.b $86,$6E,$47,$CF,$94, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F; 1584
		dc.b  $F, $F, $F, $F, $F,$90,$88,$76,$77,$6E,$6E,$6E,$6E,$6E,$6E,$6E; 1600
		dc.b $6E,$6E,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1616
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1632
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1648
		dc.b   0,  0,  2,$18,$14,  0,$A1, $F, $F, $F,  4,$7B,$50,$51, $F,$95; 1664
		dc.b $54,$54,$52,  0,  0,  0,  0,  0,$B2,$8E,$35,$36,  0,$64,$93,$93; 1680
		dc.b $1F,$16,  6,$8E,$98,$AB,  0,  0,$BD,  3,$D0,$4A,$D1,$6E,$6E,$6E; 1696
		dc.b $6E,$86,$6E,$88,$94, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F; 1712
		dc.b  $F, $F, $F, $F, $F,$90,$6E,$6E,$AF,$76,$77,$6E,$6E,$6E,$DD,$DD; 1728
		dc.b $59,$7B,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1744
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1760
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1776
		dc.b   0,  0, $F, $F,$B9,$F0,$A1, $F, $F, $F, $F, $F,$60,$61,$54,$73; 1792
		dc.b   0,$10,$46,$BB,$BB,$B3,  0,  0,$62,$94,$72,$BE,$1F,$8A,  8,  8; 1808
		dc.b $2E, $F, $F, $F, $F,$90,$F0,$F0,$94, $F, $F, $F,$95,$D0,$6E,$88; 1824
		dc.b $6E,$6E,$6E,$6E,$94, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F; 1840
		dc.b  $F, $F, $F, $F, $F,$90,$6E,$6E,$6E,$6E,$AF,$76,$6E,$E4,$F2,$F2; 1856
		dc.b $94, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1872
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1888
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1904
		dc.b   0,  0, $F, $F,$90,$F1,$A1, $F, $F, $F, $F, $F,$70,$71, $D,$18; 1920
		dc.b  $A,$33,$F3,$F4,$F4,$AB,$F0,$F0,$F0,$94,$31,$87,$2E, $F, $F, $F; 1936
		dc.b  $F, $F, $F, $F, $F,$90,$F1,$F1,$94, $F, $F, $F,$95,$95,$6E,$6E; 1952
		dc.b $6E,$6E,$6E,$6E,$94, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F; 1968
		dc.b  $F, $F, $F, $F, $F,$90,$E0,$E0,$E0,$E0,$E0,$E0,$59, $F,$F3,$F3; 1984
		dc.b $94, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2000
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2016
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2032
		dc.b   0,  0		; 2048
Level_HTZBg:	dc.b   3,  1,$D6,$DF,$EA,$EC,$F7,$F7,$F7,$F7; 0
					; DATA XREF: ROM:LevelLayout_Indexo
Level_CPZ1:	dc.b $7F, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 0
					; DATA XREF: ROM:LevelLayout_Indexo
		dc.b   0,  0,$3C,$3C,$3C,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 16
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,$3C,$3C,$3C,$3C,  0,  0,  0,  0; 32
		dc.b   0,  0,  0,  0,  0,  0,$3C,$3C,$3C,  0,  0,  0,  0,  0,  0,  0; 48
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 64
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 80
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 96
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 112
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 128
		dc.b   0,  0,$3C,$3C,$3C,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 144
		dc.b $18,$19,  0,  3,  0,  0,  0,  0,$3C,$3C,$3C,$3C,  0,  0,  0,  0; 160
		dc.b   0,  0,  0,  0,  0,  0,$3C,$3C,$3C,  0,  0,  0,  0,  0,  0,  0; 176
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 192
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 208
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 224
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 240
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 256
		dc.b   0,  0,  3,  3,$27,  0,  0,  0,  0,  0,  0,$11,  1,$1A,$25,$51; 272
		dc.b $28,$29,$70,$20,$44,$45,  1,  9,$3C,$3C,$3C,$3C,  9,  0,  0,  0; 288
		dc.b   0,  0,  0,  0,  0,  3,$3C,$3C,  3,  0,  0,  0,  0,  0,  0,  0; 304
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 320
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 336
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 352
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 368
		dc.b   0,  0,  0,  0,$11,  1,$23,  0,  0,  0,  0,  0,  0,  0,  0,  0; 384
		dc.b   0,  0,  0,$3C,  9,  1,  0,  1,$2B,$2C,  8,$21,$10,$70,$92,$61; 400
		dc.b $38,$39,  0,$78,$54,$87,  0,  0,$3C,$3C,$3C,$3C, $F, $F,  4,  5; 416
		dc.b   6,$4C,$3A,$3F,  0,$10,$1A,  0,  3,$84, $F, $F,$85,  3,  3,  3; 432
		dc.b   3,  3,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 448
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 464
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 480
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 496
		dc.b   0,  0,  2,  2,$21,  3,$33,$34,$25,$80,  4,  5,  6,  7,  4,  5; 512
		dc.b   6,  7,  8,$24, $F,  3,$25,$26,$3C,$2A,$1B,  2,$65,  0,$8B,$70; 528
		dc.b $49,$70,$70,$79,  0,  0,$11,  1,$46,  0,$11,$41,$2B,$2C,$14,$15; 544
		dc.b $16,$2F,$88,$15,  8,$65,$10,$25,$26,  0, $C,  0,  0,$50,  0,  0; 560
		dc.b $30,  3,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 576
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 592
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 608
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 624
		dc.b   0,  0,  0,  0,  0,  3,  3,  3,  3,  3,$14,$15,$16,$17,$14,$15; 640
		dc.b $16,$17,$1D,$1E,$1F,  0,$3C,$36,  2,$72,$20,$44,$6E,$25,$6B,  0; 656
		dc.b $59,$24,  4,  5,  6,  7,$21, $F,$56,$24,$21, $F,  0,  0,  0,$18; 672
		dc.b $19,  0,$17,$31,  2,$60,$65,  3,$36, $B,$1C, $B,  2,$5E,$5F,  2; 688
		dc.b $40,  3,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 704
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 720
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 736
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 752
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 768
		dc.b   0,  3,$27,$37,$2F,$8D,$3C,$30,  0,$71,$7A,$7E,$79,$86,$7D,  2; 784
		dc.b   2,  2,$14,$15,$16,$17,  6,  7,  4,  5,  6,$4C,$3A,$91,$7F,$28; 800
		dc.b $29,$70,$20,$63,$10,$79,$71,  3,  0,$2A,$20,  0,$4D,$4E,  0,$10; 816
		dc.b $23,  0, $F,  3,  3,  3,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 832
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 848
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 864
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 880
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$8B,$70; 896
		dc.b $70,$20,  0,$12,$13,  2,  2,$40,$8E,$32,  0,  0,  0,$10,$79,$3C; 912
		dc.b $72,$20,  0,$50,$12,$13,$16,$17,$14,$15,$16,$2F,$1F,$90,$40,$38; 928
		dc.b $83,$19,$71,$3C,$73,$68,$69,$10,$25,$26,$78,$8A,$5D,$5B,$58,$66; 944
		dc.b $33,$34,  0,  3,  3, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 960
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 976
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 992
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1008
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$71,  0; 1024
		dc.b $3C,$78,  2,$22,  0,  0,  9,$2A,$41,$42,$43,  6,  7,$65,$10,$70; 1040
		dc.b $79,$78,  8,$40,$22,  0,  0,$3C, $C, $D,$20,$67,$8F,$52,$72,$49; 1056
		dc.b $28,$29,$79,  0,  0,$71,$3C,$71,$72,$6D,$53, $E, $D,$55,  1, $C; 1072
		dc.b   9,  1,  1,  1, $A,  9,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1088
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1104
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1120
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1136
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$71,  0; 1152
		dc.b $3C,$73,$20,$3C,$35, $B,  3,  3,$72,$79,$15,$16,$17,$60,$65,$18; 1168
		dc.b $19,$73,$20,$3C,  0,  9, $D,$1B,$1C,  3,$71,$73,$70,$62,$60,$31; 1184
		dc.b $38,$39,$3C,$2D,$2E,$71,$3C,$5C,$71,  0,  0,  3, $F,$71,  3,$1C; 1200
		dc.b   3,  3,  3,  3,  3,  3,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1216
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1232
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1248
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1264
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$71,  3; 1280
		dc.b $3C,  0,$74,  8, $F,$3C,$3C,  0,$71,  0,  0,  0,  0,$71,$7C,$28; 1296
		dc.b $29,$70,$77,$31,$4A,$8C,$3C,$3C,$2A,$25,$6B,$10,$70,$76,$73,$20; 1312
		dc.b $48,  0,  0,$3D,$3E,$64,$2C,$6C,$57,$4F,  0,$10,$70,$79,  0,  0; 1328
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1344
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1360
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1376
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1392
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$73,$20; 1408
		dc.b $3C,  0,  0,$3C,$2A,$3B,$3B, $B,$60,  2,  0,  0,  8,$60,$40,$38; 1424
		dc.b $83,$2E,$3C,  3,  0,$17,$89,$8A, $F,$86,$7B,$66,  0,$71,  3,$78; 1440
		dc.b $31,  2,  2,  2,$39,$73,$20,$5A,$6F,$31,$31,$65,  0,  0,  0,  0; 1456
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1472
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1488
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1504
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1520
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$74; 1536
		dc.b   8,  8,$4A,$4B, $F,$10,$70,$76,$73,$20,$44,$45,$25,$6B,$30,$48; 1552
		dc.b $3D,$3E,$1A,$20,$12,$13,$40, $E, $D,  9, $C,  1,$25,$6B,$10,$79; 1568
		dc.b $3C,$3C,$3C,$3C,$3C,$3C,$7A,$6A,$73,$70,$70,$79,  0,  0,  0,  0; 1584
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1600
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1616
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1632
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1648
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1664
		dc.b $3C,$3C,  0,$17,  8,$75,  0,$73,$70,$77,$54,$87,$86,$7B,$81,$58; 1680
		dc.b $58,$82,$70,$77,$22,  0,$3C,$3C,$3C,$3C,$1C,  3,$86,$7B,$66,  0; 1696
		dc.b $3C,$3C,  0,  0,$3C,$3C,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1712
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1728
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1744
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1760
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1776
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1792
		dc.b $3C,$3C,  0,  0,$3C,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1808
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1824
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1840
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1856
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1872
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1888
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1904
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1920
		dc.b $3C,$3C,  0,  0,$3C,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1936
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1952
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1968
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1984
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2000
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2016
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2032
		dc.b   0,  0		; 2048
Level_HPZ1:	dc.b $7F, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 0
					; DATA XREF: ROM:LevelLayout_Indexo
		dc.b $10,$98,$77,  2,  0,  0,  0,  0,  0,  0,  0,  0,$77,$B5,  0,  0; 16
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  2,$77,$A8,$10,$10,$10; 32
		dc.b $10,$10,$10,$10,$10,$56,$51,$53,$10,$10,$10,$10,$10,$10,$10,$10; 48
		dc.b $10,$10,$10,$17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 64
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 80
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 96
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 112
		dc.b   0,  0,$10,$10,$10,$10,$15,$16,$15,$16,$10,$98,  2,$7A,$B5,$77; 128
		dc.b $A8,$17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$93,$85,$94,  0; 144
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$14,$10,$10,$10; 160
		dc.b $10,$10,$10,$10,$54,$58,$52,$10,$10,$10,$10,$10,$10,$10,$10,$10; 176
		dc.b $10,$10,$10,$17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 192
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 208
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 224
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 240
		dc.b   0,  0,$10,$10,$10,$98,$8E,$77,$5A,$69,$7A,$69,  0,$7D,$85, $B; 256
		dc.b $14,$17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$31,  5,  7,  0; 272
		dc.b $9D,$5F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$14,$10,$10,$10; 288
		dc.b $10,$10,$10,$10,$56,$51,$53,$10,$10,$10,$10,$10,$10,$10,$10,$10; 304
		dc.b $10,$10,$10,$17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 320
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 336
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 352
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 368
		dc.b   0,  0,$10,$10,$10,$97,$AA,$13,$6A,$79,$8D,$67,$2A,$2B,  9, $A; 384
		dc.b $A9,$17,  0,$94,  0,  0,  0,  0,  0,  0,  0,  0,$32,  3,$17,  0; 400
		dc.b $87,$70,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$14,$10,$10,$10; 416
		dc.b $10,$10,$10,  3,$57,$52,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 432
		dc.b $10,$10,$10,$17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 448
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 464
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 480
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 496
		dc.b   0,  0,$10,$10,$10,$10,$10,$23,$15,$16,$23,$23,$23, $C, $D, $E; 512
		dc.b $15,$16,$21,$AC,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$14,$20; 528
		dc.b $9E,$4C,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$14,$10,$10,$10; 544
		dc.b   3,$2E,  2,  0,$51,$53,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 560
		dc.b $10,$10,$10,$17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 576
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 592
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 608
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 624
		dc.b   0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10,$15,$16,$1C,$1D,$1E; 640
		dc.b $10,$95,$AB,$7B,  0,  0,  0,  0,  0,  0,  0,  0,  0,$93,$9B,$8E; 656
		dc.b $8F,  7,  0,$92,  0,  0,  0,  0,  0,  0,  0,  0,$14,$10,  3,$2E; 672
		dc.b   0,  0,  0,  0,$52,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 688
		dc.b $10,$10,$10,$17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 704
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 720
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 736
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 752
		dc.b   0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10, $C, $D, $E,$10,$10; 768
		dc.b $19,$68,$7D,$7E,$91,  0,  0,  0,$94,$1B,$3B,  0,  0,$3C,$4D,$2D; 784
		dc.b $5D,$5E,  0,  4,$3A,  0,  0,  0,  0,  0,  0,  0,$24,$17,  0,  0; 800
		dc.b   0,  0,  0,$51,$53,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 816
		dc.b $10,$10,$10,$17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 832
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 848
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 864
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 880
		dc.b   0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10,$1C,$1D,$1E,$10,$10; 896
		dc.b $1A,$65,$78,$78,$75,  0,  0,$3C,$31,$22,$17,  0,  0,  0,$AD,$3D; 912
		dc.b $6D,$6E,$6F,$14,$17,  0,  0,  0,$92,  0,  0,$93,$94,$9B,  0,  0; 928
		dc.b   0,  0,  0,$50,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 944
		dc.b $10,$10,$10,$17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 960
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 976
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 992
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1008
		dc.b   0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10, $F,$15,$16,$10,$10; 1024
		dc.b $21,  6,$2C,$2D,$85,  0,  0,  0,$80,$A8,$17,  0,  0,  0,$AE,$9A; 1040
		dc.b $35,$36,$37,$10,$84,  0,$11,$25,$3E,  0,  0,$3C,$46,$47,$49,$5F; 1056
		dc.b $92,$9C,$48,$A7,$16,$10,$10,$10,$10,  3,$A8,$10,$10,$10,$10,$10; 1072
		dc.b $10,$10,$10,$17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1088
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1104
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1120
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1136
		dc.b   0,  0,$10,$10,$10,$10,$10,$10,$10,$15,$16, $F,$10,$15,$16,$10; 1152
		dc.b $84,  3,  3,$5B,$3E,  0,  0,  0,$81,$A9,$17,  0,  0,$40,$41,$30; 1168
		dc.b $38,$39,$45,$9B,$7D,$1B,$10,$23,  0,$91,$92,$91,$7E, $B,$11,  1; 1184
		dc.b   6,$43,$23,$10,$10,$10,$10,$10,$AF,  0,$24,$2E,  3,$2E,  2,$2E; 1200
		dc.b   3,$2E,  2,$2E,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1216
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1232
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1248
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1264
		dc.b   0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10,$1F,$18,$2E,$7A,$7B; 1280
		dc.b $8C,  0,  0,  0,  0,$91,  0,$1B,$10,$10,$17,  0,  0,$4A,$4B,$4C; 1296
		dc.b $9F,$42,$6B,$6C,  8,$22,$10,$10,$21,$26,  8,  9,  8,$76,$A9,$23; 1312
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$55,  0,$60,$61,$62,$63,$64,$61; 1328
		dc.b $62,$63,$64,$61,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1344
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1360
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1376
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1392
		dc.b   0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10,$2F,$28,$29,$8A,$8B; 1408
		dc.b $89,$B7,$B8,$99,$2A,$2B,  9,$22,  3,  3,$27,  0,  0,$24,$3D,$26; 1424
		dc.b   5,$43,$44,$10,$10,$15,$16,$10,$10,$10,$10,$15,$16, $F,$15,$16; 1440
		dc.b $10,$10,$10,$10,$10,$10,$10,$54,$58,$59,$74,$71,$72,$73,$74,$71; 1456
		dc.b $72,$73,$74,$71,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1472
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1488
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1504
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1520
		dc.b   0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10,$15,$16,$10,$23,$10; 1536
		dc.b $23,$7F,$91,$2E,$7C,$5A,$86,$7B,  0,  0,  0,  0,  0,  0,$32,  3; 1552
		dc.b   3,  2,$2E,  3,  3,$2E,$2E,  2,  0,  0,  0,  0,  0,  0,  0,  0; 1568
		dc.b   0,$10,$10,$10,$10,$10,$10,$56,$51,$53,$10,$10,$10,$10,$10,$10; 1584
		dc.b $10,$10,$10,$17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1600
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1616
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1632
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1648
		dc.b   0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1664
		dc.b $10,$8F,$4E,$4F,$8B,$B9,$96,$7E,  0,  0,  0,  0,  0,  0,  0,  0; 1680
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1696
		dc.b   0,  0,  0,$10,$10,$10,$54,$58,$52,$10,$10,$10,$10,$10,$10,$10; 1712
		dc.b $10,$10,$10,$17,  0,  0,  0,  0,$93,$94,  0,  0,  0,  0,  0,  0; 1728
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1744
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1760
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1776
		dc.b   0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1792
		dc.b $17,$32,  3,$23,$10,$23,$21,  7,  0,  0,  0,  0,  0,  0,  0,  0; 1808
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1824
		dc.b   0,  0,  0,$10,$10,$10,$56,$51,$53,$10,$10,$10,$10,$10,$10,$10; 1840
		dc.b $10,$10,$10,$17,  0,  0,$82,$2A,$2B,  9,  0,  0,  0,  0,  0,  0; 1856
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1872
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1888
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1904
		dc.b   0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10; 1920
		dc.b $17,  0,  0,$2E,  3,$A8,$10,$17,  0,  0,  0,  0,  0,  0,  0,  0; 1936
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1952
		dc.b   0,  0,  0,$10,$10,$54,$58,$52,$10,$10,$10,$10,$10,$10,$10,$10; 1968
		dc.b $10,$10,$10,$17,  0,  0,$83,$23,$10,$10,  0,  0,  0,  0,  0,  0; 1984
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2000
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2016
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2032
		dc.b   0,  0		; 2048
Level_CPZBg:	dc.b   5,  5,$A0,$A1,$A2,  0,$A4,$A5,$B0,$B1,$B2,$B3,$B4,$B5,$C0,$C1; 0
					; DATA XREF: ROM:LevelLayout_Indexo
		dc.b $C2,$C3,$C4,$C5,$D0,$D1,$D2,$D3,$D4,$D5,$E0,$E1,$E2,$E3,$E4,$E5; 16
		dc.b $F0,$F1,$F2,$F1,$E4,$E5; 32
LeveL_HPZBg:	dc.b   7,  8,$A3,$A3,$A3,$A3,$A3,$A3,$A3,$A3,$A0,$A1,$A0,$A1,$A0,$A1; 0
					; DATA XREF: ROM:LevelLayout_Indexo
		dc.b $A0,$A1,$C0,$C1,$C2,$C3,$C4,$C5,$C6,$C7,$D0,$D1,$D2,$D3,$D4,$D5; 16
		dc.b $D6,$D7,$E0,$E1,$E2,$E3,$E4,$E5,$E6,$E7,$B0,$B1,$B0,$B1,$B0,$B1; 32
		dc.b $B0,$B1,$A2,$A2,$A2,$A2,$A2,$A2,$A2,$A2,$B2,$B2,$B2,$B2,$B2,$B2; 48
		dc.b $B2,$B2,$B2,$B2,$B2,$B2,$B2,$B2,$B2,$B2; 64
Level_Null:	dc.b   0,  0,  0,  0	; 0 ; DATA XREF: ROM:LevelLayout_Indexo
Art_BigRing:	dc.l	     0,	       0,	 0,	   0,	    $D,	     $DD,    $EDDC,   $EDDCC,	     0,	     $DD,   $DDCCC, $DDCCC6C,$DCCCCCCC,$CCCCCCCC,$CCCDCDDD,$DDCCCCDD; 0
		dc.l   $CCCCCC,$CCC66666,$66666666,$CCCCCCCC,$CCCCCCCC,$CDDDDDDD,$DDDDDDDD,$DDDEEEEE,$CCCCCC00,$666666CC,$66666666,$66666666,$CCCCC666,$DDDDDCCC,$DDDDDDDD,$EEEEEEEE; 16
		dc.l	     0,$CC000000,$66CCC000,$66666CC0,$66666666,$CC666666,$DCCCC666,$DDDDCCC6,	     0,	       0,	 0,	   0,$C0000000,$66000000,$666C0000,$66666000; 32
		dc.l	     0,	       0,	 0,	  $E,	   $EE,	     $EE,     $EED,    $EEED,  $EEDDDD,	$EEDDDDC,$EEDDDDCC,$EDDDDCCC,$DDDDCCCD,$DDDCCCCD,$DDCCCCDE,$DCCCCDDE; 48
		dc.l $CCCCDDDD,$CCCDDDEE,$CDDDEEEE,$DDEEEEEE,$DEEEEE00,$EEEE0000,$EE000000,$E0000000,$EEEEEEEE,$EEEEEEEE,$EEE00000,	   0,	     0,	       0,	 0,	   0; 64
		dc.l $EEEEEEEE,$EEEEEEEE,     $EEE,	   0,	     0,	       0,	 0,	   0,$EEEDDDCC,$EEEEEDDD,$EEEEEEED,$EEEEEEEE,  $EEEEEE,	   $EEEE,      $EE,	  $E; 80
		dc.l $66666600,$CC666660,$DDC66666,$EDDC6666,$EEDDC666,$EEEDDC66,$EEEEDDC6,$EEEEEDC6,	     0,	       0,	 0,$60000000,$6C000000,$66000000,$66600000,$666C0000; 96
		dc.l	 $EEDD,	  $EEEDD,   $EEEDD,  $EEEDDC,  $EEEDDC,	 $EEEDCC, $EEEEDCC, $EEEDDCC, $EEEDCCC,	$EEEDCCC,$EEEEDCCC,$EEEEDCCC,$EEEEDCCC,$EEEEDCCC,$EEEEDCCC,$EEEEDCCC; 112
		dc.l $EEEEDCCC,$EEEEDCCC,$EEEEDCCC,$EEEEDDCC,$EEEEEDCC,$EEEEEDCC, $EEEEDCC, $EEEEEDC, $EEEEEDC,	$EEEEEDC,  $EEEEDC,  $EEEEED,  $EEEEED,	  $EEEEE,   $EEEEE,    $EEEE; 128
		dc.l $DCCCCDEE,$CCCCDEE0,$CCCCDE00,$CCCDEE00,$CCCDE000,$CCCDE000,$CCCE0000,$CCDE0000,$CCD00000,$CCD00000,$CCD00000,$CC000000,$C6000000,$C6000000,$C6000000,$C6000000; 144
		dc.l $66000000,$66000000,$66000000,$66000000,$66000000,$66600000,$66600000,$66600000,$66660000,$66660000,$C6666000,$C6666000,$C6666600,$DC666600,$EDC66660,$EDC66666; 160
		dc.l $EEEEEDDC,	$EEEEEDC,  $EEEEDD,  $EEEEED,	$EEEED,	  $EEEEE,    $EEEE,    $EEEE,	  $EEE,	    $EEE,     $EEE,	 $EE,	   $EE,	     $EE,      $EE,	 $EE; 176
		dc.l	   $EE,	     $EE,      $EE,	 $EE,	   $EE,	    $EEE,     $EEE,	$EEE,	 $EEED,	   $EEED,   $EEEDD,   $EEEDD,  $EEEDDC,	 $EEEDCC, $EEEDDCC,$EEEDDCCC; 192
		dc.l $66660000,$C666C000,$C666C000,$CC666C00,$DC666C00,$DC666C00,$DCC666C0,$DDC666C0,$EDC666C0,$EDC666C0,$EDC6666C,$EDDC666C,$EDDC666C,$EDDC666C,$EDDC666C,$EDDC666C; 208
		dc.l $EDDCC66C,$EDDCC66C,$EDDCC66C,$EDDCC66C,$EDDCC66C,$DDDCC6CC,$DDDCC6C0,$DDCCC6C0,$DDCCCCD0,$DDCC6CD0,$CDCCCC00,$CCCCCD00,$CDCCCD00,$CCCCD000,$DCCCD000,$DCCD0000; 224
		dc.l	 $EEEE,	    $EEE,      $EE,	 $EE,	    $E,	       0,	 0,	   0,$EEDC6666,$EEEDC666,$EEEEDC66,$EEEEEDC6,$EEEEEEDC,$EEEEEEED, $EEEEEEE,  $EEEEEE; 240
		dc.l $60000000,$66000000,$66660000,$66666600,$66666666,$CC666666,$DDC66666,$EEDCCC66,	     0,	       0,	 0,	   0,	     0,$66600000,$66666666,$66666666; 256
		dc.l	     0,	       0,	 0,	   0,	     0,	    $DDD,$6666CCCC,$CCCCCCCC,	    $E,	     $EE,    $EEED,  $EEEDDC,$EEDDDCCC,$DCCCCCCC,$CCCCCCCC,$CCCCCCCD; 272
		dc.l $EEDDCCCD,$DDCCCCDD,$DCCCCDDD,$CCCCDDDD,$CCCDDDDE,$CCDDDDEE,$CDDDDEE0,$DDDDEE00,$CCDD0000,$CDD00000,$DD000000,$DE000000,$E0000000,	       0,	 0,	   0; 288
		dc.l	$EEEEE,	   $EEEE,      $EE,	  $E,	     0,	       0,	 0,	   0,$EEEDDCCC,$EEEEEDDD,$EEEEEEEE,$EEEEEEEE, $EEEEEEE,	  $EEEEE,      $EE,	   0; 304
		dc.l $CCCCCCCC,$DCCCCCCC,$EDDDDCCC,$EEEEDDDD,$EEEEEEEE,$EEEEEEEE,$EEEEEEEE,  $EEEEEE,$CCCCCCCC,$CCCCCCCC,$CCCCCCCC,$DDDDDDDD,$EEEEEEEE,$EEEEEEEE,$EEEEEEEE,$EEEEEE00; 320
		dc.l $CCCCCDDD,$CCCDDDDD,$DDDDDEEE,$DEEEEEEE,$EEEEEEE0,$EEEEE000,$EE000000,	   0,$DDEEE000,$EEEE0000,$EE000000,$E0000000,	     0,	       0,	 0,	   0; 336
		dc.l	     0,	       0,	$D,	$DDC,	 $DCCC,	  $DCCCD,  $DCCDDD, $DCDDDDD,	$CCCCC,	$DCCC666,$CC666666,$C6CCC666,$CCCCCCCC,$DDDDDDDD,$DDDDDDDD,$DDDDDDDD; 352
		dc.l $CCCCC000,$66666CCC,$66666666,$66666666,$66666666,$CC666666,$DDCC6666,$DDDDC666,	     0,	       0,$CC000000,$66CC0000,$6666C000,$66666600,$66666660,$66666666; 368
		dc.l	     0,	      $E,      $ED,	 $ED,	  $EDD,	    $EDD,    $EDDE,   $EEDDE,$DDDDDDDD,$DDDDDEEE,$DDDEEEEE,$DDEEEEEE,$DEEEEEEE,$EEEEEEEE,$EEEEEEE0,$EEEEEDE0; 384
		dc.l $EEEEEEEE,$EEEEEEEE,$EEEE0000,$EE000000,$E0000000,	       0,	 0,	   0,$DDDDDC66,$EEDDDDC6,$EEEEDDDC,  $EEEDDD,	$EEEDD,	   $EEDD,     $EED,	 $EE; 400
		dc.l	   $EE,	      $E,	$E,	   0,	     0,	       0,	 0,	   0,$66666666,$66666666,$66666666,$C6666666,$DC666666,$DC666666,$DDC66666,$DDC66666; 416
		dc.l $DDDC6666,$EDDC6666,$EDDDC666,$EDDDC666,$EDDDCC66,$EEDDDC66,$EEDDDC66, $EDDDCC6,$60000000,$66000000,$66000000,$66600000,$666C0000,$66660000,$66666000,$66666000; 432
		dc.l $66666000,$66666C00,$66666C00,$666666C0,$666666C0,$666666C0,$66666660,$6666666C,	$EDDEE,	  $EDDEE,   $EDEEE,  $EEDEEE,  $EDDEEE,	 $EDDEED, $EEDDEED, $EEDEEDD; 448
		dc.l  $EDDEEDD,	$EDDEDDC,$EEDDEDCC,$EEDDEDCC,$EEDDEDCC,$EEDDDCCC,$EEEDDCCC,$EEEDDCC6,$EEEDDCC6,$EEEDDCC6,$EEEDDC66,$EEEDDC66,$EEEEDC66,$EEEEDC66, $EEEDC66, $EEEED66; 464
		dc.l  $EEEED66,	$EEEED66,  $EEEDC6,  $EEEEC6,  $EEEEC6,	  $EEEDC,   $EEEED,   $EEEED,$EEEDDD00,$EEDDDE00,$EDDDD000,$DDDDE000,$DDDD0000,$DDCD0000,$DCCD0000,$CCCD0000; 480
		dc.l $CCCD0000,$CCC00000,$CCC00000,$CC600000,$C6600000,$66600000,$66600000,$66600000,$66600000,$66600000,$66600000,$66600000,$66600000,$66600000,$66600000,$66660000; 496
		dc.l $66660000,$66660000,$66660000,$66660000,$66666000,$66666000,$C6666600,$C6666600, $EDDDCC6,	$EDDDCC6, $EDDDCC6, $EDDDDCC,  $EDDDCC,	 $EDDDCC,  $EDDDCC,  $EDDDCC; 512
		dc.l   $EDDDCC,	 $EDDDCC,  $EDDDCC,  $EDDDCC, $EDDDDCC,	$EDDDCCC, $EDDDCCC, $EDDDCCC,$6666666C,$6666666C,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666; 528
		dc.l $6666666C,$C666666C,$C666666C,$CCC666CC,$CCCCCCCC,$CCCCCCCC,$CCCCCCCC,$CCCCCCCD,	     0,	       0,	 0,	   0,	     0,	      $E,	$E,	 $ED; 544
		dc.l	   $ED,	    $EDD,    $DDDD,   $DDDDD,  $DDDDDC,$DDDDDCCD,$DDDCCDDD,$DDDDDDDD, $EDDDCCC,$EDDDDCCC,$EDDDDCCC,$EDDDCCCC,$EDDDCCCC,$DDDDCCCC,$DDDCCCCC,$DDDCCDCC; 560
		dc.l $DDCCDDCC,$DDCCDDDC,$DCCDDDDD,$CCDDDDDD,$CDDDDDDD,$DDDDDDDD,$DDDDDDDD,$DDDDDDEE,$CCCCCCCD,$CCCCCCC0,$CCCCCCC0,$CCCCCCD0,$CCCCCCD0,$CCCCCD00,$CCCCCD00,$CCCCD000; 576
		dc.l $CCCCD000,$CCDDE000,$DDDE0000,$DDDE0000,$DDE00000,$DE000000,$EE000000,$E0000000,	$EEEEE,	   $EEEE,     $EEE,	$EEE,	   $EE,	     $EE,	$E,	   0; 592
		dc.l $D6666660,$EC666660,$EDC66666,$EEDC6666,$EEED6666,$EEEEDD66,$EEEEDDDD,$EEEEEEDD,	     0,	       0,	 0,$60000000,$66000000,$66660000,$D6666DDD,$DDDDDDDD; 608
		dc.l  $EEEEEED,	$EEEEEEE,   $EEEEE,    $EEEE,	  $EEE,	      $E,	 0,	   0,$DDDDDDDD,$DDDDDDDD,$EEEDDDDD,$EEEEEEDD,$EEEEEEEE,$EEEEEEEE, $EEEEEEE,   $EEEEE; 624
		dc.l $DDDDDDDD,$DDDDDDDD,$DDDDDDDD,$DDDEEEEE,$EEEEEEEE,$EEEEEEEE,$EEEEEEEE,$EEEEE000,$DDDDDEEE,$DDDEEEE0,$EEEEEE00,$EEEEE000,$EEEE0000,$EE000000,	 0,	   0; 640
		dc.l	     0,	     $CC,     $CC6,    $DC66,	$DCC66,	  $DC666,  $DCC666,  $DCC666, $DDCC666,	$DCCC666, $DCC6666,$DDCC6666,$DDCC6666,$DDCC6666,$DDCC6666,$DDCC6666; 656
		dc.l $DDCC6666,$DDCC6666,$DDCC6666,$DDCC6666,$DDCC6666,$DDCC6666,$DDCC6666,$DDCC6666,$EDCCC666,$EDCCC666,$EDCCC666,$EDCCC666,$EDCCC666,$EDCCC666,$EDCCC666,$EDCCCC66; 672
		dc.l $CCCCCCCC,$C666666C,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666; 688
		dc.l $66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666; 704
		dc.l $EDDCCC66,$EDDCCC66,$EDDCCCC6,$EDDCCCCC,$EDDCCCCC,$EDDCCCCC,$EDDCCCCC,$EDDCCCCC,$EDDCCCCC,$EDDDCCCC,$EDDDCCCC,$EEDDCCCC,$EEDDCCCC,$EEDDDCCC,$EEDDDCCC,$EEDDDDCC; 720
		dc.l $EEDDDDDC,$EEDDDDDD,$EEDDDDDD,$EEDDDDDD,$EEEDDDDD,	$EEDDDDD, $EEDDDDD, $EEEDDDD,  $EEDDDD,	 $EEEDDD,   $EEEDD,   $EEEEE,	 $EEEE,	    $EEE,      $EE,	   0; 736
		dc.l $66666666,$66666666,$66666666,$C666666C,$CCCCCCCC,$CCCCCCCC,$CCCCCCCC,$CCCCCCCC,$CCCCCCCC,$CCCCCCCC,$CCCCCCCC,$CCCCCCCC,$CCCCCCCC,$CCCCCCCC,$CCCCCCCC,$CCCCCCCC; 752
		dc.l $CCCCCCCC,$DCCCCCCD,$DDDDDDDD,$DDDDDDDD,$DDDDDDDD,$DDDDDDDD,$DDDDDDDD,$DDDDDDDD,$DDDDDDDD,$DDDDDDDD,$DDDDDDDD,$DDDDDDDD,$EEEEEEEE,$EEEEEEEE,$EEEEEEEE,$EEEEEEEE; 768
;
; leftover level layouts from a	previous build
;
Leftover_LevelLayouts:dc.b   0,	 0,$6E,$6E,$AF,$76,$AB,$43,  0,	 0,$B5,$66,$A8,$B2,  0,	 0,  0,	 0,  0,	 0,  0,	 0,  0,	 0,  0,	 0,  0,	 0,  0,	 0,  0,	 0; 0
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 32
		dc.b   0,  0,  0,  0,$A2,  0,  0,$93,  0,  0,$93,$57,$1A,  0,$9C, $F,$95,  0,  0,  0,$B3,$66,$67,  0,  0,  0,$A1,$96,$39,$2F,$C9,$84; 64
		dc.b $8F,$43,$42,$98, $D,$18,$D1,$47,$5F,$7C,$6E,$86,$88,$6E,$6E,$86,$94, $F, $F,$90, $F, $F,$2F,$3F,$14,  0,$93,$49,$96,$96,$D4,$68; 96
		dc.b $94,$90,$6E,$74,$75,$86,$AB,$F0,$F0,$F0,$F0,$F0,$98, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 128
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 160
		dc.b   0,$10,  9,$2B,$A8,$2D,$14,$8C,$16,  6,$8E,$35,$36,$1F,$CB, $F,$95, $E,  0,  0,$64,  0,$B5,$66,$67,  0,$67,  0,$43,$54,$44,$63; 192
		dc.b $A2,  0,  0,$73,$62,$44,$95,$7B,$7B,$D0,$6E,$6E,$6E,$6E,$7D,$BF,$BA,$5A,$5A,$5A,$5A,$5A,$5A,$5A,$2F,$3F,$8E,$78,$D7,$4A,$4A,$E2; 224
		dc.b $94,$90,$75,$B0,$6E,$6E,$A1,$96,$96,$96,$96,$96,$96,$96,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 256
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$9F,  0; 288
		dc.b   0,$55, $F,$A7,  4,$3D,$42,$47,$40,$41, $F,$31,$80,$2E, $F,$53,$54,$42,  0,  0,$93,$A2,$57,$1A,$B5,$C2,$B5,$66,$67,  0,  0,$93; 320
		dc.b $A8,$C5,$66,$67,  0,  0,$47,$49,$96,$4E,$6E,$6E,$86,$6E,$47,$CF,$94, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F; 352
		dc.b  $F,$90,$88,$76,$77,$6E,$6E,$6E,$6E,$6E,$6E,$6E,$6E,$6E,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 384
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  2,$18; 416
		dc.b $14,  0,$A1, $F, $F, $F,  4,$7B,$50,$51, $F,$95,$54,$54,$52,  0,  0,  0,  0,  0,$B2,$8E,$35,$36,  0,$64,$93,$93,$1F,$16,  6,$8E; 448
		dc.b $98,$AB,  0,  0,$BD,  3,$D0,$4A,$D1,$6E,$6E,$6E,$6E,$86,$6E,$88,$94, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F; 480
		dc.b  $F,$90,$6E,$6E,$AF,$76,$77,$6E,$6E,$6E,$DD,$DD,$59,$7B,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 512
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $F, $F; 544
		dc.b $B9,$F0,$A1, $F, $F, $F, $F, $F,$60,$61,$54,$73,  0,$10,$46,$BB,$BB,$B3,  0,  0,$62,$94,$72,$BE,$1F,$8A,  8,  8,$2E, $F, $F, $F; 576
		dc.b  $F,$90,$F0,$F0,$94, $F, $F, $F,$95,$D0,$6E,$88,$6E,$6E,$6E,$6E,$94, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F; 608
		dc.b  $F,$90,$6E,$6E,$6E,$6E,$AF,$76,$6E,$E4,$F2,$F2,$94, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 640
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $F, $F; 672
		dc.b $90,$F1,$A1, $F, $F, $F, $F, $F,$70,$71, $D,$18, $A,$33,$F3,$F4,$F4,$AB,$F0,$F0,$F0,$94,$31,$87,$2E, $F, $F, $F, $F, $F, $F, $F; 704
		dc.b  $F,$90,$F1,$F1,$94, $F, $F, $F,$95,$95,$6E,$6E,$6E,$6E,$6E,$6E,$94, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F, $F; 736
		dc.b  $F,$90,$E0,$E0,$E0,$E0,$E0,$E0,$59, $F,$F3,$F3,$94, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 768
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  3,  1; 800
		dc.b $D6,$DF,$EA,$EC,$F7,$F7,$F7,$F7,$7F, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$3C,$3C,$3C,  0,  0,  0; 832
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$3C,$3C,$3C,$3C,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$3C,$3C; 864
		dc.b $3C,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 896
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 928
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$3C,$3C,$3C,  0,  0,  0; 960
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,$18,$19,  0,  3,  0,  0,  0,  0,$3C,$3C,$3C,$3C,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$3C,$3C; 992
		dc.b $3C,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1024
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1056
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  3,  3,$27,  0,  0,  0; 1088
		dc.b   0,  0,  0,$11,  1,$1A,$25,$51,$28,$29,$70,$20,$44,$45,  1,  9,$3C,$3C,$3C,$3C,  9,  0,  0,  0,  0,  0,  0,  0,  0,  3,$3C,$3C; 1120
		dc.b   3,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1152
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1184
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$11,  1,$23,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$3C,  9,  1,  0,  1; 1216
		dc.b $2B,$2C,  8,$21,$10,$70,$92,$61,$38,$39,  0,$78,$54,$87,  0,  0,$3C,$3C,$3C,$3C, $F, $F,  4,  5,  6,$4C,$3A,$3F,  0,$10,$1A,  0; 1248
		dc.b   3,$84, $F, $F,$85,  3,  3,  3,  3,  3,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1280
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1312
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  2,$21,  3,$33,$34,$25,$80,  4,  5,  6,  7,  4,  5,  6,  7,  8,$24, $F,  3,$25,$26; 1344
		dc.b $3C,$2A,$1B,  2,$65,  0,$8B,$70,$49,$70,$70,$79,  0,  0,$11,  1,$46,  0,$11,$41,$2B,$2C,$14,$15,$16,$2F,$88,$15,  8,$65,$10,$25; 1376
		dc.b $26,  0, $C,  0,  0,$50,  0,  0,$30,  3,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1408
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1440
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  3,  3,  3,  3,  3,$14,$15,$16,$17,$14,$15,$16,$17,$1D,$1E,$1F,  0,$3C,$36; 1472
		dc.b   2,$72,$20,$44,$6E,$25,$6B,  0,$59,$24,  4,  5,  6,  7,$21, $F,$56,$24,$21, $F,  0,  0,  0,$18,$19,  0,$17,$31,  2,$60,$65,  3; 1504
		dc.b $36, $B,$1C, $B,  2,$5E,$5F,  2,$40,  3,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1536
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1568
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  3,$27,$37,$2F,$8D,$3C,$30; 1600
		dc.b   0,$71,$7A,$7E,$79,$86,$7D,  2,  2,  2,$14,$15,$16,$17,  6,  7,  4,  5,  6,$4C,$3A,$91,$7F,$28,$29,$70,$20,$63,$10,$79,$71,  3; 1632
		dc.b   0,$2A,$20,  0,$4D,$4E,  0,$10,$23,  0, $F,  3,  3,  3,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1664
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1696
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$8B,$70,$70,$20,  0,$12,$13,  2,  2,$40; 1728
		dc.b $8E,$32,  0,  0,  0,$10,$79,$3C,$72,$20,  0,$50,$12,$13,$16,$17,$14,$15,$16,$2F,$1F,$90,$40,$38,$83,$19,$71,$3C,$73,$68,$69,$10; 1760
		dc.b $25,$26,$78,$8A,$5D,$5B,$58,$66,$33,$34,  0,  3,  3, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1792
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1824
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$71,  0,$3C,$78,  2,$22,  0,  0,  9,$2A; 1856
		dc.b $41,$42,$43,  6,  7,$65,$10,$70,$79,$78,  8,$40,$22,  0,  0,$3C, $C, $D,$20,$67,$8F,$52,$72,$49,$28,$29,$79,  0,  0,$71,$3C,$71; 1888
		dc.b $72,$6D,$53, $E, $D,$55,  1, $C,  9,  1,  1,  1, $A,  9,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1920
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1952
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$71,  0,$3C,$73,$20,$3C,$35, $B,  3,  3; 1984
		dc.b $72,$79,$15,$16,$17,$60,$65,$18,$19,$73,$20,$3C,  0,  9, $D,$1B,$1C,  3,$71,$73,$70,$62,$60,$31,$38,$39,$3C,$2D,$2E,$71,$3C,$5C; 2016
		dc.b $71,  0,  0,  3, $F,$71,  3,$1C,  3,  3,  3,  3,  3,  3,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2048
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2080
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$71,  3,$3C,  0,$74,  8, $F,$3C,$3C,  0; 2112
		dc.b $71,  0,  0,  0,  0,$71,$7C,$28,$29,$70,$77,$31,$4A,$8C,$3C,$3C,$2A,$25,$6B,$10,$70,$76,$73,$20,$48,  0,  0,$3D,$3E,$64,$2C,$6C; 2144
		dc.b $57,$4F,  0,$10,$70,$79,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2176
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2208
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$73,$20,$3C,  0,  0,$3C,$2A,$3B,$3B, $B; 2240
		dc.b $60,  2,  0,  0,  8,$60,$40,$38,$83,$2E,$3C,  3,  0,$17,$89,$8A, $F,$86,$7B,$66,  0,$71,  3,$78,$31,  2,  2,  2,$39,$73,$20,$5A; 2272
		dc.b $6F,$31,$31,$65,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2304
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2336
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$74,  8,  8,$4A,$4B, $F,$10,$70,$76; 2368
		dc.b $73,$20,$44,$45,$25,$6B,$30,$48,$3D,$3E,$1A,$20,$12,$13,$40, $E, $D,  9, $C,  1,$25,$6B,$10,$79,$3C,$3C,$3C,$3C,$3C,$3C,$7A,$6A; 2400
		dc.b $73,$70,$70,$79,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2432
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2464
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$3C,$3C,  0,$17,  8,$75,  0,$73; 2496
		dc.b $70,$77,$54,$87,$86,$7B,$81,$58,$58,$82,$70,$77,$22,  0,$3C,$3C,$3C,$3C,$1C,  3,$86,$7B,$66,  0,$3C,$3C,  0,  0,$3C,$3C,  0,  0; 2528
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2560
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2592
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$3C,$3C,  0,  0,$3C,  0,  0,  0; 2624
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2656
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2688
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2720
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$3C,$3C,  0,  0,$3C,  0,  0,  0; 2752
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2784
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2816
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2848
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$7F, $F,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$98,$77,  2,  0,  0; 2880
		dc.b   0,  0,  0,  0,  0,  0,$77,$B5,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  2,$77,$A8,$10,$10,$10,$10,$10,$10,$10,$10,$56; 2912
		dc.b $51,$53,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2944
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2976
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$10,$10,$10,$10,$15,$16,$15,$16,$10,$98,  2,$7A,$B5,$77,$A8,$17,  0,  0,  0,  0; 3008
		dc.b   0,  0,  0,  0,  0,  0,$93,$85,$94,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$14,$10,$10,$10,$10,$10,$10,$10,$54,$58; 3040
		dc.b $52,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3072
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3104
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$10,$10,$10,$98,$8E,$77,$5A,$69,$7A,$69,  0,$7D,$85, $B,$14,$17,  0,  0,  0,  0; 3136
		dc.b   0,  0,  0,  0,  0,  0,$31,  5,  7,  0,$9D,$5F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$14,$10,$10,$10,$10,$10,$10,$10,$56,$51; 3168
		dc.b $53,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3200
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3232
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$10,$10,$10,$97,$AA,$13,$6A,$79,$8D,$67,$2A,$2B,  9, $A,$A9,$17,  0,$94,  0,  0; 3264
		dc.b   0,  0,  0,  0,  0,  0,$32,  3,$17,  0,$87,$70,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$14,$10,$10,$10,$10,$10,$10,  3,$57,$52; 3296
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3328
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3360
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$10,$10,$10,$10,$10,$23,$15,$16,$23,$23,$23, $C, $D, $E,$15,$16,$21,$AC,  0,  0; 3392
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,$14,$20,$9E,$4C,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$14,$10,$10,$10,  3,$2E,  2,  0,$51,$53; 3424
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3456
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3488
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10,$15,$16,$1C,$1D,$1E,$10,$95,$AB,$7B,  0,  0; 3520
		dc.b   0,  0,  0,  0,  0,  0,  0,$93,$9B,$8E,$8F,  7,  0,$92,  0,  0,  0,  0,  0,  0,  0,  0,$14,$10,  3,$2E,  0,  0,  0,  0,$52,$10; 3552
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3584
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3616
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10, $C, $D, $E,$10,$10,$19,$68,$7D,$7E,$91,  0; 3648
		dc.b   0,  0,$94,$1B,$3B,  0,  0,$3C,$4D,$2D,$5D,$5E,  0,  4,$3A,  0,  0,  0,  0,  0,  0,  0,$24,$17,  0,  0,  0,  0,  0,$51,$53,$10; 3680
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3712
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3744
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10,$1C,$1D,$1E,$10,$10,$1A,$65,$78,$78,$75,  0; 3776
		dc.b   0,$3C,$31,$22,$17,  0,  0,  0,$AD,$3D,$6D,$6E,$6F,$14,$17,  0,  0,  0,$92,  0,  0,$93,$94,$9B,  0,  0,  0,  0,  0,$50,$10,$10; 3808
		dc.b $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3840
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3872
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10, $F,$15,$16,$10,$10,$21,  6,$2C,$2D,$85,  0; 3904
		dc.b   0,  0,$80,$A8,$17,  0,  0,  0,$AE,$9A,$35,$36,$37,$10,$84,  0,$11,$25,$3E,  0,  0,$3C,$46,$47,$49,$5F,$92,$9C,$48,$A7,$16,$10; 3936
		dc.b $10,$10,$10,  3,$A8,$10,$10,$10,$10,$10,$10,$10,$10,$17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3968
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 4000
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$10,$10,$10,$10,$10,$10,$10,$15,$16, $F,$10,$15,$16,$10,$84,  3,  3,$5B,$3E,  0; 4032
		dc.b   0,  0,$81,$A9,$17,  0,  0,$40,$41,$30,$38,$39,$45,$9B,$7D,$1B,$10,$23,  0,$91,$92,$91,$7E, $B,$11,  1,  6,$43,$23,$10,$10,$10; 4064
		dc.b $10,$10,$AF,  0,$24,$2E,  3,$2E,  2,$2E,  3,$2E,  2,$2E,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 4096
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 4128
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10,$1F,$18,$2E,$7A,$7B,$8C,  0,  0,  0,  0,$91; 4160
		dc.b   0,$1B,$10,$10,$17,  0,  0,$4A,$4B,$4C,$9F,$42,$6B,$6C,  8,$22,$10,$10,$21,$26,  8,  9,  8,$76,$A9,$23,$10,$10,$10,$10,$10,$10; 4192
		dc.b $10,$10,$55,  0,$60,$61,$62,$63,$64,$61,$62,$63,$64,$61,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 4224
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 4256
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10,$2F,$28,$29,$8A,$8B,$89,$B7,$B8,$99,$2A,$2B; 4288
		dc.b   9,$22,  3,  3,$27,  0,  0,$24,$3D,$26,  5,$43,$44,$10,$10,$15,$16,$10,$10,$10,$10,$15,$16, $F,$15,$16,$10,$10,$10,$10,$10,$10; 4320
		dc.b $10,$54,$58,$59,$74,$71,$72,$73,$74,$71,$72,$73,$74,$71,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 4352
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 4384
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10,$15,$16,$10,$23,$10,$23,$7F,$91,$2E,$7C,$5A; 4416
		dc.b $86,$7B,  0,  0,  0,  0,  0,  0,$32,  3,  3,  2,$2E,  3,  3,$2E,$2E,  2,  0,  0,  0,  0,  0,  0,  0,  0,  0,$10,$10,$10,$10,$10; 4448
		dc.b $10,$56,$51,$53,$10,$10,$10,$10,$10,$10,$10,$10,$10,$17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 4480
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 4512
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$8F,$4E,$4F,$8B,$B9; 4544
		dc.b $96,$7E,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$10,$10,$10; 4576
		dc.b $54,$58,$52,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$17,  0,  0,  0,  0,$93,$94,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 4608
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 4640
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$17,$32,  3,$23,$10,$23; 4672
		dc.b $21,  7,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$10,$10,$10; 4704
		dc.b $56,$51,$53,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$17,  0,  0,$82,$2A,$2B,  9,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 4736
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 4768
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$17,  0,  0,$2E,  3,$A8; 4800
		dc.b $10,$17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$10,$10,$54; 4832
		dc.b $58,$52,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$17,  0,  0,$83,$23,$10,$10,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 4864
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 4896
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  5,  5,$A0,$A1,$A2,  0,$A4,$A5,$B0,$B1,$B2,$B3,$B4,$B5,$C0,$C1,$C2,$C3,$C4,$C5; 4928
		dc.b $D0,$D1,$D2,$D3,$D4,$D5,$E0,$E1,$E2,$E3,$E4,$E5,$F0,$F1,$F2,$F1,$E4,$E5,  7,  8,$A3,$A3,$A3,$A3,$A3,$A3,$A3,$A3,$A0,$A1,$A0,$A1; 4960
		dc.b $A0,$A1,$A0,$A1,$C0,$C1,$C2,$C3,$C4,$C5,$C6,$C7,$D0,$D1,$D2,$D3,$D4,$D5,$D6,$D7,$E0,$E1,$E2,$E3,$E4,$E5,$E6,$E7,$B0,$B1,$B0,$B1; 4992
		dc.b $B0,$B1,$B0,$B1,$A2,$A2,$A2,$A2,$A2,$A2,$A2,$A2,$B2,$B2,$B2,$B2,$B2,$B2,$B2,$B2,$B2,$B2,$B2,$B2,$B2,$B2,$B2,$B2,  0,  0,  0,  0; 5024
;----------------------------------------------------
; leftover from	a previous build
;----------------------------------------------------
Leftover_Art_BigRing:dc.l	  0,	    0,	      0,	0,	 $D,	  $DD,	  $EDDC,   $EDDCC,	  0,	  $DD,	 $DDCCC, $DDCCC6C,$DCCCCCCC,$CCCCCCCC,$CCCDCDDD,$DDCCCCDD; 0
		dc.l   $CCCCCC,$CCC66666,$66666666,$CCCCCCCC,$CCCCCCCC,$CDDDDDDD,$DDDDDDDD,$DDDEEEEE,$CCCCCC00,$666666CC,$66666666,$66666666,$CCCCC666,$DDDDDCCC,$DDDDDDDD,$EEEEEEEE; 16
		dc.l	     0,$CC000000,$66CCC000,$66666CC0,$66666666,$CC666666,$DCCCC666,$DDDDCCC6,	     0,	       0,	 0,	   0,$C0000000,$66000000,$666C0000,$66666000; 32
		dc.l	     0,	       0,	 0,	  $E,	   $EE,	     $EE,     $EED,    $EEED,  $EEDDDD,	$EEDDDDC,$EEDDDDCC,$EDDDDCCC,$DDDDCCCD,$DDDCCCCD,$DDCCCCDE,$DCCCCDDE; 48
		dc.l $CCCCDDDD,$CCCDDDEE,$CDDDEEEE,$DDEEEEEE,$DEEEEE00,$EEEE0000,$EE000000,$E0000000,$EEEEEEEE,$EEEEEEEE,$EEE00000,	   0,	     0,	       0,	 0,	   0; 64
		dc.l $EEEEEEEE,$EEEEEEEE,     $EEE,	   0,	     0,	       0,	 0,	   0,$EEEDDDCC,$EEEEEDDD,$EEEEEEED,$EEEEEEEE,  $EEEEEE,	   $EEEE,      $EE,	  $E; 80
		dc.l $66666600,$CC666660,$DDC66666,$EDDC6666,$EEDDC666,$EEEDDC66,$EEEEDDC6,$EEEEEDC6,	     0,	       0,	 0,$60000000,$6C000000,$66000000,$66600000,$666C0000; 96
		dc.l	 $EEDD,	  $EEEDD,   $EEEDD,  $EEEDDC,  $EEEDDC,	 $EEEDCC, $EEEEDCC, $EEEDDCC, $EEEDCCC,	$EEEDCCC,$EEEEDCCC,$EEEEDCCC,$EEEEDCCC,$EEEEDCCC,$EEEEDCCC,$EEEEDCCC; 112
		dc.l $EEEEDCCC,$EEEEDCCC,$EEEEDCCC,$EEEEDDCC,$EEEEEDCC,$EEEEEDCC, $EEEEDCC, $EEEEEDC, $EEEEEDC,	$EEEEEDC,  $EEEEDC,  $EEEEED,  $EEEEED,	  $EEEEE,   $EEEEE,    $EEEE; 128
		dc.l $DCCCCDEE,$CCCCDEE0,$CCCCDE00,$CCCDEE00,$CCCDE000,$CCCDE000,$CCCE0000,$CCDE0000,$CCD00000,$CCD00000,$CCD00000,$CC000000,$C6000000,$C6000000,$C6000000,$C6000000; 144
		dc.l $66000000,$66000000,$66000000,$66000000,$66000000,$66600000,$66600000,$66600000,$66660000,$66660000,$C6666000,$C6666000,$C6666600,$DC666600,$EDC66660,$EDC66666; 160
		dc.l $EEEEEDDC,	$EEEEEDC,  $EEEEDD,  $EEEEED,	$EEEED,	  $EEEEE,    $EEEE,    $EEEE,	  $EEE,	    $EEE,     $EEE,	 $EE,	   $EE,	     $EE,      $EE,	 $EE; 176
		dc.l	   $EE,	     $EE,      $EE,	 $EE,	   $EE,	    $EEE,     $EEE,	$EEE,	 $EEED,	   $EEED,   $EEEDD,   $EEEDD,  $EEEDDC,	 $EEEDCC, $EEEDDCC,$EEEDDCCC; 192
		dc.l $66660000,$C666C000,$C666C000,$CC666C00,$DC666C00,$DC666C00,$DCC666C0,$DDC666C0,$EDC666C0,$EDC666C0,$EDC6666C,$EDDC666C,$EDDC666C,$EDDC666C,$EDDC666C,$EDDC666C; 208
		dc.l $EDDCC66C,$EDDCC66C,$EDDCC66C,$EDDCC66C,$EDDCC66C,$DDDCC6CC,$DDDCC6C0,$DDCCC6C0,$DDCCCCD0,$DDCC6CD0,$CDCCCC00,$CCCCCD00,$CDCCCD00,$CCCCD000,$DCCCD000,$DCCD0000; 224
		dc.l	 $EEEE,	    $EEE,      $EE,	 $EE,	    $E,	       0,	 0,	   0,$EEDC6666,$EEEDC666,$EEEEDC66,$EEEEEDC6,$EEEEEEDC,$EEEEEEED, $EEEEEEE,  $EEEEEE; 240
		dc.l $60000000,$66000000,$66660000,$66666600,$66666666,$CC666666,$DDC66666,$EEDCCC66,	     0,	       0,	 0,	   0,	     0,$66600000,$66666666,$66666666; 256
		dc.l	     0,	       0,	 0,	   0,	     0,	    $DDD,$6666CCCC,$CCCCCCCC,	    $E,	     $EE,    $EEED,  $EEEDDC,$EEDDDCCC,$DCCCCCCC,$CCCCCCCC,$CCCCCCCD; 272
		dc.l $EEDDCCCD,$DDCCCCDD,$DCCCCDDD,$CCCCDDDD,$CCCDDDDE,$CCDDDDEE,$CDDDDEE0,$DDDDEE00,$CCDD0000,$CDD00000,$DD000000,$DE000000,$E0000000,	       0,	 0,	   0; 288
		dc.l	$EEEEE,	   $EEEE,      $EE,	  $E,	     0,	       0,	 0,	   0,$EEEDDCCC,$EEEEEDDD,$EEEEEEEE,$EEEEEEEE, $EEEEEEE,	  $EEEEE,      $EE,	   0; 304
		dc.l $CCCCCCCC,$DCCCCCCC,$EDDDDCCC,$EEEEDDDD,$EEEEEEEE,$EEEEEEEE,$EEEEEEEE,  $EEEEEE,$CCCCCCCC,$CCCCCCCC,$CCCCCCCC,$DDDDDDDD,$EEEEEEEE,$EEEEEEEE,$EEEEEEEE,$EEEEEE00; 320
		dc.l $CCCCCDDD,$CCCDDDDD,$DDDDDEEE,$DEEEEEEE,$EEEEEEE0,$EEEEE000,$EE000000,	   0,$DDEEE000,$EEEE0000,$EE000000,$E0000000,	     0,	       0,	 0,	   0; 336
		dc.l	     0,	       0,	$D,	$DDC,	 $DCCC,	  $DCCCD,  $DCCDDD, $DCDDDDD,	$CCCCC,	$DCCC666,$CC666666,$C6CCC666,$CCCCCCCC,$DDDDDDDD,$DDDDDDDD,$DDDDDDDD; 352
		dc.l $CCCCC000,$66666CCC,$66666666,$66666666,$66666666,$CC666666,$DDCC6666,$DDDDC666,	     0,	       0,$CC000000,$66CC0000,$6666C000,$66666600,$66666660,$66666666; 368
		dc.l	     0,	      $E,      $ED,	 $ED,	  $EDD,	    $EDD,    $EDDE,   $EEDDE,$DDDDDDDD,$DDDDDEEE,$DDDEEEEE,$DDEEEEEE,$DEEEEEEE,$EEEEEEEE,$EEEEEEE0,$EEEEEDE0; 384
		dc.l $EEEEEEEE,$EEEEEEEE,$EEEE0000,$EE000000,$E0000000,	       0,	 0,	   0,$DDDDDC66,$EEDDDDC6,$EEEEDDDC,  $EEEDDD,	$EEEDD,	   $EEDD,     $EED,	 $EE; 400
		dc.l	   $EE,	      $E,	$E,	   0,	     0,	       0,	 0,	   0,$66666666,$66666666,$66666666,$C6666666,$DC666666,$DC666666,$DDC66666,$DDC66666; 416
		dc.l $DDDC6666,$EDDC6666,$EDDDC666,$EDDDC666,$EDDDCC66,$EEDDDC66,$EEDDDC66, $EDDDCC6,$60000000,$66000000,$66000000,$66600000,$666C0000,$66660000,$66666000,$66666000; 432
		dc.l $66666000,$66666C00,$66666C00,$666666C0,$666666C0,$666666C0,$66666660,$6666666C,	$EDDEE,	  $EDDEE,   $EDEEE,  $EEDEEE,  $EDDEEE,	 $EDDEED, $EEDDEED, $EEDEEDD; 448
		dc.l  $EDDEEDD,	$EDDEDDC,$EEDDEDCC,$EEDDEDCC,$EEDDEDCC,$EEDDDCCC,$EEEDDCCC,$EEEDDCC6,$EEEDDCC6,$EEEDDCC6,$EEEDDC66,$EEEDDC66,$EEEEDC66,$EEEEDC66, $EEEDC66, $EEEED66; 464
		dc.l  $EEEED66,	$EEEED66,  $EEEDC6,  $EEEEC6,  $EEEEC6,	  $EEEDC,   $EEEED,   $EEEED,$EEEDDD00,$EEDDDE00,$EDDDD000,$DDDDE000,$DDDD0000,$DDCD0000,$DCCD0000,$CCCD0000; 480
		dc.l $CCCD0000,$CCC00000,$CCC00000,$CC600000,$C6600000,$66600000,$66600000,$66600000,$66600000,$66600000,$66600000,$66600000,$66600000,$66600000,$66600000,$66660000; 496
		dc.l $66660000,$66660000,$66660000,$66660000,$66666000,$66666000,$C6666600,$C6666600, $EDDDCC6,	$EDDDCC6, $EDDDCC6, $EDDDDCC,  $EDDDCC,	 $EDDDCC,  $EDDDCC,  $EDDDCC; 512
		dc.l   $EDDDCC,	 $EDDDCC,  $EDDDCC,  $EDDDCC, $EDDDDCC,	$EDDDCCC, $EDDDCCC, $EDDDCCC,$6666666C,$6666666C,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666; 528
		dc.l $6666666C,$C666666C,$C666666C,$CCC666CC,$CCCCCCCC,$CCCCCCCC,$CCCCCCCC,$CCCCCCCD,	     0,	       0,	 0,	   0,	     0,	      $E,	$E,	 $ED; 544
		dc.l	   $ED,	    $EDD,    $DDDD,   $DDDDD,  $DDDDDC,$DDDDDCCD,$DDDCCDDD,$DDDDDDDD, $EDDDCCC,$EDDDDCCC,$EDDDDCCC,$EDDDCCCC,$EDDDCCCC,$DDDDCCCC,$DDDCCCCC,$DDDCCDCC; 560
		dc.l $DDCCDDCC,$DDCCDDDC,$DCCDDDDD,$CCDDDDDD,$CDDDDDDD,$DDDDDDDD,$DDDDDDDD,$DDDDDDEE,$CCCCCCCD,$CCCCCCC0,$CCCCCCC0,$CCCCCCD0,$CCCCCCD0,$CCCCCD00,$CCCCCD00,$CCCCD000; 576
		dc.l $CCCCD000,$CCDDE000,$DDDE0000,$DDDE0000,$DDE00000,$DE000000,$EE000000,$E0000000,	$EEEEE,	   $EEEE,     $EEE,	$EEE,	   $EE,	     $EE,	$E,	   0; 592
		dc.l $D6666660,$EC666660,$EDC66666,$EEDC6666,$EEED6666,$EEEEDD66,$EEEEDDDD,$EEEEEEDD,	     0,	       0,	 0,$60000000,$66000000,$66660000,$D6666DDD,$DDDDDDDD; 608
		dc.l  $EEEEEED,	$EEEEEEE,   $EEEEE,    $EEEE,	  $EEE,	      $E,	 0,	   0,$DDDDDDDD,$DDDDDDDD,$EEEDDDDD,$EEEEEEDD,$EEEEEEEE,$EEEEEEEE, $EEEEEEE,   $EEEEE; 624
		dc.l $DDDDDDDD,$DDDDDDDD,$DDDDDDDD,$DDDEEEEE,$EEEEEEEE,$EEEEEEEE,$EEEEEEEE,$EEEEE000,$DDDDDEEE,$DDDEEEE0,$EEEEEE00,$EEEEE000,$EEEE0000,$EE000000,	 0,	   0; 640
		dc.l	     0,	     $CC,     $CC6,    $DC66,	$DCC66,	  $DC666,  $DCC666,  $DCC666, $DDCC666,	$DCCC666, $DCC6666,$DDCC6666,$DDCC6666,$DDCC6666,$DDCC6666,$DDCC6666; 656
		dc.l $DDCC6666,$DDCC6666,$DDCC6666,$DDCC6666,$DDCC6666,$DDCC6666,$DDCC6666,$DDCC6666,$EDCCC666,$EDCCC666,$EDCCC666,$EDCCC666,$EDCCC666,$EDCCC666,$EDCCC666,$EDCCCC66; 672
		dc.l $CCCCCCCC,$C666666C,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666; 688
		dc.l $66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666,$66666666; 704
		dc.l $EDDCCC66,$EDDCCC66,$EDDCCCC6,$EDDCCCCC,$EDDCCCCC,$EDDCCCCC,$EDDCCCCC,$EDDCCCCC,$EDDCCCCC,$EDDDCCCC,$EDDDCCCC,$EEDDCCCC,$EEDDCCCC,$EEDDDCCC,$EEDDDCCC,$EEDDDDCC; 720
		dc.l $EEDDDDDC,$EEDDDDDD,$EEDDDDDD,$EEDDDDDD,$EEEDDDDD,	$EEDDDDD, $EEDDDDD, $EEEDDDD,  $EEDDDD,	 $EEEDDD,   $EEEDD,   $EEEEE,	 $EEEE,	    $EEE,      $EE,	   0; 736
		dc.l $66666666,$66666666,$66666666,$C666666C,$CCCCCCCC,$CCCCCCCC,$CCCCCCCC,$CCCCCCCC,$CCCCCCCC,$CCCCCCCC,$CCCCCCCC,$CCCCCCCC,$CCCCCCCC,$CCCCCCCC,$CCCCCCCC,$CCCCCCCC; 752
		dc.l $CCCCCCCC,$DCCCCCCD,$DDDDDDDD,$DDDDDDDD,$DDDDDDDD,$DDDDDDDD,$DDDDDDDD,$DDDDDDDD,$DDDDDDDD,$DDDDDDDD,$DDDDDDDD,$DDDDDDDD,$EEEEEEEE,$EEEEEEEE,$EEEEEEEE,$EEEEEEEE; 768
;
; these	are some level mappings	(16x16 or 256x256)
;
Leftover_LevelMappings:dc.b   0,  0,$EE,$EE,$EE,$EE,  0,  0,  0,  0,  0,  0,  0,  0,$EE,$DC,$66,$66,$EE,$ED,$C6,$66,$EE,$EE,$DC,$66,$EE,$EE,$ED,$C6,$EE,$EE,$EE,$DC,$EE,$EE,$EE,$ED, $E,$EE,$EE,$EE,  0,$EE,$EE,$EE,$60,  0,  0,  0,$66,  0,  0,  0,$66,$66,  0,  0,$66,$66,$66,  0,$66,$66; 0
		dc.b $66,$66,$CC,$66,$66,$66,$DD,$C6,$66,$66,$EE,$DC,$CC,$66,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$66,$60,  0,  0,$66,$66,$66,$66,$66,$66,$66,$66,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 64
		dc.b   0,  0,  0,  0, $D,$DD,$66,$66,$CC,$CC,$CC,$CC,$CC,$CC,  0,  0,  0, $E,  0,  0,  0,$EE,  0,  0,$EE,$ED,  0,$EE,$ED,$DC,$EE,$DD,$DC,$CC,$DC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CD,$EE,$DD,$CC,$CD,$DD,$CC,$CC,$DD,$DC,$CC,$CD,$DD,$CC,$CC,$DD,$DD,$CC,$CD; 128
		dc.b $DD,$DE,$CC,$DD,$DD,$EE,$CD,$DD,$DE,$E0,$DD,$DD,$EE,  0,$CC,$DD,  0,  0,$CD,$D0,  0,  0,$DD,  0,  0,  0,$DE,  0,  0,  0,$E0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $E,$EE,$EE,  0,  0,$EE,$EE,  0,  0,  0,$EE,  0,  0,  0, $E,  0,  0; 192
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$EE,$ED,$DC,$CC,$EE,$EE,$ED,$DD,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE, $E,$EE,$EE,$EE,  0, $E,$EE,$EE,  0,  0,  0,$EE,  0,  0,  0,  0,$CC,$CC,$CC,$CC,$DC,$CC,$CC,$CC,$ED,$DD,$DC,$CC,$EE,$EE,$DD,$DD,$EE,$EE; 256
		dc.b $EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,  0,$EE,$EE,$EE,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$DD,$DD,$DD,$DD,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,  0,$CC,$CC,$CD,$DD,$CC,$CD,$DD,$DD,$DD,$DD,$DE,$EE,$DE,$EE,$EE,$EE,$EE,$EE; 320
		dc.b $EE,$E0,$EE,$EE,$E0,  0,$EE,  0,  0,  0,  0,  0,  0,  0,$DD,$EE,$E0,  0,$EE,$EE,  0,  0,$EE,  0,  0,  0,$E0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $D,  0,  0, $D,$DC,  0,  0; 384
		dc.b $DC,$CC,  0, $D,$CC,$CD,  0,$DC,$CD,$DD, $D,$CD,$DD,$DD,  0, $C,$CC,$CC, $D,$CC,$C6,$66,$CC,$66,$66,$66,$C6,$CC,$C6,$66,$CC,$CC,$CC,$CC,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$CC,$CC,$C0,  0,$66,$66,$6C,$CC,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66; 448
		dc.b $66,$66,$CC,$66,$66,$66,$DD,$CC,$66,$66,$DD,$DD,$C6,$66,  0,  0,  0,  0,  0,  0,  0,  0,$CC,  0,  0,  0,$66,$CC,  0,  0,$66,$66,$C0,  0,$66,$66,$66,  0,$66,$66,$66,$60,$66,$66,$66,$66,  0,  0,  0,  0,  0,  0,  0, $E,  0,  0,  0,$ED,  0,  0,  0,$ED,  0,  0; 512
		dc.b  $E,$DD,  0,  0, $E,$DD,  0,  0,$ED,$DE,  0, $E,$ED,$DE,$DD,$DD,$DD,$DD,$DD,$DD,$DE,$EE,$DD,$DE,$EE,$EE,$DD,$EE,$EE,$EE,$DE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$E0,$EE,$EE,$ED,$E0,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,  0,  0,$EE,  0,  0,  0,$E0,  0; 576
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$DD,$DD,$DC,$66,$EE,$DD,$DD,$C6,$EE,$EE,$DD,$DC,  0,$EE,$ED,$DD,  0, $E,$EE,$DD,  0,  0,$EE,$DD,  0,  0, $E,$ED,  0,  0,  0,$EE,  0,  0,  0,$EE,  0,  0,  0, $E,  0,  0,  0, $E,  0,  0,  0,  0,  0,  0; 640
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$C6,$66,$66,$66,$DC,$66,$66,$66,$DC,$66,$66,$66,$DD,$C6,$66,$66,$DD,$C6,$66,$66,$DD,$DC,$66,$66,$ED,$DC,$66,$66,$ED,$DD,$C6,$66,$ED,$DD,$C6,$66,$ED,$DD; 704
		dc.b $CC,$66,$EE,$DD,$DC,$66,$EE,$DD,$DC,$66, $E,$DD,$DC,$C6,$60,  0,  0,  0,$66,  0,  0,  0,$66,  0,  0,  0,$66,$60,  0,  0,$66,$6C,  0,  0,$66,$66,  0,  0,$66,$66,$60,  0,$66,$66,$60,  0,$66,$66,$60,  0,$66,$66,$6C,  0,$66,$66,$6C,  0,$66,$66,$66,$C0,$66,$66; 768
		dc.b $66,$C0,$66,$66,$66,$C0,$66,$66,$66,$60,$66,$66,$66,$6C,  0, $E,$DD,$EE,  0, $E,$DD,$EE,  0, $E,$DE,$EE,  0,$EE,$DE,$EE,  0,$ED,$DE,$EE,  0,$ED,$DE,$ED, $E,$ED,$DE,$ED, $E,$ED,$EE,$DD, $E,$DD,$EE,$DD, $E,$DD,$ED,$DC,$EE,$DD,$ED,$CC,$EE,$DD,$ED,$CC,$EE,$DD; 832
		dc.b $ED,$CC,$EE,$DD,$DC,$CC,$EE,$ED,$DC,$CC,$EE,$ED,$DC,$C6,$EE,$ED,$DC,$C6,$EE,$ED,$DC,$C6,$EE,$ED,$DC,$66,$EE,$ED,$DC,$66,$EE,$EE,$DC,$66,$EE,$EE,$DC,$66, $E,$EE,$DC,$66, $E,$EE,$ED,$66, $E,$EE,$ED,$66, $E,$EE,$ED,$66,  0,$EE,$ED,$C6,  0,$EE,$EE,$C6,  0,$EE; 896
		dc.b $EE,$C6,  0, $E,$EE,$DC,  0, $E,$EE,$ED,  0, $E,$EE,$ED,$EE,$ED,$DD,  0,$EE,$DD,$DE,  0,$ED,$DD,$D0,  0,$DD,$DD,$E0,  0,$DD,$DD,  0,  0,$DD,$CD,  0,  0,$DC,$CD,  0,  0,$CC,$CD,  0,  0,$CC,$CD,  0,  0,$CC,$C0,  0,  0,$CC,$C0,  0,  0,$CC,$60,  0,  0,$C6,$60; 960
		dc.b   0,  0,$66,$60,  0,  0,$66,$60,  0,  0,$66,$60,  0,  0,$66,$60,  0,  0,$66,$60,  0,  0,$66,$60,  0,  0,$66,$60,  0,  0,$66,$60,  0,  0,$66,$60,  0,  0,$66,$60,  0,  0,$66,$66,  0,  0,$66,$66,  0,  0,$66,$66,  0,  0,$66,$66,  0,  0,$66,$66,  0,  0,$66,$66; 1024
		dc.b $60,  0,$66,$66,$60,  0,$C6,$66,$66,  0,$C6,$66,$66,  0, $E,$DD,$DC,$C6, $E,$DD,$DC,$C6, $E,$DD,$DC,$C6, $E,$DD,$DD,$CC,  0,$ED,$DD,$CC,  0,$ED,$DD,$CC,  0,$ED,$DD,$CC,  0,$ED,$DD,$CC,  0,$ED,$DD,$CC,  0,$ED,$DD,$CC,  0,$ED,$DD,$CC,  0,$ED,$DD,$CC, $E,$DD; 1088
		dc.b $DD,$CC, $E,$DD,$DC,$CC, $E,$DD,$DC,$CC, $E,$DD,$DC,$CC,$66,$66,$66,$6C,$66,$66,$66,$6C,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$6C,$C6,$66,$66,$6C,$C6,$66,$66,$6C,$CC,$C6,$66,$CC,$CC,$CC; 1152
		dc.b $CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CD,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $E,  0,  0,  0, $E,  0,  0,  0,$ED,  0,  0,  0,$ED,  0,  0, $E,$DD,  0,  0,$DD,$DD,  0, $D,$DD,$DD,  0,$DD; 1216
		dc.b $DD,$DC,$DD,$DD,$DC,$CD,$DD,$DC,$CD,$DD,$DD,$DD,$DD,$DD, $E,$DD,$DC,$CC,$ED,$DD,$DC,$CC,$ED,$DD,$DC,$CC,$ED,$DD,$CC,$CC,$ED,$DD,$CC,$CC,$DD,$DD,$CC,$CC,$DD,$DC,$CC,$CC,$DD,$DC,$CD,$CC,$DD,$CC,$DD,$CC,$DD,$CC,$DD,$DC,$DC,$CD,$DD,$DD,$CC,$DD,$DD,$DD,$CD,$DD; 1280
		dc.b $DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$EE,$CC,$CC,$CC,$CD,$CC,$CC,$CC,$C0,$CC,$CC,$CC,$C0,$CC,$CC,$CC,$D0,$CC,$CC,$CC,$D0,$CC,$CC,$CD,  0,$CC,$CC,$CD,  0,$CC,$CC,$D0,  0,$CC,$CC,$D0,  0,$CC,$DD,$E0,  0,$DD,$DE,  0,  0,$DD,$DE,  0,  0,$DD,$E0; 1344
		dc.b   0,  0,$DE,  0,  0,  0,$EE,  0,  0,  0,$E0,  0,  0,  0,  0, $E,$EE,$EE,  0,  0,$EE,$EE,  0,  0, $E,$EE,  0,  0, $E,$EE,  0,  0,  0,$EE,  0,  0,  0,$EE,  0,  0,  0, $E,  0,  0,  0,  0,$D6,$66,$66,$60,$EC,$66,$66,$60,$ED,$C6,$66,$66,$EE,$DC,$66,$66,$EE,$ED; 1408
		dc.b $66,$66,$EE,$EE,$DD,$66,$EE,$EE,$DD,$DD,$EE,$EE,$EE,$DD,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$60,  0,  0,  0,$66,  0,  0,  0,$66,$66,  0,  0,$D6,$66,$6D,$DD,$DD,$DD,$DD,$DD, $E,$EE,$EE,$ED, $E,$EE,$EE,$EE,  0, $E,$EE,$EE,  0,  0,$EE,$EE,  0,  0; 1472
		dc.b  $E,$EE,  0,  0,  0, $E,  0,  0,  0,  0,  0,  0,  0,  0,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$EE,$ED,$DD,$DD,$EE,$EE,$EE,$DD,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE, $E,$EE,$EE,$EE,  0, $E,$EE,$EE,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DE,$EE,$EE,$EE,$EE; 1536
		dc.b $EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$E0,  0,$DD,$DD,$DE,$EE,$DD,$DE,$EE,$E0,$EE,$EE,$EE,  0,$EE,$EE,$E0,  0,$EE,$EE,  0,  0,$EE,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$CC,  0,  0, $C,$C6,  0,  0,$DC,$66,  0, $D; 1600
		dc.b $CC,$66,  0, $D,$C6,$66,  0,$DC,$C6,$66,  0,$DC,$C6,$66, $D,$DC,$C6,$66, $D,$CC,$C6,$66, $D,$CC,$66,$66,$DD,$CC,$66,$66,$DD,$CC,$66,$66,$DD,$CC,$66,$66,$DD,$CC,$66,$66,$DD,$CC,$66,$66,$DD,$CC,$66,$66,$DD,$CC,$66,$66,$DD,$CC,$66,$66,$DD,$CC,$66,$66,$DD,$CC; 1664
		dc.b $66,$66,$DD,$CC,$66,$66,$DD,$CC,$66,$66,$DD,$CC,$66,$66,$ED,$CC,$C6,$66,$ED,$CC,$C6,$66,$ED,$CC,$C6,$66,$ED,$CC,$C6,$66,$ED,$CC,$C6,$66,$ED,$CC,$C6,$66,$ED,$CC,$C6,$66,$ED,$CC,$CC,$66,$CC,$CC,$CC,$CC,$C6,$66,$66,$6C,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66; 1728
		dc.b $66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66; 1792
		dc.b $66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$ED,$DC,$CC,$66,$ED,$DC,$CC,$66,$ED,$DC,$CC,$C6,$ED,$DC,$CC,$CC,$ED,$DC; 1856
		dc.b $CC,$CC,$ED,$DC,$CC,$CC,$ED,$DC,$CC,$CC,$ED,$DC,$CC,$CC,$ED,$DC,$CC,$CC,$ED,$DD,$CC,$CC,$ED,$DD,$CC,$CC,$EE,$DD,$CC,$CC,$EE,$DD,$CC,$CC,$EE,$DD,$DC,$CC,$EE,$DD,$DC,$CC,$EE,$DD,$DD,$CC,$EE,$DD,$DD,$DC,$EE,$DD,$DD,$DD,$EE,$DD,$DD,$DD,$EE,$DD,$DD,$DD,$EE,$ED; 1920
		dc.b $DD,$DD, $E,$ED,$DD,$DD, $E,$ED,$DD,$DD, $E,$EE,$DD,$DD,  0,$EE,$DD,$DD,  0,$EE,$ED,$DD,  0, $E,$EE,$DD,  0, $E,$EE,$EE,  0,  0,$EE,$EE,  0,  0, $E,$EE,  0,  0,  0,$EE,  0,  0,  0,  0,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$C6,$66,$66,$6C,$CC,$CC; 1984
		dc.b $CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$DC,$CC,$CC,$CD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD; 2048
		dc.b $DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$DD,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$40,$AC,$40,$A4,$40,$A4,  0,$AC,$40,$AC,$40,$AC,$C0,$AC,$40,$A4,  0,$AC; 2112
		dc.b $40,$A4,$40,$AC,$40,$AC,$40,$AC,$80,$A4,$40,$AC,$40,$AC,$40,$A4,  0,$AC,$40,$AC,  0,$A0,$80,$A4,$40,$AC,$40,$A4,$40,$A4,  0,$AC,$40,$A4,$40,$A4,$C0,$AC,  0,$A4,  0,$A4,  0,$AC,$40,$AC,  0,$AC,$40,$AC,$C0,$AC,$40,$A4,$40,$AC,$40,$A4,$40,$AC,  0,$AC,$40,$AC; 2176
		dc.b $C0,$AC,$40,$A0,$40,$A4,  0,$A4,  0,$AC,$40,$AC,$40,$A4,$40,$A4,$40,$A0,  0,$A0,$40,$A4,  0,$A8,  0,$AC,$40,$A8,$C0,$A4,$40,$A0,  0,$A0,$40,$A8,$40,$AC,  0,$A4,$40,$A8,$40,$AC,  0,$A0,$C4,$84,$44,$84,$44,$84,$44,$84,$40,$84,$44,$84,$44,$84,$44,$84,$C4,$84; 2240
		dc.b $44,$84,$C4,$84,$C4,$84,$C4,$84,$44,$84,$44,$84,$C4,$84,$44,$84,$44,$84,$C0,$84,$C4,$84,$44,$84,$C4,$84,$C4,$84,$C4,$84,$44,$84,$44,$84,$44,$84,$40,$84,$C0,$84,$40,$84,$44,$8C,$44,$84,$44,$84,$44,$84,$44,$84,$C4,$8C,$44,$84,$C4,$84,$C4,$8C,$40,$84,$44,$84; 2304
		dc.b $44,$84,$44,$84,$44,$84,$44,$84,$C4,$84,$44,$84,$40,$84,$44,$84,$44,$84,$44,$84,$44,$8C,$C4,$84,$C4,$84,$C4,$84,$C4,$84,$44,$84,$40,$8C,$44,$84,$44,$84,$44,$84,$C4,$84,$C4,$84,$44,$84,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2368
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2432
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2496
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2560
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2624
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2688
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2752
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 2816
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $C,$82, $C,$82, $C,$82, $C,$80, $C,$82, $C,$82, $C,$82, $C,$82, $C,$82; 2880
		dc.b   0,$82, $C,$82, $C,$80, $C,$82,  4,$82, $C,$82, $C,$82, $C,$82, $C,$80, $C,$82, $C,$82, $C,$82, $C,$82, $C,$82, $C,$82, $C,$80, $C,$80, $C,$82,  4,$80, $C,$82, $C,$82, $C,$82, $C,$82, $C,$80, $C,$82, $C,$82, $C,$80, $C,$82, $C,$82, $C,$82,  4,$82,  4,$82; 2944
		dc.b  $C,$80, $C,$82, $C,$82,  4,$82, $C,$82, $C,$82, $C,$82, $C,$82, $C,$82, $C,$82, $C,$82, $C,$80, $C,$82, $C,$82, $C,$82, $C,$80, $C,$82, $C,$82, $C,$82, $C,$82,  4,$82, $C,$82,  4,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80; 3008
		dc.b  $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80,  4,$81, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80; 3072
		dc.b  $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$81, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,  0, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$82, $C,$80, $C,$82, $C,$82,  4,$82, $C,$82, $C,$82, $C,$80; 3136
		dc.b  $C,$82, $C,$82, $C,$82, $C,$82, $C,$82, $C,$82, $C,$80, $C,$82, $C,$82, $C,$82, $C,$82, $C,$82, $C,$82, $C,$82, $C,$82, $C,$82, $C,$80, $C,$82, $C,$82, $C,$82, $C,$80, $C,$82, $C,$82, $C,$80, $C,$82, $C,$80, $C,$82, $C,$80, $C,$82, $C,$82, $C,$82, $C,$82; 3200
		dc.b  $C,$80, $C,$82, $C,$80, $C,$82,  4,$82, $C,$82, $C,$82, $C,$82, $C,$80, $C,$82, $C,$82, $C,$82, $C,$82, $C,$82, $C,$82, $C,$82, $C,$82, $C,$80, $C,$82, $C,$80, $C,$82, $C,$82, $C,$82, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80; 3264
		dc.b  $C,$80, $C,$80,  4,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80; 3328
		dc.b  $C,$80, $C,$80, $C,$80, $C,$81, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$81, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80, $C,$80,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3392
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3456
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3520
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3584
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3648
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3712
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3776
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 3840
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8; 3904
		dc.b $C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$CA,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$CA; 3968
		dc.b $C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8; 4032
		dc.b $C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8; 4096
		dc.b $C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8; 4160
		dc.b $C8,$C8,$88,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$88,$C8; 4224
		dc.b $C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$88,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8; 4288
		dc.b $C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C0,$CC,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8; 4352
		dc.b $CC,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$CC,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,$C8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  0,  0,  8,  0,  0,  0,  8; 4416
		dc.b   0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  0,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  0,  0,  8,  0,  0,  0,  8,  0,  0,  0,  8,  0,  0,  0,  0,  0,  8,  0,  8,  0,  8,  0,  8,  0,  0; 4480
		dc.b   0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  0,  0,  8,  0,  0,  0,  8,  0,  8,  0,  0,  0,  8,  0,  8,  0,  0,  0,  8,  0,  0,  0,  8,  0,  8,  0,  8,  0,  0,  0,  8,  0,  8,  0,  0,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  0,  0,  8,  0,  8; 4544
		dc.b   0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8; 4608
		dc.b   0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  0,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  0,  0,  8,  0,  0,  0,  0,  0,  0,  0,  8,  0,  8; 4672
		dc.b   0,  8,  0,  8,  0,  8,  0,  0,  0,  8,  0,  8,  0,  8,  0,  8,  0,  0,  0,  8,  0,  8,  0,  0,  0,  8,  0,  8,  0,  8,  0,  0,  0,  0,  0,  8,  0,  8,  0,  8,  0,  0,  0,  8,  0,  8,  0,  8,  0,  0,  0,  8,  0,  8,  0,  8,  0,  8,  0,  0,  0,  8,  0,  8; 4736
		dc.b   0,  8,  0,  8,  0,  0,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  0,  0,  8,  0,  8,  0,  0,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  0,  0,  8,  0,  0,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8; 4800
		dc.b   0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,$88,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8; 4864
		dc.b   0,  8,  0,  8,  0,  8,  0,  8,  0,  0,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,  0,  8,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88; 4928
		dc.b $80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88; 4992
		dc.b $80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,  0,$88,$80,$88,  0,$88,$80,$88; 5056
		dc.b $80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,  0,$88,$80,$88,$80,$88,$80,$88,  0,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,  0,$88,  0,$88,$80,$88,$80,$88,  0,$88,$80,$88,  0,$88,$80,$88; 5120
		dc.b $80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,  0,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88; 5184
		dc.b $80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,  0,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,  0,$88,$80,$88,$80,$88,$80,$88,  0,$88,  0,$88,$80,$88,$80,$88,$80,$88,$80,$88,  0,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88; 5248
		dc.b $80,$88,  0,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,  0,$88,$80,$88,$80,$88,$80,$88,  0,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,  0,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88; 5312
		dc.b $80,$88,$80,$88,$80,$88,$80,$88,$80,$88,  0,$88,$80,$88,$80,$88,  0,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,  0,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88; 5376
		dc.b $80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,  0,$88,$80,$88,  0,$88,  0,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,  0,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,$80,$88,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 5440
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 5504
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 5568
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 5632
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 5696
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 5760
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 5824
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 5888
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$88,  0,$C8,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0; 5952
		dc.b $88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$C8,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0; 6016
		dc.b $88,  0,$88,  0,$C8,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$C8,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$88,  4,$C8,  4,$88,  4,$C8,  4,$C8,  4; 6080
		dc.b $C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$88,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$88,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4; 6144
		dc.b $C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0; 6208
		dc.b $88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0; 6272
		dc.b $88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$88,  0,$C8,  4,$88,  4,$C8,  4,$C8,  4,$88,  4,$C8,  4,$C8,  4,$C8,  4,$88,  4; 6336
		dc.b $88,  4,$88,  4,$88,  4,$C8,  4,$C8,  4,$88,  4,$88,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$CC,  4,$C8,  4,$88,  4,$88,  4,$C8,  4,$C8,  4,$C8,  4,$88,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$CC,  4,$C8,  4,$88,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4; 6400
		dc.b $C8,  4,$C8,  4,$88,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$88,  4,$88,  4,$C8,  4,$C8,  4,$C8,  4,$C8,  4,$88,  4,$C8,  4,$88,  4,$C8,  4,$88,  4,$C8,  4,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 6464
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 6528
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 6592
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 6656
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 6720
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 6784
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 6848
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 6912
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$80,$8C,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84; 6976
		dc.b $80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$80,$80,$84,$80,$84,$80,$84,$80,$84; 7040
		dc.b $80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$80,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$80,$80,$84,$80,$84,$80,$84,$80,$84,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94; 7104
		dc.b $80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94; 7168
		dc.b $80,$94,$80,$94,$80,$D4,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$84,$80,$84,$80,$80,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,  0,$84; 7232
		dc.b $80,$80,$80,$84,$80,$84,$80,$80,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$80,$80,$84,$80,$84,  0,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$80,$80,$84,$80,$84,$80,$84,$80,$84; 7296
		dc.b $80,$84,$80,$84,$80,$84,$80,$84,$80,$84,$80,$80,$80,$84,$80,$84,$80,$80,$80,$84,$80,$84,$80,$84,$80,$84,$80,$80,$80,$84,$80,$80,$80,$84,$80,$84,$80,$84,$80,$80,$80,$84,$80,$84,$80,$84,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94; 7360
		dc.b $80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94; 7424
		dc.b $80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94,$80,$94; 7488

;
; leftover art - full 128 char ASCII table
;
Leftover_Art_Alphabet:dc.b   0,	 0,  0,	 0,  0,	 0,  0,	 0,  0,	 0,  0,	 0,  0,	 0,  0,	 0,  0,	 0,  0,	 0,  0,	 0,  0,	 0,  0,	 0,  0,	 0,  0,	 0,  0,	 0, $F,$FF,  0,	 0,$F0,	 0,$F0,	 0, $F,$FF,$F0,	 0,$FF,$FF,$F0,	 0,  0,$F0,  0,$F0,  0,$FF,$FF,$F0,  0,$F0,  0,$F0,  0,$F0,  0,$F0; 0
		dc.b  $F,$FF,  0,  0,$F0,  0,$F0,  0, $F,$FF,$F0,  0,$FF,$FF,$F0,  0,  0,$F0,  0,$F0,  0, $F,$FF,  0,  0,$FF, $F,$F0,  0,$F0,  0,$F0,$FF,$FF,$F0,  0,$F0,  0,  0,  0,$FF,$FF,  0,  0,$FF,$FF,$F0,  0,  0,$F0,  0,$F0,  0, $F,$FF,  0,  0,$FF, $F,$F0,  0,$F0,  0,$F0; 64
		dc.b $FF,$FF,$F0,  0,$F0,  0,  0,  0,$FF,$FF,  0,  0,$FF,$FF,$F0,  0,  0,$FF,$FF,$F0,  0,  0,$F0,  0,  0,  0,$F0,  0,  0,  0,$F0,  0,$FF,$FF,$F0,  0,$F0,  0,  0,  0,$FF,$FF,  0,  0,$FF,$FF,$F0,  0,  0, $F,$FF,  0,  0,$F0,  0,$F0,  0,$F0,$FF,$F0,  0, $F,$F0,$F0; 128
		dc.b  $F,$FF,  0,  0,$F0,  0,$F0,  0,$FF,$FF,$F0,  0,$F0,  0,$F0,  0,  0,$F0, $F,$F0,  0,$FF,$F0,  0,  0,$F0,$FF,  0,  0,$F0,  0,$F0,$FF,$FF,  0,  0,$F0,  0,$F0,  0,$FF,$FF,$F0,  0,$FF,$FF,$F0,  0,  0,$F0,  0,  0,  0,$F0,  0,  0,  0,$F0,  0,  0,  0,$FF,$FF,$F0; 192
		dc.b $FF,$FF,  0,  0,$F0,  0,$F0,  0,$FF,$FF,$F0,  0,$FF,$FF,$F0,  0,  0,$FF,$FF,$F0,  0,$FF,$FF,  0,  0,$F0,  0,$F0,  0, $F,$FF,  0,$F0,  0,$F0,  0,$F0,  0,$F0,  0,$FF,$FF,$F0,  0,$F0,  0,$F0,  0,  0,$FF,$FF,$F0,  0,  0,$F0,  0,  0,  0,$F0,  0,  0,  0,$F0,  0; 256
		dc.b $F0,  0,  0,  0,$F0,  0,  0,  0,$F0,  0,  0,  0,$FF,$FF,$F0,  0,  0,$FF,$FF,$F0,  0,$FF,$FF,  0,  0,$F0,  0,  0,  0,$F0,  0,  0,$F0,  0,$F0,  0,$F0,  0,$F0,  0,$F0,  0,$F0,  0, $F,$FF,  0,  0,  0,$FF,$FF,$F0,  0,  0,$F0,  0,  0,  0,$F0,  0,  0,  0,$F0,  0; 320
		dc.b $FF,$FF,$F0,  0,$F0,  0,  0,  0,$FF,$FF,  0,  0,$F0,  0,  0,  0,  0,$FF,$FF,$F0,  0,$FF,$FF,  0,  0,$F0,  0,  0,  0,$F0,  0,  0, $F,$FF,  0,  0,$F0,  0,$F0,  0,$F0,  0,$F0,  0, $F,$FF,  0,  0,  0,$FF,$FF,$F0,  0,$FF,$FF,$F0,  0,$F0,$FF,  0,  0,$F0,  0,$F0; 384
		dc.b  $F,$FF,  0,  0,$F0,  0,$F0,  0, $F,$FF,$F0,  0,$FF,$FF,$F0,  0,  0, $F,$FF,  0,  0,$F0,  0,$F0,  0,$F0,  0,$F0,  0, $F,$FF,  0, $F,$FF,  0,  0,$F0,  0,$F0,  0, $F,$FF,$F0,  0,$FF,$FF,$F0,  0,  0, $F,$FF,  0,  0,  0,$F0,  0,  0,  0,$F0,  0,  0, $F,$FF,  0; 448
		dc.b $FF,$FF,  0,  0,$F0,  0,$F0,  0,$F0,  0,$F0,  0,$FF,$FF,  0,  0,  0,$FF,$FF,$F0,  0,$FF,$FF,  0,  0,$F0,  0,  0,  0,$FF,$FF,$F0,$FF,$FF,  0,  0,$F0,  0,$F0,  0,$F0,  0,$F0,  0,$FF,$FF,  0,  0,  0, $F,$F0,  0,  0,  0,$F0,  0,  0,  0,$F0,  0,  0, $F,$FF,  0; 512
		dc.b $FF,$FF,  0,  0,$F0,  0,$F0,  0,$F0,  0,$F0,  0,$FF,$FF,  0,  0,  0,$FF,$FF,$F0,  0,  0,$FF,$F0,  0,$FF,  0,  0,  0,$FF,$FF,$F0,$FF,$FF,  0,  0,$F0,  0,$F0,  0,$F0,  0,$F0,  0,$FF,$FF,  0,  0,  0,$FF,$FF,$F0,  0,  0,$FF,$F0,  0,$F0,  0,$F0,  0, $F,$FF,  0; 576
		dc.b $FF,$FF,  0,  0,$F0,  0,$F0,  0,$F0,  0,$F0,  0,$FF,$FF,  0,  0,  0,  0,$FF,  0,  0,$FF, $F,  0,  0,$FF,$FF,$F0,  0,  0, $F,  0,$F0,  0,$F0,  0,$FF,  0,$F0,  0,$F0,$FF,$F0,  0,$F0,  0,$F0,  0,  0,$F0, $F,$F0,  0,$FF,$F0,  0,  0,$F0,$FF,  0,  0,$F0,  0,$F0; 640
		dc.b  $F,$FF,  0,  0,$F0,  0,$F0,  0, $F,$FF,$F0,  0,$FF,$FF,$F0,  0,  0,$F0,  0,$F0,  0,$FF,$F0,$F0,  0,$F0, $F,$F0,  0,$F0,  0,$F0,$FF,$FF,$F0,  0,$F0,  0,  0,  0,$FF,$FF,  0,  0,$FF,$FF,$F0,  0,  0,$FF,$FF,$F0,  0,$FF,$FF,$F0,  0,$F0,  0,$F0,  0,$FF,$FF,  0; 704
		dc.b  $F,$FF,  0,  0,$F0,  0,$F0,  0,$F0,  0,$F0,  0, $F,$FF,  0,  0,  0,$F0,  0,$F0,  0,$FF,$F0,$F0,  0,$F0, $F,$F0,  0,$F0,  0,$F0,$FF,$FF,$F0,  0,$F0,  0,  0,  0,$FF,$FF,  0,  0,$FF,$FF,$F0,  0,  0,$F0,  0,$F0,  0,$FF,$FF,$F0,  0,$F0,  0,$F0,  0,$F0,  0,$F0; 768
		dc.b  $F,$FF,  0,  0,$F0,  0,$F0,  0, $F,$FF,$F0,  0,$FF,$FF,$F0,  0,  0,$FF,$FF,$F0,  0,$FF,$FF,$F0,  0,$F0,  0,$F0,  0,$FF,$FF,  0,$FF,$FF,$F0,  0,$F0,  0,  0,  0,$FF,$FF,  0,  0,$FF,$FF,$F0,  0,  0, $F,$FF,  0,  0,$F0,  0,$F0,  0,$F0,  0,$F0,  0, $F,$FF,  0; 832
		dc.b   0,  0,  0,  0,  0, $F,$F0,  0,  0,  0,$FF,  0,$FF,$FF,$FF,$F0,  0,  0,$FF,  0,  0, $F,$F0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FF,  0,  0, $F,$F0,  0,  0,$FF,$FF,$FF,$F0, $F,$F0,  0,  0,  0,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 896
		dc.b   0, $F,  0,  0,  0,$FF,$F0,  0, $F,$FF,$FF,  0, $F, $F, $F,  0,  0, $F,  0,  0,  0, $F,  0,  0,  0, $F,  0,  0,  0,  0,  0,  0,  0, $F,  0,  0,  0, $F,  0,  0,  0, $F,  0,  0, $F, $F, $F,  0, $F,$FF,$FF,  0,  0,$FF,$F0,  0,  0, $F,  0,  0,  0,  0,  0,  0; 960
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0,  0,  0,  0,  0, $F,$F0,  0,  0,  0,  0,  0; 1024
		dc.b  $F,$F0,$FF,  0, $F,$F0,$FF,  0, $F,  0,$F0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $F,  0, $F,  0,$FF,$FF,$FF,$F0, $F,  0, $F,  0, $F,  0, $F,  0, $F,  0, $F,  0,$FF,$FF,$FF,$F0, $F,  0, $F,  0,  0,  0,  0,  0; 1088
		dc.b   0, $F,  0,  0, $F,$FF,$FF,$F0,$FF, $F,  0,  0,$FF,$FF,$FF,$F0,  0, $F, $F,$F0,$FF,$FF,$FF,  0,  0, $F,  0,  0,  0,  0,  0,  0,$FF,$F0,  0,$F0,$F0,$F0, $F,  0,$FF,$F0,$F0,  0,  0, $F,  0,  0,  0,$F0,$FF,$F0, $F,  0,$F0,$F0,$F0,  0,$FF,$F0,  0,  0,  0,  0; 1152
		dc.b $FF,$F0,  0,  0,$F0, $F,  0,  0,$F0,$F0, $F,  0, $F,$FF,$FF,$F0,$F0,  0, $F,  0,$F0,  0, $F,  0, $F,$FF,$F0,  0,  0,  0,  0,  0,  0,$FF,  0,  0,  0,$FF,  0,  0,  0, $F,  0,  0,  0,$F0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1216
		dc.b   0,  0,$FF,  0,  0, $F,$F0,  0,  0,$FF,  0,  0,  0,$FF,  0,  0,  0,$FF,  0,  0,  0, $F,$F0,  0,  0,  0,$FF,  0,  0,  0,  0,  0, $F,$F0,  0,  0,  0,$FF,  0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0,$FF,  0,  0, $F,$F0,  0,  0,  0,  0,  0,  0; 1280
		dc.b   0,  0,  0,  0,  0, $F,  0,  0, $F, $F, $F,  0,  0,$FF,$F0,  0,  0,$FF,$F0,  0, $F, $F, $F,  0,  0, $F,  0,  0,  0,  0,  0,  0,  0, $F,  0,  0,  0, $F,  0,  0,  0, $F,  0,  0,$FF,$FF,$FF,$F0,  0, $F,  0,  0,  0, $F,  0,  0,  0, $F,  0,  0,  0,  0,  0,  0; 1344
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FF,  0,  0,  0,$FF,  0,  0,  0, $F,  0,  0,  0,$F0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $F,$FF,$FF,$F0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1408
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FF,  0,  0,  0,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,$F0,  0,  0, $F,$F0,  0,  0,$FF,  0,  0, $F,$F0,  0,  0,$FF,  0,  0, $F,$F0,  0,  0,$FF,  0,  0,  0,  0,  0,  0,  0; 1472
		dc.b  $F,$FF,$FF,  0,$FF,  0, $F,$F0,$FF,  0, $F,$F0,$FF,  0, $F,$F0,$FF,  0, $F,$F0,$FF,  0, $F,$F0, $F,$FF,$FF,  0,  0,  0,  0,  0,  0, $F,$F0,  0, $F,$FF,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0, $F,$FF,$FF,$F0,  0,  0,  0,  0; 1536
		dc.b  $F,$FF,$FF,  0,$FF,  0, $F,$F0,  0,  0, $F,$F0,  0, $F,$FF,  0, $F,$F0,  0,  0,$FF,  0,  0,  0,$FF,$FF,$FF,$F0,  0,  0,  0,  0, $F,$FF,$FF,$F0,  0,  0,$FF,  0,  0, $F,$F0,  0,  0,$FF,$FF,  0,  0,  0, $F,$F0,$FF,  0, $F,$F0, $F,$FF,$FF,  0,  0,  0,  0,  0; 1600
		dc.b   0,  0,$FF,  0,  0, $F,$FF,  0,  0,$FF,$FF,  0, $F,$F0,$FF,  0,$FF,  0,$FF,  0,$FF,$FF,$FF,$F0,  0,  0,$FF,  0,  0,  0,  0,  0,$FF,$FF,$FF,$F0,$FF,  0,  0,  0,$FF,$FF,$FF,  0,$FF,  0, $F,$F0,  0,  0, $F,$F0,$FF,  0, $F,$F0, $F,$FF,$FF,  0,  0,  0,  0,  0; 1664
		dc.b  $F,$FF,$FF,  0,$FF,  0, $F,$F0,$FF,  0,  0,  0,$FF,$FF,$FF,  0,$FF,  0, $F,$F0,$FF,  0, $F,$F0, $F,$FF,$FF,  0,  0,  0,  0,  0,$FF,$FF,$FF,$F0,$FF,  0, $F,$F0,  0,  0, $F,$F0,  0,  0,$FF,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0,  0,  0,  0; 1728
		dc.b  $F,$FF,$FF,  0,$FF,  0, $F,$F0,$FF,  0, $F,$F0, $F,$FF,$FF,  0,$FF,  0, $F,$F0,$FF,  0, $F,$F0, $F,$FF,$FF,  0,  0,  0,  0,  0, $F,$FF,$FF,  0,$FF,  0, $F,$F0,$FF,  0, $F,$F0, $F,$FF,$FF,$F0,  0,  0, $F,$F0,$FF,  0, $F,$F0, $F,$FF,$FF,  0,  0,  0,  0,  0; 1792
		dc.b   0,  0,  0,  0,  0,$FF,  0,  0,  0,$FF,  0,  0,  0,  0,  0,  0,  0,$FF,  0,  0,  0,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FF,  0,  0,  0,$FF,  0,  0,  0,  0,  0,  0,  0,$FF,  0,  0,  0, $F,  0,  0,  0,$F0,  0,  0; 1856
		dc.b   0,  0, $F,$F0,  0, $F,$FF,  0, $F,$FF,  0,  0,$FF,  0,  0,  0, $F,$FF,  0,  0,  0, $F,$FF,  0,  0,  0, $F,$F0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $F,$FF,$FF,$F0,  0,  0,  0,  0, $F,$FF,$FF,$F0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 1920
		dc.b $FF,  0,  0,  0, $F,$FF,  0,  0,  0, $F,$FF,  0,  0,  0, $F,$F0,  0, $F,$FF,  0, $F,$FF,  0,  0,$FF,  0,  0,  0,  0,  0,  0,  0,  0,$FF,$FF,  0, $F,$F0, $F,$F0,  0,  0, $F,$F0,  0,  0,$FF,  0,  0, $F,$F0,  0,  0,  0,  0,  0,  0, $F,$F0,  0,  0,  0,  0,  0; 1984
		dc.b  $F,$FF,$FF,  0,$FF,  0, $F,$F0,$F0,$FF,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$FF, $F, $F,$F0, $F,$FF,$FF,  0,  0,  0,  0,  0,  0,$FF,$F0,  0, $F,$F0,$FF,  0,$FF,  0, $F,$F0,$FF,  0, $F,$F0,$FF,$FF,$FF,$F0,$FF,  0, $F,$F0,$FF,  0, $F,$F0,  0,  0,  0,  0; 2048
		dc.b $FF,$FF,$FF,  0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$FF,$FF,  0, $F,$F0, $F,$F0, $F,$F0, $F,$F0,$FF,$FF,$FF,  0,  0,  0,  0,  0,  0,$FF,$FF,  0, $F,$F0, $F,$F0,$FF,  0,  0,  0,$FF,  0,  0,  0,$FF,  0,  0,  0, $F,$F0, $F,$F0,  0,$FF,$FF,  0,  0,  0,  0,  0; 2112
		dc.b $FF,$FF,$F0,  0, $F,$F0, $F,  0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,  0,$FF,$FF,$F0,  0,  0,  0,  0,  0, $F,$FF,$FF,$F0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$FF,$FF,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$FF,$FF,$F0,  0,  0,  0,  0; 2176
		dc.b  $F,$FF,$FF,$F0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$FF,$FF,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0,  0,  0,  0,  0,  0,$FF,$FF,  0, $F,$F0, $F,$F0,$FF,  0,  0,  0,$FF,  0,$FF,$F0,$FF,  0, $F,$F0, $F,$F0, $F,$F0,  0,$FF,$FF,$F0,  0,  0,  0,  0; 2240
		dc.b  $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$FF,$FF,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0,  0,  0,  0,  0,  0,$FF,$FF,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0,$FF,$FF,  0,  0,  0,  0,  0; 2304
		dc.b   0, $F,$FF,$F0,  0,  0,$FF,  0,  0,  0,$FF,  0,  0,  0,$FF,  0,$FF,  0,$FF,  0,$FF,  0,$FF,  0, $F,$FF,$F0,  0,  0,  0,  0,  0,$FF,  0,  0,$F0,$FF,  0, $F,$F0,$FF,  0,$FF,  0,$FF,$FF,$F0,  0,$FF, $F,$F0,  0,$FF,  0,$FF,  0,$FF,  0, $F,$F0,  0,  0,  0,  0; 2368
		dc.b  $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$FF,$FF,$F0,  0,  0,  0,  0,$FF,  0, $F,$F0,$FF,$F0,$FF,$F0,$FF,$FF,$FF,$F0,$FF, $F, $F,$F0,$FF,  0, $F,$F0,$FF,  0, $F,$F0,$FF,  0, $F,$F0,  0,  0,  0,  0; 2432
		dc.b $FF,  0, $F,$F0,$FF,$F0, $F,$F0,$FF,$FF, $F,$F0,$FF, $F,$FF,$F0,$FF,  0,$FF,$F0,$FF,  0, $F,$F0,$FF,  0, $F,$F0,  0,  0,  0,  0, $F,$FF,$FF,  0,$FF,  0, $F,$F0,$FF,  0, $F,$F0,$FF,  0, $F,$F0,$FF,  0, $F,$F0,$FF,  0, $F,$F0, $F,$FF,$FF,  0,  0,  0,  0,  0; 2496
		dc.b $FF,$FF,$FF,  0,$FF,  0, $F,$F0,$FF,  0, $F,$F0,$FF,  0, $F,$F0,$FF,$FF,$FF,  0,$FF,  0,  0,  0,$FF,  0,  0,  0,  0,  0,  0,  0, $F,$FF,$FF,  0,$FF,  0, $F,$F0,$FF,  0, $F,$F0,$FF,  0, $F,$F0,$FF, $F,$FF,  0,$FF, $F,$FF,$F0, $F,$FF,$FF,$F0,  0,  0,  0,  0; 2560
		dc.b $FF,$FF,$FF,  0,$FF,  0, $F,$F0,$FF,  0, $F,$F0,$FF,$FF,$FF,  0,$FF, $F,$F0,  0,$FF,  0,$FF,  0,$FF,  0, $F,$F0,  0,  0,  0,  0, $F,$FF,$FF,  0,$FF,  0, $F,$F0,$FF,  0,  0,  0, $F,$FF,$FF,  0,  0,  0, $F,$F0,$FF,  0, $F,$F0, $F,$FF,$FF,  0,  0,  0,  0,  0; 2624
		dc.b  $F,$FF,$FF,$F0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0,  0,  0,  0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0,  0,$FF,$FF,  0,  0,  0,  0,  0; 2688
		dc.b $FF,  0, $F,$F0,$FF,  0, $F,$F0,$FF,  0, $F,$F0,$FF,  0, $F,$F0, $F,$F0,$FF,  0,  0,$FF,$F0,  0,  0, $F,  0,  0,  0,  0,  0,  0,$FF,  0, $F,$F0,$FF,  0, $F,$F0,$FF,  0, $F,$F0,$FF, $F, $F,$F0,$FF,$FF,$FF,$F0,$FF,$F0,$FF,$F0, $F,  0, $F,  0,  0,  0,  0,  0; 2752
		dc.b $F0,  0,  0,$F0,$FF,  0, $F,$F0, $F,$F0,$FF,  0,  0,$FF,$F0,  0, $F,$F0,$FF,  0,$FF,  0, $F,$F0,$F0,  0,  0,$F0,  0,  0,  0,  0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0,  0,$FF,$FF,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0,  0,  0,  0; 2816
		dc.b  $F,$FF,$FF,$F0,  0,  0, $F,$F0,  0,  0,$FF,  0,  0, $F,$F0,  0,  0,$FF,  0,  0, $F,$F0,  0,  0, $F,$FF,$FF,$F0,  0,  0,  0,  0,  0,$FF,$FF,  0,  0,$FF,  0,  0,  0,$FF,  0,  0,  0,$FF,  0,  0,  0,$FF,  0,  0,  0,$FF,  0,  0,  0,$FF,$FF,  0,  0,  0,  0,  0; 2880
		dc.b  $F,$F0, $F,$F0, $F,$F0, $F,$F0,  0,$FF,$FF,  0, $F,$FF,$FF,$F0,  0, $F,$F0,  0, $F,$FF,$FF,$F0,  0, $F,$F0,  0,  0,  0,  0,  0, $F,$FF,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0, $F,$FF,$F0,  0,  0,  0,  0,  0; 2944
		dc.b   0, $F,  0,  0,  0,$FF,$F0,  0, $F,$F0,$FF,  0,$FF,  0, $F,$F0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FF,$FF,$FF,$F0,  0,  0,  0,  0; 3008
		dc.b  $F,  0,  0,  0,  0,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $F,$FF,$FF,  0,  0,  0,$FF,  0, $F,$FF,$FF,  0, $F,  0,$FF,  0, $F,  0,$FF,  0, $F,$FF,$FF,$F0,  0,  0,  0,  0; 3072
		dc.b  $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$FF,$FF,  0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$FF,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FF,$FF,$F0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0,  0,$FF,$FF,$F0,  0,  0,  0,  0; 3136
		dc.b   0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,$FF,$FF,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0,  0,$FF,$FF,$F0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FF,$FF,  0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$FF,$FF,$F0, $F,$F0,  0,  0,  0,$FF,$FF,$F0,  0,  0,  0,  0; 3200
		dc.b   0, $F,$FF,  0,  0,$FF,  0,  0,  0,$FF,  0,  0, $F,$FF,$FF,  0,  0,$FF,  0,  0,  0,$FF,  0,  0,  0,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FF,$FF,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0,  0,$FF,$FF,$F0,  0,  0, $F,$F0,  0,$FF,$FF,  0,  0,  0,  0,  0; 3264
		dc.b  $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$FF,$FF,  0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $F,$F0,  0,  0,  0,  0,  0,  0,$FF,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0,$FF,$FF,  0,  0,  0,  0,  0; 3328
		dc.b   0,  0,  0,  0,  0,  0,$FF,  0,  0,  0,  0,  0,  0, $F,$FF,  0,  0,  0,$FF,  0,  0,  0,$FF,  0, $F,  0,$FF,  0, $F,$FF,$F0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0, $F,$F0, $F,$F0,$FF,  0, $F,$FF,$F0,  0, $F,$F0,$FF,  0, $F,$F0, $F,$F0,  0,  0,  0,  0; 3392
		dc.b   0,$FF,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $F,$FF,$FF,  0, $F,$F0,$F0,$F0, $F,$F0,$F0,$F0, $F,$F0,$F0,$F0, $F,$F0,$F0,$F0,  0,  0,  0,  0; 3456
		dc.b   0,  0,  0,  0,  0,  0,  0,  0, $F,$FF,$FF,  0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FF,$FF,  0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0,  0,$FF,$FF,  0,  0,  0,  0,  0; 3520
		dc.b   0,  0,  0,  0,  0,  0,  0,  0, $F,$FF,$FF,  0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$FF,$FF,  0, $F,$F0,  0,  0, $F,$F0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FF,$FF,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0,  0,$FF,$FF,$F0,  0,  0, $F,$F0,  0,  0, $F,$F0; 3584
		dc.b   0,  0,  0,  0,  0,$FF,  0,  0,  0,$FF, $F,$F0,  0,$FF,$F0,  0,  0,$FF,  0,  0,  0,$FF,  0,  0,  0,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FF,$FF,  0, $F,$F0,  0,  0,  0,$FF,$FF,  0,  0,  0, $F,$F0, $F,$F0, $F,$F0,  0,$FF,$FF,  0,  0,  0,  0,  0; 3648
		dc.b   0,  0,  0,  0,  0,$FF,  0,  0, $F,$FF,$FF,  0,  0,$FF,  0,  0,  0,$FF,  0,  0,  0,$FF,  0,  0,  0, $F,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0, $F,$F0,  0,$FF,$FF,  0,  0,  0,  0,  0; 3712
		dc.b   0,  0,  0,  0,$FF,  0, $F,$F0,$FF,  0, $F,$F0,$FF,  0, $F,$F0, $F,$F0,$FF,  0,  0,$FF,$F0,  0,  0, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$FF,  0, $F,$F0,$FF,  0, $F,$F0,$FF,  0, $F,$F0,$FF, $F, $F,$F0, $F,$F0,$FF,  0,  0,  0,  0,  0; 3776
		dc.b   0,  0,  0,  0,  0,  0,  0,  0, $F,$F0, $F,$F0,  0,$FF,$FF,  0,  0, $F,$F0,  0,  0,$FF,$FF,  0, $F,$F0, $F,$F0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $F,$F0, $F,$F0, $F,$F0, $F,$F0,  0,$F0, $F,$F0,  0, $F,$FF,  0, $F,$FF,$F0,  0; 3840
		dc.b   0,  0,  0,  0,  0,  0,  0,  0, $F,$FF,$FF,$F0,  0,  0,$FF,  0,  0, $F,$F0,  0,  0,$FF,  0,  0, $F,$FF,$FF,$F0,  0,  0,  0,  0,  0,  0,$FF,  0,  0, $F,  0,  0,  0, $F,  0,  0,  0,$FF,  0,  0,  0, $F,  0,  0,  0, $F,  0,  0,  0,  0,$FF,  0,  0,  0,  0,  0; 3904
		dc.b   0,  0,  0,  0,  0, $F,  0,  0,  0, $F,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, $F,  0,  0,  0, $F,  0,  0,  0,  0,  0,  0,  0,$FF,  0,  0,  0,  0,$F0,  0,  0,  0,$F0,  0,  0,  0,$FF,  0,  0,  0,$F0,  0,  0,  0,$F0,  0,  0,$FF,  0,  0,  0,  0,  0,  0; 3968
		dc.b $FF,$FF,$FF,$F0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 4032
;
; various leftover stuff - mostly level	mappings and some palettes
;
; have fun exploring it	:P
;
Leftover_31000:	dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 0
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 64
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 128
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 192
		dc.w   $23,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21,$2021,  $21,  $21,	 $21,  $21,  $21,  $21,$2021,  $21,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21,$2021,  $21,  $21,	 $21,  $21,  $21,  $21,$2021,  $21,  $21,  $21,	 $21,  $21,  $21,$2021,	 $21,  $21,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21; 256
		dc.w   $21,    1,  $21,	 $21,  $21,  $21,  $21,	 $21,	 1,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21,  $21,  $21,  $21,	   1,  $21,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21,  $21,    1,    1,	 $21,  $21,  $21,  $21,	 $21,  $21,    1,  $21,	   1,  $21,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21,	 1,  $21,    1,	   1,  $21,  $21,  $21,	 $21,  $21,  $21,  $21,	   1,  $21,  $21,  $21,	 $21; 320
		dc.w   $21,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21,  $21,  $21,  $23,	 $21,  $21,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21; 384
		dc.w   $21,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21,  $21,    1,    1,	 $21,  $21,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21,  $21,  $21,    1,	 $21,  $21,  $21,  $21,	 $21,  $21,    1,  $21,	 $21,	 1,    1,  $21,	 $21,  $21,  $21,  $21,	 $21,  $21,  $21,  $21,	   1,  $21,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21,  $21,  $21,  $21,	 $21; 448
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 512
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 576
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 640
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 704
		dc.w   $8A,  $8A,  $8A,	 $8A,  $8A,  $8A,  $8A,	 $8A,  $8A,  $8A,  $88,	 $8A,  $8A,  $8A,  $82,	 $8A,  $8A,  $8A,  $8A,	 $8A,  $8A,  $82,  $8A,	 $82,  $88,  $8A,  $8A,	 $8A,  $8A,  $8A,  $8A,	 $8A,  $82,  $8A,  $8A,	 $82,  $8A,  $8A,  $82,	 $8A,  $8A,  $80,  $8A,	 $8A,  $82,  $8A,  $8A,	 $8A,  $8A,  $80,  $8A,	 $82,  $8A,  $8A,  $82,	 $8A,  $8A,  $8A,  $8A,	 $82,  $8A,  $8A,  $8A,	 $8A; 768
		dc.w   $90,  $90,  $90,	 $90,  $90,  $90,  $90,	 $90,  $90,  $90,  $90,	 $90,  $90,  $90,  $90,	 $90,  $90,  $90,  $90,	 $90,  $90,  $90,  $90,	 $90,  $90,  $90,  $90,	 $90,  $90,  $90,  $90,	 $90,  $90,  $90,  $90,	$190,  $90,  $90,  $90,	 $90,  $90,  $90,  $90,	 $90,  $90,  $90,  $90,	 $90,  $90,  $90,  $90,	 $90,  $90,  $90,  $90,	 $90,  $90,  $90,  $90,	$190,  $90,  $90,  $90,	 $90; 832
		dc.w   $8A,  $80,  $88,	 $8A,  $8A,  $8A,  $8A,	 $82,  $88,  $8A,  $8A,	 $8A,  $8A,  $82,  $8A,	 $82,  $8A,  $8A,  $8A,	 $8A,  $8A,  $82,  $8A,	 $8A,  $8A,  $8A,  $8A,	 $8A,  $8A,  $8A,  $8A,	 $8A,  $8A,  $88,  $8A,	 $80,  $8A,  $82,  $8A,	 $8A,  $88,  $8A,  $8A,	 $82,  $8A,  $8A,  $8A,	 $82,  $88,  $82,  $8A,	 $8A,  $8A,  $8A,  $8A,	 $8A,  $82,  $8A,  $8A,	 $8A,  $88,  $8A,  $8A,	 $82; 896
		dc.w  $190,  $90, $190,	 $90,  $90,  $90, $190,	 $90,  $90,  $90,  $90,	 $90, $190,  $90, $190,	 $90,  $90,  $90, $190,	$190,  $90,  $90, $190,	 $90,  $90,  $90,  $90,	$190,  $90, $190, $190,	$190, $190,  $90,  $90,	 $90, $190, $190, $190,	$190,  $90,  $90, $190,	$190, $190, $190, $190,	 $90, $190, $190,  $90,	 $90, $190, $190, $190,	$190, $190, $190,  $90,	 $90,  $90,  $90,  $90,	 $90; 960
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 1024
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 1088
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 1152
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 1216
		dc.w  $289,  $80,  $80,	$200, $280, $201,    0,	$200, $280, $200, $280,	$200,  $80,    0, $200,	$200, $200,  $80, $200,	$200, $200,    0, $200,	$200,	 0, $200, $200,	   0,	 0, $200, $280,	$200,	 0,  $80, $200,	$200, $200, $280, $200,	$200, $200, $200,    0,	$200, $200, $200, $200,	$200, $200, $200, $200,	$200, $200, $200, $200,	$200,	 0,    0, $280,	$200, $200,    0, $200,	   0; 1280
		dc.w	 1,    1,    1,	   1,	 1,    1,    1,	   1,	 1,    1,    1,	   1,	 1,    1,    1,	   1,	 1,    1,    1,	   1,	 1,    1,    1,	   1,	 1,    1,    1,	   1,	 1,    1,    1,	   1,	 1,    1,    1,	   1,	 1,    1,    1,	   1,	 1,    1,    1,	   1,	 1,    1,    1,	   1,	 1,    1,    1,	   1,	 1,    1,    1,	   1,	 1,    1,    1,	   1,	 1,    1,    1,	   1; 1344
		dc.w  $280, $200,    0,	$200, $200,    0, $200,	   0,	 0, $200, $200,	$200,	 0, $200, $280,	$200,	 0, $200, $200,	$200, $200, $280, $280,	$200, $200, $200, $200,	$200, $200, $200, $200,	$200, $200, $200, $200,	$200,	 0, $200, $200,	$200, $200,    0, $200,	$200, $200,    0, $200,	$200, $200, $200, $200,	$200, $200, $200,    0,	$200, $200, $200, $200,	$200, $200, $200, $200,	$280; 1408
		dc.w	 1,    1,    1,	   1,	 1,    1,    1,	   1,	 1,    1, $101,	   1,	 1,    1, $101,	   1, $101,    1, $101,	   1,	 1,    1, $101,	   1,	 1, $101, $101,	$101, $101,    1,    1,	$101, $101,    1, $101,	   1, $101, $101, $101,	$101, $101,    1, $101,	   1,	 1,    1,    1,	   1, $101, $101, $101,	   1,	 1,    1,    1,	$101, $101,    1,    1,	   1, $101, $101, $101,	   1; 1472
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 1536
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 1600
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 1664
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 1728
		dc.w   $22,    2,  $22,	   2,	 2,    2,    2,	   2,$2102,  $22,    2,	   2,	 2,    2,    2,$2002,	 2,    2,    2,	 $22,	 2,    2,$2002,	   2,	 2,    2,    2,	   2,	 2,$2002,    2,	   2,	 2,  $22,    2,	   2,$2102,  $22,    2,	   2,	 2,    2,    2,$2002,  $22,    2,    2,	   2,	 2,    2,$2102,	 $22,	 2,    2,  $22,	   2,  $22,$2102,    2,	   2, $102,    2,    2,	   2; 1792
		dc.w $1102,$1112,$1102,$1102, $102,$1102,$1102,$1102, $102,$1102,$1102,	$102, $102, $102,$1102,$1102,$1112,$1102, $102,$1102, $102,$1102,$1102,$1102, $102,$1102, $102,	$102,$1102,$1102, $102,$1102, $102, $102, $102,$1102,$1102,$1102, $102,$1102, $102,$1102,$1102,	$102, $102,$1102, $102,	$102, $102,$1102,$1102,	$102, $102, $102, $102,	$102,$1102,$1102,$1102,	$102, $102, $102, $102,$1102; 1856
		dc.w   $22,  $22,    2,	   2,	 2,    2,    2,	 $22,  $22,    2,  $22,	   2,	 2,    2,    2,	 $22,	 2,    2, $122,	   2,$2102,    2,    2,	$102,	 2,    2,    2,	 $22, $122,    2,    2,	   2,	 2, $102,    2,	$102, $122, $102, $122,	   2, $102,    2, $122,	$102,	 2,    2, $102,	$122,	 2, $122, $102,	   2,	 2, $102,    2,	   2, $122, $102,    2,	   2, $122,    2,    2,	 $22; 1920
		dc.w  $100, $102, $102,	$102, $102,$1102, $102,	$102, $102,$1102, $100,	$102,$1102,$1102, $102,	$102, $102, $102, $102,$1102, $102, $102, $102,	$102, $102, $102,$1102,	$102, $112, $112, $102,	$102, $112,$1102, $102,	$102, $102, $102, $102,	$102,$1102, $112, $102,	$102, $102, $102, $102,$1102, $102, $102, $102,	$102, $102, $102,$1102,	$112, $102, $102, $102,	$102, $102, $102, $102,	$102; 1984
		dc.w  $801,$38C2,$58AD,$7896,	 3,$1003,    4,$1004,	 5,$3820,$58BF,$78AA,	 7,$1007,    8,$1008,	 9,$283E,$481C,$68BD,	$B,$100B,   $C,$100C,	$D,$2859,$5839,$7817,	$F,$100F,  $10,$1010,  $11,$3871,$5854,$6835,  $13,$1013,  $14,$1014,  $15,$2888,$486D,$6850,  $17,$3919,  $18,$1018,  $19,$289D,$4884,$6869,  $1B,$101B,$4917,$101C,  $1D,$38B0,$5899,$7880,  $1F,$101F,  $20,$7914; 2048
		dc.w  $805,$28B3,$48B0,$6899,$1022,  $23,$1023,	 $24,$1824,$3804,$48C2,$68AD,  $26,$1026,  $27,$1027,  $28,$2824,$4820,$68BF,  $29,$1029,  $2A,$102A,  $2B,$3841,$583D,$781B,$102C,  $2D,$102D,	 $2E,$102E,$385C,$5858,$6839,$1030,  $31,$1031,	 $32,$1032,$2875,$4871,$6854,$1034,$290D,$1035,	 $36,$1036,$388B,$5887,$786C,$1038,$291B,$4919,	 $3A,$103A,$28A0,$589C,$7883,$103C,  $3D,$4925,$7916; 2112
		dc.w  $809,$38B5,$589F,$689C,  $40,$1040,  $41,$7924, $828,$3808,$58B2,$78AF,  $43,$1043,  $44,$1044, $845,$3827,$4804,$78C1,  $46,$1046,  $47,$1047,  $48,$3844,$5823,$781F,$1048,  $49,$1049,	 $4A,$104A,$385F,$4841,$683D,$104B,  $4C,$104C,	 $4D,$104D,$2878,$485C,$6858,$104F,$390E,$1050,	 $51,$1051,$388E,$5874,$7870,$1053,$391C,$590C,	 $55,$1055,$28A3,$488B,$6887,$1057,$2927,$591A,$7918; 2176
		dc.w  $80D,$28B8,$58A2,$788A,  $5B,$105B,$5926,$691A, $82B,$380C,$48B5,$689F,  $5E,$105E,  $5F,$7925, $848,$382A,$4808,$68B2,$1060,  $61,$1061,	 $62,$1862,$3847,$4827,$7803,  $63,$1063,  $64,$1064,  $65,$2862,$4844,$6823,$1065,  $66,$1066,	 $67,$1067,$387A,$485F,$7840,$1068,$2910,$1069,	 $6A,$106A,$2891,$5877,$785B,  $6C,$291E,$490E,$106D,  $6E,$38A5,$488E,$6874,  $70,$3928,$491C,$690C; 2240
		dc.w  $811,$28BA,$48A5,$788D,$1073,$2931,$4928,$791B,$182E,$3810,$58B7,$68A2,$1076,  $77,$592F,$6926,$184A,$282E,$480C,$78B4,  $79,$1079,  $7A,$792E, $865,$284A,$482A,$7807,  $7B,$107B,  $7C,$107C, $87D,$3864,$4847,$7826,$107D,  $7E,$107E,	 $7F,$107F,$387C,$5861,$7843,  $80,$3911,  $81,$1081,  $82,$2893,$487A,$785E,  $83,$391F,$590F,$1084,  $85,$38A7,$5890,$6877,$1086,$292A,$591D,$790D; 2304
		dc.w  $815,$28BC,$48A7,$6890,  $8A,$3932,$5929,$691D,$1832,$3814,$58B9,$78A4,  $8D,$28F8,$5930,$7927,$184D,$2832,$4810,$68B7,$108F,$28FF,$48F6,$692F,$1867,$284D,$582D,$780B,$1091,  $92,$1092,$78F4,$187F,$2867,$5849,$7829,$1093,  $94,$1094,	 $95,$1895,$287F,$4864,$7846,  $96,$3913,  $97,$1097,  $98,$2895,$487C,$6861,$1098,$2921,$4911,	 $9A,$109A,$38A9,$5892,$7879,$109B,$392B,$491F,$690F; 2368
		dc.w  $819,$28BE,$48A9,$6892,$109E,$3933,$492B,$791E,$1836,$3818,$58BB,$78A6,$10A1,$38F9,$4932,$6929,$1851,$2836,$4814,$68B9,  $A4,$3900,$58F7,$6930,$186A,$2851,$5831,$780F,  $A6,$2906,$58FE,$78F5, $882,$286A,$584C,$682D,  $A8,$10A8,$5904,$68FD, $898,$3881,$5866,$6849,  $AA,$3915,  $AB,$10AB, $8AC,$3897,$587E,$7863,$10AC,$3922,$4913,	 $AE,$10AE,$38AB,$5894,$787B,  $AF,$392C,$5920,$7910; 2432
		dc.w  $81D,$28C0,$48AB,$6894,$10B1,$2934,$492C,$6920,$183A,$381C,$58BD,$78A8,  $B4,$38FA,$4933,$792A,$1855,$283A,$4818,$68BB,$10B6,$3901,$48F9,$7931, $86E,$2855,$5835,$7813,$10B8,$2907,$4900,$68F7, $885,$386D,$5850,$6831,$10BA,$290B,$5905,$68FE,$189A,$3884,$5869,$684C,$10BC,$3917,$490A,$6904,$18AE,$289A,$4881,$6866,$10BE,$3923,$4915,$6909,$18C0,$28AE,$4897,$687E,  $C1,$392D,$4922,$7912; 2496
		dc.w $30C2,$38C0,$48AE,$6897,  $C3,$20C1,$592D,$6922,$20B3,$281D,$48C0,$68AB,$10C3,$30B1,$4934,$692C,$30B5,$383A,$581C,$78BD,  $C4,$20B4,$58FA,$6933,$20B8,$3855,$483A,$6818,$20B6,$30B6,$5901,$68F9,$20BA,$286E,$4855,$7835,$10C4,$30B8,$4907,$6900,$20BC,$2885,$586D,$7850,  $C5,$30BA,$490B,$7905,$20BE,$389A,$5884,$7869,$10C5,$30BC,$5917,$690A,$20C0,$38AE,$489A,$6881,  $C6,$30BE,$5923,$6915; 2560
		dc.w $3020,$201D,$58B0,$7899,$301E,$201F,$301F,$2020,$3004,$2801,$58C2,$78AD,$3002,$2003,$3003,$2004,$3008,$2005,$5820,$78BF,$3006,$2007,$3007,$2008,$300C,$2009,$483E,$681C,$300A,$200B,$300B,$200C,$3010,$200D,$4859,$7839,$300E,$200F,$300F,$2010,$3014,$2011,$5871,$7854,$3012,$2013,$3013,$2014,$3018,$2015,$4888,$686D,$3016,$2017,$5919,$2018,$301C,$2019,$489D,$6884,$301A,$201B,$301B,$6917; 2624
		dc.w $203E,$303A,$48A0,$789C,$203C,$303C,$203D,$6925,$2024,$2805,$48B3,$68B0,$2022,$3022,$2023,$3023,$3027,$3824,$5804,$68C2,$3025,$2026,$3026,$2027,$302A,$2028,$4824,$6820,$3028,$2029,$3029,$202A,$202E,$202B,$5841,$783D,$10C6,$302C,$202D,$302D,$2032,$302E,$585C,$7858,$2030,$3030,$2031,$3031,$2036,$3032,$4875,$6871,$2034,$3034,$490D,$3035,$203A,$3036,$588B,$7887,$2038,$3038,$491B,$6919; 2688
		dc.w $2059,$3055,$48A3,$688B,$2057,$3057,$4927,$791A,$3041,$2809,$58B5,$789F,$303F,$2040,$3040,$2041,$3044,$2828,$5808,$78B2,$3042,$2043,$3043,$2044,$3047,$2845,$5827,$6804,$3045,$2046,$3046,$2047,$204A,$2048,$5844,$7823,  $C7,$3048,$2049,$3049,$204D,$304A,$585F,$6841,$10C7,$304B,$204C,$304C,$2051,$304D,$4878,$685C,$204F,$304F,$590E,$3050,$2055,$3051,$588E,$7874,$2053,$3053,$591C,$790C; 2752
		dc.w $3071,$206E,$58A5,$688E,$306F,$2070,$5928,$691C,$305C,$280D,$48B8,$78A2,$305A,$205B,$305B,$7926,$305F,$282B,$580C,$68B5,$305D,$205E,$305E,$205F,$2062,$2848,$582A,$6808,$2060,$3060,$2061,$3061,$3064,$3862,$5847,$6827,  $C8,$2063,$3063,$2064,$2067,$2065,$4862,$6844,$10C8,$3065,$2066,$3066,$206A,$3067,$587A,$685F,  $C9,$3068,$4910,$3069,$306D,$306A,$4891,$7877,$10C9,$206C,$491E,$690E; 2816
		dc.w $2088,$2085,$58A7,$7890,  $CA,$3086,$492A,$791D,$2075,$2811,$48BA,$68A5,$2073,$3073,$4931,$6928,$2078,$382E,$5810,$78B7,$2076,$3076,$2077,$792F,$307A,$384A,$482E,$680C,$3078,$2079,$3079,$207A,$307C,$2865,$484A,$682A,$10CA,$207B,$307B,$207C,$207F,$287D,$5864,$6847,  $CB,$307D,$207E,$307E,$3081,$307F,$587C,$7861,$10CB,$2080,$5911,$2081,$3084,$2082,$4893,$687A,  $CC,$2083,$591F,$790F; 2880
		dc.w $209D,$309A,$58A9,$7892,$10CC,$309B,$592B,$691F,$308B,$2815,$48BC,$68A7,$3089,$208A,$5932,$7929,$308E,$3832,$5814,$78B9,$308C,$208D,$48F8,$7930,$2091,$384D,$4832,$6810,$208F,$308F,$48FF,$68F6,$2093,$3867,$484D,$782D,  $CD,$3091,$2092,$3092,$2095,$387F,$4867,$7849,$10CD,$3093,$2094,$3094,$3097,$3895,$487F,$6864,  $CE,$2096,$5913,$2097,$209A,$2098,$4895,$687C,$10CE,$3098,$4921,$6911; 2944
		dc.w $30B0,$30AE,$58AB,$7894,  $CF,$20AF,$592C,$7920,$20A0,$2819,$48BE,$68A9,$10CF,$309E,$5933,$692B,$20A3,$3836,$5818,$78BB,$20A1,$30A1,$58F9,$6932,$30A5,$3851,$4836,$6814,$30A3,$20A4,$5900,$78F7,$30A7,$386A,$4851,$7831,  $D0,$20A6,$4906,$78FE,$30A9,$2882,$486A,$784C,$10D0,$20A8,$30A8,$7904,$30AB,$2898,$5881,$7866,  $D1,$20AA,$5915,$20AB,$20AE,$28AC,$5897,$787E,$10D1,$30AC,$5922,$6913; 3008
		dc.w $50AD,$40AE,$48AC,$7897,  $D2,$30D1,$50AC,$7922,$40B0,$50B0,$50AE,$78AB,$10D2,$20CF,$40AF,$792C,$509F,$40A0,$4819,$68BE,$409E,$30CF,$509E,$7933,$50A2,$40A3,$5836,$7818,$50A0,$40A1,$50A1,$78F9,$40A5,$50A5,$5851,$6836,  $D3,$50A3,$40A4,$7900,$40A7,$50A7,$586A,$6851,$10D3,$20D0,$40A6,$6906,$40A9,$50A9,$4882,$686A,  $D4,$30D0,$40A8,$50A8,$40AB,$50AB,$4898,$7881,$10D4,$20D1,$40AA,$7915; 3072
		dc.w $50BF,$40C0,$58AE,$689A,  $D5,$20C6,$50BE,$7923,$40C2,$50C2,$58C0,$68AE,$10D5,$20C3,$40C1,$792D,$50B2,$40B3,$481D,$68C0,  $D6,$30C3,$50B1,$6934,$40B5,$50B5,$583A,$781C,$50B3,$20C4,$40B4,$78FA,$50B7,$40B8,$5855,$683A,$10D6,$40B6,$50B6,$7901,$50B9,$40BA,$486E,$6855,  $D7,$30C4,$50B8,$6907,$50BB,$40BC,$4885,$786D,$10D7,$20C5,$50BA,$690B,$50BD,$40BE,$589A,$7884,  $D8,$30C5,$50BC,$7917; 3136
		dc.w $401C,$501C,$4019,$689D,$401A,$501A,$401B,$501B,$4020,$5020,$401D,$78B0,$401E,$501E,$401F,$501F,$4004,$5004,$4801,$78C2,$4002,$5002,$4003,$5003,$4008,$5008,$4005,$7820,$4006,$5006,$4007,$5007,$400C,$500C,$4009,$683E,$400A,$500A,$400B,$500B,$4010,$5010,$400D,$6859,$400E,$500E,$400F,$500F,$4014,$5014,$4011,$7871,$4012,$5012,$4013,$5013,$4018,$5018,$4015,$6888,$4016,$5016,$4017,$7919; 3200
		dc.w $5039,$403A,$5036,$788B,$5037,$4038,$5038,$691B,$503D,$403E,$503A,$68A0,$503B,$403C,$503C,$403D,$5023,$4024,$4805,$68B3,$5021,$4022,$5022,$4023,$4027,$5027,$5824,$7804,$4025,$5025,$4026,$5026,$402A,$502A,$4028,$6824,$10D8,$5028,$4029,$5029,$502D,$402E,$402B,$7841,$402C,$30C6,$502C,$402D,$5031,$4032,$502E,$785C,$502F,$4030,$5030,$4031,$5035,$4036,$5032,$6875,$5033,$4034,$5034,$690D; 3264
		dc.w $5054,$4055,$5051,$788E,$5052,$4053,$5053,$791C,$5058,$4059,$5055,$68A3,$5056,$4057,$5057,$6927,$4041,$5041,$4809,$78B5,$403F,$503F,$4040,$5040,$4044,$5044,$4828,$7808,$4042,$5042,$4043,$5043,$4047,$5047,$4845,$7827,  $D9,$5045,$4046,$5046,$5049,$404A,$4048,$7844,$10D9,$20C7,$5048,$4049,$504C,$404D,$504A,$785F,  $DA,$30C7,$504B,$404C,$5050,$4051,$504D,$6878,$504E,$404F,$504F,$790E; 3328
		dc.w $406D,$506D,$506A,$6891,$506B,$30C9,$406C,$691E,$4071,$5071,$406E,$78A5,$406F,$506F,$4070,$7928,$405C,$505C,$480D,$68B8,$405A,$505A,$405B,$505B,$405F,$505F,$482B,$780C,$405D,$505D,$405E,$505E,$5061,$4062,$4848,$782A,$10DA,$4060,$5060,$4061,$4064,$5064,$5862,$7847,  $DB,$20C8,$4063,$5063,$5066,$4067,$4065,$6862,$10DB,$30C8,$5065,$4066,$5069,$406A,$5067,$787A,  $DC,$20C9,$5068,$6910; 3392
		dc.w $4084,$5084,$4082,$6893,$10DC,$20CC,$4083,$791F,$5087,$4088,$4085,$78A7,$4086,$20CA,$5086,$692A,$5074,$4075,$4811,$68BA,$5072,$4073,$5073,$6931,$5077,$4078,$582E,$7810,$5075,$4076,$5076,$4077,$407A,$507A,$584A,$682E,  $DD,$5078,$4079,$5079,$407C,$507C,$4865,$684A,$10DD,$30CA,$407B,$507B,$507E,$407F,$487D,$7864,  $DE,$20CB,$507D,$407E,$4081,$5081,$507F,$787C,$10DE,$30CB,$4080,$7911; 3456
		dc.w $5099,$409A,$4098,$6895,  $DF,$30CE,$5098,$6921,$509C,$409D,$509A,$78A9,$10DF,$30CC,$509B,$792B,$408B,$508B,$4815,$68BC,$4089,$5089,$408A,$7932,$408E,$508E,$5832,$7814,$408C,$508C,$408D,$68F8,$5090,$4091,$584D,$6832,  $E0,$408F,$508F,$68FF,$5092,$4093,$5867,$684D,$10E0,$20CD,$5091,$4092,$5094,$4095,$587F,$6867,  $E1,$30CD,$5093,$4094,$4097,$5097,$5895,$687F,$10E1,$20CE,$4096,$7913; 3520
		dc.w $7096,$6097,$7097,$7895,  $E2,$30E1,$40CE,$6096,$6099,$7099,$609A,$6098,$10E2,$20DF,$50CE,$7098,$609C,$709C,$609D,$709A,$609B,$30DF,$50CC,$709B,$708A,$608B,$708B,$6815,$7088,$6089,$7089,$608A,$708D,$608E,$708E,$7832,  $E3,$608C,$708C,$608D,$6090,$7090,$6091,$784D,$10E3,$20E0,$608F,$708F,$6092,$7092,$6093,$7867,  $E4,$30E0,$40CD,$7091,$6094,$7094,$6095,$787F,$10E4,$20E1,$50CD,$7093; 3584
		dc.w $70AA,$60AB,$70AB,$6898,  $E5,$30D4,$40D1,$60AA,$60AD,$70AD,$60AE,$68AC,$10E5,$20D2,$50D1,$70AC,$70AF,$60B0,$70B0,$70AE,  $E6,$30D2,$40CF,$60AF,$609F,$709F,$60A0,$6819,$709D,$609E,$50CF,$709E,$60A2,$70A2,$60A3,$7836,$10E6,$70A0,$60A1,$70A1,$70A4,$60A5,$70A5,$7851,  $E7,$20D3,$70A3,$60A4,$70A6,$60A7,$70A7,$786A,$10E7,$30D3,$40D0,$60A6,$70A8,$60A9,$70A9,$6882,  $E8,$20D4,$50D0,$60A8; 3648
		dc.w $60BD,$70BD,$60BE,$789A,$10E8,$20D8,$50C5,$70BC,$60BF,$70BF,$60C0,$78AE,  $E9,$20D5,$40C6,$70BE,$70C1,$60C2,$70C2,$78C0,$10E9,$30D5,$40C3,$60C1,$60B2,$70B2,$60B3,$681D,$60B1,$20D6,$50C3,$70B1,$70B4,$60B5,$70B5,$783A,  $EA,$70B3,$40C4,$60B4,$60B7,$70B7,$60B8,$7855,$10EA,$30D6,$60B6,$70B6,$60B9,$70B9,$60BA,$686E,  $EB,$20D7,$50C4,$70B8,$60BB,$70BB,$60BC,$6885,$10EB,$30D7,$40C5,$70BA; 3712
		dc.w $7017,$6018,$7018,$6015,$7015,$6016,$7016,$6017,$701B,$601C,$701C,$6019,$7019,$601A,$701A,$601B,$701F,$6020,$7020,$601D,$701D,$601E,$701E,$601F,$7003,$6004,$7004,$6801,$7001,$6002,$7002,$6003,$7007,$6008,$7008,$6005,$7005,$6006,$7006,$6007,$700B,$600C,$700C,$6009,$7009,$600A,$700A,$600B,$700F,$6010,$7010,$600D,$700D,$600E,$700E,$600F,$7013,$6014,$7014,$6011,$7011,$6012,$7012,$6013; 3776
		dc.w $6035,$7035,$6036,$7032,$6033,$7033,$6034,$7034,$6039,$7039,$603A,$7036,$6037,$7037,$6038,$7038,$603D,$703D,$603E,$703A,$603B,$703B,$603C,$703C,$6023,$7023,$6024,$6805,$6021,$7021,$6022,$7022,$7026,$6027,$7027,$7824,  $EC,$6025,$7025,$6026,$7029,$602A,$702A,$6028,$10EC,$30D8,$7028,$6029,$602D,$702D,$602E,$602B,$702B,$602C,$50C6,$702C,$6031,$7031,$6032,$702E,$602F,$702F,$6030,$7030; 3840
		dc.w $6050,$7050,$6051,$704D,$604E,$704E,$604F,$704F,$6054,$7054,$6055,$7051,$6052,$7052,$6053,$7053,$6058,$7058,$6059,$7055,$6056,$7056,$6057,$7057,$7040,$6041,$7041,$6809,$703E,$603F,$703F,$6040,$7043,$6044,$7044,$6828,  $ED,$6042,$7042,$6043,$7046,$6047,$7047,$6845,$10ED,$20D9,$7045,$6046,$6049,$7049,$604A,$6048,  $EE,$30D9,$40C7,$7048,$604C,$704C,$604D,$704A,$604B,$20DA,$50C7,$704B; 3904
		dc.w $6069,$7069,$606A,$7067,$6068,$20DC,$40C9,$7068,$706C,$606D,$706D,$706A,$606B,$706B,$50C9,$606C,$7070,$6071,$7071,$606E,$706E,$606F,$706F,$6070,$705B,$605C,$705C,$680D,$7059,$605A,$705A,$605B,$705E,$605F,$705F,$682B,$10EE,$605D,$705D,$605E,$6061,$7061,$6062,$6848,  $EF,$30DA,$6060,$7060,$7063,$6064,$7064,$7862,$10EF,$20DB,$40C8,$6063,$6066,$7066,$6067,$6065,  $F0,$30DB,$50C8,$7065; 3968
		dc.w $7080,$6081,$7081,$707F,$10F0,$30DE,$50CB,$6080,$7083,$6084,$7084,$6082,$7082,$30DC,$40CC,$6083,$6087,$7087,$6088,$6085,$7085,$6086,$40CA,$7086,$6074,$7074,$6075,$6811,$6072,$7072,$6073,$7073,$6077,$7077,$6078,$782E,  $F1,$7075,$6076,$7076,$7079,$607A,$707A,$784A,$10F1,$20DD,$7078,$6079,$707B,$607C,$707C,$6865,  $F2,$30DD,$50CA,$607B,$607E,$707E,$607F,$687D,$10F2,$20DE,$40CB,$707D; 4032
		dc.w  $803, $8C3, $8D2,	$8E2, $8F3,$30F2,$40DE,$60CB,$1822,$381E, $8D5,	$8E5,$10F3,$30F0,$50DE,$70CB, $840,$283C,$481A,$18E8,  $F4,$10F4,$50DC,$60CC, $85B,$2857,$5837,$7815,  $F5,$10F5,  $F6,$60CA,$1873,$386F,$5852,$6833,$10F6,  $F7,$10F7,	 $F8, $88A, $8CA,$586B,$684E,$10F8,$20F1,  $F9,$10F9,$189E,$18CC,$18DC,$6868,  $FA,$30F1,$40DD,$10FA,$18B1, $8CF, $8DF,$18F0,  $FB,$20F2,$50DD,$70CA; 4096
		dc.w  $807,$18C3,$18D2,$18E2,$18F3,$30E4,$40E1,$70CD, $826,$3802,$18D5,$18E5,$18FB,$20E2,$50E1,$60CE, $843,$2822,$481E,	$8E9,  $FC,$30E2,$40DF,$70CE, $85E,$383F,$583B,$7819,$10FC,  $FD,$50DF,$70CC,$1876,$385A,$5856,$6837,$10FD,  $FE,$10FE,	 $FF, $88D,$2873,$486F,$6852,$10FF,$20E3, $100,$1100,$18A1,$3889,$4886,$686B, $101,$30E3,$40E0,$1101, $8B4,$18CF,$18DF,$7882, $102,$20E4,$50E0,$60CD; 4160
		dc.w  $80B, $8C4,$489E,$689B, $8F4,$20E8,$40D4,$70D0, $829,$3806, $8D6,	$8E6, $8FC,$20E5,$50D4,$60D1, $846,$3825,$4802,$18E9,$1902,$30E5,$40D2,$70D1,$1860,$3842,$5821,$781D, $103,$20E6,$50D2,$60CF, $879,$385D,$483F,$683B,$1103, $104,$1104,$70CF,$188F,$2876,$485A,$6856, $105,$30E6,$1105,	$106, $8A4,$388C,$5872,$786E,$1106,$20E7,$40D3,	$107,$18B6,$28A1,$4889,$7885,$1107,$30E7,$50D3,$60D0; 4224
		dc.w  $80F,$28B6,$58A0,$7888, $8F5,$30EB,$50D7,$60C5,$182C,$380A,$58B3,$789D,$18FC,$30E8,$40D8,$70C5,$1848,$3828,$4806,$68B1, $903,$20E9,$40D5,$60C6, $863,$3845,$4825,$7801, $908,$30E9,$50D5,$60C3, $87B,$2860,$4842,$6821,$1108, $109,$40D6,$70C3,$1891,$3878,$485D,$783E,$1109,$20EA, $10A,$60C4, $8A6,$288F,$5875,$7859,$110A,$30EA,$50D6,	$10B,$18B8,$38A3,$488C,$6872,$110B,$20EB,$40D7,$70C4; 4288
		dc.w  $813,$18C4, $8D3,	$8E3,$18F6, $10C,$110C,	$10D,$1830,$380E,$18D6,$18E6,$18FD,$110D, $10E,$110E,$184B,$18C6,$480A,	$8EA,$1903, $10F,$110F,	$110,$1865, $8C7,$18D8,$7805,$1908,$1110, $111,$1111,$187D, $8C8, $8D9,	$8EC, $912,$1112, $113,$1113,$1893,$18CA,$18DA,	$8ED, $114,$1114, $115,$1115, $8A8, $8CD, $8DD,$18EE, $116,$1116, $117,$1117,$18BA, $8D0, $8E0,	$8F1, $118,$1118, $119,$1119; 4352
		dc.w  $817, $8C5,$18D3,$18E3,$18F8, $11A,$111A,	$11B,$1834,$3812, $8D7,	$8E7,$18FF,$111B, $11C,$111C,$184F,$2830,$480E,$18EA, $905, $11D,$111D,	$11E,$1868,$18C7,$482C,$7809,$1909,$111E, $11F,$111F, $880,$18C8,$18D9,$18EC, $914, $120,$1120,	$121, $896, $8CB, $8DB,$18ED,$1921,$20EC, $122,$1122, $8AA,$18CD,$18DD,	$8EF, $123,$30EC,$50D8,$1123,$18BC,$18D0,$18E0,$18F1, $124,$1124, $125,$70C6; 4416
		dc.w  $81B,$18C5, $8D4,	$8E4, $8FA,$1125,$40DA,$70C7,$1838,$3816,$18D7,$18E7, $901, $126,$1126,	$127,$1853,$2834,$4812,	$8EB,$1906,$1127, $128,$1128, $86C,$284F,$582F,$780D,$190A, $129,$1129,	$12A, $883, $8C9, $8DA,$782B, $916,$112A, $12B,$112B,$1898,$18CB,$18DB,	$8EE, $923,$20ED, $12C,$112C,$18AC, $8CE, $8DE,$18EF, $92D,$30ED,$40D9,$112D,$18BE, $8D1, $8E1,	$8F2, $12E,$20EE,$50D9,$60C7; 4480
		dc.w  $81F, $8C6,$18D4,$18E4, $8FB,$20F0,$50DB,$70C8,$183C,$381A, $8D8,	$8E8, $902,$112E,$40DC,$60C9,$1857,$2838,$4816,$18EB,$1907, $12F,$112F,$70C9, $870,$2853,$5833,$7811,$190B, $130,$1130,	$131,$1886,$18C9,$584E,$682F, $918,$1131, $132,$1132,$189B, $8CC, $8DC,$684B, $924,$30EE, $133,$1133, $8AF,$18CE,$18DE,	$8F0, $92E,$20EF,$50DA,	$134, $8C1,$18D1,$18E1,$18F2,$1934,$30EF,$40DB,$60C8; 4544
		dc.w $1803,$28C1,$38D1,$38E1,$38F2,$3934,$50EF,$60DB, $823,$281F,$28C6,$38D4,$38E4,$28FB,$40F0,$70DB,$1840,$383C,$581A,$28D8,$28E8,$2902,$312E,$60DC,$185B,$3857,$4838,$6816,$38EB,$3907,$212F,$312F,$2131,$2870,$4853,$7833, $90C,$390B,$2130,$3130,$3132,$3886,$38C9,$784E, $91A,$2918,$3131,$2132,$3133,$389B,$28CC,$28DC,$1925,$2924,$50EE,$2133,$2134,$28AF,$38CE,$38DE,$28F0,$292E,$40EF,$70DA; 4608
		dc.w $1807,$38B1,$28CF,$28DF,$38F0,$20FB,$40F2,$70DD,$1826,$2803,$28C3,$28D2,$28E2,$28F3,$50F2,$60DE,$1843,$3822,$581E,$28D5,$28E5,$30F3,$50F0,$70DE,$185E,$2840,$483C,$681A,$38E8,$20F4,$30F4,$70DC, $877,$285B,$4857,$7837,$190D,$20F5,$30F5,$20F6,$20F8,$3873,$586F,$7852,$191B,$30F6,$20F7,$30F7,$30F9,$288A,$28CA,$786B, $926,$30F8,$40F1,$20F9,$30FA,$389E,$38CC,$38DC,$192E,$20FA,$50F1,$60DD; 4672
		dc.w $180B,$28B4,$38CF,$38DF,$18F4,$2102,$40E4,$70E0,$1829,$2807,$38C3,$38D2,$38E2,$38F3,$50E4,$60E1,$1846,$2826,$5802,$38D5,$38E5,$38FB,$40E2,$70E1, $861,$2843,$4822,$681E,$28E9,$20FC,$50E2,$60DF,$1879,$285E,$583F,$783B, $90F,$30FC,$20FD,$70DF,$20FF,$3876,$585A,$7856, $91D,$30FD,$20FE,$30FE,$3100,$288D,$4873,$686F,$1927,$30FF,$40E3,$2100,$3101,$38A1,$5889,$6886, $92F,$2101,$50E3,$60E0; 4736
		dc.w $180F,$38B6,$48A1,$6889,$18F5,$3107,$50E7,$70D3, $82D,$280B,$28C4,$689E, $8FD,$28F4,$40E8,$60D4, $849,$2829,$5806,$28D6,$28E6,$28FC,$40E5,$70D4,$1863,$2846,$5825,$6802,$38E9,$3902,$50E5,$60D2,$187B,$3860,$5842,$7821,$1910,$2103,$40E6,$70D2, $892,$2879,$585D,$683F,$191E,$3103,$2104,$3104,$2106,$388F,$4876,$685A, $929,$2105,$50E6,$3105,$2107,$28A4,$588C,$7872, $930,$3106,$40E7,$60D3; 4800
		dc.w $1813,$38B8,$58A3,$688C, $8F7,$310B,$40EB,$60D7, $831,$280F,$48B6,$78A0, $8FE,$28F5,$50EB,$70D7, $84C,$382C,$580A,$78B3, $904,$38FC,$50E8,$60D8, $866,$3848,$5828,$6806, $909,$2903,$40E9,$60D5, $87E,$2863,$5845,$6825,$1912,$2908,$50E9,$70D5, $894,$287B,$4860,$6842, $920,$3108,$2109,$60D6,$18A8,$3891,$5878,$685D,$192A,$3109,$40EA,$210A,$210B,$28A6,$488F,$7875,$1931,$310A,$50EA,$70D6; 4864
		dc.w $3119,$38BA,$28D0,$28E0,$28F1,$2118,$3118,$2119,$210D,$2813,$38C4,$28D3,$28E3,$38F6,$210C,$310C,$310E,$3830,$580E,$38D6,$38E6,$38FD,$310D,$210E,$2110,$384B,$38C6,$680A,$28EA,$3903,$210F,$310F,$3111,$3865,$28C7,$38D8,$1914,$3908,$3110,$2111,$3113,$387D,$28C8,$28D9,$28EC,$2912,$3112,$2113,$3115,$3893,$38CA,$38DA,$28ED,$2114,$3114,$2115,$3117,$28A8,$28CD,$28DD,$38EE,$2116,$3116,$2117; 4928
		dc.w $181B,$38BC,$38D0,$38E0,$38F1,$2124,$3124,$2125,$211B,$2817,$28C5,$38D3,$38E3,$38F8,$211A,$311A,$311C,$3834,$5812,$28D7,$28E7,$38FF,$311B,$211C,$211E,$384F,$4830,$680E,$38EA,$2905,$211D,$311D,$311F,$3868,$38C7,$682C,$1916,$3909,$311E,$211F,$2121,$2880,$38C8,$38D9,$38EC,$2914,$2120,$3120,$3122,$2896,$28CB,$28DB,$38ED,$3921,$40EC,$2122,$3123,$28AA,$38CD,$38DD,$28EF,$2123,$50EC,$70D8; 4992
		dc.w $181F,$38BE,$28D1,$28E1,$28F2,$212E,$40EE,$70D9, $83D,$281B,$38C5,$28D4,$28E4,$28FA,$3125,$60DA,$2127,$3838,$5816,$38D7,$38E7,$2901,$2126,$3126,$3128,$3853,$4834,$6812,$28EB,$3906,$3127,$2128,$212A,$286C,$484F,$782F,$1918,$390A,$2129,$3129,$312B,$2883,$28C9,$28DA,$1924,$2916,$312A,$212B,$312C,$3898,$38CB,$38DB,$28EE,$2923,$40ED,$212C,$312D,$38AC,$28CE,$28DE,$38EF,$292D,$50ED,$60D9; 5056
		dc.w  $804,$512D,$58AC,$48CE,$48DE,$58EF,$492D,$70ED,$1823,$381F,$58BE,$48D1,$48E1,$48F2,$412E,$60EE, $841,$283D,$481B,$58C5,$48D4,$48E4,$48FA,$5125,$5126,$4127,$5838,$7816,$58D7,$58E7,$4901,$4126,$4128,$5128,$5853,$6834,$190C,$48EB,$5906,$5127,$5129,$412A,$486C,$684F,$191A,$3918,$590A,$4129,$412B,$512B,$4883,$48C9,$48DA,$3924,$4916,$512A,$412C,$512C,$5898,$58CB,$58DB,$48EE,$4923,$60ED; 5120
		dc.w  $808,$4134,$48AF,$58CE,$58DE,$48F0,$492E,$60EF, $827,$3803,$48C1,$58D1,$58E1,$58F2,$5934,$70EF, $844,$2823,$481F,$48C6,$58D4,$58E4,$48FB,$60F0, $85F,$3840,$583C,$781A,$48D8,$48E8,$4902,$512E,$512F,$385B,$5857,$6838, $90E,$58EB,$5907,$412F,$5130,$4131,$4870,$6853, $91C,$290C,$590B,$4130,$4132,$5132,$5886,$58C9,$1926,$291A,$4918,$5131,$4133,$5133,$589B,$48CC,$48DC,$3925,$4924,$70EE; 5184
		dc.w  $80C,$50FA,$589E,$58CC,$58DC,$392E,$40FA,$70F1, $82A,$3807,$58B1,$48CF,$48DF,$58F0,$40FB,$60F2, $847,$3826,$4803,$48C3,$48D2,$48E2,$48F3,$70F2,$1861,$3843,$5822,$781E,$48D5,$48E5,$50F3,$70F0, $87A,$385E,$4840,$683C,$190F,$58E8,$40F4,$50F4,$40F6,$2877,$485B,$6857,$191D,$390D,$40F5,$50F5,$50F7,$40F8,$5873,$786F, $928,$391B,$50F6,$40F7,$40F9,$50F9,$488A,$48CA,$192F,$2926,$50F8,$60F1; 5248
		dc.w  $810,$5101,$58A1,$7889, $8F6,$292F,$4101,$70E3,$182D,$380B,$48B4,$58CF,$58DF,$38F4,$4102,$60E4,$1849,$3829,$4807,$58C3,$58D2,$58E2,$58F3,$70E4, $864,$3846,$4826,$7802,$58D5,$58E5,$58FB,$60E2, $87C,$2861,$4843,$6822, $911,$48E9,$40FC,$70E2,$1892,$3879,$485E,$783F, $91F,$290F,$50FC,$40FD,$50FE,$40FF,$5876,$785A,$1929,$291D,$50FD,$40FE,$4100,$5100,$488D,$6873,$1930,$3927,$50FF,$60E3; 5312
		dc.w  $814,$4107,$48A4,$788C,$18F7,$2930,$5106,$60E7,$1831,$380F,$58B6,$68A1,$18FE,$38F5,$5107,$70E7,$184C,$282D,$480B,$48C4,$1904,$28FD,$48F4,$60E8,$1866,$2849,$4829,$7806,$48D6,$48E6,$48FC,$60E5,$187E,$3863,$4846,$7825, $913,$58E9,$5902,$70E5,$1894,$387B,$5860,$7842,$1920,$3910,$4103,$60E6,$5104,$2892,$4879,$785D, $92B,$391E,$5103,$4104,$5105,$4106,$588F,$6876, $932,$2929,$4105,$70E6; 5376
		dc.w  $818,$410B,$48A6,$688F, $8F9,$3931,$510A,$70EA,$1835,$3813,$58B8,$78A3, $900,$28F7,$510B,$60EB,$1850,$2831,$480F,$68B6,$1905,$28FE,$48F5,$70EB,$1869,$284C,$582C,$780A, $90A,$2904,$58FC,$70E8, $881,$2866,$5848,$7828, $915,$2909,$4903,$60E9, $897,$287E,$4863,$7845, $922,$3912,$4908,$70E9, $8AB,$2894,$487B,$6860, $92C,$2920,$5108,$4109,$410A,$38A8,$5891,$7878, $933,$392A,$5109,$60EA; 5440
		dc.w $4117,$5117,$48A8,$48CD,$48DD,$58EE,$4116,$5116,$4119,$5119,$58BA,$48D0,$48E0,$48F1,$4118,$5118,$510C,$410D,$4813,$58C4,$48D3,$48E3,$58F6,$410C,$410E,$510E,$5830,$780E,$58D6,$58E6,$58FD,$510D,$510F,$4110,$584B,$58C6, $917,$48EA,$5903,$410F,$4111,$5111,$5865,$48C7,$58D8,$3914,$5908,$5110,$4113,$5113,$587D,$48C8,$48D9,$48EC,$4912,$5112,$4115,$5115,$5893,$58CA,$58DA,$48ED,$4114,$5114; 5504
		dc.w  $820,$5123,$48AA,$58CD,$58DD,$48EF,$4123,$70EC,$4125,$381B,$58BC,$58D0,$58E0,$58F1,$4124,$5124,$511A,$411B,$4817,$48C5,$58D3,$58E3,$58F8,$411A,$411C,$511C,$5834,$7812,$48D7,$48E7,$58FF,$511B,$511D,$411E,$584F,$6830, $919,$58EA,$4905,$411D,$411F,$511F,$5868,$58C7, $925,$3916,$5909,$511E,$5120,$4121,$4880,$58C8,$58D9,$58EC,$4914,$4120,$4122,$5122,$4896,$48CB,$48DB,$58ED,$5921,$60EC; 5568
		dc.w $1804,$6122,$7122,$6896,$68CB,$68DB,$78ED,$7921, $824,$2820,$7123,$68AA,$78CD,$78DD,$68EF,$6123,$7124,$6125,$581B,$78BC,$78D0,$78E0,$78F1,$6124,$611A,$711A,$611B,$6817,$68C5,$78D3,$78E3,$78F8,$711B,$611C,$711C,$7834, $90D,$68D7,$68E7,$78FF,$611D,$711D,$611E,$784F, $91B,$2919,$78EA,$6905,$711E,$611F,$711F,$7868,$78C7,$2925,$5916,$7909,$6120,$7120,$6121,$6880,$78C8,$78D9,$78EC,$6914; 5632
		dc.w $1808,$612C,$712C,$7898,$78CB,$78DB,$68EE,$6923,$1827,$2804,$712D,$78AC,$68CE,$68DE,$78EF,$692D,$1844,$3823,$581F,$78BE,$68D1,$68E1,$68F2,$612E,$7125,$2841,$483D,$681B,$78C5,$68D4,$68E4,$68FA,$6126,$7126,$6127,$7838,$190E,$78D7,$78E7,$6901,$7127,$6128,$7128,$7853,$191C,$390C,$68EB,$7906,$6129,$7129,$612A,$686C, $927,$391A,$5918,$790A,$712A,$612B,$712B,$6883,$68C9,$68DA,$5924,$6916; 5696
		dc.w $180C,$6133,$7133,$789B,$68CC,$68DC,$5925,$6924,$182A,$2808,$6134,$68AF,$78CE,$78DE,$68F0,$692E,$1847,$2827,$5803,$68C1,$78D1,$78E1,$78F2,$7934, $862,$2844,$4823,$681F,$68C6,$78D4,$78E4,$68FB,$712E,$285F,$5840,$783C, $910,$68D8,$68E8,$6902,$612F,$712F,$585B,$7857, $91E,$290E,$78EB,$7907,$6130,$7130,$6131,$6870,$1928,$291C,$490C,$790B,$7131,$6132,$7132,$7886,$78C9,$3926,$491A,$6918; 5760
		dc.w $1810,$60F9,$70F9,$688A,$68CA,$392F,$4926,$70F8, $82E,$280C,$70FA,$789E,$78CC,$78DC,$592E,$60FA, $84A,$282A,$5807,$78B1,$68CF,$68DF,$78F0,$60FB,$1864,$2847,$5826,$6803,$68C3,$68D2,$68E2,$68F3,$187C,$3861,$5843,$7822,$1911,$68D5,$68E5,$70F3,$70F4,$287A,$585E,$6840,$191F,$390F,$78E8,$60F4,$70F5,$60F6,$4877,$685B, $92A,$391D,$590D,$60F5,$60F7,$70F7,$60F8,$7873, $931,$2928,$591B,$70F6; 5824
		dc.w $1814,$6100,$7100,$688D, $8F8,$3930,$5927,$70FF, $832,$2810,$7101,$78A1, $8FF,$28F6,$492F,$6101, $84D,$382D,$580B,$68B4,$78CF,$78DF,$58F4,$6102, $867,$3849,$5829,$6807,$78C3,$78D2,$78E2,$78F3, $87F,$2864,$5846,$6826,$1913,$78D5,$78E5,$78FB, $895,$287C,$4861,$6843, $921,$2911,$68E9,$60FC,$60FD,$3892,$5879,$685E,$192B,$291F,$490F,$70FC,$60FE,$70FE,$60FF,$7876,$1932,$3929,$491D,$70FD; 5888
		dc.w $1818,$7105,$6106,$788F,$18F9,$2932,$4929,$6105, $836,$2814,$6107,$68A4,$1900,$38F7,$4930,$7106, $851,$3831,$580F,$78B6, $906,$38FE,$58F5,$7107, $86A,$384C,$482D,$680B,$68C4,$3904,$48FD,$68F4,$1881,$3866,$4849,$6829,$1915,$68D6,$68E6,$68FC,$1897,$387E,$5863,$6846,$1922,$2913,$78E9,$7902,$18AB,$3894,$587B,$7860,$192C,$3920,$5910,$6103,$6104,$7104,$4892,$6879,$1933,$292B,$591E,$7103; 5952
		dc.w $181C,$610A,$58A8,$7891,$18FA,$2933,$592A,$7109, $83A,$2818,$610B,$68A6,$1901,$28F9,$5931,$710A, $855,$3835,$5813,$78B8, $907,$2900,$48F7,$710B,$186D,$3850,$4831,$680F, $90B,$3905,$48FE,$68F5,$1884,$3869,$484C,$782C,$1917,$290A,$4904,$78FC, $89A,$2881,$4866,$7848,$1923,$2915,$4909,$6903, $8AE,$2897,$487E,$6863,$192D,$2922,$5912,$6908,$6109,$28AB,$4894,$687B, $934,$292C,$4920,$7108; 6016
		dc.w $7114,$6115,$7115,$7893,$78CA,$78DA,$68ED,$6114,$7116,$6117,$7117,$68A8,$68CD,$68DD,$78EE,$6116,$7118,$6119,$7119,$78BA,$68D0,$68E0,$68F1,$6118,$610C,$710C,$610D,$6813,$78C4,$68D3,$68E3,$78F6,$710D,$610E,$710E,$7830,$1919,$78D6,$78E6,$78FD,$610F,$710F,$6110,$784B,$78C6,$2917,$68EA,$7903,$7110,$6111,$7111,$7865,$68C7,$78D8,$5914,$7908,$7112,$6113,$7113,$787D,$68C8,$68D9,$68EC,$6912; 6080
		dc.w $1801,$28C2,$48AD,$6896,$1003,    3,$1004,	   4,$1005,$2820,$48BF,$68AA,$1007,    7,$1008,	   8,$1009,$383E,$581C,$78BD,$100B,   $B,$100C,	  $C,$100D,$3859,$4839,$6817,$100F,   $F,$1010,	 $10,$1011,$2871,$4854,$7835,$1013,  $13,$1014,	 $14,$1015,$3888,$586D,$7850,$1017,$2919,$1018,	 $18,$1019,$389D,$5884,$7869,$101B,  $1B,$5917,	 $1C,$101D,$28B0,$4899,$6880,$101F,  $1F,$1020,$6914; 6144
		dc.w $1805,$38B3,$58B0,$7899,  $22,$1023,  $23,$1024, $824,$2804,$58C2,$78AD,$1026,  $26,$1027,	 $27,$1028,$3824,$5820,$78BF,$1029,  $29,$102A,	 $2A,$102B,$2841,$483D,$681B,  $2C,$102D,  $2D,$102E,  $2E,$285C,$4858,$7839,  $30,$1031,  $31,$1032,  $32,$3875,$5871,$7854,  $34,$390D,  $35,$1036,  $36,$288B,$4887,$686C,  $38,$391B,$5919,$103A,  $3A,$38A0,$489C,$6883,  $3C,$103D,$5925,$6916; 6208
		dc.w $1809,$28B5,$489F,$789C,$1040,  $40,$1041,$6924,$1828,$2808,$48B2,$68AF,$1043,  $43,$1044,	 $44,$1845,$2827,$5804,$68C1,$1046,  $46,$1047,	 $47,$1048,$2844,$4823,$681F,  $48,$1049,  $49,$104A,  $4A,$285F,$5841,$783D,  $4B,$104C,  $4C,$104D,  $4D,$3878,$585C,$7858,  $4F,$290E,  $50,$1051,  $51,$288E,$4874,$6870,  $53,$291C,$490C,$1055,  $55,$38A3,$588B,$7887,  $57,$3927,$491A,$6918; 6272
		dc.w $180D,$38B8,$48A2,$688A,$105B,  $5B,$4926,$791A,$182B,$280C,$58B5,$789F,$105E,  $5E,$105F,$6925,$1848,$282A,$5808,$78B2,  $60,$1061,  $61,$1062, $862,$2847,$5827,$6803,$1063,  $63,$1064,	 $64,$1065,$3862,$5844,$7823,  $65,$1066,  $66,$1067,  $67,$287A,$585F,$6840,  $68,$3910,  $69,$106A,  $6A,$3891,$4877,$685B,$106C,$391E,$590E,	 $6D,$106E,$28A5,$588E,$7874,$1070,$2928,$591C,$790C; 6336
		dc.w $1811,$38BA,$58A5,$688D,  $73,$3931,$5928,$691B, $82E,$2810,$48B7,$78A2,  $76,$1077,$492F,$7926, $84A,$382E,$580C,$68B4,$1079,  $79,$107A,$692E,$1865,$384A,$582A,$6807,$107B,  $7B,$107C,	 $7C,$187D,$2864,$5847,$6826,  $7D,$107E,  $7E,$107F,  $7F,$287C,$4861,$6843,$1080,$2911,$1081,	 $81,$1082,$3893,$587A,$685E,$1083,$291F,$490F,	 $84,$1085,$28A7,$4890,$7877,  $86,$392A,$491D,$690D; 6400
		dc.w $1815,$38BC,$58A7,$7890,$108A,$2932,$4929,$791D, $832,$2814,$48B9,$68A4,$108D,$38F8,$4930,$6927, $84D,$3832,$5810,$78B7,  $8F,$38FF,$58F6,$792F, $867,$384D,$482D,$680B,  $91,$1092,  $92,$68F4, $87F,$3867,$4849,$6829,  $93,$1094,  $94,$1095, $895,$387F,$5864,$6846,$1096,$2913,$1097,	 $97,$1098,$3895,$587C,$7861,  $98,$3921,$5911,$109A,  $9A,$28A9,$4892,$6879,  $9B,$292B,$591F,$790F; 6464
		dc.w $1819,$38BE,$58A9,$7892,  $9E,$2933,$592B,$691E, $836,$2818,$48BB,$68A6,  $A1,$28F9,$5932,$7929, $851,$3836,$5814,$78B9,$10A4,$2900,$48F7,$7930, $86A,$3851,$4831,$680F,$10A6,$3906,$48FE,$68F5,$1882,$386A,$484C,$782D,$10A8,  $A8,$4904,$78FD,$1898,$2881,$4866,$7849,$10AA,$2915,$10AB,	 $AB,$18AC,$2897,$487E,$6863,  $AC,$2922,$5913,$10AE,  $AE,$28AB,$4894,$687B,$10AF,$292C,$4920,$6910; 6528
		dc.w $181D,$38C0,$58AB,$7894,  $B1,$3934,$592C,$7920, $83A,$281C,$48BD,$68A8,$10B4,$28FA,$5933,$692A, $855,$383A,$5818,$78BB,  $B6,$2901,$58F9,$6931,$186E,$3855,$4835,$6813,  $B8,$3907,$5900,$78F7,$1885,$286D,$4850,$7831,  $BA,$390B,$4905,$78FE, $89A,$2884,$4869,$784C,  $BC,$2917,$590A,$7904, $8AE,$389A,$5881,$7866,  $BE,$2923,$5915,$7909, $8C0,$38AE,$5897,$787E,$10C1,$292D,$5922,$6912; 6592
		dc.w $20C2,$28C0,$58AE,$7897,$10C3,$30C1,$492D,$7922,$30B3,$381D,$58C0,$78AB,  $C3,$20B1,$5934,$792C,$20B5,$283A,$481C,$68BD,$10C4,$30B4,$48FA,$7933,$30B8,$2855,$583A,$7818,$30B6,$20B6,$4901,$78F9,$30BA,$386E,$5855,$6835,  $C4,$20B8,$5907,$7900,$30BC,$3885,$486D,$6850,$10C5,$20BA,$590B,$6905,$30BE,$289A,$4884,$6869,  $C5,$20BC,$4917,$790A,$30C0,$28AE,$589A,$7881,$10C6,$20BE,$4923,$7915; 6656
		dc.w $2020,$301D,$48B0,$6899,$201E,$301F,$201F,$3020,$2004,$3801,$48C2,$68AD,$2002,$3003,$2003,$3004,$2008,$3005,$4820,$68BF,$2006,$3007,$2007,$3008,$200C,$3009,$583E,$781C,$200A,$300B,$200B,$300C,$2010,$300D,$5859,$6839,$200E,$300F,$200F,$3010,$2014,$3011,$4871,$6854,$2012,$3013,$2013,$3014,$2018,$3015,$5888,$786D,$2016,$3017,$4919,$3018,$201C,$3019,$589D,$7884,$201A,$301B,$201B,$7917; 6720
		dc.w $303E,$203A,$58A0,$689C,$303C,$203C,$303D,$7925,$3024,$3805,$58B3,$78B0,$3022,$2022,$3023,$2023,$2027,$2824,$4804,$78C2,$2025,$3026,$2026,$3027,$202A,$3028,$5824,$7820,$2028,$3029,$2029,$302A,$302E,$302B,$4841,$683D,  $C6,$202C,$302D,$202D,$3032,$202E,$485C,$6858,$3030,$2030,$3031,$2031,$3036,$2032,$5875,$7871,$3034,$2034,$590D,$2035,$303A,$2036,$488B,$6887,$3038,$2038,$591B,$7919; 6784
		dc.w $3059,$2055,$58A3,$788B,$3057,$2057,$5927,$691A,$2041,$3809,$48B5,$689F,$203F,$3040,$2040,$3041,$2044,$3828,$4808,$68B2,$2042,$3043,$2043,$3044,$2047,$3845,$4827,$7804,$2045,$3046,$2046,$3047,$304A,$3048,$4844,$6823,$10C7,$2048,$3049,$2049,$304D,$204A,$485F,$7841,  $C7,$204B,$304C,$204C,$3051,$204D,$5878,$785C,$304F,$204F,$490E,$2050,$3055,$2051,$488E,$6874,$3053,$2053,$491C,$690C; 6848
		dc.w $2071,$306E,$48A5,$788E,$206F,$3070,$4928,$791C,$205C,$380D,$58B8,$68A2,$205A,$305B,$205B,$6926,$205F,$382B,$480C,$78B5,$205D,$305E,$205E,$305F,$3062,$3848,$482A,$7808,$3060,$2060,$3061,$2061,$2064,$2862,$4847,$7827,$10C8,$3063,$2063,$3064,$3067,$3065,$5862,$7844,  $C8,$2065,$3066,$2066,$306A,$2067,$487A,$785F,$10C9,$2068,$5910,$2069,$206D,$206A,$5891,$6877,  $C9,$306C,$591E,$790E; 6912
		dc.w $3088,$3085,$48A7,$6890,$10CA,$2086,$592A,$691D,$3075,$3811,$58BA,$78A5,$3073,$2073,$5931,$7928,$3078,$282E,$4810,$68B7,$3076,$2076,$3077,$692F,$207A,$284A,$582E,$780C,$2078,$3079,$2079,$307A,$207C,$3865,$584A,$782A,  $CA,$307B,$207B,$307C,$307F,$387D,$4864,$7847,$10CB,$207D,$307E,$207E,$2081,$207F,$487C,$6861,  $CB,$3080,$4911,$3081,$2084,$3082,$5893,$787A,$10CC,$3083,$491F,$690F; 6976
		dc.w $309D,$209A,$48A9,$6892,  $CC,$209B,$492B,$791F,$208B,$3815,$58BC,$78A7,$2089,$308A,$4932,$6929,$208E,$2832,$4814,$68B9,$208C,$308D,$58F8,$6930,$3091,$284D,$5832,$7810,$308F,$208F,$58FF,$78F6,$3093,$2867,$584D,$682D,$10CD,$2091,$3092,$2092,$3095,$287F,$5867,$6849,  $CD,$2093,$3094,$2094,$2097,$2895,$587F,$7864,$10CE,$3096,$4913,$3097,$309A,$3098,$5895,$787C,  $CE,$2098,$5921,$7911; 7040
		dc.w $20B0,$20AE,$48AB,$6894,$10CF,$30AF,$492C,$6920,$30A0,$3819,$58BE,$78A9,  $CF,$209E,$4933,$792B,$30A3,$2836,$4818,$68BB,$30A1,$20A1,$48F9,$7932,$20A5,$2851,$5836,$7814,$20A3,$30A4,$4900,$68F7,$20A7,$286A,$5851,$6831,$10D0,$30A6,$5906,$68FE,$20A9,$3882,$586A,$684C,  $D0,$30A8,$20A8,$6904,$20AB,$3898,$4881,$6866,$10D1,$30AA,$4915,$30AB,$30AE,$38AC,$4897,$687E,  $D1,$20AC,$4922,$7913; 7104
		dc.w $40AD,$50AE,$58AC,$6897,$10D2,$20D1,$40AC,$6922,$50B0,$40B0,$40AE,$68AB,  $D2,$30CF,$50AF,$692C,$409F,$50A0,$5819,$78BE,$509E,$20CF,$409E,$6933,$40A2,$50A3,$4836,$6818,$40A0,$50A1,$40A1,$68F9,$50A5,$40A5,$4851,$7836,$10D3,$40A3,$50A4,$6900,$50A7,$40A7,$486A,$7851,  $D3,$30D0,$50A6,$7906,$50A9,$40A9,$5882,$786A,$10D4,$20D0,$50A8,$40A8,$50AB,$40AB,$5898,$6881,  $D4,$30D1,$50AA,$6915; 7168
		dc.w $40BF,$50C0,$48AE,$789A,$10D5,$30C6,$40BE,$6923,$50C2,$40C2,$48C0,$78AE,  $D5,$30C3,$50C1,$692D,$40B2,$50B3,$581D,$78C0,$10D6,$20C3,$40B1,$7934,$50B5,$40B5,$483A,$681C,$40B3,$30C4,$50B4,$68FA,$40B7,$50B8,$4855,$783A,  $D6,$50B6,$40B6,$6901,$40B9,$50BA,$586E,$7855,$10D7,$20C4,$40B8,$7907,$40BB,$50BC,$5885,$686D,  $D7,$30C5,$40BA,$790B,$40BD,$50BE,$489A,$6884,$10D8,$20C5,$40BC,$6917; 7232
		dc.w $501C,$401C,$5019,$789D,$501A,$401A,$501B,$401B,$5020,$4020,$501D,$68B0,$501E,$401E,$501F,$401F,$5004,$4004,$5801,$68C2,$5002,$4002,$5003,$4003,$5008,$4008,$5005,$6820,$5006,$4006,$5007,$4007,$500C,$400C,$5009,$783E,$500A,$400A,$500B,$400B,$5010,$4010,$500D,$7859,$500E,$400E,$500F,$400F,$5014,$4014,$5011,$6871,$5012,$4012,$5013,$4013,$5018,$4018,$5015,$7888,$5016,$4016,$5017,$6919; 7296
		dc.w $4039,$503A,$4036,$688B,$4037,$5038,$4038,$791B,$403D,$503E,$403A,$78A0,$403B,$503C,$403C,$503D,$4023,$5024,$5805,$78B3,$4021,$5022,$4022,$5023,$5027,$4027,$4824,$6804,$5025,$4025,$5026,$4026,$502A,$402A,$5028,$7824,  $D8,$4028,$5029,$4029,$402D,$502E,$502B,$6841,$502C,$20C6,$402C,$502D,$4031,$5032,$402E,$685C,$402F,$5030,$4030,$5031,$4035,$5036,$4032,$7875,$4033,$5034,$4034,$790D; 7360
		dc.w $4054,$5055,$4051,$688E,$4052,$5053,$4053,$691C,$4058,$5059,$4055,$78A3,$4056,$5057,$4057,$7927,$5041,$4041,$5809,$68B5,$503F,$403F,$5040,$4040,$5044,$4044,$5828,$6808,$5042,$4042,$5043,$4043,$5047,$4047,$5845,$6827,$10D9,$4045,$5046,$4046,$4049,$504A,$5048,$6844,  $D9,$30C7,$4048,$5049,$404C,$504D,$404A,$685F,$10DA,$20C7,$404B,$504C,$4050,$5051,$404D,$7878,$404E,$504F,$404F,$690E; 7424
		dc.w $506D,$406D,$406A,$7891,$406B,$20C9,$506C,$791E,$5071,$4071,$506E,$68A5,$506F,$406F,$5070,$6928,$505C,$405C,$580D,$78B8,$505A,$405A,$505B,$405B,$505F,$405F,$582B,$680C,$505D,$405D,$505E,$405E,$4061,$5062,$5848,$682A,  $DA,$5060,$4060,$5061,$5064,$4064,$4862,$6847,$10DB,$30C8,$5063,$4063,$4066,$5067,$5065,$7862,  $DB,$20C8,$4065,$5066,$4069,$506A,$4067,$687A,$10DC,$30C9,$4068,$7910; 7488
		dc.w $5084,$4084,$5082,$7893,  $DC,$30CC,$5083,$691F,$4087,$5088,$5085,$68A7,$5086,$30CA,$4086,$792A,$4074,$5075,$5811,$78BA,$4072,$5073,$4073,$7931,$4077,$5078,$482E,$6810,$4075,$5076,$4076,$5077,$507A,$407A,$484A,$782E,$10DD,$4078,$5079,$4079,$507C,$407C,$5865,$784A,  $DD,$20CA,$507B,$407B,$407E,$507F,$587D,$6864,$10DE,$30CB,$407D,$507E,$5081,$4081,$407F,$687C,  $DE,$20CB,$5080,$6911; 7552
		dc.w $4099,$509A,$5098,$7895,$10DF,$20CE,$4098,$7921,$409C,$509D,$409A,$68A9,  $DF,$20CC,$409B,$692B,$508B,$408B,$5815,$78BC,$5089,$4089,$508A,$6932,$508E,$408E,$4832,$6814,$508C,$408C,$508D,$78F8,$4090,$5091,$484D,$7832,$10E0,$508F,$408F,$78FF,$4092,$5093,$4867,$784D,  $E0,$30CD,$4091,$5092,$4094,$5095,$487F,$7867,$10E1,$20CD,$4093,$5094,$5097,$4097,$4895,$787F,  $E1,$30CE,$5096,$6913; 7616
		dc.w $6096,$7097,$6097,$6895,$10E2,$20E1,$50CE,$7096,$7099,$6099,$709A,$7098,  $E2,$30DF,$40CE,$6098,$709C,$609C,$709D,$609A,$709B,$20DF,$40CC,$609B,$608A,$708B,$608B,$7815,$6088,$7089,$6089,$708A,$608D,$708E,$608E,$6832,$10E3,$708C,$608C,$708D,$7090,$6090,$7091,$684D,  $E3,$30E0,$708F,$608F,$7092,$6092,$7093,$6867,$10E4,$20E0,$50CD,$6091,$7094,$6094,$7095,$687F,  $E4,$30E1,$40CD,$6093; 7680
		dc.w $60AA,$70AB,$60AB,$7898,$10E5,$20D4,$50D1,$70AA,$70AD,$60AD,$70AE,$78AC,  $E5,$30D2,$40D1,$60AC,$60AF,$70B0,$60B0,$60AE,$10E6,$20D2,$50CF,$70AF,$709F,$609F,$70A0,$7819,$609D,$709E,$40CF,$609E,$70A2,$60A2,$70A3,$6836,  $E6,$60A0,$70A1,$60A1,$60A4,$70A5,$60A5,$6851,$10E7,$30D3,$60A3,$70A4,$60A6,$70A7,$60A7,$686A,  $E7,$20D3,$50D0,$70A6,$60A8,$70A9,$60A9,$7882,$10E8,$30D4,$40D0,$70A8; 7744
		dc.w $70BD,$60BD,$70BE,$689A,  $E8,$30D8,$40C5,$60BC,$70BF,$60BF,$70C0,$68AE,$10E9,$30D5,$50C6,$60BE,$60C1,$70C2,$60C2,$68C0,  $E9,$20D5,$50C3,$70C1,$70B2,$60B2,$70B3,$781D,$70B1,$30D6,$40C3,$60B1,$60B4,$70B5,$60B5,$683A,$10EA,$60B3,$50C4,$70B4,$70B7,$60B7,$70B8,$6855,  $EA,$20D6,$70B6,$60B6,$70B9,$60B9,$70BA,$786E,$10EB,$30D7,$40C4,$60B8,$70BB,$60BB,$70BC,$7885,  $EB,$20D7,$50C5,$60BA; 7808
		dc.w $6017,$7018,$6018,$7015,$6015,$7016,$6016,$7017,$601B,$701C,$601C,$7019,$6019,$701A,$601A,$701B,$601F,$7020,$6020,$701D,$601D,$701E,$601E,$701F,$6003,$7004,$6004,$7801,$6001,$7002,$6002,$7003,$6007,$7008,$6008,$7005,$6005,$7006,$6006,$7007,$600B,$700C,$600C,$7009,$6009,$700A,$600A,$700B,$600F,$7010,$6010,$700D,$600D,$700E,$600E,$700F,$6013,$7014,$6014,$7011,$6011,$7012,$6012,$7013; 7872
		dc.w $7035,$6035,$7036,$6032,$7033,$6033,$7034,$6034,$7039,$6039,$703A,$6036,$7037,$6037,$7038,$6038,$703D,$603D,$703E,$603A,$703B,$603B,$703C,$603C,$7023,$6023,$7024,$7805,$7021,$6021,$7022,$6022,$6026,$7027,$6027,$6824,$10EC,$7025,$6025,$7026,$6029,$702A,$602A,$7028,  $EC,$20D8,$6028,$7029,$702D,$602D,$702E,$702B,$602B,$702C,$40C6,$602C,$7031,$6031,$7032,$602E,$702F,$602F,$7030,$6030; 7936
		dc.w $7050,$6050,$7051,$604D,$704E,$604E,$704F,$604F,$7054,$6054,$7055,$6051,$7052,$6052,$7053,$6053,$7058,$6058,$7059,$6055,$7056,$6056,$7057,$6057,$6040,$7041,$6041,$7809,$603E,$703F,$603F,$7040,$6043,$7044,$6044,$7828,$10ED,$7042,$6042,$7043,$6046,$7047,$6047,$7845,  $ED,$30D9,$6045,$7046,$7049,$6049,$704A,$7048,$10EE,$20D9,$50C7,$6048,$704C,$604C,$704D,$604A,$704B,$30DA,$40C7,$604B; 8000
		dc.w $7069,$6069,$706A,$6067,$7068,$30DC,$50C9,$6068,$606C,$706D,$606D,$606A,$706B,$606B,$40C9,$706C,$6070,$7071,$6071,$706E,$606E,$706F,$606F,$7070,$605B,$705C,$605C,$780D,$6059,$705A,$605A,$705B,$605E,$705F,$605F,$782B,  $EE,$705D,$605D,$705E,$7061,$6061,$7062,$7848,$10EF,$20DA,$7060,$6060,$6063,$7064,$6064,$6862,  $EF,$30DB,$50C8,$7063,$7066,$6066,$7067,$7065,$10F0,$20DB,$40C8,$6065; 8064
		dc.w $6080,$7081,$6081,$607F,  $F0,$20DE,$40CB,$7080,$6083,$7084,$6084,$7082,$6082,$20DC,$50CC,$7083,$7087,$6087,$7088,$7085,$6085,$7086,$50CA,$6086,$7074,$6074,$7075,$7811,$7072,$6072,$7073,$6073,$7077,$6077,$7078,$682E,$10F1,$6075,$7076,$6076,$6079,$707A,$607A,$684A,  $F1,$30DD,$6078,$7079,$607B,$707C,$607C,$7865,$10F2,$20DD,$40CA,$707B,$707E,$607E,$707F,$787D,  $F2,$30DE,$50CB,$607D; 8128
		dc.w $1803,$18C3,$18D2,$18E2,$18F3,$20F2,$50DE,$70CB, $822,$281E,$18D5,$18E5,  $F3,$20F0,$40DE,$60CB,$1840,$383C,$581A,	$8E8,$10F4,  $F4,$40DC,$70CC,$185B,$3857,$4837,$6815,$10F5,  $F5,$10F6,$70CA, $873,$286F,$4852,$7833,  $F6,$10F7,  $F7,$10F8,$188A,$18CA,$486B,$784E,  $F8,$30F1,$10F9,	 $F9, $89E, $8CC, $8DC,$7868,$10FA,$20F1,$50DD,	 $FA, $8B1,$18CF,$18DF,	$8F0,$10FB,$30F2,$40DD,$60CA; 8192
		dc.w $1807, $8C3, $8D2,	$8E2, $8F3,$20E4,$50E1,$60CD,$1826,$2802, $8D5,	$8E5, $8FB,$30E2,$40E1,$70CE,$1843,$3822,$581E,$18E9,$10FC,$20E2,$50DF,$60CE,$185E,$283F,$483B,$6819,  $FC,$10FD,$40DF,$60CC, $876,$285A,$4856,$7837,  $FD,$10FE,  $FE,$10FF,$188D,$3873,$586F,$7852,  $FF,$30E3,$1100,	$100, $8A1,$2889,$5886,$786B,$1101,$20E3,$50E0,	$101,$18B4, $8CF, $8DF,$6882,$1102,$30E4,$40E0,$70CD; 8256
		dc.w $180B,$18C4,$589E,$789B,$18F4,$30E8,$50D4,$60D0,$1829,$2806,$18D6,$18E6,$18FC,$30E5,$40D4,$70D1,$1846,$2825,$5802,	$8E9, $902,$20E5,$50D2,$60D1, $860,$2842,$4821,$681D,$1103,$30E6,$40D2,$70CF,$1879,$285D,$583F,$783B, $103,$1104, $104,$60CF, $88F,$3876,$585A,$7856,$1105,$20E6, $105,$1106,$18A4,$288C,$4872,$686E, $106,$30E7,$50D3,$1107, $8B6,$38A1,$5889,$6885, $107,$20E7,$40D3,$70D0; 8320
		dc.w $180F,$38B6,$48A0,$6888,$18F5,$20EB,$40D7,$70C5, $82C,$280A,$48B3,$689D, $8FC,$20E8,$50D8,$60C5, $848,$2828,$5806,$78B1,$1903,$30E9,$50D5,$70C6,$1863,$2845,$5825,$6801,$1908,$20E9,$40D5,$70C3,$187B,$3860,$5842,$7821, $108,$1109,$50D6,$60C3, $891,$2878,$585D,$683E, $109,$30EA,$110A,$70C4,$18A6,$388F,$4875,$6859, $10A,$20EA,$40D6,$110B, $8B8,$28A3,$588C,$7872, $10B,$30EB,$50D7,$60C4; 8384
		dc.w $1813, $8C4,$18D3,$18E3, $8F6,$110C, $10C,$110D, $830,$280E, $8D6,	$8E6, $8FD, $10D,$110E,	$10E, $84B, $8C6,$580A,$18EA, $903,$110F, $10F,$1110, $865,$18C7, $8D8,$6805, $908, $110,$1111,	$111, $87D,$18C8,$18D9,$18EC,$1912, $112,$1113,	$113, $893, $8CA, $8DA,$18ED,$1114, $114,$1115,	$115,$18A8,$18CD,$18DD,	$8EE,$1116, $116,$1117,	$117, $8BA,$18D0,$18E0,$18F1,$1118, $118,$1119,	$119; 8448
		dc.w $1817,$18C5, $8D3,	$8E3, $8F8,$111A, $11A,$111B, $834,$2812,$18D7,$18E7, $8FF, $11B,$111C,	$11C, $84F,$3830,$580E,	$8EA,$1905,$111D, $11D,$111E, $868, $8C7,$582C,$6809, $909, $11E,$111F,	$11F,$1880, $8C8, $8D9,	$8EC,$1914,$1120, $120,$1121,$1896,$18CB,$18DB,	$8ED, $921,$30EC,$1122,	$122,$18AA, $8CD, $8DD,$18EF,$1123,$20EC,$40D8,	$123, $8BC, $8D0, $8E0,	$8F1,$1124, $124,$1125,$60C6; 8512
		dc.w $181B, $8C5,$18D4,$18E4,$18FA, $125,$50DA,$60C7, $838,$2816, $8D7,	$8E7,$1901,$1126, $126,$1127, $853,$3834,$5812,$18EB, $906, $127,$1128,	$128,$186C,$384F,$482F,$680D, $90A,$1129, $129,$112A,$1883,$18C9,$18DA,$682B,$1916, $12A,$112B,	$12B, $898, $8CB, $8DB,$18EE,$1923,$30ED,$112C,	$12C, $8AC,$18CE,$18DE,	$8EF,$192D,$20ED,$50D9,	$12D, $8BE,$18D1,$18E1,$18F2,$112E,$30EE,$40D9,$70C7; 8576
		dc.w $181F,$18C6, $8D4,	$8E4,$18FB,$30F0,$40DB,$60C8, $83C,$281A,$18D8,$18E8,$1902, $12E,$50DC,$70C9, $857,$3838,$5816,	$8EB, $907,$112F, $12F,$60C9,$1870,$3853,$4833,$6811, $90B,$1130, $130,$1131, $886, $8C9,$484E,$782F,$1918, $131,$1132,	$132, $89B,$18CC,$18DC,$784B,$1924,$20EE,$1133,	$133,$18AF, $8CE, $8DE,$18F0,$192E,$30EF,$40DA,$1134,$18C1, $8D1, $8E1,	$8F2, $934,$20EF,$50DB,$70C8; 8640
		dc.w  $803,$38C1,$28D1,$28E1,$28F2,$2934,$40EF,$70DB,$1823,$381F,$38C6,$28D4,$28E4,$38FB,$50F0,$60DB, $840,$283C,$481A,$38D8,$38E8,$3902,$212E,$70DC, $85B,$2857,$5838,$7816,$28EB,$2907,$312F,$212F,$3131,$3870,$5853,$6833,$190C,$290B,$3130,$2130,$2132,$2886,$28C9,$684E,$191A,$3918,$2131,$3132,$2133,$289B,$38CC,$38DC, $925,$3924,$40EE,$3133,$3134,$38AF,$28CE,$28DE,$38F0,$392E,$50EF,$60DA; 8704
		dc.w  $807,$28B1,$38CF,$38DF,$28F0,$30FB,$50F2,$60DD, $826,$3803,$38C3,$38D2,$38E2,$38F3,$40F2,$70DE, $843,$2822,$481E,$38D5,$38E5,$20F3,$40F0,$60DE, $85E,$3840,$583C,$781A,$28E8,$30F4,$20F4,$60DC,$1877,$385B,$5857,$6837, $90D,$30F5,$20F5,$30F6,$30F8,$2873,$486F,$6852, $91B,$20F6,$30F7,$20F7,$20F9,$388A,$38CA,$686B,$1926,$20F8,$50F1,$30F9,$20FA,$289E,$28CC,$28DC, $92E,$30FA,$40F1,$70DD; 8768
		dc.w  $80B,$38B4,$28CF,$28DF, $8F4,$3102,$50E4,$60E0, $829,$3807,$28C3,$28D2,$28E2,$28F3,$40E4,$70E1, $846,$3826,$4802,$28D5,$28E5,$28FB,$50E2,$60E1,$1861,$3843,$5822,$781E,$38E9,$30FC,$40E2,$70DF, $879,$385E,$483F,$683B,$190F,$20FC,$30FD,$60DF,$30FF,$2876,$485A,$6856,$191D,$20FD,$30FE,$20FE,$2100,$388D,$5873,$786F, $927,$20FF,$50E3,$3100,$2101,$28A1,$4889,$7886,$192F,$3101,$40E3,$70E0; 8832
		dc.w  $80F,$28B6,$58A1,$7889, $8F5,$2107,$40E7,$60D3,$182D,$380B,$38C4,$789E,$18FD,$38F4,$50E8,$70D4,$1849,$3829,$4806,$38D6,$38E6,$38FC,$50E5,$60D4, $863,$3846,$4825,$7802,$28E9,$2902,$40E5,$70D2, $87B,$2860,$4842,$6821, $910,$3103,$50E6,$60D2,$1892,$3879,$485D,$783F, $91E,$2103,$3104,$2104,$3106,$288F,$5876,$785A,$1929,$3105,$40E6,$2105,$3107,$38A4,$488C,$6872,$1930,$2106,$50E7,$70D3; 8896
		dc.w  $813,$28B8,$48A3,$788C,$18F7,$210B,$50EB,$70D7,$1831,$380F,$58B6,$68A0,$18FE,$38F5,$40EB,$60D7,$184C,$282C,$480A,$68B3,$1904,$28FC,$40E8,$70D8,$1866,$2848,$4828,$7806,$1909,$3903,$50E9,$70D5,$187E,$3863,$4845,$7825, $912,$3908,$40E9,$60D5,$1894,$387B,$5860,$7842,$1920,$2108,$3109,$70D6, $8A8,$2891,$4878,$785D, $92A,$2109,$50EA,$310A,$310B,$38A6,$588F,$6875, $931,$210A,$40EA,$60D6; 8960
		dc.w $2119,$28BA,$38D0,$38E0,$38F1,$3118,$2118,$3119,$310D,$3813,$28C4,$38D3,$38E3,$28F6,$310C,$210C,$210E,$2830,$480E,$28D6,$28E6,$28FD,$210D,$310E,$3110,$284B,$28C6,$780A,$38EA,$2903,$310F,$210F,$2111,$2865,$38C7,$28D8, $914,$2908,$2110,$3111,$2113,$287D,$38C8,$38D9,$38EC,$3912,$2112,$3113,$2115,$2893,$28CA,$28DA,$38ED,$3114,$2114,$3115,$2117,$38A8,$38CD,$38DD,$28EE,$3116,$2116,$3117; 9024
		dc.w  $81B,$28BC,$28D0,$28E0,$28F1,$3124,$2124,$3125,$311B,$3817,$38C5,$28D3,$28E3,$28F8,$311A,$211A,$211C,$2834,$4812,$38D7,$38E7,$28FF,$211B,$311C,$311E,$284F,$5830,$780E,$28EA,$3905,$311D,$211D,$211F,$2868,$28C7,$782C, $916,$2909,$211E,$311F,$3121,$3880,$28C8,$28D9,$28EC,$3914,$3120,$2120,$2122,$3896,$38CB,$38DB,$28ED,$2921,$50EC,$3122,$2123,$38AA,$28CD,$28DD,$38EF,$3123,$40EC,$60D8; 9088
		dc.w  $81F,$28BE,$38D1,$38E1,$38F2,$312E,$50EE,$60D9,$183D,$381B,$28C5,$38D4,$38E4,$38FA,$2125,$70DA,$3127,$2838,$4816,$28D7,$28E7,$3901,$3126,$2126,$2128,$2853,$5834,$7812,$38EB,$2906,$2127,$3128,$312A,$386C,$584F,$682F, $918,$290A,$3129,$2129,$212B,$3883,$38C9,$38DA, $924,$3916,$212A,$312B,$212C,$2898,$28CB,$28DB,$38EE,$3923,$50ED,$312C,$212D,$28AC,$38CE,$38DE,$28EF,$392D,$40ED,$70D9; 9152
		dc.w $1804,$412D,$48AC,$58CE,$58DE,$48EF,$592D,$60ED, $823,$281F,$48BE,$58D1,$58E1,$58F2,$512E,$70EE,$1841,$383D,$581B,$48C5,$58D4,$58E4,$58FA,$4125,$4126,$5127,$4838,$6816,$48D7,$48E7,$5901,$5126,$5128,$4128,$4853,$7834, $90C,$58EB,$4906,$4127,$4129,$512A,$586C,$784F, $91A,$2918,$490A,$5129,$512B,$412B,$5883,$58C9,$58DA,$2924,$5916,$412A,$512C,$412C,$4898,$48CB,$48DB,$58EE,$5923,$70ED; 9216
		dc.w $1808,$5134,$58AF,$48CE,$48DE,$58F0,$592E,$70EF,$1827,$2803,$58C1,$48D1,$48E1,$48F2,$4934,$60EF,$1844,$3823,$581F,$58C6,$48D4,$48E4,$58FB,$70F0,$185F,$2840,$483C,$681A,$58D8,$58E8,$5902,$412E,$412F,$285B,$4857,$7838,$190E,$48EB,$4907,$512F,$4130,$5131,$5870,$7853,$191C,$390C,$490B,$5130,$5132,$4132,$4886,$48C9, $926,$391A,$5918,$4131,$5133,$4133,$489B,$58CC,$58DC,$2925,$5924,$60EE; 9280
		dc.w $180C,$40FA,$489E,$48CC,$48DC,$292E,$50FA,$60F1,$182A,$2807,$48B1,$58CF,$58DF,$48F0,$50FB,$70F2,$1847,$2826,$5803,$58C3,$58D2,$58E2,$58F3,$60F2, $861,$2843,$4822,$681E,$58D5,$58E5,$40F3,$60F0,$187A,$285E,$5840,$783C, $90F,$48E8,$50F4,$40F4,$50F6,$3877,$585B,$7857, $91D,$290D,$50F5,$40F5,$40F7,$50F8,$4873,$686F,$1928,$291B,$40F6,$50F7,$50F9,$40F9,$588A,$58CA, $92F,$3926,$40F8,$70F1; 9344
		dc.w $1810,$4101,$48A1,$6889,$18F6,$392F,$5101,$60E3, $82D,$280B,$58B4,$48CF,$48DF,$28F4,$5102,$70E4, $849,$2829,$5807,$48C3,$48D2,$48E2,$48F3,$60E4,$1864,$2846,$5826,$6802,$48D5,$48E5,$48FB,$70E2,$187C,$3861,$5843,$7822,$1911,$58E9,$50FC,$60E2, $892,$2879,$585E,$683F,$191F,$390F,$40FC,$50FD,$40FE,$50FF,$4876,$685A, $929,$391D,$40FD,$50FE,$5100,$4100,$588D,$7873, $930,$2927,$40FF,$70E3; 9408
		dc.w $1814,$5107,$58A4,$688C, $8F7,$3930,$4106,$70E7, $831,$280F,$48B6,$78A1, $8FE,$28F5,$4107,$60E7, $84C,$382D,$580B,$58C4, $904,$38FD,$58F4,$70E8, $866,$3849,$5829,$6806,$58D6,$58E6,$58FC,$70E5, $87E,$2863,$5846,$6825,$1913,$48E9,$4902,$60E5, $894,$287B,$4860,$6842, $920,$2910,$5103,$70E6,$4104,$3892,$5879,$685D,$192B,$291E,$4103,$5104,$4105,$5106,$488F,$7876,$1932,$3929,$5105,$60E6; 9472
		dc.w $1818,$510B,$58A6,$788F,$18F9,$2931,$410A,$60EA, $835,$2813,$48B8,$68A3,$1900,$38F7,$410B,$70EB, $850,$3831,$580F,$78B6, $905,$38FE,$58F5,$60EB, $869,$384C,$482C,$680A,$190A,$3904,$48FC,$60E8,$1881,$3866,$4848,$6828,$1915,$3909,$5903,$70E9,$1897,$387E,$5863,$6845,$1922,$2912,$5908,$60E9,$18AB,$3894,$587B,$7860,$192C,$3920,$4108,$5109,$510A,$28A8,$4891,$6878,$1933,$292A,$4109,$70EA; 9536
		dc.w $5117,$4117,$58A8,$58CD,$58DD,$48EE,$5116,$4116,$5119,$4119,$48BA,$58D0,$58E0,$58F1,$5118,$4118,$410C,$510D,$5813,$48C4,$58D3,$58E3,$48F6,$510C,$510E,$410E,$4830,$680E,$48D6,$48E6,$48FD,$410D,$410F,$5110,$484B,$48C6,$1917,$58EA,$4903,$510F,$5111,$4111,$4865,$58C7,$48D8,$2914,$4908,$4110,$5113,$4113,$487D,$58C8,$58D9,$58EC,$5912,$4112,$5115,$4115,$4893,$48CA,$48DA,$58ED,$5114,$4114; 9600
		dc.w $1820,$4123,$58AA,$48CD,$48DD,$58EF,$5123,$60EC,$5125,$281B,$48BC,$48D0,$48E0,$48F1,$5124,$4124,$411A,$511B,$5817,$58C5,$48D3,$48E3,$48F8,$511A,$511C,$411C,$4834,$6812,$58D7,$58E7,$48FF,$411B,$411D,$511E,$484F,$7830,$1919,$48EA,$5905,$511D,$511F,$411F,$4868,$48C7,$1925,$2916,$4909,$411E,$4120,$5121,$5880,$48C8,$48D9,$48EC,$5914,$5120,$5122,$4122,$5896,$58CB,$58DB,$48ED,$4921,$70EC; 9664
		dc.w  $804,$7122,$6122,$7896,$78CB,$78DB,$68ED,$6921,$1824,$3820,$6123,$78AA,$68CD,$68DD,$78EF,$7123,$6124,$7125,$481B,$68BC,$68D0,$68E0,$68F1,$7124,$711A,$611A,$711B,$7817,$78C5,$68D3,$68E3,$68F8,$611B,$711C,$611C,$6834,$190D,$78D7,$78E7,$68FF,$711D,$611D,$711E,$684F,$191B,$3919,$68EA,$7905,$611E,$711F,$611F,$6868,$68C7,$3925,$4916,$6909,$7120,$6120,$7121,$7880,$68C8,$68D9,$68EC,$7914; 9728
		dc.w  $808,$712C,$612C,$6898,$68CB,$68DB,$78EE,$7923, $827,$3804,$612D,$68AC,$78CE,$78DE,$68EF,$792D, $844,$2823,$481F,$68BE,$78D1,$78E1,$78F2,$712E,$6125,$3841,$583D,$781B,$68C5,$78D4,$78E4,$78FA,$7126,$6126,$7127,$6838, $90E,$68D7,$68E7,$7901,$6127,$7128,$6128,$6853, $91C,$290C,$78EB,$6906,$7129,$6129,$712A,$786C,$1927,$291A,$4918,$690A,$612A,$712B,$612B,$7883,$78C9,$78DA,$4924,$7916; 9792
		dc.w  $80C,$7133,$6133,$689B,$78CC,$78DC,$4925,$7924, $82A,$3808,$7134,$78AF,$68CE,$68DE,$78F0,$792E, $847,$3827,$4803,$78C1,$68D1,$68E1,$68F2,$6934,$1862,$3844,$5823,$781F,$78C6,$68D4,$68E4,$78FB,$612E,$385F,$4840,$683C,$1910,$78D8,$78E8,$7902,$712F,$612F,$485B,$6857,$191E,$390E,$68EB,$6907,$7130,$6130,$7131,$7870, $928,$391C,$590C,$690B,$6131,$7132,$6132,$6886,$68C9,$2926,$591A,$7918; 9856
		dc.w  $810,$70F9,$60F9,$788A,$78CA,$292F,$5926,$60F8,$182E,$380C,$60FA,$689E,$68CC,$68DC,$492E,$70FA,$184A,$382A,$4807,$68B1,$78CF,$78DF,$68F0,$70FB, $864,$3847,$4826,$7803,$78C3,$78D2,$78E2,$78F3, $87C,$2861,$4843,$6822, $911,$78D5,$78E5,$60F3,$60F4,$387A,$485E,$7840, $91F,$290F,$68E8,$70F4,$60F5,$70F6,$5877,$785B,$192A,$291D,$490D,$70F5,$70F7,$60F7,$70F8,$6873,$1931,$3928,$491B,$60F6; 9920
		dc.w  $814,$7100,$6100,$788D,$18F8,$2930,$4927,$60FF,$1832,$3810,$6101,$68A1,$18FF,$38F6,$592F,$7101,$184D,$282D,$480B,$78B4,$68CF,$68DF,$48F4,$7102,$1867,$2849,$4829,$7807,$68C3,$68D2,$68E2,$68F3,$187F,$3864,$4846,$7826, $913,$68D5,$68E5,$68FB,$1895,$387C,$5861,$7843,$1921,$3911,$78E9,$70FC,$70FD,$2892,$4879,$785E, $92B,$391F,$590F,$60FC,$70FE,$60FE,$70FF,$6876, $932,$2929,$591D,$60FD; 9984
		dc.w  $818,$6105,$7106,$688F, $8F9,$3932,$5929,$7105,$1836,$3814,$7107,$78A4, $900,$28F7,$5930,$6106,$1851,$2831,$480F,$68B6,$1906,$28FE,$48F5,$6107,$186A,$284C,$582D,$780B,$78C4,$2904,$58FD,$78F4, $881,$2866,$5849,$7829, $915,$78D6,$78E6,$78FC, $897,$287E,$4863,$7846, $922,$3913,$68E9,$6902, $8AB,$2894,$487B,$6860, $92C,$2920,$4910,$7103,$7104,$6104,$5892,$7879, $933,$392B,$491E,$6103; 10048
		dc.w  $81C,$710A,$48A8,$6891, $8FA,$3933,$492A,$6109,$183A,$3818,$710B,$78A6, $901,$38F9,$4931,$610A,$1855,$2835,$4813,$68B8,$1907,$3900,$58F7,$610B, $86D,$2850,$5831,$780F,$190B,$2905,$58FE,$78F5, $884,$2869,$584C,$682C, $917,$390A,$5904,$68FC,$189A,$3881,$5866,$6848, $923,$3915,$5909,$7903,$18AE,$3897,$587E,$7863, $92D,$3922,$4912,$7908,$7109,$38AB,$5894,$787B,$1934,$392C,$5920,$6108; 10112
		dc.w $6114,$7115,$6115,$6893,$68CA,$68DA,$78ED,$7114,$6116,$7117,$6117,$78A8,$78CD,$78DD,$68EE,$7116,$6118,$7119,$6119,$68BA,$78D0,$78E0,$78F1,$7118,$710C,$610C,$710D,$7813,$68C4,$78D3,$78E3,$68F6,$610D,$710E,$610E,$6830, $919,$68D6,$68E6,$68FD,$710F,$610F,$7110,$684B,$68C6,$3917,$78EA,$6903,$6110,$7111,$6111,$6865,$78C7,$68D8,$4914,$6908,$6112,$7113,$6113,$687D,$78C8,$78D9,$78EC,$7912; 10176
		dc.w	 0,    0,$1111,$1112,$1113,$1114,$1115,$1116,$1117,$1118,$1121,$1122,$1123,$1124,$1125,$1126,$1127,$1128,$1131,$1132,$1133,$1134,$1135,$1136,$1137,$1138,$1141,$1142,$1143,$1144,$1145,$1146,$1147,$1148,$1151,$1152,$1153,$1154,$1155,$1156,$1157,$1158,$1161,$1162,$1163,$1164,$1165,$1166,$1167,$1168,$1171,$1172,$1173,$1174,$1175,$1176,$1177,$1178,$1181,$1182,$1183,$1184,$1185,$1186; 10240
		dc.w $1187,$1188,$1212,$1213,$1214,$1215,$1216,$1217,$1218,$1221,$1223,$1224,$1225,$1226,$1227,$1228,$1231,$1234,$1235,$1236,$1237,$1238,$1241,$1242,$1243,$1245,$1246,$1247,$1248,$1251,$1252,$1253,$1254,$1255,$1256,$1257,$1258,$1261,$1262,$1263,$1264,$1265,$1266,$1267,$1268,$1271,$1272,$1273,$1274,$1275,$1276,$1277,$1278,$1281,$1282,$1283,$1284,$1285,$1286,$1287,$1288,$1312,$1313,$1314; 10304
		dc.w $1315,$1316,$1317,$1318,$1323,$1324,$1325,$1326,$1327,$1328,$1331,$1334,$1335,$1336,$1337,$1338,$1341,$1345,$1346,$1347,$1348,$1351,$1352,$1355,$1356,$1357,$1358,$1361,$1362,$1363,$1364,$1365,$1366,$1367,$1368,$1371,$1372,$1373,$1374,$1375,$1376,$1377,$1378,$1381,$1382,$1383,$1384,$1385,$1386,$1387,$1388,$1412,$1413,$1414,$1415,$1416,$1417,$1418,$1423,$1424,$1425,$1426,$1427,$1428; 10368
		dc.w $1434,$1435,$1436,$1437,$1438,$1441,$1445,$1446,$1447,$1448,$1451,$1455,$1456,$1457,$1458,$1461,$1462,$1465,$1466,$1467,$1468,$1471,$1472,$1473,$1475,$1476,$1477,$1478,$1481,$1482,$1483,$1484,$1485,$1486,$1487,$1488,$1512,$1513,$1514,$1515,$1516,$1517,$1518,$1523,$1524,$1525,$1526,$1527,$1528,$1534,$1535,$1536,$1537,$1538,$1545,$1546,$1547,$1548,$1551,$1555,$1556,$1557,$1558,$1561; 10432
		dc.w $1565,$1566,$1567,$1568,$1571,$1572,$1575,$1576,$1577,$1578,$1581,$1582,$1583,$1585,$1586,$1587,$1588,$1612,$1613,$1614,$1615,$1616,$1617,$1618,$1623,$1624,$1625,$1626,$1627,$1628,$1634,$1635,$1636,$1637,$1638,$1645,$1646,$1647,$1648,$1655,$1656,$1657,$1658,$1661,$1665,$1666,$1667,$1668,$1671,$1675,$1676,$1677,$1678,$1681,$1682,$1685,$1686,$1687,$1688,$1712,$1713,$1715,$1716,$1717; 10496
		dc.w $1718,$1723,$1724,$1725,$1726,$1727,$1728,$1734,$1735,$1736,$1737,$1738,$1745,$1746,$1747,$1748,$1755,$1756,$1757,$1758,$1765,$1766,$1767,$1768,$1771,$1775,$1776,$1777,$1778,$1781,$1785,$1786,$1787,$1788,$1812,$1815,$1816,$1817,$1818,$1823,$1825,$1826,$1827,$1828,$1834,$1835,$1836,$1837,$1838,$1845,$1846,$1847,$1848,$1855,$1856,$1857,$1858,$1865,$1866,$1867,$1868,$1875,$1876,$1877; 10560
		dc.w $1878,$1881,$1885,$1886,$1887,$1888,$2115,$2125,$2135,$2155,$2165,$2175,$2185,$2355,$2455,$2465,$2555,$2565,$2575,$2585,$2615,$2655,$2665,$2675,$2685,$2715,$2755,$2765,$2775,$2785,$2815,$2825,$2855,$2865,$2875,$2885,$3115,$3125,$3155,$3165,$3175,$3185,$3215,$3225,$3235,$3255,$3265,$3275,$3285,$3455,$3555,$3565,$3575,$3655,$3665,$3675,$3685,$3715,$3755,$3765,$3775,$3785,$3815,$3825; 10624
		dc.w $3855,$3865,$3875,$3885,$4115,$4125,$4155,$4165,$4175,$4185,$4215,$4225,$4235,$4255,$4265,$4275,$4285,$4315,$4325,$4335,$4355,$4365,$4375,$4385,$4555,$4565,$4655,$4665,$4675,$4755,$4765,$4775,$4785,$4815,$4855,$4865,$4875,$4885,$5115,$5125,$5135,$5136,$5145,$5146,$5147,$5155,$5156,$5157,$5158,$5165,$5167,$5168,$5175,$5178,$5185,$5225,$5235,$5245,$5246,$5255,$5256,$5257,$5258,$5265; 10688
		dc.w $5267,$5268,$5275,$5278,$5285,$5335,$5345,$5355,$5356,$5357,$5365,$5367,$5368,$5375,$5378,$5385,$5445,$5455,$5456,$5465,$5467,$5475,$5478,$5485,$5516,$5517,$5518,$5526,$5527,$5528,$5536,$5537,$5538,$5546,$5547,$5548,$5555,$5556,$5557,$5558,$5565,$5566,$5567,$5568,$5575,$5576,$5577,$5578,$5585,$5586,$5587,$5588,$5616,$5617,$5618,$5626,$5627,$5628,$5636,$5637,$5638,$5646,$5647,$5648; 10752
		dc.w $5656,$5657,$5658,$5665,$5667,$5668,$5675,$5678,$5685,$5686,$5687,$5716,$5726,$5727,$5728,$5736,$5737,$5738,$5746,$5747,$5748,$5756,$5757,$5758,$5767,$5768,$5775,$5778,$5785,$5826,$5836,$5837,$5846,$5847,$5848,$5856,$5857,$5858,$5867,$5868,$5878,$5885,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 10816
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 10880
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 10944
		dc.w $2892,$2A92,$2892,$2892,$2892,$2892,$2892,$2892,$2A92,$2892,$2892,$2A92,$2892,$2A92,$2892,$2A92,$2892,$2892,$2892,$2A92,$2A92,$2892,$2A92,$2892,$2892,$2A92,$2892,$2892,$2A92,$2A92,$2A92,$2892,$2892,$2892,$2892,$2A92,$2892,$2892,$2892,$2892,$2892,$2892,$2892,$2A92,$2892,$2892,$2A92,$2A92,$2892,$2892,$2A92,$2892,$2892,$2A92,$2892,$2A92,$2892,$2A92,$2892,$2892,$2892,$2892,$2892,$2892; 11008
		dc.w $6992,$2992,$2892,$2992,$2992,$2892,$2992,$6992,$2892,$2992,$2992,$2992,$2992,$2992,$6992,$2992,$2992,$2992,$2992,$2992,$2992,$6892,$2892,$2992,$2992,$2992,$2992,$2992,$3992,$2892,$2892,$2992,$2992,$2992,$2992,$7992,$2892,$2992,$2992,$2992,$2992,$2892,$2992,$2992,$2892,$2992,$2992,$2992,$2992,$6992,$2992,$2992,$2892,$2992,$2992,$2992,$3992,$2992,$2992,$2992,$2996,$2992,$2992,$2992; 11072
		dc.w $2892,$2A92,$2892,$2892,$2A92,$2892,$2A92,$2892,$2A92,$2A92,$2892,$2892,$2892,$2A92,$2A92,$2892,$2892,$2892,$2A92,$2A92,$2A92,$2A92,$2892,$2A92,$2892,$2892,$2A92,$2A92,$2A92,$2A92,$2A92,$2892,$2A92,$2892,$2A92,$2A92,$2A92,$2A92,$2892,$2892,$2A92,$2892,$2A92,$2A92,$2A92,$2A92,$2892,$2A92,$2A92,$2A92,$2A92,$2892,$2892,$2A92,$2A92,$2892,$2A92,$2A92,$2A92,$2A92,$2A92,$2A92,$2A92,$2A92; 11136
		dc.w $2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2996,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2996,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992,$2992; 11200
		dc.w  $EA8,    0, $EEE,	   0, $AAA,    0, $ECA,	   0, $C86,    0,    0,	   0, $888,    0, $CCC,	$EEE, $660, $660, $8A0,	$668, $8AC, $222, $888,	$CCC, $E60,    0,    0,	   0,	 0,    0,    0,	$8E8, $660, $8A0, $668,	$8AC, $222, $888, $CCC,	$E60, $460,    0, $44E,	   0,	 0,    0,    0,	$68E, $660, $668, $8AC,	$222, $888, $CCC, $E60,	$460, $8A0,    0, $EEE,	   0,	 0,    0,  $EE,	   8; 11264
		dc.w	 0, $E60, $660,	$8A0, $668, $8AC, $222,	$888, $CCC, $E60, $660,	$8A0, $668, $8AC, $222,	$888,	 0,  $AE,  $86,	$8A8, $66A, $8AE,    0,	$868, $ACE,  $AE,  $86,	$8A8, $66A, $8AE,    0,	$868,	 0, $200, $220,	$660,  $24, $246,    0,	$222, $888, $200, $220,	$660,  $24, $246,    0,	$222,	 0, $EA8, $EEE,	$AAA, $ECA, $C86,    0,	$888, $CCC, $EA8, $EEE,	$AAA, $ECA, $C86,    0,	$888; 11328
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 11392
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 11456
		dc.w  $EA8,    0, $EEE,	   0, $AAA,    0, $ECA,	   0, $C86,    0,    0,	   0, $888,    0, $CCC,	$EEE, $660, $660, $8A0,	$668, $8AC, $222, $888,	$CCC, $E60,    0,    0,	   0,	 0,    0,    0,	$8E8, $660, $8A0, $668,	$8AC, $222, $888, $CCC,	$E60, $460,    0, $44E,	   0,	 0,    0,    0,	$68E, $660, $668, $8AC,	$222, $888, $CCC, $E60,	$460, $8A0,    0, $EEE,	   0,	 0,    0,  $EE,	   8; 11520
		dc.w	 0, $E60, $660,	$8A0, $668, $8AC, $222,	$888, $CCC, $E60, $660,	$8A0, $668, $8AC, $222,	$888,	 0,  $AE,  $86,	$8A8, $66A, $8AE,    0,	$868, $ACE,  $AE,  $86,	$8A8, $66A, $8AE,    0,	$868,	 0, $200, $220,	$660,  $24, $246,    0,	$222, $888, $200, $220,	$660,  $24, $246,    0,	$222,	 0, $EA8, $EEE,	$AAA, $ECA, $C86,    0,	$888, $CCC, $EA8, $EEE,	$AAA, $ECA, $C86,    0,	$888; 11584
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 11648
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 11712
		dc.w  $EA8,    0, $EEE,	   0, $AAA,    0, $ECA,	   0, $C86,    0,    0,	   0, $888,    0, $CCC,	$EEE, $660, $660, $8A0,	$668, $8AC, $222, $888,	$CCC, $E60,    0,    0,	   0,	 0,    0,    0,	$8E8, $660, $8A0, $668,	$8AC, $222, $888, $CCC,	$E60, $460,    0, $44E,	   0,	 0,    0,    0,	$68E, $660, $668, $8AC,	$222, $888, $CCC, $E60,	$460, $8A0,    0, $EEE,	   0,	 0,    0,  $EE,	   8; 11776
		dc.w	 0, $E60, $660,	$8A0, $668, $8AC, $222,	$888, $CCC, $E60, $660,	$8A0, $668, $8AC, $222,	$888,	 0,  $AE,  $86,	$8A8, $66A, $8AE,    0,	$868, $ACE,  $AE,  $86,	$8A8, $66A, $8AE,    0,	$868,	 0, $200, $220,	$660,  $24, $246,    0,	$222, $888, $200, $220,	$660,  $24, $246,    0,	$222,	 0, $EA8, $EEE,	$AAA, $ECA, $C86,    0,	$888, $CCC, $EA8, $EEE,	$AAA, $ECA, $C86,    0,	$888; 11840
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 11904
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 11968
		dc.w  $EA8,    0, $EEE,	   0, $AAA,    0, $ECA,	   0, $C86,    0,    0,	   0, $888,    0, $CCC,	$EEE, $660, $660, $8A0,	$668, $8AC, $222, $888,	$CCC, $E60,    0,    0,	   0,	 0,    0,    0,	$8E8, $660, $8A0, $668,	$8AC, $222, $888, $CCC,	$E60, $460,    0, $44E,	   0,	 0,    0,    0,	$68E, $660, $668, $8AC,	$222, $888, $CCC, $E60,	$460, $8A0,    0, $EEE,	   0,	 0,    0,  $EE,	   8; 12032
		dc.w	 0, $E60, $660,	$8A0, $668, $8AC, $222,	$888, $CCC, $E60, $660,	$8A0, $668, $8AC, $222,	$888,	 0,  $AE,  $86,	$8A8, $66A, $8AE,    0,	$868, $ACE,  $AE,  $86,	$8A8, $66A, $8AE,    0,	$868,	 0, $200, $220,	$660,  $24, $246,    0,	$222, $888, $200, $220,	$660,  $24, $246,    0,	$222,	 0, $EA8, $EEE,	$AAA, $ECA, $C86,    0,	$888, $CCC, $EA8, $EEE,	$AAA, $ECA, $C86,    0,	$888; 12096
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 12160
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 12224
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 12288
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 12352
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 12416
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 12480
		dc.w $2028,$2028,$2028,$2028,$2028,$2008,$2028,$2020,$2028,$2020,$2000,$2008,$2008,$2008,$2000,$2008,$2028,$2020,$2028,$2028,$2028,$2020,$2020,$2020,$2028,$2028,$2000,$2000,$2020,$2020,$2020,$2000,$2000,$2008,$2008,$2020,$2008,$2020,$2020,$2020,$2008,$2000,$2008,$2028,$2020,$2008,$2028,$2028,$2000,$2008,$2028,$2020,$2020,$2020,$2028,$2000,$2000,$2000,$2028,$2020,$2020,$2008,$2000,$2008; 12544
		dc.w $1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040; 12608
		dc.w $2000,$1000,$2020,$2028,$2000,$2000,$2008,$2020,$2020,$2020,$2008,$2008,$2000,$2020,$2020,$2020,$2020,$2008,$2000,$2000,$2028,$2020,$2020,$2020,$2000,$2020,$2008,$2008,$2020,$2020,$2000,$2020,$2008,$2020,$2000,$2020,$2028,$2020,$2028,$2000,$2008,$2028,$2028,$2020,$2028,$2028,$2020,$2000,$2008,$2028,$2020,$2000,$2028,$2000,$2020,$2000,$2020,$2020,$2020,$2028,$2020,$2008,$2028,$2020; 12672
		dc.w $1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040,$1040; 12736
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 12800
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 12864
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 12928
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 12992
		dc.w  $85C, $85C, $85C,	$85C, $85C, $85C, $85C,	$85C, $85C, $85C, $85C,	$85C, $85C, $85C, $85C,	$85C, $85C, $85C, $85C,	$85C, $85C, $85C, $85C,	$85C, $85C, $85C, $85C,	$81C, $85C, $85C, $85C,	$85C, $85C, $85C, $85C,	$85C, $85C, $85C, $85C,	$85C, $85C, $85C, $85C,$885C, $85C, $81C, $85C,	$85C, $85C, $85C, $85C,	$85C, $85C, $85C, $85C,	$85C, $85C, $81C, $85C,	$85C, $85C, $85C, $85C,	$85C; 13056
		dc.w  $95C, $95C, $95C,	$95D, $95C, $95C, $95C,	$95C, $95C, $95C, $95C,	$95D, $95C, $95C, $95C,	$95C, $95C, $95C, $95D,	$95C, $95C, $95C, $95D,	$95C, $95C, $95D, $95C,	$95C, $95D, $95C, $95C,	$95C, $95D, $95D, $95C,	$95C, $95C, $95C, $95C,	$95C, $95C, $95C, $95C,	$95C, $95C, $95D, $95D,	$95C, $95C, $95D, $95C,	$95C, $95C, $95C, $95C,	$95C, $95C, $95C, $95D,	$95C, $95D, $95C, $95C,	$95C; 13120
		dc.w  $85C, $85C, $85C,	$85C, $85C, $81C, $81C,	$85C, $85C, $85C, $85C,	$85C, $85C, $85C, $85C,	$81C, $85C, $85C, $85C,	$85C, $81C, $85C, $85C,	$85C, $85C, $85C, $85C,	$85C, $85C, $85C, $85C,	$85C, $85C, $85C, $85C,	$85C, $85C, $81C, $85C,	$85C, $85C, $85C, $85C,	$85C, $85C, $85C, $85C,	$85C, $81C, $85C, $85C,	$81C, $85C, $85C, $81C,	$81C, $85C, $85C, $85C,	$85C, $85C, $81C, $85C,	$81C; 13184
		dc.w  $95C, $95C, $95D,	$95C, $95C, $95C, $95C,	$95C, $95C, $95C, $95C,	$95C, $95D, $95C, $95C,	$95C, $95D, $95C, $95D,	$95C, $95C, $95C, $95C,	$95D, $95C, $95C, $95C,	$95C, $95C, $95C, $95D,	$95C, $95C, $95C, $95C,	$95C, $95C, $95C, $95D,	$95C, $95C, $95C, $95C,	$95C, $95D, $95C, $95C,	$955, $95C, $95C, $95C,	$95D, $95C, $95C, $95D,	$95C, $95C, $95C, $95D,	$95C, $95D, $95C, $95C,	$95C; 13248
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 13312
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 13376
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 13440
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 13504
		dc.w $300A,$300A,$300A,$300A,$300A,$300A,$300A,$300A,$300A,$300A,$300A,$300A,$300A,$300A,$200A,$320A,$300A,$300A,$300A,$200A,$300A,$300A,$300A,$300A,$300A,$300A,$300A,$300A,$300A,$380A,$300A,$300A,$300A,$300A,$300A,$300A,$300A,$300A,$300A,$300A,$300A,$300A,$300A,$300A,$300A,$300A,$300A,$300A,$300A,$320A,$320A,$300A,$300A,$300A,$300A,$300A,$300A,$320A,$300A,$300A,$300A,$300A,$300A,$300A; 13568
		dc.w $101E,$101E,$101E,$101E,$101F,$101F,$101E,$101E,$101E,$101F,$101F,$101E,$101E,$101F,$101E,$101F,$101F,$101E,$101F,$101F,$101E,$101F,$101F,$101F,$101F,$101E,$101F,$101E,$101E,$101F,$101E,$101E,$101F,$101E,$101F,$101E,$101E,$101E,$101E,$101E,$101E,$101F,$101F,$101F,$101E,$101E,$101F,$101F,$101F,$101E,$101F,$101F,$101F,$101F,$101F,$101E,$101F,$101E,$101F,$101E,$101F,$101F,$101F,$101E; 13632
		dc.w $300A,$100A,$300A,$300A,$300A,$200A,$320A,$100A,$300A,$300A,$300A,$300A,$300A,$320A,$300A,$200A,$300A,$300A,$300A,$320A,$300A,$308A,$300A,$320A,$320A,$300A,$300A,$300A,$320A,$380A,$320A,$300A,$300A,$300A,$300A,$320A,$320A,$300A,$300A,$300A,$200A,$300A,$320A,$300A,$300A,$320A,$320A,$320A,$320A,$3A0A,$1A0A,$300A,$320A,$300A,$320A,$300A,$220A,$320A,$100A,$300A,$300A,$320A,$300A,$300A; 13696
		dc.w $101E,$101F,$101F,$101F,$101F,$101E,$101F,$101E,$101F,$101F,$101F,$101F,$101F,$101E,$101E,$101F,$101F,$101F,$101F,$101F,$101E,$101F,$101F,$101F,$101F,$101F,$101E,$101E,$101F,$101E,$101F,$101F,$101E,$101F,$101F,$101F,$101F,$101F,$101E,$101F,$101E,$101F,$101F,$101F,$101F,$101E,$101F,$101F,$101F,$1017,$101F,$101F,$101F,$101E,$101F,$101E,$101F,$101F,$101F,$101E,$101F,$101F,$101F,$101E; 13760
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 13824
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 13888
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 13952
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 14016
		dc.w $A809,$A209,$A209,$A309,$2009,$A009,$A109,$A201,$AB09,$2209,$AA09,$A009,$A209,$A301,$2109,$AB09,$A009,$A001,$A109,$A009,$A009,$2309,$AB09,$A008,$A309,$A309,$2309,$2309,$2209,$A309,$A209,$A001,$2209,$A109,$2209,$A309,$AB09,$A309,$2209,$2009,$2B09,$2301,$2209,$A309,$A009,$2109,$2309,$2009,$A109,$2009,$A909,$A009,$A009,$A109,$A209,$2309,$2009,$A309,$2309,$2209,$A301,$2009,$A109,$A109; 14080
		dc.w $3101,$3101,$3101,$3101,$2101,$3101,$2101,$3101,$2101, $101,$3101,$2101,$3101,$3101,$3101,$2101,$2101,$2501,$3101,$2101,$2101,$3101,$3101,$3101,$2101,$3101,$2101,$2101,$1101,$3101,$2101,$3101,$3101,$3101,$2101,$3101,$2101,$2101,$3101,$3101,$3101,$3101,$3101,$2101,$3101,$3101,$2101,$2101,$2101,$3101,$3101,$3101,$3101,$3109,$2101,$2101,$3101,$2101,$2101,$2101,$2101,$2101,$2101,$3101; 14144
		dc.w $2009,$2209,$A101,$2209,$2109,$2201,$A109,$2309,$2901,$2009,$2009,$2109,$2109,$2309,$2109,$2309,$2109,$2B09,$2B09,$2109,$2B09,$2109,$2B09,$2B09,$2309,$2309,$2309,$A909,$2B01,$2309,$2B09,$2309,$2309,$2101,$A309,$2B09,$2309,$2B08,$2309,$2309,$2B09,$A309,$2B08,$2B09,$2B09,$2309,$2B09,$2B01,$A309,$2301,$2309,$2309,$2309,$2309,$2209,$2309,$2B09,$2B01,$2B09,$2309,$2309,$2109,$2309,$2309; 14208
		dc.w $2101,$2101,$2101,$2501,$2501,$2101,$2501,$2101,$2101,$2101,$2101,$2101,$2101,$2501,$2101,$2101,$2101,$2101,$2101,$2101,$2501,$2101,$2101,$2101,$2101,$2501,$3101,$2501,$2101,$2101,$2501,$2101,$2101,$3101,$2901,$2101,$2101,$2501,$2101,$2101,$3101,$2501,$2101,$2101,$2501,$3101,$2101,$3101,$2501,$2101,$2101,$2101,$2501,$2101,$2101,$2101,$2501,$2501,$2101,$2101,$2101,$2101,$2101,$2101; 14272
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 14336
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 14400
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 14464
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 14528
		dc.w	 2, $202, $202,	   2, $202,    2, $202,	   2, $202,    2, $202,	$202,	 2, $202, $202,	$202, $202,    2, $202,	   2, $202, $202, $202,	   2,	 2, $202, $202,	$202,	 2,    2,    2,	   2, $202, $202,    2,	$202, $202, $202, $202,	   2, $202, $202, $202,	$202,	 2,    2, $202,	   2, $202,    2, $202,	   2,	 2, $202,    2,	   2,	 2, $202, $222,	   2,	 2, $202, $202,	   2; 14592
		dc.w	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2; 14656
		dc.w  $202,    2,    2,	$202, $202,    2, $202,	   2, $202, $202, $202,	   2,	 2, $202,    2,	   2,	 2, $202, $202,	   2, $202, $202, $202,	$202, $202, $202, $202,	   2, $202, $202, $202,	$202, $202, $202, $202,	$202, $202, $202, $202,	$202, $202, $202, $222,	$202, $202, $202, $202,	$202, $202, $202, $202,	$202, $202, $202, $202,	$202, $202,    2, $202,	$202, $202, $202,    2,	$222; 14720
		dc.w	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2; 14784
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 14848
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 14912
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 14976
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15040
		dc.w $A01C,$A01C,$A018,$A018,$A03C,$A01C,$A018,$A018,$A01C,$A038,$A018,$A018,$A01C,$A018,$A018,$A018,$A018,$A01C,$A01C,$A01C,$A018,$A018,$A018,$A038,$A018,$A018,$A01C,$A018,$A018,$A018,$A038,$A018,$A018,$A01C,$A01C,$A018,$A018,$A03C,$A018,$A018,$A018,$A018,$A01C,$A018,$A038,$A018,$A018,$A01C,$A018,$A018,$A01C,$A038,$A018,$A018,$A01C,$A018,$A018,$A018,$A03C,$A018,$A01C,$A01C,$A018,$A018; 15104
		dc.w $B41C,$B01C,$B01C,$B01C,$301C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$301C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C,$B01C; 15168
		dc.w $A018,$A018,$A018,$A01C,$A018,$A018,$A018,$A018,$A018,$A018,$A01C,$A018,$A018,$A01C,$A018,$A018,$A018,$A01C,$A018,$A018,$A018,$A018,$A018,$A018,$A01C,$A018,$A018,$A018,$A018,$A018,$A018,$A018,$A038,$A018,$A01C,$A018,$A038,$A018,$A01C,$A018,$A018,$A018,$2038,$A018,$A018,$A03C,$A018,$A018,$A018,$A018,$A018,$A018,$A01C,$A01C,$A018,$A018,$A038,$A018,$A018,$A01C,$A018,$A018,$A018,$A018; 15232
		dc.w $A018,$B01C,$B41C,$B41C,$B41C,$B41C,$B014,$B41C,$B01C,$B01C,$B01C,$A01C,$B41C,$B41C,$B41C,$B41C,$B41C,$B01C,$B41C,$B01C,$B41C,$B01C,$B41C,$B41C,$B41C,$B41C,$B01C,$B41C,$B01C,$B01C,$A41C,$B01C,$B01C,$B01C,$B41C,$A01C,$B41C,$B01C,$B01C,$B01C,$B41C,$B41C,$B01C,$B01C,$B01C,$B01C,$B01C,$B014,$B41C,$B01C,$B41C,$B01C,$B41C,$A41C,$B01C,$A01C,$B41C,$B41C,$B01C,$B01C,$B01C,$B01C,$B41C,$B01C; 15296
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15360
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15424
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15488
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15552
		dc.w $8446,$8446,$8446,$8446,$8406,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8046,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8046,$8446,$8446,$8406,$8446,$8406,$8446,$8046,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8046,$8446,$8446,$8446,$8446,$8446,$8046,$8406; 15616
		dc.w $8446,$8444,$8446,$8444,$8446,$8446,$8446,$8446,$8446,$8446,$8444,$8446,$8446,$8446,$8446,$8444,$8446,$8446,$8446,$8444,$8446,$8546,$8546,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8546,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8546,$8446,$8446,$8446,$8446,$8446,$8446,$8444,$8446,$8446,$8446,$8446; 15680
		dc.w $8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8046,$8446,$8406,$8446,$8406,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8406,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8046,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8446,$8406,$8446,$8446,$8446,$8446,$8446,$8446; 15744
		dc.w $8546,$8446,$8446,$8446,$8546,$8446,$8446,$8546,$8546,$8546,$8446,$8546,$8446,$8546,$8546,$8546,$8546,$8546,$8546,$8446,$8546,$8544,$8446,$8546,$8446,$8446,$8546,$8546,$8546,$8544,$8446,$8546,$8446,$8546,$8544,$8446,$8444,$8444,$8546,$8546,$8546,$8546,$8544,$8444,$8446,$8446,$8446,$8546,$8546,$8446,$8546,$8546,$8446,$8544,$8446,$8546,$8546,$8446,$8546,$8446,$8546,$8446,$8546,$8546; 15808
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15872
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15936
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 16000
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 16064
		dc.w $888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A; 16128
		dc.w $8980,$8982,$888A,$8982,$8882,$8982,$898A,$8982,$8982,$8882,$8982,$8982,$8982,$8882,$898A,$8882,$8882,$8982,$888A,$8982,$8982,$8982,$8982,$8982,$8982,$8982,$8982,$8882,$8982, $882,$8982,$8982,$8982,$8982,$8882,$8982,$8982,$8982,$898A,$8882,$8882,$8882,$8982,$8982,$8982,$8882,$888A,$8882,$8882,$8982,$8882,$8882,$8982,$8982,$8982,$8982,$8D82,$8882,$8982,$8880,$8982,$8882,$8882,$8880; 16192
		dc.w $888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A, $88A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A, $88A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A,$888A, $88A,$888A,$888A,$888A,$888A,$888A; 16256
		dc.w $8982,$8980,$8980,$8982,$8982,$8982,$8982,$8982,$8982,$8982,$898A,	$D82,$898A,$8982,$8980,$8982,$8982,$8982,$8982,$8982,$8D82,$8D82,$8982,$8982,$8D82,$8982,$8982,$8D82,$8D82,$8982,$8982,$8982,$8982,$8982,$8D82,$8982,$898A,$8980,$8982,$8982,$8D82,$8982,$8982,$8980,$8982,$8982,$8982,$8982,$8982,$8982,$8982,$8982,$8982,$8982,$8982,$8982,$8982,$8982,$8982,$8982,$8D82,$8982,$8982,$8982; 16320
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 16384
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 16448
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 16512
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 16576
		dc.w $38E8,$3848,$3868,$3068,$3048,$3848,$3048,$3008,$3848,$3068,$3868,$3848,$3848,$3848,$3808,$3848,$3848,$3868,$3848,$3048,$3048,$3008,$3848,$3868,$3848,$3808,$3848,$3848,$3848,$3068,$30C8,$3048,$3848,$3008,$3848,$3848,$3A48,$3068,$3848,$3848,$3048,$3848,$3848,$3848,$3868,$3048,$3848,$3048,$3048,$3848,$3848,$3868,$3048,$3048,$3048,$3048,$3808,$3808,$3868,$3048,$3848,$3008,$3048,$3848; 16640
		dc.w $3158,$1158,$1158,$1158,$1158,$1158,$1158,$3158,$1158,$1158,$1158,$1158,$1158,$1158,$1158,$1158,$1158,$1158,$1158,$1158,$1158,$3158,$1158,$1158,$1158,$1158,$1158,$1158,$3158,$1158,$1158,$1158,$1158,$1158,$1158,$3158,$1058,$1158,$1158,$1158,$1158,$1158,$3158,$1158,$1158,$1158,$1058,$1158,$1158,$3158,$1158,$1158,$1158,$1158,$1158,$1158,$3158,$1158,$1158,$1158,$1158,$1158,$1158,$1158; 16704
		dc.w $3868,$1868,$3048,$3048,$3048,$3808,$3848,$3848,$3848,$3848,$3048,$3068,$3848,$3008,$3868,$3008,$3848,$3848,$3848,$3808,$3848,$3868,$3848,$3848,$3048,$3848,$3848,$3848,$3868,$3B48,$3848,$3848,$3868,$3808,$3808,$3A48,$3848,$3848,$3048,$3848,$3808,$3808,$3A68,$3848,$3808,$3868,$3848,$3808,$3848,$3A68,$3848,$3048,$3848,$3808,$3A08,$3848,$3868,$3A48,$3808,$3848,$3808,$3848,$3848,$3868; 16768
		dc.w $1158,$1158,$1158,$1158,$1158,$1158,$1158,$1158,$1158,$1158,$3158,$1158,$1158,$1158,$1158,$3158,$3158,$1958,$1158,$3158,$1158,$1158,$3158,$1158,$1158,$1158,$3158,$1158,$1158,$1158,$1158,$1158,$1158,$3158,$1158,$3158,$1158,$1158,$3158,$1158,$3158,$1158,$1158,$1158,$1158,$1158,$1158,$1158,$1158,$1158,$1158,$1158,$1158,$1158,$1158,$1158,$1158,$1158,$1158,$1158,$1158,$3158,$1158,$1158; 16832
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 16896
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 16960
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 17024
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 17088
		dc.w   $A0,  $B0,  $B0,	 $B0,  $B0,  $30,  $B0,	 $B0,  $B0,  $B0,  $A0,	 $A0,  $B0,  $B0,  $B0,	 $B0,  $B0,  $A0,  $B0,	 $30,  $B0,  $A0,  $B0,	 $B0,  $B0,  $A0,  $B0,	 $A0,  $30,  $B0,  $A0,	 $B0,  $B0,  $B0,  $B0,	 $B0,  $B0,  $B0,  $B0,	 $A0,  $B0,  $B0,  $A0,	 $20,  $B0,  $20,  $A0,	 $B0,  $A0,  $B0,  $B0,	 $B0,  $B0,  $B0,  $A0,	 $B0,  $B0,  $A0,  $B0,	 $B0,  $B0,  $B0,  $A0,	 $B0; 17152
		dc.w $1110,$11B0,$11B0,$11B0, $190,$11B0,$11B0,$1130,$11B0,$11B0,$1190,	$1B0,$1130, $1B0,$11B0,$11B0,$11B0, $1B0,$11B0,$1130,$11B0,$11B0,$11B0,$11B0,$11B0,$1130, $190,	$110,$11B0, $130,$1130,$11B0, $190,$1190, $130,$11B0, $1B0, $130,$11B0,$11B0,$1190,$10B0,$1190,$1130,$11B0,$1130, $1B0,$11B0, $1B0,$11B0, $1B0,	$1B0,$11B0,$11B0, $1B0,$11B0,$11B0, $1B0, $1B0,$1190, $1B0, $1B0, $1B0,$11B0; 17216
		dc.w   $B0,  $B0,  $B0,	 $B0,  $B0,  $A0,  $B0,	 $B0,  $A0,  $B0,  $B0,	 $B0,  $B0,  $A0,  $B0,	 $B0,  $B0,  $B0,  $B0,	 $B0,  $A0,  $B0, $2B0,	$2B0,  $B0,  $B0,  $B0,	 $B0,  $B0,  $B0,  $B0,	 $B0,  $B0,  $B0,  $B0,	 $B0,  $B0,  $B0,  $B0,	 $B0,  $A0,  $B0,  $B0,	 $B0,  $B0,  $B0,  $B0,	 $A0,  $B0, $2B0,  $B0,	 $B0,  $B0,  $B0,  $B0,	 $B0,  $B0,  $B0,  $B0,	 $B0,  $B0,  $B0,  $B0,	 $B0; 17280
		dc.w  $110, $1B0, $1B0,	$1B0, $190,$1130, $1B0,	$1B0, $130, $1B0, $1B0,	$1B0,$11B0, $1B0, $130,	$1B0, $1B0, $130, $130,$11B0,$11B0,$1130, $1B0,	$110, $1B0, $130,$11B0,	$1B0,$11B0, $1B0, $110,$1130, $1B0,$1130, $1B0,	$130, $1B0, $1B0, $1B0,	$130,$1130, $1B0, $130,	$1B0, $130, $130, $130,$11B0, $1B0, $1B0, $1B0,$11B0, $190, $1B0,$11B0,	$130, $1B0, $130, $130,	$130, $130,$11B0, $1B0,$11B0; 17344
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 17408
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 17472
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 17536
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 17600
		dc.w $28A8,$28A8,$28A8,	$8A8,$28A8, $8A8, $8A8,$28A8,$28A8, $8A8,$28A8,	$8A8, $8A8,$28A8, $8A8,$28A8, $8A8, $8A8, $8A8,	$8A8,$28A8,$28A8,$28A8,$28A8, $8A8,$28A8, $8A8,	$8A8, $8A8,$28A8,$28A8,	$8A8, $8A8, $8A8, $8A8,	$8A8,$28A8,$28A8,$28A8,	$8A8,$28A8, $8A8,$28A8,$28A8,$28A8,$28A8, $8A8,	$8A8, $8A8, $8A8,$28A8,$28A8,$28A8,$28A8, $8A8,	$8A8, $8A8,$28A8, $8A8,	$8A8,$28A8, $8A8, $8A8,	$8A8; 17664
		dc.w  $8A0, $8A0, $8A0,	$8A0, $8A8, $8A0, $8A0,	$8A0, $8A0, $8A0, $8A0,	$8A0, $8A0, $820, $8A8,	$8A0, $8A0, $8A0, $8A0,	$8A0, $8A0,$28A0, $8A0,	$8A0, $8A0, $828, $8A0,	$820, $8A0, $8A0, $8A0,	$8A0, $8A0, $880, $8A0,$28A0, $8A0, $8A0, $8A0,	$8A8, $8A0, $8A0, $8A0,	$8A0, $8A0, $8A0, $8A0,	$8A0, $8A0, $8A0, $8A0,	$8A0, $8A0, $8A0, $8A0,	$8A0, $8A0, $820, $8A8,	$8A0, $8A8, $8A0, $8A0,	$8A0; 17728
		dc.w  $8A8, $8A8, $8A8,	$8A8, $8A8, $8A8, $8A8,	$8A8, $8A8, $8A8, $8A8,	$8A8, $8A8, $8A8, $8A8,	$8A8, $8A8, $8A8, $8A8,	$8A8,$28A8, $8A8, $8A8,	$8A8, $8A8, $8A8, $8A8,$28A8, $8A8, $8A8, $8A8,	$8A8, $8A8, $8A8, $8A8,	$8A8, $8A8, $8A8, $8A8,	$8A8, $8A8,$28A8, $8A8,	$8A8, $8A8, $8A8, $8A8,	$8A8, $8A8, $8A8, $8A8,	$8A8, $8A8, $8A8, $8A8,	$8A8, $8A8, $8A8, $8A8,	$8A8, $8A8, $8A8, $8A8,	$8A8; 17792
		dc.w  $8A0, $8A0, $8A0,	$8A0, $8A0, $8A0, $8A0,	$8A0, $820, $8A0, $8A0,	$8A0, $8A0, $8A0, $8A0,	$8A0, $8A0, $8A0, $8A0,	$8A0, $8A0, $8A0, $8A0,	$8A0, $8A0, $8A0, $8A0,	$8A0, $8A0, $8A0, $8A0,	$8A0, $8A0, $8A0, $8A0,	$8A0, $8A0, $8A8, $8A0,	$8A0, $820, $8A0, $8A0,	$8A0, $8A0, $8A0, $8A0,	$8A0, $8A0, $8A0, $8A0,	$8A0, $8A0, $8A0, $8A0,	$8A0, $8A0, $8A0, $8A0,	$8A0, $8A0, $8A0, $8A0,	$8A0; 17856
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 17920
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 17984
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 18048
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 18112
		dc.w  $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A; 18176
		dc.w  $18B, $18B, $18B,	$18B, $18B, $18B, $18B,	$18A, $18B, $18B, $18B,	$18B, $18B, $18B, $18A,	$18B, $18B, $18B, $18B,	$18B, $18A, $18B, $18B,	$18B, $18B, $18B, $18A,	$18A, $18B, $18B, $18B,	$18A, $18B, $18B, $18B,	$18B, $18A, $18B, $18B,	$18B, $18B, $18B, $18B,	$18B, $18B, $18B, $18B,	$18B, $18B, $18B, $18A,	$18A, $18B, $18B, $18B,	$18B, $18B, $18B, $18B,	$18B, $18B, $18B, $18B,	$18B; 18240
		dc.w  $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A, $18A, $18A, $18A,	$18A; 18304
		dc.w  $18A, $18B, $18A,	$18B, $18B, $18B, $18B,	$18A, $18B, $18B, $18B,	$18B, $18B, $18B, $18A,	$18B, $18B, $18B, $18B,	$18B, $18B, $18B, $18B,	$18B, $18B, $183, $18B,	$18B, $18B, $18B, $18B,	$18A, $18B, $18B, $18B,	$18B, $18B, $18B, $18B,	$18B, $18B, $18B, $18A,	$18B, $18B, $18B, $18B,	$18B, $18B, $18B, $18B,	$18B, $18B, $18B, $18B,	$18B, $18B, $18B, $18B,	$183, $18B, $18B, $18B,	$18B; 18368
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 18432
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 18496
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 18560
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 18624
		dc.w $838A,$8380,$8380,$8100,$8380,$8188,$8000,$8300,$8300,$8380,$8300,$8300,$8300,$8300,$8300,$8300,$8200,$8300,$8300,$8308,$8300,$8300,$8300,$8380,$8300,$8200,$8300,$8300,$8300,$8300,$8080,$8300,$8300,$8388,$8300,$8300,$8302,$8380,$8300,$8300,$8300,$8200,$8300,$8300,$8100,$8300,$8200,$8300,$8300,$8300,$8300,$8380,$8300,$8100,$8000,$8300,$8100,$8300,$8180,$8300,$8100,$8200,$8300,$8100; 18688
		dc.w $9100,$9100,$9100,$9100,$9100,$9100,$9000,$9100,$9100,$9100,$8100,$8000,$9100,$9100,$D100,$9100,$9100,$9100,$9100,$9000,$9100,$D100,$9000,$9100,$9100,$9100,$9100,$9000,$9100,$9100,$9100,$9000,$9100,$9100,$9100,$9100,$9100,$9000,$9100,$9100,$9100,$9100,$9000,$9100,$9100,$9100,$9100,$9100,$9100,$9100,$9100,$9000,$9100,$9100,$9100,$9100,$9100,$9100,$9100,$9100,$9100,$9100,$9000,$9000; 18752
		dc.w $8380,$8100,$8300,$8300,$8300,$8200,$8300,$8300,$8200,$8100,$8300,$8300,$8180,$8300,$8380,$8100,$8380,$8300,$8300,$8300,$8302,$8380,$8300,$8300,$8300,$8300,$8300,$8300,$8380,$8300,$8300,$8300,$8300,$8300,$8300,$8300,$8300,$8300,$8100,$8300,$8300,$8300,$8380,$8300,$8300,$8380,$8300,$8300,$8300,$8380,$8200,$8100,$8300,$8300,$8200,$8300,$8280,$8380,$8300,$8308,$8300,$8300,$8300,$8380; 18816
		dc.w $9100,$9100,$8100,$8100,$8100,$9100,$9100,$9100,$9100,$8100,$9100,$9100,$9100,$9100,$8100,$8100,$8100,$9100,$8100,$9100,$9100,$9100,$9100,$8100,$9100,$8100,$9100,$9100,$9100,$9100,$8100,$9100,$9100,$9100,$9100,$9100,$9100,$9100,$9100,$9100,$9100,$8100,$9100,$9100,$9100,$9100,$8100,$9100,$9100,$9100,$9100,$9100,$9100,$8100,$9100,$9100,$8100,$9100,$8100,$8100,$8100,$9100,$9100,$9100; 18880
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 18944
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 19008
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 19072
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 19136
		dc.w $A8CE,$A84E,$A846,$804E,$884E,$A04E,$8846,$8846,$A84E,$8846,$8046,$8806,$8846,$884E,$8846,$A046,$8846,$8046,$8846,$804E,$8046,$8046,$A846,$8046,$8846,$8846,$884E,$8846,$8846,$A846,$8846,$8046,$8846,$804E,$884E,$8046,$A846,$A046,$884E,$8046,$884E,$8846,$804E,$A846,$8846,$8806,$8046,$804E,$8846,$8846,$A84E,$8846,$8006,$884E,$884E,$8046,$8846,$A846,$8846,$8846,$8806,$804E,$884E,$8846; 19200
		dc.w $884E,$8C46,$884E,$8C46,$884E,$8C4E,$8846,$8846,$8C4E,$8846,$8846,$884E,$884E,$8846,$8846,$8C46,$884E,$884E,$804E,$8846,$8846,$884E,$8C4E,$8846,$8C4E,$884E,$8C4E,$884E,$884E,$8846,$8846,$8846,$8C4E,$8C46,$8846,$8846,$8846,$884E,$8846,$884E,$8846,$884E,$8846,$884E,$8846,$8846,$884E,$884E,$884E,$884E,$8846,$8846,$8C46,$8C4E,$884E,$884E,$8C4E,$884E,$8C4E,$884E,$884E,$8846,$884E,$8C46; 19264
		dc.w $8846,$8806,$8846,$884E,$8046,$8846,$A806,$8846,$8846,$8846,$884E,$8846,$8806,$A046,$8006,$8846,$8846,$804E,$8846,$8846,$A84E,$8846,$8846,$8846, $80E,$8846,$8806,$A80E,$8846,$8846,$884E,$880E,$8846,$884E,$A846,$8846, $846,$8846,$884E,$8846,$8806,$A842,$8846,$8846,$8046,$884E,$8846,$8846,$A046,$8846,$8846,$8846,$8846,$8806,$8806,$A846,$8C46,$8846,$8806,$884E,$8846,$800E,$A846,$8846; 19328
		dc.w $884E,$8046,$8C4E,$8C4E,$8C4E,$8C4E,$884E,$8846,$8C4E,$8C4E,$8C46,$8C46,$884E,$8C4E,$8C4E,$8C46,$8C4E,$8C4E,$8C46,$8C4E,$8C4E,$8C4E,$8C4E,$8C4E,$884E,$8C4E,$884E,$884E,$8C4E,$8C4E,$884E,$8C4E,$8C46,$8C4E,$8C4E,$8C46,$884E,$8C4E,$8C4E,$8C4E,$8C46,$8C4E,$8C4E,$8C46,$8C4E,$8C4E,$8C4E,$884E,$8C4E,$8C46,$8C4E,$8C4E,$8C4E,$884E,$8C4E,$8C4E,$8C46,$8C4E,$8C4E,$8C46,$8C4E,$884E,$8C4E,$8846; 19392
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 19456
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 19520
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 19584
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 19648
		dc.w  $8E8, $8E8, $8E8,	$8E8, $868, $8E8, $8E8,	$8E8, $8E8, $8E8, $8E8,	$8E8, $8E8, $8E8, $8E8,	$868, $8E8, $868, $AE8,	$8E8, $8E8, $8E8, $8E8,	$8E8, $8E8, $8E8, $8E8,	$868, $8E8, $868, $8E8,	$8E8, $8E8, $8E8, $8E8,	$8E8, $868, $8E8, $8E8,	$868, $8E8, $868, $8E8,	$8E8, $8E8, $8E8, $8E8,	$8E8, $868, $8E8, $AE8,	$8E8, $8E8, $8E8, $8E8,	$8E8, $8E8, $8E8, $8E8,	$8E8, $8E8, $8E8, $868,	$868; 19712
		dc.w  $868, $860, $868,	$868, $868, $868, $860,	$860, $868, $868, $868,	$868, $868, $868, $868,	$868, $868, $868, $868,	$868, $868, $868, $868,	$868, $868, $868,  $68,	$868, $868, $868, $860,	$868, $868, $848, $868,	$868, $868, $868, $860,	$868, $868, $868, $868,	$868, $868, $868, $868,	$860, $868, $868, $868,	$868, $868, $868, $868,	$868, $868, $868, $868,	$868, $868, $860, $868,	$868; 19776
		dc.w  $8E8, $8E8, $8E8,	$8E8, $8E8, $8E8, $AE8,	$8E8, $8E8, $8E8, $8E8,	$8E8, $8E8, $8E8, $8E8,	$8E8, $8E8, $8E8, $8E8,	$8E8, $8E8, $AE8, $8E8,	$AE8, $8E8, $8E8, $8E8,	$AE8, $8E8, $8E8, $8E8,	$8E8, $8E8, $AE8, $AE8,	$8E8, $8E8, $8E8, $8E8,	$8E8, $8E8, $8E8, $AE8,	$8E8, $AE8, $AE8, $8E8,	$8E8, $8E8, $AE8, $8E8,	$AE8, $8E8, $8E8, $8E8,	$8E8, $AE8, $8E8, $AE8,	$AE8, $AE8, $8E8, $AE8,	$8E8; 19840
		dc.w  $868, $868, $868,	$868, $868, $868, $868,	$860, $868, $868, $868,	$868, $860, $868, $868,	$868, $868, $868, $868,	$868, $868, $868, $868,	$868, $868, $868, $868,	$868, $860, $868, $868,	$868,  $68, $868, $8E8,	$868, $868, $860, $868,	$868, $868, $860, $868,	$868, $868, $868,  $68,	$868, $868, $868, $868,	$868, $860, $868, $868,	$868, $868, $868, $868,	$860, $868, $868, $8E8,	$868; 19904
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 19968
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 20032
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 20096
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 20160
		dc.w $88C8,$88C8, $8C8,	$8C8, $8C8, $8C8,  $48,	$848,$88C8, $8C8, $8C8,	$848, $8C8, $848, $848,	$8C8, $8C8, $8C8, $8C8,	 $C8, $848,  $48,$8848,	$8C8, $848,  $C8, $848,	$848, $848,$8848, $8C8,	$848, $848,  $48,  $48,	 $48,$88C8, $8C8, $848,	$8C8,  $48, $848, $848,$8848, $8C8, $848, $848,	$848, $848, $848,$8848,	$8C8,  $C8,  $48,  $C8,	$848, $8C8,$8848,  $C8,	$8C8, $848,  $48, $848,	 $48; 20224
		dc.w $444C,  $40, $448,	 $48,  $4C,  $44,  $4C,$4448, $440, $448, $440,	$44C,  $4C,  $44,  $4C,	$448, $444, $44C,  $44,	 $48,  $4C, $44C, $444,	 $48,  $4C, $44C,  $44,	 $48,  $4C,  $48, $44C,	 $48, $44C,  $4C, $444,	 $48,  $48, $44C, $444,	 $4C,  $4C,  $48,$444C,	 $4C,  $48,  $48, $44C,	 $4C,  $48,$844C,  $4C,	 $4C,  $4C, $44C,  $4C,	 $48,$444C,  $4C,  $4C,	 $44,  $4C, $44C,  $4C,	 $44; 20288
		dc.w  $8C8,  $48, $8C8,	$8C8, $848, $8C8, $848,	$848,  $C8, $8C8, $848,	$848,  $48, $8C8, $848,	 $C8, $8C8, $848, $848,	$848, $848, $8C8, $8C8,	$848, $8C8,  $48, $848,	$848, $8C8, $CC8, $8C8,	$8C8, $848, $848,$88C8,	$848,  $C8, $848, $848,	$848, $8C8, $848, $8C8,	$848,  $48, $848, $8C8,	$848, $848, $8C8, $848,	$848, $848, $848, $848,	$8C8, $8C8, $8C8, $848,	$848, $848, $848,$8848,	$8C8; 20352
		dc.w   $48,  $4C, $444,	$448, $44C,  $4C, $444,	$440, $44C,  $4C, $44C,	 $4C, $44C, $448,  $48,	$44C,  $4C, $444, $44C,	$448, $44C, $448, $44C,	$448, $44C, $444, $448,	$4CC, $44C, $44C, $44C,	$44C,  $48, $44C, $44C,	$44C, $444, $448, $44C,	$440, $44C, $444, $448,	$44C, $44C, $44C, $44C,	 $44, $44C, $44C, $44C,	 $4C, $44C, $44C, $448,	$440, $44C, $44C,  $4C,	$448, $448, $44C, $448,	 $48; 20416
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 20480
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 20544
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 20608
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 20672
		dc.w $8094,$8094,$8094,$8094,$8094,$8094,$8094,$8090,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8090,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$A094,$8094,$8094,$8090,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094; 20736
		dc.w $8494,$80D4,$8094,	 $D4,  $D4,$8094,$80D4,$8094,$80D4,$80D4,$80D4,$80D4,$80D4,$80D4,$8094,$80D4,$80D4,$80D4,$80D4,$80D4,$8094,$8094,  $D4,$8094,  $D4,$80D4,  $D4,$80D4,$80D4,$80D4,  $94,$80D4,  $D4,$80D4,$80D4,$8094,$80D4,$80D4,$80D4,$80D4,$8094,$80D4,$8094,	 $D4,$80D4,$80D4,$80D4,$8094,  $D4,$80D4,$80D4,$80D4,$80D4,$80D4,$8094,$80D4,$80D4,$80D4,$80D4,$8094,$8094,$8094,$80D4,$8094; 20800
		dc.w $8094,$8094,$8090,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,$8094,  $94,$8094,$8094,$8094,$8094,$8090,$8094,$8094,$8094,	 $94,$8094,  $90,$8094,$8094,$8094,$8094,  $94,$8094,$8094,$8094,$8094,$8094,$8090,$8094,$8094,$8094,$8090,$8094,$8094,$8094,$8094,$8090,$8094,$8094,$8094,$8094,  $94,$8094,$8090,$8094,$8094,$8094; 20864
		dc.w $8094,  $D4,$80D4,$80D4,$80D4,$80D4,$84D4,$80D4,$80D4,$80D4,$80D4,	 $D4,$80D4, $4D4,  $D4,$80D4,$80D4,  $D4,$80D4,$80D4,$84D4,  $D4,$80D4,$80D4,$80D4,$80D4,$80D4,$80D4,$84D4,  $D4,$8494,$80D4,  $D4,$80D4,  $D4,$80D4, $4D4,$84D4,$8094,$80D4,$80D4,  $D4, $494,	$4D4,$84D4,$80D4,$8094,$8094, $4D4,  $D4,  $D4,	 $D4,  $D4,$80D4,$80D4,$84D4,  $D4,  $D4,$80D4,$8094,$8094,$80D4,$80D4,$80D4; 20928
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 20992
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 21056
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 21120
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 21184
		dc.w $889B,$889B,$809B,$809B, $28B,  $9B,$809B,	 $9B,$809B,  $9B,  $9B,$809B,  $9B, $29B,  $9B,$809B, $29B,$809B,$809B,$829B,$808B,  $9B,$809B,	 $9B,$809B,  $9B,  $9B,	 $9B, $29B,$829B,  $9B,	 $9B,  $9B,  $9B,  $9B,	 $9B,$8A9B,$809B,  $9B,	 $9B, $29B, $28B,  $9B,$829B,$809B,  $9B,$809B,$809B,  $9B,  $9B,$808B,	$29B,  $9B, $29B,$829B,	$29B, $29B,$829B,$829B,$809B,  $9B,$809B,  $9B,	$28B; 21248
		dc.w   $99, $499,  $99,	 $99,  $9B, $499,  $9B,	$499,  $9B,  $99, $499,	$49B, $499,  $9B, $499,	 $9B, $499, $499, $49B,	$499,  $9B, $49B,  $99,	$49B,  $9B,  $9B, $49B,	$49B,$809B, $499,  $99,	 $9B,  $9B,  $9B,  $99,$809B, $499,  $99,  $99,	 $9B,  $9B,  $9B,$809B,	 $9B,  $99, $499, $49B,	 $99,  $9B,$8099,  $9B,	 $9B,  $99,  $9B, $49B,	 $99, $49B,  $99, $49B,	 $99,  $9B,  $9B,  $99,	 $9B; 21312
		dc.w   $9B,  $9B, $29B,	 $9B,  $9B,  $9B,$829B,	 $9B,  $9B,  $9B, $29B,	$29B,  $9B,$889B,  $9B,	 $9B, $29B,  $9B, $A9B,	$29B,$829B, $A9B, $A9B,	$89B, $89B, $A9B, $A9B,$809B, $29B, $89B, $89B,	 $9B, $29B, $29B,$8A9B,	 $9B, $89B, $29B, $29B,	$29B, $29B,$829B, $A9B,	 $9B, $29B, $A9B, $29B,	$29B,$829B, $A9B, $29B,	$A9B, $A9B, $A9B, $29B,	$29B, $89B,  $9A, $29B,	$29B, $A9B,  $9B,$829B,	$A9B; 21376
		dc.w   $99,  $99, $49B,	$49B,  $9B, $491, $499,	$49B, $49B, $499,  $99,	$491,$8099, $499, $49B,	$499, $49B, $499, $499,	$49B, $499, $49B, $49B,	 $9B, $49B, $499,  $99,	$499, $499, $49B, $493,	$49B, $499,  $9B, $499,	$49B,  $93, $499, $49B,	$49B, $49B, $49B, $49B,	$49B, $49B, $499, $499,	$49B, $49B,  $9B, $49B,	$49B, $49B,  $9B, $49B,	$493, $49B, $49B, $49B,	$49B, $499, $499, $49B,	 $9B; 21440
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 21504
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 21568
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 21632
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 21696
		dc.w $22BD,$229D,$2299,$2299,$229D,$229D,$229D,$229D,$2299,$229D,$2299,$229D,$2299,$229D,$229D,$229D,$229D,$2299,$228D,$229D,$229D,$229D,$229D,$229D,$2299,$229D,$229D,$229D,$229D,$2299,$229D,$229D,$229D,$229D,$2299,$2299,$229D,$2299,$229D,$2299,$228D,$229D,$229D,$229D,$229D,$229D,$229D,$229D,$2299,$2299,$229D,$229D,$229D,$229D,$229D,$229D,$2299,$229D,$2299,$229D,$229D,$229D,$229D,$229D; 21760
		dc.w  $39D, $39D, $39D,	$39D, $39D, $39D, $39D,	$39D, $39D, $39D, $39D,	$39D, $39D, $39D, $39D,	$39D, $39D, $19D, $39D,	$39D, $39D, $39D, $395,	$39D, $39D, $39D, $39D,	$39D, $39D, $39D, $39D,	$19D, $39D, $39D, $39D,	$39D, $39D, $39D, $39D,	$39D, $39D, $39D, $39D,	$39D, $39D, $39D, $39D,	$39D, $39D, $39D, $39D,	$39D, $39D, $39D, $39D,	$39D, $39D, $39D, $39D,	$39D, $39D, $39D, $39D,	$39D; 21824
		dc.w  $299, $299,$2299,$229D,$229D, $29D,$2299,	$29D,$2299,$229D, $29D,$229D, $29D,$2299,$229D,$2299,$229D,$229D,$229D,$2299,$229D, $299,$2299,$2299,$2299,$2299,$229D,$2299, $299, $29D, $29D,$229D,$2299,$229D,$2299,	$29D, $299,$2299,$229D,$229D,$2299,$229D,$22B9,$229D, $29D,$229D,$229D,	$299,$229D, $299, $29D,$2299,$229D,$2299, $29D,$2299, $29D,$2299,$229D,$229D,$229D,$2299,$229D,	$29D; 21888
		dc.w  $39D, $39D, $39D,	$39D, $39D, $39D, $39D,	$39D, $39D, $39D, $39D,	$39D, $39D, $395, $39D,	$39D, $39D, $39D, $39D,	$39D, $39D, $39D, $39D,	$39D, $39D, $39D, $39D,	$39D, $39D, $39D, $39D,	$39D, $39D, $395, $39D,	$39D, $39D, $39D, $39D,	$39D, $39D, $39D, $39D,	$39D, $39D, $39D, $39D,	$39D, $39D, $39D, $39D,	$39D, $395, $395, $39D,	$39D, $39D, $39D, $39D,	$39D, $39D, $39D, $39D,	$395; 21952
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 22016
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 22080
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 22144
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 22208
		dc.w $20AA,$28AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$28AA,$20AA,$20AA,$20AA,$28AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$28AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA; 22272
		dc.w $11A9,$11A9,$11A9,$11A9,$10A9,$11AB,$10A9,$30A1,$10A9,$10A1,$10A3,$10AB,$11A9,$10A9,$10A9,$11A9,$11A1,$11AB,$11AB,$11A9,$11AB,$30A1,$11A9,$10A3,$11A3,$11AB,$10AB,$10A3,$11A9,$10A9,$118B,$10A1,$11AB,$10AB,$10A9,$31AB,$11A1,$10AB,$11A1,$108B,$10A9,$10AB,$11A1,$10AB,$10A1,$10A1,$11AB,$10A9,$10A3,$31A1,$11AB,$11A9,$10A1,$11AB,$11A9,$11AB,$10A1,$10AB,$10A9,$10A9,$11AB,$10A9,$10A9,	 $A9; 22336
		dc.w $20AA,$10AA,$20AA,$20AA,$20AA,$20AA,$28AA,$20AA,$20AA,$20A2,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$20AA,$28AA,$28AA,$28AA,$28AA,$20AA,$20AA,$20AA,  $AA,$20AA,$20AA,$20AA,$20AA,$28AA,$20AA,$28AA,$28AA,$20AA,$28AA,$20AA,$28AA,$20AA,$20AA,$28AA,$28AA,$28AA,$20AA,$28AA,$20AA,$20AA,$20AA,$20AA,$28AA,$20AA,$28AA,$20AA,$20AA,$20AA,$28AA,$20AA,$28AA,$20AA,$20AA,$20A2; 22400
		dc.w   $89,$11A9,$11A9,$11A9,$11A9,$11A9,$11AB,	$1AB,$11A9,$11A9,$11A9,$11AB, $1A9, $1A9,$11AB,$11AB,$10AB,$11AB,$11A9,$11AB,$11AB,$11A9,$11A9,$11AB,$10AB, $1AB,$11AB,$11A9,$11A9,$11A1, $1A9,$11A9,$11AB,$11A9,$11AB,$11AB,$11AB,$11AB,$11A9,$11A9,$11AB,$11AB,$11AB,$11AB,$11A9,$11A9,$11AB,$11AB,$11A9,  $A1, $1A9,$11A9,$11A1, $1AB,$11A9,	$1A9,$11A9,$11A9,$11AB,	$1AB,$11AB,$11AB,$11A9,	$1AB; 22464
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 22528
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 22592
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 22656
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 22720
		dc.w $8084,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$A080,$8080,$8080,$8080,$8080,$8080,$8080,$A080,$8080,$8080,$8080,$8080,$8080,$8080,$A080,$8080,$8080,$8080,$8080,$8080,$8080,$A080,$8080,$8080,$8080,$8080,$8080,$8080,$A080,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080; 22784
		dc.w $C185,$8185,$8185,$8185,$8185,$8185,$8185,$C185,$8185,$8185,$C185,$8185,$8185,$C185,$C185,$C185,$8185,$C185,$8185,$8185,$C185,$C185,$8185,$C185, $185,$8185,$8185,$8185,$C185,$8185,$8185,$C185,$C185,$8185,$8185,$C185,$8185,$8185,$C185,$C185,$8185,$8185,$C185,$8185,$8185,$8185,$8185,$8185,$8185,$C185,$8185,$8185,$8185,$8185,$8185,$8185,$C185,$8185,$8185,$8185,$8185,$8185,$8185,$C185; 22848
		dc.w   $80,$8080,$8080,	 $80,  $80,  $80,$8080,	 $80,  $80,$8080,  $80,	 $80,$8080,$8080,  $80,$8080,  $80,  $80,  $80,$8080,$8080,  $80,$8080,	 $80,  $81,  $80,  $80,$8080,  $80,$8080,  $80,$8080, $880,  $80,$8080,$8080,  $80,  $80,  $80,	 $80,$8080,$8080,$8080,	 $80,  $80,  $80,  $80,$8080,$8080,  $80,  $80,	 $80,  $81,$8080,  $80,$8080,$8080,$8080,  $80,$8080,  $80,$8080,$8080,	 $80; 22912
		dc.w $8185,$8185,$8185,$8185,$8185,$C185,$8185,$8185,$8185,$8185,$8185,$8185,$8185,$8185,$8185,$8185,$8185,$8185,$8185,$8185,$8185,$8185,$8185,$8185,$8185,$8185,$C185,$8185,$8185,$8185,$8185,$8185,$8185,$C185,$8185,$8185,$8185,$8185,$8185,$8185,$C185,$8185,$8185,$8185,$8185,$8185,$8185,$8185,$8185,$8185,$8185,$8185,$8185,$8185,$8185,$8185,$8185,$8185,$8185,$8185,$8185,$C185,$8185,$8185; 22976
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 23040
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 23104
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 23168
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 23232
		dc.w $C88A,$C883,$C882,$A882,$8882,$8882,$8082,$8082,$C883,$8882,$8882,$8882,$8883,$8882,$8882,$A882,$8882,$8882,$8883,$8883,$8880,$8882,$A880,$8882,$8882,$8882,$8882,$8882,$8082,$E883,$8882,$8880,$8882,$8883,$8883,$8882,$E882,$8882,$A882,$8882,$8883,$8880,$8882,$E882,$8882,$8882,$8082,$8883,$8882,$8882,$E083,$8882,$8082,$8882,$8883,$8882,$8882,$E880,$8882,$8082,$8882,$8882,$8883,$8082; 23296
		dc.w $D8C1,$D841,$D8C1,$D8C1,$C8C1,$D081,$C8C1,$D0C1,$D8C1,$D0C1,$D8C1,$D8C1,$D8C1,$D8C1,$D8C1,$D0C1,$D8C1,$D881,$D8C1,$D8C1,$D8C1,$D8C1,$D0C1,$D8C1,$D8C1,$D8C1,$D0C1,$D8C1,$D8C1,$D8C1,$D8C1,$D8C1,$D8C1,$D8C1,$C0C1,$D8C1,$D8C1,$D841,$D8C1,$D841,$D8C1,$D8C1,$D8C1,$D8C1,$D8C1,$D8C1,$D8C1,$C8C1,$D8C1,$D841,$D8C1,$D8C1,$D8C1,$D8C1,$D8C1,$D8C1,$D8C1,$D8C1,$C8C1,$D8C1,$C8C1,$C8C1,$C8C1,$D8C1; 23360
		dc.w $8882,$C082,$8080,$8882,$8082,$8882,$A883,$8882,$8882,$8882,$8883,$8082,$8882,$8882,$8082,$8882,$8882,$8082,$8882,$8882,$A883,$8882,$8882,$8882,$8883,$8882,$8882,$A882,$8880,$8882,$8882,$8882,$8882,$8882,$8882,$8882,$8882,$8882,$8883,$8882,$8882,$A882,$8882,$8880,$8882, $882,$8880,$8882,$A882,$8882,$8882,$8882,$8882,$8882,$8882,$A880,$8882,$8882,$8882,$8882,$8882,$8882,$8883,$8882; 23424
		dc.w $C8C1,$C8C1,$C0C1,$C8C1,$D8C1,$D8C1,$C8C1,$C8C1,$D8C1,$C8C1,$C8C1,$C8C1,$D8C1,$D8C1,$C8C1,$C8C1,$C8C1,$C8C1,$C8C1,$D8C1,$C0C1,$C8C1,$D8C1,$C8C1,$D8C1,$C8C1,$D0C1,$D8C1,$C8C1,$C8C1,$D8C1,$C8C1,$D8C1,$D8C1,$C8C1,$D8C1,$C8C1,$C8C1,$C8C1,$C0C1,$D8C1,$C8C1,$C0C1,$D8C1,$C8C1,$D8C1,$C8C1,$D8C1,$D8C1,$D8C1,$C8C1,$D8C1,$C8C1,$C8C1,$D8C1,$D8C1,$C8C1,$D8C1,$D0C1,$C8C1,$C8C1,$D8C1,$C8C1,$C8C1; 23488
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 23552
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 23616
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 23680
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 23744
		dc.w  $180,$2100, $100,	$180, $100, $100, $100,	$100,$2300, $100, $100,	$100, $100, $100, $100,$2100, $100, $100, $100,	$100, $100, $100,$2300,	$100, $100, $100, $300,	$100, $100,$2100,$2100,$2100, $100, $100, $300,	$100,$2100, $100,$2100,	$100, $100, $100, $100,$2100, $100, $100, $300,	$100, $100, $100,$2100,	$100, $100, $100, $100,	$300, $100,$2300, $100,	$100, $100, $100, $300,	$100; 23808
		dc.w  $100, $100, $100,	$100, $100, $100, $100,	$100, $100, $100, $100,	$100, $100, $100, $100,	$100, $100, $100, $100,	$100, $100, $100, $100,	$100, $100, $100, $100,	$100, $100, $100, $100,	$100, $100, $100, $100,	$100, $100, $100, $100,	$100, $100, $100, $100,	$100, $100, $100, $100,	$100, $100, $100, $100,	$100, $100, $100, $100,	$100, $100, $100, $100,	$100, $100, $100, $100,	$100; 23872
		dc.w  $100, $100, $100,	$100, $300, $100, $100,	$100, $100, $100, $100,	$300, $100, $100, $100,	$100, $100, $100, $100,	$100,$2100, $100, $100,	$300, $100, $100, $100,	$100, $100, $300, $300,	$300, $100, $100, $300,	$100, $300, $100, $100,	$100, $100, $300, $100,	$100, $100, $100, $100,	$300, $100, $100, $300,	$300, $100, $100, $100,$2100, $300, $300, $100,	$100, $100, $100, $300,	$300; 23936
		dc.w  $100, $100, $100,	$100, $100, $100, $100,	$100, $100, $100, $100,	$100, $100, $100, $100,	$100, $100, $100, $100,	$100, $100, $100, $100,	$100, $100, $100, $100,	$100, $100, $100, $100,	$100, $100, $100, $100,	$100, $100, $100, $100,	$100, $100, $100, $100,	$100, $100, $100, $100,	$100, $100, $100, $100,	$100, $100, $100, $100,	$100, $100, $100, $100,	$100, $100, $100, $100,	$100; 24000
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 24064
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 24128
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 24192
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 24256
		dc.w	$A,$800A,   $A,	  $A,	 2,   $A,    2,	   2,	$A,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	  $A,	 2,    2,$800A,	   2,	 2,    2,   $A,	   2,	 2,    2,    2,	   2,	 2,   $A,    2,	   2,	 2,    2,   $A,	   2,	$A,    2,    2,	   2,	 2,    2,    2,	  $A,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2; 24320
		dc.w   $14,  $14,  $14,	 $14,  $14,  $14,  $14,	 $10,  $14,  $14,  $14,	 $14,  $14,  $14,  $14,	 $14,  $10,  $14,  $14,	 $14,  $14,  $14,  $14,	 $14,  $14,  $14,  $14,	 $14,  $14,  $14,  $14,	 $14,  $1C,  $14,  $14,	 $14,  $14,  $10,  $14,	 $14,  $14,  $14,  $14,	 $14,  $14,  $14,  $14,	 $14,  $14,  $14,  $14,	 $14,  $14,  $14,  $14,	 $14,  $14,  $14,  $14,	 $14,  $14,  $14,  $14,	 $14; 24384
		dc.w	 2,    2,    2,	  $A,	 2,    2,   $A,	   2,	$A,    2,   $A,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	$A,    2,    2,	   2,	$A,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,   $A,	   2,	 2,    2,    2,	   2,	 2,   $A,    2,	   2,	 2,    2,    2,	   2,	$A,    2,    2,	  $A,	 2,    2,    2,	  $A,	 2,    2,    2,	   2; 24448
		dc.w   $14,  $14,  $14,	 $14,  $14,  $14,  $14,	 $14,  $14,  $14,  $14,	 $14,  $14,  $14,  $14,	 $14,  $14,  $14,  $14,	 $14,  $14,  $14,  $14,	 $14,  $14,  $14,  $14,	 $14,  $14,  $14,  $14,	 $14,  $14,  $14,  $14,	 $14,  $14,  $14,  $14,	 $14,  $14,  $14,  $14,	 $14,  $14,  $14,  $14,	 $14,  $14,  $14,  $14,	 $14,  $14,  $14,  $14,	 $14,  $14,  $14,  $14,	 $14,  $14,  $14,  $14,	 $14; 24512
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 24576
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 24640
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 24704
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 24768
		dc.w   $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80; 24832
		dc.w   $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $81,  $80,	 $80,  $81,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $81,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $81,  $81,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $81,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80; 24896
		dc.w   $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80; 24960
		dc.w   $80,  $80,  $81,	 $80,  $80,  $80,  $80,	 $80,  $80,  $81,  $80,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $80,	 $80,  $81,  $80,  $81,	 $80,  $80,  $80,  $80,	 $80,  $80,  $81,  $80,	 $80,  $81,  $80,  $81,	 $80,  $80,  $80,  $81,	 $80,  $80,  $81,  $80,	 $80,	 0,  $80,  $80,	 $81,  $81,  $80,  $80,	 $80,  $81,  $80,  $80,	 $80,  $80,  $80,  $81,	 $80,  $80,  $80,  $80,	 $80; 25024
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 25088
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 25152
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 25216
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 25280
		dc.w $CCC8,$CC48,$CC40,$CC40,$CC40,$CC48,$CC40,$C848,$CC40,$CC40,$CC40,$CC40,$CC40,$CC48,$CC40,$CC40,$CC40,$CC40,$CC48,$CC40,$4C40,$4C40,$CC40,$CC40,$CC40,$CC40,$CC40,$CC40,$CC40,$CC40,$CC40,$CC40,$CC48,$CC48,$4C40,$C848,$CC40,$C840,$CC40,$8C40,$CC48,$4C40,$CC40,$CC48,$CC40,$CC40,$CC40,$CC40,$CC40,$CC40,$CC48,$C840,$CC40,$C840,$CC48,$CC40,$CC48,$CC40,$C840,$CC40,$CC40,$C840,$CC40,$CC40; 25344
		dc.w $4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4440,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40; 25408
		dc.w $CC40,$4C40,$CC40,$4C48,$4C40,$CC40,$CC40,$4C40,$CC40,$CC48,$CC48,$4C40,$4C40,$CC40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$CC40,$4C40,$CC40,$4C40,$4C48,$4C40,$4C40,$CC40,$4C40,$4C40, $C40,$CC40,$4C48,$4C40,$CC48,$4C40,$4C40,$4C40,$4C48,$4C40,$4C40,$CC40,$CC48,$4C40,$CC40,$4C48,$4C48,$4C40,$C840,$CC40,$4C40,$CC40,$4C40,$4C40,$4C40,$CC40,$4C40,$CC40,$4C40,$4C40, $C40,$CC40,$CC40,$4C40; 25472
		dc.w $4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40,$4C40; 25536
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 25600
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 25664
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 25728
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 25792
		dc.w $8888,$8A80,$8280,$8880,$8080,$8A80,$8880,$8080,$8280,$8880,$8880,$8880,$8880,$8080,$8880,$8A80,$8080,$8880,$8880,$8280,$8A80,$8280,$8A80,$8080,$8880,$8080,$8280,$8880,$8880,$8A80,$8080,$8880,$8880,$8880,$8880,$8880,$8A80,$8880,$8880,$8080,$8880,$8880,$8880,$8A80,$8A80,$8080,$8A80,$8080,$8880,$8880,$8A80,$8880,$8080,$8880,$8080,$8A80,$8080,$8A80,$8880,$8880,$8880,$8880,$8080,$8080; 25856
		dc.w $8080,$8080,$8080,$8880,$8880,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$9080,$8080,$8080,$8080,$8080,$8880,$8880,$8880,$8080,$8880,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8880,$8880,$8080,$8880,$8080,$8880,$8080,$8880,$8080,$8880,$8080,$8080,$8080,$8080,$8880,$8080,$8080,$8080,$8080,$8080,$8880,$8880,$8080,$8880,$8080,$8080,$8880,$8880,$8080,$8080,$8080,$8080; 25920
		dc.w $8880,$8080,$8080,$8080,$8080,$8880,$8A80,$8280,$8080,$8880,$8880,$8080,$8880,$8280,$8A80,$8080,$8880,$8880,$8A80,$8A80,$8280,$8A80,$8A80,$8A80,$8A80,$8280,$8A80,$8A80,$8A80,$8A80,$8A80,$8A80,$8A80,$8A80,$8A80,$8A80,$8A80,$8A80,$8880,$8A80,$8A80,$8280,$8A80,$8A80,$8A80,$8A80,$8880,$8A80,$8A80,$8A80,$8A80,$8A80,$8A80,$8A80,$8880,$8A80,$8280,$8A80,$8A80,$8280,$8880,$8A80,$8A80,$8A80; 25984
		dc.w $8880,$8880,$8880,$8880,$8080,$8080,$8880,$8880,$8080,$8880,$8880,$8880,$8080,$8C80,$8880,$8080,$8080,$8880,$8880,$8880,$8880,$8080,$8880,$8880,$8880,$8080,$8880,$8880,$8080,$8880,$8080,$8880,$8880,$8880,$8880,$8880,$8080,$8C80,$8080,$8480,$8080,$8080,$8080,$8880,$8080,$8800,$8080,$8880,$8880,$8080,$8880,$8080,$8080,$8080,$8080,$8480,$8080,$8080,$8080,$8080,$8080,$8880,$8880,$8080; 26048
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 26112
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 26176
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 26240
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 26304
		dc.w $CC08,$CC08,$4C08,$4C08,$4808,$4808,$4C08,$4C08,$CC08,$4C08,$4C08,$4808,$4C08,$4C08,$4C08,$4C08,$4C08,$4808,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4808,$4408,$4C08,$4808,$4808,$CC08,$4C08,$4808,$4808,$4C08,$4C08,$4C08,$CC08,$4C08,$4808,$4C08,$4C08,$4C08,$4808,$4C08,$4808,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4808,$4808,$4C08,$CC08,$4C08,$4808,$4C08,$4C08,$4C08,$4C08; 26368
		dc.w $4C08,$4C48,$4C08,$4C08,$4C08,$4C08,$4408,$4C08,$4C48,$4C48,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C48,$4C08,$4C08,$4C48,$4C08,$4C08,$4C08,$4C48,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C48,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08; 26432
		dc.w $4C08,$4C08,$4808,$4808,$4C08,$4C08,$4C08,$4C08,$4808,$4C08,$4C08,$4808,$4808,$4C08,$4C08,$4808,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4808,$4C08,$4C08,$4C08,$4C08,$4808,$4C08,$4C08,$4C08, $C08,$4C08,$4C08,$4808,$4C08,$4408,$4C08,$4C08,$4C08,$4808,$4C08,$4C08,$4808,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08, $C08,$4C08,$4C08,$4C08,$4C08,$4C08; 26496
		dc.w $4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C48,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C48,$4C08,$4C08,$4C08,$4C08,$4408,$4C08,$4C48,$4C08,$4C08,$4C48,$4C08,$4C08,$4C08,$4C48,$4C48,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4408,$4C08,$4C08,$4C08,$4C48,$4C08,$4C48,$4C08,$4C08,$4C08,$4C08,$4C08,$4C08,$4C48,$4C08,$4C08,$4C08,$4C08,$4C48,$4C08; 26560
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 26624
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 26688
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 26752
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 26816
		dc.w $8088,$8088,  $88,	 $88,  $88,  $88,  $80,	 $88,$8080,  $88,  $80,	 $80,  $88,  $88,  $88,$8080,  $80,  $80,  $80,	 $88,  $80,  $88,$8088,	 $88,  $80,  $80,  $88,	 $88,  $88,$8080,  $88,	 $80,  $80,  $88,  $88,	 $88,$8080,  $80,  $80,	 $88,  $88,  $80,  $88,$8088,  $80,  $88,  $80,	 $88,  $80,  $80,$8080,	 $80,  $80,  $80,  $88,	 $80,  $88,$8080,  $80,	 $80,  $88,  $88,  $88,	 $80; 26880
		dc.w   $80,  $88,  $88,	 $88,  $88,  $80,  $88,	 $80,  $88,  $80,  $80,	 $88,  $88,  $88,  $88,	 $88,  $80,  $88,  $89,	 $88,  $88,  $88,  $88,	 $88,  $80,  $81,  $80,	 $88,  $88,  $88,  $80,	 $88,  $88,  $88,  $88,	 $88,  $80,  $88,  $80,	 $88,  $88,  $88,  $88,	 $88,  $80,  $80,  $89,	 $88,  $80,  $80,  $88,	 $88,  $88,  $88,  $88,	 $80,  $88,  $88,  $80,	 $80,  $88,  $80,  $88,	 $80; 26944
		dc.w   $88,  $80,  $80,	 $88,  $88,  $80,  $88,	 $80,  $88,  $80,  $88,	 $88,  $88,  $88,  $80,	 $80,  $80,  $88,  $88,	 $80,  $80,  $80,  $80,	 $80,  $80,  $80,  $88,	 $80,  $80,  $80,  $80,	 $88,  $88,  $80,  $88,	 $80,  $80,  $88,  $88,	 $80,  $80,  $80,  $80,	 $80,  $80,  $88,  $80,	 $80,  $88,  $80,  $80,	 $80,  $88,  $88,  $88,	 $80,  $80,  $88,  $80,	 $88,  $80,  $88,  $88,	 $80; 27008
		dc.w   $88,  $88,  $88,	 $88,  $88,  $80,  $80,	 $88,  $88,  $88,  $88,	 $88,  $88,  $88,  $88,	 $80,  $88,  $80,  $88,	 $88,  $88,  $88,  $88,	 $88,  $88,  $88,  $80,	 $88,  $80,  $88,  $88,	 $80,  $88,  $88,  $88,	 $88,  $88,  $89,  $88,	 $88,  $80,  $88,  $88,	 $80,  $88,  $88,  $80,	 $88,  $88,  $88,  $88,	 $88,  $80,  $88,  $88,	 $88,  $80,  $80,  $88,	 $88,  $80,  $88,  $88,	 $80; 27072
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 27136
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 27200
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 27264
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 27328
		dc.w  $CC2, $CC2, $C82,	$C82, $C02, $402, $C02,	$C82, $C02, $CC2, $C82,	$C02, $C02, $482, $C02,	$C02, $C02, $C02, $C42,	$C82, $C02, $C02, $C02,	$C82, $C02, $C02, $C02,	$C02, $C02, $C02, $C82,	$C02, $C02, $C82, $C02,	$C02, $C02, $CC2, $C02,	$C82, $C02, $C02, $C02,	$C02, $C02, $C02, $C02,	$C82, $C02, $C02, $C02,	$C82, $C02, $C02, $C02,	$C02, $C02, $C02, $C02,	$C02, $C02, $C02, $C02,	$C02; 27392
		dc.w $4C43, $C53, $C53,	$C43, $C53, $C43, $C53,	$C53, $CD3, $C43, $C53,	$C43, $C53, $C53, $C53,$4C53, $C53, $C53, $C53,	$C43, $C53,$4C43, $CD3,	$C53, $C53, $C53, $C53,	$C53,$4C53, $C53, $C53,	$C43, $C53, $C43, $C53,$4C53, $C53, $C53, $C53,	$C43, $C43, $C53, $C53,	$CD3, $C43, $C43, $C53,	$C53, $443, $C53, $C53,	$C53, $C53, $C53, $C53,	$C53, $C53, $C53, $C53,	$C43, $C53, $C43, $C53,	$C43; 27456
		dc.w  $CC2, $C02, $802,	$C82, $C02, $C02, $C02,	$C02, $C02, $C02, $C02,	$C82, $C02, $C02, $C82,	$C02, $C02, $C82, $C02,	$C02, $C82, $C82, $C02,	$C82, $C02, $C02, $C02,	$C02, $CC2, $C02, $C02,	$C02, $C02, $C02, $C02,	$C82, $C02, $C42, $C02,	$C02, $C02, $C02, $C02,	$C02, $C02, $C02, $C02,	$C02, $C02, $C02, $C82,	$C02, $C02, $C02, $C02,	$C82, $C02, $C02, $C42,	$C02, $C02, $C02, $C02,	$C02; 27520
		dc.w  $C43, $C43, $C43,	$CD3, $C53, $C53, $CD3,	$C53, $CD3, $C53, $C53,	$C53, $CC3, $CD3, $C43,	$CD3, $C53, $C53, $C53,	$C53, $CC3, $C53, $C53,	$CD3, $C43, $CD3, $C53,	$CC3, $C53, $C43, $C43,	$C43, $CD3, $C53, $C53,	$CD3, $C53, $CD3, $C43,	$CD3, $C53, $C43, $C53,	$C53, $C53, $C53, $C53,	$C43, $CD3, $CC3, $C53,	$C53, $C53, $CD3, $C43,	$CD3, $4D3, $C53, $CD3,	$C43, $C53, $C53, $CD3,	$C53; 27584
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 27648
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 27712
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 27776
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 27840
		dc.w $8080,$8000,$8000,	   0,	 0,    0,    0,	   0,$8000,    0,    0,	   0,	 0,    0,    0,$8000,	 0,    0,    0,	   0,	 0,    0,$8000,	   0,	 0,    0,    0,	   0,	 0,$8000,    0,	   0,	 0,    0,    0,	   0,$8000,    0,    0,	   0,	 0,    0,    0,$8000,	 0,    0,    0,	   0,	 0,    0,$8000,	   0,	 0,    0,    0,	   0,	 0,$8000,    0,	   0,	 0,    0,    0,	   0; 27904
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 27968
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,$8000,	 0, $800,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,$8000,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 28032
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 28096
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 28160
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 28224
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 28288
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 28352
		dc.w $C084,$C004,$8080,$8080,$8084,$8080,$8004,$C000,$C000,$8080,$8080,$8080,$8000,$8084,$8000,$C080,$8000,$C080,$C000,$C004,$8000,$C000,$C000,$8080,$8000,$8080,$8080,$C004,$8000,$C080,$C080,$C000,$8080,$C004,$8000,$C080,$C000,$8080,$8000,$8004,$8080,$C000,$8080,$C004,$C080,$8080,$C000,$8084,$8000,$8080,$C000,$8080,$8080,$8000,$8004,$8000,$8080,$C000,$8080,$8080,$8000,$8084,$8080,$8000; 28416
		dc.w $C004,$C000,$C004,$C004,$C004,$C000,$C004,$C000,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C000,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C000,$C004,$C004,$C004,$C004,$C004,$C004,$8004,$8004,$C004,$C004,$C000,$C004; 28480
		dc.w $8080,$8080,$8080,$8084,$C080,$8080,$8080,$8080,$8084,$8084,$8084,$8004,$8080,$8004,$8080,$8080,$8084,$8080,$8080,$C000,$8080,$8080,$8080,$8080,$8084,$C080,$C080,$8084,$8080,$C080,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$C080,$8080,$8080,$8080,$8080,$8084,$8080,$8080,$8080,$8080,$8080,$8080,$8080,$C080,$8080,$8080,$8000,$8080,$8080,$8080,$8080,$8000,$C080,$8080; 28544
		dc.w $8000,$C004,$C004,$8004,$8004,$C000,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$8084,$C000,$C004,$8004,$C004,$C000,$C004,$8004,$8004,$8004,$8004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$C000,$C004,$C004,$C004,$C004,$C004,$C004,$C004,$8004,$C004,$C004,$C004,$8004,$C004,$C004,$C084,$8004,$C004,$C004,$C004,$C004,$C084,$8004; 28608
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 28672
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 28736
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 28800
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 28864
		dc.w	$A,    2,    0,	   0,	 2,    2,    2,	   0,	 2,    2,    2,	   0,	 2,    0,    0,	   0,	 0,    0,    2,	   2,	 2,    2,$8002,	   0,	 0,    0,    2,	   2,	 2,    0,    2,	   0,	 0,    2,    2,	   2,	 0,    0,    0,	   2,	 2,    2,    0,	   2,	 0,    0,    2,	   2,	 0,    0,    2,	   2,	 0,    2,    2,	   2,	 2,    2,    2,	   2,	 2,    2,    2,	   0; 28928
		dc.w  $404, $404,    0,	   0,	 4,    0,    4,	   0,	 0,    4,    4,	   4,	 4,    4,    4,	   4,	 4,    4,    4,	   4,	 4,    0,    4,	   4,	 4,    4, $404,	   4,	 4,    0,    4,	   4,	 4,    4,    4,	   0, $400,    4,    4,	   4,	 4,    4,    0,	   4,	 4,    4,    4,	   4,	 4,    4,    4,	   4,	 4,    4,    4,	   4,	 4,    0,    4,	   4,	 4,    4,    0,	   4; 28992
		dc.w	 0,    0,    0,	   2,	 2,    0,    2,	   0,	 0,    0,    2,	   2,	 0,    2,    2,	   0,	 2,    2,    2,	   0,	 2,    0,    0,	   0,	 2,    2,    0,	   2,	 0,    0,    2,	   0,	 2,    0,    2,	   0,	 0,    2,    2,	   2,	 2,    0,    0,	   2,	 0,    2,    2,	   2,	 2,    0,    0,	   0,	 2,    2,    0,	   2,	 0,    0,    2,	   2,	 0,    0,    0,	   0; 29056
		dc.w  $400,    4,    4,	$400, $404, $404,    4,	   4,	 4,    4,    0,	$400, $404,    0, $404,	$400, $404, $404,    4,	$404, $404, $404,    4,	   4, $404,    4, $404,	   4, $404,    4, $404,	   0,	 4,    4, $404,	   4, $404,    4, $404,	   4,	 4, $404, $400,	$404, $404,    4,    4,	$400, $404,    0,    4,	$404, $404, $404, $404,	$400, $404, $404, $404,	$404,	 4,    4, $404,	   4; 29120
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 29184
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 29248
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 29312
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 29376
		dc.w  $840, $8C0, $840,	$8C0, $840, $840, $8C0,	$840, $840, $8C0, $800,	$840, $8C0, $840, $800,	$8C0, $840, $8C0, $840,	$8C0, $840, $8C0, $840,	$840, $8C0, $840, $8C0,	$840, $8C0, $880, $8C0,	$840, $8C0, $840, $880,	$840, $840, $8C0, $8C0,	$8C0, $840, $840, $880,	$840, $880, $800, $840,	$880, $840, $880, $8C0,	$8C0, $840, $800, $8C0,	$840, $840, $840, $840,	$8C0, $800, $8C0, $840,	$840; 29440
		dc.w  $840, $840, $840,	$840, $840, $8C0, $840,	$840, $840, $840, $840,	$840, $840, $840, $840,	$840, $840, $840, $840,	$840, $8C0, $8C0, $840,	$840, $8C0, $840, $840,	$840, $8C0, $840, $840,	$840, $840, $840, $840,	$840, $840, $840, $840,	$840, $840, $8C0, $840,	$840, $840, $840, $840,	$840, $840, $840, $840,	$840, $840, $840, $840,	$840, $840, $840, $840,	$840, $840, $840, $840,	$840; 29504
		dc.w  $880, $8C0, $8C0,	$800, $840, $8C0, $800,	$8C0, $8C0, $8C0, $8C0,	$8C0, $800, $840, $8C0,	$8C0, $8C0, $800, $8C0,	$800, $8C0, $880, $8C0,	$8C0, $880, $8C0, $8C0,	$880, $8C0, $8C0, $8C0,	$800, $880, $880, $8C0,	$8C0, $8C0, $880, $800,	$8C0, $8C0, $880, $8C0,	$8C0, $8C0, $840, $880,	$880, $8C0, $8C0, $8C0,	$880, $880, $840, $8C0,	$800, $8C0, $8C0, $880,	$840, $880, $800, $8C0,	$8C0; 29568
		dc.w  $840, $8C0, $840,	$840, $840, $840, $8C0,	$840, $840, $840, $840,	$840, $840, $8C0, $840,	$840, $840, $840, $840,	$840, $8C0, $840, $840,	$840, $840, $840, $840,	$840, $840, $840, $840,	$840, $840,  $40, $8C0,	$840, $840, $840, $840,	$8C0, $840, $840, $840,	$840, $840, $840, $840,	$840, $8C0, $840, $840,	$840, $840, $840, $840,	$8C0, $840, $840, $840,	$840, $840, $840, $CC0,	$840; 29632
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 29696
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 29760
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 29824
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 29888
		dc.w $88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$80C0,$88C0,$88C0,$80C0,$88C0,$C8C0,$88C0,$80C0,$88C0,$88C0,$80C0,$88C0,$8880,$88C0,$88C0,$80C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$80C0,$88C0,$88C0,$88C0,$8880,$80C0,$88C0,$88C0,$80C0,$88C0,$88C0,$80C0,$88C0,$88C0,$8880,$88C0; 29952
		dc.w $C8C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$C8C0,$88C0,$88C0,$88C0,$80C0,$88C0,$88C0,$C8C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$C8C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$C8C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$C8C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$C8C0,$88C0,$C8C0,$88C0,$88C0,$88C0,$88C0,$C8C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$C8C0; 30016
		dc.w $88C0,$88C0,$88C0,$88C0,$88C0,$80C0,$88C0,$88C0,$88C0,$8880,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$8880,$88C0,$88C0,$88C0,$8880,$88C0,$88C0,$88C0,$8880,$88C0,$88C0,$88C0,$8880,$88C0,$8880,$88C0,$88C0,$80C0,$88C0,$80C0,$8080,$8880,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$8880,$8880,$88C0,$88C0,$88C0,$80C0,$88C0,$88C0,$8880; 30080
		dc.w $88C0,$88C0,$88C0,$88C0,$88C0,$C8C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$C8C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$C8C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$C8C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$C8C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0,$88C0; 30144
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 30208
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 30272
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 30336
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 30400
		dc.w  $888, $888, $888,	$888, $888, $888, $888,	$888, $888, $888, $888,	$888, $888, $888, $888,	$888, $888, $888, $888,	$888, $888, $888, $888,	$888, $888, $888, $888,	$888, $888, $888, $888,	$888, $888, $888, $888,	$888, $888, $888, $888,	$888, $888, $888, $888,	$888, $888, $888, $888,	$888, $888, $888, $888,	$888, $888, $888, $888,	$888, $888, $888, $888,	$888, $888, $888, $888,	$888; 30464
		dc.w  $888, $889, $888,	$889, $889, $889, $889,	$888, $889, $889, $889,	$889, $889, $889, $889,	$889, $889, $889, $889,	$889, $889, $889, $889,	$889, $889, $889, $889,	$889, $889, $889, $889,	$889, $889, $889, $889,	$888, $888, $888, $889,	$889, $889, $889,$4888,	$889, $889, $888, $889,	$888, $888, $889, $889,	$888, $889, $889, $889,	$888, $888, $889, $889,	$889, $888, $889, $889,	$888; 30528
		dc.w  $888, $888, $888,	 $88, $888, $888, $888,	$888, $888, $888, $888,	$888, $888, $888, $888,	$888, $888, $888, $888,	$888, $888, $888, $888,	$888, $888, $888, $888,	$888, $888, $888, $888,	$888, $888, $888, $888,	$888, $888, $888, $888,	$888, $888, $888, $888,	$888, $888, $888, $888,	$888, $888, $888, $888,	$888, $888, $888, $888,	$888, $888, $888, $888,	$888, $888, $888, $888,	$888; 30592
		dc.w  $888, $889, $889,	$889, $889, $889, $889,	$888, $888, $889, $888,	$889, $889, $888, $889,	$888, $889, $889, $889,	$889, $889, $889, $889,	$889, $889, $C89, $888,	$889, $889, $889, $889,	$889, $888, $889, $C88,	$889, $889, $889, $889,	$889, $889, $889, $888,	$889, $889, $889, $889,	$889, $888, $888, $889,	$C89, $888, $888, $888,	$888, $888, $888, $889,	$889, $889, $888, $C89,	$889; 30656
ObjPos_Index:	dc.w ObjPos_GHZ1-ObjPos_Index,ObjPos_Null-ObjPos_Index;	0
					; DATA XREF: ROM:0000DC74o
					; ROM:ObjPos_Indexo ...
		dc.w ObjPos_GHZ2-ObjPos_Index,ObjPos_Null-ObjPos_Index;	2
		dc.w ObjPos_GHZ3-ObjPos_Index,ObjPos_Null-ObjPos_Index;	4
		dc.w ObjPos_GHZ1-ObjPos_Index,ObjPos_Null-ObjPos_Index;	6
		dc.w ObjPos_LZ1-ObjPos_Index,ObjPos_Null-ObjPos_Index; 8
		dc.w ObjPos_LZ2-ObjPos_Index,ObjPos_Null-ObjPos_Index; 10
		dc.w ObjPos_LZ3-ObjPos_Index,ObjPos_Null-ObjPos_Index; 12
		dc.w ObjPos_LZ3-ObjPos_Index,ObjPos_Null-ObjPos_Index; 14
		dc.w ObjPos_CPZ1-ObjPos_Index,ObjPos_Null-ObjPos_Index;	16
		dc.w ObjPos_CPZ2-ObjPos_Index,ObjPos_Null-ObjPos_Index;	18
		dc.w ObjPos_CPZ3-ObjPos_Index,ObjPos_Null-ObjPos_Index;	20
		dc.w ObjPos_CPZ1-ObjPos_Index,ObjPos_Null-ObjPos_Index;	22
		dc.w ObjPos_EHZ1-ObjPos_Index,ObjPos_Null-ObjPos_Index;	24
		dc.w ObjPos_EHZ2-ObjPos_Index,ObjPos_Null-ObjPos_Index;	26
		dc.w ObjPos_EHZ3-ObjPos_Index,ObjPos_Null-ObjPos_Index;	28
		dc.w ObjPos_EHZ1-ObjPos_Index,ObjPos_Null-ObjPos_Index;	30
		dc.w ObjPos_HPZ1-ObjPos_Index,ObjPos_Null-ObjPos_Index;	32
		dc.w ObjPos_HPZ2-ObjPos_Index,ObjPos_Null-ObjPos_Index;	34
		dc.w ObjPos_HPZ3-ObjPos_Index,ObjPos_Null-ObjPos_Index;	36
		dc.w ObjPos_HPZ1-ObjPos_Index,ObjPos_Null-ObjPos_Index;	38
		dc.w ObjPos_HTZ1-ObjPos_Index,ObjPos_Null-ObjPos_Index;	40
		dc.w ObjPos_HTZ2-ObjPos_Index,ObjPos_Null-ObjPos_Index;	42
		dc.w ObjPos_HTZ3-ObjPos_Index,ObjPos_Null-ObjPos_Index;	44
		dc.w ObjPos_HTZ1-ObjPos_Index,ObjPos_Null-ObjPos_Index;	46
		dc.w ObjPos_S1Ending-ObjPos_Index,ObjPos_Null-ObjPos_Index; 48
		dc.w ObjPos_S1Ending-ObjPos_Index,ObjPos_Null-ObjPos_Index; 50
		dc.w ObjPos_S1Ending-ObjPos_Index,ObjPos_Null-ObjPos_Index; 52
		dc.w ObjPos_S1Ending-ObjPos_Index,ObjPos_Null-ObjPos_Index; 54
		dc.w ObjPos_S1LZ1pf1-ObjPos_Index,ObjPos_S1LZ1pf2-ObjPos_Index;	56
		dc.w ObjPos_S1LZ2pf1-ObjPos_Index,ObjPos_S1LZ2pf2-ObjPos_Index;	58
		dc.w ObjPos_S1LZ3pf1-ObjPos_Index,ObjPos_S1LZ3pf2-ObjPos_Index;	60
		dc.w ObjPos_S1LZ1pf1-ObjPos_Index,ObjPos_S1LZ1pf2-ObjPos_Index;	62
		dc.w ObjPos_S1SBZ1pf1-ObjPos_Index,ObjPos_S1SBZ1pf2-ObjPos_Index; 64
		dc.w ObjPos_S1SBZ1pf3-ObjPos_Index,ObjPos_S1SBZ1pf4-ObjPos_Index; 66
		dc.w ObjPos_S1SBZ1pf5-ObjPos_Index,ObjPos_S1SBZ1pf6-ObjPos_Index; 68
		dc.w ObjPos_S1SBZ1pf1-ObjPos_Index,ObjPos_S1SBZ1pf2-ObjPos_Index; 70
		dc.w $FFFF,    0,    0	; 0
ObjPos_GHZ1:	dc.w  $248, $351,$A606	; 0 ; DATA XREF: ROM:ObjPos_Indexo
		dc.w  $334, $328,$4102	; 3
		dc.w  $340, $3AC,$C000	; 6
		dc.w  $420, $330,$A200	; 9
		dc.w  $430,$4378,$1C03	; 12
		dc.w  $4A0, $460,$AB00	; 15
		dc.w  $4A8, $388,$110C	; 18
		dc.w  $510, $378,$1C03	; 21
		dc.w  $5D6, $320,$A605	; 24
		dc.w  $8B0, $350,$9F00	; 27
		dc.w  $960, $2FA,$9F00	; 30
		dc.w  $9CD, $2FD,$3B00	; 33
		dc.w  $A30,$4308,$1C03	; 36
		dc.w  $A78, $400,$AB00	; 39
		dc.w  $AA8, $318,$110C	; 42
		dc.w  $AC8, $3C0,$AB00	; 45
		dc.w  $B10, $308,$1C03	; 48
		dc.w  $BA0, $2FE,$3B00	; 51
		dc.w  $C08, $2F8,$4400	; 54
		dc.w  $C50, $34C,$C000	; 57
		dc.w  $D08, $3B0,$4400	; 60
		dc.w  $D08, $3E0,$4401	; 63
		dc.w  $D28, $373,$3600	; 66
		dc.w  $D40, $268,$A200	; 69
		dc.w  $D58, $376,$3600	; 72
		dc.w  $D88, $377,$3600	; 75
		dc.w  $DB0, $37B,$4102	; 78
		dc.w  $DD0, $270,$A200	; 81
		dc.w  $DD8, $370,$3600	; 84
		dc.w  $E2C, $278,$4102	; 87
		dc.w  $ED0, $240,$9A00	; 90
		dc.w  $F48, $290,$3620	; 93
		dc.w  $F56, $3B3,$3600	; 96
		dc.w  $F58, $28F,$3620	; 99
		dc.w  $F68, $28C,$3620	; 102
		dc.w  $F78, $287,$3620	; 105
		dc.w  $F80, $3BF,$4102	; 108
		dc.w  $FA0, $201,$3B00	; 111
		dc.w  $FAC, $3B7,$3600	; 114
		dc.w  $FD8, $272,$3B00	; 117
		dc.w $1030,$42B0,$9A01	; 120
		dc.w $10A0, $2B0,$9A00	; 123
		dc.w $1100, $1D0,$A200	; 126
		dc.w $1170, $377,$3600	; 129
		dc.w $11D4, $370,$3600	; 132
		dc.w $11E8, $22C,$F901	; 135
		dc.w $1220, $1E8,$1801	; 138
		dc.w $1234, $373,$3600	; 141
		dc.w $1260, $1A8,$1805	; 144
		dc.w $12C0, $330,$A606	; 147
		dc.w $12E0, $330,$A606	; 150
		dc.w $12F8, $238,$C200	; 153
		dc.w $1300, $330,$A606	; 156
		dc.w $1308, $170,$A606	; 159
		dc.w $1320, $330,$A605	; 162
		dc.w $13A0, $130,$A200	; 165
		dc.w $13A0, $188,$1803	; 168
		dc.w $1420, $1A8,$1803	; 171
		dc.w $1448, $304,$C000	; 174
		dc.w $14A0, $1C8,$1803	; 177
		dc.w $14D0, $334,$3600	; 180
		dc.w $1500, $331,$3600	; 183
		dc.w $1510, $17C,$A200	; 186
		dc.w $1530, $330,$3600	; 189
		dc.w $1580, $1F1,$A604	; 192
		dc.w $1580,$4240, $380	; 195
		dc.w $1610, $130,$A200	; 198
		dc.w $1610,$4280, $300	; 201
		dc.w $1620, $160,$1806	; 204
		dc.w $1660, $1E8,$1802	; 207
		dc.w $1690,  $E0,$1802	; 210
		dc.w $1740,  $A0,$1801	; 213
		dc.w $1808, $1C0,$4401	; 216
		dc.w $1808, $1F0,$4401	; 219
		dc.w $1880,$4138,$C200	; 222
		dc.w $1900,$4140,$C200	; 225
		dc.w $1940,$4138,$C200	; 228
		dc.w $1980,$4160,$C200	; 231
		dc.w $1980, $373,$F902	; 234
		dc.w $1AF8,  $C0,$4402	; 237
		dc.w $1AF8,  $E0,$4402	; 240
		dc.w $1AF8, $2B0,$4402	; 243
		dc.w $1AF8, $2F0,$4402	; 246
		dc.w $1B60,  $88,$1803	; 249
		dc.w $1B70, $288,$1803	; 252
		dc.w $1BA0,  $C8,$1803	; 255
		dc.w $1BE0, $108,$1803	; 258
		dc.w $1C00,$42C0,$A200	; 261
		dc.w $1C20, $148,$1803	; 264
		dc.w $1C60, $188,$1803	; 267
		dc.w $1CA0, $1C8,$1803	; 270
		dc.w $1CE0, $208,$1803	; 273
		dc.w $1D40, $208,$1803	; 276
		dc.w $1D78, $476,$3B00	; 279
		dc.w $1DA0, $320,$A200	; 282
		dc.w $1DE0, $204,$1801	; 285
		dc.w $1DF8, $4B0,$4402	; 288
		dc.w $1E08, $370,$4400	; 291
		dc.w $1E18,$4368,$C201	; 294
		dc.w $1E20, $4B4,$3600	; 297
		dc.w $1E40,$4450,$C201	; 300
		dc.w $1E48, $340,$4400	; 303
		dc.w $1E60,$4330,$C201	; 306
		dc.w $1E60,$4430,$C201	; 309
		dc.w $1EA0, $2A0,$A200	; 312
		dc.w $1ED8, $2FF,$3B00	; 315
		dc.w $1F30,$4308,$1C03	; 318
		dc.w $1F80, $3C0,$AB00	; 321
		dc.w $1FA8, $318,$110C	; 324
		dc.w $1FC0, $3D0,$AB00	; 327
		dc.w $2010, $30A,$1C03	; 330
		dc.w $2020, $4B0,$3600	; 333
		dc.w $2048, $390,$3620	; 336
		dc.w $2058, $38E,$3620	; 339
		dc.w $2068, $38B,$3620	; 342
		dc.w $2078, $386,$3620	; 345
		dc.w $2080, $350,$C200	; 348
		dc.w $2088, $382,$3620	; 351
		dc.w $20D0, $370,$3B00	; 354
		dc.w $2180, $48C,$9F00	; 357
		dc.w $2248, $350,$A606	; 360
		dc.w $2334, $320,$A606	; 363
		dc.w $2378, $408,$1802	; 366
		dc.w $23F0, $380,$A200	; 369
		dc.w $2560, $4A2, $D00	; 372
		dc.w $2584, $460,$7D03	; 375
		dc.w $2584, $478,$7D03	; 378
		dc.w $2584, $490,$7D03	; 381
		dc.w $25D4, $450,$7D01	; 384
		dc.w $25D4, $470,$7D02	; 387
		dc.w $FFFF,    0,    0	; 390
ObjPos_GHZ2:	dc.w   $40, $2B2,$3640	; 0 ; DATA XREF: ROM:ObjPos_Indexo
		dc.w   $E6,  $FF,$3B00	; 3
		dc.w   $F0, $2B1,$A604	; 6
		dc.w  $110, $2B1,$A606	; 9
		dc.w  $130,$4108,$1C03	; 12
		dc.w  $130, $2B1,$A606	; 15
		dc.w  $180, $1F0,$AB00	; 18
		dc.w  $1A8, $118,$110C	; 21
		dc.w  $1C0, $1C0,$AB00	; 24
		dc.w  $20E, $10A,$1C03	; 27
		dc.w  $248, $190,$3620	; 30
		dc.w  $250, $2A0,$BC00	; 33
		dc.w  $25C, $18E,$3620	; 36
		dc.w  $270, $189,$3620	; 39
		dc.w  $270, $2A0,$BC01	; 42
		dc.w  $284, $182,$3620	; 45
		dc.w  $290, $2A0,$BC01	; 48
		dc.w  $298, $17E,$3620	; 51
		dc.w  $2B0, $2A0,$BC01	; 54
		dc.w  $2D0, $2A0,$BC01	; 57
		dc.w  $2F0, $158,$4102	; 60
		dc.w  $2F0, $170,$3B00	; 63
		dc.w  $2F0, $2A0,$BC02	; 66
		dc.w  $338, $2B5,$A603	; 69
		dc.w  $3F8, $2F0,$4402	; 72
		dc.w  $430, $258,$A200	; 75
		dc.w  $440, $300,$C000	; 78
		dc.w  $470, $100,$9F00	; 81
		dc.w  $480, $2C8,$1801	; 84
		dc.w  $4F8, $332,$3B00	; 87
		dc.w  $508, $2F0,$4410	; 90
		dc.w  $530,$4108,$1C03	; 93
		dc.w  $580, $1F0,$AB00	; 96
		dc.w  $590, $3D0,$3640	; 99
		dc.w  $5A8, $118,$110C	; 102
		dc.w  $5B0, $2B0,$C000	; 105
		dc.w  $5C0, $1C0,$AB00	; 108
		dc.w  $5C8, $340,$1506	; 111
		dc.w  $60E, $10A,$1C03	; 114
		dc.w  $620, $3D0,$3640	; 117
		dc.w  $654, $190,$3620	; 120
		dc.w  $668, $18B,$3620	; 123
		dc.w  $67C, $185,$3620	; 126
		dc.w  $690, $17F,$3620	; 129
		dc.w  $690,$42B8,$C000	; 132
		dc.w  $6A0, $360,$1803	; 135
		dc.w  $6A4, $179,$3620	; 138
		dc.w  $6B0, $3D0,$3640	; 141
		dc.w  $6F0, $170,$3B00	; 144
		dc.w  $708, $2B0,$4400	; 147
		dc.w  $720, $380,$1803	; 150
		dc.w  $740, $3D0,$3640	; 153
		dc.w  $750,  $D0,$A200	; 156
		dc.w  $7A0,$40F0,$A200	; 159
		dc.w  $7A0, $3A0,$1803	; 162
		dc.w  $7AC, $3D0,$3630	; 165
		dc.w  $7D0, $210,$A200	; 168
		dc.w  $7DC, $3D0,$3620	; 171
		dc.w  $7F4, $3D0,$3620	; 174
		dc.w  $800, $1B0,$3B00	; 177
		dc.w  $808, $3F0,$4400	; 180
		dc.w  $834, $124,$A604	; 183
		dc.w  $874, $3B0,$3B00	; 186
		dc.w  $8E8, $1C8,$1508	; 189
		dc.w  $938, $388,$C200	; 192
		dc.w  $988, $358,$C200	; 195
		dc.w  $9B4, $1FC,$3600	; 198
		dc.w  $9C8, $378,$C200	; 201
		dc.w  $A18, $348,$C200	; 204
		dc.w  $A2C,$4208,$1C03	; 207
		dc.w  $A68, $2B0,$AB00	; 210
		dc.w  $AA0, $290,$AB00	; 213
		dc.w  $AA8, $218,$110C	; 216
		dc.w  $AD8, $2E0,$AB00	; 219
		dc.w  $B10, $208,$1C03	; 222
		dc.w  $B58,$43B0,$4110	; 225
		dc.w  $BB8,$4390,$4110	; 228
		dc.w  $C20, $370,$3B00	; 231
		dc.w  $C68, $350,$C200	; 234
		dc.w  $CB4, $326,$C200	; 237
		dc.w  $D00, $358,$C200	; 240
		dc.w  $D80, $1F1,$A602	; 243
		dc.w  $D80, $350,$9F00	; 246
		dc.w  $D80,$4240, $380	; 249
		dc.w  $E10,$4280, $300	; 252
		dc.w  $E30,$4338,$4100	; 255
		dc.w  $F74, $21F,$A605	; 258
		dc.w  $FF0, $270,$3B00	; 261
		dc.w $1060, $2D0,$3600	; 264
		dc.w $10A0, $288,$180A	; 267
		dc.w $10D0, $370,$9F00	; 270
		dc.w $10E0, $2D0,$3600	; 273
		dc.w $11A0, $2D0,$3600	; 276
		dc.w $11E0, $288,$180A	; 279
		dc.w $1220, $2D0,$3600	; 282
		dc.w $1260, $288,$180A	; 285
		dc.w $1280, $220,$A200	; 288
		dc.w $12A0, $2D0,$3600	; 291
		dc.w $1310, $26C,$F901	; 294
		dc.w $1360, $2D0,$3600	; 297
		dc.w $13A0, $288,$180A	; 300
		dc.w $13C0, $240,$A200	; 303
		dc.w $13E0, $2D0,$3600	; 306
		dc.w $1408, $2F0,$4400	; 309
		dc.w $1520,$42B0,$C000	; 312
		dc.w $15D4,$4145,$4102	; 315
		dc.w $1650, $150,$A606	; 318
		dc.w $16A0, $1B0,$C000	; 321
		dc.w $16B0,$41A0,$C201	; 324
		dc.w $16F8, $1F0,$4412	; 327
		dc.w $16F8, $220,$4412	; 330
		dc.w $16F8, $2F0,$4402	; 333
		dc.w $16F8, $330,$4402	; 336
		dc.w $16F8, $370,$4402	; 339
		dc.w $16F8, $3B0,$4402	; 342
		dc.w $16F8, $3F0,$4402	; 345
		dc.w $1710, $400,$A604	; 348
		dc.w $1720, $3C0,$A200	; 351
		dc.w $1760, $238,$C201	; 354
		dc.w $1790, $370,$A200	; 357
		dc.w $17A0, $200,$9F00	; 360
		dc.w $17D0, $1FE,$3B00	; 363
		dc.w $17E0, $3F0,$9A00	; 366
		dc.w $1808, $3F0,$4410	; 369
		dc.w $1810, $370,$C200	; 372
		dc.w $1820, $3B0,$3600	; 375
		dc.w $1828, $430,$3B00	; 378
		dc.w $1830,$4208,$1C03	; 381
		dc.w $1880, $2C0,$AB00	; 384
		dc.w $188C, $4D0,$3640	; 387
		dc.w $18A0,$43B0,$C000	; 390
		dc.w $18A8, $218,$110C	; 393
		dc.w $18C0, $2A0,$AB00	; 396
		dc.w $18C8, $448,$1506	; 399
		dc.w $1908, $3B0,$4400	; 402
		dc.w $1910, $208,$1C03	; 405
		dc.w $191C, $4D0,$3640	; 408
		dc.w $19A0, $488,$1801	; 411
		dc.w $19AC, $4D0,$3640	; 414
		dc.w $19F8, $320,$4412	; 417
		dc.w $1A08, $4B0,$4400	; 420
		dc.w $1A08, $4F0,$4401	; 423
		dc.w $1A30,$42F0,$9A01	; 426
		dc.w $1A80, $477,$3B00	; 429
		dc.w $1AA0, $2F0,$9A00	; 432
		dc.w $1AF0, $410,$A200	; 435
		dc.w $1AF8, $4B0,$4402	; 438
		dc.w $1B50, $440,$A200	; 441
		dc.w $1B94, $377,$3630	; 444
		dc.w $1BA0, $310,$C200	; 447
		dc.w $1BDC, $372,$3630	; 450
		dc.w $1C08, $200,$4401	; 453
		dc.w $1C90, $3F0,$A200	; 456
		dc.w $1CA0, $470,$9A00	; 459
		dc.w $1CE0, $3E0,$A200	; 462
		dc.w $1D38,$4428,$4110	; 465
		dc.w $1DA0, $407,$A606	; 468
		dc.w $1DE4, $403,$3600	; 471
		dc.w $1DF8, $440,$4402	; 474
		dc.w $1DF8, $480,$4402	; 477
		dc.w $1DF8, $4C0,$4402	; 480
		dc.w $1F38, $370,$7D03	; 483
		dc.w $1F60, $350,$7D01	; 486
		dc.w $1F60, $370,$7D03	; 489
		dc.w $1F60, $3A2, $D00	; 492
		dc.w $1F88, $370,$7D03	; 495
		dc.w $1FD4, $370,$7D02	; 498
		dc.w $FFFF,    0,    0	; 501
ObjPos_GHZ3:	dc.w   $84, $340,$A605	; 0 ; DATA XREF: ROM:ObjPos_Indexo
		dc.w  $128, $3B8,$4102	; 3
		dc.w  $190, $3E0,$3640	; 6
		dc.w  $1C0, $3C8,$1805	; 9
		dc.w  $1E0, $340,$9A00	; 12
		dc.w  $208, $3E0,$3640	; 15
		dc.w  $250, $307,$C000	; 18
		dc.w  $260, $298,$A200	; 21
		dc.w  $278, $30C,$4102	; 24
		dc.w  $2D8, $218,$A200	; 27
		dc.w  $2E0, $240,$9A00	; 30
		dc.w  $320, $2D0,$9A00	; 33
		dc.w  $350, $208,$A604	; 36
		dc.w  $390, $250,$C200	; 39
		dc.w  $3F0,$4278,$1C03	; 42
		dc.w  $468, $288,$110C	; 45
		dc.w  $4D0, $278,$1C03	; 48
		dc.w  $530, $238,$A200	; 51
		dc.w  $530, $278,$4102	; 54
		dc.w  $590, $230,$A200	; 57
		dc.w  $5D0, $240,$9A00	; 60
		dc.w  $650, $207,$C000	; 63
		dc.w  $690, $338,$A200	; 66
		dc.w  $730,$42B0,$9A01	; 69
		dc.w  $750, $1F0,$A200	; 72
		dc.w  $780, $258,$1802	; 75
		dc.w  $7C0, $358,$4102	; 78
		dc.w  $820, $340,$C201	; 81
		dc.w  $848, $2D0,$4400	; 84
		dc.w  $848, $310,$4401	; 87
		dc.w  $848, $350,$4401	; 90
		dc.w  $848, $360,$4401	; 93
		dc.w  $850, $3A0,$BC00	; 96
		dc.w  $870, $3A0,$BC01	; 99
		dc.w  $890, $3A0,$BC01	; 102
		dc.w  $8B0, $3A0,$BC01	; 105
		dc.w  $8D0, $198,$A200	; 108
		dc.w  $8D0, $3A0,$BC01	; 111
		dc.w  $8F0, $3A0,$BC02	; 114
		dc.w  $8F0,$4278,$1C03	; 117
		dc.w  $920, $1C0,$A200	; 120
		dc.w  $968, $288,$110C	; 123
		dc.w  $9D0, $278,$1C03	; 126
		dc.w  $A08, $2C0,$4401	; 129
		dc.w  $A08, $2F0,$4401	; 132
		dc.w  $B00, $26B,$F901	; 135
		dc.w  $B24, $220,$A603	; 138
		dc.w  $B50, $1E8,$1805	; 141
		dc.w  $BA0, $240,$A200	; 144
		dc.w  $BD0, $1C8,$1801	; 147
		dc.w  $C10, $102,$A606	; 150
		dc.w  $C80, $280,$C200	; 153
		dc.w  $CD0, $260,$C200	; 156
		dc.w  $CF0,$4178,$1C03	; 159
		dc.w  $D58,$4570,$4110	; 162
		dc.w  $D68, $188,$110C	; 165
		dc.w  $DD0, $178,$1C03	; 168
		dc.w  $DD0, $531,$3B00	; 171
		dc.w  $DF0, $178,$4102	; 174
		dc.w  $E08,  $F0,$4400	; 177
		dc.w  $E08, $130,$4401	; 180
		dc.w  $E08, $170,$4401	; 183
		dc.w  $E08, $1B0,$4401	; 186
		dc.w  $E08, $1F0,$4401	; 189
		dc.w  $E08, $230,$4401	; 192
		dc.w  $E20, $520,$9F00	; 195
		dc.w  $E84,  $40,$A606	; 198
		dc.w  $EA0, $4C0,$C200	; 201
		dc.w  $EB0,  $AC,$F902	; 204
		dc.w  $EE0, $4E0,$C200	; 207
		dc.w  $EF8,  $F0,$4402	; 210
		dc.w  $EF8, $120,$4402	; 213
		dc.w  $EF8, $160,$4402	; 216
		dc.w  $EF8, $1A0,$4402	; 219
		dc.w  $EF8, $1E0,$4402	; 222
		dc.w  $F48, $505,$3B00	; 225
		dc.w  $F60, $4B0,$C200	; 228
		dc.w  $F98, $533,$3600	; 231
		dc.w  $FA0,  $C8,$1801	; 234
		dc.w  $FB4, $350,$A604	; 237
		dc.w $1020, $108,$1802	; 240
		dc.w $1060, $188,$1806	; 243
		dc.w $1080, $4D0,$A200	; 246
		dc.w $1080,$4340, $380	; 249
		dc.w $1084, $2F0,$A602	; 252
		dc.w $10A0, $570,$9A00	; 255
		dc.w $10B0, $210,$1803	; 258
		dc.w $1110,$4380, $300	; 261
		dc.w $1138,$4530,$4110	; 264
		dc.w $1140, $22C,$1803	; 267
		dc.w $1150, $4D0,$A200	; 270
		dc.w $1190, $507,$3B00	; 273
		dc.w $11D0, $240,$9A00	; 276
		dc.w $11F0, $4F0,$3610	; 279
		dc.w $1208, $4F0,$4400	; 282
		dc.w $1225,$4205,$C000	; 285
		dc.w $1240, $480,$C200	; 288
		dc.w $1270, $288,$C000	; 291
		dc.w $1280, $428,$A200	; 294
		dc.w $1290, $202,$C000	; 297
		dc.w $1290, $450,$C200	; 300
		dc.w $12E0,$4272,$C000	; 303
		dc.w $12E0, $4B1,$3600	; 306
		dc.w $1308, $4B0,$4400	; 309
		dc.w $1330,$42B0,$9A01	; 312
		dc.w $1378, $478,$3600	; 315
		dc.w $1404,$436E,$4110	; 318
		dc.w $1408, $470,$4400	; 321
		dc.w $1420, $36F,$3B00	; 324
		dc.w $1428, $420,$9F00	; 327
		dc.w $1470, $40D,$4102	; 330
		dc.w $1484, $248,$A604	; 333
		dc.w $14A8, $406,$3620	; 336
		dc.w $14B8, $2B0,$3B00	; 339
		dc.w $14C0, $36C,$F903	; 342
		dc.w $14C0, $404,$3620	; 345
		dc.w $14D8, $403,$3620	; 348
		dc.w $14E8, $420,$A200	; 351
		dc.w $14F0, $401,$3620	; 354
		dc.w $14F8, $2F0,$4402	; 357
		dc.w $14F8, $330,$4412	; 360
		dc.w $14F8, $360,$4412	; 363
		dc.w $14F8, $3B0,$4412	; 366
		dc.w $14F8, $3F0,$4412	; 369
		dc.w $14F8, $440,$4402	; 372
		dc.w $14F8, $480,$4402	; 375
		dc.w $14F8, $4B0,$4402	; 378
		dc.w $1500, $248,$A200	; 381
		dc.w $1588, $388,$1710	; 384
		dc.w $15A8, $2C8,$1508	; 387
		dc.w $1620, $4B0,$A606	; 390
		dc.w $1648, $4B0,$A606	; 393
		dc.w $1670, $4B0,$A606	; 396
		dc.w $1680, $2C8,$1803	; 399
		dc.w $1688, $388,$1710	; 402
		dc.w $1698, $4B0,$A606	; 405
		dc.w $16C0, $4B0,$A606	; 408
		dc.w $16E8, $4B0,$A602	; 411
		dc.w $1708, $3B0,$4410	; 414
		dc.w $1708, $3F0,$4411	; 417
		dc.w $1708, $430,$4411	; 420
		dc.w $1708, $460,$4411	; 423
		dc.w $1708, $4B0,$4400	; 426
		dc.w $1720, $2C8,$1803	; 429
		dc.w $1730, $479,$4102	; 432
		dc.w $1778, $476,$3630	; 435
		dc.w $17A8, $475,$3620	; 438
		dc.w $17C0, $2C8,$1803	; 441
		dc.w $17D8, $470,$3630	; 444
		dc.w $17F8, $4B0,$4402	; 447
		dc.w $17F8, $4F0,$4402	; 450
		dc.w $1870, $360,$C200	; 453
		dc.w $1878, $205,$A605	; 456
		dc.w $18C0, $390,$C200	; 459
		dc.w $18D4, $771,$3B00	; 462
		dc.w $1988, $288,$1710	; 465
		dc.w $1A00, $3B0,$3B00	; 468
		dc.w $1A80, $360,$A200	; 471
		dc.w $1A88, $288,$1710	; 474
		dc.w $1AC0, $210,$A200	; 477
		dc.w $1AE0, $340,$A200	; 480
		dc.w $1B76, $220,$A606	; 483
		dc.w $1BA0, $394,$9F00	; 486
		dc.w $1BD6, $21F,$A606	; 489
		dc.w $1C30, $278,$4102	; 492
		dc.w $1CB0, $33E,$4102	; 495
		dc.w $1CD0, $240,$9A00	; 498
		dc.w $1D10, $330,$1802	; 501
		dc.w $1D45, $207,$A606	; 504
		dc.w $1D48, $2D0,$4400	; 507
		dc.w $1D48, $310,$4401	; 510
		dc.w $1D48, $350,$4401	; 513
		dc.w $1D50, $3A0,$BC00	; 516
		dc.w $1D70, $3A0,$BC01	; 519
		dc.w $1D90, $3A0,$BC01	; 522
		dc.w $1DB0, $3A0,$BC01	; 525
		dc.w $1DD0, $3A0,$BC01	; 528
		dc.w $1DF0, $3A0,$BC02	; 531
		dc.w $1E20,$42B0,$9A01	; 534
		dc.w $1E80, $220,$A200	; 537
		dc.w $1E80, $298,$1802	; 540
		dc.w $1EE0, $2C0,$1806	; 543
		dc.w $1FF8, $3E0,$4402	; 546
		dc.w $2000, $2A0,$A200	; 549
		dc.w $2030,$43B0,$9A01	; 552
		dc.w $2050, $3D0,$3640	; 555
		dc.w $2070, $308,$1507	; 558
		dc.w $20B0, $2F0,$A200	; 561
		dc.w $20E0, $3D0,$3640	; 564
		dc.w $2120, $3D0,$9A00	; 567
		dc.w $2134, $3D0,$3620	; 570
		dc.w $2224, $314,$4102	; 573
		dc.w $2230, $296,$A200	; 576
		dc.w $2268, $2B0,$A200	; 579
		dc.w $22A0, $2CC,$A200	; 582
		dc.w $2376, $321,$A606	; 585
		dc.w $2490, $340,$A200	; 588
		dc.w $2530,$43B8,$1C03	; 591
		dc.w $2535, $320,$A605	; 594
		dc.w $2588, $3F0,$3640	; 597
		dc.w $25A8, $3C8,$110C	; 600
		dc.w $25DC, $3F0,$3620	; 603
		dc.w $25F4, $3F0,$3620	; 606
		dc.w $2608, $3F0,$4400	; 609
		dc.w $2610, $3B9,$1C03	; 612
		dc.w $26A8, $3AC,$F904	; 615
		dc.w $2980, $380,$1800	; 618
		dc.w $2A80, $380,$1800	; 621
		dc.w $2B60, $37D,$3E01	; 624
		dc.w $2B60, $3A2,$3E00	; 627
		dc.w $FFFF,    0,    0	; 630
ObjPos_LZ1:	dc.w $FFFF,    0,    0	; 0 ; DATA XREF: ROM:ObjPos_Indexo
ObjPos_LZ2:	dc.w $FFFF,    0,    0	; 0 ; DATA XREF: ROM:ObjPos_Indexo
ObjPos_LZ3:	dc.w $FFFF,    0,    0	; 0 ; DATA XREF: ROM:ObjPos_Indexo
ObjPos_S1LZ1pf1:dc.w	 7,$1078, $21A	; 0 ; DATA XREF: ROM:ObjPos_Indexo
		dc.w	 0,$10BE, $291	; 3
		dc.w	 2,$10BE, $307	; 6
		dc.w	 2,$10BE, $37E	; 9
		dc.w	 2,$105C, $390	; 12
		dc.w	 4,$1022, $352	; 15
		dc.w	 5,$1022, $2DB	; 18
		dc.w	 5,$1022, $265	; 21
		dc.w	 5		; 24
ObjPos_S1LZ1pf2:dc.w	 7,$127E, $280	; 0 ; DATA XREF: ROM:ObjPos_Indexo
		dc.w   $10,$12CE, $305	; 3
		dc.w   $12,$12CE, $38A	; 6
		dc.w   $12,$12CE, $40F	; 9
		dc.w   $12,$12A7, $46E	; 12
		dc.w   $13,$1232, $40F	; 15
		dc.w   $14,$1232, $38A	; 18
		dc.w   $14,$1232, $305	; 21
		dc.w   $14		; 24
ObjPos_S1LZ2pf1:dc.w	 7, $D22, $483	; 0 ; DATA XREF: ROM:ObjPos_Indexo
		dc.w   $21, $D9C, $482	; 3
		dc.w   $20, $DAE, $4EA	; 6
		dc.w   $23, $DAE, $564	; 9
		dc.w   $23, $DAE, $5DD	; 12
		dc.w   $23, $D34, $5DE	; 15
		dc.w   $22, $D22, $576	; 18
		dc.w   $21, $D22, $4FC	; 21
		dc.w   $21		; 24
ObjPos_S1LZ2pf2:dc.w	 7, $D62, $3A2	; 0 ; DATA XREF: ROM:ObjPos_Indexo
		dc.w   $30, $DD4, $3A2	; 3
		dc.w   $31, $DEE, $3FA	; 6
		dc.w   $32, $DEE, $46C	; 9
		dc.w   $32, $DEE, $4DD	; 12
		dc.w   $32, $D7C, $4DE	; 15
		dc.w   $33, $D62, $486	; 18
		dc.w   $30, $D62, $414	; 21
		dc.w   $30		; 24
ObjPos_S1LZ3pf1:dc.w	$B, $CAD, $242	; 0 ; DATA XREF: ROM:ObjPos_Indexo
		dc.w   $41, $D2D, $242	; 3
		dc.w   $41, $DAC, $242	; 6
		dc.w   $41, $DDE, $28F	; 9
		dc.w   $42, $DDE, $30E	; 12
		dc.w   $42, $DDE, $38D	; 15
		dc.w   $42, $DB0, $3DE	; 18
		dc.w   $43, $D31, $3DE	; 21
		dc.w   $43, $CB2, $3DE	; 24
		dc.w   $43, $C52, $3BF	; 27
		dc.w   $44, $C52, $340	; 30
		dc.w   $44, $C52, $2C1	; 33
		dc.w   $44		; 36
ObjPos_S1LZ3pf2:dc.w	 8,$1252, $20A	; 0 ; DATA XREF: ROM:ObjPos_Indexo
		dc.w   $50,$12D2, $20A	; 3
		dc.w   $51,$1352, $20A	; 6
		dc.w   $51,$13D2, $20A	; 9
		dc.w   $51,$13DE, $27E	; 12
		dc.w   $52,$139E, $2BE	; 15
		dc.w   $53,$131E, $2BE	; 18
		dc.w   $53,$129E, $2BE	; 21
		dc.w   $53,$1252, $28A	; 24
		dc.w   $50,$FFFF,    0	; 27
		dc.w	 0		; 30
ObjPos_CPZ1:	dc.w  $120, $1D0,$1901	; 0 ; DATA XREF: ROM:ObjPos_Indexo
		dc.w  $2F0, $1D0,$1901	; 3
		dc.w  $348, $210,$1908	; 6
		dc.w  $378, $220, $319	; 9
		dc.w  $3F8, $1C0, $311	; 12
		dc.w  $418, $250, $339	; 15
		dc.w  $500, $1C0, $359	; 18
		dc.w  $500, $240, $321	; 21
		dc.w  $600, $1C0, $341	; 24
		dc.w  $600, $240, $339	; 27
		dc.w  $700, $1C0, $359	; 30
		dc.w  $700, $240, $321	; 33
		dc.w  $878, $3C0, $321	; 36
		dc.w  $8F0, $1F0,$2604	; 39
		dc.w  $970, $1D0,$2604	; 42
		dc.w  $9F0, $340, $341	; 45
		dc.w  $A70, $1D0,$1901	; 48
		dc.w  $B08, $340, $321	; 51
		dc.w  $BB0, $378, $342	; 54
		dc.w  $C80, $460, $321	; 57
		dc.w  $D78, $3C0, $341	; 60
		dc.w  $E10, $100, $329	; 63
		dc.w  $F40, $1C8, $325	; 66
		dc.w  $F80,  $E0, $329	; 69
		dc.w  $FF8, $240, $341	; 72
		dc.w $1030, $498, $C70	; 75
		dc.w $1050, $498, $C71	; 78
		dc.w $1070, $498, $C72	; 81
		dc.w $1090, $498, $C73	; 84
		dc.w $10B0, $498, $C74	; 87
		dc.w $10D0, $498, $C75	; 90
		dc.w $1100, $2E0, $321	; 93
		dc.w $1588,$42E8, $380	; 96
		dc.w $15E8,$4300, $300	; 99
		dc.w $1880,$4068, $380	; 102
		dc.w $1898,$4140, $300	; 105
		dc.w $1988,$40E8, $380	; 108
		dc.w $19E8,$4100, $300	; 111
		dc.w $2688,$40E8, $380	; 114
		dc.w $26E8,$4100, $300	; 117
		dc.w $FFFF,    0,    0	; 120
ObjPos_CPZ2:	dc.w $FFFF,    0,    0	; 0 ; DATA XREF: ROM:ObjPos_Indexo
ObjPos_CPZ3:	dc.w $FFFF,    0,    0	; 0 ; DATA XREF: ROM:ObjPos_Indexo

ObjPos_EHZ1:
		incbin "Levels\03\obj\1.bin"
		even

ObjPos_EHZ2:	dc.w  $2C0,$42A0,$4132	; 0 ; DATA XREF: ROM:ObjPos_Indexo
		dc.w  $338, $300,$1C02	; 3
		dc.w  $378, $350,$D300	; 6
		dc.w  $3A8, $308,$110C	; 9
		dc.w  $3C8, $350,$D300	; 12
		dc.w  $408, $300,$1C02	; 15
		dc.w  $4B8,$22F0,$D400	; 18
		dc.w  $5C0, $2B6,$A605	; 21
		dc.w  $678, $2BC,$1C02	; 24
		dc.w  $6B8, $33C,$1C02	; 27
		dc.w  $6C8,$2270,$CB00	; 30
		dc.w  $6E8, $2C8,$110C	; 33
		dc.w  $6F8, $390,$D300	; 36
		dc.w  $728, $348,$110C	; 39
		dc.w  $748,$2250,$CB00	; 42
		dc.w  $748, $2BC,$1C02	; 45
		dc.w  $748, $390,$D300	; 48
		dc.w  $788, $33C,$1C02	; 51
		dc.w  $83C,$42A0,$4132	; 54
		dc.w  $8E0, $2B8,$1801	; 57
		dc.w  $B20, $308,$1801	; 60
		dc.w  $BC0, $2F6,$3600	; 63
		dc.w  $C68, $300,$4102	; 66
		dc.w  $CD8, $3B2,$3600	; 69
		dc.w  $D30,$2330,$CB00	; 72
		dc.w  $D78, $23C,$1C02	; 75
		dc.w  $DB8, $3BC,$1C02	; 78
		dc.w  $DE8, $24C,$110C	; 81
		dc.w  $DF8, $410,$D300	; 84
		dc.w  $E28, $3C8,$110C	; 87
		dc.w  $E30, $2D1,$A604	; 90
		dc.w  $E48, $240,$1C02	; 93
		dc.w  $E48,$42C0,$4110	; 96
		dc.w  $E48, $410,$D300	; 99
		dc.w  $E88, $3BC,$1C02	; 102
		dc.w $1058,$2290,$D400	; 105
		dc.w $1100, $350, $391	; 108
		dc.w $1188, $3C8, $311	; 111
		dc.w $11C0, $348,$1802	; 114
		dc.w $1280, $3D0, $391	; 117
		dc.w $1308, $448, $311	; 120
		dc.w $1310, $3A0,$4132	; 123
		dc.w $13F0, $2C8, $309	; 126
		dc.w $148B, $210,$4132	; 129
		dc.w $1548,$2230,$CB00	; 132
		dc.w $1560, $290, $314	; 135
		dc.w $1560, $320,$4900	; 138
		dc.w $1560, $3E0,$4904	; 141
		dc.w $1560, $460,$4904	; 144
		dc.w $1570, $351,$A601	; 147
		dc.w $15F0,$4231,$4132	; 150
		dc.w $1620,$24B0,$D400	; 153
		dc.w $1630, $198,$3600	; 156
		dc.w $166C, $4B8,$410A	; 159
		dc.w $16C8, $380, $311	; 162
		dc.w $16F8, $1BC,$1C02	; 165
		dc.w $1738, $3BC,$1C02	; 168
		dc.w $1768, $1C8,$110C	; 171
		dc.w $17A8, $3C8,$110C	; 174
		dc.w $17C8, $1BC,$1C02	; 177
		dc.w $17F8, $180, $311	; 180
		dc.w $1808, $3BC,$1C02	; 183
		dc.w $1880, $150, $391	; 186
		dc.w $1908, $1C0, $311	; 189
		dc.w $1948,$4380,$4132	; 192
		dc.w $1960, $445,$A604	; 195
		dc.w $1978,$4440,$4110	; 198
		dc.w $1990, $3B0,$41B2	; 201
		dc.w $19E8, $3F4,$3600	; 204
		dc.w $1A00, $1D0, $391	; 207
		dc.w $1A50, $2E8,$41A2	; 210
		dc.w $1A50, $430,$41B2	; 213
		dc.w $1A70, $2E8,$41A2	; 216
		dc.w $1A70, $440,$4102	; 219
		dc.w $1A80, $240, $311	; 222
		dc.w $1AD8, $474,$3600	; 225
		dc.w $1C10,$2440,$CB00	; 228
		dc.w $1C40, $280, $600	; 231
		dc.w $1C70,$2470,$CB00	; 234
		dc.w $1C98,$8470,$3600	; 237
		dc.w $1CC0,$8480,$3600	; 240
		dc.w $1CE8, $3CF,$A604	; 243
		dc.w $1D60, $480,$4900	; 246
		dc.w $1DC0, $280, $600	; 249
		dc.w $1DE0, $480,$4900	; 252
		dc.w $1E40,$2340,$CB00	; 255
		dc.w $1E60, $480,$4900	; 258
		dc.w $1EE0, $400,$D300	; 261
		dc.w $1EE0, $420,$4900	; 264
		dc.w $1EE0, $4E0,$4904	; 267
		dc.w $1F40, $280, $600	; 270
		dc.w $1FA8,$24B0,$D400	; 273
		dc.w $1FB0,$22F8,$CB00	; 276
		dc.w $1FC0, $4BC,$410A	; 279
		dc.w $1FF0, $320, $309	; 282
		dc.w $1FF0, $4B2,$A604	; 285
		dc.w $2040, $360,$1803	; 288
		dc.w $206C, $3FC,$4102	; 291
		dc.w $2088, $320, $311	; 294
		dc.w $2140, $2A0,$1802	; 297
		dc.w $2200, $2D0, $391	; 300
		dc.w $2238, $480,$1C02	; 303
		dc.w $2278, $4D0,$D300	; 306
		dc.w $2288, $340, $311	; 309
		dc.w $2290, $2A0,$4132	; 312
		dc.w $22A8, $488,$110C	; 315
		dc.w $22C8, $4D0,$D300	; 318
		dc.w $2308, $480,$1C02	; 321
		dc.w $2370, $476,$A604	; 324
		dc.w $2440, $380, $600	; 327
		dc.w $25B0,$2450,$D400	; 330
		dc.w $26C0,$2390,$D400	; 333
		dc.w $26D0,$243C,$D400	; 336
		dc.w $26F0,$2348,$CB00	; 339
		dc.w $FFFF,    0,    0	; 342
ObjPos_EHZ3:	dc.w $FFFF,    0,    0	; 0 ; DATA XREF: ROM:ObjPos_Indexo
ObjPos_HPZ1:	dc.w  $348, $180,$1C21	; 0 ; DATA XREF: ROM:ObjPos_Indexo
		dc.w  $460, $190,$1C21	; 3
		dc.w  $560, $190,$4F00	; 6
		dc.w  $5D8, $140,$1C21	; 9
		dc.w  $660, $590,$1C21	; 12
		dc.w  $6F0, $170,$A606	; 15
		dc.w  $728, $320,$1C21	; 18
		dc.w  $728, $3E0,$1C21	; 21
		dc.w  $748, $530,$1C21	; 24
		dc.w  $748, $580,$1C21	; 27
		dc.w  $810, $4D0,$1316	; 30
		dc.w  $850, $4F0,$1314	; 33
		dc.w  $858, $340,$1C21	; 36
		dc.w  $8C0, $2B0,$1314	; 39
		dc.w  $900, $3D0,$4C00	; 42
		dc.w  $940, $670,$130C	; 45
		dc.w  $960, $590,$4F00	; 48
		dc.w  $97C, $374,$1C10	; 51
		dc.w  $980, $650,$130E	; 54
		dc.w  $9C8, $680,$1C21	; 57
		dc.w  $A08, $388,$1110	; 60
		dc.w  $A10, $490,$1A00	; 63
		dc.w  $A84, $374,$1C10	; 66
		dc.w  $A90, $4B0,$1A00	; 69
		dc.w  $AD8, $560,$1C21	; 72
		dc.w  $BD8, $360,$1C21	; 75
		dc.w  $B70, $4B0,$A602	; 78
		dc.w  $C7C, $2F4,$1C10	; 81
		dc.w  $D08, $308,$1110	; 84
		dc.w  $D84, $2F4,$1C10	; 87
		dc.w  $F20, $308,$4C00	; 90
		dc.w  $F38, $540,$1C21	; 93
		dc.w  $F40, $430,$130C	; 96
		dc.w $1010, $510,$130A	; 99
		dc.w $1030, $530,$4F00	; 102
		dc.w $1050, $4F0,$130A	; 105
		dc.w $1060, $510,$4F00	; 108
		dc.w $1158, $4C0,$1C21	; 111
		dc.w $11D8, $4E0,$1C21	; 114
		dc.w $15C0, $4F0,$1200	; 117
		dc.w $1610, $390,$4C00	; 120
		dc.w $1650, $4B0,$4F00	; 123
		dc.w $16C0, $430,$4F00	; 126
		dc.w $FFFF,    0,    0	; 129
ObjPos_HPZ2:	dc.w $FFFF,    0,    0	; 0 ; DATA XREF: ROM:ObjPos_Indexo
ObjPos_HPZ3:	dc.w $FFFF,    0,    0	; 0 ; DATA XREF: ROM:ObjPos_Indexo
ObjPos_HTZ1:	dc.w  $178, $3A0,$1C04	; 0 ; DATA XREF: ROM:ObjPos_Indexo
		dc.w  $1A0, $3BE,$1600	; 3
		dc.w  $308, $460,$1C05	; 6
		dc.w  $548, $428,$181A	; 9
		dc.w  $5B8,$4428,$181B	; 12
		dc.w  $700, $468,$1400	; 15
		dc.w  $780, $3E8,$1400	; 18
		dc.w  $8C0, $390,$181A	; 21
		dc.w  $C28, $334,$2601	; 24
		dc.w  $DC0, $448,$1400	; 27
		dc.w  $EA0, $150,$1801	; 30
		dc.w  $F00, $390,$181A	; 33
		dc.w  $F60,  $F0,$1805	; 36
		dc.w $10C8, $308,$1400	; 39
		dc.w $10F8, $520,$1C04	; 42
		dc.w $1148, $208,$1400	; 45
		dc.w $1238,  $F6,$2604	; 48
		dc.w $1278,  $E0,$1C04	; 51
		dc.w $1278, $560,$1C04	; 54
		dc.w $12A0, $100,$1600	; 57
		dc.w $12A0, $57E,$1600	; 60
		dc.w $12C0, $1E8,$1400	; 63
		dc.w $12E4, $43C,$1600	; 66
		dc.w $1308, $420,$1C05	; 69
		dc.w $1380, $210,$181A	; 72
		dc.w $1408, $1A0,$1C05	; 75
		dc.w $1488, $660,$1C05	; 78
		dc.w $1650, $6A8,$1400	; 81
		dc.w $1680, $130, $3B1	; 84
		dc.w $20C0, $768,$1400	; 87
		dc.w $FFFF,    0,    0	; 90
ObjPos_HTZ2:	dc.w $FFFF,    0,    0	; 0 ; DATA XREF: ROM:ObjPos_Indexo
ObjPos_HTZ3:	dc.w $24D0, $510,$7131	; 0 ; DATA XREF: ROM:ObjPos_Indexo
		dc.w $2550, $510,$7131	; 3
		dc.w $FFFF,    0,    0	; 6
ObjPos_S1SBZ1pf1:dc.w 7			; DATA XREF: ROM:ObjPos_Indexo
		dc.w  $E14, $370,    0	; 0
		dc.w  $E5A, $34D,    1	; 3
		dc.w  $EA0, $32A,    1	; 6
		dc.w  $EE7, $307,    1	; 9
		dc.w  $EEF, $340,    2	; 12
		dc.w  $EA9, $363,    3	; 15
		dc.w  $E63, $386,    3	; 18
		dc.w  $E1C, $3A9,    3	; 21
ObjPos_S1SBZ1pf2:dc.w 7			; DATA XREF: ROM:ObjPos_Indexo
		dc.w  $F14, $2E0,  $10	; 0
		dc.w  $F5A, $2BD,  $11	; 3
		dc.w  $FA0, $29A,  $11	; 6
		dc.w  $FE7, $277,  $11	; 9
		dc.w  $FEF, $2B0,  $12	; 12
		dc.w  $FA9, $2D3,  $13	; 15
		dc.w  $F63, $2F6,  $13	; 18
		dc.w  $F1C, $319,  $13	; 21
ObjPos_S1SBZ1pf3:dc.w 7			; DATA XREF: ROM:ObjPos_Indexo
		dc.w $1014, $270,  $20	; 0
		dc.w $105A, $24D,  $21	; 3
		dc.w $10A0, $22A,  $21	; 6
		dc.w $10E7, $207,  $21	; 9
		dc.w $10EF, $240,  $22	; 12
		dc.w $10A9, $263,  $23	; 15
		dc.w $1063, $286,  $23	; 18
		dc.w $101C, $2A9,  $23	; 21
ObjPos_S1SBZ1pf4:dc.w 7			; DATA XREF: ROM:ObjPos_Indexo
		dc.w  $F14, $570,  $30	; 0
		dc.w  $F5A, $54D,  $31	; 3
		dc.w  $FA0, $52A,  $31	; 6
		dc.w  $FE7, $507,  $31	; 9
		dc.w  $FEF, $540,  $32	; 12
		dc.w  $FA9, $563,  $33	; 15
		dc.w  $F63, $586,  $33	; 18
		dc.w  $F1C, $5A9,  $33	; 21
ObjPos_S1SBZ1pf5:dc.w 7			; DATA XREF: ROM:ObjPos_Indexo
		dc.w $1B14, $670,  $40	; 0
		dc.w $1B5A, $64D,  $41	; 3
		dc.w $1BA0, $62A,  $41	; 6
		dc.w $1BE7, $607,  $41	; 9
		dc.w $1BEF, $640,  $42	; 12
		dc.w $1BA9, $663,  $43	; 15
		dc.w $1B63, $686,  $43	; 18
		dc.w $1B1C, $6A9,  $43	; 21
ObjPos_S1SBZ1pf6:dc.w	  7,$1C14, $5E0	 ; 0 ; DATA XREF: ROM:ObjPos_Indexo
		dc.w   $50,$1C5A, $5BD	; 3
		dc.w   $51,$1CA0, $59A	; 6
		dc.w   $51,$1CE7, $577	; 9
		dc.w   $51,$1CEF, $5B0	; 12
		dc.w   $52,$1CA9, $5D3	; 15
		dc.w   $53,$1C63, $5F6	; 18
		dc.w   $53,$1C1C, $619	; 21
		dc.w   $53,$FFFF,    0	; 24
		dc.w	 0		; 27
ObjPos_S1Ending:dc.w   $10, $170,$280C	; 0 ; DATA XREF: ROM:ObjPos_Indexo
		dc.w   $14, $1B2,$2812	; 3
		dc.w   $28, $1B0,$280C	; 6
		dc.w   $30, $1B2,$2812	; 9
		dc.w   $40, $170,$280F	; 12
		dc.w   $5B, $1B1,$2811	; 15
		dc.w   $64, $1B1,$2811	; 18
		dc.w   $68, $1B1,$280C	; 21
		dc.w   $D8, $1B0,$2813	; 24
		dc.w   $E4, $1B1,$280C	; 27
		dc.w   $E8, $1B0,$280F	; 30
		dc.w   $F4, $1B0,$2810	; 33
		dc.w   $F8, $1AF,$2814	; 36
		dc.w  $108, $1B0,$280E	; 39
		dc.w  $108, $1B4,$2813	; 42
		dc.w  $110, $173,$280C	; 45
		dc.w  $114, $1B0,$2810	; 48
		dc.w  $128, $174,$280E	; 51
		dc.w  $128, $1B0,$2814	; 54
		dc.w  $128, $1B2,$2813	; 57
		dc.w  $130, $1B8,$280C	; 60
		dc.w  $210, $1B0,$280A	; 63
		dc.w  $230, $1B2,$2813	; 66
		dc.w  $260, $1B0,$280D	; 69
		dc.w  $290, $1B6,$2813	; 72
		dc.w  $2B0, $150,$280A	; 75
		dc.w  $2B0, $180,$280A	; 78
		dc.w  $2B0, $1B0,$280A	; 81
		dc.w  $2F0, $1B2,$2813	; 84
		dc.w  $300, $1B0,$280A	; 87
		dc.w  $384, $1B0,$280D	; 90
		dc.w  $434, $1B8,$280D	; 93
		dc.w  $478, $1A4,$2813	; 96
		dc.w  $4D8, $176,$2813	; 99
		dc.w  $4F8, $170,$280A	; 102
		dc.w  $530, $170,$2810	; 105
		dc.w  $560, $170,$2810	; 108
		dc.w  $590, $170,$2810	; 111
		dc.w  $5C0, $170,$2810	; 114
		dc.w  $5D8, $170,$2810	; 117
		dc.w  $624, $170,$280A	; 120
		dc.w  $6C4, $1A4,$280D	; 123
		dc.w  $734, $1B8,$280A	; 126
		dc.w  $7F8, $174,$280A	; 129
		dc.w  $878, $178,$280D	; 132
		dc.w  $9B8, $158,$280A	; 135
		dc.w  $A00, $1B4,$280D	; 138
		dc.w  $A48, $152,$2812	; 141
		dc.w  $A78, $152,$2812	; 144
		dc.w  $AA8, $152,$2812	; 147
		dc.w  $AD4, $154,$2814	; 150
		dc.w  $B34, $138,$280A	; 153
		dc.w  $BF8, $174,$280A	; 156
		dc.w  $CC4, $1AB,$280D	; 159
		dc.w  $CC8, $148,$280A	; 162
		dc.w  $D34, $1BA,$280D	; 165
		dc.w  $DF8, $174,$280A	; 168
		dc.w $FFFF,    0,    0	; 171
ObjPos_Null:	dc.w $FFFF,    0,    0	; 0 ; DATA XREF: ROM:ObjPos_Indexo
;
; a symbol table. 'compiler trash'
;
Leftover_418A8:	dc.b $70,$30,  0,  0,  0,  1,$36,  6,  0,  0,  0,  4,$7F,$66,$72,$61,$6D,$65,$6F,$75,$74,$64,$32,$24,$7A,$64,$62,$61,  0,  1,$34,$BE,  0,  0,  0,  3,$63,$6F,$6C,$69,$63,$68,$67,$74,$62,$6C,  0,  0,  0,  1,$35,$E2,  0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$24,$63,$65; 0
		dc.b $62,$61,  0,  0,  0,  1,$35,$56,  0,  0,  0,  4,$7F,$66,$72,$61,$6D,$65,$6F,$75,$74,$32,$24,$7A,$64,$62,$61,  0,  0,  1,$34,$E6,  0,  0,  0,  3,$63,$6F,$6C,$69,$63,$68,$67,$6D,$6F,$76,$65,  0,  0,  1,$35,$2A,  0,  0,  0,  3,$7F,$65,$6E,$64,$31,$24,$63,$65; 64
		dc.b $62,$61,  0,  0,  0,  1,$35,$D4,  0,  0,  0,  3,$7F,$65,$6E,$64,$32,$24,$63,$65,$62,$61,  0,  0,  0,  1,$35,$D0,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$63,$65,$62,$61,  0,  0,  0,  0,  1,$35,$E0,  0,  0,  0,  4,$63,$6F,$6C,$69,$63,$68,$67,$5F,$6D,$6F,$76,$65; 128
		dc.b $5F,$74,$62,$6C,  0,  1,$34,$EA,  0,  0,  0,  4,$7F,$66,$72,$61,$6D,$65,$6F,$75,$74,$24,$7A,$64,$62,$61,  0,  0,  0,  1,$34,$D4,  0,  0,  0,  3,$63,$6F,$6C,$69,$63,$68,$67,$70,$61,$74,  0,  0,  0,  1,$36,  2,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$63; 192
		dc.b $65,$62,$61,  0,  0,  1,$35,$94,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$33,$24,$63,$65,$62,$61,  0,  0,  1,$35,$A2,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$34,$24,$63,$65,$62,$61,  0,  0,  1,$35,$C0,  0,  0,  0,  2,$63,$6F,$6C,$69,$63,$68,$67,  0,  0,  1,$34,$9C; 256
		dc.b   0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$7A,$64,$62,$61,  0,  0,  0,  1,$34,$B6,  0,  0,  0,  3,$6B,$61,$69,$74,$65,$6E,$69,$6E,$69,$74,  0,  0,  0,  1,$36,$60,  0,  0,  0,  3,$6B,$61,$69,$74,$65,$6E,$6D,$6F,$76,$65,  0,  0,  0,  1,$36,$C2,  0,  0,  0,  3; 320
		dc.b $6B,$61,$69,$74,$65,$6E,$63,$68,$67,$30,  0,  0,  0,  1,$37,$26,  0,  0,  0,  3,$6B,$61,$69,$74,$65,$6E,$63,$68,$67,$31,  0,  0,  0,  1,$37,$2E,  0,  0,  0,  3,$6B,$61,$69,$74,$65,$6E,$70,$61,$74,  0,  0,  0,  0,  1,$37,$36,  0,  0,  0,  3,$6B,$61,$69,$74; 384
		dc.b $65,$6E,$6D,$6F,$76,$65,$32,  0,  0,  1,$36,$EC,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$31,$24,$72,$64,$62,$61,  0,  0,  1,$36,$DA,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$72,$64,$62,$61,  0,  0,  1,$36,$E0,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$33,$24,$73; 448
		dc.b $64,$62,$61,  0,  0,  1,$37,  6,  0,  0,  0,  2,$6B,$61,$69,$74,$65,$6E,  0,  0,  0,  1,$36,$4C,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$34,$24,$73,$64,$62,$61,  0,  0,  1,$37,$1E,  0,  0,  0,  4,$6B,$61,$69,$74,$65,$6E,$5F,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0; 512
		dc.b   0,  1,$36,$5A,  0,  0,  0,  3,$6B,$61,$69,$74,$65,$6E,$63,$68,$67,  0,  0,  0,  0,  1,$37,$22,  0,  0,  0,  3,$6B,$61,$69,$74,$65,$6E,$73,$70,$30,  0,  0,  0,  0,  1,$37,$40,  0,  0,  0,  3,$6B,$61,$69,$74,$65,$6E,$73,$70,$31,  0,  0,  0,  0,  1,$37,$4A; 576
		dc.b   0,  0,  0,  3,$6B,$61,$69,$74,$65,$6E,$73,$70,$32,  0,  0,  0,  0,  1,$37,$54,  0,  0,  0,  3,$6B,$61,$69,$74,$65,$6E,$73,$70,$33,  0,  0,  0,  0,  1,$37,$5E,  0,  0,  0,  3,$6B,$61,$69,$74,$65,$6E,$73,$70,$34,  0,  0,  0,  0,  1,$37,$68,  0,  0,  0,  3; 640
		dc.b $6B,$61,$69,$74,$65,$6E,$69,$6E,$69,$74,$32,  0,  0,  1,$36,$B4,  0,  0,  0,  3,$70,$72,$6F,$64,$61,$69,$69,$6E,$69,$74,  0,  0,  0,  1,$37,$86,  0,  0,  0,  3,$70,$72,$6F,$64,$61,$69,$6D,$6F,$76,$65,  0,  0,  0,  1,$37,$E6,  0,  0,  0,  3,$70,$72,$6F,$64; 704
		dc.b $61,$69,$73,$70,$30,  0,  0,  0,  0,  1,$38,$60,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$30,$24,$76,$64,$62,$61,  0,  0,  1,$38,  6,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$76,$64,$62,$61,  0,  0,  1,$38,$34,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$33,$24,$76; 768
		dc.b $64,$62,$61,  0,  0,  1,$38,$38,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$34,$24,$76,$64,$62,$61,  0,  0,  1,$38,$4A,  0,  0,  0,  2,$70,$72,$6F,$64,$61,$69,  0,  0,  0,  1,$37,$74,  0,  0,  0,  3,$70,$72,$6F,$64,$61,$69,$70,$61,$74,  0,  0,  0,  0,  1,$38,$5E; 832
		dc.b   0,  0,  0,  4,$70,$72,$6F,$64,$61,$69,$5F,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0,  1,$37,$82,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$76,$64,$62,$61,  0,  0,  0,  1,$38,$24,  0,  0,  0,  2,$67,$65,$6D,$70,$61,$74,  0,  0,  0,  1,$38,$DA,  0,  0,  0,  1; 896
		dc.b $67,$65,$6D,  0,  0,  1,$38,$74,  0,  0,  0,  2,$67,$65,$6D,$73,$70,$30,$30,  0,  0,  1,$38,$DC,  0,  0,  0,  3,$67,$65,$6D,$5F,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  1,$38,$82,  0,  0,  0,  2,$67,$65,$6D,$69,$6E,$69,$74,  0,  0,  1,$38,$86,  0,  0,  0,  2; 960
		dc.b $67,$65,$6D,$6D,$6F,$76,$65,  0,  0,  1,$38,$AE,  0,  0,  0,  3,$67,$65,$6D,$66,$6F,$75,$74,$63,$68,$6B,  0,  0,  0,  1,$38,$C2,  0,  0,  0,  3,$77,$66,$61,$6C,$6C,$69,$6E,$69,$74,  0,  0,  0,  0,  1,$39,  4,  0,  0,  0,  3,$77,$66,$61,$6C,$6C,$6D,$6F,$76; 1024
		dc.b $65,$32,  0,  0,  0,  1,$3A,$54,  0,  0,  0,  3,$7F,$73,$75,$62,$24,$72,$64,$62,$61,  0,  0,  0,  0,  1,$39,$6C,  0,  0,  0,  3,$77,$66,$61,$6C,$6C,$6D,$6F,$76,$65,  0,  0,  0,  0,  1,$39,$CA,  0,  0,  0,  4,$7F,$77,$6F,$72,$6B,$6E,$61,$69,$24,$72,$64,$62; 1088
		dc.b $61,  0,  0,  0,  0,  1,$39,$AE,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$72,$64,$62,$61,  0,  0,  0,  0,  1,$39,$B0,  0,  0,  0,  4,$77,$66,$61,$6C,$6C,$5F,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0,  0,  1,$38,$FE,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$73; 1152
		dc.b $64,$62,$61,  0,  0,  1,$39,$FC,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$33,$24,$73,$64,$62,$61,  0,  0,  1,$3A,$34,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$34,$24,$73,$64,$62,$61,  0,  0,  1,$3A,$1C,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$35,$24,$73,$64,$62,$61,  0; 1216
		dc.b   0,  1,$3A,$14,  0,  0,  0,  2,$77,$66,$61,$6C,$6C,  0,  0,  0,  0,  1,$38,$F0,  0,  0,  0,  2,$77,$66,$61,$6C,$6C,$70,$61,$74,  0,  1,$3A,$6C,  0,  0,  0,  3,$77,$66,$61,$6C,$6C,$73,$70,$30,$30,  0,  0,  0,  0,  1,$3A,$A6,  0,  0,  0,  3,$77,$66,$61,$6C; 1280
		dc.b $6C,$73,$70,$30,$31,  0,  0,  0,  0,  1,$3A,$B0,  0,  0,  0,  3,$77,$66,$61,$6C,$6C,$73,$70,$30,$32,  0,  0,  0,  0,  1,$3A,$C2,  0,  0,  0,  3,$77,$66,$61,$6C,$6C,$73,$70,$30,$33,  0,  0,  0,  0,  1,$3A,$D4,  0,  0,  0,  3,$77,$66,$61,$6C,$6C,$73,$70,$30; 1344
		dc.b $34,  0,  0,  0,  0,  1,$3A,$EE,  0,  0,  0,  3,$77,$66,$61,$6C,$6C,$73,$70,$30,$35,  0,  0,  0,  0,  1,$3B,  8,  0,  0,  0,  3,$77,$66,$61,$6C,$6C,$73,$70,$30,$36,  0,  0,  0,  0,  1,$3B,$2A,  0,  0,  0,  3,$77,$66,$61,$6C,$6C,$73,$70,$30,$37,  0,  0,  0; 1408
		dc.b   0,  1,$3B,$4C,  0,  0,  0,  3,$77,$66,$61,$6C,$6C,$73,$70,$30,$38,  0,  0,  0,  0,  1,$3B,$76,  0,  0,  0,  3,$77,$66,$61,$6C,$6C,$73,$70,$30,$39,  0,  0,  0,  0,  1,$3B,$A0,  0,  0,  0,  3,$77,$66,$61,$6C,$6C,$73,$70,$31,$30,  0,  0,  0,  0,  1,$3B,$D2; 1472
		dc.b   0,  0,  0,  3,$77,$66,$61,$6C,$6C,$73,$70,$31,$31,  0,  0,  0,  0,  1,$3C,  4,  0,  0,  0,  3,$77,$66,$61,$6C,$6C,$73,$70,$31,$32,  0,  0,  0,  0,  1,$3C,$3E,  0,  0,  0,  3,$77,$66,$61,$6C,$6C,$73,$70,$31,$33,  0,  0,  0,  0,  1,$3C,$78,  0,  0,  0,  3; 1536
		dc.b $77,$66,$61,$6C,$6C,$73,$70,$31,$34,  0,  0,  0,  0,  1,$3C,$BA,  0,  0,  0,  3,$77,$66,$61,$6C,$6C,$73,$70,$31,$35,  0,  0,  0,  0,  1,$3C,$FC,  0,  0,  0,  3,$77,$66,$61,$6C,$6C,$73,$70,$31,$36,  0,  0,  0,  0,  1,$3D,$46,  0,  0,  0,  3,$77,$66,$61,$6C; 1600
		dc.b $6C,$73,$70,$31,$37,  0,  0,  0,  0,  1,$3D,$46,  0,  0,  0,  3,$77,$66,$61,$6C,$6C,$73,$70,$31,$38,  0,  0,  0,  0,  1,$3D,$46,  0,  0,  0,  3,$77,$66,$61,$6C,$6C,$73,$70,$31,$39,  0,  0,  0,  0,  1,$3A,$A4,  0,  0,  0,  3,$77,$66,$61,$6C,$6C,$73,$70,$32; 1664
		dc.b $30,  0,  0,  0,  0,  1,$3D,$58,  0,  0,  0,  3,$77,$66,$61,$6C,$6C,$73,$70,$32,$31,  0,  0,  0,  0,  1,$3D,$62,  0,  0,  0,  3,$77,$66,$61,$6C,$6C,$73,$70,$32,$32,  0,  0,  0,  0,  1,$3D,$6C,  0,  0,  0,  3,$77,$66,$61,$6C,$6C,$73,$70,$32,$33,  0,  0,  0; 1728
		dc.b   0,  1,$3D,$7E,  0,  0,  0,  3,$77,$66,$61,$6C,$6C,$73,$70,$32,$34,  0,  0,  0,  0,  1,$3D,$90,  0,  0,  0,  3,$77,$66,$61,$6C,$6C,$73,$70,$32,$35,  0,  0,  0,  0,  1,$3D,$AA,  0,  0,  0,  3,$77,$66,$61,$6C,$6C,$73,$70,$32,$36,  0,  0,  0,  0,  1,$3D,$C4; 1792
		dc.b   0,  0,  0,  3,$77,$66,$61,$6C,$6C,$73,$70,$32,$37,  0,  0,  0,  0,  1,$3D,$E6,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$73,$64,$62,$61,  0,  0,  0,  1,$39,$E2,  0,  0,  0,  3,$73,$6C,$6F,$6F,$70,$6D,$6F,$76,$65,  0,  0,  0,  0,  1,$3E,$46,  0,  0,  0,  3; 1856
		dc.b $7F,$6C,$65,$66,$74,$32,$24,$7A,$64,$62,$61,  0,  0,  1,$3E,$BC,  0,  0,  0,  2,$73,$6C,$6F,$6F,$70,$74,$62,$6C,  0,  1,$3F,$8A,  0,  0,  0,  3,$7F,$6C,$65,$66,$74,$24,$7A,$64,$62,$61,  0,  0,  0,  1,$3E,$7C,  0,  0,  0,  3,$7F,$72,$69,$67,$68,$74,$24,$7A; 1920
		dc.b $64,$62,$61,  0,  0,  1,$3E,$8A,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$73,$24,$7A,$64,$62,$61,  0,  0,  1,$3E,$F6,  0,  0,  0,  3,$7F,$73,$75,$62,$24,$7A,$64,$62,$61,  0,  0,  0,  0,  1,$3E,$54,  0,  0,  0,  3,$7F,$72,$69,$64,$65,$6F,$6E,$24,$7A,$64,$62,$61; 1984
		dc.b   0,  1,$3E,$EE,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$7A,$64,$62,$61,  0,  0,  0,  0,  1,$3E,$EC,  0,  0,  0,  3,$73,$6C,$6F,$6F,$70,$64,$69,$72,$74,$62,$6C,  0,  0,  1,$3F,$56,  0,  0,  0,  3,$7F,$72,$69,$67,$68,$74,$32,$24,$7A,$64,$62,$61,  0,  1,$3E,$CA; 2048
		dc.b   0,  0,  0,  2,$73,$6C,$6F,$6F,$70,  0,  0,  0,  0,  1,$3E,  8,  0,  0,  0,  4,$7F,$66,$72,$61,$6D,$65,$6F,$75,$74,$24,$77,$64,$62,$61,  0,  0,  0,  1,$3E,$32,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$30,$24,$7A,$64,$62,$61,  0,  0,  1,$3E,$D6,  0,  0,  0,  3; 2112
		dc.b $7F,$6A,$75,$6D,$70,$31,$24,$7A,$64,$62,$61,  0,  0,  1,$3F,$18,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$7A,$64,$62,$61,  0,  0,  1,$3F,$24,  0,  0,  0,  4,$7F,$66,$72,$61,$6D,$65,$6F,$75,$74,$64,$24,$77,$64,$62,$61,  0,  0,  1,$3E,$1E,  0,  0,  0,  4; 2176
		dc.b $7F,$70,$6C,$72,$69,$64,$65,$6F,$6E,$24,$7A,$64,$62,$61,  0,  0,  0,  1,$3E,$AE,  0,  0,  0,  4,$73,$6C,$6F,$6F,$70,$5F,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0,  0,  1,$3E,$38,  0,  0,  0,  3,$73,$6C,$6F,$6F,$70,$69,$6E,$69,$74,  0,  0,  0,  0,  1,$3E,$3C; 2240
		dc.b   0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$7A,$64,$62,$61,  0,  0,  0,  1,$3E,$96,  0,  0,  0,  3,$73,$62,$61,$6C,$6C,$69,$6E,$69,$74,  0,  0,  0,  0,  1,$42,$C8,  0,  0,  0,  2,$73,$69,$73,$6F,$6F,  0,  0,  0,  0,  1,$41,$2C,  0,  0,  0,  3,$7F,$6A,$75,$6D; 2304
		dc.b $70,$24,$66,$65,$62,$61,  0,  0,  0,  1,$41,$C6,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$67,$65,$62,$61,  0,  0,  0,  1,$41,$EC,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$69,$65,$62,$61,  0,  0,  0,  1,$42,$94,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$6B,$65; 2368
		dc.b $62,$61,  0,  0,  0,  1,$43,$28,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$6C,$65,$62,$61,  0,  0,  0,  1,$43,$3C,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$6D,$65,$62,$61,  0,  0,  0,  1,$44,$18,  0,  0,  0,  3,$73,$69,$73,$6F,$6F,$73,$75,$62,$32,  0,  0,  0; 2432
		dc.b   0,  1,$42,$9C,  0,  0,  0,  3,$73,$62,$61,$6C,$6C,$6D,$6F,$76,$65,  0,  0,  0,  0,  1,$43,$BC,  0,  0,  0,  3,$7F,$64,$6F,$77,$6E,$24,$6D,$65,$62,$61,  0,  0,  0,  1,$43,$DA,  0,  0,  0,  2,$73,$62,$61,$6C,$6C,$70,$61,$74,  0,  1,$45,$78,  0,  0,  0,  3; 2496
		dc.b $7F,$73,$75,$62,$24,$6D,$65,$62,$61,  0,  0,  0,  0,  1,$44,$50,  0,  0,  0,  2,$73,$69,$73,$6F,$6F,$70,$61,$74,  0,  1,$44,$EC,  0,  0,  0,  3,$7F,$72,$69,$64,$65,$6F,$6E,$24,$67,$65,$62,$61,  0,  1,$41,$D8,  0,  0,  0,  3,$73,$62,$61,$6C,$6C,$77,$61,$69; 2560
		dc.b $74,  0,  0,  0,  0,  1,$43,$28,  0,  0,  0,  2,$7F,$75,$70,$24,$6D,$65,$62,$61,  0,  1,$43,$C2,  0,  0,  0,  3,$73,$69,$73,$6F,$6F,$69,$6E,$69,$74,  0,  0,  0,  0,  1,$41,$5E,  0,  0,  0,  4,$7F,$77,$6F,$72,$6B,$6E,$61,$69,$24,$66,$65,$62,$61,  0,  0,  0; 2624
		dc.b   0,  1,$41,$B8,  0,  0,  0,  3,$7F,$6E,$6F,$72,$69,$64,$65,$24,$67,$65,$62,$61,  0,  1,$42,$26,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$6A,$65,$62,$61,  0,  0,  0,  0,  1,$42,$C6,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$6D,$65,$62,$61,  0,  0,  0,  0,  1,$43,$D8; 2688
		dc.b   0,  0,  0,  3,$73,$69,$73,$6F,$6F,$6D,$6F,$76,$65,  0,  0,  0,  0,  1,$41,$CC,  0,  0,  0,  3,$73,$69,$73,$6F,$6F,$72,$69,$64,$65,  0,  0,  0,  0,  1,$42,$7E,  0,  0,  0,  2,$73,$69,$73,$6F,$6F,$73,$75,$62,  0,  1,$42,$80,  0,  0,  0,  3,$7F,$6A,$75,$6D; 2752
		dc.b $70,$34,$34,$24,$67,$65,$62,$61,  0,  1,$42,$22,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$30,$24,$6C,$65,$62,$61,  0,  0,  1,$43,$9C,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$30,$24,$6D,$65,$62,$61,  0,  0,  1,$43,$FA,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$31,$24,$6D; 2816
		dc.b $65,$62,$61,  0,  0,  1,$44,$34,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$67,$65,$62,$61,  0,  0,  1,$41,$F4,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$69,$65,$62,$61,  0,  0,  1,$42,$9C,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$6C,$65,$62,$61,  0; 2880
		dc.b   0,  1,$43,$78,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$6D,$65,$62,$61,  0,  0,  1,$44,$42,  0,  0,  0,  2,$73,$62,$61,$6C,$6C,$73,$70,$30,  0,  1,$45,$7C,  0,  0,  0,  2,$73,$62,$61,$6C,$6C,$73,$70,$31,  0,  1,$45,$7C,  0,  0,  0,  3,$7F,$6A,$75,$6D; 2944
		dc.b $70,$33,$24,$67,$65,$62,$61,  0,  0,  1,$42,$10,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$33,$24,$6A,$65,$62,$61,  0,  0,  1,$42,$A8,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$33,$24,$6C,$65,$62,$61,  0,  0,  1,$43,$62,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$33,$24,$6D; 3008
		dc.b $65,$62,$61,  0,  0,  1,$44,$4E,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$34,$24,$67,$65,$62,$61,  0,  0,  1,$42,$18,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$34,$24,$6C,$65,$62,$61,  0,  0,  1,$43,$7E,  0,  0,  0,  2,$73,$69,$73,$6F,$6F,$73,$70,$30,  0,  1,$44,$F4; 3072
		dc.b   0,  0,  0,  2,$73,$69,$73,$6F,$6F,$73,$70,$31,  0,  1,$45,$36,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$35,$24,$67,$65,$62,$61,  0,  0,  1,$42,$42,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$36,$24,$67,$65,$62,$61,  0,  0,  1,$42,$4A,  0,  0,  0,  3,$7F,$6A,$75,$6D; 3136
		dc.b $70,$37,$24,$67,$65,$62,$61,  0,  0,  1,$42,$4A,  0,  0,  0,  2,$73,$62,$61,$6C,$6C,$74,$62,$6C,  0,  1,$44,$80,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$38,$24,$67,$65,$62,$61,  0,  0,  1,$42,$62,  0,  0,  0,  4,$73,$69,$73,$6F,$6F,$5F,$6D,$6F,$76,$65,$5F,$74; 3200
		dc.b $62,$6C,  0,  0,  0,  1,$41,$52,  0,  0,  0,  2,$73,$69,$73,$6F,$6F,$74,$62,$6C,  0,  1,$44,$8A,  0,  0,  0,  3,$73,$69,$73,$6F,$6F,$74,$62,$6C,$32,  0,  0,  0,  0,  1,$44,$BB,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$6F,$65,$62,$61,  0,  0,  0,  1,$47,$DC; 3264
		dc.b   0,  0,  0,  2,$74,$61,$6B,$69,$69,$6E,$69,$74,  0,  1,$47,$56,  0,  0,  0,  2,$77,$61,$74,$65,$72,  0,  0,  0,  0,  1,$45,$88,  0,  0,  0,  3,$77,$61,$74,$65,$72,$70,$61,$74,$74,$62,$6C,  0,  0,  1,$46,$14,  0,  0,  0,  2,$74,$61,$6B,$69,$6D,$6F,$76,$65; 3328
		dc.b   0,  1,$47,$90,  0,  0,  0,  2,$77,$61,$74,$65,$72,$70,$61,$74,  0,  1,$46,$54,  0,  0,  0,  4,$77,$61,$74,$65,$72,$5F,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0,  0,  1,$45,$96,  0,  0,  0,  3,$77,$61,$74,$65,$72,$69,$6E,$69,$74,  0,  0,  0,  0,  1,$45,$9A; 3392
		dc.b   0,  0,  0,  3,$7F,$65,$6E,$64,$24,$6F,$65,$62,$61,  0,  0,  0,  0,  1,$47,$EE,  0,  0,  0,  4,$74,$61,$6B,$69,$5F,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0,  0,  0,  1,$47,$52,  0,  0,  0,  2,$74,$61,$6B,$69,$70,$61,$74,  0,  0,  1,$47,$F6,  0,  0,  0,  3; 3456
		dc.b $77,$61,$74,$65,$72,$6D,$6F,$76,$65,  0,  0,  0,  0,  1,$45,$C2,  0,  0,  0,  1,$74,$61,$6B,$69,  0,  1,$47,$44,  0,  0,  0,  2,$74,$61,$6B,$69,$73,$70,$30,$30,  0,  1,$47,$FE,  0,  0,  0,  2,$74,$61,$6B,$69,$73,$70,$30,$31,  0,  1,$48,$10,  0,  0,  0,  2; 3520
		dc.b $74,$61,$6B,$69,$73,$70,$30,$32,  0,  1,$48,$82,  0,  0,  0,  2,$74,$61,$6B,$69,$73,$70,$30,$33,  0,  1,$48,$84,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$30,$24,$63,$65,$62,$61,  0,  0,  1,$45,$E4,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$31,$24,$63,$65,$62,$61,  0; 3584
		dc.b   0,  1,$45,$F4,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$63,$65,$62,$61,  0,  0,  1,$45,$F4,  0,  0,  0,  2,$77,$61,$74,$65,$72,$73,$70,$30,  0,  1,$46,$60,  0,  0,  0,  2,$77,$61,$74,$65,$72,$73,$70,$31,  0,  1,$46,$7A,  0,  0,  0,  2,$77,$61,$74,$65; 3648
		dc.b $72,$73,$70,$32,  0,  1,$46,$94,  0,  0,  0,  2,$77,$61,$74,$65,$72,$73,$70,$33,  0,  1,$46,$AE,  0,  0,  0,  2,$77,$61,$74,$65,$72,$73,$70,$34,  0,  1,$46,$E0,  0,  0,  0,  2,$77,$61,$74,$65,$72,$73,$70,$35,  0,  1,$47,$12,  0,  0,  0,  4,$7F,$66,$72,$61; 3712
		dc.b $6D,$65,$6F,$75,$74,$64,$24,$6F,$65,$62,$61,  0,  0,  1,$47,$AA,  0,  0,  0,  2,$73,$74,$65,$67,$6F,$63,$68,$67,  0,  1,$4A,$1E,  0,  0,  0,  2,$73,$74,$65,$67,$6F,  0,  0,  0,  0,  1,$48,$D0,  0,  0,  0,  3,$73,$74,$65,$67,$6F,$63,$68,$67,$30,$30,  0,  0; 3776
		dc.b   0,  1,$4A,$24,  0,  0,  0,  3,$73,$74,$65,$67,$6F,$63,$68,$67,$30,$31,  0,  0,  0,  1,$4A,$32,  0,  0,  0,  3,$73,$74,$65,$67,$6F,$63,$68,$67,$30,$32,  0,  0,  0,  1,$4A,$35,  0,  0,  0,  3,$73,$74,$65,$67,$6F,$73,$70,$30,$30,  0,  0,  0,  0,  1,$4A,$4A; 3840
		dc.b   0,  0,  0,  3,$73,$74,$65,$67,$6F,$73,$70,$30,$31,  0,  0,  0,  0,  1,$4A,$74,  0,  0,  0,  3,$73,$74,$65,$67,$6F,$73,$70,$30,$32,  0,  0,  0,  0,  1,$4A,$9E,  0,  0,  0,  3,$73,$74,$65,$67,$6F,$73,$70,$30,$33,  0,  0,  0,  0,  1,$4A,$C8,  0,  0,  0,  3; 3904
		dc.b $73,$74,$65,$67,$6F,$73,$70,$30,$34,  0,  0,  0,  0,  1,$4A,$F2,  0,  0,  0,  3,$73,$74,$65,$67,$6F,$73,$70,$30,$35,  0,  0,  0,  0,  1,$4B,$1C,  0,  0,  0,  3,$73,$74,$65,$67,$6F,$73,$70,$30,$36,  0,  0,  0,  0,  1,$4B,$46,  0,  0,  0,  3,$73,$74,$65,$67; 3968
		dc.b $6F,$73,$70,$30,$37,  0,  0,  0,  0,  1,$4B,$68,  0,  0,  0,  3,$7F,$6F,$75,$74,$30,$24,$75,$64,$62,$61,  0,  0,  0,  1,$49,$E6,  0,  0,  0,  3,$7F,$6F,$75,$74,$31,$24,$75,$64,$62,$61,  0,  0,  0,  1,$4A,$10,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$74,$64,$62; 4032
		dc.b $61,  0,  0,  0,  0,  1,$49,$9A,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$70,$64,$62,$61,  0,  0,  0,  0,  1,$49,$30,  0,  0,  0,  3,$7F,$6F,$75,$74,$24,$75,$64,$62,$61,  0,  0,  0,  0,  1,$49,$E4,  0,  0,  0,  3,$73,$74,$65,$67,$6F,$69,$6E,$69,$74,  0,  0,  0; 4096
		dc.b   0,  1,$48,$E2,  0,  0,  0,  3,$7F,$6C,$66,$74,$24,$75,$64,$62,$61,  0,  0,  0,  0,  1,$49,$CA,  0,  0,  0,  2,$73,$74,$65,$67,$6F,$70,$61,$74,  0,  1,$4A,$3A,  0,  0,  0,  4,$73,$74,$65,$67,$6F,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0,  0,  0,  1,$49,$4E; 4160
		dc.b   0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$74,$64,$62,$61,  0,  0,  1,$49,$9C,  0,  0,  0,  2,$73,$74,$65,$67,$6F,$5F,$30,  0,  0,  1,$49,$52,  0,  0,  0,  2,$73,$74,$65,$67,$6F,$5F,$31,  0,  0,  1,$49,$76,  0,  0,  0,  3,$73,$74,$65,$67,$6F,$6D,$6F,$76; 4224
		dc.b $65,  0,  0,  0,  0,  1,$49,$32,  0,  0,  0,  4,$73,$74,$65,$67,$6F,$5F,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0,  0,  1,$48,$DE,  0,  0,  0,  3,$63,$68,$65,$63,$6B,$73,$6F,$6E,$69,$63,  0,  0,  0,  1,$49,$C0,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$73,$64; 4288
		dc.b $62,$61,  0,  0,  0,  1,$49,$74,  0,  0,  0,  2,$7F,$72,$74,$24,$75,$64,$62,$61,  0,  1,$49,$F4,  0,  0,  0,  3,$7F,$62,$65,$6C,$6F,$77,$24,$61,$65,$62,$61,  0,  0,  1,$4D,  8,  0,  0,  0,  4,$66,$69,$73,$68,$32,$5F,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0; 4352
		dc.b   0,  1,$4B,$AE,  0,  0,  0,  3,$66,$69,$73,$68,$32,$6A,$75,$6D,$70,  0,  0,  0,  0,  1,$4C,$9C,  0,  0,  0,  3,$62,$66,$69,$73,$68,$32,$70,$61,$74,  0,  0,  0,  0,  1,$4D,$B2,  0,  0,  0,  2,$66,$69,$73,$68,$63,$68,$67,  0,  0,  1,$4D,$9A,  0,  0,  0,  3; 4416
		dc.b $66,$69,$73,$68,$32,$69,$6E,$69,$74,  0,  0,  0,  0,  1,$4B,$B4,  0,  0,  0,  3,$7F,$73,$75,$62,$24,$62,$65,$62,$61,  0,  0,  0,  0,  1,$4D,$80,  0,  0,  0,  2,$66,$69,$73,$68,$63,$68,$67,$30,  0,  1,$4D,$A2,  0,  0,  0,  2,$66,$69,$73,$68,$63,$68,$67,$31; 4480
		dc.b   0,  1,$4D,$A6,  0,  0,  0,  2,$66,$69,$73,$68,$63,$68,$67,$32,  0,  1,$4D,$AA,  0,  0,  0,  2,$66,$69,$73,$68,$63,$68,$67,$33,  0,  1,$4D,$AE,  0,  0,  0,  3,$7F,$73,$6B,$69,$70,$24,$7A,$64,$62,$61,  0,  0,  0,  1,$4C,$38,  0,  0,  0,  2,$62,$66,$69,$73; 4544
		dc.b $68,$32,  0,  0,  0,  1,$4B,$A0,  0,  0,  0,  4,$77,$61,$74,$65,$72,$73,$70,$65,$65,$64,$73,$65,$74,  0,  0,  0,  0,  1,$4D,$4C,  0,  0,  0,  3,$66,$69,$73,$68,$32,$6D,$6F,$76,$65,  0,  0,  0,  0,  1,$4C,$2C,  0,  0,  0,  3,$7F,$6A,$6F,$69,$6E,$24,$61,$65; 4608
		dc.b $62,$61,  0,  0,  0,  1,$4D,$22,  0,  0,  0,  3,$7F,$63,$6E,$74,$24,$62,$65,$62,$61,  0,  0,  0,  0,  1,$4D,$88,  0,  0,  0,  3,$7F,$6C,$65,$76,$65,$6C,$24,$61,$65,$62,$61,  0,  0,  1,$4C,$F4,  0,  0,  0,  2,$62,$66,$69,$73,$68,$70,$61,$74,  0,  1,$4D,$B2; 4672
		dc.b   0,  0,  0,  2,$66,$69,$73,$68,$31,$73,$70,$30,  0,  1,$4D,$BA,  0,  0,  0,  2,$66,$69,$73,$68,$31,$73,$70,$31,  0,  1,$4D,$C4,  0,  0,  0,  2,$66,$69,$73,$68,$31,$73,$70,$32,  0,  1,$4D,$CE,  0,  0,  0,  2,$66,$69,$73,$68,$31,$73,$70,$33,  0,  1,$4D,$D8; 4736
		dc.b   0,  0,  0,  2,$62,$66,$69,$73,$68,  0,  0,  0,  0,  1,$4B,$A0,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$79,$64,$62,$61,  0,  0,  0,  1,$4C,$2C,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$7A,$64,$62,$61,  0,  0,  0,  1,$4C,$5A,  0,  0,  0,  1,$72,$65,$64,$7A; 4800
		dc.b   0,  1,$4D,$F8,  0,  0,  0,  4,$7F,$66,$72,$61,$6D,$65,$6F,$75,$74,$32,$24,$71,$64,$62,$61,  0,  0,  1,$4E,$A4,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$74,$64,$62,$61,  0,  0,  0,  0,  1,$4E,$EA,  0,  0,  0,  2,$72,$65,$64,$7A,$70,$61,$74,  0,  0,  1,$4F,$16; 4864
		dc.b   0,  0,  0,  3,$7F,$65,$6E,$64,$24,$70,$64,$62,$61,  0,  0,  0,  0,  1,$4E,$60,  0,  0,  0,  2,$72,$65,$64,$7A,$69,$6E,$69,$74,  0,  1,$4E, $C,  0,  0,  0,  2,$72,$65,$64,$7A,$6D,$6F,$76,$65,  0,  1,$4E,$62,  0,  0,  0,  2,$72,$65,$64,$7A,$5F,$30,  0,  0; 4928
		dc.b   0,  1,$4E,$AC,  0,  0,  0,  2,$72,$65,$64,$7A,$5F,$31,  0,  0,  0,  1,$4E,$D0,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$74,$64,$62,$61,  0,  0,  1,$4E,$EC,  0,  0,  0,  3,$72,$65,$64,$7A,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  1,$4E,$A8,  0,  0,  0,  4; 4992
		dc.b $7F,$66,$72,$61,$6D,$65,$6F,$75,$74,$24,$71,$64,$62,$61,  0,  0,  0,  1,$4E,$92,  0,  0,  0,  2,$72,$65,$64,$7A,$63,$68,$67,$30,  0,  1,$4F, $C,  0,  0,  0,  2,$72,$65,$64,$7A,$63,$68,$67,$31,  0,  1,$4F, $F,  0,  0,  0,  2,$72,$65,$64,$7A,$63,$68,$67,  0; 5056
		dc.b   0,  1,$4F,  8,  0,  0,  0,  4,$72,$65,$64,$7A,$5F,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0,  0,  0,  1,$4E,  6,  0,  0,  0,  2,$72,$65,$64,$7A,$73,$70,$30,  0,  0,  1,$4F,$1C,  0,  0,  0,  2,$72,$65,$64,$7A,$73,$70,$31,  0,  0,  1,$4F,$26,  0,  0,  0,  2; 5120
		dc.b $72,$65,$64,$7A,$73,$70,$32,  0,  0,  1,$4F,$30,  0,  0,  0,  2,$72,$65,$64,$7A,$64,$69,$65,  0,  0,  1,$4F,  4,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$73,$64,$62,$61,  0,  0,  0,  1,$4E,$CE,  0,  0,  0,  3,$7F,$61,$62,$6F,$76,$65,$24,$63,$67,$62,$61,  0; 5184
		dc.b   0,  1,$56,$C6,  0,  0,  0,  3,$7F,$61,$62,$6F,$76,$65,$24,$66,$67,$62,$61,  0,  0,  1,$57,$68,  0,  0,  0,  3,$73,$68,$6F,$74,$64,$72,$6F,$70,$73,  0,  0,  0,  0,  1,$52,$66,  0,  0,  0,  3,$7F,$73,$70,$65,$65,$64,$24,$66,$67,$62,$61,  0,  0,  1,$57,$84; 5248
		dc.b   0,  0,  0,  2,$73,$6B,$79,$68,$6F,$72,$73,$65,  0,  1,$55,$78,  0,  0,  0,  2,$63,$68,$6B,$66,$6C,$6F,$61,$74,  0,  1,$51,$D8,  0,  0,  0,  2,$75,$70,$64,$61,$74,$6F,$69,$6C,  0,  1,$52,$A6,  0,  0,  0,  3,$6C,$61,$6E,$64,$65,$64,$79,$65,$74,  0,  0,  0; 5312
		dc.b   0,  1,$52,$F2,  0,  0,  0,  4,$73,$6B,$79,$68,$6F,$72,$73,$65,$61,$74,$74,$61,$63,$6B,  0,  0,  0,  1,$56,$3E,  0,  0,  0,  4,$73,$65,$61,$68,$6F,$72,$73,$65,$61,$74,$74,$61,$63,$6B,  0,  0,  0,  1,$50,$BA,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$71,$65; 5376
		dc.b $62,$61,  0,  0,  0,  1,$53,$4E,  0,  0,  0,  2,$63,$68,$6B,$66,$6C,$69,$70,  0,  0,  1,$53,$32,  0,  0,  0,  2,$73,$65,$61,$68,$6F,$72,$73,$65,  0,  1,$4F,$5C,  0,  0,  0,  3,$68,$6F,$72,$73,$65,$73,$70,$30,$35,  0,  0,  0,  0,  1,$54,$B8,  0,  0,  0,  3; 5440
		dc.b $68,$6F,$72,$73,$65,$73,$70,$30,$36,  0,  0,  0,  0,  1,$54,$C2,  0,  0,  0,  3,$68,$6F,$72,$73,$65,$73,$70,$30,$37,  0,  0,  0,  0,  1,$54,$CC,  0,  0,  0,  3,$68,$6F,$72,$73,$65,$73,$70,$30,$38,  0,  0,  0,  0,  1,$54,$D6,  0,  0,  0,  2,$68,$6F,$72,$73; 5504
		dc.b $65,$70,$61,$74,  0,  1,$54,$2C,  0,  0,  0,  3,$7F,$64,$6F,$6E,$65,$24,$6F,$65,$62,$61,  0,  0,  0,  1,$52,$E4,  0,  0,  0,  3,$68,$69,$74,$67,$72,$6F,$75,$6E,$64,  0,  0,  0,  0,  1,$52,$7C,  0,  0,  0,  3,$73,$6B,$79,$68,$6F,$72,$73,$65,$73,$70,$30,$30; 5568
		dc.b   0,  1,$54,$E0,  0,  0,  0,  3,$73,$6B,$79,$68,$6F,$72,$73,$65,$73,$70,$30,$31,  0,  1,$55,  2,  0,  0,  0,  3,$73,$6B,$79,$68,$6F,$72,$73,$65,$73,$70,$30,$32,  0,  1,$55,$24,  0,  0,  0,  3,$73,$6B,$79,$68,$6F,$72,$73,$65,$73,$70,$30,$33,  0,  1,$55,$4E; 5632
		dc.b   0,  0,  0,  2,$63,$68,$6B,$68,$69,$74,  0,  0,  0,  1,$53,$50,  0,  0,  0,  3,$7F,$6E,$6F,$72,$6D,$61,$6C,$24,$69,$65,$62,$61,  0,  1,$52,$5C,  0,  0,  0,  2,$66,$69,$78,$77,$69,$6E,$67,$73,  0,  1,$52,$2C,  0,  0,  0,  3,$7F,$6C,$65,$66,$74,$24,$72,$65; 5696
		dc.b $62,$61,  0,  0,  0,  1,$53,$B8,  0,  0,  0,  3,$73,$65,$61,$68,$6F,$72,$73,$65,$73,$70,$30,$30,  0,  1,$54,$46,  0,  0,  0,  3,$73,$65,$61,$68,$6F,$72,$73,$65,$73,$70,$30,$31,  0,  1,$54,$60,  0,  0,  0,  3,$73,$65,$61,$68,$6F,$72,$73,$65,$73,$70,$30,$32; 5760
		dc.b   0,  1,$54,$6A,  0,  0,  0,  3,$73,$65,$61,$68,$6F,$72,$73,$65,$73,$70,$30,$33,  0,  1,$54,$74,  0,  0,  0,  3,$73,$65,$61,$68,$6F,$72,$73,$65,$73,$70,$30,$34,  0,  1,$54,$96,  0,  0,  0,  3,$7F,$65,$64,$67,$65,$24,$66,$65,$62,$61,  0,  0,  0,  1,$51,$BC; 5824
		dc.b   0,  0,  0,  5,$73,$65,$61,$68,$6F,$72,$73,$65,$5F,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0,  0,  0,  1,$4F,$6A,  0,  0,  0,  5,$73,$6B,$79,$68,$6F,$72,$73,$65,$5F,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0,  0,  0,  1,$55,$86,  0,  0,  0,  3,$73,$6B,$79,$68; 5888
		dc.b $6F,$72,$73,$65,$69,$6E,$69,$74,  0,  1,$55,$92,  0,  0,  0,  3,$7F,$62,$65,$6C,$6F,$77,$24,$66,$67,$62,$61,  0,  0,  1,$57,$8C,  0,  0,  0,  2,$6D,$61,$6B,$65,$73,$68,$6F,$74,  0,  1,$56,$F2,  0,  0,  0,  3,$7F,$64,$6F,$77,$6E,$24,$68,$65,$62,$61,  0,  0; 5952
		dc.b   0,  1,$52,$18,  0,  0,  0,  4,$7F,$6D,$61,$6B,$65,$73,$68,$6F,$74,$24,$64,$65,$62,$61,  0,  0,  0,  1,$50,$DA,  0,  0,  0,  2,$63,$68,$6B,$61,$74,$61,$63,$6B,  0,  1,$51,$70,  0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$24,$72,$65,$62,$61,  0,  0,  0,  1,$53,$5A; 6016
		dc.b   0,  0,  0,  4,$7F,$77,$6F,$72,$6B,$6E,$61,$69,$24,$76,$64,$62,$61,  0,  0,  0,  0,  1,$50,$2E,  0,  0,  0,  3,$7F,$64,$6F,$6E,$65,$24,$62,$67,$62,$61,  0,  0,  0,  1,$56,$68,  0,  0,  0,  2,$68,$6F,$72,$73,$65,$63,$68,$67,  0,  1,$53,$F4,  0,  0,  0,  4; 6080
		dc.b $7F,$74,$6F,$72,$69,$67,$68,$74,$24,$66,$65,$62,$61,  0,  0,  0,  0,  1,$51,$AE,  0,  0,  0,  3,$7F,$76,$65,$6C,$24,$67,$65,$62,$61,  0,  0,  0,  0,  1,$51,$F4,  0,  0,  0,  4,$7F,$77,$6F,$72,$6B,$6E,$61,$69,$24,$72,$65,$62,$61,  0,  0,  0,  0,  1,$53,$CC; 6144
		dc.b   0,  0,  0,  4,$7F,$77,$6F,$72,$6B,$6E,$61,$69,$24,$64,$65,$62,$61,  0,  0,  0,  0,  1,$51,$46,  0,  0,  0,  3,$73,$65,$61,$68,$6F,$72,$73,$65,$69,$6E,$69,$74,  0,  1,$4F,$76,  0,  0,  0,  3,$63,$68,$6B,$66,$6C,$74,$64,$6F,$6E,$65,  0,  0,  0,  1,$51,$FA; 6208
		dc.b   0,  0,  0,  3,$7F,$65,$6E,$64,$24,$64,$65,$62,$61,  0,  0,  0,  0,  1,$50,$D8,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$65,$65,$62,$61,  0,  0,  0,  0,  1,$51,$6E,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$66,$65,$62,$61,  0,  0,  0,  0,  1,$51,$D6,  0,  0,  0,  3; 6272
		dc.b $7F,$65,$6E,$64,$24,$67,$65,$62,$61,  0,  0,  0,  0,  1,$51,$F8,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$68,$65,$62,$61,  0,  0,  0,  0,  1,$52,$16,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$6B,$65,$62,$61,  0,  0,  0,  0,  1,$52,$96,  0,  0,  0,  3,$7F,$6F,$75,$74; 6336
		dc.b $24,$72,$65,$62,$61,  0,  0,  0,  0,  1,$53,$EE,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$6F,$65,$62,$61,  0,  0,  0,  0,  1,$52,$E2,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$70,$65,$62,$61,  0,  0,  0,  0,  1,$53,$30,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$72,$65,$62; 6400
		dc.b $61,  0,  0,  0,  0,  1,$53,$F2,  0,  0,  0,  2,$63,$68,$6B,$73,$68,$6F,$74,  0,  0,  1,$50,$CC,  0,  0,  0,  2,$7F,$6F,$6B,$24,$64,$65,$62,$61,  0,  1,$51,$3A,  0,  0,  0,  3,$73,$65,$65,$6B,$73,$6F,$6E,$69,$63,  0,  0,  0,  0,  1,$57,$5C,  0,  0,  0,  3; 6464
		dc.b $68,$6F,$72,$73,$65,$63,$68,$67,$32,  0,  0,  0,  0,  1,$54, $F,  0,  0,  0,  2,$7F,$72,$31,$24,$72,$65,$62,$61,  0,  1,$53,$C6,  0,  0,  0,  3,$73,$65,$61,$68,$6F,$72,$73,$65,$73,$77,$69,$6D,  0,  1,$50,$9A,  0,  0,  0,  2,$6F,$69,$6C,$73,$6C,$69,$70,  0; 6528
		dc.b   0,  1,$52,$A2,  0,  0,  0,  3,$73,$6B,$79,$68,$6F,$72,$73,$65,$63,$68,$67,$30,  0,  1,$54,$1F,  0,  0,  0,  3,$73,$6B,$79,$68,$6F,$72,$73,$65,$63,$68,$67,$31,  0,  1,$54,$23,  0,  0,  0,  3,$7F,$74,$6F,$6C,$65,$66,$74,$24,$66,$65,$62,$61,  0,  1,$51,$9E; 6592
		dc.b   0,  0,  0,  3,$73,$6B,$79,$68,$6F,$72,$73,$65,$6D,$6F,$76,$65,  0,  1,$55,$F0,  0,  0,  0,  3,$73,$65,$61,$68,$6F,$72,$73,$65,$73,$68,$6F,$74,  0,  1,$50,$84,  0,  0,  0,  3,$63,$68,$6B,$61,$74,$6B,$64,$6F,$6E,$65,  0,  0,  0,  1,$51,$48,  0,  0,  0,  3; 6656
		dc.b $73,$65,$61,$68,$6F,$72,$73,$65,$63,$68,$67,$30,  0,  1,$54,  4,  0,  0,  0,  3,$73,$65,$61,$68,$6F,$72,$73,$65,$63,$68,$67,$31,  0,  1,$54,  7,  0,  0,  0,  3,$73,$65,$61,$68,$6F,$72,$73,$65,$63,$68,$67,$33,  0,  1,$54,$15,  0,  0,  0,  3,$73,$65,$61,$68; 6720
		dc.b $6F,$72,$73,$65,$63,$68,$67,$34,  0,  1,$54,$19,  0,  0,  0,  3,$73,$65,$61,$68,$6F,$72,$73,$65,$63,$68,$67,$35,  0,  1,$54,$1C,  0,  0,  0,  4,$73,$6B,$79,$68,$6F,$72,$73,$65,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  1,$56,$10,  0,  0,  0,  3,$67,$65,$74,$70; 6784
		dc.b $6F,$73,$69,$74,$69,$6F,$6E,  0,  0,  1,$56,$7A,  0,  0,  0,  3,$73,$65,$61,$68,$6F,$72,$73,$65,$6D,$6F,$76,$65,  0,  1,$50,$2E,  0,  0,  0,  3,$73,$6B,$79,$68,$6F,$72,$73,$65,$73,$68,$6F,$74,  0,  1,$56,$14,  0,  0,  0,  4,$7F,$77,$6F,$72,$6B,$6E,$61,$69; 6848
		dc.b $24,$65,$67,$62,$61,  0,  0,  0,  0,  1,$57,$5A,  0,  0,  0,  3,$7F,$6E,$65,$78,$74,$24,$63,$67,$62,$61,  0,  0,  0,  1,$56,$A6,  0,  0,  0,  4,$73,$65,$61,$68,$6F,$72,$73,$65,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  1,$50,$54,  0,  0,  0,  3,$7F,$65,$6E,$64; 6912
		dc.b $24,$64,$67,$62,$61,  0,  0,  0,  0,  1,$56,$F0,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$66,$67,$62,$61,  0,  0,  0,  0,  1,$57,$B0,  0,  0,  0,  3,$7F,$6F,$75,$74,$24,$63,$67,$62,$61,  0,  0,  0,  0,  1,$56,$CA,  0,  0,  0,  3,$7F,$6F,$75,$74,$24,$66,$67,$62; 6976
		dc.b $61,  0,  0,  0,  0,  1,$57,$BA,  0,  0,  0,  2,$7F,$6F,$6B,$24,$65,$67,$62,$61,  0,  1,$57,$4E,  0,  0,  0,  4,$7F,$6E,$65,$67,$73,$70,$65,$65,$64,$24,$66,$67,$62,$61,  0,  0,  0,  1,$57,$A8,  0,  0,  0,  3,$73,$6B,$79,$68,$6F,$72,$73,$65,$66,$6C,$79,  0; 7040
		dc.b   0,  1,$56,$28,  0,  0,  0,  3,$7F,$74,$6F,$6C,$65,$66,$74,$24,$63,$67,$62,$61,  0,  1,$56,$9A,  0,  0,  0,  4,$73,$65,$61,$68,$6F,$72,$73,$65,$66,$6C,$6F,$61,$74,  0,  0,  0,  0,  1,$50,$AC,  0,  0,  0,  2,$63,$68,$6B,$73,$68,$6F,$6F,$74,  0,  1,$56,$CC; 7104
		dc.b   0,  0,  0,  4,$73,$65,$61,$68,$6F,$72,$73,$65,$77,$69,$6E,$67,$73,  0,  0,  0,  0,  1,$50,$5A,  0,  0,  0,  3,$73,$68,$6F,$74,$73,$74,$61,$74,$75,$73,  0,  0,  0,  1,$56,$54,  0,  0,  0,  4,$7F,$73,$65,$74,$62,$65,$68,$69,$6E,$64,$24,$63,$67,$62,$61,  0; 7168
		dc.b   0,  1,$56,$A2,  0,  0,  0,  3,$77,$61,$73,$70,$63,$68,$67,$30,$30,  0,  0,  0,  0,  1,$5A,$20,  0,  0,  0,  3,$77,$61,$73,$70,$63,$68,$67,$30,$31,  0,  0,  0,  0,  1,$5A,$23,  0,  0,  0,  3,$77,$61,$73,$70,$63,$68,$67,$30,$32,  0,  0,  0,  0,  1,$5A,$27; 7232
		dc.b   0,  0,  0,  3,$77,$61,$73,$70,$63,$68,$67,$30,$33,  0,  0,  0,  0,  1,$5A,$2B,  0,  0,  0,  3,$63,$68,$65,$63,$6B,$73,$68,$6F,$6F,$74,  0,  0,  0,  1,$59,$4A,  0,  0,  0,  3,$7F,$64,$6F,$6E,$65,$24,$67,$65,$62,$61,  0,  0,  0,  1,$58,$E6,  0,  0,  0,  3; 7296
		dc.b $7F,$64,$6F,$6E,$65,$24,$6C,$65,$62,$61,  0,  0,  0,  1,$59,$AC,  0,  0,  0,  2,$77,$61,$73,$70,$69,$6E,$69,$74,  0,  1,$58,$44,  0,  0,  0,  2,$77,$61,$73,$70,$63,$68,$67,  0,  0,  1,$5A,$18,  0,  0,  0,  2,$77,$61,$73,$70,$6D,$6F,$76,$65,  0,  1,$58,$E8; 7360
		dc.b   0,  0,  0,  3,$77,$61,$73,$70,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  1,$59,  4,  0,  0,  0,  3,$7F,$68,$65,$72,$65,$32,$24,$6A,$65,$62,$61,  0,  0,  1,$59,$2E,  0,  0,  0,  3,$77,$61,$73,$70,$61,$66,$74,$65,$72,$62,  0,  0,  0,  1,$58, $C,  0,  0,  0,  2; 7424
		dc.b $77,$61,$73,$70,$73,$68,$6F,$74,  0,  1,$57,$FA,  0,  0,  0,  3,$7F,$6F,$75,$74,$24,$6B,$65,$62,$61,  0,  0,  0,  0,  1,$59,$96,  0,  0,  0,  3,$7F,$6F,$75,$74,$24,$6C,$65,$62,$61,  0,  0,  0,  0,  1,$5A,$16,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$6A,$65,$62; 7488
		dc.b $61,  0,  0,  0,  0,  1,$59,$2C,  0,  0,  0,  3,$77,$61,$73,$70,$73,$68,$6F,$6F,$74,  0,  0,  0,  0,  1,$59,$98,  0,  0,  0,  3,$7F,$74,$6F,$6C,$65,$66,$74,$24,$6B,$65,$62,$61,  0,  1,$59,$7A,  0,  0,  0,  3,$7F,$68,$65,$72,$65,$24,$6A,$65,$62,$61,  0,  0; 7552
		dc.b   0,  1,$59,$26,  0,  0,  0,  3,$7F,$68,$65,$72,$65,$24,$6C,$65,$62,$61,  0,  0,  0,  1,$59,$B2,  0,  0,  0,  3,$7F,$63,$6E,$74,$24,$66,$65,$62,$61,  0,  0,  0,  0,  1,$58,$1E,  0,  0,  0,  3,$7F,$63,$6E,$74,$24,$6B,$65,$62,$61,  0,  0,  0,  0,  1,$59,$60; 7616
		dc.b   0,  0,  0,  4,$77,$61,$73,$70,$5F,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0,  0,  0,  1,$57,$F2,  0,  0,  0,  2,$77,$61,$73,$70,$66,$6C,$79,  0,  0,  1,$59,  8,  0,  0,  0,  1,$77,$61,$73,$70,  0,  1,$57,$E0,  0,  0,  0,  3,$7F,$73,$68,$74,$24,$6B,$65,$62; 7680
		dc.b $61,  0,  0,  0,  0,  1,$59,$82,  0,  0,  0,  2,$77,$61,$73,$70,$73,$70,$30,$30,  0,  1,$5A,$42,  0,  0,  0,  2,$77,$61,$73,$70,$73,$70,$30,$31,  0,  1,$5A,$54,  0,  0,  0,  2,$77,$61,$73,$70,$73,$70,$30,$32,  0,  1,$5A,$6E,  0,  0,  0,  2,$77,$61,$73,$70; 7744
		dc.b $73,$70,$30,$33,  0,  1,$5A,$88,  0,  0,  0,  2,$77,$61,$73,$70,$73,$70,$30,$34,  0,  1,$5A,$92,  0,  0,  0,  2,$77,$61,$73,$70,$73,$70,$30,$35,  0,  1,$5A,$9C,  0,  0,  0,  2,$77,$61,$73,$70,$73,$70,$30,$36,  0,  1,$5A,$A6,  0,  0,  0,  2,$77,$61,$73,$70; 7808
		dc.b $70,$61,$74,  0,  0,  1,$5A,$34,  0,  0,  0,  2,$6F,$63,$74,$63,$68,$67,$30,$30,  0,  1,$5C,$C0,  0,  0,  0,  2,$6F,$63,$74,$70,$61,$74,  0,  0,  0,  1,$5C,$CC,  0,  0,  0,  2,$6F,$63,$74,$63,$68,$67,$30,$31,  0,  1,$5C,$C3,  0,  0,  0,  2,$6F,$63,$74,$63; 7872
		dc.b $68,$67,$30,$32,  0,  1,$5C,$C8,  0,  0,  0,  2,$6F,$63,$74,$73,$68,$6F,$74,  0,  0,  1,$5A,$DE,  0,  0,  0,  3,$7F,$65,$6E,$64,$30,$24,$77,$64,$62,$61,  0,  0,  0,  1,$5C,$38,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$76,$64,$62,$61,  0,  0,  0,  0,  1,$5B,$D0; 7936
		dc.b   0,  0,  0,  3,$7F,$65,$6E,$64,$24,$72,$64,$62,$61,  0,  0,  0,  0,  1,$5B,$64,  0,  0,  0,  3,$7F,$6F,$75,$74,$24,$77,$64,$62,$61,  0,  0,  0,  0,  1,$5C,$9E,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$77,$64,$62,$61,  0,  0,  0,  0,  1,$5C,$9C,  0,  0,  0,  1; 8000
		dc.b $6F,$63,$74,  0,  0,  1,$5A,$C8,  0,  0,  0,  3,$7F,$63,$6E,$74,$24,$78,$64,$62,$61,  0,  0,  0,  0,  1,$5C,$B2,  0,  0,  0,  3,$7F,$63,$6E,$74,$24,$70,$64,$62,$61,  0,  0,  0,  0,  1,$5A,$E8,  0,  0,  0,  2,$6F,$63,$74,$63,$68,$67,  0,  0,  0,  1,$5C,$BA; 8064
		dc.b   0,  0,  0,  2,$6F,$63,$74,$73,$70,$30,$30,  0,  0,  1,$5C,$DA,  0,  0,  0,  2,$6F,$63,$74,$73,$70,$30,$31,  0,  0,  1,$5C,$EC,  0,  0,  0,  2,$6F,$63,$74,$73,$70,$30,$32,  0,  0,  1,$5D,  6,  0,  0,  0,  2,$6F,$63,$74,$73,$70,$30,$33,  0,  0,  1,$5D,$20; 8128
		dc.b   0,  0,  0,  2,$6F,$63,$74,$73,$70,$30,$34,  0,  0,  1,$5D,$3A,  0,  0,  0,  2,$6F,$63,$74,$73,$70,$30,$35,  0,  0,  1,$5D,$44,  0,  0,  0,  2,$6F,$63,$74,$73,$70,$30,$36,  0,  0,  1,$5D,$4E,  0,  0,  0,  2,$6F,$63,$74,$73,$68,$6F,$6F,$74,  0,  1,$5B,$D2; 8192
		dc.b   0,  0,  0,  3,$6F,$63,$74,$5F,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  1,$5A,$D6,  0,  0,  0,  2,$6F,$63,$74,$65,$79,$65,  0,  0,  0,  1,$5A,$FA,  0,  0,  0,  2,$6F,$63,$74,$6C,$65,$61,$76,$65,  0,  1,$5C,$A4,  0,  0,  0,  2,$6F,$63,$74,$66,$6C,$79,  0,  0; 8256
		dc.b   0,  1,$5B,$B0,  0,  0,  0,  2,$6F,$63,$74,$69,$6E,$69,$74,  0,  0,  1,$5B,  6,  0,  0,  0,  2,$6F,$63,$74,$73,$74,$61,$6E,$64,  0,  1,$5B,$90,  0,  0,  0,  2,$6F,$63,$74,$6D,$6F,$76,$65,  0,  0,  1,$5B,$6C,  0,  0,  0,  3,$6F,$63,$74,$6D,$6F,$76,$65,$5F; 8320
		dc.b $74,$62,$6C,  0,  0,  1,$5B,$88,  0,  0,  0,  3,$7F,$64,$6F,$6E,$65,$24,$75,$64,$62,$61,  0,  0,  0,  1,$5B,$AE,  0,  0,  0,  2,$62,$61,$74,$68,$6F,$76,$65,$72,  0,  1,$5F,$56,  0,  0,  0,  2,$62,$61,$74,$69,$6E,$69,$74,  0,  0,  1,$5D,$8C,  0,  0,  0,  3; 8384
		dc.b $61,$74,$74,$61,$63,$6B,$63,$68,$6B,  0,  0,  0,  0,  1,$5E,$6C,  0,  0,  0,  2,$7F,$72,$74,$24,$62,$65,$62,$61,  0,  1,$5E,$F2,  0,  0,  0,  3,$7F,$64,$6F,$6E,$65,$24,$62,$65,$62,$61,  0,  0,  0,  1,$5F,  6,  0,  0,  0,  3,$7F,$67,$6F,$6E,$65,$24,$61,$65; 8448
		dc.b $62,$61,  0,  0,  0,  1,$5E,$B8,  0,  0,  0,  2,$6D,$6F,$76,$65,$73,$65,$74,  0,  0,  1,$5F,$36,  0,  0,  0,  2,$62,$61,$74,$6D,$6F,$76,$65,  0,  0,  1,$5D,$CA,  0,  0,  0,  3,$62,$61,$74,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0,  1,$5D,$EA,  0,  0,  0,  2; 8512
		dc.b $62,$62,$61,$74,$70,$61,$74,  0,  0,  1,$60,$16,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$78,$64,$62,$61,  0,  0,  0,  0,  1,$5E,$36,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$7A,$64,$62,$61,  0,  0,  0,  0,  1,$5E,$6A,  0,  0,  0,  2,$73,$65,$74,$70,$6F,$73,$69,  0; 8576
		dc.b   0,  1,$5D,$F0,  0,  0,  0,  2,$62,$61,$74,$63,$68,$67,  0,  0,  0,  1,$5F,$E2,  0,  0,  0,  3,$62,$61,$74,$5F,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  1,$5D,$86,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$64,$65,$62,$61,  0,  0,  0,  0,  1,$5F,$8C,  0,  0,  0,  3; 8640
		dc.b $7F,$65,$6E,$64,$24,$65,$65,$62,$61,  0,  0,  0,  0,  1,$5F,$98,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$61,$65,$62,$61,  0,  0,  0,  0,  1,$5E,$B6,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$62,$65,$62,$61,  0,  0,  0,  0,  1,$5E,$F0,  0,  0,  0,  3,$7F,$68,$65,$72; 8704
		dc.b $65,$24,$66,$65,$62,$61,  0,  0,  0,  1,$5F,$C8,  0,  0,  0,  3,$7F,$63,$6E,$74,$24,$66,$65,$62,$61,  0,  0,  0,  0,  1,$5F,$E0,  0,  0,  0,  3,$7F,$63,$6E,$74,$24,$61,$65,$62,$61,  0,  0,  0,  0,  1,$5E,$90,  0,  0,  0,  3,$62,$61,$74,$61,$74,$74,$61,$63; 8768
		dc.b $6B,  0,  0,  0,  0,  1,$5E,$38,  0,  0,  0,  2,$64,$69,$72,$65,$63,$63,$68,$67,  0,  1,$5E,$D8,  0,  0,  0,  2,$66,$69,$78,$6D,$65,  0,  0,  0,  0,  1,$5E,$58,  0,  0,  0,  3,$7F,$6E,$6F,$72,$6D,$24,$61,$65,$62,$61,  0,  0,  0,  1,$5E,$C4,  0,  0,  0,  1; 8832
		dc.b $62,$62,$61,$74,  0,  1,$5D,$78,  0,  0,  0,  2,$62,$61,$74,$63,$68,$67,$30,$30,  0,  1,$5F,$EA,  0,  0,  0,  2,$62,$61,$74,$63,$68,$67,$30,$31,  0,  1,$5F,$EE,  0,  0,  0,  2,$62,$61,$74,$63,$68,$67,$30,$32,  0,  1,$5F,$FD,  0,  0,  0,  2,$62,$61,$74,$63; 8896
		dc.b $68,$67,$30,$33,  0,  1,$60, $E,  0,  0,  0,  2,$62,$61,$74,$66,$6C,$61,$70,  0,  0,  1,$5F,$8E,  0,  0,  0,  2,$62,$61,$74,$73,$65,$65,$6B,  0,  0,  1,$5F,$9A,  0,  0,  0,  2,$73,$65,$65,$6B,$63,$68,$6B,  0,  0,  1,$5E, $A,  0,  0,  0,  2,$62,$61,$74,$73; 8960
		dc.b $70,$30,$30,  0,  0,  1,$60,$34,  0,  0,  0,  2,$62,$61,$74,$73,$70,$30,$31,  0,  0,  1,$60,$56,  0,  0,  0,  2,$62,$61,$74,$73,$70,$30,$32,  0,  0,  1,$60,$78,  0,  0,  0,  2,$62,$61,$74,$73,$70,$30,$33,  0,  0,  1,$60,$9A,  0,  0,  0,  2,$62,$61,$74,$73; 9024
		dc.b $70,$30,$34,  0,  0,  1,$60,$BC,  0,  0,  0,  2,$62,$61,$74,$73,$70,$30,$35,  0,  0,  1,$60,$D6,  0,  0,  0,  2,$62,$61,$74,$73,$70,$30,$36,  0,  0,  1,$60,$F8,  0,  0,  0,  2,$62,$61,$74,$73,$70,$30,$37,  0,  0,  1,$61,$1A,  0,  0,  0,  2,$62,$61,$74,$73; 9088
		dc.b $70,$30,$38,  0,  0,  1,$61,$3C,  0,  0,  0,  2,$62,$61,$74,$73,$70,$30,$39,  0,  0,  1,$61,$5E,  0,  0,  0,  2,$62,$61,$74,$73,$70,$31,$30,  0,  0,  1,$61,$78,  0,  0,  0,  2,$62,$61,$74,$73,$70,$31,$31,  0,  0,  1,$61,$92,  0,  0,  0,  2,$62,$61,$74,$73; 9152
		dc.b $70,$31,$32,  0,  0,  1,$61,$AC,  0,  0,  0,  2,$62,$61,$74,$73,$70,$31,$33,  0,  0,  1,$61,$BE,  0,  0,  0,  2,$62,$61,$74,$73,$70,$31,$34,  0,  0,  1,$61,$D0,  0,  0,  0,  3,$67,$61,$74,$6F,$72,$63,$68,$67,$30,$30,  0,  0,  0,  1,$63,$1C,  0,  0,  0,  3; 9216
		dc.b $67,$61,$74,$6F,$72,$63,$68,$67,$30,$31,  0,  0,  0,  1,$63,$24,  0,  0,  0,  3,$67,$61,$74,$6F,$72,$63,$68,$67,$30,$32,  0,  0,  0,  1,$63,$27,  0,  0,  0,  2,$67,$61,$74,$6F,$72,  0,  0,  0,  0,  1,$62,  0,  0,  0,  0,  3,$67,$61,$74,$6F,$72,$73,$70,$30; 9280
		dc.b $30,  0,  0,  0,  0,  1,$63,$48,  0,  0,  0,  3,$67,$61,$74,$6F,$72,$73,$70,$30,$31,  0,  0,  0,  0,  1,$63,$6A,  0,  0,  0,  3,$67,$61,$74,$6F,$72,$73,$70,$30,$32,  0,  0,  0,  0,  1,$63,$8C,  0,  0,  0,  3,$67,$61,$74,$6F,$72,$73,$70,$30,$33,  0,  0,  0; 9344
		dc.b   0,  1,$63,$AE,  0,  0,  0,  3,$67,$61,$74,$6F,$72,$73,$70,$30,$34,  0,  0,  0,  0,  1,$63,$D0,  0,  0,  0,  3,$67,$61,$74,$6F,$72,$73,$70,$30,$35,  0,  0,  0,  0,  1,$63,$F2,  0,  0,  0,  3,$67,$61,$74,$6F,$72,$73,$70,$30,$36,  0,  0,  0,  0,  1,$64,$14; 9408
		dc.b   0,  0,  0,  3,$67,$61,$74,$6F,$72,$73,$70,$30,$37,  0,  0,  0,  0,  1,$64,$36,  0,  0,  0,  3,$67,$61,$74,$6F,$72,$73,$70,$30,$38,  0,  0,  0,  0,  1,$64,$58,  0,  0,  0,  3,$67,$61,$74,$6F,$72,$73,$70,$30,$39,  0,  0,  0,  0,  1,$64,$7A,  0,  0,  0,  3; 9472
		dc.b $67,$61,$74,$6F,$72,$73,$70,$31,$30,  0,  0,  0,  0,  1,$64,$9C,  0,  0,  0,  3,$67,$61,$74,$6F,$72,$73,$70,$31,$31,  0,  0,  0,  0,  1,$64,$BE,  0,  0,  0,  2,$67,$61,$74,$6F,$72,$70,$61,$74,  0,  1,$63,$30,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$74,$64,$62; 9536
		dc.b $61,  0,  0,  0,  0,  1,$62,$C4,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$70,$64,$62,$61,  0,  0,  0,  0,  1,$62,$60,  0,  0,  0,  3,$7F,$6F,$75,$74,$24,$75,$64,$62,$61,  0,  0,  0,  0,  1,$63, $E,  0,  0,  0,  3,$7F,$73,$65,$74,$24,$75,$64,$62,$61,  0,  0,  0; 9600
		dc.b   0,  1,$63,  6,  0,  0,  0,  2,$67,$61,$74,$6F,$72,$5F,$30,  0,  0,  1,$62,$82,  0,  0,  0,  2,$67,$61,$74,$6F,$72,$5F,$31,  0,  0,  1,$62,$A6,  0,  0,  0,  3,$7F,$6C,$66,$74,$24,$75,$64,$62,$61,  0,  0,  0,  0,  1,$62,$E8,  0,  0,  0,  4,$67,$61,$74,$6F; 9664
		dc.b $72,$5F,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0,  0,  1,$62, $E,  0,  0,  0,  3,$67,$61,$74,$6F,$72,$69,$6E,$69,$74,  0,  0,  0,  0,  1,$62,$12,  0,  0,  0,  3,$67,$61,$74,$6F,$72,$6D,$6F,$76,$65,  0,  0,  0,  0,  1,$62,$62,  0,  0,  0,  3,$7F,$6A,$75,$6D; 9728
		dc.b $70,$32,$24,$74,$64,$62,$61,  0,  0,  1,$62,$C6,  0,  0,  0,  4,$67,$61,$74,$6F,$72,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0,  0,  0,  1,$62,$7E,  0,  0,  0,  2,$67,$61,$74,$6F,$72,$63,$68,$67,  0,  1,$63,$16,  0,  0,  0,  3,$63,$68,$65,$63,$6B,$73,$6F,$6E; 9792
		dc.b $69,$63,  0,  0,  0,  1,$62,$DE,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$73,$64,$62,$61,  0,  0,  0,  1,$62,$A4,  0,  0,  0,  2,$7F,$72,$74,$24,$75,$64,$62,$61,  0,  1,$62,$F8,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$62,$65,$62,$61,  0,  0,  0,  1,$65,$70; 9856
		dc.b   0,  0,  0,  4,$77,$66,$69,$73,$68,$5F,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0,  0,  1,$65, $A,  0,  0,  0,  3,$77,$66,$69,$73,$68,$69,$6E,$69,$74,  0,  0,  0,  0,  1,$65, $E,  0,  0,  0,  3,$77,$66,$69,$73,$68,$32,$70,$61,$74,  0,  0,  0,  0,  1,$65,$A6; 9920
		dc.b   0,  0,  0,  2,$77,$66,$69,$73,$68,$63,$68,$67,  0,  1,$65,$94,  0,  0,  0,  2,$66,$69,$73,$68,$73,$70,$30,  0,  0,  1,$65,$AA,  0,  0,  0,  2,$66,$69,$73,$68,$73,$70,$31,  0,  0,  1,$65,$C4,  0,  0,  0,  3,$77,$66,$69,$73,$68,$63,$68,$67,$30,  0,  0,  0; 9984
		dc.b   0,  1,$65,$9A,  0,  0,  0,  3,$77,$66,$69,$73,$68,$63,$68,$67,$31,  0,  0,  0,  0,  1,$65,$9E,  0,  0,  0,  3,$77,$66,$69,$73,$68,$63,$68,$67,$32,  0,  0,  0,  0,  1,$65,$A2,  0,  0,  0,  3,$77,$66,$69,$73,$68,$6D,$6F,$76,$65,  0,  0,  0,  0,  1,$65,$48; 10048
		dc.b   0,  0,  0,  2,$77,$66,$69,$73,$68,$32,  0,  0,  0,  1,$64,$F8,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$62,$65,$62,$61,  0,  0,  1,$65,$92,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$65,$65,$62,$61,  0,  0,  0,  1,$66,$D8,  0,  0,  0,  3,$7F,$64,$6F,$6E; 10112
		dc.b $65,$24,$66,$65,$62,$61,  0,  0,  0,  1,$67,$36,  0,  0,  0,  2,$73,$6E,$61,$69,$6C,$63,$68,$67,  0,  1,$68,$2C,  0,  0,  0,  3,$73,$6E,$61,$69,$6C,$63,$68,$67,$30,  0,  0,  0,  0,  1,$68,$30,  0,  0,  0,  3,$73,$6E,$61,$69,$6C,$63,$68,$67,$31,  0,  0,  0; 10176
		dc.b   0,  1,$68,$34,  0,  0,  0,  3,$73,$6E,$61,$69,$6C,$6D,$6F,$76,$65,  0,  0,  0,  0,  1,$66,$AC,  0,  0,  0,  2,$73,$6E,$61,$69,$6C,$73,$70,$30,  0,  1,$68,$3E,  0,  0,  0,  2,$73,$6E,$61,$69,$6C,$73,$70,$31,  0,  1,$68,$50,  0,  0,  0,  2,$73,$6E,$61,$69; 10240
		dc.b $6C,$73,$70,$32,  0,  1,$68,$62,  0,  0,  0,  3,$75,$70,$64,$61,$74,$65,$70,$61,$72,$74,$73,  0,  0,  1,$68,  4,  0,  0,  0,  4,$7F,$74,$6F,$72,$69,$67,$68,$74,$24,$66,$65,$62,$61,  0,  0,  0,  0,  1,$67,$1C,  0,  0,  0,  3,$7F,$6F,$75,$74,$31,$24,$64,$65; 10304
		dc.b $62,$61,  0,  0,  0,  1,$66,$94,  0,  0,  0,  3,$7F,$6F,$75,$74,$24,$67,$65,$62,$61,  0,  0,  0,  0,  1,$67,$90,  0,  0,  0,  3,$7F,$64,$6F,$69,$74,$24,$66,$65,$62,$61,  0,  0,  0,  1,$67,$24,  0,  0,  0,  3,$7F,$74,$6F,$6C,$65,$66,$74,$24,$66,$65,$62,$61; 10368
		dc.b   0,  1,$67,$12,  0,  0,  0,  3,$7F,$63,$6E,$74,$24,$68,$65,$62,$61,  0,  0,  0,  0,  1,$67,$BA,  0,  0,  0,  3,$7F,$63,$6E,$74,$24,$64,$65,$62,$61,  0,  0,  0,  0,  1,$66,$A6,  0,  0,  0,  2,$73,$6E,$61,$69,$6C,  0,  0,  0,  0,  1,$65,$F8,  0,  0,  0,  2; 10432
		dc.b $6D,$61,$6B,$65,$61,$66,$62,  0,  0,  1,$67,$38,  0,  0,  0,  3,$63,$68,$6B,$63,$68,$61,$72,$67,$65,  0,  0,  0,  0,  1,$66,$F4,  0,  0,  0,  3,$61,$66,$62,$75,$70,$64,$61,$74,$65,  0,  0,  0,  0,  1,$67,$92,  0,  0,  0,  2,$73,$6E,$61,$69,$6C,$70,$61,$74; 10496
		dc.b   0,  1,$68,$38,  0,  0,  0,  3,$73,$6E,$61,$69,$6C,$69,$6E,$69,$74,  0,  0,  0,  0,  1,$66,$14,  0,  0,  0,  4,$73,$6E,$61,$69,$6C,$5F,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0,  0,  1,$66, $A,  0,  0,  0,  3,$73,$6E,$61,$69,$6C,$74,$75,$72,$6E,  0,  0,  0; 10560
		dc.b   0,  1,$67,$CC,  0,  0,  0,  3,$62,$6F,$73,$73,$64,$72,$69,$6C,$6C,$65,$72,  0,  0,  1,$68,$90,  0,  0,  0,  1,$74,$62,$6C,  0,  0,  1,$69,$6C,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$76,$65,$62,$61,  0,  0,  0,  1,$69,$78,  0,  0,  0,  2,$6D,$6F,$76,$65; 10624
		dc.b $63,$61,$72,  0,  0,  1,$69,$2C,  0,  0,  0,  3,$63,$68,$65,$63,$6B,$73,$68,$6F,$6F,$74,  0,  0,  0,  1,$6D,$42,  0,  0,  0,  3,$6A,$6F,$69,$6E,$61,$64,$6A,$75,$73,$74,  0,  0,  0,  1,$69,  8,  0,  0,  0,  3,$6D,$6F,$76,$65,$6F,$6E,$73,$63,$72,$65,$65,$6E; 10688
		dc.b   0,  1,$68,$AA,  0,  0,  0,  2,$74,$69,$72,$65,$73,$69,$74,  0,  0,  1,$6C,$1A,  0,  0,  0,  3,$6D,$61,$6B,$65,$77,$68,$65,$65,$6C,$73,  0,  0,  0,  1,$6D,$72,  0,  0,  0,  4,$7F,$77,$6F,$72,$6B,$6E,$61,$69,$32,$24,$63,$67,$62,$61,  0,  0,  0,  1,$6F,$D0; 10752
		dc.b   0,  0,  0,  3,$7F,$6A,$6F,$69,$6E,$65,$64,$24,$72,$65,$62,$61,  0,  1,$68,$F4,  0,  0,  0,  3,$7F,$64,$6F,$6E,$65,$24,$6F,$65,$62,$61,  0,  0,  0,  1,$68,$C2,  0,  0,  0,  2,$6A,$6F,$69,$6E,$6C,$61,$6E,$64,  0,  1,$68,$E2,  0,  0,  0,  2,$64,$72,$69,$6C; 10816
		dc.b $6C,$65,$72,  0,  0,  1,$6B,  0,  0,  0,  0,  3,$64,$72,$69,$6C,$6C,$65,$72,$67,$75,$79,  0,  0,  0,  1,$6F,$2C,  0,  0,  0,  3,$74,$69,$72,$65,$62,$6F,$75,$6E,$63,$65,  0,  0,  0,  1,$6C,$A0,  0,  0,  0,  2,$63,$68,$65,$63,$6B,$68,$69,$74,  0,  1,$6A,$9E; 10880
		dc.b   0,  0,  0,  3,$64,$72,$69,$6C,$6C,$65,$72,$5F,$74,$62,$6C,  0,  0,  1,$6B, $E,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$64,$66,$62,$61,  0,  0,  0,  1,$6A,$C8,  0,  0,  0,  3,$69,$6E,$69,$74,$72,$6F,$74,$6F,$72,$73,  0,  0,  0,  1,$69,$D8,  0,  0,  0,  3; 10944
		dc.b $7F,$64,$6F,$6E,$65,$24,$63,$66,$62,$61,  0,  0,  0,  1,$6A,$9C,  0,  0,  0,  3,$7F,$64,$6F,$6E,$65,$24,$70,$66,$62,$61,  0,  0,  0,  1,$6B,$B4,  0,  0,  0,  2,$74,$69,$72,$65,$6D,$6F,$76,$65,  0,  1,$6C,  4,  0,  0,  0,  3,$62,$6F,$73,$73,$64,$72,$69,$6C; 11008
		dc.b $6C,$63,$68,$67,  0,  1,$70,$E0,  0,  0,  0,  2,$74,$69,$72,$65,$72,$6F,$6C,$6C,  0,  1,$6C,$38,  0,  0,  0,  3,$74,$69,$72,$65,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  1,$6C,$12,  0,  0,  0,  3,$63,$68,$65,$63,$6B,$66,$6C,$69,$70,  0,  0,  0,  0,  1,$6A,$7C; 11072
		dc.b   0,  0,  0,  3,$62,$6F,$73,$73,$68,$65,$6C,$69,$63,$68,$67,  0,  0,  1,$6F,$D2,  0,  0,  0,  3,$7F,$6C,$65,$66,$74,$24,$79,$66,$62,$61,  0,  0,  0,  1,$6D,$60,  0,  0,  0,  2,$72,$75,$6E,$61,$77,$61,$79,  0,  0,  1,$6A,$66,  0,  0,  0,  2,$63,$61,$72,$62; 11136
		dc.b $6F,$64,$79,  0,  0,  1,$6B,$C2,  0,  0,  0,  2,$74,$61,$6B,$65,$6F,$66,$66,  0,  0,  1,$6A,$4C,  0,  0,  0,  3,$7F,$72,$69,$67,$68,$74,$24,$79,$66,$62,$61,  0,  0,  1,$6D,$56,  0,  0,  0,  3,$62,$6F,$73,$73,$68,$65,$6C,$69,$63,$68,$67,$30,  0,  1,$6F,$D8; 11200
		dc.b   0,  0,  0,  3,$62,$6F,$73,$73,$68,$65,$6C,$69,$63,$68,$67,$31,  0,  1,$6F,$DC,  0,  0,  0,  3,$62,$6F,$73,$73,$68,$65,$6C,$69,$63,$68,$67,$32,  0,  1,$6F,$F2,  0,  0,  0,  2,$72,$65,$74,$72,$61,$63,$74,  0,  0,  1,$6B,$98,  0,  0,  0,  4,$62,$6F,$73,$73; 11264
		dc.b $64,$72,$69,$6C,$6C,$63,$68,$67,$30,  0,  0,  0,  0,  1,$70,$E6,  0,  0,  0,  4,$62,$6F,$73,$73,$64,$72,$69,$6C,$6C,$63,$68,$67,$31,  0,  0,  0,  0,  1,$70,$EB,  0,  0,  0,  4,$62,$6F,$73,$73,$64,$72,$69,$6C,$6C,$63,$68,$67,$32,  0,  0,  0,  0,  1,$70,$EF; 11328
		dc.b   0,  0,  0,  3,$62,$6F,$73,$73,$64,$72,$69,$6C,$6C,$73,$70,$30,  0,  1,$71,  4,  0,  0,  0,  3,$62,$6F,$73,$73,$64,$72,$69,$6C,$6C,$73,$70,$31,  0,  1,$71,$1E,  0,  0,  0,  3,$62,$6F,$73,$73,$64,$72,$69,$6C,$6C,$73,$70,$32,  0,  1,$71,$28,  0,  0,  0,  3; 11392
		dc.b $62,$6F,$73,$73,$64,$72,$69,$6C,$6C,$73,$70,$33,  0,  1,$71,$32,  0,  0,  0,  3,$62,$6F,$73,$73,$64,$72,$69,$6C,$6C,$73,$70,$34,  0,  1,$71,$3C,  0,  0,  0,  3,$62,$6F,$73,$73,$64,$72,$69,$6C,$6C,$73,$70,$35,  0,  1,$71,$46,  0,  0,  0,  3,$62,$6F,$73,$73; 11456
		dc.b $64,$72,$69,$6C,$6C,$73,$70,$36,  0,  1,$71,$50,  0,  0,  0,  3,$62,$6F,$73,$73,$64,$72,$69,$6C,$6C,$73,$70,$37,  0,  1,$71,$5A,  0,  0,  0,  3,$64,$65,$61,$74,$68,$73,$74,$61,$72,$74,  0,  0,  0,  1,$69,$70,  0,  0,  0,  5,$62,$6F,$73,$73,$64,$72,$69,$6C; 11520
		dc.b $6C,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0,  0,  0,  1,$68,$9E,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$76,$65,$62,$61,  0,  0,  0,  0,  1,$69,$A4,  0,  0,  0,  3,$7F,$6F,$66,$66,$24,$63,$66,$62,$61,  0,  0,  0,  0,  1,$6A,$8C,  0,  0,  0,  2,$6A,$6F,$69,$6E; 11584
		dc.b $5F,$74,$62,$6C,  0,  1,$68,$DE,  0,  0,  0,  3,$7F,$63,$68,$6B,$73,$65,$74,$24,$79,$66,$62,$61,  0,  1,$6D,$4C,  0,  0,  0,  3,$73,$74,$69,$63,$6B,$74,$6F,$62,$6F,$73,$73,  0,  0,  1,$6B,$3C,  0,  0,  0,  3,$67,$72,$6F,$77,$72,$6F,$74,$6F,$72,$73,  0,  0; 11648
		dc.b   0,  1,$6B,$18,  0,  0,  0,  3,$7F,$63,$6E,$74,$33,$24,$78,$66,$62,$61,  0,  0,  0,  1,$6D,$30,  0,  0,  0,  3,$7F,$6F,$75,$74,$24,$62,$66,$62,$61,  0,  0,  0,  0,  1,$6A,$7A,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$61,$66,$62,$61,  0,  0,  0,  0,  1,$6A,$64; 11712
		dc.b   0,  0,  0,  3,$7F,$65,$6E,$64,$24,$77,$66,$62,$61,  0,  0,  0,  0,  1,$6C,$BE,  0,  0,  0,  3,$7F,$73,$65,$74,$24,$79,$66,$62,$61,  0,  0,  0,  0,  1,$6D,$6A,  0,  0,  0,  3,$64,$65,$61,$74,$68,$64,$72,$6F,$70,  0,  0,  0,  0,  1,$69,$A6,  0,  0,  0,  3; 11776
		dc.b $73,$74,$69,$63,$6B,$5F,$74,$62,$6C,  0,  0,  0,  0,  1,$6B,$4A,  0,  0,  0,  2,$6E,$6F,$72,$6D,$61,$6C,  0,  0,  0,  1,$6B,$4E,  0,  0,  0,  2,$66,$6C,$79,$61,$77,$61,$79,  0,  0,  1,$69,$C0,  0,  0,  0,  2,$6A,$6F,$69,$6E,$63,$61,$72,  0,  0,  1,$68,$D0; 11840
		dc.b   0,  0,  0,  4,$7F,$77,$6F,$72,$6B,$6E,$61,$69,$24,$63,$67,$62,$61,  0,  0,  0,  0,  1,$6F,$70,  0,  0,  0,  3,$66,$6C,$79,$61,$77,$61,$79,$5F,$74,$62,$6C,  0,  0,  1,$69,$D2,  0,  0,  0,  3,$7F,$63,$6E,$74,$24,$75,$66,$62,$61,  0,  0,  0,  0,  1,$6C,$5A; 11904
		dc.b   0,  0,  0,  3,$7F,$63,$6E,$74,$24,$78,$66,$62,$61,  0,  0,  0,  0,  1,$6D,$10,  0,  0,  0,  3,$7F,$63,$6E,$74,$24,$6F,$66,$62,$61,  0,  0,  0,  0,  1,$6B,$72,  0,  0,  0,  3,$74,$69,$72,$65,$65,$78,$70,$6C,$6F,$64,$65,  0,  0,  1,$6C,$70,  0,  0,  0,  3; 11968
		dc.b $62,$6F,$73,$73,$68,$65,$6C,$69,$70,$61,$74,  0,  0,  1,$70, $C,  0,  0,  0,  2,$64,$72,$69,$6C,$6C,  0,  0,  0,  0,  1,$6C,$C2,  0,  0,  0,  3,$7F,$64,$69,$65,$24,$64,$66,$62,$61,  0,  0,  0,  0,  1,$6A,$E6,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$31,$24,$64; 12032
		dc.b $66,$62,$61,  0,  0,  1,$6A,$D6,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$64,$66,$62,$61,  0,  0,  1,$6A,$E4,  0,  0,  0,  3,$62,$6F,$73,$73,$68,$65,$6C,$69,$73,$70,$30,$30,  0,  1,$70,$1A,  0,  0,  0,  3,$62,$6F,$73,$73,$68,$65,$6C,$69,$73,$70,$30,$31; 12096
		dc.b   0,  1,$70,$24,  0,  0,  0,  3,$62,$6F,$73,$73,$68,$65,$6C,$69,$73,$70,$30,$32,  0,  1,$70,$4E,  0,  0,  0,  3,$62,$6F,$73,$73,$68,$65,$6C,$69,$73,$70,$30,$33,  0,  1,$70,$78,  0,  0,  0,  3,$62,$6F,$73,$73,$68,$65,$6C,$69,$73,$70,$30,$34,  0,  1,$70,$92; 12160
		dc.b   0,  0,  0,  3,$62,$6F,$73,$73,$68,$65,$6C,$69,$73,$70,$30,$35,  0,  1,$70,$AC,  0,  0,  0,  3,$62,$6F,$73,$73,$68,$65,$6C,$69,$73,$70,$30,$36,  0,  1,$70,$C6,  0,  0,  0,  4,$7F,$6D,$6F,$76,$65,$64,$72,$69,$6C,$6C,$24,$78,$66,$62,$61,  0,  0,  1,$6D,$22; 12224
		dc.b   0,  0,  0,  4,$7F,$77,$6F,$72,$6B,$6E,$61,$69,$31,$24,$7A,$66,$62,$61,  0,  0,  0,  1,$6D,$E6,  0,  0,  0,  3,$62,$6F,$73,$73,$64,$72,$69,$6C,$6C,$70,$61,$74,  0,  1,$70,$F4,  0,  0,  0,  4,$7F,$77,$6F,$72,$6B,$6E,$61,$69,$32,$24,$7A,$66,$62,$61,  0,  0; 12288
		dc.b   0,  1,$6E,$5A,  0,  0,  0,  4,$7F,$77,$6F,$72,$6B,$6E,$61,$69,$33,$24,$7A,$66,$62,$61,  0,  0,  0,  1,$6E,$CE,  0,  0,  0,  4,$7F,$77,$6F,$72,$6B,$6E,$61,$69,$34,$24,$7A,$66,$62,$61,  0,  0,  0,  1,$6F,$2A,  0,  0,  0,  2,$62,$69,$6C,$6C,$62,$6F,$6D,$62; 12352
		dc.b   0,  1,$74,$1E,  0,  0,  0,  2,$73,$6D,$62,$73,$70,$30,$30,  0,  0,  1,$74,$A6,  0,  0,  0,  2,$73,$6D,$62,$73,$70,$30,$31,  0,  0,  1,$74,$B0,  0,  0,  0,  2,$73,$6D,$62,$73,$70,$30,$32,  0,  0,  1,$74,$BA,  0,  0,  0,  2,$73,$6D,$62,$73,$70,$30,$33,  0; 12416
		dc.b   0,  1,$74,$C4,  0,  0,  0,  3,$62,$6F,$73,$73,$62,$61,$63,$68,$67,$31,  0,  0,  0,  1,$75,$26,  0,  0,  0,  3,$62,$6F,$73,$73,$62,$61,$63,$68,$67,$32,  0,  0,  0,  1,$75,$29,  0,  0,  0,  3,$62,$6F,$73,$73,$62,$61,$6D,$6F,$76,$65,  0,  0,  0,  1,$72,$CA; 12480
		dc.b   0,  0,  0,  3,$62,$6F,$73,$73,$62,$61,$63,$68,$67,  0,  0,  0,  0,  1,$75,$22,  0,  0,  0,  3,$62,$69,$6C,$6C,$62,$6F,$6D,$62,$5F,$74,$62,$6C,  0,  1,$74,$2C,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$73,$65,$62,$61,  0,  0,  0,  1,$74,$82,  0,  0,  0,  3; 12544
		dc.b $7F,$6A,$75,$6D,$70,$24,$6E,$65,$62,$61,  0,  0,  0,  1,$73,$82,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$6F,$65,$62,$61,  0,  0,  0,  1,$74,$1A,  0,  0,  0,  4,$62,$6F,$73,$73,$62,$61,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0,  0,  1,$73,  0,  0,  0,  0,  3; 12608
		dc.b $62,$69,$6C,$6C,$62,$6F,$6D,$62,$70,$61,$74,  0,  0,  1,$74,$CE,  0,  0,  0,  4,$62,$6F,$73,$73,$62,$61,$5F,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0,  1,$71,$A2,  0,  0,  0,  3,$62,$6F,$73,$73,$62,$61,$74,$6F,$70,  0,  0,  0,  0,  1,$73,  8,  0,  0,  0,  3; 12672
		dc.b $62,$69,$6C,$6C,$62,$6F,$6D,$62,$69,$6E,$69,$74,  0,  1,$74,$30,  0,  0,  0,  4,$7F,$77,$6F,$72,$6B,$6E,$61,$69,$24,$67,$65,$62,$61,  0,  0,  0,  0,  1,$72,$B0,  0,  0,  0,  3,$7F,$63,$6E,$74,$32,$24,$67,$65,$62,$61,  0,  0,  0,  1,$72,$5C,  0,  0,  0,  2; 12736
		dc.b $62,$6F,$73,$73,$62,$61,  0,  0,  0,  1,$71,$94,  0,  0,  0,  2,$62,$6F,$73,$73,$61,$66,$62,  0,  0,  1,$73,$3A,  0,  0,  0,  3,$62,$6F,$73,$73,$62,$61,$70,$61,$74,  0,  0,  0,  0,  1,$75,$2E,  0,  0,  0,  3,$62,$6F,$73,$73,$73,$6D,$70,$61,$74,  0,  0,  0; 12800
		dc.b   0,  1,$74,$9E,  0,  0,  0,  2,$61,$66,$62,$74,$62,$6C,  0,  0,  0,  1,$73,$36,  0,  0,  0,  3,$62,$69,$6C,$6C,$62,$6F,$6D,$62,$6D,$6F,$76,$65,  0,  1,$74,$68,  0,  0,  0,  3,$62,$6F,$73,$73,$62,$61,$73,$70,$30,$30,  0,  0,  0,  1,$75,$34,  0,  0,  0,  3; 12864
		dc.b $62,$6F,$73,$73,$62,$61,$73,$70,$30,$31,  0,  0,  0,  1,$75,$56,  0,  0,  0,  3,$62,$6F,$73,$73,$62,$61,$73,$70,$30,$32,  0,  0,  0,  1,$75,$78,  0,  0,  0,  2,$62,$6F,$73,$73,$73,$6D,  0,  0,  0,  1,$73,$D8,  0,  0,  0,  3,$62,$6F,$73,$73,$62,$6D,$73,$70; 12928
		dc.b $30,$30,  0,  0,  0,  1,$74,$DC,  0,  0,  0,  3,$62,$6F,$73,$73,$62,$6D,$73,$70,$30,$31,  0,  0,  0,  1,$74,$E6,  0,  0,  0,  3,$62,$6F,$73,$73,$62,$6D,$73,$70,$30,$32,  0,  0,  0,  1,$74,$F0,  0,  0,  0,  3,$62,$6F,$73,$73,$62,$6D,$73,$70,$30,$33,  0,  0; 12992
		dc.b   0,  1,$74,$FA,  0,  0,  0,  3,$62,$6F,$73,$73,$62,$6D,$73,$70,$30,$34,  0,  0,  0,  1,$75,  4,  0,  0,  0,  3,$62,$6F,$73,$73,$62,$6D,$73,$70,$30,$35,  0,  0,  0,  1,$75, $E,  0,  0,  0,  3,$62,$6F,$73,$73,$62,$6D,$73,$70,$30,$36,  0,  0,  0,  1,$75,$18; 13056
		dc.b   0,  0,  0,  3,$7F,$68,$65,$72,$65,$24,$6E,$65,$62,$61,  0,  0,  0,  1,$73,$9C,  0,  0,  0,  3,$7F,$63,$6E,$74,$24,$67,$65,$62,$61,  0,  0,  0,  0,  1,$71,$F8,  0,  0,  0,  3,$7F,$63,$6E,$74,$24,$6E,$65,$62,$61,  0,  0,  0,  0,  1,$73,$78,  0,  0,  0,  4; 13120
		dc.b $62,$6F,$73,$73,$62,$61,$61,$70,$70,$65,$6E,$64,$61,$67,$65,  0,  0,  1,$72,$C2,  0,  0,  0,  3,$7F,$68,$75,$72,$74,$24,$6E,$65,$62,$61,  0,  0,  0,  1,$73,$8E,  0,  0,  0,  3,$62,$6F,$73,$73,$62,$61,$69,$6E,$69,$74,  0,  0,  0,  1,$71,$AC,  0,  0,  0,  2; 13184
		dc.b $61,$66,$62,$73,$70,$30,$30,  0,  0,  1,$74,$8A,  0,  0,  0,  2,$61,$66,$62,$73,$70,$30,$31,  0,  0,  1,$74,$94,  0,  0,  0,  3,$62,$6F,$73,$73,$61,$66,$62,$70,$61,$74,  0,  0,  0,  1,$74,$86,  0,  0,  0,  3,$73,$74,$61,$66,$66,$5F,$69,$6E,$69,$74,  0,  0; 13248
		dc.b   0,  1,$75,$BA,  0,  0,  0,  3,$73,$74,$61,$66,$66,$5F,$6D,$6F,$76,$65,  0,  0,  0,  1,$76,$28,  0,  0,  0,  4,$73,$74,$61,$66,$66,$5F,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0,  0,  1,$75,$B6,  0,  0,  0,  2,$73,$74,$61,$66,$66,$70,$61,$74,  0,  1,$76,$2E; 13312
		dc.b   0,  0,  0,  2,$73,$74,$61,$66,$66,  0,  0,  0,  0,  1,$75,$A8,  0,  0,  0,  3,$73,$74,$61,$66,$66,$73,$70,$30,$30,  0,  0,  0,  0,  1,$76,$44,  0,  0,  0,  3,$73,$74,$61,$66,$66,$73,$70,$30,$31,  0,  0,  0,  0,  1,$76,$B6,  0,  0,  0,  3,$73,$74,$61,$66; 13376
		dc.b $66,$73,$70,$30,$32,  0,  0,  0,  0,  1,$77,$38,  0,  0,  0,  3,$73,$74,$61,$66,$66,$73,$70,$30,$33,  0,  0,  0,  0,  1,$77,$8A,  0,  0,  0,  3,$73,$74,$61,$66,$66,$73,$70,$30,$34,  0,  0,  0,  0,  1,$78,$4C,  0,  0,  0,  3,$73,$74,$61,$66,$66,$73,$70,$30; 13440
		dc.b $35,  0,  0,  0,  0,  1,$78,$EE,  0,  0,  0,  3,$73,$74,$61,$66,$66,$73,$70,$30,$36,  0,  0,  0,  0,  1,$79,$C0,  0,  0,  0,  3,$73,$74,$61,$66,$66,$73,$70,$30,$37,  0,  0,  0,  0,  1,$7A,$7A,  0,  0,  0,  3,$73,$74,$61,$66,$66,$73,$70,$30,$38,  0,  0,  0; 13504
		dc.b   0,  1,$7B,$74,  0,  0,  0,  3,$73,$74,$61,$66,$66,$73,$70,$30,$39,  0,  0,  0,  0,  1,$7B,$EE,  0,  0,  0,  3,$73,$74,$61,$66,$66,$73,$70,$31,$30,  0,  0,  0,  0,  1,$7C,$30,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$6E,$64,$62,$61,  0,  0,  0,  1,$76,$28; 13568
		dc.b   0,  0,  0,  4,$7F,$66,$61,$6C,$6C,$69,$6E,$67,$24,$76,$64,$62,$61,  0,  0,  0,  0,  1,$7F,$7A,  0,  0,  0,  4,$7F,$72,$69,$73,$65,$5F,$75,$70,$24,$76,$64,$62,$61,  0,  0,  0,  0,  1,$7F,$88,  0,  0,  0,  3,$62,$74,$61,$6D,$61,$6D,$6F,$76,$65,$32,  0,  0; 13632
		dc.b   0,  1,$81,$EE,  0,  0,  0,  3,$62,$74,$61,$6D,$61,$69,$6E,$69,$74,  0,  0,  0,  0,  1,$80,$C6,  0,  0,  0,  3,$73,$70,$65,$65,$64,$73,$65,$74,$5F,$6D,  0,  0,  0,  1,$7E,$6A,  0,  0,  0,  2,$62,$6F,$73,$73,$31,  0,  0,  0,  0,  1,$7C,$C4,  0,  0,  0,  2; 13696
		dc.b $62,$6F,$73,$73,$62,$6F,$6D,$62,  0,  1,$7E,$26,  0,  0,  0,  3,$7F,$70,$61,$73,$73,$30,$24,$78,$64,$62,$61,  0,  0,  1,$80,  8,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$6A,$65,$62,$61,  0,  0,  0,  1,$81,$32,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$6C,$65; 13760
		dc.b $62,$61,  0,  0,  0,  1,$81,$B4,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$6E,$65,$62,$61,  0,  0,  0,  1,$82,$3A,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$6F,$65,$62,$61,  0,  0,  0,  1,$82,$52,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$70,$65,$62,$61,  0,  0; 13824
		dc.b   0,  1,$82,$8A,  0,  0,  0,  3,$7F,$70,$61,$73,$73,$31,$24,$78,$64,$62,$61,  0,  0,  1,$80,$10,  0,  0,  0,  3,$7F,$70,$61,$73,$73,$32,$24,$78,$64,$62,$61,  0,  0,  1,$80,$1A,  0,  0,  0,  3,$62,$6F,$73,$73,$31,$63,$68,$67,$31,$30,  0,  0,  0,  1,$82,$CE; 13888
		dc.b   0,  0,  0,  3,$62,$6F,$73,$73,$31,$63,$68,$67,$31,$31,  0,  0,  0,  1,$82,$D1,  0,  0,  0,  2,$62,$6F,$73,$73,$31,$70,$61,$74,  0,  1,$82,$DC,  0,  0,  0,  2,$62,$6F,$73,$73,$32,$70,$61,$74,  0,  1,$84,$10,  0,  0,  0,  2,$62,$74,$61,$6D,$61,$73,$75,$62; 13952
		dc.b   0,  1,$81,$FE,  0,  0,  0,  3,$62,$6F,$73,$73,$5F,$79,$73,$75,$62,  0,  0,  0,  0,  1,$7D,$AC,  0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$24,$6B,$64,$62,$61,  0,  0,  0,  1,$7C,$EA,  0,  0,  0,  3,$62,$6F,$73,$73,$31,$73,$70,$31,$30,  0,  0,  0,  0,  1,$83,$EA; 14016
		dc.b   0,  0,  0,  3,$62,$6F,$73,$73,$31,$73,$70,$31,$31,  0,  0,  0,  0,  1,$83,$EC,  0,  0,  0,  3,$62,$6F,$73,$73,$31,$73,$70,$31,$32,  0,  0,  0,  0,  1,$83,$FE,  0,  0,  0,  3,$62,$74,$61,$6D,$61,$6D,$6F,$76,$65,  0,  0,  0,  0,  1,$81,$8E,  0,  0,  0,  4; 14080
		dc.b $62,$74,$61,$6D,$61,$5F,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0,  0,  1,$80,$BC,  0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$24,$6A,$65,$62,$61,  0,  0,  0,  1,$80,$F6,  0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$24,$6C,$65,$62,$61,  0,  0,  0,  1,$81,$9A,  0,  0,  0,  4; 14144
		dc.b $7F,$77,$6F,$72,$6B,$6E,$61,$69,$24,$70,$64,$62,$61,  0,  0,  0,  0,  1,$7E,$68,  0,  0,  0,  4,$7F,$77,$6F,$72,$6B,$6E,$61,$69,$24,$72,$64,$62,$61,  0,  0,  0,  0,  1,$7E,$D6,  0,  0,  0,  4,$7F,$77,$6F,$72,$6B,$6E,$61,$69,$24,$6B,$64,$62,$61,  0,  0,  0; 14208
		dc.b   0,  1,$7D,$38,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$74,$64,$62,$61,  0,  0,  0,  0,  1,$7F,$3C,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$75,$64,$62,$61,  0,  0,  0,  0,  1,$7F,$70,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$6E,$64,$62,$61,  0,  0,  0,  0,  1,$7D,$AC; 14272
		dc.b   0,  0,  0,  3,$7F,$65,$6E,$64,$24,$72,$64,$62,$61,  0,  0,  0,  0,  1,$7E,$DC,  0,  0,  0,  3,$62,$6F,$73,$73,$31,$69,$6E,$69,$74,  0,  0,  0,  0,  1,$7C,$E0,  0,  0,  0,  4,$7F,$77,$6F,$72,$6B,$6E,$61,$69,$24,$6A,$65,$62,$61,  0,  0,  0,  0,  1,$81,$5C; 14336
		dc.b   0,  0,  0,  3,$7F,$65,$78,$69,$74,$24,$76,$64,$62,$61,  0,  0,  0,  1,$7F,$B6,  0,  0,  0,  3,$7F,$66,$69,$72,$65,$24,$76,$64,$62,$61,  0,  0,  0,  1,$7F,$A8,  0,  0,  0,  3,$62,$74,$61,$6D,$61,$6B,$75,$73,$61,$72,$69,  0,  0,  1,$82,$3C,  0,  0,  0,  3; 14400
		dc.b $62,$6F,$73,$73,$31,$63,$68,$67,$30,  0,  0,  0,  0,  1,$82,$A8,  0,  0,  0,  3,$62,$6F,$73,$73,$31,$63,$68,$67,$31,  0,  0,  0,  0,  1,$82,$AB,  0,  0,  0,  3,$62,$6F,$73,$73,$31,$63,$68,$67,$32,  0,  0,  0,  0,  1,$82,$AF,  0,  0,  0,  3,$62,$6F,$73,$73; 14464
		dc.b $31,$63,$68,$67,$33,  0,  0,  0,  0,  1,$82,$B3,  0,  0,  0,  3,$62,$6F,$73,$73,$31,$63,$68,$67,$34,  0,  0,  0,  0,  1,$82,$B7,  0,  0,  0,  3,$62,$6F,$73,$73,$31,$63,$68,$67,$35,  0,  0,  0,  0,  1,$82,$BB,  0,  0,  0,  3,$62,$6F,$73,$73,$31,$63,$68,$67; 14528
		dc.b $36,  0,  0,  0,  0,  1,$82,$BF,  0,  0,  0,  3,$62,$6F,$73,$73,$31,$63,$68,$67,$37,  0,  0,  0,  0,  1,$82,$C3,  0,  0,  0,  3,$62,$6F,$73,$73,$31,$63,$68,$67,$38,  0,  0,  0,  0,  1,$82,$C6,  0,  0,  0,  3,$62,$6F,$73,$73,$31,$63,$68,$67,$39,  0,  0,  0; 14592
		dc.b   0,  1,$82,$CA,  0,  0,  0,  2,$62,$6F,$73,$73,$31,$73,$75,$62,  0,  1,$80,$74,  0,  0,  0,  3,$62,$6F,$73,$73,$31,$6D,$6F,$76,$65,  0,  0,  0,  0,  1,$7D,$50,  0,  0,  0,  2,$62,$6F,$73,$73,$31,$63,$68,$67,  0,  1,$82,$90,  0,  0,  0,  3,$62,$74,$61,$6D; 14656
		dc.b $61,$74,$61,$6D,$61,  0,  0,  0,  0,  1,$82,$58,  0,  0,  0,  3,$7F,$74,$75,$72,$6E,$24,$76,$64,$62,$61,  0,  0,  0,  1,$7F,$82,  0,  0,  0,  2,$62,$6F,$73,$73,$31,$73,$70,$30,  0,  1,$82,$F6,  0,  0,  0,  2,$62,$6F,$73,$73,$32,$73,$70,$30,  0,  1,$84,$20; 14720
		dc.b   0,  0,  0,  2,$62,$6F,$73,$73,$31,$73,$70,$31,  0,  1,$83,$28,  0,  0,  0,  2,$62,$6F,$73,$73,$32,$73,$70,$31,  0,  1,$84,$2A,  0,  0,  0,  2,$62,$6F,$73,$73,$31,$73,$70,$32,  0,  1,$83,$3A,  0,  0,  0,  2,$62,$6F,$73,$73,$32,$73,$70,$32,  0,  1,$84,$3C; 14784
		dc.b   0,  0,  0,  2,$62,$6F,$73,$73,$31,$73,$70,$33,  0,  1,$83,$4C,  0,  0,  0,  2,$62,$6F,$73,$73,$32,$73,$70,$33,  0,  1,$84,$46,  0,  0,  0,  2,$62,$6F,$73,$73,$31,$73,$70,$34,  0,  1,$83,$66,  0,  0,  0,  2,$62,$6F,$73,$73,$32,$73,$70,$34,  0,  1,$84,$50; 14848
		dc.b   0,  0,  0,  2,$62,$6F,$73,$73,$31,$73,$70,$35,  0,  1,$83,$80,  0,  0,  0,  2,$62,$6F,$73,$73,$32,$73,$70,$35,  0,  1,$84,$5A,  0,  0,  0,  2,$62,$6F,$73,$73,$31,$73,$70,$36,  0,  1,$83,$9A,  0,  0,  0,  2,$62,$6F,$73,$73,$32,$73,$70,$36,  0,  1,$84,$7C; 14912
		dc.b   0,  0,  0,  2,$62,$6F,$73,$73,$31,$73,$70,$37,  0,  1,$83,$B4,  0,  0,  0,  2,$62,$6F,$73,$73,$32,$73,$70,$37,  0,  1,$84,$8E,  0,  0,  0,  2,$62,$6F,$73,$73,$31,$73,$70,$38,  0,  1,$83,$D6,  0,  0,  0,  2,$62,$6F,$73,$73,$31,$73,$70,$39,  0,  1,$83,$E0; 14976
		dc.b   0,  0,  0,  4,$62,$6F,$73,$73,$31,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0,  0,  0,  1,$7D,$82,  0,  0,  0,  2,$62,$6F,$73,$73,$31,$74,$62,$6C,  0,  1,$7C,$DA,  0,  0,  0,  4,$7F,$66,$72,$61,$6D,$65,$6F,$75,$74,$24,$77,$64,$62,$61,  0,  0,  0,  1,$7F,$E6; 15040
		dc.b   0,  0,  0,  4,$7F,$66,$72,$61,$6D,$65,$6F,$75,$74,$24,$78,$64,$62,$61,  0,  0,  0,  1,$80,$3A,  0,  0,  0,  4,$7F,$66,$72,$61,$6D,$65,$6F,$75,$74,$24,$79,$64,$62,$61,  0,  0,  0,  1,$80,$6E,  0,  0,  0,  3,$7F,$64,$69,$65,$24,$6F,$64,$62,$61,  0,  0,  0; 15104
		dc.b   0,  1,$7E,$12,  0,  0,  0,  3,$7F,$67,$6F,$5F,$75,$70,$24,$76,$64,$62,$61,  0,  0,  1,$7F,$A0,  0,  0,  0,  2,$62,$6F,$73,$73,$31,$5F,$30,  0,  0,  1,$7D,$90,  0,  0,  0,  2,$62,$6F,$73,$73,$31,$5F,$31,  0,  0,  1,$7E,$90,  0,  0,  0,  2,$62,$6F,$73,$73; 15168
		dc.b $31,$5F,$32,  0,  0,  1,$7E,$E0,  0,  0,  0,  2,$62,$6F,$73,$73,$31,$5F,$33,  0,  0,  1,$7F,$1A,  0,  0,  0,  2,$62,$6F,$73,$73,$31,$5F,$34,  0,  0,  1,$7F,$40,  0,  0,  0,  2,$62,$6F,$73,$73,$31,$5F,$35,  0,  0,  1,$7F,$72,  0,  0,  0,  2,$62,$6F,$73,$73; 15232
		dc.b $31,$5F,$36,  0,  0,  1,$7F,$BE,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$30,$24,$78,$64,$62,$61,  0,  0,  1,$80,$38,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$30,$24,$79,$64,$62,$61,  0,  0,  1,$80,$60,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$31,$24,$6F,$64,$62,$61,  0; 15296
		dc.b   0,  1,$7E,  2,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$77,$64,$62,$61,  0,  0,  1,$7F,$DE,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$6F,$64,$62,$61,  0,  0,  1,$7E,$10,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$73,$64,$62,$61,  0,  0,  1,$7F,$16; 15360
		dc.b   0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$74,$64,$62,$61,  0,  0,  1,$7F,$26,  0,  0,  0,  4,$62,$6F,$73,$73,$31,$5F,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0,  0,  1,$7C,$D2,  0,  0,  0,  3,$62,$74,$61,$6D,$61,$6C,$65,$6E,$74,$62,$6C,  0,  0,  1,$81,$88; 15424
		dc.b   0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$30,$24,$70,$65,$62,$61,  0,  0,  1,$82,$62,  0,  0,  0,  2,$62,$74,$61,$6D,$61,  0,  0,  0,  0,  1,$80,$AE,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$6C,$65,$62,$61,  0,  0,  1,$81,$CE,  0,  0,  0,  3,$7F,$6A,$75,$6D; 15488
		dc.b $70,$33,$24,$6C,$65,$62,$61,  0,  0,  1,$81,$DA,  0,  0,  0,  3,$62,$6F,$73,$73,$31,$6F,$79,$61,$6A,$69,  0,  0,  0,  1,$7F,$EE,  0,  0,  0,  3,$7F,$70,$61,$73,$73,$24,$6E,$65,$62,$61,  0,  0,  0,  1,$82,$10,  0,  0,  0,  3,$62,$6F,$73,$73,$31,$66,$69,$72; 15552
		dc.b $65,  0,  0,  0,  0,  1,$80,$40,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$73,$64,$62,$61,  0,  0,  0,  1,$7F, $A,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$75,$64,$62,$61,  0,  0,  0,  1,$7F,$4A,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$6B,$64,$62,$61,  0,  0; 15616
		dc.b   0,  1,$7C,$F2,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$6F,$64,$62,$61,  0,  0,  0,  1,$7D,$F4,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$70,$64,$62,$61,  0,  0,  0,  1,$7E,$68,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$77,$64,$62,$61,  0,  0,  0,  1,$7F,$D8; 15680
		dc.b   0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$78,$64,$62,$61,  0,  0,  0,  1,$80,$24,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$79,$64,$62,$61,  0,  0,  0,  1,$80,$6C,  0,  0,  0,  2,$7F,$6C,$70,$24,$6D,$64,$62,$61,  0,  1,$86,$56,  0,  0,  0,  2,$7F,$6C,$70,$24; 15744
		dc.b $6F,$64,$62,$61,  0,  1,$86,$DC,  0,  0,  0,  3,$6D,$61,$73,$69,$6E,$69,$6E,$69,$74,  0,  0,  0,  0,  1,$84,$F8,  0,  0,  0,  3,$6D,$61,$73,$69,$6E,$62,$6F,$6D,$62,  0,  0,  0,  0,  1,$85,$EA,  0,  0,  0,  3,$6D,$61,$73,$69,$6E,$63,$6C,$65,$61,$72,  0,  0; 15808
		dc.b   0,  1,$86,$D2,  0,  0,  0,  4,$7F,$77,$6F,$72,$6B,$6E,$61,$69,$24,$6D,$64,$62,$61,  0,  0,  0,  0,  1,$86,$28,  0,  0,  0,  4,$7F,$77,$6F,$72,$6B,$6E,$61,$69,$24,$6E,$64,$62,$61,  0,  0,  0,  0,  1,$86,$C0,  0,  0,  0,  2,$6D,$61,$73,$69,$6E,$70,$61,$74; 15872
		dc.b   0,  1,$86,$FC,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$68,$64,$62,$61,  0,  0,  0,  0,  1,$85,$44,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$6D,$64,$62,$61,  0,  0,  0,  0,  1,$86,$2E,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$6E,$64,$62,$61,  0,  0,  0,  0,  1,$86,$D0; 15936
		dc.b   0,  0,  0,  3,$7F,$65,$6E,$64,$24,$6F,$64,$62,$61,  0,  0,  0,  0,  1,$86,$F2,  0,  0,  0,  3,$6D,$61,$73,$69,$6E,$63,$68,$67,$30,  0,  0,  0,  0,  1,$86,$F8,  0,  0,  0,  3,$6D,$61,$73,$69,$6E,$63,$68,$67,$31,  0,  0,  0,  0,  1,$86,$F8,  0,  0,  0,  3; 16000
		dc.b $6D,$61,$73,$69,$6E,$6D,$6F,$76,$65,  0,  0,  0,  0,  1,$85,$46,  0,  0,  0,  3,$6D,$61,$73,$69,$6E,$63,$65,$6E,$74,$65,$72,  0,  0,  1,$85,$EA,  0,  0,  0,  2,$6D,$61,$73,$69,$6E,$63,$68,$67,  0,  1,$86,$F4,  0,  0,  0,  3,$6D,$61,$73,$69,$6E,$73,$77,$69; 16064
		dc.b $74,$63,$68,  0,  0,  1,$85,$82,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$69,$64,$62,$61,  0,  0,  1,$85,$7A,  0,  0,  0,  5,$7F,$6E,$6F,$5F,$77,$6F,$72,$6B,$5F,$6C,$65,$66,$74,$24,$6D,$64,$62,$61,  0,  0,  0,  1,$86,$80,  0,  0,  0,  3,$7F,$70,$61,$73; 16128
		dc.b $73,$24,$6E,$64,$62,$61,  0,  0,  0,  1,$86,$B6,  0,  0,  0,  4,$7F,$66,$72,$61,$6D,$65,$6F,$75,$74,$24,$65,$64,$62,$61,  0,  0,  0,  1,$84,$D2,  0,  0,  0,  4,$7F,$62,$6F,$6D,$62,$65,$6E,$64,$24,$6D,$64,$62,$61,  0,  0,  0,  0,  1,$86,$30,  0,  0,  0,  4; 16192
		dc.b $6D,$61,$73,$69,$6E,$5F,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0,  0,  1,$84,$D8,  0,  0,  0,  2,$6D,$61,$73,$69,$6E,$73,$70,$30,  0,  1,$87, $A,  0,  0,  0,  2,$6D,$61,$73,$69,$6E,$73,$70,$31,  0,  1,$87,$44,  0,  0,  0,  2,$6D,$61,$73,$69,$6E,$73,$70,$32; 16256
		dc.b   0,  1,$87,$4E,  0,  0,  0,  2,$6D,$61,$73,$69,$6E,$73,$70,$33,  0,  1,$87,$80,  0,  0,  0,  2,$6D,$61,$73,$69,$6E,$73,$70,$34,  0,  1,$87,$8A,  0,  0,  0,  2,$6D,$61,$73,$69,$6E,$73,$70,$35,  0,  1,$87,$9C,  0,  0,  0,  2,$6D,$61,$73,$69,$6E,$73,$70,$36; 16320
		dc.b   0,  1,$87,$A6,  0,  0,  0,  2,$6D,$61,$73,$69,$6E,$74,$62,$6C,  0,  1,$84,$E8,  0,  0,  0,  3,$6D,$61,$73,$69,$6E,$75,$73,$61,$67,$69,  0,  0,  0,  1,$86,$82,  0,  0,  0,  2,$6D,$61,$73,$69,$6E,  0,  0,  0,  0,  1,$84,$AC,  0,  0,  0,  3,$6D,$61,$73,$69; 16384
		dc.b $6E,$63,$65,$6E,$74,$65,$72,$32,  0,  1,$85,$EA,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$69,$64,$62,$61,  0,  0,  0,  1,$85,$64,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$6A,$64,$62,$61,  0,  0,  0,  1,$85,$E8,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$6D,$64; 16448
		dc.b $62,$61,  0,  0,  0,  1,$86,$28,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$6E,$64,$62,$61,  0,  0,  0,  1,$86,$C0,  0,  0,  0,  3,$65,$73,$63,$6F,$72,$65,$74,$62,$6C,  0,  0,  0,  0,  1,$89,$AC,  0,  0,  0,  3,$70,$63,$6F,$6C,$73,$70,$65,$63,$69,$61,$6C,  0; 16512
		dc.b   0,  1,$8A,$CA,  0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$24,$6C,$64,$62,$61,  0,  0,  0,  1,$87,$E8,  0,  0,  0,  3,$7F,$62,$6F,$62,$69,$6E,$24,$76,$64,$62,$61,  0,  0,  1,$8B,$22,  0,  0,  0,  3,$70,$63,$6F,$6C,$70,$6C,$61,$79,$32,  0,  0,  0,  0,  1,$89,$B4; 16576
		dc.b   0,  0,  0,  3,$7F,$61,$74,$61,$72,$69,$24,$6C,$64,$62,$61,  0,  0,  1,$88,$88,  0,  0,  0,  3,$7F,$69,$74,$65,$6D,$32,$24,$6D,$64,$62,$61,  0,  0,  1,$88,$EE,  0,  0,  0,  3,$70,$6C,$61,$79,$64,$69,$65,$73,$65,$74,  0,  0,  0,  1,$8A,$72,  0,  0,  0,  3; 16640
		dc.b $7F,$69,$6D,$6F,$24,$76,$64,$62,$61,  0,  0,  0,  0,  1,$8A,$EC,  0,  0,  0,  4,$7F,$77,$6F,$72,$6B,$6E,$61,$69,$24,$74,$64,$62,$61,  0,  0,  0,  0,  1,$89,$F6,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$74,$64,$62,$61,  0,  0,  0,  0,  1,$8A,$66,  0,  0,  0,  3; 16704
		dc.b $7F,$65,$6E,$64,$24,$75,$64,$62,$61,  0,  0,  0,  0,  1,$8A,$C6,  0,  0,  0,  3,$7F,$64,$61,$6D,$61,$67,$65,$24,$74,$64,$62,$61,  0,  1,$89,$F6,  0,  0,  0,  4,$7F,$63,$6F,$6C,$69,$74,$62,$6C,$24,$6C,$64,$62,$61,  0,  0,  0,  0,  1,$87,$FA,  0,  0,  0,  3; 16768
		dc.b $7F,$62,$6F,$75,$24,$76,$64,$62,$61,  0,  0,  0,  0,  1,$8B,$34,  0,  0,  0,  2,$70,$63,$6F,$6C,$65,  0,  0,  0,  0,  1,$89,$C4,  0,  0,  0,  3,$7F,$64,$69,$65,$24,$74,$64,$62,$61,  0,  0,  0,  0,  1,$8A,$6A,  0,  0,  0,  3,$7F,$79,$61,$64,$6F,$31,$24,$76; 16832
		dc.b $64,$62,$61,  0,  0,  1,$8B, $A,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$30,$24,$6C,$64,$62,$61,  0,  0,  1,$87,$DA,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$30,$24,$6E,$64,$62,$61,  0,  0,  1,$89,$44,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$30,$24,$74,$64,$62,$61,  0; 16896
		dc.b   0,  1,$8A,$2C,  0,  0,  0,  3,$7F,$79,$61,$64,$6F,$32,$24,$76,$64,$62,$61,  0,  0,  1,$8B,$16,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$31,$24,$6E,$64,$62,$61,  0,  0,  1,$89,$9C,  0,  0,  0,  3,$7F,$79,$61,$64,$6F,$33,$24,$76,$64,$62,$61,  0,  0,  1,$8B,$1A; 16960
		dc.b   0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$75,$64,$62,$61,  0,  0,  1,$8A,$C0,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$6C,$64,$62,$61,  0,  0,  1,$88,$42,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$6E,$64,$62,$61,  0,  0,  1,$89,$A4,  0,  0,  0,  3; 17024
		dc.b $7F,$6A,$75,$6D,$70,$32,$24,$74,$64,$62,$61,  0,  0,  1,$8A,$60,  0,  0,  0,  3,$7F,$79,$61,$64,$6F,$34,$24,$76,$64,$62,$61,  0,  0,  1,$8B,$1E,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$33,$24,$6C,$64,$62,$61,  0,  0,  1,$88,$64,  0,  0,  0,  3,$7F,$6A,$75,$6D; 17088
		dc.b $70,$33,$24,$6E,$64,$62,$61,  0,  0,  1,$89,$86,  0,  0,  0,  3,$7F,$69,$74,$65,$6D,$65,$24,$6D,$64,$62,$61,  0,  0,  1,$89,  0,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$34,$24,$6C,$64,$62,$61,  0,  0,  1,$88,$6A,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$34,$24,$6E; 17152
		dc.b $64,$62,$61,  0,  0,  1,$89,$42,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$35,$24,$6C,$64,$62,$61,  0,  0,  1,$88,$82,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$35,$24,$6E,$64,$62,$61,  0,  0,  1,$89,$5C,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$36,$24,$6E,$64,$62,$61,  0; 17216
		dc.b   0,  1,$89,$76,  0,  0,  0,  3,$7F,$62,$6F,$62,$69,$6E,$32,$24,$76,$64,$62,$61,  0,  1,$8B,$2E,  0,  0,  0,  3,$70,$63,$6F,$6C,$6E,$6F,$6D,$61,$6C,  0,  0,  0,  0,  1,$89,  2,  0,  0,  0,  4,$70,$6C,$61,$79,$64,$61,$6D,$61,$67,$65,$73,$65,$74,  0,  0,  0; 17280
		dc.b   0,  1,$89,$CE,  0,  0,  0,  2,$70,$63,$6F,$6C,$65,$6E,$64,  0,  0,  1,$89,$C0,  0,  0,  0,  3,$7F,$79,$61,$64,$6F,$24,$76,$64,$62,$61,  0,  0,  0,  1,$8A,$F0,  0,  0,  0,  3,$7F,$72,$69,$6E,$67,$24,$6D,$64,$62,$61,  0,  0,  0,  1,$88,$B0,  0,  0,  0,  3; 17344
		dc.b $7F,$72,$69,$6E,$67,$65,$24,$6D,$64,$62,$61,  0,  0,  1,$88,$C0,  0,  0,  0,  1,$70,$63,$6F,$6C,  0,  1,$87,$B0,  0,  0,  0,  3,$7F,$69,$74,$65,$6D,$24,$6D,$64,$62,$61,  0,  0,  0,  1,$88,$C2,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$74,$64,$62,$61,  0,  0; 17408
		dc.b   0,  1,$8A,$3A,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$6C,$64,$62,$61,  0,  0,  0,  1,$87,$EE,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$6E,$64,$62,$61,  0,  0,  0,  1,$89,$1A,  0,  0,  0,  2,$70,$63,$6F,$6C,$70,$6C,$61,$79,  0,  1,$89,$BA,  0,  0,  0,  2; 17472
		dc.b $70,$63,$6F,$6C,$69,$74,$65,$6D,  0,  1,$88,$A2,  0,  0,  0,  2,$68,$6F,$75,$73,$30,$70,$61,$74,  0,  1,$93,$5A,  0,  0,  0,  2,$68,$6F,$75,$73,$31,$70,$61,$74,  0,  1,$93,$5E,  0,  0,  0,  2,$68,$6F,$75,$73,$32,$70,$61,$74,  0,  1,$93,$62,  0,  0,  0,  3; 17536
		dc.b $73,$70,$68,$61,$73,$68,$70,$61,$74,  0,  0,  0,  0,  1,$93,$1A,  0,  0,  0,  4,$73,$63,$72,$5F,$68,$6F,$75,$73,$65,$6B,$69,$74,$62,$6C,  0,  0,  0,  1,$90,  8,  0,  0,  0,  2,$73,$70,$75,$70,$73,$70,$30,  0,  0,  1,$93,$3E,  0,  0,  0,  2,$73,$70,$75,$70; 17600
		dc.b $73,$70,$31,  0,  0,  1,$93,$44,  0,  0,  0,  2,$6D,$65,$74,$70,$61,$74,  0,  0,  0,  1,$93,  6,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$62,$65,$62,$61,  0,  0,  0,  1,$8F,$C4,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$64,$65,$62,$61,  0,  0,  0,  1,$90,  6; 17664
		dc.b   0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$66,$65,$62,$61,  0,  0,  0,  1,$90,$3A,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$6A,$65,$62,$61,  0,  0,  0,  1,$90,$8E,  0,  0,  0,  2,$64,$65,$72,$75,$73,$70,$32,  0,  0,  1,$93,$18,  0,  0,  0,  2,$73,$70,$72,$73; 17728
		dc.b $63,$72,$65,  0,  0,  1,$8B,$DC,  0,  0,  0,  2,$6B,$6F,$75,$6B,$61,$70,$61,$74,  0,  1,$93,$1A,  0,  0,  0,  3,$73,$63,$72,$61,$63,$74,$6F,$66,$66,$74,$62,$6C,  0,  1,$8E,$34,  0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$24,$6E,$64,$62,$61,  0,  0,  0,  1,$8B,$98; 17792
		dc.b   0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$24,$70,$64,$62,$61,  0,  0,  0,  1,$8C,  6,  0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$24,$71,$64,$62,$61,  0,  0,  0,  1,$8C,$9E,  0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$24,$73,$64,$62,$61,  0,  0,  0,  1,$8E,$BE,  0,  0,  0,  3; 17856
		dc.b $7F,$6C,$6F,$6F,$70,$24,$74,$64,$62,$61,  0,  0,  0,  1,$8E,$D4,  0,  0,  0,  3,$73,$70,$64,$6F,$77,$6E,$73,$70,$30,  0,  0,  0,  0,  1,$93,$4E,  0,  0,  0,  3,$73,$70,$64,$6F,$77,$6E,$73,$70,$31,  0,  0,  0,  0,  1,$93,$54,  0,  0,  0,  2,$73,$70,$72,$65; 17920
		dc.b $76,$70,$61,$74,  0,  1,$93,  6,  0,  0,  0,  3,$73,$63,$72,$5F,$62,$72,$65,$61,$6B,  0,  0,  0,  0,  1,$90, $E,  0,  0,  0,  2,$7A,$6F,$6E,$65,$70,$61,$74,  0,  0,  1,$93,  6,  0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$24,$6A,$65,$62,$61,  0,  0,  0,  1,$90,$DC; 17984
		dc.b   0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$24,$6B,$65,$62,$61,  0,  0,  0,  1,$91, $E,  0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$24,$6C,$65,$62,$61,  0,  0,  0,  1,$91,$2A,  0,  0,  0,  4,$73,$63,$72,$5F,$72,$65,$76,$65,$72,$73,$74,$62,$6C,  0,  0,  0,  0,  1,$8F,$C8; 18048
		dc.b   0,  0,  0,  3,$7F,$65,$6E,$64,$24,$76,$64,$62,$61,  0,  0,  0,  0,  1,$8F,$2A,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$70,$64,$62,$61,  0,  0,  0,  0,  1,$8C,$82,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$78,$64,$62,$61,  0,  0,  0,  0,  1,$8F,$60,  0,  0,  0,  3; 18112
		dc.b $7F,$65,$6E,$64,$24,$7A,$64,$62,$61,  0,  0,  0,  0,  1,$8F,$90,  0,  0,  0,  2,$62,$72,$65,$61,$6B,$70,$61,$74,  0,  1,$93,$1A,  0,  0,  0,  2,$67,$6F,$6C,$65,$73,$70,$30,  0,  0,  1,$93, $C,  0,  0,  0,  2,$67,$6F,$6C,$65,$73,$70,$31,  0,  0,  1,$93,$12; 18176
		dc.b   0,  0,  0,  3,$73,$63,$72,$5F,$72,$65,$76,$65,$72,$73,  0,  0,  0,  1,$8F,$98,  0,  0,  0,  3,$73,$70,$72,$6D,$61,$70,$73,$65,$74,$74,$62,$6C,  0,  1,$90,$46,  0,  0,  0,  3,$73,$70,$72,$73,$63,$72,$61,$63,$74,$63,$6E,$74,  0,  1,$8C,$8A,  0,  0,  0,  3; 18240
		dc.b $7F,$65,$6E,$64,$24,$64,$65,$62,$61,  0,  0,  0,  0,  1,$90,  6,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$66,$65,$62,$61,  0,  0,  0,  0,  1,$90,$3A,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$62,$65,$62,$61,  0,  0,  0,  0,  1,$8F,$C6,  0,  0,  0,  2,$73,$70,$72,$73; 18304
		dc.b $63,$72,  0,  0,  0,  1,$8B,$48,  0,  0,  0,  2,$64,$65,$72,$75,$70,$61,$74,  0,  0,  1,$93,  6,  0,  0,  0,  3,$73,$63,$72,$5F,$62,$6F,$62,$69,$6E,$74,$62,$6C,  0,  1,$8F,$62,  0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$32,$24,$6E,$64,$62,$61,  0,  0,  1,$8B,$BA; 18368
		dc.b   0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$32,$24,$70,$64,$62,$61,  0,  0,  1,$8C, $A,  0,  0,  0,  2,$6B,$6F,$75,$6B,$61,$73,$70,$30,  0,  1,$93,$22,  0,  0,  0,  2,$6B,$6F,$75,$6B,$61,$73,$70,$31,  0,  1,$93,$28,  0,  0,  0,  2,$6B,$6F,$75,$6B,$61,$73,$70,$32; 18432
		dc.b   0,  1,$93,$2E,  0,  0,  0,  2,$6B,$6F,$75,$6B,$61,$73,$70,$33,  0,  1,$93,$34,  0,  0,  0,  2,$73,$70,$75,$70,$70,$61,$74,  0,  0,  1,$93,$3A,  0,  0,  0,  3,$73,$70,$68,$61,$73,$68,$73,$70,$30,  0,  0,  0,  0,  1,$93,$22,  0,  0,  0,  3,$73,$70,$68,$61; 18496
		dc.b $73,$68,$73,$70,$31,  0,  0,  0,  0,  1,$93,$28,  0,  0,  0,  2,$73,$63,$72,$5F,$31,$75,$70,  0,  0,  1,$8F,$68,  0,  0,  0,  3,$73,$63,$72,$5F,$31,$75,$70,$74,$62,$6C,  0,  0,  0,  1,$8F,$92,  0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$30,$24,$6A,$65,$62,$61,  0; 18560
		dc.b   0,  1,$90,$A4,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$71,$64,$62,$61,  0,  0,  1,$8C,$C2,  0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$31,$24,$6A,$65,$62,$61,  0,  0,  1,$90,$F0,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$33,$24,$71,$64,$62,$61,  0,  0,  1,$8D,$4A; 18624
		dc.b   0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$32,$24,$6A,$65,$62,$61,  0,  0,  1,$90,$F2,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$34,$24,$71,$64,$62,$61,  0,  0,  1,$8C,$DE,  0,  0,  0,  3,$73,$70,$68,$6F,$75,$73,$73,$70,$30,  0,  0,  0,  0,  1,$93,$66,  0,  0,  0,  3; 18688
		dc.b $73,$70,$68,$6F,$75,$73,$73,$70,$31,  0,  0,  0,  0,  1,$93,$6C,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$35,$24,$71,$64,$62,$61,  0,  0,  1,$8D,$20,  0,  0,  0,  3,$73,$70,$68,$6F,$75,$73,$73,$70,$32,  0,  0,  0,  0,  1,$93,$72,  0,  0,  0,  3,$73,$70,$68,$6F; 18752
		dc.b $75,$73,$73,$70,$33,  0,  0,  0,  0,  1,$93,$78,  0,  0,  0,  2,$73,$63,$72,$63,$6E,$74,  0,  0,  0,  1,$8E,$CA,  0,  0,  0,  2,$73,$70,$31,$75,$70,$70,$61,$74,  0,  1,$93,  6,  0,  0,  0,  3,$73,$70,$64,$6F,$77,$6E,$70,$61,$74,  0,  0,  0,  0,  1,$93,$4A; 18816
		dc.b   0,  0,  0,  3,$73,$70,$72,$6D,$61,$70,$73,$65,$74,  0,  0,  0,  0,  1,$90,$76,  0,  0,  0,  3,$73,$63,$72,$61,$63,$74,$74,$62,$6C,  0,  0,  0,  0,  1,$8E,$EA,  0,  0,  0,  3,$73,$63,$72,$70,$61,$74,$73,$65,$74,  0,  0,  0,  0,  1,$91,  0,  0,  0,  0,  3; 18880
		dc.b $7F,$6A,$75,$6D,$70,$30,$24,$6A,$65,$62,$61,  0,  0,  1,$90,$AC,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$6A,$65,$62,$61,  0,  0,  1,$90,$B0,  0,  0,  0,  3,$73,$63,$72,$5F,$62,$72,$65,$61,$6B,$74,$62,$6C,  0,  1,$90,$3C,  0,  0,  0,  2,$73,$63,$72,$5F; 18944
		dc.b $72,$69,$6E,$67,  0,  1,$8F,  2,  0,  0,  0,  3,$73,$63,$72,$5F,$68,$6F,$75,$73,$65,$6B,$69,  0,  0,  1,$8F,$CE,  0,  0,  0,  3,$73,$63,$72,$5F,$72,$69,$6E,$67,$74,$62,$6C,  0,  0,  1,$8F,$2C,  0,  0,  0,  3,$73,$63,$72,$63,$6E,$74,$63,$6C,$72,  0,  0,  0; 19008
		dc.b   0,  1,$91,$20,  0,  0,  0,  3,$73,$63,$72,$70,$61,$74,$74,$62,$6C,  0,  0,  0,  0,  1,$91,$32,  0,  0,  0,  4,$73,$70,$72,$70,$6C,$61,$79,$70,$6F,$73,$69,$74,$62,$6C,  0,  0,  0,  1,$90,$5E,  0,  0,  0,  2,$73,$63,$72,$77,$6B,$63,$68,$6B,  0,  1,$8E,$B4; 19072
		dc.b   0,  0,  0,  3,$73,$70,$72,$73,$63,$72,$73,$65,$74,  0,  0,  0,  0,  1,$8B,$DC,  0,  0,  0,  3,$73,$63,$72,$5F,$62,$6F,$62,$69,$6E,  0,  0,  0,  0,  1,$8F,$32,  0,  0,  0,  2,$67,$6F,$6C,$65,$70,$61,$74,  0,  0,  1,$93,  6,  0,  0,  0,  3,$7F,$6A,$75,$6D; 19136
		dc.b $70,$24,$73,$64,$62,$61,  0,  0,  0,  1,$8E,$C8,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$74,$64,$62,$61,  0,  0,  0,  1,$8E,$E2,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$70,$64,$62,$61,  0,  0,  0,  1,$8C,$62,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$76,$64; 19200
		dc.b $62,$61,  0,  0,  0,  1,$8F,$2A,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$78,$64,$62,$61,  0,  0,  0,  1,$8F,$5E,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$7A,$64,$62,$61,  0,  0,  0,  1,$8F,$90,  0,  0,  0,  2,$77,$61,$72,$70,$70,$61,$74,  0,  0,  1,$93,  6; 19264
		dc.b   0,  0,  0,  2,$64,$65,$72,$75,$73,$75,$62,  0,  0,  1,$98,$5C,  0,  0,  0,  2,$73,$70,$63,$6F,$6C,  0,  0,  0,  0,  1,$96,$E8,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$6E,$65,$62,$61,  0,  0,  0,  1,$93,$8E,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$76,$65; 19328
		dc.b $62,$61,  0,  0,  0,  1,$94,$F2,  0,  0,  0,  3,$7F,$6A,$6D,$70,$32,$24,$6B,$66,$62,$61,  0,  0,  0,  1,$98,$AC,  0,  0,  0,  3,$70,$6C,$61,$79,$30,$31,$69,$6E,$69,$74,  0,  0,  0,  1,$93,$A4,  0,  0,  0,  2,$73,$70,$63,$6F,$6C,$32,  0,  0,  0,  1,$96,$E8; 19392
		dc.b   0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$36,$36,$24,$6B,$66,$62,$61,  0,  1,$99,$F2,  0,  0,  0,  3,$70,$6C,$61,$79,$30,$31,$6A,$75,$6D,$70,  0,  0,  0,  1,$94,$2E,  0,  0,  0,  3,$72,$6F,$74,$73,$70,$64,$73,$65,$74,  0,  0,  0,  0,  1,$96,$56,  0,  0,  0,  4; 19456
		dc.b $70,$6C,$61,$79,$30,$31,$5F,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0,  1,$93,$9C,  0,  0,  0,  3,$7F,$6C,$65,$66,$74,$32,$24,$76,$65,$62,$61,  0,  0,  1,$94,$A4,  0,  0,  0,  3,$7F,$6C,$65,$66,$74,$32,$24,$77,$65,$62,$61,  0,  0,  1,$95,$14,  0,  0,  0,  3; 19520
		dc.b $7F,$6C,$65,$66,$74,$32,$24,$78,$65,$62,$61,  0,  0,  1,$95,$50,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$62,$66,$62,$61,  0,  0,  0,  1,$96,$12,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$61,$66,$62,$61,  0,  0,  0,  1,$95,$CE,  0,  0,  0,  3,$7F,$6A,$75,$6D; 19584
		dc.b $70,$24,$69,$66,$62,$61,  0,  0,  0,  1,$97,$C4,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$6A,$66,$62,$61,  0,  0,  0,  1,$98,$78,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$6B,$66,$62,$61,  0,  0,  0,  1,$98,$AE,  0,  0,  0,  3,$7F,$6C,$65,$66,$74,$24,$76,$65; 19648
		dc.b $62,$61,  0,  0,  0,  1,$94,$9A,  0,  0,  0,  3,$7F,$6C,$65,$66,$74,$24,$77,$65,$62,$61,  0,  0,  0,  1,$95,  6,  0,  0,  0,  3,$7F,$6C,$65,$66,$74,$24,$78,$65,$62,$61,  0,  0,  0,  1,$95,$48,  0,  0,  0,  3,$7F,$72,$69,$67,$68,$74,$24,$76,$65,$62,$61,  0; 19712
		dc.b   0,  1,$94,$8A,  0,  0,  0,  3,$7F,$72,$69,$67,$68,$74,$24,$77,$65,$62,$61,  0,  0,  1,$95,$1A,  0,  0,  0,  3,$7F,$72,$69,$67,$68,$74,$24,$78,$65,$62,$61,  0,  0,  1,$95,$34,  0,  0,  0,  2,$62,$6F,$62,$69,$6E,$63,$68,$6B,  0,  1,$98,$8E,  0,  0,  0,  4; 19776
		dc.b $7F,$6A,$75,$6D,$70,$36,$36,$36,$24,$6B,$66,$62,$61,  0,  0,  0,  0,  1,$9A,$12,  0,  0,  0,  3,$70,$6C,$61,$79,$30,$31,$67,$6F,$6C,$65,  0,  0,  0,  1,$95,$E0,  0,  0,  0,  2,$70,$6C,$61,$79,$73,$63,$72,  0,  0,  1,$95,$B6,  0,  0,  0,  3,$70,$6C,$61,$79; 19840
		dc.b $30,$31,$6D,$6F,$76,$65,  0,  0,  0,  1,$93,$E4,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$79,$65,$62,$61,  0,  0,  0,  0,  1,$95,$98,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$7A,$65,$62,$61,  0,  0,  0,  0,  1,$95,$B4,  0,  0,  0,  2,$73,$70,$63,$6F,$6C,$73,$75,$62; 19904
		dc.b   0,  1,$97,$30,  0,  0,  0,  4,$70,$6C,$61,$79,$30,$31,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0,  0,  1,$94,$1C,  0,  0,  0,  3,$73,$70,$6A,$75,$6D,$70,$63,$68,$6B,$32,  0,  0,  0,  1,$95,$9A,  0,  0,  0,  4,$7F,$77,$6F,$72,$6B,$6E,$61,$69,$24,$69,$66,$62; 19968
		dc.b $61,  0,  0,  0,  0,  1,$97,$A0,  0,  0,  0,  4,$7F,$77,$6F,$72,$6B,$6E,$61,$69,$24,$6B,$66,$62,$61,  0,  0,  0,  0,  1,$99,$1C,  0,  0,  0,  3,$7F,$6A,$6D,$70,$24,$6B,$66,$62,$61,  0,  0,  0,  0,  1,$98,$A0,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$63,$66,$62; 20032
		dc.b $61,  0,  0,  0,  0,  1,$96,$40,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$67,$66,$62,$61,  0,  0,  0,  0,  1,$97,$44,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$6A,$66,$62,$61,  0,  0,  0,  0,  1,$98,$86,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$6B,$66,$62,$61,  0,  0,  0; 20096
		dc.b   0,  1,$9A,$20,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$33,$33,$24,$6B,$66,$62,$61,  0,  1,$99,$66,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$33,$33,$24,$69,$66,$62,$61,  0,  1,$98,$2A,  0,  0,  0,  4,$7F,$72,$69,$67,$68,$74,$63,$6F,$6C,$24,$78,$65,$62,$61,  0,  0; 20160
		dc.b   0,  1,$95,$54,  0,  0,  0,  3,$7F,$72,$69,$67,$68,$74,$32,$24,$76,$65,$62,$61,  0,  1,$94,$94,  0,  0,  0,  3,$7F,$72,$69,$67,$68,$74,$32,$24,$77,$65,$62,$61,  0,  1,$95,$22,  0,  0,  0,  3,$7F,$72,$69,$67,$68,$74,$32,$24,$78,$65,$62,$61,  0,  1,$95,$42; 20224
		dc.b   0,  0,  0,  3,$70,$6C,$61,$79,$30,$31,$77,$61,$6C,$6B,  0,  0,  0,  1,$94,$20,  0,  0,  0,  3,$73,$70,$63,$6F,$6C,$73,$75,$62,$5F,$65,$76,  0,  0,  1,$97,$8C,  0,  0,  0,  3,$70,$6C,$61,$79,$30,$31,$67,$6F,$6C,$65,$32,  0,  0,  1,$96,$34,  0,  0,  0,  3; 20288
		dc.b $7F,$6C,$6F,$6F,$70,$31,$24,$6A,$66,$62,$61,  0,  0,  1,$98,$6C,  0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$32,$24,$6A,$66,$62,$61,  0,  0,  1,$98,$6E,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$35,$24,$76,$65,$62,$61,  0,  0,  1,$94,$6C,  0,  0,  0,  3,$7F,$6A,$75,$6D; 20352
		dc.b $70,$35,$24,$71,$65,$62,$61,  0,  0,  1,$93,$F8,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$36,$24,$76,$65,$62,$61,  0,  0,  1,$94,$78,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$37,$24,$76,$65,$62,$61,  0,  0,  1,$94,$A8,  0,  0,  0,  2,$73,$70,$63,$6F,$6C,$5F,$65,$76; 20416
		dc.b   0,  1,$97,$52,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$34,$34,$24,$6B,$66,$62,$61,  0,  1,$99,$9A,  0,  0,  0,  2,$70,$6C,$61,$79,$30,$31,  0,  0,  0,  1,$93,$80,  0,  0,  0,  2,$70,$6C,$61,$79,$30,$32,  0,  0,  0,  1,$9A,$22,  0,  0,  0,  3,$7F,$6A,$75,$6D; 20480
		dc.b $70,$30,$24,$62,$66,$62,$61,  0,  0,  1,$95,$F4,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$67,$66,$62,$61,  0,  0,  1,$97,$46,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$61,$66,$62,$61,  0,  0,  1,$95,$DE,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$64; 20544
		dc.b $66,$62,$61,  0,  0,  1,$96,$B0,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$69,$66,$62,$61,  0,  0,  1,$97,$C8,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$6B,$66,$62,$61,  0,  0,  1,$99,$26,  0,  0,  0,  3,$73,$70,$70,$6C,$77,$61,$6C,$6B,$5F,$6C,  0,  0; 20608
		dc.b   0,  1,$94,$F8,  0,  0,  0,  3,$73,$70,$70,$6C,$77,$61,$6C,$6B,$5F,$72,  0,  0,  0,  1,$95,$28,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$33,$24,$64,$66,$62,$61,  0,  0,  1,$96,$C6,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$33,$24,$69,$66,$62,$61,  0,  0,  1,$97,$F2; 20672
		dc.b   0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$33,$24,$6B,$66,$62,$61,  0,  0,  1,$99,$3C,  0,  0,  0,  3,$70,$6C,$61,$79,$30,$31,$73,$75,$62,  0,  0,  0,  0,  1,$94,$3A,  0,  0,  0,  3,$73,$70,$6C,$65,$76,$65,$72,$6D,$6F,$76,$65,  0,  0,  1,$94,$60,  0,  0,  0,  3; 20736
		dc.b $7F,$6A,$75,$6D,$70,$34,$24,$64,$66,$62,$61,  0,  0,  1,$96,$D4,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$34,$24,$69,$66,$62,$61,  0,  0,  1,$98,$38,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$34,$24,$6B,$66,$62,$61,  0,  0,  1,$99,$70,  0,  0,  0,  3,$7F,$6A,$75,$6D; 20800
		dc.b $70,$35,$24,$69,$66,$62,$61,  0,  0,  1,$98,$44,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$35,$24,$6B,$66,$62,$61,  0,  0,  1,$99,$A4,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$36,$24,$69,$66,$62,$61,  0,  0,  1,$98,$58,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$36,$24,$6B; 20864
		dc.b $66,$62,$61,  0,  0,  1,$99,$DA,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$37,$24,$6B,$66,$62,$61,  0,  0,  1,$9A,$20,  0,  0,  0,  3,$73,$70,$6A,$75,$6D,$70,$63,$68,$6B,  0,  0,  0,  0,  1,$95,$56,  0,  0,  0,  4,$7F,$77,$6F,$72,$6B,$6E,$61,$69,$32,$24,$69,$66; 20928
		dc.b $62,$61,  0,  0,  0,  1,$97,$DC,  0,  0,  0,  4,$7F,$77,$6F,$72,$6B,$6E,$61,$69,$32,$24,$6B,$66,$62,$61,  0,  0,  0,  1,$99,$CC,  0,  0,  0,  4,$7F,$77,$6F,$72,$6B,$6E,$61,$69,$33,$24,$69,$66,$62,$61,  0,  0,  0,  1,$98, $C,  0,  0,  0,  4,$7F,$77,$6F,$72; 20992
		dc.b $6B,$6E,$61,$69,$33,$24,$6B,$66,$62,$61,  0,  0,  0,  1,$9A,$16,  0,  0,  0,  3,$65,$66,$65,$63,$74,$74,$62,$6C,$30,  0,  0,  0,  0,  1,$9A,$F8,  0,  0,  0,  3,$65,$66,$65,$63,$74,$74,$62,$6C,$31,  0,  0,  0,  0,  1,$9B,$82,  0,  0,  0,  3,$65,$66,$65,$63; 21056
		dc.b $74,$74,$62,$6C,$32,  0,  0,  0,  0,  1,$9B,$82,  0,  0,  0,  3,$65,$66,$65,$63,$74,$74,$62,$6C,$33,  0,  0,  0,  0,  1,$9A,$F8,  0,  0,  0,  3,$65,$66,$65,$63,$74,$74,$62,$6C,$34,  0,  0,  0,  0,  1,$9B,$56,  0,  0,  0,  3,$65,$66,$65,$63,$74,$74,$62,$6C; 21120
		dc.b $35,  0,  0,  0,  0,  1,$9B,$82,  0,  0,  0,  3,$65,$66,$65,$63,$74,$74,$62,$6C,$36,  0,  0,  0,  0,  1,$9B,$82,  0,  0,  0,  3,$65,$66,$65,$63,$74,$74,$62,$6C,$37,  0,  0,  0,  0,  1,$9B,$82,  0,  0,  0,  3,$65,$66,$65,$63,$74,$74,$62,$6C,$38,  0,  0,  0; 21184
		dc.b   0,  1,$9B,$56,  0,  0,  0,  3,$65,$66,$65,$63,$74,$74,$62,$6C,$39,  0,  0,  0,  0,  1,$9B,$82,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$6E,$65,$62,$61,  0,  0,  0,  1,$9A,$AC,  0,  0,  0,  3,$65,$66,$65,$63,$74,$74,$62,$6C,$61,  0,  0,  0,  0,  1,$9B,$82; 21248
		dc.b   0,  0,  0,  3,$65,$66,$65,$63,$74,$74,$62,$6C,$62,  0,  0,  0,  0,  1,$9B,$82,  0,  0,  0,  3,$65,$66,$65,$63,$74,$74,$62,$6C,$63,  0,  0,  0,  0,  1,$9B,$82,  0,  0,  0,  3,$65,$66,$65,$63,$74,$74,$62,$6C,$64,  0,  0,  0,  0,  1,$9B,$82,  0,  0,  0,  3; 21312
		dc.b $65,$66,$65,$63,$74,$74,$62,$6C,$65,  0,  0,  0,  0,  1,$9B,$82,  0,  0,  0,  3,$65,$66,$65,$63,$74,$74,$62,$6C,$66,  0,  0,  0,  0,  1,$9B,$82,  0,  0,  0,  3,$7A,$6F,$6E,$65,$30,$61,$70,$63,$62,$6C,$6B,  0,  0,  1,$9D,$5C,  0,  0,  0,  3,$7F,$6A,$75,$6D; 21376
		dc.b $70,$24,$65,$66,$62,$61,  0,  0,  0,  1,$9B,$F4,  0,  0,  0,  3,$7A,$6F,$6E,$65,$30,$62,$70,$63,$62,$6C,$6B,  0,  0,  1,$9D,$5C,  0,  0,  0,  3,$7A,$6F,$6E,$65,$30,$63,$70,$63,$62,$6C,$6B,  0,  0,  1,$9D,$5C,  0,  0,  0,  3,$7A,$6F,$6E,$65,$30,$64,$70,$63; 21440
		dc.b $62,$6C,$6B,  0,  0,  1,$9E,$9A,  0,  0,  0,  3,$7A,$6F,$6E,$65,$30,$65,$70,$63,$62,$6C,$6B,  0,  0,  1,$9D,$5C,  0,  0,  0,  3,$7A,$6F,$6E,$65,$30,$66,$70,$63,$62,$6C,$6B,  0,  0,  1,$9D,$5C,  0,  0,  0,  2,$65,$66,$65,$63,$74,$74,$62,$6C,  0,  1,$9A,$4C; 21504
		dc.b   0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$24,$6E,$65,$62,$61,  0,  0,  0,  1,$9A,$96,  0,  0,  0,  4,$65,$66,$65,$63,$74,$62,$6C,$6F,$63,$6B,$73,$65,$74,  0,  0,  0,  0,  1,$9C,$BE,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$77,$64,$62,$61,  0,  0,  0,  0,  1,$9A,$4A; 21568
		dc.b   0,  0,  0,  4,$65,$66,$65,$63,$74,$62,$6C,$6F,$63,$6B,$74,$62,$6C,  0,  0,  0,  0,  1,$9D,  0,  0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$24,$65,$66,$62,$61,  0,  0,  0,  1,$9C,$28,  0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$24,$66,$66,$62,$61,  0,  0,  0,  1,$9C,$E0; 21632
		dc.b   0,  0,  0,  3,$7F,$73,$75,$62,$24,$65,$66,$62,$61,  0,  0,  0,  0,  1,$9C,$24,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$65,$66,$62,$61,  0,  0,  0,  0,  1,$9B,$F2,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$66,$66,$62,$61,  0,  0,  0,  0,  1,$9C,$E6,  0,  0,  0,  3; 21696
		dc.b $7A,$6F,$6E,$65,$30,$38,$70,$63,$62,$6C,$6B,  0,  0,  1,$9F,$7E,  0,  0,  0,  3,$7A,$6F,$6E,$65,$30,$39,$70,$63,$62,$6C,$6B,  0,  0,  1,$9D,$5C,  0,  0,  0,  3,$7A,$6F,$6E,$65,$30,$37,$70,$63,$62,$6C,$6B,  0,  0,  1,$9D,$5C,  0,  0,  0,  2,$65,$66,$65,$63; 21760
		dc.b $74,$77,$72,$74,  0,  1,$9A,$2C,  0,  0,  0,  2,$65,$66,$73,$74,$61,$67,$65,$61,  0,  1,$9A,$8C,  0,  0,  0,  2,$65,$66,$73,$74,$61,$67,$65,$62,  0,  1,$9A,$8C,  0,  0,  0,  2,$65,$66,$73,$74,$61,$67,$65,$63,  0,  1,$9A,$8C,  0,  0,  0,  2,$65,$66,$73,$74; 21824
		dc.b $61,$67,$65,$64,  0,  1,$9A,$90,  0,  0,  0,  2,$65,$66,$73,$74,$61,$67,$65,$65,  0,  1,$9A,$8C,  0,  0,  0,  2,$65,$66,$73,$74,$61,$67,$65,$66,  0,  1,$9A,$8C,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$31,$24,$6E,$65,$62,$61,  0,  0,  1,$9A,$BA,  0,  0,  0,  3; 21888
		dc.b $65,$66,$65,$63,$74,$6D,$6F,$76,$65,  0,  0,  0,  0,  1,$9B,$EA,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$6E,$65,$62,$61,  0,  0,  1,$9A,$DC,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$33,$24,$6E,$65,$62,$61,  0,  0,  1,$9A,$E6,  0,  0,  0,  3,$7F,$6C,$6F,$6F; 21952
		dc.b $70,$32,$24,$66,$66,$62,$61,  0,  0,  1,$9C,$E8,  0,  0,  0,  3,$7A,$6F,$6E,$65,$30,$30,$70,$63,$62,$6C,$6B,  0,  0,  1,$9D,$20,  0,  0,  0,  3,$7A,$6F,$6E,$65,$30,$31,$70,$63,$62,$6C,$6B,  0,  0,  1,$9D,$5C,  0,  0,  0,  3,$7A,$6F,$6E,$65,$30,$32,$70,$63; 22016
		dc.b $62,$6C,$6B,  0,  0,  1,$9E,$9A,  0,  0,  0,  3,$7A,$6F,$6E,$65,$30,$33,$70,$63,$62,$6C,$6B,  0,  0,  1,$9D,$20,  0,  0,  0,  3,$7A,$6F,$6E,$65,$30,$34,$70,$63,$62,$6C,$6B,  0,  0,  1,$9F,$7E,  0,  0,  0,  3,$7A,$6F,$6E,$65,$30,$35,$70,$63,$62,$6C,$6B,  0; 22080
		dc.b   0,  1,$9D,$5C,  0,  0,  0,  2,$65,$66,$73,$74,$61,$67,$65,$30,  0,  1,$9A,$8E,  0,  0,  0,  2,$65,$66,$73,$74,$61,$67,$65,$31,  0,  1,$9A,$8C,  0,  0,  0,  2,$65,$66,$73,$74,$61,$67,$65,$32,  0,  1,$9A,$90,  0,  0,  0,  2,$65,$66,$73,$74,$61,$67,$65,$33; 22144
		dc.b   0,  1,$9A,$90,  0,  0,  0,  2,$65,$66,$73,$74,$61,$67,$65,$34,  0,  1,$9A,$90,  0,  0,  0,  3,$7A,$6F,$6E,$65,$30,$36,$70,$63,$62,$6C,$6B,  0,  0,  1,$9D,$5C,  0,  0,  0,  2,$65,$66,$73,$74,$61,$67,$65,$35,  0,  1,$9A,$8C,  0,  0,  0,  2,$65,$66,$73,$74; 22208
		dc.b $61,$67,$65,$36,  0,  1,$9A,$8C,  0,  0,  0,  2,$65,$66,$73,$74,$61,$67,$65,$37,  0,  1,$9A,$8C,  0,  0,  0,  2,$65,$66,$73,$74,$61,$67,$65,$38,  0,  1,$9A,$90,  0,  0,  0,  2,$65,$66,$73,$74,$61,$67,$65,$39,  0,  1,$9A,$8C,  0,  0,  0,  3,$7F,$6A,$75,$6D; 22272
		dc.b $70,$24,$62,$65,$62,$61,  0,  0,  0,  1,$A2,$B2,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$61,$65,$62,$61,  0,  0,  0,  1,$A2,$60,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$66,$65,$62,$61,  0,  0,  0,  1,$A4,$32,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$6A,$65; 22336
		dc.b $62,$61,  0,  0,  0,  1,$A4,$96,  0,  0,  0,  2,$70,$6F,$73,$69,$77,$72,$74,  0,  0,  1,$A4,$54,  0,  0,  0,  2,$73,$63,$6F,$72,$65,$75,$70,  0,  0,  1,$A2,$48,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$75,$73,$24,$61,$65,$62,$61,  0,  1,$A2,$88,  0,  0,  0,  2; 22400
		dc.b $72,$69,$6E,$67,$77,$72,$74,  0,  0,  1,$A4,$B4,  0,  0,  0,  4,$7F,$74,$69,$6D,$65,$6F,$76,$65,$72,$24,$62,$65,$62,$61,  0,  0,  0,  1,$A3,$66,  0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$24,$6A,$65,$62,$61,  0,  0,  0,  1,$A4,$84,  0,  0,  0,  3,$7F,$6C,$6F,$6F; 22464
		dc.b $70,$24,$66,$65,$62,$61,  0,  0,  0,  1,$A4,$1C,  0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$24,$78,$65,$62,$61,  0,  0,  0,  1,$A6,$64,  0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$24,$6D,$65,$62,$61,  0,  0,  0,  1,$A4,$CC,  0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$24,$6E,$65; 22528
		dc.b $62,$61,  0,  0,  0,  1,$A5,$3A,  0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$24,$76,$65,$62,$61,  0,  0,  0,  1,$A5,$A0,  0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$24,$77,$65,$62,$61,  0,  0,  0,  1,$A5,$F8,  0,  0,  0,  3,$73,$63,$6F,$72,$65,$77,$72,$74,$32,  0,  0,  0; 22592
		dc.b   0,  1,$A4,$C6,  0,  0,  0,  2,$68,$65,$78,$77,$72,$74,$77,  0,  0,  1,$A4,$7C,  0,  0,  0,  3,$73,$63,$6F,$72,$65,$77,$72,$74,$63,$67,  0,  0,  0,  1,$A6,$B6,  0,  0,  0,  2,$63,$6F,$6E,$74,$77,$72,$74,  0,  0,  1,$A5,$1C,  0,  0,  0,  2,$73,$63,$6F,$72; 22656
		dc.b $65,$70,$61,$74,  0,  1,$A0,$F8,  0,  0,  0,  2,$73,$63,$6F,$72,$65,$77,$72,$74,  0,  1,$A4,$BE,  0,  0,  0,  2,$74,$69,$6D,$65,$77,$72,$74,  0,  0,  1,$A5,$94,  0,  0,  0,  2,$74,$69,$6D,$65,$77,$72,$74,$30,  0,  1,$A5,$9A,  0,  0,  0,  2,$74,$69,$6D,$65; 22720
		dc.b $77,$72,$74,$31,  0,  1,$A5,$8C,  0,  0,  0,  2,$73,$63,$6F,$72,$65,  0,  0,  0,  0,  1,$A0,$74,  0,  0,  0,  3,$73,$63,$6F,$72,$65,$69,$6E,$69,$74,$73,$75,$62,  0,  1,$A4,$18,  0,  0,  0,  3,$73,$63,$6F,$72,$65,$5F,$69,$6E,$69,$74,  0,  0,  0,  1,$A0,$86; 22784
		dc.b   0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$30,$24,$75,$64,$62,$61,  0,  0,  1,$A0,$CE,  0,  0,  0,  3,$72,$69,$6E,$67,$69,$6E,$69,$74,$74,$62,$6C,  0,  0,  1,$A4,$50,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$75,$64,$62,$61,  0,  0,  1,$A0,$EE,  0,  0,  0,  3; 22848
		dc.b $7F,$6C,$6F,$6F,$70,$31,$24,$66,$65,$62,$61,  0,  0,  1,$A4,$2C,  0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$32,$24,$66,$65,$62,$61,  0,  0,  1,$A4,$38,  0,  0,  0,  3,$7F,$6C,$6F,$6F,$70,$32,$24,$77,$65,$62,$61,  0,  0,  1,$A6,$40,  0,  0,  0,  3,$7F,$6C,$6F,$6F; 22912
		dc.b $70,$32,$24,$78,$65,$62,$61,  0,  0,  1,$A6,$AA,  0,  0,  0,  3,$73,$63,$6F,$72,$65,$69,$6E,$69,$74,$74,$62,$6C,  0,  1,$A4,$44,  0,  0,  0,  2,$73,$75,$62,$74,$62,$6C,  0,  0,  0,  1,$A5,$74,  0,  0,  0,  3,$73,$63,$6F,$72,$65,$73,$65,$74,$32,  0,  0,  0; 22976
		dc.b   0,  1,$A3,$7C,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$30,$24,$61,$65,$62,$61,  0,  0,  1,$A2,$88,  0,  0,  0,  4,$7F,$73,$70,$61,$63,$65,$73,$65,$74,$24,$66,$65,$62,$61,  0,  0,  0,  1,$A4,$38,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$31,$24,$62,$65,$62,$61,  0; 23040
		dc.b   0,  1,$A2,$BE,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$31,$24,$63,$65,$62,$61,  0,  0,  1,$A3,$8C,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$62,$65,$62,$61,  0,  0,  1,$A2,$D2,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$63,$65,$62,$61,  0,  0,  1,$A3,$A0; 23104
		dc.b   0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$76,$65,$62,$61,  0,  0,  1,$A5,$A4,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$77,$65,$62,$61,  0,  0,  1,$A5,$FC,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$78,$65,$62,$61,  0,  0,  1,$A6,$6C,  0,  0,  0,  3; 23168
		dc.b $7F,$6A,$75,$6D,$70,$32,$24,$6D,$65,$62,$61,  0,  0,  1,$A4,$D0,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$6E,$65,$62,$61,  0,  0,  1,$A5,$3E,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$33,$24,$62,$65,$62,$61,  0,  0,  1,$A3, $E,  0,  0,  0,  3,$7F,$6A,$75,$6D; 23232
		dc.b $70,$33,$24,$63,$65,$62,$61,  0,  0,  1,$A3,$B0,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$33,$24,$76,$65,$62,$61,  0,  0,  1,$A5,$AC,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$33,$24,$77,$65,$62,$61,  0,  0,  1,$A6,  4,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$33,$24,$78; 23296
		dc.b $65,$62,$61,  0,  0,  1,$A6,$74,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$33,$24,$6D,$65,$62,$61,  0,  0,  1,$A4,$D8,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$33,$24,$6E,$65,$62,$61,  0,  0,  1,$A5,$46,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$34,$24,$62,$65,$62,$61,  0; 23360
		dc.b   0,  1,$A3,$2E,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$34,$24,$63,$65,$62,$61,  0,  0,  1,$A3,$BE,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$34,$24,$76,$65,$62,$61,  0,  0,  1,$A5,$B6,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$34,$24,$77,$65,$62,$61,  0,  0,  1,$A6, $E; 23424
		dc.b   0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$34,$24,$78,$65,$62,$61,  0,  0,  1,$A6,$7E,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$34,$24,$6D,$65,$62,$61,  0,  0,  1,$A4,$E2,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$35,$24,$62,$65,$62,$61,  0,  0,  1,$A3,$3C,  0,  0,  0,  3; 23488
		dc.b $7F,$6A,$75,$6D,$70,$35,$24,$63,$65,$62,$61,  0,  0,  1,$A3,$E6,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$35,$24,$77,$65,$62,$61,  0,  0,  1,$A6,$38,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$35,$24,$78,$65,$62,$61,  0,  0,  1,$A6,$82,  0,  0,  0,  3,$7F,$6A,$75,$6D; 23552
		dc.b $70,$35,$24,$6A,$65,$62,$61,  0,  0,  1,$A4,$AC,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$35,$24,$6D,$65,$62,$61,  0,  0,  1,$A5,$10,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$36,$24,$62,$65,$62,$61,  0,  0,  1,$A3,$64,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$36,$24,$78; 23616
		dc.b $65,$62,$61,  0,  0,  1,$A6,$98,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$37,$24,$77,$65,$62,$61,  0,  0,  1,$A6,$3E,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$37,$24,$78,$65,$62,$61,  0,  0,  1,$A6,$A4,  0,  0,  0,  2,$73,$63,$6F,$72,$65,$73,$65,$74,  0,  1,$A2,$8A; 23680
		dc.b   0,  0,  0,  2,$72,$69,$6E,$67,$69,$6E,$69,$74,  0,  1,$A3,$E8,  0,  0,  0,  3,$70,$6C,$61,$79,$73,$75,$75,$77,$72,$74,  0,  0,  0,  1,$A6,$4C,  0,  0,  0,  4,$73,$63,$6F,$72,$65,$5F,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0,  0,  1,$A0,$82,  0,  0,  0,  2; 23744
		dc.b $73,$63,$6F,$72,$65,$73,$70,$30,  0,  1,$A1,  0,  0,  0,  0,  2,$73,$63,$6F,$72,$65,$73,$70,$31,  0,  1,$A1,$52,  0,  0,  0,  2,$73,$63,$6F,$72,$65,$73,$70,$32,  0,  1,$A1,$A4,  0,  0,  0,  2,$73,$63,$6F,$72,$65,$73,$70,$33,  0,  1,$A1,$F6,  0,  0,  0,  2; 23808
		dc.b $73,$75,$62,$74,$62,$6C,$31,  0,  0,  1,$A5,$88,  0,  0,  0,  2,$73,$75,$62,$74,$62,$6C,$32,  0,  0,  1,$A5,$84,  0,  0,  0,  2,$73,$75,$62,$74,$62,$6C,$33,  0,  0,  1,$A5,$80,  0,  0,  0,  2,$73,$75,$62,$74,$62,$6C,$34,  0,  0,  1,$A5,$7C,  0,  0,  0,  3; 23872
		dc.b $73,$63,$6F,$72,$65,$69,$6E,$69,$74,  0,  0,  0,  0,  1,$A3,$FC,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$75,$64,$62,$61,  0,  0,  0,  1,$A0,$D8,  0,  0,  0,  2,$62,$6F,$6E,$75,$73,$77,$72,$74,  0,  1,$A5,$EC,  0,  0,  0,  3,$70,$6C,$61,$79,$73,$75,$75,$63; 23936
		dc.b $67,  0,  0,  0,  0,  1,$A9,$B6,  0,  0,  0,  3,$73,$63,$6F,$72,$65,$5F,$6D,$6F,$76,$65,  0,  0,  0,  1,$A0,$B4,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$61,$65,$62,$61,  0,  0,  0,  1,$AB,$DA,  0,  0,  0,  3,$7F,$6C,$65,$6E,$64,$24,$61,$65,$62,$61,  0,  0; 24000
		dc.b   0,  1,$AC,$48,  0,  0,  0,  1,$65,$64,$69,$74,  0,  1,$AB,  0,  0,  0,  0,  2,$65,$64,$69,$74,$32,$74,$62,$6C,  0,  1,$AD,$C0,  0,  0,  0,  2,$65,$64,$69,$74,$33,$74,$62,$6C,  0,  1,$AD,$C0,  0,  0,  0,  2,$65,$64,$69,$74,$34,$74,$62,$6C,  0,  1,$AD,$FA; 24064
		dc.b   0,  0,  0,  2,$65,$64,$69,$74,$35,$74,$62,$6C,  0,  1,$AE,$D4,  0,  0,  0,  2,$65,$64,$69,$74,$36,$74,$62,$6C,  0,  1,$AE,$D4,  0,  0,  0,  2,$65,$64,$69,$74,$31,$74,$62,$6C,  0,  1,$AD,$4E,  0,  0,  0,  2,$65,$64,$69,$74,$37,$74,$62,$6C,  0,  1,$AE,$D4; 24128
		dc.b   0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$37,$37,$24,$61,$65,$62,$61,  0,  1,$AC,$64,  0,  0,  0,  2,$65,$64,$69,$74,$74,$62,$6C,  0,  0,  1,$AD,$40,  0,  0,  0,  4,$65,$64,$69,$74,$5F,$6D,$6F,$76,$65,$5F,$74,$62,$6C,  0,  0,  0,  0,  1,$AB, $E,  0,  0,  0,  4; 24192
		dc.b $7F,$77,$6F,$72,$6B,$6E,$61,$69,$24,$61,$65,$62,$61,  0,  0,  0,  0,  1,$AC,$C4,  0,  0,  0,  2,$65,$64,$69,$74,$69,$6E,$69,$74,  0,  1,$AB,$12,  0,  0,  0,  3,$7F,$65,$6E,$64,$24,$61,$65,$62,$61,  0,  0,  0,  0,  1,$AC,$EC,  0,  0,  0,  3,$7F,$6A,$75,$6D; 24256
		dc.b $70,$30,$24,$79,$64,$62,$61,  0,  0,  1,$AB,$58,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$31,$24,$79,$64,$62,$61,  0,  0,  1,$AB,$5E,  0,  0,  0,  2,$65,$64,$69,$74,$6D,$6F,$76,$65,  0,  1,$AB,$88,  0,  0,  0,  3,$65,$64,$69,$74,$70,$61,$74,$63,$68,$67,  0,  0; 24320
		dc.b   0,  1,$AD,$20,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$30,$24,$61,$65,$62,$61,  0,  0,  1,$AB,$F2,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$31,$24,$61,$65,$62,$61,  0,  0,  1,$AB,$F6,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$32,$24,$61,$65,$62,$61,  0,  0,  1,$AC,$16; 24384
		dc.b   0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$33,$24,$61,$65,$62,$61,  0,  0,  1,$AC,$2C,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$34,$24,$61,$65,$62,$61,  0,  0,  1,$AC,$38,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$35,$24,$61,$65,$62,$61,  0,  0,  1,$AC,$40,  0,  0,  0,  3; 24448
		dc.b $7F,$6A,$75,$6D,$70,$36,$24,$61,$65,$62,$61,  0,  0,  1,$AC,$7C,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$37,$24,$61,$65,$62,$61,  0,  0,  1,$AC,$80,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$38,$24,$61,$65,$62,$61,  0,  0,  1,$AC,$C4,  0,  0,  0,  3,$7F,$6A,$75,$6D; 24512
		dc.b $70,$39,$24,$61,$65,$62,$61,  0,  0,  1,$AD,$1E,  0,  0,  0,  2,$65,$64,$69,$74,$77,$61,$6C,$6B,  0,  1,$AB,$B0,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$79,$64,$62,$61,  0,  0,  0,  1,$AB,$78,  0,  0,  0,  3,$7F,$6A,$75,$6D,$70,$24,$7A,$64,$62,$61,  0,  0; 24576
		dc.b   0,  1,$AB,$98,  0,  0,  0,  3,$6D,$61,$70,$69,$6E,$69,$74,$74,$62,$6C,  0,  0,  0,  1,$AF,$58,  0,  0,  0,  3,$64,$69,$76,$64,$65,$76,$74,$62,$6C,  0,  0,  0,  0,  1,$AF,$C8,  0,  0,  0,  2,$64,$64,$65,$76,$30,$30,  0,  0,  0,  1,$B0,  8,  0,  0,  0,  2; 24640
		dc.b $64,$64,$65,$76,$30,$31,  0,  0,  0,  1,$B0,$28,  0,  0,  0,  2,$64,$64,$65,$76,$30,$32,  0,  0,  0,  1,$B0,$3C,  0,  0,  0,  2,$64,$64,$65,$76,$30,$33,  0,  0,  0,  1,$B0,$44,  0,  0,  0,  2,$64,$64,$65,$76,$30,$34,  0,  0,  0,  1,$B0,$4C,  0,  0,  0,  2; 24704
		dc.b $64,$64,$65,$76,$30,$35,  0,  0,  0,  1,$B0,$84,  0,  0,  0,  2,$64,$64,$65,$76,$30,$36,  0,  0,  0,  1,$B0,$8C,  0,  0,  0,  2,$64,$64,$65,$76,$30,$37,  0,  0,  0,  1,$B1,$5C,  0,  0,  0,  2,$64,$64,$65,$76,$30,$38,  0,  0,  0,  1,$B0,$8C,  0,  0,  0,  2; 24768
		dc.b $64,$64,$65,$76,$30,$39,  0,  0,  0,  1,$B1,$5C,  0,  0,  0,  2,$64,$64,$65,$76,$31,$30,  0,  0,  0,  1,$B0,$AC,  0,  0,  0,  2,$64,$64,$65,$76,$31,$31,  0,  0,  0,  1,$B0,$E4,  0,  0,  0,  2,$64,$64,$65,$76,$31,$32,  0,  0,  0,  1,$B0,$F8,  0,  0,  0,  2; 24832
		dc.b $64,$64,$65,$76,$31,$33,  0,  0,  0,  1,$B1,$2A,  0,  0,  0,  2,$64,$64,$65,$76,$31,$34,  0,  0,  0,  1,$B0,$8C,  0,  0,  0,  2,$64,$64,$65,$76,$31,$35,  0,  0,  0,  1,$B1,$5C,  0,  0,  0,  2,$64,$64,$65,$76,$31,$36,  0,  0,  0,  1,$B1,$70,  0,  0,  0,  2; 24896
		dc.b $64,$64,$65,$76,$31,$37,  0,  0,  0,  1,$B1,$78,  0,  0,  0,  2,$64,$64,$65,$76,$31,$38,  0,  0,  0,  1,$B1,$B0,  0,  0,  0,  2,$64,$64,$65,$76,$31,$39,  0,  0,  0,  1,$B1,$C4,  0,  0,  0,  2,$64,$64,$65,$76,$32,$30,  0,  0,  0,  1,$B1,$C4,  0,  0,  0,  2; 24960
		dc.b $64,$64,$65,$76,$32,$31,  0,  0,  0,  1,$B1,$C6,  0,  0,  0,  2,$64,$64,$65,$76,$32,$32,  0,  0,  0,  1,$B1,$D4,  0,  0,  0,  2,$64,$64,$65,$76,$32,$33,  0,  0,  0,  1,$B1,$E2,  0,  0,  0,  2,$64,$64,$65,$76,$32,$34,  0,  0,  0,  1,$B1,$F0,  0,  0,  0,  2; 25024
		dc.b $64,$64,$65,$76,$32,$35,  0,  0,  0,  1,$B1,$FE,  0,  0,  0,  2,$64,$64,$65,$76,$32,$36,  0,  0,  0,  1,$B2, $C,  0,  0,  0,  2,$64,$64,$65,$76,$32,$37,  0,  0,  0,  1,$B2,$1A,  0,  0,  0,  2,$64,$64,$65,$76,$32,$38,  0,  0,  0,  1,$B2,$1C,  0,  0,  0,  2; 25088
		dc.b $64,$64,$65,$76,$32,$39,  0,  0,  0,  1,$B2,$1E,  0,  0,  0,  2,$64,$64,$65,$76,$33,$30,  0,  0,  0,  1,$B2,$20,  0,  0,  0,  2,$64,$64,$65,$76,$33,$31,  0,  0,  0,  1,$B2,$22,  0,  0,  0,  0,  0,  0,  3,$F2,$7F,$6A,$75,$6D,  0,$5B,$F2,  0,  0,  9,$D4,$60; 25152
		dc.b   0,  0,  0,  0,  0,$44,$9B,$A4,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C6,$4E,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$32,$37,  0,  0,  0, $C,  0,$44,$5D,$54,  0,$44,$5B,$DC,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  5,$18,  0,  0,  0,  0,  2,  0,  0,  2; 25216
		dc.b $66,$6F,$78,$73,$70,$31,$32,$36,  0,  0,  0, $B,  0,$44,$5D,$7C,  0,$44,$5C,  4,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  5, $E,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$32,$35,  0,  0,  0, $A,  0,$44,$5D,$A4,  0,$44,$5C,$2C,  0,$40,$D1,$30; 25280
		dc.b   0,  0,  0,  0,  0, $A,  5,  4,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$32,$34,  0,  0,  0,  9,  0,$44,$5D,$CC,  0,$44,$5C,$54,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  4,$FA,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$32,$33; 25344
		dc.b   0,  0,  0,  8,  0,$44,$5D,$F4,  0,$44,$5C,$7C,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  4,$F0,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$32,$32,  0,  0,  0,  7,  0,$44,$5E,$1C,  0,$44,$5C,$A4,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  4,$E6; 25408
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$32,$31,  0,  0,  0,  6,  0,$44,$5E,$44,  0,$44,$5C,$CC,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  4,$DC,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$32,$30,  0,  0,  0,  5,  0,$44,$5E,$6C; 25472
		dc.b   0,$44,$5C,$F4,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  4,$D2,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$31,$39,  0,  0,  0, $E,  0,$44,$5E,$94,  0,$44,$5D,$1C,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  4,$C0,  0,  0,  0,  0,  2,  0,  0,  2; 25536
		dc.b $66,$6F,$78,$73,$70,$31,$31,$38,  0,  0,  0, $D,  0,$44,$5E,$BC,  0,$44,$5D,$44,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  4,$B6,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$31,$37,  0,  0,  0, $C,  0,$44,$5E,$E4,  0,$44,$5D,$6C,  0,$40,$D1,$30; 25600
		dc.b   0,  0,  0,  0,  0, $A,  4,$AC,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$31,$36,  0,  0,  0, $B,  0,$44,$5F, $C,  0,$44,$5D,$94,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  4,$9A,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$31,$35; 25664
		dc.b   0,  0,  0, $A,  0,$44,$5F,$34,  0,$44,$5D,$BC,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  4,$88,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$31,$34,  0,  0,  0,  9,  0,$44,$5F,$5C,  0,$44,$5D,$E4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FC,$F0; 25728
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$31,$33,  0,  0,  0,  8,  0,$44,$5F,$84,  0,$44,$5E, $C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FC,$E6,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$31,$32,  0,  0,  0,  7,  0,$44,$5F,$AC; 25792
		dc.b   0,$44,$5E,$34,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FC,$DC,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$31,$31,  0,  0,  0,  6,  0,$44,$5F,$D4,  0,$44,$5E,$5C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FC,$D2,  0,  0,  0,  0,  2,  0,  0,  2; 25856
		dc.b $66,$6F,$78,$73,$70,$30,$31,$30,  0,  0,  0,  5,  0,$44,$63,$20,  0,$44,$5E,$84,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FC,$C8,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$30,$39,  0,  0,  0, $E,  0,$44,$63,$F4,  0,$44,$5E,$AC,  0,$40,$D1,$30; 25920
		dc.b   0,  0,  0,  0,  0,  9,$FC,$B6,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$30,$38,  0,  0,  0, $D,  0,$44,$64,$1C,  0,$44,$5E,$D4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FC,$A4,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$30,$37; 25984
		dc.b   0,  0,  0, $C,  0,$44,$64,$44,  0,$44,$5E,$FC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FC,$9A,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$30,$36,  0,  0,  0, $B,  0,$44,$62,$A0,  0,$44,$5F,$24,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FC,$90; 26048
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$30,$35,  0,  0,  0, $A,  0,$44,$63,$4C,  0,$44,$5F,$4C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FC,$7E,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$30,$34,  0,  0,  0,  9,  0,$44,$64,$BC; 26112
		dc.b   0,$44,$5F,$74,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FC,$6C,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$30,$33,  0,  0,  0,  8,  0,$44,$60,$50,  0,$44,$5F,$9C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FC,$5A,  0,  0,  0,  0,  2,  0,  0,  2; 26176
		dc.b $66,$6F,$78,$73,$70,$30,$30,$32,  0,  0,  0,  7,  0,$44,$65, $C,  0,$44,$5F,$C4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FC,$48,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$30,$31,  0,  0,  0,  6,  0,$44,$60,$78,  0,$44,$5F,$EC,  0,$40,$D1,$30; 26240
		dc.b   0,  0,  0,  0,  0,  9,$FC,$46,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$30,$30,  0,  0,  0,  5,  0,$44,$66,$C4,  0,$44,$60,$14,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  2,  2,  0,  0,  0,  0,  0,  2,  0,  0,  2,$73,$63,$64,$74,$62,$6C,  0,  0; 26304
		dc.b   0,  0,  0,$16,  0,$44,$60,$C8,  0,$44,$60,$3C,  0,$40,$D1,$30,  0,$40,$D8,$94,  0, $A,$4D,$7A,  0,  0,  0,  0,  2,  0,  0,  3,$66,$61,$6C,$6C,$73,$30,$38,$63,$67,  0,  0,  0,  0,  0,  0,$12,  0,$44,$62,$78,  0,$44,$60,$68,  0,$40,$D1,$30,  0,  0,  0,  0; 26368
		dc.b   0, $A,$41,$2C,  0,  0,  0,  0,  2,  0,  0,  2,$6B,$61,$67,$65,$62,$63,$67,  0,  0,  0,  0,  7,  0,$44,$60,$A0,  0,$44,$60,$90,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,$E2,$B0,  0,  0,  0,  0,  2,  0,  0,  2,$75,$73,$61,$63,$67,  0,  0,  0,  0,  0,  0,  5; 26432
		dc.b   0,$44,$65,$34,  0,$44,$60,$B8,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,$E7,$90,  0,  0,  0,  0,  2,  0,  0,  2,$75,$6E,$69,$63,$67,  0,  0,  0,  0,  0,  0,  5,  0,$44,$61,$48,  0,$44,$60,$E0,  0,$40,$D1,$30,  0,$3C,$C2,$70,  0, $A,$2C,$A6,  0,  0,  0,  0; 26496
		dc.b   2,  0,  0,  3,$74,$69,$74,$6C,$65,$73,$70,$63,$67,  0,  0,  0,  0,  0,  0,$12,  0,$44,$6E,$34,  0,$44,$61, $C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  7,$2E,$7C,  0,  0,  0,  0,  2,  0,  0,  2,$70,$63,$6D,$5F,$74,$6F,$70,  0,  0,  0,  0,  1,  0,$44,$71,$F8; 26560
		dc.b   0,$44,$61,$34,  0,$40,$D1,$30,  0,$3F,$64,$CC,  0,$FE,$20,  0,  0,  0,  0,  0,  2,  0,  0,  3,$73,$63,$64,$74,$62,$6C,$77,$6B,$32,  0,  0,  0,  0,  0,  0,  2,  0,$44,$61,$74,  0,$44,$61,$60,  0,$40,$D1,$30,  0,$40,$7C,$98,  0,  2,$6A,$A6,  0,  0,  0,  0; 26624
		dc.b   2,  0,  0,  3,$72,$6F,$74,$6D,$61,$70,$74,$62,$6C,$35,  0,  0,  0,  0,  0,$12,  0,$44,$61,$A0,  0,$44,$61,$8C,  0,$40,$D1,$30,  0,$40,$7C,$CC,  0,  2,$65,$F6,  0,  0,  0,  0,  2,  0,  0,  3,$72,$6F,$74,$6D,$61,$70,$74,$62,$6C,$34,  0,  0,  0,  0,  0,$12; 26688
		dc.b   0,$44,$61,$CC,  0,$44,$61,$B8,  0,$40,$D1,$30,  0,$40,$7D,  0,  0,  2,$61,$1C,  0,  0,  0,  0,  2,  0,  0,  3,$72,$6F,$74,$6D,$61,$70,$74,$62,$6C,$33,  0,  0,  0,  0,  0,$12,  0,$44,$61,$F8,  0,$44,$61,$E4,  0,$40,$D1,$30,  0,$40,$7D,$34,  0,  2,$5D,$C0; 26752
		dc.b   0,  0,  0,  0,  2,  0,  0,  3,$72,$6F,$74,$6D,$61,$70,$74,$62,$6C,$32,  0,  0,  0,  0,  0,$12,  0,$44,$62,$24,  0,$44,$62,$10,  0,$40,$D1,$30,  0,$40,$7D,$68,  0,  2,$59,$AE,  0,  0,  0,  0,  2,  0,  0,  3,$72,$6F,$74,$6D,$61,$70,$74,$62,$6C,$31,  0,  0; 26816
		dc.b   0,  0,  0,$12,  0,$44,$62,$50,  0,$44,$62,$3C,  0,$40,$D1,$30,  0,$40,$7D,$9C,  0,  2,$57,$34,  0,  0,  0,  0,  2,  0,  0,  3,$72,$6F,$74,$6D,$61,$70,$74,$62,$6C,$30,  0,  0,  0,  0,  0,$12,  0,$44,$65,$5C,  0,$44,$62,$68,  0,$40,$D1,$30,  0,$40,$D8,$CC; 26880
		dc.b   0, $A,$5B,$F0,  0,  0,  0,  0,  2,  0,  0,  2,$6E,$61,$6D,$69,$30,$64,$63,$67,  0,  0,  0,$12,  0,$44,$63,$A4,  0,$44,$62,$90,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,$3A,$3A,  0,  0,  0,  0,  2,  0,  0,  2,$6D,$6F,$76,$65,$63,$67,  0,  0,  0,  0,  0,  7; 26944
		dc.b   0,$44,$62,$CC,  0,$44,$62,$B8,  0,$40,$D1,$30,  0,$40,$90,$8C,  0,  2,$7C,$58,  0,  0,  0,  0,  2,  0,  0,  3,$65,$66,$65,$63,$74,$30,$64,$64,$63,$67,  0,  0,  0,  0,  0, $A,  0,$44,$64,$6C,  0,$44,$62,$E4,  0,$40,$D1,$30,  0,$40,$90,$C0,  0,  2,$6F,$18; 27008
		dc.b   0,  0,  0,  0,  2,  0,  0,  3,$65,$66,$65,$63,$74,$30,$30,$64,$63,$67,  0,  0,  0,  0,  0, $A,  0,$44,$6F,$50,  0,$44,$63,$10,  0,$40,$D1,$30,  0,$40,$D8,$FC,  0, $A,$3F,$60,  0,  0,  0,  0,  2,  0,  0,  2,$6A,$79,$61,$6D,$61,$63,$67,  0,  0,  0,  0, $F; 27072
		dc.b   0,$44,$63,$CC,  0,$44,$63,$38,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  4,$16,$74,  0,  0,  0,  0,  2,  0,  0,  3,$61,$73,$65,$74,$74,$62,$6C,$37,$30,$7A,  0,  0,  0,  0,  0, $E,  0,$44,$63,$78,  0,$44,$63,$64,  0,$40,$D1,$30,  0,$3F,$65,  0,  0,  2,  1,  0; 27136
		dc.b   0,  0,  0,  0,  2,  0,  0,  3,$73,$63,$64,$64,$69,$72,$74,$62,$6C,$32,  0,  0,  0,  0,  0,  9,  0,$44,$64,$94,  0,$44,$63,$90,  0,$40,$D1,$30,  0,$3F,$65,$34,  0,  2,  0,  0,  0,  0,  0,  0,  2,  0,  0,  3,$73,$63,$64,$64,$69,$72,$74,$62,$6C,$31,  0,  0; 27200
		dc.b   0,  0,  0,  9,  0,$44,$64,$E4,  0,$44,$63,$BC,  0,$40,$D1,$30,  0,$40,$D9,$2C,  0, $A,$FA,$E0,  0,  0,  0,  0,  2,  0,  0,  2,$67,$6F,$6C,$65,$63,$67,  0,  0,  0,  0,  0,  7,  0,$44,$65,$84,  0,$44,$63,$E4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FE,$80; 27264
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$32,$39,  0,  0,  0, $E,  0,$44,$65,$AC,  0,$44,$64, $C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FE,$66,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$32,$38,  0,  0,  0, $D,  0,$44,$65,$FC; 27328
		dc.b   0,$44,$64,$34,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FE,$4C,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$32,$37,  0,  0,  0, $C,  0,$44,$66,$4C,  0,$44,$64,$5C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FE,$32,  0,  0,  0,  0,  2,  0,  0,  2; 27392
		dc.b $66,$6F,$78,$73,$70,$30,$32,$36,  0,  0,  0, $B,  0,$44,$66,$74,  0,$44,$64,$84,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FE,$18,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$32,$35,  0,  0,  0, $A,  0,$44,$66,$9C,  0,$44,$64,$AC,  0,$40,$D1,$30; 27456
		dc.b   0,  0,  0,  0,  0,  9,$FD,$FE,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$32,$34,  0,  0,  0,  9,  0,$44,$6E,  8,  0,$44,$64,$D4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FD,$E4,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$32,$33; 27520
		dc.b   0,  0,  0,  8,  0,$44,$67,$8C,  0,$44,$64,$FC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FD,$CA,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$32,$32,  0,  0,  0,  7,  0,$41, $B,$68,  0,$44,$65,$24,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FD,$B0; 27584
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$32,$31,  0,  0,  0,  6,  0,$44,$67,$3C,  0,$44,$65,$4C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FD,$96,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$32,$30,  0,  0,  0,  5,  0,$44,$66,$EC; 27648
		dc.b   0,$44,$65,$74,  0,$40,$D1,$30,  0,$40,$D9,$60,  0, $A,$FA,  4,  0,  0,  0,  0,  2,  0,  0,  2,$6A,$75,$6D,$70,$32,$63,$67,  0,  0,  0,  0,$12,  0,$40,$EE,$94,  0,$44,$65,$9C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FD,$7C,  0,  0,  0,  0,  2,  0,  0,  2; 27712
		dc.b $66,$6F,$78,$73,$70,$30,$31,$39,  0,  0,  0, $E,  0,$44,$6D,$B4,  0,$44,$65,$C4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FD,$62,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$31,$38,  0,  0,  0, $D,  0,$44,$66,$24,  0,$44,$65,$EC,  0,$40,$D1,$30; 27776
		dc.b   0,$40,$D9,$90,  0, $A,$AA,$22,  0,  0,  0,  0,  2,  0,  0,  2,$62,$6F,$73,$73,$73,$6D,$63,$67,  0,  0,  0,$1C,  0,$40,$FE,$70,  0,$44,$66,$14,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FD,$48,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$31,$37; 27840
		dc.b   0,  0,  0, $C,  0,$44,$71,$30,  0,$44,$66,$3C,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,$A3,$1C,  0,  0,  0,  0,  2,  0,  0,  2,$62,$6F,$73,$73,$62,$6D,$63,$67,  0,  0,  0,$1C,  0,$44,$71,$D0,  0,$44,$66,$64,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FD,$2E; 27904
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$31,$36,  0,  0,  0, $B,  0,$41,  7, $C,  0,$44,$66,$8C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FD,$14,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$31,$35,  0,  0,  0, $A,  0,$44,$6A,$AC; 27968
		dc.b   0,$44,$66,$B4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FC,$FA,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$31,$34,  0,  0,  0,  9,  0,$44,$67,$14,  0,$44,$66,$DC,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $B,  3,$D2,  0,  0,  0,  0,  2,  0,  0,  2; 28032
		dc.b $63,$6F,$6E,$74,$63,$67,  0,  0,  0,  0,  0,$16,  0,$41,  0,$8C,  0,$44,$67,  4,  0,$40,$D1,$30,  0,$40,$D9,$C0,  0, $A,$4A,$6A,  0,  0,  0,  0,  2,  0,  0,  2,$63,$73,$6F,$30,$30,$63,$67,  0,  0,  0,  0,$12,  0,$41,  1,$58,  0,$44,$67,$2C,  0,$40,$D1,$30; 28096
		dc.b   0,$40,$D9,$F4,  0, $A,$70,$86,  0,  0,  0,  0,  2,  0,  0,  2,$62,$62,$61,$74,$63,$67,  0,  0,  0,  0,  0,$16,  0,$44,$6D,$E0,  0,$44,$67,$54,  0,$40,$D1,$30,  0,$3F,$18,$58,  0,  9,$25,$4C,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$63,$67,  0,  0,  0; 28160
		dc.b   0,  0,  0,  5,  0,$44,$67,$B4,  0,$44,$67,$7C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$E1,$FC,  0,  0,  0,  0,  2,  0,  0,  2,$73,$74,$6F,$70,$66,$78,$63,$67,  0,  0,  0,$19,  0,$44,$7B,$58,  0,$44,$67,$A4,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,$3C,$20; 28224
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$74,$6F,$67,$65,$68,$63,$67,  0,  0,  0,  0,  7,  0,$44,$67,$DC,  0,$44,$67,$CC,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$70,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$31,$33,$32,  0,  0,  0,  0,$19,  0,$44,$68,  4; 28288
		dc.b   0,$44,$67,$F4,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$6C,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$31,$33,$31,  0,  0,  0,  0,$19,  0,$44,$68,$54,  0,$44,$68,$1C,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$68,  0,  0,  0,  0,  2,  0,  0,  2; 28352
		dc.b $66,$6F,$78,$77,$31,$33,$30,  0,  0,  0,  0,$19,  0,$40,$CC,$F8,  0,$44,$68,$44,  0,$40,$D1,$30,  0,$40,$DA,$28,  0, $D,$A9,$CE,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65,$31,$6D,$61,$70,  0,  0,  0,$17,  0,$44,$68,$7C,  0,$44,$68,$6C,  0,$40,$D1,$30; 28416
		dc.b   0,  0,  0,  0,  0, $A,  8,$64,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$31,$32,$39,  0,  0,  0,  0,$19,  0,$44,$68,$A4,  0,$44,$68,$94,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  9,$5A,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$31,$32,$38,  0; 28480
		dc.b   0,  0,  0,$19,  0,$44,$68,$CC,  0,$44,$68,$BC,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  9,$54,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$31,$32,$37,  0,  0,  0,  0,$19,  0,$44,$68,$F4,  0,$44,$68,$E4,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  9,$50; 28544
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$31,$32,$36,  0,  0,  0,  0,$19,  0,$44,$69,$1C,  0,$44,$69, $C,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  9,$4C,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$31,$32,$35,  0,  0,  0,  0,$19,  0,$44,$69,$44; 28608
		dc.b   0,$44,$69,$34,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  9,$48,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$31,$32,$34,  0,  0,  0,  0,$19,  0,$44,$69,$6C,  0,$44,$69,$5C,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  9,$44,  0,  0,  0,  0,  2,  0,  0,  2; 28672
		dc.b $66,$6F,$78,$77,$31,$32,$33,  0,  0,  0,  0,$19,  0,$44,$69,$94,  0,$44,$69,$84,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  9,$40,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$31,$32,$32,  0,  0,  0,  0,$19,  0,$44,$69,$BC,  0,$44,$69,$AC,  0,$40,$D1,$30; 28736
		dc.b   0,  0,  0,  0,  0, $A,  9,$3C,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$31,$32,$31,  0,  0,  0,  0,$19,  0,$44,$69,$E4,  0,$44,$69,$D4,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  9,$38,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$31,$32,$30,  0; 28800
		dc.b   0,  0,  0,$19,  0,$44,$6A, $C,  0,$44,$69,$FC,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  9,$34,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$31,$31,$39,  0,  0,  0,  0,$19,  0,$44,$6A,$34,  0,$44,$6A,$24,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  9,$2E; 28864
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$31,$31,$38,  0,  0,  0,  0,$19,  0,$44,$6A,$5C,  0,$44,$6A,$4C,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  9,$2A,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$31,$31,$37,  0,  0,  0,  0,$19,  0,$44,$6A,$84; 28928
		dc.b   0,$44,$6A,$74,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  9,$26,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$31,$31,$36,  0,  0,  0,  0,$19,  0,$44,$6A,$D8,  0,$44,$6A,$9C,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  9,$20,  0,  0,  0,  0,  2,  0,  0,  2; 28992
		dc.b $66,$6F,$78,$77,$31,$31,$35,  0,  0,  0,  0,$19,  0,$44,$6C,$1C,  0,$44,$6A,$C4,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,$90,$F4,  0,  0,  0,  0,  2,  0,  0,  3,$73,$61,$6E,$64,$63,$72,$61,$62,$63,$67,  0,  0,  0,  0,  0,  9,  0,$44,$6B,  0,  0,$44,$6A,$F0; 29056
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  9,$1A,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$31,$31,$34,  0,  0,  0,  0,$19,  0,$44,$6B,$28,  0,$44,$6B,$18,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  9,$1A,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77; 29120
		dc.b $31,$31,$33,  0,  0,  0,  0,$19,  0,$44,$6B,$50,  0,$44,$6B,$40,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  9, $E,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$31,$31,$32,  0,  0,  0,  0,$19,  0,$44,$6B,$78,  0,$44,$6B,$68,  0,$40,$D1,$30,  0,  0,  0,  0; 29184
		dc.b   0, $A,  9,$14,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$31,$31,$31,  0,  0,  0,  0,$19,  0,$44,$6B,$CC,  0,$44,$6B,$90,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  9, $E,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$31,$31,$30,  0,  0,  0,  0,$19; 29248
		dc.b   0,$41,  2,$A0,  0,$44,$6B,$B8,  0,$40,$D1,$30,  0,$40,$DA,$58,  0, $A,$FF,$5C,  0,  0,  0,  0,  2,  0,  0,  3,$65,$62,$69,$67,$72,$69,$6E,$67,$63,$67,  0,  0,  0,  0,  0,$11,  0,$44,$6B,$F4,  0,$44,$6B,$E4,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  9,  8; 29312
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$31,$30,$39,  0,  0,  0,  0,$19,  0,$44,$6C,$48,  0,$44,$6C, $C,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  9,  2,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$31,$30,$38,  0,  0,  0,  0,$19,  0,$44,$6C,$98; 29376
		dc.b   0,$44,$6C,$34,  0,$40,$D1,$30,  0,$40,$90,$F4,  0,  2,$7B,$98,  0,  0,  0,  0,  2,  0,  0,  3,$65,$66,$65,$63,$74,$30,$64,$63,$63,$67,  0,  0,  0,  0,  0,  9,  0,$44,$6C,$70,  0,$44,$6C,$60,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$FE,  0,  0,  0,  0; 29440
		dc.b   2,  0,  0,  2,$66,$6F,$78,$77,$31,$30,$37,  0,  0,  0,  0,$19,  0,$44,$6C,$C4,  0,$44,$6C,$88,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$F8,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$31,$30,$36,  0,  0,  0,  0,$19,  0,$44,$79,  0,  0,$44,$6C,$B0; 29504
		dc.b   0,$40,$D1,$30,  0,$40,$91,$28,  0,  2,$6E,$98,  0,  0,  0,  0,  2,  0,  0,  3,$65,$66,$65,$63,$74,$30,$30,$63,$63,$67,  0,  0,  0,  0,  0,  9,  0,$44,$6C,$EC,  0,$44,$6C,$DC,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$F2,  0,  0,  0,  0,  2,  0,  0,  2; 29568
		dc.b $66,$6F,$78,$77,$31,$30,$35,  0,  0,  0,  0,$19,  0,$44,$6D,$14,  0,$44,$6D,  4,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$EC,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$31,$30,$34,  0,  0,  0,  0,$19,  0,$44,$6D,$3C,  0,$44,$6D,$2C,  0,$40,$D1,$30; 29632
		dc.b   0,  0,  0,  0,  0, $A,  8,$E6,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$31,$30,$33,  0,  0,  0,  0,$19,  0,$44,$6D,$64,  0,$44,$6D,$54,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$E0,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$31,$30,$32,  0; 29696
		dc.b   0,  0,  0,$19,  0,$44,$6D,$8C,  0,$44,$6D,$7C,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$DA,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$31,$30,$31,  0,  0,  0,  0,$19,  0,$44,$6E,$60,  0,$44,$6D,$A4,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$D4; 29760
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$31,$30,$30,  0,  0,  0,  0,$19,  0,$40,$CD,$A0,  0,$44,$6D,$CC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  4,$16,$74,  0,  0,  0,  0,  2,  0,  0,  3,$61,$73,$65,$74,$74,$62,$6C,$36,$30,$7A,  0,  0,  0,  0,  0, $D; 29824
		dc.b   0,$44,$75,$40,  0,$44,$6D,$F8,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,$5D,$60,  0,  0,  0,  0,  2,  0,  0,  2,$73,$77,$69,$63,$68,$63,$67,  0,  0,  0,  0,  5,  0,$44,$7A,$18,  0,$44,$6E,$20,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,$8C,$D6,  0,  0,  0,  0; 29888
		dc.b   2,  0,  0,  3,$62,$75,$62,$62,$6C,$65,$72,$63,$67,  0,  0,  0,  0,  0,  0,  8,  0,$44,$73,$D8,  0,$44,$6E,$4C,  0,$40,$D1,$30,  0,$40,$DA,$8C,  0, $A,$53,$4E,  0,  0,  0,  0,  2,  0,  0,  3,$70,$6C,$74,$66,$72,$6D,$30,$38,$63,$67,  0,  0,  0,  0,  0,  1; 29952
		dc.b   0,$44,$6E,$88,  0,$44,$6E,$78,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$CE,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$39,$39,  0,  0,  0,  0,$19,  0,$44,$6E,$B0,  0,$44,$6E,$A0,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$CA,  0,  0,  0,  0; 30016
		dc.b   2,  0,  0,  2,$66,$6F,$78,$77,$30,$39,$38,  0,  0,  0,  0,$19,  0,$44,$6E,$D8,  0,$44,$6E,$C8,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$C6,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$39,$37,  0,  0,  0,  0,$19,  0,$44,$6F,  0,  0,$44,$6E,$F0; 30080
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$C2,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$39,$36,  0,  0,  0,  0,$19,  0,$44,$6F,$28,  0,$44,$6F,$18,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$BC,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77; 30144
		dc.b $30,$39,$35,  0,  0,  0,  0,$19,  0,$44,$6F,$78,  0,$44,$6F,$40,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$BC,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$39,$34,  0,  0,  0,  0,$19,  0,$40,$4E,$84,  0,$44,$6F,$68,  0,$40,$D1,$30,  0,  0,  0,  0; 30208
		dc.b   0, $A,$CE,  0,  0,  0,  0,  0,  2,  0,  0,  2,$61,$72,$75,$6D,$61,$63,$67,  0,  0,  0,  0, $F,  0,$44,$6F,$A0,  0,$44,$6F,$90,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$B8,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$39,$33,  0,  0,  0,  0,$19; 30272
		dc.b   0,$44,$6F,$C8,  0,$44,$6F,$B8,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$B4,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$39,$32,  0,  0,  0,  0,$19,  0,$44,$6F,$F0,  0,$44,$6F,$E0,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$B0,  0,  0,  0,  0; 30336
		dc.b   2,  0,  0,  2,$66,$6F,$78,$77,$30,$39,$31,  0,  0,  0,  0,$19,  0,$44,$70,$18,  0,$44,$70,  8,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$AA,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$39,$30,  0,  0,  0,  0,$19,  0,$44,$70,$40,  0,$44,$70,$30; 30400
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$A4,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$38,$39,  0,  0,  0,  0,$19,  0,$44,$70,$68,  0,$44,$70,$58,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$A0,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77; 30464
		dc.b $30,$38,$38,  0,  0,  0,  0,$19,  0,$44,$70,$90,  0,$44,$70,$80,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$9C,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$38,$37,  0,  0,  0,  0,$19,  0,$44,$70,$B8,  0,$44,$70,$A8,  0,$40,$D1,$30,  0,  0,  0,  0; 30528
		dc.b   0, $A,  8,$98,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$38,$36,  0,  0,  0,  0,$19,  0,$44,$70,$E0,  0,$44,$70,$D0,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$94,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$38,$35,  0,  0,  0,  0,$19; 30592
		dc.b   0,$44,$71,  8,  0,$44,$70,$F8,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$90,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$38,$34,  0,  0,  0,  0,$19,  0,$44,$71,$58,  0,$44,$71,$20,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$8C,  0,  0,  0,  0; 30656
		dc.b   2,  0,  0,  2,$66,$6F,$78,$77,$30,$38,$33,  0,  0,  0,  0,$19,  0,$41, $A,$78,  0,$44,$71,$48,  0,$40,$D1,$30,  0,$40,$DA,$C4,  0, $A,$7A,$F8,  0,  0,  0,  0,  2,  0,  0,  2,$72,$65,$64,$7A,$63,$67,  0,  0,  0,  0,  0,$1C,  0,$44,$71,$80,  0,$44,$71,$70; 30720
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$88,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$38,$32,  0,  0,  0,  0,$19,  0,$44,$71,$A8,  0,$44,$71,$98,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$84,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77; 30784
		dc.b $30,$38,$31,  0,  0,  0,  0,$19,  0,$44,$72,$20,  0,$44,$71,$C0,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$80,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$38,$30,  0,  0,  0,  0,$19,  0,$40,$FC,  8,  0,$44,$71,$E8,  0,$40,$D1,$30,  0,$40,$DA,$F4; 30848
		dc.b   0,  9,$DF,$8E,  0,  0,  0,  0,  2,  0,  0,  2,$62,$61,$72,$69,$61,$63,$67,  0,  0,  0,  0, $B,  0,$40,$16,$80,  0,$44,$72,$10,  0,$40,$D1,$30,  0,$40,$DB,$24,  0, $A,$62,$FA,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$61,$79,$6E,$6F,$63,$67,  0,  0,  0,  2; 30912
		dc.b   0,$44,$72,$48,  0,$44,$72,$38,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$7C,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$37,$39,  0,  0,  0,  0,$19,  0,$44,$72,$70,  0,$44,$72,$60,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$78,  0,  0,  0,  0; 30976
		dc.b   2,  0,  0,  2,$66,$6F,$78,$77,$30,$37,$38,  0,  0,  0,  0,$19,  0,$44,$72,$98,  0,$44,$72,$88,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$74,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$37,$37,  0,  0,  0,  0,$19,  0,$44,$72,$C0,  0,$44,$72,$B0; 31040
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$70,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$37,$36,  0,  0,  0,  0,$19,  0,$44,$72,$E8,  0,$44,$72,$D8,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$6C,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77; 31104
		dc.b $30,$37,$35,  0,  0,  0,  0,$19,  0,$44,$73,$10,  0,$44,$73,  0,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$68,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$37,$34,  0,  0,  0,  0,$19,  0,$44,$73,$38,  0,$44,$73,$28,  0,$40,$D1,$30,  0,  0,  0,  0; 31168
		dc.b   0, $A,  8,$64,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$37,$33,  0,  0,  0,  0,$19,  0,$44,$73,$60,  0,$44,$73,$50,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$60,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$37,$32,  0,  0,  0,  0,$19; 31232
		dc.b   0,$44,$73,$88,  0,$44,$73,$78,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$5C,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$37,$31,  0,  0,  0,  0,$19,  0,$44,$73,$B0,  0,$44,$73,$A0,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$58,  0,  0,  0,  0; 31296
		dc.b   2,  0,  0,  2,$66,$6F,$78,$77,$30,$37,$30,  0,  0,  0,  0,$19,  0,$44,$74,$C8,  0,$44,$73,$C8,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$50,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$36,$39,  0,  0,  0,  0,$19,  0,$44,$74,  0,  0,$44,$73,$F0; 31360
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0,  2,$B6,$B0,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65,$37,$5F,$34,$7A,  0,  0,  0,  1,  0,$44,$74,$28,  0,$44,$74,$18,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  2,$B6,$B0,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65; 31424
		dc.b $36,$5F,$34,$7A,  0,  0,  0,  1,  0,$44,$74,$50,  0,$44,$74,$40,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  2,$B6,$B0,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65,$35,$5F,$34,$7A,  0,  0,  0,  1,  0,$44,$74,$78,  0,$44,$74,$68,  0,$40,$D1,$30,  0,  0,  0,  0; 31488
		dc.b   0,  2,$B6,$B0,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65,$34,$5F,$34,$7A,  0,  0,  0,  1,  0,$44,$74,$A0,  0,$44,$74,$90,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  2,$B6,$B0,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65,$33,$5F,$34,$7A,  0,  0,  0,  1; 31552
		dc.b   0,$44,$74,$F0,  0,$44,$74,$B8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  2,$B6,$B0,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65,$32,$5F,$34,$7A,  0,  0,  0,  1,  0,$44,$75,$18,  0,$44,$74,$E0,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$48,  0,  0,  0,  0; 31616
		dc.b   2,  0,  0,  2,$66,$6F,$78,$77,$30,$36,$38,  0,  0,  0,  0,$19,  0,$44,$76,$A8,  0,$44,$75,  8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  2,$B6,$B0,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65,$31,$5F,$34,$7A,  0,  0,  0,  1,  0,$44,$75,$68,  0,$44,$75,$30; 31680
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$40,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$36,$37,  0,  0,  0,  0,$19,  0,$40,$FF,$48,  0,$44,$75,$58,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,$E9,$6E,  0,  0,  0,  0,  2,  0,  0,  2,$69,$6D,$6F,$63; 31744
		dc.b $67,  0,  0,  0,  0,  0,  0,  5,  0,$44,$75,$90,  0,$44,$75,$80,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$38,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$36,$36,  0,  0,  0,  0,$19,  0,$44,$75,$B8,  0,$44,$75,$A8,  0,$40,$D1,$30,  0,  0,  0,  0; 31808
		dc.b   0, $A,  8,$30,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$36,$35,  0,  0,  0,  0,$19,  0,$44,$75,$E0,  0,$44,$75,$D0,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$28,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$36,$34,  0,  0,  0,  0,$19; 31872
		dc.b   0,$44,$76,  8,  0,$44,$75,$F8,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$20,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$36,$33,  0,  0,  0,  0,$19,  0,$44,$76,$30,  0,$44,$76,$20,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$18,  0,  0,  0,  0; 31936
		dc.b   2,  0,  0,  2,$66,$6F,$78,$77,$30,$36,$32,  0,  0,  0,  0,$19,  0,$44,$76,$58,  0,$44,$76,$48,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,  8,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$36,$31,  0,  0,  0,  0,$19,  0,$44,$76,$80,  0,$44,$76,$70; 32000
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,$10,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$36,$30,  0,  0,  0,  0,$19,  0,$44,$77,$98,  0,$44,$76,$98,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,  8,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77; 32064
		dc.b $30,$35,$39,  0,  0,  0,  0,$19,  0,$44,$76,$D0,  0,$44,$76,$C0,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  2,$B6,$B0,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65,$37,$5F,$33,$7A,  0,  0,  0,  1,  0,$44,$76,$F8,  0,$44,$76,$E8,  0,$40,$D1,$30,  0,  0,  0,  0; 32128
		dc.b   0,  2,$B6,$B0,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65,$36,$5F,$33,$7A,  0,  0,  0,  1,  0,$44,$77,$20,  0,$44,$77,$10,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  2,$B6,$B0,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65,$35,$5F,$33,$7A,  0,  0,  0,  1; 32192
		dc.b   0,$44,$77,$48,  0,$44,$77,$38,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  2,$B6,$B0,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65,$34,$5F,$33,$7A,  0,  0,  0,  1,  0,$44,$77,$70,  0,$44,$77,$60,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  2,$B6,$B0,  0,  0,  0,  0; 32256
		dc.b   2,  0,  0,  2,$7A,$6F,$6E,$65,$33,$5F,$33,$7A,  0,  0,  0,  1,  0,$44,$77,$C0,  0,$44,$77,$88,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  2,$B6,$B0,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65,$32,$5F,$33,$7A,  0,  0,  0,  1,  0,$44,$77,$E8,  0,$44,$77,$B0; 32320
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  8,  0,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$35,$38,  0,  0,  0,  0,$19,  0,$40,$EC,$DC,  0,$44,$77,$D8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  2,$B6,$B0,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65; 32384
		dc.b $31,$5F,$33,$7A,  0,  0,  0,  1,  0,$44,$78,$10,  0,$44,$78,  0,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  7,$F8,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$35,$37,  0,  0,  0,  0,$19,  0,$44,$78,$38,  0,$44,$78,$28,  0,$40,$D1,$30,  0,  0,  0,  0; 32448
		dc.b   0, $A,  7,$F0,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$35,$36,  0,  0,  0,  0,$19,  0,$44,$78,$60,  0,$44,$78,$50,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  7,$E8,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$35,$35,  0,  0,  0,  0,$19; 32512
		dc.b   0,$44,$78,$88,  0,$44,$78,$78,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  7,$E0,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$35,$34,  0,  0,  0,  0,$19,  0,$44,$78,$B0,  0,$44,$78,$A0,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  7,$D8,  0,  0,  0,  0; 32576
		dc.b   2,  0,  0,  2,$66,$6F,$78,$77,$30,$35,$33,  0,  0,  0,  0,$19,  0,$44,$78,$D8,  0,$44,$78,$C8,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  7,$D0,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$35,$32,  0,  0,  0,  0,$19,  0,$44,$79,$F0,  0,$44,$78,$F0; 32640
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  7,$CA,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$35,$31,  0,  0,  0,  0,$19,  0,$44,$79,$28,  0,$44,$79,$18,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  2,$B5,$D4,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65; 32704
		dc.b $37,$5F,$34,$62,  0,  0,  0,  9,  0,$44,$79,$50,  0,$44,$79,$40,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  2,$B5,$D4,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65,$36,$5F,$34,$62,  0,  0,  0,  9,  0,$44,$79,$78,  0,$44,$79,$68,  0,$40,$D1,$30,  0,  0,  0,  0; 32768
		dc.b   0,  2,$B6,$66,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65,$35,$5F,$34,$62,  0,  0,  0,  9,  0,$44,$79,$A0,  0,$44,$79,$90,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  2,$A5,$C6,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65,$34,$5F,$34,$62,  0,  0,  0,  9; 32832
		dc.b   0,$44,$79,$C8,  0,$44,$79,$B8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  2,$B5,$D4,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65,$33,$5F,$34,$62,  0,  0,  0,  9,  0,$44,$7B,  8,  0,$44,$79,$E0,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  2,$B5,$D4,  0,  0,  0,  0; 32896
		dc.b   2,  0,  0,  2,$7A,$6F,$6E,$65,$32,$5F,$34,$62,  0,  0,  0,  9,  0,$44,$7B,$80,  0,$44,$7A,  8,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  7,$C4,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$77,$30,$35,$30,  0,  0,  0,  0,$19,  0,$44,$7A,$40,  0,$44,$7A,$30; 32960
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0,  2,$A5,$D0,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65,$37,$5F,$34,$61,  0,  0,  0,  8,  0,$44,$7A,$68,  0,$44,$7A,$58,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  2,$A5,$D0,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65; 33024
		dc.b $36,$5F,$34,$61,  0,  0,  0,  8,  0,$44,$7A,$90,  0,$44,$7A,$80,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  2,$AD,$D2,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65,$35,$5F,$34,$61,  0,  0,  0,  8,  0,$44,$7A,$B8,  0,$44,$7A,$A8,  0,$40,$D1,$30,  0,  0,  0,  0; 33088
		dc.b   0,  2,$9D,$C4,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65,$34,$5F,$34,$61,  0,  0,  0,  8,  0,$44,$7A,$E0,  0,$44,$7A,$D0,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  2,$A5,$D0,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65,$33,$5F,$34,$61,  0,  0,  0,  8; 33152
		dc.b   0,$44,$7B,$30,  0,$44,$7A,$F8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  2,$A5,$D0,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65,$32,$5F,$34,$61,  0,  0,  0,  8,  0,$40,$EF,$5C,  0,$44,$7B,$20,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  2,$B5,$D4,  0,  0,  0,  0; 33216
		dc.b   2,  0,  0,  2,$7A,$6F,$6E,$65,$31,$5F,$34,$62,  0,  0,  0,  9,  0,$40,$F0,$74,  0,$44,$7B,$48,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  2,$A5,$D0,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65,$31,$5F,$34,$61,  0,  0,  0,  8,  0,$41,  0,$B8,  0,$44,$7B,$70; 33280
		dc.b   0,$40,$D1,$30,  0,$40,$DB,$5C,  0, $D,$5D,$B2,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65,$31,$63,$67,  0,  0,  0,  0,  7,  0,$40,$ED,$CC,  0,$40,$EC,$CC,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  7,$B8,  0,  0,  0,  0,  0,$5B,$F2,  0,  0,  9,$B4,$60; 33344
		dc.b   0,  0,  0,  8,  0,  0,  0,  0,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$35,$39,  0,  0,  0,  0,  0,$12,  0,$44,$7B,$E4,  0,$44,$7B,$D4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$A2,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$35,$39,  0,  0; 33408
		dc.b   0,  0,  0,$12,  0,$44,$7C, $C,  0,$44,$7B,$FC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1C,$AA,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$35,$38,  0,  0,  0,  0,  0,$12,  0,$44,$7C,$34,  0,$44,$7C,$24,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$98; 33472
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$35,$38,  0,  0,  0,  0,  0,$12,  0,$44,$7C,$5C,  0,$44,$7C,$4C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1C,$88,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$35,$37,  0,  0,  0,  0,  0,$12,  0,$44,$7C,$84; 33536
		dc.b   0,$44,$7C,$74,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$8E,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$35,$37,  0,  0,  0,  0,  0,$12,  0,$44,$7C,$AC,  0,$44,$7C,$9C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1C,$66,  0,  0,  0,  0,  2,  0,  0,  2; 33600
		dc.b $70,$6C,$79,$30,$35,$36,  0,  0,  0,  0,  0,$12,  0,$44,$7C,$FC,  0,$44,$7C,$C4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$84,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$35,$36,  0,  0,  0,  0,  0,$12,  0,$44,$86,$AC,  0,$44,$7C,$EC,  0,$40,$D1,$30; 33664
		dc.b   0,  0,  0,  0,  0, $D,$93,$6E,  0,  0,  0,  0,  2,  0,  0,  2,$65,$6E,$6B,$65,$69,$63,$67,  0,  0,  0,  0,  7,  0,$44,$7D,$24,  0,$44,$7D,$14,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1C,$44,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$35,$35,  0,  0; 33728
		dc.b   0,  0,  0,$12,  0,$44,$7D,$4C,  0,$44,$7D,$3C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$7A,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$35,$35,  0,  0,  0,  0,  0,$12,  0,$44,$7D,$74,  0,$44,$7D,$64,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1C,$22; 33792
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$35,$34,  0,  0,  0,  0,  0,$12,  0,$44,$7D,$9C,  0,$44,$7D,$8C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$70,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$35,$34,  0,  0,  0,  0,  0,$12,  0,$44,$7D,$C4; 33856
		dc.b   0,$44,$7D,$B4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1C,  0,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$35,$33,  0,  0,  0,  0,  0,$12,  0,$44,$7D,$EC,  0,$44,$7D,$DC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$66,  0,  0,  0,  0,  2,  0,  0,  2; 33920
		dc.b $70,$6C,$77,$30,$35,$33,  0,  0,  0,  0,  0,$12,  0,$44,$7E,$14,  0,$44,$7E,  4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1B,$DE,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$35,$32,  0,  0,  0,  0,  0,$12,  0,$44,$7E,$3C,  0,$44,$7E,$2C,  0,$40,$D1,$30; 33984
		dc.b   0,  0,  0,  0,  0,  9,$DD,$5C,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$35,$32,  0,  0,  0,  0,  0,$12,  0,$44,$7E,$64,  0,$44,$7E,$54,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1B,$BC,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$35,$31,  0,  0; 34048
		dc.b   0,  0,  0,$12,  0,$44,$7E,$B4,  0,$44,$7E,$7C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$52,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$35,$31,  0,  0,  0,  0,  0,$12,  0,$44,$80,$BC,  0,$44,$7E,$A4,  0,$40,$D1,$30,  0,$40,$D8,  0,  0, $A,$60,$1E; 34112
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$62,$61,$6E,$65,$34,$35,$63,$67,  0,  0,  0, $E,  0,$44,$7E,$DC,  0,$44,$7E,$CC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1B,$92,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$35,$30,  0,  0,  0,  0,  0,$12,  0,$44,$7F,  4; 34176
		dc.b   0,$44,$7E,$F4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$46,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$35,$30,  0,  0,  0,  0,  0,$12,  0,$44,$7F,$2C,  0,$44,$7F,$1C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1B,$70,  0,  0,  0,  0,  2,  0,  0,  2; 34240
		dc.b $70,$6C,$79,$30,$34,$39,  0,  0,  0,  0,  0,$12,  0,$44,$7F,$54,  0,$44,$7F,$44,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$3C,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$34,$39,  0,  0,  0,  0,  0,$12,  0,$44,$7F,$7C,  0,$44,$7F,$6C,  0,$40,$D1,$30; 34304
		dc.b   0,  0,  0,  0,  0,  9,$1B,$4E,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$34,$38,  0,  0,  0,  0,  0,$12,  0,$44,$7F,$A4,  0,$44,$7F,$94,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$32,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$34,$38,  0,  0; 34368
		dc.b   0,  0,  0,$12,  0,$44,$7F,$CC,  0,$44,$7F,$BC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1B,$34,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$34,$37,  0,  0,  0,  0,  0,$12,  0,$44,$7F,$F4,  0,$44,$7F,$E4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$2A; 34432
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$34,$37,  0,  0,  0,  0,  0,$12,  0,$44,$80,$44,  0,$44,$80, $C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1B,$22,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$34,$36,  0,  0,  0,  0,  0,$12,  0,$44,$60,$F4; 34496
		dc.b   0,$44,$80,$34,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  7,$45,$DC,  0,  0,  0,  0,  2,  0,  0,  2,$70,$63,$6D,$5F,$65,$6E,$64,  0,  0,  0,  0,  1,  0,$44,$80,$6C,  0,$44,$80,$5C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$24,  0,  0,  0,  0,  2,  0,  0,  2; 34560
		dc.b $70,$6C,$77,$30,$34,$36,  0,  0,  0,  0,  0,$12,  0,$44,$80,$94,  0,$44,$80,$84,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1B,$10,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$34,$35,  0,  0,  0,  0,  0,$12,  0,$44,$80,$E4,  0,$44,$80,$AC,  0,$40,$D1,$30; 34624
		dc.b   0,  0,  0,  0,  0,  9,$DD,$1E,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$34,$35,  0,  0,  0,  0,  0,$12,  0,$44,$84,  4,  0,$44,$80,$D4,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,$D5,$AE,  0,  0,  0,  0,  2,  0,  0,  2,$6B,$61,$6D,$65,$72,$65,$63,$67; 34688
		dc.b   0,  0,  0, $E,  0,$44,$81, $C,  0,$44,$80,$FC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1A,$FE,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$34,$34,  0,  0,  0,  0,  0,$12,  0,$44,$81,$34,  0,$44,$81,$24,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$18; 34752
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$34,$34,  0,  0,  0,  0,  0,$12,  0,$44,$81,$5C,  0,$44,$81,$4C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1A,$EC,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$34,$33,  0,  0,  0,  0,  0,$12,  0,$44,$81,$84; 34816
		dc.b   0,$44,$81,$74,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$12,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$34,$33,  0,  0,  0,  0,  0,$12,  0,$44,$81,$AC,  0,$44,$81,$9C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1A,$D2,  0,  0,  0,  0,  2,  0,  0,  2; 34880
		dc.b $70,$6C,$79,$30,$34,$32,  0,  0,  0,  0,  0,$12,  0,$44,$81,$D4,  0,$44,$81,$C4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD, $A,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$34,$32,  0,  0,  0,  0,  0,$12,  0,$44,$81,$FC,  0,$44,$81,$EC,  0,$40,$D1,$30; 34944
		dc.b   0,  0,  0,  0,  0,  9,$1A,$B8,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$34,$31,  0,  0,  0,  0,  0,$12,  0,$44,$82,$24,  0,$44,$82,$14,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,  2,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$34,$31,  0,  0; 35008
		dc.b   0,  0,  0,$12,  0,$44,$82,$4C,  0,$44,$82,$3C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1A,$9E,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$34,$30,  0,  0,  0,  0,  0,$12,  0,$44,$82,$74,  0,$44,$82,$64,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DC,$FA; 35072
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$34,$30,  0,  0,  0,  0,  0,$12,  0,$44,$82,$9C,  0,$44,$82,$8C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1A,$8C,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$33,$39,  0,  0,  0,  0,  0,$12,  0,$44,$82,$C4; 35136
		dc.b   0,$44,$82,$B4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DC,$F4,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$33,$39,  0,  0,  0,  0,  0,$12,  0,$44,$82,$EC,  0,$44,$82,$DC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1A,$7A,  0,  0,  0,  0,  2,  0,  0,  2; 35200
		dc.b $70,$6C,$79,$30,$33,$38,  0,  0,  0,  0,  0,$12,  0,$44,$83,$14,  0,$44,$83,  4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DC,$EE,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$33,$38,  0,  0,  0,  0,  0,$12,  0,$44,$83,$3C,  0,$44,$83,$2C,  0,$40,$D1,$30; 35264
		dc.b   0,  0,  0,  0,  0,  9,$1A,$68,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$33,$37,  0,  0,  0,  0,  0,$12,  0,$44,$83,$64,  0,$44,$83,$54,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DC,$E8,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$33,$37,  0,  0; 35328
		dc.b   0,  0,  0,$12,  0,$44,$83,$8C,  0,$44,$83,$7C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1A,$4E,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$33,$36,  0,  0,  0,  0,  0,$12,  0,$44,$83,$B4,  0,$44,$83,$A4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DC,$E0; 35392
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$33,$36,  0,  0,  0,  0,  0,$12,  0,$44,$83,$DC,  0,$44,$83,$CC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1A,$2C,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$33,$35,  0,  0,  0,  0,  0,$12,  0,$44,$84,$2C; 35456
		dc.b   0,$44,$83,$F4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DC,$D6,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$33,$35,  0,  0,  0,  0,  0,$12,  0,$44,$88,$B4,  0,$44,$84,$1C,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  3,$82,  0,  0,  0,  0,  2,  0,  0,  2; 35520
		dc.b $66,$6F,$78,$73,$70,$30,$39,$39,  0,  0,  0, $E,  0,$44,$84,$54,  0,$44,$84,$44,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1A, $A,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$33,$34,  0,  0,  0,  0,  0,$12,  0,$44,$84,$A4,  0,$44,$84,$6C,  0,$40,$D1,$30; 35584
		dc.b   0,  0,  0,  0,  0,  9,$DC,$CC,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$33,$34,  0,  0,  0,  0,  0,$12,  0,$44,$89,$2C,  0,$44,$84,$94,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  3,$78,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$39,$38; 35648
		dc.b   0,  0,  0, $D,  0,$44,$84,$CC,  0,$44,$84,$BC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$19,$E8,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$33,$33,  0,  0,  0,  0,  0,$12,  0,$44,$85,$1C,  0,$44,$84,$E4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DC,$C2; 35712
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$33,$33,  0,  0,  0,  0,  0,$12,  0,$44,$89,$A4,  0,$44,$85, $C,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  3,$6E,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$39,$37,  0,  0,  0, $C,  0,$44,$85,$44; 35776
		dc.b   0,$44,$85,$34,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$19,$BE,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$33,$32,  0,  0,  0,  0,  0,$12,  0,$44,$85,$94,  0,$44,$85,$5C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DC,$B6,  0,  0,  0,  0,  2,  0,  0,  2; 35840
		dc.b $70,$6C,$77,$30,$33,$32,  0,  0,  0,  0,  0,$12,  0,$44,$8A,$1C,  0,$44,$85,$84,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  3,$64,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$39,$36,  0,  0,  0, $B,  0,$44,$85,$BC,  0,$44,$85,$AC,  0,$40,$D1,$30; 35904
		dc.b   0,  0,  0,  0,  0,  9,$19,$9C,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$33,$31,  0,  0,  0,  0,  0,$12,  0,$44,$86, $C,  0,$44,$85,$D4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DC,$AC,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$33,$31,  0,  0; 35968
		dc.b   0,  0,  0,$12,  0,$44,$8A,$94,  0,$44,$85,$FC,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  3,$52,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$39,$35,  0,  0,  0, $A,  0,$44,$86,$34,  0,$44,$86,$24,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$19,$7A; 36032
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$33,$30,  0,  0,  0,  0,  0,$12,  0,$44,$87,$24,  0,$44,$86,$4C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DC,$A2,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$33,$30,  0,  0,  0,  0,  0,$12,  0,$44,$8B, $C; 36096
		dc.b   0,$44,$86,$74,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  3,$40,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$39,$34,  0,  0,  0,  9,  0,$44,$8B,$34,  0,$44,$86,$9C,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  3,$36,  0,  0,  0,  0,  2,  0,  0,  2; 36160
		dc.b $66,$6F,$78,$73,$70,$30,$39,$33,  0,  0,  0,  8,  0,$44,$8B,$5C,  0,$44,$86,$C4,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  3,$2C,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$39,$32,  0,  0,  0,  7,  0,$44,$8B,$84,  0,$44,$86,$EC,  0,$40,$D1,$30; 36224
		dc.b   0,  0,  0,  0,  0, $A,  3,$22,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$39,$31,  0,  0,  0,  6,  0,$44,$8B,$AC,  0,$44,$87,$14,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  3,$10,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$39,$30; 36288
		dc.b   0,  0,  0,  5,  0,$44,$87,$4C,  0,$44,$87,$3C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$19,$58,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$32,$39,  0,  0,  0,  0,  0,$12,  0,$44,$87,$74,  0,$44,$87,$64,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DC,$98; 36352
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$32,$39,  0,  0,  0,  0,  0,$12,  0,$44,$87,$9C,  0,$44,$87,$8C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$19,$36,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$32,$38,  0,  0,  0,  0,  0,$12,  0,$44,$87,$C4; 36416
		dc.b   0,$44,$87,$B4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DC,$8E,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$32,$38,  0,  0,  0,  0,  0,$12,  0,$44,$87,$EC,  0,$44,$87,$DC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$19,$14,  0,  0,  0,  0,  2,  0,  0,  2; 36480
		dc.b $70,$6C,$79,$30,$32,$37,  0,  0,  0,  0,  0,$12,  0,$44,$88,$14,  0,$44,$88,  4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DC,$84,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$32,$37,  0,  0,  0,  0,  0,$12,  0,$44,$88,$3C,  0,$44,$88,$2C,  0,$40,$D1,$30; 36544
		dc.b   0,  0,  0,  0,  0,  9,$18,$EA,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$32,$36,  0,  0,  0,  0,  0,$12,  0,$44,$88,$64,  0,$44,$88,$54,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DC,$78,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$32,$36,  0,  0; 36608
		dc.b   0,  0,  0,$12,  0,$44,$88,$8C,  0,$44,$88,$7C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$18,$C0,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$32,$35,  0,  0,  0,  0,  0,$12,  0,$44,$88,$DC,  0,$44,$88,$A4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DC,$6C; 36672
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$32,$35,  0,  0,  0,  0,  0,$12,  0,$44,$8D,$64,  0,$44,$88,$CC,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  2,$FE,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$38,$39,  0,  0,  0, $E,  0,$44,$89,  4; 36736
		dc.b   0,$44,$88,$F4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$18,$9E,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$32,$34,  0,  0,  0,  0,  0,$12,  0,$44,$89,$54,  0,$44,$89,$1C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DC,$62,  0,  0,  0,  0,  2,  0,  0,  2; 36800
		dc.b $70,$6C,$77,$30,$32,$34,  0,  0,  0,  0,  0,$12,  0,$44,$8E,  8,  0,$44,$89,$44,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  2,$F4,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$38,$38,  0,  0,  0, $D,  0,$44,$89,$7C,  0,$44,$89,$6C,  0,$40,$D1,$30; 36864
		dc.b   0,  0,  0,  0,  0,  9,$18,$84,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$32,$33,  0,  0,  0,  0,  0,$12,  0,$44,$89,$CC,  0,$44,$89,$94,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DC,$5A,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$32,$33,  0,  0; 36928
		dc.b   0,  0,  0,$12,  0,$44,$8E,$80,  0,$44,$89,$BC,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  2,$EA,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$38,$37,  0,  0,  0, $C,  0,$44,$89,$F4,  0,$44,$89,$E4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$18,$6A; 36992
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$32,$32,  0,  0,  0,  0,  0,$12,  0,$44,$8A,$44,  0,$44,$8A, $C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DC,$52,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$32,$32,  0,  0,  0,  0,  0,$12,  0,$44,$8D,$DC; 37056
		dc.b   0,$44,$8A,$34,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  2,$E0,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$38,$36,  0,  0,  0, $B,  0,$44,$8A,$6C,  0,$44,$8A,$5C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$18,$50,  0,  0,  0,  0,  2,  0,  0,  2; 37120
		dc.b $70,$6C,$79,$30,$32,$31,  0,  0,  0,  0,  0,$12,  0,$44,$8A,$BC,  0,$44,$8A,$84,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DC,$4A,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$32,$31,  0,  0,  0,  0,  0,$12,  0,$44,$8F,$9C,  0,$44,$8A,$AC,  0,$40,$D1,$30; 37184
		dc.b   0,  0,  0,  0,  0, $A,  2,$D6,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$38,$35,  0,  0,  0, $A,  0,$44,$8A,$E4,  0,$44,$8A,$D4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$18,$36,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$32,$30,  0,  0; 37248
		dc.b   0,  0,  0,$12,  0,$44,$8B,$D4,  0,$44,$8A,$FC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DC,$42,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$32,$30,  0,  0,  0,  0,  0,$12,  0,$44,$90,$14,  0,$44,$8B,$24,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  2,$CC; 37312
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$38,$34,  0,  0,  0,  9,  0,$44,$90,$3C,  0,$44,$8B,$4C,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  2,$C2,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$38,$33,  0,  0,  0,  8,  0,$44,$90,$8C; 37376
		dc.b   0,$44,$8B,$74,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  2,$B8,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$38,$32,  0,  0,  0,  7,  0,$44,$90,$B4,  0,$44,$8B,$9C,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  2,$AE,  0,  0,  0,  0,  2,  0,  0,  2; 37440
		dc.b $66,$6F,$78,$73,$70,$30,$38,$31,  0,  0,  0,  6,  0,$44,$90,$DC,  0,$44,$8B,$C4,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  2,$A4,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$38,$30,  0,  0,  0,  5,  0,$44,$8B,$FC,  0,$44,$8B,$EC,  0,$40,$D1,$30; 37504
		dc.b   0,  0,  0,  0,  0,  9,$18,$14,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$31,$39,  0,  0,  0,  0,  0,$12,  0,$44,$8C,$24,  0,$44,$8C,$14,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DC,$38,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$31,$39,  0,  0; 37568
		dc.b   0,  0,  0,$12,  0,$44,$8C,$4C,  0,$44,$8C,$3C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$17,$F2,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$31,$38,  0,  0,  0,  0,  0,$12,  0,$44,$8C,$74,  0,$44,$8C,$64,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DC,$2E; 37632
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$31,$38,  0,  0,  0,  0,  0,$12,  0,$44,$8C,$9C,  0,$44,$8C,$8C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$17,$D8,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$31,$37,  0,  0,  0,  0,  0,$12,  0,$44,$8C,$C4; 37696
		dc.b   0,$44,$8C,$B4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DC,$26,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$31,$37,  0,  0,  0,  0,  0,$12,  0,$44,$8C,$EC,  0,$44,$8C,$DC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$17,$BE,  0,  0,  0,  0,  2,  0,  0,  2; 37760
		dc.b $70,$6C,$79,$30,$31,$36,  0,  0,  0,  0,  0,$12,  0,$44,$8D,$14,  0,$44,$8D,  4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DC,$1E,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$31,$36,  0,  0,  0,  0,  0,$12,  0,$44,$8D,$3C,  0,$44,$8D,$2C,  0,$40,$D1,$30; 37824
		dc.b   0,  0,  0,  0,  0,  9,$17,$A4,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$31,$35,  0,  0,  0,  0,  0,$12,  0,$44,$8D,$8C,  0,$44,$8D,$54,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DC,$16,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$31,$35,  0,  0; 37888
		dc.b   0,  0,  0,$12,  0,$44,$92,$94,  0,$44,$8D,$7C,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  2,$9A,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$37,$39,  0,  0,  0, $E,  0,$44,$8D,$B4,  0,$44,$8D,$A4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$17,$92; 37952
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$31,$34,  0,  0,  0,  0,  0,$12,  0,$44,$8E,$30,  0,$44,$8D,$CC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DC,$10,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$31,$34,  0,  0,  0,  0,  0,$12,  0,$44,$8E,$F8; 38016
		dc.b   0,$44,$8D,$F4,  0,$40,$D1,$30,  0,$40,$8F,$F0,  0,  2,$7D,$18,  0,  0,  0,  0,  2,  0,  0,  3,$65,$66,$65,$63,$74,$30,$64,$65,$63,$67,  0,  0,  0,  0,  0, $B,  0,$44,$93, $C,  0,$44,$8E,$20,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  2,$90,  0,  0,  0,  0; 38080
		dc.b   2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$37,$38,  0,  0,  0, $D,  0,$44,$8E,$58,  0,$44,$8E,$48,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$17,$80,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$31,$33,  0,  0,  0,  0,  0,$12,  0,$44,$8E,$A8,  0,$44,$8E,$70; 38144
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DC, $A,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$31,$33,  0,  0,  0,  0,  0,$12,  0,$44,$93,$84,  0,$44,$8E,$98,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  2,$86,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73; 38208
		dc.b $70,$30,$37,$37,  0,  0,  0, $C,  0,$44,$8E,$D0,  0,$44,$8E,$C0,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$17,$5E,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$31,$32,  0,  0,  0,  0,  0,$12,  0,$44,$8F,$4C,  0,$44,$8E,$E8,  0,$40,$D1,$30,  0,  0,  0,  0; 38272
		dc.b   0,  9,$DC,  0,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$31,$32,  0,  0,  0,  0,  0,$12,  0,$44,$8F,$24,  0,$44,$8F,$10,  0,$40,$D1,$30,  0,$40,$90,$24,  0,  2,$6F,$98,  0,  0,  0,  0,  2,  0,  0,  3,$65,$66,$65,$63,$74,$30,$30,$65,$63,$67,  0,  0; 38336
		dc.b   0,  0,  0, $B,  0,$44,$93,$FC,  0,$44,$8F,$3C,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  2,$7C,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$37,$36,  0,  0,  0, $B,  0,$44,$8F,$74,  0,$44,$8F,$64,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$17,$3C; 38400
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$31,$31,  0,  0,  0,  0,  0,$12,  0,$44,$8F,$C4,  0,$44,$8F,$8C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DB,$F6,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$31,$31,  0,  0,  0,  0,  0,$12,  0,$44,$94,$74; 38464
		dc.b   0,$44,$8F,$B4,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  2,$72,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$37,$35,  0,  0,  0, $A,  0,$44,$8F,$EC,  0,$44,$8F,$DC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$17,$2A,  0,  0,  0,  0,  2,  0,  0,  2; 38528
		dc.b $70,$6C,$79,$30,$31,$30,  0,  0,  0,  0,  0,$12,  0,$44,$91,  4,  0,$44,$90,  4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DB,$F0,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$31,$30,  0,  0,  0,  0,  0,$12,  0,$44,$94,$EC,  0,$44,$90,$2C,  0,$40,$D1,$30; 38592
		dc.b   0,  0,  0,  0,  0, $A,  2,$68,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$37,$34,  0,  0,  0,  9,  0,$44,$95,$14,  0,$44,$90,$54,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  2,$5E,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$37,$33; 38656
		dc.b   0,  0,  0,  8,  0,$44,$62,$F8,  0,$44,$90,$7C,  0,$40,$D1,$30,  0,$40,$D8,$30,  0, $A,$65,  4,  0,  0,  0,  0,  2,  0,  0,  2,$69,$74,$65,$6D,$63,$67,  0,  0,  0,  0,  0, $F,  0,$44,$95,$3C,  0,$44,$90,$A4,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  2,$54; 38720
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$37,$32,  0,  0,  0,  7,  0,$44,$95,$8C,  0,$44,$90,$CC,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  2,$4A,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$37,$31,  0,  0,  0,  6,  0,$44,$95,$DC; 38784
		dc.b   0,$44,$90,$F4,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  2,$40,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$37,$30,  0,  0,  0,  5,  0,$44,$91,$2C,  0,$44,$91,$1C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$17,$18,  0,  0,  0,  0,  2,  0,  0,  2; 38848
		dc.b $70,$6C,$79,$30,$30,$39,  0,  0,  0,  0,  0,$12,  0,$44,$91,$54,  0,$44,$91,$44,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DB,$EA,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$30,$39,  0,  0,  0,  0,  0,$12,  0,$44,$91,$7C,  0,$44,$91,$6C,  0,$40,$D1,$30; 38912
		dc.b   0,  0,  0,  0,  0,  9,$17,  6,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$30,$38,  0,  0,  0,  0,  0,$12,  0,$44,$91,$A4,  0,$44,$91,$94,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DB,$E4,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$30,$38,  0,  0; 38976
		dc.b   0,  0,  0,$12,  0,$44,$91,$CC,  0,$44,$91,$BC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$16,$E4,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$30,$37,  0,  0,  0,  0,  0,$12,  0,$44,$91,$F4,  0,$44,$91,$E4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DB,$DA; 39040
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$30,$37,  0,  0,  0,  0,  0,$12,  0,$44,$92,$1C,  0,$44,$92, $C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$16,$C2,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$30,$36,  0,  0,  0,  0,  0,$12,  0,$44,$92,$44; 39104
		dc.b   0,$44,$92,$34,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DB,$D0,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$30,$36,  0,  0,  0,  0,  0,$12,  0,$44,$92,$6C,  0,$44,$92,$5C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$16,$98,  0,  0,  0,  0,  2,  0,  0,  2; 39168
		dc.b $70,$6C,$79,$30,$30,$35,  0,  0,  0,  0,  0,$12,  0,$44,$92,$BC,  0,$44,$92,$84,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DB,$C4,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$30,$35,  0,  0,  0,  0,  0,$12,  0,$44,$96,$54,  0,$44,$92,$AC,  0,$40,$D1,$30; 39232
		dc.b   0,  0,  0,  0,  0, $A,  2,$26,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$36,$39,  0,  0,  0, $E,  0,$44,$92,$E4,  0,$44,$92,$D4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$16,$6E,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$30,$34,  0,  0; 39296
		dc.b   0,  0,  0,$12,  0,$44,$93,$34,  0,$44,$92,$FC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DB,$B8,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$30,$34,  0,  0,  0,  0,  0,$12,  0,$44,$96,$7C,  0,$44,$93,$24,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  2, $C; 39360
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$36,$38,  0,  0,  0, $D,  0,$44,$93,$5C,  0,$44,$93,$4C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$16,$44,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$30,$33,  0,  0,  0,  0,  0,$12,  0,$44,$93,$AC; 39424
		dc.b   0,$44,$93,$74,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DB,$AC,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$30,$33,  0,  0,  0,  0,  0,$12,  0,$44,$96,$A4,  0,$44,$93,$9C,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  1,$F2,  0,  0,  0,  0,  2,  0,  0,  2; 39488
		dc.b $66,$6F,$78,$73,$70,$30,$36,$37,  0,  0,  0, $C,  0,$44,$93,$D4,  0,$44,$93,$C4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$16,$32,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$30,$32,  0,  0,  0,  0,  0,$12,  0,$44,$94,$24,  0,$44,$93,$EC,  0,$40,$D1,$30; 39552
		dc.b   0,  0,  0,  0,  0,  9,$DB,$A6,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$30,$32,  0,  0,  0,  0,  0,$12,  0,$44,$96,$CC,  0,$44,$94,$14,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  1,$D8,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$36,$36; 39616
		dc.b   0,  0,  0, $B,  0,$44,$94,$4C,  0,$44,$94,$3C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$16,$10,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$30,$31,  0,  0,  0,  0,  0,$12,  0,$44,$94,$9C,  0,$44,$94,$64,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DB,$9C; 39680
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$30,$31,  0,  0,  0,  0,  0,$12,  0,$44,$96,$F4,  0,$44,$94,$8C,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  1,$BE,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$36,$35,  0,  0,  0, $A,  0,$44,$94,$C4; 39744
		dc.b   0,$44,$94,$B4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$16, $E,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$30,$30,  0,  0,  0,  0,  0,$12,  0,$44,$60,$24,  0,$44,$94,$DC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DB,$9A,  0,  0,  0,  0,  2,  0,  0,  2; 39808
		dc.b $70,$6C,$77,$30,$30,$30,  0,  0,  0,  0,  0,$12,  0,$44,$97,$1C,  0,$44,$95,  4,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  1,$A4,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$36,$34,  0,  0,  0,  9,  0,$44,$97,$44,  0,$44,$95,$2C,  0,$40,$D1,$30; 39872
		dc.b   0,  0,  0,  0,  0, $A,  1,$8A,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$36,$33,  0,  0,  0,  8,  0,$44,$97,$6C,  0,$44,$95,$54,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  1,$70,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$36,$32; 39936
		dc.b   0,  0,  0,  7,  0,$44,$95,$B4,  0,$44,$95,$7C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  2,$32,  0,  0,  0,  0,  0,  2,  0,  0,  2,$73,$63,$64,$74,$62,$6C,$34,  0,  0,  0,  0,$16,  0,$44,$97,$94,  0,$44,$95,$A4,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  1,$3C; 40000
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$36,$31,  0,  0,  0,  6,  0,$44,$96,  4,  0,$44,$95,$CC,  0,$40,$D1,$30,  0,$3F,$64,$64,  0,  2,$22,  0,  0,  0,  0,  0,  2,  0,  0,  2,$73,$63,$64,$74,$62,$6C,$33,  0,  0,  0,  0,$16,  0,$44,$97,$BC; 40064
		dc.b   0,$44,$95,$F4,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  1,$56,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$36,$30,  0,  0,  0,  5,  0,$44,$96,$2C,  0,$44,$96,$1C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  2,$12,  0,  0,  0,  0,  0,  2,  0,  0,  2; 40128
		dc.b $73,$63,$64,$74,$62,$6C,$32,  0,  0,  0,  0,$16,  0,$44,$5F,$FC,  0,$44,$96,$44,  0,$40,$D1,$30,  0,$3F,$64,$94,  0,  2,  2,  0,  0,  0,  0,  0,  2,  0,  0,  2,$73,$63,$64,$74,$62,$6C,$31,  0,  0,  0,  0,$16,  0,$44,$97,$E4,  0,$44,$96,$6C,  0,$40,$D1,$30; 40192
		dc.b   0,  0,  0,  0,  0, $A,  1,$3C,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$35,$39,  0,  0,  0, $E,  0,$44,$98, $C,  0,$44,$96,$94,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  1,$22,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$35,$38; 40256
		dc.b   0,  0,  0, $D,  0,$44,$98,$34,  0,$44,$96,$BC,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  1,  8,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$35,$37,  0,  0,  0, $C,  0,$44,$98,$88,  0,$44,$96,$E4,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  0,$EE; 40320
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$35,$36,  0,  0,  0, $B,  0,$44,$98,$B0,  0,$44,$97, $C,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  0,$D4,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$35,$35,  0,  0,  0, $A,  0,$44,$98,$D8; 40384
		dc.b   0,$44,$97,$34,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  0,$BA,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$35,$34,  0,  0,  0,  9,  0,$44,$99,  0,  0,$44,$97,$5C,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  0,$A0,  0,  0,  0,  0,  2,  0,  0,  2; 40448
		dc.b $66,$6F,$78,$73,$70,$30,$35,$33,  0,  0,  0,  8,  0,$44,$99,$28,  0,$44,$97,$84,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  0,$86,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$35,$32,  0,  0,  0,  7,  0,$44,$99,$50,  0,$44,$97,$AC,  0,$40,$D1,$30; 40512
		dc.b   0,  0,  0,  0,  0, $A,  0,$74,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$35,$31,  0,  0,  0,  6,  0,$44,$99,$78,  0,$44,$97,$D4,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  0,$62,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$35,$30; 40576
		dc.b   0,  0,  0,  5,  0,$44,$99,$A0,  0,$44,$97,$FC,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  0,$50,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$34,$39,  0,  0,  0, $E,  0,$44,$99,$C8,  0,$44,$98,$24,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  0,$3E; 40640
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$34,$38,  0,  0,  0, $D,  0,$44,$99,$F0,  0,$44,$98,$4C,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  0,$2C,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$34,$37,  0,  0,  0, $C,  0,$44,$67,$64; 40704
		dc.b   0,$44,$98,$74,  0,$40,$D1,$30,  0,$40,$D8,$60,  0, $A,$A9,$A4,  0,  0,  0,  0,  2,  0,  0,  3,$62,$6F,$73,$73,$61,$66,$62,$63,$67,  0,  0,  0,  0,  0,  0,$19,  0,$44,$9A,$18,  0,$44,$98,$A0,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  0,$1A,  0,  0,  0,  0; 40768
		dc.b   2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$34,$36,  0,  0,  0, $B,  0,$44,$9A,$40,  0,$44,$98,$C8,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  0,  0,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$34,$35,  0,  0,  0, $A,  0,$44,$9A,$68,  0,$44,$98,$F0; 40832
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FF,$EE,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$34,$34,  0,  0,  0,  9,  0,$44,$9A,$90,  0,$44,$99,$18,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FF,$D4,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73; 40896
		dc.b $70,$30,$34,$33,  0,  0,  0,  8,  0,$44,$9A,$B8,  0,$44,$99,$40,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FF,$C2,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$34,$32,  0,  0,  0,  7,  0,$44,$9A,$E0,  0,$44,$99,$68,  0,$40,$D1,$30,  0,  0,  0,  0; 40960
		dc.b   0,  9,$FF,$A8,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$34,$31,  0,  0,  0,  6,  0,$44,$9B,  8,  0,$44,$99,$90,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FF,$96,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$34,$30,  0,  0,  0,  5; 41024
		dc.b   0,$44,$9B,$30,  0,$44,$99,$B8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FF,$7C,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$33,$39,  0,  0,  0, $E,  0,$44,$9B,$58,  0,$44,$99,$E0,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FF,$6A,  0,  0,  0,  0; 41088
		dc.b   2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$33,$38,  0,  0,  0, $D,  0,$44,$9B,$80,  0,$44,$9A,  8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FF,$50,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$33,$37,  0,  0,  0, $C,  0,$44,$5B,$C4,  0,$44,$9A,$30; 41152
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FF,$36,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$33,$36,  0,  0,  0, $B,  0,$44,$5B,$EC,  0,$44,$9A,$58,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FF,$1C,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73; 41216
		dc.b $70,$30,$33,$35,  0,  0,  0, $A,  0,$44,$5C,$14,  0,$44,$9A,$80,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FF,  2,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$33,$34,  0,  0,  0,  9,  0,$44,$5C,$3C,  0,$44,$9A,$A8,  0,$40,$D1,$30,  0,  0,  0,  0; 41280
		dc.b   0,  9,$FE,$E8,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$33,$33,  0,  0,  0,  8,  0,$44,$5C,$64,  0,$44,$9A,$D0,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FE,$CE,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$33,$32,  0,  0,  0,  7; 41344
		dc.b   0,$44,$5C,$8C,  0,$44,$9A,$F8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FE,$B4,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$33,$31,  0,  0,  0,  6,  0,$44,$5C,$B4,  0,$44,$9B,$20,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$FE,$9A,  0,  0,  0,  0; 41408
		dc.b   2,  0,  0,  2,$66,$6F,$78,$73,$70,$30,$33,$30,  0,  0,  0,  5,  0,$44,$5C,$DC,  0,$44,$9B,$48,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  5,$46,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$32,$39,  0,  0,  0, $E,  0,$44,$5D,  4,  0,$44,$9B,$70; 41472
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  5,$34,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$32,$38,  0,  0,  0, $D,  0,$44,$5D,$2C,  0,$44,$5B,$B4,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  5,$22,  0,  0,  0,  0,  0,$5B,$F2,  0,  0,  9,$94,$60; 41536
		dc.b   0,  0,  0,  0,  0,$44,$BB,$B0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C6,$4A,  2,  0,  0,  2,$70,$6C,$79,$31,$33,$35,  0,  0,  0,  0,  0,$13,  0,$44,$9B,$EC,  0,$44,$9B,$DC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$B2,  0,  0,  0,  0,  2,  0,  0,  2; 41600
		dc.b $70,$6C,$77,$31,$33,$35,  0,  0,  0,  0,  0,$13,  0,$44,$9C,$14,  0,$44,$9C,  4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$22,$32,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$33,$34,  0,  0,  0,  0,  0,$13,  0,$44,$9C,$3C,  0,$44,$9C,$2C,  0,$40,$D1,$30; 41664
		dc.b   0,  0,  0,  0,  0,  9,$DE,$AC,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$33,$34,  0,  0,  0,  0,  0,$13,  0,$44,$9C,$64,  0,$44,$9C,$54,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$22,$20,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$33,$33,  0,  0; 41728
		dc.b   0,  0,  0,$13,  0,$44,$9C,$8C,  0,$44,$9C,$7C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$A6,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$33,$33,  0,  0,  0,  0,  0,$13,  0,$44,$9C,$B4,  0,$44,$9C,$A4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$22,  6; 41792
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$33,$32,  0,  0,  0,  0,  0,$13,  0,$44,$9C,$DC,  0,$44,$9C,$CC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$9E,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$33,$32,  0,  0,  0,  0,  0,$13,  0,$44,$9D,  4; 41856
		dc.b   0,$44,$9C,$F4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$21,$EC,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$33,$31,  0,  0,  0,  0,  0,$13,  0,$44,$9D,$2C,  0,$44,$9D,$1C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$96,  0,  0,  0,  0,  2,  0,  0,  2; 41920
		dc.b $70,$6C,$77,$31,$33,$31,  0,  0,  0,  0,  0,$13,  0,$44,$9D,$54,  0,$44,$9D,$44,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$21,$D2,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$33,$30,  0,  0,  0,  0,  0,$13,  0,$44,$9D,$A4,  0,$44,$9D,$6C,  0,$40,$D1,$30; 41984
		dc.b   0,  0,  0,  0,  0,  9,$DE,$8E,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$33,$30,  0,  0,  0,  0,  0,$13,  0,$44,$6B,$A0,  0,$44,$9D,$94,  0,$40,$D1,$30,  0,$3B,$93,$AC,  0, $A,  9,$60,  0,  0,  0,  0,  2,  0,  0,  2,$6C,$6F,$67,$6F,$63,$67,  0,  0; 42048
		dc.b   0,  0,  0,$11,  0,$44,$9D,$CC,  0,$44,$9D,$BC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$21,$B8,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$32,$39,  0,  0,  0,  0,  0,$13,  0,$44,$9D,$F4,  0,$44,$9D,$E4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$86; 42112
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$32,$39,  0,  0,  0,  0,  0,$13,  0,$44,$9E,$1C,  0,$44,$9E, $C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$21,$AE,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$32,$38,  0,  0,  0,  0,  0,$13,  0,$44,$9E,$44; 42176
		dc.b   0,$44,$9E,$34,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$82,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$32,$38,  0,  0,  0,  0,  0,$13,  0,$44,$9E,$6C,  0,$44,$9E,$5C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$21,$A4,  0,  0,  0,  0,  2,  0,  0,  2; 42240
		dc.b $70,$6C,$79,$31,$32,$37,  0,  0,  0,  0,  0,$13,  0,$44,$9E,$94,  0,$44,$9E,$84,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$7E,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$32,$37,  0,  0,  0,  0,  0,$13,  0,$44,$9E,$BC,  0,$44,$9E,$AC,  0,$40,$D1,$30; 42304
		dc.b   0,  0,  0,  0,  0,  9,$21,$8A,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$32,$36,  0,  0,  0,  0,  0,$13,  0,$44,$9E,$E4,  0,$44,$9E,$D4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$76,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$32,$36,  0,  0; 42368
		dc.b   0,  0,  0,$13,  0,$44,$9F, $C,  0,$44,$9E,$FC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$21,$68,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$32,$35,  0,  0,  0,  0,  0,$13,  0,$44,$9F,$34,  0,$44,$9F,$24,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$6C; 42432
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$32,$35,  0,  0,  0,  0,  0,$13,  0,$44,$9F,$5C,  0,$44,$9F,$4C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$21,$46,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$32,$34,  0,  0,  0,  0,  0,$13,  0,$44,$9F,$84; 42496
		dc.b   0,$44,$9F,$74,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$62,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$32,$34,  0,  0,  0,  0,  0,$13,  0,$44,$9F,$AC,  0,$44,$9F,$9C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$21,$24,  0,  0,  0,  0,  2,  0,  0,  2; 42560
		dc.b $70,$6C,$79,$31,$32,$33,  0,  0,  0,  0,  0,$13,  0,$44,$9F,$D4,  0,$44,$9F,$C4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$58,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$32,$33,  0,  0,  0,  0,  0,$13,  0,$44,$9F,$FC,  0,$44,$9F,$EC,  0,$40,$D1,$30; 42624
		dc.b   0,  0,  0,  0,  0,  9,$21, $A,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$32,$32,  0,  0,  0,  0,  0,$13,  0,$44,$A0,$24,  0,$44,$A0,$14,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$50,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$32,$32,  0,  0; 42688
		dc.b   0,  0,  0,$13,  0,$44,$A0,$4C,  0,$44,$A0,$3C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$20,$F0,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$32,$31,  0,  0,  0,  0,  0,$13,  0,$44,$A0,$74,  0,$44,$A0,$64,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$48; 42752
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$32,$31,  0,  0,  0,  0,  0,$13,  0,$44,$A0,$9C,  0,$44,$A0,$8C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$20,$D6,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$32,$30,  0,  0,  0,  0,  0,$13,  0,$44,$A0,$F0; 42816
		dc.b   0,$44,$A0,$B4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$40,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$32,$30,  0,  0,  0,  0,  0,$13,  0,$44,$A2,$D0,  0,$44,$A0,$DC,  0,$40,$D1,$30,  0,$3E,$D7,$60,  0,  9,$DA,$4C,  0,  0,  0,  0,  2,  0,  0,  3; 42880
		dc.b $70,$6C,$61,$79,$77,$72,$74,$70,$61,$74,  0,  0,  0,  0,  0, $C,  0,$44,$A1,$18,  0,$44,$A1,  8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$20,$BC,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$31,$39,  0,  0,  0,  0,  0,$13,  0,$44,$A1,$40,  0,$44,$A1,$30; 42944
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$38,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$31,$39,  0,  0,  0,  0,  0,$13,  0,$44,$A1,$68,  0,$44,$A1,$58,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$20,$B2,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31; 43008
		dc.b $31,$38,  0,  0,  0,  0,  0,$13,  0,$44,$A1,$90,  0,$44,$A1,$80,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$34,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$31,$38,  0,  0,  0,  0,  0,$13,  0,$44,$A1,$B8,  0,$44,$A1,$A8,  0,$40,$D1,$30,  0,  0,  0,  0; 43072
		dc.b   0,  9,$20,$A8,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$31,$37,  0,  0,  0,  0,  0,$13,  0,$44,$A1,$E0,  0,$44,$A1,$D0,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$30,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$31,$37,  0,  0,  0,  0,  0,$13; 43136
		dc.b   0,$44,$A2,  8,  0,$44,$A1,$F8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$20,$9E,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$31,$36,  0,  0,  0,  0,  0,$13,  0,$44,$A2,$30,  0,$44,$A2,$20,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$2C,  0,  0,  0,  0; 43200
		dc.b   2,  0,  0,  2,$70,$6C,$77,$31,$31,$36,  0,  0,  0,  0,  0,$13,  0,$44,$A2,$58,  0,$44,$A2,$48,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$20,$94,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$31,$35,  0,  0,  0,  0,  0,$13,  0,$44,$A2,$80,  0,$44,$A2,$70; 43264
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$28,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$31,$35,  0,  0,  0,  0,  0,$13,  0,$44,$A2,$A8,  0,$44,$A2,$98,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$20,$8A,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31; 43328
		dc.b $31,$34,  0,  0,  0,  0,  0,$13,  0,$44,$A2,$FC,  0,$44,$A2,$C0,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$24,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$31,$34,  0,  0,  0,  0,  0,$13,  0,$44,$AC,$A8,  0,$44,$A2,$E8,  0,$40,$D1,$30,  0,$40,$8F,$BC; 43392
		dc.b   0,  2,$7D,$D8,  0,  0,  0,  0,  2,  0,  0,  3,$65,$66,$65,$63,$74,$30,$64,$66,$63,$67,  0,  0,  0,  0,  0, $C,  0,$44,$A3,$24,  0,$44,$A3,$14,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$20,$80,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$31,$33,  0,  0; 43456
		dc.b   0,  0,  0,$13,  0,$44,$A3,$4C,  0,$44,$A3,$3C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$20,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$31,$33,  0,  0,  0,  0,  0,$13,  0,$44,$A3,$74,  0,$44,$A3,$64,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$20,$76; 43520
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$31,$32,  0,  0,  0,  0,  0,$13,  0,$44,$A3,$9C,  0,$44,$A3,$8C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$1C,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$31,$32,  0,  0,  0,  0,  0,$13,  0,$44,$A3,$C4; 43584
		dc.b   0,$44,$A3,$B4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$20,$6C,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$31,$31,  0,  0,  0,  0,  0,$13,  0,$44,$A3,$EC,  0,$44,$A3,$DC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$18,  0,  0,  0,  0,  2,  0,  0,  2; 43648
		dc.b $70,$6C,$77,$31,$31,$31,  0,  0,  0,  0,  0,$13,  0,$44,$A4,$14,  0,$44,$A4,  4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$20,$62,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$31,$30,  0,  0,  0,  0,  0,$13,  0,$44,$A4,$3C,  0,$44,$A4,$2C,  0,$40,$D1,$30; 43712
		dc.b   0,  0,  0,  0,  0,  9,$DE,$14,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$31,$30,  0,  0,  0,  0,  0,$13,  0,$44,$A4,$64,  0,$44,$A4,$54,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$20,$58,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$30,$39,  0,  0; 43776
		dc.b   0,  0,  0,$13,  0,$44,$A4,$B4,  0,$44,$A4,$7C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$10,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$30,$39,  0,  0,  0,  0,  0,$13,  0,$44,$A8,$E4,  0,$44,$A4,$A4,  0,$40,$D1,$30,  0,$3C,$D8,  0,  0, $A,$EA,$FC; 43840
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65,$63,$67,  0,  0,  0,  0,  0,  7,  0,$44,$A4,$DC,  0,$44,$A4,$CC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$20,$4E,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$30,$38,  0,  0,  0,  0,  0,$13,  0,$44,$A5,  4; 43904
		dc.b   0,$44,$A4,$F4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE, $C,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$30,$38,  0,  0,  0,  0,  0,$13,  0,$44,$A5,$2C,  0,$44,$A5,$1C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$20,$3C,  0,  0,  0,  0,  2,  0,  0,  2; 43968
		dc.b $70,$6C,$79,$31,$30,$37,  0,  0,  0,  0,  0,$13,  0,$44,$A5,$54,  0,$44,$A5,$44,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,  6,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$30,$37,  0,  0,  0,  0,  0,$13,  0,$44,$A5,$7C,  0,$44,$A5,$6C,  0,$40,$D1,$30; 44032
		dc.b   0,  0,  0,  0,  0,  9,$20,$2A,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$30,$36,  0,  0,  0,  0,  0,$13,  0,$44,$A5,$A4,  0,$44,$A5,$94,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,  0,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$30,$36,  0,  0; 44096
		dc.b   0,  0,  0,$13,  0,$44,$A5,$CC,  0,$44,$A5,$BC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$20,$18,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$30,$35,  0,  0,  0,  0,  0,$13,  0,$44,$A5,$F4,  0,$44,$A5,$E4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$FA; 44160
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$30,$35,  0,  0,  0,  0,  0,$13,  0,$44,$A6,$1C,  0,$44,$A6, $C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$20,  6,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$30,$34,  0,  0,  0,  0,  0,$13,  0,$44,$A6,$44; 44224
		dc.b   0,$44,$A6,$34,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$F4,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$30,$34,  0,  0,  0,  0,  0,$13,  0,$44,$A6,$6C,  0,$44,$A6,$5C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1F,$F4,  0,  0,  0,  0,  2,  0,  0,  2; 44288
		dc.b $70,$6C,$79,$31,$30,$33,  0,  0,  0,  0,  0,$13,  0,$44,$A6,$94,  0,$44,$A6,$84,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,  6,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$30,$33,  0,  0,  0,  0,  0,$13,  0,$44,$A6,$BC,  0,$44,$A6,$AC,  0,$40,$D1,$30; 44352
		dc.b   0,  0,  0,  0,  0,  9,$1F,$E2,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$30,$32,  0,  0,  0,  0,  0,$13,  0,$44,$A6,$E4,  0,$44,$A6,$D4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,  0,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$30,$32,  0,  0; 44416
		dc.b   0,  0,  0,$13,  0,$44,$A7, $C,  0,$44,$A6,$FC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1F,$D0,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$30,$31,  0,  0,  0,  0,  0,$13,  0,$44,$A7,$34,  0,$44,$A7,$24,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$FA; 44480
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$30,$31,  0,  0,  0,  0,  0,$13,  0,$44,$A7,$5C,  0,$44,$A7,$4C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1F,$BE,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$30,$30,  0,  0,  0,  0,  0,$13,  0,$3F,$AD,$DC; 44544
		dc.b   0,$44,$A7,$74,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$F4,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$30,$30,  0,  0,  0,  0,  0,$13,  0,$44,$AB,$64,  0,$44,$A7,$9C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  4,$16,$74,  0,  0,  0,  0,  2,  0,  0,  3; 44608
		dc.b $61,$73,$65,$74,$74,$62,$6C,$31,$30,$7A,  0,  0,  0,  0,  0,  8,  0,$44,$A7,$DC,  0,$44,$A7,$C8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  5,  4,$BA,  0,  0,  0,  0,  2,  0,  0,  3,$72,$69,$6E,$67,$61,$63,$74,$32,$33,  0,  0,  0,  0,  0,  0,$1C,  0,$44,$A8,  8; 44672
		dc.b   0,$44,$A7,$F4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  5,  4,$5C,  0,  0,  0,  0,  2,  0,  0,  3,$72,$69,$6E,$67,$61,$63,$74,$32,$32,  0,  0,  0,  0,  0,  0,$1C,  0,$44,$65,$D4,  0,$44,$A8,$20,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  5,  3,$CE,  0,  0,  0,  0; 44736
		dc.b   2,  0,  0,  3,$72,$69,$6E,$67,$61,$63,$74,$32,$31,  0,  0,  0,  0,  0,  0,$1C,  0,$44,$A8,$60,  0,$44,$A8,$4C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  5,  2,$A4,  0,  0,  0,  0,  2,  0,  0,  3,$72,$69,$6E,$67,$61,$63,$74,$31,$33,  0,  0,  0,  0,  0,  0,$1B; 44800
		dc.b   0,$44,$A8,$8C,  0,$44,$A8,$78,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  5,  1,$7A,  0,  0,  0,  0,  2,  0,  0,  3,$72,$69,$6E,$67,$61,$63,$74,$31,$32,  0,  0,  0,  0,  0,  0,$1B,  0,$41,  1,$30,  0,$44,$A8,$A4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  5,  0,$30; 44864
		dc.b   0,  0,  0,  0,  2,  0,  0,  3,$72,$69,$6E,$67,$61,$63,$74,$31,$31,  0,  0,  0,  0,  0,  0,$1B,  0,$44,$A9, $C,  0,$44,$A8,$D0,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  5,  9,$9C,  0,  0,  0,  0,  2,  0,  0,  3,$72,$69,$6E,$67,$61,$63,$74,$30,$33,  0,  0,  0; 44928
		dc.b   0,  0,  0,$1A,  0,$44,$AA,$B8,  0,$44,$A8,$FC,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  5,$64,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$33,$32,  0,  0,  0,  7,  0,$44,$A9,$60,  0,$44,$A9,$24,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  5,  9,$9A; 44992
		dc.b   0,  0,  0,  0,  2,  0,  0,  3,$72,$69,$6E,$67,$61,$63,$74,$30,$32,  0,  0,  0,  0,  0,  0,$1A,  0,$44,$AB,$E0,  0,$44,$A9,$50,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  5,$5A,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$33,$31,  0,  0,  0,  6; 45056
		dc.b   0,$44,$A9,$B4,  0,$44,$A9,$78,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  5,  8, $C,  0,  0,  0,  0,  2,  0,  0,  3,$72,$69,$6E,$67,$61,$63,$74,$30,$31,  0,  0,  0,  0,  0,  0,$1A,  0,$44,$AC,  8,  0,$44,$A9,$A4,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  5,$50; 45120
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$33,$30,  0,  0,  0,  5,  0,$3F,$55,  4,  0,$44,$A9,$CC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  5,  6,$AA,  0,  0,  0,  0,  2,  0,  0,  3,$72,$69,$6E,$67,$61,$63,$74,$30,$30,  0,  0,  0,  0,  0,  0,$1A; 45184
		dc.b   0,$3F,$AA,$7C,  0,$44,$A9,$F8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  2,$B6,$B4,  0,  0,  0,  0,  2,  0,  0,  3,$62,$69,$67,$72,$69,$6E,$67,$63,$67,  0,  0,  0,  0,  0,  0,$18,  0,$44,$AE,$38,  0,$44,$AA,$24,  0,$40,$D1,$30,  0,$40,$D6,$A8,  0, $A,$50,$DC; 45248
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$67,$65,$6D,$30,$38,$63,$67,  0,  0,  0,  0,$12,  0,$44,$AA,$8C,  0,$44,$AA,$4C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  4, $C,$96,  0,  0,  0,  0,  2,  0,  0,  3,$61,$73,$65,$74,$74,$62,$6C,$32,$33,  0,  0,  0,  0,  0,  0,  9; 45312
		dc.b   0,$41,  1,  8,  0,$44,$AA,$78,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $B,  6,$82,  0,  0,  0,  0,  2,  0,  0,  3,$73,$64,$73,$6F,$6E,$69,$63,$63,$67,  0,  0,  0,  0,  0,  0,$15,  0,$44,$AA,$E4,  0,$44,$AA,$A4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  4, $C,$96; 45376
		dc.b   0,  0,  0,  0,  2,  0,  0,  3,$61,$73,$65,$74,$74,$62,$6C,$32,$32,  0,  0,  0,  0,  0,  0,  9,  0,$44,$AB,$B8,  0,$44,$AA,$D0,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,$8A,$AA,  0,  0,  0,  0,  2,  0,  0,  3,$6D,$61,$6D,$61,$62,$75,$62,$63,$67,  0,  0,  0; 45440
		dc.b   0,  0,  0,  7,  0,$44,$AB,$10,  0,$44,$AA,$FC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  4, $C,$90,  0,  0,  0,  0,  2,  0,  0,  3,$61,$73,$65,$74,$74,$62,$6C,$32,$31,  0,  0,  0,  0,  0,  0,  9,  0,$44,$AD,$20,  0,$44,$AB,$28,  0,$40,$D1,$30,  0,  0,  0,  0; 45504
		dc.b   0,  4, $C,$8A,  0,  0,  0,  0,  2,  0,  0,  3,$61,$73,$65,$74,$74,$62,$6C,$32,$30,  0,  0,  0,  0,  0,  0,  9,  0,$44,$AC,$58,  0,$44,$AB,$54,  0,$40,$D1,$30,  0,$40,$D6,$D8,  0,  9,$E1,$14,  0,  0,  0,  0,  2,  0,  0,  2,$6D,$75,$74,$65,$6B,$69,$63,$67; 45568
		dc.b   0,  0,  0, $E,  0,$44,$AB,$90,  0,$44,$AB,$7C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  4,  7,$98,  0,  0,  0,  0,  2,  0,  0,  3,$61,$73,$65,$74,$74,$62,$6C,$31,$32,  0,  0,  0,  0,  0,  0,  8,  0,$44,$AD,$48,  0,$44,$AB,$A8,  0,$40,$D1,$30,  0,  0,  0,  0; 45632
		dc.b   0, $A,  4,$76,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$31,$33,  0,  0,  0,  8,  0,$44,$AC,$30,  0,$44,$AB,$D0,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  4,$64,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$31,$32,  0,  0,  0,  7; 45696
		dc.b   0,$44,$AD,$C0,  0,$44,$AB,$F8,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  4,$52,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$31,$31,  0,  0,  0,  6,  0,$44,$AE,$10,  0,$44,$AC,$20,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  4,$40,  0,  0,  0,  0; 45760
		dc.b   2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$31,$30,  0,  0,  0,  5,  0,$44,$AD,$98,  0,$44,$AC,$48,  0,$40,$D1,$30,  0,$40,$D7,$10,  0, $A,$69,$2E,  0,  0,  0,  0,  2,  0,  0,  2,$74,$6F,$67,$65,$63,$67,  0,  0,  0,  0,  0,  7,  0,$44,$B1,$D0,  0,$44,$AC,$70; 45824
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  4,$2E,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$30,$39,  0,  0,  0, $E,  0,$44,$84,$7C,  0,$44,$AC,$98,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  4,$1C,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73; 45888
		dc.b $70,$31,$30,$38,  0,  0,  0, $D,  0,$44,$84,$F4,  0,$44,$AC,$C0,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  4,$12,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$30,$37,  0,  0,  0, $C,  0,$44,$85,$6C,  0,$44,$AC,$E8,  0,$40,$D1,$30,  0,  0,  0,  0; 45952
		dc.b   0, $A,  4,  0,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$30,$36,  0,  0,  0, $B,  0,$44,$85,$E4,  0,$44,$AD,$10,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  3,$EE,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$30,$35,  0,  0,  0, $A; 46016
		dc.b   0,$44,$86,$5C,  0,$44,$AD,$38,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  3,$DC,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$30,$34,  0,  0,  0,  9,  0,$44,$86,$84,  0,$44,$AD,$60,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  3,$CA,  0,  0,  0,  0; 46080
		dc.b   2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$30,$33,  0,  0,  0,  8,  0,$40,$FE,$48,  0,$44,$AD,$88,  0,$40,$D1,$30,  0,$40,$D7,$40,  0, $B,  0,$D0,  0,  0,  0,  0,  2,  0,  0,  2,$62,$74,$65,$6E,$63,$67,  0,  0,  0,  0,  0,$10,  0,$44,$AD,$E8,  0,$44,$AD,$B0; 46144
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  3,$B8,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$30,$32,  0,  0,  0,  7,  0,$44,$86,$D4,  0,$44,$AD,$D8,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,  3,$A6,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73; 46208
		dc.b $70,$31,$30,$31,  0,  0,  0,  6,  0,$44,$B1,$A8,  0,$44,$AE,  0,  0,$40,$D1,$30,  0,$40,$D7,$70,  0, $A,$6A,$58,  0,  0,  0,  0,  2,  0,  0,  2,$73,$61,$76,$65,$63,$67,  0,  0,  0,  0,  0,  7,  0,$44,$B3,$B0,  0,$44,$AE,$28,  0,$40,$D1,$30,  0,  0,  0,  0; 46272
		dc.b   0, $A,  3,$94,  0,  0,  0,  0,  2,  0,  0,  2,$66,$6F,$78,$73,$70,$31,$30,$30,  0,  0,  0,  5,  0,$44,$AE,$60,  0,$44,$AE,$50,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1F,$AC,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$39,$39,  0,  0,  0,  0,  0,$12; 46336
		dc.b   0,$44,$AE,$88,  0,$44,$AE,$78,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,  6,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$39,$39,  0,  0,  0,  0,  0,$12,  0,$44,$AE,$B0,  0,$44,$AE,$A0,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1F,$9A,  0,  0,  0,  0; 46400
		dc.b   2,  0,  0,  2,$70,$6C,$79,$30,$39,$38,  0,  0,  0,  0,  0,$12,  0,$44,$AE,$D8,  0,$44,$AE,$C8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,  0,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$39,$38,  0,  0,  0,  0,  0,$12,  0,$44,$AF,  0,  0,$44,$AE,$F0; 46464
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1F,$88,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$39,$37,  0,  0,  0,  0,  0,$12,  0,$44,$AF,$28,  0,$44,$AF,$18,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$FA,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30; 46528
		dc.b $39,$37,  0,  0,  0,  0,  0,$12,  0,$44,$AF,$50,  0,$44,$AF,$40,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1F,$76,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$39,$36,  0,  0,  0,  0,  0,$12,  0,$44,$AF,$A0,  0,$44,$AF,$68,  0,$40,$D1,$30,  0,  0,  0,  0; 46592
		dc.b   0,  9,$DD,$F4,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$39,$36,  0,  0,  0,  0,  0,$12,  0,$44,$95,$64,  0,$44,$AF,$90,  0,$40,$D1,$30,  0,$3E,$81,$F4,  0,  4,  0,  0,  0,  0,  0,  0,  2,  0,  0,  2,$61,$73,$65,$74,$74,$62,$6C,  0,  0,  0,  0,$16; 46656
		dc.b   0,$44,$AF,$C8,  0,$44,$AF,$B8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1F,$64,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$39,$35,  0,  0,  0,  0,  0,$12,  0,$44,$AF,$F0,  0,$44,$AF,$E0,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$EE,  0,  0,  0,  0; 46720
		dc.b   2,  0,  0,  2,$70,$6C,$77,$30,$39,$35,  0,  0,  0,  0,  0,$12,  0,$44,$B0,$40,  0,$44,$B0,  8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1F,$52,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$39,$34,  0,  0,  0,  0,  0,$12,  0,$44,$68,$2C,  0,$44,$B0,$30; 46784
		dc.b   0,$40,$D1,$30,  0,$40,$D7,$A0,  0, $B,$10,$78,  0,  0,  0,  0,  2,  0,  0,  2,$72,$69,$73,$75,$63,$67,  0,  0,  0,  0,  0,$17,  0,$44,$B0,$68,  0,$44,$B0,$58,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$E8,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30; 46848
		dc.b $39,$34,  0,  0,  0,  0,  0,$12,  0,$44,$B0,$90,  0,$44,$B0,$80,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1F,$40,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$39,$33,  0,  0,  0,  0,  0,$12,  0,$44,$B0,$B8,  0,$44,$B0,$A8,  0,$40,$D1,$30,  0,  0,  0,  0; 46912
		dc.b   0,  9,$DD,$E2,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$39,$33,  0,  0,  0,  0,  0,$12,  0,$44,$B0,$E0,  0,$44,$B0,$D0,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1F,$2E,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$39,$32,  0,  0,  0,  0,  0,$12; 46976
		dc.b   0,$44,$B1,  8,  0,$44,$B0,$F8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$DC,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$39,$32,  0,  0,  0,  0,  0,$12,  0,$44,$B1,$30,  0,$44,$B1,$20,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1F,$1C,  0,  0,  0,  0; 47040
		dc.b   2,  0,  0,  2,$70,$6C,$79,$30,$39,$31,  0,  0,  0,  0,  0,$12,  0,$44,$B1,$58,  0,$44,$B1,$48,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$EE,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$39,$31,  0,  0,  0,  0,  0,$12,  0,$44,$B1,$80,  0,$44,$B1,$70; 47104
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1F, $A,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$39,$30,  0,  0,  0,  0,  0,$12,  0,$44,$B1,$F8,  0,$44,$B1,$98,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$E8,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30; 47168
		dc.b $39,$30,  0,  0,  0,  0,  0,$12,  0,$44,$7C,$D4,  0,$44,$B1,$C0,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,$37,$EA,  0,  0,  0,  0,  2,  0,  0,  2,$67,$72,$65,$65,$6E,$63,$67,  0,  0,  0,  0,  7,  0,$44,$7E,$8C,  0,$44,$B1,$E8,  0,$40,$D1,$30,  0,  0,  0,  0; 47232
		dc.b   0, $A,$88,$14,  0,  0,  0,  0,  2,  0,  0,  2,$62,$62,$61,$6C,$6C,$63,$67,  0,  0,  0,  0, $E,  0,$44,$B2,$20,  0,$44,$B2,$10,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1E,$F8,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$38,$39,  0,  0,  0,  0,  0,$12; 47296
		dc.b   0,$44,$B2,$48,  0,$44,$B2,$38,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$E2,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$38,$39,  0,  0,  0,  0,  0,$12,  0,$44,$B2,$70,  0,$44,$B2,$60,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1E,$E6,  0,  0,  0,  0; 47360
		dc.b   2,  0,  0,  2,$70,$6C,$79,$30,$38,$38,  0,  0,  0,  0,  0,$12,  0,$44,$B2,$98,  0,$44,$B2,$88,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$DC,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$38,$38,  0,  0,  0,  0,  0,$12,  0,$44,$B2,$C0,  0,$44,$B2,$B0; 47424
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1E,$D4,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$38,$37,  0,  0,  0,  0,  0,$12,  0,$44,$B2,$E8,  0,$44,$B2,$D8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$EE,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30; 47488
		dc.b $38,$37,  0,  0,  0,  0,  0,$12,  0,$44,$B3,$10,  0,$44,$B3,  0,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1E,$C2,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$38,$36,  0,  0,  0,  0,  0,$12,  0,$44,$B3,$38,  0,$44,$B3,$28,  0,$40,$D1,$30,  0,  0,  0,  0; 47552
		dc.b   0,  9,$DD,$E8,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$38,$36,  0,  0,  0,  0,  0,$12,  0,$44,$B3,$60,  0,$44,$B3,$50,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1E,$B0,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$38,$35,  0,  0,  0,  0,  0,$12; 47616
		dc.b   0,$44,$B3,$88,  0,$44,$B3,$78,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$E2,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$38,$35,  0,  0,  0,  0,  0,$12,  0,$44,$B3,$D8,  0,$44,$B3,$A0,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1E,$9E,  0,  0,  0,  0; 47680
		dc.b   2,  0,  0,  2,$70,$6C,$79,$30,$38,$34,  0,  0,  0,  0,  0,$12,  0,$44,$86,$FC,  0,$44,$B3,$C8,  0,$40,$D1,$30,  0,$40,$D7,$D0,  0, $A,$9D,$BE,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$64,$62,$63,$67,  0,  0,  0,  0,  0,  0,  5,  0,$44,$B4,  0,  0,$44,$B3,$F0; 47744
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$DC,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$38,$34,  0,  0,  0,  0,  0,$12,  0,$44,$B4,$28,  0,$44,$B4,$18,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1E,$8C,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30; 47808
		dc.b $38,$33,  0,  0,  0,  0,  0,$12,  0,$44,$B4,$50,  0,$44,$B4,$40,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$D6,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$38,$33,  0,  0,  0,  0,  0,$12,  0,$44,$B4,$78,  0,$44,$B4,$68,  0,$40,$D1,$30,  0,  0,  0,  0; 47872
		dc.b   0,  9,$1E,$7A,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$38,$32,  0,  0,  0,  0,  0,$12,  0,$44,$B4,$A0,  0,$44,$B4,$90,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$D0,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$38,$32,  0,  0,  0,  0,  0,$12; 47936
		dc.b   0,$44,$B4,$C8,  0,$44,$B4,$B8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1E,$68,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$38,$31,  0,  0,  0,  0,  0,$12,  0,$44,$B4,$F0,  0,$44,$B4,$E0,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$CA,  0,  0,  0,  0; 48000
		dc.b   2,  0,  0,  2,$70,$6C,$77,$30,$38,$31,  0,  0,  0,  0,  0,$12,  0,$44,$B5,$18,  0,$44,$B5,  8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1E,$56,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$38,$30,  0,  0,  0,  0,  0,$12,  0,$44,$B5,$40,  0,$44,$B5,$30; 48064
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$C4,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$38,$30,  0,  0,  0,  0,  0,$12,  0,$44,$B5,$68,  0,$44,$B5,$58,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1E,$44,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30; 48128
		dc.b $37,$39,  0,  0,  0,  0,  0,$12,  0,$44,$B5,$90,  0,$44,$B5,$80,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$D6,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$37,$39,  0,  0,  0,  0,  0,$12,  0,$44,$B5,$B8,  0,$44,$B5,$A8,  0,$40,$D1,$30,  0,  0,  0,  0; 48192
		dc.b   0,  9,$1E,$32,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$37,$38,  0,  0,  0,  0,  0,$12,  0,$44,$B5,$E0,  0,$44,$B5,$D0,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$D0,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$37,$38,  0,  0,  0,  0,  0,$12; 48256
		dc.b   0,$44,$B6,  8,  0,$44,$B5,$F8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1E,$20,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$37,$37,  0,  0,  0,  0,  0,$12,  0,$44,$B6,$30,  0,$44,$B6,$20,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$CA,  0,  0,  0,  0; 48320
		dc.b   2,  0,  0,  2,$70,$6C,$77,$30,$37,$37,  0,  0,  0,  0,  0,$12,  0,$44,$B6,$58,  0,$44,$B6,$48,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1E, $E,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$37,$36,  0,  0,  0,  0,  0,$12,  0,$44,$B6,$80,  0,$44,$B6,$70; 48384
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$C4,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$37,$36,  0,  0,  0,  0,  0,$12,  0,$44,$B6,$A8,  0,$44,$B6,$98,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1D,$FC,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30; 48448
		dc.b $37,$35,  0,  0,  0,  0,  0,$12,  0,$44,$B6,$D0,  0,$44,$B6,$C0,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$D6,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$37,$35,  0,  0,  0,  0,  0,$12,  0,$44,$B6,$F8,  0,$44,$B6,$E8,  0,$40,$D1,$30,  0,  0,  0,  0; 48512
		dc.b   0,  9,$1D,$EA,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$37,$34,  0,  0,  0,  0,  0,$12,  0,$44,$B7,$20,  0,$44,$B7,$10,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$D0,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$37,$34,  0,  0,  0,  0,  0,$12; 48576
		dc.b   0,$44,$B7,$48,  0,$44,$B7,$38,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1D,$D8,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$37,$33,  0,  0,  0,  0,  0,$12,  0,$44,$B7,$70,  0,$44,$B7,$60,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$CA,  0,  0,  0,  0; 48640
		dc.b   2,  0,  0,  2,$70,$6C,$77,$30,$37,$33,  0,  0,  0,  0,  0,$12,  0,$44,$B7,$98,  0,$44,$B7,$88,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1D,$C6,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$37,$32,  0,  0,  0,  0,  0,$12,  0,$44,$B7,$C0,  0,$44,$B7,$B0; 48704
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$C4,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$37,$32,  0,  0,  0,  0,  0,$12,  0,$44,$B7,$E8,  0,$44,$B7,$D8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1D,$B4,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30; 48768
		dc.b $37,$31,  0,  0,  0,  0,  0,$12,  0,$44,$B8,$10,  0,$44,$B8,  0,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$BE,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$37,$31,  0,  0,  0,  0,  0,$12,  0,$44,$B8,$38,  0,$44,$B8,$28,  0,$40,$D1,$30,  0,  0,  0,  0; 48832
		dc.b   0,  9,$1D,$A2,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$37,$30,  0,  0,  0,  0,  0,$12,  0,$44,$B8,$60,  0,$44,$B8,$50,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$B8,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$37,$30,  0,  0,  0,  0,  0,$12; 48896
		dc.b   0,$44,$B8,$88,  0,$44,$B8,$78,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1D,$90,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$36,$39,  0,  0,  0,  0,  0,$12,  0,$44,$B8,$B0,  0,$44,$B8,$A0,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$B2,  0,  0,  0,  0; 48960
		dc.b   2,  0,  0,  2,$70,$6C,$77,$30,$36,$39,  0,  0,  0,  0,  0,$12,  0,$44,$B8,$D8,  0,$44,$B8,$C8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1D,$7E,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$36,$38,  0,  0,  0,  0,  0,$12,  0,$44,$B9,  0,  0,$44,$B8,$F0; 49024
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$AC,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$36,$38,  0,  0,  0,  0,  0,$12,  0,$44,$B9,$28,  0,$44,$B9,$18,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1D,$6C,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30; 49088
		dc.b $36,$37,  0,  0,  0,  0,  0,$12,  0,$44,$B9,$50,  0,$44,$B9,$40,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$BE,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$36,$37,  0,  0,  0,  0,  0,$12,  0,$44,$B9,$78,  0,$44,$B9,$68,  0,$40,$D1,$30,  0,  0,  0,  0; 49152
		dc.b   0,  9,$1D,$5A,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$36,$36,  0,  0,  0,  0,  0,$12,  0,$44,$B9,$A0,  0,$44,$B9,$90,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$B8,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$36,$36,  0,  0,  0,  0,  0,$12; 49216
		dc.b   0,$44,$B9,$C8,  0,$44,$B9,$B8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1D,$48,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$36,$35,  0,  0,  0,  0,  0,$12,  0,$44,$B9,$F0,  0,$44,$B9,$E0,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$B2,  0,  0,  0,  0; 49280
		dc.b   2,  0,  0,  2,$70,$6C,$77,$30,$36,$35,  0,  0,  0,  0,  0,$12,  0,$44,$BA,$18,  0,$44,$BA,  8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1D,$36,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$36,$34,  0,  0,  0,  0,  0,$12,  0,$44,$BA,$40,  0,$44,$BA,$30; 49344
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$AC,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$36,$34,  0,  0,  0,  0,  0,$12,  0,$44,$BA,$68,  0,$44,$BA,$58,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1D,$24,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30; 49408
		dc.b $36,$33,  0,  0,  0,  0,  0,$12,  0,$44,$BA,$90,  0,$44,$BA,$80,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$BE,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$36,$33,  0,  0,  0,  0,  0,$12,  0,$44,$BA,$B8,  0,$44,$BA,$A8,  0,$40,$D1,$30,  0,  0,  0,  0; 49472
		dc.b   0,  9,$1D,$12,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$36,$32,  0,  0,  0,  0,  0,$12,  0,$44,$BA,$E0,  0,$44,$BA,$D0,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$B8,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$36,$32,  0,  0,  0,  0,  0,$12; 49536
		dc.b   0,$44,$BB,  8,  0,$44,$BA,$F8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1D,  0,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$36,$31,  0,  0,  0,  0,  0,$12,  0,$44,$BB,$30,  0,$44,$BB,$20,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$B2,  0,  0,  0,  0; 49600
		dc.b   2,  0,  0,  2,$70,$6C,$77,$30,$36,$31,  0,  0,  0,  0,  0,$12,  0,$44,$BB,$58,  0,$44,$BB,$48,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1C,$EE,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$30,$36,$30,  0,  0,  0,  0,  0,$12,  0,$44,$BB,$80,  0,$44,$BB,$70; 49664
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DD,$AC,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$30,$36,$30,  0,  0,  0,  0,  0,$12,  0,$44,$7B,$BC,  0,$44,$7B,$AC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$1C,$CC,  0,  0,  0,  0,  0,$5B,$F2,  0,  0,  9,$74,$60; 49728
		dc.b   0,  0,  0, $C,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$44,$BB,$C0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C6,$46,  0,$44,$BB,$D0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C6,$42,  0,$44,$BB,$E0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C6,$3E; 49792
		dc.b   0,$44,$BB,$F0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C6,$3A,  0,$44,$BC,  0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C6,$36,  0,$44,$BC,$10,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C6,$32,  0,$44,$BC,$20,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C5,$EA; 49856
		dc.b   0,$44,$BC,$30,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C5,$E6,  0,$44,$BC,$40,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C5,$E2,  0,$44,$BC,$50,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C5,$DA,  0,$44,$BC,$60,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C5,$A2; 49920
		dc.b   0,$44,$BC,$70,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C5,$9A,  0,$44,$BC,$80,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C5,$96,  0,$44,$BC,$90,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C5,$92,  0,$44,$BC,$A0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C5,$8E; 49984
		dc.b   0,$44,$BC,$B0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C5,$8A,  0,$44,$BC,$C0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C5,$82,  0,$44,$BC,$D0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C5,$4E,  0,$44,$BC,$E0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C5,$46; 50048
		dc.b   0,$44,$BC,$F0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C5,$42,  0,$44,$BD,  0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C5,$3A,  0,$44,$BD,$10,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C5,$32,  0,$44,$BD,$20,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C5,$26; 50112
		dc.b   0,$44,$BD,$30,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C4,$EA,  0,$44,$BD,$40,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C2,$BE,  0,$44,$BD,$50,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C2,$A8,  0,$44,$BD,$60,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C2,$36; 50176
		dc.b   0,$44,$BD,$70,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C1,$B4,  0,$44,$BD,$80,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$BF,$DC,  0,$44,$BD,$90,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$B8,$DE,  0,$44,$BD,$A0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$B7,$34; 50240
		dc.b   0,$44,$BD,$B0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$B7,  8,  0,$44,$BD,$C0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$B4,$F6,  0,$44,$BD,$D0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$B4,$C4,  0,$44,$BD,$E0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$B4,$12; 50304
		dc.b   0,$44,$BD,$F0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$B2,$A2,  0,$44,$BE,  0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$B2,$62,  0,$44,$BE,$10,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$B2,$58,  0,$44,$BE,$20,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$B1,$B8; 50368
		dc.b   0,$44,$BE,$30,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$B1,$4E,  0,$44,$BE,$40,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$B0,$C2,  0,$44,$BE,$50,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$B0,$8C,  0,$44,$BE,$60,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$AD,$80; 50432
		dc.b   0,$44,$BE,$70,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$AC,$F8,  0,$44,$BE,$80,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$A9,$DA,  0,$44,$BE,$90,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$A9,$14,  0,$44,$BE,$A0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$A7,$DA; 50496
		dc.b   0,$44,$BE,$B0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$A4,$AE,  0,$44,$BE,$C0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$A3,$E2,  0,$44,$BE,$D0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$A3,$BA,  0,$44,$BE,$E0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$A2,$D2; 50560
		dc.b   0,$44,$BE,$F0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$A2,$26,  0,$44,$BF,  0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$A1,$A4,  0,$44,$BF,$10,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$9F,$98,  0,$44,$BF,$20,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$9F,$5E; 50624
		dc.b   0,$44,$BF,$30,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$9F,$2A,  0,$44,$BF,$40,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$9E,$DA,  0,$44,$BF,$50,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$9D,$B2,  0,$44,$BF,$60,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$9D,$7A; 50688
		dc.b   0,$44,$BF,$70,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$9C,$34,  0,$44,$BF,$80,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$9B,$FE,  0,$44,$BF,$90,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$9A,$A8,  0,$44,$BF,$A0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$9A,$4E; 50752
		dc.b   0,$44,$BF,$B0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$99,$10,  0,$44,$BF,$C0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$94,$D0,  0,$44,$BF,$D0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$94,$CC,  0,$44,$BF,$E0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$94,$C8; 50816
		dc.b   0,$44,$BF,$F0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$94,$C4,  0,$44,$C0,  0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$94,$C0,  0,$44,$C0,$10,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$94,$BC,  0,$44,$C0,$20,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$94,$B8; 50880
		dc.b   0,$44,$C0,$30,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$94,$B4,  0,$44,$C0,$40,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$94,$B0,  0,$44,$C0,$50,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$94,$AC,  0,$44,$C0,$60,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$94,$A8; 50944
		dc.b   0,$44,$C0,$70,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$94,$78,  0,$44,$C0,$80,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$94,$70,  0,$44,$C0,$90,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$94,$68,  0,$44,$C0,$A0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$94,$60; 51008
		dc.b   0,$44,$C0,$B0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$94,$58,  0,$44,$C0,$C0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$94,$50,  0,$44,$C0,$D0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$94,$48,  0,$44,$C0,$E0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$92,$84; 51072
		dc.b   0,$44,$C0,$F0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$92,$10,  0,$44,$C1,  0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$91,$78,  0,$44,$C1,$10,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$90,$A6,  0,$44,$C1,$20,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$90,$1C; 51136
		dc.b   0,$44,$C1,$30,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$8F,$D4,  0,$44,$C1,$40,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$8E,$BE,  0,$44,$C1,$50,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$8E,$5C,  0,$44,$C1,$60,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$8D,$BE; 51200
		dc.b   0,$44,$C1,$70,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$8D,$2E,  0,$44,$C1,$80,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$87,$D4,  0,$44,$C1,$90,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$87,$C6,  0,$44,$C1,$A0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$87,$BA; 51264
		dc.b   0,$44,$C1,$B0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$87,$AC,  0,$44,$C1,$C0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$86,$DC,  0,$44,$C1,$D0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$86,$1E,  0,$44,$C1,$E0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$86,$14; 51328
		dc.b   0,$44,$C1,$F0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$85,$FC,  0,$44,$C2,  0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$85,$CA,  0,$44,$C2,$10,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$81,$DA,  0,$44,$C2,$20,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$81,$C4; 51392
		dc.b   0,$44,$C2,$30,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$81,$AE,  0,$44,$C2,$40,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$80,  6,  0,$44,$C2,$50,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$7C,$E6,  0,$44,$C2,$60,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$7C, $E; 51456
		dc.b   0,$44,$C2,$70,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$7B,$E2,  0,$44,$C2,$80,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$7B,$A4,  0,$44,$C2,$90,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$78,$DC,  0,$44,$C2,$A0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$78,$C2; 51520
		dc.b   0,$44,$C2,$B0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$75,$88,  0,$44,$C2,$C0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$75,$68,  0,$44,$C2,$D0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$75,$4C,  0,$44,$C2,$E0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$6B,$E6; 51584
		dc.b   0,$44,$C2,$F0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$65,$16,  0,$44,$C3,  0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$5A,$D6,  0,$44,$C3,$10,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$57,$BA,  0,$44,$C3,$20,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$50, $C; 51648
		dc.b   0,$44,$C3,$30,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$4F,$DA,  0,$44,$C3,$40,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$4F,$AE,  0,$44,$C3,$50,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$4D,$8C,  0,$44,$C3,$60,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$4D,$68; 51712
		dc.b   0,$44,$C3,$70,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$4D,$32,  0,$44,$C3,$80,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$4D,$16,  0,$44,$C3,$90,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$44,  6,  0,$44,$C3,$A0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$43,$A8; 51776
		dc.b   0,$44,$C3,$B0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$43, $C,  0,$44,$C3,$C0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$43,  8,  0,$44,$C3,$D0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$43,  4,  0,$44,$C3,$E0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$43,  0; 51840
		dc.b   0,$44,$C3,$F0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$42,$FC,  0,$44,$C4,  0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$42,$F8,  0,$44,$C4,$10,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$42,$F4,  0,$44,$C4,$20,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$42,$F0; 51904
		dc.b   0,$44,$C4,$30,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$42,$C2,  0,$44,$C4,$40,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$40,$D8,  0,$44,$C4,$50,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$3C,$8C,  0,$44,$C4,$60,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$3C,$74; 51968
		dc.b   0,$44,$C4,$70,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$3C,$5C,  0,$44,$C4,$80,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$3A,$96,  0,$44,$C4,$90,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$35,$DC,  0,$44,$C4,$A0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$35,$9E; 52032
		dc.b   0,$44,$C4,$B0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$32,$60,  0,$44,$C4,$C0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$32,$58,  0,$44,$C4,$D0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$24,$5A,  0,$44,$C4,$E0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$24,$52; 52096
		dc.b   0,$44,$C4,$F0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$24,$4A,  0,$44,$C5,  0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$24,$42,  0,$44,$C5,$10,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$24,$3A,  0,$44,$C5,$20,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$24,$32; 52160
		dc.b   0,$44,$C5,$30,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$24,$2A,  0,$44,$C5,$40,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$24,$22,  0,$44,$C5,$50,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$24,$1A,  0,$44,$C5,$60,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$24,$12; 52224
		dc.b   0,$44,$C5,$70,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$24, $A,  0,$44,$C5,$80,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$24,  2,  0,$44,$C5,$90,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$23,$FA,  0,$44,$C5,$A0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$23,$F2; 52288
		dc.b   0,$44,$C5,$B0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$23,$EA,  0,$44,$C5,$C0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$23,$E2,  0,$44,$C5,$D0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$23,$DA,  0,$44,$C5,$E0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$23,$D2; 52352
		dc.b   0,$44,$C5,$F0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$23,$CA,  0,$44,$C6,  0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$23,$C2,  0,$44,$C6,$10,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$23,$A8,  0,$44,$C6,$20,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$23,$8C; 52416
		dc.b   0,$44,$C6,$30,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$23,$74,  0,$44,$C6,$40,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$23,$58,  0,$44,$C6,$50,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$22,$E8,  0,$44,$C6,$60,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$22,$70; 52480
		dc.b   0,$44,$C6,$70,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$1E,$6A,  0,$44,$C6,$80,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$1E,$3C,  0,$44,$C6,$90,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$1E,$20,  0,$44,$C6,$A0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$1D,$FE; 52544
		dc.b   0,$44,$C6,$B0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$1D,$D4,  0,$44,$C6,$C0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$1D,$B2,  0,$44,$C6,$D0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$1D,$78,  0,$44,$C6,$E0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$1D,$70; 52608
		dc.b   0,$44,$C6,$F0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$14,$48,  0,$44,$C7,  0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$14,$36,  0,$44,$C7,$10,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$11,$98,  0,$44,$C7,$20,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$11,$8A; 52672
		dc.b   0,$44,$C7,$30,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  3,$92,  0,$44,$C7,$40,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$FC,  0,$44,$C7,$50,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$F8,  0,$44,$C7,$60,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$F4; 52736
		dc.b   0,$44,$C7,$70,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$F0,  0,$44,$C7,$80,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$EC,  0,$44,$C7,$90,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$E8,  0,$44,$C7,$A0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$E4; 52800
		dc.b   0,$44,$C7,$B0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$E0,  0,$44,$C7,$C0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$DC,  0,$44,$C7,$D0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$D8,  0,$44,$C7,$E0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$D4; 52864
		dc.b   0,$44,$C7,$F0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$D0,  0,$44,$C8,  0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$CC,  0,$44,$C8,$10,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$C8,  0,$44,$C8,$20,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$C4; 52928
		dc.b   0,$44,$C8,$30,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$C0,  0,$44,$C8,$40,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$BC,  0,$44,$C8,$50,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$B8,  0,$44,$C8,$60,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$B4; 52992
		dc.b   0,$44,$C8,$70,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$B0,  0,$44,$C8,$80,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$AC,  0,$44,$C8,$90,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$A8,  0,$44,$C8,$A0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$A4; 53056
		dc.b   0,$44,$C8,$B0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$A0,  0,$44,$C8,$C0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$9C,  0,$44,$C8,$D0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$98,  0,$44,$C8,$E0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$94; 53120
		dc.b   0,$44,$C8,$F0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$90,  0,$44,$C9,  0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$8C,  0,$44,$C9,$10,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$88,  0,$44,$C9,$20,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$84; 53184
		dc.b   0,$44,$C9,$30,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$80,  0,$44,$C9,$40,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$7C,  0,$44,$C9,$50,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$74,  0,$44,$C9,$60,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$6C; 53248
		dc.b   0,$44,$C9,$70,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$68,  0,$44,$C9,$80,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$64,  0,$44,$C9,$90,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$60,  0,$44,$C9,$A0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$5C; 53312
		dc.b   0,$44,$C9,$B0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$58,  0,$44,$C9,$C0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$54,  0,$44,$C9,$D0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$50,  0,$44,$C9,$E0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$4C; 53376
		dc.b   0,$44,$C9,$F0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$48,  0,$44,$CA,  0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$44,  0,$44,$CA,$10,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$40,  0,$44,$CA,$20,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$3C; 53440
		dc.b   0,$44,$CA,$30,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$38,  0,$44,$CA,$40,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$34,  0,$44,$CA,$50,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$30,  0,$44,$CA,$60,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$2C; 53504
		dc.b   0,$44,$CA,$70,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$28,  0,$44,$CA,$80,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$24,  0,$44,$CA,$90,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$20,  0,$44,$CA,$A0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$1C; 53568
		dc.b   0,$44,$CA,$B0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$18,  0,$44,$CA,$C0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$14,  0,$44,$CA,$D0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,$10,  0,$44,$CA,$E0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0, $C; 53632
		dc.b   0,$44,$CA,$F0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,  8,  0,  0,  0,  0,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,  0,  4,  0,$40,$E3,$44,  0,  0,  0,  2,$4E,$F9,  0,  0,$CF,$C2,  0,  0,  0,$40,$B1,$E4,  0,  0,  0,  2,$4E,$F9,  0,  0,$CF,$C2,  0,  0; 53696
		dc.b   0,$40,$92,$C8,  0,  0,  0,  2,$4E,$F9,  0,  0,$CF,$C2,  0,  0,  0,$40,$7F,$E0,  0,  0,  0,  3,$4E,$F9,  0,  0,$FD,$CC,$4E,$F9,  0,  0,$D2,$F0,  0,$40,$4F,$B0,  0,  0,  0,  2,$4E,$F9,  0,  0,$CF,$C2,  0,  0,  0,$40,$59,$C8,  0,  0,  0,  3,$4E,$F9,  0,  0; 53760
		dc.b $CF,$DE,$4E,$F9,  0,  0,$CF,$C2,  0,$40,$2E,$68,  0,  0,  0,  2,$4E,$F9,  0,  0,$CF,$C2,  0,  0,  0,$40,$39,$4C,  0,  0,  0,  3,$4E,$F9,  0,  0,$C7,$58,$4E,$F9,  0,  0,$C8,$8E,  0,$40,$48,  0,  0,  0,  0, $C,$4E,$F9,  0,  0,$C7,$58,$4E,$F9,  0,  0,$C8,$8E; 53824
		dc.b $4E,$F9,  0,  0,$C7,$AE,$4E,$F9,  0,  0,$DA,$C8,$4E,$F9,  0,  0,$C8,$9C,$4E,$F9,  0,  0,$2A,$F0,$4E,$F9,  0,  0,$C7,  6,$4E,$F9,  0,  0,$C7,$32,  0,$40,$1A,$54,  0,  0,  0,  9,$4E,$F9,  0,  0,$C8,$8E,$4E,$F9,  0,  0,$DA,$C8,$4E,$F9,  0,  0,$C8,$9C,$4E,$F9; 53888
		dc.b   0,  0,$C8,$1A,$4E,$F9,  0,  0,$C7,  6,$4E,$F9,  0,  0,$C7,$32,  0,$40,$28,$7C,  0,  0,  0,  6,$4E,$F9,  0,  0,$C7,$AE,$4E,$F9,  0,  0,$C8,$9C,$4E,$F9,  0,  0,$CF,$C2,$4E,$F9,  0,  0,$C7,$32,  0,$3F,$ED,$EC,  0,  0,  0,  6,$4E,$F9,  0,  0,$C7,$AE,$4E,$F9; 53952
		dc.b   0,  0,$C8,$9C,$4E,$F9,  0,  0,$C7,  6,$4E,$F9,  0,  0,$C7,$32,  0,$3F,$F4,$1C,  0,  0,  0,  5,$4E,$F9,  0,  0,$C7,$AE,$4E,$F9,  0,  0,$C8,$9C,$4E,$F9,  0,  0,$C7,$32,  0,  0,  0,$3F,$FD,$94,  0,  0,  0,  8,$4E,$F9,  0,  0,$C7,$58,$4E,$F9,  0,  0,$C8,$8E; 54016
		dc.b $4E,$F9,  0,  0,$C7,$AE,$4E,$F9,  0,  0,$C8,$9C,$4E,$F9,  0,  0,$C7,  6,  0,  0,  0,$40,  7,$48,  0,  0,  0,  6,$4E,$F9,  0,  0,$C8,$8E,$4E,$F9,  0,  0,$C8,$9C,$4E,$F9,  0,  0,$C8,$1A,$4E,$F9,  0,  0,$C7,$32,  0,$3F,$CE,$48,  0,  0,  0,  9,$4E,$F9,  0,  0; 54080
		dc.b $C7,$58,$4E,$F9,  0,  0,$C8,$8E,$4E,$F9,  0,  0,$C7,$AE,$4E,$F9,  0,  0,$C8,$9C,$4E,$F9,  0,  0,$C7,  6,$4E,$F9,  0,  0,$C7,$32,  0,$3F,$DF,  8,  0,  0,  0,  8,$4E,$F9,  0,  0,$C7,$58,$4E,$F9,  0,  0,$C8,$8E,$4E,$F9,  0,  0,$C8,$9C,$4E,$F9,  0,  0,$C7,  6; 54144
		dc.b $4E,$F9,  0,  0,$C7,$32,  0,  0,  0,$3F,$EB,$74,  0,  0,  0,  5,$4E,$F9,  0,  0,$C7,$AE,$4E,$F9,  0,  0,$C8,$9C,$4E,$F9,  0,  0,$C7,$32,  0,  0,  0,$3F,$AF,$3C,  0,  0,  0,  5,$4E,$F9,  0,  0,$C7,$AE,$4E,$F9,  0,  0,$C8,$9C,$4E,$F9,  0,  0,$C7,  6,  0,  0; 54208
		dc.b   0,$3F,$B6,$44,  0,  0,  0,  2,$4E,$F9,  0,  0,$C7,$58,  0,  0,  0,$3F,$A3,$B0,  0,  0,  0,  2,$4E,$F9,  0,  0,$2B,$16,  0,  0,  0,$3F,$3D,$1C,  0,  0,  0,  2,$4E,$F9,  0,  1,$8A,$82,  0,  0,  0,$3F,$1A,$E4,  0,  0,  0,  2,$4E,$F9,  0,  1,$8A,$82,  0,  0; 54272
		dc.b   0,$3B,$89,$B0,  0,  0,  0,  2,$4E,$F9,  0,  1,$9A,$3C,  0,  0,  0,  0,  0,  1,  0,  0,$11,$D6,  0,  0,  0,  1,  0,  0,  2,$52,  0,  0,  0,  1,  0,  0,  1,$5E,  0,  0,  0,  1,  0,  0,  8,$80,  0,  0,  0,  1,  0,  0,  2,$E4,  0,  0,  0,  1,  0,  0,  4,$82; 54336
		dc.b   0,  0,  0,  1,  0,  0,  2,$F4,  0,  0,  0,  1,  0,  0,  0,$FC,  0,  0,  0,  1,  0,  0,  2,$94,  0,  0,  0,  1,  0,  0,  9,  0,  0,  0,  0,  1,  0,  0,  2,$CA,  0,  0,  0,  1,  0,  0,  1,$58,  0,  0,  0,  1,  0,  0,  8,$7A,  0,  0,  0,  1,  0,  0,  2,$AA; 54400
		dc.b   0,  0,  0,  1,  0,  0,  2,$EE,  0,  0,  0,  1,  0,  0,  2,$8E,  0,  0,  0,  1,  0,  0,  8,$FA,  0,  0,  0,  1,  0,  0,$10,$2E,  0,  0,  0,  1,  0,  0,  0,$FA,  0,  0,  0,  1,  0,  0,  0,$F6,  0,  0,  0,  1,  0,  0,  7,$16,  0,  0,  0,  1,  0,  0,  7,$E4; 54464
		dc.b   0,  0,  0,  1,  0,  0,  2,$FE,  0,  0,  0,  1,  0,  0,  6,$A6,  0,  0,  0,  1,  0,  0, $A,$86,  0,  0,  0,  1,  0,  0,  4,$52,  0,  0,  0,  1,  0,  0,$12,$12,  0,  0,  0,  1,  0,  0,  3,$94,  0,  0,  0,  1,  0,  0,  2,$DE,  0,  0,  0,  1,  0,  0,  2,$88; 54528
		dc.b   0,  0,  0,  1,  0,  0,  8,$F4,  0,  0,  0,  1,  0,  0,  7,$DE,  0,  0,  0,  1,  0,  0,  3,$8E,  0,  0,  0,  1,  0,  0,  2,$C4,  0,  0,  0,  1,  0,  0,  2,$4C,  0,  0,  0,  1,  0,  0,  1,$52,  0,  0,  0,  1,  0,  0,  8,$74,  0,  0,  0,  1,  0,  0,  2,$D8; 54592
		dc.b   0,  0,  0,  1,  0,  0,  2,$A4,  0,  0,  0,  1,  0,  0,  4,$7C,  0,  0,  0,  1,  0,  0,  2,$E8,  0,  0,  0,  1,  0,  0,  0,$F0,  0,  0,  0,  1,  0,  0,  2,$82,  0,  0,  0,  1,  0,  0,  8,$EE,  0,  0,  0,  1,  0,  0,  2,$7C,  0,  0,  0,  1,  0,  0,  8,$E8; 54656
		dc.b   0,  0,  0,  1,  0,  0,  2,$BE,  0,  0,  0,  1,  0,  0,  2,$46,  0,  0,  0,  1,  0,  0,  8,$6E,  0,  0,  0,  1,  0,  0,  2,$9E,  0,  0,  0,  1,  0,  0,  4,$76,  0,  0,  0,  1,  0,  0,  2,$E2,  0,  0,  0,  1,  0,  0,  0,$EA,  0,  0,  0,  1,  0,  0,  8,$E2; 54720
		dc.b   0,  0,  0,  1,  0,  0,  1,$4C,  0,  0,  0,  1,  0,  0,  8,$68,  0,  0,  0,  1,  0,  0,  2,$D2,  0,  0,  0,  1,  0,  0,  2,$98,  0,  0,  0,  1,  0,  0,  2,$76,  0,  0,  0,  1,  0,  0,  8,$DC,  0,  0,  0,  1,  0,  0,  4,$10,  0,  0,  0,  1,  0,  0,  3,$42; 54784
		dc.b   0,  0,  0,  1,  0,  0,  1,$46,  0,  0,  0,  1,  0,  0,  8,$62,  0,  0,  0,  1,  0,  0,  2,$92,  0,  0,  0,  1,  0,  0,  8,$D6,  0,  0,  0,  1,  0,  0,  4, $A,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$6C,$8D,  0,  0,  3,$E9,  0,$3B, $D,$64; 54848
		dc.b   0,  0,  0,  0,  0,$45,  8,$F8,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$3B,  9,$98,  0,  0,  0,  0,  0,  0,  0,  0,  0,$40,$D1,$2C,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 54912
		dc.b   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$44,$D0,$34,  0,$44,$D0,$20,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  4,  3,$A8,  0,  0,  0,  0; 54976
		dc.b   2,  0,  0,  3,$61,$73,$65,$74,$74,$62,$6C,$31,$31,  0,  0,  0,  0,  0,  0,  8,  0,$44,$A7,$84,  0,$44,$D0,$4C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  4,  0,$96,  0,  0,  0,  0,  2,  0,  0,  3,$61,$73,$65,$74,$74,$62,$6C,$31,$30,  0,  0,  0,  0,  0,  0,  8; 55040
		dc.b   0,$44,$AF,$78,  0,$44,$D0,$78,  0,$40,$D1,$30,  0,$40,$D5,$18,  0, $B, $E,  8,  0,  0,  0,  0,  2,  0,  0,  2,$66,$62,$75,$74,$61,$63,$67,  0,  0,  0,  0,$16,  0,$44,$AA,$34,  0,$44,$D0,$A0,  0,$40,$D1,$30,  0,$40,$D5,$4C,  0, $B,  8,$BC,  0,  0,  0,  0; 55104
		dc.b   2,  0,  0,  2,$75,$73,$61,$67,$69,$63,$67,  0,  0,  0,  0,  9,  0,$44,$AC,$F8,  0,$44,$D0,$C8,  0,$40,$D1,$30,  0,$40,$D5,$7C,  0, $A,$F1, $A,  0,  0,  0,  0,  2,  0,  0,  2,$79,$61,$72,$61,$72,$65,$63,$67,  0,  0,  0, $A,  0,$44,$A7,$B0,  0,$44,$D0,$F0; 55168
		dc.b   0,$40,$D1,$30,  0,$40,$D5,$AC,  0, $A,$57,$E4,  0,  0,  0,  0,  2,  0,  0,  3,$6B,$65,$6D,$75,$72,$69,$30,$64,$63,$67,  0,  0,  0,  0,  0,$1C,  0,$44,$A8,$34,  0,$44,$D1,$1C,  0,$40,$D1,$30,  0,  0,  0,  0,  0, $A,$49,$F2,  0,  0,  0,  0,  2,  0,  0,  2; 55232
		dc.b $64,$6F,$6F,$72,$30,$30,$63,$67,  0,  0,  0,$1B,  0,$44,$D1,$54,  0,$44,$D1,$44,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$25,$3A,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$36,$36,  0,  0,  0,  0,  0,$13,  0,$44,$D1,$7C,  0,$44,$D1,$6C,  0,$40,$D1,$30; 55296
		dc.b   0,  0,  0,  0,  0,  9,$DF,$88,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$36,$36,  0,  0,  0,  0,  0,$13,  0,$44,$D1,$A4,  0,$44,$D1,$94,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$25,$20,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$36,$35,  0,  0; 55360
		dc.b   0,  0,  0,$13,  0,$44,$D1,$CC,  0,$44,$D1,$BC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DF,$80,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$36,$35,  0,  0,  0,  0,  0,$13,  0,$44,$D1,$F4,  0,$44,$D1,$E4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$25, $E; 55424
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$36,$34,  0,  0,  0,  0,  0,$13,  0,$44,$D2,$1C,  0,$44,$D2, $C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DF,$7A,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$36,$34,  0,  0,  0,  0,  0,$13,  0,$44,$D2,$44; 55488
		dc.b   0,$44,$D2,$34,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$24,$FC,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$36,$33,  0,  0,  0,  0,  0,$13,  0,$44,$D2,$6C,  0,$44,$D2,$5C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DF,$74,  0,  0,  0,  0,  2,  0,  0,  2; 55552
		dc.b $70,$6C,$77,$31,$36,$33,  0,  0,  0,  0,  0,$13,  0,$44,$D2,$94,  0,$44,$D2,$84,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$24,$E2,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$36,$32,  0,  0,  0,  0,  0,$13,  0,$44,$D2,$BC,  0,$44,$D2,$AC,  0,$40,$D1,$30; 55616
		dc.b   0,  0,  0,  0,  0,  9,$DF,$6C,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$36,$32,  0,  0,  0,  0,  0,$13,  0,$44,$D2,$E4,  0,$44,$D2,$D4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$24,$C8,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$36,$31,  0,  0; 55680
		dc.b   0,  0,  0,$13,  0,$44,$D3, $C,  0,$44,$D2,$FC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DF,$64,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$36,$31,  0,  0,  0,  0,  0,$13,  0,$44,$D3,$34,  0,$44,$D3,$24,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$24,$AE; 55744
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$36,$30,  0,  0,  0,  0,  0,$13,  0,$44,$D3,$5C,  0,$44,$D3,$4C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DF,$5C,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$36,$30,  0,  0,  0,  0,  0,$13,  0,$44,$D3,$84; 55808
		dc.b   0,$44,$D3,$74,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$24,$9C,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$35,$39,  0,  0,  0,  0,  0,$13,  0,$44,$D3,$AC,  0,$44,$D3,$9C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DF,$56,  0,  0,  0,  0,  2,  0,  0,  2; 55872
		dc.b $70,$6C,$77,$31,$35,$39,  0,  0,  0,  0,  0,$13,  0,$44,$D3,$D4,  0,$44,$D3,$C4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$24,$92,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$35,$38,  0,  0,  0,  0,  0,$13,  0,$44,$D3,$FC,  0,$44,$D3,$EC,  0,$40,$D1,$30; 55936
		dc.b   0,  0,  0,  0,  0,  9,$DF,$52,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$35,$38,  0,  0,  0,  0,  0,$13,  0,$44,$D4,$24,  0,$44,$D4,$14,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$24,$80,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$35,$37,  0,  0; 56000
		dc.b   0,  0,  0,$13,  0,$44,$D4,$4C,  0,$44,$D4,$3C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DF,$4C,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$35,$37,  0,  0,  0,  0,  0,$13,  0,$44,$D4,$74,  0,$44,$D4,$64,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$24,$66; 56064
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$35,$36,  0,  0,  0,  0,  0,$13,  0,$44,$D4,$9C,  0,$44,$D4,$8C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DF,$44,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$35,$36,  0,  0,  0,  0,  0,$13,  0,$44,$D4,$C4; 56128
		dc.b   0,$44,$D4,$B4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$24,$4C,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$35,$35,  0,  0,  0,  0,  0,$13,  0,$44,$D4,$EC,  0,$44,$D4,$DC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DF,$3C,  0,  0,  0,  0,  2,  0,  0,  2; 56192
		dc.b $70,$6C,$77,$31,$35,$35,  0,  0,  0,  0,  0,$13,  0,$44,$D5,$14,  0,$44,$D5,  4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$24,$32,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$35,$34,  0,  0,  0,  0,  0,$13,  0,$44,$D5,$3C,  0,$44,$D5,$2C,  0,$40,$D1,$30; 56256
		dc.b   0,  0,  0,  0,  0,  9,$DF,$34,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$35,$34,  0,  0,  0,  0,  0,$13,  0,$44,$D5,$64,  0,$44,$D5,$54,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$24,$10,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$35,$33,  0,  0; 56320
		dc.b   0,  0,  0,$13,  0,$44,$D5,$8C,  0,$44,$D5,$7C,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DF,$2A,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$35,$33,  0,  0,  0,  0,  0,$13,  0,$44,$D5,$B4,  0,$44,$D5,$A4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$23,$EE; 56384
		dc.b   0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$35,$32,  0,  0,  0,  0,  0,$13,  0,$44,$D6,$2C,  0,$44,$D5,$CC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DF,$20,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$35,$32,  0,  0,  0,  0,  0,$13,  0,$44,$D6,  4; 56448
		dc.b   0,$44,$D5,$F4,  0,$40,$D1,$30,  0,$40,$D5,$E4,  0, $B,$E5,$8C,  0,  0,  0,  0,  2,  0,  0,  2,$7A,$6F,$6E,$65,$30,$38,$63,$67,  0,  0,  0, $E,  0,$44,$AB,$3C,  0,$44,$D6,$1C,  0,$40,$D1,$30,  0,$40,$D6,$18,  0, $B,$21,$74,  0,  0,  0,  0,  2,  0,  0,  2; 56512
		dc.b $7A,$6F,$6E,$65,$30,$30,$63,$67,  0,  0,  0, $E,  0,$44,$D6,$54,  0,$44,$D6,$44,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$23,$D4,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$35,$31,  0,  0,  0,  0,  0,$13,  0,$44,$D6,$7C,  0,$44,$D6,$6C,  0,$40,$D1,$30; 56576
		dc.b   0,  0,  0,  0,  0,  9,$DF,$18,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$35,$31,  0,  0,  0,  0,  0,$13,  0,$44,$D6,$A4,  0,$44,$D6,$94,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$23,$B2,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$35,$30,  0,  0; 56640
		dc.b   0,  0,  0,$13,  0,$44,$D7,$20,  0,$44,$D6,$BC,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DF, $E,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$35,$30,  0,  0,  0,  0,  0,$13,  0,$44,$61,$1C,  0,$44,$D6,$E4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  5,  5,$38; 56704
		dc.b   0,  0,  0,  0,  2,  0,  0,  3,$72,$69,$6E,$67,$61,$63,$74,$38,$30,  0,  0,  0,  0,  0,  0,  2,  0,$44,$AC,$D0,  0,$44,$D7,$10,  0,$40,$D1,$30,  0,$40,$D6,$48,  0, $A,$8E,$F8,  0,  0,  0,  0,  2,  0,  0,  2,$73,$6E,$61,$69,$6C,$63,$67,  0,  0,  0,  0, $B; 56768
		dc.b   0,$44,$D7,$48,  0,$44,$D7,$38,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$23,$98,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$34,$39,  0,  0,  0,  0,  0,$13,  0,$44,$D7,$70,  0,$44,$D7,$60,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DF,  6,  0,  0,  0,  0; 56832
		dc.b   2,  0,  0,  2,$70,$6C,$77,$31,$34,$39,  0,  0,  0,  0,  0,$13,  0,$44,$D7,$98,  0,$44,$D7,$88,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$23,$7E,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$34,$38,  0,  0,  0,  0,  0,$13,  0,$44,$D7,$C0,  0,$44,$D7,$B0; 56896
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DF,  6,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$34,$38,  0,  0,  0,  0,  0,$13,  0,$44,$D7,$E8,  0,$44,$D7,$D8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$23,$5C,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31; 56960
		dc.b $34,$37,  0,  0,  0,  0,  0,$13,  0,$44,$D8,$10,  0,$44,$D8,  0,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$F6,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$34,$37,  0,  0,  0,  0,  0,$13,  0,$44,$D8,$38,  0,$44,$D8,$28,  0,$40,$D1,$30,  0,  0,  0,  0; 57024
		dc.b   0,  9,$23,$3A,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$34,$36,  0,  0,  0,  0,  0,$13,  0,$44,$D8,$60,  0,$44,$D8,$50,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DF,  0,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$34,$36,  0,  0,  0,  0,  0,$13; 57088
		dc.b   0,$44,$D8,$88,  0,$44,$D8,$78,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$23,$18,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$34,$35,  0,  0,  0,  0,  0,$13,  0,$44,$D8,$B0,  0,$44,$D8,$A0,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$F6,  0,  0,  0,  0; 57152
		dc.b   2,  0,  0,  2,$70,$6C,$77,$31,$34,$35,  0,  0,  0,  0,  0,$13,  0,$44,$D8,$D8,  0,$44,$D8,$C8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$23,  6,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$34,$34,  0,  0,  0,  0,  0,$13,  0,$44,$D9,  0,  0,$44,$D8,$F0; 57216
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$F0,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$34,$34,  0,  0,  0,  0,  0,$13,  0,$44,$D9,$28,  0,$44,$D9,$18,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$22,$F4,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31; 57280
		dc.b $34,$33,  0,  0,  0,  0,  0,$13,  0,$44,$D9,$50,  0,$44,$D9,$40,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$EA,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$34,$33,  0,  0,  0,  0,  0,$13,  0,$44,$D9,$78,  0,$44,$D9,$68,  0,$40,$D1,$30,  0,  0,  0,  0; 57344
		dc.b   0,  9,$22,$E2,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$34,$32,  0,  0,  0,  0,  0,$13,  0,$44,$D9,$A0,  0,$44,$D9,$90,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$E4,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$34,$32,  0,  0,  0,  0,  0,$13; 57408
		dc.b   0,$44,$D9,$C8,  0,$44,$D9,$B8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$22,$D0,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$34,$31,  0,  0,  0,  0,  0,$13,  0,$44,$D9,$F0,  0,$44,$D9,$E0,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$DE,  0,  0,  0,  0; 57472
		dc.b   2,  0,  0,  2,$70,$6C,$77,$31,$34,$31,  0,  0,  0,  0,  0,$13,  0,$44,$DA,$18,  0,$44,$DA,  8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$22,$B6,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$34,$30,  0,  0,  0,  0,  0,$13,  0,$44,$DA,$40,  0,$44,$DA,$30; 57536
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$D6,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$34,$30,  0,  0,  0,  0,  0,$13,  0,$44,$DA,$68,  0,$44,$DA,$58,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$22,$9C,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31; 57600
		dc.b $33,$39,  0,  0,  0,  0,  0,$13,  0,$44,$DA,$90,  0,$44,$DA,$80,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$CE,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$33,$39,  0,  0,  0,  0,  0,$13,  0,$44,$DA,$B8,  0,$44,$DA,$A8,  0,$40,$D1,$30,  0,  0,  0,  0; 57664
		dc.b   0,  9,$22,$8A,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$33,$38,  0,  0,  0,  0,  0,$13,  0,$44,$DA,$E0,  0,$44,$DA,$D0,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$C8,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$33,$38,  0,  0,  0,  0,  0,$13; 57728
		dc.b   0,$44,$DB,  8,  0,$44,$DA,$F8,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$22,$68,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$33,$37,  0,  0,  0,  0,  0,$13,  0,$44,$DB,$30,  0,$44,$DB,$20,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$BE,  0,  0,  0,  0; 57792
		dc.b   2,  0,  0,  2,$70,$6C,$77,$31,$33,$37,  0,  0,  0,  0,  0,$13,  0,$44,$DB,$58,  0,$44,$DB,$48,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$22,$56,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$79,$31,$33,$36,  0,  0,  0,  0,  0,$13,  0,$44,$DB,$80,  0,$44,$DB,$70; 57856
		dc.b   0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$DE,$B8,  0,  0,  0,  0,  2,  0,  0,  2,$70,$6C,$77,$31,$33,$36,  0,  0,  0,  0,  0,$13,  0,$44,$9B,$C4,  0,$44,$9B,$B4,  0,$40,$D1,$30,  0,  0,  0,  0,  0,  9,$22,$44,  0,  0,  0,  0,  0,$5B,$F2,  0,  0,  9,$54,$60; 57920
		dc.b   0,  0,  0,  4,  0,  0,  0,  0,  0,$44,$DB,$B8,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0, $E,$7E,  0,$44,$DB,$C8,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0, $C,$EC,  0,$44,$DB,$D8,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$AE,$F6,  0,$44,$DB,$E8,  0,  0,  3,$EC; 57984
		dc.b   0,  0,  0,  0,  0,  1,$AE,$4C,  0,$44,$DB,$F8,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$AD,$88,  0,$44,$DC,  8,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$AE,$7C,  0,$44,$DC,$18,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$AE,$74,  0,$44,$DC,$28,  0,  0,  3,$EC; 58048
		dc.b   0,  0,  0,  0,  0,  1,$AE,$6C,  0,$44,$DC,$38,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$AE,$64,  0,$44,$DC,$48,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$AE,$5C,  0,$44,$DC,$58,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C5,$D6,  0,$44,$DC,$68,  0,  0,  3,$EC; 58112
		dc.b   0,  0,  0,  0,  0,  0,$C5,$DE,  0,$44,$DC,$78,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$86,$F8,  0,$44,$DC,$88,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$96,$52,  0,$44,$DC,$98,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$96,$30,  0,$44,$DC,$A8,  0,  0,  3,$EC; 58176
		dc.b   0,  0,  0,  0,  0,  1,$94,$6A,  0,$44,$DC,$B8,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$AE,$1C,  0,$44,$DC,$C8,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$AD,$C0,  0,$44,$DC,$D8,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C4,$DE,  0,$44,$DC,$E8,  0,  0,  3,$EC; 58240
		dc.b   0,  0,  0,  0,  0,  1,$90,$DE,  0,$44,$DC,$F8,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$19,$1E,  0,$44,$DD,  8,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$18,$F4,  0,$44,$DD,$18,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$18,$8E,  0,$44,$DD,$28,  0,  0,  3,$EC; 58304
		dc.b   0,  0,  0,  0,  0,  1,$17,$9E,  0,$44,$DD,$38,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$32,$B0,  0,$44,$DD,$48,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$32,$7C,  0,$44,$DD,$58,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$32,$4E,  0,$44,$DD,$68,  0,  0,  3,$EC; 58368
		dc.b   0,  0,  0,  0,  0,  1,$32,$2E,  0,$44,$DD,$78,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$31,$EC,  0,$44,$DD,$88,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$30,$C4,  0,$44,$DD,$98,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$5F,$76,  0,$44,$DD,$A8,  0,  0,  3,$EC; 58432
		dc.b   0,  0,  0,  0,  0,  1,$71,$94,  0,$44,$DD,$B8,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$7E,$5C,  0,$44,$DD,$C8,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$86,$B6,  0,$44,$DD,$D8,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$86,$1E,  0,$44,$DD,$E8,  0,  0,  3,$EC; 58496
		dc.b   0,  0,  0,  0,  0,  1,$AE,$44,  0,$44,$DD,$F8,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$AE,$3C,  0,$44,$DE,  8,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C5,$9E,  0,$44,$DE,$18,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C5,$A6,  0,$44,$DE,$28,  0,  0,  3,$EC; 58560
		dc.b   0,  0,  0,  0,  0,  1,$84,$B2,  0,$44,$DE,$38,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C5,  2,  0,$44,$DE,$48,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$8B,$4E,  0,$44,$DE,$58,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$F0,$42,  0,$44,$DE,$68,  0,  0,  3,$EC; 58624
		dc.b   0,  0,  0,  0,  0,  0,$F0,$4A,  0,$44,$DE,$78,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C6,$B2,  0,$44,$DE,$88,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  0,$C4,$FE,  0,$44,$DE,$98,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$1C,$1A,  0,$44,$DE,$A8,  0,  0,  3,$EC; 58688
		dc.b   0,  0,  0,  0,  0,  1,$1B,$8E,  0,$44,$DE,$B8,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$1A,$C2,  0,$44,$DE,$C8,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$16, $A,  0,$44,$DE,$D8,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$15,$D8,  0,$44,$DE,$E8,  0,  0,  3,$EC; 58752
		dc.b   0,  0,  0,  0,  0,  1,$15,$68,  0,$44,$DE,$F8,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$32,$CC,  0,$44,$DF,  8,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$31,$A8,  0,$44,$DF,$18,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$30,$D4,  0,$44,$DF,$28,  0,  0,  3,$EC; 58816
		dc.b   0,  0,  0,  0,  0,  1,$36,$F8,  0,$44,$DF,$38,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$4B,$A4,  0,$44,$DF,$48,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$4D,$FC,  0,$44,$DF,$58,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$4F,$5A,  0,$44,$DF,$68,  0,  0,  3,$EC; 58880
		dc.b   0,  0,  0,  0,  0,  1,$57,$E0,  0,$44,$DF,$78,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$5A,$C8,  0,$44,$DF,$88,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$5D,$7C,  0,$44,$DF,$98,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$62,  4,  0,$44,$DF,$A8,  0,  0,  3,$EC; 58944
		dc.b   0,  0,  0,  0,  0,  1,$64,$F8,  0,$44,$DF,$B8,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$65,$F8,  0,$44,$DF,$C8,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$68,$8A,  0,$44,$DF,$D8,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$71,$8E,  0,$44,$DF,$E8,  0,  0,  3,$EC; 59008
		dc.b   0,  0,  0,  0,  0,  1,$73,$3C,  0,$44,$DF,$F8,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$72,$F4,  0,$44,$E0,  8,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$80,$A2,  0,$44,$E0,$18,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$7D,$76,  0,$44,$E0,$28,  0,  0,  3,$EC; 59072
		dc.b   0,  0,  0,  0,  0,  1,$85,$B0,  0,$44,$E0,$38,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$39,$7E,  0,$44,$E0,$48,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$59,$C4,  0,$44,$E0,$58,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$68,$84,  0,$44,$E0,$68,  0,  0,  3,$EC; 59136
		dc.b   0,  0,  0,  0,  0,  1,$6F,$98,  0,$44,$E0,$78,  0,  0,  3,$EC,  0,  0,  0,  0,  0,  1,$6F,$3E; 59200
RingPos_Index:	dc.w RingPos_GHZ1-RingPos_Index; 0 ; DATA XREF:	RingPosLoad2+1Ao
					; ROM:RingPos_Indexo ...
		dc.w RingPos_GHZ2-RingPos_Index; 1
		dc.w RingPos_GHZ3-RingPos_Index; 2
		dc.w RingPos_GHZ1-RingPos_Index; 3
		dc.w RingPos_LZ1-RingPos_Index;	4
		dc.w RingPos_LZ2-RingPos_Index;	5
		dc.w RingPos_LZ3-RingPos_Index;	6
		dc.w RingPos_LZ1-RingPos_Index;	7
		dc.w RingPos_CPZ1-RingPos_Index; 8
		dc.w RingPos_GHZ2-RingPos_Index; 9
		dc.w RingPos_GHZ3-RingPos_Index; 10
		dc.w RingPos_GHZ1-RingPos_Index; 11
		dc.w RingPos_EHZ1-RingPos_Index; 12
		dc.w RingPos_EHZ2-RingPos_Index; 13
		dc.w RingPos_HTZ1-RingPos_Index; 14
		dc.w RingPos_HTZ2-RingPos_Index; 15
		dc.w RingPos_HPZ1-RingPos_Index; 16
		dc.w RingPos_GHZ2-RingPos_Index; 17
		dc.w RingPos_GHZ3-RingPos_Index; 18
		dc.w RingPos_GHZ1-RingPos_Index; 19
		dc.w RingPos_HTZ1-RingPos_Index; 20
		dc.w RingPos_HTZ2-RingPos_Index; 21
		dc.w RingPos_LZ3-RingPos_Index;	22
		dc.w RingPos_LZ1-RingPos_Index;	23
RingPos_GHZ1:	dc.w  $144,$2360	; 0 ; DATA XREF: ROM:RingPos_Indexo
		dc.w  $334,$D22C	; 2
		dc.w  $46C,$4320	; 4
		dc.w  $680, $387	; 6
		dc.w  $6A0, $397	; 8
		dc.w  $6C0, $3A5	; 10
		dc.w  $6E3, $3B0	; 12
		dc.w  $70B, $3B3	; 14
		dc.w  $737, $3AF	; 16
		dc.w  $75B, $392	; 18
		dc.w  $9C4,$12C0	; 20
		dc.w  $B94,$12D0	; 22
		dc.w  $D50, $2B6	; 24
		dc.w  $D70, $2A9	; 26
		dc.w  $D92, $297	; 28
		dc.w  $DB4, $287	; 30
		dc.w  $DDA, $277	; 32
		dc.w  $EB1, $211	; 34
		dc.w  $ED2, $20A	; 36
		dc.w  $EF5, $203	; 38
		dc.w  $F1A, $205	; 40
		dc.w  $F3F, $209	; 42
		dc.w  $F66, $208	; 44
		dc.w  $F88,$22D8	; 46
		dc.w $1158,$232C	; 48
		dc.w $1220,$232C	; 50
		dc.w $125C, $23E	; 52
		dc.w $1280, $249	; 54
		dc.w $12A2, $259	; 56
		dc.w $12C3, $269	; 58
		dc.w $12EA, $271	; 60
		dc.w $153C, $260	; 62
		dc.w $154E, $230	; 64
		dc.w $1580, $21D	; 66
		dc.w $15AF, $230	; 68
		dc.w $15C3, $260	; 70
		dc.w $16E4, $1B5	; 72
		dc.w $170C, $1B5	; 74
		dc.w $1734, $1AB	; 76
		dc.w $175B, $19C	; 78
		dc.w $1784, $189	; 80
		dc.w $17A6, $179	; 82
		dc.w $17E0, $174	; 84
		dc.w $180C, $174	; 86
		dc.w $1820,$6074	; 88
		dc.w $183C, $176	; 90
		dc.w $186C, $178	; 92
		dc.w $189C, $17A	; 94
		dc.w $18C8,$6074	; 96
		dc.w $18CC, $174	; 98
		dc.w $18FC, $174	; 100
		dc.w $192C, $175	; 102
		dc.w $1950,$4370	; 104
		dc.w $195C, $17A	; 106
		dc.w $1970,$5074	; 108
		dc.w $198C, $17B	; 110
		dc.w $19BC, $176	; 112
		dc.w $19EC, $174	; 114
		dc.w $1D58,$6268	; 116
		dc.w $1D64,$6258	; 118
		dc.w $1D70,$5248	; 120
		dc.w $1D7C,$4238	; 122
		dc.w $1D88,$3228	; 124
		dc.w $1E00, $268	; 126
		dc.w $1F64,$5480	; 128
		dc.w $1F70,$42B4	; 130
		dc.w $2135, $374	; 132
		dc.w $2158, $37D	; 134
		dc.w $217A, $388	; 136
		dc.w $219C, $397	; 138
		dc.w $21BE, $3A8	; 140
		dc.w $21E2, $3B1	; 142
		dc.w $2342, $475	; 144
		dc.w $2367, $47E	; 146
		dc.w $2386, $48D	; 148
		dc.w $23A5, $49D	; 150
		dc.w $23C6, $4AE	; 152
		dc.w $23EC, $4B6	; 154
		dc.w $2414, $4B6	; 156
		dc.w $243A, $4B6	; 158
		dc.w $2461, $4B6	; 160
		dc.w $2486, $4B5	; 162
		dc.w $FFFF		; 164
RingPos_GHZ2:	dc.w  $180,$30BF	; 0 ; DATA XREF: ROM:RingPos_Indexo
		dc.w  $2F0,$C058	; 2
		dc.w  $564,$5268	; 4
		dc.w  $570,$4100	; 6
		dc.w  $860, $1A1	; 8
		dc.w  $86A, $1DD	; 10
		dc.w  $874,$A334	; 12
		dc.w  $886, $20D	; 14
		dc.w  $8B4, $229	; 16
		dc.w  $8C7, $2AD	; 18
		dc.w  $8E8, $230	; 20
		dc.w  $8EA, $2B7	; 22
		dc.w  $912, $2B5	; 24
		dc.w  $91C, $229	; 26
		dc.w  $93D, $2AE	; 28
		dc.w  $948, $20D	; 30
		dc.w  $95B, $293	; 32
		dc.w  $960,$8240	; 34
		dc.w  $960,$826B	; 36
		dc.w  $966, $1DD	; 38
		dc.w  $977, $1A1	; 40
		dc.w  $B90, $218	; 42
		dc.w  $B90, $240	; 44
		dc.w  $B91, $268	; 46
		dc.w  $B98, $290	; 48
		dc.w  $BB8, $2AE	; 50
		dc.w  $BE8, $2B5	; 52
		dc.w  $C19, $2B5	; 54
		dc.w  $D18,$31F0	; 56
		dc.w  $D24,$21E0	; 58
		dc.w  $D30,$11D0	; 60
		dc.w  $D3C, $1C0	; 62
		dc.w  $D3D, $260	; 64
		dc.w  $D44, $23E	; 66
		dc.w  $D44, $282	; 68
		dc.w  $D5C, $223	; 70
		dc.w  $D80, $21C	; 72
		dc.w  $DA0,$31F0	; 74
		dc.w  $DA0, $223	; 76
		dc.w  $DAC,$21E0	; 78
		dc.w  $DB8,$11D0	; 80
		dc.w  $DBC, $23E	; 82
		dc.w  $DBC, $282	; 84
		dc.w  $DC4, $1C0	; 86
		dc.w  $DC4, $260	; 88
		dc.w  $F00, $2B4	; 90
		dc.w  $F28, $2B4	; 92
		dc.w  $F4D, $2A6	; 94
		dc.w  $F62, $286	; 96
		dc.w  $F67, $261	; 98
		dc.w $1054,$1230	; 100
		dc.w $10D4,$1210	; 102
		dc.w $1194,$1230	; 104
		dc.w $1214,$1218	; 106
		dc.w $1294,$1218	; 108
		dc.w $1354,$1218	; 110
		dc.w $13D4,$1230	; 112
		dc.w $1518, $2B4	; 114
		dc.w $1542, $2AA	; 116
		dc.w $1568, $298	; 118
		dc.w $158E, $286	; 120
		dc.w $15BB, $277	; 122
		dc.w $15C4,$904C	; 124
		dc.w $15D4,$D040	; 126
		dc.w $15E4,$904C	; 128
		dc.w $1864,$51C0	; 130
		dc.w $198F, $218	; 132
		dc.w $198F, $23D	; 134
		dc.w $198F, $260	; 136
		dc.w $1994, $285	; 138
		dc.w $19A7, $2A3	; 140
		dc.w $19C8, $2B4	; 142
		dc.w $19F4, $2B5	; 144
		dc.w $1A1D, $2B6	; 146
		dc.w $FFFF		; 148
RingPos_GHZ3:	dc.w  $350, $372	; 0 ; DATA XREF: ROM:RingPos_Indexo
		dc.w  $374, $36A	; 2
		dc.w  $398, $35E	; 4
		dc.w  $3BC, $34D	; 6
		dc.w  $3E0, $33A	; 8
		dc.w  $408, $334	; 10
		dc.w  $420,$5258	; 12
		dc.w  $566, $37D	; 14
		dc.w  $584, $38C	; 16
		dc.w  $5A2, $39C	; 18
		dc.w  $5C4, $3AC	; 20
		dc.w  $5E8, $3B6	; 22
		dc.w  $648, $294	; 24
		dc.w  $66C, $28C	; 26
		dc.w  $690, $282	; 28
		dc.w  $6B8, $274	; 30
		dc.w  $6E8, $272	; 32
		dc.w  $716, $274	; 34
		dc.w  $745, $27E	; 36
		dc.w  $828,$5201	; 38
		dc.w  $920,$5250	; 40
		dc.w  $B38, $272	; 42
		dc.w  $B60, $27E	; 44
		dc.w  $B8A, $28E	; 46
		dc.w  $BB0, $2A0	; 48
		dc.w  $BDA, $2AD	; 50
		dc.w  $C09, $2B3	; 52
		dc.w  $C38,$6570	; 54
		dc.w  $CE0,$2570	; 56
		dc.w  $D20,$5140	; 58
		dc.w  $D20, $2B0	; 60
		dc.w  $D47, $2A7	; 62
		dc.w  $D68, $297	; 64
		dc.w  $D8D, $284	; 66
		dc.w  $DBC, $275	; 68
		dc.w  $DE8, $274	; 70
		dc.w  $F48,$A490	; 72
		dc.w $103C, $360	; 74
		dc.w $1040, $345	; 76
		dc.w $1040, $37C	; 78
		dc.w $104F, $32F	; 80
		dc.w $1064, $320	; 82
		dc.w $107E, $31C	; 84
		dc.w $1098, $320	; 86
		dc.w $10AF, $32F	; 88
		dc.w $10C0, $345	; 90
		dc.w $10C0, $37C	; 92
		dc.w $10C4, $360	; 94
		dc.w $1250, $372	; 96
		dc.w $1274, $36A	; 98
		dc.w $1298, $35E	; 100
		dc.w $12B8, $34E	; 102
		dc.w $12D8, $33E	; 104
		dc.w $175C, $37F	; 106
		dc.w $177E, $38A	; 108
		dc.w $179F, $39B	; 110
		dc.w $17C0, $3A9	; 112
		dc.w $17E6, $3B3	; 114
		dc.w $194C,$5398	; 116
		dc.w $19C4,$5384	; 118
		dc.w $1A3C,$5398	; 120
		dc.w $1E20, $3B8	; 122
		dc.w $1E48, $3B9	; 124
		dc.w $1E70, $3AA	; 126
		dc.w $1E98, $397	; 128
		dc.w $1EC0, $384	; 130
		dc.w $1EE6, $378	; 132
		dc.w $1F11, $375	; 134
		dc.w $2224,$C250	; 136
		dc.w $22DB, $3AF	; 138
		dc.w $2300, $3B5	; 140
		dc.w $2328, $3B4	; 142
		dc.w $234C, $3A6	; 144
		dc.w $2363, $385	; 146
		dc.w $FFFF		; 148
RingPos_LZ1:	dc.w   $98,$2248	; 0 ; DATA XREF: ROM:RingPos_Indexo
		dc.w  $250, $238	; 2
		dc.w  $268,$2228	; 4
		dc.w  $2B0, $238	; 6
		dc.w  $350, $238	; 8
		dc.w  $368,$2228	; 10
		dc.w  $3B0, $238	; 12
		dc.w  $450, $238	; 14
		dc.w  $468,$2228	; 16
		dc.w  $4B0, $238	; 18
		dc.w  $798,$1150	; 20
		dc.w  $870,$81E8	; 22
		dc.w  $888,$8200	; 24
		dc.w  $8A0,$8218	; 26
		dc.w  $8B8,$8230	; 28
		dc.w  $8D7,$8248	; 30
		dc.w  $958,$1240	; 32
		dc.w  $998,$1258	; 34
		dc.w  $C14,$13F0	; 36
		dc.w  $C94,$13F0	; 38
		dc.w  $D14,$13F0	; 40
		dc.w  $D94,$13F0	; 42
		dc.w  $E70,$82E8	; 44
		dc.w  $E88,$8300	; 46
		dc.w  $EA0,$8318	; 48
		dc.w  $EB8,$8330	; 50
		dc.w  $ED8,$8348	; 52
		dc.w $1008,$3550	; 54
		dc.w $1294,$1268	; 56
		dc.w $12D4,$125C	; 58
		dc.w $1310,$1250	; 60
		dc.w $1468,$2258	; 62
		dc.w $14D4,$1220	; 64
		dc.w $1554,$1260	; 66
		dc.w $16A8,$2298	; 68
		dc.w $FFFF		; 70
RingPos_LZ2:	dc.w  $154,$1258	; 0 ; DATA XREF: ROM:RingPos_Indexo
		dc.w  $388,$25D4	; 2
		dc.w  $488,$25D4	; 4
		dc.w  $550,$430C	; 6
		dc.w  $618,$2590	; 8
		dc.w  $634,$1354	; 10
		dc.w  $7C8,$24F4	; 12
		dc.w  $A14,$126C	; 14
		dc.w  $A68,$2358	; 16
		dc.w  $AD4,$126C	; 18
		dc.w  $B54,$11FC	; 20
		dc.w  $BD4,$11AC	; 22
		dc.w  $C08,$2414	; 24
		dc.w  $C54,$116C	; 26
		dc.w  $D08,$2414	; 28
		dc.w $1108,$3490	; 30
		dc.w $1110, $2B4	; 32
		dc.w $1130, $2BB	; 34
		dc.w $114D, $2C9	; 36
		dc.w $1162, $2E0	; 38
		dc.w $1178,$25A0	; 40
		dc.w $1179, $2F8	; 42
		dc.w $11F8,$25A0	; 44
		dc.w $FFFF		; 46
RingPos_LZ3:	dc.w  $154,$1130	; 0 ; DATA XREF: ROM:RingPos_Indexo
		dc.w  $338,$36A8	; 2
		dc.w  $3F0,$46A8	; 4
		dc.w  $4C8,$46A8	; 6
		dc.w  $530, $1B8	; 8
		dc.w  $554, $1CE	; 10
		dc.w  $570, $1EC	; 12
		dc.w  $58C, $208	; 14
		dc.w  $5AB, $225	; 16
		dc.w  $5CA, $243	; 18
		dc.w  $5F4, $253	; 20
		dc.w  $618,$2454	; 22
		dc.w  $670, $414	; 24
		dc.w  $690, $3D4	; 26
		dc.w  $6B0, $3B4	; 28
		dc.w  $6D4,$1394	; 30
		dc.w  $754,$15D4	; 32
		dc.w  $7E8,$25D4	; 34
		dc.w  $F94,$16F2	; 36
		dc.w  $FD4,$16A0	; 38
		dc.w $1008,$2514	; 40
		dc.w $1014,$16F2	; 42
		dc.w $1094,$16F2	; 44
		dc.w $10D4,$16A0	; 46
		dc.w $1108,$2514	; 48
		dc.w $1208,$2514	; 50
		dc.w $13E8,$22A8	; 52
		dc.w $1450,$4710	; 54
		dc.w $1468,$2670	; 56
		dc.w $14B8,$24F4	; 58
		dc.w $1518,$2752	; 60
		dc.w $FFFF		; 62
RingPos_HPZ1:	dc.w  $2B0,$3178	; 0 ; DATA XREF: ROM:RingPos_Indexo
		dc.w  $3E0,$2170	; 2
		dc.w  $528,$2148	; 4
		dc.w  $628,$3128	; 6
		dc.w  $6C0,$D1A8	; 8
		dc.w  $614,$4270	; 10
		dc.w  $5C0,$C2C0	; 12
		dc.w  $50E,$4370	; 14
		dc.w  $4C0,$F3BC	; 16
		dc.w  $4C0,$F47C	; 18
		dc.w  $530,$857C	; 20
		dc.w  $550,$8584	; 22
		dc.w  $570,$858C	; 24
		dc.w  $590,$8594	; 26
		dc.w  $5B0,$859C	; 28
		dc.w  $5D0,$85A4	; 30
		dc.w  $5F0,$85AC	; 32
		dc.w  $6DC,$2568	; 34
		dc.w  $8A8,$2568	; 36
		dc.w  $928,$2548	; 38
		dc.w  $9A8,$3520	; 40
		dc.w  $AF0, $4D0	; 42
		dc.w  $AF0, $4F4	; 44
		dc.w  $AEC, $518	; 46
		dc.w  $ADF, $538	; 48
		dc.w  $AC6, $553	; 50
		dc.w  $AA8, $566	; 52
		dc.w  $A82, $56F	; 54
		dc.w  $A5D, $570	; 56
		dc.w  $710, $380	; 58
		dc.w  $718, $3A8	; 60
		dc.w  $718, $358	; 62
		dc.w  $730, $337	; 64
		dc.w  $730, $3CB	; 66
		dc.w  $754, $3E8	; 68
		dc.w  $754, $318	; 70
		dc.w  $77C, $310	; 72
		dc.w  $77C, $3F0	; 74
		dc.w  $908,$3318	; 76
		dc.w  $AB4,$3318	; 78
		dc.w  $BF1, $306	; 80
		dc.w  $BE8, $32C	; 82
		dc.w  $BD4, $34B	; 84
		dc.w  $BB6, $364	; 86
		dc.w  $B90, $370	; 88
		dc.w  $F90, $370	; 90
		dc.w  $FB8, $378	; 92
		dc.w  $FDC, $388	; 94
		dc.w  $FFC, $3A2	; 96
		dc.w $1010, $3C6	; 98
		dc.w $101C, $3EC	; 100
		dc.w  $E88,$2450	; 102
		dc.w  $DB8,$3460	; 104
		dc.w  $E00,$2510	; 106
		dc.w  $E5A,$1530	; 108
		dc.w  $E96,$1550	; 110
		dc.w $11F0, $448	; 112
		dc.w $11F0, $468	; 114
		dc.w $11F0, $488	; 116
		dc.w $11E8, $4A8	; 118
		dc.w $11BE, $4DC	; 120
		dc.w $11A0, $4EB	; 122
		dc.w $11D8, $4C6	; 124
		dc.w $1180, $4F0	; 126
		dc.w  $F68,$2528	; 128
		dc.w $1100,$24C8	; 130
		dc.w $1230,$23E8	; 132
		dc.w $1300,$33A0	; 134
		dc.w $14D8,$33A0	; 136
		dc.w $1648,$23B0	; 138
		dc.w $16A8,$23E8	; 140
		dc.w $172C,$43D4	; 142
		dc.w $132C,$3498	; 144
		dc.w $1494,$34A0	; 146
		dc.w  $7F0,$2328	; 148
		dc.w $1948,$21B8	; 150
		dc.w $1988,$2138	; 152
		dc.w $19C8,$20B8	; 154
		dc.w $1A08,$2038	; 156
		dc.w $1A48,$27B8	; 158
		dc.w $1A88,$2738	; 160
		dc.w $1AC8,$26B8	; 162
		dc.w $1B08,$2638	; 164
		dc.w $1B48,$25B8	; 166
		dc.w $1B88,$2538	; 168
		dc.w $1C68,$2518	; 170
		dc.w $1E70,$2518	; 172
		dc.w $2070,$2518	; 174
		dc.w $1D68,$2558	; 176
		dc.w $1F68,$2558	; 178
		dc.w  $AC8,$2450	; 180
		dc.w  $998,$2428	; 182
		dc.w $FFFF		; 184

RingPos_EHZ1:	incbin "Levels/03/ring/1.bin"
		even
             
RingPos_EHZ2:	dc.w  $120,$21AD	; 0 ; DATA XREF: ROM:RingPos_Indexo
		dc.w  $198,$3288	; 2
		dc.w  $2A8,$2258	; 4
		dc.w  $468,$22C8	; 6
		dc.w  $6B0,$31B0	; 8
		dc.w  $708,$2320	; 10
		dc.w  $950, $2C8	; 12
		dc.w  $950, $2F0	; 14
		dc.w  $94C, $318	; 16
		dc.w  $937, $33B	; 18
		dc.w  $913, $34F	; 20
		dc.w  $83C,$9240	; 22
		dc.w  $B08,$22B8	; 24
		dc.w  $C68, $228	; 26
		dc.w  $C68, $250	; 28
		dc.w  $C68, $278	; 30
		dc.w  $C68, $200	; 32
		dc.w  $F08, $270	; 34
		dc.w  $CA8,$2330	; 36
		dc.w  $EE8, $260	; 38
		dc.w  $EC8, $250	; 40
		dc.w  $F28, $280	; 42
		dc.w  $F48, $290	; 44
		dc.w $1554,$1218	; 46
		dc.w $1100, $320	; 48
		dc.w $1150, $368	; 50
		dc.w $10B0, $368	; 52
		dc.w $10CA, $333	; 54
		dc.w $1136, $333	; 56
		dc.w $1280, $3A0	; 58
		dc.w $12D0, $3E8	; 60
		dc.w $1230, $3E8	; 62
		dc.w $124A, $3B3	; 64
		dc.w $12B6, $3B3	; 66
		dc.w $1880, $120	; 68
		dc.w $18D0, $168	; 70
		dc.w $1830, $168	; 72
		dc.w $184A, $133	; 74
		dc.w $18B6, $133	; 76
		dc.w $1A00, $1A0	; 78
		dc.w $1A50, $1E8	; 80
		dc.w $19B0, $1E8	; 82
		dc.w $19CA, $1B3	; 84
		dc.w $1A36, $1B3	; 86
		dc.w $1620, $2C0	; 88
		dc.w $164C,$12C0	; 90
		dc.w $169C,$12C0	; 92
		dc.w $16E0, $2C0	; 94
		dc.w $1A60,$C308	; 96
		dc.w $1BB0,$3348	; 98
		dc.w $1B80, $2A0	; 100
		dc.w $1BB0, $297	; 102
		dc.w $1BE0, $280	; 104
		dc.w $1C10, $269	; 106
		dc.w $1C40, $260	; 108
		dc.w $1C70, $269	; 110
		dc.w $1CA0, $290	; 112
		dc.w $1CD0, $297	; 114
		dc.w $1D00, $2A0	; 116
		dc.w $1D30, $297	; 118
		dc.w $1D60, $280	; 120
		dc.w $1D90, $269	; 122
		dc.w $1DC0, $260	; 124
		dc.w $1DF0, $269	; 126
		dc.w $1E20, $280	; 128
		dc.w $1E50, $297	; 130
		dc.w $1E80, $2A0	; 132
		dc.w $1EB0, $297	; 134
		dc.w $1EE0, $280	; 136
		dc.w $1F10, $269	; 138
		dc.w $1F40, $260	; 140
		dc.w $1F70, $269	; 142
		dc.w $1FA0, $280	; 144
		dc.w $1FD0, $297	; 146
		dc.w $2000, $2A0	; 148
		dc.w $1D94,$14A0	; 150
		dc.w $1E14,$14A0	; 152
		dc.w $1E94,$14A0	; 154
		dc.w $20A0, $440	; 156
		dc.w $20CC,$1440	; 158
		dc.w $2120, $440	; 160
		dc.w $214C,$1440	; 162
		dc.w $219C,$1440	; 164
		dc.w $21E0, $440	; 166
		dc.w $18A0, $440	; 168
		dc.w $18CC,$1440	; 170
		dc.w $191C,$1440	; 172
		dc.w $2380, $3A0	; 174
		dc.w $23B0, $397	; 176
		dc.w $23E0, $380	; 178
		dc.w $2410, $369	; 180
		dc.w $2440, $360	; 182
		dc.w $2470, $369	; 184
		dc.w $24A0, $380	; 186
		dc.w $24D0, $397	; 188
		dc.w $2500, $3A0	; 190
		dc.w $2200, $2A0	; 192
		dc.w $2250, $2E8	; 194
		dc.w $21B0, $2E8	; 196
		dc.w $21CA, $2B3	; 198
		dc.w $2236, $2B3	; 200
		dc.w $2288,$2458	; 202
		dc.w $1F60,$2988	; 204
		dc.w $1788,$23A0	; 206
		dc.w $166C, $3C8	; 208
		dc.w $166C, $3F0	; 210
		dc.w $166C, $418	; 212
		dc.w $166C, $440	; 214
		dc.w $166C, $468	; 216
		dc.w  $F50, $3D0	; 218
		dc.w  $F30, $3C0	; 220
		dc.w  $F70, $3E0	; 222
		dc.w $FFFF		; 224
RingPos_HTZ1:	dc.w   $D0,$3340	; 0 ; DATA XREF: ROM:RingPos_Indexo
		dc.w  $1E0, $3F0	; 2
		dc.w  $200, $400	; 4
		dc.w  $220, $410	; 6
		dc.w  $240, $420	; 8
		dc.w  $260, $430	; 10
		dc.w  $280, $440	; 12
		dc.w  $2A0, $450	; 14
		dc.w  $2C0, $460	; 16
		dc.w  $3C0,$2420	; 18
		dc.w  $440,$2400	; 20
		dc.w  $648,$23B8	; 22
		dc.w  $7A0,$C2E0	; 24
		dc.w  $928,$2350	; 26
		dc.w  $CFC,$32A0	; 28
		dc.w  $D10,$2420	; 30
		dc.w $FFFF		; 32
RingPos_HTZ2:	dc.w $FFFF		; DATA XREF: ROM:RingPos_Indexo
RingPos_CPZ1:	dc.w   $A8,$21B0	; 0 ; DATA XREF: ROM:RingPos_Indexo
		dc.w  $1A8,$21B0	; 2
		dc.w  $3A8,$21F0	; 4
		dc.w  $D28,$2130	; 6
		dc.w  $F80,  $B0	; 8
		dc.w  $FD0, $110	; 10
		dc.w  $F30, $110	; 12
		dc.w  $F43,  $CD	; 14
		dc.w  $FBD,  $CD	; 16
		dc.w  $FBD, $153	; 18
		dc.w  $F80, $170	; 20
		dc.w  $F30, $210	; 22
		dc.w  $F30, $1D0	; 24
		dc.w  $F43, $253	; 26
		dc.w  $F80, $270	; 28
		dc.w $1270,$C1C0	; 30
		dc.w $FFFF		; 32

;===========================================================
; now this is a	bigass chunk of	leftovers
;
; in this one you can find practically anything...
;
; most interesting though, is the uncompiled debug mode
;  code	around 0x60000.	sweet stuff
;===========================================================
Leftover_50A9C:
		incbin	"Unused/50A9C.bin"
		even

;===========================================================

		include	"Sound\SndDrv_Main.asm"
		even

;===========================================================

Art_Sonic:
		incbin	"Sprites\01\Art.bin"
		even

Map_Sonic:
		include "Sprites\01\maps.asm"
		even

Art_Tails:
		incbin	"Sprites\02\art.bin"
		even

SonicDynPLC:
		include "Sprites\01\plc.asm"
		even

Nem_Shield:	dc.b $80,$20,$80,  4,  8,$14,  9,$25,$16,$34, $A,$45,$1A,$55,$17,$65,$1B,$72,  0,$81,  4,  4,$16,$39,$26,$3A,$37,$76,$82,  5,$18,$17,$79,$83,  4,  5,$17,$77,$28,$F5,$84,  4,  6,$17,$78,$28,$F4,$85,  5,$19,$28,$FA,$86,  6,$38,$87,  4,  7,$17,$7B,$28,$F8,$38,$F9; 0
					; DATA XREF: ROM:0001C0C4o
					; ROM:0001C188o
		dc.b $FF, $D,$E2,$F8,$4D,$61,$1E,$B0,$8F,$58,$47,$AC,$23,$CA,$5D,$27,  8,$E4,$21,$38,$47,$84,  2,$D8,$5F,$1F,$31,$FA,$2E,$D8,$EB,$E5,$3E,$29,$ED,$DA,$79,$AE,$42,$DE,$B6,$EF,$A5,$BA,$97,$50,$DF,$FD,$8D,$AD,$D5,$F4,$AE,$94,$AE,$94,$AE,$94,$AE,$92,$B7,$59,$57,$42; 64
		dc.b $14,$95,$74,$85,  2,$CA,$DF,$D5,$8F,$5F,$95,$F8,$EC,$FD,$52,$5B,$F6,$73,$DE,$BB,$85,$BD,$2D,$E3,$4D,$76,$2E,$C1,$BF,$F9,$1B,$6B,$B2,$69,$91,$69,$91,$69,$91,$69,$91,$65,$AE,$D2,$C8,$A4,$31,$2C,$8B, $C,  5,$9B,$3F,$D6,$8F,$4E,$CD,$D7,$EC,$D3,$D6,$96,$DF,$B4; 128
		dc.b $9F,$15,$E0,$2D,$D5,$B9,$D2,$5D, $B,$A0,$6F,$FE,$66,$F3,$7C,$AE,$B2,$AD,$59,$56,$AC,$AB,$56,$55,$A5,$2E,$93,$95,$62,$10,$9C,$AB,$42,  1,$6C,$F1,$E7,$F6,$D1,$F5,$FB,$3C,$FA,$FE,$D1,$7D,$29,$AD,$DA,$79,$AE,$42,$DF,$16,$F7,$A7,$BB,$97,$70,$DF,$FD, $D,$F1,$7E; 192
		dc.b $1B,$5C,$32,$57, $C,$95,$C3,$25,$70,$C9,$2F,$77,$9E,$19,  8,$72,$78,$64,$87,  2,$DC,$63,$BF,$EC,$A3,$F4,$DF,$B4,$E3,$D3,$B3,$75,$49,$6F,$99,$F7,$5E,$C2,$DD,$5B,$9D,$25,$D0,$BA,  6,$FF,$EA,  0,  0,  0,$6F,$17,$C2,$6B,  8,$6B,  9, $F,$6C,$21, $F,$6C,$24,$39; 256
		dc.b   9,$18,$42,$1E,$10,$23,  9, $F,  8,  1,$38,$EF,$E3,$E8,  0,  3,$78,$D7,$94,$B7,$9E,$6D,$8E,$6D,$E5,$27,$E3,$99,$7D,$7B,$9E,$61,$EC,$92,$F3,$CE,$92,$B3,  9,$59,$BE,$65,$2D,$9B,$E6,$F9,$2F,$90,$BE,$40,  0,  0,$27,$FE,$5F,$F1,$3F,$EE,$7F,$C4,$23,$F6,$B1,$F5; 320
		dc.b $59,  0,  0,  0,$36,  0; 384
Nem_Stars:	dc.b   0,$22,$80,  6,$3C,$16,$3D,$25,$1A,$35,$1C,$45,$1D,$55,$1B,$64, $B,$72,  0,$83,  4, $C,$84,  3,  4,$85,  2,  1,$17,$7C,$86,  4, $A,$17,$7D,$FF,  0,  3,$88,  0,  0,  0,$17,$40,  0,  0,  1,$6E,$DA,$76,$80,  0,  0,$5E,$5B,$DC,$69,$CE,$B7,$80,  0,  1,$79,$6E; 0
					; DATA XREF: ROM:0001C0CAo
		dc.b $F2,$B3,$58,$FE,$99,$CD,$65,$66,$DB,$C0,  0,  0, $F,$5E,$63,$F6,$D0,  0,  0,$CB,$6E,$AE,$9D,$FE,$99,$CD,$53,$BA,$B6,$F0,  0,  0,$DB,$73,$AC,$7C,$FC,$A3,$FB,$6E,$B1,$B9,$68,  1,$2E,$5B,$75,$74,$EE,$A6,$E9,$8F,$3F,$8C,$FE,$52,$98,$F2,$A6,$E9,$DD,$5B,$72,$E0; 64
		dc.b   0,  0,  0,  1,$FA,$46,$34,  0,  0,  0,  0,  0,  0,$7A,$8E,$B3,$8C,$F2,$72,$54,$7B,$29,$D6,$4F,$9F,$F6,$AD,$64,$F9,$5D,$94,$F2,$54,$78,$CF,$26,$9D,$67,$A8,  0,  0,$76,$5C,$B9,$6D,$B6,$DD,$5D,$5D,$5D,$75,$F2,$B3,$4F,$B5,$3C,$8E,$A9,$95,$35,$4D,$4E,$7D,$F9; 128
		dc.b $33,$DF,$FB,$7D,$F9,$33,$DA,$6A,$72,$99,$53,$55,$3C,$8E,$AB,$34,$FB,$5D,$7C,$AB,$AB,$AB,$6D,$B6,$E5,$CB,$80,  0,  0,  0,$17,$F5,$8F,$E9,  0,  0,  0,  0,  0; 192

;==============================
; some unused uncompressed art
;==============================
Unused_Art_9E1FB:
		incbin	"Unused/9E1FB.bin"
		even

Map_Tails:
		include	"Sprites/02/maps.asm"
		even

TailsDynPLC:
		include	"Sprites/02/PLC.asm"
		even

;---------------------------------------------------------------------------
;Screen modes data
;---------------------------------------------------------------------------
Nem_SegaLogo:
		incbin "Modes/SegaScreen/art.bin"
		even

Eni_SegaLogo:	dc.b   7, $F,  0,$13,  0,$13,$AE,$80,$6B,$C0,$1A,$F8,$26,$BA,  1,$AF,  0,$6B,$E0,$9A,$E8,  6,$BC,  1,$AF,$82,$6B,$A0,$1A,$F0,  6,$BE,  9,$AE,$80,$6B,$C0,$1A,$F8,$26,$BA,  1,$AF,  0,$6B,$E0,$9A,$E8,  6,$BC,  1,$AF,$82,$6A,$A0,$1E,$28,$45,  4,$56,$80,$3C,$20,$95; 0
					; DATA XREF: ROM:0000311Ao
		dc.b $7C,$12,  3,$EF,$BE,$FB,$EF,$BE,$FB,$EF,$BE,$FB,$EF,$BE,$FB,$EF,$BE,$FB,$EF,$BE,$FB,$EB,  7,  0, $B,$83,  8, $B,$85,  8, $B,$80,$80,$AF,$87,  0,$13,$85,  4,$13,$85,  8,$13,$8E,$F8,$70,  8,$B8,$70,  1,$E8,$10,  0,  0,$30,$41,$E8,$30,  0,  0,$4F,$A2,$25,$10; 64
		dc.b $74,  4,$10,$96,  7,$10,  0,$2E,$C0,$80,$12,$C7,$7D,  1,$78,  3,$B8,$45,$2F,$A9,$4C,  0,  2,$EC,$A6,$94,$B1,$76,$33,$E8,  1,  0, $B,$87,$E4,$1D,$93,$C2,$7A,$4F,$49,$F0,  0,$27,$E5,  0,  0, $B,$B0,$20,  0,  0,$A8,$84,$47,$D0,  2,  0,$27, $E,$89,$29,$82,  9; 128
		dc.b $FA,  2,$B2,$58,$4B,$41,$38,$27,  6,  0,$51,  2,  8,$27,  2,$88,$54,$7F,$89,$63,$22,$E1,$51,$23,$10,$88,$BD,$22,$35, $C,$8B,$83, $C,$8B,$80,$FB,$EF,$BE,$FB,$EF,$BE,$FB,$EF,$BE,$FB,$EF,$BE,$FB,$EF,$BE,$FB,$EF,$BE,$FA,$E0,$22,  2,$3F,$C0,  0; 192
Eni_TitleMap:	dc.b   8, $D,$60,  1,  0,  0,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F4,$C2,$91,$80,  3,$E1,$81,$F1,$70,$69,$18,  3,$17,  3,$83,$80,$15, $E,$8E,  2,$87,$80,  5,$E1,$84,$72,$71,  8,$78,  3, $F,  3,$C7,$C2,$E0,$E0,  5,$43,$81,$85,$4A,$E5,$88,$38,$FE,$1E,$CF,$C7,$60,$E1,$5C; 0
					; DATA XREF: ROM:000032FEo
		dc.b $5C,$52, $E,  0,$56,  6,  0, $A,$26,$15,$1B,$37,$2A,$89,$85,$71,$72,$38,$58,  1,$58,$38,  0,$38,$38,$54,$68,$58,$D7,$2F,$34,$83,$85,$71,$F2,$E8,$78,  1,$58,$38,  0,$38,$38,$54,$38,$F8,$D7,$1F,$3D,$83,$85,$71,$F3,$98,$78,  1,$58,$38,  2,  6,$21,  2,$8E,$14; 64
		dc.b $81,$85,$41,$81,$87,$81,$8F,$8D,$70,$F4,$2E,$F8,$7B,$A0,$73,$FC,$2B,$85,$78,$A7,$3E,$E4,$30,$F0,  2,$B0,$B0,  0,$3C,$71,$1E,$15, $E,$4E,$35,$C7,$D2,$39,$E1,$5E,$47,$D1,$3A,$1C,$4C,  0,$AC,$3C,  0,$34,$9C,$6B,$9B,$A7,$C5,$C0, $A,$C3,$C0,  7,$89,$8B,$A9,$45; 128
		dc.b $C0, $A,$C4,$C0,  7,$87,$87,$B3,$46,$C0, $A,$C5,$C0,  7,$85,$C3,$BC,$C7,$C0, $A,$C5,$C0,  7,$85,$C3,$C6,$47,$C0, $A,$C2,$C0,  7,$8B,$8F,$D1,$44,$C0, $A,$C1,$C0,  7,$85,$CB,$DE,$EB,$CD,$77,$97,$DD,$43,$C0, $A,$C2,$C0,  0,$40,$C2,$A1,$42,$C0,  3,$E1,$F9,$B0; 192
		dc.b $B0,  6,$2F,$97,$C7, $A,$FC,$88,$98,  1,$58,$38,  0,$58,$78,  0,$6E,$1F,$6A,$1E,  0,$CB,$F6,$61,$E0,  5,$60,$E0,  0,$20,$6B,$10,$A2,$E0,  1,$62,$E0, $C,$5F,$93,$8E,$B1,$FC,$30,$F0,  2,$B0,$70,  0,$32,$30,  0,$B2,$30,  6,$1F,$D9, $F,  0,$2B,$33,  0,  5,  7; 256
		dc.b $7A,$81,$3B,  0,$2B,$3F,  0,$4F,$C0,$10,$70,  2,$B3,$F0,  4,$8C,  0,$43,$EF,$BE,$FB,$E8,$FF,  0; 320
Eni_TitleBg1:	dc.b   9, $D,  0,$1E,  1,  0,$7D,$F7,$DF,$7A,$8A,$80,$F1,$70,$15,  3,$7D,$BA,$6A,  8,$FB,$56,$14,$21, $A,$2A,$23,$C1,$40,$DF,$4A,$8A,$89,$C2,$41,$5A,$6A,$2A,$85,$25,$19,$7D,$2A,$2A,$39,  5,  5,$78,$28,$F4,$24,$15,$E8,$A3,$EA,$1C,$A4,  8,$2A,$A3,$F4,$94,$39,$FA; 0
					; DATA XREF: ROM:00003326o
		dc.b $2A,$43,  5,  5,$78,$29,$1C,$24,$15,$E8,$A4,$8A,$2C,$A4,$A8,$2A,$A4,$94,$94,$59,$DC,$2E,$21,$CD,$49,$90,$55,  5,$54,$7A,$1A, $A,$F3,$52,$74,$15,$41,$57,$1E,$84,$82,$BC,$9C,$75,$43,$94,$3D,$BC,$2E,$31,$CD,$4A,$10,$55,  5,$54,$8E,$1A, $A,$F3,$52,$94,$15,$41; 64
		dc.b $57,$23,$84,$82,$BF,$1C,$89,$45,$94,$5E,$4A,$A4,$AE,$4A,$A4,$AE,$4A,$A4,$AE,$4A,$A4,$AE,$4A,$A4,$AE,$94,$95,$70,$B2,$CA,$52,$5B,$FA,$4B,$EC,$BE,$CB,$A4,$BE,$4B,$AC,$BE,$CB,$E4,$C2,$4B,$AC,$BE,$4B,$AC,$BE,$4B,$A4,$BE,$CB,$66,$C8,$1D,$29,$31,$FD,$26,$76,$67; 128
		dc.b $66,$52,$69,$26,$B6,$69,$66,$92,$6D,$26,$F6,$69,$27,$16,$69,$27,$12,$73,$66,$33,$C0,  2,$8C,$9D,$71,$93,$B9,  3,$9E,  0,$12,$C0,  2,$1C,$81,$CB,  0, $B,$E2,$79,$44,$4F,$30,$99,$ED,$61,$40,$C4,$68,$54,$44,$F2,$A0,$A6,$41,$14,$EA,$22,$A3,$C0,$54,$6A,$8A,$9D; 192
		dc.b $11,$4C,$C2,$69,$BE,$C5,$40,$53,$85,$38,$54,$45,$48,$54,$45,$64,$D3,$8D,$38,$D4,  5,$30,$53,$69, $A,$D5,$21,$5C,  2,  8, $F,$51,$15,$AE,$22,$BE,$2B,$94,$85,$72,$28, $F,$51,$15,$AA,$22,$BB,$10,  7,$B9, $A,$D0,$B0, $B, $C,$60,$1E,$A2,$2C,$12,$80,$7A,$88,$B0; 256
		dc.b $46,  1,$EF,$C2,$C0,$2C,$42,$C6,$2C,$42,$C6,$2C,$42,$C6,$2C,$42,$C6,$2C,$42,$C6,$2C,$42,$C6,$2C,$42,$C7,$44,$58,$A8,$8B,$15,$11,$62,$A2,$2C,$54,$45,$8A,$88,$B1,$51,$16,$2A,$22,$C5,$4C,$58,$A8,$8B,$25,$11,$64,$A2,$2C,$94,$45,$92,$88,$B2,$51,$16,$4A,$22,$C9; 320
		dc.b $44,$59,$28,$8B,$25,$11,$64,$A2,$2C,$94,$45,$92,$88,$B2,$51,$16,$4A,$62,$C9,$44,$59,$A8,$8B,$35,$11,$66,$A2,$2C,$D4,$45,$9A,$88,$B3,$51,$16,$6A,$22,$CD,$44,$59,$A8,$8B,$35,$11,$66,$A2,$2C,$D4,$45,$9A,$88,$B3,$53,$16,$6A,$22,$D1,$44,$5A,$28,$8B,$45,$11,$68; 384
		dc.b $A2,$2D,$14,$45,$A2,$88,$B4,$51,$16,$8A,$22,$D1,$44,$5A,$28,$8B,$45,$11,$68,$A2,$2D,$14,$45,$A2,$98,$B4,$51,$16,$AA,$22,$D5,$44,$5A,$A8,$8B,$55,$11,$6A,$A2,$2D,$54,$45,$AA,$88,$B5,$51,$16,$AA,$22,$D5,$44,$5A,$A8,$8B,$55,$11,$6A,$A2,$2D,$54,$C5,$AA,$88,$B6; 448
		dc.b $51,$16,$CA,$22,$D9,$44,$5B,$28,$8B,$65,$11,$6C,$A2,$2D,$94,$45,$B2,$88,$B6,$51,$16,$CA,$22,$D9,$44,$5B,$28,$8B,$65,$11,$6C,$A6,$2D,$94,$45,$BA,$88,$B7,$51,$16,$EA,$22,$DD,$44,$5B,$A8,$8B,$75,$11,$6E,$A2,$2D,$D4,$45,$BA,$88,$B7,$51,$16,$EA,$22,$DD,$44,$5B; 512
		dc.b $A8,$8B,$75,$31,$6E,$A2,$2E,$14,$45,$C2,$88,$B8,$51,$17, $A,$22,$E1,$44,$5C,$28,$8B,$85,$11,$70,$A2,$2E,$14,$45,$C2,$88,$B8,$51,$17, $A,$22,$E1,$44,$5C,$28,$8B,$85,$11,$6E,$A2,$2D,$D4,$45,$BA,$88,$B7,$51,$16,$EA,$22,$DD,$44,$5B,$A8,$8B,$75,$11,$6E,$A2,$2D; 576
		dc.b $D4,$45,$BA,$88,$B7,$51,$16,$EA,$22,$DD,$44,$5B,$A9,$8B,$75,$11,$70,$A2,$2E,$14,$45,$C2,$88,$B8,$51,$17, $A,$22,$E1,$44,$5C,$28,$8B,$85,$11,$70,$A2,$2E,$14,$45,$C2,$88,$B8,$51,$17, $A,$22,$E1,$44,$5C,$3F,$80; 640
Eni_TitleBg2:	dc.b   9, $D,  0,$1E,  1,  0,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$DF,$7D,$F7,$D1,$A2,$2E,$4D,$F2,$50,$27,  1,$50,$37,$29,$8B,$A6,$13,$75,$A2,$2F, $B,$D2,$50,$57,$29,$8B,$D6,$13,$7B,$A8,$2F,$DF,$86,  4,$E0,  6,  0,$60,$86,  6,$60,$EE, $E,$61,$24,$AE,$4A,$A4,$AE,$4A; 0
					; DATA XREF: ROM:0000334Eo
		dc.b $A4,$AE,$4A,$A4,$AE,$8C,$95,$51,$92,$AA,$32,$55,$4E,$61,$68,$CC,$2D,$19,$85,$A3,$31,$34,$66,$26,$8C,$C4,$D1,$98,$99,$F2,  7,  6,$40,$F8,$4C,$5C,$C9,  3,$9E,  0,$13,$C0,  2,$78,  0,$4F,  0, $C,$26,$7B,$44,$4F,$30,$99,$ED,$B1,$40,$A2,$27,$98,$4C,$F6,$88,$A0; 64
		dc.b $61,$34,$1A,$22,$79,$84,$CF,$70,$99,$EE,$13,$4D,$A2,$29,$98,$4D,$37,$A8,$A8, $A,$70,$A7, $A,$88,$A9, $A,$8D,$51,$53,$A2,$29,$98,$4D,$37,$E8,$A8, $A,$71,$A7,$1A,$80,$A6, $A,$69,$A6,$9A,$61,$A6,$9A,$60,$AD,$8A,$F8,$AE,$8A,$F0,$10,$80,$7A,$90,$AD,$52,$15,$C8; 128
		dc.b $40,$3D,$44,$56,$B8,$8A,$F8,$AE,$52,$15,$C8,$A0,$3D,$44,$56,$B8, $B, $C,$60,$1E,$A2,$2C,$11,$80,$7A,$88,$B0,$4A,  1,$EA,$62,$C1,$44,$58,$A8,$8B,$15,$11,$62,$A2,$2C,$54,$45,$8A,$88,$B1,$51,$16,$2A,$22,$C5,$44,$58,$A8,$8B,$15,$11,$62,$A2,$2C,$54,$45,$8A,$88; 192
		dc.b $B1,$53,$16,$2A,$22,$C9,$44,$59,$28,$8B,$25,$11,$64,$A2,$2C,$94,$45,$92,$88,$B2,$51,$16,$4A,$22,$C9,$44,$59,$28,$8B,$25,$11,$64,$A2,$2C,$94,$45,$92,$98,$B2,$51,$16,$6A,$22,$CD,$44,$59,$A8,$8B,$35,$11,$66,$A2,$2C,$D4,$45,$9A,$88,$B3,$51,$16,$6A,$22,$CD,$44; 256
		dc.b $59,$A8,$8B,$35,$11,$66,$A2,$2C,$D4,$C5,$9A,$88,$B4,$51,$16,$8A,$22,$D1,$44,$5A,$28,$8B,$45,$11,$68,$A2,$2D,$14,$45,$A2,$88,$B4,$51,$16,$8A,$22,$D1,$44,$5A,$28,$8B,$45,$11,$68,$A6,$2D,$14,$45,$AA,$88,$B5,$51,$16,$AA,$22,$D5,$44,$5A,$A8,$8B,$55,$11,$6A,$A2; 320
		dc.b $2D,$54,$45,$AA,$88,$B5,$51,$16,$AA,$22,$D5,$44,$5A,$A8,$8B,$55,$31,$6A,$A2,$2D,$94,$45,$B2,$88,$B6,$51,$16,$CA,$22,$D9,$44,$5B,$28,$8B,$65,$11,$6C,$A2,$2D,$94,$45,$B2,$88,$B6,$51,$16,$CA,$22,$D9,$44,$5B,$29,$8B,$65,$11,$6E,$A2,$2D,$D4,$45,$BA,$88,$B7,$51; 384
		dc.b $16,$EA,$22,$DD,$44,$5B,$A8,$8B,$75,$11,$6E,$A2,$2D,$D4,$45,$BA,$88,$B7,$51,$16,$EA,$22,$DD,$4C,$5B,$A8,$8B,$85,$11,$70,$A2,$2E,$14,$45,$C2,$88,$B8,$51,$17, $A,$22,$E1,$44,$5C,$28,$8B,$85,$11,$70,$A2,$2E,$14,$45,$C2,$88,$B8,$51,$17, $A,$22,$E1,$44,$5B,$A8; 448
		dc.b $8B,$75,$11,$6E,$A2,$2D,$D4,$45,$BA,$88,$B7,$51,$16,$EA,$22,$DD,$44,$5B,$A8,$8B,$75,$11,$6E,$A2,$2D,$D4,$45,$BA,$88,$B7,$51,$16,$EA,$62,$DD,$44,$5C,$28,$8B,$85,$11,$70,$A2,$2E,$14,$45,$C2,$88,$B8,$51,$17, $A,$22,$E1,$44,$5C,$28,$8B,$85,$11,$70,$A2,$2E,$14; 512
		dc.b $45,$C2,$88,$B8,$51,$17, $F,$E0; 576
Nem_Title:	dc.b $81,$8C,$80,  4,  2,$14,  5,$25,$10,$35,$11,$46,$2E,$56,$30,$66,$32,$73,  0,$81,  4,  3,$16,$2F,$28,$E9,$38,$E6,$78,$EC,$82,  5, $E,$18,$E3,$83,  4,  4,$16,$34,$28,$E8,$84,  5,$12,$18,$E2,$85,  5,$16,$18,$EB,$86,  5, $C,$17,$70,$87,  5, $F,$17,$6C,$28,$ED; 0
					; DATA XREF: ROM:0000328Eo
		dc.b $88,  6,$35,$89,  6,$26,$17,$6D,$28,$EE,$8A,  5,$14,$17,$6E,$8B,  6,$33,$17,$72,$8C,  5,$15,$18,$EA,$8D,  6,$27,$18,$E7,$8E,  6,$31,$8F,  5, $D,$17,$6F,$FF,  0,  0,  0,  1,$D2,$71,$C5,$38,$53,$39,$38,$EE,$6C,$D4,$34,$63,$4B,$F5,$B7,$4E,$20,$6E,$97,$2E,  0; 64
		dc.b   9,$38,$EE,$6C,$D4,$93,$8D,$7F,$5A,$D9,$A9,$27,$43,$F5,$AD,$9B,$FA,$DC,$80,  0,$1E,$54,$93,$8E,$39,$C9,$C6,  0,  0,$13,$A4,$C8,$3B,$89,$D6,$83,$A5,$C1,  0,$C9,$D0,$74,$B8,$49,$D2,$64,$9D,$FA,$59,$3B,$F4,$BD,$BD,$7D,$BD,$3A,$7E,$93,$F4,$A2,$2E,$97,  9,$7E; 128
		dc.b $9A,$4E,$EB,$77,$F1,$76,$5B,$F6,$EC,$BD,$9C,$CC,$D8,$CF,$E3,$EE,$4F,$D9,$4B,$F3,  3,$FE,$DF,$F5,$FF,$BF,$67,$FD,$FF,$F5,$F9,$89,$A9,$5D,$31, $A,$68,$C6,$94,$E2,  6,$8C,$6D,$C6,$8C,$68,$B8,$D3,$FC,$CF,$90,  2,$70,$27,$C1,$A5,$3D,$CE,$59,$DD,$27,$B0,$BF,$5A; 192
		dc.b $D9,$A9,$28,$FE,$B5,$B9,$4E,  0,$1F,$F6,$71,$E1,$35,$24,$E3,$87,$3B,$66,$A4,$9C,$6B,$FA,$D6,$CD,$4B,$BF,$5A,  7,$FD,$80,  0,$64,$EC,$1C,$CC,$1D,$2C,$9D,$73,$B8,$A0,$EE,$26,$D9,$5C,$C6,$DB,$57,$BA,$53,$3B,$5D,$84,$C6,$EB,$67,$A9,$B7,$5D,$85,$7B,$F3,$32,$E3; 256
		dc.b $FD,$37,$13,$BA,$F6,$13,$BA,$F6,$15,$F6,$D8,$57,$B3,$61,$5E,$CD,$94,$BD,$9B,$29,$52,$66,$CA,$56, $F,$A5,$61,$BC,$AB,$FA,$DC,$FA,$EF,$67,$6E,$E6,$6C,$DD,$55,$7D,$2B,$75,$6E,$DF, $F,$D7,$CE,$C2,$DF,$FA,$D2,$CD,$BC,$F7,$27,$F8,$AA,$16,$75,$DE,$4D,$9D,$93,$B7; 320
		dc.b $9D,$B3,$B0,$99,$3A,$B9,$AC,$26,$6F,$CE,$4F,$61,$31,$F2,$E4,$F2,$71,$3F,$32,$74,$F9,$CD,$9C,$FC,$63,$FF,$FF,$FD,  0, $F,$F5,$67,$91,$80,  0, $E,$97,$2F,$DB,$23,$1A,$53,$88,$1A,$31,$A5,$3C, $D,$18,$D2,$9E,  6,$8C,$69,$4F,  3,$46,$36,$E3,$46,$37,$F8,$CF,$93; 384
		dc.b $80,  0,$4E,$27,$C3,$9C,  0,  0,$19,$7E,$F5,$D2,$79,$7E,$F5,$B3,$52,$EF,$D6,$80,  0,$FF,$B6,$72,$71,$C6,$76,$CD,$4C,$E4,$E3,$2F,$DE,$B6,$6A,$5D,$FA,$D0,  7,$FD,$80,$CE,$4E,$38,$CE,$D9,$A9,$9C,$9C,$65,$FB,$D6,$CD,$4B,$BF,$5A,$3F,$EC,  0,$19,$C9,$C7,$19,$DB; 448
		dc.b $35,$39,$49,$C5,$FC,$D6,$CD,$FD,$6E,$40,  1,$93,$8E,$E7,$32,$9C,$A5,$C6,$C6,$FE,$AE,$44,$C6,$C5,$CC,$6F,$E6,$15,$CC,$6E,$BB,  9,$CC,$6E,$AF,$57,$31,$BA,$BD,$4D,$8D,$D5,$E5,$7B,$DB,$AB,$C8,$D8,$FA,$6A,$F2,$36,$1D,$22,$6C,$3A,$13,$CA,$FD,$94,$53,$63,$E9,$55; 512
		dc.b $3D,$94,$83,$5F,$4A,$C1,$AE,$A4,$37,$B9,$90,$6F,$3B,$20,$D6,$6F,$64,$1B,$37,$1B,$66,$83,$79,$E1,$BE,$78,$B7,$9E,$E9,$F2,$6E,$4C,$C9,$9B,$F3,$8F,$EB,$F3,  0,  0,  4,$77,$E6,$59,$EF,$59,$66,$59,$C9,$65,$9C,$33,$91,$67,$76,$60,$56,$1F,$BC,$B7,$EB,$3F,$6A,$FF; 576
		dc.b $D6,$7E,$E7,$10,  0,$FF,$E7,$FD,$7F,$EF,$FD,$4B,$33,  3,$4C,$8C,  0,  4,$B9,$7F,$59,$A5,$3C,$51,$8D,$29,$E0,$68,$C6,$97,$3A,$9A,$31,$AB,$3A,$9A,$33,$7C,$4D,$38,$36,$27,$A7,$F5,$B6,$48,  0,$27,$1C,$F7,$35,$67,$8B,$B9,$CB,$F5,$B6,$87,$39,$6A,$F8,$CF,$AB,$C4; 640
		dc.b $67,$D5,$E4,$6B,$3E,$AF,$23,$79,$4F,$AB,$D5,$F4,$9F,$57,$A9,$AB,$5E,$6F,$64,$F4,$53,$61,$D1,$5A,$6C,$3A,$2B,$67,$23,$A2,$B6,$72,$7D,$15,$B3,$AD,$15,$B3,$DC,$D9,$EE,$6C,$F7,$36,$19,$EB,$B7,$9D,$73,$79,$3A,$2D,$27,$67,$74,$B3,$BA,$59,$E1,$98,$10,$9B,$5C,$F0; 704
		dc.b $7E,$77,$38,$9B,$76,$72,$BA,$A5,$9C,$A1,$5B,$2E,$65,$D5,$67,$C0,$FA,$DF,  3,$D7,$61,$1A,$9C,$D8,$F1,$A4,$3A,$BF,$4A,$5D,$5D,$7D,$B5,$EB,$D8,$57,$DB,$61,$5E,$F9,$3C,$AF,$7C,$A7,$C6,$F7,$CA,$7C,$55,$F2,$4C,$62,$7C,$7F,$CB,$ED,$FE,  9,$5E,$FF,$DA,$1B,$E4,$9F; 768
		dc.b $BE,$94,$FF,$9E,$8E,$20,$65,$FF,$A7,$FF,$92,$7F,$F7,  0,  0,$FF,$7E,$39,$18, $E,$93,$8E,$29,$C2,$9C,$A4,$EB,$A7,$6C,$C6,$8C,$69,$7E,$B5,$D6,$63,$62,$9C,$1A,$B3,$91,$E8,$CD,$E5,$39,$5E,$9C,$1B,$13,$D1,$8D,$38,$5E,$8C,$A6,$72,$71,$91,$A7,$3B,$66,$A7,$2B,$2F; 832
		dc.b $F3,$5C,$27,$1C,$F7,$35,$79,$E0,$CD,$EB,$CE,$49,$C3,$7A,$CF,$D1,$C3,$79,$4B,$67,$17,$1C,$E0,  0,$27,$1C,$F7,$7E,$B4,$46,$71,$84,$FA,$8B,$A7,$D5,$E2,$33,$EA,$F2,$9E,$DC,$78,$9F,$56,$AF,$57,$D2,$E3,$83,$5E,$46,$FA,$13,$67,$57,$D0,$9B,$3A,$9C,$27,$26,$93,$E8; 896
		dc.b $4D,$56,$1A,$B5,$9B,$D8,$ED,$5D,$3E,$7F,$AF,$9C, $C,$9B,$93,$1B,$93,$32,$66,$FC,$E1,$37,$EB,$F3, $A,$78,$1E,$B7,$1E,$AF,$89,$EA,$F1,$13,$D5,$E4,$6A,$7A,$BC,$8D,$F7,$EA,$F2,$35,$FC,$C3,$C8,$DF,$29,$F6,$11,$BD,$31,$81,$BD,$31,$81,$BD,$31,$81,$BD,$31,$8B,$D3; 960
		dc.b $1B,$93,$11,$86,$20,  0,  0,  0,  0,  6,$4D,$C6,$7C,$F8,$B6,$91,$A3,$1A,$53,$88,$1A,$31,$A5,$3C, $D,$18,$D1,$71,$A3,$1B,$71,$A7,$F9,$9F,$36,$53,$81,$38,$13,$E0,$D2,$9E,$E6,$AE,$CE,$27,$7E,$B7,$67,$13,$80,  0,  7,$7E,$F6, $E,$FD,$E8,  0,  1,$94,$F6,$E3,$84; 1024
		dc.b $FA,$BC,$13,$16,$7D,$5E,  1,$32,$85,$3E,$AF,  4,$CA,$14,$93,$3F,$CF,$25,$33,$56,$AE,$6F,$2A,$14,$EA,$D2,$71,$36,$32,$CC,$A7,$84,$B3,$26,$C7,$35,$9C,$65,$B7,$5C,$E2,$E2,$7E,$71,$CD,$C4,$DB,$B3,$94,$4D,$73,$96,$59,$A9,$EA,$2E,$3D,$5E,$47,$37,$EB,$8E,$D1,$37; 1088
		dc.b $A6,$27,$AB,$D5,$31,$2D,$5E,$46,$FC,$6E,$7A,$41,$EA,$98,$DC,$CC,$93,$1B,$9B,$4F,$E4,$B1,$A5,$3C,$51,$8D,$29,$E0,$68,$C6,$94,$F8,$62,$53,$A9,$A3, $F,$12,$9D,$4D,$18,$78,$C4,$D1,$87,$8F,$ED,$9F,$27,$20,  0,$65,$38,$CB,$12,$9E,$DC,$72,$C5,$D3,$EA,$F2,$65, $A; 1152
		dc.b $7C,$1B,$94,$F8,$35,$75,$79,$32,$93,$80,$B3,$7E,$7B,$57,$1C,$D8,$C4,$F5,$78,$11,$3D,$5E,  9,$99,$22,$9E,$AF,$26,$16,$3A,$CA,$BC,$A7,$C4,$93,  6,$63,$82, $C,$B1,  3,$2F,$E7,$E3,$3E,$77,$1A,$33,  3,$4C,$8C,  0,$2D,$CB,$F8,$C7,$89,$4F,$16,$1E,$25,$3C,$11,$86; 1216
		dc.b $D2,$9D,$4D,$38,$34,$B9,$C8,$F4,$63,$63,$7A,$33,$7C,$4D,$3F,$CC,$F9,$3C,$60,$8C,  0,  1,$6E,$39,$1D,$5B,$30,$79,$32,$93,$80, $B,$36,$C1,$AB,$9C,$B2,$CF,$F3,$DA,$CE,$30,$6E, $D,$63,$6E,$61,$32,$2D,$61,$33,$7E,$64,$F6,$13,$1F,$2C,$C9,$E4,$E2,$7E,$6A,$D9,$A8; 1280
		dc.b $47,$8E,$76,  0,$8F,$57,$82,$60,$C7,  4, $B,$4C,$D3,$88,$FF,$3D,$85,$E1,$D2,$E5,$27,$19,$23,$1A,$4D,$9A,$99,$9A,$31,$AB,$CE,  8,$D1,$8D,$29,$C9,$D2,$B4,$CD,$29,$C9,$38,$6F,$29,$C8,$F4,$E0,$D2,$9C,$AF,$D1,$9B,$F3,$93,$8B,$14,$E1,$3B,$66,$A4,$A9,$A1,$7F,$37; 1344
		dc.b $60,  2,$71,$CF,$76,$F2,$E7,$87, $D,$E5,$CE,$5C,$5C,$7F,$AD,$19,$25,$80,  0,  1,$C7,$23,$EA,$6B,  6,$52,$CB,$30,  0,$3B,$6A,$CD,$EB,$2C,$CB,$39,$43,$38,$67,$2C,$B3,  0,  8,$1C,$DF,$9E,$CF,$AC,  0,  0,$14,$CD,$2C,$CB,$71,$40,$D1,$8D,$B8,$D1,$8D,$B8,$D1,$98; 1408
		dc.b $1A,$64,$60,$7F,$DA,$71,$3E, $D,$29,$EE,$63,$4A,$78,$A3,$1A,$5C,$EA,$68,$CD,$E5,$3A,$9A,$70,$69,$4F,$C1,$FC,$4E,$E7,  0,  1,$77,$EA,$A7,$5D,$D0,$9D,$7F,$55,$33,$40,$11,$DD,$33,$7F,$74,  1,$7E,$AB,$F3,$18,$E6,$CF,$D6,  0,$B8,$E7,$FB,$6F,$CC, $C,$3F,$F5,$FF; 1472
		dc.b $5F,$FC,$88,$7F,$D8, $B,$BF,$55,$77,$E9,$7F,$54,$B3,$6A,$5C,$6F,$D2,$1B,$6B,$C6,$C7,$B7,$F8,$20,  0,$3F,$E6,$EF,$F1,$98,  2,$1F,$BA,$5D,$DF,$B5,$2A,$75,$C5,$26,$FE,$66,$3F,$E3,$30,$3F,$D4,$5F,$E5,$A6,$56,$1F,$FE,$EC,  0,$7E,$AA,$EF,$D2,$EE,$C1,$D6,$A2,$E3; 1536
		dc.b $BF,$56,$D1,$4C,  0,  0,  0, $C,$BF,$F5,$37,$F9,$41,$7F,$9D,$3F,$D0,  0,$DD,$87,$5A,$65,$54,$8F,$6D,$DF,$A8,$48,$1E,$46,  4,$3F,$95,  9,$BF,$6A,$A9,$82,$2F,$ED,$CF,$F4,$5F,$B9,$EC,  3,$F9,$50,$FD,$AC,$C2,$1F,$B7,$8C,$DF,$AB,$2E,$83,$FF,$18,$17,$7E,$AA,$29; 1600
		dc.b $37,$5C,$10,$2E,$CE,$88,$72,$FF,$1B,$B2,$31,$FF,$AF,$FA,$8F,$FB,$F2,$B2,$BD,$B8,$F1,$D7,$6C,$3F,$82,$D7,$B0,$53,$29,$80,$CA,$DF,$E6,$1F,$C6,$1F,$A6,  0,$65,$4F,$DB,$67,$8E,$AE,  3,$F6,$D9,$E2,$3F,$30,$21,$FF,$AF,$EA,$A1,$7F,$14,  0,$D9,$B7, $F,$ED,$61,$D7; 1664
		dc.b $FD,$AD,$19,$B2,$4E,$9E,$17,$A3,$1B,$71,$A3,$30,$34,$C8,$C0,$1C,$AB,$3F,$EF,$1A,$F3,$B9,$99,$62,$60,  1,$97,$4A,$7E,$BE,  9,$5B,$93,$3F,$DB,$92,$66,$2E,$4A,$7F,$44, $A,$FF,$98,$7F,$DC, $E,$6F,$DD,$C2,$82,$3F,$A6,$FD,$61,$26,$49,$FD,$7C,$B3, $B,$FC,$B0,$21; 1728
		dc.b $FF,$30,$98,$26,  9,$41,$72,$53,$2F,$CF,$17,$EE,$A1,$37,$EC,$B3,$DF,$36,$59,$E5,$D8,  7,$FF,$B2,$97,$FB,$F3,  3,$B2,$1F,$CA,$2D,$D7,$50,$43,$F7,$3F,$BB,$47,$15,$30,$72,$46,$F5,$FE, $E,$27,$4B,$BF,$3C,$54,$14,$FD,$F1,$24,$D9,$51,$3F,$8F,$40,$81,  2,$5D,$45; 1792
		dc.b $FE,$56,$2B,$30,$8C,$BF,$57,$FB,$20,$5F,$E1,  0,$BF,$DC,  6,$7F,$AF,$97,$6C,$73,$45,$FE,  8,$A2,$65,$44,$FF,$70,$90,$FD,$A7,$EF,$C4,$79,$80,$8F,$EF,$84,$B2,$6F,$EA,$E5,$DA,$39,$80,$8F,$EF,$81,$7E,$A8,$76,$C8,$A6,$E3,$18,$5E,  6,$1F,$9E,$FD,$50,$BB,$F4,$5F; 1856
		dc.b $AB,$DE,$3B,  0,$FF,$F0,$12,$FF,$38,  0, $C,$90,$BF,$B4,$49,$FB,$A5,$AC,$68,$EB,$45,$1C,$5B,$15,$33,$B9,$30,$42,$A7,$F0,$41,$53, $A,$FF,$98,$7F,$DC, $E,$CC,$37,$47,$72,$FE,$DB,$F5,$80,$BF,$CE,$32,$CD,$3F,$A2,$BF,$BA,$1B,$90,$93,$F4,$5A,$5D,$51,$88,$2D,$D7; 1920
		dc.b $36,$26,$A7,$3D,$88,$E7,$84,$C6,$52,$C3,$4D,$DF,$B9,  9,$2C,$28,$53,$E1,$B7,$F7,$A5,$C5,$3C,$D0,$9E,$1D,$DB,$D6,$45,$31,$70,$DB,$3E,$D5,$9A,$12,$84,$D1,$FD,$A0,$87,$EF,$4B,$F5,$B1,$9F,$F5,$DF,$AF,$C4,$FB,$78,$11,$E3,$FC,$9F,$D7,$ED,$C3,$8B,$BA,$EF,$D2,$6D; 1984
		dc.b $C2,$62,$9B,$F9,$A5,$36,  7,$89,$7F,$3F,$13,$7F,$EF,$D9,$C6,$82,$E9,$C7,$3C,$C2,$68,$6F,$C6,$33,$30,$8C,$71,$7E,$B6,$5C,  5,$D2,$C2,$78,$7E,$F6,$26,$A7,$8C,$31,$DF,$89,$86,$2F, $F,$DF,$ED,$29,$86,$13,  1,$84,$D8,$4C,$C8,$ED,$62,$CD,$CF,$C5,$C6,  6,$D9,$C7; 2048
		dc.b $F3,$59,$89,$E0,$78,$FF,$3C,$35,$DF,$A6,$FD,$78,$E7,$C2,$7C,$8F,$11,$86,$2F,$18,$33,$F6,$9F,$AD,  5,$38,$FE,$E9,$62,$71,$32,$3C,$7F,$7F,$88,$23,$C2,$49,$FD,$21,$39,$7E,$B6,$32,$87,$EB,$71,$29,$9B,$89,$A9,$C0,$F1,$DF,  6,$44,$E0,$C3,$54,$84,$93,$8C,$A4,$24; 2112
		dc.b $BF,$DD,$9A,$7C,$8F,$1F,$EF,$E2,$62,$EF,$E0,$FE,$89,$1F,$FA,$E8,$4F,$1F,$D6,$8C,$63,$FA,$F3,$C8,$C4,$7A,$6E,$FD,$73,$CA,$6E,$71,$84,$E2,$7C,$31,$3C, $F,$11,$81,$97,$EB,$7F,$48,$8E,$18,$7F,$F7,$23,$C7,$FB,$F8,$98,$CA,$F6,$7F,$3F,$60,$BA,$60,  0,$10,$FD,$EF; 2176
		dc.b $E9,  4,$80,$CB,$9E,$E9,$D7,$F9,$A4,$DC,$4E,$E7,$25,$7B,$B7,$2C,$8B,$6E,$E2,$91,$4D,$84,$D7,$48,$4C,  6,  9,$4F,$DC,$FE,$E9,$15,$23,$4D,$B4,$1B,$A1,$2B,$4F,$74,$AB,$37,$14,$26,$C2,$67,$94,$96,$9F,$9E,$9A,$79,$2E,$73,$5C,$62,$58,$19,$4D,$84,$84,$66,$B9, $E; 2240
		dc.b $79,$4D,$2C,$5F,$2B,$14,$D2,$B5,$D3,$43,$F9,$25,$65,$FE,$41,$DB,$2A,$EA,$2E,$32,$E9,$85,$4B,$BB,$5F,$CF,$60,$78,$6A,$47,$FC,$82,$68,$68,  3,$FB,$DB,$E3,$7A,$F3,$41,$B7,$6F,$2F,$E7,$AE,$B8,$1E,  7,$34,$3A,$66,$5F,$CC,$4D, $D,$97,$4C,$F0,$DC,$26,$D7,$29,$82; 2304
		dc.b $A7,$F2,$87, $F,$D2,$F1,$27,$F0,$55,$FB,$F0,$32,$FE,$FC,$C7,$94,$D7,$C5, $B,$6F,$31,$22,$FE,$E7,$45,$ED,$67,$ED,$E0,$63,$FF,$E0,$65,$D9,$37,$FB,$D9,$D9,$87,$FF,$CB,$5B,$8F,$58,$DF,$32,$F4,$ED,$87,$75,$CF,$8F,$73,$E1,$30,$18,$4D,$97,$EA,$8E,$8A,$90,$E4,$49; 2368
		dc.b $97,$F5,$1A,$4D,$1F,$DF,  4,$60,$7F,$44,$BF,$D2,$F8,$F6,$B6,$2F,$DE,$30,$D4,$8F, $D,$44,$52,$13,$45,$17,$F6,$FC,$5B,$23,$FF,$F9,$C4, $D,$79,$EE,$E7,$8C,$C7,$5F,$E0,$97,$FA,$7B,$75,$2E,$EF,$D7,$80, $C,$17,$EA,$BA,$6E,$FD,$CC,$7B,$95,$38,$B0,$68,$68,$C0,$CB; 2432
		dc.b $F5,$42,$27,$86,$DF,$D2,$7F,$1F, $F,$FF,$80,$46,$3F,$C2,$5F,$F9,$2F,$DC,$80,$26,  2,$1F,$CA,$40,$BF,$D5,$60,$2E,$9B,$9E,$BC,$CB,$FA,$FB,$B5,$32,$FD,$7C,$26,$3C,$A6,$BD,$7F,$72,$A6,$C9,$AE,$98,$DF,$FC,$97,$AF,$F1,$C1,$7F,$FC,  3,$D7,$F3,$DA,$DF,$29,$98,$AC; 2496
		dc.b $98,$AC,$F3,$1D,$2B,$62,$FD,$FA,$9B,$63,$AC,$D8,$18,$23,$FE,$3B,$1A,$80,  0,  5,$DF,$AC,$BB,$F5,$80, $C,$3A,$A1,$FA,$C5,$FD,$60,$BB,$FF,$98,$75,$47,$AA,$F2,$FD,$65,$EB,$52,$3C,$AF,$C2,$FC,$2F,$8E,$72,$9E,$AC,$FD,$5C,$67,$1F,$AA,$8D,$30,$A8,$BA,$D5,$BB,$3C; 2560
		dc.b $A8,$CE,$34,$FD,$D3,$D1,$7B,$A0,$83,$A0,$20,  3,$FF,$5F,$F9,  3,$FE,$60, $D,$DF,$D3,$DB,$72,$60,$91,$E8,$5E,$80,  5,$C9,$92,  0,  0,  1,$7F,$87, $D,  7,$40,$FE,$D2,$50,$6D,$5D,$AA,$91,$45,$42,$DA,$48,$53,  1,$FF,$3A,$69,$B9,$37,  2,$DA,$2E,$FE,$49,$4D,$4B; 2624
		dc.b $B4,$87,$44,$34,$C3,$F5,$49,$1E,$EB,$B6,$92,$47,$6E,$1D,  0, $C,$13,$76,$9B,$84,$76,$85,$CC,$BF,$B2,$49,$87,$2F,$E9,$84,$3F,$DD,$25,$21,$DD,$76,$DC,$36,$C7,$69,$68,$53,$60,$85,$FB,$38,$3E,$EE,$26,$FE,$E9,$36,$19,$6D,$29,$8A,$60, $A,$65,$DA,$5B,$46,$AF,$FE; 2688
		dc.b $9B,$72,$FC,$F6,$E4,$FD,$57,$EE,$61,$31,$77,$42,$62,$9A,$E9,$97,$6A,$6E,$48,$24,$7A,  5,$DB,$93,$76,$94,$DB,$84,$D1,$DA,$53,$65,$D1,$FC,$91, $F,$E1,$8A,$69,$FB,$A4,$59,$8B,$69,$4C,  4,$C5,$B5,$76,$E5,$FF,$30,$5A,$7F,$29, $A,$62,$FD,$CD,$DD,$D7,$4D,  4,$DD; 2752
		dc.b $A6,$E4,  0,  0,  7,$F8,$E8,$98,$4C,$5A, $D,  7,$40,  3,$F5,$5F,$CB,$EE,$FE, $C,$3F,$92,  7,$FC,$C0,$E5,$FB,$A4,$A5,$FF,$B9,$4A,$6D,$82,$5D,$A4,$3A,  0,$17,$7F,$F2,$EF,$D6,$2F,$EB,$2E,$A8,$A8,$A8,$A8,$AA,$FF,$70,$AA,  0,  0,  0,  0,$17,$6E,$87,$EA,$97,$F5; 2816
		dc.b $57,$6E,$CE,$9F,$BB,$5B,$F0,$BE,$14,$5B,$CB,$73,$4A,$9C,$A8,$5B,$E8,$57,$AE,$F5,$BD,$77,$AD,$EB,$BE,$9C,$A9,$FA,$B9,  1,$23,$53,  0,  8,$48,$BA,$40,  0,  5,$AA,$BB,$AC,$AB,  7,$75,$97,$50,  0, $F,$FE, $F,$FE,  0,  7,$FF,  0,$FF,$E0,  3,$26,$FE,$F2,$7D,$5B; 2880
		dc.b $71,$DB,$65,$C7,$D7,$56,$F0,$6D,$71,$78,$5D,$B0,$98,$BF,$66,$5A,$63,$37,$F5,$4D,$FD,$57,$1E,$CA,$95,$EF,$2B,$DF,$59,$C9,$DD,$56,$95,$13,$11,$32,$ED,$2D,$BF,$F3,$FF,$AA,$F6,$61,$FF,$FE,$9D,$7F,$76,$3B,$AE,$FD,$9C,$7F,$EB,$D8,$3F,$FF,$9E,$B7,$FE,$62,$F0,$BB; 2944
		dc.b $57,$69,$7F,$8F,$FE,$BD,$83,$FF,$FA,$FF,  7,$53,  5,$FC,$92,$9B,$F8,$6F,$D3,$F8,$A7,$22,$FE, $E,$2E,$CE,$2D,$9C,$A7,$FD,$FC,$EB,$5E,$6A,$DA,$B7,$4C,$53,$17,$EE,$4B,$52,$99,$36,$7E,$60,$9E,$85,$C5,$FA,$B3,$B7,$F6,$EF,$FE,$69,$34,$BF,$58,$B3,$93,$61,$5B,$54; 3008
		dc.b $F5,$CB,$F9,$25,$DD,$FF,$3F,$FA,$F6, $F,$FF,$FE,$A2,$FF,$CC,$1E,$DC,$36,$96,$D5,$9B,$FE,$7F,$F5,$EC,$1F,$FF,$3D,$7F,$A2,$B3,$47,$6A,$FE,$E4,$BF,$E7,$FF,$5F,$E8,$8B,$FF,$FF,$AF,$F4,$75,$29,$B0,$42,$FE,$4A,$FF,$8F,$FA,$B3,$63,$1E,$A7,$F4,$95,$76,$1A,$CF,$57; 3072
		dc.b $DE,$4F,$96,$DC,$5B,$D6,$EA,$97,$EA,$A3,$5A,$65,$5A,$65,$5A,  1,$85,$69, $E, $F,$A5,$F8,$9A,$DE,$BB,$D6,$F5,$DE,$B7,$AE,$F5,$BD,$77,$AD,$EB,$BD,$6F,$5D,$EB,$7A,$EF,$C6,$99,$D3,$96,$AC,$29,$11,$E8,$70,$34,$23,$11,$92,$64,$E4,$E3,$BB,$F6,$45,$D7,$17,$33,$4D; 3136
		dc.b $8E,$FC,$F0,  0, $E,$8D,$90,$4E,$3D,$20,$DE,$5F,$AE,$75,$8E,$DB, $A,$F7,$91,$BB,$B4,$8D,$4D,$D6,$7F,  8,$5E,$E9,$32,$EB,$DD,$91,$8D,$9F,$DA,$E3,$C3,$66,$F8,$FE,$DA,$F5,$32,$D9,$F9,$8B,$DF,$79,$6C,$FC,$C3,$A4,$FB,$CB,$61,$1B,$A4,$FB,$CB,$F5,$59,$EB,$BF,$10; 3200
		dc.b $32,$AE,$15,$7F,$4D,$DF,$A8,$BE,$AF,$4E,$DF,$CC,$43,$F5,$DD,$64,$F9,$17,$57,$F1,$EB,$B2,$DC,$5B,$9E,$8E,$7D,$FF,$9E,$42,$BF,$65,$F1,$BF,$66,$17,$8F,$FA,$7F,$DF,$F5,$5F,$C7,$FC,$F1,$73,$C0,$CB,$F3,$C5,$3A,$BF,$A7,$F3,$DC,$E7,$B0,$8D,$71,$23,$53,$FC,$F1,$F1; 3264
		dc.b $59,$C9,$3A,$3B,$FE,$FF,$D7,$DD,$96,$23,$F9,$A5,$39,$7F,$3A,$72,$C4,$E3,$8A,$4E,$EF,$D9,$EF,$AF,$F1,$FA,$8B,$8B,$F4,$BB,$2A,$46,$5B,$38,$DE,$64,$F2,$E9,$71,$3C,$8E,$17,$BC,$60,$DC,$66,$FE,$40,$15,$C9,$E6,$21,$D2,$94,$E9,$FD,$44,$3F,$31,$DA,$E3,$CF,$4F,$D2; 3328
		dc.b   0,  0,$19,$56,$15,$FD,$35,$16,$B4,$17,$56,$82,$EA,$D2,$EA,$43,$F7,$4B,$BA,$EF,$FD,  1,$86,$E8,$7E,$A9,$7F,$54,  5,$DB,$B3,$A7,$29,$1A,$DF,$BA,$CB,$4E,$51,$A1,$5F,$85,$F8,$5F,$85,$F8,$5F,$1E,$9F,$E1,$80,  0,$C9,$D7,$71,$D7,$47,$5E,$55,$81,$82,$4A,$8B,$92; 3392
		dc.b $B1,$E3,$AC,$5D,$D5,$75,$44,$2F,$75,$A3,$7B,$A5,$91,$80,  0,$EB,$FD,$23, $D,$D2,$7F,$4C, $D,$DC,$4F,$BA,$F4,  0,$A9,$34,$4E,$6E,$21,$FC,$2F,$D6,$81,$94,$C3,$FD,$25,$FF,$4B,$BF,$49,$CF,$5C,$E8,$58,$B6,$3F,$9E,$32,$DB,$AB,$A7,$C7,$7F,$E9,$36,$FE,$90,$2F,$F7; 3456
		dc.b $A3,$CD,$B7,$77,$EE,$F8,$FF,$7F,$F9,$EF,$EB,$DF,$FD,$86,$BB,$FC,$93, $F,$EF,$2F,$F4,$57,$FB,$7C,$45,$8E,$BF,$C9,$FC,$F6,  7,$8B,$2E,$73,$CD,$91,$9C,$98,$4C,$C1,$83,$86,$4C,$32,$99,$26,$FD,$B3,$E1,$D2,$F9,$41,$FC,$4E,$38,$25,$E0,$5C,$71,$3C,$90,$F3,$8D,$70; 3520
		dc.b $A8,$C2,$A3, $A,$8C,$2B,$1F,$D6,  0,  0,  5,$FF,$C8,$F5,$4F,$5F,$DE,$AD,$F8,$5E,$B7,$A9,$95,$FD,$50,$FD,$62,$FE,$B0, $B,$BF,$5B,$D5,$1B,$FA,$A0,$7D,$57,$54,  0,  5,$DB,$F0,$DE,$32,$60,$C1,$8F,$19,$27,$EB,$D9,$99,$BD, $B,$6B,$E9,$D1,$36,$CD,$20,$FD,$22,$C0; 3584
		dc.b $97,$70,$17,$1B, $B,$F8,$6E,$D2,$5F,$E3, $F,  0, $C,$BF,$E7,$FF,$30,  0,  1,$32,$40,  0,  0,$24,$DF,$C2,  0,  2,$A4,$85,$D3,$49,$B7,$66,$D2,$FE,$62,$D6,$35,$5F,$E6,  0,  0,$2F,$DE,$47,$F7,$80,  0,  0,$26,$1B,$80,  0,$5D,$38,$5F,$E1,$6A,$97,$5E,$2E,$BC,$5D; 3648
		dc.b $78,$BA,$FC, $F, $F,$EA,$4D,$2F,$EC,$CA,$6F,$FE,$80,  0,$9A,$5D,$D2,$9B,$8A,$6F,$D2,$4D,$29,$BF,$FA,  0,$18,$6D,$97,$F2,$4A,$79,$BF,$A9,$37,$FF,$40,  3,$9F,$FA,$5B,$59,$76,$DC,$27,$C4,  0,$27,$B9,$C7,$9A,$E6,$6E,  2,$E9,$E9,$35,$D3,$71,$5C,$D0,$D0,$D7,$27; 3712
		dc.b $F4,$88,$C6,$1F,$F9,$FF,$A0,$1F,$FF,$FF,$90,$1F,$F9,$FF,$A0,$1F,$FF,$71,$E6,  5,$D3,$53, $F,$D2,$64,$DC,$1B,$83,$41,$7E,$99,$B0,$67,$EE,$5A,$4C,$9A,$9F,$B9,$6A,$A6,$DB,$93,$6C,$36,$D3,$F7,$3B,$FF,$92,$D5,$6F,$73,$63,$DC,$C6,$AB, $B,$42,$99,$B0,$DC,$53,$34; 3776
		dc.b $A6,$2E,$E6,$AF,$71,$4C,$D2,$61,$6E,$8C,$C5,$A1,$4C,$D2,$6F,$EE,$5B, $A,$F7,$70,$69,$32,$33,$AE,$2B,$B6,$44,$93,$AC,$D2,$26,$B1,$76,$C9,$71,$5D,$A4,$D2,$9E,$13,$C3,$F7,$32,$83,$6B,$49,$6D,$93,$49,$89,$3A,$B8,$B4,$2D,$BD,$64,$C2,$98,$A6,$EB,$2C,$60,$D2,$9E; 3840
		dc.b $1B,$5B,$3C,$9B,$25,$E7,$93,$49,$BB,$78,$9B, $D,$F4,$9A,$CD,$26,$96,$85,$8C,$58,$B3,$AB,$74,$DA,$55,$69,$30,$B6,$93, $B,$48,$E2,$4C,$2E,$E2,$9C,$A9,$34,$36,$97,$FB,$E5,$94,$F9,$4F,$82,$4F,$83,$32,$C7,$29,$F2,$DB,$C1,$AA,$CD,$A5,$3A,$B0,$91,$71,$8D,$15,$8B; 3904
		dc.b $62,$98,$A7,$AB,$6C,$5B,$4B,$15,$4B,$14,$C4,$C5,$98,$A6,$2B,$55,$A4,$DE,$EA,$D1,$AB,$DD,$44,$56,$12,$12,$5D,$45,$9D,$6C,$53,$14,$F8,$95,$8B,$69,$63,$46,$A5,$8A,$62,$A2,$CC,$53,$15,$89,$A4,$DE,$EA,$EF,$26,$6D,$A4,$18,$56,$D2,$8D,$5B,$56,$E6,$14,$DA,$51,$A4; 3968
		dc.b $96,$29,$A8,$D2,$6D,$8A,$68,$36,$CB,$DC,$B6,$FE,$4E,$F7,$7F,$75,$C0,  0,  0,$FF,$98,  0,  1,$77,$E8,$AE,$FD,$10,  0, $F,$E1,$13,$AE,$7B,$8B,$F8,$56,$FD,$10,  0,  0,$22,$E2,$E3,$83,$89,$D0,$E3,$57,$93,$DD,  7,$93,$E3,$B1,$4D,$7B,$4A,$F5,$D8,$B7,$B8,$B6,$2D; 4032
		dc.b $EE,$2E,$D2,$61,$3C,$BB,$49,$EA,$F2,$7C,$2F,$23,$2E,$95,$32,$30,$5D,$11,$4C,$B4,$5F,$E3,$4B,$F8,$EA,$E8,$19,$6C,$27,$11,$95,$E4,$F5,$E8,$23,$57,$43,$43,$78,$C1, $C,$BF,$AF,$27,  0,  2,$FE,$C9,$78,$CB,$B7,$8D,$5F,$1F,$D1,$7E,$D4,$9D,$17,$5B,$61,$38,$9C,$F2; 4096
		dc.b $BC,$B8,$DF,$7C,$1C,$F1, $D,$1C,$A7,$91,$C7,$62,$99,$68,$5C,$CA,$87,$1D,$21,$D1, $D,  0,$11,$42,$4B,$90,$92,$3D,$17,$74,  0,  0,$C3,$FC,$64,$85,$A4,$10,$91,$74,$54,$B9,$15,$2E,$40,  9,$2D,$FA,$2E,$B6,$59,$FD,$3C,$36,$19,$68,$B7,$E8,$BF,$B3,  0, $B,$3E,$DB; 4160
		dc.b $3A,$DC,$4E,$2E,$37,$AF,$69,$76,$95,$E5,$FB,$72,$D0,$CB,$B6,$EF,$DB,$92,$11,$FE,$DE,$E7,$AB,$8F,$87,$ED,$48,$DE,$4E,$2E,$32,$38,$38,$9E,$BB, $B,$61,$AF,$69,$5E,$BB,$16,$F5,$7C,$3F,$A2,$5D,$32,$FD,$33,$E5,$69,$59,$FC,$1E,$E5,$BD,$4D,$EE,$C0,$E0,$71,$7B,$AF; 4224
		dc.b $C3,$A5,$4D,$6F,$2B,$C9,$E5,$69,$7E,$D7,$8C,  0,  9,$D9,$7E,$8A,$3C,$6B,$C6,$BF,$D2,$18,$7E,$D5,$5D,$6E,$62,$73,$CC,$16,$84,$E7,$99,$22,$A0,$75,$B8,$BF,$6E,  7,$ED,$5D,  3,$23,$27,$F1,$A9,$91,$96,$C7,$44,$E3,$D0,$46,$4F,$67,$1A,$29,$BA,  7,  4,$85,$E4,$6A; 4288
		dc.b $F2,$FE, $A,$BC,$BA,$49,$C5,$B0,$8C,$9E,$4E,$79,$7E,$DD,$78,$E3,$FB,$7F,$D3,$3B,$F6,$6A,$8A,$64,$64,$8B,$CD,$75,$E4,$91,$3C,$8F, $B,$D5,$20,$91,$FD,$9C,$3A,$21,$A4,$10,$93,  4,  0,$65,$FC,$37,$23,$AE,$E9,$4B,$8D,$50,$64,$97,$68,$49,  4,$2D,$30,$47,$24,$1D; 4352
		dc.b $62,$38,$9B,  0,$FE,$98,$40,$81,$D6,$75,$9D,$6D,$84,$F2,$ED,$71,$74,$93,$F0,$38,$3A,$27,$1D,$20,$F2,$45,$42,$38,$E9,$1B,$39,$74,$75,$80,$53,$24,$8B,$F0,$71,$3F,  7,$41,$2E,$35,$D3,$65,$9C,$B7,$E0,$77,$20,$C9,  6,  9,  3,$86,$90,$FE,$3F,$E9,$1C,$38,$EE,$ED; 4416
		dc.b $74,$6F,$27,$BA,$E3,  0,$DF,$FA,$2F,$DA,$59,$C0,$9F,$73,$9E,$62,$2E, $A,$71,$70,$87,$5F,$E9,$18,$6E,$BE,$1A,$5C,$83,$24,$10,$38,$E8,$47,$87,$F4,$CB,$4B,$B4,  8,$12,$28,$BF,$C3,$11,$4C,$91,$6F,$61,$92,  5,$30,$5B,  6,$4F,$89,$8E,$9D,$92,$64,$10,$71,$C0,$C9; 4480
		dc.b $36,$39,$F1,$32,$79,$5E,$48,$46,$46,$A9,  3,$B9,$22,$8A,$FF,$DA,$59,$C9,$91,$C5,$D8,$38,$9E,$46,$AE,$D9,$17,$42,$F2,$71,$3C,$8C,$43,$85,$E5,$A4,$74,$B9,  4,$50,$2E,$83,$F6,$63,$A0,$24,$12,  9,$82,$43,$F6,$70,$FD,$9C,$7A, $B,$A0,$BF,$C6,$48,$5D,$19,$24,$3A; 4544
		dc.b $22,$90,$40,$A8,$22,$81,  9,$2E,$4C,$90,$21,$26,$1A,  0,  4,$3A,$F8,$FF,$67,$B2,$F2,$E8,$23,$54,$81,$AA,$44,$F2,$30,$32,$45,$D0,  0,$81,$52,$E4,  8,$49,$82,$43,$F6,$6A,$84,$98,$68,  0,  3, $F,$E1,$88,$20,  8,$A9,$14,$C1,$15, $B,$A3, $A,$1B, $A,$96,$74,$B1; 4608
		dc.b $CD,$C6,$4E,$5F,$CF,$4A,$D8,$91,$96,$25,$22,$C4,$A4,$B6,$5A,$46,$CB,$20,$24,$58,$CA,$D8,$BA,$46,$EA,$48,$F1,$AC,$8E,$B2,$B3, $B,$12,$96,$25,$67,$15,$AE,$91,$59,$6C,$B2,$27,$2D,$8A,$CA,$E8,$DB,  9,$63,$67,$4B,$17,$58,$F9,$3C,$C9,$E4,$CE,$46,$59,$91,$94,$EC; 4672
		dc.b $79,$66,$47,$A3,  9,$94,$E0,$B6,$D2,$5A, $C,$24,$52,$C6,$CE,$96,$2C,$B1,$F2,$79,$93,$D7,$91,$96,$64,$6C,$CC,$8C,$B3,$23,$26,$42,$8A,$85,$C0,$8E,$1A,$13,$30,$42,$61,$96,$32,$B6,$26,$F3,$7D,$2F,$CE,$B7,$D4,$C9,$85,$99,$1E,$6A,$FC,$8F,$23,$27,$E4,$F1,  3,$CC; 4736
		dc.b $9E,$79,$BC,$8F,$93,$CC,$9E,$BC,$8C,$B3,$23,$2C,$C8,$CB,$32,$3B,$A9,$91,$80,$64,$79,$93,$CF,$36,$11,$F2,$79,$93,$D7,$91,$96,$64,$65,$99,$19,$66,$47,$75,$32,$30,$AC,$B8,$C9,$3F,$4A,$C2,$3C,$19,$82,$17, $B,$B4,  8,  0,$FF,$A8,$66,$49,$FA,$6B,$91,$78,$13,$17; 4800
		dc.b $45,$65,$DA, $D,$3F,$EA,  0,$26,$61,$FA,$6B,$BF,$6C,$4C,$56,$13,  9,$85,$FF,$6F,$D3,$13,  9,$84,$C5,$61,$30,$98,$4C,$FD,$99,$26,  8,$5A,  0,$3F,$EA,$CC,$B8,$13,  9,$8A,$C2,$61,$30,$B8,$7F,$CC,  1,$64,$FE,$AF,$E9,$B0,$61,$30,$98,$A9, $F,$D3,$61,$FA,$62,$E8; 4864
		dc.b $56,$5D,$FB,$31,$FF,$50,$2E,$61,$30,$98,$5C,  9,$84,$C2,$61,$7F,$CC,$47,$F6,$76,$4B,$24,$58,$4C,$54,$2F,$D9,$92,$12,$45,  0,  3,$FE,$A3,$86,  8,$5F,$D6,$2F,$F1,$80, $B,$FE,$79,$26,$5A,$12,$12,$17,$F4,$C9,$15,  9,  0,$8F,$F4,$C9,$2E,$E8,$24,$2D,  9,  9,  9; 4928
		dc.b   0,  2,$EE,$C0,  0,$1C,$B7,$72,$DD,$FD,$15,$DD,$CB,$F7,$40,  0,  7,$2D,$DC,$B7,$72,$DD,$CB,$70,  0,  1,$86,$EC,$37,  0,  6,$1B,$97,$F7,$57,$F2,$5E,$6E,$5B,$B9,$6E,  0,$47,$FF,$58,$5E,$BD,$9B,$39,$6E,$E5,$D4,$32,$FE,$57,$EA,$CD,$6F,$FD,$BD,$FF,$B7,$5F,$FB; 4992
		dc.b $EC,$5D,$8B,$FF,$BC,$3F,$55,$FC,$BF,$D3,$7F,$1C,$7E,$DD,$76,$47,$66,$17,$AD,$FC,$B7,$72,$DD,$FF,$C1,$1D,$91,$FF,$BA,$EC,$11,$BD,$6F,$E5,$BB,$96,$EF,$FE, $D,$8B,$B1,$7F,$6E,$BF,$B7,$C2,$F5,$BD,$7B,$39,$6E,$E5,$BB,$AB,$F5,$74,$E5,$13,$87,$ED,$F9,$97,$67,$32; 5056
		dc.b $F6,$73,$2F,$34,$79,$7F,$6B,$F5,$7B,$A1,$DB,$C2,$BC,$B6,$61,$7E,$C5,$D9,$1F,$DB,$AD,$F1,$BD,$6F,$5E,$5F,$BA,$E4,$3F,$88,$3F,$49,$BF, $D,$9B,$E3,$B1,$77,$8D,$FF,$FB,  3,$F4,$83,$F8,$83,$23,$C8,$FF,$E8,  0,$FE,$A4, $E,  7,$C4,$46,$47,  3,$23,$C2,$56,$95,$A5; 5120
		dc.b $69,$58,  0,$25,$6F,$DA,$6E,$81,$91,$E2,$DC, $C,$A5,$69,$5A,$5F,$A5,  0, $D,$DC,$B7,$2B,$71,$6F,$4E,$E2,$71,$D7,$16,$E2,$4D,$AB,$6B,$8B,$71,$87,$34,$6F,  0,  0,$16,$F8,$F3,$2F,$65,$EB,$CC,  0,$17,$AF,$67,$32,$F3,$47,$9A,$37,$80,$23,$7A,$F6,$73,$2F,$36,$17; 5184
		dc.b $80,  2,$F6,$5E,$BC,$CB,$CD,$1E,$65,$E6,$8D,$E0,  5,$BE,$3C,$CB,$CD,$1B,$C0,  3, $B,$F0,$BC,  0,  0, $B,$7C,$79,$A3,$78,  0,  8,$DE,$BD,$9D,$97,$AD,$EB,$78,  0,$47,$F7,$D7,$AF,$EF,$B9,$A3,$CD,$1E,$6C,$2F,  2,$3F,$AE,$6E,$2D,$C5,$B0,$38,$FE,$F8,$8C,$BA,$57; 5248
		dc.b $F7,$DC,$CB,$7A,$FF,$46,$37,$85,$C5,$B8,$B7,$1F,$D7,$8C, $C,$B1,$69,$19,$19,$1A,$FF,$7A,$FC,$39,$B0,$BE,$2D,$FE,$63,$71,$54,$82,$38,$D2,$3A,$29,$F4,$13,$7F,$3D,$FA,$FF,$CF,$2F,$F4,$61,$FC,$18,$5E,$57,$C0,$E1,$D9,$D9,$1B,$C0,  0,  0,$16,$F8,$DE,$46,$BF,$C1; 5312
		dc.b $2E,$65,$E6,$5E,$68,$99,$70,$5B,$D8,$F5,$BD,$7F,$6E,$B7,$AF,$67,$61,$95,$E4,$65,$D2,$46,$BD,$24,$C7,$B1,$E6,$5C,$17,$FE,$EB,$B2,$37,$AF,$64,$3A,$63,$7E,  7,$91,$97,$44,$4D,$17,$40,$8A,$7A,$2A,$19,$74,$F4,$17,$F0,$49,$16,$F2,$BE,$26,$A6,  1,$26,$5D,$18,$7E; 5376
		dc.b $CF, $D,  0,$87,$ED,$AF,$E0,$BF,$F7,$5D,$91,$BD,$7B,$23,$78,$19,$1E,$46,  0,  0,$44,$C8,$C8,$E0,$63,$9B,  3,$8D,$E3,  3,  1,$4D,$4D,$4E,$73,$27,$19,$5F,$CE,$6E,$32,$BC,$AB,$D2,$E3,$AA,$9D,$4D,$C5,$39,$55,$27,$4B,$E7,$39,$D1,$C5,$57,$55,$27,$34,$2A,$BA,$AE; 5440
		dc.b $A9,$55,$D7,$CF,$7B,$A7,$29,$FA,$67,$71,$4F,$53,$5A,$99,$4E,$85,$58,$38,$C8,$DB,$7D,$5D,$54,$72,$11,$CE,$EA,$9A,$2D,$4C,$AF,$42,$3A,$A1,$5E,$95,$34,$76,$8E,$4A,$A1,$38,$90,$90,$D1,$7A,$B4,$3A,$B5,$CD,$AC,$3A,$9C,$BA,$75,$2B,$6A,$B3,$B4,$93,$A9,$22,$75,$D0; 5504
		dc.b $A7,$53,$AA,$9D,$49,$2A,$5A,$2B,$91,$A4,$75,$71,$4F,$5D, $E,$A4,$85,$5D,$2A,$68,$4D,$27,$23,$4E,$A8,$E2,$73,$52,$AD,$BD,$67,$4A,$91,$95,$52,$76,$92,$11,$B4,$9A,$46,$49,$3B,$4D,$1A,$70,$AB,$B4,$A9,$A5,$53,$7A,$54,$FA,$8A,$76,$A1,$1A,$A1,$D8,$92,$76,$95,$51; 5568
		dc.b $86,$5F,$AF,$54,$9D,  9,$AE,$DE,$93,$AA,$39,$AA,$E2,$6A,$14,$F5,$E8,$6B,$91,$D5,$6A,$35, $D,$15,$B6,$24,$27,$23,$51,$ED,$57,$C2,$7D,$EA,$96,$4A,$93,$4A,$8D,$B2,$13,$48,$E0,$6C,$D1,$CD,$A9,$19,$75,$35,$C5,$62,$79,$34,$9C,$C2,$47,$51,$1B,$66,$59,$2D,$C1,$D6; 5632
		dc.b $54,$62,$31,$E4,$8E,$82,$31,$2D,$3B,$4D,$74,$B2,$B8,$9A,$E4,$B3,$67,$4B,$11,$F0,$47,$56,$8D,$4A,$54,$AD,  6,$95, $A,$D3,$B5,$29,$5B,$29,$D8,$98,$56,$46,$D7,$85,$4C,$91,$59,$42,$9F,$87,$55,$96,$A9,$66,$13,$A8,$D2,$6A,$2B,$D6,$A5,$5B,$7E,$9A,$D5,$2A,$A1,$31; 5696
		dc.b $18,$4D,$62,$6E,$B7,  5,$6D,$68,$C2,$62,$D4,$ED,$C2,$A9,$62,$7A,$32,$A5,$52,$4E,  9,$52,$AA,$35,$18,$85,$44,$A9,$35,  9,$19,$6A,$93,$51,$84,$84,$CA,$A7,  2,$4B,$30,$AB,$66,$13,$11,$95,$26,$93,$68,$85,$52,$AB,$16,$CC,$4A,$1B,$2A,$DE,  9,$63,$62,$59,$29,$5D; 5760
		dc.b   9,$3A,$D5,$2C,$95,$6B,$37,$93,$11,$B4,$2B,$12,$32,$1C,$2C,$4C,$42,$B7, $B,$12,$2A,$32,$88,$49,$D6,$94,$2A,$A1,$59,$96,$A9,$54,$98,$85,$62,$A6,$8C,$D2,$CC,$EB,$54,$6D,$18,$84,$85,$55,$AB,$2C,$4C,$A2,$B7,$AC,$BA,$E8,$D4,$B3,$2D, $B,$21,$32,$DA,$30,$90,$98; 5824
		dc.b $DA,$92,$12,$5A,$AA,$C6,$D3,$AE,$B4,$AD,$16,$96,$4E, $D,$5A,$AB,$15,$B4,$65,$90,$98,$48,$B4,$AC,$19,$6A,$2D,$11,$52,$36,$6B,$11,$AB,$5B,$75,$34,$AA,$55,$6D,$55,$A9,$4C,$98,$DA,$35,$5B,$68,$23,$69,$D7,$A1,$31,$58,$A9,$62,$4B,$2A,$12,$41,$88,$C2,$65,$18,$56; 5888
		dc.b $42,$4B,$36,$CB,$62,$61,$25,$90,$AC,$C8,$52,$A5,$65,$B5,$55,$B6,$4C,$10,$B8,$55,$68,$96,$62,$B6,$A5,$FA,$56,$4D,$49,$B7,$EE,$6C,$76,$47,$66,$48,$22,$F4,  9,  6,  6,$3D,$38,$B6,$70,  0,  8,$CB,$61,$81,$19,$6C,$30,$30,$7C,$A2,$F6,  0,$82,$E7,$B3,$88,$60,$F0; 5952
		dc.b $F0, $D,$E3,$81,$A2,$DA,$5C,$6C,$95,$E3,$23,$C1,$EA,$EB,$90,$98,$96,$42,$7A,$A1,$39,  1,$38,$B8,$89,$C8,$49,$6B,$C0,  6,$2E,$D9,$61,$77,  4,$39,$3C,$98,$22,$F9,  0,$22,$F3,$18,$3C,$DF,$2D,$80, $E,  0,$2E,$C5,$7D,$CC,$23,$65,$E4,$6E,$91,$3C,  5,$37,$F1,$91; 6016
		dc.b $AB,$F5,$6D,$57,$6E,$A4,$92,$D7,$15,$BD,$CF,$FE,$99,$1D,$2B,$CF,$4D,$77,$E0,$60,$C9,$91,$D8,$DD,$7F,$3D,$17,$DD,$B6,$F5,$9B,$3B,$BF,$87,$D4,$DD,$7A,$B7,$E8,$65,$7A,$9B,$1F, $D,$3F,$5F,$35,$75,$E0,$F9,$16,$8F,$FC,$C3,$11,$E5,$CC,$5D,$31,$FF,$9F,$3E,$B4,$6F; 6080
		dc.b $55,$22,$99,$70,  6,$5B,$23,$8E,$BB,$56,$6D,$5C,$F5,$CE,$62,$37,$33,$FE,$7C,$AB,$4A,$B6,$B3,$8E,  4,$E1,$81,$C0,$FF,$6E,$58,$D3,$F9,$14,$ED,$2E,$66,$74,$CD,$8C,$D9,$EF,$C7,$51,$13,$53,$27,$88,$1B,$FF,$31,$32,$E2,$DD,$50,$8E,$6C,$C8,$C9, $D,$DD,  4,$6E,$D7; 6144
		dc.b $F7,$7F,$98,$CF, $D,$CB,$BB,$6E,$9B,$B4,$11,$D1,$7B,$23,$FF,$37,$7F,  5,$D9,$A4,$10,$92,$90,$42,$E8,$54,$85,$FA,$2D,$E1, $B,$98,$90,$BF,$A7, $F,$F5,$BB,$6C,$26,$A2,$2F,$70,  5,$A2,$DE,$BC,$D8,$7E,$CF,$8F,$4A,$B2,$7A,$55,$94,$9F,$19,$67,$A9,$96,$A5,$37,$16; 6208
		dc.b $2D,$91,$19,$4F,$33,$CA,$45,$8E,$8C,$29,$A9,$B5,$6D,$A4,$B4,$18,$48,$9D,$69,$3B,$1B,$16,$35,$3C,$6B,$23,$7D,$27,$7C,$D3,$CD,$C2,$5D, $C,$47,$58,$AC,$B6,$29,$2D,$95,$C5,$2B,$9C,$B6,$CA,$C5,$C5,$6F,$D2,$3A,$5F,$98,$CC,$8E,$98,$99,$3A,$85,$33,$88,$C9,$D0,$71; 6272
		dc.b $6B,$D4,$6B,$48,$DA,$42,$B2,$2A,$E1,$A9,$63,$2B,$49,$C4,$72,$A1,$19,$54,$8E,$9A,$9B, $A,$92,$D5,$C5,$33,  8,$E4,$BA,$AC,$AC,$B3,$4A,$B2,$27,$15,$6C,$56,$57,$46,$D8,$71,$58,$B8,$9D,$25,$CC,$8E,$98,$9E,$B4,$74,$A6,$71,$1E,$B4,$83,$8A,$5A,$94,$CB,$48,$CC,$BA; 6336
		dc.b $D4,$AB,$1A,$DD,$AA,$C8,$B1,$29,$AB,$8C,$8E,$54,$D4,$CA,$A4,$74,$29,$98,$54,$2D,$68,$46,$E9,$1F,$EA,$3F,$48,$53,$16,$B3,$2F,$16,$2B,$62,$B2,$BA,$36,$87,$51,$71,$5B,$F4,$8E,$92,$E6,$47,$46,$1C,$B7,$11,$D0,$8C,$B1,$92,$D2,$36,$E2,$A7,$12,$D9,$64,  4,$8B,$19; 6400
		dc.b $5A,$4E,$91,$CA,$84,$65,$52,$3A,$11,$B0,$A8,$B8,$91,$B0,$8F,$88,$B8,$8A,$56,$5B,$2C,$89,$CB,$62,$B2,$BA,$36,  5,$D4,$30,$EA,  0,  1,  0; 6464
Nem_TitleSonicTails:dc.b $80,$C1,$80,  4,  4,$14,  5,$25, $E,$35, $F,$45,$12,$55,$15,$66,$32,$73,  0,$81,  3,  1,$15,$11,$27,$75,$38,$F1,$82,  6,$36,$83,  4,  6,$17,$6E,$28,$F4,$84,  6,$2E,$18,$EF,$85,  5,$18,$86,  5,$14,$17,$74,$28,$F6,$87,  5,$10,$17,$72,$88,  6,$38,$89,  6,$34; 0
					; DATA XREF: ROM:000032A2o
		dc.b $18,$F3,$8A,  6,$33,$8B,  6,$35,$18,$F0,$8C,  7,$6F,$18,$F2,$8D,  6,$2F,$17,$76,$8E,  5,$13,$17,$73,$8F,  5,$16,$18,$EE,$FF,  0,  0,  6,$44,  0,  0,  3,$22,  0,$1E,$32,$DB,$17,$46,$BD,$F1,$77,$5F,$C9,$2C,$2B,$B2,$7E,$9D, $A,$FF,  5,$CC,$3F,$87,$2F,$D2,$BF; 64
		dc.b   9,$CB,$C7,$BF,$70,  0,  0,$23,$23,$BA,$2A,$59,$F1,$D8,$A3,$39,$AB,$B1,$56,$5D,$9F,$FA,$55,$8A,$C1,$C5,$6E,$6B,$BD,$36,$60,$2B,$17,$C5,$B6,$71,$4D,$A2,$87,$F4,$48,$50,$B1,$52,$AC,$52,$2E,$28,$6A,$45,$48,  3,$2F,$F9,  0,  0,$19,$17,$F5,$64,$EA,$9B,$32,$14; 128
		dc.b $FC,$93,$15,$6D,$A2,$F8,$D4,$80,  0,  0,  1,$97,$FC,$80,  0,$3B,$FE,$3F,$F3,  0,  0,$1D,$BA,$4D,$97,$A0,  1,$FE,$2A,$69,$FB,$74,$A2,$7E,$DD,$68,$53,$AC,$3F,$44,$DF,$A2,$60,  0,$FF,$8A,$7F,$4D,$1A,$AC,  0,  0,$7F,$CE,$5F,$A4,$77,$7F,$4B,$B7,$25,$D4,$4D,$B5; 192
		dc.b $5D,$DB,$69,$A9,$7B,$78,$57,$76,$66,$AD,  3,$5E,$55,$6B,$BF,$A4,  0,  3,$FA,$2B,$FC,$34,$8C,$BD,  0, $F,$F4,$A6,$EE,$9F,$A4,$3D,$E5,$23,$DD,$ED,$FA,$E8,$ED,$E7,$D5,$75,$8A,$FB,$14,$F6,$77,$47,$75,$74,$57,$3D,$F1,$76,$68,$D0,$4F,$D5,$26,$A9,$A5,$F9,$BF,$F2; 256
		dc.b $47,$7F,$B5,$E0,  0,  1,$11,$97,$A4,$6B,$B8,$AF,$F0,$D0,$A6,$3B,$F9,$5C,$91,$5D,$CA,$DF,$BF,$8A,$F5,$E2, $E,$F6,$58,$3E,$8B,$B3,  5,$A3,$D8,$32,$E8,$6F,$75,$1F,$61,$DC,$99,$E4,$C6,$F0,$BC,$F4,$4B,$D3,$9C,$A7,$2D,$E2,$62,$5B,$4C,  0,  0,  0,  0,$2A,$72,$63; 320
		dc.b $93,$1C,$98,$8C,$98,$87,$33,$98,$BB,$70,$64,$63,$26,$77,$EB,$D5,$90,$FE,$BB,$C4,$10,  0,$1E,$37,$6E,$D9,$D8,$82,$1A,$9D,$C5,$60,$EB,$9E,$5A,$ED,$B2,$2F,$6B,$9C,$76,$2A,$CF,$6B,$B6,$C8,$80,$2B,$B0,  2,$4C,$13,$60,$32,$A1,$91,  9,$B5,$76,$C8,$A1,$AD,  6,$D5; 384
		dc.b $E1,$1A,$5A,$F3,$AE,$A1,$36,$DD,$76,$ED,$B4,$6F,$C9,$72,$42,$BD,$F4,$83,$AE,$D9,$A8,$F6,$20,  4,$23,$28,$D7, $E,$32,$35,$29,$17,$EA,$C3,$73,$E9,$59,$A5,$9B,$2C,$33,$A8,$B6,$DF,$53,$94,  0,$83,$A1,$95,$9D,$67,$C1,$21,$7A,$7E,$A2,  9, $C,$70,$9A,$7E,$63,$4A; 448
		dc.b $41,$74,$9D,$A7,$48,$61,$69,$C9,$D8,$94,$17,$F6,$AD,$77,$F6,$7B,$80,  0,$64,$D5,$6A,$B0,$4B,$9E,$D5,$65,$B9,$95,$96,$ED,$93,$73,$CC,$AE,$DB,$23,$2B,$B6,$73,$77,$EC,$5D,$76,$E2,  0,  0,$3E,$FF,$D5,$BF, $C,$BF,$AB,$73,$3F,$3A,$95,$83,$29,$56,$B9,$4C,$A2,$FE; 512
		dc.b $EF,$EF, $A,$F2,$7F,$2D,$99,$5A,$1F,$92,$29,$BA,$ED,$90,$BA,$ED,$A2,$EB,$B6,  6,$5B,$1A,$90,  0,$15,$98,$C8,$D6,$62,  0,  1,$94,$2B,$60,$73,$91,$B2,$6B,$9B,$CA,$14,$D7,$3A,$94,$CF,$C2,$B1,$FF,$F7,$F5,$D7,$FA,$5C,$BF,$A3,$F9,$2A,$C4,  0,  0,  9,$CC,$BE,$7D; 576
		dc.b $26,$F2,$B0,$B3,$A0,$BC,$A5,  3,$95,$B2,$B5,$60,$72,$80,$86,$44,$56,$19,$19,$85,$68,$24,$26,$AC,$86,$96,$77,$E6,$39,$AF,$84,$7F,$77,$15,$F1,$74,$2D,$C7,$F3,$B4,$DA,$86,$5B,$8D,$1C,$61,$BA,$89,$14,$68,$6E,$74,$11,$A1,$B8,$A1, $A,$D0,$71,$7B,$2C,$1C,$D0,$42; 640
		dc.b  $C,$98,  0,$32,$61,$26,$80,$12,$68,  9,$34,$1A, $E,$64,$6B,$B8,$FD,$7A,$43,$7E,$9D,$52,$16,$29,$FA,$AD,$6C,$53,$37,$90,$B9,$8F,$DD,$1C,$AD,$3B,$E0,$9F,$9A,$2A,$D9,$C3,$34,$A7,$5D,$B3,$86,$69,$FA,$74,$D9,$DD,$60,$99,$C1,$59,$61,$B6,$7A,$32,$33,$99,$19,$19; 704
		dc.b $20,$E3,$B1,$52,$BF,$B7,$CA,$2E,$EA,  0,  0,  0,  0,  2,$5D,$D2,$62,$96,$96,$64,$25,$95,$93,$30,$ED,$18,$2C,$F7,$F6,$D7,$A8,$4D,$8D,$61,$74,$5F,$43,$73,$45,$4C,$3A,$61,$8A,$94,$E5,$46,$74,$52,$14,$94,$61,$91,  0,  0,  0,$DC,$18,$7E,$CC,$30,$FF,$88,  0,$1C; 768
		dc.b $98,$8C,$98,$CB,$F2,$44,  0,  4,$8E,$4C,$6A,$58,$D4,$B1,$79,$42,$18,$BC,$A1,$62,$F2,$10,$D4,$A3,$11,$28,$E4,$58,$81,$E8,$19,$FD,$53,$74,$BA,$B6,$44,$10,  0,$15,$F3,$96,$9C,$DF,$A4,$E3,$22,  0,$C8,$D7,$49,$90,$65,$A4,$C4,$DD,$FA,$97,$E9,$FC,$F4,$D2,$C0,$3C; 832
		dc.b $A6,$9F,$CF,$9F,$9F,$F7,$D2,$C0,$48,$E9,$FD,$F9,$AF,$F3,$E6,$2A,$57,$4B,$75,$4B,$3B,$F9,$CB,$A2,$7E,$BC,$BE,$D1,$7E,$89,$3E,$E7,$E8,$91,$D1,$FF,$A9,$3A,$56,$C7,$41,$23,$60, $E,$99,$1D,$1C,$43,$8E,$8B,$DC,$E3,$A6,$47,$4E,$B2,$B4,$FA,$A9,$5B,$75, $A,$7B,$A5; 896
		dc.b $3F,$17,$5A,$71,$53,$28,$84,$33,$B3,$8A,$FF,  5,$DC,$E2,$FE,$E9,$17,$45,$DE,$2A,$53,$99,  9,$14,$29,$64,$8B,$AD,$D5,$22,$C5,$63,$BB,$3F,$E1,$72,$BD,$F4,$76,$AB,$49,$6A,$35,$A6,$5A,$D3,$2D,$7A,$57,$C2,$99,$6A,  0,$1A, $A,$E7,$5C,$E3,$A3,$B3,$20,$BF,$38,$88; 960
		dc.b $AE,$71,  5,$D9,$C4,$2D,  1,$42,$A5,$4E,$CF,$A0,$4D,$9D,$C1,$53,$2A,$2F,$5F,$CC,$1A,$7E,$E9,$F7,$FE,$B2,$93,$A4,  8,  0,$64,$41,$AF,$4E,$AE,$F0,$A2,$97,$EB,$ED,$15,$DB,$45,$E8,$9B,$6E,$F1,$CF,$8F,  7,$C7,$22,$EF,$15,$8A,$D1,$4A,$7B,$24,$52,$95,$A5,$69,$23; 1024
		dc.b $45,$F1,$58,$80,  5,$48,$22,$23,$AD,$32,$87,$F8,$40, $F,$8F,$27,$C7,$90,  0,$1C,$A9,$FE,$14,$FF,$37,$FC,$57,$FE,$29,$FF,$67,$44,$3E,$3F,$9A,$96,$6B,$E2,$13,$31,$F9,$A0,$32,$32,$8B,$E2,$F8,$BB,$A1,$7D,$13,$67,$74,$4D,$A6,$9D,$17,$69,$A1,$FD,$BE,$3C,$32,$84; 1088
		dc.b $BF,$4E,$BF,$C7,$4F,$E3,$BB,$90,  0,$3B,$AA,$78,$A7,$42,$BE,$D1,$F6,$8E,$3B,$E3,$9F,$85,$AE,$4F,  7,$F1,$76,$6F,$65,$86,$6A,$CB,$C2,$43,$3C,$A1,$9B,$F3,$73,  6,$5C,$D6,$19,$84,$DC,$E3,$9B,$E3,$4F,$D5,$70,$5F,$F9,$29,$A7,$4F,$C9,$73,$4A,$26,$C9,$34,$8F,$E4; 1152
		dc.b $B9,$C5,$79,$84,$21,$FB,$F3,$D7,$F9,$50,  4,  7,$C5,$F1,$4A,$38,$AD, $A,$45,$3A,$1B,$8A,$D1, $D,$D6,$4A,$40,$E2,$EB,$25, $F,$7B,$CD,$CE,$B2,$DC,$FB,$2F,$7F,$E9,$6E,$D5,$4F,$4E,$47,$32,$F3,$C8,$BA,$2F,$A3,$8A,$71,$18,$74,$42,$9F,$A4,$8F,$24,$B2,$FF, $D,$39; 1216
		dc.b $78,$FE,$61, $A,$5B,$9B,$A3,$38,$AF,$5F,$E7,$5B,$99,$EE,$48,$C8,$80,  6,$5F,$9A,$D6,$FE,$5D,$1C,$51,$8A,$9A,$6A,$CB,$1A,$17,$32,$50,$EA,$CE,$63,$AD,$6E,$56,$7D,$9D,$B8,$30,$60,  0,$CF,$C2,$50,$A1,$CF,$C1,$FC,$A8,$73,$D6,$5C,$A9,$FC,$17,$7B,$2F,$5D,$A3, $E; 1280
		dc.b $8A,$7D,$23,$D2,$7D,$C9,$BA,$5D,$C9,$B5,$2C,$FE,$77,$7E,$BE,$2F,$B7,$37,$4D,$4F,$3F,$D7,$B8,$CC,$80,$85,$E6,$65,$3F,$49, $A,$43,$CC,$32,$B1,$7B,$2B,  2,$F6, $A,$C5,$EC,$FD,$6B,$1C,$FC,$19,$DC,$BA,$67,$C5,$61,$4C,$F5,$3C,$9D,$7C,$3D,$BA,$A1,$A4,$B3,$2F,$8B; 1344
		dc.b $E2,$91,$7C,$52,$96,$B9, $F,$4B,$F3,$64,$E9,$E0,$91,$4F,  0,$25,$A0,  0,  0,  0,  0,$65,$98,$C8,$8C,$B3,  0,$64,$40,  1,$DF,$BA,$7F,$EA,$86,$60,  0,$3F,$F7,$FF,$1F,$FD,  0,  0,$FD,$DE,$90,$E9,$14,$DA,$6B,$6F,$CD,$6D,$34,$29,$35,$9A,$14,$B2,$E8,$85, $C,$A2; 1408
		dc.b $FD,$3F,$7C,$85,$7F,$52,$93,  6,$B6,  2,$BA,$1B, $A,$E8,$72,$F3,$FF,$30,$9D,$62,$25,$62,$24,$6A,$47,$39,$59,$7C,$66,$23,$65,$EE,$7F,$72,$97,$F5,$F3,$2B,$FA,$95,$D2,$3F,$D6,$EE,$20,$64,$40,$74,$CD,$6C,$85,$E5,$C5,$22,$9D,$CA,$56,$C5,$3B,$96,$D1,$77,$74,$5C; 1472
		dc.b $52,$2E,$F1,$58,$E8,$BD,$7C,$D3,$8F,$DF,$D2,$1A,  1,$22,  5,$4A,$59,$E5,$2C,$E8,$B8,$E8,$FB,$3E,$D3,$B4,$A2,$A7,$45,$2A,$6A,$53,$47,$45,$34,$7F,$EA,$40,  0,  0,$97,$FE,$B2,$5D,$35,$19,$6B,$95,$A5,$78,$CA,$77,$8D,$2B,$6B,$C4,$B1,$5B,$CA,$5A,$A4,$65,$8A,$DF; 1536
		dc.b $11,$5B,$F4,  0,  1,$BF,$2C,$79,$4A,$7A,$E3,$C9,$DA,$A4,$F5,$C7,$92,$5B,$C1,$27,$76,$37,$A7,$77,$82,$1B,$B9,$27,$77,$7B,$B9,$27,$75,$D0,$74,$16,$D2,$E4,$21,$58,$EB,  5,$8F,$30,$E2,$12,$6E,$D6, $F,$81,$52,$B0,$C6,$9C,$35,$D8,$D7,$7E,$80,  0,$32,$69,$6E,$E1; 1600
		dc.b $ED,$F9,$89,$B9,$A9,$CD,$CD, $F,$14,$68,$27,$ED,$D7,$97,$F0,$D3,$74,$98,$55,$80,  2,$5B,$A4,$DD,$1E,$D4,$93,$50,$29,$56,$A2,$9A,$94,$83,$CA,$41,$A5,  6,$73,$51,$1A,$B0,$15,$DC,  0,$AF,$FC,$FF,$EB,$FB,$D4,$FD,$6B,$EF,$FD,$74,$A2,$9F,$BE,$77,$8A,$4F,$F4,$EE; 1664
		dc.b $8F,$A4,$32,$68,$64,$D0,$C9,$A1,$93,$40,$2F,$F0,$D3,$77,$27,$F2,$8D,$1D,$17,$50,$3B,$AA,$D1, $B,$A2, $D,$3F,$6E,$E3,$FB,$38,$64,$D0,$CA,$7E,$72,$BC, $E,$C0, $F,$D9,$BF,$F6,$BE,$92,$FD,$2B,$76,$96,$17,$B0,$EC,$B3,$95,$EB,$CE,$51,$4E,$6B,$7A,$95,$9C,$8A,$CE; 1728
		dc.b $45,$67,$22, $A,$40,$54,$80,$12,  1,$78,$AC,$12,$19,$59,$20,$E9,$AC,$33,$84,$E0,$EB,  4,$D1,$26,$FC, $F,$DE,$FE,$B0,$81,$95,$E1,$5A,$4C,$9E,$8E,$C3,$23,$61,$9D,$86,$4F,$CA,$B3,$B0,$D8,$77,$64,$C2,$E1,$AF,  9,$7B,$F0,$EB,$DF,$78,$CA,$6E,$BD,$F3,$96,$2B,$88; 1792
		dc.b $2C,$D7,$1C,$9F,$C7,$2B,$3A,$69, $B,$60,$BE,$D7,$66,$9D,$16,$E4,$E4,$99,$D3,$54,$D4,$FE,$69,$DA,$C2,$8E,$F0,$E5,$9C,$A1,$9E,$14,$AD,$D8,$2F,$BB,$53,$34,$29,$65,$CD,$F6,$4D,$5F,$AE,$FF,$C9,$4F,$55,$D6,  9,$A2,$1C,$15,$D3, $A,$57,$59,$62,$38,$97,$E5,$40,$7D; 1856
		dc.b $E4,$65,$79,$4C,$39,$82,$5E,$53,  3,  9,$86,$4B,$CA,$DE,$AD,$BF,$4E,$34,$38,$4A,$69,$14,$9C,$28,$57,$9A,$9A,$FE,$9C,$A4,$D7,$37,$CD,$73,$85,$2D,$37,$40,$A7,$EF,$90,$AD, $A,$4D,$7A,$40,$CD,$69,$34,$3F,$DE,$A7,$34,$E9,$3A,$24,$FA,$32,$41,$3A,$73,$68,$1A,$73; 1920
		dc.b $74,$75,$C2,$CE,$89,  4,$B9,$27,  4,$3A,$A5,$D0,$C6,$D6,$67,$5F,$E5,$7A,$15,$B7,$64,$B3,$FF,$5E,$A4,$11,$FC,$10,  0,  0,$7F,$F4,$FF,$BE,$61,$3F,$FA,  0,$AD,$E2,$FA,$CD,$3B,$4B,$F5,$CE,$BE,$85,$19,$3B,$24, $B,$76,$FD,$71,$9B,$73,$5A,$24,$D3,$AD,$26,$91,$FD; 1984
		dc.b $3C,$E3,$CB,$74,$D7,$7F,$87,$1B,$FC,$33,$75,$D9,$81,$C3,$EE,$CF,$8B,$F8,$42,$EE,$30,$A4,$5D,$98,$4C,$6D,$5B,$E0,$A5,$F7,$80,$EB,$B3,$A9,$5E,$13,$84,$ED,$76,$69,$85,$B1,$BF,$46,$4F,$D6,$B7,$EB,$BF,$5A,$BD,$92,$FA,$F6,  0,$3B,$B4,$AF,$5B,$C7,$EB,$53,$FD,$CD; 2048
		dc.b $FD,$65,$9F,$F3,$FA,$15,$BB,$C2,$E5,$C5,$D6,$EC,$97,$60,$DA,$FF,$2B,$D2,$DC,$F6,$E7,$B5,$96,$C4,$5A,$B6,  2,$FE,$A1,$FB,$CE,$5B,  0,  2,$5F,$23,$B1,$7D,$E9,$7B,$27,$64,$EC,$BF,$AD,$95,$F2,$D7,$87,$EB,$C6,$E7,$70,$C8,$D2,$E5,$73,$F8,$C2,$DC,$FC,$FF,$2B,$5C; 2112
		dc.b $D3,$15,$FC,$D0,$FD,$6B,$EF,$FD,$73,$7E,$B5,$28,$EF,$D7,$70,$9F,$D6,$4B,$65,$AE,$76,$7D,$21,$A6,$FF,$D9,$E0, $F,$3A,$94,$F3,$7D,$D1,$4D,$13,$CA,$D7,$21,$4D,$3F,$2A,$96,$EF,$8B,$EC,$97,$21,$4E,$16,$C9,$72,$14,$E1,$6C,$97,$3B,$8E,$EE,$F5,$E5,$DE,$E8,$62,$E4; 2176
		dc.b $FD,$7A,$60,$A5,$BB,$25,$8A,$DF,$E5,$7A,$7E,$A3,$3E,$99,$C0,  0,$9F,$FC,$FF,$AB,$BC,$56,$32,$22,$A4,  0,$25,$DF,$2B,$BF,$35,$FC,$8D,$F4,$D6,$B7,$99,$5E,$65,$79,$5F,$DE,$17,$7F,$D7,$C4,$75,  4,  0,  0,$9D,$D5,$A6,$FF,$EC, $A,$F6,$95,$F1,$77,$62,$97,$2D,$F1; 2240
		dc.b $EF,$D5,$2F,$29,$72,$6A,$97,$97,$6A,$96,$29,$DF,$AF,$76,$AE,$DF,$6B,$B5,$B2,$77,$DF,$44,$9E, $D,$D8,$64,$37,$68,$70,$D7,$B5,$DA,$26,$1A,$F5,$3F,$98,$46,$E7,$8C,$B0,$BA,$C5,$D8,$4D,$54,$BB, $F,$2E,$C0,$7F,$E5,$72,$D3, $F,$BB,$40,$D8,$71,$46,$4D,$F8,$76,$99; 2304
		dc.b $6B,$C2,$32,$99,$8C,$DE,$52,$7B,$65,$B3,$B3,$76,$6E,$6F,$D4,$F3,$E9,$8E,$DB,$E5,$1C,$BB,$F7,$BE,$ED,$6B,$AB,$FF,$58,$96,$B9,$37,$DD,$F9,$5B,$77,$FE,$97,$CF,$5B,$B1,$76,$97,$AE,$7D,$5F,$CE,$E0,$25,$DD,$72,$7E,$F3,$FE,$B3,$F4,$F1,$D7,$F4,$FF,$A5,$B9,$31,$D7; 2368
		dc.b $B6,$F4,$B6,$B4,$4F,$D6,$63,$54,$BF,$5A,$62,$E5,$FD,$54,$2E,$29,$83,$FB,$DC,$65,$BC,$1C,$88,  3,  0,$57,  9,$BD,$3F,$7D,$E4,$BF,$BE,  0, $F,$D6,$4B,$F4,$BE,$4E,$FD,$4F,$90,  0,  0,$EF,$E6,$3B,$F8,$BE,$49,$FC,$54,$BB,$FD,$97,$6F,$AE,$F4,$DF,$95,$DE,$52,$B9; 2432
		dc.b $2E,$DE,$FF,$2E,$FD,$F2,$DF,$72,$6F,$97,$90,$DE,  0,  1,$67,$94,$3C,$F9,$FB,$65,$B3,$EF,$FC,$AC,$17,$3B,$FF,$6D,$DB,$A3,$FB,$BF,$7C,$BF,$DD,$69,$E5,$7E,$76,$E3,$1B,$2E,$36,$82,$5F, $F,$CA,$DE,$FF,$D6,$A6,$63,$F9,$57,$CC,$83,$59,$BE, $B,$8D,$7F,$49,$B8,$2C; 2496
		dc.b $EB,$30,  0,$CB,$FE,$DE,$19,$11,$2B,$D3,$30,$FB,$E6,$FB,$DA,$74,$5E,$D3,$34,$6D,$6F,$E6,$60,$C9,$7C,$D0,$C1,$96,$68,$60,$CF,$A4,$19,$F4,$E7,$7B,$E6,$EB,$DD,$CD,$D7,$A3,$42,$9F,$BE,$6E,$2C,$94,$E4,$BA,$D5,$9C,$52, $E,$99,$48,$23,$29,$48,$23,$3E,$1B,$9F,  6; 2560
		dc.b $AB,  0,$1C,$D5,$6E,$19,$ED,$49,$BD,$A8,$94,$65,$6A,$25,$19,$19,$28,$9B,$91,$97,$F2,$B4,$46,$46,$93,$23,$57,$D3,$26,  0, $A,$F6,$AD,$E8,$D9,$30,$AD,$E0, $F,$DE,$FE,$F0,  7,$90, $A,$DE,$2F,$79,$75,$EF,$2E,$BC,$5E,$3F,$5A,  0,$1E,$7F,$98,$87,$E6,$98,$62,$BA; 2624
		dc.b $29,$4B,$5E,$2F,$5C,$21,$4B,$25,$EB,$84,$29,$6A,$94,$B3,$B0,$A5, $D,$4B,$FF,$73,$7F,$EB,  0,  1,$F0,$F2,$BD,$BF,$48,$A6,$E4,$3C,$97,$19,$C2,$96,$9A,$6B,$5B,$D2,$C9, $C,$F0,$7F,$5A,$9A,$94,$C2,$76,$B9,$4C,$BB,$90,$F7,  4,$FD,$3F,$EE,$20,  0,  2,$4D,$D9,$7B; 2688
		dc.b $69,$39,$17,$DE,  5,$EB,$83,$22,$98,$39,$60,$BF,$AD,$7F,$31,$BF,$F9,$A0,  0,  6,$9C,$43,$3E,$99,$C1,$FE,$52,$FD,$EA,$9B,$64,$6D,$5B,$B1,$FB,$FC,$27,$7E,$22,$87, $B,$FA,$42,$87,$F4,$8E,$FF,$6E,$80,  0,  4,$3C,$F7,$B7,$E9,$10,$A6,$2D,$22,$98,$E2,$45,$31,$C1; 2752
		dc.b $B3,$8A,$63,$78,$79,$71,$48,$C8,$D7,$FF,$20,  0,  7,$7E,$3F,$77,$84,$29,$CD,$27,$2E,$6A,$5D,$35,$9C,$B9,$A6,$F7,$FE,$B9,$37,$8D,$F5,$F3,$FE,$2E,$80,  0,  6,$5F,$95,$F4,$C3,$2C,$FF,$31,$87,$4D,$CC,$8C,$F9,$A5,$17,$F5,$C1,$28,$D2,$A4,$EF,$17,$A7,$E9,$5B,$F5; 2816
		dc.b $A0,  0,  0,$40	; 2880
S1Nem_GHZFlowerBits:dc.b   0,  4,$80,$24, $B,$34, $A,$43,  3,$55,$1E,$74, $D,$8E,  2,  0,$34, $C,$8F,  3,  4,$13,  2,$24, $E,$FF,$9B, $F,$63,$99,$7F,$DE,$B9,$95,$3F,$5D,$58,$D0,$D0,$D0,$D0,$D7,$EB,$AD,$7F,$3B,$F0,  8,$FE,$69, $D,$DD,$F1,$1F,$5F,$F3,$FF,  1,$FE,$FF,$E1,$75,$7E,  9; 0
		dc.b $AA,$11,$5C,$D0,$E1,$E9,$FE,  3,$FC,  0; 64
Nem_SwingPlatform:dc.b $80, $E,$80,  4,	 2,$14,	 3,$24,	 4,$36,$37,$45,$1A,$56,$39,$66,$2C,$74,	 5,$81,	 3,  0,$15,$19,$26,$3C,$75,$14,$82,  5,$15,$75,	$C,$83,	 5, $D,$17,$7B,$84,  4,	 7,$17,$7C,$85,	 6,$2D,$77,$7A,$86,  5,$17,$87,	 4,  8,$16,$38,$76,$3A,$88,  6,$36,$89,	 5,$12;	0
					; DATA XREF: ROM:0001C106o
		dc.b $16,$3B,$8E,  5,$13,$18,$FA,$8F,  5,$18,$18,$FB,$FF,$D7,$17,$48,$B8,$20,$77,$CF,$EB,$8A,  8,$4C,$76,$59,$9F,$67,  5,$8D,$79,$25,$55,$D6,$65,$BD,$CB,$16,  9,$F6,$97,$21,$31,$2D,$8E,$F9,$9F,$DA,$45,$FE,$B1,$1B,$48,$FF,$50,$5F,$7B,$49,$3E,$C7,$D4,$8F,$F3,$18; 64
		dc.b $F2,$49,$B4,$14,$C6,$81,$CB,$78,$2C,  5,$5B,  6,$F0,$58,$D7,$92,$3D,$A0,$B0,$7B,$44,$CA,$62,$45,$32,$FA,$12,$3C,$4C,$76,$9F,$AD,$FE,$25,$18,$AC,$A7,$4C,$F5,$46,$2B,$29,$D3,$3D,$51,$85,$FC,$5F,$C5,$95,$4B,$F7,$A5,$50,$6D,$41,  6,$D4,$8A,$F3,$5B,$79,$B4,$72; 128
		dc.b $2A,$6D,$4A,$A3,$77,$AC,$FF,$66,$55,$1F,$D8,$1D,$33,$D5,$18,$AC,$A7,$4C,$F5,$46,$2B,$29,$D3,$3F,$83,$6F,$C4,$7B,$46,$EE,$3D,$A3,$86,$E5,$A6,$1A,$3F,$2A,$1A,$F6,  3,$1F,$95, $D,$3F,$79,$6E,$BD,$A9,$8B,$1D,$45,$8E,$2C,$71,$63,$DB,$E5,$BF, $F,$F4,$84, $B,$E6; 192
		dc.b $B3, $F,$CF, $F,$A0,$BC,$3A,$D8,$15,$77,$1C, $E,$43,$A0,$30,$80,$A2,$EE,$59,$2E,$2D,$3F,$D3,$B5,$D0,  0; 256
Nem_GHZ_Bridge:	dc.b   0, $A,$80,  5,$1A,$15,$19,$24,  9,$46,$39,$74, $B,$81,  5,$1B,$82,  5,$1D,$83,  3,  2,$15,$1E,$28,$FA,$48,$FB,$84,  3,  1,$17,$7C,$85,  3,  0,$14, $A,$86,  3,  3,$15,$18,$87,  4,  8,$16,$38,$FF,$E7,$EA,$7C,$F8,$CA,$7D,$8A,$D2,$7D,  5,$6F,$4B,$A0,$EE,$93; 0
					; DATA XREF: ROM:0001C100o
		dc.b $83,$B1,$D8,$50,$10,$EC,$15,  3,$62, $F,$53,  8,$41,$6B,  8,$60,$A0,$C2,$18,$D1,$C1,$55,$A4,$70,$3D,$94,$7F,$4C,$27,$C6,$B9,$FE,$9F,$38,$3E,$9A,$60,$AC,$FB,$F4,$A5,$6A,$90,$61,$6A,$18,$45,$94,$70,$53,  9,$96,$15,$20,$58,$50,$11,$C1,$50,$56,  2,$10,$50,$28; 64
		dc.b $74,$2D,$78,$74,$15,$AF,$D3,$82,$B2,$3E,$7A,$7E,$AE,$EE,$C8,$7C,$49, $F,$89,$23,$F4,$D9,$DF,$DE,$53,$FD,$BD,$DD,$C3,  5,$4C,$30,$54,$E0,$15,$3F,$B3,$FC,$8E,$70,$6B,$66,$7F,$A9,$95,$4F,$8C,$EF,$EE,$7E, $C,$49, $F,$89,$21,$F1,$24,$3E,$24,$87,$C3,$F9,$F4,$44; 128
		dc.b $30,$56,$FE,$7D,$EF,$2C,$1F,$4C,$30,$54,$C3,  5,$4C,$30,$54,$C3,  5,$4B,$FF,  0,$87,$C9,$A8,$7C,$9A,$87,$C9,$A8,$FE,$81,$17,$77,$77,$6F,$FC,  2,$1F,$26,$A1,$F2,$6A,$1E,$80,  0,$80,  4,$80,  2,  1,$13,  6,$24, $E,$72,  0,$81,$55,$1E,$82,  3,  5,$83,  3,  4; 192
		dc.b $FF,$FF,$BE,$F3,$F9,$1F,$F0,$7B,$F6,$1F,$B2,  0,  3,$A7,$ED,$B5,$7F,$6E,$DF,$E8,$4F,$F3,$CF,$EA,$3E,$FC,$97,$F0,$27,$E1,$9F,$D8,$CF,$C3,$6F,$D9,$7E,$10,  0, $E,$FD,$B7,$E1,$7B,$F6,$EF,$E1,$CF,$C3,$BF,$E7,$A0; 256
S1Nem_GHZRollingBall:dc.b $80,$26,$80,	5,$17,$14,  9,$25,$16,$34, $A,$45,$19,$54,  5,$65,$1A,$72,  0,$81,  4,	4,$16,$38,$82,	4,  6,$16,$39,$26,$3C,$83,  5,$18,$16,$3B,$84,	6,$3A,$17,$7A,$85,  4,	7,$17,$7B,$86,	5,$1B,$18,$F8,$87,  4,	8,$18,$FA,$28,$F9,$FF,	0, $D,$61,$70,$B8; 0
		dc.b $17, $B,$81,$70,$2E,  0,$5C,  0,$6B,$FE,$7A,$C6,$7B,$AE,$F3,$8C,$F6,  0,  0,  0,  0, $B,$FA,$3C,$FE,$8C,  0,  0,  0,  0,  0,$33,$FF,$30,  0,$D6,$15,$1B,$28,$A8,$2A, $A,$82,$A1,$6E,$5E,$79,$7F,$9B,$45,$20,$C0,$A9,$DF,$ED,$30,$2F,$14,$98,$E6,$53, $D,$2D,$74; 64
		dc.b $6B,$35,$F0,$D6,$69,$FD,$94,$7E,$96,$CE,$AF,$49,$9E,$25,$E5,$15,$15,$32,$E2, $A,$9A,$FF,$B0,$6A,  3,$F6,$7E,$3F,$EC,$67,$CA,$69,$6A,$F9,$A7,$15,$EB,$F4,$BF,$C7,$BF,$19,$40,$2F,$B0,$27,$E6,$DF,$59,$8C,$ED,$3F,$A5,  0,$1A,$F5,$FD,$60,  0,$D2,$2A,$2A,$2A,$5F; 128
		dc.b $9A,$E6,$F1,$64,$98,$A6,$54,$98,$A6,$54,$6B,$C1,$64,$57,$B3,$59,$A9,$EE,$EA,$E3,$EC,$FE,$8F,$4E,$2F,$15,$C5,$71,$94,$54,$15,$D5,$EE,$D4,$F7,$48,$FD,$2D,$F8,$A7,$6D,$E5,$A7,$E2,$60,$58,$57,$D3,  0,$2C,$1F, $B,$EF,$BF,$1F,$8E,$FF,$65,$3E,$1E,$57,$ED,$67,$DD; 192
		dc.b $7B,$2F,$FC,$1B,$F1,$94,  3,$5F,$19,$49,$F8,$94,$8A,$DA,$5E,$2D,$F5,$E4,$C5,$DA,$A1,$62,$59,$58,$56,$15,$FE,$7F,$6D,$E5,$FF,$63,$7E,$72,$C6,$9C,$F7,$4F,$FA,$1E,$9A,$EE,$AD, $F,$6D,$D9,$A7,$6B,$B5,$D8,$6B,$E4,$FA,$B7,$36,$8A,$E6,$63,$2D,$31,$9E,$46, $F,$FB; 256
		dc.b $1C,$18,$4D,$36,$12,$7D,$D9,$92,$DF,$56,$4A,$82,$D0,$FA,$68,$96,$CC,$10,$74,$F9,$DC,$BA,$A5,$6C,$B2,$4E,$C5,$DA,$C1,$B3,$E2,$BA,$FD,$1F,$ED,$40,  1,  4,$13,$4C,$9A,$63,  6,$62,$71,$3F,$A5,$39,$BA,$2F,$3A,$6B,$A0,$A8,  3,$F5,$FD,$11,$7D,$57,$AB,$A5,$BA,$BF; 320
		dc.b $18,$A4,$ED,$27,$AB,$23,$D9,$30,$8F,$6E,$9F,$71,$C9,$E9,$52,$FE,$AB,$1C,$5F,$AB,$27,$69,$4E,$96,$EA,$CE,$98,$4B,  0,  0; 384
S1Nem_GHZRollingSpikesLog:dc.b $80,$2C,$80,  3,	 2,$15,$16,$26,$32,$37,$77,$46,$38,$55,$1A,$65,$14,$73,	 3,$81,	 4,  8,$17,$76,$28,$F8,$47,$7B,$75,$15,$82,  5,$17,$17,$79,$27,$7A,$76,$3A,$83,	 2,  0,$16,$39,$28,$FA,$76,$37,$84,  5,$18,$85,	 5,$13,$86,  6,$36,$87,	 5,$12,$17,$78,$76,$33;	0
		dc.b $FF,$A4,$A9,$3D,$62,$91,$42,$7C,$4D,$C7,$13,$1E,$88,$B7,$D4,$FB,$FE,$9E,$2F,$5F,$42,$11,$F0,$84,$2F,$A6,$C4,$21,$16,$10,$84,$57,$3E,$AA,$F1,$48,$A7,$34,$93,$63,$D4,$48,$74,$96,$BB,$63,$F6,$76,$85,$FA,$7A,$FC,  8,$5F,$B3,$42,$1B,$42,$10,$8B,  8,$42,$2B,$9F; 64
		dc.b $55,$6D,$B6,$E9,$2A,$4F,$5B,$4F,$58,$D4,$D4,$7F, $E,$53,$3F,$4E,$B6,$50,$BB,$2F,$13,$32,$F2,$A1,$47,$2B,$13,$D4,$E0,$E3,$9C,$BE,$BB,$52,$3F,$2D,$2F,$79,$FE,$9F,$AA,$B6,$DB,$63,$73,$74,$89,$B8,$FD,$9A,$94,$61,$7E,$9E,$D2,$CB,$B6,$51,$B4,$B8,$96,$47,$7D,$AF; 128
		dc.b $AF,$3C,$79,$92,$3F,$65,$2C,$BD,$4A,$DD,$B2,$FE,$3F,$55,$6D,$EF,$FC,$7D,$B1,$EE,$F2,$FC,$A8,$B9,$C4,$D4,$D0,$A2,$6A,$7C,$76,$70,$84,$47,$D6,$C8,$5C,$A8,$97,$EC,$6F,$97,$F1,$F6,$B7,$F4,$A7,$7A,$B6,$F7,$C4,$D7,$F1,$ED,$35,$FB,$1B,$17,$84,$65,$CF,$6E,$66,$8E; 192
		dc.b $36,$BF,$C6,$5E,$32,$94,$16,$92,$95,$A2,$D2,$9F,$79,$29,$AB,$AF,$13,$BE,$5E,$AA,$DB,$DF,$3A,$88,$47,$71,$73,$E4,$C8,$BA,$82,$C5,$E3,$51,$DF,$98,$E6,$E8,$ED,$2D,$BB,$F8,$57,$8C,$BD,$29,$E5,$FD,$13,$58,$71,$4C,$32,$93,$6D,$B6,$F7,$CE,$A2,$10,$85,$78,$B8,$84; 256
		dc.b $65,$73,$28,$52,$50,$71,$25,$B1,$C4,$AF,$B1,$DE,$F6,$8A,$4B,$2B,$DB,$CA,$92,$F7,$61,$E8,$D4,$53, $D,$B6,$DD,$37,$CE,$A2,$10,$8B,  8,$42,$1B,$10,$84,$58,$42,$11,$5F,$E3,$C5,$E3,$D4,$B6,$2D,$F1,$86,$E0,$D6,$1C,$23,$8C,$32,$91,$4C,$32,$93,$7B,$E7,$52,$C2,$10; 320
		dc.b $B9,$42,$1B,$42,$10,$8B,  8,$42,$3F,$4D,$EF,$F2,$DF,$D7,$50,$BC,$7A,$B7,$8C,$7C,$36,$A4,$87,$DE,$10,$DE,$87,$AC,$3A,$6F,$9D,$5E,$ED,$BD,$EB,$9F,$5E,$F1,$F9,$5E, $A,$6D,$14,$29,$B3,$8A,$4D,$B6,$DE,$F9,$D5,$EE,$DB,$DE,$B9,$F5,$75,$7F,$76,$97,$1E,$71,$A9,$6A; 384
		dc.b $F8,$7A,$1B,$6D,$D3,$7C,$EA,$21,  8,$B0,$84,$21,$B1,  8,$45,$84,$21,$15,$CF,$AA,$B6,$F7,$CE,$A5,$84,$21,$72,$84,$36,$84,$21,$16,$10,$84,$57,$3E,$AA,$DB,$6E,$92,$A4,$F5,$B4,$DF,$1B,$76,$7F,$C3,$9E,$27,$9D,$44,$23,$B8,$85,$F4,$DB,$DE,$B9,$F5,$56,$DB,$63,$A4; 448
		dc.b $87,$49,$14,$BF,$1E,$2F,$FC,$3C,$EA,$21,  8,$B0,$84,$21,$B7,$BD,$73,$EA,$AC,  0; 512
S1Nem_GHZLogSpikes:dc.b	$80,$12,$80,  4,  7,$14, $C,$25,$16,$35,$1B,$44, $A,$55,$1A,$65,$1C,$74,  2,$81,  3,  2,$15,$1D,$27,$78,$82,  5,$17,$16,$3D,$83,  3,  0,$17,$79,$27,$7C,$84,  4,  8,$18,$FA,$85,  4,  3,$86,  4,  9,$87,  4,  6,$18,$FB,$FF,$B3,$46,$8D,$54,$3F,$9D,$AC,$6D,$83; 0
		dc.b $A3,$D8,$B2,$A3,$16,$4C,  8,$2A,$6D,$76,$7C, $C,$37,$FD,$17,$8C,$FE,$8E,$7F,$54,$89,$B8,$7A,$93,$D4,$68,$DD,$6C,$31,$8B,  9,$75,$BF,$B3,$1B,$BB,$A7,$56,$83,$D1,$A1,$5E,$75, $B,$91,$F9,$66,$AF,$84,  8,$8C,$B8,$8C,$95,$32,$81,$4D,$91,$4A,$5A,$9B, $E,$A6,$FA; 64
		dc.b $F6,$BD,$6C,$FD,$93,$39,$BF,$E8,$87,$D6,$7C,$22,$22,$C3,$6B,$EE,$5B,$F2,$B6,$98,$37,$3B,$23,$73,$AE,$92,$DA,$F9,$36,$90,$E9,$B7,$24,$65,  0,$88,$88,$9A,$47, $E,$34,$2F,  7,$BF,$3D,$37,$37,$15,$37,$F1,$6F,$BB,$32,$B3,$3B,$53,$1E,$43,$B3,$9B,$DC,$64, $F,  4; 128
		dc.b $44,$45,$FA,$5D,$9F,$A2,$C7,$77,$43, $E,$EB,$4B,$4B,$CD,$DC,$63,$4E,$85,$D6,$94,$12,$1A,$82,$5C,$82,$1C,$32,$93,$9A,$BA,$BC,$F2,$E7,$64,$EC,$E8,$E9,$9E,$4E,$9A,$F3,$57,$27,$1B,$1D,$B3,$10,$2D, $D,$2E,$41,$11,$7E,$93,$E6,$2B,$AF,$CB,$33,$98,$B2,$78,$D7,$D9; 192
		dc.b $21,$A8,$DB,$38,$74,$E2,$A3,$13,$8B, $E,$2E,$46, $A,$1C,$38,$2B,$1F,$D0,$43,  6,$DB,$25,$3F,$B1,$61,$8D,$B9,$7B,$C5,$2E,$5F,$87,$A9,$36,  5,$69,$EB,$B0,$E5,$F2,$5A,$7E,$91,$60; 256
Nem_GHZ_Rock:	dc.b $80,$18,$80,  4,  7,$14, $A,$25,$16,$36,$36,$45,$17,$55,$18,$65,$1A,$72,  0,$81,  3,  4,$18,$FB,$82,  4,  6,$16,$3C,$83,  5,$19,$87,  6,$3D,$88,  7,$7C,$89,  6,$39,$8B,  8,$FA,$8C,  6,$37,$8D,  6,$3A,$8E,  6,$3B,$8F,  3,  2,$16,$38,$FF,  0,  0, $D,$7B,$A6; 0
					; DATA XREF: ROM:0001C112o
		dc.b $BF,$E5,$EF,$EF,$9B,$7A,$D7,$FC,$2B,$61,$A9,$9D,$AC,$C6,$1A,$CD,$5E,$94,$C0,$5D,$8C,$2D,$45,$BE,$DF,$4F,$1F,$75,$D2,$7C,$E2,$3B,$56,$5F,$3F,$9A,$FC,$9E,$FD,$F5,$BB,$FC,$5D,$7E,$C9,$D3,$F8,$AB,$9B,$F9,$31,$C0,  1,$C6,$A7,  5,$95,$4D,$96,$95,$A0,$EA,$D2,$A0; 64
		dc.b $42,$5A,  0,  6,$B3,$B6,$6C,$CF,$9A,$69,$78,$ED,$4C,$ED,$D2,$FD,$F2,$ED,$8C,$75,$FD,$2E,$A7,$F7,$E1,$78,$40,  0,  2,$5E,$10,  1,$FB,$85,$D6,$16,$10,$52,$7F,$B7,$DD,$D5,$33,$C7,$EF,$ED,$E3,$53,$3B,$6E,$BB,$DF,$F3,$DB,$F7,$E3,$B3,$B5,$70,$C9,$97,$85,$D0,  0; 128
		dc.b $E8,$FB,$56,$45,$F8,$DA,$6C,$9F,$EF,$F7,$EF,$1D,$5B,$87,$45,$91,$4A,$C8,$A9,$64,$15,$2C,$B0,$B0,$8A,$CB,$CA,$CD,$B2,$F9,$A6,$97,$8E,$D4,$CE,$DC,$7E,$BB,$76,$FA,$B7,$8A,$BF,$45,$C3,$CA,$E2,$A3,$F2,  2,$2D,$2A,  0, $A,$61,$3C,  0,$BC,$A8,  5,$A0,  1,$B3,$6C; 192
		dc.b $DA,$8D,$4C,$ED,$CF,$E2,$BE,$B9,$FC,$DF,$3F,$40,  1,$E9,$F3,$9C,$28,$69,$5D,$57,$CD,$23,$E6,$97,$CC,$27,$E4,$A4,$E9,$E1,$B2,$1E,  0,$18,$9A,$6D,$B3,$66,$7C,$D3,$4B,$C7,$6A,$67,$FA,  0; 256
S1Nem_GHZBreakableWall:dc.b $80, $C,$80,  2,  1,$15,$17,$25,$19,$72,  0,$81,  5,$1B,$25,$1C,$82,  4,  8,$15,$18,$25,$1E,$37,$7D,$83,  6,$3B,$84,  4, $A,$85,  4,  9,$16,$3A,$27,$7C,$86,$75,$1A,$87,  5,$16,$FF,$AD,$DB,$F2,$D3,$F9,$40,$96,$3F,$26,$F5,$F8,$6A,$E5,$7E,$5B,$FC,$1B,  0,$21; 0
		dc.b $F8,$C7,$7B,$AF,$D3,$57,$E4,$73,$F9,$10,$FD,$84,$F7,$6D,$F7,$80,$F8,$C7,$E8,$FF,$4D,$5F,$E1,  0,$3F,$81,$FA,$37,$F6,$BC,$AF,$DB,$7F,  3,$81,$CF,$CA,$7C,  3,$40,  0,$68, $D,  1,$A0,  0,$34,  5,$AF,$1F,$86,$FD,$20,$4E,$18,$CF,$DF,$DA,$BE,$7F,$4E,  0,$7E,$C2; 64
		dc.b $7D,$6E,$9F,$AF,$E5,$EF,$E0,$98,$B4,$5E,  3,$33,$8C,$CB,$F5,$8B,$5F,$C0,  5,$E3,$FC,$18,$B7,$59,$C3,$F9,$7B,$C0,  0,  0; 128
S1Nem_GHZWall:	dc.b $80, $C,$80,  4,  9,$14, $B,$25,$1E,$37,$7C,$71,  0,$82,  4, $C,$15,$1B,$57,$7D,$65,$1C,$75,$1D,$83,  4, $A,$85,  4,  8,$87,  5,$1A,$FF,$FD,$9F,$EC,$47,$40,$74,$6E,$F6,$2F,$A0,$3A,$3F,  8,$4C,$7F,$42,$3D,$17,$F8,$1A,$DE,$B3,$58,$F4,$3D,  1,$35,$F4,$7E,$57; 0
		dc.b $5F,$A5,$D0,$9E,$69,$13,$13, $F,$91,$31,$30,$47,$CC,$F9,$CF,$C2, $B,$DD,$E5,  9,$AF,$A0,$26,$BE,$8B,$DD,$E5, $E,$50, $E,$50,  0; 64
Nem_EHZ_Fireball:dc.b $80,$10,$80,  3,	2,$13,	3,$24,	8,$35,$1A,$46,$39,$56,$38,$65,$1B,$75,$19,$81,	3,  0,$16,$3C,$28,$F9,$83,  5,$18,$84,	4, $B,$16,$3D,$87,  4,	9,$18,$F8,$8C,	4, $A,$18,$FA,$8D,  3,	1,$15,$1D,$28,$FB,$FF,$CF,  6, $E,$60,$1D,$84,$46,$87,	2,  2,$A4,$59; 0
					; DATA XREF: ROM:0001C156o
					; ROM:0001C21Eo
		dc.b $82,$8B,$19,$E6,$95,$31,$C0,$46, $F,$21,$96, $B,$22,  7,$58,$58,$62,$84,$E8,$21,$18,$47,$67,$83,$16,$C2, $B,$19,$58,$D8,$D4,$C0,$E3,$E6,$2F,$89,$8F,$48,$53,$78,$F8,$61,$4A,$F1,$77,$E7,$B1,$F7,$9C,$9D,$8D,$D4,$1C,$EA,$95,$14,$76,$51,$1A,$3A,$C1,$81,$C8,$D6; 64
		dc.b $15,$30,$58,$52,$60,$40,$E6,$58,$54,$1D,$EB,$1B,$FC,$9F,$B2,$E6,$25,$9B,$C2,$B5,$6C,$6A,$D0,$41,$5C,$B1,$9E,$67,$2F,$C5,$72,$87,  1,$DB,$B4,$11,$9F,$D2,$68,$7E,$9C,$6B,$E4,$88,$FB,$5F,$63,$92,$2B,$93,$91,$5B,$AE, $E,$60,$E6, $C, $E, $A,$2C,$B3,  6, $D,$70; 128
		dc.b $20,$14,$7E,$8A,$A6,$7F,$58,$AB,$63,$55,$28,$40,$5F,$8B,$FA,$28,$BF,$D6,$16,$42,$FC,$5A, $C,$A9,$B5,$86,$33,$F8,$67,$3C,$CA,$BE,$70,$BC,$EE,$44,$DA,$F3,$BB,$28,$4F,$B8,$65, $F,$80,$8A,$EF,$85,$18,$EF,  7,$60,$E7,$81,$A3,  6,  3,$3F,$8F,$DE,$23,$1B,$B6,$75; 192
		dc.b $28,$F9,$15,$1D,$8E,$F3,$D6,$59, $C,$18,$FA,$46,  2,$AE,$D1,$8A,$46,$91,$10,$69, $F,$C1,$18,$10,$10,$31,$6A,$71,$40,$AB,$F8,$54,$E4,$5B,$AE,$65,$D2,$FC,$2B,$B5,$34,$C3,$B9,  8,$6F,$DE,$4F,$C7,$B3,$1E,$7C,$20,$57,$7E,$4B,  0; 256
Nem_BurningLog:	dc.b $80,$18,$80,  4,  9,$15,$1C,$24,  8,$35,$16,$44, $C,$55,$17,$64,  6,$72,  0,$81,  4, $A,$82,  8,$FA,$83,  5,$1D,$84,  6,$3D,$87,  6,$3C,$88,  3,  2,$89,  4,  7,$8A,  5,$1A,$8C,  7,$7C,$8F,  5,$1B,$FF,  0,$BA,$6D,$AB,$D5,$FC,$A6,$DA,$CA,$84,$DB,$8A,$DF,$3C; 0
		dc.b $8F,$23,$CB,$6F,$53,$BF,$21,$71,$59,$66,$A6,$8C,$EE,$A7,$BC,$DC,$7C,$B3,$DE,$A3,$DB,$7C,$5D,  9,$51,$EC,$A2,$C8,$64,$CE,$52,$67,$FD,  8,  0,  0,  4,$26,$DB,$6F,$CB,$29,$46,$7D,$73,$64,$6B,$AD,$F3,$95,$1D,$97,$C4,$73,$F3,$36,$F5,  2,$19,$33,$E2,$AC,$A7,  0; 64
		dc.b $15,$BC,$E6,$DB,$C6,$56,$DF,$14,$7E,$62,$11,$C5,$64,$17,$F0,$BA,$DF,$35,$65,$67,$9A,$9D,$4F,$4D,$2B,$3F,$C8,$78,$F7,$B1,$AE,$FC,$6F,$73,$AB,$88,$84,$32,$67,$29,$33,$FE,$86,$51,$74,$DB,$15,$FC,$B2,$6D,$B6,$EF,$F9,$82,$E8,$19,$11,$A8,$A2,$FF,$99,$2C,$F2,$E5; 128
		dc.b $DF,$3A,$AE,$A7,$E3,$7A,$E3,$21,$93,$3E,$2A,$CA,$71,$37,$D3,$68,  0,  0,  1,$42,$84,$29,$D7,$D3,$6A,$1E,$8E,$3C,$75,$F5,$DC,$79,$58,$BB,$67,$EC,$A9,$50,$8B,$A1,$93,$39,$4A,$E9,$FF,$43,$CF,$CC,$10,$B9,$56,$FA,$E3,$C3,$EA,$EE,  0,$12,$81,$BE,$9B,$48,$59,$A9; 192
		dc.b $59,$D1, $E,$5D,$D9,$4B,$DD,$62,$38,$86,$4C,$F8,$AB,  0; 256
Nem_EHZ_Waterfall:dc.b $80,$18,$80,  2,	 0,$24,	$A,$44,	$D,$65,$1D,$73,	 2,$81,	 3,  3,$82,  5,$1C,$85,	 7,$7C,$86,  8,$FA,$87,	 4, $B,$88,  8,$FB,$89,	 6,$3C,$8A,  3,	 4,$8B,	 6,$3D,$8C,  4,	$C,$FF,$3E,$8F,$A3,$F0,$87,$D5,$78,$70,$E1,$C3,$CD,$87,	$F,$9D,$B2, $D,$10,$95,$83,$A7;	0
					; DATA XREF: ROM:0001C15Co
		dc.b $AC,$C2,$CC,$AB,$21,$66,$6C,$2C,$9B,$35,$D3,$1D,$34,$61,$E0,$CF,$7B,$C3,$E1,$C1,$9F,$67,  9,$B2,$B1, $C,$63,$2D,$19,$58,$88,$5D,$5D,$44,$61,$15,$32,$C6,$35,$50,$F0,$F0,$F4,$FB,$AF, $E,$1C,$38,$79,$B0,$E1,$F3,$B6,$41,$A2,$12,$B0,$74,$F5,$98,$59,$95,$64,$2C; 64
		dc.b $CD,$85,$93,$66,$BA,$63,$A6,$8C,$3C,$19,$EF,$78,$7C,$38,$33,$EC,$E1,$36,$56,$21,$8C,$65,$A3,$2B,$11, $B,$AB,$A8,$8C,$22,$A6,$58,$C6,$AA,$1E,$98,$7A,$44,$42,$D2,$A8,$AA,$6B,$D7,$B1,$25,$AD,$2A,$C5,$AD,$25,$DC,$45,$A4,$8C,$4B,$B6,$91,$85,$AA,$85,$D5,$A5,$53; 128
		dc.b $5A,$43,$AB,$49,$6C,$49,$75,$91,$24,$8C,$4B,$5D,$66,$DA,$49,$56,$54,$2D,$56,$24,$42,$CB,$2D,$10,$B4,$AA,$2A,$9A,$F5,$EC,$49,$6B,$4A,$B1,$6B,$49,$77,$11,$69,$23,$12,$ED,$A4,$61,$6A,$A1,$75,$69,$54,$D6,$90,$EA,$D2,$5B,$12,$5D,$64,$49,$23,$12,$D7,$59,$B6,$92; 192
		dc.b $55,$95, $B,$55,$89,  0; 256
Nem_HTZ_Fireball:dc.b	0,$10,$80,  3,	3,$15,$17,$25,$19,$35,$1B,$47,$7B,$58,$FB,$68,$FA,$74, $A,$86,	6,$39,$8A,  6,$3A,$8B,	5,$18,$8C,  3,	2,$15,$16,$27,$7A,$8D,	2,  0,$16,$38,$28,$F8,$8E,  4,	9,$16,$3B,$28,$F9,$8F,	4,  8,$15,$1A,$26,$3C,$FF,$F6,$23,$22,$C6,$AE,$28,$EE; 0
					; DATA XREF: ROM:0001C224o
		dc.b $18,$A7,$F4,$D8,$64,$4F,$3D,$C0,$A2,$79,$EE,  5,$FD,$F1,$62,$30,$BF,$37,$F1,  8,$B3,$2D,$82,$CC,$5C,$3E,$2E,$2C,$95,$F4,$55,$71,$F7,$63,$DC,$61,$1B,$8F,$5B,$58,$5F,$17,$C2,$E1,$F0,$E2,$DC,$65,$42,$37,$88,$B1,$93,$D1,$95,$F0,$B2,$87,$C2,$BF,$17,$47,$D1,$ED; 64
		dc.b $55,$71,$EC,$F4,$5C,$5A,$98,$62,$8E,$F9,$86,$62,$27,$99,$81,$47,$EF,$A0,$5F,$DF,$14,$7E,$6F,$58,$2D,$16,$84,$D7,$C5,$B0,$C4,$F8,$B5,$C4,$31,$64,$BA,$3E,$8A,$AA,$47,$DC,$58,$DE,$17,$1B,$C4,  8,$CC,$60,$6B,$38,$B1,$B8,$B1,$B5,$84,$6D,$16,$32,$8B,$19,$1D,$8C; 128
		dc.b $8C,$5B,$43,$16,$4A,$AA,$AA,$AA,$DE,$22,$72,$B5,$3D,$5D,$6A,$7A,$E5,$DA,$3E,$7A,$76,$D7,$C8,$ED,$8F,$18,$FD,$3C,$26,$34,$D5,$D3,$10,$C4,$D3,$19,$74,$D3,$4D,$55,$55,$54,$C6,$3D,$F5,$3A,$59,$E7,$A9,$D2,$BF,$5F,$31,$67,$F3,$AB,$3F,$31,$66,$61,$FA,$65,$D3,$4C; 192
		dc.b $68,$62,$1A,$B8,$C6,$9D,$9A,$69,$AA,$AA,$DE,$B7,$37,$9A,$BC,$66,$72,$A3,$32,$E6,$EB,$53,$79,$6B,$C9,$72,$35, $A,$3B,$63,$85,$E0,$FF,$79,$17,$19,$67,$66,$31,$97,$4D,$31,$95,$55,$9D,$7D,$CD,$E5,$C7,$D2,$CC,$EE,$5C,$E6,$26,$F3,$A4,$E5,$CF,$89,$F7, $A,$13,$3C; 256
		dc.b $50,$CB,$C7,$EF,$18,$9D,$86,$5C,$63,$1A,$18,$D3,$4C,  0; 320
Nem_EHZ_Bridge:	dc.b   0,  8,$80,  5,$1B,$15,$1A,$25,$1C,$38,$FA,$48,$FB,$83,  3,  2,$84,  2,  0,$16,$3C,$85,  3,  3,$14, $B,$86,  3,  4,$14, $A,$87,  4, $C,$16,$3D,$8C,  7,$7C,$8F,  5,$1D,$FF,$DA,$2E,$B1,$17,$5E,$A2,$EB,$D5,$E5,$D6,$6F,$F6,$7E,$3F,$A4,$39,$C4,$3A,$E2,$1C,$CE; 0
					; DATA XREF: ROM:0001C162o
					; ROM:0001C230o
		dc.b $21,$CC,$E7,$E4,$DD,$7D,$21,$CD,$2B,$AC,$D2,$2E,$B4,$8B,$EC,$D2,$1F,$CE,$CD,$2E,$BF,$9D,$99,$56,$2D,$FB,$56,$2F,$6A,$C5,$95,$7E,$27,$E7,$EC,$F7,$18,$BE,$A9,$8B,$99,$18,$B9,$91,$8B,$94,$FF,$27,$C8,$C5,$F5,$95,$6B,$55,$62,$D4,$ED,$8B,$53,$BF,$18,$B5,$3B,$F1; 64
		dc.b $F5,$7F,$83,$F4,$7C,$5E,$5E,$90,$E0,$F6,$BC,$65,$6C,$78,$38,$22,$3C,$1C,$4E,$9E,$11,$3A,$29,$A3,$F4,$A5,$A7,$E9,$90,$47,$E9,$88,$6C,$65,$5E,$D1,  8,$4D,$21,$C2,$71,  8,$7F,$7F,$D3,$FB,$62,$17,$21,$18,$B5,  8,$41,$6E,$E8,$66,$C8,$7E,$98,$44,$C3,$D6,$AC,$FD; 128
		dc.b $28,$9D,$14,$D4,$31,$D3,$51,$98,$E0,$88,$CC,$66,$E8,$7E,$2D,$B2,$31,$6A,$FC,$5C,$FD,$1F,$D8,  0; 192
Nem_HTZ_Lift:	dc.b $80,$30,$80,  4,  4,$14,  8,$25,$17,$36,$37,$45,$15,$56,$35,$67,$73,$73,  0,$81,  3,  1,$15,$18,$77,$79,$82,  5,$16,$18,$F5,$83,  4,  5,$78,$F4,$84,  5,$12,$16,$38,$85,  5,$13,$16,$3A,$86,  6,$32,$17,$78,$87,  4,  6,$17,$77,$88,  7,$7B,$89,  5,$14,$8A,  4; 0
					; DATA XREF: ROM:0001C256o
		dc.b   7,$16,$34,$8B,  6,$36,$8C,  7,$76,$8E,  6,$33,$8F,  7,$72,$FF,  0,$69,$AF,$5A,$27,$E6,$DF,$F4,$85,$F8,$FD, $C,$F7,$96,$9F,$A1,$AE,$97,$3B,$E3,$9D,$8D,$B7,$56,$9D,$69,$62,$D5,$FC,$9D,$B5,$5E,$66,$3B,$5D,$F6,$A7,$E7,$35,$6E,$DB,$57,$6C,$93,$B5,$5C,$A3,$DD; 64
		dc.b $D1,$D8,$EF,$4E,$6B,$4B,$1B,$94,$FD,$1D,$7A,$57,$82,$9C,$75,$A2,$2E,$38,$E8,$A2,$BE,$38,$B2,$51,$34,$C7,$E6,$77,$D0,$5D,$FB,$38,  0,  0,  0,$FC,$E5,$7F,$4D,$5C,$B4,  0,  0,  0,  0,  0,$9F,$9C,$AB,$F6,$F1,$BB,$A3,$E4,  0,$1A,$BF,$87,  0,  0,  0,  0,$5E,$57; 128
		dc.b $58,$91,$5C,$95,$A4,$B8,$45,$82,$D1,$FA,$99,$62,$72,$DE,$53,$1C,$FF,$55,$BF,$69,$4E,$5A,$27,$24,$CE,$53,$8C,$D3,$2A,$61,$31,$F9,$36,$D1,$1B,$57,$8C,$96,$7B,$95,$AB,$22,$EB,$62,$A6,$FB,$32,$2D,$76,$28,$F5,$D0,$46,$DA,$F6,$DB,$56,$ED,$AB,$76,$D5,$9F,$59,$97; 192
		dc.b $A9,$9F,$32,$AE,  6,$90,$B7,$CA,$7A,$42,$A3,$4B,$A6,$42,$F8,$E3,$7D,$31,$AE,$83,$6E,$5F,$9B,$E5,$B0,  0,  0,  0,  2,$FF,$9F,$AE,$DC,$B8,$DF,$64,$DA,$40,  0,  0,  0,  0,  0,$8F,$CF,$D7,$F4,$95,$97,$E6,$C0,  0,  0,  6,$E4,$73,$B5,$65,$79,$24,$A7,$62,$D8,$91; 256
		dc.b $5B,$21,$4C,$2D,$A5,$FA,$A8,$B1,$FD,$A9,$BF,$E8,$53,$17,$E2,$24,  0,$17,$F1,$19,$41,$FC,$9A,$15,$12,$CB,$FA,$28,$BF,$D7,$45,$FE,$BA,$B7,$F4,$55,$BF,$A2,$8B,$FD,$7E,$BF,$89,$33,$1E,$A9,$65,$92,$1E,$A2,$75,$20,  8,$CA,$3B,$C3,$2C,$61,$14,$C7,$F4,$FC,$F7,$D7; 320
		dc.b $BF,$F8,$7D,$7F,$86,$7D,$7F,$87,$DF,$FA,$3C,$2D,$BF,$47,$EA,$96,$5B,$25,$96,$71,$D4,$4D, $D,$C8,  2,$1A,$3B,$C3,$14,$5C,$22,$9F,$4F,$23,$CF,$A7,$A7,$9F,$D1,$DB,$F4,$7E,$A9,$65,$B2,$59,$67,$1D,$44,$D0,$DC,$80,$21,$A3,$BC,$31,$45,$C2,$29,$F4,$F2,$3C,$FA,$7A; 384
		dc.b $79,$FD,$23,$21,$65,$85,$63,$94,$AF,$46,$39,$4A,$C8,$E6,$8C,$50,$DF,$2F,$7C,$A9,$9A,$39,$EF,$29,$98,$73,$94,$96,$57,$FC,$C9,$69,$6E,$D4,$F6,$6A,$C9,$9D,$4A,$10,  0,$13,$59,$F7,$9A,$CD,$3C,$16,$58,$5F,  5,$96,$14,$21,$AE,$74,$CE,$B2,$EB,$95,$1E,$24,$A9,$29; 448
		dc.b $9D, $B,$70,$AD,$D6,$7E,$F1,$93,$70,$53,$3F,$CC,$DB,$16,$86,$4F,$C9,$BC,$1B,$DA,$B4,$C6,$EC,$8D,$5A,$1B,$43,$2C,$E9,$CB,$6A,$4C, $E,$67,$76,$34,$CD,$34,$A7,$BE,$59,$4D,$FC,$4F,$85,$86,$BA,$F0,$E5,$B8,$6C,$23,$FE,$C6,$99,$C3,$FE,$67,$3D,$5A, $D,$48,  0,  0; 512
		dc.b   0,  0,  0,  0,  2,$19,$65,$4F,$7B,$52,$65,$33,$3E,$B0,$B4,$2C,$99,$3A,$72,$2C,$B6,$B9,$92,$CB,$27,$89,$24,$8D,$2F,$C6,$3D,$E7,$18,$A6,$25,$9A,$67,$46,$CE,$8F,$2E,$C5, $D,$DD,$97,$99,$AE,$C6,$AE,$5E,$AE,$5C,$6A,$5F,$57,  0,  0,  0,  0,$6B,$4E,$6A,$F5,$A1; 576
		dc.b $AB,$23,$64,$EC,$B3,$57,$FC,$E3,$8B,$AC,$A6,$AD, $A,$C7,$29,$5D,$58,$E5,$20,  2,$69,$AF,$4F,$46,$28,$78,$EA,$99,$D1,$71,$C7,$E9,$79,$69,$8F,$D2,$4F,$7F,$D0,$C9,$1F,$24,$A6,$74,$31,$63,$42,$9C,$91,$F3,$D9,$E6,$B3,$13,$59,$C9,$77,$F0,$59,$6F,$E0,$B2,$80,  0; 640
		dc.b $82,$85,$91,$E3,$3A,$33,$D0,$BA,$4E,$5C,$AC,$5A,$24,$8B,$3E,$F0,$78,$9B,$17,$4C,$E9,$FA,$17,$89,$2B,$A6,$4E,  0,$15,$54,$50,$35,$60,$39,$9A, $A,$D0, $E,$7B,$4F,$60,  0,$E6,$6A,$41,  3,$9C,$C3,$8A,$B8,$1B,$80; 704
Nem_HTZ_AutomaticDoor:dc.b $80,	 4,$80,	 4,  8,$15,$1C,$33,  1,$44, $A,$54, $D,$76,$3E,$81,  3,	 0,$14,	 9,$83,	 4,  7,$85,  5,$17,$86,	 5,$18,$87,  5,$19,$89,	 4,  6,$8A,$15,$1D,$8B,	 5,$16,$8C,  3,	 2,$8F,	 5,$1E,$FF,$FC,$47,$F5,$FF,$10,$3D,$FB,$1F,  8,$FC,$17,$E8,$63,$F0,$55,$35; 0
					; DATA XREF: ROM:0001C22Ao
		dc.b $35,$30,  8,$89,$A9,$A9,$80,$44, $D,$1A,$38,$34,$68,$DF,$7E,$BB,$F4, $E,$5F,$9F,$93,$1F,$8E, $E,$39,$7C,$3D,$8A,$EA,$2C,$9B,$3F,$1B,$E1,$EC,$57,$51,$64,$D9,$F8,$DF, $F,$62,$BA,$8B,$26,$CF,$C6,$F8,$7B,$15,$D4,$59,$36,$78,  0; 64
Nem_HTZ_Seesaw:	dc.b $80,$18,$80,  4,  6,$15,$19,$26,$3A,$34,  8,$45,$17,$55,$1A,$66,$3B,$74,  2,$81,  3,  0,$14, $A,$26,$38,$36,$39,$48,$F9,$78,$FA,$82,  4,  5,$78,$FB,$83,  5,$1B,$15,$16,$84,  4,  7,$15,$13,$77,$7B,$85,  4,  4,$86,  5,$18,$87,  4,  3,$16,$3C,$8A,  5,$12,$8B; 0
					; DATA XREF: ROM:0001C168o
					; ROM:0001C236o
		dc.b   7,$7A,$8F,  8,$F8,$FF,$22,$22,$67,$4C,$5C,$6C,$43,$B0,$D6,$F4,$3A,$FD,$BE,$7F,$A2,$4D,$FE,$3F,$7F,$67,$FE,$67,$FF, $B,$7F,$90,$88,$88,$88,$BF,$EF,$F4,$5F,$F3,$F7,$F7,$FF,$6F,$AF,$64,$44,$44,$45,$FF,$7F,$A2,$FF,$9F,$BF,$BF,$FB,$7D,$7B,$2E,$DF,$4E,$34,$16; 64
		dc.b $EF,$B1,$73,$B4,$6D,$9C,$5C,$D5,$20,$C1,$A5,$F8,$89,$D6,$A6,$44,$59,$FC,$B5,$F0,$2E,$95,$B8,$DB,$6C,$47,$17,$AD,$AB,$C7,$1B,$C6,$6C,$DC,$1E,$1C,$59,$B8,$54,$71,$66,  6,$8A,$8E,$2D,$46,$8A,$8F,$F2,$68,$A9,$3E,$4D,$33,$3E,$62,$74,$78,$89,$D1,$E2,$FC,$1E,$33; 128
		dc.b $66,$E0,$F0,$E2,$CD,$C2,$A3,$8B,$30,$34,$54,$71,$6A,$34,$54,$7F,$93,$45,$49,$F2,$69,$99,$F3,$13,$AD,$4C,$88,$88,$88,$8F,$1A,$A3,$C5,$F8,$3C,$66,$CD,$C1,$E1,$C5,$9B,$85,$47,$16,$60,$68,$A8,$E2,$D4,$68,$A8,$FF,$26,$8A,$93,$E4,$D3,$33,$E6,$27,$47,$88,$9D,$1E; 192
		dc.b $2F,$C1,$E3,$36,$6E, $F, $E,$2C,$DC,$2A,$38,$B3,  3,$45,$47,$16,$A3,$45,$47,$F9,$34,$54,$9F,$26,$99,$9F,$31,$3A,$D4,$C8,$88,$8A,$FE,$43,$E1,$83,$1E,$1E,$BA,$A5,$DB, $D,$E4,$30,$C8,$6B,$35,$6F,$2E,$2C,$C1,$D9,$51,$C6,$FA,$34,$54,$9E,$68,$D4,$75,$47,$B8,$9E; 256
		dc.b $C8,$B5,$F9,$AF,$CC,$7E,$6B,$A5,$FC,$FA,$C7,$C5,$7C,$11,$11,$11,$11,$11,$14,$7C,$67,$E2,$F5,$12,$FC,$47,$8A,$3D,$75,$2F,$42,$24,$2F,$21,$A1,$A9,$5F,$C1,  6,$CB,$A5,  5,$A5,$A8,$36,$59,$5F,$C6,$1D,$C8,$77,$21,$DC,$BD, $C,$FE,$6E,$59,$97,$E6,$F2,$3D,$4B,$B1; 320
		dc.b $2E,$C4,$BB, $D,$E5,$E4,$AC,$71,$4A,$5A, $B,$A5,$63,$81,$E5,$E5,$A1,$A1,$2B,$89,$40,$F5,$2E,$80; 384
Nem_HPZ_Bridge:	dc.b $80,$15,$80,  3,  1,$14,  8,$26,$33,$36,$36,$46,$39,$56,$3A,$66,$3B,$73,  2,$81,  3,  0,$15,$1A,$82,  4, $A,$83,  3,  3,$14, $B,$84,  5,$18,$85,  6,$38,$86,  6,$32,$18,$FA,$87,  4,  9,$88,  7,$7A,$89,  7,$79,$8A,  6,$37,$8C,  8,$F8,$8E,  7,$78,$8F,  7,$7B; 0
					; DATA XREF: ROM:0001C1AEo
		dc.b $FF,$D9,$FE,$8A,  3,  6,$C8,$A0,$CB,$CF,$2C,$32,$C8,$A1,$8B,$8A,$39,$35,$C8,$7C,$85,$DB,$5D,$8B,$E8,$5F,$42,$90,$CF,$F4,$31,$FA,$1C,$C2,$A1,$D5,$8E,$AC,$2E,$DA,$EC,$72,$C2,$E5,$E4,$6A,$2F,  2,$81,$65,$E3,$2C,$D9,$62,$81,$B2,$18,$8F,$D1,$3F,$D8,$C6,$A2,$C8; 64
		dc.b $BF,$CA,$40,$38,$E3,$EB,$46,$86,$36,$A3,$8D,$A4,$E5,$B4,$C4,$E7,$24,$40,$E6,$B6,$92,$33,$11,$30,$E0,$44,$82,$E0,$72,$E3,$44,$45,$ED,$A8,$BF,$F8,$DC,$6B,$6B,$80,$75, $F,$91, $C,$89,$81, $E,$26,  6,$60,$CE,$D5,$C8,$80,$67,$39,$89,$DB,$23,$3B,$60,$D6,$D8,$14; 128
		dc.b $75,$F5,$C6,  8,$8F,$CA,$58,$37,$1A,$8F,$D0,$91,$FA,$22,$2B,$89,$19,  2,$E5,$F1,$26,$46,$54,$E4,$E8,$EA,  4,$31,$44,$1B,$CC,$17,  3,$A0,$87,$41,$C9,  5,$E6,$24,$83,$60,$89,$3A,$87,$13,  0,$87,$43,$F4,$F0, $B,$A0,$5D,  8,$14,$C8,$A6,$44,$7E,$9C,$53,  4,$44; 192
		dc.b $C3,$8D,$19,  4,$59,  6,$46,$6C,$83,$2C,$74,$10,$E8,$43,$23,$3B,$20,$D0,$70,$23,$47,$46,$5D,$64,$24,$CF, $E,$59,$19,  9,$E2,$81,$F5,$F1,$C7,$BF,$DD,$E1,$9B,$FD,$2C,$A4,$97,$7E,$37,$3B,$E3,$F4,$7C,$3A,$3B,$FA,$F3,$ED,$24,$92,$49,$24,$92,$5E,$B7,$AF,$3F,$8D; 256
		dc.b $F1,$EF,$CE,$19,$BF,$D2,$CA,$49,$77,$E3,$73,$BE,$3F,$47,$97,$18,$7E,$7C,$7B,$F8,$49,$24,$92,$49,$24,$97,$E2,$FE,$31,$BF,$8F,$5E,$77,$C3,$37,$FA,$59,$49,$2E,$FC,$6E,$77,$C7,$E8,$FE,$BF,$2B,$F9,$FF,$CE,$24,$92,$49,$24,$92,$48; 320
Nem_HPZ_Waterfall:dc.b $80,$35,$80,  3,	 0,$15,$19,$23,	 1,$35,$17,$45,$1A,$56,$3B,$67,$78,$74,	 4,$81,	 4,  6,$34,  9,$48,$F8,$82,  6,$38,$83,	 4,  5,$17,$7A,$85,  4,	 8,$86,	 6,$39,$87,  4,	 7,$89,	 5,$16,$17,$7B,$8A,  5,$1B,$8B,	 5,$18,$8C,  4,	$A,$8D,	 6,$3A,$8E,  7,$79,$FF;	0
					; DATA XREF: ROM:0001C1B4o
		dc.b $14,$30,$30,$30,$5C,$BA,$69,$CC,$20,$83,  9,$A8,$42,$A8,$81,$4A,$86,$2A,$85,$C3,$16,$4D,$36,$9C,$BA,$69,$CC,$20,$83,  9,$A8,$42,$A8,$81,$4A,$86,$2A,$85,$C3,$16,$40,$E8,$5B,$4E,$5D,  3,$A1,$7D,$41,$84,$10,$86,$34,$A8,$55,  2,$A1,$50,$C5,$B4,$C8,$5B,$4E,$5D; 64
		dc.b   3,$A1,$7D,$41,$84,$10,$86,$34,$A8,$55,  2,$A1,$50,$C5,$B5,$C9,$E5,  3,$97,$41,  6,$10,$42,$21,$8D,$29,$54,$40,$A5,$74,$C5,$B4,$C5,$83,$97,$44,$D3,$97,$41,  6,$10,$42,$21,$8D,$29,$54,$40,$A5,$74,$C5,$B4,$C5,$83,$97,$40,$ED,$4D,$8B,$CD,$E6,$F3,$79,$11,$99; 128
		dc.b $31,$37,$9B,$C8,$5C,$CD,$E6,$F2,$18,$2C,$9F,$80,$F9,$9B,$C9,$79,$BC,$DE,$6F,$37,$91,$19,$93,$13,$79,$BC,$85,$CC,$DE,$6F,$21,$82,$C9,$F8, $F,$99,$BC,$88,$14,$18,$72,$14,$79,$16,$1E,$47,$5A,$F2,$3A, $A,$3C,$8E,$83, $E,$87,$43,$A3,$D1,$E8,$38,$62,$C8,$28,$60; 192
		dc.b $6C,$60,$5B,$C7,$9F,$1E,$46,$FC,$75,$A5,$1D, $B,$78,$F3,$A6,$1D,  7,$1B,$18,$1B,$1E,$7C,$79,$D6,$FC,$74,$3A,$3B,$14,$3A,$3D,$1A,$18,$14,$28,$D1,$C1,$F2,$38,$14,$D8,$1E,$4F,$E4,$75,$FA,$1C,$F4,$3C,$C8,$61,$D4,$9E,$A4,$38,$A9,$BC,$8A,$18, $C,$19,$11, $D,$85; 256
		dc.b $6A,$C2,$85,$B3,$46,$C6,$87,$E6,$BD,$1A,$CB,$6B,$F2,$2F,$CE,$68,$7E,$5F,$9B,$BF,$E5,$57,$91,$68,$E0,$7A,$6C,$C7, $B,$F9,$17,$1C,$73,$97,$E3,$2E,$AE,$B0,$AE,$2A,$D5,$EF,$78,$AB,$FE,$F3,$3F,$9C,$1F,$95,$1B,$B7,$E5,$79,$F5,$65,$CA,$EB,$D5,$FD,$65,$87,$E8,$47; 320
		dc.b $E4,$43,$7E,$9D,$BF,$6E,$3F,$10,$1F,$F2,$C2,$3F,$11,$C4,$72,$3F,$2D,$D7,$10,$AD,$C8,$C7,$10,$39,$78,$E4,$B5, $B,$30,$83,$CE,$1B,$F1,$1C,  6, $D,$80,$AD,$F9,$21,$81,$F9,$A1,$F9,$14,$EE,$DE,$2D,$AC,$5E,$B3,$8B,$D5,$EB,  6,$B1,$BA,$C1,$AC,$36,$FB,$C0,$B5,$7E; 384
		dc.b $6C,$A8,$AC, $F,$CD, $B,$1C,$7A,$CD,$8D,$87,$BA,$18,$CD,$B3,  3,  7,$F5,$29,$DF,$E7,$33,$F9,$C1,$8F,$CE,$66,$A3,  3,$D9,$B7,$E6,$FD,$9F,$CE,$66,$8F,$E7,$3F,$37,$5A,$FC,$DA,$22,$22,$77,$6C,$EE,$F6,$CB,$6F,$BE,  7,$BB,$DB,$9B, $B,$56,$33,$58,$B4,$38,$D9,$DD; 448
		dc.b   6,$E7,$3C,$67,$81,$18,$DD,$96,$AC,$A3, $B,$BB,$3E,$ED,$9B,$2D,$B0,$C2,$C2,$AC,$77,$9A,$16,$1C,$73,$FA,$BB,$56,$16,$3F,$45,$6A,$C3,$28,$FE,$4F,$19,$AC,$70,$3D,$A8,$AC,  5,$DD,$AF,$8F,$5F,$A9,$3E,$D1,$11, $D,$78,$7C,$77,$86,$DF,$7B,$16,$18,$35,$B1,$66,$C1; 512
		dc.b $C5,$B3,$F9,$B3,$BB,$2E,$77,$5C, $B, $A, $A,$2D,$CF, $B,$9F,$62,$B8,$6E,$5E,$F1,$C0,$8A,$E3,  2,$2C,$A3,$9E,  6,$D6,$D1,$C3,$2F,$1E,$84,$7E,$4B,$9D,$41,$8F,$C9,$43,$88,$BF,$2C,$63,$81,$EA,$C3,$D8,$E1,$73,$F8,$80,$D9,$51,$2A,$66,$F2,$14,$2F,$C0,$51,$37,$97; 576
		dc.b $61,$F1,$79,$CB,  9, $E,$1E,$6F,$39,$71,$30,$64,$40,$89,$BC,$E6,  4,$DE,$54,$CD,$E4,$28,$5F,$80,$A2,$6F,$2E,$C3,$E2,$F3,$96,$12,$1C,$3C,$DE,$72,$E2,$60,$C8,$81,$13,$79,$CC, $F,$C4,$5B,$AB,$77,$1D,$AA,  5, $A,$8A,$14,$AE,$57,$2A,$C1,$8B,$5D,$83,$16,$D3,$5D; 640
		dc.b $83,$87, $F,$DB,$87, $F,$DB,$E5,$FB,$81,  2,$13,$F4,$A6,$35,$1D,$AA,  5, $A,$8A,$14,$AE,$57,$2A,$C1,$8B,$5D,$83,$16,$D3,$5D,$83,$87, $F,$DB,$87, $F,$DB,$E5,$FB,$81,  2,$13,$F2,$BC,$DA,$AD,$5F,$A9,$DA,$78,$AF,$14,$89,$BF,$1B,$4E,$ED,$E2,$C8,$88,$31,$E3,  8; 704
		dc.b $88,$88,$88,$88,$9A,$B7,$8B,$22,$20,$C7,$8C,$27,$74,$30,$30,$30,$5C,$BA,$69,$CC,$20,$83,  9,$A8,$42,$A8,$81,$4A,$86,$2A,$85,$C3,$16,$40,$E8,$5B,$4E,$5D,  3,$A1,$7D,$41,$84,$10,$86,$34,$A8,$55,  2,$A1,$50,$C5,$B5,$C9,$E5,  3,$97,$41,  6,$10,$42,$21,$8D,$29; 768
		dc.b $54,$40,$A5,$74,$C5,$B4,$C5,$83,$97,$40,$ED,$4D,$8B,$CD,$E6,$F3,$79,$11,$99,$31,$37,$9B,$C8,$5C,$CD,$E6,$F2,$18,$2C,$9F,$80,$F9,$9B,$C8; 832
Nem_HPZ_Emerald:dc.b $80,$20,$80,  3,  2,$13,  3,$24, $A,$35,$18,$45,$17,$55,$19,$66,$3A,$75,$1B,$81,  3,  0,$16,$38,$82,  4,  8,$17,$78,$83,  3,  1,$16,$39,$84,  7,$77,$85,  5,$1A,$18,$F7,$86,  5,$16,$18,$F6,$87,  4,  9,$17,$79,$8C,  7,$76,$8E,  7,$7A,$FF,$E8,$64,$4D,$C4,$9C; 0
					; DATA XREF: ROM:0001C1CCo
		dc.b   9,$38,$12,$70,$35,  6,$86,$9E,$B9,$11,$E5,$4F,$2B,$F4,$5E,$FE,$45,$CB,$17,$2C,$6C,$6C,$6C,$6C,$6C,$55,$B3,$63,$18,$B1,$70,$EC,$71, $B,$5D,$1B,$60,$87,$64, $D,$15,$69,$B8,$53,$18,$81,$D4, $D,$A8,$BC, $E,$88,$8B,$82,$3D,$FD,$BC,$DB,$4F,$87,$C2,$FD,$12,  8; 64
		dc.b $20,$E0,$38,$2C,$10,$83, $F,$BA,$28,$39,$5D,$D8,$F1,$AF,$CA,$5B,$CF,$E9,$7F,$29,$C2,$15,$6D,$9E,$10,$C1,$A1,$8E,$28,$33,$53,$8E,$32,$5C,$D8,$54, $A,$1B, $E,$2E,$36,$E3,$B3,$D2, $C,$2D,$28,$7F,$8F,$5A,$A1,$F8,$F1,$72,$1D,$AB,$F1,$B5,$1E,$C4,$6C,$54,$7E,$71; 128
		dc.b $87,$EA,$E3,$D2,$17,$FC,$C7,$E2,$7F,$15,$FA,$9F,$C4,$57,  8,$16,$17,$1C,$A0,$B8,$E5,  5,$C7,$35,$C7,$35,$C7,$37,  7,$F4,$2C,$41,$8E,$7F,$44,$58,$C4,$16,$36,$2A, $D,$E6,$E2,$CE, $D,$E5,$41,$DB, $E,$54,$14,$3D,$63,$9E,$D1,$E9,$4A,  8,$23,$EA,$8D,$1F,$52,$86; 192
		dc.b  $F,$AE,$8F,$E2,$7A,$3F,$89,$DF,$47,$A3,$93,$93,$93,$41,$9C,$7E,$27,$F1,$1F,$89,$FD,$57,$E6,$E3,$F8,$2B,$F4,$75,$CD,$1E,$84,$50,$2E,$74,$43,$12,$FB,$C0,$31,$FA,$69,$31,$EF,$FC,$61,$B9,$BD,$8A,$9C,$1A,$9D,$CA,$B1,$43,  7,$33,$80,$C1,$C0,$47,$22,$85,$73,$46; 256
		dc.b $E1,$15,$CE,  7,$2C,$54,$30,$FC,$A1,$71,$28,$39,$62,$6E,$50,$9B,$94,$25,$85,$D8,$A1,$38,$ED,$C8,$BF,$64,$1C,$FE,$6F,$F1,$1D,$ED,$3A,$E6,$38,$B4,$77,$42,$AD,$A4,$1C,$8B,$57,$9F,$6A,$95,$ED,$41,$7B,$50,$5A,$5F,$B6,$F3,$AF,$DB,$7E,$9F,$A1,$6A,$1B,$5C,$2B,$21; 320
		dc.b $B5,$C5,$C6,  5,$98,$63,$6A,$D3,$79,$B9,$DC,$B9,$B3,$3D, $C,$4F,$B0,$62,$AC,$C3,$16,$47,$25,  7,$C6,$CE,$38,$47,$F3,$D4,$3F,$3B,$8F,$CE,$63,$F3,$B9,$FC,$57,$E6,$FF,$15,$F9,$BF,$CE,$59,$4D,$A6,$DC,$2F,$28,$32,$85,$A5,$94,$1F,$B1,$B9,$F7,$C1,$7E,$EA,$6D,$FA; 384
		dc.b $58,$98,$FD,$B6,$A0,$20,$CB,$B6,$4E, $B,$B6,$AE,$70,$5D,$B5,$78,$B5,$17,$26,$F1,$6C,$C9,$BF,$BD,$E2,$DD,$1C,$C6,$F2,$3A,$39,$FC,$F6,$3F,$3C,$83,$FC,$F3, $B,$F3,$D4,$32,$32,$32,$32,$33,$DB,$F1,$BF,$AC,$FC,$6F,$E7,$3C,$72,$11,$C4,$28,$BC,$C3,$2E,$35,$78,$CC; 448
		dc.b $28,$CC,$F8,$D7,$83,$1A,$F1,$AF,  3,$30,$37,$78,  7,  5,$1C,$1E,$3A,$38,$22,$2E,$22,$E4,$60,$10,$68,$31,$41,$82,$C5,  6,$30,$6B,$C5,$E1,$11,$45,$16,$3B,$2E,$5E,$9F,$6A,$EF,$8E,$CB,$B8,$D6,$3B,$77,$EB,$B6,$91,$BF,$6D,$F6,$5D,$BF,$BB,  8,$6C,$5C,$B8,$D8,$AF; 512
		dc.b $D1,$B1,$72,$C2,$2C,$D0,$7C,$DC,$DC,$1B,$8C,$8C,$8C,$8C,$8C,$8C,$8D,$D5,$B3,$A5,$18,$D6,$74,$8E,$84,$28,$DD,$B6,$B4,$CD,$59,$78,$18,$19,  5, $E,$AC,$F8,$2A,$48,$65,$49,$44,$42,$EE,$68,$C6,$25,$80,  0; 576
Nem_HPZ_Platform:dc.b $80,$10,$80,  4,	9,$15,$19,$37,$7C,$72,	0,$83,	5,$18,$16,$3B,$84,  2,	1,$26,$3D,$85,	5,$1A,$87,  4,	8,$16,$3C,$36,$38,$89,	4, $B,$8A,  4, $A,$16,$37,$77,$7D,$8B,	6,$39,$8D,  6,$3A,$8E,	6,$36,$FF,$AD,$A3,$6A,$FD,$5B,$89,$EF,$F4,$B0,	1,$FE, $D,$AA; 0
					; DATA XREF: ROM:0001C1BAo
		dc.b $69,$FD,$1F,$15,$34,  0,  4,$FE,$3F,$9F,$CF,$FE,$23,$F0,$5C,$FE, $B,$FA,$B1,$A0,  3,$FA,$7A,$C3,$5F,$B4,$C3,$F1,$CA,  0,$1F,$81,$E7,$F2,$3A,$FC,$8E,$B8,$C7,$98,  0,$3F,$EB,$FB,$38,$EE,$3F,$40,$80,  7,$CF,$D0,$EB,$F6,$3C,$63,$CC,  0,$1F,$F5,$FD,$9C,$77, $E; 64
		dc.b $59,$F4,  0,$2F,$F3,$B7,$53,$B0,  0,  0,$1F,$D0,$65,$3F,$81,$BF,$F0,$22,$77,$B8,$BE,$AF,$7B,  0,  0,  1,$97,$E4,$4D,$65,$CA,$7D,$DE,$EB,$F7,$20,  0,  0,$66,$27,$8C,$B3,$FB,$43,$EF,$5F,$99,$EA,$FF,$5A,  0,  0,  3,$E3,$1E,$C7,$E5,$21,$FD,$3B,$96,$7D,$FA,  0; 128
Nem_HPZ_PulsingBall:dc.b $80,$22,$80,  3,  2,$14,  6,$25,$12,$34, $A,$45,$18,$55,$1A,$66,$3C,$74,  7,$81,  3,  0,$15,$17,$36,$3B,$82,  4,  8,$83,  3,  1,$15,$19,$27,$7A,$84,  6,$3A,$18,$F8,$85,  5,$16,$15,$1C,$86,  5,$1B,$87,  5,$13,$17,$7B,$FF,$7D,  3,$40,$C0,$90,$8B,$ED,$84,$34; 0
					; DATA XREF: ROM:0001C1C0o
		dc.b $ED,$5B,$EA,$65,  8,$11,$D2,$32,$D9,$45,  8,$43,$66,$BD,$EA,$7E,  4,$5E,$83,$A3,$83,$A0,$EC,$70, $B,$E7,  1,$67,  1,$1D,$5D,$FB,$8F,$E0,$E5,$1D,$66,$B7,$EA,$B6,$51,$C6,$70,$5D,$DD,$DD,$DD,$DD,$DD,$F4,$71,$9C,$14,$77,$5E,$B7,$59,$D1,$59,$FE, $C,$76,$F7,$D1; 64
		dc.b $43,$19,$43,$19,$72,$30,$5D,$86,$8E, $B,$A0,$F4,$50,$F2,$7A,$F7,$47,$61,$40,$45,$1D,$C8,$AE,$A0,$40,$46,$7D,$6E,$AD,$36,$80,$DB,$BC,  9,  8,$22,$88,$77,$A0,$68,$18,$12,$11,$79,$B0,$86,$F8,$AE,$74,$50,$8B,$DB,$13,$89,  8,$46,$6C,$1B,$7D,$6B,$72,$12, $F,$A0; 128
		dc.b $E8,$B0,$62,$C6,$43,$42,$45,$19,  3,$23,$59,$62,$C1,$67,  1,$1D,$5D,$FB,$8F,$E0,$E5,$1D,$66,$A7,$EA,$A6,$5B,$D3,$96,$ED,$AF,$57,$6F,$DB,$CA,$75,$35,$36,$BB,$4D,$83,  7,$A0,$C1,$A6,$D7,$69,$A9,$D4,$E5,$FB,$76,$BD,$5D,$BB,$62,$FE,$98,$CE,$BD,$4E,$B3,$A2,$B3; 192
		dc.b $FC,$18,$ED,$EF,$A2,$86,$32,$83,$16,$CD,$19,$11,$22,$8C,$86,$84,$8B,$16, $C,$5D,  7,$D0,$90,$96,$F5,$D6,$D8,$34,$CA,$81,$28,$9E,$2D,$78,  8,$F5,$CA,$F8,$68, $D,$3B,$C0,$90,$82,$28,$87,$77,$77,$C5,$B5,$CC,$73,$1C,$42,$5C,$42,$DE,  6,$E2,$16,$1A,$11,$42,$C8; 256
		dc.b $2E,$4B,$3A,$3E,  6,$B3, $F,$D2,$63,$F4,$AD,$FF,$5F,$D2,$CB,$8D,$72,$18,$1B,$42,$80,$7A,$9A,$9D,$ED,$31,$F9,$29,$FE,$58,$23,$68,$9B,$46,$67,$83,$5F,$A1,$95,$DA,$18,$36,$70,$68,$22,$C3,$41,$7C,$73,$F2,$DE,$FF,$4B,$8F,$EA,$E3,$F8,$BD,$B7,$32,$D7,$AF,$4B,$FA; 320
		dc.b $28,$C2,$FD,$3A,$FD, $C,$4B,$DA,$EE,$53,$41,$AE,$D3,$59,$61,$83,$53, $C,$50,$90,$D7,$BF,$CB,$73,$E1,$DD,$ED,$E7,$3C,$E6,  2,$E6,  2,$E4,$A1,$E0,$2E,$30,$F0,$4D, $D,$43,$71,$4D,$D4,$F1,$FA,$40,$D6,$77,$7B,$6A,$C7,$16,$3B,$AB,$1D,$D5,$8E,$D0,$91,$DA,$10,$D6; 384
		dc.b $F0,$ED,  8,$D1,$56,$56,$6B,$EC,$36,$E5,$9A,$28,$F8,$1A,$CD,$1B,$BC,$B9,$56,$DE,$7F,$6A,$7F,$4D,$2B,$6D,$AF,$F9,$26,$19,$8F,$D0,$98,$43,$F4,$F0,$DC,$C7,$5F,$92,$FD, $F,$C1,$BA,$CA,$21,$65,$AE,$8B,$5E,$11,$57,$60,$E5,  7,$C6,$7F,$8F,$EB,$92,$FD,$36,$79,$5F; 448
		dc.b $96,$B2,$B7,$E4,$AE,$DC,$BC,$1B,$B7,$E9,$C4,$1E,$D7,$B1,$19,$57,$53,$41,$65,  5,$3A,$28,$29,$DD,$8A,$12,$BA,$2E,$85,  4,$5D,$7F,$1F,$F2,$D6,$77,$7E,$6A,$CA,$DA,$B2,$B5,  5,$6C,$10,$B9,$20,$F0,$17,$1A,$68,$EA,$68,$35,$A4,$1A,$D8,$2F,$40,  0; 512
Nem_HPZ_Various:dc.b $80,$16,$80,  3,  1,$14,  8,$26,$38,$36,$3A,$45,$1B,$56,$3D,$66,$3B,$74,  9,$81,  3,  0,$14, $A,$82,  4, $B,$18,$F8,$83,  3,  2,$15,$1A,$84,  6,$3C,$85,  5,$18,$86,  5,$19,$18,$F9,$87,  3,  3,$16,$39,$38,$FA,$FF,$FC,$7F,$E2,$FF,$7F,$F8,$CF,$C7,$FF,$55,$E2; 0
					; DATA XREF: ROM:0001C1C6o
		dc.b $66,$66,$7F,$A7,$85,$81,$FB,$5B,$C7,$D2,$E5,$4C,$CC,$CF,$FD,$7F,$65,$9F,$8C,$A3,$A9,$99,$99,$EB, $F,$F2,$BF,$59,$7F,$3F,$4B,$95,$F5,$33,$33,$3F,$F5,$C5,$8C,$56,  6,$1F,$F5,$66,$66,$65,$63,$FA,$77,$8B,$4F,$F1,$DA,$FD,$2E,$8A,$F3,$B7,$33,$33,$FA,$3F,$3F,$14; 64
		dc.b $7F,$15,$F8,$EF,$DE,$7E,$DB,$8D,$7E,$88,$42,$22,$78,$10,$88,$9E,  4,$22,$27,$81, $A,$76,$21,$4E,$C4,$C8,$93,$6B,$F4,$54,$B9,$F9,$17,$80,$68,$BC,$F4, $D,$38,  6,$99,$A3,$4C,$88,$A6,$44,$53,$22,$11,$64,$11,$1E,$30,$6B,$8C,$66,$8A,$E3,$10,$B7,$63,$BF,$8E,$EE; 128
		dc.b $48,$C7,$F5,$9F,$FC,$72,$87,$40,$8B,$11,$50,$2C,$D4,$32,$10,$E9,$90,$8A,$2C,$B2,$15,$8E,$4B,$35,$1C,$96,$3C,$20,$F3,$96,$A0,$43,$5D,$3C,$AE,$BE,$56,$F2,$BD,$5B,$FC,$AF,$E9,$B9,$C1,$FD, $D,$A3,$50,$8E,$84,$23,$A1,  8,$E8,$16,$8E,$81,$71,$A0,$5C,$68,$17,  0; 192
		dc.b $82,$CB,$8F,  3,$3C,$C2,$79,$E4,$88,$4E,  7,$4B,$2F,$D5,$F3,$EA,$CF,$6A,$3F,$A7,  3,$FC,$C0,$DF,$EC,$6C,$BB,$51,$A8,$76,$75,  0,$B0,$BA,  5,$82,  8,$20,$B1,$6A,$88,$2D,$45,$10,$FC,$28,$D6,$71,$C2,$8C,$6C,$5E,$FE,$3D,$BD,$8E,$C7,$7F,$A2,$D6,$C1,$50,$24,$82; 256
		dc.b $A0,$49,  5,$40,$9E,$14,  9,$E1,$40,$9F,$44,$FA,$27,$D5,$FE,$21,$FE,$60,$6F,$F6,$36,$5D,$A8,$D4,$3B,$3A,$80,$58,$5D,  2,$C1,  4,$10,$58,$B5,$44,$16,$A2,$88,$7E,$14,$6B,$38,$E1,$46,$36,$2F,$7F,$1E,$DE,$C7,$7F,$1F,$A3,$85,$CF,$C8,$BC,  3,$45,$E7,$A0,$69,$C0; 320
		dc.b $34,$CD,$1A,$64,$45,$32,$22,$99,$10,$8B,$20,$88,$F1,$83,$5C,$63,$34,$57,$18,$85,$BB,$1D,$FC,$77,$72,$40; 384
Nem_UnusedDust:	dc.b   0,$18,$80,  5,$17,$14,  8,$25,$1B,$35,$19,$45,$1C,$56,$3A,$67,$7A,$72,  0,$83,  4,  6,$14, $A,$28,$F9,$38,$FA,$84,  3,  2,$14,  9,$25,$18,$37,$7B,$58,$F8,$85,  4,  7,$15,$16,$26,$3C,$35,$1A,$46,$3B,$58,$FB,$FF,$CF,$CE,$EB, $D,$7A,$9F,$29,$77,$4B,$B6,$9D; 0
		dc.b $26,$5F,$77,$69,$D5,$26,$C3,$DE,$A7,$CA,$5A,$57,$69,$7C,$57,$C5,$7C,$5F,$F8,$73,$1F,$D3,$3F,$A7, $A,$BD,$B3,$CE,$A7,$C5,$A5,$FE,$5C,$7F,$D7,$FE,$B6,$5F,$E5,$4E,$B5,$8D,$7F,$D1,$3A,$79,$AC,$7F,$CE,$EC,  7,$A5,$EA,$7A,$B4,$E7,$C9,$BA,$BB,$E3,$3E,$7F,$11,$D3; 64
		dc.b $E2,$25,$D6,$6C,$DC,$4C,$B8,$C0,  6,$EB,$2D,$8A,$85,$69,$6B,$AD,$4D,$D6,$93,$DD,$69,$3D,$D9,$77, $D,$36,$5B,$6F,$79,$FA,  0,  3,$33,$FC,$3F,$86,$F7,$DC,$FD,$AE,$D3,$AE,$D7,$DC,$F9,$86,$F8,$6B,$B6,$2B,$7F,$40,  4,$37,$A5,$F3,$9B,$2A,$DE,$93,$47,$78,$7F,$7F; 128
		dc.b $33,$F5, $C,$9B,$94,  0,  0,$43,$AE,$6B,$6B,$B8,$5D,$C3,$2B,$26,$DC,$D6,$69,  2,$F4,$E0,  3,$F5,$68,$78,$56,$BA,$75,$76,$4F,  9,$A1,$90,$10,$9D,$42,$8B,$28,$50,$C9,$80, $D,$DB,$AF,$39,$65,$94,$F5, $A,$28,$2F,$2C,$9E,$EF,$D2,$B7,$2C,$9B,$32,  0,$1E,$AC,$B9; 192
		dc.b $65,$CC,$43,$F5,$60,$37,$6E,$A4,$2E,$80, $B,$74,$9F,$2E,$43,$C3,$81,$D2,$7D,$BE,$D1,$74,  0,  6,$6D,$D4,$C2,$38,$83,$A4,  0,$70; 256
Nem_CPZ_FloatingPlatform:dc.b	0,$10,$80,$73,	0,$81,	4,  5,$15,$12,$26,$2E,$36,$3A,$46,$3B,$74,  6,$82,  5,$14,$26,$34,$36,$33,$83,	4,  2,$16,$39,$25, $F,$35,$10,$84,  4,	3,$15,$16,$26,$32,$37,$78,$46,$35,$85,	4,  4,$15,$13,$86,  5, $E,$28,$FA,$87,	6,$36,$88,  5,$11,$16,$3D,$89; 0
					; DATA XREF: ROM:0001C12Eo
		dc.b $27,$79,$8A,$15,$18,$28,$FB,$8B,  7,$7C,$16,$2F,$8C,  5,$15,$8D,  6,$37,$8E,  6,$38,$FF,$7E,$BA,$15,$1F,$9C,$34,$2A,$3E,$F9,$5F,$2F,$92,$BF,$BB,$EE,$F8,$B7,$DD,$7E,$70,$D0,$A8,$FC,$E1,$A1,$53,$93,$CD,$F9,$95,$1F,$9C,$34,$2A,$3D,$BF,$21,$2C,$FF,$61,$D7,$F4; 64
		dc.b $24,  0,  0,  0,  0,$19,$7F,$16,  6,$56,$79,$96,$50,$32,$B2,$DF,$D7,$E2,$AF,$EB,$1F,$3A,$FB,$EB,$F7,$50,$32,$B3,$CC,$B2,$81,$95,$9E,$65,$64,$81,$91,$C0,$CB,$28,$19,$59,$E6,$59,$37,$37,$68,$CC,$DF,$C0,$F3,$FE, $F,$C4,$80,  0,  0, $F,$DA,$FE,$DB,$C2,$1C,$F5; 128
		dc.b $43,$4F,  8,$73,$FB,$EF,$1D,$E3,$BC,$77,$F7,$E1, $E,$7A,$A1,$A6,$55,$B9,$35,$43,$4C,$AB,$72,$6A,$86,$9E,$10,$E7,$AA,$1A,$31,$5A,$6C,$CD,$77,$F2,$63,$BC,$7C,$C6,$BC,$7B,$F8, $F,$DC,$FE,$A3,$F6,$1E,$78,$FF,  7,$E2,$40,  0, $F,$A9,$D9,$66,$E9,$1C,$A6,$EA,$A9; 192
		dc.b $CA,$6E,$AB,$90,$97, $E,$54,$FD,$7E,$1C,$A7,$76,$1D,$53,$FD,$7E,$1D,$52,$6B,$B9,$5F,$D2,$AF,$2A,$85,$42,$49,$21,$3A,$8E,$24,$54,$FC,$B5,$3F,$2C,$8A,$7F,$C6,$32,$52,$FA,$25,$E5,$5E,$D2,$2B,$4F,$E9,$99,$A3,$C4,$77,$8E,$D1,$DA,$BF,$C8,$D9,$DB,$FB,$BF,$BB,$3B; 256
		dc.b $88,$D6,$3C,$7B,$B7,$9F,$D4,$6F,$1F,$D0,$7F,$24,  0,  0; 320
Nem_HPZ_WaterSurface:dc.b   0,$18,$80,	3,  4,$16,$38,$26,$3C,$37,$7A,$73,  5,$86,  5,$1A,$16,$3A,$87,	4, $C,$16,$3B,$88,  2,	1,$16,$39,$27,$7B,$38,$F8,$89,	2,  0,$15,$1B,$FF,$B6,$DB,$FE, $D,$79,$FF,$6F,$D3,$76,$EB,$F6,$FE,$F1,$EF,$9D,$A6,  9,$C8,$88,$EE,$10,$83,  8,$42,$6E,$10; 0
					; DATA XREF: ROM:0001C1D2o
		dc.b $B6,$D9,$D7,$AF,$DB,$4F,$EB,$67,$ED,$B3,$F8,$DD,$F5,$CF,$7A,$E7,$3F,$B1,$8E,$72,$23,$8E,$D1,$13,$92,  9,$37,  4,$4E,  8,$42,$1E,$88,$5B,$67,$7F,$D0,$C7,$3F,$81,$9E,$F3,$C7,$3E,$3B,$18,$CF,$70,$4F,$81,$13,$E0,$44,$77,  4,$83,  4,$49,$B8,$42,$1C,$1E,$10,$E0; 64
		dc.b $F0,$B6,$DB,$6C,$73,$AF,$5F,$C8,$D6,$68,$FE,$47,$48,$8F,$68,$CF,$67,$22,$41,$DC,$21, $E,  8,$42,$1C,$10,$87,$A2,$DB,$6D,$BE,$75,$9A,$CD,$67,$59,$D3,$FB,$7F,$E4,$7E,$9C,$44,$F8,$11,$1D,$A4,$11,$84,$20,$EE,$10,$87,$A2,$DB,$6D,$FF,$B7,$5D,$EB,$35,$FB,$77,$F8; 128
		dc.b $EF,$7F,$C8,$13,$91,$13,$91,$11,$DA,$24,$38,$12, $E,$E1,  8,$70,$5B,$6D,$FE,$86,$BF,$4F,$EB,$FE,$EE,$73,$8F,$62,$38,$E7,$22,$23,$B4,$44,$88,$88,$EE,$10,$48,$89,  9,$BE,$1E, $B,$6D,$B6,$CC,$FF,  7,$ED,$F5,$9A,$C3,$E3,$4E,$93, $E,$73,$46,$18,$23,  4,$83,$BF; 192
		dc.b   8,$70,$41,$21,$E8,$85,$B6,$DB,$6C,$CF,$DB,$77,$D6,$3F,$A7,$F7,$A7,$39,$CD,$A2,$43,$21,$86,$13,$70,$F0,$E0,$84,$38,$3F,$80,$52,$DB,$6D,$99,$D6,$71,$D7,$E9,$F5,$9D,$38,$F7,$F0,$7B,$26,$D1,$11,$84,$21,$C1,  8,$43,$D1, $E, $F,$E0,$16,$DB,$6D,$9A,$CF,$E8,$7F; 256
		dc.b $1D,$CF,$66,$39,$EC,$4C,$73,$68,$88,$C2,  9,$37,  4,$87,$F4,  8,$7A,$2D,$B6,$DB,$E6,$6B,$FA,$1C,$E6,$9D,$38,$67,$3A,$CE,$91,$C7,$1D,  9,$86, $C,$21,$83,$B8,$42,$1C,$1E,$10,$E0,$84,$2C,  0,  0; 320
Nem_Button:	dc.b $80,$10,$80,  3,  2,$24, $A,$34, $C,$72,  0,$81,  4, $D,$13,  3,$26,$3C,$86,  6,$3B,$78,$FB,$87,  7,$7A,$27,$7C,$88,  7,$7B,$28,$FA,$89,$76,$3A,$8E,  6,$38,$16,$39,$8F,  4, $B,$13,  4,$FF,$FA,$F9,$DF,$AF,$38,$9B,$74,$D4,$A6,$A5,$35,$29,$A9,$4D,$4A,$D4,$F8; 0
		dc.b $E8,  0, $F,$B6,$B7,$2D,$3C,$B4,$F2,$D3,$CB,$4F,$2D,$3C,$DE,$7F,$9F,$F8,$9F,$F4,$57,$BF,$CC,$FE,$58,$5F,$98,$D5,$6C,  3,$B9,$CE,$FF,$43,$53,$C6,$AF,$1A,$BC,$6A,$F1,$AB,$C6,$BF,$BF,$CE,$FF,$A3,$F1,$3F,$96,$FC,$CF,$B2,$9D,$AD,$FC,$C0,  2,$DF,$C8,$47,$EE,$F6; 64
		dc.b $71,$E4,$4E,$A2,$75,$13,$A8,$9D,$44,$EB,$86,$B6,$BA,  0,  0,  0,  3,$EB,$E7,$7E,$BC,$E2,$6D,$D3,$52,$9A,$94,$D4,$A6,$A5,$35,$2B,$53,$E3,$A0,  0,$3E,$DA,$DC,$B4,$F2,$D3,$CB,$4F,$2D,$3C,$B4,$F3,$79,$FE,$7F,$40,  0,$7D,$E6,$A7,$8D,$5E,$35,$78,$D5,$E3,$57,$8D; 128
		dc.b $7F,$7F,$9D,$E8,  0, $F,$5D,$FC,$FA,$BD,$9C,$79,$13,$A8,$9D,$44,$EA,$27,$51,$3A,$E1,$AD,$A0,  0; 192
Nem_VSpring2:	dc.b   0,$14,$80,  4,  7,$25,$1A,$46,$3A,$66,$3C,$73,  0,$81,  4,  5,$14,  6,$66,$3D,$76,$30,$86,  5,$19,$15,$16,$36,$38,$87,  5,$13,$15,$14,$88,  5,$12,$16,$31,$25,$17,$89,  3,  1,$14,  8,$78,$FB,$8C,  5,$15,$17,$7C,$28,$FA,$36,$39,$56,$3B,$8D,  4,  4,$16,$36; 0
					; DATA XREF: ROM:0001C142o
					; ROM:0001C17Ao ...
		dc.b $26,$37,$FF,  0,  0,  0,$BD,$33,$3C,$B2,$2E,$F5,$54,$5D,$EA,$8C,$8B,$BD,$55,$17,$7A,$A3,$22,$EF,$55,$45,$DE,$A9,$80,  0,  0,  7,$FD,$92,$A9,$DA,$76,$95,$4E,$D3,$B4,$AA,$76,$9D,$E0,  0,  0,  1,$FF,$6E,$78,$E7,$8E,$78,$E7,$8E,$78,$E7,$8C,  0,  0,  0,$3F,$4D; 64
		dc.b $3C,$D2,$5F,$12,$BB,$37,$D6,$CA,$8B,$F1,$2B,$B3,$7D,$6C,$A8,$BF,$12,$BB,$37,$D6,$CA,$98,$2B,$FD,$DE,$96,$7F,$7E,$CD,$E9,$67,$F4,$DE,$96,$C0,  0,  0,  3,$FD,$2F,$6A,$5C,$FA,$FF,$76,$A5,$CF,$AF,$6A,$5C,$E0,  0,  0,  1,$E1,$EA,$33,$A8,$B4,$DE,$27,$9A,$29,$94; 128
		dc.b $F1,$67,$38,$B4,$7E,$41,$BF,$53,$23,$A6,$89,$74,$C7,$C5,  0,  1,$E1,$EA,$33,$A8,$9E,$66,$F1,$FA,$79,$29,$9C,$A7,$26,$73,$8F,$F0,$5F,$D3,$7A,$5B,  0,  0,  0,  3,$3C,$4B,$3D,$24,$DA,$9B,$74,$A0,$78,$7C,$94,$74,$71,$8D,$2C,$4A,$34,$DF,$B9,$FD,$83,$19,$1F,$D8; 192
		dc.b $44,$8E,$A3,$12,$F1,$49,$2B,$9B,$62,$BF,$90,$CC,$E4,$DA,$9B,$74,$A3,$C6,$FE,$87,$AF,$6A,$5C,$E0,  0,  0,  0,  0; 256
Nem_HSpring2:	dc.b $80, $C,$80,  3,  2,$14, $A,$26,$38,$37,$7A,$46,$39,$55,$19,$68,$FA,$73,  3,$81,  2,  0,$15,$1B,$26,$3B,$57,$7B,$68,$FB,$86,  6,$3C,$88,  5,$1A,$89,  3,  4,$8C,  5,$18,$57,$7C,$8E,  6,$3A,$8F,  4, $B,$FF,$FB,$D2,$C2,$C2,$C2,$B5,$F2,$B0,$B0,$B0,$8A,$10,$B6; 0
					; DATA XREF: ROM:0001C148o
					; ROM:0001C180o ...
		dc.b $BE,$E8,$42,$1D,$7F,$69,$B7,$5F,$DA,$6D,$B6,$DB,$E0,$42,$2B,$DD,$7B,$AF,$75,$F6,$84,$21,$1F,$45,$61,$61,$62,$BE,$5A,$F9,$58,$58,$58,$E3,$47,$E6, $F,$CC,$2E,$D6,$E3,$6A,$D5,$D5,$BA,$11,$43,$6E,$84,$50,$EA,$D5,$D5,$B7,$5D,$AD,$CC,$CA,$EF,$A9,$9B,$CC,$BE,$A5; 64
		dc.b $5D,$5F,$D4,$5D,$44,$71,$67,$24,$2D,$F2,$78,$21,$1C,$5E,$48,$AD,$F2,$35,$BE,$48,$DB,$6F,$91,$CE,$4D,$3B,$9C,$1A,$1F,$E7,$A2,$35,$BE,$25, $A,$58,$B5,$50,$8B,$6A,$57,$EC,$66,$67,$AE,$E6,$6F,$D1,$A9,$7D,$4C,$9C,$69,$6A,$17,$28,$CE,$E1,$E1,$73,$22,$25,$1E,$2E; 128
		dc.b $B3,$F9,$F9,$E8,$8C,$C9,$A7,$F4,  0,  0; 192
Nem_DSpikes:	dc.b   0,$20,$80,  5,$1A,$16,$37,$25,$19,$35,$17,$45,$15,$55,$14,$65,$18,$73,  0,$81,  3,  1,$15,$16,$86,  4,  7,$87,  4,  8,$17,$7A,$27,$7B,$88,  5,$12,$16,$3B,$28,$F9,$89,  3,  2,$16,$38,$26,$39,$8A,  6,$3A,$16,$36,$8C,  5,$13,$17,$78,$27,$79,$38,$FA,$8D,  4; 0
					; DATA XREF: ROM:0001C13Co
					; ROM:0001C174o ...
		dc.b   6,$FF,$18,$34,$B5,$6C,$D5,$2C,$68,$5B,  4,  0,  0,  0,$59,$A5,$72,$C5,$A3,$2C,$7F,$5B,$1B,$9F,$E6,$BE,$BF,$9B,$36,$7F,$DE,$CD,$A7,$FB,$D9,$B4,$DA,$65,$A6,$D3,$6F,$1A,$2D,$36,$F3,$B9,$6F,$AC,$96,$F3,$72,$DE,$2A,$5A,$74,$2D,$82,  0,  0,$3E,$26,$F4,$F0,$F5; 64
		dc.b $F2,$F7,$FA,$7C,$F9,$FD,$36,$FE,$3F,$8D,$A9,$FF,$1A,$7F,$D6,$F2,$DF,$A6,$FA,$2C,$FF,$CC,  0,  0,  0,  0,  0,$F8,$9B,$D3,$C3,$D0,$B7,$F3,$37,$2D,$F5,$92,$DE,$6E,$5A,$6D,$52,$D3,$A1,$6C,$10,  0,  0,  1,$E1,$9E,$F3,$69,$B3,$E5,$A6,$D3,$68,$DE,$6D,$3F,$D6,$C6; 128
		dc.b $9A,$7F,$CD,$94,$FF,$9A,$7F,$BA,$5A,$DF,$AD,$2D,$6D,$16,$2D,$6C,$96,$B5,$6C,  0,  0,$68,$D3,$83,$73,$DA,$CA,$B4,$4B,$75,$DD,$A3,$50,$54,$3F,$E8,$54,$15, $E,$74,$54,$15, $F,$B9,$4E,$53,$E4,$A7,$2A,$E5,$39,$A9,$4F,$42,$B0,$40,  0,$E1,$1A,$49,$1A,$BC,$91,$B9; 192
		dc.b $79,$23,$9B,$3C,$91,$DD,$ED,$12,$47,$50,$F6,$89,$22,$A1,$ED,$25,$A2,$A2,$56,$DE, $A,$92,$CA,$82,$AE,$54,$50,$80,  0,  0,  0,  6,$39,$BA,$8E,$F9,$D1,$50,$BD,$AD,$15,$1C,$CB,$72,$9F,$F4,$39,$29,$E8,$53,$D0,$A7,$A1,$58,$20,  0,  0,  0,  1,$5E,$6F,$C7,$77,$32; 256
		dc.b $46,$E7,$8A,$95, $A,$A6,$4A,$A5,$45, $C,$A8,$56, $E,  8,$E6,$BE,$FF,$93,$FA,$19,$3F,$A9,$67,$F8,$20,$46,$14,$50,$A8,$A1,  0,  0,  0,  2,$8B,$1F,$96,$E2,$E7,$D3,$F1,$9B,$7B,$57,$B7,$6A,$B6,$E3, $B,$10,$A9,$25,$45, $A,$A6,$4A,$A7,$89,$5F,$F7,$37,$ED,$54,$A0; 320
		dc.b   0,  0,  0,  0,  0,$6F,$C5,$78,$AF,$3D,$67,$9F,$D5,$6B,$9D,$A5,$B7,$1B,$7C,$F4,$B6,$FE,$42,$EB,$F7,$1E,$97,$EE,$3D,$AE,$BB,$FD,$BA,$DA,$4F, $F, $B,$F5,$52,$78,$75,$B4,$BA,$93,$C2,$EB,$E7,$AE,$F8,$E9,$74,$B6,$FF,$C8,  0, $E,$B1,$B5,$25,$B5,$62,$5B,$5F,$D4; 384
		dc.b $B6,$CB,$C7,$7B,$69,$47,$CE,$DC,$7C,$ED,$CF,$7B,$73,$AF,$D5,$73,$BF,$F2,$72,  0; 448
Nem_HUD:	dc.b $80,$18,$80,  4,  6,$14, $A,$24, $C,$34, $B,$48,$FB,$55,$1D,$65,$1C,$72,  0,$81,  3,  2,$18,$F9,$25,$1B,$36,$3D,$8C,  4,  7,$16,$3C,$38,$FA,$8D,  3,  4,$15,$1A,$38,$F8,$FF,$2B,$E9,$53,$DC,$59,$AE,$C6,$D2,$67,$A8,$C8,$C7,$A8,$9B,$C4,$FD,$8F,$6F,$73,$3E,$3E; 0
					; DATA XREF: ROM:0001C0A4o
		dc.b $6B,$D0, $F,$BF,$A5,$4F,$71,$66,$B8,$8D,$33,$B4,$4D,$BB,$F1,$19,$1E,$DE,$E2,$AF,$85,$9E,$80,$7D,$FD,$2A,$7B,$8B,$35,$C4,$63,$B4,$4E,$D1,  5,$47,$B7,$B8,$AB,$E1,$67,$A0,$17,$FC,$C5,$C8,$B3,$5C,$5D,$8E,$D1,$3D,$C5,$9A,$68,$AD,  5,$EA,$B5,$5B,$6D,$80,$57,$F3; 64
		dc.b $17,$22,$CD,$71,$76,$3B,$46,$7B,$9F,$35,$1D,$A2,  1,$B5,$5A,$AD,$B6,$C0,$33,$C5,$4E,  0,$CE,$D1,$33,$80,$56,$B3,$4D,$BA,$F9,  0,$75,$9E,$21,$A0,$E3,$DC,$C7,$68,$9A,$71,$4E,$29,$C4,$6A,$96,$6C,  3,$3E,$95,$3D,$C5,$9A,$E2,$34,$CE,$DA,$78,$C8,$C7,$EC,$7B,$7B; 128
		dc.b $8A,$BE,$16,$7A,  1,$7F,$DC,$43,$79,$5A,$E7,$C9,$4E,$D1,  0,$5E,$BB,$B0, $B,$F1,$57,$80, $E,$D1,$33,$B4,  0,$D6,$69,$B7,$5B,  0,$57,$E2,$26,$3D,$BB,$3F,$5C,$95,$14,$68,$AD,$45,$D4,$15,$AE,$EC,  2,$BF,$B8,$8C,$F8,$FB,$F7,$27,$89,$9E,$E2,$CF,$D6,$F7,$77,$3F; 192
		dc.b $58,$86,$FE,$ED,$7F,$84,  6,  0; 256
Nem_Lives:	dc.b $80, $C,$80,  3,  0,$13,  2,$25,$12,$36,$3B,$46,$36,$55,$1A,$66,$3C,$74,  6,$81,  3,  1,$15,$16,$26,$3D,$82,  5,$17,$83,  5,$15,$84,  5,$18,$85,  8,$F8,$86,  4,  7,$87,  5,$13,$16,$33,$88,  6,$37,$8B,  6,$38,$8C,  5,$14,$16,$3A,$28,$FA,$8D,  4,  8,$16,$32; 0
					; DATA XREF: ROM:0001C0AAo
		dc.b $28,$FB,$8E,  8,$F9,$8F,  6,$39,$FF,$FF,$8F,$FD,$C6,$3F,$6B,$7A,$8C,$58,$6F,$CB,$AC,  2, $E,$F2,$C4,$B9,$5F,$92,$3B,$FE,$26,$62,$F9,$CB,$81,$3B,$27,$E6,$E5,$17,$57,$FD,$20,$9F,$75,$F8,$15,$F9,$81,$57,$32,$21,$CA,$AF,$E2,$9D,$7E,$51,$54,$4E,$F9,$FE,$8E,$8D; 64
		dc.b $FF,$7A,$F8,$FF,$95,$A8,$C2,$CC,$3F,$C4,$88,$CC,$15,$14,$53,$E3,  3,$F3,$E7,$67,$F9,$B8,$F8,$E6,$56,$9A,$9A,$21,$F7,$97,$1C,$8C,$6F,$F3,$55,$D7,$1F,$8A,$BA,$B0,$2F, $B,$F2,$D3,$7E,$25,$FB,$CF,$DB,$FF,$C5,$7E,$F0,$AA, $F,$B1,$41,$41,$95,$A5,$90,$A1,$95,$B6; 128
		dc.b $FA,$10,$68,$3F,$7A,$65,$FB,$16,$60,$E7,$4F,$3F,$1F,$C7,$D3,$CF,$53,$3A,$23,$E8,$AE,$84,  8,$2C,$CD,$DC,  8,$32,$FB,$2B,$2F,$65,$66,$4E,$7B,$2F,$33,$DE,$67,$6C,$CE,$C5,$E6,$75,$3F,$2D,$D9,$1D,$11,$D4,$35,$35, $D,$1E,$16,$C9,$64,$47,$A2,$CC,$CC,$CC,$CC,$C5; 192
		dc.b $7D,$19,$50,$40,$83,$B6,$5A,$F7,$6E,$8A,$A0,$81,  6,$5F,$64,$15,$EB,$33,$33,$33,$20,  0; 256
Nem_Ring:	dc.b   0, $E,$80,  6,$3D,$15,$19,$25,$18,$34, $A,$44,  9,$55,$1A,$65,$1C,$76,$3A,$85,  2,  0,$15,$1B,$86,  4,  8,$16,$3B,$28,$FA,$37,$7C,$8C,  3,  3,$14, $B,$38,$FB,$8D,  3,  2,$16,$3C,$FF,$94,$E3, $B,$EF,$2A,$D6,$FD,$13,$46,  6,$A8,$4C,$A2,$E4,$71,$23,$89,$1C; 0
					; DATA XREF: ROM:0001C0B0o
		dc.b $48,$A1,$C8,$E2,$44,$E1,$D0,$9F,$D6,$36,$AE,$7F,$4B,$F5,$3F,$AC,$EF,$1B,$4F,$BA,$DA,$EE,$47,$12,$27,$12,$38,$91,$C4,$8E,$24,$BA,$13,$54,$AF,  2,$B5,$EC,$7E,$B3,$CC,$DA,$DE,$3F,$4B,$D6,$3C,$95,$74,$9A,$30,$9A,$29,$32,$86,$8A,$1A,$91,$A9,$1A,$91,$A9,$1A,$24; 64
		dc.b $6A,$47,$E4,$96,$A4,$4F,$5B,$BD,$5C,$3A,$13,$87,$42,$71,$29,$C3,$A1,$43,$A1,$38,$A1,$38,$A1,$38,$A1,$38,$A1,$42,$A5,$66,  4,$D6,$3C,$B3,$17,$BA,$DF,$5E,$DC,$BE,$DE,$17,$C5,$95,$F1,$65,$7C,$59,$5F,$16,$53,$ED,$AC,$A7,$DB,$59,$3E,$CC,$9F,$66,$45,$68,$C8,$AD; 128
		dc.b $19,$3F,$7A,$64,$FD,$E9,$83,$C2,$77,$C3,$8B,$8F,$44,$14,$28,$47,$A2,$7F,$4D,$64,$50,$8A,$20,$D3,$E2,$E1,$A5,$A4,$D6,$97,$5D,$74,$71,$68,$66,  4,$E1,$A3,  3,$32,$61,$70,$EB,$47,$16,$86,$69,$70,$EB,$AE,$A8,  0; 192
Nem_Monitors:	dc.b $80,$3C,$80,  4,  2,$15,$15,$25,$10,$35,$12,$45, $B,$55,$16,$67,$77,$74,  0,$81,  4,  1,$14,  6,$27,$72,$37,$6E,$82,  6,$30,$83,  6,$2E,$84,  6,$36,$85,  7,$6F,$86,  5,$13,$16,$34,$87,  4,  3,$16,$33,$77,$78,$88,  5, $A,$17,$71,$89,  5,$14,$16,$35,$38,$F6; 0
					; DATA XREF: ROM:0001C0BEo
		dc.b $8A,  6,$32,$17,$74,$8B,  7,$70,$8C,$17,$7A,$8D,  6,$31,$17,$75,$68,$F3,$8E,  5,$11,$15, $F,$28,$F2,$38,$F7,$8F,  4,  4,$15, $E,$27,$76,$37,$73,$66,$2F,$FF,  0,$87,$F1,$AB,$3F,$E0,$95,  4,$B9,$C1,$2B,$AA,$E9,$24,$24,  0,  0,  0,  0,  0,  0,  0,  3,$B2, $E; 64
		dc.b $64,$A1,$AA,$3C,$85,$43,$61,$57,$B4,$37,  0, $C,$B5,$E3,$2E,$3A,$CB,$70,$7F,$DB,$FE,$3F,$FF,$FF,$C8,$53,$3D,$74,$3F,$27,$72,$8B,$99,$E3,$D9,$BC,$BB,$33,$F9,$B3,$D0,$5C,$DE,$5C,$9E,$E8,$A3,$3F,$B4,$5C,$CF,$48,$B9,$9F,$CD,$9E,$E7,$B9,$BD,$DD,$C8,$F5,$D3,$38; 128
		dc.b $F7,$57,$8D,$C8,$3F,$DF,$14,$6F,$FC,$FB,$69,$9F,$EA,$45,$EE,$68,$34,$54,$73,$8A,$3C,$69,$FA,$6F,$DB,$FF,$C4,$3F,$ED,$FF,$1F,$FF,$FF,$E4, $F,$4C,$F5,$31,$73,$3D,$B9,$B2,$45,$BF,$BE,$F6,$70,$A3,$F7,$3F,$73,$D2,$3B,$9E,$E7,$B7,$92,$7B,$BA,$28,$F7,$33,$9E,$EE; 192
		dc.b $51,$67,$BB,$77,$BA,$47,$3D,$73,$A2,$BB,$F8,$70,$A7,$F4,$50,$79,$FF,$E7,$3D,$3D,$9C,$F1,$FD,$4C,$5A,$1C,$9E,$91,$99,$AB,$F6,$FF,$A6,$A7,$FC,$43,$F8,$D0,$FE, $C,$EB,$CC,$86,$85,$AD,$51,$74,  4,  2,$40,  0,  0,  0,  0,  0,  0,$91,$AF,$31,$49,$74,$4A,$8A,$8B; 256
		dc.b $F2,$95,$15,  9,$7B,$28,$61,$BA,  2,$1D,$F8,$EB,$2D,$78,$CB,$70,$2E,$92,$A4,  4,$95,$5A,$56,$62,$82,$A8,$24,$E0,$A8,$24,$C2,$79,$92,$86,$84,$8F,$21,$51,$51,$62,$5E,$D0,$DC,  0,$32,$D7,$8C,$B8,$EB,$2D,$C1,$21,$B0,$D8,$4A,$66,$25,$43,$AA,$68,$2A,$8D,$44,$A3; 320
		dc.b $42,$55,$54,$69,$13,$81,$93,$A2,$75,$7B,$50,$EB,$FF,$9D,$33,$FD,$48,$BD,$CD,  6,$8A,$8E,$71,$47,$8D,$3F,$4D,$FB,$7F,$F8,$80,$54,$49,$AA,$C4,$33,$26,$92,$49,$55,$15,$54,$E4,$A3,$27,$55,$46,$33,$12,$32,$9C,$5D,$4C,$CA,$7F,$A9,$CC,$8F,$D9, $D,$46,$3F,$A9,$89; 384
		dc.b   9,$28,$B9,$1D, $F,$43,$56,$64,$7F,$A6,$A7,$FC,$6D,$49,  9, $C,$85,$43,$21,$2E,$30,$19,$4D,$67,$1B, $B,$AB,$89,$4D,  8,$54,$5B,$40,$54,$25,$42,$9D,$14,$30,$DD,  1, $E,$FC,$75,$96,$BC,$43,$71,$E9,$9E,$B3,$E4,$FE,$C2,$F7,$32,$79,$3B,$97,$93,$9B,$DD,$CD,$14; 448
		dc.b $7B,$B9,$76,$67,$8C,$5C,$DE,$42,$F7,$34,$45,$EE,$6F,$77,$33,$D9,$EE,$DC,$FE,$D3,$CF,$5D,$28,$13,$D7,$4C,$E6,$8F,$73,$3B,$DD,$D1,$17,$7F,$79,$9C,$F4,$8B,$73,$6E,$6D,$11,$E6,$CF,$67,$72,$8E,$E7,$8C,$59,$EE,$7B,$3F,$B0,$B9,$9F,$CF,$74,$69,$A6,$7A,$18,$78,$AE; 512
		dc.b $3A,$D8,$E7,$45,$C4,$67,$AC,$A3,$39,$75,$A0,$56,$96,$A0,$2F,$6B,$61,$72,$96,$82,$82,$B4,$18,$A4,$B1,$C2,$69,$FB,$7E,$91,$30,$F1, $C,$6D,$8E,$D2,$E2,$5B,$62,$BD,$E5,$D5,$7B,$FF,$5A,$4A,$25, $D,$71,$23,$23,$DB,$19,$28,$2C,$64,$79,$1A,$C6,$87,  7, $C,$65,$D9; 576
		dc.b $79,$AB,$F8,$E1,$E0,$2D,$D5,$78,$B4,$B1,$1E,$FF,$9B,$2F,$DD,$CB,$84,$27,$E8,$CB,$82,$E6,$5C,$21,$33,$C4,$FD,$7E,$4B,$21,$FC,$67,$EB,$6A,$99,$70,$90,$D7,$18,  9,$26,$25,$FA,$D7,$17,$50,$F0,$1D,$6C,$D8,$F7,$1C,$57,$F9,$B0,$2F,$DD,$9F,$A9,$C3,$84,$D7,$C0,$B1; 640
		dc.b $39,$C3,$81,$7E,$30,$72,$FC,$97,$A3,$E1,$92,$57,$F7,$B5,$15,$E2,$84,$30,$EA,$4E,$FD,$68,$1F,$9E,$5E,$61,$6E,$AB,$C5,$A5,$88,$FA,  5,$F0, $B,$63,$96,$6B,$C7,$A5,$BA,$86,$5E,$67,$E6,$1E,$67,$E7,$90,$67,$6F,$CD,$9A,$FD,$70,$30,$EF,$90,$4B,$D0,$E3,$26,$C5,$7D; 704
		dc.b $42,$DE,$79,$79,$98,$1D,$EA,$BC,  2,$1A,$7E,$9E,  8,$42,$49,  4,$21,$24,$86,$5C,$32,$FC,$DC,  6,$AC,$10,$FE, $C,$3F,$98, $A,$BC,$EF, $B,$CE,$F5,  0,  0,  0,$62,$1D,$7F,$19,$2E,$4B,$FD,$E0,$4A,$F5,$5E,$60,$77,$AA,$F5,$DD,$86,$D0,$BB, $D,$2E,$58,$CA,$E1,$99; 768
		dc.b $5C,  0,$10,$B8,$66,$57,$58,$57,$76,$1A,$5C,$BB,$B0,$D9,$57,$9D,$E1,$79,$DE,$AD,$B0,$B9,$77,$69,$85,$CB,$1B,$5C,$53,$1B,$80,  2,$17,$14,$C6,$E9, $A,$EE,$D3, $B,$A1,$B6,$17,$2E,$F5,$5E,$60,$77,$AB,$9E,$2E,$5C,$D7,$81,$5C,$58,$43, $D,$8B,$6C, $B, $D,$8E,$E2; 832
		dc.b $B8,$CB, $D,$8E,$E2,$B8,$E1,$86,$C5,$B6,$10,$C0,$AE,$2C,$17,$32,$DE,$BC, $B,$78,  2,$AF,$3B,$C2,$F3,$ED,$97,$65,$43,  5,$EF,$32,$3D,$F0,$DE,$64,$7B,$EB,$B6,  5,$84,$B6,$C0,$B7,$AF,$7F,$7C,$2C,$64,$7B,$E4,$64,$7B,$D7,$87,$7D,$F6,$BD,$57,$98,$78,$AF,$F6,$8B; 896
		dc.b $20,$87,$EA,$80,$BF,$74,$15,$CA,$D9,  0,$77,$E9,$6E,$81,$6E,$9E,  3,$C7,$F6,$83,$22,$FD,$50,$5B,$A2,$F2,$5E,$52,$FD,$54,$B2,  5,$F4,$B7,$40,$B7,$4B,$78,  3,$BD,$57,$85,$7D,$7E,$B6,$32,$62,$BA,$CD,$5F,$DE,$7E,$51,$73,$88,$AE,$71,$15,$CE,$22,$B9,$C4,$57,$38; 960
		dc.b $8A,$F4,$A2,$AF,$3B,$C2,$F3,$BD,$40,$86,$91,$C7,$F1,$95,$15, $D,$C3, $C,$2E,$C0,$65,$BF,$86,$FF,$D6,$54,$52,$8B,$14,$A2,$C5,$28,$B1,$4A,$2C,$52,$8B,$E3,$6B,$D5,$79,$80; 1024
Nem_VSpikes:	dc.b $80,  8,$80,  4, $B,$24, $C,$35,$1C,$57,$7D,$71,  0,$81,  5,$1D,$82,  4, $A,$87,  5,$1E,$88,  7,$7C,$8A,  3,  4,$8F,  4, $D,$FF,$E7,$BF,$C1,$D3,$EC,$B8,$7F,  2,$AE,$8E,$4C,$8E,$6D,$E8,$C9,$59,$53,$3B,$7D,$73,$73,$45,$C1,$5F,$C0,$A0,$4F,$9E,$FD,$37,$BE,$33; 0
					; DATA XREF: ROM:0001C0EEo
					; ROM:0001C136o ...
		dc.b $E3,$FC,$1A,$FB,$2E,  1,$C9,$57,$50,$FB,$A3,$27,$2A,  1,  0,  0; 64
Nem_Points:	dc.b $80,$12,$80,  3,  3,$14, $C,$25,$1A,$36,$3D,$47,$7C,$56,$3C,$67,$7D,$72,  0,$81,  3,  2,$15,$1C,$26,$3B,$35,$1B,$86,  3,  4,$87,  4, $A,$14, $B,$26,$3A,$FF,  0, $E,$3D,$BF,$C4,$D2,$97,$17,$E3,$B1,$62,$75,$AB,  3,$CB,$F8,$B1,$65,$29,$73,$B7,$B0,  3,$DE,$3E; 0
					; DATA XREF: ROM:0001C0B6o
					; ROM:0001C18Eo
		dc.b $62,$B5,$2B,$C5,$ED,$6A,$B1,  1,$ED,$78,$BE,$52,$95,$AE,$3E,  0,$1C,$7B,$75,$14,$B8,$9A,$6B,$13,$AD,$58,$19,$5A,$BD,$26,$B1,$3A,$8A,$5C,$ED,$EC,  0,$CD,$BE,$FA,$8A,$57,$A9,$A6,$BA,$D5,$29,$7F,$11,$D7,$CE,$B2,$BC,$4D,$7E,$DD,$4A,$7B,$7C,  0,$38,$F6,$EA,$29; 64
		dc.b $71,$34,$D6,$27,$5A,$B0,$32,$B5,$7A,$4D,$62,$75,$14,$B9,$DB,$D8,  0,$FF,$E2,$FF,$6E,$E5,$78,$B5,$D6,$56,$5C,$FA,$B4,$BA,$F5,$75,$AA,$F5,$35,$9D,$47,$2B,$FE,$20,  7,$1E,$DD,$45,$2E,$26,$9A,$C4,$EB,$56,  6,$56,$AF,$49,$AC,$4E,$A2,$97,$3B,$7B,  0,$1E,$DF,$72; 128
		dc.b $E2,$96,$B1,$35,$AB,$D5,$80,$EF,$56,$B1,$35,$92,$E2,$97,$B7,$D8,  0,$BE,$C5,$E2,  0,$3E,$AF,$B1,$78,  0; 192
Nem_Lamppost:	dc.b $80, $A,$80,  3,  2,$14,  9,$24, $A,$72,  0,$81,  3,  3,$15,$1D,$83,  6,$3D,$85,  5,$1B,$87,  7,$7C,$89,  4,  8,$8A,  4, $B,$8B,  5,$1C,$8C,  5,$18,$8D,  6,$3C,$8E,  7,$7D,$8F,  5,$19,$15,$1A,$FF,$FE,  4,$7E,$6A,$A3,$78,$FC,$BC,$EF, $B,$F1,  9,$A8,$9C,$A7; 0
					; DATA XREF: ROM:0001C09Eo
		dc.b $6B,$1F,$D0,$8A,$F9,$58,  0,  0,$3F,$C1,$FB,$5F,$13,$E5,$7E,$77,$F8,$1E,$57,$57,$85,$39,$F0,  0,  0,$3F,$C1,$FC,$DD,$FE,$5A,$BF,$32,$BF,$25,$31,$2D,$65,$44,$FA,$B2,$C8,$AF,$C1,  0,  0,  5,$3F,$CF,$67,$F3,$CD,$3D,$75,$30,$51,$F9,$8F,$9F,$75,$F6,$A3,$BA,$98; 64
		dc.b $6B,$29,$A8,$7A,$61,$FB, $D,$DF,$2F,$96,  4,$EE,$F9,$7C,$B0,$27,$DF,$D4,$46,  9,$F7,$F5,$11,$80,  0,$50,$F4,$F2,$FF,$11,$F3,$F5,$CF,$EF,$75,$D4,$C1,  0; 128
Nem_Signpost:	dc.b $80,$3A,$80,  3,  0,$15,$13,$25,$14,$36,$33,$46,$36,$56,$34,$66,$35,$74,  2,$81,  4,  4,$16,$38,$58,$F2,$77,$75,$82,  6,$37,$83,  6,$2F,$84,  5, $F,$17,$76,$85,  5,$16,$86,  6,$2E,$17,$78,$48,$F6,$78,$EF,$87,  4,  8,$17,$73,$88,  4,  6,$18,$F5,$89,  6,$32; 0
					; DATA XREF: ROM:0001C2B0o
		dc.b $78,$F4,$8A,  5,$15,$8B,  5,$12,$8C,  5, $E,$17,$72,$8D,  5,$18,$18,$F3,$8E,  4,  5,$18,$EE,$78,$F7,$8F,  4,  3,$17,$74,$FF,$22,$9F,$F5,$85,$DE,$59,$27,$4F,$DB,$53,$2F,$DF,$CC,$CB,$43,$22,$22,$22,$22,$22,$22,$22,$22,$22,$22,$11,$A1,$A7,$EE,$3F,$32, $F,$F7; 64
		dc.b $C1,$3F,$B3,$3F,$22,$EF,$EB,$DF,$FA,$FF,$E1,$E7,$C7,$8C,$DB,$25,$3A,$3B,$29,$A1,$6C,$9A,$3B,$22,$19,$68,$DB,$62,$FD,$B0,$93,$4C,$D3,$6C,$25,$DA,$24,$EF,$CA,$97,$3F,$3C,$23,$F6,$4B,$C7,$41,$51,$7F,$40,$74,$32,$CE,$FD,$9D,$7A,$68,$9B,$E6,$E0,$9A,$DE, $F,$F5; 128
		dc.b $1D,$B9,$B7,$BF,$A7,$F0,$72,$E7,$B2,$28,$F6,$3A,$BF,$F6,$3D,$82,$78,$FC,$A8,$E0,$7E,$4C,$71,$48,$7A,$67, $B,$84,$A4, $E,$29,$14,$6D,$90,$78,$A2,  5,$E2,$29,$7A,$7E,$49,$23,$64,$DD,  2,$5F,$BA,$4D,$C8,$12,$88,$CE,$40,$99,$B1,$3D,$35,$DD,$28,$C1,$93,$14,$46; 192
		dc.b $40,$9C,$82,$9E,$F8,$A7,$EB,$13,$7B,$93,$34,$67,$5C,$99,$C8,$3A,$E8,$E3,$3E,$5E,$38,$1D,$2F,$E5,$E0,$C3,$86,$F5,$F1,$EB,$DA,$DF,$AD,$F7,$F4,$EA,$53,$FE,$B0,$BB,$CB,$24,$E9,$FB,$6A,$65,$FB,$59,$99,$68,$64,$44,$44,$44,$44,$44,$44,$44,$44,$44,$42,$34,$34,$FD; 256
		dc.b $97,$E6,$41,$FE,$F8,$27,$F6,$67,$E4,$5D,$FD,$7F,$6C,$EF,$D3,$7E,$95,$6C,$75,$B6,$7C,$ED,$5C,$FB,$B9,$D2,$4C,$15,$33,$7F,  7,$99,$E5,$AB,$F2,$4D,$8D,$F8,$D5,$E4,$5A,$1B,$C8,$B6,$75,$F8,$CF,$95,$E7,$9B,$83,$97,$67,$1E,$DC,$BF,$27,$9B,$A6,$ED,$39,$68,$EC,$69; 320
		dc.b $85,$D1,$47,$EC,$BC,$C7,$F3,$92,$9F,$C9,$6B,$9B,$F8,$39,$73,$D9,$14,$7B,$1A,$8E,$BD,$FF,$F5,$3D,$6D,$5E,$9F,$BB,$E6,$1E,$3F,$63,$73,$F8,$9B,$40,$41,$C6,$7C,$4D,$1A,$9F,$A9,  9,$36,$A6,$54,$49,$9A,$E8,$CB,$AC,$68,$D9,$B5,$18,$64,$D4,$E9,$34,$6C,$D7,$58,$34; 384
		dc.b $DB,$B8,$2F,$13,$5B,$EA,$8A,$69,$3C,$AE,$DD,$E9,$FA,$E7,$F2,$7C,$F8,$50,$9D,  7,$EC,$66,$86,$81, $C,$1A,$29,$AE,$9D,$D7,$34,$34,$7E,$A7,$A9,$4F,$FA,$C2,$EF,$2C,$93,$A7,$ED,$A9,$96,$86,$5A,$19,$11,$6B,$95,$7F,$98,$32,$76,$B7,$72,$2E,$44,$EC,$FF,$79,$3B,$9D; 448
		dc.b $A5,$DF,$AC,$D7,$F5,$99,$B8,$72,$2D,$50,$B6,$76,$9C,$82,$15,$21,$DB,$1A,$7E,$EF,$F3,$20,$FF,$7C,$13,$FB,$33,$F2,$2E,$FE,$BD,$E4,$44,$44,$44,$5F,$DC,$2E,$44,$44,$44,$ED,$3F,$F8,$A9,$E6,$3F,$5D,$B7,  5,$C4,$F0,$79,$A1,$21, $F,$D8,$8F,$CD,$C7,$EE,$5B,$DF,$D3; 512
		dc.b $F8,$39,$73,$D9,$14,$7B,$1A,$8E,$BD,$E5,$B7,$EA,$A9,$F9,$AF,$D0,$CE,$BC,$67,$54,$CD,$C5,$54,$1F,$9B,$BC,$3A,$72,$F5,$17,$E8,$93,$BB,$34,$69,$C3,$BF,$51,$2B,$A9,$C9,$AE,$AE,$CF,$C5,$74,$76,$33,$FD,$60,$FD,$E3,$5D,$CC,$7E,$A9,$95,  2,$D6,$75,$DD,$D8, $B,$FA; 576
		dc.b $A1,$C4,$FF,$5D,$5F,$CD,$A6,$7D,$D3,$4C,$D5,$D3,$E0,$2B,$B6,$5C,$71,$FB,$88,$FD,$57,$BF,$A7,$52,$9B,$5D,$1F,$A6, $C,$BF,$C1,$C8,$C2,$A7,$4B,$B4,$C9,$B6,$31,$2D,$65,$99,$91,$11,$14,$DF,$AA,$EB,$5D,$65,$A9,$EA,$7A,$DF,$AB,$6B,$6D,$6D,$AD,$B5,$B6,$AD,$AD,$FA; 640
		dc.b $9E,$90,$6C,$12,$66,$8F,$4B,$95,$32,  6,$A1,$19,$1B,$F5,$33,$4F,$CC,$F8,$8D,$94,$D3,$D8,$D7,$AA,$77,$FF,$62,$F6,$12,$12,$9C,$9C,$24,$25,$3A,$B8,$48,$48,$5F,$5C,  9,  9, $B,$FC,$E9,$51,$E6,$EA,$54,$63,$90,$90,$A8,$C3,$8C,$18,$53,$C7,$47,$9C,$2C,$AB,$26,$79; 704
		dc.b $C6,$1F,$89,$18,$37,$B9,$F8,$63, $E,$91,$BD,$58,$E1,$D2,$38,$56,$3C,$9C,$F3,$8C,$31,$DC,$E8,$38,$C4,$34,$1B,$5F,$1B,$89,$54,$EB,$7B,$D9,$D1,$63,$7A,$BE,$DC,$D8,$DE,$BF,$95,$BA,$FB,$8E,$4B,$FA,$5D,$EA,$72,$5B,$62,$D7,$3C,$DE,$B6,$C5,$AE,$ED,$65,$79,$D9,$64; 768
		dc.b $72,$7C,$AD,$57,$FB,$FA,$47,$8F,$23,$5D,$91,$4F,$DB,$AF,$7E,$ED,$66,$B3,$59,$AB,$FB,$D9,$60,$79,$B9,$71,$2B,$C6,$1C,$7D,$D8,$BC,$63,$A6,$E6,$B7,$8E,$E3,$DC,$D6,$6B,$71,$AB,$AE,$51,$73,$D0,$F7,$7C,$1C,$5B,$73,$C5,$81,$C5,$9E,$B2,$B0,$51,$D9,$AF,$78,$C8,$DF; 832
		dc.b $5F,$37,$AC,$39,$AB,$E6,$CB,  7,$EB,$63,$6C,$45,$D1,$EB,$CF,$11,$94,  6,$36,$DE,  4,  3, $D,$7B,$DA,$47,$23,$74,$9F,$7C, $E,$73,$7C,$24,$4E,$3B,$42,$6F,$DA, $E,$D1,$7A,$73,  7,$61,$7F,$E9,  1,$D9,  5,$9F,$67,$AD,$AB,$2A,$9D,$4E,$A7,$EF,$E9,$D4,$BF,$AD,$3F; 896
		dc.b $2B,$87,$B1,$A6,$5B,$B5,$ED,$BE,$53,$A8,$90,$AD,$24,$24,$25,$49,  9,  9,  3,$12,$D6,$5A,$D4,$57,$6A,$8A,$87,$D2,$AF,$97,$6A,$2B,$DC,$F6,$A2,$C3,$A2,$FA,$62, $E,$25,$47,$3C,$E2,$54,$75,$4D,$9D,$47,$64,$6D,$14,$73,$39,$AD,$47,$43,$A5,$6A,$1B,$2B,$ED,$43,$B2; 960
		dc.b $BE,$D4,$59,$2D,$9F,$45,$92,$D9,$F4,$5B,$2F,$6A,$2D,$95,$E7,$45,$B1,$BC,$E2,$75,$39,$1C,$96,$7F,$CE,$1E,$88,$13,$C7,$E9,$DA,$6A,$68,$15,$27,$DC,$83,$B8,$36,$8C, $F,$F6,$26,$13,$44,$22,$22,$22,$22,$22,$22,$22,$22,$22,$22,$22,$22,$6D,$19,$32,$FD,$B6,$48,$3D; 1024
		dc.b $6E,$CB,$D4,$A9,$C1,$A1,$11,$11,$11,$11,$11,$11,$4C,  0; 1088
Nem_Crocobot:	dc.b   0,$2C,$80,  5,$11,$16,$2A,$26,$30,$36,$33,$47,$76,$58,$EF,$67,$70,$74,  4,$81,  3,  0,$14,  6,$26,$2E,$36,$35,$48,$F2,$57,$6C,$77,$78,$82,  4,  2,$15,$13,$27,$74,$38,$F7,$83,  4,  3,$15, $B,$26,$2B,$47,$6F,$58,$F6,$84,  5,$14,$17,$6E,$85,  6,$31,$17,$6D; 0
					; DATA XREF: ROM:0001C1E6o
		dc.b $86,  5,$16,$17,$71,$87,  5, $F,$16,$34,$88,  5, $A,$17,$72,$89,  5,$12,$17,$7A,$8A,  5, $E,$17,$73,$8C,  6,$32,$18,$F3,$8D,  5,$10,$16,$2F,$27,$75,$38,$EE,$FF,$44,$44,$44,$44,$44,$38,$AF,$30,$63,$78,$30,$7F,$B4,$9E,$FB,$47,$F8,$56,$7C,$7F,$C3,$56,$3F,$CD; 64
		dc.b $C3,$F8,$A8,$88,$88,$88,$89,$DF,$3E,$C4,$BC,$C9,$74,$CD,$F3,$3C,$F4,$DB,$98,$B6,$30,$CC,$5B,$6E,$7F,$F3,$5D, $F,$FE,$9B,$EC,$BF,$7B,$3E,$7E,$3F,$FB,$8F,$F7,$72,$8F,$F1,$6F,$EF,$DA,$88,$88,$99,$F4,$CC,$AB,$23,$89,$7F,$50,$A9,$FF,$3D,$B3,$AF,$17,$F1,$79,$6D; 128
		dc.b $FD,$B6,$97,$B7,$1D,$2F,$6B,$7E,$9F,$6F,$1F,$D3,$A9,$78,$AB,$45,$17,$EC,$FD,$D7,$62,$5C,$CE,$CF,$FE,$17,$8F,$FE,$FF,$F3,$FF,$BF,$F5,$C3,$CB, $F,$2C,  7,$EA,$46,$7A,$A2,$24,$FB,$65,$43,$2C,$32,$81,$D0,$CA,$AB,$D7,$43,$28,$F4,$5D, $C,$2E,$6B,$A1,$83,$E8,$74; 192
		dc.b $32,$1D,$17,$31,$35,$93,$C8,$7F, $A,$E2,$17,$96,$D6,$86,$5D,$C2,$19,$5B,$2B,$F1,$19,$5B,$CE,$18,$D9,$FF,$AC,$86,$8A,$97,$55,$39,$4E,$7F,$E9,$5D,$25,$49,$5E,$36,$73,$FF, $C,$BC,$22,$E2,$BC, $C,$18,$5D,$46, $C,$2E,$AE,$8B,$A1,$D4,$40,$97,$43,$89,$31,$2E,$95; 256
		dc.b $13,$12,$F0,$B9,$78,$29,$9E,$75,$68,$38,$97,$6B,$BB,$29,$B3,$D1,$B8, $E, $A,$EF,$D1,$11,$11,$11,$13,$BD,$FC,$1E,$AA,$9F,$55,$D5,$3D,$42,$CD,$1B,$AC,$FB,$F2,$BB,$F9,$B9,$77,$6D,$44,$44,$44,$3E,$14,$3E,$F3,$A1,$F6,$5D, $E,$1E,$70,$AE,$87,$94,$2C,$4B,$DC,$70; 320
		dc.b $67,$AF,$71,$97,$12,$5E,$E3,$B8,$97,$BB,$57,$AE,$97,$71,$25,$C7,$C8,$8E,$2A,$F2,$FD,$3E,$BC,$6A,$D9,$87,$96,$7A,$D4,$F8,$EB,$53,$D4,$2C,$D1,$BA,$CF,$86,$42,$CD,$7F,$9D,$9E,$21,$E7,$FF,$DD,$BD,$76,$DD,$FA,$51,$FA,$91,$9E,$A8,$88,$88,$88,$91,$AF,$3B,$D6,$58; 384
		dc.b $7E,$99,$65,$50,$B6,$8B,$2C,$86,$9C,$8C,$A0,$4F,$E4,$E3,$28,$1F,$B9,$CE,$87,$33,$21,$ED,$31,$EC,$43,$A2,$E6,$3F,$84,$F2,$6F,$70,$57,$75,$28,$5D, $F,$3B,$DA,$19,$5B,$28,$62,$21,$95,$B2,$86,$36,$7F,$EB,$21,$A2,$A5,$D5,$4E,$53,$9F, $D,$AE,$92,$A4,$AF,$1B,$39; 448
		dc.b $FF,$86,$5E,$12,$39,$67,$FA,$C8,$61,$97,$75,$59,$7F,$37,$F8,$50,$9E,$F2,$3D,$D6,$FE,$A7,$E9,$BF,$48,$74,$FF,$9F,$F8,$DB,$78,$A1,$8A,$DE,$BA,$10,$58,$23,$1A,$5C,$41,$F6,$7A,$84,$1B,$4B,$38,$41,$21,$C2,$1C,$21,$C2,$15,$79,$E1,$3C,$AF,$C1,$65,$7E,$1B,$8C,$A1; 512
		dc.b $81,$EE,$32,$BE,$35,$D0,$CA,$11,$F6,$28,$D6,$F5,$94,$6B, $B,$9E,$C2,$3E,$EC,$6B,$EB,$8A,$E6,$74,$FF,$9F,$F8,$DB,$78,$A1,$8A,$DE,$BA,$10,$58,$23,$1A,$5C,$41,$F6,$7A,$84,$1B,$4B,$38,$41,$4D,$CC,$5F,$C5,$43,$F6,$6A,$96,$C7,$6C,$55,$DC,$D4,$CE,$6E,$4F, $A,$F4; 576
		dc.b $CF,$12,$F0, $E,$9F,$F3,$FF,$1B,$6F,$14,$31,$5B,$D7,$42, $B,  4,$63,$4B,$88,$3E,$CF,$50,$83,$69,$67,  8,$29,$B9,$8B,$F8,$A8,$7E,$CD,$52,$D8,$ED,$8A,$BB,$9B,$D9,$CC,$E5,$3C,$2B,$D3,$28,$4B,$C0,$3D,$C6,$57,$C6,$BA,$19,$42,$3E,$C5,$1A,$DE,$B2,$8D,$61,$73,$D8; 640
		dc.b $47,$DD,$8D,$7D,$71,$5C,$EF,$C4,$E6,$D5,$93,$7A,$D7,$F5,$2E,$D7,$90,$53,$28,$72, $A,$67, $F,$DD,$2A,$42,$43,$F5,$5B,$24,$E4,$44,$4D,$F8,$19,$5C,$55,$16,$A5,$53,$17,$66,$91,$66,$D2,$9E, $E,$65,$90,$8A,$98,$8E,$4F, $A, $E,$98,$54,$9C,$1D,$D0,$45,$A7,$98,$E0; 704
		dc.b $7B,$8C,$AF,$8D,$74,$32,$84,$7D,$8A,$35,$BD,$65,$1A,$C2,$E7,$B0,$8F,$BB,$1A,$FA,$E2,$B9,$DF,$89,$CD,$AB,$26,$92,$B5,$F5,$CB,$5F,$41,$CC,$A1,$27,  7,$33,$83,$B9,$39,$52,$12, $A,$E7,$E5,$26,$44,$44,$DF,$81,$95,$C5,$51,$6A,$55,$31,$76,$69,$16,$77,$19,$60,$E1; 768
		dc.b $25,$90,$8B,$83,$88,$C3,$E4,$E6,$9C,$94,$1C,$DD,  4,$43,$BB,$DD,$C0,$F7,$19,$5F,$1A,$E8,$65,  8,$FB,$14,$6B,$7A,$CA,$35,$85,$CF,$61,$1F,$76,$35,$F5,$C5,$73,$BF,$13,$9B,$56,$4C,$A9,$6B,$2E,$4E,$D7,$D0,$73,$28,$49,$C1,$CC,$E1,$CF,$F5,$12,$12, $E,$E5,$E5,$E8; 832
		dc.b $22,$22,$6F,$C0,$CA,$E2,$A8,$B5,$2A,$98,$BB,$5C,$59,$B4,$8B,$37,  9,$19,$60,$E6,$59,$4A,$2E,$62,$30,$F0,$E0,$E9,$85,$33,$BD,$E5,$11,$C0; 896
Nem_Buzzbomber:	dc.b   0,$1C,$80,  5, $C,$15, $D,$25,$12,$35,$17,$47,$76,$57,$7A,$66,$37,$73,  0,$81,  3,  1,$14,  5,$26,$34,$37,$77,$46,$3A,$86,  5,$11,$16,$39,$28,$FA,$87,  5,$13,$88,  5, $F,$16,$36,$89,  4,  4,$15,$18,$26,$3C,$8B,  5,$16,$16,$35,$8C,  5,$10,$15,$15,$27,$7B; 0
					; DATA XREF: ROM:0001C194o
					; ROM:0001C1ECo ...
		dc.b $8D,  5,$14,$16,$38,$28,$F8,$8E,  5, $E,$16,$33,$8F,  6,$32,$18,$F9,$FF, $D,$D6,$5F,$8A,$66,$A6,$8D,$B3,$2C,$59,$C6,$F4,$DF,$8D,$F8,$BC,$69,$59,$46,$74,$E6,$46,$71,$59,$19,$C5,$65,$4A,$ED,$2A,$57,$89,$53,$F7,$92,$A7,$BA,$5F,$F7,$BF,$8A,$B7,$AB,$1A,$30,$EC; 64
		dc.b $AC,$A6,$88,$5B,$4D,$30,$DA,$33,$BB,$69,$25,$F8,$EA,$BC,$77,$8C,$38,$54,$7C,$DF,$C1,$48,$FE,$5D,$FC,$14,$9E,$DF, $B,$8F,$8E,$BE,$3A,$A3,$7A,  7,$6F,$E3,$AE,$D3,$8C,$E2,$B8,$FD,$C1,$FF,$49,$42,$85, $A,$16,$79,$23,$B2,$5D,$F3,$45,$94,$D3,$BB,$53,$FA,$2C,$FF; 128
		dc.b  $A,$7F,$C7,$FA,$2D,$EA,$5A, $E,$D3,$33,$7D,$F9,$31,$7A,$37,$63,$37,$A3,$70,$5E,$92,$57,$A0,  2,$56,$DC,$FA,$5D,$A7,$19,$BF,$1F,$F1,$DC,$80,  0,  0,$30,$EB,$A3,$3B,$E6,$B6,$3E,$72,$99,$A6,$99,$98,$BB,$4C,$CE,$BA,$6A,$52,$DA,$6B,$8D,$31,$D6,$15,$87,$C5,$40; 192
		dc.b   0,  0,$6B,$E9,$22,$EE,$C5,$1D,$1B,$AE,$65,$8F,$62,$EA,$B1,$7A,$D9,$15,$E8,$70,$AC,$2C,$C1,$EC,$83,$79,$99,$BE,$FC,$98,$BD,$1B,$B1,$9B,$D1,$B8,$2F,$49,$2B,$D0,  0,  0,$BB,$F7,$33,$DC,$C7,$73,$36,$EB,$22,$F5,$70,  0,  0,  0,  0,  0,$9B,$D9,$6D,$E8,$A1,$74; 256
		dc.b $51,$AB,$67,$14,$6A,$6B,$A3,$71,$DD,$BF,$D1,$6F,$56,$97,$9A,$C8,$F8,$6F,$DF,$D2,$80,  0, $B,$6E,$D8,$71,$BA,$45,$CB,$66,$97,$45, $D,$9B,$9F,$96,$2C,$B2,$A6,$65,$3B,$BA,$38,$D3,$3F,$17,$F5,$6B,$FB,$9B,$68,$8C,$EB,$17,$2F,$37,$7C,$66,$97,$3B,$7A,$28,  0,  0; 320
		dc.b   0,$2F,$5E,$D0,$CE,$17,$77,$2E,$AB,$61,$9D,$6F,$EC,  0,  0,  0,  1,$DB,$DD,$E1,$FA,$E8,$49,$DF,$4E,$AB,$21,$FA,$EA,$CB,$D8,  0,  0,  0,$64,$3D,$41,$90,$6F,$F3,$1B,$5F,$D7,$65,$ED,$DC,$BB,$E6,$19,$7D,$3B,$26,$41,$DC,$BA,$19,$57,$2C,$F2,$85,$1B, $F,$98,$52; 384
		dc.b $F5,$A0,  0,  0,$19, $E,$D5,$64,$1B,$5F,$98,$51,$95,$CB,$3C,$99,$57,$7D,$3A,$B9,$7F,$19,$D0,$CB,$F6,$CE,$AE,$5F,$B6,$CA,$8C,$86,$5C,$E5,  9,$57,$80,$D0; 448
Nem_Bat:	dc.b   0,$3A,$80,  5,$14,$14,  8,$25,$15,$35,$16,$45,$12,$56,$35,$67,$77,$73,  1,$81,  3,  0,$14,  7,$26,$33,$37,$7A,$86,  5,$13,$16,$37,$87,  5,$17,$16,$34,$27,$72,$36,$36,$48,$F6,$57,$78,$88,  4,  6,$15,$18,$26,$38,$89,  3,  2,$16,$32,$26,$3A,$38,$F8,$8B,  7; 0
					; DATA XREF: ROM:0001C1E0o
					; ROM:0001C1F2o
		dc.b $76,$18,$F7,$8C,  7,$73,$8E,  7,$79,$FF,$A3,$C8,$7B,$8B,$76,$FC,$F7,$61,$5F,$DF,$76,$CE,$9F,$9E,$7C,$9A,$3D,$62,$1E,$6D,$94,$3C,$DD,$42,$13,$75,$54,$37,$55,$1F,$16,$7C,$AA,$2E,$EA,  3,$5F,$38,  9,$A6,$F0,$13,$5F,$79,$3C,$87,$B8,$A8,$ED,$F9,$EE,$D9,$F6,$FD; 64
		dc.b $F3,$64,$FF,$9E,$A6,$3D,$46,$4D,$37,$84,$F3,$78,$4F,$30,$A1,$6E,$15,$7E,  5,$72,$7B,$27,$B8,$AE,$77,$61, $F,$36,$42,$37,$BB,$21,$60,$9A,$EA,$75,  9,$B4,$A8,$CB,$16,$1D,$59,$F2,$B0,$4F,$20,$9B,$57,$92,$69,$CB,$39,$26,$9C,$B9,$F9,$9C,$B9,$F9,$9E,$BC,$FC,$EB; 128
		dc.b $F9,$CE,$FC,$E6,$AE,$C8,$46,$8C,$85,$71,$90,$AF,$42,$D9,$3D,$9D, $B,$26,$12,$7D,$66,$CA,$59,$CA,$6C,$A5,$3F,$3C,$E5,$3F,$3C,$E5,$E7,$9E,$BF,$9C,$D7,$99,$24,$93,$A8,$D5,$E4,$ED,$67,$C5,$5F,$88,$7C,$5D,$A9,$9B,$72,$A0,$60,$DC,$A8,$2E,$36,$A0,$98,$DA,$82,$E3; 192
		dc.b $6A,  6,$1B,$53,$3D,$A8,$3C,$50,$78,$A0,$F0,$3C,$4C,$6D,$BD,  7,$29,$D4,$5F,$7B,  9,$EA,  9,$24,$9A,$DD,$4A,$EA,$53,$5C,$A1,$5D,$53,$A7,$4F,$50,$C1,$9E,$30,$30,$F4,$C0,$E1,$F8, $C,$98,$32,$61,$A7,$F2,  7,$2F,$E4, $D,$B8,$1B,$32,$61,$ED,$C0,$F6,$C0,$F6,$C0; 256
		dc.b $F6,$58,$1E,$18,$78,$61,$B6,$F7,$61,$FA,$68,$9B, $E,$E0,$92,$49,$24,$92,$49,$24,$8E,$EF,$AB,$3C,$93,$3D,$B8,$7A,$E9,$87,$8E,$49,$9E,$9B,$61,$F6,$DE,$83,$4D,$ED,$79,$EB,$32,$49,$24,$92,$49,$24,$93,$6C,$E9,$EB,$26,$A0,$60,$B8,$A0,$B8,$C6,$94,$13, $D,$CA,$82; 320
		dc.b $E3,$6A,  6,$1B,$53,$3D,$A8,$3C,$50,$78,$A0,$D3,$F6,$C3,$F4,$C4,$9A,$67,$4F,$E0,$E0,$2F,$DC, $F,$E4,$2C, $F,$6E,$3C,$26,$FF,$3B,$7F,$DF,$FE,$FF,$F7,$DB,$FE,$C4,$EB,$C9,$46,$FD,$54,$2E,$4A,$3D,$2A,$FE,$E3,$D6,$8A,$FF,$B8,$1E,$CA,$EC,$3C,$60,$7B,$2C, $D,$37; 384
		dc.b $D3,  2,$71,$FB,$66,  4,$92,$49,$30,$3B,$B7,$AA,$E9,$C6,$7A,$2D,$EB,$FA,$62,$49,$24,$92,$75,$FE,$8C,  6,$1D, $A, $B,$8E,$15,  4,$C3,$68,$D4,$17,$1B,$50,$30,$DA,$99,$ED,$41,$FD,$62,$49,$24,$92,$FA,$E5,$9D,$71,$D6,$7A,$71,$D7,$B7,$1F,$F7,$FF,$BF,$FD,$89,$24; 448
		dc.b $92,$63,$92,$8D,$FA,$AE,$5C,$94,$67,$21,$8C,$E1,$9F,$87,$BE,$1F,$8E,$58,$76,$FF,$30,$24,$92,$49,$24,$91,$DD,$B3,$B7,$ED,$B3,$A0,$24,$92,$49,$B0,$5D,$C3,$48,$21,$DC,$49,$D5,$86,$42,$1F,$20,$A8,$30,$86,$56,$1C,$12,$49,$32,$CE,$BE,$AB,$9A,$8C,$FA,$87,$F8,$8F; 512
		dc.b $EC,$C7,$F6,$45,$3E,$38,$A7,$EE,  9,$24,$93,$6C,$E4,$E9,$EA,$ED,$90,$87,$BE,$17,$AE,$4D,$93,$ED,$87,$F0,$3F,$4D,$B5,$BF,$6C,$49,$24,$93,$4B,$A9,$4D,$6A,$AE,$A4,$3B,$B3,$C8,$60,$59,$86,$1E,$2E,$C1,$B7,$14,$FD,$30,$24,$92,$6C,$3B,$BC,$5E,$A1, $A,$2A,$86,$42; 576
		dc.b $F5,$17,$65,$61,$A3, $A,$8E,$4C,$23,$7D,  3, $A,$EF,$89,$CA,$60,$93,$60,$9A,$EA,$75,  9,$B4,$A8,$CB,$16,$1D,$59,$F2,$B0,$4F,$20,$9B,$57,$92,$69,$CB,$39,$26,$9C,$B9,$F9,$9E,$BC,$FC,$F7,$E7,$DF,$99,$9A,$BB,$21,$1A,$32,$15,$C6,$42,$BD, $B,$64,$F6,$74,$2C,$98; 640
		dc.b $49,$F5,$9B,$29,$67,$29,$B2,$94,$FC,$F3,$97,$9E,$7A,$F3,$EF,$CC,$9C,$E5,$EE,$25,$EE,$F6,$F7,$FE, $C,$76,$18,$CA,  7,$EE,$14,$37,$4D,$38,$C2,$6D,$E1,$82,$76,$84,$13,$A8,$1F,$C9,$81,$F0,$2A,$32,$7A,$FF,  6,  6,$3F,$4D,  1,$B9,$4E,$1D,$B4,$50,$13,$68,$D0,$32; 704
		dc.b $E2,$A3,$E2,$A3,$E2,$DE,$A4,$19,$6A,$F2,$4D,$39,$67,$24,$D3,$24,$93,$5C,$EC,$3F,$56,$20,$7B,$FE,$7B,$B5,  7,$BF,$EF,$A8,$3B,$7E,$FB,$B5,$10,$ED,$F9,$EE,$D1,$97,$A8,$E9,$EB,$96,$75,$C9,$EC,$9E,$4F,$71,$61,$36,$42,$B3,$BE,$10,$8D,$1B,$21,$17,$C6,$42,$2E,$DD; 768
		dc.b   8,$6E,$85,$7A,$16,$E8,$5B,$21,$2C,$E4,$C8,$49,$F5,$9B,$29,$67,$29,$B2,$24,$93,$20,  0; 832
Nem_Octopus:	dc.b   0,$3A,$80,  6,$31,$16,$2B,$26,$32,$36,$33,$48,$F3,$56,$37,$66,$30,$73,  0,$81,  3,  1,$14,  6,$26,$36,$37,$74,$58,$F6,$68,$F2,$82,  4,  4,$14,  7,$25,$11,$37,$75,$58,$F7,$83,  4,  5,$15,$16,$26,$35,$37,$72,$47,$76,$57,$77,$84,  5,$12,$16,$34,$85,  7,$73; 0
		dc.b $86,  5,$10,$16,$38,$87,  5,$13,$88,  6,$2F,$89,  6,$2E,$8C,  5,$14,$8D,  6,$2A,$8E,  7,$7A,$17,$78,$FF,  0,  0,$30,$4C,$13,  9,$EE,$87,$14,$CD, $A,$49,$32,$42,$86,$11,$B2,$19,$6B,$A2,$95,$F7,$2A,$9D,  0,$F3,$8D,$71,$D7,$14,$EE,$9F,$F3,$FF,$1C,$ED,  9,$F6; 64
		dc.b $FD,$34,$F9,$37,$1C,$9B,$8E,$4D,  9,$EA,$9F,$A6,$9D,$A0,$57,$F2,$FA,$A1,$EE,$87,$B8,$11,$F3,$D6,$35,$F2,$8E,$3D,$DD,$7F,$49,$AA,$69, $D,$2C,$92,$FD,$34,$AC,$9A,$43,$48,$2A,$2F,$E9,$14,$AA,$7F,$8D,$3F,$C6,$9D,$A0,$A9,$D8,$BF,$77,  0,  0,$13,  4,$C1,$30,$7D; 128
		dc.b $DF,$77,$DD,$F7,$7D,$DF,$74,$C2,$27,$23,$8B,  0,  0,  3,$24,$97,$9D,$93,$2E,$A6,$B8,$B5,$6E,$D5,$C4,$E4,$8A,$D9,$BC, $E,$70,$64,$EE,$63,$CB,$13,$EF,$5B,$75,$CD,$9E,$BF,$6A,$A9,$C5,$2A,$A5,$5F,$95,$A7,$E9,$69,$54,$90,$CA, $A,$92,$42,$92,$54,$28,$56,$4A,$8C; 192
		dc.b $F2,$7D,$91,$5C,$E2,$D1,$39,$B9,$1B,$F6,$8D,$BF,$E5,$7C,$EF,$BA,$37,$F0,$67,$73,$DF,  3,$3B,$EE,$6B,$8C,$EF,$B9,$BF,$5B,$4A,$9A,$AF,$D2,$D2,$AF,$D2,$F1,$69,$41,$4E,$88,$51,$64,$92,$54,$64,$5D,$15,$36,$4D,$51,$B1,$28,$AF,$99,$7D,$E0,$77,$4C,  8,  3, $E,$77; 256
		dc.b $6F,$4E,$7B,$D0,$EF,$A1,$F3,$28,$A7,$34,$2E,$72,$92,$17,$35,$D9, $B,$9C,$51,$53,$12,$EC,$F5,$94,$38,$C0,$E5,  2,  0,  0,  1,$9F,$2C,$97,$AE,$50,$E8,  0,  2,$27,$23,$8B,  0,  0,$C2,$C8,$CB,$16,$B4,$93,$65,$D1,$7A,$43,$60,  0,  5,$3B,$98,$F2,$C4,$FB,$D6,$DD; 320
		dc.b $73,$67,$AF,$DA,$AA,$71,$4A,$A9,$52,$F1,$25,$4A,$55,$2D,$5C,$C9,$7A,$B2,$FF,$C4,  0,  7,$68,$DB,$FE,$57,$CE,$FB,$A3,$7F,  6,$77,$3D,$F0,$33,$BE,$E6,$B8,$CE,$FB,$9B,$F5,$B4,$A9,$AA,$E3,$9D,$2A,$84,$B9,$C9,$59,$3F,$68,$AD,$19,$43,$C8,  0,  2,$60,$40,$18,$73; 384
		dc.b $C2,$9C,$F7,$A7,$F0,$6B,$92,$A7,$F0,$79,$27,$94,$F6,  0,  0,  0,  0,  1,$D7,$33,$D7,$2E,$93,  0,  0,  0,  0,  0,$36,$CF,$69,$67,$79,$81,  0,  1,$13,$91,$C5,$80,  0,$61,$B2,$E8,$DA,$6A,$65,$AC,$7F,$E2,$40,  0,$14,$EE,$63,$CB,$13,$EF,$5B,$75,$CD,$9E,$BF,$6A; 448
		dc.b $A9,$C5,$2A,$A5,$4C,$B2,$82,$A3,$2C,$96,$25,$24,$BD,$4C,$3C,$80,  0,$76,$8D,$BF,$E5,$3B,$A7,$74,$67,  3,$3B,$EE,$7B,$E6,$7F,$31,$73,$5D,$79,$BE,$E6,$FD,$6D,$2A,$6A,$97,$48,$39,$D7,$48,$2A,$1E,$5A,$2A,$79,$40,  0,  2,$60,$40,$18,$73,$C2,$9C,$F7,$7E,$95,$97; 512
		dc.b $5F,$64,$D7,$FE,$26,$F0,  0,  0,  0,  0,$1B,$79,$F4,$CF,$6F,$C5,  0,  0,  0,  0,  0,$1A,$A6,$56,$8E,$53,$E8,  0,  2,$27,$23,$8B,  0,  0,$C1,$F6,$54,$DB,$4B,$1F,$D2,$6A,$90,$F2,  0,  0,$53,$B9,$8F,$2C,$4F,$BD,$6D,$D7,$36,$7A,$FD,$AA,$A7,$14,$AA,$95,$6A,$57; 576
		dc.b $45,$72,$B2,$B3,$94,$59,$2B,$F4,$86,$C0,  0,$3B,$46,$DF,$F2,$9C,$27,$74,$66,$61,$F9,$7B,$9E,$F8,$19,$DF,$73,$5D,$7C,$CD,$CD,$FA,$DA,$54,$D5,$32,$2E,$88,$51,$92,$D2,$8B,$3D,$BF,$E2,  0,  1,$30,$20, $C,$39,$E1,$4E,$7B,$C7,$6A,$D9,$EC,$C9,$B4,$56,$1E,$40,  0; 640
		dc.b   0,  0,  0,$3A,$66,$BD,$32,$9E,$D3,  0,  0,  0,$C5,$F2,$8D,$AB,$4E,$D8,$A7,$74,$FF,$1A,$6A,$F6,$4B,$46, $A,$96,$7E,$14,$D9,$B8,$53,$66,$84,$F5,$4F,$D3,$4D,$65,  2,$BF,$97,$B3,$9E,$C5, $F,$60,  0,  0,  1,$5F,$EF,$32,$FE,$E5,$7F,$DC,$AF,$FB,$95,$FF,$73,$2F; 704
		dc.b $DE,  0,  0,  0, $F,$3F,$19,$F8,$E3,$C5,$7E,$BF,$6D,$EB,$1F,$5F,$D6,$F1,$FD,$6F,$58,$FA,$FD,$B7,$AA,$FC,$71,$E3,$3F,$19,  0,  0; 768
Nem_Triceratops:dc.b   0,$32,$80,  5,$15,$16,$30,$26,$2E,$36,$33,$47,$71,$57,$75,$67,$76,$74,  6,$81,  3,  1,$15,$13,$27,$74,$36,$36,$46,$2D,$78,$F3,$82,  6,$2F,$17,$6E,$83,  4,  8,$17,$6B,$26,$34,$84,  5,$12,$16,$2C,$27,$70,$38,$F5,$48,$F6,$85,  7,$77,$86,  5,$14,$17,$72,$87; 0
					; DATA XREF: ROM:0001C1F8o
		dc.b   4,  7,$17,$73,$88,  4,  4,$17,$6F,$48,$F7,$89,  3,  0,$16,$31,$27,$6A,$38,$F2,$8A,  4,  5,$16,$32,$27,$78,$8C,$18,$F4,$FF,$AB,$E6,$A9,$57,$B9,$51,$51,$F0,$54,$5D,$F4,$4F,$E5,$25,$10,$7E,$E9,$39,$A0,$51,$97,$F5,  7,$F5,$23,$82,$72,$49,$44,$9F,$F4,$CE,$B2; 64
		dc.b $89,$FE,$99,$25,$13,$E4,$E9,$2B,$D3,$F4,$E8,$B2,$BE,$17,$7A,$CA,$37,$47,$A9,$FE,$1C,$A6,$A8,$A3,$34,$F0,$2E,$F0,$14,$E1,$FB,$A0,$A5,$14,$28,$50,$8E,$14,$28,$4A,$3A,$85,  9,$47,$D4,$A9,$47,$53,$25,$4E,$6A, $C,$2F,$35,$C4,$C4,$B2,$D4,$75,$D8,$14,$18,$E0,$B8; 128
		dc.b $ED,$20,$A0,$EF,$21,$71,$A2,$15,$21,$41,$C1,$3A,$A2,$F1,$47,$1C,$5D,$70,$A5,$C8,$32,$22,$CC,$55,$39, $F,$55,$A3,$A0,$B3,$5B,$A5,$16,$51,$BB,$22,$B1,$FB,$27,$51,$1F,$B2,$7C,$7F,$86,$A1,$E5,$FB,$35,  7,$D9,$71,$A7,$FB,$3F,$8D,$E9,$46,$66,$69,$76,$E1,$C7,$5D; 192
		dc.b $99,$EE,$89,$66,$37,$44,$AE,$1B,$A2,$57, $F,$D1,$44,$B0,$12,$D2,$58, $B,$34,$95,$47,$AC,$4A,$BF,$AC,$FD,$6F,$79,$7F,$33,$F3,$BD,$FA,$D0,$60,$B8,$53,$9D,$55,$30,$2F,$2A,$BD,$1E,$A5,$E2,$A9,$47,$B2,$2F,$AE,$5A,$6E,$AC,$B4,$FD,$15,$46,$52,$D0,$26,$5E,$AB,$CF; 256
		dc.b $2B, $A,$51,$D0,$4F,$7D,$11,$48,$C9,$28,$8A, $E,$2A,$EA,$30,$38,$B8,$EB,$8F,$1F,$69,$A5,$A8, $F,$B8,$3E,$39,$3A,$6E, $E,$81,$E9,$B8,$82,$F4,$4D,$75,$28,$E8,$BA,$E7,$FD,$46,$66,$66,$66,$62,$EA,$45,$F0,$72,$22,$F3,$12,$2A,$12,$24,$65,$B9,$28,$F6,$17,$4B,$DD; 320
		dc.b $3A,$20,$84,$DB,$4B,$65,$85,$B7,$5B,$75,$B7,$5B,$9E,$D9,$ED,$C7,$A7,$62,$DE,$D3,$4B,$50,$1F,$7D,$5F,$DA,$FF,$C8,$BC,$82,  8,$BD,$F0,$E1,$B9,$2B,$C3,$76,$BC,$4A,$A6,$80,$A7,$3A,$6B,$C5,$C5,$10,$5C,$2B,$45,$EA,$8C,$CD,$71,$75,$22,$F8,$39,$11,$79,$89,$6A,$48; 384
		dc.b $91,$96,$28,$E9,$61,$BD,$28,$9B,$24,$25,$A3,$5D,$BA,$EB,$6C,$61,$6D,$D6,$DD,$6E,$7B,$67,$B7,$1E,$9D,$8B,$7B,$4D,$2D,$40,$7D,$F5,$7F,$68,$2F,$FE,$48,$20,$82,$19,$99,$99,$99,$99,$8B,$A9,$17,$C1,$C8,$8B,$E0,$CA,$78,$C1,$B0,$2E,$29,$61,$D4,$51,$D2,$62,$69,$44; 448
		dc.b $35,$B0,$A3,$A1,$AD,$87,$F4,$47,$85,$EE,$90,$62,$CB,$D0,$41,$8B,$37,$6B,$3A,$E5,$FB,$33,$E4,$8A,  8,$21,$E8,$EA,$6A, $B,$8A,$29,$CD,$C3,$B3,$33,$33,$37,$6B,$38,$D9,$18,$2E,$14,$B2,$AA,$98,$17,$95,$5E,$8F,$52,$F1,$54,$A3,$D9,$17,$D7,$2D,$37,$56,$5A,$7E,$8A; 512
		dc.b $A3,$29,$68,$13,$2F,$55,$E7,$95,$85,$28,$E8,$27,$BE,$88,$A4,$64,$94,$45,  7,$15,$75,$18,$1C,$5C,$75,$C5,$99,$99,$99,$9B,$AB,$E6,$A9,$57,$B9,$51,$51,$F0,$54,$5D,$F4,$4F,$E5,$25,$10,$7E,$E9,$39,$A0,$51,$92,$7B, $B,$23,$84,$4A,$F8,$B2,$89,$2D,$76,$72,$75,$E0; 576
		dc.b $7F,$4C,$92,$89,$F2,$74,$95,$E9,$FA,$74,$59,$5F, $B,$BD,$65,$1B,$A3,$D4,$FF, $E,$53,$F6,$9A,$5A,$80,$FB,$EA,$FE,$D0,$5F,$FC,$90,$41,  4,$33,$33,$33,$33,$33,$2A,$28,$CD,$3C, $B,$BC,  5,$38,$7E,$E8,$29,$45, $A,$14,$23,$85, $A,$12,$8E,$A1,$42,$51,$F5,$2A,$51; 640
		dc.b $D4,$C9,$53,$9A,$83, $B,$CD,$71,$31,$2C,$B5,$1D,$76,  5,  6,$38,$2E,$3B,$48,$28,$3B,$C8,$5C,$68,$85,$48,$50,$75,$4F,$79,$E4,$BF,$C2,$C8,$7F, $B,$92,$7F, $B,$7A,$FF, $C,$6C,$E8,$6E,$B6,$EB,$6E,$B6,$EB,$6E,$B7,$3D,$B3,$DB,$8F,$4E,$C5,$8F,$E3,$7D,$3F,$7B,$3F; 704
		dc.b $EE,$CF,$FA,$BE,$73,$13,$D5,$30,$71,$20,$89,$89,$82,$27,$A9,$48,$9E,$39,$6C,$26,$BB,  5,$29,$68,$54,$FE,$8A,$3F,$9F,$9D,$D6,$FF,$F7,$FF,$BF,$F5,$F3,$FE,$4F,$4C,$4E,$A9,$E5,$35,$13,$CB,$F5,  2,$7E,$E2,$7B,$E7,$4E,$9B,$CF,$22, $A,$3D,$1C,$83,$57,$A3,$91,$3A; 768
		dc.b $F4,$13,$C2,$DB,$BA,$71,$EF,$DB,$BF,$6E,$F2,$EA,$6F,$97,$19,$45,$F2,$CE,$C8,$BE,$45,$6B,$C2, $A,$3A,$F0,$29,$CD,$6C,$3E,$55,$9F,$93,$33,$33,$36,  7,$F1,$BE,$9F,$BD,$9F,$F7,$67,$FD,$5E,$83,$FA,$22,$7A,$A6, $E,$A9,$89,$F9,$11,$30,$42,$EC,$26,$BB,  3,$BF,$61; 832
		dc.b $FA,$8B,$42,$FF,$87,$2F,$3F,$3B,$AD,$FF,$EF,$FF,$7F,$EB,$E7,$FC,$9B,$7C,$BA,$78,$41,$3F,  5,$C4,$D5,$27,$41,$3F,$D4,$1A,$6D,$BE,$8F,$6F,$22, $D,$7F,$4E,$44,$EB,$D0,$4F,  3,$8C,$EE,$E9,$C7,$BF,$6E,$FD,$BB,$CB,$A9,$BE,$5C,$65,$17,$CB,$3B,$22,$F9,$15,$AF,  8; 896
		dc.b $28,$EB,$C0,$A7,$35,$B0,$F9,$56,$7E,$4C,$CC,$CC,$CC,$CC,$CC,$CC,$CD,$76,$BE,$31,$F8,$CD,$2E,$A7,$EB,$35,$E1,$CB,$F1,$9F,$B3,$AC,$7E,$33,$4C,$F5,$B3,$33,$33,$33,$33,$75,$D3,$38,$F4,$D3, $E,$5E,$9A,$56,$9F,$BC,$FD,$9F,$A6,$97,$68,$D9,$80,  0; 960
Nem_Dinobot:	dc.b   0,$30,$80,  5,$14,$15,$11,$25,$16,$35,$18,$47,$73,$56,$37,$67,$72,$75,$15,$81,  3,  0,$15,$12,$26,$33,$36,$36,$58,$F8,$86,  4,  6,$17,$76,$87,  4,  5,$16,$38,$88,  6,$34,$89,  4,  7,$17,$77,$8C,  4,  4,$16,$32,$26,$3A,$37,$7A,$47,$79,$8D,  3,  1,$15,$13; 0
					; DATA XREF: ROM:0001C1DAo
					; ROM:0001C1FEo
		dc.b $25,$17,$47,$7B,$8E,  7,$78,$8F,  5,$10,$16,$35,$FF,$AD,$79,$1C,$5D,$2C,$B3,$CA,$DC, $C,$AD,$2E,$AC,$7D,$44,$F9,$89,$41,$90,$89,$41,$90,$8F,$F7,$6C,$D4,$CE,$CB,$B6,$3F,$6F,$CF,$F5,$35,$E4,$98,$E9,$E3,$F1,$45, $A,$C2,$6A,$15,$A5,$37, $E,$29,$9D,$79,$3E,$EE; 64
		dc.b $BB,$BA,$F2,$7A,$F2,$4A,$2B,$38,$ED,$FA,$77,$E1,$95,$E3,$FF,$DF,$27,$FD,$87,$D4,$10,$C3,$2D,$50,$C1,$52, $D,  3, $E,$13,$53,  9,$34,$3A,$59,$37,$A3,$FA,$61,$D4,$FC,$DE,$57,$D9,$DB,$6E,$1D,$73,$E1,$C7,$6E,$1F,$3F,$D4,$E6,$AD,$1F,$84,$D9,$7B, $A,$77,$D8,$8E; 128
		dc.b $FF,$AE,$69,$43,$E0,$F5,$AA,  3,$96,$AD,  0,$7A,$D5,$18,$1F,$2C,$13,$DA,$BC,$92,$FF,$B9,$DA,$9B,$59,$35,$42,$23,$AA,$4C,$47,$2B,$88,$91,$BC,$E5,$8F,$DE,$8B,$40,$5C,$45,$60,$2E,$29,$C2,  9,$8A,$76,$41,$31,$4E,$C8,$26,$28,$C8,$2E,$28,$83,$F7,$A2,$9E,$C4,$6F; 192
		dc.b $2B,$67,$CC,$69,$9C,$22,$A3,$41,$AC,$42,$8F,$10,  4,$28,$F1,  0,$99,$F8,$80,$86,$6D,$E0,$20,$D4,$B0,$C9,$58,$2C,  1,$56, $A,$D7,$59,$28,$49,$A8,$2A,$13,$DF,$7F,$61,$D7,$D8,$75,$FD,$EC,$BB,$FF,$85,$FF,$E3,$B8,$4E,$6E,$C3, $E,$AC,$2B,$5A,$D5,$2A,$46,$E8,$46; 256
		dc.b $E4,$6F,$31,$CC,$A0,$E6,$50,$8C,$14,$23,  5,  8,$B1,$C8,$8B,$14,$81,$11,$28,$C8,$44,$42,$41,  8,$8C,$B2,$22,$33,  8,$44,$58,$82,$2D,$99,$16,$CC,$8B,$77,$23, $A,$CE,$31,$FA,$61,$8F,$D3,$8C,$70,$E3,$1D,$C7,$3D,$B0,$9A,$A0,$B0,$76,$41,$67,$E1,  5,$6B,$58,$9C; 320
		dc.b $5D,$2C,$B3,$CA,$DC, $C,$AD,$2E,$AC,$7D,$44,$F9,$89,$41,$90,$89,$41,$90,$8F,$F7,$77,$95,$9A,$99,$D9,$76,$C7,$ED,$F9,$FE,$A7,$92,$63,$A7,$8F,$C5,$14,$2B,  9,$A8,$56,$94,$DC,$38,$A6,$75,$AD,$6B,$5A,$F2,$7E,$6E,$DA,$63,$46,$57,$8F,$FF,$7C,$9F,$F6,$1F,$50,$43; 384
		dc.b  $C,$B5,$43,  5,$48,$34, $C,$38,$4D,$4C,$24,$D0,$E9,$64,$DE,$8F,$E9,$87,$53,$F3,$79,$5F,$67,$F8,$57,$6D,$95,$C2,$E6,$AF,$2E,$DC,$38,$56,$FD,$CE,$C9,$B2,$F6, $F,$F8,$B7,$D8,$8F,$CD,$FE,$B9,$A5,$F8,$BF,$83,$D6,$A8, $E,$5A,$B4,  1,$EB,$54,$50,$7C,$FE,$61,$3D; 448
		dc.b $D1,$E4,$97,$8F,$7D,$AD,$B5,$13,$5C,$88,$A3,$AB,$14,$98,$5E,$D7,$1A,$11,$BC,$E5,$8F,$DE,$8B,$40,$5C,$45,$60,$2E,$29,$C2,  9,$8A,$76,$41,$31,$4E,$C8,$26,$28,$C8,$2E,$28,$83,$F7,$A2,$9E,$C4,$6F,$2B,$67,$CC,$69,$9C,$22,$A3,$41,$AC,$42,$8F,$10,  4,$28,$F1,  0; 512
		dc.b $99,$F8,$80,$86,$6D,$E0,$20,$D4,$B0,$C9,$58,$2C,  1,$56, $A,$D7,$59,$28,$49,$A8,$2A,$13,$F7,$BF,$A9,$B8,$7D,$15,$AE,$1F,$4E,$3F,$7B,$2F,$CC,$7F,  7,$40,$F6,$1F,$A8,$14,$EF,$E8,$BB,$2B,$AB,  4,$65,$7E,$18,$25,$6B,$5A,$D8,$F2,$23,$91,$1B,$91,$B9,$1B,$91,$BC; 576
		dc.b $C7,$39,$8C,$14,$23,  5,  8,$B1,$48,$11,$43,$94,$10,$8A,  4,$86,$44,$52,$59,$4C,$52,$61,  8,$8B,$11,$31,$1C,$C8,$B6,$64,$59,$C1,$18,$79,$73,$D1,$F7,$D1,$F7,$7A,$F2,$1C,$88,$DC,$8D,$D0,$56,$B5,$E6,$71,$74,$B2,$CF,$2B,$70,$32,$B4,$BA,$B1,$F5,$13,$E6,$25,  6; 640
		dc.b $42,$25,  6,$42,$3F,$DD,$E4,$39, $C,$35,$25,$85,$CF,$9F,$E9,$F9,$26,$3A,$78,$FC,$51,$42,$B0,$9A,$85,$69,$4D,$C3,$8A,$67,$5A,$D6,$B5,$AD,$6B,$58,$FF,$F7,$C9,$FF,$61,$F5,  4,$30,$CB,$54,$30,$54,$83,$40,$C3,$84,$D4,$C2,$4D, $E,$96,$4D,$E8,$FE,$98,$75,$3F,$37; 704
		dc.b $95,$F6,$7F,$85,$7F,$85,$70,$D9,$AB,$C9,$64,$A1,$59,$7B,$2E,$C9,$B2,$F6, $F,$F8,$B7,$D8,$8F,$CD,$FE,$B9,$A5,$F8,$BF,$83,$D6,$A8, $E,$5A,$B4,  1,$EB,$54,$91,$F3,$DD,$3D,$D1,$E4,$97,$8F,$7D,$B1,$B6,  5,$E3,$2D,$18,$69,$2D,$15,$86,$8A,$46,$F3,$96,$3F,$7A,$2D; 768
		dc.b   1,$71,$15,$80,$B8,$A7,  8,$26,$29,$D9,  4,$C5,$3B,$20,$98,$A3,$20,$B8,$A2, $F,$DE,$8A,$7B,$11,$BC,$AD,$9F,$31,$A6,$70,$8A,$8D,  6,$B1, $A,$3C,$40,$10,$A3,$C4,  2,$67,$E2,  2,$19,$B7,$80,$83,$52,$C3,$25,$60,$B0,  5,$58,$2B,$5D,$64,$A1,$26,$A0,$A8,$4F,$6F; 832
		dc.b $A4,$C3,$E8,$AC,$B3, $F,$A7,$1A,$4C,$77,$FC,$C3,$C9,$74,$71,$DE,$9C,$69,$28,$CF,$47,$16,$6E,$88,$8F,$64,$98,$AD,$6B,$5D,$C8,$E4,$46,$E4,$6F,$31,$CE,$63,$9C,$C7,$39,$8C,$14,$23,  5,  8,$B1,$48,$11,$19,$C1,  5,$2F,  4,$22,$81,$21,$91,$14,$96,$53,$14,$98,$43; 896
		dc.b $2A,$31,  9,$28,$E6,$92,$8E,$64,$5B,$B9,$18,$70,$E3, $F,$2E,$6E,$37,$7A,$D6,$B5,$AF,$20; 960
Nem_HPZ_Piranha:dc.b   0,$40,$80,  5,$10,$15,$14,$25,$12,$36,$34,$46,$30,$56,$2F,$66,$2D,$74,  3,$81,  3,  0,$15,$13,$26,$31,$37,$75,$82,  5,$11,$17,$6B,$28,$F4,$83,  6,$33,$84,  7,$73,$86,  5, $C,$17,$71,$28,$F7,$87,  4,  5,$16,$2C,$27,$74,$88,  4,  4,$15, $D,$27,$72,$37,$70; 0
					; DATA XREF: ROM:0001C204o
		dc.b $89,  4,  2,$16,$2A,$27,$64,$36,$36,$48,$F3,$8A,  7,$6A,$18,$F5,$27,$78,$48,$EC,$8B,  5, $E,$17,$6E,$27,$6F,$8C,  6,$2E,$18,$ED,$28,$F2,$8D,  6,$2B,$17,$65,$8E,  5, $F,$17,$77,$FF,$33,$33,$33,$33,$33,$BE,$AD,$2A,$6C,$8B,$85,  9,$B5,$F6,$D0,$92,$BF,$28,$12; 64
		dc.b $2D,$D3,$64,  9,$16,$E9,$DC,$48,$AC,$AF,$C8,$91,$78,$FE,$B4,$93,$F6,$DD,$C9,$3F,$AF,$46,  4,$9A,$68,$C1,  6,$49,$93,$60,$A3,$D6,$6A,$25,$DF,$F5,$B8,$7E,$B8,$CC,$CC,$CC,$CE,$D6,$5F,$CE,$38,$73,$D7,$A6,$71,$AA,$59,$C7,$25,$33,$FF,$4B,$57,$DD,$B6,$7E,$D9,$BF; 128
		dc.b $C7,$67,$F2,$3A,$56,$FF,$EC,$5D,$5B,$F8, $B,$AB,$7A,$2A,  7,$65,$7A,$B4,$3B,$2B,$D5,$A4,$CA,$DE,$AD,$26,$2B,$EC,$42, $C,$45,$69,$4D,$31,$4E,$AA,$20,$CC,$6B,$78,$66,$37,$56,$F0,$A3,$B7,$FF,$B5,$BC,$7F,$7A,$77,$CE,$D7,$99,$9D,$B9,$CB,$F6,$65, $F,$CA,$47,$20; 192
		dc.b $64,$76,$10,$8E,$C2,$9B,  9,$6C,$25,$B0,$97,$98,$A2,$79,$88,$71,$56,$D4,$19,$67,  2,$6F,$FC,$5D,$E3,$7F,$EE,$99,$FE,$A2,$F5,$DD,$FD,$A6,$2B,$BC,$33,$52,  5, $E,$D4,$5A,$82,$A4,$F7,$AB,$67,$BD,$B3,$DC,$8E,$C7,$F9,$6F,$1F,$DB,$1B,$D3,$FE,$33,$87,$F0,$64,$36; 256
		dc.b $95,$5C,$A5,$AD,$2C,$C3,$38,$D9,$7F,$A4,$3D,$30,$99,$99,$99,$E9,$12,$D3,$5D,$54,$D7,$52,$52,$39,$D4,$D8,$47,$3A,$B9,$43,$3A,$9A,$A5, $C,$89,$52,$2B,$B2,$58,$50,$D5,$B8,$AC,$28,$78,$70,$52,$87,$EE,$9C, $A,$1E,$BF,$C1,$86,$A0,$4A,$C5,$A3,$81,$72,$A6,$EF,$E0; 320
		dc.b $C3,$78,$45,$28,$6E,  5,$61,$41,$C1,$B5,$22,$88,$92,$58,$54,$D6,$48,$A9,$2D,$64,$DC,$35,$92,$5F,$AC,$CC,$CC,$CC,$CC,$CC,$CC,$EF,$AB,$4A,$9B,$22,$E1,$42,$6D,$7D,$B4,$24,$AF,$CA,  4,$8B,$74,$D9,  2,$45,$BA,$77,$12,$2B,$2B,$F2,$24,$5E,$3F,$AD,$24,$FD,$B7,$72; 384
		dc.b $4F,$EB,$D1,$81,$26,$9A,$30,$41,$86,$67,$7B,$34,$7E,$50,$9A,$77,$CB,$7F,$73,$33,$33,$B5,$97,$F3,$8E,$1C,$F5,$E9,$9C,$6A,$96,$71,$C9,$4C,$FF,$D2,$D5,$F7,$6D,$9F,$B6,$6F,$F1,$D9,$FC,$8E,$95,$BF,$FB,$17,$56,$FE,  2,$EA,$DE,$8A,$81,$D9,$5E,$AD, $E,$CA,$F5,$69; 448
		dc.b $32,$B7,$AB,$49,$8A,$FB,$10,$83,$11,$5A,$53,$4C,$53,$AA,$88,$33,$1A,$DF,$29,$DD,$96,$8C,$9D,$D5,$BD,$93,$4B,$B2,$BC,$20,$BB,$2B,$E7,$77,$EB,$5F,  1,$97,$BC,$BF,$5C,$66,$78,$67,$2F,$D9,$94,$3F,$29,$1C,$81,$91,$D8,$42,$3B, $A,$6C,$25,$B0,$96,$C2,$5E,$62,$89; 512
		dc.b $E6,$21,$C5,$5B,$50,$65,$9C,  9,$BF,$F1,$77,$8D,$FF,$BA,$67,$FA,$8B,$D7,$77,$F6,$98,$AE,$F0,$CD,$48,$14,$3B,$51,$6A, $A,$93,$DE,$AD,$9E,$F6,$CF,$72,$3B,$1F,$E5,$BC,$7F,$6D,$FB,$D3,$FE,$33,$87,$F0,$64,$36,$95,$5C,$A5,$AD,$2C,$C3,$38,$D9,$7F,$A4,$3D,$30,$99; 576
		dc.b $99,$99,$C3,$D3,$48,$82,$D2,$22,$A9,$6B,  4,$92,$88,$26,$CB,$3F,$3A,$64,$6C,$9D,$91,$25,$AB,$75,$52,$F0,$E1,$2F,$DD,$38,$53,$D7,$F8,$30,$D4,  9,$58,$B4,$70,$2E,$54,$DD,$FC,$18,$6F,  5,$2D,$C0,$92,$4E,  4,$D9,  8,$ED,$28,$86,$E9,$10,$49,$86,$B2,$B7,$59,$99; 640
		dc.b $9D,$B9,$25,$53,$56,$84,$DE,$90,$26,$AF,$1B,$A8,$4B,$C7,$B6,$8C,$25,$66,$59,$15,$8F,$AD,$EC,$83,  5,$9D,$D6,$70,$16,$77, $C, $C, $B,  7,$D6,$BD,$60,$FC,$B8,$B2,$8F,$CA,$B3,$93,$EB,$BA,$7A,$3E,$BE,$DC,$1F,$96,$F7,$D7,$68,$B4,$5A,$FB,$4A,$D8,$DB,$13,$33,$33; 704
		dc.b $33,$3D,$B4,$E1,$55,$3F,$B1,$57,$95,$7C,$27,$DB,$5B,$56,$6C,$BA,$B7,$A2,$F9,$65,$7B,$7F,$9A,$F6,$FE,$F5,$FC,$BF,$7D,$67,$2B,$38, $F,$E4,$10,$70,$E5,$B7,$52,$F7,$EA,$CE,$9E,$4F,$EB,$DB,$5B,$F8,$65,$EE,$15,$BD,$5D,$FD,$1F,$E5,$96,$3F,$BB,$42,$C5,$37,$22,$A7; 768
		dc.b $57,$2B,$15,$24,$23,$C7,  8,$B2,$F8,$B2,$D8,$99,$99,$99,$DF,$FB,$2F,$D1,$F3,$4C,$9E,$99,$AA,$7F,$65,$78,$F9,$D9,$C7,$6E,$8C,$5C,$88,$BE,$E9,$53,$55,$96,$55,$8A,$58,$85,$BE,$7C,$BB,  3,$5D,$D8,$11,$5D,$E1,$8E,$9B,$BD,$4B,$56,$E4,$77,$63,$83,$B5,$33,$C3,$83; 832
		dc.b $8B,$B3,$7F,$62,$6F,$D5,$3D,$5F,$BB,  4,$A3,$F7,$61,$15,$8E,$1B,$A6,$8B,$10,$85,$8C,$22,$5C,$27,$12,$42,$45,$28,$44,$91,$49,$64,$5D, $A,$51,$B3,  8,$95,$F1,$33,$BD,$96,$F3,$67,$3C,$32,$73,$FC,$9D,$3F,$B3,$9C,$3F,$D3,$9D,$58,$90,$A8,$5E,$42,$F2,$17,$95,$A5; 896
		dc.b $69,$5A,$5F,$93,$D7,$2F,$3D,$70,$AB,$F9,$11,$C8,$DE,$8E,$24,$2E,$90,$71,$34,$96,$8E,$1F,$B7,$A3,$BA,$68,$2A,$BC,$19,$99,$99,$99,$99,$CB,$24,$AA,$6A,$D0,$9B,$D2,  4,$D5,$E3,$75,  9,$78,$F6,$D1,$84,$AC,$CB,$22,$B1,$F5,$C9,$82,$C7,$E0,$2C,$C1,$81,$6F,$9D,$AC; 960
		dc.b $B4,$41,$9A,  6,$5C,$94,$64,$D2,$BB,$A6,$93,$B9,$F5,$FF,$32,$B8,$77,$FE,$6C,$BF,$9D,$6B,$ED,$2B,$63,$6C,$4C,$CC,$CC,$CC,$F6,$D3,$85,$54,$FE,$C5,$5E,$55,$F0,$9F,$6D,$6D,$59,$B2,$EA,$DE,$8B,$E5,$95,$ED,$FE,$6B,$DB,$FB,$D7,$F2,$FD,$F5,$9C,$AC,$E0,$3F,$90,$41; 1024
		dc.b $DC,$36,$EA,$5E,$F8,$93,$3A, $B,$AB,$7F,$5B,$B2,$BF,$87,$EB,$5E,$15,$BF,$AE, $E,$FE,$8F,$F2,$CB,$1F,$DD,$A1,$62,$9B,$91,$53,$AB,$95,$8A,$92,$11,$E3,$84,$59,$86,$B6,$61,$18,$47,  8,$99,$99,$99,$FE,$CB,$F4,$7C,$D3,$27,$A6,$6A,$9F,$D9,$5E,$3E,$76,$71,$DB,$A3; 1088
		dc.b $17,$22,$2F,$BA,$54,$D5,$65,$95,$62,$96,$21,$6F,$9F,$2E,$C0,$D7,$76,  4,$57,$78,$63,$A6,$EF,$52,$D5,$B9,$1D,$D8,$E0,$ED,$4C,$F0,$E0,$E2,$EC,$DF,$D8,$9B,$F5,$4F,$57,$EE,$C1,$28,$FD,$D8,$45,$63,$86,$E9,$A2,$C4,$55,$8C,$2A,$E5, $C,$50,$93,$42,$69,$69,$14,$BE; 1152
		dc.b $36,$C4,$CC,$ED,$65,$BC,$D9,$CF, $C,$9C,$FF,$27,$4F,$EC,$E7, $F,$F4,$E7,$56,$24,$2A,$17,$90,$BC,$85,$E5,$69,$5A,$43,$F6,$54,$AB,$12,$D7,$FE,$98,$6C,$DA,$54,$84,$92,$71,$34,$A4,$E2,$4C,$1C,$2F,$75,$A0,$C1,$99,$99,$99,$9D,$E0; 1216
Nem_Seahorses:	dc.b   0,$3E,$80,  5,$13,$15,$12,$25,$16,$36,$32,$46,$33,$56,$2E,$66,$38,$74,  4,$81,  3,  0,$15, $E,$27,$78,$38,$F3,$82,  6,$2F,$83,  7,$76,$84,  6,$3A,$85,  5, $F,$16,$36,$28,$F2,$38,$F6,$86,  4,  6,$16,$37,$87,  4,  8,$17,$73,$88,  4,  5,$17,$77,$89,  3,  1; 0
		dc.b $15,$18,$27,$7A,$8A,  8,$F7,$8C,  5,$15,$16,$35,$8D,  5,$14,$16,$34,$27,$72,$FF,$44,$44,$44,$44,$BB,$13,$F6,$30,$B3,$7E,$AD,$50,$64,$FD,$1E,$6C,$FA,$3C,$66,$F0,$88,$89,$C7,$EE,$6C,$77,$85,$91,$76,$F1,$22,$ED,$E2,$6F,$3B,$FE,$9D,$F4,$A9,$8F,$D4, $F,$D6,$1D; 64
		dc.b $B1,$FE,$D7,$7B,$69,$76,$DC, $E,  5,$CF,$6C,$DF,$4A,$F1,$1E,$CD,$CC,$F2,$6F,$53,$1A,$1A,$D1,$F3,$51,$5D,$EB,$B2,$8A,$6B,$A3,$D4,$6B,$A6,$C3,$F5,$9A,$6D,$FA,$CA,$79, $A,$56,$8E,$DA,$7A,$79,$BE,$6F, $D,$DF,$CD,$A0,$88,$F1,  4,$32,$87,$BA,$3B,$87,$86,$F3,$A0; 128
		dc.b $9C,$77,$39,$61,$24,$A7,$38,$39,$B1,$C8,$31,$CC,$1B,$82,$24,$A1,$4D,$B9,$E2,$CD,$8C,$CA,$22,$22,$22,$22,$6D,$73,$EB,$B6,$4F,$DE,$83,$79,$BF,$5A, $C,$4D,$F4,$DB,$2D,$91,$11,$11,$11,$27,$FB,$9B,$1D,$68,$64,$75,$C2,$C8,$BB,$78, $F,$2E,$6E,$63,$53,$1F,$A8,$14; 192
		dc.b $D4,$ED,$42,$F3,$4D,$69,$5B,$79,$69,$76,$DC, $E,  5,$CF,$6C,$DF,$4A,$A7,$F1,$6D,$C9,$97,$F4,$E7,$4F,$E4,$A8,$AE,$F5,$D9,$45,$35,$D1,$EA,$35,$E4,$FE,$55,$D3,$6D,$74,$F6,$AB,$56,$83,$CB,$5A,$3C,$79,$51,$ED,$DC,$3D,$CC, $A,$C7,$88,$60,$54,$3D,$D0,$AE,$78,$6F; 256
		dc.b $3A,  4,$49,$F7,$F5,$6C,$25,$C2,$51,$DE,$43,$7F,$52,$18,$CC,$70,$12,$5D,$EC,$DC,$FD,$4B,$D2,$22,$22,$22,$22,$67,$E5,$9F,$E9,$A8,$37,$1A,$6A,$FC, $F,$64,$44,$44,$44,$44,$FD,$CD,$8E,$B4,$32,$3A,$E1,$64,$5D,$BC,  7,$97,$37,$31,$A9,$8F,$D4,$69,$A9,$DB, $F,$34; 320
		dc.b $FD,$65,$2D,$E5,$A5,$DB,$70,$38,$17,$3D,$B3,$7D,$2A,$9F,$C5,$B7,$26,$5F,$D3,$9D,$3F,$92,$A2,$BB,$D7,$65,$14,$D7,$47,$A8,$D7,$93,$C7,$EB,$34,$DA,$BC,$BD,$B9,$3B,$CB,$4F,$1E,$C1,$BB,$87,$B9,$81,$58,$F1, $C, $A,$87,$BA,$15,$CF, $D,$E7,$41,$9B,$F4,$AD,$9F,$C9; 384
		dc.b $A4,$FE,$55,$A4,$DF,$CA,$B4,$7C,$DF,$CA,$B4,$2F,$E5,$5A,$3C,$BF,$95,$69,$E5,$A5,$5A,$BA,$3E,$9A,$EF,$50,$FA,$57,$77,$33,$EA,$CE,$8D,$E8,$EF,$D3,$96,$99,$FD,$47,$36,$91,$EF,  4,$5B, $E,$8C,$CF,$36,$D7,$47,$89,$D3,$D8,$4B,$66,$87,$8D,$DE,$CE,$2E,$2F,$87,$11; 448
		dc.b $2D,$B0,$E9,$17,$B9,$E2,$4F,$F4,$F1,$36,$15,$F6,  5,$E2,$9B,$3A,$6C,$FF, $F,$13,$67,$8D,$9D,$32,$36, $F, $C,$19,$E3,$60,$F8,$DC,$6C,$26,$60,$37,$90,$B2,$E2,$5C,$F1,$96,$11,$12,$6B,$8B,$73,$39,$46,$33,$28,$89,$DD,$F9,$46,$D9,$BD,$11,$2D,$7F,$E4,$FA,$B5,$FF; 512
		dc.b $A3,$69,$5F,$FA,$3E,$BB,$4E,$FF,$D1,$F5,$DA,$F9,$DF,$FA,$3E,$BB,$1B,$FF,$47,$D7,$6B,$CD,$FF,$A3,$EB,$B7,$E8,$BF,$27,$D3,$75,$F9,$3B,$FB,$7E,$53,$7E,$85,$FD,$BA,$DD,$CD,$7F,$4C,$E8,$DF,$B3,$BF,$4E,$5A,$67,$F5,$1C,$DA,$47,$BC,$11,$6C,$3A,$33,$3C,$DB,$F2,$9F; 576
		dc.b $93,$BC,$4F,$B7,$EC,$84,$BF,$24,$D1,$78,$99,$BD,$9C,$7C,$5F, $E,$20,$AF,$E4,$B1,$E6,$6F,$75,$EE,$9D,$FE,$AF,$12,$1D,$7E,$C8,$4E,$F1,$DB,$F2,$4E,$9B,$5F,$E2,$F1,$36,$BC,$7E,$49,$D3,$23,$F2,$42,$F1,$30,$D7,$8F,$C9,  9,$C6,$E3,$F2,$42,$66,  3,$7E,$88,$7A,$CC; 640
		dc.b $B2,$9C,$97,$75,$36,$EE,$CA,$6C,$63,$F5,  6,$42,$16,$14,$C8,$15,$85,$32,  5,$79,$9B,  2,$B0,$A2,$40,$AC,  3,$20,$5D,  0,$C8,$15,$1E,$E2,$40,$86,$EB,$DE,$4E,$F7,$FC,$A7,$BE,$5F,$9A,$EB,$DE,$EF,$CD,$7A,$CC,$B2,$9C,$97,$75,$36,$EE,$CA,$6C,$63,$F5,  6,$42,$16; 704
		dc.b $14,$C8,$15,$85,$32,  5,$79,$9B,  2,$B0,$A2,$40,$AC,  3,$20,$5D,  0,$C8,$15,$1E,$E2,$40,$8E,$BD,$EC,$EF,$D5,$22,$70,$57,$82,$88,$89,$2B,$F8,$BE,$E1,$DA,$FC,$C7,$5D,$AE,$1D,$76,$CC,$75,$DA,$E1,$7B,  3,$93,$B9,$DC,$E4,$51,$CD,$85,$EE,$58,$30,$2F,$13,$3D,$C2; 768
		dc.b $DE,$24,$42,$C5,$E2,$45,$4B, $B,$15,$86,$19,$18,$23,$23,$17,$8C,$8A,$8C,$8A,$DE,$32,$2A,$32,$2B,$78,$B1,$5B,$C6,$4A,$EC,$C2,$22,$22,$5D,$5B,$AA,$73,$A9,$5C,$98,$AC,$5A,$A5,$61,$A5,$52,$B0,$D4,$9D,$1A,$BC,$8C,$EB,$A6,$21,$A7,$8F,$D3,$6B,$6F,$E4,$A2,$24,$A9; 832
		dc.b $75, $E,$74,$2B,$99,$5B,$96,$2E,$85,$B9,$96,$ED,$F4,$CB,$4B,$A1,$6E,$65,$BB,$F5,$99,$FA,$44,$44,$44,$44,$44,$B6,$B9,$55,$B1,$2D,$70,$B1,$3A,$61,$79,$B4,$E8,$DA,$F2,$95,$69,$85,$89,$62,$B4,$E7,$96,$35,$BB,  8,$88,$89,$6A,$E9,$2A,$E8,$56,$D8,$58,$C9,$61,$B3; 896
		dc.b $DE,$E6,$E3,$4B,$A3,$86,$E2,$BC,$1A,$F0,$51,$13,$C6,$4E,$2A,$2D,$FC,$1C,$BC,$22,$22,$22,$22,$22,$26,$65,$C6,$C5,$C4,$19,$38,$A9,$12,$F0,$5D,$23,$E6,$6C,$5C,$51,$11,$11,$11,$13,$22,$E3,$6F,$32,$26,$7C,$15,$C7,$F0,$4F,$FC,$5C,$7F,$A2,$67,$FD,$1B,$17,$14,$44; 960
		dc.b $44,$44,$49,  4,$4E,  4,$86,$63,$87,$4C,$66,$E9,$89,  9,$79,$DB,$FA,$33,$13,$FE, $C,$8F,$F4,$6C,$7C,$64,$66,$EE,  2,$22,$22,$22,$22,$22,  3,$73,$B1,$97,$9E,$25,$FD,$1C,$7F,$C7,$1F,$D1,$CB, $E,$44,$44,$44,$44,$44,$B8,$8C,$8F,$89,$61,$D8,$FF, $C,$FF,$83,$67; 1024
		dc.b $22,$22,$22,$22,$5C,$2C,$32,$17,$3A,$E1,$30,$88,$89,$98; 1088
Nem_UnusedRollingBall:dc.b   0,$1B,$80,	 5,$14,$15,$15,$26,$34,$36,$31,$57,$73,$76,$32,$82,  4,	 6,$17,$75,$27,$71,$83,	 3,  0,$16,$2F,$27,$79,$37,$7A,$47,$77,$84,  3,	 1,$15,$13,$26,$33,$37,$6E,$47,$72,$58,$F7,$86,	 7,$74,$17,$76,$87,  6,$30,$17,$78,$88,	 5,$12,$17,$6F,$89,  3,	 2; 0
		dc.b $17,$70,$8A,  4,  8,$17,$6A,$8B,  4,  7,$16,$2E,$26,$36,$37,$6B,$48,$F6,$78,$F8,$8D,  5,$16,$FF,$CB,$9E,$AC,$77,$69,$3E,$C6,$BE,$F5,$23,$75,  8,$20,$83,$4F,$24,$1B,$DB,$C9,$BD,$83,$7F,$4D,$83,  6,$BD,$AC,$C1,$83,$10,$D6,$E2,$1C,$D9,$AC,$C5,$E1,$F7,$3C,$2F; 64
		dc.b $68,$51,$47,$4E,$9F,$85,$2E,$4E,$9D,$56,$E4,$E9,$EB,$B1, $B,$4B,$81,$18,$CC,$1E,$64,$65,$FC,$AF,$31,$FB,$84, $F,$EA,$3C,$4B,$81,$DF,$87,$4F,$11,$39,$61,$DB,  9,$4E,$51,$87,$4F,$13,$94,$7E,$9E,$53,$8F,$1B,$9E,$25,$9F,$42,$A3,$DD,$4B,$93,$CB,$30,$46,$A9,$82; 128
		dc.b  $A,$83,$DE,$11,$60,$D7,$A8,$21,$83,  5, $F,$C4,$37,  7,$1C,$6C,$9D,$38,$6B,$33,$A7,$5A,$CB,$A7,$5B,  9,$A7,$57,$7B,$DD,$CB,$6C,$AF,$E6,$7C,$E2,$A7,$7E,$92,$84,$6F,$AE,$12,$85,$3A,$FE,$A2,$3F,$53,$4C,$D4,$3A,$A7,$4D,$CA,$EE,$4E,$9F,$DE,$E2,  8,$9A,$70,$41; 192
		dc.b   6,$EE,$E5,$3F,$73,$73,  6,$BD,$D3,$8E,$21,$CD,$1A,$CD,$B1,$A5,$9B,$63,$5D,$73,$AE,$D3,$D2,$E9,$E3,$76,$59,$65,$88,$38,$FA,$D3,$BD,$43,  6, $D,$51,$D4,$30,$A2,$6B,$35,$BA,$D1,$43,$5B,$AF, $F,$D5,$7E,$A6,$16,$A9,$44,$A2,$4B,$F5,$52,$8D,$EB,$35,$28,$97,$25; 256
		dc.b $AA,$7D,$A7,$A8,$83,$79,$51,$3F,$46,$29,$7B,$5E,$62,$85,$83,  2,$AA,$18,$30,$55,$21,$AF,$7D,  8,$60,$F8,$CE,$EE,$77,$65,$EF,$C2,$7D,$B3,$44,$6E,$DE,  8,$9A,$C2,$5E,$97,$E9,$DA,$F5,$87,$E9,$99,$47,$F1,$D4,$4B,$94,$4B,$3E,$C6,$5F,$E4,$97,$FD,  8,$20,$89,$82; 320
		dc.b   8,$22,$7F,$D3,$21,$83,$79,$2C,$18,$30,$62,$38,$86,$10,$43,$59,$AC,$C9,$C8,$6B,$35,$B8,$7F,$6D,$3A,$75,$F1,$F1,$F1,$B6,$48,$F3,$84,$46,$32,$84,$46,$9B,$E1,$11,$5C,$25,$A9,$1A,$CA,$25,$AA,$74,$9F,$EA,$9C,$D3,$38,$75,$76,$70,$9D,$3E,$E7,$57,  2, $A,$74,$E4; 384
		dc.b $10,$EA,$EF,$57,$23,$E9,$D3,$90,$C3,$59,$E3,$B1,$A7,$51,$B1,$A3, $D,$8D,$75,$CE,$BA,$CE,$9A,$F1,$BB,$2C,$B2,$C5,$36,$3C,$3A,$E8,$A3,$F5,$15,$5A,$B7,$E1,$55,$9E,$FA,$4F,$B4,$E5,$4F,$FA,$10,$46,$E0,$41,$13,  4,$10,$44,$C1,  4,$1F,$F9,$DE,$C1,$83,$5E,$C1,$83; 448
		dc.b   6,$BF,$88,$EA,$68,$2C,$D6,$EA,$F4,$22,$CD,$60,$F5,$F6,$55,$D6,$9F,$4F,$6C,$75,$F3,$73,$97,$AD,$C3,$B0,$6F,$3F,$B2, $D,$7F,$F5,$E5,$84,$B0,$FD,$37,$89,$7E,$9F,$A7,$89,$61,$BF,$F4,$F9,$C6,$FC,$33,$E8,$A2,$5C,$94,$A3,$92,$8C,$C1, $F,$29,$82, $B,$C1,$EE,$F0; 512
		dc.b $58,$35,$EF,  4,$30,$60,$E9,$C7,$EC,$B8,$39,$16,$6B,$7E,$A5,$C8,$B3,$3A,$75,$AD,$3A,$F8,$F8,$F6,$FF,$A7,$FD,$32,$9F,$33,$1C,$31,$FD,$44,$2D,$30,$DF,$A9,$57,$F7,$10,$AB,$9C,$B5,$2A,$74,$DD, $A,$9C,$A1,$7F,$91,$4C,$11,$37,$20,$82, $A,$3D,$CB,$9E,$E5,$16, $D; 576
		dc.b $7D,$C7,$F6,$42,$E3,$C4,$6D,$4B,$30,$D7,$4F,$ED,$D7,$FB,$75,$F6,$D3,$5E,$33,$CB,$98,  0; 640
Nem_UnusedMotherBubbler:dc.b $80,$18,$80,  3,  0,$14, $A,$24,  7,$36,$30,$46,$38,$57,$78,$66,$39,$74,  5,$81,  4,  3,$16,$36,$27,$7A,$82,  4,  8,$17,$76,$83,  5,$13,$84,  7,$74,$85,  7,$79,$86,  4,  4,$87,  4,  2,$16,$37,$88,  5,$19,$89,  5,$17,$8A,  7,$75,$8B,  6,$31,$17,$7B,$8C,  5; 0
		dc.b $1A,$17,$77,$8D,  5,$12,$8E,  4,  6,$8F,  5,$16,$18,$F8,$FF,$55,$55,$5F,$1F,$94,$C3,$F2,$88,$4F,$D0,$93,$6C,  9,  8,$E8,$BF,$44,$D9,  8,$6F,$23,  5,$6C,$25,$C1,$86,  9,$6D,$83,$4C,$13, $F,$89,$98,$4B,$4A,$1B,$52,$40,$72,$D3,$90,$31,$BF,$16,$73,$B9,$DA,$3F; 64
		dc.b $2C,$63,$32,$89,$EA,$CF,$B4,  9,$F7,$3F,$F6,$D7,$F0,$68,$FC,$1B,$70,$62,$ED,$CD,$DB,$9B,$97,$E9,$B8,$F4,$AA,$AA,$BC,$9A,$FF, $C,$7F,$86,$71,$37,$FC,$F7,$EC,$43,$7E,$69,$97,$6C,$9B,$7E,$69,$BB,  2,$3F,$CF, $F,$38,$18,$31,$E6,$8B,$D0,$2B,$57,$AD,$E5,$60,$47; 128
		dc.b $44,$D1,$6C,$32,$1A,$88,$17,$82,$B4,$85,$9E,$DD,$45,$A6,$3E,$3A,$A1,$CE,$BA,$E9,$24,$25,$DD,$3F,$3A,$24,$24,$24,$F1,$48,$F1,$7A,$C7,$83,$D0,$90,$8B,$F9,$74,$8B,$F5,$B2,$16,$22,$FD,$7D,$FF,  7,$15,$55,$A3,$5E,$4D,$57,$C1,$74,$E5,$3F,$67,$D3,$71,$FB,$14,$1D; 192
		dc.b $3F,$83,$E6,$65,$B7,$EB,$CE,$C5,$F9,$36,$1F,$9A,$24,$F3,$4C,$3F,$5C,$50,$7D,$23,$6B,$17,$E6,  8,$7E,$9E,$DF,$9D,$46,$79,$19,$26,$2C,$E8,$49,$7A,$FD,$38,$3B,$44,$88,$6D,$56,$9C,$B3,$61,$B0,$89,$88,$F8,$64,$BE,$2D,$38,$17,$74,$CC,$E3, $F,$CA,$C4,$F9,$8C,$DD; 256
		dc.b  $B,$E3,$DD,$F2,$49,$ED,$55,$55,$79,$CA,$F8,$FC,$C2,$F8,$CA,$AA,$F3,$D3,$92,$E8,$3F,$72,$37,$BC,$CD,$AD,$74,$29,$C5,$8C,$59,  1,$B1,$8D,$AA,$D2,$D8,$5B,$7A,$FD,$7B,$90,$B3,$18,$20,$41, $B,$23,$7A,$F7,$78,$21,$68,$98,$81,$2B,$75,$1F,$93,$1F,$93,$8A,$FD,$18; 320
		dc.b $C6,$63,$22,$62,$E2,$2B,$22,$E1,$33,$EA,$F4,$4A,$AA,$AA,$AA,$BC,$F7,$5D,$71,$15,$DF, $E,$CA,$B0,$25,$5F,$98,$73,$C3,$22,  6,$87,$EA,  4,$1E,$B0,$81,$27,$ED,$B3,$C0,$31,$27,$D8,$4B, $F,$D6,$AA,$F1,$DD,$7B,$E1, $F,$AC,$3B,$56,$B8,$85,$81,$A1,$FB,$81,  2,$4F; 384
		dc.b $97,$3F,$D4,$54,$1E,$B0,$81,$27,$ED,$B5,$76,  6,$25,$5E,$BF,$3A,$FF,$AD,$55,$24,$2C, $B,$4D,$A2,$73,$9C,$A6,$6E,$73,$94,$CD,$CB,$4D,$A2,$C0,$90,$95,$70,$24,  8,$4E,$6D,$8B,$1B,$A4,$DA,$68,$E9,$36,$9A,$39,$B6,$2C,$6E,$48,$10,$96,$B7,$7D,$E8,$D0,$21,$D1,  6; 448
		dc.b $C5,$81,$52,$4D,$A6,$8E,$93,$69,$A5,$10,$6C,$58,$15,$1A,  4,$3A,$DD,$F7,$7F,$D3,$F0,$46,$4E,$43,$16,$C4,$15,$24,$E5,$34,$74,$9C,$A6,$94,$43,$16,$C4,$13,$91,$97,$1F,$A7,$A0,  0; 512
Nem_UnusedBubbler:dc.b	 0,$18,$80,  3,	 0,$14,	 9,$25,$18,$36,$38,$46,$3B,$56,$3A,$67,$7A,$75,$19,$86,	 4, $B,$17,$7B,$87,  4,	 6,$16,$39,$88,	 4,  7,$16,$3C,$89,  4,	 8,$15,$1A,$28,$FA,$8A,	 3,  2,$16,$36,$28,$F8,$8E,  3,	 1,$16,$37,$8F,	 4, $A,$18,$F9,$FF,$CE,	$D,$76,$65,$F8;	0
		dc.b $AE,$8B,$8D,$DC,$38,$DD,$81, $F,$4E,$99,$3D, $A,$D9,$D3,$E7,$3C,$1A,$EC,$CB,$F1,$42,$9F,  7,$E5,$8D, $A,  7,$90,$FF,$23,$67,$F8,$EB,$DF,$67,$58,$BA,$30,$F2,$7C,$AD,$A4,$BA,$86,$20,$BB,$3E,$98,$A8,$7D,$18,$7F,$A5, $F,$15,$87,$52,$F4,$1E,$50,$54,$10,$34,$13; 64
		dc.b $40,$4F, $E,$CB,$F9,$2E,$CF,$FB,$94,$34,$F1,$B4,$E9,$D6,$96,$73,$EB,$DF,$77,$CF,$77,$E7,$16,$69,$62,$D9,$DA,$A4,$FE,$9F,$C9,$AE,$7C,$42,$F7,$F1,$45,$F2,$A9,$43,$16,$DB,$9A,$8A,$DA,$1D,$A1,$83,$79,  9,$94,$AD,$26,$80,$A3,$6D,$3E,$73,$7E,$9E,$FA,$57,$3F,$2C; 128
		dc.b $15,$C1,  4,$37,$D3,$27, $E,$DA,$79,$4E,$D1,$BD,$27, $D,$7C,$A7,$42, $B,$3A,$79,$62,$CA,$14,  6,$8E,$54,$6D, $F,$FB,$95,$AF,$ED,$42,$8F,$8F,$AC,$FA,$BE,$AA,$F8,$DA,$94,$A6,$D8,$A9,$4C,$B9,$43,$95,$50,$98,$32,$A8,$B8,$41,$94,$35,$C2,  9,$E3,$DF,$E0,$63,$6B; 192
		dc.b $8F,$7F,$81,$B4,$DA,$6B,$8B,$4D,$B4,$35,$AB,$78,$7A,$F8,$67,$4D,$1F,$BA,$67,$6F,$DD,$66,$E8,$B4,$2A,$61,$A6,$85,$4C,$A3,$66,$AF,$8E,$53,$B2,$A6,$5A,$75,$AE,$7C,$50,$D6,$BC,$50,$DE,$FE,$21,$BF,$4C,$A3,$F2,$3F,$B6,$86,$FC,$8F,$ED,$A2,$FF,  3,$1F,$B6,$D7,$ED; 256
		dc.b $BF,$4F,$FC,$A8,$64,$EB,$F5,$1F,$49,$F4,$9E,$32,$1B,$A7,$9A,$38,$71,$F2,$5E,$76,$A8, $F,$30,$9A,$36,$96,$8F,$86,$9B,$68,$55,$C8,$F7,$15,  1,$85,$B4,$34,$3B, $B,$6D,$27,$96,$8B,$AB,$87,$11,$7B,$3D,$F8,$5D,$3A,$84,$ED,  9,$F4,$84,$34,$28,$5A,$96,$E1,$B3,$DB; 320
		dc.b $76,$D3,$EF,$A6,$9E,$41,$93,$8B,$F5,$7D,$37,$BE,$1A,$77,  7, $C,  8,$7E,$2F,$B3,$83,$83,$E8,$E1,$D6, $F,$9D,$7E,$BA,$9A,$4E,$1A,$4F,$6C, $A,$E8,$A1,$5C,$19,$F9,$46,$24,$CB,$4B,$62,  1,$81,$4D,$18,$89,$2D,$31,$86,  9,$97, $F,$D2,$C2,$70,$BD,$2C,$B6,$71,$52; 384
		dc.b $EC,$65,  7,$C1,  8,$38,$60,$42,$60,$F2,$E1,$B4,$E1,$D8,$E1,$67,$36,$CF,$2C,$23, $B,$D6,$D1,$DB,$E1, $D,$B1, $F,$2E,$18,$1A, $F,$C3,$43,$8A,$CF,$A3,$D1,  7,$A3,$82,$37,  4,$6E,  8,$32,$41,  4,$19,$20,$83,$24,$11,$FA,$E9,$23,$70,$41,  4,$6F,$C6,$E3,$7F,$47; 448
		dc.b $39,$CE, $E,$64,$F0,$78,$20,$F4,$46,$F8,$20,$83,$82,$37,  6,$77,$1B,$F0,$41,  6,$48,$20,$E3,$70,$64,$82,  8,$38,$23,$70,$7B,$DF,$39,$C0; 512
Nem_Snail:	dc.b $80,$1A,$80,  3,  1,$14,  7,$24,  8,$34, $A,$46,$32,$56,$36,$66,$39,$74,  6,$81,  3,  0,$15,$16,$28,$FA,$82,  7,$79,$83,  6,$3A,$84,  6,$37,$85,  5,$18,$86,  6,$35,$87,  7,$77,$88,  3,  2,$17,$76,$89,  5,$12,$17,$7A,$8A,  7,$78,$8C,  5,$13,$16,$38,$28,$F8; 0
					; DATA XREF: ROM:0001C19Ao
					; ROM:0001C262o
		dc.b $8D,  6,$34,$17,$7B,$8E,  6,$33,$8F,  5,$17,$18,$F9,$FF,$66,$75,$28,$D2,  7,$AD,  4,$9F,$3B,$6F,$81,$22,$33,$B8,$37,$B5,$ED,$71,$DE,$E4,$5C,$47,$7D,$F1,$DE,$E4,$1D,  7,$52,$EF,$E3,$7A,$51,$A0,$71,$D6,$5F,$93,$60,$C7,$C5,  7,$D4,$E9,$68,$E0,$CF,$20,$F3,$69; 64
		dc.b $D0,$89,$B4,$E0,$54,$DA,  3,$59,$AC,$CC,$CC,$D1,$FC,$D3,$EF,$F8,$3A,$5B,$F8,$63,$AF,$12,  7,$F4,$72,$32,$F3,$D1,$1A,$FA,$E9,$EC,$7F,$24,$6C,$43,$F8,$C4,$4F,$73,$AA,$3F, $F,$FC,$C1,$1C,$11,$E7,$21,$E5,$3F,  3,$AE,$DB,$2F,$3B,$E5,$E4,$AA,$E8,$89,$B3,$31,$E0; 128
		dc.b $30,$21,$FC,$29,$91,$1A,$A8,$13,$3F,$15,$36,$E2,$84,$7E,$F0,$FF,$85,$99,$9B,$F5,$B9,$7D,$7B,$DA,$DE,$E3,$F1,$78,$36,$D0,$8D,$51,  6,$C7,$80,$43,$FC,$40,$FE,$E3,$CE,$3E, $F,$F4,$78,$FC,$9E,$53,$1D,$11,$EE,$67,$CD,$A7,$FA,$69,$8C,$AF,$97,$E7,$84,$E2,$7F,$58; 192
		dc.b $79,$E3,$F5,$D7,$A0,$E3,$61,$9D,$7C,$E6,$22,$57,$EF,$F9,$57,$99,$D6,$FE,$E2,$6D,$FB,$C6,$6F,$FE,$7F,$C5,$99,$99,$99,$D5,$22,$84,$23,$A0,$79,$2B,$BE,$E5, $C,$CD,$B7,$17,$CC,$67,$21,$B8,$B8,$CE,$B7,$19,$99,$3F,$83,$F9,$49,$3C,$F5,$E6,$71,$A3,$F0,$DB,$71,$B4; 256
		dc.b $BF,$48,$7C,$23,$7F,$AD,$F5,$CD, $C,$FE,$5C,$7E,$BB,$E5,$FE,$7F,$62,$E0,$8C,$1F,$D4,$61,$4B,$44,$EB,$41,$B0,$3F, $E,$36,$15,$C0,$A9,$DB,$20,$CC,$CC,$D4,$BB,$A3,$AA,$92,$B8,$B8,$BF,$E7,$A5,$A9,  5,$1B,$C5,$BB,$E7,$69, $B,$9D,$42,$2B,$39,$38,$5F,$95, $A,$27; 320
		dc.b $DA,$B4,$56,$8C,$20,$E2,$78,$42,$30,$B9, $C,$E3,$2C,$23,$FC,$13,$8F,$EC,$3F,$F5,$57,$37,$E6,$FC,$A6,$6E,$71,$CA,$C7,$2B,$1C,$AC,$50,$75,$8A, $E,$B1,$41,$D6, $F,$D5,$63,$FB, $F,$FF,$5D,$AD,$56,$C8,$6C,$23,$B1,$10,$99,$C5,$7E,$A1,$85,$7E,$A1,$88,$85,$42,$15; 384
		dc.b   8,$55,$66,$FF,$8D,$99,$FF,$F0,$CF,$FB,$87,$EC,$7F,$52,$54,$49,$D6,$5E,$99,$36,$5E,$8A,$7F,$46,$4F,$DB,$F5,$39,$7F,$A1,$BF,$91,$FF,$1B,$35,$A9,$40,$A5,  1,$FB,$50,$32,$69,$64,$1B,$90,$65,$B4,$9F,$B1,  7,$F5,  5, $C,$90,$8E,$D2,$15,$6D,$80,  0,$2A,$80,  5; 448
		dc.b $12,$16,$2B,$26,$2D,$36,$31,$47,$73,$56,$35,$67,$76,$74,  1,$81,  5, $F,$16,$27,$27,$78,$82,  4,  0,$14,  5,$26,$30,$37,$7A,$83,  4,  4,$16,$26,$26,$2A,$84,  5,$14,$17,$71,$85,  7,$6E,$86,  5,$10,$17,$77,$87,  5,$11,$17,$75,$88,  5, $E,$17,$74,$89,  4,  3; 512
		dc.b $16,$33,$28,$F7,$8A,  4,  6,$17,$6F,$8B,  4,  2,$16,$2C,$26,$36,$8C,  6,$2F,$17,$72,$27,$79,$8D,  6,$32,$8F,  7,$70,$16,$2E,$26,$34,$38,$F6,$FF,$11,$11,$11,$11,$11,$11,$B7,$77,$7C,$7F,$6B, $A,$E9,$BA,$1F,$A5,$A5,$54,$86,$EE,$22,$22,$22,$22,$22,$23,$DA,$96; 576
		dc.b $EE,$EF,$BA,$95,$EE,$A6,$EA,$6E,$A4,$B8,$EE,$FD,$26,$EF,$E1,$F1,$41,$11,$11,$11,$11,$11,$87,$6A,$42,$5D,$ED,$A7,$ED,$61,$5C,$DB,$B8,$EE,$49,$7E,$92,$AE,$22,$22,$23,$CF, $B,$56,$AA,$C2,$6E,$37,$88,$88,$8E,$1C,$EA,$5B,$78,$D4,  2,$22,$3D,$82,$6B,$7F,$85,$58; 640
		dc.b $20,$69,$20,$40,$D3,$21,$EC,$7C,$F3,$6C,$4E,$3D,$21,$52,$C5,$CF,$5A,$96,$FB,$83,$F6,$77,$E5,$A5,$52,  9,$8D,$29,$79,$82,$67,$14,$A3,$81,$27,$84,$51,$C0,$8E,$FD,$37,$40,$40,$74,$5C, $E,$30,$4C,$10,$19,$5C,$15,  1,$B4,$18,$12,$93,$3B,  9,$4C,$70,$72,$92,$4F; 704
		dc.b   8,$A9,$3A,$3D,$DC,$A4,$9D,$5D,$81,$27,$F0,$88,$E6,  3,  2,$36,$99,$D0,$CD,$9C,$25,$DB,$32,$E6,$6D,$12,$C7,$7B,$CC,$AD,$6E,$8C,$65,$5C,$61,$D1,$8C,$A5,$17,$BB,$3B,$2B,$5F,$6B,$E0,$BA,$65,$7B,$C3,$FB,$8B,$C3,$F9,$8B,$77,$EF,$17,$4F,$2B,$A7,$95,$BB,$2F,$E6; 768
		dc.b $68,$13,$72,$F6,  4,$FE,$E7,  0,$FE,$65,$C1,$FB,$CD,  3,$CF,$B0,$79,$CB,$40,$FD,$E6,$80,$8B,  6,$25,$48,  4,$48,$D2,$88,$F5,$6F,$D4,$54,  6,$DD,$2A,  2,$F7,$A8,$2C,$7C,$2A,  7,$93,$DD,$50,$78,$65,$28,$31,$BA,$14,$42,$89,$B3,$9F,$FA,$8D,$F9,$97,$4D,$E7,$B7; 832
		dc.b $BF,$EE,$DF,$17,$ED,$E1,$CF,$2F,$D8,$93,$7E,$C7,$67,$31,$A6,$12,$32,$4A,$5F,$44,  2,$4A,$5F,$FA,$44,$EA,$94,$FD,$9B,$C8,$36,$5D,$B3,$B0, $A,$73,$DA,$5B,$77,$B2,$4B,$76,$5C,$B2,$5B,$B9,$5D,$87, $B,$F4,$96,$1E,$D2,$58,  6,$95,$83,$FD,$5B,$E9,$39,$E1,$C3,$2E; 896
		dc.b $59,$5C,$1A,$72,$E0,  9,$ED,$7F,  0,$4F,$60,$AB,$40,$9A,  8,$BF,$B3,$7F,$F4,$FF,$E4,$16,$54,  5,$39,$CC,$A5,$E2,$60,$FD,$8C,$A6,  7,$E2,$80,$EC,$CA,$B0,$76,$FC,$CA,$5B,$CE,$CB,$76,$E6,$73,$D8,$6E,$6F,  4,$71,$71,$49,$E4,$71,$73,$DA,$B7,$C9,$E4,$D1,$B5,$E4; 960
		dc.b $6D,$1A,$EC,$37,$45,$D8,$D8,$6D,$AD,$86,$C7,$39,$D8,$CE,$EB,$BC,$CB,$AC,$22,$E6,$32,$EF,$17,$31,$94,$A2,$ED,$E7,$64,$9D,$BC,$EC,$AD,$B3,$B2,$DD,$84,$44,$47,$1B,$F5,$E5,$CF,$2E,$5C,$FC,$E3,$97,$9C,$7F,$3B,$CB,$1B,$B9,$5A,$17,$65,$7D,$AB,$75,$F6,$E1,$76,$20; 1024
		dc.b $8B,$88,$4D, $E,$60,$8F,$D5,$44,$44,$44,$44,$44,$44,$44,$75,$5B,$7F,$3B,$CB,$84,$B2,$F3,$95,$DF,$BC,$CB,$4F,$E6,$69,$FD,$CB,$BF,$D9,$C2,$FF,$F7,$E5,$FF,$FF,$EF,$87,$F7,$C1,$3F,$9E,$13,$7B,  5,$57,$2F,$EC,$D7,$F6,$6B,$FC,$35,$7D,$58,$4F,$85,$B3,$EB,$3E,$AF; 1088
		dc.b $2D,$5E,$5A,$BC,$B5,$79,$6B,$3E,$B3,$F6,$7F,$67,$88,$88,$8A,$C0,$31,$E0, $F,$5B,$6E,  4,$5A,$EE,  9,$96,$57,  5,$41,$2B,$82,$A5,$E0,$B3,$61,$C0,$21,$37,$A4,$7A,$7A,$A9,$77,$85,$40,$64,$E0,$99,$67,$E8,$98,$7E,$99,$C0,$F5,$74,$22,$D3,$E1,$17,$27,$8F,$49,$39; 1152
		dc.b $41,$82,$69,$C9,$C6,$A7,$3E,$C6,$4E,$9C,$9E,$59,$C6,$72,$9E,$2C,$73,$93,$D9,$D1,$3F,  4,$6D,$39,$78,$FD,$DB,$CB,$FE,$3F,$DB,$FF,$8C,$A7,$C4,$B1,$2C,$DA,$D2,$3D,$EE,$C4,$B3,$6D,$6C,$11,$11,$11,$F5,$8A,$CC,$B5,$82,$52,$FA,$20,$49,$38,$DF,$49,$83,$F6,$7C,$53; 1216
		dc.b $F8,$4E,$64,$C0,$BA,$B9,$5A,$78,$45,$95,$1D,$D5,$94,$A6,$67,$60,$5F,$D2,$B1,$D8,$6C,$70,$DB,$38,$B1,$37,$EA, $D,$E5,$FB,$A3,$B1,$FE,$F6,$4E,$1F,$B1,$B0,$13,$F9,$6F,$5F,$E0,$F7,$6F,$DD,$9C,$E4,$F2,$F7,$DF,$EE,$DF,$C8,$6E,$9D,$61,$1E,$91,$FD,$34,$5D,$FF,$A6; 1280
		dc.b $FF,$C8,$88,$8E,$DC,$CB,$32,$C4,$BD,$CA,$D2,$36,$81,$95,$66,$CE,$79,$95,$6D, $E,$AC,$65,$27,$3E,$3B,$CC,$A5,$FD,$92,$93,$C1,  2,$CA,$D2,$97,$A2,$D7,$4B,$F8,$A0,$57,$EA,$88,$12,$D9,$E0,$81,$27,$E6,$4B,$59,$3C,$96,$D3,$2D,$58,$F5,$32,$D4,$87,$B0,  0; 1344
Nem_EHZ_Piranha:dc.b $80,$16,$80,  3,  1,$14,  8,$24, $A,$35,$19,$45,$17,$56,$38,$68,$F8,$75,$1A,$81,  3,  0,$16,$3A,$82,  7,$78,$83,  7,$7A,$84,  4,  7,$18,$F6,$85,  6,$3B,$86,  5,$12,$87,  5,$13,$88,  4,  4,$89,  5,$18,$18,$FA,$8A,  7,$79,$8B,  4,  5,$8C,  6,$39,$8D,  5,$16; 0
					; DATA XREF: ROM:0001C1A0o
					; ROM:0001C268o
		dc.b $8E,  5,$1B,$8F,  4,  6,$18,$F7,$FF,$D6,$B5,$AF,$8B,$6B,$8B, $D,$5E,$C3,$5E,$B5,$71,$A2,$35,$95,  4,$65,$FE,$3C,$11,$B8,$FC,$EF,$45, $D,$BA,$A4,$B0,$BA,  3,$DA,$D2,$1E,$D2,$5E,$61,$3B,$D9,$42,$A5,$36,$26,$C5,$8A,$11,$1D,$14,$53,$D6,$DE,$BC,$FE,$79,$CF,$30; 64
		dc.b $3D,$8F,$29,$3F,$44,$56,$C8,$F4,$41,$E7,$F3,$C9,$8F,$54,$98,$4B,$F2,$5A,$6D,$CF,$EB,$46,$26,$B7, $C,$EB,$90,$C2,$E1,$8B,$AD,  6,$E0,$31, $E,$B0,$D3,$E1,$BE,$13,$5F,$A1,$7A,$C6,$F4,$5C,$AC,  2,$F7,$49,$F0,$C9,$6B,$FA,$69,$F9,$5C,$A6,$3F,$2F,$94, $D,$3C,$A0; 128
		dc.b $69,$E5,  3,$4C,$CA,$65,  3,$4C,$EC,$14, $D,$39,  6,$28,$DB,$2D,$E2,$45,$1B,$95,$F0,$F4,$9E,$7D,$88,$E6,$36,$7A,$29,$24,$DD,$7E,$85,$8B,$F4,$E3,$F3,$D1,$EC,$53,$E9,$AD, $B,$C9,$62,$96,$8B, $F,$D7,$49,$6A,$53,$5A,$94,$F6,$1E,$B7,$D5,$B2,$1B,$C3,$8C,$F8,$71; 192
		dc.b $9F, $E, $F,$74,$E0,$8C,$82, $A,$E4,$17,$C8,$2E,$B9,$F6,$5E,$17,$85,$D6,$B5, $B,$BB,$7E,$72,$9D,$24,$29,$44,$DC,$8C,$CC,$CA,$9E,$30,$F4,$13,$13,$7E,$3C,$9B,$40,$C4,$2D,$39,$75,$BB,$AF, $B,$C2,$E6,$5C,$48,$5E,$43,$80,$5A,$ED,$B4,$F7,$FC,$E5,$BB,$71,$F9,$3D; 256
		dc.b $11,$9F,$D0,$C7,$2B,$75,$22,$E0,$A9,$B5,$29,$B4,$5B,$93,$69,$E6,$7C,$C8,$CA,$25, $C,$18,$C8,$89,$19,$47,$45,$A1,$A9,$A1,$37,$82,$C7,$AF,$A4,$60,$9F,$54,$98,$E3,$F5,$D2,$B8,$29,$2B,$8B,$F7,$EC,$12,$51,$FA,$67,$29,$5C,$D9,$7B,$11,$C8,$85,$7F,$85,$89,$E3,$80; 320
		dc.b $D8,$E0,$36,$38, $D,$8A,$68, $D,$88,$1E,$E4,$34,$61,  7,$BE,$F3,$84,$1C,$2C,$FB,$FC,$E5,$3A,$48,$52,$89,$B9,$10,$E8,$C6,$50,$A0,$8C,$3D,$7E,$60,$CD,$E1,$C8,$3E,$4D,$88,$4A,$58,$E8,$BA,$DD,$D6,$EE,$B4,$85,$D6,$A7,$C2,$6C,$15,$BE,$2E,$98,$D1,$F7,$FC,$E7,$EB; 384
		dc.b $47,$E4,$F4,$46,$7F,$43,$A8,$E5,$6E,$A4,$1B,$50,$2B,$16,$E4,$A9,$B5,$4B,$9B,$4E,$A7,$18,$18,$33,$6D,$A0,$60,$9B,$14,$33,$FF,$9D,$6B,$8F,$DF,$4B,$3D,$14,$95,$C6,$7B,$FD,$20,$49,$1F,$D3,$2B,$84,$8E,$6C,$55,$C1,$E4,$52,$BF,$C2,$9F,$CB,$F1,$EF,$F9,$7B,$8D,$B4; 448
		dc.b $F8, $D,$38,$FD,$49,$1B,$BF,$D6,$B1,$A8,  0,  0; 512
Nem_BossShip:	dc.b $80,$60,$80,  3,  0,$14,  4,$25, $F,$35,$13,$46,$31,$56,$32,$66,$34,$74,  2,$81,  4,  3,$15,$16,$38,$F2,$82,  6,$2E,$17,$77,$83,  6,$30,$17,$6E,$84,  7,$72,$85,  7,$73,$86,  5,$11,$17,$78,$87,  5,$10,$17,$6F,$88,  5,$15,$17,$75,$89,  4,  5,$16,$38,$28,$F7; 0
					; DATA XREF: ROM:0001C278o
					; ROM:0001C28Ao
		dc.b $8A,  5,$14,$8B,  5,$12,$17,$74,$8C,  5, $E,$16,$33,$28,$F3,$38,$F6,$8D,  6,$36,$17,$7A,$8E,  6,$2F,$17,$76,$8F,  4,  6,$16,$35,$FF,$7F,$14,$AC,$34,$64,$54,$C2,$D3,$C3,$F4,$2F,$C2,$E1,$AB,$EE, $C,$F5,$30,$C4,$4F,$5C,  3,$3C,$DF,$FA,$60,$68,$BF,$AB,$BC,$92; 64
		dc.b $E4,$BB,$2B,$85,$CF,$BA,$78,$76,$DA,$2F,$C0,$6A,$35,$1D,$AD,$D9,$83,$6C,$7F,$AE,$3B,$96,$4C,$2D,$7E,$1C,  3,$43,$BE,$E6,$7D,$86,$16,  6,$35,$37,$5B,$57,$E0,$19,$F7,$A3,$4E,$1A,$2E,$97,$E9, $D,$17,$4B,$D0,$EE,$5B,$83,$AE, $B,$82,$5D,$3E,$B3,$C0,$1D,$70,$7E; 128
		dc.b   8,$75,$FD,$1C,$CC,$96,$BA,$1D,$74,$35,$22,$22,$22,$2F,$E4,$1D,$56,$E9,$AA,$4A,$E7,$F7,$EB,$2F,$D1,  9,$25,$7A, $E,$95,$4A,$8E,$98,$4F,$AE,  4,$3F,$F1,$FF,$12,$22,$22,$21,$BE,$96,$EB,$4D,$A3,$25,$8A,$5D,$2E,$35,$7A,$8D,$67,$A9,$33,$F5,$9E,$A8,$63,$53,$48; 192
		dc.b $8F,$2F,$10,$C7,$79,$BC,$C1,$C2,$33,$F1,  5,$43,$1B,$EF,$B8,$1A,$76,$C5,$A6,$61,$87,$E8,$86,$BD,$F1,$B9,$FF,$A3,$5F,$DD,$FE,$A0,$BF,$51,$A5,$71,$EB,$A7,$E8,$66,$6F,$32,$B1,$19,$11,$11,$7E,$A8,$FF,$55,$57,$F4,$DC,$73,$95,$52,$E9,$F5,$4E,$E9,$84,$86,$B7, $F; 256
		dc.b $D1,$18,$61,$77,$EF,$E3,$DD,$A7,$2B,$87,$F0,$51,$B4,$3C,$6E,$6F,$21, $C,$8E,$39,$1A,$7F,$3E, $D,$92,$DC,$3F,$A4,$2E,$CB, $F,$F5,$D4,$88,$88,$88,$8C,$AC,$5E,$44,$64,$55,$FF,$3D,$DF,$DD,$6C,$31,$B9,$30,$9D,$CF,$C1,$F7, $F,$D0,$DC,$97, $D,$55,$A5,  9,$2A,$2C; 320
		dc.b $79,$39,$22,$14,$72,$47,$45,$87,$EA,$16,  1,$53,$77,$74,$AE,$E1,$DE,$29,$B8,$77,$7E,$E1,$DD,$FB,$87,$77,$EE,$1D,$D2,$B2,$AC,$96,$43,$F7,$1F,$AB,$1F,$B8,$FD,$59,$11,$11,$11,$11,$17,$FC,$48,$BF,$8D,$BE,$96,$16,$D4,$33,$DA,$6C,$64,$4F,$B8,$2F,$2E,$9C,$4A, $E; 384
		dc.b $4D,$91,$CF,$D9,$1C,$9C,$E5,$E1,$61,$CE,$18,$F7,$CB,$BE,$5D,$F2,$EF,$97,$79,$63,$74,$A0,$BF,$A6,$59,$44,$F8,$F0,$9E,$38,$F1,$58,$AC,$9F,$2B,$33,$EA,$18,$C5,$D3,$D4,$1B,$F0,$EF,$B5,$52,$A3,$F4,$75,$7F,$F2, $B,$2B,$4E,$C9,$E4,$44,$53,$A5,$A9,$5F,$10,$C2,$A2; 448
		dc.b $EB,$F3,$DB,  0,$B7,$BB,$F4,$72,$3B,$DD,$80,$EA,$8E,$C0,$54,$72,$92,$CB,$A8,$E4,$E8,$39,$FC,$83,$83,$93,$92,$72,$72,$72,$4E,$43,$A5,$7C,$FA,$8D,$D9,$6E,$9E,  3,$73,$F0,$D8,$6E,$4C,$36,$3D,$7C,$DA,$EF,$E9,$DD,$85,$D6,$F3,$D9,$DB,$78,$FF,$DF,$EA, $A,$A9,$84; 512
		dc.b $BF,$50,$87,$57,$D7,$1F,$DC,$18,$FD,$C0,$34,$EA,$2D,$3B,$62,$64,$44,$45,$A4, $E,$B4,$37,$EC,$2E,$91,$BF,  1,$2C,$7F,$51,$8D,$4B,$4F,$D4,$69,$CB,$2E,$59,$54,$B5,$97,$37,$E1,$EA,$E1,$CD,$1C,$6C,$18,$73,$4B,$DE,$C9,$87,$EB,$75,$4C,$3F,$A5,  7,$7F,$B7,$FD,$74; 576
		dc.b $FD,$C4,$EA,$FA,$83,  7,$FB,$83,$7F,$91,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$16,$9F,$B8,$4E,$AD,$7E,$A2,$AD,$79,$83,$15, $D,$D9,$BB,$7F,$21,$6A,$A4,$44,$44,$44,$44,$45,$EF,$8F,$E8,$78,$7B,$25,$95,$2F,$1F,$A1,$1C,  3,$1F,$C9,$B0,$59,$B0,$30,$B3,$60,$61; 640
		dc.b $66,$C0,$C2,$92,$B2,$30,$34,$52,$69,$9A,$29,$11,$14,$CF,$16,$30,$73,$BC,$57,$F4,$3B,$F8,$35,$22,$22,$25,$22,$52,$9D,$60,$FE,$A6,$C6,$95, $D,  8,$DE, $C,$35,$B8,$30,$D6,$67,$B5,$98,$29,$A8,$36, $A,$60,$F7,$F5,$32,$22,$22,$22,$22,$22,$11,$CB,$C1,$62,$AD,$59; 704
		dc.b $A8,$AE,$3C,$1D,$48,$88,$A7,$FB,$87,$D5,$BD,$DF,$7C,$4F,$34,$8C,$14,$6C,$9E,$16,$A9,$B7,$8A,$AB,$FC,$21,$A4,$52,$AA,$91,$4A,$83,$11,$7D,$B8,$7D,$34,$A7,$EE,$7F,$6C,$44,$44,$44,$44,$45,$A4,$72,$F0,$58,$AB,$56,$6A,$2B,$8F,  7,$52,$22,$29,$FE,$E1,$F5,$6F,$77; 768
		dc.b $DF,$1F,$34,$8C,$17,$CC,$78,$5A,$9E,$7E,$2A,$A8,$E9,$45, $D,$20,$95,$54,$8A,$54,$18,$8B,$ED,$C3,$E5,$A4,$BF,$73,$FB,$62,$CB,$A6,$32,  7,$3D,$81,$8D,$FE,$93,  1,$16,$FC,$D4,$DC,$B1,$6A,$4F,$7A,$B6,$E8,$C9,$20,$A2,$E9,$C9,$FB,$25,$24,$18,$28,$FC,$D6,$3F,$9A; 832
		dc.b  $D,  6,$4A, $D,$6F,$45, $D,$D8,$7B,$C5,$61,$D6,$D5,$FE,$5C,$FC,$BA,$58,$66,$2D,$42,$DD,$9B,$E3,$8E,$F9,$EF,$7E,$1C,$A1,$8C,$8B,$FD,$83,$F5,$DE,$C2,$F1,$76,$57,$63,$C3,$AD,$8A,$A5,$85,$54,$4A,$92,$A4,$8F,$88,$C2,$3B,$F8,$C9,$74,$A6,$91,$FE,$E1,$33,$FD,$99; 896
		dc.b $FE,$61,$C9,$ED,$B1,$E7,$FB,$D4,$F5,$33,$2B,$4C,$F2,$FD, $A,$58,$1B,$E5,$4F,$D5,$FE,$53,$9C,$23,  6,$3F,$D7,$BD,$60,$7A,$40,$F4,$81,$7F,$7D, $D,$BC,$B5,$AB,$BB,$64,$E1,$78,$30,$C6,$1C,$2F,  7,$37,$4C,$DE,$EB,$C8,$89,$3F,$9A,$6D,$79,$65,$D3,$19,  3,$9E,$C0; 960
		dc.b $C6,$FF,$49,$80,$8B,$7E,$6A,$6E,$58,$B5,$27,$BD,$5B,$74,$64,$90,$51,$74,$E4,$FD,$92,$92, $C,$14,$7E,$6B,$1F,$CD,  6,$83,$25,  6,$B7,$A2,$86,$EC,$3D,$E2,$B0,$EB,$6A,$FF,$2E,$7E,$5D,$2C,$33,$16,$A1,$6E,$CD,$F1,$C7,$7C,$F7,$BF, $E,$50,$C6,$45,$FE,$C1,$FA,$EF; 1024
		dc.b $61,$78,$BB,$2B,$B1,$E1,$D6,$C5,$52,$C2,$AA,$25,$49,$52,$47,$C4,$61,$1D,$FC,$64,$B8,$B8,$50,$7B,$24,$5D,$37,$4F,$CC,$33,$FC,$C3,$3F,$CC,$38,$67,$FB,$D3,$77,$AC,$76,$C4,$CA,$D3,$3C,$BF,$42,$96,  6,$F9,$53,$F5,$7F,$94,$E7,  8,$C1,$8F,$F5,$EF,$58,$1E,$90,$3D; 1088
		dc.b $20,$5F,$DF,$43,$6F,$2D,$6A,$EE,$D9,$38,$5E, $C,$31,$87, $B,$C1,$CD,$D3,$37,$BA,$F2,$22,$4F,$E6,$9B,$5E,$5A,$48,$B2,$91,$EF,$FD,$6B,$E2,$DF,$9A,$1B,$23,$96,$2D,$41,$18,$3B,$7A,$B7,$34,$82,$41,$47,$39,$C9,$EE,$48,$48,$30,$51,$28,$63,$D0,$34,$19,$24,$35,$BD; 1152
		dc.b $14,$37,$61,$EF,$15,$76,$EA,$1D,$7A,$79,$74,$B0,$CC,$58,$A5,$BB,$3D,$D2,$21,$D5,$3A,$8C,$E8,$23,$4C,$D2,$91,$14,$7B,$87,$A0,$E0,$EA,$FE,$DE,$AE,$18,$4F, $A,  3,$F6,$3E,$62,$9E,$5C,$C7,$14,$E7, $E,$56,$45,$B8,$60,$30,$AA,$89,$52,$4B,$43,$E2,$30,$8E,$FA,$2E; 1216
		dc.b $47,$42,$27,$E6,$FF,$34,$68,$47,$1C,  8,$9D,$8E,$6D,$FD,$CD,$87,$F3,$41,$DC,$53,$32,$B5,$25,$4E,$9C,$FF,$29,  8,$C1,$8F,$F5,$EF,$58,$1E,$90,$3D,$20,$5F,$DF,$43,$6F,$2D,$6A,$EE,$D9,$38,$5E, $C,$36,$69,$78,$31,$EB,$32,$75,$E9,$62,$2C,$BF,$9A,$6D,$79,$69,$22; 1280
		dc.b $CA,$47,$BF,$F5,$AF,$8B,$7E,$68,$6C,$8E,$58,$B5,  4,$60,$ED,$EA,$DC,$D2,  9,  5,$1C,$E7,$27,$B9,$21,$20,$C1,$44,$A1,$8F,$40,$D0,$64,$90,$D6,$F4,$50,$DD,$87,$BC,$55,$DB,$A8,$75,$E9,$E5,$D2,$C3,$31,$62,$96,$EC,$F7,$48,$87,$54,$EA,$33,$A0,$8D,$33,$4A,$44,$51; 1344
		dc.b $EE,$1E,$83,$83,$BF,$AE,$E1,$D9,$3B,$50,$6E,$F5,$76,$1C,$C5,$1E,$7C,$C7,$14,$E7, $E,$56,$45,$B8,$60,$30,$AA,$89,$52,$4B,$43,$E2,$30,$8E,$FA,$2E,$47,$42,$9E,$6F,$F3,$7C,$5D,$8C,  8,$B1,$F3,$7F,$B3,$79,$FA,  6,$3F,$5A,$F3,$B8,$A6,$65,$6A,$4A,$9D,$39,$FE,$52; 1408
		dc.b $11,$83,$1F,$EB,$DE,$B0,$3D,$20,$63,$D9,$20,$4C,$F7,$32,$18,$CE,$F3,$D6,$A3,$3C,$5D,$DD, $C,$33,$AF,$99,$83,$75,$FA,$3A,$F9,$9A,$3A,$F2,$D1,$D7,$CF,$F5,$A6,$D7,$B8,$6C,$5B,$3E,$46,$E4,$D8,$B6,$91,$C2,$2E,$7C,$44,$5A,$34,$7C,$1C,$B1,$6A,$3D,$DB,$D5,$B9,$A4; 1472
		dc.b $12, $A,$39,$CE,$4F,$72,$42,$41,$82,$89,$43,$1E,$81,$A0,$C9,$21,$AD,$E8,$A1,$BB, $F,$78,$AB,$B7,$50,$EB,$D3,$CB,$A5,$86,$62,$C5,$2D,$D9,$EE,$91, $E,$A9,$D4,$67,$41,$1A,$66,$94,$88,$A3,$DC,$3D,  7,  7,  8,$EF,$88,$70,$81,$A1,$C2,$83,$FA,$29,$1F,$E6,$73,$E2; 1536
		dc.b $9F,$A7,$E4,$68,$B3,$C2,$AA,$25,$49,$2D, $F,$88,$C2,$92,$85,$15,$1C,$1C, $E,$81,$C1,$D3,$76,$51,$4F,$68,$3D,$C4,$48,$ED,$3D,$B1,$6F,$5F,$CC,$7F,$EB,$73,$B8,$A6,$65,$6A,$4A,$9D,$39,$FE,$52,$11,$83,$1F,$EB,$DE,$B0,$3D,$20,$63,$F9,$82,$18,$B9,$19,$EE,$64,$31; 1600
		dc.b $9D,$E7,$AD,$5C,$1D,$8B,$83,$AF,  6,$18,$66,$2F,  6,$3D,$A7,$E9,$C1,$D7,$A5,$88,$B2,$D9,$DF,$AD,$36,$BE,$67,$89,$CC,$DE,$64,$2C,$E8,$47,$28,$B4,$67,$9A,$C5,$62,$F7,$6F,$56,$54,$82,$41,$42,$CE,$59,$42,$41,$82,$89,$43,$1E,$81,$A0,$C9,$21,$AD,$E8,$A1,$BB, $F; 1664
		dc.b $78,$AC,$78,  7,$5B,$7B,$5B,$31,$E0,$66,$5C,$BF,$2B,$E3,$F2,$BC,$81,$CC,$DE,$68,$69,$D7,$94,$4F,$95,$79,$23,$A0,$1C,$1C,$FF,$53,$8F,$ED,$E2,$22,$73,$38,$9E,$90,$FE,$EB,$97, $A,$7E,$98,$72,$45,$7F,$2B,$AA,$A2,$92,$A2,$C8,$F8,$8C,$29,$BC,$2E,$4E,$7E,$65,$3F; 1728
		dc.b $37,$FB,$26,$A1,$D3,$B6,$2E,$BA,$F9,$B9,$1C,$F7,$4D,$B3,$3C,$8C,$59,$30,$39,$D8,$8E,$66,$94,$95,$3A,$73,$FC,$A4,$23,  6,$3F,$D7,$BD,$60,$7A,$40,$F4,$81,$7F,$7D,$3F,$A3,$AD,$7B,$64,$E1,$D8,$18,$61,$98,$BC,$1C,$DD,$3B,$23,$AF,$79,$E4,$65,$A0; 1792
Nem_CPZ_ProtoBoss:dc.b $80,$6F,$80,  4,	 5,$14,	 8,$24,	 7,$35,$18,$46,$2F,$55,$16,$66,$33,$72,	 0,$81,	 4,  6,$17,$6B,$82,  7,$70,$83,	 6,$34,$18,$EF,$84,  7,$73,$85,	 7,$72,$86,  5,$14,$18,$F3,$87,	 6,$36,$18,$F4,$27,$76,$88,  4,	 4,$15,$13,$27,$74,$68,$EE,$77,$75,$89,	 5,$12;	0
					; DATA XREF: ROM:0001C290o
		dc.b $17,$6A,$8A,  8,$F1,$8B,  7,$6F,$18,$F2,$8C,  7,$71,$18,$F6,$8D,  6,$32,$18,$F7,$8E,  6,$2E,$18,$F0,$8F,  5,$15,$17,$6E,$28,$F5,$FF,  0,$2D,$AA,$F9,$6E,$C4,$AE,$BE,$4C,$BA,$F1,$C3,$D6,$FF,$D1,$63,$F6,$6F,$FC,$90,  0,$3F,$F3,$FC,$E6,$BB,$5A,$FA,$AD,$78,$35; 64
		dc.b $63,$F4,$4B,$55,$E0,$DF,$B3,$FC,$96,$9F,$C9,$3B,$ED,$FA,$90,  0,$2F,$FF,$CF,$FC,$7F,$E4,$7F,$CF,$FF,$20,  0,  1,$FA,$9B,$DB,$BF,$53,$FE,$89,$B4,$93,$F0,$5A,$AE,$92,$7E,$15,$E0,$BA,$4B,$48,$AE,$75,  3,$12,$F2,$D5,$E5,$AB,$7C,$B6,$D5,$BF,$57,$8A,$52,$7E,$36; 128
		dc.b $D5,$76,$25,$E0,$CF,$26,$DC,$C4,$49,$7F,$43,$72,$CB,$F4,$7E, $B,$25,$FD,$1F,$84,$7E,$FB,$D5,$7F,$DD,$AD,$52,$2E,$5D,$CC,$F5,$5D,$CC,$EC,$BA,$D3,$34,$BF,$A3,$DC,$BF,$B8,$8A,$AA,$5E,$CA,$DF,$B8,$FD,$4A,$EB,$E9,$E4,$3C,$88,$D2,$F9,$46,$9F,$C9,$7F,$E7,$DD,$AE; 192
		dc.b $F6,$DD,$AE,$35,$EE, $A,$E6,$D9,$A3,$46,$BD,$CA,$D1,$AF,$76,$2E,$6B,$5D,$57,$BB,$75,$CB,$AD,$6E,$DD,$E1,$AC,  0,$91,$9F, $A,$EB,$DD,$F9,$25,$E1,$5B,$FB,$DA,$ED,$7D,$F8,$FD,$CE,$B5,$D3,$51,$28,$E1,$FA,$38,$90,  5,$7F,$25,$A2,$FE,$86,$BF,$92,$D1,$7F,$42,$BA; 256
		dc.b $71,$84,$68,$D2,$B0,$92,$56,$D1,$53,$44,$54,$6E,$F4,$D3,$A0,  0,$1C,$3B,$D7,$47,$D2,$D2,$BF,$52,$C9,$7F,$47,$FA,$A5,$97,$F6,$D7,$57,$A6,$AD,$F1,$C3,$5A,$F0,$D0,$23,$4F,$3A,$8F,$24,$8A,$64,$F3,$8A,$22,$CB,$BF,$F5,$70,$9F,$B2,$C5,$7C,$2B,$C1,$EB,$E1,$5E,$10; 320
		dc.b $D2,$FD,$12,$A4,$37,$EC,$D7,$F3,$5F,$D9,$F2,$95,$FE,$4D,$7F,$78,  6,$73,$D4,$F3,$F0,$69,$42,$5C,$D0,$92,$76,$B7,$AE,$A7,$FC,$96,$A6,$84,$F2,$93,$2C,$95,$15,$19,$65,$17,$6D,$EB,$FA,$65,$BB,$5D,$BD,$1A,$19,$50,  0,$2C,$DF,$A6,$68,$D7,$E0,$CE,$C1,$76,$BB,$BD; 384
		dc.b $6E,$EB,$B7,$E8,$69,$E9,$40,$1A,$96,$AA,$FA,$61,$2E,$FD, $C,$32,$B7,$F3,$F6,$A5,$6E,$DD,$75,$68,$D4,$DB,$CF,$6A,$7A,  0,  1,$9F,$9F,$69,$EC,$D7,$7A,$C5,$42,$EF,$F0,$F5,$FF,$88,  1,$FF,$7F,$FB,$7F,$1B,$55,$3D,$17,$6A,$A2,$D6,$3D,$3A,$3F,$69,$BF,$69,$BF,$69; 448
		dc.b $BF,$69,$BF,$69,$BF,$69,$BF,$69,$AE,$D4,$6A,$36,$CE,$CF,$77,$E4,$83,$C3,$D5,$7B,$FA,$FE,$86,$9A,$E4,$91,$DA,$FE,$C9,$8E,$C9,$8E,$C9,$8E,$D7,$47,$A2,$EC,$D7,$37,$1F,$DB,$6D,$24,$E5,$FE,$10,  0,  1,$7A,$5F,$FA,$29,  6,$3F,$47,$7F,$49,$63,$F4,$20,  0,  5,$E8; 512
		dc.b $DD,$1A,$75,$A4,$AE,$AD,$25,$76,$E5,$6D,$CB,$73,$49,$2E,$69,$23,$49,$BF,$52,$DA,$80,$46,$E8,$D3,$AD,$25,$75,$69,$2B,$B7,$2B,$6E,$5B,$9A,$49,$73,$49,$1A,$4D,$FA,$96,$D4,  2,$37,$46,$9D,$69,$2B,$AB,$49,$5D,$B9,$5B,$72,$DC,$D2,$4B,$9A,$48,$D2,$6F,$D4,$B6,$A2; 576
		dc.b $5E,$34,$97,$8A,$6C,$C1,$2D,$FB,$26,$F9,$51,$A5,$BF,$64,$DF,$2A,$30,$4B,$7E,$C9,$BE,$54,$65,$FE,$8C,$AD,$2D,$2D,$2D,$33,$96,$72,$B4,$9A,$D2,$6C,$E5,$E3,$49,$78,$A6,$CC,$BC,$63,$45,$AD,$1B,$8C,$68,$B5,$A3,$6F,$D9,$37,$CA,$8C,$B2,$D9,$37,$CA,$8C,$B7,$46,$9C; 640
		dc.b $2B,$46,$BA,$34,$E1,$5A,$34,$B6,$4D,$F2,$A3,$2F,$F0,$53,$F3,$58,$96,$8B,$C4,$C4,$BC,$B6,$C4,$BC,$B6,$31,$2E,$FE,$37,$EA,$DF,$49,$78,$CF,$6D,$75,$5D,$38,$2D,$68,$D1,$A2,$F0,$79,$FE,$AE,$54,$69,$EF,$FD,$4D,$18,$AB,$D6,$54,$6D,$93,$7C,$A9,$AD,$5B,$DB,$25,$F6; 704
		dc.b $A0,$BE,$FC,$5B,$DA,$80,  7,$9F,$B6,$5C,$7D,$CF,$3F,$6C,$B8,$FB,$80,$1F,$E5,$17,$FC,$A0,  0,$19,$FB,$16,$E2,$D9,$E4,$62,$9F,$AC,$8F,$38,$D7,$E6,$BE,$52,$9F,$8A,$E9,$37,$6D,$2C,$99,$FF,$D4,$FD,$66,$FC,$9D,$B5,$2A,$65,  8,$BE,$16,$BA,$10,$23,$FA,$A0,$BC,$6D; 768
		dc.b $C6,$D4,$F1,$6C,$51,$77,$98,$A2,$EF,$BF,$F3,$56,$D5,$D3,$8F,$BA,$2A,$43,$5F,$3C,$5C,$67,$40,$7E,$BF,$F5,$E5,$9A,$72,$33,$4E,$41,$7C,$ED,$FA,$55,$F7,$FC,$AB,$E4,$C9,$7B,$4A,$FE,$39,$EB,$FD,$A3,$F1,$B6,$5F,$C1,$11,$BF,$2B,$93,$E4,$BC,$D5,$39,$65,$1F,$94,$74; 832
		dc.b $CB,$34,$FF,$A6,$7F,$F1,$31,$FA,$DF,$CA,$C6,$4B,$37,$E2,$C9,$8E,$2B,$22,$FD,$65,$BD,$BF,$A9,$45,$FC,$A7,$EC,$6A,$FC,$9E,$5C,$DF,$94,$73,$2F,$E4, $B,$FE,$45,$FF,$4C,$EF,$9A,$CD,$67,$7A,  0,$63,$AC,$F1,$32,$12,$10,$BE,$61,$8F,$EC,$44,$E2,$60,$E9,  8,$18,$48; 896
		dc.b $4C,$24,$26,$12,$10,$C2,$42,  3,$A6,$10,  8,$4C,$20,$E9,  9,$7C,$C2,$D3,$B4,$CB,$4E,$D3,$2D,$3B,$D2,$11,$D3,  8,$A9,$64,$12,$C8,$2A,$61,$1F,$F7,  6,$3F,$70,$E9,$84,$54,$B2,  0,$96,$45,$4C,$23,$FE,$E0, $B,$50,$CD,$96,$97,$B1,$45,$A6,$6C,$F4,$86,$B3,$59,$96; 960
		dc.b $B6,$AD,$EC,$15,$8A,$8F,$51,$EB,$9D,$40,$1D,  0,$41,  4,$10, $C,$53,$3A,$5A,$97,$D1,$69,$9D, $C,$51,$76,$B3,$45,$22,$8E,$CB,$E6,$30,$CB,$B9,$B3,$AB,$3D,$70,$D5,$BE,$B1,$5B,$EA,$2D,$4C,$EA,$16,$AE,$75,  0,$12,$C8,$BF,$D8,  7,$A0,$B4,$C5,$22,$97,$B2,$D0,$1E; 1024
		dc.b $8C,$2D,$30,$C1,$55,$6C,$54,$5D,$C0,$5C,  0,$19,$A0,$59,$2C,$96,$4B,$20,$A8,$61,$1D,  1,  5,$4B,$23,$A0,  1,$7E,$4B,$FB,$82,$71,$D1,$F9, $E,$96,$47,$48,$47,$9D,$F3,$BE,$77,$CE,$C8,$18,$40,$74,$2C,$8E,$8A,$8F,$37,$40,$B7,$BB,$FE,$B6,$32,$5C,$B1,$CD,$F9,$BF; 1088
		dc.b $37,$E7,$8C,$97,$27,$E5,$93,$FE,$B5,$50,$10,$41,  1,  9,$90,$83,$A0,$59,$22,$64,$25,$90,$C6,$46,$41,$9E,$56,$C8,  0, $C,$FF,$B0, $A,$97,$A0,$B9,$17,$CE,$3A,$3F,$21,$D2,$C8,$E9,  8,$F3,$BE,$77,$CE,$F9,$D9,  4,$74,$59,$AF,$45,$4C,$FD,$DF,$F5,$B1,$92,$E5,$8E; 1152
		dc.b $6F,$CD,$F9,$BF,$3C,$64,$B9,$3F,$2C,$9F,$F5,$AA,$80,$82,  8,  9,  9,$7C,$EF,$47,$47,$48,$C9,$52,$11,$F2,$54,$11,$50,$8C,$AD,$90,$59,  0, $E,$A0,  0,$21,$7A,$42,$42,$2A,$10,$8B,$3C,$4C,$59,$E6,$91,$FC,$80,  8,$E5,$7C,$ED,$38,$E8,$FC,$95,  9,$90,$96,$9D,$F3; 1216
		dc.b $BE,$77,$CE,$C8,$1F,$C8,$59,$DF,$CB,$27,$FD,$6C,$64,$B9,$63,$9B,$F3,$7E,$6F,$CF,$19,$2E,$4F,$CB,$27,$FD,$6A,$A0,$82,  8,  8,$13,$26,$25,$F9,$42,$1F,$B8,$32,  0,  0,$CF,$A8,  4,$C2,$64,$C4,$10,  0,$EA,  0,$2F,$70,$BD,$C0,  7,$53,$A8,  1,$DC,$2F,$70,$11,$DC; 1280
		dc.b   2,$F7,  1,$D4, $E,$A0,$77,  0,$BD,$C4,$77,  0, $B,$DC,$75,  0,$3A,$9D,$C0,  2,$A5,$90,  0,  4,  0,  0,$B2,  0,  0,  0; 1344
Nem_BigExplosion:dc.b	0,$64,$80,  4,	5,$15,$12,$25,$15,$35,$18,$46,$35,$57,$6E,$68,$F6,$75,$13,$86,	6,$36,$17,$73,$27,$78,$37,$76,$48,$F7,$57,$7A,$76,$34,$8A,  6,$33,$17,$75,$8C,	3,  0,$14,  6,$25,$16,$37,$72,$8D,  3,	1,$14,	7,$26,$32,$36,$38,$47,$6F,$57,$77,$8E,	4,  8; 0
		dc.b $15,$17,$27,$79,$8F,  4,  4,$15,$14,$27,$74,$FF,$D6,$98,$84,$8E,$72,$BF,$65,$4F,$49,$FE,$64,$FF,$32,$7F,$99,$3F,$CC,$91,$E9,$23,$D2,$47,$AA,$47,$BA,$A7,$9F,$12,$4F,$E7,$56,$9E,$75,$FD,$FF,$B6,$D4,$BD,$76,$8E,$74,$97,$BA,$2C,$7B,$C2,$47,$A8,$5F,$50,$BE,$A1; 64
		dc.b $7D,$42,$FA,$84,$F7,$BA,$7B,$C2,$2F,$6B,$A2,$FF,$39,$25,$E6,$95,$A4,$E7,$39,$CE,$73,$C4,$67,$AF,$5D,$B1,$DA,$BE,$F2,$F5,$2F,$52,$CF,$DE,$51,$EF,$28,$CF,$B4,$A3,$AF,$89,$5F,$B5,$63,$B4,$82,$76,$50,$91,$D9,$52,$33,$EC,$A2,$3A,$F8,$92,$75,$DA,$36,$92,$79,$EB; 128
		dc.b $2A,$46,$77,$90,$A4,$24,$4A,$D4,$8A,$DA,$9B,$82,$7B,  9,$CE,$6B,$13,$C4,$63,$F7,$57,$5F,$5D,$7D,$67,$A6,$9A,$69,$A6,$9A,$69,$A6,$9A,$69,$A6,$9A,$69,$A6,$9A,$7F,$9A,$3F,$CD,$1D,$63,$3D,$A3,$6A,$42,$7E,$FB,$92,$42,$42,$F2,$E9,$8E,$53,$C6,$DA,$ED,$9A,$ED,$D6; 192
		dc.b $17,$9E,$7E,$23,$4C,$FD,$67,$1A,$69,$A6,$9A,$69,$A6,$9A,$69,$A6,$9A,$69,$A6,$9A,$69,$A6,$9A,$6D,$9E,$DD,$79,$E7,$1F,$AA,$FF,$F4,$2A,$47,$4F,$E6,$23,$4E,$75,$CF,$DB,$6C,$F7,$6D,$9E,$ED,$AF,$AF,$8C,$F1,$E2,$31,$E3,$38,$AF,$8E,$B5,$ED,$15,$ED,$D6,$5E,$3F,$55; 256
		dc.b $2E,$DD,$65,$DB,$38,$97,$6B,$85,$E7,$9C,$74,$5E,$C8,$11,$7D,$D0,$27,$A4,$1E,$F0,$8B,$EF,  8,$BD,$AE,$8B,$DA,$12,$5E,$3A,$A4,$BB,$52,$5E,$21,  4,$B3,$BD,$2B,$14,$6A,$A3,$6A,$27,$39,$CF,$72,$6A,$90,$30,$D1,$B5,$50,$5D,$17,$94,$78,$E5,$4F,$EE,$24,$7F,$72,$2C; 320
		dc.b $9F,$EC,$4B,$50,$AA,$67,$D0,$1A,$6D,$9A,  7,$4C,$F6,$CE,  2,  4,$E7,$9D,$FA,$78,$CE,$10,$53,$B5,$16,$9C,$FA,$D9,  7,$3B,$DB,$B4,  3,$EF,  0,$8C,$F9,$DD,$48,$CE,$39,$C2,$90,$9F,$BE,$91,  9,$74,$90,$34,$84,$AB,$74,$D4,$53,$70,$33,$9C,$E7,$4B,$E7,$58,$E7,$D7; 384
		dc.b $CF,$3C,$FB,$46,$DD,$52,$3D,$20,$F2,$DC,$D2,$13,$98,$46,$FD,$52,$33,$8E,$A0,$82,$C7,$63,$FD,$CC,$D9,$F9,$6F,$64, $E,$8D,  8,$C5,$A9,$1C,$A9,$19,$F2,$48,$CF,$64,$B2,$47,$3B,$25,$F3,$8B,$52,$FF,$DC,$A0,$8F,$EE,$51,$9E,$C8,$11,$DA,$96,$2D,$41,$93,$74,$71,$40; 448
		dc.b $81,$1D,$90,$16,$7F,$F6,$65,$86,$79,$CE,$6B,$FB,$E0,$8B,$7E,$D0,$3D,$FC,$A6,$DF,$DE,$F1,$D5,$92,$3A,$ED, $C,$99,$F8,$8D,$39,$8F,$F3,  8,$ED,$68,$E7,$62,$22,$83,$21,$74,$6C,$B3,$DA,$10,$10,$79,$C5,$2D,$B7,$58,$41,  2,$3F,$54,$20,$25,$FA,$FE,$F9,$2F,$D6,$33; 512
		dc.b $81,$7E,$B1,$9E,$CD,$1F,$AA,$DA,$12,$F9,$ED,$D7,$CF,$8C,$FC,$8E,$79,$DC,$46,$63,$3F,$21,$2E,$11,$91,$90,$25,$9E,$83,$20,$6D,$39,$CE,$75,$1E,$CC,$9A,$A3,$26,$11,$90,$57,$F7,$ED,$24,$FE,$64,$9A,$80,$C8,$74, $E,$B6,$36,$53,$6A,$33,$8F,$DF,$87,$1D,  1,$E4,$83; 576
		dc.b $7D,$A4,$11,$9E,$56,$47,$94,$32,$11,$28,$14,$69,$40,$4B,$4A,$28,$1E,$50,$8C,$6A,$10,$1C,$58,$E2,$83,$56,$33,$9C,$E7,$39,$E0,$EB,$96,$38,$95,$9C,$2F,$27,$4E,$4E,$10,$10,$EC,$8B,$C0,$48,$5E,$12,$F6,$7E,$96,$36,$46,$53,$C9,$5D,$AE,$15,$C5,$F6, $A,$42,$47,$38; 640
		dc.b $51,$48,$DA,$EA,$13,$C8,$2A,$C9, $C,$64,$29,  0,$AB,$25,$DD,$4B,$26,$4A,$E1,$32,$5E,$E2,$5C,$35,$47,$1A,$BC,$CD,$7F,$99,$8E,$53,$9F,$FF,$5F,$F9,$8F,$D2,$13,$F9,$89,$74,$FE,$62,$6D,$14,$B2,$73,$F2,$90,$9C,$EF,$CE,$FE,$28,$3F,$7D,$46,$A5,$EC,$9F,$BE,$64,$BF; 704
		dc.b $38,$64,$8F,$10,$42,$47,$38,  5,$93,$CB,$16,$48,$B1,$6A,$32,$3F,$2B,$F0,$D7,$70,$90,$2E,$E1,$3C,$A5,$92,$F4,  8,$29,$14,  6,$D4, $F,$FE,$C7,$41,$D1,$88,$A3,$11,$BC,$2E,$4C,$FC,$B8,$56,$9C,$EA,$D9,$29,$14,$2C,$69,$70,$59,$3C,$A0,$7A,$5F,$F7,$FE,$76,$B5,$3C; 768
		dc.b $51,$91,$B6,$63,$CB,$61,$BD,$6C,$43,$B7,$FB,$41,$6D,$ED,$46,$71,$1B,$46,$6C,$6F,$CF,$34,$6B,$FE,$A9,$2C,$91,$9D,$1B,$F7,$E1,  1,$B2,$33,$D8,$B3,$82,  8,$CB,$96,$41,$39,$65,$6D,$E3,$84,$1B,$D1,$9F,$F7,$E3,$2E,$83,$8B,$70,$BF,$ED,$9C,$DB,$75, $E,$BD,  8,$AD; 832
		dc.b   5,$2B,$14,  4,$4B,$68,$A3,$CB,$6B,$D0,$CB,$6B,$83,$5D,$A0,$65,$2B,$D1,$E5,$D1,$9D,$4F,$EF,$DD,$4F,$40,$A5,$7F,$98,$EA,$41,$E4,$A4,$64, $A,$96,$70,$54,$A6,$40,$82,$1D,$88,$2D,$C0,$23,$7B,$10,$42,$F0,$DB,$ED,$90,$71,$C2,$FF,$B5,$7B,$CB,$78,$93,$8D,$4C,$E7; 896
		dc.b $B8,$EA,$C6,$5D,$E5,$BC,$2B,$8E,$15,$F9,$15,$22,$97,$2A,$D4,$B8,$52,$D4,$80,$A5,$45,$20,$48,$8A,  3,$51, $C,$64,$12,  3,$A8,$A4,  7,$5B,$51,$D4,$B5,$1D,$5E,$CE,$AF,$67,$57,$6C,$97,$2B,$1A,$EF,$AE,$FA,$EF,$A8,$E3, $C,$F8,$B1,$AB,$C8,$E0,$CE,$73,$9D,$4A,$F1; 960
		dc.b $22,$3B,$DB,$24,$B6,$49,$70,$EC,$97,$62,$DD,$1B,$2E,$9D,$DB,$78,$EE,$3F,$DA,$1D,$1C,$11,$BC,$70,$CE,$1C,$38,$3F,$DC,$23,$A4,$20,$23,$F9,$C2,$97,$A4, $F,$DF,$D8,$FF,$30,$8C,$86,$43,$BB,$6F,$B6,$41,$DB,$FF,$BB,$DB,$FF,$B9,$37, $A,$E3,$8A,$82,$1E,$75,$22,$BD; 1024
		dc.b $E5,$FE,$D0,$E3,$7C,$23,$71,$74,$6C,$87,$FB,$58,$B1,$E4,$41,$B3,$B2, $A,$10,$5B,$A0,$22,$12,$E8, $F,$F3,$90,$8F,$DF,$72,$F3,$42,$C9,$74,  8,$DD,$21, $F,$46,$A0,$84,$62,$C8,$12,$C8,$D4,$B1,  6,$8C,$EC,$81,$1C,$16,$DE,$32,$1C, $F,$FE,$FF,$F7,$81,$FF,$DF,$FE; 1088
		dc.b $F7,$19,$57,$89,$CE,$40,$EE,$CB,$50,$ED,$5D,$F5,$C8,$1A,$B7,  1,$51,$88,$75,$A0,$21,$D5,  3,$B1,$56,$76,$C9,  8,$A3,$A0,$21,$32,$43,$D3,$2B,$21,$65,$1B,$C2,$82,$32,  5,$BB,$82,$37,$B7,$70,$47,$71,$BD,$41,$1C,$29,$1C,$4B,$BC,$B8,$53,$2C,$94,$D5,$D5,$EB,$C4; 1152
		dc.b $E7,$39,$C9,$B5,$21,$30,$45,$24,$E3,$A2,$B8,$E8,$15,$C2,$38,$52,$1C,$10,$A7,$95,$4B,$10,$A6,$4C,$42,$99,$38,$DC,$55,$14,$48,$85, $A,$24,$42,$85,$32,$2C,$6A,$E1,$EA,$E0,$E0,$AB,$E0,$AB,$A8,$97,$18,$32,$21,$24,$42,$91,$45,$2C,$42,$A4,$8F,$F3,$25,$F8,$93,$64; 1216
		dc.b $AB,$DB,$52,$DB,$9E,$73,$9D,$B2,$95,$B2,$52,$80,$8C,$27,$FB,$28,$30,$28,$C6,$A1,$2D,$86,$4C,$1B,$6A,$43,$E3,$8A,$95,$63,$52,$AC,$6B,$90,$35,  5,$5E,$A1,$5F, $C,$BB,$D4,$15,$EE,$37,$3F,$B1,$D4,$3E,$E3,$F8,$9F,$60,$A2,$A9,$86,$5F,$E6,$54,$87,$A8,$7E,$52,$FC; 1280
		dc.b $4B,$FF,$31,$7B,$89,$77,$DC,$F2,$DE,$BF,$DC,$A6,$FF,$FE,$16,$AB,$38,$93,$10,$45,$59,$C6,$18,$A6,$19,$E4,$54,$B5,$4A,$95,$69,$15,$70,$77,$3E,$AE,$31,$90,$C3,$85,$38,$B6,$AD,$8B,$4A,$D8,$13,$91,$C1,$D4,$A9,$C3,$A9,$A8,$5C,$AB,$67,$5E,$52,$2A,$CA,$32,$FE,$61; 1344
		dc.b $FE,$E4,$86,$5C,$88,$CA,$7A,$9F,$67,$DC,$33,$E2,$4C,$64,$64,$C6,$4E,$AC,$64,$55,$DA,$45,$72,$15,$2B,$67,$A8,$41,$94,$BA,$58,$A8,$FD,$F8,$2B,$6A,$29,$5B,$20,$53,$20,$AC,$EA,$25,$62,$A6,$45,$8A,$BA,$F1,$2E,$EB,$BE,$BB,$D4,$AF,$FB,$54,$77,$5F,$F6,$AF,$FB,$57; 1408
		dc.b $BD,$46,$55,$70,$70,$5B,$51,$39,$CE,$7B,$8E,$AE,$35,$6D,$4F,$B0,$53,$B8,$E1,$8D,$4A,$9D,$48,$2A,$54,$82,$D2,$2A,$14,$83,$AB,$89,$19,$38,$91,$DC,$30,$24,$27,$21,$39,$E0,$19,$E0,$A8,$A9,$A8,$A9,$12,$15,$2D,$20,$A1,$58,$AB,$AF, $C,$64,$EC,$A2,$A3,$2F,$66,$9C; 1472
		dc.b $F7,$15,$3E,$C3,$70,$9E,$A6,$7A,$99,$CE,$73,$9C,$F5,$12,$18,$69,$CD,$44,$E6,$A2,$72,$2A,$67,$3D,$44,$D4,$61,$A4,$14,$A8,$91,$AB,$A9,$67,$50,$A1,$E4,$1E,$AF,$5F,$F6,$B3,$EE,$2A,$77,  5,$79,  9,$15,$1E,$C2,$42,$A2,$7A,$89,$CE,$73,$13,$9C,$E7,$39,$CE,$7B,$8C; 1536
		dc.b $E6,$A2,$73,$57,$12,  4,$19, $C,$15,$63,$8B,$49,$8F,$25,$75,$32,$76,$33,$99,$F6,  7,$50,$A0,$EE,$6F,$60,$70,$CA,$F8,$CB,$73,$6A,$67,$51,$A8,$C0,$91,$13,$1E,$C7,$73,$E0,$48,$D5,$B8,$C1,$53,$B8,$3E,$A0,$C8,$C8,$8D,$CC,$A5,$4C,$99,$EA,$58,$E0,$AB,$D5,$B2,$5E; 1600
		dc.b $F2,$70,$A7, $D,$EC,$77,$3E,$A0; 1664
Nem_BossShipBoost:dc.b	 0,  8,$80,  5,$1C,$15,$16,$23,	 2,$34,	 6,$45,$1B,$66,$3E,$73,	 0,$86,$15,$1E,$8C,  4,	 9,$15,$1A,$23,	 1,$35,$1D,$8E,	 4, $A,$14, $C,$8F,  4,	 7,$14,	 8,$25,$17,$FF,	 0, $D,$95,$FC,$F5,$FB,$E7,$6F,$63,$7B,$17,$EF,$9D,$7F,$3F,$64,	 0,  0,	 2,$7E,$EB,$47;	0
					; DATA XREF: ROM:0001C296o
		dc.b $6D,$57,$3C,$AB,$9E,$47,$6D,$D6,$90,  0,  0,$31,$69,$BA,$97,$FD,$72,$7F,$D3,$52,$FE,$33,$7E,$D9,$BF,$6C,$BF,$8C,$9E,$BD,$56,$D3,$FE,$B9,$A6,$FB,$20,  1,$3F,$3E,$B7,  5,$54,$1B,$64,$1E,$7E,$1B,$2F,$AF,$C3,$65,$F5,$90,$79,$50,$6D,  5,$3E,$B7,$20,$7C; 64
Nem_Smoke:	dc.b   0,$10,$80,  4,  9,$14, $A,$25,$1C,$34, $C,$46,$3A,$55,$1A,$68,$FB,$73,  1,$86,  6,$3B,$87,  4,  8,$15,$1B,$28,$FA,$88,  3,  2,$14, $B,$26,$3C,$8A,  3,  0,$13,  3,$26,$3D,$47,$7C,$FF,$27,$4F,$9F,$BA,$54,$EC,$2A, $A,$3B,$85,$2E,$E2,$C5,$EE,$DA,$8E,$E1,  4; 0
					; DATA XREF: ROM:0001C29Co
		dc.b $14,$7E,$5B,$C1,$7F,$C7,$7F,$D8,$9F,$6D,$D7,$C5,$8D,$12,$67,$C7,$C8,$EE,$2C,$54,$77,$B4,$E4,$2D,$A7,$21,$6D,$39,$5F,$48,$56,$FB,$DA,$13,$1F,$A6,$84,$FF,$8E,$9F,$F6,$3E,$2F,$65,$7F,$6A,$97,$EE,$89,$38,$37,$83,$CE,$9C,$DE,$82,$AF,$70,$79,$1C, $B,$F6,$F4,$17; 64
		dc.b $ED,$E8,$2D,$DD,$3B, $B,$9F,$31,$C8,$5A,$64,$D2,$FA,$E0,$5F,$4A,$9A,$8B,$E0,$B7,$8F,$A1,$4A,$34,$20,$F3,$D5,$14,$36,$B6,$24,$6F,$C1,$22,$FD,$E7,$C2,$49,$E8,$2F,$B1,$80,$F0,$2A,$1A,$10,$86,  5,  3,  2,$12,$B7,$D0,$51,$4E,$5F,$19,$24,$E9,$D0,$A0,$A3,$A1, $A; 128
		dc.b $5E,$84,$60,$24,$E8,$42,$C1,$71,$42,$99,$94,$34,$F0,$12,$4C,$82,$49,$E9,$E8,$68,$1E,  3,$80,$92,$4F,$42,$47,$D8,$32,  9,$3A,  7,$40,$FD,$83,$20,$9E,  0; 192
Nem_EHZ_Boss:	dc.b $80,$80,$80,  4,  4,$14,  6,$25,$11,$35,$13,$45,$16,$55,$14,$66,$37,$73,  0,$81,  3,  1,$16,$36,$27,$73,$38,$F2,$82,  6,$35,$18,$F4,$83,  5,$12,$17,$72,$28,$EB,$84,  8,$F0,$85,  7,$76,$86,  6,$2E,$17,$74,$87,  6,$30,$18,$EA,$88,  4,  5,$16,$33,$28,$EE,$89; 0
					; DATA XREF: ROM:0001C27Eo
					; ROM:0001C2A2o
		dc.b   4,  7,$16,$31,$28,$EF,$8A,  6,$32,$8B,  6,$2F,$18,$F6,$8C,  6,$34,$8D,  7,$70,$8E,  5,$15,$18,$F3,$8F,  5,$10,$17,$71,$28,$F1,$FF,  0,$6F,$A5,$34,$A6,$94,$D1,$B2,$8E,$8D,$94,$74,$6C,$A3,$A3,$64,$D9,$69,$CF,$F5,$7B,$7F,$70,$68,$37,$5B,$67,$6B,$BC,$E7,$FB; 64
		dc.b $68,$70,$D1,$21,$1C,$2D,$9B,$70,$C7,$33,$BC,$37,$85,$8B,$D6,$26,$E7,$30,$9C,$13,$38,$BC,$EE,$8A,$FE,$9A,$B1,$74,$C2,$BB,$E2,$CF,$5C,$18,$86,$7C,$BF,$5B,$A3,$69,$FC,$1F,$CE,$27,$EA,$A3,$F9,$A6,$C9,$B2,$8E,$54,$CA,$99,$53,$2A,$64,  5,$36,$B1,$4D,$36,$63,$1D; 128
		dc.b $13,$68,$AA,$69,$45, $B,$A1,$11,$83,$2F,  2,$1B,$8C,$78,$32,$96,$54,$28,$AC,$B0,$5E,  5,$53,$38,$F0,$7A,$A7,$15,$45,$65,$2C,$B0,$2B,$E6,$A9,  3,$9E,$FE,$79,$A1,$45,$89,$4A,$A1,$AF,$7A,$2D,$67,$FB,$8E,$C8,$E9,$FA,$EB,$93,$F2,$8F,$C5,$20,$5B,$4C,$78,$A6,$C9; 192
		dc.b $F9,$C7,$34,$D3,  6,$33,$D0,$21,$14,$2D,$A7,$E6,$BB,$68,$9F,$9C,$BB,$68,$3E,$8C,$50,$86,$D1,$8A,$18,$FE,$72,$E3,$58,$3C,$74,$CB,$F2,$BA, $D,$CD, $D, $D, $D, $C,$EE,$43,$6F, $B,$BF,$AF,$5C,$BF,$A9,$72,$56,$5D,$BB,$EA,$DC,$2F,$CA,$78,$37, $C,$2F,$62,$F1,$D0; 256
		dc.b $AD,$CE,$AE,$AC,$71,$D9,$51,$E2,$EA,$D7,$78,$DC,$E9,$83,$14,$82,$2E,  9,$B4,$10,$B6,$D0,$42,$99,$C4,$B2,$A6,$17,$1B,$7E,$71,$77,$D3,$C1,$77,$D3,$C3,$3E,$D6,$D1,$1F,$B5,$B4,$6E,$C9,$CD,$B6,$DF,$C0,$CD,$7C, $B,$6A,$DE,  6,$32,$DC,$B1,$B1,$D0,$47,$54,$C1,$16; 320
		dc.b $32,$C2,$ED,$23,$85,$DE, $C,$BD,$5F,$94,$D7,$45,$4F,$CA,$1D,$74,$4C,$F6,$96,$91,$CE,$5A,$26,$7D,$2F,$D1,$15,$21,$D3,$48,$D7,$F4,$F3,$82,$71,$99,$7C,$E2,$A8,$71,$9E,$78,$DD,$D5,$77,$ED,$E1,$E7, $F,$D7,$17,$DD,$5C,$3D,$BB,$9E,$30,$59,$F7,$8F,$CA,$DD,$5C,$38; 384
		dc.b $E1,$C0,$FE,$8A,$5A,$E4,$9A,  0,  0,$FD,$E7,$E7,$53,$FD,$89,$AF,$94,$6B,$AE, $D,$B3,$43,$B7,$53,$2B,$43,$F2,$9D,$45,$DA,$A7,$C1,$1E,$AE,$D0,$7E,$CB,$C5,$DB, $E,$EB,$9E,$38,$47,$A3,$AA,$2B,$74,$75,$4A,$DC,$BD,$1D,$53,$CD,$3A,$3A,$B6,$7D,$1D,$51,$5B,$A3,$AC; 448
		dc.b $FA,$3A,$A7,$E9,$F6,$AC,$30,$33,$E7,$4F,$6A,$5E,$2F,$17,$75,$26,$1F,$A6,$89,$9F,$E9,$CC,$3F,$5C,$EA,$8A,$79,$6A,  0,$DF,$4B,$7E,$75,$6B, $C,$21,$55,$7A,$FF,$33,$C3,$B6,$43,$FE,$20,$7F,$DF,$F2,$BF,$D4,$6F,$E8,$FF,$E1,$3F,$D6,$B1,$FD,$E1,$8F,$EF,$7C,$23,$FB; 512
		dc.b $DC,$23,$FB,$D9,$FE,$F4,$C7,$F7,$9F,$CB,$CA,$FC,$BF,$83,  3, $F,$D5,$B7,$8B,$5E,$DE,$29,$7C,$7C,$E1,$7B,$5C,$52,$A7,$A4,$61,$53,$38,$67,$5F,$CE,$DE,$8B,$D2,$1B,$5F,$73,$F4,$C1,$BF,$34,$E9,$9B,$7E,$69,$D7,$64,$D2,$EA,$A1,$48,$69,$89,$F1,$47,$4E,$29,$CF,$8F; 576
		dc.b $38,$FE,$6B,$FB,$60,$8F,$F0,$8F,$FB,$FF,$D3,$FE,$3F,$F8,$FF,$DF,$FF,$3F,$7B,$FB,$CF,$DE,$FE,$F3,$F7,$BF,$BC,$FD,$EF,$FF,$3F,$79,$7F,$FA,$AB,$FE,$FD,$CE,$E5,$AA,$62,$61,$54,$AC, $C,$15, $C,$2B,$3F,$3C,$EB,$1E,$37,$3E,$D0,$7E,$AB,$B1,$E7,$DC,$8A,$7C,$F9,$AA; 640
		dc.b $40,$A7,$8D,$52,  6,  9,$CD, $D,$76,$89,$5E,$34,$EA,$BF,$C4,$A7,$52,$7E,$51,$16,$9E,$1A,$27,$56,$D1,$FC,$E4,$7F,$83,$A7,$F5,$D0,$FF,$53,$97,$FC,$7F,$F1,$FF,$BF,$EE,$37,$EB,$2D,$FA,$CB,$7E,$B2,$DF,$AC,$B7,$F7,$1B,$F4,$B9,$7E,$D4,$A1,$87,$F4,$61,$58,$61, $C; 704
		dc.b  $A,$A7,$54,$30,$82,$C1,$70,$9C,$23,$FB,$78,$FF,$36,  9,$DA,$90,$FE,$D3,$3A,$A3,$AA,$2B,$15,$72,$AC,$E8,$55,$EA,$97,$63,$56,$2B,$57,$6A,$B5,$C5,$6D,$73,$AD,$AE,$75,$68,  6,$B9,$D5,$20,$52,$11,$C0,$C2,$E8,$68,$D0,$30,$AA,$1F,$CE,$7E,$91,$7A,$BF,$6C,$9A,$27; 768
		dc.b $6F,$DA,$7A,$68,$B8,$F9,$4B,$F5,$7F,$C3,  0,  0,$3F,$AB,$E1,$C3,$FA,$2D, $F,$DB,$AA,$5D,$87,$F3,$F3,$B7,$EF,$F0,$86,$1C,$5B,$B7, $E,$DC,$3F,$2B,$C6,$D9,$41,$3F,$94,$9C,$5D,$51,$D6,$2E,$55,$CA,$B2,$BD,$55,$EA,$B1,$2C,$5A,$AD,$56,$A8,  9,  6,$83,$40,$21,$48; 832
		dc.b $14,$81,$4A,$BE,$CF,$B2,$D7,$FA,$29,$FF,$80,$F8,$5C,$E9,$9D,$CF,$85,$CE,$A9, $B,$9F, $B,$9D,$2B,$D4,$F8,$5C,$E9,  4,$83,$E1,$73,$A1,$75,$7C,$2E,$75,$43,$8E,$17,$3A,$67,$8E,$17,$3C,$4D,$B6,$4F,$E0,$88,$F4,$FD,$75,$DE,$69,$87,$8E,$1C,$57, $D,$D7,$F4,$F0,$C2; 896
		dc.b   9,$DB,$F5,$BD,$B8,$7E,$57,$7F,$FD,$26,$17,$2B,$6D,$83,$15,$8F,$39,$BD,$61,$58,$B9,$5E,$79,$9A,$A7,$EE, $D,$66,$A6,$A8,$59,$4D,$50,$B2,$9A,$A1,$48,$24,$2A,$85,$21,$63,  4,$2A,$66,$5A,$BC,$EA,$9D,$DF,$BE,$53,$72,$77,$39,$4B,$95,$B6,$6C,$2B,$72,$CE,$1E,$76; 960
		dc.b $54,$CE,$6E,$A8,$66,$E8,$6D,$B0,  2,$95,$34,$E2,$69,$C4,$CF,$8D,$3F,$2B,  3,$3F,$CD,$1B,$6C,  5,$31,$A7,$17,$A1,$AB,$CC,$A4,$29,  6,$31,$82,$1A,$14,$53,$12,$8A,$6C,$A6,$CA,$68,$40,  0,  0,  0,  0,  0,  0,  0, $A,$1B,$62,$B1,$C5,$39,$23,$E5,$D6,$9A,$A9,$FD; 1024
		dc.b $6E,$BC,$20,$A7,$F5,$BA,$F0,$82,$3E,$5D,$69,$AC,$71,$4E,$56,$C5,$77,$20,  0,  0,  0,  0,  0,  0, $A,$6D,$3C,$73,$6C,$66,$72,$9F,$25,$BC,$F5,$B4,$AF,$7F,$F1,$24,$23,$E2,$DE,$27,$8B,$78,$9F,$4B,$42,$57,$BF, $F,$D9,$2D,$E7,$AD,$8E,$53,$E4,$D8,$8C,$73,$A6,$C0; 1088
		dc.b   0,  0,  0,  1,$B9,$9E,$D9,$2B,$63,$9D,$F2,$C6,$6B,$7C,$AD,$2F,$69,$27,$5B,$2D,$E6,$D2,$9F,$EC,$B1,$E1,$AA,$71,$9F,$16,$E2,$85,$BC,$9B,$66,$D9,$B6,$6E,$28,$5B,$69,$F1,$6D,$71,$E1,$AA,$71,$94,$FF,$44,$B7,$9B,$5F,$24,$EB,$69,$5A,$57,$E3,$35,$BD,$B1,$CE,$F9; 1152
		dc.b $4F,$6C,$97,$72,  0,  0,  1,$FB,$90,$F3,$FD,$9B,$B4,$B7,$BF,$58,$C9,$ED,$E8,$53,$1E,$1A,$C7,$28,$FE,$FD,$21,$D0,$C7,$85, $A,$6C,$DB,  0,$DB,$31,$1B,$24,$2E,$C0,$A4,$12, $D,$5E,$29, $D,$71,$D4,$6A,$C7,$2B,$F5,$6D,$4B,$A4,$87,$EC,$DE,$8F,$1F,$DC,$80,  0,  0; 1216
		dc.b   0,  0,  0,  4,$39,$3C,$71,$5B,$CA,$3E,$5D,$77,$BA,$9F,$D6,$EB,$C1,$14,$FE,$B7,$5E, $C,$F9,$75,$DF,$74,$71,$5B,$EB,$63,$93,$80,  0,  0,  0,  0,  0,  0,  6,$EF,$33,$93,$C7,$15,$BE,$49,$8C,$56,$F2,$9F,$C3,$48,$4B,$F8,$4F,$77, $D,$CF,$F7,$D0,$EF,$C3,$FB,$E9; 1280
		dc.b $2F,$E1,$62,$9F,$C3,$6C,$62,$B7,$96,$C5,$6F,$95,$8E,$4E,$1C,  0,  0,  0,  0,$37,$34,$75,$6D,$B2,$76,$C7,$3B,$E5,$45,$BC,$CA,$3C,$A7,$C9,$AF,$7E,$12,$9E,$AD,$FC,$24,$E9,  4,$FD,$FB,$18,$4C,$B7,$F0,$63,$FC,$16,$30,$99,$48,$27,$EF,$DB,$F8,$49,$D2,$53,$D5,$20; 1344
		dc.b $9C,$9A,$F7,$D6,$3C,$B7,$5B,$CC,$B1,$CE,$F9,$4F,$6C,$9C,$3A,$EE,$40,  0,  0,$31,$DA,$99,$97,$A6,$6D,$FB,$36,$7B,$4A,$F5, $F,$E9,$C3,$D1,$2F,$58,$F1,$E0,$D5,$80,$89,$D5,$BC,$80,$9F,$90,$AE,$A9,$5E,$2D,$AD,$A1,$C2,$3F,$B2,$6B,$D7,$77,$9C,$AF,$54,$FD,$9B,$3D; 1408
		dc.b $B3,$9E,$65,$DB,$1D,$80,  0,  0,  0,  0,  0,  2,$77,$C5,$F6,$E4,$8F,$94,$AF,$7E,$1A,$A9,$FD,$6B,$41,$4F,$EB,$5A,  8,$F9,$4A,$F7,$E1,$AC,$5F,$6E,$56,$EF,  0,  0,  0,  0,  0,  0,  0, $D,$DE,$7D,$F1,$73,$28,$E2,$8B,$7F,$5A,$75,$A6,$AD,$2F,$D1,$63,$FA,$2B,$57; 1472
		dc.b $FB,$EC,$61,$43,$AF,$EF,$D0,$C2,$5F,$A2,$C7,$86,$A9,$D6,$9A,$B6,$28,$B7,$F5,$B3,$99,$6F,$DE,$1C,  0,  0,  0,  0,$37,$34,$75,$6C,$BB,$DB,$6B,$E5,$3E,$EB,$E4,$9C,$A3,$EC,$63,$CA,$3E,$92,$8D,$EF,  4,$FE,$12,$18,$37,$8C,$78,$DB,$FA,$31,$FE, $C,$78,$D8,$B7,$8C; 1536
		dc.b $7F,$84,$95,$84,$A3,$7B,$C7,$94,$7D,$23,$EC,$5B,$BA,$F9,$27,$2D,$AF,$95,$32,$EF, $E,$BB,$90,  0,  0, $C,$BB,$E7,$7A,$C9,$32,$8E,$77,$C9,$32,$6E,$5E,$DA,$A6,$53,$BD,$F5,$6F,$D9,$36,$B9,$4E,$E7,$82,$7E,$FC,$31,$E1,$33,$1F,$28,$90,$3C,$81,$63,$43,$C3,$8B,$42; 1600
		dc.b $DC,$5E,$E8,$27,$EC,$9B,$5C,$A3,$ED, $C,$93,$97,$B2,$6A,$D9,$DF,$CB,$26,$F6,$92,$3C,$7F,$35,$88,  0,  0,$22,$68,$68,$68,$68,$68,$45,  8,$B2,$C5,$59,$64,$51,$59,$64,$CB,$26,$94,$64,$92,$5B,$49,$24,$92,$69,$5A,$4C,$BD,$6A,$CA,$CA,$CB,$15,$45,$62,  0,$20,$10; 1664
		dc.b $41,  4,$10,$44,$FC,$93,$9C,$C8,  0,  0,$8B,$6C,$E9,$24,$59,$BD,$30,$71,$25,$8F,$50,$BA,$8F,  1,$47,$86,$F7,$22,$C7,$A9,$14,$2C,$F0,$7D,$DC,  0,  0,  4,$73,$9F,$FC,$67,$CC,$10,  0, $D,$FC,$94,$C7,$F8,$3D,$F6,$29,$DC,$92,$65,$4E,$E4,$E5,$DC,$8B,$7B,$3E,$17; 1728
		dc.b $AC,$93,$54,$AA,$68,$B1,$D4,$55,$20,$B3,$7C,$16,$F9,$27,$A7,$B2,$C9,$6F,$6B,$E5,$DD,$D6,$9D,$D3,$C6,$C7,$1F,$E0,$BB,$7F,$24,  0,  0,$33,$E6,$9E,$42,$64,$10,$41,  4,$10,$D7,$58,$A5,$6E,$A4,$AB,$75,$24,$66,$5A,$18,$4F,$D0,$80,$2D,$A8,$D6,$B8,$5A,$56,$32,$AE; 1792
		dc.b $16,$37,$51,$EC,$45, $D, $D, $D, $D, $D,  8,  0,$50,$D0,$D0,$D0,$D0,$D0,$8A,$11,$65,$8A,$B2,$C8,$A2,$B2,$C9,$96,$4D,$28,$C9,$24,$B6,$92,$49,$24,$D2,$B4,$99,$7A,$D5,$95,$95,$96,$2A,$8A,$C4,  0,$40,$20,$82,  8,$20,$89,$F9,$27,$39,$90,  0,  1,$16,$D9,$D2,$48; 1856
		dc.b $B3,$7A,$63,$48,$24,$96,$3D,  0,$51,$BA,$84,$58,$F4,$45,$B4,$19,$67,$8E,$EE,  0,  0,  2,$39,$CF,$FE,$33,$E6,  8,  0,  6,$EF,$CD,$3F,$93,$DD,$8D,$96,$2B,$76,$73,$5B,$B3,$9B,$DC,$EA,$8A,$E8,$60,$5A,$A4,$52,$A6,$8A,$E8,$60,$6C,$F7,$3A,$CD,$6E,$CE,$6B,$76,$69; 1920
		dc.b $8D,$97,$F9,$3D,$CD,$DF,$98,  0,  0,$67,$CD,$3C,$84,$C8,$20,$82,  8,$21,$96,$C5,$33,$DF,$31,$32,$D9,$80,  0,$A6,$62,$25,$33,$B6,$74,$5B,$11,$43,$43,$43,$43,$43,$42,$37,  0,  0; 1984
Nem_EHZ_Boss_Blades:dc.b   0,$14,$80,  5,$17,$14,  9,$26,$39,$35,$1A,$45,$19,$72,  0,$81,  3,  2,$15,$18,$25,$1B,$56,$3D,$67,$7C,$86,  5,$16,$76,$3A,$87,  4,  7,$18,$FA,$88,  4,  8,$16,$38,$28,$FB,$89,  4,  6,$14, $A,$26,$3C,$76,$3B,$FF,$D7,$EE,$27,$87,$B7,$D5,$E1,$FF,$6C,$FF,$C8; 0
					; DATA XREF: ROM:0001C284o
					; ROM:0001C2A8o
		dc.b $68,$69,$F7,$4D,$67,$6E,$77,$59,$54,$AC,$A5,$35,$94,$26,$4C,$9D,$47,$F0,$5D,$32,$BA,$74,$D9,$DE,$93,$FE,$5A,$FF,$2E,$AB,$87,$B7,$99,$FB,$AE,$5F,$F7, $D,$2D,$1F,$C9,$BF,$B2,$CF,$66,$D5,$6F,$9F,$32,$EC,$A5,$59,$42,$64,$CA,$14,$7F,  6,$13,$26,$57,$4D,$FB,$1C; 64
		dc.b $BC,$32,$D7,$CB,$D9,$F8,$A5,$98,$FA,$89,$87,$FD,$33,$DD,$FF,$8C,$FF,$7F,$A7,$68,$9F,$74,$D6,$76,$E7,$75,$95,$53,$8B,$43,$29,$C3,$C6,$27, $F,$18,$9C,$56,$33,$BD,$26,$87,$BF,$CB,$AA,$E1,$ED,$E6,$5F,$8A,$E7,$EB,$ED,$A6,$A3,$F7,$37,$F6,$59,$EC,$DA,$AD,$F3,$E6; 128
		dc.b $53,$5A,$13,$4E,$1E,$31,$38,$78,$C4,$E2,$AE,$A7,$79,$B5,$2D,$7C,$BD,$9F,$8A,$40,  0,  5,$FA,$EC,  0,  0,  0,$3A,$EC,  0,  0,  0,$3A,$EC,  0,  0,  0,$3A,$EC,  0,  0,  0,$3A,$EC,  0,  0,  0,$3A,$EC,  0,  0,  0; 192
S1Nem_Ballhog:	dc.b $80,$2F,$80,  3,  1,$14,  6,$25, $A,$35,$11,$45,$14,$56,$2F,$66,$36,$75, $B,$81,  3,  0,$16,$2E,$27,$76,$38,$F7,$82,  5,$16,$18,$F5,$83,  4,  4,$15,$13,$26,$37,$38,$EF,$48,$EE,$78,$F4,$84,  6,$34,$86,  6,$35,$18,$F2,$87,  5, $F,$16,$31,$27,$78,$38,$F3,$88; 0
		dc.b   5, $E,$16,$32,$26,$38,$89,  5,$10,$16,$33,$8A,  6,$30,$17,$74,$8B,  5,$12,$18,$F6,$8D,  7,$72,$17,$75,$8E,  7,$73,$8F,  5,$15,$FF,$A3,$F5,$7D,$F5,$E7,$B0,$BC,$5E,$FA,$FE,$32,$FD,$2F,$76,$9B, $B,$45,$D5,$5A,$DF,$55,$C7,  3,$AF,$2A,$7E,$53,$9C,$50,$41,$65; 64
		dc.b $EA,$16,$E9,$CF,$28,$6F,$62,$3F,$19,$CB,$12,$3A,$DC,$CF,$60,$C1,$9E,$17,$4F,$50,$A1,$66,$B7,$6B,$2D,$67,$1B,$2A,$CA,$FD,$17,$33,$6C,$7F,$58,$6A,$7F,$2B,$23,$22,$2A,$B3,$76,$1A,$F5,$FC,$62,$5A, $F,$3F,$9E,$36,$38,$7E,$17,$9D,$E2,$42,$F1,$80,$DA,$BF,$85,$B1; 128
		dc.b $D1,$87,$E1,$54,$34,$D8,$68,$AB,$2D,$6C,$34,$11,$1A,$5F,$A1, $A,$46,$17,$88,$A0,$3F,$C2,$3D,$28,$25,$B0,$95,$12,$C8,$AB,$20,$92,$AD,$74,$84,$94,$F2,$2A, $D,$81,$95,$4D,$59,$E7, $D,$22,$F3,$8E,$8C,$83,$C5,$C4,$27,$64,$7B, $D,$DD,  5,  4,$75,$E9,$EC,$22,$10; 192
		dc.b $CA,$82,$77,$88,$47,$86,$E2,$9F,$E9,$3F,$E1,$5A,$C6,  3,$A4,$BD,$62,$20,$A9,$19,$61,$E9,$BD,$3F,$F7,$FF,$1F,$FF,$9F,$CA,$37,$ED,$31,$3A,$79,$97,$DD,$E7,$A8,$7A,$7B,$CE, $E,$EF,$83,$88,$CF,$21,$2F,$7F,$D5,$9F,$DD,$AD,$5E,$83,$37,$B9,$A0,$FB,$AA,$E8,$6B,$CC; 256
		dc.b $70,$61,$AE,$3F,$F1,$5A,$FF,$45,$72,$BB,$95,$BD,$C9,$10,$5E,$50,$E0,$CF,$8D,$43,$D4, $E,$8F,$67,$84,$2F,$67,$89,$9C,$75,$13,$6B,$B7,$57,$7C,$67,$14,$5D,$E8,$28,$82,$33,$8C,$F2,$8E,$60,$B8,$37,$EB,$C5,$5C,$15,$51,$55,$79,$43,$86,$FF, $A,$D7,$78,$E9,$41,$2D; 320
		dc.b $84,$9B,$BE,$C8,$50,$F8, $A,$F3,$1A,$10,$FE,$C8,$F2,$83,$7C,$88,$42,$E8,$73,$AB,$26,$50,$D5,$EB,$6B,$49,$DB,  7,$52,$D8,  8,$3A,$29,$D0,$44,$21,$C2,$82,$77,$88,$47,$86,$E2,$9F,$E9,$3F,$E1,$5A,$C6,  3,$A4,$BD,$62,$20,$A9,$19,$61,$DD,$FB,$29,$91,$E7,$76,$83; 384
		dc.b $C1,$F0,$9D,$B5,$C7,$2D,$CD,$D5,$E7,$AC,$1D,$BB,$FC,$A0,$E5,$AD,$9D,$7B,$82,$9D,$98,$C3,$CA,  3,$F5,$47,$F2,$BD,$16,$AF,$41,$9B,$DC,$D0,$7D,$D5,$74,$35,$E6,$38,$30,$D7,$1F,$F8,$AD,$7F,$A2,$B9,$5D,$CA,$DE,$E4,$55,$D8,$94,$20,$BE,$98,$9C,$6E,$3E,$2E,$99,$ED; 448
		dc.b $DE,$7B,$94,$E9,$AE,$92,$A2,$2E,$F4,$14,$41,$19,$C6,$79,$47,$30,$5C,$1B,$F5,$E2,$AE, $A,$A8,$AA,$BC,$A1,$C3,$7F,$85,$6B,$BC,$74,$A0,$95,$2D,$39,$37,$AD,$D2,$43,$63,$A8,$C3,$9E,$16,$20,$86,$AC,$5F,$26,$46,$C4,$F6,$4F,$7C,$48,$EF,$74,$15,$37,  5,  4,$32,$B9; 512
		dc.b $42,$7E,$D1,$CE,$67,$86,$CC,$FF,$A4,$48,$FB,$61,$38,$88,$2A,$46,$58,$7A,$71,$FC,$AE,$7D,$3F,$3E,$7D,$B4,$C5,$A5,$E1,$AE,$3E,$7A,$E3,$6F,$74,$CD,$DD,$F0,$61,$9E,$5F,$D1,$FF,$DA,$BD,$38,$39,$E3,$C1,$CF,$1D,$DB,$B6,$FE,$A8,$D3,$B1,$79,$43,$83,$3D,$56,$96,$AF; 576
		dc.b $2F,$16,$2F,$67,$89,$9C,$75,$13,$6B,$B7,$6E,$E8,$B9,$2F,$95,$10,$46,$60,$F7,$B9,$5F,$B9,$AB,$81,$FC,$F9,$15,$57,$94,$38,$6F,$E0,$99,$61,$41,$2D,$84,$A8,$96,$45,$59,  4,$95,$6B,$A4,$24,$A7,$91,$50,$6C, $C,$AA,$6A,$CF,$D9,$E7, $D,$14,$83,$C6,$8C,$10,$63,$73; 640
		dc.b   4,$B9,$1E,$A1,$3C,$E8,$83,$69,  8,$84,$32,$A0,$4D,$82,$6C,$36,$75,$32,$57, $C,$1B,$F9,$2E,$18,$1F,$6C,$27,$11,  5,$48,$CB, $F,$4D,$E9,$FF,$BF,$F8,$FF,$FD,$B4,$A7,$E5,$1E,$DF,$A4,$C5,$B4,$F0,$DA,$DD,$E7,$AA,$3D,$3D,$D1,$D9,$F7,$BA,$4D, $E,$24,$7B,$7E,$AD; 704
		dc.b $BF,$56,$BA,$25,$27, $E,$E2, $C,$1E,$E6,$83,$88,$AB,$8C,$3F,$3E,$32,$30,$AD,$CE,$20,$C3,$5C,$67,$66,$ED,$DC,$AD,$EE,$48,$82,$F2,$87,  6,$7C,$6A,$1E,$A0,$74,$7B,$3C,$21,$7B,$3C,$4C,$E3,$A8,$9A,$86,$E5,  8,$DE,$33,$BD,$22,$81,$74,$40,$BA,$25,$26,$E8,$A6,$54; 768
		dc.b $85,$C5,$C1,$BF,$5E,$2A,$E0,$AA,$8A,$AD,$C0,$F9,$43,$20,$DF,$C1,$59,$CE,$39,$E4,$A8,$65,$18,$39,$74,$83,$96,$B5,$DF,  7,$2F,$68,$3B,$68,$65,$7E,$79,$5F,$9A,$F3,$BF,$2C,$EF,$CA,$11,$C8,$BA, $C,$EF,$CF,$39,$65,$D0,$2E,$FC,$F3,$A9,$92,$D6,$CE,$82,$E8,$E8,$47; 832
		dc.b $28,$2B,$2C,$E3,$9A,$D7,$1E,$B1,$EB,$35,$72,$9C,$79,$22,$D4,$87,$92,$2E,$28,$B5,$9E,$48,$BD,$B9,$26,$DC,$A7,$7F,$59,$DF,$D5,$7D,$6F,$9F,$5A,$21,$4E,$4A,$4B,$A7,$C9,$87,$40,$8B,$4E,$44,$74,  8,$A4,$B9,$29,$35,$B2,$72,$5D,$13,$94,$67,$C9,$53,$EB,$1E,$B7,$80; 896
Nem_Crabmeat:	dc.b   0,$44,$80,  5,$12,$15, $F,$25,$10,$35,$15,$46,$35,$56,$38,$67,$72,$74,  2,$81,  3,  0,$15,$14,$27,$78,$86,  6,$32,$17,$77,$87,  4,  6,$16,$34,$27,$76,$88,  5, $E,$15,$16,$89,  4,  4,$15,$13,$27,$7A,$8A,  6,$36,$17,$73,$8B,  5,$18,$17,$74,$8C,  6,$2F,$16; 0
		dc.b $2E,$26,$33,$37,$75,$47,$79,$8D,  4,  3,$15,$11,$28,$F6,$38,$F7,$8E,  4,  5,$16,$37,$FF,$22,$E5,$7F,  6,$B5,$31,$C5,$F4,$D6,$FF,$10,$3B,$A9,  8,$DC,$21,$1C,$E0,$6A,$77,$54,$D4,$EF,$A9,$AC,$75,$35,$3D,$62,$BC,$8C,$A5,$99,$C3,$3E,$77,$9C,$97,$3E,$71,$92,$E7; 64
		dc.b $B5,$E6,$F5,$EA,$6F,$5E,$A7,$49,$2E,$67,$E1,$6E,$8F,$85,$BA,$37,  5,$F7,$FE,$E2,$C6,$E3,$DE,$F5,$F6,$59,$FE,$B8,$D5,$3F,$50,$A7,$BC,$DD,$91,$11,$48,$F9,$1F,$28,$F1,$1E, $D,$B2,$6A,$B7,$E9,$9A,$1D,$E9,$94,$1B,$2A,$34, $D,$B2,$6A,$9A,$3B,$53,$4D,$24,$B8,$D8; 128
		dc.b $E4,$8D,$2C,$5C,$F4,$D3,$39,$45,$66,$EC,$B5,$9B,$B9,$21,$17,$27,$42,$7A,$23,$E6,$D9,$39,$9E,$9A,$39,$1A,$48,$EF,$DB,$89,$8D,$29,$24,$67,$20,$82,  6,$70,$82,  9,$30,$82,  7,$B8,$3C,$54,$57,  1,$C9,$46,$C5,$F4,$E9,$B2,$31,$F9,$31,$77,$F3,$44,$53,$B3,$BD,$87; 192
		dc.b $67,$68,$61,$3B,$A5,$99,$C2,$62,$76,$16,$3A,$4C,$58,$1A,$84,$16,$90,$88,$5B,$3E,$86,$BA,$57,$F6,$24,$45,$AC,$56,$A7,$7A,$DF,$53,$BD,$6F,$81,$DC,$B7,$C0,$EE,$30,$F8,$E6,$1E,$6A,$77,$2B,$CD,$4F,$37,$9A,$9E,$70,$35,$3B,$A0,$6B,$1B,$EA,$6B,$1D,$4D,$4F,$83,$52; 256
		dc.b $2F,$6D,$6F,$E7,$18,$5F,$CE,$F8,$BE,$ED,$AE,$8C,$BC,$C6,$4B,$9F,$B8,$5F,$EE,$AD,$3F,$9B,$79,$A8,$F7,$EA,$B1,$95,$E7,$BD,$EA,$72,$35,$9E,$EF,$54,$FD,$42,$BD,$67,$6C,$9E,$6B,$3B,$64,$44,$44,$45,  6,$C9,$AA,$D4,$C9,$A1,$95,$3B,$C1,$BF,$4C,$D5,$6C,$9B,$54,$77; 320
		dc.b   8,$DC,$26,$8B,$8D,$A0,$8D,$8B,$A0,$8D,$99,$11,$17,$11,$E2,$3A,$FB,$6B,$ED,$AB,$64,$D5,$6F,$D3,$57,$2A,$65,$56,$A6,$5A,$B6,$4D,$B6,$15,$EE,$43,$BB,$12,$64,$91,$E6,$E6,$49,$19,$13,$E3,$73,$E3,$CF,$38,$F3,$CD,$65,$7E,$D9,$AB,$FC,$AB,$FC,$AB,$FA,$AC,$1B,$35; 384
		dc.b $86,$59,$AC,$A8,$DE,$CB,$E0,$D7,$AD,$16,$FD,$CF,$3D,$E6,$A7,$72,$FE,$A1,$16,$24,$44,$45,$53,$E0,$5F,$AD,$2F,$38,$78,$BC,$DF,$FB,$1B,$CD,$FE,$2E,$37,$D2,$E8,$BC,$67,$17,$E6,$6A,$6F,$BE,$2A,$70,$8E,$E7,$C4,$DD,$A6,$B3,$77,$24,$22,$D6,$7A,$CC,$25,$7D,$34,$3D; 448
		dc.b $68,$FF,$5A,$3A,$42,$61,$2D,$29,$86,$72,  7,$CC,$33,$84,$10,$49,$85,$50,$49,$B5,$15,$C0,$72,$51,$B1,$7D,$3A,$6C,$8C,$7E,$4C,$5D,$FF,$D4,$ED,$2D, $C,$76,$FD,$43,  4,$FD,$33,$92,$C2,$6E,$47,$23,$87,$EE,$28,$82,$D4,$DE,$96,$90,$8E,$F6,$7D, $D,$74,$AF,$F0,$79; 512
		dc.b  $E,$54,$47,$26,$1F,$B7,$4A,$5F,$86,$F2,$6C,$EF,$7B,$82,$76,$48,$BB,$F6,$E0,$F4,$4E,$E8,$34,$70,$98,$73,$38,$2D,$85,$82,$9D,$BC,$7A,$B0,$FE,$4D,$BF,$7D,$4D,$14,$E8,$FF,$D8,$91,$57,$2B,$4D,$63,$69,$A9,$EE,$E9,$CB,$DD,$39,$7E,$DD,$19,$F9,$39,$AC,$1A,$56,$4F; 576
		dc.b $D8,$B7,$8A,$82,$FD,$CD,$50,$7F,$26,$43,$FD,$32,$FE,$8A,$72,  4,$5B,$C6,$B1,$22,$22,$2E,$1B,$90,$22,$E4,$9C,$82,$70,$27,$C5,$13,$90,$D6,$2B,$37,$65,$AC,$DD,$C9,  8,$88,$88,$AB,$FB,$98,$7F,$25,$FF,$B9,$A4,$BD,$51,$BF,$72,$25,$93,$9A,$62,$4C,$E4,$69,$89,$76; 640
		dc.b   8,$24,$EE,$C1,  4,$86,$82,$48,$24,$E4, $F, $F,$67, $E,$1C,$38,$61,$C3,  2,$AE,  3,$92,$8D,$8B,$E9,$D3,$64,$63,$F2,$62,$EF,$E6,$88,$A7,$6F,$71,$DB,$DC,$27,$7F,$E6,$8F,$F4,$8B,$7A,$B0,$B0,$D1,$C8,$2C,$CE,$4A,$2F,$EA,$3C,$1A,$E8,$21,$FC,$12,$22,$22,$22,$22; 704
		dc.b $E5,$44,$72,$61,$FB,$74,$A5,$F8,$6F,$26,$CE,$F7,$B8,$27,$64,$8B,$BF,$6E, $F,$44,$EE,$83,$47,  9,$87,$33,$82,$D8,$58,$4E,$DE,$12,$96,$13, $A,$2D,$FB,$E1,$2D,$14,$E8,$FF,$D8,$91,$57,$2B,$4D,$63,$69,$A9,$EE,$E9,$CB,$DD,$20,$D0,$FD,$BA,$33,$F2,$73,$58,$34,$AC; 768
		dc.b $9F,$B1,$6F,$1F,$B9,$1E,$BF,$E2,$44,$44,$45,$AE,$F1,$AC,$48,$88,$B8,$F5,$AF,$EC,$48,$88,$88,$88,$B9,$4D,$DA,$6B,$37,$72,$42,$22,$22,$E4,$9A,$CD,$D5,$98,$75,$66,$D9,$43,$D6,$8F,$F5,$A3,$A4,$26,$12,$D2,$98,$67,$20,$7C,$C3,$38,$41,  4,$98,$55,  4,$9B,$50,$44; 832
		dc.b $45,$5C,  7,$25,$1B,$17,$D3,$A6,$C8,$C7,$E4,$C5,$DF,$FD,$4E,$DE,$E3,$B7,$B8,$4E,$FE,$D6,$1E,$BF,$70,$2C,$96,$98,$FD,$44,$CE,$9F,$B8,$43,$DE,$D3,$A1,$AE,$89, $F,$E0,$91,$17,$21,$C8,$11,$11,$11,$14,$AE,$8B,$CF,$3E,$71,$92,$E7,$CC,$DE,$B9,$ED,$7B,$D7,$CB,$D7; 896
		dc.b $C9,$11,$14,$78,$8F,$1E,$DA,$FB,$11,$11,$16,$B7,$F2,$BF,$FC,$39,$FF,  6,$5F,$EC,$91,$FF,$71,$F1,$EB, $F,$E6,$EA,$7B,$91,$14,$17,$AC,$17,$36,$82,$E7,$94,$17,$D9,$A0,$79,$9F,$8B,$B7,$BE,$97,$2B,$91,$73,$34,$73,$1E,$66,$8E,$C9,$AE,$3D,$CD,$D9,$47,$F7,$C6,$9F; 960
		dc.b $BE,$8B,$F7,$32,$AB,$A1,$3D,$11,$F3,$6C,$9D,$A6,$4D,$AF,$E9,$9A,$B9,$53,$2A,$E5,$46,$AB,$64,$DA,$9A,$39,$EB,$8D,$8E,$48,$D2,$C5,$C7,$24,$67,$66,$FC,$23,$92,$8D,$8B,$E9,$D3,$67,$31,$F9,$41,$77,$F3,$44,$53,$B3,$BD,$87,$67,$68,$61,$3B,$A5,$99,$C2,$6F,$4D,$1C; 1024
		dc.b $8D,$24,$77,$ED,$C4,$C6,$94,$92,$33,$90,$41,  3,$38,$41,  4,$98,$41,  3,$DC,$1E,$2A,$1E,$27,$61,$63,$A4,$C5,$81,$A8,$41,$69,  8,$85,$B3,$E8,$6B,$A5,$7F,$62,$44,$45,$C6,$F5,$DE,$30,$58,$DD,  5,$3C,$DE,$A7,$D5,$EA,$7D,$5E,$A7,$D5,$EA,$7D,$60,$A7,$9C,$16,$37; 1088
		dc.b $57,$78,$F1,$B9,$11,$16,$FC,$47,$7A,$DD,$15,$86,$66,$B0,$EA,$6A,$FE,$A6,$AF,$EA,$6A,$FE,$A6,$AF,$CC,$D6,$17,$45,$61,$1D,$EB,$B9,$11,$11,$57,$A5,$7A,$73,$86,$39,$F7,$86,$36,$FD,$33,$F1,$B7,$ED,$9F,$8D,$BF,$6C,$FC,$6D,$FB,$67,$E3,$6F,$DB,$43,$1B,$7E,$9A,$18; 1152
		dc.b $E7,$DE,$BD,$39,$F1,$D0,$88,$8B,$A7,$1C,$FA,$57,$BF,$3C,$43,$F4,$DB,$62,$1F,$B6,$DB, $F,$FD,$B6,$D8,$7F,$ED,$B6,$C3,$FF,$6D,$B6,$1F,$FA,$6D,$B1, $E,$FC,$F1, $E,$7D,$2B,$D0,$8B,$80,  0; 1216
Nem_GHZBuzzbomber:dc.b $80,$37,$80,  4,	 3,$14,	 5,$24,	 8,$34,	 7,$45,$15,$56,$36,$67,$6F,$73,	 0,$81,	 4,  2,$15,$13,$27,$74,$82,  6,$35,$18,$F2,$83,	 4,  6,$16,$2E,$27,$7A,$84,  7,$75,$85,	 7,$76,$86,  6,$2F,$87,	 5,$12,$16,$38,$48,$F3,$58,$F7,$88,  4,	 4,$17,$72,$89,	 5,$16;	0
		dc.b $8A,  6,$34,$18,$F6,$8B,  6,$32,$17,$6E,$8C,  5,$18,$17,$77,$8D,  7,$78,$8E,  5,$14,$17,$73,$8F,  6,$33,$FF,  0,$6F,$CD,$7C,$51,$73,$5F,  7,$9D,$33,$3A,$78,$3C,$4C,$E9,$A9,$E0,$8F,$3A,$62,$5E,  9,$7C,$B0,$4F,$D8,$FB,$3A,$1F,$69,$13,$DE,$B2,$AC,$DF,$4B,$FB; 64
		dc.b $19,$3F,$6D,$9B,$2E,$AD,$D6, $A,$D7,$95,$E0,$78,$DF,$8F,  0,$7E,$89,$6D,$99,$92,$EA,$49,$95,$8C,$95,$97,$5F,$CA,$C5,$D1,$D9,$F8,$21,$9C,$75,$FC,$B1,$E8,$AC,$7F,$A5,$7F,$CA,$B6,$4A,$C7,$C1,$5B,$CA,$60,  1,$FD,$95,$45,$FD,$47,$E6,$53,$3A,$22,$F2,$32,$D9,$39; 128
		dc.b $A5,$79,  0,$12,$CA,$82,$10,$AC,$69,$FB,$1B,$24,$C0,  0, $B,$6F,$4B, $D,$E9,$60,$2B,$61,$BC,$BF,$33,$5B,$21,$94,$AF,$D6,$F8,$2B,$CB,$7E,$6C,$4E,$56,$2B,$EA,$46,$40, $B,$F8,$B6,$A5,$69,$D2,$F4,$65,$4B,$D1,$F9,$1B,$75,$67,$26,$EA,$CB,$C8,$E6,$69,$D7,$3C,$42; 192
		dc.b $62,$EA,$E0,$F0,$7D, $F,$33,$A6,$A8,$68,$54,$32,$CD,$14,$9D,$8F,$43,$2A,$67,$3F,$2F,$1D,$F7,$69,$AB,$76,$EB,$DA,$EC,$7E,$CE,$2F,$3B,$8D,$97,$AF,$E5,$6F,$ED,$94,$FF,$9E,$56,$2D,$88,$FF,$C2,$7F,$BB,$54,$2F,$D9,$F2,$23,$FE,$88,$8E,$2B,$29,$A3,$E7,$4C,$C9,$E7; 256
		dc.b $B2,$6E,$47,$2B,$8A,$B3,$1B,$CB,$B5,$FF,$95,$2D,$FA,$C5,$ED,$F9,$67,$D3,$1A,$19,$2D,$F9,$92,$12,$D8,$B3,$28,$24,$CF,$91,$DC,$92,$4F,$E0,$E9,$D5,$8B,$CA,$7A,$AD,$CA,$42,$E8,$62,$76,$32,$56,$36,$9C,$74,  0,  0,  3,$DA,$BF,$99,$C5,$A0,$B4,$2C,$25,$8C,$98,$FC; 320
		dc.b $41,$1B,$15,$FA,$1F,$23,$BD,$8A,$B4,$52,$74,$65,$B4,$35,$50,$D9,$58,$AD,$1E,$AC,$9F,$C1,$D4,  0,$3F,$72,$F8,$5D,$3F,$33,$1E,$DA,$FB,$58,$EF,$AA,$5B,$55,$F2,$3D,$50,$19,$39,$44,$CC,$AA,$CE,$D0,$C7,$71,$DC,$ED,$AF,$4F,$29,$80,  0,  0,$5B,$7E,$42,$C3,$95,$53; 384
		dc.b $A4,$31,$F2,$27,$E8,$E4,$A5,$2B,$F5,$BE, $A,$F2,$DF,$9B,$13,$95,$8A,$FA,$91,$90,  2,$FE,$2D,$A9,$5A,$74,$BD,$19,$52,$F4,$7E,$46,$DD,$59,$C9,$BA,$B5,$7F,$C2,  7,$4B,$7E,$5B,$84,$34,$2A,$19,$66,$8A,$5B,$64,$65,$4C,$C9,$5B,$22,$D3,$77,$46,$B7,$A8,$FE,  8,$F3; 448
		dc.b $B4,$FF,$9E,$49,$BC,$8F,$FC,$27,$FB,$B5,$42,$FD,$9F,$22,$3F,$E8,$85,$2E, $B,$5E,$97,$CE,$CC,$73,$CE,$99,$F4,$59,$EC,$9B,$91,$CA,$E2,$AC,$C0,$91,$C8,$E4,$BE,$EB,$EF,$1E,$6F,$FB,$7A,$C8,$E4,  0,$96,$FE, $E,$4F,$E7,$1E,$EB,$FE,$73,$91,$FB,$C4,$8F,$F4,$FB,$48; 512
		dc.b   0,$25,$B7,$15,$FD,$BC,$79,$C4,$8F,$87,$91,$F1,$1E,$E7,$FF,$7F,$FB,$FF,$DF,$F4,$E7,$25,$91,$CA,$B2,$39,$3F,$9C,$79,$C7,$ED,$DE,$47,$20,  0,  1, $D,$1F,$F9, $B,$C8,$FF,$50,$A9,  9,$54,$DE,$80, $D,$93,$7F,$23,$47,$FE,$44,$21,$A1,$A0,  0, $D,$90,$D2,$BF,$A8; 576
		dc.b $D9,$16,$FD,$F7,$80,$15, $D,$15, $F,$FF,$1F,$F8,$FE,$41,$A1,$FF,$21,$D0,$D0,  3,$43,$43,$48,$FE,$C2,$FF,$61,$7F,$B0,$BF,$B8,$34,$54,$34,  2,$38,$7E,$26,$BC,$4F,$DB,$83,$23,$FD,$57,$E9,$C8,$F4,$3D,$16,$51,$A4,$4A,$26,$B2,$2D,$32,$3C,$9C,$B7,$11,$C8,$8F,$23; 640
		dc.b $29,$47,$4E,$14,$A4,$72,$59,$1F,$E9,$D6,$47,$23,$93,$C8,$FC,$CF,$89,$EE,$29,$4F,$D8,$CB,$43,$F6,$DB,$D9,$F4,$5D,$14,$B2,$29,$68,$46,$4F,$D0,$F2,$8C,$97,$23,$29,$46,$44,$E5,$A1,$48,$9C,$A4,$B2,$89,$6D,$28,$90,  0,  0,$7C,$EB,$4B,$9E,$8D,$38,$A3,$10,$7A,$31; 704
		dc.b   7,$A3,$10, $B,$35,$6E,$97,$1D, $F,$D7,$35,$FD,$F0,$7F,$DF,$2F,$3F,$47,$43,$BB,$A3,$2C,$C0,$52,$6A,  7,$26,$A0,$72,$6A,$44,$DA,$8F,$75,$2B,$CC,  0,  3,$F3,$7E,$77,$45,$2E,$9D,$49,$E8,$C4,  0,$AD,$18,$81,$56,$97,$4D,$F9,$DD,$B7,$30,  7,$3D,$AE,$E6,$F3,$BA; 768
		dc.b $95,$20,$4D,$40,  5,$49,$A8,$E5,$59,$DD,$48,$BB,$9B,$F3,  3,$15,$A6,$1B,$BC,$6A,$C7,$76,$17,$56,$3B,$B0,$B4,$C3,$77,$AE,  0,$AD,$3F,$3B,$FA,$C5,$69,$FA,$EE,$AD,$17,$2B,$47,$A9,$FA,$EF,$4F,$CE,$FE,$B0,  0,$17,$BE,$FC,$6D,$80,  0,  2,$BB,$9F,$74,$E3,$29,$F7; 832
		dc.b $AE,$1F,$22,$C0,  2,$B9,$16,  6,$2B,$94,$FB,$BE,$E9,$ED,$B8,  1,$BB,$69,$EE,$7E,$F3,$CA,$B8,$18,$2C,$80,$15,$C1,$64,$F8,$AF,$79,$E5,$13,$DC,$FB,$86,$C0; 896
Nem_UnknownGroundExplosion:dc.b	$80,$24,$80,  4,  6,$14,  8,$24,  9,$34, $C,$45,$16,$55,$1A,$65,$1B,$73,  0,$81,  4,  7,$16,$3C,$86,  5,$17,$17,$7A,$87,  4, $A,$17,$7B,$8A,  8,$F8,$8B,  5,$1C,$18,$F9,$8C,  3,  2,$16,$3B,$8D,  3,  1,$16,$3A,$FF,  0,  0,  5,$AF,$BF,$5B,$F4,$33,$F3,$4D,$7C; 0
		dc.b $76,$FC,$D6,$71,$D9, $B,$53,$A1,$B5,$65,$4B,$77,$D2,  8,  0,  0,  0,$47,$33,$93,$C8,$E6,$3F,$CC,$5F,$8F,$1E,$16,$3D,$BB,$2B,$76,$C8,$69,$5B,$BD,$28,$56,$ED,$96,$DF,$F5,$92,$6B,$C6,$4C,$59,$7B,$F5,$F0,$DC,$6F,$E6,$70,  0,  0, $D,$CD,$F0,$5F,$57,$17,$9E,$42; 64
		dc.b $9F,$99,$FC,$D7,$2A,$CF,$4A,$53,$52,$C4,$FB,$A5,$67,$DD,$2D,$56,$F8,  0,  2,$DD,$D9,$57,$C6,$2A,$38,$98,$E2,$6F,$8D,$55,$96,$93,$53,$DA,$9C,$21,$6A,$D2,$67,$59,$CC,$53,$EE,$DC,$6A,$65,$9C,$6B,$EE,$AE,$EA,$79,$14,$E6,$6E,$FF,$A7,$92,$D7,$F3,$3F,$5A,  8,$FD; 128
		dc.b $DC,$AF,$DE,$FC,$FC,$5F,$3A,$7D,$90,  0,$40,  0,  6,$2D,$77,  8,$42,$CF,$D6,$3B,$28,$5E,$37,$88,$BB,$53,$53,$3F,$BB,$BD,$DF,$D7,$9F,$FD,$1D,$EB,$DA,$B7,$54,$B1,$31,$A0,$A5,$41,$A4,  6,$9C,$32,$D5, $C,$4C,$F7,$9F,$D6,$42,$6F,$D6,$3D,$62,$76,$73,$2E,$D5,$AA; 192
		dc.b $B3,$C3,$E7,$B7,$63,$8E,$C7,$1F,$AB,$10,  4,$FE,$AB,$3E,$3C,$6F,$88,$F8,$76,$7E,$E1,$D9,$D4,$F1,$9D,  9,$22,$56,$5D,$9D,$94,$18,$A7,$6E,$D8,$B7,$B8,$78,$BC,$5D,$EA, $D,$E9,$AB, $D,$FF,$43,$9F,$BD,$62,$DD,$61,$93,$62,$3A,  0,  6,$E6,$F8,$3E,$63,$F7,$6E,$DF; 256
		dc.b $3F,$A1,$29,$D9,$FF,$78,$C9,$D4,$A0,$C8,$5B,$B7,$65,$8F,$3F,$AC,$7F,$77,$78,$78,$A7,$6F,$50,$FE,$9B,$DB,$5F,$AB,$CF,$A8,$3C,$F4,$D7,$CF,$DE,$ED,$37,$52,$6A,$2E,$A6,$F2,$F1,$D3,$1B,$EF,$A0,  6,$F8,$A7,$91,$CB,$72,$3B,$87,$65, $A,$C8,$6D,$F1,$C5,$6A,$9A,$B5; 320
		dc.b $57,$39,$4C,$75,$7D,$70,$C1,$95,$26,$68,$EA,$E7,$44,  0,  0,$C5,$B4,$C6,$DD,$5B,$F7,$B8,$5B,$A9,$2A,$1F,$6F,$25,$D8,$D8,$C1,$12,$76,$63,$AD,$10,$74,$75,$D6,$88,  0, $C,$3B,$38,$77,$FA,$D0,$74,$EC,$71,$D9,$F0,$EC,$C3,$99,$3E,$19,$2F,$D4,$97,$12,$76,$58,$B7; 384
		dc.b $92,$58,$E8,$B7,$EB,$53,$19,$3B,$E9,$CE,$88,$20,  0,  6,$CE,$C8,$B7,$50,$64,$C7,$58,$60,$CA, $A, $E,$8D,$97,$58,$E5,$8E,$8D,$BA,  3,$68,$D8,$B9,$B7,$40, $D,  0; 448
S1Nem_LZBurrobot:dc.b	0,$5A,$80,  5,$10,$15,$12,$25,$14,$36,$31,$47,$6F,$56,$35,$66,$33,$74,	5,$81,	3,  0,$16,$30,$26,$36,$38,$F2,$82,  5,$11,$16,$32,$27,$72,$38,$EB,$83,	8,$EF,$18,$F1,$84,  8,$F6,$86,	6,$2F,$18,$F7,$87,  4,	6,$16,$34,$88,	4,  4,$16,$2E,$26,$38,$38,$EA; 0
		dc.b $89,  3,  1,$15,$13,$27,$76,$38,$F3,$8C,  5,$16,$17,$6E,$38,$EE,$8D,  5, $F,$15,$15,$27,$73,$38,$F4,$48,$F0,$8E,  5, $E,$17,$74,$38,$F5,$FF,$55,$55,$55,$CD,$EA,$AB,$9B,$66,$9A,$C4,$EB,$14,$DE,$52,$FA,$14,$BD, $C, $A,$5F,$FC,$8B,$C5,$C2,$E0,$41,$40,$52,$1B; 64
		dc.b $11,$3C,$7C,$B3, $A,$AA,$AA,$B4,$77,$A4,$2B,$DD,$CF,$FB,$8F,$F2,$73,$ED,$E3,$F9,$4F,$18,$BD,$BD,$BF,$2B,$FA,$68,$B5,$FF,$85,$FD,$B3,  6,$F6,$BC,$1D,  3,$77,$DE, $B,$71,$E3,$A2,$46,$F4,$9F,$5F,  7,$AC,$DD,$3E,$42,$E9,$F2,$23,$B7,$22,$26,$39,$10,$47,$5F,$FC; 128
		dc.b $60,$FE,$9B,$25,$5D,$FC,$85,$55,$57,$BB,$5F,$47,$53,$C1,$D2,$B7,$84,$AD,$E1,$28,$F8,$3A,$19,$78,$43,$97,$A4,$22,$59,$1A,$B0,$37,$F0,$CF,$81,$6E,$19,$D0,$3F,$C8,$74,$22,$78,$74,$B2,$EC,$25,$D6,$29,$C8,$63,$B6,$54,$19,$6E,$AC,$12,$3D,$D5,$8B,$FB,$AB,$8B,$DC; 192
		dc.b $97,$E3,$D1,$1B,$7B,$91,$B7,$BA,$EC,$50,$B9,$28,$F2,$20,$21,$57,$11,$B9,$FD,$1E,$37,$55,$C1,$D0,$B3,$B6,$87,$98,$94,$D3,  4,$91,$40,$81,$24,$50,$10,$65,$DB,  3,$21,$E6,$29,$FC,$1D,$2E,$8D,$6D,$A2,$64,$EA,$B5,$D9,  7,$3F,$8C,$98,$3A,$EC,$9A,$63,$F5,$8E,$9E; 256
		dc.b $16,$AB,$B0,$C9,$FE,$59,$6D,$90,$3D,$5E,$FC, $F,$D3,$84,$60,$6E, $C,$85,  1,$40,$86,$E1,$34,$17,$61,$FC,$9B,$8F,$FC,$6D,$CD,$D4,$E7,$D2,$8F,$F5,$A7,$A8,$A7,$EB,$86,$3B,$6F,$19,$9B,$BF,$4F,$26,$41,$A0,$68,$60,$DC,  6, $D,$71,$42,$81,$90,$DD,$E7,$D4, $E,  5; 320
		dc.b   8,$40,$6E,$37,  8,$7F,$45,$55,$55,$55,$60,$F5,$55,$CD,$B3,$4D,$62,$75,$8A,$6F,$28,$68,$6F,$37,$A4,$12,$F3,$70,$4B,$CA,$10,$87,$69,$84,$22,$1E,$53,$18,$F9,$66,$15,$55,$55,$68,$EF,$48,$57,$BB,$9F,$F7,$1F,$E4,$E7,$DB,$C7,$F2,$9E,$31,$7B,$7B,$7E,$57,$F4,$D1; 384
		dc.b $6B,$FF, $B,$FB,$66, $D,$ED,$78,$3A,  6,$EF,$BC,$16,$E3,$C7,$44,$89,$49,$F5,$A0,$43,$D6,$84,$4F,$92,$11,$3E,$49,$30,$79,$76,$C3,$94,$F0,$EB,$FF,$8C,$1F,$D3,$64,$AB,$BF,$90,$AA,$AA,$F7,$6B,$E8,$EA,$78,$3A,$56,$F0,$95,$BC,$25,$1F,  7,$43,$2F,  8,$72,$F4,$84; 448
		dc.b $4B,$23,$56,  6,$FE,$19,$F0,$2D,$C3,$3A,  7,$F9, $E,$84,$4F, $E,$96,$5D,$84,$BA,$C5,$39, $C,$76,$CA,$83,$2D,$D5,$82,$47,$BA,$B1,$7F,$75,$71,$7B,$92,$FC,$7A,$23,$6F,$72,$36,$F7,$5D,$8A,$17,$25,$1E,$44,  4,$2A,$E2,$37,$3F,$A3,$C6,$EA,$B8,$3A,$16,$76,$D0,$F3; 512
		dc.b $12,$ED,$82,$4A,$61,  3,$4A,$60,$84,$94,$D3,  3,$21,$3B,$85,$3F,$83,$A5,$D1,$AD,$B4,$4C,$9D,$56,$BB,$20,$E7,$F1,$93,  7,$5D,$93,$4C,$7E,$B1,$D3,$C2,$D5,$76,$19,$3F,$CB,$2D,$B2,  5,$1A,$7A,$7B,$B1,$4D,  5,$C0,$E8,$18,$DC,$2E, $C,$85,  1,$B8,$32,$61,$DA,$E9; 576
		dc.b $A7,$FC,$6D,$CD,$D4,$E7,$D2,$8F,$F5,$A7,$A8,$A7,$EB,$86,$3B,$6F,$19,$A7,$E9,$EE,$93,$11,$30,$90,$C1,$B8,  8,$19, $D,$C5,  3,$5C,$50,$A4,$DB,$80,$70,$2C,$41,  9,$3E,  4,$3F,$A2,$AA,$AA,$B0,$19,$8C,$C6,$63,$31,$98,$CC,$66,$35,$11,$D4,$47,$51,$19,$56,$42,$30; 640
		dc.b $E7,$21,$18,$3D,$D5,$90,$AB,$AB,$20,$F7,$55,$CF,$93,$DC,$F9,$BE,$4F,$83,$FB,$49,$F2,$ED,$BD,$DD,$A4,$13,$78,$37,$9C,$76,$4C,$41,$4B,$CD, $F,$55,$36,$4B,$CC,$A7,$D5,$23,$D5,$7A,$36,$D3,$BD,$23,$3E,$A3,$78,$FE,$4D,$E3,$2C, $C,$6F,$3F,$D2,$6B,$FF,$C4,$DF,$F2; 704
		dc.b $FF,$97,$F8,$8F,$F4,$8D,$FF,$C2,$2C,$83,$AC,$DD,  1,$C8,$DD, $D,$B2,$9C,$3B,$6D,$6B,$BC,$DF,$65,$55,$55,$5F,$4C,$7C,$5D,$6A,$CA,$3F,$A3,$B3,$E5,$EF,$ED,$DE,$EB,$3E,  3,$DF,$DA,$2F,$B4, $F,$BF,$B4,$5D,$67,$7E,$9B,$BE,$2E,$B3,$DA,$FE,$FC,$9D,$5F,$E1,$73,$FE; 768
		dc.b $17,$39,$E5,$CD,$CC,$86,$3C,$DD,$C3,$AA,$E8,$71,$EB, $E,$DF,$AE,$10,$DD,$57,  9,$7E,$B2,$B4,$FD,$65,$5D,$A9,  5,$29,$63,  0,$94,$B3,$E0,$E4,$A5,$9F,  7,$26,$36,$7D,$9D,$8E,$E7,$DA,$89,$DD,$20,$83,$73,$E4,  8,$B3,$84,$84,$F0,$4A,  2,$27,$8E,$13,$DE,$10,$EA; 832
		dc.b $13,$30,$AA,$AA,$AA,$AA,$B7,$E8,$99,$57,$F4,$FC,$9C,$FD,$13,$90,$75,$AE,$E4,$C3,$77,$26,$9F,$73,$A6,$37,$55,$D8,$45,$FF,$C1,$C8,$FE,$9F,$AE,$ED,$2F,$E5,$70,$22,$F4,$89,  9,$A0,$D1, $A,$16,$20,$A0,$E0,$11,$30,$7F,$83,$3C,  8,$30,  8,$70,$64,$90,$42, $B,$50; 896
		dc.b $4C,$26,$23,$B6,$FC,$13,$30,$AB,$BB,$9B,$A5,$E9,$D2,$55,$F5,$97,$F3,$84,$87,$EB,$85,$3C,$B1,$88,$D6,$23,$58,$8D,$46,$61,$73,$D3,$50,$5B,$79,$C0,$E2,$C8,$41,$A2,$14,  6,$86,$E2,$D4,$E0,$35,$10,$82,$29,$71,$18,$EC,$AA,$AA,$AA,$B8,$8C,$C6,$63,$31,$98,$CC,$66; 960
		dc.b $33,$1A,$88,$EA,$23,$A8,$8E,$A2,$3A,$EE,$DF,$B9,$FB,$ED,$D3,$1D,$CE,$B6,$36,$95,$B1,$B4,$2D,$8D,$9D, $B,$41,$F2,$B6,$F1,$7E,$FC, $A,$62, $A,$5F,$88,$F3,$A6,$C9,$7D, $F,$13,$97,$61,$7A,$4B,$6B,$8A,$34,$F8,$29,$1F,$34,  6,$F1,$E6,$2F,$19,$1C,$23,$79,$FE,$93; 1024
		dc.b $5F,$FE,$26,$FF,$97,$FC,$AD,$FD,$22,$FB,$75,$9B,$EC,$FB,$64,$59,$1D,$57,$44,$DD,  0,$E6,$89,$BA,  0,$B6,$53,$81,  5,$B0,$7D,$C0,$B1,$73,$D5,$55,$55,$7D,$31,$F1,$75,$AB,$28,$FE,$8E,$CF,$97,$BF,$B7,$7B,$AC,$F8, $F,$7F,$68,$BE,$D0,$3E,$FE,$D1,$75,$9D,$FA,$6E; 1088
		dc.b $F8,$BA,$CF,$6B,$FB,$F2,$75,$7F,$85,$CF,$F8,$5C,$E7,$97,$37,$32,$18,$F3,$77, $E,$AB,$A1,$C7,$AC,$3B,$7E,$B8,$43,$D1,$C2,$4F,$DD,$5A,$77,$56,$4F,$83,$ED,$44,$7C,$1F,$8A,$56, $F,$A2,$41,$F0,$AC,$92,$1C,$FA,$41,$20,$F7,  9,$83,  7,$BA,$7B,$43,  2, $A,  9,  4; 1152
		dc.b $13,$12,  5,$30,$4A,  2,$2E,$C7,  2,$9B,$C4,$F5,  7,$30,$AA,$AA,$AA,$AA,$B7,$E8, $B,  7,$B1,$68,$82,$1D,$A1,$C8,$74,$E2,$71, $E,$BB,$94,$C5,$DF,$D2,$4F,$F1,  2,$3F,$84,$8D,$77,$5F,$E9,$EE,$E4,$8C,$10,$25,$F1,$41,$A2,  4,$BC,$E8,$50,$89,$8E,  1,$17,  3,$FC; 1216
		dc.b $1B,$B0,$21,$A0,$27,$81,$49,  9,$8D,$28,$10,$84,$C4,$24,$F7,$E0,$73, $A,$BD,$D5,$93,$F7,$73,$97,$83,$A4,$EA,$F4,$12,$F5,$14,$F2,$C6,$23,$58,$8D,$62,$35,$19,$85,$CD,$8E,$A2,$7B,$CE, $D,$8A,$31, $D,$42,$8C,$1A,$88,$50,$B5,$38,$2D,$44,$C1,  5,$26,$83,$1D,$95; 1280
		dc.b $56, $F,$71,$4C,$7A,$14,$DE,$E2,$9A,$94,$95,$5D,$DA, $F,$70,$98,$B4,$1E,$E4,$23,$74,$82, $D,$CF,$90,$22,$CE,$12,$13,$C1,$28,  8,$9E,$38,$4F,$78,$43,$A8,$4C,$C2,$AA,$AA,$AA,$AA,$DF,$A2,$46,$B6,$FD,$3E,$4E,$AE,$89,$C9,$CF,$B5,$DC,$83,$B7,$72,$62,$3B,$9C,$70; 1344
		dc.b $DD,$57, $C,$9F,$FC,$1C,$8F,$E9,$FA,$EE,$D2,$FE,$57,  2,$3D,$E2,$42,$68,$12,$F4,$28,$58,$82,$83,$80,$44,$C1,$FE, $C,$F0,$21,$A0,$10,$E0,$52,$41,  8,$D2,$82,$61,$31,$1D,$B7,$E0,$73, $A,$B6,$E6,$EA,$73,$E9,$47,$FA,$D3,$D4,$53,$F5,$C3,$1D,$B7,$C4,$6B,$11,$AC; 1408
		dc.b $46,$A3,$30,$B9,$B1,$D4,$4F,$79,$C1,$B1,$46,$21,$A8,$51,$83,$51, $A,$16,$A7,  5,$A8,$98,$20,$A4,$D0,$63,$B2,$AA,$CB,$9C,$B9,$FE,$B2, $F,$FE,$E4,$1F,$FD,$C8,$3F,$F9,$91,$7F,$F3,$23,$DF,$5F,$D6,$47,$C6,$BF,$AC,$EF,$CB,$9D,$BB,$F9,$7A,$65,$A7,$37,$47,$F4,$EE; 1472
		dc.b $A8,$8E,$86,$15,$11,$D0,$42,$A3,$2B,$A5,$5E,$B9,$3E,$9A,$2A,$AA,$AA,$AA,$D7,$A6,$2F,$D1,$1D,$46,$EA,$32,$FE,$41,$88,$6E,$A3,$91,$BD,$90,$F5,$F6,$FF,$97,$FC,$BA,$DB,$FC,$5A,$7F,$48,$B7,$F4,$83,$47,$CC,$21,$EA,$9C,$52,$F9,$EC,$C9,$7F,$51,$92,$5F,$74,$E4,$6F; 1536
		dc.b $4D,$A9,$D4,$68,$6F,$42,$31,$4D,$B1,$37,$91,$BD,  6,$A4,$63,$BA,$B4,$EE,$AC,$1F,$DD,$58,$57,$77,$3E,$F7,$78,$3A,$21,$D5,$FD,$70,$88,$F5,$DA,$3E,$4D,$10,$9D,$62,$20,$DD,$D6, $F,$F2,$22, $A,$5E,$D7,$44,$14,$FD,$3A,  7,  3,$D4,$3A, $F,$3C,$3A,$7F,  6,  3,$F5; 1600
		dc.b $C2,  2,$5B,$48,$66,$33, $A,$AA,$AB,$9B,$B3,$76,$6E,$F1,$DE,$32,$F1,$93,$1F,$E1,$30,$9F,$22,$85,$8E,$11,$69,$8E,$81,$8E,$11,$B3,$C3,  2,$23,$67,$E0,$70,$4D,$C0,$DC,  8,$B3,$C1,$43,$85,$9E, $A,$6D,$B9,$D8,$20,$23,$70,$38,$4F,$F8,$2F,$1E,$62, $F,$77,$95,$2A; 1664
		dc.b $AA,$AA,$AA,$BB,$DB,$DD,$B1,$C2,$6D,$43,$C0,$49,$32,$14,  9,$24,$3D,$52,$64,$64,$29,$20,$5A,$62,$53,  5,  4,$B0,$28,$28, $A, $C,$4A, $D,$E4,$6A,$15,$55,$55,$57,$30,  0; 1728
Nem_GHZ_Piranha:dc.b $80,$20,$80,  4,  2,$14,  5,$24, $A,$35,$12,$45,$17,$56,$36,$65,$18,$74,  3,$81,  3,  0,$17,$7B,$82,  7,$7A,$83,  5,$19,$84,  5,$1A,$85,  6,$37,$86,  5,$16,$87,  4,  7,$16,$3A,$88,  4,  4,$16,$3B,$89,  5,$13,$8A,  8,$F9,$8B,  6,$39,$8C,  6,$38,$8D,  6,$3C; 0
					; DATA XREF: ROM:0001C0E8o
					; ROM:0001C11Ao
		dc.b $8E,  4,  6,$8F,  4,  8,$18,$F8,$FF,$33,$3C,$31,$EC,$C7,$B3,$1E,$C1,$78,$97,$E5,$B8,$7A,$78,  4,$16,$C6,$A3,$9B,$15,$81,$41, $E,$6F,$16,$79,$59,$96,$C0,$98,$21,$59,$5A,$75,$3B,$A7,$C1,$34,$E9,$20,$E2,$77,$49,$9E,$C9,$B2,  3,$BA, $D,$87,$72,$EF,$E2,$93,$E2; 64
		dc.b $49,  5,$FA,$E5,$B4,$F9,$DC,$41,$36,$7D,$79,$E9,  9,$88,$69,$FB,$15,$37,$46,$82,$F5,$AE,$8A,$DB,$AC,$DF,$F5,$15,$37,$EF,$7A,$99,$36,$4B,$E6,$9F,$72,$C9,$78,$3C,$E0,$82,$EE,$DB,$64,$81,  2,$CC,$FD,$E6,$86,$6D,$17,$11,$F9,$3B,$E4,$F1,$3C,$45,  5,$16,$2C,$D0; 128
		dc.b $DF,  2,$E0,$B5,  7,  5,$99,$7B,$82,$F6,$59,$B8,$CD,$C1,$44,$FB,$5C,$F1,$62,$F8,$B7,$C5,$AF,$F9,$6A,$FF,$F7,$FE,$6D,$F9,$DB,$B2,$F9,$2D,$C8,$17,$92,  6,$42,$42,$4E,$BF,$AB,$56,$72,$FC,$B0,$E4,$B4,$CF,$42,$9B,$A2,  6,$A2,$3F,$43,$F2,$B3,$6F,$D4,$D2, $F,$D1; 192
		dc.b $DC,$4B,$58,$EC,$86,$FC,$AF,$10,$84,$19,$7E,$48,$16,$B7,$2D,$57,$32,$69,$93,$2E,$A5,$B9,$6B,$6D,$6D,$AE,$EE,$9E,$FB,$A0,$BE,$D1,$5E,$42,$BA,$A7,$97,$47,$D1,$36,$CF,$3F,$EF,$2F,$F6,$5C,$CC,$CC,$CC,$DF, $D,$6C,$45,$8F,$11,$69,  8,$21,$29,$B6,$C8,  9,$9E,$93; 256
		dc.b   1,$30,$10,$99,$E4,$13,  1,$30, $C,$DC,$CC,$CC,$CC,$D5,$F0,$F2,$6F,$CE,$49,$BD,$7E,$76,$9B,$D6,$BA,$BC,$FA,$BC,$FA,$97,$AD,$75,$B4,$DE,$FE,$B4,$F5, $B,$EB,$CC,$35,$ED,$C3,$CA,$60,$85,$3E,$D6,  4,$DC,$DB,$66,$E4,$AD,$29,$BD,  2,$6B,$86,$42,$B5,$34,$D6,$77; 320
		dc.b $4F,$85,$89,$AA,$46,$10,$A2,$6B,$3A,$99,$DD, $F,$69,$98,$C2,$6C,$82,$E8,$12,$E9,$30,$9F,$96,$BC,$F9,$B4,$AC,$5C,$23,$D5,$97,$77,$5B,$22,$F0,$8E,$56,$DE,$BF,$33,$64,$27,$A8,$4D,$C9,$D5,$E7,$92,$F9,$FC,$E9,$3E,$E5,$92,$81,$E7,  4,$17,$76,$DB,$24,  8,$16,$67; 384
		dc.b $EF,$34,$33,$68,$B8,$8F,$C9,$DF,$26,$59,$20,$A2,$77,  5,$18,$B2,$E4,$81,$6F,$81,$1B,$69,$21,$73,$48,$22,$E2,$59,$90,$85,$CF,$14,$22,$5F,$B8,$F8,$EF,$F4,$25,$D9, $F,$FC,$7F,$C4,$FF,$3B,$74,$5F,$25,$B9,  2,$F2,$40,$C8,$48,$49,$D7,$F5,$6A,$CE,$5F,$96,$1C,$96; 448
		dc.b $99,$E8,$53,$74,$40,$D4,$47,$E8,$7E,$56,$6D,$FA,$9A,$41,$FA,$33,$5D,$63,$B5,$DF,$95,$E2,$10,$83,$2F,$C9,  2,$D6,$E5,$AA,$E6,$4D,$32,$65,$D4,$B7,$2D,$1D,$33,$97,  9,$7E,$3D,$F7,$41,$7D,$A2,$F5,$65,  8,$5F,$9E,$8F,$CB,$38,$7A,$F8,$6E,$BF,$70,$BF,$9E,$FD,$8F; 512
		dc.b $EE,$25,$FB,$13,$33,$33,$33,$37,$C3,$5B,$11,$63,$C4,$5A,$42,  8,$4A,$6D,$B2,  2,$67,$A4,$C0,$4C,  4,$26,$79,  4,$C0,$4C,  3,$37,$33,$33,$35,$7C,$33,$ED,$37,$D8; 576
Nem_S1LZJaws:	dc.b $80,$20,$80,  3,  0,$14,  4,$24,  6,$35, $F,$45,$18,$55,$14,$66,$39,$74,  2,$81,  4,  3,$15,$16,$26,$35,$82,  5,$15,$17,$77,$83,  5, $E,$16,$34,$84,  6,$37,$85,  7,$74,$17,$76,$86,  5,$10,$16,$32,$26,$36,$37,$78,$87,  5,$12,$17,$7B,$28,$F9,$88,  4,  5,$18; 0
		dc.b $F3,$89,  6,$38,$8A,  7,$75,$18,$F4,$8B,  6,$2F,$8C,  5,$11,$18,$F5,$8D,  6,$33,$18,$F2,$8E,  5,$13,$8F,  6,$2E,$FF,$E5,$52,$3E,$53,$59,$88,$9B,$E4, $C,$87,$67,$43,$81,$98,$34,$9A,$A6,$7C,$1E,$E8,$ED,$FB,$47,$3F,$31,$2D,$64,$FF,$91,$6A,$DF,$DE,$F1,$E8,$73; 64
		dc.b $49,$F7,$BD,$2C, $D,$66,$20,$93,$CD,$70,$BB,$89,$22,$8C,$D5,$EB,$C4,$69,$BA,$49,$B3,$BD,$25,  6,$94,$12,$F6,$8F,$5F,$26,$8A,$6A,$87,$FA,$CC,$6B,$EB,$94,$73,$98,$B2,$75,$37,$4D,$24,$42,$CF,$81,$F5, $E,$98,$F7,$77,$4D,$E6,$24,$14,$1F,  2,$42,$E0,$7D,$74,$FC; 128
		dc.b $A5,$E4,$74,$E9,$E8,$D5,$E8,$2B,$8F,$CF, $A,$DF,$DC,$7E,$7D,$26,$23,$89,$40,$E3,  9,$C9,$2F,  7,$15,$94,$33,$7C,$45,$F8,$8E,$6F,$3A,$1B,$7E,$C5,$22,$EC,$45,$CF,$F5,$70,$77,$EB,$13,$4F,$F8,$91,$27,$CF,  9,$ED,$2E,$56,$FD,$7B,$2C, $B,$F7,$75,$75,$F5,$ED,$7D; 192
		dc.b $58,$C5,$C6,$B5,$6B,$99,$6A,$46,$9F,$A8,$37,$FE,$A4,$DF,$AA,$B8,$3A,$C1,$5C,$DF,$99,$57,$23,$8F,$F4,$64,$8E,$53,$7B,$94,$2B,$39,$70,$E1,$FB,$8D,$3F,$E2,$45,$4F,$E3,$B6,$D6,$C8,$9F,$2D,$64,$34,$7D,$D5,$B3,$5C,$C6,$97,$52,$E4,$D6,$8E,$7D,$93,$40,$74,$56,$52; 256
		dc.b $FD,$42,$79,$9F,$F2,$2C,$3F,$82,$4C,$7C,$A9,$D1,$79,$B1,$16,$15,$23,$E5,$35,$98,$89,$BE,$40,$C8,$76,$74,$38,$19,$83,$49,$AA,$67,$C1,$EE,$8E,$DF,$B4,$73,$F3,$12,$D6,$4F,$F9,$16,$AD,$FD,$EF,$1E,$87,$3E,$25,$3A,$F4,$BD, $D,$F3,$39,  9,$C8,$4D,$23,$D3,$7F,$2D; 320
		dc.b $FA,$A5,$8B,$50,$71,$C1,$90,$38,$F2,$71,$68,$B1,$FE,$B1,$CF,$D5,$DC,$9E,$51,$CE,$78,$EA,$6E,$9A,$48,$85,$9F,  3,$EA,$1D,$31,$EE,$EE,$9B,$CC,$48,$28,$3E,  4,$85,$C0,$FA,$E9,$F9,$4B,$C8,$E9,$D3,$D1,$AB,$D0,$57,$1F,$9E,$1D,$2F,$EE,$3F,$3E,$3F,$3D,$9C,$5B,$3D; 384
		dc.b $FA,$B4,$26,$F3,$88,$52,$FE, $C,$74,$7C,$5C,$FF,$57,$37,$AE,$8F,$D2,$9A,$61,$D6,$FE,$19,$A7,$F0,$48,$93,$E7,$84,$F6,$97,$2B,$7E,$BD,$96,  5,$FB,$BA,$BA,$FA,$F6,$BE,$AC,$62,$E3,$5A,$B5,$CC,$B5,$23,$4F,$D4,$1B,$FF,$52,$6F,$D5,$5C,$1D,$60,$AE,$6F,$CC,$AB,$91; 448
		dc.b $C7,$FA,$32,$47,$29,$BD,$CA,$15,$9C,$B8,$70,$FD,$C6,$9F,$F1,$22,$A7,$F1,$DB,$6B,$64,$4F,$96,$B2,$1A,$3E,$EA,$D9,$AE,$63,$4B,$A9,$72,$6B,$47,$3E,$C9,$A0,$3A,$2B,$29,$7E,$A1,$3C,$CF,$F9,$16,$1F,$C1,$26,$3E,$54,$E8,$BC,$D8,$8A,$9B,$63,$C1,$43,$19, $C,$84,$1F; 512
		dc.b $FC,$61, $E,$60,$32,$68,  8,$34,$39,$D8,$41,$20,$D0,$10,$C6,$43,$F8,$CF,$D8,$88,$88,$A9,$95,$20,$36,$A6,$C9,$95,$20,$9B,$24,  7,$F1,$86,$49,$E0,$B2,$4F,$E3,$3F,$22,$22,$22,$21,$95,$36,$6C,$B1,$FD,$6C,$78,$1B, $F,  3,$22,$1E,$31,$91,$11,$11,$11,$17,$30,$7C; 576
		dc.b   6,$D8,$D9,$A0,$90,$22,$22,$22,$27,$80; 640
Nem_S1SYZRoller:dc.b $80,$50,$80,  3,  1,$14,  5,$24,  6,$34,  7,$45,$14,$55,$18,$66,$33,$74,  4,$81,  3,  0,$15,$15,$26,$38,$82,  5,$17,$17,$77,$83,  5,$12,$17,$72,$84,  7,$75,$85,  7,$76,$86,  5,$13,$17,$73,$87,  4,  8,$17,$74,$28,$F5,$88,  5,$16,$18,$F3,$89,  6,$34,$17,$78; 0
		dc.b $8A,  8,$F6,$8B,  8,$F2,$8C,  6,$32,$18,$F7,$8D,  6,$37,$8E,  6,$35,$8F,  6,$36,$18,$F4,$FF,$44,$44,$C7,$77,$EF,$30,$D7,$33,$8A,$4A,$97,$97,$68,$6B,$AC,$52,$57,$60,$97,$4E,$4C,$21,$33,$CA,$95,$B1,$E4, $C,$8D,$E4,$8D,$DC,$DC,$49,$83,$F2,$5B,$A8,$E5,$81,$FA; 64
		dc.b $3A, $B,$F1,$9E,$E8,$6F,$D7,$F6,$7A,$F5,$9C,$1A,$CF,$D4,$FE,$98,$35,$68,$21,$B8,$89,$A8,$78,$A4,  4,$60,$7A,$AE,$F7,$5E,$A4,$1B,$6C,$7B,$3F,$6D,$FB,$7E,$A2,$EB,$DA,$CB,$6D,$8F,$69,$EA,$6C,$7D,$BB,$1D,$4E,$B1,$A5,$EC,$6D,$3D,$46,$D6,$3E,$72,$B2,$D9,$7C,$A4; 128
		dc.b $39,$F9,$F9,$48,$10,$D2,$18,$95,$D8,$68,$3B,$BE,$4D,$AB,$E4,$DB,$A8,$39,$28,$DD,$F2,$7D,$2C, $D,$C8,$A7,  4,$2F,$EC,$54,$68,$FB,$AF,$69,  5,  7,$AE,$D6,$F2, $B,$D7,$6B,$74,$F2,  7,$6A,$48,$FA,$5B,$A5,$A4,$DB,$45,$94,$1B,$11,$E9,$CA,$C3,$4F,$31,$B4,$AD,$FA; 192
		dc.b $91,$E3,$2F,$52,$17,$43,$B1,$83,$60,$45,$84,$6A,$6D,$A3,  9,$F1,$A9,$D4,$86,$D0,$68,$88,$88,$88,$88,$94,$DD,$13,$31,$BA,$22,$62,$F2,$C6,$DA,$E0,$22,$22,$22,$37,$7D,  6,$3C,$A4,$D7,$42,$31,$C5,  1,$AE,$62,$82,$97,$92,$55,$ED,$8B, $B,$48,$52,$CF,$61,$6A,$C9; 256
		dc.b $AC,$14,$4A,$DA,  7,$1A, $C,  4,$44,$4C,$5A,$9E,$62,$9E,$2C,$3C,$77,$95,$6C,$BF,$AB,$EF,$FA,$AE,$3F,$36,$17,$F3,$66,$B4,$F2,$F7,$21,$7D,$BB,$74,  4,$1B,$6C,$B5,$22,$FE,$CD,$59,$D5,$C7,$E9,$AA,$FF,$B6,$AB,$F3,$AF,$E8,$F3,$B7,$E6,$F9,$19,$2D,$48,$E5,$8A,$B0; 320
		dc.b $A5,$B4,$B4,$D4,$5B,$C5,$B5,$22,$CD,$E6,$D6,$3A,$73,$B1,$11,$E3,$D0,$1D,$20,$FE,$A6,$DF,$F1,$CE,$F9,$F9,$77,$A0,$FC,$D7,$E8,$A9,$FA,$AE,$FE,$EF,$F9,$AE,$99,$6E,$B5,$3E,$D7,$9E,$FA,$ED,$63,$6D,$8C,$FB,$4B,$A8,$BF,$B3,$4C,$4F,$87,$FD,$B7,$10,$7F,$AD,$7F,$D9; 384
		dc.b $FE,$9A,$4F,$26,$FE,$1A,$CB,$B3,$7E,$8C,$1F,$D1,$D8,$83,$3F,$DC,  6,$B1,$B0,$69,$9B,$11,$A3,$7E,$DA,$DE,$27,$FB,$FD,$38,$FF,$49,$FF, $A,$22,$5F,$3F,$6E,$F4,$1F,$9B,$BB,$FE,$A2,$57,$6E,$AC,$1A,$79,$DD,$6E,$29,$2E,$EF,$21,$49,$1B,$87,$E4,$29,$54,$44,$44,$C7; 448
		dc.b $8C, $B, $F, $D,$A2,$F9,$B7,$12,$B7,$80,$FF,$AB,$B3,$85,$F2,$A0,$A5,$C2,$56,$92,$CE,$D2,$AE,$61,$C5,$A4,$92,$A5,$AA,$8D,$E0,$25,$34, $C,$3C,$7F, $A,$D5,$FE,$57,$F2,$FF,$58,$41,$F6,$ED,$EB,$C5,$B6,$6A,$CF,$B7,$97, $B,$FD,$67,$FD,$B0,$CC,$1F,$D1,$E3,$CF,$F5; 512
		dc.b $5C,$94,$1F,  0,$F9,$9D,$39,$D8,$88,$F1,$E8, $E,$90,$74,$5B,$35,$7C,$7E,$CF,$BF,$2F,$ED,$7E,$6F,$DF,$F5,$BA,$ED,$96,$F7,$A9,$E4,$6D,$B7,$4F,$DB,$5F,$DA,$9F,$F1,$3F,$E6,$3F,$E6, $B,$FC,$31,$C9,$E4,$FF,$F3,$3C,$AB,$DB,$F4,$7E,$6B,$B4,$CD,$97,$43,$A4,$CF,$EE; 576
		dc.b  $F,$EC,$F8,$3F,$C3,$69,$2C,$93,$31,$26,$91,$96,$62,$F4,$91, $F,$23,$7C,$48,$52,$43,  1,$11,$11,$11,$11,$12,$9F,$9D,$A6,$E9,$C9,$F7,$95,$37,$92,$C9,$A4,$B9,$69,$4C,$9F,$54,$39,$2C,$D1,$1B,$24,$CF,$24,$C6,$A8,$C2,$99,$1A,$B6,$A8,$72,$21,$F5,$4D,$72,$CF,$5B; 640
		dc.b $A2,$22,$22,$3F,$EF, $F,$EB,$1F,$23,$FF,$14,$7F,$49,$2E,$BE,$8B,$2F,$CF,  7,$D5,  8,$C0,$41,$48,  6,$AF,$EB,$9C,$10,$B3,$71,$80,$F3,$31,$5C,$45,$26,$C1,$F9,$F4,$50,$D3,$50,$D5,$99,  6,$AA,$16,$AB,$55,$FD,$89, $B,$55,$A9,$BB,$D5,$7F,$44,$A2,$9F,$B2,$44,$4F; 704
		dc.b $DE,$27,$EB,  8,$C6,$47,$F6,$2D,$FC,$FA,$AC,$4F,$A7,$A6,$B3,$21,$7A,$4C,$60,$53,$95,$24,$B2,$47,$92,$C9,$C7,$22,$16,$64,$38,$F5, $A,$1E,  3,$4D,$82,$C1,$AB,$43,$CD,$82,$C1,$E6, $F,$3A,$AF,$38,$9F,$45,$E6,$1E,$6F,$C1,$9E,$27,$15,$A7, $D,$77,$FD,$11,$FD,$92; 768
		dc.b $22,$22,$3E,$49,$96,$7A,$DE,$9A,$E7,$3A,$DF,$31,$D5,$E1,$43,  3,$13,$A0,$69,$23,$84,$33,$CE,$30,$13,  2,  8,$5A,$AC,$5D,$60,$C1, $F,$19,$F1,$76,  8,$B7,$C5,$E9,$DD,$11,$11,$11,$11,$11,$FD,$E9,$95,$5F,$21,$E8,$E3,$6A,$6F,$B2,$8C,$C6,$61,$77,$D9,$46,$75,$45; 832
		dc.b $D9,$11,$C6,$63,$30,$B7,$44,$70,$D7,$4B,$A2,$5D,$3B,$A2,$22,$22,$3F,$EF, $F,$EB,$3F,$63,$95,$6D,$FB,$91,$B6,$8D,$D3,$65,$F5, $F, $B,$56,$8E,$1A,$1E,$A6,$14,$4E,  1,$98,$31,$C2,$F3,$20,$85,$E7,$13,  4,$1E,$64,$45,$4F,$4E,$6A,$16,  1,$99,  4,$74,$60,$A0,$F3; 896
		dc.b  $E, $D,$68,$12,$A4,$38,$50,$E0,$F0,$C1,$14,$10,$8D,$75,$FD,$8A,$FE,$88,$D6,$9F,$B2,$44,$4F,$DE,$3F,  7,$F5,$87,$F5,$DC,$1C,$9B,$F3,$C4,$1F,$E0,$FA,  4,$3F,$D1,$D4,$3F,$ED,$FF,$6D,$FC,$17,$E4,  8,$59,$2C,$28,$A4,$28,$93,$F4,$5E,$49,$CD,$83,$F3,$50,$66,$D5; 960
		dc.b $60,$F5,$5A,$B0,$5E,$81,$E1,$60,$35,$69,$55,$89,$8B,$10,$62,$7B,$68,$81,$A7,$B2,$E4,$FF,$AD,$3F,$B2,$44,$44,$47,$C9,$32,$4C,$A8,$33,$D4,$1C,$93,$26,$8D,$45,  4,$F1,$27,$C9,$F4, $F,$24,$23,$3B,$67,$60,$89,$8D,$17,$25,$1A,$60,$67,$A3,$65,$8C,$93,$19,$63,$2C; 1024
		dc.b $64,$88,$88,$88,$88,$94,$FC,$A5,$3A,$F4,$7E,$A7,$A2,$37,$53,$FA,$66,$E6,$94,$BA,$34,$DB,$2D,$B2,$50,$B2,$32,$CA,$71,$9C,$22,$52,$59,  5,$DD,$1F,$24,$6D,$D6,$54,$DD,$16,$54,$DD,$3F,$3A,$88,$88,$88,$FF,$A4,$B9,$FC,$A4,$A0,$C0,$EA,$60,$C3,$7E,$DD,$79,$F4,$60; 1088
		dc.b $8D,$38,$9F,$45,$99,  4,$18,$9B,  5,$14,$AB,$84,$78,$68,$58,$35,$5F,$5C,$E0,$FA,$BC,$FD,$5A,$64,$2C,$73,$6E,$11,$1F,$DD,$32,$4F,$74,$69,$3F,$EB,$37,$E5,$8F,$CE,$EB,$2C,$F7,$FD,$72,$22,$7E,$C9,$FF,$63,$CB,$AA,$C3,$CE,$F3,$30,$60,$87,$86,$14,$86,$E0,$88,$9D; 1152
		dc.b $4D,$48,$30,$41, $D, $B,$5A,  6,$E5,$49,$2D,$54,$62,$71,$75,$1D,$1A,$57,$9E,$26,$C1,$44,$CD,$5E,$61,$44,$19,$AF,$ED,$D8,$4C,$C1,$9A,$83,$14, $B,$57,$AE,  2,$2E,$47,$FB,$87,$23,$AB,$FE,$B8,$FE,$F9,$11,$11,$1F,$AA,$75,$C4,$C7,$5C, $C,$56,$7D,$68, $C,$EE,$D0; 1216
		dc.b $30, $C,$CC,$E8,$20,$DD,$64,$BC,$F1, $F,$22,$29,$58,$33,$6E,$67,$A0,$C4,$38,$CC,$34,$B1,  9,$40,$65,$41,$2C,$6F,$9E,$B4,$CA,$F8,$D5,$11,$33,  0; 1280
Nem_Motobug:	dc.b   0,$1D,$80,  4,  6,$15,$11,$25,$16,$36,$32,$46,$2E,$57,$6A,$67,$75,$74,  4,$81,  3,  0,$15,$12,$26,$2B,$37,$6B,$47,$77,$57,$78,$82,  7,$71,$27,$73,$83,  6,$2A,$18,$F5,$84,  8,$F4,$85,  7,$72,$86,  5, $E,$16,$34,$87,  4,  5,$16,$36,$27,$74,$88,  4,  3,$15; 0
					; DATA XREF: ROM:0001C10Co
		dc.b $14,$89,  4,  2,$15, $F,$27,$76,$57,$7B,$8A,  7,$6E,$8B,  5,$13,$8C,  5,$10,$16,$33,$28,$F2,$48,$F8,$58,$F3,$8D,  6,$2F,$16,$30,$8E,  7,$70,$8F,  7,$6F,$16,$31,$FF,$44,$44,$BB,$1D,$43,$16,$FD,$7C,$46,$F6,$AE,$1E,$A3,$21, $F,$41,$6E,$35, $F,$CA,$D9,$6A,$F4; 64
		dc.b $FC,$AC,$4D,$5D,$57,$A3,$A2,$6A,$EF,$57,$44,$C2,$F1,$A9,$D1,$30,$BC,$6A,$74,$78,$AF,$EC,$93,$56,$E8,$5B,$76,$78,$37,$E6,$A1,$87,$EA,$B3,$BE,$1B,$B4,$CE,$FC,$F7,$69,$5F,$97,$E6,$A7,$F9,$29,$79,$4E,$AE,$63,$3F,$4F,$5E,$62,$1F,$A6,$E6,$21,$FA,$65,$E6,$34,$DB; 128
		dc.b $9D,$6A,$7C,$EB,$53,$FD,$97,$4F,$E1,$27,$FF,$7C,$F0,$DD,$FE,$CF,$CD,$40,$7F,$6A,$BF,$2D,$D9,$D7,$E7,$2F,$3A,$FC,$E5,$E6,$21,$7F,$FF,$3E,$2F,  5,$E5,$80,$23,$10,$FD,$68,$78,$C3,$95,$42,  4,$89,$84,$2E,$87,$EB,$61,$6D,$D9,$E1,  8,$E7,$BA,$18,$41,$BE,$30,$FF; 192
		dc.b $65,$FF,$EC,$FE,$EE,$77,$F0,$FF,$6F, $F,$DE,$61,$F9,$ED,$3F,$AE,$7A,$7F,$63,$4F,$E4,$11,$FB,$8F,$F4,$A2,  9,$C1,$CB,$10,$AE,$E1,$A4,$4C,$2F,  7,$2B,$50,$18,$50,$D4,$93,  3,$63,$1A,$8C,$5D,$FC,$29,$E2,$A0,$B8,$CF,$17,$6C,$5C,$70,$9B,$EB,$37,$5F,$30,$F0,$AE; 256
		dc.b $5B,$DF,$27,$29, $A,$49,$D2,$28,$C9,$D5,$EF,$1C,$9C,$55,  9,$96,$F0,$42,$AA,$F1,$15,$7E,$BB,$F7,$F7,$D7,$7C,$F1,$98,$7C,$AF,$9C,$A9,$3A,$CF,$A7,$FC,$4E,$1B,$FE,$3F,$E3,$E0,$8F,$DA,$87,$D3,$60,$C7,$D2,$51,$5D,$76,  6,$43,$28,$75,$87,$58,$75,$E1, $D,$4A,$56; 320
		dc.b $D9,$A8,$41,$74,$FD,$C0,$A7,$F2,$47,$B0,$C3,$3A,$ED,$26,  8,$88,$88,$8C,$5D,$E2,$5D,$EC,$5A,$EC,$FA,$EE,$78,$EA,$48,$8F,$F1,$DB,$59,$8F,$DC,$FE,$A2,$5E,$F5,$F6,  5,$E1,$11,$94,$C8,$64,$6F,$19,$3C,$5C,$52,$B8,$22,$22,$31,$77,$B1,$6B,$B3,$EB,$B9,$E3,$A9,$22; 384
		dc.b $23,$CF,$5A,$87,$D3,$63,$97,$6A,$16,$BE,$C0,$BC,$22,$23,$1B,$C6,$4F,$17,$14,$AE,  8,$88,$88,$DF,$D2,$88,$27,  7,$2C,$42,$BB,$86,$96, $B,$C1,$CB,$1D,$E0,$C2,$86,$DF,$33,$13,  6,$DF,$9B,$94,$C4,$4C,$4E,$51,$FF,$92,$82,$FE,$16,$C5,$FB,$20,$52,$FC,$DE,$33,$1F; 448
		dc.b $FF,$C5,$C5,$8C,$F1,$99, $F,$D5,$E3,$FA,$BC,$2B,$E4,$E2,$A8,$4E,$5C,$88,$55,$5F,$2F,$D1,$FE,$BB,$97,$AF,$7D,$F5,$4B,$F7,$33,$91,$7E,$E2,$F0,$54,$E9,$FF,$13,$86,$FF,$8F,$F8,$F8,$23,$F6,$A1,$F4,$D8,$31,$F4,$94,$57,$5D,$81,$90,$CB,$F5,  3,$2A, $B,$8C,$6A,$31; 512
		dc.b $A8,$C2,$22,$75,$FD,$46,$B6,$57,$77,$67,$28,$2A,$D9,$C2,$2F, $C,$E1,$91,$22,$22,$25,$94,$AE,$5A,$16,$46,$46,$57,$3D,$13,$52,$BE,$DB,$15,$1E,$DD,$28,$FD,$8D,$4D,$E6,$BF,$C8,$23,$2A,$15,$1E,$D4,$ED,$91,$50,$AE,$36,$2B,$19,$58,$AC,$6C,$4C,$4C,$7A,$89,$9E,$C5; 576
		dc.b $62,$C8,$98,$A2,$4C,$5A,$89,$8A,$20,  0; 640
Nem_S1Newtron:	dc.b   0,$55,$80,  4,  3,$15, $F,$25,$10,$36,$31,$46,$34,$58,$F4,$67,$72,$73,  0,$81,  4,  2,$15,$11,$26,$2C,$36,$33,$47,$70,$78,$F2,$82,  4,  6,$16,$2B,$28,$EF,$37,$74,$83,  5,$13,$16,$2E,$28,$F1,$84,  6,$2A,$16,$2F,$85,  5,$14,$17,$6C,$86,  7,$76,$16,$32,$87; 0
		dc.b   5, $E,$17,$71,$28,$EE,$88,  4,  5,$17,$6A,$28,$F0,$89,  4,  4,$17,$6B,$38,$F3,$8A,  8,$EB,$18,$F5,$8B,  7,$6F,$38,$F6,$8C,  6,$2D,$18,$EA,$27,$6E,$8D,  5,$12,$16,$30,$27,$6D,$8E,  7,$73,$FF,$18,$C8,$E4,$21,$23,$A8,$E8,$20,$C7,$33,$EC,$20,$C7,$33,$98,$83; 64
		dc.b $1B,$1C,$84,$18,$C8,$E4,$34,$23,$60,  1,$CC,$FA,$CF,$79,$EF,  7,$51,$CC,$E6,$7B,$C1,$D0,$E6,$73,$36,  7,$23,$B4,$E4,$73,  7,$69,$F6,$3B,$4E,$40,$ED,$3B,$4C,$8E,$40,$E4,$76,$9C,$8C,$80,  7,$BC,$FA,$C6,$9B,$CF,$79,$91,$B8,$1E,$F3,$43,$53,$98,$32,$34,$32,$3A; 128
		dc.b   3,$23,$53,$23,$98,$35,$37,$1B,$8D,  1,$A1,$F6,$37,$1A,$83,$43,$53,$53,$20,  1,$A0,$E4,$86,$A6,$E1, $A,$1C,$CD,$C6,$80,$EA,$3A,$1D,$46,$80,$D8,$EA,$32,$3A,  3,$71,$B8,$C8,$DC, $F,$B1,$B8,$D4,$D4,  0,  1,$B8,$72,$EC,$68,  0,$E5,$51,$B1,$A0,$81,  0,  0,  0; 192
		dc.b   0,  0,  0,  0,$34,$53,$23,$23,$40,$69,$A2,$8E,$48,$39,$20,$83,$1D,$46,$C2,  4,$64,  0,  0,  0,  0,  2, $A,$6A,$68,$6A, $D, $D, $C,$8C,$80,  0,  1, $A,$1A,$9B,$81,$A9,$B4,  8,$1A,$19, $D,  8,$E8,$64,$34,$63,$23,$51,$A1,$19,  0, $C,$8E,$87,$31,  6,$3A,$8D; 256
		dc.b $44,  8,$D4,$DC,$34,$43,$70,$D0,$8D,$86,$84,$74,$1A,$11,$90,$D1,$4D,  4,$2A,$32,$32,$10,$63,$20,  0, $F,$C3,$1F,$E6,$C3, $A,$AE,$7E,$17,$EC,$7C,$AE,$A6,$4F,$6B,$A9,$93,$DA,$77,$EC,$7D,$73,$AA,$72,$3E,$97,$48,$CB,$A4,$AD,$3B,$2B,$95,$AF,$AE,$3C,$ED,$87,$49; 320
		dc.b $63,$16,$E7, $E,$10,$E1, $E,$18,$E7,$A5,$80,  0,$31,$FD,$D5,$DE,$BE,$D5,$75,$FF,$6E,$FF,$1F,$D5,$D3,$F6,$75,$EF,$A7,$F0,$EB,$9E,$DB,$AB,$96,$EC,$26,$DF,$CC,$C1,$AD,$CB,$74,$9A,$DC,$A3,$6C,$9B,$74,$70,$2F,$DE,$6D,$29,$75,$6D,$B3,$9E,$16,$27,$96,$6C,$4F,$E0; 384
		dc.b $CF,$2A,$A2,$EF,  2,$6B,$DB,$59,$19,$57,$9B,$FF,$A3,$8D,$80,$FA,$F9,$6F,$F5,$D3,$F5,$7D,$68,$E5,$4F,$62,$E2,$BF,$9B,$8A,$BB,$56,$F2,$49,$AD,$CA,$5D,$DF,$B4,$27,$22,$97,$E9,$75,$12,$95,$F4,$8A,$D9,$3A,$8B,$F7,  5,$36,$D5,$DC,$A8,$C8,$EC,$9C,$A8,$C8,$EC,$9D; 448
		dc.b $A8,$91,$78,$EA,$27,$6B,$F0,$42,$70,  1,$39,$21,$1A,$62,$84,$A8,$E4,$7D,$CB,$DC,$87,$4F,$17,$2E,$BD,$97,$CD,$75,$DF,$4B,$E6,$85,$3B,$E9,$55,$26,$55,$DE,$5B,$3F,$71,$32,$AA,$9D,$BB,$AC,$E3,$93,$B5,$12,$FE,$99,$DA,$89,$5C,  0,  0,  0,  0, $B,$C9,$CB,$E9,$D9; 512
		dc.b $67,$A7,$6D,$7A,$17,$9C,$75,$70,$F3,$E1,$AF,$82,$F0,$3D,$49,$18,$2A,$16,$8A,$85,$A2,$A1,$1B,$3E,$AD,$64,$7D,$F5,$56,$4F,$EF,$B1,$F9,$80, $D,$39,$20,  0,  0,  7,$72,$EB,$57,$78,$6B,$25,$2F,$32,$D6,$5F,$A9,$CD,$BC,$A1,$C1,$FE,$5E,$56,$42,$C1,$4E,$30,$D8,$5A; 576
		dc.b $9C,$65,$55,$71,$52,$52,$62,$79,$32,$A1,$1D,$8D,$AF,$FA,$3A,$F3,$3B,$29,$18,$15,$75,$13,$94,$8C,$AB,$27,$29,$1E,$7A,$C9,$FF,$D1,$C7,$31,$1B,$B1,$2D,$97,$42,$FD,$85,  6,$BC,$96,$15,$97,$18,$47,$53,$95,$F1,$45,$72,$BE,$28,$AE,$57,$D8,$91,$7E,$6D,$51,$3E,$2D; 640
		dc.b $4A,$89,$F1,$6A,$54,$50,$26,$BE,$2F,$B1,$A2,$F4,$D5,$9A,$6A,$4E, $A,$99,$D5,$42,$4B, $E,$AA,$F3,$3A,$F3,$7F,$F4,$5F,$C2,$16,  0,$FC,$31,$FE,$6C,$30,$AA,$E7,$E1,$7E,$C7,$CA,$EA,$64,$F6,$BA,$99,$3D,$A7,$7E,$C7,$D7,$3A,$A7,$23,$E9,$74,$8C,$BA,$4A,$D3,$B2,$B9; 704
		dc.b $5B,$8B,$17,$3B,$60,$D6,$4A, $D,$67,$37,$B7,  7,$B7,  7,$93,$67,  2,$E9,$8E,$60,  0,$31,$FD,$D5,$DE,$BE,$D5,$75,$FF,$6E,$FF,$1F,$D5,$D3,$F6,$75,$EF,$A7,$F0,$EB,$9E,$DB,$AB,$96,$EC,$26,$DF,$CC,$C1,$AD,$CB,$74,$9A,$DC,$A3,$6C,$9B,$74,$70,$2F,$DE,$6D,$29,$75; 768
		dc.b $6D,$B3,$9E,$15,$92,$47,$BF,$3A,$EC,$7B,$66,$CF,$CD,$DE,  4,$D7,$B6,$B2,$32,$AF,$37,$FF,$47,$1B,  7,$A6,$18,$FF,$36,$18,$55,$73,$F0,$BF,$63,$E5,$75,$32,$7B,$5D,$4C,$9E,$D3,$BF,$63,$EB,$9D,$53,$91,$F4,$BA,$46,$5D,$25,$69,$D9,$5C,$AD,$7D,$71,$E7,$6B,$CB,$A4; 832
		dc.b $A1,$63,$73,$C7,$3D,$2C,  0,  0,  0,$C7,$F7,$57,$7A,$FB,$55,$D7,$FD,$BB,$FC,$7F,$57,$4F,$D9,$D7,$BE,$9F,$C3,$AE,$7B,$6E,$AE,$5B,$B0,$9B,$7F,$33,  6,$B7,$2D,$D2,$6B,$72,$8D,$B2,$6D,$D1,$C0,$BF,$79,$B4,$A5,$D5,$B6,$CE,$78,$58,$9E,$5C,$1A,$27,$C1,$88,$E3,$54; 896
		dc.b $5C,$A6,$55,$D5,$5A,$3C,$BB,$E3,$8D,$80,$19,$79,$C5,$7F,$A3,$FC,$9C,$D0,$93,$C8,$C9,$A3,$54, $B,$BE,$AC,$4B,$BF,$4B,  0,  0,  0,$3B,$97,$5A,$BB,$C3,$59,$29,$79,$96,$B2,$FD,$4E,$6D,$E5,$5F,$91,$42,$CD,$23,$C8,$80,  0,  1,$1B,$B1,$2D,$97,$42,$FD,$85,  6,$BC; 960
		dc.b $96,$15,$97,$18,$47,$53,$95,$F1,$45,$72,$BE,$28,$AE,$57,$D8,$91,$7E,$6D,$53,$EC,$6A,$55,  8,$B5,$2A,$84,$5A,$F8,$66,$D0,$24,$D4,$50,$4D,$48,$58,$AA,$16,$34,$24,$2F,$48,$FA,$47,$D2,$3E,$84,  0,$3C,$31,$FE,$6C,$30,$AA,$E7,$E1,$7E,$C7,$CA,$EA,$64,$F6,$BA,$99; 1024
		dc.b $3D,$A7,$7E,$C7,$D7,$3A,$A7,$2F,$E1,$5D,$28,$F4,$95,$B9,$D7,$2B,$5F,$5C,$79,$DB, $E,$92,$C6,$2D,$CF,$D2,$23,$1F,$DD,$5D,$EB,$ED,$57,$5F,$F6,$EF,$F1,$FD,$5D,$3F,$67,$5E,$FA,$7F, $E,$B9,$ED,$BA,$B9,$6E,$C2,$6D,$FC,$CC,$1A,$DC,$B7,$49,$AD,$CA,$36,$C9,$B7,$47; 1088
		dc.b   2,$FD,$E6,$D2,$97,$56,$DB,$39,$E1,  4,$E4,$5D,$7C,$B7,$FA,$E9,$FA,$BE,$B4,$72,$A7,$B1,$71,$5F,$CD,$C5,$5D,$AB,$79,$24,$D6,$E5,$27,$23,$BF,$68,$4E,$45,$2F,$D2,$A2,$92,$95,$F4,$8A,$D9,$3A,$8B,$F7,  5,$36,$D5,$DC,$A8,$C8,$EC,$9C,$A8,$C8,$EC,$9D,$A8,$91,$78; 1152
		dc.b $EA,$27,$6B,$F0,$42,$70,  1,$39,$21,$1A,$62,$84,$A8,$E4,$7D,$CB,$DC,$87,$4F,$17,$2E,$BD,$97,$CD,$75,$DF,$4B,$E6,$85,$3B,$E9,$55,$26,$55,$DE,$5B,$3F,$71,$32,$AA,$9D,$BB,$AC,$E3,$93,$B5,$12,$FE,$99,$DA,$89,$5C,$5E,$71,$53,$E1,$AF,$D0,$93,$91,  0,  7,$72,$EB; 1216
		dc.b $57,$78,$6B,$25,$2F,$32,$D6,$5F,$A9,$CD,$AC,$C4,$80,$11,$BB,$12,$D9,$74,$2F,$D8,$50,$6B,$CB,$1A,$CB,$48,$80,  0,$C7,$D7,$4E,$BF,$CD,$C2,$9F,$B3,$7D,$3B,$52,$78,$3F,$2A,$4E,$56,$9C,$F6,$4E,$5D,$47,$FB,$39,$5A,$47,$75,$72,$B4,$BF,$A5,$2B,$7B,$EC,$C0,$DA,$3D; 1280
		dc.b $1E,$5F,$C2,$84,$7B,$F4,$B2,$1F,$FA,$FF,$DF,$FE,$FD,$8F,$6D,$7F,$9B,$3D,$D8,$36,$F3,$FD,$E4,$99,$5D,$6E,$5D,$52,$4E,$C5,$95,$B8,$23,$8B,$AB,$6A,$3B,$AB,$6F,$34,$5F,$E6,$B1,$26,$DE,$75,$C7,$F8,$51,$3E,$85, $C,$C6,$3D,$60,$69,$71,$A1,$F8,$EC,$7A,$CF,$F7,  8; 1344
		dc.b $B5,$6A,$E2,$A5,$D8,$95,$D9,$38,$9C,$48,$EC,$9C,$4E,$24,$5E,$2A,$4B,$FA,$9F,  2,$42,$FE,$49,$24,$7C,$EC,$48,$A1,$42,$28,$4D,$A5,$80, $F,$E1,$C3,$F8,$BE,$3F,$B5,$F0,$45,$4A,$6A,$E3,$A9,  9,$5D,$93,$95,  9,$1D,$93,$95,  9,$17,$8A,$FF,$27,$C3,$59,$7F,$64,$9B; 1408
		dc.b $F9,$25,$DE,$96,$7F,$8B,$C8,  0,  1,$CF,$92,$77,$14,$15,$32,$2F,$D2,$2A,$71,$2F,$D2,$AA,$71,$2F,$D2,$6B,$D4,$5E,$28,$5A,$8B,$BC,$BF,$53,$9B,$67,  2,  0,$6E,$C6,$DF,$D7,$F5,$3F,$F9,$FF,$BC,$FD,$7F,$56,$DF,$DE,$4A,$1F,$BD,$18,$FF,$31,$F6,$FE,$FF,$77,$E3,$F2; 1472
		dc.b $FD,$FD,$BF,$C6,$FD,$FE,$5F,$BF,$EA,$FD,$FE,$E9,$7F,$33,  3,$FE,$68, $F,$DD,$A7,$E3,$FF,$98,$FD,$DB,$5F,$B4, $D,  0,  0; 1536
S1Nem_SYZSnail:	dc.b $80,$3D,$80,  3,  2,$14,  6,$24,  8,$35,$13,$45,$15,$56,$32,$66,$3A,$73,  1,$81,  3,  0,$15,$14,$28,$F3,$48,$F8,$82,  6,$34,$18,$F6,$83,  5, $E,$17,$76,$27,$7A,$84,  6,$35,$85,  6,$38,$86,  5,$18,$18,$F7,$87,  5, $F,$18,$F2,$88,  5,$16,$89,  6,$33,$8A,  6; 0
		dc.b $39,$8B,  6,$37,$8C,  6,$36,$8D,  7,$78,$8E,  5,$17,$8F,  5,$12,$17,$77,$FF,$24,$92,$4C,$DF,$8B,$6B,$8C,$EC,$9E,$AF,$B4,$5B,$3A,$FE,$B1,  5,$7F,$14,$41,$B6, $C,$38,$94,$C2,$C7,$E6,$95,$23,$DD,$9E,$ED,$36,$F2,$F0,$EE,$55,$C6,$EE,$6F,$CF,  9,$C9,$7E,$AD,$59; 64
		dc.b   9,$47,$E6,$9B,$94,$1B,$9F,$CD,$C0,$C8,$21,$BF,$BE,$5F,$94,$FD,$17,$A2,$49,$26,$3F,$48,$E8,$D5,$3F,$3B,$E9, $F,$BD,$24,$B5,$7C,  9,$84,$32,$73,$3B,$57,$B6,$DD,$A0,$36,$DD,$DF,$1D,$A9, $E,$A4,  7, $A,$B8,$55,$C0,$92,$4A,$7D,$31,$68,$1D, $F,$2A,$BE,$97,$DE; 128
		dc.b $77,$96,$F5,$E4,$6E,$26,$F2,$B8,$BC,$F3,$E0,$5B,$47,$B0,$56,$1B,$49,$F7,$AE,$77,$42,$CB, $D,$69,$89,$52,$4E,$4F,$41,$84,$BA,$E0,$BC,$17,$64,$E1,$5D,  5,$75,  4,$96,$EC,$FA,$62,$CE,$61,$D0,$F2,$AE,$A1,$5F,$75,$E7,$AD,$C5,$44, $F,$5C,$8B,  5,$C7,$E5,$3C,$37; 192
		dc.b $60,$A9,$CB,$A4,$B0,$FC,$ED,$76,$93,  6,$76,$68,$4A,$72,$CD,$A8,$E4,$2F, $E,$EF,$F9,$85,$DB,$BC,$FF,$5E,$D2,$4E,$EF,$39,$2E,$F5,$F3,$FE,$7C,$7C,$12,$4F,$EC,$F4,$F5,$30,$4B,$3F,$CE,$1F,$30,$53,$D3,$F2,$7A,$EC,$82,$7A, $C,$20,$29,$2D, $C,$F4,$94,$C3,$95,$BA; 256
		dc.b $B4,$DC,$1A,$4B,$D8,$37,$76,$11,$26,$19, $A,$D0,$92,$49,$9B,$CA,$B5,$45,$A5,$D0,$79,$EA,$4F,$67,$B6,$2C,$F6,$7D,$ED,$95,$F2,$B7,$57,$CA,$CA,$F5,$BC,$59,$AC,$AE,$D2,$56,$BA, $C,$FF,$CC,$7B,$E7,$2C,$58,$33,$F0,$31,$47,$E2,$97,$52,$BD,$3B,$DA,  5,$C5,$A0,$4A; 320
		dc.b $B7,$95,$2D,$51,$CC,$F7,$FC,$D6,$43,$2F,$21,$D3,$C7,$4F,$74,$FF,$4F,$37,$F9,$A7,$30,$81,$3F,$D1,$20,$DA,$46,$84,$E8,$49,$24,$92,$4E,$4F,$C5,$A6,$FC,$3E,$F6,$C6,$76,$78,$7D,$6D,$9D,$7F,$58,$82,$BF,$8A,$20,$DB,  6,$1C,$4A,$61,$63,$F3,$4A,$91,$EE,$DF,$D7,$F0; 384
		dc.b $EE,$75,$DF,$9D,$DC,$DF,$9E,$13,$92,$FD,$5A,$B2,$12,$8F,$CD,$37,$28,$37,$3F,$9B,$81,$90,$43,$7F,$7C,$BF,$29,$FA,$2F,$45,$9D,$FB,$45,$D9,$7E,$DF,$5F,$6F,$36,$7D,$3B,$21,$3A,$39, $A,$87,$21,$50,$E2,$EC,$A8,$49,$24,$92,$49,$26,$31,$4C,$5A,  7,$95,$5F,$71,$7D; 448
		dc.b $F5,$FD,$60,$5B,$AC,$E8,$D2,$A8,$E0,$6E,$1D,  2,$6E,$67,$2E,$2F,$B2,$F5,$C0,$6F,$CE,$48,$47,$A9,$4F,$CD,  3,$49,$DD,$CC,$27,$2E,$D5,$12,$4E,$A8,$EF,$95,  9,$24,$9F,$4F,$C5,$BB,$36,$B8,$7D,$F7,$81,$D0,$F2,$8A,$70,$3F,$3D,$BC,$F8,$41, $F,$D9,$B0,$5F,$AD,$CC; 512
		dc.b $5B,$B3,$6A,$DB,$4A,$35,$87,$4A,$35,$F1,$6C,$E7,$6A,$2E,$5A,$C1,$AD,$9D, $B, $C,$C2,$76,$74,$2F,$67,$4A,  7,$69,  5,$EE,$BB,$C0,$4E,$F3,$4F,$4E,$15,$70,$A8,$EB,$41,$5F,$D9,$E9,$EA,$60,$96,$7F,$9C,$3E,$60,$A7,$A7,$E4,$F5,$D9,  4,$F4,$18,$40,$52,$5A,$19,$E9; 576
		dc.b $50,$E3,$93,$82,$93,$7B, $C,$86,$43,$21,$5A,$12,$49,$24,$92,$4D,$75,$9B,$F1,$69,$BF, $F,$BE,$D0,$3A,$1E,$55,$7D,$2F,$BC,$EF,$2D,$C4,$FC, $D,$FA,$E2,$F8,$CE,$CB,$59,$6F,$AC,$5B,$3A,$FE,$B1,  5,$7F,$14,$41,$B6, $C,$38,$94,$C2,$C7,$E6,$83,$7B,$6D,$EF,$A8,$4E; 640
		dc.b $7D,$F6,$7E,$9C,$53,$5A,$F9,  7,$78,$6F,$64,$F0,$B1,  1,$3C,$2A,$30,$4F,  7,$B4,  5,$6F,$CE,$E6,$E6, $B,$8D,$C6,$39,$DF,$9D,$9B,$F3,$C2,$72,$5F,$AB,$56,$42,$51,$F9,$A6,$E5,  6,$E7,$F3,$70,$32,  8,$6F,$EF,$97,$95,  8,$30,$FC,$9F,$E7, $F,$59,$E1, $A,$DA,$1E; 704
		dc.b $9F,$93,$D7,$E7,$3D,$9D,$AF,$63,$D6,$B9,$6B,$8A,$EB,$89,$1A,$E0,$A7,$57,$45,$B1,$39,$68,$74,$24,$CF,$C7,$EB,$26,$23,$5D,$15,$E7,$9C,$B4,$42,$29,$26,$A3,  4,$F7,$35,$22,$5D,$A1,$D6,$12,$5E,$B6,$61,$DF,$F3,$93,$A1,$27,$46,$70,$9F,$B1,$D0,$47,$E7,$2C,$3F,$45; 768
		dc.b $E1,$B8,$4E,$A8,$D9,$39,$4A,  7,$E7,$3B,$35,$22,$D4,$AD,$8B,$AB,$26,$FE,$1A,$FD,$FD,$7C,$FF,$9F,$1F,  4,$93,$F9,$CD,$3F,$67,$A5,$1D,  1,$B6,$CB,$6C,$EB,$A6,$73, $E,$43,$33, $E, $A,$D2,$5E,$C1,$BB,$B0,$89,$30,$C8,$56,$84,$92,$57,$C1,$24,$92,$4C,  2,$41,$20; 832
		dc.b $D0,$FF,$C4,$92,$7A,$D8,$F4,$E2,$4F,$52,$6F,$86,$15,$A1,$EB,$E0,$CF,$F5,$88,$36,$CA,$9B,$4C,$2E,$45,$79,$5C,$E0,$98,$A3,$4A,$A2,$F5,$EE,$84,$F8,$5C,$66,$CE,$6E,$1D,$12,$F5,$78,$1F,$AE,$3D,$7C,$12,$49,$24,$C0,$24,$12, $D, $F,$FC,$49,$27,$A9,$12,$49,$EA,$4D; 896
		dc.b $F0,$C2,$B4,$3D,$7C,$19,$FE,$B1,  6,$92,$A6,$D0,$E0,$B9,$15,$E5,$73,$B4,$51,$85,$42,$DF,$21,$29,$FE,$BC,$86,$72,$E1,$71,$9D,$78,$74,$4B,$D5,$E0,$7E,$B8,$CC,  0; 960
S1Nem_MZBat:	dc.b   0,$29,$80,  5, $A,$15, $E,$25, $F,$35,$16,$45,$14,$56,$2F,$66,$2E,$74,  3,$81,  4,  4,$15,$13,$38,$F3,$48,$F2,$82,  4,  6,$15,$18,$27,$6E,$83,  5, $B,$17,$78,$37,$7A,$84,  6,$32,$17,$74,$85,  6,$33,$86,  6,$38,$15,$15,$87,  5,$10,$16,$36,$27,$75,$88,  4; 0
		dc.b   2,$15,$12,$27,$6F,$37,$76,$47,$72,$58,$F6,$89,  3,  0,$15,$11,$26,$35,$36,$34,$47,$77,$8C,  8,$F7,$8D,  7,$73,$FF,$79,$56,$81,$5B,$5E,$50,$A2,  2,$47,$CE,$2C,$F8,$CD,$9F,$AA,$33,$BB,$A3,$B4,$42,$74,$67,$B3,$82,$75,$25,  4,$82,  9,$28,$6C,$38,$92,$87,$F5; 64
		dc.b $D5,$DC,$A0,$A8,$CA,$2B,$70,$21,$55,$BA,$3C,$4D,$6E,$19,$F1,$35,$BD,$75,$E8,$F6,$F1,$96,$76,$F1,$96,$76,$65,$DC,$D6,$A9,$5B,$65, $B,$40,$A8,$84,$12,$CD,$19,$BD,$A6,$41,$EC,$85,$17,$A4,$B5,$74,$B4,$74,$B4,$77,$68,$BB,$94,$55,$CA,$2A,$87,$20,$AF,$DB,$C8,$29; 128
		dc.b $71,$28,$10,$52,$EA,  8,$39,$73,$E2,$2E,$5C,$F8,$CC,$3B,$A5,$56,$FC,$F2,$F0,$CF,$CF,$2F,$17,$AD,$AF,$63,$95,$F0,$95,$21,$BD,$F0,$E4,$E8,$4B,$AA,$A0,$5B,$6A,$AD,$A3,$DA,  3,$92,$A3,$C9,$F1,$DF,$40,$4D,$78,$6B,$9A,$E6,$BF,$35,$DE,$8B,$BD,$17,$7F, $B,$BF,$36; 192
		dc.b $B9,$8C,$CC,$CC,$CC,$CA,$E1,$2A,$16,$A4,$FF,$67,$72,$7F,$27,$CB,$26,$27,  6,$2C,$F0,$E1,$8C,$F2,$C2,$82,$FA,$6E,  9,$95,$72,$5B, $F,$D0,$D5,$61,  4,$EB,$A7,$ED,$97,$AA,$EB,$E8,$7F,$8F,$1E,$B1,$92,$BF,$65,$D1,$9C,$BE,$9B,$A9,$B8,$CE,$E8,$52,  4,$1F,$21,$35; 256
		dc.b $4B,$C8,$87,$F4,$74,$F3,$1F,$A1,$D5,  7,$F4,$47,$FC,$7C,$F4,$9F,$F6,$53,$FF,$3D,$DD,$A5,$B4,$EB,$AB,  4,$2A,$85,$E2,$75,$C9,$78,$9E,$CB,$DD,$39,$7E,$C9,$35,$DC,$9B,$C3,$47,$CA,$9B,$DD,  9,$45,$50,$21,$FA,$10,$AF,$38,$BA,$7A,$3B,$FB,$2E,$EE,$FE,$EF,$4D,$1F; 320
		dc.b $DD,$F3,$D1,$DF,$D9,$77,$FA,$54, $C,$CE,$E2,$BA,$17,$42,$E2,$B8,$5C,$86,$77,$A5,$C2,$E0,$66,$66,$68,$42,$89,$2A,  5,$14,$2C,$14,$50,$74,$15,$A9,$6C,$4E,$8A,$A4,$66,$67,$46,$76,$4C,$FC,$2B,$36,$7E,$EC,$F2,$7B,$2F,$A3,$3B,$35,$E5,$5C,$94,$11,$73,$A9,$99,$B5; 384
		dc.b $D8,$BF,$17,$AF,$75,$BD,$62,$FD,$15,$AF,$6B,$68,$66,$66,$72,$45,$CE,$A4,$38,$5F,$ED,$9D,$9B,$2E,$AB,$7B,$7A,$B3,$7E,$8E,$98,$85,$F8,$39,$7A,$61,$DB,$C3, $F,$6C,$17,$5D,$ED,$FD,$79,$43,$F6,$C5,$FE,$7F,$D3,$2B,$1F,$F7,$16,$42,$A9,$3E,$75,$83,$E7,$D5,$E9,$D9; 448
		dc.b $E5,$A3,$F8,$81,  4,$7C,$2A,$57,$4C,$B6,$78,$49,$5A,$2A,$28,$58,$28,$A1,$6D,$4A,$91,$33,$57,$F1,$CA,$DF,$C7,$37,$C2,$9B,$15,$24,$66,$66,$76,$6B,$B1,$7E,$2F,$65,$D3,$35,$E5,$44,$5A,$51,$16,$94,$E1,$7C,$53,$36,$5D,  3,$2E,$C2,$6C,$F1,$E6,$E1,$E5,$1F,$E8,$99; 512
		dc.b $AB,$26,$BF,$3C,$59,$B3,$CB, $F,$E9,$B9,$F5,$C9,$7B,$94,$95,$F4,$C9,$5D,$BF,$47,$FA,$62,$E3,$65,$D5,$65, $A,$C3,$F4,$72,$DB,$8F,$1C,$A1,$8F,$64,$FF,$42,$7F,$A0,$CC,$CC,$CC,$DA,$E5,$B0,$EA,$14,$B6,  8,$55,$25,$E2,$75,$82,$F1,$3E,$BB,$A7,$BF,$72,$69,$84,$DE; 576
		dc.b $12,$3E,$4A,$D7,$C8,$4E,$3F,$A1,$1E,$71,$21,$FD,$12,$13,$D6,$41,$34,$28,$A6,$AA,$20,$AD,$5C,$41,$3F,$F1,$FF,$8F,$FC,$7F,$A2,$3E,$DD,$F7,$C7,$7E,$9F,$F8,$21,$49, $A,$48,$15,$A4,  9,$D0,$56,$F0,$50,$25,$6F,$50,$27,$46,$56,$90,$BE,$2F,  4,$A1,$42,$B8,$AE,  6; 640
		dc.b $66,$63,$DA,$3D,$83,$BB,$5B,$7D,$25,$79,$19,$9D,$C5,$CE,$F8,$7B,$FE,$76,$D0,$FC,$FF,$BF,$37,$97,$BF,$E7,$6C,$39,$99,$DF,$FA,$DA,$17,$EB,$3F,$3A,$E2,$FD,$7F,$E7,$39,$A8,$BF,$9F,$EF,$CC,$BF,$5F,$F9,$CE,$6A,$E7,$FA,$CF,$CE,$BB,$F5,$A7,$40,  0; 704
S1Nem_Splats:	dc.b $80,$1D,$80,  4,  5,$14,  4,$25, $F,$34,  8,$45,$17,$55,$15,$66,$33,$74,  2,$81,  3,  0,$15,$16,$27,$76,$82,  5,$14,$83,  5, $E,$17,$77,$26,$3A,$84,  7,$73,$85,  5,$13,$16,$36,$86,  5,$18,$87,  6,$34,$17,$79,$88,  5,$12,$17,$7A,$89,  6,$32,$8A,  6,$37,$8B; 0
		dc.b   7,$78,$17,$72,$8C,  6,$35,$17,$7B,$8E,  4,  6,$16,$38,$8F,  4,  3,$18,$F8,$FF,$22,$CF,$C5,$7C,$57,$C2,$CE,$B3,$D6,$F9,$6B,$88,$A0,$C0,$89,$D6,$4B,$3D,  6,$7A,$46,$2C,$41,$FB,$E2,$75,$9F,  6,$FA,$2D,$9D,$7F,$8D,$62,$85,$4E,$F7,$A7,$7A,$CC,$45,$39,$8E,$77; 64
		dc.b $B3,$3F,$C2,$83,$AD,$A4,$F9,$BA,$D5,$D0,$E5,$77,$62,$50,$7D,$3C,$D4,$DD,  1, $D,$D0,$68,$69,$C8,$7E,$BB,$96,$D7,$9F,  9,$F9,$A9,$B2,$7E,$69,$19,$37,$4B,$7E,$8A,$4A,$36,$FC,$B0,$59,$64,$6C,$10,$23,$82,$D3,$68,$73,$E6,$8E,$78,$BF,$95,$37,$B6,$7B,$FE,$64,$F7; 128
		dc.b $8F,$D5,$3D,$C5,$57,  8,$EA,$9F,$D3,$4E,$A8,$1F,$DB,$F2,$8F,$F3,$30,$B3,$7B,$AC,$6C,$9A,$58,$C4,$93,$F6,$32,$74,$59,$F2,$76,  1,$E1,$C9,$DF,$F4,$CE,$8E,$90,$13,$AE,$E9,$AF,$F0,$E4,$76,$FD,$DD, $F,$F3,$4F,$17,$B6,$CD,$DB,$6E,$17,$F4,$BC,$3F,$F5,$C4,$45,$70; 192
		dc.b $44,$45,$98,$22,$2C,$E8,$54,$22,$A1,$5F,$2F,$4D,  1,$26,$CF,$F6,$4F,$64,$F6, $A,$A1,$67,  2, $D,$3F,$4B,$7F,$E7,$2F,$17,$1F,$15,$B1,$11,$66,$D9,$98,$FD,$4F,$90,$81,$8D,$59,$7B,$31,$A8,$92,  6,$35,$12,$40,$C6,$AD,$24, $C,$6A,$D2,$5F,$C6,$F3,$E5,$BF,$3D,$5B; 256
		dc.b $5F,$CE,$FE,$F0,$D7,$F5,$EB,$FB,$1F,$D7,$88,$EC,$44,$50,$D9,$9E,$62,$39,$35,$67,$AD,$F2,$D7,$11,$41,$81,$13,$AC,$96,$7A, $C,$F4,$8C,$58,$83,$F7,$C4,$EB,$3E, $D,$F4,$5B,$3A,$FF,$1A,$C5, $A,$9D,$EF,$4E,$F5,$98,$8A,$73,$1C,$EF,$66,$7F,$85,  7,$5B,$49,$F3,$75; 320
		dc.b $AB,$A1,$CA,$EE,$C4,$A0,$FA,$79,$A9,$BA,  2,$1B,$A0,$D0,$E0,$1E,$63,$E2,$B6,$26,$4F,$D5,$72,$D7,$F2,$52,$51,$B7,$E5,$82,$CB,$23,$50,$81,$1C,$6B,$4D,$A1,$CF,$9A,$39,$E2,$FE,$54,$DE,$D9,$EF,$F9,$93,$DE,$3F,$54,$F7,$15,$5C,$23,$AA,$7F,$4D,$3A,$A0,$7F,$6F,$CA; 384
		dc.b $3F,$CC,$C2,$CD,$EE,$B1,$B2,$69,$63,$12,$4F,$D8,$C9,$D1,$67,$C9,$D8,  7,$87,$27,$7F,$D3,$3A,$3A,$40,$4E,$BB,$A6,$BF,$C3,$91,$A8,$4F,$4F,$CB,$D7, $B,$D9,$8D,$5B,$24,$96,$34,$69,  7,$DB,$2B,$2F,$EA,$EF,$FA,$5E,$55,$DB,$97,$EF,$93,$65,  9,$FC,$E2,$22,$20,$44; 448
		dc.b $59,$D0,$A8,$45,$42,$BE,$5E,$9A,  2,$4D,$9F,$EC,$9E,$C9,$EC,$15,$42,$CE,  4,$1A,$7E,$96,$E6,$F3,  8,$3F,$5E,$23,$B1,$57,$F5,$3A,$4B,$24, $C,$6A,$32,$49,$63,$46,$90,$4C,$BD,$36,$24,$81,$8D,$5B,$24,$96,$34,$69,  6,$FC,$6E,$BF,$8D,$D7,$9F,$B3,$D7,$F3,$BF,$BC; 512
		dc.b $FF,$89,$11,$11,$71,$5F,$8A,$80; 576
S1Nem_Bomb:	dc.b $80,$29,$80,  4,  5,$14,  6,$25,$13,$34,  8,$45, $F,$55, $E,$66,$32,$73,  0,$81,  4,  2,$14,  3,$28,$F6,$38,$F7,$82,  5,$17,$83,  6,$33,$84,  6,$34,$85,  6,$37,$86,  5,$18,$17,$76,$87,  6,$38,$88,  4,  4,$16,$36,$89,  5,$15,$17,$7A,$8A,  6,$3A,$8B,  7,$72; 0
		dc.b $8C,  5,$12,$16,$35,$37,$78,$8D,  5,$16,$17,$73,$8E,  7,$77,$8F,  5,$14,$17,$79,$FF,  0,  0,  0,$C9,$1F,$B3,$D0,$39,$27,$48,$2F,$58,$64,$9E,$B3,$24,$91,$BC,$80,$11,$5C,$89,$14,$9E,$72,  6,$F2,$E6,  0,  1,$78,$FD,$32,$70,$D4,$25,$3A,$2A,$2D,$3B,$D0,$95,  3; 64
		dc.b $FF,$53,$E6,$7F,$A6,$3A,$35,$3B,$3B,$B1,$D2,$7E,$7A,$A3,$8A,$25,$CA,$AF,$E0,$9D,$7C,$D1,$FE,$9B,$49,$9C,$F7,$2A,$FE,$A1,$8B,$4F,$13,$F6,$6F,$EE,$73,  0,  0,  2, $D,$9F,$56,$48,$C2,$93,$F1,$53,$49,$F6,$77,$96,$24,$82,$CA,$98,$47,$D5,$C5,$F9,$E4,$99,$2E,$C0; 128
		dc.b $AA,$DB,$2A,$54,$9A,$56,$43,$99,$BA,$56,$20,  0,  0,  8,$47,$EC,$F4, $E,$49,$D2, $B,$D6,$19,$27,$AC,$C9,$24,$6F,$20,  4,$57,$22,$45,$27,$9C,$81,$BC,$B9,$80,  0,$5E,$3F,$4C,$9C,$35,  9,$4E,$8A,$8B,$4E,$F4,$25,$40,$FF,$D4,$F9,$9F,$E9,$8E,$8D,$4E,$CE,$EC,$74; 192
		dc.b $9F,$9E,$A8,$E2,$8E,$FC,$55,$F5,$CB,$F3,$C8,$FF,$4D,$A4,$CE,$7B,$95,$7F,$50,$C5,$A7,$89,$FB,$37,$F7,$39,$80,  0,  1,  6,$CF,$AB,$24,$61,$49,$F8,$A9,$A4,$FB,$3B,$CB,$12,$41,$65,$6E,$91,$FC,$13,$CA,$F9,$A4,$C9,$76,  5,$56,$D9,$52,$A4,$D2,$B2,$1C,$CD,$D2,$B1; 256
		dc.b $4C,$DC,$61,$DE,$9F,$7F,$CD,$2F,$EC,$CA,$7F,$E2,$5F,$F0,$FF,$F7,$58,$D7,$6F,  7,$B7,$BC,$C9,$D7,$CE,$3F,$2B,$F9,$28,$FC,$A1,$C7,$BA,$54,$A6,$61,  9,  8,$46,$F6,$EA,$7F,$95,$6C,$69,$BE,$7F,$E4,$BF,$FC,$5C,$6E,$31,$95,$DF,$F9,$32,$7F,$E8,$9F,$EC,$3F,$FB,$AC; 320
		dc.b $6A,$59,$F8,$3C,$CB,$F4,$6F,$35,$CD,$78,$FD,$97,$E4,$F7,$B9,$FE,$D2,$3F,$A8,$6B,$FC,$14,$A8,$71,$E4,$84,$FE,$59,$63,$4D,$F3,$8F,$D2,$5E,$3D,$D8,$DC,$60,  7,$7E,$55,$DF,$94,$71,$FF,$F7,$58,$D4,$FC,$55,$1A,$BB,$54,$91,$B9,$6B,$5E,$4B,$F9,$5C,$36,$9C,$7F,$D3; 384
		dc.b $4F,$F8,$9B,$93,$24,$27,$10,$C8,$AF,$96,$6E,$31,  6,$E3,  0,  7,$FE,$4E,$EF,$FC,$96,$7F,$CD,$FE,$64,$6A,$7E,$2F,$A3,$6D,$7D,$31,$3D,$71,$17,$FE,$A5,$D7,$F6,$67,$FD,$37,$FB,$32,$55,$D2,$E5,$96,$2E,$4E,$C5,$E3,$F4,$97,$8F,$70,$18,$DC,$60,  7,$FE,$8D,$FF,$A2; 448
		dc.b $7F,$B7,$FF,$75,$8D,$4F,$C1,$B5,$51,$49,$51,$73,$EB,$93,$6F,$6C,$CB,$F2,$FA,$6E,$D7,$CF,$FA,$9F,$F1,$37,$25,$5C,$42,$AE,$E5,$96,$34,$DF,$38,$FD,$25,$E3,$DC,  0,$32,$DE,$E1,$D2,$CC,  0,  0,  0,$3A,$A4,$22,$59,$5A,$4B,$22,$99,$5A,$4B,$69,$34,$AC,$DC,$DB,$9A; 512
		dc.b $F3,$26,$36,$B3,$F7,$52,  0,  0,  3,$E8,$53,$C4,$E4,$B8,$5E,$DC,$97,$8C,$59,$BA,$B2,$D9,$6D,$DB,$A8,$B7,$58,$EA,$2D,$D2,$FE,$69,$68,$BF,$9A,$5C,$49,$53,$F3,$52,$9D,$16,$58,  0,  0,  4,$69,$28,$B4,$8E,$56,$62,$82,$5B,$3A,$C2,$CE,$B2,$94,$13,$5A,$47,$2B,$41; 576
		dc.b $C4,$BB,$F3,$EF,$26,$BD,$1A,$97,$59,$52,$29,$21,$2A,$45,$24,$B7,$A3,$52,$ED,$2E,$FC,$FB,$C9,$40; 640
S1Nem_Orbinaut:	dc.b $80,$1F,$80,  4,  4,$16,$37,$25,$12,$34,  7,$44,  8,$55,$18,$65,$17,$73,  0,$81,  3,  1,$16,$3A,$82,  5,$15,$83,  4,  5,$16,$3C,$84,  7,$7A,$85,  6,$36,$86,  5,$19,$87,  4,  6,$88,  5,$13,$89,  8,$F8,$8A,  6,$3B,$17,$7B,$8B,  8,$FA,$8C,  5,$16,$8D,  5,$14; 0
		dc.b $8E,  5,$1A,$8F,  5,$1C,$FF,  0,$5D,$63,$C6,$75,$46,$22,$53,$D9,$18,$EF,$3E,$1D,$99,$F3,$A3,$89,$A7,$E5,$9E,$78,$F8,$D4,$76,$9C,$DA,$3D,$C5,$40,$A8,$5B,$9F,$31,$D2,$DC,$80,  2,$7F,$49,$14,$C5,$59, $C,$16,$42,$1C,$D7,$F4,$B2,$AB,$ED,$2E,$37,$1C,$CD,$26,$9C; 64
		dc.b $94,$D2,$71,$AC,$EB,$92,$D9,$3F,$3E,$9D,$CB,$6F,$D5,  0,  0,$92,$BF,$4A,$7F,$67,$F9,$22,$9F,$D1,  0,  4,$A8,$A9,$BA,$91,$75,$22,$EA,$40,$18,$22,$F5,$30,$70,$6A,$5F,$A8,$35,$52,$F5,$EA,  8,  0,  1,$85,$8F,$19,$D5,$18,$89,$4F,$76,$3B,$CF,$9E,$B7,$69,$67,$5E; 128
		dc.b $B1,$34,$E9,$E7,$8F,$8D,$47,$69,$CD,$A3,$DC,$54, $A,$85,$B9,$F3,$1D,$2D,$C8,  0,$27,$F4,$91,$4C,$55,$90,$C1,$64,$21,$CB,$7E,$96,$4D,$B4,$B6,$DF,$6E,$37,$1C,$CD,$26,$9C,$94,$D2,$71,$AC,$EB,$92,$D9,$3F,$3E,$9D,$CB,$6F,$D5,  0,  0,$92,$BF,$4A,$7F,$67,$F9,$22; 192
		dc.b $9F,$D1,  0,  4,$A8,$A9,$BA,$91,$75,$22,$EA,$40,$18,$22,$F5,$30,$70,$6A,$5F,$A8,$35,$52,$F5,$EA,  8,  0,  1,$8B,$47,$E7,$19,$EC,$8C,$44,$A7,$BB,$1D,$E7,$C3,$BB,$4B,$3E,$8E,$27,$DF,$4F,$3C,$7C,$6A,$36,$4E,$77,$1F,$95,$8A,  1,$41,$6B,$9F,$CE,$63,$AB,$5C,$80; 256
		dc.b   2,$7F,$75,$2C,$62,$8C,$86, $B,$21, $E,$59,$3D,$C9,$93,$BD,$FB,$96,$CD,$C7,$FA,$9A,$4D,$39,$29,$A4,$E3,$59,$D7,$25,$DA,$7E,$7D,$36,$97,$7F,$A5,  0,  1,$2B,$3F,$56,$3F,$BC,$FC,$E9,$4F,$E8,$80,  2,$50,$50,$DE,$C4,$5E,$C4,$5E,$C4,  1,$82,$2F,$43,  7,  6,$85; 320
		dc.b $FA,$83,$4B,$17,$A7,$50,$40,$18,$B5,$FB,$DF,$2F,$6D,$F3,$DD,$12,$99,$93,$1B,$21,$95,$13,$25,$E9,$9B,$65,$3B,$CD,$13,$36,$CF,$D3,$4D,$50,$B1,$B5,$3F,$3C,$ED,$2A,$7D,$63,$DE,$EB,$2C,$D6,$8B,$2F,$CE,$69,$34,$BB,$D9,$CD,$CE,$B1,$41,$16,$DD,$68,$96,$CD,$9E,$C9; 384
		dc.b $98,$35,$D6,$15,$DB,$7F,$29,$EF,$D4,$BC,$FC,$A2,$BF,$EB,$91,$5A,$BA,$92,$A3,$66,$8E,$B4,$F4,$5E,$89,$AB,$52,$F4,$1B,$80; 448
S1Nem_Caterkiller:dc.b $80,$10,$80,  3,	 0,$14,	 3,$24,	 2,$35,$13,$46,$36,$56,$39,$74,	 8,$81,	 4,  5,$16,$2E,$28,$F8,$82,  4,	 4,$15,$18,$83,	 4,  6,$16,$3B,$84,  6,$3A,$18,$F9,$85,	 5,$19,$86,  5,$15,$87,	 5,$16,$16,$3D,$88,  6,$37,$89,	 5,$14,$18,$FA,$8A,  5,$1A,$18,$FB,$8B;	0
		dc.b   6,$38,$8C,  6,$2F,$8D,  5,$12,$8E,  4,  7,$8F,  6,$3C,$FF,$2B,$E5,$B5,$E7,$21,$79,$DC,$18,$29,$C8,$33,$89,$15,$9E,$20,$36,$A7,$DE,$D4,$F4,$50,$FD,$BA,$D9,$1B,$84,$34,$2A,$FC, $B,$48,$BD,$2D,$57,$27,$D5,$4F,$22,$E1,$92,$FD,$98,$90,$6F,$D9,$30,$D3,$7E,$C5; 64
		dc.b $3F,$C0,$A3,$74,$84,$8C,$46,$22,$F9,$44,$B6,$50,$DB,$55,$9F,$65,$78,$E7,$74,$8C,$42,$17,$C9,$24,$F2,$48,$2C,$B3,$7E,$7A,$1F,$96,$19,$3F,$B1,$F9,$52,$5E,$23,$8E,$F8,$FD,$18,$6C,$3D,$12,$F6,$7F,$8D,$28,$72,$E8,$D3,$94,$DB,$13,$C4,$40,$BE,$5B,$5E,$72,$17,$9D; 128
		dc.b $C1,$82,$9C,$83,$38,$91,$59,$E2,  3,$6A,$7D,$ED,$4F,$45, $F,$DB,$AD,$91,$B8,$43,$42,$AF,$C0,$B4,$8B,$D2,$D5,$72,$7D,$54,$F2,$2E,$19,$2F,$D9,$89,$69,$A6,$D0,$6D,$CE,$E2,$C5,$68,$34,$EB,$F4,$4E,$49,$F1,$A9,$E0,$EF,$94,$F0,$72,$D9,$43,$6D,$56,$7D,$95,$E3,$9D; 192
		dc.b $D2,$31,  8,$5F,$24,$93,$C9,$20,$B2,$CD,$F9,$E8,$7E,$58,$64,$FE,$C7,$E5,$49,$78,$8E,$3B,$CE,$BB, $C,$77, $F,$1A,$F2,$DC,$EF,$2B,$1B,  4,$9A,$15,$46,$14,$20,$E9,$2E,  8,$77, $C,$17,$E8,$8B,$12,$2F,$9B,$83,$8E,$AE,$B1,$F7,$CB,$EA,$5F,$9C,$B0,$6D,$7E,$FB,$42; 256
		dc.b $CB,$E1,$3A,$73,$E4,$FF,$5E,$4B,$35,$AD,$3F,$82,$FE,  5,$FD,$F7,$87,$47,$FD,$7C,$E9,$77,$34,$1F,$13,$FA,$3C,$4F,$E8,$F0,$55,$52,$41,$5E, $B,$F3,$D5,$D1,$3F,$DF, $A,$CA,$7F,$9B,$37,$50,$8A,$6C,$87,$7A,$77,$7C,$FF,$58,$68,$BB,$71,$44,$52,$6A, $A,$27,$7C,$6E; 320
		dc.b $5B,$D6,$82,$82,$E7,$F1,$68,$7F,$AE,$5A,$17,$E7,$BE,$A6; 384
Nem_S1TitleCard:dc.b $80,$80,$80,  4,  9,$14,  7,$24,  8,$35,$16,$45,$17,$55,$19,$65,$18,$73,  1,$81,  3,  0,$16,$34,$26,$39,$83,  6,$36,$86,  4,  6,$17,$76,$27,$7A,$87,  3,  2,$16,$3A,$27,$77,$37,$78,$47,$79,$88,  6,$37,$89,  6,$35,$8A,  8,$F7,$8E,  4, $A,$18,$F6,$8F,  6,$38; 0
					; DATA XREF: ROM:00003B54o
					; ROM:0000523Eo ...
		dc.b $FF,$BA,$65,$71,$22,$CB,  1, $C,$2B,$21,$90,$C2,$46,$13,$AC,  9,$5E,$A3,$CC,$A1,$3F,$B1,$90,$C0,$D9,$A5, $B,$77,$CF,$26,$CC,$32, $B, $C,$82,$58,$64,$1B,$A7,$61,  1,$C5,$C6,$13,$B0,$86,$70,$83,$F9,$76,$FE,$BF,$68,$F1,$7E,$49,$26,$CB,$D5,$BC,$5F,$92,$49,$68; 64
		dc.b $5E,$BF,$EF,$DE,$7F,$63,$4E,$84,$6E,$9D,  8,$14,$71,$57,$DD,$9D,  7,$A7,$42,$15,$4A,$60,$E3,$54,$E8,$3E,$94,$71,$57,$DD,$9D,  9,$6A,$9E,$83,$F7,$D2,$39,$7F,$51,$DA,$BA,$76,$9A,$D7,$49,$67,$D4,$5E,$AC,$CF,$A8,$24,$98,$4F,$A8,$80,$F5,$74,$FA,$88, $A,$6B,$5B; 128
		dc.b  $E,$AB,$B4,$69,$DF,$B4,$29, $A,$BB,$58,$6B,$52,$D6,$1B,$9A,$C6,$FD,$67,$92,$4D,$F7,$61,$7A,$CE,$F2,$83,$EE,$D4,$83,$B5,$74,$23,$AD,$2D,$D7,$F5,$94,$78,$16,$E4,$92,$49,$24,$92,$D0,$BD,$7F,$DD,$7F,$86,$BB,$5F,$5A,$96,$B0,$D5,$DA,$C2,$B1,$AB,$B0,$80,$49,$C6; 192
		dc.b $EE,$84,$56,$77,$74,$1F,$7A,$94,$22,$BA,$16,$5A,$5D,$7F,$99,$47,$81,$6E,$49,$26,$CB,$D5,$BC,$5F,$92,$49,$68,$5E,$BF,$EF,$E6,$74,$EF,$56,$E7,$5C,  2,$AC,$C2,$74,$76,$27, $B,  1,$63,$49,$60,$6F,$BD,$BD,$55,$BC,$C7,$F5,$FB,$28,$F0,$2D,$C9,$24,$D9,$7A,$B7,$8B; 256
		dc.b $F2,$49,$2D,  8,$3F,$98,$F3,$1D,$EA,$DC,$EB,$80,$55,$98,$4E,$8F,$BE,$2B,$15,$8D,$70,$16,$34,$24,$92,$FE,$A3,$B5,$74,$ED,$35,$AE,$92,$CF,$A8,$BD,$59,$9F,$50,$49,$30,$9F,$51,  1,$EA,$E9,$F5,$10,$14,$D6,$B6,$1D,$57,$68,$D3,$BF,$68,$52,$15,$76,$B0,$D6,$A5,$AC; 320
		dc.b $35,$AC,$8D,$CF,$59,$E4,$99,$FF,$30,$EF, $B,$F6,$38,$DF,$3B,$D5,$DA,$95,$FA,$1D,$DF,$A6,$EA,$44,$A8,$50,$2C,  9,$27,$2B,$D5,$BC,$5F,$92,$49,$68,$41,$FC,$C0,$F2,$1D,$A1,$10,$49,$33,$DB,$3D,$67,$42,$49,$C3,$42, $F,$E6,$3C,$C3,$42,$20,$92,$49,$24,$92,$ED,  8; 384
		dc.b $3F,$97,$6F,$12,$25,$A1,$10,$4C,$EF,$9D,$EA,$FB,$D5,$F5,$AC,$D2,$CA, $B,  1,$1C,  2,$D0,$83,$F9,$81,$E4,$3A,$A9,$EA,$35,$A5,$CC,$EF,$48,$5A,$90,$BA,$19,$18,$62,$B0, $B,$5C,$3A,$B3,$38,$B0,$4E,$D6,$51,$D8,$4F,$F5,$E5,$BC,$4E,$8A,$14, $B,  2,$49,$24,$92,$4B; 448
		dc.b $B4,$2F,$5F,$F7,$FF,$89,$24,$92,$49,$37,$60,$6E,$D1,$FB,$6B,$7F,$5D,$FC,$6B,$A4,$B4,$51,$BA,$7D,$F1,$57,$18,$67,$DF,$15,$70,$FB,$C0,$67,$A3,$71,$90,$D3,$58,$D5,$A5, $B,$77,$70,$A7,$4D,$57,$65,$15,  8,$89,$43,$21,$8D,$D0,$C8,$60,$6E,$30,$C0,$9C,$83,$2D,  8; 512
		dc.b $3F,$99,$ED,$D7,$EC,$5A,$16,  5,$D3,$B5,$C3,$B5,$9A,$14,  4,$E2,$C1,$11,$90,$D8, $B,  0,$96,$94,$2D,$DE,$FC,$AE,$C2,$CD,$28,$82,$49,$96,$2C,$56,  5,$D3,$B5,$C6,$43,$60,$2C, $E,$B3,$A2,$ED,$1D,$AB,$A7,$69,$AD,$74,$96,$7D,$45,$EA,$CC,$FA,$82,$49,$84,$FA,$88; 576
		dc.b  $F,$57,$4F,$A8,$80,$A6,$B5,$B0,$EA,$BB,$46,$9D,$FB,$47,$2A,$BB,$58,$6B,$52,$D6,$1B,$BB,$5E,$B1,$BB,$B0,$24,$98,$DD,$D0,$8A,$CE,$EE,$83,$EF,$52,$83,$B5,$74,$23,$AD,$2D,$D7,$F5,$94,$78,$16,$E4,$92,$6C,$BD,$5B,$C5,$F9,$24,$96,$84,$1F,$CC,$74,$DC,$BA,$A0,$CA; 640
		dc.b   6,$B5,$21,  7,$1B,$B8,$36,$DD,$C4,$6F,$52,$18,$4B,$50,$4C,$1F,$A6,$D2,$39,$24,$92,$6F,$FF,$65,$1E,  5,$B9,$24,$9B,$2F,$56,$F1,$7E,$49,$25,$A1,  7,$F3,  9,$BF,$62,$F4,$19,$5B,$5A,$90,$83,$8D,$DC,$1B,$6E,$E2,$37,$A9, $C,$1E,$82,$61,$60,$85,$93,$A1,  1,$C1; 704
		dc.b $BD,$63,$57,$6D,$D9,$C2,$D2,$94,  6,$E8,$59,$BA,$ED,$29,$84,$F7,$90,$EB,$92,$64,$3A,$B3,  7,$64,$E1,$90,$90,$CF,$A3,$77,$96,$7F,$D8,$97,$58, $D,$94,$19,$5D,$90,$ED,$2B,$9E,$FD,$A1,$48,$52,$CA,$C1,$94,$B5,$B4,$61,$90,$D8,  5,$3F,$64,$FA,$48,$90,$CA,$19,$38; 768
		dc.b $42,$74,$4E,$2C, $E,$19,$C3,$F6,$90,$98,$4F,$76,$D1,$FC,$7E,$DA,$47,$7B,$37,$26,$10,$C8,$24,$92,$49,$30,$D8,$F1,$FB,$65,$3A,$77,$17,$D1,$B0, $A,$C6,$84,$92,$49,$2E,$86,$56,$3A,$F4,$1D,$42,$81,$60,$49,$24,$9C,$A1, $B,  2,$15,$94,$76,$71,$D6,$74,$EF,$1D,$94; 832
		dc.b $88,$52,$AE,$1C,$12,$49,$26,$CC,$50,$B3,$5F,$B4,$A1,$6E,$85,$96,$97,$5F,$C6,$12,$D6,$50,$D0,$D6, $E,$2C,$A1,  8,$68,$6B,  7,$16,$45,$89,$24,$E1,$B1,$DE,$3B,$29,$10,$A5,$5D,  9,$17,$61,$66,$16, $C,$18,$5D,$85,$90,$C3,  2,$49,$39,$42,$FD,$64,$75,$FC,$68,$F2; 896
		dc.b $EB,$F8,$26,$50,$C8,$BB,$65,$B2,$B0,$32,$CE,$21,$A1,$9D,$42, $E,$1D,  7,$67,$10,$D0,$17,$6F,$FB,$FF,$5E,$47,$50,$1C,$28,$61,$2A,$10,$70,$E8,$5C,$61,$85,$D0,$BA,  7,$20,$D9,$81,$BB,$47,$ED,$AD,$FD,$77,$FF,  9,$24,$BF,$60,$6F,$D6,$79,$8F,$7C,$FB,$E7,$DF,$3E; 960
		dc.b $F3,$F8,$BB,$7B,$CF,$E2,$ED,$EE,$FF,$9B,$7F,$77,$FD,$5C,$8F,$D5,$F3,$F8,$B9,$D1,$BF,$74,$EB,$F1,$BF,$82,$FC,$5F,$E0,$83,$FE,$36,$75,$1A,$FE,$2F,$3A,$17,$FC,$6C,$EB,$3B,$FB,$BB,$7E,$37,$F0,$5E,$FF,$82, $E,$1B,$F5,$7E,$E3,$F3,$5F,$BB,$91,$F9,$A7,$FC,$DE,$39; 1024
		dc.b $38,  7,  1,$FF,$37,$9E,$49,$24,$93,$7F,$D7,$88,$E3,$3C,$67,$82,$71,$ED,$9D,  9,$24,$92,$49,$24,$92,$7F,$7D,$6E,$7D,$B8,$8F,$CF,$DF,$83,$9E,$2D,$ED,$7A,$D0,$99,$FD,$F5,$BF,$82,$49,$9E,$33,$C6,$78,$CF,$19,$E3,$3C,$5A,$8C,$F1,$7A,$24,$CF,$FB,$B8,$AF,$E8,$BF; 1088
		dc.b $E7,$CF,  4,$3D,$5A,$84,$8E,  9,$38,$E0,$C5,  9,$E0,$C5, $B,$D0,$BD, $B,$D0,$BD, $C,$83,$8F,$EF,$82,$4C,$FF,$79,$FF,$83,$ED,$C4,$7E,$7E,$FC,$1C,$F1,$6F,$6B,$D6,$84,$CF,$EF,$AD,$FC,$1F,$CF,$92,$73,$ED,$9D,$27,$F7,$E0,$9C,$50,$7A,$B5,$70,$64,$56,  7,$B6,$74; 1152
		dc.b $FD,$77,$E7,$E3,$97,$FC,$F9,$E0,$87,$AB,$50,$91,$C1,$38,$E2,$28,$4F,  6,$28,$1C,$D0,$7A,$C0,$A8,$A0,$E0,$9C,$71,$9E,$2D,$40,$DE,$85,$BD,$84,$7B,$69,$6D,$33,$FC,$F1,$8A,$11,$ED,$81,$9A,$E2,$68,$18,$F6,$9A,$16,$19,$AE, $C,$D3,$FF,$3A,$44,$FF,$44,$92,$63,$F7; 1216
		dc.b $E1,$F8,$B5,  8,$F6,$C0,$24,$9C,$D7,$16,$E2,$D4,$1F,$F7,$C2,$3F,$62,$49,$31,$F9,$F0,$FF,$9F, $F,$44,$F1,$9A,$33,$C6,$68,$E0,$51,$8F,$67,$1E,$D3,$CB,$F2,$49,$33,$F9,$F1,$3F,$9F,  4,$92,$49,$8A,$E2,$DC,$5A,$83,$FE,$F8,$47,$EC,$49,$24,$E9,$71,$BE,$D6,$1B,$7B; 1280
		dc.b $88,$1B, $B, $D,$85,$86,$E3,$3F,$8B,$B8,$9D,$BF,$25,$FA,$3D,$F6,$FC,$96,$DA,$4F,$B8,$71,$F8,$23,$B0,$C8,$38,$18,$FC,$5C,$FF,$4F,$50,$49,$C0,$BE,$9B,$46,$9B,$7E,$15,$38,$DB,$F0,$A8,$40,$FC,$17,$E1,$3F,$4B,$9D,$23,$9D,$BF, $B,$3A,$6D,$F8,$5F,$C2,$2D,$36,$FC; 1344
		dc.b $2A,$11,$F8,$54,$2E, $E,$3F,$2B,$FD,$4D,$36,$FC,$17,$E1,$7F,$88,$98,$12,$49,$8F,$DA,$7E,$D7,$F0,$9F,$85,$FC,$16,$DF,$B1,$90,$CB,$F0,$9F,$85,$FC,$16,$D7, $C,$89,$27,$FE,$A7,$4C,$FE,$17,$61,$70,$DB, $B,$86,$D8,$5C,$36,$C2,$E1,$B0,$36,$19,$18,$58,  7,$61,$91; 1408
		dc.b $85,$80,$49,$C0,$C2,$C0,$C6,$C0,$FF,$54,$11,$91,$B5,$C6,$CD,$61,$B3,  8,$1B,$30,$81,$B3,  8,$1B,$30,$30,$36,$61,$6F,$C2,$B0,$BE,$84,$93,$9F,$FA,$9C, $C,$8D,$B0,$D7,$1B, $C,$B5,$C6,$C3,$2D,$71,$B0,$CB,$5C,$6C,$32,$D8,$17,$1B,$61,$8D,$C6,$C2,$FB,$36,$58,$64; 1472
		dc.b $12,$49,$24,$92,$49,$24,$92,$49,$24,$92,$49,$24,$92,$70; 1536
Nem_Explosion:	dc.b $80,$60,$80,  3,  0,$14,  4,$24,  7,$34, $A,$45,$17,$56,$32,$66,$33,$74,  5,$81,  3,  1,$16,$34,$27,$79,$83,  7,$76,$84,  5,$12,$17,$78,$86,  5,$18,$87,  4,  6,$16,$38,$28,$F6,$88,  5,$13,$16,$3A,$89,  4,  8,$16,$35,$28,$F7,$8A,  7,$7A,$8B,  7,$73,$8C,  6; 0
					; DATA XREF: ROM:0001C0D2o
		dc.b $37,$8D,  6,$36,$8E,  7,$72,$8F,  5,$16,$17,$77,$FF,$CE,$D7,$EF,$7B,$65,$CD,$E1,$53,$9C,$92,$15,$55,$5F,$9C,$92,$16,$B9,$C9,$22,$B9,$CB,$3E,$7E,$32,$FC,$DF,$FF,$D3,$DD,$F5,$7D,$56,$15,$55,$55,$55,$73,$F7,$7D,$5F,$DD,$3F,$E9,$FF,$B1,$DD,$6C,$BC,$D6,$A1,$25; 64
		dc.b $CD,$55,$55,$E1,$25,$CD,$6F,$2E,$77,$97,$3B,$CB,$9E,$5C,$D5,$55,$57,$2C,$67,$8C,$8E,$66,$15,$73,$9E,$7C,$96,$F3,$BE,  7,$55,$F9,$64,$6A,$FC,$B7,$E7,$AA,$34,$53,$45,$7F,$5F,$47,$38,$39,$90,$6A,$60,$D7,$EA, $D,$4D,$CD,$E6,$27,$94,$EF,$D6,$53,$55,$55,$BC,$F3; 128
		dc.b $E9,$E7,$87,$98,$B3, $C,$23,$59,$30,$30,$CF,$13,$78,$68,$A8,$1F,$9E,$4E,$4E,$79,  6,$A2,$FC,$AE,$53,$95,$14,$E4,$B4,$60,$7E,$C5,$CD,$15,$29,$61,$6A,$E4,$96,$16,  4,$1F,$D7,$A5,$88,$20,$82,$9A,  2,$84,$14,$EE,$87,$94,$1F,$CF,$58,$7E,$7A,$3A,$23,$F3,$D0,$3F; 192
		dc.b $63,$CA,$28,$EA,$93,$55,$49,$AA,$4D,$72,$9B,$CD,$31,$96,  7,$1F,$A8,$C0,$29,$C6,$33,$84,$3A,$CD,$A0,$17,$B3,$E8,  8,$E4,$B4,$68,$A1,$16,$72,$84,$79,  5,$3B,$A7,$91,$CB,$BE,$47,$90,$D0,$10,$68,$BF,$EC,$5C,$82,$2C,$5F,$44,$D1,$F4,$E4, $B,$94,$D1, $E, $E,  7; 256
		dc.b $9B,$26,$2D,$CA,$D8,$83,$80,$7A,$30,$98,$82,$9D,$67,$35,$55,$54,$C6,$78,$51,$8C,$B1,$96,  6,  6,$2B,$93,$7E,$59,$CF,$2B,$63,$2B,$4F,$23,$CA,$6E,$73,$28,$6B,$4E,$56,$9B,$E9,$69,$D1,  6,$FA, $C,$51,  4,$61,$F4,$4F,$CB,$5F,  3, $F,$86,$BE,$33,$6C,$EC,$B9,$C1; 320
		dc.b $CC,$E5,$8C,$F0,$AA,$AA,$AA,$B7,$E2,$EC, $D,$30,$39,$1B,$B1,$5D,$32,$2A,$6E,$6E,$D4,$43,$25,$B4,$BD,$9D,$95,$FF,$62,$B6,$42,$34,$B9,$55,$73,$64,$2A,$F0,$41,$72,$9D,$CD,$41,$1D,$C5,$9F,$41,$67,$F7,$F3,$7F,$75,$5A,$F6,$C2,$71,$E5,$18,$10,$51,$81,$1A,$5C,$AE; 384
		dc.b $46,$B4,$AD,$10,$AE,$46,$8D,$10,$41,$52, $E,$5A,$21,$C8,$8F,$37,$D2,$D9,$F2,  5, $D,$1C,$CA,$95,$53,$73,$DF,$C8,$22,$D9,$14,$B3,$F2,$B0,$FD,$F9,$4F,$D7,$A5,$94,$1C,$A0,$7F,$47,$1F,$AE,$FD,$C8,$F3,$C0,$6A,$D3,  5,$54,$17,$29,$A3,$9C,$BC,$A1,  5,$CA,$1E,$EA; 448
		dc.b $BF,$AF,$2A,$45,$9E,$C8,$47,$EB,$C1,$4B,$39,  4,$72,$43,$7D,$10,$83,$91,$57,$D1,  8,$D0,$10,$68,$E4,$54,$1A,$20,$8D,$1C,$DB,$95,$81,  6,$CF,$A0,$B0,$D0,$7E,$BF,$F6,$29,$A6,$A5, $E,$A9,$AC,$E3,$3F,$6B,$F9,$C3,$66,$5B,$32,$D9,$95,$65,$53,$91,  5,$4D,$1E,$E3; 512
		dc.b $F6,$2D,$61,$6B,$9E,$F9,$17,$35,$E5,$19,$6B,$45,$B9,$57,$65,  4,$68,$18,$1A,$6A,$D3, $F,$DC,$58,$4D,$3F,$5E,$6B,$B9,$8E,$93,$CF,$4F,$A0,$9D,$7E,$A1,$55,$55,$55,$5F,$AB,$CC,$5A,$A6,$2D,$53,$16,$16,$55,$BF,$7C,$AC,$6A,$63,$90,$28,$C8,$6A,$CA,$D3,$A9,$D7,$E7; 576
		dc.b $92,$C9,$3B,$5D,$81,$B6,$66,$AC,$D1,$93,$3C,$F8,$9A,$42,$E6,$D7,$F6,$BF,$B7,$4C,$9E,$C2,$C3,$87,$B7,$16,$F6,$16, $C,$93,$E1,$1B,$A7,$9E,$A9,$61,$68,$AE,$F9,$F4,$90,$3A,$64,$8A,$65,$10,$C9,$3E,$20,$30,$87,$E5,$34,$35,$69,$BD,$AE,$52,$DF,$9E,$48,$F2,  8,$98; 640
		dc.b $FD,$CB,$CD,$DB,$F7, $E,$C3,$FE,$F9,$FE,$DD,$EC,$C1,$87,  8,$C1,$83, $B,$3B, $B,$30,$9A,$30,$9B,$4C,$4F,$3B,$4E,$BA,$B4,$D9,$FF,$50,$18,$7F,$1D,$27,$64,$B3,$57,$74,$D6,$6F,$37,$8D,$26,$27,  9,$AB,$24,$C8,$87,$EE, $A,$33,$D9,$20,$45,$85,$92,  1,$B2,$1A,$EE; 704
		dc.b $52,  7,$EA,$17,$F7,$2A,$8D,$3C,$AD,$34,$E9,$AA,$7D,$C7,$42,$6B,$56,$BF,$77,$98,$B2,$5A,$69,$D5,$33,$CD,$2C,$D5,$D5,$D8,$35,$AB,$D8,$34,$27,  0,$F2,$1A,$B2,$7F,$25,$55,$5D,$B3,$B4,$F2,$B0,$9E,$56,$13,$CA,$CB,$7E,$E9,$3B,$F2,$BF,$94,$9D,$69,$5C,$A1, $B,$B0; 768
		dc.b $82,$93,$A9,$C7,$4A,$AA,$AA,$B3,$CE,$6A,$F3,$46,$AE,$B8,$C9,$AF,$31,$FA,$8B,$FE,$A1,$FA,$8C,$A7,$19,$4C,$6A,$B9,$6B,$9B,  9,$D4,$5B,$39,$89,$D6,$A2,$61,$AF,$30,$CF, $A,$B7,$E3,$2F,$64,$67,$E0,$70,$EC,$8D,$94,$C3,$4F,$26,$9D,$4F,$5B,$C0,$81,$D3,$C2,$A7,$4D; 832
		dc.b $9B,  8,$56,$CD,$94,$4E,$F3,$13,$76,$78,$7E,$4F,  2,$1E,$6F,  2,$27,$9C,$D7,$81,$C2,$70,$3F,$AE,$3D,$83,$59,$83,  6, $D,$36, $C,$EC,$ED,$9B,$2A,$BC,$DD,$9E,$6E,$C1,$87,$15,$60,$D6,$79,$89,$89,$8D,$7F,$50,$FE,$E2,$12,$69,  2,$1B,$36,$13,$6C,$D9,$55,$44,  8; 896
		dc.b $AD,$72,$84,$85,$54,$9B,$F4,$93,$4E,$AC,$27,$5E,$D3,$4E,$83,$57,$5F,$B7,$79,$A4,$DB,$29,$AA,$E4,$C9,$3A,$67,$68,$B9,$E5,$17,$D5,$55,$72,$6C,$ED,$9F,$59,$35,$84,$EB,$DA,$79,$36,$6D,$D5,$4D,$94,$CE,$BA,$89,$BB,$44,$C1,$76,$D7,$38,$10,$AA,$AA,$98,$CF,$19,$1C; 960
		dc.b $CE,$CA,$FF,$9D,$CB,$61,$F9,$DB,$EC,$9F,$82,$BE,$D9,$EF,$B5,$60,$7E,$72,$BF,$2C,$9D,$AB,$F2,$DF,$9A,$AD,$B5,$58,$A3,$2C,$DB,$F2,$74,$73,$D8,$E6,$41,$AD,$C1,$AF,$D6,$1A,$DD,$CD,$F7,$1B,$E5,$BD,$FF,$39,$96,$EA,$AA,$B7,$DF,$3F,$CE,$3E,$F8,$7D,$C5,$BB, $C,$27; 1024
		dc.b $6B,$26,  6,$3B,$3C,$6C,$F1,$DA,  1,$48,$1F,$9A,$4F,$4F,$1E,$87,$6A,$87,$F5,$78,$4F,$55,  9,$E9,$6B,$51,$FB,$97,$8A,$85,$84,$EC,$3B,$57,$E0,$93,$B0,$EC,$20,$1F,$D1,$A7,$62,  8,$23,$64,$D0,$14,$20,$A3,$76,$90,$3F,$82,$D8,$E3,$F0,$5D,$87,$E4,$B6,$FC,$E1,$1F; 1088
		dc.b $92,$D8,$7E,$C7,$F0,$5B,$51,$FC,$EA,$6E,$AA,$9B,$AA,$6E,$B9,$6E,$FB,$26,$13,$70,$46,  7,$66,$1F,$9C,$C0,$81,$2E,$CD,$8C,$A5,  9,$EE,$3B,$40,$87,$EC,$FA,$88,$1E,$96,$A2,$A1,$20,$76,$78,$48,$1E,$E2,$13,$F2,$69,$EE,$3D,$7E,$4F,$28,$F4,$35,$10,$22,$A1,$F5,$94; 1152
		dc.b $3C,  8,$DB,$B4,$3E,$A9,$AB,$EB,$EB,$68,$7D,$92,$50,$9B,$7A,$8C,$4B,$5D,$99,$30,$DF,$82,$ED,$EB,$63,$80,$7F,$38,$76,$4C,$6C,$53,$F3,$99,$EE,$AA,$AA,$98,$CF, $A,$31,$96,$32,$C0,$C0,$C5,$7A,$B7,$E5,$9E,$3D,$76,$C6,$5D,$B7,$CA,$3D,$6E,$F1,$9C,$24,$56,$BE,$BB; 1216
		dc.b $17,$D7,$B1,$1F,$9D,$10,$20,$7E,$B4,$6A,$39,$D4,  8,$18,$7D,$53,$9E,$2F,$CF,$6E,$69,$2E,$7F,$82,$D8,$6C,$9E,$86,$D7,$61,$B5,$F9,$AA,$6D,$5B,$6F,$B0,$DA,$88,$FD,$6A,$62,$B6,$4C,$2A,$AA,$AA,$AD,$FF,$37,$7D,$C4,$AB,$76,$92,$D6,$EA,$C2,$59,$49,$64,$AF,$BA,$48; 1280
		dc.b $48,$6E,$C1,$84,$9D,$83,$3E,$EC,$19,$7F,$68,$8C,$B2,$1E,$2F,$25,$57,$2C,$92,$57,$D8,$89,$3C,$93,$89,$56,$C4,$70,$19,$F4, $C,$FF,$AD,$F3,$7F,$D6,$AA,$D7,$EA,$EC,$9F,$9B,$FD,$22,$73,$12,$12,$4E,$62,$43,$B4,$84,$3F,$65,$64,$84,$ED,$5E,$2B,$C2,$49,$83,$23,$3B; 1344
		dc.b $3B,$49,$DA,$55,$21,$21,$25,$90,$96,$5E,$12,$59,$48,$7E,$93,$57,$F0,$35,$BC,$84,$92,$55,$27,$87,$92,$40,$87,$90,$81,$15,$21,$AD,$E4,$21,$24,$18,$49,$24,$B2,$46,$12,$18,$61,$EC,$25,$93,$21,$F6,$46,$D8,$1C,$BF,$3B,$FC,$1B,$7E,$6F,$1F,$BD,$1F,$A4,$FC,$D8,$E7; 1408
		dc.b $AA,$78,$B4,$93,$5A,$F7,$79,$24,$84, $F,  3,$C2,$A4,$84,$92,$42,$41,$84,$98,$48,$33,$FE,$DC,$16,$46,$1E,$43,$48,$37,$EC,$52,$41,$86,$8C,$92,$76,$12,$7E,  4,$84,$84,$92,$57,$F0,$22,$42,$49,$AA,$49,$FD,$EF,$E1,$24,$3C,  9,  9,$54,$84,$91,$84,$84,$AF,$E0,$33; 1472
		dc.b $B5,$48,$30,$F6,$22,$41,$93,$4F,$1C, $D,  7,  3,$F6,$29,$A7,$E7,$4A,$1F,$CE,$A7,$E7,$77,$DB,$3F,$D5,$DF,$F4,$96,$E7,$9C,$B9,$BF,$B8,$97,$34,$84,$81,$27,$8A,$E6,$F0,$21,$52,$4F,$A8,$90,$F1,$52,$7F,$DA, $E,$2F,$CD,$83, $E,$12,$5C, $E,$1E,$4F,$24,$81,$FA,$44; 1536
		dc.b $E6,$35,$CB,$51,$E0,$34,$67,$24,$92,$A3,$6E,$24,$EC,$8C,$92,$4D,$F2,$DE,$BC,$73,$A6, $C,$37,$4F,$63,$5C,$1D,$BF,$38,$9E,$7F,$38,$FA, $D,$EB,$F5,$97,  0; 1600
Nem_GameOver:	dc.b $80,$22,$80,  5,$1B,$14,  7,$24,  6,$35,$17,$46,$3A,$55,$16,$64,  9,$73,  0,$81,  8,$FA,$82,  3,  1,$15,$1C,$26,$3C,$83,  4, $A,$84,  3,  2,$16,$3B,$25,$1A,$48,$F9,$85,  7,$7A,$86,  4,  8,$15,$19,$27,$7B,$38,$F8,$87,  5,$18,$FF,$EB,$DB,$67,$A8,$B4,$36,$AE; 0
					; DATA XREF: ROM:0001C0DAo
		dc.b $BC,$87,$44,  0,$19,$3A,$2C,$59,$16,$4C,$B3,$B2,$A4,$F7,$6E,$6B,$25,$FC,$75,  4,$37,$76,$E7,$76,$F3,$AF,$82,  5,$91, $F,$EA,$D1,$41,$D1,$BF,$65,$BB,$E5,$F9,$7C,$DF,$3D,$40,$7E,$DE,$1D,$70,  1,$B8,$65,$90,$36,$9B,$5B,$37,$E0, $F,$A6,$8F,$E1,$32,$83,$28,$B2; 64
		dc.b $92,$9D,$16,$20,$5B,$20,$5B,$BB,$70,  1,$A6,$CA,$C6,$CF,$55,$83,$6A,$65,$7C,$1D,$9B,$D0,$C1,$B5, $C,$5E,$9E,$AF,$81,$53,$89,$35,$38,$93,$5B,$D3,$63,$7E,$63,$37,$F5,$56,$AB,$7A,$9A,$B7,$A9,$AB,$7A,$9A,$7A,$9C,$5A,$A7,  7,$AA,$9C,$1E,$AA,$70,$5F,$5B,$2F,$1F; 128
		dc.b $B4,  2,$DD,$C9,$78,$65,  0,$3A,$6E,$DC,$DC,$81,$65,  0,$37,$CF,$BE,$F7,$C0,$3E,$5B,$FA,$4F,$EC,$81,$7D,$75,$FB,$20,$2F,$FC,$62,  3,$FC,$B1,$F9,$C8,$1B,$4D,$AD,$9B,$F0,  1,$D2,$C8,$E9,  5,$25,$49, $F,$A6,$8F,$E1,$32,$83,$28,$B2,$92,$9D,$16,$22,$61,$D1,$78; 192
		dc.b  $E,$8F,$48,$D9, $C,$97,$52,$54,$9D,$75,$E2,$CB,$67,$A8,$B4,$36,$AE,$BC,$87,$44,  0,$19,$3A,$2C,$59,$16,$4C,$B3,$B2,$A4,$F7,$6E,$6B,$25,$FC,$75,  6,$51,$7E,$D9,$1D,$F1,$49,$4E,$8B,$10,  4,$C3,$A2,$F1,$D6,$59,$1E,$91,$BF,$65,$BB,$E5,$F9,$F0,$67,$E8,$DA,$19; 256
		dc.b $17,$A6,$30,$DF,$4C,$5A,$2E,$5E,$AF,$12,$41,$98,$92, $C,$C4,$90,$AF,$F0,$D4,$D0,$D1,$34,$FE,$6E,$9A,$1A,$26,$9F,$9B,$FA,$A6,$87,$CD,$BF,$26,$FC,$B4, $B,$72,$D0,$2F,$AE,$B1,$AF,$8C,$49,$A9,$C6,$AF,$FB,$20,  0,  0,  0,  6,$BD,$FA,$FD,$93,$50,$C1,$7F,$DA,$62; 320
		dc.b $FF,$C2,  0,  0,  0,  0,$3A,$F6,$40,$65,$24,  0,  0,  0,  1,$AB,$80,  0; 384
Nem_VSpring:	dc.b   0,$10,$80,  6,$3A,$13,  1,$26,$2C,$45,$11,$58,$FB,$65,$14,$73,  0,$81,$76,$2D,$86,  5, $A,$15,$17,$25,$13,$87,  4,  4,$16,$36,$25,$1A,$36,$38,$88,  4,  6,$15,$19,$25,$12,$89,  5,$10,$16,$3B,$26,$30,$8C,  5, $E,$16,$3C,$26,$31,$35, $B,$8D,  5,$15,$15, $F; 0
					; DATA XREF: ROM:0001C0F4o
		dc.b $26,$3D,$37,$7C,$48,$FA,$8E,$26,$37,$36,$39,$FF,$2B,$53,$8B,$D6,$5F,$8A,$8B,$D6,$5F,$8A,$8B,$D6,$5F,$8A,$8B,$D7,$FD,$67,$7E,$D9,$CA,$5C,$D7,$37,$29,$73,$5C,$DC,$A5,$CD,$73,$72,$BF,$D9,$57,$55,$7F,$5E,$55,$DF,$31,$FA,$F2,$AE,$F9,$8F,$D7,$95,$77,$CC,$7F,$BA; 64
		dc.b $EA,$EE,$5F,$C9,$F7,$72,$FE,$4F,$BB,$97,$F2,$7D,$DC,$BF,$90,  0,  2,$92,$8C,$BB,$FE,$C5,$B0,$6D,$BF,$6D,$6C,$1B,$53,$B7,$57,$D6,$78,$FD,$C7,$F6,$6D,$E3,$3D,$DB,$C3,$61,$6F,$FA,$21,$2F,$E4,$80,  0,$18,$47,  0,$65,$66,$62,$DF,$69,$44,$B3,$30,$3B,$34,$61,$B7; 128
		dc.b $EC,$21,$62,$2B,$A6,$FB,$52,$51,  2,$59,$23,$B3,$46,$1D,$27,$EC,$21,$62,$5D,$A8,$C0, $A,$7E,$E4,$76,$C1,$A8,$CA,$FE,$B8,$1D,$7E,$E4,$60,$1A,$89,$7F,$E3,$80,  0,$1F,$72,$8C,$90,$20,$41,$71,$74,$1A,$BE,$B3,$C6,$40,  0,$6A,$3F,$E8,$84,$BF,$92,  0,  0,$61,$1C; 192
		dc.b $22,  0		; 256
Nem_HSpring:	dc.b $80, $E,$80,  2,  0,$14,  8,$25,$19,$37,$7D,$45,$1A,$56,$3C,$65,$1B,$73,  2,$81,  3,  3,$83,  5,$1C,$86,  4,  9,$87,  6,$3A,$15,$18,$88,  6,$3D,$16,$3B,$89,  5,$17,$17,$7C,$8C,  4, $A,$8F,  5,$16,$FF,$49,$25,$DA,$5B,$B3,$BB,$BB,$BE,$58,$E2,$D1,$62,$C3,$1A; 0
					; DATA XREF: ROM:0001C0FAo
		dc.b $CB,$CB,$1F,$DB,$25,$61,$8D,$23,$F2,$2A,$2C,$5B,$4D, $F,$2D,$3B,$BB,$BB,$A5,$F1,$24,$92,$F3,$FD,$B5,$FE,$19,$DC,$EF,$F2,$C4,$92,$4D,$12,$49,$27,$E7, $A,$28,$FC,$E1,$45,$14,$94,$51,$45,$15,$14,$51,$4A,$24,$92,$49,$A2,$49,$25,$24,$4E,$E7,$72,$31,$8E,$3F,$C3; 64
		dc.b  $C,$63,$1E,$DE,$DF, $E,$1C,$39,$1C,$38,$70,$E2,$FF,$F2,$F7,$AD,$75,$E6,$2D,$F7,$10,$E2,$7A,$59,$67,$E5,$B3,$65, $F,$56,$C2,$5F,$59,$D2,$4B,$C7,$E3,$BE,$71,$DD,$E3,$F4,$FE,$9F,$31,$AB,$EF,$AB,$6B,$1D,$FD,$6B,$5F,$A6,$86,$A3,$F2,$29,$47,$C4,$B3,$8F,$6F,$9E; 128
		dc.b $8E,$BD,$3A,$F6,$2F,$18,$EC,$F9,$88,$EC,$FC,$76,$9C,$5B,$58,$EF,$37,$7B,$98,$69,$25,$E7,$C5,$E3,$D7,$EA,$34,  0; 192
Nem_BigFlash:	dc.b $80,$54,$80,  5,$1B,$16,$3C,$26,$3D,$36,$3B,$46,$3A,$55,$1C,$64, $B,$71,  0,$86,  3,  4,$18,$F8,$78,$FA,$8B,  4, $C,$8C,  5,$1A,$8D,  4, $A,$18,$F9,$FF,$FE,$B5,$6E,$67,$79,$37,$5F,$19,$75,$32,$EA, $E,$A5,$C0,  3,$73,$92,$E2,  0,$1F,$15,$79,$F0,$F8,$DE,$72; 0
					; DATA XREF: ROM:0001C2BCo
		dc.b $56,$5D,$4C,$BA,$CB,$A8,$89,$ED,$5E,$75,$53,$72,$BD,$A9,$B9,$5D,$65,$D0,$EE,$5C,  7,$92,$E0,  7,$71,$2A,$F2,$22,$23,$E1,$97,$48,$CB,$A4,$EE,$5C,$F7,$2E,$8C,$BA,$19,$74,$F6,$5C,  0, $E,$E2,$2A,$F1,  8,$42,$AF,  5,$5E,  3,$EB,$9F,$3C,$F9,  1,$E5,$5D,  0,$1B; 64
		dc.b $AB,$A0,  7,$5F,$FD,$E5,$3E,$5F,$2A,$7C,$8F,$35,$7A,  0,$DD,$5F,$E0,$7A,$AD,$6F,$55,$ED,$6B,$7A,$AE,$BF,  3,$74,$7B,$AB,$D0,$BF,$EE,$BE,$41,$4A,$52,$94,$A2,$95,$ED,$5D,  0,$F2,$AE,$BB,$D7,$35,$BD,$75,$AD,$EB,$9A,$1D,$FC,$BF,$5A,$F9,$50,  0,$51,$42,$82,$80; 128
		dc.b $FD,$E8,$A5,$3E,$54,$A5,$28,  0,  0,$1F,$FD,  0,$29,$45,$28,$A2,$85,  5,  3,$FF,$A2,$E7,$55,$3A,$99,$C8,$9E,$CE,$E6,$E6,$E7,$7F,$1B,$9C,$87,$BA,$BD,  7,$B2,$E0,  7,$9A,$BD, $A,$F8,$F2,$BE,$33,$CA,$99,$D6,  1,$71,$97,$48,$CB,$A4,$75,$AF,$33,$BD,$79,$46,$5D; 192
		dc.b $7B,$57,$9D,$54,$DC,$AF,$32,$A6,$E5,$79,$5E,$65,$D1,$CA,$FF,$36,  0,  0,  0,  0,$EF,$27,$32,  0,  0,  0,  1,$F5,$F1,$57,$9F, $F,$84,  0,  0,  0,$1F,$42,$25,$5E,$44,$44,$40,  0,  0,$7D,  0,$11,$15,$78,$84,$21,$57,$82,$AF,  1,$F4,  0,  7,$25,$C0,  7,$25,$C0; 256
		dc.b   0,$2A,$FF,  3,$D5,$6B,$7A,$EE,$B5,$BD,$73,$F0,$37,$41,$DC,$B8,  6,$E7,$26,$E7,$53,$73,$90,  3,$D9,$70,$72,$AE,$87,$B2,$E0,$39,$AB,$D0,  0,$E4,$B8,  1,$73,$93,$73,$A9,$B9,$C8, $F,$25,$C0,$EF,$57,$A1,$D0,  0; 320
Nem_S1BonusPoints:dc.b	 0,$24,$80,  5,$15,$15,$13,$24,	 8,$35,$16,$57,$78,$76,$2E,$81,	 4,  2,$14,  4,$27,$7A,$83,  7,$74,$16,$36,$28,$F8,$84,	 6,$35,$15,$12,$27,$6F,$85,  4,	 3,$17,$75,$86,	 3,  0,$15,$18,$26,$34,$37,$77,$47,$71,$57,$79,$8B,  6,$2F,$17,$76,$8C,	 4,  7,$14,  6;	0
					; DATA XREF: ROM:0001C2B6o
		dc.b $25,$14,$77,$6E,$8D,  6,$32,$8E,  4,  5,$16,$39,$37,$7B,$8F,$16,$33,$27,$70,$FF,$C7,$83,$D2,$C7,$C6, $F,$CC,$CF,$8C,$1E,$9D,$7C,$9D,$4F,$BC,$A6,$6B,$FB,$C8,$52,$A4,$10,$27,$29,$96,$10,$41,  4,$13,$C8,$82, $A,$B1,  4,$14,$20,$82,$BC,$90,$F5,$3E,$51,$A6,$EB; 64
		dc.b $FB,$CA,$B6,$5E,$F2,$6F,$E7,$37,$36,$E6,$EB,$A3,$48,  7,$BE,$BD,$65,$FA,$B3,$97,$6E,$12,$BF,$F9,$FA,$DF,$C3,$F6,$97,$E7,$2D,$AF,$CE,$5F,$1B,$92,$88,$F8,$27,$2C,$7A,  4,$10,$20,$20,$81,  1,  4,  8,  8,$20,$40,$41,$34,$27,$2C,$7A,$A2,$6E,$7A,$F4,$DF,$C2,$36; 128
		dc.b $DF,$FC, $F,$8B,$AE,$C7,$89,$18,$B7,$69,$75,$9E,$7D,$A4,$63,$F7,$F7,$C8,$4B,$85,$FA,$9F,$49,$67,$7E,$A7,$B4,$B3,$BF,$5D,$CC,$94,$27,$2C,$13,$90,$20,$80,$82,  4,  4,$10,$20,$20,$81,  1,  4,  8,  8,$13,$96,  9,$C8,$32,$50,$B7,$67,$BF,$A5,$56,$5B,$42,$ED,$75; 192
		dc.b $D7,$46,$2D,$A1,$CF,$89,$D7,$89,$CF,$B9,$C6,$87,$6F,$27,$5D,$7B,$9C,$E8,$A7,  4,$CB,$60,$4E,$B6,$20,$4A,$70,$40,$96,$C4,  9,$72,$82,  4,$AD,$32,  4,$B4,$A8,$27,$FD,$74,$C9,$B9,$8A,$2B,$C7,$B6,$9F,$B6,$5B,$72,$DE,$39,$BA,$B8,$F0,$7A,$58,$F8,$C1,$F9,$99,$F1; 256
		dc.b $83,$D3,$AF,$93,$A9,$F7,$94,$CC,$2D,$20,$D5,$8A,$CA,$E4,$26,$61,$4B,$10,$6A,$E4,$27,$93,$AB,$90,$AD,$15,$C8,$7E,$F1,$5C,$85,$57,$27,$57,$21,$35,$75,$62,$9B,$2D,$2B,$93,$7B,$CA,$9E,$DB,$9B,$73,$75,$D1,$A4,  3,$DF,$5E,$B2,$FD,$59,$CB,$B7,  9,$5F,$FC,$FD,$6F; 320
		dc.b $E1,$FB,$4B,$F3,$96,$D7,$E7,$2F,$8D,$D4,$4A,$13,$96,  9,$FD,  4,  4,$10,$20,$20,$81,  1,  4,  8,  8,$20,$40,$43,$D6,  9,$D1,$93,$75,$2B,$D3,$7F,  8,$DB,$7F,$F0,$3E,$2E,$BB,$1E,$24,$62,$DD,$A5,$D6,$79,$F6,$91,$8F,$DF,$DF,$21,$2E,$17,$EA,$7D,$25,$9D,$FA,$9E; 384
		dc.b $D2,$CE,$FD,$77,$25,$11,$F0,$4E,$58,$F4,  8,$20,$40,$41,  2,  2,  8,$10,$10,$40,$80,$82,$68,$4E,$58,$F5,$44,$DC,$F9,$EF,$E9,$55,$96,$D0,$BB,$5D,$75,$D1,$8B,$68,$73,$E2,$75,$E2,$73,$EE,$71,$A1,$DB,$C9,$D7,$5E,$E7,$36,$50,$70,$CA,$76,$65,$FE,  1,$3A,$83,$82; 448
		dc.b $75,$3B,$13,$AB,$E5,  4,$EB,$49,$93,$AF,$EF,$2A,$CA,$F9,$2C,$D9,$5D,$61,$95,$A3,$F5,$CD,$94,$FF,$5D,$4C,$AD,$CB,$78,$E6,$EA,$E3,$C1,$E9,$63,$E3,  7,$E6,$67,$C6, $F,$4E,$BE,$4E,$A7,$DE,$53,$30,$B4,$83,$5A,$59,$69,$33, $A,$C5,  6,$B4,$9E,$4E,$B4,$AD,$17,$FD; 512
		dc.b $8B,$4A,$AE,$4E,$B4,$9A,$BA,$D2,$6C,$B4,$AE,$4D,$EF,$2A,$7B,$6E,$6D,$CD,$D7,$46,$90, $F,$7D,$7A,$CB,$F5,$67,$2E,$DC,$25,$7F,$F3,$F5,$BF,$87,$ED,$2F,$CE,$5B,$5F,$9C,$BE,$37,$39,$51,$1C,$81,$39,$60,$B0,$81,  1,  4,  8,  8,$20,$40,$41,  2,  2,  8,$10,$10,$F5; 576
		dc.b $82,$74,$64,$DC,$F5,$E9,$BF,$84,$6D,$BF,$F8,$1F,$17,$5D,$8F,$12,$31,$6E,$D2,$EB,$3C,$FB,$48,$C7,$EF,$EF,$90,$97, $B,$F5,$3E,$92,$CE,$FD,$4F,$69,$67,$7E,$BB,$99,$3F,$98,$58,$2A,$10,$40,$4C,$41,  1,$31,  4,  4,$C4,$10,$13,$10,$40,$54,$2C,$17,$F3,$13,$77,$EF; 640
		dc.b $33,$DF,$D2,$AB,$2D,$A1,$76,$BA,$EB,$A3,$16,$D0,$E7,$C4,$EB,$C4,$E7,$DC,$E3,$43,$B7,$93,$AE,$BD,$CE,$6C,$A0,$E1,$94,$EC,$CB,$FC,  6,$50,$70,$CA,$76,$65,$7C,$A1,$96,$93,$65,$FD,$E5,$59,$5F,$25,$9B,$2B,$AC,$32,$B4,$7E,$B9,$B2,$9F,$EB,$A9,$95,$B9,$6F,$1C,$DD; 704
		dc.b $50,  0		; 768
S1Nem_SonicContinue:dc.b $80,$25,$80,  3,  1,$15,$14,$25, $F,$36,$2E,$46,$32,$56,$38,$66,$2F,$73,  2,$81,  3,  0,$16,$37,$27,$72,$48,$F6,$82,  5,$13,$83,  5,$1A,$18,$F3,$84,  8,$F7,$86,  4,  8,$17,$7A,$47,$78,$87,  5,$15,$17,$75,$88,  4,  6,$17,$76,$89,  5, $E,$38,$EF,$8A,  6,$36; 0
		dc.b $8B,  6,$33,$17,$74,$8C,  5,$12,$18,$EE,$28,$F2,$8D,  7,$73,$8E,  5,$18,$8F,  5,$16,$FF,$49,$2C,$BF,$44,$FF,$C9,$6F,  7,$F2,$51,$5F,$42,$62,  7,  1,$5E,$32,$98,$A8,$CA,$63,$D6,$EF,$FC,$90,$FD,$35,$DF,$A2,$17,$CD,$24,$7F,$E5,$ED,$FF,$6E,$49,$24,$95,$F1,$CA; 64
		dc.b $E1,$FE,$6F,$D9,$7E,$C6,$EF,$D9,$25,$FF,$2F,$FB,$7F,$C5,$24,$92,$4B,$FE,$3F,$F6,$FF,$92,$4A,$E1,$2C,$84,$A7,$27,$89,$27,$E0,$89,$2B,$B4,$84,$AE,$CC,$2B,$B4,$7A,$65,$32,$2F,  9,$FA,$B8,$4B,$46,$67,$9E,  8,$B6,$87,$3E,$CE,  7,$B8,$B1,$73,$64,$C5,$DE,$CE,$4A; 128
		dc.b $F9,$DF,$34,$AE,$9F,$E8,$EE,$9F,$2C,$A6,$94,$D4,$71,$EE,$95,$62,$9F,$A4,$7F,$E5,$3F,$4D,$87, $F,$5E,$6C,$46,$3C,$DB,$62,$1C,$DF,$99,$67,$C8,$FE,$64,$ED,$BD,$8B,$39,$E0,$FE,$65,$81,$D8,$86,$78,$6D,$B8,$70,$BB,$FE,$79, $B,$BF,$4F,$31,$46,$B5,$69,$30,$77,$6A; 192
		dc.b $E8,$CC,$50,$31,$F3,$BB,$95,$37,$FC,$F5,  1,$EC,$6B,$1A,$A0,$35,$83,$3D,$11,$4D,$57,$28,$7C,$D1, $F,$75,$34,$43,$D8,$3E,  8,$71,$F3,$2D,$2E,$F3,$6A,$5A, $C,$77,$40,$91,$8D,$48,$CA, $F,$75,$9F,$2F,$66,$BD,$C1,$AF,$76,$97,$E8,$EE,$EB,$4F,$3B,$BF,$4E,$75,$40; 256
		dc.b $FE,$B3,$3C,$9F,  4,$71,$5D,$C8,$7C,$54,$8B,$B5,$B5,$72,$B3,$45,$45,  3,$1D,$5D, $F,$8A,$D2,$65,$8E,$A3,$AD,$31,$4D,$44,$DA,$A1,$FA,$38,$CB,$9B,$A3,$A7,$90,$71,$8E,$AF,$CF,$68,$11,$CA,$B1,$2F,$1D,$C7,$F9,$85,$9F,$FB,$87,$72,$EF,$49,$1F,$C9,$2E,  5,$F5,$41; 320
		dc.b $70, $E,$9D,$95,$4E,$1C,$FD,  5,$BE,$53,$A0,$BA,$74,$B3,$F5,$8C,$C1,$E7,$4F,$73,$BD,$A3,$33,$B4,$EC,$46,$C7,$38,$C1,$C1,$CF,$61,$EF,$41,$31,$98,$6F,$CF,$36,$D1,$5C,$DB,$F3,$3B,$FE,$74,$B9,$5F,$D3,$F4,$42,$79,$FF,$24,$D8,$CA,$D0,$63,$BA,$2D,$23,$1A,$91,$96; 384
		dc.b $71,$D1,$9D,$4A,$87,$E3,$B7,$E1,$48,$A7,$EB,$C7,$E7,$87,$EB,$CB,  6,$2C,$58,$86,$78,$20,$83,$63,$63,$8A,  6, $C,$1C,$92,$5B,$78,$CD,$8F,$4F,$20,$E1,$1D,$5F,$9F,$A1,$1C,$AB,$DD,$E2,$50,$DF,$CC,$38,$7F,$EE, $B,$16,$EF,$7B,$AE,$6D,$D6,$41,$24,$AF,$CD,$D5,$87; 448
		dc.b $43,$B3,$DB,  3,$F7,$F3,$A7,$EB,$F1,$F9,$F6,$A5,$8E, $D,$69,$B9, $F,$B6,$4C,$FD,$DE,$DB,$B1,$1D,$87,$62,$E6,$78,$41,$7B,$24,$96,$DE,$33,$63,$D3,$C8,$38,$47,$57,$E7,$E8,$47,$2A,$FB,$FE,$17,$C4,$88,$FE,$61,$ED,$4F,$EC,$16,$EF,$EC,$5D,$73,$38,$64,$C3,$80,$E4; 512
		dc.b $92,$E3,$A7,$E8,$84,$F3,$FE,$49,$B1,$95,$A0,$CA,$B9,$C6,$39,$ED,$CC,$62,$D9,$ED,$51,$4C,$53,$43,  6,$C5,$81,$C3,$83,  3,$86, $F,$B1,$60,$CF, $F,  6,$C5,$AE, $E,$BF,$D9,$24,$B6,$F1,$9B,$1E,$9E,$41,$C2,$3A,$BF,$3F,$42,$39,$57,$F3,$BE,$24,$E6,$FE,$65,  5,$3F; 576
		dc.b $B0,$5B,$BC,$B1,$76,$4C,$32,$61,$C3,$92,$49,$71,$2E,$31,$7C,$EE,$F2,$CA,$4A,$57,$CE,$FB,$11,$2B,$84,$B9,$E5,$24,$92,$49,$3F,$17,$CD,$79,$5F,$2E,$25,$7C,$F2,  6,$D9,$73,$90,$BE,$49,$24,$96,$40; 640
S1Nem_MiniSonic:dc.b $80,$1E,$80,  4,  5,$14,  4,$24,  8,$35,$13,$45,$18,$56,$35,$66,$32,$73,  1,$81,  3,  0,$15,$16,$27,$7A,$82,  5,$14,$17,$79,$83,  4,  6,$16,$3A,$84,  6,$36,$85,  6,$34,$86,  6,$38,$87,  5,$15,$88,  6,$2F,$18,$F9,$89,  6,$2E,$8A,  7,$76,$8B,  6,$33,$8C,  6; 0
		dc.b $39,$8D,  7,$78,$17,$7B,$8E,  4,  7,$16,$37,$8F,  5,$12,$17,$77,$FF,$25,$3F,$7E,$12,$53,$71,$1B,$E4, $E,$FA,$FA,$C7,$70,$61,$E5,$39,$4D,$C2,$7E,$F8,$47,$EC,$49,$26,$7F,$BF,  9,$29,$B8,$8D,$F2,  4,$93,$AB,$CA,$72,$9B,$84,$FD,$F0,$8F,$D8,$92,$4C,$77,$11,$23; 64
		dc.b  $E,$64,$65,$87,$49,$61,$F2, $F,$90,$7C,$82,$6F,$37,$5F,$50,  9,$26,$41,$7F,$9E,$63,$74,$78,$B1,$24,$93, $F,$3D,$D6,$D1,$E8,$92,$64,$17,$B8,$28,$F9,$58,$92,$49,$2B,$BE,$BE,$89,$25,$3B,$88,$EE,$51,$CC,$8C,$B0,$E9,$2C,$3E,$41,$F2, $F,$90,$4D,$E7,$BF,$A8,$B1; 128
		dc.b $24,$85,$EE,$17,$B9,$24,$92,$66,$F2,$9C,$A6,$F1,$FB,$E6,  9,$FB,$16,$39, $D,$6D,$3B,$35,  2,$F7,$DF,$C7,$2A,$32,$64,$FD,$F2,$88,$FD,$14,$DF,$F3,$94,$33,$FD,$76,$BF,$A2,$9B,$FE,$B2,$85,$7F,$BC,$17,$F8,$5D,  8,$14,$60,$DF,$A2,$6F,$49,$E9,$3C,$B5,$A2,$8A,$1B; 192
		dc.b $20,$C3,$51,$14,$26,  6,$4C,$30,$27,$44,$61,$81,$A8,$61,$86,$18,$B1,$26,$3F,$47,$1D,$7E,$9D,$29,$67,$94,$79,$41,$29,$D1,  4,$75,$F9,$97,$46,$9D,$15,$B5,$A2,$8C,$51,$A8,$32,$A2, $D,$42,$F3, $C,$30,$C2,  2,$37,$9F,$9B,$A3,$F3,$56,$B9,$33,$15,$B9,$42,$DF,$F9; 256
		dc.b $CD,$1B,$80,$96,$49,$5C,$B7,$BD,$AF,$D3,$B2,$5F,$55,$71,$8D,$87,$6D,$A7,$A6,$63,$17,$FB,$E5,$B2,$AF,$5A,$FE,$5F,$66,$F2,$96,$5A,$8C,  5,$AA,$51,$94,$2D,$A1,$AC,$DC,$36,$AC,$B5,$46,$81,$3D,$8A,$B2,$D5,$39,$5A,$BD,$3F,$58,$B9,$F6,$D1,$42, $A,$E8,$EB,$C7,$E5; 320
		dc.b $34,$F0,$E9,$5F,$CA,$B6,$78,$E3,$9D,$33,$41,$76,$D7,$DD,$E1,$33,$5C,$EF,$90,$8C,$FB,$7C,$D6,$72,$13,$17,$DD,$C5,$FE,$13,$DC,$AB,$A2,$FB,$FC,$E0,$BB,$F7,$B8,$FD,$1C,$75,$FA,$74,$A5,$9E,$51,$E5,  4,$A7,$44,$11,$D7,$E6,$5D,$1A,$74,$56,$D6,$8A,$31,$46,$A0,$CA; 384
		dc.b $88,$35, $B,$CC,$30,$C3,  8,  8,$DE,$7E,$6E,$8F,$CD,$5A,$E4,$CC,$56,$E5, $B,$7F,$E7,$34,$6E,  2,$59,$25,$72,$DE,$F6,$BF,$4E,$C9,$7D,$55,$C6,$36,$1D,$B6,$9E,$99,$8C,$5F,$EF,$96,$CA,$BD,$6B,$F9,$7D,$9B,$CA,$59,$6A,$30,$16,$A9,$46,$50,$B6,$86,$B3,$70,$DA,$B2; 448
		dc.b $D5,$1A,  4,$F6,$2A,$CB,$54,$E5,$6A,$F4,$FD,$62,$E7,$DB,$45,  8,$2B,$A3,$AF,$1F,$94,$D3,$C3,$A5,$7F,$2A,$D9,$E3,$8E,$74,$CD,  5,$DB,$5F,$77,$84,$CD,$73,$BE,$42,$33,$ED,$F3,$77,$87,$49, $B,$FA,$71,$7D,$DF,$95,$D9,$D7,$DC,$BA,$B9,  0; 512
Nem_Bunny:	dc.b   0,$12,$80,  5,$12,$15,$1A,$25,$13,$35,$19,$45,$17,$55,$1C,$66,$3C,$78,$FA,$81,  4, $A,$86,  3,  3,$15,$18,$26,$3B,$38,$FB,$87,  3,  0,$16,$3A,$88,  3,  2,$14,  8,$25,$16,$35,$1B,$47,$7C,$89,  3,  1,$16,$3D,$FF,$95,$8E,$7E,$64,$EE,$F6,$37,$31,$7B,$64,$A6; 0
					; DATA XREF: ROM:0001C2C6o
					; ROM:0001C30Co
		dc.b $B2,$83,$19,$4E,$86,$53,$A1,$38,$74,$26,$18,$C4,$C6,  3,$92,$F4,$77,$23,  6, $E,$BD,$B0,$C9,$41,$DD,  7,$72,$87,  1,$E0,$53,$1B,$92,$1D,$F5,$21,$81,$E1,$B4,$FE,$6B,$67,$46,$D3,$B1,$CE,$F3, $D,$19,$A0,$C2,$9A,$14,$D4,$D0,$A6,$A6,$85,$38,$D5,$60,$31,$AC, $C; 64
		dc.b  $D,$7D,$8F,$57,$B0,$60,$F5,$6F,$65,$80,$8C,$F0,$16,$7A,$46,$E4,$71, $E,$6C,$4D, $E,$C2,$C8,$C0,$FA,$CF,$EE,$66,$7F,$42,$67,$BA,$D4,$62,$27,$18,$57,$87,$E2,$FA,$F1,$70,$8E,$21,$C8,$E4,  6,$26,$57,$62,$68,$63,$65, $F,$EC,$4A,$3A,$B4,$8C,$74,$56,$8D,$99,$D5; 128
		dc.b $18,$C9,$F9,$23,$FB,$7C,$7D,$7D,$1F,$3D,$E5,$1E,$2A,$37,$8A,$BC,$55,$CD,$8C,$FA,$DE,$BE,$35,$2F,$8D,$1D,$BA,$47,$6E,$91,$41,$87,$4E,$97,$63,  1,$7F,$58,$47,$D8,$92,$3C,  8,$DD,  3,$73,$17,$82,$B3,$80,$5F,$D6,$8E,$4D,$A6,$6C,$35,  1,$11,$28,$68,$C1,$4D,$19; 192
		dc.b $5B, $B,$5F,$26,$57,$3D,$F0,$FD,$78,$75,$D2,$91,$52,$18,$16,$90,$EE,$D2,$41,$EF,$26,  5,$CA,$17,$81,$37,$6A,$9B,  8,$D6,$58,$8B,$F7,$C4,$36,$67,$D6,$F5,$F1,$A9,$6C,$34,$76,$E9,$1D,$BA,$45,  6,$1D,$3A,$5D,$8C,  5,$FD,$60,$57,$D8,$94,$1B,$DA,$F0, $E,$6C,$32; 256
		dc.b $99,$46,$68,$D0,$47,$48,$CA,$82,$32,$46,$54,$D1,$91,$D5,  3,$AA,$F2,$BC,$47,$96,$BE,  5,$C0,  0; 320
Nem_Chicken:	dc.b $80, $E,$80,  3,  1,$15,$17,$25,$18,$34, $A,$45,$12,$55,$19,$67,$7A,$76,$37,$81,  3,  0,$15,$13,$83,  8,$F8,$84,  8,$F9,$85,  6,$39,$86,  6,$36,$87,  5,$16,$88,  4,  8,$89,  4,  6,$8A,  6,$38,$16,$3B,$8B,  8,$FA,$8C,  5,$1A,$8D,  6,$3A,$8E,  3,  2,$17,$7B; 0
					; DATA XREF: ROM:0001C304o
					; ROM:0001C312o
		dc.b $8F,  4,  7,$16,$3C,$FF,$DF,$D6,$B3,$D6,$50,$93,$6D,$F9,$BC,$30,$79,$E0,$3C,$F7,$A7,$16,$2B,$7B,$B7,$A5,$3B,$45,$9A,$98,$FB,$65,$38,$2B,$CF,$7F,$96,$FC,$17,$C0,$41,$40,$E4,$B0,$FD,$7D,$97,  7,$F3,$37,$12,$67,$12, $C,$82,$A1,$1A,$69,$22,$29,$FE,$78,$92,$E0; 64
		dc.b $4A,$7B,$DF,$AF,$41,$67,$EB,$66,$90,$70,$D5,$37,$1B,$CA,$C1,$F7,$DD,$B1,$16,$9A,$A6,$A6,$BC,$4D,$32,$3F,$82,$FC,$B7,$BF, $F,$23,$64,$10,$2A,$C3,$C0,$D7,$17,$FC,$CE,  3,$B5,$7B,$61,$5F,$10,$32,$B3,$C7,$CB,$C8,$70,$B3,$3A,$D6,$75,$E8,$7A,$EB,$9A,$8B,$15,$88; 128
		dc.b $7D,$CB,$3E,$67,$4E,$5C,$1D,$88,$90,$DA,$7F,$AF,$28,$3C,$F0,$C9,$C4,$5B, $D,$6D,$97,$CB,$E3,$F4,$9C,$36,$3F,$55,$3F,$CE,$75,$FA,$1A,$1A,$AE,$7E,$BB,$B4,$31,$42,$E1,$C3,$52, $F,$3B,$87,$CB,$8B,$5C,$5D,$F7,$A0,$41,$56,$86,$99,$70,$C5,$1F,$1B,$9F,$8F,$D7,$86; 192
		dc.b $1A,$C0,$8E,$3C,$D5,$E0,$F1,$F9,$4C,$7E,$87,$BC,$CC,$FE,$72,$5A,$F4, $F,$32,$EB,$95,$95,$B8,$CB,$DF,$6A,$99,$1B,$41,$80,$E5,  3,  7,$D9,$67,$21,$E8,$11,$B4,$EF,  0,$B7,$E5,$AE,$21,$87, $B,$13,$83,$F3,$21,$DE,$BA,$A9,$91,$A9,$7D,$77,$68,$6B,$8B,$87, $D,$48; 256
		dc.b $38,$C0,$7C,$B8,$B4,$9F,$79,$20,$55,$A1,$8A,$74,$18,$AC,$47,$3F,$1E,$10,$9B,$55,$B5,$9C,$EB,$1D,$ED,$2E,$C4,$80; 320
Nem_Penguin:	dc.b   0,$12,$80,  6,$36,$15,$1A,$23,  1,$35,$18,$47,$7B,$75,$19,$81,  3,  2,$14,  8,$26,$3B,$38,$FB,$48,$FA,$86,  4,  9,$16,$39,$87,  4,  7,$17,$7A,$88,  4,  6,$16,$38,$89,  3,  0,$15,$16,$27,$7C,$8B,  4, $A,$16,$3A,$8F,  5,$17,$16,$37,$26,$3C,$FF,$CE,$73,$8E; 0
					; DATA XREF: ROM:0001C2D4o
		dc.b $B7,$C2,$AD,$CA,$B5,$5C,$DA,$45,$C8,$79,$76,$22,$53,$B1,$12,$9D,$B4,$84,$A7,$65,$B0,$42,$77,$81,$1B,$A1,  2,$37,$D8,$7F,$47,$61,$16,$E3,$41,$71,$E8,$86,$7E,$4B,$3F,$E9,$8B,$3F,$E9,$8B,$7A,$97,$21,$9F,$8D,$75,$BD,$B6,$AF,$33,$9C,$9B,$F5,$EE,$F4,$BD,$D5,$96; 64
		dc.b   4,$DB, $F,$2E,$30,$EA,$46,$1D,$48,$C3,$A9,  8,$DE,$42,$1B,$2D,$B7,$81,$1B,$5E,  4, $D,$BE,$86,$9A,$D0,$34,$FC,$20,$65,$D8,$63,$97,$6C,$72,$ED,$89,$F4,$D8,$67,$61,$81,$BF,$5E,$FC,$AC,$E7,$3F,$D0,$BD,$62,$FB,$55,$FA,$35,$FB,$F3,$78,$E8,$A6,$F8,$5A,$D0,$58; 128
		dc.b $76,$47,$D9,$11,$63,$16,$46,  4,$61,  8,$3F,$45,$7C,$5A,$8F,$8D,$A8,$10,$35,$16,$8D,$21,$C2,$1A,$41,$E7,$8D,$20,$CF,$2F,$B7,$63,$8A,$CE,$73,$9C,$F9,$EE,$AE,$2F,$80,$A4,$51,$4F,$2D,$45,$4A,$60,$54,$A6,  5,$4A,$90,$62,$42,$3D,$DD,$18,$F0,$FD,$1B,$70,  8,$6E; 192
		dc.b $58,$B0,$E5,$C8,$61,$E8,$A6,$B3,$1B,$70, $B, $A,$DE,$B5,$FD,$FF,$E8,$5E,$B1,$7D,$AA,$FD,$1A,$FD,$F9,$BC,$74,$53,$7C,$2D,$68,$2C,$3B,$23,$EC,$88,$FD,$CE,$D1,$68,$B4, $F,$BB,$7F,$87,$E4,$6D,$D8,$EF,$6F,$F0,$EB,$EE,$C6,  7,  5,  6,$F4,$50,$6E,$4A, $F,$C9,$41; 256
		dc.b $BD,$6B,$BF,$D4,$7B,$B2,$CE,$73,$BD,$7B,$F2,$B0,$2A,$6F,$45,$3C,$B5,$15,$29,$81,$52,$98,$15,$2A,$41,$89,  8,$F7,$74,$63,$C3,$F4,$7E,$88,$67,$60,$59,$E5,$D8,$BF,$2E,$C7,$F6,$CE,$7F,$6C,$C7,$97,$96,$2D,$FA,$76,$3B,$D3,  2,$BC,$AC,$2A,$DE,$B4; 320
Nem_Seal:	dc.b   0, $E,$80,  5,$18,$15,$16,$25,$1A,$35,$1B,$45,$1C,$56,$3B,$76,$3A,$81,  5,$19,$86,  3,  3,$15,$17,$26,$3C,$38,$F9,$87,  2,  0,$14, $A,$26,$3D,$38,$FA,$88,  3,  2,$14,  9,$28,$F8,$89,  4,  8,$18,$FB,$FF,$EB,$AE,$BA,$E4,$9B,$45,$F4,$86,$3D,$21,$8F,$43,$C8; 0
					; DATA XREF: ROM:0001C2DAo
					; ROM:0001C2E8o
		dc.b $B4,$3C,$8A,$D2,$F2,$2B,$52,$BE,$6C,$5C,$BD,$A0,$F9,$F8,$89,$FB,$43,$11,$38,$F8,$AB,$D9,$41,$E6,$A2,$AF,$B5,$4F,$70,$AB,$91,$3B,$55,$C1,$F5,$D7,$5D,$5A,$7B,$62,$E0,$C5,$B1,$8B,$66,$59,$B3,$2C,$D9,$97,$3A,$BA,$AD,$32,$E6,$BC,$23,$51,$31,$F1,$84,$21,$8B, $E; 64
		dc.b $90,$AD,$72,$16,$9D,$46,$E9,$70,$51,$C5,$1D,$D2,$ED,$9D,$75,$B8,$EE,$17,$73,$DA,$3B,$47,$73,$DC,$2C, $B,$6B, $F,$E0,$50,$D3,$FA,$5E,$B2,$E5,$91,$F3,$65,$57,$34,$BE,$B7,$22,$EA,$6A,$6D,$4E,$A7,  7,$83,$31,$E5,$32,$3C,$1E,$48,$2E,$3C,$90,$BD,$79,$79,$3C,$2E; 128
		dc.b $2F,$EB,$13,$F2,$60,$F8,$FB,$B0,$A2,$9F,$A8,$B8,$A0,$84,$28,$B4,$FE,$E7,$A8,$5C,$84,$72,$4E,$21,$F1, $F,$92,$72,$27,$B4,$77, $B,$90,$A3,$70,$A9,$C2,$8A,$B8,$C4,$5C,$86,$A9,$FD,$4F,$D2,$8C,$42,$A9,$A9,$D0,$EA,$6D,$E0,$CB,$5E,$99,$18,$B8,$F2,$46,$2E,$3C,$91; 192
		dc.b $8F,$5E,$5E,$71,$E1,$73,$1F,$D6,$30,$BE,$4B,$13,$F7,$A2,$61,$45,$84,$28,$56,$43,$21,$5A,$10,$C8,$B2,$85,$ED,$80; 256
Nem_Pig:	dc.b $80,$12,$80,  3,  2,$14,  9,$24,  7,$35,$18,$45,$17,$55,$1A,$65,$1B,$74,  8,$81,  3,  0,$14, $A,$26,$3C,$86,  8,$FA,$87,  5,$1C,$8A,  4,  6,$17,$7C,$26,$3D,$8B,  3,  1,$15,$1D,$8C,  5,$16,$8D,  5,$19,$18,$FB,$FF,$76,$3B,  7,$E6,$2A,$EC,$15,$B5,$95,$9B,$8E; 0
					; DATA XREF: ROM:0001C2F0o
					; ROM:0001C2FEo
		dc.b $60,$EC,$42,$B7,$33,$AC,$F1,$31, $F,$69,$F2,$59,$52, $A,$97,$6B,$62,$23,$46,  6,$C8,$7F,$B6,$71,$86, $F,$94,$1C,$CE,$4B, $D,$10,$CB,$D2,$35,$57,$B2, $C,$F9,$59,$D7,  4,$23,$B0,$F9,$E5,$B0,$39,$9B,$8B,$38,$2C,$1A,$7C,$5E,$20,$AB,$15,$DC,  8,$88,$3A,$1A,  5; 64
		dc.b $D8,$3B,$7D,$B8,$6C,$17, $B,$2E,$18,$E5,$D8,$C4,$44,$39,$76,$28,$84,$C6,$48,$96,$F2,$EC,$6B,$46,  4,$6C,$88,$D9,$11,$B2,$FE,$A2,$E2,$48,$73,$21,$16,$E8,$70,$AA,$2F,$5A,$F1, $B,$88,$91,$AF,$A4,$1C,$7E,$5B,  3,$EA,$C9,$A6,$B9,$6F,$92,$17,$15,$98,$FB,$FA,$D0; 128
		dc.b $BD,$3B, $D,$BB,$35,$F2,$BF,  4,$70,$39,$F8,$F8,$D8,$4C,$F6,$E5,$85,$ED,$22,$E1,$8F,$EC,$58,$BF,$EA,$F0,$62,$22,$22,$22,$2F,$D9,$62,$8D,$31,$92,$25,$BC,$BB,$1A,$D1,$43, $C,$69,$CA,$AC,$7D,$62,$B2,$B9,$4D,$D9,$B7,$5F,$EC,$7A,$8B,$89,$21,$CC,$8B,$8B,$F7,$1F; 192
		dc.b $2A,$21,  7,$1B,$A4,$10,$D0,$43,$5F,$C1,$70,$99,  7,$F0,$AF,$18,$CF,$EE,$E7,$D3,$B0,$DB,$B3,$5F,$2B,$F0,$47,  3,$9F,$8F,$8D,$84,$CF,$6E,$58,$5E,$D2,$2E,$18,$F9,$F0,$CD,$23,$AA,$EC,$D4,$D4,$F7,$F6,$38,$FD,$DC,$80,  0; 256
Nem_Flicky:	dc.b   0, $E,$80,  5,$14,$15,$12,$25,$15,$35,$18,$46,$37,$56,$3B,$66,$3C,$74,  7,$81,  4,  4,$16,$3D,$82,  3,  1,$15,$1A,$27,$7C,$83,  3,  0,$15,$19,$28,$FA,$84,  5,$16,$85,  4,  5,$15,$13,$48,$FB,$86,  4,  6,$87,  4,  8,$8B,  6,$36,$8C,$16,$3A,$8F,  5,$17,$15; 0
					; DATA XREF: ROM:0001C2CCo
					; ROM:0001C2F6o
		dc.b $1C,$FF,$77,$77,$7C,$1F,$AC, $B,$4E,$A1,$5A,$75,$B4,$34,$2D,$55,$92, $D,$43,$24,$19,$10,$C9,  6,$59,$56,$E4,$87,$5C,$DA,$47,$A1,$CD,$D0,$2C,$A6,$57,$F2,$D2,$36,$9F,$E5,$AA,$82,$6D,$84,$2A,$37,$4D,$93,$7B,$ED,$BD,$FD,$DD,$1D,$DD,$FB,$18,$C9,$18,$5B,  3,$85; 64
		dc.b $65,$18,$86,$8B,$62,$11,$97,$10,$8C,$31,  8,$C0,$D6,$EC,$B9,$AF,$3A,$15,$B8,$E8,$D4,$27,$6C,$A6,$75,$69,$D8,$D6,$61,$30,$A5,$37,$D9,$3B,$DA,$FD,$FB,$7F,$11,$DE,$A1,$CF,$82,$A1,$68,$44,$8C,$F4,$24,$66,  8,$91,$98,$22,$84,$19,$90,$44,$CA,$EA,$4A,$CA,$14,$CA; 128
		dc.b $E6,$60,$D3,$87,$F4,$32,$4E,$76,$9F,$AB,$DF,$F4,$2E,$F2,$16,$5B,$66,$56,$FB,$14,$FB,$65,$1F,$A5,$10,$D1,$95,$D3,$24,$11,$F1,$92, $F,$D1,$64,$83,$9E,$8B,$5D,$35,$D6,$B9,$EF,$CF,$CD,$BB,$BB,$F8,$1C,$F8,$3B,$23,$B2, $E,$E4,$11,$4C,$D3,$E6,$66,$35,$25,$FD,$99; 192
		dc.b $94,$FE,$96,$57,$9F,$D5,$39,$B2,$4C,$52,$FB,$25,$3D,$5A,$5F,$64,$91,$4A,$7A,$EF,$B8,$B2,$DB,$32,$B7,$D8,$A7,$DB,$28,$FD,$28,$86,$8C,$AE,$99,$20,$8F,$8C,$90,$7E,$8B,$24,$68,$74,$5A,$E8, $F,$5A,$E1,$4F,$9F,$9B,$7A, $F,$17,$C4,$7F,  0; 256
Nem_Squirrel:	dc.b   0,$12,$80,  5,$17,$15,$19,$24, $A,$35,$12,$45,$1B,$56,$39,$68,$F8,$75,$13,$81,  4,  6,$16,$3C,$86,  4,  8,$87,  5,$1A,$88,  6,$3B,$8A,  5,$18,$17,$7B,$27,$7A,$48,$FA,$8B,  3,  1,$14,  7,$25,$16,$36,$38,$8D,  3,  0,$13,  2,$26,$3A,$38,$F9,$FF,$A5,$CE, $F; 0
					; DATA XREF: ROM:0001C2E2o
		dc.b $54,$70,$8C,$81,$83,$23,$A8,$D4,$8C,$36,$A4,$61,$B5,$40,$C3,$6A,$8E, $C,$62,$8F,$EE,$AE,$51,$F5,$70,$E1,$C6,$51,$1E,$E4,$BD,$EC,$1C,$6C,$3D,$C1,$B8,$76,$BD,$81,$61,$9E,$18,$D3,$A3,$C8,$3F,  3,$E0,$4E,$4B,$3F,$27,$19,  5,$60,$E4,$18,$22,$8E,$A3,$46,$8E,$9A; 64
		dc.b  $D,$1D,$34,$1A,$3A,$68,$23,$2D,$88,$38,$39,$FA,$39,$FD,$D1,$45,$38,$71,$E8,$15,$7F,$4A,$BD,$91,$2B,  9,$78,$E2,$E7,$A6,$22,$C0,$B7,$17,  5,$3E,$41,$1B,$5C,$AE,$44,$E7,$39,$CF,$6F,$27,$54,$FD,$52,$B6,$45,$BC,$CB,$F9,$22,$D3,$9C,$E7,$39,$CC,$AD,$9C,$2D,$FF; 128
		dc.b $6E,$BA,$B6,$7F,$9A,$F7,$16,$46,$E0,$B3,$87,  6,$FE,$74,$45,$33,$83,$42,$C2,$85,$9A,$4E,$A4,  8,$32,$6B,$4F,$F9,$B4, $A,$23,$21,$C1,$81,$74,$FA,$8E,$C7,$10,$DD,$8E,$21,$BB, $F,$83, $D, $C,$7D,$1F,$CB,$60,$FF,$A8,$1F,$AB,$B7,$52,$20,$89,$36,  6,$C3,$72,$43; 192
		dc.b $4E,$73,$9C,$ED,$5F,$EB,$F9,$FE,$DF,$F7,$5B,$FB,$62,$FF,$A1,$E2,$5F,$B1,$9F,$C1,$E4,$1D,$87,$E5,$48,$AD,$9C,$2D,$DB,$95,$CA,$E4,$5A,$43,$8A,  7,$A3,$95,$61,$61,$FA,$1F,$E5,$B7,  3,$D9,$16,$57,$E1,$67,$E6,$43,$E3,$F9,$B4, $A,$23,$21,$C1,$81,$74,$FA,$8E,$C7; 256
		dc.b $10,$DD,$8E,$21,$BB, $F,$83, $D, $C,$7D,$1F,$CB,$60,$FF,$A8,$1F,$AB,$D8,$35,$10,$E1,$A9,$38,$F2,$85,$86,$C3,$CC; 320

Map16_EHZ:
          incbin "Levels\03\16.bin"
          even

Nem_EHZ:
        incbin "Levels\03\art.bin"
        even

Map16_HTZ:	dc.w $41FE,$49FE,$41FF,$49FF,$4200,$4A00,$4201,$4A01,$4202,$4A02,$4203,$4A03,$4204,$4206,$4205,$4207,$4208,$420A,$4209,$420B,$4204,$420C,$4205,$420D,$420E,$4210,$420F,$4211,$4A0A,$4212,$4A0B,$4213,$4204,$420C,$4205,$420D,$420E,$4210,$420F,$4211,$4202,$4A02,$4203,$4A03,$4A10,$4A0E,$4A11,$4A0F,$4204,$420C,$4205,$420D,$4214,$4216,$4215,$4217,$4202,$4A02,$4203,$4A03,$4A16,$4A14,$4A17,$4A15; 0
					; DATA XREF: MainLevelLoadBlock+5Eo
		dc.w $41FC,$4218,$41FD,$4219,$421A,$421C,$421B,$421D,$421E,$4A1E,$421F,$4A1F,$4A1C,$4A1A,$4A1D,$4A1B,$41FC,$41FC,$41FD,$41FD,$41FC,$4220,$41FD,$4221,$4222,$4A22,$4223,$4A23,$4A20,$41FC,$4A21,$41FD,$4224,$4A24,$4225,$4A25,$4A10,$4A0E,$4A11,$4A0F,$4A10,$4A0E,$4A11,$4A0F,$4A16,$4A14,$4A17,$4A15,$4A1C,$4A1A,$4A1D,$4A1B,$41FC,$4218,$41FD,$4219,$421A,$421C,$421B,$421D,$421E,$4A1E,$421F,$4A1F; 64
		dc.w $41FC,$41FC,$41FD,$41FD,$41FC,$4220,$41FD,$4221,$4222,$4A22,$4223,$4A23,$4A20,$41FC,$4A21,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$4224,$4A24,$4225,$4A25,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD; 128
		dc.w $4204,$420C,$4205,$420D,$4214,$4216,$4215,$4217,$41FC,$4218,$41FD,$4219,$421A,$421C,$421B,$421D,$421E,$4A1E,$421F,$4A1F,$41FC,$4220,$41FD,$4221,$4222,$4A22,$4223,$4A23,$4224,$4A24,$4225,$4A25,$4226,$421C,$4227,$421D,$4A18,$4220,$4A19,$4221,$4204,$420C,$4205,$420D,$4214,$4216,$4215,$4217,$4A1C,$4A26,$4A1D,$4A27,$4A20,$4218,$4A21,$4219,$4A18,$4220,$4A19,$4221,$4226,$421C,$4227,$421D; 192
		dc.w $41FC,$41FC,$41FD,$41FD,$4228,$422A,$4229,$422B,$A22C,$A22E,$A22D,$A22F,$A230,$A232,$A231,$A233,$A234,$A236,$A235,$A237,$A238,$A23A,$A239,$A23B,$A23C,$A23E,$A23D,$A23F,$A240,$A242,$A241,$A243,$4244,$4246,$4245,$4247,$4248,$424A,$4249,$424B,$424C,$424E,$424D,$424F,$4250,$4252,$4251,$4253,$4254,$4256,$4255,$4257,$4A4A,$424A,$4A4B,$424B,$5A4B,$4258,$5A4A,$4259,$425A,$425C,$425B,$425D; 256
		dc.w $425E,$4260,$425F,$4261,$4262,$4264,$4263,$4265,$4266,$4268,$4267,$4269,$426A,$426C,$426B,$426D,$426E,$4270,$426F,$4271,$4272,$4274,$4273,$4275,$4276,$4278,$4277,$4279,$4244,$424E,$4245,$424F,$427A,$427C,$427B,$427D,$427E,$4280,$427F,$4281,$4282,$4284,$4283,$4285,$4286,$4288,$4287,$4289,$428A,$428C,$428B,$428D,$428E,$4290,$428F,$4291,$4248,$4292,$4249,$4293,$4294,$4296,$4295,$4297; 320
		dc.w $4298,$429A,$4299,$429B,$429C,$429E,$429D,$429F,$42A0,$42A2,$42A1,$42A3,$4248,$42A4,$4249,$42A5,$42A6,$4A94,$42A7,$4A95,$4248,$42A8,$4249,$42A9,$42AA,$4A94,$42AB,$4A95,$42AC,$42AE,$42AD,$42AF,$5A97,$4A94,$5A96,$4A95,$42B0,$42B2,$42B1,$42B3,$42B4,$42A2,$42B5,$42A3,$4248,$42B6,$4249,$42B7,$42B8,$42BA,$42B9,$42BB,$42BC,$42BE,$42BD,$42BF,$4294,$5AA7,$4295,$5AA6,$5A79,$5A77,$5A78,$5A76; 384
		dc.w $5A71,$5A6F,$5A70,$5A6E,$5A85,$5A83,$5A84,$5A82,$42C0,$5AAD,$42C1,$5AAC,$5ABF,$42C2,$5ABE,$42C3,$4AC2,$5ABD,$4AC3,$5ABC,$5ABF,$5ABD,$5ABE,$5ABC,$5A53,$5A51,$5A52,$5A50,$C2C4,$CAC4,$C2C5,$CAC5,$42C6,$42C8,$42C7,$42C9,$5A47,$42CA,$5A46,$42CB,$42CA,$42CC,$42CB,$42CD,$42CE,$42D0,$42CF,$42D1,$42D2,$42D4,$42D3,$42D5,$62D6,$62D6,$62D7,$62D7,$62D8,$62DA,$62D9,$62DB,$62DC,$62DE,$62DD,$62DF; 448
		dc.w $62E0,$61FC,$62E1,$61FD,$62DE,$62E2,$62DF,$62E3,$62E4,$62E6,$62E5,$62E7,$61FC,$62E8,$61FD,$62E9,$62EA,$61FC,$62EB,$61FD,$62EC,$62EE,$62ED,$62EF,$62F0,$62F2,$62F1,$62F3,$62F4,$62D6,$62F5,$62D7,$62F6,$62D6,$62F7,$62D7,$62D6,$62E4,$62D7,$62E5,$62F8,$62FA,$62F9,$62FB,$62FC,$62FE,$62FD,$62FF,$6300,$6302,$6301,$6303,$6304,$61FC,$6305,$61FD,$61FC,$6306,$61FD,$6307,$6308,$630A,$6309,$630B; 512
		dc.w $630C,$630E,$630D,$630F,$6310,$62D6,$6311,$62D7,$6312,$6314,$6313,$6315,$6316,$6318,$6317,$6319,$62F8,$6B0E,$62F9,$6B0F,$631A,$62F6,$631B,$62F7,$631C,$62F4,$631D,$62F5,$62E6,$62EC,$62E7,$62ED,$631E,$6320,$631F,$6321,$6322,$6324,$6323,$6325,$6326,$630E,$6327,$630F,$62E4,$62F8,$62E5,$62F9,$6328,$632A,$6329,$632B,$632C,$632E,$632D,$632F,$6330,$6332,$6331,$6333,$6334,$6336,$6335,$6337; 576
		dc.w $6338,$6310,$6339,$6311,$62E6,$633A,$62E7,$633B,$62EE,$630C,$62EF,$630D,$633C,$633E,$633D,$633F,$6340,$630E,$6341,$630F,$6342,$6344,$6343,$6345,$6346,$6348,$6347,$6349,$634A,$634C,$634B,$634D,$62F8,$634E,$62F9,$634F,$6322,$62F6,$6323,$62F7,$6350,$6330,$6351,$6331,$62E6,$6308,$62E7,$6309,$6352,$6354,$6353,$6355,$6356,$61FC,$6357,$61FD,$61FC,$62DC,$61FD,$62DD,$6358,$635A,$6359,$635B; 640
		dc.w $635C,$635E,$635D,$635F,$6360,$6362,$6361,$6363,$62F8,$6364,$62F9,$6365,$633C,$631C,$633D,$631D,$62F4,$62E4,$62F5,$62E5,$62E6,$6366,$62E7,$6367,$6368,$6324,$6369,$6325,$6340,$62F2,$6341,$62F3,$6300,$62D6,$6301,$62D7,$636A,$636C,$636B,$636D,$6334,$636A,$6335,$636B,$636E,$635A,$636F,$635B,$62F8,$6370,$62F9,$6371,$6372,$6338,$6373,$6339,$6310,$62E4,$6311,$62E5,$62E6,$6374,$62E7,$6375; 704
		dc.w $6376,$633E,$6377,$633F,$6378,$630E,$6379,$630F,$62DE,$62E0,$62DF,$62E1,$6330,$6334,$6331,$6335,$637A,$6332,$637B,$6333,$6332,$6334,$6333,$6335,$6336,$637C,$6337,$637D,$636E,$6350,$636F,$6351,$6330,$6334,$6331,$6335,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD; 768
		dc.w $41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD; 832
		dc.w $41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD; 896
		dc.w $41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD,$41FC,$41FC,$41FD,$41FD; 960
Nem_HTZ:	dc.b $81,$82,$80,  3,  1,$14,  5,$25,$11,$35,$13,$45,$18,$55,$14,$66,$37,$73,  0,$81,  4,  6,$17,$72,$82,  4,  4,$18,$F0,$83,  6,$36,$18,$F5,$84,  6,$2F,$18,$F6,$85,  6,$32,$17,$76,$86,  6,$33,$87,  4,  7,$17,$75,$88,  6,$35,$18,$F3,$89,  6,$38,$8A,  5,$12,$18; 0
					; DATA XREF: ROM:0001C212o
		dc.b $F1,$8B,  6,$2E,$8C,  5,$10,$17,$73,$27,$77,$38,$F4,$8D,  5,$15,$17,$74,$8E,  6,$34,$18,$F2,$8F,  5,$16,$FF,  0,  0,  0,  0,  0,  0,$8F,$EA,$3A,$63,$B5,$3B,$53,$B5,$3B,$53,$B5,$3B,$53,$B5,$3B,$53,$B5,$3B,$53,$B5,$3B,$53,$B5,$3B,$53,$B1,$FD,$76,$6E,$8E,$91; 64
		dc.b $6D,$DB,$76,$A7,$2A,$72,$7C,$33,$96,$9D,$95,$23,$A4,$6F,$5D,$30,$DB,$A6,$F7,$86,$C6,$45,$31,$DA,$FC,$7E,$97,$F5,$D9,$BA,$3A,$45,$B7,$6D,$DA,$9C,$A9,$CA,$8D,$93,$63,$22,$93,$BC,$E6,$59,$6F,$2C,$A9,$16,$74,$56,$2C,$E8,$C8,$50,$BA,$1E,$49,$8F,$D0,$A3,$22,$F2; 128
		dc.b $2D,$3E,$51,$FD,$75,$B4,$FC,$FB,$D3,$8A,$71,$4E,$29,$C5,$38,$8F,$E6,$4F, $B,$F9,$95,$E0,$FE,$66,$7F,$99,  0,  0,  5,$3F,$73,$FB,$A8,$ED,$4D,$A3,$E2,$76,$3F,$AA,$5E,$3C,$40,$9C,$B7,$6A,$5D,$49,$52,$4D,$46,$5B,$A3,$71,$FC,$DC,$64,$6E,$C3,$5D,$89,$5D,$89,$35; 192
		dc.b $C7,$F7,$6D,$FA,$B9,$DD,$46,$5B,$A9,$74,$DF,$39,$51,$DA,$6F, $B,$A6,$D0,$C5,$D2,$9B,$5D,$8B,$A4,  0,  2,$90,$F1,$F4,$D3,$33,$9C,$5F,$23,$9A,$BC,$2E,$7C,$CB,$C2,$E3,$72,$3E,$77,$45,$CD,$D2,$8D,$C9,$47,$A5,$C9,$47,$A5,$C9,$47,$8E,$8B,$72,$2E,$91,$75,$D2,$37; 256
		dc.b $21,$D2,$6E,$74,$A6,$98,$E3,$2F,$CC,$FE,$EA,$3B,$46,$4B,$B2,$F8,$AE,$C7,$C5,$7F,$33,$E2,$23,$C0,$DB,$1C,$16,$A2,$63,$8D,$B1,$C1,$6A,$22,$B2,$F0,$85,$93,$63,$C6,$C5,$36,$9B,$24,$76,$E3,$64,$5F,$53,$FA,$3F, $F,$D0,$EC,$36,$69,$B0,$D9,$A6,$EC,$1A,$7D,$5A,$6C; 320
		dc.b $ED,$B4,$79,$27,$A9,$E4,$53,$D4,$B1,$FD,$19,$E5,$FB,$32,$D1,$D9,$5A,$3B,$2B, $A,$36,$33,$2C,$7A,$F2,$CC,$B3,$9C,$F6,$CC,$B7,$5C,$FD,$51,$BA,$A7,$AE,$6A,$E9,$EA,$50,$B2,$6C,$B9,$AF,$AC,$51,$76,$2C,$73,$9B,$2A,$45,$8B,$67,$BA,$46,$F2,$D9,$C6,$F8,$A2,$DE,$79; 384
		dc.b $66,$B7,$96,$72,$86,$F2,$CE,$73,$37,$96,$73,$9B,$E5,$FA,$1E,$B8,$FE, $C,$FC,$6E,$C5,$C7,$8C,$DE,$77,$17,$A6,$D7,$41,$E6,$CB,  6,$DE,$57,$6F,$C7,$29,$F0,$79,$61,$15,$97,$84,$2C,$9B,$1E,$36,$29,$B4,$D9,$23,$B7,$1B,$22,$FA,$9F,$D1,$F8,$7E,$87,$61,$B3,$4D,$C6; 448
		dc.b $CD,$37, $E,$D8,$76,$9B,$16,$DA,$3C,$93,$D4,$F2,$29,$EA,$58,$FE,$8C,$F2,$FD,$99,$68,$EC,$AD,$1D,$95,$85,$1B,$1F,$96,$FD,$BF,$2C,$67,$B6,$71,$7C,$FD,$51,$5D,$3D,$73,$3D,$53,$D4,$A1,$64,$D9,$73,$5F,$52,$C5,$17,$63,$CB,$39,$B2,$A4,$58,$B6,$7B,$A4,$6F,$2D,$9C; 512
		dc.b $6F,$8A,$2D,$E7,$96,$6B,$79,$67,$28,$6F,$2C,$E7,$33,$79,$67,$39,$C3,$4F,$1B,$B9,$C8,  0,  0,$1B,$F1,$4E,$29,$C5,$38,$A7,$11,$D9,$78,$8E,$CB,$C4,$76,$5E,$23,$B4,$7F,$73,$FA,$AD,$A9,$C5,$38,$3B,$4F,$83,$B4,$F8,$A7, $B,$B4,$78,$5D,$95,$B8,$5D,$A9,$B4,$59,$76; 576
		dc.b $11,$65,$D8,$45,$A8,$C2,$8D,$BB,$4D,$D5,$85,$1A,$6E, $B,$4D,$C5,$1C, $A,$38,$A3,$89,$A1,$71,$8B,$DC,$FE,$8B,$D7,$21,$36,$DD,$A6,$8A,$DB,$B6,$ED,$BB,$6E,$D1,$45,$E5,$4E,$54,$E5,$4E,$54,$E5,$4E,$54,$E5,$1F,$D7,$5B,$4F,$CF,$E6,$29,$C6,$C3,$1C,$6C,$31,$C2,$B6; 640
		dc.b $36,$C7, $A,$D8,$DB,$1C, $D,$8B,$47,$81,$B1,$68,$F0,$36,$2D,$3D,$8B,$17,$ED,$79,$68,$A6,$1C,$A3,$16,$C3,$61, $B,$61, $B,$45,$CA,$16,  2,$8D,$17,$8B,$61, $B,$6E,$CA,$F3,$6D,$DB,$76,$5E,$FE,$5F,$9F,$CB,$76,$A7, $F,$4D,$A9,$C3,$53,$6A,$70,$5E,$8D,$8E,$36,$54; 704
		dc.b $9B,$3C,$F8,$D8,$2A,$2F,$1B,$45,$26,$CA,$8D,$C6,$CA,$E9,$36,$54,$5D,$8F,$2E,$CF,$9C,$A3,$B4,$FC,$67,$B7, $B,$2D,$A9,$C2,$EC,$BF,$99,$5D,$97,$68,$EC,$AD,$B2,$ED,$4D,$A2,$CB,$B0,$8B,$2E,$C2,$2D,$46,$14,$6C,$78,$DD,$FA,$3F,$CB,$63,$B5,$3B,$53,$B5,$3B,$53,$B5; 768
		dc.b $3B,$53,$B1,$B4,$6F,$EC,$B6,$8D,$F9,$25,$32,$9D,$EA,$91,$83,$80,$27,$E1,$7E,$D7,$C3,$F3,$E7,$B5,$3B,$53,$B5,$3B,$61,$3B,$1B,$E6,$F9,$2C,$27,$94,$EC,$B9,$5E,$B6,$8D,$EE,  0,  0,$17,$5E,$9A,$71,$A7,$1F,$AD,$39,$C6,  6,$BF,$96,$83,$18,$66,$D9,$99,$72,$AA,$E6; 832
		dc.b $D2,$6A,$C2,$EE,$A6,$5D,$39,$97,$5E,$90,$AC,$AE,$EB,  6,$7A,$C8,$DC,$F0,$FC,$DB,$CA,$E2,$F5,$B8,$DD,$53,  7,$E4,$5B,$AC,$1E,$EE,$45,$CB,$3C,$AE,$32,$75,$B8,$CA,$A7,$AD,$6E,$32,$83,$D7,$AD,$CB,$77,$36,$CE,$B0,$FC,$B5,$73,$8B,$47,$36,$39,$F2,$39,$9A,$B5,$CC; 896
		dc.b $ED,$9C,$3A,$31,$EB,$9B,$74,$30,$2E,$61,$2A,$F2,$8B,$99,$5C,$D5,$2E,$7A,$FE,$6E,$BF,$B7,$30,$B9,$EE,$5E,$BC,$DE,$E8,$BF,$33,$71,$AC, $C,$16,  6,$B7,$73,$68,$57,$F4,$F7,$56,$50,$6A,$F5,$3E,$2F,  6,$DB,$F4,$9A,$5F,$B7,$E7,$CD,$F1,$D0,$DB,$DB,$4D,$8E,$97,$ED; 960
		dc.b $79,$97,$AD,$96,$FD,$A5,$B5,$61,$77,$53,$2E,$9C,$CB,$AF,$48,$56,$57,$75,$83,$3D,$64,$6E,$78,$7E,$6D,$E5,$71,$7A,$DC,$6E,$A9,$83,$F2,$2D,$D6, $F,$77,$22,$E5,$9E,$57,$19,$3A,$DC,$65,$53,$D6,$B7,$19,$41,$EB,$D6,$E5,$BA,$1A,$6D,$7D,$B4,$F6,$B5,$F1,$DA,$37,$EC; 1024
		dc.b $6F,$F5,$37,$9A,$ED,$76,$CF,$B5,$FA,$74,$63,$D6,$F6,$E8,$60,$5C,$C2,$55,$E5,$17,$32,$B9,$AA,$5C,$F5,$FC,$DD,$7F,$6E,$61,$73,$DC,$BD,$79,$BD,$D1,$7E,$66,$E3,$58,$18,$2C, $D,$6E,$E6,$D0,$AF,$E9,$EE,$AC,$A0,$D5,$EA,$7C,$5E, $C,$EA,$F2,$2F,$72,$BC,$1E,$32,$2E; 1088
		dc.b $7A,$AF,$8B,$B7,$ED,$E5,$D1,$7F,$4E,$DD, $C, $B,$98,$4A,$BC,$A2,$E6,$57,$35,$4B,$9E,$BF,$9B,$AF,$ED,$CC,$2E,$7B,$97,$AF,$37,$BA,$2F,$CC,$DC,$6B,  3,  5,$81,$AD,$DC,$DB,$9F,$E9,$EE,$E9,  5,$72,$FD,$16,  6,$BD,$64,$F7,$41,$EA,$EA,$E5,$CB,$CF,$AC,$5C,$BA,$B9; 1152
		dc.b $72,$F7,$3C, $F,$ED,$E0,$F7,$17,$2E,$60,$6E,$2F,  5,$81,$E6,$F0,$37,$40,$F3,$BA,  6,$11,$7B,$8F,$33,  3,$74,$60,$AD,$73,$DC,$60,$AD,$71,$FC,$DC,$23,  3, $B,$9E,$30,$35,$83,$DC,$C7,$9C,$9C,$BC,$A0,$F0,$DE, $F,$17,$5B,$8D,$CA,$E7,$F3,$66,$EE,$77,$1B,$95,$D7; 1216
		dc.b $9B,$98,$3C, $F,$35,$85,$DE,$8B,$CC,$C0,$C0,$C0,$C2,$7C,$CC,$16,  6, $C,$60,$B0,$E9,$CA, $B,  6,$AF,$27,$2C,$B0,$6B,$9E,$EE,$51,$93,$FE,$6F,$97,$39,$3C, $D,$D2,$57,$85,$6E,$EA,$60,$60,$6E,$83,$98,$18,$78,$C2,$E3,  3, $B,$A4,$F0,$58,$18,$5D,$D6,$A5,$96,$15; 1280
		dc.b $7E,$47,$99,$E8,$5B,$15,$56,$B8,$F3,$30,$5F,$CD,$C0,$D6,$11,$B9,$E1,$C8,$B1,$6E,$B0,$FD,$8C,$AB,$73,$9F,$D0,$CA,$B7,$3F,$F0,$6A,$5F,$C4,$B4, $B,$FE,$6C,$B1,$AB,$3F,$3B,$BF,$63,$73,$F7,$37,$2D,$DD,$EB,$22,$C7,$9B,$41,$79,$73,$AB,$1E,$46,$B0,$AB,$49,$96,$B0; 1344
		dc.b $E4,$64,$B0,$3C,$8D,$CB,  6,$37,$1B,$98,$F4,$F1,$32,$63,$2A,$F8,$99,$19,$5D,$E2,$5C,$F8,$B4,$8F,$55,$F1,$5E,$B1,$BA,$BD,$4D,$DE,$27,$F9,$8C,$B0,$8D,$61,$23,  8,$B4,$24,$61,$16,$32,$6A,$AB,$2D,$C7,$91,$69,$35,$C6,$EF,$D0,$DD,$1F,$CD,$AD,$D1,$BB,$C4,$C8,$C8; 1408
		dc.b $DD,$FB,$A3,$59,$37,$EA,$95,$E5,$19,$19,$3C,$8C,$8C,$95,$E4,$64,$64,$AF,$23,$23,$28,$C8,$FE,$6E,$B2,$30,$9C,$2A,$F7,$48,$B2,$D4,$DD,$E3,$C8,$B7,$33,$2B,$BF,$42,$6A,$7C,$6E,$65,$65,$F1,$B8,$F2,$3E,$35,$BA,$4D,$FB,$AA,$C2,$50,$32,$73,$2E,$90,$73,$D7,$C5,$E0; 1472
		dc.b $E6,$4F,$59,$1A,$BF,$89,$E8,$64,$64,$B2,$EB,$23,$2B,$A2,$F5,$5B,$A7,$55,$91,$BA,$57,$49,$EE,$A9,$81,$BA,$46,$E7,$3D,$3C,$4B,$97,$91,$AD,$D3,$91,$AC,$2E,$EA,$65,$D3,$99,$75,$E9, $A,$CA,$EE,$B0,$67,$AC,$BF,$36,$F0,$FC,$DB,$C9,$5E,$B7,$1B,$AA,$E5,$DA,$E2,$CE; 1536
		dc.b $AE,$D7,$31,$72,$CE,$6E,$32,$75,$B8,$CA,$A5,$CD,$6E,$32,$AB,$98,$3D,$CB,$2A,$A6,$99,$69,$6E,$D6,$5E,$9F,$9F,$FD,$F7,$84,$DA,$8C,$BE,$1D,$8F,$63,$D7, $D,$36,  0,$CA,$32,$C4,$A3,$69,$CB,$16,$C4,$92,$72,$9A,$45,$26,$93,$B7,$EB,$7F,$3F, $D,$3D,$46,$ED,$DB,$C0; 1600
		dc.b $2B,$63,$41,$8A,$CE,$D8,$D2,$D3,$AE,$24,$A9,$19,  2,$80,$BA,$14,$8A,$31,$45,$47,$C2,$1C,$92,$F4,  0,$7F,$C8,  0,  0,$1F,$F2,  0,$7E,$C8, $F,$D9, $F,$F9,  0,  0,  3,$FE,$40, $F,$DF,$FE,$B6,$D4,$6D,$B7,$65,$FD,$AB,  0,  0,  6,$CB,$21,$1B,$1B,$46,$53,$90,$32; 1664
		dc.b $36,$29,$BD,$AB,$FB,$FF,$2F,$51,$BB,$76,$F0, $A,$C0,  0,  1,$90,$C5,$A3,$51,$49,$47,$4C,$AB,$7A,$3E,$B0,$73,$9C,$53,$19,$AB,$8D,$D0,  0,  0,  0,  0,$53,$3F,$5F,$D2,$B9,$78,$E6,$50,$14,$9E,$78,$CC,$2B,$80,  0,  0,  0,$9F,$D3,$40,  0,  0,$E7,$47,$5C,$C1,$49; 1728
		dc.b $E7,$44,$8B,$A1,$45,$41,$E0,$E8,$A8, $B,$94,$FE,$3E,$7E,$CE,  0,  0,  0,$10,$4F,$35,$72,$83,  8,$5C,$E7,$34,$8A,$17,$39,$23,$94,$CC,  0,$7F,$E4,  0,  0, $F,$F9,$4F,$F6,$43,$79,$7E,$CA,$32,  0,$7F,$C8,  0,  0,$1F,$F2,$FD,$90,$9C,$BA,$7E,$BF,$CA,$5D,$2D,$D3; 1792
		dc.b $98,  3,$FE,$40,  0,  0,$FD,$90,$A4,$BA,$7E,$BF,$CB,$2F,  3,$CB,$9F,$4F,$CF,$F9,  0,$3F,$E4,  0,  3,$1F,$A2,$9A,  3,$2A,$99,$74,$FC,$FD,$FB,$69,$7F,$80,$8B,$79,$7E,$7F,$A4,$2A,  0,$FF,$90,  2,$29,$8F, $C,$24,$E5,$5D,$16,$55,$B6,$5B,$1B,$69,$92,$4D,$84,$7B; 1856
		dc.b $72,$2D,$DA,$70,$AF,$9F,$8F,$E7,$C0,$1F,$E2,$A7,$86,$10,$1A,$DA,$32,$AD,$91,$A5,$5B,$64,$87,$95,$FB,$4D,$B2,$8A,$76,$56,$39,$3C,$F2,$60,$29,$2B,$78,$F9,$D6,$58,$F0,$C2,  3,$5B,$4E,$B6,$46,$5A,$D9, $B,$1A,$D9,$31,$B3,$2F,$87,$25,$ED,$D6,$2D,$46,  0,$52,$D8; 1920
		dc.b $94,$E5,$8F,$CF,$97,$CA,$CD,$A1,$AD,$92,$2D,$54,$8A,$1C,$B6,$62,$99,$3B,$47,$27,$9F,$2A,$64,  0,$8C,$96,$42,$96,$8C,$82,$C9,$64,$B2,$C5,$95,$15,$34,$B7,$8E,$B2,$B5,$43,  0,$31,$69,$CB,$16,$C5,$A7,$21,$89,  5,$92,$1B,$2A,$61,$30,$91,$74,$9B,$CF,$32,$8E,$8E; 1984
		dc.b $86,$F4,  0,$7F,$C8,  0,  0,$DF,$FE,$42,$3E, $B,$5B,$14,$8D,$91,$92,$29,$D2,  0, $F,$F9,  1,$BD,$A2,$8B,$68,$A2,$DB,$97,$81,$95,$B1,$5C,$B1,$54,$8F,$2B,$24,$72,$5E,$45,$32,$C6,$4F,$3B,$A5,$A6,$BD,$3C,$C1,$CD,$52,$2E,$15,$1C,$14,$54,$CF,  9,$1F,  7,$14,$7F; 2048
		dc.b   5,$49,  2,$85,$CD,$A9,$28,$C9,$50,$52,$C6,$BA,$BD,$74,$BE,$EC,$80,  0,  0,$80,$A6,$1C,$23,$E1,$31,$9A,$BA,$1C,$E8,$98,$4A,$7E,$89,$D2,$FB,$5D,$14,$32,$9A,$2E,$48,$A8,$B6,$5D,$91,$6D,$17,$32,$AA,$A2,$D7,$24,$28,$EA,$8C,$AF,$16,$5C,$B0,$D9,$61,$B7,$C8, $A; 2112
		dc.b $48,$62,$4B,$7B,$46,$46,$C0,$B5,$18,  9,$C8,$1B,  8,$C8,$48,$1B,$2D,$A2,$80,$A2,$CB,$16,$54,  9,$9A,$E5,$7A,$67,$96,$CF,$91,$CC,$51,$C1,$45,$48,$A1,$CC,$17,$54,$13,$4C,$78,$62,$53,$43,$65,$70,$51,$E6,$91,$94,$E4,$E9,$19,$4E,$BA,$F4,$BF,$4C,$F2,  0,  0,  0; 2176
		dc.b   0,  2,$82,$88,$F4,$73,$DB,$F4,$99,  0,$3F,$64,$16,$DA,$4F,$F3,$ED,$1F,$CF,$C5,$AD,$A6,$32,$68,$F6,$68,$F6,$9D,$ED,$19, $C,$4A,$32,$12,$8C,$A7,$69,$1F, $B,$63,$C0,$56,$D1,$AF,$E7,$F6,$6A,$FE,$7D,$22,$DB,$34,$52,$7E,$19,$3C,$5B,$AA,$B1,$60,$2C,$B2, $B,$65; 2240
		dc.b $92,$C8,$5A,$72,$9D,$B7,$FD,$90,  2,$7F,$F2,  0,  0,  7,$FC,$86,$F6,$A6,$8D,$FD,$2E,$60, $F,$F9,  0,  4,$51,$6B,$A2,$A2,$E9,$B1,$F0,$35,$D3,$15,$45,$E5,$5B,$21,$6B,$D7,$66,$29,$96,$11,$E7,$74,$B8,$D6,$D2,$D6,$D3,$40,$98,$CE,$29,$87,  5,$F0,$80,$A0,  0,  0; 2304
		dc.b   3,$FE,$91,$EA,$F5,$9A,$49,$5D,  6,$24,$8E,$50,$66,$51,$7C,$1C,$14,$9B,$A0,$5C,$D1,$50,$2E,$60,$17,  3,$F6,$BF,$A4,$C8,$6F,$6D,$DB,$F6,$4B,$6D,$DA,$95,$DD, $B,$4E,$AA,$93,$42,$CE,$23,$5D,$D0,$A0,$9C,$B7,$72,$91,$B6,$89,$97,$53,$93,  2,$94,$67,$18,$69,$C8; 2368
		dc.b $4E,$53,$B0,$9C,$81,$B5,$10,$4D,$25,$14,$36, $E,$53,$35,$AA,$37,$83,$1A,$B8,$A5,$A3,$9A,$4F,$39,$A6,$1C,$33,$E1,$95,  4,$D9,$53, $C,$F8,$79,$E7,$34,$9E,$68,$16,$CF,$BA,$57,$8F,$CF,$C8,$D8,$4D,$19,$50,$56,$8E,$1C,  1,$BB,$D1,$C5,$68,$82,$28,$C1,$53,$F5,$B6; 2432
		dc.b $3E,$45,$16,$D1,$45,$B4,$6F,$5B,$53,$48,$E4,$C7,$48,$E5,$4C,$B0,$D9,$61,$B7,$C8,$52,$51,$90,$5B, $C,$4A,$76,$A6,$56,$3E,$26,$D2,$DE,$40,$62,$51,$B0,$9D,$A7,$28,$A0,$9C,$82,$45,$30,$EB,$28,$A1,$B3,$94,  7,$38,$A1,$74,$9B,$9C,$8E,$65,$C0,$1F,$F2,$1B,$E9,$4B; 2496
		dc.b $4D, $D,$5A,$28,$64,$91,$45,$C9,$5A,$36,$56,$28, $D,$97,$28,$D9,$52,$6C,$AF,$1C,$A5,$F9,$BE,$9E,$60,  0,  0,  0,  0,  0,$4F,$E9,$A6,$EF,$86,$DD,$C3,  4,$A3,$8C,$32,  1,$47,$28,$2C,$A8,$16,$54,$48,$F6,$7C,$8C,$8D,$80,$1F,$D2,$1B,$A1,$96,$EF,$34,$35,$4D,$DB; 2560
		dc.b $12,$4A,$3B,$1F,  5,$AA,$1D,$81,$43,$54,$57,$45,$42,$91,$95,$8A,$3B,$2B,$AB,$CD,$29,$25,$49,$BB,$51,$15,$E6,$C5,$37,$71,$46,  2,$76,  5,$A9,$21,$39,$47,$A7,$99,$90,  1,$7F,$E4,  0,  0, $F,$F9,  1,$BD,$7F,$C5,$6D,$D0,$51, $F,$F4,$81,$B5,$2A,$D1,$45,$4A,$59; 2624
		dc.b $A2,$86,$B3,$43,$54,$8A,$2A,$45,$96,$CA,$8C,$B6,$54,$75,$B3,$2B,$E1,$32,$9D,$B4,$3D,$9D,$B2,$32,$42,$8E,$CB,$92,$BC,$6A,$C5,$27,$B2,$BD,$13,$77,$A3,$51,$B7,$4D,$DF,$16,  2,$53,$90,$11,$C8,$61,  4,$64,$B2,$28,$26,$87,$39,$CA,$76,$A3,$83,$64,$39,$A0,$9B,$84; 2688
		dc.b $9A,$14,$5C,$F0,$F3,$74,$A6,$48,$F9,$7B,$5D,$2C,$4B,$77,$DD,$17,$F4,$53,$40,$A8,$65,$BB,$AB,$89,$A4,$D0,$CB,$77,$9A,$2A,$52,$4A,$93,$75,$79,$A6,$2C,$72,$B4,$AD,$AD,$4C,$80, $A,$F4,$B0,$47,  8,  0,$A2,$52,$C0,  8,$DB,$C7,$F3,$E6,$5A,$80,$3F,$64,  0,  0,  9; 2752
		dc.b $FE,$C8,  1,$3B,$78,$FE,$7C,$CB,$50,  0,  0,  0,  0,  0,$57,$C6,$B6,$3D,$42,$A2,$A3,$AA,$51,$D7,$34,$74,  8,$B9,$97,$48,$E7,$8C,$A6,$80,  0,  0,$8E,$57,$7B,$75,$E1,$CD,$90,$47,$42,$87,$22,$82,$39,$2A,$45,$23,$91,$48,$A2,$E6, $A,$2E,$58,$7C,$66,  6,$60,  3; 2816
		dc.b $FB,$5F,$D2,$64,  0,$FF,$90,  0, $D,$D2,$88,$7F,$A4, $D,$A9,$59,$A1,$92,$37,$E8,$8A,$6B,$58,$6E,$94,$4A,$21,$D3,$F8,$54,$45,$D2,$96,$9A,$1B,$4D, $D,$A2,$C8,$6D,$4A,$C7,$26,$32,$45,$CA,$39,$31,$CA,$6C,$72,$A3, $A,$69,$6F,$D2,$BB,$64,$74,$54,$75,$D1,$51,$E8; 2880
		dc.b $F4,$4D,$DF, $C,$37,$C9,$80,$9E,$80,$4A,$72,  2,$32,$B7,$8A,$48,$D8,  1,$FC,$20,  0,$32,$DD,$C0,$3F,$B2,$54,  0,$46,$B6,$E8,$72, $A,$94,$90,$DD,$F7,$40, $A,$61,$80,$18,$90,  2,$DA,$74,$B7,$15,$41,$BB,$AB,$84,$78,$DA,$2C,$73,$54,$2E,  6,$EC,  4,$D1,$C3,  1; 2944
		dc.b $4C,$B3,$BF,$3B,$D9,$D7,$34,$78,$BA,$47,$C1,$E6,$81,$CA,$47,$3C,$67,$14,  0,  0,  0, $B,$96,$7E,$D9,$3F,$60,$5D,$15,$33, $E,$51,$D3,$38,$A0,$28,$E7,$35,$C8,$2A,  0,  0,  2,$69,$FD,$34,  0,$1C,$C0,$CF, $F,$8C,$95,  1,$CD,$52,$28,$72,$8A,$45,$17,$21,$14,$39; 3008
		dc.b $14,$36,$11,$4B,$17,$D7,$AF,$B5,$D9,  0,  0,  0,  0,$A8,$30,$85,$D3,  9,$47,$28,$E7,$35,$43,$92,$66,$FE,$A1,$32,$7C,$B3,$F0,$D8,  0,$99,$3E,$59,$F8,$6C,  0,$4C,$9F,$2C,$FC,$36,$8B,$B6,$D3,$42,$F9,$F5,$AF,$E7,$FF,$9B,$FF,$11,$77,$EA,$BF,$72,  0,$14,$4C,$21; 3072
		dc.b $74,$56,$5F,  7,$57,$67,$54,$76,$2E,$87,$45,$7B,$2B,$AA,$2A,$55, $F,$92,$1A,$E3,$4F,$D1,$58,  5,$FC,$CF,$9F,$E6,$E5,$74,$50,$2E,$65,$23,$9A,$BA,$A3,$EE,$87,$34,$2F,$14,$5F,$D1,$3E,$E8,$A9,$17,$35,$5D, $E,$88,$B5,$5D,$16,$A1,$6B,$1D,$3F,$64,  2,$E9, $F,$DF; 3136
		dc.b $C3,$40,$51,$65,$89,$45,$24,$25,$39,$62,$58,$B0,$9D,$80,  0,$BE,$E8,$7F,$6A,$72,$A7,$2B,$56,$D5,$B5,$74,$84,$53,  9,$84,$C2,$4E,$51,$B6,$25,$1B,  5,$96,$2D,$8B,$62,$40,  8,$B5,$18,$E5,$D4,$F2,$8F,$86,$4B,$A4,$2B,$69,$6B, $B,$8A,$47,$C3, $E,$AE,$A8,$AF,$44; 3200
		dc.b $54,$94,$D3,$12,$C5,$A7,$61,$19,  3,$25,$96,$24,  2,$E5,$BF,$2C,$BA,$C7,$8D,$3C,$6D,$A5,$6C,$AE,$B9,$AA,$2F,$86,$12,$29,$D5,$5C,$14,$54,$B1,$41,$14,$9C,$B1,$28,$D8,$52,$4B,$65,$90,$8D,$80,$95,$DA,$E9,$D3,$CD,$E2,$8A,$87,$38,$A4,$D3,$37,$57,$9A,$3A,$A6,$3C; 3264
		dc.b  $A,$45,$30,$8A,$E2,$32,$8A,$62,$51,$95,$24,$6D,$19,$62,$40,$2D,$8D,$75,$E9,$E5,$75,$80,$29,$44,$8E,$73,$72,$93,$7C,$66,$BE, $F,$34,$8A,$67,$37,$48,$BD,$12,$28,$15,$23,$6C,$25,$A3,$2A,$4A,$7E,$15,$EB,$FA,$D0,  0,  0,  0,  0,  0,$7F,$F0,  0,  0,  0, $D,$F2; 3328
		dc.b $8F,$4E,$D7,$9C,$AB,$1B,$CE,$5A,$AB,$6B,  3,$A9,$65,$63, $E,$90,$AF,$3E,$80,  0,  0, $B,$5C,$8E,$5C,$8E,$4C,$5B,$5B,$CE,$4B,$C5,$ED,$C7,$B6,$AB,$C2,$EB,$7D,$1B,$56,$14,$AF,$FB,  0,$11,$AE,$54,$63,$94,$EA,$B7,$E4,$17,$25,$D7,$DB,$B4,$58,$FE,$93,$56,$5D,$56; 3392
		dc.b $F9,$B7,$17,$96,$C7,$9D,$39, $D,$FF,$F8,  0,  0,  8,$D5,$8B,$65,$CA,$A6,$F6,$5F,$62,$DA,$FB,$7E,$A2,$3A,$80,  2,$FE,$B6,$1D,$32,$A8,  0,  0,  6,$43,$F4,$A3,$90,$C8,$64,  7,$ED,$79,$76,  0,  0,  7,$66, $D,$BD,$EC,  3,  0,$C0,$F9,$C3,$8E,$77,$D4,  0,  0,  0; 3456
		dc.b   0,  0,$1E,$70,$E3,$9D,$F0,  0,  0,  0,  0,  0,  7,$66,$CB,$F6,$20,  0,  0,  0,  5,$E9,$CF,$A3,$64,  5,$1B,$2E,$9C,$FA,  0,  0,  0,  0,$2B,$FA,$5E,$43,$90,$15,$FD,$2F,$EC,$40,  0,  0,$B9,$55,$84,$F2,$8B,  5,$CB, $C,  3, $B,$CE,$A7,$A7,$30,  0,  0,  0,  0; 3520
		dc.b $86,$BC,$97,$91,$61,$BF,$EA,$7F,$7A,  0,  0,  0,  0,  0, $D,$4F,$6E,$57,$B1,$D7,$25,$CA,$FC,$97,$5E,$C2,$F0,  0,  0,  0,  0,$5E,$39,$7E,$67,$A7,  0,  6,$DF,$5E,$54,$F3,$DE,$F6,$DF,$5D,$EF,$6D,$F5, $D,$BE,$A1,$B7,$D4,$37,$9D,$61,$FA,$96,  0,  0,  0,  0,  0; 3584
		dc.b   7,$9F,$1A,$F4,$FC,$C8,  0,  0,  0,  0,  0,$3F,$6B,$CB,$B0,  0,  0, $E,$53,$FD,$2D,$F9,$2E,$5A,$CF,$B6,$B3,$BC,  0,$31,$97,$2E,$DD,$32,  0,  0,  0,$DF,$2A,$64,$BC,$95,$95,$97,$90,  2,$3F,$D1,$EC,  6,$F9,$47,$A7,$6B,$CE,$55,$8D,$E7,$2D,$55,$B5,$81,$D4,$B2; 3648
		dc.b $B1,$85,$39,  0,  0,  3,$A4,$2B,$E8,$B5,$C8,$E5,$C8,$E4,$C5,$B5,$BC,$E4,$BC,$5E,$DC,$7B,$6A,$BC,$2E,$B7,$D1,$B5,$61,$46,  0,  0,  6,$FD,$DA,$B0,$AF,$1C,$AA,$6F,$65,$F6,$2D,$AF,$B7,$EA,$23,$A8,  0,  0,  0,  0,$2F,$9F,$3E,$99,$56,$2D,$BD,$EC,  3,  0,$C0,$30; 3712
		dc.b   0,  0,$2F,$30,$D7,$A7,$30,  0,  0,  0,  0,  0,$5E,$75,$3D,$39,$80,  0,  2,$F0,$2F,  2,$F1,$AE,$F7,$89,$C3,$FB,$B0,$A3,$43, $D,  3,$AF,$EE,$60,$B7,$8B,$C5,$E2,$F1,$79,$E7,$3E,$93,$E9,$3B,$E1,$4D,$40,  3,$5F,$CC,$F4,$E6,  0,  0,  0,  0, $D,$E7,$7D,$21,$86; 3776
		dc.b $85,$35,$E7,$EC,$B7,$80,  0,  0,  0,  0,  0,$EB, $B,$CF,$B6,$A0,  0,  0,  0,  0,  4,$EF,$8F,$E5,$B2,$4C,$BF,$3F,$FA,$73,$C2,$73,$5F,$23,$DF,$43,$FD,$EF,$DB,$FE,$99,$DB,$F4,$F9,$F2,$2D,$FB,$EF,$D3,$C7,$CA,$2E,$BF,$AE,$FD,$14, $C, $C,$27,  3,  1,  3,  3,$E8; 3840
		dc.b $60,$61,$E4,$3F,$BC,$FB,$E5,$FB,$2F,$D7,$7F,$30,$FF,$F9,$7F,$EE,$58,$B4,$FF,$62,$5F,$F3,$39,$9C,$CB,$F9,$2B,$9E,$BC,$3E,$9E,$1E,$5F,$A7,$8F,$34,$FD,$76,$20,$7B,$CE,$11,$FE,$E6,$8B,$FB,$E5,$F2,$9F,$91,$FE,$F1,$D0,$2E,$87,$FB,$C7,$43,$FA,$72,$F1,$FD,$3E,$9C; 3904
		dc.b $68,$74,$4F,$2E,$65,$21,$1E,$67,$BF,$FF,$97,$FA,$FA,$1F,$EB,$9F,$EF,$18,$2F,$EF,$8C,$17,$F9,$CB,$FF,$E3,$FC,$7F,$D7,$7F,$1D,$74,$C7,$93,$9F,$D3,$9E,$A5,$D9,$5E,$3F,$A1,$5E,$DC,$6B,$C6,$7D,$57,$BF,$EB,$BD, $F,$7F,$D7,$1F,$47,$5F,$E7,$7E,$9E,$9D,$4F,$EF,$8F; 3968
		dc.b $EB,$97,$9E,$91,$E6,$BF,$AE,$3E,$9D,$4F,$91,$F2,$EB,$1D,$17,$FA,$BC,$80,  0,  0,  0,  0,  1,$7C,$2B, $E,$9F,$99,$3A,$B0,$1B,$EA,$7F,$63,$AF,$1A,$B4,$75,$60,  0,  0,  1,$BF,$3A,$C3,$F5,$B9,  0,$17,$A7,$3E,$8D,$90,  0,  0,  0,$14,$6C,$BA,$73,$E8,  0,$AF,$E9; 4032
		dc.b $79, $E,$40,  0,  0,  0,$43,$F4,$8B,$EC,  0,  0,  5,$BC,$DF,$3B,$E7,$79,$BD,$7D,$B7,$BE,$7A,$8F,$3D,$D8,$DF,$4D,$63,$A9,$62,$DC,$43,$50,  0,  0,  0,$26,$DB,$EB,$46,$BE,$9A,$D1,$B1,$DE,$F3,$5E,$60,  0,  0,$E6,$2F,$17,$D3,$50,$6F,  0,$47,$F5,$DC,$B2,$FC,$DF; 4096
		dc.b $E9,$CF,$92,$FE,$F8,$F7,$FD,$72,$F7,$8F,$EB,$97,$F6,$E5,$FC,$A3,$FD,$72,$E5,$CF, $E,$5D,$7C,$8E,$87,$F5,$CB,  3,$A2,$F7,$3E,$80,$52,  6,$18,$81,$E6,$60,$7B,$98,$18,$1E,$E3,$1F,$CC,$1D,$FC,$8E,$87,$49,$FF,$38,$FF,$FA,$3A,$1D, $E,$90,$30,$30,$30,$58,$18,$1E; 4160
		dc.b $F4,$E7,$BC,  1,$84,$61,$1E,$67,$D2,$30,$30,$9F,$FF,$3D,$17,$D1,$7F,$B9,$BF,$94,$74,$3A,$2F,$EB,$8E,$93,$75,$D0,$E8,$AE,$74,$3F,$AE,$3A,$18,$2E,$87,$43,$A1,$E6,$60,$61,$38,$1E,$E6,  6,  7,$F9,$87,$F9,$87,$FD,$91,$D1,$34,$4E,$39,$9F,$DF,$3A,$FA,$1D,$20,$BD; 4224
		dc.b $E3,$CE,$3F,$FE,$C3,$9F,$DB,$9F,$D3,$C5,$CF,$E9,$CF,$5D,$15,$CB,$9F,$D7,$1D, $F,$91,$FD,$71,$D0,$C1,$74,$30,$3E,$8B,$E8,$79,$9E,$EB,$FD,$C5,$DA,$DB,$5C,$F7,$7A,$C6,$FC,$6A,  0,  0,  0,  0,$5D,$A7,$62,$E7,$6C,$CE,$6D,$9B,$F2,$76,$FD,$7F,$1F,$9F,$F3,  0,  0; 4288
		dc.b   0,  0,  0,$74,$3A,$2F,$96,$AC,$5A,$DA,$E6,$DC,$68,$D6,$D3,$86,$D0,  0,  0,  0,  0,  5,$A7,$67,$2D,$A2,$E9,$67,$D3,$F2,$DA,$F0,$90,$39,$80,  0,  0,  0,  4,$5C,$EC,$5C,$FE,$9F,$D7,$AE,$7D,$7F,$2D,$93,$67,$6E,$35,$B7,$E6,$74,$CC,  0,  0,  0,  0,  0,$1F,$99; 4352
		dc.b $D5,$BB,$DE,  0,  0,  0,  0,  0,  3,$E6,$D0,$BE,$8C, $D,$F4,$D4,  3,$7E,$FA,$80,  0,  0, $D,$4E,$BC,$55,$B5,  0,  0,  0,  0,  0,  4,$75,$37,$D7,$98,  0,  0,  0,  0,  0,$15,$BC,$FF,$48,  0,  0,  0,  0,  0,$DB,$43,$65,$7E,$3F,$2D,$A3,$E6,$79,$7E,$67,$32,$97; 4416
		dc.b $E6,  0,  0,  0,  0,  1,$6C,$E7,$65,$CF,$4E,$59,$B2,$67,$FB,$9C,$B8,$CB,$8F,$23,$FC,$CF,$23,$FC,$C8,$F7,$3C,$CF,$79,$C0,$C0,  0,  0,$81,$86,$3D,$27,$CC,$C2,$70,  6, $B,  3,$DC,$FA,$2C, $F,$A1,$FF,$E7,$F3, $C, $F,$A6,$20,$60,$29,  8,$C2,$30,$5E,$E6,$11,$81; 4480
		dc.b $81,$80,$8C,$29,$DC,$C0,$C0,$FF,$F3,$FF,$9A,$43,$44,$30,$30,$D0,$FE,$F8,$E9,  3,  3,$FB,$EF,$45,$F2,$81,$EE,$BA,$47,$BC,$60,$7B,$AF,$F7, $F,$F7, $C,$16,  6,  0,$42,$70,$3D,$D7,$FB,$8B,$DC,$C2,$30,$3D,$C7,$79,$E8,$74,$3F,$FE,$D0,$F9,$1D, $F,$EB,$96,  6,  7; 4544
		dc.b $48,$1F,$FE,$73,$30,$3C,$CC,$27,  1,$38,$53,$9C,$60,$7B,$AF,$A1,$82,$C0,$C0,$C0,$C3,$1E,$98,$81,$86,$DD,$7D,$7F,$37,$B1,$BE,$7A,$CE,$F8,$DE,$B7,$AE,$B1,$BD,$6F,$37,$88,$DE,$B7,$85,$BC,  0,  0,$1B,$F4,$85,$7D,  0,  0,  0,  0,  0,$69,$1B,$1B,$16,$B1,$B3,$69; 4608
		dc.b $9F,$95,$9B,$F5,$FA,$E9,$46,$86,$1A,  7,$5F,$DC,$C1,$6F,$17,$8B,$C5,$E2,$F0,  0,  0,  0,  0,  0,  3,$CE,$7D,$27,$D2,$77,$C2,$9A,$80,$37,$E9,$E9,$D0,  0,  0,$1F,$AD,$EC,$18,$30,$60,  0,$D7,$99,$D7,$D8,  0,  0,  0,  0,$23,$B5,$36,$2F,$6E,$A7,$3E,$5F,$A6,$64; 4672
		dc.b $F2,$CD,$B2,$D7,$C8,  0,  0,  0,  0,  7,$E7,$CB,$9D,$17,$F4,$39,$A5,$BC,$BB,$26,$99,$3E,$5C,$40,$FF,$F3,$D0,$F7,$30,$30,$3C,$F1,$CF,$78,  9,$C3,$7E,$66,$18,$81,$81,$81,$84,$F9,$98,$4E,  0,  3,  3,  3,  5,$FE,$61,$FE,$E2,$F7,$3C,$CF,$A1,$81,$FF,$62,$C0,$F3; 4736
		dc.b $30,$9F,$33,  3,  5,$F4,$30,$58,$18,  0, $C, $C,$31,  3,$CF,$78,$62,$13,$81,$EE,$79,$98,$18,$18,$18,$18,$18,$1F,$FE,$40,$C0,$FF,$32,$70,$3C,$F7,$80,$1B,$C2,$9C,$CC, $F,$FF,$20,$60,$7F,$B9,$3E,$F8,$EE,$60,$BF,$EC,$3F,$CC,$30,$3F,$CC,$3E,$86,  6, $B,$CC,$C2; 4800
		dc.b $3E,$86,  7,$99,$82,$F3,$30,$9C,  4,$E1,$4E,$E6,$11,$81,$81,$82,$C3,$78,  0,$20,$60,$61,$1B,$9E,$E7,$BB,$F4,$E0,  0,  0,  0,$47,$DB,$9C,$6F,$F3,$3A,$AC,$35,$63,$AA,$C3,$F4,$38,$6A,$73,$AF,$3F,$61,$7D,$2F,$D7,$17,$EA,$D3,$BF,$5E,$51,$BF,$5E,$51,$BF,$5E,$51; 4864
		dc.b $BF,$5E,$51,$BF,$52,$D8,$F3,  0,  1,$FC,$18,$F1,$3F,$DA,$7E,$F4, $B,$F7,$D6,$FD,$F5,$BF,$7D,$6F,$17,$80,  0,$11,$FD, $F,$9D,$F4,$D6,$3F,$99,$AE,$BE,$C0,  0,  0,  0,  0,$30,$E7,$D5,$73,$47,$4F,$CB,$26,$BA,$5B,$8B,$79,$E8,  0,  0,  0,  0,  2,$C7,$48,$E8,$5B; 4928
		dc.b $4B,$1F,$CF,$B6,$99,$E8,$B6,$D3,$3D,  0,$9F,$1A,$AD,$E7,$5E,$3F,$48,$BA,$FB,$2D,$EB,$7C,$F5,$A5,$E2,$97,$81,$4B,$F1,$B5,$36,$3B,$1E,$A6,$DF,$A6,$E4,$FA,$67,$F9,$9D,$78,$D0,$E7,$90,  0,  0,  0,  0,  0,$35,$3F,$A1,$D4,$C0,  0,  0,  0,  0,  0,  7,$CF,$86,$3A; 4992
		dc.b $80,$6F,$17,$8B,$F1,$7A,$DF,$3D,$7D,$8E,$B3,$F3,$BC,$EB,$36,$D5,$75,$9B,$6A,$BA,$CD,$B5,$DD,$B5,$DD,$B5,  1,$5B,$F5,$35,$80,  0,  0,  0,$1A,$E2,$F5,$F3,$A7,$B1,$D4,  8,$EB, $A,$EB,$1B,$C0,  0,  0,  0,  0,  1,$36,$FD,$48,  0,  0,  0,  0, $B,$1D, $E,$91,$6E; 5056
		dc.b $33,$F2,$B6,$B6,$D3,$8D,$74,$6C,$D9,  0,  0,  1,$E6,$DE,$71,$BC,$EA,$6F,$37,$9F,$63,$FA,$45,$BC,$DE,$6F,$13,$D8,$FA,$AF,$AB,$27,$24,$D8,$B7,$F1,$F9,  0; 5120
Nem_HTZ_AniPlaceholders:dc.b $80,$2E,$80,  3,  1,$14,  5,$25,$11,$35,$15,$45,$16,$55,$18,$67,$72,$73,  0,$81,  4,  4,$16,$33,$27,$7A,$82,  5,$13,$17,$78,$83,  4,  7,$17,$73,$84,  7,$70,$17,$74,$85,  5,$14,$17,$75,$86,  6,$32,$17,$76,$87,  4,  6,$17,$6F,$28,$EF,$48,$F6,$78,$F7,$88,  5; 0
					; DATA XREF: ROM:0001C218o
		dc.b $17,$18,$F2,$89,  5,$10,$18,$F3,$8A,  6,$35,$8B,  7,$71,$8C,  6,$34,$8D,  6,$36,$8E,  5,$12,$28,$EE,$8F,  7,$6E,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,$17,$B5,$3A,$38,$5E,$D4,$E8,$E0,  0,  0,  0,  0,  5,$69,$DA,$95,$A7,$6A,  0,  0,  2,$B2,$DD,$A5; 64
		dc.b   0,$A6,$54,$E1,$74,$10,$57,$8C,$E2,$8A,$F1,$42,$8D,$5F,$D2,$3D,$34,$EA,  6,$25,$B8,  1,$C9,$35,$7C,$48,$47,$83,$CC,$4D,$7A,$32,$C0,$3F,  9,$A2,$EB,$66,$8E,$FC,$A9,$C1,$F2,$A0,$12,$E2,  6,$B0,  2,$B3,$11,$EB,$C9,$D7,$5B,$74,$B3,$96, $E,$BB,$14, $B,$4E,$3A; 128
		dc.b $F0,$A7,$47,  0,  0,  0,  1,$78,$CB,$74,$B4,$D7,$80,$AD,$EB,$2B,$4F,$2C,$76,$7B,$EB,$3B,$C0,$45,$C6,$1C,$A2,$B6,$54,  9,$19,$BC,$50, $E,$76,$60,$50,$A2,$A3,$24,$5D,$53,$9A,$FE,$DD,$79,$AF,$F9,$F2,$EA,$DC,$37,$D9,$EB,$CF,$37,$9A,  1,$C9,$E6,$C5,$B0,$D1,$45; 192
		dc.b $CD,$84,$52,$28,$AE,$2C,$8E,$79,$85,$F7,$FD,$BF,$E9,$93, $D,$54,$E6,$CA,$8B,$E8,$14,$28,$39,$5F,$8C,$58,$ED,$64,$59,$84,$8B,$96,$30,$2F,$58,$55,$D2,$79,$BD,$B5,$7A,$B4,$A1,$1F,$EB,$F8,$E0,$C9,$96,$F2,$96,$CC,$BC,$50,$BC,$50,$B2,$BC,$59,$50,$E7,$5D,$5E,$E2; 256
		dc.b $D7,$3A,$FA,$2D,$86,$AB,$E6,$5A,$C8,$51,$5E,$DC,$C1,$7D,$F9,$7B,$55,$A1,$7C,$9B,$B2,  2,$99,$7E,$6A,$FB,$A1,$69,$AA, $A,$CD,$5A,$28,$35,$8A,$78,$59,$1B,$B2,$DD,$CA,$1F,$1A,$D5,$A7,$AB,$C6,$50,$2E, $B,$D6, $B,$EF,$BD,$7A,$65,$A4,$DD,$AE,$52,$56,$43,$28, $C; 320
		dc.b $66,$12,$28,$12,$D2,$AB,$87,$B3,$D7,$6E,$52, $E,$2C,$8B,$BD,$77,$E4,$DE,$1A,$8A,$FF,$A2,$47,$3F,$B2,$39,$99,$AC,$CF,$FC,$7D,$FF,$7D,$5F,$DF,$7B,$FE,$C6,$BF,$B1,$3F,$E7,$87,$71,$EE,$B7,$FB,$A2,$C5,$8E,$F2,$C5,$8B,$2B,$14,$28,$5B,$D1,$49,$BE,$47,$F6,$3E,$15; 384
		dc.b $D1,$50,$CD,$1D, $E,$66,$7F,$B7,$F4,$7F,$7D,$DE,$92,$8F,$73,$1F,$EF,$7F,$5D,$61,$EC,$BF,$DE,$AF,$EF,$8E,$F9,$1D,$EB,$E6,$7B,$D7,$F3,$CC,$5A,$46,$46,$47,$7C,$8C,$8C,$93,$A7,$6E,$F4,$9B,$FF,  5,$CE,$67,$D4,$E3,$99,$43,$FC,$13,$9C,$7F,$AE,$77,$9F,$CF,$1F,$69; 448
		dc.b $42,$50,$94,$25,  3, $F,$EF,$19,$7B,$C5, $A,$14,$EF,$C9,$B2,$6C,$8F,$FF,$8F,$F7, $E,$8B,$A1,$D0,$DF,$86,$5C,$2F,$95,$F2,$28,$F9,$CC,$CD, $F,$A8,$A1,$FF, $A,$FE,$DC,$F7,$D5,$BF,$DC,$65,  9,$43,$B9,$60,$7D,$8C,$97,$7A,$FF,$5E,$2C,$7D,$A1,$38,$7E,$8A,$4B,$FA; 512
		dc.b $C3,$A1,$97,$EB,$25,$3E,$EF,$CE,$1E,$E5,$FC,$DF,$EA,$78,$F5,$1F,$F2,$16,$62,$DF,$B2,$A3,$4E,$95,$69,$E1,$97,$51,$56,$5D,$6A,$D3,$5F,$D9,$51,$A7,$4B,$31,$61,$FF,$21,$E1,$66,  0,$8F,$FC,$80,  0,  1,$FF,$20,  7,$EC,$FF,$62,  4,$7C,$AD,$7F,$CF,$DE,$30,$4F,$D7; 576
		dc.b $DD,$7C,$D0,$FE,$7E,$F1,$82,$2E,$E5,$F3,$5D,$CB,  4,$C6,$6A,$87,$74,$7C,$CE,$65,$20,$B0,$8C,$23,$C5,$B2,$C5,$12,$DC,$4D,$31,$C5,$B1,$A6,$34,$29,$64,$E5,$B2,$5D,$74,$D9,$76,$5D, $A,$6C,$61,$B6,$87,$3B,$D1,$37, $D, $E,$77,$A2,$6E,$3A,$14,$D8,$C3,$65,$D3,$65; 640
		dc.b $DB,$1B,$25,$EC,$9C,$B4,$29,$8D,  6,$80,  8,$FE,$76,$DB,$21,$A5,$6E,$98,$A7,$95,$2D,$D4,$F5,$B5,$3C,$AB,$4B,$94,$1C,$92,$D7,$C5, $F,$95,$A8,$3A,$80,  6,$21,$73,$FA,$85,$4D,$C6,$F9,$DD,$77,$2F,$9A,$5F,$33, $F,$29,$6E,$FC,$F1,$82,$1D,$D6,$82,$1F,$CF,$D6,$19; 704
		dc.b $9D,$D5,$81,$4C,$40,$A6,$20,$40; 768

Map128_EHZ:	incbin "Levels/03/128.bin"
		even

Map16_HPZ:	dc.w $4000,$4000,$4000,$4000,$4001,$4002,$4003,$4003,$4004,$4005,$C006,$C007,$4008,$4008,$C009,$C00A,$4008,$4805,$C80A,$C809,$4802,$4801,$C00B,$C00C,$C00D,$C00E,$C00F,$C010,$C000,$C000,$E011,$C012,$C000,$C000,$C013,$E011,$4014,$4015,$4016,$4017,$4014,$4015,$4016,$4018,$4002,$4002,$4019,$401A,$4004,$4005,$401B,$401C,$4008,$4008,$C01D,$C00A,$601E,$601F,$6020,$6021,$C022,$C023,$C024,$C025; 0
		dc.w $C026,$C027,$C028,$C029,$C02A,$C000,$C02B,$C000,$C000,$C02C,$C000,$C02D,$C827,$C02E,$C829,$C02F,$C030,$C031,$C032,$C000,$C033,$C034,$C035,$C036,$C037,$C038,$C039,$C03A,$403B,$403C,$403B,$403C,$403D,$403E,$403D,$403E,$403F,$4040,$403F,$4040,$4041,$4042,$4041,$4042,$C043,$C000,$C044,$C045,$C046,$C047,$C048,$C049,$C04A,$C04B,$C04C,$C04D,$C04E,$C04F,$C050,$C051,$C84F,$C052,$C053,$C054; 64
		dc.w $C00D,$C00E,$C00F,$C000,$C055,$C056,$C057,$C051,$C000,$C000,$C000,$C058,$C000,$C000,$C059,$C013,$C000,$C05A,$C000,$C000,$C05B,$C05C,$C05D,$C05E,$C022,$C05F,$C024,$C025,$C810,$C060,$C061,$C062,$4000,$4000,$4000,$6063,$4000,$4000,$6064,$6065,$C000,$C066,$C000,$D012,$C067,$C068,$C069,$C034,$C06A,$C06B,$C06C,$C06D,$C06E,$C000,$C06F,$C070,$4802,$4002,$4071,$4003,$4802,$4002,$4003,$4003; 128
		dc.w $4802,$4815,$4003,$6072,$6073,$6074,$6075,$6076,$6077,$6077,$4012,$4013,$6078,$6077,$4079,$407A,$C813,$C84A,$C84D,$C84C,$4000,$4000,$607B,$607C,$4000,$4000,$506D,$4000,$403D,$403E,$407D,$407E,$403F,$4040,$407F,$506F,$C827,$C02E,$C080,$C02F,$C810,$C060,$C061,$C062,$C081,$C038,$C082,$C03A,$C083,$C084,$C085,$C086,$C087,$C088,$C089,$C08A,$C08B,$C08C,$C08D,$C08E,$608F,$6090,$6091,$4092; 192
		dc.w $C866,$6093,$E094,$6095,$4001,$4002,$4096,$4003,$4008,$4805,$480A,$4097,$C000,$C000,$C012,$C013,$C000,$C098,$C87A,$C879,$C04A,$C099,$C04C,$C04D,$D039,$C09A,$C837,$C834,$C834,$C09B,$C08E,$C003,$C09C,$C09D,$C09E,$C09F,$C0A0,$D833,$C0A1,$C0A2,$C0A3,$C0A4,$C0A5,$C835,$C0A6,$E0A7,$C0A8,$C879,$C000,$C0A9,$C000,$C0AA,$C0AB,$C0AC,$C0AD,$C0AE,$C0AF,$C0B0,$C0B1,$C0B2,$C892,$C867,$C834,$C869; 256
		dc.w $C06A,$C0B3,$C06C,$C0B4,$C84F,$C855,$C053,$C054,$D069,$C0B5,$C0A8,$C879,$4000,$60B6,$4000,$60B7,$60B8,$60B9,$60BA,$60BB,$C000,$C0BC,$C0BC,$C869,$D0BC,$C0BD,$C000,$C000,$C0BE,$C0BF,$C000,$C000,$C813,$D834,$C039,$C09A,$C09C,$C09D,$C09E,$C0BD,$D0BE,$C813,$C033,$C0C0,$C0BE,$C000,$C000,$C000,$60C1,$60C2,$60C3,$60C4,$C000,$C05D,$C000,$C000,$C0C5,$C0BD,$C000,$C000,$60C6,$4000,$60C7,$4000; 320
		dc.w $C0C8,$C0C9,$D813,$C0CA,$C0CB,$D06D,$C0CC,$C0CD,$C000,$C0C8,$C000,$D813,$C0C9,$C0CB,$C0CA,$C0CC,$D06D,$C000,$C0CD,$C000,$60CE,$60CF,$4000,$60D0,$60D1,$60D1,$60D2,$60D3,$60CF,$60D4,$60D5,$60D6,$60D7,$60D8,$7865,$60D9,$60DA,$70D6,$60DB,$60DC,$4000,$60D7,$4000,$7865,$60D8,$60DA,$60D9,$60DB,$70D6,$4000,$60DC,$4000,$C0DD,$C0DE,$C0DF,$C0E0,$C0E1,$C0E2,$C0E3,$C0E4,$C000,$C0DD,$C000,$C0DF; 384
		dc.w $C0DE,$C0E1,$C0E0,$C0E3,$C0E2,$C000,$C0E4,$C000,$4000,$60E5,$4000,$60E6,$60E7,$60E8,$60E9,$60EA,$60EB,$60EC,$60ED,$60E9,$4000,$4000,$60EE,$4000,$60E5,$60E7,$60E6,$60E9,$60E8,$60EF,$60EA,$60F0,$60EF,$4000,$60F0,$4000,$C0F1,$C0F2,$C0F3,$C0F4,$C0F5,$C05F,$C0F6,$C025,$C810,$C000,$C061,$C000,$C000,$C0F1,$C000,$C0F3,$C0F2,$C0F5,$C0F4,$C0F6,$C05F,$C810,$C025,$C061,$60E8,$60F7,$60EA,$60F8; 448
		dc.w $60F9,$60FA,$60FB,$60FC,$60F7,$70D6,$60F8,$60FD,$60FE,$60FF,$6876,$6875,$6100,$6101,$6102,$6103,$6104,$4000,$6105,$4000,$4000,$60FE,$4000,$6876,$60FF,$6100,$6875,$6102,$6101,$6104,$6103,$6105,$C0DD,$C106,$C0DF,$C107,$C0E1,$C108,$C0E3,$C109,$C013,$C000,$C107,$C10A,$4000,$4000,$4000,$4000,$C106,$C0E1,$C107,$C0E3,$C108,$C013,$C109,$C107,$C000,$C000,$C10A,$C10B,$C000,$C000,$C10C,$C10D; 512
		dc.w $C10E,$C10F,$C110,$C111,$C112,$C113,$C114,$C013,$C115,$C0F1,$C000,$C0F3,$C0F2,$C116,$C0F4,$C117,$C118,$C119,$C11A,$C11B,$C10B,$C000,$C11C,$C11D,$C000,$C000,$C000,$C10C,$C000,$C10E,$C10D,$C110,$C10F,$C112,$C111,$C114,$C113,$C115,$C013,$C000,$C116,$C118,$C117,$C11A,$C119,$C10B,$C11B,$C11C,$C000,$C000,$C11D,$C000,$40CE,$40CF,$4000,$40D0,$40D1,$40D1,$40D2,$40D3,$40CF,$40D4,$40D5,$40D6; 576
		dc.w $40D7,$40D8,$5865,$40D9,$40DA,$50D6,$40DB,$40DC,$4000,$40D7,$4000,$5865,$40D8,$40DA,$40D9,$40DB,$50D6,$4000,$40DC,$4000,$4000,$40E5,$4000,$40E6,$40E7,$40E8,$40E9,$40EA,$40EB,$40EC,$40ED,$40E9,$4000,$4000,$40EE,$4000,$40E5,$40E7,$40E6,$40E9,$40E8,$40EF,$40EA,$40F0,$40EF,$4000,$40F0,$4000,$40E8,$40F7,$40EA,$40F8,$40F9,$40FA,$40FB,$40FC,$40F7,$50D6,$40F8,$40FD,$40FE,$40FF,$4876,$4875; 640
		dc.w $4100,$4101,$4102,$4103,$4104,$4000,$4105,$4000,$4000,$40FE,$4000,$4876,$40FF,$4100,$4875,$4102,$4101,$4104,$4103,$4105,$4000,$611E,$4000,$611F,$5039,$409A,$6120,$4834,$4834,$409B,$408E,$4003,$409C,$409D,$409E,$6121,$5033,$58BC,$6122,$4000,$40BE,$40F1,$4000,$40F3,$40E2,$50C0,$40E4,$5813,$68D4,$6123,$68D6,$68D5,$6124,$6121,$68D3,$68D2,$6125,$68CE,$68D0,$4000,$C000,$C0C8,$C000,$C126; 704
		dc.w $D004,$C0E2,$C08E,$C0E4,$4000,$411E,$4000,$411F,$5039,$409A,$4120,$4834,$409C,$409D,$409E,$4121,$5033,$58BC,$4122,$4000,$C000,$C0F1,$C000,$C0F3,$C0E2,$D8BC,$C0E4,$C000,$48D4,$4123,$48D6,$48D5,$4124,$4121,$48D3,$48D2,$4125,$48CE,$48D0,$4000,$4000,$6127,$4000,$6128,$C129,$C8AB,$C8AE,$C8AD,$C000,$C058,$D05A,$C8B1,$612A,$C12B,$C910,$C12C,$C85F,$612D,$C825,$C8F6,$4000,$C010,$612E,$612F; 768
		dc.w $4000,$4000,$6130,$6131,$4000,$4000,$6132,$6133,$4000,$6134,$4000,$6135,$D8BF,$C000,$D862,$C000,$4000,$6136,$4000,$6136,$4000,$4000,$4000,$6137,$4000,$6138,$C010,$6139,$5860,$4000,$4000,$4000,$4000,$4000,$613A,$4000,$C861,$C825,$613B,$D034,$4000,$4000,$4000,$613C,$613D,$C86B,$613E,$C86D,$4000,$613F,$6140,$6141,$C000,$C060,$C000,$C062,$C8BF,$C000,$D85A,$C000,$4802,$4002,$4142,$4071; 832
		dc.w $4802,$4002,$4003,$4871,$4802,$4002,$4142,$4142,$C000,$C143,$C000,$C03A,$C810,$C000,$C061,$C000,$C000,$C09A,$C000,$C834,$D033,$D8BC,$C8A2,$C013,$C0DD,$C0AC,$C144,$C0AE,$C0DD,$C929,$C144,$C0AE,$C858,$C066,$C0B1,$C0B2,$6145,$6146,$4002,$4802,$6133,$6147,$4014,$4015,$4000,$4000,$6145,$6146,$4000,$4000,$6133,$6147,$4014,$4015,$50BC,$4003,$4002,$4004,$4003,$4003,$4804,$4802,$4003,$58BC; 896
		dc.w $4815,$4814,$4014,$4015,$C810,$D0BC,$C06D,$C000,$C000,$C87A,$C000,$C126,$C0C9,$C0CB,$C0CA,$C0CC,$D06D,$C000,$C0CD,$C000,$C000,$C0DD,$C000,$C0F3,$C0F2,$C0F5,$C0F4,$C0F6,$C05F,$C810,$C025,$C061,$4002,$4002,$4003,$4003,$C0DD,$C0DE,$C0DF,$C0E0,$C0E1,$C0E2,$C0E3,$C0E4,$C000,$C0DD,$C000,$C0DF,$C0DE,$C0E1,$C0E0,$C0E3,$C0E2,$C000,$C0E4,$C000,$C000,$C000,$D0BF,$D8C5,$C000,$C0C8,$D85D,$C126; 960
		dc.w $D06D,$C0DD,$C0CD,$C144,$4802,$4815,$506E,$6072,$6073,$6074,$6075,$6076,$6148,$6149,$614A,$614B,$4015,$4002,$6872,$4000,$C000,$E136,$C14C,$E136,$E14D,$E14E,$E14F,$E150,$E151,$E152,$E153,$E94F,$C154,$E136,$C154,$E136,$E155,$E156,$E14F,$E150,$E157,$E158,$E153,$E94F,$C154,$E136,$D14C,$E136,$E159,$E15A,$E936,$C000,$E14D,$E14E,$E15B,$E15B,$E151,$E152,$E15B,$E15B,$E936,$C000,$E15C,$C000; 1024
		dc.w $C060,$D08A,$C15D,$D088,$E15E,$C000,$C000,$C000,$E15B,$E15F,$E160,$E161,$E15B,$E15B,$E15B,$E15B,$E15B,$E162,$E15B,$E163,$E164,$C000,$E165,$C000,$C000,$C05D,$C000,$C058,$C0C5,$C8A0,$C059,$C8A1,$C166,$C166,$F077,$F077,$C94C,$C000,$F077,$F077,$C000,$C000,$F077,$F077,$E167,$E077,$E168,$C000,$E15B,$E169,$E16A,$E16B,$E15B,$E15B,$E15B,$E16C,$E16D,$E16E,$E16F,$E170,$E171,$C066,$C000,$D012; 1088
		dc.w $E172,$E173,$E174,$E175,$E176,$E15B,$E177,$E15B,$E15B,$E178,$E179,$E17A,$E17B,$E17C,$E17D,$C000,$E17E,$E17F,$E180,$F173,$E181,$E15B,$E182,$E15B,$E15B,$E15B,$E183,$E184,$E185,$E186,$E187,$E188,$E189,$E17D,$E18A,$C000,$E077,$E18B,$C000,$C000,$E18C,$E18D,$C000,$C000,$E18A,$C000,$C000,$C000,$C0C5,$D8BC,$C000,$C000,$C858,$C000,$C0B1,$C000,$C000,$C000,$C058,$C059,$C000,$C0DD,$C013,$C144; 1152
		dc.w $D069,$C098,$C0A8,$C879,$C0AF,$D8BC,$C0B1,$C000,$E94E,$E94D,$E15B,$E15B,$E151,$E152,$E95B,$E95B,$D069,$C000,$D8BC,$C000,$C000,$C05D,$F15E,$C000,$C0C5,$C8A0,$C000,$D0BC,$C081,$D013,$D862,$C000,$C000,$E971,$C000,$C000,$E167,$E077,$E168,$D14C,$E077,$E18B,$D94C,$C000,$E95B,$E176,$E95B,$E177,$F977,$E15B,$F976,$E15B,$C000,$C000,$C013,$C000,$E981,$E15B,$E982,$E15B,$E15B,$E181,$E15B,$E182; 1216
		dc.w $C05A,$C038,$C060,$C03A,$C15D,$C09A,$C837,$C834,$D860,$C000,$D85A,$C000,$E936,$C000,$E15C,$C000,$F94E,$F94D,$E15B,$E15B,$E15B,$E15B,$E151,$E152,$E159,$E15A,$E936,$C000,$E14F,$E150,$E155,$E156,$E153,$E94F,$E157,$E158,$E936,$C94C,$E936,$C954,$C000,$C813,$C059,$C8A1,$618E,$618F,$781F,$781E,$D033,$D8BC,$C0BE,$C000,$C081,$D013,$D944,$C000,$4000,$618E,$4000,$781F,$618F,$4000,$781E,$4000; 1280
		dc.w $C0AF,$C0BD,$C0B1,$C000,$D8DD,$C000,$C8BC,$C000,$4000,$4000,$4000,$6063,$618E,$618F,$6190,$6191,$4015,$4002,$4017,$4819,$4002,$4815,$58BC,$6192,$7876,$7875,$6193,$7873,$D8BC,$C000,$C000,$C000,$D8DD,$C000,$C000,$C000,$6194,$6195,$798F,$798E,$C858,$C000,$C0B1,$C8BC,$4000,$618E,$6063,$6190,$618F,$4000,$6191,$4000,$4015,$4002,$4017,$58BC,$7875,$7992,$7873,$5015,$7993,$4000,$6076,$4000; 1344
		dc.w $C000,$C060,$C000,$C062,$4000,$4000,$48BC,$6063,$4015,$4815,$58BC,$6192,$618E,$618F,$6190,$6191,$6196,$6197,$4000,$6192,$6873,$4015,$6075,$6076,$C000,$C0DD,$C000,$C144,$C000,$C0BF,$C000,$C000,$4000,$7072,$7196,$7197,$4802,$4815,$50BC,$4018,$4001,$4002,$4003,$4003,$C000,$C000,$C098,$C859,$C000,$C060,$C858,$C062,$C000,$C0DD,$C858,$C144,$C000,$C000,$E198,$C000,$C000,$C000,$E199,$E19A; 1408
		dc.w $F998,$E19B,$E19C,$E19D,$E99B,$F198,$E19E,$E19F,$E99B,$C000,$E1A0,$E1A1,$E19B,$E998,$E1A2,$E1A3,$E19B,$F198,$E1A4,$E1A5,$E19B,$C000,$E1A6,$E1A7,$C000,$C000,$E1A8,$E99B,$C000,$C000,$E198,$E99B,$C000,$C000,$E199,$E1A9,$F99B,$E199,$E1AA,$E1AB,$E1AC,$E1AD,$E1AE,$E1AF,$E1B0,$E1B1,$E1B2,$E1B3,$E1B4,$E1B5,$E1B6,$E1B7,$E1B8,$E1B9,$E1BA,$E0CE,$E077,$E077,$E8CF,$E8D1,$E077,$E074,$E8D1,$E8CF; 1472
		dc.w $E1BB,$E1B9,$E1BA,$E0CE,$E1BC,$E1BD,$E1B6,$E1B7,$E1BE,$E1BF,$E1B2,$E1B3,$E1C0,$E1C1,$E1C2,$E1AF,$E998,$E1C3,$E1C4,$E1C5,$C000,$C000,$E1C6,$E1C7,$E1C8,$E1C9,$E1CA,$E1CB,$E1CC,$E1CD,$E1CE,$E1CF,$E1D0,$E1D1,$C098,$C859,$E1CF,$C000,$C858,$C000,$60EF,$68D0,$60F0,$4000,$E1CF,$C000,$C000,$C000,$E1D0,$E1D1,$C000,$C000,$E1D2,$E1D3,$E1CE,$E1CF,$E1D4,$E1D5,$E1D6,$E1D7,$E1CE,$E1D8,$C012,$C013; 1536
		dc.w $E9D8,$E9CE,$C059,$C013,$C014,$C815,$C014,$C815,$C000,$C014,$C000,$C014,$E198,$C000,$E9A3,$E0E7,$C000,$C000,$C000,$E99B,$E874,$E077,$E8CF,$E8D1,$C000,$C000,$E1D9,$E1A8,$C000,$E198,$E1DA,$E1DB,$E1DC,$E1DD,$E1CE,$E1D8,$E9C7,$E1DE,$E1DF,$E1E0,$C000,$E99B,$E1E1,$E1E2,$C000,$C000,$E1E3,$E19B,$C000,$C000,$E998,$C000,$C000,$C000,$E198,$E1E4,$E198,$F998,$E1E5,$E1E6,$E1C8,$E1E7,$E1E8,$E1E9; 1600
		dc.w $E1EA,$E1EB,$E1CE,$E1D8,$E9D8,$E1EC,$C000,$C000,$E1ED,$E1EE,$E1D8,$C000,$E1EF,$E1F0,$E1F1,$E9EC,$E1F2,$E1F3,$E1F4,$E1F5,$E99B,$E1F6,$E1F7,$E1F8,$F998,$E198,$E1F9,$E1FA,$E000,$E19B,$E1A1,$E1A2,$E998,$E99B,$E1A3,$E1FB,$E198,$E99B,$E1FC,$E1FD,$E9A8,$E1FE,$E1FF,$E200,$E201,$E202,$E203,$E1F5,$E204,$E205,$E1F1,$E9EC,$E206,$E1EE,$E1D8,$C000,$C000,$E207,$C000,$C000,$E208,$E209,$C000,$C000; 1664
		dc.w $E20A,$E20B,$C000,$E0CE,$E20C,$E077,$E8CF,$E8D1,$E074,$E20C,$E8D1,$E8CF,$EA09,$EA08,$C000,$C058,$EA07,$C000,$C059,$C013,$C000,$C09A,$D85A,$C834,$C07A,$C143,$C082,$C03A,$420D,$420D,$420E,$420E,$420F,$4210,$4211,$4212,$4213,$4214,$4215,$4216,$4142,$4142,$4217,$4218,$4219,$421A,$421B,$421C,$421D,$421E,$4217,$4218,$421F,$4220,$421B,$421C,$4221,$4222,$4211,$4212,$4223,$4224,$4225,$4226; 1728
		dc.w $4227,$4228,$4229,$422A,$4223,$422B,$4225,$4226,$421D,$421E,$422C,$422D,$422E,$422F,$4230,$4231,$4221,$4222,$4232,$4212,$421D,$421E,$4233,$4234,$421F,$4220,$421B,$4235,$4236,$4237,$4229,$422A,$4238,$421E,$4233,$4234,$421D,$421E,$4239,$4234,$4236,$4237,$423A,$623B,$4236,$4237,$623C,$623B,$4221,$623D,$4211,$623E,$623F,$623D,$6240,$623E,$421D,$6241,$4217,$6242,$6243,$6241,$6244,$6242; 1792
		dc.w $4221,$6245,$4211,$6246,$6247,$6245,$6248,$6246,$421D,$6249,$4217,$624A,$624B,$6249,$4221,$624A,$421D,$421E,$4239,$424C,$4227,$424D,$4229,$422A,$424E,$424F,$4250,$421C,$4236,$4251,$4252,$4212,$4227,$4228,$4253,$422A,$4236,$4237,$4229,$4254,$4255,$4237,$4256,$4257,$4238,$421E,$4258,$4218,$422E,$4259,$4230,$4231,$4236,$4237,$423A,$4257,$4221,$623D,$425A,$623E,$4236,$6241,$4229,$6242; 1856
		dc.w $4238,$421E,$4233,$425B,$4236,$6245,$4229,$6246,$4236,$6249,$4229,$624A,$6249,$625C,$624A,$625D,$623D,$623F,$623E,$6240,$6241,$6243,$6242,$6244,$6245,$6247,$6246,$6248,$421D,$6249,$4217,$625E,$625F,$624B,$421B,$421C,$4236,$623D,$623C,$623E,$4236,$4251,$4251,$4212,$6241,$6260,$6261,$4212,$6262,$6263,$4225,$4226,$625E,$6243,$4217,$6261,$4A37,$4A36,$623C,$623B,$4236,$623D,$4251,$623E; 1920
		dc.w $421D,$6249,$4217,$6261,$624B,$6249,$421B,$6261,$4264,$4265,$4266,$4264,$4265,$4267,$4267,$408E,$4265,$4265,$4265,$4265,$4268,$4269,$4269,$408E,$408E,$408E,$408E,$408E,$4266,$4266,$4266,$4266,$4268,$4268,$4268,$4268,$4265,$4265,$426A,$426B,$4265,$4265,$4265,$426C,$4265,$4265,$426D,$426E,$4265,$4265,$426C,$426D,$4265,$4265,$426E,$426A,$4265,$4265,$426B,$4265,$4265,$4265,$426F,$4265; 1984
		dc.w $4265,$4265,$4265,$426A,$4270,$4271,$4272,$4273,$4274,$4275,$4276,$4277,$4278,$4279,$4273,$4276,$4275,$4278,$4277,$4273,$4279,$427A,$4276,$4277,$4274,$427B,$427B,$4A0D,$4274,$427A,$4276,$4277,$427C,$427D,$427E,$427F,$4280,$4281,$4282,$427E,$4283,$408E,$427E,$4283,$4284,$427D,$4285,$427E,$4280,$4281,$427E,$427E,$427C,$427C,$427E,$427E,$427C,$427D,$427F,$4282,$4268,$4268,$4286,$4287; 2048
		dc.w $4268,$4268,$4288,$4289,$428A,$428B,$4287,$4288,$4268,$428C,$4289,$4287,$428A,$428B,$428D,$5A8D,$4268,$428A,$4286,$4287,$428B,$4268,$4288,$4289,$428E,$428F,$4268,$4290,$4291,$4292,$4293,$4294,$5A88,$5A87,$4268,$4268,$5A89,$428F,$4268,$4290,$5A8D,$4268,$4A82,$4295,$4296,$4297,$4298,$4299,$4268,$4268,$5297,$4268,$429A,$4268,$4268,$428A,$4268,$4268,$4282,$5296,$4A82,$429B,$5297,$4268; 2112
		dc.w $428A,$429C,$5297,$4268,$4268,$4268,$429D,$429E,$429F,$4A82,$42A0,$42A0,$429B,$42A1,$42A0,$42A0,$4268,$4268,$42A2,$42A3,$429F,$4A82,$42A0,$429E,$429B,$42A1,$429E,$42A0,$4268,$42A1,$42A0,$429D,$4A82,$429B,$42A0,$42A0,$4142,$42A4,$4142,$4142,$42A5,$4142,$4142,$4142,$42A4,$4142,$4142,$4142,$42A4,$42A5,$4142,$4142,$4142,$42A5,$4142,$4142,$4265,$4265,$426B,$426A,$520E,$520E,$4A0D,$4A0D; 2176
		dc.w $427C,$427D,$427E,$427E,$4268,$4A8B,$428D,$5A8D,$4282,$4268,$4268,$4286,$428A,$428B,$4289,$4287,$4268,$428C,$4288,$4289,$4268,$4A8B,$4287,$4288,$4282,$4268,$4289,$428D,$4A8B,$4282,$5A8D,$4268,$5A8D,$4268,$4268,$4268,$4268,$428E,$4268,$4268,$428F,$4291,$4290,$4293,$4292,$5A88,$4294,$4268,$5A87,$5A89,$4A82,$4295,$4292,$5A8D,$4294,$4268,$4268,$429A,$5297,$4268,$429F,$42A1,$429D,$429E; 2240
		dc.w $4268,$4268,$42A0,$42A0,$429B,$42A1,$42A2,$42A3,$4268,$4268,$42A0,$429E,$429F,$4A82,$429E,$42A0,$429B,$42A1,$42A0,$429D,$4268,$42A1,$42A2,$42A3,$42A6,$42A7,$4142,$52A4,$4142,$42A8,$52A5,$4142,$42A9,$4AA8,$52A5,$4142,$42A7,$4AA7,$4142,$52A4,$42A6,$42A7,$52A5,$4142,$4142,$42A8,$52A4,$4142,$42A9,$4AA8,$52A4,$52A5,$42A7,$4AA7,$4142,$52A5,$4AA0,$4AA0,$529F,$5A82,$4AA0,$4AA0,$529B,$52A1; 2304
		dc.w $4AA0,$529E,$529F,$5A82,$529E,$4AA0,$529B,$52A1,$4AA0,$529D,$4268,$52A1,$4AA0,$4AA0,$5A82,$529B,$527B,$420D,$5274,$527B,$4AA0,$529E,$4268,$4268,$529E,$4AA0,$529F,$5A82,$4AA0,$529D,$529B,$52A1,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000; 2368
		dc.w $4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000; 2432
		dc.w $4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000; 2496
		dc.w $4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$C046,$C047,$C048,$C049,$C067,$C068,$C069,$C034,$C8F2,$C8F1,$C8F4,$C8F3,$C000,$C060,$C000,$C062; 2560
		dc.w $C813,$C84A,$C84D,$C84C,$C08B,$C08C,$C08D,$C08E,$D860,$C000,$C000,$C000,$C000,$C2AA,$D0C5,$D0B0,$C000,$C2AB,$C000,$C2AC,$C000,$C2AD,$C000,$C000,$C2AA,$C2AE,$C2AF,$C2B0,$C2B1,$C2B2,$D8AE,$D834,$D8BE,$C2B3,$C2B4,$C2B5,$C06D,$C000,$C000,$C000,$C000,$C2B6,$C0BC,$C833,$C09C,$C09D,$C09E,$C2B7,$C2B8,$C2B9,$C2BA,$C2BB,$C813,$C84A,$C84D,$C84C,$C046,$C047,$C048,$C049,$62BC,$62BD,$62BE,$6ABE; 2624
		dc.w $62BF,$62C0,$62C1,$6AC1,$62C2,$62C0,$62C3,$62C4,$C815,$E073,$C818,$C816,$C000,$C000,$C059,$C013,$C2C5,$C2C6,$C2C7,$C000,$C2C8,$C2C9,$C000,$C2CA,$C000,$C2CB,$C2CC,$C2CD,$C000,$C2C5,$C000,$C2C7,$C2C6,$C2C8,$C000,$C000,$C2C9,$C000,$C2CA,$C000,$C000,$C000,$C2CE,$C2CC,$C2CB,$C000,$C2CD,$C000,$C000,$C2CF,$C000,$CACA,$C2D0,$C2D1,$C000,$C000,$E2D2,$F93A,$CAC7,$C000,$C000,$CACB,$E2D3,$E2D4; 2688
		dc.w $C000,$C000,$CACC,$D2C8,$D2CA,$C000,$D2C9,$C000,$601E,$601F,$798F,$798E,$4000,$601E,$4000,$798F,$601F,$4000,$798E,$4000,$7991,$7990,$798F,$798E,$7863,$4000,$4000,$4000,$4000,$7991,$4000,$798F,$7990,$7863,$798E,$4000,$4000,$60E5,$4000,$60E6,$60E7,$60E8,$60E9,$60EA,$4000,$4000,$4000,$4000; 2752
Nem_HPZ:	dc.b $82,$D5,$80,  4,  2,$14,  5,$25, $F,$35,$10,$45,$14,$55,$13,$65,$16,$73,  0,$81,  4,  3,$16,$2E,$28,$E6,$38,$EB,$82,  5,$11,$16,$34,$28,$E7,$83,  4,  4,$16,$2F,$27,$71,$84,  5, $E,$17,$6D,$28,$ED,$85,  5,$12,$16,$33,$28,$E9,$86,  5,$15,$17,$72,$87,  4,  6; 0
					; DATA XREF: ROM:0001C02Ct
					; ROM:0001C1A8o
		dc.b $16,$31,$28,$EE,$88,  8,$E8,$89,  7,$6A,$18,$EF,$8A,  7,$6B,$18,$EA,$8B,  7,$6E,$8C,  6,$32,$18,$F0,$8D,  7,$6C,$18,$EC,$8E,  6,$30,$17,$70,$8F,  7,$6F,$FF,  0,  0,  0,$DF,$BB,$F7,$F9,$6F,$77,$F1,$5A,$46,  0,$16,$FE,$9C,$92,$47,$FB,$58,$CB,$F6,$E9,$8A,  0; 64
		dc.b   0,$FF,$AB,$71,$6B,$D8,  0,  0,$12,$FF, $B,$7F,$8C,  0,  7,$FD,$63,$FE,$64,$2B,$C0,  0,$42,$4D,$9F,$F1,$EB,$8F,$ED,$A1,$B6,$F5,$DB,$89,$60,$4E,$C4,$B8,$43,$83,$DC,$D3,$73,$16,$C9,$B2,$6C,$7B,$95,$9D,$FA,$9C,$7F,$A9,$C3,$F9,$A3,$60,$16,$D9,$3D,$85,$FD,$CB; 128
		dc.b $80,  0, $F,$FB,$FF,$C9,$FF,$C7,$ED,$68,$6C,$A6,$2A,$E6,$86,$C2,$65,$67,$B9,$59,$76,$B4,$1C,$BD,$CB,$B7,$19,$E2, $B,$F8,$85,$B6,$8E,$7F,$EE,$97,$AB,$F6,$FD,$58,$C3,$AB,$FB,$A0, $B,$6B,$9E,$B9,$EB,$9E,$BB,$75,$4F,$AA,$1D,$54,$D7,$3D,$60, $B,$7E,$A7,$F5,$DD; 192
		dc.b $40,$51,$C0,$B5,$80,$3F,$53,$86,$AE,$C6,$7B,$4D,$84,$D8,$4D,$85,$BF,$5D,$FA,$9D,$8C,$1E,$C2, $E, $E,$56,$27,$11,$93,$A1,$81,$19,$6D,$65,$FC,$DF,$EA,$B0,$EF,  0,$4F,$18,$63,$D8,$F6,$C3,$65,$92,$8D,$DF,$D4,  4,$30,$9E,  5,$B1,$FC,  9, $B,$61,$61,$3D,$8B,$14; 256
		dc.b $7A,$70,$CB,$F7,$AE,$9E,$B9,$53,$59,$D3,$59,$D3,$59,$D3,$59,$D3,$59,$D3,$59,$CD,$DF,$DB,$DE,$EC,$2C,$EC,$2C,$EC,$2C,$EC,$2C,$EC,$2C,$EC,$2C,$EC,  9,$DB,$1C,$57,$49,$C8,$57,$F4,$B0,  0,$5B, $D,$65,$AD,$DC,$7A,$32,$FC,$C6,$87,$1F,$EA,$B4,$80,  0,$7F,$4E,$49; 320
		dc.b $AB,$67,$7E, $E,$D4,$E0,  0,  0,$6C,$FD,$C9,$60,$E0,  0,  0,$16,$1B,$50,$B6,$C1,$CA,$E0,  0,  0,$B5,$AB,$95,$CF,$70,  0,  1,$67,$41,$CA,$E2,$ED,  0,  0,$1C,$AE,$2E,$D5,$71,$7E,$D0,  0,  0,$71,$76,$BD,$B6,$B3,$BB,$80,  0,  6,$56,$2F,$FB,$F7,$59,$A9,$8C,$31; 384
		dc.b  $A,$E5,$67,$B9,$59,$EE,$5C,$3F,$73,$D9,$90,$99,$A0,$A1,$A5,$44, $D,$39,  8,$BA,$29,$27,  5,$E4,$65,$A5,$62,$F6,$85,$4D,$B4,$AC,$41,$1B,$69,$58,$85,$47,$56,$44,$E8,$A0,$53,$4E,$46,$C2,$15,$74,$A2,$A6,$85,$28,$B9,$E6,$91,$92,$43,$AD,$D5,$74,$44,$34,$AC,$44; 448
		dc.b $23,$58,$D2,$B1,$9C,$45,$BF,$37,$D5,$FB,$E6,$2D,$B0,$69,$50,$C4,$CC,$4C,$C2,$D7,$F6,$7F,$B2,$6B,$1E,$33,$BB,$19,$99,$63,$43,  6, $D,$DD,$3F,$B4, $F,$31,$33,$5B,$CD,$F7,$E8,$52,$8A,$69, $D,$28,$7F,$E5,$B5,$69,$C8,$91,$79,$3E,$32,$AD,$BF,$66,$2F, $C,$AE,$91; 512
		dc.b $70,$26,$27,$1C,$B0,$27,$3D,$C7,$2D,$64,$E6,$57,$5C,$AE,$65,$71,$E2,$4E,$65,$72,$B6,$D6,$82,$3D,$8B,$AB,$BF,$65,$B5,$13,$16, $B,$A8,$98,$B6,$E1,$A8,$98,$9C,$46,$E9,$DC,$4C,$4E,$57,$1D,$9C,$D4,$97,$72,$35,$F5,$72,$BA,$8E,$7B,$A0,$E2,$74,$DC,$AE,$A6,$D2,$4A; 576
		dc.b $39,$78,$8F,$E3,$BD,$D0,$67,$BA, $C,$F7,  7,$3D,$A0,$E0,$E5,$67,$E3,$CF,$B5,$4D,$4C,$9C,$C7,$3D,$4F,$3D,$AD,$47,$16,$A7,$99,$39,$85, $C,$B5,  0,  5,$B5,$29,$A9,$B9,$A0,$6F,$D4,$A6,$F7,$36,$A7,$17,$5C,$B1,$71,$1B,$DD,$AA,$66,$4D,$B4,$E1,$A8,$9D,$36,$71,$18; 640
		dc.b $86,$A2,$30,  0,$A6,$AB,$33,$8E,$1A,$9E,$6B,$A9,$9D,  3,$D5,$83,$8C,$B3,$42,$C2,$46,$E2,$62,$D7,$23,$73,$DD,$73,$95,$9C,$46,$E5,$67,$16,$B7,$2B,$38,$B5,$BD,$9C,$5A,$DE,$D3,$62,$71,$6B,$9E,$BA,$38,$6B,$A3,$A6,$C5,$AE, $D,$36,$5D,$76,$E1,$AD,$7B,$B6,$EB,$9E; 704
		dc.b $B9,$EB,$13,$69,$B4,$DA,$6D,$6C,$67,$8C,$31,$86,$20,  1,$3E,$EB,$34,$DA,$6C,  0,$16,$FE,$EF,  8,$5F, $B,$E1,$78,  0,$4D,$DF,$E5,$71,$D9,$C7,$67,$1D,$9C,$76,$71,$D9,$C7,$67,$1F,$12,$ED, $F,$47, $A,$23,$85,$11,$C2,$6E,$7F,$ED,$21,$B4,$8E,$8E,$3A,$38,$E8,$E3; 768
		dc.b $A3,$8E,$8E,$3A,$38,$E6,$EF,$EA,$BA,$67,$2A,$1C,$A8,$72,$A1,$CA,$87,$2A,$1C,$A8,$72,$99,$FF,$52,$33,$AC,$EB,$3A,$CE,$B3,$AB,$EF,$2A,$AD,$EB,$52,$BE,$95,$FE,$A8,$4A,$8B,$25,$45,$92,$B6,$48,$5E,$BF,$B5,$C6,$F9,$E3,$7C,$F1,$BE,$78,$80,$3F,$77,$94,$6B,$10,  0; 832
		dc.b   0,$6C,$FD,$76,$CC,$50,  0,  0,$1B,$3F,$5D,$B1,$B6,$20,  0,  0,$35,$36,$AD,$98,$3B,$5B,  0,  0,  1,$DA,$D8,$9A,$F0,  0,  0,$13,$21,$31,$76,$80,  0,  0,$9D,$22,$97,$30,  0,  0,$24,$65,$22,$ED,  0,  0,  3,$DC,$72,$3A,$87,$29,$93,$9B,$50,  0,  7,$29,$BF,$55; 896
		dc.b $1C,$D4,$38,$39,$E6,$E6,$B3,$A6,$6F,$70,$81,$FE,$BF,$F9,$63,$50,$1A,$A6,$D6,$73,$6A,$9B,$9B,$BE,$8E,$BF,$F5,$5F,$F1,$14,$C5,$CB,$8B,$AF,$26,$75,$F0,$41,$6F,$EA,$94,$B9,$BF,$4C,$BD,$DC,$57,$88,  0,  8,$48,$25,$9B,$8D,$3B,$B8,$D3,$B9,$2C,$C3,$FC,$86,  0,$1C; 960
		dc.b $69,$DD,$C6,$9D,$CB,$FD,$19,$17,$F8,$40,  4,$D6,$4D,$AD,$64,$DA,$BA,$7E,$98,$E4,$E6,$27,$2B,$3D,$8B,$69,$33,$D9,$5C,$4C,$F6, $C,$4E,$9B,$13,$A6,$C5,$FE,$54,$7F,$19,$17,$1E,$E5,$EE,$53,$75, $D,$C2,$86,$EA,$1B,$A1,$9B,$A7,$FE,$70,$8C,  5,$91,$85,$11,$A5,$C5; 1024
		dc.b $91,$6E,$7B,$89,$C5,$71,$39,$EE,$53,$27,$33,$CC,$11,$AB,$13,$A0,$E8,$19,$1B,$B5,$70,$EA,$FC,$DA,$6A,$B2,$7F,$65,$C5,$7E,$24,$DB,$49,$CA,$CA,$E2,$FD,$A4,$A9,$72,$F5,$AB,$9B,$4C,$CC,$9D,$B1,$C4,$C4,$E3,$5D,$8E,$81,$AE,$C7,$31,$3A,$1B,$1C,$AE,$86,$C4,$B6,$C1; 1088
		dc.b $81,$7F,$BC,$DC,$36,$87,$42,$57,$13,$A1,$B6,$47,$B6,$8E,$BA,$54,$DA,$4E,$2E,$DC,$C9,$CF,$32,$35,$71,$1C,$1C,$46,$A7,$33,$57,$11,$C1,$C0,$14,$BB,$64,$72,$75,$1C,$6E,$A4,$9C,$6F,$CE,$92,$57,$19,$66,$15,$C6,$1F,$CC,$E9,$5D,  3,$27,$29,$DB,$6A,$99,$39,$EE,$53; 1152
		dc.b $57,$48,$9C,$A6,$AE,$57,  6,$2C,$CC,$B6,$B5,$1C,$1C,$BB,$60,$E7,$BA, $E,$7B,$86,$D5,$BA, $E,$23,$2C,$F4,$DD,$BC,$8D,$C5,$8F,$7A,$9E,$D2,$68,$5D,$B5,$A9,$77,$6D, $D,$76,$8F,$DA,$73,$67,$DB,$AA,  6,$FD,$45,$B4,$8D,$FA,$97,$69,$BF,$53,$DD, $D,$50,$FD,$BE, $A; 1216
		dc.b $D4,$C0,$60,  0,$9F,  8,$70,$CD,$78,$66,$BC,$33,$87, $F,$DD,$CA,$9C,$24,$6B,$C3,$33,$2E,$19,$91,$AE,$6A,$74,$71,$D1,$D2,$A3,$A5,$38,$FF,$93,$62,$5B,$62,$5B,$62,$5B,$62,$5B,$62,$5B,$62,$5B,$62,$7E,$AB, $F,$D7,$C4,$2B,$8C,$51,$C7,  4,$9B,$A2,$E3,$57,$1C,$9E; 1280
		dc.b $E3,$93,$DD,$23,$2E,$68,$D9,  3,$DC,$60,$3D,$C1,$CA,$E3,$5B,$FB,$4A,$EE,$CB,$E7,$D9,$7C,$FB,$2F,$9F,$60,  3,$F5,$DD,$58,$7E,$7C,$3D,$C4,$E3,  5,$7A,$B9,$FD,$97,$96,$D3,$5E,$CB,$DD,$4E,$CB,$F1,$87,$67,$46,$CC,$68,$7D,$98,$C2,$EE,$CC,$60,$65,$D9,$43,  6, $F; 1344
		dc.b $7F,$F6,$E4,$27,$84,$85,$30,$90,$A6,$12, $B,$BB,$F7,$3F,$AB,$AB,$97,  6,$83,$83,$8B,  6,$A3,$83,$B0,$64,$A3,$97,$8C,$3F,$5C,$5F,$A6,$C8,$2E,$12,$14,$C2,$4F,$C6,$18,$DF,$84,$B1,$BD,$ED,$7C,$30,$CB,$FB,$E0,  9,$E7, $C,$E1,$9C,$33,$9F,$F5,$49,$21,$9A,$45,$73; 1408
		dc.b $24,$91,$66,$A9,$2A,$24,$A8,$92,$A2,$4A,$89,$29,$B7,$F4,$DC,$87,$64,$3B,$21,$D9, $E,$C8,$76,$43,$B2,$1F,$F8,$8C,  1,$3E,$10,$E1,$72,$F0,$B9,$78,$5D,  3,$97,$F5,$24,$EB,$49,$D6,$93,$AD,$27,$3F,$6A,$C9,$CB,$7F,$F1,$1F,$C6,$46,$EB,$FF,$5B,$C3,$7D,$DC,$27,$77; 1472
		dc.b   9,$DD,$C2,$77,  1,$FF,$3F,$E8,$E7, $D,$B8,$AE,$DC,$57,$6E,$30,$C4,  1,$3F,$FA, $B,$3A,$1D,$A8,$5D,$BC,$49,$DC,$60,$82,$DF,$C7,$BF,$5A,$F6,$DE,$5B,$78,$96,$B6,$BC,$3F,$5B, $A,$6B,$61,$3D,$7F,$AD,  0,$6D,$9E,$3B,$67,$8E,$D9,$E3,$B7,$8E,$AE,$1D,$E1,$75,$B0; 1536
		dc.b $A6,$B6,$14,$D6,$C0,$59,$83,  6, $C,$18,$30,$61,$FF,$A7,$2B,$8B,$B5,$B6,$B3,$BB,$9D,$8B,$9B,$B4,  1,$B3,$56,$1A,$F0,$FD,$52,$FE,$DC,$62,$30,$EA,$C3,$5F,  2,$6D,$AC,$EC,$70,$76,$2E,$6D,$AC,$7B,$4D,$D7,$3A,$B8,$D5,$B9,$36,$B1,$AC,$6B,$1A,$C6,$B1,$AC,$6B,$2F; 1600
		dc.b $E3,$6D,$C0,$E1,$17,$98,$37,$C6,  6, $D,$63,$43,  6,$5F,$AF,$E1,$74,$B9,$93,$5C,$9A,$2B,$AF,$56,$99,$AE,$99,$BF,$64,$9D,$D6,$5B,$23,  3,$5D,$E8,$A7,$5E,$24,$7C,$9B,$F5,$E8,$75,$6E,$50,$AB,$A2,$C6,$A6,$D9,$AD,$D0,$FF,$8B,$1C,$EA,$65,$FD,$12,$4F,$E1,$2A,$2F; 1664
		dc.b $15,$45,$41,$79,$20,$9A,$52,$E8,$5D, $B,$A1,$79,$89,$A1,$D1, $E,$66,  0,$B7,$FD,$3F,$E5,$FF,$51,$FF,$11,$FF,$1F,$F9,$61,$D7,$A4,$8B,$7F,$E9,$B3,$8A,$EA,$4F,$D9,$3F,$5F,$ED,$E1,$97,$35,$36, $D,$87,$6C,$BF,$68,$5C,$44,$1C,$82,$CE,$41,$67,$20,$6F,$ED,$EF,$2C; 1728
		dc.b $86,$43,$21,$90,$C8,$64,$32,$3F,$F6,$26,$CB,$26,$CB,$26,$CB,$26,$CB,$26,$C2,$AD,$37,$55,$1F,$F9,$8B,$CF,$F5,$DC,$B3,$70,$9F,$27,$FE,$9A,$F2,$E5,$C6,$EA,$DE,$57,$62,$85,$76,$3D,$6D,$5B,$97,$6A,$46,$5B,$A5,$B8,  1,$47,$13,$85,$3A,$A8,$C5,$D5,$A9,$B5,$6C,$D5; 1792
		dc.b $D5,$A8,  0,$E2,$74,$18,$B5,$AB,$95,$C3,$FF,$5D,$5A,$B5,$FE,$E4,  0,$AC,$5F,$B7,$57,$17,$ED,  7,$FE,$BF,$5B,$FC,$97,$B9,$EC,$20,$E2,$62,$DB,  6,$2C,$7F,$68,$DD,$BC,$59,$C5,$FF,$AE,$8F,$EE,$74,$23,$AC,$8E,$B2,$3A,$C8,$EB,$23,$AC,$8E,$B2,  4,$9A,$53,$8D,$56; 1856
		dc.b $F8,$5E,$F4,$A8,$A2,$54,$2F,$EC,$CB,$F4,$D3,$4A,$5F, $B,$E1,$78,  0,$51,$3F,$E8,$2C,$62,$66,$26,$6B,$FC,$4C,$EA,  0,$BE,$78,$DF,$3C,$6F,$9E,$29,$4B,$B9,  7,$98,$99,$89,$98,$9C,$BF,$C2,$E9, $B,$3A,$42,$CE,$90,$B3,$A4,$FE,$B9,  0,  2,$98,$99,$BA,$86,$E2,$EB; 1920
		dc.b $91,$E7,  7,$48,$59,$D2,$16,$74,$85,$9D,$FC,$12,$DB,  3,$75, $D,$C2,$86,$EA,$1B,$85, $D,$D3,$4F,$DB,$95,$F0,$64,  2,$8C,$80,$51,$92,$18,$95,$ED,$CA,$8E,$3B,$38,$C5,$9C,  0,$C4,$BF,$86,  9,$90, $A,$32,  1,$6F,$F1,$80,  0,  1,$7A,$3F,$37,$FA,$AF,$CC,$21,$19; 1984
		dc.b $35,$6F,$B9,$AA,$65,$76,$27,  6,$B9,$6E,$A9,$AD,$DA,$2D,$DA,$78,$5D,$A7,$83,$CE,$FF,$DF,$9B,$CD,$51,$4C,$8E,$F2,$BA,$37,$BF,$48,$78,$2F,$EF,$17,$C0,$4F,$F5,$93,$F0,$7D,$F9,$41,  8,$DF,$7D,$CF,$42,$38,$22,$9B,$D2,$17,  3,$5F,$E9,$DD,$7C,$EE,$BE,$77,$5F,$3B; 2048
		dc.b $80,$FF,$9F,$EB,$36,$75,$85,$3C,$97,$F3,$70,$FC,$DD,$E4,$79,$6E,$BC,$8C,$9B,$72,$15,$CD,$5B,$EE,$6A,$9A,$11,$93,$1A,$F5,$7E,$6F,$2E,$CC,$A6,$7A,$E8,$7A,$DA,  7,$AD,$8D,$E7,$AD,$8D,$E7,$B2,$A6,$46,$47,$B0,$D4,$E2,$7B, $D,$4E,$25,$AD,$8D,$4D,$22,$4C,$6B,$74; 2112
		dc.b $6A,$6A,$7A,$64,$B7,$44,$B2,$53,$D3,$C1,$4E,$25,$94,$22,$59,$4F,$2A,$26,$F4,$74,$11,$C4,$C9,$DA,$1C,$4E,$56,$A3,$82,$B0,$68,$39,$ED,$FB,$3F,$FB,$FE,$DC,$62,  3,$51,$CA,$D4,$74,$FB,$3B,$FF,$5D,$19,$E4,$94,$C9,$1D, $C,$A7,$91,$23,$9F,$94,$F2,$54,$72,$E5,$68; 2176
		dc.b $F1,$2F,$DA,$1D,$9C,$76,$71,$D9,$C7,$67,$1D,$9C,$76,$77,$FC,$64,  0,  0, $F,$FA,$B1,$7F,$5C,$91,$AC,$8D,$64,$6B,$23,$59,$1A,$C9,$8F,$F4,$CB,$FE,$E0,  0,  7,$FD,$EF,$17,$8B,$C5,$E0,  4,$FF,$22,$35,$91,$AC,$8D,$64,$6B,$23,$59,$1A,$C8,$D6,$40,  5,$92,$97,$C9; 2240
		dc.b $F7,$E6,$B7,$E6,$FE,$3F,$C6,$24,$B5,$F6,$BE,$D7,$DA,$FB,$5F,$6B,$EC,$D3,$72,$51,$C9,$47,$25,$1C,$94,$72,$51,$C9,$34,$9C,$BF,$CE,$75,$49,$9C,$AF,$A1,$E7,$7C, $C,$B3,$48,$1B,$8A,$54,$93,$AD,$27,$7F,$94,$59,$C2,$6E,$13,$70,$79,$D6,$EE,$93,$27,$63,  7,$26,$DC; 2304
		dc.b $67,$B7,$12,$72,$3F,$68,$57,$20,$87,$ED,$7F,$4D,$10,$AE,$13,$70,$9B,$85,$B3,$FD,$95,$62,$B8,$AB,$A9,$89,$3A,$6C,$58,$D1,$B6,$E3,$3D,$B8,$CF,$6E,$3F,$AC,$C3,$F3,$FB,$AA,$F8,$DD,$B0,$B2,$79,$E4,$FC,$97,$64,$F0,$9E,$13,$8C,$E3,$6F,$F1,$24,$CE,$67,$33,$99,$CC; 2368
		dc.b $E6,$73,$3B,$47,$97,$75,$EC,$E2,$35,$71,$6A, $D,$B4,$E1,$A8,$9C,$F7,$2B,$38,$8C,$43,$51,$18,  0,$53,$55,$99,$C7, $D,$4F,$32,$76,$A6,$73,$DC,$4C,$5D,$B2,$39,  9,$BA,$42,$8E,$A8,$A3,$AA,$16,$4F,$76,$86,$52,$19,$8C,$C6,$60, $E,$93,$EE,$70,$57,$54,$51,$D5,$14; 2432
		dc.b $75,$44,$CF,$FA,$EE,  0,$4E,$E8,$5D,$B5,$6E,$DA,$B7,$6D,$86,$D0,  0,$9E,$63,$31,$9A,$C7,$F8,$D7,$80,$27,$7C,$2F,$B9,$6F,$B9,$59,$2E,$86,$7F,$B4,$CE,$17,$6D,$5B,$B6,$AD,$DB,$61,$B4,  1,$36,$FF,$11,$4B,$FA,$E4,$E8,$D9,$D1,$B3,$A3,$67,$46,$CE,$8D,$9D,$14,$FD; 2496
		dc.b $BD,$EC,$BD,$B7,$96,$DE,$24,$91,$BC,$3D,$22,$28,$91,$14,$48,$8A,$24,$45,$12,$21,$FC,$62,$B7,$C2,$F8,$31,$FF,  9,$26,$69,$43,$47,$40,$E6,$64,$8E,$79,$CC,$D5,$1C,$B2,$B7,$EF,$37,$FE,$AC, $B,$54,$4E,$A8,$29,$54,  7, $A,$A0,$36,$7D,$51,$4E,$86,$C1,$F5,$43,$63; 2560
		dc.b  $F,$AC,$9C,$9A,  0,  5,$AA,  1,$56,$5B,$74,$74,$1A,$C6,$FA,$A1,$B3,$D0,$21,$91,$91,$A3,$DA,  6,$24,$E4,$D1,$1A,$40,$52,$A8,$60,  8,$55, $D,$B6,$E9,$2D,$A8,$4C,$2C,$64,$71,$7B,$40,$C2,$98,$23,$89,$BF,$44,$37,$B4,$DB,$5D,$1B,$5D,$1B,$5D,$1B,$5D,$1B,$5D,$1B; 2624
		dc.b $5D,$1B,$5C,$F0,  0, $A,$75,$43,$AB,$15,$EA,$C5,$70,$D7,$8C,$3A,$BF,$7B,$8C,$3A,$B1,$5E,$AC,$57,$AB,$18,$62,  0,$9E,$1F,$EF,$C0,$ED,$81,$DB,  3,$B6,  7,$6C, $E,$D8,$1D,$B0,$3D,$5F,$DA,$DA,$96,$72,$59,$C9,$67,$25,$9C,$96,$72,$59,$C9,$FB,$DD,$DD,$1A,$B5,$8B; 2688
		dc.b $1B,$EA,$86,$C0,  7,$D5, $C,$8C,$B4,$97,$6E,$80,$8E,$20,$C0,$10,$38,$9D,$10,$EB,$27,$26,$80, $A,$19,$19,$55, $D,$80,$7A,$34,$9C,$9A,$20,  2,$20,$C0,$9E,$FF,$F7,  0,$2F,$9F,$65,$F3,$EC,$BE,$7D,$97,$95,$64,$E4,$8E,$FC,  0,$10,$32,$38,$D5, $D,$80,  0,  0,$47; 2752
		dc.b $33,$23,$54,$3C,$4D, $E,$A4,$97,$21,$96,$EE,$CE,$1A,$FF,$36,$7F,$F4,$72,$59,$92,$CC,$96,$64,$B3,$25,$99,$25,$36,$FF,$A0,$13,$CE,$92,$DA,$FC,$DC,$FC,$F6,$BE,$5B,$60,$6E,$A1,$CC,$E6,$73,$35,$BD,$4C,$AF,$D0,$A5,$7E,$8B,$B7,$48,$1B,$BA,$5C,$BD,$B7,$3A,$48,$59; 2816
		dc.b $ED,$35,$96,$D2,$37,$B9,$4E,$67,$33,$99,$80,$FB,$E4,$FB,$F4,$2E,$3A,$43,$40,  4,$FF,$67,$AB,$F5,$C2,$1A,$D9,$50,$5E,$BA,$DA,  8,$10,$B5,$B5,$2F,$2D,$F9,$7F,$3E,$A7,$7C,$CE,$F2,$48,$1F,$EC,$E0,$7F,$B3,$81,$F1,$A1,$DF,$33,$4F,$F0,$80,$15,$27,$C6,$9F,$B3,$24; 2880
		dc.b $54,$2F,$E1,$92,$2F,$F0,$CD,$15, $A,$F2,$34,$84,$54,$D2,$C6,$96,$34,$23,$A1,$A5,$8D,$3F,$C2,  0, $F,$49,$F1,$87,$F0,$DF,$C4,$91,$7F,$66,$FF,$E1,$AF,$EC,$DF,$FB,$32,$42,$8F,$EC,$D6,$25,$13,$8D,$F1,$A4,$4B,$FC,$2A,$84,$85,$FF,$34,$2F,$F9,$FF,$CF,$F8,$71,$38; 2944
		dc.b $FE,$CE,$2F,$BC,$E3,  4,$2F,$E8,$FF,$CE,$69,$3B,$CE,$17,$D2,$F2,$37,$F1,$87,$EC,$CD,$7F,$67, $F,$D9,$97,$39,$7E,$CD,$4C,$B8,$C1, $A,$F8,$72,$2B,$DF,$8F,$2B,$E1,$8D,$64,$85,$D7,$C9,$22,$F4,$E7,$30,$A8,$62,$88,$62,$88,$62,$69,$FE,$24,$AF,$F4,$4A,$AD,$6A,$B5; 3008
		dc.b $AA,$D6,$AB,$5A,$AD,$6A,$B2,$4E,$BF,$F1,  2,$77,$50,$EF,$7D,$C8,$FB,$AF,$79,$DF,  8,$A5,$23,$38,$CE,$33,$8A,$E2,$B1,$2C,$73,$24,$C7,$35,$43,$CE,$87,$FB,$35,$E6,$5E,$25,$75,$F1,$53,$BC,$A2,$F4,$58,$CE,$33,$8C,$E2,  3,$F1,$47,$E3,$99,$26,$39,$C3,$30,  4,$FF; 3072
		dc.b $66,$5C,$C2,  8,$6A,$82,$F5,$43,$82,  4,$24,$3A,$5E,$5F,$E1,$DE,$27,$81,$8A,$60,$62,$98,$18,$5C,$3F,$57,$2E,$D8,$CB,$1F,$DA,$13,$A2,$D7,$C1,$D2,$C6,$F7,$BA,$45,$8C,$1D,$2B,$3A,$56,$74,$B2,$EA,$77,$49,$D9,$17,  3,$54,$8D,$12,$2B,$81,$92,$46,$89,$17,$E0,$69; 3136
		dc.b $1A,$1C,$68,$7F,$E4,$37, $D,$A3,$68,$DA,  0,$FF,$AF,$FD,  0,$BE,$78,$DF,$36,$E3,$47,$37,$1A,$39,$AB,$FD,$42,$6A,$25,$68,$87,$44,$3A,$21,$D1, $E,$88,$73,$8F,$F5,$A2,$E9,$51,$C4,$E9,$59,$D2,$B3,$A4,$FD,$AA,$E9,$43,$69,$3A,$54,$ED,$97,$F4,$DB,$57,$F5,$35,$B5; 3200
		dc.b $30,$6A,$60,$D4,$C1,$A9,$83,$53,  6,$A6, $D,$36,$99,$89,$9C,$45, $E,$22,$87,$11,$43,$88,$56,$53,$8A,$B4,$A8,$D2,$53,$89,$34,$A8,$D2,$79,$C5,$A5,$48,$CA,$7F,$E3,$92,$72,$EB,$24,$95,$71,$85,$FC,$B1,$7D,$E5,$CA,$17,$DA,$FB,$5F,$59,$A7,$FC,$40,$C6,$7C,$B1,$9D; 3264
		dc.b $7B,$A8,$75,$EE,$38,$1F,$28,$A0,$BC,$5E,$2F,  0,$17,$F4,$E3,$7D, $C,$AF,$B5,$F6,$BD,$F7,$AD,$F0,$BC,$AF,$A7,$FC,$EF,$5F,$F0,$DA,$29,$48,$CE,$24,$90,$8C,$E2,$A8,$F8,$CE,$3D,$7C,$E8,$76,$43,$A1,$92,$1D,$90,$EC,$87,$64,$3B,$21,$C7,$8B,$E3,$33,$8B,$D0,$8E,$33; 3328
		dc.b $8C,$10,$92,$69,$4B,$E6,$96,$FF, $A,$1D,$90,$EC,$87,$64,$37,$DE,$A8,$70,$BC,$90,$E9,$C4,$FF,$A6,$49,$FE,$19,$B1,$D1,$AB,$46,$AD,$1A,$B4,$6A,$D1,$AB,$39,$7F,$8E,$C7,$33,$99,$CC,$E6,$73,$39,$9C,$F7,$FF,$AF,  9,$37,$F1, $B,  8,$DF,$3C,$6F,$7E,$12,$2C,$52,$CC; 3392
		dc.b $FC,$24,$1F,$FB,$B9,$3F,$FE,$80,$25,$9A,$F9,$E3,$79,$5C,$F6,$A9,$AF,$EE,$F5,$96,$62,$98,$48,$E7,$83,$AD,$80,  3,$F3,$7F,$BA,$E1,$70,$9B,$A8,$E2,$C1,$D6,$C3,$6C,$F8,$6D,$9F,  7,$17,$F6,$F3,$FF,$24,$A9,$75, $D,$4D,$6E,$85,$D0,$39,$98,$99,$89,$9C,$CE,  9, $E; 3456
		dc.b $31,$23,$BF,$9C,$A4,$5A,$42,$47,$3F,$FE,$CD,$8E,$8D,$5A,$35,$68,$D5,$A3,$56,$8D,$5A,$35,$67,$5B,$5E,$2F,$17,$8B,$C0,  9,$2F,$E9,$25,$4D,$A1,$79,$57,$19,$F2,$C4,$AF,$7F,$20,$B7,$88,$73,$47,$AC,  1,$8C,$F9,$63,$3E,$58,$CF,$96,$30,$42,$E4,$21,$78,$B5,$E5,$78; 3520
		dc.b $BD,$6F,$85,$EB,$FD,$30,$93,$49,$A4,$D2,$69,$34,$9A,$5B,$F6,$65,$CC,$20,$86,$2C,$86,$57,$8B,$D5, $E,$17,$BF,$F8,$64,$86,$95,$FE,  9,$1C,$B1,$9F,$2C,$5E,$68,$5C,$9A,$D5,$79,$A0,$7F,$EC,$91,$FF,$F1,  1,$AD,$5C,$67,$CB,$12,$B9,$FC,$8C,$12,$7F,  6,$C6,$49,$15; 3584
		dc.b $BA,$86,$F4,$89,$18,$7A,$44,$2D,$FA,$1F,$18,$A5,$D3,$BE,$E5,$67,$DF,$74,$EF,  0,$55,$53,$AC,$2A,$44,$51,$22,$FC,$61,$8E,$77,$9B,$67,  4,$94,$24,$5F,$D3,$B2,$52,$F8,$5E,$F9,$5E,  0,$A7,$FC,$40,  7,$68,$9D,$A2,$76,$89,$C3,$99, $D,$E8,$11,$50,$E0,$81,  9, $E; 3648
		dc.b $88,$2F,$39,$A1,$6F,$FF,$56,$78,$FE,$D1,$9D,$16,$BE, $E,$96,$37,$BD,$D2,$2C,$60,$E9,$59,$D2,$B3,$A4,$D3,$74,$9C,$36,$8D,$A3,$68,  3,$FE,$BF,$C4,$29,$51,$C7,$47,$1B,$A4,$F7,$1D,$1C,$64,$E9,$2B,$8E,$66,$AE,$90,$57,$2B,$A4,$AE,$3A,$38,$D5,$D2,$53,$9C,$9E,$E9; 3712
		dc.b $14,$A7,$29,$CA,$DF,$EE,$76,$16,$76,$16,$76,$16,$76, $F,$DA,$AE,$C2,$1B,$49,$D8,$53,$B7,$FD,$DA,$F0,  0,  0,$1A,$CC,  0,$14,$E1, $E,$1A,$2F,  3,$96,$3C,$1D,$23,$E9,$E1,$AF,$77,  9,$F0,$D1,$78,$68,$BC,$34,$7A,$68,$57,$E2,$69,$8D,$D9,$91,$E6,$29,$FF,$E0,  4; 3776
		dc.b $F8,$43,$86,$8B,$C3,$45,$E1,$A4,$38,$7E,$F3,$48,$70,$93,$97,$81,$CA,$EE,$1A,$38,$C9,$DA,$13,$19,$1B,$D8,$D5,$CA,$C6,$A6,$AC,$6F,$72,$B7,$ED,$AF,$74,$D8,$DE,$8D,$53,$24,$C4,$E4,$F3,$CD,$5C,$1C,$1C,$3F,$69,$2E,$68,$39,$4D,$E6,$A7,  7,$11,$C0,$C8,$E6,$6B,$9B; 3840
		dc.b $8E,$45,$9B,$FA,$61,$9C,$DA,$C8,$D6,$46,$B2,$37,$69,$AA,$47,$A5,$52,$24,$E7,$A4,$5E,$E5,$6F,$E2,$DC,$21,$FF,$4F,$FA,$AE,$30,$C7,$B1,$71,$EC,$5C,$7B,$21,$7F,$F3,$B5,$CF,$38,$66,$CF,$CC,$99, $B,$35,$64,$A3,$25,$19,$28,$C9,$36,$FD,$A4,$A3,$B4,$8F,$96,$BD,$99; 3904
		dc.b $D5,$BB,$17,$1E,$C8,$76,  0,$27,$FD,$BE,$1F,$C4,$94,$CD,$4D,$6E,$A1,$C0,$C8,$C4, $C,$4C,$C4,$CC,$4C,$DF,$7C,$2F,$D0,$A4,$E4,$D1,$E7,$28,$D3,$66,$AF,$E7,$1F,$46,$AC,$69,$1E,$CC,$5E,$95,$2E,$C6,$7A,$55,$76,$41,$2B,$64,$AD,$92,$BF,$EF,$C8,  6,$B6,$CC,$67,$D9; 3968
		dc.b $8C,$FB,$31,$9F,$63,$7F,$56,$B9,$42,$F8,$C9,$6F,$D1,$6F,$D2,$1A,  0,$27,$9F,$F5,$33,$E6,$A7,$4F,$35,$3A,$40,  1,$DD,$FF,$CE,$2E,$CC,$67,$D9,$89,$73,$2F,$63,$74,$F3,$16,$C7,$F4,$B8,$ED,$21,$FF,$E0,$1A,$DB,$31,$A1,$F6,$62,$F9,$38,$FB,$31,$7C,$B6,$F6,$31,$75; 4032
		dc.b $E7,$D1,$BC,$E6,$7B,$CE,$DB,$CE,$86,$5B,$CE,$69,$BC,$E0,$77,$EF,$3A,$5F,$BC,$DE,$65,$7E,$FA,$71,$81,$F1,$9D,$F4,$32,$4B,$24,$CD,  6,$CF,$EF,$6F,$C9,$26,$99,$25,$2F,$C9,$21,$C7,$24,$7F,$EC,$F2,$45,$FE,$1E,$48,$5F,$D3,$C9,$32,$DF,$96,$FC,$B7,$E4,  0,$B6,$FC; 4096
		dc.b $A1,$96,$FB,$D7,$7E,$5F,$B3,$CB,$7F,$F4,$F2,$DF,$96,$FC,$B7,$92,$43,$C0,$8D,$7C,$14,$CB,$2D,$EF,$35,$BD,$4D,$E8,$A7,$33,$99,$CF,$2D,$9F,$DE,$F0,$BE,$7E,$17,$CF,$C2,$F9,$EF,$CA,$9C,$55, $B,$F6,$65,$FE,$3D,$F9,$6F,$CB,$7E,$5B,$F2,  0,$5F,$3C,$B7,$DF, $B,$FC; 4160
		dc.b $2F,$54,$54,$CB,$7D,$FF,$AC,$DF,$96,$FF,  8,$78,$43,$C2,$1E,  2,  9,$3E,$2A,$85,$FB,$32,$FE,$19,$26,$FD,$5A,$F5,$6B,$FD,$4E,$12,$FE,$89,$60,$EB,$60,$EB,$60,$EB,$60,$EB,$60,$EB,$60,$EB,$6E,  0,  0,  0,  0,$4E,$48,  0,$9E,$EE,$88,$70,$CD,$78,$66,$BC,$33,$86; 4224
		dc.b $60,  9,$FE,$E3,$BE,$4E,$5E,$6B,$F9,$88,$E3, $B,$A2,$BB,$13,$2D,$91,$53,$2D,$97,$7E,$7C,$E9,$77,  9,$DD,$C3,$FA,$9D,$3F,$E4,$2B,$81,$C1,$1F,$72,$EC,$48,$5C,$5B,$12,$DB,$12,$1C,$36,$12,$3F,$4B,$C9,$21,$A7,$12,$47,$E9,$79,$E3,$79,$44,$CB,$3B,$B1,$4A,$66,$60; 4288
		dc.b $BF,$5D,$B3,$77,$E6, $B,$7F,  9,$26,$7D,$7F,$98,$81,$95,$DD,$84,$64,$6B,$74, $E,$86,$A6, $C,$BF,$5F,$FB,$ED,$F3,$CD,$7F,$6B,$7E,$7F,$B3,$CE,$FF,$DA,$DD,$9D,$11,$FC,$C8,$5C,$CA,$8B,$1B,$BF,$3F,$E1,$BE,$45,$84,$12,$BB,$27,$14,$13,$C8,$4D,$21,$C4,$BF,$7B,$FB; 4352
		dc.b $E0,  0,$87,$FD,$7F,$E7,$FB,$5F,$DB,$7E,$CC,  9,$E6,$BF,$B5,$BF,$3F,$D9,$E7,$7F,$ED,$57,$3A,$1F,$F8,$E2,  0,  0,$7F,$D7,$FE,$A0,  0,$21,$FF,$5F,$D9,$FE,$D7,$92,  0,$27,$24,$90,  0,  8,$49,$24,  0,$84,$92,$40,$AE,$48,$B4,$8A,$55,  0,  0,  1,$A6,$97,$D5,$C0; 4416
		dc.b   0,$2D,$29,$CA,$12,$AA,$55,$82,$C9,$24,  8,$C0,$59,$24,$88,$C8,$C4,$F7,$E1,$24,$91,$61,$BD,$22,$BC,$2F,$32,$E8,$DD,$7D,$CB,$79,$1C,$CE,$67,$33,$B7,$FF,$C5,$8E,$67,$11,$43,$89,$C0,$E3,$43,$89,$19,$6C,$E1,$BF,$B3,$F5,$89,$6C,$92,$91,$2C,$92, $C,$85,$92,$3E; 4480
		dc.b $E5,$C9,$1E,$68,$B9,$21,$21,$C3,$24,$AA,$47,$AF,$60,  0,$5A,$42,$72,$E3,$A5,$CE,$AC,$CD,$4C,$3C,$D4,$C1,$1A,$1C, $E,$26,$20,$71,$3A,$44,$C4,$CC,  0,  5,$25,$5A,$49,  4,$A1,$24,$94,$24,$12,$44,$6B,$24,$94,$25,  3,$5C,$EB,$7E,$82,$D2,$13,$92,$52,$49,$49,$2C; 4544
		dc.b $A8,$92,$59,$55,$2A,$EB,$A4,$92,$81,$C0,$C8,$C9,$25,$48,$C9,$4C,$8E,$26,$A6,$47,  3,$7C,$4C,$8D,$4E,$26,$BD,$2E,$AF,$70,  0,  0,$3F,$CF,$BA,$79,$4F,$29,$E5,$3C,$A7,$93,$EF,$2C,$96,$F5,$C8,$AF,$87,$86,$F3,$13,$C0,$C5,$30,$31,$4C, $C,$4F, $F,$F7,$88,$7F,$D7; 4608
		dc.b $FE,$7F,$F2,$FF,$BF,$FC,$6E,$E5,$FB,$2E,$57,$7E,$D7,$89,$7E,$CF,$49,$57,$F6,$4D,$5B,$BF,$6E,$65,$7F,$59,$22,$F2,$54,$7E,$77,$FF,$C4,  0,$3F,$EB,$FF,$3F,$F9,$7E,$DF,$F6,$9F,$B3,$16,$94,$E4,$94,$92,$4A,$12,$49,$42,$49,$28,$49,$24,$A6,$B2,$FD,$B3,$17,$4F,$EC; 4672
		dc.b $E5,$C7,$F6,$A9,$D3,  9,$3F,$AD,$6E,$85,$CB,$D6,$B7,$7F,$4A,$B2,$D2,$F2,$92,$48,$11,$91,$89,$24,$88,$C8,$E2,  0,$69,$68,$91,$4B,$A2,$57,$3E,$24,$73,$31,$33,  0,$4F,  9,$E0,$74,$C0,$E5, $C, $E,$4E,$7E,  7,$27,$32,$E0,$72,$73,$2E,  7,$27,$31,$36, $E,$93,$98; 4736
		dc.b $99,$35,$FE,$7F,$77,$67,$E6,$EB,$CD,$89,$A0,  0,  4,$FD,$36,$9F,$A6,$E9,$E4,$E9,$1B,$EE,$BC,  0,  7,$F4,$B9,$38,$E5,$57,$55, $F,$B6,$FE,$7E,$DB,$F9,$FB,$6F,$E7,$ED,$BF,$9F,$B6,$FE,$7E,$DB,$F9,$FB,$6F,$E7,$DA,$8E,$BE,$24,$8E,$27,$5F,$12,$47,$13,$AF,$89,$23; 4800
		dc.b $89,$D7,$C4,$91,$C4,$EB,$E2,$48,$E2,$75,$F1,$24,$71,$3A,$F8,$92,$38,$9D,$7C,$4A,$B2,$47,$12,$1A,$5D,$8F,$58,  0, $E,$5A,$7E,$CF,$96,$7D,$B1,$FD,$BF,$58,  0, $F,$D9,$7E,$99,$3A,$F9,$CE,$D1,$B4,$6D,$1B,$46,$D1,$B4,$6D,$1D,$7B,$F8,$77,$E1,$BC,  0,  0,$1D,$1B; 4864
		dc.b $B0,$D9,$AB,$76,$1B,$EB,$B6,$FE,$72,$75,$50,$F9,$D6,$AD,$73,$99,$6A,$D7,$39,$89,$D5,$43,$E7,$AE,$DB,$F9,$EB,$B6,$FE,$7D,$A8,$EB,$E2,$48,$E2,$75,$F1,$24,$71,$3A,$F8,$95,$50,$92,$BD,$35,$42,$4A,$F4,$A3,$89,$D7,$C4,$91,$C4,$EB,$E2,$48,$E2,$75,$F1,$24,$26,$24; 4928
		dc.b $28,$88,$DA,$3B,$6F,$FD,$96,$DB,$FF,$65,$68,$DA,$36,$D0,$A2,$48,$4E,$2E,$7B,$F6,$D7,$9C,$D2,$AE,$23,$4B,$9A,$AA,$69,$73,$55,$79,$CD,$2A,$E2,$E7,$BF,$6D,$79,$EF,$DB,$53,$8B,$A4,$8C,$95,$BA,  6,$A6,$2C,$E8,$C8,$8C,$8C,  1,$1C,$6F,$D1, $E,$26,  5,$22, $C,  1; 4992
		dc.b $3B,$AD,$75,$AE,$B5,$D6,$BA,$D7,$5A,$E7,$56,$FD,$10,$14,$64,$46,$47,$13,  0,  1,$5B,$F2,$D5,$D1,$AF,$70,$5C,$24,$29,$84,$85,$30,$90,$9E,$CF,$D4,$F4,$6B,$FC,$D9,$A9,$C4,$E0,$71,$38,$1C,$4E,  7,$13,$A4,$4E,$66,$2C,$6B,$B6,$B7,$DC,$E2,$8C,$9F,$22,$8C,$94,$D6; 5056
		dc.b $32,$53,$27,$40,$DF,$19,$40,$E3,$25,$32,$38,$BC,$E0,$D7,$F3,$E3,$73,$DC,$FB,$9F,$19,$2D,$CE,$99,$94,$64,$20,$E8,$C8,$8C,$71,$AB,$8B,$45,$32,$38,$9A,$98,$23,$89,$A9,$82,$38,$98,$81,$C4,$E1,$79,$BD,$D5,$BA,$D7,$5A,$EB,$5C,$E9,$99,$46,$40,$1B,$DD,$19,$15,$D6; 5120
		dc.b $BA,$C6,$E8,$C8,$11,$85,$74,$64,$46, $A,$FA,$B8,$C9,$23,  3,$89,$80,$14,$C8,$E2,$60,$29,$82,$38,$98,$10,$38,$98,$10,$38,$9D,$35,$6E,$FE,$D7,$FD,$7F,$E2,$3F,$EE,$3F,$EF,$FF,$3C,$BF,$DB,$72,$FF,$12,$5B,$7F,$E5,$FF,$51,$D6,$5C,$D0,$37,$F5,$97,$37,$EC,$8F,$9C; 5184
		dc.b $B9,$A3,$D6,$F3,  0, $B,$1D,$AE,$B5,$D6,$B9,$76,$BE,$5B,$74,$2D,$A5,$A6,$6E,$2D,$33,$5D,$33,$5B,$9A,$B7,$E3,$B6,$ED,$A5,$1C,$CA,$45,$A4,$95,$C5,$1C,$D4,$CA,$32,$79,$94,$64,$B7,$2C,$94,$D6,$E5,$35,$3D,$16,$E2,$3B,$D6,$E7,$99,$1B,$EE,$89,$AD,$DA,$19,$5D,$A5; 5248
		dc.b $C4,$7A,$5C,$F8,$DD,$43,$B1,$DA,$EB,$5D,$6B,$AD,$72,$BA,$17,$3A,$72,$28,$C1,$C5,$19,$1B,$F6,$D5,$2E,$B5,$D6,$BA,$D7,$5A,$E2,$75, $D,$C2,$26,$EA,$F1,$AB,$8E,  6,$46,$E1,$19,$11,$82,$3D,$24,$46,  8,$E2,$72,$23,$A4,$53,$9D,$A5,$5B,$A1,$19,$15,$C4,$E8,$C9,$F7; 5312
		dc.b $5A,$51,$91,$1A,$BA,$32,  4,$6A,$E8,$CA,  8,$CE,$32,$E7,$23,  4,$71,$35,$30,$47,$13,$81,$C4,$1C, $E,$26,$29,$10,$62,$66,  0,$B4,$7F,$89,$17,$55,$CF,$75,$7B,$6A,$55,$ED,$47,$19,$1B,$91,$D7,$9B,$1F,$18,$A3,$D2,$29,$CE,$DF,$E2,$3F,$E1,$3A,$27,$17,$47,$FE,$9F; 5376
		dc.b $F4,$72,$39,$1C,$8E,$47,$7F,$CE,$29,$14,$8A,$45,$3F,$E5,$FF,$28,$A4,$6B,$14,$8A,$39,$1C,$6E,$47,$5E,$C8,$48,$C8,$C8,$C8,$48,$C8,$CE,$47,$1B,$91,$DF,$B3,$2F,$E1,$C7,$8C,$52,$25,$17,$C4,$A2,$48,$55,$24,$24,$72,$39,$1C,$8E,$BD,$91,$91,$91,$91,$91,$91,$91,$9C; 5440
		dc.b $8E,$47,$23,$BF,$E7,$7C,$52,$29,$14,$89,$44,$A2,$51,$28,$BB,$FA,$57,$7F,$59,  0,$3F,$EB,$A0,$3F,$EB,$DF,$FF,$1F,$E9,$B1,$7F,$84,  2,$FF,  8,$3F,$E9,$B0,$6F,$EA,$A5,$D4,$71,$5D,$6B,$95,$D1,$7D,$CE,$8C,$A1,$28,$CA, $E,$9B,$8A,$32,$2B,$8B,$6D,$6F,$8D,$D6,$BA; 5504
		dc.b  $E,$5B,$95,$D0,$B9,$C5,$18,$4B,$49,$3D,$D1,$CD,$76,$C6,$4B,$75,$A4,$51,$92,$9A,$C6,$4A,$6B,$19,$29,$A9,$C9,$4D,$4E,$2A,$6A,$71,$E6,$53,$89,$C0,$E2,$6B,$57,$19,$73,$A4, $D,$F1,$91,$1A,$9C,$65,  3,$8B,$CE,  6,$46,$A7,$13,$23,$53,$8C,$E2,$46,$B7,$C6,$E8,$18; 5568
		dc.b $99,$80,  5,$B4,$43,$A1,$C4,$E0,$71,$3A,$44,$E6,$60,  0,$AE,$16,$61,$63,  2,$91,$7C,$4A,$25,$12,$89,$44,$A2,  0,  0,$14,$4A,$25,$12,$FD,$91,$FF,$88,$BF,$C4,$5F,$C2,$47,$A4,$78,$9B,$1F,$EC,$DC,$64,$6E,$4E,$DA,$95,$7B,$6A,$E7,$BA,$AE,$6A,$72,  7,$FD,$74, $D; 5632
		dc.b $FD,$10,  1,$37,$F4,$40,  4,$7F,$D7,$40,$3F,$CC,$9F,$E2,$E6,$B5,$D6,$BA,$D7,$5A,$5F,$E4,$2F,$F9,$74,$B7,$ED,$B8,$DD,$6B,$9F,$B5,$4F,$B7,$4E,$DE,$7C,$F9,$FA,$57,$A5,$F7,$42,$E5,$8F,$1F,$D9,$5D,$6B,$AD,$75,$AE,$B5,$D6,$3D,$B4,$71,$44,$E1,$B6,$B7,$51,$C5,$72; 5696
		dc.b $ED,$8A,$DC,$ED,$24,$AE,$94,$73,$2D,$BA,$4A,$11,$CD,$6E,$8C,$96,$E5,$64,$C6,$BB,$4E,$4E,$2D,$33,$2E,$7C,$D4,$FA,$56,$E8,$5D, $B,$9F,$CC,$FB,$B4,$2E,$6D,$39,$94,$EF,$8A,$15,$CB,$74,$4D,$E7,$A1,$AD,$D1,$23,$2B,$B4,$B9,$74,$BA,$17,  9,$ED,$AF,$1F,$D9,$49,$4D; 5760
		dc.b $73,$53,$53,$5B,$94,$E2,$46,$F3,$89,$1A,$DD,$12,$35,$3D,$2E,$2B,$A2,$47,  8,$91,$C2,$37,$50,$C0,  0,$5B,$6F,$F5,$B4,$FF,$A8,$FF,$88,$FF,$8F,$FC,$BF,$A3,$A7,$F4,$E9,$FF,$11,$CC,$5D,$7C,$E7,$FB,$2E,$68,$F5,$BC,$ED,$FE,$24,$87,$34,$4B,$9B,$9E,$EE,$7E,$62,$8F; 5824
		dc.b $34, $C,  1,$38,$89,$C6,$A2,$91,$AC,$44,$23,$5D,  3,$AA,$E4,$57,$48,$68,$C7,$C9, $C,$45,$8F,$92,$18,$26,$3E,$48,$61,$52,$2E,$29,$56,$55,$81,$DF,$15,$93,$12,$48,$B3,$54,$95,$12,$54,$49,$51,$25,$44,$94,$F1,$38,$F1,$72,$48,$21,$8A,$20,  8,$62,$1C,$48,$F8,$9C; 5888
		dc.b $22,$F3,$10,$8A,$99,$4A,$68,$48,$BA,$27,$2A,$56,$26,$B1,$28,$BA,$B1,$BC,$D1,$4C,$92,  6,$48,$B7,$2A,$17,$2B,$88,$D0,$AA,$47,$3A,$B1,$A9,$A2,$D5,$AD,$57,$9F,$EC,$85,$8E,$66,$94,$34,$3B,$34, $D,$39,  8,$1C,$5D,$11,$CD,$4E,$73,$81,$B4,$A2,$70,$62,$34,$79,$B1; 5952
		dc.b $54,$41,$1D,$57,$45,$6B,$39,$25,$25,$39,$59,$DF,$A6,$81,$C6,$EA,$1A,$58,$D3,$FC,$AC,$94,$49,$5E,$F4,$95,$4A,$F2,$49,$55,$B9,$4A,$B2,$8B,$15,$CF,$92,$29,$A9,$D7,$8F,$33,$D0,$FF,$C4,  0, $F,$CA,$9A,$8B,$25,$DC,$BA,$A1,$B8,$2E,$A8,$6E,$5D,$45,$92,$EE,$86,$40; 6016
		dc.b  $F,$DC,$AE,$5A,$96,$F5,$CB,$F5,$3D,$40,  7,$EA,$9E,$A2,$EA,$FC,$DF,$79,$25,$CC,$BA,$1A,$B1,$6A,$FF,$58,  2,$1A,$AD,$AA,$19,$5B,$21,$6D,$50,$DC,$BA,$8B,$25,$DD, $C,$97,$A9,$75,$EE,$F0,$E5,$AB,$75,$58,$BA,$62,$CB,$28,$32,$FE,$D7,$F3,$7F,$DC,$2D,$50,$DC,$BA; 6080
		dc.b $8B,$22,$D6,$5F,$AB,$C8,$B2,$AB,$47,$12,$FD,$AA,$67,$5F,$D9,$BE,$F7,$9A,$DE,$57,$17,$7F,$EA,$BF,$56,$3C,$17,$F5,$3A,$F3,$D5,$AF,$89,$A6,$87,$FA,$66,$2B,$89,$9F,$CD,$6E,$E2,$CF,$F3,$7F,$BC,$5F,$D4,$EB,$FC,$DA,$17,$13,$26,$AC,$AE,$AE,$2F,$C4,$BF,$8B,$64,$2C; 6144
		dc.b $DF,$7C,$A0,$85,$7F,$EA,$56,$EE,$AF,  9,$56,$EC,$AB,$FB,$54,$26,$2C,$CA,$F2,$8C,$AB,$24,$53,$BC,$A3,$75,$5A,$6C,$B7,$3D,$A5,$58,$FE,$AC,$9A,$39,$6A,$D7,$BB,$5D,$C5,$D4,$5D,$6F,$BB,$F6,$E7,$5E,$E2,$EF,$65,$96,$1A,$97,$3D,$59,$43,$C2,$7F,$D5,$24,$FC,$DF,$56; 6208
		dc.b $69,$12,$6F,$CF,$92,$48,$B0,$D4,$A9,$2A,$24,$A8,$92,$A2,$4A,$89,$29,$B7,$F4,$DC,$87,$BB,$F9,$84,$9A,$D7,$3A,$AA,$6C,$91,$24,$13,$A1,$26,$9B,$AC,$9B,$8E,$69,$AF,$FC,$47,$AB,$F7,$4F,$45,$BB,$77,$81,$5C,$58,$94,$8D,$58,$B3,$2E,$EC,$CA,$F5,$91,$5E,$B9,$92,$17; 6272
		dc.b $37,$EA,$7A,$BF,$56,$3F,$59,$FA,$95,$E9,$2B,$FA,$90,$AF,$2E,$62,$4E,$65,$6B,$9F,$8A,$FE,$DF,$A7,$77,$EF,$3F,$52,  7,$EA,$FF,$59,$46,$5F, $F,$DB,$BE,$4B,$FC,$52,$CE,$17,$FF,$67,$A8,$B5,$43,$72,$EA,$2C,$97,$74,$32,$86,$5A,$B5,$D2,$44,$9F,$BA,$5B,$E1,$AD,$26; 6336
		dc.b $7F,$EA,$DC,  0,$86,$AB,$6A,$7E,$BC,$BF,$37,  3,$65,$DD,$E0,$5F,$BB,$2F, $A,$6E,$10,$D4,$FE,$FD,$65,$A8,$BB,$C9, $B,$F5,$3C,$48,$E9,$73,$15,$F7,$13,$16,$AE,$AD,$CF,$92,$FE,$6D,$A3,$25,$DD,$8C,$9F,$B8,$99,$F7,$AB,$16,$68,$58,$E7,$CA,$35,$5C,$D0,$C9,$BA,$6B; 6400
		dc.b $1F,$D7,$C0,$F8,$6F,$BE,$37,$72,$64,$23,$A2,$5C,$4C,$B2,$32,$C7,$3E,$8D,$91,$29,$74,$76,$69,$B3,$7E,$CE,$7C,$F9,$FA,$57,$F4,$DF,$C3,$13,$FC,$DC,$3F,$37,$A2,$E5,$B9,$F2,$EA,$65,$8C,$8A,$E7,$C9,$4D,$71,$E9,$D7,$F9,$BF,  5,$8B,$FB,$EF,$2F,$D4,$A4,$79,$31,$46; 6464
		dc.b $55,$8F,$ED,$5B,$3A,$49,$78,$C6,$44,$91,$E6,$28,$A1,$5C,$AC,$5F,$B6,$68,$D6,$39,$FE,$99, $A,$44,$8B,$FA,$E9,$6C,$FD,$77,$3E,$CF,$D9,$74,$C7,$F6,$AF,$94,$39,$8B,$AD,$ED,$FE,$68,$7F,$CB,$FE,$A3,$FE,$23,$FE,$3F,$B2,$FC,$FF,$57,$EE,$D6,$4B,$CD,$9D,$50,$D5,$AF; 6528
		dc.b $23,$2C,$49,$14,$CB,$12,$89,$F2,$EE,$96,$39,$B7,$E6,$36,$7E,$63,$B3,$7F,$3F,$EF,$FA,$3F,$54,$5D,$CF,$93,$3F,$A5,$3F,$6B,$C4,$F3,$BD,$4F,$7C,$BA,$3F,$7D,$BE,$3B,$3F,$A5,$28,$FF,$55,$7F,$6A,$FF,$E2,$8F,$F8,$8F,$F8,$FF,$CB,$FE,$2F,$FF,$1C,$4B,$FA,$24,$73,$32; 6592
		dc.b $FE,$8C,$4F,$FA,$47,$1F,$E8,$91,$8B,$65,$FA,$9F,$DD,$56,$F8,$F5,$A9,$D2,$E2,$3F,$F7,$E1,$FF,$2F,$FA,$8E,$BD,$5F,$A8,$C3,$56,$1A,$8C,$B1,$2F,$EB,$FE,$A3,$7F,$EA,$37,$FF,$CB,$FE,$A3,$FE,$20,$17,$FC,$7F,$E5,$FF,$10,  4,$39,$FF,$87,$CD,$FF,$22,$FF,$88,  0,$43; 6656
		dc.b $F7,$9F,$A9,$DC,$B9,$FE,$B7,$7F,$E6,$3B,$3F,$E5,$FF,$51,$FF,$11,$D7,$FB,$6F,$DB,$8F,$F9,$7F,$D4,$7F,$C4,$7F,$C6,$1F,$F2,$2F,$F8,$80,  0,$7F,$F2,$77,$78,$5E,$BB,$37,$FE,$63,$87,$67,$FC,$BF,$EA,$3F,$E2,$3A,$F5,$7F,$23,$BC,$8E,$A6,$B7,$62,$58,$DB,$A3,$F5,$FF; 6720
		dc.b $B8,$FF,$97,$FD,$47,$5F,$EE,$77,$74,$7E,$6C,$DE,$85,$79,$5D,$FC,$EF,$D7,$FF,$CB,$FE,$A3,$FE,$34,$E7,$FE,$59,$77,$F1,$5D,$77,$BE,$F3,$1F,$C1,$23,$EE,$79,$C3,$1F,$D7,$FF,$23,$9F,$F9,$1F,$AD,$FD,$A9,$62,$48,$F9,$2B,$17,$12,$E9,$37,$DE,$5B, $B,$F9,$DB,$23,$BF; 6784
		dc.b $FA,$52,$8F,$F5,$4A,$BF,$E3,  2,$7B,$B2,$87,$7C,$64,$5F,$A9,$86,$BE,$23,$F6,$7F,$FA, $B,$97,$E6,$FF,$55,$E0,$CB,$CC,$BD,$CF,$E9,$5E,$E7,$E6,$FB,$DF,$D3,$77,$F0,$DF,$FC,$14,$62,$65,$FC,$FE, $D,$BF,$A3,$F3,$FC,$FB,$FF,$65,$D3,$1F,$DA,$BE,$50,$E6,$2E,$B7,$A7; 6848
		dc.b $F8,$80,$10,$D5,$6D,$50,$C9,$7F,$75,$B9,$BF,$37,$72,$FF,$2D,$B9,$3F,$BF,$35,$EF,$84,$B5,$17,$EC,$D6,$F8,$5F,$70,$EB,$56,$26,$5D,$FC,$15,$97,$F5,$E5,$FD,$72,$93,$E4,$AC,$5D,$25,$25,$4A,$7E,$61,$FF,$AD,$D3, $E,$CE,$7C,$F9,$FA,$57,$F4,$DF,$C3,$2D,$50,$DC,$BA; 6912
		dc.b $8B,$25,$DC,$5A,$97,$28,$27,$EE,$9E,$6F,$3F,$D5,$95,$C5,$71,$77,$17,$E9,$B1,$F0,$DD,$FB,$CD,$C0,  8,$6A,$7E,$E7,$EA,$7B,$78,$51,$97,$C1,$FB,$BF,$79, $C,$AD,$90,$5D,$56,$D4, $B,$BE,$1D,$E4,$9F,$B9,$2B,$CB,$F9,$3D,$4B,$A9,$7A,$B7,$19,$6A,$2C,$8E,$B8,$97,$53; 6976
		dc.b $2E,$7A,$C8,$F1,$E9,$23,$62,$91,$66,$6C,$BD,$28,$7D,$CB,$22,$48,$DD,$56,$89,$5E,$57,$13,$57,$98,$B1,$29,$17,$72,$CA,$19,$97,$63,$14,$8B,$67,$46,$85,$2E,$CD,$33,$E8,$D9,$A6,$6B,$F9,$FF,$D5,$6F,$FD,$BE,$7B,$3A,$34,$CF,$B3,$4C,$FB,$34,$CD,$74,$CD,$6E,$CD,$6E; 7040
		dc.b $85,$CB,$D6,$B7,$69,$FA,$9C,$3A,$BF,$31,$8C,$64,$5C,$73,$54,$2B,$8B,$89,$1B,$45,$1E,$6C,$5B,$16,$E6,$FC,$C4,$48,$CB,$7F,$46,$92,$C3,$F3,$FA,$66,$58,$7E,$7F,$66,$BF,$D7,$91,$BF,$3E,$8E,$4D,$12,$EC,$8E,$3D,$1B,$3A,$34,$97,$E7,$F9,$F3,$2D,$3A,$54,$F3,$7D,$CF; 7104
		dc.b $E6,$53,$CD,$DF,$C1,$E9,$5B,$A1,$72,$F5,$AD,$D1,$7D,$DA,$17,$36,$8A,$7C,$E5,$CC,$FB,$A1,$7F,$3F,$12,$EB,$E7,$3F,$D9,$73,$44,$B9,$9F,$70,  2,$7F,$C4,$FD,$32,$F3,$F4,$E9,$D2,$FC,$DF,$CC,$BC,$CF,$B9,$FC,$CB,$CD,$CF,$77,$39,$5C,$BF,$D2,$7F,$32,$F3,$3E,$E7,$F3; 7168
		dc.b $69,$CD,$CE,$47,$CE,$5C,$CB,$CD,  3,  5,$FB,$9F, $E,$F8,$67,$FC,$31,$C6,$E2,$37,$E0,$C5,$CD,$C2,$2C,$B8,$6F,$D2,$5B,$CB,$7E,$99,$97,$43,$6C,$EA,$FC,$FF,$46,$65,$25,$6D,$F0,$97,$46,$F8,$A1,$7E,$B7,$49,$61,$B3,$9F,$32,$D3,$A5,$4F,$37,$DC,$FE,$65,$3B,$FF,$84; 7232
		dc.b $93,$CA,$D9,$43,$55,$B5,  5,$EA,$87,$E6,$EE,$5C,$B7,$16,$2F,$CB,$F3,$7E,$1B,$84,$FA,$A1,$D4,$BF,$BA,$A7,$FC,$61,$FF,$77,$E5,$6C,$BF,$8A,$59,$D2,$44,$85,$79,$71,$24,$2B,$CB,$83,$D3,$86,$97,$70,$D3,$3F,$CF,$E9,$9A,$FE,$63,$F5,$5B,$F1,$92,$CB,$67,$46,$89,$2E; 7296
		dc.b $8D,$9A,$67,$86,$CD,$33,$5D,$33,$5B,$B3,$5B,$A1,$72,$F5,$AD,$DA,$2D,$DA,$2D,$DA,$2D,$DA,$2D,$D0,$BA,$17,  0,  4,$F2,$D5, $D,$C5,$9F,$82,$EE,$5E,$9D,$4F,$FE,$1E,$BA,$1A,$F5,$73,$52,$E5,$EB,$EA,$FE,$D9,$6A,$86,$E5,$D4,$59,$2E,$E8,$64,$1F,$93,$F2,$2E,$A6,$2D; 7360
		dc.b $4B,$95,$4E,$25,$AB,$72,$CA,$28,$BB,$BC,$3B,$F5,$D3,$F5,$2B,$FA,$9E,$25,$A9,$E8,$BA,$9F,$79,$1B,$D0,$AE,$62,$BD,$EC,$48,$5C,$CC,$BC,$95,$A9,$8A,$C8,$BF,$AA,$16,$F5,$42,$D9,$D0,$65,$7E,$1B,$34,$32,$E1,$A6,$7C,$34,$CD,$7A,$37,$EC,$D7,$BF,$56,$25,$8D,$7A,$30; 7424
		dc.b $D1,$AB,$D1,$86,$99,$EF,$C3,$4C,$D7,$4C,$D6,$EC,$D6,$E8,$5C,$BD,$6B,$77,$F4,$AF,$3D,$93,$CA,$1F,$AC,$29,$2E,$BF,$DB,$17,$53,$EF,$5E,$62,$8D,$E6,$F3,$2B,$9A, $C,$B9,$7E,$DC,$B1,$D5,$FB,$51,$D3,$C5,$FD,$8F,$FD,$6E,$85,$C3,$9F,$3C,$34,$E9,$58,$E6,$FB,$B5,$EF; 7488
		dc.b $E8,$FC,$FB,$72,$29,$37,$E6,$39,$E5,$B3,$A3,$4E,$9D,$9A,$66,$F8,$E6,$BC,$D2,$5B,$A1,$72,$F5,$AD,$DC,$FA,$B4,$BF,$9B,$70,$5D,$56,$D4,$BD,$50,$F0,$E4,$5F,$A9,$93,$F5,$43,$A7,$F6,$70,$FD,$D7,$EE,$43,$FF,$95,$FA,$BA,$32,$99,$5C,$AC,$A6,$A7,$9F,$ED,$FF,$3E,$B2; 7552
		dc.b $FD,$46,$9F,$A9,$ED,$E4,  0,$7E,$BB,$6B,$87,$7C,$EF,$EA,$2D,$6B,$FB,$A2,$D6,$FD,$D0,$D4,$BB,$97,$22,$D5,$4C,$80,$2E,$A7,$F5,$6E,$BB,$BF,$59,$1F,$77,$7F,$56,$EF,$D6,$16,$56,$C8,$2E,$AD,$7F,$9B,$2D,$7F,$9B,$8D,$71,$DC,$7D,$C5,$9E,$2B,$2A,$DE,$B9,$A2,$9F,$87; 7616
		dc.b $7F,$52,$44,$B5,$16,$5D,$F1,$4D,$D2,$C9,$E6,$4C,$F9,$23,$FA,$6A,$F9,$15,$FD,$7A,$1D,$71,$FC,$F9,$63,$FA,$8D,$37,$78,$76,$F2,$9F,$E6,$E1,$F9,$BC,$4B,$5F,$E6,$E1,$B8,$FF,$6E,$52,$32,$65,$95,$50,$C9,$89,$A8,$C5,$19,$12,$46,$EA,$A3,$1C,$51,$E7, $E,$62,$EE,$37; 7680
		dc.b $B1,$7E,$60,$B1,$DF,$F9,$8D,$1B,$F3,$1C,$F9,$F4,$69,$D2,$B1,$CD,$F7,$6C,$FC,$FF,$53,$72,$65,$EC,$E7,$2F,$CC,$69,$D3,$D1,$A6,$6F,$8E,$6B,$CD,$25,$BA,$17,$2F,$5A,$DD,$CF,$DF,$86,$FD,$7D,$1F,$9B,$26,$9B,$2C,$89,  8,$F3,$AA,$46,$E2,$BE,$1F,$9F,$79,$FE,$7F,$45; 7744
		dc.b $C3,$7E,$99,$F0,$D3,$35,$C3,$7F,$67,$E7,$F1,$35,$6F,$CC,$68,$BB,$FA,$34,$CF,$F3,$FA,$66,$BA,$66,$B7,$66,$B7,$42,$E5,$EB,$5B,$B4,$81,$96,$97,$3E,$E2,$D3,$99,$4D,$79,$EE,$2E,$65,$D0,$DF,$CC,$51,$9D,$C3,$FD,$5A,$BA,$D7, $D,$8B,$F9,$FC,$32,$D3,$F3,$FC,$FD,$3A; 7808
		dc.b $74,$BF,$37,$F3,$2F,$33,$EE,$7F,$37,$E9,$B6,$C9,$79,$FA,$57,$A5,$F7,$3F,$99,$79,$9F,$73,$F9,$B4,$E6,$E7,$23,$E7,$2E,$62,$EB, $B,$96,$EF,$EC,$93,$7F, $C,$A5, $B,$F3,$82,$14,$B9,$73,$12,$6C,$E1,$FA,$FC,$32,$E7,$DF,$FA,$EF,$DE,$11,$BF,$99,$88,$F9,$43,$15,$C7; 7872
		dc.b $7F,$4F,$EE,$23,$FA,$DF,$D9,$4B,$9F,$F6,$A5,$D3,  3,$FD,$AB,$CF,$F6,$A3,$FE,$23,$FE,$3F,$F2,$FF,$88, $B,$95,$B2,$86,$AB,$6A,$7E,$4F,$FD,$4E,$45,$FA,$A7,$E6,$FB,$DF,$FC,$AF,$D4,$8B,$6B,$7E,$EF,$D5,$17,$EA,$CA,$E5,$EE,$7D,$CF,$FD,$B9,$74,$C1,$A3,$7F,$2E,$92; 7936
		dc.b $37,$A1,$6C,$2D,$FF,$BE,$D9,$1D,$FF,$D2,$94,$7F,$AA,$52,$99,$97,$F4,$48,$E6,$7F,$E6,$67,$FF,$CB,$FE,$A3,$FE,$23,$FE,$3F,$C2,$E3,$FC,$12,$D5, $D,$CB,$A8,$B2,$5D,$D0,$C8, $B,$7E,$AF,$AB,$F5,$8F,$32,$AF,$87,$EC,$AA,$5D,$57,$AC,$AE,$7F,$15,$B9,$4C,$B1,$53,$C3; 8000
		dc.b $7E,$1F,$98,$FD,$7F,$FC,$BF,$EA,$FF,$DF,$FE,$E3,$35,$EE,$7C,$A0,$C9,$99,$7E,$E3, $F,$D4,$7F,$CB,$FE,$A3,$AF,$8E,$BD,$DF,$AE,$FD,$52,$E7, $E,$25,$5E,$67,$A4,$39,$97,$B9,$E6,$5F,$98,$2F,$DF,$E1,$A6,$BF,$E1,$6B,$E5,$FA,$DF,  2,$F0,$26,$2B,$B3,$26,$7B,$2C,$97; 8064
		dc.b $B9,$26,$C4,$92,$2F,$DC,$70,$FC,$C7,$FC,$BF,$6B,$FB,$64,$FD,$CF,$EE,$8A,$E4,$7D,$D3,$BA,$1D,$6F,$35,$FD,$B9,$96,$30,$FC,$FF,$F6,$1D,$C1,$DB,$FF,$30,$ED,$D7,$6E,$65,$C9,$EC,$F9,$77,$2E,$65,$8B,$E4,$AD,$1F,$DA,$DF,$D1,$FC,$DE,$1F,$F2,$FD,$57,$E7,$F6,$78,$57; 8128
		dc.b $38,$A1,$AA,$12,$1A,$DD,$79,$73,$63,$79,$5C,$58,$E9,$76,$1F,$EF,$FF,$97,$ED,$7F,$6D,$FB,$32,$DD, $D,$4B,$B9,$72,$2D,$54,$C8,  2,$EF,$DD,$E1,$FA,$95,$6C,$E7,$CF,$FB,$56,$9C,$8B,$BB,$3A,$A3,$2D,$6F,$23,$C4,$B9,$70,$FD,$7F,$EA,$3F,$E5,$FF,$57,$EB,$D5,$D5,$FA; 8192
		dc.b $9E,$85,$BD,$E6,$85,$CD,$FA,$6B,$89,$B7,$FE,$A3,$F5,$FD,$1F,$F2,$FF,$A8,$EB,$FD,$9F,$EC,$8B,$2B,$64,$17,$52,$EA,$A7,$79,$7E,$E4,$AF,$89,$5F,$A7,$26,$45,$BB,$12,$FE,$57,$E6,$F2,$B6,$4F,$FC,$DF,$81,$7E,$A9,$59,$F7,$3F,$13,$2F,$E3,$C7,$1F,$E2,$BF,$35,$BF,$B8; 8256
		dc.b $B3,$E4,$6A,$CB,$2E,$8A,$FE,$BF,$F3,$1B,$23,$D1,$FD,$29,$47,$FA,$A5,$29,$99,$7F,$44,$8E,$67,$FB,$2C,$3F,$37,$AF,$F5,$9A,$A4,$A9,$D2,$5C,$4F,$3A,$1A,$E7,$5B,$D7,$F6,$A4,$85,$22,$BF,$B3,$87,$67, $F,$D9,$6C,$E1,$BF,$F7,$A8,$75,$FE,$39,$96,$2F,$91,$AB,$3F,$63; 8320
		dc.b $FF,$71,$1C,$3F,$3F,$FB,$29,$73,$FE,$D4,$BA,$60,$7D,$1F,$BF,$EA,$D5,$1C,$F9,$76,$6F,$24,$D9,$C3,$9F,$66,$1C,$FD,$3A,$74,$BF,$37,$F3,$2F,$33,$EE,$7F,$37,$1B,$8B,$AC,$B9,$EE,$5E,$62,$D2,$9C,$C0,  1,$FF,$2E,$B8,$7E,$CB,$FC,$25,$FB,$27,$FF,  4,  1,$CF,$FC,$37; 8384
		dc.b $FF,$C6,$9C,$FF,$F1,$FE,$13,$FF,$82,  7,$FC,$FA,$C7,$FC,$61,$FB,$2F,$F8,$FE,$CA,$17,  3,$2F,$F1,$C4,$7F,$C4,$7F,$C7,$FE,$40,$7F,$DF,$FE,$A3,$FE,$23,$FE,$3F,$F2,  8,$48,$48,$48,$5F,$F3,$FF,$9F,$FC,$FF,$E7,$FF,$3F,$F9,$FF,$CF,$FE,$7F,$F3,$42,$E2,$5C,$4B,$89; 8448
		dc.b $71,$24,$24,$24,$54,$24,$24,$24,$24,$24,$24,$24,$54,$7A,$16,$75,$E9,$AC,$80,$7C,$6B,$48,$CE,$24,$8E,$AC,$11,$5D,$52,$8C,$F9,$EE,$D1,$C9,$48,$EC,$A4,$76,$61,  8,$EC,$A4,$76,$16, $F,$8E,$CA,$47,$62,$E0,$FD,$8B,$84,$3F,$5C,$5C,$78,$53,$62,$E0,$FD,$85,$82,$E0; 8512
		dc.b $5B,$38,$3F,  4,$C2,$18,$25,$30,  9,$3C,$3B,$12,$98,$51,$30,$14,$41,$34,$13,$4A,$6C,$49,$A0,$BC,$5E,$12,$77,$C2,$F8,$5E,$F7,$5E,$4E,$E7,$AA,$B8,$AA,$2A,$F7,$42,$A2,$AE,$15,$B7,$E9,$A1,$57,$69,$DB,$67,$72,$88,$7B,$AA,$B5,$88,$27,$56,$15,$88,$87,$E9,$8A,$AB; 8576
		dc.b $50,  0,  0,$3E,$3F,$A6,$86,$C6,$74,$37,$AA,$33,$AC,$85,$BC,$4F,$7D,$11,$A8,$CE,$2F,$DC,$9F,$E9,$84,$EB,$16,$72,$D6,$2C,$84,$8E,$27,$6C,$E0,$8C,$E2,$8E,$AE, $E,$85,$5A,$D5,$6F,$DB,$3E,$A0,  0,$27,$53,$7F,$23,$68,$72,$E6,  0,$2D,$4E,$AF,$A9,$B2,$3A,$AA,$C4; 8640
		dc.b $8A,$EA,$AA,$41,$D5,$38,$ED,$E2,$D5,$8E,$2F,$46,$48,$24,$D0,$A3,$FB,$E6,$74,$4B,$F5,$DA,$97,$92,$B4,$DA,$69,$FD,$4A,$D3,$4A,$AF,$39,$55,$B4,$83,$61,$4A,$E1,$4A,$B2,$F2,$57,$60,$58,$2F,$2D,$9C,  9,$BB,$70,$7A,  1,$36,$9B,$14,$60,$CF,$8A,$B5,$23,$4B,$AA,$EA; 8704
		dc.b $32,$D5,$ED, $A,$8A,$8A,$80,$29,$FA,$6A,$72,$15,  2,$A2,$B0,$A9,$AD,$4A,$A6,$C5,$FA,$62,$AD,$CC,$2A,$39,$5A,$AD,$57,$D4,$D9,$1D,$55,$62,$45,$75,$55,$20,$E5,$E2,$51,$74,$E3,$C8,$4E,$20,$44, $F,$DB,$F3,$A4,$F7,$97,$27,$EF,$C1,$FC,$B7,$CF,$79,$61, $D,$F4,$8E; 8768
		dc.b $F5,$C1,$FB,$17,  9,$E1,$6C,  7,  1,$C0,$61,$3E,$10,$E1, $E, $F,$4E,  4,$8C,$A8,$A8,$4E,$6B,$39,$95,$20,$E6,$B3,$92,$3F,$C4,$7D,$68,$EA,$D9,$8F,$F6,$F6,$4D,$AC,$1E,$8E,$57,$30,$24,$74,$1C,$C2,$1B,$63,$57,$2B,$96,$A5,$50,$2A,  5,$61,$50, $B,$93,$A9,$C8,$54; 8832
		dc.b  $A,$D3,$12,$AA,$E3, $B,$A1,$CA,$EE,$E9,$E2,$55,$53,$68,$54,$E9,$8C,$1A,$CD,  3,$A3,$11,$C2,$4D,$39,$50,$E0,$6A,$70,$30,  8,$D4,$E0,$65,$23,$9C,$83,$E5,$69,  2,$94, $D,$65,  3,  4,$D6,$67,$FE,$9A,$46,$AC,$A8,$4E,$32,$6A,$38,$D5,$20,$E3,$B3,$92,$3F,$C4,$7D; 8896
		dc.b $68,$EA,$CF,$91,$3B,$F4,$D1,$7A,$72,$81,$BF,$90,$23,$13,$39,$D6,$9C,$8B,$AE,$A0,$2F,$E9,$9F,$58,$B9,$6A,$AE,$7F,$25,$72,$D6,$15,$75,$AA,$EB,$54,  0,  5,$A3,$4D,$27,$CE,  0,$7C,$69,$A3,$AA,$F8,$93,$96,$AF,$74,$2A,$51,$FD,$37,$6C,$4A,$BA,$3D,$D1,$74,$1D,$37; 8960
		dc.b $15,$61,$1E,$50,$8C,$E3,$38,$CD,$DF,$D6,$9F,$27,$FE,$99,$5B,$94,$1A,$6D,$36,$9E,$34,$62,$67,$DD,$CB,$A7,$A2,$B4,$D8,$B5,$7E,$C2,$C1,$6A,$5B,$38,$42,$B8,  7,$9D,$8E,$D2,$7F,$ED,$E4,$FB,$A8,$6B,$73,$CC,  2,$35,$38,$19,$48,$E7,$2E,$BF,$DB,$89,$D6,$37,$2D,$62; 9024
		dc.b $C8,$A6,$4E,$D9,$C1,$E7,$2D,$5C,$20,$C6,$D4,$62,$36,$FF,$2D,$69,$A3,$F9,$D5,$B4,$83,$4D,$A6,$CF,$E4,$58,$D1,$89,$9F,$73,$CE,$C7,  3,$B1,$82,$6B,$34,$E5,$69,  7,$B3,$CD,$EC,$F3,$A1,$D8,$E0,$D6,$68,$1D,$18,$8E,$8C,$BF,$B6, $A,$76,$38,$34,$DA,$6D,$49,$34,$E5; 9088
		dc.b  $E,$E9,$7E,$D9,$F2,$C6, $C,$6B,$8B,$CE,$8C,$1E,$6B,$58,$19,$48,$E7,$9D,$A4,$B5,$53,$7D,$70,$E4,$6F,$C1,$FC,$8A,$B6,$C2,$75,$A2,$36,$10,$67,$17,$EE,$2B,$CD,$46,$B3,  1,$36,$B6,$5B,$97,$59,$6A,$2F,$CD,$EA,$DD,$AC,$B5,$3F,$56,$E0,$20,$D6,$6A,$34,$19,$59,$77; 9152
		dc.b $13,$6A,$2D,$DA,$CA,$2C,$B9,$35,$77,$16,$ED,$42,$C8,$16,$44,$C0,$3D,  4,$A1,$20,  2,$A2,$C8,$4E,$45,$7B,$D2,$95,$43,$91,$54,$EA,$15,$9E,$C1,$52,$72, $B,$25,$90,$A2,$52,$42,$88,$15, $A,$45,$20,$46,$FB,$C2,$9F,$15,$43,  6,$48,$10,$15,$C0,$9A,$E0,  8,$C2,$B5; 9216
		dc.b $31, $F,$60,$74,$61,$4A,$B7,$22,$3A,$C8,  0,$4D,$72,$98,$23,$9A,  5,$C4,$52,$4F,$36,  4,$CF,$61,$39,$13,$11,$82,$91,$49,$95,$84,$96,$40,$30,$84,$9F,$20,  1,$49,$E8,  2,$C9,$50,$11,$BD,  4,$90,$A2,$59,$98,$59,  4,$84,$A1,$22,$60,  1,$24,$24,  4,$A8,$93,$94; 9280
		dc.b $CE,$68,$F4,  4,$85,$52,$97,$1A,$24,$24,  4, $C,$19,$22,$98,$79,$AC,$89,$18,$31,$19,$20,$83,$3D,$8C,$3D,$88,$D6,$42,$AD,$52,$8E,$E3,$42,$C9,$FB,$1F,$91,$64,$9B,$17,$62,$E4,$5B,$17,$63,$77,$AE,$C2,$D5,$BC,$F5,$C4,$F6,$29,$EB,$54,$2D,$87,$AE,$11,$C1,$3F,$53; 9344
		dc.b $FA,$FC,$2C,$D5,$A3,$13,$55,$5A,$2F,$6B,$8A,$42,$6D,$66,$7F,$5F,$ED,$E9,$DD,$55,$36,$85,$4E,$98,$C1,$AC,$D0,$3A,$31,$1D,$19,$E7,$63,$81,$D8,$C1,$35,$9A,$72,$5C,$DF,$D3,$7C,$33,$A9,$BC,$DE,$CF,$3A,$1D,$AE,$7B,$14,$AA,$D2,$56,$24,$24,$29,$41,$1F,$25,$49,$2D; 9408
		dc.b $FC,$8A,$57,$BF,$8C,$12,$68,$51,$FD,$F3,$3A,$25,$FA,$ED,$4B,$C9,$5A,$6D,$3A,$FF,$45,$9E,$6B,$D1,  3,$2E,$8C,$14,$D7,$A2,  6,$5D,  5,$84,$3A,$27,$D0,$B8,$3F,$A1,$70,$86,$CF,$CC,$7E,$DB,  9,$53,$A2,  6,$5D,  5,$83,$CF,$A3,$85,$30, $F,$3B,$1D,$A4,$FF,$DB,$46; 9472
		dc.b $DB,$FA,  7,$45,$B0,$95,$30,$45,$35,$C2,  6,$52,$24,$A4,$AB,$D3,$69,$5A,$4F,$95,$25,$54,$53,$29,$6C,$E0,$A6,$52,$D5,$C2, $C,$6D,$46,$23,$6A,$F4,$91,$91,$A4, $C,  9,$B3,$E2,$F6,$84,$44,$40,$D8,$64,$6F,$DE,$4C,$76,$C4,$CB,$7D,$18,$6F,$A2,$35,$19,$C5,$FB,$8A; 9536
		dc.b $F3,$3E,$56,$94, $E,$12,$57,$5C,$B2,$A1,$C1,$CF,$C4,$62,$EE,$6F,$DB,$49,$6A,$CE,$85,$70,$24,$67,$2E,$10,$42,$AD,$B0,$9D,$68,$8D,$84,$19,$C5,$FB,$F3,$FD,$34,$F1,$A3,$4D,$A7,$15,$65,$D1,$C6,$4C,$51,$27,$29,$BD,$D0,$32,$4E,$EE,$D6,$AD,$22,$C5,$57,$C5,$9F,$52; 9600
		dc.b $8B,$52,$AC, $D,$4E,  6,$52,$39,$CB,$AF,$F6,$E2,$75,$8D,$CB,$58,$B2,$41,$DB,$38,$2D,$D2,$D5,$C2, $C,$6D,$46,$23,$6D,$7B,$B5,$EE,$D5,$D5,$B8,$41,  4,$18,$C2,$9D,$18,$40,$DE,$61,$4C,$A4,  2,$E2,$15,$A8,$60,$AA,$87,$BA,$55,$E6,$5C,$28,$65,$82,$EC,$5C,$8B,$66; 9664
		dc.b $B8,$EC,$5C,$8B,$52,$DC,$85,$A8,$B7,$12,$2A, $F,$CD,$BD,$39,$EE,$E7,$30,$64,$8F,$D9,$91,$6C,$24,$5D,$99,$16,$C7,$DC,$FD,$8B,$92,$E4,$79,$2B,$BA, $B,$71,$65,$DE,$A6,$C7,$B3,$A3,$BF,$58,$2C,$9F,$B0,$B0,$2C,$9F,$B0,$B0,$26,$BB,$22,$37,$E4,$59,$6C,$2D,$66,$59; 9728
		dc.b $16,$5B,$3A,$1F,$91,$65,$A8,$8D,$15,$8B,$57,$E6,$17,$71,$64,$59,$44,$9D,$B9,$B2,$3D,$CF,$DF,$92,$BA,$1B,$D9,$26,$E0,$1F,$CF,$FA,$B2,$89,$96,$A5,$DC,$51,$2D,$4B,$B9,$FD, $A,$73,$3D,$65,$AD,$E7,$AC,$B5,$BC,$FF,$54,$5A,$D7,$A9,$75,$BE,$3A,$BF,$30,$9A,$1C,$53; 9792
		dc.b $45,$D9,$44,$8E,$CB,$44,$18,  3,$2F,$F5,$15,$45,$45,$45,$45,$45,$47,$FD,$AA,  0,  0, $F,$FB,  0,  0,  3,$FE,$D6,$CA,$79,$4F,$29,$E5,$3C,$A7,$94,$F2,$9A,$7F,$BC,  0,  0,$16,$49,$A6,$54,$4C,$A8,$99,$51,$32,$A2,$65,$44,$CA,$89,$95,$BF,$99,$8B,$FF,$57, $D,$D6; 9856
		dc.b $DC,$37, $D,$C3,$70,$DC,$58,$D3,$72,$F7,  6,$B3,$4D,$A6,$D3,$69,$B4,$DA,$7B,$A7,$BA,$7B,$A7,$BA,$7B,$A7,$BA,$7B,$A7,$BA,$DE,$1F,$DB,$5C,$46,$23,$10,  0,$FF,$B8,  3,$11,$88,$C4,$31,$7F,$9C,$3F,$F6,$EB,$8C,$3B,$A6,$C4,$D0,$67,$B2,$B5,$31,$10,$DD,$34,$2D,$D4; 9920
		dc.b $4E,$82,$DD, $B,$D7,$73,$EF,$DC,$BB,$97,$8B,$F7,$17,$1E,$87,$EE,$24,$24,$FD,$D8,  2,$7B,$61,$B6,$1B,$61,$B6,$6C,$E6,$77,$EF,$FF,$67,$B9,$FF,$C3,$7F,$F0,$FA,$17,$FA,$6B,$FD,$3D,$C5,$FE,$32,$FF,$1F,$43,$99,$CC,$E6,$73,  0,$27,$F9,$88,$7E,$62,$1F,$98,$87,$E6; 9984
		dc.b $27,$FD,$CF,$CC,$43,$6C,$36,$C3,$68,  0,$4E,$5F,$EF,$2D,$63,$58,$D6,$35,$8D,$63,$58,$D7,$FD,$5E,$C8,$7E,$62,$1F,$98,$87,$E6,  0,  2,$7D,$1F,$ED,$DD,$2B,$6E,$95,$B7,$4A,$DB,$A5,$6D,$D2,$B6,$E9,$5B,$74,$BF,$D0,$80,  9,$DF, $B,$E1,$7C,$2F,$9F,$F4,$E7,$7C,$2F; 10048
		dc.b $85,$E0,  1,$3F,$FA,$18,$30,$60,$C1,$83,  6,$5F,$E5,$75,$9A,$6C,$94,$6B,$E0,$DC,$5E,$DF,$B3,$56,$FE,$19,$37,$F4,$DB,$FE,$7F,$F3,$2E,$25,$C4,$B8,$97,$12,$42,$42,$45,$42,$42,$42,$42,$42,$42,$42,$45,$47,$A2,$A6,$5F,$AF,$CB,$7D,$F9,$6F,$82,$15,$FF,$9F,$54,$2E; 10112
		dc.b $25,$96,$F4,$24,$24,$24,$54,$24,$24,$24,$24,$24,$24,$24,$54,$7A,$3D,$1E,$84,$8F,$47,$A3,$D2,$88,$F4,$7A,$3D,  0,$16,$D1,$17,$9D,$50,$A3,$63,$B2,$44,$44,$44,$44,$BF,$DF,$B0,  1,$F9,$FB,$26,$FC,$A8,$84,$9F,$9F,$82,$3F,$2D,$FE,$1B,$FF,$59,$BF,$2B,$65,$3C,$92; 10176
		dc.b $99,$5F, $C,$89,$21,$BC,$90,$91,$72,$42,$42,$42,$C9,$1E,$85,$B9,$91,$E8,$FE,$E0,$D6,$69,$B4,$DA,$6D,$36,$9F,$47,$FB,$F2,$B2,$6F,$9A,$16,$54,$42,$4D,$F4,$42,$4D,$F0,$42,$42,$DF,  4,$7E,$45,$E1,$BF,$F5,$9B,$D0,$5B,$70,$9E,$E6,$B2,$53,$73,$24,$D2,$9B,$99,  4; 10240
		dc.b $37,$30,$A6,$E6,$14,$DC,$C2,$92,$6B,$6A,$9E,  5,$A8,$6A,$83,$60,$BA,$86,$A7,$B6, $F,$D4,$35,$2B,$7F,$24,  1,$3C,$61,$8C,$31,$86,$33,$FE,$BC,$F1,$86,$30,$C4,  0,$26,$EF,$F3,$92,  4,  8,$10,$20,$41,$FE,$3B,$9F,$CF,  8,$DA,$22,$22,$22,$22,$25,$7D,$22,$BC,$42; 10304
		dc.b $59,$26,$93,$49,$A4,$D2,$68,  1,$69,$7A,$E9, $B,$E3,$34,$28,$C1,$1F,$15,$4A,$45,  0,$56,$9B,$4D,$A6,$D3,$69,$B4,$DA,$D8,$97,$EF,$83,$DB,  1,$66,$C0,$59,$B0,  5,$FD,$72,$C0,  1,$6C,$29,$C2,$1C,$21,$C2,$78,$4F,$1E,$13,$C7,$84,$F1,$E1,$3C,$40,$1F,$E7,$D5,$4E; 10368
		dc.b $10,$E1, $E,$14,$C0,  1,$6F,$FD,$30,$60,$C1,$83,  6, $C,$5F,$ED,$D6,  0,$E1,$3C,$78,$4F,$1E,$13,$C7,$87,$F5,$2F,$B3,$A6,$E9,$BA,$6E,$9B,$A6,$E9,$BA,$CE,$1D,$A1,$D6,$74,$DD,$37,$4D,$D3,$74,$DC,  0,$14,$8B,$3E,$2D,$1C,$D6,$3F,$C5,$D3,$FA,$BA,$34,$5A,$2D,$10; 10432
		dc.b   3,$5B,$12,$68,$7F,$1D,$FF,$D7,$26,$89,$44,$A2,$51,$28,$FF,$94,$A3,$FD,$55,$8F,$F1,$5F,$1F,$DA,$C2,$3D,$34,$8E,$73,$8C,$89,$89,$89,$8A,$5F,$F7,$FF,$BF,$FD,$FF,$EF,$FD,$72,$FE,$BB,$F1,$26,$83,$17,$EE,$57,$BE,$1F,$A9,$9E,$A2,$D5, $D,$4F,$D4,$BA,$A9,$DE,  3; 10496
		dc.b $D8,$13,$13,$3F,$FA,$EB,$FD,$75,$FE,$3B,$FF,$6F, $E,$EA,$63,$39,  2,$89,$45,$FF,$D2,$5F,$E9,$2F,$F0,$9F,$FB,$28,$73,$D3,$49,$B8,$AA,$55,$2A,$97,$FD,$BF,$ED,$FF,$6E,$4D,$FC,$63,$62,$6A,$B7,$23,$5E,$EF,$D3,$19,$63,$FC,$63,$2F,$E3,$31,$91,$D4,$F9,$32,$F3,$7E; 10560
		dc.b $99,$8A,$EF,$E3,$31,$FF,$DB,$FE,$DF,$F6,$FD,$31,$54,$AA,$55,$2A,$80,$15,$A9,$89,$31,$32,$B2,$F7,$3D,$8B,$17,$D4,$8D,$AA,$55,$2F,$FB,$7F,$DB,$FE,$DF,$F6,$FF,$B7,$FD,$BF,$EC,$55,$23,$2A,$95,$4B,$12,$62,$65,$65,$EE,$7B,$16,$34,$C4,  0,$FA,$95,$4A,$A5,$DF,$FA; 10624
		dc.b $6D,$5B,$F5,$2F,$2D,$54,$E5,$AA,$9F,$A6,$D5, $F,$DB,$6A,$7F,$F1,$B5,$2F,$F5,$B5,$16,$AF,$EB,$6A,$2A,$EF,$AE,$FF,$D3,$7F,$7F,$97,$F7,$F9,$7F,$3F,$F4,$DF,$BF,$FD,$B7,$EB,$FF,$8D,$F9,$FF,$EB,$6F,$2A,$95,$4A,$A0,  7,$9D,$2E,$23,$23,$53,$5E,$67,$99,$5D,$43,$9D; 10688
		dc.b $C4,$64,$6A,$6B,$CC,$F3,$2B,$A9,$70,  1,$FD,$7F,$B6,  9,$67,$24,$EA,$E4,$9D,$5C,$8F,$AA,$D5,$CB,$58,$54,$AA,$BF,$C6,$9D,$67,$59,$D6,$75,  0,  8,$73,$50,$C1,$83,  0,  3,$E7,$EB,$41,$34,$9A,$69,  4,$8A,$C5,$52,$30,$89,$46,$71,$87,$F9,$F5,$4F,  9,$53,  9,$53; 10752
		dc.b   9,$53,  9,$53,  9,$53,  9,$53,  9,$4F, $F,$DD,$9C,$F0,$39,$B8,$4F,  3,$9B,$84,$F0,$39,$BA, $D,$36,$42,$C0,$D5,$91,$5C,$AC,$94,$64,$7E,  6,$C9,  7,$32,$52,$A9,$3C,$BF,$7F,$2D,$B4,$75,$B0,$31,$67,$5B,  3,$16,$77,$57,$F2,$F3,$75,$D3,$DB,$74,$F6,$DD,$3D,$A0; 10816
		dc.b  $A,$FF,$95,$A3,$66,$8D,$9A,$36,$68,$D9,$A3,$66,$8D,$9A,$27,$36,  0,$4F,$6C,$3F,$68,$BF,$B4,$7F,$6C, $D,$C0,  9,$ED,$9F,$ED,$27,$FB,$49,$FE,$D1,$BF,$87,$88,  2,$7B,$61,$B7,$15,$DB,$8B,$DD,$8C,$3B,$FF,$7D,$DF, $C,$75,$E0,$B8,$F5,$3B,$BB,$AA,$1D,$4F,$73, $A; 10880
		dc.b $39,$82,$B9,$EE,$E3,$B6,$DB,$6D,$B4,$3A,$7D,$B6,$DB,$6D,$AF,$77,$16, $A,$E6,$14,$73,$3F,$18,$63,$DB,$DD,$B5,$ED,$B6,$1D,$FB,$35,$89,$B6,$B1,$46,$D6,$FD,$B0,$FD,$A3,$6B,$FD,$A2,$E1,$DB,$47,  0,  4,$36,$C3,$F6,$8B,$FB,$47,$F6,$C2,$55,$FE,$95,$52,$D5,$4B,$55; 10944
		dc.b $2D,$54,$B5,$52,$D5,$4B,$55,$3F,$CA,$96,$39,$9C,$CE,$67,$33,$99,$CC,$E7,$2F,$F2,$59,$A6,$D3,$69,$B4,$DA,$6D,$36,$B7,$F8,$D9,$D6,$67,$59,$9D,$66,$75,$99,$D6,$67,$59,$9D,$AB,$FB,$5B,$3F,$E3,$54,$38,$19,$1C,$4D,$6E,$53,$89,$5C,$AC,$46,$87,  6,$23,$42,$42,$62; 11008
		dc.b $62,$34,$8B,$93,$6A,$46,$F2,$E6,$8A,$15,$CA,$85,$79,$AA,$15,$E6,$A8,$57,$99,$32,$15,$E6,$4C,$B7,$99,$32,$DE,$64,$CA,$6E,$A9,$31,$62,$E5,$C4,$98,$DC,$46,$58,$D5,$91,$4D,$59,$20,$D5,$48,$72,$4A,$55,$26,$93,$3E,$2A,$98,$F2,$38,$C8,$CA,$E2,$6A,$C0,$CA,$E6,$53; 11072
		dc.b $2B,$98,$AE,$2B,$98,$8D,$6E,$62,$35,$B9,$88,$D5,$1A,$B7,$3D, $F,$FC,$C6,$51,$EB,$89,$34,$51,$6F,$56,$89,$5E,$A6,$4C,$69,  3,$26,$32,$32,$32,$32,$63,$8B,$11,$91,$95,$59,$CC,$65,$73,$E5,$5B,$89,$1F,$25,$4A,$44,$ED,$A5,$A2,  8,$EC,$6F,$BF,$9C,$D5,  8,$C3,$CD; 11136
		dc.b $50,$8C,$3C,$D5,  8,$C3,$CD,$50,$50,$D5,  5, $C,  3,  4,$71,$4D,$2F,$72,$DC,$46,$CE,$24,$2B,$AB,$27,$A2,$CA,$87,$1A,$69,$38,$8A,$5D,$FD,$85,$FD,$C8,$24,$A6,  8,$E8,$61,$27,$43,  3,$91,$60,$B8,$5C,$58,$3E,$E2,$C1,$7B,$EA,$4E,$D7,$C0,$AF,$ED,$54,$ED,$2F,$D7; 11200
		dc.b $38,$BF,$5C,$FE,  0, $B,$61,$BF, $A,$5C,$30,$86,$16,$91,$8C,$28,$62,$CE,$2F,$DF,$77,$CF,$1F,$D7,$76,$D3,$F5,$5B,$67,$D4,  0,$6B,$60,$D3,$6C,$1A,$6D,$83,$41,$C4,$D8,$33,$F5,$B8,$9B,  6,$7E,$B7,$5B,$5B,$9B,  6,$86,$B7,  6,$D6,$D0,$D6,$4E,$1A,$E6,$D3,$C0,$9C; 11264
		dc.b   0,  2,$9A,$AC,$C4,$E9,$A6,$B8,$60,$AD,$44,$75,$30,$D9,$A8,  1,$6D,$58,$2F,$7F,  6,$4E,$1D,$D7,$BB,$F6,$E5,$B4,$BF,$52,$DB,$70,$D4,$B8,$21,$39,$97,  5,$76, $B,$81,$23,$B0,$65,$BD,$D8,$34,$1D,$85,$35,$E0,$AC,$FC,$3A,$97,$BB,$57,$67,$F1,$C0,$1D,$F3,$C7,$F5; 11328
		dc.b $2F,$91,$32,$F7,$E0,$7B,$7F,$8F,$FA,$AF,$DF,$6A,$9B,$6A,$A3,$60,$D0,$6C,$1A, $D,$83,$13,$95,$B0,$62,$76,$BA,$3B,$5A,$B6, $C,$ED,$6A,$CF,$77,$EF,$B5,$35,$18,$BB,$7F,$5D,$B7,$F5,$4F,$EA,  0,$4F,$86,$BC,$3B,$E0,$E2,$BF,$5E,$AF,$D7,$17,$6A,$3F,$F5,$C4,$E9,$F0; 11392
		dc.b   0,$3E,$55,$E3,$B0,$A4,$92,$53,$8E,$C4,$92,$99,$1C,$7A,$14,$DF,$76,$C3,$53,$C0,$AE,$C8,$8D,$70,$2B,$B2,$28,$AE,  5,$74,$4D,$FC,$37,$98,$94,$E5,$4C,$EF,$7C,$89,$33,$2C,$EF,$92,$CA,$FC,$D4,$D0,$A4,$B7,$15,$5B,$86,$CE,$74,$7A,$60,$F4,$C9,$F8,$3D,$32,$24,$2C; 11456
		dc.b   8,$C9,$32,$2B,$C8,$DF,$92,$99,$5E,$BE,  4,$8F,$FD,$60,  0,$15,$80,  5,$14,$13,  2,$26,$39,$36,$37,$58,$F8,$76,$38,$81,  3,  0,$13,  3,$26,$2D,$36,$3A,$47,$78,$68,$FA,$75,$19,$82,  3,  1,$14,  9,$25,$15,$36,$3B,$45,$18,$57,$7A,$83,  5,$1A,$16,$2C,$25,$17; 11520
		dc.b $84,  4,  8,$16,$36,$27,$79,$47,$7B,$58,$F9,$FF,$CF,$3E,$37,$EB,$7E,$B9,$B6,$55,$B3,$CD,$A7,$9B,$4A,$CF,$8E,$C5,$5A,$23,$84,$C8,$43,  3, $E,$B6,  9,$A3,$28,$1A,  9,$40,$B2,$84,$89,$40,$E8,$11,$41,$30, $A,  7,$44,$14,$2A, $A,$18,$81,$51,$B5,$6D,$89,$F1,$A3; 11584
		dc.b $FD,$13,$F4,$7E,$8E,$7E,$BD,$3F,$F9,$73,$8F,$89,$EB,$7F,$E8,$AC,$FF,$44,$BF,$F0,$3F,$82,$FF,$81,$2F,$7A,$BD,$EA,$F7,$96,$82,$97,$4F,$A3,$9C,$E7,$39,$CE,$5A,$2E,$84,$29,$72,$11,$B4,$84,$6D,$2E,$92,$E4,$22,$2A,$11,$15,  8,$E7,$C7,$62,$AD,$11,$C2,$64,$21,$81; 11648
		dc.b $87,$5D,$84,$D1,$94, $D,  4,$A0,$59,$42,$44,$A0,$60,$11,$41,$30, $A,  6,  8,$28,$54,$14,$31,  3,$BD,$BD,$47,$F8,$A3,$FE,$58,$B3,$17,$EE,$F1,$DD,$9B,$57,$AF,$56,$FA,$7F,$E2,$16,$60,$5F,$11,$7E,$F6,$B3,$BC,$F3,$E3,$7E,$B7,$EB,$9B,$4C,$2B,$4C,$73,$6C,$73,$6C; 11712
		dc.b $2C,$F8,$3E,$41,$F2,$16,$DC,$26,$42,  7,$55,  6,$2F,$37,$D8,$D9,$47,  8,$6A,$80,$C2,$10,$E1, $B,  1,$84,$36,  6,$28,$35,$B0,$84,$35,$1A,$10,$86,$A3,$42,$10,$BC,$6A, $F,$EC,$F6,$FE,$9C,$7F, $F,$CD,$FF,$69,$7F,$77,$F7,$67,$CD,$9F,$3E,$9F,$9C,$73,$E6,$7E,$36; 11776
		dc.b $EB,$79,$E9,$62,$DF,$F1,$3F,$F0,$3F,$82,$FF,$81,$2F,$78,$97,$BC,$4B,$DE, $B,$41,$41,$74,$BE,$3F,$87,$5D,$BF,$67,$3F,$B4,$B9,$F7,$61,$F7,$7F,$9B,$3E,$6C,$6A,$1D,  8,$50,$5C,$85, $E,$42,$86,$74,$E9,  4,$1D,$10,$A0,$58,$42,$81,$70,$A0,$71,$C7,$1C,$71,$C7,$1C; 11840
		dc.b   0,  0		; 11904
Map128_HPZ:	dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 0
					; DATA XREF: ROM:0001C034o
		dc.w	 0,    0,    0,	   0,$100A,$100B,$100C,$300C,	 0,    0,    0,	   0,$1018,$1019,$181A,$381A,$100A,$100B,$100C,$300C,$300D,$3403,$3402,$3005,$1018,$1019,$181A,$381A,$301B,$3012,$3013,$3014,$300D,$3403,$3402,$3005,$3021,  $1F,  $20,	 $8B,$3011,$3012,$3013,$3014,  $24,  $25,  $26,	 $E3,  $1E,  $1F,  $20,	 $8B,  $43,  $44, $41C,	$434,  $24,  $25,  $26,	 $E3,  $3B,  $3C,  $3D,	$43E; 64
		dc.w   $4A,  $52,$241C,$2045,$2858,$2047,$2059,$214C,$203B,$203C,$203D,$243E,  $5D,  $5E,  $5B,	   0,$2858,$2047,$2059,$214C,	 0,    0,    0,	   0,  $5D,  $5E,  $5B,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 128
		dc.w   $4A,  $52, $41C,	 $45,  $46,  $47,  $48,	$449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,$204F,$2050,  $46,  $47,  $48,	$449,  $4A,  $52,$241C,$2045,$204D,$204E,  $4F,	 $50,  $3B,  $3C,$203D,$243E,$204A,$2052,$241C,$2045,$2046,$2047,$2048,$2449,$203B,$203C,$203D,$243E,$204D,$204E,$204F,$202C,$2858,$2047,$2059,$285A,$204A,$2C55,  $56,	 $5B,  $5D,  $5E,  $5B,	$400, $843,    0,    0,	   0; 192
		dc.w $30ED,$300B,$34DF,$30E1,$302E,$302F,$3001,$3002,$3192,$3591,$3014,$308B,$3024,$3025,$300F,$3010,$2192,$2591,  $8B,	 $8B,  $43,  $44, $41C,	 $1D,$2192,$2591, $12E,	$12F,  $3B,  $3C,  $3D,	$43E,$2192,$2591, $41C,	 $45,  $46,  $47,  $48,	 $E5,$2192,$2591,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,$2192,$2041,  $48,	$449,  $4A,  $52, $41C,	 $45,$20E6,$204E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 256
		dc.w $30E1,$30E1,$30E1,$30E1,$302E,$302F,$3001,$3002,$308B,$308B,$308B,$308B,$3024,$3025,$300F,$3010,  $8B,  $8B,  $22,	 $23,  $43,  $44, $41C,	 $1D,  $E7,  $E8, $42B,	 $50,  $3B,  $3C,  $3D,	$43E,  $4A,  $52, $41C,	 $45,  $46,  $47,  $48,	 $E5,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,  $46,  $47,  $48,	$449,  $4A,  $52, $41C,	 $45,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 320
		dc.w $3003,$3403,$3402,$3005,$302E,$302F,$3001,$3002,$3011,$3012,$3013,$3014,$3024,$3025,$300F,$3010,$301E,  $1F,  $20,	 $8B,  $43,  $44, $41C,	 $1D,  $24,  $25,  $26,	 $E3,  $3B,  $3C,  $3D,	$43E,  $43,  $44, $41C,	$434,  $46,  $47,  $48,	 $E5,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,  $46,  $47,  $48,	$449,  $4A,  $52, $41C,	 $45,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 384
		dc.w $3003,$3403,$3402,$3005,$30E1,$30DF,$300B,$34ED,$3011,$3012,$3013,$3014,$308B,$3414,$3191,$3592,  $1E,  $1F,  $20,	 $8B,  $8B,  $8B,$2191,$2592,  $24,  $25,  $26,	 $E3,  $8B,  $8B,$2191,$2592,  $43,  $44, $41C,	$434,  $8E,  $8B,$2191,$2592,  $3B,  $3C,  $3D,	$43E, $864,  $8B,$2191,$2592,  $46,  $47,  $48,	$449,  $43,  $44,$241C,$2434,$204D,$204E,  $4F,$2050,$203B,$203C,$203D,$243E; 448
		dc.w $30DF,$302F,$302F,$302F,$302E,$302F,$302F,$30EF,$30E2,$303C,$303D,$343E,$3024,$3025,$3026,$30E3,  $E4,  $47,  $48,	 $E5,  $43,  $44, $41C,	$434,  $E6,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E,  $4A,  $52, $41C,	 $45,  $46,  $47,  $48,	$449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,  $46,  $47,  $48,	$449,  $4A,  $52, $41C,	 $45,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 512
		dc.w $30E1,$30E1,$30E1,$30E1,$302E,$302F,$30E0,$30E1,$308B,$308B,$308B,$308B,$3024,$3025,$3026,$30E3,  $8B,  $8B,  $22,	 $23,  $43,  $44, $41C,	$434,  $E7,  $E8, $42B,	 $50,  $3B,  $3C,  $3D,	$43E,  $4A,  $52, $41C,	 $45,  $46,  $47,  $48,	$449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,  $46,  $47,  $48,	$449,  $4A,  $52, $41C,	 $45,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 576
		dc.w $3101,$3102,$3503,	   0,	 0,$3103,$3502,$3501,$308B,$308B,$30D4,	$106, $107,$34D4,$308B,$308B,  $8B,$308B,$3549,	$109, $10A,$34D4,$308B,	 $8B,  $8B,$308B,$3108,	$109, $10A,$3149,$308B,	 $8B,  $43,$3044,$3108,	$109, $10A,$3508,$3022,	 $23,  $3B,$303C,$3108,	$109, $10A,$3508,$342B,	 $50,  $46,$3047,$3108,	$109, $10A,$3508,$341C,	 $45,  $4D,$304E,$3108,	$109, $10A,$3508,$303D,	$43E; 640
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,  $28,  $29,    0,	   0,	 0,    0, $429,	$428; 704
		dc.w   $4A,  $52, $41C,	 $45,  $46,  $47,  $48,	$449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,  $46,  $47,  $48,	$449,  $4A, $C55, $41C,	 $45,  $4D,  $4E,  $4F,	 $2C, $843,    0, $910,	$43E,  $4A, $C55,  $56,	 $5B,$308B,$308B,$305D,$3136, $137,  $8B,  $8B,$308B,$308B,$3D2B,$3D2A,$3D3A,  $D7,  $8B,$308B,$308B,$3D28,$3D27,$3D26,$3D3C,  $E7, $12D,$308B,$3D23,$3D22, $113, $113,	$13F; 768
		dc.w   $4A,  $52, $41C,	 $45,  $46,  $47,  $48,	$449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $2C,  $46,  $47,  $48,	$449,  $4A, $C55,  $56,	 $5B,  $4D,  $4E,  $4F,	 $50, $137,  $8B,  $8B,	 $8B,$304A,$3052,$341C,$3045,$30D7,$308B,$308B,$308B,$3118,$3118,$3118,$3118,$3119,$311A,$311A,$311A, $120, $120, $120,	$120, $120, $120, $120,	$120, $124, $124, $124,	$124, $124, $124, $124,	$124; 832
		dc.w   $4A,$3C55,$3108,	$109, $10A,$3508,$3048,	$449, $843,$308B,$310B,	$109, $10A,$3508,$304F,	 $50,  $8B,$308B,$38D4,	$109, $10A,$350B,$341C,	 $45,  $8B,$308B,$3D0C,	$10D, $10E,$310F,$3910,	$43E,$308B,$3D11,$3D12,	$113,$3114,$3115,$3116,	$117,$3D1B,$3D1C,$3D1D,	$113,$311E,$311F,$342B,	 $50, $121, $113, $113,$3122,$3123,$308B,$341C,	 $45,$3125,$3126,$3127,$3128,$308B,$308B, $910,	$43E; 896
		dc.w   $4A,$3052,$3108,	$147, $148,$3508,$3048,	$449,  $3B,$303C,$3108,	$147, $148,$3508,$304F,	 $50,  $46,$3047,$3108,	$147, $148,$3508,$341C,	 $45,  $4D,$304E,$3108,	$147, $148,$3508,$303D,	$43E,  $4A,$3052,$3108,	$147, $148,$3508,$3048,	$449,  $3B,$303C,$3108,	$147, $148,$3508,$304F,	 $50,  $46,$3047,$3108,	$147, $148,$3508,$341C,	 $45,  $4D,$304E,$3108,	$147, $148,$3508,$303D,	$43E; 960
		dc.w $304A,$3052, $41C,	 $45,  $46,  $47,$2048,$3449,$303B,$303C,  $3D,	$43E,  $4D,  $4E,$204F,$3050,$3046,$3047,  $48,	$449,  $4A,  $52, $41C,$3045,$304D,$304E,  $4F,	 $50,  $3B,  $3C,  $3D,$343E,$304A,$3052, $41C,	 $45,  $46,  $47,$2048,$3449,$303B,$303C,  $3D,	$43E,  $4D,  $4E,$204F,$3050,$3046,$3047,  $48,	$449,$204A,  $52,$241C,$3045,$304D,$304E,$304F,$3050,$303B,$303C,$303D,$343E; 1024
		dc.w  $6FF, $2FE, $2FF,	   0,	 0,    0,    0,	   0, $EFF, $AFE, $EFD,	   0,	 0,    0,    0,	   0,	 0,  $AF,  $B0,	 $B1,	 0,    0,    0,	   0,	 0,  $A5,  $A6,	 $A7,  $A8,    0,    0,	   0,$3041,$302F,$302F,$302F,$302E,$302F,$3001,$3002,$303B,$303C,$303D,$343E,$3024,$3025,$300F,$3010,$3046,$3047,  $48,	 $E5,  $43,  $44, $41C,	 $1D,$304D,$304E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 1088
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 3, $403, $402,	   5,  $2E,  $2F,    1,	   2,  $11,  $12,  $13,	 $14,  $24,  $25,   $F,	 $10,  $1E,  $1F,  $20,	   0,  $43,  $44, $41C,	 $1D,  $24,  $25,  $26,	 $7B,  $3B,  $3C,  $3D,	$43E; 1152
		dc.w	 0,    0,    0,	$400, $400,    0,    0,	   0,	 0,    0,    0,	$400, $400,    0,    0,	   0,	 0,    0,    0,	   0, $400,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$3003,$3403,$3402,$3005,$302E,$302F,$30E0,$30E1,$3011,$3012,$3013,$3014,$3024,$3025,$3026,$30E3,  $1E,  $1F,  $20,	 $8B,  $43,  $44, $41C,	$434,  $24,  $25,  $26,	 $E3,  $3B,  $3C,  $3D,	$43E; 1216
		dc.w $204A,$2052, $41C,	 $45,  $46,  $47,$2048,$2449,$203B,$203C,  $3D,	$43E,  $4D,  $4E,$204F,$2050,$2858,$2047,  $48,	$449,  $4A,  $52,$241C,$2045,$20E6,$204E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E,$204A,$2052, $41C,	 $45,  $46,  $47,  $48,	$449,$203B,$203C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,$2858,$2047,  $48,	$449,  $4A,  $52, $41C,	 $45,$20E6,$204E,$204F,$2050,$203B,$203C,$203D,$243E; 1280
		dc.w $204A,$2052, $41C,	 $45,  $46,  $47,  $48,	$449,$203B,$203C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,$2046,$2047,  $48,	$449,  $4A,  $52, $41C,	 $45,$204D,$204E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E,  $4A,  $52, $41C,	 $45, $858,  $47,  $59,	$14C,  $3B,  $3C,  $3D,	$43E,  $5D,  $5E,  $5B,	 $8B,  $46,  $47,  $48,	 $E5,  $43,  $44, $41C,	$434,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 1344
		dc.w   $4A,  $52, $41C,	 $45,  $46,  $47,$2048,$2449,  $3B,  $3C,  $3D,	$43E,  $4D, $A93,$204F,$2050, $858,  $47,  $59,	$85A,  $4A,  $8B, $41C,	 $45,  $5D,  $5E,  $5B,	 $8B, $843,  $8B, $910,	$43E,  $8B,  $8B,  $8B,	 $8B,  $8B,  $8B, $116,	$117,  $8B,  $8B,  $8B,	 $8B,  $E7,  $E8, $42B,	 $50,  $8B,  $8B,  $22,	 $23,  $4A,  $52, $41C,$2045,  $E7,  $E8,$242B,$2050,$203B,$203C,$203D,$243E; 1408
		dc.w $304A,$3052, $41C,	 $45,  $46,  $47,$2048,$20E5,$303B,$303C,  $3D,	$43E,  $4D,  $4E,$204F,$202C,  $46,  $47,  $48,	$449,  $4A,  $52,$241C,$2434,$204D,$204E,  $4F,	 $50,  $3B,  $3C,$203D,$243E,$204A,$2052, $41C,	 $45,  $46,  $47,$2048,$20E5,$203B,$203C,  $3D,	$43E,  $4D,  $4E,$204F,$202C,$2046,$2047,  $48,	$449,  $4A,  $52,$241C,$2434,$204D,$204E,  $4F,$2050,$203B,$203C,$203D,$243E; 1472
		dc.w   $4A,  $52, $41C,	 $45,  $46,  $47,  $48,	$449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,  $46,  $47,  $48,	$449,  $4A,$2052,$241C,$2045,  $4D,  $4E,  $4F,$2050,$269C,$269C,$269C,$269C,$304A,$3052,$369C,$269C,$269C,    0,    0,	   0,$3118,$369C,$369C,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 1536
		dc.w $304A,$3134,$3CFA,$3CCD,$3CCE,$3CCF,$3CD0,$3CD1,$314D,$3EB1,$3EB0,$3EAF,$3CD5,    0,    0,	   0,$308B,$3EAE,$3EAD,	$EAC,	 0,    0,    0,	   0,$3CDB,$3CDC,    0,	   0,	 0,    0,    0,	   0,$3CD9,$3CDA,    0,	   0,	 0,    0,    0,	   0,$3CD6,    0,    0,	   0,	 0,    0,    0,	   0,$3CD2,    0,    0,	   0,	 0,    0,    0,	   0,$3CCA,    0,    0,	   0,	 0,    0,    0,	   0; 1600
		dc.w $34CA,    0,    0,	   0,	 0,    0,    0,	   0,$34D2,    0,    0,	   0,	 0,    0,    0,	   0,$34D6,    0,    0,	   0,	 0,    0,    0,	   0,$34D9,$34DA,    0,	   0,	 0,    0,    0,	   0,$34DB,$34DC,    0,	   0,	 0,    0,    0,	   0,$3560,$36AE,$36AD,	$6AC,	 0,    0,    0,	   0,$30DE,$36B1,$36B0,$36AF,$34D5,    0,    0,	   0,$34CB,$34CC,$34FA,$34CD,$34CE,$34CF,$34D0,$34D1; 1664
		dc.w  $400, $400, $400,	$400, $400, $400, $400,$30CA, $400, $400, $400,	$400, $400, $400, $400,$30D2, $400, $400, $400,	$400, $400, $400, $400,$30D6, $400, $400, $400,	$400, $400, $400,$30DA,$30D9, $400, $400, $400,	$400, $400, $400,$30DC,$30DB, $400, $400, $400,	$400, $2AC,$32AD,$32AE,$3160, $400, $400, $400,$30D5,$32AF,$32B0,$32B1,$34DE,$30D1,$30D0,$30CF,$30CE,$30CD,$30FA,$30CC,$30CB; 1728
		dc.w   $4A,$3134,$3938,$3D1E, $113,$311D,$311C,$3139, $137,$308B,$3D15,$3D14, $113,$3112,$3111,$3166, $142,$308B,$3D43,$3D44, $145,$3146,$308B,$34D7, $4CB,$312D,$390B,	$147, $148,$34D4,$308B,	 $8B,  $4A,$3130,$3108,	$147, $148,$3149,$3022,	$14A,  $3B,$303C,$3108,	$147, $148,$3508,$342B,	 $50,  $46,$3047,$3108,	$147, $148,$3508,$341C,	 $45,  $4D,$304E,$3108,	$147, $148,$3508,$303D,	$43E; 1792
		dc.w $3918,$3918,$3918,$3918,$3918,$3919,$391A,$391A,$303B,$303C,$303D,$343E,$34CB,$312D,$316B,$3422,  $46,  $47,  $48,	$449,  $4A, $130, $41C,	$434,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E,  $4A,  $52, $41C,	 $45,  $46,  $47,  $48,	$449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,  $46,  $47,  $48,	$449,  $4A,  $52, $41C,	 $45,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 1856
		dc.w $3129,$312A,$312B,$308B,$308B,  $8B,  $5D,	$12C,$308B,$308B,$308B,$308B,  $E7, $12D, $12E,	$12F,  $8B,  $8B,  $22,	 $23,  $4A, $130, $41C,	 $45,  $E7,  $E8, $42B,	 $50,  $3B,  $3C,  $3D,	$43E,  $4A,  $52, $41C,	 $45,  $46,  $47,  $48,	$449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,  $46,  $47,  $48,	$449,  $4A,  $52, $41C,	 $45,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 1920
		dc.w   $4A,$3052,$3108,	$109, $10A,$3508,$3048,	$449,  $3B,$303C,$3108,	$109, $10A,$3508,$304F,	 $50,  $46,$3047,$310B,	$109, $10A,$350B,$341C,	 $45,  $4D,$3131,$350F,	$532, $133,$390C,$3910,	$43E,  $4A,$3134,$3515,$3514, $513,$3912,$3135,$312C, $137,  $8B,$3138,$351E, $513,$391D,$391C,$3939,  $D7,  $8B,$308B,$3523,$3522, $513, $513,	$13B,  $8B,  $8B, $16B,$3422,$3528,$3527,$3526,$353E; 1984
		dc.w $3041,$140C,$140C,$140B,$140B,$140B,$140B,$140A,$341A,$141A,$141A,$1419,$1419,$1419,$1419,$1417,$3046,$3041,$340B,$3002,$3003,$3042,$340C,$140B,$304D,$304E,$300F,$3010,$3011,$3012,$341A,$1419,  $4A,  $52, $41C,	 $1D,  $1E,$301F,$3041,$3002,  $3B,  $3C,  $3D,	$43E,  $24,$3025,$300F,$3010,  $46,  $47,  $48,	 $E5,  $43,  $44, $41C,	 $1D,$204D,$204E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 2048
		dc.w $3041,$302F,$302F,$302F,$302E,$302F,$3001,$3002,$303B,$303C,$303D,$343E,$3024,$3025,$300F,$3010,  $46,  $47,  $48,	 $E5,  $43,  $44, $41C,	 $1D,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E,  $4A,  $52, $41C,	 $45,  $46,  $47,  $48,	$449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,  $46,  $47,  $48,	$449,  $4A,  $52, $41C,	 $45,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 2112
		dc.w $30E1,$30E1,$30E1,$30E1,$30E1,$30E1,$302E,$302F,$308B,$308B,$308B,$308B,$308B,$302A,$342B,$3050,  $8B,  $8B,  $22,	 $23,  $43,  $44, $41C,	 $45,  $E7,  $E8, $42B,	 $50,  $3B,  $3C,  $3D,	$43E,  $4A,  $52, $41C,	 $45,  $46,  $47,  $48,	$449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,  $46,  $47,  $48,	$449,  $4A,  $52,$241C,$2045,$204D,$204E,$204F,$2050,$203B,$203C,$203D,$243E; 2176
		dc.w   $43,  $44, $41C,	$434,  $46,  $47,$2048,$2449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,$204F,$2050,  $46,  $47,  $48,	$449,  $4A,  $52,$241C,$2045,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,$203D,$243E,  $4A,  $52, $41C,	 $45,  $46,  $47,$2048,$3449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,$204F,$3050,  $46,  $47,  $48,	$449,  $4A,  $52,$241C,$2045,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,$203D,$243E; 2240
		dc.w $204A,$2052, $41C,	 $45,  $46,  $47,  $48,	$449,$203B,$203C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,$2858,$2047,  $48,	$449,  $4A,  $52, $41C,	 $45,$20E6,$204E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E,$204A,$2052, $41C,	 $45,$2046,$2047,$2048,$2449,$203B,$203C,$203D,$243E,$204D,$204E,$204F,$202C,$2858,$2047,$2059,$285A,$204A,$2C55,  $56,	 $5B,  $5D,  $5E,  $5B,	   0, $843,    0,    0,	   0; 2304
		dc.w	 0,    0,    0,	   0,$100A,$100B,$100B,$100B,	 0,    0,    0,	   0,$1018,$1019,$1819,$181A,$100A,$100B,$100B,$100C,$340C,$340B,$340B,$3441,$1018,$1819,$1819,$181A,$3419,$3438,$3438,$3438,$3003,$3403,$3402,$3005,$382D,  $8B,$2022,$2023,$3011,$3012,$3013,$3014,$308B,  $2A,$242B,$202C,  $1E,  $1F,  $20,	 $8B,  $43,  $44,$241C,$2434,  $24,  $25,  $26,	 $E3,  $3B,  $3C,$203D,$243E; 2368
		dc.w $3003,$3403,$3402,$3005,$302E,$302F,$30E0,$30E1,$3011,$3012,$3013,$3014,$3024,$3025,$3026,$30E3,  $1E,  $1F,  $20,	 $8B,  $43,  $44, $41C,	$434,  $24,  $25,  $26,	 $E3,  $3B,  $3C,  $3D,	$43E,  $43,  $44, $41C,	$434,  $46,  $47,  $48,	$449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,  $46,  $47,  $48,	$449,  $4A,  $52, $41C,	 $45,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 2432
		dc.w   $4A,  $52, $41C,	 $45,  $46,  $47,$2048,$2449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,$204F,$202C,  $46,  $47,  $48,	$449,  $4A,  $52,$241C,$2434,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,$203D,$243E,$204A,$2052, $41C,	 $45,  $46,$2047,$2048,$2449,$203B,$203C,$203D,$243E,$204D,$204E,$204F,$202C,$2858,$2047,$2059,$285A,$204A,$2C55,  $56,	 $5B,  $5D,  $5E,  $5B,	   0, $843,    0,    0,	   0; 2496
		dc.w $34E9,$34EA,$34EB,$34EC,	 0,    0,    0,	   0,$30ED,$30EE,$30EF,$30F0,$34E9,$34EA,$34EB,$34EC,  $24,  $25,  $26,$30F1,$30ED,$30EE,$30EF,$30F0,  $8B,  $F2,  $F3,	 $F4,  $24,  $25,  $26,$30F1,  $43,  $44, $41C,	$434,  $8E,  $F5,  $F6,	 $F7,  $3B,  $3C,  $3D,	$43E, $864,  $8B,  $F9,	 $FA,  $46,  $47,  $48,	$449,  $43,  $44, $41C,	$434,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 2560
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$34E9,$34EA,$34EB,$34EC,	 0,    0,    0,	   0,$30ED,$30EE,$30EF,$30F0,$34E9,$34EA,$34EB,$34EC,  $24,  $25,  $26,$30F1,$30ED,$302F,$3001,$3002,  $8B,  $F2,  $F3,	 $F4,  $24,  $25,$300F,$3010,  $8B,  $FB,  $FC,	 $FD,  $43,  $44, $41C,	 $1D,  $FE,  $FF,  $F3,	$100,  $3B,  $3C,  $3D,	$43E; 2624
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$100A,$100B,$100B,$300C,$300D,$3403,$3402,$3005,$1018,$1019,$1019,$301A,$301B,$3012,$3013,$3014,$3003,$3403,$3402,$3005,$3021,$301F,    6,	   7,$301B,$3012,$3013,$3014,$3024,$3025,   $F,	 $15,$3021,  $1F,    6,	   7,	 8,  $44, $41C,	 $45,$3024,  $25,   $F,	 $15,  $16,  $3C,  $3D,	$43E; 2688
		dc.w $100A,$100B,$300C,$300C,$300D,$3403,$3402,$3005,$1018,$1019,$301A,$301A,$301B,$3012,$3013,$3014,$30E1,$30DF,$300B,$3005,$3021,$301F,  $20,	 $8B,$308B,$308B,$3191,$3592,$3024,$3025,  $26,	 $E3,	 8,  $44, $41C,	$434,  $8E,  $8B,  $60,	 $61,  $16,  $3C,  $3D,	$43E, $864,  $8B, $192,	$591,  $46,  $47,  $48,	 $E5,  $43,  $44, $41C,	 $45,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 2752
		dc.w $3442,$3042,$300B,$140A,	 0,  $72,  $73,	 $78,$3011,$3012,$341A,$1417,	 0,  $76,  $86,	 $87,  $1E,$301F,$3041,$3002,$3003,$3042,$340B,$140A,  $24,$3025,$300F,$3010,$3011,$3012,$341A,$1417,	 7,    8, $41C,	 $1D,  $1E,  $1F,$3041,$3002,  $3B,  $3C,  $3D,	$43E,  $24,  $25,$300F,$3010,  $46,  $47,  $48,	 $E5,	 7,    8, $41C,	 $1D,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 2816
		dc.w	 0,    0,    0,	   0,	 0,  $72,  $73,	 $78,	 0,    0,    0,	   0,	 0,  $76,  $77,	   0,	 0,    0,    0,	   0, $400, $2E2, $2E3,	   0,	 0,    0,    0,	   0,	 0, $EE3, $EE2,	   0,$3003,$3042,$300B,$140A,	 0,  $76,  $77,	   0,$3011,$3012,$341A,$1417,  $72, $486,  $83,	 $84,  $1E,$301F,$3041,$3002,$3003,$3042,$300B,$140A,  $24,$3025,$300F,$3010,$3011,$3012,$341A,$1417; 2880
		dc.w $204A,$2052, $41C,	 $45,  $46,  $47,$2048,$2449,$203B,$203C,$203D,	$43E,  $4D,  $4E,$204F,$2050,$2858,$2047,$2048,$2449,$204A,  $52,$241C,$2045,  $5D,$2A93,$204F,$2050,$203B,$203C,$203D,$243E,	 0,    0,  $56,	 $57,$2858,$2047,$2059,$214C,	 0,    0,    0,	   0,  $5D,  $5E,  $5B,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 2944
		dc.w   $43,  $44, $41C,	$434,$308B,$352B,$352A,$353A,  $3B,  $3C,  $3D,	$43E,  $8B,  $8B,$316B,$3422,  $46,  $47,  $48,	 $E5,  $43,  $44, $41C,	$434,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E,  $4A,  $52, $41C,	 $45,  $46,  $47,  $48,	$449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,  $46,  $47,  $48,	$449,  $4A,  $52, $41C,	 $45,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 3008
		dc.w	 0,    0,    0,	   0,$100A,$100B,$100B,$100B,	 0,    0,    0,	   0,$1018,$1019,$1019,$1019,$100B,$100B,$100B,$100B,$100B,$300C,$300C,$300C,$1019,$1019,$1019,$1019,$1019,$3019,$3038,$3038,$100C,$100C,$100C,$3402,$3005, $82D,    0,	   0,$1038,$1038,$1038,$3039,$3014,    0,    0,	   0,  $BC,  $BD,  $BE,	   0,	 0,    0,    0,	   0,  $85,  $86,  $87,	   0,	 0,    0,    0,	   0; 3072
		dc.w $3041,$302F,$302F,$302F,$302E,$302F,$30E0,$30E1,$303B,$303C,$303D,$343E,$3024,$3025,$3026,$30E3,$2046,$2047,  $48,	 $E5,  $43,  $44, $41C,	$434,$204D,$204E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E,$204A,$2052, $41C,	 $45,  $46,  $47,  $48,	$449,$203B,$203C,$203D,$243E,$204D,$204E,  $4F,	 $50,$2858,$2047,$2059,$285A,$204A,$2052, $41C,	 $45,  $5D,  $5E,  $5B,	$4D3,$203B,$203C,  $3D,	$43E; 3136
		dc.w	 0,    0,    0,	$558,$2858,$2047,  $48,	$449,	 0,    0,    0,	   0,$20E6,$204E,  $4F,	 $50,	 0,    0,    0,	   0,$204A,$2052, $41C,	 $45,	 0,    0,    0,	$4D3,$203B,$203C,$203D,$243E,	 0,    0,    0,	$558,$2858,$2047,$2059,$285A,	 0,    0,    0,	   0,  $5D,  $5E,  $5B,	$4D3,	 0,    0,    0,	   0,	 0,    0,    0,	$558,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 3200
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,  $E1,  $E1,  $E1,	 $E1,  $2E,  $2F,  $E0,	 $E1,	 0,    0,    0,	   0,  $24,  $25,  $26,	 $7B,	 0,    0,  $22,	 $23,  $43,  $44, $41C,	$434,  $E7,  $E8, $42B,	 $50,  $3B,  $3C,  $3D,	$43E; 3264
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,  $E1,  $E1,  $E1,	 $E1,  $2E,  $2F,    1,	   2,	 0,    0,    0,	   0,  $24,  $25,   $F,	 $10,	 0,    0,  $22,	 $23,  $43,  $44, $41C,	 $1D,  $E7,  $E8, $42B,	 $50,  $3B,  $3C,  $3D,	$43E; 3328
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$100A,$100B,$100C,$300C,	 0,    0,    0,	   0,$1018,$1019,$181A,$381A; 3392
		dc.w  $2F7, $6F8, $2F9,	   0,	 0,    0,    0,	   0, $EF9, $AF8, $EF7,	   0,	 0,    0,    0,	   0,	 0,  $AF,  $B0,	 $B1,$100A,$100B,$100C,$300C,	 0,  $A5,  $A6,	 $A7,$1018,$1019,$181A,$381A,$100A,$100B,$100C,$300C,$300D,$3403,$3402,$3005,$1018,$1019,$181A,$381A,$301B,$3012,$3013,$3014,$300D,$3403,$3402,$3005,$3021,  $1F,  $20,	 $8B,$301B,$3012,$3013,$3014,$3024,  $25,  $26,	 $E3; 3456
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$300D,$3403,$3402,$3005,$30E1,$30DF,$302F,$302F,$301B,$3012,$3013,$3014,$308B,$308B,$3910,$343E,$3021,$301F,  $20,	 $8B,  $8B,  $8B, $116,	$117,$3024,$3025,  $26,	 $E3,  $8B,  $2A, $42B,	 $50,  $8B,  $8B,  $60,	 $61,	 7,    8, $41C,	 $45,  $8B,  $8B, $192,	$591,  $15,  $16,  $3D,	$43E; 3520
		dc.w $100B,$100C,$100C,$100C,$100C,$300C,$3402,$3005,$1019,$1019,$1019,$1019,$1019,$3019,$3039,$3014,$300C,$300C,$300C,$3402,$3005,$382D,    0,	   0,$3038,$3038,$3038,$3039,$3014,    0,    0,	   0,	 0, $992, $D91,	   0,	 0,    0,    0,	   0,	 0, $860, $861,	   0,	 0,    0,    0,	   0,	 0,  $79,  $7A,	 $7B,	 0,    0,    0,	   0,	 0,    0,  $79,	 $7A,  $7B,    0,    0,	   0; 3584
		dc.w $2021,$201F,$2020,	 $8B,  $8B,  $8B,  $60,	 $61,$2024,$2025,$2026,	 $E3,  $8B,  $8B, $192,	$591,$208B,$208B,  $60,	 $61,  $43,$2044,$241C,$2045,$208B,$208B,$2192,$2591,$203B,$203C,$203D,$243E,$208B,$2044,$241C,$2045,$2046,  $B7,  $B8,	 $B9,$20E2,$203C,$203D,$243E,  $BC,  $BD,  $BE,	   0,$20E4,$2047,$2059,$214C,  $6A,  $6B,  $6C,	   0,  $5D,  $5E,  $5B,	   0,	 0, $2E2, $2E3,	   0; 3648
		dc.w $3442,$3042,$300B,$140A,	 0,    0,    0,	   0,$3011,$3012,$341A,$1417,	 0,    0,    0,	   0,  $1E,$301F,$341A,$1417,	 0,    0,    0,	   0,  $24,$3025,$341A,$1417,	 0,    0,    0,	   0,  $43,$3044,$329C,$3041,$34DF,$30DF,$300B,$34ED,  $3B,  $3C,$303D,$343E,$3014,$3414,$3191,$3592,  $46,  $47,  $48,	 $E5,  $43,  $44,$241C,$2434,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,$203D,$243E; 3712
		dc.w $302F,$302F,$302F,$302F,$30E1,$30DF,$300B,$34ED,$303B,$303C,$303D,$343E,$308B,$3414,$3191,$3592,$3046,$3047,  $48,	 $E5,  $8B,  $8B,$2191,$2592,$304D,$304E,  $4F,	 $2C,  $8B,  $8B,$2191,$2592,$304A,$3052, $41C,	$434,  $8E,  $8B,$2191,$2592,$303B,$303C,  $3D,	$43E, $864,  $8B,$2191,$2592,$3046,$3047,  $48,	 $E5,  $43,  $44,$241C,$2434,$304D,$304E,  $4F,	 $50,  $3B,  $3C,$203D,$243E; 3776
		dc.w $100A,$100B,$100B,$100B,$100B,$100B,$100B,$100B,$1018,$1819,$1819,$1819,$1819,$1819,$1819,$1819,  $18, $819, $819,	$819, $819, $819, $819,	$819,  $37,  $38,  $38,	 $38,  $38,  $38,  $38,	 $38,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0, $400,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 3840
		dc.w   $43,  $44, $41C,	 $1D,  $1E,$301F,$3041,$3002,  $3B,  $3C,  $3D,	$43E,  $24,$3025,$300F,$3010,$2046,$2047,  $48,	 $E5,  $43,  $44, $41C,	 $1D,$204D,$204E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E,$204A,$2052, $41C,	 $45,  $46,  $47,  $48,	$449,$203B,$203C,$203D,$243E,$204D,$204E,  $4F,$2050,$2858,$2047,$2059,$214C,$204A,$2052,$241C,$2045,  $5D,  $5E,  $5B,$20DD,$203B,$203C,$203D,$243E; 3904
		dc.w $340C,$340B,$140B,$140B,$140B,$140B,$140B,$140A,$3419,$3419,$1419,$1419,$1419,$1419,$1419,$1418, $419, $419, $419,	$419, $419, $419, $419,	$418, $438, $438, $438,	$438, $438, $438, $438,	$437,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 3968
		dc.w	$B,   $B,   $B,	  $B, $40B, $40B, $40B,	$40B, $819, $819, $819,	$819, $419, $419, $419,	$419, $819, $819, $819,	$819, $419, $419, $419,	$419,  $38,  $38,  $38,	 $38, $438, $438, $438,	$438,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 4032
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$100A,$100B,$100C,$100C,$100C,$100C,$100C,$100C,$1037,$1038,$1038,$1038,$1038,$1038,$1038,$1038,	 0,  $BC,  $BD,	 $BE,	 0,    0,    0,	   0,	 0,  $76,  $7F,	 $6C,	 0,    0,    0,	   0; 4096
		dc.w	 0,    0,    0,	   0,	 0,  $A9,  $A3,	 $A4,	 0,    0,    0,	   0,  $A5,  $AC,  $AD,	 $AE,	 0,    0,    0,	   0,$100A,$100B,$100B,$100B,	 0,    0,    0,	   0,$1018,$1019,$1019,$1019,$100C,$100C,$100C,$100C,$100C,$100C,$100C,$100C,$1038,$1038,$1038,$1038,$1038,$1038,$1038,$1038,  $BC,  $BD,  $BE,	   0,	 0,    0,    0,	   0, $2F4, $2F5, $2F6,	   0,	 0,    0,    0,	   0; 4160
		dc.w	 0,    0,    0,	   0,	 0, $EE3, $EE2,	   0,	 0,    0,    0,	   0,	 0, $2F4, $2F5,	$2F6,	 0,    0,    0,	   0,	 0, $EF6, $EF5,	$EF4,	 0,    0,    0,	   0,	 0,  $72,  $73,	 $74,	 0,    0,    0,	   0,$100A,$100B,$100B,$100B,	 0,    0,    0,	   0,$1018,$1019,$1019,$1019,$100A,$100B,$100B,$100B,$300B,$300B,$300B,$300B,$1018,$1019,$1019,$1019,$3019,$3038,$3038,$3038; 4224
		dc.w $3003,$3403,$3402,$3005,$382D,$308B,  $22,	 $23,$3011,$3012,$3013,$3014,$308B,$302A, $42B,	 $2C,  $1E,  $1F,  $20,	 $8B,  $43,  $44, $41C,	$434,  $24,  $25,  $26,	 $E3,  $3B,  $3C,  $3D,	$43E,  $43,  $44, $41C,	$434,  $46,  $47,  $48,	$449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,  $46,  $47,  $48,	$449,  $4A,  $52, $41C,	 $45,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 4288
		dc.w   $8B,  $8B,  $8B,	 $8B,  $8B,  $8B,  $60,	 $61,  $8B,  $8B,  $8B,	 $8B,  $8B,  $8B,  $F9,	 $89,  $8B,  $8B,  $22,	 $23,  $43,  $44, $41C,	 $45,  $E7,  $E8, $42B,	 $50,  $3B,  $3C,  $3D,	$43E,  $4A,  $52, $41C,	 $45,  $46,  $47,  $48,	$449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,  $46,  $47,  $48,	$449,  $4A,  $52, $41C,	 $45,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 4352
		dc.w	 7,    8, $41C,	 $45,$2046,$2047,$2048,$2449,  $15,  $16,  $3D,$243E,$204D,$204E,$204F,$2050,$2046,$2047,$2048,$2449,$204A, $C55,  $56,	 $57,$204D,$204E,$204F,$202C, $843,    0,    0,	   0,$204A,$2C55,  $56,	 $5B,	 0,    0,    0,	   0, $843,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 4416
		dc.w $300B,$302F,$302F,$302F,$302E,$302F,$30E0,$30E1,$3819,$3819,$303D,$343E,$3024,$3025,$3026,$30E3,$2819,$2047,  $C3,	 $5E,$2043,$2044,$241C,$2434,  $C7,  $C8,  $C9,	$4D3,$203B,$203C,$203D,$243E,  $A2,  $A3,  $A4,	$558,  $C2,  $B7,  $C3,$2449,	 0,  $AF,  $B0,	 $B1,  $C7,  $C8,  $C9,	$537,	 0, $400,  $AF,	 $B0, $4B0,  $AA,    0,	$558,	 0,    0, $4B1,	$4B0, $4AF, $400,    0,	   0; 4480
		dc.w $30E1,$30E1,$30E1,$30E1,$302E,$302F,$3001,$3002,$308B,$308B,$308B,$308B,$3024,$3025,$300F,$3010,  $8B,  $8B,  $22,	 $23,  $43,  $44, $41C,	 $1D,$20E7,  $E8, $42B,	 $50,  $3B,  $3C,  $3D,	$43E,$204A,$2052, $41C,$2045,$2046,$2047,$2048,$2449,$203B,$203C,$203D,$243E,$204D,$204E,$204F,$2050,$2858,$2047,$2059,$285A,$204A, $C55,  $56,	 $57,  $5D,  $5E,  $5B,	   0, $843,    0,    0,	   0; 4544
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$100A,$100B,$100B,$300C,$300D,$3403,$3402,$3005,$1018,$1019,$1019,$301A,$301B,$3012,$3013,$3014,$100B,$100B,$3402,$3005,$3021,  $1F,  $20,	 $8B,$1019,$1019,$3013,$3014,  $24,  $25,  $26,	 $27,$3402,$3005,$382D,	 $8B,  $43,  $44, $41C,	 $45,$3039,$3014,  $8B,	 $8B,  $3B,  $3C,  $3D,	$43E; 4608
		dc.w $3003,$3042,$340B,$140A,	 0,    0,    0,	   0,$3011,$3012,$341A,$1417,	 0,    0,    0,	   0,  $1E,$301F,$3041,$3002,$3003,$3042,$340B,$140A,  $24,$3025,$300F,$3010,$3011,$3012,$341A,$1417,$2043,$2044,$241C,$201D,$201E,$301F,$3041,$140C,$203B,$203C,$203D,$243E,$2024,$3025,$300F,$1419,  $C2,  $B7,  $C3,	 $C4,	 0,    0,  $56,	$45D,  $C7,  $C8,  $C9,	   0,	 0,    0,    0,	   0; 4672
		dc.w $3041,$340C,$140C,$102F,$140B,$140A,    0,	   0,$303B,$303C,$1C1A,$1419,$1C19,$1C17,    0,	   0,$2858,$3047,$3041,$3002,$3003,$3042,$340C,$140C,$20E6,$304E,$300F,$3010,$3011,$3012,$341A,$141A,$204A,$2052, $41C,	 $1D,  $1E,$301F,$3041,$3002,$203B,$203C,  $3D,	$43E,  $24,$3025,$300F,$3010,$2858,$2047,  $48,	 $E5,  $43,  $44, $41C,	 $1D,$20E6,$204E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 4736
		dc.w  $EF6, $EF5, $EF4,	   0,	 0,    0,    0,	   0,  $72,  $73,  $74,	 $75,	 0,    0,    0,	   0,$140B,$140B,$140B,$140A,	 0,    0,    0,	   0,$1C19,$1C19,$1C19,$1C17,	 0,    0,    0,	   0,$3003,$3042,$340C,$140C,$140B,$140B,$140B,$140A,$3011,$3012,$341A,$141A,$1C19,$1C19,$1C19,$1C17,  $1E,$301F,$3041,$3002,$3003,$3042,$340C,$140C,  $24,$3025,$300F,$3010,$3011,$3012,$341A,$141A; 4800
		dc.w	 0, $872, $873,	$878,	 0,    0,    0,	   0,	 0,    0, $2E2,	$2E3,	 0,    0,    0,	   0,	 0,    0, $EE3,	$EE2,	 0,    0,    0,	   0,	 0, $484, $483,	$482,	 0,    0,    0,	   0,	 0,  $76,  $77,	   0,	 0,    0,    0,	   0,  $72,  $73,  $74,	 $75,	 0,    0,    0,	   0,$140B,$140B,$140B,$140A,	 0,    0,    0,	   0,$1C19,$1C19,$1C19,$1C17,	 0,    0,    0,	   0; 4864
		dc.w $300B,$300B,$140B,$140A,	 0,    0,    0,	   0,$3819,$3819,$141A,$1417,	 0,    0,    0,	   0,$3819,$3819,$3041,$3002,$3003,$3042,$340B,$140A,$3038,$3038,$300F,$3010,$3011,$3012,$341A,$1417,$2043,$2044, $41C,$301D,$301E,$301F,$3041,$3002,$203B,$203C,  $3D,	$43E,  $24,$3025,$300F,$3010,$2858,$2047,  $48,	 $E5,  $43,  $44, $41C,	 $1D,$20E6,$204E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 4928
		dc.w $3003,$3042,$340C,$140C,$140B,$140B,$140B,$140A,$3011,$3012,$341A,$141A,$1419,$1419,$1419,$1417,  $1E,$301F,$3041,$3002,$3003,$3042,$340C,$140B,  $24,$3025,$300F,$3010,$3011,$3012,$341A,$1419,  $43,  $44, $41C,	 $1D,  $1E,$301F,$3041,$3002,  $3B,  $3C,  $3D,	$43E,  $24,$3025,$300F,$3010,  $46,  $47,  $48,	 $E5,  $43,  $44, $41C,	 $1D,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 4992
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$140B,$140A,    0,	   0,	 0,    0,    0,	   0,$1419,$1417,    0,	   0,	 0,    0,    0,	   0,$3003,$3403,$3402,$3005,$302E,$302F,$30E0,$30E1,$3011,$3012,$3013,$3014,$3024,$3025,$3026,$30E3,  $1E,  $1F,  $20,	 $8B,  $43,  $44, $41C,	$434,  $24,  $25,  $26,	 $E3,  $3B,  $3C,  $3D,	$43E; 5056
		dc.w	 0,    0,    0,$314E,$314F,  $8B, $116,	$117,	 0,    0,  $28,$3163,$30E7,  $E8, $42B,	 $50,	 0,    0,$3164,$3165,  $4A,  $52, $41C,	 $45,	 0,    0,$314B,$3166,  $3B,  $3C,  $3D,	$43E,	 0,$314E,$314F,	$167, $858,  $47,  $48,	$449,$3028,$3163,  $8B,	 $8B,  $E6,  $4E,  $4F,	 $50,$3164,$3165, $169,	$16A,  $4A,  $52, $41C,	 $45,$3163,$308B, $16B,	$16C,  $3B,  $3C,  $3D,	$43E; 5120
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,$314E,	 0,    0,    0,	   0,	 0,    0,    0,$314B,	 0,    0,    0,	   0,	 0,    0,$314E,$314F,	 0,    0,    0,	   0,	 0,  $28,$3163,$308B,	 0,    0,    0,	   0,	 0,$3164,$3165,	$169,	 0,    0,    0,	   0,	 0,$314B,$316B,	$16D,	 0,    0,    0,	   0,$314E,$314F, $41C,	 $45,	 0,    0,    0,	   0,$314B,$308B, $910,	$43E; 5184
		dc.w	 0,    0,    0,$314E,$314F,  $8B, $116,	$117,	 0,    0,$3028,$3163,  $E7,  $E8, $42B,	 $50,	 0,    0,$3164,$3165,  $4A,  $52, $41C,	 $45,	 0,    0,$314B,$3166,  $3B,  $3C,  $3D,	$43E,	 0,$314E,$314F,	$167, $858,  $47,  $48,	$449,	 0,$314B,$308B,	 $8B,  $E6,  $4E,  $4F,	 $50,$314E,$314F,  $22,	 $23,  $4A,  $52, $41C,	 $45,$314B,$302A, $42B,	 $50,  $3B,  $3C,  $3D,	$43E; 5248
		dc.w $314F,  $44, $41C,	 $45,  $46,  $47,  $48,	$449,$30E2,  $3C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,  $E4,  $47,  $48,	$449,  $4A,  $52, $41C,	 $45,  $E6,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E,  $4A,  $52, $41C,	 $45,  $46,  $47,  $48,	$449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,  $46,  $47,  $48,	$449,  $4A,  $52, $41C,	 $45,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 5312
		dc.w   $4A,  $52, $41C,	 $45,  $46,  $47,  $48,	$449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,  $46,  $47,  $48,	$449,  $4A,  $52, $41C,	 $45,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E,  $4A,  $52, $41C,	 $45,  $46,  $47,  $48,	$449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $2C,  $46,  $47,  $48,	$449,  $4A, $C55,  $8B,$308B,  $4D,  $4E,  $4F,	 $50, $14D,  $8B,  $8B,$3EB4; 5376
		dc.w   $43,  $44, $41C,	$434,  $8B,  $8B,$308B,$3C0E,  $3B,  $3C,  $3D,	$43E,  $E7, $15A, $EB8,	$EB7,  $46,  $47,  $48,	$449,  $4A, $15D,$3D5E,$315F,  $4D,  $4E,  $4F,	 $2C, $843,$3EB4,$3EB3,	   0,  $4A,  $52, $41C,	$434,$3EB6,$3EB5,    0,	   0,  $3B,  $3C,  $3D,	$43E,$3162,$3D56,    0,	   0,  $46,  $47,  $59,$314C,$3EB2,    0,    0,	   0,  $4D, $150,  $5B,$3EB4,$3EB3,    0,    0,	   0; 5440
		dc.w   $4A,  $52, $41C,	 $45, $158,  $8B,$308B,$3EB2,  $3B,  $3C,  $3D,	$43E,  $E7, $15A,$3EB8,$3EB7,  $46,  $47,  $48,	$449,  $4A, $15D,$3D5E,$315F,  $4D,  $4E,  $4F,	 $50, $8F7,$3EB4,$3EB3,	   0,  $4A,  $52, $41C,	 $45,$3EB6,$3EB5,    0,	   0,  $3B,  $3C,  $3D,	$43E,$3162,$3D56,    0,	   0,  $46,  $47,  $59,$314C,$3EB2,    0,    0,	   0,  $4D, $150,  $5B,$3EB4,$3EB3,    0,    0,	   0; 5504
		dc.w   $4A, $134,$308B,$3EB2,	 0,    0,    0,	   0, $14D,  $8B,$3EB4,$3EB3,	 0,    0,    0,	   0, $151,$3EB6,$3EB5,	   0,	 0,    0,    0,	   0, $154,$3155,$3D56,	   0,	 0,    0,    0,	   0,$308B,$3EB2,    0,	   0,	 0,    0,    0,	   0,$3EB4,$3EB3,    0,	   0,	 0,    0,    0,	   0,$3D59,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 5568
		dc.w   $4A, $134,$308B,$3EB2,	 0,    0,    0,	   0, $14D,  $8B,$3EB4,$3EB3,	 0,    0,    0,	   0, $151,$3EB6,$3EB5,	   0,	 0,    0,    0,	   0, $154,$3155,$3D56,	   0,	 0,    0,    0,	   0,$308B,$3EB2,    0,	   0,	 0,    0,    0,	   0,$3EB4,$3EB3,    0,	   0,	 0,    0,    0,	   0,$3EB2,    0,    0,	   0,	 0,    0,    0,	   0,$3EB3,    0,    0,	   0,	 0,    0,    0,	   0; 5632
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,$3028,$3029,$329F,$329F,    0,	   0,	 0,    0,$3164,$3165,$329C,$329C,$329F,$329F,	 0,    0,$314B,$3166,  $3B,$329C,$329C,$329C,	 0,$314E,$314F,	$167, $858,  $47,  $48,	$449,	 0,$314B,$308B,	 $8B,  $E6,  $4E,  $4F,	 $50,$314E,$314F,  $22,	 $23,  $4A,  $52, $41C,	 $45,$314B,$302A, $42B,	 $50,  $3B,  $3C,  $3D,	$43E; 5696
		dc.w   $4A,  $52, $41C,$2045,$2046,  $47,  $48,$2449,$203B,$203C,$203D,$243E,$204D,$204E,$204F,$2050,$2046,$2047,$229B,$2E9A,$204A,$2052,$241C,$2045,$2A96,$2297,$2E98,	$299,$203B,$203C,$203D,$243E,  $7C,  $7D,  $7E,	   0,$2858,$2047,$2059,$214C,	 0,  $7C,  $7D,	 $7E,  $5D,  $5E,  $5B,	   0,	 0,    0,  $7C,	 $7D,  $7E,    0,    0,	   0,	 0,    0,    0,	$2A7, $2A8, $2A9,    0,	   0; 5760
		dc.w   $43,  $44, $41C,	 $1D,  $1E,  $1F,$3041,$3002,  $3B,  $3C,  $3D,	$43E,  $24,  $25,$300F,$3010,  $46,  $47,  $48,	 $E5,  $43,  $44, $41C,$201D,  $4D,  $4E,  $4F,$2050,$203B,$203C,$203D,$243E,$204A,  $52, $41C,$2045,$2858,$2047,$2059,$214C,$203B,$203C,$203D,$243E,  $5D,  $5E,  $5B,	   0,$2858,$2047,$2059,$214C,	 0,    0,    0,	   0,  $5D,  $5E,  $5B,	   0,	 0,    0,    0,	   0; 5824
		dc.w	 3, $403, $402,	   5,  $2E,  $2F,  $E0,	 $E1,  $11,  $12,  $13,	 $14,  $24,  $25,  $26,	 $7B,  $1E,  $1F,  $20,	   0,  $43,  $44, $41C,	$434,  $24,  $25,  $26,	 $7B,  $3B,  $3C,  $3D,	$43E,  $43,  $44, $41C,	$434,  $46,  $47,  $48,	$449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,  $46,  $47,  $48,	$449,  $4A,  $52, $41C,	 $45,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 5888
		dc.w	 0,    0,    0,	 $B5,  $B6,  $B7,  $B8,$214C,	 0,    0,    0,	   0,  $BC,  $BD,  $BE,	   0,	 0,    0,    0,	   0,  $76,  $77,    0,	   0,	 0,    0,    0,	   0, $2E6, $2E7,    0,	   0,	 0,    0,    0,	   0, $EE7, $EE6,    0,	   0,	 0,    0,    0,	$484, $483, $482,    0,	   0,	 0,    0,    0,	 $76,  $77,    0,    0,	   0,	 0,    0,  $72,	 $73,  $74,  $75,  $28,	 $29; 5952
		dc.w $204A,$2052, $41C,$2045,$2858,$2047,$2059,$214C,$203B,$203C,$203D,$243E,  $5D,  $5E,  $5B,	   0,$2858,$2047,$2059,$214C,	 0,    0,    0,	   0,  $5D,  $5E,  $5B,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,  $22,	 $23,	 0,    0,    0,	   0,	 0,  $2A, $42B,	 $2C,	 0,    0,    0,	   0; 6016
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$140C,$140B,$140B,$140B,$140B,$140B,$140B,$140A,$1438,$1438,$1438,$1438,$1438,$1438,$1438,$1437,	 0,    0,    0,	   0,  $C7,  $C8,  $C9,	   0,	 0,    0,    0,	   0,  $A9,  $AC,  $A4,	   0; 6080
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0, $400,    0,    0,	   0,	 0, $400, $400,	$400,	 0,    0,    0,	   0,	 0,    0,    0,	   0, $400, $400, $400,	$400, $400,    0, $400,	$400,	 0,    0,    0,	   0,	 0,    0,    0,	   0, $400, $400, $400,	$577,$3576,$3575,$3574,$3573, $56E,$3585,$3184,$3183,$3182,$3181,$3180,$357F,$318E,$318D,$3188,$3189,$308B,$308B,$32B9,$32BA; 6144
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0, $400, $400, $400,	$400, $400, $400, $400,	$400,	 0,    0,    0,	   0,	 0,    0,    0,	   0, $400, $400, $400,	$400, $400, $400, $400,	$400, $16E,    0,    0,	   0,	 0,    0,    0,	   0,$3173,$3174,$3175,$3176, $177,    0,    0,	   0,$317F,$3580,$3581,$3582,$3583,$3584,$3185,	$16E,$318A,$308B,$316B,$3422,$358B,$358C,$358D,$358E; 6208
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0, $400, $400, $400,	$400, $400, $400, $400,	$400,	 0,    0,    0,	   0,	 0,    0,    0,	   0, $400, $400, $400,	$400, $400, $400, $400,	$400,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$3196,    0,    0,	   0,	 0,    0,    0,	   0; 6272
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0, $400, $400, $400,	$400, $400, $400, $400,	$400,	 0,    0,    0,	   0,	 0,    0,    0,	   0, $400, $400, $400,	$400, $400, $400, $400,	$400,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,$3197; 6336
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0, $400, $400, $400,	$400, $400, $400, $400,	$400,	 0,    0,    0,	   0,	 0,    0,    0,	   0, $400, $400, $400,	$400, $400, $400, $400,	$400,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,$316E,$316F,$3170,$3171,$3172, $177,$3178,$3179,$317A,$317B,$317C,$317D,$317E,$3186,$3187,$3188,$3189,$308B,$308B,$32B9,$32BA; 6400
		dc.w $100A,$100B,$100B,$100B,$100B,$100B,$100B,$100B,$1018,$1819,$1819,$1819,$1819,$1819,$1819,$1819,  $18, $819, $819,	$819, $819, $819, $819,	$819,  $37,  $38,  $38,	 $38,  $38,  $38,  $38,	 $38,	 0,    0,  $BC,	 $BD,  $BE,    0,    0,	   0,	 0,    0, $2F4,	$2F5, $2F6,    0,    0,	   0,	 0,    0, $EF6,	$EF5, $EF4,    0,    0,	   0,	 0,    0,  $72,	 $73,  $74,  $75,    0,	   0; 6464
		dc.w   $4A,  $52, $41C,	 $45,  $46,  $47,  $48,	$449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,  $46,  $47, $29B,	$E9A,  $4A,  $52, $41C,	 $45, $A96, $297, $E98,	$299,  $3B,  $3C,  $3D,	$43E,  $7C,  $7D,  $7E,	   0, $858,  $47,  $59,	$14C,	 0,  $7C,  $7D,	 $7E,  $5D,  $5E,  $5B,	   0,	 0,    0,  $7C,	 $7D,  $7E,    0,    0,	   0,	 0,    0,    0,	 $62,  $63,  $64,    0,	   0; 6528
		dc.w	 0,    0,  $85,	 $86,  $87,    0,    0,	   0,	 0,    0, $484,	$483, $482,    0,    0,	   0,	 0,    0,  $85,	 $86,  $87,    0,    0,	   0,	 0,    0,    0,	 $76,  $7F,  $6C,    0,	   0,$3003,$3403,$3402,$3005,$302E,$302F,$3001,$3002,$3011,$3012,$3013,$3014,$3024,$3025,$300F,$3010,  $1E,  $1F,  $20,	 $8B,  $43,  $44, $41C,	 $1D,  $24,  $25,  $26,	 $E3,  $3B,  $3C,  $3D,	$43E; 6592
		dc.w	 0, $8A5, $8A6,	$8A7, $8A8,    0,    0,	   0,	 0,    0,  $AF,	 $B0,  $B1,    0,    0,	   0,	 0,    0,    0,	$2EC, $2ED,    0,    0,	   0,	 0,    0,    0,	$EED, $EEC,    0,    0,	   0,	 0,    0,    0,	 $B2,  $B3,  $B4,    0,	   0,	 0,    0,    0,	   0,  $A9,  $AA,    0,	   0,	 0,    0,    0,	 $A5,  $A6,  $A7,  $A8,	   0,	 0,    0,    0,	 $A9,  $AA,  $AF,  $B0,	 $B1; 6656
		dc.w $204A,$2052,$241C,$2045,$2858,$2047,$2059,$214C,$203B,$203C,$203D,$243E,  $5D,  $5E,  $5B,	   0,  $B6,  $B7,  $B8,	 $B9,	 0,    0,    0,	   0,  $BC,  $BD,  $BE,	   0,	 0,    0,    0,	   0,  $6A,  $6B,  $6C,	   0,	 0,    0,    0,	   0,	 0,  $82,  $83,	 $84,	 0,    0,    0,	   0,	 0,    0, $2E6,	$2E7,	 0,    0,    0,	   0,	 0,    0, $EE7,	$EE6,	 0,    0,    0,	   0; 6720
		dc.w	 0,    0,    0,	$EA9, $2AA, $2AB,    0,	   0,	 0,    0,    0,	   0,  $79,  $7A,  $7B,	   0,	 0,    0,    0,	 $8F,  $90,  $70,  $71,	   0,	 0,  $8F,  $90,	 $91,  $92,  $93,  $94,	 $95,$30E1,$30E1,$30E1,$30E1,$302E,$302F,$30E0,$30E1,$308B,$308B,$308B,$308B,$3024,$3025,$3026,$30E3,  $8B,  $8B,  $22,	 $23,  $43,  $44, $41C,	$434,  $E7,  $E8, $42B,	 $50,  $3B,  $3C,  $3D,	$43E; 6784
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$100A,$100B,$100B,$100B,	 0,    0,    0,	   0,$1018,$1019,$1019,$1019,$100B,$100B,$100C,$300C,$300D,$3403,$3402,$3005,$1019,$1019,$1019,$381A,$3011,$3012,$3013,$3014,$300C,$300C,$3402,$3005,$301E,  $1F,  $20,	 $8B,$3038,$3038,$3039,$3014,$3024,  $25,  $26,	 $E3; 6848
		dc.w $100A,$100B,$100B,$300C,$300D,$3403,$3402,$3005,$1018,$1019,$1819,$301A,$301B,$3012,$3013,$3014,$300C,$300C,$3402,$3005,$3021,  $1F,  $20,	 $8B,$3019,$3038,$3039,$3014,$3024,  $25,  $26,	 $E3,$382D,  $8B,  $8B,	 $8B,  $8B,  $8B,  $60,	 $61,$308B,  $8B,  $8B,	 $8B,  $8B,  $8B,  $F9,	 $50,  $8B,  $8B,  $22,	 $23,  $43,  $44, $41C,	 $45,  $E7,  $E8, $42B,	 $50,  $3B,  $3C,  $3D,	$43E; 6912
		dc.w $3003,$3403,$3402,$3005,$302E,$302F,$3030,$3031,$3011,$3012,$3013,$3014,$3024,$3025,$3026,$3027,  $1E,  $1F,    6,	   7,	 8,  $44, $41C,	 $45,  $24,  $25,   $F,	 $15,  $16,  $3C,  $3D,	$43E,  $43,  $44, $41C,	 $45,$2046,$2047,$2048,$2449,$203B,$203C,$203D,$243E,$204D,$204E,$204F,$2050,$2858,$2047,$2048,$2449,$204A,$2C55,  $56,	 $57,  $5D, $A93,$204F,$202C, $843,    0,    0,	   0; 6976
		dc.w $3032,$3433,$369E,$369D,$3435,$3036,  $22,	 $23,$303B,$303C,$303D,$343E,$343F,$3440,$368D,	 $2C,  $46,  $47,  $48,	$449,  $4A,$304B,$368C,$3690,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,$303D,$3691,$204A,$2052,$241C,$2045,$2046,$2047,$2048,$3449,$203B,$203C,$203D,$243E,$204D,$204E,$204F,$302C,  $C2,  $B7,  $C3,	 $C4,$204A,$2C55,  $56,	 $5B,  $C7,  $C8,  $C9,	   0, $843,    0,    0,	   0; 7040
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,  $8E,    0,    0,	   0,	 0,    0,    0,	   0, $864,    0,    0,	   0,	 0,    0,    0,	   0,$3453,    0,    0,	   0,	 0,    0,    0,	   0,$3454,    0,    0,	   0,	 0,    0,    0,	   0,$345C,    0,    0,	   0,	 0,    0,    0,	   0,$345F,    0,    0,	   0,	 0,    0,    0,	   0; 7104
		dc.w	 0,    0,    0,	   0,$100A,$100B,$140B,$140A,	 0,    0,    0,	   0,$1018,$1019,$1419,$1418,$100A,$100B,$100B,$100B,$100B,$300B,$3402,$3005,$1018,$1019,$1019,$1019,$1019,$3019,$3039,$3014,$100C,$100C,$300C,$3402,$3005, $82D,    0,	   0,$1038,$1038,$3038,$3039,$3014,    0,    0,	   0,  $BC,  $BD,  $BE,	   0,	 0,    0,    0,	   0,  $85,  $86,  $87,	   0,	 0,    0,    0,	   0; 7168
		dc.w   $8B,  $44, $41C,	$434,$308B,$308B,$2022,$3190,  $E2,  $3C,  $3D,	$43E,  $E7,  $E8,$242B,$202C, $1B5,  $47,  $48,	$449,  $4A,  $52,$241C,$2434,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,$203D,$243E,  $4A,  $52, $41C,	 $45,  $46,  $47,$2048,$2449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,$204F,$2050,  $46,  $47,  $48,	$449,  $4A,  $52,$241C,$2045,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,$203D,$243E; 7232
		dc.w $3598,$3599,$359A,$319B, $19C,    0,    0,	   0,$308B,$31A1,$35A2,$35A3,$35A4,$35A5,$35A6,$31A7,  $8B,$308B,$3022,$3023,$31AE,$31AF,$31B0,$31B1,  $8B,  $2A, $42B,	 $2C,  $8B,  $8B,$32B9,$32BA,  $43,  $44, $41C,	$434,  $8B,  $8B,  $76,	 $77,  $3B,  $3C,  $3D,	$43E,  $E7, $15A, $191,	$592,  $46,  $47,  $48,	$449,  $4A,  $52, $41C,	$434,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 7296
		dc.w	 0,    0, $16E,	$19C,$319D,$319E,$319F,$31A0,$31A8,$31A9,$31AA,$31AB,$31AC,$31AD,$35A1,$30DD,$31B2,$35B0,$31B3,$31B4,$308B,$3044,$341C,	 $45, $18A,  $2A, $42B,	 $2C,  $E2,  $3C,  $3D,	$43E,	 0,  $44, $41C,	$434, $1B5,  $47,  $48,	$449,  $E2,  $3C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50, $1B5,  $47,  $48,	$449,  $4A,  $52, $41C,	 $45,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 7360
		dc.w $318F,$2044,$341C,	$434,  $8B,  $8B,  $76,	 $77,$203B,$203C,  $3D,	$43E,  $E7, $12D, $191,	$592,$2046,$2047,  $48,	$449,  $4A, $130, $41C,	$434,$204D,$204E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E,  $4A,  $52, $41C,	 $45,  $46,  $47,  $48,	$449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,  $46,  $47,  $48,	$449,  $4A,  $52, $41C,	 $45,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 7424
		dc.w $140C,$140B,$140B,$140B,$140B,$140B,$140B,$140A,$1419,$1419,$1419,$1419,$1419,$1419,$1419,$1418, $419, $419, $419,	$419, $419, $419, $419,	$418, $438, $438, $438,	$438, $438, $438, $438,	$437,  $BC,  $BD,  $BE,	   0,  $BC,  $BD,  $BE,	   0,  $85,  $86,  $87,	   0,  $76,  $77,    0,	   0,	 0,  $76,  $77,	 $72,  $73,  $78,    0,	   0,	 0,  $82,  $83,	$483,  $77,    0,    0,	   0; 7488
		dc.w $3565,$329F,$329F,$3106,$3107,$329F,$329F,$3165,$308B,$32A1,$329F,$3109,$310A,$329F,$36A1,$308B,  $8B,$308B,$32A1,	$109, $10A,$36A1,$308B,	 $8B,  $8B,$308B,$3105,	$109, $10A,$34D4,$308B,	 $8B,  $43,$3044,$3108,	$109, $10A,$3505,$3022,	 $23,  $3B,$303C,$3108,	$109, $10A,$3508,$342B,	 $50,  $46,$3047,$3108,	$109, $10A,$3508,$341C,	 $45,  $4D,$304E,$3108,	$109, $10A,$3508,$303D,	$43E; 7552
		dc.w $204A,$2052,$241C,$2045,  $46,$2047,$2048,	$449,$203B,$203C,$203D,$243E,$204D,$204E,$204F,$2050,$2858,$2047,$2059,$214C,$204A,$2C55,$241C,$2045,  $5D,  $5E,  $5B,	   0, $843,    0,$2910,$243E,	 0,    0,    0,	   0,	 0,    0,  $5D,	$12C,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 7616
		dc.w $300B,$300B,$300B,$300B,$340B,$340B,$340B,$340B,$3819,$3819,$3819,$3819,$3419,$3419,$3419,$3419, $819, $819, $819,	$819, $419, $419, $419,	$419,  $38,  $38,  $38,	 $38, $438, $438, $438,	$438,	 0,    0,    0,	   0,  $BC,  $BD,  $BE,	   0,	 0,    0,    0,	   0,  $85,  $86,  $87,	   0,	 0,    0,    0,	   0,	 0,  $76,  $77,	   0,	 0,    0,    0,	   0,	 0,  $82,  $83,	 $84; 7680
		dc.w	 0,    0,  $76,	 $77,	 0,    0,    0,	   0,	 0,    0,  $82,	 $83,  $84,    0,    0,	   0,	 0,    0,  $72,	 $73,  $74,  $75,    0,	   0,	 0,    0,  $76,	 $7F,  $80,  $81,    0,	   0,$30E1,$30E1,$30E1,$30E1,$302E,$302F,$3001,$3002,$308B,$308B,$308B,$308B,$3024,$3025,$300F,$3010,  $8B,  $8B,  $22,	 $23,  $43,  $44, $41C,	 $1D,  $E7,  $E8, $42B,	 $50,  $3B,  $3C,  $3D,	$43E; 7744
		dc.w $204A,$2052, $41C,	 $45,  $46,  $47,  $48,$2449,$203B,$203C,  $3D,	$43E,  $4D,  $4E,  $4F,$2050,$2858,$2047,$2048,$2449,$204A,  $52,$241C,$2045,  $5D,$2A93,$204F,$2050,$203B,$203C,$203D,$243E,	 0,    0,  $56,	 $57,$2046,$2047,$229B,$2E9A,	 0,    0,    0,	   0,$2A96,$2297,$2E98,	$299,	 0,    0,    0,	   0,  $6D,  $6E,    0,	   0,	 0,    0,    0,	   0,  $79,  $7A,  $7B,	$400; 7808
		dc.w $204A,$2052,$241C,$2045,$2858,$2047,$2059,$214C,$203B,$203C,$203D,$243E,  $5D,  $5E,  $5B,	   0,  $C2,  $B7,  $C3,	 $C4,	 0,    0,    0,	   0,  $C7,  $C8,  $C9,	   0,	 0,    0,    0,	   0,  $A2,  $A3,  $A4,	   0,	 0,    0,    0,	   0,	 0,  $AF,  $B0,	 $B1,	 0,    0,    0,	   0,	 0,    0, $2EC,	$2ED,	 0,    0,    0,	   0,	 0,    0, $EED,	$EEC,	 0,    0,    0,	   0; 7872
		dc.w $2043,$2044,$241C,$2045,$2046,$2047,$2048,$2449,$203B,$203C,$203D,$243E,$204D,$204E,$204F,$2050,  $C2,  $B7,  $C3,	 $C4,$204A,$2C55,  $56,	 $57,  $C7,  $C8,  $C9,	   0, $843,    0,    0,	   0,  $A2,  $A3,  $A4,	   0,	 0,    0,    0,	   0,	 0,  $AF,  $B0,	 $B1,	 0,    0,    0,	   0,	 0,    0, $2EC,	$2ED,	 0,    0,    0,	   0,	 0,    0, $EED,	$EEC,	 0,    0,    0,	   0; 7936
		dc.w	 0,    0,    0,	   0, $47E, $47D, $47C,	   0,	 0,    0,    0,	 $6F,  $70,  $71,    0,	   0,	 0,    0,    0,	 $7C,  $7D,  $7E,    0,	   0,	 0,    0,    0,	   0, $2A7, $2A8, $2A9,	   0,	 0,    0,    0,	   0, $EA9, $2AA, $2AB,	   0,	 0,    0,    0,	   0,	 0,  $79,  $7A,	 $7B,	 0,    0,    0,	   0,  $8F,  $90,  $70,	 $71,	 0,    0,  $8F,	 $90,  $91,  $92,  $93,	 $7E; 8000
		dc.w	 0,    0,  $A2,	 $A3,  $A4,    0,    0,	   0,	 0,    0,    0,	 $AF,  $B0,  $B1,    0,	   0,	 0,    0,    0,	   0, $2E8, $2E9,    0,	   0,	 0,    0,    0,	   0, $EE9, $EE8,    0,	   0,	 0,    0,    0,	   0,  $B2,  $B3,  $B4,	   0,	 0,    0,    0,	   0,	 0,  $A9,  $AA,	   0,	 0,    0,    0,	   0,  $A5,  $A6,  $A7,	 $A8,	 0,    0,    0,	   0,  $A9,  $AC,  $AD,	 $AE; 8064
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0, $400,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$340C,$140C,$140C,$140A,	 0,    0,    0,	   0,$341A,$141A,$141A,$1417,	 0,    0,    0,	   0,$369C,$3041,$340B,$3002,$3003,$3042,$340B,$140A,$3024,$3025,$300F,$3010,$3011,$3012,$341A,$1417; 8128
		dc.w	 0,    0,    0,	$558,$2858,$2047,  $48,	$449,	 0,    0,    0,	   0,$20E6,$204E,  $4F,	 $50,	 0,    0,    0,	   0,$204A,$2052,$241C,$2045,	 0,    0,    0,	$28F,$203B,$203C,$203D,$243E,	 0,    0,    0,	 $B5,  $B6,  $B7,  $B8,	 $B9,	 0,    0,    0,	   0,  $BC,  $BD,  $BE,	   0,	 0,    0,    0,	   0,  $6A,  $6B,  $6C,	   0,	 0,    0,    0,	   0,	 0, $2E6, $2E7,	   0; 8192
		dc.w	 0,    0,    0,	   0,	 0, $EE7, $EE6,	   0,	 0,    0,    0,	   0, $484, $483, $482,	   0,	 0,    0,    0,	$484, $483, $482,    0,	   0,	 0,    0,    0,	 $76,  $7F,  $6C,    0,	   0,$3041,$302F,$302F,$302F,$30E1,$30E1,$302E,$302F,$303B,$303C,$303D,$343E,$308B,$302A,$342B,$3050,$3046,$3047,  $48,	 $E5,  $43,  $44, $41C,	 $45,$304D,$304E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 8256
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$100A,$100B,$100B,$300C,	 0,    0,    0,	   0,$1018,$1019,$1019,$301A,$3041,$300B,$300B,$300C,$300D,$3403,$3402,$3005,$304D,$304E,$304F,$3050,$301B,$3012,$3013,$3014; 8320
		dc.w $204A,$2052, $41C,	 $45,  $21,  $1F,  $20,	   0,$203B,$203C,  $3D,	$43E,  $24,  $25,  $26,	 $27,$2858,$2047,  $48,	 $E5,  $43,  $44, $41C,	 $45,$20E6,$204E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E,$204A,$2052, $41C,	 $45,  $46,  $47,  $48,	$449,$203B,$203C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,$2858,$2047,  $48,	$449,  $4A,  $52, $41C,	 $45,$20E6,$204E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 8384
		dc.w   $4A,  $52, $41C,	 $45,  $46,  $47,$2048,$2449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,$204F,$2050,  $46,  $47,  $48,	$449,  $4A,  $52,$241C,$2045,  $4D,  $4E,  $4F,$2050,$203B,$203C,$203D,$243E,  $4A,  $52,$241C,$2045,$2046,$2047,$229B,$2E9A,$203B,$203C,$203D,$243E,$2A96,$2297,$2E98,	$299,$2858,$2047,$2059,$214C,  $7C,  $7D,  $7E,	   0,  $5D,  $5E,  $5B,	$400,	 0,  $6D,  $6E,	   0; 8448
		dc.w	 0,  $72,  $73,	 $78,	 0,    0,    0,	   0, $484, $483, $482,	   0,	 0,    0,    0,	   0,  $85,  $86,  $87,	   0,	 0,    0,    0,	   0,	 0, $2F4, $2F5,	$2F6,	 0,    0,    0,	   0,	 0, $EF6, $EF5,	$EF4,	 0,    0,    0,	   0,	 0,  $72,  $73,	 $74,  $75,    0,    0,	   0,	 0,  $76,  $77,	 $82,  $83,  $84,    0,	   0,  $72,  $73,  $74,	 $72,  $73,  $74,  $75,	   0; 8512
		dc.w   $4A,  $52, $41C,	 $45,  $46,  $47,  $48,	$449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,$204F,$2050,$2046,$2047,  $48,	$449,  $4A,  $52,$241C,$2045,$204D,$204E,  $4F,	 $50,  $3B,  $3C,$203D,$243E,$204A,$2052, $41C,$2045,$2046,  $47,$2048,$2449,$203B,$203C,$203D,$243E,$204D,$204E,$204F,$202C,  $C2,  $B7,  $C3,	 $C4,$204A,$2C55,  $56,	 $5B,  $C7,  $C8,  $C9,	   0, $843,    0,    0,	   0; 8576
		dc.w  $2FD, $2FE, $2FF,	   0,	 0,    0,    0,	   0, $EFF, $EFE, $EFD,	   0,	 0,    0,    0,	   0,	 0,  $AF,  $B0,	 $B1,	 0,    0,    0,	   0,	 0,  $A5,  $A6,	 $A7,  $A8,    0,    0,	   0,$100A,$100B,$100C,$100C,$100C,$100C,$100C,$100C,$1037,$1038,$1038,$1038,$1038,$1038,$1038,$1038,	 0,  $BC,  $BD,	 $BE,	 0,  $BC,  $BD,	 $BE,	 0,  $76,  $77,	   0,	 0,  $76,  $77,	   0; 8640
		dc.w  $442,  $42,   $B,	$40A,	 0,  $72,  $73,	 $78,  $11,  $12, $41A,	$417,	 0,  $76,  $7F,	 $87,  $1E,  $1F,  $41,	   2,	 3,  $42, $40B,	$40A,  $24,  $25,   $F,	 $10,  $11,  $12, $41A,	$417,  $43,  $44, $41C,	 $1D,  $1E,  $1F,  $41,	   2,  $3B,  $3C,  $3D,	$43E,  $24,  $25,   $F,	 $10,  $46,  $47,  $48,	 $E5,  $43,  $44, $41C,	 $1D,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 8704
		dc.w	 0,    0,    0,	$EA9, $2AA, $2AB,    0,	   0,	 0,    0,    0,	   0,  $79,  $7A,  $7B,	   0,	 0,    0,    0,	 $8F,  $90,  $70,  $71,	   0,	 0,  $8F,  $90,	 $91,  $92,  $93,  $94,	 $95,$3003,$3403,$3402,$3005,$30E1,$329C,$329F,$329F,$3011,$3012,$3013,$3014,$308B,$329C,$329C,$329F,  $1E,  $1F,  $20,	 $8B,  $43,  $44,$229C,$229C,  $24,  $25,  $26,	 $E3,  $3B,  $3C,$203D,$243E; 8768
		dc.w	 0,    0,    0,	$400,	 0, $2A4, $2A5,	   0,	 0,    0,    0,	$400,	 0, $EA5, $2A6,	   0,	 0,    0,    0,	   0,	 0,  $6D,  $6E,	   0,	 0,    0,    0,	 $8F,  $90,  $91,  $7A,	 $7B,$3003,$3403,$3402,$3005,$302E,$302F,$30E0,$30E1,$3011,$3012,$3013,$3014,$3024,$3025,$3026,$30E3,  $1E,  $1F,  $20,	 $8B,  $43,  $44, $41C,	$434,  $24,  $25,  $26,	 $E3,  $3B,  $3C,  $3D,	$43E; 8832
		dc.w	 0,    0,  $A9,	 $AA,	 0,    0,    0,	   0,	 0,    0,  $AF,	 $B0,  $B1,    0,    0,	   0,	 0,    0,  $A5,	 $A6,  $A7,  $A8,    0,	   0,	 0,    0,  $A9,	 $AC,  $AD,  $AE,    0,	   0,$30E1,$30E1,$30E1,$30E1,$302E,$302F,$3001,$3002,$308B,$308B,$308B,$308B,$3024,$3025,$300F,$3010,  $8B,  $8B,  $22,	 $23,  $43,  $44, $41C,	 $1D,  $E7,  $E8, $42B,	 $50,  $3B,  $3C,  $3D,	$43E; 8896
		dc.w	 0,    0,    0,	   0,  $6F,  $70,  $71,	   0,	 0,    0,    0,	$47B, $47A, $479,    0,	   0,	 0,    0,    0,	$2A7, $2A8, $2A9,    0,	   0,	 0,    0,    0,	$EA9, $2AA, $2AB,    0,	   0,	 0,    0,    0,	$47E, $47D, $47C,    0,	   0,	 0,    0,  $6F,	 $70,  $71,    0,    0,	   0,	 0,    0,  $7C,	 $7D,  $7E,    0,    0,	   0,	 0,    0,    0,	$2A7, $2A8, $2A9,    0,	   0; 8960
		dc.w	 0,    0,    0,	$400,	 0, $2A4, $2A5,	   0,	 0,    0,    0,	$400,	 0, $EA5, $2A6,	   0,	 0,    0,    0,	   0,	 0,  $6D,  $6E,	   0,	 0,    0,    0,	 $8F,  $90,  $91,  $7A,	 $7B,$3003,$3403,$3402,$3005,$302E,$302F,$3001,$3002,$3011,$3012,$3013,$3014,$3024,$3025,$300F,$3010,  $1E,  $1F,  $20,	 $8B,  $43,  $44, $41C,	 $1D,  $24,  $25,  $26,	 $E3,  $3B,  $3C,  $3D,	$43E; 9024
		dc.w $204A,$2052, $41C,	 $45,  $46,  $47,  $48,	$449,$203B,$203C,$203D,$243E,  $4D,  $4E,  $4F,$2050,$2858,$2047,$2048,$2449,$204A,$2052,$241C,$2045,  $5D,$2A93,$204F,$2050,$203B,$203C,$203D,$243E,	 0,    0, $843,	 $B5,  $B6,  $B7,  $B8,	 $B9,	 0,    0,    0,	   0,  $BC,  $BD,  $BE,	   0,	 0,    0,    0,	   0,  $6A,  $6B,  $6C,	   0,	 0,    0,    0,	   0,	 0,  $82,  $83,	 $84; 9088
		dc.w   $43,  $44, $41C,	 $1D,  $1E,$301F,$3041,$3002,  $3B,  $3C,  $3D,	$43E,  $24,$3025,$300F,$3010,$2046,$2047,  $48,	 $E5,  $43,  $44, $41C,	 $1D,$204D,$204E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E,$204A,$2052, $41C,	 $45,  $46,  $47,  $48,	$449,$203B,$203C,$203D,$243E,$204D,  $4E,  $4F,	 $50,$2858,$2047,$2059,$214C,$204A,  $52, $41C,	 $45,  $5D,  $5E,  $5B,$2166,$203B,$203C,$203D,$243E; 9152
		dc.w  $1F2, $1F3, $1F2,	$1F4, $1F4, $1F3, $1F2,	$1F3, $1F3, $1F2, $1F5,	$1F2, $1F3, $1F2, $1F5,	$1F2, $1F2, $1F5, $1F2,	$1F5, $1F2, $1F5, $1F2,	$1F5, $1F5, $1F2, $1F5,	$1F2, $1F5, $1F2, $1F5,	$1F2, $1F2, $1F5, $1F2,	$1F5, $1F2, $1F5, $1F2,	$1F5, $1F5, $1F2, $1F5,	$DF6, $DF7, $1F2, $1F5,	$1F2, $1F2, $1F5, $1F2,	$1F4, $1F8, $1F5, $1F2,	$1F5, $1F5, $DF6, $DF7,	$1F2, $1F5, $DF6, $DF7,	$1F2; 9216
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0, $6FC,	$2FB, $2FC,    0,    0,	   0,	 0,    0, $EFC,	$EFB, $EFA,    0,    0,	   0,	 0,    0,  $A5,	 $A6,  $A7,  $A8,    0,	   0,	 0,    0,  $A9,	 $AA,  $AF,  $B0,  $B1,	   0; 9280
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0, $6FF,	$2FE, $2FF,    0,    0,	   0,	 0,    0, $EFF,	$AFE, $EFD,    0,    0,	   0,	 0,    0,  $A5,	 $A6,  $A7,  $A8,    0,	   0,	 0,    0,  $A9,	 $AA,  $AF,  $B0,  $B1,	   0,	 0,  $A5,  $A6,	$8AA,  $A5,  $A6,  $A7,	 $A8; 9344
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0, $6F0,	$2EF, $2F0,    0,    0,	   0,	 0,    0, $EF0,	$EEF, $EEE,    0,    0,	   0,	 0,    0,  $72,	 $73,  $74,  $75,    0,	   0,	 0,    0,  $76,	 $77,  $82,  $83,  $84,	   0; 9408
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0, $6F3,	$2F2, $2F3,    0,    0,	   0,	 0,    0, $EF3,	$EF2, $EF1,    0,    0,	   0,	 0,    0,  $72,	 $73,  $74,  $75,    0,	   0,	 0,    0,  $76,	 $77,  $82,  $83,  $84,	   0,	 0,  $72,  $73,	 $74,  $72,  $73,  $74,	 $75; 9472
		dc.w   $4A,  $52, $41C,	 $45,  $46,  $47,  $48,	$449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,  $46,  $47,  $48,	$449,  $4A,  $52, $41C,	 $45,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E,  $4A,  $52, $41C,	 $45,  $46,  $47,$2048,$2449,  $3B,  $3C,  $3D,	$43E,$204D,$204E,$229C,$229C,$3046,$3047,$3048,$3449,$329C,$229C,$229C,	   0,$329C,$329C,$329C,$329C,$329C,    0,    0,	   0; 9536
		dc.w   $A2,  $A3,  $A4,	   0,	 0,    0,    0,	   0,	 0,  $AF,  $B0,	 $B1,	 0,    0,    0,	   0,	 0,    0, $2EA,	$2EB,	 0,    0,    0,	   0,	 0,    0, $EEB,	$EEA,	 0,    0,    0,	   0,	 0,    0,  $B2,	 $B3,  $B4,    0,    0,	   0,	 0,    0,    0,	 $A9,  $AA,    0,    0,	   0,	 0,    0,  $A5,	 $A6,  $A7,  $A8,    0,	   0,	 0,    0,  $A9,	 $AA,  $AF,  $B0,  $B1,	   0; 9600
		dc.w   $4A,  $52, $41C,	 $45,  $46,  $47,$2048,$20E5,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,$204F,$202C,  $46,  $47,  $48,	$449,  $4A,  $52,$241C,$2434,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,$203D,$243E,  $4A,  $52, $41C,	 $45,  $46,  $47,$2048,$2449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,$204F,$2050,  $46,  $47,  $48,	$449,  $4A,  $52, $41C,	 $45,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 9664
		dc.w   $4A,  $52, $41C,	 $45,  $46,  $47,  $48,	$449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,$204F,$2050,  $46,  $47,  $48,	$449,  $4A,  $52,$241C,$2045,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,$203D,$243E,  $4A,  $52, $41C,	 $45,  $46,  $47,$2048,$20E5,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,$204F,$202C,  $46,  $47,  $48,	$449,  $4A,  $52,$241C,$2434,$204D,$204E,$204F,$2050,$203B,$203C,$203D,$243E; 9728
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$329F,$329F,$329C,$302F,$302E,$302F,$3001,$3002,$329F,$329C,$329C,$343E,$3024,$3025,$300F,$3010,$229C,$229C,  $48,	 $E5,  $43,  $44, $41C,	 $1D,$204D,$204E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 9792
		dc.w	 0,    0,    0,	 $C1,  $C2,  $B7,  $C3,	 $C4,	 0,    0,    0,	   0,  $C7,  $C8,  $C9,	   0,	 0,    0,    0,	   0, $2FD, $2FE, $2FF,	   0,	 0,    0,    0,	   0, $EFF, $AFE, $EFD,	   0,	 0,    0,    0,	   0,	 0,  $AF,  $B0,	 $B1,	 0,    0,    0,	   0,	 0,  $A5,  $A6,	 $AB,	 0,    0,    0,	   0,	 0,  $A9,  $A3,	 $A4,	 0,    0,    0,	   0,  $A5,  $AC,  $AD,	 $AE; 9856
		dc.w $204A,$2052,$241C,$2045,$2858,$2047,$2059,$214C,$203B,$203C,$203D,$243E,  $5D,  $5E,  $5B,	   0,  $B6,  $B7,  $B8,	 $B9,	 0,    0,    0,	   0,  $BC,  $BD,  $BE,	   0,	 0,    0,    0,	   0,  $6A,  $6B,  $6C,	   0,	 0,    0,    0,	   0,	 0, $2E4, $2E5,	   0,	 0,    0,    0,	   0,	 0, $EE5, $EE4,	   0,	 0,    0,    0,	   0,	 0,  $76,  $7F,	 $6C,	 0,    0,    0,	   0; 9920
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$100A,$100B,$100B,$100B,	 0,    0,    0,	   0,$1018,$1019,$1019,$1019,$100A,$100B,$100B,$100B,$300B,$300B,$300B,$300B,$1018,$1019,$1019,$1019,$3019,$3038,$3038,$3038; 9984
		dc.w $300A,$340B,$100B,$140A,	 0,    0,    0,	   0,$3017,$301A,$141A,$1417,	 0,    0,    0,	   0,$2017,$201A,$3041,$3002,$3003,$3042,$340B,$140A,$2017,$201A,$300F,$3010,$3011,$3012,$341A,$1417,$2017,$201A,$241C,$201D,$201E,$301F,$3041,$140C,$2191,$203C,$203D,$243E,$2024,$3025,$300F,$1419,  $C2,  $B7,  $C3,	 $C4,	 0,    0,  $56,	$45D,  $C7,  $C8,  $C9,	   0,	 0,    0,    0,	   0; 10048
		dc.w	 0,  $68,  $69,	   0,	 0, $2E6, $2E7,	   0, $475, $474, $473,	$472,	 0, $EE7, $EE6,	   0,$140B,$140B,$140B,$140A,	 0,  $76,  $77,	   0,$1C19,$1C19,$1C19,$1C17,  $72,  $73,  $74,	 $75,$3003,$3042,$340C,$140C,$140B,$140B,$140B,$140A,$3011,$3012,$341A,$141A,$1C19,$1C19,$1C19,$1C17,  $1E,$301F,$3041,$3002,$3003,$3042,$340C,$140C,  $24,$3025,$300F,$3010,$3011,$3012,$341A,$141A; 10112
		dc.w	 0,    0, $47E,	$47D, $47C,    0,    0,	   0,	 0,  $6F,  $70,	 $71,	 0,    0,    0,	   0,	 0,  $7C,  $7D,	 $7E,	 0,    0,    0,	   0,	 0,    0, $2A7,	$2A8, $2A9,    0,    0,	   0,	 0,    0, $EA9,	$2AA, $2AB,    0,    0,	   0,	 0,    0,    0,	 $79,  $7A,  $7B,    0,	   0,	 0,    0,  $8F,	 $90,  $70,  $71,    0,	   0,  $8F,  $90,  $91,	 $92,  $93,  $7E,    0,	   0; 10176
		dc.w  $1F9, $1FA, $1FB,	$1FC, $1FD, $1FE, $1FF,	$200, $201, $202, $203,	$204, $205, $206, $201,	$207, $208, $209, $20A,	$20B, $20C, $20D, $20E,	$20C, $20F, $210, $211,	$212, $210, $213, $20F,	$210, $216, $217, $218,	$219, $217, $238, $216,	$217, $21B, $21C, $21D,	$21E, $21F, $21B, $21C,	$21B, $221, $222, $223,	$224, $225, $226, $227,	$228, $229, $22A, $22B,	$22C, $22D, $22B, $22C,	$229; 10240
		dc.w  $1FE, $1F9, $1FA,	$1FB, $1FC, $1FD, $1FE,	$1FF, $206, $201, $202,	$203, $204, $205, $206,	$9B7, $20D, $208, $209,	$20A, $20B, $20C, $20D,	$20D, $231, $232, $E18,	$233, $234, $235, $236,	$237, $238, $239, $23A,	$23B, $23C, $23A, $23D,	$1F8, $23E, $1F8, $1F8,	$21D, $21E, $21F, $21B,	$21F, $221, $222, $223,	$224, $227, $225, $226,	$224, $229, $22A, $22B,	$22D, $22D, $22B, $22C,	$22D; 10304
		dc.w  $1F2, $1F3, $1F2,	$1F4, $1F4, $1F3, $1F2,	$1F3, $1F3, $1F2, $1F5,	$1F2, $1F3, $1F2, $1F5,	$1F2, $1F2, $1F5, $1F2,	$1F5, $1F2, $1F5, $1F2,	$1F5, $1F5, $1F2, $1F5,	$1F2, $1F5, $1F2, $1F5,	$1F2, $1F2, $1F5, $1F2,	$1F5, $1F2, $1F5, $1F2,	$1F5, $1F5, $1F2, $1F5,	$DF6, $DF7, $1F2, $1F5,	$1F2, $1F2, $1F5, $1F2,	$1F4, $1F8, $1F5, $1F2,	$1F5, $1F5, $DF6, $DF7,	$1F2, $1F5, $DF6, $DF7,	$1F2; 10368
		dc.w  $DF2, $DF7, $1F8,	$1F5, $DF2, $DF7, $1F8,	$1F5, $1F5, $DF2, $1F5,	$DF6, $1F4, $DF2, $1F5,	$DF2, $1F2, $1F5, $DF2,	$DF7, $1F8, $1F5, $DF2,	$1F5, $1F5, $DF2, $1F5,	$DF2, $1F5, $DF2, $1F5,	$DF2, $1F2, $1F5, $DF2,	$1F5, $DF2, $1F5, $DF2,	$1F5, $1F5, $DF2, $1F5,	$DF2, $1F5, $DF2, $1F5,	$DF2, $DF2, $1F5, $DF2,	$DF3, $DF2, $1F5, $DF2,	$1F5, $DF3, $DF2, $DF3,	$1F4, $1F4, $DF2, $DF3,	$DF2; 10432
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 10496
		dc.w   $41,    2,    3,	 $42, $40C, $40B, $40B,	$40A,	$F,  $10,  $11,	 $12, $41A, $419, $419,	$417,  $46,  $47,  $41,	   2,	 3,  $42, $40C,	$40B,  $4D,  $4E,   $F,	 $10,  $11,  $12, $41A,	$419,  $4A,  $52, $41C,	 $1D,  $1E,  $1F,  $41,	   2,  $3B,  $3C,  $3D,	$43E,  $24,  $25,   $F,	 $10,  $46,  $47,  $48,	 $E5,  $43,  $44, $41C,	 $1D,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 10560
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 10624
		dc.w $229F,$229F, $29C,	 $45,  $46,  $47,  $48,	$449,$229F,$229C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,$229C,$2047,  $48,	$449,  $4A,  $52, $41C,	 $45,$204D,$204E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E,  $4A,  $52, $41C,	 $45, $858,  $47,  $59,	$14C,  $3B,  $3C,  $3D,	$43E,  $5D,  $5E,  $5B,	 $8B,  $46,  $47,  $48,	 $E5,  $43,  $44, $41C,	$434,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 10688
		dc.w   $4A,  $52, $41C,	 $45,  $46,  $47,  $48,	$449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,$2046,$2047,  $48,	$449,  $4A,  $52, $41C,	 $45,$204D,$204E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E,$204A,$2052, $41C,	 $45,  $46,  $47,  $48,	$449,$203B,$203C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,$2858,$2047,  $48,	$449,  $4A,  $52, $41C,	 $45,$20E6,$204E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 10752
		dc.w $204A,$2052, $41C,	 $45,  $46,  $47,  $48,	$449,$203B,$203C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,$2858,$2047,  $48,	$449,  $4A,  $52, $41C,	 $45,$20E6,$204E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E,$204A,$2052, $41C,	 $45,  $46,  $47,  $48,	$449,$203B,$203C,  $3D,	$43E,  $4D,  $4E,  $4F,	 $50,  $46,  $47,  $48,	$449,  $4A,  $52, $41C,	 $45,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 10816
		dc.w	 0,    0,    0,	   0,	 0,    0, $2E6,	$2E7,	 0,    0,    0,	   0,	 0,    0, $EE7,	$EE6,	 0,    0,    0,	   0,	 0, $484, $483,	$482,	 0,    0,    0,	   0, $484, $483,  $6B,	 $6C,$3041,$302F,$302F,$302F,$302E,$302F,$3001,$3002,$303B,$303C,$303D,$343E,$3024,$3025,$300F,$3010,  $46,  $47,  $48,	 $E5,  $43,  $44, $41C,	 $1D,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,  $3D,	$43E; 10880
		dc.w   $4A,  $52, $41C,	 $45,  $46,  $47,  $48,$2449,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,$204F,$2050,  $46,  $47,  $48,	$449,  $4A,  $52,$241C,$2045,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,$203D,$243E,  $4A,  $52, $41C,	 $45,$2046,$2047,$229B,$2E9A,$203B,$203C,$203D,$243E,$2A96,$2297,$2E98,	$299,$2858,$2047,$2059,$214C,  $6D,  $6E,    0,	   0,  $5D,  $5E,  $5B,	   0,  $79,  $7A,  $7B,	$400; 10944
		dc.w $3003,$3403,$3402,$3005,$30E1,$30DF,$300B,$34ED,$3011,$3012,$3013,$3014,$3000,$3414,$3191,$3592,  $1E,  $1F,    6,	   7,	 8,  $44,$2191,$2592,  $24,  $25,   $F,	 $15,  $16,  $3C,$2191,$2592,  $43,  $44, $41C,	 $45,  $46,  $47,$2191,$2592,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,$2191,$2592,  $46,  $47,  $48,	$449,  $4A,  $52,$241C,$2434,  $4D,  $4E,  $4F,$2050,$203B,$203C,$203D,$243E; 11008
		dc.w $204A,$2052, $41C,	 $45,  $46,  $47,  $48,	$449,$203B,$203C,$203D,	$43E,  $4D,  $4E,  $4F,	 $50,$2858,$2047,$2048,$2449,$204A,$2052,$241C,$2045,  $5D,$2A93,$204F,$2050,$203B,$203C,$203D,$243E,	 0,    0,    0,	 $C1,  $C2,  $B7,  $C3,	 $C4,	 0,    0,    0,	   0,  $C7,  $C8,  $C9,	   0,	 0,    0,    0,	   0,  $A2,  $A3,  $A4,	   0,	 0,    0,    0,	   0,	 0,  $AF,  $B0,	 $B1; 11072
		dc.w	 0,    0,    0,	   0,	 0,    0, $2E8,	$2E9,	 0,    0,    0,	   0,	 0,    0, $EE9,	$EE8,	 0,    0,    0,	   0,	 0,    0,  $A9,	 $AA,	 0,    0,    0,	   0,	 0, $4B4, $4B3,	$4B2,	 0,    0,    0,	   0,  $A5,  $A6,  $AB,	   0,	 0,    0,    0,	   0,  $B2,  $B3,  $B4,	   0,	 0,    0,    0,	   0,	 0,  $B2,  $B3,	 $B4,	 0,    0,    0,	   0,	 0, $4B1, $4B0,	$4AF; 11136
		dc.w   $4A,  $52, $41C,	 $45,  $46,  $47,$2048,$20E5,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,$204F,$202C,  $46,  $47,  $48,	$449,  $4A,  $52,$241C,$2434,  $4D,  $4E,  $4F,	 $50,  $3B,  $3C,$203D,$243E,  $4A,  $52, $41C,	 $45,  $46,  $47,$2048,$229C,  $3B,  $3C,  $3D,	$43E,  $4D,  $4E,$229C,$229F, $858,  $47,  $59,	$85A,  $4A, $29C,$229C,$229F,  $5D,  $5E,  $5B,	   0, $843,  $8B,$229F,$229F; 11200
		dc.w  $246, $247, $248,	$249, $24A, $24B, $24C,	$24D, $A21, $A22, $A23,	$A24, $A25, $A26, $A27,	$A28, $A1B, $A1C, $A1D,	$A1E, $A1F, $A1B, $A1C,	$A1B, $A16, $A17, $A18,	$A19, $A17, $A38, $A16,	$A17, $A0F, $A10, $A11,	$A12, $A10, $A13, $A0F,	$A10, $A08, $A09, $A0A,	$A0B, $A0C, $A0D, $A0E,	$A0C, $A01, $A02, $A03,	$A04, $A05, $A06, $A01,	$A07, $9F9, $9FA, $9FB,	$9FC, $9FD, $9FE, $9FF,	$A00; 11264
		dc.w  $246, $247, $248,	$249, $24A, $24B, $24C,	$24D, $A21, $A22, $A23,	$A24, $A27, $A25, $A26,	$A24, $A3E, $9F8, $9F8,	$A1D, $A1E, $A1F, $A1B,	$A1F, $A38, $A39, $A3A,	$A3B, $A3C, $A3A, $A3D,	$9F8, $A31, $A32, $618,	$A33, $A34, $A35, $A36,	$A37, $A0D, $A08, $A09,	$A0A, $A0B, $A0C, $A0D,	$A0D, $A06, $A01, $A02,	$A03, $A04, $A05, $254,	$1B7, $9FE, $9F9, $9FA,	$9FB, $9FC, $9FD, $9FE,	$9FF; 11328
		dc.w  $1F2, $1F4, $1F8,	$1F5, $1F2, $1F4, $1F8,	$1F5, $DF7, $1F2, $1F5,	$DF6, $DF7, $1F2, $1F5,	$DF6, $1F8, $1F5, $1F2,	$1F4, $1F8, $1F5, $1F2,	$1F4, $1F5, $DF6, $DF7,	$1F2, $1F5, $DF6, $DF7,	$1F2, $1F2, $1F4, $1F8,	$1F5, $1F2, $1F4, $1F8,	$1F5, $DF7, $1F2, $1F5,	$DF6, $DF7, $1F2, $1F5,	$DF6, $1F8, $1F5, $1F2,	$1F4, $1F8, $1F5, $1F2,	$1F4, $1F5, $DF6, $DF7,	$1F2, $1F5, $DF6, $DF7,	$1F2; 11392
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 11456
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 11520
		dc.w $204A,$2052,$241C,$2045,$2858,$2047,$2059,$214C,$203B,$203C,$203D,$243E,  $5D,  $5E,  $5B,	   0,  $B6,  $B7,  $B8,	 $B9,	 0,    0,    0,	   0,  $BC,  $BD,  $BE,	   0,	 0,    0,    0,	   0,  $6A,  $6B,  $6C,	   0,	 0,    0,    0,	   0,	 0, $2E2, $2E3,	   0,	 0,    0,    0,	   0,	 0, $EE3, $EE2,	   0,	 0,    0,    0,	   0,	 0,  $6A,  $6B,	 $6C,	 0,    0,    0,	   0; 11584
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 11648
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$329F,$329F,$329F,$329F,$329F,$329F,$329F,$329F,$329F,$329F,$32A0,$32A0,$32A0,$329F,$329F,$32A0,	 0,$32A1,$32A0,$36A1,$308B,$32A1,$36A1,$308B,	 0,    0,$32A1,$32A0,$32A0,$32A0,$32A0,$32A0; 11712
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$329F,$329F,$329F,$329F,$329F,$329F,$329F,$329F,$32A0,$329F,$329F,$32A0,$32A0,$32A0,$329F,$329F,$308B,$32A1,$36A1,$308B,$32A1,$32A0,$36A1,	   0,$32A0,$32A0,$32A0,$32A0,$32A0,$36A1,    0,	   0; 11776
		dc.w	 0,    0,    0,	$EA9, $2AA, $2AB,    0,	   0,	 0,    0,    0,	   0,  $79,  $7A,  $7B,	   0,	 0,    0,    0,	 $8F,  $90,  $70,  $71,	   0,	 0,  $8F,  $90,	 $91,  $92,  $93,  $94,	 $95,$3003,$3403,$3402,$3005,$30E1,$30DF,$300B,$34ED,$3011,$3012,$3013,$3014,$308B,$3414,$3191,$3592,  $1E,  $1F,  $20,	 $8B,  $43,  $44,$229C,$229C,  $24,  $25,  $26,	 $E3,  $3B,  $3C,$203D,$229C; 11840
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 11904
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 11968
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 12032
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 12096
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 12160
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 12224
		dc.w  $1B8, $1B9, $1BA,	$1BB, $1B8, $1B9, $1BA,	$1BB, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1B9, $1BC, $1BD, $1BE,	$1BF, $1BE, $1B9, $1D4,	$1C3, $1C4, $1BF, $1C5,	$1BD, $1C2, $1C0, $1C7,	$1C7, $1C8, $1C6, $1C7,	$5C0; 12288
		dc.w  $1B8, $1B9, $1BA,	$1BB, $1B8, $1B9, $1BA,	$1BB, $1BC, $1BD, $1BE,	$1BF, $1D4, $1BD, $1BE,	$1BF, $1BE, $1BF, $1BC,	$1D8, $1C7, $5D5, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1C1, $1CA, $1CB, $1BE,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1CC, $1CD, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1CE, $1CF, $1BE,	$1B9, $1BE, $1BF, $1BC,	$1BD, $1D0, $1D1, $1C2,	$1C0, $1BC, $1BD, $1BE,	$1BF, $1D2, $1D3, $1BE,	$1C1; 12352
		dc.w  $1B8, $1B9, $1BA,	$1BB, $1B8, $1B9, $1BA,	$1BB, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1B9, $1BC, $1BD, $1BE,	$1BF, $1BE, $1B9, $1C9,	$1C3, $1C4, $1BF, $1BC,	$1BD, $1D4, $1C0, $1C7,	$1C7, $1C8, $1C6, $1C4,	$1BF, $1C7, $1C7, $1C7,	$1C7, $1C7, $1C7, $1C8,	$1BD, $1C7, $1C7, $1C7,	$1C7, $1C7, $1C7, $1D7,	$1BF; 12416
		dc.w  $1B8, $1B9, $1BA,	$1BB, $1B8, $1B9, $1BA,	$1BB, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1BE, $1B9, $1C9,	$1C6, $1BC, $1BD, $1BE,	$1BF, $1D4, $1C0, $1C7,	$1C7; 12480
		dc.w  $1B8, $1B9, $1BA,	$1BB, $1B8, $1B9, $1BA,	$1BB, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1D8, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1C1, $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF, $1C4, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1C8, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF; 12544
		dc.w  $1B8, $1B9, $1BA,	$1BB, $1B8, $1B9, $1BA,	$1BB, $1D4, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF, $1C7, $5D5, $1C5,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1CA, $1CA, $1EA,	$1BF, $1BC, $1BD, $1BE,	$1BF, $1CC, $1CC, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1CE, $1CE, $1BE,	$1B9, $1BC, $1BD, $1BE,	$1BF, $1D0, $1D0, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1D2, $1D2, $1C4,	$1BF, $1C9, $1C6, $1C4,	$1BF; 12608
		dc.w  $1B8, $1B9, $1BA,	$1BB, $1B8, $1B9, $1BA,	$1BB, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1C2, $1C0, $1C4,	$1BF; 12672
		dc.w  $1B8, $1B9, $1BA,	$1BB, $1B8, $1B9, $1BA,	$1BB, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1C2, $1BD, $1BE,	$1BF; 12736
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 12800
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 12864
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 12928
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 12992
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 13056
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 13120
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 13184
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 13248
		dc.w  $1D8, $1C7, $1C7,	$1C7, $1C7, $1C7, $1C7,	$1D6, $1DA, $1C7, $1C7,	$1C7, $1C7, $1C7, $1D7,	$1BF, $1BE, $1C1, $1C7,	$1C7, $1C7, $1C7, $1DB,	$1BD, $1C2, $1C3, $1C7,	$1C7, $1DD, $1D6, $1BE,	$1BF, $1BE, $1C1, $1CA,	$1D6, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1CC,	$1BF, $1BC, $1BD, $1BE,	$1BF, $1BE, $1BF, $1CE,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1D0,	$1BF, $1BC, $1BD, $1BE,	$1BF; 13312
		dc.w  $1BE, $1BF, $1BC,	$1BD, $1CC, $1CC, $1BC,	$1C3, $1BC, $1BD, $1BE,	$1BF, $1CE, $1CE, $1BE,	$1C1, $1BE, $1BF, $1BC,	$1BD, $1D0, $1D0, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1CE, $1CE, $1C4,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1DE, $1DE, $1C8,	$1C6, $1BC, $1BD, $1BE,	$1B9, $1DF, $1DF, $1C7,	$1C7, $1BE, $1BF, $1C2,	$1C0, $1E1, $1E1, $1C7,	$1C7, $1BC, $1BD, $1C0,	$1C7, $1E2, $1E2, $1C7,	$1C7; 13376
		dc.w  $1C7, $1C7, $1C7,	$1C7, $1C7, $1C7, $1C8,	$1BD, $1DD, $1C7, $1D7,	$1C1, $1C7, $1C7, $1D7,	$1BF, $1BE, $1C1, $1DB,	$1C3, $1C7, $1C7, $1C8,	$1BD, $1BC, $1BD, $1BE,	$1C1, $1CA, $1CB, $1EA,	$1BF, $1C4, $1BF, $1BC,	$1BD, $1E3, $1E3, $1BC,	$1BD, $1C8, $1BD, $1BE,	$1BF, $1E4, $1E4, $1BE,	$1BF, $1D7, $1BF, $1BC,	$1BD, $1E5, $1E5, $1BC,	$1C0, $1C8, $1BD, $1BE,	$1BF, $1E6, $1E6, $1BE,	$1C1; 13440
		dc.w  $1BE, $1BF, $1BC,	$1BD, $1EA, $1C1, $1CA,	$1D6, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1CC,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1CE,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1D0,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1D2,	$1BD, $1C9, $1C6, $1BE,	$1B9, $1C9, $1C6, $1DE,	$1BF, $1C7, $1C7, $1D4,	$1C0, $1C7, $1C7, $1DF,	$1C6, $1C7, $1C7, $1C7,	$1C7, $1C7, $1C7, $1E1,	$1C7; 13504
		dc.w  $1EA, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1B9, $1BC, $1BD, $1BE,	$1B9, $1BE, $1BF, $1C2,	$1C0, $1C4, $1BF, $1C2,	$1C0, $1C2, $1C3, $1C0,	$1C7, $1C8, $1C3, $1C0,	$1C7, $1BE, $1C1, $1DD,	$1C7, $1D7, $1C1, $1DD,	$1CB, $1BC, $1BD, $1BE,	$1C1, $1BC, $1BD, $1BE,	$1E6, $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1E3, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1E4; 13568
		dc.w  $1DE, $1DE, $1C8,	$1C6, $1C7, $1C7, $1C8,	$1C6, $1DF, $1DF, $1C7,	$1C7, $1C7, $1C7, $1C7,	$1C7, $1E1, $1E1, $1C7,	$1C7, $1C7, $1C7, $1C7,	$1C7, $1E2, $1E2, $1C7,	$1C7, $1C7, $1C7, $1C7,	$1C7, $1E9, $1E9, $1CB,	$1CB, $1EA, $1C1, $1CB,	$1CB, $1E6, $1E6, $1E6,	$1E6, $1BC, $1BD, $1E6,	$1E6, $1E3, $1E3, $1E3,	$1E3, $1BE, $1BF, $1E3,	$1E3, $1E4, $1E4, $1E4,	$1E4, $1BC, $1BD, $1E4,	$1E4; 13632
		dc.w  $1BE, $1BF, $1C2,	$1C3, $1C0, $1C7, $1C8,	$1BD, $1C8, $1BD, $1BE,	$1C1, $1DD, $1C7, $1D7,	$1BF, $1D7, $1BF, $1BC,	$1BD, $1BE, $1C1, $1BC,	$1BD, $1C8, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF, $1EA, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF; 13696
		dc.w  $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF; 13760
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 13824
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 13888
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 13952
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 14016
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 14080
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 14144
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 14208
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 14272
		dc.w  $1BE, $1BF, $1D2,	$1BD, $1BE, $1BF, $1C2,	$1C0, $1BC, $1BD, $1CC,	$1BF, $1C2, $1C3, $1C0,	$1C7, $1BE, $1BF, $1CE,	$1BD, $1BE, $1C1, $1DD,	$1C7, $1BC, $1BD, $1D0,	$1BF, $1BC, $1BD, $1BE,	$1C1, $1BE, $1BF, $1F0,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF; 14336
		dc.w  $1C4, $1BF, $1DD,	$1CB, $1E9, $1E9, $1CB,	$1CB, $1C8, $1BD, $1BE,	$1E6, $1E6, $1E6, $1E6,	$1E6, $1D7, $1BF, $1BC,	$1E3, $1E3, $1E3, $1E3,	$1E3, $1BC, $1BD, $1BE,	$1E4, $1E4, $1E4, $1E4,	$1E4, $1BE, $1BF, $1BC,	$1E5, $1E5, $1E5, $1E5,	$1E5, $1BC, $1BD, $1BE,	$1E6, $1E6, $1E6, $1E6,	$1E6, $1BE, $1BF, $1BC,	$1E8, $1EB, $1EC, $1ED,	$1E8, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF; 14400
		dc.w  $1EA, $1BF, $1BC,	$1BD, $1E3, $1E3, $1C2,	$1C3, $1BC, $1BD, $1BE,	$1BF, $1E4, $1E4, $1BE,	$1C1, $1BE, $1BF, $1BC,	$1BD, $1E5, $1E5, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1E6, $1E6, $1BE,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1E3, $1E3, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1E4, $1E4, $1BE,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1EB, $1ED, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF; 14464
		dc.w  $1C7, $1C7, $1C7,	$1C1, $1C7, $1C7, $1E2,	$1D6, $1CA, $1CB, $1D7,	$1C1, $1CA, $1CB, $1EF,	$1BF, $1CE, $1E5, $1C2,	$1BD, $1E3, $1E3, $1CE,	$1BD, $1D0, $1E6, $1BF,	$1BF, $1E4, $1E4, $1D0,	$1BF, $1D2, $1E3, $1BC,	$1BD, $1EB, $1EC, $1D2,	$1BD, $1CC, $1E4, $1BE,	$1BF, $1BC, $1BD, $1F0,	$1BF, $1F0, $5ED, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF; 14528
		dc.w  $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1E5, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1E6, $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1E3, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1E4, $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1E8, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF; 14592
		dc.w  $1E5, $1E5, $1E5,	$1E5, $1BE, $1BF, $1E5,	$1E5, $1E6, $1E6, $1E6,	$1E6, $1BC, $1BD, $1E6,	$1E6, $1E3, $1E3, $1E3,	$1E3, $1BE, $1BF, $1ED,	$1E8, $1E4, $1E4, $1E4,	$1E4, $1BC, $1BD, $1BE,	$1BF, $1EB, $1EC, $1ED,	$1E8, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF; 14656
		dc.w  $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1B9, $1C9, $1C6, $1C4,	$1BF, $1BE, $1B9, $1D4,	$1C0, $1C7, $1C7, $1C8,	$1BD, $1BC, $1C0, $1C7,	$1C7, $1D9, $1D6, $1EA,	$1BF, $1BE, $1C1, $1DD,	$1D6, $1EA, $1BF, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF; 14720
		dc.w  $1BE, $1BF, $1BC,	$1D8, $1C7, $5D5, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1C1, $1CA, $1CB, $1BE,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1D2, $1E3, $1BC,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1CC, $1E4, $1BE,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1F0, $5ED, $1C2,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF, $1BE, $1BF, $1BC,	$1BD, $1BE, $1BF, $1C2,	$1BD, $1BC, $1BD, $1BE,	$1BF, $1BC, $1BD, $1BE,	$1BF; 14784
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 14848
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 14912
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 14976
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15040
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15104
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15168
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15232
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15296
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15360
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15424
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15488
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15552
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15616
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15680
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15744
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15808
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15872
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15936
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 16000
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 16064
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 16128
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 16192
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 16256
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 16320
Map16_CPZ:	dc.w $4000,$4000,$4000,$4000,$A001,$A002,$A001,$A002,$E003,$E803,$E004,$E005,$E006,$E006,$8007,$8008,$E006,$E006,$8008,$8807,$A009,$A00A,$A009,$A00A,$E00B,$E00B,$E00C,$E00C,$E00D,$E00E,$E00D,$E00E,$E00E,$E00F,$E00E,$E00F,$E010,$E010,$E011,$E011,$A012,$E013,$A014,$E015,$A016,$E017,$A018,$E019,$E01A,$E01A,$E01B,$E01B,$E01C,$E01D,$E013,$E01E,$E01D,$E01F,$E01E,$E017,$A020,$A021,$A022,$A023; 0
					; DATA XREF: ROM:0001C000t
					; ROM:0001C010t
		dc.w $E024,$E025,$E026,$E027,$E028,$E029,$E02A,$E02B,$E02C,$E02D,$E02C,$E02E,$E02D,$E02C,$E02E,$E02C,$A02F,$E015,$A030,$E031,$A018,$E019,$A010,$E032,$E033,$E034,$E035,$E835,$E036,$E037,$E038,$E039,$A03A,$A03B,$A03C,$803D,$A03E,$A023,$803F,$8040,$E041,$E042,$E043,$E044,$E045,$E046,$E047,$E048,$E02C,$E02E,$E02C,$F02D,$E02E,$E02C,$F02D,$E02C,$E049,$E04A,$E049,$E04A,$E04B,$E04C,$E04B,$E04C; 64
		dc.w $E003,$E803,$E04D,$E04D,$E04E,$E84E,$E006,$E006,$E04F,$E050,$E051,$E052,$E053,$E054,$E055,$E056,$A057,$A058,$A059,$A05A,$A058,$A057,$A05A,$A059,$A012,$A05B,$A014,$A05C,$A05B,$A012,$A05C,$A014,$E013,$A016,$E015,$A018,$E017,$A012,$E019,$A014,$E006,$E006,$E05D,$E05E,$E05F,$E060,$E061,$E861,$E062,$E063,$E064,$E065,$E066,$E067,$E068,$E069,$A06A,$A06B,$A06C,$A06D,$A06B,$A06A,$A06D,$A06C; 128
		dc.w $A02F,$A06B,$A030,$A06D,$A06B,$A02F,$A06D,$A030,$E015,$A018,$E031,$A010,$E019,$A02F,$E032,$A030,$A06E,$A06F,$E070,$E071,$A06E,$A06F,$E072,$E073,$A06E,$A06F,$E068,$E069,$E074,$E075,$E076,$E077,$E074,$E075,$E877,$E077,$E074,$E075,$E877,$E078,$E079,$E07A,$E079,$E07A,$E079,$E07A,$E07B,$E07C,$E070,$E071,$E07B,$E07C,$E07D,$E07E,$A07F,$A080,$E07D,$E07E,$A081,$A080,$E07D,$E07E,$A080,$A081; 192
		dc.w $E07D,$E07E,$A080,$A87F,$E070,$E071,$E079,$E07A,$E082,$E083,$E084,$E085,$E083,$E086,$E085,$E087,$E083,$E083,$E085,$E085,$E076,$E077,$E07D,$E07E,$E877,$E077,$E088,$E089,$E877,$E077,$E07D,$E07E,$E877,$E078,$E07D,$E07E,$E07D,$E07E,$E08A,$E08A,$E088,$E088,$E08A,$E08A,$E049,$E04A,$E08B,$E08C,$E04B,$E04C,$E08D,$E88B,$E08B,$E08E,$E08B,$E08F,$E08D,$E88B,$E08D,$E88B,$E090,$A091,$E092,$A093; 256
		dc.w $E08B,$E094,$E08B,$E095,$E096,$E88B,$E097,$E88B,$E08B,$E098,$E08B,$E099,$E09A,$E01A,$E09B,$E01B,$E04D,$A09C,$A09D,$A09E,$A09F,$A0A0,$E0A1,$E0A2,$A0A3,$A0A4,$E0A5,$E0A6,$F066,$F067,$F055,$F056,$E0A7,$E0A7,$E0A8,$E0A8,$E0A7,$E0A9,$E0A8,$E0AA,$E0AB,$E08E,$E0AC,$E0AD,$E08F,$E08C,$E0AD,$E8AC,$E0A9,$E0A7,$E0AA,$E0A8,$F0AA,$E08C,$E0AE,$E0AC,$E0AF,$E0B0,$E0B1,$E0B2,$E07D,$E07E,$E07D,$E07E; 320
		dc.w $E000,$E000,$E000,$E0B3,$E0B4,$E8B4,$E0B5,$E8B5,$E08E,$E08F,$E0AD,$E0B6,$E08C,$F0AA,$E8AC,$E0B7,$E0B8,$E0B9,$E0BA,$E0BB,$E0B3,$E0BC,$E0BC,$E0BD,$E0BE,$E8BE,$E0BF,$E010,$A06F,$A06E,$E010,$E010,$A06F,$A06E,$E010,$E0C0,$A06F,$A06E,$E0C1,$E0C2,$A06F,$E0C3,$E0C4,$E0C5,$E0C3,$A06F,$E0C5,$E8C4,$A06E,$A06F,$E8C2,$E8C1,$A06E,$A06F,$E8C0,$E010,$E0BA,$E0BB,$E0C6,$E0C7,$E0BD,$E0BF,$E0BF,$E010; 384
		dc.w $E0C8,$E0C8,$E010,$E010,$E0C9,$E0CA,$E0CB,$F8C8,$E0CC,$E0CD,$E0CE,$E0CF,$E000,$E000,$E0D0,$E0D1,$E000,$E000,$E0D2,$E0D3,$E0CC,$E0CD,$E0CE,$E8CF,$E0C9,$E0CA,$E0CB,$F0C8,$A06E,$A06F,$E010,$E010,$E0D4,$E0D5,$E0D4,$E0D6,$E0C8,$E010,$E0C8,$E010,$E0D7,$E0D8,$E0D9,$E0DA,$E000,$E0DB,$E0DC,$E0DD,$E010,$E010,$E8C8,$E8C8,$E0C9,$E0CA,$E0CB,$E0C8,$E0CC,$E0CD,$E0CE,$F0CF,$E0B4,$E8B4,$E0DE,$E8DE; 448
		dc.w $E010,$E0C8,$E010,$E0C8,$E0DF,$E0E0,$E0E1,$E0E2,$E072,$E073,$E074,$E075,$E0E3,$E0E4,$E0E5,$F8C8,$E000,$E0E6,$E0DB,$E0E7,$E0E8,$E0E9,$E0EA,$F0CF,$A057,$A058,$A059,$A05A,$A058,$A058,$A05A,$A05A,$A058,$E0EB,$A05A,$E0EC,$E0ED,$E0EE,$E0EF,$E02D,$E0E3,$E0E4,$E0E5,$F0C8,$E0F0,$F0E2,$E0F1,$E0F2,$E0C8,$E010,$E0C8,$E0F3,$E0E8,$E0E9,$E0EA,$E0CF,$E8EE,$E8ED,$E02D,$E8EF,$E0E3,$E0E4,$E0E5,$E0C8; 512
		dc.w $A06A,$A0F4,$A06C,$A0F5,$A0F4,$A0F4,$A0F5,$A0F5,$A0F4,$E0F6,$A0F5,$E0F7,$E0F8,$E0F9,$E0FA,$E0F9,$E0E8,$E0E9,$E0EA,$E8CF,$E010,$E0C8,$E8F3,$E0C8,$E0C8,$F8FA,$E0C8,$F8F8,$E000,$E0FB,$E000,$E0FC,$E0F9,$E8F8,$E0F9,$E8FA,$E8C8,$E010,$E8C8,$E010,$A058,$A057,$A05A,$A059,$A858,$E0FD,$A85A,$E0FE,$E0E8,$E0E9,$E0EA,$F8CF,$F8F3,$E02E,$E010,$E0F9,$E0FF,$E100,$E0BA,$E0BB,$F0FA,$E0C8,$F0F8,$E0C8; 576
		dc.w $E0C8,$F8EF,$E8EE,$E8ED,$E000,$E101,$E000,$E102,$E02E,$F0F3,$E0F9,$E010,$E8C8,$E010,$E8C8,$E8C8,$A0F4,$A06A,$A0F5,$A06C,$A8F4,$E103,$A8F5,$E104,$E0E3,$E0E4,$E0E5,$E0C8,$E889,$E0F9,$E889,$E0F9,$E0BA,$E0BB,$E105,$E106,$F0EF,$E0C8,$E0ED,$E0EE,$E107,$E108,$A06F,$A06E,$E109,$E10A,$A06F,$A06E,$E0F9,$E089,$E0F9,$E089,$E0CC,$E0CD,$E0CE,$F8CF,$E0C9,$E0CA,$E0CB,$E0C8,$E010,$E010,$E0C8,$E0C8; 640
		dc.w $E010,$E0C8,$E0C8,$E0C8,$E889,$E02E,$E889,$E0F9,$A10B,$A10C,$A10D,$A10E,$A10F,$A110,$A111,$A112,$E010,$E010,$A06F,$A06E,$E010,$F0C0,$A06F,$A06E,$E02E,$E089,$E0F9,$E089,$F8C0,$E010,$A06E,$A06F,$E010,$E010,$A06E,$A06F,$E10A,$E909,$A06E,$A06F,$E908,$E907,$A06E,$A06F,$E889,$E0F9,$E889,$F02D,$A10D,$A10E,$A10D,$A10E,$A111,$A112,$A111,$A112,$F0C1,$F0C2,$A06F,$A06E,$F0C4,$F0C5,$A06F,$F0C3; 704
		dc.w $E0F9,$E089,$F02D,$E089,$F0C5,$F8C4,$F0C3,$A06F,$E070,$E113,$E07B,$E114,$E913,$E071,$E914,$E07C,$E113,$E913,$E114,$E914,$A091,$A891,$A091,$A891,$A10D,$A10E,$A10B,$A10C,$A111,$A112,$A10F,$A110,$A115,$A05B,$A116,$A05C,$A05B,$A117,$A05C,$A118,$A05B,$A05B,$A05C,$A05C,$E0DE,$E8DE,$E0DE,$E8DE,$E0BE,$E8BE,$E0DE,$E8DE,$E0DE,$E8DE,$E0B5,$E8B5,$A06E,$A06F,$E053,$E054,$E000,$E000,$E119,$E11A; 768
		dc.w $811B,$811C,$811D,$811E,$811C,$E086,$811E,$E087,$A11F,$A06B,$A120,$A06D,$A06B,$A121,$A06D,$A122,$A06B,$A06B,$A06D,$A06D,$E123,$E070,$E124,$E07B,$E125,$E126,$E127,$E128,$E071,$E129,$E07C,$E124,$E12A,$E003,$E092,$E84D,$E119,$E11A,$E000,$E12B,$E12C,$E919,$E12D,$E12E,$E119,$E11A,$E12F,$E92D,$811C,$811C,$811E,$811E,$E04E,$E84E,$E04E,$E84E,$A06E,$A06F,$E08A,$E08A,$E000,$E130,$E000,$E131; 832
		dc.w $E132,$E932,$E133,$E933,$8134,$8934,$8135,$E136,$A012,$A012,$A014,$A014,$E137,$A058,$E137,$A05A,$E138,$E938,$E133,$E933,$E08E,$E139,$E13A,$E13B,$E0E8,$E0E9,$E0EA,$F8CF,$F8F3,$E02E,$E010,$E0F9,$E0FF,$E100,$E0BA,$E0BB,$E000,$E13C,$E13D,$E13E,$E13F,$2140,$E13F,$2140,$2141,$E93F,$2142,$E93F,$A143,$A143,$A144,$A144,$E137,$E137,$E137,$E137,$A10D,$A10E,$E145,$E146,$E147,$E148,$E149,$E14A; 896
		dc.w $E14B,$E14C,$E14D,$E14E,$E0E3,$E0E4,$E0E5,$E0C8,$E000,$E000,$E000,$E14F,$E150,$F8CF,$E151,$E152,$2140,$E93F,$2153,$E93F,$2140,$E93F,$2141,$E93F,$A82F,$A82F,$A830,$A830,$E13F,$E13F,$E13F,$E13F,$E13A,$E154,$E155,$A10E,$E156,$A112,$A111,$A112,$E000,$E000,$E157,$E158,$E000,$E159,$E15A,$E15B,$E15C,$E151,$F8CF,$E152,$E152,$E088,$E088,$E15D,$E15E,$215F,$E15E,$2160,$E15E,$2942,$E15E,$2160; 960
		dc.w $2153,$E95E,$295F,$E95E,$2141,$E95E,$2142,$E95E,$2140,$E95E,$2153,$E95E,$E95E,$E95E,$E95E,$E95E,$A10D,$A10E,$E161,$E162,$A111,$A112,$E163,$E164,$E165,$E166,$E167,$E168,$E966,$E169,$E16A,$E16B,$E16C,$E16D,$E16E,$F8CF,$E000,$E000,$E000,$E16F,$E000,$E000,$E170,$E171,$E172,$E173,$E174,$E175,$A912,$A911,$E176,$E177,$E178,$E179,$E174,$E175,$E000,$E000,$E17A,$E0D2,$E000,$E000,$E17B,$E17C; 1024
		dc.w $E000,$E000,$E17D,$E17E,$E000,$E000,$E17F,$E180,$E14B,$E181,$E182,$E183,$E184,$E185,$E0AA,$E186,$E187,$E188,$E189,$E18A,$E18B,$E18C,$E08C,$E08F,$E939,$E88E,$E18D,$E0BE,$E18E,$E0BE,$A111,$A112,$E18F,$E190,$F165,$E191,$E192,$E193,$E194,$E195,$E0AA,$E196,$F0AA,$E197,$E198,$E199,$E19A,$E08E,$E19B,$E19C,$E166,$E966,$F0AA,$E08C,$E16C,$E19D,$E08F,$E08E,$E96C,$E0BE,$E08E,$E139,$E8BE,$E19E; 1088
		dc.w $E198,$E19F,$E1A0,$E1A1,$E1A2,$E0D8,$E0D9,$E0DA,$E165,$E166,$F18F,$E16C,$E966,$E0AB,$E99D,$E1A3,$E16C,$E19D,$E0BE,$E8BE,$E99D,$E1A3,$E0BE,$E8BE,$E0BE,$E8BE,$E1A4,$E1A5,$E18E,$E0BE,$E1A6,$E000,$E8BE,$E98E,$E000,$E000,$E08E,$E139,$E13A,$E19E,$E13A,$E19E,$E1A7,$E000,$E1A7,$E000,$E000,$E000,$E1A8,$E0CA,$E0CB,$E0C8,$F8C2,$F8C1,$A06E,$A06F,$E000,$E000,$E1A9,$E1AA,$E000,$E000,$E1AB,$E1AC; 1152
		dc.w $E1AD,$E1AE,$E1AF,$E1B0,$E17E,$E1B1,$E196,$E1B2,$E1B3,$E1B4,$E0AA,$E1B5,$E0A7,$E18F,$E0A8,$F165,$E1B6,$E1B7,$E0AA,$E1B8,$E1B9,$E18F,$E1BA,$F165,$E000,$E000,$E172,$E173,$E1BB,$E1BC,$E149,$E14A,$E1BD,$E1BE,$E1BF,$E1C0,$E0AA,$E1C1,$F0AA,$E08F,$E1C2,$E1C3,$E08C,$E08E,$E197,$E1C4,$E166,$E966,$F0AA,$E08F,$E16C,$E99D,$E08C,$E165,$E1A3,$F18F,$A10D,$E1C5,$A10D,$A10E,$E1C6,$E1C7,$A111,$A112; 1216
		dc.w $E174,$E175,$E18B,$E18C,$E1C8,$E1C9,$E0AB,$E08E,$E08E,$E08C,$E08F,$E139,$E16C,$E19D,$E18E,$E0BE,$E99D,$E1A3,$E8BE,$E18E,$E0BE,$E8BE,$E000,$E000,$E1A4,$E1A5,$E000,$E000,$E1A6,$E000,$E000,$E000,$A10D,$A10E,$E161,$E1CA,$A111,$A112,$E1CB,$E1CC,$E8BD,$E1CD,$E1CE,$E1CF,$A912,$E1D0,$E1D1,$E1D2,$E99E,$E93A,$E1D3,$E1D4,$E000,$E000,$E000,$E1D5,$E000,$E0DB,$E1D6,$E1D7,$E1D8,$E1D9,$E1DA,$E183; 1280
		dc.w $E1B1,$E1DB,$E0AA,$E1B8,$E180,$E18F,$E1BA,$F165,$A10D,$A10E,$A10D,$E1DC,$A1DD,$E1DE,$E1DF,$E1E0,$A10D,$E1E1,$A10D,$A10E,$F98E,$E9A3,$E1E2,$E1E3,$E000,$E1E4,$E1E5,$E1E6,$E1E7,$E1E8,$E1E9,$E1EA,$E1EB,$E0AA,$E1EC,$F0AA,$E1ED,$E1EE,$E08E,$E08F,$E000,$E000,$E1EF,$E1F0,$E1F1,$E1F2,$E1F3,$E1F4,$E1F5,$E9F1,$E9F4,$E9F3,$A1F6,$E1F7,$E1F8,$E1F9,$E000,$E000,$E000,$E1FA,$E0CC,$E1FB,$E1FC,$E1E0; 1344
		dc.w $E1FD,$E1FE,$E1FF,$E200,$E201,$E08F,$E202,$E9CD,$E08C,$E16C,$E98E,$E1A4,$E99D,$E1A3,$E1A5,$E1A6,$E000,$E203,$E204,$E1D2,$E205,$E206,$E207,$E208,$EA06,$E209,$EA08,$E20A,$E20B,$E9CF,$E20C,$E20D,$E0E8,$E1FC,$E20E,$E1F9,$E20F,$E210,$E210,$E08C,$E08F,$E08E,$E202,$E9CD,$E20B,$E9CF,$E0BD,$E20D,$E20D,$E000,$E000,$E000,$E211,$E212,$E213,$E214,$E215,$E216,$E217,$E08F,$E08C,$E202,$E08C,$E20B; 1408
		dc.w $E9CD,$E218,$E9CF,$E20D,$E219,$E000,$E000,$E000,$E000,$E000,$E17A,$E1AD,$E000,$E000,$E21A,$E17D,$E000,$E000,$E21B,$E21C,$E21D,$E21E,$E0AA,$E21F,$E220,$E0AA,$E221,$E222,$E223,$E224,$E08C,$E08F,$E15E,$2160,$E15E,$2160,$E9CD,$E0BD,$E9CF,$E20D,$E9CD,$E218,$E9CF,$E225,$E20B,$E9CF,$E20C,$E226,$E18F,$E1AF,$F165,$E227,$E228,$E0AA,$E229,$E222,$E22A,$E22B,$E08E,$E08C,$E222,$E22C,$E22D,$E08F; 1472
		dc.w $E08C,$E22D,$E08C,$E16C,$E08E,$E16C,$E99D,$E1A3,$E1A3,$F18E,$E1A5,$E1A6,$A111,$E22E,$A111,$A112,$E22F,$A10E,$A10D,$A10E,$E230,$A112,$A111,$A112,$E165,$E0AB,$F18F,$E231,$E08E,$E22D,$E232,$E233,$E08C,$E08F,$E232,$EA31,$E16C,$E99D,$E1A4,$E1A5,$E1A3,$E1A4,$E1A6,$E000,$E1A5,$E1A6,$E000,$E000,$A90E,$E234,$E235,$E236,$A912,$E237,$E238,$E236,$E1CF,$EA0B,$E239,$E8BD,$E1CF,$EA0B,$E23A,$E8BD; 1536
		dc.w $E23B,$E23C,$A10D,$E12B,$E1F1,$E9F5,$E1F3,$E1F4,$E1F5,$E9F1,$E9F4,$E9F3,$A10D,$A10E,$E23B,$E23C,$A111,$A112,$E23D,$E23E,$E1F1,$E9F5,$E1F3,$E1F4,$E1F5,$E9F1,$E9F4,$E9F3,$E23D,$E23E,$E12D,$E12E,$E000,$E1D3,$E1D3,$E236,$E08F,$E08E,$E08E,$E23F,$E1CF,$E240,$E241,$E242,$E205,$E206,$E207,$E208,$EA06,$E209,$EA08,$E20A,$E20B,$E9CF,$E20C,$E243,$E1CF,$E240,$E241,$E242,$E205,$E206,$E207,$E208; 1600
		dc.w $EA06,$E209,$EA08,$E20A,$E20B,$E9CF,$E20C,$E243,$E236,$E244,$E244,$E0AB,$E245,$E246,$A10D,$A10E,$E215,$E247,$E248,$E08C,$E249,$E1CD,$EA0D,$E1CF,$E9CD,$E218,$E9CF,$E24A,$E24B,$EA15,$E08E,$EA48,$E215,$E247,$E248,$E08C,$E249,$E1CD,$EA0D,$E1CF,$E9CD,$E218,$E9CF,$E24A,$E24B,$EA15,$E08E,$EA48,$E24C,$E244,$E248,$E08E,$E24D,$E24E,$A111,$A112,$624F,$6A4F,$6250,$6A50,$E0A7,$E0A7,$E0A8,$E251; 1664
		dc.w $E0A7,$E252,$E253,$E254,$E255,$E256,$E257,$E258,$E259,$E25A,$E0AA,$E25B,$E25C,$E18F,$E25D,$F165,$EA44,$EA36,$E8AB,$E25E,$E9D3,$E000,$E25F,$E260,$E18B,$E18C,$E08C,$E08F,$4261,$4262,$4261,$4262,$E0AB,$E263,$E264,$E265,$E266,$E267,$E268,$E269,$E26A,$E0AA,$E1EC,$F0AA,$426B,$426B,$426B,$426B,$E000,$EA0D,$E17F,$E180,$E26C,$E26D,$E26E,$E26F,$E270,$E271,$E0AA,$E186,$E272,$E273,$E189,$E18A; 1728
		dc.w $E08E,$E139,$E8BE,$E274,$4275,$4275,$4276,$4276,$E0A7,$E0A7,$E0A8,$E251,$E0A7,$E252,$E253,$E254,$E255,$E256,$E257,$E258,$E259,$E25A,$E0AA,$E25B,$E25C,$E18F,$E25D,$F165,$E19B,$E19C,$E166,$E966,$6277,$6278,$6277,$6279,$E8BE,$E98E,$EA0D,$E8BD,$E88E,$E88F,$E1CD,$EA02,$427A,$427B,$427C,$427D,$E0AB,$E263,$E264,$E265,$E266,$E267,$E268,$E269,$E26A,$E0AA,$E1EC,$F0AA,$400D,$400E,$400D,$400E; 1792
		dc.w $400E,$400F,$400E,$400F,$4010,$4010,$4011,$4011,$4079,$407A,$4079,$407A,$4079,$407A,$407B,$407C,$4070,$4071,$407B,$407C,$4070,$4071,$4079,$407A,$4003,$4803,$404D,$404D,$404E,$484E,$4006,$4006,$404F,$4050,$4051,$4052,$404D,$A09C,$A09D,$A09E,$A09F,$A0A0,$40A1,$40A2,$A0A3,$A0A4,$40A5,$40A6,$5066,$5067,$5055,$5056,$401A,$401A,$401B,$401B,$4049,$404A,$4049,$404A,$404B,$404C,$404B,$404C; 1856
		dc.w $40BE,$48BE,$40DE,$48DE,$40DE,$48DE,$40B5,$48B5,$4070,$4113,$407B,$4114,$4913,$4071,$4914,$407C,$4113,$4913,$4114,$4914,$40B8,$40B9,$40BA,$40BB,$40FF,$4100,$40BA,$40BB,$40BA,$40BB,$40C6,$40C7,$40BA,$40BB,$4105,$4106,$627E,$6277,$627F,$6277,$600D,$600E,$600D,$600E,$600E,$600F,$600E,$600F,$6010,$6010,$6011,$6011,$6079,$607A,$6079,$607A,$6079,$607A,$607B,$607C,$601A,$601A,$601B,$601B; 1920
		dc.w $6033,$6034,$6035,$6835,$6036,$6037,$6038,$6039,$40B4,$48B4,$40B5,$48B5,$4088,$4088,$408A,$408A,$6280,$6031,$6281,$6282,$203A,$203B,$203C,	 $3D,$6070,$6071,$607B,$607C,$6070,$6071,$6079,$607A,$60B4,$68B4,$60B5,$68B5,$6088,$6088,$608A,$608A,$205B,$205B,$205C,$205C,$2115,$205B,$2116,$205C,$205B,$2117,$205C,$2118,$4283,$4283,$4283,$4283,$4284,$426B,$4285,$4286,$6049,$604A,$6049,$604A; 1984
		dc.w $604B,$604C,$604B,$604C,$604D,$209C,$209D,$209E,$209F,$20A0,$60A1,$60A2,$20A3,$20A4,$60A5,$60A6,$206B,$206B,$206D,$206D,$211F,$206B,$2120,$206D,$206B,$2121,$206D,$2122,$6287,$6288,$6289,$628A,$628B,$628C,$626B,$628D,$628E,$628E,$626B,$626B,$628F,$6290,$2291,$2292,$6293,$4294,$2295,$4296,$4297,$4298,$4299,$429A,$429B,$429C,$429D,$429E,$429F,$42A0,$42A1,$42A1,$42A0,$42A2,$4031,$42A3; 2048
		dc.w $42A4,$62A5,$42A6,$62A7,$42A2,$42A4,$42A3,$42A6,$626B,$628D,$42A8,$42A9,$626B,$626B,$626B,$626B,$62AA,$62AB,$62AA,$62AB,$62AC,$4294,$62AC,$4294,$62AD,$62AD,$62AE,$62AF,$62B0,$62B0,$42B1,$42B1,$42A1,$42A1,$42A1,$42A1,$4031,$42A3,$4031,$42B2,$42A6,$62B3,$42B4,$72B3,$42A3,$42A6,$42B2,$42B4,$4000,$4000,$4000,$4000,$42B5,$42B5,$42B6,$42B6,$62B7,$42B5,$62B8,$42B6,$42B9,$42BA,$42BB,$42BC; 2112
		dc.w $42BD,$42B9,$42BB,$42BC,$42B1,$42B1,$42B1,$42B1,$42A1,$42A1,$42A1,$42A1,$4031,$42BE,$4031,$42A3,$42BF,$62B3,$42A6,$72B3,$42BE,$42BF,$42A3,$42A6,$42C0,$42C1,$42C0,$42C1,$42C2,$42C3,$42C2,$42C3,$4031,$42C4,$42C0,$42C1,$42C5,$42C6,$42C2,$42C3,$42C7,$42C8,$42C7,$42C8,$42C9,$42C8,$42CA,$42C8,$42A1,$42A1,$42CB,$42CB,$4031,$42A3,$42CB,$42CC,$42A6,$62B3,$42CD,$72B3,$42A3,$42A6,$42CC,$42CE; 2176
		dc.w $42CF,$4000,$42D0,$42D1,$4000,$4000,$42D2,$42D1,$42D3,$42D3,$42D4,$42D5,$42D6,$42D7,$42D8,$42D7,$42D7,$42D9,$42DA,$42D7,$42D9,$42D7,$4018,$42D7,$42DB,$42DC,$42DD,$42DE,$42DF,$42E0,$42E1,$42E2,$42DE,$42E1,$42DF,$42DC,$42E3,$4018,$42DB,$42E4,$42E5,$42E6,$42D8,$42D1,$42D1,$42D1,$42D1,$42D2,$42D1,$42D1,$42D1,$42D1,$42E7,$42E8,$42E5,$42E8,$42D7,$42E9,$42E8,$42EA,$42EB,$42EC,$42E9,$42E9; 2240
		dc.w $42E3,$42ED,$42EE,$4AE1,$42EF,$42F0,$4ADE,$4AE0,$4AED,$4AED,$4ADF,$4ADC,$42DD,$42F1,$42E3,$42F2,$42E7,$42D2,$42E5,$42D1,$42D2,$42D1,$42EC,$42D7,$42D1,$42D2,$42D1,$42D1,$42E7,$42F3,$42E5,$42D3,$42EA,$42E8,$42D3,$42F4,$42AD,$42E8,$42D3,$42F5,$42E3,$42ED,$42F6,$4018,$42EF,$42F0,$4018,$4018,$4AED,$4AED,$4018,$4018,$4018,$4018,$42F7,$42F1,$42E7,$42D7,$42D8,$42EC,$42D7,$42D7,$42DA,$42DA; 2304
		dc.w $42EC,$4018,$42D9,$42DA,$42CF,$4000,$42F8,$4000,$4000,$4000,$4000,$4000,$42DB,$42F9,$42DD,$42FA,$42DB,$42FB,$42DD,$42FC,$42FD,$42FC,$42FE,$42FB,$42FE,$4AFD,$42FD,$42FD,$4AF7,$42F7,$42F2,$42F2,$5AF9,$4AF9,$42FF,$42D4,$5AF9,$5AF9,$42D5,$42FF,$4300,$4301,$4302,$4303,$4301,$4301,$4304,$4305,$4301,$4301,$4306,$4304,$4301,$4301,$4305,$4306,$4018,$4307,$4302,$4307,$4308,$4308,$4308,$4308; 2368
		dc.w $4308,$4307,$4308,$4307,$4309,$4309,$430A,$430A,$4018,$4018,$4AF7,$4AE4,$4309,$4307,$430A,$4307,$4018,$4303,$4018,$4307,$4306,$4304,$430B,$430B,$4306,$4304,$430B,$4307,$4018,$4307,$4018,$4307,$4308,$4308,$430C,$430C,$4308,$4307,$430C,$4307,$430C,$430C,$430C,$430C,$430C,$4307,$430C,$4307,$42F1,$42E4,$42F2,$42F2,$430D,$430D,$430E,$430E,$4000,$430F,$4000,$4310,$4000,$4000,$4000,$4311; 2432
		dc.w $4000,$4000,$4000,$4B11,$4000,$4301,$4000,$4301,$4301,$4301,$4301,$4301,$4312,$4313,$4313,$4B13,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000; 2496
		dc.w $4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000; 2560
		dc.w $4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000; 2624
		dc.w $4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000; 2688
		dc.w $4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000,$4000; 2752
Nem_CPZ:	dc.b $83,$14,$80,  3,  0,$14,  6,$25,$11,$36,$2A,$45,$13,$56,$2B,$66,$30,$74,  2,$81,  4,  3,$16,$2D,$28,$E2,$78,$E7,$82,  5, $E,$16,$31,$28,$EE,$83,  4,  4,$16,$2F,$27,$72,$78,$E6,$84,  5,$12,$17,$6F,$85,  5,$10,$17,$66,$28,$EA,$86,  5, $F,$17,$6C,$87,  4,  5; 0
					; DATA XREF: ROM:0001BFFCt
					; ROM:0001C00Ct ...
		dc.b $17,$67,$28,$E9,$88,  6,$2C,$17,$70,$28,$ED,$89,  6,$32,$18,$E8,$8A,  7,$6B,$18,$EC,$8B,  7,$6E,$8C,  6,$2E,$18,$E3,$8D,  6,$34,$8E,  7,$6A,$18,$EB,$8F,  5,$14,$17,$6D,$28,$F0,$FF,$22,$22,$22,$22,$FD,$4E,$BC,$B5,$D9,$AE,$37,$8C,$63,$78,$C6,$37,$8C,$63,$78; 64
		dc.b $C6,$37,$8C,$63,$78,$C6,$37,$8C,$78,$B5,$3B,$F3,$B4,$8E,$DA,$F6,$D7,$B6,$BD,$B5,$ED,$AF,$6D,$7B,$63,$FB,$EF,$D8,$F3,$4E,$48,$C6,$2D, $E,$36,$38,$3D,$33,$46,  1,$F2,$57,$F4,$85,$34,$70,$70,$40,$F5,$AD,$F2,$58,$21,$A1,$BE,$49,$37,$C9,$BF,$66,$F9,$1A,$54,$F9; 128
		dc.b   3,$94,$15,  2,$18,$3A,$96,$D0,$6E,$78,$7B,$8D,$64,$B0,$58,$49,$E6,$86,$90,$59,$3E,$69,$27,$FE,$CD,$A4,$FA,$90,$D0,$22,$C2,$46,$15,$90,$18,$37,$87,$DA,$2D,$FD,$92,$39,$1D,$CD,$FF,$74,$3F,$E3,$47,$8B,$16,$5F,$D2,$29,$24,$7F,$68,$8D,$A7,$1E,$F5,$41,$C5,$3F; 192
		dc.b $D7,$4F,$88,$7E,$B4,$86,$D6,$E2,$16,$EA,$1F,$AC,$21,$C0,$59,$5D,$B5,$F5,$C7,$F3,$B7,$5B,$77,$E7,$4A,$D1,$B4,$5B,$FA,$CB,$7F,$58,$59,$DF,$43,$7F,$43,$5B,$B6,$AB,$76,$D5,$6E,$DA,$AD,$DB,$55,$BB,$6A,$B7,$6D,$56,$ED,$6D,$5C,$7F,$9D,$E2,$C6,$BC,$6B,$C6,$BC,$6B; 256
		dc.b $C6,$BC,$6B,$C6,$BA,$69,$E1,$FA,$C2,$28,$AA,$61,$2A,$F3,$91,$47,$63,$6C,$6B,$DA,$F2,$22,$22,$26,$B5,$E7,$27,$A9,$B9,$AD,$63,$5D,$42,$F6,$43,$D5,$86,$A1,$7B,$21,$EA,$16,$B1,$AB,$67,$40,$AE,$1C,$4A, $F,$37,$F5,$B9,$F9,$8B,$9B,$9F,$FE,$FC,$FB, $F,$F8,$F6,$EC; 320
		dc.b $AA,$F0,$AF,$28,$DF,$5F,$12,$D5,$D2,$1F,$1E,$27,$D5,$D2,$44,$44,$44,$45,$5F,$F5,$1B,$FA,$8D,$FD,$46,$FE,$A3,$7F,$51,$BF,$A8,$DF,$D4,$12,$6F,$DA,$5C,$D2,$8C,$9A,$EE,$D9,$35,$D1,$BA,$AB,$6E,$8D,$1B,$48,$E9,$AC,$69,$1D,  6,$BB,$AC,$16,$28,$D6,$21,$74,$AE,$4C; 384
		dc.b $AF,$22,$22,$22,$3F,$F1,$DD,$B4,$6B,$1A,$F5,$35,  6,$B1,  6,$A4,$68,$D2,$8D,$27,$AE,$96,$36,$A1,$AE,$1D,$B4,$D6,$34,$B0,$59,$A6,$B1,$74,$74,$8B,$BA,$BF,$70,$44,$44,$44,$54,$FF,$41,$11,$11,$17,$FE,$BF,$C6,$44,$44,$44,$3F,$C6,$3F,$F6,$44,$44,$44,$5F,$E9,$B0; 448
		dc.b $88,$88,$88,$A1,$FD,$79,$10,$FE,$BB,$7F,$45,$BF,$A6,$4D,$FD,$36,$FE,$8B,$7F,$5C,$89,$8C,$18,$3A,$8C,$18,$32,$22,$10,$FE,$B4,  9,$8C,$18,$36,$FF,  8,$FF,  8,$30,$60,$C1,$91, $F,$F0,$91,$83,  6, $C,$73,$F3,$83,  6, $C,$19,$11,$11,$11,$11,$73,$7F,$89,  8,$C1; 512
		dc.b $83,  6,$3F,$C2,$9F,$E1,$40,$60,$C1,$84,$22,$FF,$22,$8D,$F5,$F0,$DE,$D6,$47,$78,$B1,$B8,$35,$91,$DE,$2C,$AE,$C8,$A3,$59,$87,  8,$A0,$ED,$FD,$9D,$82,$FF,$D9,  4, $E,$1B,$75,$24,$69,$37,$14,$4D,$9C,$29,$56,$EC,$8F,$F5,$D4,$B8,$59,$52,$11, $B,  8,$8B,  4,$B7; 576
		dc.b $F5,$DC,$64,$44,$44,$45,$66,$BC,$BF,$4D,$9D,$AF,$A9,$1B,$F6,$71,$FE,$98,$FD,$9B,$25,$57,$E1,$7C,$6F,$6B,$EA,$47,$41,$48,$92,$A5,$6F,$E1,$C0,$D9,  2,$43,$F4,$81,$19,$4F,$3C,$4D,$4C,$20,$BC,$E1,$2C,$F1,$BC,$25,$68,$DF,$C3,$63,$9B,$CD,$78,$9E, $D,$4F,$A4,$6F; 640
		dc.b $72,$7E,$C6,$29,$20,$FB,$64,$DB,$DE, $E,$F0,$FD,$EE,$89,$A9,$E7,$BC,$D8,$D3,$3A,$31,$F2,$CE,$6B,$C8,$DD,$BD,$50,$1B,$3F,$32,$36,$73,$81,$11,$13,$21,$83,$8E,$79,$2D,$AD,$9F,$36,$2D,$9E,  4,$44,$44,$55,$21,$66,$77,$20,$93,$E4,$15,$90,$5E,$C7,$35,$30,$95,$A4; 704
		dc.b $CF,  3,$4A,$DD,$5A,$15,$F5,$20,$FE,$1C,$FF,$66,$45,$5A,$45,$DD,$5F,$A6,$52,$22,$22,$22,$77,$F5,$65,$8E,$69,$2C,$A0,$44,$58,$E6,$92,$CA,$18,$E6,$92,$CA,$18,$E6,$92,$CA,$1C,$32,$7A,$BF,$2B,  8,$B5,$DD,$A1,$83,$FC,$E9,$AB,$FA,$B6,$7E,$6F,$5F,$EA,$F5,$EE,$63; 768
		dc.b $A6,$AA,$19, $E,$19,$7E,$AA,$51,$BB,$8B,$46,$BB,$8B,$46,$90,$31,$A5,$77,$46, $D,$74,$6E,$6B,$A3,$73,$4A,$37,$57,$75,$82,$C8,$35,$DD,$B2,$6B,$BB,$65,$1B,  5,$92,$AE,$51,$93,$4A,$32,$69,$46,$55,$CA,$3F,$B2,$FD,$36,$A2,$22,$22,$22,$C1,$48,$88,$88,$8A,$6F,$83; 832
		dc.b $B8,$BF,$4D,$99,$97,$F4,$D9,$82,$BD,$5E,$8C,$86, $E,$A8,$2B,$C2,$4C,$EB,$72,$9A,$45,$CA,$F5,$7F,$F1,$7F,$4D,$C5,$9B,$F4,$CB,$52,$3D,$5E,$B3,$30,$75,$20,$7A,$BE,$67,$34,$35,$70,$72,$C1,$EA,$EC,$CD,$D3,  1,$FB,$52,$8D,$A9,  7,$66,$30,$81,$3B,$B7,$AB,$27,$F0; 896
		dc.b $B9,$37,$F0,$86,$23,$1B,$45,$A2,$D6,$D4,$DA,$88,$8A,$AD,$4D,$A8,$9A,$D7,$5B,  7,$A7,$F0,$5E,$4A,$44,$44,$58,$1A,$14,$E5,$9E,$68,$FC,$1E,$55,$F4,$F3,$7F,$4D,$C4,$33,$FE,$D1,$9E,$39,$47,$F6,$D3,$FD,$30,$46,$FE,$BB,$7F,$4D,$D8,$3C,$65,$C7,$A4,$AA,$E1,$D0,$28; 960
		dc.b $DB,$C1,$8A, $C,$85,$91,$A0,$DE,$D6,$5D,$4B,$B7,$8D,$F6, $B,$1A,$C6,$95,$25,$63,$58,$2C,$3B,$11,$90,$72,$9F,$E6,$DD,$3D,$99,$23,$20,$FC,$E8,$86,$97,$42,$4C,$FE,$8B,$32,$8B,$FF,$89,$57,$43,$6E,$D1,$B6,$8D,$D6, $D,$C2,$D1,$A0,$A6,$82,$D1,$41,$B4,$6D, $E,$67; 1024
		dc.b  $C,$42, $A,$20,$BC,$70,$16, $E,  4,$FC,$FA,$97,$27,$8D,$5F,$B1,$A5,$4F,$D7,$BA,$85,$48,$BF,$5E,$EB,$6B,$E1,$53,$EA,$B3,$60,$7F,$F6,$3F,$36,$44,$44,$44,$52,$FE,$AB,$C7,$EC,$42,$4E,$DA,$ED,$AE,$DA,$ED,$AE,$D6,$FD,$E6,$97,$7E,$77,$AF,$C3,$A4,$21,$83,$B1,$AF; 1088
		dc.b $AA,$C1,$7D,$56, $B,$EA,$B0,$5F,$55,$82,$FA,$AC,$1A,$75,$D3,$56,$DF,$F3,$85,$FE,$1C,$7F,$82,$81,$DF,$C7,$7E,$69,$9A,$8F,$E0,$C7,$FA,$6E,$21,$D5,$DC,$8E,$19,$C5,$A1,$CA,$C6,$C8,$D6,$8B,$EA,$BE,$A7,$15,$E5,$82,$11,$11,$11,$14,$6F,$8A,$35,$E5,$1B,$C8,$99,$D5; 1152
		dc.b $26,$31,$E5,$C5,$7D,$68,$39,$92,$7F,$B3,$9F,$EC,$E7,$FB,$39,$FE,$CE,$7C,$A5,$34,$94,$EF,$CF,$14,$AD,$C5,$5B,$81,$D5,  2, $A,$53,$83,$A0,$E4,$7E,$7A,$9D,$3C,$62,$81,$D5,$20,$74,$54,$E6,$B5,$71,$6C,$5D,$E5,$FA,$63,$A8,$C8,$88,$B0,$5D,$86,$55,$71,$7E,$9B,$3F; 1216
		dc.b $17,$4D,$A4,$44,$45,$1E,$2D,$9F,$B7,$FD,$A7,$EC,$7F,$66,$44,$44,$5F,$B6,$FD,$BF,$FD,  8,$88,$88,$BF,$E9,$FA,$4C,$FB,  7,$2B,$73,$91,$11,$10,$E9,$D9,$68,$E6,$C4,$7E,$90,$38,$3A,$4F,$57,$CB,$19,$3E,  2, $F,$93,$42,$30,$63,$69,$31,$BB,$34,$73, $C,$7A,$9C,$1C; 1280
		dc.b $B0,$5C,$D9,$C7,$49,$4F,$BB,$F6,$E3,$AB,$F6,$E3,$A4,$A7,$DD,$FB,$77,$7F,$9D,$BF,$AE,$1C,$53,$D4, $E,$3D,$6C,$63,$AE,$A3,$1F,$CE,$6D,$FF,$C5,$E5,$FB,$2F,$FB,$8E,$B1,$AA,$3A,$88,$B0,$FD,$70,$D5,$1F,$FA,$FF,$D8,$7F,$84,$8F,$FC,$CD,$FD,$12, $F,$FE,$B9,$7F,$D4; 1344
		dc.b $5E,$BF,$B3,$75,$A2,$D7,$CA,$19,$DD,$9D,$D0, $F,$FD,$BE,$21,$FF,$B5,$72,  7,$C1,$D0,$C4,$C4,$A0,$E8,$3A,$3F,$B3,  6,$F0,$84,$40,$E2,$75,$9C,$4D,$4C,$99,$58,$D6,$A4,  9,$88,$74,  8,$27,$EC,$91,$8C,$2B,$D4,$E2,$A6,$86,$A1,$1D,  9,$2C,$A0,$11,$D0,$92,$CA,  4; 1408
		dc.b $11,$CF,$38,$49,$61,$13,$C1,$19,$CA,$20,$A8,$F7,  7,  8,$2E,$C3,$CD,$18,$36,$C8,$A0,$BC,$C4,$1E,$1E,$E0,$A8,$AC,$8F,$CC,$48,$E5,$7C,$36,$47,$F6,$48,$37,$A6,$31,$E9,$9A,$10,$3A,$D2,$18,$B5,$84,$44,$43,$FB,  4,$83,$FA,$6E,$B3,$FA,$67,$90,$C8,$64,$32,$64,  8; 1472
		dc.b $10,$21,  7,  7,  7,  7,$10,$A0,$A0,$A0,$A0,$A0,$A0,$A0,$A1,$8B,  5,$82,$CA, $F,$EF,$98,$FE,$89,$37,$F4,$5B,$FB,$E6,$43,$FA,$54,$3D,$35,$E9,$AF,$4D,$74,$20,$60,$C1,$83,$20,$60,$C1,$83,  6, $C,$18,$30,$60,$C1,$83,$2C,$B5,$65,$AB,$2D,$59,$6A,$2E,$62,$FF,$91; 1536
		dc.b $7F,$FC,$C1,$83,  6,$39,$CC,$18,$30,$64,$40,$C1,$83,  6,$39,$CC,$18,$30,$64,$3F,$EB,$FD,$45,$95,$EE,$BD,$C6,$86,$86, $C,$18,$35,$6B,$41,$88,  3,$89,$C4,$C5,$A0,$EB,$3D,$9D,$3F,$A6,$59,$2F,$E9,$16,$41, $F,$14,  8,$C6, $C,$20,$36,$36,$50,$73,$94,$6D,$AF,$F6; 1600
		dc.b $2D,$FB,$3C,$79,$AF,$20,$98,$4A,$32,$BC,$D4,$A2,$8C,$FF,$DB,$B2,$7F,$50,$73,$21,$56,$82,$F9,$46,$58,$29,$92,$37,$ED,$DE,$B2,$43,$90,$57,$EF,$AE,$F6,$40,$F5,$A8,$E2,$73,$B4,$1C,$5E,$1F,$13,$D8,$1E,$DF,$D6,$FF,$97,$34,$CE,$28, $C,$1C,$65,$17,$E7,$35,$B5,$F6; 1664
		dc.b $E7,$7A,$BE,$D7,$8F,$D8,$85,$6F,$E2,$3B,$9A,$F2,  7,$52,  5,$D8,$6D,$21,$27,$9A,$98,$7B,$6C,$35,$7A,$BF,$7B,$87,$EC,$46,$F6,$D8,$3F,$48,$CA,$F5,$47,$44,$D5,$E0,$C4,$94,$D7,$88,$49,$4D,$F2,$B4,$49,$4C,$38,$18,$92,$98,$E2,$4E,$93, $E,$6F,$E3,$BA,$D6,$FD,$22; 1728
		dc.b $87,$B4,$31,$37,$9A,$C8,$5B,$BC,$D6,$4C,$68, $D,$65,$52,$1A,$C8,$18,$B7,$62,$BC,$C6,$67,$AB,$F7,$D4,$FC, $C,$A2,$B1,$53,$2A,$CE,$BE,$4C,$E0,$90,$C6,$6F, $F,$59,$EC,$CF,$82,$35,$BB,$37,$CD,$F2,$8F,$EC,$8A,$3F,$C4,$86,$F3,$4A,$CD,$62,$60,$C4,$2D,$1C,$43,$88; 1792
		dc.b $5A,$4C,$71,$36,$57,$F4,$BF,$3B,$F3,$BF,$A5,$E6,$C6,$C8,$73,$35,$63,$6B,$64,$C7,$59,$C4,$E7,$6B,$18,$7A,$EC,$CE,$F5,$4F,$ED,$D9,$82, $F,$EC,$11,$11,$10,$7E,$4F,$C9,$F9,$3C,$FF,$FF,$FF,$FA, $A, $A, $A,$11,$33,$83,$83,$87,$FC,$9D,$BB,$2D,$D9,$6E,$CB,$71,$91; 1856
		dc.b $11,$11,$17,$FA,$D0,$89,  2,  4,  8,$39,$90,$20,$40,$84,$44,$3F,$D1, $A,$F4,$AF,$4A,$F4,$AF,$4A,$F4,$AE,$EF,$E8,$AF,$FA,$FF,$D4,$B5,$E9,$5E,$95,$E9,$5E,$95,$E9,$33,$D2,$BD,$52,$5F,$D2,$67,  6,$EE,$2C,$48,$8C,$3A,$66,$25,$83,$E6,$78,$49,$D6,$BA,$DE,$EB,$5D; 1920
		dc.b $6A,$11,$4D,$D8,$4B,  7,$93,$62,$1F,$89,$8C,$55,$91,$8E,$BE,$28,$DA,$2D,$69,$1C,$4C,$1B,$E2,$63,$3C,$CC,$1B,$5A,$E3, $A,$E8,$DE,$B5,$5A,$91,$30,$75,$DB,$54,$81,$8B,$41,$BE,$6F,$56,$31,$6C,$4E,$36,$C6,$DA,$ED,$8D,$B5,$1B,$1C,$6D,$63,  7,$51,$CF,$88,$18,$30; 1984
		dc.b $6C,$60,$C5,$B3,$B4,$18,$39,$9C,$ED,$63,  7,$3B,$62,$60,$C1,$8B,$5A,$D6,$38,$FF,  6,$57,$BA,$F7,$23,$7F,$4D,$BF,$A2,$41,$7F,$AA,$3F,$C6,$3F,$C2,$3F,$EF,$FE,$2E,$6E,$72,$FF,$AF,$37,$F4,$43,$FF,$AE, $F,$FA,$52,$5F,$E9,$B7,$F4,$49,$BF,$AA,$A3,$FC,$63,$FC,$23; 2048
		dc.b $FC,$E1,$6B,$79,$1E,  6,$1D,$84,$A6,$61,$E4,$53,$7D,$66,$45,$37,$61,$2C,$1E,$44,$CF,$AE,$D2,$C0,$C3,$B0,$96, $F,$99,$E0,$6A,$F5,$FE,$32,$BD,$7F,$4C,$A4,$53,$76,$12,$C1,$E4,$CF,$57,$AF,$E9,$B3,$BD,$C9,$FB,$23,$7E,$F9,$A6,$7D,$F5,$5F,$9F,$31,$C6,$FD,$89,$1C; 2112
		dc.b $6D,$80,$BD,$B1,  9,$9F,$66,$FB,$FF,$68,$F3,$A9,$1C, $D,$AF,$30,$E1,$7D,$B8,$B6,$CC,$62,$7B,$37,$C7,$96,$7D,$E2,$1B,$FF,$6F,$21,$FB,$5C,$60,$EF,$D4,$BE,$C8,$F8,$11,$8D,$F7,$71,$37,  3,$FD,$F8,$E0,$78,$59,$76,$12,$FD,$C7,$E9,  8,$BF,$F9,$CF,$CF,$FF,$82,$FF; 2176
		dc.b $E3,$7E,$BA,$8D,$C2,$AE,$1B,$EA,$E3,$E0,$7B,  5,$BC,$2A,$B4,$4A,$8D,$4E,  5,$21,$63,$59,$BC,$8B,$FF,  5,$CF,$FF,$FF,$FF,$FF,$E7,$FF,  5,$CE,$5F,$FF,$E7,$E7,$FF,$F1,$17,$FE,  8,$88,$BF,$F2,$45,$CE,$44,$5F,$F8,$2F,$FA,$97,$39,$73,$11,$73,$11,$73,$91,$17,$FD; 2240
		dc.b $7F,$EA,$44,$44,$44,$5F,$F5,$FD,$AA,$FE,$93,$F6,$AB,$FA,$4F,$DA,$AF,$E9,$3F,$6A,$BF,$A4,$FD,$AA,$FE,$93,$F6,$AB,$FA,$4F,$DA,$AF,$E9,$3F,$64,$39,$7F,$CA,$A7,$61,$28,$C3,$F4,$C3,$F4,$C3,$A5,$3A,$47,$10,$E2,$20,$F5,$12,$37,$40,$88,$88,$88,$B2,$D7,$BA,$ED,$32; 2304
		dc.b $D5,$94,$5E,$25,$37,$91,  8,$61, $A,$A5,$84,$B0,$BB,$4D,$5A,$5C,$44,$44,$44,$51,$BB,$4D,$5A,$5D,$17,$E0,$FA,$E1,$84,  4,$99,$F5,$49,$9E,$55,$C3,  8,$61,$2C,$25,$53,$F0,$79,$10,$86,$10,$12,$1F,$D9,$D3,$28,$AE,$65,$6C,$EE,$FC,$DB,$99,$33,$F1,$AC,$53,$F6,$28; 2368
		dc.b $C8,$C9,$5C,$9A,$40,$D9,$19,$25,$95,$DA,$B2,$59,$20,$E1,$6F,$61, $D,$F7,$4A,$1B,$F5,$4A,$E9,$42,$5F,$AE,$1C,$2D,$EC,$21,$BE,$E9,$43,$7E,$A1,$2B,$37,$5D,$96,$BB,$81,$8B,$45,$B5,$1B,$18,$36,$56,$58,$E2,$31,  9,$BF,$F6,$A1,$64,$FC,$CB,  8,$AB,$28,$97,$1D,$9A; 2432
		dc.b $2B,$94,$70,$B7,$B0,$86,$FB,$A5, $D,$FA,$A5,$74,$A1,$2F,$D7, $E,$16,$F6,$10,$FD,$27,$1F,$E7,$57,$A3,$4F,$E4,$B4,$89,$9E,$DF,$BD,$D5,$67,$5F,$EC,$7F,$67,$FB,$7F,$DB,$7F,$EE,$30,$C2,  5,$2C,$24,$C6,$38,$AA,$3E,$DC,$81,$8B,$2A,$C8,$59,$FD,$9B, $A,$37,$69,$AB; 2496
		dc.b $48,$64,$45,$D6,$E4,  8,$ED,$45,$FF,$5F,$CD,$AB,$E0,$F5,$DC,$44,$59,$14,$5D,$56,$40,$C1,$D4,$B1,$58,$A9,$B8,$D4,$9A,  0,$C2,$3B,$50,$7E,$7C,$50,$89,  2,$18,$50,$64,$46,$C8,$61,$49,$B7,$C0,$D9,$46,$F8,$62,$61,$77,$C3,$14,$31,$BE,$18,$84,$3D,$EA,$37,$AA,$5A; 2560
		dc.b $E1,$6B,$87,$50,$EA,$1D,$3F,$B4,$70,$BF,$F6,$24,$A1,  8,$1D,$48,$10,$7E,$C4,$20,$BE,$26,$11,$B9,  3,$17,$CE,$D1,$C9,$63,$FB,$11,$D3,$51,$C7,$F6,$E9,$C5,$54,$39,$7E,$C6,$11,$FD,$99, $E,$3F,$D6,$DC,$DC, $C,$1D,$84,$DF,$9D,$FD,$56,$84,$DF,$9D,$FD,$56,$95,$59; 2624
		dc.b $95,$91,$FE,$A1,$57,$94,$6C,$E8,$79,$EC,$16,$74,$3C,$6C,$16,$74,$3C,$6C,$16,$74,$3C,$6C,$9D,$85,$1E,$87,$AB,$F2,$6C,$8D,$F4,$7E,$43,$A1,$8E,$3D,$16,$4F,$F7,$27,$1F,$DC,$D8,$44,$51,$D9,$5D,$B2,$BB,$F7,$B6,$8B,$3F,$73,$B7,$FA,$96,$C7,$80,$E1,$51,$D7,$66,$44; 2688
		dc.b $43,$F9,$B2,$6F,$DC,$8C,$9B,$F6,$87,$85,$86,$4D, $D,$EB,$2D,$50, $B,$BD,$2A,$3C,$4D,$8C,$26,$30,$64,$A9,$1A, $B,$D6, $C,$38,$42,$2A,$D8,$F5,$83,$C1,$F2,$59,  8,  8,$39,$F0,$90,$30,$6C,$AC,$F0,$F9,$BE,$4F,$86,$76,$FD,$36,$7C,$47,$F0,$82,$E0,$78,$4A,$32,$C2; 2752
		dc.b $CC,$2E,$D3,$8F,$4B,$9A,$5A,$71,$9D,$CD,$66,$17,$69,$C6,$77,$47,$4E,$3D,$2E,$26,$E8,$FD,$B3,$5B,$B5,$B8,$F7,$E6,$EC,$FF,$E3,$70,$E8,$D9,$C7,$BF,$37,$67,$FF,$1D,$2A,$B1,  8,$21,$28,$6C, $E,$10,$93,$F3,$BA,$11,$34,$32,$74,$B0,$41,  9,$2C,$9E,$1C,$21,$28,$67; 2816
		dc.b  $A,$3B,$AD,$CC,$B0,$7C,$36,$7E,$91,$77,$E7,$34,$38,$9B,$CA,$68,$EC,$CB,  5,$92,$FE,$D3,$3C,$97,$7E,$7F,$EA,$7F,$FC,$88,$8B,$FF,$1F,$F2,$E6,$FF,$BF,$3F,$31,$73,$73,$FF,$F3,$77,$E7,$7F,$9C,$2D,$FD,$90,$3A,$D1,$9E,$CF,  9,$82,  7,$8D,$81,$EB,$78,$B4,$24,$D6; 2880
		dc.b $28,$E3, $A,$6E,$36,$FE,$3B,$C8,$9B,$F8,$28,$4C,$7F,$B3,$21,$AF,$76,$BF,$E7,$33,$C8,$4B,  9,$16, $F,$C1,$F5,$42,$BD,$5B,$BF,$BD,$FF,$28,$3D,$67,  7,$AC,$E0,$F5,$9C,$1E,$B3,$FF,$B7,$3F,$FD,$7F,$E4,$44,$45,$FF,$6E,$7F,$FB,$1B,$FF,$68,$F3,$5C,$73,$E2,$B8,$BF; 2944
		dc.b $3B,$F1, $F,$96,$A5,$93,$D8,$DB,$20,$6C,$B0,$EB,$82,$8C,$57,$32,$E2,$69,$6B,$CD, $C,$3D,$CB,$FB,$26,$83,$A6,$6F,$85,$68,$F8,$56,$8F,$85,$69,$B2,$B4,$83,$C2,$E3,  7,$1C,$BF,$64,$AE, $F,$A9,$C9,$5A,$38,$1C,$51,$C7,$52,$38,$EA,$47,$1D,$48,$E3,$99,$CA,$A7,$3E; 3008
		dc.b $B4,$70,$48,$A3,$8C,$23,$23,$8D,$90,$23,$8E,$A4,$71,$CD,$C7,$5C,$9C,$F8,$3E,$12,$7C,$1C,$F8,$48,$41,$F5,$A4,$1F,$52,  4,$83,$E2,$8C,$99,$99,$22,$8F,$85,$68,$F5,$1D,$4F,$73,$DB,$A9,$EE,$CC,$95,$C1,$67,  5,$75,$4F,$57,$54,$F0,$EA,$A1,$FA,$48,$C1,$71,$7C,$84; 3072
		dc.b $15,$CC,$E7,$E6,$58,$7E,$9A,$48,$E7,$9B,$AF,$22,$22,$22,$28,$98,$7C,$64,$44,$4C,$F1,$9E,$4C,$FC,$FF,$B4, $B,$6D,$ED,$28,$63,$7B,$7F,$C8,$9A, $D,  2,$8E,$71,$9D,$9E,$68,$F3,$4D,$9C,$F9,$9D,$99,$D9,$9D, $F,$DB,$C1,$CB,$8E,$7C,$57,$17,$E7,$7E,$21,$F2,$D4,$B2; 3136
		dc.b $7B,$1B,$64, $D,$96,$1D,$70,$51,$8A,$E6,$5C,$44,  6,$30,$58,$1A,$9F,$F0,$C8,$88,$88,$A5,  9,$73,$5E,$12,$AC,$F2,$59,$47,$3C,$96,$51,$CF,$25,$94,$73,$C9,$65,$1C,$F2,$59,$47,$3C,$96,$4A,$F5,$64,  8,$44,$44,$44,$4A,$F5,$64,  8,$44,$44,$44,$4B,$FB,$57,$C0,$3A; 3200
		dc.b $6F,$49,$BE,$FA,$9F,$7B,$A2,$FE,$51,$7D,$EE,$36,$7D,$EE,$8B,$EF,$74,$5D,$7B,$AA,$72,$3A,$B7,$15,$6F,$AD,$F5,$BC,$1D,$4F,  7,$53,$C1,$85,$7E,$73,$7A,$BD,$C3,$A7,$62,$C8,$7F,$84,$72,$1B,$16,$7B,$14,$72,$FD,$88,$E2,$9F,$4E,$C5,$93,$D6,$DC,$E6,$81,$E0,$C2,$98; 3264
		dc.b $78,$38,  3,$89,$C0,$6C,$63,$10,$43, $F,$65,$D8,$A1,$E1,$4C,$3C,$3D,$8E,$2F,$22,$22,$22,$17,$CD,$33, $E,$4F,$87,$40,$E5,$B3,$69,$14,$F9, $F,$D9,$F5,$27,$F5,$72,$86,$5D,$51,$CB, $D,$BF,$C3,$A5,$77,$8F,$E1,$E6,$4F,$E2,$F4,$43,$F9,$2D,$91,$16,$1D,$74,$E3,$A7; 3328
		dc.b $5A,$C2,$59,$E5, $C,$F0,$96,$79,$43,$3C,$25,$9E,$50,$CF,  9,$67,$94,$14,$E1,$2C,$F2,$81,$84,$FD,$A2,$44,$D8,$E2,$A6,$CE,$97,$F4,$FF,$EB,$FF,$92,$22,$28,$EE,$CB,$F7,$D9,$6E,$75,$6E,$C8,$7E,$C8,$64,$51,$CF,$3F,$D9,$CE,$DA,$B2,$A7,$45,$32,$16,$65,$67,$F3,$C8; 3392
		dc.b $88,$88,$81,$83,$FD,$B7,$49,$BE, $F,$84,$73,$C9,$65,$1C,$F2,$59,$47,$3C,$96,$51,$CF,$25,$94,$73,$C9,$65,$1C,$F2,$59,$7F,$19,$CF,$77,$F1,$8D,$E6,$45,$13,$4A,$D5,$D5,$BC,$C8,$A3,$D4,$DE,  3,$36,$D8,$C3,$6C,$E8,$44,$55,$E5,$3E,$88,$4F,$A2,$15,$E5,  9,$E5,  4; 3456
		dc.b $8F,$44,$12,$39,$66,$46,$E8,$85,$F1,$CC,$93,$BE,$BF, $D,$97,$C7,$2C,$D7,$8E,$88,$5F,$1C,$C9,$3B,$C8,$8A,$BF,$FA,$91,$11,$11,$57,$9A,$BC,$C4,$55,$E6,$AB,$36,$D6,$CD,$B5,$B3,$6D,$AB,$6D,$7F,$AA,$F0,$6E,$AF,  6,$F0,$22,$22,$AB,$2A,$BF,$53, $B,$B5,$59,$B9,$C6; 3520
		dc.b $A1,$D0,$3D,$E7,  7,$3D,$CF,$DE,$F7,$3D,$1F,$2E,$B9,$2A,  4,$19,$54,$83,$3E,$A8,$2A,$3D,$53,$A5,$CF,$74,$3A,$4E, $E,$7C,$9D,$6B,$A4,$F2,$22,$AF,$30,$FE,$2E,$D8,$7F,$3D,$A9,$87,$FE,$8A,$7D,$4D,$D5,$E1,$9B,$94,$6F,$22,$8D,$CD,$FD,$6E,$C2,$22,$22,$2F,$FA,$FF; 3584
		dc.b $D4,$88,$88,$9B,$FE,$BF,$DF,$6F,$E7,$DD,$5A,$29,$11,$11,$56,$8A,$FF,$EF,$A1,$11,$11,$11,$11,$11,$10,$FE,$E1,$10,$4F,$E3,$25,$27, $A,$56,$96,$4D,$E8,$B6,$45,$E8,$CA,$20,$F4, $A,$D0,$A4,$9B,$38,$A0,$B1,$59,$51,$AE,$B3,$C2,  2,$E1,$94,$4E,$E0,$8F,$C8,$58,$2E; 3648
		dc.b $83,$2E,$4D,$61,$BC,$E3,$25,  7,$9C,$E4,$81,$45,$B2,$46,$78,$CE,$8D,$4C,$A5,$45,$AA,$E1,$90,$50,$FB,$82,$3C,$C2,$9D,$D0,$65,$30,$A3,$27,$9D,$79,$67,$39,$46,$CB,$64,$83,$2B,$1A,$49,$39,$24,$4E,$42,$49,$54,$94,$4A,$32, $A,$F9,$45,$24,$1C,$81,$59,$15,$1B,$3D; 3712
		dc.b $4A,$CB,$56,$76,$FE,$2B,$B3,$11,$11,$11,$61, $C,$20,$44,$44,$55,$E6,$9C,$36,$CE,$14,$AE,$14,$9C,$29,$56,$6A,$55, $D,$B5,$42,$95,$D0,$B0,$B3,$2E,$BD,$BC,$64,$44,$44,$44,$F1,$8A,$3F,$7A,$C3,$A6, $D,  5,$8E,$70,$E2,$99,$85,$84,$60,$FE,$9E,$A7,$AB,$1A,$EC,$56; 3776
		dc.b $74,$A1,$BD,$14,$3B,$F4,$91,$57,$FE,$91,$B7,$AE,$17,$B7,$EC,$AF,$C7,$F6,$A1,$D9,$A3,$43,$85,$6A,$E4,$87,$E9,$35,$83,$79,$8B,$60,$D6,$B4,$22,$60,$E2,$6F,$8C,$22,$A1,$6B,$CF,$82,$B7,$E7,$53,$BA,  3,$F3,$A3,$8E,$3D,$75,$6A,$AB,$8F,$53,$75,$B6,$A1,$AB,$18,$37; 3840
		dc.b $5B,$B3,$98,$EB,$89,$A5,$4A,$68, $E,$9A,$F7,$6A,$A7,$18,$85, $A,$70,$A1,$57,$4A,$F2,$2A,$F2,$83,$65,$76,$D7,$A1, $C,$A0,$95,$65,  4,$29,$C1, $A,$B4,$C3,$F9,$EF,$42,$9E,$50,$4A,$B2,$82,$15,$59,$41,$2A,$CA,  9,$56,$50,$49,$A3,$FF,$AA,$44,$45,$84,$2B,$85, $A; 3904
		dc.b $70,$A4,$E1,$49,$C2,$85,$38,$52,$70,$A4,$E1,$4A,$E9,$87,$FE,$88,$88,$8B,  8,$10,$87,$F2,$A8,$45, $A,$14,$F2,$2A,$14,$F2,$87,$F6,$9F,$71,$4E,$14,$29,$C2,$85,$38,$50,$A3,$DC,$BD,$B4,$70,$70,$70,$71,$31,$83,  7,$13,  6, $E,$26, $C,$19,$14,$54,$28,$58,$A8,$50; 3968
		dc.b $B1,$50,$A1,$61,$42,$20,$A1,$43,$E2,$A1,$41,$C5,$42,$83,$6D,$79,$6B,$CB,$5D,$8F,$DC,$3F,$92,$1C,$36,$75,$67, $F,$CE,$53,$7E,$79,$EC,$EA,$CE,$3F,$92,$1D,$E1,$AB,$2D,$42,$19,$E4,$1C,$1C,$1E,$A0,$C1,$8B,$59,  2,  4,$23,$64,  8,$11,$EA, $C,$18,$3C,$F2, $E, $E; 4032
		dc.b $1E,$1A,$B2,$D4,$1C,$45,$3C,$A0,$84,$44,$56,$7E,$A7,$53,$B5,$E5,$5F,$E7,$48,$AD,$65,$81,$60,$B0,$6B,$62,$B0,$B6,$6A,$CB,$B2,$A5,$FD,$23,$D9,$F2,$8C,$94,$B0,$53,$58,$45,$C7,$1E,$E3,$65,$87,$75,$F7,$2C,$2B,$35,$CD,$1A,  3,$7A,$FE,$D6,$27,$FB,$62,$39,$DE,$BF; 4096
		dc.b $C6,$10,$FE,$8C,$8F,  4,$22,$C2,$15,$A5,$69, $C,$8A,$1A,$43,$48,$6A,$47, $A, $A, $A, $A, $A, $A, $A, $A,$11,$10,$70,$70,$70,$70,$70,$70,$70,$70,$70,$70,$70,$71,$10,$40,$81,  2,  4,  8,$10,$20,$40,$81,  2,$16,$43,$21,$90,$C8,$65,$AF,$2D,$79,$6E,$B9,$26,$B4; 4160
		dc.b $22,$2A,$8F,  3,$85,$26,$64,$3F,$58,$51,$54,$A8,$F0,$3C, $E,$14,$FD,$61,$5C,$EC,$38,$51,$B2,$BA,$85,$56,$50,$42,$22,$2A,$B2,$82,$35,$EE,$90,$76,$97,$11,$11,$11,$15,$EE,$90,$76,$9F,$BC,$2C,$33,$21,$14,$78,$F0,$CA,  9,$56,$B4,$7F,$50,$A4,$E1,$42,$22,$29,$C2; 4224
		dc.b $85,$87,$EB, $A,$30,$42,$29,$C2,$9F,$AC,$2B,$89,$1C,$FB,$32,$B3,$2A,$1B,$8D,$C6,$E3,  6, $C,$18,$32,$22,$22, $A,$14,$28,$50,$A1,$42,$85, $A,$14,$28,$7D,  8,$94,$28,$58,$A8,$50,$B1,$50,$A1,$6A,$90,$7C,$1E,$97,$1A,$9F,$F4,$DC,$9B,$E2,$8E,$4D,$F1,$47,$26,$F8; 4288
		dc.b $A3,$93,$7C,$51,$C9,$BE,$28,$E4,$DF,$19,$42,$5C,$D7,$84,$22,$22,$22,$1F,$C5,$7C,$10,$88,$88,$88,$88,$AB,$85,  8,$88,$89,  2,  4,$28,$50,$88,$8A,$6F,$A1,$61,$FA,$C2,$8C,$10,$8A,$6F,$A7,$EB,  1,$D7,$71,$BA,$BB,$57,$F9,$E8,$E4,$DF,$14,$72,$6F,$8A,$39,$37,$C5; 4352
		dc.b $1C,$9B,$E2,$8E,$4D,$F1,$47,$26,$FA,$8C,$1F,$ED,$BA,$4D,$F0,$7C,  8,$88,$88,$BF,$8C,$E7,$FF,$4A, $E,$84,$65,$9B,$18,$9E,$6C,$44,$94,$E0,$33,  7,$B8,$D4,$86,$76,$CF,  9,$6C,$1D,$CB,$FA,$4A,$DC,$DF,$B2, $A,$D9,$B6,$55,$9F,$78,$38,$AF,$52,$45,$DD,$4A,$37,$9F; 4416
		dc.b $F9,$1F,$FC,$46,$75,$7D,$C3,$B8,$66,$78,$CC,$FC,$50,$F1,$43,$74,$5D,$53,$E4,$F0,$F9,$3E,$4B,$25,$DE,$AF,$FE,$26,$78,$34,$9A,$51,$72,$62,$8E,$68,$26,$C4,$83,$27,$ED,$11,$8E,$A3,$8F,$ED,$22,$A9,$B1,$15,$BF,$A4,$38,$69,$C3,$4F,$FC,$70,$22,$22,$22,$ED,$FC,$DF; 4480
		dc.b $43,$FB,$6F,$C6,$84,$44,$45,$1E,$1F,$9B,$CA,$C3,$B0,$F7,$1E,$E3,$A9,$30,$4C,$13,  4,$C1,$30,$4C,$12,$26, $C,$18,$D0,$3A,$74, $E,$9D,  3,$A7,$40,$E9,$D0,$3A,$74, $E,$9D,  3,$A7,$41,$A3,$F5,$3F,$53,$F5,$3E,$9A,$8E,$27,$A8,$88,$88,$BA,$1F,$D2,$FC,$9F,$FA,$9D; 4544
		dc.b $DD,$B4,$67,$27,$69,$11,$11,$7E,$A7,$75,$91,$79,$A9,$A9,$A9,$B1,$C4,$E2,$71,$38,$9C,$4E,$27,$13,$89,$C4,$E2,$71,$38,$9C,$4E,$34,$17, $D,$32,$22,$22,$22,$27,$3F,$53,$EE,$87,$19,$FE,$C8,$DC,$64,$44,$44,$44,$44,$44,$45,$B3,$A5,$EA,$FF,$CD,$FE,$AB,$76,$BD,$D3; 4608
		dc.b $48,$DE, $F,$4A,$24,$50,$F5,$5C,$13,$BA,$DC,$49,$DF,$EF,$63,  6, $D,$BF,$C3,$40,$6C,$73,$BA,$96,$CD,$C7,$AA,$27,$72,$6A,$31,$4E,$2A,$6A,$A1,$B1,$83,  6,$40,$FF,$BD,$A4,$52,$A4,  7,$A5,$2F,$70,$43,$D5,$74,$71,$B7,$BA,$85,$FE,$FB,$41,$83,  6,$3F,$C2, $D,$8D; 4672
		dc.b $8D,$AE,$A5,$B3,$71,$EA,$89,$DC,$9A,$8C,$18,$B6,$9A,$A9,$68,$30,$60,$C1,$90,$FF,$3B,$C8,$3B,$FA,$21,$26,$98,$21,$10,$4C,$1D,$FB,$19,$2D,$6A,$86,$E4,$DF,  9,$5E, $D,$EA,$6E,$E5,$15,  7,$78,$30,$A0,$EF,  6,$14,$18,$40,$61,$63,$7E,$3D,$45,$70,$B8,$5C,$2E,$6B; 4736
		dc.b $85,$C2,$E1,$71,$73,$F3,$73,$7F,$F4,$BF,$F9,$CE,$5C,$DF,$F9,$FF,$CF,$FC,$88,$85,$C2,$E1,$70,$FF,$E7,$FF,$38,$C5,$C2,$E1,$71, $F,$FE,$91,$73,$91,$7F,$F0,$B7,$64,$FC,$9F,$93,$F2,$77,$FB,$DD,$FE,$F6,$A0,$F0,$9D,  6,$AA,$8E,$80,$D9,$C1, $F,$AD,$C3,$B9, $D,$1C; 4800
		dc.b $8E, $E, $E, $E,$22,$64,  8,$11,$B9,$1E,$97,$B5,$E7,$A3,$AA,$4B,$37,$65,$3E,$D1,$A8,$F5,$1E,$A3,$EB,$FF,$79,$FF,$BC,$E8,$3C,  5,$23,$41,$AA,$A3,$A0,$3A,$90,$FA,$DC,$29,$8A,$1A,$63,$40,$E0,$E0,$E1,$42,$24,  8,$10,$20,$BC,$F4,$E4,$EB,$CF,$47,  4,$64,$B3,$76; 4864
		dc.b $53,$ED,$8F,$47,$EE,$32,$D6, $C,$63,  3,  6,$D8,$E6,$38,$E7, $B,$52,$33,$A6,$91,$36,$B5,$8C,$3A,  6,$E5,$85,$B8,$84,$10, $E,$82,$EF,$58,$39,$97,$7A,$B3,$A0,$BB,$D6,  1,$D0,$5D,$EB,  2,$22, $F,$74,$5C,$14,$F1,$B4,$88,$88,$88,$87,$FD,$77,$85,$DE,$A2,$F0,$EB; 4928
		dc.b $5C,$31,$1F,$B5,$A9,$77,$AD,$4E,$B5,$C3,$38,$FD,$AC,$7F,$AB,$9E,$39,$E6,$B9,$94,$A7,$8D,$76,$94,$76,$1E,$73,$FD,$B2,$6C,$3B,$C9,$A1,$9D,$C2, $C,$B8,$D4,$AE,$CD,$25,$74,$54,$1A,  5,$74,$61,$25,$72,$55,$F9,$D3,$70,$74,  7,$18,$31,$8C, $C,$1B,$63,$98,$E3,$9C; 4992
		dc.b $2D,$48,$CE,$9A,$44,$DA,$D6,$30,$E8,$1B,$96,  0,$DD,  5,$92,$C0,$E3,$27,$C1,$5B,$3B,$BF,$36,$E6,$4C,$FC,$6B,$14,$FD,$8A,$32,$32,$57,$26,$90,$36,$46,$43,$91,$BA,  8,$15,$BF,$4D,$FA,$44,$7F,$F5,$47,$EC,$F8,$AB,$37,$90,$32,$AE,  7,$17,$24,$91,$6B,$49,$43,$7A; 5056
		dc.b $38,$D1,$C6,$AF,$30,$86,$16,$37,$98,$50,$62,$F3, $B,$68,$BD,$96,$D0,$83,$F4,$D7,$E2,$79,$DE,$E4,$FD,$26,$C5,$6E,$EE,$27, $E,$E5,$79,$11,$57,  9,$38,$27,$FD,$3F,$49,$FF,$2F,$F9,$2F,$F9,$87,$FB,$48,$7F,$B3,$9A,$48,$EF,$E2,$38,$68,$F3,$FD,$93,$68,$BD,$CF,$36; 5120
		dc.b $D1,$ED,$F9,$D8,$E8,$FC,$34,$7F,$FB, $F,$FC,$70,$22,$22,$22,$2A,$DE,$84,$44,$45,$37,$A1,$97,$F1,$82,$38,$7F,$9E,$AE,$B1,$A9,$B4,$1A,$87,$5A,$36,$83,$50,$D4,$71,$D0,$6A,$8F,$EB,$5B,$51,$FF,$96,$5F,$E5,$10,$58, $E,$91,  5,$80,$72,$34,$96,$53,$34,$36,$92,$E1; 5184
		dc.b $A0,$84,$A0,$14,$68,$90,$94,$10,$EF,$82,$39,$3F,$6B,$FF,$F2,$FF,$4E,$AF,$F4,$2F,$FB,$9F,$FF,$F2,$23,$A7,$EC,$41,$8F,$DF,$1E,$A8,$D0,$AB,$3C,$B6,$64,$6D,$97,$EF,$5F,$A9,$BF,$7A,$DA,$2F,$ED,$15,  2,$7E,$D1,$2A,$EB,$AF,$AE,$2A,$9F,$B2,$45,$38,$55,  3,$1F,$D1; 5248
		dc.b $1C,$C9,$FE,$72,$22,$22,$22,$91,$7F,$9D,$BF,$5A,$DA,$AA,$D0,$6A,  8,$DA, $D,$43,$51,$8D,  6,$A1,$D7,$57,$58,$D4,$7F,$E5,$D3,$FD,$84,$51,$EB,$DD,$38,$21,$F5,$C4,$C3,$E4,$E6,$D5,$25,$8F,$5E,$3F,$A6,$1A,$83,$96,$ED,$78,$88,$21,$F5,$E2, $C,$3E,$4E,$6D,$52,$59; 5312
		dc.b $E3,$FA,$61,$B2,$3F,$A6,$B5,$B6,$5B,$9F,$65,$B9,$FF,$6D,$9C,$B6,$5A, $F,$65,$B9,$DE,$B6,$E7,$D9,$6E,$7D,$96,$E7,$D8,$6E,$51,$B0,$DC,$CA, $D,$CC,$A1,$42,  4,$12,$79,$A9,$54,$F4,$32,$2A,$9E,$86,$45,$37,$C3,$F4,$84,$44,$45,$83,$C9,$9F, $F,$D2,$38,$83,$D0,$CA; 5376
		dc.b $A7,$A1,$94,$D0,$CA,$B5,$FE,$8B,$88,$88,$88,$89,$DF,$D5,$7F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$EC,$7F,$FB,$FB,$1F,$DC,$11,$11,$17,$EF,$3F,$68,$5F,$B8,$8E,$9D,$51,$D2,$3A,$36,$91,$D1,$A5,$1D,$2B,$D2,$30,$6D,$23,$A3,$69,$1D,$1A,$51,$D2,$BD; 5440
		dc.b $23,  6,$D2,$3A,$36,$91,$D2,$BD,$2B,$D2,$30,$6D,$23,$A3,$69,$1D,$2B,$D2,$2E,$37,$1D,$2E,$B2,$EA,$D7,  5,$C1,$70,$7C,$2A,$7C,$36,$B3,$E1,$B5,$9F, $D,$B5,$1C,$35,$6B,$D5,$AF,$6D,$47, $D,$AC,$70,$DA,$C7, $D,$B5,$6D,$22,$AB,$85,$5C,$31,$A6,$BB,$B5,$C9,$CF,$8A; 5504
		dc.b $45,$22,$91,$48,$A4,$52,$29,$14,$83,$23,$41,$28,$C9,  4,$DA,$D0,$4D,$B5,$40,$F5,$E5,$AF,$A3,  7,$CE, $F,$A3,$1C,$1F,$B5,$A1,$E1,$1D,$A4,$53,$B3, $B, $B, $B,$27,$C1,$D1,$E1,$8A,$76,$E3,$7A,$F7,$5F,$9C,$F9,$67,$B5,$3F,$53,$D7,$9D,$ED,$DB,$8A,$70,$EE,$BD,$71; 5568
		dc.b $E5,$9C,$EF,$E9,$B5,$33,$F1,$5E,$2D,$E4,$DC,$A3,$79,$FF,$1B,$34,$88,$88,$8A,$AF,$FA,$FE,$FF,$F6,$BF,$BA,$22,$C2,$11,$FD,$AD,$3A,$BF,$FF,$1D,$A5,$5D,  8,$8A,$7F,$F8,$FF,$97,$37,$4B,$FF,$73,$A8,$F5,$52,$AD,$B3,$DB,$1E,$D9,$E2,$B4,$A9,$21,$49,$BE,$95,$D3, $F; 5632
		dc.b $FD,$16, $F,$AD,$E9,$37,$A1,$D4,$F4,$3A,$9E,$87,$53,$D0,$E6,$F8,$6F,$71,$94,$DE,$87,$53,$D0,$CA,$A7,$A1,$D4,$F4,$32,$A9,$F2,$38,$EC,$12,$7B,$6C,$90,$45,$FD,$30,$39,$31,$C5,$4D,$5E, $D,$EC,$A0,$C5,$AD,$B3,$89,$46,$C0,$AF,$56,$7C,$56, $F,$38,$AB,$82,$9B,$2B; 5696
		dc.b $84,$8D,$95,$C2,$46,$CA,$E1,$23,$8B,$84,$8C,$3A,$32,$36,$56,$91,$C6, $D, $F,$F2,$73,$FE,$C7,$FF,$BF,$B1,$FD,$C1,$11,$55,$FB,$1E,$8D,$B5,$6C,$B4,$1E,$CB,$73,$BD,$6D,$CF,$B2,$DC,$FB, $D,$D9,$F6,$1B,$94,$6C,$37,$28,$30,$6E,$58,$9B,$20,$93,$DC,$A3,$3E,$C3,$73; 5760
		dc.b $6C,$37,$54,$6E,$A9,$70,$5C,$17,  5,$C1,$59,$16,$46,$E6,$CF,$FA,$67,$37,$E9,$9C,$CE, $F,$73,$38,$24,$5D,$14,  6,$12,$29,$14,$8A,$45,$22,$82,  2,  1,$E2,  4,$44,$44,$43,$FE,$DF,$F6,$22,$22,$AF,$FE,$DC,$D6,$FF,$57,$79,$11,$11,$15,$7B,$2B,$D8,$45,$3F,$D3,$37; 5824
		dc.b $E9,$B9,$6C,$E5,$C5,$7F,$14,$6D,$AF,$F6,$98,$DA,$DB,$2F,$B7,$65,$F6,$B5,$F6,$D5,$69,$11,$57,$FF,$42,$AF,$64,$DF,$7C,$76,$25,$AC,$FB,$CD,$B6,$25,$B1,$BC,$E6,$72,$59,$C0,$39,$6A,$93,$39,$62,$72,$67,$2C,$4E,$4C,$E5,$89,$C9,$9C,$B1,$39,$32,$D4,$72,$80,$7D,$46; 5888
		dc.b  $C,$88,$88,$88,$A9,$FA,$9E,$21,$FB,$C2,$FD,$A7,$EE,  8,$88,$88,$88,$88,$88,$AA,$D7,$96,$BC,$9C,$6E,$36,$CD,$B2,$A4,$DE,$95,$1F,$E7,$4E,$29,$81,$AF,  5,$3A,$B6,$20,$40,$AF,$CF,  5, $B,  3,$81,$C0,$22,$CC,$C2,$CC,$C2,$CC,$C2,$CC,$C2,$CC,$C2,$CC,$C1,$C0,$E0; 5952
		dc.b $70,$10,$10,$48,$24,$12, $C,$91,$48,$A4,$52,$29,$14,$8A,$45,$22,$91,$46,$80,$82,$40,$43,$FF,$F4,$D7,$AB,$5E,$AD,$7D,$15,$2E, $B,$82,$E0,$B8,$1C,$36,  8,$1C,$3F,$FF,$56,$ED,$5B,$B3,$6E,$D5,$B8,$3A,$5D,$92,$73,$2F,$ED,$16,$3F,$B2,$8B,$97,$62,$BA,$26,$C7,$57; 6016
		dc.b $EC,$EA,$FD,$93,$2C,$31,$5B,$B7,$64,$5F,$B3,$2A,$BF,$62,$3F,$5C,$36,$46,$F9,$C1,$9E,$CF,$38,$32,$1F,$E9,$9C,$F9,$11,  3,$A8,$E3,$FB,$72,$26,$92,$FE,$D9,$64,$FF,$F1,$8B,$C3,$B9,$1A,$C9,$6A,$35,$92,$99,$60,$71,$35,  8,$71,$CF,$FD,$FF,$CE,$FF,$48,$88,$88,$88; 6080
		dc.b $BF,$FD,$CD,$5A,$60,$B8,$4B, $D,$A3,$F9,$ED,$4C,$3F,$F9,$7F,$4A,$38,$1C,$BF,$5C, $D,$21,$AB,$F5,$5E,$12,$D7,$CA,$37,$91,$46,$E6,$84,$F8,$C5,$E1,$DC,$8D,$64,$B5,$1A,$C9,$4C,$B0,$38,$9A,$C9,$6A,$35,$92,$9C,$61,$78,$E6,$FD,$98,$4C,$16,$B3,$95,$5B,$42,$36,$D6; 6144
		dc.b $34,$DB,$56,$DA,$EC,$E8,$F0,$65,$D9,$E0,$DE,  4,$44,$55,$65,$57,$EA,$61,$FB,$AE,$4F,$22,$22,$2A,$F3,$47,$AB,$6C,$7A,$BB,  8,$AB,$CD,$1E,$AD,$A3,$37,$83,$43,$6C,$E9,$87,$F2,$BC,$23,$9B,$C0,$66,$DB,$18,$6D,$9D,  8,$AA,$ED,$8F, $E,$EF,$D5,$62,$44,$44,$33,$55; 6208
		dc.b $9B,$6B,$66,$DA,$D9,$B6,$D5,$9B,$F7,$5B,$6A,$CD,$B5,$B3,$6D,$6C,$DB,$6A,$DA,$45,$57, $A,$B8,$63,$57, $E,$C2,$AF,$85,$5C,$31,$6E,$18,$DF,$C3,$1B,$F3,$E3,$7E,$7B,$6F,$CF,$6D,$FD,$1B,$3F,$6B,$C3,$1B,$F3,$E3,$7E,$7B,$6F,$CF,$6D,$F9,$ED,$BD,$AD,$BD,$BF,$66,$D7; 6272
		dc.b $DA,$D7,$DB,$C7,  7,$40,$E4,$2C,$D0,$28,$59,$A8,$59,$A8,$56,$85,$4F,$81,$ED, $F,$87,$83,$3F,$6C,$E9,$86,$BB,$B5,$DD,$AF,$C0,$20,$48,$78,$34,$36,$C6,$1B,$67,$42,$2A,$BB,$63,$C3,$BB,$5D,$35,$BD,$D2,$12,  7,$81,$E0,$78,$1D,$50,$30,$6D,  3,$DA, $E,  7,$B5,$A0; 6336
		dc.b $36,$D5,  3,$D7,$AB,$5E,$5B,$62,$B0,$7E,$D6,$83,$F6,$B4, $F,$6D,$5B,$48,$AA,$E1,$57, $C,$7F,$75,$8D,$4F,$CC,$FA,$93,$7A,$54,$7F,$9D,$38,$A5,$48,$C6,$BC,$14,$C2,  4,$D8,$81,  2,$C3,$3C,$14,$27,$F5,$50,$88,$88,$BF,$EB,$FF,$FF,$FD,$11,$11,$55,$FF,$5F,$FF,$D5; 6400
		dc.b $FF,$A2,$22,$9F,$FD,$7F,$FE,$51,$FF,$D1,$15,$5F,$F5,$FF,$F9,$15,$5F,$FA,$C2,  3,$FA,$B4,$87,$F7,$C5,  8,$8A,$BB,$3F,$55,$FB,$F5,$EA,$FF,$F9,$11,$17,$FE,$3F,$E4,$44,$55,$42,$3F,$B5,$A7,$57,$EF,$C7,$81,$11,$11,$10,$FF,$C7,$FC,$B9,$BF,$6F,$FB,$9F,$DF,$61,$64; 6464
		dc.b $7F,$70,$EE,$DF,$D9,$27,$77,$EC,$D7,$97,$ED,$CF,$A7,$F6,$29,$C5,$FB,$31,$D5,$FC,$69,$F5,$37,$57,$86,$6F,  8,$ED,$22,$28,$F6,$F8,$37,$6F,$81,$11,$47,$84,$7B,$71,$ED,$EE,$BF,$BB,$96,$7E,$5D,$36,$F4,$F1,$5F,$C5,$C9,$B9,$46,$F8,$F2,$B7,$97,$17,$1F,$17,$EB,$1B; 6528
		dc.b $F5,$93,$FF,$95,$7C,$23,$DB,$88,$E1,$DD,$7D,$98,$F2,$CE,$EB,$FA,$6D,$4C,$FC,$57,$AD,$BC,$9B,$56,$7D,$9D,$56,$63,$7F,$4B,$AF,$CF,$C4,$99,$ED,$E4,$B6,$DF,$13,$BD,$BF,$66,$D7,$F1, $B,$ED,$FD,$67,$2C,$75,$7E,$75,$1B,$95,$A2,$FE,$2E,$34,$B7,$F5,$8C,$7C,$71,$78; 6592
		dc.b $BA,$6F,$9C,$30,$84,$74,$E3,$7D,$47,$C6,$F8,$C2,$EA,$E1,$54,$B0,$94,$DF,$83,$C9,$A0,$DC,$7F,$9D,$D5,$BB,$AE,$DB,$DB,$F6,$6D,$7D,$AD,$7D,$BC,$77,$DB,$76,$B6,$B7,$8C,$3D,$B8,$C4,$30,$85,$5F,$9D,$E3,$AA,$DE,$3A,$B8,$EA,$83,$4A,$A8,$34,$8A,$2F,$AA, $C,$FA,$A1; 6656
		dc.b $3E,$CF,$EE,$5B,$B2,$AC,$F6,$EC,$31,$B3,$3D,$AA,$F3,$76,$CC,$F6,$B1,$BB,$66,$7A,$8D,$DB,$2B,$37,$1B,$82,  4,$12,  7,$D4,$F3,$53,$7A,$36,$73,  6,$13,$7C,$D6,$49,$1E,$94,$37,$8B,$5E,$6F,$53,$7D,$BB,$2D,$78,$71,$D4,$F8,$37,$EC,$48,$AA,$FD,$BC,$4E,$A3,$22,$1B; 6720
		dc.b $B2,$FD,$F6,$5B,$88,$88,$BF,$F1,$FF,$2E,$6F,$FB,$F3,$F3,$17,$37,$3F,$EF,$32,$FD,$65,$50,$8F,$FC,$88,$8B,$FF,$1F,$F2,$E6,$FF,$BF,$FF,$88,$AA,$FF,$C7,$FC,$B9,$BF,$EF,$CF,$57,$31,$73,$73,$F1,$D9,$FC,$C6,$94,$5F,$83,$C7,$EF,$7F,$7D,$FB,$32,$E6,$E7,$FF,$E3,$43; 6784
		dc.b   8,$10,$FF,$95,$5F,$F8,$FF,$97,$37,$FD,$F9,$F9,$8B,$9B,$9F,$FF,$84,$1F,$83,$EA,$86,$10,$8C,$83,$BF,$95,$AB,$87,$F4,$91,$DF,$D3,$54,$FE,$B9,$AF,$F4,$50,$FF,$A6,$12,$B4,$1F,$D3,$37,$E6,$FD,$B2,$F2,$FF,$BF,$3F,$31,$73,$73,$FF,$30,$DB,$F7,$80,$FF,$79,$AE,$E1; 6848
		dc.b $75,$4F,$AA,$58,$48,$88,$43,  8,$47,$F7,$9F,$BD,$FD,$8F,$31,$73,$73,$FF,$F1,$9F,$54,$19,$E3,$F5,$DB,$BF,$5D,$A4,$7F,$66,$7C,$BF,$63,$77,$17,$EF,  5,$D6,$5D,$5C,$99,$F8,$3E,$70,$9F,$5E,$EF,$E7,$73,  4,$C1,$6B,$39,$60,$95,$9A,$E1,$2A,$FF,$A3,$9E,$AD,$96,$83; 6912
		dc.b $D9,$6E,$77,$AD,$B9,$F6,$5B,$9F,$66,$39,$F6,$62,$DB,$31,$AB,$12,$1C,$DF,$F7,$E7,$E6,$2E,$6E,$7F,$DE,$5A,$DF,$BC,$D0,$FF,$B8,$2E,$22,$22,$9F,$E7,$67,$A6,$D9,$E9,$4A,$F4,$A4,$F4,$A5,$5F,$9D,$A5,$5A,$6D,$AB,$4A,$57,$42,$C3,$F7,$DE,  3,$F6,$28,$28,$3F,$66,$12; 6976
		dc.b $CA,$D1,$6C,$E4,$11,$94,$C5,$E1,$58,$E9,$26,$CE,$28,$2C,$56,$54,$FD,$64,$B9, $B,$FA,$51,$C0,$E5,$FA,$E9,$18,$86,$A1,$D1,$AA,$45,$57,$44,$61,$AA,$3A,$A0,$D0,$FD,$74,$1B,$62,$4A,  1,$F2,$8B,$F3,$B5,$B3,$32,$CE,$FE,$97,$AD,$7B,$23,$FA,$6C,$7F,$4D,$DD,$15,$7C; 7040
		dc.b $BF,$64,$1F,$9C,$85,$B5,$DA,$E7,$F1,$77,  7,$F7,$54,$E2,$C3,$FE,$53,$EE,$6E,$E8,$E2,$44,$45,$5D,$FB,$F1,$6C,$FB,$31,$6D,$98,$D5,$89,$11,$15,$7F,$A6,$CD,$FA,$AE,$5B,$6A,$DB,$3A,$11,$15,$79,$4F,$A2,$1F,$CA,$BD,$E4,$44,$44,$53,$EA,$9F,$51,$11,$57,$9A,$3D,$5B; 7104
		dc.b $7A,$BC,$1B,$C2,$7F,$FA,$29,$F5, $F,$DA,$F8,$43,$F7,$F1,$A1,$16,$1F,$BA,$FD,$FF,$ED,$7F,$FE,$44,$45,$FF,$8F,$F9,$11,$11,$11, $F,$FA,$F8,$7F,$17,$F5,$44,$45,$84,  7,$F5,$69, $F,$EF,$8A,$11,$11,$15,$5F,$F8,$FF,$97,$37,$4F,$F2,$7F,$5C,$58,$58,$3F,$B0,$EB,$3F; 7168
		dc.b $A4,$8E,$FE,$9A,$A7,$F5,$CD,$7F,$A2,$92,$FE,$AB,$CA,$3F,$F5,$FF,$F9,$11,$17,$FE,$3F,$E5,$CD,$FF,$7E,$7E,$62,$FE,$1F,$E9,$BF,$8B,$57,$FD,$7F,$FE,$44,$45,$FB,$8F,$DD,$7E,$CB,$FE,$BF,$FF,$22,$22,$FF,$C7,$FC,$B9,$BF,$EF,$CF,$CC,$5C,$DC,$EA,$24,$24,$24,$61,$42; 7232
		dc.b $CD,$43,$E0,$70, $F,$38,$7F,$FC,$88,$A7,$AE,$ED,$77,$6B,$BB,$5D,  2,$41,$20,$90,$10,$1F,$FF,$22,$22,$FF,$C7,$FC,$B9,$BF,$EF,$CF,$CC,$5F,$F2,$FE,$E4,$8E,$CF,$E6,$C0,$43,$FF,$E4,$44,$5F,$F8,$FF,$97,$37,$FD,$F9,$F9,$8B,$FE,$5F,$FC,$9F,$FE,  8,$8B,  8,$4F,$35; 7296
		dc.b $23,$9B,$68,$EA,$DB,$1E,$AF,$E5,$61,  9,$E6,$A3,$75,$6D,$19,$BC,$23,$B4,$8A,$76,$76,$78,$35,$99,$BC,$23,$B4,$88,$A3,$DA,$DD,$BD,$DC,$3B,$B9,$70,$FD,$57,$EA,$4A,$BE,$11,$ED,$C7,$B7,$BA,$FE,$EE,$59,$F9,$74,$DB,$D3,$C5,$7E,$F5,$D8,$78,$DF,$D3,$C5,$9F,$8B,$95; 7360
		dc.b $BC,$A3,$7C,$79,$37,$2E,$2B,$F8,$BF,$59,$6F,$EB,$23,$6E,$9F,$CE,$E5,$1B,$E3,$CA,$DE,$5C,$5C,$7C,$5F,$AC,$6F,$D6,$43,  8,$15,$5F,$B8,$FD,$DF,$EC,$FF,$EF,$CF,$CC,$5C,$DC,$FF,$BC,$AA,$EF,$D6,$FF,  7,$98,$B9,$B9,$FF,$F8,$51,$D3,$FD,$C9,$5A, $F,$E9,$9A,$7F,$46; 7424
		dc.b $E3,$FE,$E0,$B9,$A1,$84,$1A,$58,$48,$7E,$B7,$F9,$9C,$5F,$EC,$D7,$83,$DA,$58,$4A,$A8,$61,  6,$7E, $F,$6F,$FD,$1B,$8E,$6A,$CE,$37,$54,$A1,$41,$BA,$B5,$22,$20,$F7,$3D,$C2,$46,$EA,$B3,$BD,$AD,$9B,$ED,$AD,$CF,$77,$13,$CE,$2F,$76,$C6,$30,$60,$DC,$C8,$10,$20,$5C; 7488
		dc.b $64,$8E,$93,$9B,$3B,$E2,$73,$B4,$95,$FD,$2F,$CF,$B2,$B7,$BB,$F4,$D3,$37,$1F,$E9,$84,$96, $F,$FD,$27,$15,$ED,$FB,$36,$BC,$E3,$7D,$B7,$72,$B7,$8C,$71,$71,$B3,$FF,$59,$53,$E7,  6,$EB,$FD,$6E,$57, $B,$F8,$B8,$C5,$BF,$AC, $F,$1C,$6F,$8B,$E2,$F2,$10,$C2,$13,$94; 7552
		dc.b $EE,$ED,$BA,$CD,$2C,$59,$98,$59,$98,$59,$98,$59,$98,$59,$98,$5A,$A0,$70,$38,$1C, $F,$C0,$41,$20,$9A,$EE,$D6,$C9,$14,$8A,$45,$22,$91,$48,$A4,$52,$29,$14,$80,$80,$82,$43,$FF,$ED,$4D,$7A,$B5,$E5,$AF,$A0,$88,$A7, $D,$82,  7,  7,$FF,$FC,$A3,$4F,$F1, $D,$2B,$41; 7616
		dc.b $A4,$DC,$83,$49,$B9,  6,$93,$75,$F9,$45,$EC,$A3,$5E,$A0,$F3,$50,$8F,$45, $F,$72,$31,$87,$A8,$30,$F6,$73,$D4,$18,$7B,$1B,$D4,$1D,$4E,$7A,$83,$A8,$DE,$B5,$B9,$EB,$59,$BD,$60,$EB,$50,$3C,$1C,$98,$C2,$B1,$C9,  1,$87,$B1,$C9,  1,$87,$B1,$CA,$F3, $F,$63,$93,$18; 7680
		dc.b $7B,$1C,$94,$18,$7B,$1C,$A0,$92,$C6,$46,$12,$29,$14,$8A,$45,$22,$90,$A0,$4A,$A8,$C8,$D0,$A4,$50,$25,$2A,$48,$52,$A4,$7C,$32,$D7,$AB,$5D,  2,$85,$9A,$85,$68,$50,$28,$50,$74,$65, $B, $A,$45,$60,$FA,$54,$7B,$6A,$7D,$30,$A5,$7B,$4A,$76,$57,$63,$A7,$63,$A7,$63; 7744
		dc.b $82,$46,$C7,  4,$51,$C1,$C1,$14,$F5,$E2,$C9,$2C,$21,$49,$C2,$93,$85,$27, $A,$4E,$14,$9C,$29,$38,$52,$BA, $E,$1D,$7D, $D,$C3,$66,$7A,$AC,$1B,$2A,$B1,$C6,$F8,$D8,$E4,$58,$D8,$E4,$50,$62,$C7,$22,$83,$4B,$1C,$8A, $D,  3,$82,$6F,$86,$C2,$22,$2C,$21,$3C,$D4,$8E; 7808
		dc.b $6D,$B5,$66,$FD,$51,$61, $A,$BA,$A8,$D9,$BC,  6,$6D,$B5,$6D,$2A,$FF,$75,$E0,$DD,$5E,  2,$1E,$15,$50,$88,$AA,$ED,$6E,$DE,$EE,$CE,$E2,$22,$22,$19,$9B,$F6,$BB,$73,$7E,$FD,$B3,$7F,$68,$8A,$BC,$CD,$FB,$5D,$B9,$BF,$7E,$DB,$48,$88,$8A,$76,$47,$F7, $E,$ED,$FD,$92; 7872
		dc.b $77, $E,$4B,$FB,$3E,$93,$FD,$9F,$E9,$20,$DF,$F5,$FF,$F9,$11,$17,$F6,$1D,$D8,$ED,$6E,$86,$33,$A0,$74,$E8,$1D,$3A,  7,$4E,$81,$D3,$A0,$74,$E9,  7,$4D,$C3,$41,$A8,$6A,  9,  6,$38,$9C,$4E,$27,$13,$89,$C4,$E2,$71,$38,$9C,$4E,$27,$13,$89,$AB,$82,  7,  4,$75,$67; 7936
		dc.b $4A,$8E,$14,$AA,$1B,$6A,$3A,$4E,$14,$AE,$95,$D3, $A,$6B,$BB,$5D,$D4,$A9,  2,$52,$A4,$85,$26,$94,$9C,$29,$5D,$2B,$A1,$57,$61,$4F,$83,$AA,$B3,$14,$8D,$8E,  8,$AD,$63,$82,$2B,$58,$E0,$8A, $E,$C7,  4,$50,$68,$EB,$D4,$1A,  7,$28,$57,$AE,$26,$F5,  6,$1E,$15,$CF; 8000
		dc.b $50,$61,$EC,$6F,$50,$71,$57,$3D,$41,$D4,$6F,$59,$AB,$9E,$B5,$9E,$C7,$3D,$CF,$71,$85,$72,$93,$95,$C4,$AE,$64,  8,$12,$29,$14,$8A,$45,$22,$91,$40,$AE,$5C,$64,$1D,$56,$77,$B5,$B3,$E2,$AD,$C6,$EE,$27,$AC,$4D,$C6,$F3, $B,$51,$94,  4,$82, $B,$C8,$88,$8A,$BC,$D5; 8064
		dc.b $66,$DB,$56,$6E,$C2,$C2,$15,$C2,$93,$85,$2A,$CD,$4A,$A1,$B6,$39,$A9,$3C,$DA,$E9,$3C,$D4,$AA,$1B,$67,$42,$AE,$CA,$EC,$75,$5C,$1D,$55,$98,$DF,$FA,$A7,$35,$F8,$42,$79,$A9,$1C,$DB,$5B,$36,$D8,$C3,$6C,$E8,$58,$6B,$DB,$38,$6D,$9D,  8,$A7,$C2,$AE,$18,$B7, $C,$42; 8128
		dc.b $70,$C4,$5E,$BC,$3F,$55,$91,$BE,$76,$63,$1E, $E,  8,$38,$63,$7A,$D9,$8D,$F9,$CD,$C1,$33,$DA,$2F,$5B,$45,$F9,$CC,$5E,$DB,$E0,$F8,$62,$82,$FC,$F6,$DF,$9E,$DB,$C2,$DB,$7B,$38,$C2,$36,$37,$5E,$31,$E3,$8B,$B8,$C4,  6,$37,$46,  3,$AF,$FA,$53,$ED,$8F, $E,$E1,$C3; 8192
		dc.b $11,$7D,$98,$F2,$CE,$EB,$FA,$6D,$4C,$FC,$57,$AD,$A2,$F6,$31,$7B,$63,$7B,$63,$C6,$D8,$F1,$B6,$3C,$75,$71,$C6,$13,$78,$84,$DE,$55,$7E,$F3,$F5,$BA,$87,$17,$20,$7C,$A2,$E4,$8F,$75,$C3,$BB,$F5,$81,$DF,$AC,$AA,$E8,$C3,  8,$47,$FD,$D7,$47,$F6,$57,$77,$7E,$F0,$7E; 8256
		dc.b $B0,$9F,$83,$E7, $C,$21,$5F,$FE,  8,$88,$8B,  8,$4F,$35,$27,$9B,$59,$61,  9,$E6,$A4,$73,$6D,$6C,$DB,$63, $D,$B3,$A6,$1A,$B2,$FD,$66,$5D,$8B, $E,$98,$63,  5,$8E,$70,$E2,$99,$85,$84,$60,$FE,$9E,$A7,$83,  6,$BB,$15,$E7,$27,$23,$A4,$8E,$47,$7E,$9A,$A9,$23,$24; 8320
		dc.b $50,$20,$4A,$D0,$23,$1C,$60,$FC,$D6,$EC,$FD,$D1,$AF,$64,$CE,$EF,$D6,$DD,$A3,$D4,$E2,$6B,$5A,$EB,$27,$9C,$57,$59,$32,$85,$AB,$F8,$F5,$69,$AF,$4E,$C6,$D7,$1E,$2D,$51,$36,$A1,$B1,$B5, $C,$98,$EA,$3A,$E8, $E,$BA, $A,$7E,$BB,$BA,$15,$7E,$B2,$A4,$64,$94,$50,$20; 8384
		dc.b $46,$40,$91,$CC,$F8,$44,$FF,$75,$B2,$DA,$BB,$14,$C6,$43,$24,$E8,$95,$49,$82,$60,$98,$26,  9,$82,$32,$D4,$91,$D0,$68,$34,$80,$D2,$A3,$A4,$E1,$49,$9D,$27, $A,$4C,$E9,$5D, $A,$BB,$32,$D7,$96,$BC,$B5,$D2,$C9,$C2,$93,$7D,$27, $A,$4D,$F4,$29,$C2,$93,$7D,$2B,$A4; 8448
		dc.b $EC,$D7,$3B,$1C,$95,$58,$E9,$D8,$E0,$8A,$D6,$38,$22,$B5,$8E,  8,$A0,$E2,$8A, $D,$2C,$72,$28,$34, $E,  9,$BE,$1B,  8,$88,$8B,  8,$57, $A,$57, $A,$57, $A,$55,$9A,$95,$43,$6D,$50,$A4,$E1,$49,$C2,$95,$D3, $F,$E5,$52,$B8,$52,$70,$A4,$E1,$49,$C2,$93,$85,$2B,$A1; 8512
		dc.b $57,$66,$16,$15,$7C,$27,$66,$35,$58,$E0,$8D,$C1,$C1,$14,$59,$8D,$EA,$76,$38,$26,$73,$16,$62,$92,$5B,$6C,$C6,$F5,$B5,$C1,$33,$98,$E4,$B6,$84,$19,$CC,$5E,$1D,$68,$46,$75,$C2,$F1,$8D,$C1,$19,$DC,$6D,$B2,  3,$F5,$BA,$AF,$53,$17,$8C,$E6,$11,$9C, $C,$20,$C6,$E3; 8576
		dc.b   8,$1D,$C6,$2F, $E,$BA,$6E,$BA,$AC,$6E,$9B,$85,$D3,$77,$1C,$EE,$67,$E0,$F2,$12,$C2,$55,$43,  8,$4F,$F5,$BF,$AE,$E3,$17,$8C,$78,$D1,$9D,$C6,$F6,$C6,$E6,$78,$77,$18,$94,$6E,$8C,$8A,$70,$C2,  4,$43,$75,$7B,$86,$EA,$B7,$32,$DD,$1D,$C1,$41,$EA,$8E,$E0,$69,$3B; 8640
		dc.b $91,$BF,$91,$FA,$62,$C2,$15,$C2,$93,$85,$27, $A,$4E,$14,$9C,$29,$5C,$3F,$95,$84,$2B,$85,$27, $A,$4E,$14,$AB,$35,$2A,$86,$DA,$A1,$4A,$D7,$F7,$3A,$AF,$29,$99,$36,$47,$17,$DC,$58,$3E,$E1,$91,$D4,$F7,$26,$BF,$E5,$91,  3,$22,$32,$3A,$A9,$1F,$D8,$E9,$F9,$BF,$E5; 8704
		dc.b $64,$17,$65,$4B,$FA,$47,$B3,$E5,$19,$29,$60,$A6,$B0,$8B,$8E,$3D,$C7,$D8,$1D,$FA,$AD,$D6,$88,$6D,$AF,$35,$DE,$15,$3F,$A8,$8C,$B8,$AA,$FD,$D7,$F4,$6E,$DD,$C4,$51,$32,$AE,$E7,$C4,$F5,$95,$CF,$AD,$F5,$1D,$59,$99,$32,$10, $E,$54,$68,  7, $C,$C1,$C1,$C3,$AA,$47; 8768
		dc.b   1,$D5,$2E,$2E,$A9,$1A,$9A,  8,$48,$D4,$D1,$9D,$9C,$D1,$DD,$1B,$B5,$EE,$D6,$AF,$AE,$47,$3C,$91,$F5,$68,$A1,$23,$A3,$2C,$74,  9,$8C,$86,$81,$1C,$1E,$7A,  4,$73,$3C,$49,$1D,$37,$2E, $E,$86, $E,$84,$5E,$70, $E,$80,$78,$48,  7,$41,$E0,$DC,$1D,  7,$83,$67,$41; 8832
		dc.b $E0,$C6,$78,$3C,$18,$57,$87,$83, $A,$F7,$3C,$18,$57,$B9,$8C,$2B,$DC,$C6,$15,$EE,$A9,$5E,$EA,$95,$EE,$9B,$DD,$5B,$A7, $D,$73,$85,$27, $A,$4E,$14,$9C,$28,$53,$85,$27, $A,$57,$4A,$B8,$6B,$AA,$CC,$52,$36,$38,$22,$B5,$8E,  8,$AD,$63,$82,$28,$3B,$1C,$11,$41,$C5; 8896
		dc.b $14,$18,$47,$22,$83,  8,$11,$41,$84, $E,$50,$61,  3,$AE,  6,$10,$3A,$E0,$61,  3,$AE,$8A,  7,$5D,$14, $E,$B9,$E2,$4C,$EB,$83,$C4,$83,$AE,$AE,$5F,$E8,$22,$22,$C2,$13,$CD,$4A,$A1,$B6,$70,$D7,$B6,$70,$DB,$1C,$D4,$AA,$1B,$6A,$85,$27, $A,$57,$42,$AE,$CE,$CD,$B1; 8960
		dc.b $B3,$36,$DA,$B6,$91,$4E,$CA,$EC,$75,$5C,$1D,$1E,$18,$DE,$DC,$35,$B8,$D2,$AB,$31,$46,$E0,$E0,$8A,$2C,$C6,$F5,$3B,$1C,$13,$39,$87,$5E,$B6,$8B,$F3,$98,$BD,$CB,$68,$4C,$6E,$D5,$E1,$77,$5B,$B0,$B2,$BB,$1D,$57,  7,$55,$66,$37,$B5,$8E,  9,$9F,$83,$82,$2D,$B8,$DE; 9024
		dc.b $A6,$11,$C1,  2,$98,$47,  4,$CE,$61,  2,$2D,$A1,$1C,$8A,$62,$F7,$5C,$A6,$13,$1B,$81,$84,$77,$1C,$51,$D7,$54,$8E,$BA,$6F,$5E,$3F,$CE,$EA,$B9,$16,$D0,$8E,$B9,$4C,$5E,$EB,$81,$84,$C6,$E1,$2B,$DD,$C6,$D2,$C6,$E0,$F8,$F1,$B3,$C4,$30,$80,$CB,$F5,$7A,$F2,$FC,$DA; 9088
		dc.b $B9,$A4,$E1,$8C,$1C,$20,$1D,  6,$83,$83,$A0,$F8,$C1,$D0,$7C,$E0,$F0,$75,$3C,$1D,$4F,  6,$16,  1,$E0,$C2,$BE, $F,  6,$15,$EE,$78,$30,$AF,$73,$18,$57,$B9,$8C,$2B,$DD,$52,$BD,$D5,$2B,$DD,$37,$BA,$B7,$11,$11,$14,$FF,$EB,$FF,$F6,$FF,$D1,$57,$99,$BF,$6B,$B7,$37; 9152
		dc.b $EF,$DB,$69,$15,$7F,$DA,$DA,$DF,$B5,$DB,$9B,$F7,$ED,$B4,$88,$AA,$E1,$1E,$DC,$7F,$55,$DC,$44,$44,$42,$15,$75,$50,$75,$78,$37,$57,$EE,$8A,$BC,$D5,$66,$DA,$3A,$B6,$B4,$3C,$2A,$A1,$11,$55,$DB,$1E,$1D,$DD,$B8,$F2,$EE,$BF,$A7,$96,$7E,$2E,$9B,$45,$FC,$5C,$B1,$EA; 9216
		dc.b $BE,$EE,$B1,$9B,$6C,$61,$B6,$74,$22,$9F, $A,$B8,$62,$DC,$31,  9,$C3,$11,$7A,$E3,$CB,$39,$DF,$D3,$68,$CF,$C5,$CA,$D1,$7F,$70,$BF,$1F,$D6,$26,$3C,$71,$77,$1C,$DF,$BA,$EF,$E7,$13,$1F,$EC,$C8,$A2,$60,$C1,$A3,$7F,  6,$3F,$C1,$63,$94,$15,$E0,$F1,  9,$9E,$D1,$7A; 9280
		dc.b $DA,$2F,$CE,$62,$F7,$2D,$B7,$E3,$71,$84,$C7,$8C,$5E,$EE,$38,$E3,$74,$ED,$EB,$BA,$A4,$C6,$E1,  0,$8E,$E3,$68,  7,$5D,$5D,$C2,$58,$48,$3F,  7,$94,$78,$FB,$3F,$37,$76,$B0,$F0,$61,$5E,$E7,$83, $A,$F5,$63, $A,$F7,$18,$30,$BB,  1,$B2,$BD,$CC,$61,$76,$44,$C3,$DD; 9344
		dc.b $51,$87,$C9,$EE,$54, $E, $F,  6,$15,$E6,$F0,$61,$5E,$6C,$61,$5E,$E6,$30,$AF,$3A,$95,$EE,$A9,$5E,$73,$7B,$96,$6F,$90,$92,$C3,$67,$F0,$47,$37,$FC,$BF,$F9,$2C,$25,$18,$61,  9,$FF,$C8,$8B, $F,$FC,$7F,$CB,$9B,$FE,$FC,$FC,$DF,$F2,$FF,$E4,$DF,$39,  7,$CE,$45,$3F; 9408
		dc.b $F1,$6B,$6F,$E4,$3B,$87,$F0,$93,$11,$FB,$35,$E5,$FB,$73,$E9,$FD,$8A,$71,$7E,$CD,$DC,$BF,$65,$77,$F9,$37,$77,$7E,$CD,$79,$7E,$DC,$FA,$7F,$62,$9C,$5F,$B3,$77,$2F,$D9,$5D,$DD,$FB,$C1,$FA,$C9,$E9,$D7,$FA,$C6,$4C,$7F,$58,$CE,$E3,$9D,$C4,$44,$58,$6B,$DD,$FC,$CD; 9472
		dc.b   8,$8A,$2A,$14,$3D,$BF,$8E,$F6,$FE,$3B,$D9,$42,$85,$65,$6B,$7A,$5E,$A0,$C3,$D9,$CF,$50,$61,$ED,$B1,$41,$D4,$E7,$A8,$3A,$B6,$2D,$6E,$7A,$D7,$B3,$7B,$DC,$A8,$D0,$78,$30,$AF,$73,$C1,$85,$79,$B1,$85,$7B,$98,$C2,$BC,$C2,$B2,$BD,$CC,$A1,$5E,$71,$50,$F7,$54,$A1; 9536
		dc.b $24,$6E,  8,$AE,$83,$C1,$85,$7B,$9E, $C,$2B,$E4,$C6,$15,$EE,$40,$61,$5F,$20,$8C,$AF,$73,$20,$57,$CA,$28,$1E,$E4,$8A,  9,$3D,$1E,$1E,$8F,$1F,$E3,$8A,$61,$2C,$16,$A9,$67,$B7,$A6,$D1,$9C,$7E,$C4,$5A,$2D,$FF,$A7,$31,$7F,$DD,$BF,$7B,$57,$EF,$5B,$9F,$9F,$FE,$9C; 9600
		dc.b $C4,$45,$CF,$FF,$7E,$77,$3D,$CF,$71,$B9,$6B,$85,$26,$FA,$4E,$14,$99,$D2,$A5,$85,$26,$FA,$4E,$14,$AE,$14,$D7,$AB,$5E,$AD,$74,  7,$54,$28, $E,$27,$46,$36,$85,$22,$60,$E9,$51,$C2,$93,$3A,$4E,$14,$AE,$95,$D9,$5D,$8E,$9D,$8E,$4A,$AC,$72,$2C,$6C,$72,$2C,$6C,$72; 9664
		dc.b $28,$31,$63,$91,$41,$A5,$8E,$45,  6,$81,$CF,$47,$49,$1E,$81,$22,$90,$A0,$4A,$A8,$C8,$D0,$A4,$50,$25,$2A,$48,$52,$BA,$4E,$14,$AD,$FA,$B5,$EA,$D7,$AB,$5D,$2B,$85,$26,$74,$9C,$29,$33,$A4,$E1,$49,$9D,$26,$FA,$56,$BA,$BA,$38,$75,$9B,$D4,$18,$7B,$39,$EA, $C,$3D; 9728
		dc.b $8D,$EA, $E,$A7,$3D,$41,$D4,$6F,$5A,$DC,$F5,$AC,$DE,$72,  8,$6E,$57,$9B,$D4,$18,$78,$57,$3D,$41,$87,$B1,$BD,$41,$83, $F,$73,$D4,$5A, $C,$39,$EA, $C,$18,$83,$9E,$AC,$91,$3D,$82,  1,$EC,$E2,$18,$9B,$8D,$C6,$12,$69,$82,$11,  4,$AD,$5D,  3,$81,$CB,$3C,$D5,$31; 9792
		dc.b $59,  8,$4A,$F0,$6F,$53,$77,$28,$A8,$3B,$C1,$85,  7,$78,$30,$A0,$C2,  3, $A,$D9,$E4,$90,$93,$A4,$8A,$91,$40,$92,$12,$72,$29,$A3,$8D,$5E,$61, $C,$2C,$6F,$30,$A0,$C5,$E6,$16,$D1,$7B,$2D,$A1,  1,$C8,$20,$71,$B8,$A4,$70,$37,$5A,$12,$68,$10,$88,$A6,$83,$FB,$3A; 9856
		dc.b $DF,$5E,$95,$E8,$12,$AD,  2,$3A,$3A,  4,$74,$74,  8,$E8,$E8,$11,$D1,$D0,$23,$A6,$9A,$BF,$98,$72,$AD,$E9,$95,$5A,$20,$5D,$1B,$4A,  5,$6F,$CE,$D0,$4B,$14,$14,$63,$78,$4A,$54,$F3,$A5,$4F, $F,$CB,$87,$5B,$9E,$A0,$C3,$CC,$39,$EA, $D,$68,$CE,$7A,$BE,$95,$38,$E9; 9920
		dc.b $56,$6A,$55, $D,$B5,$42,$98,$52,$BD,$A5,$3B,$2B,$B0,$E7,$64,$8E,$AB, $E,  7,$1B,$1E,$E0,$A3,$80,$7B,$94,$F5,$3D,$8D,$94,$3C,$18,$57,$B9,$E0,$C2,$BD,$CC,$61,$5E,$E6,$30,$AF,$75,$4A,$FB,$33,$32,$BE,$C1,$B6,  1,$F6,$55,$48,$3B,$2E,$BA,$71,$84,$50,$68,$13,$45; 9984
		dc.b   6,$81,$34,$63,$40,$9A,$31,$A0,$4D,$D1,$40,$9A,$3D,$A4,$13,$4A,$A4,$9A,$46, $C,$B6,$6B,$B3,$76,$9B,$AC,$A8,$F0,$3C, $F,  3,$C0,$F0,$3C, $E,$26, $C,$18,$5C,$17,  5,$C1,$70,$5C,$17,  5,$C1,$41,$C8,$20,$93,$E0,$E7,$8C,$E6,$10,$1A,$DA,$11,$C8,$A6,$2F,$75,$CA; 10048
		dc.b $61,$31,$B8,$18,$47,$71,$C5,$1D,$75,$48,$EB,$A6,$F5,$E3,$FC,$EE,$AB,$91,$6D,  8,$EB,$94,$C5,$EE,$B8,$18,$4C,$6E,$6B,$DD,$C7,$1C,$6E,$9F,$19,$57,$C7,$D9,$F9,$BB,$B5,$87,$83, $A,$F9,$3C,$18,$5D,$8E,  6,$17,$63,$18,$5D,$95,$2E,$CA,$95,$E1,$F5,$3E,$D0,$F8,$BD; 10112
		dc.b $4C,$1A,$87,$87,$83, $A,$FD,$6F,  6,$15,$FA,$D8,$C2,$BF,$5B,$18,$57,$EB,$A9,$5F,$AE,$A5,$7E,$B9,$BF,$5D,$69,$77,$67,$E6,$EE,$D7,  7,$83, $A,$F7,$3C,$18,$57,$9B,$18,$57,$E7,$43, $A,$F9,  3,$50,$AF,$D6,$E4,  6,$AF,$D6,$2E,$72,  7,$EB,$8D,$CE,$4B,$3F,$85,$AA; 10176
		dc.b $55,$D8,$E9,$D8,$E4,$AA,$C7,$22,$C6,$C7,$22,$C6,$C7,$22,$83,$E0,$E4,$5B,$53,$14,$53,  8,$24,$1F,$21,  4,$7B,$1C,$4E,$27,$13,$89,$C4,$E2,$71,$38,$9C,$4E,$27,$13,$89,$C4,$E2,$A1,$E1,$5C,$44,$44,$44,$50,$37,$1B,$8D,$C8,$21,$FD,$20,$F5,$C3,$F4,$D9,$DF,$13,$96; 10240
		dc.b $69,$45,$46,$A1,$A4,$FA,$F4,$9E,$9A,$AE,$9E,$9A,$AE,$9F,$5E,$93,$D4,$34,$AA,$5D,$51,$7D,$DF,$AD,$67,$E9,$FB,$10,$F4,$FE,$78,$87,$F5,$BF,$E5,$FF,$7E,$7E,$62,$E6,$FE, $B,$53,$F5,$96,$ED,$1F,$AD,$6F,$FF,$F8,$11,$11,$7F,$E3,$FC,$4B,$FE,$37,$FF,$DF,$9F,$F6,$71; 10304
		dc.b $A3,$5F,$E0,$2F,$DB,$56,$D2,$AF,$F7,$3E,  1,$7F,$4D,$E0, $F,$C2,$AA,$11,$15,$5D,$AD,$DB,$FA,$AD,$BD,$3F,$AD,$FF,$F9,$11,$57,$B7,$87,$F7,$F3,$FE,$FE,$AF,$FF,$FF,$7C,$AB,$DA,$DF,$FF,$FD,$FB,$6D,$22,$22,$29,$D9,$1F,$DC,$4B,$B7,$F6,$F0,$FD,$31,$FE,$9B,$FE,$E7; 10368
		dc.b $FB,$9F,$D7,$53, $B,$23,$FB,$85,$ED,$FD,$A3,$FF,$49,$FB,$55,$EA,$FD,$B9,$F4,$FE,$C5,$38,$BF,$67,$57,$F0,$FF,$FF,$1F,$FF,$FF,$FC,$88,$A7,$FF,$FD,$B5,$FF,$FF,$69,$11,$17,$FE,$3F,$A3,$B2,$BF,$FB,$E7,$E7,$E6,$2F,$F9,$7F,$72,$DF,$EE,$C7,$FF,$E4,$44,$5F,$F8,$FE; 10432
		dc.b $17,$17,$F0,$E3,$FF,$7E,$7E,$62,$FF,$97,$FF,$27,$A7,$5E,$9C,$7B,$AC,$D1,  2,$18,$54,$1A,$20,$43, $A,$DA,$20,$43,$AB,$72,  4,$39,$33,$F4,$40,$92,$AB,$4B,$DA,$1F,$AD,$DB,$AD,$CB,$E0,$CE,$B2,$B4,$75,$93,$54,$75,$8D,$B4,$2A,$2F,$EF,$ED,$7F,$84,$76,$CE,$98,$53; 10496
		dc.b $F7,$5F,$BF,$80,$CD,$E0,$D0,$DB,$1F,  9,$D0,$8A,$AE,$D8,$FE,$E1,$7F,$57,$7F,$E6,$E5,$CE,$98,$7E,$CD,$FC,$A1,$17,$E0,$91,$4D,$90,$7E,$67,$AE,$F5,$96,$79,$17,$39,$73,$11,$6C,$83,$FF,$6B,$BD,$65,$FB,$7F,$FC,$B3,$F0,$7D,$70,$C2,  2,$4C,$FA,$A4,$CF,$C3,$F3,$B5; 10560
		dc.b $7E,$77,$6F,$EF,$AF,$E3,$FF,$94,$1E,$B5,$1C,$1E,$B1,$3A,$41,$EA,$C7,$41,  7,$AD,$B4,$6D,$87,$B6,$39,$E9,$3B,$EE,$A5,$4E,$BE,$95,$1E,$D9,$D0,$AB,$B2,$BB,$1F,$57,  0,$F8,$D9,$FB,$1E,$ED,$7F,$BB,$9C,$86,$93,$CB,$4A,$33,$FF,$3B,$B5,$B4,$DD,$B6,$3A,$6D,$9D, $B; 10624
		dc.b   7,$6D,$9E,$9B,$67,$42,$29,$F0,$AB,$87,$63,$70,$EC,$1B,$B8,$76, $F,$CD,$AF, $E,$EC,$8D,$F3,$B3,$64,$78,$3C,$28,$E1,$B3,$A6,$CD,$9F,$B7,$37,$8E,$9B,$47,$4D,$A2,$FC,$E6,$2F,$6C,$51,$F0,$C5,$1D,$9B,$3D,$A9,$D3,$6D,$E1,$6D,$BD,$9C,$61,$1B,$1B,$AF,$18,$F1,$C5; 10688
		dc.b $DC,$62,  3,$1B,$A3,  1,$D7,$FD,$29,$F6,$C7,$87,$EA,$87, $E,$C1,$F9,$BB,$3B,$3F,$57,$9F,$5F,$E6,$FA,$6D,$DD,$9F,$8A,$F5,$B4,$5E,$D0,$FD,$27,$ED,$C8,$88,$88,$8A,$12,$64,$C6,  0,$E4,$C6,$15,$8E,$48, $C,$3D,$8E,$48, $C,$3D,$8E,$57,$98,$7B,$1C,$98,$C3,$ED,$12; 10752
		dc.b $D9,$9F,$F7,$E1,$3F,$3B,$FB,$23,$95,$6F,$4C,$A6,$81,$74,$8E,$81,$5B,$F5,$B4,$95,$FF,$BF,$1E,  4,$44,$44,$43,$FF, $E, $F,$3F,$D9,$21,$A8,$FD,$9F,$ED,$FF,$73,$FB,$EC,$2C,$8F,$EE,$1F,$DB,$FB,$65,$67,$FF,$1E,$DF,$E3,$9F,$4F,$EC,$53,$8B,$F6,$63,$F5,$BF,$CE,$9F; 10816
		dc.b $EB,$5B,$F5,$BE,$1F,$9D,$F0,$8E,$D2,$22,$8F,$6F,$83,$76,$F8,$11,$14,$78,$47,$B7,$B3,$B6,$9D,$9F,$9B,$D7,$AB,$5E,$AF,$CD,$E7,$73,$DD,$FA,$9E,$BA,$F8,$47,$B7,$60,$E0,$BB,$F3,$D9,$D8,$FC,$D9,$F5,$7E,$6F,$A6,$DA,$67,$E2,$BD,$6D,$E4,$DA,$B3,$F1,$F5,$58,$2C,$E8; 10880
		dc.b $E9,$B7,$2C,$FC,$43,$3D,$BC,$96,$DB,$E2,$77,$B7,$EC,$DA,$FE,$21,$7D,$BF,$AC,$75,$AD,$77,$65,$5B,$2D,  7,$B2,$DC,$EF,$5B,$73,$EC,$B7,$3E,$C9,$74,$EC,$D6,$A1,$36,$76, $D,$10,$76,$42,$3A,$27,$45,$DF,$B9,$91,$7F,$C8,$A2,$F8,$57,  7,$D7,$7C,$79,$AF,$FD,$8D,$FD; 10944
		dc.b $C2,$50,$C5,$9F,$BD,$5A,$50,$DE,$3B,$8C,$7E,$D7,$FE,$F9,$CB,$99,$DF,$D3,$91,$14,$4D,$F8,$2D,$76,$91,$44,$FF,$A5, $C,$70,$74,$30,$CD,$86,$6C,$21,$2C,$37,$E1,$BF,  5,$AE,$F9,$DF,$39,$24,$F7,$CE,$12,$9B,$A1,$3C,$6B,$A4,$51,$D0,$97,$1D,$4B,$6E,$97,  4,$B5,$E0; 11008
		dc.b $F4,$B9,$AD,$63,$D2,$E6,$57,$42,$49,$A5,$19,$D0,$93,$8F,$4D,$41,$D0,$93,$81,$E9,$94, $D,$E6,$D6,$A3,$D9,  1,$E8,$B6,$DF,$A3,$5A,$DA,$5C,$61,$ED,$A5,$C7,$56,$AB,$9D,$28,$D2,$E3,$48,$E5,$71,$B1,$B6,$87,$17,$B3,$A1,$27,$35,$AE,$84,$9C,$35,  3,$AB,$4B,$B1,$8E; 11072
		dc.b $97,$5A,$AD,$A5,$C6,$91,$D2,$E3,$AB,$4B,$8C,$20,$37,$DA,$C8,$77,$F1,$E1,$F9,$D6,$36,$71,$F1,$D4,$F7,$1F,$E7,$66,$87,$75,$2B,$3F,$CE,$85,$30,$80,$EE,$D3,$F6,$6C,$74,$AE, $E,$9E,$69,$E6,$9E,$69,$E6,$9B,$A1,$3C,$6B,$7E,$12,$86,$19,$B0,$CD,$86,$6C,$33,$61,$9B; 11136
		dc.b  $C,$C2,$1F,$C2,$52,$22,$22,$22,$22,$A9,$70,$86, $E,$A8,$FF,$AE,$10,$9D,$FC,$17,$66,$FE,$31,$11,$17,$FD,$CB,$9F,$FF,$64,$44,$44,$45,$4D,$5F,$DF,$22,$22,$22,$22,$22, $E,$FE,$89,  3,$FE,$90,$5F,$E8,$B7,$F5,$C7,$F9,$48,$B9,$CB,$FE,$5C,$FF,$F7,$FE,$BB,$7F,$45; 11200
		dc.b $F0,$FF,$21,$11,$11,$35,$F8,$E6,$70,$CF,$B3,$89,$3F,$C8,$44,$64,$58,$3A,$B5,$22,$22,$22,$27,$56,$A4,$A4,$44,$44,$5F,$E5,$FF,$BF,$FC,$B9,$B9,$FF,$EE,$5C,$FF,$D1,$7A,$7F,$5C,$C7,$F4,$90,$7F,$4D,$BF,$A2,$83,$FA,$E6,$43,$FA,$2A,$3F,$A6,$44,$44,$44,$4D,$FD,$21; 11264
		dc.b $FF,$27,$11,$11,$11,$7F, $B,$AB,$F8,$3D,$24,$44,$44,$4F,$E9,$97,$52,$F1,$7E,$CC,$88,$88,$89,$F0,$38,$47,$FA,$82,$43,$FA,$8D,$FC,$48,$FE,$D2,$AF,$D2,$4F,$7C,$F7,$CE,$55,$DD,$C2,$AB,$AB,$95,$72,$AE,$55,$CA,$BB,$AB,$BA,$BB,$9B,$90,$CA,$18,$F2,$3C,$F8,$91,$11; 11328
		dc.b $11,$75,$49,$B3,$11,$11,$11,$17,$EB,$61,$8E,$68,$CA,$BB,$AB,$BA,$BB,$8A,$A9,$57,$2A,$E5,$57,$14,$36,$43,  8,$56,$EA,$DD,$59,$D6,$75,$9C,$E0,$73,$80,$FE,$A8,$30,$60,$DB,$88,$39,$AD,$73,$27,$EC,$6F,$67,  7, $B,$C7,$EC,$C2, $F,$E1,$8E,$64,$70,$70,$70,$70,$E7; 11392
		dc.b $E7,$70,$FE,$8A,  3,$70,$B5,$C8,$6E,$BC,$3A,$F7,$73,$7F,$4C,$73,  4,$1C,$82, $B,$19,$2C,$1D,$AD,$C1,$AC,$1C,  7,  1,$C0,$8A,$7B,$AC,$DD,$66,$EB,$37,$58,$81,$2C,$40,$84,$38,$35,$8D,$63,$70,$1C,$2A,$B0,$8A,$AD,$7B,$B5,$EE,$D7,$BB,$5E,$E3,$1F,$E1,$4F,$F0,$A7; 11456
		dc.b $10,$36,$4B,$42,$32,$62,$11,$C8,$11,$D7,$E3,$FD,$37,$72,$70,$70,$43,$4F,$E0,$A7,$10,$E2,$4E,$24,$37,$18,$34,$3C,$50,$C1,$A1,$BA,$F0,$86,$87,$CD,$CD,$CD,$CC,$10,$20,$4B,$12,$C1,$64,$EC,$1C,  7,  1,$DA,$2C,$1C,  8,$B8,$6E,$B3,$75,$9B,$AC,$64,$B1,  5,$F6,$35; 11520
		dc.b $82,$C0,$8D,$C0,$58,$DC,$2A,$ED,$8F,  2,$26,$D5,$FE,$D4,$22,$22,$22,$2A,$D7,  5,$22,$22,$22,$2C,$10,$88,$88,$B0,$4F,$FB,$F3,$F3, $E,$62,$1F,$E1,$22,$22,$22,$22,$4F,$E8,$84,$FE,$88,$39,$C3,$FC,$2B,$FE,$31,$FE,$32,$1F,$E1,$42,$2F,$F2,$C8,$75,$B7,$5B,$75,$B7; 11584
		dc.b $5B,$23,$B3,$3A,$A3,$50,$64,$44,$D0,$D8,$A1,$F0,$91,$11,$11,$7F,$85,$3F,$C2,$90,$D8,$A1,$F0,$91,$11,$31,$A8,$38,$A3,$B3,$3A,$3A,$AA,$D4,$40,$E9,$FB,$1A,$19,$17,$31,$7F,$DC,$B9,$FF,$AA,$F9,$11,$7F,$4D,$48,$7F,$5C,$C8,$7F,$45,$BF,$8F,$B1,$C4,$44,$44,$44,$7F; 11648
		dc.b $A6,$5F,$D3,$11,$11,$11,$13,$ED,$1B,$37,$91,$11,$11,$17,$4B,$ED,$BC,$88,$88,$88,$89,$AC,$16, $B,  8,$A3,$60,$B0,$58,$44,$44,$2C,$16, $B,  8,$A3,$60,$B0,$58,$44,$44,$51,$E7,$FF,$BF,$39,$7F,$DC,$B9,$87,$F5,$9B,$FA,$CD,$FD,$66,$FE,$B3,$7F,$59,$BF,$AC,$DF,$D6; 11712
		dc.b $10,$77,$F0,$E0,$44,$4C,$A5,$83,$BF,$AB,$21,$AA,$9B,  3,$9B,$55,$36,$38,$B1,$AB,$12,$18,$B6,$25,$1F,$D9,$13,$75,$67,$CD,$22,$22,$9A,$93,$7F,$15,$CC,$F1,$B0,$52,$12,$48,$5F, $D,$79,$BF,$EE,$44,$45,$FF,$21,$A7,$46,$9D,  1,$D4,$FC,$DD,$3F,$36,$E2,$75,$3F,$37; 11776
		dc.b $4F,$CD,$E3,$4F,$CD,$D3,$F3,$6E,$20,$A1,$42,$8F,$FB,$A9,$A9,$A9,$A9,$AC,$A1,$28,$4A,$12,$87,$F0,$F3,$10,$FE,$1E,$62,$1F,$C3,$CC,$43,$F8,$79,$89,$BF,$67,$98,$9B,$F6,$79,$89,$91,$D7,$BA, $C,$6A,$F3,$CE,$20,$B6,$A8,$7C,$AD,$6B,$5B,$9C,$88,$BF,$EF,$FF,$21,$B2; 11840
		dc.b $8F,$A3,$C4,$B1,$DC,$ED,$CE,$97,$39,$11,$7F,$DF,$FE,$5A,$9F,$A9,$E3,$21,$96,$E4,$DC,$90,$BA,$17,$14,$2F,$D7, $D,$7D,$57,$EB,$86,$BC,$C4,$44,$44,$57,$41,$21,$7F,$EB,$20,$90,$BF,$8C,$88,$8B,$9F,$9C,$88,$BF,$EF,$FF,$21,$B0,$53,$F5,$30,$BE,$1A,$FF,$59,$FF,$5F; 11904
		dc.b $FA,$FF,$D7,$FE,$BF,$F5,$FF,$AF,$FD,$7F,$CB,$2F,$F2,$CB,$FC,$B2,$FF,$2C,$BF,$CB,$2F,$F2,$CB,$FC,$B2,$FF,$2C,$BF,$E4,$44,$45,$FF,$21,$C3,$A0,$74,$43,$F3,$BC,$70,$E3, $A,$44,$45,$5C,$1D,$FD,$50,$F6,$FD,$B4,$13,$7F,$EC,$85,$AD,$C8,$88,$8A,$12,$86,$FE,$90,$F1; 11968
		dc.b $FC,$69,$3A,$5F,$C1,$4B,$7A,$B7,$91,$11,$2E,$6E,$EB,$C3,$C7,$ED,$82,$9C,$BF,$67,  7,$40,$C8,$88,$88,$8A,$B7,$8B,$7B,$88,$88,$88,$89,$C6,$36,$43,$79,$11,$11,$11,$40,$28,$51,$69,$11,$11,$12,$9E,$73,$E9,  6,$C6,$C6,$44,$44,$45,$FE,$14,$95,$D2,$BA,$57,$49,$46; 12032
		dc.b $A0,$73,$D4,$32,$16,$46,$C1,$60,$B2,$2F,$16,$4D,$E2,$C1,$64,$5E, $C,$6A,$8B,$F0,$B0,$64,$2C,$89,$87,$CE,$84,$1E,$1F,$17,$8B,  5,$91,$7C,$6C,$8D,$80,$C3,$E3,$AA,$34,$6E,$ED,$CE,$DD,$89,$11,$12,$85, $A,$14,$7F,$DD,$4D,$4D,$4D,$4C,$18,$30,$60,$C8,$88,$8C,$18; 12096
		dc.b $30,$63,$9F,$9C,$C1,$83,$16,$91,$11,$18,$B4,$1B,$7F,$84,$7F,$84,$18,$B4,$19,$11,$13,$18,$B4,$1B,$7F,$84,$71,$54,$70,$94,$25,  9,$42,$58,$5D,$5D,$D5,$DD,$5B,$AB,$D2,$BD,  8,$88,$AA,$85,$70,$29,$D8,$D0,$AF,$33,$28,$41,  3,$6D,$7A,$65,$76,$56, $F,$EE,$B7,$F5; 12160
		dc.b $DB,$FA,$6D,$FD,$96,$FE,$EB,$7F,$5D,$BF,$A6,$DF,$D9,$22,$22,$6F,$EE,$B7,$F5,$DB,$FA,$62,$EF,$EA,$DC,$25,$FA,$BD,$ED,$41,$D1,$B6,$39,$37,$43,$6E,$FE,$13,$4B,$F5,$7B,$DA,$83,$A3,$6C,$72,$6E,$80,$B7,$7F,$15,$5B,$19,$BB,$AD,$D1,$76,$AE,$8D,$4E,$26,$76,$AE,$8D; 12224
		dc.b $4E,$8B,$BA,$DC,$1D,$1C,$43,$B5,$3A,$A7, $B,$9D,$17,$75,$BA,$BC,$A6,$ED,$4A,$E6,$C4,$62,$CE,$5D,$4E,$1D,$C3,$26,$77,$EB,$9D,$D6,$E6,$C8,$6E,$C8,$3E,$5B,$96,$99,  4,$1A,$DA,$48,$16,$39,$99,$46,$A1,$23,$D7,$1D,$C2,$DB,$23,$AD,$A0,$61,$63,$99,  4,$A3,  0,$BA; 12288
		dc.b $48,$40,$F7,$8F,$EB,$B7,$27,$68,$E6,$EB,$3A, $A,$37,$64,$3F,$54,$DF,$D7,$6E,$4E,$D1,$CD,$D6,$74,$14,$1A,$2E,$AC,$DB,$B5,$43,$20,$83,$73,$49,  2,$84,$19,$99,$43,$84, $F,$5C,$75,$83,$A6,$41,$23,$4D,$C8,$25,$1D,$D0,$65,$8C,  2,$E8,$A2,$87,$BC,$88,$87,$F5,$DB; 12352
		dc.b $93,$B4,$73,$75,$9D,  5,$1B,$B2,$1F,$AA,$26,$FE,$BB,$72,$76,$8E,$6E,$B3,$A0,$A3,$76,$43,$F5,$44,$44,$3F,$3A,$D4,$E2,$22,$C2,$15,$E6,$9E,$69,$EE,$80,$84,$57,$70,$CC,$DA,$6B,$75,$D9,$5C,$59,$2D,$9D,$39,$2E,$4B,$67,$4E,$4A,$5D,$1A,$B2,$5C,$97,$F5,$3A,$B2,$5C; 12416
		dc.b $97,$22,$6D,$7A,$3B,$2E,$31,$B9,$46,$E8,$37,$E6,$C2,$EE,$8E,$E1,$9E,$30,$1B,$96,$39,$BF,$37,$1C,$C3,$74,$77,$40,$42,$2B,$B8,$66,$6D,$35,$BA,$EC,$AE,$2C,$B8,$74,$70,$E8,$E1,$D1,$C3,$22,$E8,$B1,$75,$64,$BF,$A9,$B1,$75,$64,$B9,$11,$17, $F,$D4,$D9,$97,$6F,$EA; 12480
		dc.b $6C,$CA,$C2,$E8,$FD,$C7,$EE,$7F,$71,$D0,$44,$5D,$16,$65,$DB,$FA,$9B,$32,$ED,$C8,$97,$A1,$72,$5D,$59,$FA,$17,$25,$D4,$A4,$44,$B6,$67,$E8,$B3,$25,$B3,$3F,$45,$99,$16,$56,$65,$DB,$FA,$9B,$32,$ED,$E8,$22,$25,$D4,$B9,$2F,$46,$7D,$4B,$92,$F4,$29,$65,$FB,$8C,$AC; 12544
		dc.b $E8,$FD,$C6,$56,$64,$4D,$AF,$47,$65,$C6,$37,$28,$DD,  6,$FC,$D8,$5D,$D1,$DC,$33,$CF,$72,$CF,$F3,$75,$EE,$2C,$31,$DA,$3F,$5C,$5F,$BA,$CD,$BB,$F9,$59,$B7,$6B,$2D,$DD,$90,$D7,$BB,$5F,$E6,$FB,$21,$AF,$76,$BD,$C5,$8E,$EA, $D,$5B,$B5,$E4,$10,$6E,$69,$20,$50,$63; 12608
		dc.b $35,$54,$10,$1A,$E3,  8,$D9,$18,$34, $E,$79,$90,$48,$50,$40,$6B,$19,$69,$65,$DD,  3,$FB,$AD,$FD,$76,$FE,$9B,$7F,$64,$88,$A3,$AF,$47,$5D,$67,$44,$6C,  7,  7,  5,  8,$33,$32,$84,$8E,$E8,$D8,$C9,$AE,$3A,$D9,$EC,$A1,$D1,$4C,$37,$3B,$6D,$9F,$AE,$1D,$BD,$96,$32; 12672
		dc.b $68,$E0,$F7,$36,$AC,$9F,$4C,$9E,$D0,$E3,$CD,$73,$76,$F6,$58,$C9,$A3,$83,$DC,$DA,$B2,$7D,$32,$7B,$43,$8F,$35,$C4,$44,$4D,$DB,$D9,$63,$26,$8E, $F,$73,$6A,$C9,$F4,$C9,$ED, $E,$3C,$D7,$37,$6F,$65,$8C,$9A,$38,$3D,$CD,$AB,$27,$D3,$27,$B4,$38,$F3,$5C,$44,$43,$FF; 12736
		dc.b $E3,$FA,$ED,$C9,$DA,$39,$BA,$CE,$82,$8D,$D9, $F,$D5,$37,$4E,$65,$64,$D1,$C1,$EE,$6D,$59,$3E,$99,$3D,$B5,$DF,$D8,$84,$44,$4D,$FD,$76,$E4,$ED,$1C,$DD,$67,$41,$41,$A6,$7B,$3A,$74,$22,$22,$22,$CA,$CC,$BF,$71,$D1,$64,$A1,$AF,$7E,$19,$A7,$9A,$7B,$A0,$21,$15,$DC; 12800
		dc.b $33,$36,$71,$99,$B7,$28,$DD,  1, $F,$CD,$85,$DC,$33,$6E,$1A,$6B,$75,$D9,$5C,$44,$44,$45,$95,$9D,$1D,$BD,$16,$74,$76,$E4,$44,$44,$45,$9F,$56,$7E,$DC,$D7,$66,$FD,$51,$6B,$DD,$AE,$1A,$FF,$37, $D,$7B,$B5,$C3,$5F,$E6,$E0,$5B,$B5,$EE,$87,$67,$EA,$F5,$EE,$87,$67; 12864
		dc.b $E6,$CB,$FF,$C4,$44,$44,$45,$FF,$E1,$FD,$86,$E4,$ED,$1C,$DD,$67,$41,$46,$CD,$AF,$A9,$BB,$7B,$2C,$64,$D1,$C1,$EE,$6D,$59,$3E,$99,$3C,$6A,$DD,$8F,$E6,$DD,$A8,$88,$88,$4B,$F5,$7B,$DA,$83,$A3,$6C,$72,$6E,$86,$DD,$FC,$26,$97,$EA,$F7,$B5,  7,$46,$D8,$E4,$DD, $D; 12928
		dc.b $BB,$F8,$44,$44,$38,$ED,$D4,$D0,$AF,$34,$F3,$4F,$74,$26,$BB,$A7,$9E,$7B,$96,$7F,$9B,$AF,$27,$6D,$1F,$AE,$2D,$DA,$E1,$D9,$BB,$B3,$76,$B8,$76,$6E,$EC,$2D,$D9,$BB,$37,$6B,$FC,$DE,$6E,$CD,$DA,$F7,$17,$EF,$C7,$EB,$88,$88,$88,$8B,$F6,$3A,$8A,$3B,$FF,$37,$2C,$DF; 12992
		dc.b $A4,$FC,$DC,$B3,$48,$A1,$BB,$7E,$EF,$DA,$EE,$DF,$BB,$A8,$BF,$EE,$D8,$CD,$DD,$6E,$8B,$B5,$74,$6A,$71,$33,$B5,$74,$6A,$18,$87,$75,$9F,$59,$B3,$8E,$9D,$14,$FD,$34,$35,$DF,$AC,$B7,$EB,$97,$57,$E9,$35,$CB,$AA,$45,$24,$96,$BD,$FD,$92,$49,$6B,$DF,$D8,$44,$5D,$9B; 13056
		dc.b $F5,$C9,$25,$D9,$BF,$5C,$92,$45,$28,$4A,$1A,$E1,$FA,$48,$4A,$1A,$E1,$BC,$88,$A5,  4,$EC,$87,$E9,$20,$9D,$90,$DE,$52,$EA,$96,$BF,$D2,$75,$4B,$5E,$F2,$22,$96,$6F,$D5,$43,$7E,$6F,$D5,$42,$45,$28,$4A,  9,$28,$6F,$84,$A0,$92,$84,$8B,$F8,$D2,$D9,$3D,$53,$75,$D9; 13120
		dc.b $5C,$E8,$BA,$EC,$AE,$70,$C5,$B5,$33,$94,$DC,$D8,$85,  7,$77,$EB,$AD,$A3,$F2,$19, $E, $B,$D6,$BA,$96,$BF,$CE,$CF,$4A,$F4,$AF,$4A,$F4,$AF,$4A,$F4,$C3,$9C,$88,$88,$8B,$FE,$FF,$F6,$22,$29,$EF,$9C,$8F,$54,$A7,$4C,$A7,$2D,$4B,$2D,$35,$E9,$D9,$D1,$AC,$41,$D9,$B1; 13184
		dc.b $B8,$3A,$E8,$3B,$36,$E0,$EB,$A0,$EC,$DB,$87,$53,$B4,$BB,$70,$EA,$76,$97,$38,$88,$3A,$17,$66,$74,  3,$A1,$76,$67,$5C,$2E,$C7,$8E,$17, $B,$B1,$E3,$85,$C1,$D7,$3A,$17,$3A,$58,$DC,$E8,$5C,$ED,  8,$9D,$AD,$DA,$E1,$AF,$11,$AD,$DA,$E1,$AD,$DB,$B5,$3B,$B3,$1D,$13; 13248
		dc.b $53,$BB,$31,$D1,  6,$B8,$3B,$36,$BD,$CE,$D7,  7,$66,$D6,$E2,$27,$41,$D9,$B1,$80,$83,$B3,$63,$70,$75,$D0,$76,$6D,$C1,$D7,$41,$D9,$B7, $E,$A7,$69,$76,$E7,$75,$3B,$4B,$9C,$45,$4F,$EF,$58,$44,$44,$44,$46,$DC,$6C,$F2,$8E,$5A,$CA,$B3,$2C,$2C,$D6,$51,$FD,$33,$7E; 13312
		dc.b $98,$A3,$C2,$BA,$61,$91,$61,$AA,$C2,$8F,$26,$E4,$51,$E1,$5D,$30,$C8,$B0,$D5,$61,$47,$2B,$32,$DB,$95,$99,$47,$44,$22,$A8,$EA,$32,$22,$1F,$AB,$75,$DF,$AB,$28,$F4,$56,$78,$50,$B0,$5C,$8A,$3F,$A9,$C7,$F5,$24,$44,$44,$5F,$FE,$FF,$E0,$FF,$60,$FF,$38,$FF,$58,$FF; 13376
		dc.b $60,$FF,$38,$FF,$59,$7F,$8B,$71,$11,$11,$11, $D,$30,$A6,$14,$6E,$ED,$C3,$41,$FB,$2D,$CC,$E1,$DD,$B8,$7F,$4B,$76,$43,$F9,$23,$70,$FE,$D9,$11,$11,$53, $A,$16,$1A,$FF,$DA, $E,$B5,$79,$D6,$AF,$3A,$D5,$E7,$5A,$BC,$EB,$57,$9D,$6A,$F3,$AD,$70,$37,$CC,$DE,$B5,$1B; 13440
		dc.b $D6,$A3,$7A,$D4,$6F,$5A,$8D,$EB,$51,$BD,$66,  0; 13504
Nem_CPZ_Unknown:dc.b   0,  8,$80,$12,  0,$73,  4,$82,$15,$1A,$87,$13,  2,$88,$13,  3,$89,$13,  5,$8A,$15,$1B,$8B,$15,$1C,$8C,$16,$3E,$8D,$15,$1D,$8E,$14, $C,$75,$1E,$FF,$92,$49,$24,$36,$6C,$A5,$18,$C4,$29,$24,$85,$28,$C7, $A,$51,$8E,$14,$A3,$1C,$29,$46,$38,$52,$8C,$73,$AF,$AF; 0
					; DATA XREF: ROM:0001C128o
		dc.b $AF,$AF,$FF,$BD,$7D,$7A,$5A,$5F,$F2,$D3,$D3,$D2,$D2,$FF,$E7,$CB,$E5,$F2,$F9,$7F,$F3,$8B,$8B,$8B,$8B,$FF,$7C,$5C,$5B,$CD,$E7,$FE,$B6,$B6,$AE,$5C,$FF,$CD,$55,$3C,$79,$FF,$85,$8B,$16,$2C,$FF,$BF,$BD,$EF,$78,  0; 64
Map128_CPZ:	dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 0
					; DATA XREF: ROM:0001C004o
					; ROM:0001C014o
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$F02A,$F02C,$F02A,$F02B,$F02B,$F02A,$F02C,$F02A,$F034,$F0DE,$F0DE,$F0DE,$F0DE,$F0DE,$F0DE,$F034,$F03B,$F0D0,  $D1,	 $DC,  $DC, $4D1,$F4D0,$F03B,$F0C2,$F0C3,  $DD,	 $C2,  $C3,  $DD,$F0C2,$F0C3; 64
		dc.w $F02A,$F02B,$F02A,$F02C,$F02A,$F02B,$F02A,$F02C,$F034,$F035,$F035,$F035,$F035,$F034,$F036,$F034,$F03A,$3037,  $38,	 $38,  $39,  $3B,$F023,$F03A,$F03B,$303D,  $3E,	 $3F,  $40,  $3C,$F02D,$F03B,$F041,$3002,    2,	   2,	 2,    2,$F002,$F041,$F03A,$3042,  $43,	 $44,  $44, $443,$F442,$F03A,$F03B,$F045,$F046,$F047,$F047,$F446,$F048,$F03B,$F03C,$F049,$F04A,$F049,$F049,$F04A,$F049,$F03C; 128
		dc.w $F061,$F0C2,$F0C3,$F03C,$F03C,$F0C2,$F0C3,$F061,$F09E,$F03C,$F041,$F045,$F048,$F041,$F03C,$F064,$F0A8,$F05E,  $3A,	 $5F,  $5F,  $3A,$F05E,$F06E,$F09E,$F05E,  $5E,	 $5E,  $5E,  $5E,$F05E,$F064,$F0A8,$F05E,  $5E,	 $5E,  $5E,  $5E,$F05E,$F06E,$F09E,$F05E,  $41,	 $5F,  $5F,  $41,$F05E,$F064,$F0A8,$F03C,$F03A,$F049,$F049,$F03A,$F03C,$F06E,$F061,$F0C2,$F0C3,$F03C,$F03C,$F0C2,$F0C3,$F061; 192
		dc.w $3551,$3550,$354F,$354E,$354D, $400, $400,	$400,$353D,$353C,$3559,$3558,$3557,$3556, $400,	$400, $400, $546, $563,	$562,$3561,$3560,$355F,	$55E, $400, $400, $400,	$56C, $56B,$356A,$3569,$3568,	 0,    0,    0,	   0, $56C, $56B,$356A,$F191,	 0,    0,    0,	   0,	 0, $56C,$C19A,$F19B,	 0,    0,    0,	   0,$C15A,$C16D,$C1A4,$C16F,$C172,$C173,$C174,$C175,$C176,$C177, $16F,	$179; 256
		dc.w	 0,    0,    0,$C14D,$C14E,$C14F,$C150,$C151,	 0,    0,$C156,$C157,$C158,$C159,$C13C,$C13D,$C15E,$C15F,$C160,$C161, $162, $163, $146,	   0,$C168,$C169,$C16A,	$16B, $16C,    0,    0,	   0,$F192, $16A, $16B,	$16C,	 0,    0,    0,	   0,$319C,$319D, $16C,	   0,	 0,    0,    0,	   0,$31A6,$31A7,$356D,$355A,	 0,    0,    0,	   0, $1A5,$356F,$3577,$3576,$3575,$3574,$3573,$3572; 320
		dc.w $C551,$C550,$C54F,$C54E,$C54D, $400, $400,	$400,$C53D,$C53C,$C559,$C558,$C557,$C556, $400,	$400, $400, $546, $563,	$562,$C561,$C560,$C55F,	$55E, $400, $400, $400,	$56C, $56B,$C56A,$C569,$C568,	 0,    0,    0,	   0, $56C, $56B,$C56A,$F195,	 0,    0,    0,	   0,	 0, $56C,$319E,$F19F,	 0,    0,    0,	   0,$315A,$316D,$31A8,$316F,$3172,$3173,$3174,$3175,$3176,$3177, $16F,	$179; 384
		dc.w	 0,    0,    0,$314D,$314E,$314F,$3150,$3151,	 0,    0,$3156,$3157,$3158,$3159,$313C,$313D, $15E,$315F,$3160,$3161, $162, $163, $146,	   0,$3168,$3169,$316A,	$16B, $16C,    0,    0,	   0,$F196, $16A, $16B,	$16C,	 0,    0,    0,	   0,$F1A0,$C1A1, $16C,	   0,	 0,    0,    0,	   0,$F1AA,$C1AB,$C56D,$C55A,	 0,    0,    0,	   0, $1A9,$C56F,$C577,$C576,$C575,$C574,$C573,$C572; 448
		dc.w $3058,$3059,$3058,$3058,$3058,$3058,$305C,$3058,$3062,$3063,$305A,$305B,$305A,$305B,$305D,$3462,  $5E,  $5F,  $5E,	 $5E,  $5E,  $5E,  $5F,	 $5E,  $5E,  $5F,  $5E,	 $5E,  $5E,  $5E,  $5F,	 $5E,  $5E,  $5F,  $5F,	 $5F,  $5F,  $5F,  $5F,	 $5E,  $5E,  $5F,  $5F,	 $5F,  $5F,  $5F,  $5F,	 $5E,  $5E,  $5F,  $5E,	 $5E,  $5E,  $5E,  $5F,	 $5E,  $5E,  $5F,  $5E,	 $5E,  $5E,  $5E,  $5F,	 $5E; 512
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$F02A,$F02B,$F02A,$F02C,$F02C,$F02A,  $2B,$F02A,$F036,$F036,$F036,$F036,$F036,$F036,$F036,$F036; 576
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$F07F,$F002,$F002,$F07F,	 0,    0,    0,	   0,$F0CB,$F036,$F036,$F0CB,	 0,    0,    0,	   0,$F0CB,$F018,$F418,$F0CB,$F02A,$F02B,$F02B,$F02A,$F0CD,$F037,$F039,$F0CD,$F036,$F036,$F036,$F036; 640
		dc.w $F04B,$F04C,$F02A,$F02B,$F02B,$F02A,$F04B,$F04C,$F04D,$F04E,$F036,$F035,$F035,$F036,$F04D,$F04E,$F050,$F051,  $23,	 $4F, $44F, $423,$F050,$F051,$F052,$F053,   $C,	 $20,  $20,   $C,$F453,$F452,$F041,$F002,    2,	   2,	 2,    2,$F002,$F041,$F03A,$F054,  $55,	 $56, $456,  $20,$F057,$F03A,$F03B,$F045,$F046,$F047,$F047,$F446,$F048,$F03B,$F03C,$F049,$F04A,$F049,$F049,$F04A,$F049,$F03C; 704
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$F04B,$F04C,$F02A,$F02B,$F02B,$F02A,$F04B,$F04C,$F04D,$F04E,$F036,$F035,$F035,$F036,$F04D,$F04E; 768
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$F04B,$F04C,$F02A,$F02B,$F02B,$F02A,$F04B,$F04C,$F04D,$F04E,$F036,$F035,$F035,$F036,$F04D,$F04E,$F050,$F051,$F023,$F04F,$F44F,$F423,$F050,$F051,$F052,$F053,$F00C,$F020,$F020,$F00C,$F453,$F452; 832
		dc.w $F07F,$F02B,$F02B,$F07F,	 0,    0,    0,	   0,$F0CB,$F036,$F036,$F0CB,	 0,    0,    0,	   0,$F0CB,$F054,  $55,$F0CD,$F02A,$F02B,$F02A,$F061,$F0CB,$F035,  $35,$F035,$F035,$F035,$F035,$F0CB,$F0CB,$F037,  $38,	 $38,  $38,  $38,$F039,$F0CB,$F0CB,$F042,  $43,	 $44,  $44, $443,$F442,$F0CB,$F0CB,$F018, $418,	 $21,  $21,  $56,$F456,$F0CB,$F0CD,$F0C2,$F0C3,$F0C2,$F0C3,$F0C2,$F0C3,$F0CD; 896
		dc.w $F041,$F082,$F082,$F082,$F082,$F082,$F082,$F041,$F03B,$F037,$F038,$F038,$F038,$F038,$F039,$F03B,$F041,$F05F,$F05F,$F05F,$F05F,$F05F,$F05F,$F041,$F03B,$F049,$F049,$F049,$F049,$F049,$F049,$F03B,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 960
		dc.w $F001,$F002,$F002,$F003,$F004,$F002,$F002,$F005,$F001,$F006,$F006,$F006,$F006,$F006,$F006,$F005,$F00F,$F40F,    9,	   9, $408, $407,  $28,	 $29,$F019,$F419,   $D,	  $E,	$C,   $C,  $32,	 $33,$F411,$F410,  $12,	 $13,  $18, $418,$F016,$F017,$F41B,$F41A,  $1C,	 $1D,  $20,  $20,$F01E,$F01F,  $26,  $27,  $21,	 $21,  $24,  $25,$F010,$F011,  $30,  $31,  $22,	$422,  $2E,  $2F,$F01A,$F01B; 1024
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,$F0DF,	 0,    0,    0,	   0,	 0,    0,    0,$F0E9,	 0,    0,    0,	   0,	 0,    0,$F0F2,$F0F3,	 0,    0,    0,	   0,$F0FA,$F0FB,$F0FC,$F0FD; 1088
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,$F15B,	 0,    0,    0,	   0,	 0,    0,$F164,$F165,	 0,    0,    0,	   0,$F15A,$F16D,$F16E,$F16F,$F172,$F173,$F174,$F175,$F176,$F177,$F16F,	$179; 1152
		dc.w	 0,    0,    0,$F14D,$F14E,$F14F,$F150,$F151,	 0,    0,$F156,$F157,$F158,$F159,$F13C,$F13D,$F15E,$F15F,$F160,$F161,$F162, $163, $146,	$147,$F168,$F169,$F16A,	$16B, $16C,    0,    0,	   0,$F15C,$F16A, $16B,	$16C,	 0,    0,    0,	   0,$F166, $167, $16C,	   0,	 0,    0,    0,	   0, $170, $171,    0,	   0,	 0,    0,    0,	   0, $16C,    0,    0,	   0,	 0,    0,    0,	   0; 1216
		dc.w $C17C,$C17D,$C17E,$C17F,$C180, $181, $182,	$16C, $186, $187, $188,	$189, $18A, $18B,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 1280
		dc.w  $56C, $582, $581,$3580,$357F,$357E,$357D,$357C,	 0,    0, $58B,	$58A, $589, $588, $587,	$586,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 1344
		dc.w $317C,$317D,$317E,$317F, $180, $181, $182,	$16C, $186, $187, $188,	$189, $18A, $18B,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 1408
		dc.w  $56C, $582,$C581,$C580,$C57F,$C57E,$C57D,$C57C,	 0,    0, $58B,	$58A, $589, $588, $587,	$586,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 1472
		dc.w	 0,    0,  $60,$F061,$F02C,$F02A,$F02B,$F02A,	 0,  $60,$3065,$3066,$3067,$F068,$F069,$F06A,  $60,$3065,  $6F,	 $70,$3C71,$FC72,$FC73,$FC74,$3061,  $6F,  $79,$3C7A,$3C7B,    0,    0,	   0,$3041,  $79,$3C83,$3C84,	 0,    0,    0,	   0,$303B,  $8C,$3C8D,	   0,	 0,    0,    0,	   0,$305E,$3096,$3C97,	   0,	 0,    0,    0,	   0,$305E,$30A0,$3CA1,	   0,	 0,    0,    0,	   0; 1536
		dc.w $F02A,$F02B,$F02A,$F02C,$F061, $460,    0,	   0,$F06B,$F06C,$F06D,$C077,$C466,$C465, $460,	   0,$F874,$F873,$F87E,$C876,$C080,$C46F,$C465,	$460,	 0,    0,    0,$C87B,$C87A,$C080,$C46F,$C061,	 0,    0,    0,	   0,$C884,$C88A,$C080,$C041,	 0,    0,    0,	   0,	 0,$C894,$C095,$C03B,	 0,    0,    0,	   0,	 0,$C897,$C09F,$C05E,	 0,    0,    0,	   0,	 0,$C8A1,$C0A9,$C05E; 1600
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$F058,$F059,$F058,$F058,$F058,$F058,$F05C,$F058,$F062,$F063,$F05A,$F05B,$F05A,$F05B,$F05D,$F462,  $5E,  $5F,  $5E,	 $5E,  $5E,  $5E,  $5F,	 $5E,  $5E,  $5F,  $5E,	 $5E,  $5E,  $5E,  $5F,	 $5E; 1664
		dc.w   $5E,  $5E,  $5E,	 $5E,$F07F,$F002,$F002,$F07F,  $5E,  $5E,  $5E,	 $5E,$F0CB,$F036,$F036,$F0CB,$F07F,$F02A,$F02B,$F02A,$F0CD,  $D8,$F4D8,$F0CB,$F0CB,$F0DE,$F0DE,$F0DE,$F0DE,  $DE,$F0DE,$F0CB,$F0CB,$F0D0,  $D1,	 $DC,  $DC, $4D1,$F4D0,$F0CB,$F0CB,$F041,  $18,	$418, $454, $455,$F041,$F0CB,$F0CB,$F03B,  $21,	 $20,  $20,  $21,$F03B,$F0CB,$F0CD,$F03C,$F0C2,$F0C4,$F0C4,$F0C3,$F03C,$F0CD; 1728
		dc.w $F050,$F051,  $23,	 $4F, $44F, $423,$F050,$F051,$F052,$F053,$F00C,$F020,$F020,$F00C,$F453,$F452,$F09E,$F002,$F002,$F002,$F002,$F002,$F002,$F064,$F0A8,$F054,  $55,	 $56, $456,  $20,$F057,$F06E,$F09E,$F0DE,  $DE,	 $DE,  $DE,  $DE,$F0DE,$F064,$F0A8,$F042,  $43,	 $44,  $44, $443,$F442,$F06E,$F09E,$F016,$F017,$F020,$F020,$F417,$F016,$F064,$F0A8,$F03C,$F0C2,$F0C4,$F0C4,$F0C3,$F03C,$F06E; 1792
		dc.w $C058,$C059,$C058,$C058,$C058,$C058,$C05C,$C058,$C062,$C063,$C05A,$C05B,$C05A,$C05B,$C05D,$C462,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 1856
		dc.w $C551,$C550,$C54F,$C54E,$C54D,    0,    0,	   0,$C53D,$C53C,$C559,$C558,$C557,$C556,    0,	   0, $547, $546, $563,	$562,$C561,$C560,$C55F,	$55E,	 0,    0,    0,	$56C, $56B,$C56A,$C569,$C568,	 0,    0,    0,	   0, $56C, $56B,$C56A,$C5A2,	 0,    0,    0,	   0,	 0, $56C, $56B,$C56A,	 0,    0,    0,	   0,	 0,    0, $56C,	$56B,	 0,    0,    0,	   0,	 0,    0,    0,	$56C; 1920
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$C598,    0,    0,	   0,	 0,    0,    0,	   0,$C5A2,$C598,    0,	   0,	 0,    0,    0,	   0,$C56A,$C5A2,$C598,	   0,	 0,    0,    0,	   0, $56B,$C599,$C5A2,$C598,	 0,    0,    0,	   0; 1984
		dc.w $F001,$F002,$F002,$F003,$F004,$F002,$F002,$F005,$F001,$F006,$F006,$F006,$F006,$F006,$F006,$F005,	$A,   $B,    7,	   8,	 9,    9,$F00F,$F40F,  $14,  $15,   $C,	  $C,	$D,   $E,$F019,$F419,$F016,$F017,  $18,	$418,  $12,  $13,$F010,$F011,$F01E,$F01F,  $20,	 $20,  $1C,  $1D,$F01A,$F01B,$F411,$F410,  $24,	 $25,  $21,  $21,  $26,	 $27,$F41B,$F41A,  $2E,	 $2F,  $22, $422,  $30,	 $31; 2048
		dc.w $F02A,$F002,$F002,$F02A,$F07F,$F036,$F036,$F07F,$F034,$F034,$F034,$F034,$F0CB,$F054,$F055,$F0CB,$F03B,$F03B,$F03B,$F03B,$F0CB,$F045,$F048,$F0CB,$F021,$F021,$F021,$F021,$F0CD,$F03D,$F040,$F0CD,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 2112
		dc.w $F17C,$F17D,$F17E,$F17F,$F180,$F181, $182,	$16C, $186, $187, $188,	$189, $18A, $18B,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 2176
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$F551,$F550,$F54F,$F54E,$F54D,    0,    0,	   0,$F53D,$F53C,$F559,$F558,$F557,$F556,    0,	   0, $547, $546, $563,	$562,$F561,$F560,$F55F,	$55E,	 0,    0,    0,	$56C, $56B,$F56A,$F569,$F568; 2240
		dc.w $F02A,$F02B,$F002,$F003,$F004,$F002,$F02B,$F02A,$F061,$F035,$F035,$F035,$F035,$F035,$F035,$F061,$F064,$F05E,  $5E,	 $5E,  $5E,  $5E,$F05E,$F09E,$F06E,$F0C2,$F0C4,$F0C3,$F0C2,$F0C4,$F0C3,$F0A8,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 2304
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$F533,$F532,$F531,$F530,$F52F,$F52E, $400,	$400,$F53D,$F53C,$F53B,$F53A,$F539,$F538,$F537,$F536, $400, $546, $545,	$544, $543, $542,$F541,$F540, $400, $400, $400,	$400, $52B, $52A, $529,	$542; 2368
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0, $400, $400, $400,	$400, $400, $400, $400,	$400, $400, $400, $400,	$400, $400, $400, $400,	$400,$F50B,$F50A,$F509,	$400, $400, $400, $400,	$400,$F515,$F514,$F513,$F512,$F511,$F510,$F50F,$F50E; 2432
		dc.w $F064,$F0C2,$F0C3,$F041,$F041,$F0C2,$F0C3,$F09E,$F06E,$F03C,$F03C,$F03B,$F03B,$F03C,$F03C,$F0A8,$F064,$F034,$F034,$F034,$F034,$F034,$F034,$F09E,$F06E,$F03B,$F00C,$F00C,$F00C,$F00C,$F03B,$F0A8,$F064,$F03C,$F05E,$F09E,	 0,    0,    0,	   0,$F06E,$F03C,$F05E,$F0A8,	 0,    0,    0,	   0,$F064,$F0C2,$F0C3,$F09E,	 0,    0,    0,	   0,$F06E,$F049,$F049,$F0A8,	 0,    0,    0,	   0; 2496
		dc.w $3064,$3078,    0,	   0,	 0,    0,    0,	   0,$306E,$3878,    0,	   0,	 0,    0,    0,	   0,$30C8,$30C9,  $87,	 $87,  $87,  $87,  $87,	 $9A,$30D2,$30D3,  $91,	 $91,  $91,  $91,  $91,	 $A4,$3064,$3078,    0,	   0,	 0,    0,    0,	   0,$306E,$3878,    0,	   0,	 0,    0,    0,	   0,$3064,$3078,    0,	   0,	 0,    0,    0,	   0,$306E,$3878,    0,	   0,	 0,    0,    0,	   0; 2560
		dc.w	 0,    0,    0,	   0,	 0,$C000,$C478,$C09E,	 0,    0,    0,	   0,	 0,$C000,$CC78,$C0A8,  $87,  $87,  $87,	 $87,  $87,$C088,$C089,$C09E,  $91,  $91,  $91,	 $91,  $91,$C092,$C093,$C0A8,	 0,    0,    0,	   0,	 0,$C09C,$C09D,$C09E,	 0,    0,    0,	   0,$C084,$C0A6,$C0A7,$C0A8,	 0,    0,    0,$C07B,$C07A,$C080,$C0B1,$C09E,$C074,$C073,$C0AD,$C0AE,$C0AF,$C0B0,$C0BB,$C0A8; 2624
		dc.w   $5E,  $5F,  $5E,	 $5E,  $5E,  $5E,  $5F,	 $5E,  $5E,  $5F,  $5F,	 $5F,  $5F,  $5F,  $5F,	 $5E,  $5E,  $5F,  $5E,	 $5F,  $5F,  $5E,  $5F,	 $5E,  $5E,  $5F,  $5E,	 $5F,  $5F,  $5E,  $5F,	 $5E,  $5E,  $5F,  $5E,	 $5F,$F061,$F003,$F004,$F061,  $5E,  $5F,  $5E,	 $5F,$F0CB,$F0B9,$F0BA,$F0CB,$F02A,$F002,$F002,$F02A,$F0CB,  $82,  $82,$F0CB,$F020,$F00C,$F00C,$F020,$F0CD,$F00C,$F00C,$F0CD; 2688
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,$F109,$F10A,$F10B,$F10E,$F10F,$F110,$F111,$F112,$F113,$F114,$F115,$F118,$F119,$F11A,$F11B,$F11C,$F11D,$F11E,$F11F,$F122,$F123,$F124,$F125, $126, $127, $128,	 $5E,  $5E,  $5E,  $5F,	 $5E,  $5E,  $5E,  $5E,	 $5E,  $5E,  $5E,  $5F,	 $5E,  $5E,  $5E,  $5E,	 $5E; 2752
		dc.w	 0,    0,$F12E,$F12F,$F130,$F131,$F132,$F133,$F136,$F137,$F138,$F139,$F13A,$F13B,$F13C,$F13D,$F140,$F141,$F142,$F143, $144, $145, $146,	 $5E,$F142,$F129, $12A,	$12B,  $5E,  $5E,  $5E,	 $5E, $12A, $12B,    0,	   0,  $5E,  $5E,  $5E,	 $5E,	 0,    0,    0,	   0,  $5E,  $5F,  $5F,	 $5E,  $5E,  $5E,  $5E,	 $5E,  $5E,  $5E,  $5E,	 $5E,  $5E,  $5E,  $5E,	 $5E,  $5E,  $5E,  $5E,	 $5E; 2816
		dc.w	 0,    0,  $60,$F061,$F02C,$F02A,$F02B,$F02A,	 0,  $60,$3065,$3066,$3067,$F068,$F069,$F06A,  $60,$3065,$306F,$3070,$3C71,$FC72,$FC73,$FC74,$3061,$306F,$3079,$3C7A,$3C7B,    0,    0,	   0,$3041,$3079,$3C83,$3C84,	 0,    0,    0,	   0,$303B,$308C,$3C8D,	   0,	 0,    0,    0,	   0,$305E,$3096,$3C97,	   0,	 0,    0,    0,	   0,$305E,$30A0,$3CA1,	   0,	 0,    0,    0,	   0; 2880
		dc.w $F02A,$F02B,$F02A,$F02C,$F061, $460,    0,	   0,$F06B,$F06C,$F06D,$C077,$C466,$C465, $460,	   0,$F874,$F873,$F87E,$C876,$C080,$C46F,$C465,	$460,	 0,    0,    0,$C87B,$C87A,$C080,$C46F,$C061,	 0,    0,    0,	   0,$C884,$C88A,$C080,$C041,	 0,    0,    0,	   0,	 0,$C894,$C095,$C03B,	 0,    0,    0,	   0,	 0,$C897,$C09F,$C05E,	 0,    0,    0,	   0,	 0,$C8A1,$C0A9,$C05E; 2944
		dc.w  $56C, $579,$C56F,$C5A2,$C598,    0,    0,	   0,	 0, $56C, $579,$C56F,$C5A2,$C598,    0,	   0,	 0,    0, $56C,	$579,$C56F,$C5A2,$C598,	   0,	 0,    0,    0,	$56C, $579,$C56F,$C5A2,$C598,	 0,    0,    0,	   0, $56C, $579,$C56F,$C5A2,	 0,    0,    0,	   0,	 0, $56C, $579,$C56F,	 0,    0,    0,	   0,	 0,    0, $56C,	$579,	 0,    0,    0,	   0,	 0,    0,    0,	$56C; 3008
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,  $CF, $4CF,  $CF,	$4CF,	 0,    0,    0,	   0,  $D9, $4DB, $4DA,	$4D9,	 0,    0,    0,	   0; 3072
		dc.w $F02A,$F02B,$F02A,$F02C,$F02A,$F02B,$F02A,$F02C,$F034,$F035,$F035,$F035,$F035,$F034,$F036,$F034,$F03A,$F037,  $38,	 $38,  $39,  $3B,$F023,$F03A,$F03B,$F03D,  $3E,	 $3F,  $40,  $3C,$F02D,$F03B,$F041,$F002,    2,	   2,	 2,    2,$F002,$F041,$F03A,$F0D0,  $D1,	 $DC,  $DC, $4D1,$F4D0,$F03A,$F03B,$F045,$F046,$F047,$F047,$F446,$F048,$F03B,$F03C,$F049,$F04A,$F049,$F049,$F04A,$F049,$F03C; 3136
		dc.w   $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,$358C,  $BD,    0,	   0,	 0,    0,    0,	   0,$35A2,$358D,    0,	   0,	 0,    0,    0,	   0, $56A,$35A2,$3598,	   0,	 0,    0,    0,	   0, $18E, $56A,$35A2,$3598,	 0,    0,    0,	   0; 3200
		dc.w	 0,    0,    0,	   0, $56C, $56B, $56A,$F55C,	 0,    0,    0,	   0,	 0, $56C, $567,$F566,	 0,    0,    0,	   0,	 0,    0, $56C,	$570,	 0,    0,    0,	   0,	 0,    0,    0,	$56C,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 3264
		dc.w $F55B,    0,    0,	   0,	 0,    0,    0,	   0,$F565,$F564,    0,	   0,	 0,    0,    0,	   0, $56F,$F56E,$F56D,$F55A,	 0,    0,    0,	   0, $579, $56F,$F577,$F576,$F575,$F574,$F573,$F572, $56C, $582, $581,$F580,$F57F,$F57E,$F57D,$F57C,	 0,    0, $58B,	$58A, $589, $588,$F587,$F586,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 3328
		dc.w  $400, $400, $400,	$400,$F02A,$F002,$F02A,$F07F, $400, $400, $400,	$400,$F034,$F0CE,$F034,$F0CB,	 0,    0,    0,	   0,$F03A,$F857,$F03A,$F0CB,	 0,    0,    0,	   0,$F03B,$F03C,$F03B,$F0CB,	 0,    0,    0,$F0DF,$F03C,  $35,$F035,$F0CC,	 0,    0,    0,$F0E9,$F03A,  $45,$F048,$F0CB,	 0,    0,$F0F2,$F0F3,$F03B,  $5F,$F05F,$F0CB,$F0FA,$F0FB,$F0FC,$F0FD,$F03C,$F002,$F002,$F0CD; 3392
		dc.w  $51F, $51E,$F51D,$F51C,$F51B,$F51A,$F519,$F518, $400, $528, $527,	$526, $525, $524, $523,	$522,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 3456
		dc.w $F064,$F03C,$F03C,$F09E,	 0,    0,    0,	   0,$F06E,$F05E,$F05E,$F0A8,	 0,    0,    0,	   0,$F064,$F05E,$F05E,$F09E,	 0,    0,    0,	   0,$F06E,$F0C2,$F0C3,$F0A8,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 3520
		dc.w $F02B,$F02A,$C002,$C002,$C002,$C002,$C02A,$C02B,$F035,$F035,$C036,$C036,$C036,$C036,$C035,$C035,$F0C8,$F0C9,$C03D,$C03E,$C03F,$C040,$C0C8,$C0C9,$F0D2,$F0D3,$C0C2,$C0C3,$C0C2,$C0C3,$C0D2,$C0D3,$3064,$3078,    0,	   0,	 0,    0,    0,	   0,$306E,$3878,    0,	   0,	 0,    0,    0,	   0,$3064,$3078,    0,	   0,	 0,    0,    0,	   0,$306E,$3878,    0,	   0,	 0,    0,    0,	   0; 3584
		dc.w $C0C1,$C12D,$C0B7,$C0B8,$C0B9,$C0BA,$C0C5,$C09E,$C0C2,$C0C3,$C020,$C021,$C020,$C0C2,$C0C3,$C0A8,$C0E2,$C0D0,  $D1,	 $DC, $CD1, $4D0,$C0E2,$C09E,$C0F6,$C042,  $43,	 $44, $443, $442,$C0F6,$C0A8,$C041,$C054,  $55,	 $56, $456,  $18,$C418,$C09E,$C03B,$C036,  $36,	 $36,  $36,  $36,$C036,$C0A8,$C03A,$C05F,$C05F,$C05F,$C05F,$C05F,$C05F,$C09E,$C03B,$C0C2,$C0C3,$C0C2,$C0C3,$C0C2,$C0C3,$C0A8; 3648
		dc.w $F551,$F550,$F54F,$F54E,$F54D,    0,    0,	   0,$F53D,$F53C,$F559,$F558,$F557,$F556,    0,	   0, $547, $546, $563,	$562,$F561,$F560,$F55F,	$55E,	 0,    0,    0,	$56C, $56B,$F56A,$F569,$F568,	 0,    0,    0,	   0, $56C, $56B,$F56A,$F55C,	 0,    0,    0,	   0,	 0, $56C, $567,$F566,	 0,    0,    0,	   0,	 0,    0, $56C,	$570,	 0,    0,    0,	   0,	 0,    0,    0,	$56C; 3712
		dc.w   $5E,  $5E,  $5E,	 $5E,  $5E,  $5E,  $5E,	 $5E,  $5E,  $5E,  $5E,	 $5E,  $5E,  $5E,  $5E,	 $5E,$F02A,$F02B,$F02A,$F02B,$F02B,$F02A,$F02B,$F02A,$F035,$F036,$F036,$F035,$F035,$F036,$F036,$F035,$F064,$F023,  $54,	 $21,  $21,  $55,$F023,$F09E,$F06E,$F02D,  $56,	$456,  $56, $456,$F02D,$F0A8,$F064,$F045,  $47,	 $47,  $47,  $47,$F048,$F09E,$F06E,$F049,$F049,$F049,$F049,$F049,$F049,$F0A8; 3776
		dc.w   $5E,  $5E,  $5F,	 $5E,  $5E,  $5F,  $5E,	 $5E,  $5E,  $5E,  $5F,	 $5E,  $5E,  $5F,  $5E,	 $5E,  $5E,  $5E,  $5E,	 $5F,  $5F,  $5E,  $5E,	 $5E,  $5E,  $5E,  $5E,	 $5F,  $5F,  $5E,  $5E,	 $5E,  $5E,  $5E,  $5E,	 $5F,  $5F,  $5E,  $5E,	 $5E,  $5E,  $5E,  $5E,	 $5F,  $5F,  $5E,  $5E,	 $5E,  $5E,  $5E,  $5F,	 $5E,  $5E,  $5F,  $5E,	 $5E,  $5E,  $5E,  $5F,	 $5E,  $5E,  $5F,  $5E,	 $5E; 3840
		dc.w $3041,$308E,$34A1,	   0,	 0,    0,    0,	   0,$303B,$3098,$3497,	   0,	 0,    0,    0,	   0,$305E,$30A2,$3485,	   0,	 0,    0,    0,	   0,$305E,$30AC,$348F,$3484,	 0,    0,    0,	   0,$305E,$30B6,$3099,$347A,$347B,    0,    0,	   0,$305E,$30C0,  $A3,$307C,$347D,$347E,$3473,$3474,$3041,$30C5,  $AA,	 $AB,$30B4,$30B5,$30BE,$30BF,$303B,$30C5,$3020,$30C2,$30C3,$3020,$30C2,$30C3; 3904
		dc.w	 0,    0,    0,	   0,	 0,    0,$C478,$C09E,	 0,    0,    0,	   0,	 0,    0,$CC78,$C0A8,	 0,    0,    0,	   0,	 0,$C0A1,$C089,$C09E,	 0,    0,    0,	   0,	 0,$C097,$C093,$C0A8,	 0,    0,    0,	   0,	 0,$F0E6,$F0E7,$F0E8,$310E,$310F,$3110,$3111,$F0F0,$F0F1,$F0A7,$F0A8,$3118,$3119,$311A,$F120,$F121,$F080,$C0B1,$C09E,$C106,$C107,$C108,$C12C,$C0AF,$C0B0,$C0BB,$C0A8; 3968
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$F55B,    0,    0,	   0,	 0,    0,    0,	   0,$F565,$F564,    0,	   0,	 0,    0,    0,	   0,$F56F,$F56E,$F56D,$F55A,	 0,    0,    0,	   0,$F579,$F56F,$F577,$F576,$F575,$F574,$F573,$F572; 4032
		dc.w $F0D5,$F0D6,$F4D6,$F0D7,$F058,$F059,$F058,$F058,$F03C,$F0D8,$F4D8,$F03C,$F062,$F063,$F05A,$F462,  $5E,  $5E,  $5F,	 $5F,  $5F,  $5F,  $5E,	 $5E,  $5E,  $5E,  $5F,	 $5F,  $5F,  $5F,  $5E,	 $5E,  $5E,  $5E,  $5E,	 $5E,  $5E,  $5E,  $5E,	 $5E,  $5E,  $5E,  $5E,	 $5E,  $5E,  $5E,  $5E,	 $5E,  $5E,  $5E,  $5F,	 $5F,  $5F,  $5F,  $5E,	 $5E,  $5E,  $5E,  $5F,	 $5F,  $5F,  $5F,  $5E,	 $5E; 4096
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,  $CF, $4CF,  $CF,	$4CF,	 0,    0,    0,	   0,  $D9,  $DA,  $DB,	$4D9,	 0,    0,    0,	   0,$F0D5,$F0D6,$F4D6,$F0D7,$F058,$F059,$F058,$F058,$F03C,$F0D8,$F4D8,$F03C,$F062,$F063,$F05A,$F462,  $5E,  $5E,  $5F,	 $5F,  $5F,  $5F,  $5E,	 $5E,  $5E,  $5E,  $5F,	 $5F,  $5F,  $5F,  $5E,	 $5E; 4160
		dc.w  $154, $18F, $56A,$35A2,$3598,    0,    0,	   0,  $BC, $183, $56B,	$56A,$35A2,$3598,    0,	   0,  $BC,  $BD, $56C,	$56B, $56A,$31B4,$F1B5,$C10B,$C104,$C105,$C110,$C1BC,$C1BD,$F1BE,$F1BF,$F1B6,$C118,$C119,$C11A,$C11B,$C11C,$C11D,$C11E,$31C0,$C122,$C123,$C124,$C125, $126, $127, $1C9,	$1CA, $1A3, $1AD,    0,	   0,	 0,    0, $56C,	$56B,  $C6,  $C7,    0,	   0,	 0,    0,    0,	$56C; 4224
		dc.w	 0,    0,$C12E,$C12F,$C130,$C131,$C132,$C133,$C136,$C137,$C138,$C139,$C13A,$C13B,$C13C,$C13D,$C140,$C141,$C142,	$143, $144, $145, $146,	$147, $142, $129, $12A,	$12B,	 0,    0,    0,	   0,$354C, $12B,    0,	   0,	 0,    0,    0,	   0,$35A2,$3598,    0,	   0,	 0,    0,    0,	   0, $1CA,$35AC,$356D,$355A,	 0,    0,    0,	   0, $56B, $599,$3577,$3576,$3575,$3574,$3573,$3572; 4288
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,$F109,$F10A,$F10B,$F10E,$F10F,$F110,$F111,$F112,$F113,$F114,$F115; 4352
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,$F12E,$F12F,$F130,$F131,$F132,$F133,$F136,$F137,$F138,$F139,$F13A,$F13B,$F13C,$F13D,$F140,$F141,$F142,$F143, $144, $145, $146,	   0,$F142, $129, $12A,	$12B,	 0,    0,    0,	   0; 4416
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$F4DF, $400, $400,	$400,	 0,    0,    0,	   0,$F4E9, $400, $400,	$400,	 0,    0,    0,	   0,$F4F3,$F4F2, $400,	$400,	 0,    0,    0,	   0,$F4FD,$F4FC,$F4FB,$F4FA,	 0,    0,    0,	   0; 4480
		dc.w	 0,    0,    0,	   0,$F061,$F02A,$F02A,$F061,	 0,    0,    0,	   0,$F0CB,$F00C,$F00C,$F0CB,$F02A,$F02B,$F02B,$F02A,$F0CB,  $36,$F036,$F0CB,$F034,$F036,$F036,$F034,$F0CB,  $23,$F023,$F0CB,$F03A,$F021,  $21,	 $3A,  $CC,  $2D,$F02D,$F0CC,$F03A,$F018, $418,	 $3A,  $CB,  $C5,$F0C5,$F0CB,$F03B,$F020,  $20,	 $3B,  $CB,  $C5,$F0C5,$F0CB,$F0C2,$F0C3,$F0C2,$F0C3,$F0CD,$F0C5,$F0C5,$F0CD; 4544
		dc.w $3064,$3078,    0,	   0,	 0,    0,    0,	   0,$306E,$3878,    0,	   0,	 0,    0,    0,	   0,$3041,$308E, $4A1,	   0,	 0,    0,    0,	   0,$303B,$3098,$3497,	   0,	 0,    0,    0,	   0,$305E,$30A2,$3485,	   0,	 0,    0,    0,	   0,$305E,$30AC,$348F,$3484,	 0,    0,    0,	   0,$305E,$30B6,$3099,$347A,$347B,    0,    0,	   0,$305E,$30C0,$30A3,$307C,$347D,$347E,$3473,$3474; 4608
		dc.w $3064,$3078,    0,	   0,	 0,    0,    0,	   0,$306E,$3878,    0,	   0,	 0,    0,    0,	   0,$3041,$308E,$349B,	 $87,  $87,  $87,  $87,	 $9A,$303B,$3098,$34A5,	 $91,  $91,  $91,  $91,	 $A4,$305E,$30A2,$3485,	   0,	 0,    0,    0,	   0,$305E,$30AC,$348F,$3484,	 0,    0,    0,	   0,$305E,  $B6,$3099,$347A,$347B,    0,    0,	   0,$305E,$30C0,$30A3,$307C,$347D,$347E,$3473,$3474; 4672
		dc.w $F5C6,$F5C5,$F5C4,$F5C3,$F5C2,$3058,$305C,$3058,$F53D,$F53C,$F559,$F5CE,$F5CD,$F5CC,$305D,$3462, $547, $546, $563,	$562,$C561,$C560,$C55F,	$55E,	 0,    0,    0,	$56C, $56B,$C56A,$C569,$C568,	 0,    0,    0,	   0, $56C, $56B,$C56A,$C55C,	 0,    0,    0,	   0,	 0, $56C, $567,$C566,	 0,    0,    0,	   0,	 0,    0, $56C,	$570,	 0,    0,    0,	   0,	 0,    0,    0,	$56C; 4736
		dc.w $3058,$3059,$3058,$3058,$3058,$3058,$305C,$3058,$3062,$3063,$305A,$305B,$305A,$305B,$305D,$3462,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$C55B,    0,    0,	   0,	 0,    0,    0,	   0,$C565,$C564,    0,	   0,	 0,    0,    0,	   0,$C56F,$C56E,$C56D,$C55A,	 0,    0,    0,	   0, $579,$C56F,$C577,$C576,$C575,$C574,$C573,$C572; 4800
		dc.w	 0,    0,    0,$314D,$314E,$314F,$3150,$3151,	 0,    0,$3156,$3157,$3158,$3159,$313C,$313D, $15E,$315F,$3160,$3161, $162, $163, $146,	   0,$3168,$3169,$316A,	$16B, $16C,    0,    0,	   0,$F196,$316A, $16B,	$16C,	 0,    0,    0,	   0,$F1A0,$C1A1, $16C,	   0,	 0,    0,    0,	   0,$C1AA,$C1AB,$C598,	   0,	 0,    0,    0,	   0, $1A9,$C56F,$C5A2,$C598,	 0,    0,    0,	   0; 4864
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,$3198,	 0,    0,    0,	   0,	 0,    0,$3198,$31A2,	 0,    0,    0,	   0,$315A,$316D,$31AC,$316F,$3172,$3173,$3174,$3175,$3176,$3177,$316F,	$179; 4928
		dc.w	 0,    0,    0,$3198,$31A2,$316F, $179,	$16C,	 0,    0,$3198,$31A2,$316F, $179, $16C,	   0,	 0,$3198,$31A2,$316F, $179, $16C,    0,	   0,$3198,$31A2,$316F,	$179, $16C,    0,    0,	   0,$31A2,$316F, $179,	$16C,	 0,    0,    0,	   0,$316F, $179, $16C,	   0,	 0,    0,    0,	   0, $179, $16C,    0,	   0,	 0,    0,    0,	   0, $16C,    0,    0,	   0,	 0,    0,    0,	   0; 4992
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$355B,    0,    0,	   0,	 0,    0,    0,	   0,$3565,$3564,    0,	   0,	 0,    0,    0,	   0,$356F,$356E,$356D,$355A,	 0,    0,    0,	   0,$3579,$356F,$3577,$3576,$3575,$3574,$3573,$3572; 5056
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,  $CF, $4CF,  $CF,	$4CF,	 0,    0,    0,	   0,  $D9,  $DA,  $DB,	$4D9,	 0,    0,    0,	   0; 5120
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,  $81, $481,  $86,	 $87,  $87,  $87,  $87,	 $9A,  $8B, $48B,  $90,	 $91,  $91,  $91,  $91,	 $A4,  $B2,  $B3,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,$F50D,$F50C,$F509,	   0,	 0,    0,    0,	   0,$F515,$F514,$F513,$F512,$F511,$F510,$F50F,$F50E; 5184
		dc.w   $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,$F55B,  $BD,    0,	   0,	 0,    0,    0,	   0,$F565,$F54B,    0,	   0,	 0,    0,    0,	   0,$F56F,$F56E,$F56D,$F55A,	 0,    0,    0,	   0, $14A,$F56F,$F577,$F576,$F575,$F574,$F573,$F572; 5248
		dc.w $F058,$F059,$F058,$F058,$F058,$F058,$F05C,$F058,$F062,$F063,$F05A,$F05B,$F05A,$F05B,$F05D,$F462, $88B, $C8B,    0,	   0,	 0,    0,    0,	   0,  $8B, $48B,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 5312
		dc.w $F118,$F119,$F11A,$F11B,$F11C,$F11D,$F11E,	$11F,$F122,$F123,$F124,$F125, $126, $127, $128,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 5376
		dc.w   $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,$F058,$F059,$F058,$F058,$F058,$F058,$F05C,$F058,$F062,$F063,$F05A,$F05B,$F05A,$F05B,$F05D,$F462, $1A3, $1AD,    0,	   0,	 0,    0,    0,	   0,  $C6,  $C7,    0,	   0,	 0,    0,    0,	   0; 5440
		dc.w $F07F,$F036,$F036,$F07F,$F02A,$F002,$F002,$F02A,$F0CB,$F054,$F055,$F0CB,$F034,$F034,$F034,$F034,$F0CB,$F045,  $48,	 $CB,  $3B,  $3B,$F03B,$F03B,$F0CD,$F03D,$F040,$F0CD,$F021,$F021,$F021,$F021,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 5504
		dc.w $F535,$F534,$F54F,$F54E,$F54D,    0,    0,	   0,$F53D,$F53C,$F559,$F558,$F557,$F556,    0,	   0, $13E, $13F, $563,$F562,$F561,$F560,$F55F,	   0,  $BC,  $BD,    0,	$56C, $56B,$F56A,$F569,$F568,  $BC,  $BD,    0,	   0, $56C, $56B,$F56A,$F55C,  $BC,  $BD,    0,	   0,	 0, $56C, $567,$F566,  $BC,  $BD,    0,	   0,	 0,    0, $56C,	$570,  $C6,  $C7,    0,	   0,	 0,    0,    0,	$56C; 5568
		dc.w $F058,$F059,$F058,$F058,$F058,$F058,$F05C,$F058,$F062,$F063,$F05A,$F05B,$F05A,$F05B,$F05D,$F462,  $87,  $87,  $87,	 $87,  $87,  $87,  $87,	 $9A,  $91,  $91,  $91,	 $91,  $91,  $91,  $91,	 $A4,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 5632
		dc.w $F041,$F0C5,$F0AA,$F0AB,$F0B4,$F0B5,$F0BE,$F0BF,$F03B,$F0C5,$F020,$F0C2,$F0C3,$F020,$F0C2,$F0C3,$F041,$F082,$F082,$F082,$F082,$F082,$F082,$F041,$F03B,  $45,  $47,	 $47,  $47,  $47,  $48,$F03B,  $5E,  $5E,  $5F,	 $5F,  $5F,  $5F,  $5E,	 $5E,  $5E,  $5E,  $5E,	 $5E,  $5E,  $5E,  $5E,	 $5E,  $5E,  $5E,  $5E,	 $5E,  $5E,  $5E,  $5E,	 $5E,  $5E,  $5E,  $5F,	 $5F,  $5F,  $5F,  $5E,	 $5E; 5696
		dc.w   $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,$F15B,  $BC,  $BD,    0,	   0,	 0,    0,$F164,$F165,  $BC,  $BD,    0,	   0,$F15A,$F16D,$F16E,$F16F,$F148,$F149,$F174,$F175,$F176,$F177,$F16F,	$179; 5760
		dc.w $F058,$F059,$F058,$F058,$F058,$F058,$F05C,$F058,$F062,$F063,$F05A,$F05B,$F05A,$F05B,$F05D,$F462, $88B, $C8B,  $86,	 $87,  $87,  $87,  $87,	 $9A,  $8B, $48B,  $90,	 $91,  $91,  $91,  $91,	 $A4,  $B2,  $B3,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $C6,  $C7,    0,	   0,	 0,    0,    0,	   0; 5824
		dc.w   $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0, $193, $194,  $CF,	$4CF,	 0,    0,    0,	   0, $190, $197,  $DB,	$4D9,	 0,    0,    0,	   0; 5888
		dc.w $F058,$F059,$F058,$F058,$F058,$F058,$F05C,$F058,$F062,$F063,$F05A,$F05B,$F05A,$F05B,$F05D,$F462,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 5952
		dc.w $C0D5,$C0D6,$C4D6,$C0D7,$C058,$C059,$C058,$C058,$C03C,$C0D8,$C4D8,$C03C,$C062,$C063,$C05A,$C462,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,$3198,	 0,    0,    0,	   0,	 0,    0,$3198,$31A2,	 0,    0,    0,	   0,	 0,$3198,$31A2,$316A,	 0,    0,    0,	   0,$3198,$31A2,$3199,	$16B; 6016
		dc.w $C058,$C059,$C058,$C1AF,$F1B0,$F1B1,$F1B2,$F1B3,$C462,$C063,$F1B8,$F1B9,$F1BA,$F159,$F13C,$F13D,$315E,$315F,$3160,$3161,$3162, $163, $146,	$147,$3168,$3169,$316A,	$16B, $16C,    0,    0,	   0,$31A2,$316A, $16B,	$16C,	 0,    0,    0,	   0,$316A, $16B, $16C,	   0,	 0,    0,    0,	   0, $16B, $16C,    0,	   0,	 0,    0,    0,	   0, $16C,    0,    0,	   0,	 0,    0,    0,	   0; 6080
		dc.w $F058,$F059,$F058,$F058,$F058,$F058,$F05C,$F058,$F062,$F063,$F05A,$F05B,$F05A,$F05B,$F05D,$F462, $1A3, $1AD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $C6,  $C7,    0,	   0,	 0,    0,    0,	   0; 6144
		dc.w  $116,$F51E,$F51D,$F51C,$F51B,$F51A,$F519,$F518, $1A3, $117, $527,	$526,$F525,$F524,$F523,$F522,  $81, $481,    0,	   0,	 0,    0,    0,	   0,  $8B, $48B,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 6208
		dc.w  $154, $155,$F581,$F580,$F57F,$F57E,$F57D,$F57C,  $BC,  $BD, $58B,	$58A,$F589,$F588,$F587,$F586,  $81, $481,    0,	   0,	 0,    0,    0,	   0,  $8B, $48B,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 6272
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,  $87,  $87,  $87,	 $87,  $87,  $87,  $87,	 $9A,  $91,  $91,  $91,	 $91,  $91,  $91,  $91,	 $A4; 6336
		dc.w   $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,$F109,$F10A,$F10B,$F104,$F105,$F110,$F111,$F112,$F113,$F114,$F115,$F118,$F119,$F11A,$F11B,$F11C,$F11D,$F11E,$F11F,$F122,$F123,$F124,$F125, $126, $127, $128,	   0, $1A3, $1AD,    0,	   0,	 0,    0,    0,	   0,  $C6,  $C7,    0,	   0,	 0,    0,    0,	   0; 6400
		dc.w $F058,$F059,$F0C8,$F0C9,$F010,$F011,    0,	   0,$F062,$F063,$F0D2,$F0D3,$F01A,$F01B,    0,	   0, $1A3, $1AD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $C6,  $C7,    0,	   0,	 0,    0,    0,	   0; 6464
		dc.w $F058,$F059,$F0C8,$F0C9,$F010,$F011,    0,	   0,$F062,$F063,$F0D2,$F0D3,$F01A,$F01B,    0,	   0,  $81, $481,    0,	   0,	 0,    0,    0,	   0,  $8B, $48B,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 6528
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,  $81, $481,    0,	   0,	 0,    0,    0,	   0,  $8B, $48B,    0,	   0,	 0,    0,    0,	   0; 6592
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,  $87,  $87,  $87,	 $87,  $87,  $87,  $87,	 $9A,  $91,  $91,  $91,	 $91,  $91,  $91,  $91,	 $A4,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,  $81, $481,  $87,	 $87,  $87,  $87,  $87,	 $9A,  $8B, $48B,  $91,	 $91,  $91,  $91,  $91,	 $A4; 6656
		dc.w   $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $C6,  $C7,    0,	   0,	 0,    0,    0,	   0,  $81, $481,    0,	   0,	 0,    0,    0,	   0,  $8B, $48B,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,  $87,  $87,  $87,	 $87,  $87,  $87,  $87,	 $9A,  $91,  $91,  $91,	 $91,  $91,  $91,  $91,	 $A4; 6720
		dc.w $F17C,$F17D,$F17E,$F17F,$F180,$F181, $182,	$171,$F186,$F187,$F188,$F189, $18A, $18B,    0,	   0, $88B, $C8B,    0,	   0,	 0,    0,    0,	   0,  $8B, $48B,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 6784
		dc.w   $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,$F50D,$F50C,$F509,	   0,	 0,    0,    0,	   0,$F515,$F514,$F513,$F512,$F511,$F510,$F50F,$F50E; 6848
		dc.w $F0D5,$F0D6,$F4D6,$F0D7,$F058,$F059,$F058,$F058,$F03C,$F0D8,$F4D8,$F03C,$F062,$F063,$F05A,$F462, $1A3, $1AD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $C6,  $C7,    0,	   0,	 0,    0,    0,	   0; 6912
		dc.w $F51F,$F51E,$F51D,$F51C,$F51B,$F51A,$F519,$F518,	 0, $528, $527,$F526,$F525,$F524,$F523,$F522,  $87,  $87,  $87,	 $87,  $87,  $87,  $87,	 $9A,  $91,  $91,  $91,	 $91,  $91,  $91,  $91,	 $A4,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 6976
		dc.w   $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,$F12E,$F12F,$F130,$F131,$F132,$F133,$F0EE,$F0EF,$F138,$F139,$F13A,$F13B,$F13C,$F13D,$F140,$F141,$F142,$F143,$F144,$F145, $146,	$147,$F142,$F0E5, $12A,	$12B,	 0,    0,    0,	   0; 7040
		dc.w   $BC,  $BD,    0,	$14D,$C14E,$C14F,$C150,$C151,  $BC,  $BD,$C156,$C157,$C158,$C159,$C13C,$C13D,  $BC,$C153,$C160,$C161,$C162, $163, $146,	$147,$C15D,$C169,$C16A,$C16B, $16C,    0,    0,	   0,$C15C,$C16A,$C16B,	$16C,	 0,    0,    0,	   0,$C166, $17B, $16C,	   0,	 0,    0,    0,	   0, $17A, $185,    0,	   0,	 0,    0,    0,	   0, $184,  $BD,    0,	   0,	 0,    0,    0,	   0; 7104
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,  $87,  $87,  $87,	 $87,  $87,  $87,  $87,	 $9A,  $91,  $91,  $91,	 $91,  $91,  $91,  $91,	 $A4,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 7168
		dc.w   $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $C6,  $C7,    0,	   0,	 0,    0,    0,	   0; 7232
		dc.w   $5E,  $5E,  $5E,	 $5E,  $5E,  $5E,  $5E,	 $5E,  $5E,  $5E,  $5F,	 $5F,  $5F,  $5F,  $5F,	 $5E,  $81, $481,  $86,	 $87,  $87,  $87,  $87,	 $9A,  $8B, $48B,  $90,	 $91,  $91,  $91,  $91,	 $A4,  $B2,  $B3,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $C6,  $C7,    0,	   0,	 0,    0,    0,	   0; 7296
		dc.w   $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $81, $481,  $86,	 $87,  $87,  $87,  $87,	 $9A,  $8B, $48B,  $90,	 $91,  $91,  $91,  $91,	 $A4,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 7360
		dc.w	 0,    0,$F411,$F410,$F0C8,$F0C9,$F05C,$F458,	 0,    0,$F41B,$F41A,$F0D2,$F0D3,$F05D,$F462,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 7424
		dc.w $F058,$F059,$F0C8,$F0C9,$F010,$F011,    0,	   0,$F062,$F063,$F0D2,$F0D3,$F01A,$F01B,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 7488
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,  $81, $481,    0,	   0,	 0,    0,    0,	   0,  $8B, $48B,    0,	   0,	 0,    0,    0,	   0,  $B2,  $B3,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $C6,  $C7,    0,	   0,	 0,    0,    0,	   0; 7552
		dc.w   $BC,  $BD,$F411,$F410,$F0C8,$F0C9,$F05C,$F458,  $C6,  $C7,$F41B,$F41A,$F0D2,$F0D3,$F05D,$F462,  $81, $481,    0,	   0,	 0,    0,    0,	   0,  $8B, $48B,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 7616
		dc.w   $BC,  $BD,$F411,$F410,$F0C8,$F0C9,$F05C,$F458,  $BC,  $BD,$F41B,$F41A,$F0D2,$F0D3,$F05D,$F462,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $C6,  $C7,    0,	   0,	 0,    0,    0,	   0; 7680
		dc.w   $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $C6,  $C7,    0,	   0,	 0,    0,    0,	   0,  $81, $481,    0,	   0,	 0,    0,    0,	   0,  $8B, $48B,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 7744
		dc.w   $BC,  $BD,$F411,$F410,$F0C8,$F0C9,$F05C,$F458,  $C6,  $C7,$F41B,$F41A,$F0D2,$F0D3,$F05D,$F462,  $81, $481,  $86,	 $87,  $87,  $87,  $87,	 $9A,  $8B, $48B,  $90,	 $91,  $91,  $91,  $91,	 $A4,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 7808
		dc.w $F116,$F51E,$F51D,$F51C,$F51B,$F51A,$F519,$F518,  $BC, $117, $527,	$526,$F525,$F524,$F523,$F522,  $81, $481,  $86,	 $87,  $87,  $87,  $87,	 $9A,  $8B, $48B,  $90,	 $91,  $91,  $91,  $91,	 $A4,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 7872
		dc.w   $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $C6,  $C7,    0,	   0,	 0,    0,    0,	   0,  $81, $481,  $86,	 $87,  $87,  $87,  $87,	 $9A,  $8B, $48B,  $90,	 $91,  $91,  $91,  $91,	 $A4,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,  $CF, $4CF,  $CF,	$4CF,	 0,    0,    0,	   0,  $D9, $4DB, $4DA,	$4D9,	 0,    0,    0,	   0; 7936
		dc.w $F116,$F51E,$F51D,$F51C,$F51B,$F51A,$F519,$F518, $1A3, $117, $527,	$526,$F525,$F524,$F523,$F522,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $C6,  $C7,    0,	   0,	 0,    0,    0,	   0; 8000
		dc.w $F118,$F119,$F11A,$F11B,$F11C,$F11D,$F11E,$F11F,$F122,$F123,$F124,$F125, $126, $127, $128,	$400,  $87,  $87,  $87,	 $87,  $87,  $87,  $87,	 $9A,  $91,  $91,  $91,	 $91,  $91,  $91,  $91,	 $A4,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 8064
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,  $87,  $87,  $87,	 $87,  $87,  $87,  $87,	 $9A,  $91,  $91,  $91,	 $91,  $91,  $91,  $91,	 $A4,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,  $CF, $4CF,  $CF,	$4CF,	 0,    0,    0,	   0,  $D9,  $DA,  $DB,	$4D9,	 0,    0,    0,	   0; 8128
		dc.w $F061,$F002,$F02A,$F02B,$F02B,$F02A,$F002,$F061,$F0DD,$F0DE,$F0DE,$F0DE,$F0DE,$F0DE,$F0DE,$F0DD,$F0DD,$F0D0,$F0D1,$F0DC,$F0DC,$F4D1,$F4D0,$F0DD,  $E0,  $E1,  $E1,	 $E1,  $E1,  $E1,  $E1,	 $E0,  $E2,  $E3,  $E3,	 $E3,  $E3,  $E3,  $E3,	 $ED,  $EC,  $EA,  $EA,	 $EA,  $EA,  $EA,  $EA,	 $F7,$F4F6,$F4EB,$F4F4,$F4F5,  $EA,  $EA,  $EA,	 $F7,$F0E4,$F178,$F0FE,$F0FF,$F500,$F501,$F502,$F503; 8192
		dc.w $F0D5,$F0D6,$F4D6,$F0D7,$F058,$F059,$F058,$F058,$F03C,$F0D8,$F4D8,$F03C,$F062,$F063,$F05A,$F462,  $87,  $87,  $87,	 $87,  $87,  $87,  $87,	 $9A,  $91,  $91,  $91,	 $91,  $91,  $91,  $91,	 $A4,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 8256
		dc.w $F0C1,$F12D,$F0B7,$F0B8,$F0B9,$F0BA,$F0C5,$F09E,$F0C2,$F0C3,$F020,$F021,$F020,$F0C2,$F0C3,$F0A8,  $87,  $87,  $87,	 $87,  $87,  $87,  $87,	 $9A,  $91,  $91,  $91,	 $91,  $91,  $91,  $91,	 $A4,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 8320
		dc.w $F0C1,$F12D,$F0B7,$F061,$F02C,$F02A,$F02B,$F02A,$30C2,$30C3,$3016,$3017,$3067,$F068,$F069,$F06A,$3064,$3064,$3020,$3070,$3C71,$FC72,$FC73,	$C74,$306E,$306E,$3079,$3C7A,$3C7B,    0,    0,	   0,$3064,$3079,$3C83,$3C84,	 0,    0,    0,	   0,$306E,$308C,$3C8D,	   0,	 0,    0,    0,	   0,$305E,$3096,$3C97,	   0,	 0,    0,    0,	   0,$305E,$30A0, $CA1,	   0,	 0,    0,    0,	   0; 8384
		dc.w $F061,$F0C2,$F0C3,$F034,$F034,$F034,$F034,$F034,$F0CB,$F054,$F055,$F03B,$F03B,$F03B,$F03B,$F03B,$F0CB,$F0C2,  $C3,	 $37,  $38,  $38,  $38,	 $38,$F0CB,$F041,$F03C,$F03D,$F03E,$F03E,$F03F,$F03F,$F0CB,$F03B,$F03C,	 $5E,  $5E,  $5E,  $5E,	 $5E,$F0CB,$F03C,  $5E,	 $5E,  $5E,  $5E,  $5E,	 $5E,$F0CD,  $5E,  $5E,	 $5E,  $5E,  $5E,  $5E,	 $5E,  $5E,  $5E,  $5E,	 $5E,  $5E,  $5E,  $5E,	 $5E; 8448
		dc.w $F034,$F0C2,$F0C3,$F061,$F03C,$F03C,$F03C,$F061,$F03B,$F056,$F456,$F0CB,$F0AB,$F0AA,$F0AB,$F0CB,  $39,  $C2,  $C3,	 $CB,  $C2,  $C4,$F0C3,$F0CB,$F040,$F03C,  $41,	 $CB,  $34,  $34,$F034,$F0CB,  $5E,$F03C,$F03B,	 $CB,  $3B,  $3B,$F03B,$F0CB,  $5E,  $5E,$F03C,$F0CB,  $C2,  $C3,$F03C,$F0CB,  $5E,  $5E,  $5E,$F0CD,$F041,$F03C,$F041,$F0CB,  $5E,  $5E,  $5E,	 $5E,$F03B,$F03C,$F03B,$F0CD; 8512
		dc.w	 0,    0,    0,	   0,	 0,    0, $52B,	$52A,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 8576
		dc.w  $12A, $12B,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 8640
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$3598,    0,    0,	   0,	 0,    0,    0,	   0,$35A2,$3598,    0,	   0,	 0,    0,    0,	   0,$356F,$35AC,$356D,$355A,	 0,    0,    0,	   0,$3579,$356F,$3577,$3576,$3575,$3574,$3573,$3572; 8704
		dc.w $F058,$F059,$F058,$F058,$F058,$F058,$F05C,$F058,$F062,$F063,$F05A,$F05B,$F05A,$F05B,$F05D,$F462,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,  $CF, $4CF,  $CF,	$4CF,	 0,    0,    0,	   0,  $D9, $4DB, $4DA,	$4D9,	 0,    0,    0,	   0; 8768
		dc.w $F058,$F059,$F058,$F058,$F058,$F058,$F05C,$F058,$F062,$F063,$F05A,$F05B,$F05A,$F05B,$F05D,$F462,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 8832
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,  $81, $481,  $86,	 $87,  $87,  $87,  $87,	 $9A,  $8B, $48B,  $90,	 $91,  $91,  $91,  $91,	 $A4,  $B2,  $B3,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $C6,  $C7,    0,	   0,	 0,    0,    0,	   0; 8896
		dc.w $F064,$F0C2,$F0C3,$F041,$F041,$F0C2,$F0C3,$F09E,$F06E,$F03C,$F03C,$F03B,$F03B,$F03C,$F03C,$F0A8,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$F55B,    0,    0,	   0,	 0,    0,    0,	   0,$F565,$F564,    0,	   0,	 0,    0,    0,	   0,$F56F,$F56E,$F56D,$F55A,	 0,    0,    0,	   0,$F579,$F56F,$F577,$F576,$F575,$F574,$F573,$F572; 8960
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,$C598,    0,    0,	   0,	 0,    0,    0,	   0,$C5A2,$C598,    0,	   0,	 0,    0,    0,	   0,$C56F,$C5AC,$C56D,$C55A,	 0,    0,    0,	   0,$C579,$C56F,$C577,$C576,$C575,$C574,$C573,$C572; 9024
		dc.w $F551,$F550,$F54F,$F54E,$F54D,    0,    0,	   0,$F53D,$F53C,$F559,$F558,$F557,$F556,    0,	   0, $547, $546, $563,	$562,$F561,$F560,$F55F,	$55E,	 0,    0,    0,	$56C, $56B,$F56A,$F569,$F568,	 0,    0,    0,	   0, $56C, $56B,$F56A,$F5A2,	 0,    0,    0,	   0,	 0, $56C, $56B,$F56A,	 0,    0,    0,	   0,	 0,    0, $56C,	$56B,	 0,    0,    0,	   0,	 0,    0,    0,	$56C; 9088
		dc.w  $56C, $579,$C56F,$C5A2,$C598,    0,    0,	   0,	 0, $56C, $579,$C56F,$C5A2,$C598,    0,	   0,	 0,    0, $56C,	$579,$C56F,$C5A2,$C598,	   0,	 0,    0,    0,	$56C, $579,$C56F,$C5A2,$C598,	 0,    0,    0,	   0, $56C, $579,$C56F,$C55C,	 0,    0,    0,	   0,	 0, $56C, $579,$C566,	 0,    0,    0,	   0,	 0,    0, $56C,	$56B,	 0,    0,    0,	   0,	 0,    0,    0,	$571; 9152
		dc.w  $154, $155,$F581,$F580,$F57F,$F57E,$F57D,$F57C,  $BC,  $BD, $58B,	$58A,$F589,$F588,$F587,$F586,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $BC,  $BD,    0,	   0,	 0,    0,    0,	   0,  $C6,  $C7,    0,	   0,	 0,    0,    0,	   0; 9216
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,  $81, $481,  $87,	 $87,  $87,  $87,  $87,	 $9A,  $8B, $48B,  $91,	 $91,  $91,  $91,  $91,	 $A4,$F55B,  $BD,    0,	   0,	 0,    0,    0,	   0,$F565,$F54B,    0,	   0,	 0,    0,    0,	   0,$F56F,$F56E,$F56D,$F55A,	 0,    0,    0,	   0, $14A,$F56F,$F577,$F576,$F575,$F574,$F573,$F572; 9280
		dc.w	 0,    0,    0,	   0,	 0,    0, $52B,	$52A,	 0,    0,    0,	   0,	 0,    0,    0,	   0,  $87,  $87,  $87,	 $87,  $87,  $87,  $87,	 $9A,  $91,  $91,  $91,	 $91,  $91,  $91,  $91,	 $A4,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 9344
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 9408
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 9472
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 9536
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 9600
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 9664
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 9728
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 9792
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 9856
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 9920
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 9984
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 10048
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 10112
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 10176
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0, $26F,    0,	$270,	 0,    0,    0,	   0,	 0, $251,    0,	   0,	 0,    0,    0,	   0,	 0, $236, $237,	$238; 10240
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0, $26F,    0, $270,	   0,	 0,    0,    0,	   0, $230, $231, $231,	   0,	 0,    0,    0,	   0, $23A, $23B, $23B,	   0; 10304
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0, $26F,    0, $270,	   0,	 0,    0,    0,	   0, $251, $252, $252,	   0,	 0,    0,    0,	   0, $236, $237, $238,	   0,	 0,    0,    0,	   0, $240, $241, $242,	$26F,	 0,    0, $270,	   0; 10368
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 10432
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0, $26F,    0, $270,	   0,	 0,    0,    0,	   0, $230, $231, $231,	   0,	 0,    0,    0,	   0, $23A, $23B, $23B,	   0,	 0,    0,    0,	   0; 10496
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0, $26F,    0,	$270,	 0,    0,    0,	   0,	 0, $251, $252,	$252,	 0,    0,    0,	   0,	 0, $236, $237,	$238,	 0,    0,    0,	   0,	 0, $236, $237,	$238,	 0,    0,    0,	   0,	 0, $240, $241,	$242,	 0,    0,    0,	   0; 10560
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 10624
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 10688
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 10752
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 10816
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 10880
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 10944
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 11008
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 11072
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 11136
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 11200
		dc.w	 0,    0,    0,	   0,	 0, $240, $241,	$242,	 0,    0, $26F,	$670,	 0, $24A, $24B,	$24C,	 0,    0, $26E,	   0,	 0, $254, $255,	$256, $25A, $25B, $25B,	$25B,	 0, $243, $26C,	$257, $264, $265, $265,	$266, $2FD, $243, $257,	$257, $25E, $273, $25F,	$260, $2FE, $243, $257,	$257, $267, $273, $268,	$260, $2FF, $253, $258,	$259, $25E, $273, $261,	$216, $217, $217, $228,	$229; 11264
		dc.w	 0,    0,    0,	   0, $244, $23B, $23C,	   0,	 0,    0,    0,	   0, $24E, $245, $246,	   0,	 0,    0,    0,	   0, $24E, $24F, $250,	$2FD, $2FC, $2FC, $2FC,	$2FC, $233, $234, $235,	$2FD, $2FC, $2FC, $2FC,	$2FC, $23D, $23E, $23F,	$2FD, $216, $217, $2FC,	$2FC, $247, $248, $249,	$2FE, $216, $221, $20E,	$20F, $210, $211, $232,	$2FF, $216, $221, $218,	$219, $21A, $21B, $217,	$217; 11328
		dc.w  $24A, $24B, $24C,	$230, $231,    0, $231,	   0, $254, $255, $256,	$244, $245, $23C, $246,	   0, $239, $24D, $262,	$24E, $235, $250, $24F,	$25A, $243, $26C, $257,	$233, $234, $235, $634,	$264, $243, $257, $26C,	$23D, $A3E, $228, $229,	$25E, $243, $257, $26C,	$247, $249, $228, $229,	$267, $253, $22A, $22B,	$247, $248, $226, $227,	$25E, $217, $22A, $22B,	$247, $232, $228, $229,	$267; 11392
		dc.w  $26F, $270,    0,	   0,	 0,    0,    0,	   0, $26D, $26E,    0,	   0,	 0,    0,    0,	   0, $25B, $25C, $25B,	$25D,	 0,    0,    0,	   0, $265, $265, $265,	$266,	 0,    0,    0,	   0, $25F, $25F, $25F,	$260, $2FC, $2FC, $2FC,	$2FC, $268, $268, $268,	$269, $20F, $210, $211,	$2FC, $26A, $26A, $216,	$217, $217, $21A, $21B,	$22A, $26A, $26A, $216,	$221, $221, $224, $225,	$22A; 11456
		dc.w  $244, $23B, $23C,	   0,	 0,    0,    0,	   0, $24E, $245, $246,	$26F,	 0,    0, $270,	   0, $24E, $24F, $250,	$230, $231,    0, $231,	   0, $233, $234, $235,	$244, $245, $23C, $246,	   0, $23D, $23E, $23F,	$24E, $23E, $250, $228,	$229, $247, $248, $249,	$247, $248, $235, $226,	$227, $22B, $232, $232,	$247, $232, $232, $228,	$229, $22B, $217, $217,	$217, $22A, $22B, $226,	$227; 11520
		dc.w	 0, $24A, $24B,	$24C,	 0,    0,    0,	   0,	 0, $254, $255,	$256,	 0,    0,    0,	   0,	 0, $239, $24D,	$262,	 0, $270,    0,	   0,	 0, $243, $26C,	$257, $23B, $246,    0,	   0,	 0, $243, $257,	$26C, $245, $246, $2FC,	$2FC, $2FD, $243, $257,	$26C, $234, $235, $2FC,	$2FC, $2FE, $253, $258,	$259, $20E, $20F, $210,	$211, $2FF, $216, $217,	$217, $218, $219, $21A,	$21B; 11584
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 11648
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 11712
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 11776
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 11840
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 11904
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 11968
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 12032
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 12096
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 12160
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 12224
		dc.w  $25E, $259, $258,	$22A, $22B, $221, $226,	$227, $21E, $21F, $220,	$22A, $22B, $21D, $21D,	$21D, $20C, $20D, $20C,	$20D, $20C, $20D, $20C,	$20D, $1FD, $1FD, $1FF,	$200, $1FD, $1FD, $1FD,	$1FD, $1FD, $1FD, $1FF,	$200, $1FD, $1FD, $1FD,	$1FD, $1FD, $1FD, $1FF,	$200, $207, $207, $207,	$207, $1FD, $1FD, $1FF,	$200, $208, $208, $208,	$208, $207, $207, $1FF,	$200, $212, $212, $212,	$212; 12288
		dc.w  $216, $221, $218,	$223, $224, $225, $221,	$221, $21E, $21F, $220,	$22D, $22E, $22F, $21D,	$21E, $20C, $20D, $20C,	$20D, $20C, $20D, $20C,	$20D, $1FD, $1FD, $1FD,	$1FD, $1FD, $1FD, $1FD,	$1FD, $1FD, $1FD, $1FD,	$1FD, $1FD, $1FD, $209,	$209, $207, $207, $207,	$207, $207, $207, $213,	$213, $208, $208, $208,	$208, $208, $208, $213,	$213, $212, $212, $212,	$212, $212, $212, $213,	$213; 12352
		dc.w  $221, $22A, $22B,	$20F, $210, $211, $227,	$25E, $21F, $220, $220,	$220, $22E, $22F, $229,	$21E, $20C, $20D, $20C,	$20D, $20C, $20D, $20C,	$20D, $1FD, $1FD, $1FD,	$1FD, $1FD, $1FD, $1FD,	$1FD, $20A, $20B, $1FD,	$1FD, $1FD, $1FD, $1FD,	$1FD, $214, $215, $207,	$207, $207, $207, $207,	$207, $214, $215, $208,	$208, $208, $208, $208,	$208, $214, $215, $212,	$212, $212, $212, $212,	$212; 12416
		dc.w  $261, $261, $216,	$221, $221, $22E, $22F,	$22A, $220, $220, $220,	$21D, $21E, $220, $220,	$220, $20C, $20D, $20C,	$20D, $20C, $20D, $20C,	$20D, $1FD, $1FD, $1FD,	$1FD, $1FD, $1FD, $1FD,	$1FD, $1FD, $1FD, $1FD,	$1FD, $1FD, $1FD, $1FD,	$1FD, $207, $207, $207,	$207, $207, $209, $20A,	$20B, $208, $208, $208,	$208, $208, $213, $214,	$215, $212, $212, $212,	$212, $212, $213, $214,	$215; 12480
		dc.w  $22B, $221, $221,	$221, $22A, $22B, $228,	$229, $22B, $220, $220,	$21D, $21E, $220, $220,	$220, $20C, $20D, $20C,	$20D, $20C, $20D, $20C,	$20D, $1FD, $1FD, $1FD,	$1FD, $1FD, $1FD, $1FD,	$1FD, $1FD, $1FD, $1FD,	$1FD, $1FD, $1FD, $1FD,	$1FD, $1FD, $1FD, $1FD,	$1FD, $1FD, $1FD, $1FD,	$1FD, $1EF, $1EF, $1EF,	$1EF, $1EF, $1EF, $1EF,	$213, $1FD, $1FD, $1FD,	$1FD, $1FD, $1FD, $1FD,	$1FD; 12544
		dc.w  $22A, $22B, $221,	$221, $218, $223, $224,	$225, $22A, $22B, $21D,	$21E, $220, $22D, $22E,	$22F, $20C, $20D, $20C,	$20D, $20C, $20D, $20C,	$20D, $209, $209, $20A,	$20B, $1FD, $1FD, $1FD,	$1FD, $213, $213, $214,	$215, $1FD, $1FD, $1FD,	$1FD, $213, $213, $214,	$215, $1FD, $1FD, $1FD,	$1FD, $213, $213, $214,	$215, $1FD, $1FD, $1FD,	$1FD, $213, $203, $603,	$215, $207, $207, $207,	$207; 12608
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 12672
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 12736
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 12800
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 12864
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 12928
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 12992
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 13056
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 13120
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 13184
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 13248
		dc.w  $1F4, $5F4, $1FF,	$200, $1FD, $1FD, $1FD,	$1FD, $1FE, $5FE, $1FF,	$200, $1F4, $5F4, $1F4,	$5F4, $1F4, $5F4, $1FF,	$200, $1FE, $5FE, $1FE,	$5FE, $1FE, $5FE, $1F0,	$1F1, $1EF, $1EF, $1FF,	$200, $1FF, $200, $201,	$202, $1F5, $5F5, $5E9,	$1E9, $5E9, $1E9, $1EF,	$1EF, $1EF, $1EF, $5E9,	$1E9, $5E9, $1E9, $213,	$213, $213, $213, $1FF,	$200, $5E9, $1E9, $213,	$213, $213, $213, $1FF,	$200; 13312
		dc.w  $1FD, $1FD, $1FD,	$1FD, $1FD, $1FD, $213,	$602, $1F4, $5F4, $1F4,	$5F4, $1F4, $5F4, $1F4,	$5F4, $1FE, $5FE, $1FE,	$5FE, $1FE, $5FE, $1FE,	$5FE, $1C1, $1C1, $1C1,	$1C1, $1C1, $1C1, $1C1,	$1C1, $1B7, $5B7, $1CB,	$1B7, $5B7, $1CB, $1B7,	$5B7, $1B7, $5B7, $5DC,	$1B7, $5B7, $1DC, $1B7,	$5B7, $1B7, $5B7, $DDA,	$1B7, $5B7, $9DA, $1B7,	$5B7, $1D8, $5D8, $1D6,	$1D8, $5D8, $1D6, $1D8,	$5D8; 13376
		dc.w  $201, $215, $1FD,	$1FD, $1FD, $1FD, $1FD,	$1FD, $1F4, $5F4, $1F4,	$5F4, $1EF, $1EF, $1F0,	$1F1, $1FE, $5FE, $1FE,	$5FE, $1F4, $5F4, $1F4,	$5F4, $1FF, $200, $1FF,	$200, $1FE, $5FE, $1FE,	$5FE, $5E9, $1E9, $5E9,	$1E9, $213, $213, $213,	$1E5, $5E9, $1E9, $5E9,	$1E9, $213, $213, $213,	$1E7, $5E9, $1E9, $5E9,	$1E9, $213, $213, $213,	$1E5, $1FF, $200, $1FF,	$200, $1C1, $1C1, $1C1,	$1E7; 13440
		dc.w  $1FD, $1FD, $1FD,	$1FD, $1FD, $213, $214,	$215, $1EF, $1EF, $1EF,	$1EF, $1F4, $5F4, $1F4,	$5F4, $1F4, $5F4, $1F4,	$5F4, $1FE, $5FE, $1FE,	$5FE, $1FE, $5FE, $1FE,	$5FE, $203, $603, $203,	$603, $1B7, $5B7, $1CB,	$1B7, $5B7, $1CB, $1B7,	$5B7, $1B7, $5B7, $5DC,	$1B7, $5B7, $1DC, $1B7,	$5B7, $1B7, $5B7, $DDA,	$1B7, $5B7, $9DA, $1B7,	$5B7, $1D8, $5D8, $1D6,	$1D8, $5D8, $1D6, $1D8,	$5D8; 13504
		dc.w  $207, $207, $207,	$207, $207, $207, $207,	$207, $1F4, $5F4, $1F4,	$5F4, $1F4, $5F4, $1F4,	$5F4, $1FE, $5FE, $1FE,	$5FE, $1FE, $5FE, $1FE,	$5FE, $1CF, $1D0, $1D1,	$1D1, $1D1, $1D1, $1D1,	$1D1, $1E6, $1DB, $5DB,	$1DC, $1DA, $1D7, $1D6,	$1E5, $1E8, $1CB, $1CB,	$1CB, $1D4, $1E2, $1E3,	$1E7, $1E6, $1E2, $1E3,	$1D4, $1DD, $1DD, $1DD,	$1E5, $1E8, $1F3, $1F3,	$1F3, $1F3, $1F3, $1F3,	$1E7; 13568
		dc.w  $1F4, $5F4, $1F4,	$5F4, $1F4, $5F4, $1F4,	$5F4, $1FE, $5FE, $1FE,	$5FE, $1FE, $5FE, $1FE,	$5FE, $1F4, $5F4, $1F4,	$5F4, $1F4, $5F4, $1F4,	$5F4, $1FE, $5FE, $1FE,	$5FE, $1FE, $5FE, $1FE,	$5FE, $213, $213, $1F2,	$213, $213, $1F2, $1FF,	$200, $1C1, $1C1, $1E0,	$1C1, $1C1, $1E0, $5E9,	$1E9, $213, $213, $1E1,	$213, $213, $1E1, $5E9,	$1E9, $1C1, $1C1, $1E0,	$1C1, $1C1, $1E0, $1FF,	$200; 13632
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 13696
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 13760
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 13824
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 13888
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 13952
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 14016
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 14080
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 14144
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 14208
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 14272
		dc.w  $5E9, $1E9, $1C1,	$1C1, $1C1, $1C1, $5E9,	$1E9, $5E9, $1E9, $213,	$213, $213, $213, $5E9,	$1E9, $5E9, $1E9, $213,	$213, $213, $213, $1FF,	$200, $5E9, $1E9, $213,	$213, $213, $213, $5E9,	$1E9, $5E9, $1E9, $213,	$213, $213, $213, $5E9,	$1E9, $5E9, $1E9, $213,	$213, $213, $213, $5E9,	$1E9, $5E9, $1E9, $213,	$213, $213, $213, $5E9,	$1E9, $5E9, $1E9, $1C1,	$1C1, $1C1, $1C1, $5E9,	$1E9; 14336
		dc.w  $1B7, $5B7, $1D7,	$1B7, $5B7, $1D7, $1B7,	$5B7, $1B7, $5B7, $5DC,	$1B7, $5B7, $1DC, $1B7,	$5B7, $1B7, $5B7, $1CB,	$1B7, $5B7, $1CB, $1B7,	$5B7, $1D1, $1D1, $1D1,	$1D1, $1D1, $1D1, $1D1,	$1D1, $5D0, $5CF, $1E2,	$1E3, $1E2, $1E3, $1CF,	$1D0, $1E2, $1E3, $1D4,	$1E2, $1E3, $1D4, $1E2,	$1E3, $1DD, $1DD, $1DD,	$1DD, $1DD, $1DD, $1DD,	$1DD, $1CB, $1DA, $1DB,	$5DB, $1DB, $5DB, $5DA,	$1CB; 14400
		dc.w  $5E9, $1E9, $5E9,	$1E9, $213, $213, $213,	$1E5, $5E9, $1E9, $5E9,	$1E9, $213, $213, $213,	$1E7, $1FF, $200, $1FF,	$200, $213, $213, $213,	$1E5, $1FF, $200, $1FF,	$200, $1C1, $1C1, $1C1,	$1E7, $5E9, $1E9, $5E9,	$1E9, $213, $213, $213,	$1E5, $5E9, $1E9, $5E9,	$1E9, $1C1, $1C1, $1C1,	$1E7, $5E9, $1E9, $5E9,	$1E9, $213, $213, $213,	$1E5, $5E9, $1E9, $5E9,	$1E9, $213, $213, $213,	$1E7; 14464
		dc.w  $1B7, $5B7, $1D7,	$1B7, $5B7, $1D7, $1B7,	$5B7, $1B7, $5B7, $5DC,	$1B7, $5B7, $1DC, $1B7,	$5B7, $1B7, $5B7, $1CB,	$1B7, $5B7, $1CB, $1B7,	$5B7, $1D1, $1D1, $1D1,	$1D1, $1D1, $1D1, $1D1,	$1D1, $5D0, $5CF, $1E2,	$1E3, $1E2, $1E3, $1CF,	$1D0, $1E2, $1E3, $1D4,	$1E2, $1E3, $1D4, $1E2,	$1E3, $1DD, $1DD, $1DD,	$1DD, $1DD, $1DD, $1DD,	$1DD, $1CB, $1DA, $1DB,	$5DB, $1DB, $5DB, $5DA,	$1CB; 14528
		dc.w  $1E6, $1B7, $5B7,	$1DE, $1DF, $1B7, $5B7,	$1E5, $1E8, $1B7, $5B7,	$1DE, $1DF, $1B7, $5B7,	$1E7, $1E6, $1B7, $5B7,	$1DE, $1DF, $1B7, $5B7,	$1E5, $1E8, $1D8, $5D8,	$1D6, $1D6, $1D8, $5D8,	$1E7, $1E6, $1B7, $5B7,	$1DE, $1DF, $1B7, $5B7,	$1E5, $1E8, $1B7, $5B7,	$1DE, $1DF, $1B7, $5B7,	$1E7, $1E6, $1B7, $5B7,	$1DE, $1DF, $1B7, $5B7,	$1E5, $1E8, $1DD, $1DD,	$1DD, $1DD, $1DD, $1DD,	$1E7; 14592
		dc.w  $1FF, $200, $1DD,	$1DD, $1DD, $1DD, $1DD,	$1DD, $5E9, $1E9, $213,	$213, $213, $213, $213,	$213, $5E9, $1E9, $213,	$213, $213, $213, $213,	$213, $5E9, $1E9, $213,	$213, $213, $213, $213,	$213, $5E9, $1E9, $213,	$213, $213, $213, $213,	$213, $5E9, $1E9, $213,	$213, $213, $213, $213,	$213, $5E9, $1E9, $213,	$213, $213, $213, $213,	$213, $1FF, $200, $213,	$213, $213, $213, $213,	$213; 14656
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 14720
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 14784
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 14848
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 14912
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 14976
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15040
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15104
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15168
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15232
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15296
		dc.w  $5E9, $1E9, $213,	$213, $213, $213, $5E9,	$1E9, $5E9, $1E9, $213,	$213, $213, $213, $5E9,	$1E9, $5E9, $1E9, $213,	$213, $213, $213, $5E9,	$1E9, $5E9, $1E9, $213,	$213, $213, $213, $5E9,	$1E9, $5E9, $1E9, $213,	$213, $213, $213, $5E9,	$1E9, $5E9, $1E9, $1FB,	$1FA, $1FA, $1FC, $5E9,	$1E9, $5E9, $1E9, $205,	$204, $204, $206, $5E9,	$1E9, $1FF, $200, $213,	$213, $213, $213, $1FF,	$200; 15360
		dc.w  $1D5, $1B7, $5B7,	$1D8, $5D8, $1B7, $5B7,	$1D5, $1D2, $1B7, $5B7,	$1D6, $1D6, $1B7, $5B7,	$1D2, $1D3, $1B7, $5B7,	$1DC, $1DA, $1B7, $5B7,	$1D3, $1E2, $1E4, $1E3,	$1D7, $1D7, $1E2, $1E4,	$1E3, $1D5, $1E5, $1C1,	$1C1, $1C1, $1C1, $1E6,	$1D5, $1D2, $1E7, $1DE,	$1DF, $1DE, $1DF, $1E8,	$1D2, $1D2, $1E5, $1DE,	$1DF, $1DE, $1DF, $1E6,	$1D2, $1D3, $1E7, $1DE,	$1DF, $1DE, $1DF, $1E8,	$1D3; 15424
		dc.w  $5E9, $1E9, $5E9,	$1E9, $213, $213, $213,	$1E5, $5E9, $1E9, $5E9,	$1E9, $213, $213, $213,	$1E7, $5E9, $1E9, $5E9,	$1E9, $213, $213, $213,	$1E5, $5E9, $1E9, $5E9,	$1E9, $213, $213, $213,	$1E7, $5E9, $1E9, $5E9,	$1E9, $213, $213, $213,	$1E5, $5E9, $1E9, $5E9,	$1E9, $213, $213, $213,	$1E7, $5E9, $1E9, $5E9,	$1E9, $213, $213, $213,	$1E5, $1FF, $200, $1FF,	$200, $213, $213, $213,	$1E7; 15488
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15552
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15616
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15680
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15744
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15808
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15872
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 15936
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 16000
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 16064
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 16128
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 16192
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 16256
		dc.w	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0,	 0,    0,    0,	   0; 16320
Map16_GHZ:	dc.w $4000,$4000,$4001,$4001,$4002,$4802,$4003,$4803,$4004,$4006,$4005,$4007,$4008,$400A,$4009,$400B,$400C,$400E,$400D,$400F,$4010,$4012,$4011,$4013,$4014,$4016,$4015,$4017,$4018,$401A,$4019,$401B,$401C,$401E,$401D,$401F,$4020,$4022,$4021,$4023,$4024,$4026,$4025,$4027,$4028,$402A,$4029,$402B,$402C,$402E,$402D,$402F,$4030,$4032,$4031,$4033,$4034,$4036,$4035,$4037,$4038,$400A,$4039,$400B; 0
					; DATA XREF: ROM:0001BFF0t
					; ROM:0001C050o
		dc.w $403A,$403C,$403B,$403D,$403E,$4040,$403F,$4041,$4042,$4044,$4043,$4045,$4046,$4842,$4047,$4843,$4048,$404A,$4049,$404B,$404C,$404E,$404D,$404F,$4050,$4052,$4051,$4053,$4054,$4056,$4055,$4057,$4058,$405A,$4059,$405B,$405C,$405E,$405D,$405F,$4060,$4062,$4061,$4063,$4064,$4066,$4065,$4067,$4068,$406A,$4069,$406B,$406C,$406E,$406D,$406F,$4070,$4072,$4071,$4073,$4074,$4076,$4075,$4077; 64
		dc.w $4078,$407A,$4079,$407B,$407C,$407E,$407D,$407F,$4080,$4082,$4081,$4083,$4084,$4086,$4085,$4087,$4088,$408A,$4089,$408B,$408C,$408E,$408D,$408F,$4090,$4092,$4091,$4093,$4000,$4094,$4001,$4095,$4008,$4096,$4009,$4097,$4098,$409A,$4099,$409B,$409C,$409E,$409D,$409F,$40A0,$40A2,$40A1,$40A3,$40A4,$402C,$40A5,$402D,$4030,$4034,$4031,$4035,$40A6,$40A8,$40A7,$40A9,$40AA,$40AC,$40AB,$40AD; 128
		dc.w $40AE,$40B0,$40AF,$40B1,$40B2,$40B4,$40B3,$40B5,$40B6,$40B8,$40B7,$40B9,$40BA,$40BC,$40BB,$40BD,$40BE,$40C0,$40BF,$40C1,$40C2,$40C4,$40C3,$40C5,$4064,$406E,$4065,$406F,$4070,$40C6,$4071,$40C7,$4080,$408A,$4081,$408B,$4090,$4802,$4091,$4803,$4000,$40C8,$4001,$40C9,$40CA,$40CC,$40CB,$40CD,$40CE,$40D0,$40CF,$40D1,$40D2,$40D4,$40D3,$40D5,$40D6,$40D8,$40D7,$40D9,$40DA,$40DC,$40DB,$40DD; 192
		dc.w $40DE,$40E0,$40DF,$40E1,$40E2,$40E4,$40E3,$40E5,$40E6,$40E8,$40E7,$40E9,$40EA,$40EC,$40EB,$40ED,$40EE,$40F0,$40EF,$40F1,$40F2,$40F4,$40F3,$40F5,$4042,$40F6,$4043,$40F7,$4002,$40F8,$4003,$40F9,$40FA,$40FC,$40FB,$40FD,$40F2,$40FE,$40F3,$40FF,$4100,$4102,$4101,$4103,$4104,$4106,$4105,$4107,$4108,$410A,$4109,$410B,$410C,$410E,$410D,$410F,$4110,$4112,$4111,$4113,$4114,$4116,$4115,$4117; 256
		dc.w $4118,$411A,$4119,$411B,$411C,$411E,$411D,$411F,$4120,$4122,$4121,$4123,$4124,$4126,$4125,$4127,$4128,$412A,$4129,$412B,$412C,$412E,$412D,$412F,$4130,$4132,$4131,$4133,$4134,$4136,$4135,$4137,$4936,$4138,$4937,$4139,$4000,$413A,$4001,$413B,$413C,$413E,$413D,$413F,$4140,$4142,$4141,$4143,$404C,$4144,$404D,$4145,$4146,$4148,$4147,$4149,$414A,$414C,$414B,$414D,$40FA,$414E,$40FB,$414F; 320
		dc.w $4150,$4150,$4151,$4151,$4152,$4154,$4153,$4155,$4156,$4158,$4157,$4159,$C15A,$C15C,$C15B,$C15D,$C15E,$C160,$C15F,$C161,$4162,$4164,$4163,$4165,$4166,$4168,$4167,$4169,$416A,$416C,$416B,$416D,$416E,$4170,$416F,$4171,$4172,$4174,$4173,$4175,$4176,$4178,$4177,$4179,$4176,$4976,$4177,$4977,$417A,$417C,$417B,$417D,$417E,$497E,$417F,$497F,$4180,$4182,$4181,$4183,$4184,$4984,$4185,$4985; 384
		dc.w $4186,$4188,$4187,$4189,$418A,$418C,$418B,$418D,$418E,$4190,$418F,$4191,$4192,$4194,$4193,$4195,$4176,$4976,$4177,$4977,$4196,$4996,$4197,$4997,$4198,$4998,$4199,$4999,$4198,$419A,$4199,$419B,$491E,$419C,$491F,$419D,$419E,$41A0,$419F,$41A1,$41A2,$41A4,$41A3,$41A5,$4974,$41A6,$4975,$41A7,$C1A8,$C1AA,$C1A9,$C1AB,$C1AC,$C1AE,$C1AD,$C1AF,$C1B0,$C1B2,$C1B1,$C1B3,$C1B4,$C1B6,$C1B5,$C1B7; 448
		dc.w $C1B8,$C1BA,$C1B9,$C1BB,$C1BC,$C1BE,$C1BD,$C1BF,$417E,$41C0,$417F,$41C1,$4008,$41C2,$4009,$41C3,$41C4,$41C6,$41C5,$41C7,$41C8,$41CA,$41C9,$41CB,$40B6,$41CC,$40B7,$41CD,$41CE,$41D0,$41CF,$41D1,$4000,$41D2,$4001,$41D3,$40B6,$C1CC,$40B7,$C1CD,$C1CE,$41D0,$C1CF,$41D1,$C000,$C1D2,$C001,$C1D3,$41D4,$49D4,$41D5,$49D5,$41D6,$41D8,$41D7,$41D9,$41DA,$41DC,$41DB,$41DD,$41DE,$41E0,$41DF,$41E1; 512
		dc.w $41E2,$41E2,$41E3,$41E3,$41E4,$41E6,$41E5,$41E7,$41E8,$41EA,$41E9,$41EB,$41EC,$41EE,$41ED,$41EF,$41F0,$41F2,$41F1,$41F3,$41F4,$4802,$41F5,$4803,$41F6,$41F8,$41F7,$41F9,$41E2,$41FA,$41E3,$41FB,$41FC,$41FC,$41FD,$41FD,$41FE,$4200,$41FF,$4201,$4202,$4204,$4203,$4205,$4206,$4802,$4207,$4803,$4208,$420A,$4209,$420B,$41D4,$420C,$41D5,$420D,$420E,$4210,$420F,$4211,$4212,$4214,$4213,$4215; 576
		dc.w $4216,$4218,$4217,$4219,$421A,$421C,$421B,$421D,$421E,$4190,$421F,$4191,$4002,$4220,$4003,$4221,$4222,$4224,$4223,$4225,$4226,$41FC,$4227,$41FD,$4228,$422A,$4229,$422B,$422C,$4802,$422D,$4803,$422E,$4230,$422F,$4231,$41FC,$4232,$41FD,$4233,$4234,$4802,$4235,$4803,$4236,$49FC,$4237,$49FD,$4238,$423A,$4239,$423B,$423C,$4802,$423D,$4803,$4002,$423E,$4003,$423F,$4222,$4224,$4223,$4225; 640
		dc.w $4226,$41FC,$4227,$41FD,$4240,$4242,$4241,$4243,$4244,$4246,$4245,$4247,$4248,$424A,$4249,$424B,$424C,$424E,$424D,$424F,$4030,$4250,$4031,$4251,$4252,$4A52,$4253,$4A53,$4254,$4254,$4255,$4255,$4256,$4A52,$4257,$4A53,$4258,$40A8,$4259,$40A9,$C13C,$C13E,$C13D,$C13F,$C140,$C142,$C141,$C143,$C146,$C148,$C147,$C149,$425A,$4802,$425B,$4803,$425C,$4802,$425D,$4803,$C162,$C164,$C163,$C165; 704
		dc.w $C166,$C168,$C167,$C169,$4000,$425E,$4001,$425F,$4260,$4262,$4261,$4263,$4264,$4266,$4265,$4267,$4268,$426A,$4269,$426B,$426C,$4000,$426D,$4001,$426E,$4270,$426F,$4271,$4272,$4274,$4273,$4275,$4276,$4278,$4277,$4279,$427A,$427C,$427B,$427D,$427E,$4000,$427F,$4001,$4280,$4282,$4281,$4283,$4284,$4286,$4285,$4287,$4288,$428A,$4289,$428B,$428C,$4000,$428D,$4001,$428E,$4000,$428F,$4001; 768
		dc.w $4000,$4290,$4001,$4291,$4292,$4294,$4293,$4295,$4296,$4298,$4297,$4299,$429A,$4000,$429B,$4001,$429C,$4000,$429D,$4001,$429E,$400A,$429F,$400B,$C000,$C25E,$C001,$C25F,$C260,$C262,$C261,$C263,$C264,$C266,$C265,$C267,$C268,$C26A,$C269,$C26B,$C26C,$C000,$C26D,$C001,$C26E,$C270,$C26F,$C271,$C272,$C274,$C273,$C275,$C276,$C278,$C277,$C279,$C27A,$C27C,$C27B,$C27D,$C27E,$C000,$C27F,$C001; 832
		dc.w $C280,$C282,$C281,$C283,$C284,$C286,$C285,$C287,$C288,$C28A,$C289,$C28B,$C28C,$C000,$C28D,$C001,$C28E,$C000,$C28F,$C001,$C000,$C290,$C001,$C291,$C292,$C294,$C293,$C295,$C296,$C298,$C297,$C299,$C29A,$C000,$C29B,$C001,$C29C,$C000,$C29D,$C001,$C29E,$400A,$C29F,$400B,$49CA,$49C8,$49CB,$49C9,$42A0,$40CC,$42A1,$40CD,$4038,$41C2,$4039,$41C3,$41C8,$42A2,$41C9,$42A3,$42A4,$42A6,$42A5,$42A7; 896
		dc.w $42A8,$42AA,$42A9,$42AB,$41A8,$41AA,$41A9,$41AB,$41AC,$41AE,$41AD,$41AF,$42AC,$42AC,$42AD,$42AD,$401C,$401E,$401D,$401F,$4020,$4022,$4021,$4023,$42AE,$41A0,$42AF,$41A1,$42B0,$42B2,$42B1,$42B3,$42B4,$42B6,$42B5,$42B7,$42B8,$42BA,$42B9,$42BB,$42BC,$4000,$42BD,$4001,$62BE,$62BE,$62BF,$62BF,$62C0,$62C2,$62C1,$62C3,$62C4,$62C6,$62C5,$62C7,$62C8,$62CA,$62C9,$62CB,$62CC,$62CE,$62CD,$62CF; 960
		dc.w $62D0,$62D2,$62D1,$62D3,$62D4,$62D6,$62D5,$62D7,$62D8,$62DA,$62D9,$62DB,$62DC,$62DE,$62DD,$62DF,$62E0,$62BE,$62E1,$62BF,$62E2,$62E4,$62E3,$62E5,$62E6,$62E8,$62E7,$62E9,$62EA,$62EC,$62EB,$62ED,$62EE,$62F0,$62EF,$62F1,$42F2,$42F4,$42F3,$42F5,$42F6,$42F8,$42F7,$42F9,$42FA,$42FC,$42FB,$42FD,$42FE,$4300,$42FF,$4301,$4302,$4304,$4303,$4305,$4306,$4308,$4307,$4309,$430A,$430C,$430B,$430D; 1024
		dc.w $430E,$4310,$430F,$4311,$4312,$4314,$4313,$4315,$4316,$4318,$4317,$4319,$431A,$431C,$431B,$431D,$431E,$4320,$431F,$4321,$4322,$4324,$4323,$4325,$4326,$4328,$4327,$4329,$432A,$432C,$432B,$432D,$432E,$4330,$432F,$4331,$4332,$4334,$4333,$4335,$4336,$4338,$4337,$4339,$433A,$433C,$433B,$433D,$433E,$4340,$433F,$4341,$4342,$4344,$4343,$4345,$4346,$4348,$4347,$4349,$434A,$434C,$434B,$434D; 1088
		dc.w $434E,$4350,$434F,$4351,$4352,$4354,$4353,$4355,$4356,$4358,$4357,$4359,$435A,$435C,$435B,$435D,$435E,$4360,$435F,$4361,$4362,$4364,$4363,$4365,$4366,$4368,$4367,$4369,$436A,$436C,$436B,$436D,$436E,$4370,$436F,$4371,$4372,$4374,$4373,$4375,$4376,$4378,$4377,$4379,$437A,$437C,$437B,$437D,$437E,$4380,$437F,$4381,$4382,$4384,$4383,$4385,$4386,$4388,$4387,$4389,$438A,$438C,$438B,$438D; 1152
		dc.w $438E,$4158,$438F,$4159,$4156,$4390,$4157,$4391,$4392,$4394,$4393,$4395,$4396,$4398,$4397,$4399,$5B98,$439A,$5B99,$439B,$439C,$439E,$439D,$439F,$63A0,$63A2,$63A1,$63A3,$63A4,$63A6,$63A5,$63A7,$63A8,$63AA,$63A9,$63AB,$63AC,$63AE,$63AD,$63AF,$43B0,$43B2,$43B1,$43B3,$43B4,$43B6,$43B5,$43B7,$43B8,$43BA,$43B9,$43BB,$43BC,$43BE,$43BD,$43BF,$43C0,$43C2,$43C1,$43C3,$43C4,$43C6,$43C5,$43C7; 1216
		dc.w $43C8,$43CA,$43C9,$43CB,$43CC,$4190,$43CD,$4191,$43CE,$43D0,$43CF,$43D1,$43D2,$43D4,$43D3,$43D5,$43D6,$43D8,$43D7,$43D9,$492A,$412A,$492B,$412B,$4180,$4980,$4181,$4981,$C180,$C182,$C181,$C183,$4046,$4842,$4047,$4843,$C002,$C802,$C003,$C803,$C1A2,$C1A4,$C1A3,$C1A5,$C3DA,$C802,$C3DB,$C803,$C000,$C3DC,$C001,$C3DD,$C000,$C3DE,$C001,$C3DF,$C99C,$C11E,$C99D,$C11F,$C3E0,$C3E2,$C3E1,$C3E3; 1280
		dc.w $4000,$43E4,$4001,$43E5,$42BE,$43E6,$42BF,$43E7,$43E8,$43EA,$43E9,$43EB,$4000,$43EC,$4001,$43ED,$43EE,$43F0,$43EF,$43F1,$43F2,$43F4,$43F3,$43F5,$43F6,$43F8,$43F7,$43F9,$43FA,$43FC,$43FB,$43FD,$43FE,$4400,$43FF,$4401,$8402,$8404,$8403,$8405,$8406,$8408,$8407,$8409,$840A,$840C,$840B,$840D,$640E,$6410,$640F,$6411,$6412,$6414,$6413,$6415,$433A,$4416,$433B,$4417,$42BE,$42BE,$42BF,$42BF; 1344
		dc.w $4418,$441A,$4419,$441B,$441C,$441E,$441D,$441F,$4420,$4422,$4421,$4423,$4424,$42BE,$4425,$42BF,$4426,$4428,$4427,$4429,$442A,$442C,$442B,$442D,$C2F2,$C2F4,$C2F3,$C2F5,$C2F6,$C2F8,$C2F7,$C2F9,$C2FA,$C2FC,$C2FB,$C2FD,$C002,$C42E,$C003,$C42F,$C430,$C432,$C431,$C433, $40A, $40C, $40B,	$40D,$4434,$42BE,$4435,$42BF,$4436,$4438,$4437,$4439,$443A,$443C,$443B,$443D,$443E,$4440,$443F,$4441; 1408
		dc.w $4442,$4444,$4443,$4445,$4446,$4448,$4447,$4449,$444A,$444C,$444B,$444D,$4C00,$4BFE,$4C01,$4BFF,$4BFC,$4BFA,$4BFD,$4BFB,$4C1A,$4C18,$4C1B,$4C19,$CC32,$CC30,$CC33,$CC31,$CC2E,$C802,$CC2F,$C803,$C44E,$C450,$C44F,$C451,$C452,$C454,$C453,$C455,$4456,$4458,$4457,$4459,$4000,$43DE,$4001,$43DF,$4000,$43DC,$4001,$43DD,$43DA,$4802,$43DB,$4803,$43E0,$43E2,$43E1,$43E3,$445A,$445C,$445B,$445D; 1472
		dc.w $445E,$4460,$445F,$4461,$4462,$4464,$4463,$4465,$CC58,$CC56,$CC59,$CC57,$C99C,$C11E,$C99D,$C11F,$4004,$4006,$4005,$4007,$400C,$400E,$400D,$400F,$4010,$4012,$4011,$4013,$4014,$4016,$4015,$4017,$4018,$401A,$4019,$401B,$4002,$4802,$4003,$4803,$C91E,$C19C,$C91F,$C19D,$C002,$C802,$C003,$C803,$492A,$412A,$492B,$412B,$4180,$4980,$4181,$4981,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001; 1536
		dc.w $4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001; 1600
		dc.w $4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001; 1664
		dc.w $4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001,$4000,$4000,$4001,$4001; 1728
Nem_GHZ:	dc.b $84,$66,$80,  3,  1,$14,  5,$25,$10,$34,  7,$46,$2F,$55,$14,$66,$35,$73,  0,$81,  4,  4,$16,$2B,$28,$F6,$38,$F2,$82,  5,$12,$16,$32,$38,$F3,$78,$EB,$83,  4,  6,$16,$31,$38,$F1,$84,  7,$74,$85,  6,$27,$17,$6F,$38,$F5,$86,  7,$6E,$78,$F4,$87,  6,$36,$17,$72; 0
					; DATA XREF: ROM:MainLoadBlockst
					; ROM:0001C04Co ...
		dc.b $88,  6,$33,$17,$70,$89,  6,$2E,$17,$76,$8A,  6,$26,$18,$F0,$8B,  6,$30,$17,$73,$8C,  6,$34,$18,$EF,$8D,  5,$16,$18,$EA,$8E,  5,$11,$18,$EE,$8F,  6,$2A,$17,$71,$FF,  0,  0,  0,  0,  0,  0,$F5,$F1,  0,$7A,  0,  0,  3,$D0,  1,$5E,$3B,$F9,  0,$3A,$DE,$67,$CF; 64
		dc.b $54,$99,$66,$39,$DC,$B3,$2D,$C0,  4,  2,$F6,$45,$42,$CF,$87,$85,$D9,$E1,$9D,$C0, $F,$D1,$4D,$E7,$9C,$26,$38,$2D,$D4,$43,$9A,$CC,$66,  0,$6A,$8E,$CE,$80,$B3,$A3,$B2,$1F,$D7,$7E,$B6,$35,  0,  0,  0,  0,  3,$C5,$E3,$AA,$45,$62,$62,$6A,$89,$EE,$31,  0,  0,  0; 128
		dc.b   0,$42,$2F,$18,$44,$D4,$B5,$51, $C,$56,$27,$F5,$DF,$BF,$8D,$40, $A,$64,  0,  0, $A,$64,$F5,$3D,$5A,$A5,$4B,$51,$A8,$C6,$A3,$E1,$3C,$C0, $F,$3F,$50,  0,  0,$7E,$8A,$DE,$B5,$42,$63,$82,$C6,$88,$6A,$59,$8C,$DC,$FF,$71,$84,$C0, $E,$B0,  0,  0,$75,$BE,$6F,$36; 192
		dc.b $A9,$9A,$E6,$66,$38,$4D,$2E,$12,$CC,  1,$D6,  0,  0, $F,$D1,$67,$E7,$34,$33,$37,$2E,$14,$43,$32,$E6,$73,$EE,$FD,$EC,$6A,  0,$75,$BD,$4F,$6D,$52,$A5,$A8,$DB,$45,$A9,$74,  0,$20,$17,$B2,$2A,$16,$78,$F1,$D2,$D1,$B6,$80, $F,$D1,$55,$E7,$68,$54,$62,$BA,$51, $D; 256
		dc.b $96,$A3,$50,  3,$54,$76,$74,  5,$9D,$1D,$90,$FE,$AA,$EE,$EB,$68,  0,$FF,$B8,  0,  0,$3F,$EE,$F6,$79,$B5,$49,$96,$C6,$D3,$C6,$A9,$FA,$8D,$40, $F,$F1,  0,  0,  0,$FE,$8A,$DF,$A2,$35,$42,$C7,$45,$8D,$10,$D4,$B6,$35,$77,$7E,$FE,$35,$52,$2F,$50,$85,$4F,$53,$C6; 320
		dc.b $15,$2D,$46,$A7,$40,  0,$83,  7,$AD,$82,$B2,  3,$1A,$9B,$42,$C8,$F5,$3C,$44,$40,$56,  0,  2,$8A,$8C,$15,$80,$29,  6, $F,$A5,$BB,$BB,$F8,$80,$3A,$C0,  2,$9A,$3D,$42,$16,$FD,$11,$B4,$A1,$A4,$2A,$5B,$1B,$3A, $A,$A3,$FB,$DE,$E0,  7,$5D,$34,$A5,$4F,$53,$E8,$F5; 384
		dc.b $52,$A7,$D0,$68,  2,$B0,$10,$E7,$C3, $C,$F9,$80,$3A,$C0,$1C,$B7,$F2,$DE,$3F,$EA,$3A,$C0,$1D,$60, $E,$B0,  7,$FD,$47,$FD,$47,$58,  3,$FE,$E0, $E,$B0,  0,$1F,$F5,$1D,$60, $E,$5B,$F9,$6F,  0,$75,$80,$17,$25,$C8,$7F,$D4,$75,$80,$3F,$69,$FB,$60,  3,$C5,$E3,$AA; 448
		dc.b $45,$62,$63,$52,$C5,$6A,  0,$20,$17,$B2,$2A,$16, $F,$57,$75,$A3,$68,$D4,  4,$22,$F1,$84,$4D,$4B,$55,$10,$C5,$62,$62,  0,$D5,$1D,$9D,  1,$67,$47,$64,  7,$F5,$DF,$AD,$8D,$40,$3C,$5E,$3A,$A4,$56,$26,$35,$2C,$56,$A0,  2,  1,$7B,$22,$A1,$60,$E9,  6,$54,$FD,$77; 512
		dc.b $EB,$7B,$84,$22,$F1,$84,$4D,$4B,$55,$10,$C5,$62,$62,  0,$D5,$1D,$9D,  1,$67,$47,$64,$10,$67,$4E,$EF,$DE,$F7,  7,$8B,$C7,$54,$8A,$C4,$C6,$A5,$8A,$D4,  0,$47,$67,$40,$59,$D1,$D9,  4,$19,$D0,$77,$7E,$F7,$B8,$3C,$5E,$3A,$A4,$56,$26,$35,$2C,$56,$A0,  2, $B,$D9; 576
		dc.b $15, $B,  7,$48,$32,$A2,$B0,$BF,$BB,$F7,$BD,$C0,  0,  0,  0,  0,$2F,$8D,$22,$7B,$97,$B9,$50,$2D,$41,$59,$52,$A0,$80,$B1,$64,  5,  1,$67,$41,$50,$37,$52,$A0,$6E,$5A,$A9,$72,$F7,$78,$34,$D1,  1,  0,$BD,$91,$50,$B0,$74,$83,$2A,$2B,  0,  1,$BA,$15,$2E,$97,$D5; 640
		dc.b $7C,$CB,$74,$E6,$EA,$A7,  0,$7F,$D4,  0,  0,$96,$B2,$9F,$CF,$7A,$CF,$49,$DE,$77,$9C,$CE,$BB,$FF,$4F,$23,$38,  3,$FE,$A0,  0,  0,$F5,$F3,$79,$E1,$3A,$CF,$7C,$F7,$CF,$36,$15,$4D,$9D,$B4,$B8,$20,  1,$18,$16,$28, $A,$2B,$41,$2F,$60,  5,$F1,$1A,$2D,$56,$BE,$A3; 704
		dc.b $64,$6B,$54,$D5,$8A,$54,$51,$58,$42,$AA,$22,$A3,$16,  1,$6B,$76,  0,$D5,$7C,$45,$4B,$52,$C6,$F8,$DE,$91,$B3,$75,$46,$A0,$35,$47,$67,$40,$59,$D1,$D9,  4,$19,$D0,  1,$63,$11, $A,$96,$C6,$2F,$DF,$D5,$8C,$40,$47,$67,$40,$59,$D1,$D9,  4,$19,$D0,  1,$63,$11,$4B; 768
		dc.b $18,$AD,$54,$D1,$7B,$FA,$9A,$A8,$84,  2,$F6,$45,$42,$C1,$D2, $C,$A8,$AC,  0,  6,$30,$A9,$74,$BE,$AB,$EC,$BA,$2C,$57,$F6,$8B,$60,  1,$F4,  0, $D,$52,$89,$44,$5F,$E3,$7E,$9E,  9,$44,$A2,$53,$77,$E9,$FF,$4D,$A5,$26,$A4,$C1,$7F,$4D,$B4,$CA,$81,$52,  8,$A9,  4; 832
		dc.b $54,$17,$D5,$7A,$53,$6A,$A1,$FA,$7C,$8C,$AA,$59,$52,$50,$B2,$CB,$5E,$EE,$3D,$5A,$45,$D9,$D0,$16,$74,$76,$41,  6,$74,  0,$54,$74,$17,$CA,$D2,$8A,$D5,$4D,$29,$A2,$D4,$3B,$FA,$B8,$F7,$3B,$3A,  2,$CE,$8E,$C8,$20,$CE,$80, $B,$18,$8B,$E5,$54,$B4,$5B,$52,$34,$8A; 896
		dc.b $D8,$77,$71,$EA,$EF,$17,$B2,$2A,$16, $E,$90,$65,$45,$60,  0,$31,$85,$4B,$A3,$CA,$C7,$25,$A9,$62,$BA, $A,$81,$EF,$EA,$D2,$AE,$E2,$80,$B3,$A3,$B2,  8,$33,$A0,  2,$C6,$22,$96,$31,$5A,$8F,$99,$8C,$AF,$8A,$D8, $E,$EE,$3D,$5D,$F7,$B2,$2A,$16, $E,$90,$65,$45,$60; 960
		dc.b   0,$31,$85,$4B,$A5,$F5,$5F,$6C,$A3,$96,$86,$54,$A8,  3,$A7,$EB,$74,$AB,$BA, $C,$E8,$EC,$82, $C,$E8,  0,$B1,$88,$A5,$8C,$56,$AA,$68,$BE,$71,$CA,$C0, $E,$EE,$3D,$5A,$58, $D,$51,$D9,$D0,$16,$74,$76,$41,  6,$74,  0,$60,$62,$21,$52,$D4,$62,$F3,$47,$AB,$18,$80; 1024
		dc.b $80,$5E,$C8,$A8,$58,$3A,$41,$95,$15,$80,  0,$C6,$15,$2C,$6F,$AA,$F9,$A3,$53,$46,$CB,$80,$48,$32,$A2,$B0,  0,$18,$C2,$A5,$D2,$FA,$AF,$B2,$E8,$B1,$16,$3D,$60, $F,$D6,$C7,$BE,$A8,$85,$67,$40,  5,$8C,$45,$2C,$62,$B5,$53,$4A,$68,$B5, $E,$B0,  4,$78,$E9,$68,$DB; 1088
		dc.b $44,$83,$2A,$2B,  0,  1,$8C,$2A,$5D,$2F,$AA,$FB,$2E,$8B,$11,$60,$7A,$C0,$1F,$AD,$8F,$7D,$51,$56,$74,  0,$58,$C4,$42,$A5,$B1,$88,$EF,$35,  0,$3A,$C0,$1F,$AF,$D3,$BB,$A9,$58,  0, $C,$61,$52,$E9,$7D,$57,$D9,$74,$58,$D8,  0,$7A,$C0,$1D,$5D,$DD,$FC,$40,$16,$31; 1152
		dc.b $14,$B1,$8A,$D5,$4D,$29,$A2,$D4,  0,$EB,  0,$71,$EF,$EE,$EA,  0,$3C,$61,$52,$E9,$7D,$57,$D9,$74,$58,$8B,  0, $F,$58,  3,$AB,$BB,$BF,$88,$15,$1D,$2F,$91,$95,$2C,$62,$B5,$53,$4A,$68,$B5,  0,  7,$58,  3,$8F,$7F,$77,$50,$B1,$88,$BE,$55,$4B,$45,$B5,$23,$48,$AD; 1216
		dc.b $80,  0,$75,$80,$3A,$BB,$BB,$F8,$87,$8C,$2A,$5D,$1E,$56,$39,$2D,$4B,$15,$D0,$54,  0,  0,$F5,$80,$3D,$40, $F,$FF,$70,  0,  0,$7F,$DC,  1,$EB,  9,  0,$3F,$C4,  0,  0,  3,$FE,$20,  1,$E8,$72,$59,  8,$4F,$49,$E1,$3A,$A3,$65,$B4,$B6,$90,$84,$E2,$13,$80,  1,$6F; 1280
		dc.b $E9,  0,$37,$ED,$FA,$5D,$80,  7,$FC,$5B,  9,$CC,$E6,$70,$F3,$99,$CC,$E0,$4E,$F2,$7F,$F1,$74,  0,$6D,$36,$D7,$73,$CE,$E3,$63,$15,$AA,$9A,$53,$45,$AB,$AC,  0,  0,$1D,$60,  9,$5A,$39,$69,$C4,$D5,$7D,$97,$45,$88,$B1,$EB,  0,  0,  7,$58,  3,$CF,$BA,$56,$BF,$4A; 1344
		dc.b $68,$B5, $E,$B0,  0,  0,$7F,$48,$C9,$77,$3C,$B7,  5,$DC,$64,$BD,$25,$9F,$49,$46,$D0,$D1,$62,$2C, $F,$58,  0,  0,$3A,$DF,$74,$24,$B2,$3B,$A1,$2B,$F7,$2C,$8F,$E5,$25,$D0,  1,$D6,  0,  0, $F,$E9,$19,$2E,$E7,$96,$E0,$BB,$8C,$97,$A4,$BF,$29,$20,  4,$3A,$C0,  0; 1408
		dc.b   1,$D6,$FB,$A1,$25,$91,$DD,  9,$5F,$B9,$64,$7F,$29,$2E,$80, $E,$B0,  0,$91,$90,$A4,$8C,$97,$71,$FD,$B4,$8E,$E9,$3C,$96,$40,$7E,$D0,  0,$FD,$60,  1,$B8,$EE,$14,$DC,$77,$2C,$8F,$ED,$A5,$D3,$74,$9F,$72,$EE,  1,$FF,$68,  0,$EB,$7D,$D0,$92,$C8,$EE,$84,$AF,$DC; 1472
		dc.b $B2,$86,$E0,  1,$F4,  0,$7E,$D0,  0,$FF,$D2,$32,$5D,$CF,$2D,$C1,$77,$19,$43,$72,$C8,  1, $F,$40,  3,$FE,$D3,$71,$DC,$29,$B8,$EE,$59,$1F,$DB,$4B,$A6,$E9,$3E,$E5,$DC,  0,  0,$7A,  0,$3F,$68,$37,$42,$4B,$2B,$E5,$7F,$E9,$BA,$7E,$58,$CB,$75,$24,  0,  0,$1F,$40; 1536
		dc.b   7,$8F,$A8,  0,  0,  0,  0,  8,$45,$E3,  8,$9A,$8C,$57,$B8,$D4,  0,  0,  0,  0,$BE,$2F,$1D,$52,$2B,$13,$1A,$96,$2B,$51,$E3,$FB,$EA,$A2,  0,  0,  0,  3,$C5,$E3,$AA,$45,$62,$63,$52,$C5,$6A,  7,$8F,$EF,$AA,$88,  0,  0,  0,$78,$BC,$75,$48,$AC,$4C,$6A,$58,$AD; 1600
		dc.b $40,$1E,$3F,$BE,$AA,$20,  0,  0,$10,$8B,$C6,$11,$35,$2D,$54,$43,$15,$89,$88,$1A,$A7,$1F,$DF,$71,  0,  0,  4,$22,$F1,$84,$4D,$4B,$55,$10,$C5,$62,$62,  6,$A8,$38,$FE,$FB,$88,  0,  0,$22,$BD,$C6,$A5,$AA,$88,$62,$B1,$31,  3,$54,  3,$8F,$EF,$B8,$80,  0,$84,$5E; 1664
		dc.b $30,$89,$A9,$6A,$A2,$18,$AC,$4C,$40,$D5,  0,$BD,$90,$F1,$FD,$75,$A3,$50,  0,$3C,$5E,$3A,$A4,$56,$26,$35,$2C,$56,$A0,  2,  1,$7B,$22,$A1,$67,$AB,$BA,$D1,$B4,$6A,$84,$5E,$30,$89,$A9,$6A,$A2,$18,$AC,$4C,$40,$D5,$1D,$9D,  1,$67,$47,$64,$10,$67,$40,$3B,$AC,$DD; 1728
		dc.b $5F,$AE,$84,$4D,$4B,$55,$10,$C5,$62,$62,  6,$A8, $A,$2B,$51,$9D,$1D,$90,$41,$9D,  0,  6,$36,$C6,$C9,$13,$55,$10,$C5,$62,$62,  6,$A8,  5,$67,$F4,$68,$20,$CE,$80, $B,$18,$8B,$EC,$9F,$A3,$B2,$45, $C,$56,$26,$20,$6A,$80,$5E,$C8,$A8,$59,$D2, $C,$A8,$AC,  0,  6; 1792
		dc.b $30,$A9,$74,$74,$8D,$91,$AD,$DC,  0,  0,  0,  0,$78,$9A,$96,$3A,$A4,$56,$26,$35,$2C,$5F,$8F,$EF,$AA,$88,  0,  0,  0,$78,$9A,$96,$3A,$A4,$56,$26,$35,$2C,$40,$82,$71,$FD,$F7,$10,  0,  0,$3C,$4D,$4B,$1D,$52,$2B,$13,$1A,$96,$20,$41,  0,$E3,$FB,$EE,$20,  0,$21; 1856
		dc.b $17,$8C,$22,$6A,$31,$AB,$B8,$C4,$C6,$A5,$88,  2,  8,$EC,$E8, $B,$3D,$5D,$DD,$51,$E2,  0,$78,$9A,$96,$3A,$A4,$56,$26,$35,$2C,$40,$82,  1,$7B,$22,$A1,$60,$E9,  6,$54,$FD,$77,$EB,$7B,$83,$C4,$D4,$B1,$D5,$22,$B1,$31,$A9,$62,  4,$10,$3B,$3A,  2,$CE,$8E,$C8,$20; 1920
		dc.b $CE,$83,$BB,$A9,$AC,$91,$31,$D5,$22,$B1,$31,$A9,$62,  4,$10,  0,$EC,$E8, $B,$3A,$3B,$20,$83,$3A,  8,$A3,$5B,$14,$35,$2C,$40,$10,$47,$67,$40,$5A,$F4,$3F,$A3,$45,$42,$C1,$D2, $C,$A8,$AC,  0,$BE,$BF,$14,  8,  5,$EC,$8A,$85,$83,$A4,$19,$53,$54, $A,$CE,$80, $B; 1984
		dc.b $18,$8B,$F4,$4B,$7E,$8E,$B7,$67,$40,$59,$D1,$D9,  4,$19,$D0,  0,  3,$C6,$15,$2E,$97,$D5,$7D,$97,$45,$8A,$F7,$71,$EA,$4D,$1D,$9D,  1,$67,$47,$64,$10,$67,$40,  0,$A8,$E9,$7C,$8C,$A9,$63,$15,$AA,$9A,$53,$45,$AB,$4E,$A8,$E9,$57,$72,$3B,$20,$83,$3A,  0,$2C,$62; 2048
		dc.b $29,$63,$15,$AA,$9A,$53,$45,$AB,$AC,  1,$C7,$BC,$C7,$AA,$A5,$D2,$FA,$AF,$B2,$E8,$B1,$5F,$E9,$55,$20,  0,  0,$75,$BE,$E8,$49,$64,$77,$42,$57,$EE,$C5,$1B,$7B,$4E,  0,  0,  0,  0,$14,$AA,$91,$78,$BD,$4B,$15,$8F,$10,  0,  0, $A,$54,$F1,$10,$8B,$C5,$EA,$84,$56; 2112
		dc.b $26,$2E,$82,$35,$7E,$FB,$88,  0,$52,$AA,$45,$E2,$F5,$3C,$69,$17,$A8,$54,  2,$B0,$10,$E3,$DD,$68,$F1,$A5,$4F,$11,  8,$BC,$5E,$A8,$45,$62,$62,$E8,  0,$10,$60,$F5,$B0,$56,$40,$6A,$8B,$58,$B2,$3C,$5E,$A1,$50, $A,$C0,  0,$51,$51,$82,$B0,  5,$20,$C1,$EB,$F1,$AC; 2176
		dc.b   8,$30,$7A,$D8,$2B,$20,  0,$A5,$11,$D8,$DA,$11,$84,$81,$B3,$E9,$7C,$61,$56,$89,$D4,$6A,$EE,$A2,$2A,$30,$56,  0,$A4,$18,  7,$43,$15,$D2,$9A,$2D,$46,$DA,$E5,$A6,$46,$54,$B1,$A8,$6B,$1A,$BB,$ED,$1B,$68,$12,$88,$EC,$6A,$86,$90,$90,$35,$3C,$6F,$D2,$16,$35,$2C; 2240
		dc.b $40,$10,$EB,  0,$69,$6E,$EE,$FE,$28,$74,$58,$D2,$2B,$63,$56,$B9,$47,$23,$2A,$54,$6C,  0,  3,$5E,$B0,  7,$58,  3,$AC,  0,  0,$A6,$E3,$97,$4F,$D1,$6E,$90,$DC,$F2,$BF,$74,$25,$D2,$5F,$94,$90,  2,$1D,$60,  0,$BB,$96,$54,$92,$C8,$EE,$A4,$BF,$2C,$7F,$2C,$77,$53; 2304
		dc.b $A1,$90,$10,$FD,$A0,$14,$91,$C8,$FE,$8B,$74,$84,$9F,$75,$F2,$86,$E3,$25,$DC,  0,$87,$A0,  3,$F6,$94,$92,$EE,$A6,$E5,$DC,$65,$49,$7E,$5B,$A7,$E5,$A5,$BA,$92,$3B,$80,  0,$6B,$E8,  0,$F4,  0,$7A,  0,  0,  3,$D1,$EC,$F8,$6A,$98,$2D,$8D,$B7,$69,$6D,$DC,$F7,$60; 2368
		dc.b   0,$F4,  0,  0,  7,$E9,$B0,$FD,$B5,$A1,$81,$99,$74,$A2,$1B,$2E,  7, $F, $E,$7D,$5A,$58,  1,$E8,$F8,$3D,$B5,$4B,$2E,  7, $D,$16,$CB,$30,  1,  0,$BD,$91,$50,$B3,$E9,$D5,$1C,$33,$C2,$60,  7,$E9,$AD,$FB,$6C,$21,$63,$A2,$CD,$44,$38,$2D,$8D,$80,$1A,$A3,$B3,$A0; 2432
		dc.b $2C,$E8,$EC,$87,$F5,$79,$F7,$5B,$40,  7,$ED,$AD,$FA,$63,$6D,$52,$CB,$81,$C3,$45,$B2,$CC,  0,$40,$2F,$64,$54,$2C,$1F,$4E,$A8,$E1,$9E,$13,  1, $B,$3D,$BF,$2C,$70,$DD,$36,$E3,$35,$10,$E0,$B6,$36,  0,$6A,$8E,$CE,$80,$B3,$A3,$B2,  3,$E1,$9F,$EA,$E6,$C0,  0,$5B; 2496
		dc.b $FA,$40,  0,  0,$2D,$FD,$20,  2,$E4,$B2,$60,  7,$F8,$98,  0,  0,$1F,$E2,$60,  7,$97,$E9,$7A,  0,$F6,$86,$EC,$3F,$2C,$7F,$4C,$52,$CB,$81,$C3,$45,$B2,$CC,  0,$40,$2F,$64,$54,$2C,$1D,$20,$CA,$9F,$AD,$8F, $E,$62,$16,$7B,$43,  3,$32,$E9,$B9,$77,$1D,$C8,$70,$5B; 2560
		dc.b $1B,  0,$35,$47,$67,$40,$59,$D1,$D9,  4,$19,$D0,$A7,$8D,$60,$20,$56, $A,$97,$B3,$A3,$3A,  4,$76,  0,$6B,$13,$51,$A8,$2C,$4D,$46,$D2,$EE,$FC,$B7,$E5,  0,$1E,$80,  0,  0,$F4,$10,$B3,$DA,$18,$19,$8D,$59,$71,$E9,$1E,$80, $A,$64,  0,  0, $A,$64,  0,$7F,$50,  7; 2624
		dc.b $9F,$A8,  0,  0,$3C,$FD,$44,$2A,$7A,$A1,$31,$C0,$DB,$2B,$60,$93,$20,$7C,$1E,$D4,$DC,$96,$DC,$70,$DD,$84,$CB,$82,$E8,  0,$47,$67,$40,$59,$D1,$D9,  4,$19,$D0,$73,$E1,$DD,$D5, $C,$1F,  8,$58,$E8,$B3,$51, $E, $B,$63,$60,$35,$47,$67,$40,$59,$D1,$D9,  4,$19,$D0; 2688
		dc.b  $E,$A8,$B7, $E,$76,$86,  6,$65,$D2,$88,$6C,$B8,$1C,  0,$D5,  1,$45,$6A,$33,$A3,$B2,  8,$33,$A0,  0,$E1,$9E,$31,$4B,$19,$A8,$87,  5,$B1,$B0,$1A,$A0,$15,$9F,$D1,$A0,$83,$3A,  0,$2C,$62,$2F,$B2,$1C,$73,$4C,$10,$D9,$70,$38,  1,$AA,  1,$7B,$22,$A1,$67,$48,$32; 2752
		dc.b $A2,$B0,  0,$18,$C2,$A5,$D1,$F8,$E9,$55,$B4,$4A,$8C,$68,$86,$A5,$A8,$D4,  6,$A8,  5,$67,$F4,$68,$20,$CE,$80, $B,$18,$8B,$EC,$92,$C6,$E4,$99, $D,$4B,$31,$98, $D,$50, $B,$D9,$15, $B,$3A,$41,$95,$15,$80,  0,$C6,$15,$2E,$8F,$D3, $C,$FA,$18,$F5,  0,$3D,  0,  0; 2816
		dc.b   1,$FB,$6C,$37,$4D,$B8,$E1,$AA,$60,$B6,$36,$99,$70,$7E,$FE,$AE,$73,$60,  0,$F4,  0,  0,$F6,$3A,$2E,$14,$DC,$98,$6E,$36,$36,$D1,$6C,  4,$13,$C3,$9F,$57,$78,  3,$D0,  0,$F8,$19,$96,$DA,$A5,$97,  3,$86,$8B,$60,$20,$80,$77,$F5,$73,$F0,  0,$7A,  8,$60,$F8,$42; 2880
		dc.b $C7,$43,$84,$DC,$CD,$8D,$A6,$5C,  0,$10,$47,$67,$40,$59,$E6,$E7,$9C,$6D,$DE,  0,$FD,$B5,$B7,$69,$B8,$DB,$54,$B2,$E0,$70,$D1,$6C,  4,$10, $B,$D9,$15, $B,  7,$48,$32,$A7,$EB,$63,$C3,$98,$7C, $C,$CB,$6A,$6E,$4B,$6E,$38,$1C,$26,$5C,  0,$82,  7,$67,$40,$59,$D1; 2944
		dc.b $D9,  4,$19,$D0,$73,$E0,$D1,$4B,$1C,$35,$4C,$16,$C6,$D3,$2E,  0,$41,  0, $E,$CE,$80,$B3,$A3,$B2,  8,$33,$A0,$B2,$34,$71,$43,$A2,$D8,  1,  4,$76,$74,  5,$AF,$43,$FA,$34,$54,$2C,$1D,$20,$CA,$8A,$C0, $A,$61,$C3,$BB,$A8,$E1,$46,$38, $A,$31,$C3,$F6,$CE,$81,  2; 3008
		dc.b $2B,$5E,$86,$A0, $D,$4F,$A4,$3D,$42,$D4,$2F,$F3,$FD,$A0,  3,$D0,  0,$10,$20,$4B,$FF,$4B,$D3,$F6,$CE,$81,  2,$1F,$DA,$7E,$9F,$70,  3,$D0,  0,$29,$33,$D8,$43, $F,$D3,$1C,$37,$42,$68,$59,$70,$38,$3A, $B,$69,$D5,$CF,$C0,  1,$E9,$4D,$29,$67,$C1,$F4,$7B,$53,  7; 3072
		dc.b $98,$4C,  2,$B0,$10,$F0,$E7,$1B,$77,$D3,$47,$C0,$42,$DF,$A6,$36,$DD, $D,$21,$82,$D8,$D9,$D0,  0,$20,$C1,$EB,$60,$AC,$80,$E9,$66,$89,$64,$7B,$3E,$83,$40,$15,$80,  0,$A2,$A3,  5,$60, $A,$41,$83,$E1,$37,$6E,$FE,$23,$A0,$E8,$3F,$AA,$A8,$10, $E,$80,$74,  3,$A4; 3136
		dc.b $E3,$54,$1E,$5F,$B4,  0,$7F,$D4,  0,  0,$1F,$F5,  0,$79,$FA,$80,$F5,$42,$56,$C8,$FE,$88,$A5,$4B,$63,$68,$AD,$4B,$A0,  1,  0,$BD,$91,$50,$B0,$74,$83,$2A,$71,$B7,$EB,$B8,$88,$59,$EA,$85,$8C,$56,$32,$59,$19,$21,$A9,$6A,$36,  0,$6A,$8E,$CE,$80,$B3,$A3,$B2,  8; 3200
		dc.b $33,$A7, $E,$7D,$BC,  0,$1D,$6F,$9B,$CD,$AA,$4C,$B9,$9C,$F0,$59,$96,$E0,  2,  1,$7B,$22,$A1,$67,$C2,$6C,$F0,$CF,  9,$B0,  0,$7E,$8B,$3F,$3C,$E1,$31,$B9,$6E,$A2,$19,$96,$63,$98,  3,$54,$76,$74,  5,$9D,$1D,$90,$FE,$AA,$EE,$FA,$A2,$7D,$35,$DB,$59,$FF,$4F,$FB; 3264
		dc.b $43,$FA,$5F,$10,  0,  0,  0,$3C,$BF,$69,$E8,  7,$ED,$3F,$6F,$E3,$EA,  0,  0,  0,  5,$78,$FA,$EE,$DB,$24,$74,$DD,$B1,$4B,$D3,$71,$42,$9E,$B2,$9F,$F2,$DC,$95,$21,$3B,$ED,$25,$9F,$A2,$A3,$CE,  0,$D7,$77,$A8,  0,  0,$21,$BB,$D4,  0,  0,$10,$DD,$EA,  0,$84,$FF; 3328
		dc.b $A2,$E8,  0,  0,  0,  0,  3,$F9,$FF,$AE,$43,$65,$AC,$C6,$A9,$7E,$FE,$20,  1,$54,$69,$5D,$51,$D5,$2A,$8C,$12,$CA,$95,$45,$6C,$E8,$A9,$63,$6B,$FF,$5B,$5B,$14,$95,$91,$E4,$52, $D,$25,$64,$85,$6A,$8B,$1B,$69,$D5,$DC,$94,$8E,$A9,$4A,$A9,$1D,$52,$91,$D5,$29,$17; 3392
		dc.b $B5,$56,$87,$51,$42,$C8,$7F,$5A,$DA,$B4,$10,$5E,$8D,$7B,$6B,$1D,$2D,$1F,$D7,$9B,$6A,$C2,$DA,$B5,$B5,$61,$6D,$58,$59,$7D,$95,$A3,$57,$B7,$8A,$1C,$55,  0,$A5,$6C, $D,$BF,$5D,$76,$7C,$F5,$DD,$4D,$D4,$DC,$BF,$B6,$E9,$FA,$28,$6E,$A6,$EA,$6E,$A6,$E0,  6,$BD,$60; 3456
		dc.b  $E,$31,$6D,$13,$A9,$8A,$7E,$B6,$F4,$AA,$B7,$62,$C9,  6,$83,$2B,$23,$B5,$66,$B8,$77,$C2,$B8,$77,$C1,$1F,$BC,$77,$80,  0,$EE,$B6,$9D,$5D,$CA,$D5,$82,$CE,$D5,$D1,$AB,$C4,$34,$1A,$B5,$68,$31,$45,$68,$21,$45,$65,$65,$AC,$B2,$F7,$AA,$16,$87,$79,$42,$CF,$DF,$5D; 3520
		dc.b $3B,$C2,$7E,$97,$C4,$F4,$1D,  7,$41,$2F,$D3,$5F,$D0,$6E,$1B,$80,  2,$99,  0,$3C,$FF,$68,  0,$F4,  0,$6E,$1B,$86,$E1,$B9,$FC,$F6,$FD,$35,$E8,$10,$20,  0,$79,$FA,$80,  0,  3,$CF,$D4,  0,$FE,$A0,  0,  0,  0,  0,$30,$CF, $B,$A6,$BB,$3C,$11,$AB,$64,$62,$C8,$52; 3584
		dc.b $45,$19, $B,$57,$FC,$34,$2D,$FC,$1C,$53,$C4,$A2,$D6,$B8,$A7,$E8,$FC,$9B,$D9,$95,$90,$E2,$71,$42,$DF,$C1,$C5,$31,$38,$D6,$D5,$B5,$78,$9C,$4E,$28,$7D,$95, $A,$7E,$8E,$BF,$D1,$FB,$62,$90,$C5,$50,$A4,$95,$BD,$8B,$57,$89,$C5, $B,$56,$D5,$E2,$8C,$51,$8A,$2A,$62; 3648
		dc.b $71,$4C,$4F,$93,$7B,$31,$C5, $B,$14,$6A,$CB,$26,$2B,$8A,$31,$AD,$AB,$6A,$F1,$4C,$4E,$35,$B7,$F0,$58,$A7,$F0,$D3,$1F,$22,$C5,$3F,$46,$58,$B2,$FB,$32,$B1,$C7,$D9,$BC,$8B,$2F,$F0,$CB,$43,$C8,$FB,$7E,$8C,$A6,$25, $D,$66,$55,$B2,$63,$84,$CC,$99,$DC,$70,$9B,  4; 3712
		dc.b $B9,$73,$33,$65,$C0,$E1,$35,$C9,$77,  3,$84,$D7,$70,$E7,$7E,$75,$F6,$5F,$DD,$76,$C2,$E9,$4D,$DB,$38,$36,$72,$32,$CC,$B1,$46,$32,$46,$45,$46,$42,$8C,$AC,$8C,$A9,$8A,$2F,$E8,$D0,$B1,$43,$24,$35,$E3,$5B,$23,$57,$89,$93,$70,$BB,  4,$BA,$6C, $F,$39,$AE,$C0,$F0; 3776
		dc.b $CA,$63,$81,$E1,$72,$5D,$32,$F3,$E1,$74,$DD,$AB,$CE,$1D,$BF,$75, $C,$FB,$4D,$2B,$B0,$5B,$96,$57,$20,$29,  4,$28, $B,$16,$83,  2,$85, $B,$14,  5,$8B,$14,$2C, $A,$41,$8A,  2,$C5, $A,$16,$78,$BA,$16,$82,$2C,$69,$28,$A4,$50,$C8,$41,$8A,$16,  5,$8A,$41,  1,$42; 3840
		dc.b $C5,$8B,  2,$D0,$42,$82,  9,  6,  5,$20,$C5,$23,  8,$9A,$95,$8B,$14,$2C,$86,$37,$D5,$28,$B4,$5A,$A0,$A8,$58,$A1,$40,$5A,$F6,  5, $A,$16,$28, $B,$16,$28,$58,$14,$83,$14,  5,$8A,$41,$9E,$2E,$85,$8A,$14,$58,$EB,$14,$8B,$19,  2,$C5,$8A,$16,  5, $A,$16,$28, $B; 3904
		dc.b $41, $B,  8,$31,$62,$80,$A4,$10,$5E,$85,$8C,$A3,  8,$9A,$95,$8B,$14,$2C,$86,$37,$A6,$E9,$6C,$76,$33,$AA,  4,$6B,$DA,  8,$1D,$1D,$A0,$8D,$7B,$42,$B6,$A2,$41,$20,$C5,$95,$1A,  8,$59,$D9,$19,$D8,$B2,$32,$2A,$31,$45,$46,$D1,$24,$C9,  8,$D6,$CB,$26,$85,$6C,  0; 3968
		dc.b $7A,$D8,$2B, $A,$32,$D6,$C0,$B1,$60,$EC,$5A, $C,$AD,$7B,$41,$9D,$8B,$5A,$3A,$49, $C,$8E,$8B,$A1,$92,$5F,$A2,$A5,$F2,$AD,$63,$AA,$45,$64,$65,$52,$C5,$64,  0,$40,$2F,$64,$54,$2C,$1D,$20,$CA,$8D,$26,$2C,$7B,$9E,$56,$5A,$CB,$69,  9,$42,$26,$A5,$95,$10,$B2,$C4; 4032
		dc.b $C4,  1,$AA,$3B,$3A,  2,$CE,$8E,$C8,$20,$CE,$9D,$DF,$BD,$EE,  0,  0,  0,$D6,$57,$D5,$2B,$3C,$AC,$6C,$F5,$7E,$B1,$ED,$8D,$3A,$9B,$5B,$52,$35, $D,$53,$54,$D6,$5A,$B6,$A8, $F,$1B,$EA,$5E,$25,$A9,$54,$90,$DA,$FA,$F4,$FE,$8D,$FE,$2B,$8D,$91,$AD,$8F,$51,$AE,$A9; 4096
		dc.b $37,$EB,$A4,$80,$6A,$8E,$CE,$80,$B3,$A3,$B2,$41,$9D,  0, $F,$A4,$2C,$B1,$BE,$D7,$D4,$B1,$5D,$17,$BF,$AB,$8A,$54,$35,$40,$2F,$64,$54,$2C,$1D, $B,$45,$B4,$AA,$36,$BE,$57,$E9,$23,$25,$8E,$E9,$FF,$4F,$2A,$A5,$D3,$F6,$E0, $E,$EE,$3D,$5D,$E2, $C, $B,$21,$40,$8A; 4160
		dc.b $D1,$85,$57,$A3,$C7,$75,$A1,$54,$37,$5B,$5D,$D5,$65,$A6,$E8,$4F,$CA,$77,$FD,$BF,$ED,  0,$1D,$FD,$5C,$62,$51,$58,$B2,$5E,$DA,$41,$1E,$A5,$B3,$45,$72,$7D,$24,$B6,$DD,$1D,$D2,$BF,$75,$FB,$80,$10,$FD,$BF,$ED,$3F,$6E,  0,$FD,$A0,  1,$FD,  0,  0, $F,$DB,$BF,$ED; 4224
		dc.b $FF,$68,  0,$7F,$DA,  0,$3D,  0,  0,  7,$FD,$BF,$E5,$3F,$2D,$CB,$78,  3,$25,$C8,  0,$BD,$60,  1,$4D,$CB,$25,$DD,$49,$43,$77,$4D,$D2,$FC,$B1,$FC,$B0,$5D,$C2,$FF,$DA,  0,$1F,$AC,  1,$B9,$77,$79,$AE,$E1,$4D,$D4,$F4,  0,$3F,$ED,  0,$1D,$60, $F,$3F,$DB,  0,$3D; 4288
		dc.b   0,$1F,$B6,$F3,  0,$75,$80,  0,  3,$AC,  1,$92,$E4,  0,$5E,$B0,  0,  0,$75,$80,$32,$5C,$80, $B,$D6,  0,$7F,$DB,$80,$3F,$EA,  0,$F2,$F3,  0,$7A,  0,  0,$1F,$B7,$7D,$EB,$5F,$E5,  0,$19,$72,$AF,$F2,$80, $F,$40,  0,  1,$FF,$6F,$FB,$40,  5,$37,$AE,$F0,  7,$FD; 4352
		dc.b $40,$19,$7A,$E4,  0,$EB,  0,$6F,$E5,$90,  1,$7F,$EA,  0,$F3,$F5,  0,$75,$80,$17,$25,$C8,  1,$D6,  0,  0, $E,$B0,  2,$E4,$B9,  0,$3A,$C0,  0,  1,$D6,  0,$5C,$97,$20,  7,$5E,$AD,$46,$A6,$D4,$DA,$FE,$4F,$29,$FF,$AD,$B0,$1A,$FA, $A,$F9,$6F,$D5,$8A,$43,$66,$BF; 4416
		dc.b $68,$21,$92,$7E,$DB,$7B,$3C,$85,$24,$28,$8F,$FA,$6F,$E2,$AC,$85,$25,$4D,$DF,$E5,$40,  0,$D7,$FE,$A0,  0,  7,$98,$F5,  0,  0,  7,$58,  0, $E,$B0,  7,$58,$5C,$97,$20,  7,$58,  0, $E,$B0,  7,$58,$5C,$BF,$29,$F9,$6D,$52,$89,$44,$5F,$DB,$74,$FD,$2C,$12,$89,$44; 4480
		dc.b $A2,  0,$35,$FF,$A8,  2,$35,$57,$D3,$9F,$42,$C7,$8A,$D4,$92,$AA,$F4,$BE,$C7,$FA,$3A,$27,$E8,$EF,$64,$B6,$2A,$D5,$9E,$AC,$6C,$5A,$1D,$40,$A6,$A9,$AC,$B5,$6D,$50,$6B,$54,$69,$2D,$6D,$2A,$AF,$B1,$B4,$9F,$F5,$95,$5F,$8D,$9D,$BA,$AF,$B0,  0,  0,  6,$BE,$3E,$50; 4544
		dc.b $95,$25,$49,$5F,$23,$FC,$23,$2B,$E5,$49,$52,$50,$92,$CA,$12,$59,$42,$45,$A5,  9,$16,$79,$16,$5C,$8C,$99,$E4,$51,$E4,$52,$89,$AA,$78,$D6,$65,  9,$14,$94,$24,$51,$E4,$51,$72,$32,$47,$91,$67,$91,$6A,$35,$18,  0,  0,$1A,$C6,$AF,$DF,$71,  8,  0,$46,  5,$8A,  3; 4608
		dc.b $A1,$8B,$68,$C5,$21,$18,$55,$BA,$DF,$96,$BF,$72,$CF,$A2,$FE,$D3,$69,$55,$2A,$48,  2,$97,$26,$6D,$73,$5C, $A,$41, $A,  2,$C5,$A0,$C0,$A1,$42,$C5,  1,$62,$C5, $B,  2,$90,$62,$80,$B1,$42,$85,$81,$42,$D0,$40,$64,$50,$A1,$90,$83,$14,$2C, $B,$14,$82,  2,$85,$8B; 4672
		dc.b $16,  5,$A0,$85,  4,$12, $C, $A,$41,$8A,  2,$C5,$8A,$16,  6,$45,$8B,  8,$21,$62,$85,  1,$6B,$D8,$14,$28,$58,$A0,$2C,$58,$A1,$60,$52, $C,$50,$16,$29,  6,  5, $B,$14,$28,$20,$85,$8C,$81,$62,$C5, $B,  2,$85, $B,$14,  5,$A0,$85,$84,$18,$B1,$40,$52,  8,$2F,$42; 4736
		dc.b $C6,$40,$B1,$62,$85,$85,$46,$2D,$16,$A8,$2A,$41, $A,  2,$C5,$A0,$D4,$45,$42,$85,$8A,  4,$F1,$4A,$9A,$D7,$C9,$51,$74,$62,$8B,$13,$39,$D8,$C9,$A4,$9B,$26,$CC, $A,$16,$82,  8,$CA,$A4,$B2,$69,$21,  6,$28,$5A,$88,$51,$8A,$41,$1D,$9D, $B,$16,$2C,$F1,$36,$56,$A9; 4800
		dc.b $53,$72, $A,$8C,$93,$72,$B4,$E7,$6B,$F6,$4D,$8F,$46,$E8,$80,$B1,$62,$85,$86,$92,$B3,$54,$D1, $A,$85,$8A,$14,  5,$AF,$6A,$22,$A1,$42,$C5,  2,$78,$A5,$4D,$6B,$E4,$A8,$BA,$31,$45,$89,$9C,$EC,$64,$D2,$4D,$8E,$CC, $A,$16,$28,$50,$44,$D4,$96,$6D,$24, $B,$16,$28; 4864
		dc.b $5A,$88,$6B,$28,$58,$A3,$B3,$B4,$10,$B3,$C4,$DA,$15,$31,$6D,$C8,$2A,$49,$1D,$C8,$B3,$9D,$AF,$D8,$EC,$9D,$1B,$A4,$81,$62,$C5, $B, $D,$8E,$C8,$50,$41, $B,$14,$28,$27,$69,$CC,$E6,$76,  5, $A,$16,$28, $B,$16,$28,$58,$14,$83,$14,$13,$B4,$E9,$39,$9D,$81,$42,$C5; 4928
		dc.b  $A,  9,$CC,$E9,$3B,$4F,$20,$58,$B1,$42,$C2,$74,$9D,$27,$69,$D0,$16,$82,$16,$10,$62,$C5,  1,$48,$20,$59,$CC,$E9,$3B,$4F,$20,$58,$B1,$42,$C2,$73,$3B,$4E,$D3,$85,$48,$21,$41,$3B,$4E,$D3,$99,$D8,$14,$28,$58,$A0,$2C,$58,$A1,$60,$52, $C,$50,$4E,$D3,$A4,$E9,$3B; 4992
		dc.b   2,$85,$A0,$82,$79,$4E,$93,$A4,$F2,$10,$62,$85,$84,$ED,$3A,$4E,$67,$40,$50,$B1,$62,$C0,$B4,$10,$A0,$82,$41,$84,$E9,$39,$9D,$A7,$40,$58,$B1,$42,$C0,$E0,$6E,$DB,$3D,$AE,  0,$75,$80,$3F,$6D,$25,$95,$F2,  2,$47,$D0,  1,$E3,$BF,  9,$86,$A9,$AA,$6B,$2D,$5B,$54; 5056
		dc.b   0,  1,  8,$BC,$61,$12,$8B,$55,$10,$C5,$62,$53,$BF,$AB,$8C,$6A,  0,$75,$80,  0,$EB,  1,$EA,$84,$AD,$91,$FD,$11,$4A,$96,$C6,$C6,$36,$97,$54,$AA,  0,$75,$80,  0,$EB,  2,$16,$58,$9A,$B2,$36,$91,$92,$1A,$9E,$C6,$DF,$BE,$31,$2C,$78,$AD,$49,$2A,$AF,$4B,$EC,$7F; 5120
		dc.b $A3,$A2,$7E,$8E,$F6,$4B,$62,$AD,$59,$EA,$C6,$C5,$A1,$D4,  0,$BE,$2E,$86,$30,$8D,$2A,$28,$62,$B1,$29,$1A,$BF,$7D,$C6,$5A,$DA,$55,$5F,$63,$69,$3F,$EB,$2A,$BF,$1B,$3B,$75,$5F,$60,  0,  1,$62,$16,$26,$26,$2B,$14,$31,$49,$B0,$AB,$98,$BD, $E, $B,$56,$A9,$32,$E0; 5184
		dc.b $63,$52,$E0,  4,$10,$3B,$3A,  2,$CE,$8E,$C8,$20,$CE,$82,$33,$67,$2C,$EE,$AA,$20,  1,$55,$73,$60,$77,$CD,$CE,$62,$93,$A4,$F5,$CC,$70,$33,$54,$B8,$2C,$40,  8,  5,$EC,$8A,$85,$9E,$AE,$EB,$46,$D1,$A8,  1,  8,$BC,$61,$13,$52,$D5,$44,$31,$58,$98,$80,$35,$47,$67; 5248
		dc.b $40,$59,$D1,$D9, $C,$6A,$9B,$39,$67,$35,$40,  1,$BC,$A4,$D5,$D4,$93,$A6,$13,$61,$D2,$6E,$87,$A6,$13,$61,$BD,$67,$49,$90,  0,$17,$79,$49,$93, $A,$92,$74,$C3,$C0,$CD,$D0,$F3,$99,$66,$9F,$A6,  9,$BA,$DD,$E0, $F,$40,$3C,$FF,$6C,  7,$FD,$47,$58,  3,$C7,$F6,$E0; 5312
		dc.b  $F,$40,$3C,$FF,$6C,  7,$A8,$F5,$EB,  0,$7A,$F9,  0,$3D,  0,$FD,$B7,$98,  3,$D5,$FC,$FF,$6E,  0,$F2,$F5,  0,$7A,  0,$3C,$FF,$6C,  0,$FE,$BE,$54,$DE,  7,$AF,$90,  3,$D0,  0,$3F,$6D,$21,$FA,$21,$D7,$EA,$3F,$4A,$27,$F2,$F5,  0,$7A,  0,  0,$1F,$A2,$BF,$F4,$47; 5376
		dc.b $F2,$9F,$96,$A6,$43,$7D,$37,$AF,$ED,  0,$1E,$80,  0,  0,$F4,$19, $C,$B7,$52,$C7,$F4,$80,  0,  0,  0,  0,$21,$69, $A,$5A,$40,  0,  0,  0,  1,$4B,$48,$43,$F6,$FE,$BF,$A7,$9B,$6F,$D2,$80,  0,  0,  0,$21,$69, $B,$F7,$FE,$DF,$7D,$3F,$4B,$9C,$FF,$A7,  0,  0,  0; 5440
		dc.b   2,$16,$90,$3B,$CF,$E9,$F7,$AE,$C3,$5F,$D3,$CD,$B7,$E9,$40,  0,  0,$21,$69, $F,$D2,$AF,$29,$E1,$BF,$FA,$40, $F,$D2,$E7,$3F,$E9,$C0,  0,$42,$D2,  7,$94,$27,$E4,$BF,$A5,  2,$FE,$B1,$AC,$F7,$EF,$3F,$A7,$9B,$61,$AC,$A9,$65,$E4,$FB,$F2,$5E,$4F,$C8,  0,  3,$EF; 5504
		dc.b $F3,$E5,$92,$EF,$7D,$E2,$FD,$D0,$FD,$BA,$1E,$57,$EC,$35,$EB,  2,$9B,$DF,$7B,$EF,$7D,$E2,$FD,$DF,$D2,$3B,$A1,$BB,$28,$7E,$5A,$FD,$DA,$F9,$7A,$8A,$6F,$7D,$EB,$FA,$2D,$BC,$D6,$7B,$F7,$BE,$57,$CA,$92,$BF,$F2,$D7,$EE,$A6,$ED,$7D,  0,$13,$C3,$F4,$9B,$A7,$BE,$54; 5568
		dc.b $95,$FB,$A5,  9,$2F,$F1,$A4,  0,  0,$6B,$E8,  0,  0, $F,$4E,$54,$DF,$CA,$9B,$F7, $F,$D3,  0,$3A,$C0, $F,$FB,$40,  7,$A0,  0,$7E,$5B,$A1,$E5,$7F,$4D,$FC,$A9,$BF,$FA,$40,  7,$95,$46,$40,  0,  0,  0,  0,  5,$F6,$95,$2D,$20,  0,  0,  0,  0,  0,  0,  0,  0,  0; 5632
		dc.b   0,$14,$B4,$8E,$FB,$E7,$BE,$D2,$FD,$28,  0,  1,$AC,$EF,$23,$3B,$D8,$CF,$49,$EF,$E5,$7C,$FF,$D2,$9C, $D,$7F,$4B,$9F,$2C,$A1,$63,$38,$A4,$F4,$9F,$CC,$EF,$BE,$70,  0,$14,$9F,$FA,$5B,$4A,$F9,$EF,$DF,$7C,$F7,$E5,$FD,$71,$AC,$F4,$9C,$FF, $B,$6C,$9E,$7A,$4E,$29; 5696
		dc.b $3B,$C8,$CE,$F2,$33,$BC,$AF,$DD,$28,$7E,$8B,$F8,$CB,$2A,$4A,$92,$D6,$78,$74,$FD,$34,$E2,$12,$A6,$E7,$FD,$17,$F1,$96,$54,$95,$24,  0,$1A,$FA,  0,$2B,$C7,$7F,$20,  7,$58,  0,$5F,$FA,$55,$FD,$2C,$37,$D3,$AC,  1,$BF,$96,$FE,$40, $E,$B1,$4D,$F0,$FD,$2A,$FE,$94; 5760
		dc.b $3C,$F4,$9E,$93,$AF,$9E,$DF,$A2,$84,$F4,$9E,$93,$D2,$5F,$A7,$F1,  0,$7A,  7,$F3,$FD,$B0,$1F,$F5, $F,$D6,$29,$CB,$D7,$92,$FE,$D3,$CC, $A,$65,$FA,$6E,$8B,$FC,$21, $D,$F0,$FD,$2A,$FE,$94,  1,$7F,$F0,$BF,$4E,$BC,$A7,$87,$20,$6D,$28,$7E,$8A,$A3,$FA,$25,$CA,$13; 5824
		dc.b $E4,$F3,$DF,$BD,$72,$E5,$E7,$BC,  0,$FB,$DF,$7B,$F2,$7E,$4B,$2A,$58,  0,$FF,$A7,$9B,$6F,$D2,$81,$4D,$FE,$7B,$EF,$9E,$93,$99,$43,$79,$B0,  0,  0,  3,$EF,$36,$BE,$73,$67,$9C,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  5,$27,$D6,$70,  0,$D6,$7A,$4F,$7C,$A9,$63; 5888
		dc.b $3D,$27,$A6,$C2,$93,$FF,  8,$CF,$49,$C6,$BB,$FF,$A4,$76,$14,$DB,$5E,$B0,$35,$9E,$93,$8A,$4F,$49,$E1,$D7,  9,$E1,$20,$B3,$C2,$47,$2D,$BF,$44,$77,$2C,$F0,$DC,$16,$7A,$7F,$4B,$F2,$D3,$BC,$85,$25,$4D,$D4,$DC,$29,$BB,$5F,$F3,  0,$32,$5F,$CB,$7E,$53,$59,$E9,$3D; 5952
		dc.b $27,$5F,$3D,$BF,$45,  9,$E9,$3D,$27,$A4,$E0, $D,$7A,$C0,$1C,$B7,$E3,$58,  3,$D0,  0,  0,$1E,$9A,$EE,$A6,$EA,$6E,$5F,$E3,  0,$21,$E8,$35,$DD,$4D,$D4,$DD,$4D,$D4,$94,$27,$59,$42,$73,$B8,$FE,$8B,$6C,$B7,$42,$7A,$4F,$49,$F5,$DE,$9F,$A7,$7D,$D4,$94,$27,$59,$42; 6016
		dc.b $73,$B8,$FE,$8B,$6C,$B7,$42,$7A,$4F,$49,$E9,$3D,$27,  2,$93,$FF,$4A,$7A,$6D,$4D,$A9,$3B,$FE,$8B,$6F,$D2,$8D,$67,$A4,$EB,$E7,$38,$A4,$E2,$93,$99,$3C,$E6,$CF,$38,  0,  0,  0,  0,$53,$60,$F2,$3B,  7,$B1,$D8,$52,$7F,$D1,  8,$6C,$2F,$DF,$FC,$20,$27,$D7,$AF,$59; 6080
		dc.b $C0,$A4,$E0,$52,$75,$EB,$79,$C5,$27,$86,$E9,$72,$C9,$77,  9,$C4,$25, $F,$3F,$DB,$42,$40,$52,$40,$52,$54,$E9,$FE,$60,  5,$FF,$A2,$79,$2C,$E0,$7E,$DB,$CE,$12,$59,$C4,$25,$49,$42,$70,$B2,$84,$E2,$1F,$A2,$DB,$CD,$67,$14,$9E,$9B,$7F, $B,$78,$BF,$60,$BF,$C2,$D6; 6144
		dc.b $70,$29,$B0,$A6,$C6,$42,$12,$D8,$D8,$3C,$E0,$42,$47,$94,$2C,$76,  3,$5F,$D1,  7,$9C,  1,$4D,$86,$BF,$C2,$59,$C0,$BF,$69,$7E,$DF,$79,$9C, $A,$7F,$4B,$F2,$CB,$38,$86,$E0,$1E,$70,$1F,$FC,$5B,$83,$CE,$B2, $B,$CB,$30,  4,$32,  0,  0,  5,$32,  0,$53,$F6,$F9,$FE; 6208
		dc.b $94,  0,$BF,$D2,  0,  0,  2,$FF,$48,  0,$BB,$4F,$E4,  0,$FD,$17,$F1,$80,  0,  1,$FA,$2F,$E3,  0,$3F,$4F,$3A,$7E,$90,  1,$D6,  0,  0, $E,$B0,  7,$AA,$7E,$90,  1,$E8,  0,  0, $F,$41,$AE,$EA,$6E,$3F,$D6,  0,$2F,$A0,$D7,$75,$37, $A,$6E,$A6,$EA,$49,$FF,$4D,$E7; 6272
		dc.b $B2,$EE,$84,$E1,$77,$42,$75,$DD, $E,$9F,$A7,$7D,$D4,$95,$24,$F3,$EE,$3E,$7B,$4B,$73,$CF,$49,$E9,$3D,$27,$14,$9E,$93,$EB,$D6,$35,$DA,$9B,$1D,$BF,$85,$BC,$4E,$35,$EB,$D7,$6A,$6D,$4D,$A9,$B5,$27,$A4,$E6,$CF,$39,$93,$CB,$5D,$80,$D7,$F4,$B2,$B5,$F3,$9B,$3C,$E6; 6336
		dc.b $4F,$38,  0,  0,  0,  0,$6B,$EC,$DF,$BC,$BE,$C6,$AA,$55,$6B,$EA,$B5,$F5,$52,$AA,$54,$A9,$C4,$D4,$9C,$63, $A,$A2,  0,  0, $B,$FF,$9B,$DD,$6C,$68,$9A,$62,$5A,$16,$AD,$92,$F4,$29,$22,$98,$E4,$50,$C7,$4F,$66,$A3,$5F,$68,$33,$D8,$36,$B6, $D,$AD,$80,$5F,$D7,$7E; 6400
		dc.b $BD,$25, $F,$63,$68,$57,$A7,$51,$AD,$7A,$97,$1A,$DD, $E,$58,$A2,$A4,$34,$8C,$10,$1D,$29,$A5,$11,$D9,$74,$A2,  0,$2F,$EA,$D2,$F9,$6B,$69,$6B,$6A,$85,$42,$A8,$71,$45,$A9,$E3,$C5,$2A,$A4,$6A,  0,  0,  6,$BD,$42,$11,$78,$C2,$26,$4B,$55,$10,$C5,$62,$58,  1,$AA; 6464
		dc.b $3B,$3A,  2,$CE,$8E,$C8,$20,$CE,$9E,$1D,$B9,$F0,$1D,$60, $E,$B0,  0,$1D,$60, $F,$D3,$CF,$9F,$E9,$40,  0,  0,  0,  0,$1A,$8E,$4E,$95,$2D,$46,$AD,$AE,$9A,$7F, $D,$B3,$1D,$60, $E,$B0,  0,$1D,$60, $E,$DF,$B6,$FC,$A4,$22,$ED,  8,$9A,$96,$54,$43,$15,$89,$88,$1A; 6528
		dc.b $A3,$B3,$A0,$2C,$E8,$EC,$82, $C,$E8,  1,$C1,$B3,$EE,$EA,$41,$32,$DA,$98,  3,$6F,$CB,  1,$7B,$2D,$67,$1B,$D8,  8,$83,$A7,$E5,$AC,$62, $E,$8F,$60,  0,$A7,$F4,$BF,$2C,$21,$23,$B8,$53,$75,$F2,$BE,$43,$5D,$D2,$FE,$B1,$DC,  5,$3D,$7C,$40,  0,  0,  0,  2,$FF,$D7; 6592
		dc.b $C2,$55,$1A,$CC,$AA,$B5,$70,$97,$1F,$DF,  0,  0,  0,  0,  0,$FD,$70,$FD,$72,$FF,$78,  0,  0,  0,  0, $C,$B5,$D0, $D,$62,  0,$D6,$AA,$55,$4A,$A9,$55,$2A,$A4,$A9,$2B,$5F,$2B,$6B,$FA,$D3,$65,$D3,$F5,$A6,$C6,$C7,$FA,$3A, $F,$FF,$2D,$5D,$DD,$5A,$1A,$8D,$78,$A5; 6656
		dc.b $4F,$5B,$6A,$80,  0,  5,$2D,$54,$3F,$5B,$1B,$1E,$A3,$DC,$85,$3F,$58,$52,$F6,$84,$BF,$5D,$6D,$3A,$AA,$1F,$CD,$EF,$2C,$F5,$D9,$31,$A5,$78,$D2,$BC,$69,$DD,$68,$71,$74,$AA,$FA,$A2,$3F,$5B,$52,$F5,$2E,$56,$86,$56,$5B,$19,$2D,$50,$92,$D9,$FF,$5F,$2F,$DE,$81,$FC; 6720
		dc.b $DE,$FA,$57,$6D,$50,$A7,$F3,$74,$B6,$80,  0,  5,$2C,$2D,$4E,$A0,  5,$3F,$7A,$FF,$BD,  0,  0,  0,  0,$42,$AB,$F8,$A3,$D5,$5B,$C5,$2F,$8F,$8D,$3A,$A2,$62,$C6,$D4,$B4,$2A,$8B,$5A,$15,$2D,$A1,$52,$C6,$15,$52,$AA,$55,$4A,$B5,$F2,$1E,$D5,$25,$2B, $B,$FB,$C8,$68; 6784
		dc.b $7F,$5A,$BA,$75,$42,$29,$6B,$E5,$AD,$80,  0, $A,$55,$4A,$8F,$B2,$D5,$7D,$7F,$AE,$1A,$26,$89,$A7,$B5,$8D,$8D,$80, $A,$D4,$6A,$55,$4A,$8E,$8F,$54,$34,$29,$55,$E9,$1A,$45,$63,$FB,$D5,$89,$60,$CB,$13,$FB,$EB,$2F,$EB,$9F,$CA,$AB,$1B,$43,$13,$65,$46,$7B,$24,$A0; 6848
		dc.b $8B,$21,$7A,$6A,$D2,$A2,$6B,$23,$A5,$10,$E9,$4E,$A4,$79,$43,$C8,$27,$FC,$C0, $C,  1,$63,$5F,$7B,$24,$91,$7A,$90,$5F,$59,$FE, $A,$A0,  3,$59,$6B,$22,$D2,$C4,$A0,$2D,$5A,$A5,$19,$5A,$BB,$E5,$1F,$D7,$A2,$FE,$F4,$D9,$6C,$B6,$5B,$3F,$EF,$25,$EC,$F2,$1A,$A0,  0; 6912
		dc.b $7B,$7F, $D,$6D,$5D,$F2,$EF,$EA,$4D,$74,$35,  5,$B7,$EB,$AA,$36,$8B,$2A,$5A,$2C,$7D,$8B,$1A,$DE,$B0,  0,$A2,$1A,$FF,$7E,$6A,$EE,$76,$EA,$16,$74,$85,$A1,$A7,$55,$76,$BF,$BE,$C1,$78,$8E,$22,$A9,$6B,$6A,$A5,$AD,$A1,$63,$FC,$D3,$63,$6F,$DE,$71,$C7,$2E,$E5,$EF; 6976
		dc.b $1A, $D,  0,  0,  0,  5,$52,$A5,$8E,$4F,$FB,$ED,  0,$D0,$2E,$9F,$C2,$EE,  0, $D,$5A,$8D,$6A,$5A,$91,$A3,$6B,$6A,$46,$8D,$AD,$A9,$11,$4F,$DF,$6B,$1A,$46,$91,$BE,$2D,$7D,$8D,$AF,$6A,$47,$54,$A4,$52,$89,$4A,$A9,$17,$45,$48,$22,$C6,  8,$B1,$4A,$46,$DA,$E9,$FC; 7040
		dc.b $19,$5A,$98,$80,$28,$94,$4A,$25,$12,$FA,$E0,$85,$2F,$8A,$5E,$94,$48,$D2,$34,$4D,$63, $F,$3F,$DE,$D1,$8B,$2E,$26,$36,$38,$F7,$58,$B1,$47,$62,$86,$2A,$D0,$45,$63,$C9,$23, $D,$96,$26,$CC,$B3,$42,$D1,$D8,$B3,$D9,$6E,$45,$B3,$2C,$D0,$B4,$55,$9E,$CB,$9C,$2C,$C5; 7104
		dc.b $26,$85,$A2,$A8,$74,$EE,$69,$B0,$38,$23, $A,$47,$46,$BE,$47,$40,$CF,$94,$F7,  6,$7D,$93, $B,$BF,$46,$A8,$67,$BA,$FC,$27,$BD,$30,$33,$DD,  4,$3B,$EF,$C2,$75,$B9,$53,  3,$3B,$A1,$DE,$B6,$F0,$4A,$BF,$54,  0,  1,$FF,$E6,  0,  0,$3A,$6B,$64,$A5,$5A,$7F,$74,$DB; 7168
		dc.b $56,$D0,$6A,$9A,$3E,$21,$74,$BD,  2,$E8,  6,$8A,$9A,$E9,$7E,$81,$74,$17,$A7,$7B,$E9,$EC,$3C,$B5,$B0,$A5,$85,$13,$5D,  5,$13,$5D,$28,$9A,$E9,$44,$D7,$4A,$58,$D5,$2F,$DF,$AC,$B4,$3D,$50,$B3,$26,$9D,$50,$B2,$A6,$8F,$10,$DA,$D9,$B5,$B0,$88,  0,  0,$3F,$5F,$1A; 7232
		dc.b $5A,$2F,$D5,$21,$7E,$92,$1A,$DB,$56,$16,$BD,$8B,$5F,$66,$36,$BE,$C5,$A9,$13,$6A,$63,$4B,$1B,$52,$2D,$49,$F0,$DE,$B5,$74,$59,$A1,$54,$CA,$8F,$15,$C2,$F9,$FD,$9E,$33,$53,$BA,$6D,$63,$D0,  0,  0,  1,$BF,$C8,$A9,$81,$9D,$D0,$EF,$BF,  9,$E1,$FE,$79,$D7,$6D,$36; 7296
		dc.b $94,$39,$24,$F9,$3D,$A5, $E,$87,$76,$9B,$B6,$28,  0,$15,$57,$32,$1D,$F3,$74,$C2,$6C,$12,$74,$DF,$84,$D8,$74,$3D,$13,$6B,$B3,$BB,$BE,$CA,$9A,$A6,$B1,$48,$21,$CB,$44,$BF,$4B,$68,$BA,$1D,$3A,$8A,$2A,$5A,$1A, $B,  0,  0,  0,$E8,$BF,$DC,$5D,  0,$1A,  0,  6,$80; 7360
		dc.b  $D,  0,$D0,  3,$D2,$7A,$A7,$E8,$80,  0,$6A,$AE,$64,$3B,$E6,$E9,$84,$D8,$24,$E9,$BF,  9,$B0,$E8,$7A,$2A,$4C,$93,$80,  2,$D5,$5C,$C8,$77,$CD,$D3,  9,$B0,$49,$D3,$7E,$13,$61,$D0,$F4,$54,$99,$27,  0,  5,$AA,$B9,$90,$EF,$9B,$A6,$13,$60,$93,$A6,$FC,$26,$C3,$A1; 7424
		dc.b $E8,$A9,$32,$4E,  0, $B,$52,$19,$90,$C6,$79,$BA,$78,$60,$85,$30,$E9,$E1,$CD,$26,$4C,$37,$F4,$FD,$70,$4D,$53,$59,$6A,$DA,$A0,  2,$FA,$9E,$22,$11,$78,$BA,$42,$2A,$86,$2E,$82,$35,$7E,$FB,$8C,$B5,$B4,$AA,$BE,$C6,$D2,$7F,$D6,$55,$7E,$36,$76,$EA,$BE,$C0,  0,  0; 7488
		dc.b $31,$BF,$B8,$C5,$E3,$BA,$3B,$19,$8C,$C0,$A4,$10,$A0,$2C,$5A, $C, $A,$14,$2C,$50,$16,$2C,$50,$B0,$29,  6,$28, $B,$14,$28,$59,$E2,$FD, $B,$41, $A,$45,$67,$3B,$1D,$D1,$48,$F4,$33,$88,$31,$42,$C0,$B1,$48,$20,$28,$58,$B1,$60,$5A,  8,$50,$41,$20,$C0,$A1,$9C,$B1; 7552
		dc.b $48,$C2,$26,$A5,$DD,  4,$2C,$86,$2B,$39,$E9,$56,$D1,$9E,$3B,$AA,$E8, $A,$16,$28,$50,$16,$BD,$81,$42,$85,$8A,  2,$C5,$8A,$16,  5,$20,$C5,  1,$62,$90,$67,$8B,$F4,$2C,$50,$A1,$48,$AE,$C7,$63,$D2,$29,$1E,$86,$70,$58,$B1,$42,$C0,$A1,$42,$C5,  1,$68,$21,$61,  6; 7616
		dc.b $2C,$50,$14,$82, $B,$F7,$16,$32,$8C,$22,$6A,$5E,$90,$42,$C8,$62,$BB,$1E,$9C,$7F,$7D,$54,$47,$FC,$FF,$EF,$FF,$16,$2C,$58,$B2,$B1,$62,$C5,$80,$1F,$F3,$FF,$8F,$FD,$FA,$FF,$E2,$2A,$8C,$38,$AB,$1E,$2B,$52,$4A,$AB,$D2,$FB,$1F,$E8,$E8,$9F,$A3,$BD,$92,$D8,$AB,$56; 7680
		dc.b $7A,$B1,$B1,$68,$75,  0,  0,$BE,$2E,$86,$30,$89,$43,$DD,$C6,$25,$8F,$15,$A9,$25,$55,$E9,$7D,$8F,$F4,$74,$4F,$D1,$DE,$C9,$6C,$55,$AB,$3D,$58,$D8,$B4,$3A,$80,$17,$C4,$D4,$15,$22,$B1,$31,$84,$5F,$8F,$EF,$AA,$8C,$B5,$B4,$AA,$BE,$C6,$D2,$7F,$D6,$55,$7E,$36,$76; 7744
		dc.b $EA,$BE,$C0,  8,$44,$D4,$B1,$D5,$22,$B1,$31,$A9,$62,  4,$13,$8F,$EF,$B8,$F0,$EC,$F9,$C9,$A5,$83,$F8,$73,  2,$FF,$D4,$FE,$A1,$7F,$53,$C1,$B5,$C0,  0,  0,  2,$1C,$E6,$BF, $C,$B3,$BE,$EE,  0,$1C,$F5,$6C,$3C,$1F,$9F,$80,  0,$3F,$EA,$7F,$54,$BF,$A9,$F6,$E1, $F; 7808
		dc.b $D5,$F0,  0,  7,$E1,$D9,$F8,$5C,$DA,$CC,  0,$3E,$18,$5F,$34,$9B,$3E,$D0,$FD,$47,$60,  0,  0,$1B,$B5,$6F,$D5,$BC,$DF,$AB,  0,  0,$35,$E7,$E0,$F8,$49,$A5,$9B,$F6,$E0,  0,  2,$1F,$A9,$E0,$7B,$63,$26,$CC,$F6,$F0,$E6,  0,  0,  0,$7F,$E2,  0,  0,  0,  0,  0,  0; 7872
		dc.b   0,  0,  1,$4C,$5F,$F4,$77,$B1,$67,$C4,$A4,$18,$D6,$50,$FE,$8E,$B8,$32,$B1,$AE,$FF,$D1,$80,  0,  0,$7F,$8D,$7F,$A2,$C9, $F,$D3,$D6,$79,$14,$3B,$22,$D6,$6B,$E4,$8C,$50,$A6,$C5,$19, $A,$19,$6F,$E9,$EA,  0,$14,$68,$78,$A3,$16,$43,$59,$46,$43,$59,$DA,$1B,$14; 7936
		dc.b $D8,$EC,$8B,$C9,$F6,$5F,$2D,$8D,$6F,$5C,$18,$2F,$F0,$CE,$3F,$F7,  2, $D,  6,$76,$2C,$8D,  4,$64,$29,$8A,$14,$E4,$51,$79,$14,$D8,$A6,$C6,$B8,$6C,$52,$1C,$8A,$41,$B6,$47,$62,$85, $B,$16,$76,$7F,$D1,$85,$C4,$FF,$9F,$A2,$FF, $C,$E2,$7C,$8F,$B7,$ED,$D1,$76,$35; 8000
		dc.b $9D,$8E,$C5,$16,$BD,$8A,$1F,$D1,$9A,$C1,$6B,$F1,$76, $C,  0,$1A,$ED,$D3,$FA,$EC,$5A,$98,$D3,$1B,$F7,$57,$8B,$EC,$50,$B2,$D7,$C9, $E,$25,$17,$6A,$D7,$D8,$F2,$4F,$D1,$94,$A3,$14,$3B,$51,$2F,$65,$41,$7B,  5,$FE,$BF,$E5,  0,  0,  0,$C7,$C5,$51,$AB,$2D, $A,$D5; 8064
		dc.b $8B,$6C,$50,$D6,$CB,$FB,$72,$8A,$97,$D6,$BB,$43,$62,$8B,$FA,$73,$D3,$7E,$5F,$A5,  0,  0,  0,  0,$30,$6A,$21,$FE,$9E,$DE,$CB,$8C,$FF,$A2,$29,$93,$B5,$74,$C5,$2F,$FD,$1D,$11,$95,$8B,$14,$87,$F4,$E0,$C0,  0,  0, $F,$3F,$E8,$BF,$4B,$D3,$68,$72,$35,$C1,$35,$48; 8128
		dc.b $57,$2A,$CE,$C5,$31,$2C,$8B,$8A,$1C,$53,$62,$C9,$FA,$34,$87,$E8,$DD,$96,$BE,$45,$8B,$21,$D9,$D9, $F,$25,$64,$FD,$3A,$16,$43,$CA,$B6,$3E,$45,$18,$FF, $C,$FE,$D3,$97,$4D,$91,$AB,$63,$8A,$1A,$DA,$FF,$15,$AF,$13,$FA,$3D,$8A,$14,$62,$C9,$B1,$F2,$64,$3C,$93,$92; 8192
		dc.b $2D,$7B,$1D,$8F,$F4,$79,$34,$2B,$28,$5B,$D8,$A3,$2F,$E8,$D3,$56, $C, $F,$F1,$FA,$4F,$D0,$B1,$C4,$7B,$1C,$55,$17,$15,$F6,$2C,$A8,$7F,$4E,$D5,$9D,$BC,$B6,$3B,$24,$3F,$4E,$50,$E2,$7F,$6E,$98,$94,$E4,$76,$42,$86,$BE,$49,$FC,$3A,$E9,$E3,$AB,  9,$FF,$C9,$B7,$B2; 8256
		dc.b $D6,$7F,$4F,$59,$D9,$50,$EC,$76,$AD,$F6,$AC,$A1,$F2,$DB,$F4,$6F,$B4,$31,$35,$DF,$FA,$30,  0,  0,$74,$9F,$A7,$E9,$7F,$28,$50,$D7,$2F,$28,$35,$7B,$14,$A7,$2A,$D5, $D,$7B,$1A,$CA,$16,$4F,$DB,$C1,$BC,$B1,$5F,$10,  0,  0,$7E,$52,$7E,$9F,$A5,$94,$13,$63,$B2,$14; 8320
		dc.b $5F,$D3,$A2,$EC,$76,$4D,$8A,$1E,$48,$6B,$E4,$B5,$96,$29,$B1,$AD,$50,$D7,$8A,$F8,$AB,  0,  0,  0,$B4,$BF,$C6,$85,$8E,$25,$91,$58,$E2,$9B,$23,$2B,$2E,$CA,$D0,$F6,$2D, $F,$10, $F,$E8,$D7,$15,$AC,$B5,$6C,$9B,$3E,$C9,$B2,$6D, $E,$45,$36,$6F,$6F,$D3,$A1,$42,$DE; 8384
		dc.b $C5,$8B,$1F,$12,$C0,  0,  0,$A6,$34,$AF,$F4,$65,$8F,$2A,$D5,$97,$62,$8F,$B5,$78,$96,$29,$8A,$E2,$59,$71,$46,$BD,$92,$F6,$38,$80,  6,$AD, $F,$14,$62,$C8,$6B,$28,$5A,$4C,$9A,$B5,$74,$C5,$2F,$FD,$1D,$11,$95,$8B,$14,$87,$F4,$E0,$C0, $D,$5A, $C,$EC,$59,$1A,  8; 8448
		dc.b $C8,$53,$14,$29,$C8,$A2,$F2,$29,$B6,$ED,$B7,$7B,$1D,$BD,$96,$B3,$FA,$7A,$CE,$CA,$87,$63,$B5,$6F,$B5,$65, $F,$96,$DF,$A3,$7D,$A1,$89,$AE,$FC,$61,$FC,$33,$89,$F2,$3E,$DF,$B7,$45,$D8,$D6,$76,$3B,$14,$5A,$F6,$28,$7F,$46,$6B,  8,$7F,$45,$BA,  9,$B1,$D9, $A,$2F; 8512
		dc.b $E9,$D1,$76,$3B,$26,$C5, $F,$24,$35,$F2,$5A,$CB,$14,$D8,$D6,$A8,$6B,$C6,$1F,$A3,$56,$5F,$E1,$C3,$C8,$E2,$9F,$B7,$F6,$D8,$D6,$76,$5A,$D5, $E,$CB,$FA,$32,$87,$6A,$57,$BB,$26,$F2,$D8,$A3,$21,$43,$C9,$18,$A1,$AD,$6B,$3E,$C7,$91,$43,$B2,$43,$F4,$E8,$7F,$A3,$FF; 8576
		dc.b $32,$C7,$C5,$51,$AB,$2D, $A,$D5,$8B,$6C,$50,$D6,$CB,$FB,$72,$8A,$97,$D6,$BB,$43,$62,$8B,$FA,$75,$43,$BB,$65,$DA,  9,$B1,$D9, $A,$2F,$E9,$D1,$76,$3B,$26,$C5, $F,$24,$35,$F2,$5A,$CB,$14,$D8,$D6,$A8,$6B,$C5,$7C,$55,$80,  5,$83,$51, $F,$F4,$F6,$F6,$5C,$77,$1A; 8640
		dc.b $D7,$F4,$68,$58,$E2,$59,$15,$8E,$29,$B2,$32,$B2,$EC,$AD, $F,$62,$D0,$F1,  0,$FE,$8D,$71,$5A,$CB,$56,$C9,$B3,$EC,$9B,$26,$D0,$E4,$53,$66,$F6,$FD,$3A,$14,$2D,$EC,$58,$B1,$F1,$2C,  0,  0, $A,$63,$4A,$FF,$46,$58,$F2,$AD,$59,$76,$28,$FB,$57,$89,$62,$98,$AE,$25; 8704
		dc.b $97,$14,$6B,$D9,$2F,$63,$88,  0,  0, $A,$4F,$FA,$4F,$D2,$F4,$4F,$D1,$F9,$31,$ED,$31,$45,$B8,$C8,$CC,$F2,$32,  0,$5F,$23,$27,$B8,$C8,$CC,$F7,$78,$6B,$E1,$83,$CC,$72, $F,$31,$C9,$19,$5B,$F5,$5B,$6E,$DF,$B7,$E5,$27,$FD,$39,$91,$92,$2C,$DD,$5F,$A2,$38,$19,$1B; 8768
		dc.b $3B,$24,$80,$17,$B2,$49,$F0,$32,$36,$79,$BA,$A1,$FA,$AB,$F2,$36, $F,$91,$B3,$F8,$59,$7F,$45,$D0,$FE,$9A,$7D,$A7,$E8,$9F,$A3,$F2,$65,$65,$43,$9F,$6F,  8,$27,$E8,$8C,$D4,$94,$13,$2B,$F3,$B8,$E5,$7D,$DF,$AA,$17,$FE,$AB,  8,$5C,$7F,$44,$F2,$39,$3E,$47,  8,$5D; 8832
		dc.b $FA,$A2,$8C,$AC,$A9,$B6,$ED,$FB,$7E,$52,$7E,$4B,$23,$24,$5D,$97,$F4,$4B,$37,$EB,$74,$5C, $F,$E8,$9A, $C,$9A,$A6,$4D,  6,$91,$B6,$8B,$84,$DD,$42,$1F,$AA,$B3,$FE,$88,$DA,$19,$19,$3C,$C7,$2B,$FC,$3A,$AF,$D9,$7F,$45,$D0,$FE,$9A,$7D,$A7,$E8,$9F,$A3,$F2,$65,$65; 8896
		dc.b $40,$73,$ED,$E1,$82,$A7,$9A,  5,$4F,$34,$5C,$FB,$78,$60,$35,$E7,$44,$90,$79,$8A,$48,$DC,$FC,$D0,$DC,$B3,$14,$DB,$BE,$7E,$EE,$93,$F2,$59,$19,$22,$EC,$BF,$A2,  7,$C3,$F5,$BA,$2A,$63,$93,  5,$4C,$72,$65,$F0,$FD,$6E,$80,$CD,$75,$24,$C2,$92,$65,$D2,$13,$49,$E2; 8960
		dc.b $70,$3B,$69,  9,$77,$4B,$BA,$51,  0,  0,  4,$38,$F7,$F1,$A5,$7D,$DE,$22,$BC,$97,$15,$C5,$6B,$C4,$62,$BE,$7F,$BC,$E3,$DC,  0,  0, $F,$DE, $E,$A5,$C5,$72,$7F,$1E,$F0,$BE,$35,$85,$F1,$AF,$F7,$FF,$BC,  0,  7,$EE,$E2,$17,$BB,$C9,$7C,$B2,$E3,$4C,$56,$B5,$FE,$9E; 9024
		dc.b $4F,$8A,$F8,$D6,$16,$B7,$AF,$AB,$8F,$77,$10,  0,$EE,$EF,$A6,$3D,$EB,$5A,$E2,$F5,$AF,$52,$D6,$F5,$AE,$35,$AD,$6B,$88,$F2,$F1, $B,$8E,$58,$F1,$EF,$AD,$F8,$D2,$BF,$1E,$38,$F9,$8C,$72,$F2,$A7,$92,$E4,  7,$96,$35,$AF,$96,$2B,$6B,$F1,$3F,$AD,$AD,$64,$B2,$EA,$11; 9088
		dc.b $D2,$D5,$69,$15,$95,$FC,$57,$C5,$F2,$5C,$78,$D6,$3F,$A6,$1F,$1A,$D7,$10,$B5,$AE,$2B,$5F,$8C,$11,$EB,$5A,$F1,$54,$85,$65, $A,$5A,$AB,$43,$4B,$19,$1E,$AD,  0,  0,  1,$4E,$3D,$F4,$C5,$7B,$D6,$BE,$FC,$7C,$86,$2B,$5E,$35,$85,$F1,$EE,$E3,$DF,$C4,  0,  0,$1D,$FD; 9152
		dc.b $41,$F1,$AF,$BD,$71,$5A,$F8,$8C,$B1,$AC,$2D,$7E,$2B,$C7,$BF,$F7,$E0,  0,  0,$7E,$FE,$2B,$C6,$95,$F8,$F1,$C7,$CC,$63,$97,$95,$3C,$97,$25,$EA,$E3,$FB,$E0,  0,  0,$71,$EF,$1C,$57,$C5,$F2,$5C,$78,$D6,$3F,$A6,$1F,$1A,$F8,$FE,$F3,$A8,  0,$1F,$BB,$88,$5E,$EF,$2E; 9216
		dc.b $39,$56,$17,$C5,$6B,$7C,$82,$E2,$BE,$23,$C5,$71,$FD,$E7,$EF,$C0,  3,$BB,$BE,$98,$F7,$AD,$6B,$8B,$D6,$BC,$42,$E4,$BE,$20,$2E,$21,$FC,$97,$BF,$2C,$57,$8D,$31,$5A,$D7,$FA,$79,$3E,$2B,$E3,$58,$5A,$DE,$B5,$C6,$BC,$45,$AA,$AF,$C5,$78,$E9,$1C,$8E,$96,$D9,$E2,$90; 9280
		dc.b $DB,$8A,$B4,$C6,$7D,$8A,$33,$CF,$22,$D2,$4E,$3D,$4B,$5B,$D6,$B8,$D6,$B5,$AE,$23,$CB,$C4,$2E,$39,$62,$B8,$D7,$90,$C5,$6B,$5A,$F2,$5A,$AD,$AC,$BF,$7B,$55,$9F,$23,$1B,$42,$5B,$59,$18,$F1,$D2,$EA,$E5,$A0,$F1,$5A,$DF,$20,$B8,$AF,$88,$F1,$5C,$57,$FA,$62,$BC,$BF; 9344
		dc.b $83, $A,$EA,$B0,$43,$D5,$DC,$F2,$3C,$97,$3A,$A4,$76,$9D,$66,$B7,$75,$AA,$B5,$41,$72,$5F,$10,$17,$10,$FE,$4B,$58,$16,$E3,$65,$CE,$A7,$EF,$86,$CF,$B1,$8C,$D6,$3F,$A2,$D1, $B,$44,$DA,$16,$8A,$46,$D2,$8D,$46,$55,$68,$F2,$84,$84,$A1,$C7,$B8,$2F,$1C,$6B,$A5,$7D; 9408
		dc.b $4B,$93,$E3,$5E,$42,$D5,$57,$E2,$BC,$74,$8E,$47,$4B,$6C,$F1,$48,$6D,$C5,$5A,$63,$3E,$C5,$19,$E7,$95,$51,$D2,$A9,$19,$18,$E9,$C6,$5A,$F7,$C8,$D6,$FC,$42,$FF,$4C,$3E,$35,$AE,$21,$F1,$5A,$D6,$BC,$96,$AB,$6B,$2F,$DE,$D5,$67,$C8,$C6,$D0,$96,$D6,$46,$3D,$F5,$4D; 9472
		dc.b $5B,$58,$63,$5A,$D6,$FE,$4B,$5B,$E2,$B8,$85,$FE,$9E,$5C,$6B,$C4,$2C,$8F,$1A,$DF,$95,$56,$E3,$B1,$DA,$1B,$1D,$AF,$E5,$23,$2D,$9F,$48,$48,$CB,$69,$77,$69,$C7,$48,$8F,$2C,$6B,$5C,$6B,$14,$AC,$2E,$2B,$5A,$F9,$2D,$56,$AC,$55,$6A,$B3,$5A,$C5,$2D,$54,$30,$B6,$92; 9536
		dc.b $86,$88,$63,$92,$A6,$27,$F5,$B5,$26,$5A,$53,$CB,$1A,$D7,$CB,$15,$B5,$F8,$9F,$D6,$D6,$B2,$59,$75,  8,$E9,$4C,$A1,$28,$48,$4A,$1C,$7B,$82,$F1,$C6,$BA,$57,$D4,$B9,$2E,$4B,$96,$34,$AD,$71,$5A,$FC,$60,$8F,$5A,$D7,$8A,$A4,$2B,$28,$52,$D5,$5A,$1A,$5A,$16,$AB,$49; 9600
		dc.b $18,$E9,$C6,$5A,$F7,$C8,$D6,$FC,$42,$FF,$4C,$3E,$35,$F1,$C7,$2A,$F8,$D3,$15,$AD,$7F,$A7,$93,$E2,$BE,$35,$85,$AD,$EB,$CB,$15,$AC,$78,$AD,$6F,$90,$5C,$57,$C4,$78,$AF,$8E,$4B,$92,$D6,$F5,$AE,$35,$AD,$6B,$88,$F2,$F1, $B,$8E,$58,$AF,$98,$7C,$97,$C4,  5,$C4,$3F; 9664
		dc.b $92,$F9,$64,$16,$D5,$57,$E2,$BC,$74,$8E,$47,$4B,$6C,$F1,$48,$6D,$C5,$5A,$63,$3E,$C5,$19,$E7,$97,$E5,$B6,$8F,$B5,$D9,$A4,$D0,$99, $C,$DD,$B8,$4D,$71,$9B,$2E,$17,$4D,$72,$73,$5B,$A6,$BB,  5,$F0,$E7, $C,$F1,$E7,$9E,$13,$67,$D8,$E7,$BA,$7E,$91,$EA,$D3,$A0,$C5; 9728
		dc.b $6B,$5A,$F2,$5A,$AD,$AC,$BF,$7B,$55,$9F,$23,$1B,$42,$5B,$59,$18,$E7,$84,$DD,$3B,$AD,$32,$4D,$83,$A6,$67,$87,$63,$99,$9B,$1E,$D0,$9B,$99,$CE,$E9,$B3,$BA,$63,$36,$49,$9D,$D3,$5D,$97,$3B,$A6,$C2,$EE,  6,$EE,$9B,$4F,$1F,$D6,$F4,$15,$E5,$FC,$18,$57,$55,$82,$1E; 9792
		dc.b $AE,$E7,$91,$E4,$B9,$D5,$23,$B4,$EB,$D1,$AB,$64,$6C,$FC,$39,$C2,$EF, $E,$6B,$E0,$FC,$31,$C2,$6B,$8F, $E,$D8,$4D,$71,$ED,$9B,$CC,$D7,$66,$66,$5F,  3,$74,$DB,$BF,$99,$D3,$60,$B6,$E3,$65,$CE,$A7,$EF,$86,$CF,$B1,$8C,$D6,$3F,$A2,$D1, $B,$44,$DA,$16,$8A,$46,$D8; 9856
		dc.b $74,$8C,$D8,$6E,$B3,$4D,$81,$BB,$19,$8E,  7,$86,$53,$1C, $F, $B,$92,$E9,$97,$9F, $B,$A6,$ED,$5E,$70,$ED,$FB,$A8,$67,$DA,$69,$5D,$83,$5D,$9C,$C9,$77,  8,$4A,$12,$12,$87,$1E,$E0,$BC,$71,$AE,$95,$F5,$2E,$4B,$D3,$6E,$91,$FD,$7E,$D9,$A4,$D0,$99, $C,$DD,$B8,$4D; 9920
		dc.b $71,$9B,$2E,$17,$4D,$72,$73,$5B,$A6,$BB,  5,$F0,$E7, $C,$F1,$E7,$9E,$13,$67,$D8,$E7,$76,$78,$23,$23,$5D,$1D,$38,$CB,$5E,$F9,$1A,$DF,$88,$5F,$E9,$87,$C6,$BD,$BA,$6E,$FD,$6E,$93,$A4,$D8,$3A,$66,$78,$76,$39,$99,$B1,$ED,  9,$B9,$9C,$EE,$9B,$3B,$A6,$33,$64,$99; 9984
		dc.b $DD,$35,$D9,$73,$BA,$6C,$2E,$E0,$6E,$CF,  9,$BC,$B3,  0,  0,  0,  1,$72,$DE,  0,$DE,$17,$2F,$50,  0, $B,$F9,$4D,$E0,  0,  0,  1,$FF,$29,$BC,  0,$17,$7F,$E5,$37,$80,  5,$2B,  0,  0,$BB,$FF,$69,$4F,$CA,$64,$BF,$94,  0,  0,$F9,  1,$4E,$55,$AF,$E5,$80,  3,$D7; 10048
		dc.b $F6,$80,  0,  0,$A7,$E5,  3,$EF,  0,$3E,$FA,$FF,$2C,$17,$7F,$E5,$32, $F,$F9,$4D,$E0, $A,$56,  0,  0,  5,$FC,$A7,$E5,$BF,$28,$17,$F2,$99,  0,  0,$5D,$E0,  1,$BC,  0,$FB,$D7,$78,$7F,$50,$1F,$F2,$9B,$C0,  1,$7F,$28,$29,$58,  0,$2D,$61,$77,$FE,$5A,$BD,$E2,$95; 10112
		dc.b $80,  0,$7F,$20,$17,$F2,$C1,$F7,$81,$4D,$EB,$5E,$F0,$BF,$96,  0,$2E,$40,  0,  0,$7D,$FF,$96,  3,$7F,$E5,$B7,$FE,$50, $E,$55,$87,$CB,$F6,$EF,$CB,$2F,$CA,  5,$AC,  1,$97,$E5,  6,$FA,$C0,$1F,$96,$FC,$A0,  0,$6F,$5F,$2F,$CA,$72,$DE,  0, $B,$58,  0,$53,$7F,$2F; 10176
		dc.b $CA,$72, $B,$58,  0,  1,$58,$7A,$C0,  0,$52,$BE,$59,  0,  3,$FE,$5B,$20,  0, $F,$58,  0,$3D,$6B,$90,$14,$C8,  7,$E4,$1F,$7F,$20,  0, $F,$92,$E4,$37,$FE,$5A,$B0,$17,$7D,$60, $A,$C3,$F2,  0,  0,  3,$EF,$FC,$B5,$7B,$C0,$5A,$D7,$90,$7A,$D7,$F6,$E1,$F0,$CE,$E6; 10240
		dc.b $FC,$A3,$61,$9A,$4D,  9,$90,$CD,$DB,$84,$D7,$19,$B2,$E1,$74,$D7,$27,$35,$BA,$6B,$B0,$5F, $E,$70,$CF,$1E,$79,$E1,$36,$7D,$8E,$77,$4D,$73,$57,$3D,$80,  1,$72,$5A,$E9,$C8,$67,$84,$DE,$CD,$32,$4D,$83,$A6,$67,$87,$63,$99,$9B,$1E,$D0,$9B,$99,$CE,$E9,$B3,$BA,$63; 10304
		dc.b $36,$49,$9D,$D3,$5D,$97,$3B,$A6,$C2,$EE,  6,$EB,$47,$3F,$D1,$A6,$60,$3E,$41,$79,$64,  3,$E3,$FC,$1C,$FC,$39,$C2,$EF, $E,$6B,$E0,$FC,$31,$C2,$6B,$8F, $E,$D8,$4D,$71,$ED,$9B,$CC,$D7,$66,$66,$5F,  3,$74,$D1,$E9,$8D,$76,$88,$E4,  0,$C9,$79,  1,$76,$69,$9F,$6C; 10368
		dc.b $66,$C0,$DD,$8C,$C7,  3,$C3,$29,$8E,  7,$85,$C9,$74,$CB,$CF,$85,$D3,$76,$AF,$38,$76,$FD,$D4,$33,$ED,$34,$AE,$C2,$7B,$77,$B6,$19,$CC,  0, $B,$5B,$D6,$B9,  5,$D2,$A8,$F4,$F6,$BB,$34,$9A,$13,$21,$9B,$B7,  9,$AE,$33,$65,$C2,$E9,$AE,$4E,$6B,$74,$D7,$60,$BE,$1C; 10432
		dc.b $E1,$9E,$3C,$F3,$C2,$6C,$FB,$1C,$EE,$9A,$3F,$A4,$6C,  0,  1,$79, $E,$59, $C,$F0,$CF,$F4,$69,$9A,$4D,$83,$A6,$67,$87,$63,$99,$9B,$1E,$D0,$9B,$99,$CE,$E9,$B3,$BA,$63,$36,$49,$9D,$D3,$5D,$97,$3B,$A6,$C2,$EE,  6,$EC,$F0,$CD,$BF,$28,$99,$80,  0,$5C,$B9,  5,$F2; 10496
		dc.b $C5,$33,$33,$73,$85,$C6,$6C,$B8,$1C,$26,$B9,$2E,$E0,$70,$9A,$EE,$1C,$EF,$CE,$BE,$CB,$FB,$AE,$D8,$5D,$29,$BB,$66,$66,$CF,  6,$EA,$B9,  0,  1,$F9,$3E,$41,$F0,$99,$33,$E7,$5C,$D8,$1B,$B1,$FD,$D2,$F3,$F0,$C7,$83,$F6,$E0,$6E,$9B,  3,$9F,$63,$74,$D8,$1C,$EE,$69; 10560
		dc.b $A1,$35,$C7,$C1,$66,$C3,$3F,$E0,$E0,$17,$F2,$9B,$C0,  0,$2E,$FA,$F9,  0,  0,  1,$7D,$72,  0,  5,$FD,$A6,$40,$3D,$60,$3D,$60,$72,$C9,$79, $A,$79,$80,  0,  0,$6F,$C8,  5,$DE,$BC,$80,  1,$7F,$AA,  0,  0,  0,  6,$40,$53,$23,$C3, $B,$A6,$59,$B1,$AD,$96,$6E,$73; 10624
		dc.b $67,$70,  0,  0,$29,$BC,  7,$DF,$C8, $C,$38,$61,$A4,$EA,$98,$D7,$72,$CD,$CE,$6C,$EE,$C8, $A,$7E,$50,  0,$29,$F9,$60,$BB,$C7,$98,$1B,$F9,$64,$17,$7E,$41,$FF,$29,$BC,$64,  2,$D6,$BC,$80, $B,$BF,$90,  1,$F7,$8A,$6F,$CB,$78,  0,$2F,$A8, $F,$BC, $A,$F7,$80,  6; 10688
		dc.b $43,$F2,$95,$F2,$C8, $A,$64,$3F,$2D,$C9,$F2,$FD,$B8,$5C,$80,$7F,$30,  7,$ED,$C2,$E4,$B9,  5,$F3,$1B,$F2,  0, $F,$EA,$E4,  0,  0, $D,$EB,$BF,$20,$BB,$C7,$20,  6,$43,$21,$4E,$5B,$F2,  2,$99,$2F,$ED,$F2, $B,$96,$19,$CD,$76,$19,$AA,$16,$AD,$97,$14,$2C,$93,$5D; 10752
		dc.b $5E,$28,$C5,$18,$A2,$A6,$27,$14,$C4,$F9,$37,$B3,$1C,$50,$B1,$46,$AC,$B2,$62,$B8,$A3,$1A,$DA,$B6,$AF,$14,$C4,$E3,$5B,$7F,  5,$8A,$7F, $D,$31,$F2,$2C,$53,$F4,$66,$4C,$8C,$52,$EC,$D0,$B5,$6C,$B8,$A1,$64,$5A,$F1,$46,$BB,  6,$28,$B5,$AE,$29,$FA,$3F,$26,$F6,$65; 10816
		dc.b $64,$38,$9C,$50,$B7,$F0,$71,$4C,$4E,$35,$B5,$6D,$5E,$27,$13,$8A,$1F,$65,$42,$9F,$A3,$AF,$F4,$7E,$D8,$A4,$31,$3A,$55,$85,$D9,$DD,$CC, $F,$DB,$E4,  2,$E5,$BF,$90,$7C,$80,  1,$F2,$E4,$B9,  1,$FB,$75,$C8,$3E,$F0,$17,$96,$40,$3E,$5E,$B9,  0,  2,$FE,$DF,$20,$17; 10880
		dc.b $97,$E5,$B2,  0,  7,$AD,$FF,$6E,$1F,$2E,$59,  0,  3,$EF,$5F,$5C,$82,$EF,$E4,$1F,$7F,$2C,$80,$5F,$DB,$BF,$9B,$D7,$C3,$C9,$7B,$42,$EC,$E8,$99,$9E,$DC, $E,$6B,$DB,$19,$8C,$D7,$66,$79,$CC,$53,$29,$8C,$D7,$67,$CF,$2B,$A6,$BB,$3B,$8F, $B,$B0,$9A,$EB,$74,$FD,$1E; 10944
		dc.b $78,$66,  0,$1C,$97,$25,$FD,$D7,$F6,$72,$C7,$29,$B9,$CB,$1F,  6,$43,$77,  9,$8D,$D3,$70,$ED,$31,$9A,$EE,$19,$4C,$66,$B9,$79,$A5,$DC,$FC,$17, $B,$B9,$E3,$9C,$33,$3D,$B3,$9B, $C,$F0,$FD,$1A,$61,$35,$C1,$F3,$86,$57,$70,$BB,$9A,$E1,$23,$72,$F0,$39,$F3,$C7,$2F; 11008
		dc.b  $A,$F1,$F2,$CB,$19,$21,$9B,$F5,$29,$2A,$F0,$86,$7E,$1C,$D7,$C1,$F8,$63,$84,$D7,$1E,$1D,$B0,$9A,$E3,$DB,$37,$99,$AE,$CC,$CC,$BE,  6,$E9,$AE,$6A,$FF,$29,$35,$C1,$F9,$2E,$77,$65,$35,$D9,$56,$B2,$C1,$5A,$5D,$A6,$3C,$31,$5F, $F,$E1,$21,$F6,$93,$67,$26,$97,$83; 11072
		dc.b $21,$BB,$84,$C6,$E9,$B8,$76,$98,$CD,$77, $C,$A6,$33,$5C,$BC,$D2,$EE,$7E, $B,$85,$DC,$F1,$CE,$19,$9E,$D9,$CD,$86,$77,$27,$E8,$EE,$9A,$E0,$BE,$63,$78,$A7,$2F,$D4,$FE,$A3,$1F,$63,$5F,  4,$93,$5D,$FA,$83,$2A,$F0,$86,$7E,$1C,$D7,$C1,$F8,$63,$84,$D7,$1E,$1D,$B0; 11136
		dc.b $9A,$E3,$DB,$37,$99,$AE,$CC,$CC,$BE,  6,$E9,$A3,$FA,$4C,$73,$C0, $F,$DB,$E4,$1F,$27,$CA,$9E,$5C,$2B,$CD,$6E,$6B,$8E,$19,$AD,$C9,$84,$C9,$E0,$BC,$FC,$31,$E0,$FD,$B8,$1B,$A6,$C0,$E7,$D8,$DD,$36,  7,$3B,$9A,$68,$4D,$71,$F0,$5F, $B,$AF,$9B,$87,$67,$CE,$4D,$2C; 11200
		dc.b $1F,$C3,$9A,$CD,$AC,$C1,$7F,$53,$FA,$85,$FD,$4F,  6,$5C,$FB,$2E,  6,$6C,$AE,$7F, $C,  7,$87,$38,$67,$26,$96,$10,$E1,$D9,$FC,$30,$5E,$17,$34,$D8,$2F, $E,$C0,$3F,$87,$EA,$E1,$34,$B1,$97,$65,$FD,$47,$EA,$4E,$7A,$B6,$1E, $F,$CF,$C1,$FF,$51,$FA,$9F,$D4,$24,$9B; 11264
		dc.b $F4,$59,$9B,$BC,$39,$CC, $F,$EA,$7F,$54,$BF,$A9,$F6,$E1, $F,$D5,$FE,$A3,  9,$9F,$86,$13,$67,$D8,$E7, $C,$F1,$E7,$76, $B,$E1,$CE,$E4,$E6,$B7,$4C,$66,$CB,$85,$D3,$19,$BB,$70,$9B,$B3,$70,$C0,$CD,$74,$AE,$E1,$84,$1B,$87,$EA,$57,$F5,$1F,$A9, $B,$36,$B3,$2F,$3F; 11328
		dc.b   7,$C2,$4D,$2C,$DF,$B7, $B,$9F,  9,$BB,$1E,$17,$61,$35,$DC,$F2,$BA,$6B,$B3,$4C,$A6,$33,$5D,$9C,$D7,$66,$79,$CD, $E,$D8,$CC,$73,$3D,$B8,$1C,$D3,$3C, $E,$13,$5D,$9D,$D9,$B6,$72,$9A,$5F,$AA,$C6,$E3,$87,$EA,$B9,$AF,$83,$F0,$C7,  9,$AE,$3C,$3B,$61,$35,$C7,$B6; 11392
		dc.b $6F,$33,$5D,$99,$99,$7C, $D,$D3,$49,$E6,$CB,$33,$DB,$39,$B0,$CF,$9E,$39,$C3,$9F,$82,$E1,$74,$D7,$2F,$34,$BA,$6B,$B8,$65,$31,$BA,$6E,$1D,$A6,$37,$4C,$70,$E0,$DD,$97, $E,$1F,$A9,$87,$39,$8E,  7,$86,$53,$1C, $F, $B,$92,$E9,$97,$9F, $B,$A6,$ED,$5E,$70,$ED,$FB; 11456
		dc.b $A8,$67,$DA,$69,$5D,$82,$5D,$C1,$2E,$CE,$60,$2F,$8D,$5A,  0,  0,$78,$A1,$40,$28,$C0,$43,$8A,$14,$87,$EF,$FA,$80,  0,  1,$DE,  0,  0,$53,$1E,$F7,$E3,$DE,  0,  0,  1,$1A,$B4,  0,$68,  4,$22,$15,$9F,$BB,$8E,$80,  0,  0,  0,$52,$3A,$5F,$10,$17,$BE,$D7,$F7,$CB; 11520
		dc.b $8A,$32,$3E,$22,$11,$40,$20,$D2,  1,$D8,$A1,$AA,$B1, $F,$13,$58,$74,$10,$C6, $D,$7B,$48,$CA,$3C,$74,  0,  6,$92,  0,$13,$BC,  7,$AF,$1B,$68,$53,$2C,$45,$F2,$28,$50,$A5,$34,$B4,$7B,$FF,$5A,  0,  0,  1,  8,$D5,$A0,  1,$E2,$8B,$A0,$10,$8F,$1E,$F0,  0,  0,  0; 11584
		dc.b   0, $B,$1A,$BB,$C3,$C6,$AC,$B8,$E8,$20,$92,$C5,$7B,$84,$18,  5,$AE,$F9,$E6,$E3,$DF,$56,$8F,$90,$D6,$41,$77,$AC,$80,$87,$7A,$E9,$DD,$A5,$E8,$10,$E8,$25,$56,$85,$83,  5,$43,$DE,$FE, $B,$FA,$C0,$79, $A,$64,  0,$D6,$5F,$94,$DE,  2,$C8,$EE,$4D,$E0,$2C,$84,$8E; 11648
		dc.b $C0,  1,$4C,$80,$17,$F4,$1A,$F4,  0,  1, $C,$80,$14,$C8,  0,$38,$FF,$30, $B,$E4,$C6,$C3,$10,$15,$21,$FB,$CF, $D,$2C,$1F,$90,$14,$C8,  8,$46,$AE,$FA,$32,$42,$32,$65,$D2,$F6,$D5,$1D,$1D,$1D,$2F,$6B,$FB,$E3,$A7,$EF,$7B,$E4,  0,  0,  3,$DD,$56,$96,$AB,$54, $B; 11712
		dc.b $5B,$20,$29,$DD,$88,$83, $E,$7D,$DA,$75,$47,$59,$1D,$B2, $F,$B4,$85,$24,$35,$E3,$6D,$1D,$18, $A,$22,$A7,$78,$D0,$B2, $A,$69,$D5,$57,$EB,  0,$79,  0,  5,$23,$56,$80,$3C,$50,$B6,$97,$CA,$F4,$BE,$35,$2C,$AF,$AC,$A2,$A7,$86,$95,$4D,$71,$98,$EE,$5E,$97,$C9,$67; 11776
		dc.b $33,$ED,$2A,$48,  0,$21,$DD,$AA,$54, $C,$74,$76,$7A,$A1,$67,$94,$10,$E8,$AC,$E8,$A8,$B3,$69,$6A,$B4,$B6,$96,$9C,  0,  0,  0, $B,$FB,$9E,$AD,$24,$9A,$B5,$8C,$6A,$62,$8B,$6A,$75,$78,$77,$DB,$45,$49,$EF,$94,$E0,$52,$40,  0,$29,$DE,$35,$48,$47,$42,$87,$BE,$F9; 11840
		dc.b $31,$D2,$19,$F1,$D3,$3D,$23,$7A,$64,$67,$10,$9C,  0,$21,$EB,$FB,$7D,$5B,$FC,$5B,$A9,$B0,$A6,$CB,$FC,$2F,$D3,$3B, $A,$6C,$29,$B3,$A6,$5F,$B6,$E9,$39,$68,$4A,$F4,$94,$18,$A6,$BC,$B2,$FC,$A0,$F4,  3,$59,$7F,$5B,$69,$DF,$2B,$E5,$49,$51,$28,$9A,$FF,$D4,  1,$BF; 11904
		dc.b $CF,$78,$C8,  5,$F3,$1F,$D2,  0,  0,$BD,$60, $D,$BF,$CB,$96,$B9,$6B,$93,$FE,$89,$7F,$44,$F9,$6B,$96,$B9,$6B,$20,  7,$58,  3,$AC,  1,$D6,  0,$96,$B9,$6B,$FE,$21,$FC,$2D,$72,$D7,$F4,$43,$25,$C8,  0,$BD,$60,  1,$AC,$F4,$9E,$93,$AF,$9E,$DF,$A2,$84,$F4,$9E,$93; 11968
		dc.b $D2,$5B,$6F,$E5,$BF,$59,$E9,$B4,$AF,$9D,$7C,$E7,$A4,$F4,$DB,$F8,$46,$7A,$4E,  0,$D7,$AC,  1,$FF,$70,  7,$58,  0,$6B,$3F,$F4,$A7,$A4,$F4,$DB,$F4,$50,$9D,$F2,$9E,$93,$EB,$3F,$2D,$FC,$B5,$9E,$93,$D2,$75,$F3,$DB,$F4,$50,$9E,$93,$D2,$7A,$4E,  0,$D7,$AC,  1,$E5; 12032
		dc.b $EA,$27,$13,$8F,$EB,$2B,  6,  2,$70,$27,  2,$7D,$C3,$56,  7,$F4,$7E,$A0,$B0,$1F,$D6,$59,$C0,$13,$80,  3,$7E,$98,  1,$7C,$E0,  1,$F9,$60,$28,$C0,  0,$37,  0,$3D,$7F,$47,$BA,$71,$38,$9C,$4E,$DF,$A6,$BE,$71,$38,$9C,  0,  0,  3,$C7,$D4,  1,$E8,  0,$9C,$4E,$27; 12096
		dc.b $13,$8F,$DB,$3C,$E2,$71,$3A,$FB,$7E,$91,  1,$40,$3F,$AA,$BD,  0,$1D,  0,  1,$3F,$4A,  0,$F2,$6F,$D3,$80,$3A,$C0,  0, $F,$DB,$F9,$FA,$F9,$80,$25,$FA,$4F,$33,$B8,$6E,$1B,$9F,$CC,$FE,$9A,$50,$96,$E8,$4A,$12,$DD,  9,$42,$5B,$A1,$28,$49,$E4,$24,$B2,$BE,$46,$47; 12160
		dc.b $F8,$50,$90,$93,$CA,$12,$84,$A1,$BB,$F4,$80, $F,$40,  6,$ED,$65,$BB,$59,$6E,$D6,$5B,$9F,$F4,$4B,$FA,$69,$3E,$E8,$49,$F7,$42,$4F,$BB,$DB,$F4,$7C,$80,$14,$DE,  5,$10,  0,  4,$E0, $D,$7A,  0,  0,  0,  0,  0,$1A,$A6,$A8,  0,  0,  0,  6,$A9,$7E,$32,$82,$33,$D7; 12224
		dc.b $7A,$6B,$E5,$E2,  0,  3,$56,$A3,$5F,$8D,$E9,$7D,$77,$A6,$BD,$60, $F,$1F,$69,$51,$A8,$D7,$A3,$5E,$DF,$C2,$2D,$46,  0,  1,$AF,$58,  3,$CB,$C4,  0,  0,  3,$56,$A3,$51,$A8,$9F,$A2,$83,$51,$A8,$DA,$FE,$8F,$DA,$54,$6A,$35,$1B,$5F,$38,$35,$1A,$8D,$46,  0,$6B,$D6; 12288
		dc.b   0,$F2,$F3,$3F,$A3,$76,$1A,$F5,$80,  0,$FD,$10,$97,$A7,$ED,$80,$1F,$B4,  0,$3F,$58,  0,  1,$BB,$5D,$D0,$FD,$A0,  1,$FF,$68,  0,$EB,  0,  0,  7,$5F,$ED,$BF,$44,$24,$3F,$68,  0,$7E,$B0,  0,  0,$75,$8F,$3F,$DB,  6,$9B,$9F,$55,$77,$27,$EB,$CF,$7A,$54,$B5,$5F; 12352
		dc.b $8F,$7A,$2B,$1C,$98,$A2,$B1,$43,$18,$31,$43,$15,$63,$93,$14,$5C,$7B,$D2,$18, $C,$29,$81,$FD,$24,$F0,$C0,$74,$1F,$94,$9D,$2A,$5A,$9D,$3B,$B7,$76,$CD,$2C,$B9,$9C,$D3,$43,$65,$FD,$41,$EA,$3C,$16,$C7,$BA,$77,$42,$C6,$78,$21,$63,$3A,$D8,$F7,$4E,$FD,$47,$86,$BB; 12416
		dc.b $53,$68,$7E,$A7,$A1,$DA,$9B,$53,$A3,$FE,$A6,$FD,$3A,$97,$F7,  7,$DA,$EB,$4F,$74,$7F,$5E,$7B,$D2,$15,$51,$BD,$97,$13,$54,$5F,$24,$BE,$B6,$8B,$E3,$6A,$D7,$F4,$68,  7,$E5,$27,$7E,$94,$C0,$FE,$52,$77,$E9,$4C,$1D,$2A,$5A,$9D,$3B,$B7,$76,$CD,$2C,$B9,$9C,$D3,$43; 12480
		dc.b $65,$FD,$47,$54,$F9,$BE,$71,$DD,$FA,$8B,$ED,$3C,$33,$DD,$1B,$ED,$3E,$7B,$EF,$9F,$F5,  1,$7B, $B,$AF,$EC,$7A,$52,$E1,$D1,$F4,$EA,$5F,$DC,$7E,$E5,$2E,$4F,$4D,$DD,$DF,$C1,$39,$A7,$1B,$EE,$AF,$F5,$F0,$ED,$ED,$7F,$EA,$40,  0,  0,  0,$FE,$36,$D9,$9F,$E0,$9A,$B5; 12544
		dc.b $A8,$FF,$7C,$21,$FE,$8A,$FF,$A4,$FF,$1B,$6C,$CE,$EE,$EA,$CD,$4B,$9A,$54,$B5,$42,$E4,$8D,$48,$FD,$93,$5E,$C0,$1F,$F8,$80,  5,$F1,$A8,$51,$1B,$41, $A,$B4,$54,$BD,$9F,$4A,$54,$59,$50,$E8,$A9,$7B,$41,$15,$20,$90,$B7,$7F,$F3,$40,  0,  0,  0,$D1,$6A,$D0,$41,$2C; 12608
		dc.b $59,$34,$B4,$34,$5A,$ED,  4,$54,$3D,$5A,$7F,$34,  0,  0,  0,  0,$17,$BF,$54,$B2,$D4,$74,$48,$68,$C7,$4F,$D6,$9E,$F0,  0,  0,  0,$2F,$AB,$41,$46,$4B,$69,$65,$D1,$6B,$3D,$45, $A,$7E,$F7,$4F,$D6,$80,  0,  0,  0,$1F,$78,$5F,$CA,$6F,$E4,$17,$7F,$E5,$31,$AC,  0; 12672
		dc.b $1F,$C7,$C9,$FC,$C7,$ED,$80,$1E,$80, $F,$5F,$11,$4C,$60,$98,$AF,$E8,$FF,$84,  0,$DC,$3F,$4D,$90,$C8,$7A,  0,$26,$BB,$36,$FD,$2E,$89,$36, $E,$99,$9E,$1D,$8E,$66,$6C,$7B,$42,$6E,$67,$3B,$A6,$CE,$E9,$8C,$D9,$26,$77,$4D,$76,$5C,$EE,$9B, $B,$B8,$1E,$D3,$61,$49; 12736
		dc.b $9E,$65,$9B,$B7,  9,$AE,$33,$65,$C2,$E9,$AE,$4E,$6B,$74,$D7,$60,$BE,$1C,$E1,$9E,$3C,$F3,$C2,$6C,$FB,$1C,$D3,  9,$97,  9,$92,$E3,$C2,$EC,$26,$BB,$9E,$57,$4D,$76,$69,$94,$C6,$6B,$B3,$9A,$EC,$CF,$39,$A1,$DB,$19,$8E,$67,$B7,  3,$9A,$67,$81,$C2,$6B,$B3,$C7, $B; 12800
		dc.b $9A,$57,$19,$60,$6E,$E0,$78,$1E,$1D,$8E,$66,$6C,$7B,$42,$6E,$67,$3B,$A6,$CE,$E9,$8C,$D9,$26,$77,$4D,$76,$5C,$EE,$9B, $B,$B8,$1B,$AD,$84,$DF,$B4,$B5,$F3,$A4,$FB,$3C,$FD,$17,$F2,$8A,$94,$9D,$1D,$16,$78,$6E,$DA,$75,$AE,$F4,$E1,$FA,$3A,$CE,$68,$66,$79,$96,$6E; 12864
		dc.b $DC,$26,$B8,$CD,$97, $B,$A6,$B9,$39,$AD,$D3,$5D,$82,$F8,$73,$86,$78,$F3,$CF,  9,$B3,$EC,$73,$BA,$6B,$9A,$B9,$EC,$B2,$86,$E7,$94,$FA,$EF,$DC,$2F,$E8,$7C,$B0,$45,$E5,$DA,$69,$D2,$75,$69,$1E,$FB,$B1,$96,  6,$EE,  7,$81,$E1,$D8,$E6,$66,$C7,$B4,$26,$E6,$73,$BA; 12928
		dc.b $6C,$EE,$98,$CD,$92,$67,$74,$D7,$65,$CE,$E9,$B0,$BB,$81,$BB,$3C,$26,$F2,$CC,  0,  0,  0,  0,$37,$FE,$53,$20,$17,$7D,$7F,$96,$C8,  0,$16,$B0,  5,$61,$EB,  0,  1,$4D,$F5,$E4,  2,$E4,  0,$14,$E5,$5E,$40,  0,$BC,$80,$A6,$5B,$F2,  0,  0,  7,$E5,$37,$80,  0,$7A; 12992
		dc.b $D7,$78,$5F,$EA,$80,  0,  0,  0,  2,$FA,$80,$FF,$B7,$F2,$7F,$D2,$89,$C7,$A0,  0,  0,$3D,  0,$1E,$3E,$A3,$78,$DE,$D0,$FE,$37,$E9,$40,  0,  1,$E8,  0,$F5,$F1,  0, $F,$51,$E2,  0,  3,$D0,  1,$E7,$FB,$40,  0,  0,  5,$FC,$A6,$F0,$32,$7D,$E1,$72,$AC, $F,$31,$90; 13056
		dc.b $15,$E4,$17,$2A,$C3,$E1,$9C,$7A,$7B,$5D,$9A,$4D,  9,$90,$CD,$DB,$84,$D7,$19,$B2,$E1,$74,$D7,$27,$35,$BA,$6B,$B0,$5F, $E,$70,$CF,$1E,$79,$E1,$36,$7D,$8E,$77,$4D,$54,$F8,$A5,$C3,$78,$A7,$28,$48,$3D,$61,$E6,$BA,$AE,$8D,$5E,$69,$36, $E,$99,$9E,$1D,$8E,$66,$6C; 13120
		dc.b $7B,$42,$6E,$67,$3B,$A6,$CE,$E9,$8C,$D9,$26,$77,$4D,$76,$5C,$EE,$9B, $B,$B8,$1B,$B3,$C2,$6F,$2C,$C0,  2,$EC,$F0,$4E,$7E,$19,$DD,$35,$D9,$73,$BA,$6C,$2E,$E0,$6E,$F6,$74,$CD,$26,$84,$C8,$66,$ED,$C2,$6B,$8C,$D9,$70,$BA,$6B,$93,$9A,$DD,$35,$D8,$2F,$87,$38,$67; 13184
		dc.b $8F,$3C,$F0,$9B,$3E,$C7,$3B,$A6,$C3,$CA,$E0,  0,$F2,$E7,$E1, $C,$F1,$E7,$9E,$13,$67,$D8,$E7,$EC,$F5,$CD,$83,$A6,$67,$87,$63,$99,$9B,$1E,$D0,$9B,$99,$CE,$E9,$B3,$BA,$63,$36,$49,$9D,$D3,$5D,$97,$3B,$A6,$C2,$EE,  6,$EC,$F0,$9B,$CB,$30,  0,$AF,$B7, $A,$F3,$3C; 13248
		dc.b $3B,$1E,$17,$4D,$81,$C3,$34,$37,$4D,$81,$C3,$35,$99,$E6,$59,$BB,$70,$9A,$E3,$36,$5C,$2E,$9A,$E4,$E6,$B7,$4D,$76, $B,$E1,$CE,$19,$E3,$CF,$3C,$26,$CF,$B1,$CE,$E9,$B0,$F2,$B8,  0,$2B,$ED,$C2,$BB,$A6,$E1,$DA,$63,$74,$C7, $E, $D,$74,$D8,$19,$2F,$69,$60,$6E,$E0; 13312
		dc.b $78,$1E,$1D,$8E,$66,$6C,$7B,$42,$6E,$67,$3B,$A6,$CE,$E9,$8C,$D9,$26,$77,$4D,$76,$5C,$EE,$9B, $B,$B8,$1B,$AD,$1C,$DB,$F2,$89,$98,$7D,$E0,$2F,$2C,$80,$7C,$B7,$AC,$E3,$59,$EF,$9C,$5F,$FA,$71,$AC,$AF,$E5,$F9,$4C,$80, $B,$38,$9E,$BA,$72,$14,$E5,$FA,$28,$4E,  4; 13376
		dc.b $EB,$20,  3,$F4,$59,$DF,$A0,$5D,$96,$7B,$FF,$28,$35,$49,$EF,$DD,$B2,$FB,$2C,$8A,$1E,$18,$D7,$99,$CD, $C,$CB,$99,$99,$66,$ED,$C2,$6B,$8C,$D9,$70,$BA,$6B,$93,$9A,$DD,$35,$D8,$2F,$87,$38,$67,$8F,$3C,$F0,$9B,$3E,$C7,$3B,$A6,$C2,$BD,$FA,$53,$70,$D7,$75,$3A,  4; 13440
		dc.b $35,$E1,$ED,$CB,$B4,$CA,$8A,$D2,$37,$67,$76,$32,$C0,$DD,$C0,$F0,$3C,$3B,$1C,$CC,$D8,$F6,$84,$DC,$CE,$77,$4D,$9D,$D3,$19,$B2,$4C,$EE,$9A,$EC,$B9,$DD,$36,$17,$70,$37,$4D,$76,$6D,$ED,$98,  3,$AC,  0,  0,$1D,$60,$53,$AC,  0,$BD,$60,  0,  0,$EB,  3,$CF,$F6,$DE; 13504
		dc.b $3E,$A0,  0,  0,  0,  0,  6,$AD,$AB,  0,  0,  0,  1,$AB,$5F,$BF,$74,$1A,$77,$C6,$F6,$D7,$C7,$D4,  0,  6,$B3,$D2,$7B,$F7,$DE,$D7,$E3,$7B,$6B,$E8,  0,$F5,$FD,$1E,$EA,$4F,$49,$EF,$69,$EF,$9F,$F8,$C6,$7A,$4E,  0,  3,$5F,$40,  7,$ED,$FF,$68,  0,$FF,$A8,  3,$5D; 13568
		dc.b $A9,$B4,$AF,$DA,$57,$ED,$25,$FD,$2C,$8F,$E8,$97,$67,$91,$D9,$E4,$76,$79,$2F,$9E,$DB,$E5,$4D,$A9,$B5,$36,$87,$E9,$7F,$84,$BB,$4A,$12,$3B,$4A,$12,$3B,$4A,$12,$59,$42,$54,$95,$25,$49,$5F,$23,$FC,$23,$2B,$E5,$49,$52,$50,$97,$E9,$37,$42,$40, $F,$40,  6,$23,$11; 13632
		dc.b $BC,$6F,  0, $F,$1F,$50,  7,$A0,  0,  0,$37,$FF,$59,$58,$34,$E2,$75,$F5,$C7,$F2,$C0,$7A,$8F,$10,  0,  0,  0,  7,$8F,$A8,  3,$D3,$F4,$A2,$7C,$46,$20,  0,  0,$1E,$BE,$3E,$BE,$20,  0,  0,  0,  0,  7,$8F,$AB, $F,$D1,$FA,$80,  0,  0,  0,  0,  0; 13696
Nem_GHZ2:	dc.b $81,$CD,$80,  3,  1,$14,  4,$25,$12,$34,  7,$46,$31,$56,$26,$66,$35,$73,  0,$81,  4,  5,$15,$11,$28,$F4,$37,$75,$82,  5,$14,$16,$2B,$77,$73,$83,  4,  6,$16,$2E,$38,$F7,$84,  7,$76,$17,$78,$85,  7,$6F,$16,$34,$86,  7,$71,$78,$F6,$87,  6,$36,$17,$6E,$88,  6; 0
		dc.b $33,$17,$70,$89,  6,$2F,$17,$72,$8A,  6,$2A,$18,$F3,$8B,  6,$32,$17,$74,$8C,  6,$30,$18,$F2,$8D,  6,$27,$18,$F5,$8E,  5,$10,$18,$EF,$8F,  5,$16,$18,$EE,$FF,  0,  0,  0,$D6,$D8,$F7,$2B,$DA,$2F,  5,$C6,$1E,$F3,$7A,$C0,$C1,$8C,$F3,$4F,$2B,$41,$A7,$95,$92,$79; 64
		dc.b $59,$21,$2B,$4D,$69,$AD,$35,$B5,$EA,$3D,  0,  0,$6A,$D3,$34,$F3,$4E,$9F,$CE,  0, $D,$7F,$5F,$2A,$58,$C4,$D2,$D3,$C5,$2D,$3C,$5E,$21,$3F,$79,$2C, $F,$EB,$53, $F,$59,$41,$67,$C6,$9A,$CE,  0,  0,$4D,$69,$AC,$7D,$12,$D8,$AD,$A6,$84,$D0,$9A,$18,$C1,$B1,$9C,$CF; 128
		dc.b $8B,$4D, $D,$57,$5B,$77,$80,  0,$FD,$70,$FD,$70,$EF,$18,$2E, $B,$87,$A4,$E6,$73,$38,  1,$1A,$66,$9A,$D3,$58,$E0,$F6,$96,  5,$6D,$8A,$C2,$68,$24,$3F,$7A,$90,$2C,$1A,$50,$76,$33,$CD,$70,  2,$65,$99,$66,$54,$FE,$77,$EB,$C0,$1A,$D3,$5C,  0,$84,$CC,$7F,$5C,$FD; 192
		dc.b $6D,$39,$9E,$57,$19,$D1,$59,$E7,$5A,$49,$52,$83,$15,$D5,$A9,$32,$EB,$43,$84,$CA,$70,$9B,$D5,$5E,$92,$EA,$14,$4C,$C5,$92,$E3,  9,$CD,$DD,$F3,$96,$2A,$EC,$54,$C1,$1A,$4A,$8C,$77,$2C,$25,$B2,$42,$4D,$FA,$40,  6,$B6,$9A,$D3,$5A,$6B,$4D,$69,$A9,$35,$27,$C6,$93; 256
		dc.b $EB,$FA,$D3,$3A,$61,$FA,$D3,$39,$9C,$FF,$47,  0,  0, $C,  1,$63,$1F,$26,$5A,$2A,$7A,$A8,$C6,$27,$F8,$28,$A0, $D,$69,$AE,$1F,$EE,$4B,$77,$FA,$E0,$6C,$63,$72,$D9,$E2,$DA,$A8,  0,  1,$34,$F6,$97,$EB,$61,$39,$F5,$3D,$EA,$57,$F5,$85,$71,$69,$51,$1A,$25,$82,$34; 320
		dc.b $51,$66,$64,$68,$E3,$48,$7E,$BD,$53,$F7,$A6,$74,$9D,$27,$49,$DF,$F7,$94,$F4,$7A, $D,$54,  0,$3F,$FC,$3F,$9B,$E4,$59,$E3,$3A,$DD,$34,$6E,$9A,$37,$4D,$DF,$3C,$BB,$9D,$6D,$8D,$A0,$3F,$5B,$64,$F5,$4A,$E7,$95,$73,$A4,$E6,$89,$69,$51,$27,$D6,$D3,$4F,$1C,$69,$E5; 384
		dc.b $EA,$BA,$E0,$6C,$12,$7F,$D7,$58,$CF,  6,$45,$9E, $C,$7D, $B,$18,$BC,$40,  2,$65,$31,$FD,$F9,$B7,$7B,$C0, $D,$7F,$9B,$E5,$34,$67,$D5,$4A,$FF,$37,  9,$F0,  0,  0,$26,$9C,$4E,$27,$13,$BA,$CA,$79,$61,$EB,$19,$F1,$F2,$9C,$27,$70,$EE,$16,$A6,$B3,$DA,$9A,$CF,$29; 448
		dc.b $CF,$F3,$4C,$E6,$7F,$DE,$77,$5D,$5F,$7A,$79, $C,  6,  0, $F,$DE,$BF,$EF,$40,$C7,$F7,$DA,$B6,$B3,$CD,  9,$9B,$59,$E6,$80,  0,  0,  0,  9,$FB,$E7,$59,$AD,$34,$1D,$51,$64,$A9,  9,$2A,$41,$66,$84,$FA,$D0,$CF,$35,$30,$3E,$B2,$9D,$97, $F,$59,$4E,$8B,$83,$C0,$36; 512
		dc.b $B3,$B6,$B3,$9F,$DF,$7E,$BD,$52,$32,$52,$B8,$C1,$71,$59,$96,$13,$42,$65,$D6,$13,$2C,$D3,$C1,$FD,$68,$31,$C2,$83,$59,$F5,$69,$BB,$E7,$BB,$B4,$3B,$24,$F0,$D8,$B3,$CE,$97,$AA,$4E,$C9,$54,$A7,$82,$33,$CE,$99,$CA,$76,$2B,$54,$A7,$82,$2B,$CE,$A7,$29,$5B,$B2,$55; 576
		dc.b $2B,$54,$8A,$F0,$4C,$B1,$DF,$E8,$F0,$AA,$6E,$FA,$B5,$87,$6C,$3F,$DC,$AC,$26,$86, $D,$8D, $E,  1,$9E,$BD,$F7,$86,$7D,$97,$2B,$FF,$46,$8A,$77,$DF,$8E,$5B,$F1,$5C,$8E,$FB,$E4,$A7,$4C,$72,$DE,$97,$A2,$E4,$77,$BA,$9D,$31,$CB,$7E,$2B,$91,$DE,$EA,$74,$C7,$2D,$F2; 640
		dc.b $FF,$3E,$F4,$DB, $D,$A9,$2D,$CB,$BE,$B7,$9E,$92,$EC,$78,$E1,$C7,$62,$A0,  1,$68,$D4,$A7,$4A,$BB,$65,$56,$4B,$BD,$74,$CA,$AC,$BB,$1E,$D0,$F3,$CA,$AE,$E8,  0,  0,$7F,$F9,$80,  0, $E,$BA,$CE,$BA,$D8,$2E,$AB,$AC,$16,$4A,$6B,$C1,$71,$C2,$7C,$13,  3,$87,$A9,$54; 704
		dc.b $59,$E5,$80,$9C,  0,  0,  6,  2,$7D,$5B,  1,$AA,$E0,$F7,  4,$C3,$15,  9,$80,$18,$22,$EB,$86,$38,  4,$C0,$62,$BA,$E0,$98,  0,$30,  0, $C,  0,$18,  1,$80,  0,$5A,$93,$4E,$6B,$7F,$DF,$60,  6,  0,$60,$7D,  7,$5D,$67,$13,$4E,$26,$5D,$70,$13,$2E,$B8,$4C,$BA,$E1; 768
		dc.b $32,$EB,$84,$CD,  9,$F1,$62,$D8,$CE,$C6,$7C,$67,$2D,$34, $C,$F3,$5D,$34,$E6,$79,$A0,$D2,$ED,$BE,$DB,$EA,$50,  0,$36,$8D,$4A,$74,$AB,$B6,$55,$64,$BB,$D7,$4C,$AA,$CB,$B1,$EC,$8B,$52,$EF,  0,  4,$B4,$6A,$53,$A5,$5D,$B2,$AB,$25,$DE,$BA,$65,$56,$5D,$8F,$63,$E3; 832
		dc.b $7F,$68,$87,$82,$42,$50,$48,$2E,$30,$4B,$1B,  9,$AC,$8C,$11,$71,$67,$56,$75,$16,$39,$A3,  9,$41,$33,$9A,  7,$37,$FD,$B6,$52,$D9,$F2, $F,$B4,$CC,$76, $C,$18,$27,$EC,$B7,$EC,$F7,$3E,$F5,$FC,$B6,$DB,$D3,$88,$FC,$B6,$DA,$26,$FF,$CB,$7E,$96,$5B,$D9,$7C,  7,$83; 896
		dc.b $D8,$C2,$50,$9A,$C6,  6,  9,  2,$A1,$40, $A,$C0,$B1,$50,$55,$1A,$4A,  5,$9E,$D2,$B3,$DB,$1C,$25,$43,$81,$A7,$6A,$4E,$68,$70,$4E,$38,$F1,$C6,$8F,$C6,$54,  1,$FF,$6F,$FB,$41,$FF,$51,$FF,$5F,$FA,$F5,$FD,$A0,$12,$80,$48,$18,$18,$24,$15,$2C,$90,$4B,  5,  8,$C1; 960
		dc.b $17,$16,$75,$67,$50,$A0,$6B,$64,$C0,$DA,$56,$4C,$12,$D5,$C2,$89,$63,$C5,$38,$9A,$4B,$8A,$51,$28,$9C,$65,$40,  1,$FD,$A7,$ED,$C7,$FD,$47,$FD,$7F,$EB,$FB,$4E,$A0,$18,$24,$1D,$61,$8C,$1E,  8,$A9,  4,$86,$AB,  7,$60,$8A,$55,$9D,$44,$99,$14,$AC,$B0,$48,$63,$3E; 1024
		dc.b $38,$3D,$8E,$12,$80,$34,$9D,$37,$D0,  4,$D8, $D,$80,$9B,$FA,$A1,$3F,$AA,$13,$FA,$A9,$FC,$5E,$C9,$E2,$3D,$80,  0, $D,$60,$F0,$D5,$60,$90,$30,$B2,$41,$2C,  0,$57,$67,$50,$59,$D5,$D9,$44,$99,$D4,  1,$39,$80,$95,$92,$73,  1,$E4,$6C,  0,$E6,  0,$EB,$EE,  0,$94; 1088
		dc.b $1E,$12,$81,$B2,$5A,$65,$30,$48,$18,  1,$AA,$81,$8B,$2A,$29,$60,$EB,$26,$45,$46,  0,  3,  9,$59,$30,$C6,$D8,$CE,$98,$24,$27,  0,$1E,$60, $E,$60, $F,$E9,$1A,$27,$17,$A7,$10,$9C,$4D,$25,$C5,$28,  0,$97,$B0,  1,$FF,$68,  0,$E6,$FC,$65,$44,$A1,$E3,$2A,$63,$C5; 1152
		dc.b $29,$2E,$20,  3,$EC,  0,$FD,$AF,$B8,  0,  0,$1E,  6,$C9, $D,$56,  9,  3, $B,$24,  0,$92,$80,$1D,$9D,$41,$67,$57,$65,$12,$67,$51,$DF,$FB,$DE,$F0,  0,$12,$83,$C2,$50,$36,$30,$B7,$79,$81,$85,$92,  0,  9,$2B,$B3,$A8,$2D,$8A,$9F,$D1,$AA,$29,$60,$EB,$26,$45,$46; 1216
		dc.b   0,$63,$DF,$FB,$DE,$F0,  3,$C1,$EC,$61,$28,$4D,$63,  3,  4,$81,$8C,$CA,  6,$AA,$EC,$EA, $B,$3A,$BB,$28,$93,$3A,$80,$27,$30,$12,$B2,$4E,$60,$FE,$FE,$AB,  0,  0,$94,  2,$40,$C0,$C1,$20,$A5,$6C,$90,$48, $D,$54, $C,$59,$51,$4B,  7,$59,$32,$2A,$30,  0,$18,$4A; 1280
		dc.b $C9,$86,$36,$C6,$78,$CE,$AD,$3C,$18,  0,  0, $F,  3,$64,$86,$AB,  4,$81,$85,$92,  0,$49,$40,$EE,$FD,$F7,$70,  0,  9,$41,$E1,$28,$1B,$18,$5B,$BC,$C0,$C2,$C9,  0,  4,$95,$D9,$D4,$16,$7B,$77,$FA,$C3,$B8,  0,$F0,$36,$48,$6A,$B0,$48,$18,$59,$20,  4,$94, $C,$59; 1344
		dc.b $51,$4B,  7,$59,$32,$2F,$EB,$BF,$5B,$DE,$1E,  6,$C9, $D,$56,  9,  3, $B,$24,  0,$92,$87,$67,$50,$59,$D5,$D9,$44,$99,$D4,  1,$39,$80,$C6,$96,$A6,  9,$3C,$D0,$9A,  9,$38,  0, $E,$60, $F,$5E,$FA,$61,$FA,$F4,$C3,$1B,$63,$3A,$60,$90,$4F,$E9,$5A,$80,  0,  0,$E6; 1408
		dc.b $FC,$65,$44,$A1,$E3,$2A,$63,$C5,$28,$7C,$53,$B0,  3,$98,  0,  0,$3F,$A4,$68,$9C,$5E,$9C,$42,$71,$34,$4E,$D4,$F1,$40,  4,$B9,$80,  0,  3,$9B,$F1,$95,$12,$87,$8C,$A9,$8F,$1F,$2B,$4F,$D3, $A,$9D,$9D,$41,$67,$57,$65,$12,$67,$50,  0,$B1,$C3,$1A,$1A,$4D,$39,$82; 1472
		dc.b $5A,$6C,$26,$C1,$2D,$87,$AC,$30,$B7,$7A,$BB,$28,$93,$3A,$80,$27,$30,$13,$4E,$60,$96,$9B,  9,$B0,$4B,$73,  0,$43,$BB,  9,$E1,$3E, $B,$26,$45,$46,  0,  3,  9,$59,$30,$C6,$D8,$CE,$98,$24,  4,$E0,$F3,  0,$7A,$F7,$F9,$77,  1,$63,$86,$34,$34,$9A,$73,  4,$B4,$D8; 1536
		dc.b $4D,$82,$58,  0,$39,$80,$3A,$FB,$80,$1E,  6,$C9, $D,$56,  9,  3, $B,$24,  0,$92,$81,$8B,$2A,$29,$60,$EB,$26,$45,$D5,$42,$33,$A8,  2,$73,  1,$8B,$41,$BF,$5B,$DE,$1E,  6,$C9, $D,$56,  9,  3, $B,$24,  0,$92,$87,$67,$50,$59,$D5,$D9,$44,$99,$D4,  0,  3,$C2,$56; 1600
		dc.b $4C,$31,$B6,$33,$A6,  9,  4,$EB,$74,$18,  0,  6,$30,$9A,  7,$BD,$3B,$D1,$42,$58,$23,$22,$D8,$28,$2C,$59,$41,$50,$59,$D4,$58,$1B,$E6,$B0,$37,$A5,$A6,$BD,$23,$E2,$7E,$CB,  0,  4,$A0,$F0,$94, $D,$92,$D3,$29,$82,$40,$C0, $D,$54, $C,$59,$51,$4B,  7,$59,$32,$2A; 1664
		dc.b $30,  0,$1B,$E5,$64,$C3,$1B,$63,$55,$70,$A6,$FC,$2D,$BF,$89,$E2,$26,$E2,$78,$A5, $F,$ED,$A9,$DB,$8D,$1F,$8A,$71,  0,  0,$3D,$80,$1E,$C0, $F,$60,  0,  0,$7B,  0,$3D,$80,$1E,$C0,  0,  0,$F6,  0,$7B,  0,$3D,$80,  0,  1,$EC,  0,$7F,$DA,  0,$39,$80,  5, $D,  4; 1728
		dc.b $D4,$34,$4E,$27,$F6,$D4,$3C,$68,$F4,$4A,  1,$FB,$40,  3,$F3,  0, $E,$27,$88,$9B,$89,$E2,$94,$3F,$B6,$A7,$6E,$34,$7E,$29,$C4,  7,$FD,$A0,  3,$9B,$F1,$95,$12,$87,$8C,$A9,$8F,$14,$A4,$B8,$80, $F,$B0,  3,$F6,$80,  7,$FE,$91,$A2,$71,$7A,$71,  9,$C4,$D2,$5C,$52; 1792
		dc.b $80,  9,$7B,  0,$1F,$87,$6C,$B1,$C2,$6C,$12,$C3,$98,  0,  0,$3F,$A4,$68,$9C,$5E,$9C,$42,$71,$34,$4E,$D4,$F1,$40,  4,$B9,$80,  7,$13,$C4,$4D,$C4,$F1,$4A,$1F,$DB,$53,$B7,$1A,$3F,$14,$E2,  5,$7B,$A3,$E0,  1,$FF,$50,  0,  2,$9A,$D3,$7F,$EC,$B4,$4D,$F3,$6F,$7D; 1856
		dc.b $EF,$BC,$EF,$4D,$3F,$4F,$43,$BC,  1,$FF,$50,  0,  0,$7E,$D7,$F6,$4F,$BE,$5B,$D3,$7E,$3B,$F1,$DF,$1E,$CB,$BD,$37,$80,$3D,$80,  0,  1,$EC,  0,$F6,  0,$7B,  0,  0,  3,$D8,  1,$EC,  0,$F6,  0,  0,  7,$B0,  3,$D8,  1,$EC,  0,  0, $F,$60,  3,$FE,$D0,  1,$CC,  1; 1920
		dc.b $AD,$26,$E7,$40,$FF,$C2,$4A,$DF,$F4,$43,$5A,$D2,$9A,$D7,$8D,$78,$D6,$9F,$A2,$4F,$D1,$25,$78,$D7,$8D,$73,$50,  1,$AF,$30,  7,$30,  7,$30,  0,$1C,$C0,$1C,$C0,  0,$73,  0,  1,$CC,  1,$CC,  0,  7,$30,  0,$1C,$C0,$1C,$C0,  0,$73,  0,  1,$CC,  1,$CC,$6E,$D3,$76; 1984
		dc.b $80, $E,$7A,$B4,$CD,$36,$D3,$6D,$2E,$27,$76,$3F,$E6,$4D,$E3,$78,$DE,$37,$FE,$5A,$6D,$E7,$F6,$9F,$96,$DF,$33,$15,$96,$CD,$8E,$D2,$53,$45,$FD,$B6,$8C,$F4,$13,$50,$4C,$AF,$FA,$6F,$E2,$A5,  4,$D4,$9B,$8F,$F9,$57,$5D,$37,$56,  0,$4E,$60,  0,$C1,$BF,$A4,$8C,$18; 2048
		dc.b $30,$6A,$E6,$63,$D7,$F4,$60,  3,$CC,  0,  7,$30,  7,$31,$EF,$D4,  0,  6,$30,$9A,  7,$BD,$3B,$D1,$42,$58,$23,$22,$D8,$28,$2C,$59,$41,$50,$59,$D4,$58,$18,$4D,$60,$60,$96,$9A,  9,$1B,$A7,$65,$80,  2,$50,$78,$4A,  6,$C9,$69,$94,$C1,$20,$60,  6,$AA,  6,$2C,$A8; 2112
		dc.b $A5,$83,$AC,$99,$15,$18,  0, $C,$25,$64,$C3,$1B,$63,$3A,$42,$86,$16,$A0,  3,$98,  0,  0,$39,$80,$12,$B4,$AC,  1,$CC,  0,  0,$1C,$C0,$1E,$96,$F7,$78,$1B,$25,$84,$12,  6,  2,$C2,$65,$11,$3F,$A3,$59,$33,$A8,$B0,$30,$9A,$C0,$C1,$2D,$34,$26,$82,$58,  1,$CC,  0; 2176
		dc.b   0,$1C,$C0,$11,$BA,$76,$89,$86,$AB,  4,$81,$85,$92,  9,$60,  2,$BB,$4A,$25,$8B,$45,$18,  0, $C,$25,$64,$C3,$1B,$63,$3A,$60,$90,$9C,  0,$79,$80,  0,  3,$98,  3,$D2,$DE,$F0,$94, $D,$92,$D3,$29,$82,$40,$C0, $D,$54,$15,$46,$99,$9D,$5D,$94,$49,$9D,$40,$13,$98; 2240
		dc.b   9,$A7,$30,$4B,$4D,$82,$7E,$CA,$15,$CE,  0,  0, $F,$E9,$1A,$27,$17,$A7,$10,$9C,$4D,$13,$7B,$69,$6F,$D1,$98,$6A,$B0,$48,$18,$59,$20,$96,  0,$2B,$B6,$B7,$2A,$29,$60,$EB,$26,$45,$46,  0,  3,  9,$59,$30,$C6,$D8,$CE,$98,$24,$13,$FA,$56,$A0,  0,  0,$39,$BF,$19; 2304
		dc.b $51,$28,$78,$CA,$98,$F1,$FD,$11,$FC,$B5,$3B,  0,$39,$80,  0,  3,$98,  0,  0,$39,$80,  0,  3,$98,  1,$2B,$4A,$C0,$1C,$C0,  0,  1,$CC,  0,  0,$1C,$C0,  0,  1,$CC,  1,$FB,$40,  3,$FB,  0,  0,  3,$D8,  0,  0,$1E,$C0,  0,  0,$F6,  0,$7B,  0,$3D,$80,  0,  1,$EC; 2368
		dc.b   0,  0, $F,$60,  0,  0,$7B,  0,$1B,$7F,$4F,$5B,$80,  7,$FD,$C0, $E,$30,$4E,$F2,$A0, $F,$F7,$28,  3,$AF,$EB,$B3,  0,$7F,$84,  0,$73,$3D,$FD,$CB,$98,  0,$FF,$B8,  3, $E,$BD,$F9,$98,$F7,$40,  0,$7F,$DC,$A0,$7E,$FB,$D0,$5E,  0,$FF,  8,$18,$FA,$1F,$5F,$DF,$CF; 2432
		dc.b $D8,  1,$CC,  1,$5A,$56,  0,$4E,$60, $F,$7F,$DB,$80,$3D,$80,$1B,$B4,$BA,$20, $E,$60, $D,$DA,$6E,$D0,$7F,$D4,$73,  0,$73,  0,$73,  0,$7F,$D4,$7F,$D4,$73,  0,$75,$FD,$A8,  3,$D8, $F,$D9,$7E,$D8, $F,$FA,$8E,$60, $F,$DB,$FE,$D4,  0,  0,  0,  0,  6,$59,$E5,$7D; 2496
		dc.b $57,$E7,$92,$B4,$59,$58,$B2,$95,$A1,$56,$52,$D1,$FE,$1A,$96,$FE, $D,$CB,$EE,$55,$22,$97,$2F,$E8,$FA,$B7,$A3,$23,$29,$B8,$C6,$B9,$37,$A1,$68,$DC,$6E,$52,$D1,$68,$DC,$AC,$55,$8A,$A2,$DC,$6E,$5B,$8F,$56,$F4,$63,$72,$9B,$8D,$16,$88,$D1,$B9,$6E,$37,$45,$A2,$D1; 2560
		dc.b $B8,$DC,$6E,$53,$E8,$8A,$57,$F4,$71,$FD,$1F,$A5,$CB,$2B,$8A,$D6,$D4,$5A,$7E,$8D,$2E,$56,$31,$68,$B4,$6E,$5B,$8D,$D1,$6F,$E0,$B1,$5F,$E1,$AD,$DD,$4B,$15,$FD,$19,$62,$C9,$E8,$C8,$C6,$EF,$46,$EA,$59,$3F,$86,$5A,$5D,$4F,$A7,$E8,$CA,$DC,$54,$C4,$D2,$2C,$B7,$52; 2624
		dc.b $2C,$AC,$8C,$55,$8D,$15,$95,$15,$94,$AB,$23,$2B,$22,$DC,$A9,$FA,$35,$2C,$54,$D1,$4C,$6E,$8B,$2B,$46,$EA,$70,$A2,$DF,$91,$CA,$AC,$96,$F4,$CC,$D5,$5F,  3,$95,$57,$AD,$FC, $E,$55,$5F,$C3,$A6,$39,$C7,$92,$7E,$EB,$96,$57,$D2,$AE,$59,$9A,$5C,$79,$67,$CA,$AC,$8F; 2688
		dc.b $4A,$AF,$C8,$F0,$AE,$A3,$91,$E1,$7A,$DF,$52,$74,$E1,$7D,$5C,$A3,$9C,$B9,$7E,$EA,$59,$F2,$AA,$97,$E4,$B7,$F0,$5B,$F3,$AA,$6B,$9F,$F4,$78,$B1,$67,$B8,$AC,$98,$C4,$A9,$FD,$1C,$64,$C8,$C6,$38,$FF,$CE,$E4,$FE,$8B,$2C,$BF,$4F,$13,$B8,$A9,$D9,$52,$26,$3B,$95,$8A; 2752
		dc.b $95,$D8,$AB,$29,$53,$4D,$3B,$7E,$D4,  0,$26,$69,$7B,$AB,$16,$53,$12,$A5,$A8,$DF,$B2,  2,$4D,$26,$76,$2C,$AD,$25,$65,$2B,$72,$95,$DC,$55,$37,$18,$95,$3C,$76,$3C,$53,$62,$BB,$1D,$95,$37,$3E,$C9,$D7,$63,$17,$8C,$98,$27,$F0,$CD,$D4,$D2,$BF,$D1,$A6,$C5,$65,$B8; 2816
		dc.b $AC,$9B,$65,$76,$2A,$54,$B1,$67,$67,$FD,$18,$4B,$8F,$F9,$FB,$27,$F0,$CD,$C7,$A9,$F4,$FD,$BA,$A6,$C6,$27,$63,$B1,$54,$8E,$C5,$4F,$E8,$CC,$66,$ED,$B7,$8F,$D3,$F6,$62,$D3,$5D,$35,$D8,$F1,$8D,$CF,$B1,$52,$C9,$1D,$CA,$6E,$2A,$9B,$45,$23,$5E,$9B,$1B,$9D,$83,  0; 2880
		dc.b   6,$BE,$FF,$A2,$DF,$FA,$32,$B3,$31,$53,$B4,$CB,$8B,$22,$8C,$58,$27,$6D,$BF,$A8,$AD,$12,$D2,$8A,$31,$6D,$8A,$98,$B2,$7E,$DC,$AA,$2E,$31,$4D,$A5,$B1,$54,$FD,$39,$ED,$A5,$7F,$A5,  0,$30,$69,$94,$FF,$4F,$6F,$44,$BB,$7F,$E8,$8A,$D6,$ED,$19,$AE,$5C,$7F,$47,$32; 2944
		dc.b $B2,$31,$62,$B2,$FE,$9C,$99,$F7,$FE,$8B,$F4,$BD,$B6,$96,$E3,$19,$2E,$AB,$28,$D2,$27,$62,$B7,$16,$54,$B9,$4D,$CB,$B1,$65,$FD,$1A,$CB,$F4,$6E,$C9,$1D,$C5,$8B,$29,$D9,$D9,$4E,$E4,$65,$FD,$3A,$96,$53,$BA,$2C,$7A,$95,$63,$FC,$33,$FB,$4D,$DD,$B6,$56,$8B,$1B,$94; 3008
		dc.b $C5,$B1,$F7,$48,$DC,$7F,$47,$B1,$52,$AC,$59,$76,$3D,$59,$4E,$E5,$DC,$BF,$B5,$A7,$1D,$94,$B1,$B8,$7A,$1B,$91,$52,$E4,$F4,$2C,$8A,$7F,$4E,$D1,$3B,$75,$D8,$EC,$B2,$D8,$F1,$F4,$FC,$B7,$F4,$77,$34,$A2,$54,$B7,$A1,$56,$4F,$D1,$AE,$AC,$18,$1A,$6F,$FD,$13,$4B,$F6; 3072
		dc.b $EB,$71,$5D,$C7,$65,$2A,$63,$B9,$7F,$87,$19,$BD,$F5,$61,$BF,$FC,$9B,$7A,$24,$4F,$E9,$E2,$76,$45,$3B,$1D,$A2,$FB,$44,$A9,$EB,$B7,$E8,$DF,$69,$5C,$63,$DB,$7F,$6D,$38,$EE,$2A,$63,$4E,$B2,$68,$EC,$56,$6D,$D1,$45,$31,$D8,$C4,$A9,$65,$FD,$BC,$9B,$AE,$ED,$FD,$BF; 3136
		dc.b $4C,$B2,$5D,$8E,$CA,$55,$3F,$4E,$A9,$B1,$D9,$76,$2A,$77,$29,$8E,$E4,$89,$62,$BB,$18,$A2,$98,$DD,$25,$4B,$8D,$CA,$58,$DC,$59,$51,$8D,$CB,$B2,$B2,$32,$6C,$8D,$2F,$42,$D2,$F7,  0,$FE,$8D,$2E,$48,$96,$8B,$2E,$CF,$B2,$EC,$BB,$4B,$71,$5D,$9B,$D3,$F4,$EA,$54,$B7; 3200
		dc.b $A1,$62,$C7,$F8,$7A,$C7,$F4,$65,$8E,$E8,$A3,$26,$C5,$5F,$68,$DC,$58,$AD,$C9,$71,$64,$B9,$5B,$16,$57,$B7,$95,$B0,$B4,$D1,$EF,$F7,$11,$AD,$2E,$4B,$92,$37, $B,$93,$F6,$4F,$DD,$DE,$FE,$A9,$72,$56,$FE,$FE,$41,$3D,$E2,$13,$DE,$3F,$BF,$FD,$E0,  0,$3F,$7F,$70,$4E; 3264
		dc.b $FE,$A9,$DF,$DD,$DE,  0,$1D,$FE,$53,$5D,$E4,$91,$4B,$93,$B9,$23,$E5,$DD,$35,$C9,$14,$FE,$9D,$6F,$72,$7B,$C4,$24,$5E,$35,$F5,$AD,$22,$F1,$4B,$A2,$91,$4B,$87,$5F,$70,$97,$57,$77,$77,$94,$5F,$BA,$68,$FB,$F7,$5D,$FB,$21,$75,$7D,$66,$EA,$95,$A5,$77,$7E,$F9,$FB; 3328
		dc.b $93,$DD,$EB,$4B,$BB,$A2,$3F,$A6,$1E,$E8,$D7,$75,$77,$4D,$D6,$E8,$A7,$5B,$92,$7C,$6E,$3F,$AD,$8A,$51,$29,$EA,$21,$84,$FD,$D3,$F9,$5A,$79,$A2,$97,$24,$7D,$E4,$AF,$14,$8D,$C8,$B2,$89,$52,$B3,$DA,$79,$61,$39,$A1,$9E,$8D,$E5,$35,$C9,$E4,$91,$F2,$BB,$A8,$B9,$23; 3392
		dc.b $74,$42,$7B,$FE,$CB,$CB,$B8,$5D,$1F,$24,$B9,$23,$DC,$2B,$BA,$21,$23,$EF,$37,$51,$EE,$91,$7A,$C2,$5C,$9E,$E3,$DD,$3D,$EB,$13,$56,$9E,$E0,$25,$C1,$FA,$A7,$5A,$C2,$4F,$68,$FB,$A7,$76,$10,$AC,$E1,$3E,$CF,  5,$96,$DD,$C8,$D5,$1D,$FB,$15,$67,$DF,$43,$71,$F2,$F5; 3456
		dc.b $17,$24,$52,$35,$A5,$A7,$D6,$9F,$BD,$B4,$EF,$59,$84,$F2,$A6,$D3,$AB,$1F,$2B,$55,$71,$80,$8D,$7F,$C1,$94,$6D,$38,$53,$EB,$DE,$F4,$3B,$93,$3B,$50,$ED,$BD,$33,$B7,$AD,$A7,$86,  1,$27,$EE,$9D,$33,$B3,$F9,$4B,$67,$D8,$C2,$A9,$CF,$E8,$B0,$52,$D0,$33,$CA,$78,$2C; 3520
		dc.b $27,$A4,$2C,$69,$6C,$1E,$92,$A0,$A4,$BB,$BB,$C2,$77,$5D,$19,$A3,$EA,$95,$A4,$FF,$AF,$C2,$18,$77,$E1,$DD,$4D,$7C,$A8,$62,$FD,$C1,$3F,$A6,$1E,$E8,$FB,$FE,$C8,$5D,$14,$8B,$F5,$48,$BD,$C9,$70,$4F,$E9,$D7,$1A,$D2,$23,$AD,$D1,$4B,$A2,$26,$88,$4B,$92,$29,$E5,$D4; 3584
		dc.b $25, $F,$74,$5F,$75,$A7,$EE,$D8,$ED,$2D,$8E,$D8,$EE,$A1,$A6,$CF,$84,$A8,$69,$B2,$FA,$DB,$D6,$B8,$8B,$4F,$6C,$D2,$22,$69,$ED,$2C,$A7,$C2,$92,$C1,$4C,$2B,$45,$B8,$DF,$55,$EB, $F,$5C,$B3,$5A,$A5,$52,$9A,$B9,$70,$AA,$F3,$55,$7C,$2F,$AA,$F5,$E8,$97,$D5,$7E,$49; 3648
		dc.b $E7,$D2,$59,$DD,$D3,$3C,$AA,$CF,$91,$CF,$D1,$E3,$56,$4E,$B9,$9E,$1C,$8E,$66,$AB,$B9,$4A,$AE,$87,$3B,$EA,$CE,$FA,$8D,$55,$AE,$77,$D5,$7D,$7D,$2F,$AB,$2B,$F8,$1E,$55,$65,$8F,$9F,$49,$5F,$E7,$D1,$3C,$DF,$85,$D9,$55,$79,$E1,$CB,$2A,$AF,$3C,$B3,$7A,$9A,$FC,$CD; 3712
		dc.b $49,$E6,$6F,$A8,$E4,$6F,$E1,$7F,$9E,$46,$FB,$AA,$39,$1E,$15,$D4,$72,$3C,$2F,$5B,$EA,$4E,$9C,$2F,$AB,$94,$73,$97,$2F,$DD,$4B,$3E,$55,$52,$FC,$96,$FE, $B,$7E,$75,  0,  0,$4F,$1A,  7,$F1,$A0, $F,$5E,$80, $D,  2,$7E,$59,$34,  0,  0,  2,$78,$D0,  0,$13,$4F,$1A; 3776
		dc.b   0,$9A,$78,$D2,$6F,$15,$A7,$80,  0, $F,$A2,$46,$B0,$F1,  0,  0,$9B,$9E,$B0,$37,$45,$3F,$2C,  0,$1F,$B5,$FD,$A0,$7F,$1A,  0,$26,$88,$7F,  2,$6D,  0, $F,$A4,$7F,$2C,$13,$44,$FC,$B0,  0,  4,$F1,$F9,$6F,  1,$3C,$56,  0,  1,$34,$13,$68,  0,$F1,$A0,  0,$26,$9E; 3840
		dc.b $34, $F,$A0,  1,$F4,$4D,  2,$78,$88,$78,$80,  2,$44,$26,$9F,$96,$8E,$82,$68,$80,  0,$4F,$CB,$27,$80,$9F,$96,  0,$25,$60,$3C,$77,  0,$9F,$96, $F,$A0,$13,$69,$F9,$68,$EE,  0,  7,$D3,$F2,$C0,$69,$F9,$6D,$3C,  1,$BA,$21,$EB,$FD,$BB,$EE,$AF,$C0,$D1,$3C,  0,  2; 3904
		dc.b $68,$9D,$7C,$6E,$D0,$27,$8F,$CB,$24,$40,$7A,$FC, $D,$22,  3,$C7,$75,$7A,  1,$10,  0,$9B,$4D,$DE,$37,  4,$88,  0,  1,$F9,$6A,$C0,  1,$FF,$2D,$58, $F,$10,$F1,  0,  1,$37,$50,$26,$88,  0,$3C,$52,$B0,$26,$AC,  7,$DC,$13,$48,$FE,$5A,$B0,$34,$88,  2,$21,$F4,$4A; 3968
		dc.b $C0,  0,$25,$69,$58,  0,  0,  0,$D3,$F2,$D1,$D0,  4,$8A,$6E, $F,$14,$FD,$B8,$7A,$D3,$4F,$CB,  0,  2,$56,$91,$9B,$70,$D3,$FA,$40,$3D,$61,$37,$56,  3,$EE,$AD,$34,$1B,$80,$15,$A6,$E0,$3F,$2D,$E3,$F6,$40,  0,$91,$78,$A5,$61,$34,$4D,$2B,  0,  4,$DC,$37,$56,$1F; 4032
		dc.b $70,  0,  7,$AF,$70,$7A,$F7,  0,  4,$DB,$9E,$B0,$FD,$6E,$5C,$CD,$5D,$25,$79,$AA,$BE,  7,$2A,$AF,$5B,$F8,$1C,$AA,$BF,$87,$4C,$73,$8F,$24,$FD,$D7,$2C,$AF,$A5,$5C,$B3,$2B,$4C,$EF,$8E,$66,$AC,$8D,$F7,$7E,$E9,$3A,$79,$DD,$C1,$F9,$70,$37,$D5,$91,$CF,$91,$BE,$AC; 4096
		dc.b $8E,$77,$B5,$52,$AA,$F3,$E6,$95,$65,$9F,$F0,$72,  9,$E3,$40,  0, $F,$E3,$40,  0,$4F,$DA,$56,  2,$75,  0,  0,  3,$C4,  9,$A2,  6,$EA,$D3,$70,$9B,$F6,$5A,$56,  2,$68,$9B,$80,  1,$3F,$AA,  5,$60,$4D,$59,$E1,$95,$F5,$25,$57,$45,$92,$AE,$95,$67,$78,$13,$78,  0; 4160
		dc.b   9,$A2,  3,$E9,$B8, $C,$B8,$65,$86,$F4,$5B,$A3,$7A,$55,$D2,$AC,$EF, $F,$A0,$FD,$90,$1A,$6E,$AC,$26,$95,$87,$F1,$A0,$AC,  4,$8A,$6E,  9,$FD,$50,  0,$4F,$DA,$80,$34,  9,$A6,$E0,  3,$E8,$26,$D3,$76,$81,$E3,$A0,  0,$56,$3C,$47,$75,$60,$4D,$58,$FC,$B6,$E7,$AF; 4224
		dc.b $F6,$E1,$2B,$DD,$A5,$63,$F6,$43,$4A,$C0,  2,$BD,  0,$4F,$D9,  0,$3F,$6E,$13,$4D,$D5,$80,  0,  1,$34,$4D,$2B,  9,$A0,$DC,  0,$AC,$25,$F5,$67,$D3,$34,$52,$D1,$64,$B9,$4B,$2D,$57,$C6,$E5,$62,$AC,$55,$16,$E3,$72,$DC,$7A,$B7,$A3,$1B,$94,$B5,$59,$67,$CB,$CE,$F1; 4288
		dc.b $BB,$4A,$C0,$9A,$B4,$FD,$BD,$61,$32,$E1,$D3,$3A,$D4,$B4,$59,$2E,$52,$CA,$91,$B9,$5A,$FC,$98,$AA,$45,$2E,$5F,$D1,$F5,$6F,$46,$46,$53,$71,$9E,$D7,$F9,$DF,$D0, $F,$DB,$D6,  2,$57,$A6,$E0,$F5,$80,  3,$D7,$B9,$2B,  3,$F6,$E9,$58,$7D,  0,$4D,$D5,$80,$F5,$E9,$E2; 4352
		dc.b $B0,  0,$78,$BF,$ED,$C3,$FE,$DC,  0,$1F,$F6,$F5,$80,$95,$EE,  0,  9,$B4,$4F,$DA,$D6,$13,$4D,$C1,$F4,$DD,$58,  9,$FB,$77,$FD,$93,$C7,$87,$5F,$1E,$77,$44,  0,$37,$25,$69,$FB,$AF,$EC,$D7,$75,$69,$FB,$BA,$9B,$39,$97,$33,$CB,$81,$CD,$39,$5D,$51,$AA,$FC,$CF,$4A; 4416
		dc.b $8A,$D7,$51,$AA,$FC,$FA,$57,$7D,$57,$E7,$79,$E1,$7E,$55,$5E,$D9,$1B,$F3,$6A,$AF,$65,$37,$F0,$A8,$DF,$57, $E,$55,$1A,$AF,$E1,$5D,$46,$AB,$D3,$A2,$DF,$D3,$CD,$32,$BF,$A5,$D9,$CB,$33,$CB,$3A,$B2,$CF,$2F,$D1,$AE,$55,$5E,$1F,$39,$57,$7F, $B,$FA,$26,$54,$37,$A7; 4480
		dc.b   3,$9F,$4B,$AB,$F3,$8D,$DD,$6B,$BA,$8A,$6A,$FD,$4A,$D2,$39,$4B,$3F,$3E,$89,$E6,$FC,$2E,$CA,$AB,$CF, $E,$59,$55,$79,$E5,$9B,$D4,$D7,$E6,$6A,$4F,$33,$7D,$57,$B4,$7C,$55,$78,$7D,$C9,$9D,$F5,$D5,$7D,$71,$4A,$64,$8D,$4E,$55,$1E,$17,$27,$9F,$F0,$94,$FA,$72,$CB; 4544
		dc.b $85,$FD,  2,$7E,$C8,$68,$26,$DD,$FA,$9F,$D4,$5D,$E8,$63,$C3,$F7,$BD,$39,  1,$FB,$7A,$C3,$D6,$F5,$CD,$D7,$84,$73,$4B,$DA,$F3,$96,$69,$7A,$E5,$52,$F9,$A7,$4F,$3B,$B8,$3F,$2E,  6,$FA,$B2,$39,$F2,$37,$D5,$91,$CE,$F6,$AA,$55,$5E,$7C,$D3,$CE,$FC,$6A,$E1,$C9,$F3; 4608
		dc.b $A3,$53,$27,$F3,$E8,$95,$6B,$50,$4F,$D4,$FE,$A1,$3F,$53,$C1,$B5,$C8, $F,$3F,$D5,$CA,$AA,$5D,$4E,$49,$FA,$8F,$D4,$9C,$F5,$6C,$BC,$DF,$A5,$1A,$F7,$AA,$BB,$DF,$CF,$21,$E7,$D2,$59,$D1,$A9,$94,$B8,$72,$7F,$3C,$93,$85,$ED,$56,$49,$C3,$93,$FE,$A3,$F5,$3F,$A8,$5A; 4672
		dc.b $37,$E8,$B3,$37,$F9,$F4,$A8,$1F,$D4,$FE,$A9,$3F,$53,$E9,$C2,$5F,$AB,$FD,$46,$55,$3F, $C,$AA,$CF,$91,$CE,$59,$DD,$D2,$FC,$93,$CF,$A5,$EB,$D1,$2F,$A8,$D5,$5F, $B,$EA,$35,$72,$E1,$57,$26,$E1,$91,$AA,$F3,$7F, $E,$95,$72,$3C,$2F,$CA,$AB,$FA,$57,$7D,$57,$E6,$B5; 4736
		dc.b $D4,$6A,$BF,$3A,$AF,$CC,$F4,$AA,$5C,$AE,$A8,$E6,$79,$70,$39,$AE,$79,$1C,$AA,$BF,$85,$F5,$2D,$59,$66,$A0,$63, $B,$60,  0,  1,$E0,$A5,$40,$99,$80,$97,$72,$95,$3E,$5F,$BF,$F5,  0,  0,$2E,$F2,$7E,$EF,$28,$5B,  0,  6,  0,$4A,  1,$19,$FB,$FB,$B0,  2,$68,$61,$8C; 4800
		dc.b   0,$4F,$29,$F1,$F2,$A7,$72,$B2,$BD,$C2,$50,$50,$24,$D4,  2,$CB,$46,$F2,$85,$80,  1,$A8,$A0,$63,$87,$E8,$ED,$87,$EB,$E2,$25,$EE,$62,$1D,$44,$AE,$93,$6A,$AD,$46,$B6,  0,$24,$6E,$9F,  2,$B5,$DC,$31,$A1,$52,$A5,$66,$C2,$78,$79,$7E,$B6,$50,$B6,  0,  7,$82,$A6; 4864
		dc.b   0,$4A,$1D,$DE,$40,  0,$12,$16,$F2, $F, $B,$57,$DD,$80,$92,$D2,$E4,$EF,$12,$60,$12,$38,$E0,$DD,$C6,$8B,$32,$85,$38, $A,$5B,  2,$C1,$82,$29,$F2,$96,$FA,$AC,$9F,$AC,$7A,$C6,$B4,  9,$A2,$50,  7,$D0,$4D,$B8,$4D,$58,  3,$5A,$78,$D0,  4,$A1,$E2,$BA,  0,$94,$14; 4928
		dc.b $3B,$63,$DA,$B1,$8F,$60,  0,$12,$AE,$55,$9A,$C0,$12,$AC,  0, $D,$60,$4D,$58,  0,$77,$7F,$30, $C,$68,$C6,$71,$70,  8,$B2,$C2,$8C,$5A,$D8,$4F,$26,$59,$42,$8C,$98,$62,$DA,$AB,$AB,$AB,$AE,$2D,$8F,$EF,$3D,$78,$79,  7,$DC,  4,$D5,$80,$94,$D6,$80,  0,  0,$3D,$F6; 4992
		dc.b $C2,$7B,$6A,$A1,$22,$CA, $A,$F7,$DC,$24,$C3,$D0,$E1,$EB,$82,$B0,$13,$2A,$2F,$90,$C0,$B2,$89,$AF,$CF,$BB,$F5,$94,$D6,$87,$6A,$C3,$ED,$41,$35,  0,$4A,  1,$AD,  0,  2,$68,$5B,  0,$1E, $A,$5B, $C,$69,$8A,$E3, $B,$25,$31,$89,$54,$5B,$77,$D8,$D0,$DB,$15,$B0,$30; 5056
		dc.b $C1,$D9,$ED,$29,$DE,$92,$53,$82,$33,$AA,$2A,$55,$9F,$77, $C,$33,$3C,$53,$B6,$34,$4D,$E7,$7E,$D4,$9A,$80, $D,$77,$EB,$BC,  0,  0,  0, $C,$7B,$DE,$D8,$51,$75,$69,$CC,$2C,$C5,$52,$79,$BD,$61,$6F,$29,$F0,  3,$C8,$6A,$B2,$86,  5,$4F,$96,$34,$63,$84,$A7,$B6,$57; 5120
		dc.b $E1, $C,$24,$BB,$F1,$A6,$F0,$26,$A0,$13,$6F,$97,$6A,$F1,$5A,$CE,$F1,$2D,$E0,  0,  0,  0,$42,$C2,$65,$6C,  4,$AD,$82,$2E,$2C,$F8,$4D,$62,$C8,$A7,  4,$5C,$5A,$4A,$8B,$25,$94,$FE,$5F,$CD,  3,  4,$B6,  2,$4B,$39,$65,$C2,$79,$60,$91,$9E,$4A,$8A,$7D,$70,$FE,$68; 5184
		dc.b   0,$27,$96,$AB,$3A,$58,$E0,$B2,$C1,$8E,$1F,$AD,$3E,$40,$63,$6C,  4,$CC,$B3,$E1,$3A,$60,$91,$3E,$A5,$4A,$FE,$F7, $F,$D6,$80,$1F,$40,$9E,$34,$DC,$13,$4F,$17,$2E,$66,$A7,$A9,$2A,$E5,$C2,$AB,$CD,$55,$F0,$BE,$AB,$D7,$A2,$5F,$55,$F9,$27,$9F,$49,$67,$77,$4C,$F2; 5248
		dc.b $AB,$3E,$47,$3A,$1A,$AF,$E0,$73,$A6,$46,$FE,  7,$81,$E1,$C8,$E6,$6A,$BB,$94,$AA,$E8,$73,$BE,$AC,$EF,$A8,$D5,$5A,$E7,$7D,$57,$D7,$D2,$FA,$B2,$BF,$81,$BE,$7C,$AA,$FD,$A4,$F8,$EF,$5D,$FB,$3E,$FE,$C9,$E1,$16,$6D,$EA,$EA,$9B,$E5,$C7,$6D,$E9,$1C,$57,$85,$66,$85; 5312
		dc.b $7D,$52,$92,$E2,$F4,$DF,$AE,$9C,$46,$3D,$8F,$5C,$95,$37,$72,$AB,$7A,$EF,$4E, $B,$DB,$79,$AC,  0,$34,$F1,$58,  9,$A4,$7F,$2D,$58,  0,$24,$40,$9B,$C2,$56,  2,$56,  0,$13,$6E,$8D,$60,  0,$9B,$80,$7F,$1B,$B4,$AC,  0,  4,$53,$40,$9F,$D5,$7F,$1A,  1,$5B,$E8,$12; 5376
		dc.b $B8,$81,$FB,$21,$58,$11,$AC,$25,$71, $F,$5C,$6B,  9,$A0,$9B,$74,$A8,$1E,$21,$EB,$D2,$80,  1,$2B,$F3,$C9,$7A,$79,$E7,$7D,$57,$D7,$D2,$FA,$B2,$BF,$81,$BF,$3C,$AA,$EB,$98,  0,$75,$E9,$E7,$2C,$EE,$E9,$9E,$55,$67,$C8,$E7,$7D,$59,$75,$BC,  0,$23,$CB,$84,$73,$3C; 5440
		dc.b $39,$1E,$17,$D5,$91,$CB,$38,$E7,$95,$4B,$55,$F9,$80,  4,$79,$70,$8D,$F5,$70,$E5,$51,$BE,$A3,$97,  6,$BE,$3D,$AD,$EB,$E6,  0,$4D,$E3,$7C,$66,$DC,$1F,$4A,$F6,$A0,$9B,$7E,$3B,$C6,$3F,$A7,$1A,$D3,$1A,$F4,$4A,$4B,$78,$1B,$D2,$80,  7,$EC,$9B,$DF,$B0,$4D,$93,$7E; 5504
		dc.b $3E,  6,$AB,$BF,$1E,$3B,$27,$A2,$50,$A9,$E1,$5A,$2E,$F9,$F0,$9B,$88,$D7,$8C,$DD,$82,$98,$E5,$E9,$BB,$95,$48,$A9,$C9,$33,$56,$A8,$D4,$99,$9A,$92,$AE,$5C,$2A,$BC,$D5,$5F, $B,$EA,$BD,$7A,$25,$F5,$5F,$92,$79,$F4,$96,$77,$74,$CF,$2A,$B3,$E4,$78,$65,$53,$FE,$A3; 5568
		dc.b $93,$E7,$46,$A6,$4F,$E7,$D0, $C,$7F,$53,$FA,$84,$FD,$4F,  6,$D7,$29,$74,$AB,$1C,$AB,$CF,$1B,$F8,  0,$73,$D5,$B2,$F3,$7E,$9E,$60,  0,$FF,$A9,$FD,$52,$7E,$A7,$D3,$84,$BF,$57,$C0,  0,$1F,$87,$27,$E1,$7B,$6B,$50,  0, $B,$F5,$6F,$D5,$BD,$5F,$AB,  0,$63,$E7,$96; 5632
		dc.b $35,$51,$B3,$E5,$2F,$D4,$72,  0,  0,  0,$7E,$9E,$6F,$95,$1A,$99,$BF,$2E,  0,  0,$25,$FA,$9E,  7,$95,$D4,$6C,$CF,$2F,$3E,$84,  0; 5696
UnkComp_Map128_GHZ:dc.b	 $A,$E3,$D1,$A3,$E8,$FA,$3F,$E8,$FF,$A1,$F4,$5D,$17,$44,$8F,$A2,$E8,$B1,$FF,$47,$F4,$7F,$47,$D1,$D1,$A3,$44,$51,$A2,$42,$8F,$D1,$23,$FF,$FC, $F,$F1,$8F,$9C,$4C,$7A,$31,$D1,$A3,$F4,$42,$87,$42,$8D,$17,$46,$8D,$12,$34,$68,$F4,$68,$E8,$D1,$A3,$46,$95,$3F,$D3; 0
					; DATA XREF: ROM:0001BFF4o
					; ROM:0001C054o
		dc.b $27,$FA,$54,$FF,$4A,$9F,$E9,$D1,$D1,$F4,$C8,$FA,$7E,$8F,$A3,$15,$6A,$D1,$AB,$57,$46,$8F,$E3,$FF,$FF,$FE,$9F,$FE,$9F,$56,$AD,$1F,$A3,$84,$28,$F0,$45,$17,  1,$18,$46,$8C,$AB,$4E,$9D,$3A,$74,$E9,$42,$D4,$E9,$42,$F4,$E1,$7E,$28,$6B, $F,$E8,$49,$FD, $E,$CF,$F4; 64
		dc.b $74,$74,$68,$74,$3A,$74,$74,$45,$1D,$1E,$BD,  9,$29,$D1,$F9,$3E,$8F,$13,$FF,$89,$5F,$EA,$14,$AE,$5C,$9D,$7A,$35,$E8,$F4,$E8,$95,$F4,$24,$7D,$1F,$66,$8D,$93,$35,$6B,$DB,$AD,$6E,$B9,$BA,$F6,$EB,$DB,$A3,$6E,$8B,$6E,$A6,$91,$BA,$16,$E8,$6E,$D5,$C9,$57,$B4,$21; 128
		dc.b $28,$DA,$14,$7D,$22,$14,$69,$11,$A4,$88,$4F,$4D,$4E,$89,$22,$72,$BD,$19,$B7,$47,$46,$8D,$12,$34,$68,$D1,$AB,$B5,$D1,$ED,$D1,$D4,$58,$26,$48,$B8,$27,$D1,$94,$DA,$3D,$1A,$3A,$32,$94,$F1,  9,$FC,  0,$AD,$A1,$68,$8D,$7A,$D4,$6B,$9B,$D1,$BF,$6E,$9D,$3D,$BA,$35; 192
		dc.b $C8,$53,$BF,$46,$DC,$23,$46,$CD,$1A,$37,$68,$50,$B3,$46,$8D,$1A,$36,$7A,$34,$7A,$14,$75,$E8,$D1,$A3,  8,$F4,$68,$FC,$68,$EE,$10,$FA,$1B,$84,$28,$D3,$A7,$47,$4E,$8D,$1A,$34,$74,$68,$D5,$AF,$6E,$ED,$1B,$B4,$6E,$D1,$BB,$46,$DD,$1B,$7A,$1B,$87,$77, $E,$D0,$F7; 256
		dc.b $6E,$5C,$BB, $E,$D1,$B8,$42,  3,$9B,$B4,$5E,$ED,$1F,$47,$FB,$9F,$C5,$27,$E7,$E7,$CA,$4E,$9D,$FB,$37,$EE,$31,$60,$C6,$E2,$FD,$83,  7,$76,$2C,$51,$A3,$42,$A6,$8D,$1A,$16,$6C,$DD,$B7,$66,$AD,$1D,$1B,  4,$68,$D1,$AC,$47,$E0,$6C,$BB,$A4,$68,$95,$A3,$6E,$8D, $A; 320
		dc.b $34,$68,$91,$23,$46,$E1,$22,$37,$48,$C7,$80,$88,$27,$A2,$58,$9D,$FA,$36,$F4,$68,$D3,$A2,$B7,$5E,$8D,$3A,$F4,$69,$11,$A4,$4B,$A3,$E9,$74,$E9,$29,$74,$A8,$53,$A7,$46,$8D,$3D, $F,$43,$4A,$BB,$43,$5E,$B1,$24,$A7,$4E,$BD,$BB,$76,$E9,$D1,$B7,$5E,$9D,$1A,$71,$5E; 384
		dc.b $BB,$5F,$A7,$94,$E9,$D0,$B3,$5C,$CD,$9B,$34,$68,$D1,$D1,$A2,$B3,$4B,$A3,  8,$D4,$23,$5A,$8D,$5A,$A4,$68,$99,$B3,$46,$AD,$AA,$B6,$EA,$D5,$A3,$56,$8D, $A,$B4,$CA,$D5,$A1,$57,$7E,$8F,$F4,$7F,$E8,$E6,$8E,$50,$A7,$D1,$A7,$D1,$F4,$BA,$37,$72,$FD,$1E,$8D,$1D,$1B; 448
		dc.b $9E,$8D,$5A,$15,  8,$C2,$34,$E9,$D0,$A3,$57,$A3,$A3,$F4,$60,$7E,$90,$FF,$9F,$A4,$F8,$FD,$FA,$35,$EB,$D7,$A3,$46,$AC,$A3,$42,$8D,$1A,$35,$EB,$D1,$B3,$46,$FD,$1B,$77,$5F,$D0,$D7,$7F,$F5,$AC,$D9,$B7,$A3,$46,$8D,$1A,$27,$F4,$74,$45,$19,$28,$91,$A9,$F4,$28,$D1; 512
		dc.b $A2,$46,$8D,$1A,$43,$F4,$2D,$D1,$B7,$46,$AD,$DA,$34,$68,$D1,$A3,$4E,$EB,$D9,$10,$F3,$94,$3F,$F0,$84,$59,$A1,$5E,$BD,$13,$F0,$8C,$23,$7B,$E0,$A1,$45,$83,$28,$50,$A1,$79,$44,$AD,$FB,$D4,$6D,$D8,$A2,$7E,$F1,$9A,$34,$68,$D0,$A3,$21,$DA,$30,$51,$82,$BD,$7A,$76; 576
		dc.b $69,$D3,$BD,$46,$ED,$1A,$34,$6D,$D9,$BB,$56,$8D,$7A,$35,$E8,$D1,$A3,$46,$9D,$1A,$34,$7F,$47,$F4,$7F,$47,$F4,$5D,  9,$A2,$E8,$51,$F4,$28,$BF,  8,$47,$D1,$A1,$E8,$D0,$F4,$68,$68,$CF,$A3,$E8,$FD,$1A,$1E,$89,$1F,$FE,$31,$FF,$8C,$77,$EF,$D9,$2E,$46,$CD,$93,$36; 640
		dc.b $4C,$57,$AF,$67,$46,$11,$FE,$68,$C8,$7E,$89, $B,  6,$6C,$59,$86,$88,$D9,$B3,$46,$CC,$A3,$6F,$A2,$BB,$46,$8D,$1B,$7B,$FA,$44,$3F,$CB,$84,$FE,$FD,$30,$48,$9D,$1B,$B4,$E9,$D1,$FF,$BF,  1,$53,$F7,$88,$55,$3B,$76,$ED,$D3,$B4,$2E,$4A,$37,$C9,$D1,$FF,$47,$FD,$1F; 704
		dc.b $F4,$7F,$D9,$D9,$A3,$F0,$8F,$F0,$3C,$51,$D1,$D9,$FF,$FF,$FF,$1F,$FD,$7C,$AB,$46,$AC,$A3,$5E,$8D,$18,$6E,$91,$A2,$3F,$FD,$22,$51,$F4,$C9,$61,$98,$46,$AC,$A3,$46,$8D,$7A,$16,$EA,$21,$42,$BF,$9A,$BA,$53,$57,$58,$AD,$5A,$D7,$F7,$2B,$91,$B8,$56,$89,$CA,$F9,$B8; 768
		dc.b $A3,$47,$FD,$1F,$FD,$1F,$F4,$88,$D1,$A8,$46,$51,$D1,$9F,$44,$8B,$F4,$48,$BF,$67,$46,$8D,$BB,$34,$6D,$D3,$A3,$AB,$B9,$B8,$43,$2E,$C0,$56,$ED,$1B,$75,$68,$F6,$D4,$6D,$D7,$AB,$7A,$F5,$1F,$4C,$8F,$DF,$23,$F5,$78,$EA,$FE,$AF,$FA,$BA,$B5,$88,$C2,$3A,$BA,$31,$E9; 832
		dc.b $51,$8E,$42,$35,$69,$51,$2B,$76,$89,$22,$75,$6B,$D5,$A3,$56,$E9,$1A,$44,$6E,$DF,$BF,$4E,$8D,$93,$A7,$E8,$D1,$B1,$54,$8D,$52,$7E,$38,$F0,$BE,$3E,$BE,$1B,$23,$2B,$D1,$AF,$14,$6B,$D1,$AF,$34,$3A,$21,$D1,$51,$3B, $B,$82,$F4,$6E,$D7,$B7,$5E,$8D,$1B,$B6,$6E,$D1; 896
		dc.b $BB,$66,$85,$9A,$15,$AD,$D0,$B3,$62,$D5,$DA,$56,$6E,$CB,$B0,$ED,$92,$74,$4B,$95,$E8,$9B,$A3,$66,$8D,$3A,$46,$EA,$54,$8B,$7E,$87,$D1,$D0,$B4,$A3,$5A,$12,$23,$66,$BD,$7A,$B4,$6A,$D3,$B3,$48,$8D,$DA,$34,$68,$C2,$54,$68,$D1,$A3,$46,$CD,$9A,$75,$C8,$D3,$84,$65; 960
		dc.b $1A,$27,$EF,$D1,$AB,$46,$AD,$DB,$34,$6E,$D5,$A3,$46,$DD,$3B,$35,$4F,$D1,$B2,$42,$85,$BA,$24,$69,$D1,$A3,$66,$9E,$8D,$9A,$35,$E8,$D1,$B3,$66,$9D,$3A,$34,$C8,$D3,$A3,$76,$AD,$5B,$B2,$8D,$3B,$F7,$ED,$91,$B7,$46,$9F,$A3,$FB,$D5,$BF,$BC,$7C,$F4,$5E,$3F,$7A,$1F; 1024
		dc.b $BF,$46, $A,$30,$85,$1A,$34,$68,$91,$A3,$76,$ED,$19,$66,$8D,$5A,$34,$61,$9B,$36,$6C,$D1,$2B,$56,$8D,$1A,$A4,$FA,$9D,$4B,$5D,$1B,$CF,$E8,$DE,$7D,$3A,$AD,$78,$5E,$13,$A3,$9E,$88,$74,$54,$5F,$42,$A8,  5,$6A,$D1,$AE,$4E,$8D,$3B,$97,$1C,$25,$FD,$9A,$34,$68,$99; 1088
		dc.b $DD,$A4,$A3,$FE,$89,$17,$AC,$47,$E3,$46,$FD,$7A,$1F,$D7,$9F,$48,$9D,$9A,$36,$6C,$DB,$E8,$D1,$D5,$D1,$A7,$46,$DD,$EB,$3F,$FE, $F,$FD,$1F,$FD,  9,$FE,$8C,$7E,$51,$F4,$68,$BE,$8F,$FF,$FE,$99,$1F,$A3,$3D,$1F,$FD,$1F,$C7,$D0,$9F,$FA,$13,$C0,$D3,$D6,  5,$A9,$91; 1152
		dc.b $A4,$43,$C2,$1D,$17,$28,$D1,$AB,$46,$FD,$1D,$18,$D1,$C2,$BF,$47,$E8,$74,$6F,$DB,$AB,$46,$A9,$FA,$34,$88,$7A,$3A,$2E,$8D,$3A,$34,$6B,$D5,$A3,$27,$A3,$47,$D1,$A3,$62,$95,$1A,$34,$A8,$D1,$A3,$5C,$8D,$7A,$34,$74,$69,$D1,$A3,$56,$DD,$1A,$36,$7A,$37,$EA,$9F,$3F; 1216
		dc.b $56,$DD,$1A,$37,$E8,$CA,$35,$6D,$D5,$BF, $D,$91,$A7,$46,$D9,$7A,$34,$68,$D7,$BB,$76,$8D,$1A,$35,$E8,$D1,$A7,$46,$E1,$12,$3B,$A1,$A3,$76,$8D,$1F,$A3,$E7,$E8,$74,$3F,$FE,$3F,$1E,$8D,$D2,$B4,$69,$C2,$14,$68,$47,$56,$3A,$34,$34,$63,$47,$FF,$E7,$F8,$FC,$33,$34; 1280
		dc.b $63,$45,$4F,$D1,$A3,$FA,$3E,$34,$7F,$1F,$42,$11,$9E,$9C,$F4,$7E,$8F,$A3,$E8,$F4,$48,$E8,$D1,$FC,$74,$7C,$61,$1F,$3D,$1F,$3D,$1F,$9A,$3F,$86,$FF,$A7,$46,$8D,$5E,$11,$AB,$FD,$1C,$7A,$3F,$D1,$E4,$5D,$EE,$DD,$AF,$46,$AD,$1A,$F4,$6C,$D0,$D1,$FE,$3F,$D5,$9F,$EF; 1344
		dc.b $D9,$A3,$46,$BD,$FA,$34,$6C,$11,$23,$47,$FF,$47,$FF,$47,$FF,$47,$FD,$1D,$1A,$34,$67,$47,$47,$FD,$1C,$7D,$1F,$F4,$6F,$9E,$23,$56,$A1,$5D,$1A,$BA,$37,$EA,$F4,$68,$FC,$D1,$AB,$5E,$ED,$62,$17,$EE,$DF,$BF,$7F,$84,$5A,$2F,$E6,$8B,$FE,$6D,$26,$21,$2D,$11,$5F,$5E; 1408
		dc.b $ED,$7A,$34,$7F,$F4,$88,$87,$E9,$10,$C9,  8,$D1,$A3,$46,$8D,$1A,$7E,$A3,$AA,$F9,$E8,$BE,$7A,$2F,$FD,$1F,$1F,$FF,$9F,$FE,$8E,$93,$E8,$E3,$FA,$7F,$E8,$FF,$A3,$FA,$94,$62,$AD,$1F,$A3,$83,$47,$83,$FE,$A5,$53,$B6,$EA,$50,$A3,$6A,$DD,$5A,$B4,$6A,$68,$D0,$AD,$5E; 1472
		dc.b $AD,$38,$4F,$A3,$4F,$BB,$42,$8D, $B,$55,$E8,$50,$AF,$5E,$8E,$9D,$1D,$3A,$3A,$74,$74,$E8,$D3,$A3,$9E,$DD,$1A,$AE,$8E,$87,$46,$CD,$1D,$1A,$34,$6F,$D1,$BF,$46,$FD,$1B,$F5,$EC,$E8,$D9,$A3,$67,$6D,$D9,$87,$E8,$DF,$A3,$7E,$8E,$FF,$46,$C2,$C3,$A3,$AC,$60,$EC,$B9; 1536
		dc.b $60,$17,$A2,$B8,$5E,$CD,$1A,$30,$CD,$DB,$37,$E9,$99,$23,$49,$B3,$B7,$D9,$94,$BA,$26,$7E,$8D, $F,$DF,$B1,$B8,$66,$9D,$3A,$37,$48,$DC,$A3,$68,$8D,$1F,$84,$7F,$DE,$9B,$A4,$68,$FA,$33,$FF,$E8,$7F,$CD, $F,$D8,$18,$56,$9D,$BA,$74,$3C,$23,$45,$4A,$8D,  8,$4E,$A5; 1600
		dc.b  $B,$B5,$6A,$DC,$A2,$43,$54,$8D,$1A,$38,$6C,  1,$FD,  8,$4B,$FA,$10,$99,$23,$F3,$D0,$AF,$46,$BF,$FA,$B5,$34,$E7,$44,$E9, $A,$36,$C8,$51,$B7,$5E,$DD,$1B,$E4,$4B,$D1,$A3,$B0,$28,$FF,$F4,$7F,$FA,$D3,$64,$53,$A3,$23,$E8,$FF,$E8,$D3,$21,$5E,$8D,$5A,$34,$6A,$D3; 1664
		dc.b $A3,$E8,$FA,$3E,$8F,$A3,$FA,$3F,$AB,$54,$AD,$FA,$74,$6A, $C,$A7,$F4,$EA,$53,$A9,$5F,$46,$8F,$E8,$FA,$3A,$7A,$D1,$88,$14,$41,$42,$3A,$94,$6C,$D1,$A7,$42,$9D,$1A,$34,$25,$78,$FD,$1A,$D4,$8C,$D5,$AB,$62,$8D,$5B,  4,$6B,$DD,$A7,$66,$8D,$9D,$5B,$3A,$B6,$7A,$54; 1728
		dc.b $88,$D5,$AB,$56,$AD,$1B,$25,$28,$82,$B5,$41,$5A,$AA,$B5,$4A,$D8,$84,$E8,$D7,$A3,$5E,$BD,$4A,$F5,$6B,$D5,$AF,$56,$8D,$5A,$15,$68,$D7,$A3,$46,$8E,$88,$83,$52,$A3,$AF,$57,$AF,$57,$AF,$4E,$91,$BA,$B4,$66,$95,$3A,$24,$AA,$19,$B0,$72,$95,$1A,$34,$5F,$5F,$FD,$5F; 1792
		dc.b $F5,$68,$D5,$B7,$F4,$5D,$17,$44,$16,$23,$F4,$68,$D1,$A3,$46,$8D,$BA,$3E,$8E,$11,$F4,$68,$D1,$A3,$66,$CD,$9C,$B3,$50,$A5,$9A,$87,$6D,$3A,$3D,$5D,$1A,$44,$3D,$1A,$24,$6A, $A,$B7,$6D,$D9,$B7,$7E,$8B,$D1,$FF,$46,$3F,$E8,$FA,$17,$FC,$74,$68,$FF,$A3,$FE,$D1,$1F; 1856
		dc.b $F4,$88,$E8,$E8,$C2,$3A,$3A,$31,$EC,$8C,$7C,$83,$1F,$4E,$22,$8C,$A7,$A2,$D1,$D1,  4,$FA,$34,$64,$7F,$D3,$FF,$D1,$FF,$D1, $F,$E8,$D1,$D1,$A3,$42,$8D,$3A,$34,$6E,$DD,$D1,$B7,$46,$DD,$1B,$72,$8D,$1A,$34,$6A,$8A,$A2,$A9, $A,$85,$68,$94,$2A,$E8,$94,$9F,$FF,$C7; 1920
		dc.b $FC,$70,$D1,$7A,$D7,$E5,$1A,$3D,$C2,$17,  4,$A3,  8,$DD,$A3,$6E,$9D,$1A,$4F,$46,$B7,$A3,$E8,$D6,$7A,$F5,$68,$D4,$BF,$56,$A5,$5B,$F4,$6A,$D1,$BF,$7E,$CC,$7B,$33,$D9,$8E,$CD,$27,$FF,$7F,$BF,$7F,$BF,$7E,$AD,$2A,$A2,$95,$2A,$A4,$29,$12,$AA,$42,$94,$7D,$2A,$5D; 1984
		dc.b $A6,$1B,$46,$8F,$94,$6A,$D7,$A1,$4E,$85,$3A,$14,$E8,$F4,$7F,$A3,$C5,$52,$34,$65,$5E,$91,$12,$BF,$D2,$2A,$FE,$B1,$3F,$D1,$A4,$F8,$E2,$FD,$E2,$67,$EC,$52,$24,$42,$8D,$DA,$27,$6B,$D5,$A3,$56,$FD,$5B,$F5,$6A,$AA,$D5,$2B,$3F,$F8,$FF,$C5, $E,$47,$CA,$32,$8C,$F0; 2048
		dc.b $8B,$FE,$20,$7F,$3C,$23,$46,  6,$8D,$1D,$1A,$33,$83,$21, $A,$11,$23,$E6,$F2,$78,$FF,$3C,$FC,$7A,$12,$8B,$43,$A1,$D0,$A3,$47,$D1,$65,  8,$C1,$A1,$46,$68,$CC,$8F,$E5,  9,$E3,$3A,$14,$48,$D0,$80,$84,$E8,$80,$A2,$28,$65,$19,$44,  2,$14,$48,$51,$BD,$7E,$8D,$EB; 2112
		dc.b $F4,$6F,$5F,$BF,$7E,$FD,$1B,$B4,$68,$F4,$7F,$D1,$FF,$72,$8D,$FA,$3B,$8A,$3F,$BC,$FC,$7D,$E7,$FF,$D6,$3F,$5E,$C5,$19,$FA,$39,$1D,$1C,$A1,$A3,$3F,$A3,$77,$EE,$FE,$FD,$1A,$36,$F6,$66,$8D,$1D,$1A,$B4,$59,$FD, $D,$CF,$F4,$21,$A4,$45,$13,$54,$74,$E8,$E9,$A9,$D1; 2176
		dc.b $A7,$43,$1A,$35,$68,$E5,$3A,$3A,$3F,$3F,$F0,$7F,$8E,$27,$CB,$4E,$8D,$39,$46,$88,$A3,$4E,  9,$46,$8D,$1B,$F4,$68,$F4,$6C,$FA,$3F,$46,$8D,$1A,$34,$7D,$1F,$A3,$E8,$FA,$3A,$34,$7F,$47,$3E,$87,$F8,$65,$EA,$FF,$84,$72,$11,$D1,$E8,$E8,$D0,$A3,$FF,$F4,$3A,$3F,$C9; 2240
		dc.b $A2,$E8,$E8,$D0,$E8,$DB,$A3,$3A,$23,$A3,$43,$E8,$FF,$97,$27,$FF,$E8,$C7,$E2,$8D,$FF,$FA,$31,$47,$E8,$FF,$A3,$28,$B1,$30,$8A,$71, $E,$AE,$25,$DA,$3F,$47,$45,$E8,$7F,$AB,$2A,$FA,$B2,$AC,$AB,$15,$65,$5A,$14,$67,$FF,$A2,$4F,$D5,$E8,$E8,$E8,$D1,$D1,$95,$62,$AF; 2304
		dc.b $AB,$FA,$BF,$F8,$A3,$FE,$8D,$5F,$AB,$D1,$FA,$3F,$EA,$D1,$7C,$C2,$29,$98,$56,$7F,$E8,$FF,$E8,$FF,$E8,$FF,$BB,$BB,$46,$8D,$1A,$B0,$8C,$D1,$51,$E8,$A8,$E8,$A8,$D3,$DF,$A3,$46,$8D,$1F,$E8,$E8,$FE,$91,$1D,$1A,$3F,$1A,$3E,$36,$F8,$66,$8E,$8F,$E8,$D8,$FA,$34,$7F; 2368
		dc.b $47,$A3,$FF,$47,$FF,$1F,$FF,$F1,$47,$42,$11,$C9,$FF,$46,$8D,$19,$E8,$71,$9E,$87,$47,$8F,$FF,$FE,$79,$1F,$F0,$23,$89,$42,$8E,$8E,$51,$A3,  8,$F0,$11,$FD, $D,$18,$42,$84,$A1,$46,$89,$1A,$34,$68,$93,$A7,$4E,$9D,$3A,$7A,$4A,$70,$93,$4B,$54,$2E,$11,$A3,$F8,$57; 2432
		dc.b $C6,$8D,$42,$B4,$29,$D1,$82,$98,$21,$46,$7E,$8D,$27,$E8,$A9,$13,$4C,$84,$F4,$89,$D3,$A7,$4E,$9D,$1C,$75,  1, $E,$26,$A9,$42,$15,$28,$CD,$1A,$B5,$69,$D1,$A7,$B3,$4E,$AD,$33,  4,$E9,$BB,$24,$9A,$C5,$B6,$7A,$73,$4F,$46,$8C,$31,$46,$C4,$2A,$48,$28,$48,$67,$F3; 2496
		dc.b $FD,$25,$6C,$72,$B9,$9A,$15,$EC,$D7,$AF,$57,$61,$22,$18,  0,  4,$21,$42,$8D,$9B,$34,$68,$99,$AB,$76,$8D,$1E,$8E,$50,$E8,$E5,$15,$1C,$A1,$78,$89,$FA,$34,$74,$68,$D1,$A1,$46,$89,$1A,$14,$68,$D1,$B7,$58,$DD,$7B,$F5,$8F,$11,$B0,$ED,$97,$CD,$87,$DF,$A2,$68,$CD; 2560
		dc.b $B3,$34,$6C,$D7,$87,$68,$56,$21,$61,$AC,$5B,$60,$CB,$61,$D8,$3F,$73,$60,$FD,$AB,$C5,$88,$61,$AB,$57,$22,$D1,$FA,$22,$EF,$91,$28,$91,  5,$FC,$E7,$B1,$D8,  0,$27,$9B,$30,$4B,$14,$48,$91,$86,$60,$A2,$A3,  8,$42,$14,$48,$D0,$80,$9D,$BA,$35,$69,$94,$43,$9A,$69; 2624
		dc.b $4C,$D2,$97,$69,$C2,$B4,$4A,$DD,$BB,$49,$10,$40,$42,$8D,$44,$F6,$9C,$66,$D1,$46,$1C,$26,$4A,$9D,$B8,$4C,$ED,$3A,$50,$52,$23,$77,$48,$9E,$84,$A3,$D0,$A3,$50,$8D, $A,$24,$6F, $C,$A9,$42,$8D,$2A,$B4,$C8,$91,$94,$4A,$D3,$AF,$56,$AD,$3A,$B4,$DA,$A5,$8B,$EF,$56; 2688
		dc.b $53,$D3,$F6, $A,$D1,$B1,$2A,$52,$AA,$96,$33,$60,$99,$3B,  4,$C9,$E9,$16,$A7,$78,$A1,$2D,$E2,$57,$E9,$D3,$A3,$54,$FD,$32,$45,$EA,$D5,$AB,$56,$AE,$8C,  0,  0,  1,$7F,  1, $C,$D6,  0,$D7,$10, $D,$DB,  0,$DC,$10, $D,$E0,  0,$E1,  1,$AB,  1,$AC,$10,  9,$E5,  0; 2752
		dc.b $E6,  1,$AD,  1,$AE, $B,  1,$AF,  1,$B0,$1C,$67,  0,$79,$10,$B1,  1,$B2,$1C,$10,  8,$B3,  1,$B4, $C,$83,  0,$F6,$3C,$B3,  0,$10,$ED,  0,$85,  0,$D8,  0,$D9,  0,$DA,$64, $B,$DD,  0,$DE,  0,$DF,$10, $B,$E2,  0,$E3,  0,$E4,$10, $B,$E7,  0,$E8,$94, $D,$E9,$7C; 2816
		dc.b   6,  6,  8,$10,$7C,  6,  8,$10,$7C,  6,  7,  0,$EA,  4,$27,$7C,$82,  6,$27,$54,$13,$54,$2F,$54,$2E,$54, $D,$50,$B5,$50,$B9,$50, $A, $E,$23,$54,$21,$54,$1E,$54,$1D,$50,  2,$1E,$50, $A,$23,  4,  1,  4,$26,  2,$25,  0,  2,$26,  2,  1,  2,  1,$42,  0,$76,  2; 2880
		dc.b  $B,$12,$6E,  1,$45,  2, $A,$10,  8,  0,$B8,  0,$B6,  2,$30,$43,  8,  1,$41,$3C,  2,$12,$80,$B9,$54,$B5,$82,  9,$80, $A,$82,$80, $B,$82,  6,$78,  7,  1,$44,$40,  6,$78,  9,$72,$52,  7,$76,  6,$70,$19,  2,$11,$F4,$84,  6,$C1,  0,$C2,  0,$C3,$F4,$84,  6,$C6; 2944
		dc.b   0,$C7,  0,$C8,$F4,$84,  7,$CB,  0,$CC,  0,$CD,$F4,$84,  7,$D0,  0,$D1,  0,$D2,$84,  8,  1,  7,$D4,$10,$21,  3,$50,$29,$84,$10,  8,$C4,  0,$C5,$D0, $D,$C9,  0,$CA,$10, $D,$CE,  0,$CF,$A4, $B,  1,$D3,$98,  7,$28, $C,$A4, $A,$98,  9,$28,$10,  8,$84, $A,$10; 3008
		dc.b  $D,$50,$13,$50,$14,$54,  2,$33,$54,$32,$54,$31,$54,$30,  4,$88,$50,$24,  0,$24,$50,$23,$50,$37,$54,$36,$54,$35,$54,$34,$54,$3C,$26,  7,$39,  4,$25,  4,$24,  4,$38,$54,$3E,$3E, $E,  4,$40,$10,$18,  0,$28,$90,$10,$54,$3B,  4,$3A,$10, $D,$3D,$84,$14,$10,  8; 3072
		dc.b   4,$3F,$84,$14,$B0,$89,$B0,  3,  1,$44,$84,$14,$B0,  8,$CE,$68,  7,$B0,  7,$CE,  0,$20,$F6,  6,$86, $A,$F6,  6,$86, $A,$F6,  6,$86,$2D,$E0,$F6,  6,$86,$10,$FC,  7,$E6,  7,  1,$EC,  7,  0,$D5,$98,  0,  2,$83,$E0,  1,$10,$10,$14,$13,$10,$13,  4,$A0,$44,$10; 3136
		dc.b $11,$14,$23,$10,$23,  4,$50,$23,$95,$22,  1,$6B,  1, $A,  5,$6B,$12, $D,  9,$22, $F, $A, $C, $A,$7A,  1, $B,$7E,  4, $F,$E0,  7,  2,  8,$12,$10,$74,  2,  7,$6E,$C4,  9,$72,  4,$D8, $A,$C4,$10,$12,$C8,  6,$10,  9,  1,$43,  1,$40,$10,$D4,  1,$86,  4,$47,$12; 3200
		dc.b   6,  0,$B6,$58,$54,$5C,$54,$4C,$54,$4A,$54,$45,$54,$43,$50,$42,$58,$54,$5C,$C4,  6,$54,$1C,$54,$1B,$24,$28,$C4,$C8,$80,$10,$CC, $A,$90,  6,$CC, $A,$10,  7,  0,$B8,$D4,  7,$10,$4A,  9,$47,  0,$84,$E6,$72,$76,$45,$50,$4A,$50,$4C,$E6,  7,$1B,$50,$1C,$3A,  6; 3264
		dc.b $E6,  6,$36,$BC,  9,$80,$1A,$64,  9,$FC, $C,$64,$FC, $B,$64,$FC, $B,$64,  8,$7A,  7,$E8,  9,$7A,  7,$10, $A,$7A,  6,$10,  4,  3,$80,  7,$20,$EA,$A4,$FC, $C,  1,$FC, $C,  1,$E4,$72, $D,$76, $A, $F,$4A,  2,$76,  8,$F0,$10,$4A,  2,$18,$A2,$58,$F0,$20,$4A,  2; 3328
		dc.b $18,  6,$50,$46,$F0,$88,  2,$18,  6,$FC,$10,  7,$BC,$2F,  2,$50,  2,$3E,  6,$46,$BC,$21,$3E,  8,$28,$BC,$3E,  9,$10,$FC,  9,$10,$11,$12,$77,$76,$27,  2,  9,$F4,$38,  6,$90,  9, $E,$10, $F,$58,$1C,$36, $D,$10,$25,  0,$17, $F,$9A,$54,$29, $F,  8,$F0,$10,$1A; 3392
		dc.b   6,$10,  9,$20,$4C,$24,$54,$76,$60,$14,  2,$76,  6,$50,$12,$C8,  6,$10,$76,$50,$6E, $E,  6,  1,$42,$7C,  7,$10,  8,$43,$10, $E,  2,$C4,$7A,$50,$2A,$54,  2,$29, $C,$88,  7,$14,$50,$16,$54,  2,  6, $A,$C6,  6,$96,$7C,$9A,$C0,  6,$AC,  6,$38,$50, $C,$C8,$86; 3456
		dc.b   6,$77,$10,  9,$10,  7,$84,  6,$54, $C,$18, $D,$6E,$C0,  8,$60,  7,$EC,  2,$30,  9,$E6,  7,$36,  8,$D6,  6,  2,$52,$14,  2,$2A,  0,  6,$CC,  6,$58,  7,$3C,  7,$AC,$DE,$10, $A,$10,  6,$C8,$1A,$72,$29,  2, $E,$6C,  6,$1F,$20,  8,  6,$10,$6B,$20,  1,  2,$8E; 3520
		dc.b  $E,$20,$50, $B,$10,$56,$76,  6,  2,  9,$20,$90,  7,  0,$98,  2,  7,$10,$1F,  1,$86,  0,$41,  2,  1,$88,$10,  8,$14,$D8,  2,$10,$72,$10,  1,  2,$14,$D8,  2,$10,  8,$78,  9,  0,  8,  2,  8,$73,$FA,  7,$68,  8,  2,$37,$66,  6,  2,  9,$6E,$10,$10,$76, $F,$E8; 3584
		dc.b   9,$28,  8,$59, $B,  2,  6,  1, $A,  2,  6,  1, $A,  2,  6,  1, $A,  2,  6,  1, $E,$F2,  7,$10,$1A,$CE, $A,  4,  5,$EA,$72,  2, $E,$DE,  2,$8C,  8,$1A,$E3,  0,$E4,$8C,  9,$1C,$72,$8C,  8,$1A,$8C,$11,$8A,$20,$7E,$7A,  6,$7A,$82,  3,$4E,  7,  1,$F9,$7C,$F0; 3648
		dc.b $14,$4E,  6,$10,  7,$7D,$F0,$24,$10, $A,$F9,$7E,$F1,$89,$F0,  1,$5E,$F9,$81,$F9,$80,$F9,$7F, $E,$30,$52,$50,$68,$50,$69,$F0,$74,  2,$6A,$30,$74,  0,$70,$10,$6C,$54,$6D,  4,  2,$6A,$6F,  0,$71,$7A, $C,$D8,  9,$62,  7,$CA,  6,$7E,$2E,$50,  2,$2F,$F2,$EE,$13; 3712
		dc.b $7E,$1E,$BE,  7,$EE,$F0,$7E,  6,$26,$F2,$F0,  8,  8,$50,  9,  8,$4C,$77,$10, $A,  2,  8,$10,$A8,  8,$38,  6,$42,$14,$4C, $A,$EA, $C,$A0,  9,$52, $E,$B8,$72,  7,$A2,$52,  9,$DA, $F,$10, $B,$2A,$EA, $A,  0,$15,$F0,$19,$E0,$12,  4,$47,$C8,$47,  1,$88,$54,$86; 3776
		dc.b  $B,$84,$9A,  9,$46,  7,$C0, $D,$2E,  7,$58,  2,  8,$58,  7,  2,$60,$58,  6,  2,  9,$9E,$B6,  2,  9,$4E,$10, $C,$20,$4B,$54,$4A,$50,  2,  6,$28,$1E,$82,  8,$54,$28,$BC,$82,  7,$50,$16,  2,$30,$8E, $F,  1,  0,  1,  2,$11,$5A,  7,$F0,$40,$30,  9,$BE,  8,$10; 3840
		dc.b $32,$C8,  8,$EE,  6,$9A,$1A,$98,$92, $B,$54,$18,$54,$45,$10,  7,$1F,$F0,$20,$18,$54,$1D,$76,  6,$64,$72,$18,  4,$25,$74,  2,$60, $C,$64,$10,  2,$15,$E8,  7,  4, $B,$47,$5A,$54,$43,$50,  2,$45,$92,$10,$1C,$50,  2,$1D,$14,  7,$10,$8A,$25,  2,$92,  8,$30,$2F; 3904
		dc.b   4, $D,$1E, $C,$A0,$10,$B0,$18,$F8,$37,  2,$25,$AE,$12,$10, $A,$C0,$20,  2,$38,$F8, $C, $A,$41,$10,  9,$14,$F0,$46,$10,  6,$54,$1D,$82,  6,$F0,$92,$F8,  6,$82,  6,$10,$40, $C,$6A,$40, $B,$AA,  8,$92, $C,$10,$11,$42,  7,$2E,  7,$51,$22, $A,$1E,$5F,$C4, $A; 3968
		dc.b $BC,  1,$85,$B0, $C,$BE,$B0, $E,$32,$B0, $D,$C4,$B0, $C,$7C, $E,$30,$B0,  8,$14,$D0,  8,$D2, $C,$7E,  6,$38,  7,  0,$26,$14,$10, $C,$3E,$1C,$40,$16,$2E,  8,  0,  8,$10, $C,$58,$20,$13,$34,$10, $C,$3C,$14,  2,$3C,$20, $F,  8,  6,  2,  6,  4, $F,$30,$10,$10; 4032
		dc.b $13,  2,  8,$30,$13,$34,$10,$30,$11,$10,$23,  2,  8,$30,  2,$20,$DA, $B,$30,  2,$10,$C0,  8,$31,$44,$10,  6,$C0,  8,$30,$72,$20,  7,$43,  1,$40,$62,$31,$41,$20,  7,$24,  7,  4,$40,$A6, $F,  1,$61,$3D,$7B,$10, $E,$90, $E,$34,$D0,  8,$7E,$73,  1,$44,$10,  6; 4096
		dc.b $90, $A,$10,$7C,$10,  9, $C,$E0,  6,$FE, $A,$20, $C,  2,$10,$10,$1A,$10,$3D,$7C,$A0, $F,$7D,$10, $E,$35,$89,$3D,$7E,$10, $C,$82,$12,$1D,$7F,$1D,$80,$1D,$81,$AE,  2,  0,$6A,$10,$74,$10,$70,$14,$74,  2,$69,$14,$68,$10,$13,$F8,$6F,  0,$71,  0,$6D,  2,$10,$6D; 4160
		dc.b $14,$6C,$10,$23,$7E,  9,  2,$29,$8E, $D,$20,  9,$12, $A,$EE, $C,$3A,$13,$84, $D,$36,$20, $C,$3A,$60,$12,$84,$3E,$4A, $F,$BC, $E,$40,  6,$AA,$17,$A0, $F,$E0,$16,$AA, $A,  8,  7,$30, $A,$B0,$10,$13,$14,$4B,$14,$4A,$10,  2,$4B,$36,$23,$14,$21,$14,$1E,$14,$1D; 4224
		dc.b $10,$1E,$10,$21,$34,$80,  9,$7E, $A,$FA, $C,  1,  0,  1,$E0,$20,$7E,  8,$8A,  9,$80,$30, $A,$14,$80, $F,$14,$80,$7E,$80,  7,$32,$80,$7E,$80,$19,$D2,  0,$F1,  0,$F2,  4,$EA,  6,$10,$1C,$90,$10,$49,  4,$7F,$B0,$32,$74,  2,$84,  0,$EF,  0,$F0,  4,$2E, $A,  2; 4288
		dc.b   7,$2E,  9,  2,  6,$3C, $D,$B8,  8,  8, $C,$B4,$30,$78,  7,$80,$2C,$7E,$10,$F8, $B,  0,$50,$29,$54,$29,$4C, $A,$51,$44,$14,$54,$14,  6,  2,$14,$F0,$11,$50,$23,  0,$24,  4,$24,  6,  2, $A,$A0,$C0, $F,$10,$4E,  6,$86,  6,$20,$42,  9,$1A,$10, $E, $A,$10, $B; 4352
		dc.b $14,$77,$50,$2A,$54,  2,$7E,$7C,  2,$16,$54,  2,$7E,$54,$7C,  2,$7C,$7E,$CA,$24,  2,$C4,$16,$BE,  6,$D0,$88,  6,$D6,  7,$10, $C,$80,  6,  4,$1E, $F,$B0, $B,  2,  6,$10, $C,$56,$10, $D, $C,$10,$1E,  6,$C2,  6,$6C,$20,$3E, $B,$22,$20,$BC,  7,$C0,  6,$30,$14; 4416
		dc.b $8A, $D,  8,  6,$40,  9,$2A,$6E, $A,$6C, $A,$B8,  9,$10, $F,$6E, $A,$E6,$2E,$80,$10,$61,  9,$16,  6,$10,$19,$10,  9,$10,$37, $C,  6,$10, $B,  1,$7F,$90,$11,$10,$41,$50,$10,$10,$1F,  1,$7F,  1, $B,$D6,  0,$D7,  0,$D8,$10, $B,$DB,  0,$DC,  0,$DD,$10, $B,$E0; 4480
		dc.b   0,$E1,  0,$E2,$10, $B,$E5,  0,$E6,  0,$E7,$D3,$AF,  1,$B0,  4, $B,$E9,$10,$B1,  1,$B2,  4,$10,  9,$B3,  1,$B4,  4,$10, $F,  4,$27,  0,$B3,  0, $C,  4, $A,$EA,  0,$D9,  0,$DA,$7C,  9, $C,$DE,  0,$DF,$7C,  9, $C,$E3,  0,$E4,$7C,  9, $C,$E8,$7C, $B, $C,  1; 4544
		dc.b $AB,  1,$AC,$7C, $D,$AD,  1,$AE,$7C, $C,  0,$67,  0,$79,$7C,  9,  1,$83,  0,$F6,$7C,$10,  6,  3,$F0,$10,$54,$2F,$54,$B9,$54,$B5,$50,  2,$B9,$50, $A,$13,$F0,$11,$54,$21,$54,$1E,$54,$1D,$50,  2,$1E,$50, $A,$23,$A0,$72,$C0,  7,$C2,  7,  0,$B0,  2,  6,  0, $E; 4608
		dc.b $40,$DE,  6,$92,$40,$A2,  6,$9E,  8,  0, $F,  1,  0,  1,$72,$80,  6,$54, $D,$50,$8A,$50,$2E, $E,$23,$80,  9,$82, $E,$C0,  6,$80,$82,$E0,$2E, $C,$40,$1E, $D,  2,  6,$10, $D,$22,  7,$1E,$2C,$E2, $D,$74, $D,$58,$10,$33,$12, $C,  4,$41,  2,$47,$94,  8,  2,$11; 4672
		dc.b $E0,$1F,$10,$30,$1E,$17,$47,$C8,  7,$41,$72,  2,$4B,$54,$4A,$54,$45,$54,$43,  2,$6A,$84,  8,$54,$1C,$50,$1B,$3E,  7,$84,  4,$84,$20,  9,$A2,  8,$D0, $D,$30,$15,  0, $C,$F0,$10,$50,$43,$50,$45,$50,$4A,$50,$4B,$70,  7,  2,$74,$7A,$70,  6,$72,$74,$7A,$EE,$10; 4736
		dc.b $F0,  6,$EE, $B,$F0,$EE,  6,$16,$A8,  6,$F8,  6,$6C,$EE,$15,  1,  8,$C1,  0,$C2,  0,$C3,  0,$C4,$10,  9,$C6,  0,$C7,  0,$C8,  0,$C9,$10,  9,$CB,  0,$CC,  0,$CD,  0,$CE,$10,  9,$D0,  0,$D1,  0,$D2,  0,$D3,$42, $D,$D4,$52, $F,$10,  6,$5A,  0,$5B,  4,  4,$10; 4800
		dc.b   8, $F,  0,$5D,  0,$65,  4,  4,  1,$27,  0,$D5,  4, $E,$C5,$34, $F,$CA,$10, $F,$CF,$F5,$5E,$30,$10,$14,$33,$14,$66,$10, $D,$10,$2E,$10,$2F,$14,$13,$30,$12,$30,$11,$14,$37,$14,$1D,$10,  2,$1E,$10,$21,$10,$23,$30,$6E,$20,$72,  4,$39,$FE, $A,$20,$10,  0, $C; 4864
		dc.b $10,  6,  0,  7, $A,$10,$16,$82, $A,$20,  7,  2,  9,$10,$F4,$7F,$90,$90,  1,  9,  4,  0,$10,$10,$14,$2F,$14,$2E,$14, $D,$12,$14,  2,$11,$14,$21,$14,$1E,$12,$14,$1E,$D6,$90, $D,  2,$D0,  6,$92,  7,  2,$10,  6,$E6, $A, $A,  6,$1C,  6,  2,  0, $F,  6,  3,  2; 4928
		dc.b   8,$7E,  6,$C5,$10,$2F,$10,$13,  2,$12,$7E,  7,$CA,$86,  2,$6E,$7E,  7,$CF,$84,$EA,  6,$7E,  7,  4,$50,  7,$D4, $C,  4,$10,  8, $C,$F6,  7,$10, $C,$FE,  7,$84,$76,$D5, $C,$EE,$90,$11,$10,  8,$41,$10,$4D,$10,$4E,$10,$4F,$10,  7,$15,$10,$19,$10,$34,$10,$35; 4992
		dc.b $10,$1C,$10,  7,$1F,$10,$20,  0,$38,  0,$24,  4,$10,  7,  8,  6,$1A,$10, $D,$78,$20, $E,$43,$20, $F,$8C,$10,$52,$10,$53,$F4,$F8,$10,$50,$10,$3D,$10,$37,$F4,$F8,$10,$3E,  0,$3F,  0,$39,$6A, $A,  0,$F0,  6,$10, $A,$30, $E,$7A,  9,$80,  9,  0, $E,$1E,  6,$40; 5056
		dc.b  $C,  3,  0, $E,$50,$90,$2E,$8E,  2,$2E,  2,$90, $D,  2,$34,  0, $F,$32, $F,$88,$16,  2, $B,  0,$18,  1,  7,$50,$2F,  6,$12,$10,  9, $A,  6,$28,  9,  0,  9,$EC,$FC,$70,  8,$AF,  1,$B0,$F0,$F8,  7,  1,$B1,  1,$B2,$FC,$F8,  7,  1,$B3,  1,$B4,  0, $D,$B3,  0; 5120
		dc.b $10,$83,  0,$85,  0,$1A,$50,$4D,$50,$4E,$50,  0,  9,$50,$19,$50,$34,$50,$35,$50,  0,  9,$50,  0,$15,  8,$10, $E,  6,$10, $E,$73,  0, $F,  1,  0,  1,$8C,$50,$52,$50,$53,$76,$FA,  7,  1,$3D,$50,$37,$F2,$F8,$FA,  6,  0,  7,$76,$30,  0, $E,$E0, $A,$18,$88,$DA; 5184
		dc.b  $A,$20, $D,  8,  9,  0,$10,$90,$10,$D0,$1B,$52,$20, $C,$E6,$10,$41,$90,$10,$FE, $D,$D0,  8,$A6, $A,$10,  7,$50,$E6,$6A,  9,$26,  6,$10,$28,$B2,$1C,$A0,$1B,$B6,$20, $F,  1,$86,  0,$36,$41,  1,$88,  8,  4,$47,  4,  1,  2,$BA,  8,$14,  2,$4B,$14,$4A,$14,$45; 5248
		dc.b $BA,  8,$14,  2,$38,$B8,  8,$2C,$38,  6,$F0, $F,$B0, $F,$10,$40,$F2, $F,$4A,  7,$20,  9,$4A,  7,$BC,$47,$8A,$10,$43,  2,$78,$4A,$10,$4B,$8A,$1C,  2,$C0,  7,  2,$A4,  2,$AC, $B,  2, $F,  0,$43,$FE, $A,$E0,  7,$FE,  9,$B8,  7,$10,$13,$32,  9,  0, $F,  0,  9; 5312
		dc.b $10,  8,  0,  8,  0,$20, $C,  0, $C, $C,$F0,  8,  8, $C,$10,  8,  0,$FC,  0,  7,$54,$28,  7,  0,$7F,  2,  0, $E,  2,  0, $E,  0,$70,  8,$FC,$DC,$F0,$14,  0,$B8,$D4,$78,  8,$E2, $A,$F0,$16,$10,  9,$CE, $D,$D0,$BC, $A,$9C,$74,  2,  4,$56,  8,$45,$54,$13,  2; 5376
		dc.b $50,$46,  0,$51,$10,  7,$23,  2,$B0,$5F,$10,  6,$24,  2,  8,$10,$17,  0,$12,$FC, $A,$20,  6,$62,  8,$18,  6,$42, $B,$52,  6, $C,  6,  2,$10,  8,$7A, $F,$10,$1F,$A0,$20,$10, $A,  6, $A,$20, $D,$40,$10,$10,$2D, $A,  6,$A0,$16,$9E,  9,$10,  7,$A6, $B,$4C,$10; 5440
		dc.b $2A,$BE,  6,$4C,$6E,  6,$7A,$86, $B,$10,  0,$18,$D8,  8,$20, $E,$D0,  8,$10, $D,$32, $B,$20,  6,  0,$23,$10,  9,  0,$13,  2, $C,$DE, $F,$10,  6,$FE,  9,$F0,$32,$78,  6,$CA,$A2,  8,$A0,$11,$10,$22,$2C,$88, $B, $C,$10, $D,$40, $B,$20,$15,$10, $A,$64,  9,$70; 5504
		dc.b  $E,  1,  0,  1,$B0,  9,$B0,  8,$5A,  9,$2A, $D,$10,$3F,$E2, $D,  0,$1F,$F8,  7,$86,  8,$A0, $A,$76,$10, $A,$56, $D,$10,$33,  2,  7,$68,  8,$42,  8,$F6, $D,$26,$88,  6,$A2,$17,$2A,$1C,$3A,$1B,$E0,  2,  7,$98,  8,$18,  8,$10, $C,$41,  4,$47,$10, $B,$15,$30; 5568
		dc.b $19,$14,$4B,$F8,$40,  0,$47,  1,$88,$30,$20,$1C,$F8,$7E, $A,$30,$E4,$F8,  6,$7E, $A,$F8, $A,$7E,$19,$5C, $C,$4A,  2,$5C, $B,$4A,  2,$5C,  9,$2A,  6,$5C, $C,$60,$5C,$22,  2,$1E,$90,$10,$D0,$2D,$10, $E,$2E,  0,  6,$20,  8,$86, $A,$10,$1A,$8E, $E,$50,  0, $E; 5632
		dc.b $DE,$16,  0, $A,$6A,$2C,$10,$76,  7,  8,  8,$D0, $E,$A0, $F,$32,$20, $F,  1,$86,$36,  1,$88,  8,$40,$50,$13,  2,  6,  6,$4B,$54,$4A,$54,$45,$50,$23,  2,  6,  6,$21,$54,$1E,$54,$1D,$A8,  9,  8,  4,$25,$80,$1F,$82,$A6, $E,$A0,$20,$10, $C, $A,$47,$8A,$84,$50; 5696
		dc.b $43,  2,$78,$4A,$50,$4B,$8A,$1C,  2,$1D,$50,$1E,$50,$21,$88,$1E,  2,$78,$26,$18,  0,$1D,$10,$1E,$B6,$40, $D,$20, $F,$40, $D,$7C,$F0,$86,  4,$41,  2,$40,$10,$4D,$10,$4E,$10,$4F,$6C, $D,$42,  6,$46, $A, $C,$BC, $D,$6E,$1C, $C,  2,$84,$2A,  9,$47,$10,$52,$10; 5760
		dc.b $53,$14,$13,$2A, $C,$10,$3D,$10,$3E,$28, $C,  9,  0,$3F,  0,$40,$1C,$10,$50, $C,  8, $C,  6,$76,  6,  2,$10,$34,$10,$35,$10,$36,$76,  7,  2,  0,$38,  0,$24,$38,$32,$11,$AC, $A,$8C,  7,$EC,$1F,$78,  8,$82,$16,$10,$37,$98,  6,  2,  9,$39,$A2,  8,  1,$16,  8; 5824
		dc.b  $C, $B,$10,$25,$A8,  6,$8C,  0,$24,$D6,  0,$D7,  0,$D8,  0,$D9,  0,$DA,  4,  0,  1,  4,$DB,  0,$DC,  0,$DD,  0,$DE,  0,$DF,$10,  7,$E0,  0,$E1,  0,$E2,  0,$E3,  0,$E4, $E,$10,$E5,  0,$E6,  0,$E7,  0,$E8, $E,  6,  2,  1,$AB,  1,$AC,  0,$E9,$2B,$10,  8,$AD; 5888
		dc.b   1,$AE,$10,  6,$3E,$3A,  4,$79,  4,$67,$10,  7,$27,$10,$3B,$10,$3C,  4,$85,$10,$EC,$10,$8A,$10,$2D,$10,$2E,$10,$33,$8A,  1,  9,  1,$AF,  1,$B0, $E, $A,$4A,$B1,  1,$B2,$74,  7,$5A,  0,$5B,  4,$5A,  1,$B3,  1,$B4,$64,  6,  0,$5D,  0,$65,  4,  4,$B3,  0,$B4; 5952
		dc.b   0,  3,$64,$58,$66,$14, $D,$10,$B5,$10,$B9,$10,$13,$64,$58,$36,$14,$36,  4,$5E,$10,$23,$EE,  7,$25,$7A,  4,  2,$FA,  2, $A,$F8,$2E,$1E,$14,$37,  2,$1C,$14,$24,$2E,$26,  4,$39,  2,$28, $B,  2, $A,$B0,  8, $E,  6,$6C,$2D,  2,$12,  1,  0,  1,$4E,  4,$76,  2; 6016
		dc.b   8,  5, $C,$3E, $B,  5,$45,  4,$6E,$10,  6,  0,$B8,  4,$B6,  2,  5,$43,$10,  7,$EA,$10,$10, $A,$7E,$2F,  2,$2E,$FA,$38,  8,$6C,  7,$72,  2,$46,  0,$51,$10,  7,$23,  2,$6E,  0,$5F,$10,  6,$26,  7,$10,$19,$74,$21,$F0, $C,$EE, $C,$88,  8,$FC,$24,$15,$10,$19; 6080
		dc.b $8A,  6,$FA,  7,$1F,$10,$20,$8A,  6,$10,  8,$80,$AE,$10,$10,$A0,$1C,$3C,$20, $D,$30,$10,$10,  7,$7C,$10,$27,$AC,  9,$10,  7,$A0,$11,$40,$10, $C,$F0,  9,$20,  9,$10,$2A,$8E, $D,$C0, $A,  2,  6,$10,$10,$E2,$13,  1,$44,$52,  7,$86,  9,$FC,$E6,$50, $B,$72,  9; 6144
		dc.b $F2,  7,$10, $B,$92, $A,$B6, $A,$92,  7,$E6,$16,  7,$76,$20,$6C,  7,$E0,  8,$D0, $F,  2,$2A,$10, $A,$34,  8,$20,  9, $A,$10, $B,$40,$10,$E2, $B,$90, $A,$36, $A,  0,$1A,$B4, $A,$E0,$22,$50,$1A,$D0,$14,$B0,$20,$82, $D,$E0,  9,$82,  7,$4E,  8,$46,$42,$4E,$1F; 6208
		dc.b $20,$6E,$B0,  4,$78,$10,  7,$C4,  9,$10,$1C,$D0, $A,$30,$72,$30,  1,  2, $D, $A,$30,$8C,  2,$8D,$30,$8E,$30,$8F,$10,  8,$90,  2,$38,$91,$38,$92,$38,$93,$38,$94,$38,$95,  4,$B7,  2,  0,$90,  0,$97,  8,$98,  2,$38,$99,$38,$9A,$8E, $F,$C4,$80,  8,$10,  8,$D0; 6272
		dc.b  $A,$10,$AA,$7E,  6,$D2,$10,$30,$6E,$31,$44, $B,$10,$31,$43,$30,$D0, $B,$40,$20,$C0, $B,$10,$38,$9B,$10, $E,$30,$68,$30,$69,$30,$9C,$38,$9D,$38,$9E,$38,$9F,$92,$A0,$30,$6C,$34,$6D,$30,$A2,$B8,$38,$A3,$38,$A4,$38,$A5,$12,$74, $A,$12,$A8,$10, $C,$24,$3C,$AC; 6336
		dc.b $10,$B8,$5C,  6,$30,$A3,$30,$20,  6,$1E,  6,$AE,$30,$AF,$30,$B0,$10, $B,$B1,$30,$B2, $E,$3C,$B2,$10,  6,$3C,$A7,$3C,$A6, $C, $E,$B0,$3C,$AF,$38,$A1,$90,$D2,$B2,  6,$A0,$A6,$38,$A7,$72, $A,$10,$A9,$30,$AA,$10, $C,$3C,$AB,$38,$AD,$10, $C,$30,$A9,$38,$20, $D; 6400
		dc.b $30,$A6,$30,$40, $D,$3C,$B1,$F0,$10, $A,$AE,$10, $E,$90,  6,$34,$AA,$3C,$A9,  4,$90,$A8,$3C,$A3,$10,  7,$AD,$38,$AB,$10,$38,$AC,$E4,$10,$16,$3C,$AA,$34,$30,$34,$A8,$34,$30,  8,$A7,$34,$A6,$10,$A5,$34,$A4,$F0,  8,$34,$A1,$34,$A0,$12,$9F,$10,  9,$9B,$34,$9A; 6464
		dc.b $34,$99,$12,$C2, $A,$34,$95,$34,$94,$34,$93,$A0,  7,$90, $B,$10,$26,  4,  6,$21,$40,$82,$20,  7,  0,  7,$34,$9E,$24,$9D,$20,$8C,  2,  9, $B,$72, $C,$97, $C,$90,  2, $A,$34,$92,$34,$91,  4,$90,  2,  6,  0,$B7,  2,$36,$73,$64, $A,$3C,$8F,$64, $D,$74, $D,$76; 6528
		dc.b   7,$20, $A,$96,  6,$10,$19,$24,  7,$50,$14,$2A,  6,  2,$76,  0,  1,$3C,$8E,$3C,$8D,$3C,$8C,  2,$30,$96,$30,$6B,$34,$69,$34,$68,$5A,  6,  2,$6E,$30,$6F,$30,$6D,$34,$6C,$D8, $C,$30,  6,$6E, $A,$10,$14,$EA,  9,$5C,$10,$10,  8,$7A,  8,$34,$10,  1,$7F,  1,$37; 6592
		dc.b $D6,  0,$D7,  0,$D8,  0,$D9,  0,$DA,$10,  7,$DB,  0,$DC,  0,$DD,  0,$DE,  0,$DF,$10,  7,$E0,  0,$E1,  0,$E2,  0,$E3,  0,$E4,$10,  7,$E5,  0,$E6,  0,$E7,  0,$E8,$44, $D,$E9,$C4,$7F,  1,$10,$90,$10,$10,  1, $A,$10, $F,  9, $E,  9, $F,  0,$EA,  0,  3,  1, $B; 6656
		dc.b  $F,  8,$10,  1,$14,$14,$13,$10,$13,$10,  9,$11,$10,$24,$14,$23,$10,$23,$30,  9,$8E,$1C,$10,$10,$9C, $D,$E4,$AC, $E,$6E,$10,  8,$FE,  7,$77,$20,  9,$F6, $B,$EE, $A,  1,$40,$40,$18,$26,  8,  1,$86,  4,$41,  2,$47,$7E,  7,$90,  9,$84,  8,$C0,  9,$24,$14,$20; 6720
		dc.b  $A,$E0,$16,$CE,$10,$DE,$11,  0,$16,$47,  0,$10,  2,$14,$13,  2,$4B,$14,$4A,$14,$45,$14,$43,  2,$23,  2,$21,$14,$1E,$14,$1D,$14,$1C,$10,$1B,$A4,$B8,$9C,$26,  2,$25,  4,  0,  4,$32,$6E,$BC,$18,$CE,  7,$77,$E6,  7,$AE,  6,$E6, $A,$18,  6,  2,$1D,$10,$43,$10; 6784
		dc.b $45,$10,$4A,$10,$4B,$10,$BC,  2,$74,$1D,$10,$1E,$10,$21,$10,$BC,  2,  0,$74,  4,  2,$6E,  8,$78,  8,$6E, $A, $A,  6,$6E, $A,$78,$25,$92,  9,$AB,  1,$AC,$58,$AF,  1,$B0,$16,$C1,  1,$AD,  1,$AE,$10,$B1,  1,$B2,$10,$C6,  4,$79,  4,$67,$10,$B3,  1,$B4,$10,$CB; 6848
		dc.b   4,$85,  4,$83,  4,$27,  0,$B3,  0,$10,  6,$D0,$50,$13,  2,$54,$2F,$54,$B9,$54,$B5,$54,$31,$54,$30,  4,$3A,$50,$24,  2,$23,$50,$37,$54,$36,$54,$35,$54,$34,$54,$3C,$68,  7,$39,$3E,$24,  4,$38,$54,$3E,$7E, $E,  4,$CA,$C2,  0,$C3,  0,$C4,  0,$C5,$B0,  9,$C7; 6912
		dc.b   0,$C8,  0,$C9,  0,$CA,$10,  9,$CC,  0,$CD,  0,$CE,  0,$CF,$10,  9,$D1,  0,$D2,  0,$D3,$C0,$10,  7,  1,$D4,$D0,  6,$10,  6,$54,$3B,  4,$88,$10, $D,$3D,$84,$14,$3A,$10,  8,  4,$3F,$84,$14,$33,$54,$56,$54,$4E,$54,$4D,$54,$42,$DA,  4, $A,$C8,  7,$6C,$1A,$10; 6976
		dc.b   8,$B4,$34,  6,$FA,  7,$68,  7,$20,  8,$90,$40,$10, $B,$40,$14,$1A,  8,$80, $E,  4, $D,$94,$30,  8,$50,$13,$88,  7,$30,  7,  0,$24,$8C,$14,$98,$B0,  9,$20,$DC,$30,  8,$68,$10,$20,  7,$9C,  8,$80,$19,$C1,$82,  9,  1,  6,$C6,$82,  9,  1,  6,$CB,$82,  9,  1; 7040
		dc.b   6,$D0,$82,  9,  1, $A,$82,  6,$10,$26,  3,  2,$D5,  4, $F,$6C,$7F,  1,  9,$C0,$13,$F0,$12,$10,  9,$23,  2,$F0,$6E,$21,  9,$C8,  8,$10,$56,  0,  0,  1,  1,$7F,$90, $C,$54,  6,$10, $A,$54,  6,$10, $A,$54,  6,$10, $A,$54,  6,$34,  8,$42,  6,$E9,$10,  9,$42; 7104
		dc.b   6,$10, $A,$42,  6,$E9,$FE,$41,  0,$84,$42,  7,$20,$C4, $A,  1,  6,$C4, $A,  1,  6,$C4, $A,  1,  6,$E8,$FC,$4E,$55,$48,  2,  6,$C4,$B5,$28,$8B,$54,$23,  2,  7,$21,$92,$3C,$A8,  6,  2,  0,$3C, $A,$7E,  8,$16,$40,  8,$7E,  7,$46,  6,$10,  6,  2,  9,$EC,  0; 7168
		dc.b   7,$86,$15,$C0,  6,$DC,  8,$42,$AC,$10,  6,$42,  1, $A,$C0,  7,$8B,$84,  6,  1,  9,$C0,  7,$14,$42,  1, $B,$84,$D4,  7,$50,$2F,$50,$13,$AE,  7,$14,$37,$50,$21,$50,$23,$66,  7,$68,$39,$46,  0,$12,$F8,  8,$50,$47,$10,$12,$62,$10, $C,$62,$30,$10,$B0,$BA,  6; 7232
		dc.b $10,$53,$BA,  0,$BB,  4,  4,$10, $A,$BC,  0,$BF,  4,$BC,  1,$86,$FE,  2,  0,$E2,$90, $B,$10, $B,$3A,$50,$3B,$10,  9, $C,$50,$3C,$50,$3D,  4,  3,  4,$85,$50,$EC,$50,$8A, $C,$50,$3E,  0,$3F,$54,$13,$51,$48, $A,$1B, $C,  0,$40,  1,$42,$54,$3E, $A,$25, $C,$F8; 7296
		dc.b   6,$7E,  8,$8A,  9,$80,$10,$58,$C0,$50,$2F,$46,  2,  6,$58,$36,$BA,  2,  7,$58,$4E,$BA, $A,$72,$4A,  4,  8,$74,  6,$86,  6,$1C,  6,$6A,  4,$6E,  6,  6,  2,$1B,  1,$14, $F,$E6,$A8,$EC,  4,  1,$10,$10,$14,$13,$10,$13,  4,  2,$CE,$10,$11,$14,$23,$10,$23,  4; 7360
		dc.b   2,$CE,$5C,$46,  6,  2,$67,  0,$79,$10,  6,  8,$10,  8,  6,  9,$83,  0,$85,  1,$86,  4,$47,$98,  9,$12, $A,$7E, $B,$76,  1, $B,$7C,$24,$74,  2,  7,$A4,$74,  2,  7,$44,  6,$78,  7,$54,  8,$76,  7,$16,$20,$78, $A,$10,  6,$F8,  8,$47,$84,$66,$D8,  6,$14,$4C; 7424
		dc.b $14,$4A,$14,$45,$14,$43,$10,$42,$D8,  6,$14,$21,$14,$1E,$14,$1D,$14,$1C,$14,$1B,$E8,  4,$26,  0,  4,$4C,$1D,  2,$33,$72,$76,$45,$10,$4A,$10,$4C,$E6,  7,$1B,$10,$1C,$10,$1D,$10,$1E,$10,$21,$E6,  6,$FC,  4,$BC,$14,  2, $D,$E0,  7,$10,$30,  1,$70,$58,  7,$DE; 7488
		dc.b   6,  1,$2F,$C1,  0,$C2,$10, $D,$C6,  0,$C7,$10, $D,$CB,  0,$CC,$10, $D,$D0,  0,$D1,$38,  9,$C3,  0,$C4,  0,$C5,$38, $B,$C8,  0,$C9,  0,$CA,$60, $B,$5E,$60, $B,$A2,  8,$30,  8,$10, $E,$3E,$C4,$27,$30,$BE, $B,$14,$2F,$14,$2E,$BE, $C,$46,$BE, $C,$46,$80, $F; 7552
		dc.b   1,  0,  1,$B8,  9,$CD,  0,$CE,  0,$CF,$B8, $B,$D2,  0,$D3,$CC, $D,$D4, $C, $F,$D5,$2A,  4,$14, $D,  2,$10,  2,$78,$2F,$82,  2,$B6,$82, $B,$23,$B6,$82, $B,  0,$26,  1, $C,$38, $C,  1,$38,  7,  1,  9,$B8, $C,  1,$B8,$D0, $C,$B8,  1,$6B,  1,  9,  5,$6B,$B8; 7616
		dc.b  $A,$E0,$3C,$62,  7,$7F,$70,$7A,$10,$DC,  2,  6,  8,  7,$DC,  2,  6,$80,  7,$38,  7,$3A,  8,$BC,  8,$10,  8,$3C,  9,$45, $A,  7,$3C,  8,$1D, $A,  6,$3C,  9,$25,  0,$8A,$86,$50, $E,$7A, $A,$80,  9,$6A,  8,$70,  8,$10, $E,$B8,$7A,$CE,$30,$7A,  9,  8,  2,$7A; 7680
		dc.b   9, $A,$1C,$7A, $A, $A,$80, $F,  0,$44,$22, $F,$10,$18,$44,  6,$10,  8,$44,  8,$7C, $C, $C,$7C, $C,$C4,  6,$7E, $A,$C4,  6,$7E, $A,$D4,$10,  1,$24,$7C, $C,  1,$7C, $C,  1,$36,$7E, $A,$90,  6,$BA, $A,$A0, $A,$D4,$F6,$10,  8, $A,$27,$C6,$C2,$D5,  4,$27,$7C; 7744
		dc.b   6,$3E,  8,$14,$2F,$7C,  6,$3E,  8,$14,$21,$7C,  6,$EE,  8,$86,$88,$10,$C4,$34,  2,  7,$88,  3,$F8,$FA,  7,$88,$F8,$7A,  4,  7,  0,$B4,$F8,$88, $B,$84,  8,$88,  3,$50,$29,$54,$29,$14, $A,$50,$13,$50,$14,$54,$14,$50,$94,  9,$50,$23,  0,$24,  4,$24,$50,$84; 7808
		dc.b   9,$36,  7,$94, $A,$1E,  7,  1,$A9,  1,$AA,  4,$42,  1,$44,$20,$F1,  0,$F2,  4, $A,$42,$10, $A,  1,$43,  1,$41,$20, $D,  1,$3F,$78,  9,  4,  7,$58,  9,  4,$28,$DE,  8,$10,$18,$B8,  1,$40,$B0, $D,$72, $C,$10, $D,$73,  0,$77,$10, $D,$50,$20,$10,$10,  4,$7F; 7872
		dc.b $4C, $A,$50,  7,$4C, $C,$2E,  2,$4C,  7,$50,$52,$D0,  9,$50,$56,  9,$16,$42,  0,$76,  2,  6,  1,$44,$10,  7,$45,  2,  6,$30,$20,$43,  0,$B6,  2,  7,$10,  2, $B,$C4,$84,$80,  9,$C8,  6,$14, $A,$D0,  6,$14, $A,$42,  7,$10,  1,$AB,  1,$AC,$70,  9,$AF,  1,$B0; 7936
		dc.b   1,$AD,  1,$AE,$60,  7,$10,$B1,  1,$B2,  0,$67,  0,$79,  1,$41,$10,  7,$B3,  1,$B4,$10,$BE,  8,  0,$B3,  0,$10,$83,  0,$85,$90,$11,$10,  8,$41,$10,$4D,$10,$4E,$10,$4F,$10,  7,$15,$30,$19,$10,$34,$10,$35,$50,$10,  6,$1F,$30,$20,  0,$38,  0,$24,  4,$10,  7; 8000
		dc.b $20,  8,  6,$B8,$10, $F,  6,$10, $E,$73,$10, $F,  1,  0,  1,$8C,$10,$52,$10,$53,$3A,$FA,$30,$FA,$50,$10,$3D,$10,$37,$F2,$F8,$FA,$30,  8,$3E,  0,$3F,  0,$39,$76,  6,  6,$20,$30,$40,$AE, $C,$10,$58,  7,  1,$18,$21,$42,$1C,  9,$6E,$20,  6,$98,  7,  0,$77,$10; 8064
		dc.b   7,$EE, $D,$10,  1,$D6,  0,$D7,  0,$D8,  0,$D9,  0,$DA,$63,  7,$DB,  0,$DC,  0,$DD,  0,$DE,  0,$DF,$10,  7,$E0,  0,$E1,  0,$E2,  0,$E3,  0,$E4,$2A,  1,$E5,  0,$E6,  0,$E7,  0,$E8,$2A,  7,  1,  6,$E9,$2A,  9,$10, $C,$2A,$10, $C,$B4,  7,$10, $C,  1,  7,$24; 8128
		dc.b  $A,$5E, $E,$CA,$9A,  7,$A4, $A,$9A,  6,$A4, $A,$9A,  6,$9E,  7,  1,$9A,  6,$10, $A,$6A, $A,$10,$15,$34,$16,$40,  4,$24,$10,$40,$44,  8,$10,$40,$44,$ED,  0,$F6,$46,$40,  4,$54,$13,$54,$2F,$54,$2E,$54,$89,$50,$B5,$50,$B9,$50,$2F,  2,$54,$23,$54,$21,$54,$1E; 8192
		dc.b $54,$1D,$50,  2,$1E,$50,$21,  2,$2E,$30,  8,$2E,$80, $F,  2,$A0,$1F,$10,$11,$EA,  4,$7A,  2,$7E,  6,$80,  2, $E,$80,  2, $D,$6A, $B,  2,$16,$70,$30,$C0,  6,$10, $A,$40,  1,$9B,  1,$9C,$11,  9,$74,$9D,  1,$9E,$10, $D,$9F,  1,$A0,$10,  9,$74,  1,$95,  1,$96; 8256
		dc.b $F2, $A,  6, $F,  1, $C,  6,$AA,$10,$2E, $C,  6,$2E, $E,$D2,$10,  1,  6,$2E, $A,  1, $A,$DC,  7,$B8,  6,$72,  8,$CA,$11,$A1,$11,$A2,$72, $A,$CA,$A3,  1,$A4,$72, $B,$CA,$97,  1,$98,$42,  6,$7E,$27,  0,$B3,$11,$93,$11,$94,$10,$4A,$10,$4C,$FE,  6,$14,$B9,$7A; 8320
		dc.b   8,$FE,  6,$14,$1E,$7A,  8,$FE,  7,  0,$11,$3A,$78,$90,$48,$3A,$78,$10,$48,$3A,$78,$10,$48, $A,  0,  4,$B4,  4,$B3,$FE,$48,$14,$B5,$AC,$B5,$10,$78,$38,$14,  2,$1D,$14,$82, $C,$23,  4,$25,$74,$82, $A,  0,$12,$76, $C,  1,$48, $C,  1,$48, $C,  1,$48,$17,$10; 8384
		dc.b  $C,  1, $A,$10, $C,  1,$6B,  1,  9,  5,$6B,$10,  9,$D5,  0,$B8, $B,$C0,  2,  6,  1,$6F,$7A,$7A, $D,$10,$10,$34,  2,  8,  7,$11,$11,$A5,$11,$A6,$14,$3A,  6,$23,  0,$72,  1,$A7,  1,$A8,$C6,$B0,  8,$86,  5,$92,  5,$91,$10, $A,$74,$4C,$15,$90,$14,$45,  2,$10; 8448
		dc.b $43,$10,  4,$4A,$30,  8,$32,$88,$30,  8,  2,$8A,$86,$3C,$40, $C,$EC, $A,$90,$EC, $B,$61,  6,$7A,  6,  1,  9,$7A,  8,$B0,  8,$7A,  8,$B4,  8,$7A,  9, $A,$1C,$7A, $A, $A,$80, $F,$88,$FF,  4,$FE,  4,$FD,  4,$FC,  0,$FB,  0,  4,$FD,  0,$FF,  5,  3,  5,  2,  5; 8512
		dc.b   1,  5,$5B,$FB,$ED,  1,  3,  8, $F,  6,  1,  7,  1,  8,$22,  2,$11,$29,$16,$13,$18,$39,  1,$36,  4, $A,$5C,  1,$5D,  1,$3E,  1,$3D,  1,$3B,  4,  5,  8,  2,$1B,  1,$1C,  1,$1D,  1,$1E,  8,$65,  1,$5F,  2,$30,  6,$86, $A,$91,  4,  5,  4,$86, $A,$58, $F,  8; 8576
		dc.b $8C,$1A,$80, $F,$82,  5,$37,  6,$74,$3F,  4,$80,$82,$84,$76,$2A,$80,  6, $C,  5, $E,  1,$11,  2,$1F,$45,$21,  2,$70,  1,$2B,$16,  5,$5E,  1,$23,  1,$62,  1,$2F,  2,$71,  1,$6D,  2,$32,  5,$35,  1,$35,  4,  5,$34,  1,$33,  4,  2, $A,  0,$F8, $C,  9,$33,  8; 8640
		dc.b   0,$F9,  2,  8,  8,  2,  6,  8,$F9,  4,  4,  0,$FA, $E,  4, $C,$FA,  8,  8, $A, $C,  6,  2,  7, $C,$FA,  0,  1,$7A,$2E,  4,$7C,$12,  9,$12,  5,$16,  1,$15,$74,$80,  6,  5,$19,  1,  2,$2F, $D,$72,  9,$35,  2,$80,$7A,  7, $C, $A,  2,$82,$5E,$F8,  5,$7E,$72; 8704
		dc.b  $A, $C,$70, $A,  8,$FA,$82, $A,  7, $C,$82,  4,  8, $E,$8E, $C,  1,$12,$E6,$76,  6,  1,  6,$E6,$76,  6,  1,  6,$E6,$76, $A,$E6,  6,$76, $A,$F0, $F,$10,$10,$40,  7,$20,$10,  1,$57,  1,$66, $B,  9,$5A,  0,$5B,  4,$5A,  1,$67,$10,  9,$5D,  0,$65,  4,$5D,  1; 8768
		dc.b $68,$C0,$90, $D,$F0,  7,$10,$17,$3A,$C0,$F6,$10,  7,$27,$50,$3B,$50,$3C,$72,$2F,$54,$32,$50,$8A,$50,  4,$33,$50,$3D,$50,$3E,$74,$21,$54,$36,$50,$1A,$50,$1C,$50,$1D,  0,$3F,  0,$40,$62,$FE, $A,$7C,$10,  6,$58,  7,$4C,$66,$50,$2F,$51,$48, $C,  7,$3C,$4C,$46; 8832
		dc.b $21,$50,$23, $C,  7,$3E,$4C,$44,  1, $C,  7,$58,  1,$42,  0,$76,  1,$44, $C,  6,$A2,  6,  1,$45,  0,$72,$5A, $B,$43,  0,$B6,  1,$41,$FE,$1F,$80,  8,  1,  8,$90, $F,$34,$9C, $D,$10,$23,$10, $F,$40, $F,$30,$10,$21,  0,  7,  1,$39,$7B,$20,  3,$10,$29,$10,$2A; 8896
		dc.b $14,  2,$29,$16,$30,$13,$10,$14,$10,$16,$14,  2,  1,$96,$30,$72,$24,  2,  4,  2,$96,$C0,$10,$31,  6,  6,$10,  9,$30,  6, $C,$1E,  8,$10,  7,$1E, $B,  8,$73,$1C,  0,$77,$10,  6,  0,  7,$90,  6,$7C,$90,$F0,  6,$10,  6,$7D,$10, $C,$39,$7E,$31,$89,$40,$83,  0; 8960
		dc.b $85,$19,$81,$19,$80,$19,$7F, $E,$1E,  1,$10,$68,$10,$69,$10,$74,  2,  0,$6A,  0,  4,$70,$10,$6C,$14,$6D,  4,  2,$B6,$6F,  0,$71,$AA, $B,$9E,$18,$18,  2,  8,$90,$18,  2,  8,$BE,$14,$D8,$2A,$D8,$E0,  8,$D0,$10,$50,$30,$80,$70,  1,$7F,  1,$11,$10,$F3,  2, $E; 9024
		dc.b $42,$11,$B5,  1,$B6,  4, $C,  0,$7C,  0,$7D,  4,$4C,$80,$7F,  4,$7F,  4,$7F,  4,$34,$63,  0,$64,  4, $C,$10,$7E,$10,$7F,  4, $D,$80,$10,$81,  4, $C,  0,$80,  0,  4,$1C,$81,  0,  1,$80,$7F,$81,$50,$70,$50,$6B,  2,  8,$F0,  2,$A0,$72,$A0,  1,  2,$FD,$89,$F5; 9088
		dc.b $7F,$F5,$80,$F5,$24,$B4,$CD,$89,$C5,$7E,$90,  6,  4,$7A,  1,$52,$C0,  1,$C5,$88,  1, $A,$72,$10,$9A,$10, $E,$7B,$10, $E,$CD,$53,$10, $F,$50, $D,  8,$74,$82, $A,$10,$6A,$F1,$81,$F1,$80,$F1,$7F,$F1,$8B,$A1,$49,  2,$21,$47,$26,  6,$31,$4F,$31,$8B,  1,$49,  2; 9152
		dc.b $10,  4,  2,$31,$4B,$31,$10, $E,$4C,$10, $A,  4,$31,$4D,$10,  8,$BE,  7,$10,$10,$30,  5,$4E,$10,$90,$CC,$54,$9F, $A,$E2,$C1,$8C,$C5,$56,$12, $C,  5,$7A,$C1,$8D,$C5,$55,$C5,$26,$A4,  6,$6E,$51,$72,$51,$73,$51,$74,$51,$75,$54,$14,$54,$7B,$C0, $A,  2,$54,$24; 9216
		dc.b $54,$82,$50,$6D,  2,  0,  2,  8,$80,$27,$39,$4B,$35,$4E,  5,$82,  1,$4A, $E,  7,$F0,$8A, $E,  8,$31,$78,$31,$79, $E, $A,$51,$76,$51,$77,$51,$8A,$45, $E,  6,$8C,$76,$75,$50,$90,$51,  6,$7B,$8E,$74,$6F,$10,$5F,$50,  6,$82,$8E,$34,$45,$16,$5F,  6,$44,  8,$10; 9280
		dc.b  $B,$10,$70,$10,$6B,  2,  6,$30,  2,$20,$72,$20,  1,  2,$3D,$89,$35,$7F,$35,$80,$35,  0,  7, $E,  0, $B,$30,  1,$35,  0, $D,$10,  0, $D,$10,  0, $D,$10,$3D,  0, $D,$10,  0,  9,$74,$82,  8,  2,$6A,$31,$81,$31,$80,$31,$7F,$31,$8B,$21,$49,  2,$B0,  7,  1,$4F; 9344
		dc.b   1,  0, $F,  1,$4B,$10, $F,$4C,$10, $F,$4D,$10,  8,  1,  6,  9,$10,$10,$30,  0,  8,$90,$3C,  0, $F,$31,$8C,$35,  0, $F,$31,$8D,$35,$55,$35,  0, $B,  1,$72,$35,$58,$35,$57,$15,$60,$14,  1,$7B,$C0, $B,$6B,$14,$24,$14,$82,$10,$6D,  2, $A,  0,$28,  9,$4B,  5; 9408
		dc.b $83,  0, $A,  9,$4F, $E, $A,  1,$78,  1,$79, $E, $A,$15,$6A,$15,$69,$15,$83,$15,  0,  9,$76,$75,$10,$6E,$11,$51,  6,$7B,$8D,$76,$6F,$10,$5F,  6,$82,$8E,  0,$20,$46,$D6,  0,$D7,  0,$D8,  0,$D9,  0,$DA,$8B,  7,$DB,  0,$DC,  0,$DD,  0,$DE,  0,$DF,$10,  7,$E0; 9472
		dc.b   0,$E1,  0,$E2,  0,$E3,  0,$E4,$10,  7,$E5,  0,$E6,  0,$E7,  0,$E8,$A7, $D,$E9,$B7, $F,$10,$30,  1,$7F,$A0,$1A,$4E,  6,$10,  8,  6, $A,  3,  2,$EA,$10,  8,$10,$34,  2,$12,$10,  9,$38,  2,$6E,$30,  9,$74,  6,$6E,$D1, $A,$10, $F,  1,$7F,  1,$7F,  1,$5B,  1; 9536
		dc.b $5B,  1,$67,  5,$5B,$12, $D,$66, $D, $B, $F,  4,  3,  1,$68,$CA,  1,$7E,  0,  0,  1,  1,  8,$50,$10,$54,$13,  2,$50,$13,$10,  9,$11,$54,$23,  2,$50,$23,$36, $A,  4,  1,  2,$30, $A,$10,$49,$FB,  2,  9,$FC,  0,$FD,  0,$FF,$10, $A,$29,  1,  3,  1,  8,$22, $B; 9600
		dc.b $1A,  8,  5,  1,  6,  1,  7,$1A, $A,  1,$36,$1E, $C,  5,$39,  1,$38,  1,$37,  1,$39, $E,  7,$3E,  5,$3D,  1,$3C,  5,$3B,  1,$3D, $A,  1,$3F,  1,$5C,  1, $C,  1, $D,  5, $E,  1,$28,  1,$29,  1,$2A,  1,  8, $D,$7C, $B,$FE,$7E,$95,$7C,  9,  2,$7E, $E,  5,  8; 9664
		dc.b   5,  7,  5,  6,  5,  5,$88,$12,$94, $D,$84, $D,$80,$38,  5,$36,$86,  1,$5D,  2,  5,$5C,$80,$3C,  1,$3B,$86,  1, $F,$80, $B,$6C,  5,  4,$12,  1,$15,  5,$2B,  1,$2C,  1,$2D,  1,$2E,  9,$2B,  5,$13,  1,$2F,  1,$32,  4,$30,  1,$31,  8,  2,$26, $D,$33,  1,$34; 9728
		dc.b   9,$35,  1,$35,  4,  2,  5, $A,$33,  0,$F8,  4,  1,  2, $A,  2,$11,$F9,  2,$15,$FA,  2, $E, $E,  2, $B,$7E,$80, $A,  1,$64,$82,$72,$80, $B,$23,  1,$24,  5,$33,$82,  5,$80,  7,$78,$68,$82,$16, $C,$54,  6,$14, $E,  9,$70,$14,$7C,$15,$80,$C6,  6,$80,  9,$FC; 9792
		dc.b  $B,$80,  7,$F0,$12,$88,$1D,$37,$B2,$36,$FE,  8, $E,$74,$3E,  1,$7E,$3F,  0, $A,$6C,$7A,  2, $B,$38,  8,  4,$FF,  4,$FD,  4,$86,$44,  8,  4,  5,  3,$75,  5,  0,$5E,$10, $C, $E,$1F,$7A,$FA,  6,$10,  7,$7A,$80,$FA,$7E,$84,$7E, $D,  2,$64,  1,$5E,  1,$63,$10; 9856
		dc.b  $B,$74,  1,$6D,  1,$6F,  1,$6E,  4,$6E,$76,$78,  9,  2,  5,  2, $A,$86,  7,$F9,$72,$7C,  7,$FA,$15,$74,  6,$72,$13,$80, $F,$78,  7,  5,$84,$1C,  1,$1E,$90,$76,  2,$6E,  5,$84,$25,$8C,$62,$6E,  0,$76,$8A,$72,  6, $A,$34,  8,  6,  2,  8,  0,  9,$FC, $C,$82; 9920
		dc.b $24,$3E, $D,  4,  0, $B,$86,  6,  0,$31,$80,  4,$82,  7,$78,$3B,  5,$3D,  2,$80,  5,$6C,$78,$FA,$11, $A,  6,  4,$FE,$F8, $C,$3C,  2,$F8,  6,  5,$6E,$1D,$92,$1C,$7C, $E,$80,  9,$80,  4,  2,$FE,  2, $D,$78,$80,  6,$8A,  6,$20,  1,$70,  1,$2B,  2,$12,  9,$17; 9984
		dc.b   5,$15,  9,$15,$FE,$71,$84,  5,  4,$19,  5,$1A,  4,$F6,  4,  6, $A,$F8,  8,  0, $D,$86,  8,$F8,$14,  0,$20,$16,  2,$16,$78,  2,$12,  8, $A,$72,$7C,  4,  2,$26,  8, $C,$72,$80,  6,$80,  8,  0,  6,$8A, $A,$78,  2,$18,$80,$21,$F7,$7F,  1,$7F,  1,$32,  4,  3; 10048
		dc.b   2,  6,  0,  2,  8,$14,$13,  2,  6,$10,  2, $A,$23,  2,  6,$10,  2,  8,$62,  2,$6E,  7,  2,  9,$10,  7,  1,  0,  1,$80,$34,$7C,  8,  6,$7C, $C,  6,$7C, $B,  6,$6C, $C,$82,  8,$10, $D,$FC, $D,$7B,$FC, $F,$82,$1E,$7C,$12,$78,$7C,$12,  6,  6,$36,  1,$3A,$FE; 10112
		dc.b $FC,  6,$3D, $C,$1B,$E8,$1D,  1,$1E,  1,$27,$84,  7,$46,$FE,  8, $B,$FE,  8,  7,$72,$12,$88,$1E,$F6,  7,$84,$84,  7,$7A,$F6,$86,  8,  1,$5C,$FA,$FE, $F,$80,$82,  1,$1F,  2,$21,  1,$22,  2,$84,  6,  0,$25,  2,$84,  7,$78,$6C,$7E,  4,  5,  6,$8E,$8C, $C,  8; 10176
		dc.b $35,$84,$8A,  6,  2, $A,$14,  7,  8,$F9,  4,  8,  4, $C,$10, $C,  2, $A,$78,  8,  8,$FA,  4,  6, $C,$FA,$78,$13,  1,$14,  4,  1,$17,  2,  8,$7A,$80,$1A,  2,$18,  1,$19,$84,$32,$78,  6,$82,$84,$6E,  4, $C,$72, $A,  6,  4,$8A, $A, $C,$62,$82,  8,$7C,  7,  6; 10240
		dc.b   8,  2,  8,$88,$7A,  7,  2,$7E, $A,$4E,$14,$F0,$28,$22,  8,  0, $C,$F4,  0,  1,  8, $A,$39,$F4,$3C,  4,$80,$86,$10,$7A,  5, $E,$7A,$28,  4,$60,  2,$7E, $C,$4C,$7E,$1B,$14,$1E, $C,$16,$F2,$5D,  2,  5,  2,  8,  4,$8E,$74,  2, $A,$82,$17,  2,$15,  5,$14,$7A; 10304
		dc.b $2C,  4,$61,  2,  5,$18,  2,$1A,$FE,  0,  4,$62,  2,  0,$FC,$86,$FC, $A,$84,  6, $C,$F2,  8, $A,$F8,  7,$84,  4,  6,$84, $E,  8,$16, $A,  8,$7A,$82,  6, $C, $A,$74,  2, $A,  1,$2D,$74,  2, $A,$82,$78,  7,$82,  2,$70,  7,$FA,  4,  5, $E,$74,$6C,  2,  6,$F4; 10368
		dc.b $72,  6,$F6,$90,$92, $A, $A,$7E,  4, $A,$C4,  6,$80,$24,$1E, $B,$1C,  7,$90, $C,  4, $C,$78,$38,  5,  4,$74,$FA,  6,$3C,$82,$8E,$5E,$7E, $D,$2A,$E6,$14,  5,  7,  5,$88,$92,$34,$84, $F,  6,$80,  4,$FC,$86,$1D,  2,  4, $C,  8,$1B,$80,$F6,$7E,  8,  0,$F6,$7E; 10432
		dc.b   9,$32,$80,$F4,$82,  7,$86,  2,$68,  5,$80,$9A,$FE, $A,$9A,  6,$EA,  8,  8,  6,  6,$8C,  6,$72,$8C,$FE,  7,  0,$7F,  0,$7F,  0,$7F,  0,$7F,  0, $B,$FA,  0,  0; 10496

;
; yet another leftover chunk
;
		incbin	"Unused/E0178.bin"
		even

S1Nem_EndingGraphics:dc.b $80,$25,$80,	3,  1,$14,  7,$25,$13,$35,$12,$45,$1A,$55,$16,$65,$18,$74,  4,$81,  3,	0,$16,$37,$27,$7A,$82,	6,$38,$83,  4,	6,$16,$36,$86,	7,$78,$18,$F6,$38,$F8,$87,  7,$79,$88,	6,$39,$8A,  5,$15,$8B,	5,$17,$17,$75,$8C,  5,$14,$17,$76,$8D,	4,  5,$17; 0
		dc.b $74,$8E,  4,  8,$17,$77,$8F,  5,$19,$18,$F7,$FF,$44,$44,$44,$44,$FD,$AF,$EC,$E7,$79,$5E,$6A,$68,$F5,$B0,$37,$75,$2A,$89,$81,$D9,$4F,$50,$56,$77,$21,$E9,$AD,$CA,$BD,$D1,$10,$84,$93,$48,$21,$69,  9,$30,$49,$B4,$82,$20,$3B,$16,$DE,$6D,$21,$26,  9,$36,$90,$44; 64
		dc.b $4E,$BF,$98,$EF,$D1,$11,$3F,$EC,$88,$96,$BD,$53,  3,  3,$FA,$C7,$8C,$36,  2,$7F,$5A,$F5,$C7,$9D,$57,$CA,$CB,$CA,$95,$F8,$CF,$EB,$25,$1B,$5B,$BB,$62, $F,$E6,$A6,$B4,$AB,$D6,$85,$AD,$4E,  1,$5D,$6F,$4F,$E8,$EB,$F6,$6F,$B7,$21,$A3,$68,$E4,$EF,$46,$E7,$DA,$BC; 128
		dc.b $50,$B1,$AD,$1E,$83,$8A,$E8,$69,$4F,$F4,$68,$3F,$47,$A6,$11,$B3,$B6,$E6,$39,$DB,$9A,$44,$FF,$30,$46,$14,$53,$4A,$54,$4B,$F5,$99,$F8,$3B,$73,$26,$FC,$C6,$B9,$C5,$6F,$FD,$64,$18,$18,$E0,$FF,$59,$B0,$13,$15,$BA,$22,$5B,$FE,$C9,$35,$92,$CE,$E6,$A6,$FE,$D7,$5F; 192
		dc.b $14,$F0,$88,$9F, $B,$FA,$62,$B8, $A,$F7,$37,$A3,$AB,$D4,$F6,$56,$70,$D3,$84,$6B,$2F,$33,$5F,$63,$76,$9D,$67, $E, $D,$DD,$50,$B5,$82,$20,$44,$D3,  7,  5,$93,$40,$B1,$6D,$D3,  2,$4D,$20,$85,$A4,$24,$C1,$1F,$62,$21,$69,$2C,$D8,$63,$F1,$2B,$A1,$E0,$FE,$99,$F8; 256
		dc.b $7B,$9B,$96,$2A,$F5,$43,$FB,$DE,$B5,$BA,$4D,$64,$B3,$B9,$AB,$D3,$C3,$F8,$3E,  1,$BB,$A9,$54,$44,$C0,$44,$D3,  7,  5,$92,$42,$6C,$FE,$8F,$E8,$C2,  9,$34,$82,$16,$90,$93,  4,$9B,$48,$77,$FD,$69,$DB,$4A,$73,$6C,$AE,$B2,$BA,$CD,$B3,$6C,$B8,$F7,$39,$1E,$F0,$EB; 320
		dc.b $C3,$74,$EE,$BB,$58,$53,$62,$D3,$5D,$D8,$68,$11,$C1,$1B,$7E,$48,$83,$14,$F4,$D6,$6D,$74,$EF,$D1,$11,$12,$51,$28,$C0,$87,$83,  7,$30,$AF, $D,$35,$46,$C2,$DA, $B,$3C,$4E,$14,$3E,$6C, $C,$3C,$16,$DC,$FA,$22,$7E,$8A,$CF,$7A,$74,$3B,$BF,$47,$DB,$79,  3,$F9,$2D; 384
		dc.b $83,$89,$D2,$26,$25,$1F,$AD,$EC,$FC,$61,$78,$C2,$E5,$32,$99,$9F,$B8,$7C,$CA,$3D,$C6,$4C,$7E,$B6,$91,$9D,$52,$C2,$4C,$F4,$B0,$B3,$3C,$6B,$8B,  9,$C1,$85,$CC,$1E,$E6,$11,$12,$71,$28,$9C,$1C,$BE,$6C, $C,$3C,$18,$35,$EB,$D2,$8B,$F9,$AB,$D8,$1B,$AC,$AE,$1F,$A1; 448
		dc.b $F6,$12,$57,$51,$8A, $C, $C,$5F,$74,$44,$3F,$C6,$9F,$54,$EB,$2F,$D9,$C0,$7F,$DF,$72,$DC,$36,$B9,$39,$B6,$57,$55,$53,$F1,$5B,$56,$D5,$71,$D8,$D4,$56,$8A,$FC,$F0,$DC,$C7,$48,$DA,$C2,$9B,$16,$9A,$EE,$C3,$40,$8E,  8,$DB,$F2,$44,$15,$CF,$A6,$B3,$4F,$DB,$F3,$1D; 512
		dc.b $3B,$A2,$59,$69,$FC,$6A,  9,$52,$B2,$ED,$A1,$FB,$D9,$FE,$C4,$FE,$A9,$FB,$79,$9A,$D0,$89,  7,$5B, $F,$E3,$11,$7B,$5E,$C1,$3A,$D7,$F7,$93,$F4,$56,$7B,$D3,$A1,$DD,$FA,$3E,$DB,$C8,$1F,$C9,$6C,$1C,$4F,$2B,$31,$2B,$FE,$A3,$DD,$FC,$E1,$7C,$E1,$6A,$95,$F8,$95,$67; 576
		dc.b $D8,$3D,$64,$B4,$A8,$A9,  0,  0; 640
S1Nem_CreditsFont:dc.b $80,$60,$80,  3,	 0,$14,	$A,$25,$16,$35,$17,$46,$39,$57,$77,$65,$1A,$74,	 7,$81,	 3,  1,$16,$37,$82,  4,	 6,$17,$7B,$28,$F9,$83,	 5,$13,$15,$12,$26,$32,$57,$76,$84,  5,$18,$85,	 6,$3C,$86,  4,	 8,$16,$3A,$87,	 3,  2,$16,$33,$26,$36,$36,$38,$48,$F8,$57,$7A;	0
		dc.b $FF,$AF,$E9,  6,$3D,$6C,$C6, $B,$64,$10,$98,$6C,$EA,$61,$78,$16,$E1,$B5,$E3,$BB,$EB,$CB,$EE,$1B,$BC,$C2,$F0,$20,$84,$C3,$66,$C6, $B,$64,$18,$F5,$B7,$BB,$FB,$DB,$A2,$C3,$26,$30,$5B,$36,$90,$43,$36,$C4,$81,$90,$58,  6,$D3, $A,$8E,$56,$23,$E0,$6F,$C5,$E5,$DE; 64
		dc.b $41,$60,$11,$9B,$62,$40,$E6,$D2,  8,$64,$C6, $B,$6D,$D1,$61,$FC,$21,$EE,$EC,$61,$5C,$A3,$3B,$30,$33,$B9,$54,$A9,$81,$95,$8A,$AC,$53,  3,$21,$80,$55,$7E,$52,$6C, $C,$84,$E9,$57,$E5,$28,$89, $C,$66,  8,$C7,$16,$43,$2D,$F2,$3D,  8,$DA,$37,$BF,$EC,$B3,$83,$79; 128
		dc.b $10,$D6,$54,$8D,$E4,$43,$5B,$14,$8D,$E4,$43,$5B,$14,$8D,$E4,$43,$62,$B1,$48,$4E,$D2,$A5,$6C, $D,$F3,$EF,$31,$B5,$8F,$F0,$F7,$8F,$88,$1E,$DC,$46,$D1,$5B,$E4,$43,$59,  9,$D2,$B2,$A2,$25,$4A,$88,$56,$65,$53,$E6,$75,$8E,$72,$54,$46,$74,$AD,$FB,$3D,$19,$D9,$57; 192
		dc.b $40,$E4,$41,$11,$B4,  6,$1E,$EE,$C7,$D9,$8E,$37,$47,$23,$99,$98,$42,$7B,$CC,$2B,$48,$2A,$9A,$A5,$64,$33,$BC,$EC,$BB,$A1,$E5,$D5,$1B,$21,$95,$A4,$79,$FD,$35,$6D,$B8,$3F,$B3,$F6,$23,$8F,$F9,$46,$B7,$D2,$67,$E6,$7B,$BE,$93,$3D,$E4,$79,$3A,$F2,$8B,$DD,$51,$BC; 256
		dc.b $8F,$39,$C3,$8F,$D9,  8,$F4, $F,$6B,$7C,$69,$3E,$96,$93,$BB,$BE,$95,$BE,  1,$EC,$23,$D6,$9B,$E2,$2B,$F8,$66,$B8,$A2,$38,  7,$BC,$ED,$B7,$3B,$58,$8F,$D9,$95,$6D,$FA,$36,$DE,$14,$57,$F0,$F7,$1C,$5F,$8B,$FF, $F,$71,$F1, $E,$18,$47,$A0,$7B,$5B,$E3,$49,$DD,$DD; 320
		dc.b $F4,$B4,$9E,$DC,$51,$EC,$23,$D7,$3F,$39,$F4,$5A,$A4,$C6, $B,  4,$D2, $A,$93,$62,$56,$98,$58,$1B,$D4,$DF,$53,$EF,$30,$B0,$37,  9,$B1,$2B,$26,$90,$55,$26,$30,$5A,$8A,$82,$D6,$47,$DD,$91,$6D,$7F,$48,$47,$A0,$7B,$5B,$87,$77,$77,$77,$77,$56,$F8,  7,$B0,$8F,$55; 384
		dc.b $FD,$28,$D1,$77,$77,$77,$2D,$DD,$1F,$D9,$51,$8C,$E2,$BF,$87,$B8,$E2,$FC,$5F,$F8,$7B,$8F,$88,$7B,$46,$D0,$58,$1C,$8F,$56,$4D,$23,$7F,$CA,$CB,$96,$C7,$9A,$67,$BB,$6B,$C6,$D7,$98,$6E,$65,$E7,$79,$59,$54,$10,$72,$22,  4,$6D,  5,$9C,$C6,$D1,$63,$91,$A8,$A5,$79; 448
		dc.b $EA,$5D,$F1,$E6,$9B,$CD,$33,$BF,$38,$6E,$F3,$FC,$AF,$32,$65,$78,$39,$1A,$31,$B4,$57,$BE,$58,$31,$EB,$66,$30,$5B,$20,$84,$C3,$67,$53, $B,$C0,$B7, $D,$AF,$1D,$DF,$5E,$5F,$70,$DD,$E6,$17,$81,  4,$26,$1B,$36,$30,$5B,$20,$C7,$AD,$BD,$DF,$DE,$DD,$16,$19,$31,$82; 512
		dc.b $D9,$B4,$82,$19,$B6,$24, $C,$82,$C0,$34,$66,$15,$1A,$39,$17,$B1,$C8,$D1,$98,$54,$64,$16,  1,$19,$B6,$24, $E,$6D,$20,$86,$4C,$60,$B6,$DD,$16,$D7,$B1,$1E,$81,$ED,$6F,$8D,$27,$77,$77,$D2,$D2,$7B,$71,$47,$B0,$8F,$5C,$FC,$E7,$D1,$6A,$93,$18,$2C,$13,$48,$22,$13; 576
		dc.b $62,$56,$98,$58,  6,$D3,$7D,$4F,$BC,$C2,$C5,$9B,$69,$D2, $B, $C,$84,$F7,$93,$61,$5D,$A4,$AC,$51,$CB,$78,$31,$B4, $F,$7A,$63,$D6,$CC,$60,$B6,$41,  9,$86,$CE,$A6,$17,$81,$6E,$1B,$5E,$3B,$BE,$BC,$BE,$E1,$BB,$CC,$2F,  2,  8,$4C,$36,$6C,$60,$B6,$41,$8F,$5B,$7B; 640
		dc.b $BF,$BD,$BA,$2C,$32,$63,  5,$B3,$69,  4,$33,$6C,$48,$19, $C,$20,$6D,$95,$CB,$E8,$BE,$56,$90,$C2,  4,$66,$D8,$90,$39,$B4,$82,$19,$31,$82,$DB,$74,$5B,$5E,$C4,$7A,  7,$B5,$B8,$BE,$2C,$C0,$CA,$DE,  5,$58,$B3,$6F,$2C,$5D,$19,$59,$8A,$A5,$75,$53,$60,$C0,$CC,$63; 704
		dc.b $CA,$34,$B1,$DD,$4A,$B7,$C8,$86,$11,$B4,$7B,$EF,  6,$36,$80,$51,$C8,$89,$99,$85,$79,$85,$8B,$4C,$79,$89,$11,$89,$89,$15,$5D,$52,$35,$12,$82,$1B,$12,$34,$C2,$41,$1E,$60,$86,$A9,$9A,$6B,$14,$5A,$E8,$B7,$25,$BB,$FF,$C9,$8F,$5C,  4,$5B,$F6,$75,$31,$C6,$E1,$59; 768
		dc.b $3D,$B1,$65,$BC,$B9,$54,$AE,$84,$C2,$AD,$E5,$4A,$EA,$FB,$8E,$2D,$31,$C0,$45,$BF,$66,$C7,$AE,$1A,$FF,$39,$F4,$5A,$A4,$C5,$5B,$31,$3B,$EC,$37,$BA,$D4,$B7,$A4,$26,$15,$D5,$2E,$65,$BD,$F0,$FA,$43,$7A,$CC,$4E,$F2,$62,$AD,$9F,$45,$B5,$F2,$23,$D0,$3D,$AD,$C3,$BB; 832
		dc.b $BB,$DE,$7C,$91,$1D,$E6,$CE,$B0,$10,$47,$2C,$D8,$AD,$F2, $C,$7A,$DB,$DF,$78,$11,$B4,  2, $E,$47,$95,$45,$DD,$C1,$D2,$D1,$9D,$C8,$98,$90,$22,$62,$6B,$13,$AC,$CE,$2F,$9B,$48,$A1,$96,$E8,$B6,$DD,$16,$1E,$EF,$EC,$31,$EB,$66,$30,$5B,$20,$84,$9B,$3A,$96,$19,$60; 896
		dc.b $11,$85,$53,$E6,$7C,$AB,$30,$3F,$B3,$1E,  4,$44,$C2,$A4,$66,$15,$8C,$C2,$EE,$B5,$F0, $F,$61,$1E,$B9,$F9,$CF,$A2,$D5,$26,$30,$58,$26,$90,$56,$F3,$12,  6,$E8,$17,$E6,  1,$E5,$A7,$CE,$29,$1A,$F2,$41,$52,$61,$2D,$C7,$17,$E2,$FF,$C3,$DC,$7C,$43,$86,$11,$E8,$1E; 960
		dc.b $D6,$E1,$DD,$D6,$93,$BB,$BB,$DB,$8A,$3D,$84,$7A,$78,$11,$B4, $F,$D0,$E4,$69,$52,$B9,$EF,$97,$3C,$5F,$8B,$E5,$DC,$E9,$68,$BB,$D2,$B1,  7,$22,$20,$46,$D0,$F5,$1E,$81,$ED,$6F,$8B,$6D,$63,$95,$FA,$37,$F6,$57,$76,$2E,$EE,$EF,$59,$DC,$E5,$78,$DB,$E7,$9F,$50,$3B; 1024
		dc.b $11,$F1,$CE,$DD,$F2,$3C,$9E,$B9,$47,$DD,$CB,$3B,$BB,$D6,$7D,$F2,$37,$DA,$1C,$7C,$88,$F4, $F,$6B,$7C,$69,$3B,$BB,$BB,$BE,$95,$BE,  1,$EC,$23,$D7,$3F,$39,$F4,$7D,$89,$31,$E8,$B6,$6D,$22,$86,$65,  9,$DE,$6D,$30,$44,$87,$98,$A3,$53,$7D,$4F,$99, $F,$31,$46,$A6; 1088
		dc.b $D3,  4,$66,$50,$9D,$66,$D2,$28,$49,$8F,$45,$B3,$E8,$FB,$EF,$F3,$1E,$A0,$F6,$35,$C3,$BB,$BB,$BB,$BB,$DF,$8A,$3D,$8C,$7A,$87,$11,$E8,$1E,$D6,$F8,$D2,$77,$77,$77,$7D,$2B,$7C,  3,$D8,$47,$AD,$37,$C4,$16,$FE,$19,$43,$81,$32,$36,$C2,$A3,$FB,$3E,$F2,$BC,$86,$10; 1152
		dc.b $DF,$6E,$76,$C2,$1B,$FE,$CE,$FF,$B3,$BE,$D8,$54,$78,$13,$23,$F8,$65, $F,$88,$3F,$D2,$A6,$EF, $B,$B9,$9B,$BB,$FF, $A,$F1,$C5,$8E,$5D,$D3,$89,$5F,$1E,$5C,$CA,$36,  8,$4B,$66,$30,$7F,$66,$18,$C7,$1E,$F9,$6F,$88,$AF,$E1,$9A,$E1,$DD,$DD,$DF,$53,$D2,$EF,$89,$1A; 1216
		dc.b $CE,$41,$56,$46, $B, $D,$A0,$B6,$BE,$44,$7A,  7,$B5,$B8,$BE,$2C,$C0,$C9,$AB,$C0,$88,$86,$A6,$22,$51,$74,$65,$E0,$62,$8C,$C7,$8C,$10,$98,$CE,  1,$61,$98,$9D,$B3,$13,$BA,$13,$33,  7,$22,$88,$8D,$A0,$C3,$C1,$8D,$A0,$14,$72,$22,$66,$61,$5E,$63,$3B,$4C,$66,$18; 1280
		dc.b $88,$CC,$4C,$20,$DE,  9,$94,$58,$79,$22,$AF,$12,  5,$A9,$A0,$14,$3C,$A6,$91, $D,$6C,$5F,$8B,$76,$23,$D4,$3D,$47,$A0,$7B,$5B,$E3,$49,$DD,$DD,$DD,$F4,$AD,$F0, $F,$61,$1E,$B9,$F9,$CF,$A3,$EC,$49,$8F,$44,$66,$D2,$28,$66,$50,$9D,$E6,$D3,  4,$48,$79,$8E,$66,$FA; 1344
		dc.b $9F,$32,$1E,$63,$99,$B4,$C1,$19,$94,$27,$59,$B4,$8A,$12,$63,$D1,$19,$F4,$7D,$F7,$F9,$11,$E8,$1E,$D6,$E1,$DD,$6B,$CD,$33,$BB,$BB,$DB,$8A,$3D,$84,$7A,$7E,$B8,$81,$BF,$EC,$F7,$C9,$95,$A6,$D8,$2A,$D8,$2B,$2D,$FF,$28,$26,$7A,$13,$12,$34,$C3,$F2,$94,$AA,$42,$44; 1408
		dc.b $35,$7E,$52,$A2,$A4,$24,$6F,$F9,$4A,$20,$C9,$58,$C1,$CB,$78,$11,$B4,$3D,$47,$A0,$7B,$5B,$E3,$49,$F4,$B4,$9D,$DD,$DE,$DC,$51,$EC,$23,$D6,$9B,$E2,$2B,$F8,$66,$B8,$A2,$38,  7,$BC,$ED,$B7,$3B,$58,$8F,$D9,$95,$63, $A, $B,$52,$3F,$36,$2C,$EF,$C9,$D4,$68; 1472
S1Nem_EndingSONICText:dc.b $80,$30,$80,	 6,$3A,$15,$1B,$24,  9,$35,$1A,$45,$18,$54, $A,$64,  5,$74,  4,$81,  5,$16,$82,	 3,  1,$17,$7B,$28,$F8,$83,  3,	 0,$15,$19,$26,$3B,$48,$FA,$84,	 4,  6,$16,$3C,$28,$F9,$85,  4,	 8,$15,$1C,$27,$7A,$86,	 5,$17,$87,  4,	 7,$FF,$D1, $D,$12,$5A,	 8; 0
		dc.b $E8,$DD,$B4,$5E,$9C,$26,$33,$80,$E9,$41,$C5, $B,$A8,$85, $C,$46, $B,$45,$FC,$AF,$7D,$1F,  1, $D,$D5,$FD,$C3,$47,$BB,$55,$85,$3A,$DE,  6,  8,$8F,$E2,$4F,$F0,$93,$EA,$6F,$EA,$F3,  7,$A3,  8,$89,$A7,$87,$C7,$7A,$F4,$C0,$EF,$B3, $D,  2,$84,$22,$E4,$8D,$5A,$1A; 64
		dc.b $3C,$83,$79,$F6,$18,$FA,  6,$7B,$86,$81,$42, $A,$B2,$24,$2D,$D4,$25,  5,$7C, $F,$72, $C,$37,$5F,$30,$D3,$F0,$98,$CE,$F3,$B7,$8D,$C3,$EB,$35,$CA,$E5,$67,$4F,$1B,$87,$DE,$77,$94,$D9,$A3,$7C,$1F,$CB,$E8,$B8,$B4,$97,$1D,$19,$B0,$AB,$D1,$15,$65,$75,$B6,$8A,$DB; 128
		dc.b $76,$D5,$F6,$EB,$65,$22,$6F,$37,$91,$36,$14,$5C,$51,$71,$45,$D4,$A2,$75,$F5,$2F,$E9,$F0,$1A,$F8, $D,$7C,  6,$BE,  3,$5E,$5F,$D3,$CF,$D6,$88,$6F,$42,$1A, $F,$70,$11,$11,$27,$BD,  7,$E4,$F0,$EB,$35,$65,$65,$2B,$75,$22,$4C,$FE,$D5,$F5,$FB,$34,$44,$81,$42,$1A; 192
		dc.b  $F,$7B,$21,$BD,$26,$33,$4F,  8,$16,$16,$14,$61,$E2,$B3,$D3,  3,$83, $D,  0,$E0,$43,$9A, $E,$68,$3A,$E5,$78,$A0,$AD,$D4,$AB,$2D,$AB,$38,$E5,  4,$4A,$14,$1F,  1,$CC,$88,$73,$D1,$86,$80,$76,$C0,$A5,$66,$73,$D4,$3C,$BC,  5,$85,$85,  9, $F,$2F,$1D,$66,$73,$8F; 256
		dc.b $8D, $F,$94,$42,$B6,$5B,$A8,$2B,$65,$75,$B2,$2D,$95,$D6,$D4, $D,$5D,$6C,$A5,$11,$24,$7C,$E3,$E1,$3B,$9C,$F1,$E5,$E0,$35,$F0,$1A,$F8, $D,$7C,  6,$BE,$38,$F2,$F1,$DC,$E7,$FA,$5B,$FE,$25,$D6,$C6,$85,$D6,$C6,$85,$D6,$CA,$11,$11,$24,$AB,$85,$B2,$DC,$51,$B2,$DC; 320
		dc.b $51,$B2,$DC,$51,$B7,$C8,$9B,$FC,$68,$A7,$78,$E3,$EB,$C8,$2D,$36,$22,$88,$A6,$82,$D3,$6E,$3E,$9B,$B5,$FE,$97,$43,$FA,$88,$88,$85,$6E,$B6,$50,$EA,$51,$11,$11,$11,$11,$2B,$FE,$9F,$F2,$46,$E3,$6A,$D9,$B3,$48,$F3,$AB,$6A,$EC,$2D,$AB,$B6,  7,$98,$B6,$4D,$E5,$B8; 384
		dc.b $C5,$3E,  4,$8F,$94,$44,$44,$44,$D3,$A2,$22,$22,$22,$22,$24,$89,$FD,$A6,$3E,$13,$EA,$5F,$D3,$E0,$35,$F0,$1A,$F8, $D,$7C,  6,$BC,$BF,$A7,$9F,$A9,$F8,$C7,$C8,$44,$49,$2B,$65,$BD,$11,$56,$57,$5B,$22,$D9,$5D,$6C,$A4,$2D,$D6,$CA,$51,$3E,$46,$BE,$13,$19,$DE,$76; 448
		dc.b $F1,$B8,$7D,$66,$B9,$5C,$AC,$E9,$E3,$70,$FB,$CE,$F2,$A4,$36,$C8,$86,$83,$D1,$78,$12,$5C,$61,$C5,  4,$4A,$15,$CC,$66,$AC,$AC,$A5,$6E,$A4,$2F,$17,$2A,$E2,$8B,$8A,$2F,  3,  4,$43,$41,$C1, $C,$9B,$1E,  9,$6B,$FB,$BB,$48,$E0,$C7,$E4,$6B,$F2,$38,$1C,$12,$D7,$F7; 512
		dc.b $76,$91,$E0,$DF,$A6,$13,$D9,$E0,$38,$10,$EB,$65,$BD,  3,$FB,$3D,$DB,$A7,$FD,$A8,$BF,$46,$44,$14,$44,$4C,  6,$D1,$E5,$B7,$C7,$1D,$67,$AE,$E5,$D6,$CB,$95,$7A,$16,$FD,$99,$8F,$CB,$FE,$D5,$87,$B4,$96,$E3,$4B,$5B,$36,$6D,$D8,$79,$D5,$B5,$76,$16,$D5,$DB,$56,$1E; 576
		dc.b $69,$AD,$93,$79,$6E,$31,  0; 640
; ---------------------------------------
; lots of leftover stuff, mostly garbage
; ---------------------------------------
		incbin	"Unused/E166F.bin"

		incbin	"Misc/FFDE7.bin"

EndOfRom:
		END


